/**
 * @typedef {import('../../../types/FormControlMixinTypes.js').FormControlHost} FormControlHost
 */
export class Required extends Validator {
    /**
     * In order to prevent accessibility violations, the aria-required attribute will
     * be combined with compatible aria roles: https://www.w3.org/TR/wai-aria/#aria-required
     */
    static get _compatibleRoles(): string[];
    /**
     * In order to prevent accessibility violations, the aria-required attribute will
     * be combined with compatible platform input elements
     */
    static get _compatibleTags(): string[];
}
export type FormControlHost = import('../../../types/FormControlMixinTypes.js').FormControlHost;
import { Validator } from "../Validator.js";
