"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logStartMessage = void 0;
const ip_1 = __importDefault(require("ip"));
const chalk_1 = __importDefault(require("chalk"));
const createAddress = (config, host, path) => `http${config.http2 ? 's' : ''}://${host}:${config.port}${path}`;
function logNetworkAddress(config, logger, openPath) {
    try {
        const address = ip_1.default.address();
        if (typeof address === 'string') {
            logger.log(`${chalk_1.default.white('Network:')}  ${chalk_1.default.cyanBright(createAddress(config, address, openPath))}`);
        }
    }
    catch (_a) {
        //
    }
}
function logStartMessage(config, logger) {
    var _a;
    const prettyHost = (_a = config.hostname) !== null && _a !== void 0 ? _a : 'localhost';
    let openPath = typeof config.open === 'string' ? config.open : '/';
    if (!openPath.startsWith('/')) {
        openPath = `/${openPath}`;
    }
    logger.log(chalk_1.default.bold('Web Dev Server started...'));
    logger.log('');
    logger.group();
    logger.log(`${chalk_1.default.white('Root dir:')} ${chalk_1.default.cyanBright(config.rootDir)}`);
    logger.log(`${chalk_1.default.white('Local:')}    ${chalk_1.default.cyanBright(createAddress(config, prettyHost, openPath))}`);
    logNetworkAddress(config, logger, openPath);
    logger.groupEnd();
    logger.log('');
}
exports.logStartMessage = logStartMessage;
//# sourceMappingURL=logStartMessage.js.map