"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getManualDebugMenu = void 0;
const chalk_1 = __importDefault(require("chalk"));
const ip_1 = __importDefault(require("ip"));
function getManualDebugMenu(config) {
    const localAddress = `${config.protocol}//${config.hostname}:${config.port}/`;
    const networkAddress = `${config.protocol}//${ip_1.default.address()}:${config.port}/`;
    return [
        'Debug manually in a browser not controlled by the test runner.',
        ' ',
        "Advanced functionalities such commands for changing viewport and screenshots don't work there.",
        'Use the regular debug option to debug in a controlled browser.',
        ' ',
        `Local address:   ${chalk_1.default.cyanBright(localAddress)}`,
        `Network address: ${chalk_1.default.cyanBright(networkAddress)}`,
        ' ',
        `${chalk_1.default.gray('Press')} D ${chalk_1.default.gray('to open the browser.')}`,
        `${chalk_1.default.gray('Press')} ${config.manual ? 'Q' : 'ESC'} ${chalk_1.default.gray('to exit manual debug.')}`,
    ].filter(_ => !!_);
}
exports.getManualDebugMenu = getManualDebugMenu;
//# sourceMappingURL=getManualDebugMenu.js.map