"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSelectFilesMenu = void 0;
const chalk_1 = __importDefault(require("chalk"));
const path_1 = require("path");
function getSelectFilesMenu(succeededFiles, failedFiles) {
    const maxI = succeededFiles.length + failedFiles.length;
    const minWidth = maxI.toString().length + 1;
    function formatTestFile(file, i, offset, failed) {
        return `[${i + offset}]${' '.repeat(Math.max(0, minWidth - (i + offset).toString().length))}${chalk_1.default[failed ? 'red' : 'cyan'](path_1.relative(process.cwd(), file))}`;
    }
    const entries = [
        'Test files:\n',
        ...succeededFiles.map((f, i) => formatTestFile(f, i, failedFiles.length + 1, false)),
        '',
    ];
    if (failedFiles.length > 0) {
        entries.push('Failed test files:\n', ...failedFiles.map((f, i) => formatTestFile(f, i, 1, true)));
    }
    return entries;
}
exports.getSelectFilesMenu = getSelectFilesMenu;
//# sourceMappingURL=getSelectFilesMenu.js.map