"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWatchCommands = void 0;
const chalk_1 = __importDefault(require("chalk"));
function getWatchCommands(coverage, testFiles, focusedTest) {
    if (focusedTest) {
        return [
            `${chalk_1.default.gray('Press')} F ${chalk_1.default.gray('to focus another test file.')}`,
            `${chalk_1.default.gray('Press')} D ${chalk_1.default.gray('to debug in the browser.')}`,
            coverage ? `${chalk_1.default.gray('Press')} C ${chalk_1.default.gray('to view coverage details.')}` : '',
            `${chalk_1.default.gray('Press')} Q ${chalk_1.default.gray('to exit watch mode.')}`,
            `${chalk_1.default.gray('Press')} Enter ${chalk_1.default.gray('to re-run this test file.')}`,
            `${chalk_1.default.gray('Press')} ESC ${chalk_1.default.gray('to exit focus mode')}`,
        ].filter(_ => !!_);
    }
    return [
        testFiles.length > 1
            ? `${chalk_1.default.gray('Press')} F ${chalk_1.default.gray('to focus on a test file.')}`
            : '',
        `${chalk_1.default.gray('Press')} D ${chalk_1.default.gray('to debug in the browser.')}`,
        `${chalk_1.default.gray('Press')} M ${chalk_1.default.gray('to debug manually in a custom browser.')}`,
        coverage ? `${chalk_1.default.gray('Press')} C ${chalk_1.default.gray('to view coverage details.')}` : '',
        `${chalk_1.default.gray('Press')} Q ${chalk_1.default.gray('to quit watch mode.')}`,
        `${chalk_1.default.gray('Press')} Enter ${chalk_1.default.gray('to re-run all tests.')}`,
    ].filter(_ => !!_);
}
exports.getWatchCommands = getWatchCommands;
//# sourceMappingURL=getWatchCommands.js.map