"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectTestFiles = void 0;
const globby_1 = __importDefault(require("globby"));
const path_1 = __importDefault(require("path"));
function collectTestFiles(patterns, baseDir = process.cwd()) {
    const testFiles = new Set();
    for (const pattern of Array.isArray(patterns) ? patterns : [patterns]) {
        const normalizedPattern = pattern.split(path_1.default.sep).join('/');
        const foundFiles = globby_1.default.sync(normalizedPattern, { cwd: baseDir, absolute: true });
        for (const file of foundFiles) {
            testFiles.add(file);
        }
    }
    return Array.from(testFiles);
}
exports.collectTestFiles = collectTestFiles;
//# sourceMappingURL=collectTestFiles.js.map