import '../../chunks/egw_json-c294eee1.js';
import { aR as Et2LinkList, aS as e, aT as Et2SelectAccount, P as A, E as EgwApp, aG as et2_button, aQ as et2_selectbox, b as etemplate2, g as et2_nextmatch, a as egw, ap as nm_open_popup } from '../../chunks/etemplate2-0976562a.js';
import '../../vendor/bower-asset/jquery/dist/jquery.min.js';
import '../../vendor/bower-asset/cropper/dist/cropper.min.js';
import '../../vendor/bower-asset/diff2html/dist/diff2html.min.js';
import '../../vendor/tinymce/tinymce/tinymce.min.js';

/**
 * EGroupware eTemplate2 - JS Link object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 * @copyright 2011 Nathan Gray
 */

/**
 * @deprecated use Et2LinkTo
 */

/**
 * @deprecated use Et2LinkAppSelect
 */

/**
 * @deprecated use Et2LinkEntry
 */

/**
 * @deprecated use Et2Link
 */

/**
 * @deprecated use Et2LinkEntryReadonly
 */

/**
 * @deprecated use Et2LinkString
 */

/**
 * @deprecated use Et2LinkList
 */
// can't just define as type, as tracker/app.ts uses it with iterateOver()!
// export type et2_link_list = Et2LinkList;
class et2_link_list extends Et2LinkList {}

/**
 * @deprecated use Et2LinkAdd
 */

var _dec, _class, _descriptor;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

/**
 * Select widget customised for tracker to limit users
 *
 */
var Et2TrackerAssigned = (_dec = e(), (_class = class Et2TrackerAssigned extends Et2SelectAccount {
  constructor() {
    super();
    /**
     * Limit users to those of a specific queue
     *
     * @type {number}
     */
    _initializerDefineProperty(this, "tracker", _descriptor, this);
    this.searchUrl = "tracker_assigned_etemplate_widget::ajax_search";
    this.searchOptions = {};
  }

  /**
   * Do not pre-fill the list, we only want certain users, which are passed from client
   *
   * @protected
   * @internal
   */
  _getAccounts() {
    return Promise.resolve();
  }

  /**
   * Start searching
   *
   * Overridden from parent to easily set the tracker
   */
  startSearch() {
    var _superprop_getStartSearch = () => super.startSearch,
      _this = this;
    return _asyncToGenerator(function* () {
      _this.searchOptions['tracker'] = _this.tracker;
      return _superprop_getStartSearch().call(_this);
    })();
  }

  /**
   * Override icon - none
   *
   * @param option
   * @protected
   */
  _iconTemplate(option) {
    return A;
  }
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, "tracker", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return '0';
  }
})), _class));
if (!customElements.get("et2-tracker-assigned")) {
  customElements.define("et2-tracker-assigned", Et2TrackerAssigned);
}

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * UI for tracker
 */
class trackerAPP extends EgwApp {
  /**
   * Constructor
   */
  constructor() {
    super('tracker');
    // Filter push messages to see if we can ignore it
    _defineProperty(this, "push_filter_fields", ["tr_tracker", "tr_version", "tr_creator", "tr_assigned"]);
  }

  /**
   * Destructor
   */
  destroy(_app) {
    super.destroy(_app);
  }

  /**
   * This function is called when the etemplate2 object is loaded
   * and ready.  If you must store a reference to the et2 object,
   * make sure to clean it up in destroy().
   *
   * @param {etemplate2} _et2
   * @param {string} _name name of template loaded
   */
  et2_ready(_et2, _name) {
    // call parent
    super.et2_ready(_et2, _name);
    switch (_name) {
      case 'tracker.admin':
        this.acl_queue_access();
        break;
      case 'tracker.edit':
        this.edit_popup();
        break;
      case 'tracker.index':
        this.filter_change();
        if (this.et2.getArrayMgr('content').getEntry('nm[only_tracker]'))
          // there's no this.et2.getWidgetById('colfilter[tr_tracker]').hide() and
          // jQuery(this.et2.getWidgetById('colfilter[tr_tracker]').getDOMNode()).hide()
          // hides already hiden selectbox and not the choosen container :(
          jQuery('#tracker_index_col_filter_tr_tracker__chzn').hide();
        break;
      case 'tracker.escalations':
        // Set any filters with multiple values to multiple
        _et2.widgetContainer.getWidgetById('escalation').iterateOver(function (widget) {
          if (typeof widget.options.value === 'object' && widget.options.value.length > 1) {
            var button = null;
            // Find associated expand button
            widget.getParent().getParent().iterateOver(function (widget) {
              button = widget;
            }, this, et2_button);
            this.multiple_assigned(false, button);
            widget.set_value(widget.options.value);
          }
        }, this, et2_selectbox);
        break;
    }
  }

  /**
   * Observer method receives update notifications from all applications
   *
   * @param {string} _msg message (already translated) to show, eg. 'Entry deleted'
   * @param {string} _app application name
   * @param {(string|number)} _id id of entry to refresh or null
   * @param {string} _type either 'update', 'edit', 'delete', 'add' or null
   * - update: request just modified data from given rows.  Sorting is not considered,
   *		so if the sort field is changed, the row will not be moved.
   * - edit: rows changed, but sorting may be affected.  Requires full reload.
   * - delete: just delete the given rows clientside (no server interaction neccessary)
   * - add: requires full reload for proper sorting
   * @param {string} _msg_type 'error', 'warning' or 'success' (default)
   * @param {object|null} _links app => array of ids of linked entries
   * or null, if not triggered on server-side, which adds that info
   */
  observer(_msg, _app, _id, _type, _msg_type, _links) {
    if (typeof (_links === null || _links === void 0 ? void 0 : _links.tracker) != 'undefined') {
      if (_app === 'timesheet') {
        var nm = this.et2 ? this.et2.getWidgetById('nm') : null;
        if (nm) nm.applyFilters();
      }
    }
  }

  /**
   * Retrieve the current state of the application for future restoration
   *
   * The state can be anything, as long as it's an object.  The contents are
   * application specific.  Overriding the default implementation to always use
   * the tracker list, not escalations.
   * The return value of this function cannot be passed directly to setState(),
   * since setState is expecting an additional wrapper, eg:
   * {name: 'something', state: getState()}
   *
   * @return {object} Application specific map representing the current state
   */
  getState() {
    var state = {};

    // Try and find a nextmatch widget, and set its filters
    var et2 = etemplate2.getById('tracker-index');
    if (!et2) return {};
    et2.widgetContainer.iterateOver(function (_widget) {
      state = _widget.getValue();
    }, this, et2_nextmatch);
    return state;
  }

  /**
   * Tracker list filter change, used to toggle date fields
   */
  filter_change() {
    var filter = this.et2.getWidgetById('filter');
    var dates = this.et2.getWidgetById('tracker.index.dates');
    if (filter && dates) {
      dates.set_disabled(filter.getValue() !== "custom");
      if (filter.value == "custom") {
        window.setTimeout(function () {
          jQuery(this.et2.getWidgetById('startdate').getDOMNode()).find('input').focus();
        }.bind(this), 100);
      }
    }
    return true;
  }

  /**
   * User wants to share
   *
   * @param {egwAction} _action
   * @param {egwActionObject} _selected
   * @param _target
   */
  share_link(_action, _selected, _target) {
    if (_action.id == 'shareWritableFilemanager') {
      // No checkbox for parent to find, explicitly set writable
      super.share_link(_action.parent.getActionById('shareFilemanager'), _selected, _target, true);
    } else {
      // Leave writable parameter undefined so parent can check
      super.share_link(_action, _selected, _target);
    }
  }

  /**
   * Used in escalations on buttons to change filters from a single select to a multi-select
   *
   * @param {object} _event
   * @param {et2_baseWidget} _widget
   *
   * Note: It's important to consider the menupop widget needs to be always first child of
   * buttononly's parent, since we are getting the right selectbox by orders
   */
  multiple_assigned(_event, _widget) {
    _widget.set_disabled(true);
    var selectbox = _widget.getParent()._children[0];
    selectbox.set_multiple(true);
    selectbox.set_tags(true, '98%');
    return false;
  }

  /**
   * tprint
   * @param _action
   * @param _senders
   */
  tprint(_action, _senders) {
    var id = _senders[0].id.split('::');
    if (_action.id === 'print') {
      var popup = egw().open_link('/index.php?menuaction=tracker.tracker_ui.tprint&tr_id=' + id[1], '', egw().link_get_registry('tracker', 'add_popup'), 'tracker');
      popup.onload = function () {
        this.print();
      };
    }
  }

  /**
   * Check if the edit window is a popup, then set window focus
   */
  edit_popup() {
    if (typeof this.et2.node != 'undefined' && typeof this.et2.node.baseURI != 'undefined') {
      if (!this.et2.node.baseURI.match(/no_?popup/)) {
        window.focus();
        if (this.et2.node.baseURI.match('composeid'))
          //tracker created by mail application
          {
            window.resizeTo(750, 550);
          }
      }
    }
  }

  /**
   * canned_comment_request
   *
   */
  canned_comment_requst() {
    var editor = this.et2.getWidgetById('reply_message');
    var id = this.et2.getValueById('canned_response');
    if (id && editor) {
      // Need to specify the popup's egw
      this.et2.egw().json('tracker.tracker_ui.ajax_canned_comment', [id, document.getElementById('tracker-edit_reply_message').style.display == 'none']).sendRequest(true);
    }
  }
  /**
   * canned_comment_response
   * @param _replyMsg
   */
  canned_comment_response(_replyMsg) {
    this.et2.getWidgetById('canned_response').set_value('');
    var editor = this.et2.getWidgetById('reply_message');
    if (editor) {
      editor.set_value(_replyMsg);
    }
  }

  /**
   * Update the UI to show the file after user adds a file to a comment
   *
   * @param {HTMLElement} dom_node
   * @param {et2_widget} widget
   * @returns {undefined}
   */
  comment_add_vfs(dom_node, widget) {
    // Add the file into the existing list of files
    if (widget._type === 'vfs-select') {
      var upload = widget.getParent().getWidgetById(widget.options.method_id);

      // Could not find the upload widget
      if (!upload) {
        return;
      }
      var value = widget.get_value();
      for (var i in value) {
        upload._addFile({
          name: value[i],
          path: value[i]
        });
      }
    }

    // Update link widget on links tab
    widget.getRoot().iterateOver(function (widget) {
      widget._get_links();
    }, this, et2_link_list);
  }

  /**
   * acl_queue_access
   *
   * Enables or disables the Site configuration 'Staff'tab 'Users' widget
   * based on the 'enabled_queue_acl_access' config setting
   */
  acl_queue_access() {
    var queue_acl = this.et2.getWidgetById('enabled_queue_acl_access');

    // Check content too, in case we're viewing a specific queue and that widget
    // isn't there
    var content = this.et2.getArrayMgr('content').getEntry('enabled_queue_acl_access');
    if (queue_acl && queue_acl.get_value() === 'false' || content !== null && !content) {
      this.et2.getWidgetById('users').set_disabled(true);
    } else {
      this.et2.getWidgetById('users').set_disabled(false);
    }
  }

  /**
   * Get title in order to set it as document title
   * @returns {string}
   */
  getWindowTitle() {
    return this.et2.getValueById('tr_summary');
  }

  /**
   * Action handler for context menu change assigned action
   *
   * We populate the dialog with the current value.
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _selected
   */
  change_assigned(_action, _selected) {
    var et2 = _selected[0].manager.data.nextmatch.getInstanceManager();
    var assigned = et2.widgetContainer.getWidgetById('assigned');
    if (assigned) {
      assigned.set_value([]);
      et2.widgetContainer.getWidgetById('assigned_action[title]').set_value('');
      et2.widgetContainer.getWidgetById('assigned_action[title]').set_class('');
      et2.widgetContainer.getWidgetById('assigned_action[ok]').set_disabled(_selected.length !== 1);
      et2.widgetContainer.getWidgetById('assigned_action[add]').set_disabled(_selected.length === 1);
      et2.widgetContainer.getWidgetById('assigned_action[delete]').set_disabled(_selected.length === 1);
    }
    if (_selected.length === 1) {
      var data = egw.dataGetUIDdata(_selected[0].id);
      if (assigned && data && data.data) {
        et2.widgetContainer.getWidgetById('assigned_action[title]').set_value(data.data.tr_summary);
        et2.widgetContainer.getWidgetById('assigned_action[title]').set_class(data.data.class);
        assigned.set_value(data.data.tr_assigned);
      }
    }
    nm_open_popup(_action, _selected);
  }

  /**
   * Override the viewEntry to remove unseen class
   * right after view the entry.
   *
   * @param {type} _action
   * @param {type} _senders
   */
  viewEntry(_action, _senders) {
    super.viewEntry(_action, _senders);
    var nm = this.et2.getWidgetById('nm');
    var nm_indexes = nm.getController()._indexMap;
    var node = null;
    for (var i in nm_indexes) {
      if (nm_indexes[i]['uid'] == _senders[0]['id']) {
        node = nm_indexes[i].row._nodes[0].find('.tracker_unseen');
      }
    }
    if (node) {
      node.removeClass('tracker_unseen');
    }
  }

  /**
   * Handle context menu action on the comments to show the file buttons
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _entries
   */
  reply_files(_action, _entries) {
    var row = null;
    for (var i in _entries) {
      row = _entries[i].iface.getDOMNode();
      jQuery('.et2_toolbar', row).removeClass('hide_buttons').get(0).scrollIntoView();
    }
    jQuery("body").one('click', function () {
      jQuery('.et2_toolbar', row).addClass('hide_buttons');
    });
  }

  /**
   * Handle context menu action on the comments to edit the comment
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _entries
   */
  reply_edit(_action, _entries) {
    for (var i in _entries) {
      var row_id = _entries[i].id.split('row_')[1];
      if (typeof row_id !== 'string') {
        return;
      }
      var widget_id = row_id + '[reply_message]';
      var widget = _entries[i].iface.getWidget().getWidgetById(widget_id);

      // Trigger the edit mode
      widget.dblclick();
    }
  }
}
app.classes.tracker = trackerAPP;
//# sourceMappingURL=app.min.js.map
