import { f as functionBindNative, a as functionUncurryThis, t as toObject$5, b as functionCall, c as fixRegexpWellKnownSymbolLogic, d as fails$e, e as anObject$a, i as isCallable$f, g as isNullOrUndefined$6, h as toIntegerOrInfinity$1, j as toLength$4, k as toString$a, r as requireObjectCoercible$6, l as advanceStringIndex$2, m as getMethod$6, n as regexpExecAbstract, w as wellKnownSymbol$f, o as classof$5, p as getBuiltIn$5, q as inspectSource$2, s as tryToString$4, u as toPropertyKey$1, v as objectDefineProperty, x as createPropertyDescriptor$3, y as toAbsoluteIndex$1, z as lengthOfArrayLike$4, A as isRegexp, B as regexpExec$1, C as regexpStickyHelpers, D as hasOwnProperty_1, E as sharedKey$1, F as isObject$5, G as objectCreate, H as defineBuiltIn$8, I as isPure, J as aCallable$a, _ as _export, K as functionName, L as createNonEnumerableProperty$3, M as toIndexedObject$1, N as addToUnscopables$1, O as internalState, P as descriptors, Q as classofRaw, R as makeBuiltInExports, S as objectIsPrototypeOf, T as functionUncurryThisClause, U as engineUserAgent, V as global$c, W as html$1, X as documentCreateElement$1, Y as objectGetOwnPropertyDescriptor, Z as isForced_1, $ as engineV8Version, a0 as whitespaces$1, a1 as stringTrim, a2 as copyConstructorProperties$1, a3 as objectGetOwnPropertyNames, a4 as regexpGetFlags, a5 as regexpUnsupportedDotAll, a6 as regexpUnsupportedNcg, a7 as objectKeys$1, a8 as objectGetOwnPropertySymbols, a9 as objectPropertyIsEnumerable, aa as indexedObject, ab as notARegexp, ac as correctIsRegexpLogic, ad as EgwFnct, ae as egwActionStoreJSON, af as regexpFlags, ag as egwBitIsSet, ah as EGW_AO_FLAG_IS_CONTAINER, ai as EGW_AO_SHIFT_STATE_NONE, aj as EGW_AO_STATE_SELECTED, ak as EGW_AO_STATE_VISIBLE, al as EGW_AO_STATE_NORMAL, am as EGW_AO_SHIFT_STATE_MULTI, an as EGW_AO_SHIFT_STATE_BLOCK, ao as egwSetBit, ap as EGW_AO_STATE_FOCUSED, aq as EGW_KEY_A, ar as EGW_KEY_SPACE, as as EGW_KEY_PAGE_DOWN, at as EGW_KEY_ARROW_UP, au as EGW_KEY_ARROW_DOWN, av as EGW_KEY_PAGE_UP, aw as egwQueueCallback, ax as EGW_AO_EXEC_SELECTED, ay as EGW_AO_EXEC_THIS, az as egwObjectLength, aA as EGW_VALID_KEYS, aB as EGW_KEY_F1, aC as EGW_KEY_F12, aD as EGW_KEY_MENU, aE as EGW_AO_FLAG_DEFAULT_FOCUS, aF as EGW_KEY_ARROW_LEFT, aG as EGW_KEY_ARROW_RIGHT, aH as EGW_KEY_ESCAPE, aI as EGW_KEY_ENTER, aJ as EGW_AI_DRAG_OVER, aK as EGW_AI_DRAG_ENTER, aL as EGW_AI_DRAG_OUT, aM as egwIsMobile$1, aN as sprintf, aO as egwUnfocus, aP as egwGetShiftState, aQ as commonjsGlobal$1, aR as getDefaultExportFromCjs } from './egw_json-c294eee1.js';
import '../vendor/bower-asset/jquery/dist/jquery.min.js';
import '../vendor/bower-asset/cropper/dist/cropper.min.js';
import '../vendor/bower-asset/diff2html/dist/diff2html.min.js';
import '../vendor/tinymce/tinymce/tinymce.min.js';

/**
 * EGroupware eTemplate2 - File which contains all interfaces
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 */

// fixing circular dependencies

var et2_implements_registry = {};

/**
 * Checks if an object / et2_widget implements given methods
 *
 * @param obj
 * @param methods
 */
function implements_methods(obj, methods) {
  for (var i = 0; i < methods.length; ++i) {
    if (typeof obj[methods[i]] !== 'function') {
      return false;
    }
  }
  return true;
}

/**
 * Interface for all widget classes, which are based on a DOM node.
 */

var et2_IDOMNode = "et2_IDOMNode";
et2_implements_registry.et2_IDOMNode = function (obj) {
  return implements_methods(obj, ["getDOMNode"]);
};

/**
 * Interface for all et2_inputWidgets
 */

var et2_IInputNode = "et2_IInputNode";
et2_implements_registry.et2_IInputNode = function (obj) {
  return implements_methods(obj, ["getInputNode"]);
};

/**
 * Interface for all widgets which support returning a value
 */

var et2_IInput = "et2_IInput";
et2_implements_registry.et2_IInput = function (obj) {
  return implements_methods(obj, ["getValue", "isDirty", "resetDirty", "isValid"]);
};

/**
 * Interface for widgets which should be automatically resized
 */

var et2_IResizeable = "et2_IResizeable";
et2_implements_registry.et2_IResizeable = function (obj) {
  return implements_methods(obj, ["resize"]);
};

/**
 * Interface for widgets which have the align attribute
 */

var et2_IAligned = "et2_IAligned";
et2_implements_registry.et2_IAligned = function (obj) {
  return implements_methods(obj, ["get_align"]);
};

/**
 * Interface for widgets which want to e.g. perform clientside validation before
 * the form is submitted.
 */

var et2_ISubmitListener = "et2_ISubmitListener";
et2_implements_registry.et2_ISubmitListener = function (obj) {
  return implements_methods(obj, ["submit"]);
};

/**
 * Interface all widgets must support which can operate on given DOM-Nodes. This
 * is used in grid lists, when only a single row gets really stored in the widget
 * tree and this instance has to work on multiple copies of the DOM-Tree elements.
 */

var et2_IDetachedDOM = "et2_IDetachedDOM";
et2_implements_registry.et2_IDetachedDOM = function (obj) {
  return implements_methods(obj, ["getDetachedAttributes", "getDetachedNodes", "setDetachedAttributes"]);
};

/**
 * Interface for widgets that need to do something special before printing
 */

var et2_IPrint = "et2_IPrint";
et2_implements_registry.et2_IPrint = function (obj) {
  return implements_methods(obj, ["beforePrint", "afterPrint"]);
};

/**
 * Interface all exposed widget must support in order to getMedia for the blueimp Gallery.
 */

var et2_IExposable = "et2_IExposable";
et2_implements_registry.et2_IExposable = function (obj) {
  return implements_methods(obj, ["getMedia"]);
};

var es_string_replace = {};

var NATIVE_BIND$1 = functionBindNative;

var FunctionPrototype = Function.prototype;
var apply$3 = FunctionPrototype.apply;
var call$g = FunctionPrototype.call;

// eslint-disable-next-line es/no-reflect -- safe
var functionApply = typeof Reflect == 'object' && Reflect.apply || (NATIVE_BIND$1 ? call$g.bind(apply$3) : function () {
  return call$g.apply(apply$3, arguments);
});

var uncurryThis$f = functionUncurryThis;
var toObject$4 = toObject$5;

var floor$2 = Math.floor;
var charAt$2 = uncurryThis$f(''.charAt);
var replace$4 = uncurryThis$f(''.replace);
var stringSlice$7 = uncurryThis$f(''.slice);
// eslint-disable-next-line redos/no-vulnerable -- safe
var SUBSTITUTION_SYMBOLS = /\$([$&'`]|\d{1,2}|<[^>]*>)/g;
var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&'`]|\d{1,2})/g;

// `GetSubstitution` abstract operation
// https://tc39.es/ecma262/#sec-getsubstitution
var getSubstitution$2 = function (matched, str, position, captures, namedCaptures, replacement) {
  var tailPos = position + matched.length;
  var m = captures.length;
  var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;
  if (namedCaptures !== undefined) {
    namedCaptures = toObject$4(namedCaptures);
    symbols = SUBSTITUTION_SYMBOLS;
  }
  return replace$4(replacement, symbols, function (match, ch) {
    var capture;
    switch (charAt$2(ch, 0)) {
      case '$': return '$';
      case '&': return matched;
      case '`': return stringSlice$7(str, 0, position);
      case "'": return stringSlice$7(str, tailPos);
      case '<':
        capture = namedCaptures[stringSlice$7(ch, 1, -1)];
        break;
      default: // \d\d?
        var n = +ch;
        if (n === 0) return match;
        if (n > m) {
          var f = floor$2(n / 10);
          if (f === 0) return match;
          if (f <= m) return captures[f - 1] === undefined ? charAt$2(ch, 1) : captures[f - 1] + charAt$2(ch, 1);
          return match;
        }
        capture = captures[n - 1];
    }
    return capture === undefined ? '' : capture;
  });
};

'use strict';
var apply$2 = functionApply;
var call$f = functionCall;
var uncurryThis$e = functionUncurryThis;
var fixRegExpWellKnownSymbolLogic$2 = fixRegexpWellKnownSymbolLogic;
var fails$d = fails$e;
var anObject$9 = anObject$a;
var isCallable$e = isCallable$f;
var isNullOrUndefined$5 = isNullOrUndefined$6;
var toIntegerOrInfinity = toIntegerOrInfinity$1;
var toLength$3 = toLength$4;
var toString$9 = toString$a;
var requireObjectCoercible$5 = requireObjectCoercible$6;
var advanceStringIndex$1 = advanceStringIndex$2;
var getMethod$5 = getMethod$6;
var getSubstitution$1 = getSubstitution$2;
var regExpExec$1 = regexpExecAbstract;
var wellKnownSymbol$e = wellKnownSymbol$f;

var REPLACE$1 = wellKnownSymbol$e('replace');
var max$3 = Math.max;
var min$4 = Math.min;
var concat$1 = uncurryThis$e([].concat);
var push$3 = uncurryThis$e([].push);
var stringIndexOf$2 = uncurryThis$e(''.indexOf);
var stringSlice$6 = uncurryThis$e(''.slice);

var maybeToString = function (it) {
  return it === undefined ? it : String(it);
};

// IE <= 11 replaces $0 with the whole match, as if it was $&
// https://stackoverflow.com/questions/6024666/getting-ie-to-replace-a-regex-with-the-literal-string-0
var REPLACE_KEEPS_$0 = (function () {
  // eslint-disable-next-line regexp/prefer-escape-replacement-dollar-char -- required for testing
  return 'a'.replace(/./, '$0') === '$0';
})();

// Safari <= 13.0.3(?) substitutes nth capture where n>m with an empty string
var REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE = (function () {
  if (/./[REPLACE$1]) {
    return /./[REPLACE$1]('a', '$0') === '';
  }
  return false;
})();

var REPLACE_SUPPORTS_NAMED_GROUPS = !fails$d(function () {
  var re = /./;
  re.exec = function () {
    var result = [];
    result.groups = { a: '7' };
    return result;
  };
  // eslint-disable-next-line regexp/no-useless-dollar-replacements -- false positive
  return ''.replace(re, '$<a>') !== '7';
});

// @@replace logic
fixRegExpWellKnownSymbolLogic$2('replace', function (_, nativeReplace, maybeCallNative) {
  var UNSAFE_SUBSTITUTE = REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE ? '$' : '$0';

  return [
    // `String.prototype.replace` method
    // https://tc39.es/ecma262/#sec-string.prototype.replace
    function replace(searchValue, replaceValue) {
      var O = requireObjectCoercible$5(this);
      var replacer = isNullOrUndefined$5(searchValue) ? undefined : getMethod$5(searchValue, REPLACE$1);
      return replacer
        ? call$f(replacer, searchValue, O, replaceValue)
        : call$f(nativeReplace, toString$9(O), searchValue, replaceValue);
    },
    // `RegExp.prototype[@@replace]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@replace
    function (string, replaceValue) {
      var rx = anObject$9(this);
      var S = toString$9(string);

      if (
        typeof replaceValue == 'string' &&
        stringIndexOf$2(replaceValue, UNSAFE_SUBSTITUTE) === -1 &&
        stringIndexOf$2(replaceValue, '$<') === -1
      ) {
        var res = maybeCallNative(nativeReplace, rx, S, replaceValue);
        if (res.done) return res.value;
      }

      var functionalReplace = isCallable$e(replaceValue);
      if (!functionalReplace) replaceValue = toString$9(replaceValue);

      var global = rx.global;
      if (global) {
        var fullUnicode = rx.unicode;
        rx.lastIndex = 0;
      }
      var results = [];
      while (true) {
        var result = regExpExec$1(rx, S);
        if (result === null) break;

        push$3(results, result);
        if (!global) break;

        var matchStr = toString$9(result[0]);
        if (matchStr === '') rx.lastIndex = advanceStringIndex$1(S, toLength$3(rx.lastIndex), fullUnicode);
      }

      var accumulatedResult = '';
      var nextSourcePosition = 0;
      for (var i = 0; i < results.length; i++) {
        result = results[i];

        var matched = toString$9(result[0]);
        var position = max$3(min$4(toIntegerOrInfinity(result.index), S.length), 0);
        var captures = [];
        // NOTE: This is equivalent to
        //   captures = result.slice(1).map(maybeToString)
        // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
        // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
        // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.
        for (var j = 1; j < result.length; j++) push$3(captures, maybeToString(result[j]));
        var namedCaptures = result.groups;
        if (functionalReplace) {
          var replacerArgs = concat$1([matched], captures, position, S);
          if (namedCaptures !== undefined) push$3(replacerArgs, namedCaptures);
          var replacement = toString$9(apply$2(replaceValue, undefined, replacerArgs));
        } else {
          replacement = getSubstitution$1(matched, S, position, captures, namedCaptures, replaceValue);
        }
        if (position >= nextSourcePosition) {
          accumulatedResult += stringSlice$6(S, nextSourcePosition, position) + replacement;
          nextSourcePosition = position + matched.length;
        }
      }
      return accumulatedResult + stringSlice$6(S, nextSourcePosition);
    }
  ];
}, !REPLACE_SUPPORTS_NAMED_GROUPS || !REPLACE_KEEPS_$0 || REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE);

var es_string_split = {};

var uncurryThis$d = functionUncurryThis;
var fails$c = fails$e;
var isCallable$d = isCallable$f;
var classof$4 = classof$5;
var getBuiltIn$4 = getBuiltIn$5;
var inspectSource$1 = inspectSource$2;

var noop$2 = function () { /* empty */ };
var empty = [];
var construct = getBuiltIn$4('Reflect', 'construct');
var constructorRegExp = /^\s*(?:class|function)\b/;
var exec$2 = uncurryThis$d(constructorRegExp.exec);
var INCORRECT_TO_STRING = !constructorRegExp.exec(noop$2);

var isConstructorModern = function isConstructor(argument) {
  if (!isCallable$d(argument)) return false;
  try {
    construct(noop$2, empty, argument);
    return true;
  } catch (error) {
    return false;
  }
};

var isConstructorLegacy = function isConstructor(argument) {
  if (!isCallable$d(argument)) return false;
  switch (classof$4(argument)) {
    case 'AsyncFunction':
    case 'GeneratorFunction':
    case 'AsyncGeneratorFunction': return false;
  }
  try {
    // we can't check .prototype since constructors produced by .bind haven't it
    // `Function#toString` throws on some built-it function in some legacy engines
    // (for example, `DOMQuad` and similar in FF41-)
    return INCORRECT_TO_STRING || !!exec$2(constructorRegExp, inspectSource$1(argument));
  } catch (error) {
    return true;
  }
};

isConstructorLegacy.sham = true;

// `IsConstructor` abstract operation
// https://tc39.es/ecma262/#sec-isconstructor
var isConstructor$1 = !construct || fails$c(function () {
  var called;
  return isConstructorModern(isConstructorModern.call)
    || !isConstructorModern(Object)
    || !isConstructorModern(function () { called = true; })
    || called;
}) ? isConstructorLegacy : isConstructorModern;

var isConstructor = isConstructor$1;
var tryToString$3 = tryToString$4;

var $TypeError$9 = TypeError;

// `Assert: IsConstructor(argument) is true`
var aConstructor$1 = function (argument) {
  if (isConstructor(argument)) return argument;
  throw $TypeError$9(tryToString$3(argument) + ' is not a constructor');
};

var anObject$8 = anObject$a;
var aConstructor = aConstructor$1;
var isNullOrUndefined$4 = isNullOrUndefined$6;
var wellKnownSymbol$d = wellKnownSymbol$f;

var SPECIES$2 = wellKnownSymbol$d('species');

// `SpeciesConstructor` abstract operation
// https://tc39.es/ecma262/#sec-speciesconstructor
var speciesConstructor$3 = function (O, defaultConstructor) {
  var C = anObject$8(O).constructor;
  var S;
  return C === undefined || isNullOrUndefined$4(S = anObject$8(C)[SPECIES$2]) ? defaultConstructor : aConstructor(S);
};

'use strict';
var toPropertyKey = toPropertyKey$1;
var definePropertyModule = objectDefineProperty;
var createPropertyDescriptor$2 = createPropertyDescriptor$3;

var createProperty$2 = function (object, key, value) {
  var propertyKey = toPropertyKey(key);
  if (propertyKey in object) definePropertyModule.f(object, propertyKey, createPropertyDescriptor$2(0, value));
  else object[propertyKey] = value;
};

var toAbsoluteIndex = toAbsoluteIndex$1;
var lengthOfArrayLike$3 = lengthOfArrayLike$4;
var createProperty$1 = createProperty$2;

var $Array = Array;
var max$2 = Math.max;

var arraySliceSimple = function (O, start, end) {
  var length = lengthOfArrayLike$3(O);
  var k = toAbsoluteIndex(start, length);
  var fin = toAbsoluteIndex(end === undefined ? length : end, length);
  var result = $Array(max$2(fin - k, 0));
  for (var n = 0; k < fin; k++, n++) createProperty$1(result, n, O[k]);
  result.length = n;
  return result;
};

'use strict';
var apply$1 = functionApply;
var call$e = functionCall;
var uncurryThis$c = functionUncurryThis;
var fixRegExpWellKnownSymbolLogic$1 = fixRegexpWellKnownSymbolLogic;
var anObject$7 = anObject$a;
var isNullOrUndefined$3 = isNullOrUndefined$6;
var isRegExp$2 = isRegexp;
var requireObjectCoercible$4 = requireObjectCoercible$6;
var speciesConstructor$2 = speciesConstructor$3;
var advanceStringIndex = advanceStringIndex$2;
var toLength$2 = toLength$4;
var toString$8 = toString$a;
var getMethod$4 = getMethod$6;
var arraySlice$3 = arraySliceSimple;
var callRegExpExec = regexpExecAbstract;
var regexpExec = regexpExec$1;
var stickyHelpers$1 = regexpStickyHelpers;
var fails$b = fails$e;

var UNSUPPORTED_Y$1 = stickyHelpers$1.UNSUPPORTED_Y;
var MAX_UINT32 = 0xFFFFFFFF;
var min$3 = Math.min;
var $push = [].push;
var exec$1 = uncurryThis$c(/./.exec);
var push$2 = uncurryThis$c($push);
var stringSlice$5 = uncurryThis$c(''.slice);

// Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
// Weex JS has frozen built-in prototypes, so use try / catch wrapper
var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = !fails$b(function () {
  // eslint-disable-next-line regexp/no-empty-group -- required for testing
  var re = /(?:)/;
  var originalExec = re.exec;
  re.exec = function () { return originalExec.apply(this, arguments); };
  var result = 'ab'.split(re);
  return result.length !== 2 || result[0] !== 'a' || result[1] !== 'b';
});

// @@split logic
fixRegExpWellKnownSymbolLogic$1('split', function (SPLIT, nativeSplit, maybeCallNative) {
  var internalSplit;
  if (
    'abbc'.split(/(b)*/)[1] == 'c' ||
    // eslint-disable-next-line regexp/no-empty-group -- required for testing
    'test'.split(/(?:)/, -1).length != 4 ||
    'ab'.split(/(?:ab)*/).length != 2 ||
    '.'.split(/(.?)(.?)/).length != 4 ||
    // eslint-disable-next-line regexp/no-empty-capturing-group, regexp/no-empty-group -- required for testing
    '.'.split(/()()/).length > 1 ||
    ''.split(/.?/).length
  ) {
    // based on es5-shim implementation, need to rework it
    internalSplit = function (separator, limit) {
      var string = toString$8(requireObjectCoercible$4(this));
      var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
      if (lim === 0) return [];
      if (separator === undefined) return [string];
      // If `separator` is not a regex, use native split
      if (!isRegExp$2(separator)) {
        return call$e(nativeSplit, string, separator, lim);
      }
      var output = [];
      var flags = (separator.ignoreCase ? 'i' : '') +
                  (separator.multiline ? 'm' : '') +
                  (separator.unicode ? 'u' : '') +
                  (separator.sticky ? 'y' : '');
      var lastLastIndex = 0;
      // Make `global` and avoid `lastIndex` issues by working with a copy
      var separatorCopy = new RegExp(separator.source, flags + 'g');
      var match, lastIndex, lastLength;
      while (match = call$e(regexpExec, separatorCopy, string)) {
        lastIndex = separatorCopy.lastIndex;
        if (lastIndex > lastLastIndex) {
          push$2(output, stringSlice$5(string, lastLastIndex, match.index));
          if (match.length > 1 && match.index < string.length) apply$1($push, output, arraySlice$3(match, 1));
          lastLength = match[0].length;
          lastLastIndex = lastIndex;
          if (output.length >= lim) break;
        }
        if (separatorCopy.lastIndex === match.index) separatorCopy.lastIndex++; // Avoid an infinite loop
      }
      if (lastLastIndex === string.length) {
        if (lastLength || !exec$1(separatorCopy, '')) push$2(output, '');
      } else push$2(output, stringSlice$5(string, lastLastIndex));
      return output.length > lim ? arraySlice$3(output, 0, lim) : output;
    };
  // Chakra, V8
  } else if ('0'.split(undefined, 0).length) {
    internalSplit = function (separator, limit) {
      return separator === undefined && limit === 0 ? [] : call$e(nativeSplit, this, separator, limit);
    };
  } else internalSplit = nativeSplit;

  return [
    // `String.prototype.split` method
    // https://tc39.es/ecma262/#sec-string.prototype.split
    function split(separator, limit) {
      var O = requireObjectCoercible$4(this);
      var splitter = isNullOrUndefined$3(separator) ? undefined : getMethod$4(separator, SPLIT);
      return splitter
        ? call$e(splitter, separator, O, limit)
        : call$e(internalSplit, toString$8(O), separator, limit);
    },
    // `RegExp.prototype[@@split]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@split
    //
    // NOTE: This cannot be properly polyfilled in engines that don't support
    // the 'y' flag.
    function (string, limit) {
      var rx = anObject$7(this);
      var S = toString$8(string);
      var res = maybeCallNative(internalSplit, rx, S, limit, internalSplit !== nativeSplit);

      if (res.done) return res.value;

      var C = speciesConstructor$2(rx, RegExp);

      var unicodeMatching = rx.unicode;
      var flags = (rx.ignoreCase ? 'i' : '') +
                  (rx.multiline ? 'm' : '') +
                  (rx.unicode ? 'u' : '') +
                  (UNSUPPORTED_Y$1 ? 'g' : 'y');

      // ^(? + rx + ) is needed, in combination with some S slicing, to
      // simulate the 'y' flag.
      var splitter = new C(UNSUPPORTED_Y$1 ? '^(?:' + rx.source + ')' : rx, flags);
      var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
      if (lim === 0) return [];
      if (S.length === 0) return callRegExpExec(splitter, S) === null ? [S] : [];
      var p = 0;
      var q = 0;
      var A = [];
      while (q < S.length) {
        splitter.lastIndex = UNSUPPORTED_Y$1 ? 0 : q;
        var z = callRegExpExec(splitter, UNSUPPORTED_Y$1 ? stringSlice$5(S, q) : S);
        var e;
        if (
          z === null ||
          (e = min$3(toLength$2(splitter.lastIndex + (UNSUPPORTED_Y$1 ? q : 0)), S.length)) === p
        ) {
          q = advanceStringIndex(S, q, unicodeMatching);
        } else {
          push$2(A, stringSlice$5(S, p, q));
          if (A.length === lim) return A;
          for (var i = 1; i <= z.length - 1; i++) {
            push$2(A, z[i]);
            if (A.length === lim) return A;
          }
          q = p = e;
        }
      }
      push$2(A, stringSlice$5(S, p));
      return A;
    }
  ];
}, !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC, UNSUPPORTED_Y$1);

var iterators = {};

var fails$a = fails$e;

var correctPrototypeGetter = !fails$a(function () {
  function F() { /* empty */ }
  F.prototype.constructor = null;
  // eslint-disable-next-line es/no-object-getprototypeof -- required for testing
  return Object.getPrototypeOf(new F()) !== F.prototype;
});

var hasOwn$5 = hasOwnProperty_1;
var isCallable$c = isCallable$f;
var toObject$3 = toObject$5;
var sharedKey = sharedKey$1;
var CORRECT_PROTOTYPE_GETTER = correctPrototypeGetter;

var IE_PROTO = sharedKey('IE_PROTO');
var $Object = Object;
var ObjectPrototype = $Object.prototype;

// `Object.getPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.getprototypeof
// eslint-disable-next-line es/no-object-getprototypeof -- safe
var objectGetPrototypeOf = CORRECT_PROTOTYPE_GETTER ? $Object.getPrototypeOf : function (O) {
  var object = toObject$3(O);
  if (hasOwn$5(object, IE_PROTO)) return object[IE_PROTO];
  var constructor = object.constructor;
  if (isCallable$c(constructor) && object instanceof constructor) {
    return constructor.prototype;
  } return object instanceof $Object ? ObjectPrototype : null;
};

'use strict';
var fails$9 = fails$e;
var isCallable$b = isCallable$f;
var isObject$4 = isObject$5;
var create$2 = objectCreate;
var getPrototypeOf$1 = objectGetPrototypeOf;
var defineBuiltIn$7 = defineBuiltIn$8;
var wellKnownSymbol$c = wellKnownSymbol$f;
var IS_PURE$b = isPure;

var ITERATOR$7 = wellKnownSymbol$c('iterator');
var BUGGY_SAFARI_ITERATORS$1 = false;

// `%IteratorPrototype%` object
// https://tc39.es/ecma262/#sec-%iteratorprototype%-object
var IteratorPrototype$2, PrototypeOfArrayIteratorPrototype, arrayIterator;

/* eslint-disable es/no-array-prototype-keys -- safe */
if ([].keys) {
  arrayIterator = [].keys();
  // Safari 8 has buggy iterators w/o `next`
  if (!('next' in arrayIterator)) BUGGY_SAFARI_ITERATORS$1 = true;
  else {
    PrototypeOfArrayIteratorPrototype = getPrototypeOf$1(getPrototypeOf$1(arrayIterator));
    if (PrototypeOfArrayIteratorPrototype !== Object.prototype) IteratorPrototype$2 = PrototypeOfArrayIteratorPrototype;
  }
}

var NEW_ITERATOR_PROTOTYPE = !isObject$4(IteratorPrototype$2) || fails$9(function () {
  var test = {};
  // FF44- legacy iterators case
  return IteratorPrototype$2[ITERATOR$7].call(test) !== test;
});

if (NEW_ITERATOR_PROTOTYPE) IteratorPrototype$2 = {};
else if (IS_PURE$b) IteratorPrototype$2 = create$2(IteratorPrototype$2);

// `%IteratorPrototype%[@@iterator]()` method
// https://tc39.es/ecma262/#sec-%iteratorprototype%-@@iterator
if (!isCallable$b(IteratorPrototype$2[ITERATOR$7])) {
  defineBuiltIn$7(IteratorPrototype$2, ITERATOR$7, function () {
    return this;
  });
}

var iteratorsCore = {
  IteratorPrototype: IteratorPrototype$2,
  BUGGY_SAFARI_ITERATORS: BUGGY_SAFARI_ITERATORS$1
};

var defineProperty$4 = objectDefineProperty.f;
var hasOwn$4 = hasOwnProperty_1;
var wellKnownSymbol$b = wellKnownSymbol$f;

var TO_STRING_TAG$1 = wellKnownSymbol$b('toStringTag');

var setToStringTag$4 = function (target, TAG, STATIC) {
  if (target && !STATIC) target = target.prototype;
  if (target && !hasOwn$4(target, TO_STRING_TAG$1)) {
    defineProperty$4(target, TO_STRING_TAG$1, { configurable: true, value: TAG });
  }
};

'use strict';
var IteratorPrototype$1 = iteratorsCore.IteratorPrototype;
var create$1 = objectCreate;
var createPropertyDescriptor$1 = createPropertyDescriptor$3;
var setToStringTag$3 = setToStringTag$4;
var Iterators$4 = iterators;

var returnThis$1 = function () { return this; };

var iteratorCreateConstructor = function (IteratorConstructor, NAME, next, ENUMERABLE_NEXT) {
  var TO_STRING_TAG = NAME + ' Iterator';
  IteratorConstructor.prototype = create$1(IteratorPrototype$1, { next: createPropertyDescriptor$1(+!ENUMERABLE_NEXT, next) });
  setToStringTag$3(IteratorConstructor, TO_STRING_TAG, false, true);
  Iterators$4[TO_STRING_TAG] = returnThis$1;
  return IteratorConstructor;
};

var uncurryThis$b = functionUncurryThis;
var aCallable$9 = aCallable$a;

var functionUncurryThisAccessor = function (object, key, method) {
  try {
    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    return uncurryThis$b(aCallable$9(Object.getOwnPropertyDescriptor(object, key)[method]));
  } catch (error) { /* empty */ }
};

var isCallable$a = isCallable$f;

var $String = String;
var $TypeError$8 = TypeError;

var aPossiblePrototype$1 = function (argument) {
  if (typeof argument == 'object' || isCallable$a(argument)) return argument;
  throw $TypeError$8("Can't set " + $String(argument) + ' as a prototype');
};

/* eslint-disable no-proto -- safe */

var uncurryThisAccessor = functionUncurryThisAccessor;
var anObject$6 = anObject$a;
var aPossiblePrototype = aPossiblePrototype$1;

// `Object.setPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.setprototypeof
// Works with __proto__ only. Old v8 can't work with null proto objects.
// eslint-disable-next-line es/no-object-setprototypeof -- safe
var objectSetPrototypeOf = Object.setPrototypeOf || ('__proto__' in {} ? function () {
  var CORRECT_SETTER = false;
  var test = {};
  var setter;
  try {
    setter = uncurryThisAccessor(Object.prototype, '__proto__', 'set');
    setter(test, []);
    CORRECT_SETTER = test instanceof Array;
  } catch (error) { /* empty */ }
  return function setPrototypeOf(O, proto) {
    anObject$6(O);
    aPossiblePrototype(proto);
    if (CORRECT_SETTER) setter(O, proto);
    else O.__proto__ = proto;
    return O;
  };
}() : undefined);

'use strict';
var $$o = _export;
var call$d = functionCall;
var IS_PURE$a = isPure;
var FunctionName = functionName;
var isCallable$9 = isCallable$f;
var createIteratorConstructor$1 = iteratorCreateConstructor;
var getPrototypeOf = objectGetPrototypeOf;
var setPrototypeOf$2 = objectSetPrototypeOf;
var setToStringTag$2 = setToStringTag$4;
var createNonEnumerableProperty$2 = createNonEnumerableProperty$3;
var defineBuiltIn$6 = defineBuiltIn$8;
var wellKnownSymbol$a = wellKnownSymbol$f;
var Iterators$3 = iterators;
var IteratorsCore = iteratorsCore;

var PROPER_FUNCTION_NAME$1 = FunctionName.PROPER;
var CONFIGURABLE_FUNCTION_NAME = FunctionName.CONFIGURABLE;
var IteratorPrototype = IteratorsCore.IteratorPrototype;
var BUGGY_SAFARI_ITERATORS = IteratorsCore.BUGGY_SAFARI_ITERATORS;
var ITERATOR$6 = wellKnownSymbol$a('iterator');
var KEYS = 'keys';
var VALUES = 'values';
var ENTRIES = 'entries';

var returnThis = function () { return this; };

var iteratorDefine = function (Iterable, NAME, IteratorConstructor, next, DEFAULT, IS_SET, FORCED) {
  createIteratorConstructor$1(IteratorConstructor, NAME, next);

  var getIterationMethod = function (KIND) {
    if (KIND === DEFAULT && defaultIterator) return defaultIterator;
    if (!BUGGY_SAFARI_ITERATORS && KIND in IterablePrototype) return IterablePrototype[KIND];
    switch (KIND) {
      case KEYS: return function keys() { return new IteratorConstructor(this, KIND); };
      case VALUES: return function values() { return new IteratorConstructor(this, KIND); };
      case ENTRIES: return function entries() { return new IteratorConstructor(this, KIND); };
    } return function () { return new IteratorConstructor(this); };
  };

  var TO_STRING_TAG = NAME + ' Iterator';
  var INCORRECT_VALUES_NAME = false;
  var IterablePrototype = Iterable.prototype;
  var nativeIterator = IterablePrototype[ITERATOR$6]
    || IterablePrototype['@@iterator']
    || DEFAULT && IterablePrototype[DEFAULT];
  var defaultIterator = !BUGGY_SAFARI_ITERATORS && nativeIterator || getIterationMethod(DEFAULT);
  var anyNativeIterator = NAME == 'Array' ? IterablePrototype.entries || nativeIterator : nativeIterator;
  var CurrentIteratorPrototype, methods, KEY;

  // fix native
  if (anyNativeIterator) {
    CurrentIteratorPrototype = getPrototypeOf(anyNativeIterator.call(new Iterable()));
    if (CurrentIteratorPrototype !== Object.prototype && CurrentIteratorPrototype.next) {
      if (!IS_PURE$a && getPrototypeOf(CurrentIteratorPrototype) !== IteratorPrototype) {
        if (setPrototypeOf$2) {
          setPrototypeOf$2(CurrentIteratorPrototype, IteratorPrototype);
        } else if (!isCallable$9(CurrentIteratorPrototype[ITERATOR$6])) {
          defineBuiltIn$6(CurrentIteratorPrototype, ITERATOR$6, returnThis);
        }
      }
      // Set @@toStringTag to native iterators
      setToStringTag$2(CurrentIteratorPrototype, TO_STRING_TAG, true, true);
      if (IS_PURE$a) Iterators$3[TO_STRING_TAG] = returnThis;
    }
  }

  // fix Array.prototype.{ values, @@iterator }.name in V8 / FF
  if (PROPER_FUNCTION_NAME$1 && DEFAULT == VALUES && nativeIterator && nativeIterator.name !== VALUES) {
    if (!IS_PURE$a && CONFIGURABLE_FUNCTION_NAME) {
      createNonEnumerableProperty$2(IterablePrototype, 'name', VALUES);
    } else {
      INCORRECT_VALUES_NAME = true;
      defaultIterator = function values() { return call$d(nativeIterator, this); };
    }
  }

  // export additional methods
  if (DEFAULT) {
    methods = {
      values: getIterationMethod(VALUES),
      keys: IS_SET ? defaultIterator : getIterationMethod(KEYS),
      entries: getIterationMethod(ENTRIES)
    };
    if (FORCED) for (KEY in methods) {
      if (BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME || !(KEY in IterablePrototype)) {
        defineBuiltIn$6(IterablePrototype, KEY, methods[KEY]);
      }
    } else $$o({ target: NAME, proto: true, forced: BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME }, methods);
  }

  // define iterator
  if ((!IS_PURE$a || FORCED) && IterablePrototype[ITERATOR$6] !== defaultIterator) {
    defineBuiltIn$6(IterablePrototype, ITERATOR$6, defaultIterator, { name: DEFAULT });
  }
  Iterators$3[NAME] = defaultIterator;

  return methods;
};

// `CreateIterResultObject` abstract operation
// https://tc39.es/ecma262/#sec-createiterresultobject
var createIterResultObject$1 = function (value, done) {
  return { value: value, done: done };
};

'use strict';
var toIndexedObject = toIndexedObject$1;
var addToUnscopables = addToUnscopables$1;
var Iterators$2 = iterators;
var InternalStateModule$2 = internalState;
var defineProperty$3 = objectDefineProperty.f;
var defineIterator = iteratorDefine;
var createIterResultObject = createIterResultObject$1;
var IS_PURE$9 = isPure;
var DESCRIPTORS$7 = descriptors;

var ARRAY_ITERATOR = 'Array Iterator';
var setInternalState$2 = InternalStateModule$2.set;
var getInternalState = InternalStateModule$2.getterFor(ARRAY_ITERATOR);

// `Array.prototype.entries` method
// https://tc39.es/ecma262/#sec-array.prototype.entries
// `Array.prototype.keys` method
// https://tc39.es/ecma262/#sec-array.prototype.keys
// `Array.prototype.values` method
// https://tc39.es/ecma262/#sec-array.prototype.values
// `Array.prototype[@@iterator]` method
// https://tc39.es/ecma262/#sec-array.prototype-@@iterator
// `CreateArrayIterator` internal method
// https://tc39.es/ecma262/#sec-createarrayiterator
var es_array_iterator = defineIterator(Array, 'Array', function (iterated, kind) {
  setInternalState$2(this, {
    type: ARRAY_ITERATOR,
    target: toIndexedObject(iterated), // target
    index: 0,                          // next index
    kind: kind                         // kind
  });
// `%ArrayIteratorPrototype%.next` method
// https://tc39.es/ecma262/#sec-%arrayiteratorprototype%.next
}, function () {
  var state = getInternalState(this);
  var target = state.target;
  var kind = state.kind;
  var index = state.index++;
  if (!target || index >= target.length) {
    state.target = undefined;
    return createIterResultObject(undefined, true);
  }
  if (kind == 'keys') return createIterResultObject(index, false);
  if (kind == 'values') return createIterResultObject(target[index], false);
  return createIterResultObject([index, target[index]], false);
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values%
// https://tc39.es/ecma262/#sec-createunmappedargumentsobject
// https://tc39.es/ecma262/#sec-createmappedargumentsobject
var values = Iterators$2.Arguments = Iterators$2.Array;

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');

// V8 ~ Chrome 45- bug
if (!IS_PURE$9 && DESCRIPTORS$7 && values.name !== 'values') try {
  defineProperty$3(values, 'name', { value: 'values' });
} catch (error) { /* empty */ }

var es_promise = {};

var es_promise_constructor = {};

var classof$3 = classofRaw;

var engineIsNode = typeof process != 'undefined' && classof$3(process) == 'process';

var makeBuiltIn = makeBuiltInExports;
var defineProperty$2 = objectDefineProperty;

var defineBuiltInAccessor$4 = function (target, name, descriptor) {
  if (descriptor.get) makeBuiltIn(descriptor.get, name, { getter: true });
  if (descriptor.set) makeBuiltIn(descriptor.set, name, { setter: true });
  return defineProperty$2.f(target, name, descriptor);
};

'use strict';
var getBuiltIn$3 = getBuiltIn$5;
var defineBuiltInAccessor$3 = defineBuiltInAccessor$4;
var wellKnownSymbol$9 = wellKnownSymbol$f;
var DESCRIPTORS$6 = descriptors;

var SPECIES$1 = wellKnownSymbol$9('species');

var setSpecies$2 = function (CONSTRUCTOR_NAME) {
  var Constructor = getBuiltIn$3(CONSTRUCTOR_NAME);

  if (DESCRIPTORS$6 && Constructor && !Constructor[SPECIES$1]) {
    defineBuiltInAccessor$3(Constructor, SPECIES$1, {
      configurable: true,
      get: function () { return this; }
    });
  }
};

var isPrototypeOf$3 = objectIsPrototypeOf;

var $TypeError$7 = TypeError;

var anInstance$2 = function (it, Prototype) {
  if (isPrototypeOf$3(Prototype, it)) return it;
  throw $TypeError$7('Incorrect invocation');
};

var uncurryThis$a = functionUncurryThisClause;
var aCallable$8 = aCallable$a;
var NATIVE_BIND = functionBindNative;

var bind$5 = uncurryThis$a(uncurryThis$a.bind);

// optional / simple context binding
var functionBindContext = function (fn, that) {
  aCallable$8(fn);
  return that === undefined ? fn : NATIVE_BIND ? bind$5(fn, that) : function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};

var uncurryThis$9 = functionUncurryThis;

var arraySlice$2 = uncurryThis$9([].slice);

var $TypeError$6 = TypeError;

var validateArgumentsLength$2 = function (passed, required) {
  if (passed < required) throw $TypeError$6('Not enough arguments');
  return passed;
};

var userAgent$5 = engineUserAgent;

// eslint-disable-next-line redos/no-vulnerable -- safe
var engineIsIos = /(?:ipad|iphone|ipod).*applewebkit/i.test(userAgent$5);

var global$b = global$c;
var apply = functionApply;
var bind$4 = functionBindContext;
var isCallable$8 = isCallable$f;
var hasOwn$3 = hasOwnProperty_1;
var fails$8 = fails$e;
var html = html$1;
var arraySlice$1 = arraySlice$2;
var createElement$1 = documentCreateElement$1;
var validateArgumentsLength$1 = validateArgumentsLength$2;
var IS_IOS$1 = engineIsIos;
var IS_NODE$4 = engineIsNode;

var set$5 = global$b.setImmediate;
var clear = global$b.clearImmediate;
var process$4 = global$b.process;
var Dispatch = global$b.Dispatch;
var Function$1 = global$b.Function;
var MessageChannel = global$b.MessageChannel;
var String$1 = global$b.String;
var counter = 0;
var queue$3 = {};
var ONREADYSTATECHANGE = 'onreadystatechange';
var $location, defer, channel, port;

fails$8(function () {
  // Deno throws a ReferenceError on `location` access without `--location` flag
  $location = global$b.location;
});

var run = function (id) {
  if (hasOwn$3(queue$3, id)) {
    var fn = queue$3[id];
    delete queue$3[id];
    fn();
  }
};

var runner = function (id) {
  return function () {
    run(id);
  };
};

var eventListener = function (event) {
  run(event.data);
};

var globalPostMessageDefer = function (id) {
  // old engines have not location.origin
  global$b.postMessage(String$1(id), $location.protocol + '//' + $location.host);
};

// Node.js 0.9+ & IE10+ has setImmediate, otherwise:
if (!set$5 || !clear) {
  set$5 = function setImmediate(handler) {
    validateArgumentsLength$1(arguments.length, 1);
    var fn = isCallable$8(handler) ? handler : Function$1(handler);
    var args = arraySlice$1(arguments, 1);
    queue$3[++counter] = function () {
      apply(fn, undefined, args);
    };
    defer(counter);
    return counter;
  };
  clear = function clearImmediate(id) {
    delete queue$3[id];
  };
  // Node.js 0.8-
  if (IS_NODE$4) {
    defer = function (id) {
      process$4.nextTick(runner(id));
    };
  // Sphere (JS game engine) Dispatch API
  } else if (Dispatch && Dispatch.now) {
    defer = function (id) {
      Dispatch.now(runner(id));
    };
  // Browsers with MessageChannel, includes WebWorkers
  // except iOS - https://github.com/zloirock/core-js/issues/624
  } else if (MessageChannel && !IS_IOS$1) {
    channel = new MessageChannel();
    port = channel.port2;
    channel.port1.onmessage = eventListener;
    defer = bind$4(port.postMessage, port);
  // Browsers with postMessage, skip WebWorkers
  // IE8 has postMessage, but it's sync & typeof its postMessage is 'object'
  } else if (
    global$b.addEventListener &&
    isCallable$8(global$b.postMessage) &&
    !global$b.importScripts &&
    $location && $location.protocol !== 'file:' &&
    !fails$8(globalPostMessageDefer)
  ) {
    defer = globalPostMessageDefer;
    global$b.addEventListener('message', eventListener, false);
  // IE8-
  } else if (ONREADYSTATECHANGE in createElement$1('script')) {
    defer = function (id) {
      html.appendChild(createElement$1('script'))[ONREADYSTATECHANGE] = function () {
        html.removeChild(this);
        run(id);
      };
    };
  // Rest old browsers
  } else {
    defer = function (id) {
      setTimeout(runner(id), 0);
    };
  }
}

var task$1 = {
  set: set$5,
  clear: clear
};

var Queue$2 = function () {
  this.head = null;
  this.tail = null;
};

Queue$2.prototype = {
  add: function (item) {
    var entry = { item: item, next: null };
    var tail = this.tail;
    if (tail) tail.next = entry;
    else this.head = entry;
    this.tail = entry;
  },
  get: function () {
    var entry = this.head;
    if (entry) {
      var next = this.head = entry.next;
      if (next === null) this.tail = null;
      return entry.item;
    }
  }
};

var queue$2 = Queue$2;

var userAgent$4 = engineUserAgent;

var engineIsIosPebble = /ipad|iphone|ipod/i.test(userAgent$4) && typeof Pebble != 'undefined';

var userAgent$3 = engineUserAgent;

var engineIsWebosWebkit = /web0s(?!.*chrome)/i.test(userAgent$3);

var global$a = global$c;
var bind$3 = functionBindContext;
var getOwnPropertyDescriptor$3 = objectGetOwnPropertyDescriptor.f;
var macrotask = task$1.set;
var Queue$1 = queue$2;
var IS_IOS = engineIsIos;
var IS_IOS_PEBBLE = engineIsIosPebble;
var IS_WEBOS_WEBKIT = engineIsWebosWebkit;
var IS_NODE$3 = engineIsNode;

var MutationObserver$1 = global$a.MutationObserver || global$a.WebKitMutationObserver;
var document$2 = global$a.document;
var process$3 = global$a.process;
var Promise$1 = global$a.Promise;
// Node.js 11 shows ExperimentalWarning on getting `queueMicrotask`
var queueMicrotaskDescriptor = getOwnPropertyDescriptor$3(global$a, 'queueMicrotask');
var microtask$1 = queueMicrotaskDescriptor && queueMicrotaskDescriptor.value;
var notify$1, toggle, node, promise, then;

// modern engines have queueMicrotask method
if (!microtask$1) {
  var queue$1 = new Queue$1();

  var flush = function () {
    var parent, fn;
    if (IS_NODE$3 && (parent = process$3.domain)) parent.exit();
    while (fn = queue$1.get()) try {
      fn();
    } catch (error) {
      if (queue$1.head) notify$1();
      throw error;
    }
    if (parent) parent.enter();
  };

  // browsers with MutationObserver, except iOS - https://github.com/zloirock/core-js/issues/339
  // also except WebOS Webkit https://github.com/zloirock/core-js/issues/898
  if (!IS_IOS && !IS_NODE$3 && !IS_WEBOS_WEBKIT && MutationObserver$1 && document$2) {
    toggle = true;
    node = document$2.createTextNode('');
    new MutationObserver$1(flush).observe(node, { characterData: true });
    notify$1 = function () {
      node.data = toggle = !toggle;
    };
  // environments with maybe non-completely correct, but existent Promise
  } else if (!IS_IOS_PEBBLE && Promise$1 && Promise$1.resolve) {
    // Promise.resolve without an argument throws an error in LG WebOS 2
    promise = Promise$1.resolve(undefined);
    // workaround of WebKit ~ iOS Safari 10.1 bug
    promise.constructor = Promise$1;
    then = bind$3(promise.then, promise);
    notify$1 = function () {
      then(flush);
    };
  // Node.js without promises
  } else if (IS_NODE$3) {
    notify$1 = function () {
      process$3.nextTick(flush);
    };
  // for other environments - macrotask based on:
  // - setImmediate
  // - MessageChannel
  // - window.postMessage
  // - onreadystatechange
  // - setTimeout
  } else {
    // `webpack` dev server bug on IE global methods - use bind(fn, global)
    macrotask = bind$3(macrotask, global$a);
    notify$1 = function () {
      macrotask(flush);
    };
  }

  microtask$1 = function (fn) {
    if (!queue$1.head) notify$1();
    queue$1.add(fn);
  };
}

var microtask_1 = microtask$1;

var hostReportErrors$1 = function (a, b) {
  try {
    // eslint-disable-next-line no-console -- safe
    arguments.length == 1 ? console.error(a) : console.error(a, b);
  } catch (error) { /* empty */ }
};

var perform$4 = function (exec) {
  try {
    return { error: false, value: exec() };
  } catch (error) {
    return { error: true, value: error };
  }
};

var global$9 = global$c;

var promiseNativeConstructor = global$9.Promise;

/* global Deno -- Deno case */

var engineIsDeno = typeof Deno == 'object' && Deno && typeof Deno.version == 'object';

var IS_DENO$1 = engineIsDeno;
var IS_NODE$2 = engineIsNode;

var engineIsBrowser = !IS_DENO$1 && !IS_NODE$2
  && typeof window == 'object'
  && typeof document == 'object';

var global$8 = global$c;
var NativePromiseConstructor$5 = promiseNativeConstructor;
var isCallable$7 = isCallable$f;
var isForced$1 = isForced_1;
var inspectSource = inspectSource$2;
var wellKnownSymbol$8 = wellKnownSymbol$f;
var IS_BROWSER = engineIsBrowser;
var IS_DENO = engineIsDeno;
var IS_PURE$8 = isPure;
var V8_VERSION = engineV8Version;

var NativePromisePrototype$3 = NativePromiseConstructor$5 && NativePromiseConstructor$5.prototype;
var SPECIES = wellKnownSymbol$8('species');
var SUBCLASSING = false;
var NATIVE_PROMISE_REJECTION_EVENT$1 = isCallable$7(global$8.PromiseRejectionEvent);

var FORCED_PROMISE_CONSTRUCTOR$5 = isForced$1('Promise', function () {
  var PROMISE_CONSTRUCTOR_SOURCE = inspectSource(NativePromiseConstructor$5);
  var GLOBAL_CORE_JS_PROMISE = PROMISE_CONSTRUCTOR_SOURCE !== String(NativePromiseConstructor$5);
  // V8 6.6 (Node 10 and Chrome 66) have a bug with resolving custom thenables
  // https://bugs.chromium.org/p/chromium/issues/detail?id=830565
  // We can't detect it synchronously, so just check versions
  if (!GLOBAL_CORE_JS_PROMISE && V8_VERSION === 66) return true;
  // We need Promise#{ catch, finally } in the pure version for preventing prototype pollution
  if (IS_PURE$8 && !(NativePromisePrototype$3['catch'] && NativePromisePrototype$3['finally'])) return true;
  // We can't use @@species feature detection in V8 since it causes
  // deoptimization and performance degradation
  // https://github.com/zloirock/core-js/issues/679
  if (!V8_VERSION || V8_VERSION < 51 || !/native code/.test(PROMISE_CONSTRUCTOR_SOURCE)) {
    // Detect correctness of subclassing with @@species support
    var promise = new NativePromiseConstructor$5(function (resolve) { resolve(1); });
    var FakePromise = function (exec) {
      exec(function () { /* empty */ }, function () { /* empty */ });
    };
    var constructor = promise.constructor = {};
    constructor[SPECIES] = FakePromise;
    SUBCLASSING = promise.then(function () { /* empty */ }) instanceof FakePromise;
    if (!SUBCLASSING) return true;
  // Unhandled rejections tracking support, NodeJS Promise without it fails @@species test
  } return !GLOBAL_CORE_JS_PROMISE && (IS_BROWSER || IS_DENO) && !NATIVE_PROMISE_REJECTION_EVENT$1;
});

var promiseConstructorDetection = {
  CONSTRUCTOR: FORCED_PROMISE_CONSTRUCTOR$5,
  REJECTION_EVENT: NATIVE_PROMISE_REJECTION_EVENT$1,
  SUBCLASSING: SUBCLASSING
};

var newPromiseCapability$2 = {};

'use strict';
var aCallable$7 = aCallable$a;

var $TypeError$5 = TypeError;

var PromiseCapability = function (C) {
  var resolve, reject;
  this.promise = new C(function ($$resolve, $$reject) {
    if (resolve !== undefined || reject !== undefined) throw $TypeError$5('Bad Promise constructor');
    resolve = $$resolve;
    reject = $$reject;
  });
  this.resolve = aCallable$7(resolve);
  this.reject = aCallable$7(reject);
};

// `NewPromiseCapability` abstract operation
// https://tc39.es/ecma262/#sec-newpromisecapability
var f$5 = newPromiseCapability$2.f = function (C) {
  return new PromiseCapability(C);
};

'use strict';
var $$n = _export;
var IS_PURE$7 = isPure;
var IS_NODE$1 = engineIsNode;
var global$7 = global$c;
var call$c = functionCall;
var defineBuiltIn$5 = defineBuiltIn$8;
var setPrototypeOf$1 = objectSetPrototypeOf;
var setToStringTag$1 = setToStringTag$4;
var setSpecies$1 = setSpecies$2;
var aCallable$6 = aCallable$a;
var isCallable$6 = isCallable$f;
var isObject$3 = isObject$5;
var anInstance$1 = anInstance$2;
var speciesConstructor$1 = speciesConstructor$3;
var task = task$1.set;
var microtask = microtask_1;
var hostReportErrors = hostReportErrors$1;
var perform$3 = perform$4;
var Queue = queue$2;
var InternalStateModule$1 = internalState;
var NativePromiseConstructor$4 = promiseNativeConstructor;
var PromiseConstructorDetection = promiseConstructorDetection;
var newPromiseCapabilityModule$4 = newPromiseCapability$2;

var PROMISE = 'Promise';
var FORCED_PROMISE_CONSTRUCTOR$4 = PromiseConstructorDetection.CONSTRUCTOR;
var NATIVE_PROMISE_REJECTION_EVENT = PromiseConstructorDetection.REJECTION_EVENT;
var NATIVE_PROMISE_SUBCLASSING = PromiseConstructorDetection.SUBCLASSING;
var getInternalPromiseState = InternalStateModule$1.getterFor(PROMISE);
var setInternalState$1 = InternalStateModule$1.set;
var NativePromisePrototype$2 = NativePromiseConstructor$4 && NativePromiseConstructor$4.prototype;
var PromiseConstructor = NativePromiseConstructor$4;
var PromisePrototype = NativePromisePrototype$2;
var TypeError$2 = global$7.TypeError;
var document$1 = global$7.document;
var process$2 = global$7.process;
var newPromiseCapability$1 = newPromiseCapabilityModule$4.f;
var newGenericPromiseCapability = newPromiseCapability$1;

var DISPATCH_EVENT = !!(document$1 && document$1.createEvent && global$7.dispatchEvent);
var UNHANDLED_REJECTION = 'unhandledrejection';
var REJECTION_HANDLED = 'rejectionhandled';
var PENDING = 0;
var FULFILLED = 1;
var REJECTED = 2;
var HANDLED = 1;
var UNHANDLED = 2;

var Internal, OwnPromiseCapability, PromiseWrapper, nativeThen;

// helpers
var isThenable = function (it) {
  var then;
  return isObject$3(it) && isCallable$6(then = it.then) ? then : false;
};

var callReaction = function (reaction, state) {
  var value = state.value;
  var ok = state.state == FULFILLED;
  var handler = ok ? reaction.ok : reaction.fail;
  var resolve = reaction.resolve;
  var reject = reaction.reject;
  var domain = reaction.domain;
  var result, then, exited;
  try {
    if (handler) {
      if (!ok) {
        if (state.rejection === UNHANDLED) onHandleUnhandled(state);
        state.rejection = HANDLED;
      }
      if (handler === true) result = value;
      else {
        if (domain) domain.enter();
        result = handler(value); // can throw
        if (domain) {
          domain.exit();
          exited = true;
        }
      }
      if (result === reaction.promise) {
        reject(TypeError$2('Promise-chain cycle'));
      } else if (then = isThenable(result)) {
        call$c(then, result, resolve, reject);
      } else resolve(result);
    } else reject(value);
  } catch (error) {
    if (domain && !exited) domain.exit();
    reject(error);
  }
};

var notify = function (state, isReject) {
  if (state.notified) return;
  state.notified = true;
  microtask(function () {
    var reactions = state.reactions;
    var reaction;
    while (reaction = reactions.get()) {
      callReaction(reaction, state);
    }
    state.notified = false;
    if (isReject && !state.rejection) onUnhandled(state);
  });
};

var dispatchEvent$1 = function (name, promise, reason) {
  var event, handler;
  if (DISPATCH_EVENT) {
    event = document$1.createEvent('Event');
    event.promise = promise;
    event.reason = reason;
    event.initEvent(name, false, true);
    global$7.dispatchEvent(event);
  } else event = { promise: promise, reason: reason };
  if (!NATIVE_PROMISE_REJECTION_EVENT && (handler = global$7['on' + name])) handler(event);
  else if (name === UNHANDLED_REJECTION) hostReportErrors('Unhandled promise rejection', reason);
};

var onUnhandled = function (state) {
  call$c(task, global$7, function () {
    var promise = state.facade;
    var value = state.value;
    var IS_UNHANDLED = isUnhandled(state);
    var result;
    if (IS_UNHANDLED) {
      result = perform$3(function () {
        if (IS_NODE$1) {
          process$2.emit('unhandledRejection', value, promise);
        } else dispatchEvent$1(UNHANDLED_REJECTION, promise, value);
      });
      // Browsers should not trigger `rejectionHandled` event if it was handled here, NodeJS - should
      state.rejection = IS_NODE$1 || isUnhandled(state) ? UNHANDLED : HANDLED;
      if (result.error) throw result.value;
    }
  });
};

var isUnhandled = function (state) {
  return state.rejection !== HANDLED && !state.parent;
};

var onHandleUnhandled = function (state) {
  call$c(task, global$7, function () {
    var promise = state.facade;
    if (IS_NODE$1) {
      process$2.emit('rejectionHandled', promise);
    } else dispatchEvent$1(REJECTION_HANDLED, promise, state.value);
  });
};

var bind$2 = function (fn, state, unwrap) {
  return function (value) {
    fn(state, value, unwrap);
  };
};

var internalReject = function (state, value, unwrap) {
  if (state.done) return;
  state.done = true;
  if (unwrap) state = unwrap;
  state.value = value;
  state.state = REJECTED;
  notify(state, true);
};

var internalResolve = function (state, value, unwrap) {
  if (state.done) return;
  state.done = true;
  if (unwrap) state = unwrap;
  try {
    if (state.facade === value) throw TypeError$2("Promise can't be resolved itself");
    var then = isThenable(value);
    if (then) {
      microtask(function () {
        var wrapper = { done: false };
        try {
          call$c(then, value,
            bind$2(internalResolve, wrapper, state),
            bind$2(internalReject, wrapper, state)
          );
        } catch (error) {
          internalReject(wrapper, error, state);
        }
      });
    } else {
      state.value = value;
      state.state = FULFILLED;
      notify(state, false);
    }
  } catch (error) {
    internalReject({ done: false }, error, state);
  }
};

// constructor polyfill
if (FORCED_PROMISE_CONSTRUCTOR$4) {
  // 25.4.3.1 Promise(executor)
  PromiseConstructor = function Promise(executor) {
    anInstance$1(this, PromisePrototype);
    aCallable$6(executor);
    call$c(Internal, this);
    var state = getInternalPromiseState(this);
    try {
      executor(bind$2(internalResolve, state), bind$2(internalReject, state));
    } catch (error) {
      internalReject(state, error);
    }
  };

  PromisePrototype = PromiseConstructor.prototype;

  // eslint-disable-next-line no-unused-vars -- required for `.length`
  Internal = function Promise(executor) {
    setInternalState$1(this, {
      type: PROMISE,
      done: false,
      notified: false,
      parent: false,
      reactions: new Queue(),
      rejection: false,
      state: PENDING,
      value: undefined
    });
  };

  // `Promise.prototype.then` method
  // https://tc39.es/ecma262/#sec-promise.prototype.then
  Internal.prototype = defineBuiltIn$5(PromisePrototype, 'then', function then(onFulfilled, onRejected) {
    var state = getInternalPromiseState(this);
    var reaction = newPromiseCapability$1(speciesConstructor$1(this, PromiseConstructor));
    state.parent = true;
    reaction.ok = isCallable$6(onFulfilled) ? onFulfilled : true;
    reaction.fail = isCallable$6(onRejected) && onRejected;
    reaction.domain = IS_NODE$1 ? process$2.domain : undefined;
    if (state.state == PENDING) state.reactions.add(reaction);
    else microtask(function () {
      callReaction(reaction, state);
    });
    return reaction.promise;
  });

  OwnPromiseCapability = function () {
    var promise = new Internal();
    var state = getInternalPromiseState(promise);
    this.promise = promise;
    this.resolve = bind$2(internalResolve, state);
    this.reject = bind$2(internalReject, state);
  };

  newPromiseCapabilityModule$4.f = newPromiseCapability$1 = function (C) {
    return C === PromiseConstructor || C === PromiseWrapper
      ? new OwnPromiseCapability(C)
      : newGenericPromiseCapability(C);
  };

  if (!IS_PURE$7 && isCallable$6(NativePromiseConstructor$4) && NativePromisePrototype$2 !== Object.prototype) {
    nativeThen = NativePromisePrototype$2.then;

    if (!NATIVE_PROMISE_SUBCLASSING) {
      // make `Promise#then` return a polyfilled `Promise` for native promise-based APIs
      defineBuiltIn$5(NativePromisePrototype$2, 'then', function then(onFulfilled, onRejected) {
        var that = this;
        return new PromiseConstructor(function (resolve, reject) {
          call$c(nativeThen, that, resolve, reject);
        }).then(onFulfilled, onRejected);
      // https://github.com/zloirock/core-js/issues/640
      }, { unsafe: true });
    }

    // make `.constructor === Promise` work for native promise-based APIs
    try {
      delete NativePromisePrototype$2.constructor;
    } catch (error) { /* empty */ }

    // make `instanceof Promise` work for native promise-based APIs
    if (setPrototypeOf$1) {
      setPrototypeOf$1(NativePromisePrototype$2, PromisePrototype);
    }
  }
}

$$n({ global: true, constructor: true, wrap: true, forced: FORCED_PROMISE_CONSTRUCTOR$4 }, {
  Promise: PromiseConstructor
});

setToStringTag$1(PromiseConstructor, PROMISE, false, true);
setSpecies$1(PROMISE);

var es_promise_all = {};

var wellKnownSymbol$7 = wellKnownSymbol$f;
var Iterators$1 = iterators;

var ITERATOR$5 = wellKnownSymbol$7('iterator');
var ArrayPrototype = Array.prototype;

// check on default Array iterator
var isArrayIteratorMethod$1 = function (it) {
  return it !== undefined && (Iterators$1.Array === it || ArrayPrototype[ITERATOR$5] === it);
};

var classof$2 = classof$5;
var getMethod$3 = getMethod$6;
var isNullOrUndefined$2 = isNullOrUndefined$6;
var Iterators = iterators;
var wellKnownSymbol$6 = wellKnownSymbol$f;

var ITERATOR$4 = wellKnownSymbol$6('iterator');

var getIteratorMethod$3 = function (it) {
  if (!isNullOrUndefined$2(it)) return getMethod$3(it, ITERATOR$4)
    || getMethod$3(it, '@@iterator')
    || Iterators[classof$2(it)];
};

var call$b = functionCall;
var aCallable$5 = aCallable$a;
var anObject$5 = anObject$a;
var tryToString$2 = tryToString$4;
var getIteratorMethod$2 = getIteratorMethod$3;

var $TypeError$4 = TypeError;

var getIterator$2 = function (argument, usingIterator) {
  var iteratorMethod = arguments.length < 2 ? getIteratorMethod$2(argument) : usingIterator;
  if (aCallable$5(iteratorMethod)) return anObject$5(call$b(iteratorMethod, argument));
  throw $TypeError$4(tryToString$2(argument) + ' is not iterable');
};

var call$a = functionCall;
var anObject$4 = anObject$a;
var getMethod$2 = getMethod$6;

var iteratorClose$1 = function (iterator, kind, value) {
  var innerResult, innerError;
  anObject$4(iterator);
  try {
    innerResult = getMethod$2(iterator, 'return');
    if (!innerResult) {
      if (kind === 'throw') throw value;
      return value;
    }
    innerResult = call$a(innerResult, iterator);
  } catch (error) {
    innerError = true;
    innerResult = error;
  }
  if (kind === 'throw') throw value;
  if (innerError) throw innerResult;
  anObject$4(innerResult);
  return value;
};

var bind$1 = functionBindContext;
var call$9 = functionCall;
var anObject$3 = anObject$a;
var tryToString$1 = tryToString$4;
var isArrayIteratorMethod = isArrayIteratorMethod$1;
var lengthOfArrayLike$2 = lengthOfArrayLike$4;
var isPrototypeOf$2 = objectIsPrototypeOf;
var getIterator$1 = getIterator$2;
var getIteratorMethod$1 = getIteratorMethod$3;
var iteratorClose = iteratorClose$1;

var $TypeError$3 = TypeError;

var Result = function (stopped, result) {
  this.stopped = stopped;
  this.result = result;
};

var ResultPrototype = Result.prototype;

var iterate$4 = function (iterable, unboundFunction, options) {
  var that = options && options.that;
  var AS_ENTRIES = !!(options && options.AS_ENTRIES);
  var IS_RECORD = !!(options && options.IS_RECORD);
  var IS_ITERATOR = !!(options && options.IS_ITERATOR);
  var INTERRUPTED = !!(options && options.INTERRUPTED);
  var fn = bind$1(unboundFunction, that);
  var iterator, iterFn, index, length, result, next, step;

  var stop = function (condition) {
    if (iterator) iteratorClose(iterator, 'normal', condition);
    return new Result(true, condition);
  };

  var callFn = function (value) {
    if (AS_ENTRIES) {
      anObject$3(value);
      return INTERRUPTED ? fn(value[0], value[1], stop) : fn(value[0], value[1]);
    } return INTERRUPTED ? fn(value, stop) : fn(value);
  };

  if (IS_RECORD) {
    iterator = iterable.iterator;
  } else if (IS_ITERATOR) {
    iterator = iterable;
  } else {
    iterFn = getIteratorMethod$1(iterable);
    if (!iterFn) throw $TypeError$3(tryToString$1(iterable) + ' is not iterable');
    // optimisation for array iterators
    if (isArrayIteratorMethod(iterFn)) {
      for (index = 0, length = lengthOfArrayLike$2(iterable); length > index; index++) {
        result = callFn(iterable[index]);
        if (result && isPrototypeOf$2(ResultPrototype, result)) return result;
      } return new Result(false);
    }
    iterator = getIterator$1(iterable, iterFn);
  }

  next = IS_RECORD ? iterable.next : iterator.next;
  while (!(step = call$9(next, iterator)).done) {
    try {
      result = callFn(step.value);
    } catch (error) {
      iteratorClose(iterator, 'throw', error);
    }
    if (typeof result == 'object' && result && isPrototypeOf$2(ResultPrototype, result)) return result;
  } return new Result(false);
};

var wellKnownSymbol$5 = wellKnownSymbol$f;

var ITERATOR$3 = wellKnownSymbol$5('iterator');
var SAFE_CLOSING = false;

try {
  var called = 0;
  var iteratorWithReturn = {
    next: function () {
      return { done: !!called++ };
    },
    'return': function () {
      SAFE_CLOSING = true;
    }
  };
  iteratorWithReturn[ITERATOR$3] = function () {
    return this;
  };
  // eslint-disable-next-line es/no-array-from, no-throw-literal -- required for testing
  Array.from(iteratorWithReturn, function () { throw 2; });
} catch (error) { /* empty */ }

var checkCorrectnessOfIteration$1 = function (exec, SKIP_CLOSING) {
  if (!SKIP_CLOSING && !SAFE_CLOSING) return false;
  var ITERATION_SUPPORT = false;
  try {
    var object = {};
    object[ITERATOR$3] = function () {
      return {
        next: function () {
          return { done: ITERATION_SUPPORT = true };
        }
      };
    };
    exec(object);
  } catch (error) { /* empty */ }
  return ITERATION_SUPPORT;
};

var NativePromiseConstructor$3 = promiseNativeConstructor;
var checkCorrectnessOfIteration = checkCorrectnessOfIteration$1;
var FORCED_PROMISE_CONSTRUCTOR$3 = promiseConstructorDetection.CONSTRUCTOR;

var promiseStaticsIncorrectIteration = FORCED_PROMISE_CONSTRUCTOR$3 || !checkCorrectnessOfIteration(function (iterable) {
  NativePromiseConstructor$3.all(iterable).then(undefined, function () { /* empty */ });
});

'use strict';
var $$m = _export;
var call$8 = functionCall;
var aCallable$4 = aCallable$a;
var newPromiseCapabilityModule$3 = newPromiseCapability$2;
var perform$2 = perform$4;
var iterate$3 = iterate$4;
var PROMISE_STATICS_INCORRECT_ITERATION$2 = promiseStaticsIncorrectIteration;

// `Promise.all` method
// https://tc39.es/ecma262/#sec-promise.all
$$m({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION$2 }, {
  all: function all(iterable) {
    var C = this;
    var capability = newPromiseCapabilityModule$3.f(C);
    var resolve = capability.resolve;
    var reject = capability.reject;
    var result = perform$2(function () {
      var $promiseResolve = aCallable$4(C.resolve);
      var values = [];
      var counter = 0;
      var remaining = 1;
      iterate$3(iterable, function (promise) {
        var index = counter++;
        var alreadyCalled = false;
        remaining++;
        call$8($promiseResolve, C, promise).then(function (value) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[index] = value;
          --remaining || resolve(values);
        }, reject);
      });
      --remaining || resolve(values);
    });
    if (result.error) reject(result.value);
    return capability.promise;
  }
});

var es_promise_catch = {};

'use strict';
var $$l = _export;
var IS_PURE$6 = isPure;
var FORCED_PROMISE_CONSTRUCTOR$2 = promiseConstructorDetection.CONSTRUCTOR;
var NativePromiseConstructor$2 = promiseNativeConstructor;
var getBuiltIn$2 = getBuiltIn$5;
var isCallable$5 = isCallable$f;
var defineBuiltIn$4 = defineBuiltIn$8;

var NativePromisePrototype$1 = NativePromiseConstructor$2 && NativePromiseConstructor$2.prototype;

// `Promise.prototype.catch` method
// https://tc39.es/ecma262/#sec-promise.prototype.catch
$$l({ target: 'Promise', proto: true, forced: FORCED_PROMISE_CONSTRUCTOR$2, real: true }, {
  'catch': function (onRejected) {
    return this.then(undefined, onRejected);
  }
});

// makes sure that native promise-based APIs `Promise#catch` properly works with patched `Promise#then`
if (!IS_PURE$6 && isCallable$5(NativePromiseConstructor$2)) {
  var method$1 = getBuiltIn$2('Promise').prototype['catch'];
  if (NativePromisePrototype$1['catch'] !== method$1) {
    defineBuiltIn$4(NativePromisePrototype$1, 'catch', method$1, { unsafe: true });
  }
}

var es_promise_race = {};

'use strict';
var $$k = _export;
var call$7 = functionCall;
var aCallable$3 = aCallable$a;
var newPromiseCapabilityModule$2 = newPromiseCapability$2;
var perform$1 = perform$4;
var iterate$2 = iterate$4;
var PROMISE_STATICS_INCORRECT_ITERATION$1 = promiseStaticsIncorrectIteration;

// `Promise.race` method
// https://tc39.es/ecma262/#sec-promise.race
$$k({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION$1 }, {
  race: function race(iterable) {
    var C = this;
    var capability = newPromiseCapabilityModule$2.f(C);
    var reject = capability.reject;
    var result = perform$1(function () {
      var $promiseResolve = aCallable$3(C.resolve);
      iterate$2(iterable, function (promise) {
        call$7($promiseResolve, C, promise).then(capability.resolve, reject);
      });
    });
    if (result.error) reject(result.value);
    return capability.promise;
  }
});

var es_promise_reject = {};

'use strict';
var $$j = _export;
var call$6 = functionCall;
var newPromiseCapabilityModule$1 = newPromiseCapability$2;
var FORCED_PROMISE_CONSTRUCTOR$1 = promiseConstructorDetection.CONSTRUCTOR;

// `Promise.reject` method
// https://tc39.es/ecma262/#sec-promise.reject
$$j({ target: 'Promise', stat: true, forced: FORCED_PROMISE_CONSTRUCTOR$1 }, {
  reject: function reject(r) {
    var capability = newPromiseCapabilityModule$1.f(this);
    call$6(capability.reject, undefined, r);
    return capability.promise;
  }
});

var es_promise_resolve = {};

var anObject$2 = anObject$a;
var isObject$2 = isObject$5;
var newPromiseCapability = newPromiseCapability$2;

var promiseResolve$2 = function (C, x) {
  anObject$2(C);
  if (isObject$2(x) && x.constructor === C) return x;
  var promiseCapability = newPromiseCapability.f(C);
  var resolve = promiseCapability.resolve;
  resolve(x);
  return promiseCapability.promise;
};

'use strict';
var $$i = _export;
var getBuiltIn$1 = getBuiltIn$5;
var IS_PURE$5 = isPure;
var NativePromiseConstructor$1 = promiseNativeConstructor;
var FORCED_PROMISE_CONSTRUCTOR = promiseConstructorDetection.CONSTRUCTOR;
var promiseResolve$1 = promiseResolve$2;

var PromiseConstructorWrapper = getBuiltIn$1('Promise');
var CHECK_WRAPPER = IS_PURE$5 && !FORCED_PROMISE_CONSTRUCTOR;

// `Promise.resolve` method
// https://tc39.es/ecma262/#sec-promise.resolve
$$i({ target: 'Promise', stat: true, forced: IS_PURE$5 || FORCED_PROMISE_CONSTRUCTOR }, {
  resolve: function resolve(x) {
    return promiseResolve$1(CHECK_WRAPPER && this === PromiseConstructorWrapper ? NativePromiseConstructor$1 : this, x);
  }
});

var web_domCollections_iterator = {};

// iterable DOM collections
// flag - `iterable` interface - 'entries', 'keys', 'values', 'forEach' methods
var domIterables = {
  CSSRuleList: 0,
  CSSStyleDeclaration: 0,
  CSSValueList: 0,
  ClientRectList: 0,
  DOMRectList: 0,
  DOMStringList: 0,
  DOMTokenList: 1,
  DataTransferItemList: 0,
  FileList: 0,
  HTMLAllCollection: 0,
  HTMLCollection: 0,
  HTMLFormElement: 0,
  HTMLSelectElement: 0,
  MediaList: 0,
  MimeTypeArray: 0,
  NamedNodeMap: 0,
  NodeList: 1,
  PaintRequestList: 0,
  Plugin: 0,
  PluginArray: 0,
  SVGLengthList: 0,
  SVGNumberList: 0,
  SVGPathSegList: 0,
  SVGPointList: 0,
  SVGStringList: 0,
  SVGTransformList: 0,
  SourceBufferList: 0,
  StyleSheetList: 0,
  TextTrackCueList: 0,
  TextTrackList: 0,
  TouchList: 0
};

// in old WebKit versions, `element.classList` is not an instance of global `DOMTokenList`
var documentCreateElement = documentCreateElement$1;

var classList = documentCreateElement('span').classList;
var DOMTokenListPrototype$1 = classList && classList.constructor && classList.constructor.prototype;

var domTokenListPrototype = DOMTokenListPrototype$1 === Object.prototype ? undefined : DOMTokenListPrototype$1;

var global$6 = global$c;
var DOMIterables = domIterables;
var DOMTokenListPrototype = domTokenListPrototype;
var ArrayIteratorMethods = es_array_iterator;
var createNonEnumerableProperty$1 = createNonEnumerableProperty$3;
var wellKnownSymbol$4 = wellKnownSymbol$f;

var ITERATOR$2 = wellKnownSymbol$4('iterator');
var TO_STRING_TAG = wellKnownSymbol$4('toStringTag');
var ArrayValues = ArrayIteratorMethods.values;

var handlePrototype = function (CollectionPrototype, COLLECTION_NAME) {
  if (CollectionPrototype) {
    // some Chrome versions have non-configurable methods on DOMTokenList
    if (CollectionPrototype[ITERATOR$2] !== ArrayValues) try {
      createNonEnumerableProperty$1(CollectionPrototype, ITERATOR$2, ArrayValues);
    } catch (error) {
      CollectionPrototype[ITERATOR$2] = ArrayValues;
    }
    if (!CollectionPrototype[TO_STRING_TAG]) {
      createNonEnumerableProperty$1(CollectionPrototype, TO_STRING_TAG, COLLECTION_NAME);
    }
    if (DOMIterables[COLLECTION_NAME]) for (var METHOD_NAME in ArrayIteratorMethods) {
      // some Chrome versions have non-configurable methods on DOMTokenList
      if (CollectionPrototype[METHOD_NAME] !== ArrayIteratorMethods[METHOD_NAME]) try {
        createNonEnumerableProperty$1(CollectionPrototype, METHOD_NAME, ArrayIteratorMethods[METHOD_NAME]);
      } catch (error) {
        CollectionPrototype[METHOD_NAME] = ArrayIteratorMethods[METHOD_NAME];
      }
    }
  }
};

for (var COLLECTION_NAME in DOMIterables) {
  handlePrototype(global$6[COLLECTION_NAME] && global$6[COLLECTION_NAME].prototype, COLLECTION_NAME);
}

handlePrototype(DOMTokenListPrototype, 'DOMTokenList');

var es_string_trim = {};

var PROPER_FUNCTION_NAME = functionName.PROPER;
var fails$7 = fails$e;
var whitespaces = whitespaces$1;

var non = '\u200B\u0085\u180E';

// check that a method works with the correct list
// of whitespaces and has a correct name
var stringTrimForced = function (METHOD_NAME) {
  return fails$7(function () {
    return !!whitespaces[METHOD_NAME]()
      || non[METHOD_NAME]() !== non
      || (PROPER_FUNCTION_NAME && whitespaces[METHOD_NAME].name !== METHOD_NAME);
  });
};

'use strict';
var $$h = _export;
var $trim = stringTrim.trim;
var forcedStringTrimMethod$1 = stringTrimForced;

// `String.prototype.trim` method
// https://tc39.es/ecma262/#sec-string.prototype.trim
$$h({ target: 'String', proto: true, forced: forcedStringTrimMethod$1('trim') }, {
  trim: function trim() {
    return $trim(this);
  }
});

//export var app = window.app;
var egw$1 = window.egw;
var framework$1 = window.framework;
var app$1 = window.app;
var egw_getFramework$1 = window.egw_getFramework;
var jQuery$1 = window.jQuery;

var es_symbol_description = {};

// `Symbol.prototype.description` getter
// https://tc39.es/ecma262/#sec-symbol.prototype.description
'use strict';
var $$g = _export;
var DESCRIPTORS$5 = descriptors;
var global$5 = global$c;
var uncurryThis$8 = functionUncurryThis;
var hasOwn$2 = hasOwnProperty_1;
var isCallable$4 = isCallable$f;
var isPrototypeOf$1 = objectIsPrototypeOf;
var toString$7 = toString$a;
var defineBuiltInAccessor$2 = defineBuiltInAccessor$4;
var copyConstructorProperties = copyConstructorProperties$1;

var NativeSymbol = global$5.Symbol;
var SymbolPrototype = NativeSymbol && NativeSymbol.prototype;

if (DESCRIPTORS$5 && isCallable$4(NativeSymbol) && (!('description' in SymbolPrototype) ||
  // Safari 12 bug
  NativeSymbol().description !== undefined
)) {
  var EmptyStringDescriptionStore = {};
  // wrap Symbol constructor for correct work with undefined description
  var SymbolWrapper = function Symbol() {
    var description = arguments.length < 1 || arguments[0] === undefined ? undefined : toString$7(arguments[0]);
    var result = isPrototypeOf$1(SymbolPrototype, this)
      ? new NativeSymbol(description)
      // in Edge 13, String(Symbol(undefined)) === 'Symbol(undefined)'
      : description === undefined ? NativeSymbol() : NativeSymbol(description);
    if (description === '') EmptyStringDescriptionStore[result] = true;
    return result;
  };

  copyConstructorProperties(SymbolWrapper, NativeSymbol);
  SymbolWrapper.prototype = SymbolPrototype;
  SymbolPrototype.constructor = SymbolWrapper;

  var NATIVE_SYMBOL = String(NativeSymbol('test')) == 'Symbol(test)';
  var thisSymbolValue = uncurryThis$8(SymbolPrototype.valueOf);
  var symbolDescriptiveString = uncurryThis$8(SymbolPrototype.toString);
  var regexp = /^Symbol\((.*)\)[^)]+$/;
  var replace$3 = uncurryThis$8(''.replace);
  var stringSlice$4 = uncurryThis$8(''.slice);

  defineBuiltInAccessor$2(SymbolPrototype, 'description', {
    configurable: true,
    get: function description() {
      var symbol = thisSymbolValue(this);
      if (hasOwn$2(EmptyStringDescriptionStore, symbol)) return '';
      var string = symbolDescriptiveString(symbol);
      var desc = NATIVE_SYMBOL ? stringSlice$4(string, 7, -1) : replace$3(string, regexp, '$1');
      return desc === '' ? undefined : desc;
    }
  });

  $$g({ global: true, constructor: true, forced: true }, {
    Symbol: SymbolWrapper
  });
}

var es_regexp_constructor = {};

var isCallable$3 = isCallable$f;
var isObject$1 = isObject$5;
var setPrototypeOf = objectSetPrototypeOf;

// makes subclassing work correct for wrapped built-ins
var inheritIfRequired$1 = function ($this, dummy, Wrapper) {
  var NewTarget, NewTargetPrototype;
  if (
    // it can work only with native `setPrototypeOf`
    setPrototypeOf &&
    // we haven't completely correct pre-ES6 way for getting `new.target`, so use this
    isCallable$3(NewTarget = dummy.constructor) &&
    NewTarget !== Wrapper &&
    isObject$1(NewTargetPrototype = NewTarget.prototype) &&
    NewTargetPrototype !== Wrapper.prototype
  ) setPrototypeOf($this, NewTargetPrototype);
  return $this;
};

var defineProperty$1 = objectDefineProperty.f;

var proxyAccessor$1 = function (Target, Source, key) {
  key in Target || defineProperty$1(Target, key, {
    configurable: true,
    get: function () { return Source[key]; },
    set: function (it) { Source[key] = it; }
  });
};

var DESCRIPTORS$4 = descriptors;
var global$4 = global$c;
var uncurryThis$7 = functionUncurryThis;
var isForced = isForced_1;
var inheritIfRequired = inheritIfRequired$1;
var createNonEnumerableProperty = createNonEnumerableProperty$3;
var getOwnPropertyNames = objectGetOwnPropertyNames.f;
var isPrototypeOf = objectIsPrototypeOf;
var isRegExp$1 = isRegexp;
var toString$6 = toString$a;
var getRegExpFlags$1 = regexpGetFlags;
var stickyHelpers = regexpStickyHelpers;
var proxyAccessor = proxyAccessor$1;
var defineBuiltIn$3 = defineBuiltIn$8;
var fails$6 = fails$e;
var hasOwn$1 = hasOwnProperty_1;
var enforceInternalState = internalState.enforce;
var setSpecies = setSpecies$2;
var wellKnownSymbol$3 = wellKnownSymbol$f;
var UNSUPPORTED_DOT_ALL = regexpUnsupportedDotAll;
var UNSUPPORTED_NCG = regexpUnsupportedNcg;

var MATCH = wellKnownSymbol$3('match');
var NativeRegExp = global$4.RegExp;
var RegExpPrototype$1 = NativeRegExp.prototype;
var SyntaxError = global$4.SyntaxError;
var exec = uncurryThis$7(RegExpPrototype$1.exec);
var charAt$1 = uncurryThis$7(''.charAt);
var replace$2 = uncurryThis$7(''.replace);
var stringIndexOf$1 = uncurryThis$7(''.indexOf);
var stringSlice$3 = uncurryThis$7(''.slice);
// TODO: Use only proper RegExpIdentifierName
var IS_NCG = /^\?<[^\s\d!#%&*+<=>@^][^\s!#%&*+<=>@^]*>/;
var re1 = /a/g;
var re2 = /a/g;

// "new" should create a new object, old webkit bug
var CORRECT_NEW = new NativeRegExp(re1) !== re1;

var MISSED_STICKY = stickyHelpers.MISSED_STICKY;
var UNSUPPORTED_Y = stickyHelpers.UNSUPPORTED_Y;

var BASE_FORCED = DESCRIPTORS$4 &&
  (!CORRECT_NEW || MISSED_STICKY || UNSUPPORTED_DOT_ALL || UNSUPPORTED_NCG || fails$6(function () {
    re2[MATCH] = false;
    // RegExp constructor can alter flags and IsRegExp works correct with @@match
    return NativeRegExp(re1) != re1 || NativeRegExp(re2) == re2 || NativeRegExp(re1, 'i') != '/a/i';
  }));

var handleDotAll = function (string) {
  var length = string.length;
  var index = 0;
  var result = '';
  var brackets = false;
  var chr;
  for (; index <= length; index++) {
    chr = charAt$1(string, index);
    if (chr === '\\') {
      result += chr + charAt$1(string, ++index);
      continue;
    }
    if (!brackets && chr === '.') {
      result += '[\\s\\S]';
    } else {
      if (chr === '[') {
        brackets = true;
      } else if (chr === ']') {
        brackets = false;
      } result += chr;
    }
  } return result;
};

var handleNCG = function (string) {
  var length = string.length;
  var index = 0;
  var result = '';
  var named = [];
  var names = {};
  var brackets = false;
  var ncg = false;
  var groupid = 0;
  var groupname = '';
  var chr;
  for (; index <= length; index++) {
    chr = charAt$1(string, index);
    if (chr === '\\') {
      chr = chr + charAt$1(string, ++index);
    } else if (chr === ']') {
      brackets = false;
    } else if (!brackets) switch (true) {
      case chr === '[':
        brackets = true;
        break;
      case chr === '(':
        if (exec(IS_NCG, stringSlice$3(string, index + 1))) {
          index += 2;
          ncg = true;
        }
        result += chr;
        groupid++;
        continue;
      case chr === '>' && ncg:
        if (groupname === '' || hasOwn$1(names, groupname)) {
          throw new SyntaxError('Invalid capture group name');
        }
        names[groupname] = true;
        named[named.length] = [groupname, groupid];
        ncg = false;
        groupname = '';
        continue;
    }
    if (ncg) groupname += chr;
    else result += chr;
  } return [result, named];
};

// `RegExp` constructor
// https://tc39.es/ecma262/#sec-regexp-constructor
if (isForced('RegExp', BASE_FORCED)) {
  var RegExpWrapper = function RegExp(pattern, flags) {
    var thisIsRegExp = isPrototypeOf(RegExpPrototype$1, this);
    var patternIsRegExp = isRegExp$1(pattern);
    var flagsAreUndefined = flags === undefined;
    var groups = [];
    var rawPattern = pattern;
    var rawFlags, dotAll, sticky, handled, result, state;

    if (!thisIsRegExp && patternIsRegExp && flagsAreUndefined && pattern.constructor === RegExpWrapper) {
      return pattern;
    }

    if (patternIsRegExp || isPrototypeOf(RegExpPrototype$1, pattern)) {
      pattern = pattern.source;
      if (flagsAreUndefined) flags = getRegExpFlags$1(rawPattern);
    }

    pattern = pattern === undefined ? '' : toString$6(pattern);
    flags = flags === undefined ? '' : toString$6(flags);
    rawPattern = pattern;

    if (UNSUPPORTED_DOT_ALL && 'dotAll' in re1) {
      dotAll = !!flags && stringIndexOf$1(flags, 's') > -1;
      if (dotAll) flags = replace$2(flags, /s/g, '');
    }

    rawFlags = flags;

    if (MISSED_STICKY && 'sticky' in re1) {
      sticky = !!flags && stringIndexOf$1(flags, 'y') > -1;
      if (sticky && UNSUPPORTED_Y) flags = replace$2(flags, /y/g, '');
    }

    if (UNSUPPORTED_NCG) {
      handled = handleNCG(pattern);
      pattern = handled[0];
      groups = handled[1];
    }

    result = inheritIfRequired(NativeRegExp(pattern, flags), thisIsRegExp ? this : RegExpPrototype$1, RegExpWrapper);

    if (dotAll || sticky || groups.length) {
      state = enforceInternalState(result);
      if (dotAll) {
        state.dotAll = true;
        state.raw = RegExpWrapper(handleDotAll(pattern), rawFlags);
      }
      if (sticky) state.sticky = true;
      if (groups.length) state.groups = groups;
    }

    if (pattern !== rawPattern) try {
      // fails in old engines, but we have no alternatives for unsupported regex syntax
      createNonEnumerableProperty(result, 'source', rawPattern === '' ? '(?:)' : rawPattern);
    } catch (error) { /* empty */ }

    return result;
  };

  for (var keys = getOwnPropertyNames(NativeRegExp), index$1 = 0; keys.length > index$1;) {
    proxyAccessor(RegExpWrapper, NativeRegExp, keys[index$1++]);
  }

  RegExpPrototype$1.constructor = RegExpWrapper;
  RegExpWrapper.prototype = RegExpPrototype$1;
  defineBuiltIn$3(global$4, 'RegExp', RegExpWrapper, { constructor: true });
}

// https://tc39.es/ecma262/#sec-get-regexp-@@species
setSpecies('RegExp');

/**
 * IE Fix for array.indexOf
 */
if (typeof Array.prototype.indexOf == "undefined") {
  Array.prototype.indexOf = function (_elem) {
    for (var i = 0; i < this.length; i++) {
      if (this[i] === _elem) return i;
    }
    return -1;
  };
}

/**
 * Array with all types supported by the et2_checkType function.
 */
var et2_validTypes = ["boolean", "string", "rawstring", "html", "float", "integer", "any", "js", "dimension"];

/**
 * Object whith default values for the above types. Do not specify array or
 * objects inside the et2_typeDefaults object, as this instance will be shared
 * between all users of it.
 */
var et2_typeDefaults = {
  "boolean": false,
  "string": "",
  "rawstring": "",
  // no html-entity decoding
  "html": "",
  "js": null,
  "float": 0.0,
  "integer": 0,
  "any": null,
  "dimension": "auto"
};
function et2_evalBool(_val) {
  if (typeof _val == "string") {
    if (_val == "false" || _val == "0") {
      return false;
    }
  }
  return _val ? true : false;
}

/**
 * Concat et2 name together, eg. et2_concat("namespace","test[something]") == "namespace[test][something]"
 * @param variable number of arguments to contact
 * @returns string
 */
function et2_form_name(_cname, _name) {
  var parts = [];
  for (var i = 0; i < arguments.length; ++i) {
    var name = arguments[i];
    if (typeof name == 'string' && name.length > 0)
      // et2_namespace("","test") === "test" === et2_namespace(null,"test")
      {
        parts = parts.concat(name.replace(/]/g, '').split('['));
      }
  }
  var name = parts.shift();
  return parts.length ? name + '[' + parts.join('][') + ']' : name;
}

/**
 * Checks whether the given value is of the given type. Strings are converted
 * into the corresponding type. The (converted) value is returned. All supported
 * types are listed in the et2_validTypes array.
 *
 * @param mixed _val value
 * @param string _type a valid type eg. "string" or "js"
 * @param string _attr attribute name
 * @param object _widget
 */
function et2_checkType(_val, _type, _attr, _widget) {
  if (typeof _attr == "undefined") {
    _attr = null;
  }
  function _err() {
    var res = et2_typeDefaults[_type];
    if (typeof _val != "undefined" && _val) {
      egw$1.debug("warn", "Widget %o: '" + _val + "' was not of specified _type '" + _type + (_attr != null ? "' for attribute '" + _attr + "' " : "") + "and is now '" + res + "'", _widget);
    }
    return res;
  }

  // If the type is "any" simply return the value again
  if (_type == "any") {
    return _val;
  }

  // we dont check default-value any further, that also fixes type="js" does NOT accept null,
  // which happens on expanded values
  if (_val === et2_typeDefaults[_type]) {
    return _val;
  }

  // If the type is boolean, check whether the given value is exactly true or
  // false. Otherwise check whether the value is the string "true" or "false".
  if (_type == "boolean") {
    if (_val === true || _val === false) {
      return _val;
    }
    if (typeof _val == "string") {
      var lcv = _val.toLowerCase();
      if (lcv === "true" || lcv === "false" || lcv === "") {
        return _val === "true";
      }
      if (lcv === "0" || lcv === "1") {
        return _val === "1";
      }
    } else if (typeof _val == "number") {
      return _val != 0;
    }
    return _err();
  }

  // Check whether the given value is of the type "string"
  if (_type == "string" || _type == "html" || _type == "rawstring") {
    if (typeof _val == "number")
      // as php is a bit vague here, silently convert to a string
      {
        return _val.toString();
      }
    if (typeof _val == "string") {
      return _type == "string" ? html_entity_decode(_val) : _val;
    }

    // Handle some less common possibilities
    // Maybe a split on an empty string
    if (typeof _val == "object" && jQuery.isEmptyObject(_val)) return "";
    return _err();
  }

  // Check whether the value is already a number, otherwise try to convert it
  // to one.
  if (_type == "float") {
    if (typeof _val == "number") {
      return _val;
    }
    if (!isNaN(_val)) {
      return parseFloat(_val);
    }
    return _err();
  }

  // Check whether the value is an integer by comparing the result of
  // parseInt(_val) to the value itself.
  if (_type == "integer") {
    if (parseInt(_val) == _val) {
      return parseInt(_val);
    }
    return _err();
  }

  // Parse the given dimension value
  if (_type == "dimension") {
    // Case 1: The value is "auto"
    if (_val == "auto") {
      return _val;
    }

    // Case 2: The value is simply a number, attach "px"
    if (!isNaN(_val)) {
      return parseFloat(_val) + "px";
    }

    // Case 3: The value is already a valid css pixel value or a percentage
    if (typeof _val == "string" && (_val.indexOf("px") == _val.length - 2 && !isNaN(_val.split("px")[0]) || _val.indexOf("%") == _val.length - 1 && !isNaN(_val.split("%")[0]))) {
      return _val;
    }
    return _err();
  }

  // Javascript
  if (_type == "js") {
    if (typeof _val == "function" || typeof _val == "undefined") {
      return _val;
    }
    if (_val) _val = _val.replace(/window\.close\(\)/g, 'egw(window).close()');

    // Check to see if it's a string in app.appname.function format, and wrap it in
    // a closure to make sure context is preserved
    if (typeof _val == "string" && _val.substr(0, 4) == "app." && app) {
      var parts = _val.split('.');
      var func = parts.pop();
      var parent = window;
      for (var i = 0; i < parts.length && typeof parent[parts[i]] != 'undefined'; ++i) {
        parent = parent[parts[i]];
      }
      if (typeof parent[func] == 'function') {
        try {
          return jQuery.proxy(parent[func], parent);
        } catch (e) {
          egw$1.debug('error', 'Function', _val);
          return _err();
        }
      }
    }
    if (!_val || typeof _val == "string") {
      return _val; // get compiled later in widgets own initAttributes, as widget is not yet initialised
    }
  }

  // We should never come here
  throw "Invalid type identifier '" + _attr + "': '" + _type + "'";
}

/**
 * If et2_no_init is set as default value, the initAttributes function will not
 * try to initialize the attribute with the default value.
 */
var et2_no_init = new Object();

/**
 * Validates the given attribute with the given id. The validation checks for
 * the existance of a human name, a description, a type and a default value.
 * If the human name defaults to the given id, the description defaults to an
 * empty string, the type defaults to any and the default to the corresponding
 * type default.
 */
function et2_validateAttrib(_id, _attrib) {
  // Default ignore to false.
  if (typeof _attrib["ignore"] == "undefined") {
    _attrib["ignore"] = false;
  }

  // Break if "ignore" is set to true.
  if (_attrib.ignore) {
    return;
  }
  if (typeof _attrib["name"] == "undefined") {
    _attrib["name"] = _id;
    egw$1.debug("log", "Human name ('name'-Field) for attribute '" + _id + "' has not been supplied, set to '" + _id + "'");
  }
  if (typeof _attrib["description"] == "undefined") {
    _attrib["description"] = "";
    egw$1.debug("log", "Description for attribute '" + _id + "' has not been supplied");
  }
  if (typeof _attrib["type"] == "undefined") {
    _attrib["type"] = "any";
  } else {
    if (et2_validTypes.indexOf(_attrib["type"]) < 0) {
      egw$1.debug("error", "Invalid type '" + _attrib["type"] + "' for attribute '" + _id + "' supplied.  Valid types are ", et2_validTypes);
    }
  }

  // Set the defaults
  if (typeof _attrib["default"] == "undefined") {
    _attrib["default"] = et2_typeDefaults[_attrib["type"]];
  }
}

/**
 * Equivalent to the PHP array_values function
 */
function et2_arrayValues(_arr) {
  var result = [];
  for (var key in _arr) {
    // @ts-ignore we check key is an integer
    if (parseInt(key) == key) {
      result.push(_arr[key]);
    }
  }
  return result;
}

/**
 * Equivalent to the PHP array_keys function
 */
function et2_arrayKeys(_arr) {
  var result = [];
  for (var key in _arr) {
    result.push(key);
  }
  return result;
}
function et2_arrayIntKeys(_arr) {
  var result = [];
  for (var key in _arr) {
    result.push(parseInt(key));
  }
  return result;
}

/**
 * Equivalent to the PHP substr function, partly take from phpjs, licensed under
 * the GPL.
 */
function et2_substr(str, start, len) {
  var end = str.length;
  if (start < 0) {
    start += end;
  }
  end = typeof len === 'undefined' ? end : len < 0 ? len + end : len + start;
  return start >= str.length || start < 0 || start > end ? "" : str.slice(start, end);
}

/**
 * Split a $delimiter-separated options string, which can contain parts with
 * delimiters enclosed in $enclosure. Ported from class.boetemplate.inc.php
 *
 * Examples:
 * - et2_csvSplit('"1,2,3",2,3') === array('1,2,3','2','3')
 * - et2_csvSplit('1,2,3',2) === array('1','2,3')
 * - et2_csvSplit('"1,2,3",2,3',2) === array('1,2,3','2,3')
 * - et2_csvSplit('"a""b,c",d') === array('a"b,c','d')	// to escape enclosures double them!
 *
 * @param string _str
 * @param int _num=null in how many parts to split maximal, parts over this
 * 	number end up (unseparated) in the last part
 * @param string _delimiter=','
 * @param string _enclosure='"'
 * @return array
 */
function et2_csvSplit(_str, _num, _delimiter, _enclosure) {
  // Default the parameters
  if (typeof _str == "undefined" || _str == null) {
    _str = "";
  }
  if (typeof _num == "undefined") {
    _num = null;
  }
  if (typeof _delimiter == "undefined") {
    _delimiter = ",";
  }
  if (typeof _enclosure == "undefined") {
    _enclosure = '"';
  }

  // If the _enclosure string does not occur in the string, simply use the
  // split function
  if (_str.indexOf(_enclosure) == -1) {
    return _num === null ? _str.split(_delimiter) : _str.split(_delimiter, _num);
  }

  // Split the string at the delimiter and join it again, when a enclosure is
  // found at the beginning/end of a part
  var parts = _str.split(_delimiter);
  for (var n = 0; typeof parts[n] != "undefined"; n++) {
    var part = parts[n];
    if (part.charAt(0) === _enclosure) {
      var m = n;
      while (typeof parts[m + 1] != "undefined" && parts[n].substr(-1) !== _enclosure) {
        parts[n] += _delimiter + parts[++m];
        delete parts[m];
      }
      parts[n] = et2_substr(parts[n].replace(new RegExp(_enclosure + _enclosure, 'g'), _enclosure), 1, -1);
      n = m;
    }
  }

  // Rebuild the array index
  parts = et2_arrayValues(parts);

  // Limit the parts to the given number
  if (_num !== null && _num > 0 && _num < parts.length && parts.length > 0) {
    parts[_num - 1] = parts.slice(_num - 1, parts.length).join(_delimiter);
    parts = parts.slice(0, _num);
  }
  return parts;
}

/**
 * Parses the given string and returns an array marking parts which are URLs
 */
function et2_activateLinks(_content) {
  var _match = false;
  var arr = [];
  function _splitPush(_matches, _proc) {
    if (_matches) {
      // We had a match
      _match = true;

      // Replace "undefined" with ""
      for (var i = 1; i < _matches.length; i++) {
        if (typeof _matches[i] == "undefined") {
          _matches[i] = "";
        }
      }

      // Split the content string at the given position(s)
      // but we only handle the first occurence
      var splitted = _content.split(_matches[0]);

      // Push the not-matched part
      var left = splitted.shift();
      if (left) {
        // activate the links of the left string
        arr = arr.concat(et2_activateLinks(left));
      }

      // Call the callback function which converts the matches into an object
      // and appends it to the string
      _proc(_matches);

      // Set the new working string to the right part
      _content = splitted.join(_matches[0]);
    }
  }
  var mail_regExp = /(mailto:)?([a-z0-9._-]+)@([a-z0-9_-]+)\.([a-z0-9._-]+)/i;

  //  First match things beginning with http:// (or other protocols)
  var protocol = '(http:\\/\\/|(ftp:\\/\\/|https:\\/\\/))'; // only http:// gets removed, other protocolls are shown
  var domain = '([\\w-]+\\.[\\w-.]+)';
  var subdir = '([\\w\\-\\.,@?^=%&;:\\/~\\+#]*[\\w\\-\\@?^=%&\\/~\\+#])?';
  var http_regExp = new RegExp(protocol + domain + subdir, 'i');

  //  Now match things beginning with www.
  var domain = 'www(\\.[\\w-.]+)';
  var subdir = '([\\w\\-\\.,@?^=%&:\\/~\\+#]*[\\w\\-\\@?^=%&\\/~\\+#])?';
  var www_regExp = new RegExp(domain + subdir, 'i');
  do {
    _match = false;

    // Abort if the remaining length of _content is smaller than 20 for
    // performance reasons
    if (!_content) {
      break;
    }

    // No need make emailaddress spam-save, as it gets dynamically created
    _splitPush(_content.match(mail_regExp), function (_matches) {
      arr.push({
        "href": (_matches[1] ? '' : 'mailto:') + _matches[0],
        "text": _matches[2] + "@" + _matches[3] + "." + _matches[4]
      });
    });

    // Create hrefs for links starting with "http://"
    _splitPush(_content.match(http_regExp), function (_matches) {
      arr.push({
        "href": _matches[0],
        "text": _matches[2] + _matches[3] + _matches[4]
      });
    });

    // Create hrefs for links starting with "www."
    _splitPush(_content.match(www_regExp), function (_matches) {
      arr.push({
        "href": "http://" + _matches[0],
        "text": _matches[0]
      });
    });
  } while (_match);
  arr.push(_content);
  return arr;
}

/**
 * Inserts the structure generated by et2_activateLinks into the given DOM-Node
 */
function et2_insertLinkText(_text, _node, _target) {
  if (!_node) {
    egw$1.debug("warn", "et2_insertLinkText called without node", _text, _node, _target);
    return;
  }

  // Clear the node
  for (var i = _node.childNodes.length - 1; i >= 0; i--) {
    _node.removeChild(_node.childNodes[i]);
  }
  for (var i = 0; i < _text.length; i++) {
    var _s;
    var s = _text[i];
    if (typeof s == "string" || typeof s == "number") {
      // Include line breaks
      var lines = typeof s !== "number" && s.split ? s.split('\n') : [s + ""];

      // Insert the lines
      for (var j = 0; j < lines.length; j++) {
        _node.appendChild(document.createTextNode(lines[j]));
        if (j < lines.length - 1) {
          _node.appendChild(document.createElement("br"));
        }
      }
    } else if ((_s = s) !== null && _s !== void 0 && _s.text)
      // no need to generate a link, if there is no content in it
      {
        if (!s.href) {
          egw$1.debug("warn", "et2_activateLinks gave bad data", s, _node, _target);
          s.href = "";
        }
        var a = jQuery(document.createElement("a")).attr("href", s.href).text(s.text);
        if (typeof _target != "undefined" && _target && _target != "_self" && s.href.substr(0, 7) != "mailto:") {
          a.attr("target", _target);
        }
        // open mailto links depending on preferences in mail app
        if (s.href.substr(0, 7) == "mailto:" && (egw$1.user('apps').mail || egw$1.user('apps').felamimail) && egw$1.preference('force_mailto', 'addressbook') != '1') {
          a.click(function (event) {
            egw$1.open_link(this.href);
            return false;
          });
        }
        a.appendTo(_node);
      }
  }
}

/**
 * Creates a copy of the given object (non recursive)
 */
function et2_cloneObject(_obj) {
  var result = {};
  for (var key in _obj) {
    result[key] = _obj[key];
  }
  return result;
}

/**
 * Returns true if the given array of nodes or their children contains the given
 * child node.
 */
function et2_hasChild(_nodes, _child) {
  for (var i = 0; i < _nodes.length; i++) {
    if (_nodes[i] == _child) {
      return true;
    } else if (_nodes[i].childNodes) {
      var res = et2_hasChild(_nodes[i].childNodes, _child);
      if (res) {
        return true;
      }
    }
  }
  return false;
}

/**
 * Functions to work with ranges and range intersection (used in the dataview)
 */

/**
 * Common functions used in most view classes
 */

/**
 * Returns an "range" object with the given top position and height
 */
function et2_range(_top, _height) {
  return {
    "top": _top,
    "bottom": _top + _height
  };
}

/**
 * Returns an "area" object with the given top- and bottom position
 */
function et2_bounds(_top, _bottom) {
  return {
    "top": _top,
    "bottom": _bottom
  };
}

/**
 * Returns whether two range objects intersect each other
 */
function et2_rangeIntersect(_ar1, _ar2) {
  return !(_ar1.bottom < _ar2.top || _ar1.top > _ar2.bottom);
}

/**
 * Returns whether two ranges intersect (result = 0) or their relative position
 * to each other (used to do a binary search inside a list of sorted range objects).
 */
function et2_rangeIntersectDir(_ar1, _ar2) {
  if (_ar1.bottom < _ar2.top) {
    return -1;
  }
  if (_ar1.top > _ar2.bottom) {
    return 1;
  }
  return 0;
}

/**
 * Returns whether two ranges are equal.
 */
function et2_rangeEqual(_ar1, _ar2) {
  return _ar1.top === _ar2.top && _ar1.bottom === _ar2.bottom;
}

/**
 * Substracts _ar2 from _ar1, returns an array of new ranges.
 */
function et2_rangeSubstract(_ar1, _ar2) {
  // Per default return the complete _ar1 range
  var res = [_ar1];

  // Check whether there is an intersection between the given ranges
  if (et2_rangeIntersect(_ar1, _ar2)) {
    res = [et2_bounds(_ar1.top, _ar2.top), et2_bounds(_ar2.bottom, _ar1.bottom)];
  }

  // Remove all zero-length ranges from the result
  for (var i = res.length - 1; i >= 0; i--) {
    if (res[i].bottom - res[i].top <= 0) {
      res.splice(i, 1);
    }
  }
  return res;
}

/**
 * Decode html entities so they can be added via .text(_str), eg. html_entity_decode('&amp;') === '&'
 *
 * @param {string} _str
 * @returns {string}
 */
function html_entity_decode(_str) {
  return _str && _str.indexOf('&') != -1 ? jQuery('<span>' + _str + '</span>').text() : _str;
}

var es_object_assign = {};

'use strict';
var DESCRIPTORS$3 = descriptors;
var uncurryThis$6 = functionUncurryThis;
var call$5 = functionCall;
var fails$5 = fails$e;
var objectKeys = objectKeys$1;
var getOwnPropertySymbolsModule = objectGetOwnPropertySymbols;
var propertyIsEnumerableModule = objectPropertyIsEnumerable;
var toObject$2 = toObject$5;
var IndexedObject$1 = indexedObject;

// eslint-disable-next-line es/no-object-assign -- safe
var $assign = Object.assign;
// eslint-disable-next-line es/no-object-defineproperty -- required for testing
var defineProperty = Object.defineProperty;
var concat = uncurryThis$6([].concat);

// `Object.assign` method
// https://tc39.es/ecma262/#sec-object.assign
var objectAssign = !$assign || fails$5(function () {
  // should have correct order of operations (Edge bug)
  if (DESCRIPTORS$3 && $assign({ b: 1 }, $assign(defineProperty({}, 'a', {
    enumerable: true,
    get: function () {
      defineProperty(this, 'b', {
        value: 3,
        enumerable: false
      });
    }
  }), { b: 2 })).b !== 1) return true;
  // should work with symbols and should have deterministic property order (V8 bug)
  var A = {};
  var B = {};
  // eslint-disable-next-line es/no-symbol -- safe
  var symbol = Symbol();
  var alphabet = 'abcdefghijklmnopqrst';
  A[symbol] = 7;
  alphabet.split('').forEach(function (chr) { B[chr] = chr; });
  return $assign({}, A)[symbol] != 7 || objectKeys($assign({}, B)).join('') != alphabet;
}) ? function assign(target, source) { // eslint-disable-line no-unused-vars -- required for `.length`
  var T = toObject$2(target);
  var argumentsLength = arguments.length;
  var index = 1;
  var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
  var propertyIsEnumerable = propertyIsEnumerableModule.f;
  while (argumentsLength > index) {
    var S = IndexedObject$1(arguments[index++]);
    var keys = getOwnPropertySymbols ? concat(objectKeys(S), getOwnPropertySymbols(S)) : objectKeys(S);
    var length = keys.length;
    var j = 0;
    var key;
    while (length > j) {
      key = keys[j++];
      if (!DESCRIPTORS$3 || call$5(propertyIsEnumerable, S, key)) T[key] = S[key];
    }
  } return T;
} : $assign;

var $$f = _export;
var assign = objectAssign;

// `Object.assign` method
// https://tc39.es/ecma262/#sec-object.assign
// eslint-disable-next-line es/no-object-assign -- required for testing
$$f({ target: 'Object', stat: true, arity: 2, forced: Object.assign !== assign }, {
  assign: assign
});

var es_string_startsWith = {};

'use strict';
var $$e = _export;
var uncurryThis$5 = functionUncurryThisClause;
var getOwnPropertyDescriptor$2 = objectGetOwnPropertyDescriptor.f;
var toLength$1 = toLength$4;
var toString$5 = toString$a;
var notARegExp$1 = notARegexp;
var requireObjectCoercible$3 = requireObjectCoercible$6;
var correctIsRegExpLogic$1 = correctIsRegexpLogic;
var IS_PURE$4 = isPure;

// eslint-disable-next-line es/no-string-prototype-startswith -- safe
var nativeStartsWith = uncurryThis$5(''.startsWith);
var stringSlice$2 = uncurryThis$5(''.slice);
var min$2 = Math.min;

var CORRECT_IS_REGEXP_LOGIC$1 = correctIsRegExpLogic$1('startsWith');
// https://github.com/zloirock/core-js/pull/702
var MDN_POLYFILL_BUG$1 = !IS_PURE$4 && !CORRECT_IS_REGEXP_LOGIC$1 && !!function () {
  var descriptor = getOwnPropertyDescriptor$2(String.prototype, 'startsWith');
  return descriptor && !descriptor.writable;
}();

// `String.prototype.startsWith` method
// https://tc39.es/ecma262/#sec-string.prototype.startswith
$$e({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG$1 && !CORRECT_IS_REGEXP_LOGIC$1 }, {
  startsWith: function startsWith(searchString /* , position = 0 */) {
    var that = toString$5(requireObjectCoercible$3(this));
    notARegExp$1(searchString);
    var index = toLength$1(min$2(arguments.length > 1 ? arguments[1] : undefined, that.length));
    var search = toString$5(searchString);
    return nativeStartsWith
      ? nativeStartsWith(that, search, index)
      : stringSlice$2(that, index, index + search.length) === search;
  }
});

/**
 * Function which compiles the given PHP string to a JS function which can be
 * easily executed.
 *
 * @param _expr is the PHP string expression
 * @param _vars is an array with variable names (without the PHP $).
 * 	The parameters have to be passed to the resulting JS function in the same
 * 	order.
 */
function et2_compilePHPExpression(_expr, _vars) {
  if (typeof _vars == "undefined") {
    _vars = [];
  }
  try {
    // Initialize the parser object and create the syntax tree for the given
    // expression
    var parser = _php_parser(_expr);
    var syntaxTree = [];

    // Parse the given expression as if it was a double quoted string
    _php_parseDoubleQuoteString(parser, syntaxTree);

    // Transform the generated syntaxTree into a JS string
    var js = _php_compileJSCode(_vars, syntaxTree);

    // Log the successfull compiling
    egw$1.debug("log", "Compiled PHP " + _expr + " --> " + js);
  } catch (e) {
    // if expression does NOT compile use it literally and log a warning, but not stop execution
    egw$1.debug("warn", "Error compiling PHP " + _expr + " --> using it literally (" + (typeof e == 'string' ? e : e.message) + ")!");
    return function () {
      return _expr;
    };
  }
  // Prepate the attributes for the function constuctor
  var attrs = [];
  for (var i = 0; i < _vars.length; i++) {
    attrs.push("_" + _vars[i]);
  }
  attrs.push(js);

  // Create the function and return it
  return Function.apply(Function, attrs);
}
var STATE_DEFAULT = 0;
var STATE_ESCAPED = 1;
var STATE_CURLY_BRACE_OPEN = 2;
var STATE_EXPECT_CURLY_BRACE_CLOSE = 3;
var STATE_EXPECT_RECT_BRACE_CLOSE = 4;
var STATE_EXPR_BEGIN = 5;
var STATE_EXPR_END = 6;
function _throwParserErr(_p, _err) {
  throw "Syntax error while parsing '" + _p.expr + "' at " + _p.pos + ", " + _err;
}
function _php_parseDoubleQuoteString(_p, _tree) {
  // Extract all PHP variables from the string
  var state = STATE_DEFAULT;
  var str = "";
  while (_p.pos < _p.expr.length) {
    // Read the current char and then increment the parser position by
    // one
    var c = _p.expr.charAt(_p.pos++);
    switch (state) {
      case STATE_DEFAULT:
      case STATE_CURLY_BRACE_OPEN:
        switch (c) {
          case '\\':
            state = STATE_ESCAPED;
            break;
          case '$':
            // check for '$$' as used in placeholder syntax, it is NOT expanded and returned as is
            if (_p.expr.charAt(_p.pos) == "$" && state == STATE_DEFAULT) {
              _p.pos++;
              str += '$$';
              break;
            }
            // check for '$' as last char, as in PHP "test$" === 'test$', $ as last char is NOT expanded
            if (_p.pos == _p.expr.length) {
              str += '$';
              break;
            }
            // check for regular expression "/  $/"
            if (_p.expr.charAt(_p.pos) == '/' && _p.expr.charAt(0) == '/') {
              str += '$';
              break;
            }
            if (str) {
              _tree.push(str);
              str = "";
            }

            // Support for the ${[expr] sytax
            if (_p.expr.charAt(_p.pos) == "{" && state != STATE_CURLY_BRACE_OPEN) {
              state = STATE_CURLY_BRACE_OPEN;
              _p.pos++;
            }
            if (state == STATE_CURLY_BRACE_OPEN) {
              _tree.push(_php_parseVariable(_p));
              state = STATE_EXPECT_CURLY_BRACE_CLOSE;
            } else {
              _tree.push(_php_parseVariable(_p));
            }
            break;
          case '{':
            state = STATE_CURLY_BRACE_OPEN;
            break;
          default:
            if (state == STATE_CURLY_BRACE_OPEN) {
              str += '{';
              state = STATE_DEFAULT;
            }
            str += c;
        }
        break;
      case STATE_ESCAPED:
        str += c;
        break;
      case STATE_EXPECT_CURLY_BRACE_CLOSE:
        // When returning from the variableEx parser,
        // the current char must be a "}"
        if (c != "}") {
          _throwParserErr(_p, "expected '}', but got " + c);
        }
        state = STATE_DEFAULT;
        break;
    }
  }

  // Throw an error when reaching the end of the string but expecting
  // "}"
  if (state == STATE_EXPECT_CURLY_BRACE_CLOSE) {
    _throwParserErr(_p, "unexpected end of string, expected '}'");
  }

  // Push the last part of the string onto the syntax tree
  if (state == STATE_CURLY_BRACE_OPEN) {
    str += "{";
  }
  if (str) {
    _tree.push(str);
  }
}

// Regular expression which matches on PHP variable identifiers (without the $)
var PHP_VAR_PREG = /^([A-Za-z0-9_]+)/;
function _php_parseVariableName(_p) {
  // Extract the variable name form the expression
  var vname = PHP_VAR_PREG.exec(_p.expr.substr(_p.pos));
  if (vname) {
    // Increment the parser position by the length of vname
    _p.pos += vname[0].length;
    return {
      "variable": vname[0],
      "accessExpressions": []
    };
  }
  _throwParserErr(_p, "expected variable identifier.");
}
function _php_parseVariable(_p) {
  // Parse the first variable
  var variable = _php_parseVariableName(_p);

  // Parse all following variable access identifiers
  var state = STATE_DEFAULT;
  while (_p.pos < _p.expr.length) {
    var c = _p.expr.charAt(_p.pos++);
    switch (state) {
      case STATE_DEFAULT:
        switch (c) {
          case "[":
            // Parse the expression inside the rect brace
            variable.accessExpressions.push(_php_parseExpression(_p));
            state = STATE_EXPECT_RECT_BRACE_CLOSE;
            break;
          default:
            _p.pos--;
            return variable;
        }
        break;
      case STATE_EXPECT_RECT_BRACE_CLOSE:
        if (c != "]") {
          _throwParserErr(_p, " expected ']', but got " + c);
        }
        state = STATE_DEFAULT;
        break;
    }
  }
  return variable;
}

/**
 * Reads a string delimited by the char _delim or the regExp _delim from the
 * current parser context and returns it.
 *
 * @param {object} _p parser contect
 * @param {string} _delim delimiter
 * @return {string} string read (or throws an exception)
 */
function _php_readString(_p, _delim) {
  var state = STATE_DEFAULT;
  var str = "";
  while (_p.pos < _p.expr.length) {
    var c = _p.expr.charAt(_p.pos++);
    switch (state) {
      case STATE_DEFAULT:
        if (c == "\\") {
          state = STATE_ESCAPED;
        } else if (c === _delim || typeof _delim != "string" && _delim.test(c)) {
          return str;
        } else {
          str += c;
        }
        break;
      case STATE_ESCAPED:
        str += c;
        state = STATE_DEFAULT;
        break;
    }
  }
  _throwParserErr(_p, "unexpected end of string while parsing string!");
}
function _php_parseExpression(_p) {
  var state = STATE_EXPR_BEGIN;
  var result = null;
  while (_p.pos < _p.expr.length) {
    var c = _p.expr.charAt(_p.pos++);
    switch (state) {
      case STATE_EXPR_BEGIN:
        switch (c) {
          // Skip whitespace
          case " ":
          case "\n":
          case "\r":
          case "\t":
            break;
          case "\"":
            result = [];
            var p = _php_parser(_php_readString(_p, "\""));
            _php_parseDoubleQuoteString(p, result);
            state = STATE_EXPR_END;
            break;
          case "\'":
            result = _php_readString(_p, "'");
            state = STATE_EXPR_END;
            break;
          case "$":
            result = _php_parseVariable(_p);
            state = STATE_EXPR_END;
            break;
          default:
            _p.pos--;
            result = _php_readString(_p, /[^A-Za-z0-9_#]/);
            if (!result) {
              _throwParserErr(_p, "unexpected char " + c);
            }
            _p.pos--;
            state = STATE_EXPR_END;
            break;
        }
        break;
      case STATE_EXPR_END:
        switch (c) {
          // Skip whitespace
          case " ":
          case "\n":
          case "\r":
          case "\t":
            break;
          default:
            _p.pos--;
            return result;
        }
    }
  }
  _throwParserErr(_p, "unexpected end of string while parsing access expressions!");
}
function _php_parser(_expr) {
  return {
    expr: _expr,
    pos: 0
  };
}
function _throwCompilerErr(_err) {
  throw "PHP to JS compiler error, " + _err;
}
function _php_compileVariable(_vars, _variable) {
  if (_vars.indexOf(_variable.variable) >= 0) {
    // Attach a "_" to the variable name as PHP variable names may start
    // with numeric values
    var result = "_" + _variable.variable;

    // Create the access functions
    for (var i = 0; i < _variable.accessExpressions.length; i++) {
      result += "[" + _php_compileString(_vars, _variable.accessExpressions[i]) + "]";
    }
    return '(typeof _' + _variable.variable + ' != "undefined" && typeof ' + result + '!="undefined" && ' + result + ' != null ? ' + result + ':"")';
  }
  _throwCompilerErr("Variable $" + _variable.variable + " is not defined.");
}
function _php_compileString(_vars, _string) {
  if (!(_string instanceof Array)) {
    _string = [_string];
  }
  var parts = [];
  var hasString = false;
  for (var i = 0; i < _string.length; i++) {
    var part = _string[i];
    if (typeof part == "string") {
      hasString = true;
      // Escape all "'" and "\" chars and add the string to the parts array
      parts.push("'" + part.replace(/\\/g, "\\\\").replace(/'/g, "\\'") + "'");
    } else {
      parts.push(_php_compileVariable(_vars, part));
    }
  }
  if (!hasString)
    // Force the result to be of the type string
    {
      parts.push('""');
    }
  return parts.join(" + ");
}
function _php_compileJSCode(_vars, _tree) {
  // Each tree starts with a "string"
  return "return " + _php_compileString(_vars, _tree) + ";";
}

// Include this code in in order to test the above code
/*(function () {
	var row = 10;
	var row_cont = {"title": "Hello World!"};
	var cont = {10: row_cont};

	function test(_php, _res)
	{
		console.log(
			et2_compilePHPExpression(_php, ["row", "row_cont", "cont"])
				(row, row_cont, cont) === _res);
	}

	test("${row}[title]", "10[title]");
	test("{$row_cont[title]}", "Hello World!");
	test('{$cont["$row"][\'title\']}', "Hello World!");
	test("$row_cont[${row}[title]]");
	test("\\\\", "\\");
	test("", "");
})();*/

function _defineProperty$2g(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Manage access to various template customisation arrays passed to etemplate->exec().
 *
 * This manages access to content, modifications and readonlys arrays
 */
class et2_arrayMgr {
  /**
   * Constructor
   *
   * @memberOf et2_arrayMgr
   * @param _data
   * @param _parentMgr
   */
  constructor() {
    var _data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _parentMgr = arguments.length > 1 ? arguments[1] : undefined;
    _defineProperty$2g(this, "splitIds", true);
    _defineProperty$2g(this, "data", void 0);
    // Holds information about the current perspective
    _defineProperty$2g(this, "perspectiveData", {
      "owner": null,
      "key": null,
      "row": null
    });
    _defineProperty$2g(this, "_parentMgr", void 0);
    _defineProperty$2g(this, "readOnly", false);
    if (typeof _parentMgr == "undefined") {
      _parentMgr = null;
    }

    // Copy the parent manager which is needed to access relative data when
    // being in a relative perspective of the manager
    this._parentMgr = _parentMgr;

    // Hold a reference to the data
    if (typeof _data == "undefined" || !_data) {
      egw$1.debug("log", "No data passed to content array manager.  Probably a mismatch between template namespaces and data.");
      _data = {};
    }

    // Expand sub-arrays that have been shmushed together, so further perspectives work
    // Shmushed keys look like: ${row}[info_cat]
    // Expanded: ${row}: Object{info_cat: ..value}
    if (this.splitIds) {
      // For each index, we need a key: {..} sub array
      for (var key in _data) {
        // Split up indexes
        var indexes = key.replace(/&#x5B;/g, "[").split('[');

        // Put data in the proper place
        if (indexes.length > 1) {
          var value = _data[key];
          var target = _data;
          for (var i = 0; i < indexes.length; i++) {
            indexes[i] = indexes[i].replace(/&#x5D;/g, '').replace(']', '');
            if (typeof target[indexes[i]] == "undefined" || target[indexes[i]] === null) {
              target[indexes[i]] = i == indexes.length - 1 ? value : {};
            }
            target = target[indexes[i]];
          }
          delete _data[key];
        }
      }
    }
    this.data = _data;
  }

  /**
   * Returns the root content array manager object
   */
  getRoot() {
    if (this._parentMgr != null) {
      return this._parentMgr.getRoot();
    }
    return this;
  }
  getParentMgr() {
    return this._parentMgr;
  }
  getPerspectiveData() {
    return this.perspectiveData;
  }
  setPerspectiveData(new_perspective) {
    this.perspectiveData = new_perspective;
  }
  setRow(new_row) {
    this.perspectiveData.row = new_row;
  }

  /**
   * Explodes compound keys (eg IDs) into a list of namespaces
   * This uses no internal values, just expands
   *
   * eg:
   * a[b][c] => [a,b,c]
   * col_filter[tr_tracker] => [col_filter, tr_tracker]
   *
   * @param {string} _key
   *
   * @return {string[]}
   */
  explodeKey(_key) {
    if (!_key || typeof _key == 'string' && _key.trim() === "") {
      return [];
    }

    // Parse the given key by removing the "]"-chars and splitting at "["
    var indexes = [_key];
    if (typeof _key === "string") {
      _key = _key.replace(/&#x5B;/g, "[").replace(/&#x5D;/g, "]");
      indexes = _key.split('[');
    }
    if (indexes.length > 1) {
      indexes = [indexes.shift(), indexes.join('[')];
      indexes[1] = indexes[1].substring(0, indexes[1].length - 1);
      var children = indexes[1].split('][');
      if (children.length) {
        indexes = jQuery.merge([indexes[0]], children);
      }
    }
    return indexes;
  }

  /**
   * Returns the path to this content array manager perspective as an array
   * containing the key values
   *
   * @param _path is used internally, do not supply it manually.
   */
  getPath(_path) {
    if (typeof _path == "undefined") {
      _path = [];
    }
    if (this.perspectiveData.key != null) {
      // prepend components of this.perspectiveData.key to path, can be more then one eg. "nm[rows]"
      _path = this.perspectiveData.key.replace(/]/g, '').split('[').concat(_path);
    }
    if (this._parentMgr != null) {
      _path = this._parentMgr.getPath(_path);
    }
    return _path;
  }

  /**
   * Get array entry is the equivalent to the boetemplate get_array function.
   * It returns a reference to the (sub) array with the given key. This also works
   * for keys using the ETemplate referencing scheme like a[b][c]
   *
   * @param _key is the string index, may contain sub-indices like a[b]
   * @param _referenceInto if true none-existing sub-arrays/-indices get created
   *    to be returned as reference, else false is returned. Defaults to false
   * @param _skipEmpty returns null if _key is not present in this content array.
   *    Defaults to false.
   */
  getEntry(_key, _referenceInto, _skipEmpty) {
    if (typeof _referenceInto == "undefined") {
      _referenceInto = false;
    }
    if (typeof _skipEmpty == "undefined") {
      _skipEmpty = false;
    }

    // Parse the given key by removing the "]"-chars and splitting at "["
    var indexes = this.explodeKey(_key);
    if (indexes.length == 0 && _skipEmpty) {
      return null;
    }
    var entry = this.data;
    for (var i = 0; i < indexes.length; i++) {
      // Abort if the current entry is not an object (associative array) and
      // we should descend further into it.
      var isObject = typeof entry === 'object';
      if (!isObject && !_referenceInto || entry == null || jQuery.isEmptyObject(entry)) {
        return null;
      }

      // Check whether the entry actually exists
      var idx = indexes[i];
      if (_skipEmpty && (!isObject || typeof entry[idx] == "undefined")) {
        return null;
      }
      entry = entry[idx];
    }
    return entry;
  }

  /**
   * Equivalent to the boetemplate::expand_name function.
   *
   * Expands variables inside the given identifier to their values inside the
   * content array.
   *
   * @param {string} _ident Key used to reference into managed array
   * @return {*}
   */
  expandName(_ident) {
    // Check whether the identifier refers to an index in the content array
    var is_index_in_content = _ident.charAt(0) == '@';

    // Check whether "$" occurs in the given identifier
    var pos_var = _ident.indexOf('$');
    if (pos_var >= 0 && (this.perspectiveData.row != null || !_ident.match(/\$\{?row\}?/))
    // Avoid messing with regex in validators
    && pos_var !== _ident.indexOf("$/")) {
      // Get the content array for the current row
      var row = typeof this.perspectiveData.row == 'number' ? this.perspectiveData.row : '';
      var row_cont = this.data[row] || {};
      // $cont is NOT root but current name-space in old eTemplate
      var cont = this.data; //getRoot().data;
      var _cont = this.data; // according to a grep only used in ImportExport just twice

      // Check whether the expression has already been compiled - if not,
      // try to compile it first. If an error occurs, the identifier
      // function is set to null
      if (typeof et2_arrayMgr.compiledExpressions[_ident] == "undefined") {
        try {
          if (this.perspectiveData.row == null) {
            // No row, compile for only top level content
            // @ts-ignore
            et2_arrayMgr.compiledExpressions[_ident] = et2_compilePHPExpression(_ident, ["cont", "_cont"]);
          } else {
            // @ts-ignore
            et2_arrayMgr.compiledExpressions[_ident] = et2_compilePHPExpression(_ident, ["row", "cont", "row_cont", "_cont"]);
          }
        } catch (e) {
          et2_arrayMgr.compiledExpressions[_ident] = null;
          egw$1.debug("error", "Error while compiling PHP->JS ", e);
        }
      }

      // Execute the previously compiled expression, if it is not "null"
      // because compilation failed. The parameters have to be in the same
      // order as defined during compilation.
      if (et2_arrayMgr.compiledExpressions[_ident]) {
        try {
          if (this.perspectiveData.row == null) {
            // No row, exec with only top level content
            _ident = et2_arrayMgr.compiledExpressions[_ident](cont, _cont);
          } else {
            _ident = et2_arrayMgr.compiledExpressions[_ident](row, cont, row_cont, _cont);
          }
        } catch (e) {
          // only log error, as they are no real errors but missing data
          egw$1.debug("log", typeof e == 'object' ? e.message : e);
          _ident = null;
        }
      }
    }
    if (is_index_in_content && _ident) {
      // If an additional "@" is specified, this means that we have to return
      // the entry from the root element
      if (_ident.charAt(1) == '@') {
        return this.getRoot().getEntry(_ident.substr(2));
      } else {
        return this.getEntry(_ident.substr(1));
      }
    }
    return _ident;
  }
  parseBoolExpression(_expression) {
    if (typeof _expression === "boolean") {
      return _expression;
    }
    if (typeof _expression === "undefined" || _expression === null) {
      return false;
    }
    if (typeof _expression === "number") {
      return !!_expression;
    }

    // Check whether "$" occurs in the given identifier, don't parse rows if we're not in a row
    // This saves booleans in repeating rows from being parsed too early - we'll parse again when repeating
    if (_expression.indexOf('$') >= 0 && this.perspectiveData.row == null && _expression.match(/\$\{?row\}?/)) {
      return _expression;
    }

    // If the first char of the expression is a '!' this means, that the value
    // is to be negated.
    if (_expression.charAt(0) == '!') {
      return !this.parseBoolExpression(_expression.substr(1));
    }

    // Split the expression at a possible "="
    var parts = _expression.split('=');

    // Expand the first value
    var val = this.expandName(parts[0]);
    val = typeof val == "undefined" || val === null ? '' : '' + val;

    // If a second expression existed, test that one
    if (typeof parts[1] != "undefined") {
      // Expand the second value
      var checkVal = '' + this.expandName(parts[1]);

      // Values starting with / are treated as regular expression. It is
      // checked whether the first value matches the regular expression
      if (checkVal.charAt(0) == '/') {
        return new RegExp(checkVal.substr(1, checkVal.length - 2)).test(val);
      }

      // Otherwise check for simple equality
      return val == checkVal;
    }
    return et2_evalBool(val);
  }

  /**
   * ?
   *
   * @param {object} _owner owner object
   * @param {(string|null|object)} _root string with key, null for whole data or object with data
   * @param {number?} _row key for into the _root for the desired row
   */
  openPerspective(_owner, _root, _row) {
    // Get the root node
    var root = typeof _root == "string" ? this.data[_root] : _root == null ? this.data : _root;
    if (typeof root == "undefined" && typeof _root == "string") {
      root = this.getEntry(_root);
    }

    // Create a new content array manager with the given root
    var constructor = this.readOnly ? et2_readonlysArrayMgr : et2_arrayMgr;
    var mgr = new constructor(root, this);

    // Set the owner
    mgr.perspectiveData.owner = _owner;

    // Set the root key
    if (typeof _root == "string") {
      mgr.perspectiveData.key = _root;
    }

    // Set _row parameter
    if (typeof _row != "undefined") {
      mgr.perspectiveData.row = _row;
    }
    return mgr;
  }
}

/**
 * @augments et2_arrayMgr
 */
_defineProperty$2g(et2_arrayMgr, "compiledExpressions", {});
class et2_readonlysArrayMgr extends et2_arrayMgr {
  constructor() {
    super(...arguments);
    _defineProperty$2g(this, "readOnly", true);
  }
  /**
   * Find out if the given ID is readonly, according to the array data
   *
   * @memberOf et2_readonlysArrayMgr
   * @param _id
   * @param _attr
   * @param _parent
   * @returns
   */
  isReadOnly(_id, _attr, _parent) {
    var entry = null;
    if (_id != null) {
      if (_id.indexOf('$') >= 0 || _id.indexOf('@') >= 0) {
        _id = this.expandName(_id);
      }
      // readonlys was not namespaced in old eTemplate, therefore if we dont find data
      // under current namespace, we look into parent
      // (if there is anything namespaced, we will NOT look for parent!)
      var mgr = this;
      while (mgr.getParentMgr() && jQuery.isEmptyObject(mgr.data)) {
        mgr = mgr.getParentMgr();
      }
      entry = mgr.getEntry(_id);
    }

    // Let the array entry override the read only attribute entry
    if (typeof entry != "undefined" && !(typeof entry === 'object')) {
      return entry;
    }

    // If the attribute is set, return that
    if (typeof _attr != "undefined" && _attr !== null) {
      // Accept 'editable', but otherwise boolean
      return typeof _attr === 'string' && this.expandName(_attr) === 'editable' ? 'editable' : et2_evalBool(_attr);
    }

    // Otherwise take into accounf whether the parent is readonly
    if (typeof _parent != "undefined" && _parent) {
      return true;
    }

    // Otherwise return the default value
    entry = this.getEntry("__ALL__");
    return entry !== null && typeof entry != "undefined";
  }

  /**
   * Override parent to handle cont and row_cont.
   *
   * Normally these should refer to the readonlys data, but that's not
   * useful, so we use the owner inside perspective data to expand using content.
   *
   * @param {string} ident Key for searching into the array.
   * @returns {*}
   */
  expandName(ident) {
    return this.perspectiveData.owner.getArrayMgr('content').expandName(ident);
  }
}

/**
 * Creates a new set of array managers
 *
 * @param _owner is the owner object of the array managers - this object (a widget)
 *    will free the array manager
 * @param _mgrs is the original set of array managers, the array managers are
 *    inside an associative array as recived from et2_widget::getArrayMgrs()
 * @param _data is an associative array of new data which will be merged into the
 *    existing array managers.
 * @param _row is the row for which the array managers will be opened.
 */
function et2_arrayMgrs_expand(_owner, _mgrs, _data, _row) {
  // Create a copy of the given _mgrs associative array
  var result = {};

  // Merge the given data associative array into the existing array managers
  for (var key in _mgrs) {
    result[key] = _mgrs[key];
    if (typeof _data[key] != "undefined") {
      // Open a perspective for the given data row
      var rowData = {};
      rowData[_row] = _data[key];
      result[key] = _mgrs[key].openPerspective(_owner, rowData, _row);
    }
  }

  // Return the resulting managers object
  return result;
}

function et2_compileLegacyJS(_code, _widget, _context) {
  // Replace the javascript pseudo-functions
  _code = js_pseudo_funcs(_code, _widget);

  // Check whether _code is simply "1" -- if yes replace it accordingly
  if (_code === '1') {
    _code = 'widget.getInstanceManager().submit(); return false;';
  }

  // Check whether some pseudo-variables still reside inside of the code,
  // if yes, replace them.
  if (_code.indexOf("$") >= 0 || _code.indexOf("@") >= 0) {
    // Get the content array manager for the widget
    var mgr = _widget.getArrayMgr("content");
    if (mgr) {
      _code = mgr.expandName(_code);
    }
    // If replacement cleared the code, skip the rest
    if (!_code) {
      return false;
    }
  }

  // Context is the context in which the function will run. Set context to
  // null as a default, so that it's possible to find bugs where "this" is
  // accessed in the code, but not properly set.
  var context = _context ? _context : null;

  // Check whether the given widget implements the "et2_IDOMNode"
  // interface
  if (!context && _widget.implements(et2_IDOMNode)) {
    context = _widget.getDOMNode();
  }

  // Check to see if it's referring to an existing function with no arguments specified.
  // If so, bind context & use it directly
  if (_code.indexOf("(") === -1) {
    var parts = _code.split(".");
    var existing_func = parts.pop();
    var parent = _widget.egw().window;
    for (var i = 0; i < parts.length; ++i) {
      if (typeof parent[parts[i]] !== "undefined") {
        parent = parent[parts[i]];
      }
      // Nope
      else {
        break;
      }
    }
    if (typeof parent[existing_func] === "function") {
      // Bind the object so no matter what happens, context is correct
      return parent[existing_func].bind(parent);
    }
  }

  // Generate the function itself, if it fails, log the error message and
  // return a function which always returns false
  try {
    // Code is app.appname.function, add the arguments so it can be executed
    if (typeof _code == 'string' && _code.indexOf('app') == 0 && _code.split('.').length >= 3 && _code.indexOf('(') == -1) {
      var _parts = _code.split('.');
      var app = _widget.getInstanceManager().app_obj;
      // check if we need to load the object
      if (_parts.length === 3 && typeof app[_parts[1]] === 'undefined') {
        return function (ev, widget) {
          return egw$1.applyFunc(_code, [ev, widget]);
        };
      }
      // Code is app.appname.function, add the arguments so it can be executed
      _code += '(ev,widget)';
      // Return what the function returns
      if (_code.indexOf("return") == -1) {
        _code = "return " + _code;
      }
    }
    // use app object from etemplate2, which might be private and not just window.app
    _code = _code.replace(/(window\.)?app\./, 'widget.getInstanceManager().app_obj.');
    var func = new Function('ev', 'widget', _code);
  } catch (e) {
    _widget.egw().debug('error', 'Error while compiling JS code ', _code);
    return function () {
      return false;
    };
  }

  // Execute the code and return its results, pass the egw instance and
  // the widget
  return function (ev, widget) {
    // Dump the executed code for debugging
    egw$1.debug('log', 'Executing legacy JS code: ', _code);
    if (arguments && arguments.length > 2) {
      egw$1.debug('warn', 'Legacy JS code only supports 2 arguments (event and widget)', _code, arguments);
    }
    // Return the result of the called function
    return func.call(context, ev, widget || _widget);
  };
}

/**
 * Resolve javascript pseudo functions in onclick or onchange:
 * - egw::link('$l','$p') calls egw.link($l,$p)
 * - form::name('name') returns expanded name/id taking into account the name at that point of the template hierarchy
 * - egw::lang('Message ...') translate the message, calls egw.lang()
 * - confirm('message') translates 'message' and adds a '?' if not present
 * - window.open() replaces it with egw_openWindowCentered2()
 * - xajax_doXMLHTTP('etemplate. replace ajax calls in widgets with special handler not requiring etemplate run rights
 *
 * @param {string} _val onclick, onchange, ... action
 * @param {et2_widget} widget
 * @ToDo replace xajax_doXMLHTTP with egw.json()
 * @ToDo replace (common) cases of confirm with new dialog, idea: calling function supplys function to call after confirm
 * @ToDo template::styles(name) inserts the styles of a named template
 * @return string
 */
function js_pseudo_funcs(_val, widget) {
  if (_val.indexOf('egw::link(') != -1) {
    _val = _val.replace(/egw::link\(/g, 'egw.link(');
  }
  if (_val.indexOf('form::name(') != -1) {
    // et2_form_name doesn't care about ][, just [
    var _cname = widget.getPath() ? widget.getPath().join("[") : false;
    document.et2_form_name = et2_form_name;
    _val = _val.replace(/form::name\(/g, "'" + widget.getRoot()._inst.uniqueId + "_'+" + (_cname ? "document.et2_form_name('" + _cname + "'," : '('));
  }
  if (_val.indexOf('egw::lang(') != -1) {
    _val = _val.replace(/egw::lang\(/g, 'egw.lang(');
  }

  // ToDo: inserts the styles of a named template
  /*if (preg_match('/template::styles\(["\']{1}(.*)["\']{1}\)/U',$on,$matches))
  {
  	$tpl = $matches[1] == $this->name ? $this : new etemplate($matches[1]);
  	$on = str_replace($matches[0],"'<style>".str_replace(array("\n","\r"),'',$tpl->style)."</style>'",$on);
  }*/

  // translate messages in confirm()
  if (_val.indexOf('confirm(') != -1) {
    _val = _val.replace(/confirm\((['"])(.*?)(\?)?['"]\)/, "confirm(egw.lang($1$2$1)+'$3')"); // add ? if not there, saves extra phrase
  }

  // replace window.open() with EGw's egw_openWindowCentered2()
  if (_val.indexOf('window.open(') != -1) {
    _val = _val.replace(/window.open\('(.*)','(.*)','dependent=yes,width=([^,]*),height=([^,]*),scrollbars=yes,status=(.*)'\)/, "egw_openWindowCentered2('$1', '$2', $3, $4, '$5')");
  }

  // replace xajax calls to code in widgets, with the "etemplate" handler,
  // this allows to call widgets with the current app, otherwise everyone would need etemplate run rights
  if (_val.indexOf("xajax_doXMLHTTP('etemplate.") != -1) {
    _val = _val.replace(/^xajax_doXMLHTTP\('etemplate\.([a-z]+_widget\.[a-zA-Z0-9_]+)\'/, "xajax_doXMLHTTP('" + egw$1.getAppName() + ".$1.etemplate'");
  }
  if (_val.indexOf('this.form.submit()') != -1) {
    _val = _val.replace('this.form.submit()', 'widget.getInstanceManager().submit()');
  }
  return _val;
}

/**
 * @license
 * Copyright 2019 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const t$9=window,e$h=t$9.ShadowRoot&&(void 0===t$9.ShadyCSS||t$9.ShadyCSS.nativeShadow)&&"adoptedStyleSheets"in Document.prototype&&"replace"in CSSStyleSheet.prototype,s$8=Symbol(),n$d=new WeakMap;class o$j{constructor(t,e,n){if(this._$cssResult$=!0,n!==s$8)throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");this.cssText=t,this.t=e;}get styleSheet(){let t=this.o;const s=this.t;if(e$h&&void 0===t){const e=void 0!==s&&1===s.length;e&&(t=n$d.get(s)),void 0===t&&((this.o=t=new CSSStyleSheet).replaceSync(this.cssText),e&&n$d.set(s,t));}return t}toString(){return this.cssText}}const r$7=t=>new o$j("string"==typeof t?t:t+"",void 0,s$8),i$b=(t,...e)=>{const n=1===t.length?t[0]:e.reduce(((e,s,n)=>e+(t=>{if(!0===t._$cssResult$)return t.cssText;if("number"==typeof t)return t;throw Error("Value passed to 'css' function must be a 'css' function result: "+t+". Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.")})(s)+t[n+1]),t[0]);return new o$j(n,t,s$8)},S$2=(s,n)=>{e$h?s.adoptedStyleSheets=n.map((t=>t instanceof CSSStyleSheet?t:t.styleSheet)):n.forEach((e=>{const n=document.createElement("style"),o=t$9.litNonce;void 0!==o&&n.setAttribute("nonce",o),n.textContent=e.cssText,s.appendChild(n);}));},c$7=e$h?t=>t:t=>t instanceof CSSStyleSheet?(t=>{let e="";for(const s of t.cssRules)e+=s.cssText;return r$7(e)})(t):t;

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */var s$7;const e$g=window,r$6=e$g.trustedTypes,h$9=r$6?r$6.emptyScript:"",o$i=e$g.reactiveElementPolyfillSupport,n$c={toAttribute(t,i){switch(i){case Boolean:t=t?h$9:null;break;case Object:case Array:t=null==t?t:JSON.stringify(t);}return t},fromAttribute(t,i){let s=t;switch(i){case Boolean:s=null!==t;break;case Number:s=null===t?null:Number(t);break;case Object:case Array:try{s=JSON.parse(t);}catch(t){s=null;}}return s}},a$4=(t,i)=>i!==t&&(i==i||t==t),l$9={attribute:!0,type:String,converter:n$c,reflect:!1,hasChanged:a$4};class d$4 extends HTMLElement{constructor(){super(),this._$Ei=new Map,this.isUpdatePending=!1,this.hasUpdated=!1,this._$El=null,this.u();}static addInitializer(t){var i;this.finalize(),(null!==(i=this.h)&&void 0!==i?i:this.h=[]).push(t);}static get observedAttributes(){this.finalize();const t=[];return this.elementProperties.forEach(((i,s)=>{const e=this._$Ep(s,i);void 0!==e&&(this._$Ev.set(e,s),t.push(e));})),t}static createProperty(t,i=l$9){if(i.state&&(i.attribute=!1),this.finalize(),this.elementProperties.set(t,i),!i.noAccessor&&!this.prototype.hasOwnProperty(t)){const s="symbol"==typeof t?Symbol():"__"+t,e=this.getPropertyDescriptor(t,s,i);void 0!==e&&Object.defineProperty(this.prototype,t,e);}}static getPropertyDescriptor(t,i,s){return {get(){return this[i]},set(e){const r=this[t];this[i]=e,this.requestUpdate(t,r,s);},configurable:!0,enumerable:!0}}static getPropertyOptions(t){return this.elementProperties.get(t)||l$9}static finalize(){if(this.hasOwnProperty("finalized"))return !1;this.finalized=!0;const t=Object.getPrototypeOf(this);if(t.finalize(),void 0!==t.h&&(this.h=[...t.h]),this.elementProperties=new Map(t.elementProperties),this._$Ev=new Map,this.hasOwnProperty("properties")){const t=this.properties,i=[...Object.getOwnPropertyNames(t),...Object.getOwnPropertySymbols(t)];for(const s of i)this.createProperty(s,t[s]);}return this.elementStyles=this.finalizeStyles(this.styles),!0}static finalizeStyles(i){const s=[];if(Array.isArray(i)){const e=new Set(i.flat(1/0).reverse());for(const i of e)s.unshift(c$7(i));}else void 0!==i&&s.push(c$7(i));return s}static _$Ep(t,i){const s=i.attribute;return !1===s?void 0:"string"==typeof s?s:"string"==typeof t?t.toLowerCase():void 0}u(){var t;this._$E_=new Promise((t=>this.enableUpdating=t)),this._$AL=new Map,this._$Eg(),this.requestUpdate(),null===(t=this.constructor.h)||void 0===t||t.forEach((t=>t(this)));}addController(t){var i,s;(null!==(i=this._$ES)&&void 0!==i?i:this._$ES=[]).push(t),void 0!==this.renderRoot&&this.isConnected&&(null===(s=t.hostConnected)||void 0===s||s.call(t));}removeController(t){var i;null===(i=this._$ES)||void 0===i||i.splice(this._$ES.indexOf(t)>>>0,1);}_$Eg(){this.constructor.elementProperties.forEach(((t,i)=>{this.hasOwnProperty(i)&&(this._$Ei.set(i,this[i]),delete this[i]);}));}createRenderRoot(){var t;const s=null!==(t=this.shadowRoot)&&void 0!==t?t:this.attachShadow(this.constructor.shadowRootOptions);return S$2(s,this.constructor.elementStyles),s}connectedCallback(){var t;void 0===this.renderRoot&&(this.renderRoot=this.createRenderRoot()),this.enableUpdating(!0),null===(t=this._$ES)||void 0===t||t.forEach((t=>{var i;return null===(i=t.hostConnected)||void 0===i?void 0:i.call(t)}));}enableUpdating(t){}disconnectedCallback(){var t;null===(t=this._$ES)||void 0===t||t.forEach((t=>{var i;return null===(i=t.hostDisconnected)||void 0===i?void 0:i.call(t)}));}attributeChangedCallback(t,i,s){this._$AK(t,s);}_$EO(t,i,s=l$9){var e;const r=this.constructor._$Ep(t,s);if(void 0!==r&&!0===s.reflect){const h=(void 0!==(null===(e=s.converter)||void 0===e?void 0:e.toAttribute)?s.converter:n$c).toAttribute(i,s.type);this._$El=t,null==h?this.removeAttribute(r):this.setAttribute(r,h),this._$El=null;}}_$AK(t,i){var s;const e=this.constructor,r=e._$Ev.get(t);if(void 0!==r&&this._$El!==r){const t=e.getPropertyOptions(r),h="function"==typeof t.converter?{fromAttribute:t.converter}:void 0!==(null===(s=t.converter)||void 0===s?void 0:s.fromAttribute)?t.converter:n$c;this._$El=r,this[r]=h.fromAttribute(i,t.type),this._$El=null;}}requestUpdate(t,i,s){let e=!0;void 0!==t&&(((s=s||this.constructor.getPropertyOptions(t)).hasChanged||a$4)(this[t],i)?(this._$AL.has(t)||this._$AL.set(t,i),!0===s.reflect&&this._$El!==t&&(void 0===this._$EC&&(this._$EC=new Map),this._$EC.set(t,s))):e=!1),!this.isUpdatePending&&e&&(this._$E_=this._$Ej());}async _$Ej(){this.isUpdatePending=!0;try{await this._$E_;}catch(t){Promise.reject(t);}const t=this.scheduleUpdate();return null!=t&&await t,!this.isUpdatePending}scheduleUpdate(){return this.performUpdate()}performUpdate(){var t;if(!this.isUpdatePending)return;this.hasUpdated,this._$Ei&&(this._$Ei.forEach(((t,i)=>this[i]=t)),this._$Ei=void 0);let i=!1;const s=this._$AL;try{i=this.shouldUpdate(s),i?(this.willUpdate(s),null===(t=this._$ES)||void 0===t||t.forEach((t=>{var i;return null===(i=t.hostUpdate)||void 0===i?void 0:i.call(t)})),this.update(s)):this._$Ek();}catch(t){throw i=!1,this._$Ek(),t}i&&this._$AE(s);}willUpdate(t){}_$AE(t){var i;null===(i=this._$ES)||void 0===i||i.forEach((t=>{var i;return null===(i=t.hostUpdated)||void 0===i?void 0:i.call(t)})),this.hasUpdated||(this.hasUpdated=!0,this.firstUpdated(t)),this.updated(t);}_$Ek(){this._$AL=new Map,this.isUpdatePending=!1;}get updateComplete(){return this.getUpdateComplete()}getUpdateComplete(){return this._$E_}shouldUpdate(t){return !0}update(t){void 0!==this._$EC&&(this._$EC.forEach(((t,i)=>this._$EO(i,this[i],t))),this._$EC=void 0),this._$Ek();}updated(t){}firstUpdated(t){}}d$4.finalized=!0,d$4.elementProperties=new Map,d$4.elementStyles=[],d$4.shadowRootOptions={mode:"open"},null==o$i||o$i({ReactiveElement:d$4}),(null!==(s$7=e$g.reactiveElementVersions)&&void 0!==s$7?s$7:e$g.reactiveElementVersions=[]).push("1.6.1");

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
var t$8;const i$a=window,s$6=i$a.trustedTypes,e$f=s$6?s$6.createPolicy("lit-html",{createHTML:t=>t}):void 0,o$h="$lit$",n$b=`lit$${(Math.random()+"").slice(9)}$`,l$8="?"+n$b,h$8=`<${l$8}>`,r$5=document,u$4=()=>r$5.createComment(""),d$3=t=>null===t||"object"!=typeof t&&"function"!=typeof t,c$6=Array.isArray,v$2=t=>c$6(t)||"function"==typeof(null==t?void 0:t[Symbol.iterator]),a$3="[ \t\n\f\r]",f$4=/<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g,_$1=/-->/g,m$3=/>/g,p$2=RegExp(`>|${a$3}(?:([^\\s"'>=/]+)(${a$3}*=${a$3}*(?:[^ \t\n\f\r"'\`<>=]|("|')|))|$)`,"g"),g$1=/'/g,$$d=/"/g,y$1=/^(?:script|style|textarea|title)$/i,w$1=t=>(i,...s)=>({_$litType$:t,strings:i,values:s}),x$1=w$1(1),b$1=w$1(2),T$1=Symbol.for("lit-noChange"),A$1=Symbol.for("lit-nothing"),E$1=new WeakMap,C$1=r$5.createTreeWalker(r$5,129,null,!1);function P$1(t,i){if(!Array.isArray(t)||!t.hasOwnProperty("raw"))throw Error("invalid template strings array");return void 0!==e$f?e$f.createHTML(i):i}const V$1=(t,i)=>{const s=t.length-1,e=[];let l,r=2===i?"<svg>":"",u=f$4;for(let i=0;i<s;i++){const s=t[i];let d,c,v=-1,a=0;for(;a<s.length&&(u.lastIndex=a,c=u.exec(s),null!==c);)a=u.lastIndex,u===f$4?"!--"===c[1]?u=_$1:void 0!==c[1]?u=m$3:void 0!==c[2]?(y$1.test(c[2])&&(l=RegExp("</"+c[2],"g")),u=p$2):void 0!==c[3]&&(u=p$2):u===p$2?">"===c[0]?(u=null!=l?l:f$4,v=-1):void 0===c[1]?v=-2:(v=u.lastIndex-c[2].length,d=c[1],u=void 0===c[3]?p$2:'"'===c[3]?$$d:g$1):u===$$d||u===g$1?u=p$2:u===_$1||u===m$3?u=f$4:(u=p$2,l=void 0);const w=u===p$2&&t[i+1].startsWith("/>")?" ":"";r+=u===f$4?s+h$8:v>=0?(e.push(d),s.slice(0,v)+o$h+s.slice(v)+n$b+w):s+n$b+(-2===v?(e.push(void 0),i):w);}return [P$1(t,r+(t[s]||"<?>")+(2===i?"</svg>":"")),e]};class N$1{constructor({strings:t,_$litType$:i},e){let h;this.parts=[];let r=0,d=0;const c=t.length-1,v=this.parts,[a,f]=V$1(t,i);if(this.el=N$1.createElement(a,e),C$1.currentNode=this.el.content,2===i){const t=this.el.content,i=t.firstChild;i.remove(),t.append(...i.childNodes);}for(;null!==(h=C$1.nextNode())&&v.length<c;){if(1===h.nodeType){if(h.hasAttributes()){const t=[];for(const i of h.getAttributeNames())if(i.endsWith(o$h)||i.startsWith(n$b)){const s=f[d++];if(t.push(i),void 0!==s){const t=h.getAttribute(s.toLowerCase()+o$h).split(n$b),i=/([.?@])?(.*)/.exec(s);v.push({type:1,index:r,name:i[2],strings:t,ctor:"."===i[1]?H$2:"?"===i[1]?L$1:"@"===i[1]?z$1:k$1});}else v.push({type:6,index:r});}for(const i of t)h.removeAttribute(i);}if(y$1.test(h.tagName)){const t=h.textContent.split(n$b),i=t.length-1;if(i>0){h.textContent=s$6?s$6.emptyScript:"";for(let s=0;s<i;s++)h.append(t[s],u$4()),C$1.nextNode(),v.push({type:2,index:++r});h.append(t[i],u$4());}}}else if(8===h.nodeType)if(h.data===l$8)v.push({type:2,index:r});else {let t=-1;for(;-1!==(t=h.data.indexOf(n$b,t+1));)v.push({type:7,index:r}),t+=n$b.length-1;}r++;}}static createElement(t,i){const s=r$5.createElement("template");return s.innerHTML=t,s}}function S$1(t,i,s=t,e){var o,n,l,h;if(i===T$1)return i;let r=void 0!==e?null===(o=s._$Co)||void 0===o?void 0:o[e]:s._$Cl;const u=d$3(i)?void 0:i._$litDirective$;return (null==r?void 0:r.constructor)!==u&&(null===(n=null==r?void 0:r._$AO)||void 0===n||n.call(r,!1),void 0===u?r=void 0:(r=new u(t),r._$AT(t,s,e)),void 0!==e?(null!==(l=(h=s)._$Co)&&void 0!==l?l:h._$Co=[])[e]=r:s._$Cl=r),void 0!==r&&(i=S$1(t,r._$AS(t,i.values),r,e)),i}class M$1{constructor(t,i){this._$AV=[],this._$AN=void 0,this._$AD=t,this._$AM=i;}get parentNode(){return this._$AM.parentNode}get _$AU(){return this._$AM._$AU}u(t){var i;const{el:{content:s},parts:e}=this._$AD,o=(null!==(i=null==t?void 0:t.creationScope)&&void 0!==i?i:r$5).importNode(s,!0);C$1.currentNode=o;let n=C$1.nextNode(),l=0,h=0,u=e[0];for(;void 0!==u;){if(l===u.index){let i;2===u.type?i=new R$1(n,n.nextSibling,this,t):1===u.type?i=new u.ctor(n,u.name,u.strings,this,t):6===u.type&&(i=new Z$1(n,this,t)),this._$AV.push(i),u=e[++h];}l!==(null==u?void 0:u.index)&&(n=C$1.nextNode(),l++);}return C$1.currentNode=r$5,o}v(t){let i=0;for(const s of this._$AV)void 0!==s&&(void 0!==s.strings?(s._$AI(t,s,i),i+=s.strings.length-2):s._$AI(t[i])),i++;}}class R$1{constructor(t,i,s,e){var o;this.type=2,this._$AH=A$1,this._$AN=void 0,this._$AA=t,this._$AB=i,this._$AM=s,this.options=e,this._$Cp=null===(o=null==e?void 0:e.isConnected)||void 0===o||o;}get _$AU(){var t,i;return null!==(i=null===(t=this._$AM)||void 0===t?void 0:t._$AU)&&void 0!==i?i:this._$Cp}get parentNode(){let t=this._$AA.parentNode;const i=this._$AM;return void 0!==i&&11===(null==t?void 0:t.nodeType)&&(t=i.parentNode),t}get startNode(){return this._$AA}get endNode(){return this._$AB}_$AI(t,i=this){t=S$1(this,t,i),d$3(t)?t===A$1||null==t||""===t?(this._$AH!==A$1&&this._$AR(),this._$AH=A$1):t!==this._$AH&&t!==T$1&&this._(t):void 0!==t._$litType$?this.g(t):void 0!==t.nodeType?this.$(t):v$2(t)?this.T(t):this._(t);}k(t){return this._$AA.parentNode.insertBefore(t,this._$AB)}$(t){this._$AH!==t&&(this._$AR(),this._$AH=this.k(t));}_(t){this._$AH!==A$1&&d$3(this._$AH)?this._$AA.nextSibling.data=t:this.$(r$5.createTextNode(t)),this._$AH=t;}g(t){var i;const{values:s,_$litType$:e}=t,o="number"==typeof e?this._$AC(t):(void 0===e.el&&(e.el=N$1.createElement(P$1(e.h,e.h[0]),this.options)),e);if((null===(i=this._$AH)||void 0===i?void 0:i._$AD)===o)this._$AH.v(s);else {const t=new M$1(o,this),i=t.u(this.options);t.v(s),this.$(i),this._$AH=t;}}_$AC(t){let i=E$1.get(t.strings);return void 0===i&&E$1.set(t.strings,i=new N$1(t)),i}T(t){c$6(this._$AH)||(this._$AH=[],this._$AR());const i=this._$AH;let s,e=0;for(const o of t)e===i.length?i.push(s=new R$1(this.k(u$4()),this.k(u$4()),this,this.options)):s=i[e],s._$AI(o),e++;e<i.length&&(this._$AR(s&&s._$AB.nextSibling,e),i.length=e);}_$AR(t=this._$AA.nextSibling,i){var s;for(null===(s=this._$AP)||void 0===s||s.call(this,!1,!0,i);t&&t!==this._$AB;){const i=t.nextSibling;t.remove(),t=i;}}setConnected(t){var i;void 0===this._$AM&&(this._$Cp=t,null===(i=this._$AP)||void 0===i||i.call(this,t));}}class k$1{constructor(t,i,s,e,o){this.type=1,this._$AH=A$1,this._$AN=void 0,this.element=t,this.name=i,this._$AM=e,this.options=o,s.length>2||""!==s[0]||""!==s[1]?(this._$AH=Array(s.length-1).fill(new String),this.strings=s):this._$AH=A$1;}get tagName(){return this.element.tagName}get _$AU(){return this._$AM._$AU}_$AI(t,i=this,s,e){const o=this.strings;let n=!1;if(void 0===o)t=S$1(this,t,i,0),n=!d$3(t)||t!==this._$AH&&t!==T$1,n&&(this._$AH=t);else {const e=t;let l,h;for(t=o[0],l=0;l<o.length-1;l++)h=S$1(this,e[s+l],i,l),h===T$1&&(h=this._$AH[l]),n||(n=!d$3(h)||h!==this._$AH[l]),h===A$1?t=A$1:t!==A$1&&(t+=(null!=h?h:"")+o[l+1]),this._$AH[l]=h;}n&&!e&&this.j(t);}j(t){t===A$1?this.element.removeAttribute(this.name):this.element.setAttribute(this.name,null!=t?t:"");}}class H$2 extends k$1{constructor(){super(...arguments),this.type=3;}j(t){this.element[this.name]=t===A$1?void 0:t;}}const I$1=s$6?s$6.emptyScript:"";class L$1 extends k$1{constructor(){super(...arguments),this.type=4;}j(t){t&&t!==A$1?this.element.setAttribute(this.name,I$1):this.element.removeAttribute(this.name);}}class z$1 extends k$1{constructor(t,i,s,e,o){super(t,i,s,e,o),this.type=5;}_$AI(t,i=this){var s;if((t=null!==(s=S$1(this,t,i,0))&&void 0!==s?s:A$1)===T$1)return;const e=this._$AH,o=t===A$1&&e!==A$1||t.capture!==e.capture||t.once!==e.once||t.passive!==e.passive,n=t!==A$1&&(e===A$1||o);o&&this.element.removeEventListener(this.name,this,e),n&&this.element.addEventListener(this.name,this,t),this._$AH=t;}handleEvent(t){var i,s;"function"==typeof this._$AH?this._$AH.call(null!==(s=null===(i=this.options)||void 0===i?void 0:i.host)&&void 0!==s?s:this.element,t):this._$AH.handleEvent(t);}}class Z$1{constructor(t,i,s){this.element=t,this.type=6,this._$AN=void 0,this._$AM=i,this.options=s;}get _$AU(){return this._$AM._$AU}_$AI(t){S$1(this,t);}}const j$1={O:o$h,P:n$b,A:l$8,C:1,M:V$1,L:M$1,R:v$2,D:S$1,I:R$1,V:k$1,H:L$1,N:z$1,U:H$2,F:Z$1},B$1=i$a.litHtmlPolyfillSupport;null==B$1||B$1(N$1,R$1),(null!==(t$8=i$a.litHtmlVersions)&&void 0!==t$8?t$8:i$a.litHtmlVersions=[]).push("2.8.0");const D$1=(t,i,s)=>{var e,o;const n=null!==(e=null==s?void 0:s.renderBefore)&&void 0!==e?e:i;let l=n._$litPart$;if(void 0===l){const t=null!==(o=null==s?void 0:s.renderBefore)&&void 0!==o?o:null;n._$litPart$=l=new R$1(i.insertBefore(u$4(),t),t,void 0,null!=s?s:{});}return l._$AI(t),l};

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */var l$7,o$g;const r$4=d$4;class s$5 extends d$4{constructor(){super(...arguments),this.renderOptions={host:this},this._$Do=void 0;}createRenderRoot(){var t,e;const i=super.createRenderRoot();return null!==(t=(e=this.renderOptions).renderBefore)&&void 0!==t||(e.renderBefore=i.firstChild),i}update(t){const i=this.render();this.hasUpdated||(this.renderOptions.isConnected=this.isConnected),super.update(t),this._$Do=D$1(i,this.renderRoot,this.renderOptions);}connectedCallback(){var t;super.connectedCallback(),null===(t=this._$Do)||void 0===t||t.setConnected(!0);}disconnectedCallback(){var t;super.disconnectedCallback(),null===(t=this._$Do)||void 0===t||t.setConnected(!1);}render(){return T$1}}s$5.finalized=!0,s$5._$litElement$=!0,null===(l$7=globalThis.litElementHydrateSupport)||void 0===l$7||l$7.call(globalThis,{LitElement:s$5});const n$a=globalThis.litElementPolyfillSupport;null==n$a||n$a({LitElement:s$5});const h$7={_$AK:(t,e,i)=>{t._$AK(e,i);},_$AL:t=>t._$AL};(null!==(o$g=globalThis.litElementVersions)&&void 0!==o$g?o$g:globalThis.litElementVersions=[]).push("3.3.3");

/**
 * @license
 * Copyright 2022 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const o$f=!1;

/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const e$e=Symbol.for(""),l$6=t=>{if((null==t?void 0:t.r)===e$e)return null==t?void 0:t._$litStatic$},o$e=t=>({_$litStatic$:t,r:e$e}),i$9=(t,...r)=>({_$litStatic$:r.reduce(((r,e,l)=>r+(t=>{if(void 0!==t._$litStatic$)return t._$litStatic$;throw Error(`Value passed to 'literal' function must be a 'literal' result: ${t}. Use 'unsafeStatic' to pass non-literal values, but\n            take care to ensure page security.`)})(e)+t[l+1]),t[0]),r:e$e}),s$4=new Map,a$2=t=>(r,...e)=>{const o=e.length;let i,a;const n=[],u=[];let c,$=0,f=!1;for(;$<o;){for(c=r[$];$<o&&void 0!==(a=e[$],i=l$6(a));)c+=i+r[++$],f=!0;$!==o&&u.push(a),n.push(c),$++;}if($===o&&n.push(r[o]),f){const t=n.join("$$lit$$");void 0===(r=s$4.get(t))&&(n.raw=n,s$4.set(t,r=n)),e=u;}return t(r,...e)},n$9=a$2(x$1),u$3=a$2(b$1);

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const e$d=e=>n=>"function"==typeof n?((e,n)=>(customElements.define(e,n),n))(e,n):((e,n)=>{const{kind:t,elements:s}=n;return {kind:t,elements:s,finisher(n){customElements.define(e,n);}}})(e,n);

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const i$8=(i,e)=>"method"===e.kind&&e.descriptor&&!("value"in e.descriptor)?{...e,finisher(n){n.createProperty(e.key,i);}}:{kind:"field",key:Symbol(),placement:"own",descriptor:{},originalKey:e.key,initializer(){"function"==typeof e.initializer&&(this[e.key]=e.initializer.call(this));},finisher(n){n.createProperty(e.key,i);}};function e$c(e){return (n,t)=>void 0!==t?((i,e,n)=>{e.constructor.createProperty(n,i);})(e,n,t):i$8(e,n)}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function t$7(t){return e$c({...t,state:!0})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const e$b=(e,t,o)=>{Object.defineProperty(t,o,e);},t$6=(e,t)=>({kind:"method",placement:"prototype",key:t.key,descriptor:e}),o$d=({finisher:e,descriptor:t})=>(o,n)=>{var r;if(void 0===n){const n=null!==(r=o.originalKey)&&void 0!==r?r:o.key,i=null!=t?{kind:"method",placement:"prototype",key:n,descriptor:t(o.key)}:{...o,key:n};return null!=e&&(i.finisher=function(t){e(t,n);}),i}{const r=o.constructor;void 0!==t&&Object.defineProperty(o,n,t(n)),null==e||e(r,n);}};

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function e$a(e){return o$d({finisher:(r,t)=>{Object.assign(r.prototype[t],e);}})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function i$7(i,n){return o$d({descriptor:o=>{const t={get(){var o,n;return null!==(n=null===(o=this.renderRoot)||void 0===o?void 0:o.querySelector(i))&&void 0!==n?n:null},enumerable:!0,configurable:!0};if(n){const n="symbol"==typeof o?Symbol():"__"+o;t.get=function(){var o,t;return void 0===this[n]&&(this[n]=null!==(t=null===(o=this.renderRoot)||void 0===o?void 0:o.querySelector(i))&&void 0!==t?t:null),this[n]};}return t}})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function e$9(e){return o$d({descriptor:r=>({get(){var r,o;return null!==(o=null===(r=this.renderRoot)||void 0===r?void 0:r.querySelectorAll(e))&&void 0!==o?o:[]},enumerable:!0,configurable:!0})})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function e$8(e){return o$d({descriptor:r=>({async get(){var r;return await this.updateComplete,null===(r=this.renderRoot)||void 0===r?void 0:r.querySelector(e)},enumerable:!0,configurable:!0})})}

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */var n$8;const e$7=null!=(null===(n$8=window.HTMLSlotElement)||void 0===n$8?void 0:n$8.prototype.assignedElements)?(o,n)=>o.assignedElements(n):(o,n)=>o.assignedNodes(n).filter((o=>o.nodeType===Node.ELEMENT_NODE));function l$5(n){const{slot:l,selector:t}=null!=n?n:{};return o$d({descriptor:o=>({get(){var o;const r="slot"+(l?`[name=${l}]`:":not([name])"),i=null===(o=this.renderRoot)||void 0===o?void 0:o.querySelector(r),s=null!=i?e$7(i,n):[];return t?s.filter((o=>o.matches(t))):s},enumerable:!0,configurable:!0})})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */function o$c(o,n,r){let l,s=o;return "object"==typeof o?(s=o.slot,l=o):l={flatten:n},r?l$5({slot:s,flatten:n,selector:r}):o$d({descriptor:e=>({get(){var e,t;const o="slot"+(s?`[name=${s}]`:":not([name])"),n=null===(e=this.renderRoot)||void 0===e?void 0:e.querySelector(o);return null!==(t=null==n?void 0:n.assignedNodes(l))&&void 0!==t?t:[]},enumerable:!0,configurable:!0})})}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const t$5={ATTRIBUTE:1,CHILD:2,PROPERTY:3,BOOLEAN_ATTRIBUTE:4,EVENT:5,ELEMENT:6},e$6=t=>(...e)=>({_$litDirective$:t,values:e});class i$6{constructor(t){}get _$AU(){return this._$AM._$AU}_$AT(t,e,i){this._$Ct=t,this._$AM=e,this._$Ci=i;}_$AS(t,e){return this.update(t,e)}update(t,e){return this.render(...e)}}

/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const{I:l$4}=j$1,i$5=o=>null===o||"object"!=typeof o&&"function"!=typeof o,n$7={HTML:1,SVG:2},t$4=(o,l)=>void 0===l?void 0!==(null==o?void 0:o._$litType$):(null==o?void 0:o._$litType$)===l,v$1=o=>{var l;return null!=(null===(l=null==o?void 0:o._$litType$)||void 0===l?void 0:l.h)},d$2=o=>void 0!==(null==o?void 0:o._$litDirective$),u$2=o=>null==o?void 0:o._$litDirective$,e$5=o=>void 0===o.strings,r$3=()=>document.createComment(""),c$5=(o,i,n)=>{var t;const v=o._$AA.parentNode,d=void 0===i?o._$AB:i._$AA;if(void 0===n){const i=v.insertBefore(r$3(),d),t=v.insertBefore(r$3(),d);n=new l$4(i,t,o,o.options);}else {const l=n._$AB.nextSibling,i=n._$AM,u=i!==o;if(u){let l;null===(t=n._$AQ)||void 0===t||t.call(n,o),n._$AM=o,void 0!==n._$AP&&(l=o._$AU)!==i._$AU&&n._$AP(l);}if(l!==d||u){let o=n._$AA;for(;o!==l;){const l=o.nextSibling;v.insertBefore(o,d),o=l;}}}return n},f$3=(o,l,i=o)=>(o._$AI(l,i),o),s$3={},a$1=(o,l=s$3)=>o._$AH=l,m$2=o=>o._$AH,p$1=o=>{var l;null===(l=o._$AP)||void 0===l||l.call(o,!1,!0);let i=o._$AA;const n=o._$AB.nextSibling;for(;i!==n;){const o=i.nextSibling;i.remove(),i=o;}},h$6=o=>{o._$AR();};

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const s$2=(i,t)=>{var e,o;const r=i._$AN;if(void 0===r)return !1;for(const i of r)null===(o=(e=i)._$AO)||void 0===o||o.call(e,t,!1),s$2(i,t);return !0},o$b=i=>{let t,e;do{if(void 0===(t=i._$AM))break;e=t._$AN,e.delete(i),i=t;}while(0===(null==e?void 0:e.size))},r$2=i=>{for(let t;t=i._$AM;i=t){let e=t._$AN;if(void 0===e)t._$AN=e=new Set;else if(e.has(i))break;e.add(i),l$3(t);}};function n$6(i){void 0!==this._$AN?(o$b(this),this._$AM=i,r$2(this)):this._$AM=i;}function h$5(i,t=!1,e=0){const r=this._$AH,n=this._$AN;if(void 0!==n&&0!==n.size)if(t)if(Array.isArray(r))for(let i=e;i<r.length;i++)s$2(r[i],!1),o$b(r[i]);else null!=r&&(s$2(r,!1),o$b(r));else s$2(this,i);}const l$3=i=>{var t,s,o,r;i.type==t$5.CHILD&&(null!==(t=(o=i)._$AP)&&void 0!==t||(o._$AP=h$5),null!==(s=(r=i)._$AQ)&&void 0!==s||(r._$AQ=n$6));};class c$4 extends i$6{constructor(){super(...arguments),this._$AN=void 0;}_$AT(i,t,e){super._$AT(i,t,e),r$2(this),this.isConnected=i._$AU;}_$AO(i,t=!0){var e,r;i!==this.isConnected&&(this.isConnected=i,i?null===(e=this.reconnected)||void 0===e||e.call(this):null===(r=this.disconnected)||void 0===r||r.call(this)),t&&(s$2(this,i),o$b(this));}setValue(t){if(e$5(this._$Ct))this._$Ct._$AI(t,this);else {const i=[...this._$Ct._$AH];i[this._$Ci]=t,this._$Ct._$AI(i,this,0);}}disconnected(){}reconnected(){}}

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const t$3=async(t,s)=>{for await(const i of t)if(!1===await s(i))return};class s$1{constructor(t){this.G=t;}disconnect(){this.G=void 0;}reconnect(t){this.G=t;}deref(){return this.G}}class i$4{constructor(){this.Y=void 0,this.Z=void 0;}get(){return this.Y}pause(){var t;null!==(t=this.Y)&&void 0!==t||(this.Y=new Promise((t=>this.Z=t)));}resume(){var t;null===(t=this.Z)||void 0===t||t.call(this),this.Y=this.Z=void 0;}}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */class o$a extends c$4{constructor(){super(...arguments),this._$Cq=new s$1(this),this._$CK=new i$4;}render(i,s){return T$1}update(i,[s,r]){if(this.isConnected||this.disconnected(),s===this._$CX)return;this._$CX=s;let n=0;const{_$Cq:o,_$CK:h}=this;return t$3(s,(async t=>{for(;h.get();)await h.get();const i=o.deref();if(void 0!==i){if(i._$CX!==s)return !1;void 0!==r&&(t=r(t,n)),i.commitValue(t,n),n++;}return !0})),T$1}commitValue(t,i){this.setValue(t);}disconnected(){this._$Cq.disconnect(),this._$CK.pause();}reconnected(){this._$Cq.reconnect(this),this._$CK.resume();}}const h$4=e$6(o$a);

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const c$3=e$6(class extends o$a{constructor(r){if(super(r),r.type!==t$5.CHILD)throw Error("asyncAppend can only be used in child expressions")}update(r,e){return this._$CJ=r,super.update(r,e)}commitValue(r,e){0===e&&h$6(this._$CJ);const s=c$5(this._$CJ);f$3(s,r);}});

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const d$1=t=>v$1(t)?t._$litType$.h:t.strings,h$3=e$6(class extends i$6{constructor(t){super(t),this.tt=new WeakMap;}render(t){return [t]}update(s,[e]){const u=t$4(this.et)?d$1(this.et):null,h=t$4(e)?d$1(e):null;if(null!==u&&(null===h||u!==h)){const e=m$2(s).pop();let o=this.tt.get(u);if(void 0===o){const s=document.createDocumentFragment();o=D$1(A$1,s),o.setConnected(!1),this.tt.set(u,o);}a$1(o,[e]),c$5(o,void 0,e);}if(null!==h){if(null===u||u!==h){const t=this.tt.get(h);if(void 0!==t){const i=m$2(t).pop();h$6(s),c$5(s,void 0,i),a$1(s,[i]);}}this.et=e;}else this.et=void 0;return this.render(e)}});

/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const o$9=e$6(class extends i$6{constructor(t){var i;if(super(t),t.type!==t$5.ATTRIBUTE||"class"!==t.name||(null===(i=t.strings)||void 0===i?void 0:i.length)>2)throw Error("`classMap()` can only be used in the `class` attribute and must be the only part in the attribute.")}render(t){return " "+Object.keys(t).filter((i=>t[i])).join(" ")+" "}update(i,[s]){var r,o;if(void 0===this.it){this.it=new Set,void 0!==i.strings&&(this.nt=new Set(i.strings.join(" ").split(/\s/).filter((t=>""!==t))));for(const t in s)s[t]&&!(null===(r=this.nt)||void 0===r?void 0:r.has(t))&&this.it.add(t);return this.render(s)}const e=i.element.classList;this.it.forEach((t=>{t in s||(e.remove(t),this.it.delete(t));}));for(const t in s){const i=!!s[t];i===this.it.has(t)||(null===(o=this.nt)||void 0===o?void 0:o.has(t))||(i?(e.add(t),this.it.add(t)):(e.remove(t),this.it.delete(t)));}return T$1}});

/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const e$4={},i$3=e$6(class extends i$6{constructor(){super(...arguments),this.st=e$4;}render(r,t){return t()}update(t,[s,e]){if(Array.isArray(s)){if(Array.isArray(this.st)&&this.st.length===s.length&&s.every(((r,t)=>r===this.st[t])))return T$1}else if(this.st===s)return T$1;return this.st=Array.isArray(s)?Array.from(s):s,this.render(s,e)}});

/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const l$2=l=>null!=l?l:A$1;

/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const l$1=e$6(class extends i$6{constructor(r){if(super(r),r.type!==t$5.PROPERTY&&r.type!==t$5.ATTRIBUTE&&r.type!==t$5.BOOLEAN_ATTRIBUTE)throw Error("The `live` directive is not allowed on child or event bindings");if(!e$5(r))throw Error("`live` bindings can only contain a single expression")}render(r){return r}update(i,[t]){if(t===T$1||t===A$1)return t;const o=i.element,l=i.name;if(i.type===t$5.PROPERTY){if(t===o[l])return T$1}else if(i.type===t$5.BOOLEAN_ATTRIBUTE){if(!!t===o.hasAttribute(l))return T$1}else if(i.type===t$5.ATTRIBUTE&&o.getAttribute(l)===t+"")return T$1;return a$1(i),t}});

/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const e$3=()=>new o$8;class o$8{}const h$2=new WeakMap,n$5=e$6(class extends c$4{render(t){return A$1}update(t,[s]){var e;const o=s!==this.G;return o&&void 0!==this.G&&this.ot(void 0),(o||this.rt!==this.lt)&&(this.G=s,this.dt=null===(e=t.options)||void 0===e?void 0:e.host,this.ot(this.lt=t.element)),A$1}ot(i){var t;if("function"==typeof this.G){const s=null!==(t=this.dt)&&void 0!==t?t:globalThis;let e=h$2.get(s);void 0===e&&(e=new WeakMap,h$2.set(s,e)),void 0!==e.get(this.G)&&this.G.call(this.dt,void 0),e.set(this.G,i),void 0!==i&&this.G.call(this.dt,i);}else this.G.value=i;}get rt(){var i,t,s;return "function"==typeof this.G?null===(t=h$2.get(null!==(i=this.dt)&&void 0!==i?i:globalThis))||void 0===t?void 0:t.get(this.G):null===(s=this.G)||void 0===s?void 0:s.value}disconnected(){this.rt===this.lt&&this.ot(void 0);}reconnected(){this.ot(this.lt);}});

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const u$1=(e,s,t)=>{const r=new Map;for(let l=s;l<=t;l++)r.set(e[l],l);return r},c$2=e$6(class extends i$6{constructor(e){if(super(e),e.type!==t$5.CHILD)throw Error("repeat() can only be used in text expressions")}ct(e,s,t){let r;void 0===t?t=s:void 0!==s&&(r=s);const l=[],o=[];let i=0;for(const s of e)l[i]=r?r(s,i):i,o[i]=t(s,i),i++;return {values:o,keys:l}}render(e,s,t){return this.ct(e,s,t).values}update(s,[t,r,c]){var d;const a=m$2(s),{values:p,keys:v}=this.ct(t,r,c);if(!Array.isArray(a))return this.ut=v,p;const h=null!==(d=this.ut)&&void 0!==d?d:this.ut=[],m=[];let y,x,j=0,k=a.length-1,w=0,A=p.length-1;for(;j<=k&&w<=A;)if(null===a[j])j++;else if(null===a[k])k--;else if(h[j]===v[w])m[w]=f$3(a[j],p[w]),j++,w++;else if(h[k]===v[A])m[A]=f$3(a[k],p[A]),k--,A--;else if(h[j]===v[A])m[A]=f$3(a[j],p[A]),c$5(s,m[A+1],a[j]),j++,A--;else if(h[k]===v[w])m[w]=f$3(a[k],p[w]),c$5(s,a[j],a[k]),k--,w++;else if(void 0===y&&(y=u$1(v,w,A),x=u$1(h,j,k)),y.has(h[j]))if(y.has(h[k])){const e=x.get(v[w]),t=void 0!==e?a[e]:null;if(null===t){const e=c$5(s,a[j]);f$3(e,p[w]),m[w]=e;}else m[w]=f$3(t,p[w]),c$5(s,a[j],t),a[e]=null;w++;}else p$1(a[k]),k--;else p$1(a[j]),j++;for(;w<=A;){const e=c$5(s,m[A+1]);f$3(e,p[w]),m[w++]=e;}for(;j<=k;){const e=a[j++];null!==e&&p$1(e);}return this.ut=v,a$1(s,m),T$1}});

/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const i$2="important",n$4=" !"+i$2,o$7=e$6(class extends i$6{constructor(t){var e;if(super(t),t.type!==t$5.ATTRIBUTE||"style"!==t.name||(null===(e=t.strings)||void 0===e?void 0:e.length)>2)throw Error("The `styleMap` directive must be used in the `style` attribute and must be the only part in the attribute.")}render(t){return Object.keys(t).reduce(((e,r)=>{const s=t[r];return null==s?e:e+`${r=r.includes("-")?r:r.replace(/(?:^(webkit|moz|ms|o)|)(?=[A-Z])/g,"-$&").toLowerCase()}:${s};`}),"")}update(e,[r]){const{style:s}=e.element;if(void 0===this.ht){this.ht=new Set;for(const t in r)this.ht.add(t);return this.render(r)}this.ht.forEach((t=>{null==r[t]&&(this.ht.delete(t),t.includes("-")?s.removeProperty(t):s[t]="");}));for(const t in r){const e=r[t];if(null!=e){this.ht.add(t);const r="string"==typeof e&&e.endsWith(n$4);t.includes("-")||r?s.setProperty(t,r?e.slice(0,-11):e,r?i$2:""):s[t]=e;}}return T$1}});

/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const o$6=e$6(class extends i$6{constructor(t){if(super(t),t.type!==t$5.CHILD)throw Error("templateContent can only be used in child bindings")}render(r){return this.vt===r?T$1:(this.vt=r,document.importNode(r.content,!0))}});

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */class e$2 extends i$6{constructor(i){if(super(i),this.et=A$1,i.type!==t$5.CHILD)throw Error(this.constructor.directiveName+"() can only be used in child bindings")}render(r){if(r===A$1||null==r)return this.ft=void 0,this.et=r;if(r===T$1)return r;if("string"!=typeof r)throw Error(this.constructor.directiveName+"() called with a non-string value");if(r===this.et)return this.ft;this.et=r;const s=[r];return s.raw=s,this.ft={_$litType$:this.constructor.resultType,strings:s,values:[]}}}e$2.directiveName="unsafeHTML",e$2.resultType=1;const o$5=e$6(e$2);

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */class t$2 extends e$2{}t$2.directiveName="unsafeSVG",t$2.resultType=2;const o$4=e$6(t$2);

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const n$3=t=>!i$5(t)&&"function"==typeof t.then,h$1=1073741823;class c$1 extends c$4{constructor(){super(...arguments),this._$C_t=h$1,this._$Cwt=[],this._$Cq=new s$1(this),this._$CK=new i$4;}render(...s){var i;return null!==(i=s.find((t=>!n$3(t))))&&void 0!==i?i:T$1}update(s,i){const r=this._$Cwt;let e=r.length;this._$Cwt=i;const o=this._$Cq,c=this._$CK;this.isConnected||this.disconnected();for(let t=0;t<i.length&&!(t>this._$C_t);t++){const s=i[t];if(!n$3(s))return this._$C_t=t,s;t<e&&s===r[t]||(this._$C_t=h$1,e=0,Promise.resolve(s).then((async t=>{for(;c.get();)await c.get();const i=o.deref();if(void 0!==i){const r=i._$Cwt.indexOf(s);r>-1&&r<i._$C_t&&(i._$C_t=r,i.setValue(t));}})));}return T$1}disconnected(){this._$Cq.disconnect(),this._$CK.pause();}reconnected(){this._$Cq.reconnect(this),this._$CK.resume();}}const m$1=e$6(c$1);

(function(){
/*

 Copyright (c) 2020 The Polymer Project Authors. All rights reserved.
 This code may only be used under the BSD style license found at
 http://polymer.github.io/LICENSE.txt
 The complete set of authors may be found at
 http://polymer.github.io/AUTHORS.txt
 The complete set of contributors may be found at
 http://polymer.github.io/CONTRIBUTORS.txt
 Code distributed by Google as part of the polymer project is also
 subject to an additional IP rights grant found at
 http://polymer.github.io/PATENTS.txt
*/
'use strict';function g(a){var b=0;return function(){return b<a.length?{done:!1,value:a[b++]}:{done:!0}}}
if(!ShadowRoot.prototype.createElement){var h=window.HTMLElement,l=window.customElements.define,m=window.customElements.get,n=window.customElements,p=new WeakMap,q=new WeakMap,r=new WeakMap,t=new WeakMap;window.CustomElementRegistry=function(){this.l=new Map;this.o=new Map;this.i=new Map;this.h=new Map;};window.CustomElementRegistry.prototype.define=function(a,b){a=a.toLowerCase();if(void 0!==this.j(a))throw new DOMException("Failed to execute 'define' on 'CustomElementRegistry': the name \""+a+'" has already been used with this registry');
if(void 0!==this.o.get(b))throw new DOMException("Failed to execute 'define' on 'CustomElementRegistry': this constructor has already been used with this registry");var c=b.prototype.attributeChangedCallback,d=new Set(b.observedAttributes||[]);u(b,d,c);c={g:b,connectedCallback:b.prototype.connectedCallback,disconnectedCallback:b.prototype.disconnectedCallback,adoptedCallback:b.prototype.adoptedCallback,attributeChangedCallback:c,observedAttributes:d};this.l.set(a,c);this.o.set(b,c);d=m.call(n,a);
d||(d=v(a),l.call(n,a,d));this===window.customElements&&(r.set(b,c),c.s=d);if(d=this.h.get(a)){this.h.delete(a);var e="undefined"!=typeof Symbol&&Symbol.iterator&&d[Symbol.iterator];d=e?e.call(d):{next:g(d)};for(e=d.next();!e.done;e=d.next())e=e.value,q.delete(e),w(e,c,!0);}c=this.i.get(a);void 0!==c&&(c.resolve(b),this.i.delete(a));return b};window.CustomElementRegistry.prototype.upgrade=function(){x.push(this);n.upgrade.apply(n,arguments);x.pop();};window.CustomElementRegistry.prototype.get=function(a){var b;
return null==(b=this.l.get(a))?void 0:b.g};window.CustomElementRegistry.prototype.j=function(a){return this.l.get(a)};window.CustomElementRegistry.prototype.whenDefined=function(a){var b=this.j(a);if(void 0!==b)return Promise.resolve(b.g);var c=this.i.get(a);void 0===c&&(c={},c.promise=new Promise(function(d){return c.resolve=d}),this.i.set(a,c));return c.promise};window.CustomElementRegistry.prototype.m=function(a,b,c){var d=this.h.get(b);d||this.h.set(b,d=new Set);c?d.add(a):d.delete(a);};var y;
window.HTMLElement=function(){var a=y;if(a)return y=void 0,a;var b=r.get(this.constructor);if(!b)throw new TypeError("Illegal constructor (custom element class must be registered with global customElements registry to be newable)");a=Reflect.construct(h,[],b.s);Object.setPrototypeOf(a,this.constructor.prototype);p.set(a,b);return a};window.HTMLElement.prototype=h.prototype;var v=function(a){function b(){var c=Reflect.construct(h,[],this.constructor);Object.setPrototypeOf(c,HTMLElement.prototype);
a:{var d=c.getRootNode();if(!(d===document||d instanceof ShadowRoot)){d=x[x.length-1];if(d instanceof CustomElementRegistry){var e=d;break a}d=d.getRootNode();d===document||d instanceof ShadowRoot||(d=(null==(e=t.get(d))?void 0:e.getRootNode())||document);}e=d.customElements;}e=e||window.customElements;(d=e.j(a))?w(c,d):q.set(c,e);return c}b.prototype.connectedCallback=function(){var c=p.get(this);c?c.connectedCallback&&c.connectedCallback.apply(this,arguments):q.get(this).m(this,a,!0);};b.prototype.disconnectedCallback=
function(){var c=p.get(this);c?c.disconnectedCallback&&c.disconnectedCallback.apply(this,arguments):q.get(this).m(this,a,!1);};b.prototype.adoptedCallback=function(){var c,d;null==(c=p.get(this))||null==(d=c.adoptedCallback)||d.apply(this,arguments);};return b},u=function(a,b,c){if(0!==b.size&&void 0!==c){var d=a.prototype.setAttribute;d&&(a.prototype.setAttribute=function(f,k){if(b.has(f)){var C=this.getAttribute(f);d.call(this,f,k);c.call(this,f,C,k);}else d.call(this,f,k);});var e=a.prototype.removeAttribute;
e&&(a.prototype.removeAttribute=function(f){if(b.has(f)){var k=this.getAttribute(f);e.call(this,f);c.call(this,f,k,null);}else e.call(this,f);});}},z=function(a){var b=Object.getPrototypeOf(a);if(b!==window.HTMLElement)return b===h?Object.setPrototypeOf(a,window.HTMLElement):z(b)},w=function(a,b,c){c=void 0===c?!1:c;Object.setPrototypeOf(a,b.g.prototype);p.set(a,b);y=a;try{new b.g;}catch(d){z(b.g),new b.g;}b.observedAttributes.forEach(function(d){a.hasAttribute(d)&&b.attributeChangedCallback.call(a,d,
null,a.getAttribute(d));});c&&b.connectedCallback&&a.isConnected&&b.connectedCallback.call(a);},A=Element.prototype.attachShadow;Element.prototype.attachShadow=function(a){var b=A.apply(this,arguments);a.customElements&&(b.customElements=a.customElements);return b};var x=[document],B=function(a,b,c){var d=(c?Object.getPrototypeOf(c):a.prototype)[b];a.prototype[b]=function(){x.push(this);var e=d.apply(c||this,arguments);void 0!==e&&t.set(e,this);x.pop();return e};};B(ShadowRoot,"createElement",document);
B(ShadowRoot,"importNode",document);B(Element,"insertAdjacentHTML");var D=function(a){var b=Object.getOwnPropertyDescriptor(a.prototype,"innerHTML");Object.defineProperty(a.prototype,"innerHTML",Object.assign({},b,{set:function(c){x.push(this);b.set.call(this,c);x.pop();}}));};D(Element);D(ShadowRoot);Object.defineProperty(window,"customElements",{value:new CustomElementRegistry,configurable:!0,writable:!0});};
}).call(self);

const appliedClassMixins = new WeakMap();

/** Vefify if the Mixin was previously applyed
 * @private
 * @param {function} mixin      Mixin being applyed
 * @param {object} superClass   Class receiving the new mixin
 * @returns {boolean}
 */
function wasMixinPreviouslyApplied(mixin, superClass) {
  let klass = superClass;
  while (klass) {
    if (appliedClassMixins.get(klass) === mixin) {
      return true;
    }
    klass = Object.getPrototypeOf(klass);
  }
  return false;
}

/** Apply each mixin in the chain to make sure they are not applied more than once to the final class.
 * @export
 * @param {function} mixin      Mixin to be applyed
 * @returns {object}            Mixed class with mixin applied
 */
function dedupeMixin(mixin) {
  return superClass => {
    if (wasMixinPreviouslyApplied(mixin, superClass)) {
      return superClass;
    }
    const mixedClass = mixin(superClass);
    appliedClassMixins.set(mixedClass, mixin);
    return mixedClass;
  };
}

/**
 * @typedef {import('./types').RenderOptions} RenderOptions
 * @typedef {import('./types').ScopedElementsMixin} ScopedElementsMixin
 * @typedef {import('./types').ScopedElementsHost} ScopedElementsHost
 * @typedef {import('./types').ScopedElementsMap} ScopedElementsMap
 * @typedef {import('@lit/reactive-element').CSSResultOrNative} CSSResultOrNative
 */

/**
 * @template {import('./types').Constructor<HTMLElement>} T
 * @param {T} superclass
 * @return {T & import('./types').Constructor<ScopedElementsHost>}
 */
const ScopedElementsMixinImplementation = superclass =>
  /** @type {ScopedElementsHost} */
  class ScopedElementsHost extends superclass {
    /**
     * Obtains the scoped elements definitions map if specified.
     *
     * @returns {ScopedElementsMap}
     */
    static get scopedElements() {
      return {};
    }

    /**
     * Obtains the ShadowRoot options.
     *
     * @type {ShadowRootInit}
     */
    static get shadowRootOptions() {
      return this.__shadowRootOptions;
    }

    /**
     * Set the shadowRoot options.
     *
     * @param {ShadowRootInit} value
     */
    static set shadowRootOptions(value) {
      this.__shadowRootOptions = value;
    }

    /**
     * Obtains the element styles.
     *
     * @returns {CSSResultOrNative[]}
     */
    static get elementStyles() {
      return this.__elementStyles;
    }

    static set elementStyles(styles) {
      this.__elementStyles = styles;
    }

    // either TS or ESLint will complain here
    // eslint-disable-next-line no-unused-vars
    constructor(..._args) {
      super();
      /** @type {RenderOptions} */
      this.renderOptions = this.renderOptions || undefined;
    }

    /**
     * Obtains the CustomElementRegistry associated to the ShadowRoot.
     *
     * @returns {CustomElementRegistry}
     */
    get registry() {
      // @ts-ignore
      return this.constructor.__registry;
    }

    /**
     * Set the CustomElementRegistry associated to the ShadowRoot
     *
     * @param {CustomElementRegistry} registry
     */
    set registry(registry) {
      // @ts-ignore
      this.constructor.__registry = registry;
    }

    /** @override */
    createRenderRoot() {
      const {
        scopedElements,
        shadowRootOptions,
        elementStyles,
      } = /** @type {typeof ScopedElementsHost} */ (this.constructor);

      if (!this.registry) {
        this.registry = new CustomElementRegistry();

        Object.entries(scopedElements).forEach(([tagName, klass]) =>
          this.registry.define(tagName, klass),
        );
      }

      /** @type {ShadowRootInit} */
      const options = {
        mode: 'open',
        ...shadowRootOptions,
        customElements: this.registry,
      };

      this.renderOptions.creationScope = this.attachShadow(options);

      if (this.renderOptions.creationScope instanceof ShadowRoot) {
        S$2(this.renderOptions.creationScope, elementStyles);

        this.renderOptions.renderBefore =
          this.renderOptions.renderBefore || this.renderOptions.creationScope.firstChild;
      }

      return this.renderOptions.creationScope;
    }

    /**
     * Defines a scoped element.
     *
     * @param {string} tagName
     * @param {typeof HTMLElement} klass
     */
    defineScopedElement(tagName, klass) {
      return this.registry.get(tagName) || this.registry.define(tagName, klass);
    }

    /**
     * @deprecated use the native el.tagName instead
     *
     * @param {string} tagName
     * @returns {string} the tag name
     */
    // eslint-disable-next-line class-methods-use-this
    getScopedTagName(tagName) {
      return tagName;
    }

    /**
     * @deprecated use the native el.tagName instead
     *
     * @param {string} tagName
     * @returns {string} the tag name
     */
    // eslint-disable-next-line class-methods-use-this
    static getScopedTagName(tagName) {
      return tagName;
    }
  };

const ScopedElementsMixin = dedupeMixin(ScopedElementsMixinImplementation);

/** @typedef {import('./src/types').ScopedElementsMap} ScopedElementsMap */

/* eslint-disable class-methods-use-this */

/**
 * @typedef {import('../types/DelegateMixinTypes').DelegateMixin} DelegateMixin
 */

/**
 * @typedef DelegateEvent
 * @property {string} type - Type of event
 * @property {(event: Event) => unknown} handler - Event arguments
 * @property {boolean | AddEventListenerOptions} [opts]
 */

/**
 * @type {DelegateMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('../index').LitElement>} superclass
 */
const DelegateMixinImplementation = superclass =>
  // eslint-disable-next-line
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends superclass {
    constructor() {
      super();

      /**
       * @type {DelegateEvent[]}
       * @private
       */
      this.__eventsQueue = [];

      /**
       * @type {Object.<string,?>}
       * @private
       */
      this.__propertiesQueue = {};
      /** @private */
      this.__setupPropertyDelegation();
    }

    /**
     * @returns {{target: Function, events: string[], methods: string[], properties: string[], attributes: string[]}}
     */
    get delegations() {
      return {
        target: () => {},
        events: [],
        methods: [],
        properties: [],
        attributes: [],
      };
    }

    connectedCallback() {
      super.connectedCallback();
      this._connectDelegateMixin();
    }

    /** @param {import('lit-element').PropertyValues } changedProperties */
    updated(changedProperties) {
      super.updated(changedProperties);
      this._connectDelegateMixin();
    }

    /**
     * @param {string} type
     * @param {(event: Event) => unknown} handler
     * @param {boolean | AddEventListenerOptions} [opts]
     */
    addEventListener(type, handler, opts) {
      const delegatedEvents = this.delegations.events;
      if (delegatedEvents.indexOf(type) > -1) {
        if (this.delegationTarget) {
          this.delegationTarget.addEventListener(type, handler, opts);
        } else {
          this.__eventsQueue.push({ type, handler });
        }
      } else {
        super.addEventListener(type, handler, opts);
      }
    }

    /**
     * @param {string} name
     * @param {string} value
     */
    setAttribute(name, value) {
      const attributeNames = this.delegations.attributes;
      if (attributeNames.indexOf(name) > -1) {
        if (this.delegationTarget) {
          this.delegationTarget.setAttribute(name, value);
        }
        super.removeAttribute(name);
      } else {
        super.setAttribute(name, value);
      }
    }

    /**
     * @param {string} name
     */
    removeAttribute(name) {
      const attributeNames = this.delegations.attributes;
      if (attributeNames.indexOf(name) > -1) {
        if (this.delegationTarget) {
          this.delegationTarget.removeAttribute(name);
        }
      }
      super.removeAttribute(name);
    }

    /**
     * @protected
     */
    _connectDelegateMixin() {
      if (this.__connectedDelegateMixin) return;

      if (!this.delegationTarget) {
        this.delegationTarget = this.delegations.target();
      }

      if (this.delegationTarget) {
        this.__emptyEventListenerQueue();
        this.__emptyPropertiesQueue();
        this.__initialAttributeDelegation();

        this.__connectedDelegateMixin = true;
      }
    }

    /**
     * @private
     */
    __setupPropertyDelegation() {
      const propertyNames = this.delegations.properties.concat(this.delegations.methods);
      propertyNames.forEach(propertyName => {
        Object.defineProperty(this, propertyName, {
          get() {
            const target = this.delegationTarget;
            if (target) {
              if (typeof target[propertyName] === 'function') {
                return target[propertyName].bind(target);
              }
              return target[propertyName];
            }
            if (this.__propertiesQueue[propertyName]) {
              return this.__propertiesQueue[propertyName];
            }
            // This is the moment the attribute is not delegated (and thus removed) yet.
            // and the property is not set, but the attribute is (it serves as a fallback for
            // __propertiesQueue).
            return this.getAttribute(propertyName);
          },
          set(newValue) {
            if (this.delegationTarget) {
              const oldValue = this.delegationTarget[propertyName];
              this.delegationTarget[propertyName] = newValue;
              // connect with observer system if available
              if (typeof this.triggerObserversFor === 'function') {
                this.triggerObserversFor(propertyName, newValue, oldValue);
              }
            } else {
              this.__propertiesQueue[propertyName] = newValue;
            }
          },
        });
      });
    }

    /**
     * @private
     */
    __initialAttributeDelegation() {
      const attributeNames = this.delegations.attributes;
      attributeNames.forEach(attributeName => {
        const attributeValue = this.getAttribute(attributeName);
        if (typeof attributeValue === 'string') {
          this.delegationTarget.setAttribute(attributeName, attributeValue);
          super.removeAttribute(attributeName);
        }
      });
    }

    /**
     * @private
     */
    __emptyEventListenerQueue() {
      this.__eventsQueue.forEach(ev => {
        this.delegationTarget.addEventListener(ev.type, ev.handler, ev.opts);
      });
    }

    /**
     * @private
     */
    __emptyPropertiesQueue() {
      Object.keys(this.__propertiesQueue).forEach(propName => {
        this.delegationTarget[propName] = this.__propertiesQueue[propName];
      });
    }
  };

const DelegateMixin = dedupeMixin(DelegateMixinImplementation);

/**
 * @typedef {import('../types/DisabledMixinTypes').DisabledMixin} DisabledMixin
 */

/**
 * @type {DisabledMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('../index').LitElement>} superclass
 */
const DisabledMixinImplementation = superclass =>
  // eslint-disable-next-line no-shadow
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends superclass {
    static get properties() {
      return {
        disabled: {
          type: Boolean,
          reflect: true,
        },
      };
    }

    constructor() {
      super();
      /** @protected */
      this._requestedToBeDisabled = false;
      /** @private */
      this.__isUserSettingDisabled = true;
      /** @private */
      this.__restoreDisabledTo = false;
      this.disabled = false;
    }

    makeRequestToBeDisabled() {
      if (this._requestedToBeDisabled === false) {
        this._requestedToBeDisabled = true;
        this.__restoreDisabledTo = this.disabled;
        this.__internalSetDisabled(true);
      }
    }

    retractRequestToBeDisabled() {
      if (this._requestedToBeDisabled === true) {
        this._requestedToBeDisabled = false;
        this.__internalSetDisabled(this.__restoreDisabledTo);
      }
    }

    /**
     * @param {boolean} value
     * @private
     */
    __internalSetDisabled(value) {
      this.__isUserSettingDisabled = false;
      this.disabled = value;
      this.__isUserSettingDisabled = true;
    }

    /**
     * @param {PropertyKey} name
     * @param {?} oldValue
     */
    requestUpdate(name, oldValue) {
      super.requestUpdate(name, oldValue);
      if (name === 'disabled') {
        if (this.__isUserSettingDisabled) {
          this.__restoreDisabledTo = this.disabled;
        }
        if (this.disabled === false && this._requestedToBeDisabled === true) {
          this.__internalSetDisabled(true);
        }
      }
    }
  };

const DisabledMixin = dedupeMixin(DisabledMixinImplementation);

/**
 * @typedef {import('../types/DisabledWithTabIndexMixinTypes').DisabledWithTabIndexMixin} DisabledWithTabIndexMixin
 */

/**
 * @type {DisabledWithTabIndexMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('../index').LitElement>} superclass
 */
const DisabledWithTabIndexMixinImplementation = superclass =>
  // eslint-disable-next-line no-shadow
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends DisabledMixin(superclass) {
    static get properties() {
      return {
        // we use a property here as if we use the native tabIndex we can not set a default value
        // in the constructor as it synchronously sets the attribute which is not allowed in the
        // constructor phase
        tabIndex: {
          type: Number,
          reflect: true,
          attribute: 'tabindex',
        },
      };
    }

    constructor() {
      super();
      /** @private */
      this.__isUserSettingTabIndex = true;
      /** @private */
      this.__restoreTabIndexTo = 0;
      this.__internalSetTabIndex(0);
    }

    makeRequestToBeDisabled() {
      super.makeRequestToBeDisabled();
      if (this._requestedToBeDisabled === false && this.tabIndex != null) {
        this.__restoreTabIndexTo = this.tabIndex;
      }
    }

    retractRequestToBeDisabled() {
      super.retractRequestToBeDisabled();
      if (this._requestedToBeDisabled === true) {
        this.__internalSetTabIndex(this.__restoreTabIndexTo);
      }
    }

    /**
     * @param {number} value
     * @private
     */
    __internalSetTabIndex(value) {
      this.__isUserSettingTabIndex = false;
      this.tabIndex = value;
      this.__isUserSettingTabIndex = true;
    }

    /**
     * @param {PropertyKey} name
     * @param {?} oldValue
     */
    requestUpdate(name, oldValue) {
      super.requestUpdate(name, oldValue);

      if (name === 'disabled') {
        if (this.disabled) {
          this.__internalSetTabIndex(-1);
        } else {
          this.__internalSetTabIndex(this.__restoreTabIndexTo);
        }
      }

      if (name === 'tabIndex') {
        if (this.__isUserSettingTabIndex && this.tabIndex != null) {
          this.__restoreTabIndexTo = this.tabIndex;
        }

        if (this.tabIndex !== -1 && this._requestedToBeDisabled === true) {
          this.__internalSetTabIndex(-1);
        }
      }
    }

    /** @param {import('lit-element').PropertyValues } changedProperties */
    firstUpdated(changedProperties) {
      super.firstUpdated(changedProperties);
      // for ShadyDom the timing is a little different and we need to make sure
      // the tabindex gets correctly updated here
      if (this.disabled) {
        this.__internalSetTabIndex(-1);
      }
    }
  };

const DisabledWithTabIndexMixin = dedupeMixin(DisabledWithTabIndexMixinImplementation);

/**
 * @typedef {import('lit').ReactiveControllerHost} ReactiveControllerHost
 * @typedef {import('lit').ReactiveController} ReactiveController
 * @implements {ReactiveController}
 */
class ScopedStylesController {
  /**
   * @param {import('lit').CSSResult} scope
   * @return {import('lit').CSSResultGroup}
   */
  // eslint-disable-next-line no-unused-vars
  static scopedStyles(scope) {
    return i$b``;
  }

  /**
   * @param {ReactiveControllerHost & import('lit').LitElement} host
   */
  constructor(host) {
    (this.host = host).addController(this);
    // Perhaps use constructable stylesheets instead once Safari supports replace(Sync) methods
    this.__styleTag = document.createElement('style');
    this.scopedClass = `${this.host.localName}-${Math.floor(Math.random() * 10000)}`;
  }

  hostConnected() {
    this.host.classList.add(this.scopedClass);
    this.__setupStyleTag();
  }

  hostDisconnected() {
    this.__teardownStyleTag();
  }

  __setupStyleTag() {
    this.__styleTag.textContent = /** @type {typeof ScopedStylesController} */ (
      this.host.constructor
    )
      .scopedStyles(r$7(this.scopedClass))
      .toString();
    this.host.insertBefore(this.__styleTag, this.host.childNodes[0]);
  }

  __teardownStyleTag() {
    this.host.removeChild(this.__styleTag);
  }
}

/* eslint-disable class-methods-use-this */

/**
 * @typedef {import('../types/SlotMixinTypes').SlotMixin} SlotMixin
 * @typedef {import('../types/SlotMixinTypes').SlotsMap} SlotsMap
 * @typedef {import('../index').LitElement} LitElement
 */

/**
 * @type {SlotMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<LitElement>} superclass
 */
const SlotMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class SlotMixin extends superclass {
    /**
     * @return {SlotsMap}
     */
    get slots() {
      return {};
    }

    constructor() {
      super();
      /** @private */
      this.__privateSlots = new Set(null);
    }

    connectedCallback() {
      super.connectedCallback();
      this._connectSlotMixin();
    }

    /**
     * @private
     * @param {import('@lion/core').TemplateResult} template
     */
    __renderAsNodes(template) {
      const tempRenderTarget = document.createElement('div');
      D$1(template, tempRenderTarget, this.renderOptions);
      return Array.from(tempRenderTarget.childNodes);
    }

    /**
     * @protected
     */
    _connectSlotMixin() {
      if (!this.__isConnectedSlotMixin) {
        Object.keys(this.slots).forEach(slotName => {
          const hasSlottableFromUser =
            slotName === ''
              ? // for default slot (''), we can't use el.slot because polyfill for IE11
                // will do .querySelector('[slot=]') which produces a fatal error
                // therefore we check if there's children that do not have a slot attr
                Array.from(this.children).find(el => !el.hasAttribute('slot'))
              : Array.from(this.children).find(el => el.slot === slotName);

          if (!hasSlottableFromUser) {
            const slotContent = this.slots[slotName]();
            /** @type {Node[]} */
            let nodes = [];

            if (t$4(slotContent)) {
              nodes = this.__renderAsNodes(slotContent);
            } else if (!Array.isArray(slotContent)) {
              nodes = [/** @type {Node} */ (slotContent)];
            }

            nodes.forEach(node => {
              if (!(node instanceof Node)) {
                return;
              }
              if (node instanceof Element && slotName !== '') {
                node.setAttribute('slot', slotName);
              }
              this.appendChild(node);
              this.__privateSlots.add(slotName);
            });
          }
        });
        this.__isConnectedSlotMixin = true;
      }
    }

    /**
     * @param {string} slotName Name of the slot
     * @return {boolean} true if given slot name been created by SlotMixin
     * @protected
     */
    _isPrivateSlot(slotName) {
      return this.__privateSlots.has(slotName);
    }
  };

const SlotMixin = dedupeMixin(SlotMixinImplementation);

/* global ShadyCSS */

/**
 * @typedef {import('../types/UpdateStylesMixinTypes').UpdateStylesMixin} UpdateStylesMixin
 * @typedef {import('../types/UpdateStylesMixinTypes').StylesMap} StylesMap
 */

/**
 * @type {UpdateStylesMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<HTMLElement>} superclass
 */
const UpdateStylesMixinImplementation = superclass =>
  // eslint-disable-next-line no-shadow
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends superclass {
    /**
     * @example
     * <my-element>
     *     <style>
     *         :host {
     *          color: var(--foo);
     *         }
     *     </style>
     * </my-element>
     *
     * $0.updateStyles({'background': 'orange', '--foo': '#fff'})
     * Chrome, Firefox: <my-element style="background: orange; --foo: bar;">
     * IE: <my-element>
     *     => to head: <style>color: #fff</style>
     *
     * @param {StylesMap} updateStyles
     */
    updateStyles(updateStyles) {
      const styleString = this.getAttribute('style') || this.getAttribute('data-style') || '';

      /**
       * reducer function
       * @param {Object.<string, string>} acc
       * @param {string} stylePair
       */
      const reducer = (acc, stylePair) => {
        /** @type {Array.<string>} */
        const parts = stylePair.split(':');
        if (parts.length === 2) {
          // eslint-disable-next-line prefer-destructuring
          acc[parts[0]] = parts[1];
        }
        return acc;
      };
      const currentStyles = styleString.split(';').reduce(reducer, {});

      const newStyles = { ...currentStyles, ...updateStyles };
      let newStylesString = '';
      // @ts-ignore not sure how to type ShadyCSS..
      if (typeof ShadyCSS === 'object' && !ShadyCSS.nativeShadow) {
        // No ShadowDOM => IE, Edge

        /** @type {Object.<string, string>} */
        const newCssVariablesObj = {};

        Object.keys(newStyles).forEach(key => {
          if (key.indexOf('--') === -1) {
            newStylesString += `${key}:${newStyles[key]};`;
          } else {
            newCssVariablesObj[key] = newStyles[key];
          }
        });
        this.setAttribute('style', newStylesString);
        // @ts-ignore not sure how to type ShadyCSS..
        ShadyCSS.styleSubtree(this, newCssVariablesObj);
      } else {
        // has shadowdom => Chrome, Firefox, Safari
        Object.keys(newStyles).forEach(key => {
          newStylesString += `${key}: ${newStyles[key]};`;
        });
        this.setAttribute('style', newStylesString);
      }
    }
  };

const UpdateStylesMixin = dedupeMixin(UpdateStylesMixinImplementation);

/**
 * From https://stackoverflow.com/questions/4565112/javascript-how-to-find-out-if-the-user-browser-is-chrome
 * @param {string} [flavor]
 */
function checkChrome(flavor = 'google-chrome') {
  const isChromium = /** @type {window & { chrome?: boolean}} */ (window).chrome;
  if (flavor === 'chromium') {
    return isChromium;
  }
  const winNav = window.navigator;
  const vendorName = winNav.vendor;
  const isOpera = typeof (/** @type {window & { opr?: boolean}} */ (window).opr) !== 'undefined';
  const isIEedge = winNav.userAgent.indexOf('Edge') > -1;
  const isIOSChrome = winNav.userAgent.match('CriOS');

  if (flavor === 'ios') {
    return isIOSChrome;
  }

  if (flavor === 'google-chrome') {
    return (
      isChromium !== null &&
      typeof isChromium !== 'undefined' &&
      vendorName === 'Google Inc.' &&
      isOpera === false &&
      isIEedge === false
    );
  }

  return undefined;
}

const browserDetection = {
  isIE11: /Trident/.test(window.navigator.userAgent),
  isChrome: checkChrome(),
  isIOSChrome: checkChrome('ios'),
  isChromium: checkChrome('chromium'),
  isMac: navigator.appVersion.indexOf('Mac') !== -1,
};

class EventTargetShim {
  constructor() {
    const delegate = document.createDocumentFragment();

    /**
     *
     * @param {string} type
     * @param {EventListener} listener
     * @param {Object} [opts]
     */
    const delegatedAddEventListener = (type, listener, opts) =>
      delegate.addEventListener(type, listener, opts);

    /**
     * @param {string} type
     * @param {EventListener} listener
     * @param {Object} [opts]
     */
    const delegatedRemoveEventListener = (type, listener, opts) =>
      delegate.removeEventListener(type, listener, opts);

    /**
     * @param {Event|CustomEvent} event
     */
    const delegatedDispatchEvent = event => delegate.dispatchEvent(event);

    this.addEventListener = delegatedAddEventListener;

    this.removeEventListener = delegatedRemoveEventListener;

    this.dispatchEvent = delegatedDispatchEvent;
  }
}

var _templateObject$1b, _templateObject2$J, _templateObject3$s;
function ownKeys$11(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$10(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$11(Object(source), true).forEach(function (key) { _defineProperty$2f(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$11(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$1b(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$2f(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * This mixin will allow any LitElement to become an Et2Widget
 *
 * Usage:
 * @example
 * export class Et2Loading extends Et2Widget(BXLoading) { ... }
 * @example
 * export class Et2Button extends Et2InputWidget(Et2Widget(BXButton)) { ... }
 *
 * @see Mixin explanation https://lit.dev/docs/composition/mixins/
 */
function applyMixins(derivedCtor, baseCtors) {
  baseCtors.forEach(baseCtor => {
    Object.getOwnPropertyNames(baseCtor.prototype).forEach(name => {
      if (name !== 'constructor') {
        derivedCtor.prototype[name] = baseCtor.prototype[name];
      }
    });
  });
}
var Et2WidgetMixin = superClass => {
  class Et2WidgetClass extends superClass {
    /** WebComponent **/
    static get styles() {
      return [...(super.styles ? Array.isArray(super.styles) ? super.styles : [super.styles] : []), i$b(_templateObject$1b || (_templateObject$1b = _taggedTemplateLiteral$1b(["\n\t\t\t\t:host([disabled]) {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t}\n\t\t\t\t\n\t\t\t\t/* CSS to align internal inputs according to box alignment */\n\t\t\t\t:host([align=\"center\"]) .input-group__input {\n\t\t\t\t\tjustify-content: center;\n\t\t\t\t}\n\t\t\t\t:host([align=\"right\"]) .input-group__input {\n\t\t\t\t\tjustify-content: flex-end;\n\t\t\t\t}\n\n\t\t\t\t  /* Put widget label to the left of the widget */\n\n\t\t\t\t  ::part(form-control) {\n\t\t\t\t\tdisplay: flex;\n\t\t\t\t\talign-items: center;\n\t\t\t\t\tflex-wrap: wrap;\n\t\t\t\t  }\n\n\t\t\t\t  ::part(form-control-label) {\n\t\t\t\t\tflex: 0 0 auto;\n\t\t\t\t\twhite-space: normal;\n\t\t\t\t  }\n\n\t\t\t\t  ::part(form-control-input) {\n\t\t\t\t\tflex: 1 1 auto;\n\t\t\t\t\tposition: relative;\n\t\t\t\t\tmax-width: 100%;\n\t\t\t\t  }\n\n\t\t\t\t  ::part(form-control-help-text) {\n\t\t\t\t\tflex-basis: 100%;\n\t\t\t\t\tposition: relative;\n\t\t\t\t  }\n\n\t\t\t\t  /* Use .et2-label-fixed class to give fixed label size */\n\n\t\t\t\t  :host(.et2-label-fixed)::part(form-control-label) {\n\t\t\t\t\twidth: initial;\n\t\t\t\t\twidth: var(--label-width, 8em);\n\t\t\t\t  }\n\n\t\t\t\t  :host(.et2-label-fixed)::part(form-control-help-text) {\n\t\t\t\t\tleft: calc(var(--sl-spacing-medium) + var(--label-width, 8em));\n\t\t\t\t  }\n            "])))];
    }
    static get properties() {
      return _objectSpread$10(_objectSpread$10({}, super.properties), {}, {
        /**
         * Widget ID.  Optional, and not always the same as the DOM ID if the widget is inside something
         * else that also has an ID.
         * Putting this in the properties() list causes the parent portion of the DOM ID to be duplicated
         * due to how LitElement processes the change
         */
        //id: {type: String, reflect: false},

        /**
         * CSS Class.  This class is applied to the _outside_, on the web component itself.
         * Due to how WebComponents work, this might not change anything inside the component.
         */
        class: {
          type: String,
          reflect: true
        },
        /**
         * Defines whether this widget is visibly disabled.
         *
         * The widget is still visible, but clearly cannot be interacted with.  Widgets disabled in the template
         * will not return a value to the application code, even if re-enabled via javascript before submitting.
         * To allow a disabled widget to be re-enabled and return a value, disable via javascript in the app's
         * et2_ready() instead of an attribute in the template file.
         */
        disabled: {
          type: Boolean,
          reflect: true
        },
        /**
         * The widget is not visible.
         *
         * As far as the user is concerned, the widget does not exist.  Widgets hidden with an attribute in the
         * template may not be created in the DOM, and will not return a value.  Widgets can be hidden after creation,
         * and they may return a value if hidden this way.
         */
        hidden: {
          type: Boolean,
          reflect: true
        },
        /**
         * Accesskey provides a hint for generating a keyboard shortcut for the current element.
         * The attribute value must consist of a single printable character.
         * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/accesskey
         */
        accesskey: {
          type: String,
          reflect: true
        },
        /**
         * Widget ID of another node to insert this node into instead of the normal location
         * This isn't a normal property...
         */
        parentId: {
          type: String,
          noAccessor: true
        },
        /**
         * Tooltip which is shown for this element on hover
         */
        statustext: {
          type: String,
          reflect: true
        },
        /**
         * The label of the widget
         * This is usually displayed in some way.  It's also important for accessability.
         * This is defined in the parent somewhere, and re-defining it causes labels to disappear
         */
        label: {
          type: String
        },
        onclick: {
          type: Function
        },
        /*** Style type attributes ***/
        /**
         * Disable any translations for the widget
         */
        noLang: {
          type: Boolean,
          reflect: false
        },
        /**
         * Used by Et2Box to determine alignment.
         * Allowed values are left, right
         */
        align: {
          type: String,
          reflect: true
        },
        /**
         * comma-separated name:value pairs set as data attributes on DOM node
         * data="mime:${row}[mime]" would generate data-mime="..." in DOM, eg. to use it in CSS on a parent
         */
        data: {
          type: String,
          reflect: false
        }
      });
    }

    /**
     * List of properties that get translated
     *
     * Done separately to not interfere with properties - if we re-define label property,
     * labels go missing.
     * @internal
     * @returns {{statustext : boolean, label : boolean}}
     */
    static get translate() {
      return {
        label: true,
        statustext: true
      };
    }

    /**
     * Widget Mixin constructor
     *
     * Note the ...args parameter and super() call
     *
     * @param args
     */
    constructor() {
      super(...arguments);
      _defineProperty$2f(this, "_mgrs", []);
      _defineProperty$2f(this, "_parent", null);
      _defineProperty$2f(this, "_inst", null);
      /**
       * et2_widget compatability
       * @deprecated Legacy compatability.  Some legacy widgets check their parent to see whats allowed
       **/
      _defineProperty$2f(this, "supportedWidgetClasses", []);
      /**
       * If we put the widget somewhere other than as a child of its parent, we need to record that so
       * we don't move it back to the parent.
       * @type {Element}
       * @internal
       */
      _defineProperty$2f(this, "_parent_node", void 0);
      /**
       * Not actually required by et2_widget, but needed to keep track of non-webComponent children
       */
      _defineProperty$2f(this, "_legacy_children", []);
      /**
       * Keep track of child widgets
       * This can differ from this.children, as it only includes the widgets where this.children will be child DOM nodes,
       * not guaranteed to be widgets
       */
      _defineProperty$2f(this, "_children", []);
      /**
       * Internal Properties - default values, and actually creating them as fields
       * Do not include public property defined in properties()
       */
      /**
       * Internal widget ID
       * @type {string}
       * @internal
       */
      _defineProperty$2f(this, "_widget_id", "");
      /**
       * Actual DOM ID, which is different from the widget ID
       * @type {string}
       * @internal
       */
      _defineProperty$2f(this, "_dom_id", "");
      /**
       * TypeScript & LitElement ensure type correctness, so we can't have a string value like "$row_cont[disable_me]"
       * as a boolean property so we store them here, and parse them when expanding.  Strings do not have this problem,
       * since $row_cont[disable_me] is still a valid string.
       * @internal
       */
      _defineProperty$2f(this, "_deferred_properties", {});
      this.disabled = false;
      this._handleClick = this._handleClick.bind(this);

      // make all sizable widgets large by default on mobile template
      if (typeof egwIsMobile == "function" && egwIsMobile()) {
        this.size = "large";
      }
    }
    connectedCallback() {
      super.connectedCallback();
      this.addEventListener("click", this._handleClick);
      if (this.statustext && !egwIsMobile()) {
        this.egw().tooltipBind(this, this.egw().lang(this.statustext));
      }
    }
    disconnectedCallback() {
      var _this$egw;
      (_this$egw = this.egw()) === null || _this$egw === void 0 || _this$egw.tooltipUnbind(this);
      this.removeEventListener("click", this._handleClick);
    }

    /**
     * NOT the setter, since we cannot add to the DOM before connectedCallback()
     *
     * TODO: This is not best practice.  Should just set property, DOM modification should be done in render
     * https://lit-element.polymer-project.org/guide/templates#design-a-performant-template
     *
     * @param value
     */
    set_label(value) {
      var oldValue = this.label;

      // Remove old
      var oldLabels = this.getElementsByClassName("et2_label");
      while (oldLabels[0]) {
        this.removeChild(oldLabels[0]);
      }
      this.__label = value;
      if (value) {
        if (this._labelNode) {
          this._labelNode.textContent = this.__label;
        } else {
          var label = document.createElement("span");
          label.classList.add("et2_label");
          label.textContent = this.__label;
          // We should have a slot in the template for the label
          label.slot = "label";
          this.appendChild(label);
          this.requestUpdate('label', oldValue);
        }
      }
    }

    /**
     * supports legacy set_statustext
     * @deprecated use this.statustext
     * @param value
     */
    set_statustext(value) {
      this.statustext = value;
    }
    set statustext(value) {
      var oldValue = this.__statustext;
      this.__statustext = value;
      this.requestUpdate("statustext", oldValue);
    }
    get statustext() {
      return this.__statustext;
    }

    /**
     * Wrapper on this.disabled because legacy had it.
     *
     * @deprecated Use widget.disabled for visually disabled, widget.hidden for visually hidden.
     * 	Widgets that are hidden from the server via attribute or $readonlys will not be created.
     * 	Widgets that are disabled from the server will not return a value to the application code.
     *
     * @param {boolean} value
     */
    set_disabled(value) {
      var oldValue = this.disabled;
      this.disabled = value;
      this.hidden = value;
      this.requestUpdate("disabled", oldValue);
    }

    /**
     * Get the actual DOM ID, which has been prefixed to make sure it's unique.
     *
     * @returns {string}
     */
    get dom_id() {
      return this.getAttribute("id");
    }

    /**
     * Set the ID of the widget
     *
     * This is the "widget" ID, which is used as an index into the managed arrays (content, etc) and when
     * trying to find widgets by ID.
     *
     * This is not the DOM ID.
     *
     * @param {string} value
     */
    set id(value) {
      this._widget_id = value;
      var dom_id = "";
      if (this._widget_id) {
        // Create a namespace for this object with new ID
        if (this._createNamespace()) {
          this.checkCreateNamespace();
        }
        var path = this.getPath();
        if (this.getInstanceManager()) {
          path.unshift(this.getInstanceManager().uniqueId);
        }
        path.push(value);
        dom_id = path.join("_");
      }
      this.setAttribute("id", dom_id);
      this.requestUpdate("id");
    }

    /**
     * Get the ID of the widget
     *
     * @returns {string}
     */
    get id() {
      return this._widget_id;
    }

    /**
     * Set the dataset from a CSV
     * @param {string} value
     */
    set data(value) {
      // Clear existing
      Object.keys(this.dataset).forEach(dataKey => {
        delete this.dataset[dataKey];
      });
      var data = value.split(",");
      data.forEach(field => {
        var f = field.split(":");
        if (f[0] && typeof f[1] !== "undefined") {
          this.dataset[f[0]] = f[1];
        }
      });
    }
    get data() {
      var data = [];
      Object.keys(this.dataset).forEach(k => {
        data.push(k + ":" + this.dataset[k]);
      });
      return data.join(",");
    }

    /**
     * A property has changed, and we want to make adjustments to other things
     * based on that
     *
     * @param {import('@lion/core').PropertyValues } changedProperties
     */
    updated(changedProperties) {
      super.updated(changedProperties);

      // required changed, add / remove validator
      if (changedProperties.has('label')) {
        this._set_label(this.label);
      }
      if (changedProperties.has("statustext")) {
        this.egw().tooltipUnbind(this);
        if (this.statustext) {
          this.egw().tooltipBind(this, this.statustext);
        }
      }
      if (changedProperties.has("onclick")) {
        this.classList.toggle("et2_clickable", this.onclick != null && typeof this.onclick != "undefined");
      }
    }

    /**
     * Any attribute that refers to row content cannot be resolved immediately, but some like booleans cannot stay a
     * string because it's a boolean attribute.  We store them for later, and parse when they're fully in their row.
     *
     * If you are creating a widget that can go in a nextmatch row, and it has boolean attributes that can change
     * for each row, add those attributes into deferredProperties
     */
    get deferredProperties() {
      return this._deferred_properties;
    }
    set deferredProperties(value) {
      this._deferred_properties = value;
    }

    /**
     * Do some fancy stuff on the label, splitting it up if there's a %s in it
     *
     * Normally called from updated(), the "normal" setter stuff has already been run before
     * this is called.  We only override our special cases (%s) because the normal label has
     * been set by the parent
     *
     * @param value
     * @protected
     */
    _set_label(value) {
      if (!this._labelNode) {
        return;
      }
      // Remove any existing post label
      var existing = Array.from(this.children).find(el => el.slot === "after" && el.tagName === "LABEL");
      if (existing) {
        this.removeChild(existing);
      }

      // Split the label at the "%s"
      var parts = et2_csvSplit(value, 2, "%s");
      if (parts.length > 1) {
        var after = document.createElement("label");
        after.slot = "after";
        after.textContent = parts[1];
        this.appendChild(after);
        this._labelNode.textContent = parts[0];
      }
    }
    set class(value) {
      var oldValue = this.classList.value;
      this.classList.value = value;
      this.requestUpdate('class', oldValue);
    }
    get class() {
      return this.classList.value;
    }

    /**
     * Set the widget class
     *
     * @deprecated Use this.class or this.classList instead
     * @param {string} new_class
     */
    set_class(new_class) {
      this.class = new_class;
    }

    /**
     * Event handlers
     */

    /**
     * Click handler calling custom handler set via onclick attribute to this.onclick
     *
     * @param _ev
     * @returns
     */
    _handleClick(_ev) {
      if (typeof this.onclick == 'function') {
        // Make sure function gets a reference to the widget, splice it in as 2. argument if not
        var args = Array.prototype.slice.call(arguments);
        if (args.indexOf(this) == -1) {
          args.splice(1, 0, this);
        }
        return this.onclick(...args);
      }
      return true;
    }

    /** et2_widget compatability
     * @deprecated
     **/
    destroy() {
      // Not really needed, use the disconnectedCallback() and let the browser handle it

      // Call the destructor of all children so any legacy widgets get destroyed
      for (var i = this.getChildren().length - 1; i >= 0; i--) {
        this.getChildren()[i].destroy();
      }

      // Free the array managers if they belong to this widget
      for (var _key in this._mgrs) {
        if (this._mgrs[_key] && this._mgrs[_key].owner == this) {
          delete this._mgrs[_key];
        }
      }

      // if widget exists DOM-wise outside the parent, we need to explicitly remove it
      if (this._parent_node) this.remove();
    }
    isInTree() {
      // TODO: Probably should watch the state or something
      return true;
    }

    /**
     * Get property-values as object
     *
     * @deprecated use widget methods
     */
    get options() {
      var options = {};
      // @ts-ignore not sure how to tell TS this is a ReactiveElement and properties is a static getter
      for (var name in this.constructor.properties) {
        options[name] = this[name];
      }
      // adding attributes too
      this.getAttributeNames().forEach(name => {
        options[name] = this.getAttribute(name);
      });
      // add some (not declared) known properties
      if (typeof this.get_value === 'function') {
        options.value = this.get_value();
      }
      console.groupCollapsed("Deprecated widget.options use");
      console.trace("Something called widget.options on ", this);
      console.groupEnd();
      return options;
    }

    /**
     * Loads the widget tree from an XML node
     *
     * @param _node xml node
     */
    loadFromXML(_node) {
      // Load the child nodes.
      for (var i = 0; i < _node.childNodes.length; i++) {
        var node = _node.childNodes[i];
        var widgetType = node.nodeName.toLowerCase();
        if (widgetType == "#comment") {
          continue;
        }
        if (widgetType == "#text") {
          if (node.data.replace(/^\s+|\s+$/g, '')) {
            this.innerText = node.data;
          }
          continue;
        }

        // Create the new element
        this.createElementFromNode(node);
      }
    }

    /**
     * Create a et2_widget from an XML node.
     *
     * First the type and attributes are read from the node.  Then the readonly & modifications
     * arrays are checked for changes specific to the loaded data.  Then the appropriate
     * constructor is called.  After the constructor returns, the widget has a chance to
     * further initialize itself from the XML node when the widget's loadFromXML() method
     * is called with the node.
     *
     * @param _node XML node to read
     * @param _name XML node name
     *
     * @return et2_widget
     */
    createElementFromNode(_node, _name) {
      var attributes = {};

      // Parse the "readonly" and "type" flag for this element here, as they
      // determine which constructor is used
      var _nodeName = attributes["type"] = _node.getAttribute("type") ? _node.getAttribute("type") : _node.nodeName.toLowerCase();
      var readonly = attributes["readonly"] = this.getArrayMgr("readonlys") ? this.getArrayMgr("readonlys").isReadOnly(_node.getAttribute("id"), _node.getAttribute("readonly"), typeof this.readonly !== "undefined" ? this.readonly : false) : false;

      // Check to see if modifications change type
      var modifications = this.getArrayMgr("modifications");
      if (modifications && _node.getAttribute("id")) {
        var entry = modifications.getEntry(_node.getAttribute("id"));
        if (entry == null) {
          // Try again, but skip the fancy stuff
          // TODO: Figure out why the getEntry() call doesn't always work
          entry = modifications.data[_node.getAttribute("id")];
          if (entry) {
            this.egw().debug("warn", "getEntry(" + _node.getAttribute("id") + ") failed, but the data is there.", modifications, entry);
          } else {
            // Try the root, in case a namespace got missed
            entry = modifications.getRoot().getEntry(_node.getAttribute("id"));
          }
        }
        if (entry && entry.type && typeof entry.type === 'string') {
          _nodeName = attributes["type"] = entry.type;
        }
        entry = null;
      }

      // if _nodeName / type-attribute contains something to expand (eg. type="@${row}[type]"),
      // we need to expand it now as it defines the constructor and by that attributes parsed via parseXMLAttrs!
      if (_nodeName.charAt(0) == '@' || _nodeName.indexOf('$') >= 0) {
        _nodeName = attributes["type"] = this.getArrayMgr('content').expandName(_nodeName);
      }
      var widget;
      if (undefined == window.customElements.get(_nodeName)) {
        // Get the constructor - if the widget is readonly, use the special "_ro"
        // constructor if it is available
        if (typeof et2_registry[_nodeName] === "undefined") {
          _nodeName = 'placeholder';
        }
        var _constructor = et2_registry[_nodeName];
        if (readonly === true && typeof et2_registry[_nodeName + "_ro"] != "undefined") {
          _constructor = et2_registry[_nodeName + "_ro"];
        }

        // Parse the attributes from the given XML attributes object
        this.parseXMLAttrs(_node.attributes, attributes, _constructor.prototype);

        // Do an sanity check for the attributes
        ClassWithAttributes.generateAttributeSet(et2_attribute_registry[_constructor.name], attributes);

        // Creates the new widget, passes this widget as an instance and
        // passes the widgetType. Then it goes on loading the XML for it.
        widget = new _constructor(this, attributes);

        // Load the widget itself from XML
        widget.loadFromXML(_node);
      } else {
        widget = loadWebComponent(_nodeName, _node, this);
        if (this.addChild && widget) {
          // webcomponent going into old et2_widget
          this.addChild(widget);
        }
      }
      return widget;
    }

    /**
     * The parseXMLAttrs function takes an XML DOM attributes object
     * and adds the given attributes to the _target associative array. This
     * function also parses the legacyOptions.
     *
     * N.B. This is only used for legacy widgets.  WebComponents use transformAttributes() and
     * do their own handling of attributes.
     *
     * @param _attrsObj is the XML DOM attributes object
     * @param {object} _target is the object to which the attributes should be written.
     * @param {et2_widget} _proto prototype with attributes and legacyOptions attribute
     */
    parseXMLAttrs(_attrsObj, _target, _proto) {
      // Check whether the attributes object is really existing, if not abort
      if (typeof _attrsObj == "undefined") {
        return;
      }

      // Iterate over the given attributes and parse them
      var mgr = this.getArrayMgr("content");
      for (var i = 0; i < _attrsObj.length; i++) {
        var attrName = _attrsObj[i].name;
        var attrValue = _attrsObj[i].value;

        // Special handling for the legacy options
        if (attrName == "options" && _proto.constructor.legacyOptions && _proto.constructor.legacyOptions.length > 0) {
          var legacy = _proto.constructor.legacyOptions || [];
          // Check for modifications on legacy options here.  Normal modifications
          // are handled in widget constructor, but it's too late for legacy options then
          if (_target.id && this.getArrayMgr("modifications").getEntry(_target.id)) {
            var mod = this.getArrayMgr("modifications").getEntry(_target.id);
            if (typeof mod.options != "undefined") {
              attrValue = _attrsObj[i].value = mod.options;
            }
          }
          // expand legacyOptions with content
          if (attrValue.charAt(0) == '@' || attrValue.indexOf('$') != -1) {
            attrValue = mgr.expandName(attrValue);
          }

          // Parse the legacy options (as a string, other types not allowed)
          var splitted = et2_csvSplit(attrValue + "");
          for (var j = 0; j < splitted.length && j < legacy.length; j++) {
            // Blank = not set, unless there's more legacy options provided after
            if (splitted[j].trim().length === 0 && legacy.length >= splitted.length) {
              continue;
            }

            // Check to make sure we don't overwrite a current option with a legacy option
            if (typeof _target[legacy[j]] === "undefined") {
              attrValue = splitted[j];

              /**
              If more legacy options than expected, stuff them all in the last legacy option
              Some legacy options take a comma separated list.
               */
              if (j == legacy.length - 1 && splitted.length > legacy.length) {
                attrValue = splitted.slice(j);
              }
              var attr = et2_attribute_registry[_proto.constructor.name][legacy[j]] || {};

              // If the attribute is marked as boolean, parse the
              // expression as bool expression.
              if (attr.type == "boolean") {
                attrValue = mgr.parseBoolExpression(attrValue);
              } else if (typeof attrValue != "object") {
                attrValue = mgr.expandName(attrValue);
              }
              _target[legacy[j]] = attrValue;
            }
          }
        } else if (attrName == "readonly" && typeof _target[attrName] != "undefined") {
          // do NOT overwrite already evaluated readonly attribute
        } else {
          var attrs = et2_attribute_registry[_proto.constructor.name] || {};
          if (mgr != null && typeof attrs[attrName] != "undefined") {
            var _attr = attrs[attrName];

            // If the attribute is marked as boolean, parse the
            // expression as bool expression.
            if (_attr.type == "boolean") {
              attrValue = mgr.parseBoolExpression(attrValue);
            } else {
              attrValue = mgr.expandName(attrValue);
            }
          }

          // Set the attribute
          _target[attrName] = attrValue;
        }
      }
    }
    transformAttributes(attrs) {
      var _this$getArrayMgr;
      transformAttributes(this, this.getArrayMgr("content"), attrs);

      // Add in additional modifications
      if (this.id && (_this$getArrayMgr = this.getArrayMgr("modifications")) !== null && _this$getArrayMgr !== void 0 && _this$getArrayMgr.getEntry(this.id)) {
        transformAttributes(this, this.getArrayMgr("content"), this.getArrayMgr("modifications").getEntry(this.id));
      }
    }
    iterateOver(_callback, _context, _type) {
      if (this.disabled) {
        // Don't if we're disabled
        return;
      }
      if (typeof _type === "undefined" || _type === et2_widget || _type === Et2Widget || typeof _type === 'function' && this instanceof _type || et2_implements_registry[_type] && et2_implements_registry[_type](this)) {
        _callback.call(_context, this);
      }

      // Ask children
      for (var i = 0; i < this._children.length; i++) {
        this._children[i].iterateOver(_callback, _context, _type);
      }
    }

    /**
     * Needed for legacy compatability.
     *
     * @param {Promise[]} promises List of promises from widgets that are not done.  Pass an empty array, it will be filled if needed.
     */
    loadingFinished(promises) {
      if (typeof promises === "undefined") {
        promises = [];
      }
      // Note that WebComponents don't do anything here, their lifecycle is different
      // This is just to support legacy widgets
      var doLoadingFinished = () => {
        var _this$childNodes$;
        /**
         * This is needed mostly as a bridge between non-WebComponent widgets and
         * connectedCallback().  It's not really needed if the whole tree is WebComponent.
         * WebComponents can be added as children immediately after creation, and they handle the
         * rest themselves with their normal lifecycle (especially connectedCallback(), which is kind
         * of the equivalent of doLoadingFinished()
         */
        // @ts-ignore this is not an et2_widget, so getDOMNode(this) is bad
        if (!this._parent_node && this.getParent() instanceof et2_widget && this.getParent().getDOMNode(this) != this.parentNode) {
          // @ts-ignore this is not an et2_widget, and Et2Widget is not a Node
          this.getParent().getDOMNode(this).append(this);
        }

        // An empty text node causes problems with legacy widget children
        // It throws off their insertion indexing, making them get added in the wrong place
        if (((_this$childNodes$ = this.childNodes[0]) === null || _this$childNodes$ === void 0 ? void 0 : _this$childNodes$.nodeType) == this.TEXT_NODE && this.childNodes[0].textContent == "") {
          this.removeChild(this.childNodes[0]);
        }
        for (var i = 0; i < this.getChildren().length; i++) {
          var child = this.getChildren()[i];
          child.loadingFinished(promises);
        }
      };
      doLoadingFinished();
      promises.push(this.getUpdateComplete());
    }
    getWidgetById(_id) {
      if (this.id == _id) {
        return this;
      }
      if (this.getChildren().length == 0) {
        return null;
      }
      var check_children = children => {
        for (var i = 0; i < children.length; i++) {
          var elem = children[i].getWidgetById(_id);
          if (elem != null) {
            return elem;
          }
        }
        if (this.id && _id.indexOf('[') > -1 && children.length) {
          var ids = new et2_arrayMgr().explodeKey(_id);
          var widget = this;
          for (var _i = 0; _i < ids.length && widget !== null; _i++) {
            widget = widget.getWidgetById(ids[_i]);
          }
          return widget;
        }
      };
      return check_children(this.getChildren()) || null;
    }

    /**
     * Parent is different than what is specified in the template / hierarchy.
     * Widget ID of another node to insert this node into instead of the normal location
     *
     * @param {string} parent
     */
    set parentId(parent) {
      this.__parentId = parent;
      this.updateComplete.then(() => {
        if (!this.__parentId) {
          return;
        }
        var parent = document.querySelector("#" + this.__parentId) || this.__parentId;
        if (parent && parent instanceof Element) {
          parent.append(this);
          this._parent_node = parent;
        }
      });
    }
    get parentId() {
      return this.__parentId;
    }
    setParent(new_parent) {
      this._parent = new_parent;
      if (this.id) {
        // Create a namespace for this object
        if (this._createNamespace()) {
          this.checkCreateNamespace();
        }
      }
      // @ts-ignore
      this._parent.addChild(this);
    }
    getParent() {
      if (this._parent) {
        return this._parent;
      }
      return null;
    }
    getParentDOMNode() {
      return this._parent_node;
    }
    addChild(child) {
      if (this._children.indexOf(child) >= 0) {
        return;
      }
      if (child instanceof et2_widget) {
        // Type of et2_widget._parent is et2_widget, not Et2Widget.  This might cause problems, but they
        // should be fixed by getting rid of the legacy widget with problems
        // @ts-ignore
        child._parent = this;

        // During legacy widget creation, the child's DOM node won't be available yet.
        this._legacy_children.push(child);
        var child_node = null;
        try {
          //@ts-ignore Technically getDOMNode() is from et2_DOMWidget
          child_node = typeof child.getDOMNode !== "undefined" ? child.getDOMNode(child) : null;
        } catch (e) {
          // Child did not give up its DOM node nicely but errored instead
        }
        if (child_node && child_node !== this) {
          this.append(child_node);
        }
      } else {
        this.append(child);
      }
      this._children.push(child);
    }

    /**
     * Get child widgets
     * Use <obj>.children to get web component children
     * @returns {et2_widget[]}
     */
    getChildren() {
      return this._children;
    }
    getType() {
      return this.nodeName;
    }
    getDOMNode() {
      return this;
    }

    /**
     * Creates a copy of this widget.
     *
     * @param {et2_widget} _parent parent to set for clone, default null
     */
    clone(_parent) {
      // Default _parent to null
      if (typeof _parent == "undefined") {
        _parent = null;
      }

      // Create the copy
      var copy = this.cloneNode();
      copy.id = this._widget_id;
      if (_parent) {
        copy.setParent(_parent);
      } else {
        // Copy a reference to the content array manager
        copy.setArrayMgrs(this.getArrayMgrs());

        // Pass on instance too
        copy.setInstanceManager(this.getInstanceManager());
      }
      var widget_class = window.customElements.get(this.localName);
      var properties = widget_class ? widget_class.elementProperties : [];
      properties.forEach((v, key) => {
        copy[key] = this[key];
      });

      // Keep the deferred properties
      copy._deferred_properties = this._deferred_properties;

      // Create a clone of all child widgets of the given object
      for (var i = 0; i < this.getChildren().length; i++) {
        this.getChildren()[i].clone(copy);
      }
      return copy;
    }

    /**
     * Sets the array manager for the given part
     *
     * @param {string} _part which array mgr to set
     * @param {object} _mgr
     */
    setArrayMgr(_part, _mgr) {
      this._mgrs[_part] = _mgr;
    }

    /**
     * Returns the array manager object for the given part
     *
     * @param {string} managed_array_type name of array mgr to return
     */
    getArrayMgr(managed_array_type) {
      if (this._mgrs && typeof this._mgrs[managed_array_type] != "undefined") {
        return this._mgrs[managed_array_type];
      } else if (this.getParent()) {
        return this.getParent().getArrayMgr(managed_array_type);
      }
      return null;
    }

    /**
     * Sets all array manager objects - this function can be used to set the
     * root array managers of the container object.
     *
     * @param {object} _mgrs
     */
    setArrayMgrs(_mgrs) {
      this._mgrs = et2_cloneObject(_mgrs);
    }

    /**
     * Returns an associative array containing the top-most array managers.
     *
     * @param _mgrs is used internally and should not be supplied.
     */
    getArrayMgrs(_mgrs) {
      if (typeof _mgrs == "undefined") {
        _mgrs = {};
      }

      // Add all managers of this object to the result, if they have not already
      // been set in the result
      for (var _key2 in this._mgrs) {
        if (typeof _mgrs[_key2] == "undefined") {
          _mgrs[_key2] = this._mgrs[_key2];
        }
      }

      // Recursively applies this function to the parent widget
      if (this._parent) {
        this._parent.getArrayMgrs(_mgrs);
      }
      return _mgrs;
    }

    /**
     * Checks whether a namespace exists for this element in the content array.
     * If yes, an own perspective of the content array is created. If not, the
     * parent content manager is used.
     *
     * Constructor attributes are passed in case a child needs to make decisions
     */
    checkCreateNamespace() {
      // Get the content manager
      var mgrs = this.getArrayMgrs();
      for (var _key3 in mgrs) {
        var mgr = mgrs[_key3];

        // Get the original content manager if we have already created a
        // perspective for this node
        if (typeof this._mgrs[_key3] != "undefined" && mgr.perspectiveData.owner == this) {
          mgr = mgr.getParentMgr();
        }

        // Check whether the manager has a namespace for the id of this object
        var entry = mgr.getEntry(this.id);
        if (typeof entry === 'object' && entry !== null || this.id) {
          // The content manager has an own node for this object, so
          // create an own perspective.
          this._mgrs[_key3] = mgr.openPerspective(this, this.id);
        } else {
          // The current content manager does not have an own namespace for
          // this element, so use the content manager of the parent.
          delete this._mgrs[_key3];
        }
      }
    }

    /**
     * Set the instance manager
     * Normally this is not needed as it's set on the top-level container, and we just return that reference
     *
     */
    setInstanceManager(manager) {
      this._inst = manager;
    }

    /**
     * Returns the instance manager
     *
     * @return {etemplate2}
     */
    getInstanceManager() {
      if (this._inst != null) {
        return this._inst;
      } else if (this.getParent()) {
        return this.getParent().getInstanceManager ? this.getParent().getInstanceManager() : null;
      }
      return null;
    }

    /**
     * Returns the base widget
     * Usually this is the same as getInstanceManager().widgetContainer
     */
    getRoot() {
      if (this.getParent() != null) {
        return this.getParent().getRoot();
      } else {
        return this;
      }
    }

    /**
     * Returns the path into the data array.  By default, array manager takes care of
     * this, but some extensions need to override this
     */
    getPath() {
      var _this$getArrayMgr$get, _this$getArrayMgr2;
      var path = (_this$getArrayMgr$get = (_this$getArrayMgr2 = this.getArrayMgr("content")) === null || _this$getArrayMgr2 === void 0 ? void 0 : _this$getArrayMgr2.getPath()) !== null && _this$getArrayMgr$get !== void 0 ? _this$getArrayMgr$get : [];

      // Prevent namespaced widgets with value from going an extra layer deep
      if (this.id && this._createNamespace() && path[path.length - 1] == this.id) {
        path.pop();
      }
      return path;
    }
    _createNamespace() {
      return false;
    }
    egw() {
      if (this.getParent() != null && typeof this.getParent().egw === "function") {
        return this.getParent().egw();
      }
      // Get the window this object belongs to
      var wnd = null;
      // @ts-ignore Technically this doesn't have implements(), but it's mixed in
      if (this.implements(et2_IDOMNode)) {
        var node = this.getDOMNode();
        if (node && node.ownerDocument) {
          wnd = node.ownerDocument.parentNode || node.ownerDocument.defaultView;
        }
      }

      // If we're the root object, return the phpgwapi API instance
      return typeof egw$1 === "function" ? egw$1('phpgwapi', wnd) : window['egw'] ? window['egw'] : null;
    }
  }

  // Add some more stuff in
  applyMixins(Et2WidgetClass, [ClassWithInterfaces]);
  return Et2WidgetClass;
};
var Et2Widget = dedupeMixin(Et2WidgetMixin);

/**
 * Load a Web Component
 * @param _nodeName
 * @param _template_node
 * @param parent Parent widget
 */
// @ts-ignore Et2Widget is I guess not the right type
function loadWebComponent(_nodeName, _template_node, parent) {
  var _parent$options;
  var attrs = {};
  var load_children = true;

  // support attributes object instead of an Element
  if (typeof _template_node.getAttribute === 'undefined') {
    attrs = _template_node;
    load_children = false;
  } else {
    _template_node.getAttributeNames().forEach(attribute => {
      attrs[attribute] = _template_node.getAttribute(attribute);
    });
  }

  // Try to find the class for the given node
  var mobile = typeof egwIsMobile != "undefined" && egwIsMobile();
  if (mobile && typeof window.customElements.get(_nodeName + "_mobile") != "undefined") {
    _nodeName += "_mobile";
  }
  var widget_class = window.customElements.get(_nodeName);
  if (!widget_class) {
    // Given node has no registered class.  Try some of our special things (remove type, fallback to actual node)
    var tries = [_nodeName.split('-')[0]];
    if (_template_node.nodeName) {
      tries = tries.concat(_template_node.nodeName.toLowerCase());
    }
    for (var i = 0; i < tries.length && !window.customElements.get(_nodeName); i++) {
      _nodeName = tries[i];
    }
    widget_class = window.customElements.get(_nodeName);
    if (!widget_class) {
      debugger;
      throw Error("Unknown or unregistered WebComponent '" + _nodeName + "', could not find class.  Also checked for " + tries.join(','));
    }
  }

  // Don't need to create hidden elements
  if (parent !== null && parent !== void 0 && parent.hidden || attrs["hidden"] && parent !== null && parent !== void 0 && parent.getArrayMgr("content") && parent.getArrayMgr("content").parseBoolExpression(attrs["hidden"])) {
    //return null;
  }
  var readonly = parent !== null && parent !== void 0 && parent.getArrayMgr("readonlys") ? parent.getArrayMgr("readonlys").isReadOnly(attrs["id"], attrs["readonly"], typeof (parent === null || parent === void 0 ? void 0 : parent.readonly) !== "undefined" ? parent.readonly : ((_parent$options = parent.options) === null || _parent$options === void 0 ? void 0 : _parent$options.readonly) || false) : false;
  if (readonly === true && typeof window.customElements.get(_nodeName + "_ro") != "undefined") {
    _nodeName += "_ro";
  }

  // @ts-ignore
  var widget = document.createElement(_nodeName);
  if (parent && typeof widget.setParent === 'function') widget.setParent(parent);

  // Set read-only.  Doesn't really matter if it's a ro widget, but otherwise it needs set
  widget.readonly = readonly;
  delete attrs.readonly;
  widget.transformAttributes(attrs);

  // Children need to be loaded
  if (load_children) {
    widget.loadFromXML(_template_node);
  }
  return widget;
}

/**
 * Take attributes from a node in a .xet file and apply those to a WebComponent widget
 *
 * Any attributes provided that match a property (or attribute) on the widget will be adjusted according to
 * the passed arrayManager, coerced into the proper type, and set.
 * It is here that we find values or set attributes that should come from content.
 *
 * @param widget
 * @param {et2_arrayMgr} mgr
 * @param attributes
 */
function transformAttributes(widget, mgr, attributes) {
  var widget_class = window.customElements.get(widget.localName);

  // Special case attributes
  if (attributes.attributes) {
    // Attributes in content? "attributes" is read-only in webComponent
    var mgr_attributes = mgr.getEntry(attributes.attributes);
    delete attributes.attributes;
    if (mgr_attributes) {
      Object.assign(attributes, ...mgr_attributes);
    }
  }
  if (attributes.width) {
    widget.style.setProperty("width", attributes.width);
    widget.style.setProperty("flex", "0 0 auto");
    delete attributes.width;
  }

  // Apply any set attributes - widget will do its own coercion
  for (var attribute in attributes) {
    var attrValue = attributes[attribute];

    // If there is no attribute set, ignore it.  Widget sets its own default.
    if (typeof attrValue === "undefined") {
      continue;
    }

    // preprocessor and transformer can't know if application widget is a web-component or a legacy one
    // translate attribute names to camelCase (only do it for used underscore, to not require a regexp)
    if (attribute !== 'select_options' && attribute.indexOf('_') !== -1) {
      var parts = attribute.split('_');
      if (attribute === 'parent_node') parts[1] = 'Id';
      attribute = parts.shift() + parts.map(part => part[0].toUpperCase() + part.substring(1)).join("");
    }
    var property = widget_class.getPropertyOptions(attribute);
    switch (typeof property === "object" ? property.type : property) {
      case Boolean:
        if (typeof attrValue == "boolean") {
          // Already boolean, nothing needed
          break;
        }
        // If the attribute is marked as boolean, parse the
        // expression as bool expression.
        attrValue = mgr ? mgr.parseBoolExpression(attrValue) : attrValue;
        if (typeof attrValue === "string") {
          // Parse decided we still needed a string ($row most likely) so we'll defer it until later
          // Repeating rows & nextmatch will parse it again when doing the row
          widget.deferredProperties[attribute] = attrValue;
          // Leave the current value at whatever the default is
          continue;
        }
        break;
      case Function:
        if (typeof attrValue == "string" && mgr && mgr.getPerspectiveData().row == null && (attrValue.indexOf("$row") > -1 || attrValue.indexOf("$row_cont") > -1)) {
          // Need row context, defer it until later
          // Repeating rows & nextmatch will parse it again when doing the row
          widget.deferredProperties[attribute] = attrValue;
          console.log("Had to defer %s parsing for %o\nCan it be rewritten to avoid $row & $row_cont?", attribute, widget);
          break;
        }
        // We parse it into a function here so we can pass in the widget as context.
        // Leaving it to the LitElement conversion loses the widget as context
        if (typeof attrValue !== "function") {
          attrValue = et2_compileLegacyJS(attrValue, widget, widget);
        }
        break;
      case Object:
      case Array:
        // Leave it alone if it's not a string
        if (typeof attrValue !== "string") {
          break;
        }
      // fall through to look in content
      default:
        attrValue = mgr ? mgr.expandName("" + attrValue) : attrValue;
        if (attrValue && typeof attrValue == "string" && widget_class.translate[attribute]) {
          // allow attribute to contain multiple translated sub-strings eg: {Firstname}.{Lastname}
          if (attrValue.indexOf('{') !== -1) {
            attrValue = attrValue.replace(/{([^}]+)}/g, (str, p1) => {
              return widget.egw().lang(p1);
            });
          } else {
            attrValue = widget.egw().lang(attrValue);
          }
        } else if (attrValue && [Object, Array, Number].indexOf(typeof property === "object" ? property.type : property) != -1) {
          // Value was not supposed to be a string, but was run through here for expandName
          try {
            attrValue = JSON.parse(attrValue);
          } catch (e) {
            console.info(widget_class.name + "#" + widget.id + " attribute '" + attribute + "' has type " + (typeof property === "object" ? property.type.name : property.name) + " but value %o could not be parsed", attrValue);
          }
        }
        break;
    }

    // Bind handlers directly, since we can do that now.  Event handlers still need to be defined
    // in properties() as {type: Function}, but this will take care of the binding.  This is
    // separate from internal events.
    // (handlers can only be bound _after_ the widget is added to the DOM
    if (attribute.startsWith("on") && typeof attrValue == "function") {
      //widget.updateComplete.then(() => addEventListener(attribute, attrValue));
    }

    // Set as attribute or property, as appropriate.  Don't set missing attributes.
    if (widget.getAttributeNames().indexOf(attribute) >= 0 || property.reflect && attrValue) {
      // Set as attribute (reflected in DOM)
      widget.setAttribute(attribute, attrValue === true ? "" : attrValue);
    } else if (attribute === 'options') {
      console.trace('Ignored setting depricated "options" attribute for widget #' + widget.id, widget);
      continue;
    }
    // Set as property
    widget[attribute] = attrValue;
  }
  if (widget_class.getPropertyOptions("value") && widget.set_value) {
    if (mgr != null) {
      var val = mgr.getEntry(widget.id, false, true);
      if (val !== null) {
        widget.set_value(val);
      }
    }
  }
}

/**
 * Take the name of one of our images, find the full URL (including theme), and wrap it up so you can use it in a
 * widget's css block.
 *
 * @example
 * import {cssImage} from Et2Widget;
 * ...
 * static get styles()
 * {
 * 		return [
 * 			...super.styles,
 * 			css`
 * 			:host {
 * 				background-image: ${cssImage("save")};
 *			}
 *		`];
 *	}
 * @param image_name Name of the image
 * @param app_name Optional, image is from an app instead of api
 * @returns {CSSResult}
 */
function cssImage(image_name, app_name) {
  var url = (egw$1 === null || egw$1 === void 0 ? void 0 : egw$1.image) && (egw$1 === null || egw$1 === void 0 ? void 0 : egw$1.image(image_name, app_name));
  if (url) {
    return i$b(_templateObject2$J || (_templateObject2$J = _taggedTemplateLiteral$1b(["url(", ")"])), r$7(url));
  } else {
    return i$b(_templateObject3$s || (_templateObject3$s = _taggedTemplateLiteral$1b([""])));
  }
}

function _defineProperty$2e(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class ClassWithInterfaces {
  /**
   * The implements function can be used to check whether the object
   * implements the given interface.
   *
   * As TypeScript can not (yet) check if an objects implements an interface on runtime,
   * we currently implements with each interface a function called 'implements_'+interfacename
   * to be able to check here.
   *
   * @param _iface name of interface to check
   */
  implements(_iface_name) {
    if (typeof et2_implements_registry[_iface_name] === 'function' && et2_implements_registry[_iface_name](this)) {
      return true;
    }
    return false;
  }

  /**
   * Check if object is an instance of a class or implements an interface (specified by the interfaces name)
   *
   * @param _class_or_interfacename class(-name) or string with name of interface
   */
  instanceOf(_class_or_interfacename) {
    if (typeof _class_or_interfacename === 'string') {
      return this.implements(_class_or_interfacename);
    }
    if (_class_or_interfacename === Et2Widget) {
      return true;
    }
    return this instanceof _class_or_interfacename;
  }
}
class ClassWithAttributes extends ClassWithInterfaces {
  constructor() {
    super(...arguments);
    /**
     * Object to collect the attributes we operate on
     */
    _defineProperty$2e(this, "attributes", void 0);
  }
  /**
   * Returns the value of the given attribute. If the property does not
   * exist, an error message is issued.
   *
   * @param {string} _name
   * @return {*}
   */
  getAttribute(_name) {
    if (typeof this.attributes[_name] != "undefined" && !this.attributes[_name].ignore) {
      if (typeof this["get_" + _name] == "function") {
        return this["get_" + _name]();
      } else {
        return this[_name];
      }
    } else {
      egw$1.debug("error", this, "Attribute '" + _name + "' does not exist!");
    }
  }

  /**
   * The setAttribute function sets the attribute with the given name to
   * the given value. _override defines, whether this[_name] will be set,
   * if this key already exists. _override defaults to true. A warning
   * is issued if the attribute does not exist.
   *
   * @param {string} _name
   * @param {*} _value
   * @param {boolean} _override
   */
  setAttribute(_name, _value, _override) {
    if (typeof this.attributes[_name] != "undefined") {
      if (!this.attributes[_name].ignore) {
        if (typeof _override == "undefined") {
          _override = true;
        }
        var val = et2_checkType(_value, this.attributes[_name].type, _name, this);
        if (typeof this["set_" + _name] == "function") {
          this["set_" + _name](val);
        } else if (_override || typeof this[_name] == "undefined") {
          this[_name] = val;
        }
      }
    } else {
      egw$1.debug("warn", this, "Attribute '" + _name + "' does not exist!");
    }
  }

  /**
   * generateAttributeSet sanitizes the given associative array of attributes
   * (by passing each entry to "et2_checkType" and checking for existance of
   * the attribute) and adds the default values to the associative array.
   *
   * @param {object} _attrs is the associative array containing the attributes.
   */
  static generateAttributeSet(widget, _attrs) {
    // Sanity check and validation
    for (var key in _attrs) {
      if (typeof widget[key] != "undefined") {
        if (!widget[key].ignore) {
          _attrs[key] = et2_checkType(_attrs[key], widget[key].type, key, this);
        }
      } else {
        // Key does not exist - delete it and issue a warning
        delete _attrs[key];
        egw$1.debug("warn", this, "Attribute '" + key + "' does not exist in " + _attrs.type + "!");
      }
    }

    // Include default values or already set values for this attribute
    for (var key in widget) {
      if (typeof _attrs[key] == "undefined") {
        var _default = widget[key]["default"];
        if (_default == et2_no_init) {
          _default = undefined;
        }
        _attrs[key] = _default;
      }
    }
    return _attrs;
  }

  /**
   * The initAttributes function sets the attributes to their default
   * values. The attributes are not overwritten, which means, that the
   * default is only set, if either a setter exists or this[propName] does
   * not exist yet.
   *
   * @param {object} _attrs is the associative array containing the attributes.
   */
  initAttributes(_attrs) {
    for (var key in _attrs) {
      if (typeof this.attributes[key] != "undefined" && !this.attributes[key].ignore && !(_attrs[key] == undefined)) {
        this.setAttribute(key, _attrs[key], false);
      }
    }
  }
  static buildAttributes(class_prototype) {
    var class_tree = [];
    var attributes = {};
    var n = 0;
    do {
      n++;
      class_tree.push(class_prototype);
      class_prototype = Object.getPrototypeOf(class_prototype);
    } while (class_prototype && class_prototype !== ClassWithAttributes && n < 50);
    for (var i = class_tree.length - 1; i >= 0; i--) {
      attributes = ClassWithAttributes.extendAttributes(attributes, class_tree[i]._attributes);
    }
    return attributes;
  }

  /**
   * Extend current _attributes with the one from the parent class
   *
   * This gives inheritance from the parent plus the ability to override in the current class.
   *
   * @param _attributes
   * @param _parent
   */
  static extendAttributes(_parent, _attributes) {
    function _copyMerge(_new, _old) {
      var result = {};

      // Copy the new object
      if (typeof _new != "undefined") {
        for (var key in _new) {
          result[key] = _new[key];
        }
      }

      // Merge the old object
      for (var key in _old) {
        if (typeof result[key] == "undefined") {
          result[key] = _old[key];
        }
      }
      return result;
    }
    var attributes = {};

    // Copy the old attributes
    for (var key in _attributes) {
      attributes[key] = _copyMerge({}, _attributes[key]);
    }

    // Add the old attributes to the new ones. If the attributes already
    // exist, they are merged.
    for (var key in _parent) {
      var _old = _parent[key];
      attributes[key] = _copyMerge(attributes[key], _old);
    }

    // Validate the attributes
    for (var key in attributes) {
      et2_validateAttrib(key, attributes[key]);
    }
    return attributes;
  }
}

function _defineProperty$2d(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
// fixing circular dependencies by only importing type

/**
 * The registry contains all XML tag names and the corresponding widget
 * constructor.
 */
var et2_registry = {};
var et2_attribute_registry = {};

/**
 * Registers the widget class defined by the given constructor, registers all its class attributes, and associates it
 * with the types in the _types array.
 *
 * @param {function} _constructor constructor
 * @param {array} _types widget types _constructor wants to register for
 */
function et2_register_widget(_constructor, _types) {
  "use strict";

  et2_attribute_registry[_constructor.name] = ClassWithAttributes.buildAttributes(_constructor);
  // Iterate over all given types and register those
  for (var i = 0; i < _types.length; i++) {
    var type = _types[i].toLowerCase();

    // Check whether a widget has already been registered for one of the
    // types.
    if (et2_registry[type]) {
      egw$1.debug("warn", "Widget class registered for " + type + " will be overwritten.");
    }
    et2_registry[type] = _constructor;
  }
}

/**
 * Creates a widget registered for the given tag-name. If "readonly" is listed
 * inside the attributes, et2_createWidget will try to use the "_ro" type of the
 * widget.
 *
 * @param _name is the name of the widget with which it is registered. If the
 * 	widget is not found, an et2_placeholder will be created.
 * @param _attrs is an associative array with attributes. If not passed, it will
 * 	default to an empty object.
 * @param _parent is the parent to which the element will be attached. If _parent
 * 	is not passed, it will default to null. Then you have to attach the element
 * 	to a parent using the addChild or insertChild method.
 */
function et2_createWidget(_name, _attrs, _parent) {
  "use strict";

  if (typeof _attrs == "undefined") {
    _attrs = {};
  }
  if (typeof _attrs != "object") {
    _attrs = {};
  }
  if (typeof _parent == "undefined") {
    _parent = null;
  }

  // check and return web-components in case widget is no longer available as legacy widget
  if (typeof et2_registry[_name] === "undefined" && window.customElements.get('et2-' + _name)) {
    return loadWebComponent('et2-' + _name, _attrs, _parent);
  }

  // Parse the "readonly" and "type" flag for this element here, as they
  // determine which constructor is used
  var nodeName = _attrs["type"] = _name;
  var readonly = _attrs["readonly"] = typeof _attrs["readonly"] === "undefined" ? false : _attrs["readonly"];

  // Get the constructor - if the widget is readonly, use the special "_ro"
  // constructor if it is available
  if (typeof et2_registry[nodeName] === "undefined") {
    nodeName = 'placeholder';
  }
  var constructor = et2_registry[nodeName];
  if (readonly && typeof et2_registry[nodeName + "_ro"] !== "undefined") {
    constructor = et2_registry[nodeName + "_ro"];
  }

  // Do a sanity check for the attributes
  ClassWithAttributes.generateAttributeSet(et2_attribute_registry[constructor.name], _attrs);
  // Create the new widget and return it
  return new constructor(_parent, _attrs);
}

// make et2_createWidget publicly available as we need to call it from stylite/js/gantt.js (maybe others)
if (typeof window.et2_createWidget === 'undefined') window['et2_createWidget'] = et2_createWidget;
/**
 * The et2 widget base class.
 *
 * @augments ClassWithAttributes
 */
class et2_widget extends ClassWithAttributes {
  /**
   * Widget constructor
   *
   * To implement the attributes inheritance and overriding each extending class/widget needs to call:
   *
   * 	super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_DOMWidget._attributes, _child || {}));
   *
   * @param _parent is the parent object from the XML tree which contains this
   * 	object. The default constructor always adds the new instance to the
   * 	children list of the given parent object. _parent may be NULL.
   * @param _attrs is an associative array of attributes.
   * @param _child attributes object from the child
   */
  constructor(_parent, _attrs, _child) {
    super(); // because we in the top of the widget hierarchy
    _defineProperty$2d(this, "_type", void 0);
    _defineProperty$2d(this, "id", void 0);
    _defineProperty$2d(this, "supportedWidgetClasses", void 0);
    _defineProperty$2d(this, "options", void 0);
    _defineProperty$2d(this, "readonly", void 0);
    _defineProperty$2d(this, "_parent", void 0);
    _defineProperty$2d(this, "_children", []);
    _defineProperty$2d(this, "_egw", void 0);
    _defineProperty$2d(this, "_mgrs", {});
    /**
     * This is used and therefore it we can not (yet) make it private
     *
     * @deprecated use this.getInstanceMgr()
     */
    _defineProperty$2d(this, "_inst", null);
    this.attributes = ClassWithAttributes.extendAttributes(et2_widget._attributes, _child || {});

    // Check whether all attributes are available
    if (typeof _parent == "undefined") {
      _parent = null;
    }
    if (typeof _attrs == "undefined") {
      _attrs = {};
    }
    if (_attrs.attributes) {
      jQuery.extend(_attrs, _attrs.attributes);
    }
    // Initialize all important parameters
    this._mgrs = {};
    this._inst = null;
    this._children = [];
    this._type = _attrs["type"];
    this.id = _attrs["id"];

    // Add this widget to the given parent widget
    if (_parent != null) {
      _parent.addChild(this);
    }

    // The supported widget classes array defines a whitelist for all widget
    // classes or interfaces child widgets have to support.
    this.supportedWidgetClasses = [et2_widget, HTMLElement];
    if (_attrs["id"]) {
      // Create a namespace for this object
      if (this._createNamespace()) {
        this.checkCreateNamespace(_attrs);
      }
    }
    if (this.id) {
      //this.id = this.id.replace(/\[/g,'&#x5B;').replace(/]/g,'&#x5D;');
    }

    // Add all attributes hidden in the content arrays to the attributes
    // parameter
    this.transformAttributes(_attrs);

    // Create a local copy of the options object
    this.options = et2_cloneObject(_attrs);
  }

  /**
   * The destroy function destroys all children of the widget, removes itself
   * from the parents children list.
   * In all classes derrived from et2_widget ALWAYS override the destroy
   * function and remove ALL references to other objects. Also remember to
   * unbind ANY event this widget created and to remove all DOM-Nodes it
   * created.
   */
  destroy() {
    // Call the destructor of all children
    for (var i = this._children.length - 1; i >= 0; i--) {
      this._children[i].destroy();
    }

    // Remove this element from the parent, if it exists
    if (typeof this._parent != "undefined" && this._parent !== null && this._parent instanceof et2_widget) {
      this._parent.removeChild(this);
    }

    // Free the array managers if they belong to this widget
    for (var key in this._mgrs) {
      if (this._mgrs[key] && this._mgrs[key].owner == this) {
        this._mgrs[key].destroy();
      }
    }
  }
  getType() {
    return this._type;
  }
  setType(_type) {
    this._type = _type;
  }

  /**
   * Creates a copy of this widget. The parameters given are passed to the
   * constructor of the copied object. If the parameters are omitted, _parent
   * is defaulted to null
   *
   * @param {et2_widget} _parent parent to set for clone, default null
   */
  clone(_parent) {
    // Default _parent to null
    if (typeof _parent == "undefined") {
      _parent = null;
    }

    // Create the copy
    var copy = new this.constructor(_parent, this.options);

    // Assign this element to the copy
    copy.assign(this);
    return copy;
  }
  assign(_obj) {
    if (typeof _obj._children == "undefined") {
      this.egw().debug("log", "Foo!");
    }

    // Create a clone of all child elements of the given object
    for (var i = 0; i < _obj._children.length; i++) {
      _obj._children[i].clone(this);
    }

    // Copy a reference to the content array manager
    this.setArrayMgrs(_obj.mgrs);
  }
  /**
   * Returns the parent widget of this widget
   */
  getParent() {
    return this._parent;
  }
  /**
   * Returns the list of children of this widget.
   */
  getChildren() {
    return this._children;
  }

  /**
   * Returns the base widget
   */
  getRoot() {
    if (this._parent != null) {
      return this._parent.getRoot();
    } else {
      return this;
    }
  }

  /**
   * Inserts an child at the end of the list.
   *
   * @param _node is the node which should be added. It has to be an instance
   * 	of et2_widget
   */
  addChild(_node) {
    this.insertChild(_node, this._children.length);
  }

  /**
   * Inserts a child at the given index.
   *
   * @param _node is the node which should be added. It has to be an instance
   * 	of et2_widget
   * @param _idx is the position at which the element should be added.
   */
  insertChild(_node, _idx) {
    // Check whether the node is one of the supported widget classes.
    if (this.isOfSupportedWidgetClass(_node)) {
      // Remove the node from its original parent
      if (_node._parent) {
        _node._parent.removeChild(_node);
      }
      _node._parent = this;
      this._children.splice(_idx, 0, _node);
    } else {
      this.egw().debug("error", "Widget " + _node._type + " is not supported by this widget class", this);
      //			throw("Widget is not supported by this widget class!");
    }
  }

  /**
   * Removes the child but does not destroy it.
   *
   * @param {et2_widget} _node child to remove
   */
  removeChild(_node) {
    // Retrieve the child from the child list
    var idx = this._children.indexOf(_node);
    if (idx >= 0) {
      // This element is no longer parent of the child
      _node._parent = null;
      this._children.splice(idx, 1);
    }
  }

  /**
   * Searches an element by id in the tree, descending into the child levels.
   *
   * @param _id is the id you're searching for
   */
  getWidgetById(_id) {
    if (this.id == _id) {
      return this;
    }
    if (!this._children) return null;
    for (var i = 0; i < this._children.length; i++) {
      var elem = this._children[i].getWidgetById(_id);
      if (elem != null) {
        return elem;
      }
    }
    if (this.id && _id.indexOf('[') > -1 && this._children.length) {
      var ids = new et2_arrayMgr().explodeKey(_id);
      var widget = this;
      for (var i = 0; i < ids.length && widget !== null; i++) {
        widget = widget.getWidgetById(ids[i]);
      }
      return widget;
    }
    return null;
  }

  /**
   * Function which allows iterating over the complete widget tree.
   *
   * @param _callback is the function which should be called for each widget
   * @param _context is the context in which the function should be executed
   * @param _type is an optional parameter which specifies a class/interface
   * 	the elements have to be instanceOf.
   */
  iterateOver(_callback, _context, _type) {
    if (typeof _type == "undefined") {
      _type = et2_widget;
    }
    if (this.isInTree() && this.instanceOf(_type)) {
      _callback.call(_context, this);
    }
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].iterateOver(_callback, _context, _type);
    }
  }

  /**
   * Returns true if the widget currently resides in the visible part of the
   * widget tree. E.g. Templates which have been cloned are not in the visible
   * part of the widget tree.
   *
   * @param _sender
   * @param {boolean} _vis can be used by widgets overwriting this function - simply
   * 	write
   * 		return this._super(inTree);
   *	when calling this function the _vis parameter does not have to be supplied.
   */
  isInTree(_sender, _vis) {
    if (typeof _vis == "undefined") {
      _vis = true;
    }
    if (this._parent) {
      return _vis && this._parent.isInTree(this);
    }
    return _vis;
  }
  isOfSupportedWidgetClass(_obj) {
    for (var i = 0; i < this.supportedWidgetClasses.length; i++) {
      if (_obj instanceof this.supportedWidgetClasses[i]) {
        return true;
      }
    }
    return false;
  }

  /**
   * The parseXMLAttrs function takes an XML DOM attributes object
   * and adds the given attributes to the _target associative array. This
   * function also parses the legacyOptions.
   *
   * @param _attrsObj is the XML DOM attributes object
   * @param {object} _target is the object to which the attributes should be written.
   * @param {et2_widget} _proto prototype with attributes and legacyOptions attribute
   */
  parseXMLAttrs(_attrsObj, _target, _proto) {
    // Check whether the attributes object is really existing, if not abort
    if (typeof _attrsObj == "undefined") {
      return;
    }

    // Iterate over the given attributes and parse them
    var mgr = this.getArrayMgr("content");
    for (var i = 0; i < _attrsObj.length; i++) {
      var attrName = _attrsObj[i].name;
      var attrValue = _attrsObj[i].value;

      // Special handling for the legacy options
      if (attrName == "options" && _proto.constructor.legacyOptions && _proto.constructor.legacyOptions.length > 0) {
        var legacy = _proto.constructor.legacyOptions || [];
        var attrs = et2_attribute_registry[Object.getPrototypeOf(_proto).constructor.name] || {};
        // Check for modifications on legacy options here.  Normal modifications
        // are handled in widget constructor, but it's too late for legacy options then
        if (_target.id && this.getArrayMgr("modifications").getEntry(_target.id)) {
          var mod = this.getArrayMgr("modifications").getEntry(_target.id);
          if (typeof mod.options != "undefined") attrValue = _attrsObj[i].value = mod.options;
        }
        // expand legacyOptions with content
        if (attrValue.charAt(0) == '@' || attrValue.indexOf('$') != -1) {
          attrValue = mgr.expandName(attrValue);
        }

        // Parse the legacy options (as a string, other types not allowed)
        var splitted = et2_csvSplit(attrValue + "");
        for (var j = 0; j < splitted.length && j < legacy.length; j++) {
          // Blank = not set, unless there's more legacy options provided after
          if (splitted[j].trim().length === 0 && legacy.length >= splitted.length) continue;

          // Check to make sure we don't overwrite a current option with a legacy option
          if (typeof _target[legacy[j]] === "undefined") {
            attrValue = splitted[j];

            /**
            If more legacy options than expected, stuff them all in the last legacy option
            Some legacy options take a comma separated list.
             */
            if (j == legacy.length - 1 && splitted.length > legacy.length) {
              attrValue = splitted.slice(j);
            }
            var attr = et2_attribute_registry[_proto.constructor.name][legacy[j]] || {};

            // If the attribute is marked as boolean, parse the
            // expression as bool expression.
            if (attr.type == "boolean") {
              attrValue = mgr.parseBoolExpression(attrValue);
            } else if (typeof attrValue != "object") {
              attrValue = mgr.expandName(attrValue);
            }
            _target[legacy[j]] = attrValue;
          }
        }
      } else if (attrName == "readonly" && typeof _target[attrName] != "undefined") {
        // do NOT overwrite already evaluated readonly attribute
      } else {
        var _attrs2 = et2_attribute_registry[_proto.constructor.name] || {};
        if (mgr != null && typeof _attrs2[attrName] != "undefined") {
          var attr = _attrs2[attrName];

          // If the attribute is marked as boolean, parse the
          // expression as bool expression.
          if (attr.type == "boolean") {
            attrValue = mgr.parseBoolExpression(attrValue);
          } else {
            attrValue = mgr.expandName(attrValue);
          }
        }

        // Set the attribute
        _target[attrName] = attrValue;
      }
    }
  }

  /**
   * Apply the "modifications" to the element and translate attributes marked
   * with "translate: true"
   *
   * @param {object} _attrs
   */
  transformAttributes(_attrs) {
    var _this = this;
    // Apply the content of the modifications array
    if (this.id) {
      if (typeof this.id != "string") {
        console.log(this.id);
      }
      if (this.getArrayMgr("modifications")) {
        var data = this.getArrayMgr("modifications").getEntry(this.id);

        // Check for already inside namespace
        if (this._createNamespace() && this.getArrayMgr("modifications").perspectiveData.owner == this) {
          data = this.getArrayMgr("modifications").data;
        }
        if (typeof data === 'object') {
          for (var key in data) {
            _attrs[key] = data[key];
          }
        }
      }
    }

    // Translate the attributes
    var _loop = function _loop() {
      if (_attrs[key] && typeof _this.attributes[key] != "undefined") {
        if (_this.attributes[key].translate === true || _this.attributes[key].translate === "!no_lang" && !_attrs["no_lang"]) {
          var value = _attrs[key];
          // allow statustext to contain multiple translated sub-strings eg: {Firstname}.{Lastname}
          if (value.indexOf('{') !== -1) {
            var _egw2 = _this.egw();
            _attrs[key] = value.replace(/{([^}]+)}/g, function (str, p1) {
              return _egw2.lang(p1);
            });
          } else {
            _attrs[key] = _this.egw().lang(value);
          }
        }
      }
    };
    for (var key in _attrs) {
      _loop();
    }
  }

  /**
   * Create a et2_widget from an XML node.
   *
   * First the type and attributes are read from the node.  Then the readonly & modifications
   * arrays are checked for changes specific to the loaded data.  Then the appropriate
   * constructor is called.  After the constructor returns, the widget has a chance to
   * further initialize itself from the XML node when the widget's loadFromXML() method
   * is called with the node.
   *
   * @param _node XML node to read
   * @param _name XML node name
   *
   * @return et2_widget
   */
  createElementFromNode(_node, _name) {
    var attributes = {};

    // Parse the "readonly" and "type" flag for this element here, as they
    // determine which constructor is used
    var _nodeName = attributes["type"] = _node.getAttribute("type") ? _node.getAttribute("type") : _node.nodeName.toLowerCase();
    var readonly = attributes["readonly"] = this.getArrayMgr("readonlys") ? this.getArrayMgr("readonlys").isReadOnly(_node.getAttribute("id"), _node.getAttribute("readonly"), typeof this.readonly !== 'undefined' ? this.readonly : this.options.readonly) : false;

    // Check to see if modifications change type
    var modifications = this.getArrayMgr("modifications");
    if (modifications && _node.getAttribute("id")) {
      var entry = modifications.getEntry(_node.getAttribute("id"));
      if (entry == null) {
        // Try again, but skip the fancy stuff
        // TODO: Figure out why the getEntry() call doesn't always work
        var entry = modifications.data[_node.getAttribute("id")];
        if (entry) {
          this.egw().debug("warn", "getEntry(" + _node.getAttribute("id") + ") failed, but the data is there.", modifications, entry);
        } else {
          // Try the root, in case a namespace got missed
          entry = modifications.getRoot().getEntry(_node.getAttribute("id"));
        }
      }
      if (entry && entry.type && typeof entry.type === 'string') {
        _nodeName = attributes["type"] = entry.type;
      }
      entry = null;
    }

    // if _nodeName / type-attribute contains something to expand (eg. type="@${row}[type]"),
    // we need to expand it now as it defines the constructor and by that attributes parsed via parseXMLAttrs!
    if (_nodeName.charAt(0) == '@' || _nodeName.indexOf('$') >= 0) {
      _nodeName = attributes["type"] = this.getArrayMgr('content').expandName(_nodeName);
    }

    // check and return web-components in case widget is no longer available as legacy widget
    if (typeof et2_registry[_nodeName] === "undefined" && window.customElements.get('et2-' + _nodeName)) {
      return loadWebComponent('et2-' + _nodeName, _node, this);
    }

    // Get the constructor - if the widget is readonly, use the special "_ro"
    // constructor if it is available
    if (typeof et2_registry[_nodeName] === "undefined" && typeof window.customElements.get(_nodeName) == "undefined") {
      _nodeName = 'placeholder';
    }
    var constructor = et2_registry[_nodeName];
    if (readonly === true && typeof et2_registry[_nodeName + "_ro"] != "undefined") {
      constructor = et2_registry[_nodeName + "_ro"];
    }
    if (typeof window.customElements.get(_nodeName) !== "undefined") {
      widget = loadWebComponent(_nodeName, _node, this);
    } else {
      // Parse the attributes from the given XML attributes object
      this.parseXMLAttrs(_node.attributes, attributes, constructor.prototype);

      // Do an sanity check for the attributes
      ClassWithAttributes.generateAttributeSet(et2_attribute_registry[constructor.name], attributes);

      // Creates the new widget, passes this widget as an instance and
      // passes the widgetType. Then it goes on loading the XML for it.
      var widget = new constructor(this, attributes);

      // Load the widget itself from XML
      widget.loadFromXML(_node);
    }
    return widget;
  }

  /**
   * Loads the widget tree from an XML node
   *
   * @param _node xml node
   */
  loadFromXML(_node) {
    // Load the child nodes.
    for (var i = 0; i < _node.childNodes.length; i++) {
      var node = _node.childNodes[i];
      var widgetType = node.nodeName.toLowerCase();
      if (widgetType == "#comment") {
        continue;
      }
      if (widgetType == "#text") {
        if (node.data.replace(/^\s+|\s+$/g, '')) {
          this.loadContent(node.data);
        }
        continue;
      }

      // Create the new element
      this.createElementFromNode(node);
    }
  }

  /**
   * Called whenever textNodes are loaded from the XML tree
   *
   * @param _content
   */
  loadContent(_content) {}

  /**
   * Called when loading the widget (sub-tree) is finished. First when this
   * function is called, the DOM-Tree is created. loadingFinished is
   * recursively called for all child elements. Do not directly override this
   * function but the doLoadingFinished function which is executed before
   * descending deeper into the DOM-Tree.
   *
   * Some widgets (template) do not load immediately because they request
   * additional resources via AJAX.  They will return a Deferred Promise object.
   * If you call loadingFinished(promises) after creating such a widget
   * programmatically, you might need to wait for it to fully complete its
   * loading before proceeding.  In that case use:
   * <code>
   * var promises = [];
   * widget.loadingFinished(promises);
   * jQuery.when.apply(null, promises).done( doneCallback );
   * </code>
   * @see {@link http://api.jquery.com/category/deferred-object/|jQuery Deferred}
   *
   * @param {Promise[]} promises List of promises from widgets that are not done.  Pass an empty array, it will be filled if needed.
   */
  loadingFinished(promises) {
    // Call all availble setters
    this.initAttributes(this.options);

    // Make sure promises is defined to avoid errors.
    // We'll warn (below) if programmer should have passed it.
    if (typeof promises == "undefined") {
      promises = [];
      var warn_if_deferred = true;
    }
    var loadChildren = function loadChildren() {
      // Descend recursively into the tree
      for (var i = 0; i < this._children.length; i++) {
        try {
          this._children[i].loadingFinished(promises);
        } catch (e) {
          egw$1.debug("error", "There was an error with a widget:\nError:%o\nProblem widget:%o", e.valueOf(), this._children[i], e.stack);
        }
      }
    };
    var result = this.doLoadingFinished();
    if (typeof result == "boolean" && result) {
      // Simple widget finishes nicely
      loadChildren.apply(this, arguments);
    } else if (typeof result == "object" && result.then) {
      // Warn if list was not provided
      if (warn_if_deferred) {
        // Might not be a problem, but if you need the widget to be really loaded, it could be
        egw$1.debug("warn", "Loading was deferred for widget %o, but creator is not checking.  Pass a list to loadingFinished().", this);
      }
      // Widget is waiting.  Add to the list
      promises.push(result);
      // Fihish loading when it's finished
      result.then(loadChildren.bind(this));
    }
  }

  /**
   * The initAttributes function sets the attributes to their default
   * values. The attributes are not overwritten, which means, that the
   * default is only set, if either a setter exists or this[propName] does
   * not exist yet.
   *
   * Overwritten here to compile legacy JS code in attributes of type "js"
   *
   * @param {object} _attrs
   */
  initAttributes(_attrs) {
    for (var key in _attrs) {
      if (typeof this.attributes[key] != "undefined" && !this.attributes[key].ignore && !(_attrs[key] == undefined)) {
        var val = _attrs[key];
        // compile string values of attribute type "js" to functions
        if (this.attributes[key].type == 'js' && typeof _attrs[key] == 'string') {
          val = et2_compileLegacyJS(val, this, this.implements(et2_IInputNode) ? this.getInputNode() : this.implements(et2_IDOMNode) ? this.getDOMNode() : null);
        }
        this.setAttribute(key, val, false);
      }
    }
  }

  /**
   * Does specific post-processing after the widget is loaded.  Most widgets should not
   * need to do anything here, it should all be done before.
   *
   * @return {boolean|Promise} True if the widget is fully loaded, false to avoid procesing children,
   * or a Promise if loading is not actually finished (eg. waiting for AJAX)
   *
   * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise Promise}
   */
  doLoadingFinished() {
    return true;
  }
  /**
   * The egw function returns the instance of the client side api belonging
   * to this widget tree. The api instance can be set in the "container"
   * widget using the setApiInstance function.
   */
  egw() {
    // The _egw property is not set
    if (typeof this._egw === 'undefined') {
      if (this._parent != null) {
        return this._parent.egw();
      }

      // Get the window this object belongs to
      var wnd = null;
      if (this.implements(et2_IDOMNode)) {
        var node = this.getDOMNode();
        if (node && node.ownerDocument) {
          wnd = node.ownerDocument.parentNode || node.ownerDocument.defaultView;
        }
      }

      // If we're the root object, return the phpgwapi API instance
      return egw$1('phpgwapi', wnd);
    }
    return this._egw;
  }

  /**
   * Sets the client side api instance. It can be retrieved by the widget tree
   * by using the "egw()" function.
   *
   * @param {IegwAppLocal} _egw egw object to set
   */
  setApiInstance(_egw) {
    this._egw = _egw;
  }
  /**
   * Sets all array manager objects - this function can be used to set the
   * root array managers of the container object.
   *
   * @param {object} _mgrs
   */
  setArrayMgrs(_mgrs) {
    this._mgrs = et2_cloneObject(_mgrs);
  }

  /**
   * Returns an associative array containing the top-most array managers.
   *
   * @param _mgrs is used internally and should not be supplied.
   */
  getArrayMgrs(_mgrs) {
    if (typeof _mgrs == "undefined") {
      _mgrs = {};
    }

    // Add all managers of this object to the result, if they have not already
    // been set in the result
    for (var key in this._mgrs) {
      if (typeof _mgrs[key] == "undefined") {
        _mgrs[key] = this._mgrs[key];
      }
    }

    // Recursively applies this function to the parent widget
    if (this._parent) {
      this._parent.getArrayMgrs(_mgrs);
    }
    return _mgrs;
  }

  /**
   * Sets the array manager for the given part
   *
   * @param {string} _part which array mgr to set
   * @param {object} _mgr
   */
  setArrayMgr(_part, _mgr) {
    this._mgrs[_part] = _mgr;
  }

  /**
   * Returns the array manager object for the given part
   *
   * @param {string} managed_array_type name of array mgr to return
   */
  getArrayMgr(managed_array_type) {
    if (this._mgrs && typeof this._mgrs[managed_array_type] != "undefined") {
      return this._mgrs[managed_array_type];
    } else if (this._parent) {
      return this._parent.getArrayMgr(managed_array_type);
    }
    return null;
  }

  /**
   * Checks whether a namespace exists for this element in the content array.
   * If yes, an own perspective of the content array is created. If not, the
   * parent content manager is used.
   *
   * Constructor attributes are passed in case a child needs to make decisions
   */
  checkCreateNamespace(_attrs) {
    // Get the content manager
    var mgrs = this.getArrayMgrs();
    for (var key in mgrs) {
      var mgr = mgrs[key];

      // Get the original content manager if we have already created a
      // perspective for this node
      if (typeof this._mgrs[key] != "undefined" && mgr.perspectiveData.owner == this) {
        mgr = mgr.parentMgr;
      }

      // Check whether the manager has a namespace for the id of this object
      var entry = mgr.getEntry(this.id);
      if (typeof entry === 'object' && entry !== null || this.id) {
        // The content manager has an own node for this object, so
        // create an own perspective.
        this._mgrs[key] = mgr.openPerspective(this, this.id);
      } else {
        // The current content manager does not have an own namespace for
        // this element, so use the content manager of the parent.
        delete this._mgrs[key];
      }
    }
  }

  /**
   * Widgets that do support a namespace should override and return true.
   *
   * Since a private attribute doesn't get instanciated properly before it's needed,
   * we use a method so we can get what we need while still in the constructor.
   *
   * @private
   */
  _createNamespace() {
    return false;
  }
  /**
   * Sets the instance manager object (of type etemplate2, see etemplate2.js)
   *
   * @param {etemplate2} _inst
   */
  setInstanceManager(_inst) {
    this._inst = _inst;
  }

  /**
   * Returns the instance manager
   *
   * @return {etemplate2}
   */
  getInstanceManager() {
    if (this._inst != null) {
      return this._inst;
    } else if (this._parent) {
      return this._parent.getInstanceManager();
    }
    return null;
  }

  /**
   * Returns the path into the data array.  By default, array manager takes care of
   * this, but some extensions need to override this
   */
  getPath() {
    var path = this.getArrayMgr("content").getPath();

    // Prevent namespaced widgets with value from going an extra layer deep
    if (this.id && this._createNamespace() && path[path.length - 1] == this.id) path.pop();
    return path;
  }
}
_defineProperty$2d(et2_widget, "_attributes", {
  "id": {
    "name": "ID",
    "type": "string",
    "description": "Unique identifier of the widget"
  },
  "no_lang": {
    "name": "No translation",
    "type": "boolean",
    "default": false,
    "description": "If true, no translations are made for this widget"
  },
  /**
   * Ignore the "span" property by default - it is read by the grid and
   * other widgets.
   */
  "span": {
    "ignore": true
  },
  /**
   * Ignore the "type" tag - it is read by the "createElementFromNode"
   * function and passed as second parameter of the widget constructor
   */
  "type": {
    "name": "Widget type",
    "type": "string",
    "ignore": true,
    "description": "What kind of widget this is"
  },
  /**
   * Ignore the readonly tag by default - its also read by the
   * "createElementFromNode" function.
   */
  "readonly": {
    "ignore": true
  },
  /**
   * Widget's attributes
   */
  attributes: {
    "name": "Widget attributes",
    "type": "any",
    "ignore": true,
    "description": "Object of widget attributes"
  }
});
// Set the legacyOptions array to the names of the properties the "options"
// attribute defines.
_defineProperty$2d(et2_widget, "legacyOptions", []);

function _defineProperty$2c(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * eGroupWare egw_action framework - JS Menu abstraction
 *
 * @link http://www.egroupware.org
 * @author Andreas Stöckel <as@stylite.de>
 * @copyright 2011 by Andreas Stöckel
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package egw_action
 * @version $Id$
 */

/**
 *
 * @param {type} _structure
 */
class egwMenuImpl {
  constructor(_structure) {
    _defineProperty$2c(this, "dhtmlxmenu", void 0);
    //Create a new dhtmlxmenu object
    // @ts-ignore       //origin not easily ts compatible --> soon to be replaced by shoelace anyway
    this.dhtmlxmenu = new dhtmlXMenuObject();
    this.dhtmlxmenu.setSkin("egw");
    this.dhtmlxmenu.renderAsContextMenu();
    // TODO: Keyboard navigation of the menu

    //Attach the simple click handler
    this.dhtmlxmenu.attachEvent("onClick", id => {
      if (id) {
        var elem = this.dhtmlxmenu.getUserData(id, 'egw_menu');
        if (elem && elem.onClick) {
          if (elem.checkbox) {
            this.dhtmlxmenu.setContextMenuHideAllMode(false);
          }
          var res = elem.onClick(elem);
          if (elem.checkbox && (res === false || res === true)) {
            var checked = res;
            if (elem.groupIndex != 0) {
              this.dhtmlxmenu.setRadioChecked(id, checked);
            } else {
              this.dhtmlxmenu.setCheckboxState(id, checked);
            }
          }
        }
      }
    });

    //Attach the radiobutton click handler
    this.dhtmlxmenu.attachEvent("onRadioClick", (group, idChecked, idClicked) => {
      if (idClicked) {
        var elem = this.dhtmlxmenu.getUserData(idClicked, 'egw_menu');
        if (elem) {
          elem.set_checked(true);
        }
      }
      return true;
    });

    //Attach the radiobutton click handler
    this.dhtmlxmenu.attachEvent("onCheckboxClick", (id, state) => {
      if (id) {
        var elem = this.dhtmlxmenu.getUserData(id, 'egw_menu');
        if (elem) {
          elem.set_checked(!state);
        }
      }
      return true;
    });

    //Translate the given structure to the dhtmlx object structure
    this._translateStructure(_structure, this.dhtmlxmenu.topId, 0);

    // Add disableIfNoEPL class to the relevant action's DOM
    for (var i in this.dhtmlxmenu.idPull) {
      if (this.dhtmlxmenu.userData[i + '_egw_menu'] && this.dhtmlxmenu.userData[i + '_egw_menu']['data'] && this.dhtmlxmenu.userData[i + '_egw_menu']['data']['disableIfNoEPL']) {
        this.dhtmlxmenu.idPull[i].className += ' disableIfNoEPL';
      }
    }
  }
  _translateStructure(_structure, _parentId, _idCnt) {
    //Initialize the counter which we will use to generate unique id's for all
    //dhtmlx menu objects
    var counter = 0;
    var last_id = null;
    _structure.forEach((elem, i) => {
      var id = elem.id || 'elem_' + (_idCnt + counter);
      counter++;

      //Check whether this element is a separator
      if (elem.caption == '-' && last_id != null) {
        //Add the separator next to last_id with the id "id"
        this.dhtmlxmenu.addNewSeparator(last_id, id);
      } else {
        if (elem.checkbox && elem.groupIndex === 0) {
          //Add checkbox
          this.dhtmlxmenu.addCheckbox("child", _parentId, i, id, elem.caption, elem.checked, !elem.enabled);
        } else if (elem.checkbox && elem.groupIndex > 0) {
          //Add radiobox
          elem._dhtmlx_grpid = "grp_" + _idCnt + '_' + elem.groupIndex;
          this.dhtmlxmenu.addRadioButton("child", _parentId, i, id, elem.caption, elem._dhtmlx_grpid, elem.checked, !elem.enabled);
        } else {
          var caption = elem.caption;
          if (elem.default) caption = "<b>" + caption + "</b>";
          this.dhtmlxmenu.addNewChild(_parentId, i, id, caption, !elem.enabled, elem.iconUrl, elem.iconUrl);
        }
        if (elem.shortcutCaption != null) {
          this.dhtmlxmenu.setHotKey(id, elem.shortcutCaption);
        }
        if (elem.children.length > 0) {
          counter += this._translateStructure(elem.children, id, _idCnt + counter);
        }
      }

      //Set the actual egw menu as user data element
      this.dhtmlxmenu.setUserData(id, 'egw_menu', elem);

      // Set the tooltip if one has been set
      if (elem.hint) {
        this.dhtmlxmenu.setTooltip(id, elem.hint);
      }
      last_id = id;
    });
    return counter;
  }
  showAt(_x, _y, _onHide) {
    if (_onHide) {
      this.dhtmlxmenu.attachEvent("onHide", id => {
        if (id === null) {
          _onHide();
        }
      });
    }
    window.setTimeout(() => {
      this.dhtmlxmenu.showContextMenu(_x, _y);
      // TODO: Get keyboard focus
    }, 0);
  }
  hide() {
    this.dhtmlxmenu.hide();
  }
}

function ownKeys$10(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$$(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$10(Object(source), true).forEach(function (key) { _defineProperty$2b(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$10(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$2b(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class EgwAction {
  set_caption(_value) {
    this.caption = _value;
  }
  set_iconUrl(_value) {
    this.iconUrl = _value;
  }
  /**
   * The allowOnMultiple property may be true, false, "only" (> 1) or number of select, e.g. 2
   *
   * @param {(boolean|string|number)} _value
   */
  set_allowOnMultiple(_value) {
    this.allowOnMultiple = _value;
  }
  set_enabled(_value) {
    this.enabled.setValue(_value);
  }
  // Data which can be freely assigned to the action
  /**
   * @deprecated just set the data parameter with '=' sign to use its setter
   * @param _value
   */
  set_data(_value) {
    this.data = _value;
  }
  /**
   * The set_onExecute function is the setter function for the onExecute event of
   * the EgwAction object. There are three possible types the passed "_value" may
   * take:
   *    1. _value may be a string with the word "javaScript:" prefixed. The function
   *       which is specified behind the colon and which has to be in the global scope
   *       will be executed.
   *    2. _value may be a boolean, which specifies whether the external onExecute handler
   *       (passed as "_handler" in the constructor) will be used.
   *    3. _value may be a JS function which will then be called.
   * In all possible situation, the called function will get the following parameters:
   *    1. A reference to this action
   *    2. The senders, an array of all objects (JS)/object ids (PHP) which evoked the event
   *
   * @param {(string|function|boolean)} _value
   */
  set_onExecute(_value) {
    this.onExecute.setValue(_value);
  }
  /**
   * Constructor for EgwAction object
   *
   * @param {EgwAction} _parent
   * @param {string} _id
   * @param {string} _caption
   * @param {string} _iconUrl
   * @param {(string|function)} _onExecute
   * @param {boolean} _allowOnMultiple
   * @returns {EgwAction}
   **/
  constructor(_parent, _id) {
    var _caption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
    var _iconUrl = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
    var _onExecute = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var _allowOnMultiple = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : true;
    _defineProperty$2b(this, "id", void 0);
    _defineProperty$2b(this, "caption", void 0);
    _defineProperty$2b(this, "group", void 0);
    _defineProperty$2b(this, "order", void 0);
    _defineProperty$2b(this, "iconUrl", void 0);
    _defineProperty$2b(this, "allowOnMultiple", void 0);
    _defineProperty$2b(this, "enabled", void 0);
    _defineProperty$2b(this, "hideOnDisabled", false);
    _defineProperty$2b(this, "data", {});
    _defineProperty$2b(this, "type", "default");
    //All derived classes have to override this!
    _defineProperty$2b(this, "canHaveChildren", false);
    //Has to be overwritten by inheriting action classes
    // this is not bool all the time. Can be ['popup'] e.g. List of egwActionClasses that are allowed to have children?
    _defineProperty$2b(this, "parent", void 0);
    _defineProperty$2b(this, "children", []);
    //i guess
    _defineProperty$2b(this, "onExecute", new EgwFnct(this, null, []));
    /**
     * Set to either a confirmation prompt, or TRUE to indicate that this action
     * cares about large selections and to ask the confirmation prompt(s)
     *
     * --set in egw_action_popup--
     * @param {String|Boolean} _value
     */
    _defineProperty$2b(this, "confirm_mass_selection", undefined);
    _defineProperty$2b(this, "hideOnMobile", false);
    _defineProperty$2b(this, "disableIfNoEPL", false);
    /**
     * Default icons for given id
     */
    _defineProperty$2b(this, "defaultIcons", {
      view: 'view',
      edit: 'edit',
      open: 'edit',
      // does edit if possible, otherwise view
      add: 'new',
      new: 'new',
      delete: 'delete',
      cat: 'attach',
      // add as category icon to api
      document: 'etemplate/merge',
      print: 'print',
      copy: 'copy',
      move: 'move',
      cut: 'cut',
      paste: 'editpaste',
      save: 'save',
      apply: 'apply',
      cancel: 'cancel',
      continue: 'continue',
      next: 'continue',
      finish: 'finish',
      back: 'back',
      previous: 'back',
      close: 'close'
    });
    if (_parent && (typeof _id != "string" || !_id) && _parent.type !== "actionManager") {
      throw "EgwAction _id must be a non-empty string!";
    }
    this.parent = _parent;
    this.id = _id;
    this.caption = _caption;
    this.iconUrl = _iconUrl;
    if (_onExecute !== null) {
      this.set_onExecute(_onExecute);
    }
    this.allowOnMultiple = _allowOnMultiple;
    this.enabled = new EgwFnct(this, true);
  }

  /**
   * Clears the element and removes it from the parent container
   */
  remove() {
    // Remove all references to the child elements
    this.children = [];
    // Remove this element from the parent list
    if (this.parent) {
      var idx = this.parent.children.indexOf(this);
      if (idx >= 0) {
        this.parent.children.splice(idx, 1);
      }
    }
  }

  /**
   * Searches for a specific action with the given id
   *
   * @param {(string|number)} _id ID of the action to find
   * @param {number} [_search_depth=Infinite] How deep into existing action children
   *    to search.
   *
   * @return {(EgwAction|null)}
   */
  getActionById(_id) {
    var _search_depth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Number.MAX_VALUE;
    // If the current action object has the given id, return this object
    if (this.id == _id) {
      return this;
    }
    // If this element is capable of having children, search those for the given
    // action id
    if (this.canHaveChildren) {
      for (var i = 0; i < this.children.length && _search_depth > 0; i++) {
        var elem = this.children[i].getActionById(_id, _search_depth - 1);
        if (elem) {
          return elem;
        }
      }
    }
    return null;
  }
  /**
   * Searches for actions having an attribute with a certain value
   *
   * Example: actionManager.getActionsByAttr("checkbox", true) returns all checkbox actions
   *
   * @param {string} _attr attribute name
   * @param _val attribute value
   * @return array
   */
  getActionsByAttr(_attr) {
    var _val = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
    var _actions = [];

    // If the current action object has the given attr AND value, or no value was provided, return it
    if (typeof this[_attr] != "undefined" && (this[_attr] === _val || typeof _val === "undefined" && this[_attr] !== null)) {
      _actions.push(this);
    }

    // If this element is capable of having children, search those too
    if (this.canHaveChildren) {
      for (var i = 0; i < this.children.length; i++) {
        _actions = _actions.concat(this.children[i].getActionsByAttr(_attr, _val));
      }
    }
    return _actions;
  }
  /**
   * Adds a new action to the child elements.
   *
   * @param {string} _type
   * @param {string} _id
   * @param {string} _caption
   * @param {string} _iconUrl
   * @param {(string|function)} _onExecute
   * @param {boolean} _allowOnMultiple
   */

  addAction(_type, _id) {
    var _caption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
    var _iconUrl = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
    var _onExecute = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var _allowOnMultiple = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : true;
    //Get the constructor for the given action type
    if (!(_type in window._egwActionClasses)) {
      _type = "popup";
    }

    // Only allow adding new actions, if this action class allows it.
    if (this.canHaveChildren) {
      var _window$_egwActionCla;
      var _constructor = (_window$_egwActionCla = window._egwActionClasses[_type]) === null || _window$_egwActionCla === void 0 ? void 0 : _window$_egwActionCla.actionConstructor;
      if (typeof _constructor == "function") {
        var action = new _constructor(this, _id, _caption, _iconUrl, _onExecute, _allowOnMultiple);
        this.children.push(action);
        return action;
      } else {
        throw "Given action type not registered.";
      }
    } else {
      throw "This action does not allow child elements!";
    }
  }
  /**
   * Updates the children of this element
   *
   * @param {object} _actions { id: action, ...}
   * @param {string} _app defaults to egw_getAppname()
   */
  updateActions(_actions, _app) {
    if (this.canHaveChildren) {
      if (typeof _app == "undefined") _app = window.egw(window).app_name();
      /*
      this is an egw Object as defined in egw_core.js
      probably not because it changes on runtime
       */
      var localEgw = window.egw(_app, window);
      //replaced jQuery calls
      if (Array.isArray(_actions)) {
        //_actions is now an object for sure
        //happens in test website
        _actions = _objectSpread$$({}, _actions);
      }
      for (var i in _actions) {
        var elem = _actions[i];
        if (typeof elem == "string") {
          //changes type of elem to Object {caption:string}
          _actions[i] = elem = {
            caption: elem
          };
        }
        if (typeof elem == "object")
          // isn't this always true because of step above? Yes if elem was a string before
          {
            // use attr name as id, if none given
            if (typeof elem.id != "string") elem.id = i;

            // if no iconUrl given, check icon and default icons
            if (typeof elem.iconUrl == "undefined") {
              if (typeof elem.icon == "undefined") elem.icon = this.defaultIcons[elem.id]; // only works if default Icon is available
              if (typeof elem.icon != "undefined") {
                elem.iconUrl = localEgw.image(elem.icon);
              }
              //if there is no icon and none can be found remove icon tag from the object
              delete elem.icon;
            }

            // always add shortcut for delete
            if (elem.id == "delete" && typeof elem.shortcut == "undefined") {
              elem.shortcut = {
                keyCode: 46,
                shift: false,
                ctrl: false,
                alt: false,
                caption: localEgw.lang('Del')
              };
            }

            // translate caption
            if (elem.caption && (typeof elem.no_lang == "undefined" || !elem.no_lang)) {
              elem.caption = localEgw.lang(elem.caption);
              if (typeof elem.hint == "string") elem.hint = localEgw.lang(elem.hint);
            }
            delete elem.no_lang;

            // translate confirm messages and place '?' at the end iff not there yet
            for (var attr in {
              confirm: '',
              confirm_multiple: ''
            }) {
              if (typeof elem[attr] == "string") {
                elem[attr] = localEgw.lang(elem[attr]) + (elem[attr].substr(-1) != '?' ? '?' : '');
              }
            }

            // set certain enabled functions iff elem.enabled is not set so false
            if (typeof elem.enabled == 'undefined' || elem.enabled === true) {
              if (typeof elem.enableClass != "undefined") {
                elem.enabled = this.enableClass;
              } else if (typeof elem.disableClass != "undefined") {
                elem.enabled = this.not_disableClass;
              } else if (typeof elem.enableId != "undefined") {
                elem.enabled = this.enableId;
              }
            }

            //Check whether the action already exists, and if no, add it to the
            //actions list
            var action = this.getActionById(elem.id);
            if (!action) {
              //elem will be popup on default
              if (typeof elem.type == "undefined") {
                elem.type = "popup";
              }
              var _constructor2 = null;

              // Check whether the given type is inside the "canHaveChildren"
              // array // here can have children is used as array where possible types of children are stored
              if (this.canHaveChildren !== true && this.canHaveChildren.indexOf(elem.type) == -1) {
                throw "This child type '" + elem.type + "' is not allowed!";
              }
              if (typeof window._egwActionClasses[elem.type] != "undefined") {
                _constructor2 = window._egwActionClasses[elem.type].actionConstructor;
              } else {
                throw "Given action type \"" + elem.type + "\" not registered, because type does not exist";
              }
              if (typeof _constructor2 == "function" && _constructor2) action = new _constructor2(this, elem.id);else throw "Given action type \"" + elem.type + "\" not registered.";
              this.children.push(action);
            }
            action.updateAction(elem);

            // Add sub-actions to the action
            if (elem.children) {
              action.updateActions(elem.children, _app);
            }
          }
      }
    } else {
      throw "This action element cannot have children!";
    }
  }
  /**
   * Callback to check if none of _senders rows has disableClass set
   *
   * @param _action EgwAction object, we use _action.data.disableClass to check
   * @param _senders array of egwActionObject objects
   * @param _target egwActionObject object, gets called for every object in _senders
   * @returns boolean true if none has disableClass, false otherwise
   */
  not_disableClass(_action, _senders, _target) {
    if (_target.iface.getDOMNode()) {
      return !_target.iface.getDOMNode().classList.contains(_action.data.disableClass);
    } else if (_target.id) {
      // Checking on a something that doesn't have a DOM node, like a nm row
      // that's not currently rendered
      var data = window.egw.dataGetUIDdata(_target.id);
      if (data && data.data && data.data.class) {
        return -1 === data.data.class.split(' ').indexOf(_action.data.disableClass);
      }
    }
  }
  /**
   * Callback to check if all of _senders rows have enableClass set
   *
   * @param _action EgwAction object, we use _action.data.enableClass to check
   * @param _senders array of egwActionObject objects
   * @param _target egwActionObject object, gets called for every object in _senders
   * @returns boolean true if none has disableClass, false otherwise
   */
  enableClass(_action, _senders, _target) {
    if (typeof _target == 'undefined') {
      return false;
    } else if (_target.iface.getDOMNode()) {
      return _target.iface.getDOMNode().classList.contains(_action.data.enableClass);
    } else if (_target.id) {
      // Checking on a something that doesn't have a DOM node, like a nm row
      // that's not currently rendered.  Not as good as an actual DOM node check
      // since things can get missed, but better than nothing.
      var data = window.egw.dataGetUIDdata(_target.id);
      if (data && data.data && data.data.class) {
        return -1 !== data.data.class.split(' ').indexOf(_action.data.enableClass);
      }
    }
  }
  /**
   * Enable an _action, if it matches a given regular expression in _action.data.enableId
   *
   * @param _action EgwAction object, we use _action.data.enableId to check
   * @param _senders array of egwActionObject objects
   * @param _target egwActionObject object, gets called for every object in _senders
   * @returns boolean true if _target.id matches _action.data.enableId
   */
  enableId(_action, _senders, _target) {
    if (typeof _action.data.enableId == 'string') {
      _action.data.enableId = new RegExp(_action.data.enableId);
    }
    return _target.id.match(_action.data.enableId);
  }
  /**
   * Applies the same onExecute handler to all actions which don't have an execute
   * handler set.
   *
   * @param {(string|function)} _value
   */
  setDefaultExecute(_value) {
    // Check whether the onExecute handler of this action should be set
    if (this.type != "actionManager" && !this.onExecute.hasHandler()) {
      this.onExecute.isDefault = true;
      this.onExecute.setValue(_value);
    }

    // Apply the value to all children
    if (this.canHaveChildren) {
      for (var elem of this.children) {
        elem.setDefaultExecute(_value);
      }
    }
  }
  /**
   * Executes this action by using the method specified in the onExecute setter.
   *
   * @param {array} _senders array with references to the objects which caused the action
   * @param {object} _target is an optional parameter which may represent e.g. a drag drop target
   */
  execute(_senders) {
    var _target = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    if (!this._check_confirm_mass_selections(_senders, _target)) {
      return this._check_confirm(_senders, _target);
    }
  }
  /**
   * If this action needs to confirm mass selections (attribute confirm_mass_selection = true),
   * check for any checkboxes that have a confirmation prompt (confirm_mass_selection is a string)
   * and are unchecked.  We then show the prompt, and set the checkbox to their answer.
   *
   * * This is only considered if there are more than 20 entries selected.
   *
   * * Only the first confirmation prompt / checkbox action will be used, others
   *        will be ignored.
   *
   * @param {type} _senders
   * @param {type} _target
   * @returns {Boolean}
   */
  _check_confirm_mass_selections(_senders, _target) {
    var _this = this;
    var obj_manager = egw_getObjectManager(this.getManager().parent.id, false);
    if (!obj_manager) {
      return false;
    }

    // Action needs to care about mass selection - check for parent that cares too
    var confirm_mass_needed = false;
    var action = this;
    while (action && action !== obj_manager.manager && !confirm_mass_needed) {
      confirm_mass_needed = !!action.confirm_mass_selection;
      action = action.parent;
    }
    if (!confirm_mass_needed) return false;

    // Check for confirm mass selection checkboxes
    var confirm_mass_selections = obj_manager.manager.getActionsByAttr("confirm_mass_selection");
    confirm_mass_needed = _senders.length > 20;
    //no longer needed because of '=>' notation
    //const self = this;

    // Find & show prompt
    var _loop = function _loop() {
        var check = confirm_mass_selections[i];
        if (check.checkbox === false || check.checked === true) {
          return 0; // continue
        }

        // Show the mass selection prompt
        var msg = window.egw.lang(check.confirm_mass_selection, obj_manager.getAllSelected() ? window.egw.lang('all') : _senders.length);
        var callback = _button => {
          // YES = unchecked, NO = checked
          check.set_checked(_button === window.Et2Dialog.NO_BUTTON);
          if (_button !== window.Et2Dialog.CANCEL_BUTTON) {
            _this._check_confirm(_senders, _target);
          }
        };
        window.Et2Dialog.show_dialog(callback, msg, _this.data.hint, {}, window.Et2Dialog.BUTTONS_YES_NO_CANCEL, window.Et2Dialog.QUESTION_MESSAGE);
        return {
          v: true
        };
      },
      _ret;
    for (var i = 0; confirm_mass_needed && i < confirm_mass_selections.length; i++) {
      _ret = _loop();
      if (_ret === 0) continue;
      if (_ret) return _ret.v;
    }
    return false;
  }
  /**
   * Check to see if action needs to be confirmed by user before we do it
   */
  _check_confirm(_senders, _target) {
    // check if actions needs to be confirmed first
    if (this.data && (this.data.confirm || this.data.confirm_multiple) && this.onExecute.functionToPerform != window.nm_action && typeof window.Et2Dialog != 'undefined')
      // let old eTemplate run its own confirmation from nextmatch_action.js
      {
        var msg = this.data.confirm || '';
        if (_senders.length > 1) {
          if (this.data.confirm_multiple) {
            msg = this.data.confirm_multiple;
          }
          // check if we have all rows selected
          var obj_manager = egw_getObjectManager(this.getManager().parent.id, false);
          if (obj_manager && obj_manager.getAllSelected()) {
            msg += "\n\n" + window.egw.lang('Attention: action will be applied to all rows, not only visible ones!');
          }
        }
        //no longer needed because of '=>' notation
        //var self = this;
        if (msg.trim().length > 0) {
          if (this.data.policy_confirmation && window.egw.app('policy')) {
            import(window.egw.link('/policy/js/app.min.js')).then(() => {
              if (typeof window.app.policy === 'undefined' || typeof window.app.policy.confirm === 'undefined') {
                window.app.policy = new window.app.classes.policy();
              }
              window.app.policy.confirm(this, _senders, _target);
            });
            return;
          }
          window.Et2Dialog.show_dialog(_button => {
            if (_button == window.Et2Dialog.YES_BUTTON) {
              // @ts-ignore
              return this.onExecute.exec(this, _senders, _target);
            }
          }, msg, this.data.hint, {}, window.Et2Dialog.BUTTONS_YES_NO, window.Et2Dialog.QUESTION_MESSAGE);
          return;
        }
      }
    // @ts-ignore
    return this.onExecute.exec(this, _senders, _target);
  }
  updateAction(_data) {
    egwActionStoreJSON(_data, this, "data");
  }

  /**
   * Returns the parent action manager
   */
  getManager() {
    if (this.type == "actionManager") {
      return this;
    } else if (this.parent) {
      return this.parent.getManager();
    } else {
      return null;
    }
  }

  /**
   * The appendToGraph function generates an action tree which automatically contains
   * all parent elements. If the appendToGraph function is called for a
   *
   * @param {not an array} _tree contains the tree structure - pass an object containing {root:Tree}
   *    the empty array "root" to this function {"root": []}. The result will be stored in
   *    this array.
   * @param {boolean} _addChildren is used internally to prevent parent elements from
   *    adding their children automatically to the tree.
   */
  appendToTree(_tree) {
    var _addChildren = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    if (typeof _addChildren == "undefined") {
      _addChildren = true;
    }

    // Preset some variables
    var root = _tree.root;
    var parentNode = null;
    var node = {
      "action": this,
      "children": []
    };
    if (this.parent && this.type != "actionManager") {
      // Check whether the parent container has already been added to the tree
      parentNode = _egwActionTreeFind(root, this.parent);
      if (!parentNode) {
        parentNode = this.parent.appendToTree(_tree, false);
      }

      // Check whether this element has already been added to the parent container
      var added = false;
      for (var child of parentNode.children) {
        if (child.action == this) {
          node = child;
          added = true;
          break;
        }
      }
      if (!added) {
        parentNode.children.push(node);
      }
    } else {
      var _added = false;
      for (var treeElem of root) {
        if (treeElem.action == this) {
          node = treeElem;
          _added = true;
          break;
        }
      }
      if (!_added) {
        // Add this element to the root if it has no parent
        root.push(node);
      }
    }
    if (_addChildren) {
      for (var _child of this.children) {
        _child.appendToTree(_tree, true);
      }
    }
    return node;
  }
  /**
   * @deprecated directly set value instead
   * @param _value
   */
  set_hideOnDisabled(_value) {
    this.hideOnDisabled = _value;
  }
  /**
   * @deprecated directly set value instead
   * @param _value
   */
  set_hideOnMobile(_value) {
    this.hideOnMobile = _value;
  }
  /**
   * @deprecated directly set value instead
   * @param _value
   */
  set_disableIfNoEPL(_value) {
    this.disableIfNoEPL = _value;
  }
  set_hint(hint) {}
  clone() {
    var clone = Object.assign(Object.create(Object.getPrototypeOf(this)), this);
    clone.onExecute = this.onExecute.clone();
    if (this.enabled) {
      clone.enabled = this.enabled.clone();
    }
    return clone;
  }
}
/**
 * finds an egwAction in the given tree
 * @param {Tree}_tree where to search
 * @param {EgwAction}_elem elem to search
 * @returns {TreeElem} the treeElement for corresponding _elem if found, null else
 */
function _egwActionTreeFind(_tree, _elem) {
  for (var current of _tree) {
    if (current.action == _elem) {
      return current;
    }
    if (typeof current.children != "undefined") {
      var elem = _egwActionTreeFind(current.children, _elem);
      if (elem) {
        return elem;
      }
    }
  }
  return null;
}

/**
 * EGroupware egw_action framework - egw action framework
 *
 * @link https://www.egroupware.org
 * @author Andreas Stöckel <as@stylite.de>
 * @copyright 2011 by Andreas Stöckel
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package egw_action
 */

/**
 * egwActionManager manages a list of actions - it overwrites the egwAction class
 * and allows child actions to be added to it.
 *
 * @param {EgwAction} _parent
 * @param {string} _id
 * @return {EgwActionManager}
 */
class EgwActionManager extends EgwAction {
  constructor() {
    var _parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    var _id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
    super(_parent, _id);
    this.type = "actionManager";
    this.canHaveChildren = true;
  }
}

function _defineProperty$2a(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The egwActionLink is used to interconnect egwActionObjects and egwActions.
 * This gives each action object the possibility to decide, whether the action
 * should be active in this context or not.
 *
 * @param _manager is a reference to the egwActionManager which contains the action
 *    the object wants to link to.
 */
class EgwActionLink {
  constructor(_manager) {
    _defineProperty$2a(this, "enabled", true);
    _defineProperty$2a(this, "visible", true);
    _defineProperty$2a(this, "actionId", "");
    _defineProperty$2a(this, "actionObj", null);
    _defineProperty$2a(this, "manager", void 0);
    this.manager = _manager;
  }
  updateLink(_data) {
    egwActionStoreJSON(_data, this, true);
  }
  set_enabled(_value) {
    this.enabled = _value;
  }
  set_visible(_value) {
    this.visible = _value;
  }
  set_actionId(_value) {
    this.actionId = _value;
    this.actionObj = this.manager.getActionById(_value);
    if (!this.actionObj) throw "Action object with id '" + _value + "' does not exist!";
  }
}

var es_regexp_flags = {};

var global$3 = global$c;
var DESCRIPTORS$2 = descriptors;
var defineBuiltInAccessor$1 = defineBuiltInAccessor$4;
var regExpFlags = regexpFlags;
var fails$4 = fails$e;

// babel-minify and Closure Compiler transpiles RegExp('.', 'd') -> /./d and it causes SyntaxError
var RegExp$2 = global$3.RegExp;
var RegExpPrototype = RegExp$2.prototype;

var FORCED$2 = DESCRIPTORS$2 && fails$4(function () {
  var INDICES_SUPPORT = true;
  try {
    RegExp$2('.', 'd');
  } catch (error) {
    INDICES_SUPPORT = false;
  }

  var O = {};
  // modern V8 bug
  var calls = '';
  var expected = INDICES_SUPPORT ? 'dgimsy' : 'gimsy';

  var addGetter = function (key, chr) {
    // eslint-disable-next-line es/no-object-defineproperty -- safe
    Object.defineProperty(O, key, { get: function () {
      calls += chr;
      return true;
    } });
  };

  var pairs = {
    dotAll: 's',
    global: 'g',
    ignoreCase: 'i',
    multiline: 'm',
    sticky: 'y'
  };

  if (INDICES_SUPPORT) pairs.hasIndices = 'd';

  for (var key in pairs) addGetter(key, pairs[key]);

  // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
  var result = Object.getOwnPropertyDescriptor(RegExpPrototype, 'flags').get.call(O);

  return result !== expected || calls !== expected;
});

// `RegExp.prototype.flags` getter
// https://tc39.es/ecma262/#sec-get-regexp.prototype.flags
if (FORCED$2) defineBuiltInAccessor$1(RegExpPrototype, 'flags', {
  configurable: true,
  get: regExpFlags
});

function _defineProperty$29(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The egwActionObject represents an abstract object to which actions may be
 * applied. Communication with the DOM tree is established by using the
 * egwActionObjectInterface (AOI), which is passed in the constructor.
 * egwActionObjects are organized in a tree structure.
 *
 * @param {string} _id is the identifier of the object which
 * @param {EgwActionObject} _parent is the parent object in the hierarchy. This may be set to NULL
 * @param {egwActionObjectInterface} _iface is the egwActionObjectInterface which connects the object
 *    to the outer world.
 * @param {EgwActionManager} _manager is the action manager this object is connected to
 *    this object to the DOM tree. If the _manager isn't supplied, the parent manager
 *    is taken.
 * @param {number} _flags a set of additional flags being applied to the object,
 *    defaults to 0
 */
class EgwActionObject {
  constructor(_id, _parent, _interface, _manager) {
    var _flags = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
    _defineProperty$29(this, "id", void 0);
    _defineProperty$29(this, "parent", void 0);
    _defineProperty$29(this, "children", []);
    _defineProperty$29(this, "actionLinks", []);
    _defineProperty$29(this, "iface", void 0);
    _defineProperty$29(this, "manager", void 0);
    _defineProperty$29(this, "flags", void 0);
    _defineProperty$29(this, "data", null);
    _defineProperty$29(this, "setSelectedCallback", null);
    _defineProperty$29(this, "registeredImpls", []);
    // Two variables which help fast travelling through the object tree, when
    // searching for the selected/focused object.
    _defineProperty$29(this, "selectedChildren", []);
    _defineProperty$29(this, "focusedChild", null);
    _defineProperty$29(this, "onBeforeTrigger", undefined);
    _defineProperty$29(this, "_context", undefined);
    if (typeof _manager == "undefined" && typeof _parent == "object" && _parent) _manager = _parent.manager;
    if (typeof _flags == "undefined") _flags = 0;
    this.id = _id;
    this.parent = _parent;
    this.iface = _interface;
    this.manager = _manager;
    this.flags = _flags;
    this.setAOI(_interface);
  }

  /**
   * Sets the action object interface - if "NULL" is given, the iface is set
   * to a dummy interface which is used to store the temporary data.
   *
   * @param {egwActionObjectInterface} _aoi
   */
  setAOI(_aoi) {
    if (_aoi == null) {
      //TODo replace DummyInterface
      _aoi = new egwActionObjectInterface();
    }

    // Copy the state from the old interface
    if (this.iface) {
      _aoi.setState(this.iface.getState());
    }

    // Replace the interface object
    this.iface = _aoi;
    this.iface.setStateChangeCallback(this._ifaceCallback, this);
    this.iface.setReconnectActionsCallback(this._reconnectCallback, this);
  }
  /**
   //     * Returns the object from the tree with the given ID
   //     *
   //     * @param {string} _id
   //     * @param {number} _search_depth
   //     * @return {egwActionObject} description
   //     * @todo Add search function to egw_action_commons.js
   //     */
  getObjectById(_id, _search_depth) {
    if (this.id == _id) {
      return this;
    }
    if (typeof _search_depth == "undefined") {
      _search_depth = Number.MAX_VALUE;
    }
    for (var i = 0; i < this.children.length && _search_depth > 0; i++) {
      var obj = this.children[i].getObjectById(_id, _search_depth - 1);
      if (obj) {
        return obj;
      }
    }
    return null;
  }
  /**
   * Adds an object as child to the actionObject and returns it - if the supplied
   * parameter is an object, the object will be added directly, otherwise an object
   * with the given id will be created.
   *
   * @param {(string|object)} _id Id of the object which will be created or the object
   *    that will be added.
   * @param {object} _interface if _id was a string, _interface defines the interface which
   *    will be connected to the newly generated object.
   * @param {number} _flags are the flags will which be supplied to the newly generated
   *    object. May be omitted.
   * @returns object the generated object
   */
  addObject(_id) {
    var _interface = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var _flags = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    return this.insertObject(false, _id, _interface, _flags);
  }
  /**
   * Inserts an object as child to the actionObject and returns it - if the supplied
   * parameter is an object, the object will be added directly, otherwise an object
   * with the given id will be created.
   *
   * @param {number} _index Position where the object will be inserted, "false" will add it
   *    to the end of the list.
   * @param {string|object} _id Id of the object which will be created or the object
   *    that will be added.
   * @param {object} _iface if _id was a string, _iface defines the interface which
   *    will be connected to the newly generated object.
   * @param {number} _flags are the flags will which be supplied to the newly generated
   *    object. May be omitted.
   * @returns object the generated object
   */

  insertObject(_index, _id, _iface, _flags) {
    if (_index === false) _index = this.children.length;
    var obj = null;
    if (typeof _id == "object") {
      obj = _id;

      // Set the parent to null and reset the focus of the object
      obj.parent = null;
      obj.setFocused(false);

      // Set the parent to this object
      obj.parent = this;
    } else if (typeof _id == "string") {
      obj = new EgwActionObject(_id, this, _iface, this.manager, _flags);
    }
    if (obj) {
      // Add the element to the children
      this.children.splice(_index, 0, obj);
    } else {
      throw "Error while adding new element to the ActionObjects!";
    }
    return obj;
  }
  /**
   * Deletes all children of the egwActionObject
   */

  clear() {
    // Remove all children
    while (this.children.length > 0) {
      this.children[0].remove();
    }

    // Delete all other references
    this.selectedChildren = [];
    this.focusedChild = null;

    // Remove links
    this.actionLinks = [];
  }
  /**
   * Deletes this object from the parent container
   */
  remove() {
    // Remove focus and selection from this element
    this.setFocused(false);
    this.setSelected(false);
    this.setAllSelected(false);

    // Unregister all registered action implementations
    this.unregisterActions();

    // Clear the child-list
    this.clear();

    // Remove this element from the parent list
    if (this.parent != null) {
      var idx = this.parent.children.indexOf(this);
      if (idx >= 0) {
        this.parent.children.splice(idx, 1);
      }
    }
  }
  /**
   * Searches for the root object in the action object tree and returns it.
   */
  getRootObject() {
    if (this.parent === null) {
      return this;
    } else {
      return this.parent.getRootObject();
    }
  }
  /**
   * Returns a list with all parents of this object.
   */
  getParentList() {
    if (this.parent === null) {
      return [];
    } else {
      var list = this.parent.getParentList();
      list.unshift(this.parent);
      return list;
    }
  }
  /**
   * Returns the first parent which has the container flag
   */
  getContainerRoot() {
    if (egwBitIsSet(this.flags, EGW_AO_FLAG_IS_CONTAINER) || this.parent === null) {
      return this;
    } else {
      return this.parent.getContainerRoot();
    }
  }
  /**
   * Returns all selected objects which are in the current subtree.
   *
   * @param {function} _test is a function, which gets an object and checks whether
   *    it will be added to the list.
   * @param {array} _list is internally used to fetch all selected elements, please
   *    omit this parameter when calling the function.
   */
  getSelectedObjects(_test, _list) {
    if (typeof _test == "undefined") _test = null;
    if (typeof _list == "undefined") {
      _list = {
        "elements": []
      };
    }
    if ((!_test || _test(this)) && this.getSelected()) _list.elements.push(this);
    if (this.selectedChildren) {
      for (var i = 0; i < this.selectedChildren.length; i++) {
        this.selectedChildren[i].getSelectedObjects(_test, _list);
      }
    }
    return _list.elements;
  }
  /**
   * Returns whether all objects in this tree are selected
   */
  getAllSelected() {
    if (this.children.length == this.selectedChildren.length) {
      for (var i = 0; i < this.children.length; i++) {
        if (!this.children[i].getAllSelected()) return false;
      }
      // If this element is a container *and* does not have any children, we
      // should return false. If this element is not a container we have to
      // return true has this is the recursion base case
      return !egwBitIsSet(this.flags, EGW_AO_FLAG_IS_CONTAINER) || this.children.length > 0;
    }
    return false;
  }
  /**
   * Toggles the selection of all objects.
   *
   * @param _select boolean specifies whether the objects should get selected or not.
   *    If this parameter is not supplied, the selection will be toggled.
   */
  toggleAllSelected(_select) {
    if (typeof _select == "undefined") {
      _select = !this.getAllSelected();
    }

    // Check for a select_all action
    if (_select && this.manager && this.manager.getActionById('select_all')) {
      return this.manager.getActionById('select_all').execute(this);
    }
    this.setAllSelected(_select);
  }
  /**
   * Creates a list which contains all items of the element tree.
   *
   * @param {boolean} _visibleOnly
   * @param {object} _obj is used internally to pass references to the array inside
   *    the object.
   * @return {array}
   */
  flatList(_visibleOnly, _obj) {
    if (typeof _obj == "undefined") {
      _obj = {
        "elements": []
      };
    }
    if (typeof _visibleOnly == "undefined") {
      _visibleOnly = false;
    }
    if (!_visibleOnly || this.getVisible()) {
      _obj.elements.push(this);
    }
    for (var child of this.children) {
      child.flatList(_visibleOnly, _obj);
    }
    return _obj.elements;
  }
  /**
   * Returns a traversal list with all objects which are in between the given object
   * and this one. The operation returns an empty list, if a container object is
   * found on the way.
   *
   * @param {object} _to
   * @return {array}
   * @todo Remove flatList here!
   */
  traversePath(_to) {
    var contRoot = this.getContainerRoot();
    if (contRoot) {
      // Get a flat list of all the hncp elements and search for this object
      // and the object supplied in the _to parameter.
      var flatList = contRoot.flatList();
      var thisId = flatList.indexOf(this);
      var toId = flatList.indexOf(_to);

      // Check whether both elements have been found in this part of the tree,
      // return the slice of that list.
      if (thisId !== -1 && toId !== -1) {
        var from = Math.min(thisId, toId);
        var to = Math.max(thisId, toId);
        return flatList.slice(from, to + 1);
      }
    }
    return [];
  }
  /**
   * Returns the index of this object in the children list of the parent object.
   */
  getIndex() {
    if (this.parent === null) {
      //TODO check: should be -1 for invalid
      return 0;
    } else {
      return this.parent.children.indexOf(this);
    }
  }
  /**
   * Returns the deepest object which is currently focused. Objects with the
   * "container"-flag will not be returned.
   */
  getFocusedObject() {
    return this.focusedChild || null;
  }
  /**
   * Internal function which is connected to the ActionObjectInterface associated
   * with this object in the constructor. It gets called, whenever the object
   * gets (de)selected.
   *
   * @param {number} _newState is the new state of the object
   * @param {number} _changedBit
   * @param {number} _shiftState is the status of extra keys being pressed during the
   *    selection process.
   */
  _ifaceCallback(_newState, _changedBit, _shiftState) {
    if (typeof _shiftState == "undefined") _shiftState = EGW_AO_SHIFT_STATE_NONE;
    var selected = egwBitIsSet(_newState, EGW_AO_STATE_SELECTED);
    var visible = egwBitIsSet(_newState, EGW_AO_STATE_VISIBLE);

    // Check whether the visibility of the object changed
    if (_changedBit == EGW_AO_STATE_VISIBLE && visible != this.getVisible()) {
      // Deselect the object
      if (!visible) {
        this.setSelected(false);
        this.setFocused(false);
        return EGW_AO_STATE_NORMAL;
      } else {
        // Auto-register the actions attached to this object
        this.registerActions();
      }
    }

    // Remove the focus from all children on the same level
    if (this.parent && visible && _changedBit == EGW_AO_STATE_SELECTED) {
      selected = egwBitIsSet(_newState, EGW_AO_STATE_SELECTED);
      var objs = [];
      if (selected) {
        // Deselect all other objects inside this container, if the "MULTI" shift-state is not set
        if (!egwBitIsSet(_shiftState, EGW_AO_SHIFT_STATE_MULTI)) {
          this.getContainerRoot().setAllSelected(false);
        }

        // If the LIST state is active, get all objects in between this one and the focused one
        // and set their select state.
        if (egwBitIsSet(_shiftState, EGW_AO_SHIFT_STATE_BLOCK)) {
          var focused = this.getFocusedObject();
          if (focused) {
            objs = this.traversePath(focused);
            for (var i = 0; i < objs.length; i++) {
              objs[i].setSelected(true);
            }
          }
        }
      }

      // If the focused element didn't belong to this container, or the "list"
      // shift-state isn't active, set the focus to this element.
      if (objs.length == 0 || !egwBitIsSet(_shiftState, EGW_AO_SHIFT_STATE_BLOCK)) {
        this.setFocused(true);
        _newState = egwSetBit(EGW_AO_STATE_FOCUSED, _newState, true);
      }
      this.setSelected(selected);
    }
    return _newState;
  }
  /**
   * Handler for key presses
   *
   * @param {number} _keyCode
   * @param {boolean} _shift
   * @param {boolean} _ctrl
   * @param {boolean} _alt
   * @returns {boolean}
   */
  handleKeyPress(_keyCode, _shift, _ctrl, _alt) {
    switch (_keyCode) {
      case EGW_KEY_ARROW_UP:
      case EGW_KEY_ARROW_DOWN:
      case EGW_KEY_PAGE_UP:
      case EGW_KEY_PAGE_DOWN:
        if (!_alt) {
          var intval = _keyCode == EGW_KEY_ARROW_UP || _keyCode == EGW_KEY_ARROW_DOWN ? 1 : 10;
          if (this.children.length > 0) {
            // Get the focused object
            var _focused2 = this.getFocusedObject();

            // Determine the object which should get selected
            var selObj = null;
            if (!_focused2) {
              selObj = this.children[0];
            } else {
              selObj = _keyCode == EGW_KEY_ARROW_UP || _keyCode == EGW_KEY_PAGE_UP ? _focused2.getPrevious(intval) : _focused2.getNext(intval);
            }
            if (selObj != null) {
              if (!_shift && !(this.parent && this.parent.data && this.parent.data.keyboard_select)) {
                this.setAllSelected(false);
              } else if (!(this.parent && this.parent.data && this.parent.data.keyboard_select)) {
                var objs = _focused2.traversePath(selObj);
                for (var i = 0; i < objs.length; i++) {
                  objs[i].setSelected(true);
                }
              }
              if (!(this.parent.data && this.parent.data.keyboard_select)) {
                selObj.setSelected(true);
              }
              selObj.setFocused(true);

              // Tell the aoi of the object to make it visible
              selObj.makeVisible();
            }
            return true;
          }
        }
        break;

      // Space bar toggles selected for current row
      case EGW_KEY_SPACE:
        if (this.children.length <= 0) {
          break;
        }
        // Mark that we're selecting by keyboard, or arrows will reset selection
        if (!this.parent.data) {
          this.parent.data = {};
        }
        this.parent.data.keyboard_select = true;

        // Get the focused object
        var focused = this.getFocusedObject();
        focused.setSelected(!focused.getSelected());

        // Tell the aoi of the object to make it visible
        focused.makeVisible();
        return true;

      // Handle CTRL-A to select all elements in the current container
      case EGW_KEY_A:
        if (_ctrl && !_shift && !_alt) {
          this.toggleAllSelected();
          return true;
        }
        break;
    }
    return false;
  }
  getPrevious(_intval) {
    if (this.parent != null) {
      if (this.getFocused() && !this.getSelected()) {
        return this;
      }
      var flatTree = this.getContainerRoot().flatList();
      var idx = flatTree.indexOf(this);
      if (idx > 0) {
        idx = Math.max(1, idx - _intval);
        return flatTree[idx];
      }
    }
    return this;
  }
  getNext(_intval) {
    if (this.parent != null) {
      if (this.getFocused() && !this.getSelected()) {
        return this;
      }
      var flatTree = this.getContainerRoot().flatList(true);
      var idx = flatTree.indexOf(this);
      if (idx < flatTree.length - 1) {
        idx = Math.min(flatTree.length - 1, idx + _intval);
        return flatTree[idx];
      }
    }
    return this;
  }
  /**
   * Returns whether the object is currently selected.
   */

  getSelected() {
    return egwBitIsSet(this.getState(), EGW_AO_STATE_SELECTED);
  }
  /**
   * Returns whether the object is currently focused.
   */

  getFocused() {
    return egwBitIsSet(this.getState(), EGW_AO_STATE_FOCUSED);
  }
  /**
   * Returns whether the object currently is visible - visible means, that the
   * AOI has a dom node and is visible.
   */

  getVisible() {
    return egwBitIsSet(this.getState(), EGW_AO_STATE_VISIBLE);
  }
  /**
   * Returns the complete state of the object.
   */

  getState() {
    return this.iface.getState();
  }
  /**
   * Sets the focus of the element. The formerly focused element in the tree will
   * be de-focused.
   *
   * @param {boolean} _focused - whether to remove or set the focus. Defaults to true
   */

  setFocused(_focused) {
    if (typeof _focused == "undefined") _focused = true;
    var state = this.iface.getState();
    if (egwBitIsSet(state, EGW_AO_STATE_FOCUSED) != _focused) {
      // Un-focus the currently focused object
      var currentlyFocused = this.getFocusedObject();
      if (currentlyFocused && currentlyFocused != this) {
        currentlyFocused.setFocused(false);
      }
      this.iface.setState(egwSetBit(state, EGW_AO_STATE_FOCUSED, _focused));
      if (this.parent) {
        this.parent.updateFocusedChild(this, _focused);
      }
    }
    if (this.focusedChild != null && _focused == false) {
      this.focusedChild.setFocused(false);
    }
  }
  /**
   * Sets the selected state of the element.
   *
   * @param {boolean} _selected
   * @TODO Callback
   */

  setSelected(_selected) {
    var state = this.iface.getState();
    if (egwBitIsSet(state, EGW_AO_STATE_SELECTED) != _selected && egwBitIsSet(state, EGW_AO_STATE_VISIBLE)) {
      this.iface.setState(egwSetBit(state, EGW_AO_STATE_SELECTED, _selected));
      if (this.parent) {
        this.parent.updateSelectedChildren(this, _selected || this.selectedChildren.length > 0);
      }
    }
  }
  /**
   * Sets the selected state of all elements, including children
   *
   * @param {boolean} _selected
   * @param {boolean} _informParent
   */

  setAllSelected(_selected) {
    var _informParent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var state = this.iface.getState();

    // Update this element
    if (egwBitIsSet(state, EGW_AO_STATE_SELECTED) != _selected) {
      var _this$parent, _this$parent2;
      this.iface.setState(egwSetBit(state, EGW_AO_STATE_SELECTED, _selected));
      if (_informParent && this.parent) {
        this.parent.updateSelectedChildren(this, _selected);
      }
      if ((_this$parent = this.parent) !== null && _this$parent !== void 0 && _this$parent.data && (_this$parent2 = this.parent) !== null && _this$parent2 !== void 0 && (_this$parent2 = _this$parent2.data) !== null && _this$parent2 !== void 0 && _this$parent2.keyboard_select) {
        this.parent.data.keyboard_select = false;
      }
    }

    // Update the children if they should be selected or if they should be
    // deselected and there are selected children.
    if (_selected || this.selectedChildren.length > 0) {
      for (var i = 0; i < this.children.length; i++) {
        this.children[i].setAllSelected(_selected, false);
      }
    }

    // Copy the selected children list
    this.selectedChildren = [];
    if (_selected) {
      for (var _i = 0; _i < this.children.length; _i++) {
        this.selectedChildren.push(this.children[_i]);
      }
    }

    // Call the setSelectedCallback
    egwQueueCallback(this.setSelectedCallback, [], this, "setSelectedCallback");
  }
  /**
   * Updates the selectedChildren array each actionObject has in order to determine
   * all selected children in a very fast manner.
   *
   * @param {(string|egwActionObject} _child
   * @param {boolean} _selected
   * @todo Has also to be updated, if an child is added/removed!
   */

  updateSelectedChildren(_child, _selected) {
    var id = this.selectedChildren.indexOf(_child); // TODO Replace by binary search, insert children sorted by index!
    var wasEmpty = this.selectedChildren.length == 0;

    // Add or remove the given child from the selectedChildren list
    if (_selected && id == -1) {
      this.selectedChildren.push(_child);
    } else if (!_selected && id != -1) {
      this.selectedChildren.splice(id, 1);
    }

    // If the emptiness of the selectedChildren array has changed, update the
    // parent selected children array.
    if (wasEmpty != (this.selectedChildren.length == 0) && this.parent) {
      this.parent.updateSelectedChildren(this, wasEmpty);
    }

    // Call the setSelectedCallback
    egwQueueCallback(this.setSelectedCallback, this.getContainerRoot().getSelectedObjects(), this, "setSelectedCallback");
  }
  /**
   * Updates the focusedChild up to the container boundary.
   *
   * @param {(string|egwActionObject} _child
   * @param {boolean} _focused
   */

  updateFocusedChild(_child, _focused) {
    if (_focused) {
      this.focusedChild = _child;
    } else {
      if (this.focusedChild == _child) {
        this.focusedChild = null;
      }
    }
    if (this.parent /*&& !egwBitIsSet(this.flags, EGW_AO_FLAG_IS_CONTAINER)*/) {
      this.parent.updateFocusedChild(_child, _focused);
    }
  }
  /**
   * Updates the actionLinks of the given ActionObject.
   *
   * @param {array} _actionLinks contains the information about the actionLinks which
   *    should be updated as an array of objects. Example
   *    [
   *        {
   * 			"actionId": "file_delete",
   * 			"enabled": true
   * 		}
   *    ]
   *    string[] or {actionID:string,enabled:boolean}[]
   *    If an supplied link doesn't exist yet, it will be created (if _doCreate is true)
   *    and added to the list. Otherwise, the information will just be updated.
   * @param {boolean} _recursive If true, the settings will be applied to all child
   *    object (default false)
   * @param {boolean} _doCreate If true, not yet existing links will be created (default true)
   */

  updateActionLinks(_actionLinks) {
    var _recursive = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var _doCreate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    for (var elem of _actionLinks) {
      // Allow single strings for simple action links.
      if (typeof elem == "string") {
        elem = {
          actionId: elem,
          enabled: true
        };
      }
      if (typeof elem.actionId != "undefined" && elem.actionId) {
        //Get the action link object, if it doesn't exist yet, create it
        var actionLink = this.getActionLink(elem.actionId);
        if (!actionLink && _doCreate) {
          actionLink = new EgwActionLink(this.manager);
          this.actionLinks.push(actionLink);
        }

        //Set the supplied data
        if (actionLink) {
          actionLink.updateLink(elem);
        }
      }
    }
    if (_recursive) {
      for (var i = 0; i < this.children.length; i++) {
        this.children[i].updateActionLinks(_actionLinks, true, _doCreate);
      }
    }
    if (this.getVisible() && this.iface != null) {
      this.registerActions();
    }
  }
  /**
   * Reconnects the actions.
   */

  _reconnectCallback() {
    this.registeredImpls = [];
    this.registerActions();
  }
  /**
   * Registers the action implementations inside the DOM-Tree.
   */
  registerActions() {
    var groups = this.getActionImplementationGroups();
    for (var group in groups) {
      // Get the action implementation for each group
      if (typeof window._egwActionClasses[group] != "undefined" && window._egwActionClasses[group].implementation && this.iface) {
        var impl = window._egwActionClasses[group].implementation();
        if (this.registeredImpls.indexOf(impl) == -1) {
          // Register a handler for that action with the iface of that object,
          // the callback and this object as context for the callback
          if (impl.registerAction(this.iface, this.executeActionImplementation, this)) {
            this.registeredImpls.push(impl);
          }
        }
      }
    }
  }
  /**
   * Unregisters all action implementations registered to this element
   */
  unregisterActions() {
    while (this.registeredImpls.length > 0) {
      var impl = this.registeredImpls.pop();
      if (this.iface) {
        impl.unregisterAction(this.iface);
      }
    }
  }
  triggerCallback() {
    if (this.onBeforeTrigger) {
      return this.onBeforeTrigger();
    }
    return true;
  }
  makeVisible() {
    this.iface.makeVisible();
  }
  /**
   * Executes the action implementation which is associated to the given action type.
   *
   * @param {object} _implContext is data which should be delivered to the action implementation.
   *    E.g. in case of the popup action implementation, the x and y coordinates where the
   *    menu should open, and contextmenu event are transmitted.
   * @param {string} _implType is the action type for which the implementation should be
   *    executed.
   * @param {number} _execType specifies in which context the execution should take place.
   *    defaults to EGW_AO_EXEC_SELECTED
   */

  executeActionImplementation(_implContext, _implType, _execType) {
    if (typeof _execType == "undefined") {
      _execType = EGW_AO_EXEC_SELECTED;
    }
    if (typeof _implType == "string") {
      _implType = window._egwActionClasses[_implType].implementation();
    }
    if (typeof _implType == "object" && _implType) {
      var selectedActions;
      if (_execType == EGW_AO_EXEC_SELECTED) {
        if (!egwBitIsSet(EGW_AO_FLAG_IS_CONTAINER, this.flags)) {
          this.forceSelection();
        }
        selectedActions = this.getSelectedLinks(_implType.type);
      } else if (_execType == EGW_AO_EXEC_THIS) {
        selectedActions = this._getLinks([this], _implType.type);
      }
      if (selectedActions.selected.length > 0 && egwObjectLength(selectedActions.links) > 0) {
        return _implType.executeImplementation(_implContext, selectedActions.selected, selectedActions.links);
      }
    }
    return false;
  }
  /**
   * Forces the object to be inside the currently selected objects. If this is
   * not the case, the object will select itself and deselect all other objects.
   */

  forceSelection() {
    var selected = this.getContainerRoot().getSelectedObjects();

    // Check whether this object is in the list
    var thisInList = selected.indexOf(this) != -1;

    // If not, select it
    if (!thisInList) {
      this.getContainerRoot().setAllSelected(false);
      this.setSelected(true);
    }
    this.setFocused(true);
  }
  /**
   * Returns all selected objects, and all action links of those objects, which are
   * of the given implementation type, actionLink properties such as
   * "enabled" and "visible" are accumulated.
   *
   * Objects have the chance to change their action links or to deselect themselves
   * in the onBeforeTrigger event, which is evaluated by the triggerCallback function.
   *
   * @param _actionType is the action type for which the actionLinks should be collected.
   * @returns object An object which contains a "links" and a "selected" section with
   *    an array of links/selected objects-
   */

  getSelectedLinks(_actionType) {
    // Get all objects in this container which are currently selected
    var selected = this.getContainerRoot().getSelectedObjects();
    return this._getLinks(selected, _actionType);
  }
  /**
   *
   * @param {array} _objs
   * @param {string} _actionType
   * @return {object} with attributes "selected" and "links"
   */

  _getLinks(_objs, _actionType) {
    var actionLinks = {};
    var testedSelected = [];
    var test = function test(olink, obj) {
      // Test whether the action type is of the given implementation type
      if (olink.actionObj.type == _actionType) {
        if (typeof actionLinks[olink.actionId] == "undefined") {
          actionLinks[olink.actionId] = {
            "actionObj": olink.actionObj,
            "enabled": testedSelected.length == 1,
            "visible": false,
            "cnt": 0
          };
        }

        // Accumulate the action link properties
        var llink = actionLinks[olink.actionId];
        llink.enabled = llink.enabled && olink.actionObj.enabled.exec(olink.actionObj, _objs, obj) && olink.enabled && olink.visible;
        llink.visible = llink.visible || olink.visible;
        llink.cnt++;

        // Add in children, so they can get checked for visible / enabled
        if (olink.actionObj && olink.actionObj.children.length > 0) {
          for (var j = 0; j < olink.actionObj.children.length; j++) {
            var child = olink.actionObj.children[j];
            test({
              actionObj: child,
              actionId: child.id,
              enabled: olink.enabled,
              visible: olink.visible
            }, obj);
          }
        }
      }
    };
    var _loop = function _loop(obj) {
      if (!egwBitIsSet(obj.flags, EGW_AO_FLAG_IS_CONTAINER) && obj.triggerCallback()) {
        testedSelected.push(obj);
        obj.actionLinks.forEach(item => {
          test(item, obj); //object link
        });
      }
    };
    for (var obj of _objs) {
      _loop(obj);
    }

    // Check whether all objects supported the action
    for (var k in actionLinks) {
      actionLinks[k].enabled = actionLinks[k].enabled && actionLinks[k].cnt >= testedSelected.length && (actionLinks[k].actionObj.allowOnMultiple === true || actionLinks[k].actionObj.allowOnMultiple == "only" && _objs.length > 1 || actionLinks[k].actionObj.allowOnMultiple == false && _objs.length === 1 || typeof actionLinks[k].actionObj.allowOnMultiple === 'number' && _objs.length == actionLinks[k].actionObj.allowOnMultiple);
      if (!window.egwIsMobile()) actionLinks[k].actionObj.hideOnMobile = false;
      actionLinks[k].visible = actionLinks[k].visible && !actionLinks[k].actionObj.hideOnMobile && (actionLinks[k].enabled || !actionLinks[k].actionObj.hideOnDisabled);
    }

    // Return an object which contains the accumulated actionLinks and all selected
    // objects.
    return {
      "selected": testedSelected,
      "links": actionLinks
    };
  }
  /**
   * Returns the action link, which contains the association to the action with
   * the given actionId.
   *
   * @param {string} _actionId name of the action associated to the link
   */

  getActionLink(_actionId) {
    for (var i = 0; i < this.actionLinks.length; i++) {
      var _this$actionLinks$i$a;
      if (((_this$actionLinks$i$a = this.actionLinks[i].actionObj) === null || _this$actionLinks$i$a === void 0 ? void 0 : _this$actionLinks$i$a.id) == _actionId) {
        return this.actionLinks[i];
      }
    }
    return null;
  }
  /**
   * Returns all actions associated to the object tree, grouped by type.
   *
   * @param {function} _test gets an egwActionObject and should return, whether the
   *    actions of this object are added to the result. Defaults to an "always true"
   *    function.
   * @param {object} _groups is an internally used parameter, may be omitted.
   */

  getActionImplementationGroups(_test, _groups) {
    // If the _groups parameter hasn't been given preset it to an empty object
    // (associative array).
    if (typeof _groups == "undefined") _groups = {};
    if (typeof _test == "undefined") _test = function _test(_obj) {
      return true;
    };
    this.actionLinks.forEach(item => {
      var action = item.actionObj;
      if (typeof action != "undefined" && _test(this)) {
        if (typeof _groups[action.type] == "undefined") {
          _groups[action.type] = [];
        }
        _groups[action.type].push({
          "object": this,
          "link": item
        });
      }
    });

    // Recursively add the actions of the children to the result (as _groups is
    // an object, only the reference is passed).
    this.children.forEach(item => {
      item.getActionImplementationGroups(_test, _groups);
    });
    return _groups;
  }
  /**
   * Check if user tries to get dragOut action
   *
   * keys for dragOut:
   *    -Mac: Command + Shift
   *    -Others: Alt + Shift
   *
   * @param {event} _event
   * @return {boolean} return true if Alt+Shift keys and left mouse click are pressed, otherwise false
   */

  isDragOut(_event) {
    return (_event.altKey || _event.metaKey) && _event.shiftKey && _event.which == 1;
  }
  /**
   * Check if user tries to get selection action
   *
   * Keys for selection:
   *    -Mac: Command key
   *    -Others: Ctrl key
   *
   * @param {type} _event
   * @returns {Boolean} return true if left mouse click and Ctrl/Alt key are pressed, otherwise false
   */

  isSelection(_event) {
    return !_event.shiftKey && _event.which == 1 && (_event.metaKey || _event.ctrlKey || _event.altKey);
  }
}

/**
 * EGroupware egw_action framework - egw action framework
 *
 * @link https://www.egroupware.org
 * @author Andreas Stöckel <as@stylite.de>
 * @copyright 2011 by Andreas Stöckel
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package egw_action
 */

/**
 * The egwActionObjectManager is a dummy class which only contains a dummy
 * AOI. It may be used as root object or as object containers.
 *
 * @param {string} _id
 * @param {string} _manager
 * @return {EgwActionObjectManager}
 */
class EgwActionObjectManager extends EgwActionObject {
  constructor(_id, _manager) {
    var aoi = new egwActionObjectInterface();
    //const ao = new egwActionObject(_id, null, aoi, _manager, EGW_AO_FLAG_IS_CONTAINER)
    super(_id, null, aoi, _manager, EGW_AO_FLAG_IS_CONTAINER);
    this.triggerCallback = function () {
      return false;
    };
  }
}

function _defineProperty$28(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The egwDragAction class overwrites the egwAction class and adds the new
 * "dragType" property. The "onExecute" event of the drag action will be called
 * whenever dragging starts. The onExecute JS handler should return the
 * drag-drop helper object - otherwise a default helper will be generated.
 */
class EgwDragAction extends EgwAction {
  set_dragType(_value) {
    this.dragType = _value;
  }

  /**
   * @param {EgwAction} parent
   * @param {string} _id
   * @param {string} _caption
   * @param {string} _iconUrl
   * @param {(string|function)} _onExecute
   * @param {bool} _allowOnMultiple
   */
  constructor(parent, _id, _caption, _iconUrl, _onExecute, _allowOnMultiple) {
    super(parent, _id, _caption, _iconUrl, _onExecute, _allowOnMultiple);
    _defineProperty$28(this, "dragType", "default");
    this.type = "drag";
    this.hideOnDisabled = true;
  }
}

function _defineProperty$27(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class EgwDragActionImplementation {
  constructor() {
    _defineProperty$27(this, "type", "drag");
    _defineProperty$27(this, "helper", null);
    _defineProperty$27(this, "ddTypes", []);
    _defineProperty$27(this, "selected", []);
    _defineProperty$27(this, "defaultDDHelper", _selected => {
      var _selected$, _selected$0$_context;
      // Table containing clone of rows
      var table = document.createElement("table");
      table.classList.add('egwGridView_grid', 'et2_egw_action_ddHelper_row');
      // tr element to use as last row to show 'more ...' label
      var moreRow = document.createElement('tr');
      moreRow.classList.add('et2_egw_action_ddHelper_moreRow');
      // Main div helper container
      var div = document.createElement("div");
      div.append(table);
      var rows = [];
      // Maximum number of rows to show
      var maxRows = 3;
      // item label
      var itemLabel = egw$1.lang(egw$1.link_get_registry(egw$1.app_name(), _selected.length > 1 ? 'entries' : 'entry') || egw$1.app_name());
      var index = 0;

      // Take select all into account when counting number of rows, because they may not be
      // in _selected object
      var pseudoNumRows = (_selected$ = _selected[0]) !== null && _selected$ !== void 0 && (_selected$ = _selected$._context) !== null && _selected$ !== void 0 && (_selected$ = _selected$._selectionMgr) !== null && _selected$ !== void 0 && _selected$._selectAll ? (_selected$0$_context = _selected[0]._context) === null || _selected$0$_context === void 0 || (_selected$0$_context = _selected$0$_context._selectionMgr) === null || _selected$0$_context === void 0 ? void 0 : _selected$0$_context._total : _selected.length;

      // Clone nodes but use copy webComponent properties
      var carefulClone = node => {
        // Don't clone text nodes, it causes duplication in et2-description
        if (node.nodeType == node.TEXT_NODE) {
          return;
        }
        var clone = node.cloneNode();
        var widget_class = window.customElements.get(clone.localName);
        var properties = widget_class ? widget_class.properties : [];
        for (var key in properties) {
          clone[key] = node[key];
        }
        // Children
        node.childNodes.forEach(c => {
          var child = carefulClone(c);
          if (child) {
            clone.appendChild(child);
          }
        });
        if (widget_class) {
          clone.requestUpdate();
        }
        return clone;
      };
      for (var egwActionObject of _selected) {
        var row = carefulClone(egwActionObject.iface.getDOMNode());
        if (row) {
          rows.push(row);
          table.append(row);
        }
        index++;
        if (index == maxRows) {
          // Label to show number of items
          var spanCnt = document.createElement('span');
          spanCnt.classList.add('et2_egw_action_ddHelper_itemsCnt');
          div.append(spanCnt);
          spanCnt.textContent = pseudoNumRows + ' ' + itemLabel;
          // Number of not shown rows
          var restRows = pseudoNumRows - maxRows;
          if (restRows > 0) {
            moreRow.textContent = egw$1.lang("".concat(pseudoNumRows - maxRows, " more ").concat(itemLabel, " selected ..."));
          }
          table.append(moreRow);
          break;
        }
      }
      var text = document.createElement('div');
      text.classList.add('et2_egw_action_ddHelper_tip');
      div.append(text);

      // Add notice of Ctrl key, if supported
      if ('draggable' in document.createElement('span') && navigator && navigator.userAgent.indexOf('Chrome') >= 0 && egw$1.app_name() == 'filemanager')
        // currently only filemanager supports drag out
        {
          if (rows.length == 1) {
            text.textContent = egw$1.lang('You may drag file out to your desktop', itemLabel);
          } else {
            text.textContent = egw$1.lang('Note: If you drag out these selected rows to desktop only the first selected row will be downloaded.', itemLabel);
          }
        }
      // Final html DOM return as helper structure
      return div;
    });
    _defineProperty$27(this, "registerAction", (_aoi, _callback, _context) => {
      var node = _aoi.getDOMNode() && _aoi.getDOMNode()[0] ? _aoi.getDOMNode()[0] : _aoi.getDOMNode();
      if (node) {
        // Prevent selection
        node.onselectstart = function () {
          return false;
        };
        if (!(window.FileReader && 'draggable' in document.createElement('span'))) {
          // No DnD support
          return;
        }

        // It shouldn't be so hard to get the action...
        var action = null;
        var groups = _context.getActionImplementationGroups();
        if (!groups.drag) {
          return;
        }

        // Bind mouse handlers
        //et2_dataview_view_aoi binds mousedown event in et2_dataview_rowAOI to "egwPreventSelect" function from egw_action_common via jQuery.mousedown
        //jQuery(node).off("mousedown",egwPreventSelect)
        //et2_dataview_view_aoi binds mousedown event in et2_dataview_rowAOI to "egwPreventSelect" function from egw_action_common via addEventListener
        //node.removeEventListener("mousedown",egwPreventSelect)
        node.addEventListener("mousedown", event => {
          if (_context.isSelection(event)) {
            node.setAttribute("draggable", false);
          } else if (event.which != 3) {
            document.getSelection().removeAllRanges();
          }
        });
        node.addEventListener("mouseup", event => {
          node.setAttribute("draggable", true);

          // Set cursor back to auto. Seems FF can't handle cursor reversion
          document.body.style.cursor = 'auto';
        });
        node.setAttribute('draggable', true);
        var ai = this;
        var dragstart = function dragstart(event) {
          // The helper function is called before the start function
          // is evoked. Call the given callback function. The callback
          // function will gather the selected elements and action links
          // and call the doExecuteImplementation function. This
          // will call the onExecute function of the first action
          // in order to obtain the helper object (stored in ai.helper)
          // and the multiple dragDropTypes (ai.ddTypes)
          _callback.call(_context, false, ai);
          if (action && egw$1.app_name() == 'filemanager') {
            if (_context.isSelection(event)) return;

            // Get all selected
            var selected = ai.selected;

            // Set file data
            for (var i = 0; i < 1; i++) {
              var d = selected[i].data || egw$1.dataGetUIDdata(selected[i].id).data || {};
              if (d && d.mime && d.download_url) {
                var url = d.download_url;

                // NEED an absolute URL
                if (url[0] == '/') url = egw$1.link(url);
                // egw.link adds the webserver, but that might not be an absolute URL - try again
                if (url[0] == '/') url = window.location.origin + url;
                event.dataTransfer.setData("DownloadURL", d.mime + ':' + d.name + ':' + url);
              }
            }
            event.dataTransfer.effectAllowed = 'copy';
            if (event.dataTransfer.types.length == 0) {
              // No file data? Abort: drag does nothing
              event.preventDefault();
              return;
            }
          } else {
            event.dataTransfer.effectAllowed = 'linkMove';
          }
          var data = {
            ddTypes: ai.ddTypes,
            selected: ai.selected.map(item => {
              return {
                id: item.id
              };
            })
          };
          if (!ai.helper) {
            ai.helper = ai.defaultDDHelper(ai.selected);
          }
          // Add a basic class to the helper in order to standardize the background layout
          ai.helper.classList.add('et2_egw_action_ddHelper', 'ui-draggable-dragging');
          document.body.append(ai.helper);
          this.classList.add('drag--moving');
          event.dataTransfer.setData('application/json', JSON.stringify(data));

          // Wait for any webComponents to finish
          var wait = [];
          var webComponents = [];
          var check = element => {
            if (typeof element.updateComplete !== "undefined") {
              webComponents.push(element);
              element.requestUpdate();
              wait.push(element.updateComplete);
            }
            element.childNodes.forEach(child => check(child));
          };
          check(ai.helper);
          // Clumsily force widget update, since we can't do it async
          Promise.all(wait).then(() => {
            wait = [];
            webComponents.forEach(e => wait.push(e.updateComplete));
            Promise.all(wait).then(() => {
              event.dataTransfer.setDragImage(ai.helper, 12, 12);
              debugger;
            });
          });
          this.setAttribute('data-egwActionObjID', JSON.stringify(data.selected));
        };
        var dragend = _ => {
          var helper = document.querySelector('.et2_egw_action_ddHelper');
          if (helper) helper.remove();
          var draggable = document.querySelector('.drag--moving');
          if (draggable) draggable.classList.remove('drag--moving');
          // cleanup drop hover class from all other DOMs if there's still anything left
          Array.from(document.getElementsByClassName('et2dropzone drop-hover')).forEach(_i => {
            _i.classList.remove('drop-hover');
          });
        };

        // Drag Event listeners
        node.addEventListener('dragstart', dragstart, false);
        node.addEventListener('dragend', dragend, false);
        return true;
      }
      return false;
    });
    _defineProperty$27(this, "unregisterAction", _aoi => {
      var node = _aoi.getDOMNode();
      if (node) {
        node.setAttribute('draggable', "false");
      }
      return true;
    });
    /**
     * Builds the context menu and shows it at the given position/DOM-Node.
     *
     * @param {string} _context
     * @param {array} _selected
     * @param {object} _links
     */
    _defineProperty$27(this, "executeImplementation", (_context, _selected, _links) => {
      // Reset the helper object of the action implementation
      this.helper = null;
      var hasLink = false;

      // Store the drag-drop types
      this.ddTypes = [];
      this.selected = _selected;

      // Call the onExecute event of the first actionObject
      for (var k in _links) {
        if (_links[k].visible) {
          hasLink = true;

          // Only execute the following code if a JS function is registered
          // for the action and this is the first action link
          if (!this.helper && _links[k].actionObj.onExecute.hasHandler()) {
            this.helper = _links[k].actionObj.execute(_selected);
          }

          // Push the dragType of the associated action object onto the
          // drag type list - this allows an element to support multiple
          // drag/drop types.
          var type = Array.isArray(_links[k].actionObj.dragType) ? _links[k].actionObj.dragType : [_links[k].actionObj.dragType];
          for (var i of type) {
            if (this.ddTypes.indexOf(i) === -1) {
              this.ddTypes.push(i);
            }
          }
        }
      }
      // If no helper has been defined, create a default one
      if (!this.helper && hasLink) {
        this.helper = this.defaultDDHelper(_selected);
      }
      return true;
    });
  }
}

/**
 * @deprecated use upper case class
 */
class egwDragActionImplementation extends EgwDragActionImplementation {}
var _dragActionImpl$1 = null;
function getDragImplementation$1() {
  if (!_dragActionImpl$1) {
    _dragActionImpl$1 = new EgwDragActionImplementation();
  }
  return _dragActionImpl$1;
}

function _defineProperty$26(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The egwDropAction class overwrites the egwAction class and adds the "acceptedTypes"
 * property. This array should contain all "dragTypes" the drop action is allowed to
 *
 * @param {EgwAction} _id
 * @param {string} _handler
 * @param {string} _caption
 * @param {string} _icon
 * @param {(string|function)} _onExecute
 * @param {bool} _allowOnMultiple
 * @returns {egwDropAction}
 */
class EgwDropAction extends EgwAction {
  constructor(_id, _handler, _caption, _icon, _onExecute, _allowOnMultiple) {
    super(_id, _handler, _caption, _icon, _onExecute, _allowOnMultiple);
    _defineProperty$26(this, "acceptedTypes", void 0);
    _defineProperty$26(this, "order", void 0);
    _defineProperty$26(this, "group", void 0);
    this.type = "drop";
    this.acceptedTypes = ["default"];
    this.canHaveChildren = ["drag", "popup"];
    this["default"] = false;
    this.order = 0;
    this.group = 0;
  }
  set_default(_value) {
    this["default"] = _value;
  }
  set_order(_value) {
    this.order = _value;
  }
  set_group(_value) {
    this.group = _value;
  }
  /**
   * The acceptType property allows strings as well as arrays - strings are
   * automatically included in an array.
   *
   * @param {(string|array)} _value
   */
  set_acceptedTypes(_value) {
    if (_value instanceof Array) {
      this.acceptedTypes = _value;
    } else {
      this.acceptedTypes = [_value];
    }
  }
}

var es_array_sort = {};

'use strict';
var tryToString = tryToString$4;

var $TypeError$2 = TypeError;

var deletePropertyOrThrow$1 = function (O, P) {
  if (!delete O[P]) throw $TypeError$2('Cannot delete property ' + tryToString(P) + ' of ' + tryToString(O));
};

var arraySlice = arraySliceSimple;

var floor$1 = Math.floor;

var mergeSort = function (array, comparefn) {
  var length = array.length;
  var middle = floor$1(length / 2);
  return length < 8 ? insertionSort(array, comparefn) : merge$1(
    array,
    mergeSort(arraySlice(array, 0, middle), comparefn),
    mergeSort(arraySlice(array, middle), comparefn),
    comparefn
  );
};

var insertionSort = function (array, comparefn) {
  var length = array.length;
  var i = 1;
  var element, j;

  while (i < length) {
    j = i;
    element = array[i];
    while (j && comparefn(array[j - 1], element) > 0) {
      array[j] = array[--j];
    }
    if (j !== i++) array[j] = element;
  } return array;
};

var merge$1 = function (array, left, right, comparefn) {
  var llength = left.length;
  var rlength = right.length;
  var lindex = 0;
  var rindex = 0;

  while (lindex < llength || rindex < rlength) {
    array[lindex + rindex] = (lindex < llength && rindex < rlength)
      ? comparefn(left[lindex], right[rindex]) <= 0 ? left[lindex++] : right[rindex++]
      : lindex < llength ? left[lindex++] : right[rindex++];
  } return array;
};

var arraySort$1 = mergeSort;

'use strict';
var fails$3 = fails$e;

var arrayMethodIsStrict$2 = function (METHOD_NAME, argument) {
  var method = [][METHOD_NAME];
  return !!method && fails$3(function () {
    // eslint-disable-next-line no-useless-call -- required for testing
    method.call(null, argument || function () { return 1; }, 1);
  });
};

var userAgent$2 = engineUserAgent;

var firefox = userAgent$2.match(/firefox\/(\d+)/i);

var engineFfVersion = !!firefox && +firefox[1];

var UA = engineUserAgent;

var engineIsIeOrEdge = /MSIE|Trident/.test(UA);

var userAgent$1 = engineUserAgent;

var webkit = userAgent$1.match(/AppleWebKit\/(\d+)\./);

var engineWebkitVersion = !!webkit && +webkit[1];

'use strict';
var $$c = _export;
var uncurryThis$4 = functionUncurryThis;
var aCallable$2 = aCallable$a;
var toObject$1 = toObject$5;
var lengthOfArrayLike$1 = lengthOfArrayLike$4;
var deletePropertyOrThrow = deletePropertyOrThrow$1;
var toString$4 = toString$a;
var fails$2 = fails$e;
var internalSort = arraySort$1;
var arrayMethodIsStrict$1 = arrayMethodIsStrict$2;
var FF = engineFfVersion;
var IE_OR_EDGE = engineIsIeOrEdge;
var V8 = engineV8Version;
var WEBKIT = engineWebkitVersion;

var test$1 = [];
var nativeSort = uncurryThis$4(test$1.sort);
var push$1 = uncurryThis$4(test$1.push);

// IE8-
var FAILS_ON_UNDEFINED = fails$2(function () {
  test$1.sort(undefined);
});
// V8 bug
var FAILS_ON_NULL = fails$2(function () {
  test$1.sort(null);
});
// Old WebKit
var STRICT_METHOD = arrayMethodIsStrict$1('sort');

var STABLE_SORT = !fails$2(function () {
  // feature detection can be too slow, so check engines versions
  if (V8) return V8 < 70;
  if (FF && FF > 3) return;
  if (IE_OR_EDGE) return true;
  if (WEBKIT) return WEBKIT < 603;

  var result = '';
  var code, chr, value, index;

  // generate an array with more 512 elements (Chakra and old V8 fails only in this case)
  for (code = 65; code < 76; code++) {
    chr = String.fromCharCode(code);

    switch (code) {
      case 66: case 69: case 70: case 72: value = 3; break;
      case 68: case 71: value = 4; break;
      default: value = 2;
    }

    for (index = 0; index < 47; index++) {
      test$1.push({ k: chr + index, v: value });
    }
  }

  test$1.sort(function (a, b) { return b.v - a.v; });

  for (index = 0; index < test$1.length; index++) {
    chr = test$1[index].k.charAt(0);
    if (result.charAt(result.length - 1) !== chr) result += chr;
  }

  return result !== 'DGBEFHACIJK';
});

var FORCED$1 = FAILS_ON_UNDEFINED || !FAILS_ON_NULL || !STRICT_METHOD || !STABLE_SORT;

var getSortCompare = function (comparefn) {
  return function (x, y) {
    if (y === undefined) return -1;
    if (x === undefined) return 1;
    if (comparefn !== undefined) return +comparefn(x, y) || 0;
    return toString$4(x) > toString$4(y) ? 1 : -1;
  };
};

// `Array.prototype.sort` method
// https://tc39.es/ecma262/#sec-array.prototype.sort
$$c({ target: 'Array', proto: true, forced: FORCED$1 }, {
  sort: function sort(comparefn) {
    if (comparefn !== undefined) aCallable$2(comparefn);

    var array = toObject$1(this);

    if (STABLE_SORT) return comparefn === undefined ? nativeSort(array) : nativeSort(array, comparefn);

    var items = [];
    var arrayLength = lengthOfArrayLike$1(array);
    var itemsLength, index;

    for (index = 0; index < arrayLength; index++) {
      if (index in array) push$1(items, array[index]);
    }

    internalSort(items, getSortCompare(comparefn));

    itemsLength = lengthOfArrayLike$1(items);
    index = 0;

    while (index < itemsLength) array[index] = items[index++];
    while (index < arrayLength) deletePropertyOrThrow(array, index++);

    return array;
  }
});

/**
 * The translation function converts the given native key code into one of the
 * egw key constants as listed above. This key codes were chosen to match the
 * key codes of IE and FF.
 */
var egw_keycode_translation_function = function egw_keycode_translation_function(_nativeKeyCode) {
  // Map the numpad to the 0..9 keys
  if (_nativeKeyCode >= 96 && _nativeKeyCode <= 105) {
    _nativeKeyCode -= 48;
  }
  return _nativeKeyCode;
};

/**
 * Checks whether the given keycode is in the list of valid key codes. If not,
 * returns -1.
 */
function egw_keycode_makeValid(_keyCode) {
  var idx = EGW_VALID_KEYS.indexOf(_keyCode);
  if (idx >= 0) {
    return _keyCode;
  }
  return -1;
}
function _egw_nodeIsInInput(_node) {
  if (_node != null && _node != document) {
    var tagName = _node.tagName.toLowerCase();
    if (tagName == "input" || tagName == "select" || tagName == 'textarea' || tagName == 'button' || ['et2-textbox', 'et2-number', 'et2-searchbox', 'et2-select', 'et2-textarea', 'et2-button'].indexOf(tagName) != -1) {
      return true;
    } else {
      return _egw_nodeIsInInput(_node.parentNode);
    }
  } else {
    return false;
  }
}

/**
 * execute
 * @param fn after DOM is ready
 * replacement for jQuery.ready()
 */
function ready(fn) {
  if (document.readyState !== 'loading') {
    fn();
  } else {
    document.addEventListener('DOMContentLoaded', fn);
  }
}

/**
 * Register the onkeypress handler on the document
 */
ready(() => {
  //waits for DOM ready

  // Fetch the key down event and translate it into browser-independent and
  // easy to use key codes and shift states
  document.addEventListener("keydown", keyboardEvent => {
    // Translate the given key code and make it valid
    // TODO there are actual string key codes now so it would be nice to use those standardized ones instead of using our own
    var keyCode = keyboardEvent.keyCode;
    keyCode = egw_keycode_translation_function(keyCode);
    keyCode = egw_keycode_makeValid(keyCode);

    // Only go on if this is a valid key code - call the key handler
    if (keyCode != -1) {
      // Check whether the event came from the sidebox - if yes, ignore
      //if(jQuery(keyboardEvent.target).parents("#egw_fw_sidemenu").length > 0) return;
      var target = keyboardEvent.target; // this is some kind of element
      while ((target = target.parentNode) && target !== document) {
        if (!"#egw_fw_sidemenu" || target.matches("#egw_fw_sidemenu")) return;
      }

      // If a context menu is open, give the keyboard to it
      if (typeof _egw_active_menu !== undefined && _egw_active_menu && _egw_active_menu.keyHandler(keyCode, keyboardEvent.shiftKey, keyboardEvent.ctrlKey || keyboardEvent.metaKey, keyboardEvent.altKey)) {
        keyboardEvent.preventDefault();
        return;
      }
      // Check whether the event came from an input field - if yes, only
      // allow function keys (like F1) to be captured by our code
      var inInput = _egw_nodeIsInInput(keyboardEvent.target);
      if (!inInput || keyCode >= EGW_KEY_F1 && keyCode <= EGW_KEY_F12) {
        if (egw_keyHandler(keyCode, keyboardEvent.shiftKey, keyboardEvent.ctrlKey || keyboardEvent.metaKey, keyboardEvent.altKey)) {
          // If the key handler successfully passed the key event to some
          // subcomponent, prevent the default action
          keyboardEvent.preventDefault();
        }
      }
    }
  });
});
/**
 * Required to catch the context menu
 */
jQuery(window).on("contextmenu", document, function (event) {
  // Check for actual key press
  if (!(event.originalEvent.x == 1 && event.originalEvent.y == 1)) return true;
  if (!event.ctrlKey && egw_keyHandler(EGW_KEY_MENU, event.shiftKey, event.ctrlKey || event.metaKey, event.altKey)) {
    // If the key handler successfully passed the key event to some
    // subcomponent, prevent the default action
    event.preventDefault();
    return false;
  }
  return true;
});

/**
 * Creates a unique key for the given shortcut
 * TODO those ids exist already
 */
function egw_shortcutIdx(_keyCode, _shift, _ctrl, _alt) {
  return "_" + _keyCode + "_" + (_shift ? "S" : "") + (_ctrl ? "C" : "") + (_alt ? "A" : "");
}
var egw_registeredShortcuts = {};

/**
 * Registers a global shortcut. If the shortcut already exists, it is overwritten.
 * @param {int} _keyCode is one of the keycode constants
 * @param {bool} _shift whether shift has to be set
 * @param {bool} _ctrl whether ctrl has to be set
 * @param {bool} _alt whether alt has to be set
 * @param {function} _handler the function which will be called when the shortcut
 * 	is evoked. An object containing the shortcut data will be passed as first
 * 	parameter.
 * @param {any} _context is the context in which the function will be executed
 */
function egw_registerGlobalShortcut(_keyCode, _shift, _ctrl, _alt, _handler, _context) {
  // Generate the hash map index for the shortcut
  var idx = egw_shortcutIdx(_keyCode, _shift, _ctrl, _alt);

  // Register the shortcut
  egw_registeredShortcuts[idx] = {
    "handler": _handler,
    "context": _context,
    "shortcut": {
      "keyCode": _keyCode,
      "shift": _shift,
      "ctrl": _ctrl,
      "alt": _alt
    }
  };
}

/**
 * Unregisters the given shortcut.
 */
function egw_unregisterGlobalShortcut(_keyCode, _shift, _ctrl, _alt) {
  // Generate the hash map index for the shortcut
  var idx = egw_shortcutIdx(_keyCode, _shift, _ctrl, _alt);

  // Delete the entry from the hash map
  delete egw_registeredShortcuts[idx];
}

/**
 * the egw_keyHandler function handles various key presses. The boolean
 * _shift, _ctrl, _alt values have been translated into platform independent
 * values (for apple devices).
 */
function egw_keyHandler(_keyCode, _shift, _ctrl, _alt) {
  // Check whether there is a global shortcut waiting for the keypress event
  var idx = egw_shortcutIdx(_keyCode, _shift, _ctrl, _alt);
  if (typeof egw_registeredShortcuts[idx] != "undefined") {
    var shortcut = egw_registeredShortcuts[idx];

    // Call the registered shortcut function and return its result, if it handled it
    var result = shortcut.handler.call(shortcut.context, shortcut.shortcut);
    if (result) return result;
  }

  // Pass the keypress to the currently focused action object

  // Get the object manager and fetch the container of the currently
  // focused object
  var focusedObject = egw_globalObjectManager$1 ? egw_globalObjectManager$1.getFocusedObject() : null;
  var appMgr = egw_getAppObjectManager(false);
  if (appMgr && !focusedObject) {
    focusedObject = appMgr.getFocusedObject();
    if (!focusedObject) {
      // If the current application doesn't have a focused object,
      // check whether the application object manager contains an object
      // with the EGW_AO_FLAG_DEFAULT_FOCUS flag set.
      var egwActionObject = null;
      for (var child of appMgr.children) {
        if (egwBitIsSet(EGW_AO_FLAG_DEFAULT_FOCUS, child.flags)) {
          egwActionObject = child;
          break;
        }
      }

      // Get the first child of the found container and focus the first
      // object
      if (egwActionObject && egwActionObject.children.length > 0) {
        egwActionObject.children[0].setFocused(true);
        focusedObject = egwActionObject.children[0];
      }
    }
  }
  if (focusedObject) {
    // Handle the default keys (arrow_up, down etc.)
    var _egwActionObject = focusedObject.getContainerRoot();
    var handled = false;
    if (_egwActionObject) {
      handled = _egwActionObject.handleKeyPress(_keyCode, _shift, _ctrl, _alt);
    }

    // Execute the egw_popup key handler of the focused object
    if (!handled) {
      return focusedObject.executeActionImplementation({
        "keyEvent": {
          "keyCode": _keyCode,
          "shift": _shift,
          "ctrl": _ctrl,
          "alt": _alt
        }
      }, "popup", EGW_AO_EXEC_SELECTED);
    }
    return handled;
  }
  return false;
}

function _defineProperty$25(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
//Global variable which is used to store the currently active menu so that it
//may be closed when another menu opens
var _egw_active_menu = null;

/**
 * Internal function which generates a menu item with the given parameters as used
 * in e.g. the egwMenu.addItem function.
 */
//TODO Icons: write PHP GD script which is capable of generating the menu icons in various states (disabled, highlighted)
function _egwGenMenuItem() {
  var _parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var _id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var _caption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
  var _iconUrl = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
  var _onClick = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
  //Create a menu item with no parent (null) and set the given parameters
  var item = new egwMenuItem(_parent, _id);
  item.set_caption(_caption);
  item.set_iconUrl(_iconUrl);
  item.set_onClick(_onClick);
  return item;
}

/**
 * Internal function which parses the given menu tree in _elements and adds the
 * elements to the given parent.
 */
function _egwGenMenuStructure(_elements, _parent) {
  var items = [];

  //Go through each object in the elements array
  for (var obj of _elements) {
    //Go through each key of the current object
    var item = new egwMenuItem(_parent, null);
    for (var key in obj) {
      if (key == "children" && obj[key].constructor === Array) {
        //Recursively load the children.
        item.children = _egwGenMenuStructure(obj[key], item);
      } else {
        //Directly set the other keys
        //TODO Sanity necessary checks here?
        //TODO Implement menu item getters?
        if (key == "id" || key == "caption" || key == "iconUrl" || key == "checkbox" || key == "checked" || key == "groupIndex" || key == "enabled" || key == "default" || key == "onClick" || key == "hint" || key == "shortcutCaption") {
          item['set_' + key](obj[key]);
        }
      }
    }
    items.push(item);
  }
  return items;
}

/**
 * Internal function which searches for the given ID inside an element tree.
 */
function _egwSearchMenuItem(_elements, _id) {
  for (var item1 of _elements) {
    if (item1.id === _id) return item1;
    var item = _egwSearchMenuItem(item1.children, _id);
    if (item) return item;
  }
  return null;
}

/**
 * Internal function which allows to set the onClick handler of multiple menu items
 */
function _egwSetMenuOnClick(_elements, _onClick) {
  for (var item of _elements) {
    if (item.onClick === null) {
      item.onClick = _onClick;
    }
    _egwSetMenuOnClick(item.children, _onClick);
  }
}

/**
 * replacement function for jquery trigger
 * @param selector
 * @param eventType
 */
function trigger(selector, eventType) {
  if (typeof eventType === 'string' && typeof selector[eventType] === 'function') {
    selector[eventType]();
  } else {
    var event = typeof eventType === 'string' ? new Event(eventType, {
      bubbles: true
    }) : eventType;
    selector.dispatchEvent(event);
  }
}

/**
 * Constructor for the egwMenu object. The egwMenu object is an abstract representation
 * of a context/popup menu. The actual generation of the menu can be done by
 * so-called menu implementations. Those are activated by simply including the JS file
 * of such an implementation.
 *
 * The currently available implementation is the "egwDhtmlxMenu.js" which is based
 * upon the dhtmlxmenu component.
 */
class egwMenu {
  // This is equivalent to iface in other classes and holds an egwMenuImpl
  constructor() {
    //The "items" variable contains all menu items of the menu
    _defineProperty$25(this, "children", []);
    //The "instance" variable contains the currently opened instance. There may
    //only be one instance opened at a time.
    _defineProperty$25(this, "instance", null);
  }

  /**
   * The private _checkImpl function checks whether a menu implementation is available.
   *
   * @returns bool whether a menu implementation is available.
   */
  _checkImpl() {
    return typeof egwMenuImpl == 'function';
  }

  /**
   * Hides the menu if it is currently opened. Otherwise, nothing happens.
   */
  hide() {
    //Reset the currently active menu variable
    if (_egw_active_menu == this) _egw_active_menu = null;

    //Check whether a currently opened instance exists. If it does, close it.
    if (this.instance != null) {
      this.instance.hide();
      this.instance = null;
    }
  }

  /**
   * The showAtElement function shows the menu at the given screen position in a
   * (hopefully) optimal orientation. There can only be one instance of the menu opened at
   * one time and the menu implementation should care that there is only one menu
   * opened globally at all.
   *
   * @param {number} _x is the x position at which the menu will be opened
   * @param {number} _y is the y position at which the menu will be opened
   * @param {boolean} _force if true, the menu will be reopened at the given position,
   * 	even if it already had been opened. Defaults to false.
   * @returns {boolean} whether the menu had been opened
   */
  showAt(_x, _y) {
    var _force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    //Hide any other currently active menu
    if (_egw_active_menu != null) {
      if (_egw_active_menu == this && !_force) {
        this.hide();
        return false;
      } else {
        _egw_active_menu.hide();
      }
    }
    if (this.instance == null && this._checkImpl) {
      //Obtain a new egwMenuImpl object and pass this instance to it
      this.instance = new egwMenuImpl(this.children);
      _egw_active_menu = this;
      this.instance.showAt(_x, _y, () => {
        this.instance = null;
        _egw_active_menu = null;
      });
      return true;
    }
    return false;
  }

  /**
   * Key handler to allow keyboard navigation of menu
   * TODO does not work
   *
   * @return {boolean} true if we dealt with the keypress
   */
  keyHandler(_keyCode, _shift, _ctrl, _alt) {
    // Let main key-handler deal with shortcuts
    var idx = egw_shortcutIdx(_keyCode, _shift, _ctrl, _alt);
    if (typeof egw_registeredShortcuts[idx] !== "undefined") {
      return false;
    }

    //TODO change with shoelace
    var current = this.instance.dhtmlxmenu.menuSelected;
    if (current !== -1) {
      var find_func = function (child) {
        if (child.id === current.replace(this.instance.dhtmlxmenu.idPrefix, "")) {
          return child;
        } else if (child.children) {
          for (var i = 0; i < child.children.length; i++) {
            var result = find_func(child.children[i]);
            if (result) return result;
          }
        }
        return null;
      }.bind(this);
      current = find_func(this);
    } else {
      current = this.children[0];
      trigger("#" + this.instance.dhtmlxmenu.idPrefix + current.id, "mouseover");
      return true;
    }
    switch (_keyCode) {
      case EGW_KEY_ENTER:
        trigger("#" + this.instance.dhtmlxmenu.idPrefix + current.id, "click");
        return true;
      case EGW_KEY_ESCAPE:
        this.hide();
        return true;
      case EGW_KEY_ARROW_RIGHT:
        if (current.children) {
          current = current.children[0];
        }
        break;
      case EGW_KEY_ARROW_LEFT:
        if (current.parent && current.parent !== this) {
          current = current.parent;
        }
        break;
      case EGW_KEY_ARROW_UP:
      case EGW_KEY_ARROW_DOWN:
        var direction = _keyCode === EGW_KEY_ARROW_DOWN ? 1 : -1;
        var parent = current.parent;
        var index = parent.children.indexOf(current);
        var cont = false;

        // Don't run off ends, skip disabled
        do {
          index += direction;
          cont = !parent.children[index] || !parent.children[index].enabled || !parent.children[index].id;
        } while (cont && index + direction < parent.children.length && index + direction >= 0);
        if (index > parent.children.length - 1) {
          index = parent.children.length - 1;
        }
        if (index < 0) {
          index = 0;
        }
        current = parent.children[index];
        break;
      default:
        return false;
    }
    if (current) {
      trigger("#" + this.instance.dhtmlxmenu.idPrefix + current.id, "mouseover");
      this.instance.dhtmlxmenu._redistribSubLevelSelection(this.instance.dhtmlxmenu.idPrefix + current.id, this.instance.dhtmlxmenu.idPrefix + (current.parent ? current.parent.id : this.instance.dhtmlxmenu.topId));
    }
    return true;
  }

  /**
   * Adds a new menu item to the list and returns a reference to that object.
   *
   * @param {string} _id is a unique identifier of the menu item. You can use
   * 	the getItem function to search a specific menu item inside the menu tree. The
   * 	id may also be false, null or "", which makes sense for items like separators,
   * 	which you don't want to access anymore after adding them to the menu tree.
   * @param {string} _caption is the caption of the newly generated menu item. Set the caption
   * 	to "-" in order to create a separator.
   * @param {string} _iconUrl is the URL of the icon which should be prepended to the
   * 	menu item. It may be false, null or "" if you don't want an icon to be displayed.
   * @param {function} _onClick is the JS function which is being executed when the
   * 	menu item is clicked.
   * @returns {egwMenuItem} the newly generated menu item, which had been appended to the
   * 	menu item list.
   */
  addItem(_id, _caption, _iconUrl, _onClick) {
    //Append the item to the list
    var item = new egwMenuItem(this, _id, _caption, _iconUrl, _onClick);
    this.children.push(item);
    return item;
  }

  /**
   * Removes all elements from the menu structure.
   */
  clear() {
    this.children = [];
  }

  /**
   * Loads the menu structure from the given object tree. The object tree is an array
   * of objects which may contain a subset of the menu item properties. The "children"
   * property of such an object is interpreted as a new sub-menu tree and appended
   * to that child.
   *
   * @param {array} _elements is an array of elements which should be added to the menu
   */
  loadStructure(_elements) {
    this.children = _egwGenMenuStructure(_elements, this);
  }

  /**
   * Searches for the given item id within the element tree.
   */
  getItem(_id) {
    return _egwSearchMenuItem(this.children, _id);
  }

  /**
   * Applies the given onClick handler to all menu items which don't have a clicked
   * handler assigned yet.
   */
  setGlobalOnClick(_onClick) {
    _egwSetMenuOnClick(this.children, _onClick);
  }
}

/**
 * Constructor for the egwMenuItem. Each entry in a menu (including separators)
 * is represented by a menu item.
 */
class egwMenuItem {
  set_id(_value) {
    this.id = _value;
  }
  set_caption(_value) {
    //A value of "-" means that this element is a separator.
    this.caption = _value;
  }
  set_checkbox(_value) {
    this.checkbox = _value;
  }
  set_checked(_value) {
    if (_value && this.groupIndex > 0) {
      //Uncheck all other elements in this radio group
      for (var menuItem of this.parent.children) {
        if (menuItem.groupIndex == this.groupIndex) menuItem.checked = false;
      }
    }
    this.checked = _value;
  }
  constructor(_parent, _id) {
    var _caption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
    var _iconUrl = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "";
    var onClick = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    _defineProperty$25(this, "id", void 0);
    _defineProperty$25(this, "caption", "");
    _defineProperty$25(this, "checkbox", false);
    _defineProperty$25(this, "checked", false);
    _defineProperty$25(this, "groupIndex", 0);
    _defineProperty$25(this, "enabled", true);
    _defineProperty$25(this, "iconUrl", "");
    _defineProperty$25(this, "onClick", null);
    _defineProperty$25(this, "default", false);
    _defineProperty$25(this, "data", null);
    _defineProperty$25(this, "shortcutCaption", null);
    _defineProperty$25(this, "children", []);
    _defineProperty$25(this, "parent", void 0);
    //is set for radio Buttons
    _defineProperty$25(this, "_dhtmlx_grpid", "");
    //hint might get set somewhere
    _defineProperty$25(this, "hint", "");
    this.parent = _parent;
    this.id = _id;
    this.caption = _caption;
    this.iconUrl = _iconUrl;
    this.onClick = onClick;
  }

  /**
   * Searches for the given item id within the element tree.
   */
  getItem(_id) {
    if (this.id === _id) return this;
    return _egwSearchMenuItem(this.children, _id);
  }

  /**
   * Applies the given onClick handler to all menu items which don't have a clicked
   * handler assigned yet.
   */
  setGlobalOnClick(_onClick) {
    this.onClick = _onClick;
    _egwSetMenuOnClick(this.children, _onClick);
  }

  /**
   * Adds a new menu item to the list and returns a reference to that object.
   *
   * @param {string} _id is a unique identifier of the menu item. You can use
   * 	the getItem function to search a specific menu item inside the menu tree. The
   * 	id may also be false, null or "", which makes sense for items like separators,
   * 	which you don't want to access anymore after adding them to the menu tree.
   * @param {string} _caption is the caption of the newly generated menu item. Set the caption
   * 	to "-" in order to create a separator.
   * @param {string} _iconUrl is the URL of the icon which should be prepended to the
   * 	menu item. It may be false, null or "" if you don't want an icon to be displayed.
   * @param {function} _onClick is the JS function which is being executed when the
   * 	menu item is clicked.
   * @returns {egwMenuItem} the newly generated menu item, which had been appended to the
   * 	menu item list.
   */
  addItem(_id, _caption, _iconUrl, _onClick) {
    //Append the item to the list
    var item = _egwGenMenuItem(this, _id, _caption, _iconUrl, _onClick);
    this.children.push(item);
    return item;
  }
  set_groupIndex(_value) {
    //If groupIndex is greater than 0 and the element is a checkbox, it is
    //treated like a radio box
    this.groupIndex = _value;
  }
  set_enabled(_value) {
    this.enabled = _value;
  }
  set_onClick(_value) {
    this.onClick = _value;
  }
  set_iconUrl(_value) {
    this.iconUrl = _value;
  }
  set_default(_value) {
    this["default"] = _value;
  }
  set_data(_value) {
    this.data = _value;
  }
  set_hint(_value) {
    this.hint = _value;
  }
  set_shortcutCaption(_value) {
    this.shortcutCaption = _value;
  }
}

function ownKeys$$(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$_(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$$(Object(source), true).forEach(function (key) { _defineProperty$24(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$$(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$24(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * EGroupware TapAndSwipe helper library
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package Api
 * @subpackage ui
 * @link https://www.egroupware.org
 * @author Hadi Nategh <hn@egroupware.org>
 */

class tapAndSwipe {
  /**
   * Constructor
   * @param _element
   * @param _options
   */
  constructor(_element, _options) {
    /**
     * Keeps the touch X start point
     * @private
     */
    _defineProperty$24(this, "_startX", null);
    /**
     * Keeps the touch Y start point
     * @private
     */
    _defineProperty$24(this, "_startY", null);
    /**
     * Keeps the touch X end point
     * @private
     */
    _defineProperty$24(this, "_endX", null);
    /**
     * Keeps the touch Y end point
     * @private
     */
    _defineProperty$24(this, "_endY", null);
    /**
     * keeps the distance travelled between startX point and endX point
     * @private
     */
    _defineProperty$24(this, "_distanceX", null);
    /**
     * keeps the distance travelled between startY point and endY point
     * @private
     */
    _defineProperty$24(this, "_distanceY", null);
    /**
     * flag to keep the status of type of tap
     * @private
     */
    _defineProperty$24(this, "_isTapAndHold", false);
    /**
     * keeps the timeout id for taphold
     */
    _defineProperty$24(this, "_tapHoldTimeout", null);
    /**
     * keeps the timeout id for tap
     */
    _defineProperty$24(this, "_tapTimeout", null);
    /**
     * keeps the contact point on touch start
     * @private
     */
    _defineProperty$24(this, "_fingercount", null);
    _defineProperty$24(this, "_scrolledElementObj", null);
    _defineProperty$24(this, "_hasBeenScrolled", false);
    _defineProperty$24(this, "_scrollEventTriggered", false);
    _defineProperty$24(this, "_stillMoving", false);
    /**
     * Options
     * @protected
     */
    _defineProperty$24(this, "options", null);
    /**
     * Keeps the html node
     */
    _defineProperty$24(this, "element", null);
    this.options = _objectSpread$_(_objectSpread$_({}, tapAndSwipe._default), _options);
    var element = _element || _options.element;
    // Dont construct if the element is not there
    if (!element || !(typeof element != 'string' && element instanceof EventTarget)) return;
    this.element = element instanceof EventTarget ? element : document.querySelector(element);
    this.element.addEventListener('touchstart', this._onTouchStart.bind(this), false);
    this.element.addEventListener('touchend', this._ontouchEnd.bind(this), false);
    this.element.addEventListener('touchmove', this._onTouchMove.bind(this), false);
    this.element.addEventListener('touchcancel', this._onTouchCancel.bind(this), false);
  }
  _onScrolled(event) {
    this._scrollEventTriggered = true;
  }
  _onTouchCancel(event) {
    //cleanup tapHoldTimeout
    window.clearTimeout(this._tapHoldTimeout);
    //cleanup tapHoldTimeout
    window.clearTimeout(this._tapTimeout);
  }
  _onTouchMove(event) {
    this._stillMoving = true;
  }
  /**
   * on touch start event handler
   * @param event
   * @private
   */
  _onTouchStart(event) {
    this._startX = event.changedTouches[0].pageX;
    this._startY = event.changedTouches[0].pageY;
    this._isTapAndHold = false;
    this._fingercount = event.touches.length;
    if (event.composedPath()) {
      var scrolledItem = event.composedPath().filter(_item => {
        if (_item instanceof HTMLElement) _item.addEventListener('scroll', this._onScrolled.bind(this), false);
        return _item instanceof HTMLElement && this.element.contains(_item) && (_item.scrollTop != 0 || _item.scrollLeft != 0);
      });
      if (scrolledItem.length > 0) {
        this._scrolledElementObj = {
          el: scrolledItem[0],
          scrollTop: scrolledItem[0].scrollTop,
          scrollLeft: scrolledItem[0].scrollLeft
        };
      } else {
        this._scrolledElementObj = null;
      }
    }
    this._tapHoldTimeout = window.setTimeout(_ => {
      this._isTapAndHold = true;
      //check scrolling
      if (this.options.allowScrolling && this._stillMoving) {
        return;
      }
      this.options.tapAndHold.call(this, event, this._fingercount);
    }, this.options.tapHoldThreshold);
  }

  /**
   * On touch end event handler
   * @param event
   * @private
   */
  _ontouchEnd(event) {
    this._endX = event.changedTouches[0].pageX;
    this._endY = event.changedTouches[0].pageY;
    this._stillMoving = false;
    if (this._scrolledElementObj) {
      switch (this.options.allowScrolling) {
        case "vertical":
          this._hasBeenScrolled = this._scrolledElementObj.el.scrollTop != this._scrolledElementObj.scrollTop;
          break;
        case "horizental":
          this._hasBeenScrolled = this._scrolledElementObj.el.scrollLeft != this._scrolledElementObj.scrollLeft;
          break;
        case "both":
          this._hasBeenScrolled = this._scrolledElementObj.el.scrollTop != this._scrolledElementObj.scrollTop || this._scrolledElementObj.el.scrollLeft != this._scrolledElementObj.scrollLeft;
          break;
        default:
          this._hasBeenScrolled = false;
      }
    } else {
      this._hasBeenScrolled = false;
    }
    this._handler(event);
  }

  /**
   * Handles the type of gesture and calls the right callback for it
   * @param event
   * @private
   */
  _handler(event) {
    var _this$_hasBeenScrolle;
    //cleanup tapHoldTimeout
    window.clearTimeout(this._tapHoldTimeout);
    this._distanceX = Math.abs(this._endX - this._startX);
    this._distanceY = Math.abs(this._endY - this._startY);
    var isTabOrHold = this._endX == this._startX && this._endY == this._startY || Math.sqrt(this._distanceX * this._distanceX + this._distanceY * 2) < this.options.threshold;
    this._hasBeenScrolled = (_this$_hasBeenScrolle = this._hasBeenScrolled) !== null && _this$_hasBeenScrolle !== void 0 ? _this$_hasBeenScrolle : !isTabOrHold && this._scrollEventTriggered;
    //check scrolling
    if (this.options.allowScrolling && this._hasBeenScrolled) {
      // let the scrolling happens
      return;
    }

    // Tap & TapAndHold handler
    if (isTabOrHold) {
      if (!this._isTapAndHold) {
        this._tapTimeout = window.setTimeout(_ => {
          this.options.tap.call(this, event, this._fingercount);
        }, 100);
      }
      return;
    }

    // left swipe handler
    if (this._endX + this.options.threshold < this._startX && this._distanceX > this._distanceY) {
      if (this._distanceX < this.options.minSwipeThreshold) return;
      this.options.swipe.call(this, event, 'left', this._distanceX, this._fingercount);
      return;
    }

    // right swipe handler
    if (this._endX - this.options.threshold > this._startX && this._distanceX > this._distanceY) {
      if (this._distanceX < this.options.minSwipeThreshold) return;
      this.options.swipe.call(this, event, 'right', this._distanceX, this._fingercount);
      return;
    }

    // up swipe handler
    if (this._endY + this.options.threshold < this._startY && this._distanceY > this._distanceX) {
      if (this._distanceY < this.options.minSwipeThreshold) return;
      this.options.swipe.call(this, event, 'up', this._distanceY, this._fingercount);
      return;
    }

    // down swipe handler
    if (this._endY - this.options.threshold > this._startY && this._distanceY > this._distanceX) {
      if (this._distanceY < this.options.minSwipeThreshold) return;
      this.options.swipe.call(this, event, 'down', this._distanceY, this._fingercount);
      return;
    }
  }

  /**
   * destroy the event listeners
   */
  destroy() {
    this.element.removeEventListener('touchstart', this._onTouchStart);
    this.element.removeEventListener('touchend', this._ontouchEnd);
    this.element.removeEventListener('touchcancel', this._onTouchCancel);
  }
}
_defineProperty$24(tapAndSwipe, "_default", {
  threshold: 5,
  tapHoldThreshold: 3000,
  minSwipeThreshold: 150,
  allowScrolling: 'both',
  swipe: function swipe() {},
  tap: function tap() {},
  tapAndHold: function tapAndHold() {}
});

function _defineProperty$23(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class EgwPopupActionImplementation {
  constructor() {
    _defineProperty$23(this, "type", "popup");
    _defineProperty$23(this, "auto_paste", true);
    _defineProperty$23(this, "registerAction", (_aoi, _callback, _context) => {
      var node = _aoi.getDOMNode();
      if (node) {
        this._registerDefault(node, _callback, _context);
        this._registerContext(node, _callback, _context);
        return true;
      }
      return false;
    });
    _defineProperty$23(this, "unregisterAction", function (_aoi) {
      var node = _aoi.getDOMNode();
      //TODO jQuery replacement
      jQuery(node).off();
      return true;
    });
    /**
     * Builds the context menu and shows it at the given position/DOM-Node.
     *
     * @param {object} _context
     * @param {type} _selected
     * @param {type} _links
     * @param {type} _target
     * @returns {Boolean}
     */
    _defineProperty$23(this, "executeImplementation", (_context, _selected, _links, _target) => {
      if (typeof _target == "undefined") {
        _target = null;
      }
      this._context = _context;
      if (typeof _context == "object" && typeof _context.keyEvent == "object") {
        return this._handleKeyPress(_context.keyEvent, _selected, _links, _target);
      } else if (_context != "default") {
        //Check whether the context has the posx and posy parameters
        if ((typeof _context.posx != "number" || typeof _context.posy != "number") && typeof _context.id != "undefined") {
          // Calculate context menu position from the given DOM-Node
          var node = _context;
          var x = jQuery(node).offset().left;
          var y = jQuery(node).offset().top;
          _context = {
            "posx": x,
            "posy": y
          };
        }
        var menu = this._buildMenu(_links, _selected, _target);
        menu.showAt(_context.posx, _context.posy);
        return true;
      } else {
        var defaultAction = this._getDefaultLink(_links);
        if (defaultAction) {
          defaultAction.execute(_selected);
        }
      }
      return false;
    });
    /**
     * Registers the handler for the default action
     *
     * @param {any} _node
     * @param {function} _callback
     * @param {object} _context
     * @returns {boolean}
     */
    _defineProperty$23(this, "_registerDefault", (_node, _callback, _context) => {
      var defaultHandler = e => {
        // Prevent bubbling bound event on <a> tag, on touch devices
        // a tag should be handled by default event
        if (window.egwIsMobile() && e.target.tagName == "A") return true;
        if (typeof document["selection"] != "undefined" && typeof document["selection"].empty != "undefined") {
          document["selection"].empty();
        } else if (typeof window.getSelection != "undefined") {
          var sel = window.getSelection();
          sel.removeAllRanges();
        }
        if (!(_context.manager.getActionsByAttr('singleClick', true).length > 0 && e.target.classList.contains('et2_clickable'))) {
          _callback.call(_context, "default", this);
        }

        // Stop action from bubbling up to parents
        e.stopPropagation();
        e.cancelBubble = true;

        // remove context menu if we are in mobile theme
        // and intended to open the entry
        if (_egw_active_menu && e.which == 1) _egw_active_menu.hide();
        return false;
      };
      if (window.egwIsMobile() || _context.manager.getActionsByAttr('singleClick', true).length > 0) {
        _node.addEventListener('click', defaultHandler); //jQuery(_node).on('click', defaultHandler);
      } else {
        _node.ondblclick = defaultHandler;
      }
    });
    _defineProperty$23(this, "_getDefaultLink", function (_links) {
      var defaultAction = null;
      for (var k in _links) {
        if (_links[k].actionObj["default"] && _links[k].enabled) {
          defaultAction = _links[k].actionObj;
          break;
        }
      }
      return defaultAction;
    });
    _defineProperty$23(this, "_searchShortcut", (_key, _objs, _links) => {
      for (var item of _objs) {
        var shortcut = item.shortcut;
        if (shortcut && shortcut.keyCode == _key.keyCode && shortcut.shift == _key.shift && shortcut.ctrl == _key.ctrl && shortcut.alt == _key.alt && item.type == "popup" && (typeof _links[item.id] == "undefined" || _links[item.id].enabled)) {
          return item;
        }
        var obj = this._searchShortcut(_key, item.children, _links);
        if (obj) {
          return obj;
        }
      }
    });
    _defineProperty$23(this, "_searchShortcutInLinks", (_key, _links) => {
      var objs = [];
      for (var k in _links) {
        if (_links[k].enabled) {
          objs.push(_links[k].actionObj);
        }
      }
      return this._searchShortcut(_key, objs, _links);
    });
    /**
     * Handles a key press
     *
     * @param {object} _key
     * @param {type} _selected
     * @param {type} _links
     * @param {type} _target
     * @returns {Boolean}
     */
    _defineProperty$23(this, "_handleKeyPress", (_key, _selected, _links, _target) => {
      // Handle the default
      if (_key.keyCode == EGW_KEY_ENTER && !_key.ctrl && !_key.shift && !_key.alt) {
        var defaultAction = this._getDefaultLink(_links);
        if (defaultAction) {
          defaultAction.execute(_selected);
          return true;
        }
      }

      // Menu button
      if (_key.keyCode == EGW_KEY_MENU && !_key.ctrl) {
        return this.executeImplementation({
          posx: 0,
          posy: 0
        }, _selected, _links, _target);
      }

      // Check whether the given shortcut exists
      var obj = this._searchShortcutInLinks(_key, _links);
      if (obj) {
        obj.execute(_selected);
        return true;
      }
      return false;
    });
    _defineProperty$23(this, "_handleTapHold", function (_node, _callback) {
      //TODO (todo-jquery): ATM we need to convert the possible given jquery dom node object into DOM Element, this
      // should be no longer necessary after removing jQuery nodes.
      if (_node instanceof jQuery) {
        _node = _node[0];
      }
      var tap = new tapAndSwipe(_node, {
        // this threshold must be the same as the one set in et2_dataview_view_aoi
        tapHoldThreshold: 1000,
        allowScrolling: "both",
        tapAndHold: function tapAndHold(event, fingercount) {
          if (fingercount >= 2) return;
          // don't trigger contextmenu if sorting is happening
          if (document.querySelector('.sortable-drag')) return;
          _callback(event);
        }
      });
      // bind a custom event tapandhold to be able to call it from nm action button
      _node.addEventListener('tapandhold', _event => {
        _callback(_event);
      });
    });
    /**
     * Registers the handler for the context menu
     *
     * @param {any} _node
     * @param {function} _callback
     * @param {object} _context
     * @returns {boolean}
     */
    _defineProperty$23(this, "_registerContext", (_node, _callback, _context) => {
      var contextHandler = e => {
        //Obtain the event object, this should not happen at any point
        if (!e) {
          e = window.event;
        }

        // Close any open tooltip so they don't get in the way
        egw$1(window).tooltipCancel();
        if (_egw_active_menu) {
          _egw_active_menu.hide();
        } else if (!e.ctrlKey && e.which == 3 || e.which === 0 || e.type === 'tapandhold')
          // tap event indicates by 0
          {
            var _xy = this._getPageXY(e);
            var _implContext = {
              event: e,
              posx: _xy.posx,
              posy: _xy.posy
            };
            _callback.call(_context, _implContext, this);
          }
        e.cancelBubble = !e.ctrlKey || e.which == 1;
        if (e.stopPropagation && e.cancelBubble) {
          e.stopPropagation();
        }
        return !e.cancelBubble;
      };
      // Safari still needs the taphold to trigger contextmenu
      // Chrome has default event on touch and hold which acts like right click
      this._handleTapHold(_node, contextHandler);
      if (!window.egwIsMobile()) jQuery(_node).on('contextmenu', contextHandler);
    });
    /**
     * Groups and sorts the given action tree layer
     *
     * @param {type} _layer
     * @param {type} _links
     * @param {type} _parentGroup
     */
    _defineProperty$23(this, "_groupLayers", (_layer, _links, _parentGroup) => {
      // Separate the multiple groups out of the layer
      var link_groups = {};
      for (var i = 0; i < _layer.children.length; i++) {
        var popupAction = _layer.children[i].action;

        // Check whether the link group of the current element already exists,
        // if not, create the group
        var grp = popupAction.group;
        if (typeof link_groups[grp] == "undefined") {
          link_groups[grp] = [];
        }

        // Search the link data for this action object if none is found,
        // visible and enabled = true is assumed
        var visible = true;
        var enabled = true;
        if (typeof _links[popupAction.id] != "undefined") {
          visible = _links[popupAction.id].visible;
          enabled = _links[popupAction.id].enabled;
        }

        // Insert the element in order
        var inserted = false;
        var groupObj = {
          "actionObj": popupAction,
          "visible": visible,
          "enabled": enabled,
          "groups": []
        };
        for (var j = 0; j < link_groups[grp].length; j++) {
          var elem = link_groups[grp][j].actionObj;
          if (elem.order > popupAction.order) {
            inserted = true;
            link_groups[grp].splice(j, 0, groupObj);
            break;
          }
        }

        // If the object hasn't been inserted, add it to the end of the list
        if (!inserted) {
          link_groups[grp].push(groupObj);
        }

        // If this child itself has children, group those elements too
        if (_layer.children[i].children.length > 0) {
          this._groupLayers(_layer.children[i], _links, groupObj);
        }
      }

      // Transform the link_groups object into a sorted array
      var groups = [];
      for (var k in link_groups) {
        groups.push({
          "grp": k,
          "links": link_groups[k]
        });
      }
      groups.sort(function (a, b) {
        var ia = parseInt(a.grp);
        var ib = parseInt(b.grp);
        return ia > ib ? 1 : ia < ib ? -1 : 0;
      });

      // Append the groups to the groups2 array
      var groups2 = [];
      for (var item of groups) {
        groups2.push(item.links);
      }
      _parentGroup.groups = groups2;
    });
    /**
     * Build the menu layers
     *
     * @param {type} _menu
     * @param {type} _groups
     * @param {type} _selected
     * @param {type} _enabled
     * @param {type} _target
     */
    _defineProperty$23(this, "_buildMenuLayer", (_menu, _groups, _selected, _enabled, _target) => {
      var firstGroup = true;
      for (var item1 of _groups) {
        var firstElem = true;

        // Go through the elements of each group
        for (var link of item1) {
          if (link.visible) {
            // Add a separator after each group
            if (!firstGroup && firstElem) {
              _menu.addItem("", "-");
            }
            firstElem = false;
            var item = _menu.addItem(link.actionObj.id, link.actionObj.caption, link.actionObj.iconUrl);
            item.default = link.actionObj["default"];

            // As this code is also used when a drag-drop popup menu is built,
            // we have to perform this check
            if (link.actionObj.type == "popup") {
              item.set_hint(link.actionObj.hint);
              item.set_checkbox(link.actionObj.checkbox);
              item.set_checked(link.actionObj.checked);
              if (link.actionObj.checkbox && link.actionObj.isChecked) {
                item.set_checked(link.actionObj.isChecked.exec(link.actionObj, _selected));
              }
              item.set_groupIndex(link.actionObj.radioGroup);
              if (link.actionObj.shortcut && !window.egwIsMobile()) {
                var shortcut = link.actionObj.shortcut;
                item.set_shortcutCaption(shortcut.caption);
              }
            }
            item.set_data(link.actionObj);
            if (link.enabled && _enabled) {
              item.set_onClick(elem => {
                // Pass the context
                elem.data.menu_context = this._context;

                // Copy the "checked" state
                if (typeof elem.data.checked != "undefined") {
                  elem.data.checked = elem.checked;
                }
                elem.data.execute(_selected, _target);
                if (typeof elem.data.checkbox != "undefined" && elem.data.checkbox) {
                  return elem.data.checked;
                }
              });
            } else {
              item.set_enabled(false);
            }

            // Append the parent groups
            if (link.groups) {
              this._buildMenuLayer(item, link.groups, _selected, link.enabled, _target);
            }
          }
        }
        firstGroup = firstGroup && firstElem;
      }
    });
    /**
     * Builds the context menu from the given action links
     *
     * @param {type} _links
     * @param {type} _selected
     * @param {type} _target
     * @returns {egwMenu|EgwActionImplementation._buildMenu.menu}
     */
    _defineProperty$23(this, "_buildMenu", (_links, _selected, _target) => {
      // Build a tree containing all actions
      var tree = {
        "root": []
      };

      // Automatically add in Drag & Drop actions
      if (this.auto_paste && !window.egwIsMobile() && !this._context.event.type.match(/touch/)) {
        this._addCopyPaste(_links, _selected);
      }
      for (var k in _links) {
        _links[k].actionObj.appendToTree(tree);
      }

      // We need the dummy object container in order to pass the array by
      // reference
      var groups = {
        "groups": []
      };
      if (tree.root.length > 0) {
        // Sort every action object layer by the given sort position and grouping
        this._groupLayers(tree.root[0], _links, groups);
      }
      var menu = new egwMenu();

      // Build the menu layers
      this._buildMenuLayer(menu, groups.groups, _selected, true, _target);
      return menu;
    });
    _defineProperty$23(this, "_getPageXY", function getPageXY(event) {
      // document.body.scrollTop does not work in IE
      var scrollTop = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
      var scrollLeft = document.body.scrollLeft ? document.body.scrollLeft : document.documentElement.scrollLeft;
      return {
        'posx': event.clientX + scrollLeft,
        'posy': event.clientY + scrollTop
      };
    });
    /**
     * Automagically add in context menu items for copy and paste from
     * drag and drop actions, based on current clipboard and the accepted types
     *
     * @param {object[]} _links Actions for inclusion in the menu
     * @param {EgwActionObject[]} _selected Currently selected entries
     */
    _defineProperty$23(this, "_addCopyPaste", (_links, _selected) => {
      // Get a list of drag & drop actions
      var drag = _selected[0].getSelectedLinks('drag').links;
      var drop = _selected[0].getSelectedLinks('drop').links;

      // No drags & no drops means early exit (only by default added egw_cancel_drop does NOT count!)
      if ((!drag || jQuery.isEmptyObject(drag)) && (!drop || jQuery.isEmptyObject(drop) || Object.keys(drop).length === 1 && typeof drop.egw_cancel_drop !== 'undefined')) {
        return;
      }

      // Find existing actions so we don't get copies
      var mgr = _selected[0].manager;
      var copy_action = mgr.getActionById('egw_copy');
      var add_action = mgr.getActionById('egw_copy_add');
      var clipboard_action = mgr.getActionById('egw_os_clipboard');
      var paste_action = mgr.getActionById('egw_paste');

      // Fake UI so we can simulate the position of the drop
      var ui = {
        position: {
          top: 0,
          left: 0
        },
        offset: {
          top: 0,
          left: 0
        }
      };
      if (this._context.event) {
        var event = this._context.event.originalEvent;
        ui.position = {
          top: event.pageY,
          left: event.pageX
        };
        ui.offset = {
          top: event.offsetY,
          left: event.offsetX
        };
      }
      // Create default copy menu action
      if (drag && !jQuery.isEmptyObject(drag)) {
        // Don't re-add if it's there
        if (copy_action == null) {
          // Create a drag action that allows linking
          copy_action = mgr.addAction('popup', 'egw_copy', window.egw.lang('Copy to clipboard'), window.egw.image('copy'), function (action, selected) {
            // Copied, now add to clipboard
            var clipboard = {
              type: [],
              selected: []
            };

            // When pasting we need to know the type of drag
            for (var k in drag) {
              if (drag[k].enabled && drag[k].actionObj.dragType.length > 0) {
                clipboard.type = clipboard.type.concat(drag[k].actionObj.dragType);
              }
            }
            clipboard.type = jQuery.uniqueSort(clipboard.type);
            // egwAction is a circular structure and can't be stringified so just take what we want
            // Hopefully that's enough for the action handlers
            for (var _k in selected) {
              if (selected[_k].id) clipboard.selected.push({
                id: selected[_k].id,
                data: selected[_k].data
              });
            }

            // Save it in session
            window.egw.setSessionItem('phpgwapi', 'egw_clipboard', JSON.stringify(clipboard));
          }, true);
          copy_action.group = 2.5;
        }
        if (add_action == null) {
          // Create an action to add selected to clipboard
          add_action = mgr.addAction('popup', 'egw_copy_add', window.egw.lang('Add to clipboard'), window.egw.image('copy'), function (action, selected) {
            // Copied, now add to clipboard
            var clipboard = JSON.parse(window.egw.getSessionItem('phpgwapi', 'egw_clipboard')) || {
              type: [],
              selected: []
            };

            // When pasting we need to know the type of drag
            for (var k in drag) {
              if (drag[k].enabled && drag[k].actionObj.dragType.length > 0) {
                clipboard.type = clipboard.type.concat(drag[k].actionObj.dragType);
              }
            }
            clipboard.type = [...new Set(clipboard.type)].sort();
            // egwAction is a circular structure and can't be stringified so just take what we want
            // Hopefully that's enough for the action handlers
            for (var _k2 in selected) {
              if (selected[_k2].id) clipboard.selected.push({
                id: selected[_k2].id,
                data: selected[_k2].data
              });
            }

            // Save it in session
            window.egw.setSessionItem('phpgwapi', 'egw_clipboard', JSON.stringify(clipboard));
          }, true);
          add_action.group = 2.5;
        }
        if (clipboard_action == null) {
          // Create an action to add selected to clipboard
          clipboard_action = mgr.addAction('popup', 'egw_os_clipboard', window.egw.lang('Copy to OS clipboard'), window.egw.image('copy'), function (action) {
            if (document.queryCommandSupported('copy')) {
              jQuery(action.data.target).trigger('copy');
            }
          }, true);
          clipboard_action.group = 2.5;
        }
        var os_clipboard_caption = "";
        if (this._context.event) {
          os_clipboard_caption = this._context.event.originalEvent.target.innerText.trim();
          clipboard_action.set_caption(window.egw.lang('Copy "%1"', os_clipboard_caption.length > 20 ? os_clipboard_caption.substring(0, 20) + '...' : os_clipboard_caption));
          clipboard_action.data.target = this._context.event.originalEvent.target;
        }
        jQuery(clipboard_action.data.target).off('copy').on('copy', function (event) {
          try {
            window.egw.copyTextToClipboard(os_clipboard_caption, clipboard_action.data.target, event).then(successful => {
              // Fallback
              if (typeof successful == "undefined") {
                // Clear message
                window.egw.message(window.egw.lang("'%1' copied to clipboard", os_clipboard_caption.length > 20 ? os_clipboard_caption.substring(0, 20) + '...' : os_clipboard_caption));
                window.getSelection().removeAllRanges();
                return false;
              } else {
                // Show fail message
                window.egw.message(window.egw.lang('Use Ctrl-C/Cmd-C to copy'));
              }
            });
          } catch (err) {}
        });
        if (typeof _links[copy_action.id] == 'undefined') {
          _links[copy_action.id] = {
            "actionObj": copy_action,
            "enabled": true,
            "visible": true,
            "cnt": 0
          };
        }
        if (typeof _links[add_action.id] == 'undefined') {
          _links[add_action.id] = {
            "actionObj": add_action,
            "enabled": true,
            "visible": true,
            "cnt": 0
          };
        }
        if (typeof _links[clipboard_action.id] == 'undefined') {
          _links[clipboard_action.id] = {
            "actionObj": clipboard_action,
            "enabled": os_clipboard_caption.length > 0,
            "visible": os_clipboard_caption.length > 0,
            "cnt": 0
          };
        }
      }

      // Create default paste menu item
      if (drop && !jQuery.isEmptyObject(drop)) {
        // Create paste action
        // This injects the clipboard data and calls the original handler
        var paste_exec = function paste_exec(action, selected) {
          // Add in clipboard as a sender
          var clipboard = JSON.parse(window.egw.getSessionItem('phpgwapi', 'egw_clipboard'));
          // Fake drop position
          drop[action.id].actionObj.ui = ui;
          // Set a flag so apps can tell the difference, if they need to
          drop[action.id].actionObj.paste = true;
          drop[action.id].actionObj.execute(clipboard.selected, selected[0]);
          drop[action.id].actionObj.paste = false;
        };
        var clipboard = JSON.parse(window.egw.getSessionItem('phpgwapi', 'egw_clipboard')) || {
          type: [],
          selected: []
        };

        // Don't re-add if action already exists
        if (paste_action == null) {
          paste_action = mgr.addAction('popup', 'egw_paste', window.egw.lang('Paste'), window.egw.image('editpaste'), paste_exec, true);
          paste_action.group = 2.5;
          paste_action.order = 9;
          if (typeof paste_action.canHaveChildren !== "boolean") {
            paste_action.canHaveChildren.push('drop');
          }
        }

        // Set hint to something resembling current clipboard
        var hint = window.egw.lang('Clipboard') + ":\n";
        paste_action.set_hint(hint);
        // Add titles of entries
        for (var i = 0; i < clipboard.selected.length; i++) {
          var id = clipboard.selected[i].id.split('::');
          window.egw.link_title(id[0], id[1], function (title) {
            if (title) this.hint += title + "\n";
          }, paste_action);
        }

        // Add into links, so it's included in menu
        // @ts-ignore exec uses arguments:IArguments and therefor can consume them even if ts does not know it
        if (paste_action && paste_action.enabled.exec(paste_action, clipboard.selected, _selected[0])) {
          if (typeof _links[paste_action.id] == 'undefined') {
            _links[paste_action.id] = {
              "actionObj": paste_action,
              "enabled": false,
              "visible": clipboard != null,
              "cnt": 0
            };
          }
          while (paste_action.children.length > 0) {
            paste_action.children[0].remove();
          }

          // If nothing [valid] in the clipboard, don't bother with children
          if (clipboard == null || typeof clipboard.type != 'object') {
            return;
          }

          // Add in actual actions as children
          for (var k in drop) {
            // Add some choices - need to be a copy, or they interfere with
            // the original
            //replace jQuery with spread operator
            // set the Prototype of the copy set_onExecute is not available otherwise
            var drop_clone = drop[k].actionObj.clone(); //Object.assign(Object.create(Object.getPrototypeOf(drop[k].actionObj)), drop[k].actionObj) //{...drop[k].actionObj};
            //warning This method is really slow
            //Object.setPrototypeOf(drop_clone, EgwAction.prototype)
            var parent = paste_action.parent === drop_clone.parent ? paste_action : paste_action.getActionById(drop_clone.parent.id) || paste_action;
            drop_clone.parent = parent;
            drop_clone.onExecute = new EgwFnct(this, null, []);
            drop_clone.children = [];
            drop_clone.set_onExecute(paste_exec);
            parent.children.push(drop_clone);
            parent.allowOnMultiple = paste_action.allowOnMultiple && drop_clone.allowOnMultiple;
            _links[k] = jQuery.extend({}, drop[k]);
            _links[k].actionObj = drop_clone;

            // Drop is allowed if clipboard types intersect drop types
            _links[k].enabled = false;
            _links[k].visible = false;
            for (var _i = 0; _i < drop_clone.acceptedTypes.length; _i++) {
              if (clipboard.type.indexOf(drop_clone.acceptedTypes[_i]) != -1) {
                _links[paste_action.id].enabled = true;
                _links[k].enabled = true;
                _links[k].visible = true;
                break;
              }
            }
          }
        }
      }
    });
    _defineProperty$23(this, "_context", void 0);
  }
}

/**
 * @deprecated use uppercase class
 */
class egwPopupActionImplementation extends EgwPopupActionImplementation {}
var _popupActionImpl = null;
function getPopupImplementation() {
  if (!_popupActionImpl) {
    _popupActionImpl = new EgwPopupActionImplementation();
  }
  return _popupActionImpl;
}

function _defineProperty$22(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class EgwDropActionImplementation {
  constructor() {
    _defineProperty$22(this, "type", "drop");
    //keeps track of current drop element where dragged item's entered.
    // it's necessary for dragenter/dragleave issue correction.
    _defineProperty$22(this, "currentDropEl", null);
    _defineProperty$22(this, "registerAction", (_aoi, _callback, _context) => {
      var node = _aoi.getDOMNode() && _aoi.getDOMNode()[0] ? _aoi.getDOMNode()[0] : _aoi.getDOMNode();
      var self = this;
      if (node) {
        node.classList.add('et2dropzone');
        var dragover = event => {
          if (event.preventDefault) {
            event.preventDefault();
          }
          if (!this.getTheDraggedDOM()) return;
          var data = {
            event: event,
            ui: this.getTheDraggedData()
          };
          _aoi.triggerEvent(EGW_AI_DRAG_OVER, data);
          return true;
        };
        var dragenter = function dragenter(event) {
          event.stopImmediatePropagation();
          // don't trigger dragenter if we are entering the drag element
          // don't go further if the dragged element is no there (happens when a none et2 dragged element is being dragged)
          if (!self.getTheDraggedDOM() || self.isTheDraggedDOM(this) || this == self.currentDropEl) return;
          self.currentDropEl = event.currentTarget;
          event.dataTransfer.dropEffect = 'link';
          var data = {
            event: event,
            ui: self.getTheDraggedData()
          };
          _aoi.triggerEvent(EGW_AI_DRAG_ENTER, data);

          // cleanup drop hover class from all other DOMs if there's still anything left
          Array.from(document.getElementsByClassName('et2dropzone drop-hover')).forEach(_i => {
            _i.classList.remove('drop-hover');
          });
          this.classList.add('drop-hover');

          // stop the event from being fired for its children
          event.preventDefault();
          return false;
        };
        var drop = function drop(event) {
          event.preventDefault();
          // don't go further if the dragged element is no there (happens when a none et2 dragged element is being dragged)
          if (!self.getTheDraggedDOM()) return;

          // remove the hover class
          this.classList.remove('drop-hover');
          var helper = self.getHelperDOM();
          var ui = self.getTheDraggedData();
          ui.position = {
            top: event.clientY,
            left: event.clientX
          };
          ui.offset = {
            top: event.offsetY,
            left: event.offsetX
          };
          var data = JSON.parse(event.dataTransfer.getData('application/json'));
          if (!self.isAccepted(data, _context, _callback, undefined) || self.isTheDraggedDOM(this)) {
            // clean up the helper dom
            if (helper) helper.remove();
            return;
          }
          var selected = data.selected.map(item => {
            return egw_getObjectManager(item.id, false);
          });

          //links is an Object of DropActions bound to their names
          var links = _callback.call(_context, "links", self, EGW_AO_EXEC_THIS);

          // Disable all links which only accept types which are not
          // inside ddTypes
          for (var k in links) {
            var accepted = links[k].actionObj.acceptedTypes;
            var enabled = false;
            for (var i = 0; i < data.ddTypes.length; i++) {
              if (accepted.indexOf(data.ddTypes[i]) != -1) {
                enabled = true;
                break;
              }
            }
            // Check for allowing multiple selected
            if (!links[k].actionObj.allowOnMultiple && selected.length > 1) {
              enabled = false;
            }
            if (!enabled) {
              links[k].enabled = false;
              links[k].visible = !links[k].actionObj.hideOnDisabled;
            }
          }

          // Check whether there is only one link
          var cnt = 0;
          var lnk = null;
          for (var _k in links) {
            if (links[_k].enabled && links[_k].visible) {
              lnk = links[_k];
              cnt += 1 + links[_k].actionObj.children.length;

              // Add ui, so you know what happened where
              lnk.actionObj.ui = ui;
            }
          }
          if (cnt == 1) {
            window.setTimeout(function () {
              lnk.actionObj.execute(selected, _context);
            }, 0);
          }
          if (cnt > 1) {
            // More than one drop action link is associated
            // to the drop event - show those as a popup menu
            // and let the user decide which one to use.
            // This is possible as the popup and the popup action
            // object and the drop action object share same
            // set of properties.
            var popup = getPopupImplementation();
            var pos = popup._getPageXY(event);

            // Don't add paste actions, this is a drop
            popup.auto_paste = false;
            window.setTimeout(function () {
              popup.executeImplementation(pos, selected, links, _context);
              // Reset, popup is reused
              popup.auto_paste = true;
            }, 0); // Timeout is needed to have it working in IE
          }
          // Set cursor back to auto. Seems FF can't handle cursor reversion
          jQuery('body').css({
            cursor: 'auto'
          });
          _aoi.triggerEvent(EGW_AI_DRAG_OUT, {
            event: event,
            ui: self.getTheDraggedData()
          });

          // clean up the helper dom
          if (helper) helper.remove();
          self.getTheDraggedDOM().classList.remove('drag--moving');
        };
        var dragleave = function dragleave(event) {
          event.stopImmediatePropagation();

          // don't trigger dragleave if we are leaving the drag element
          // don't go further if the dragged element is no there (happens when a none et2 dragged element is being dragged)
          if (!self.getTheDraggedDOM() || self.isTheDraggedDOM(this) || this == self.currentDropEl) return;
          var data = {
            event: event,
            ui: self.getTheDraggedData()
          };
          _aoi.triggerEvent(EGW_AI_DRAG_OUT, data);
          this.classList.remove('drop-hover');
          event.preventDefault();
          return false;
        };

        // DND Event listeners
        node.addEventListener('dragover', dragover, false);
        node.addEventListener('dragenter', dragenter, false);
        node.addEventListener('drop', drop, false);
        node.addEventListener('dragleave', dragleave, false);
        return true;
      }
      return false;
    });
    _defineProperty$22(this, "unregisterAction", function (_aoi) {
      var node = _aoi.getDOMNode();
      if (node) {
        node.classList.remove('et2dropzone');
      }
      return true;
    });
    /**
     * Builds the context menu and shows it at the given position/DOM-Node.
     *
     * @param {string} _context
     * @param {array} _selected
     * @param {object} _links
     */
    _defineProperty$22(this, "executeImplementation", function (_context, _selected, _links) {
      if (_context == "links") {
        return _links;
      }
    });
    _defineProperty$22(this, "isTheDraggedDOM", function (_dom) {
      return _dom.classList.contains('drag--moving');
    });
    _defineProperty$22(this, "getTheDraggedDOM", function () {
      return document.querySelector('.drag--moving');
    });
    _defineProperty$22(this, "getHelperDOM", function () {
      return document.querySelector('.et2_egw_action_ddHelper');
    });
    _defineProperty$22(this, "getTheDraggedData", () => {
      // @ts-ignore // in our case dataset will be present
      var data = this.getTheDraggedDOM().dataset.egwactionobjid;
      var selected = [];
      if (data) {
        data = JSON.parse(data);
        selected = data.map(item => {
          return egw_getObjectManager(item.id, false);
        });
      }
      return {
        draggable: this.getTheDraggedDOM(),
        helper: this.getHelperDOM(),
        selected: selected,
        position: undefined,
        offset: undefined
      };
    });
    // check if given draggable is accepted for drop
    _defineProperty$22(this, "isAccepted", (_data, _context, _callback, _node) => {
      if (_node && !_node.classList.contains('et2dropzone')) return false;
      if (typeof _data.ddTypes != "undefined") {
        var accepted = this._fetchAccepted(_callback.call(_context, "links", this, EGW_AO_EXEC_THIS));

        // Check whether all drag types of the selected objects
        // are accepted
        var ddTypes = _data.ddTypes;
        for (var i = 0; i < ddTypes.length; i++) {
          if (accepted.indexOf(ddTypes[i]) != -1) {
            return true;
          }
        }
      }
      return false;
    });
    _defineProperty$22(this, "_fetchAccepted", _links => {
      // Accumulate the accepted types
      var accepted = [];
      for (var k in _links) {
        for (var i = 0; i < _links[k].actionObj.acceptedTypes.length; i++) {
          var type = _links[k].actionObj.acceptedTypes[i];
          if (accepted.indexOf(type) == -1) {
            accepted.push(type);
          }
        }
      }
      return accepted;
    });
  }
}
class egwDropActionImplementation extends EgwDropActionImplementation {}

function _defineProperty$21(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class EgwPopupAction extends EgwAction {
  constructor(_id, _handler, _caption, _icon, _onExecute, _allowOnMultiple) {
    super(_id, _handler, _caption, _icon, _onExecute, _allowOnMultiple);
    //var action = new EgwAction(_id, _handler, _caption, _icon, _onExecute, _allowOnMultiple);
    _defineProperty$21(this, "default", false);
    _defineProperty$21(this, "order", 0);
    _defineProperty$21(this, "group", 0);
    _defineProperty$21(this, "hint", false);
    _defineProperty$21(this, "checkbox", false);
    _defineProperty$21(this, "radioGroup", 0);
    _defineProperty$21(this, "checked", false);
    _defineProperty$21(this, "confirm_mass_selection", null);
    _defineProperty$21(this, "shortcut", null);
    _defineProperty$21(this, "singleClick", false);
    _defineProperty$21(this, "isChecked", void 0);
    this.type = "popup";
    this.canHaveChildren = ["popup"];
  }
  set_singleClick(_value) {
    this.singleClick = _value;
  }
  set_default(_value) {
    this.default = _value;
  }
  set_order(_value) {
    this.order = _value;
  }
  set_group(_value) {
    this.group = _value;
  }
  set_hint(_value) {
    this.hint = _value;
  }
  // If true, the action will be rendered as checkbox
  set_checkbox(_value) {
    this.checkbox = _value;
  }
  set_checked(_value) {
    this.checked = _value;
  }
  /**
   * Set either a confirmation prompt, or TRUE to indicate that this action
   * cares about large selections and to ask the confirmation prompt(s)
   *
   * @param {String|Boolean} _value
   */
  set_confirm_mass_selection(_value) {
    this.confirm_mass_selection = _value;
  }
  // Allow checkbox to be set from context using the given function
  set_isChecked(_value) {
    this.isChecked = new EgwFnct(this, null, []);
    if (_value !== null) {
      this.isChecked.setValue(_value);
    }
  }
  // If radioGroup is >0 and the element is a checkbox, radioGroup specifies
  // the group of radio buttons this one belongs to
  set_radioGroup(_value) {
    this.radioGroup = _value;
  }
  set_shortcut(_value) {
    if (_value) {
      var sc = {
        "keyCode": -1,
        "shift": false,
        "ctrl": false,
        "alt": false,
        "caption": ""
      };
      if (typeof _value == "object" && typeof _value.keyCode != "undefined" && typeof _value.caption != "undefined") {
        sc.keyCode = _value.keyCode;
        sc.caption = _value.caption;
        sc.shift = typeof _value.shift == "undefined" ? false : _value.shift;
        sc.ctrl = typeof _value.ctrl == "undefined" ? false : _value.ctrl;
        sc.alt = typeof _value.alt == "undefined" ? false : _value.alt;
      }
      this.shortcut = sc;
    } else {
      this.shortcut = false;
    }
  }
}

/**
 * @deprecated
 * use uppercase class
 */
class egwPopupAction extends EgwPopupAction {}

function _defineProperty$20(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Getter functions for the global egwActionManager and egwObjectManager objects
 */

var egw_globalActionManager = null;
var egw_globalObjectManager$1 = null;

/**
 * Returns the action manager for the given application - each application has its
 * own sub-ActionManager in the global action manager object to prevent collisions
 * from happening
 *
 * @param _id is the name of the sub-actionManager which should be returned.
 *    If the action manager does not exist right now, it is created. If the
 *    parameter is omitted or null, the global action manager is returned.
 * @param {boolean} [_create=true] If an objectManager with the given id is not
 *    found, it will be created at the top level.
 * @param {number} [_search_depth=Infinite] How deep into existing action children
 *    to search.
 */
function egw_getActionManager(_id) {
  var _create = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var _search_depth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Number.MAX_VALUE;
  // Check whether the global action manager had been created, if not do so
  var res = egw_globalActionManager;
  if (egw_globalActionManager == null) {
    res = egw_globalActionManager = new EgwActionManager();
  }

  // Check whether the sub-action manager exists, if not, create it
  if (typeof _id != 'undefined' && _id != null) {
    res = egw_globalActionManager.getActionById(_id, _search_depth);
    if (res == null && _create) {
      res = egw_globalActionManager.addAction("actionManager", _id);
    }
  }
  return res;
}

/**
 * Returns the object manager for the given application - each application may
 * have its own object manager where it can place action objects or containers.
 *
 * @param _id is the name of the sub-object manager should be returned. If the
 *    object manager does not exist right now, it is created. If the parameter
 *    is ommited or null, the global object manager is returned.
 * @param {boolean} [_create=true] If an objectManager with the given id is not
 *    found, it will be created at the top level.
 * @param {number} [_search_depth=Infinite] How deep into existing action children
 *    to search.
 */
function egw_getObjectManager(_id) {
  var _create = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var _search_depth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Number.MAX_VALUE;
  // Check whether the global object manager exists
  var res = egw_globalObjectManager$1;
  if (res == null) {
    res = egw_globalObjectManager$1 = new EgwActionObjectManager("_egwGlobalObjectManager", egw_getActionManager());
  }

  // Check whether the sub-object manager exists, if not, create it
  if (typeof _id != 'undefined' && _id != null) {
    res = egw_globalObjectManager$1.getObjectById(_id, _search_depth);
    if (res == null && _create) {
      res = new EgwActionObjectManager(_id, egw_getActionManager(_id, true, _search_depth));
      egw_globalObjectManager$1.addObject(res);
    }
  }
  return res;
}

/**
 * Returns the object manager for the current application
 *
 * @param {boolean} _create
 * @param {string} _appName //appName might not always be the current app, e.g. running app content under admin tab
 * @return {EgwActionObjectManager}
 */
function egw_getAppObjectManager(_create) {
  var _appName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  return egw_getObjectManager(_appName ? _appName : window.egw(window).app_name(), _create, 1);
}

/**
 * Returns the action manager for the current application
 *
 * @param {boolean} _create
 * @return {EgwActionManager}
 */
// this function is never used
function egw_getAppActionManager(_create) {
  return egw_getActionManager(window.egw_getAppName(), _create, 1);
}

/** egwActionHandler Interface **/

/**
 * Constructor for the egwActionHandler interface which (at least) should have the
 * execute function implemented.
 *
 * @param {function} _executeEvent
 * @return {egwActionHandler}
 * TODO no usage?
 */
function egwActionHandler(_executeEvent) {
  //Copy the executeEvent parameter
  this.execute = _executeEvent;
}

/** egwAction Object
 * @deprecated use EgwAction
 * **/
class egwAction extends EgwAction {}

/** egwActionManager Object **/

/**
 * @deprecated
 */
class egwActionManager extends EgwActionManager {}

/**
 * Associative array where action classes may register themselves
 *
 */
if (typeof window._egwActionClasses == "undefined") {
  window._egwActionClasses = {
    actionManager: undefined,
    default: undefined,
    drag: undefined,
    drop: undefined,
    popup: undefined
  };
}
if (typeof window._egwActionClasses.actionManager == "undefined") {
  window._egwActionClasses.actionManager = {
    actionConstructor: EgwActionManager,
    implementation: null
  };
}
if (typeof window._egwActionClasses.default == "undefined") {
  window._egwActionClasses.default = {
    actionConstructor: EgwAction,
    implementation: null
  };
}
if (typeof window._egwActionClasses.drag == "undefined") {
  window._egwActionClasses.drag = {
    actionConstructor: EgwDragAction,
    implementation: getDragImplementation()
  };
}
if (typeof window._egwActionClasses.drop == "undefined") {
  window._egwActionClasses.drop = {
    actionConstructor: EgwDropAction,
    implementation: getDropImplementation()
  };
}
if (typeof window._egwActionClasses.popup == "undefined") {
  window._egwActionClasses.popup = {
    "actionConstructor": EgwPopupAction,
    "implementation": getPopupImplementation
  };
}

/** EgwActionImplementation Interface **/

/**
 * @deprecated implement upperCase interface EgwActionImplementation instead
 */
class egwActionImplementation {
  constructor() {
    _defineProperty$20(this, "type", void 0);
    _defineProperty$20(this, "doRegisterAction", function () {
      throw "Abstract function call: registerAction";
    });
    _defineProperty$20(this, "doUnregisterAction", function () {
      throw "Abstract function call: unregisterAction";
    });
    _defineProperty$20(this, "doExecuteImplementation", function () {
      throw "Abstract function call: executeImplementation";
    });
  }
  executeImplementation(_context, _selected, _links) {
    return this.doExecuteImplementation(_context, _selected, _links);
  }
  registerAction(_actionObjectInterface, _triggerCallback) {
    var _context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    return this.doRegisterAction(_actionObjectInterface, _triggerCallback, _context);
  }
  unregisterAction(_actionObjectInterface) {
    return this.doUnregisterAction(_actionObjectInterface);
  }
}

/** egwActionLink Object **/

/**
 * @deprecated implement upperCase class instead
 */
class egwActionLink extends EgwActionLink {}

/**
 * @deprecated implement upperCase interface EgwActionImplementation instead
 */
class egwActionObject extends EgwActionObject {}

/** egwActionObjectInterface Interface **/

/**
 * @deprecated This is just a default wrapper class for the EgwActionObjectInterface interface.
 * Please directly implement it instead!
 * ... implements EgwActionObjectInterface{
 *     getDomNode(){...}
 * }
 * instead of className{
 *     var aoi = new egwActionObjectInterface()
 *     aoi.doGetDomNode = function ...
 * }
 *
 * @return {egwActionObjectInterface}
 */
class egwActionObjectInterface {
  constructor() {
    //Preset the iface functions
    _defineProperty$20(this, "_state", EGW_AO_STATE_NORMAL || EGW_AO_STATE_VISIBLE);
    // _outerCall may be used to determine, whether the state change has been
    // evoked from the outside and the stateChangeCallback has to be called
    _defineProperty$20(this, "stateChangeCallback", null);
    // The doTriggerEvent function may be overwritten by the aoi if it wants to
    // support certain action implementation specific events like EGW_AI_DRAG_OVER
    _defineProperty$20(this, "stateChangeContext", null);
    _defineProperty$20(this, "reconnectActionsCallback", null);
    _defineProperty$20(this, "reconnectActionsContext", null);
  }
  doGetDOMNode() {
    return null;
  }
  // or not.
  doSetState(_state) {}
  // or EGW_AI_DRAG_OUT
  doTriggerEvent(_event, _data) {
    return false;
  }
  doMakeVisible() {}
  getDOMNode() {
    return this.doGetDOMNode();
  }
  getState() {
    return this._state;
  }
  makeVisible() {
    return this.doMakeVisible();
  }
  reconnectActions() {
    if (this.reconnectActionsCallback) {
      this.reconnectActionsCallback.call(this.reconnectActionsContext);
    }
  }
  setReconnectActionsCallback(_callback, _context) {
    this.reconnectActionsCallback = _callback;
    this.reconnectActionsContext = _context;
  }
  setState(_state) {
    //Call the doSetState function with the new state (if it has changed at all)
    if (_state != this._state) {
      this._state = _state;
      this.doSetState(_state);
    }
  }
  setStateChangeCallback(_callback, _context) {
    this.stateChangeCallback = _callback;
    this.stateChangeContext = _context;
  }
  triggerEvent(_event) {
    var _data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    return this.doTriggerEvent(_event, _data);
  }
  updateState(_stateBit, _set, _shiftState) {
    // Calculate the new state
    //this does not guarantee a valid state at runtime
    var newState = egwSetBit(this._state, _stateBit, _set);

    // Call the stateChangeCallback if the state really changed
    if (this.stateChangeCallback) {
      this._state = this.stateChangeCallback.call(this.stateChangeContext, newState, _stateBit, _shiftState);
    } else {
      this._state = newState;
    }
  }
}

/** egwActionObjectManager Object **/

/**
 * @deprecated implement upperCase class instead
 */
class egwActionObjectManager extends EgwActionObjectManager {}

/**
 * dragdrop
 */

/**
 * Register the drag and drop handlers
 */
if (typeof window._egwActionClasses == "undefined") window._egwActionClasses = {
  actionManager: undefined,
  default: undefined,
  drag: undefined,
  drop: undefined,
  popup: undefined
};

/**
 * @deprecated
 */
class egwDropAction extends EgwDropAction {}
window._egwActionClasses["drop"] = {
  "actionConstructor": EgwDropAction,
  "implementation": getDropImplementation
};

/**
 * @deprecated
 */
class egwDragAction extends EgwDragAction {}
(() => {
  window._egwActionClasses.drag = {
    "actionConstructor": EgwDragAction,
    "implementation": getDragImplementation
  };
})();
var _dragActionImpl = null;
function getDragImplementation() {
  if (!_dragActionImpl) {
    _dragActionImpl = new EgwDragActionImplementation();
  }
  return _dragActionImpl;
}
var _dropActionImpl = null;
function getDropImplementation() {
  if (!_dropActionImpl) {
    _dropActionImpl = new egwDropActionImplementation();
  }
  return _dropActionImpl;
}

function _defineProperty$1$(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Abstract widget class which can be inserted into the DOM. All widget classes
 * deriving from this class have to care about implementing the "getDOMNode"
 * function which has to return the DOM-Node.
 *
 * @augments et2_widget
 */
class et2_DOMWidget extends et2_widget {
  /**
   * When the DOMWidget is initialized, it grabs the DOM-Node of the parent
   * object (if available) and passes it to its own "createDOMNode" function
   *
   * @memberOf et2_DOMWidget
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_DOMWidget._attributes, _child || {}));
    _defineProperty$1$(this, "parentNode", null);
    _defineProperty$1$(this, "disabled", false);
    _defineProperty$1$(this, "_attachSet", {
      "node": null,
      "parent": null
    });
    _defineProperty$1$(this, "_actionManager", void 0);
    _defineProperty$1$(this, "width", void 0);
    _defineProperty$1$(this, "height", void 0);
    _defineProperty$1$(this, "dom_id", void 0);
    _defineProperty$1$(this, "overflow", void 0);
    _defineProperty$1$(this, "_surroundingsMgr", void 0);
    this._surroundingsMgr = null;
  }
  /**
   * Detatches the node from the DOM and clears all references to the parent
   * node or the dom node of this widget.
   */
  destroy() {
    this.detachFromDOM();
    this.parentNode = null;
    this._attachSet = {};
    if (this._actionManager) {
      var app_om = egw_getObjectManager(this.egw().getAppName(), false, 1);
      if (app_om) {
        var om = app_om.getObjectById(this.id);
        if (om) om.remove();
      }
      this._actionManager.remove();
      this._actionManager = null;
    }
    if (this._surroundingsMgr) {
      this._surroundingsMgr.destroy();
      this._surroundingsMgr = null;
    }
    super.destroy();
  }

  /**
   * Attaches the container node of this widget to the DOM-Tree
   */
  doLoadingFinished() {
    // Check whether the parent implements the et2_IDOMNode interface. If
    // yes, grab the DOM node and create our own.
    if (this.getParent() && this.getParent().implements(et2_IDOMNode)) {
      if (this.options.parent_node) {
        this.set_parent_node(this.options.parent_node);
      } else {
        this.setParentDOMNode(this.getParent().getDOMNode(this));
      }
    }
    return true;
  }

  /**
   * Detaches the widget from the DOM tree, if it had been attached to the
   * DOM-Tree using the attachToDOM method.
   */
  detachFromDOM() {
    if (this._attachSet && this._attachSet.node && this._attachSet.parent) {
      // Remove the current node from the parent node
      try {
        this._attachSet.parent.removeChild(this._attachSet.node);
      } catch (e) {
        // Don't throw a DOM error if the node wasn't in the parent
      }

      // Reset the "attachSet"
      this._attachSet = {
        "node": null,
        "parent": null
      };
      return true;
    }
    return false;
  }

  /**
   * Attaches the widget to the DOM tree. Fails if the widget is already
   * attached to the tree or no parent node or no node for this widget is
   * defined.
   */
  attachToDOM() {
    // Attach the DOM node of this widget (if existing) to the new parent
    var node = this.getDOMNode(this);
    if (node && this.parentNode && (!this._attachSet || this._attachSet && node != this._attachSet.node || this.parentNode != this._attachSet.parent)) {
      // If the surroundings manager exists, surround the DOM-Node of this
      // widget with the DOM-Nodes inside the surroundings manager.
      if (this._surroundingsMgr) {
        node = this._surroundingsMgr.getDOMNode(node);
      }

      // Append this node at its index
      var idx = this.getDOMIndex();
      if (idx < 0 || idx > this.parentNode.childNodes.length - 1) {
        this.parentNode.appendChild(node);
      } else {
        this.parentNode.insertBefore(node, this.parentNode.childNodes[idx]);
      }

      // Store the currently attached nodes
      this._attachSet = {
        "node": node,
        "parent": this.parentNode
      };
      return true;
    }
    return false;
  }

  /**
   * Inserts a child at the given index.
   *
   * @param _node is the node which should be added. It has to be an instance
   * 	of et2_widget
   * @param _idx is the position at which the element should be added.
   */
  insertChild(_node, _idx) {
    super.insertChild(_node, _idx);
    if (_node.instanceOf && _node.instanceOf(et2_DOMWidget) && typeof _node.hasOwnProperty('parentNode') && this.getDOMNode(this)) {
      try {
        _node.setParentDOMNode(this.getDOMNode(_node));
      } catch (_unused) {
        // Not ready to be added, usually due to construction order,
        // will probably try again in doLoadingFinished()
      }
    }
    // _node is actually a Web Component
    else if (_node instanceof Element) {
      if (this.getDOMNode(_node)) {
        this.getDOMNode(_node).append(_node);
      } else {
        // Warn about it.  This slows down loading, as it requires a second pass (loadingFinished) to get the child
        // properly added.
        console.warn("Legacy widget " + this.getType() + "[#" + this.options.id + "] could not handle adding a child (" + _node.getType() + (_node.id ? "#" + _node.id : "") + ")");
      }
    }
  }
  isAttached() {
    return this.parentNode != null;
  }
  getSurroundings() {
    if (!this._surroundingsMgr) {
      this._surroundingsMgr = new et2_surroundingsMgr(this);
    }
    return this._surroundingsMgr;
  }

  /**
   * Get data for the tab this widget is on.
   *
   * Will return null if the widget is not on a tab or tab data containing
   * - id
   * - label
   * - widget (top level widget)
   * - contentDiv (jQuery object for the div the tab content is in)
   *
   * @returns {Object|null} Data for tab the widget is on
   */
  get_tab_info() {
    var parent = this;
    do {
      parent = parent.getParent();
    } while (parent !== this.getRoot() && ['tabbox', 'ET2-TABBOX'].indexOf(parent.getType()) == -1);

    // No tab
    if (parent === this.getRoot()) {
      return null;
    }
    var tabbox = parent;

    // Find the tab index
    for (var i = 0; i < tabbox.tabData.length; i++) {
      var _tabbox$tabData$i$con;
      // Find the tab by DOM heritage
      // @ts-ignore
      if ((_tabbox$tabData$i$con = tabbox.tabData[i].contentDiv) !== null && _tabbox$tabData$i$con !== void 0 && _tabbox$tabData$i$con.contains(this.div[0] || this)) {
        return tabbox.tabData[i];
      }
    }
    // On a tab, but we couldn't find it by DOM nodes  Maybe tab template is
    // not loaded yet.  Try checking IDs.
    var template = this;
    do {
      template = template.getParent();
      // @ts-ignore
    } while (template !== tabbox && template.getType() !== 'template');
    for (var i = tabbox.tabData.length - 1; i >= 0; i--) {
      if (template && template.id && template.id === tabbox.tabData[i].id) {
        return tabbox.tabData[i];
      }
    }
    // Fallback
    var fallback = this.getParent();
    if (typeof fallback.get_tab_info === 'function') {
      return fallback.get_tab_info();
    }
    return null;
  }

  /**
   * Set the parent DOM node of this element.  Takes a wider variety of types
   * than setParentDOMNode(), and matches the set_<attribute> naming convention.
   *
   * @param _node String|DOMNode DOM node to contain the widget, or the ID of the DOM node.
   */
  set_parent_node(_node) {
    if (typeof _node == "string") {
      var parent = jQuery('#' + _node);
      if (parent.length === 0 && window.parent) {
        // Could not find it, try again with wider context
        // (in case there's an iframe in admin, for example)
        parent = jQuery('#' + _node, window.parent.document);
      }
      if (parent.length === 0) {
        this.egw().debug('warn', 'Unable to find DOM parent node with ID "%s" for widget %o.', _node, this);
      } else {
        this.setParentDOMNode(parent.get(0));
      }
    } else {
      this.setParentDOMNode(_node);
    }
  }

  /**
   * Set the parent DOM node of this element. If another parent node is already
   * set, this widget removes itself from the DOM tree
   *
   * @param _node
   */
  setParentDOMNode(_node) {
    if (_node != this.parentNode) {
      // Detatch this element from the DOM tree
      this.detachFromDOM();
      this.parentNode = _node;

      // And attatch the element to the DOM tree
      this.attachToDOM();
    }
  }

  /**
   * Returns the parent node.
   */
  getParentDOMNode() {
    return this.parentNode;
  }

  /**
   * Returns the index of this element in the DOM tree
   */
  getDOMIndex() {
    if (this.getParent()) {
      var idx = 0;
      var children = this.getParent().getChildren();
      if (children && children.indexOf) return children.indexOf(this);
      egw$1.debug('warn', 'No Array.indexOf(), falling back to looping. ');
      for (var i = 0; i < children.length; i++) {
        if (children[i] == this) {
          return idx;
        } else if (children[i].isInTree()) {
          idx++;
        }
      }
    }
    return -1;
  }

  /**
   * Sets the id of the DOM-Node.
   *
   * DOM id's have dots "." replaced with dashes "-"
   *
   * @param {string} _value id to set
   */
  set_id(_value) {
    this.id = _value;
    this.dom_id = _value ? this.getInstanceManager().uniqueId + '_' + _value.replace(/\./g, '-') : _value;
    var node = this.getDOMNode(this);
    if (node) {
      if (_value != "") {
        node.setAttribute("id", this.dom_id);
      } else {
        node.removeAttribute("id");
      }
    }
  }
  set_disabled(_value) {
    var node = this._surroundingsMgr != null ? this._surroundingsMgr.getDOMNode(this.getDOMNode(this)) : this.getDOMNode(this);
    if (node && this.disabled != _value) {
      this.disabled = _value;
      if (_value) {
        jQuery(node).hide();
      } else {
        jQuery(node).show();
      }
    }
  }
  set_width(_value) {
    this.width = _value;
    var node = this.getDOMNode(this);
    if (node) {
      jQuery(node).css("width", _value);
    }
  }
  set_height(_value) {
    this.height = _value;
    var node = this.getDOMNode(this);
    if (node) {
      jQuery(node).css("height", _value);
    }
  }
  set_class(_value) {
    var node = this.getDOMNode(this);
    if (node) {
      if (this["class"]) {
        jQuery(node).removeClass(this["class"]);
      }
      jQuery(node).addClass(_value);
    }
    this["class"] = _value;
  }
  set_overflow(_value) {
    this.overflow = _value;
    var node = this.getDOMNode(this);
    if (node) {
      jQuery(node).css("overflow", _value);
    }
  }
  set_data(_value) {
    var node = this.getDOMNode(this);
    if (node && _value) {
      var pairs = _value.split(/,/g);
      for (var i = 0; i < pairs.length; ++i) {
        var name_value = pairs[i].split(':');
        jQuery(node).attr('data-' + name_value[0], name_value[1]);
      }
    }
  }
  set_background(_value) {
    var node = this.getDOMNode(this);
    var values = '';
    if (_value && node) {
      values = _value.split(',');
      jQuery(node).css({
        "background-image": 'url("' + values[0] + '")',
        "background-position-x": values[1],
        "background-position-y": values[2],
        "background-scale": values[3]
      });
    }
  }

  /**
   * Set Actions on the widget
   *
   * Each action is defined as an object:
   *
   * move: {
   *      type: "drop",
   *      acceptedTypes: "mail",
   *      icon:   "move",
   *      caption:	"Move to"
   *      onExecute:      javascript:mail_move"
   * }
   *
   * This will turn the widget into a drop target for "mail" drag types.  When "mail" drag types are dropped,
   * the global function mail_move(egwAction action, egwActionObject sender) will be called.  The ID of the
   * dragged "mail" will be in sender.id, some information about the sender will be in sender.context.  The
   * etemplate2 widget involved can typically be found in action.parent.data.widget, so your handler
   * can operate in the widget context easily.  The location varies depending on your action though.  It
   * might be action.parent.parent.data.widget
   *
   * To customise how the actions are handled for a particular widget, override _link_actions().  It handles
   * the more widget-specific parts.
   *
   * @param {object} actions {ID: {attributes..}+} map of egw action information
   * @see api/src/Etemplate/Widget/Nextmatch.php egw_actions() method
   */
  set_actions(actions) {
    if (this.id == "" || typeof this.id == "undefined") {
      this.egw().debug("warn", "Widget should have an ID if you want actions", this);
      return;
    }

    // Initialize the action manager and add some actions to it
    // Only look 1 level deep
    var gam = egw_getActionManager(this.egw().appName, true, 1);
    if (typeof this._actionManager != "object") {
      if (gam.getActionById(this.getInstanceManager().uniqueId, 1) !== null) {
        gam = gam.getActionById(this.getInstanceManager().uniqueId, 1);
      }
      if (gam.getActionById(this.id, 1) != null) {
        this._actionManager = gam.getActionById(this.id, 1);
      } else {
        this._actionManager = gam.addAction("actionManager", this.id);
      }
    }
    this._actionManager.updateActions(actions, this.egw().appName);
    if (this.options.default_execute) this._actionManager.setDefaultExecute(this.options.default_execute);

    // Put a reference to the widget into the action stuff, so we can
    // easily get back to widget context from the action handler
    this._actionManager.data = {
      widget: this
    };

    // Link the actions to the DOM
    this._link_actions(actions);
  }
  set_default_execute(_default_execute) {
    this.options.default_execute = _default_execute;
    if (this._actionManager) this._actionManager.setDefaultExecute(null, _default_execute);
  }

  /**
   * Get all action-links / id's of 1.-level actions from a given action object
   *
   * This can be overwritten to not allow all actions, by not returning them here.
   *
   * @param actions
   * @returns {Array}
   */
  _get_action_links(actions) {
    var action_links = [];
    for (var i in actions) {
      var action = actions[i];
      action_links.push(typeof action.id != 'undefined' ? action.id : i);
    }
    return action_links;
  }

  /**
   * Link the actions to the DOM nodes / widget bits.
   *
   * @param {object} actions {ID: {attributes..}+} map of egw action information
   */
  _link_actions(actions) {
    // Get the top level element for the tree
    var objectManager = egw_getAppObjectManager(true);
    var widget_object = objectManager.getObjectById(this.id);
    if (widget_object == null) {
      // Add a new container to the object manager which will hold the widget
      // objects
      widget_object = objectManager.insertObject(false, new egwActionObject(this.id, objectManager, new et2_action_object_impl(this).getAOI(), this._actionManager || objectManager.manager.getActionById(this.id) || objectManager.manager));
    } else {
      widget_object.setAOI(new et2_action_object_impl(this, this.getDOMNode()).getAOI());
    }

    // Delete all old objects
    widget_object.clear();
    widget_object.unregisterActions();

    // Go over the widget & add links - this is where we decide which actions are
    // 'allowed' for this widget at this time
    var action_links = this._get_action_links(actions);
    widget_object.updateActionLinks(action_links);
  }
}

/**
 * The surroundings manager class allows to append or prepend elements around
 * an widget node.
 */
_defineProperty$1$(et2_DOMWidget, "_attributes", {
  "disabled": {
    "name": "Disabled",
    "type": "boolean",
    "description": "Defines whether this widget is visible.  Not to be confused with an input widget's HTML attribute 'disabled'.",
    "default": false
  },
  "width": {
    "name": "Width",
    "type": "dimension",
    "default": et2_no_init,
    "description": "Width of the element in pixels, percentage or 'auto'"
  },
  "height": {
    "name": "Height",
    "type": "dimension",
    "default": et2_no_init,
    "description": "Height of the element in pixels, percentage or 'auto'"
  },
  "class": {
    "name": "CSS Class",
    "type": "string",
    "default": et2_no_init,
    "description": "CSS Class which is applied to the dom element of this node"
  },
  "overflow": {
    "name": "Overflow",
    "type": "string",
    "default": et2_no_init,
    "description": "If set, the css-overflow attribute is set to that value"
  },
  "parent_node": {
    "name": "DOM parent",
    "type": "string",
    "default": et2_no_init,
    "description": "Insert into the target DOM node instead of the normal location"
  },
  "actions": {
    "name": "Actions list",
    "type": "any",
    "default": et2_no_init,
    "description": "List of egw actions that can be done on the widget.  This includes context menu, drag and drop.  TODO: Link to action documentation"
  },
  default_execute: {
    name: "Default onExecute for actions",
    type: "js",
    default: et2_no_init,
    description: "Set default onExecute javascript method for action not specifying their own"
  },
  resize_ratio: {
    name: "Resize height of the widget on callback resize",
    type: "string",
    default: '',
    description: "Allow Resize height of the widget based on exess height and given ratio"
  },
  data: {
    name: "comma-separated name:value pairs set as data attributes on DOM node",
    type: "string",
    default: '',
    description: 'data="mime:${row}[mime]" would generate data-mime="..." in DOM, eg. to use it in CSS on a parent'
  },
  background: {
    name: "Add background image",
    type: "string",
    default: '',
    description: "Sets background image, left, right and scale on DOM"
  }
});
class et2_surroundingsMgr extends ClassWithAttributes {
  /**
   * Constructor
   *
   * @memberOf et2_surroundingsMgr
   * @param _widget
   */
  constructor(_widget) {
    super();
    _defineProperty$1$(this, "widget", void 0);
    _defineProperty$1$(this, "_widgetContainer", null);
    _defineProperty$1$(this, "_widgetSurroundings", []);
    _defineProperty$1$(this, "_widgetPlaceholder", null);
    _defineProperty$1$(this, "_widgetNode", null);
    _defineProperty$1$(this, "_ownPlaceholder", true);
    _defineProperty$1$(this, "_surroundingsUpdated", false);
    this.widget = _widget;
  }
  destroy() {
    this._widgetContainer = null;
    this._widgetSurroundings = null;
    this._widgetPlaceholder = null;
    this._widgetNode = null;
  }
  prependDOMNode(_node) {
    this._widgetSurroundings.unshift(_node);
    this._surroundingsUpdated = true;
  }
  appendDOMNode(_node) {
    // Append an placeholder first if none is existing yet
    if (this._ownPlaceholder && this._widgetPlaceholder == null) {
      this._widgetPlaceholder = document.createElement("span");
      this._widgetSurroundings.push(this._widgetPlaceholder);
    }

    // Append the given node
    this._widgetSurroundings.push(_node);
    this._surroundingsUpdated = true;
  }
  insertDOMNode(_node) {
    if (!this._ownPlaceholder || this._widgetPlaceholder == null) {
      this.appendDOMNode(_node);
      return;
    }

    // Get the index of the widget placeholder and delete it, insert the
    // given node instead
    var idx = this._widgetSurroundings.indexOf(this._widgetPlaceholder);
    this._widgetSurroundings.splice(idx, 1, _node);

    // Delete the reference to the own placeholder
    this._widgetPlaceholder = null;
    this._ownPlaceholder = false;
  }
  removeDOMNode(_node) {
    for (var i = 0; this._widgetSurroundings && i < this._widgetSurroundings.length; i++) {
      if (this._widgetSurroundings[i] == _node) {
        this._widgetSurroundings.splice(i, 1);
        this._surroundingsUpdated = true;
        break;
      }
    }
  }
  setWidgetPlaceholder(_node) {
    if (_node != this._widgetPlaceholder) {
      if (_node != null && this._ownPlaceholder && this._widgetPlaceholder != null) {
        // Delete the current placeholder which was created by the
        // widget itself
        var idx = this._widgetSurroundings.indexOf(this._widgetPlaceholder);
        this._widgetSurroundings.splice(idx, 1);

        // Delete any reference to the own placeholder and set the
        // _ownPlaceholder flag to false
        this._widgetPlaceholder = null;
        this._ownPlaceholder = false;
      }
      this._ownPlaceholder = _node == null;
      this._widgetPlaceholder = _node;
      this._surroundingsUpdated = true;
    }
  }
  _rebuildContainer() {
    // Return if there has been no change in the "surroundings-data"
    if (!this._surroundingsUpdated) {
      return false;
    }

    // Build the widget container
    if (this._widgetSurroundings.length > 0) {
      // Check whether the widgetPlaceholder is really inside the DOM-Tree
      var hasPlaceholder = et2_hasChild(this._widgetSurroundings, this._widgetPlaceholder);

      // If not, append another widget placeholder
      if (!hasPlaceholder) {
        this._widgetPlaceholder = document.createElement("span");
        this._widgetSurroundings.push(this._widgetPlaceholder);
        this._ownPlaceholder = true;
      }

      // If the surroundings array only contains one element, set this one
      // as the widget container
      if (this._widgetSurroundings.length == 1) {
        if (this._widgetSurroundings[0] == this._widgetPlaceholder) {
          this._widgetContainer = null;
        } else {
          this._widgetContainer = this._widgetSurroundings[0];
        }
      } else {
        // Create an outer "span" as widgetContainer
        this._widgetContainer = document.createElement("span");

        // Append the children inside the widgetSurroundings array to
        // the widget container
        for (var i = 0; i < this._widgetSurroundings.length; i++) {
          this._widgetContainer.appendChild(this._widgetSurroundings[i]);
        }
      }
    } else {
      this._widgetContainer = null;
      this._widgetPlaceholder = null;
    }
    this._surroundingsUpdated = false;
    return true;
  }
  update() {
    if (this._surroundingsUpdated) {
      var attached = this.widget ? this.widget.isAttached() : false;

      // Reattach the widget - this will call the "getDOMNode" function
      // and trigger the _rebuildContainer function.
      if (attached && this.widget) {
        this.widget.detachFromDOM();
        this.widget.attachToDOM();
      }
    }
  }
  getDOMNode(_widgetNode) {
    // Update the whole widgetContainer if this is not the first time this
    // function has been called but the widget node has changed.
    if (this._widgetNode != null && this._widgetNode != _widgetNode) {
      this._surroundingsUpdated = true;
    }

    // Copy a reference to the given node
    this._widgetNode = _widgetNode;

    // Build the container if it didn't exist yet.
    var updated = this._rebuildContainer();

    // Return the widget node itself if there are no surroundings arround
    // it
    if (this._widgetContainer == null) {
      return _widgetNode;
    }

    // Replace the widgetPlaceholder with the given widget node if the
    // widgetContainer has been updated
    if (updated) {
      this._widgetPlaceholder.parentNode.replaceChild(_widgetNode, this._widgetPlaceholder);
      if (!this._ownPlaceholder) {
        this._widgetPlaceholder = _widgetNode;
      }
    }

    // Return the widget container
    return this._widgetContainer;
  }
  getWidgetSurroundings() {
    return this._widgetSurroundings;
  }
}

/**
 * The egw_action system requires an egwActionObjectInterface Interface implementation
 * to tie actions to DOM nodes.  This one can be used by any widget.
 *
 * The class extension is different than the widgets
 *
 * @param {et2_DOMWidget} widget
 * @param {Object} node
 *
 */
class et2_action_object_impl {
  constructor(_widget, _node) {
    _defineProperty$1$(this, "aoi", void 0);
    var widget = _widget;
    var objectNode = _node;
    this.aoi = new egwActionObjectInterface();
    this.aoi.getWidget = function () {
      return widget;
    };
    this.aoi.doGetDOMNode = function () {
      return objectNode ? objectNode : widget.getDOMNode();
    };

    // _outerCall may be used to determine, whether the state change has been
    // evoked from the outside and the stateChangeCallback has to be called
    // or not.
    this.aoi.doSetState = function (_state, _outerCall) {};

    // The doTiggerEvent function may be overritten by the aoi if it wants to
    // support certain action implementation specific events like EGW_AI_DRAG_OVER
    // or EGW_AI_DRAG_OUT
    this.aoi.doTriggerEvent = function (_event, _data) {
      switch (_event) {
        case EGW_AI_DRAG_OVER:
          jQuery(this.node).addClass("ui-state-active");
          break;
        case EGW_AI_DRAG_OUT:
          jQuery(this.node).removeClass("ui-state-active");
          break;
      }
    };
  }
  getAOI() {
    return this.aoi;
  }
}

function _defineProperty$1_(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which manages the DOM node itself. The simpleWidget class is derrived
 * from et2_DOMWidget and implements the getDOMNode function. A setDOMNode
 * function is provided, which attatches the given node to the DOM if possible.
 *
 * @augments et2_DOMWidget
 */
class et2_baseWidget extends et2_DOMWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_baseWidget._attributes, _child || {}));
    _defineProperty$1_(this, "align", 'left');
    _defineProperty$1_(this, "node", null);
    _defineProperty$1_(this, "statustext", '');
    _defineProperty$1_(this, "_messageDiv", null);
    _defineProperty$1_(this, "_tooltipElem", null);
    _defineProperty$1_(this, "onclick", void 0);
  }
  destroy() {
    super.destroy();
    this.node = null;
    this._messageDiv = null;
  }

  /**
   * The setMessage function can be used to attach a small message box to the
   * widget. This is e.g. used to display validation errors or success messages
   *
   * @param _text is the text which should be displayed as a message
   * @param _type is an css class which is attached to the message box.
   * 	Currently available are "hint", "success" and "validation_error", defaults
   * 	to "hint"
   * @param _floating if true, the object will be in one row with the element,
   * 	defaults to true
   * @param _prepend if set, the message is displayed behind the widget node
   * 	instead of before. Defaults to false.
   */
  showMessage(_text, _type, _floating, _prepend) {
    // Preset the parameters
    if (typeof _type == "undefined") {
      _type = "hint";
    }
    if (typeof _floating == "undefined") {
      _floating = true;
    }
    if (typeof _prepend == "undefined") {
      _prepend = false;
    }
    var surr = this.getSurroundings();

    // Remove the message div from the surroundings before creating a new
    // one
    this.hideMessage(false, true);

    // Create the message div and add it to the "surroundings" manager
    this._messageDiv = jQuery(document.createElement("div")).addClass("message").addClass(_type).addClass(_floating ? "floating" : "").text(_text.valueOf() + "");

    // Decide whether to prepend or append the div
    if (_prepend) {
      surr.prependDOMNode(this._messageDiv[0]);
    } else {
      surr.appendDOMNode(this._messageDiv[0]);
    }
    surr.update();
  }

  /**
   * The hideMessage function can be used to hide a previously shown message.
   *
   * @param _fade if true, the message div will fade out, otherwise the message
   * 	div is removed immediately. Defaults to true.
   * @param _noUpdate is used internally to prevent an update of the surroundings
   * 	manager.
   */
  hideMessage(_fade, _noUpdate) {
    if (typeof _fade == "undefined") {
      _fade = true;
    }
    if (typeof _noUpdate == "undefined") {
      _noUpdate = false;
    }

    // Remove the message from the surroundings manager and remove the
    // reference to it
    if (this._messageDiv != null) {
      var surr = this.getSurroundings();
      var self = this;
      var messageDiv = this._messageDiv;
      self._messageDiv = null;
      var _done = function _done() {
        surr.removeDOMNode(messageDiv[0]);

        // Update the surroundings manager
        if (!_noUpdate) {
          surr.update();
        }
      };

      // Either fade out or directly call the function which removes the div
      if (_fade) {
        messageDiv.fadeOut("fast", _done);
      } else {
        _done();
      }
    }
  }
  detachFromDOM() {
    // Detach this node from the tooltip node
    if (this._tooltipElem) {
      this.egw().tooltipUnbind(this._tooltipElem);
      this._tooltipElem = null;
    }

    // Remove the binding to the click handler
    if (this.node) {
      jQuery(this.node).unbind("click.et2_baseWidget");
    }
    return super.detachFromDOM();
  }
  attachToDOM() {
    var ret = super.attachToDOM();

    // Add the binding for the click handler
    if (this.node) {
      jQuery(this.node).bind("click.et2_baseWidget", this, function (e) {
        return e.data.click.call(e.data, e, this);
      });
      if (typeof this.onclick == 'function') jQuery(this.node).addClass('et2_clickable');
    }

    // Update the statustext
    this.set_statustext(this.statustext);
    return ret;
  }
  setDOMNode(_node) {
    if (_node != this.node) {
      // Deatch the old node from the DOM
      this.detachFromDOM();

      // Set the new DOM-Node
      this.node = _node;

      // Attatch the DOM-Node to the tree
      return this.attachToDOM();
    }
    return false;
  }
  getDOMNode(_sender) {
    return this.node;
  }
  getTooltipElement() {
    return this.getDOMNode(this);
  }

  /**
   * Click handler calling custom handler set via onclick attribute to this.onclick
   *
   * @param _ev
   * @returns
   */
  click(_ev) {
    if (typeof this.onclick == 'function') {
      // Make sure function gets a reference to the widget, splice it in as 2. argument if not
      var args = Array.prototype.slice.call(arguments);
      if (args.indexOf(this) == -1) args.splice(1, 0, this);
      return this.onclick.apply(this, args);
    }
    return true;
  }
  set_statustext(_value) {
    // Tooltip should not be shown in mobile view
    if (egwIsMobile$1()) return;
    // Don't execute the code below, if no tooltip will be attached/detached
    if (_value == "" && !this._tooltipElem) {
      return;
    }
    this.statustext = _value;

    //Get the domnode the tooltip should be attached to
    var elem = jQuery(this.getTooltipElement());
    if (elem) {
      // Make readable by screenreader
      elem.attr("aria-description", this.statustext);

      //If a tooltip is already attached to the element, remove it first
      if (this._tooltipElem) {
        this.egw().tooltipUnbind(this._tooltipElem);
        this._tooltipElem = null;
      }
      if (_value && _value != '') {
        this.egw().tooltipBind(elem, _value, this.options.statustext_html);
        this._tooltipElem = elem;
      }
    }
  }
  set_align(_value) {
    this.align = _value;
  }
  get_align() {
    return this.align;
  }
}

/**
 * Simple container object
 *
 * There is no tag to put this in a template.  By convention we only make one of these per etemplate,
 * and it's the top level object.
 */
_defineProperty$1_(et2_baseWidget, "_attributes", {
  "statustext": {
    "name": "Tooltip",
    "type": "string",
    "description": "Tooltip which is shown for this element",
    "translate": true
  },
  "statustext_html": {
    "name": "Tooltip is html",
    "type": "boolean",
    "description": "Flag to allow html content in tooltip",
    "default": false
  },
  "align": {
    "name": "Align",
    "type": "string",
    "default": "left",
    "description": "Position of this element in the parent hbox"
  },
  "onclick": {
    "name": "onclick",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code which is executed when the element is clicked."
  }
});
class et2_container extends et2_baseWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_container._attributes, _child || {}));
    this.setDOMNode(document.createElement("div"));
  }

  /**
   * The destroy function destroys all children of the widget, removes itself
   * from the parents children list.
   * Overriden to not try to remove self from parent, as that's not possible.
   */
  destroy() {
    // Call the destructor of all children
    for (var i = this._children.length - 1; i >= 0; i--) {
      this._children[i].destroy();
    }

    // Free the array managers if they belong to this widget
    for (var key in this._mgrs) {
      if (this._mgrs[key] && this._mgrs[key].owner == this) {
        this._mgrs[key].destroy();
      }
    }
  }

  /**
   * Searches for a DOM widget by id in the tree, descending into the child levels.
   *
   * @param _id is the id you're searching for
   */
  getDOMWidgetById(_id) {
    var widget = this.getWidgetById(_id);
    if (widget && (widget instanceof HTMLElement || widget.instanceOf(et2_DOMWidget))) {
      return widget;
    }
    return null;
  }

  /**
   * Searches for a Value widget by id in the tree, descending into the child levels.
   *
   * @param _id is the id you're searching for
   */
  getInputWidgetById(_id) {
    var widget = this.getWidgetById(_id);
    // instead of checking widget to be instance of valueWidget (which would create a circular dependency)
    // we check for the interface/methods of valueWidget
    if (widget && typeof widget.get_value === 'function' && typeof widget.set_value === 'function') {
      return widget;
    }
    return null;
  }

  /**
   * Set the value for a child widget, specified by the given ID
   *
   * @param id  string The ID you're searching for
   * @param value Value for the widget
   *
   * @return Returns the result of widget's set_value(), though this is usually undefined
   *
   * @throws Error If the widget cannot be found or it does not have a set_value() function
   */
  setValueById(id, value) {
    var widget = this.getWidgetById(id);
    if (!widget) throw 'Could not find widget ' + id;

    // Don't care about what class it is, just that it has the function
    // @ts-ignore
    if (typeof widget.set_value !== 'function') {
      throw 'Widget ' + id + ' does not have a set_value() function';
    }

    // @ts-ignore
    return widget.set_value(value);
  }

  /**
   * Get the current value of a child widget, specified by the given ID
   *
   * This is the current value of the widget, which may be different from the original value given in content
   *
   * @param id  string The ID you're searching for
   * @throws Error If the widget cannot be found or it does not have a set_value() function
   */
  getValueById(id) {
    var widget = this.getWidgetById(id);
    if (!widget) throw 'Could not find widget ' + id;

    // Don't care about what class it is, just that it has the function
    // @ts-ignore
    if (typeof widget.get_value !== 'function' && typeof widget.value == "undefined") {
      throw 'Widget ' + id + ' does not have a get_value() function';
    }

    // @ts-ignore
    return typeof widget.get_value == "function" ? widget.get_value() : widget.value;
  }

  /**
   * Set the value for a child widget, specified by the given ID
   *
   * @param id  string The ID you're searching for
   * @throws Error If the widget cannot be found or it does not have a set_value() function
   */
  setDisabledById(id, value) {
    var widget = this.getWidgetById(id);
    if (!widget) throw 'Could not find widget ' + id;

    // Don't care about what class it is, just that it has the function
    // @ts-ignore
    if (typeof widget.set_disabled !== 'function') {
      throw 'Widget ' + id + ' does not have a set_disabled() function';
    }

    // @ts-ignore
    return widget.set_disabled(value);
  }
}
// Register widget for attributes, but not for any xml tags
et2_register_widget(et2_container, []);

/**
 * Container object for not-yet supported widgets
 *
 * @augments et2_baseWidget
 */
class et2_placeholder extends et2_baseWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_placeholder._attributes, _child || {}));
    /**
     *  he attrNodes object will hold the DOM nodes which represent the
     * values of this object
     */
    _defineProperty$1_(this, "attrNodes", void 0);
    _defineProperty$1_(this, "visible", false);
    _defineProperty$1_(this, "placeDiv", void 0);
    this.attrNodes = {};

    // Create the placeholder div
    this.placeDiv = jQuery(document.createElement("span")).addClass("et2_placeholder");
    var headerNode = jQuery(document.createElement("span")).text(this.getType() || "").addClass("et2_caption").appendTo(this.placeDiv);
    var attrsCntr = jQuery(document.createElement("span")).appendTo(this.placeDiv).hide();
    headerNode.click(this, function (e) {
      e.data.visible = !e.data.visible;
      if (e.data.visible) {
        attrsCntr.show();
      } else {
        attrsCntr.hide();
      }
    });
    for (var key in this.options) {
      if (typeof this.options[key] != "undefined") {
        if (typeof this.attrNodes[key] == "undefined") {
          this.attrNodes[key] = jQuery(document.createElement("span")).addClass("et2_attr");
          attrsCntr.append(this.attrNodes[key]);
        }
        this.attrNodes[key].text(key + "=" + this.options[key]);
      }
    }
    this.setDOMNode(this.placeDiv[0]);
  }
  getDetachedAttributes(_attrs) {
    _attrs.push("value");
  }
  getDetachedNodes() {
    return [this.placeDiv[0]];
  }
  setDetachedAttributes(_nodes, _values) {
    this.placeDiv = jQuery(_nodes[0]);
  }
}
// Register widget, but no tags
et2_register_widget(et2_placeholder, ['placeholder', 'placeholder_ro']);

var es_string_search = {};

// `SameValue` abstract operation
// https://tc39.es/ecma262/#sec-samevalue
// eslint-disable-next-line es/no-object-is -- safe
var sameValue$1 = Object.is || function is(x, y) {
  // eslint-disable-next-line no-self-compare -- NaN check
  return x === y ? x !== 0 || 1 / x === 1 / y : x != x && y != y;
};

'use strict';
var call$4 = functionCall;
var fixRegExpWellKnownSymbolLogic = fixRegexpWellKnownSymbolLogic;
var anObject$1 = anObject$a;
var isNullOrUndefined$1 = isNullOrUndefined$6;
var requireObjectCoercible$2 = requireObjectCoercible$6;
var sameValue = sameValue$1;
var toString$3 = toString$a;
var getMethod$1 = getMethod$6;
var regExpExec = regexpExecAbstract;

// @@search logic
fixRegExpWellKnownSymbolLogic('search', function (SEARCH, nativeSearch, maybeCallNative) {
  return [
    // `String.prototype.search` method
    // https://tc39.es/ecma262/#sec-string.prototype.search
    function search(regexp) {
      var O = requireObjectCoercible$2(this);
      var searcher = isNullOrUndefined$1(regexp) ? undefined : getMethod$1(regexp, SEARCH);
      return searcher ? call$4(searcher, regexp, O) : new RegExp(regexp)[SEARCH](toString$3(O));
    },
    // `RegExp.prototype[@@search]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@search
    function (string) {
      var rx = anObject$1(this);
      var S = toString$3(string);
      var res = maybeCallNative(nativeSearch, rx, S);

      if (res.done) return res.value;

      var previousLastIndex = rx.lastIndex;
      if (!sameValue(previousLastIndex, 0)) rx.lastIndex = 0;
      var result = regExpExec(rx, S);
      if (!sameValue(rx.lastIndex, previousLastIndex)) rx.lastIndex = previousLastIndex;
      return result === null ? -1 : result.index;
    }
  ];
});

var esnext_promise_allSettled = {};

var es_promise_allSettled = {};

'use strict';
var $$b = _export;
var call$3 = functionCall;
var aCallable$1 = aCallable$a;
var newPromiseCapabilityModule = newPromiseCapability$2;
var perform = perform$4;
var iterate$1 = iterate$4;
var PROMISE_STATICS_INCORRECT_ITERATION = promiseStaticsIncorrectIteration;

// `Promise.allSettled` method
// https://tc39.es/ecma262/#sec-promise.allsettled
$$b({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION }, {
  allSettled: function allSettled(iterable) {
    var C = this;
    var capability = newPromiseCapabilityModule.f(C);
    var resolve = capability.resolve;
    var reject = capability.reject;
    var result = perform(function () {
      var promiseResolve = aCallable$1(C.resolve);
      var values = [];
      var counter = 0;
      var remaining = 1;
      iterate$1(iterable, function (promise) {
        var index = counter++;
        var alreadyCalled = false;
        remaining++;
        call$3(promiseResolve, C, promise).then(function (value) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[index] = { status: 'fulfilled', value: value };
          --remaining || resolve(values);
        }, function (error) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[index] = { status: 'rejected', reason: error };
          --remaining || resolve(values);
        });
      });
      --remaining || resolve(values);
    });
    if (result.error) reject(result.value);
    return capability.promise;
  }
});

var es_promise_finally = {};

'use strict';
var $$a = _export;
var IS_PURE$3 = isPure;
var NativePromiseConstructor = promiseNativeConstructor;
var fails$1 = fails$e;
var getBuiltIn = getBuiltIn$5;
var isCallable$2 = isCallable$f;
var speciesConstructor = speciesConstructor$3;
var promiseResolve = promiseResolve$2;
var defineBuiltIn$2 = defineBuiltIn$8;

var NativePromisePrototype = NativePromiseConstructor && NativePromiseConstructor.prototype;

// Safari bug https://bugs.webkit.org/show_bug.cgi?id=200829
var NON_GENERIC = !!NativePromiseConstructor && fails$1(function () {
  // eslint-disable-next-line unicorn/no-thenable -- required for testing
  NativePromisePrototype['finally'].call({ then: function () { /* empty */ } }, function () { /* empty */ });
});

// `Promise.prototype.finally` method
// https://tc39.es/ecma262/#sec-promise.prototype.finally
$$a({ target: 'Promise', proto: true, real: true, forced: NON_GENERIC }, {
  'finally': function (onFinally) {
    var C = speciesConstructor(this, getBuiltIn('Promise'));
    var isFunction = isCallable$2(onFinally);
    return this.then(
      isFunction ? function (x) {
        return promiseResolve(C, onFinally()).then(function () { return x; });
      } : onFinally,
      isFunction ? function (e) {
        return promiseResolve(C, onFinally()).then(function () { throw e; });
      } : onFinally
    );
  }
});

// makes sure that native promise-based APIs `Promise#finally` properly works with patched `Promise#then`
if (!IS_PURE$3 && isCallable$2(NativePromiseConstructor)) {
  var method = getBuiltIn('Promise').prototype['finally'];
  if (NativePromisePrototype['finally'] !== method) {
    defineBuiltIn$2(NativePromisePrototype, 'finally', method, { unsafe: true });
  }
}

function _defineProperty$1Z(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * et2_valueWidget is the base class for et2_inputWidget - valueWidget introduces
 * the "value" attribute and automatically loads it from the "content" array
 * after loading from XML.
 */
class et2_valueWidget extends et2_baseWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_valueWidget._attributes, _child || {}));
    _defineProperty$1Z(this, "label", '');
    _defineProperty$1Z(this, "value", void 0);
    _defineProperty$1Z(this, "_labelContainer", null);
  }

  /**
   *
   * @param _attrs
   */
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
    if (this.id) {
      // Set the value for this element
      var contentMgr = this.getArrayMgr("content");
      if (contentMgr != null) {
        var val = contentMgr.getEntry(this.id, false, true);
        if (val !== null) {
          _attrs["value"] = val;
        }
      }
      // Check for already inside namespace
      if (this._createNamespace() && this.getArrayMgr("content").perspectiveData.owner == this) {
        _attrs["value"] = this.getArrayMgr("content").data;
      }
    }
  }
  set_label(_value) {
    // Abort if there was no change in the label
    if (_value == this.label) {
      return;
    }
    if (_value) {
      // Create the label container if it didn't exist yet
      if (this._labelContainer == null) {
        this._labelContainer = jQuery(document.createElement("label")).addClass("et2_label");
        this.getSurroundings().insertDOMNode(this._labelContainer[0]);
      }

      // Clear the label container.
      this._labelContainer.empty();

      // Create the placeholder element and set it
      var ph = document.createElement("span");
      this.getSurroundings().setWidgetPlaceholder(ph);

      // Split the label at the "%s"
      var parts = et2_csvSplit(_value, 2, "%s");

      // Update the content of the label container
      for (var i = 0; i < parts.length; i++) {
        if (parts[i]) {
          this._labelContainer.append(document.createTextNode(parts[i]));
        }
        if (i == 0) {
          this._labelContainer.append(ph);
        }
      }

      // add class if label is empty
      this._labelContainer.toggleClass('et2_label_empty', !_value || !parts[0]);
    } else {
      // Delete the labelContainer from the surroundings object
      if (this._labelContainer) {
        this.getSurroundings().removeDOMNode(this._labelContainer[0]);
      }
      this._labelContainer = null;
    }

    // Update the surroundings in order to reflect the change in the label
    this.getSurroundings().update();

    // Copy the given value
    this.label = _value;
  }
  get_value() {
    return this.value;
  }

  /**
   * Set value of widget
   *
   * @param {string} _value value to set
   */
  set_value(_value) {
    this.value = _value;
  }
}
_defineProperty$1Z(et2_valueWidget, "_attributes", {
  "label": {
    "name": "Label",
    "default": "",
    "type": "string",
    "description": "The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",
    "translate": true
  },
  "value": {
    "name": "Value",
    "description": "The value of the widget",
    "type": "rawstring",
    // no html-entity decoding
    "default": et2_no_init
  }
});

function _defineProperty$1Y(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
// fixing circular dependencies by only importing the type (not in compiled .js)

/**
 * et2_inputWidget derrives from et2_simpleWidget and implements the IInput
 * interface. When derriving from this class, call setDOMNode with an input
 * DOMNode.
 */
class et2_inputWidget extends et2_valueWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_inputWidget._attributes, _child || {}));

    // mark value as not initialised, so set_value can determine if it is necessary to trigger change event
    _defineProperty$1Y(this, "_oldValue", void 0);
    _defineProperty$1Y(this, "onchange", void 0);
    this._oldValue = et2_no_init;
    this._labelContainer = null;
  }
  destroy() {
    var node = this.getInputNode();
    if (node) {
      jQuery(node).unbind("change.et2_inputWidget");
      jQuery(node).unbind("focus");
    }
    super.destroy();
    this._labelContainer = null;
  }

  /**
   * Make sure dirty flag is properly set
   */
  doLoadingFinished() {
    var result = super.doLoadingFinished();
    this.resetDirty();
    return result;
  }

  /**
   * Load the validation errors from the server
   *
   * @param {object} _attrs
   */
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);

    // Check whether an validation error entry exists
    if (this.id && this.getArrayMgr("validation_errors")) {
      var val = this.getArrayMgr("validation_errors").getEntry(this.id);
      if (val) {
        _attrs["validation_error"] = val;
      }
    }
  }
  attachToDOM() {
    var node = this.getInputNode();
    if (node) {
      jQuery(node).off('.et2_inputWidget').bind("change.et2_inputWidget", this, function (e) {
        e.data.change.call(e.data, this);
      }).bind("focus.et2_inputWidget", this, function (e) {
        e.data.focus.call(e.data, this);
      });
    }
    return super.attachToDOM();

    //		jQuery(this.getInputNode()).attr("novalidate","novalidate"); // Stop browser from getting involved
    //		jQuery(this.getInputNode()).validator();
  }

  detatchFromDOM() {
    //		if(this.getInputNode()) {
    //			jQuery(this.getInputNode()).data("validator").destroy();
    //		}
    super.detachFromDOM();
  }
  change(_node, _widget, _value) {
    var messages = [];
    var valid = this.isValid(messages);

    // Passing false will clear any set messages
    this.set_validation_error(valid ? false : messages);
    if (valid && this.onchange) {
      if (typeof this.onchange == 'function') {
        // Make sure function gets a reference to the widget
        var args = Array.prototype.slice.call(arguments);
        if (args.indexOf(this) == -1) args.push(this);
        return this.onchange.apply(this, args);
      } else {
        return et2_compileLegacyJS(this.options.onchange, this, _node)();
      }
    }
    return valid;
  }
  focus(_node) {
    if (typeof this.options.onfocus == 'function') {
      // Make sure function gets a reference to the widget
      var args = Array.prototype.slice.call(arguments);
      if (args.indexOf(this) == -1) args.push(this);
      return this.options.onfocus.apply(this, args);
    }
  }

  /**
   * Set value of widget and trigger for real changes a change event
   *
   * First initialisation (_oldValue === et2_no_init) is NOT considered a change!
   *
   * @param {string} _value value to set
   */
  set_value(_value) {
    var node = this.getInputNode();
    if (node) {
      jQuery(node).val(_value);
      if (this.isAttached() && this._oldValue !== et2_no_init && this._oldValue !== _value) {
        jQuery(node).change();
      }
    }
    this._oldValue = _value;
  }
  set_id(_value) {
    this.id = _value;
    this.dom_id = _value && this.getInstanceManager() ? this.getInstanceManager().uniqueId + '_' + this.id : _value;

    // Set the id of the _input_ node (in contrast to the default
    // implementation, which sets the base node)
    var node = this.getInputNode();
    if (node) {
      // Unique ID to prevent DOM collisions across multiple templates
      if (_value != "") {
        node.setAttribute("id", this.dom_id);
        node.setAttribute("name", _value);
      } else {
        node.removeAttribute("id");
        node.removeAttribute("name");
      }
    }
  }
  set_needed(_value) {
    var node = this.getInputNode();
    if (node) {
      if (_value && !this.options.readonly) {
        jQuery(node).attr("required", "required");
      } else {
        node.removeAttribute("required");
      }
    }
  }
  set_validation_error(_value) {
    var node = this.getInputNode();
    if (node) {
      if (_value === false) {
        this.hideMessage();
        jQuery(node).removeClass("invalid");
      } else {
        this.showMessage(_value, "validation_error");
        jQuery(node).addClass("invalid");

        // If on a tab, switch to that tab so user can see it
        var widget = this;
        while (widget.getParent() && widget.getType() !== 'et2-tabbox') {
          widget = widget.getParent();
        }
        if (widget.getType() == 'et2-tabbox') widget.activateTab(this);
      }
    }
  }

  /**
   * Set tab index
   *
   * @param {number} index
   */
  set_tabindex(index) {
    jQuery(this.getInputNode()).attr("tabindex", index);
  }
  getInputNode() {
    return this.node;
  }
  get_value() {
    return this.getValue();
  }

  /**
   * @param boolean submit_value true: call by etemplate2.(getValues|submit|postSubmit)()
   */
  getValue(submit_value) {
    var node = this.getInputNode();
    if (node) {
      var val = jQuery(node).val();
      return val;
    }
    return this._oldValue;
  }
  isDirty() {
    var value = this.getValue();
    if (typeof value !== typeof this._oldValue) {
      return true;
    }
    if (this._oldValue === value) {
      return false;
    }
    switch (typeof this._oldValue) {
      case "object":
        if (typeof this._oldValue.length !== "undefined" && this._oldValue.length !== value.length) {
          return true;
        }
        for (var key in this._oldValue) {
          if (this._oldValue[key] !== value[key]) return true;
        }
        return false;
      default:
        return this._oldValue != value;
    }
  }
  resetDirty() {
    this._oldValue = this.getValue();
  }
  isValid(messages) {
    var ok = true;

    // Check for required
    if (this.options && this.options.needed && !this.options.readonly && !this.disabled && (this.getValue() == null || this.getValue().valueOf() == '')) {
      messages.push(this.egw().lang('Field must not be empty !!!'));
      ok = false;
    }
    return ok;
  }

  /**
   * Called whenever the template gets submitted. We return false if the widget
   * is not valid, which cancels the submission.
   *
   * @param _values contains the values which will be sent to the server.
   * 	Listeners may change these values before they get submitted.
   */
  submit(_values) {
    var messages = [];
    var valid = this.isValid(messages);

    // Passing false will clear any set messages
    this.set_validation_error(valid ? false : messages);
    return valid;
  }
}
_defineProperty$1Y(et2_inputWidget, "_attributes", {
  "needed": {
    "name": "Required",
    "default": false,
    "type": "boolean",
    "description": "If required, the user must enter a value before the form can be submitted"
  },
  "onchange": {
    "name": "onchange",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code which is executed when the value changes."
  },
  "onfocus": {
    "name": "onfocus",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code which get executed when wiget receives focus."
  },
  "validation_error": {
    "name": "Validation Error",
    "type": "string",
    "default": et2_no_init,
    "description": "Used internally to store the validation error that came from the server."
  },
  "tabindex": {
    "name": "Tab index",
    "type": "integer",
    "default": et2_no_init,
    "description": "Specifies the tab order of a widget when the 'tab' button is used for navigating."
  },
  readonly: {
    name: "readonly",
    type: "boolean",
    "default": false,
    description: "Does NOT allow user to enter data, just displays existing data"
  }
});

var es_array_reduce = {};

var aCallable = aCallable$a;
var toObject = toObject$5;
var IndexedObject = indexedObject;
var lengthOfArrayLike = lengthOfArrayLike$4;

var $TypeError$1 = TypeError;

// `Array.prototype.{ reduce, reduceRight }` methods implementation
var createMethod = function (IS_RIGHT) {
  return function (that, callbackfn, argumentsLength, memo) {
    aCallable(callbackfn);
    var O = toObject(that);
    var self = IndexedObject(O);
    var length = lengthOfArrayLike(O);
    var index = IS_RIGHT ? length - 1 : 0;
    var i = IS_RIGHT ? -1 : 1;
    if (argumentsLength < 2) while (true) {
      if (index in self) {
        memo = self[index];
        index += i;
        break;
      }
      index += i;
      if (IS_RIGHT ? index < 0 : length <= index) {
        throw $TypeError$1('Reduce of empty array with no initial value');
      }
    }
    for (;IS_RIGHT ? index >= 0 : length > index; index += i) if (index in self) {
      memo = callbackfn(memo, self[index], index, O);
    }
    return memo;
  };
};

var arrayReduce = {
  // `Array.prototype.reduce` method
  // https://tc39.es/ecma262/#sec-array.prototype.reduce
  left: createMethod(false),
  // `Array.prototype.reduceRight` method
  // https://tc39.es/ecma262/#sec-array.prototype.reduceright
  right: createMethod(true)
};

'use strict';
var $$9 = _export;
var $reduce = arrayReduce.left;
var arrayMethodIsStrict = arrayMethodIsStrict$2;
var CHROME_VERSION = engineV8Version;
var IS_NODE = engineIsNode;

// Chrome 80-82 has a critical bug
// https://bugs.chromium.org/p/chromium/issues/detail?id=1049982
var CHROME_BUG = !IS_NODE && CHROME_VERSION > 79 && CHROME_VERSION < 83;
var FORCED = CHROME_BUG || !arrayMethodIsStrict('reduce');

// `Array.prototype.reduce` method
// https://tc39.es/ecma262/#sec-array.prototype.reduce
$$9({ target: 'Array', proto: true, forced: FORCED }, {
  reduce: function reduce(callbackfn /* , initialValue */) {
    var length = arguments.length;
    return $reduce(this, callbackfn, length, length > 1 ? arguments[1] : undefined);
  }
});

var es_array_reverse = {};

var classof$1 = classofRaw;

// `IsArray` abstract operation
// https://tc39.es/ecma262/#sec-isarray
// eslint-disable-next-line es/no-array-isarray -- safe
var isArray$2 = Array.isArray || function isArray(argument) {
  return classof$1(argument) == 'Array';
};

'use strict';
var $$8 = _export;
var uncurryThis$3 = functionUncurryThis;
var isArray$1 = isArray$2;

var nativeReverse = uncurryThis$3([].reverse);
var test = [1, 2];

// `Array.prototype.reverse` method
// https://tc39.es/ecma262/#sec-array.prototype.reverse
// fix for Safari 12.0 bug
// https://bugs.webkit.org/show_bug.cgi?id=188794
$$8({ target: 'Array', proto: true, forced: String(test) === String(test.reverse()) }, {
  reverse: function reverse() {
    // eslint-disable-next-line no-self-assign -- dirty hack
    if (isArray$1(this)) this.length = this.length;
    return nativeReverse(this);
  }
});

var esnext_string_replaceAll = {};

var es_string_replaceAll = {};

'use strict';
var $$7 = _export;
var call$2 = functionCall;
var uncurryThis$2 = functionUncurryThis;
var requireObjectCoercible$1 = requireObjectCoercible$6;
var isCallable$1 = isCallable$f;
var isNullOrUndefined = isNullOrUndefined$6;
var isRegExp = isRegexp;
var toString$2 = toString$a;
var getMethod = getMethod$6;
var getRegExpFlags = regexpGetFlags;
var getSubstitution = getSubstitution$2;
var wellKnownSymbol$2 = wellKnownSymbol$f;
var IS_PURE$2 = isPure;

var REPLACE = wellKnownSymbol$2('replace');
var $TypeError = TypeError;
var indexOf = uncurryThis$2(''.indexOf);
var replace$1 = uncurryThis$2(''.replace);
var stringSlice$1 = uncurryThis$2(''.slice);
var max$1 = Math.max;

var stringIndexOf = function (string, searchValue, fromIndex) {
  if (fromIndex > string.length) return -1;
  if (searchValue === '') return fromIndex;
  return indexOf(string, searchValue, fromIndex);
};

// `String.prototype.replaceAll` method
// https://tc39.es/ecma262/#sec-string.prototype.replaceall
$$7({ target: 'String', proto: true }, {
  replaceAll: function replaceAll(searchValue, replaceValue) {
    var O = requireObjectCoercible$1(this);
    var IS_REG_EXP, flags, replacer, string, searchString, functionalReplace, searchLength, advanceBy, replacement;
    var position = 0;
    var endOfLastMatch = 0;
    var result = '';
    if (!isNullOrUndefined(searchValue)) {
      IS_REG_EXP = isRegExp(searchValue);
      if (IS_REG_EXP) {
        flags = toString$2(requireObjectCoercible$1(getRegExpFlags(searchValue)));
        if (!~indexOf(flags, 'g')) throw $TypeError('`.replaceAll` does not allow non-global regexes');
      }
      replacer = getMethod(searchValue, REPLACE);
      if (replacer) {
        return call$2(replacer, searchValue, O, replaceValue);
      } else if (IS_PURE$2 && IS_REG_EXP) {
        return replace$1(toString$2(O), searchValue, replaceValue);
      }
    }
    string = toString$2(O);
    searchString = toString$2(searchValue);
    functionalReplace = isCallable$1(replaceValue);
    if (!functionalReplace) replaceValue = toString$2(replaceValue);
    searchLength = searchString.length;
    advanceBy = max$1(1, searchLength);
    position = stringIndexOf(string, searchString, 0);
    while (position !== -1) {
      replacement = functionalReplace
        ? toString$2(replaceValue(searchString, position, string))
        : getSubstitution(searchString, string, position, [], undefined, replaceValue);
      result += stringSlice$1(string, endOfLastMatch, position) + replacement;
      endOfLastMatch = position + searchLength;
      position = stringIndexOf(string, searchString, position + advanceBy);
    }
    if (endOfLastMatch < string.length) {
      result += stringSlice$1(string, endOfLastMatch);
    }
    return result;
  }
});

var es_object_fromEntries = {};

var $$6 = _export;
var iterate = iterate$4;
var createProperty = createProperty$2;

// `Object.fromEntries` method
// https://github.com/tc39/proposal-object-from-entries
$$6({ target: 'Object', stat: true }, {
  fromEntries: function fromEntries(iterable) {
    var obj = {};
    iterate(iterable, function (k, v) {
      createProperty(obj, k, v);
    }, { AS_ENTRIES: true });
    return obj;
  }
});

const windowWithOptionalPolyfill =
  /** @type {Window & typeof globalThis & {applyFocusVisiblePolyfill?: function}} */ (window);
const polyfilledNodes = new WeakMap();

/**
 * @param {Node} node
 */
function applyFocusVisiblePolyfillWhenNeeded(node) {
  if (windowWithOptionalPolyfill.applyFocusVisiblePolyfill && !polyfilledNodes.has(node)) {
    windowWithOptionalPolyfill.applyFocusVisiblePolyfill(node);
    polyfilledNodes.set(node, undefined);
  }
}

/**
 * @typedef {import('../types/FocusMixinTypes').FocusMixin} FocusMixin
 * @type {FocusMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const FocusMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class FocusMixin extends superclass {
    /** @type {any} */
    static get properties() {
      return {
        focused: { type: Boolean, reflect: true },
        focusedVisible: { type: Boolean, reflect: true, attribute: 'focused-visible' },
      };
    }

    constructor() {
      super();

      /**
       * Whether the focusable element within (`._focusableNode`) is focused.
       * Reflects to attribute '[focused]' as a styling hook
       * @type {boolean}
       */
      this.focused = false;

      /**
       * Whether the focusable element within (`._focusableNode`) matches ':focus-visible'
       * Reflects to attribute '[focused-visible]' as a styling hook
       * See: https://developer.mozilla.org/en-US/docs/Web/CSS/:focus-visible
       * @type {boolean}
       */
      this.focusedVisible = false;
    }

    connectedCallback() {
      super.connectedCallback();
      this.__registerEventsForFocusMixin();
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      this.__teardownEventsForFocusMixin();
    }

    /**
     * Calls `focus()` on focusable element within
     */
    focus() {
      this._focusableNode?.focus();
    }

    /**
     * Calls `blur()` on focusable element within
     */
    blur() {
      this._focusableNode?.blur();
    }

    /**
     * The focusable element:
     * could be an input, textarea, select, button or any other element with tabindex > -1
     * @protected
     * @type {HTMLElement}
     */
    // @ts-ignore it's up to Subclassers to return the right element. This is needed for docs/types
    // eslint-disable-next-line class-methods-use-this, getter-return, no-empty-function
    get _focusableNode() {
      // TODO: [v1]: remove return of _inputNode (it's now here for backwards compatibility)
      // @ts-expect-error see above
      return /** @type {HTMLElement} */ (this._inputNode || document.createElement('input'));
    }

    /**
     * @private
     */
    __onFocus() {
      this.focused = true;

      if (typeof windowWithOptionalPolyfill.applyFocusVisiblePolyfill === 'function') {
        this.focusedVisible = this._focusableNode.hasAttribute('data-focus-visible-added');
      } else
        try {
          // Safari throws when matches is called
          this.focusedVisible = this._focusableNode.matches(':focus-visible');
        } catch (_) {
          this.focusedVisible = false;
        }
    }

    /**
     * @private
     */
    __onBlur() {
      this.focused = false;
      this.focusedVisible = false;
    }

    /**
     * @private
     */
    __registerEventsForFocusMixin() {
      applyFocusVisiblePolyfillWhenNeeded(this.getRootNode());

      /**
       * focus
       * @param {Event} ev
       */
      this.__redispatchFocus = ev => {
        ev.stopPropagation();
        this.dispatchEvent(new Event('focus'));
      };
      this._focusableNode.addEventListener('focus', this.__redispatchFocus);

      /**
       * blur
       * @param {Event} ev
       */
      this.__redispatchBlur = ev => {
        ev.stopPropagation();
        this.dispatchEvent(new Event('blur'));
      };
      this._focusableNode.addEventListener('blur', this.__redispatchBlur);

      /**
       * focusin
       * @param {Event} ev
       */
      this.__redispatchFocusin = ev => {
        ev.stopPropagation();
        this.__onFocus();
        this.dispatchEvent(new Event('focusin', { bubbles: true, composed: true }));
      };
      this._focusableNode.addEventListener('focusin', this.__redispatchFocusin);

      /**
       * focusout
       * @param {Event} ev
       */
      this.__redispatchFocusout = ev => {
        ev.stopPropagation();
        this.__onBlur();
        this.dispatchEvent(new Event('focusout', { bubbles: true, composed: true }));
      };
      this._focusableNode.addEventListener('focusout', this.__redispatchFocusout);
    }

    /**
     * @private
     */
    __teardownEventsForFocusMixin() {
      this._focusableNode.removeEventListener(
        'focus',
        /** @type {EventListenerOrEventListenerObject} */ (this.__redispatchFocus),
      );
      this._focusableNode.removeEventListener(
        'blur',
        /** @type {EventListenerOrEventListenerObject} */ (this.__redispatchBlur),
      );
      this._focusableNode.removeEventListener(
        'focusin',
        /** @type {EventListenerOrEventListenerObject} */ (this.__redispatchFocusin),
      );
      this._focusableNode.removeEventListener(
        'focusout',
        /** @type {EventListenerOrEventListenerObject} */ (this.__redispatchFocusout),
      );
    }
  };

/**
 * For browsers that not support the [spec](https://developer.mozilla.org/en-US/docs/Web/CSS/:focus-visible),
 * be sure to load the polyfill into your application https://github.com/WICG/focus-visible
 * (or go for progressive enhancement).
 */
const FocusMixin = dedupeMixin(FocusMixinImplementation);

/* eslint-disable no-bitwise */

const moveDownConditions = [
  Node.DOCUMENT_POSITION_PRECEDING,
  Node.DOCUMENT_POSITION_CONTAINS,
  Node.DOCUMENT_POSITION_CONTAINS | Node.DOCUMENT_POSITION_PRECEDING,
];

/**
 * @desc Let the order of adding ids to aria element by DOM order, so that the screen reader
 * respects visual order when reading:
 * https://developers.google.com/web/fundamentals/accessibility/focus/dom-order-matters
 * @param {HTMLElement[]} descriptionElements - holds references to description or label elements whose
 * id should be returned
 * @param {Object} opts
 * @param {boolean} [opts.reverse]
 * @returns {HTMLElement[]} sorted set of elements based on dom order
 */
function getAriaElementsInRightDomOrder(descriptionElements, { reverse } = {}) {
  /**
   * @param {HTMLElement} a
   * @param {HTMLElement} b
   * @return {-1|1}
   */
  const putPrecedingSiblingsAndLocalParentsFirst = (a, b) => {
    // https://developer.mozilla.org/en-US/docs/Web/API/Node/compareDocumentPosition
    const pos = a.compareDocumentPosition(b);

    // Unfortunately, for IE, we have to switch the order (?)
    if (moveDownConditions.includes(pos)) {
      return browserDetection.isIE11 ? -1 : 1;
    }
    return browserDetection.isIE11 ? 1 : -1;
  };

  const descriptionEls = descriptionElements.filter(el => el); // filter out null references
  descriptionEls.sort(putPrecedingSiblingsAndLocalParentsFirst);
  if (reverse) {
    descriptionEls.reverse();
  }
  return descriptionEls;
}

/**
 * A modelValue can demand a certain type (Date, Number, Iban etc.). A correct type will always be
 * translatable into a String representation (the value presented to the end user) via the
 * `formatter`. When the type is not valid (usually as a consequence of a user typing in an invalid
 * or incomplete viewValue), the current truth is captured in the `Unparseable` type.
 * For example: a viewValue can't be parsed (for instance 'foo' when the type should be Number).

 * The model(value) concept as implemented in lion-web is conceptually comparable to those found in
 * popular frameworks like Angular and Vue.

 * The Unparseable type is an addition on top of this that mainly is added for the following two
 * purposes:
 * - restoring user sessions
 * - realtime updated with all value changes
 */
class Unparseable {
  /** @param {string} value */
  constructor(value) {
    /**
     * Meta info for restoring serialized Unparseable values
     * @type {'unparseable'}
     */
    this.type = 'unparseable';
    /**
     * Stores current view value. For instance, value '09-' is an unparseable Date.
     * This info can be used to restore previous form states.
     * @type {string}
     */
    this.viewValue = value;
  }

  toString() {
    return JSON.stringify({ type: this.type, viewValue: this.viewValue });
  }
}

/**
 * @typedef {import('@lion/core').LitElement} LitElement
 * @typedef {import('../../types/FormControlMixinTypes').FormControlHost} FormControlHost
 * @typedef {import('../../types/registration/FormRegisteringMixinTypes').FormRegisteringMixin} FormRegisteringMixin
 * @typedef {import('../../types/registration/FormRegisteringMixinTypes').FormRegisteringHost} FormRegisteringHost
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').ElementWithParentFormGroup} ElementWithParentFormGroup
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').FormRegistrarHost} FormRegistrarHost
 */

/**
 * #FormRegisteringMixin:
 *
 * This Mixin registers a form element to a Registrar
 *
 * @type {FormRegisteringMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<LitElement>} superclass
 */
const FormRegisteringMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends superclass {
    constructor() {
      super();
      /**
       * The registrar this FormControl registers to, Usually a descendant of FormGroup or
       * ChoiceGroup
       * @type {FormRegistrarHost | undefined}
       */
      this._parentFormGroup = undefined;
    }

    connectedCallback() {
      super.connectedCallback();
      this.dispatchEvent(
        new CustomEvent('form-element-register', {
          detail: { element: this },
          bubbles: true,
        }),
      );
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      if (this._parentFormGroup) {
        this._parentFormGroup.removeFormElement(/** @type {* & FormRegisteringHost} */ (this));
      }
    }
  };

const FormRegisteringMixin = dedupeMixin(FormRegisteringMixinImplementation);

/**
 * @typedef {import('@lion/core').TemplateResult} TemplateResult
 * @typedef {import('@lion/core').CSSResult} CSSResult
 * @typedef {import('@lion/core').CSSResultArray} CSSResultArray
 * @typedef {import('@lion/core/types/SlotMixinTypes').SlotsMap} SlotsMap
 * @typedef {import('./validate/LionValidationFeedback').LionValidationFeedback} LionValidationFeedback
 * @typedef {import('../types/choice-group/ChoiceInputMixinTypes').ChoiceInputHost} ChoiceInputHost
 * @typedef {import('../types/FormControlMixinTypes.js').FormControlHost} FormControlHost
 * @typedef {import('../types/FormControlMixinTypes.js').HTMLElementWithValue} HTMLElementWithValue
 * @typedef {import('../types/FormControlMixinTypes.js').FormControlMixin} FormControlMixin
 * @typedef {import('../types/FormControlMixinTypes.js').ModelValueEventDetails} ModelValueEventDetails
 */

/**
 * Generates random unique identifier (for dom elements)
 * @param {string} prefix
 */
function uuid(prefix) {
  return `${prefix}-${Math.random().toString(36).substr(2, 10)}`;
}

/**
 * #FormControlMixin :
 *
 * This Mixin is a shared fundament for all form components, it's applied on:
 * - LionField (which is extended to LionInput, LionTextarea, LionSelect etc. etc.)
 * - LionFieldset (which is extended to LionRadioGroup, LionCheckboxGroup, LionForm)
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 * @type {FormControlMixin}
 */
const FormControlMixinImplementation = superclass =>
  // eslint-disable-next-line no-shadow, no-unused-vars
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class FormControlMixin extends FormRegisteringMixin(DisabledMixin(SlotMixin(superclass))) {
    /** @type {any} */
    static get properties() {
      return {
        name: { type: String, reflect: true },
        readOnly: { type: Boolean, attribute: 'readonly', reflect: true },
        label: String, // FIXME: { attribute: false } breaks a bunch of tests, but shouldn't...
        helpText: { type: String, attribute: 'help-text' },
        modelValue: { attribute: false },
        _ariaLabelledNodes: { attribute: false },
        _ariaDescribedNodes: { attribute: false },
        _repropagationRole: { attribute: false },
        _isRepropagationEndpoint: { attribute: false },
      };
    }

    /**
     * The label text for the input node.
     * When no light dom defined via [slot=label], this value will be used.
     * @type {string}
     */
    get label() {
      return this.__label || (this._labelNode && this._labelNode.textContent) || '';
    }

    /**
     * @param {string} newValue
     */
    set label(newValue) {
      const oldValue = this.label;
      /** @type {string} */
      this.__label = newValue;
      this.requestUpdate('label', oldValue);
    }

    /**
     * The helpt text for the input node.
     * When no light dom defined via [slot=help-text], this value will be used
     * @type {string}
     */
    get helpText() {
      return this.__helpText || (this._helpTextNode && this._helpTextNode.textContent) || '';
    }

    /**
     * @param {string} newValue
     */
    set helpText(newValue) {
      const oldValue = this.helpText;
      /** @type {string} */
      this.__helpText = newValue;
      this.requestUpdate('helpText', oldValue);
    }

    /**
     * Will be used in validation messages to refer to the current field
     * @type {string}
     */
    get fieldName() {
      return this.__fieldName || this.label || this.name || '';
    }

    /**
     * @param {string} value
     */
    set fieldName(value) {
      /** @type {string} */
      this.__fieldName = value;
    }

    /**
     * @configure SlotMixin
     */
    get slots() {
      return {
        ...super.slots,
        label: () => {
          const label = document.createElement('label');
          label.textContent = this.label;
          return label;
        },
        'help-text': () => {
          const helpText = document.createElement('div');
          helpText.textContent = this.helpText;
          return helpText;
        },
      };
    }

    /**
     * The interactive (form) element. Can be a native element like input/textarea/select or
     * an element with tabindex > -1
     * @protected
     */
    get _inputNode() {
      return /** @type {HTMLElementWithValue} */ (this.__getDirectSlotChild('input'));
    }

    /**
     * Element where label will be rendered to
     * @protected
     */
    get _labelNode() {
      return /** @type {HTMLElement} */ (this.__getDirectSlotChild('label'));
    }

    /**
     * Element where help text will be rendered to
     * @protected
     */
    get _helpTextNode() {
      return /** @type {HTMLElement} */ (this.__getDirectSlotChild('help-text'));
    }

    /**
     * Element where validation feedback will be rendered to
     * @protected
     */
    get _feedbackNode() {
      return /** @type {LionValidationFeedback} */ (this.__getDirectSlotChild('feedback'));
    }

    constructor() {
      super();

      /**
       * The name the element will be registered with to the .formElements collection
       * of the parent. Also, it serves as the key of key/value pairs in
       *  modelValue/serializedValue objects
       * @type {string}
       */
      this.name = '';

      /**
       * A Boolean attribute which, if present, indicates that the user should not be able to edit
       * the value of the input. The difference between disabled and readonly is that read-only
       * controls can still function, whereas disabled controls generally do not function as
       * controls until they are enabled.
       * (From: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#attr-readonly)
       * @type {boolean}
       */
      this.readOnly = false;

      /**
       * The label text for the input node.
       * When no value is defined, textContent of [slot=label] will be used
       * @type {string}
       */
      this.label = '';

      /**
       * The helpt text for the input node.
       * When no value is defined, textContent of [slot=help-text] will be used
       * @type {string}
       */
      this.helpText = '';

      /**
       * The model value is the result of the parser function(when available).
       * It should be considered as the internal value used for validation and reasoning/logic.
       * The model value is 'ready for consumption' by the outside world (think of a Date
       * object or a float). The modelValue can(and is recommended to) be used as both input
       * value and output value of the `LionField`.
       *
       * Examples:
       * - For a date input: a String '20/01/1999' will be converted to new Date('1999/01/20')
       * - For a number input: a formatted String '1.234,56' will be converted to a Number:
       *   1234.56
       */
      // TODO: we can probably set this up properly once propert effects run from firstUpdated
      // this.modelValue = undefined;
      /**
       * Unique id that can be used in all light dom
       * @type {string}
       * @protected
       */
      this._inputId = uuid(this.localName);

      /**
       * Contains all elements that should end up in aria-labelledby of `._inputNode`
       * @type {HTMLElement[]}
       */
      this._ariaLabelledNodes = [];

      /**
       * Contains all elements that should end up in aria-describedby of `._inputNode`
       * @type {HTMLElement[]}
       */
      this._ariaDescribedNodes = [];

      /**
       * Based on the role, details of handling model-value-changed repropagation differ.
       * @type {'child'|'choice-group'|'fieldset'}
       */
      this._repropagationRole = 'child';

      /**
       * By default, a field with _repropagationRole 'choice-group' will act as an
       * 'endpoint'. This means it will be considered as an individual field: for
       * a select, individual options will not be part of the formPath. They
       * will.
       * Similarly, components that (a11y wise) need to be fieldsets, but 'interaction wise'
       * (from Application Developer perspective) need to be more like fields
       * (think of an amount-input with a currency select box next to it), can set this
       * to true to hide private internals in the formPath.
       * @type {boolean}
       */
      this._isRepropagationEndpoint = false;

      this.addEventListener(
        'model-value-changed',
        /** @type {EventListenerOrEventListenerObject} */ (this.__repropagateChildrenValues),
      );
      /** @type {EventListener} */
      this._onLabelClick = this._onLabelClick.bind(this);
    }

    connectedCallback() {
      super.connectedCallback();
      this._enhanceLightDomClasses();
      this._enhanceLightDomA11y();
      this._triggerInitialModelValueChangedEvent();

      if (this._labelNode) {
        this._labelNode.addEventListener('click', this._onLabelClick);
      }
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      if (this._labelNode) {
        this._labelNode.removeEventListener('click', this._onLabelClick);
      }
    }

    /** @param {import('@lion/core').PropertyValues } changedProperties */
    updated(changedProperties) {
      super.updated(changedProperties);

      if (changedProperties.has('_ariaLabelledNodes')) {
        this.__reflectAriaAttr(
          'aria-labelledby',
          this._ariaLabelledNodes,
          this.__reorderAriaLabelledNodes,
        );
      }

      if (changedProperties.has('_ariaDescribedNodes')) {
        this.__reflectAriaAttr(
          'aria-describedby',
          this._ariaDescribedNodes,
          this.__reorderAriaDescribedNodes,
        );
      }

      if (changedProperties.has('label') && this._labelNode) {
        this._labelNode.textContent = this.label;
      }

      if (changedProperties.has('helpText') && this._helpTextNode) {
        this._helpTextNode.textContent = this.helpText;
      }

      if (changedProperties.has('name')) {
        this.dispatchEvent(
          /** @privateEvent */
          new CustomEvent('form-element-name-changed', {
            detail: { oldName: changedProperties.get('name'), newName: this.name },
            bubbles: true,
          }),
        );
      }
    }

    /** @protected */
    _triggerInitialModelValueChangedEvent() {
      this._dispatchInitialModelValueChangedEvent();
    }

    /** @protected */
    _enhanceLightDomClasses() {
      if (this._inputNode) {
        this._inputNode.classList.add('form-control');
      }
    }

    /** @protected */
    _enhanceLightDomA11y() {
      const { _inputNode, _labelNode, _helpTextNode, _feedbackNode } = this;

      if (_inputNode) {
        _inputNode.id = _inputNode.id || this._inputId;
      }
      if (_labelNode) {
        _labelNode.setAttribute('for', this._inputId);
        this.addToAriaLabelledBy(_labelNode, { idPrefix: 'label' });
      }
      if (_helpTextNode) {
        this.addToAriaDescribedBy(_helpTextNode, { idPrefix: 'help-text' });
      }
      if (_feedbackNode) {
        // Generic focus/blur handling that works for both Fields/FormGroups
        this.addEventListener('focusin', () => {
          _feedbackNode.setAttribute('aria-live', 'polite');
        });
        this.addEventListener('focusout', () => {
          _feedbackNode.setAttribute('aria-live', 'assertive');
        });

        this.addToAriaDescribedBy(_feedbackNode, { idPrefix: 'feedback' });
      }
      this._enhanceLightDomA11yForAdditionalSlots();
    }

    /**
     * Enhances additional slots(prefix, suffix, before, after) defined by developer.
     *
     * When boolean attribute data-label or data-description is found,
     * the slot element will be connected to the input via aria-labelledby or aria-describedby
     * @param {string[]} additionalSlots
     * @protected
     */
    _enhanceLightDomA11yForAdditionalSlots(
      additionalSlots = ['prefix', 'suffix', 'before', 'after'],
    ) {
      additionalSlots.forEach(additionalSlot => {
        const element = this.__getDirectSlotChild(additionalSlot);
        if (element) {
          if (element.hasAttribute('data-label')) {
            this.addToAriaLabelledBy(element, { idPrefix: additionalSlot });
          }
          if (element.hasAttribute('data-description')) {
            this.addToAriaDescribedBy(element, { idPrefix: additionalSlot });
          }
        }
      });
    }

    /**
     * Will handle help text, validation feedback and character counter,
     * prefix/suffix/before/after (if they contain data-description flag attr).
     * Also, contents of id references that will be put in the <lion-field>._ariaDescribedby property
     * from an external context, will be read by a screen reader.
     * @param {string} attrName
     * @param {HTMLElement[]} nodes
     * @param {boolean|undefined} reorder
     */
    __reflectAriaAttr(attrName, nodes, reorder) {
      if (this._inputNode) {
        if (reorder) {
          const insideNodes = nodes.filter(n => this.contains(n));
          const outsideNodes = nodes.filter(n => !this.contains(n));

          // eslint-disable-next-line no-param-reassign
          nodes = [...getAriaElementsInRightDomOrder(insideNodes), ...outsideNodes];
        }
        const string = nodes.map(n => n.id).join(' ');
        this._inputNode.setAttribute(attrName, string);
      }
    }

    /**
     * Default Render Result:
     * <div class="form-field__group-one">
     *   <div class="form-field__label">
     *     <slot name="label"></slot>
     *   </div>
     *   <small class="form-field__help-text">
     *     <slot name="help-text"></slot>
     *   </small>
     * </div>
     * <div class="form-field__group-two">
     *   <div class="input-group">
     *     <div class="input-group__before">
     *       <slot name="before"></slot>
     *     </div>
     *     <div class="input-group__container">
     *       <div class="input-group__prefix">
     *         <slot name="prefix"></slot>
     *       </div>
     *       <div class="input-group__input">
     *         <slot name="input"></slot>
     *       </div>
     *       <div class="input-group__suffix">
     *         <slot name="suffix"></slot>
     *       </div>
     *     </div>
     *     <div class="input-group__after">
     *       <slot name="after"></slot>
     *     </div>
     *   </div>
     *   <div class="form-field__feedback">
     *     <slot name="feedback"></slot>
     *   </div>
     * </div>
     */
    render() {
      return x$1`
        <div class="form-field__group-one">${this._groupOneTemplate()}</div>
        <div class="form-field__group-two">${this._groupTwoTemplate()}</div>
      `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    _groupOneTemplate() {
      return x$1` ${this._labelTemplate()} ${this._helpTextTemplate()} `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    _groupTwoTemplate() {
      return x$1` ${this._inputGroupTemplate()} ${this._feedbackTemplate()} `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _labelTemplate() {
      return x$1`
        <div class="form-field__label">
          <slot name="label"></slot>
        </div>
      `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _helpTextTemplate() {
      return x$1`
        <small class="form-field__help-text">
          <slot name="help-text"></slot>
        </small>
      `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    _inputGroupTemplate() {
      return x$1`
        <div class="input-group">
          ${this._inputGroupBeforeTemplate()}
          <div class="input-group__container">
            ${this._inputGroupPrefixTemplate()} ${this._inputGroupInputTemplate()}
            ${this._inputGroupSuffixTemplate()}
          </div>
          ${this._inputGroupAfterTemplate()}
        </div>
      `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _inputGroupBeforeTemplate() {
      return x$1`
        <div class="input-group__before">
          <slot name="before"></slot>
        </div>
      `;
    }

    /**
     * @return {TemplateResult | nothing}
     * @protected
     */
    _inputGroupPrefixTemplate() {
      return !Array.from(this.children).find(child => child.slot === 'prefix')
        ? A$1
        : x$1`
            <div class="input-group__prefix">
              <slot name="prefix"></slot>
            </div>
          `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _inputGroupInputTemplate() {
      return x$1`
        <div class="input-group__input">
          <slot name="input"></slot>
        </div>
      `;
    }

    /**
     * @return {TemplateResult | nothing}
     * @protected
     */
    _inputGroupSuffixTemplate() {
      return !Array.from(this.children).find(child => child.slot === 'suffix')
        ? A$1
        : x$1`
            <div class="input-group__suffix">
              <slot name="suffix"></slot>
            </div>
          `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _inputGroupAfterTemplate() {
      return x$1`
        <div class="input-group__after">
          <slot name="after"></slot>
        </div>
      `;
    }

    /**
     * @return {TemplateResult}
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _feedbackTemplate() {
      return x$1`
        <div class="form-field__feedback">
          <slot name="feedback"></slot>
        </div>
      `;
    }

    /**
     * Used for Required validation and computation of interaction states
     * @param {any} modelValue
     * @return {boolean}
     * @protected
     */
    _isEmpty(modelValue = /** @type {any} */ (this).modelValue) {
      let value = modelValue;
      if (/** @type {any} */ (this).modelValue instanceof Unparseable) {
        value = /** @type {any} */ (this).modelValue.viewValue;
      }

      // Checks for empty platform types: Objects, Arrays, Dates
      if (typeof value === 'object' && value !== null && !(value instanceof Date)) {
        return !Object.keys(value).length;
      }

      // eslint-disable-next-line no-mixed-operators
      // Checks for empty platform types: Numbers, Booleans
      const isNumberValue = typeof value === 'number' && (value === 0 || Number.isNaN(value));
      const isBooleanValue = typeof value === 'boolean' && value === false;

      return !value && !isNumberValue && !isBooleanValue;
    }

    /**
     * All CSS below is written from a generic mindset, following BEM conventions:
     * https://en.bem.info/methodology/
     * Although the CSS and HTML are implemented by the component, they should be regarded as
     * totally decoupled.
     *
     * Not only does this force us to write better structured css, it also allows for future
     * reusability in many different ways like:
     *  - disabling shadow DOM for a component (for water proof encapsulation can be combined with
     *    a build step)
     *  - easier translation to more flexible, WebComponents agnostic solutions like JSS
     *    (allowing extends, mixins, reasoning, IDE integration, tree shaking etc.)
     *  - export to a CSS module for reuse in an outer context
     *
     *
     * Please note that the HTML structure is purposely 'loose', allowing multiple design systems
     * to be compatible
     * with the CSS component.
     * Note that every occurence of '::slotted(*)' can be rewritten to '> *' for use in an other
     * context
     */

    /**
     * {block} .form-field
     *
     * Structure:
     * - {element}  .form-field__label : a wrapper element around the projected label
     * - {element}  .form-field__help-text (optional) : a wrapper element around the projected
     *               help-text
     * - {block}    .input-group : a container around the input element, including prefixes and
     *               suffixes
     * - {element}  .form-field__feedback (optional) : a wrapper element around the projected
     *               (validation) feedback message
     *
     * Modifiers:
     * - {state} [disabled] when .form-control (<input>, <textarea> etc.) has disabled set
     *            to true
     * - {state} [filled] whether <input> has a value
     * - {state} [touched] whether the user had blurred the field once
     * - {state} [dirty] whether the value has changed since initial value
     *
     * TODO: update states below
     * These classes are now attributes. Check them agains the new attribute names inside ValidateMixin
     * and InteractionStateMixin. Some states got renamed. Make sure to use the correct ones!
     * - {state} .state-focused: when .form-control (<input>, <textarea> etc.) <input> has focus
     * - {state} .state-invalid: when input has error(s) (regardless of whether they should be
     *            shown to the user)
     * - {state} .state-error: when input has error(s) and this/these should be shown to the user
     * - {state} .state-warning: when input has warning(s) and this/these should be shown to the
     *            user
     * - {state} .state-info: when input has info feedback message(s) and this/these should be shown
     *            to the user
     * - {state} .state-success: when input has success feedback message(s) and this/these should be
     *            shown to the user
     */

    /**
     * {block} .input-group
     *
     * Structure:
     * - {element} .input-group__before (optional) : a prefix that resides outside the container
     * - {element} .input-group__container : an inner container: this element contains all styling
     *  - {element} .input-group__prefix (optional) : a prefix that resides in the container,
     *               allowing it to be detectable as a :first-child
     *  - {element} .input-group__input : a wrapper around the form-control component
     *   - {block} .form-control : the actual input element (input/select/textarea)
     *  - {element} .input-group__suffix (optional) : a suffix that resides inside the container,
     *               allowing it to be detectable as a :last-child
     *  - {element} .input-group__bottom (optional) : placeholder element for additional styling
     *               (like an animated line for material design input)
     * - {element} .input-group__after (optional) :  a suffix that resides outside the container
     */
    static get styles() {
      return [
        i$b`
          /**********************
            {block} .form-field
           ********************/

          :host {
            display: block;
          }

          :host([hidden]) {
            display: none;
          }

          :host([disabled]) {
            pointer-events: none;
          }

          :host([disabled]) .form-field__label ::slotted(*),
          :host([disabled]) .form-field__help-text ::slotted(*) {
            color: var(--disabled-text-color, #767676);
          }

          /***********************
            {block} .input-group
           *********************/

          .input-group__container {
            display: flex;
          }

          .input-group__input {
            flex: 1;
            display: flex;
          }

          /***** {state} :disabled *****/
          :host([disabled]) .input-group ::slotted([slot='input']) {
            color: var(--disabled-text-color, #767676);
          }

          /***********************
            {block} .form-control
           **********************/

          .input-group__container > .input-group__input ::slotted(.form-control) {
            flex: 1 1 auto;
            margin: 0; /* remove input margin in Safari */
            font-size: 100%; /* normalize default input font-size */
          }
        `,
      ];
    }

    /**
     * This function exposes descripion elements that a FormGroup should expose to its
     * children. See FormGroupMixin.__getAllDescriptionElementsInParentChain()
     * @return {Array.<HTMLElement>}
     * @protected
     */
    // Returns dom references to all elements that should be referred to by field(s)
    _getAriaDescriptionElements() {
      return [this._helpTextNode, this._feedbackNode];
    }

    /**
     * Allows to add extra element references to aria-labelledby attribute.
     * @param {HTMLElement} element
     * @param {{idPrefix?:string; reorder?: boolean}} customConfig
     */
    addToAriaLabelledBy(element, { idPrefix = '', reorder = true } = {}) {
      // eslint-disable-next-line no-param-reassign
      element.id = element.id || `${idPrefix}-${this._inputId}`;
      if (!this._ariaLabelledNodes.includes(element)) {
        this._ariaLabelledNodes = [...this._ariaLabelledNodes, element];
        // This value will be read when we need to reflect to attr
        /** @type {boolean} */
        this.__reorderAriaLabelledNodes = Boolean(reorder);
      }
    }

    /**
     * Allows to remove element references from aria-labelledby attribute.
     * @param {HTMLElement} element
     */
    removeFromAriaLabelledBy(element) {
      if (this._ariaLabelledNodes.includes(element)) {
        this._ariaLabelledNodes.splice(this._ariaLabelledNodes.indexOf(element), 1);
        this._ariaLabelledNodes = [...this._ariaLabelledNodes];
        // This value will be read when we need to reflect to attr
        /** @type {boolean} */
        this.__reorderAriaLabelledNodes = false;
      }
    }

    /**
     * Allows to add element references to aria-describedby attribute.
     * @param {HTMLElement} element
     * @param {{idPrefix?:string; reorder?: boolean}} customConfig
     */
    addToAriaDescribedBy(element, { idPrefix = '', reorder = true } = {}) {
      // eslint-disable-next-line no-param-reassign
      element.id = element.id || `${idPrefix}-${this._inputId}`;
      if (!this._ariaDescribedNodes.includes(element)) {
        this._ariaDescribedNodes = [...this._ariaDescribedNodes, element];
        // This value will be read when we need to reflect to attr
        /** @type {boolean} */
        this.__reorderAriaDescribedNodes = Boolean(reorder);
      }
    }

    /**
     * Allows to remove element references from aria-describedby attribute.
     * @param {HTMLElement} element
     */
    removeFromAriaDescribedBy(element) {
      if (this._ariaDescribedNodes.includes(element)) {
        this._ariaDescribedNodes.splice(this._ariaDescribedNodes.indexOf(element), 1);
        this._ariaDescribedNodes = [...this._ariaDescribedNodes];
        // This value will be read when we need to reflect to attr
        /** @type {boolean} */
        this.__reorderAriaLabelledNodes = false;
      }
    }

    /**
     * @param {string} slotName
     * @return {HTMLElement | undefined}
     */
    __getDirectSlotChild(slotName) {
      return /** @type {HTMLElement[]} */ (Array.from(this.children)).find(
        el => el.slot === slotName,
      );
    }

    _dispatchInitialModelValueChangedEvent() {
      // When we are not a fieldset / choice-group, we don't need to wait for our children
      // to send a unified event
      if (this._repropagationRole === 'child') {
        return;
      }

      // Initially we don't repropagate model-value-changed events coming
      // from children. On firstUpdated we re-dispatch this event to maintain
      // 'count consistency' (to not confuse the application developer with a
      // large number of initial events). Initially the source field will not
      // be part of the formPath but afterwards it will.
      /** @type {boolean} */
      this.__repropagateChildrenInitialized = true;
      this.dispatchEvent(
        new CustomEvent('model-value-changed', {
          bubbles: true,
          detail: /** @type {ModelValueEventDetails} */ ({
            formPath: [this],
            initialize: true,
            isTriggeredByUser: false,
          }),
        }),
      );
    }

    /**
     * Hook for Subclassers to add logic before repropagation
     * @configurable
     * @param {CustomEvent} ev
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this, no-unused-vars
    _onBeforeRepropagateChildrenValues(ev) {}

    /**
     * @param {CustomEvent} ev
     */
    __repropagateChildrenValues(ev) {
      // Allows sub classes to internally listen to the children change events
      // (before stopImmediatePropagation is called below).
      this._onBeforeRepropagateChildrenValues(ev);
      // Normalize target, we also might get it from 'portals' (rich select)
      const target = (ev.detail && ev.detail.element) || ev.target;
      const isEndpoint =
        this._isRepropagationEndpoint || this._repropagationRole === 'choice-group';

      // Prevent eternal loops after we sent the event below.
      if (target === this) {
        return;
      }

      // A. Stop sibling handlers
      //
      // Make sure our sibling event listeners (added by Application developers) will not get
      // the child model-value-changed event, but the repropagated one at the bottom of this
      // method
      ev.stopImmediatePropagation();

      // B1. Are we still initializing? If so, halt...
      //
      // Stop repropagating children events before firstUpdated and make sure we de not
      // repropagate init events of our children (we already sent our own
      // initial model-value-change event in firstUpdated)
      const isGroup = this._repropagationRole !== 'child'; // => fieldset or choice-group
      const isSelfInitializing = isGroup && !this.__repropagateChildrenInitialized;
      const isChildGroupInitializing = ev.detail && ev.detail.initialize;
      if (isSelfInitializing || isChildGroupInitializing) {
        return;
      }

      // B2. Are we a single choice choice-group? If so, halt when target unchecked
      // and something else is checked, meaning we will get
      // another model-value-changed dispatch for the checked target
      //
      // We only send the checked changed up (not the unchecked). In this way a choice group
      // (radio-group, checkbox-group, select/listbox) acts as an 'endpoint' (a single Field)
      // just like the native <select>
      if (!this._repropagationCondition(target)) {
        return;
      }

      // C1. We are ready to dispatch. Create a formPath
      //
      // Compute the formPath. Choice groups are regarded 'end points'
      let parentFormPath = [];
      if (!isEndpoint) {
        parentFormPath = (ev.detail && ev.detail.formPath) || [target];
      }
      const formPath = [...parentFormPath, this];

      // C2. Finally, redispatch a fresh model-value-changed event from our host, consumable
      // for an Application Developer
      //
      // Since for a11y everything needs to be in lightdom, we don't add 'composed:true'
      this.dispatchEvent(
        new CustomEvent('model-value-changed', {
          bubbles: true,
          detail: /** @type {ModelValueEventDetails} */ ({
            formPath,
            isTriggeredByUser: Boolean(ev.detail?.isTriggeredByUser),
          }),
        }),
      );
    }

    /**
     * Based on provided target, this condition determines whether received model-value-changed
     * event should be repropagated
     * @param {FormControlHost} target
     * @protected
     * @overridable
     */
    // eslint-disable-next-line class-methods-use-this
    _repropagationCondition(target) {
      return Boolean(target);
    }

    /**
     * @overridable
     * A Subclasser should only override this method if the interactive element
     * ([slot=input]) is not a native element(like input, textarea, select)
     * that already receives focus on label click.
     *
     * @example
     * _onLabelClick() {
     *   this._invokerNode.focus();
     * }
     * @protected
     */
    // eslint-disable-next-line class-methods-use-this
    _onLabelClick() {}
  };

const FormControlMixin = dedupeMixin(FormControlMixinImplementation);

const sym = Symbol.for('lion::SingletonManagerClassStorage');

class SingletonManagerClass {
  constructor() {
    /** protected */
    this._map = window[sym] ? window[sym] : (window[sym] = new Map());
  }

  /**
   * Ignores already existing keys (e.g. it will not override)
   *
   * @param {string} key
   * @param {any} value
   */
  set(key, value) {
    if (!this.has(key)) {
      this._map.set(key, value);
    }
  }

  /**
   * @param {string} key
   * @returns
   */
  get(key) {
    return this._map.get(key);
  }

  /**
   * @param {string} key
   */
  has(key) {
    return this._map.has(key);
  }
}

const singletonManager = new SingletonManagerClass();

function createCommonjsModule$1(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

// @flow
var LONG = 'long';
var SHORT = 'short';
var NARROW = 'narrow';
var NUMERIC = 'numeric';
var TWODIGIT = '2-digit';

/**
 * formatting information
 **/
var formatMessageFormats = {
  number: {
    decimal: {
      style: 'decimal'
    },
    integer: {
      style: 'decimal',
      maximumFractionDigits: 0
    },
    currency: {
      style: 'currency',
      currency: 'USD'
    },
    percent: {
      style: 'percent'
    },
    default: {
      style: 'decimal'
    }
  },
  date: {
    short: {
      month: NUMERIC,
      day: NUMERIC,
      year: TWODIGIT
    },
    medium: {
      month: SHORT,
      day: NUMERIC,
      year: NUMERIC
    },
    long: {
      month: LONG,
      day: NUMERIC,
      year: NUMERIC
    },
    full: {
      month: LONG,
      day: NUMERIC,
      year: NUMERIC,
      weekday: LONG
    },
    default: {
      month: SHORT,
      day: NUMERIC,
      year: NUMERIC
    }
  },
  time: {
    short: {
      hour: NUMERIC,
      minute: NUMERIC
    },
    medium: {
      hour: NUMERIC,
      minute: NUMERIC,
      second: NUMERIC
    },
    long: {
      hour: NUMERIC,
      minute: NUMERIC,
      second: NUMERIC,
      timeZoneName: SHORT
    },
    full: {
      hour: NUMERIC,
      minute: NUMERIC,
      second: NUMERIC,
      timeZoneName: SHORT
    },
    default: {
      hour: NUMERIC,
      minute: NUMERIC,
      second: NUMERIC
    }
  },
  duration: {
    default: {
      hours: {
        minimumIntegerDigits: 1,
        maximumFractionDigits: 0
      },
      minutes: {
        minimumIntegerDigits: 2,
        maximumFractionDigits: 0
      },
      seconds: {
        minimumIntegerDigits: 2,
        maximumFractionDigits: 3
      }
    }
  },
  parseNumberPattern: function (pattern/*: ?string */) {
    if (!pattern) return
    var options = {};
    var currency = pattern.match(/\b[A-Z]{3}\b/i);
    var syms = pattern.replace(/[^¤]/g, '').length;
    if (!syms && currency) syms = 1;
    if (syms) {
      options.style = 'currency';
      options.currencyDisplay = syms === 1 ? 'symbol' : syms === 2 ? 'code' : 'name';
      options.currency = currency ? currency[0].toUpperCase() : 'USD';
    } else if (pattern.indexOf('%') >= 0) {
      options.style = 'percent';
    }
    if (!/[@#0]/.test(pattern)) return options.style ? options : undefined
    options.useGrouping = pattern.indexOf(',') >= 0;
    if (/E\+?[@#0]+/i.test(pattern) || pattern.indexOf('@') >= 0) {
      var size = pattern.replace(/E\+?[@#0]+|[^@#0]/gi, '');
      options.minimumSignificantDigits = Math.min(Math.max(size.replace(/[^@0]/g, '').length, 1), 21);
      options.maximumSignificantDigits = Math.min(Math.max(size.length, 1), 21);
    } else {
      var parts = pattern.replace(/[^#0.]/g, '').split('.');
      var integer = parts[0];
      var n = integer.length - 1;
      while (integer[n] === '0') --n;
      options.minimumIntegerDigits = Math.min(Math.max(integer.length - 1 - n, 1), 21);
      var fraction = parts[1] || '';
      n = 0;
      while (fraction[n] === '0') ++n;
      options.minimumFractionDigits = Math.min(Math.max(n, 0), 20);
      while (fraction[n] === '#') ++n;
      options.maximumFractionDigits = Math.min(Math.max(n, 0), 20);
    }
    return options
  },
  parseDatePattern: function (pattern/*: ?string */) {
    if (!pattern) return
    var options = {};
    for (var i = 0; i < pattern.length;) {
      var current = pattern[i];
      var n = 1;
      while (pattern[++i] === current) ++n;
      switch (current) {
        case 'G':
          options.era = n === 5 ? NARROW : n === 4 ? LONG : SHORT;
          break
        case 'y':
        case 'Y':
          options.year = n === 2 ? TWODIGIT : NUMERIC;
          break
        case 'M':
        case 'L':
          n = Math.min(Math.max(n - 1, 0), 4);
          options.month = [ NUMERIC, TWODIGIT, SHORT, LONG, NARROW ][n];
          break
        case 'E':
        case 'e':
        case 'c':
          options.weekday = n === 5 ? NARROW : n === 4 ? LONG : SHORT;
          break
        case 'd':
        case 'D':
          options.day = n === 2 ? TWODIGIT : NUMERIC;
          break
        case 'h':
        case 'K':
          options.hour12 = true;
          options.hour = n === 2 ? TWODIGIT : NUMERIC;
          break
        case 'H':
        case 'k':
          options.hour12 = false;
          options.hour = n === 2 ? TWODIGIT : NUMERIC;
          break
        case 'm':
          options.minute = n === 2 ? TWODIGIT : NUMERIC;
          break
        case 's':
        case 'S':
          options.second = n === 2 ? TWODIGIT : NUMERIC;
          break
        case 'z':
        case 'Z':
        case 'v':
        case 'V':
          options.timeZoneName = n === 1 ? SHORT : LONG;
          break
      }
    }
    return Object.keys(options).length ? options : undefined
  }
};

// @flow
// "lookup" algorithm http://tools.ietf.org/html/rfc4647#section-3.4
// assumes normalized language tags, and matches in a case sensitive manner
var lookupClosestLocale = function lookupClosestLocale (locale/*: string | string[] | void */, available/*: { [string]: any } */)/*: ?string */ {
  if (typeof locale === 'string' && available[locale]) return locale
  var locales = [].concat(locale || []);
  for (var l = 0, ll = locales.length; l < ll; ++l) {
    var current = locales[l].split('-');
    while (current.length) {
      var candidate = current.join('-');
      if (available[candidate]) return candidate
      current.pop();
    }
  }
};

// @flow

/*:: export type Rule = 'zero' | 'one' | 'two' | 'few' | 'many' | 'other' */
var zero = 'zero', one = 'one', two = 'two', few = 'few', many = 'many', other = 'other';
var f$2 = [
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return 0 <= n && n <= 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var n = +s;
    return i === 0 || n === 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 0 ? zero
      : n === 1 ? one
      : n === 2 ? two
      : 3 <= n % 100 && n % 100 <= 10 ? few
      : 11 <= n % 100 && n % 100 <= 99 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    return i === 1 && v === 0 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n % 10 === 1 && n % 100 !== 11 ? one
      : (2 <= n % 10 && n % 10 <= 4) && (n % 100 < 12 || 14 < n % 100) ? few
      : n % 10 === 0 || (5 <= n % 10 && n % 10 <= 9) || (11 <= n % 100 && n % 100 <= 14) ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n % 10 === 1 && (n % 100 !== 11 && n % 100 !== 71 && n % 100 !== 91) ? one
      : n % 10 === 2 && (n % 100 !== 12 && n % 100 !== 72 && n % 100 !== 92) ? two
      : ((3 <= n % 10 && n % 10 <= 4) || n % 10 === 9) && ((n % 100 < 10 || 19 < n % 100) && (n % 100 < 70 || 79 < n % 100) && (n % 100 < 90 || 99 < n % 100)) ? few
      : n !== 0 && n % 1000000 === 0 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    var f = +(s + '.').split('.')[1];
    return v === 0 && i % 10 === 1 && i % 100 !== 11 || f % 10 === 1 && f % 100 !== 11 ? one
      : v === 0 && (2 <= i % 10 && i % 10 <= 4) && (i % 100 < 12 || 14 < i % 100) || (2 <= f % 10 && f % 10 <= 4) && (f % 100 < 12 || 14 < f % 100) ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    return i === 1 && v === 0 ? one
      : (2 <= i && i <= 4) && v === 0 ? few
      : v !== 0 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 0 ? zero
      : n === 1 ? one
      : n === 2 ? two
      : n === 3 ? few
      : n === 6 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var t = +('' + s).replace(/^[^.]*.?|0+$/g, '');
    var n = +s;
    return n === 1 || t !== 0 && (i === 0 || i === 1) ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    var f = +(s + '.').split('.')[1];
    return v === 0 && i % 100 === 1 || f % 100 === 1 ? one
      : v === 0 && i % 100 === 2 || f % 100 === 2 ? two
      : v === 0 && (3 <= i % 100 && i % 100 <= 4) || (3 <= f % 100 && f % 100 <= 4) ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    return i === 0 || i === 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    var f = +(s + '.').split('.')[1];
    return v === 0 && (i === 1 || i === 2 || i === 3) || v === 0 && (i % 10 !== 4 && i % 10 !== 6 && i % 10 !== 9) || v !== 0 && (f % 10 !== 4 && f % 10 !== 6 && f % 10 !== 9) ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : n === 2 ? two
      : 3 <= n && n <= 6 ? few
      : 7 <= n && n <= 10 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 || n === 11 ? one
      : n === 2 || n === 12 ? two
      : ((3 <= n && n <= 10) || (13 <= n && n <= 19)) ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    return v === 0 && i % 10 === 1 ? one
      : v === 0 && i % 10 === 2 ? two
      : v === 0 && (i % 100 === 0 || i % 100 === 20 || i % 100 === 40 || i % 100 === 60 || i % 100 === 80) ? few
      : v !== 0 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    var n = +s;
    return i === 1 && v === 0 ? one
      : i === 2 && v === 0 ? two
      : v === 0 && (n < 0 || 10 < n) && n % 10 === 0 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var t = +('' + s).replace(/^[^.]*.?|0+$/g, '');
    return t === 0 && i % 10 === 1 && i % 100 !== 11 || t !== 0 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : n === 2 ? two
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 0 ? zero
      : n === 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var n = +s;
    return n === 0 ? zero
      : (i === 0 || i === 1) && n !== 0 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var f = +(s + '.').split('.')[1];
    var n = +s;
    return n % 10 === 1 && (n % 100 < 11 || 19 < n % 100) ? one
      : (2 <= n % 10 && n % 10 <= 9) && (n % 100 < 11 || 19 < n % 100) ? few
      : f !== 0 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var v = (s + '.').split('.')[1].length;
    var f = +(s + '.').split('.')[1];
    var n = +s;
    return n % 10 === 0 || (11 <= n % 100 && n % 100 <= 19) || v === 2 && (11 <= f % 100 && f % 100 <= 19) ? zero
      : n % 10 === 1 && n % 100 !== 11 || v === 2 && f % 10 === 1 && f % 100 !== 11 || v !== 2 && f % 10 === 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    var f = +(s + '.').split('.')[1];
    return v === 0 && i % 10 === 1 && i % 100 !== 11 || f % 10 === 1 && f % 100 !== 11 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    var n = +s;
    return i === 1 && v === 0 ? one
      : v !== 0 || n === 0 || n !== 1 && (1 <= n % 100 && n % 100 <= 19) ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : n === 0 || (2 <= n % 100 && n % 100 <= 10) ? few
      : 11 <= n % 100 && n % 100 <= 19 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    return i === 1 && v === 0 ? one
      : v === 0 && (2 <= i % 10 && i % 10 <= 4) && (i % 100 < 12 || 14 < i % 100) ? few
      : v === 0 && i !== 1 && (0 <= i % 10 && i % 10 <= 1) || v === 0 && (5 <= i % 10 && i % 10 <= 9) || v === 0 && (12 <= i % 100 && i % 100 <= 14) ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    return 0 <= i && i <= 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    return v === 0 && i % 10 === 1 && i % 100 !== 11 ? one
      : v === 0 && (2 <= i % 10 && i % 10 <= 4) && (i % 100 < 12 || 14 < i % 100) ? few
      : v === 0 && i % 10 === 0 || v === 0 && (5 <= i % 10 && i % 10 <= 9) || v === 0 && (11 <= i % 100 && i % 100 <= 14) ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var n = +s;
    return i === 0 || n === 1 ? one
      : 2 <= n && n <= 10 ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var f = +(s + '.').split('.')[1];
    var n = +s;
    return (n === 0 || n === 1) || i === 0 && f === 1 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    var v = (s + '.').split('.')[1].length;
    return v === 0 && i % 100 === 1 ? one
      : v === 0 && i % 100 === 2 ? two
      : v === 0 && (3 <= i % 100 && i % 100 <= 4) || v !== 0 ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return (0 <= n && n <= 1) || (11 <= n && n <= 99) ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 || n === 5 || n === 7 || n === 8 || n === 9 || n === 10 ? one
      : n === 2 || n === 3 ? two
      : n === 4 ? few
      : n === 6 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    return (i % 10 === 1 || i % 10 === 2 || i % 10 === 5 || i % 10 === 7 || i % 10 === 8) || (i % 100 === 20 || i % 100 === 50 || i % 100 === 70 || i % 100 === 80) ? one
      : (i % 10 === 3 || i % 10 === 4) || (i % 1000 === 100 || i % 1000 === 200 || i % 1000 === 300 || i % 1000 === 400 || i % 1000 === 500 || i % 1000 === 600 || i % 1000 === 700 || i % 1000 === 800 || i % 1000 === 900) ? few
      : i === 0 || i % 10 === 6 || (i % 100 === 40 || i % 100 === 60 || i % 100 === 90) ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return (n % 10 === 2 || n % 10 === 3) && (n % 100 !== 12 && n % 100 !== 13) ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 || n === 3 ? one
      : n === 2 ? two
      : n === 4 ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 0 || n === 7 || n === 8 || n === 9 ? zero
      : n === 1 ? one
      : n === 2 ? two
      : n === 3 || n === 4 ? few
      : n === 5 || n === 6 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n % 10 === 1 && n % 100 !== 11 ? one
      : n % 10 === 2 && n % 100 !== 12 ? two
      : n % 10 === 3 && n % 100 !== 13 ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : n === 2 || n === 3 ? two
      : n === 4 ? few
      : n === 6 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 || n === 5 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 11 || n === 8 || n === 80 || n === 800 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    return i === 1 ? one
      : i === 0 || ((2 <= i % 100 && i % 100 <= 20) || i % 100 === 40 || i % 100 === 60 || i % 100 === 80) ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n % 10 === 6 || n % 10 === 9 || n % 10 === 0 && n !== 0 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var i = Math.floor(Math.abs(+s));
    return i % 10 === 1 && i % 100 !== 11 ? one
      : i % 10 === 2 && i % 100 !== 12 ? two
      : (i % 10 === 7 || i % 10 === 8) && (i % 100 !== 17 && i % 100 !== 18) ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : n === 2 || n === 3 ? two
      : n === 4 ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return 1 <= n && n <= 4 ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return (n === 1 || n === 5 || (7 <= n && n <= 9)) ? one
      : n === 2 || n === 3 ? two
      : n === 4 ? few
      : n === 6 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n === 1 ? one
      : n % 10 === 4 && n % 100 !== 14 ? many
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return (n % 10 === 1 || n % 10 === 2) && (n % 100 !== 11 && n % 100 !== 12) ? one
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return (n % 10 === 6 || n % 10 === 9) || n === 10 ? few
      : other
  },
  function (s/*: string | number */)/*: Rule */ {
    var n = +s;
    return n % 10 === 3 && n % 100 !== 13 ? few
      : other
  }
];

var plurals = {
  af: { cardinal: f$2[0] },
  ak: { cardinal: f$2[1] },
  am: { cardinal: f$2[2] },
  ar: { cardinal: f$2[3] },
  ars: { cardinal: f$2[3] },
  as: { cardinal: f$2[2], ordinal: f$2[34] },
  asa: { cardinal: f$2[0] },
  ast: { cardinal: f$2[4] },
  az: { cardinal: f$2[0], ordinal: f$2[35] },
  be: { cardinal: f$2[5], ordinal: f$2[36] },
  bem: { cardinal: f$2[0] },
  bez: { cardinal: f$2[0] },
  bg: { cardinal: f$2[0] },
  bh: { cardinal: f$2[1] },
  bn: { cardinal: f$2[2], ordinal: f$2[34] },
  br: { cardinal: f$2[6] },
  brx: { cardinal: f$2[0] },
  bs: { cardinal: f$2[7] },
  ca: { cardinal: f$2[4], ordinal: f$2[37] },
  ce: { cardinal: f$2[0] },
  cgg: { cardinal: f$2[0] },
  chr: { cardinal: f$2[0] },
  ckb: { cardinal: f$2[0] },
  cs: { cardinal: f$2[8] },
  cy: { cardinal: f$2[9], ordinal: f$2[38] },
  da: { cardinal: f$2[10] },
  de: { cardinal: f$2[4] },
  dsb: { cardinal: f$2[11] },
  dv: { cardinal: f$2[0] },
  ee: { cardinal: f$2[0] },
  el: { cardinal: f$2[0] },
  en: { cardinal: f$2[4], ordinal: f$2[39] },
  eo: { cardinal: f$2[0] },
  es: { cardinal: f$2[0] },
  et: { cardinal: f$2[4] },
  eu: { cardinal: f$2[0] },
  fa: { cardinal: f$2[2] },
  ff: { cardinal: f$2[12] },
  fi: { cardinal: f$2[4] },
  fil: { cardinal: f$2[13], ordinal: f$2[0] },
  fo: { cardinal: f$2[0] },
  fr: { cardinal: f$2[12], ordinal: f$2[0] },
  fur: { cardinal: f$2[0] },
  fy: { cardinal: f$2[4] },
  ga: { cardinal: f$2[14], ordinal: f$2[0] },
  gd: { cardinal: f$2[15] },
  gl: { cardinal: f$2[4] },
  gsw: { cardinal: f$2[0] },
  gu: { cardinal: f$2[2], ordinal: f$2[40] },
  guw: { cardinal: f$2[1] },
  gv: { cardinal: f$2[16] },
  ha: { cardinal: f$2[0] },
  haw: { cardinal: f$2[0] },
  he: { cardinal: f$2[17] },
  hi: { cardinal: f$2[2], ordinal: f$2[40] },
  hr: { cardinal: f$2[7] },
  hsb: { cardinal: f$2[11] },
  hu: { cardinal: f$2[0], ordinal: f$2[41] },
  hy: { cardinal: f$2[12], ordinal: f$2[0] },
  io: { cardinal: f$2[4] },
  is: { cardinal: f$2[18] },
  it: { cardinal: f$2[4], ordinal: f$2[42] },
  iu: { cardinal: f$2[19] },
  iw: { cardinal: f$2[17] },
  jgo: { cardinal: f$2[0] },
  ji: { cardinal: f$2[4] },
  jmc: { cardinal: f$2[0] },
  ka: { cardinal: f$2[0], ordinal: f$2[43] },
  kab: { cardinal: f$2[12] },
  kaj: { cardinal: f$2[0] },
  kcg: { cardinal: f$2[0] },
  kk: { cardinal: f$2[0], ordinal: f$2[44] },
  kkj: { cardinal: f$2[0] },
  kl: { cardinal: f$2[0] },
  kn: { cardinal: f$2[2] },
  ks: { cardinal: f$2[0] },
  ksb: { cardinal: f$2[0] },
  ksh: { cardinal: f$2[20] },
  ku: { cardinal: f$2[0] },
  kw: { cardinal: f$2[19] },
  ky: { cardinal: f$2[0] },
  lag: { cardinal: f$2[21] },
  lb: { cardinal: f$2[0] },
  lg: { cardinal: f$2[0] },
  ln: { cardinal: f$2[1] },
  lt: { cardinal: f$2[22] },
  lv: { cardinal: f$2[23] },
  mas: { cardinal: f$2[0] },
  mg: { cardinal: f$2[1] },
  mgo: { cardinal: f$2[0] },
  mk: { cardinal: f$2[24], ordinal: f$2[45] },
  ml: { cardinal: f$2[0] },
  mn: { cardinal: f$2[0] },
  mo: { cardinal: f$2[25], ordinal: f$2[0] },
  mr: { cardinal: f$2[2], ordinal: f$2[46] },
  mt: { cardinal: f$2[26] },
  nah: { cardinal: f$2[0] },
  naq: { cardinal: f$2[19] },
  nb: { cardinal: f$2[0] },
  nd: { cardinal: f$2[0] },
  ne: { cardinal: f$2[0], ordinal: f$2[47] },
  nl: { cardinal: f$2[4] },
  nn: { cardinal: f$2[0] },
  nnh: { cardinal: f$2[0] },
  no: { cardinal: f$2[0] },
  nr: { cardinal: f$2[0] },
  nso: { cardinal: f$2[1] },
  ny: { cardinal: f$2[0] },
  nyn: { cardinal: f$2[0] },
  om: { cardinal: f$2[0] },
  or: { cardinal: f$2[0], ordinal: f$2[48] },
  os: { cardinal: f$2[0] },
  pa: { cardinal: f$2[1] },
  pap: { cardinal: f$2[0] },
  pl: { cardinal: f$2[27] },
  prg: { cardinal: f$2[23] },
  ps: { cardinal: f$2[0] },
  pt: { cardinal: f$2[28] },
  'pt-PT': { cardinal: f$2[4] },
  rm: { cardinal: f$2[0] },
  ro: { cardinal: f$2[25], ordinal: f$2[0] },
  rof: { cardinal: f$2[0] },
  ru: { cardinal: f$2[29] },
  rwk: { cardinal: f$2[0] },
  saq: { cardinal: f$2[0] },
  scn: { cardinal: f$2[4], ordinal: f$2[42] },
  sd: { cardinal: f$2[0] },
  sdh: { cardinal: f$2[0] },
  se: { cardinal: f$2[19] },
  seh: { cardinal: f$2[0] },
  sh: { cardinal: f$2[7] },
  shi: { cardinal: f$2[30] },
  si: { cardinal: f$2[31] },
  sk: { cardinal: f$2[8] },
  sl: { cardinal: f$2[32] },
  sma: { cardinal: f$2[19] },
  smi: { cardinal: f$2[19] },
  smj: { cardinal: f$2[19] },
  smn: { cardinal: f$2[19] },
  sms: { cardinal: f$2[19] },
  sn: { cardinal: f$2[0] },
  so: { cardinal: f$2[0] },
  sq: { cardinal: f$2[0], ordinal: f$2[49] },
  sr: { cardinal: f$2[7] },
  ss: { cardinal: f$2[0] },
  ssy: { cardinal: f$2[0] },
  st: { cardinal: f$2[0] },
  sv: { cardinal: f$2[4], ordinal: f$2[50] },
  sw: { cardinal: f$2[4] },
  syr: { cardinal: f$2[0] },
  ta: { cardinal: f$2[0] },
  te: { cardinal: f$2[0] },
  teo: { cardinal: f$2[0] },
  ti: { cardinal: f$2[1] },
  tig: { cardinal: f$2[0] },
  tk: { cardinal: f$2[0], ordinal: f$2[51] },
  tl: { cardinal: f$2[13], ordinal: f$2[0] },
  tn: { cardinal: f$2[0] },
  tr: { cardinal: f$2[0] },
  ts: { cardinal: f$2[0] },
  tzm: { cardinal: f$2[33] },
  ug: { cardinal: f$2[0] },
  uk: { cardinal: f$2[29], ordinal: f$2[52] },
  ur: { cardinal: f$2[4] },
  uz: { cardinal: f$2[0] },
  ve: { cardinal: f$2[0] },
  vo: { cardinal: f$2[0] },
  vun: { cardinal: f$2[0] },
  wa: { cardinal: f$2[1] },
  wae: { cardinal: f$2[0] },
  xh: { cardinal: f$2[0] },
  xog: { cardinal: f$2[0] },
  yi: { cardinal: f$2[4] },
  zu: { cardinal: f$2[2] },
  lo: { ordinal: f$2[0] },
  ms: { ordinal: f$2[0] },
  vi: { ordinal: f$2[0] }
};

var formatMessageInterpret = createCommonjsModule$1(function (module, exports) {




/*::
import type {
  AST,
  SubMessages
} from '../format-message-parse'
type Locale = string
type Locales = Locale | Locale[]
type Placeholder = any[] // https://github.com/facebook/flow/issues/4050
export type Type = (Placeholder, Locales) => (any, ?Object) => any
export type Types = { [string]: Type }
*/

exports = module.exports = function interpret (
  ast/*: AST */,
  locale/*:: ?: Locales */,
  types/*:: ?: Types */
)/*: (args?: Object) => string */ {
  return interpretAST(ast, null, locale || 'en', types || {}, true)
};

exports.toParts = function toParts (
  ast/*: AST */,
  locale/*:: ?: Locales */,
  types/*:: ?: Types */
)/*: (args?: Object) => any[] */ {
  return interpretAST(ast, null, locale || 'en', types || {}, false)
};

function interpretAST (
  elements/*: any[] */,
  parent/*: ?Placeholder */,
  locale/*: Locales */,
  types/*: Types */,
  join/*: boolean */
)/*: Function */ {
  var parts = elements.map(function (element) {
    return interpretElement(element, parent, locale, types, join)
  });

  if (!join) {
    return function format (args) {
      return parts.reduce(function (parts, part) {
        return parts.concat(part(args))
      }, [])
    }
  }

  if (parts.length === 1) return parts[0]
  return function format (args) {
    var message = '';
    for (var e = 0; e < parts.length; ++e) {
      message += parts[e](args);
    }
    return message
  }
}

function interpretElement (
  element/*: Placeholder */,
  parent/*: ?Placeholder */,
  locale/*: Locales */,
  types/*: Types */,
  join/*: boolean */
)/*: Function */ {
  if (typeof element === 'string') {
    var value/*: string */ = element;
    return function format () { return value }
  }

  var id = element[0];
  var type = element[1];

  if (parent && element[0] === '#') {
    id = parent[0];
    var offset = parent[2];
    var formatter = (types.number || defaults.number)([ id, 'number' ], locale);
    return function format (args) {
      return formatter(getArg(id, args) - offset, args)
    }
  }

  // pre-process children
  var children;
  if (type === 'plural' || type === 'selectordinal') {
    children = {};
    Object.keys(element[3]).forEach(function (key) {
      children[key] = interpretAST(element[3][key], element, locale, types, join);
    });
    element = [ element[0], element[1], element[2], children ];
  } else if (element[2] && typeof element[2] === 'object') {
    children = {};
    Object.keys(element[2]).forEach(function (key) {
      children[key] = interpretAST(element[2][key], element, locale, types, join);
    });
    element = [ element[0], element[1], children ];
  }

  var getFrmt = type && (types[type] || defaults[type]);
  if (getFrmt) {
    var frmt = getFrmt(element, locale);
    return function format (args) {
      return frmt(getArg(id, args), args)
    }
  }

  return join
    ? function format (args) { return String(getArg(id, args)) }
    : function format (args) { return getArg(id, args) }
}

function getArg (id/*: string */, args/*: ?Object */)/*: any */ {
  if (args && (id in args)) return args[id]
  var parts = id.split('.');
  var a = args;
  for (var i = 0, ii = parts.length; a && i < ii; ++i) {
    a = a[parts[i]];
  }
  return a
}

function interpretNumber (element/*: Placeholder */, locales/*: Locales */) {
  var style = element[2];
  var options = formatMessageFormats.number[style] || formatMessageFormats.parseNumberPattern(style) || formatMessageFormats.number.default;
  return new Intl.NumberFormat(locales, options).format
}

function interpretDuration (element/*: Placeholder */, locales/*: Locales */) {
  var style = element[2];
  var options = formatMessageFormats.duration[style] || formatMessageFormats.duration.default;
  var fs = new Intl.NumberFormat(locales, options.seconds).format;
  var fm = new Intl.NumberFormat(locales, options.minutes).format;
  var fh = new Intl.NumberFormat(locales, options.hours).format;
  var sep = /^fi$|^fi-|^da/.test(String(locales)) ? '.' : ':';

  return function (s, args) {
    s = +s;
    if (!isFinite(s)) return fs(s)
    var h = ~~(s / 60 / 60); // ~~ acts much like Math.trunc
    var m = ~~(s / 60 % 60);
    var dur = (h ? (fh(Math.abs(h)) + sep) : '') +
      fm(Math.abs(m)) + sep + fs(Math.abs(s % 60));
    return s < 0 ? fh(-1).replace(fh(1), dur) : dur
  }
}

function interpretDateTime (element/*: Placeholder */, locales/*: Locales */) {
  var type = element[1];
  var style = element[2];
  var options = formatMessageFormats[type][style] || formatMessageFormats.parseDatePattern(style) || formatMessageFormats[type].default;
  return new Intl.DateTimeFormat(locales, options).format
}

function interpretPlural (element/*: Placeholder */, locales/*: Locales */) {
  var type = element[1];
  var pluralType = type === 'selectordinal' ? 'ordinal' : 'cardinal';
  var offset = element[2];
  var children = element[3];
  var pluralRules;
  if (Intl.PluralRules && Intl.PluralRules.supportedLocalesOf(locales).length > 0) {
    pluralRules = new Intl.PluralRules(locales, { type: pluralType });
  } else {
    var locale = lookupClosestLocale(locales, plurals);
    var select = (locale && plurals[locale][pluralType]) || returnOther;
    pluralRules = { select: select };
  }

  return function (value, args) {
    var clause =
      children['=' + +value] ||
      children[pluralRules.select(value - offset)] ||
      children.other;
    return clause(args)
  }
}

function returnOther (/*:: n:number */) { return 'other' }

function interpretSelect (element/*: Placeholder */, locales/*: Locales */) {
  var children = element[2];
  return function (value, args) {
    var clause = children[value] || children.other;
    return clause(args)
  }
}

var defaults/*: Types */ = {
  number: interpretNumber,
  ordinal: interpretNumber, // TODO: support rbnf
  spellout: interpretNumber, // TODO: support rbnf
  duration: interpretDuration,
  date: interpretDateTime,
  time: interpretDateTime,
  plural: interpretPlural,
  selectordinal: interpretPlural,
  select: interpretSelect
};
exports.types = defaults;
});
var formatMessageInterpret_1 = formatMessageInterpret.toParts;
var formatMessageInterpret_2 = formatMessageInterpret.types;

var formatMessageParse = createCommonjsModule$1(function (module, exports) {

/*::
export type AST = Element[]
export type Element = string | Placeholder
export type Placeholder = Plural | Styled | Typed | Simple
export type Plural = [ string, 'plural' | 'selectordinal', number, SubMessages ]
export type Styled = [ string, string, string | SubMessages ]
export type Typed = [ string, string ]
export type Simple = [ string ]
export type SubMessages = { [string]: AST }
export type Token = [ TokenType, string ]
export type TokenType = 'text' | 'space' | 'id' | 'type' | 'style' | 'offset' | 'number' | 'selector' | 'syntax'
type Context = {|
  pattern: string,
  index: number,
  tagsType: ?string,
  tokens: ?Token[]
|}
*/

var ARG_OPN = '{';
var ARG_CLS = '}';
var ARG_SEP = ',';
var NUM_ARG = '#';
var TAG_OPN = '<';
var TAG_CLS = '>';
var TAG_END = '</';
var TAG_SELF_CLS = '/>';
var ESC = '\'';
var OFFSET = 'offset:';
var simpleTypes = [
  'number',
  'date',
  'time',
  'ordinal',
  'duration',
  'spellout'
];
var submTypes = [
  'plural',
  'select',
  'selectordinal'
];

/**
 * parse
 *
 * Turns this:
 *  `You have { numBananas, plural,
 *       =0 {no bananas}
 *      one {a banana}
 *    other {# bananas}
 *  } for sale`
 *
 * into this:
 *  [ "You have ", [ "numBananas", "plural", 0, {
 *       "=0": [ "no bananas" ],
 *      "one": [ "a banana" ],
 *    "other": [ [ '#' ], " bananas" ]
 *  } ], " for sale." ]
 *
 * tokens:
 *  [
 *    [ "text", "You have " ],
 *    [ "syntax", "{" ],
 *    [ "space", " " ],
 *    [ "id", "numBananas" ],
 *    [ "syntax", ", " ],
 *    [ "space", " " ],
 *    [ "type", "plural" ],
 *    [ "syntax", "," ],
 *    [ "space", "\n     " ],
 *    [ "selector", "=0" ],
 *    [ "space", " " ],
 *    [ "syntax", "{" ],
 *    [ "text", "no bananas" ],
 *    [ "syntax", "}" ],
 *    [ "space", "\n    " ],
 *    [ "selector", "one" ],
 *    [ "space", " " ],
 *    [ "syntax", "{" ],
 *    [ "text", "a banana" ],
 *    [ "syntax", "}" ],
 *    [ "space", "\n  " ],
 *    [ "selector", "other" ],
 *    [ "space", " " ],
 *    [ "syntax", "{" ],
 *    [ "syntax", "#" ],
 *    [ "text", " bananas" ],
 *    [ "syntax", "}" ],
 *    [ "space", "\n" ],
 *    [ "syntax", "}" ],
 *    [ "text", " for sale." ]
 *  ]
 **/
exports = module.exports = function parse (
  pattern/*: string */,
  options/*:: ?: { tagsType?: string, tokens?: Token[] } */
)/*: AST */ {
  return parseAST({
    pattern: String(pattern),
    index: 0,
    tagsType: (options && options.tagsType) || null,
    tokens: (options && options.tokens) || null
  }, '')
};

function parseAST (current/*: Context */, parentType/*: string */)/*: AST */ {
  var pattern = current.pattern;
  var length = pattern.length;
  var elements/*: AST */ = [];
  var start = current.index;
  var text = parseText(current, parentType);
  if (text) elements.push(text);
  if (text && current.tokens) current.tokens.push([ 'text', pattern.slice(start, current.index) ]);
  while (current.index < length) {
    if (pattern[current.index] === ARG_CLS) {
      if (!parentType) throw expected(current)
      break
    }
    if (parentType && current.tagsType && pattern.slice(current.index, current.index + TAG_END.length) === TAG_END) break
    elements.push(parsePlaceholder(current));
    start = current.index;
    text = parseText(current, parentType);
    if (text) elements.push(text);
    if (text && current.tokens) current.tokens.push([ 'text', pattern.slice(start, current.index) ]);
  }
  return elements
}

function parseText (current/*: Context */, parentType/*: string */)/*: string */ {
  var pattern = current.pattern;
  var length = pattern.length;
  var isHashSpecial = (parentType === 'plural' || parentType === 'selectordinal');
  var isAngleSpecial = !!current.tagsType;
  var isArgStyle = (parentType === '{style}');
  var text = '';
  while (current.index < length) {
    var char = pattern[current.index];
    if (
      char === ARG_OPN || char === ARG_CLS ||
      (isHashSpecial && char === NUM_ARG) ||
      (isAngleSpecial && char === TAG_OPN) ||
      (isArgStyle && isWhitespace(char.charCodeAt(0)))
    ) {
      break
    } else if (char === ESC) {
      char = pattern[++current.index];
      if (char === ESC) { // double is always 1 '
        text += char;
        ++current.index;
      } else if (
        // only when necessary
        char === ARG_OPN || char === ARG_CLS ||
        (isHashSpecial && char === NUM_ARG) ||
        (isAngleSpecial && char === TAG_OPN) ||
        isArgStyle
      ) {
        text += char;
        while (++current.index < length) {
          char = pattern[current.index];
          if (char === ESC && pattern[current.index + 1] === ESC) { // double is always 1 '
            text += ESC;
            ++current.index;
          } else if (char === ESC) { // end of quoted
            ++current.index;
            break
          } else {
            text += char;
          }
        }
      } else { // lone ' is just a '
        text += ESC;
        // already incremented
      }
    } else {
      text += char;
      ++current.index;
    }
  }
  return text
}

function isWhitespace (code/*: number */)/*: boolean */ {
  return (
    (code >= 0x09 && code <= 0x0D) ||
    code === 0x20 || code === 0x85 || code === 0xA0 || code === 0x180E ||
    (code >= 0x2000 && code <= 0x200D) ||
    code === 0x2028 || code === 0x2029 || code === 0x202F || code === 0x205F ||
    code === 0x2060 || code === 0x3000 || code === 0xFEFF
  )
}

function skipWhitespace (current/*: Context */)/*: void */ {
  var pattern = current.pattern;
  var length = pattern.length;
  var start = current.index;
  while (current.index < length && isWhitespace(pattern.charCodeAt(current.index))) {
    ++current.index;
  }
  if (start < current.index && current.tokens) {
    current.tokens.push([ 'space', current.pattern.slice(start, current.index) ]);
  }
}

function parsePlaceholder (current/*: Context */)/*: Placeholder */ {
  var pattern = current.pattern;
  if (pattern[current.index] === NUM_ARG) {
    if (current.tokens) current.tokens.push([ 'syntax', NUM_ARG ]);
    ++current.index; // move passed #
    return [ NUM_ARG ]
  }

  var tag = parseTag(current);
  if (tag) return tag

  /* istanbul ignore if should be unreachable if parseAST and parseText are right */
  if (pattern[current.index] !== ARG_OPN) throw expected(current, ARG_OPN)
  if (current.tokens) current.tokens.push([ 'syntax', ARG_OPN ]);
  ++current.index; // move passed {
  skipWhitespace(current);

  var id = parseId(current);
  if (!id) throw expected(current, 'placeholder id')
  if (current.tokens) current.tokens.push([ 'id', id ]);
  skipWhitespace(current);

  var char = pattern[current.index];
  if (char === ARG_CLS) { // end placeholder
    if (current.tokens) current.tokens.push([ 'syntax', ARG_CLS ]);
    ++current.index; // move passed }
    return [ id ]
  }

  if (char !== ARG_SEP) throw expected(current, ARG_SEP + ' or ' + ARG_CLS)
  if (current.tokens) current.tokens.push([ 'syntax', ARG_SEP ]);
  ++current.index; // move passed ,
  skipWhitespace(current);

  var type = parseId(current);
  if (!type) throw expected(current, 'placeholder type')
  if (current.tokens) current.tokens.push([ 'type', type ]);
  skipWhitespace(current);
  char = pattern[current.index];
  if (char === ARG_CLS) { // end placeholder
    if (current.tokens) current.tokens.push([ 'syntax', ARG_CLS ]);
    if (type === 'plural' || type === 'selectordinal' || type === 'select') {
      throw expected(current, type + ' sub-messages')
    }
    ++current.index; // move passed }
    return [ id, type ]
  }

  if (char !== ARG_SEP) throw expected(current, ARG_SEP + ' or ' + ARG_CLS)
  if (current.tokens) current.tokens.push([ 'syntax', ARG_SEP ]);
  ++current.index; // move passed ,
  skipWhitespace(current);

  var arg;
  if (type === 'plural' || type === 'selectordinal') {
    var offset = parsePluralOffset(current);
    skipWhitespace(current);
    arg = [ id, type, offset, parseSubMessages(current, type) ];
  } else if (type === 'select') {
    arg = [ id, type, parseSubMessages(current, type) ];
  } else if (simpleTypes.indexOf(type) >= 0) {
    arg = [ id, type, parseSimpleFormat(current) ];
  } else { // custom placeholder type
    var index = current.index;
    var format/*: string | SubMessages */ = parseSimpleFormat(current);
    skipWhitespace(current);
    if (pattern[current.index] === ARG_OPN) {
      current.index = index; // rewind, since should have been submessages
      format = parseSubMessages(current, type);
    }
    arg = [ id, type, format ];
  }

  skipWhitespace(current);
  if (pattern[current.index] !== ARG_CLS) throw expected(current, ARG_CLS)
  if (current.tokens) current.tokens.push([ 'syntax', ARG_CLS ]);
  ++current.index; // move passed }
  return arg
}

function parseTag (current/*: Context */)/*: ?Placeholder */ {
  var tagsType = current.tagsType;
  if (!tagsType || current.pattern[current.index] !== TAG_OPN) return

  if (current.pattern.slice(current.index, current.index + TAG_END.length) === TAG_END) {
    throw expected(current, null, 'closing tag without matching opening tag')
  }
  if (current.tokens) current.tokens.push([ 'syntax', TAG_OPN ]);
  ++current.index; // move passed <

  var id = parseId(current, true);
  if (!id) throw expected(current, 'placeholder id')
  if (current.tokens) current.tokens.push([ 'id', id ]);
  skipWhitespace(current);

  if (current.pattern.slice(current.index, current.index + TAG_SELF_CLS.length) === TAG_SELF_CLS) {
    if (current.tokens) current.tokens.push([ 'syntax', TAG_SELF_CLS ]);
    current.index += TAG_SELF_CLS.length;
    return [ id, tagsType ]
  }
  if (current.pattern[current.index] !== TAG_CLS) throw expected(current, TAG_CLS)
  if (current.tokens) current.tokens.push([ 'syntax', TAG_CLS ]);
  ++current.index; // move passed >

  var children = parseAST(current, tagsType);

  var end = current.index;
  if (current.pattern.slice(current.index, current.index + TAG_END.length) !== TAG_END) throw expected(current, TAG_END + id + TAG_CLS)
  if (current.tokens) current.tokens.push([ 'syntax', TAG_END ]);
  current.index += TAG_END.length;
  var closeId = parseId(current, true);
  if (closeId && current.tokens) current.tokens.push([ 'id', closeId ]);
  if (id !== closeId) {
    current.index = end; // rewind for better error message
    throw expected(current, TAG_END + id + TAG_CLS, TAG_END + closeId + TAG_CLS)
  }
  skipWhitespace(current);
  if (current.pattern[current.index] !== TAG_CLS) throw expected(current, TAG_CLS)
  if (current.tokens) current.tokens.push([ 'syntax', TAG_CLS ]);
  ++current.index; // move passed >

  return [ id, tagsType, { children: children } ]
}

function parseId (current/*: Context */, isTag/*:: ?: boolean */)/*: string */ {
  var pattern = current.pattern;
  var length = pattern.length;
  var id = '';
  while (current.index < length) {
    var char = pattern[current.index];
    if (
      char === ARG_OPN || char === ARG_CLS || char === ARG_SEP ||
      char === NUM_ARG || char === ESC || isWhitespace(char.charCodeAt(0)) ||
      (isTag && (char === TAG_OPN || char === TAG_CLS || char === '/'))
    ) break
    id += char;
    ++current.index;
  }
  return id
}

function parseSimpleFormat (current/*: Context */)/*: string */ {
  var start = current.index;
  var style = parseText(current, '{style}');
  if (!style) throw expected(current, 'placeholder style name')
  if (current.tokens) current.tokens.push([ 'style', current.pattern.slice(start, current.index) ]);
  return style
}

function parsePluralOffset (current/*: Context */)/*: number */ {
  var pattern = current.pattern;
  var length = pattern.length;
  var offset = 0;
  if (pattern.slice(current.index, current.index + OFFSET.length) === OFFSET) {
    if (current.tokens) current.tokens.push([ 'offset', 'offset' ], [ 'syntax', ':' ]);
    current.index += OFFSET.length; // move passed offset:
    skipWhitespace(current);
    var start = current.index;
    while (current.index < length && isDigit(pattern.charCodeAt(current.index))) {
      ++current.index;
    }
    if (start === current.index) throw expected(current, 'offset number')
    if (current.tokens) current.tokens.push([ 'number', pattern.slice(start, current.index) ]);
    offset = +pattern.slice(start, current.index);
  }
  return offset
}

function isDigit (code/*: number */)/*: boolean */ {
  return (code >= 0x30 && code <= 0x39)
}

function parseSubMessages (current/*: Context */, parentType/*: string */)/*: SubMessages */ {
  var pattern = current.pattern;
  var length = pattern.length;
  var options/*: SubMessages */ = {};
  while (current.index < length && pattern[current.index] !== ARG_CLS) {
    var selector = parseId(current);
    if (!selector) throw expected(current, 'sub-message selector')
    if (current.tokens) current.tokens.push([ 'selector', selector ]);
    skipWhitespace(current);
    options[selector] = parseSubMessage(current, parentType);
    skipWhitespace(current);
  }
  if (!options.other && submTypes.indexOf(parentType) >= 0) {
    throw expected(current, null, null, '"other" sub-message must be specified in ' + parentType)
  }
  return options
}

function parseSubMessage (current/*: Context */, parentType/*: string */)/*: AST */ {
  if (current.pattern[current.index] !== ARG_OPN) throw expected(current, ARG_OPN + ' to start sub-message')
  if (current.tokens) current.tokens.push([ 'syntax', ARG_OPN ]);
  ++current.index; // move passed {
  var message = parseAST(current, parentType);
  if (current.pattern[current.index] !== ARG_CLS) throw expected(current, ARG_CLS + ' to end sub-message')
  if (current.tokens) current.tokens.push([ 'syntax', ARG_CLS ]);
  ++current.index; // move passed }
  return message
}

function expected (current/*: Context */, expected/*:: ?: ?string */, found/*:: ?: ?string */, message/*:: ?: string */) {
  var pattern = current.pattern;
  var lines = pattern.slice(0, current.index).split(/\r?\n/);
  var offset = current.index;
  var line = lines.length;
  var column = lines.slice(-1)[0].length;
  found = found || (
    (current.index >= pattern.length) ? 'end of message pattern'
      : (parseId(current) || pattern[current.index])
  );
  if (!message) message = errorMessage(expected, found);
  message += ' in ' + pattern.replace(/\r?\n/g, '\n');
  return new SyntaxError(message, expected, found, offset, line, column)
}

function errorMessage (expected/*: ?string */, found/* string */) {
  if (!expected) return 'Unexpected ' + found + ' found'
  return 'Expected ' + expected + ' but found ' + found
}

/**
 * SyntaxError
 *  Holds information about bad syntax found in a message pattern
 **/
function SyntaxError (message/*: string */, expected/*: ?string */, found/*: ?string */, offset/*: number */, line/*: number */, column/*: number */) {
  Error.call(this, message);
  this.name = 'SyntaxError';
  this.message = message;
  this.expected = expected;
  this.found = found;
  this.offset = offset;
  this.line = line;
  this.column = column;
}
SyntaxError.prototype = Object.create(Error.prototype);
exports.SyntaxError = SyntaxError;
});
var formatMessageParse_1 = formatMessageParse.SyntaxError;

var supportedExp = new RegExp(
  '^(' + Object.keys(plurals).join('|') + ')\\b'
);

/*::
import type { Types } from 'format-message-interpret'
import type { AST } from 'format-message-parse'
type Options = {
  types: Types
}
type Internals = {
  ast: AST,
  format: (args?: Object) => string,
  locale: string,
  locales?: string | string[],
  toParts?: (args?: Object) => any[],
  options?: Options
}
*/

var internals/*: WeakMap<MessageFormat, Internals> */ = new WeakMap();

/*!
 * Intl.MessageFormat prollyfill
 * Copyright(c) 2015 Andy VanWagoner
 * MIT licensed
 **/
function MessageFormat (
  pattern/*: string */,
  locales/*:: ?: string | string[] */,
  options/*:: ?: Options */
) {
  if (!(this instanceof MessageFormat) || internals.has(this)) {
    throw new TypeError('calling MessageFormat constructor without new is invalid')
  }
  var ast = formatMessageParse(pattern);
  internals.set(this, {
    ast: ast,
    format: formatMessageInterpret(ast, locales, options && options.types),
    locale: MessageFormat.supportedLocalesOf(locales)[0] || 'en',
    locales: locales,
    options: options
  });
}
var messageFormat = MessageFormat;

// $FlowFixMe It thinks `value` needs to be defined for format
Object.defineProperties(MessageFormat.prototype, {
  format: {
    configurable: true,
    get: function format () {
      var values = internals.get(this);
      if (!values) throw new TypeError('MessageFormat.prototype.format called on value that\'s not an object initialized as a MessageFormat')
      return values.format
    }
  },
  formatToParts: {
    configurable: true,
    writable: true,
    value: function formatToParts (args/*:: ?: Object */) {
      var values = internals.get(this);
      if (!values) throw new TypeError('MessageFormat.prototype.formatToParts called on value that\'s not an object initialized as a MessageFormat')
      var frmt = values.toParts || (values.toParts = formatMessageInterpret.toParts(
        values.ast,
        values.locales,
        values.options && values.options.types
      ));
      return frmt(args)
    }
  },
  resolvedOptions: {
    configurable: true,
    writable: true,
    value: function resolvedOptions () {
      var values = internals.get(this);
      if (!values) throw new TypeError('MessageFormat.prototype.resolvedOptions called on value that\'s not an object initialized as a MessageFormat')
      return {
        locale: values.locale
      }
    }
  }
});

/* istanbul ignore else */
if (typeof Symbol !== 'undefined') {
  Object.defineProperty(MessageFormat.prototype, Symbol.toStringTag, { value: 'Object' });
}

Object.defineProperties(MessageFormat, {
  supportedLocalesOf: {
    configurable: true,
    writable: true,
    value: function supportedLocalesOf (requestedLocales/*:: ?: string | string[] */) {
      return [].concat(
        Intl.NumberFormat.supportedLocalesOf(requestedLocales),
        Intl.DateTimeFormat.supportedLocalesOf(requestedLocales),
        Intl.PluralRules ? Intl.PluralRules.supportedLocalesOf(requestedLocales) : [],
        [].concat(requestedLocales || []).filter(function (locale) {
          return supportedExp.test(locale)
        })
      ).filter(function (v, i, a) { return a.indexOf(v) === i })
    }
  }
});

/**
 * @param {Object.<string, Object>} obj
 * @returns {boolean}
 */
function isLocalizeESModule(obj) {
  return !!(obj && obj.default && typeof obj.default === 'object' && Object.keys(obj).length === 1);
}

// @ts-expect-error [external]: no types for this package

/**
 * @typedef {import('../types/LocalizeMixinTypes').NamespaceObject} NamespaceObject
 */

/** @typedef {import('../types/LocalizeMixinTypes').DatePostProcessor} DatePostProcessor */
/** @typedef {import('../types/LocalizeMixinTypes').NumberPostProcessor} NumberPostProcessor */

/**
 * `LocalizeManager` manages your translations (includes loading)
 */
class LocalizeManager {
  // eslint-disable-line no-unused-vars
  constructor({
    autoLoadOnLocaleChange = false,
    fallbackLocale = '',
    showKeyAsFallback = false,
  } = {}) {
    /** @private */
    this.__delegationTarget = document.createDocumentFragment();
    /** @protected */
    this._autoLoadOnLocaleChange = !!autoLoadOnLocaleChange;
    /** @protected */
    this._fallbackLocale = fallbackLocale;
    /** @protected */
    this._showKeyAsFallback = showKeyAsFallback;

    /**
     * @type {Object.<string, Object.<string, Object>>}
     * @private
     */
    this.__storage = {};

    /**
     * @type {Map.<RegExp|string, function>}
     * @private
     */
    this.__namespacePatternsMap = new Map();

    /**
     * @type {Object.<string, function|null>}
     * @private
     */
    this.__namespaceLoadersCache = {};

    /**
     * @type {Object.<string, Object.<string, Promise.<Object|void>>>}
     * @private
     */
    this.__namespaceLoaderPromisesCache = {};

    this.formatNumberOptions = {
      returnIfNaN: '',
      /** @type {Map<string,DatePostProcessor>} */
      postProcessors: new Map(),
    };

    this.formatDateOptions = {
      /** @type {Map<string,DatePostProcessor>} */
      postProcessors: new Map(),
    };

    /**
     * Via html[data-localize-lang], developers are allowed to set the initial locale, without
     * having to worry about whether locale is initialized before 3rd parties like Google Translate.
     * When this value differs from html[lang], we assume the 3rd party took
     * control over the page language and we set this._langAttrSetByTranslationTool to html[lang]
     */
    const initialLocale = document.documentElement.getAttribute('data-localize-lang');

    /** @protected */
    this._supportExternalTranslationTools = Boolean(initialLocale);

    if (this._supportExternalTranslationTools) {
      this.locale = initialLocale || 'en-GB';
      this._setupTranslationToolSupport();
    }

    if (!document.documentElement.lang) {
      document.documentElement.lang = this.locale || 'en-GB';
    }

    /** @protected */
    this._setupHtmlLangAttributeObserver();
  }

  /** @protected */
  _setupTranslationToolSupport() {
    /**
     * This value allows for support for Google Translate (or other 3rd parties taking control
     * of the html[lang] attribute).
     *
     * Have the following scenario in mind:
     * 1. locale is initialized by developer via html[data-localize-lang="en-US"] and
     * html[lang="en-US"]. When localize is loaded (note that this also can be after step 2 below),
     * it will sync its initial state from html[data-localize-lang]
     * 2. Google Translate kicks in for the French language. It will set html[lang="fr"].
     * This new language is not one known by us, so we most likely don't have translations for
     * this file. Therefore, we do NOT sync this value to LocalizeManager. The manager should
     * still ask for known resources (in this case for locale 'en-US')
     * 3. locale is changed (think of a language dropdown)
     * It's a bit of a weird case, because we would not expect an end user to do this. If he/she
     * does, make sure that we do not go against Google Translate, so we maintain accessibility
     * (by not altering html[lang]). We detect this by reading _langAttrSetByTranslationTool:
     * when its value is null, we consider Google translate 'not active'.
     *
     * When Google Translate is turned off by the user (html[lang=auto]),
     * `localize.locale` will be synced to html[lang] again
     *
     * Keep in mind that all of the above also works with other tools than Google Translate,
     * but this is the most widely used tool and therefore used as an example.
     */
    this._langAttrSetByTranslationTool = document.documentElement.lang || null;
  }

  teardown() {
    this._teardownHtmlLangAttributeObserver();
  }

  /**
   * @returns {string}
   */
  get locale() {
    if (this._supportExternalTranslationTools) {
      return this.__locale || '';
    }
    return document.documentElement.lang;
  }

  /**
   * @param {string} value
   */
  set locale(value) {
    /** @type {string} */
    let oldLocale;
    if (this._supportExternalTranslationTools) {
      oldLocale = /** @type {string} */ (this.__locale);
      this.__locale = value;
      if (this._langAttrSetByTranslationTool === null) {
        this._setHtmlLangAttribute(value);
      }
    } else {
      oldLocale = document.documentElement.lang;
      this._setHtmlLangAttribute(value);
    }

    if (!value.includes('-')) {
      this.__handleLanguageOnly(value);
    }

    this._onLocaleChanged(value, oldLocale);
  }

  /**
   * @param {string} locale
   * @protected
   */
  _setHtmlLangAttribute(locale) {
    this._teardownHtmlLangAttributeObserver();
    document.documentElement.lang = locale;
    this._setupHtmlLangAttributeObserver();
  }

  /**
   * @param {string} value
   * @throws {Error} Language only locales are not allowed(Use 'en-GB' instead of 'en')
   * @private
   */
  // eslint-disable-next-line class-methods-use-this
  __handleLanguageOnly(value) {
    throw new Error(`
      Locale was set to ${value}.
      Language only locales are not allowed, please use the full language locale e.g. 'en-GB' instead of 'en'.
      See https://github.com/ing-bank/lion/issues/187 for more information.
    `);
  }

  /**
   * @returns {Promise.<Object|void>}
   */
  get loadingComplete() {
    if (typeof this.__namespaceLoaderPromisesCache[this.locale] === 'object') {
      return Promise.all(Object.values(this.__namespaceLoaderPromisesCache[this.locale]));
    }
    return Promise.resolve();
  }

  reset() {
    this.__storage = {};
    this.__namespacePatternsMap = new Map();
    this.__namespaceLoadersCache = {};
    this.__namespaceLoaderPromisesCache = {};
  }

  /**
   * @param {string} locale
   * @param {string} namespace
   * @param {object} data
   * @throws {Error} Namespace can be added only once, for a given locale
   */
  addData(locale, namespace, data) {
    if (this._isNamespaceInCache(locale, namespace)) {
      throw new Error(
        `Namespace "${namespace}" has been already added for the locale "${locale}".`,
      );
    }

    this.__storage[locale] = this.__storage[locale] || {};
    this.__storage[locale][namespace] = data;
  }

  /**
   * @param {RegExp|string} pattern
   * @param {function} loader
   */
  setupNamespaceLoader(pattern, loader) {
    this.__namespacePatternsMap.set(pattern, loader);
  }

  /**
   * @param {NamespaceObject[]} namespaces
   * @param {Object} [options]
   * @param {string} [options.locale]
   * @returns {Promise.<Object>}
   */
  loadNamespaces(namespaces, { locale } = {}) {
    return Promise.all(
      namespaces.map(
        /** @param {NamespaceObject} namespace */
        namespace => this.loadNamespace(namespace, { locale }),
      ),
    );
  }

  /**
   * @param {NamespaceObject} namespaceObj
   * @param {Object} [options]
   * @param {string} [options.locale]
   * @returns {Promise.<Object|void>}
   */
  loadNamespace(namespaceObj, { locale = this.locale } = { locale: this.locale }) {
    const isDynamicImport = typeof namespaceObj === 'object';

    const namespace = /** @type {string} */ (
      isDynamicImport ? Object.keys(namespaceObj)[0] : namespaceObj
    );

    if (this._isNamespaceInCache(locale, namespace)) {
      return Promise.resolve();
    }

    const existingLoaderPromise = this._getCachedNamespaceLoaderPromise(locale, namespace);
    if (existingLoaderPromise) {
      return existingLoaderPromise;
    }

    return this._loadNamespaceData(locale, namespaceObj, isDynamicImport, namespace);
  }

  /**
   * @param {string | string[]} keys
   * @param {Object.<string,?>} [vars]
   * @param {Object} [opts]
   * @param {string} [opts.locale]
   * @returns {string}
   */
  msg(keys, vars, opts = {}) {
    const locale = opts.locale ? opts.locale : this.locale;
    const message = this._getMessageForKeys(keys, locale);
    if (!message) {
      return '';
    }
    const formatter = new messageFormat(message, locale);
    return formatter.format(vars);
  }

  /** @protected */
  _setupHtmlLangAttributeObserver() {
    if (!this._htmlLangAttributeObserver) {
      this._htmlLangAttributeObserver = new MutationObserver(mutations => {
        mutations.forEach(mutation => {
          if (this._supportExternalTranslationTools) {
            if (document.documentElement.lang === 'auto') {
              // Google Translate is switched off
              this._langAttrSetByTranslationTool = null;
              this._setHtmlLangAttribute(this.locale);
            } else {
              this._langAttrSetByTranslationTool = document.documentElement.lang;
            }
          } else {
            this._onLocaleChanged(document.documentElement.lang, mutation.oldValue || '');
          }
        });
      });
    }
    this._htmlLangAttributeObserver.observe(document.documentElement, {
      attributes: true,
      attributeFilter: ['lang'],
      attributeOldValue: true,
    });
  }

  /** @protected */
  _teardownHtmlLangAttributeObserver() {
    if (this._htmlLangAttributeObserver) {
      this._htmlLangAttributeObserver.disconnect();
    }
  }

  /**
   * @param {string} locale
   * @param {string} namespace
   * @protected
   */
  _isNamespaceInCache(locale, namespace) {
    return !!(this.__storage[locale] && this.__storage[locale][namespace]);
  }

  /**
   * @param {string} locale
   * @param {string} namespace
   * @protected
   */
  _getCachedNamespaceLoaderPromise(locale, namespace) {
    if (this.__namespaceLoaderPromisesCache[locale]) {
      return this.__namespaceLoaderPromisesCache[locale][namespace];
    }
    return null;
  }

  /**
   * @param {string} locale
   * @param {NamespaceObject} namespaceObj
   * @param {boolean} isDynamicImport
   * @param {string} namespace
   * @returns {Promise.<Object|void>}
   * @protected
   */
  _loadNamespaceData(locale, namespaceObj, isDynamicImport, namespace) {
    const loader = this._getNamespaceLoader(namespaceObj, isDynamicImport, namespace);
    const loaderPromise = this._getNamespaceLoaderPromise(loader, locale, namespace);
    this._cacheNamespaceLoaderPromise(locale, namespace, loaderPromise);
    return loaderPromise.then(
      /**
       * @param {Object} obj
       * @param {Object} obj.default
       */
      obj => {
        // add data only if we have the promise in cache
        if (
          this.__namespaceLoaderPromisesCache[locale] &&
          this.__namespaceLoaderPromisesCache[locale][namespace] === loaderPromise
        ) {
          const data = isLocalizeESModule(obj) ? obj.default : obj;
          this.addData(locale, namespace, data);
        }
      },
    );
  }

  /**
   * @param {NamespaceObject} namespaceObj
   * @param {boolean} isDynamicImport
   * @param {string} namespace
   * @throws {Error} Namespace shall setup properly. Check loader!
   * @protected
   */
  _getNamespaceLoader(namespaceObj, isDynamicImport, namespace) {
    let loader = this.__namespaceLoadersCache[namespace];
    if (!loader) {
      if (isDynamicImport) {
        const _namespaceObj = /** @type {Object.<string,function>} */ (namespaceObj);
        loader = _namespaceObj[namespace];
        this.__namespaceLoadersCache[namespace] = loader;
      } else {
        loader = this._lookupNamespaceLoader(namespace);
        this.__namespaceLoadersCache[namespace] = loader;
      }
    }

    if (!loader) {
      throw new Error(`Namespace "${namespace}" was not properly setup.`);
    }

    this.__namespaceLoadersCache[namespace] = loader;

    return loader;
  }

  /**
   * @param {function} loader
   * @param {string} locale
   * @param {string} namespace
   * @param {string} [fallbackLocale]
   * @returns {Promise.<any>}
   * @throws {Error} Data for namespace and (locale or fallback locale) could not be loaded.
   * @protected
   */
  _getNamespaceLoaderPromise(loader, locale, namespace, fallbackLocale = this._fallbackLocale) {
    return loader(locale, namespace).catch(() => {
      const lang = this._getLangFromLocale(locale);
      return loader(lang, namespace).catch(() => {
        if (fallbackLocale) {
          return this._getNamespaceLoaderPromise(loader, fallbackLocale, namespace, '').catch(
            () => {
              const fallbackLang = this._getLangFromLocale(fallbackLocale);
              throw new Error(
                `Data for namespace "${namespace}" and current locale "${locale}" or fallback locale "${fallbackLocale}" could not be loaded. ` +
                  `Make sure you have data either for locale "${locale}" (and/or generic language "${lang}") or for fallback "${fallbackLocale}" (and/or "${fallbackLang}").`,
              );
            },
          );
        }
        throw new Error(
          `Data for namespace "${namespace}" and locale "${locale}" could not be loaded. ` +
            `Make sure you have data for locale "${locale}" (and/or generic language "${lang}").`,
        );
      });
    });
  }

  /**
   * @param {string} locale
   * @param {string} namespace
   * @param {Promise.<Object|void>} promise
   * @protected
   */
  _cacheNamespaceLoaderPromise(locale, namespace, promise) {
    if (!this.__namespaceLoaderPromisesCache[locale]) {
      this.__namespaceLoaderPromisesCache[locale] = {};
    }
    this.__namespaceLoaderPromisesCache[locale][namespace] = promise;
  }

  /**
   * @param {string} namespace
   * @returns {function|null}
   * @protected
   */
  _lookupNamespaceLoader(namespace) {
    /* eslint-disable no-restricted-syntax */
    for (const [key, value] of this.__namespacePatternsMap) {
      const isMatchingString = typeof key === 'string' && key === namespace;
      const isMatchingRegexp =
        typeof key === 'object' && key.constructor.name === 'RegExp' && key.test(namespace);
      if (isMatchingString || isMatchingRegexp) {
        return value;
      }
    }
    return null;
    /* eslint-enable no-restricted-syntax */
  }

  /**
   * @param {string} locale
   * @returns {string}
   * @protected
   */
  // eslint-disable-next-line class-methods-use-this
  _getLangFromLocale(locale) {
    return locale.substring(0, 2);
  }

  /**
   * @param {string} type
   * @param {EventListener} listener
   * @param {...Object} options
   */
  addEventListener(type, listener, ...options) {
    this.__delegationTarget.addEventListener(type, listener, ...options);
  }

  /**
   * @param {string} type
   * @param {EventListener} listener
   * @param {...Object} options
   */
  removeEventListener(type, listener, ...options) {
    this.__delegationTarget.removeEventListener(type, listener, ...options);
  }

  /**
   *  @param {CustomEvent} event
   */
  dispatchEvent(event) {
    this.__delegationTarget.dispatchEvent(event);
  }

  /**
   * @param {string} newLocale
   * @param {string} oldLocale
   * @returns {undefined}
   * @protected
   */
  _onLocaleChanged(newLocale, oldLocale) {
    // Event firing immediately, does not wait for loading the translations
    this.dispatchEvent(new CustomEvent('__localeChanging'));
    if (newLocale === oldLocale) {
      return;
    }
    if (this._autoLoadOnLocaleChange) {
      this._loadAllMissing(newLocale, oldLocale);
      this.loadingComplete.then(() => {
        this.dispatchEvent(new CustomEvent('localeChanged', { detail: { newLocale, oldLocale } }));
      });
    } else {
      this.dispatchEvent(new CustomEvent('localeChanged', { detail: { newLocale, oldLocale } }));
    }
  }

  /**
   * @param {string} newLocale
   * @param {string} oldLocale
   * @protected
   */
  _loadAllMissing(newLocale, oldLocale) {
    const oldLocaleNamespaces = this.__storage[oldLocale] || {};
    const newLocaleNamespaces = this.__storage[newLocale] || {};
    Object.keys(oldLocaleNamespaces).forEach(namespace => {
      const newNamespaceData = newLocaleNamespaces[namespace];
      if (!newNamespaceData) {
        this.loadNamespace(namespace, {
          locale: newLocale,
        });
      }
    });
  }

  /**
   * @param {string | string[]} keys
   * @param {string} locale
   * @returns {string | undefined}
   * @protected
   */
  _getMessageForKeys(keys, locale) {
    if (typeof keys === 'string') {
      return this._getMessageForKey(keys, locale);
    }
    const reversedKeys = Array.from(keys).reverse(); // Array.from prevents mutation of argument
    let key;
    let message;
    while (reversedKeys.length) {
      key = reversedKeys.pop();
      message = this._getMessageForKey(key, locale);
      if (message) {
        return message;
      }
    }
    return undefined;
  }

  /**
   * @param {string | undefined} key
   * @param {string} locale
   * @returns {string}
   * @throws {Error} `key`is missing namespace. The format for `key` is "namespace:name"
   * @protected
   *
   */
  _getMessageForKey(key, locale) {
    if (!key || key.indexOf(':') === -1) {
      throw new Error(
        `Namespace is missing in the key "${key}". The format for keys is "namespace:name".`,
      );
    }
    const [ns, namesString] = key.split(':');
    const namespaces = this.__storage[locale];
    const messages = namespaces ? namespaces[ns] : {};
    const names = namesString.split('.');
    const result = names.reduce(
      /**
       * @param {Object.<string, any> | string} message
       * @param {string} name
       * @returns {string}
       */
      (message, name) => (typeof message === 'object' ? message[name] : message),
      messages,
    );

    return String(result || (this._showKeyAsFallback ? key : ''));
  }

  /**
   * @param {{locale:string, postProcessor:DatePostProcessor}} options
   */
  setDatePostProcessorForLocale({ locale, postProcessor }) {
    this.formatDateOptions.postProcessors.set(locale, postProcessor);
  }

  /**
   * @param {{locale:string, postProcessor:NumberPostProcessor}} options
   */
  setNumberPostProcessorForLocale({ locale, postProcessor }) {
    this.formatNumberOptions.postProcessors.set(locale, postProcessor);
  }
}

/** @type {LocalizeManager} */
// eslint-disable-next-line import/no-mutable-exports
let localize =
  singletonManager.get('@lion/localize::localize::0.10.x') ||
  new LocalizeManager({
    autoLoadOnLocaleChange: true,
    fallbackLocale: 'en-GB',
  });

/**
 * @param {LocalizeManager} newLocalize
 */
function setLocalize(newLocalize) {
  localize.teardown();
  localize = newLocalize;
}

/**
 * Gets the locale to use
 *
 * @param {string} [locale] Locale to override browser locale
 * @returns {string}
 */
function getLocale(locale) {
  if (locale) {
    return locale;
  }
  if (localize && localize.locale) {
    return localize.locale;
  }
  return 'en-GB';
}

/**
 * To filter out some added characters in IE
 *
 * @param {string} str
 * @param {string} [locale='']
 * @param {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} [options] Intl options are available
 * @returns {string}
 */
function normalizeIntlDate(str, locale = '', { weekday, year, month, day } = {}) {
  const dateString = [];
  for (let i = 0, n = str.length; i < n; i += 1) {
    // remove unicode 160
    if (str.charCodeAt(i) === 160) {
      dateString.push(' ');
      // remove unicode 8206
    } else if (str.charCodeAt(i) === 8206) {
      dateString.push('');
    } else {
      dateString.push(str.charAt(i));
    }
  }

  const result = dateString.join('');

  // Normalize webkit date formatting without year
  if (!year && weekday === 'long' && month === 'long' && day === '2-digit') {
    const CHINESE_LOCALES = [
      // Webkit has a space while chrome and firefox not. Example: ("10月12日 星期六")
      'zh-CN',
      'zh-Hans',
      'zh-Hans-CN',
      'zh-Hans-HK',
      'zh-Hans-MO',
      'zh-Hans-SG',
      // Skip 'zh-Hant' and 'zh-Hant-TW', since webkit/firefox/chromium are aligned.
      // 'zh-Hant',
      // 'zh-Hant-TW',
      'zh-Hant-HK',
      'zh-Hant-MO',
    ];

    if (CHINESE_LOCALES.includes(locale)) {
      return result.replace(' ', '');
    }

    if (result.indexOf(',') === -1 && locale === 'en-GB') {
      // Saturday 12 October -> Saturday, 12 October
      const match = result.match(/^(\w*) (\d*) (\w*)$/);
      if (match !== null) {
        return `${match[1]}, ${match[2]} ${match[3]}`;
      }
    }

    if (result.indexOf(', ') !== -1 && locale === 'sk-SK') {
      // sobota, 12. októbra -> sobota 12. októbra
      return result.replace(', ', ' ');
    }

    if (locale === 'en-PH') {
      // Saturday, October 12 -> Saturday, 12 October
      const match = result.match(/^(\w*), (\w*) (\d*)$/);
      if (match !== null) {
        return `${match[1]}, ${match[3]} ${match[2]}`;
      }
    }
  }

  return result;
}

/** @typedef {import('../../types/LocalizeMixinTypes').DatePostProcessor} DatePostProcessor */

/**
 * Formats date based on locale and options
 *
 * @param {Date} date
 * @param {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} [options] Intl options are available
 * @returns {string}
 */
function formatDate$2(date, options) {
  if (!(date instanceof Date)) {
    return '';
  }

  const formatOptions =
    options ||
    /** @type {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} */ ({});
  /**
   * Set smart defaults if:
   * 1) no options object is passed
   * 2) options object is passed, but none of the following props on it: day, month, year.
   */
  if (!options || (options && !options.day && !options.month && !options.year)) {
    formatOptions.year = 'numeric';
    formatOptions.month = '2-digit';
    formatOptions.day = '2-digit';
  }
  const computedLocale = getLocale(formatOptions && formatOptions.locale);
  let formattedDate = '';
  try {
    formattedDate = new Intl.DateTimeFormat(computedLocale, formatOptions).format(date);
  } catch (e) {
    formattedDate = '';
  }

  if (localize.formatDateOptions.postProcessors.size > 0) {
    Array.from(localize.formatDateOptions.postProcessors).forEach(([locale, fn]) => {
      if (locale === computedLocale) {
        formattedDate = fn(formattedDate);
      }
    });
  }

  if (formatOptions.postProcessors && formatOptions.postProcessors.size > 0) {
    Array.from(formatOptions.postProcessors).forEach(([locale, fn]) => {
      if (locale === computedLocale) {
        formattedDate = fn(formattedDate);
      }
    });
  }

  return normalizeIntlDate(formattedDate, computedLocale, formatOptions);
}

/**
 * To trim the date
 *
 * @param {string} dateAsString
 * @returns {string}
 */
function trim(dateAsString) {
  return dateAsString.replace(/^[^\d]*/g, '').replace(/[^\d]*$/g, '');
}

/**
 * To clean date from added characters from IE
 *
 * @param {string} dateAsString
 * @returns {string}
 */
function clean(dateAsString) {
  // list of separators is from wikipedia https://www.wikiwand.com/en/Date_format_by_country
  // slash, point, dash or space
  return trim(dateAsString.replace(/[^\d-. /]/g, ''));
}

/**
 * To sanitize a date from IE11 handling
 *
 * @param {Date} date
 * @returns {string}
 */
function sanitizedDateTimeFormat(date) {
  const fDate = formatDate$2(date);
  return clean(fDate);
}

/**
 * To split a date into days, months, years, etc
 *
 * @param {string} dateAsString
 * @returns {ArrayLike.<string> | null}
 */
function splitDate(dateAsString) {
  return dateAsString.match(/(\d{1,4})([^\d]+)(\d{1,4})([^\d]+)(\d{1,4})/);
}

/**
 * To compute the localized date format
 * @returns {string}
 */
function getDateFormatBasedOnLocale() {
  /**
   *
   * @param {ArrayLike.<string>} dateParts
   * @returns {string[]}
   */
  function computePositions(dateParts) {
    /**
     * @param {number} index
     * @returns {string}
     */
    function getPartByIndex(index) {
      /** @type {Object.<string,string>} */
      const template = {
        2012: 'year',
        12: 'month',
        20: 'day',
      };
      const key = dateParts[index];
      return template[key];
    }

    return [1, 3, 5].map(getPartByIndex);
  }

  // Arbitrary date with different values for year,month,day
  const date = new Date();
  date.setDate(20);
  date.setMonth(11);
  date.setFullYear(2012);

  // Strange characters added by IE11 need to be taken into account here
  const formattedDate = sanitizedDateTimeFormat(date);

  // For Dutch locale, dateParts would match: [ 1:'20', 2:'-', 3:'12', 4:'-', 5:'2012' ]
  const dateParts = splitDate(formattedDate);

  const dateFormat = {};
  if (dateParts) {
    dateFormat.positions = computePositions(dateParts);
  }
  return `${dateFormat.positions[0]}-${dateFormat.positions[1]}-${dateFormat.positions[2]}`;
}

/**
 * @param {string[]} months
 */
function forceShortMonthNamesForEnGb(months) {
  if (months[8] === 'Sept') {
    // eslint-disable-next-line no-param-reassign
    months[8] = 'Sep';
  }
  return months;
}

/** @type {Object.<string, Object.<string,string[]>>} */
const monthsLocaleCache = {};

/**
 * @desc Returns month names for locale
 * @param {Object} [options]
 * @param {string} [options.locale] locale
 * @param {"long" | "numeric" | "2-digit" | "short" | "narrow"} [options.style=long] long, short or narrow
 * @returns {string[]} like: ['January', 'February', ...etc].
 */
function getMonthNames({ locale = 'en-GB', style = 'long' } = {}) {
  let months = monthsLocaleCache[locale] && monthsLocaleCache[locale][style];

  if (months) {
    return months;
  }

  months = [];

  const formatter = new Intl.DateTimeFormat(locale, { month: style });
  for (let i = 0; i < 12; i += 1) {
    const date = new Date(2019, i, 1);
    const formattedDate = formatter.format(date);
    const normalizedDate = normalizeIntlDate(formattedDate);
    months.push(normalizedDate);
  }
  if (locale === 'en-GB' && style === 'short') {
    months = forceShortMonthNamesForEnGb(months);
  }
  monthsLocaleCache[locale] = monthsLocaleCache[locale] || {};
  monthsLocaleCache[locale][style] = months;

  return months;
}

/** @type {Object.<string, Object.<string,string[]>>} */
const weekdayNamesCache = {};

/**
 * @desc Return cached weekday names for locale for all styles ('long', 'short', 'narrow')
 * @param {string} locale locale
 * @returns {Object.<string,string[]>} - like { long: ['Sunday', 'Monday'...], short: ['Sun', ...], narrow: ['S', ...] }
 */
function getCachedWeekdayNames(locale) {
  const cachedWeekdayNames = weekdayNamesCache[locale];
  let weekdays;

  if (cachedWeekdayNames) {
    return cachedWeekdayNames;
  }

  weekdayNamesCache[locale] = {
    long: [],
    short: [],
    narrow: [],
  };

  /** @type {Array<"long" | "short" | "narrow">} style */
  const styles = ['long', 'short', 'narrow'];
  styles.forEach(style => {
    weekdays = weekdayNamesCache[locale][style];
    const formatter = new Intl.DateTimeFormat(locale, {
      weekday: style,
    });

    const date = new Date('2019/04/07'); // start from Sunday
    for (let i = 0; i < 7; i += 1) {
      const weekday = formatter.format(date);
      const normalizedWeekday = normalizeIntlDate(weekday);
      weekdays.push(normalizedWeekday);
      date.setDate(date.getDate() + 1);
    }
  });

  return weekdayNamesCache[locale];
}

/**
 * @desc Returns weekday names for locale
 * @param {Object} [options]
 * @param {string} [options.locale] locale
 * @param {string} [options.style=long] long, short or narrow
 * @param {number} [options.firstDayOfWeek=0] 0 (Sunday), 1 (Monday), etc...
 * @returns {string[]} like: ['Sunday', 'Monday', 'Tuesday', ...etc].
 */
function getWeekdayNames({ locale = 'en-GB', style = 'long', firstDayOfWeek = 0 } = {}) {
  const weekdays = getCachedWeekdayNames(locale)[style];
  const orderedWeekdays = [];
  for (let i = firstDayOfWeek; i < firstDayOfWeek + 7; i += 1) {
    orderedWeekdays.push(weekdays[i % 7]);
  }
  return orderedWeekdays;
}

/**
 * @desc Makes suitable for date comparisons
 * @param {Date} date
 * @returns {Date}
 */
function normalizeDateTime(date) {
  return new Date(date.getFullYear(), date.getMonth(), date.getDate());
}

/**
 * To get the absolute value of a number.
 *
 * @param  {string} n - number in string format
 * @returns {string}
 */
function pad$1(n) {
  const digitRegex = /^\d+$/;
  const v = digitRegex.test(String(n)) ? Math.abs(Number(n)) : n;
  return String(v < 10 ? `0${v}` : v);
}

/**
 * To add a leading zero to a single number
 *
 * @param {string} dateString
 * @returns {string}
 */
function addLeadingZero(dateString) {
  const dateParts = splitDate(dateString);
  const delimiter = dateParts ? dateParts[2] : '';
  const dateArray =
    dateString.split && dateString.split(delimiter).filter(str => str.trim().length > 0);
  if (!dateArray || dateArray.length !== 3) {
    // prevent fail on invalid dates
    return '';
  }
  return dateArray.map(pad$1).join('-');
}

/**
 * @param {function} fn
 */
const memoize = fn => {
  /** @type {Object.<any, any>} */
  const cache = {};

  return /** @param {any} parm */ parm => {
    const n = parm;
    if (n in cache) {
      return cache[n];
    }
    const result = fn(n);
    cache[n] = result;
    return result;
  };
};

const memoizedGetDateFormatBasedOnLocale = memoize(getDateFormatBasedOnLocale);

/**
 * To parse a date into the right format
 *
 * @param {string} dateString
 * @returns {Date | undefined}
 */
function parseDate$1(dateString) {
  const stringToParse = addLeadingZero(dateString);
  let parsedString;

  switch (memoizedGetDateFormatBasedOnLocale(localize.locale)) {
    case 'day-month-year':
      parsedString = `${stringToParse.slice(6, 10)}/${stringToParse.slice(
        3,
        5,
      )}/${stringToParse.slice(0, 2)}`;
      break;
    case 'month-day-year':
      parsedString = `${stringToParse.slice(6, 10)}/${stringToParse.slice(
        0,
        2,
      )}/${stringToParse.slice(3, 5)}`;
      break;
    case 'year-month-day':
      parsedString = `${stringToParse.slice(0, 4)}/${stringToParse.slice(
        5,
        7,
      )}/${stringToParse.slice(8, 10)}`;
      break;
    default:
      parsedString = '0000/00/00';
  }

  const [year, month, day] = parsedString.split('/').map(Number);
  const parsedDate = new Date(Date.UTC(year, month - 1, day));

  // Check if parsedDate is not `Invalid Date` or that the date has changed (e.g. the not existing 31.02.2020)
  if (
    year > 0 &&
    month > 0 &&
    day > 0 &&
    parsedDate.getDate() === day &&
    parsedDate.getMonth() === month - 1
  ) {
    return parsedDate;
  }
  return undefined;
}

/**
 * @typedef {import('@lion/core').DirectiveResult} DirectiveResult
 * @typedef {import('../types/LocalizeMixinTypes').LocalizeMixin} LocalizeMixin
 */

/**
 * # LocalizeMixin - for self managed templates
 * @type {LocalizeMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const LocalizeMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class LocalizeMixin extends superclass {
    /**
     * @returns {Object.<string,function>[]}
     */
    static get localizeNamespaces() {
      return [];
    }

    /**
     * @returns {boolean}
     */
    static get waitForLocalizeNamespaces() {
      return true;
    }

    constructor() {
      super();

      /** @private */
      this.__boundLocalizeOnLocaleChanged =
        /** @param {...Object} args */
        (...args) => {
          const event = /** @type {CustomEvent} */ (Array.from(args)[0]);
          this.__localizeOnLocaleChanged(event);
        };

      this.__boundLocalizeOnLocaleChanging =
        /** @param {...Object} args */
        () => {
          this.__localizeOnLocaleChanging();
        };

      // should be loaded in advance
      /** @private */
      this.__localizeStartLoadingNamespaces();

      if (this.localizeNamespacesLoaded) {
        this.localizeNamespacesLoaded.then(() => {
          /** @private */
          this.__localizeMessageSync = true;
        });
      }
    }

    /**
     * hook into LitElement to only render once all translations are loaded
     * @returns {Promise.<void>}
     */
    async performUpdate() {
      if (Object.getPrototypeOf(this).constructor.waitForLocalizeNamespaces) {
        await this.localizeNamespacesLoaded;
      }
      super.performUpdate();
    }

    connectedCallback() {
      super.connectedCallback();
      if (this.localizeNamespacesLoaded) {
        this.localizeNamespacesLoaded.then(() => this.onLocaleReady());
      }
      localize.addEventListener('__localeChanging', this.__boundLocalizeOnLocaleChanging);
      localize.addEventListener('localeChanged', this.__boundLocalizeOnLocaleChanged);
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      localize.removeEventListener('__localeChanging', this.__boundLocalizeOnLocaleChanging);
      localize.removeEventListener('localeChanged', this.__boundLocalizeOnLocaleChanged);
    }

    /**
     * @param {string | string[]} keys
     * @param {Object.<string,?>} [variables]
     * @param {Object} [options]
     * @param {string} [options.locale]
     * @returns {string | DirectiveResult}
     */
    msgLit(keys, variables, options) {
      if (this.__localizeMessageSync) {
        return localize.msg(keys, variables, options);
      }

      if (!this.localizeNamespacesLoaded) {
        return '';
      }

      return m$1(
        this.localizeNamespacesLoaded.then(() => localize.msg(keys, variables, options)),
        A$1,
      );
    }

    /**
     * @returns {string[]}
     * @private
     */
    __getUniqueNamespaces() {
      /** @type {string[]} */
      const uniqueNamespaces = [];

      // IE11 does not support iterable in the constructor
      const s = new Set();
      Object.getPrototypeOf(this).constructor.localizeNamespaces.forEach(s.add.bind(s));
      s.forEach(uniqueNamespace => {
        uniqueNamespaces.push(uniqueNamespace);
      });
      return uniqueNamespaces;
    }

    /** @private */
    __localizeStartLoadingNamespaces() {
      this.localizeNamespacesLoaded = localize.loadNamespaces(this.__getUniqueNamespaces());
    }

    /**
     * Start loading namespaces on the event that is sent immediately
     * when localize.locale changes --> 'localeChanging'
     * @private
     */
    __localizeOnLocaleChanging() {
      this.__localizeStartLoadingNamespaces();
    }

    /**
     * @param {CustomEvent} event
     * @private
     */
    __localizeOnLocaleChanged(event) {
      this.onLocaleChanged(event.detail.newLocale, event.detail.oldLocale);
    }

    onLocaleReady() {
      this.onLocaleUpdated();
    }

    /**
     * @param {string} newLocale
     * @param {string} oldLocale
     */
    // eslint-disable-next-line no-unused-vars
    onLocaleChanged(newLocale, oldLocale) {
      this.onLocaleUpdated();
      this.requestUpdate();
    }

    // eslint-disable-next-line class-methods-use-this
    onLocaleUpdated() {}
  };

const LocalizeMixin = dedupeMixin(LocalizeMixinImplementation);

/**
 * When number is NaN we should return an empty string or returnIfNaN param
 *
 * @param {string|undefined} returnIfNaN
 * @returns {string}
 */
function emptyStringWhenNumberNan(returnIfNaN) {
  return returnIfNaN || localize.formatNumberOptions.returnIfNaN;
}

/**
 * To get the decimal separator
 *
 * @param {string} [locale] To override the browser locale
 * @returns {string} The separator
 */
function getDecimalSeparator(locale) {
  const computedLocale = getLocale(locale);
  const formattedNumber = Intl.NumberFormat(computedLocale, {
    style: 'decimal',
    minimumFractionDigits: 1,
  }).format(1);
  return formattedNumber[1];
}

/**
 * @param {string} value
 * @returns {string} value with forced "normal" space
 */
function normalSpaces(value) {
  // If non-breaking space (160) or narrow non-breaking space (8239) then return ' '
  return value.charCodeAt(0) === 160 || value.charCodeAt(0) === 8239 ? ' ' : value;
}

/**
 * Gets the group separator
 *
 * @param {string} [locale] To override the browser locale
 * @returns {string}
 */
function getGroupSeparator(locale) {
  const computedLocale = getLocale(locale);
  const formattedNumber = Intl.NumberFormat(computedLocale, {
    style: 'decimal',
    minimumFractionDigits: 0,
  }).format(10000);
  return normalSpaces(formattedNumber[2]);
}

/**
 * Add separators when they are not present
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @param {string} groupSeparator
 * @returns {FormatNumberPart[]}
 */
function forceAddGroupSeparators(formattedParts, groupSeparator) {
  /** @type {FormatNumberPart[]} */
  let concatArray = [];
  let firstPart;
  let integerPart;

  for (let i = 0; i < formattedParts.length; i += 1) {
    if (formattedParts[i].type === 'integer') {
      firstPart = formattedParts.splice(0, i);
      integerPart = formattedParts.splice(0, 1);
    }
  }
  if (integerPart !== undefined) {
    const numberOfDigits = integerPart[0].value.length;
    const mod3 = numberOfDigits % 3;
    const groups = Math.floor(numberOfDigits / 3);
    const numberArray = [];
    let numberOfGroups = 0;
    let numberPart = '';
    let firstGroup = false;
    // Loop through the  integer
    for (let i = 0; i < numberOfDigits; i += 1) {
      numberPart += integerPart[0].value[i];
      // Create first grouping which is < 3
      if (numberPart.length === mod3 && firstGroup === false) {
        numberArray.push({
          type: 'integer',
          value: numberPart,
        });
        if (numberOfDigits > 3) {
          numberArray.push({
            type: 'group',
            value: groupSeparator,
          });
        }
        numberPart = '';
        firstGroup = true;
        // Create groupings of 3
      } else if (numberPart.length === 3 && i < numberOfDigits - 1) {
        numberOfGroups += 1;
        numberArray.push({
          type: 'integer',
          value: numberPart,
        });
        if (numberOfGroups !== groups) {
          numberArray.push({
            type: 'group',
            value: groupSeparator,
          });
        }
        numberPart = '';
      }
    }
    numberArray.push({
      type: 'integer',
      value: numberPart,
    });
    if (firstPart) {
      concatArray = firstPart.concat(numberArray, formattedParts);
    }
  }
  return concatArray;
}

/**
 * For Dutch and Belgian amounts the currency should be at the end of the string
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @returns {FormatNumberPart[]}
 */
function forceCurrencyToEnd(formattedParts) {
  if (formattedParts[0].type === 'currency') {
    const moveCur = formattedParts.splice(0, 1);
    const moveLit = formattedParts.splice(0, 1);
    formattedParts.push(moveLit[0]);
    formattedParts.push(moveCur[0]);
  } else if (formattedParts[0].type === 'minusSign' && formattedParts[1].type === 'currency') {
    const moveCur = formattedParts.splice(1, 1);
    const moveLit = formattedParts.splice(1, 1);
    formattedParts.push(moveLit[0]);
    formattedParts.push(moveCur[0]);
  }
  return formattedParts;
}

/**
 * Parts with forced "normal" spaces
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @returns {FormatNumberPart[]}
 */
function forceNormalSpaces(formattedParts) {
  /** @type {FormatNumberPart[]} */
  const result = [];
  formattedParts.forEach(part => {
    result.push({
      type: part.type,
      value: normalSpaces(part.value),
    });
  });
  return result;
}

/**
 * When in some locales there is no space between currency and amount it is added
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @param {import('../../../../types/LocalizeMixinTypes').FormatNumberOptions} [options]
 * @returns {FormatNumberPart[]}
 */
function forceSpaceBetweenCurrencyCodeAndNumber(
  formattedParts,
  { currency, currencyDisplay } = {},
) {
  const numberOfParts = formattedParts.length;
  const literalObject = { type: 'literal', value: ' ' };
  if (numberOfParts > 1 && currency && currencyDisplay === 'code') {
    if (formattedParts[0].type === 'currency' && formattedParts[1].type !== 'literal') {
      // currency in front of a number: EUR 1.00
      formattedParts.splice(1, 0, literalObject);
    } else if (
      formattedParts[0].type === 'minusSign' &&
      formattedParts[1].type === 'currency' &&
      formattedParts[2].type !== 'literal'
    ) {
      // currency in front of a negative number: -EUR 1.00
      formattedParts.splice(2, 0, literalObject);
    } else if (
      formattedParts[numberOfParts - 1].type === 'currency' &&
      formattedParts[numberOfParts - 2].type !== 'literal'
    ) {
      // currency in behind a number: 1.00 EUR || -1.00 EUR
      formattedParts.splice(numberOfParts - 1, 0, literalObject);
    }
  }
  return formattedParts;
}

/**
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @param {import('../../../../types/LocalizeMixinTypes').FormatNumberOptions} [options]
 * @returns {FormatNumberPart[]}
 */
function forceYenSymbol(formattedParts, { currency, currencyDisplay } = {}) {
  const result = formattedParts;
  const numberOfParts = result.length;
  // Change the symbol from JPY to ¥, due to bug in Chrome
  if (numberOfParts > 1 && currency === 'JPY' && currencyDisplay === 'symbol') {
    result[numberOfParts - 1].value = '¥';
  }
  return result;
}

/**
 * @desc Intl uses 0 as group separator for bg-BG locale.
 * This should be a ' '
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @returns {FormatNumberPart[]} corrected formatted parts
 */
function forceSpaceInsteadOfZeroForGroup(formattedParts) {
  return formattedParts.map(p => {
    if (p.type === 'group' && p.value === '0') {
      p.value = ' '; // eslint-disable-line no-param-reassign
    }
    return p;
  });
}

/**
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @param {import('../../../../types/LocalizeMixinTypes').FormatNumberOptions} [options]
 * @returns {FormatNumberPart[]}
 */

function forceTryCurrencyCode(formattedParts, { currency, currencyDisplay } = {}) {
  const result = formattedParts;
  if (currency === 'TRY' && currencyDisplay === 'code') {
    result.map(part => {
      const newPart = part;
      if (part.type === 'currency') {
        newPart.value = 'TL';
      }
      return newPart;
    });
  }
  return result;
}

/** @type {Object.<string,string>} */
const CURRENCY_CODE_SYMBOL_MAP = {
  EUR: '€',
  USD: '$',
  JPY: '¥',
};

/**
 * Change the symbols for locale 'en-AU', due to bug in Chrome
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @param {import('../../../../types/LocalizeMixinTypes').FormatNumberOptions} [options]
 * @returns {FormatNumberPart[]}
 */
function forceENAUSymbols(formattedParts, { currency, currencyDisplay } = {}) {
  const result = formattedParts;
  if (formattedParts.length > 1 && currencyDisplay === 'symbol' && currency) {
    if (Object.keys(CURRENCY_CODE_SYMBOL_MAP).includes(currency)) {
      result[0].value = CURRENCY_CODE_SYMBOL_MAP[currency];
    }
    result[1].value = '';
  }
  return result;
}

/**
 * Normalizes function "formatNumberToParts"
 *
 * @typedef {import('../../../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {FormatNumberPart[]} formattedParts
 * @param {import('../../../../types/LocalizeMixinTypes').FormatNumberOptions} options
 * @param {string} _locale
 * @returns {FormatNumberPart[]}
 */
function normalizeIntl(formattedParts, options = {}, _locale) {
  let normalize = forceNormalSpaces(formattedParts);
  // Dutch and Belgian currency must be moved to end of number
  if (options.style === 'currency') {
    if (options.currencyDisplay === 'code' && _locale.slice(0, 2) === 'nl') {
      normalize = forceCurrencyToEnd(normalize);
    }
    // Add group separator for Bulgarian locale
    if (_locale === 'bg-BG') {
      normalize = forceAddGroupSeparators(normalize, getGroupSeparator());
      normalize = forceSpaceInsteadOfZeroForGroup(normalize);
    }
    // Force space between currency code and number
    if (_locale === 'en-GB' || _locale === 'en-US' || _locale === 'en-AU' || _locale === 'en-PH') {
      normalize = forceSpaceBetweenCurrencyCodeAndNumber(normalize, options);
    }
    // Force missing Japanese Yen symbol
    if (_locale === 'fr-FR' || _locale === 'fr-BE') {
      normalize = forceYenSymbol(normalize, options);
    }
    if (_locale === 'tr-TR') {
      normalize = forceTryCurrencyCode(normalize, options);
      if (options.currencyDisplay === 'code') {
        normalize = forceCurrencyToEnd(normalize);
      }
    }
    if (_locale === 'en-AU') {
      normalize = forceENAUSymbols(normalize, options);
    }
  }
  return normalize;
}

/**
 * Round the number based on the options
 *
 * @param {number} number
 * @param {string} roundMode
 * @throws {Error} roundMode can only be round|floor|ceiling
 * @returns {number}
 */
function roundNumber(number, roundMode) {
  switch (roundMode) {
    case 'floor':
      return Math.floor(number);
    case 'ceiling':
      return Math.ceil(number);
    case 'round':
      return Math.round(number);
    default:
      throw new Error('roundMode can only be round|floor|ceiling');
  }
}

/**
 * Splits a number up in parts for integer, fraction, group, literal, decimal and currency.
 *
 * @typedef {import('../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {number} number Number to split up
 * @param {import('../../types/LocalizeMixinTypes').FormatNumberOptions} [options] Intl options are available extended by roundMode,returnIfNaN
 * @returns {string | FormatNumberPart[]} Array with parts or (an empty string or returnIfNaN if not a number)
 */
function formatNumberToParts(number, options = {}) {
  let parsedNumber = typeof number === 'string' ? parseFloat(number) : number;
  const computedLocale = getLocale(options && options.locale);
  // when parsedNumber is not a number we should return an empty string or returnIfNaN
  if (Number.isNaN(parsedNumber)) {
    return emptyStringWhenNumberNan(options && options.returnIfNaN);
  }
  // If roundMode is given the number is rounded based upon the mode
  if (options && options.roundMode) {
    parsedNumber = roundNumber(number, options.roundMode);
  }
  let formattedParts = [];

  const formattedNumber = Intl.NumberFormat(computedLocale, options).format(parsedNumber);
  const regexCurrency = /[.,\s0-9]/;
  const regexMinusSign = /[-]/; // U+002D, Hyphen-Minus, &#45;
  const regexNum = /[0-9]/;
  const regexSeparator = /[.,]/;
  const regexSpace = /[\s]/;
  let currency = '';
  let numberPart = '';
  let fraction = false;
  for (let i = 0; i < formattedNumber.length; i += 1) {
    // detect minusSign
    if (regexMinusSign.test(formattedNumber[i])) {
      formattedParts.push({ type: 'minusSign', value: '−' /* U+2212, 'Minus-Sign', &minus; */ });
    }
    // detect numbers
    if (regexNum.test(formattedNumber[i])) {
      numberPart += formattedNumber[i];
    }

    // detect currency (symbol or code)
    if (!regexCurrency.test(formattedNumber[i]) && !regexMinusSign.test(formattedNumber[i])) {
      currency += formattedNumber[i];
    }
    // push when another character then currency
    if (regexCurrency.test(formattedNumber[i]) && currency) {
      formattedParts.push({ type: 'currency', value: currency });
      currency = '';
    }

    // detect dot and comma separators
    if (regexSeparator.test(formattedNumber[i])) {
      // Write number grouping
      if (numberPart) {
        formattedParts.push({ type: 'integer', value: numberPart });
        numberPart = '';
      }
      const decimal = getDecimalSeparator(computedLocale);
      if (formattedNumber[i] === decimal) {
        formattedParts.push({ type: 'decimal', value: formattedNumber[i] });
        fraction = true;
      } else {
        formattedParts.push({ type: 'group', value: formattedNumber[i] });
      }
    }
    // detect literals (empty spaces) or space group separator
    if (regexSpace.test(formattedNumber[i])) {
      const group = getGroupSeparator(computedLocale);
      const hasNumberPart = !!numberPart;
      // Write number grouping
      if (numberPart && !fraction) {
        formattedParts.push({ type: 'integer', value: numberPart });
        numberPart = '';
      } else if (numberPart) {
        formattedParts.push({ type: 'fraction', value: numberPart });
        numberPart = '';
      }
      // If space equals the group separator it gets type group
      if (normalSpaces(formattedNumber[i]) === group && hasNumberPart && !fraction) {
        formattedParts.push({ type: 'group', value: formattedNumber[i] });
      } else {
        formattedParts.push({ type: 'literal', value: formattedNumber[i] });
      }
    }
    // Numbers after the decimal sign are fractions, write the last
    // fractions at the end of the number
    if (fraction === true && i === formattedNumber.length - 1) {
      // write last number part
      if (numberPart) {
        formattedParts.push({ type: 'fraction', value: numberPart });
      }
      // If there are no fractions but we reached the end write the number part as integer
    } else if (i === formattedNumber.length - 1 && numberPart) {
      formattedParts.push({ type: 'integer', value: numberPart });
    }
    // push currency on end of loop
    if (i === formattedNumber.length - 1 && currency) {
      formattedParts.push({ type: 'currency', value: currency });
      currency = '';
    }
  }
  formattedParts = normalizeIntl(formattedParts, options, computedLocale);
  return formattedParts;
}

/** @typedef {import('../../types/LocalizeMixinTypes').NumberPostProcessor} NumberPostProcessor */

/**
 * Formats a number based on locale and options. It uses Intl for the formatting.
 *
 * @typedef {import('../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @typedef {import('@lion/localize/types/LocalizeMixinTypes').FormatNumberOptions} FormatOptions
 * @param {number} number Number to be formatted
 * @param {FormatOptions} [options] Intl options are available extended by roundMode and returnIfNaN
 * @returns {string}
 */
function formatNumber(number, options = /** @type {FormatOptions} */ ({})) {
  if (number === undefined || number === null) return '';
  const formattedToParts = formatNumberToParts(number, options);
  // If number is not a number
  if (
    formattedToParts === options.returnIfNaN ||
    formattedToParts === localize.formatNumberOptions.returnIfNaN
  ) {
    return /** @type {string} */ (formattedToParts);
  }
  let printNumberOfParts = '';
  // update numberOfParts because there may be some parts added
  const numberOfParts = formattedToParts && formattedToParts.length;
  for (let i = 0; i < numberOfParts; i += 1) {
    const part = /** @type {FormatNumberPart} */ (formattedToParts[i]);
    printNumberOfParts += part.value;
  }

  const computedLocale = getLocale(options && options.locale);

  if (localize.formatNumberOptions.postProcessors.size > 0) {
    Array.from(localize.formatNumberOptions.postProcessors).forEach(([locale, fn]) => {
      if (locale === computedLocale) {
        printNumberOfParts = fn(printNumberOfParts);
      }
    });
  }

  if (options.postProcessors && options.postProcessors.size > 0) {
    Array.from(options.postProcessors).forEach(([locale, fn]) => {
      if (locale === computedLocale) {
        printNumberOfParts = fn(printNumberOfParts);
      }
    });
  }

  return printNumberOfParts;
}

/**
 * @param {string} currencyName
 */
function forceCurrencyNameForPHPEnGB(currencyName) {
  if (currencyName === 'Philippine pesos') {
    // eslint-disable-next-line no-param-reassign
    currencyName = 'Philippine pisos';
  }
  return currencyName;
}

/**
 * Based on number, returns currency name like 'US dollar'
 *
 * @typedef {import('../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {string} currencyIso iso code like USD
 * @param {import('../../types/LocalizeMixinTypes').FormatNumberOptions} [options] Intl options are available extended by roundMode
 * @returns {string} currency name like 'US dollar'
 */
function getCurrencyName(currencyIso, options) {
  const parts = /** @type {FormatNumberPart[]} */ (
    formatNumberToParts(1, {
      ...options,
      style: 'currency',
      currency: currencyIso,
      currencyDisplay: 'name',
    })
  );
  let currencyName = parts
    .filter(p => p.type === 'currency')
    .map(o => o.value)
    .join(' ');
  const locale = options?.locale || localize.locale;
  if (currencyIso === 'PHP' && locale === 'en-GB') {
    currencyName = forceCurrencyNameForPHPEnGB(currencyName);
  }
  return currencyName;
}

/**
 * @example
 * getFractionDigits('JOD'); // return 3
 *
 * @typedef {import('../../types/LocalizeMixinTypes').FormatNumberPart} FormatNumberPart
 * @param {string} [currency="EUR"] Currency code e.g. EUR
 * @returns {number} fraction for the given currency
 */
function getFractionDigits(currency = 'EUR') {
  const parts = /** @type {FormatNumberPart[]} */ (
    formatNumberToParts(123, {
      style: 'currency',
      currency,
    })
  );
  const [fractionPart] = parts.filter(part => part.type === 'fraction');
  return fractionPart ? fractionPart.value.length : 0;
}

/**
 * For Turkey fixes currency label with locale options
 *
 * @param {string} currency
 * @param {string} locale
 * @returns {string}
 */
function normalizeCurrencyLabel(currency, locale) {
  return currency === 'TRY' && locale === 'tr-TR' ? 'TL' : currency;
}

/**
 * @param {string} value to evaluate
 * @return {boolean} true if value equal . or ,
 */
function isDecimalSeparator(value) {
  return value === '.' || value === ',';
}

/**
 * Determines the best possible parsing mode.
 *
 * - If there is only one separator (withLocale)
 * - 1,23 => xxx1.23 (heuristic)
 * - else parse mode depends mostly on the last 4 chars
 * - 1234 => xxx1234 (heuristic)
 * - [space]123 => xxx123 (heuristic)
 * - ,123 => unclear
 *   - if 1.000,123 (we find a different separator) => 1000.123 (heuristic)
 *   - if 1,000,123 (we find only same separators) => 1000123 (unparseable)
 *   - if 100,123 (we find no more separators) => unclear
 *     - if en => 100123 (withLocale)
 *     - if nl => 100.123 (withLocale)
 *
 * See also {@link parseAmount}
 *
 * @example
 * getParseMode('1.234') => 'withLocale'
 *
 * @param {string} value Clean number (only [0-9 ,.]) to be parsed
 * @return {string} unparseable|withLocale|heuristic
 */
function getParseMode(value, { mode = 'auto' } = {}) {
  const separators = value.match(/[., ]/g);

  if (mode === 'auto' && separators && separators.length === 1) {
    return 'withLocale';
  }

  if (value.length > 4) {
    const charAtLastSeparatorPosition = value[value.length - 4];
    if (isDecimalSeparator(charAtLastSeparatorPosition)) {
      const firstPart = value.substring(0, value.length - 4);
      const otherSeparators = firstPart.match(/[., ]/g);
      if (otherSeparators) {
        const lastSeparator = charAtLastSeparatorPosition;
        return otherSeparators.indexOf(lastSeparator) === -1 ? 'heuristic' : 'unparseable';
      }
      return 'withLocale';
    }
  }
  return 'heuristic';
}

/**
 * Parses numbers by considering the locale.
 * Useful for numbers with an ending pair of 3 number chars as in this case you can not be
 * certain if it is a group or comma separator. e.g. 1.234; 1,234; 1234.567;
 * Taking into consideration the locale we make the best possible assumption.
 *
 * @example
 * parseWithLocale('1.234', { locale: 'en-GB' }) => 1.234
 * parseWithLocale('1,234', { locale: 'en-GB' }) => 1234
 *
 * @param {string} value Number to be parsed
 * @param {Object} options Locale Options
 * @param {string} [options.locale]
 */
function parseWithLocale(value, options) {
  const locale = options && options.locale ? options.locale : undefined;
  const separator = getDecimalSeparator(locale);
  const regexNumberAndLocaleSeparator = new RegExp(`[0-9${separator}-]`, 'g');
  let numberAndLocaleSeparator = value.match(regexNumberAndLocaleSeparator)?.join('');
  if (separator === ',') {
    numberAndLocaleSeparator = numberAndLocaleSeparator?.replace(',', '.');
  }
  if (!numberAndLocaleSeparator) {
    return NaN;
  }
  return parseFloat(numberAndLocaleSeparator);
}

/**
 * Parses numbers by considering all separators.
 * It only keeps the last separator and uses it as decimal separator.
 *
 * Warning: This function works only with numbers that can be heuristically parsed.
 *
 * @param {string} value Number that can be heuristically parsed
 * @return {number} parsed javascript number
 */
function parseHeuristic(value) {
  if (value.match(/[0-9., ]/g)) {
    // 1. put placeholder at decimal separator
    const numberString = value
      .replace(/(,|\.)([^,|.]*)$/g, '_decSep_$2')
      .replace(/(,|\.| )/g, '') // 2. remove all thousand separators
      .replace(/_decSep_/, '.'); // 3. restore decimal separator
    return parseFloat(numberString);
  }
  return 0;
}

/**
 * Parses a number string and returns the best possible javascript number.
 * For edge cases it may use locale to give the best possible assumption.
 *
 * It has 3 "methods" of returning numbers
 * - 'unparseable': becomes just numbers
 * - 'withLocale': result depends on given or global locale
 * - 'heuristic': result depends on considering separators
 *
 * @example
 * parseNumber('1.234.567'); // method: unparseable => 1234567
 * parseNumber('1.234'); // method: withLocale => depending on locale 1234 or 1.234
 * parseNumber('1.234,56'); // method: heuristic => 1234.56
 * parseNumber('1 234.56'); // method: heuristic => 1234.56
 * parseNumber('1,234.56'); // method: heuristic => 1234.56
 *
 * @param {string} value Number to be parsed
 * @param {object} [options] Locale Options
 */
function parseNumber(value, options) {
  const containsNumbers = value.match(/\d/g);
  if (!containsNumbers) {
    return undefined;
  }
  const matchedInput = value.match(/[0-9,.\- ]/g);
  if (!matchedInput) {
    return undefined;
  }
  const cleanedInput = matchedInput.join('');
  const parseMode = getParseMode(cleanedInput, options);
  switch (parseMode) {
    case 'unparseable': {
      const cleanedInputMatchStr = cleanedInput.match(/[0-9]/g)?.join('');
      if (!cleanedInputMatchStr) {
        return NaN;
      }
      return parseFloat(cleanedInputMatchStr);
    }
    case 'withLocale':
      return parseWithLocale(cleanedInput, options || {});
    case 'heuristic':
      return parseHeuristic(cleanedInput);
    default:
      return 0;
  }
}

// TODO: still needed? It can be solved with while loop as well

/**
 * Use the `.add` method to add async functions to the queue
 * Await the `.complete` if you want to ensure the queue is empty at any point
 * `complete` resolves whenever no more tasks are running.
 * Important note: Currently runs tasks 1 by 1, there is no concurrency option at the moment
 */
class AsyncQueue {
  constructor() {
    this.__running = false;
    /** @type {function[]} */
    this.__queue = [];
  }

  /**
   *
   * @param {function} task
   */
  add(task) {
    this.__queue.push(task);
    if (!this.__running) {
      // We have a new queue, because before there was nothing in the queue
      this.complete = new Promise(resolve => {
        /** @type {function} */
        this.__callComplete = resolve;
      });
      this.__run();
    }
  }

  /** @private */
  async __run() {
    this.__running = true;
    await this.__queue[0]();
    this.__queue.shift();
    if (this.__queue.length > 0) {
      this.__run();
    } else {
      this.__running = false;
      if (this.__callComplete) {
        this.__callComplete();
      }
    }
  }
}

/**
 * Return PascalCased version of the camelCased string
 *
 * @param {string} str
 * @return {string}
 */
function pascalCase(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
}

// TODO: will be moved to @Lion/core later?

/**
 * @typedef {import('../../types/utils/SyncUpdatableMixinTypes').SyncUpdatableMixin} SyncUpdatableMixin
 * @typedef {import('../../types/utils/SyncUpdatableMixinTypes').SyncUpdatableNamespace} SyncUpdatableNamespace
 */

/**
 * Why this mixin?
 * - it adheres to the "Member Order Independence" web components standard:
 * https://github.com/webcomponents/gold-standard/wiki/Member-Order-Independence
 * - sync observers can be dependent on the outcome of the render function (or, more generically
 * speaking, the light and shadow dom). This aligns with the 'updated' callback that is supported
 * out of the box by LitElement, which runs after connectedCallback as well.
 * - makes the propertyAccessor.`hasChanged` compatible in synchronous updates:
 * `updateSync` will only be called when new value differs from old value.
 * See: https://lit-element.polymer-project.org/guide/lifecycle#haschanged
 * - it is a stable abstraction on top of a protected/non official lifecycle LitElement api.
 * Whenever the implementation of `requestUpdate` changes (this happened in the past for
 * `requestUpdate`) we only have to change our abstraction instead of all our components
 * @type {SyncUpdatableMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const SyncUpdatableMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends superclass {
    constructor() {
      super();

      /**
       * Namespace for this mixin that guarantees naming clashes will not occur...
       * @type {SyncUpdatableNamespace}
       */
      this.__SyncUpdatableNamespace = {};
    }

    /**
     * Empty pending queue in order to guarantee order independence
     *
     * @param {import('lit-element').PropertyValues } changedProperties
     */
    firstUpdated(changedProperties) {
      super.firstUpdated(changedProperties);
      this.__syncUpdatableInitialize();
    }

    connectedCallback() {
      super.connectedCallback();
      this.__SyncUpdatableNamespace.connected = true;
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      this.__SyncUpdatableNamespace.connected = false;
    }

    /**
     * Makes the propertyAccessor.`hasChanged` compatible in synchronous updates
     * @param {string} name
     * @param {*} newValue
     * @param {*} oldValue
     * @private
     */
    static __syncUpdatableHasChanged(name, newValue, oldValue) {
      // @ts-expect-error [external]: accessing private lit property
      const properties = this.elementProperties;
      if (properties.get(name) && properties.get(name).hasChanged) {
        return properties.get(name).hasChanged(newValue, oldValue);
      }
      return newValue !== oldValue;
    }

    /** @private */
    __syncUpdatableInitialize() {
      const ns = this.__SyncUpdatableNamespace;
      const ctor =
        /** @type {typeof SyncUpdatableMixin & typeof import('../../types/utils/SyncUpdatableMixinTypes').SyncUpdatableHost} */ (
          this.constructor
        );

      ns.initialized = true;
      // Empty queue...
      if (ns.queue) {
        Array.from(ns.queue).forEach(name => {
          // @ts-ignore [allow-private] in test
          if (ctor.__syncUpdatableHasChanged(name, this[name], undefined)) {
            this.updateSync(name, undefined);
          }
        });
      }
    }

    /**
     * @param {string} name
     * @param {*} oldValue
     */
    requestUpdate(name, oldValue) {
      super.requestUpdate(name, oldValue);

      this.__SyncUpdatableNamespace = this.__SyncUpdatableNamespace || {};
      const ns = this.__SyncUpdatableNamespace;

      const ctor =
        /** @type {typeof SyncUpdatableMixin & typeof import('../../types/utils/SyncUpdatableMixinTypes').SyncUpdatableHost} */ (
          this.constructor
        );
      // Before connectedCallback: queue
      if (!ns.initialized) {
        ns.queue = ns.queue || new Set();
        // Makes sure that we only initialize one time, with most up to date value
        ns.queue.add(name);
      } // After connectedCallback: guarded proxy to updateSync
      // @ts-ignore [allow-private] in test
      else if (ctor.__syncUpdatableHasChanged(name, this[name], oldValue)) {
        this.updateSync(name, oldValue);
      }
    }

    /**
     * An abstraction that has the exact same api as `requestUpdate`, but taking
     * into account:
     * - [member order independence](https://github.com/webcomponents/gold-standard/wiki/Member-Order-Independence)
     * - property effects start when all (light) dom has initialized (on firstUpdated)
     * - property effects don't interrupt the first meaningful paint
     * - compatible with propertyAccessor.`hasChanged`: no manual checks needed or accidentally
     * run property effects / events when no change happened
     * effects when values didn't change
     * All code previously present in requestUpdate can be placed in this method.
     * @param {string} name
     * @param {*} oldValue
     */
    updateSync(name, oldValue) {} // eslint-disable-line class-methods-use-this, no-unused-vars
  };

const SyncUpdatableMixin = dedupeMixin(SyncUpdatableMixinImplementation);

/**
 * @typedef {import('../validate/Validator').Validator} Validator
 * @typedef {import('@lion/core').TemplateResult} TemplateResult
 * @typedef {Object} messageMap
 * @property {string | Node} message
 * @property {string} type
 * @property {Validator} [validator]
 */

/**
 * @desc Takes care of accessible rendering of error messages
 * Should be used in conjunction with FormControl having ValidateMixin applied
 */
class LionValidationFeedback extends s$5 {
  static get properties() {
    return {
      feedbackData: { attribute: false },
    };
  }

  /**
   * @overridable
   * @param {Object} opts
   * @param {string | Node | TemplateResult } opts.message message or feedback node or TemplateResult
   * @param {string} [opts.type]
   * @param {Validator} [opts.validator]
   * @protected
   */
  // eslint-disable-next-line class-methods-use-this
  _messageTemplate({ message }) {
    return message;
  }

  /**
   * @param {import('@lion/core').PropertyValues } changedProperties
   */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (this.feedbackData && this.feedbackData[0]) {
      this.setAttribute('type', this.feedbackData[0].type);
      this.currentType = this.feedbackData[0].type;
      window.clearTimeout(this.removeMessage);
      // TODO: this logic should be in ValidateMixin, so that [show-feedback-for] is in sync,
      // plus duration should be configurable
      if (this.currentType === 'success') {
        this.removeMessage = window.setTimeout(() => {
          this.removeAttribute('type');
          /** @type {messageMap[]} */
          this.feedbackData = [];
        }, 3000);
      }
    } else if (this.currentType !== 'success') {
      this.removeAttribute('type');
    }
  }

  render() {
    return x$1`
      ${this.feedbackData &&
      this.feedbackData.map(
        ({ message, type, validator }) => x$1`
          ${this._messageTemplate({ message, type, validator })}
        `,
      )}
    `;
  }
}

/**
 * @typedef {object} MessageData
 * @property {*} [MessageData.modelValue]
 * @property {string} [MessageData.fieldName]
 * @property {HTMLElement} [MessageData.formControl]
 * @property {string} [MessageData.type]
 * @property {Object.<string,?>} [MessageData.config]
 * @property {string} [MessageData.name]
 */

class Validator {
  /**
   *
   * @param {?} [param]
   * @param {Object.<string,?>} [config]
   */
  constructor(param, config) {
    this.__fakeExtendsEventTarget();

    /** @type {?} */
    this.__param = param;

    /** @type {Object.<string,?>} */
    this.__config = config || {};
    this.type = (config && config.type) || 'error'; // Default type supported by ValidateMixin
  }

  static get validatorName() {
    return '';
  }

  static get async() {
    return false;
  }

  /**
   * @desc The function that returns a Boolean
   * @param {?} [modelValue]
   * @param {?} [param]
   * @param {{}} [config]
   * @returns {Boolean|Promise<Boolean>}
   */
  // eslint-disable-next-line no-unused-vars, class-methods-use-this
  execute(modelValue, param, config) {
    const ctor = /** @type {typeof Validator} */ (this.constructor);
    if (!ctor.validatorName) {
      throw new Error(
        'A validator needs to have a name! Please set it via "static get validatorName() { return \'IsCat\'; }"',
      );
    }
    return true;
  }

  set param(p) {
    this.__param = p;
    if (this.dispatchEvent) {
      this.dispatchEvent(new Event('param-changed'));
    }
  }

  get param() {
    return this.__param;
  }

  set config(c) {
    this.__config = c;
    if (this.dispatchEvent) {
      this.dispatchEvent(new Event('config-changed'));
    }
  }

  get config() {
    return this.__config;
  }

  /**
   * @overridable
   * @param {MessageData} [data]
   * @returns {Promise<string|Node>}
   * @protected
   */
  async _getMessage(data) {
    const ctor = /** @type {typeof Validator} */ (this.constructor);
    const composedData = {
      name: ctor.validatorName,
      type: this.type,
      params: this.param,
      config: this.config,
      ...data,
    };
    if (this.config.getMessage) {
      if (typeof this.config.getMessage === 'function') {
        return this.config.getMessage(composedData);
      }
      throw new Error(
        `You must provide a value for getMessage of type 'function', you provided a value of type: ${typeof this
          .config.getMessage}`,
      );
    }
    return ctor.getMessage(composedData);
  }

  /**
   * @overridable
   * @param {MessageData} [data]
   * @returns {Promise<string|Node>}
   */
  // eslint-disable-next-line no-unused-vars
  static async getMessage(data) {
    return `Please configure an error message for "${this.name}" by overriding "static async getMessage()"`;
  }

  /**
   * @param {HTMLElement} formControl
   */
  onFormControlConnect(formControl) {} // eslint-disable-line

  /**
   * @param {HTMLElement} formControl
   */
  onFormControlDisconnect(formControl) {} // eslint-disable-line

  /**
   * @desc Used on async Validators, makes it able to do perf optimizations when there are
   * pending "execute" calls with outdated values.
   * ValidateMixin calls Validator.abortExecution() an async Validator can act accordingly,
   * depending on its implementation of the "execute" function.
   * - For instance, when fetch was called:
   * https://stackoverflow.com/questions/31061838/how-do-i-cancel-an-http-fetch-request
   * - Or, when a webworker was started, its process could be aborted and then restarted.
   */
  abortExecution() {} // eslint-disable-line

  /**
   * @private
   */
  __fakeExtendsEventTarget() {
    const delegate = document.createDocumentFragment();

    /**
     *
     * @param {string} type
     * @param {EventListener} listener
     * @param {Object} [opts]
     */
    const delegatedAddEventListener = (type, listener, opts) =>
      delegate.addEventListener(type, listener, opts);

    /**
     * @param {string} type
     * @param {EventListener} listener
     * @param {Object} [opts]
     */
    const delegatedRemoveEventListener = (type, listener, opts) =>
      delegate.removeEventListener(type, listener, opts);

    /**
     * @param {Event|CustomEvent} event
     */
    const delegatedDispatchEvent = event => delegate.dispatchEvent(event);

    this.addEventListener = delegatedAddEventListener;

    this.removeEventListener = delegatedRemoveEventListener;

    this.dispatchEvent = delegatedDispatchEvent;
  }
}

// For simplicity, a default validator only handles one state:
// it can either be true or false an it will only have one message.
// In more advanced cases (think of the feedback mechanism for the maximum number of
// characters in Twitter), more states are needed. The alternative of
// having multiple distinct validators would be cumbersome to create and maintain,
// also because the validations would tie too much into each others logic.

/**
 * @desc Instead of evaluating the result of a regular validator, a ResultValidator looks
 * at the total result of regular Validators. Instead of an execute function, it uses a
 * 'executeOnResults' Validator.
 * ResultValidators cannot be async, and should not contain an execute method.
 */
class ResultValidator extends Validator {
  /**
   * @param {Object} context
   * @param {Validator[]} context.regularValidationResult
   * @param {Validator[]} context.prevValidationResult
   * @param {Validator[]} context.prevShownValidationResult
   * @param {Validator[]} [context.validators]
   * @returns {boolean}
   */
  /* eslint-disable no-unused-vars */
  // eslint-disable-next-line class-methods-use-this
  executeOnResults({
    regularValidationResult,
    prevValidationResult,
    prevShownValidationResult,
    validators,
  }) {
    /* eslint-enable no-unused-vars */
    return true;
  }
}

/**
 * @typedef {import('../../../types/FormControlMixinTypes.js').FormControlHost} FormControlHost
 */

class Required$1 extends Validator {
  static get validatorName() {
    return 'Required';
  }

  /**
   * In order to prevent accessibility violations, the aria-required attribute will
   * be combined with compatible aria roles: https://www.w3.org/TR/wai-aria/#aria-required
   */
  static get _compatibleRoles() {
    return [
      'combobox',
      'gridcell',
      'input',
      'listbox',
      'radiogroup',
      'select',
      'spinbutton',
      'textarea',
      'textbox',
      'tree',
    ];
  }

  /**
   * In order to prevent accessibility violations, the aria-required attribute will
   * be combined with compatible platform input elements
   */
  static get _compatibleTags() {
    return ['input', 'select', 'textarea'];
  }

  /**
   * We don't have an execute function, since the Required validator is 'special'.
   * The outcome depends on the modelValue of the FormControl and
   * FormControl.__isEmpty / FormControl._isEmpty.
   */

  /**
   * @param {FormControlHost & HTMLElement} formControl
   */
  // @ts-ignore [allow-protected] we are allowed to know FormControl protcected props in form-core
  // eslint-disable-next-line class-methods-use-this
  onFormControlConnect({ _inputNode: inputNode }) {
    if (inputNode) {
      const role = inputNode.getAttribute('role') || '';
      const elementTagName = inputNode.tagName.toLowerCase();
      const ctor = /** @type {typeof Required} */ (this.constructor);
      if (ctor._compatibleRoles.includes(role) || ctor._compatibleTags.includes(elementTagName)) {
        inputNode.setAttribute('aria-required', 'true');
      }
    }
  }

  /**
   * @param {FormControlHost & HTMLElement} formControl
   */
  // @ts-ignore [allow-protected] we are allowed to know FormControl protcected props in form-core
  // eslint-disable-next-line class-methods-use-this
  onFormControlDisconnect({ _inputNode: inputNode }) {
    if (inputNode) {
      inputNode.removeAttribute('aria-required');
    }
  }
}

/* eslint-disable class-methods-use-this, camelcase, no-param-reassign, max-classes-per-file */

// TODO: [v1] make all @readOnly => @readonly and actually make sure those values cannot be set

/**
 * @typedef {import('../../types/validate/ValidateMixinTypes').ValidateMixin} ValidateMixin
 * @typedef {import('../../types/validate/ValidateMixinTypes').ValidationType} ValidationType
 */

/**
 * @param {any[]} array1
 * @param {any[]} array2
 */
function arrayDiff(array1 = [], array2 = []) {
  return array1.filter(x => !array2.includes(x)).concat(array2.filter(x => !array1.includes(x)));
}

/**
 * Handles all validation, based on modelValue changes. It has no knowledge about dom and
 * UI. All error visibility, dom interaction and accessibility are handled in FeedbackMixin.
 *
 * @type {ValidateMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const ValidateMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends FormControlMixin(
    SyncUpdatableMixin(DisabledMixin(SlotMixin(ScopedElementsMixin(superclass)))),
  ) {
    static get scopedElements() {
      const scopedElementsCtor =
        /** @type {typeof import('@open-wc/scoped-elements/src/types').ScopedElementsHost} */ (
          super.constructor
        );
      return {
        ...scopedElementsCtor.scopedElements,
        'lion-validation-feedback': LionValidationFeedback,
      };
    }

    /** @type {any} */
    static get properties() {
      return {
        validators: { attribute: false },
        hasFeedbackFor: { attribute: false },
        shouldShowFeedbackFor: { attribute: false },
        showsFeedbackFor: {
          type: Array,
          attribute: 'shows-feedback-for',
          reflect: true,
          converter: {
            fromAttribute: /** @param {string} value */ value => value.split(','),
            toAttribute: /** @param {[]} value */ value => value.join(','),
          },
        },
        validationStates: { attribute: false },
        isPending: {
          type: Boolean,
          attribute: 'is-pending',
          reflect: true,
        },
        defaultValidators: { attribute: false },
        _visibleMessagesAmount: { attribute: false },
        __childModelValueChanged: { attribute: false },
      };
    }

    /**
     * Types of validation supported by this FormControl (for instance 'error'|'warning'|'info')
     * @overridable
     * @type {ValidationType[]}
     */
    static get validationTypes() {
      return ['error'];
    }

    /**
     * @overridable
     * Adds "._feedbackNode" as described below
     */
    get slots() {
      /**
       * FIXME: Ugly workaround https://github.com/microsoft/TypeScript/issues/40110
       * @callback getScopedTagName
       * @param {string} tagName
       * @returns {string}
       *
       * @typedef {Object} ScopedElementsObj
       * @property {getScopedTagName} getScopedTagName
       */
      return {
        ...super.slots,
        feedback: () => {
          // @ts-ignore we load a polyfill to support createElement on shadowRoot
          const feedbackEl = this.shadowRoot.createElement('lion-validation-feedback');
          feedbackEl.setAttribute('data-tag-name', 'lion-validation-feedback');
          return feedbackEl;
        },
      };
    }

    /**
     * Combination of validators provided by Application Developer and the default validators
     * @type {Validator[]}
     * @protected
     */
    get _allValidators() {
      return [...this.validators, ...this.defaultValidators];
    }

    constructor() {
      super();

      /**
       * As soon as validation happens (after modelValue/validators/validator param change), this
       * array is updated with the active ValidationTypes ('error'|'warning'|'success'|'info' etc.).
       * Notice the difference with `.showsFeedbackFor`, which filters `.hasFeedbackFor` based on
       * `.feedbackCondition()`.
       *
       * For styling purposes, will be reflected to [has-feedback-for="error warning"]. This can
       * be useful for subtle visual feedback on keyup, like a red/green border around an input.
       *
       * @example
       * ```css
       * :host([has-feedback-for~="error"]) .input-group__container {
       *   border: 1px solid red;
       * }
       * ```
       * @type {ValidationType[]}
       * @readOnly
       */
      this.hasFeedbackFor = [];

      /**
       * Based on outcome of feedbackCondition, this array decides what ValidationTypes should be
       * shown in validationFeedback, based on meta data like interaction states.
       *
       * For styling purposes, it reflects it `[shows-feedback-for="error warning"]`
       * @type {ValidationType[]}
       * @readOnly
       * @example
       * ```css
       * :host([shows-feedback-for~="success"]) .form-field__feedback {
       *   transform: scaleY(1);
       * }
       * ```
       */
      this.showsFeedbackFor = [];

      // TODO: [v1] make this fully private (preifix __)?
      /**
       * A temporary storage to transition from hasFeedbackFor to showsFeedbackFor
       * @type {ValidationType[]}
       * @readOnly
       * @private
       */
      this.shouldShowFeedbackFor = [];

      /**
       * The outcome of a validation 'round'. Keyed by ValidationType and Validator name
       * @readOnly
       * @type {Object.<string, Object.<string, boolean>>}
       */
      this.validationStates = {};

      /**
       * Flag indicating whether async validation is pending.
       * Creates attribute [is-pending] as a styling hook
       * @type {boolean}
       */
      this.isPending = false;

      /**
       * Used by Application Developers to add Validators to a FormControl.
       * @example
       * ```html
       * <form-control .validators="${[new Required(), new MinLength(4, {type: 'warning'})]}">
       * </form-control>
       * ```
       * @type {Validator[]}
       */
      this.validators = [];

      /**
       * Used by Subclassers to add default Validators to a particular FormControl.
       * A date input for instance, always needs the isDate validator.
       * @example
       * ```js
       * this.defaultValidators.push(new IsDate());
       * ```
       * @type {Validator[]}
       */
      this.defaultValidators = [];

      /**
       * The amount of feedback messages that will visible in LionValidationFeedback
       * @protected
       */
      this._visibleMessagesAmount = 1;

      /**
       * @type {Validator[]}
       * @private
       */
      this.__syncValidationResult = [];

      /**
       * @type {Validator[]}
       * @private
       */
      this.__asyncValidationResult = [];

      /**
       * Aggregated result from sync Validators, async Validators and ResultValidators
       * @type {Validator[]}
       * @private
       */
      this.__validationResult = [];

      /**
       * @type {Validator[]}
       * @private
       */
      this.__prevValidationResult = [];

      /**
       * @type {Validator[]}
       * @private
       */
      this.__prevShownValidationResult = [];

      /**
       * The updated children validity affects the validity of the parent. Helper to recompute
       * validatity of parent FormGroup
       * @private
       */
      this.__childModelValueChanged = false;

      /** @private */
      this.__onValidatorUpdated = this.__onValidatorUpdated.bind(this);
      /** @protected */
      this._updateFeedbackComponent = this._updateFeedbackComponent.bind(this);
    }

    connectedCallback() {
      super.connectedCallback();
      localize.addEventListener('localeChanged', this._updateFeedbackComponent);
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      localize.removeEventListener('localeChanged', this._updateFeedbackComponent);
    }

    /**
     * @param {import('@lion/core').PropertyValues} changedProperties
     */
    firstUpdated(changedProperties) {
      super.firstUpdated(changedProperties);
      this.__validateInitialized = true;
      this.validate();
      if (this._repropagationRole !== 'child') {
        this.addEventListener('model-value-changed', () => {
          this.__childModelValueChanged = true;
        });
      }
    }

    /**
     * @param {string} name
     * @param {?} oldValue
     */
    updateSync(name, oldValue) {
      super.updateSync(name, oldValue);
      if (name === 'validators') {
        // trigger validation (ideally only for the new or changed validator)
        this.__setupValidators();
        this.validate({ clearCurrentResult: true });
      } else if (name === 'modelValue') {
        this.validate({ clearCurrentResult: true });
      }

      if (
        [
          'touched',
          'dirty',
          'prefilled',
          'focused',
          'submitted',
          'hasFeedbackFor',
          'filled',
        ].includes(name)
      ) {
        this._updateShouldShowFeedbackFor();
      }

      if (name === 'showsFeedbackFor') {
        // This can't be reflected asynchronously in Safari
        // Screen reader output should be in sync with visibility of error messages
        if (this._inputNode) {
          this._inputNode.setAttribute('aria-invalid', `${this._hasFeedbackVisibleFor('error')}`);
          // this._inputNode.setCustomValidity(this._validationMessage || '');
        }

        const diff = arrayDiff(this.showsFeedbackFor, oldValue);
        if (diff.length > 0) {
          this.dispatchEvent(new Event(`showsFeedbackForChanged`, { bubbles: true }));
        }
        diff.forEach(type => {
          this.dispatchEvent(
            new Event(`showsFeedbackFor${pascalCase(type)}Changed`, { bubbles: true }),
          );
        });
      }

      if (name === 'shouldShowFeedbackFor') {
        const diff = arrayDiff(this.shouldShowFeedbackFor, oldValue);
        if (diff.length > 0) {
          this.dispatchEvent(new Event(`shouldShowFeedbackForChanged`, { bubbles: true }));
        }
      }
    }

    /**
     * Triggered by:
     *  - modelValue change
     *  - change in the 'validators' array
     * -  change in the config of an individual Validator
     *
     * Three situations are handled:
     * - a1) the FormControl is empty: further execution is halted. When the Required Validator
     * (being mutually exclusive to the other Validators) is applied, it will end up in the
     * validation result (as the only Validator, since further execution was halted).
     * - a2) there are synchronous Validators: this is the most common flow. When modelValue hasn't
     * changed since last async results were generated, 'sync results' are merged with the
     * 'async results'.
     * - a3) there are asynchronous Validators: for instance when server side evaluation is needed.
     * Executions are scheduled and awaited and the 'async results' are merged with the
     * 'sync results'.
     *
     * - b) there are ResultValidators. After steps a1, a2, or a3 are finished, the holistic
     * ResultValidators (evaluating the total result of the 'regular' (a1, a2 and a3) validators)
     * will be run...
     *
     * Situations a2 and a3 are not mutually exclusive and can be triggered within one `validate()`
     * call. Situation b will occur after every call.
     *
     * @param {{ clearCurrentResult?: boolean }} [opts]
     */
    async validate({ clearCurrentResult } = {}) {
      if (this.disabled) {
        this.__clearValidationResults();
        this.__finishValidation({ source: 'sync', hasAsync: true });
        this._updateFeedbackComponent();
        return;
      }
      if (!this.__validateInitialized) {
        return;
      }

      this.__prevValidationResult = this.__validationResult;
      if (clearCurrentResult) {
        // Clear ('invalidate') all pending and existing validation results.
        // This is needed because we have async (pending) validators whose results
        // need to be merged with those of sync validators and vice versa.
        this.__clearValidationResults();
      }
      await this.__executeValidators();
    }

    /**
     * @desc step a1-3 + b (as explained in `validate()`)
     */
    async __executeValidators() {
      this.validateComplete = new Promise(resolve => {
        this.__validateCompleteResolve = resolve;
      });

      // When the modelValue can't be created by FormatMixin.parser, still allow all validators
      // to give valuable feedback to the user based on the current viewValue.
      const value =
        this.modelValue instanceof Unparseable ? this.modelValue.viewValue : this.modelValue;

      /** @type {Validator | undefined} */
      const requiredValidator = this._allValidators.find(v => v instanceof Required$1);

      /**
       * 1. Handle the 'exceptional' Required validator:
       * - the validatity is dependent on the formControl type and therefore determined
       * by the formControl.__isEmpty method. Basically, the Required Validator is a means
       * to trigger formControl.__isEmpty.
       * - when __isEmpty returns true, the input was empty. This means we need to stop
       * validation here, because all other Validators' execute functions assume the
       * value is not empty (there would be nothing to validate).
       */
      // TODO: Try to remove this when we have a single lion form core package, because then we can
      // depend on FormControlMixin directly, and _isEmpty will always be an existing method on the prototype then
      const isEmpty = this.__isEmpty(value);
      if (isEmpty) {
        if (requiredValidator) {
          this.__syncValidationResult = [requiredValidator];
        }
        this.__finishValidation({ source: 'sync' });
        return;
      }

      // Separate Validators in sync and async
      const /** @type {Validator[]} */ filteredValidators = this._allValidators.filter(
          v => !(v instanceof ResultValidator) && !(v instanceof Required$1),
        );
      const /** @type {Validator[]} */ syncValidators = filteredValidators.filter(v => {
          const vCtor = /** @type {typeof Validator} */ (v.constructor);
          return !vCtor.async;
        });
      const /** @type {Validator[]} */ asyncValidators = filteredValidators.filter(v => {
          const vCtor = /** @type {typeof Validator} */ (v.constructor);
          return vCtor.async;
        });

      /**
       * 2. Synchronous validators
       */
      this.__executeSyncValidators(syncValidators, value, {
        hasAsync: Boolean(asyncValidators.length),
      });

      /**
       * 3. Asynchronous validators
       */
      await this.__executeAsyncValidators(asyncValidators, value);
    }

    /**
     * step a2 (as explained in `validate()`): calls `__finishValidation`
     * @param {Validator[]} syncValidators
     * @param {unknown} value
     * @param {{ hasAsync: boolean }} opts
     * @private
     */
    __executeSyncValidators(syncValidators, value, { hasAsync }) {
      if (syncValidators.length) {
        this.__syncValidationResult = syncValidators.filter(v =>
          v.execute(value, v.param, { node: this }),
        );
      }
      this.__finishValidation({ source: 'sync', hasAsync });
    }

    /**
     * step a3 (as explained in `validate()`), calls __finishValidation
     * @param {Validator[]} asyncValidators all Validators except required and ResultValidators
     * @param {?} value
     * @private
     */
    async __executeAsyncValidators(asyncValidators, value) {
      if (asyncValidators.length) {
        this.isPending = true;
        const resultPromises = asyncValidators.map(v => v.execute(value, v.param, { node: this }));
        const booleanResults = await Promise.all(resultPromises);
        this.__asyncValidationResult = booleanResults
          .map((r, i) => asyncValidators[i]) // Create an array of Validators
          .filter((v, i) => booleanResults[i]); // Only leave the ones returning true
        this.__finishValidation({ source: 'async' });
        this.isPending = false;
      }
    }

    /**
     * step b (as explained in `validate()`), called by __finishValidation
     * @param {Validator[]} regularValidationResult result of steps 1-3
     * @private
     */
    __executeResultValidators(regularValidationResult) {
      const resultValidators = /** @type {ResultValidator[]} */ (
        this._allValidators.filter(v => {
          const vCtor = /** @type {typeof Validator} */ (v.constructor);
          return !vCtor.async && v instanceof ResultValidator;
        })
      );

      return resultValidators.filter(v =>
        v.executeOnResults({
          regularValidationResult,
          prevValidationResult: this.__prevValidationResult,
          prevShownValidationResult: this.__prevShownValidationResult,
        }),
      );
    }

    /**
     * @param {object} options
     * @param {'sync'|'async'} options.source
     * @param {boolean} [options.hasAsync] whether async validators are configured in this run.
     * @private
     * If not, we have nothing left to wait for.
     */
    __finishValidation({ source, hasAsync }) {
      const syncAndAsyncOutcome = [...this.__syncValidationResult, ...this.__asyncValidationResult];
      // if we have any ResultValidators left, now is the time to run them...
      const resultOutCome = this.__executeResultValidators(syncAndAsyncOutcome);

      this.__validationResult = [...resultOutCome, ...syncAndAsyncOutcome];
      // this._storeResultsOnInstance(this.__validationResult);

      const ctor =
        /** @type {typeof import('../../types/validate/ValidateMixinTypes').ValidateHost} */ (
          this.constructor
        );

      /** @type {Object.<string, Object.<string, boolean>>} */
      const validationStates = ctor.validationTypes.reduce(
        (acc, type) => ({ ...acc, [type]: {} }),
        {},
      );
      this.__validationResult.forEach(v => {
        if (!validationStates[v.type]) {
          validationStates[v.type] = {};
        }
        const vCtor = /** @type {typeof Validator} */ (v.constructor);
        validationStates[v.type][vCtor.validatorName] = true;
      });
      this.validationStates = validationStates;

      this.hasFeedbackFor = [...new Set(this.__validationResult.map(v => v.type))];

      /** private event that should be listened to by LionFieldSet */
      this.dispatchEvent(new Event('validate-performed', { bubbles: true }));
      if (source === 'async' || !hasAsync) {
        if (this.__validateCompleteResolve) {
          // @ts-ignore [allow-private]
          this.__validateCompleteResolve();
        }
      }
    }

    /**
     * @private
     */
    __clearValidationResults() {
      this.__syncValidationResult = [];
      this.__asyncValidationResult = [];
    }

    /**
     * @param {Event|CustomEvent} e
     * @private
     */
    __onValidatorUpdated(e) {
      if (e.type === 'param-changed' || e.type === 'config-changed') {
        this.validate();
      }
    }

    /**
     * @private
     */
    __setupValidators() {
      const events = ['param-changed', 'config-changed'];
      if (this.__prevValidators) {
        this.__prevValidators.forEach(v => {
          events.forEach(e => {
            if (v.removeEventListener) {
              v.removeEventListener(e, this.__onValidatorUpdated);
            }
          });
          v.onFormControlDisconnect(this);
        });
      }
      this._allValidators.forEach(v => {
        if (!(v instanceof Validator)) {
          // throws in constructor are not visible to end user so we do both
          const errorType = Array.isArray(v) ? 'array' : typeof v;
          const errorMessage = `Validators array only accepts class instances of Validator. Type "${errorType}" found. This may be caused by having multiple installations of @lion/form-core.`;
          // eslint-disable-next-line no-console
          console.error(errorMessage, this);
          throw new Error(errorMessage);
        }
        const ctor =
          /** @type {typeof import('../../types/validate/ValidateMixinTypes').ValidateHost} */ (
            this.constructor
          );
        if (ctor.validationTypes.indexOf(v.type) === -1) {
          const vCtor = /** @type {typeof Validator} */ (v.constructor);
          // throws in constructor are not visible to end user so we do both
          const errorMessage = `This component does not support the validator type "${v.type}" used in "${vCtor.validatorName}". You may change your validators type or add it to the components "static get validationTypes() {}".`;
          // eslint-disable-next-line no-console
          console.error(errorMessage, this);
          throw new Error(errorMessage);
        }
        events.forEach(e => {
          if (v.addEventListener) {
            v.addEventListener(e, this.__onValidatorUpdated);
          }
        });
        v.onFormControlConnect(this);
      });
      this.__prevValidators = this._allValidators;
    }

    /**
     * Helper method for the mutually exclusive Required Validator
     * @param {?} v
     * @private
     */
    __isEmpty(v) {
      if (typeof this._isEmpty === 'function') {
        return this._isEmpty(v);
      }
      return (
        this.modelValue === null || typeof this.modelValue === 'undefined' || this.modelValue === ''
      );
    }

    // ------------------------------------------------------------------------------------------
    // -- Feedback specifics --------------------------------------------------------------------
    // ------------------------------------------------------------------------------------------

    /**
     * @typedef {object} FeedbackMessage
     * @property {string | Node} message this
     * @property {string} type will be 'error' for messages from default Validators. Could be
     * 'warning', 'info' etc. for Validators with custom types. Needed as a directive for
     * feedbackNode how to render a message of a certain type
     * @property {Validator} [validator] when the message is directly coupled to a Validator
     * (in most cases), this property is filled. When a message is not coupled to a Validator
     * (in case of success feedback which is based on a diff or current and previous validation
     * results), this property can be left empty.
     */

    /**
     * @param {Validator[]} validators list of objects having a .getMessage method
     * @return {Promise.<FeedbackMessage[]>}
     * @private
     */
    async __getFeedbackMessages(validators) {
      let fieldName = await this.fieldName;
      return Promise.all(
        validators.map(async validator => {
          if (validator.config.fieldName) {
            fieldName = await validator.config.fieldName;
          }
          // @ts-ignore [allow-protected]
          const message = await validator._getMessage({
            modelValue: this.modelValue,
            formControl: this,
            fieldName,
          });
          return { message, type: validator.type, validator };
        }),
      );
    }

    /**
     * Responsible for retrieving messages from Validators and
     * (delegation of) rendering them.
     *
     * For `._feedbackNode` (extension of LionValidationFeedback):
     * - retrieve messages from highest prio Validators
     * - provide the result to custom feedback node and let the
     * custom node decide on their renderings
     *
     * In both cases:
     * - we compute the 'show' flag (like 'hasErrorVisible') for all types
     * - we set the customValidity message of the highest prio Validator
     * - we set aria-invalid="true" in case hasErrorVisible is true
     * @protected
     */
    _updateFeedbackComponent() {
      const { _feedbackNode } = this;
      if (!_feedbackNode) {
        return;
      }

      if (!this.__feedbackQueue) {
        this.__feedbackQueue = new AsyncQueue();
      }

      if (this.showsFeedbackFor.length > 0) {
        this.__feedbackQueue.add(async () => {
          /** @type {Validator[]} */
          this.__prioritizedResult = this._prioritizeAndFilterFeedback({
            validationResult: this.__validationResult,
          });

          if (this.__prioritizedResult.length > 0) {
            this.__prevShownValidationResult = this.__prioritizedResult;
          }

          const messageMap = await this.__getFeedbackMessages(this.__prioritizedResult);
          _feedbackNode.feedbackData = messageMap.length ? messageMap : [];
        });
      } else {
        this.__feedbackQueue.add(async () => {
          _feedbackNode.feedbackData = [];
        });
      }
      this.feedbackComplete = this.__feedbackQueue.complete;
    }

    /**
     * Default feedbackCondition condition, used by Subclassers, that will be used when
     * `feedbackCondition()` is not overridden by Application Developer.
     * Show the validity feedback when returning true, don't show when false
     * @param {string} type could be 'error', 'warning', 'info', 'success' or any other custom
     * Validator type
     * @param {object} meta meta info (interaction states etc)
     * @protected
     */
    // eslint-disable-next-line no-unused-vars
    _showFeedbackConditionFor(type, meta) {
      return true;
    }

    /**
     * Allows Subclassers to add meta info for feedbackCondition
     * @configurable
     */
    get _feedbackConditionMeta() {
      return { modelValue: this.modelValue, el: this };
    }

    /**
     * Allows the end user to specify when a feedback message should be shown
     * @example
     * ```js
     * feedbackCondition(type, meta, defaultCondition) {
     *   if (type === 'info') {
     *     return return;
     *   } else if (type === 'prefilledOnly') {
     *     return meta.prefilled;
     *   }
     *   return defaultCondition(type, meta);
     * }
     * ```
     * @overridable
     * @param {string} type could be 'error', 'warning', 'info', 'success' or any other custom
     * Validator type
     * @param {object} meta meta info (interaction states etc)
     * @param {((type: string, meta: object) => boolean)} currentCondition this is the _showFeedbackConditionFor
     * that can be used if a developer wants to override for a certain type, but wants to fallback
     * for other types
     * @returns {boolean}
     */
    feedbackCondition(
      type,
      meta = this._feedbackConditionMeta,
      currentCondition = this._showFeedbackConditionFor.bind(this),
    ) {
      return currentCondition(type, meta);
    }

    /**
     * Used to translate `.hasFeedbackFor` and `.shouldShowFeedbackFor` to `.showsFeedbackFor`
     * @param {string} type
     * @protected
     */
    _hasFeedbackVisibleFor(type) {
      return (
        this.hasFeedbackFor &&
        this.hasFeedbackFor.includes(type) &&
        this.shouldShowFeedbackFor &&
        this.shouldShowFeedbackFor.includes(type)
      );
    }

    /** @param {import('@lion/core').PropertyValues} changedProperties */
    updated(changedProperties) {
      super.updated(changedProperties);

      if (
        changedProperties.has('shouldShowFeedbackFor') ||
        changedProperties.has('hasFeedbackFor')
      ) {
        const ctor =
          /** @type {typeof import('../../types/validate/ValidateMixinTypes').ValidateHost} */ (
            this.constructor
          );
        // Necessary typecast because types aren't smart enough to understand that we filter out undefined
        this.showsFeedbackFor = /** @type {string[]} */ (
          ctor.validationTypes
            .map(type => (this._hasFeedbackVisibleFor(type) ? type : undefined))
            .filter(Boolean)
        );
        this._updateFeedbackComponent();
      }

      if (changedProperties.has('__childModelValueChanged') && this.__childModelValueChanged) {
        this.validate({ clearCurrentResult: true });
        this.__childModelValueChanged = false;
      }

      if (changedProperties.has('validationStates')) {
        const prevStates = /** @type {{[key: string]: object;}} */ (
          changedProperties.get('validationStates')
        );
        if (prevStates) {
          Object.entries(this.validationStates).forEach(([type, feedbackObj]) => {
            if (
              prevStates[type] &&
              JSON.stringify(feedbackObj) !== JSON.stringify(prevStates[type])
            ) {
              this.dispatchEvent(new CustomEvent(`${type}StateChanged`, { detail: feedbackObj }));
            }
          });
        }
      }
    }

    /**
     * @protected
     */
    _updateShouldShowFeedbackFor() {
      const ctor =
        /** @type {typeof import('../../types/validate/ValidateMixinTypes').ValidateHost} */ (
          this.constructor
        );

      // Necessary typecast because types aren't smart enough to understand that we filter out undefined
      const newShouldShowFeedbackFor = /** @type {string[]} */ (
        ctor.validationTypes
          .map(type =>
            this.feedbackCondition(
              type,
              this._feedbackConditionMeta,
              this._showFeedbackConditionFor.bind(this),
            )
              ? type
              : undefined,
          )
          .filter(Boolean)
      );

      if (JSON.stringify(this.shouldShowFeedbackFor) !== JSON.stringify(newShouldShowFeedbackFor)) {
        this.shouldShowFeedbackFor = newShouldShowFeedbackFor;
      }
    }

    /**
     * Orders all active validators in this.__validationResult. Can
     * also filter out occurrences (based on interaction states)
     * @overridable
     * @param {{ validationResult: Validator[] }} opts
     * @return {Validator[]} ordered list of Validators with feedback messages visible to the end user
     * @protected
     */
    _prioritizeAndFilterFeedback({ validationResult }) {
      const ctor =
        /** @type {typeof import('../../types/validate/ValidateMixinTypes').ValidateHost} */ (
          this.constructor
        );
      const types = ctor.validationTypes;
      // Sort all validators based on the type provided.
      const res = validationResult
        .filter(v =>
          this.feedbackCondition(
            v.type,
            this._feedbackConditionMeta,
            this._showFeedbackConditionFor.bind(this),
          ),
        )
        .sort((a, b) => types.indexOf(a.type) - types.indexOf(b.type));
      return res.slice(0, this._visibleMessagesAmount);
    }
  };

const ValidateMixin = dedupeMixin(ValidateMixinImplementation);

/* eslint-disable class-methods-use-this */

/**
 * @typedef {import('../types/FormatMixinTypes').FormatMixin} FormatMixin
 * @typedef {import('@lion/localize/types/LocalizeMixinTypes').FormatNumberOptions} FormatOptions
 * @typedef {import('../types/FormControlMixinTypes.js').ModelValueEventDetails} ModelValueEventDetails
 */

// For a future breaking release:
// - do not allow the private `.formattedValue` as property that can be set to
// trigger a computation loop.
// - do not fire events for those private and protected concepts
// - simplify _calculateValues: recursive trigger lock can be omitted, since need for connecting
// the loop via sync observers is not needed anymore.
// - consider `formatOn` as an overridable function, by default something like:
// `(!_isHandlingUserInput || !hasError) && !focused`
// This would allow for more advanced scenarios, like formatting an input whenever it becomes valid.
// This would make formattedValue as a concept obsolete, since for maximum flexibility, the
// formattedValue condition needs to be evaluated right before syncing back to the view

/**
 * @desc Designed to be applied on top of a LionField.
 * To understand all concepts within the Mixin, please consult the flow diagram in the
 * documentation.
 *
 * ## Flows
 * FormatMixin supports these two main flows:
 * [1] Application Developer sets `.modelValue`:
 *     Flow: `.modelValue` (formatter) -> `.formattedValue` -> `._inputNode.value`
 *                         (serializer) -> `.serializedValue`
 * [2] End user interacts with field:
 *     Flow: `@user-input-changed` (parser) -> `.modelValue` (formatter) -> `.formattedValue` - (debounce till reflect condition (formatOn) is met) -> `._inputNode.value`
 *                                 (serializer) -> `.serializedValue`
 *
 * For backwards compatibility with the platform, we also support `.value` as an api. In that case
 * the flow will be like [2], without the debounce.
 *
 * ## Difference between value, viewValue and formattedValue
 * A viewValue is a concept rather than a property. To be compatible with the platform api, the
 * property for the concept of viewValue is thus called `.value`.
 * When reading code and docs, one should be aware that the term viewValue is mostly used, but the
 * terms can be used interchangeably.
 * The `.formattedValue` should be seen as the 'scheduled' viewValue. It is computed realtime and
 * stores the output of formatter. It will replace viewValue. once condition `formatOn` is met.
 * Another difference is that formattedValue lives on `LionField`, whereas viewValue is shared
 * across `LionField` and `._inputNode`.
 *
 * For restoring serialized values fetched from a server, we could consider one extra flow:
 * [3] Application Developer sets `.serializedValue`:
 *     Flow: serializedValue (deserializer) -> `.modelValue` (formatter) -> `.formattedValue` -> `._inputNode.value`
 *
 * @type {FormatMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const FormatMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class FormatMixin extends ValidateMixin(FormControlMixin(superclass)) {
    /** @type {any} */
    static get properties() {
      return {
        formattedValue: { attribute: false },
        serializedValue: { attribute: false },
        formatOptions: { attribute: false },
      };
    }

    /**
     * @param {string} name
     * @param {any} oldVal
     */
    requestUpdate(name, oldVal) {
      super.requestUpdate(name, oldVal);

      if (name === 'modelValue' && this.modelValue !== oldVal) {
        this._onModelValueChanged({ modelValue: this.modelValue }, { modelValue: oldVal });
      }
      if (name === 'serializedValue' && this.serializedValue !== oldVal) {
        this._calculateValues({ source: 'serialized' });
      }
      if (name === 'formattedValue' && this.formattedValue !== oldVal) {
        this._calculateValues({ source: 'formatted' });
      }
    }

    /**
     * The view value. Will be delegated to `._inputNode.value`
     */
    get value() {
      return (this._inputNode && this._inputNode.value) || this.__value || '';
    }

    /** @param {string} value */
    set value(value) {
      // if not yet connected to dom can't change the value
      if (this._inputNode) {
        this._inputNode.value = value;
        /** @type {string | undefined} */
        this.__value = undefined;
      } else {
        this.__value = value;
      }
    }

    /**
     * Preprocesses the viewValue before it's parsed to a modelValue. Can be used to filter
     * invalid input amongst others.
     * @example
     * ```js
     * preprocessor(viewValue) {
     *   // only use digits
     *   return viewValue.replace(/\D/g, '');
     * }
     * ```
     * @param {string} v - the raw value from the <input> after keyUp/Down event
     * @returns {string} preprocessedValue: the result of preprocessing for invalid input
     */
    preprocessor(v) {
      return v;
    }

    /**
     * Converts viewValue to modelValue
     * For instance, a localized date to a Date Object
     * @param {string} v - viewValue: the formatted value inside <input>
     * @param {FormatOptions} opts
     * @returns {*} modelValue
     */
    // eslint-disable-next-line no-unused-vars
    parser(v, opts) {
      return v;
    }

    /**
     * Converts modelValue to formattedValue (formattedValue will be synced with
     * `._inputNode.value`)
     * For instance, a Date object to a localized date.
     * @param {*} v - modelValue: can be an Object, Number, String depending on the
     * input type(date, number, email etc)
     * @param {FormatOptions} opts
     * @returns {string} formattedValue
     */
    // eslint-disable-next-line no-unused-vars
    formatter(v, opts) {
      return v;
    }

    /**
     * Converts `.modelValue` to `.serializedValue`
     * For instance, a Date object to an iso formatted date string
     * @param {?} v - modelValue: can be an Object, Number, String depending on the
     * input type(date, number, email etc)
     * @returns {string} serializedValue
     */
    serializer(v) {
      return v !== undefined ? v : '';
    }

    /**
     * Converts `.serializedValue` to `.modelValue`
     * For instance, an iso formatted date string to a Date object
     * @param {?} v - modelValue: can be an Object, Number, String depending on the
     * input type(date, number, email etc)
     * @returns {?} modelValue
     */
    deserializer(v) {
      return v === undefined ? '' : v;
    }

    /**
     * Responsible for storing all representations(modelValue, serializedValue, formattedValue
     * and value) of the input value. Prevents infinite loops, so all value observers can be
     * treated like they will only be called once, without indirectly calling other observers.
     * (in fact, some are called twice, but the __preventRecursiveTrigger lock prevents the
     * second call from having effect).
     *
     * @param {{source:'model'|'serialized'|'formatted'|null}} config - the type of value that triggered this method. It should not be
     * set again, so that its observer won't be triggered. Can be:
     * 'model'|'formatted'|'serialized'.
     * @protected
     */
    _calculateValues({ source } = { source: null }) {
      if (this.__preventRecursiveTrigger) return; // prevent infinite loops

      /** @type {boolean} */
      this.__preventRecursiveTrigger = true;
      if (source !== 'model') {
        if (source === 'serialized') {
          /** @type {?} */
          this.modelValue = this.deserializer(this.serializedValue);
        } else if (source === 'formatted') {
          this.modelValue = this._callParser();
        }
      }
      if (source !== 'formatted') {
        this.formattedValue = this._callFormatter();
      }
      if (source !== 'serialized') {
        this.serializedValue = this.serializer(this.modelValue);
      }
      this._reflectBackFormattedValueToUser();
      this.__preventRecursiveTrigger = false;
    }

    /**
     * @param {string|undefined} value
     * @return {?}
     * @private
     */
    _callParser(value = this.formattedValue) {
      // A) check if we need to parse at all

      // A.1) The end user had no intention to parse
      if (value === '') {
        // Ideally, modelValue should be undefined for empty strings.
        // For backwards compatibility we return an empty string:
        // - it triggers validation for required validators (see ValidateMixin.validate())
        // - it can be expected by 3rd parties (for instance unit tests)
        // TODO(@tlouisse): In a breaking refactor of the Validation System, this behavior can be corrected.
        return '';
      }

      // A.2) Handle edge cases We might have no view value yet, for instance because
      // _inputNode.value was not available yet
      if (typeof value !== 'string') {
        // This means there is nothing to find inside the view that can be of
        // interest to the Application Developer or needed to store for future
        // form state retrieval.
        return undefined;
      }

      // B) parse the view value

      // - if result:
      // return the successfully parsed viewValue
      // - if no result:
      // Apparently, the parser was not able to produce a satisfactory output for the desired
      // modelValue type, based on the current viewValue. Unparseable allows to restore all
      // states (for instance from a lost user session), since it saves the current viewValue.
      const result = this.parser(value, this.formatOptions);
      return result !== undefined ? result : new Unparseable(value);
    }

    /**
     * @returns {string|undefined}
     * @private
     */
    _callFormatter() {
      // - Why check for this.hasError?
      // We only want to format values that are considered valid. For best UX,
      // we only 'reward' valid inputs.
      // - Why check for _isHandlingUserInput?
      // Downwards sync is prevented whenever we are in an `@user-input-changed` flow, [2].
      // If we are in a 'imperatively set `.modelValue`' flow, [1], we want to reflect back
      // the value, no matter what.
      // This means, whenever we are in hasError and modelValue is set
      // imperatively, we DO want to format a value (it is the only way to get meaningful
      // input into `._inputNode` with modelValue as input)

      if (
        this._isHandlingUserInput &&
        this.hasFeedbackFor &&
        this.hasFeedbackFor.length &&
        this.hasFeedbackFor.includes('error') &&
        this._inputNode
      ) {
        return this._inputNode ? this.value : undefined;
      }

      if (this.modelValue instanceof Unparseable) {
        // When the modelValue currently is unparseable, we need to sync back the supplied
        // viewValue. In flow [2], this should not be needed.
        // In flow [1] (we restore a previously stored modelValue) we should sync down, however.
        return this.modelValue.viewValue;
      }

      return this.formatter(this.modelValue, this.formatOptions);
    }

    /**
     * @param {{ modelValue: unknown; }[]} args
     * @protected
     */
    _onModelValueChanged(...args) {
      this._calculateValues({ source: 'model' });
      this._dispatchModelValueChangedEvent(...args);
    }

    /**
     * This is wrapped in a distinct method, so that parents can control when the changed event
     * is fired. For objects, a deep comparison might be needed.
     * @param {{ modelValue: unknown; }[]} args
     * @protected
     */
    // eslint-disable-next-line no-unused-vars
    _dispatchModelValueChangedEvent(...args) {
      /** @event model-value-changed */
      this.dispatchEvent(
        /** @privateEvent model-value-changed: FormControl redispatches it as public event */
        new CustomEvent('model-value-changed', {
          bubbles: true,
          detail: /** @type { ModelValueEventDetails } */ ({
            formPath: [this],
            isTriggeredByUser: Boolean(this._isHandlingUserInput),
          }),
        }),
      );
    }

    /**
     * Synchronization from `._inputNode.value` to `LionField` (flow [2])
     * Downwards syncing should only happen for `LionField`.value changes from 'above'.
     * This triggers _onModelValueChanged and connects user input
     * to the parsing/formatting/serializing loop.
     * @protected
     */
    _syncValueUpwards() {
      if (!this.__isHandlingComposition) {
        this.value = this.preprocessor(this.value);
      }
      const prevFormatted = this.formattedValue;
      this.modelValue = this._callParser(this.value);

      // Sometimes, the formattedValue didn't change, but the viewValue did...
      // We need this check to support pasting values that need to be formatted right on paste
      if (prevFormatted === this.formattedValue && this.__prevViewValue !== this.value) {
        this._calculateValues();
      }
      /** @type {string} */
      this.__prevViewValue = this.value;
    }

    /**
     * Synchronization from `LionField.value` to `._inputNode.value`
     * - flow [1] will always be reflected back
     * - flow [2] will not be reflected back when this flow was triggered via
     *   `@user-input-changed` (this will happen later, when `formatOn` condition is met)
     * @protected
     */
    _reflectBackFormattedValueToUser() {
      if (this._reflectBackOn()) {
        // Text 'undefined' should not end up in <input>
        this.value = typeof this.formattedValue !== 'undefined' ? this.formattedValue : '';
      }
    }

    /**
     * Every time .formattedValue is attempted to sync to the view value (on change/blur and on
     * modelValue change), this condition is checked. When enhancing it, it's recommended to
     * call `super._reflectBackOn()`
     * @overridable
     * @return {boolean}
     * @protected
     */
    _reflectBackOn() {
      return !this._isHandlingUserInput;
    }

    /**
     * This can be called whenever the view value should be updated. Dependent on component type
     * ("input" for <input> or "change" for <select>(mainly for IE)) a different event should be
     * used  as source for the "user-input-changed" event (which can be seen as an abstraction
     * layer on top of other events (input, change, whatever))
     * @protected
     */
    _proxyInputEvent() {
      // TODO: [v1] remove composed (and bubbles as well if possible)
      /** @protectedEvent user-input-changed meant for usage by Subclassers only */
      this.dispatchEvent(new Event('user-input-changed', { bubbles: true }));
    }

    /** @protected */
    _onUserInputChanged() {
      // Upwards syncing. Most properties are delegated right away, value is synced to
      // `LionField`, to be able to act on (imperatively set) value changes
      this._isHandlingUserInput = true;
      this._syncValueUpwards();
      this._isHandlingUserInput = false;
    }

    /**
     * @param {Event} event
     */
    __onCompositionEvent({ type }) {
      if (type === 'compositionstart') {
        this.__isHandlingComposition = true;
      } else if (type === 'compositionend') {
        this.__isHandlingComposition = false;
        // in all other cases this would be triggered via user-input-changed
        this._syncValueUpwards();
      }
    }

    constructor() {
      super();

      // TODO: [v1] delete; use 'change' event directly within this file
      /**
       * Event that will trigger formatting (more precise, visual update of the view, so the
       * user sees the formatted value)
       * Default: 'change'
       * @deprecated use _reflectBackOn()
       * @protected
       */
      this.formatOn = 'change';

      /**
       * Configuration object that will be available inside the formatter function
       */
      this.formatOptions = /** @type {FormatOptions} */ ({});

      /**
       * The view value is the result of the formatter function (when available).
       * The result will be stored in the native _inputNode (usually an input[type=text]).
       *
       * Examples:
       * - For a date input, this would be '20/01/1999' (dependent on locale).
       * - For a number input, this could be '1,234.56' (a String representation of modelValue
       * 1234.56)
       * @type {string|undefined}
       * @readOnly
       */
      this.formattedValue = undefined;

      /**
       * The serialized version of the model value.
       * This value exists for maximal compatibility with the platform API.
       * The serialized value can be an interface in context where data binding is not
       * supported and a serialized string needs to be set.
       *
       * Examples:
       * - For a date input, this would be the iso format of a date, e.g. '1999-01-20'.
       * - For a number input this would be the String representation of a float ('1234.56'
       *   instead of 1234.56)
       *
       * When no parser is available, the value is usually the same as the formattedValue
       * (being _inputNode.value)
       * @type {string|undefined}
       */
      this.serializedValue = undefined;

      /**
       * Whether the user is pasting content. Allows Subclassers to do this in their subclass:
       * @example
       * ```js
       * _reflectBackOn() {
       *   return super._reflectBackOn() || this._isPasting;
       * }
       * ```
       * @protected
       * @type {boolean}
       */
      this._isPasting = false;

      /**
       * Flag that will be set when user interaction takes place (for instance after an 'input'
       * event). Will be added as meta info to the `model-value-changed` event. Depending on
       * whether a user is interacting, formatting logic will be handled differently.
       * @protected
       * @type {boolean}
       */
      this._isHandlingUserInput = false;
      /**
       * @private
       * @type {string}
       */
      this.__prevViewValue = '';
      this.__onCompositionEvent = this.__onCompositionEvent.bind(this);
      // This computes formattedValue
      this.addEventListener('user-input-changed', this._onUserInputChanged);
      // This sets the formatted viewValue after paste
      this.addEventListener('paste', this.__onPaste);

      /**
       * @protected
       */
      this._reflectBackFormattedValueToUser = this._reflectBackFormattedValueToUser.bind(this);

      /**
       * @private
       */
      this._reflectBackFormattedValueDebounced = () => {
        // Make sure this is fired after the change event of _inputNode, so that formattedValue
        // is guaranteed to be calculated
        setTimeout(this._reflectBackFormattedValueToUser);
      };
    }

    __onPaste() {
      this._isPasting = true;
      this.formatOptions.mode = 'pasted';
      setTimeout(() => {
        this._isPasting = false;
        this.formatOptions.mode = 'auto';
      });
    }

    connectedCallback() {
      super.connectedCallback();

      // Connect the value found in <input> to the formatting/parsing/serializing loop as a
      // fallback mechanism. Assume the user uses the value property of the
      // `LionField`(recommended api) as the api (this is a downwards sync).
      // However, when no value is specified on `LionField`, have support for sync of the real
      // input to the `LionField` (upwards sync).
      if (typeof this.modelValue === 'undefined') {
        this._syncValueUpwards();
      }
      this._reflectBackFormattedValueToUser();

      if (this._inputNode) {
        this._inputNode.addEventListener(this.formatOn, this._reflectBackFormattedValueDebounced);
        this._inputNode.addEventListener('input', this._proxyInputEvent);
        this._inputNode.addEventListener('compositionstart', this.__onCompositionEvent);
        this._inputNode.addEventListener('compositionend', this.__onCompositionEvent);
      }
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      if (this._inputNode) {
        this._inputNode.removeEventListener('input', this._proxyInputEvent);
        this._inputNode.removeEventListener(
          this.formatOn,
          /** @type {EventListenerOrEventListenerObject} */ (
            this._reflectBackFormattedValueDebounced
          ),
        );
        this._inputNode.removeEventListener('compositionstart', this.__onCompositionEvent);
        this._inputNode.removeEventListener('compositionend', this.__onCompositionEvent);
      }
    }
  };

const FormatMixin = dedupeMixin(FormatMixinImplementation);

/**
 * @typedef {import('../types/InteractionStateMixinTypes').InteractionStateMixin} InteractionStateMixin
 * @typedef {import('../types/InteractionStateMixinTypes').InteractionStates} InteractionStates
 */

/**
 * @desc `InteractionStateMixin` adds meta information about touched and dirty states, that can
 * be read by other form components (ing-uic-input-error for instance, uses the touched state
 * to determine whether an error message needs to be shown).
 * Interaction states will be set when a user:
 * - leaves a form field(blur) -> 'touched' will be set to true. 'prefilled' when a
 *   field is left non-empty
 * - on keyup (actually, on the model-value-changed event) -> 'dirty' will be set to true
 *
 * @type {InteractionStateMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const InteractionStateMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class InteractionStateMixin extends FormControlMixin(superclass) {
    /** @type {any} */
    static get properties() {
      return {
        touched: { type: Boolean, reflect: true },
        dirty: { type: Boolean, reflect: true },
        filled: { type: Boolean, reflect: true },
        prefilled: { attribute: false },
        submitted: { attribute: false },
      };
    }

    /**
     * @param {PropertyKey} name
     * @param {*} oldVal
     */
    requestUpdate(name, oldVal) {
      super.requestUpdate(name, oldVal);
      if (name === 'touched' && this.touched !== oldVal) {
        this._onTouchedChanged();
      }

      if (name === 'modelValue') {
        // We do this in requestUpdate because we don't want to fire another re-render (e.g. when doing this in updated)
        // Furthermore, we cannot do it on model-value-changed event because it isn't fired initially.
        this.filled = !this._isEmpty();
      }

      if (name === 'dirty' && this.dirty !== oldVal) {
        this._onDirtyChanged();
      }
    }

    constructor() {
      super();

      /**
       * True when user has focused and left(blurred) the field.
       * @type {boolean}
       */
      this.touched = false;

      /**
       * True when user has changed the value of the field.
       * @type {boolean}
       */
      this.dirty = false;

      /**
       * True when user has left non-empty field or input is prefilled.
       * The name must be seen from the point of view of the input field:
       * once the user enters the input field, the value is non-empty.
       * @type {boolean}
       */
      this.prefilled = false;

      /**
       * True when the modelValue is non-empty (see _isEmpty in FormControlMixin)
       * @type {boolean}
       */
      this.filled = false;

      /**
       * True when user has attempted to submit the form, e.g. through a button
       * of type="submit"
       * @type {boolean}
       */
      // TODO: [v1] this might be fixable by scheduling property effects till firstUpdated
      // this.submitted = false;

      /**
       * The event that triggers the touched state
       * @type {string}
       * @protected
       */
      this._leaveEvent = 'blur';

      /**
       * The event that triggers the dirty state
       * @type {string}
       * @protected
       */
      this._valueChangedEvent = 'model-value-changed';

      /**
       * @type {(event: Event) => unknown}
       * @protected
       */
      this._iStateOnLeave = this._iStateOnLeave.bind(this);

      /**
       * @type {(event: Event) => unknown}
       * @protected
       */
      this._iStateOnValueChange = this._iStateOnValueChange.bind(this);
    }

    /**
     * Register event handlers and validate prefilled inputs
     */
    connectedCallback() {
      super.connectedCallback();
      this.addEventListener(this._leaveEvent, this._iStateOnLeave);
      this.addEventListener(this._valueChangedEvent, this._iStateOnValueChange);
      this.initInteractionState();
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      this.removeEventListener(this._leaveEvent, this._iStateOnLeave);
      this.removeEventListener(this._valueChangedEvent, this._iStateOnValueChange);
    }

    /**
     * Evaluations performed on connectedCallback.
     * This method is public, so it can be called at a later moment (when we need to wait for
     * registering children for instance) as well.
     * Since this method will be called twice in last mentioned scenario, it must stay idempotent.
     */
    initInteractionState() {
      this.dirty = false;
      this.prefilled = !this._isEmpty();
    }

    /**
     * Sets touched value to true and reevaluates prefilled state.
     * When false, on next interaction, user will start with a clean state.
     * @protected
     */
    _iStateOnLeave() {
      this.touched = true;
      this.prefilled = !this._isEmpty();
    }

    /**
     * Sets dirty value and validates when already touched or invalid
     * @protected
     */
    _iStateOnValueChange() {
      this.dirty = true;
    }

    /**
     * Resets touched and dirty, and recomputes prefilled
     */
    resetInteractionState() {
      this.touched = false;
      this.submitted = false;
      this.dirty = false;
      this.prefilled = !this._isEmpty();
    }

    /**
     * Dispatches event on touched state change
     * @protected
     */
    _onTouchedChanged() {
      /** @protectedEvent touched-changed */
      this.dispatchEvent(new Event('touched-changed', { bubbles: true, composed: true }));
    }

    /**
     * Dispatches event on touched state change
     * @protected
     */
    _onDirtyChanged() {
      /** @protectedEvent dirty-changed */
      this.dispatchEvent(new Event('dirty-changed', { bubbles: true, composed: true }));
    }

    /**
     * @override ValidateMixin
     * Show the validity feedback when one of the following conditions is met:
     *
     * - submitted
     *   If the form is submitted, always show the error message.
     *
     * - prefilled
     *   the user already filled in something, or the value is prefilled
     *   when the form is initially rendered.
     *
     * - touched && dirty
     *   When a user starts typing for the first time in a field with for instance `required`
     *   validation, error message should not be shown until a field becomes `touched`
     *   (a user leaves(blurs) a field).
     *   When a user enters a field without altering the value(making it `dirty`),
     *   an error message shouldn't be shown either.
     * @protected
     * @param {string} type
     * @param {InteractionStates} meta
     */
    // @ts-expect-error FIXME: istatemixin should implement validatemixin, then @override is valid
    // eslint-disable-next-line class-methods-use-this, no-unused-vars
    _showFeedbackConditionFor(type, meta) {
      return (meta.touched && meta.dirty) || meta.prefilled || meta.submitted;
    }

    /**
     * @enhance ValidateMixin
     */
    get _feedbackConditionMeta() {
      return {
        // @ts-ignore to fix, InteractionStateMixin needs to depend on ValidateMixin
        ...super._feedbackConditionMeta,
        submitted: this.submitted,
        touched: this.touched,
        dirty: this.dirty,
        filled: this.filled,
        prefilled: this.prefilled,
      };
    }
  };

const InteractionStateMixin = dedupeMixin(InteractionStateMixinImplementation);

/**
 * `LionField`: wraps <input>, <textarea>, <select> and other interactable elements.
 * Also it would follow a nice hierarchy: lion-form -> lion-fieldset -> lion-field
 *
 * Note: We don't support placeholders, because we have a helper text and
 * placeholders confuse the user with accessibility needs.
 *
 * Please see the docs for in depth information.
 *
 * @example
 * <lion-field name="myName">
 *   <label slot="label">My Input</label>
 *   <input type="text" slot="input">
 * </lion-field>
 *
 * @customElement lion-field
 */
class LionField extends FormControlMixin(
  InteractionStateMixin(FocusMixin(FormatMixin(ValidateMixin(SlotMixin(s$5))))),
) {
  /**
   * @param {import('@lion/core').PropertyValues } changedProperties
   */
  firstUpdated(changedProperties) {
    super.firstUpdated(changedProperties);
    /** @type {any} */
    this._initialModelValue = this.modelValue;
  }

  connectedCallback() {
    super.connectedCallback();
    this._onChange = this._onChange.bind(this);
    this._inputNode.addEventListener('change', this._onChange);
    this.classList.add('form-field'); // eslint-disable-line
  }

  disconnectedCallback() {
    super.disconnectedCallback();
    this._inputNode.removeEventListener('change', this._onChange);
  }

  resetInteractionState() {
    super.resetInteractionState();
    this.submitted = false;
  }

  /**
   * Resets modelValue to initial value.
   * Interaction states are cleared
   */
  reset() {
    this.modelValue = this._initialModelValue;
    this.resetInteractionState();
  }

  /**
   * Clears modelValue.
   * Interaction states are not cleared (use resetInteractionState for this)
   */
  clear() {
    // TODO: [v1] set to undefined
    this.modelValue = '';
  }

  /**
   * Dispatches custom bubble event
   * @protected
   */
  _onChange() {
    /** @protectedEvent user-input-changed */
    this.dispatchEvent(new Event('user-input-changed', { bubbles: true }));
  }

  /**
   * @configure InteractionStateMixin, ValidateMixin
   */
  get _feedbackConditionMeta() {
    return { ...super._feedbackConditionMeta, focused: this.focused };
  }

  /**
   * @configure FocusMixin
   */
  get _focusableNode() {
    return this._inputNode;
  }
}

/* eslint-disable */

/**
 * This class closely mimics the natively
 * supported HTMLFormControlsCollection. It can be accessed
 * both like an array and an object (based on control/element names).
 * @example
 * // This is how a native form works:
 * <form>
 *   <input id="a" name="a">
 *   <fieldset>
 *      <input id="b1" name="b[]">
 *      <input id="b2" name="b[]">
 *      <input id="c" name="c">
 *   </fieldset>
 *   <select id="d" name="d">
 *     <option></option>
 *   </select>
 *   <fieldset>
 *     <input type="radio" id="e1" name="e">
 *     <input type="radio" id="e2" name="e">
 *   </fieldset>
 *   <select id="f" name="f" multiple>
 *     <option></option>
 *   </select>
 *   <fieldset>
 *     <input type="checkbox" id="g1" name="g">
 *     <input type="checkbox" id="g2" name="g">
 *   </fieldset>
 * </form>
 *
 * form.elements[0]; // Element input#a
 * form.elements[1]; // Element input#b1
 * form.elements[2]; // Element input#b2
 * form.elements[3]; // Element input#c
 * form.elements.a;  // Element input#a
 * form.elements.b;  // RadioNodeList<Element> [input#b1, input#b2]
 * form.elements.c;  // input#c
 *
 * // This is how a Lion form works (for simplicity Lion components have the 'l'-prefix):
 * <l-form>
 *  <form>
 *
 *    <!-- fields -->
 *
 *    <l-input id="a" name="a"></l-input>
 *
 *
 *    <!-- field sets ('sub forms') -->
 *
 *    <l-fieldset>
 *      <l-input id="b1" name="b"</l-input>
 *      <l-input id="b2" name="b"></l-input>
 *      <l-input id="c" name="c"></l-input>
 *    </l-fieldset>
 *
 *
 *    <!-- choice groups (children are 'end points') -->
 *
 *    <!-- single selection choice groups -->
 *    <l-select id="d" name="d">
 *      <l-option></l-option>
 *    </l-select>
 *    <l-radio-group id="e" name="e">
 *      <l-radio></l-radio>
 *      <l-radio></l-radio>
 *    </l-radio-group>
 *
 *    <!-- multi selection choice groups -->
 *    <l-select id="f" name="f" multiple>
 *      <l-option></l-option>
 *    </l-select>
 *    <l-checkbox-group id="g" name="g">
 *      <l-checkbox></l-checkbox>
 *      <l-checkbox></l-checkbox>
 *    </l-checkbox-group>
 *
 *  </form>
 * </l-form>
 *
 * lionForm.formElements[0];                  // Element l-input#a
 * lionForm.formElements[1];                  // Element l-input#b1
 * lionForm.formElements[2];                  // Element l-input#b2
 * lionForm.formElements.a;                   // Element l-input#a
 * lionForm.formElements['b[]'];              // Array<Element> [l-input#b1, l-input#b2]
 * lionForm.formElements.c;                   // Element l-input#c
 *
 * lionForm.formElements[d-g].formElements; // Array<Element>
 *
 * lionForm.formElements[d-e].value;          // String
 * lionForm.formElements[f-g].value;          // Array<String>
 */
class FormControlsCollection extends Array {
  /**
   * @desc Gives back the named keys and filters out array indexes
   * @return {string[]}
   * @protected
   */
  _keys() {
    return Object.keys(this).filter(k => Number.isNaN(Number(k)));
  }
}

// eslint-disable-next-line max-classes-per-file

/**
 * @typedef {import('../../types/FormControlMixinTypes').FormControlHost} FormControlHost
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').FormRegistrarMixin} FormRegistrarMixin
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').FormRegistrarHost} FormRegistrarHost
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').ElementWithParentFormGroup} ElementWithParentFormGroup
 * @typedef {import('../../types/registration/FormRegisteringMixinTypes').FormRegisteringHost} FormRegisteringHost
 * @typedef {FormControlHost & HTMLElement & {_parentFormGroup?:HTMLElement, checked?:boolean}} FormControl
 */

/**
 * @desc This allows an element to become the manager of a register.
 * It basically keeps track of a FormControlsCollection that it stores in .formElements
 * This will always be an array of all elements.
 * In case of a form or fieldset(sub form), it will also act as a key based object with FormControl
 * (fields, choice groups or fieldsets)as keys.
 * For choice groups, the value will only stay an array.
 * See FormControlsCollection for more information
 * @type {FormRegistrarMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const FormRegistrarMixinImplementation = superclass =>
  // eslint-disable-next-line no-shadow, no-unused-vars
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends FormRegisteringMixin(superclass) {
    /** @type {any} */
    static get properties() {
      return {
        _isFormOrFieldset: { type: Boolean },
      };
    }

    constructor() {
      super();

      /**
       * Closely mimics the natively supported HTMLFormControlsCollection. It can be accessed
       * both like an array and an object (based on control/element names).
       * @type {FormControlsCollection}
       */
      this.formElements = new FormControlsCollection();

      /**
       * Flag that determines how ".formElements" should behave.
       * For a regular fieldset (see LionFieldset) we expect ".formElements"
       * to be accessible as an object.
       * In case of a radio-group, a checkbox-group or a select/listbox,
       * it should act like an array (see ChoiceGroupMixin).
       * Usually, when false, we deal with a choice-group (radio-group, checkbox-group,
       * (multi)select)
       * @type {boolean}
       * @protected
       */
      this._isFormOrFieldset = false;

      this._onRequestToAddFormElement = this._onRequestToAddFormElement.bind(this);
      this._onRequestToChangeFormElementName = this._onRequestToChangeFormElementName.bind(this);

      this.addEventListener(
        'form-element-register',
        /** @type {EventListenerOrEventListenerObject} */ (this._onRequestToAddFormElement),
      );
      this.addEventListener(
        'form-element-name-changed',
        /** @type {EventListenerOrEventListenerObject} */ (this._onRequestToChangeFormElementName),
      );

      /**
       * initComplete resolves after all pending initialization logic
       * (for instance `<form-group .serializedValue=${{ child1: 'a', child2: 'b' }}>`)
       * is executed
       * @type {Promise<any>}
       */
      this.initComplete = new Promise((resolve, reject) => {
        this.__resolveInitComplete = resolve;
        this.__rejectInitComplete = reject;
      });

      /**
       * registrationComplete waits for all children formElements to have registered
       * @type {Promise<any> & {done?:boolean}}
       */
      this.registrationComplete = new Promise((resolve, reject) => {
        this.__resolveRegistrationComplete = resolve;
        this.__rejectRegistrationComplete = reject;
      });
      this.registrationComplete.done = false;
      this.registrationComplete.then(
        () => {
          this.registrationComplete.done = true;
          this.__resolveInitComplete(undefined);
        },
        () => {
          this.registrationComplete.done = true;
          this.__rejectInitComplete(undefined);
          throw new Error(
            'Registration could not finish. Please use await el.registrationComplete;',
          );
        },
      );
    }

    connectedCallback() {
      super.connectedCallback();
      this._completeRegistration();
    }

    /**
     * Resolves the registrationComplete promise. Subclassers can delay if needed
     * @overridable
     */
    _completeRegistration() {
      Promise.resolve().then(() => this.__resolveRegistrationComplete(undefined));
    }

    disconnectedCallback() {
      super.disconnectedCallback();

      if (this.registrationComplete.done === false) {
        Promise.resolve().then(() => {
          Promise.resolve().then(() => {
            this.__rejectRegistrationComplete();
          });
        });
      }
    }

    /**
     *
     * @param {ElementWithParentFormGroup} el
     */
    isRegisteredFormElement(el) {
      return this.formElements.some(exitingEl => exitingEl === el);
    }

    /**
     * @param {FormControl} child the child element (field)
     * @param {number} indexToInsertAt index to insert the form element at
     */
    addFormElement(child, indexToInsertAt) {
      // This is a way to let the child element (a lion-fieldset or lion-field) know, about its parent
      // eslint-disable-next-line no-param-reassign
      child._parentFormGroup = /** @type {* & FormRegistrarHost} */ (this);

      // 1. Add children as array element
      if (indexToInsertAt >= 0) {
        this.formElements.splice(indexToInsertAt, 0, child);
      } else {
        this.formElements.push(child);
      }

      // 2. Add children as object key
      if (this._isFormOrFieldset) {
        const { name } = child;
        if (!name) {
          console.info('Error Node:', child); // eslint-disable-line no-console
          throw new TypeError('You need to define a name');
        }
        if (name === this.name) {
          console.info('Error Node:', child); // eslint-disable-line no-console
          throw new TypeError(`You can not have the same name "${name}" as your parent`);
        }

        if (name.substr(-2) === '[]') {
          if (!Array.isArray(this.formElements[name])) {
            this.formElements[name] = new FormControlsCollection();
          }
          if (indexToInsertAt > 0) {
            this.formElements[name].splice(indexToInsertAt, 0, child);
          } else {
            this.formElements[name].push(child);
          }
        } else if (!this.formElements[name]) {
          this.formElements[name] = child;
        } else {
          console.info('Error Node:', child); // eslint-disable-line no-console
          throw new TypeError(
            `Name "${name}" is already registered - if you want an array add [] to the end`,
          );
        }
      }
    }

    /**
     * @param {FormControlHost} child the child element (field)
     */
    removeFormElement(child) {
      // 1. Handle array based children
      const index = this.formElements.indexOf(child);
      if (index > -1) {
        this.formElements.splice(index, 1);
      }

      // 2. Handle name based object keys
      if (this._isFormOrFieldset) {
        const { name } = child; // FIXME: <-- ElementWithParentFormGroup should become LionFieldWithParentFormGroup so that "name" exists
        if (name.substr(-2) === '[]' && this.formElements[name]) {
          const idx = this.formElements[name].indexOf(child);
          if (idx > -1) {
            this.formElements[name].splice(idx, 1);
          }
        } else if (this.formElements[name]) {
          delete this.formElements[name];
        }
      }
    }

    /**
     * Hook for Subclassers to perform logic before an element is added
     * @param {CustomEvent} ev
     * @protected
     */
    _onRequestToAddFormElement(ev) {
      const child = ev.detail.element;
      if (child === this) {
        // as we fire and listen - don't add ourselves
        return;
      }
      if (this.isRegisteredFormElement(child)) {
        // do not readd already existing elements
        return;
      }
      ev.stopPropagation();

      // Check for siblings to determine the right order to insert into formElements
      // If there is no next sibling, index is -1
      let indexToInsertAt = -1;
      if (this.formElements && Array.isArray(this.formElements)) {
        indexToInsertAt = this.formElements.indexOf(child.nextElementSibling);
      }
      this.addFormElement(child, indexToInsertAt);
    }

    /**
     * @param {CustomEvent} ev
     * @protected
     */
    _onRequestToChangeFormElementName(ev) {
      const element = this.formElements[ev.detail.oldName];
      if (element) {
        this.formElements[ev.detail.newName] = element;
        delete this.formElements[ev.detail.oldName];
      }
    }

    /**
     * @param {CustomEvent} ev
     * @protected
     */
    _onRequestToRemoveFormElement(ev) {
      const child = ev.detail.element;
      if (child === this) {
        // as we fire and listen - don't remove ourselves
        return;
      }
      if (!this.isRegisteredFormElement(child)) {
        // do not remove non existing elements
        return;
      }
      ev.stopPropagation();

      this.removeFormElement(child);
    }
  };

const FormRegistrarMixin = dedupeMixin(FormRegistrarMixinImplementation);

/**
 * @typedef {import('../../types/registration/FormRegistrarPortalMixinTypes').FormRegistrarPortalMixin} FormRegistrarPortalMixin
 * @typedef {import('../../types/registration/FormRegistrarPortalMixinTypes').FormRegistrarPortalHost} FormRegistrarPortalHost
 */

/**
 * This allows to register fields within a form even though they are not within the same dom tree.
 * It does that by redispatching the event on the registration target.
 * Neither form or field need to know about the portal. It acts as if the field is part of the dom tree.
 *
 * @example
 * <my-form></my-form>
 * <my-portal .registrationTarget=${document.querySelector('my-form')}>
 *   <my-field></my-field>
 * </my-portal>
 * // my-field will be registered within my-form
 * @type {FormRegistrarPortalMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<HTMLElement>} superclass
 */
const FormRegistrarPortalMixinImplementation = superclass =>
  // eslint-disable-next-line no-shadow, no-unused-vars
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class extends superclass {
    constructor() {
      super();

      /**
       * Registration target: an element, usually in the body of the dom, that captures events
       * and redispatches them on host
       * @type {(FormRegistrarPortalHost & HTMLElement) | undefined}
       */
      this.registrationTarget = undefined;
      this.__redispatchEventForFormRegistrarPortalMixin =
        this.__redispatchEventForFormRegistrarPortalMixin.bind(this);
      this.addEventListener(
        'form-element-register',
        /** @type {EventListenerOrEventListenerObject} */ (
          this.__redispatchEventForFormRegistrarPortalMixin
        ),
      );
    }

    /**
     * @param {CustomEvent} ev
     * @private
     */
    __redispatchEventForFormRegistrarPortalMixin(ev) {
      ev.stopPropagation();
      if (!this.registrationTarget) {
        throw new Error('A FormRegistrarPortal element requires a .registrationTarget');
      }
      this.registrationTarget.dispatchEvent(
        new CustomEvent('form-element-register', {
          detail: { element: ev.detail.element },
          bubbles: true,
        }),
      );
    }
  };

const FormRegistrarPortalMixin = dedupeMixin(FormRegistrarPortalMixinImplementation);

/**
 * @typedef {import('../types/NativeTextFieldMixinTypes').NativeTextFieldMixin} NativeTextFieldMixin
 * @type {NativeTextFieldMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass} superclass
 */
const NativeTextFieldMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class NativeTextFieldMixin extends FormatMixin(FocusMixin(FormControlMixin(superclass))) {
    /** @type {any} */
    static get properties() {
      return {
        autocomplete: { type: String, reflect: true },
      };
    }

    constructor() {
      super();

      /**
       * Delegates this property to input/textarea/select.
       * @type {string | undefined}
       */
      this.autocomplete = undefined;
    }

    /**
     * @protected
     * @type {HTMLInputElement | HTMLTextAreaElement}
     */
    get _inputNode() {
      return /** @type {HTMLInputElement | HTMLTextAreaElement} */ (super._inputNode);
    }

    /** @type {number} */
    get selectionStart() {
      const native = this._inputNode;
      if (native && native.selectionStart) {
        return native.selectionStart;
      }
      return 0;
    }

    set selectionStart(value) {
      const native = this._inputNode;
      if (native && native.selectionStart) {
        native.selectionStart = value;
      }
    }

    /** @type {number} */
    get selectionEnd() {
      const native = this._inputNode;
      if (native && native.selectionEnd) {
        return native.selectionEnd;
      }
      return 0;
    }

    set selectionEnd(value) {
      const native = this._inputNode;
      if (native && native.selectionEnd) {
        native.selectionEnd = value;
      }
    }

    /**
     * The view value. Will be delegated to `._inputNode.value`
     * @override FormatMixin
     */
    get value() {
      return (this._inputNode && this._inputNode.value) || this.__value || '';
    }

    /**
     * @param {string} value
     * @override FormatMixin - We don't delegate, because we want to preserve caret position via _setValueAndPreserveCaret
     */
    set value(value) {
      // if not yet connected to dom can't change the value
      if (this._inputNode) {
        // Only set if newValue is new, fix for Safari bug: https://github.com/ing-bank/lion/issues/1415
        if (this._inputNode.value !== value) {
          this._setValueAndPreserveCaret(value);
        }
        /** @type {string | undefined} */
        this.__value = undefined;
      } else {
        this.__value = value;
      }
    }

    /**
     * Restores the cursor to its original position after updating the value.
     * @param {string} newValue The value that should be saved.
     * @protected
     */
    _setValueAndPreserveCaret(newValue) {
      // Only preserve caret if focused (changing selectionStart will move focus in Safari)
      if (this.focused) {
        // Not all elements might have selection, and even if they have the
        // right properties, accessing them might throw an exception (like for
        // <input type=number>)
        try {
          // SelectElement doesn't have selectionStart/selectionEnd
          if (!(this._inputNode instanceof HTMLSelectElement)) {
            const start = this._inputNode.selectionStart;
            this._inputNode.value = newValue;
            // The cursor automatically jumps to the end after re-setting the value,
            // so restore it to its original position.
            this._inputNode.selectionStart = start;
            this._inputNode.selectionEnd = start;
          }
        } catch (error) {
          // Just set the value and give up on the caret.
          this._inputNode.value = newValue;
        }
      } else {
        this._inputNode.value = newValue;
      }
    }

    /**
     * @override FormatMixin
     */
    _reflectBackFormattedValueToUser() {
      super._reflectBackFormattedValueToUser();
      if (this._reflectBackOn() && this.focused) {
        try {
          // try/catch, because Safari is a bit sensitive here
          this._inputNode.selectionStart = this._inputNode.value.length;
          // eslint-disable-next-line no-empty
        } catch (_) {}
      }
    }

    /**
     * @configure FocusMixin
     */
    get _focusableNode() {
      return this._inputNode;
    }
  };

const NativeTextFieldMixin = dedupeMixin(NativeTextFieldMixinImplementation);

/* eslint-disable max-classes-per-file */

/**
 * @param {?} value
 */
const isString = value => typeof value === 'string';

class IsString extends Validator {
  static get validatorName() {
    return 'IsString';
  }

  /**
   * @param {?} value
   */
  // eslint-disable-next-line class-methods-use-this
  execute(value) {
    let hasError = false;
    if (!isString(value)) {
      hasError = true;
    }
    return hasError;
  }
}

class EqualsLength extends Validator {
  static get validatorName() {
    return 'EqualsLength';
  }

  /**
   * @param {?} value
   */
  execute(value, length = this.param) {
    let hasError = false;
    if (!isString(value) || value.length !== length) {
      hasError = true;
    }
    return hasError;
  }
}

class MinLength extends Validator {
  static get validatorName() {
    return 'MinLength';
  }

  /**
   * @param {?} value
   */
  execute(value, min = this.param) {
    let hasError = false;
    if (!isString(value) || value.length < min) {
      hasError = true;
    }
    return hasError;
  }
}

class MaxLength extends Validator {
  static get validatorName() {
    return 'MaxLength';
  }

  /**
   * @param {?} value
   */
  execute(value, max = this.param) {
    let hasError = false;
    if (!isString(value) || value.length > max) {
      hasError = true;
    }
    return hasError;
  }
}

class MinMaxLength extends Validator {
  static get validatorName() {
    return 'MinMaxLength';
  }

  /**
   * @param {?} value
   */
  execute(value, { min = 0, max = 0 } = this.param) {
    let hasError = false;
    if (!isString(value) || value.length < min || value.length > max) {
      hasError = true;
    }
    return hasError;
  }
}

const isEmailRegex =
  /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
class IsEmail$1 extends Validator {
  static get validatorName() {
    return 'IsEmail';
  }

  /**
   * @param {?} value
   */
  // eslint-disable-next-line class-methods-use-this
  execute(value) {
    let hasError = false;
    if (!isString(value) || !isEmailRegex.test(value.toLowerCase())) {
      hasError = true;
    }
    return hasError;
  }
}

/**
 * @param {?} value
 * @param {RegExp} pattern
 */
const hasPattern = (value, pattern) => pattern.test(value);
class Pattern extends Validator {
  static get validatorName() {
    return 'Pattern';
  }

  /**
   * @param {?} value
   */
  // eslint-disable-next-line class-methods-use-this
  execute(value, pattern = this.param) {
    if (!(pattern instanceof RegExp)) {
      throw new Error(
        'Psst... Pattern validator expects RegExp object as parameter e.g, new Pattern(/#LionRocks/) or new Pattern(RegExp("#LionRocks")',
      );
    }
    let hasError = false;
    if (!isString(value) || !hasPattern(value, pattern)) {
      hasError = true;
    }

    return hasError;
  }
}

/* eslint-disable max-classes-per-file */

/**
 * check for not being NaN (NaN is the only value in javascript which is not equal to itself)
 *
 * @param {number} value to check
 */
const isNumber = value =>
  // eslint-disable-next-line no-self-compare
  value === value && typeof value === 'number';

class IsNumber extends Validator {
  static get validatorName() {
    return 'IsNumber';
  }

  /**
   * @param {?} value
   */
  // eslint-disable-next-line class-methods-use-this
  execute(value) {
    let isEnabled = false;
    if (!isNumber(value)) {
      isEnabled = true;
    }
    return isEnabled;
  }
}

class MinNumber extends Validator {
  static get validatorName() {
    return 'MinNumber';
  }

  /**
   * @param {?} value
   */
  execute(value, min = this.param) {
    let isEnabled = false;
    if (!isNumber(value) || value < min) {
      isEnabled = true;
    }
    return isEnabled;
  }
}

class MaxNumber extends Validator {
  static get validatorName() {
    return 'MaxNumber';
  }

  /**
   * @param {?} value
   */
  execute(value, max = this.param) {
    let isEnabled = false;
    if (!isNumber(value) || value > max) {
      isEnabled = true;
    }
    return isEnabled;
  }
}

class MinMaxNumber extends Validator {
  static get validatorName() {
    return 'MinMaxNumber';
  }

  /**
   * @param {?} value
   */
  execute(value, { min = 0, max = 0 } = this.param) {
    let isEnabled = false;
    if (!isNumber(value) || value < min || value > max) {
      isEnabled = true;
    }
    return isEnabled;
  }
}

/* eslint-disable max-classes-per-file */

/**
 * @param {?} value
 */
function isDate(value) {
  return (
    Object.prototype.toString.call(value) === '[object Date]' && !Number.isNaN(value.getTime())
  );
}

class IsDate extends Validator {
  static get validatorName() {
    return 'IsDate';
  }

  /**
   * @param {?} value
   */
  // eslint-disable-next-line class-methods-use-this
  execute(value) {
    let hasError = false;
    if (!isDate(value)) {
      hasError = true;
    }
    return hasError;
  }
}

class MinDate extends Validator {
  static get validatorName() {
    return 'MinDate';
  }

  /**
   * @param {?} value
   */
  execute(value, min = this.param) {
    let hasError = false;
    if (!isDate(value) || normalizeDateTime(value) < normalizeDateTime(min)) {
      hasError = true;
    }
    return hasError;
  }
}

class MaxDate extends Validator {
  static get validatorName() {
    return 'MaxDate';
  }

  /**
   * @param {?} value
   */
  execute(value, max = this.param) {
    let hasError = false;
    if (!isDate(value) || normalizeDateTime(value) > normalizeDateTime(max)) {
      hasError = true;
    }
    return hasError;
  }
}

class MinMaxDate extends Validator {
  static get validatorName() {
    return 'MinMaxDate';
  }

  /**
   * @param {?} value
   */
  execute(value, { min = 0, max = 0 } = this.param) {
    let hasError = false;
    if (
      !isDate(value) ||
      normalizeDateTime(value) < normalizeDateTime(min) ||
      normalizeDateTime(value) > normalizeDateTime(max)
    ) {
      hasError = true;
    }
    return hasError;
  }
}

class IsDateDisabled extends Validator {
  static get validatorName() {
    return 'IsDateDisabled';
  }

  /**
   * @param {?} value
   */
  execute(value, isDisabledFn = this.param) {
    let hasError = false;
    if (!isDate(value) || isDisabledFn(value)) {
      hasError = true;
    }
    return hasError;
  }
}

/**
 * @typedef {import('../Validator').Validator} Validator
 */

class DefaultSuccess extends ResultValidator {
  /**
   * @param  {...any} args
   */
  constructor(...args) {
    super(...args);
    this.type = 'success';
  }

  /**
   *
   * @param {Object} context
   * @param {Validator[]} context.regularValidationResult
   * @param {Validator[]} context.prevValidationResult
   * @param {Validator[]} context.prevShownValidationResult
   * @returns {boolean}
   */
  // eslint-disable-next-line class-methods-use-this
  executeOnResults({ regularValidationResult, prevShownValidationResult }) {
    const errorOrWarning = /** @param {Validator} v */ v =>
      v.type === 'error' || v.type === 'warning';
    const hasErrorOrWarning = !!regularValidationResult.filter(errorOrWarning).length;
    const hasShownErrorOrWarning = !!prevShownValidationResult.filter(errorOrWarning).length;

    return !hasErrorOrWarning && hasShownErrorOrWarning;
  }
}

/**
 * @typedef {import('../../types/choice-group/ChoiceGroupMixinTypes').ChoiceGroupMixin} ChoiceGroupMixin
 * @typedef {import('../../types/FormControlMixinTypes').FormControlHost} FormControlHost
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').ElementWithParentFormGroup} ElementWithParentFormGroup
 * @typedef {import('../../types/form-group/FormGroupMixinTypes').FormControl} FormControl
 * @typedef {import('../../types/choice-group/ChoiceInputMixinTypes').ChoiceInputHost} ChoiceInputHost
 */

/**
 * ChoiceGroupMixin applies on both Fields (listbox/select-rich/combobox)  and FormGroups
 * (radio-group, checkbox-group)
 * TODO: Ideally, the ChoiceGroupMixin should not depend on InteractionStateMixin, which is only
 * designed for usage with Fields, in other words: their interaction states are not derived from
 * children events, like in FormGroups
 *
 * @type {ChoiceGroupMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const ChoiceGroupMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class ChoiceGroupMixin extends FormRegistrarMixin(InteractionStateMixin(superclass)) {
    /** @type {any} */
    static get properties() {
      return {
        multipleChoice: { type: Boolean, attribute: 'multiple-choice' },
      };
    }

    get modelValue() {
      const elems = this._getCheckedElements();
      if (this.multipleChoice) {
        return elems.map(el => el.choiceValue);
      }
      return elems[0] ? elems[0].choiceValue : '';
    }

    set modelValue(value) {
      /**
       * @param {ChoiceInputHost} el
       * @param {any} val
       */
      const checkCondition = (el, val) => {
        if (typeof el.choiceValue === 'object') {
          return JSON.stringify(el.choiceValue) === JSON.stringify(value);
        }
        return el.choiceValue === val;
      };

      if (this.__isInitialModelValue) {
        this.registrationComplete.then(() => {
          this.__isInitialModelValue = false;
          this._setCheckedElements(value, checkCondition);
          this.requestUpdate('modelValue', this._oldModelValue);
        });
      } else {
        this._setCheckedElements(value, checkCondition);
        this.requestUpdate('modelValue', this._oldModelValue);
      }
      this._oldModelValue = this.modelValue;
    }

    get serializedValue() {
      // We want to filter out disabled values out by default:
      // The goal of serializing values could either be submitting state to a backend
      // ot storing state in a backend. For this, only values that are entered by the end
      // user are relevant, choice values are always defined by the Application Developer
      // and known by the backend.

      // Assuming values are always defined as strings, modelValues and serializedValues
      // are the same.
      const elems = this._getCheckedElements();
      if (this.multipleChoice) {
        return elems.map(el => el.serializedValue.value);
      }
      return elems[0] ? elems[0].serializedValue.value : '';
    }

    set serializedValue(value) {
      /**
       * @param {ChoiceInputHost} el
       * @param {string} val
       */
      const checkCondition = (el, val) => el.serializedValue.value === val;

      if (this.__isInitialSerializedValue) {
        this.registrationComplete.then(() => {
          this.__isInitialSerializedValue = false;
          this._setCheckedElements(value, checkCondition);
          this.requestUpdate('serializedValue');
        });
      } else {
        this._setCheckedElements(value, checkCondition);
        this.requestUpdate('serializedValue');
      }
    }

    get formattedValue() {
      const elems = this._getCheckedElements();
      if (this.multipleChoice) {
        return elems.map(el => el.formattedValue);
      }
      return elems[0] ? elems[0].formattedValue : '';
    }

    set formattedValue(value) {
      /**
       * @param {{ formattedValue: string }} el
       * @param {string} val
       */
      const checkCondition = (el, val) => el.formattedValue === val;

      if (this.__isInitialFormattedValue) {
        this.registrationComplete.then(() => {
          this.__isInitialFormattedValue = false;
          this._setCheckedElements(value, checkCondition);
        });
      } else {
        this._setCheckedElements(value, checkCondition);
      }
    }

    constructor() {
      super();

      /**
       * When false (default), modelValue and serializedValue will reflect the
       * currently selected choice (usually a string). When true, modelValue will and
       * serializedValue will be an array of strings.
       * @type {boolean}
       */
      this.multipleChoice = false;

      /**
       * @type {'child'|'choice-group'|'fieldset'}
       * @configure FormControlMixin event propagation
       * @protected
       */
      this._repropagationRole = 'choice-group';
      /** @private */
      this.__isInitialModelValue = true;
      /** @private */
      this.__isInitialSerializedValue = true;
      /** @private */
      this.__isInitialFormattedValue = true;
    }

    connectedCallback() {
      super.connectedCallback();

      this.registrationComplete.then(() => {
        this.__isInitialModelValue = false;
        this.__isInitialSerializedValue = false;
        this.__isInitialFormattedValue = false;
      });
    }

    /**
     * @enhance FormRegistrarMixin: we need one extra microtask to complete
     */
    _completeRegistration() {
      // Double microtask queue to account for Webkit race condition
      Promise.resolve().then(() => super._completeRegistration());
    }

    /** @param {import('@lion/core').PropertyValues} changedProperties */
    updated(changedProperties) {
      super.updated(changedProperties);
      if (changedProperties.has('name') && this.name !== changedProperties.get('name')) {
        this.formElements.forEach(child => {
          // eslint-disable-next-line no-param-reassign
          child.name = this.name;
        });
      }
    }

    /**
     * @enhance FormRegistrarMixin
     * @param {FormControl} child
     * @param {number} indexToInsertAt
     */
    addFormElement(child, indexToInsertAt) {
      this._throwWhenInvalidChildModelValue(child);
      // eslint-disable-next-line no-param-reassign
      child.name = this.name;
      super.addFormElement(child, indexToInsertAt);
    }

    clear() {
      if (this.multipleChoice) {
        this.modelValue = [];
      } else {
        this.modelValue = '';
      }
    }

    /**
     * @override from FormControlMixin
     * @protected
     */
    _triggerInitialModelValueChangedEvent() {
      this.registrationComplete.then(() => {
        this._dispatchInitialModelValueChangedEvent();
      });
    }

    /**
     * A filter function which will exclude a form field when returning false
     * By default, exclude form fields which are disabled
     *
     * The type is be passed as well for more fine grained control, e.g.
     * distinguish the filter when fetching modelValue versus serializedValue
     *
     * @param {FormControl} el
     * @param {string} type
     * @returns {boolean}
     */
    // eslint-disable-next-line class-methods-use-this, no-unused-vars
    _getFromAllFormElementsFilter(el, type) {
      return true;
    }

    /**
     * Implicit :( @override for FormGroupMixin, as choice fields "fieldsets"
     * will always implement both mixins
     *
     * TODO: Consider making this explicit by extracting this method to its own mixin and
     * using it in both FormGroupMixin and ChoiceGroupMixin, then override it here
     * This also makes it more DRY as we have same method with similar implementation
     * in FormGroupMixin. I (@jorenbroekema) think the abstraction is worth it here..
     *
     * @param {string} property
     * @param {(el: FormControl, property?: string) => boolean} [filterFn]
     * @returns {{[name:string]: any}}
     * @protected
     */
    _getFromAllFormElements(property, filterFn) {
      // Prioritizes imperatively passed filter function over the protected method
      const _filterFn = filterFn || this._getFromAllFormElementsFilter;

      // For modelValue, serializedValue and formattedValue, an exception should be made,
      // The reset can be requested from children
      if (
        property === 'modelValue' ||
        property === 'serializedValue' ||
        property === 'formattedValue'
      ) {
        return this[property];
      }
      return this.formElements.filter(el => _filterFn(el, property)).map(el => el.property);
    }

    /**
     * @param {FormControl} child
     * @protected
     */
    _throwWhenInvalidChildModelValue(child) {
      if (
        typeof child.modelValue.checked !== 'boolean' ||
        !Object.prototype.hasOwnProperty.call(child.modelValue, 'value')
      ) {
        throw new Error(
          `The ${this.tagName.toLowerCase()} name="${
            this.name
          }" does not allow to register ${child.tagName.toLowerCase()} with .modelValue="${
            child.modelValue
          }" - The modelValue should represent an Object { value: "foo", checked: false }`,
        );
      }
    }

    /**
     * @protected
     */
    _isEmpty() {
      if (this.multipleChoice) {
        return this.modelValue.length === 0;
      }

      if (typeof this.modelValue === 'string' && this.modelValue === '') {
        return true;
      }
      if (this.modelValue === undefined || this.modelValue === null) {
        return true;
      }
      return false;
    }

    /**
     * @param {CustomEvent & {target:FormControl}} ev
     * @protected
     */
    _checkSingleChoiceElements(ev) {
      const { target } = ev;
      if (target.checked === false) return;

      const groupName = target.name;
      this.formElements
        .filter(i => i.name === groupName)
        .forEach(choice => {
          if (choice !== target) {
            choice.checked = false; // eslint-disable-line no-param-reassign
          }
        });
      // this.__triggerCheckedValueChanged();
    }

    /**
     * @protected
     */
    _getCheckedElements() {
      // We want to filter out disabled values by default
      return this.formElements.filter(el => el.checked && !el.disabled);
    }

    /**
     * @param {string | any[]} value
     * @param {Function} check
     * @protected
     */
    _setCheckedElements(value, check) {
      if (value === null || value === undefined) {
        // Uncheck all
        // eslint-disable-next-line no-return-assign, no-param-reassign
        this.formElements.forEach(fe => (fe.checked = false));
        return;
      }
      for (let i = 0; i < this.formElements.length; i += 1) {
        if (this.multipleChoice) {
          let valueIsIncluded = value.includes(this.formElements[i].modelValue.value);

          // For complex values, do a JSON Stringified includes check, because [{ v: 'foo'}].includes({ v: 'foo' }) => false
          if (typeof this.formElements[i].modelValue.value === 'object') {
            valueIsIncluded = /** @type {any[]} */ (value)
              .map(/** @param {Object} v */ v => JSON.stringify(v))
              .includes(JSON.stringify(this.formElements[i].modelValue.value));
          }

          this.formElements[i].checked = valueIsIncluded;
        } else if (check(this.formElements[i], value)) {
          // Allows checking against custom values e.g. formattedValue or serializedValue
          this.formElements[i].checked = true;
        } else {
          this.formElements[i].checked = false;
        }
      }
    }

    /**
     * @private
     */
    __setChoiceGroupTouched() {
      const value = this.modelValue;
      if (value != null && value !== this.__previousCheckedValue) {
        // TODO: what happens here exactly? Needs to be based on user interaction (?)
        this.touched = true;
        this.__previousCheckedValue = value;
      }
    }

    /**
     * @override FormControlMixin
     * @param {CustomEvent} ev
     * @protected
     */
    _onBeforeRepropagateChildrenValues(ev) {
      // Normalize target, since we might receive 'portal events' (from children in a modal,
      // see select-rich)
      const target = (ev.detail && ev.detail.element) || ev.target;
      if (this.multipleChoice || !target.checked) {
        return;
      }
      this.formElements.forEach(option => {
        if (target.choiceValue !== option.choiceValue) {
          option.checked = false; // eslint-disable-line no-param-reassign
        }
      });
      this.__setChoiceGroupTouched();
      this.requestUpdate('modelValue', this._oldModelValue);
      this._oldModelValue = this.modelValue;
    }

    /**
     * @param {FormControlHost & ChoiceInputHost} target
     * @protected
     * @configure FormControlMixin: don't repropagate unchecked single choice choiceInputs
     */
    _repropagationCondition(target) {
      return !(
        this._repropagationRole === 'choice-group' &&
        !this.multipleChoice &&
        !target.checked
      );
    }
  };

const ChoiceGroupMixin = dedupeMixin(ChoiceGroupMixinImplementation);

/* eslint-disable class-methods-use-this */

/**
 * @typedef {import('../../types/FormControlMixinTypes').FormControlHost} FormControlHost
 * @typedef {FormControlHost & HTMLElement & {_parentFormGroup?:HTMLElement, checked?:boolean}} FormControl
 * @typedef {import('../../types/choice-group/ChoiceInputMixinTypes').ChoiceInputMixin} ChoiceInputMixin
 * @typedef {import('../../types/choice-group/ChoiceInputMixinTypes').ChoiceInputModelValue} ChoiceInputModelValue
 */

/**
 * @param {ChoiceInputModelValue} nw\
 * @param {{value?:any, checked?:boolean}} old
 */
const hasChanged = (nw, old = {}) => nw.value !== old.value || nw.checked !== old.checked;

/**
 * @type {ChoiceInputMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const ChoiceInputMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class ChoiceInputMixin extends FormatMixin(superclass) {
    /** @type {any} */
    static get properties() {
      return {
        checked: { type: Boolean, reflect: true },
        disabled: { type: Boolean, reflect: true },
        modelValue: { type: Object, hasChanged },
        choiceValue: { type: Object },
      };
    }

    /**
     * The value that will be registered to the modelValue of the parent ChoiceGroup. Recommended
     * to be a string
     * @type {string|any}
     */
    get choiceValue() {
      return this.modelValue.value;
    }

    set choiceValue(value) {
      this.requestUpdate('choiceValue', this.choiceValue);
      if (this.modelValue.value !== value) {
        /** @type {ChoiceInputModelValue} */
        this.modelValue = { value, checked: this.modelValue.checked };
      }
    }

    /**
     * @param {string} name
     * @param {any} oldValue
     */
    requestUpdate(name, oldValue) {
      super.requestUpdate(name, oldValue);

      if (name === 'modelValue') {
        if (this.modelValue.checked !== this.checked) {
          this.__syncModelCheckedToChecked(this.modelValue.checked);
        }
      } else if (name === 'checked') {
        if (this.modelValue.checked !== this.checked) {
          this.__syncCheckedToModel(this.checked);
        }
      }
    }

    /**
     * @param {import('@lion/core').PropertyValues } changedProperties
     */
    firstUpdated(changedProperties) {
      super.firstUpdated(changedProperties);
      if (changedProperties.has('checked')) {
        // Here we set the initial value for our [slot=input] content,
        // which has been set by our SlotMixin
        this.__syncCheckedToInputElement();
      }
    }

    /**
     * @param {import('@lion/core').PropertyValues } changedProperties
     */
    updated(changedProperties) {
      super.updated(changedProperties);
      if (changedProperties.has('modelValue')) {
        this.__syncCheckedToInputElement();
      }

      if (
        changedProperties.has('name') &&
        this._parentFormGroup &&
        this._parentFormGroup.name !== this.name
      ) {
        this._syncNameToParentFormGroup();
      }
    }

    constructor() {
      super();
      /**
       * Boolean indicating whether or not this element is checked by the end user.
       */
      // TODO: [v1] this can be solved when property effects are scheduled until firstUpdated
      // this.checked = false;
      /**
       * Whereas 'normal' `.modelValue`s usually store a complex/typed version
       * of a view value, choice inputs have a slightly different approach.
       * In order to remain their Single Source of Truth characteristic, choice inputs
       * store both the value and 'checkedness', in the format { value: 'x', checked: true }
       * Different from the platform, this also allows to serialize the 'non checkedness',
       * allowing to restore form state easily and inform the server about unchecked options.
       * @type {{value:string|any,checked:boolean}}
       */
      this.modelValue = { value: '', checked: false };
      // TODO: maybe disabled is more a concern of FormControl/Field?
      /**
       * Boolean indicating whether or not this element is disabled.
       * @type {boolean}
       */
      this.disabled = false;

      /**
       * The value property of the modelValue. It provides an easy interface for storing
       * (complex) values in the modelValue
       */

      /** @protected */
      this._preventDuplicateLabelClick = this._preventDuplicateLabelClick.bind(this);
      /** @protected */
      this._toggleChecked = this._toggleChecked.bind(this);
    }

    /**
     * Styles for [input=radio] and [input=checkbox] wrappers.
     * For [role=option] extensions, please override completely
     */
    static get styles() {
      return [
        ...(super.styles || []),
        i$b`
          :host {
            display: flex;
            flex-wrap: wrap;
          }

          :host([hidden]) {
            display: none;
          }

          .choice-field__graphic-container {
            display: none;
          }
          .choice-field__help-text {
            display: block;
            flex-basis: 100%;
          }
        `,
      ];
    }

    /**
     * Template for [input=radio] and [input=checkbox] wrappers.
     * For [role=option] extensions, please override completely
     */
    render() {
      return x$1`
        <slot name="input"></slot>
        <div class="choice-field__graphic-container">${this._choiceGraphicTemplate()}</div>
        <div class="choice-field__label">
          <slot name="label"></slot>
        </div>
        <small class="choice-field__help-text">
          <slot name="help-text"></slot>
        </small>
        ${this._afterTemplate()}
      `;
    }

    /**
     * @protected
     */
    _choiceGraphicTemplate() {
      return A$1;
    }

    /**
     * @protected
     */
    _afterTemplate() {
      return A$1;
    }

    connectedCallback() {
      super.connectedCallback();
      if (this._labelNode) {
        this._labelNode.addEventListener('click', this._preventDuplicateLabelClick);
      }
      this.addEventListener('user-input-changed', this._toggleChecked);
    }

    disconnectedCallback() {
      super.disconnectedCallback();
      if (this._labelNode) {
        this._labelNode.removeEventListener('click', this._preventDuplicateLabelClick);
      }
      this.removeEventListener('user-input-changed', this._toggleChecked);
    }

    /**
     * The native platform fires an event for both the click on the label, and also
     * the redispatched click on the native input element.
     * This results in two click events arriving at the host, but we only want one.
     * This method prevents the duplicate click and ensures the correct isTrusted event
     * with the correct event.target arrives at the host.
     * @param {Event} ev
     * @protected
     */
    // eslint-disable-next-line no-unused-vars
    _preventDuplicateLabelClick(ev) {
      const __inputClickHandler = /** @param {Event} _ev */ _ev => {
        _ev.stopImmediatePropagation();
        this._inputNode.removeEventListener('click', __inputClickHandler);
      };
      this._inputNode.addEventListener('click', __inputClickHandler);
    }

    /**
     * @param {Event} ev
     * @protected
     */
    // eslint-disable-next-line no-unused-vars
    _toggleChecked(ev) {
      if (this.disabled) {
        return;
      }
      this._isHandlingUserInput = true;
      this.checked = !this.checked;
      this._isHandlingUserInput = false;
    }

    // TODO: make this less fuzzy by applying these methods in LionRadio and LionCheckbox
    // via instanceof (or feat. detection for tree-shaking in case parentGroup not needed)
    /**
     * Override this in case of extending ChoiceInputMixin and requiring
     * to sync differently with parent form group name
     * Right now it checks tag name match where the parent form group tagname
     * should include the child field tagname ('checkbox' is included in 'checkbox-group')
     * @protected
     */
    _syncNameToParentFormGroup() {
      // @ts-expect-error [external]: tagName should be a prop of HTMLElement
      if (this._parentFormGroup.tagName.includes(this.tagName)) {
        this.name = this._parentFormGroup?.name || '';
      }
    }

    /**
     * @param {boolean} checked
     * @private
     */
    __syncModelCheckedToChecked(checked) {
      this.checked = checked;
    }

    /**
     * @param {any} checked
     * @private
     */
    __syncCheckedToModel(checked) {
      this.modelValue = { value: this.choiceValue, checked };
    }

    /**
     * @private
     */
    __syncCheckedToInputElement() {
      // ._inputNode might not be available yet(slot content)
      // or at all (no reliance on platform construct, in case of [role=option])
      if (this._inputNode) {
        /** @type {HTMLInputElement} */
        (this._inputNode).checked = this.checked;
      }
    }

    /**
     * @override
     * This method is overridden from FormatMixin. It originally fired the normalizing
     * 'user-input-changed' event after listening to the native 'input' event.
     * However on Chrome on Mac whenever you use the keyboard
     * it fires the input AND change event. Other Browsers only fires the change event.
     * Therefore we disable the input event here.
     * @protected
     */
    _proxyInputEvent() {}

    /**
     * @override
     * hasChanged is designed for async (updated) callback, also check for sync
     * (requestUpdate) callback
     * @param {{ modelValue:unknown }} newV
     * @param {{ modelValue:unknown }} [old]
     * @protected
     */
    _onModelValueChanged({ modelValue }, old) {
      let _old;
      if (old && old.modelValue) {
        _old = old.modelValue;
      }
      // @ts-expect-error [external]: lit private property
      if (this.constructor.elementProperties.get('modelValue').hasChanged(modelValue, _old)) {
        super._onModelValueChanged({ modelValue });
      }
    }

    /**
     * @override
     * Overridden from FormatMixin, since a different modelValue is used for choice inputs.
     * Sets modelValue based on checked state (instead of value), so that changes will be detected.
     */
    parser() {
      return this.modelValue;
    }

    /**
     * @override Overridden from FormatMixin, since a different modelValue is used for choice inputs.
     * @param {ChoiceInputModelValue } modelValue
     */
    formatter(modelValue) {
      return modelValue && modelValue.value !== undefined ? modelValue.value : modelValue;
    }

    /**
     * @override
     * Overridden from LionField, since the modelValue should not be cleared.
     */
    // @ts-expect-error FIXME: @override gives error because LionField is not superclass type, this mixin should only allow LionField extensions
    clear() {
      this.checked = false;
    }

    /**
     * Used for required validator.
     * @protected
     */
    _isEmpty() {
      return !this.checked;
    }

    /**
     * @override
     * Overridden from FormatMixin, since a different modelValue is used for choice inputs.
     * Synchronization from user input is already arranged in this Mixin.
     * @protected
     */
    _syncValueUpwards() {}
  };

const ChoiceInputMixin = dedupeMixin(ChoiceInputMixinImplementation);

class FormElementsHaveNoError extends Validator {
  static get validatorName() {
    return 'FormElementsHaveNoError';
  }

  /**
   * @param {unknown} [value]
   * @param {string | undefined} [options]
   * @param {{ node: any }} [config]
   */
  // eslint-disable-next-line class-methods-use-this
  execute(value, options, config) {
    const hasError = config?.node._anyFormElementHasFeedbackFor('error');
    return hasError;
  }

  static async getMessage() {
    return '';
  }
}

/**
 * @typedef {import('../../types/form-group/FormGroupMixinTypes').FormGroupMixin} FormGroupMixin
 * @typedef {import('../../types/form-group/FormGroupMixinTypes').FormGroupHost} FormGroupHost
 * @typedef {import('../../types/form-group/FormGroupMixinTypes').FormControl} FormControl
 * @typedef {import('../../types/FormControlMixinTypes').FormControlHost} FormControlHost
 * @typedef {import('../../types/registration/FormRegisteringMixinTypes').FormRegisteringHost} FormRegisteringHost
 * @typedef {import('../../types/registration/FormRegistrarMixinTypes').ElementWithParentFormGroup} ElementWithParentFormGroup
 */

/**
 * @desc Form group mixin serves as the basis for (sub) forms. Designed to be put on
 * elements with [role="group|radiogroup"] (think of checkbox-group, radio-group, fieldset).
 * It bridges all the functionality of the child form controls:
 * ValidateMixin, InteractionStateMixin, FormatMixin, FormControlMixin etc.
 * It is designed to be used on top of FormRegistrarMixin and ChoiceGroupMixin.
 * Also, it is th basis of the LionFieldset element (which supports name based retrieval of
 * children via formElements and the automatic grouping of formElements via '[]').
 *
 * @type {FormGroupMixin}
 * @param {import('@open-wc/dedupe-mixin').Constructor<import('@lion/core').LitElement>} superclass
 */
const FormGroupMixinImplementation = superclass =>
  // @ts-ignore https://github.com/microsoft/TypeScript/issues/36821#issuecomment-588375051
  class FormGroupMixin extends FormRegistrarMixin(
    FormControlMixin(ValidateMixin(DisabledMixin(SlotMixin(superclass)))),
  ) {
    /** @type {any} */
    static get properties() {
      return {
        submitted: { type: Boolean, reflect: true },
        focused: { type: Boolean, reflect: true },
        dirty: { type: Boolean, reflect: true },
        touched: { type: Boolean, reflect: true },
        prefilled: { type: Boolean, reflect: true },
      };
    }

    /**
     * The host element with role group (or radigroup or form) containing neccessary aria attributes
     * @protected
     */
    get _inputNode() {
      return this;
    }

    /**
     * Object keyed by formElements names, containing formElements' modelValues
     */
    get modelValue() {
      return this._getFromAllFormElements('modelValue');
    }

    set modelValue(values) {
      if (this.__isInitialModelValue) {
        this.__isInitialModelValue = false;
        this.registrationComplete.then(() => {
          this._setValueMapForAllFormElements('modelValue', values);
        });
      } else {
        this._setValueMapForAllFormElements('modelValue', values);
      }
    }

    /**
     * Object keyed by formElements names, containing formElements' serializedValues
     */
    get serializedValue() {
      return this._getFromAllFormElements('serializedValue');
    }

    set serializedValue(values) {
      if (this.__isInitialSerializedValue) {
        this.__isInitialSerializedValue = false;
        this.registrationComplete.then(() => {
          this._setValueMapForAllFormElements('serializedValue', values);
        });
      } else {
        this._setValueMapForAllFormElements('serializedValue', values);
      }
    }

    /**
     * Object keyed by formElements names, containing formElements' formattedValues
     */
    get formattedValue() {
      return this._getFromAllFormElements('formattedValue');
    }

    set formattedValue(values) {
      this._setValueMapForAllFormElements('formattedValue', values);
    }

    /**
     * True when all of the children are prefilled (see InteractionStateMixin for more details.)
     */
    get prefilled() {
      return this._everyFormElementHas('prefilled');
    }

    constructor() {
      super();

      // ._inputNode === this, which always requires a value prop
      this.value = '';

      /**
       * Disables all formElements in group
       */
      this.disabled = false;

      /**
       * True when parent form is submitted
       */
      this.submitted = false;

      /**
       * True when any of the children is dirty (see InteractionStateMixin for more details.)
       */
      this.dirty = false;

      /**
       * True when the group as a whole is blurred (see InteractionStateMixin for more details.)
       */
      this.touched = false;

      /**
       * True when any of the children is focused.
       */
      this.focused = false;

      /** @private */
      this.__addedSubValidators = false;
      /** @private */
      this.__isInitialModelValue = true;
      /** @private */
      this.__isInitialSerializedValue = true;
      /** @private */
      this._checkForOutsideClick = this._checkForOutsideClick.bind(this);

      this.addEventListener('focusin', this._syncFocused);
      this.addEventListener('focusout', this._onFocusOut);
      this.addEventListener('dirty-changed', this._syncDirty);
      this.addEventListener('validate-performed', this.__onChildValidatePerformed);

      this.defaultValidators = [new FormElementsHaveNoError()];

      this.__descriptionElementsInParentChain = new Set();

      /** @type {{modelValue?:{[key:string]: any}, serializedValue?:{[key:string]: any}}} */
      this.__pendingValues = { modelValue: {}, serializedValue: {} };
    }

    connectedCallback() {
      super.connectedCallback();
      this.setAttribute('role', 'group');

      this.initComplete.then(() => {
        this.__isInitialModelValue = false;
        this.__isInitialSerializedValue = false;
        this.__initInteractionStates();
      });
    }

    disconnectedCallback() {
      super.disconnectedCallback();

      if (this.__hasActiveOutsideClickHandling) {
        document.removeEventListener('click', this._checkForOutsideClick);
        this.__hasActiveOutsideClickHandling = false;
      }
      this.__descriptionElementsInParentChain.clear();
    }

    __initInteractionStates() {
      this.formElements.forEach(el => {
        if (typeof el.initInteractionState === 'function') {
          el.initInteractionState();
        }
      });
    }

    /**
     * @override from FormControlMixin
     */
    _triggerInitialModelValueChangedEvent() {
      this.registrationComplete.then(() => {
        this._dispatchInitialModelValueChangedEvent();
      });
    }

    /**
     * @param {import('@lion/core').PropertyValues } changedProperties
     */
    updated(changedProperties) {
      super.updated(changedProperties);

      if (changedProperties.has('disabled')) {
        if (this.disabled) {
          this.__requestChildrenToBeDisabled();
        } else {
          this.__retractRequestChildrenToBeDisabled();
        }
      }

      if (changedProperties.has('focused')) {
        if (this.focused === true) {
          this.__setupOutsideClickHandling();
        }
      }
    }

    __setupOutsideClickHandling() {
      if (!this.__hasActiveOutsideClickHandling) {
        document.addEventListener('click', this._checkForOutsideClick);
        this.__hasActiveOutsideClickHandling = true;
      }
    }

    /**
     * @param {Event} event
     */
    _checkForOutsideClick(event) {
      const outsideGroupClicked = !this.contains(/** @type {Node} */ (event.target));
      if (outsideGroupClicked) {
        this.touched = true;
      }
    }

    __requestChildrenToBeDisabled() {
      this.formElements.forEach(child => {
        if (child.makeRequestToBeDisabled) {
          child.makeRequestToBeDisabled();
        }
      });
    }

    __retractRequestChildrenToBeDisabled() {
      this.formElements.forEach(child => {
        if (child.retractRequestToBeDisabled) {
          child.retractRequestToBeDisabled();
        }
      });
    }

    // eslint-disable-next-line class-methods-use-this
    _inputGroupTemplate() {
      return x$1`
        <div class="input-group">
          <slot></slot>
        </div>
      `;
    }

    /**
     * Handles interaction state 'submitted'.
     * This allows children to enable visibility of validation feedback
     */
    submitGroup() {
      this.submitted = true;
      this.formElements.forEach(child => {
        if (typeof child.submitGroup === 'function') {
          child.submitGroup();
        } else {
          child.submitted = true; // eslint-disable-line no-param-reassign
        }
      });
    }

    /**
     * Resets to initial/prefilled values and interaction states of all FormControls in group,
     */
    resetGroup() {
      this.formElements.forEach(child => {
        if (typeof child.resetGroup === 'function') {
          child.resetGroup();
        } else if (typeof child.reset === 'function') {
          child.reset();
        }
      });

      this.resetInteractionState();
    }

    /**
     * Clears all values and resets all interaction states of all FormControls in group,
     */
    clearGroup() {
      this.formElements.forEach(child => {
        if (typeof child.clearGroup === 'function') {
          child.clearGroup();
        } else if (typeof child.clear === 'function') {
          child.clear();
        }
      });

      this.resetInteractionState();
    }

    /**
     * Resets all interaction states for all formElements
     */
    resetInteractionState() {
      this.submitted = false;
      this.touched = false;
      this.dirty = false;
      this.formElements.forEach(formElement => {
        if (typeof formElement.resetInteractionState === 'function') {
          formElement.resetInteractionState();
        }
      });
    }

    /**
     * A filter function which will exclude a form field when returning false
     * By default, exclude form fields which are disabled
     *
     * The type is be passed as well for more fine grained control, e.g.
     * distinguish the filter when fetching modelValue versus serializedValue
     *
     * @param {FormControl} el
     * @param {string} type
     * @returns {boolean}
     */
    // eslint-disable-next-line class-methods-use-this, no-unused-vars
    _getFromAllFormElementsFilter(el, type) {
      return !el.disabled;
    }

    /**
     * Gets a keyed be name object for requested property (like modelValue/serializedValue)
     * @param {string} property
     * @param {(el: FormControl, property?: string) => boolean} [filterFn]
     * @returns {{[name:string]: any}}
     */
    _getFromAllFormElements(property, filterFn) {
      const result = {};

      // Prioritizes imperatively passed filter function over the protected method
      const _filterFn = filterFn || this._getFromAllFormElementsFilter;

      // @ts-ignore [allow-protected]: allow Form internals to access this protected method
      this.formElements._keys().forEach(name => {
        const elem = this.formElements[name];
        if (elem instanceof FormControlsCollection) {
          result[name] = elem.filter(el => _filterFn(el, property)).map(el => el[property]);
        } else if (_filterFn(elem, property)) {
          if (typeof elem._getFromAllFormElements === 'function') {
            result[name] = elem._getFromAllFormElements(property);
          } else {
            result[name] = elem[property];
          }
        }
      });
      return result;
    }

    /**
     * Sets the same value for requested property in all formElements
     * @param {string | number} property
     * @param {any} value
     */
    _setValueForAllFormElements(property, value) {
      this.formElements.forEach(el => {
        el[property] = value; // eslint-disable-line no-param-reassign
      });
    }

    /**
     * Allows to set formElements values via a keyed object structure
     * @param {string} property
     * @param {{ [x: string]: any; }} values
     */
    _setValueMapForAllFormElements(property, values) {
      if (values && typeof values === 'object') {
        Object.keys(values).forEach(name => {
          if (Array.isArray(this.formElements[name])) {
            this.formElements[name].forEach(
              (/** @type {FormControl} */ el, /** @type {number} */ index) => {
                el[property] = values[name][index]; // eslint-disable-line no-param-reassign
              },
            );
          }
          if (this.formElements[name]) {
            this.formElements[name][property] = values[name];
          } else {
            this.__pendingValues[property][name] = values[name];
          }
        });
      }
    }

    /**
     * Returns true when one of the formElements has requested
     * @param {string} property
     */
    _anyFormElementHas(property) {
      return Object.keys(this.formElements).some(name => {
        if (Array.isArray(this.formElements[name])) {
          return this.formElements[name].some((/** @type {FormControl} */ el) => !!el[property]);
        }
        return !!this.formElements[name][property];
      });
    }

    /**
     * @param {string} state one of ValidateHost.validationTypes
     */
    _anyFormElementHasFeedbackFor(state) {
      return Object.keys(this.formElements).some(name => {
        if (Array.isArray(this.formElements[name])) {
          return this.formElements[name].some((/** @type {FormControl} */ el) =>
            Boolean(el.hasFeedbackFor && el.hasFeedbackFor.includes(state)),
          );
        }
        return Boolean(
          this.formElements[name].hasFeedbackFor &&
            this.formElements[name].hasFeedbackFor.includes(state),
        );
      });
    }

    /**
     * Returns true when all of the formElements have requested property
     * @param {string} property
     */
    _everyFormElementHas(property) {
      return Object.keys(this.formElements).every(name => {
        if (Array.isArray(this.formElements[name])) {
          return this.formElements[name].every((/** @type {FormControl} */ el) => !!el[property]);
        }
        return !!this.formElements[name][property];
      });
    }

    // TODO: the same functionality has been implemented with model-value-changed event, which
    // covers the same and works with FormRegistrarPortalMixin
    /**
     * Gets triggered by event 'validate-performed' which enabled us to handle 2 different situations
     *  - react on modelValue change, which says something about the validity as a whole
     *  (at least two checkboxes for instance) and nothing about the children's values
     *  - children validity states have changed, so fieldset needs to update itself based on that
     * @param {Event} ev
     */
    __onChildValidatePerformed(ev) {
      if (ev && this.isRegisteredFormElement(/** @type {FormControl} */ (ev.target))) {
        this.validate();
      }
    }

    _syncFocused() {
      this.focused = this._anyFormElementHas('focused');
    }

    /**
     * @param {Event} ev
     */
    _onFocusOut(ev) {
      const lastEl = this.formElements[this.formElements.length - 1];
      if (ev.target === lastEl) {
        this.touched = true;
      }
      this.focused = false;
    }

    _syncDirty() {
      this.dirty = this._anyFormElementHas('dirty');
    }

    /**
     * Traverses the _parentFormGroup tree, and gathers all aria description elements
     * (feedback and helptext) that should be provided to children.
     *
     * In the example below, when the input for 'street' has focus, a screenreader user
     * would hear the #group-error.
     * In case one of the inputs was in error state as well, the SR user would
     * first hear the local error, followed by #group-error
     * @example
     * ```html
     * <lion-fieldset name="address">
     *   <lion-input name="street" label="Street" .modelValue="${'Park Avenue'}"></lion-input>
     *   <lion-input name="number" label="Number" .modelValue="${100}">...</lion-input>
     *   <div slot="feedback" id="group-error">
     *      Park Avenue only has numbers up to 80
     *   </div>
     * </lion-fieldset>
     * ```
     */
    __storeAllDescriptionElementsInParentChain() {
      const unTypedThis = /** @type {unknown} */ (this);
      let parent = /** @type {FormControlHost & { _parentFormGroup:any }} */ (unTypedThis);
      while (parent) {
        // @ts-ignore [allow-protected]: in parent/child relations we are allowed to call protected methods
        const descriptionElements = parent._getAriaDescriptionElements();
        const orderedEls = getAriaElementsInRightDomOrder(descriptionElements, { reverse: true });
        orderedEls.forEach(el => {
          this.__descriptionElementsInParentChain.add(el);
        });
        // Also check if the newly added child needs to refer grandparents
        parent = parent._parentFormGroup;
      }
    }

    /**
     * @param {FormControl} child
     */
    __linkParentMessages(child) {
      this.__descriptionElementsInParentChain.forEach(el => {
        if (typeof child.addToAriaDescribedBy === 'function') {
          child.addToAriaDescribedBy(el, { reorder: false });
        }
      });
    }

    /**
     * @param {FormControl} child
     */
    __unlinkParentMessages(child) {
      this.__descriptionElementsInParentChain.forEach(el => {
        if (typeof child.removeFromAriaDescribedBy === 'function') {
          child.removeFromAriaDescribedBy(el);
        }
      });
    }

    /**
     * @enhance FormRegistrarMixin: connects ValidateMixin and DisabledMixin.
     * On top of this, error messages of children are linked to their parents
     * @param {FormControl & {serializedValue:string|object}} child
     * @param {number} indexToInsertAt
     */
    addFormElement(child, indexToInsertAt) {
      super.addFormElement(child, indexToInsertAt);
      if (this.disabled) {
        child.makeRequestToBeDisabled();
      }
      if (!this.__descriptionElementsInParentChain.size) {
        this.__storeAllDescriptionElementsInParentChain();
      }
      this.__linkParentMessages(child);
      this.validate({ clearCurrentResult: true });

      if (typeof child.addToAriaLabelledBy === 'function' && this._labelNode) {
        child.addToAriaLabelledBy(this._labelNode, { reorder: false });
      }
      if (!child.modelValue) {
        const pVals = this.__pendingValues;
        if (pVals.modelValue && pVals.modelValue[child.name]) {
          // eslint-disable-next-line no-param-reassign
          child.modelValue = pVals.modelValue[child.name];
        } else if (pVals.serializedValue && pVals.serializedValue[child.name]) {
          // eslint-disable-next-line no-param-reassign
          child.serializedValue = pVals.serializedValue[child.name];
        }
      }
    }

    /**
     * Gathers initial model values of all children. Used when resetGroup() is called.
     */
    get _initialModelValue() {
      return this._getFromAllFormElements('_initialModelValue');
    }

    /**
     * @override FormRegistrarMixin; Connects ValidateMixin
     * @param {FormRegisteringHost & FormControl} el
     */
    removeFormElement(el) {
      super.removeFormElement(el);
      this.validate({ clearCurrentResult: true });

      if (typeof el.removeFromAriaLabelledBy === 'function' && this._labelNode) {
        el.removeFromAriaLabelledBy(this._labelNode, { reorder: false });
      }
      this.__unlinkParentMessages(el);
    }
  };

const FormGroupMixin = dedupeMixin(FormGroupMixinImplementation);

function asyncGeneratorStep$m(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$m(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$m(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$m(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
class Required extends Required$1 {
  /**
   * Returns a Boolean.  True if the test fails
   * @param {?} [modelValue]
   * @param {?} [param]
   * @param {{}} [config]
   * @returns {Boolean|Promise<Boolean>}
   */
  execute(modelValue, param, config) {
    return modelValue == "" || modelValue == undefined || modelValue == null;
  }

  /**
   * Give a message about this field being required.  Could be customised according to MessageData.
   * @param {MessageData | undefined} data
   * @returns {Promise<string>}
   */
  static getMessage(data) {
    return _asyncToGenerator$m(function* () {
      return data.formControl.egw().lang("Field must not be empty !!!");
    })();
  }
}

function asyncGeneratorStep$l(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$l(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$l(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$l(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * Manual validator for server-side validation messages passed
 * from Etemplate.  It just gives whatever message is passed in when created.
 *
 */
class ManualMessage extends ResultValidator {
  static get validatorName() {
    return "ManualMessage";
  }
  static getMessage(_ref) {
    return _asyncToGenerator$l(function* () {
      var {
        fieldName,
        modelValue,
        formControl,
        params
      } = _ref;
      return params;
    })();
  }
}

var _templateObject$1a;
function asyncGeneratorStep$k(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$k(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$k(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$k(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$_(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$Z(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$_(Object(source), true).forEach(function (key) { _defineProperty$1X(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$_(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$1a(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1X(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$8(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

// LionValidationFeedback needs to be registered manually
window.customElements.define('lion-validation-feedback', LionValidationFeedback);

/**
 * This mixin will allow any LitElement to become an Et2InputWidget
 *
 * Usage:
 * export class Et2Button extends Et2InputWidget(LitWidget)) {...}
 */

/**
 * Need to define the interface first, to get around TypeScript issues with protected/public
 * This must match the public API for Et2InputWidgetClass
 * @see https://lit.dev/docs/composition/mixins/#typing-the-subclass
 */
var Et2InputWidgetMixin = superclass => {
  var _dec, _class;
  var Et2InputWidgetClass = (_dec = e$c(), (_class = class Et2InputWidgetClass extends Et2Widget(superclass) {
    /** WebComponent **/
    static get styles() {
      return [...super.styles, i$b(_templateObject$1a || (_templateObject$1a = _taggedTemplateLiteral$1a(["\n\t\t\t\t  /* Allow actually disabled inputs */\n\n\t\t\t\t  :host([disabled]) {\n\t\t\t\t\tdisplay: initial;\n\t\t\t\t  }\n\n\t\t\t\t  /* Needed so required can show through */\n\n\t\t\t\t  ::slotted(input), input {\n\t\t\t\t\tbackground-color: transparent;\n\t\t\t\t  }\n\n\t\t\t\t  /* Used to allow auto-sizing on slotted inputs */\n\n\t\t\t\t  .input-group__container > .input-group__input ::slotted(.form-control) {\n\t\t\t\t\twidth: 100%;\n\t\t\t\t  }\n\n\t\t\t\t  .form-control__help-text {\n\t\t\t\t\tposition: relative;\n\t\t\t\t  }\n\t\t\t\t"])))];
    }
    static get properties() {
      return _objectSpread$Z(_objectSpread$Z({}, super.properties), {}, {
        /**
         * The label of the widget
         * Overridden from parent to use our accessors
         */
        label: {
          type: String,
          noAccessor: true
        },
        // readOnly is what the property is in Lion, readonly is the attribute
        readOnly: {
          type: Boolean,
          attribute: 'readonly'
        },
        // readonly is what is in the templates
        // I put this in here so loadWebComponent finds it when it tries to set it from the template
        readonly: {
          type: Boolean,
          reflect: true
        },
        required: {
          type: Boolean,
          reflect: true
        },
        onchange: {
          type: Function
        },
        /**
         * Have browser focus this input on load.
         * Overrides etemplate2.focusOnFirstInput(), use only once per page
         * https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#attributes
         */
        autofocus: {
          type: Boolean,
          reflect: true
        },
        autocomplete: {
          type: String
        }
      });
    }

    /**
     * List of properties that get translated
     * Done separately to not interfere with properties - if we re-define label property,
     * labels go missing.
     * @returns object
     */
    static get translate() {
      return _objectSpread$Z(_objectSpread$Z({}, super.translate), {}, {
        placeholder: true
      });
    }

    /**
     * Compatibility for deprecated name "needed"
     *
     * @deprecated use required instead
     * @param val
     */
    set needed(val) {
      this.required = val;
    }
    /**
     * Compatibility for deprecated name "needed"
     *
     * @deprecated use required instead
     */
    get needed() {
      return this.required;
    }
    constructor() {
      super(...arguments);
      _defineProperty$1X(this, "__readonly", void 0);
      _defineProperty$1X(this, "__label", "");
      _defineProperty$1X(this, "_oldValue", void 0);
      _defineProperty$1X(this, "node", void 0);
      // Validators assigned to one specific instance of a widget
      _defineProperty$1X(this, "validators", void 0);
      // Validators for every instance of a type of widget
      _defineProperty$1X(this, "defaultValidators", void 0);
      // Promise used during validation
      _defineProperty$1X(this, "validateComplete", void 0);
      // Hold on to any server messages while the user edits
      _defineProperty$1X(this, "_messagesHeldWhileFocused", void 0);
      _defineProperty$1X(this, "isSlComponent", false);
      this.validators = [];
      this.defaultValidators = [];
      this._messagesHeldWhileFocused = [];
      this.readonly = false;
      this.required = false;
      this._oldValue = this.getValue();
      this.isSlComponent = typeof this.handleChange === 'function';
      this.et2HandleFocus = this.et2HandleFocus.bind(this);
      this.et2HandleBlur = this.et2HandleBlur.bind(this);
      this.autocomplete = 'on';
    }
    connectedCallback() {
      super.connectedCallback();
      this._oldChange = this._oldChange.bind(this);
      this.node = this.getInputNode();
      this.updateComplete.then(() => {
        this.addEventListener(this.isSlComponent ? 'sl-change' : 'change', this._oldChange);
      });
      this.addEventListener("focus", this.et2HandleFocus);
      this.addEventListener("blur", this.et2HandleBlur);
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this.removeEventListener(this.isSlComponent ? 'sl-change' : 'change', this._oldChange);
      this.removeEventListener("focus", this.et2HandleFocus);
      this.removeEventListener("blur", this.et2HandleBlur);
    }

    /**
     * A property has changed, and we want to make adjustments to other things
     * based on that
     *
     * @param changedProperties
     */
    updated(changedProperties) {
      super.updated(changedProperties);

      // required changed, add / remove validator
      if (changedProperties.has('required')) {
        // Remove all existing Required validators (avoids duplicates)
        this.validators = (this.validators || []).filter(validator => !(validator instanceof Required));
        if (this.required) {
          this.validators.push(new Required());
        }
      }
      if (changedProperties.has("value")) {
        // Base off this.value, not this.getValue(), to ignore readonly
        this.classList.toggle("hasValue", !(this.value == null || this.value == ""));
      }
    }

    /**
     * Change handler calling custom handler set via onchange attribute
     *
     * @param _ev
     * @returns
     */
    _oldChange(_ev) {
      if (typeof this.onchange == 'function' && (
      // If we have an instanceManager, make sure it's ready.  Otherwise, we ignore the event
      !this.getInstanceManager() || this.getInstanceManager().isReady)) {
        // Make sure function gets a reference to the widget, splice it in as 2. argument if not
        var args = Array.prototype.slice.call(arguments);
        if (args.indexOf(this) == -1) {
          args.splice(1, 0, this);
        }
        return this.onchange(...args);
      }
      return true;
    }

    /**
     * When input receives focus, clear any validation errors.
     *
     * If the value is the same on blur, we'll put them back
     * The ones from the server (ManualMessage) can interfere with submitting.
     *
     * Named et2HandleFocus to avoid overwriting handleFocus() in Shoelace components
     *
     * @param {FocusEvent} _ev
     */
    et2HandleFocus(_ev) {
      if (this._messagesHeldWhileFocused.length > 0) {
        return;
      }

      // Collect any ManualMessages
      this._messagesHeldWhileFocused = (this.validators || []).filter(validator => validator instanceof ManualMessage);
      // Remove ManualMessages from validators list
      for (var i = 0; i < this.validators.length; i++) {
        if (this._messagesHeldWhileFocused.indexOf(this.validators[i]) != -1) {
          this.validators.splice(i, 1);
        }
      }
      this.updateComplete.then(() => {
        // Remove all messages.  Manual will be explicitly replaced, other validators will be re-run on blur.
        this.querySelectorAll("lion-validation-feedback").forEach(e => e.remove());
      });
    }

    /**
     * If the value is unchanged, put any held validation messages back
     *
     * Named et2HandleBlur to avoid overwriting handleBlur() in Shoelace components
     *
     * @param {FocusEvent} _ev
     */
    et2HandleBlur(_ev) {
      if (this._messagesHeldWhileFocused.length > 0 && this.getValue() == this._oldValue) {
        this.validators = this.validators.concat(this._messagesHeldWhileFocused);
        this._messagesHeldWhileFocused = [];
      }
      this.updateComplete.then(() => {
        this.validate();
      });
    }
    set_value(new_value) {
      this.value = new_value;

      // Save this so we can compare against any user changes
      this._oldValue = this.getValue();
      if (typeof this._callParser == "function") {
        this.modelValue = this._callParser(new_value);
      }
    }
    get_value() {
      return this.getValue();
    }
    set_readonly(new_value) {
      this.readonly = new_value;
    }

    // Deal with Lion readOnly vs etemplate readonly
    set readonly(new_value) {
      this.__readonly = super.__readOnly = new_value;
      this.requestUpdate("readonly");
    }
    get readonly() {
      return this.__readonly;
    }
    set readOnly(new_value) {
      this.readonly = new_value;
    }

    /**
     *  Lion mapping
     * @deprecated
     */
    get readOnly() {
      return this.readonly;
    }

    /**
     * @param boolean submit_value true: call by etemplate2.(getValues|submit|postSubmit)()
     */
    getValue(submit_value) {
      return this.readonly || this.disabled ? null :
      // Give a clone of objects or receiver might use the reference
      this.value && typeof this.value == "object" ? typeof this.value.length == "undefined" ? _objectSpread$Z({}, this.value) : [...this.value] : this.value;
    }

    /**
     * The label of the widget
     * Legacy support for labels with %s that get wrapped around the widget
     *
     * Not the best way go with webComponents - shouldn't modify their DOM like this
     *
     * @param new_label
     */
    set label(new_label) {
      if (!new_label || !new_label.includes("%s")) {
        return super.label = new_label;
      }
      this.__label = new_label;
      var [pre, post] = et2_csvSplit(new_label, 2, "%s");
      this.label = pre;
      if ((post === null || post === void 0 ? void 0 : post.trim().length) > 0) {
        this.updateComplete.then(() => {
          var _this$parentNode;
          var label = document.createElement("et2-description");
          label.innerText = post;
          // Put in suffix, if parent has a suffix slot
          if ((_this$parentNode = this.parentNode) !== null && _this$parentNode !== void 0 && (_this$parentNode = _this$parentNode.shadowRoot) !== null && _this$parentNode !== void 0 && _this$parentNode.querySelector("slot[name='suffix']")) {
            label.slot = "suffix";
          }
          this.parentNode.append(label);
        });
      }
    }
    get label() {
      return this.__label;
    }
    isDirty() {
      // Readonly can't be dirty, it can't change
      if (this.readonly) {
        return false;
      }
      var value = this.getValue();
      if (typeof value !== typeof this._oldValue) {
        return true;
      }
      if (this._oldValue === value) {
        return false;
      }
      switch (typeof this._oldValue) {
        case "object":
          if (Array.isArray(this._oldValue) && this._oldValue.length !== value.length) {
            return true;
          }
          for (var key in this._oldValue) {
            if (this._oldValue[key] !== value[key]) {
              return true;
            }
          }
          return false;
        default:
          return this._oldValue != value;
      }
    }
    resetDirty() {
      this._oldValue = this.getValue();
    }

    /**
     * Used by etemplate2 to determine if we can submit or not
     *
     * @param messages
     * @returns {boolean}
     */
    isValid(messages) {
      var ok = true;
      debugger;

      // Check for required
      if (this.required && !this.readonly && !this.disabled && (this.getValue() == null || this.getValue().valueOf() == '')) {
        messages.push(this.egw().lang('Field must not be empty !!!'));
        ok = false;
      }
      return ok;
    }
    getInputNode() {
      // From LionInput
      return this._inputNode;
    }
    transformAttributes(attrs) {
      super.transformAttributes(attrs);

      // Set attributes for the form / autofill.  It's the individual widget's
      // responsibility to do something appropriate with these properties.
      if (this.autocomplete == "on" && window.customElements.get(this.localName).getPropertyOptions("name") != "undefined" && this.getArrayMgr("content") !== null) {
        this.name = this.getArrayMgr("content").explodeKey(this.id).pop();
      }

      // Check whether an validation error entry exists
      if (this.id && this.getArrayMgr("validation_errors")) {
        var val = this.getArrayMgr("validation_errors").getEntry(this.id);
        if (val) {
          this.set_validation_error(val);
        }
      }
    }

    /**
     * Massively simplified validate, as compared to what ValidatorMixin gives us, since ValidatorMixin extends
     * FormControlMixin which breaks SlSelect's render()
     *
     * We take all validators for the widget, and if there's a value (or field is required) we check the value
     * with each validator.  For array values we check each element with each validator.  If the value does not
     * pass the validator, we collect the message and display feedback to the user.
     *
     * We handle validation errors from the server with ManualMessages, which always "fail".
     * If the value is empty, we only validate if the field is required.
     *
     * @param skipManual Do not run any manual validators, used during submit check.  We don't want manual validators to block submit.
     */
    validate() {
      var _arguments = arguments,
        _this = this;
      return _asyncToGenerator$k(function* () {
        var _this$querySelector;
        var skipManual = _arguments.length > 0 && _arguments[0] !== undefined ? _arguments[0] : false;
        if (_this.readonly || _this.disabled) {
          // Don't validate if the widget is read-only, there's nothing the user can do about it
          return Promise.resolve();
        }
        var validators = [...(_this.validators || []), ...(_this.defaultValidators || [])];
        var fieldName = _this.id;
        var feedbackData = [];
        var resultPromises = [];
        (_this$querySelector = _this.querySelector("lion-validation-feedback")) === null || _this$querySelector === void 0 || _this$querySelector.remove();

        // Collect message of a (failing) validator
        var doValidate = /*#__PURE__*/function () {
          var _ref = _asyncToGenerator$k(function* (validator, value) {
            if (validator.config.fieldName) {
              fieldName = yield validator.config.fieldName;
            }
            // @ts-ignore [allow-protected]
            return validator._getMessage({
              modelValue: value,
              formControl: this,
              fieldName
            }).then(message => {
              feedbackData.push({
                message,
                type: validator.type,
                validator
              });
            });
          });
          return function (_x, _x2) {
            return _ref.apply(this, arguments);
          };
        }().bind(_this);

        // Check if a validator fails
        var doCheck = /*#__PURE__*/function () {
          var _ref2 = _asyncToGenerator$k(function* (value, validator) {
            var result = validator.execute(value, validator.param, {
              node: _this
            });
            if (result === true) {
              resultPromises.push(doValidate(validator, value));
            } else if (result !== false && typeof result.then === 'function') {
              result.then(doValidate(validator, value));
              resultPromises.push(result);
            }
          });
          return function doCheck(_x3, _x4) {
            return _ref2.apply(this, arguments);
          };
        }();
        validators.map( /*#__PURE__*/function () {
          var _ref3 = _asyncToGenerator$k(function* (validator) {
            var values = _this.getValue();
            if (values !== null && !Array.isArray(values)) {
              values = [values];
            }
            if (values !== null && !values.length) {
              values = [''];
            } // so required validation works

            // Run manual validation messages just once, doesn't usually matter what the value is
            if (validator instanceof ManualMessage) {
              if (!skipManual) {
                doCheck(values, validator);
              }
            }
            // Only validate if field is required, or not required and has a value
            // Don't bother to validate empty fields
            else if (_this.required || !_this.required && _this.getValue() != '' && _this.getValue() !== null) {
              // Validate each individual item
              values.forEach(value => doCheck(value, validator));
            }
          });
          return function (_x5) {
            return _ref3.apply(this, arguments);
          };
        }());
        _this.validateComplete = Promise.all(resultPromises);

        // Wait until all validation is finished, then update UI
        _this.validateComplete.then(() => {
          // Show feedback from all failing validators
          if (feedbackData.length > 0) {
            var feedback = document.createElement("lion-validation-feedback");
            feedback.feedbackData = feedbackData;
            feedback.slot = "help-text";
            _this.append(feedback);
            if (_this.shadowRoot.querySelector("slot[name='feedback']")) {
              feedback.slot = "feedback";
            } else if (_this.shadowRoot.querySelector("#help-text")) {
              // Not always visible?
              _this.shadowRoot.querySelector("#help-text").style.display = "initial";
            } else {
              // No place to show the validation error.  That's a widget problem, but we'll show it as message
              _this.egw().message(feedback.textContent, "error");
            }
          }
        });
        return _this.validateComplete;
      })();
    }
    set_validation_error(err) {
      /* Shoelace uses constraint validation API
      https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#the-constraint-validation-api
      	if(err === false && this.setCustomValidity)
      {
      	// Remove custom validity
      	this.setCustomValidity('');
      	return;
      }
      this.setCustomValidity(err);
      	// must call reportValidity() or nothing will happen
      this.reportValidity();
      	 */

      if (err === false) {
        // Remove all Manual validators
        this.validators = (this.validators || []).filter(validator => !(validator instanceof ManualMessage));
        return;
      }
      // Need to change interaction state so messages show up
      // submitted is a little heavy-handed, especially on first load, but it works
      this.submitted = true;

      // Add validator
      this.validators.push(new ManualMessage(err));
      // Force a validate - not needed normally, but if you call set_validation_error() manually,
      // it won't show up without validate()
      this.validate();
    }

    /**
     * Get a list of feedback types
     *
     * @returns {string[]}
     */
    get hasFeedbackFor() {
      var _this$querySelector2;
      var feedback = ((_this$querySelector2 = this.querySelector("lion-validation-feedback")) === null || _this$querySelector2 === void 0 ? void 0 : _this$querySelector2.feedbackData) || [];
      return feedback.map(f => f.type);
    }

    /**
     * Called whenever the template gets submitted. We return false if the widget
     * is not valid, which cancels the submission.
     *
     * @param _values contains the values which will be sent to the server.
     * 	Listeners may change these values before they get submitted.
     */
    submit(_values) {
      var _this2 = this;
      return _asyncToGenerator$k(function* () {
        _this2.submitted = true;

        // If using Lion validators, run them now
        if (_this2.validate) {
          // Force update now
          _this2.validate(true);
          yield _this2.validateComplete;
          return (_this2.hasFeedbackFor || []).indexOf("error") == -1;
        }
        return true;
      })();
    }
  }, (_applyDecoratedDescriptor$8(_class.prototype, "label", [_dec], Object.getOwnPropertyDescriptor(_class.prototype, "label"), _class.prototype)), _class));
  return Et2InputWidgetClass;
};
var Et2InputWidget = dedupeMixin(Et2InputWidgetMixin);

/**
 * Loads the given URL asynchronously from the server
 *
 * We make the Ajax call through main-windows jQuery object, to ensure cached copy
 * in main-windows etemplate2 prototype works in IE too!
 *
 * @param {string} _url
 * @param {function} _callback function(_xml)
 * @param {object} _context for _callback
 * @param {function} _fail_callback function(_xml)
 * @return Promise
 */
function et2_loadXMLFromURL(_url, _callback, _context, _fail_callback) {
  if (typeof _context == "undefined") {
    _context = null;
  }

  // use window object from main window with same algorithm as for the template cache
  var win;
  try {
    if (opener && opener.etemplate2) {
      win = opener;
    }
  } catch (e) {
    // catch security exception if opener is from a different domain
  }
  if (typeof win == "undefined") {
    win = egw$1.top;
  }

  // if preprocessor is missing --> add it
  if (_url.indexOf('/etemplate.php/') === -1) {
    var parts = _url.match(/^(.*)(\/[^/]+\/templates\/.*)$/);
    if (parts) {
      _url = parts[1] + '/api/etemplate.php' + parts[2];
    }
  }

  // we add the full url (protocol and domain) as sometimes just the path
  // gives a CSP error interpreting it as file:///path
  // (if there are a enough 404 errors in html content ...)
  return win.fetch((_url[0] === '/' ? location.protocol + '//' + location.host : '') + _url, {
    method: 'GET'
  }).then(response => {
    if (!response.ok) {
      throw response;
    }
    return response.text();
  }).then(xml => {
    var parser = new window.DOMParser();
    return parser.parseFromString(xml, "text/xml");
  }).then(xmldoc => {
    if (typeof _callback === 'function') {
      _callback.call(_context, xmldoc.children[0]);
    }
    return xmldoc.children[0];
  }).catch(_err => {
    egw$1().message('Loading eTemplate from ' + _url + ' failed!' + "\n\n" + (typeof _err.stack !== 'undefined' ? _err.stack : _err.status + ' ' + _err.statusText), 'error');
    if (typeof _fail_callback === 'function') {
      _fail_callback.call(_context, _err);
    }
  });
}
function et2_directChildrenByTagName(_node, _tagName) {
  // Normalize the tag name
  _tagName = _tagName.toLowerCase();
  var result = [];
  for (var i = 0; i < _node.childNodes.length; i++) {
    if (_tagName == _node.childNodes[i].nodeName.toLowerCase()) {
      result.push(_node.childNodes[i]);
    }
  }
  return result;
}
function et2_filteredNodeIterator(_node, _callback, _context) {
  for (var i = 0; i < _node.childNodes.length; i++) {
    var node = _node.childNodes[i];
    var nodeName = node.nodeName.toLowerCase();
    if (nodeName.charAt(0) != "#") {
      _callback.call(_context, node, nodeName);
    }
  }
}
function et2_readAttrWithDefault(_node, _name, _default) {
  var val = _node.getAttribute(_name);
  return val === null ? _default : val;
}

/**
 * Interface for select options
 *
 * While we can (mostly) handle key => value maps, this is the preferred way to specify selectable options.
 * For option groups, value is the list of sub-options.
 *
 */

/**
 * Find the select options for a widget, out of the many places they could be.
 *
 * This will give valid, correct array of SelectOptions.  It will check:
 * - sel_options ArrayMgr, taking into account namespaces and checking the root
 * - content ArrayMgr, looking for "options-<id>"
 * - passed options, used by specific select types
 *
 * @param {Et2Widget} widget to check for.  Should be some sort of select widget.
 * @param {object} attr_options Select options in attributes array
 * @param {SelectOption[]} options Known options, passed in if you've already got some.  Cached type options, for example.
 * @return {SelectOption[]} Select options, or empty array
 */
function find_select_options(widget, attr_options) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var name_parts = widget.id.replace(/&#x5B;/g, '[').replace(/]|&#x5D;/g, '').split('[');
  var content_options = [];

  // Try to find the options inside the "sel-options"
  if (widget.getArrayMgr("sel_options")) {
    // Try first according to ID
    var _options = widget.getArrayMgr("sel_options").getEntry(widget.id);
    // ID can get set to an array with 0 => ' ' - not useful
    if (_options && (_options.length == 1 && typeof _options[0] == 'string' && _options[0].trim() == '' ||
    // eg. autorepeated id "cat[3]" would pick array element 3 from cat
    typeof _options.value != 'undefined' && typeof _options.label != 'undefined' && widget.id.match(/\[\d+]$/))) {
      content_options = null;
    } else {
      content_options = _options;
    }
    // We could wind up too far inside options if label,title are defined
    if (_options && !isNaN(name_parts[name_parts.length - 1]) && _options.label && _options.title) {
      name_parts.pop();
      content_options = widget.getArrayMgr("sel_options").getEntry(name_parts.join('['));
      delete content_options["$row"];
    }

    // Select options tend to be defined once, at the top level, so try that
    if (!content_options || content_options.length == 0) {
      content_options = widget.getArrayMgr("sel_options").getRoot().getEntry(name_parts[name_parts.length - 1]);
    }

    // Try in correct namespace (inside a grid or something)
    if (!content_options || content_options.length == 0) {
      content_options = widget.getArrayMgr("sel_options").getEntry(name_parts[name_parts.length - 1]);
    }

    // Try name like widget[$row]
    if (name_parts.length > 1 && (!content_options || content_options.length == 0)) {
      var pop_that = JSON.parse(JSON.stringify(name_parts));
      while (pop_that.length > 1 && (!content_options || content_options.length == 0)) {
        var last = pop_that.pop();
        content_options = widget.getArrayMgr('sel_options').getEntry(pop_that.join('['));

        // Double check, might have found a normal parent namespace ( eg subgrid in subgrid[selectbox] )
        // with an empty entry for the selectbox.  If there were valid options here,
        // we would have found them already, and keeping this would result in the ID as an option
        if (content_options && !Array.isArray(content_options) && typeof content_options[last] != 'undefined' && content_options[last]) {
          content_options = content_options[last];
        } else if (content_options) {
          // Check for real values
          for (var key in content_options) {
            if (!(isNaN(key) && typeof content_options[key] === 'string' || !isNaN(key) && typeof content_options[key] === 'object' && typeof content_options[key]['value'] !== 'undefined')) {
              // Found a parent of some other namespace
              content_options = undefined;
              break;
            }
          }
        }
      }
    }

    // Maybe in a row, and options got stuck in ${row} instead of top level
    // not sure this code is still needed, as server-side no longer creates ${row} or {$row} for select-options
    var row_stuck = ['${row}', '{$row}'];
    for (var i = 0; i < row_stuck.length && (!content_options || content_options.length == 0); i++) {
      // perspectiveData.row in nm, data["${row}"] in an auto-repeat grid
      if (widget.getArrayMgr("sel_options").perspectiveData.row || widget.getArrayMgr("sel_options").data[row_stuck[i]]) {
        var row_id = widget.id.replace(/[0-9]+/, row_stuck[i]);
        content_options = widget.getArrayMgr("sel_options").getEntry(row_id);
        if (!content_options || content_options.length == 0) {
          content_options = widget.getArrayMgr("sel_options").getEntry(row_stuck[i] + '[' + widget.id + ']');
        }
      }
    }
    if (attr_options && Object.keys(attr_options).length > 0 && content_options) {
      // Clean, merge and filter out duplicates
      content_options = [...new Map([...cleanSelectOptions(_options), ...cleanSelectOptions(content_options || [])].map(item => [item.value, item])).values()];
    }
    if (content_options) {
      content_options = cleanSelectOptions(content_options);
    }
  }

  // Check whether the options entry was found, if not read it from the
  // content array.
  if (content_options && content_options.length > 0 && widget.getArrayMgr('content') != null) {
    if (content_options) {
      attr_options = content_options;
    }
    var content_mgr = widget.getArrayMgr('content');
    if (content_mgr) {
      // If that didn't work, check according to ID
      if (!content_options) {
        content_options = content_mgr.getEntry("options-" + widget.id);
      }
      // Again, try last name part at top level
      if (!content_options) {
        content_options = content_mgr.getRoot().getEntry("options-" + name_parts[name_parts.length - 1]);
      }
    }
  }

  // Default to an empty object
  if (content_options == null) {
    content_options = [];
  }

  // Include passed options, preferring any content options
  if (options.length || Object.keys(options).length > 0) {
    content_options = cleanSelectOptions(content_options);
    for (var _i in content_options) {
      var value = typeof content_options[_i] == 'object' && typeof content_options[_i].value !== 'undefined' ? content_options[_i].value : _i;
      var added = false;

      // Override any existing
      for (var j in options) {
        if ('' + options[j].value === '' + value) {
          added = true;
          options[j] = content_options[_i];
          break;
        }
      }
      if (!added) {
        var insert = typeof content_options[_i] == "object" && content_options[_i].value === value && content_options[_i].label ? content_options[_i] : {
          value: value,
          label: content_options[_i]
        };
        options.splice(parseInt(_i), 0, insert);
      }
    }
    content_options = options;
  }

  // Clean up
  if (!Array.isArray(content_options) && typeof content_options === "object" && Object.values(content_options).length > 0) {
    var fixed_options = [];
    for (var _key in content_options) {
      var option = {
        value: _key,
        label: content_options[_key]
      };
      // This could be an option group - not sure we have any
      if (typeof option.label !== "string" && option.label) {
        // @ts-ignore Yes, option.label.label is not supposed to exist but that's what we're checking
        if (typeof option.label.label !== "undefined") {
          option = Object.assign(option, option.label);
        }
      }
      fixed_options.push(option);
    }
    content_options = fixed_options;
  }
  return content_options;
}

/**
 * Clean up things that might be select options and get them to what we need to make
 * them consistent for widget use.
 *
 * Options might be just a list of labels, or an object of value => label pairs, etc.
 *
 * @param {SelectOption[] | string[] | object} options
 */
function cleanSelectOptions(options) {
  var fixed_options = [];
  if (!Array.isArray(options)) {
    for (var key in options) {
      var _option$value;
      var option = options[key];
      if (typeof option === 'number') {
        option = "" + option;
      }
      if (typeof option === 'string') {
        option = {
          label: option
        };
      } else if (option === null) {
        option = {
          label: key + ""
        };
      }
      option.value = "" + ((_option$value = option.value) !== null && _option$value !== void 0 ? _option$value : key.trim()); // link_search prefixes keys with one space
      fixed_options.push(option);
    }
  } else {
    // make sure value is a string, and label not an object with sub-options
    options.forEach(option => {
      // old taglist used id, instead of value
      if (typeof option.value === 'undefined' && typeof option.id !== 'undefined') {
        option.value = option.id;
        delete option.id;
      }
      if (typeof option.value === 'number') {
        option.value = option.value.toString();
      }
      if (typeof option.label !== 'string') {
        fixed_options.push(...cleanSelectOptions(option.label));
      } else if (fixed_options.findIndex(o => o.value == option.value) == -1) {
        fixed_options.push(option);
      }
    });
  }
  return fixed_options;
}

var _templateObject$19, _templateObject2$I, _templateObject3$r;
function _taggedTemplateLiteral$19(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function asyncGeneratorStep$j(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$j(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$j(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$j(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _initializerDefineProperty$7(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _defineProperty$1W(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$7(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$7(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

/**
 * Base class for things that do selectbox type behaviour, to avoid putting too much or copying into read-only
 * selectboxes, also for common handling of properties for more special selectboxes.
 *
 * As with most other widgets that extend Shoelace components, do not override render() without good reason.
 * To extend this mixin, override:
 * - _optionTargetNode(): Return the HTMLElement where the "options" go.
 * - _optionTemplate(option:SelectOption): Renders the option.  To use a special widget, use its tag in render.
 * Select option:
 * ```js
 * 		return html`
 *             <option value="${option.value}" title="${option.title}" ?selected=${option.value == this.modelValue}>
 *                 ${option.label}
 *             </option>`;
 * ```
 *
 *
 * or pass it off to a different WebComponent:
 *
 * ```js
 * _optionTemplate(option:SelectOption) : TemplateResult
 * {
 *     return html`
 *           <special-option-tag .value=${option}></special-option-tag>`;
 * }
 * ```
 *
 * Optionally, you can override:
 * - _emptyLabelTemplate(): How to render the empty label
 * - slots(): Most Lion components have an input slot where the <input> tag is created.
 * You can specify something else, or return {} to do your own thing.  This is a little more complicated.  You should
 * also override _inputGroupInputTemplate() to do what you normally would in render().
 *
 */ // Export the Interface for TypeScript
var Et2WidgetWithSelectMixin = superclass => {
  var _dec, _dec2, _dec3, _class, _descriptor, _descriptor2;
  var Et2WidgetWithSelect = (_dec = e$c({
    type: String
  }), _dec2 = e$c({
    type: Number,
    noAccessor: true,
    reflect: true
  }), _dec3 = e$c({
    type: Object
  }), (_class = class Et2WidgetWithSelect extends Et2InputWidget(superclass) {
    constructor() {
      super(...arguments);
      /**
       * The current value of the select, submitted as a name/value pair with form data. When `multiple` is enabled, the
       * value attribute will be a space-delimited list of values based on the options selected, and the value property will
       * be an array.
       *
      @property({
      	noAccessor: true,
      	converter: {
      		fromAttribute: (value : string) => value.split(',')
      	}
      })
      value : string | string[] = "";
       */
      /**
       * Textual label for first row, eg: 'All' or 'None'.  It's value will be ''
       */
      _initializerDefineProperty$7(this, "emptyLabel", _descriptor, this);
      /**
       * Limit size
       */
      _initializerDefineProperty$7(this, "__select_options", _descriptor2, this);
      /**
       * When we create the select option elements, it takes a while.
       * If we don't wait for them, it causes issues in SlSelect
       */
      _defineProperty$1W(this, "_optionRenderPromise", Promise.resolve());
      /**
       * Options found in the XML when reading the template
       * @type {SelectOption[]}
       * @private
       */
      _defineProperty$1W(this, "_xmlOptions", []);
      this.__select_options = [];
    }
    getUpdateComplete() {
      var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
        _this = this;
      return _asyncToGenerator$j(function* () {
        var result = yield _superprop_getGetUpdateComplete().call(_this);
        yield _this._optionRenderPromise;
        return result;
      })();
    }

    /** @param {import('@lion/core').PropertyValues } changedProperties */
    updated(changedProperties) {
      super.updated(changedProperties);

      // If the ID changed (or was just set) and select_options wasn't, find the new select options
      if (changedProperties.has("id") && !changedProperties.has("select_options")) {
        var options = find_select_options(this, {}, this._xmlOptions);
        if (options.length) {
          this.select_options = options;
        }
      }
    }
    getValueAsArray() {
      if (Array.isArray(this.value)) {
        return this.value;
      }
      if (this.value == "null" || this.value == null || typeof this.value == "undefined" || !this.emptyLabel && this.value == "") {
        return [];
      }
      return [this.value];
    }

    /**
     * Search options for a given value, returning the first matching option
     *
     * @return SelectOption | null
     */
    optionSearch(value) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var search = function search(options, value) {
        return options.find(option => {
          if (Array.isArray(option.value)) {
            return search(option.value, value);
          }
          return option.value == value;
        });
      };
      return search(options !== null && options !== void 0 ? options : this.select_options, value);
    }

    /**
     * Set the select options
     *
     * @param new_options
     */
    set select_options(new_options) {
      var old_options = this.__select_options;
      this.__select_options = cleanSelectOptions(new_options);
      this.requestUpdate("select_options", old_options);
    }

    /**
     * Set select options
     *
     * @deprecated assign to select_options
     * @param new_options
     */
    set_select_options(new_options) {
      this.select_options = new_options;
    }

    /**
     * Select box options
     *
     * Will be found automatically based on ID and type, or can be set explicitly in the template using
     * <option/> children, or using widget.select_options = SelectOption[]
     */
    get select_options() {
      return this.__select_options;
    }

    /**
     * Get the node where we're putting the options
     *
     * If this were a normal selectbox, this would be just the <select> tag (this._inputNode) but in a more
     * complicated widget, this could be anything.
     *
     * @overridable
     * @returns {HTMLElement}
     */
    get _optionTargetNode() {
      return this;
    }

    /**
     * Render the "empty label", used when the selectbox does not currently have a value
     *
     * @overridable
     * @returns {TemplateResult}
     */
    _emptyLabelTemplate() {
      return x$1(_templateObject$19 || (_templateObject$19 = _taggedTemplateLiteral$19(["", ""])), this.emptyLabel);
    }

    /**
     * Render a single option
     *
     * Override this method to specify how to render each option.
     * In a normal selectbox, this would be something like:
     *```
     * <option value="${option.value}" title="${option.title}" ?selected=${option.value == this.modelValue}>
     *     ${option.label}
     * </option>`;
     * ```
     * but you can do whatever you need.  To use a different WebComponent, just use its tag instead of "option".
     * We should even be able to pass the whole SelectOption across
     * ```
     * <special-option .value=${option}></special-option>
     * ```
     *
     * @overridable
     * @param {SelectOption} option
     * @returns {TemplateResult}
     */
    _optionTemplate(option) {
      return x$1(_templateObject2$I || (_templateObject2$I = _taggedTemplateLiteral$19(["\n                <span>Override _optionTemplate(). ", " => ", "</span>"])), option.value, option.label);
    }
    _groupTemplate(option) {
      if (!Array.isArray(option.value)) {
        return this._optionTemplate(option);
      }
      return x$1(_templateObject3$r || (_templateObject3$r = _taggedTemplateLiteral$19(["\n\n                <small>", "</small>\n                ", "\n                <sl-divider></sl-divider>\n\t\t\t"])), this.noLang ? option.label : this.egw().lang(option.label), option.value.map(this._optionTemplate.bind(this)));
    }

    /**
     * Load extra stuff from the template node.  In particular, we're looking for any <option/> tags added.
     *
     * @param {Element} _node
     */
    loadFromXML(_node) {
      var new_options = [];

      // Read the option-tags, but if not rendered there won't be any yet so check existing options
      var options = _node.querySelectorAll("option");
      for (var i = 0; i < options.length; i++) {
        new_options.push({
          value: et2_readAttrWithDefault(options[i], "value", options[i].textContent),
          // allow options to contain multiple translated sub-strings eg: {Firstname}.{Lastname}
          label: options[i].textContent.replace(/{([^}]+)}/g, (str, p1) => {
            return this.egw().lang(p1);
          }),
          title: et2_readAttrWithDefault(options[i], "title", "")
        });
      }
      this._xmlOptions = new_options;
      if (options.length == 0 && this.__select_options.length) {
        // Start with any existing options, (static options from type)
        // Use a copy since we'll probably be modifying it, and we don't want to change for any other
        // widget of the same static type
        new_options = [...this.__select_options];
      }
      if (this.id) {
        new_options = find_select_options(this, {}, new_options);
      }
      if (new_options.length) {
        this.select_options = new_options;
      }
    }
  }, (_descriptor = _applyDecoratedDescriptor$7(_class.prototype, "emptyLabel", [_dec], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function initializer() {
      return "";
    }
  }), _descriptor2 = _applyDecoratedDescriptor$7(_class.prototype, "__select_options", [_dec2], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function initializer() {
      return [];
    }
  }), _applyDecoratedDescriptor$7(_class.prototype, "select_options", [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, "select_options"), _class.prototype)), _class));
  return Et2WidgetWithSelect;
};

var sl_css = i$b`
  :root,
  :host,
  .sl-theme-light {
    color-scheme: light;

    --sl-color-gray-50: hsl(0 0% 97.5%);
    --sl-color-gray-100: hsl(240 4.8% 95.9%);
    --sl-color-gray-200: hsl(240 5.9% 90%);
    --sl-color-gray-300: hsl(240 4.9% 83.9%);
    --sl-color-gray-400: hsl(240 5% 64.9%);
    --sl-color-gray-500: hsl(240 3.8% 46.1%);
    --sl-color-gray-600: hsl(240 5.2% 33.9%);
    --sl-color-gray-700: hsl(240 5.3% 26.1%);
    --sl-color-gray-800: hsl(240 3.7% 15.9%);
    --sl-color-gray-900: hsl(240 5.9% 10%);
    --sl-color-gray-950: hsl(240 7.3% 8%);

    --sl-color-red-50: hsl(0 85.7% 97.3%);
    --sl-color-red-100: hsl(0 93.3% 94.1%);
    --sl-color-red-200: hsl(0 96.3% 89.4%);
    --sl-color-red-300: hsl(0 93.5% 81.8%);
    --sl-color-red-400: hsl(0 90.6% 70.8%);
    --sl-color-red-500: hsl(0 84.2% 60.2%);
    --sl-color-red-600: hsl(0 72.2% 50.6%);
    --sl-color-red-700: hsl(0 73.7% 41.8%);
    --sl-color-red-800: hsl(0 70% 35.3%);
    --sl-color-red-900: hsl(0 62.8% 30.6%);
    --sl-color-red-950: hsl(0 60% 19.6%);

    --sl-color-orange-50: hsl(33.3 100% 96.5%);
    --sl-color-orange-100: hsl(34.3 100% 91.8%);
    --sl-color-orange-200: hsl(32.1 97.7% 83.1%);
    --sl-color-orange-300: hsl(30.7 97.2% 72.4%);
    --sl-color-orange-400: hsl(27 96% 61%);
    --sl-color-orange-500: hsl(24.6 95% 53.1%);
    --sl-color-orange-600: hsl(20.5 90.2% 48.2%);
    --sl-color-orange-700: hsl(17.5 88.3% 40.4%);
    --sl-color-orange-800: hsl(15 79.1% 33.7%);
    --sl-color-orange-900: hsl(15.3 74.6% 27.8%);
    --sl-color-orange-950: hsl(15.2 69.1% 19%);

    --sl-color-amber-50: hsl(48 100% 96.1%);
    --sl-color-amber-100: hsl(48 96.5% 88.8%);
    --sl-color-amber-200: hsl(48 96.6% 76.7%);
    --sl-color-amber-300: hsl(45.9 96.7% 64.5%);
    --sl-color-amber-400: hsl(43.3 96.4% 56.3%);
    --sl-color-amber-500: hsl(37.7 92.1% 50.2%);
    --sl-color-amber-600: hsl(32.1 94.6% 43.7%);
    --sl-color-amber-700: hsl(26 90.5% 37.1%);
    --sl-color-amber-800: hsl(22.7 82.5% 31.4%);
    --sl-color-amber-900: hsl(21.7 77.8% 26.5%);
    --sl-color-amber-950: hsl(22.9 74.1% 16.7%);

    --sl-color-yellow-50: hsl(54.5 91.7% 95.3%);
    --sl-color-yellow-100: hsl(54.9 96.7% 88%);
    --sl-color-yellow-200: hsl(52.8 98.3% 76.9%);
    --sl-color-yellow-300: hsl(50.4 97.8% 63.5%);
    --sl-color-yellow-400: hsl(47.9 95.8% 53.1%);
    --sl-color-yellow-500: hsl(45.4 93.4% 47.5%);
    --sl-color-yellow-600: hsl(40.6 96.1% 40.4%);
    --sl-color-yellow-700: hsl(35.5 91.7% 32.9%);
    --sl-color-yellow-800: hsl(31.8 81% 28.8%);
    --sl-color-yellow-900: hsl(28.4 72.5% 25.7%);
    --sl-color-yellow-950: hsl(33.1 69% 13.9%);

    --sl-color-lime-50: hsl(78.3 92% 95.1%);
    --sl-color-lime-100: hsl(79.6 89.1% 89.2%);
    --sl-color-lime-200: hsl(80.9 88.5% 79.6%);
    --sl-color-lime-300: hsl(82 84.5% 67.1%);
    --sl-color-lime-400: hsl(82.7 78% 55.5%);
    --sl-color-lime-500: hsl(83.7 80.5% 44.3%);
    --sl-color-lime-600: hsl(84.8 85.2% 34.5%);
    --sl-color-lime-700: hsl(85.9 78.4% 27.3%);
    --sl-color-lime-800: hsl(86.3 69% 22.7%);
    --sl-color-lime-900: hsl(87.6 61.2% 20.2%);
    --sl-color-lime-950: hsl(86.5 60.6% 13.9%);

    --sl-color-green-50: hsl(138.5 76.5% 96.7%);
    --sl-color-green-100: hsl(140.6 84.2% 92.5%);
    --sl-color-green-200: hsl(141 78.9% 85.1%);
    --sl-color-green-300: hsl(141.7 76.6% 73.1%);
    --sl-color-green-400: hsl(141.9 69.2% 58%);
    --sl-color-green-500: hsl(142.1 70.6% 45.3%);
    --sl-color-green-600: hsl(142.1 76.2% 36.3%);
    --sl-color-green-700: hsl(142.4 71.8% 29.2%);
    --sl-color-green-800: hsl(142.8 64.2% 24.1%);
    --sl-color-green-900: hsl(143.8 61.2% 20.2%);
    --sl-color-green-950: hsl(144.3 60.7% 12%);

    --sl-color-emerald-50: hsl(151.8 81% 95.9%);
    --sl-color-emerald-100: hsl(149.3 80.4% 90%);
    --sl-color-emerald-200: hsl(152.4 76% 80.4%);
    --sl-color-emerald-300: hsl(156.2 71.6% 66.9%);
    --sl-color-emerald-400: hsl(158.1 64.4% 51.6%);
    --sl-color-emerald-500: hsl(160.1 84.1% 39.4%);
    --sl-color-emerald-600: hsl(161.4 93.5% 30.4%);
    --sl-color-emerald-700: hsl(162.9 93.5% 24.3%);
    --sl-color-emerald-800: hsl(163.1 88.1% 19.8%);
    --sl-color-emerald-900: hsl(164.2 85.7% 16.5%);
    --sl-color-emerald-950: hsl(164.3 87.5% 9.4%);

    --sl-color-teal-50: hsl(166.2 76.5% 96.7%);
    --sl-color-teal-100: hsl(167.2 85.5% 89.2%);
    --sl-color-teal-200: hsl(168.4 83.8% 78.2%);
    --sl-color-teal-300: hsl(170.6 76.9% 64.3%);
    --sl-color-teal-400: hsl(172.5 66% 50.4%);
    --sl-color-teal-500: hsl(173.4 80.4% 40%);
    --sl-color-teal-600: hsl(174.7 83.9% 31.6%);
    --sl-color-teal-700: hsl(175.3 77.4% 26.1%);
    --sl-color-teal-800: hsl(176.1 69.4% 21.8%);
    --sl-color-teal-900: hsl(175.9 60.8% 19%);
    --sl-color-teal-950: hsl(176.5 58.6% 11.4%);

    --sl-color-cyan-50: hsl(183.2 100% 96.3%);
    --sl-color-cyan-100: hsl(185.1 95.9% 90.4%);
    --sl-color-cyan-200: hsl(186.2 93.5% 81.8%);
    --sl-color-cyan-300: hsl(187 92.4% 69%);
    --sl-color-cyan-400: hsl(187.9 85.7% 53.3%);
    --sl-color-cyan-500: hsl(188.7 94.5% 42.7%);
    --sl-color-cyan-600: hsl(191.6 91.4% 36.5%);
    --sl-color-cyan-700: hsl(192.9 82.3% 31%);
    --sl-color-cyan-800: hsl(194.4 69.6% 27.1%);
    --sl-color-cyan-900: hsl(196.4 63.6% 23.7%);
    --sl-color-cyan-950: hsl(196.8 61% 16.1%);

    --sl-color-sky-50: hsl(204 100% 97.1%);
    --sl-color-sky-100: hsl(204 93.8% 93.7%);
    --sl-color-sky-200: hsl(200.6 94.4% 86.1%);
    --sl-color-sky-300: hsl(199.4 95.5% 73.9%);
    --sl-color-sky-400: hsl(198.4 93.2% 59.6%);
    --sl-color-sky-500: hsl(198.6 88.7% 48.4%);
    --sl-color-sky-600: hsl(200.4 98% 39.4%);
    --sl-color-sky-700: hsl(201.3 96.3% 32.2%);
    --sl-color-sky-800: hsl(201 90% 27.5%);
    --sl-color-sky-900: hsl(202 80.3% 23.9%);
    --sl-color-sky-950: hsl(202.3 73.8% 16.5%);

    --sl-color-blue-50: hsl(213.8 100% 96.9%);
    --sl-color-blue-100: hsl(214.3 94.6% 92.7%);
    --sl-color-blue-200: hsl(213.3 96.9% 87.3%);
    --sl-color-blue-300: hsl(211.7 96.4% 78.4%);
    --sl-color-blue-400: hsl(213.1 93.9% 67.8%);
    --sl-color-blue-500: hsl(217.2 91.2% 59.8%);
    --sl-color-blue-600: hsl(221.2 83.2% 53.3%);
    --sl-color-blue-700: hsl(224.3 76.3% 48%);
    --sl-color-blue-800: hsl(225.9 70.7% 40.2%);
    --sl-color-blue-900: hsl(224.4 64.3% 32.9%);
    --sl-color-blue-950: hsl(226.2 55.3% 18.4%);

    --sl-color-indigo-50: hsl(225.9 100% 96.7%);
    --sl-color-indigo-100: hsl(226.5 100% 93.9%);
    --sl-color-indigo-200: hsl(228 96.5% 88.8%);
    --sl-color-indigo-300: hsl(229.7 93.5% 81.8%);
    --sl-color-indigo-400: hsl(234.5 89.5% 73.9%);
    --sl-color-indigo-500: hsl(238.7 83.5% 66.7%);
    --sl-color-indigo-600: hsl(243.4 75.4% 58.6%);
    --sl-color-indigo-700: hsl(244.5 57.9% 50.6%);
    --sl-color-indigo-800: hsl(243.7 54.5% 41.4%);
    --sl-color-indigo-900: hsl(242.2 47.4% 34.3%);
    --sl-color-indigo-950: hsl(243.5 43.6% 22.9%);

    --sl-color-violet-50: hsl(250 100% 97.6%);
    --sl-color-violet-100: hsl(251.4 91.3% 95.5%);
    --sl-color-violet-200: hsl(250.5 95.2% 91.8%);
    --sl-color-violet-300: hsl(252.5 94.7% 85.1%);
    --sl-color-violet-400: hsl(255.1 91.7% 76.3%);
    --sl-color-violet-500: hsl(258.3 89.5% 66.3%);
    --sl-color-violet-600: hsl(262.1 83.3% 57.8%);
    --sl-color-violet-700: hsl(263.4 70% 50.4%);
    --sl-color-violet-800: hsl(263.4 69.3% 42.2%);
    --sl-color-violet-900: hsl(263.5 67.4% 34.9%);
    --sl-color-violet-950: hsl(265.1 61.5% 21.4%);

    --sl-color-purple-50: hsl(270 100% 98%);
    --sl-color-purple-100: hsl(268.7 100% 95.5%);
    --sl-color-purple-200: hsl(268.6 100% 91.8%);
    --sl-color-purple-300: hsl(269.2 97.4% 85.1%);
    --sl-color-purple-400: hsl(270 95.2% 75.3%);
    --sl-color-purple-500: hsl(270.7 91% 65.1%);
    --sl-color-purple-600: hsl(271.5 81.3% 55.9%);
    --sl-color-purple-700: hsl(272.1 71.7% 47.1%);
    --sl-color-purple-800: hsl(272.9 67.2% 39.4%);
    --sl-color-purple-900: hsl(273.6 65.6% 32%);
    --sl-color-purple-950: hsl(276 59.5% 16.5%);

    --sl-color-fuchsia-50: hsl(289.1 100% 97.8%);
    --sl-color-fuchsia-100: hsl(287 100% 95.5%);
    --sl-color-fuchsia-200: hsl(288.3 95.8% 90.6%);
    --sl-color-fuchsia-300: hsl(291.1 93.1% 82.9%);
    --sl-color-fuchsia-400: hsl(292 91.4% 72.5%);
    --sl-color-fuchsia-500: hsl(292.2 84.1% 60.6%);
    --sl-color-fuchsia-600: hsl(293.4 69.5% 48.8%);
    --sl-color-fuchsia-700: hsl(294.7 72.4% 39.8%);
    --sl-color-fuchsia-800: hsl(295.4 70.2% 32.9%);
    --sl-color-fuchsia-900: hsl(296.7 63.6% 28%);
    --sl-color-fuchsia-950: hsl(297.1 56.8% 14.5%);

    --sl-color-pink-50: hsl(327.3 73.3% 97.1%);
    --sl-color-pink-100: hsl(325.7 77.8% 94.7%);
    --sl-color-pink-200: hsl(325.9 84.6% 89.8%);
    --sl-color-pink-300: hsl(327.4 87.1% 81.8%);
    --sl-color-pink-400: hsl(328.6 85.5% 70.2%);
    --sl-color-pink-500: hsl(330.4 81.2% 60.4%);
    --sl-color-pink-600: hsl(333.3 71.4% 50.6%);
    --sl-color-pink-700: hsl(335.1 77.6% 42%);
    --sl-color-pink-800: hsl(335.8 74.4% 35.3%);
    --sl-color-pink-900: hsl(335.9 69% 30.4%);
    --sl-color-pink-950: hsl(336.2 65.4% 15.9%);

    --sl-color-rose-50: hsl(355.7 100% 97.3%);
    --sl-color-rose-100: hsl(355.6 100% 94.7%);
    --sl-color-rose-200: hsl(352.7 96.1% 90%);
    --sl-color-rose-300: hsl(352.6 95.7% 81.8%);
    --sl-color-rose-400: hsl(351.3 94.5% 71.4%);
    --sl-color-rose-500: hsl(349.7 89.2% 60.2%);
    --sl-color-rose-600: hsl(346.8 77.2% 49.8%);
    --sl-color-rose-700: hsl(345.3 82.7% 40.8%);
    --sl-color-rose-800: hsl(343.4 79.7% 34.7%);
    --sl-color-rose-900: hsl(341.5 75.5% 30.4%);
    --sl-color-rose-950: hsl(341.3 70.1% 17.1%);

    --sl-color-primary-50: var(--sl-color-sky-50);
    --sl-color-primary-100: var(--sl-color-sky-100);
    --sl-color-primary-200: var(--sl-color-sky-200);
    --sl-color-primary-300: var(--sl-color-sky-300);
    --sl-color-primary-400: var(--sl-color-sky-400);
    --sl-color-primary-500: var(--sl-color-sky-500);
    --sl-color-primary-600: var(--sl-color-sky-600);
    --sl-color-primary-700: var(--sl-color-sky-700);
    --sl-color-primary-800: var(--sl-color-sky-800);
    --sl-color-primary-900: var(--sl-color-sky-900);
    --sl-color-primary-950: var(--sl-color-sky-950);

    --sl-color-success-50: var(--sl-color-green-50);
    --sl-color-success-100: var(--sl-color-green-100);
    --sl-color-success-200: var(--sl-color-green-200);
    --sl-color-success-300: var(--sl-color-green-300);
    --sl-color-success-400: var(--sl-color-green-400);
    --sl-color-success-500: var(--sl-color-green-500);
    --sl-color-success-600: var(--sl-color-green-600);
    --sl-color-success-700: var(--sl-color-green-700);
    --sl-color-success-800: var(--sl-color-green-800);
    --sl-color-success-900: var(--sl-color-green-900);
    --sl-color-success-950: var(--sl-color-green-950);

    --sl-color-warning-50: var(--sl-color-amber-50);
    --sl-color-warning-100: var(--sl-color-amber-100);
    --sl-color-warning-200: var(--sl-color-amber-200);
    --sl-color-warning-300: var(--sl-color-amber-300);
    --sl-color-warning-400: var(--sl-color-amber-400);
    --sl-color-warning-500: var(--sl-color-amber-500);
    --sl-color-warning-600: var(--sl-color-amber-600);
    --sl-color-warning-700: var(--sl-color-amber-700);
    --sl-color-warning-800: var(--sl-color-amber-800);
    --sl-color-warning-900: var(--sl-color-amber-900);
    --sl-color-warning-950: var(--sl-color-amber-950);

    --sl-color-danger-50: var(--sl-color-red-50);
    --sl-color-danger-100: var(--sl-color-red-100);
    --sl-color-danger-200: var(--sl-color-red-200);
    --sl-color-danger-300: var(--sl-color-red-300);
    --sl-color-danger-400: var(--sl-color-red-400);
    --sl-color-danger-500: var(--sl-color-red-500);
    --sl-color-danger-600: var(--sl-color-red-600);
    --sl-color-danger-700: var(--sl-color-red-700);
    --sl-color-danger-800: var(--sl-color-red-800);
    --sl-color-danger-900: var(--sl-color-red-900);
    --sl-color-danger-950: var(--sl-color-red-950);

    --sl-color-neutral-50: var(--sl-color-gray-50);
    --sl-color-neutral-100: var(--sl-color-gray-100);
    --sl-color-neutral-200: var(--sl-color-gray-200);
    --sl-color-neutral-300: var(--sl-color-gray-300);
    --sl-color-neutral-400: var(--sl-color-gray-400);
    --sl-color-neutral-500: var(--sl-color-gray-500);
    --sl-color-neutral-600: var(--sl-color-gray-600);
    --sl-color-neutral-700: var(--sl-color-gray-700);
    --sl-color-neutral-800: var(--sl-color-gray-800);
    --sl-color-neutral-900: var(--sl-color-gray-900);
    --sl-color-neutral-950: var(--sl-color-gray-950);

    --sl-color-neutral-0: hsl(0, 0%, 100%);
    --sl-color-neutral-1000: hsl(0, 0%, 0%);

    --sl-border-radius-small: 0.1875rem;
    --sl-border-radius-medium: 0.25rem;
    --sl-border-radius-large: 0.5rem;
    --sl-border-radius-x-large: 1rem;

    --sl-border-radius-circle: 50%;
    --sl-border-radius-pill: 9999px;

    --sl-shadow-x-small: 0 1px 2px hsl(240 3.8% 46.1% / 6%);
    --sl-shadow-small: 0 1px 2px hsl(240 3.8% 46.1% / 12%);
    --sl-shadow-medium: 0 2px 4px hsl(240 3.8% 46.1% / 12%);
    --sl-shadow-large: 0 2px 8px hsl(240 3.8% 46.1% / 12%);
    --sl-shadow-x-large: 0 4px 16px hsl(240 3.8% 46.1% / 12%);

    --sl-spacing-3x-small: 0.125rem;
    --sl-spacing-2x-small: 0.25rem;
    --sl-spacing-x-small: 0.5rem;
    --sl-spacing-small: 0.75rem;
    --sl-spacing-medium: 1rem;
    --sl-spacing-large: 1.25rem;
    --sl-spacing-x-large: 1.75rem;
    --sl-spacing-2x-large: 2.25rem;
    --sl-spacing-3x-large: 3rem;
    --sl-spacing-4x-large: 4.5rem;

    --sl-transition-x-slow: 1000ms;
    --sl-transition-slow: 500ms;
    --sl-transition-medium: 250ms;
    --sl-transition-fast: 150ms;
    --sl-transition-x-fast: 50ms;

    --sl-font-mono: SFMono-Regular, Consolas, "Liberation Mono", Menlo,
      monospace;
    --sl-font-sans: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto,
      Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji",
      "Segoe UI Symbol";
    --sl-font-serif: Georgia, "Times New Roman", serif;

    --sl-font-size-2x-small: 0.625rem;
    --sl-font-size-x-small: 0.75rem;
    --sl-font-size-small: 0.875rem;
    --sl-font-size-medium: 1rem;
    --sl-font-size-large: 1.25rem;
    --sl-font-size-x-large: 1.5rem;
    --sl-font-size-2x-large: 2.25rem;
    --sl-font-size-3x-large: 3rem;
    --sl-font-size-4x-large: 4.5rem;

    --sl-font-weight-light: 300;
    --sl-font-weight-normal: 400;
    --sl-font-weight-semibold: 500;
    --sl-font-weight-bold: 700;

    --sl-letter-spacing-denser: -0.03em;
    --sl-letter-spacing-dense: -0.015em;
    --sl-letter-spacing-normal: normal;
    --sl-letter-spacing-loose: 0.075em;
    --sl-letter-spacing-looser: 0.15em;

    --sl-line-height-denser: 1;
    --sl-line-height-dense: 1.4;
    --sl-line-height-normal: 1.8;
    --sl-line-height-loose: 2.2;
    --sl-line-height-looser: 2.6;

    --sl-focus-ring-color: var(--sl-color-primary-600);
    --sl-focus-ring-style: solid;
    --sl-focus-ring-width: 3px;
    --sl-focus-ring: var(--sl-focus-ring-style) var(--sl-focus-ring-width)
      var(--sl-focus-ring-color);
    --sl-focus-ring-offset: 1px;

    --sl-button-font-size-small: var(--sl-font-size-x-small);
    --sl-button-font-size-medium: var(--sl-font-size-small);
    --sl-button-font-size-large: var(--sl-font-size-medium);

    --sl-input-height-small: 1.875rem;
    --sl-input-height-medium: 2.5rem;
    --sl-input-height-large: 3.125rem;

    --sl-input-background-color: var(--sl-color-neutral-0);
    --sl-input-background-color-hover: var(--sl-input-background-color);
    --sl-input-background-color-focus: var(--sl-input-background-color);
    --sl-input-background-color-disabled: var(--sl-color-neutral-100);
    --sl-input-border-color: var(--sl-color-neutral-300);
    --sl-input-border-color-hover: var(--sl-color-neutral-400);
    --sl-input-border-color-focus: var(--sl-color-primary-500);
    --sl-input-border-color-disabled: var(--sl-color-neutral-300);
    --sl-input-border-width: 1px;
    --sl-input-required-content: "*";
    --sl-input-required-content-offset: -2px;
    --sl-input-required-content-color: var(--sl-input-label-color);

    --sl-input-border-radius-small: var(--sl-border-radius-medium);
    --sl-input-border-radius-medium: var(--sl-border-radius-medium);
    --sl-input-border-radius-large: var(--sl-border-radius-medium);

    --sl-input-font-family: var(--sl-font-sans);
    --sl-input-font-weight: var(--sl-font-weight-normal);
    --sl-input-font-size-small: var(--sl-font-size-small);
    --sl-input-font-size-medium: var(--sl-font-size-medium);
    --sl-input-font-size-large: var(--sl-font-size-large);
    --sl-input-letter-spacing: var(--sl-letter-spacing-normal);

    --sl-input-color: var(--sl-color-neutral-700);
    --sl-input-color-hover: var(--sl-color-neutral-700);
    --sl-input-color-focus: var(--sl-color-neutral-700);
    --sl-input-color-disabled: var(--sl-color-neutral-900);
    --sl-input-icon-color: var(--sl-color-neutral-500);
    --sl-input-icon-color-hover: var(--sl-color-neutral-600);
    --sl-input-icon-color-focus: var(--sl-color-neutral-600);
    --sl-input-placeholder-color: var(--sl-color-neutral-500);
    --sl-input-placeholder-color-disabled: var(--sl-color-neutral-600);
    --sl-input-spacing-small: var(--sl-spacing-small);
    --sl-input-spacing-medium: var(--sl-spacing-medium);
    --sl-input-spacing-large: var(--sl-spacing-large);

    --sl-input-focus-ring-color: hsl(198.6 88.7% 48.4% / 40%);
    --sl-input-focus-ring-offset: 0;

    --sl-input-filled-background-color: var(--sl-color-neutral-100);
    --sl-input-filled-background-color-hover: var(--sl-color-neutral-100);
    --sl-input-filled-background-color-focus: var(--sl-color-neutral-100);
    --sl-input-filled-background-color-disabled: var(--sl-color-neutral-100);
    --sl-input-filled-color: var(--sl-color-neutral-800);
    --sl-input-filled-color-hover: var(--sl-color-neutral-800);
    --sl-input-filled-color-focus: var(--sl-color-neutral-700);
    --sl-input-filled-color-disabled: var(--sl-color-neutral-800);

    --sl-input-label-font-size-small: var(--sl-font-size-small);
    --sl-input-label-font-size-medium: var(--sl-font-size-medium);
    --sl-input-label-font-size-large: var(--sl-font-size-large);
    --sl-input-label-color: inherit;

    --sl-input-help-text-font-size-small: var(--sl-font-size-x-small);
    --sl-input-help-text-font-size-medium: var(--sl-font-size-small);
    --sl-input-help-text-font-size-large: var(--sl-font-size-medium);
    --sl-input-help-text-color: var(--sl-color-neutral-500);

    --sl-toggle-size-small: 0.875rem;
    --sl-toggle-size-medium: 1.125rem;
    --sl-toggle-size-large: 1.375rem;

    --sl-overlay-background-color: hsl(240 3.8% 46.1% / 33%);

    --sl-panel-background-color: var(--sl-color-neutral-0);
    --sl-panel-border-color: var(--sl-color-neutral-200);
    --sl-panel-border-width: 1px;

    --sl-tooltip-border-radius: var(--sl-border-radius-medium);
    --sl-tooltip-background-color: var(--sl-color-neutral-800);
    --sl-tooltip-color: var(--sl-color-neutral-0);
    --sl-tooltip-font-family: var(--sl-font-sans);
    --sl-tooltip-font-weight: var(--sl-font-weight-normal);
    --sl-tooltip-font-size: var(--sl-font-size-small);
    --sl-tooltip-line-height: var(--sl-line-height-dense);
    --sl-tooltip-padding: var(--sl-spacing-2x-small) var(--sl-spacing-x-small);
    --sl-tooltip-arrow-size: 6px;

    --sl-z-index-drawer: 700;
    --sl-z-index-dialog: 800;
    --sl-z-index-dropdown: 900;
    --sl-z-index-toast: 950;
    --sl-z-index-tooltip: 1000;
  }

  .sl-scroll-lock {
    padding-right: var(--sl-scroll-lock-size) !important;
    overflow: hidden !important;
  }

  .sl-toast-stack {
    position: fixed;
    top: 0;
    inset-inline-end: 0;
    z-index: var(--sl-z-index-toast);
    width: 28rem;
    max-width: 100%;
    max-height: 100%;
    overflow: auto;
  }

  .sl-toast-stack sl-alert {
    margin: var(--sl-spacing-medium);
  }

  .sl-toast-stack sl-alert::part(base) {
    box-shadow: var(--sl-shadow-large);
  }
`;

// src/utilities/base-path.ts
var basePath = "";
function setBasePath(path) {
  basePath = path;
}
function getBasePath(subpath = "") {
  if (!basePath) {
    const scripts = [...document.getElementsByTagName("script")];
    const configScript = scripts.find((script) => script.hasAttribute("data-shoelace"));
    if (configScript) {
      setBasePath(configScript.getAttribute("data-shoelace"));
    } else {
      const fallbackScript = scripts.find((s) => {
        return /shoelace(\.min)?\.js($|\?)/.test(s.src) || /shoelace-autoloader(\.min)?\.js($|\?)/.test(s.src);
      });
      let path = "";
      if (fallbackScript) {
        path = fallbackScript.getAttribute("src");
      }
      setBasePath(path.split("/").slice(0, -1).join("/"));
    }
  }
  return basePath.replace(/\/$/, "") + (subpath ? `/${subpath.replace(/^\//, "")}` : ``);
}

// src/components/icon/library.default.ts
var library = {
  name: "default",
  resolver: (name) => getBasePath(`assets/icons/${name}.svg`)
};
var library_default_default = library;

// src/components/icon/library.system.ts
var icons = {
  caret: `
    <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round">
      <polyline points="6 9 12 15 18 9"></polyline>
    </svg>
  `,
  check: `
    <svg part="checked-icon" class="checkbox__icon" viewBox="0 0 16 16">
      <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" stroke-linecap="round">
        <g stroke="currentColor">
          <g transform="translate(3.428571, 3.428571)">
            <path d="M0,5.71428571 L3.42857143,9.14285714"></path>
            <path d="M9.14285714,0 L3.42857143,9.14285714"></path>
          </g>
        </g>
      </g>
    </svg>
  `,
  "chevron-down": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-down" viewBox="0 0 16 16">
      <path fill-rule="evenodd" d="M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"/>
    </svg>
  `,
  "chevron-left": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-left" viewBox="0 0 16 16">
      <path fill-rule="evenodd" d="M11.354 1.646a.5.5 0 0 1 0 .708L5.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0z"/>
    </svg>
  `,
  "chevron-right": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-right" viewBox="0 0 16 16">
      <path fill-rule="evenodd" d="M4.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L10.293 8 4.646 2.354a.5.5 0 0 1 0-.708z"/>
    </svg>
  `,
  copy: `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-files" viewBox="0 0 16 16" part="svg">
      <path d="M13 0H6a2 2 0 0 0-2 2 2 2 0 0 0-2 2v10a2 2 0 0 0 2 2h7a2 2 0 0 0 2-2 2 2 0 0 0 2-2V2a2 2 0 0 0-2-2zm0 13V4a2 2 0 0 0-2-2H5a1 1 0 0 1 1-1h7a1 1 0 0 1 1 1v10a1 1 0 0 1-1 1zM3 4a1 1 0 0 1 1-1h7a1 1 0 0 1 1 1v10a1 1 0 0 1-1 1H4a1 1 0 0 1-1-1V4z"></path>
    </svg>
  `,
  eye: `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-eye" viewBox="0 0 16 16">
      <path d="M16 8s-3-5.5-8-5.5S0 8 0 8s3 5.5 8 5.5S16 8 16 8zM1.173 8a13.133 13.133 0 0 1 1.66-2.043C4.12 4.668 5.88 3.5 8 3.5c2.12 0 3.879 1.168 5.168 2.457A13.133 13.133 0 0 1 14.828 8c-.058.087-.122.183-.195.288-.335.48-.83 1.12-1.465 1.755C11.879 11.332 10.119 12.5 8 12.5c-2.12 0-3.879-1.168-5.168-2.457A13.134 13.134 0 0 1 1.172 8z"/>
      <path d="M8 5.5a2.5 2.5 0 1 0 0 5 2.5 2.5 0 0 0 0-5zM4.5 8a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0z"/>
    </svg>
  `,
  "eye-slash": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-eye-slash" viewBox="0 0 16 16">
      <path d="M13.359 11.238C15.06 9.72 16 8 16 8s-3-5.5-8-5.5a7.028 7.028 0 0 0-2.79.588l.77.771A5.944 5.944 0 0 1 8 3.5c2.12 0 3.879 1.168 5.168 2.457A13.134 13.134 0 0 1 14.828 8c-.058.087-.122.183-.195.288-.335.48-.83 1.12-1.465 1.755-.165.165-.337.328-.517.486l.708.709z"/>
      <path d="M11.297 9.176a3.5 3.5 0 0 0-4.474-4.474l.823.823a2.5 2.5 0 0 1 2.829 2.829l.822.822zm-2.943 1.299.822.822a3.5 3.5 0 0 1-4.474-4.474l.823.823a2.5 2.5 0 0 0 2.829 2.829z"/>
      <path d="M3.35 5.47c-.18.16-.353.322-.518.487A13.134 13.134 0 0 0 1.172 8l.195.288c.335.48.83 1.12 1.465 1.755C4.121 11.332 5.881 12.5 8 12.5c.716 0 1.39-.133 2.02-.36l.77.772A7.029 7.029 0 0 1 8 13.5C3 13.5 0 8 0 8s.939-1.721 2.641-3.238l.708.709zm10.296 8.884-12-12 .708-.708 12 12-.708.708z"/>
    </svg>
  `,
  eyedropper: `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-eyedropper" viewBox="0 0 16 16">
      <path d="M13.354.646a1.207 1.207 0 0 0-1.708 0L8.5 3.793l-.646-.647a.5.5 0 1 0-.708.708L8.293 5l-7.147 7.146A.5.5 0 0 0 1 12.5v1.793l-.854.853a.5.5 0 1 0 .708.707L1.707 15H3.5a.5.5 0 0 0 .354-.146L11 7.707l1.146 1.147a.5.5 0 0 0 .708-.708l-.647-.646 3.147-3.146a1.207 1.207 0 0 0 0-1.708l-2-2zM2 12.707l7-7L10.293 7l-7 7H2v-1.293z"></path>
    </svg>
  `,
  "grip-vertical": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-grip-vertical" viewBox="0 0 16 16">
      <path d="M7 2a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm3 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0zM7 5a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm3 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0zM7 8a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm3 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm-3 3a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm3 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm-3 3a1 1 0 1 1-2 0 1 1 0 0 1 2 0zm3 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0z"></path>
    </svg>
  `,
  indeterminate: `
    <svg part="indeterminate-icon" class="checkbox__icon" viewBox="0 0 16 16">
      <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" stroke-linecap="round">
        <g stroke="currentColor" stroke-width="2">
          <g transform="translate(2.285714, 6.857143)">
            <path d="M10.2857143,1.14285714 L1.14285714,1.14285714"></path>
          </g>
        </g>
      </g>
    </svg>
  `,
  "person-fill": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-person-fill" viewBox="0 0 16 16">
      <path d="M3 14s-1 0-1-1 1-4 6-4 6 3 6 4-1 1-1 1H3zm5-6a3 3 0 1 0 0-6 3 3 0 0 0 0 6z"/>
    </svg>
  `,
  "play-fill": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-play-fill" viewBox="0 0 16 16">
      <path d="m11.596 8.697-6.363 3.692c-.54.313-1.233-.066-1.233-.697V4.308c0-.63.692-1.01 1.233-.696l6.363 3.692a.802.802 0 0 1 0 1.393z"></path>
    </svg>
  `,
  "pause-fill": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-pause-fill" viewBox="0 0 16 16">
      <path d="M5.5 3.5A1.5 1.5 0 0 1 7 5v6a1.5 1.5 0 0 1-3 0V5a1.5 1.5 0 0 1 1.5-1.5zm5 0A1.5 1.5 0 0 1 12 5v6a1.5 1.5 0 0 1-3 0V5a1.5 1.5 0 0 1 1.5-1.5z"></path>
    </svg>
  `,
  radio: `
    <svg part="checked-icon" class="radio__icon" viewBox="0 0 16 16">
      <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
        <g fill="currentColor">
          <circle cx="8" cy="8" r="3.42857143"></circle>
        </g>
      </g>
    </svg>
  `,
  "star-fill": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-star-fill" viewBox="0 0 16 16">
      <path d="M3.612 15.443c-.386.198-.824-.149-.746-.592l.83-4.73L.173 6.765c-.329-.314-.158-.888.283-.95l4.898-.696L7.538.792c.197-.39.73-.39.927 0l2.184 4.327 4.898.696c.441.062.612.636.282.95l-3.522 3.356.83 4.73c.078.443-.36.79-.746.592L8 13.187l-4.389 2.256z"/>
    </svg>
  `,
  "x-lg": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-x-lg" viewBox="0 0 16 16">
      <path d="M2.146 2.854a.5.5 0 1 1 .708-.708L8 7.293l5.146-5.147a.5.5 0 0 1 .708.708L8.707 8l5.147 5.146a.5.5 0 0 1-.708.708L8 8.707l-5.146 5.147a.5.5 0 0 1-.708-.708L7.293 8 2.146 2.854Z"/>
    </svg>
  `,
  "x-circle-fill": `
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-x-circle-fill" viewBox="0 0 16 16">
      <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM5.354 4.646a.5.5 0 1 0-.708.708L7.293 8l-2.647 2.646a.5.5 0 0 0 .708.708L8 8.707l2.646 2.647a.5.5 0 0 0 .708-.708L8.707 8l2.647-2.646a.5.5 0 0 0-.708-.708L8 7.293 5.354 4.646z"></path>
    </svg>
  `
};
var systemLibrary = {
  name: "system",
  resolver: (name) => {
    if (name in icons) {
      return `data:image/svg+xml,${encodeURIComponent(icons[name])}`;
    }
    return "";
  }
};
var library_system_default = systemLibrary;

// src/components/icon/library.ts
var registry = [library_default_default, library_system_default];
var watchedIcons = [];
function watchIcon(icon) {
  watchedIcons.push(icon);
}
function unwatchIcon(icon) {
  watchedIcons = watchedIcons.filter((el) => el !== icon);
}
function getIconLibrary(name) {
  return registry.find((lib) => lib.name === name);
}
function registerIconLibrary(name, options) {
  unregisterIconLibrary(name);
  registry.push({
    name,
    resolver: options.resolver,
    mutator: options.mutator,
    spriteSheet: options.spriteSheet
  });
  watchedIcons.forEach((icon) => {
    if (icon.library === name) {
      icon.setIcon();
    }
  });
}
function unregisterIconLibrary(name) {
  registry = registry.filter((lib) => lib.name !== name);
}

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

var _templateObject$18;
function _taggedTemplateLiteral$18(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Here is the common overrides and customisations for Shoelace
 */

/**
 * Make shoelace icons available
 */
registerIconLibrary('default', {
  resolver: name => {
    var _egw$image;
    return typeof egw$1 !== "undefined" ? (_egw$image = egw$1.image(name)) !== null && _egw$image !== void 0 ? _egw$image : "".concat(egw$1.webserverUrl || "", "/node_modules/@shoelace-style/shoelace/dist/assets/icons/").concat(name, ".svg") : '';
  }
});

/**
 * Register egw images as an icon library
 * @example <sl-icon library="egw" name="infolog/navbar"/>
 * @example <sl-icon library="egw" name="5_day_view"/>
 */
if (typeof egw$1 !== "undefined" && typeof egw$1.image == "function") {
  registerIconLibrary('egw', {
    resolver: name => {
      return egw$1.image(name) || '';
    }
  });
}

/**
 * Customise shoelace styles to match our stuff
 * External CSS & widget styles will override this
 */
var shoelace = [sl_css, i$b(_templateObject$18 || (_templateObject$18 = _taggedTemplateLiteral$18(["\n  :root,\n  :host,\n  .sl-theme-light {\n\t--sl-font-size-medium: ", "px;\n\t--sl-input-height-small: 24px;\n\t--sl-input-height-medium: 32px;\n\t--sl-button-font-size-medium: ", "px;\n\t--sl-input-help-text-font-size-medium: var(--sl-font-size-medium);\n\t--sl-spacing-small: 0.1rem;\n\t--sl-spacing-medium: 0.5rem;\n\n\t--sl-input-border-radius-small: 2px;\n\t--sl-input-border-radius-medium: 3px;\n\t--sl-input-border-color-focus: #E6E6E6;\n\t--indicator-color: #696969;\n\t--sl-input-focus-ring-color: #26537C;\n\t--sl-focus-ring-width: 2px;\n\t--sl-color-gray-150: #f0f0f0;\n      \n  }\n  .tab-group--top .tab-group__tabs {\n      --track-width: 3px;\n  }\n  .form-control--has-label .form-control__label {\n    display: inline-block;\n    color: var(--sl-input-label-color);\n    margin-right: var(--sl-spacing-medium);\n  }\n  "])), typeof egw$1 != "undefined" && egw$1.preference && egw$1.preference('textsize', 'common') != '12' ? parseInt(egw$1.preference('textsize', 'common')) : 12, typeof egw$1 != "undefined" && egw$1.preference && egw$1.preference('textsize', 'common') != '12' ? parseInt(egw$1.preference('textsize', 'common')) : 12)];

function ownKeys$Z(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$Y(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$Z(Object(source), true).forEach(function (key) { _defineProperty$1V(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$Z(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1V(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
// Export the Interface for TypeScript

/**
 * Mixin to support widgets that have a set number of rows.
 * Whether that's a maximum or a fixed size, implementation is up to the widget.
 * Set rows=0 to clear.
 *
 * To implement in a webcomponent set height or max-height based on the --rows CSS variable:
 *  max-height: calc(var(--rows, 5) * 1.3rem);
 * @param {T} superclass
 * @constructor
 */
var RowLimitedMixin = superclass => {
  class RowLimit extends superclass {
    static get properties() {
      return _objectSpread$Y({}, super.properties);
    }
    set rows(row_count) {
      if (isNaN(Number(row_count)) || !row_count) {
        this.style.removeProperty("--rows");
        this.removeAttribute("rows");
      } else {
        this.style.setProperty("--rows", row_count);
        this.setAttribute("rows", row_count);
      }
    }
    get rows() {
      return this.style.getPropertyValue("--rows");
    }
  }
  return RowLimit; // as unknown as superclass & T;
};

// src/internal/form.ts
var formCollections = /* @__PURE__ */ new WeakMap();
var reportValidityOverloads = /* @__PURE__ */ new WeakMap();
var userInteractedControls = /* @__PURE__ */ new WeakSet();
var interactions$1 = /* @__PURE__ */ new WeakMap();
var FormControlController = class {
  constructor(host, options) {
    this.handleFormData = (event) => {
      const disabled = this.options.disabled(this.host);
      const name = this.options.name(this.host);
      const value = this.options.value(this.host);
      const isButton = this.host.tagName.toLowerCase() === "sl-button";
      if (!disabled && !isButton && typeof name === "string" && name.length > 0 && typeof value !== "undefined") {
        if (Array.isArray(value)) {
          value.forEach((val) => {
            event.formData.append(name, val.toString());
          });
        } else {
          event.formData.append(name, value.toString());
        }
      }
    };
    this.handleFormSubmit = (event) => {
      var _a;
      const disabled = this.options.disabled(this.host);
      const reportValidity = this.options.reportValidity;
      if (this.form && !this.form.noValidate) {
        (_a = formCollections.get(this.form)) == null ? void 0 : _a.forEach((control) => {
          this.setUserInteracted(control, true);
        });
      }
      if (this.form && !this.form.noValidate && !disabled && !reportValidity(this.host)) {
        event.preventDefault();
        event.stopImmediatePropagation();
      }
    };
    this.handleFormReset = () => {
      this.options.setValue(this.host, this.options.defaultValue(this.host));
      this.setUserInteracted(this.host, false);
      interactions$1.set(this.host, []);
    };
    this.handleInteraction = (event) => {
      const emittedEvents = interactions$1.get(this.host);
      if (!emittedEvents.includes(event.type)) {
        emittedEvents.push(event.type);
      }
      if (emittedEvents.length === this.options.assumeInteractionOn.length) {
        this.setUserInteracted(this.host, true);
      }
    };
    this.reportFormValidity = () => {
      if (this.form && !this.form.noValidate) {
        const elements = this.form.querySelectorAll("*");
        for (const element of elements) {
          if (typeof element.reportValidity === "function") {
            if (!element.reportValidity()) {
              return false;
            }
          }
        }
      }
      return true;
    };
    (this.host = host).addController(this);
    this.options = __spreadValues({
      form: (input) => {
        if (input.hasAttribute("form") && input.getAttribute("form") !== "") {
          const root = input.getRootNode();
          const formId = input.getAttribute("form");
          if (formId) {
            return root.getElementById(formId);
          }
        }
        return input.closest("form");
      },
      name: (input) => input.name,
      value: (input) => input.value,
      defaultValue: (input) => input.defaultValue,
      disabled: (input) => {
        var _a;
        return (_a = input.disabled) != null ? _a : false;
      },
      reportValidity: (input) => typeof input.reportValidity === "function" ? input.reportValidity() : true,
      setValue: (input, value) => input.value = value,
      assumeInteractionOn: ["sl-input"]
    }, options);
  }
  hostConnected() {
    const form = this.options.form(this.host);
    if (form) {
      this.attachForm(form);
    }
    interactions$1.set(this.host, []);
    this.options.assumeInteractionOn.forEach((event) => {
      this.host.addEventListener(event, this.handleInteraction);
    });
  }
  hostDisconnected() {
    this.detachForm();
    interactions$1.delete(this.host);
    this.options.assumeInteractionOn.forEach((event) => {
      this.host.removeEventListener(event, this.handleInteraction);
    });
  }
  hostUpdated() {
    const form = this.options.form(this.host);
    if (!form) {
      this.detachForm();
    }
    if (form && this.form !== form) {
      this.detachForm();
      this.attachForm(form);
    }
    if (this.host.hasUpdated) {
      this.setValidity(this.host.validity.valid);
    }
  }
  attachForm(form) {
    if (form) {
      this.form = form;
      if (formCollections.has(this.form)) {
        formCollections.get(this.form).add(this.host);
      } else {
        formCollections.set(this.form, /* @__PURE__ */ new Set([this.host]));
      }
      this.form.addEventListener("formdata", this.handleFormData);
      this.form.addEventListener("submit", this.handleFormSubmit);
      this.form.addEventListener("reset", this.handleFormReset);
      if (!reportValidityOverloads.has(this.form)) {
        reportValidityOverloads.set(this.form, this.form.reportValidity);
        this.form.reportValidity = () => this.reportFormValidity();
      }
    } else {
      this.form = void 0;
    }
  }
  detachForm() {
    var _a;
    if (this.form) {
      (_a = formCollections.get(this.form)) == null ? void 0 : _a.delete(this.host);
      this.form.removeEventListener("formdata", this.handleFormData);
      this.form.removeEventListener("submit", this.handleFormSubmit);
      this.form.removeEventListener("reset", this.handleFormReset);
      if (reportValidityOverloads.has(this.form)) {
        this.form.reportValidity = reportValidityOverloads.get(this.form);
        reportValidityOverloads.delete(this.form);
      }
    }
    this.form = void 0;
  }
  setUserInteracted(el, hasInteracted) {
    if (hasInteracted) {
      userInteractedControls.add(el);
    } else {
      userInteractedControls.delete(el);
    }
    el.requestUpdate();
  }
  doAction(type, submitter) {
    if (this.form) {
      const button = document.createElement("button");
      button.type = type;
      button.style.position = "absolute";
      button.style.width = "0";
      button.style.height = "0";
      button.style.clipPath = "inset(50%)";
      button.style.overflow = "hidden";
      button.style.whiteSpace = "nowrap";
      if (submitter) {
        button.name = submitter.name;
        button.value = submitter.value;
        ["formaction", "formenctype", "formmethod", "formnovalidate", "formtarget"].forEach((attr) => {
          if (submitter.hasAttribute(attr)) {
            button.setAttribute(attr, submitter.getAttribute(attr));
          }
        });
      }
      this.form.append(button);
      button.click();
      button.remove();
    }
  }
  /** Returns the associated `<form>` element, if one exists. */
  getForm() {
    var _a;
    return (_a = this.form) != null ? _a : null;
  }
  /** Resets the form, restoring all the control to their default value */
  reset(submitter) {
    this.doAction("reset", submitter);
  }
  /** Submits the form, triggering validation and form data injection. */
  submit(submitter) {
    this.doAction("submit", submitter);
  }
  /**
   * Synchronously sets the form control's validity. Call this when you know the future validity but need to update
   * the host element immediately, i.e. before Lit updates the component in the next update.
   */
  setValidity(isValid) {
    const host = this.host;
    const hasInteracted = Boolean(userInteractedControls.has(host));
    const required = Boolean(host.required);
    host.toggleAttribute("data-required", required);
    host.toggleAttribute("data-optional", !required);
    host.toggleAttribute("data-invalid", !isValid);
    host.toggleAttribute("data-valid", isValid);
    host.toggleAttribute("data-user-invalid", !isValid && hasInteracted);
    host.toggleAttribute("data-user-valid", isValid && hasInteracted);
  }
  /**
   * Updates the form control's validity based on the current value of `host.validity.valid`. Call this when anything
   * that affects constraint validation changes so the component receives the correct validity states.
   */
  updateValidity() {
    const host = this.host;
    this.setValidity(host.validity.valid);
  }
  /**
   * Dispatches a non-bubbling, cancelable custom event of type `sl-invalid`.
   * If the `sl-invalid` event will be cancelled then the original `invalid`
   * event (which may have been passed as argument) will also be cancelled.
   * If no original `invalid` event has been passed then the `sl-invalid`
   * event will be cancelled before being dispatched.
   */
  emitInvalidEvent(originalInvalidEvent) {
    const slInvalidEvent = new CustomEvent("sl-invalid", {
      bubbles: false,
      composed: false,
      cancelable: true,
      detail: {}
    });
    if (!originalInvalidEvent) {
      slInvalidEvent.preventDefault();
    }
    if (!this.host.dispatchEvent(slInvalidEvent)) {
      originalInvalidEvent == null ? void 0 : originalInvalidEvent.preventDefault();
    }
  }
};
var validValidityState = Object.freeze({
  badInput: false,
  customError: false,
  patternMismatch: false,
  rangeOverflow: false,
  rangeUnderflow: false,
  stepMismatch: false,
  tooLong: false,
  tooShort: false,
  typeMismatch: false,
  valid: true,
  valueMissing: false
});
var valueMissingValidityState = Object.freeze(__spreadProps(__spreadValues({}, validValidityState), {
  valid: false,
  valueMissing: true
}));
var customErrorValidityState = Object.freeze(__spreadProps(__spreadValues({}, validValidityState), {
  valid: false,
  customError: true
}));

// src/utilities/form.ts
function serialize$1(form) {
  const formData = new FormData(form);
  const object = {};
  formData.forEach((value, key) => {
    if (Reflect.has(object, key)) {
      const entry = object[key];
      if (Array.isArray(entry)) {
        entry.push(value);
      } else {
        object[key] = [object[key], value];
      }
    } else {
      object[key] = value;
    }
  });
  return object;
}
function getFormControls(form) {
  const rootNode = form.getRootNode();
  const allNodes = [...rootNode.querySelectorAll("*")];
  const formControls = [...form.elements];
  const collection = formCollections.get(form);
  const shoelaceFormControls = collection ? Array.from(collection) : [];
  return [...formControls, ...shoelaceFormControls].sort((a, b) => {
    if (allNodes.indexOf(a) < allNodes.indexOf(b))
      return -1;
    if (allNodes.indexOf(a) > allNodes.indexOf(b))
      return 1;
    return 0;
  });
}

// src/styles/component.styles.ts
var component_styles_default = i$b`
  :host {
    box-sizing: border-box;
  }

  :host *,
  :host *::before,
  :host *::after {
    box-sizing: inherit;
  }

  [hidden] {
    display: none !important;
  }
`;

var tree_item_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
    outline: 0;
    z-index: 0;
  }

  :host(:focus) {
    outline: none;
  }

  slot:not([name])::slotted(sl-icon) {
    margin-inline-end: var(--sl-spacing-x-small);
  }

  .tree-item {
    position: relative;
    display: flex;
    align-items: stretch;
    flex-direction: column;
    color: var(--sl-color-neutral-700);
    cursor: pointer;
    user-select: none;
  }

  .tree-item__checkbox {
    pointer-events: none;
  }

  .tree-item__expand-button,
  .tree-item__checkbox,
  .tree-item__label {
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-medium);
    font-weight: var(--sl-font-weight-normal);
    line-height: var(--sl-line-height-dense);
    letter-spacing: var(--sl-letter-spacing-normal);
  }

  .tree-item__checkbox::part(base) {
    display: flex;
    align-items: center;
  }

  .tree-item__indentation {
    display: block;
    width: 1em;
    flex-shrink: 0;
  }

  .tree-item__expand-button {
    display: flex;
    align-items: center;
    justify-content: center;
    box-sizing: content-box;
    color: var(--sl-color-neutral-500);
    padding: var(--sl-spacing-x-small);
    width: 1rem;
    height: 1rem;
    flex-shrink: 0;
    cursor: pointer;
  }

  .tree-item__expand-button {
    transition: var(--sl-transition-medium) rotate ease;
  }

  .tree-item--expanded .tree-item__expand-button {
    rotate: 90deg;
  }

  .tree-item--expanded.tree-item--rtl .tree-item__expand-button {
    rotate: -90deg;
  }

  .tree-item--expanded slot[name='expand-icon'],
  .tree-item:not(.tree-item--expanded) slot[name='collapse-icon'] {
    display: none;
  }

  .tree-item:not(.tree-item--has-expand-button) .tree-item__expand-icon-slot {
    display: none;
  }

  .tree-item__expand-button--visible {
    cursor: pointer;
  }

  .tree-item__item {
    display: flex;
    align-items: center;
    border-inline-start: solid 3px transparent;
  }

  .tree-item--disabled .tree-item__item {
    opacity: 0.5;
    outline: none;
    cursor: not-allowed;
  }

  :host(:focus-visible) .tree-item__item {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
    z-index: 2;
  }

  :host(:not([aria-disabled='true'])) .tree-item--selected .tree-item__item {
    background-color: var(--sl-color-neutral-100);
    border-inline-start-color: var(--sl-color-primary-600);
  }

  :host(:not([aria-disabled='true'])) .tree-item__expand-button {
    color: var(--sl-color-neutral-600);
  }

  .tree-item__label {
    display: flex;
    align-items: center;
    transition: var(--sl-transition-fast) color;
  }

  .tree-item__children {
    display: block;
    font-size: calc(1em + var(--indent-size, var(--sl-spacing-medium)));
  }

  /* Indentation lines */
  .tree-item__children {
    position: relative;
  }

  .tree-item__children::before {
    content: '';
    position: absolute;
    top: var(--indent-guide-offset);
    bottom: var(--indent-guide-offset);
    left: calc(1em - (var(--indent-guide-width) / 2) - 1px);
    border-inline-end: var(--indent-guide-width) var(--indent-guide-style) var(--indent-guide-color);
    z-index: 1;
  }

  .tree-item--rtl .tree-item__children::before {
    left: auto;
    right: 1em;
  }

  @media (forced-colors: active) {
    :host(:not([aria-disabled='true'])) .tree-item--selected .tree-item__item {
      outline: dashed 1px SelectedItem;
    }
  }
`;

var checkbox_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }

  .checkbox {
    position: relative;
    display: inline-flex;
    align-items: flex-start;
    font-family: var(--sl-input-font-family);
    font-weight: var(--sl-input-font-weight);
    color: var(--sl-input-label-color);
    vertical-align: middle;
    cursor: pointer;
  }

  .checkbox--small {
    --toggle-size: var(--sl-toggle-size-small);
    font-size: var(--sl-input-font-size-small);
  }

  .checkbox--medium {
    --toggle-size: var(--sl-toggle-size-medium);
    font-size: var(--sl-input-font-size-medium);
  }

  .checkbox--large {
    --toggle-size: var(--sl-toggle-size-large);
    font-size: var(--sl-input-font-size-large);
  }

  .checkbox__control {
    flex: 0 0 auto;
    position: relative;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: var(--toggle-size);
    height: var(--toggle-size);
    border: solid var(--sl-input-border-width) var(--sl-input-border-color);
    border-radius: 2px;
    background-color: var(--sl-input-background-color);
    color: var(--sl-color-neutral-0);
    transition: var(--sl-transition-fast) border-color, var(--sl-transition-fast) background-color,
      var(--sl-transition-fast) color, var(--sl-transition-fast) box-shadow;
  }

  .checkbox__input {
    position: absolute;
    opacity: 0;
    padding: 0;
    margin: 0;
    pointer-events: none;
  }

  .checkbox__checked-icon,
  .checkbox__indeterminate-icon {
    display: inline-flex;
    width: var(--toggle-size);
    height: var(--toggle-size);
  }

  /* Hover */
  .checkbox:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--sl-input-border-color-hover);
    background-color: var(--sl-input-background-color-hover);
  }

  /* Focus */
  .checkbox:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__input:focus-visible ~ .checkbox__control {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  /* Checked/indeterminate */
  .checkbox--checked .checkbox__control,
  .checkbox--indeterminate .checkbox__control {
    border-color: var(--sl-color-primary-600);
    background-color: var(--sl-color-primary-600);
  }

  /* Checked/indeterminate + hover */
  .checkbox.checkbox--checked:not(.checkbox--disabled) .checkbox__control:hover,
  .checkbox.checkbox--indeterminate:not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--sl-color-primary-500);
    background-color: var(--sl-color-primary-500);
  }

  /* Checked/indeterminate + focus */
  .checkbox.checkbox--checked:not(.checkbox--disabled) .checkbox__input:focus-visible ~ .checkbox__control,
  .checkbox.checkbox--indeterminate:not(.checkbox--disabled) .checkbox__input:focus-visible ~ .checkbox__control {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  /* Disabled */
  .checkbox--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .checkbox__label {
    display: inline-block;
    color: var(--sl-input-label-color);
    line-height: var(--toggle-size);
    margin-inline-start: 0.5em;
    user-select: none;
  }

  :host([required]) .checkbox__label::after {
    content: var(--sl-input-required-content);
    margin-inline-start: var(--sl-input-required-content-offset);
  }
`;

// src/internal/default-value.ts
var defaultValue = (propertyName = "value") => (proto, key) => {
  const ctor = proto.constructor;
  const attributeChangedCallback = ctor.prototype.attributeChangedCallback;
  ctor.prototype.attributeChangedCallback = function(name, old, value) {
    var _a;
    const options = ctor.getPropertyOptions(propertyName);
    const attributeName = typeof options.attribute === "string" ? options.attribute : propertyName;
    if (name === attributeName) {
      const converter = options.converter || n$c;
      const fromAttribute = typeof converter === "function" ? converter : (_a = converter == null ? void 0 : converter.fromAttribute) != null ? _a : n$c.fromAttribute;
      const newValue = fromAttribute(value, options.type);
      if (this[propertyName] !== newValue) {
        this[key] = newValue;
      }
    }
    attributeChangedCallback.call(this, name, old, value);
  };
};

var icon_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
    width: 1em;
    height: 1em;
    box-sizing: content-box !important;
  }

  svg {
    display: block;
    height: 100%;
    width: 100%;
  }
`;

// src/internal/watch.ts
function watch(propertyName, options) {
  const resolvedOptions = __spreadValues({
    waitUntilFirstUpdate: false
  }, options);
  return (proto, decoratedFnName) => {
    const { update } = proto;
    const watchedProperties = Array.isArray(propertyName) ? propertyName : [propertyName];
    proto.update = function(changedProps) {
      watchedProperties.forEach((property) => {
        const key = property;
        if (changedProps.has(key)) {
          const oldValue = changedProps.get(key);
          const newValue = this[key];
          if (oldValue !== newValue) {
            if (!resolvedOptions.waitUntilFirstUpdate || this.hasUpdated) {
              this[decoratedFnName](oldValue, newValue);
            }
          }
        }
      });
      update.call(this, changedProps);
    };
  };
}

var ShoelaceElement = class extends s$5 {
  constructor() {
    super();
    Object.entries(this.constructor.dependencies).forEach(([name, component]) => {
      this.constructor.define(name, component);
    });
  }
  emit(name, options) {
    const event = new CustomEvent(name, __spreadValues({
      bubbles: true,
      cancelable: false,
      composed: true,
      detail: {}
    }, options));
    this.dispatchEvent(event);
    return event;
  }
  /* eslint-enable */
  static define(name, elementConstructor = this, options = {}) {
    const currentlyRegisteredConstructor = customElements.get(name);
    if (!currentlyRegisteredConstructor) {
      customElements.define(name, class extends elementConstructor {
      }, options);
      return;
    }
    let newVersion = " (unknown version)";
    let existingVersion = newVersion;
    if ("version" in elementConstructor && elementConstructor.version) {
      newVersion = " v" + elementConstructor.version;
    }
    if ("version" in currentlyRegisteredConstructor && currentlyRegisteredConstructor.version) {
      existingVersion = " v" + currentlyRegisteredConstructor.version;
    }
    if (newVersion && existingVersion && newVersion === existingVersion) {
      return;
    }
    console.warn(
      `Attempted to register <${name}>${newVersion}, but <${name}>${existingVersion} has already been registered.`
    );
  }
};
/* eslint-disable */
// @ts-expect-error This is auto-injected at build time.
ShoelaceElement.version = "2.8.0";
ShoelaceElement.dependencies = {};
__decorateClass([
  e$c()
], ShoelaceElement.prototype, "dir", 2);
__decorateClass([
  e$c()
], ShoelaceElement.prototype, "lang", 2);

var CACHEABLE_ERROR = Symbol();
var RETRYABLE_ERROR = Symbol();
var parser;
var iconCache = /* @__PURE__ */ new Map();
var SlIcon = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.initialRender = false;
    this.svg = null;
    this.label = "";
    this.library = "default";
  }
  /** Given a URL, this function returns the resulting SVG element or an appropriate error symbol. */
  async resolveIcon(url, library) {
    var _a;
    let fileData;
    if (library == null ? void 0 : library.spriteSheet) {
      return x$1`<svg part="svg">
        <use part="use" href="${url}"></use>
      </svg>`;
    }
    try {
      fileData = await fetch(url, { mode: "cors" });
      if (!fileData.ok)
        return fileData.status === 410 ? CACHEABLE_ERROR : RETRYABLE_ERROR;
    } catch (e) {
      return RETRYABLE_ERROR;
    }
    try {
      const div = document.createElement("div");
      div.innerHTML = await fileData.text();
      const svg = div.firstElementChild;
      if (((_a = svg == null ? void 0 : svg.tagName) == null ? void 0 : _a.toLowerCase()) !== "svg")
        return CACHEABLE_ERROR;
      if (!parser)
        parser = new DOMParser();
      const doc = parser.parseFromString(svg.outerHTML, "text/html");
      const svgEl = doc.body.querySelector("svg");
      if (!svgEl)
        return CACHEABLE_ERROR;
      svgEl.part.add("svg");
      return document.adoptNode(svgEl);
    } catch (e) {
      return CACHEABLE_ERROR;
    }
  }
  connectedCallback() {
    super.connectedCallback();
    watchIcon(this);
  }
  firstUpdated() {
    this.initialRender = true;
    this.setIcon();
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    unwatchIcon(this);
  }
  getUrl() {
    const library = getIconLibrary(this.library);
    if (this.name && library) {
      return library.resolver(this.name);
    }
    return this.src;
  }
  handleLabelChange() {
    const hasLabel = typeof this.label === "string" && this.label.length > 0;
    if (hasLabel) {
      this.setAttribute("role", "img");
      this.setAttribute("aria-label", this.label);
      this.removeAttribute("aria-hidden");
    } else {
      this.removeAttribute("role");
      this.removeAttribute("aria-label");
      this.setAttribute("aria-hidden", "true");
    }
  }
  async setIcon() {
    var _a;
    const library = getIconLibrary(this.library);
    const url = this.getUrl();
    if (!url) {
      this.svg = null;
      return;
    }
    let iconResolver = iconCache.get(url);
    if (!iconResolver) {
      iconResolver = this.resolveIcon(url, library);
      iconCache.set(url, iconResolver);
    }
    if (!this.initialRender) {
      return;
    }
    const svg = await iconResolver;
    if (svg === RETRYABLE_ERROR) {
      iconCache.delete(url);
    }
    if (url !== this.getUrl()) {
      return;
    }
    if (t$4(svg)) {
      this.svg = svg;
      return;
    }
    switch (svg) {
      case RETRYABLE_ERROR:
      case CACHEABLE_ERROR:
        this.svg = null;
        this.emit("sl-error");
        break;
      default:
        this.svg = svg.cloneNode(true);
        (_a = library == null ? void 0 : library.mutator) == null ? void 0 : _a.call(library, this.svg);
        this.emit("sl-load");
    }
  }
  render() {
    return this.svg;
  }
};
SlIcon.styles = icon_styles_default;
__decorateClass([
  t$7()
], SlIcon.prototype, "svg", 2);
__decorateClass([
  e$c({ reflect: true })
], SlIcon.prototype, "name", 2);
__decorateClass([
  e$c()
], SlIcon.prototype, "src", 2);
__decorateClass([
  e$c()
], SlIcon.prototype, "label", 2);
__decorateClass([
  e$c({ reflect: true })
], SlIcon.prototype, "library", 2);
__decorateClass([
  watch("label")
], SlIcon.prototype, "handleLabelChange", 1);
__decorateClass([
  watch(["name", "src", "library"])
], SlIcon.prototype, "setIcon", 1);

var SlCheckbox = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      value: (control) => control.checked ? control.value || "on" : void 0,
      defaultValue: (control) => control.defaultChecked,
      setValue: (control, checked) => control.checked = checked
    });
    this.hasFocus = false;
    this.title = "";
    this.name = "";
    this.size = "medium";
    this.disabled = false;
    this.checked = false;
    this.indeterminate = false;
    this.defaultChecked = false;
    this.form = "";
    this.required = false;
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  handleClick() {
    this.checked = !this.checked;
    this.indeterminate = false;
    this.emit("sl-change");
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleInput() {
    this.emit("sl-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleDisabledChange() {
    this.formControlController.setValidity(this.disabled);
  }
  handleStateChange() {
    this.input.checked = this.checked;
    this.input.indeterminate = this.indeterminate;
    this.formControlController.updateValidity();
  }
  /** Simulates a click on the checkbox. */
  click() {
    this.input.click();
  }
  /** Sets focus on the checkbox. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the checkbox. */
  blur() {
    this.input.blur();
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /**
   * Sets a custom validation message. The value provided will be shown to the user when the form is submitted. To clear
   * the custom validation message, call this method with an empty string.
   */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    return x$1`
      <label
        part="base"
        class=${o$9({
      checkbox: true,
      "checkbox--checked": this.checked,
      "checkbox--disabled": this.disabled,
      "checkbox--focused": this.hasFocus,
      "checkbox--indeterminate": this.indeterminate,
      "checkbox--small": this.size === "small",
      "checkbox--medium": this.size === "medium",
      "checkbox--large": this.size === "large"
    })}
      >
        <input
          class="checkbox__input"
          type="checkbox"
          title=${this.title}
          name=${this.name}
          value=${l$2(this.value)}
          .indeterminate=${l$1(this.indeterminate)}
          .checked=${l$1(this.checked)}
          .disabled=${this.disabled}
          .required=${this.required}
          aria-checked=${this.checked ? "true" : "false"}
          @click=${this.handleClick}
          @input=${this.handleInput}
          @invalid=${this.handleInvalid}
          @blur=${this.handleBlur}
          @focus=${this.handleFocus}
        />

        <span
          part="control${this.checked ? " control--checked" : ""}${this.indeterminate ? " control--indeterminate" : ""}"
          class="checkbox__control"
        >
          ${this.checked ? x$1`
                <sl-icon part="checked-icon" class="checkbox__checked-icon" library="system" name="check"></sl-icon>
              ` : ""}
          ${!this.checked && this.indeterminate ? x$1`
                <sl-icon
                  part="indeterminate-icon"
                  class="checkbox__indeterminate-icon"
                  library="system"
                  name="indeterminate"
                ></sl-icon>
              ` : ""}
        </span>

        <div part="label" class="checkbox__label">
          <slot></slot>
        </div>
      </label>
    `;
  }
};
SlCheckbox.styles = checkbox_styles_default;
SlCheckbox.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7('input[type="checkbox"]')
], SlCheckbox.prototype, "input", 2);
__decorateClass([
  t$7()
], SlCheckbox.prototype, "hasFocus", 2);
__decorateClass([
  e$c()
], SlCheckbox.prototype, "title", 2);
__decorateClass([
  e$c()
], SlCheckbox.prototype, "name", 2);
__decorateClass([
  e$c()
], SlCheckbox.prototype, "value", 2);
__decorateClass([
  e$c({ reflect: true })
], SlCheckbox.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCheckbox.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCheckbox.prototype, "checked", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCheckbox.prototype, "indeterminate", 2);
__decorateClass([
  defaultValue("checked")
], SlCheckbox.prototype, "defaultChecked", 2);
__decorateClass([
  e$c({ reflect: true })
], SlCheckbox.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCheckbox.prototype, "required", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlCheckbox.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch(["checked", "indeterminate"], { waitUntilFirstUpdate: true })
], SlCheckbox.prototype, "handleStateChange", 1);

var spinner_styles_default = i$b`
  ${component_styles_default}

  :host {
    --track-width: 2px;
    --track-color: rgb(128 128 128 / 25%);
    --indicator-color: var(--sl-color-primary-600);
    --speed: 2s;

    display: inline-flex;
    width: 1em;
    height: 1em;
  }

  .spinner {
    flex: 1 1 auto;
    height: 100%;
    width: 100%;
  }

  .spinner__track,
  .spinner__indicator {
    fill: none;
    stroke-width: var(--track-width);
    r: calc(0.5em - var(--track-width) / 2);
    cx: 0.5em;
    cy: 0.5em;
    transform-origin: 50% 50%;
  }

  .spinner__track {
    stroke: var(--track-color);
    transform-origin: 0% 0%;
  }

  .spinner__indicator {
    stroke: var(--indicator-color);
    stroke-linecap: round;
    stroke-dasharray: 150% 75%;
    animation: spin var(--speed) linear infinite;
  }

  @keyframes spin {
    0% {
      transform: rotate(0deg);
      stroke-dasharray: 0.01em, 2.75em;
    }

    50% {
      transform: rotate(450deg);
      stroke-dasharray: 1.375em, 1.375em;
    }

    100% {
      transform: rotate(1080deg);
      stroke-dasharray: 0.01em, 2.75em;
    }
  }
`;

const connectedElements = new Set();
const documentElementObserver = new MutationObserver(update);
const translations = new Map();
let documentDirection = document.documentElement.dir || 'ltr';
let documentLanguage = document.documentElement.lang || navigator.language;
let fallback;
documentElementObserver.observe(document.documentElement, {
    attributes: true,
    attributeFilter: ['dir', 'lang']
});
function registerTranslation(...translation) {
    translation.map(t => {
        const code = t.$code.toLowerCase();
        if (translations.has(code)) {
            translations.set(code, Object.assign(Object.assign({}, translations.get(code)), t));
        }
        else {
            translations.set(code, t);
        }
        if (!fallback) {
            fallback = t;
        }
    });
    update();
}
function update() {
    documentDirection = document.documentElement.dir || 'ltr';
    documentLanguage = document.documentElement.lang || navigator.language;
    [...connectedElements.keys()].map((el) => {
        if (typeof el.requestUpdate === 'function') {
            el.requestUpdate();
        }
    });
}
class LocalizeController$1 {
    constructor(host) {
        this.host = host;
        this.host.addController(this);
    }
    hostConnected() {
        connectedElements.add(this.host);
    }
    hostDisconnected() {
        connectedElements.delete(this.host);
    }
    dir() {
        return `${this.host.dir || documentDirection}`.toLowerCase();
    }
    lang() {
        return `${this.host.lang || documentLanguage}`.toLowerCase();
    }
    getTranslationData(lang) {
        var _a, _b;
        const locale = new Intl.Locale(lang);
        const language = locale === null || locale === void 0 ? void 0 : locale.language.toLowerCase();
        const region = (_b = (_a = locale === null || locale === void 0 ? void 0 : locale.region) === null || _a === void 0 ? void 0 : _a.toLowerCase()) !== null && _b !== void 0 ? _b : '';
        const primary = translations.get(`${language}-${region}`);
        const secondary = translations.get(language);
        return { locale, language, region, primary, secondary };
    }
    exists(key, options) {
        var _a;
        const { primary, secondary } = this.getTranslationData((_a = options.lang) !== null && _a !== void 0 ? _a : this.lang());
        options = Object.assign({ includeFallback: false }, options);
        if ((primary && primary[key]) ||
            (secondary && secondary[key]) ||
            (options.includeFallback && fallback && fallback[key])) {
            return true;
        }
        return false;
    }
    term(key, ...args) {
        const { primary, secondary } = this.getTranslationData(this.lang());
        let term;
        if (primary && primary[key]) {
            term = primary[key];
        }
        else if (secondary && secondary[key]) {
            term = secondary[key];
        }
        else if (fallback && fallback[key]) {
            term = fallback[key];
        }
        else {
            console.error(`No translation found for: ${String(key)}`);
            return String(key);
        }
        if (typeof term === 'function') {
            return term(...args);
        }
        return term;
    }
    date(dateToFormat, options) {
        dateToFormat = new Date(dateToFormat);
        return new Intl.DateTimeFormat(this.lang(), options).format(dateToFormat);
    }
    number(numberToFormat, options) {
        numberToFormat = Number(numberToFormat);
        return isNaN(numberToFormat) ? '' : new Intl.NumberFormat(this.lang(), options).format(numberToFormat);
    }
    relativeTime(value, unit, options) {
        return new Intl.RelativeTimeFormat(this.lang(), options).format(value, unit);
    }
}

// src/utilities/localize.ts
var LocalizeController = class extends LocalizeController$1 {
};

var SlSpinner = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
  }
  render() {
    return x$1`
      <svg part="base" class="spinner" role="progressbar" aria-label=${this.localize.term("loading")}>
        <circle class="spinner__track"></circle>
        <circle class="spinner__indicator"></circle>
      </svg>
    `;
  }
};
SlSpinner.styles = spinner_styles_default;

// src/utilities/animation-registry.ts
var defaultAnimationRegistry = /* @__PURE__ */ new Map();
var customAnimationRegistry = /* @__PURE__ */ new WeakMap();
function ensureAnimation(animation) {
  return animation != null ? animation : { keyframes: [], options: { duration: 0 } };
}
function getLogicalAnimation(animation, dir) {
  if (dir.toLowerCase() === "rtl") {
    return {
      keyframes: animation.rtlKeyframes || animation.keyframes,
      options: animation.options
    };
  }
  return animation;
}
function setDefaultAnimation(animationName, animation) {
  defaultAnimationRegistry.set(animationName, ensureAnimation(animation));
}
function setAnimation(el, animationName, animation) {
  customAnimationRegistry.set(el, __spreadProps(__spreadValues({}, customAnimationRegistry.get(el)), { [animationName]: ensureAnimation(animation) }));
}
function getAnimation(el, animationName, options) {
  const customAnimation = customAnimationRegistry.get(el);
  if (customAnimation == null ? void 0 : customAnimation[animationName]) {
    return getLogicalAnimation(customAnimation[animationName], options.dir);
  }
  const defaultAnimation = defaultAnimationRegistry.get(animationName);
  if (defaultAnimation) {
    return getLogicalAnimation(defaultAnimation, options.dir);
  }
  return {
    keyframes: [],
    options: { duration: 0 }
  };
}

// src/internal/animate.ts
function animateTo(el, keyframes, options) {
  return new Promise((resolve) => {
    if ((options == null ? void 0 : options.duration) === Infinity) {
      throw new Error("Promise-based animations must be finite.");
    }
    const animation = el.animate(keyframes, __spreadProps(__spreadValues({}, options), {
      duration: prefersReducedMotion() ? 0 : options.duration
    }));
    animation.addEventListener("cancel", resolve, { once: true });
    animation.addEventListener("finish", resolve, { once: true });
  });
}
function parseDuration(delay) {
  delay = delay.toString().toLowerCase();
  if (delay.indexOf("ms") > -1) {
    return parseFloat(delay);
  }
  if (delay.indexOf("s") > -1) {
    return parseFloat(delay) * 1e3;
  }
  return parseFloat(delay);
}
function prefersReducedMotion() {
  const query = window.matchMedia("(prefers-reduced-motion: reduce)");
  return query.matches;
}
function stopAnimations(el) {
  return Promise.all(
    el.getAnimations().map((animation) => {
      return new Promise((resolve) => {
        const handleAnimationEvent = requestAnimationFrame(resolve);
        animation.addEventListener("cancel", () => handleAnimationEvent, { once: true });
        animation.addEventListener("finish", () => handleAnimationEvent, { once: true });
        animation.cancel();
      });
    })
  );
}
function shimKeyframesHeightAuto(keyframes, calculatedHeight) {
  return keyframes.map((keyframe) => __spreadProps(__spreadValues({}, keyframe), {
    height: keyframe.height === "auto" ? `${calculatedHeight}px` : keyframe.height
  }));
}

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function n$2(n,o,r){return n?o():null==r?void 0:r()}

var _SlTreeItem = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.indeterminate = false;
    this.isLeaf = false;
    this.loading = false;
    this.selectable = false;
    this.expanded = false;
    this.selected = false;
    this.disabled = false;
    this.lazy = false;
  }
  static isTreeItem(node) {
    return node instanceof Element && node.getAttribute("role") === "treeitem";
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "treeitem");
    this.setAttribute("tabindex", "-1");
    if (this.isNestedItem()) {
      this.slot = "children";
    }
  }
  firstUpdated() {
    this.childrenContainer.hidden = !this.expanded;
    this.childrenContainer.style.height = this.expanded ? "auto" : "0";
    this.isLeaf = !this.lazy && this.getChildrenItems().length === 0;
    this.handleExpandedChange();
  }
  async animateCollapse() {
    this.emit("sl-collapse");
    await stopAnimations(this.childrenContainer);
    const { keyframes, options } = getAnimation(this, "tree-item.collapse", { dir: this.localize.dir() });
    await animateTo(
      this.childrenContainer,
      shimKeyframesHeightAuto(keyframes, this.childrenContainer.scrollHeight),
      options
    );
    this.childrenContainer.hidden = true;
    this.emit("sl-after-collapse");
  }
  // Checks whether the item is nested into an item
  isNestedItem() {
    const parent = this.parentElement;
    return !!parent && _SlTreeItem.isTreeItem(parent);
  }
  handleChildrenSlotChange() {
    this.loading = false;
    this.isLeaf = !this.lazy && this.getChildrenItems().length === 0;
  }
  willUpdate(changedProperties) {
    if (changedProperties.has("selected") && !changedProperties.has("indeterminate")) {
      this.indeterminate = false;
    }
  }
  async animateExpand() {
    this.emit("sl-expand");
    await stopAnimations(this.childrenContainer);
    this.childrenContainer.hidden = false;
    const { keyframes, options } = getAnimation(this, "tree-item.expand", { dir: this.localize.dir() });
    await animateTo(
      this.childrenContainer,
      shimKeyframesHeightAuto(keyframes, this.childrenContainer.scrollHeight),
      options
    );
    this.childrenContainer.style.height = "auto";
    this.emit("sl-after-expand");
  }
  handleLoadingChange() {
    this.setAttribute("aria-busy", this.loading ? "true" : "false");
    if (!this.loading) {
      this.animateExpand();
    }
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  handleSelectedChange() {
    this.setAttribute("aria-selected", this.selected ? "true" : "false");
  }
  handleExpandedChange() {
    if (!this.isLeaf) {
      this.setAttribute("aria-expanded", this.expanded ? "true" : "false");
    } else {
      this.removeAttribute("aria-expanded");
    }
  }
  handleExpandAnimation() {
    if (this.expanded) {
      if (this.lazy) {
        this.loading = true;
        this.emit("sl-lazy-load");
      } else {
        this.animateExpand();
      }
    } else {
      this.animateCollapse();
    }
  }
  handleLazyChange() {
    this.emit("sl-lazy-change");
  }
  /** Gets all the nested tree items in this node. */
  getChildrenItems({ includeDisabled = true } = {}) {
    return this.childrenSlot ? [...this.childrenSlot.assignedElements({ flatten: true })].filter(
      (item) => _SlTreeItem.isTreeItem(item) && (includeDisabled || !item.disabled)
    ) : [];
  }
  render() {
    const isRtl = this.localize.dir() === "rtl";
    const showExpandButton = !this.loading && (!this.isLeaf || this.lazy);
    return x$1`
      <div
        part="base"
        class="${o$9({
      "tree-item": true,
      "tree-item--expanded": this.expanded,
      "tree-item--selected": this.selected,
      "tree-item--disabled": this.disabled,
      "tree-item--leaf": this.isLeaf,
      "tree-item--has-expand-button": showExpandButton,
      "tree-item--rtl": this.localize.dir() === "rtl"
    })}"
      >
        <div
          class="tree-item__item"
          part="
            item
            ${this.disabled ? "item--disabled" : ""}
            ${this.expanded ? "item--expanded" : ""}
            ${this.indeterminate ? "item--indeterminate" : ""}
            ${this.selected ? "item--selected" : ""}
          "
        >
          <div class="tree-item__indentation" part="indentation"></div>

          <div
            part="expand-button"
            class=${o$9({
      "tree-item__expand-button": true,
      "tree-item__expand-button--visible": showExpandButton
    })}
            aria-hidden="true"
          >
            ${n$2(this.loading, () => x$1` <sl-spinner></sl-spinner> `)}
            <slot class="tree-item__expand-icon-slot" name="expand-icon">
              <sl-icon library="system" name=${isRtl ? "chevron-left" : "chevron-right"}></sl-icon>
            </slot>
            <slot class="tree-item__expand-icon-slot" name="collapse-icon">
              <sl-icon library="system" name=${isRtl ? "chevron-left" : "chevron-right"}></sl-icon>
            </slot>
          </div>

          ${n$2(
      this.selectable,
      () => x$1`
                <sl-checkbox
                  part="checkbox"
                  exportparts="
                    base:checkbox__base,
                    control:checkbox__control,
                    control--checked:checkbox__control--checked,
                    control--indeterminate:checkbox__control--indeterminate,
                    checked-icon:checkbox__checked-icon,
                    indeterminate-icon:checkbox__indeterminate-icon,
                    label:checkbox__label
                  "
                  class="tree-item__checkbox"
                  ?disabled="${this.disabled}"
                  ?checked="${l$1(this.selected)}"
                  ?indeterminate="${this.indeterminate}"
                  tabindex="-1"
                ></sl-checkbox>
              `
    )}

          <slot class="tree-item__label" part="label"></slot>
        </div>

        <div class="tree-item__children" part="children" role="group">
          <slot name="children" @slotchange="${this.handleChildrenSlotChange}"></slot>
        </div>
      </div>
    `;
  }
};
var SlTreeItem = _SlTreeItem;
SlTreeItem.styles = tree_item_styles_default;
SlTreeItem.dependencies = {
  "sl-checkbox": SlCheckbox,
  "sl-icon": SlIcon,
  "sl-spinner": SlSpinner
};
__decorateClass([
  t$7()
], SlTreeItem.prototype, "indeterminate", 2);
__decorateClass([
  t$7()
], SlTreeItem.prototype, "isLeaf", 2);
__decorateClass([
  t$7()
], SlTreeItem.prototype, "loading", 2);
__decorateClass([
  t$7()
], SlTreeItem.prototype, "selectable", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTreeItem.prototype, "expanded", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTreeItem.prototype, "selected", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTreeItem.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTreeItem.prototype, "lazy", 2);
__decorateClass([
  i$7("slot:not([name])")
], SlTreeItem.prototype, "defaultSlot", 2);
__decorateClass([
  i$7("slot[name=children]")
], SlTreeItem.prototype, "childrenSlot", 2);
__decorateClass([
  i$7(".tree-item__item")
], SlTreeItem.prototype, "itemElement", 2);
__decorateClass([
  i$7(".tree-item__children")
], SlTreeItem.prototype, "childrenContainer", 2);
__decorateClass([
  i$7(".tree-item__expand-button slot")
], SlTreeItem.prototype, "expandButtonSlot", 2);
__decorateClass([
  watch("loading", { waitUntilFirstUpdate: true })
], SlTreeItem.prototype, "handleLoadingChange", 1);
__decorateClass([
  watch("disabled")
], SlTreeItem.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("selected")
], SlTreeItem.prototype, "handleSelectedChange", 1);
__decorateClass([
  watch("expanded", { waitUntilFirstUpdate: true })
], SlTreeItem.prototype, "handleExpandedChange", 1);
__decorateClass([
  watch("expanded", { waitUntilFirstUpdate: true })
], SlTreeItem.prototype, "handleExpandAnimation", 1);
__decorateClass([
  watch("lazy", { waitUntilFirstUpdate: true })
], SlTreeItem.prototype, "handleLazyChange", 1);
setDefaultAnimation("tree-item.expand", {
  keyframes: [
    { height: "0", opacity: "0", overflow: "hidden" },
    { height: "auto", opacity: "1", overflow: "hidden" }
  ],
  options: { duration: 250, easing: "cubic-bezier(0.4, 0.0, 0.2, 1)" }
});
setDefaultAnimation("tree-item.collapse", {
  keyframes: [
    { height: "auto", opacity: "1", overflow: "hidden" },
    { height: "0", opacity: "0", overflow: "hidden" }
  ],
  options: { duration: 200, easing: "cubic-bezier(0.4, 0.0, 0.2, 1)" }
});

var tree_styles_default = i$b`
  ${component_styles_default}

  :host {
    /*
     * These are actually used by tree item, but we define them here so they can more easily be set and all tree items
     * stay consistent.
     */
    --indent-guide-color: var(--sl-color-neutral-200);
    --indent-guide-offset: 0;
    --indent-guide-style: solid;
    --indent-guide-width: 0;
    --indent-size: var(--sl-spacing-large);

    display: block;
    isolation: isolate;

    /*
     * Tree item indentation uses the "em" unit to increment its width on each level, so setting the font size to zero
     * here removes the indentation for all the nodes on the first level.
     */
    font-size: 0;
  }
`;

// src/internal/math.ts
function clamp$1(value, min, max) {
  const noNegativeZero = (n) => Object.is(n, -0) ? 0 : n;
  if (value < min) {
    return noNegativeZero(min);
  }
  if (value > max) {
    return noNegativeZero(max);
  }
  return noNegativeZero(value);
}

function syncCheckboxes(changedTreeItem, initialSync = false) {
  function syncParentItem(treeItem) {
    const children = treeItem.getChildrenItems({ includeDisabled: false });
    if (children.length) {
      const allChecked = children.every((item) => item.selected);
      const allUnchecked = children.every((item) => !item.selected && !item.indeterminate);
      treeItem.selected = allChecked;
      treeItem.indeterminate = !allChecked && !allUnchecked;
    }
  }
  function syncAncestors(treeItem) {
    const parentItem = treeItem.parentElement;
    if (SlTreeItem.isTreeItem(parentItem)) {
      syncParentItem(parentItem);
      syncAncestors(parentItem);
    }
  }
  function syncDescendants(treeItem) {
    for (const childItem of treeItem.getChildrenItems()) {
      childItem.selected = initialSync ? treeItem.selected || childItem.selected : !childItem.disabled && treeItem.selected;
      syncDescendants(childItem);
    }
    if (initialSync) {
      syncParentItem(treeItem);
    }
  }
  syncDescendants(changedTreeItem);
  syncAncestors(changedTreeItem);
}
var SlTree = class extends ShoelaceElement {
  constructor() {
    super();
    this.selection = "single";
    this.localize = new LocalizeController(this);
    this.clickTarget = null;
    // Initializes new items by setting the `selectable` property and the expanded/collapsed icons if any
    this.initTreeItem = (item) => {
      item.selectable = this.selection === "multiple";
      ["expand", "collapse"].filter((status) => !!this.querySelector(`[slot="${status}-icon"]`)).forEach((status) => {
        const existingIcon = item.querySelector(`[slot="${status}-icon"]`);
        if (existingIcon === null) {
          item.append(this.getExpandButtonIcon(status));
        } else if (existingIcon.hasAttribute("data-default")) {
          existingIcon.replaceWith(this.getExpandButtonIcon(status));
        } else {
        }
      });
    };
    this.handleTreeChanged = (mutations) => {
      for (const mutation of mutations) {
        const addedNodes = [...mutation.addedNodes].filter(SlTreeItem.isTreeItem);
        const removedNodes = [...mutation.removedNodes].filter(SlTreeItem.isTreeItem);
        addedNodes.forEach(this.initTreeItem);
        if (this.lastFocusedItem && removedNodes.includes(this.lastFocusedItem)) {
          this.lastFocusedItem = null;
        }
      }
    };
    this.handleFocusOut = (event) => {
      const relatedTarget = event.relatedTarget;
      if (!relatedTarget || !this.contains(relatedTarget)) {
        this.tabIndex = 0;
      }
    };
    this.handleFocusIn = (event) => {
      const target = event.target;
      if (event.target === this) {
        this.focusItem(this.lastFocusedItem || this.getAllTreeItems()[0]);
      }
      if (SlTreeItem.isTreeItem(target) && !target.disabled) {
        if (this.lastFocusedItem) {
          this.lastFocusedItem.tabIndex = -1;
        }
        this.lastFocusedItem = target;
        this.tabIndex = -1;
        target.tabIndex = 0;
      }
    };
    this.addEventListener("focusin", this.handleFocusIn);
    this.addEventListener("focusout", this.handleFocusOut);
    this.addEventListener("sl-lazy-change", this.handleSlotChange);
  }
  async connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "tree");
    this.setAttribute("tabindex", "0");
    await this.updateComplete;
    this.mutationObserver = new MutationObserver(this.handleTreeChanged);
    this.mutationObserver.observe(this, { childList: true, subtree: true });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.mutationObserver.disconnect();
  }
  // Generates a clone of the expand icon element to use for each tree item
  getExpandButtonIcon(status) {
    const slot = status === "expand" ? this.expandedIconSlot : this.collapsedIconSlot;
    const icon = slot.assignedElements({ flatten: true })[0];
    if (icon) {
      const clone = icon.cloneNode(true);
      [clone, ...clone.querySelectorAll("[id]")].forEach((el) => el.removeAttribute("id"));
      clone.setAttribute("data-default", "");
      clone.slot = `${status}-icon`;
      return clone;
    }
    return null;
  }
  selectItem(selectedItem) {
    const previousSelection = [...this.selectedItems];
    if (this.selection === "multiple") {
      selectedItem.selected = !selectedItem.selected;
      if (selectedItem.lazy) {
        selectedItem.expanded = true;
      }
      syncCheckboxes(selectedItem);
    } else if (this.selection === "single" || selectedItem.isLeaf) {
      const items = this.getAllTreeItems();
      for (const item of items) {
        item.selected = item === selectedItem;
      }
    } else if (this.selection === "leaf") {
      selectedItem.expanded = !selectedItem.expanded;
    }
    const nextSelection = this.selectedItems;
    if (previousSelection.length !== nextSelection.length || nextSelection.some((item) => !previousSelection.includes(item))) {
      Promise.all(nextSelection.map((el) => el.updateComplete)).then(() => {
        this.emit("sl-selection-change", { detail: { selection: nextSelection } });
      });
    }
  }
  getAllTreeItems() {
    return [...this.querySelectorAll("sl-tree-item")];
  }
  focusItem(item) {
    item == null ? void 0 : item.focus();
  }
  handleKeyDown(event) {
    if (!["ArrowDown", "ArrowUp", "ArrowRight", "ArrowLeft", "Home", "End", "Enter", " "].includes(event.key)) {
      return;
    }
    if (event.composedPath().some((el) => {
      var _a;
      return ["input", "textarea"].includes((_a = el == null ? void 0 : el.tagName) == null ? void 0 : _a.toLowerCase());
    })) {
      return;
    }
    const items = this.getFocusableItems();
    const isLtr = this.localize.dir() === "ltr";
    const isRtl = this.localize.dir() === "rtl";
    if (items.length > 0) {
      event.preventDefault();
      const activeItemIndex = items.findIndex((item) => item.matches(":focus"));
      const activeItem = items[activeItemIndex];
      const focusItemAt = (index) => {
        const item = items[clamp$1(index, 0, items.length - 1)];
        this.focusItem(item);
      };
      const toggleExpand = (expanded) => {
        activeItem.expanded = expanded;
      };
      if (event.key === "ArrowDown") {
        focusItemAt(activeItemIndex + 1);
      } else if (event.key === "ArrowUp") {
        focusItemAt(activeItemIndex - 1);
      } else if (isLtr && event.key === "ArrowRight" || isRtl && event.key === "ArrowLeft") {
        if (!activeItem || activeItem.disabled || activeItem.expanded || activeItem.isLeaf && !activeItem.lazy) {
          focusItemAt(activeItemIndex + 1);
        } else {
          toggleExpand(true);
        }
      } else if (isLtr && event.key === "ArrowLeft" || isRtl && event.key === "ArrowRight") {
        if (!activeItem || activeItem.disabled || activeItem.isLeaf || !activeItem.expanded) {
          focusItemAt(activeItemIndex - 1);
        } else {
          toggleExpand(false);
        }
      } else if (event.key === "Home") {
        focusItemAt(0);
      } else if (event.key === "End") {
        focusItemAt(items.length - 1);
      } else if (event.key === "Enter" || event.key === " ") {
        if (!activeItem.disabled) {
          this.selectItem(activeItem);
        }
      }
    }
  }
  handleClick(event) {
    const target = event.target;
    const treeItem = target.closest("sl-tree-item");
    const isExpandButton = event.composedPath().some((el) => {
      var _a;
      return (_a = el == null ? void 0 : el.classList) == null ? void 0 : _a.contains("tree-item__expand-button");
    });
    if (!treeItem || treeItem.disabled || target !== this.clickTarget) {
      return;
    }
    if (isExpandButton) {
      treeItem.expanded = !treeItem.expanded;
    } else {
      this.selectItem(treeItem);
    }
  }
  handleMouseDown(event) {
    this.clickTarget = event.target;
  }
  handleSlotChange() {
    const items = this.getAllTreeItems();
    items.forEach(this.initTreeItem);
  }
  async handleSelectionChange() {
    const isSelectionMultiple = this.selection === "multiple";
    const items = this.getAllTreeItems();
    this.setAttribute("aria-multiselectable", isSelectionMultiple ? "true" : "false");
    for (const item of items) {
      item.selectable = isSelectionMultiple;
    }
    if (isSelectionMultiple) {
      await this.updateComplete;
      [...this.querySelectorAll(":scope > sl-tree-item")].forEach(
        (treeItem) => syncCheckboxes(treeItem, true)
      );
    }
  }
  /** @internal Returns the list of tree items that are selected in the tree. */
  get selectedItems() {
    const items = this.getAllTreeItems();
    const isSelected = (item) => item.selected;
    return items.filter(isSelected);
  }
  /** @internal Gets focusable tree items in the tree. */
  getFocusableItems() {
    const items = this.getAllTreeItems();
    const collapsedItems = /* @__PURE__ */ new Set();
    return items.filter((item) => {
      var _a;
      if (item.disabled)
        return false;
      const parent = (_a = item.parentElement) == null ? void 0 : _a.closest("[role=treeitem]");
      if (parent && (!parent.expanded || parent.loading || collapsedItems.has(parent))) {
        collapsedItems.add(item);
      }
      return !collapsedItems.has(item);
    });
  }
  render() {
    return x$1`
      <div
        part="base"
        class="tree"
        @click=${this.handleClick}
        @keydown=${this.handleKeyDown}
        @mousedown=${this.handleMouseDown}
      >
        <slot @slotchange=${this.handleSlotChange}></slot>
        <span hidden aria-hidden="true"><slot name="expand-icon"></slot></span>
        <span hidden aria-hidden="true"><slot name="collapse-icon"></slot></span>
      </div>
    `;
  }
};
SlTree.styles = tree_styles_default;
__decorateClass([
  i$7("slot:not([name])")
], SlTree.prototype, "defaultSlot", 2);
__decorateClass([
  i$7("slot[name=expand-icon]")
], SlTree.prototype, "expandedIconSlot", 2);
__decorateClass([
  i$7("slot[name=collapse-icon]")
], SlTree.prototype, "collapsedIconSlot", 2);
__decorateClass([
  e$c()
], SlTree.prototype, "selection", 2);
__decorateClass([
  watch("selection")
], SlTree.prototype, "handleSelectionChange", 1);

// src/components/tree/tree.ts
var tree_default = SlTree;
SlTree.define("sl-tree");

var visually_hidden_styles_default = i$b`
  ${component_styles_default}

  :host(:not(:focus-within)) {
    position: absolute !important;
    width: 1px !important;
    height: 1px !important;
    clip: rect(0 0 0 0) !important;
    clip-path: inset(50%) !important;
    border: none !important;
    overflow: hidden !important;
    white-space: nowrap !important;
    padding: 0 !important;
  }
`;

var SlVisuallyHidden = class extends ShoelaceElement {
  render() {
    return x$1` <slot></slot> `;
  }
};
SlVisuallyHidden.styles = visually_hidden_styles_default;

// src/components/visually-hidden/visually-hidden.ts
var visually_hidden_default = SlVisuallyHidden;
SlVisuallyHidden.define("sl-visually-hidden");

var tooltip_styles_default = i$b`
  ${component_styles_default}

  :host {
    --max-width: 20rem;
    --hide-delay: 0ms;
    --show-delay: 150ms;

    display: contents;
  }

  .tooltip {
    --arrow-size: var(--sl-tooltip-arrow-size);
    --arrow-color: var(--sl-tooltip-background-color);
  }

  .tooltip::part(popup) {
    pointer-events: none;
    z-index: var(--sl-z-index-tooltip);
  }

  .tooltip[placement^='top']::part(popup) {
    transform-origin: bottom;
  }

  .tooltip[placement^='bottom']::part(popup) {
    transform-origin: top;
  }

  .tooltip[placement^='left']::part(popup) {
    transform-origin: right;
  }

  .tooltip[placement^='right']::part(popup) {
    transform-origin: left;
  }

  .tooltip__body {
    display: block;
    width: max-content;
    max-width: var(--max-width);
    border-radius: var(--sl-tooltip-border-radius);
    background-color: var(--sl-tooltip-background-color);
    font-family: var(--sl-tooltip-font-family);
    font-size: var(--sl-tooltip-font-size);
    font-weight: var(--sl-tooltip-font-weight);
    line-height: var(--sl-tooltip-line-height);
    color: var(--sl-tooltip-color);
    padding: var(--sl-tooltip-padding);
    pointer-events: none;
    user-select: none;
  }
`;

var popup_styles_default = i$b`
  ${component_styles_default}

  :host {
    --arrow-color: var(--sl-color-neutral-1000);
    --arrow-size: 6px;

    /*
     * These properties are computed to account for the arrow's dimensions after being rotated 45º. The constant
     * 0.7071 is derived from sin(45), which is the diagonal size of the arrow's container after rotating.
     */
    --arrow-size-diagonal: calc(var(--arrow-size) * 0.7071);
    --arrow-padding-offset: calc(var(--arrow-size-diagonal) - var(--arrow-size));

    display: contents;
  }

  .popup {
    position: absolute;
    isolation: isolate;
    max-width: var(--auto-size-available-width, none);
    max-height: var(--auto-size-available-height, none);
  }

  .popup--fixed {
    position: fixed;
  }

  .popup:not(.popup--active) {
    display: none;
  }

  .popup__arrow {
    position: absolute;
    width: calc(var(--arrow-size-diagonal) * 2);
    height: calc(var(--arrow-size-diagonal) * 2);
    rotate: 45deg;
    background: var(--arrow-color);
    z-index: -1;
  }
`;

const sides = ['top', 'right', 'bottom', 'left'];
const alignments = ['start', 'end'];
const placements = /*#__PURE__*/sides.reduce((acc, side) => acc.concat(side, side + "-" + alignments[0], side + "-" + alignments[1]), []);
const min$1 = Math.min;
const max = Math.max;
const round = Math.round;
const floor = Math.floor;
const createCoords = v => ({
  x: v,
  y: v
});
const oppositeSideMap = {
  left: 'right',
  right: 'left',
  bottom: 'top',
  top: 'bottom'
};
const oppositeAlignmentMap = {
  start: 'end',
  end: 'start'
};
function clamp(start, value, end) {
  return max(start, min$1(value, end));
}
function evaluate(value, param) {
  return typeof value === 'function' ? value(param) : value;
}
function getSide(placement) {
  return placement.split('-')[0];
}
function getAlignment(placement) {
  return placement.split('-')[1];
}
function getOppositeAxis(axis) {
  return axis === 'x' ? 'y' : 'x';
}
function getAxisLength(axis) {
  return axis === 'y' ? 'height' : 'width';
}
function getSideAxis(placement) {
  return ['top', 'bottom'].includes(getSide(placement)) ? 'y' : 'x';
}
function getAlignmentAxis(placement) {
  return getOppositeAxis(getSideAxis(placement));
}
function getAlignmentSides(placement, rects, rtl) {
  if (rtl === void 0) {
    rtl = false;
  }
  const alignment = getAlignment(placement);
  const alignmentAxis = getAlignmentAxis(placement);
  const length = getAxisLength(alignmentAxis);
  let mainAlignmentSide = alignmentAxis === 'x' ? alignment === (rtl ? 'end' : 'start') ? 'right' : 'left' : alignment === 'start' ? 'bottom' : 'top';
  if (rects.reference[length] > rects.floating[length]) {
    mainAlignmentSide = getOppositePlacement(mainAlignmentSide);
  }
  return [mainAlignmentSide, getOppositePlacement(mainAlignmentSide)];
}
function getExpandedPlacements(placement) {
  const oppositePlacement = getOppositePlacement(placement);
  return [getOppositeAlignmentPlacement(placement), oppositePlacement, getOppositeAlignmentPlacement(oppositePlacement)];
}
function getOppositeAlignmentPlacement(placement) {
  return placement.replace(/start|end/g, alignment => oppositeAlignmentMap[alignment]);
}
function getSideList(side, isStart, rtl) {
  const lr = ['left', 'right'];
  const rl = ['right', 'left'];
  const tb = ['top', 'bottom'];
  const bt = ['bottom', 'top'];
  switch (side) {
    case 'top':
    case 'bottom':
      if (rtl) return isStart ? rl : lr;
      return isStart ? lr : rl;
    case 'left':
    case 'right':
      return isStart ? tb : bt;
    default:
      return [];
  }
}
function getOppositeAxisPlacements(placement, flipAlignment, direction, rtl) {
  const alignment = getAlignment(placement);
  let list = getSideList(getSide(placement), direction === 'start', rtl);
  if (alignment) {
    list = list.map(side => side + "-" + alignment);
    if (flipAlignment) {
      list = list.concat(list.map(getOppositeAlignmentPlacement));
    }
  }
  return list;
}
function getOppositePlacement(placement) {
  return placement.replace(/left|right|bottom|top/g, side => oppositeSideMap[side]);
}
function expandPaddingObject(padding) {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    ...padding
  };
}
function getPaddingObject(padding) {
  return typeof padding !== 'number' ? expandPaddingObject(padding) : {
    top: padding,
    right: padding,
    bottom: padding,
    left: padding
  };
}
function rectToClientRect(rect) {
  return {
    ...rect,
    top: rect.y,
    left: rect.x,
    right: rect.x + rect.width,
    bottom: rect.y + rect.height
  };
}

function computeCoordsFromPlacement(_ref, placement, rtl) {
  let {
    reference,
    floating
  } = _ref;
  const sideAxis = getSideAxis(placement);
  const alignmentAxis = getAlignmentAxis(placement);
  const alignLength = getAxisLength(alignmentAxis);
  const side = getSide(placement);
  const isVertical = sideAxis === 'y';
  const commonX = reference.x + reference.width / 2 - floating.width / 2;
  const commonY = reference.y + reference.height / 2 - floating.height / 2;
  const commonAlign = reference[alignLength] / 2 - floating[alignLength] / 2;
  let coords;
  switch (side) {
    case 'top':
      coords = {
        x: commonX,
        y: reference.y - floating.height
      };
      break;
    case 'bottom':
      coords = {
        x: commonX,
        y: reference.y + reference.height
      };
      break;
    case 'right':
      coords = {
        x: reference.x + reference.width,
        y: commonY
      };
      break;
    case 'left':
      coords = {
        x: reference.x - floating.width,
        y: commonY
      };
      break;
    default:
      coords = {
        x: reference.x,
        y: reference.y
      };
  }
  switch (getAlignment(placement)) {
    case 'start':
      coords[alignmentAxis] -= commonAlign * (rtl && isVertical ? -1 : 1);
      break;
    case 'end':
      coords[alignmentAxis] += commonAlign * (rtl && isVertical ? -1 : 1);
      break;
  }
  return coords;
}

/**
 * Computes the `x` and `y` coordinates that will place the floating element
 * next to a reference element when it is given a certain positioning strategy.
 *
 * This export does not have any `platform` interface logic. You will need to
 * write one for the platform you are using Floating UI with.
 */
const computePosition$1 = async (reference, floating, config) => {
  const {
    placement = 'bottom',
    strategy = 'absolute',
    middleware = [],
    platform
  } = config;
  const validMiddleware = middleware.filter(Boolean);
  const rtl = await (platform.isRTL == null ? void 0 : platform.isRTL(floating));
  let rects = await platform.getElementRects({
    reference,
    floating,
    strategy
  });
  let {
    x,
    y
  } = computeCoordsFromPlacement(rects, placement, rtl);
  let statefulPlacement = placement;
  let middlewareData = {};
  let resetCount = 0;
  for (let i = 0; i < validMiddleware.length; i++) {
    const {
      name,
      fn
    } = validMiddleware[i];
    const {
      x: nextX,
      y: nextY,
      data,
      reset
    } = await fn({
      x,
      y,
      initialPlacement: placement,
      placement: statefulPlacement,
      strategy,
      middlewareData,
      rects,
      platform,
      elements: {
        reference,
        floating
      }
    });
    x = nextX != null ? nextX : x;
    y = nextY != null ? nextY : y;
    middlewareData = {
      ...middlewareData,
      [name]: {
        ...middlewareData[name],
        ...data
      }
    };
    if (reset && resetCount <= 50) {
      resetCount++;
      if (typeof reset === 'object') {
        if (reset.placement) {
          statefulPlacement = reset.placement;
        }
        if (reset.rects) {
          rects = reset.rects === true ? await platform.getElementRects({
            reference,
            floating,
            strategy
          }) : reset.rects;
        }
        ({
          x,
          y
        } = computeCoordsFromPlacement(rects, statefulPlacement, rtl));
      }
      i = -1;
      continue;
    }
  }
  return {
    x,
    y,
    placement: statefulPlacement,
    strategy,
    middlewareData
  };
};

/**
 * Resolves with an object of overflow side offsets that determine how much the
 * element is overflowing a given clipping boundary on each side.
 * - positive = overflowing the boundary by that number of pixels
 * - negative = how many pixels left before it will overflow
 * - 0 = lies flush with the boundary
 * @see https://floating-ui.com/docs/detectOverflow
 */
async function detectOverflow(state, options) {
  var _await$platform$isEle;
  if (options === void 0) {
    options = {};
  }
  const {
    x,
    y,
    platform,
    rects,
    elements,
    strategy
  } = state;
  const {
    boundary = 'clippingAncestors',
    rootBoundary = 'viewport',
    elementContext = 'floating',
    altBoundary = false,
    padding = 0
  } = evaluate(options, state);
  const paddingObject = getPaddingObject(padding);
  const altContext = elementContext === 'floating' ? 'reference' : 'floating';
  const element = elements[altBoundary ? altContext : elementContext];
  const clippingClientRect = rectToClientRect(await platform.getClippingRect({
    element: ((_await$platform$isEle = await (platform.isElement == null ? void 0 : platform.isElement(element))) != null ? _await$platform$isEle : true) ? element : element.contextElement || (await (platform.getDocumentElement == null ? void 0 : platform.getDocumentElement(elements.floating))),
    boundary,
    rootBoundary,
    strategy
  }));
  const rect = elementContext === 'floating' ? {
    ...rects.floating,
    x,
    y
  } : rects.reference;
  const offsetParent = await (platform.getOffsetParent == null ? void 0 : platform.getOffsetParent(elements.floating));
  const offsetScale = (await (platform.isElement == null ? void 0 : platform.isElement(offsetParent))) ? (await (platform.getScale == null ? void 0 : platform.getScale(offsetParent))) || {
    x: 1,
    y: 1
  } : {
    x: 1,
    y: 1
  };
  const elementClientRect = rectToClientRect(platform.convertOffsetParentRelativeRectToViewportRelativeRect ? await platform.convertOffsetParentRelativeRectToViewportRelativeRect({
    rect,
    offsetParent,
    strategy
  }) : rect);
  return {
    top: (clippingClientRect.top - elementClientRect.top + paddingObject.top) / offsetScale.y,
    bottom: (elementClientRect.bottom - clippingClientRect.bottom + paddingObject.bottom) / offsetScale.y,
    left: (clippingClientRect.left - elementClientRect.left + paddingObject.left) / offsetScale.x,
    right: (elementClientRect.right - clippingClientRect.right + paddingObject.right) / offsetScale.x
  };
}

/**
 * Provides data to position an inner element of the floating element so that it
 * appears centered to the reference element.
 * @see https://floating-ui.com/docs/arrow
 */
const arrow = options => ({
  name: 'arrow',
  options,
  async fn(state) {
    const {
      x,
      y,
      placement,
      rects,
      platform,
      elements
    } = state;
    // Since `element` is required, we don't Partial<> the type.
    const {
      element,
      padding = 0
    } = evaluate(options, state) || {};
    if (element == null) {
      return {};
    }
    const paddingObject = getPaddingObject(padding);
    const coords = {
      x,
      y
    };
    const axis = getAlignmentAxis(placement);
    const length = getAxisLength(axis);
    const arrowDimensions = await platform.getDimensions(element);
    const isYAxis = axis === 'y';
    const minProp = isYAxis ? 'top' : 'left';
    const maxProp = isYAxis ? 'bottom' : 'right';
    const clientProp = isYAxis ? 'clientHeight' : 'clientWidth';
    const endDiff = rects.reference[length] + rects.reference[axis] - coords[axis] - rects.floating[length];
    const startDiff = coords[axis] - rects.reference[axis];
    const arrowOffsetParent = await (platform.getOffsetParent == null ? void 0 : platform.getOffsetParent(element));
    let clientSize = arrowOffsetParent ? arrowOffsetParent[clientProp] : 0;

    // DOM platform can return `window` as the `offsetParent`.
    if (!clientSize || !(await (platform.isElement == null ? void 0 : platform.isElement(arrowOffsetParent)))) {
      clientSize = elements.floating[clientProp] || rects.floating[length];
    }
    const centerToReference = endDiff / 2 - startDiff / 2;

    // If the padding is large enough that it causes the arrow to no longer be
    // centered, modify the padding so that it is centered.
    const largestPossiblePadding = clientSize / 2 - arrowDimensions[length] / 2 - 1;
    const minPadding = min$1(paddingObject[minProp], largestPossiblePadding);
    const maxPadding = min$1(paddingObject[maxProp], largestPossiblePadding);

    // Make sure the arrow doesn't overflow the floating element if the center
    // point is outside the floating element's bounds.
    const min$1$1 = minPadding;
    const max = clientSize - arrowDimensions[length] - maxPadding;
    const center = clientSize / 2 - arrowDimensions[length] / 2 + centerToReference;
    const offset = clamp(min$1$1, center, max);

    // If the reference is small enough that the arrow's padding causes it to
    // to point to nothing for an aligned placement, adjust the offset of the
    // floating element itself. This stops `shift()` from taking action, but can
    // be worked around by calling it again after the `arrow()` if desired.
    const shouldAddOffset = getAlignment(placement) != null && center != offset && rects.reference[length] / 2 - (center < min$1$1 ? minPadding : maxPadding) - arrowDimensions[length] / 2 < 0;
    const alignmentOffset = shouldAddOffset ? center < min$1$1 ? min$1$1 - center : max - center : 0;
    return {
      [axis]: coords[axis] - alignmentOffset,
      data: {
        [axis]: offset,
        centerOffset: center - offset + alignmentOffset
      }
    };
  }
});

function getPlacementList(alignment, autoAlignment, allowedPlacements) {
  const allowedPlacementsSortedByAlignment = alignment ? [...allowedPlacements.filter(placement => getAlignment(placement) === alignment), ...allowedPlacements.filter(placement => getAlignment(placement) !== alignment)] : allowedPlacements.filter(placement => getSide(placement) === placement);
  return allowedPlacementsSortedByAlignment.filter(placement => {
    if (alignment) {
      return getAlignment(placement) === alignment || (autoAlignment ? getOppositeAlignmentPlacement(placement) !== placement : false);
    }
    return true;
  });
}
/**
 * Optimizes the visibility of the floating element by choosing the placement
 * that has the most space available automatically, without needing to specify a
 * preferred placement. Alternative to `flip`.
 * @see https://floating-ui.com/docs/autoPlacement
 */
const autoPlacement = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    name: 'autoPlacement',
    options,
    async fn(state) {
      var _middlewareData$autoP, _middlewareData$autoP2, _placementsThatFitOnE;
      const {
        rects,
        middlewareData,
        placement,
        platform,
        elements
      } = state;
      const {
        crossAxis = false,
        alignment,
        allowedPlacements = placements,
        autoAlignment = true,
        ...detectOverflowOptions
      } = evaluate(options, state);
      const placements$1 = alignment !== undefined || allowedPlacements === placements ? getPlacementList(alignment || null, autoAlignment, allowedPlacements) : allowedPlacements;
      const overflow = await detectOverflow(state, detectOverflowOptions);
      const currentIndex = ((_middlewareData$autoP = middlewareData.autoPlacement) == null ? void 0 : _middlewareData$autoP.index) || 0;
      const currentPlacement = placements$1[currentIndex];
      if (currentPlacement == null) {
        return {};
      }
      const alignmentSides = getAlignmentSides(currentPlacement, rects, await (platform.isRTL == null ? void 0 : platform.isRTL(elements.floating)));

      // Make `computeCoords` start from the right place.
      if (placement !== currentPlacement) {
        return {
          reset: {
            placement: placements$1[0]
          }
        };
      }
      const currentOverflows = [overflow[getSide(currentPlacement)], overflow[alignmentSides[0]], overflow[alignmentSides[1]]];
      const allOverflows = [...(((_middlewareData$autoP2 = middlewareData.autoPlacement) == null ? void 0 : _middlewareData$autoP2.overflows) || []), {
        placement: currentPlacement,
        overflows: currentOverflows
      }];
      const nextPlacement = placements$1[currentIndex + 1];

      // There are more placements to check.
      if (nextPlacement) {
        return {
          data: {
            index: currentIndex + 1,
            overflows: allOverflows
          },
          reset: {
            placement: nextPlacement
          }
        };
      }
      const placementsSortedByMostSpace = allOverflows.map(d => {
        const alignment = getAlignment(d.placement);
        return [d.placement, alignment && crossAxis ?
        // Check along the mainAxis and main crossAxis side.
        d.overflows.slice(0, 2).reduce((acc, v) => acc + v, 0) :
        // Check only the mainAxis.
        d.overflows[0], d.overflows];
      }).sort((a, b) => a[1] - b[1]);
      const placementsThatFitOnEachSide = placementsSortedByMostSpace.filter(d => d[2].slice(0,
      // Aligned placements should not check their opposite crossAxis
      // side.
      getAlignment(d[0]) ? 2 : 3).every(v => v <= 0));
      const resetPlacement = ((_placementsThatFitOnE = placementsThatFitOnEachSide[0]) == null ? void 0 : _placementsThatFitOnE[0]) || placementsSortedByMostSpace[0][0];
      if (resetPlacement !== placement) {
        return {
          data: {
            index: currentIndex + 1,
            overflows: allOverflows
          },
          reset: {
            placement: resetPlacement
          }
        };
      }
      return {};
    }
  };
};

/**
 * Optimizes the visibility of the floating element by flipping the `placement`
 * in order to keep it in view when the preferred placement(s) will overflow the
 * clipping boundary. Alternative to `autoPlacement`.
 * @see https://floating-ui.com/docs/flip
 */
const flip$1 = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    name: 'flip',
    options,
    async fn(state) {
      var _middlewareData$flip;
      const {
        placement,
        middlewareData,
        rects,
        initialPlacement,
        platform,
        elements
      } = state;
      const {
        mainAxis: checkMainAxis = true,
        crossAxis: checkCrossAxis = true,
        fallbackPlacements: specifiedFallbackPlacements,
        fallbackStrategy = 'bestFit',
        fallbackAxisSideDirection = 'none',
        flipAlignment = true,
        ...detectOverflowOptions
      } = evaluate(options, state);
      const side = getSide(placement);
      const isBasePlacement = getSide(initialPlacement) === initialPlacement;
      const rtl = await (platform.isRTL == null ? void 0 : platform.isRTL(elements.floating));
      const fallbackPlacements = specifiedFallbackPlacements || (isBasePlacement || !flipAlignment ? [getOppositePlacement(initialPlacement)] : getExpandedPlacements(initialPlacement));
      if (!specifiedFallbackPlacements && fallbackAxisSideDirection !== 'none') {
        fallbackPlacements.push(...getOppositeAxisPlacements(initialPlacement, flipAlignment, fallbackAxisSideDirection, rtl));
      }
      const placements = [initialPlacement, ...fallbackPlacements];
      const overflow = await detectOverflow(state, detectOverflowOptions);
      const overflows = [];
      let overflowsData = ((_middlewareData$flip = middlewareData.flip) == null ? void 0 : _middlewareData$flip.overflows) || [];
      if (checkMainAxis) {
        overflows.push(overflow[side]);
      }
      if (checkCrossAxis) {
        const sides = getAlignmentSides(placement, rects, rtl);
        overflows.push(overflow[sides[0]], overflow[sides[1]]);
      }
      overflowsData = [...overflowsData, {
        placement,
        overflows
      }];

      // One or more sides is overflowing.
      if (!overflows.every(side => side <= 0)) {
        var _middlewareData$flip2, _overflowsData$filter;
        const nextIndex = (((_middlewareData$flip2 = middlewareData.flip) == null ? void 0 : _middlewareData$flip2.index) || 0) + 1;
        const nextPlacement = placements[nextIndex];
        if (nextPlacement) {
          // Try next placement and re-run the lifecycle.
          return {
            data: {
              index: nextIndex,
              overflows: overflowsData
            },
            reset: {
              placement: nextPlacement
            }
          };
        }

        // First, find the candidates that fit on the mainAxis side of overflow,
        // then find the placement that fits the best on the main crossAxis side.
        let resetPlacement = (_overflowsData$filter = overflowsData.filter(d => d.overflows[0] <= 0).sort((a, b) => a.overflows[1] - b.overflows[1])[0]) == null ? void 0 : _overflowsData$filter.placement;

        // Otherwise fallback.
        if (!resetPlacement) {
          switch (fallbackStrategy) {
            case 'bestFit':
              {
                var _overflowsData$map$so;
                const placement = (_overflowsData$map$so = overflowsData.map(d => [d.placement, d.overflows.filter(overflow => overflow > 0).reduce((acc, overflow) => acc + overflow, 0)]).sort((a, b) => a[1] - b[1])[0]) == null ? void 0 : _overflowsData$map$so[0];
                if (placement) {
                  resetPlacement = placement;
                }
                break;
              }
            case 'initialPlacement':
              resetPlacement = initialPlacement;
              break;
          }
        }
        if (placement !== resetPlacement) {
          return {
            reset: {
              placement: resetPlacement
            }
          };
        }
      }
      return {};
    }
  };
};

function getSideOffsets(overflow, rect) {
  return {
    top: overflow.top - rect.height,
    right: overflow.right - rect.width,
    bottom: overflow.bottom - rect.height,
    left: overflow.left - rect.width
  };
}
function isAnySideFullyClipped(overflow) {
  return sides.some(side => overflow[side] >= 0);
}
/**
 * Provides data to hide the floating element in applicable situations, such as
 * when it is not in the same clipping context as the reference element.
 * @see https://floating-ui.com/docs/hide
 */
const hide = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    name: 'hide',
    options,
    async fn(state) {
      const {
        rects
      } = state;
      const {
        strategy = 'referenceHidden',
        ...detectOverflowOptions
      } = evaluate(options, state);
      switch (strategy) {
        case 'referenceHidden':
          {
            const overflow = await detectOverflow(state, {
              ...detectOverflowOptions,
              elementContext: 'reference'
            });
            const offsets = getSideOffsets(overflow, rects.reference);
            return {
              data: {
                referenceHiddenOffsets: offsets,
                referenceHidden: isAnySideFullyClipped(offsets)
              }
            };
          }
        case 'escaped':
          {
            const overflow = await detectOverflow(state, {
              ...detectOverflowOptions,
              altBoundary: true
            });
            const offsets = getSideOffsets(overflow, rects.floating);
            return {
              data: {
                escapedOffsets: offsets,
                escaped: isAnySideFullyClipped(offsets)
              }
            };
          }
        default:
          {
            return {};
          }
      }
    }
  };
};

function getBoundingRect(rects) {
  const minX = min$1(...rects.map(rect => rect.left));
  const minY = min$1(...rects.map(rect => rect.top));
  const maxX = max(...rects.map(rect => rect.right));
  const maxY = max(...rects.map(rect => rect.bottom));
  return {
    x: minX,
    y: minY,
    width: maxX - minX,
    height: maxY - minY
  };
}
function getRectsByLine(rects) {
  const sortedRects = rects.slice().sort((a, b) => a.y - b.y);
  const groups = [];
  let prevRect = null;
  for (let i = 0; i < sortedRects.length; i++) {
    const rect = sortedRects[i];
    if (!prevRect || rect.y - prevRect.y > prevRect.height / 2) {
      groups.push([rect]);
    } else {
      groups[groups.length - 1].push(rect);
    }
    prevRect = rect;
  }
  return groups.map(rect => rectToClientRect(getBoundingRect(rect)));
}
/**
 * Provides improved positioning for inline reference elements that can span
 * over multiple lines, such as hyperlinks or range selections.
 * @see https://floating-ui.com/docs/inline
 */
const inline = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    name: 'inline',
    options,
    async fn(state) {
      const {
        placement,
        elements,
        rects,
        platform,
        strategy
      } = state;
      // A MouseEvent's client{X,Y} coords can be up to 2 pixels off a
      // ClientRect's bounds, despite the event listener being triggered. A
      // padding of 2 seems to handle this issue.
      const {
        padding = 2,
        x,
        y
      } = evaluate(options, state);
      const nativeClientRects = Array.from((await (platform.getClientRects == null ? void 0 : platform.getClientRects(elements.reference))) || []);
      const clientRects = getRectsByLine(nativeClientRects);
      const fallback = rectToClientRect(getBoundingRect(nativeClientRects));
      const paddingObject = getPaddingObject(padding);
      function getBoundingClientRect() {
        // There are two rects and they are disjoined.
        if (clientRects.length === 2 && clientRects[0].left > clientRects[1].right && x != null && y != null) {
          // Find the first rect in which the point is fully inside.
          return clientRects.find(rect => x > rect.left - paddingObject.left && x < rect.right + paddingObject.right && y > rect.top - paddingObject.top && y < rect.bottom + paddingObject.bottom) || fallback;
        }

        // There are 2 or more connected rects.
        if (clientRects.length >= 2) {
          if (getSideAxis(placement) === 'y') {
            const firstRect = clientRects[0];
            const lastRect = clientRects[clientRects.length - 1];
            const isTop = getSide(placement) === 'top';
            const top = firstRect.top;
            const bottom = lastRect.bottom;
            const left = isTop ? firstRect.left : lastRect.left;
            const right = isTop ? firstRect.right : lastRect.right;
            const width = right - left;
            const height = bottom - top;
            return {
              top,
              bottom,
              left,
              right,
              width,
              height,
              x: left,
              y: top
            };
          }
          const isLeftSide = getSide(placement) === 'left';
          const maxRight = max(...clientRects.map(rect => rect.right));
          const minLeft = min$1(...clientRects.map(rect => rect.left));
          const measureRects = clientRects.filter(rect => isLeftSide ? rect.left === minLeft : rect.right === maxRight);
          const top = measureRects[0].top;
          const bottom = measureRects[measureRects.length - 1].bottom;
          const left = minLeft;
          const right = maxRight;
          const width = right - left;
          const height = bottom - top;
          return {
            top,
            bottom,
            left,
            right,
            width,
            height,
            x: left,
            y: top
          };
        }
        return fallback;
      }
      const resetRects = await platform.getElementRects({
        reference: {
          getBoundingClientRect
        },
        floating: elements.floating,
        strategy
      });
      if (rects.reference.x !== resetRects.reference.x || rects.reference.y !== resetRects.reference.y || rects.reference.width !== resetRects.reference.width || rects.reference.height !== resetRects.reference.height) {
        return {
          reset: {
            rects: resetRects
          }
        };
      }
      return {};
    }
  };
};

// For type backwards-compatibility, the `OffsetOptions` type was also
// Derivable.
async function convertValueToCoords(state, options) {
  const {
    placement,
    platform,
    elements
  } = state;
  const rtl = await (platform.isRTL == null ? void 0 : platform.isRTL(elements.floating));
  const side = getSide(placement);
  const alignment = getAlignment(placement);
  const isVertical = getSideAxis(placement) === 'y';
  const mainAxisMulti = ['left', 'top'].includes(side) ? -1 : 1;
  const crossAxisMulti = rtl && isVertical ? -1 : 1;
  const rawValue = evaluate(options, state);

  // eslint-disable-next-line prefer-const
  let {
    mainAxis,
    crossAxis,
    alignmentAxis
  } = typeof rawValue === 'number' ? {
    mainAxis: rawValue,
    crossAxis: 0,
    alignmentAxis: null
  } : {
    mainAxis: 0,
    crossAxis: 0,
    alignmentAxis: null,
    ...rawValue
  };
  if (alignment && typeof alignmentAxis === 'number') {
    crossAxis = alignment === 'end' ? alignmentAxis * -1 : alignmentAxis;
  }
  return isVertical ? {
    x: crossAxis * crossAxisMulti,
    y: mainAxis * mainAxisMulti
  } : {
    x: mainAxis * mainAxisMulti,
    y: crossAxis * crossAxisMulti
  };
}

/**
 * Modifies the placement by translating the floating element along the
 * specified axes.
 * A number (shorthand for `mainAxis` or distance), or an axes configuration
 * object may be passed.
 * @see https://floating-ui.com/docs/offset
 */
const offset$1 = function (options) {
  if (options === void 0) {
    options = 0;
  }
  return {
    name: 'offset',
    options,
    async fn(state) {
      const {
        x,
        y
      } = state;
      const diffCoords = await convertValueToCoords(state, options);
      return {
        x: x + diffCoords.x,
        y: y + diffCoords.y,
        data: diffCoords
      };
    }
  };
};

/**
 * Optimizes the visibility of the floating element by shifting it in order to
 * keep it in view when it will overflow the clipping boundary.
 * @see https://floating-ui.com/docs/shift
 */
const shift$1 = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    name: 'shift',
    options,
    async fn(state) {
      const {
        x,
        y,
        placement
      } = state;
      const {
        mainAxis: checkMainAxis = true,
        crossAxis: checkCrossAxis = false,
        limiter = {
          fn: _ref => {
            let {
              x,
              y
            } = _ref;
            return {
              x,
              y
            };
          }
        },
        ...detectOverflowOptions
      } = evaluate(options, state);
      const coords = {
        x,
        y
      };
      const overflow = await detectOverflow(state, detectOverflowOptions);
      const crossAxis = getSideAxis(getSide(placement));
      const mainAxis = getOppositeAxis(crossAxis);
      let mainAxisCoord = coords[mainAxis];
      let crossAxisCoord = coords[crossAxis];
      if (checkMainAxis) {
        const minSide = mainAxis === 'y' ? 'top' : 'left';
        const maxSide = mainAxis === 'y' ? 'bottom' : 'right';
        const min = mainAxisCoord + overflow[minSide];
        const max = mainAxisCoord - overflow[maxSide];
        mainAxisCoord = clamp(min, mainAxisCoord, max);
      }
      if (checkCrossAxis) {
        const minSide = crossAxis === 'y' ? 'top' : 'left';
        const maxSide = crossAxis === 'y' ? 'bottom' : 'right';
        const min = crossAxisCoord + overflow[minSide];
        const max = crossAxisCoord - overflow[maxSide];
        crossAxisCoord = clamp(min, crossAxisCoord, max);
      }
      const limitedCoords = limiter.fn({
        ...state,
        [mainAxis]: mainAxisCoord,
        [crossAxis]: crossAxisCoord
      });
      return {
        ...limitedCoords,
        data: {
          x: limitedCoords.x - x,
          y: limitedCoords.y - y
        }
      };
    }
  };
};
/**
 * Built-in `limiter` that will stop `shift()` at a certain point.
 */
const limitShift = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    options,
    fn(state) {
      const {
        x,
        y,
        placement,
        rects,
        middlewareData
      } = state;
      const {
        offset = 0,
        mainAxis: checkMainAxis = true,
        crossAxis: checkCrossAxis = true
      } = evaluate(options, state);
      const coords = {
        x,
        y
      };
      const crossAxis = getSideAxis(placement);
      const mainAxis = getOppositeAxis(crossAxis);
      let mainAxisCoord = coords[mainAxis];
      let crossAxisCoord = coords[crossAxis];
      const rawOffset = evaluate(offset, state);
      const computedOffset = typeof rawOffset === 'number' ? {
        mainAxis: rawOffset,
        crossAxis: 0
      } : {
        mainAxis: 0,
        crossAxis: 0,
        ...rawOffset
      };
      if (checkMainAxis) {
        const len = mainAxis === 'y' ? 'height' : 'width';
        const limitMin = rects.reference[mainAxis] - rects.floating[len] + computedOffset.mainAxis;
        const limitMax = rects.reference[mainAxis] + rects.reference[len] - computedOffset.mainAxis;
        if (mainAxisCoord < limitMin) {
          mainAxisCoord = limitMin;
        } else if (mainAxisCoord > limitMax) {
          mainAxisCoord = limitMax;
        }
      }
      if (checkCrossAxis) {
        var _middlewareData$offse, _middlewareData$offse2;
        const len = mainAxis === 'y' ? 'width' : 'height';
        const isOriginSide = ['top', 'left'].includes(getSide(placement));
        const limitMin = rects.reference[crossAxis] - rects.floating[len] + (isOriginSide ? ((_middlewareData$offse = middlewareData.offset) == null ? void 0 : _middlewareData$offse[crossAxis]) || 0 : 0) + (isOriginSide ? 0 : computedOffset.crossAxis);
        const limitMax = rects.reference[crossAxis] + rects.reference[len] + (isOriginSide ? 0 : ((_middlewareData$offse2 = middlewareData.offset) == null ? void 0 : _middlewareData$offse2[crossAxis]) || 0) - (isOriginSide ? computedOffset.crossAxis : 0);
        if (crossAxisCoord < limitMin) {
          crossAxisCoord = limitMin;
        } else if (crossAxisCoord > limitMax) {
          crossAxisCoord = limitMax;
        }
      }
      return {
        [mainAxis]: mainAxisCoord,
        [crossAxis]: crossAxisCoord
      };
    }
  };
};

/**
 * Provides data that allows you to change the size of the floating element —
 * for instance, prevent it from overflowing the clipping boundary or match the
 * width of the reference element.
 * @see https://floating-ui.com/docs/size
 */
const size = function (options) {
  if (options === void 0) {
    options = {};
  }
  return {
    name: 'size',
    options,
    async fn(state) {
      const {
        placement,
        rects,
        platform,
        elements
      } = state;
      const {
        apply = () => {},
        ...detectOverflowOptions
      } = evaluate(options, state);
      const overflow = await detectOverflow(state, detectOverflowOptions);
      const side = getSide(placement);
      const alignment = getAlignment(placement);
      const isYAxis = getSideAxis(placement) === 'y';
      const {
        width,
        height
      } = rects.floating;
      let heightSide;
      let widthSide;
      if (side === 'top' || side === 'bottom') {
        heightSide = side;
        widthSide = alignment === ((await (platform.isRTL == null ? void 0 : platform.isRTL(elements.floating))) ? 'start' : 'end') ? 'left' : 'right';
      } else {
        widthSide = side;
        heightSide = alignment === 'end' ? 'top' : 'bottom';
      }
      const overflowAvailableHeight = height - overflow[heightSide];
      const overflowAvailableWidth = width - overflow[widthSide];
      const noShift = !state.middlewareData.shift;
      let availableHeight = overflowAvailableHeight;
      let availableWidth = overflowAvailableWidth;
      if (isYAxis) {
        const maximumClippingWidth = width - overflow.left - overflow.right;
        availableWidth = alignment || noShift ? min$1(overflowAvailableWidth, maximumClippingWidth) : maximumClippingWidth;
      } else {
        const maximumClippingHeight = height - overflow.top - overflow.bottom;
        availableHeight = alignment || noShift ? min$1(overflowAvailableHeight, maximumClippingHeight) : maximumClippingHeight;
      }
      if (noShift && !alignment) {
        const xMin = max(overflow.left, 0);
        const xMax = max(overflow.right, 0);
        const yMin = max(overflow.top, 0);
        const yMax = max(overflow.bottom, 0);
        if (isYAxis) {
          availableWidth = width - 2 * (xMin !== 0 || xMax !== 0 ? xMin + xMax : max(overflow.left, overflow.right));
        } else {
          availableHeight = height - 2 * (yMin !== 0 || yMax !== 0 ? yMin + yMax : max(overflow.top, overflow.bottom));
        }
      }
      await apply({
        ...state,
        availableWidth,
        availableHeight
      });
      const nextDimensions = await platform.getDimensions(elements.floating);
      if (width !== nextDimensions.width || height !== nextDimensions.height) {
        return {
          reset: {
            rects: true
          }
        };
      }
      return {};
    }
  };
};

function getNodeName(node) {
  if (isNode(node)) {
    return (node.nodeName || '').toLowerCase();
  }
  // Mocked nodes in testing environments may not be instances of Node. By
  // returning `#document` an infinite loop won't occur.
  // https://github.com/floating-ui/floating-ui/issues/2317
  return '#document';
}
function getWindow$1(node) {
  var _node$ownerDocument;
  return (node == null ? void 0 : (_node$ownerDocument = node.ownerDocument) == null ? void 0 : _node$ownerDocument.defaultView) || window;
}
function getDocumentElement(node) {
  var _ref;
  return (_ref = (isNode(node) ? node.ownerDocument : node.document) || window.document) == null ? void 0 : _ref.documentElement;
}
function isNode(value) {
  return value instanceof Node || value instanceof getWindow$1(value).Node;
}
function isElement(value) {
  return value instanceof Element || value instanceof getWindow$1(value).Element;
}
function isHTMLElement(value) {
  return value instanceof HTMLElement || value instanceof getWindow$1(value).HTMLElement;
}
function isShadowRoot(value) {
  // Browsers without `ShadowRoot` support.
  if (typeof ShadowRoot === 'undefined') {
    return false;
  }
  return value instanceof ShadowRoot || value instanceof getWindow$1(value).ShadowRoot;
}
function isOverflowElement(element) {
  const {
    overflow,
    overflowX,
    overflowY,
    display
  } = getComputedStyle$1(element);
  return /auto|scroll|overlay|hidden|clip/.test(overflow + overflowY + overflowX) && !['inline', 'contents'].includes(display);
}
function isTableElement(element) {
  return ['table', 'td', 'th'].includes(getNodeName(element));
}
function isContainingBlock(element) {
  const webkit = isWebKit();
  const css = getComputedStyle$1(element);

  // https://developer.mozilla.org/en-US/docs/Web/CSS/Containing_block#identifying_the_containing_block
  return css.transform !== 'none' || css.perspective !== 'none' || (css.containerType ? css.containerType !== 'normal' : false) || !webkit && (css.backdropFilter ? css.backdropFilter !== 'none' : false) || !webkit && (css.filter ? css.filter !== 'none' : false) || ['transform', 'perspective', 'filter'].some(value => (css.willChange || '').includes(value)) || ['paint', 'layout', 'strict', 'content'].some(value => (css.contain || '').includes(value));
}
function getContainingBlock(element) {
  let currentNode = getParentNode(element);
  while (isHTMLElement(currentNode) && !isLastTraversableNode(currentNode)) {
    if (isContainingBlock(currentNode)) {
      return currentNode;
    } else {
      currentNode = getParentNode(currentNode);
    }
  }
  return null;
}
function isWebKit() {
  if (typeof CSS === 'undefined' || !CSS.supports) return false;
  return CSS.supports('-webkit-backdrop-filter', 'none');
}
function isLastTraversableNode(node) {
  return ['html', 'body', '#document'].includes(getNodeName(node));
}
function getComputedStyle$1(element) {
  return getWindow$1(element).getComputedStyle(element);
}
function getNodeScroll(element) {
  if (isElement(element)) {
    return {
      scrollLeft: element.scrollLeft,
      scrollTop: element.scrollTop
    };
  }
  return {
    scrollLeft: element.pageXOffset,
    scrollTop: element.pageYOffset
  };
}
function getParentNode(node) {
  if (getNodeName(node) === 'html') {
    return node;
  }
  const result =
  // Step into the shadow DOM of the parent of a slotted node.
  node.assignedSlot ||
  // DOM Element detected.
  node.parentNode ||
  // ShadowRoot detected.
  isShadowRoot(node) && node.host ||
  // Fallback.
  getDocumentElement(node);
  return isShadowRoot(result) ? result.host : result;
}
function getNearestOverflowAncestor(node) {
  const parentNode = getParentNode(node);
  if (isLastTraversableNode(parentNode)) {
    return node.ownerDocument ? node.ownerDocument.body : node.body;
  }
  if (isHTMLElement(parentNode) && isOverflowElement(parentNode)) {
    return parentNode;
  }
  return getNearestOverflowAncestor(parentNode);
}
function getOverflowAncestors(node, list) {
  var _node$ownerDocument2;
  if (list === void 0) {
    list = [];
  }
  const scrollableAncestor = getNearestOverflowAncestor(node);
  const isBody = scrollableAncestor === ((_node$ownerDocument2 = node.ownerDocument) == null ? void 0 : _node$ownerDocument2.body);
  const win = getWindow$1(scrollableAncestor);
  if (isBody) {
    return list.concat(win, win.visualViewport || [], isOverflowElement(scrollableAncestor) ? scrollableAncestor : []);
  }
  return list.concat(scrollableAncestor, getOverflowAncestors(scrollableAncestor));
}

function getCssDimensions(element) {
  const css = getComputedStyle$1(element);
  // In testing environments, the `width` and `height` properties are empty
  // strings for SVG elements, returning NaN. Fallback to `0` in this case.
  let width = parseFloat(css.width) || 0;
  let height = parseFloat(css.height) || 0;
  const hasOffset = isHTMLElement(element);
  const offsetWidth = hasOffset ? element.offsetWidth : width;
  const offsetHeight = hasOffset ? element.offsetHeight : height;
  const shouldFallback = round(width) !== offsetWidth || round(height) !== offsetHeight;
  if (shouldFallback) {
    width = offsetWidth;
    height = offsetHeight;
  }
  return {
    width,
    height,
    $: shouldFallback
  };
}

function unwrapElement(element) {
  return !isElement(element) ? element.contextElement : element;
}

function getScale(element) {
  const domElement = unwrapElement(element);
  if (!isHTMLElement(domElement)) {
    return createCoords(1);
  }
  const rect = domElement.getBoundingClientRect();
  const {
    width,
    height,
    $
  } = getCssDimensions(domElement);
  let x = ($ ? round(rect.width) : rect.width) / width;
  let y = ($ ? round(rect.height) : rect.height) / height;

  // 0, NaN, or Infinity should always fallback to 1.

  if (!x || !Number.isFinite(x)) {
    x = 1;
  }
  if (!y || !Number.isFinite(y)) {
    y = 1;
  }
  return {
    x,
    y
  };
}

const noOffsets = /*#__PURE__*/createCoords(0);
function getVisualOffsets(element) {
  const win = getWindow$1(element);
  if (!isWebKit() || !win.visualViewport) {
    return noOffsets;
  }
  return {
    x: win.visualViewport.offsetLeft,
    y: win.visualViewport.offsetTop
  };
}
function shouldAddVisualOffsets(element, isFixed, floatingOffsetParent) {
  if (isFixed === void 0) {
    isFixed = false;
  }
  if (!floatingOffsetParent || isFixed && floatingOffsetParent !== getWindow$1(element)) {
    return false;
  }
  return isFixed;
}

function getBoundingClientRect(element, includeScale, isFixedStrategy, offsetParent) {
  if (includeScale === void 0) {
    includeScale = false;
  }
  if (isFixedStrategy === void 0) {
    isFixedStrategy = false;
  }
  const clientRect = element.getBoundingClientRect();
  const domElement = unwrapElement(element);
  let scale = createCoords(1);
  if (includeScale) {
    if (offsetParent) {
      if (isElement(offsetParent)) {
        scale = getScale(offsetParent);
      }
    } else {
      scale = getScale(element);
    }
  }
  const visualOffsets = shouldAddVisualOffsets(domElement, isFixedStrategy, offsetParent) ? getVisualOffsets(domElement) : createCoords(0);
  let x = (clientRect.left + visualOffsets.x) / scale.x;
  let y = (clientRect.top + visualOffsets.y) / scale.y;
  let width = clientRect.width / scale.x;
  let height = clientRect.height / scale.y;
  if (domElement) {
    const win = getWindow$1(domElement);
    const offsetWin = offsetParent && isElement(offsetParent) ? getWindow$1(offsetParent) : offsetParent;
    let currentIFrame = win.frameElement;
    while (currentIFrame && offsetParent && offsetWin !== win) {
      const iframeScale = getScale(currentIFrame);
      const iframeRect = currentIFrame.getBoundingClientRect();
      const css = getComputedStyle$1(currentIFrame);
      const left = iframeRect.left + (currentIFrame.clientLeft + parseFloat(css.paddingLeft)) * iframeScale.x;
      const top = iframeRect.top + (currentIFrame.clientTop + parseFloat(css.paddingTop)) * iframeScale.y;
      x *= iframeScale.x;
      y *= iframeScale.y;
      width *= iframeScale.x;
      height *= iframeScale.y;
      x += left;
      y += top;
      currentIFrame = getWindow$1(currentIFrame).frameElement;
    }
  }
  return rectToClientRect({
    width,
    height,
    x,
    y
  });
}

function convertOffsetParentRelativeRectToViewportRelativeRect(_ref) {
  let {
    rect,
    offsetParent,
    strategy
  } = _ref;
  const isOffsetParentAnElement = isHTMLElement(offsetParent);
  const documentElement = getDocumentElement(offsetParent);
  if (offsetParent === documentElement) {
    return rect;
  }
  let scroll = {
    scrollLeft: 0,
    scrollTop: 0
  };
  let scale = createCoords(1);
  const offsets = createCoords(0);
  if (isOffsetParentAnElement || !isOffsetParentAnElement && strategy !== 'fixed') {
    if (getNodeName(offsetParent) !== 'body' || isOverflowElement(documentElement)) {
      scroll = getNodeScroll(offsetParent);
    }
    if (isHTMLElement(offsetParent)) {
      const offsetRect = getBoundingClientRect(offsetParent);
      scale = getScale(offsetParent);
      offsets.x = offsetRect.x + offsetParent.clientLeft;
      offsets.y = offsetRect.y + offsetParent.clientTop;
    }
  }
  return {
    width: rect.width * scale.x,
    height: rect.height * scale.y,
    x: rect.x * scale.x - scroll.scrollLeft * scale.x + offsets.x,
    y: rect.y * scale.y - scroll.scrollTop * scale.y + offsets.y
  };
}

function getClientRects(element) {
  return Array.from(element.getClientRects());
}

function getWindowScrollBarX(element) {
  // If <html> has a CSS width greater than the viewport, then this will be
  // incorrect for RTL.
  return getBoundingClientRect(getDocumentElement(element)).left + getNodeScroll(element).scrollLeft;
}

// Gets the entire size of the scrollable document area, even extending outside
// of the `<html>` and `<body>` rect bounds if horizontally scrollable.
function getDocumentRect(element) {
  const html = getDocumentElement(element);
  const scroll = getNodeScroll(element);
  const body = element.ownerDocument.body;
  const width = max(html.scrollWidth, html.clientWidth, body.scrollWidth, body.clientWidth);
  const height = max(html.scrollHeight, html.clientHeight, body.scrollHeight, body.clientHeight);
  let x = -scroll.scrollLeft + getWindowScrollBarX(element);
  const y = -scroll.scrollTop;
  if (getComputedStyle$1(body).direction === 'rtl') {
    x += max(html.clientWidth, body.clientWidth) - width;
  }
  return {
    width,
    height,
    x,
    y
  };
}

function getViewportRect(element, strategy) {
  const win = getWindow$1(element);
  const html = getDocumentElement(element);
  const visualViewport = win.visualViewport;
  let width = html.clientWidth;
  let height = html.clientHeight;
  let x = 0;
  let y = 0;
  if (visualViewport) {
    width = visualViewport.width;
    height = visualViewport.height;
    const visualViewportBased = isWebKit();
    if (!visualViewportBased || visualViewportBased && strategy === 'fixed') {
      x = visualViewport.offsetLeft;
      y = visualViewport.offsetTop;
    }
  }
  return {
    width,
    height,
    x,
    y
  };
}

// Returns the inner client rect, subtracting scrollbars if present.
function getInnerBoundingClientRect(element, strategy) {
  const clientRect = getBoundingClientRect(element, true, strategy === 'fixed');
  const top = clientRect.top + element.clientTop;
  const left = clientRect.left + element.clientLeft;
  const scale = isHTMLElement(element) ? getScale(element) : createCoords(1);
  const width = element.clientWidth * scale.x;
  const height = element.clientHeight * scale.y;
  const x = left * scale.x;
  const y = top * scale.y;
  return {
    width,
    height,
    x,
    y
  };
}
function getClientRectFromClippingAncestor(element, clippingAncestor, strategy) {
  let rect;
  if (clippingAncestor === 'viewport') {
    rect = getViewportRect(element, strategy);
  } else if (clippingAncestor === 'document') {
    rect = getDocumentRect(getDocumentElement(element));
  } else if (isElement(clippingAncestor)) {
    rect = getInnerBoundingClientRect(clippingAncestor, strategy);
  } else {
    const visualOffsets = getVisualOffsets(element);
    rect = {
      ...clippingAncestor,
      x: clippingAncestor.x - visualOffsets.x,
      y: clippingAncestor.y - visualOffsets.y
    };
  }
  return rectToClientRect(rect);
}
function hasFixedPositionAncestor(element, stopNode) {
  const parentNode = getParentNode(element);
  if (parentNode === stopNode || !isElement(parentNode) || isLastTraversableNode(parentNode)) {
    return false;
  }
  return getComputedStyle$1(parentNode).position === 'fixed' || hasFixedPositionAncestor(parentNode, stopNode);
}

// A "clipping ancestor" is an `overflow` element with the characteristic of
// clipping (or hiding) child elements. This returns all clipping ancestors
// of the given element up the tree.
function getClippingElementAncestors(element, cache) {
  const cachedResult = cache.get(element);
  if (cachedResult) {
    return cachedResult;
  }
  let result = getOverflowAncestors(element).filter(el => isElement(el) && getNodeName(el) !== 'body');
  let currentContainingBlockComputedStyle = null;
  const elementIsFixed = getComputedStyle$1(element).position === 'fixed';
  let currentNode = elementIsFixed ? getParentNode(element) : element;

  // https://developer.mozilla.org/en-US/docs/Web/CSS/Containing_block#identifying_the_containing_block
  while (isElement(currentNode) && !isLastTraversableNode(currentNode)) {
    const computedStyle = getComputedStyle$1(currentNode);
    const currentNodeIsContaining = isContainingBlock(currentNode);
    if (!currentNodeIsContaining && computedStyle.position === 'fixed') {
      currentContainingBlockComputedStyle = null;
    }
    const shouldDropCurrentNode = elementIsFixed ? !currentNodeIsContaining && !currentContainingBlockComputedStyle : !currentNodeIsContaining && computedStyle.position === 'static' && !!currentContainingBlockComputedStyle && ['absolute', 'fixed'].includes(currentContainingBlockComputedStyle.position) || isOverflowElement(currentNode) && !currentNodeIsContaining && hasFixedPositionAncestor(element, currentNode);
    if (shouldDropCurrentNode) {
      // Drop non-containing blocks.
      result = result.filter(ancestor => ancestor !== currentNode);
    } else {
      // Record last containing block for next iteration.
      currentContainingBlockComputedStyle = computedStyle;
    }
    currentNode = getParentNode(currentNode);
  }
  cache.set(element, result);
  return result;
}

// Gets the maximum area that the element is visible in due to any number of
// clipping ancestors.
function getClippingRect(_ref) {
  let {
    element,
    boundary,
    rootBoundary,
    strategy
  } = _ref;
  const elementClippingAncestors = boundary === 'clippingAncestors' ? getClippingElementAncestors(element, this._c) : [].concat(boundary);
  const clippingAncestors = [...elementClippingAncestors, rootBoundary];
  const firstClippingAncestor = clippingAncestors[0];
  const clippingRect = clippingAncestors.reduce((accRect, clippingAncestor) => {
    const rect = getClientRectFromClippingAncestor(element, clippingAncestor, strategy);
    accRect.top = max(rect.top, accRect.top);
    accRect.right = min$1(rect.right, accRect.right);
    accRect.bottom = min$1(rect.bottom, accRect.bottom);
    accRect.left = max(rect.left, accRect.left);
    return accRect;
  }, getClientRectFromClippingAncestor(element, firstClippingAncestor, strategy));
  return {
    width: clippingRect.right - clippingRect.left,
    height: clippingRect.bottom - clippingRect.top,
    x: clippingRect.left,
    y: clippingRect.top
  };
}

function getDimensions(element) {
  return getCssDimensions(element);
}

function getRectRelativeToOffsetParent(element, offsetParent, strategy) {
  const isOffsetParentAnElement = isHTMLElement(offsetParent);
  const documentElement = getDocumentElement(offsetParent);
  const isFixed = strategy === 'fixed';
  const rect = getBoundingClientRect(element, true, isFixed, offsetParent);
  let scroll = {
    scrollLeft: 0,
    scrollTop: 0
  };
  const offsets = createCoords(0);
  if (isOffsetParentAnElement || !isOffsetParentAnElement && !isFixed) {
    if (getNodeName(offsetParent) !== 'body' || isOverflowElement(documentElement)) {
      scroll = getNodeScroll(offsetParent);
    }
    if (isOffsetParentAnElement) {
      const offsetRect = getBoundingClientRect(offsetParent, true, isFixed, offsetParent);
      offsets.x = offsetRect.x + offsetParent.clientLeft;
      offsets.y = offsetRect.y + offsetParent.clientTop;
    } else if (documentElement) {
      offsets.x = getWindowScrollBarX(documentElement);
    }
  }
  return {
    x: rect.left + scroll.scrollLeft - offsets.x,
    y: rect.top + scroll.scrollTop - offsets.y,
    width: rect.width,
    height: rect.height
  };
}

function getTrueOffsetParent(element, polyfill) {
  if (!isHTMLElement(element) || getComputedStyle$1(element).position === 'fixed') {
    return null;
  }
  if (polyfill) {
    return polyfill(element);
  }
  return element.offsetParent;
}

// Gets the closest ancestor positioned element. Handles some edge cases,
// such as table ancestors and cross browser bugs.
function getOffsetParent(element, polyfill) {
  const window = getWindow$1(element);
  if (!isHTMLElement(element)) {
    return window;
  }
  let offsetParent = getTrueOffsetParent(element, polyfill);
  while (offsetParent && isTableElement(offsetParent) && getComputedStyle$1(offsetParent).position === 'static') {
    offsetParent = getTrueOffsetParent(offsetParent, polyfill);
  }
  if (offsetParent && (getNodeName(offsetParent) === 'html' || getNodeName(offsetParent) === 'body' && getComputedStyle$1(offsetParent).position === 'static' && !isContainingBlock(offsetParent))) {
    return window;
  }
  return offsetParent || getContainingBlock(element) || window;
}

const getElementRects = async function (_ref) {
  let {
    reference,
    floating,
    strategy
  } = _ref;
  const getOffsetParentFn = this.getOffsetParent || getOffsetParent;
  const getDimensionsFn = this.getDimensions;
  return {
    reference: getRectRelativeToOffsetParent(reference, await getOffsetParentFn(floating), strategy),
    floating: {
      x: 0,
      y: 0,
      ...(await getDimensionsFn(floating))
    }
  };
};

function isRTL(element) {
  return getComputedStyle$1(element).direction === 'rtl';
}

const platform$1 = {
  convertOffsetParentRelativeRectToViewportRelativeRect,
  getDocumentElement,
  getClippingRect,
  getOffsetParent,
  getElementRects,
  getClientRects,
  getDimensions,
  getScale,
  isElement,
  isRTL
};

// https://samthor.au/2021/observing-dom/
function observeMove(element, onMove) {
  let io = null;
  let timeoutId;
  const root = getDocumentElement(element);
  function cleanup() {
    clearTimeout(timeoutId);
    io && io.disconnect();
    io = null;
  }
  function refresh(skip, threshold) {
    if (skip === void 0) {
      skip = false;
    }
    if (threshold === void 0) {
      threshold = 1;
    }
    cleanup();
    const {
      left,
      top,
      width,
      height
    } = element.getBoundingClientRect();
    if (!skip) {
      onMove();
    }
    if (!width || !height) {
      return;
    }
    const insetTop = floor(top);
    const insetRight = floor(root.clientWidth - (left + width));
    const insetBottom = floor(root.clientHeight - (top + height));
    const insetLeft = floor(left);
    const rootMargin = -insetTop + "px " + -insetRight + "px " + -insetBottom + "px " + -insetLeft + "px";
    const options = {
      rootMargin,
      threshold: max(0, min$1(1, threshold)) || 1
    };
    let isFirstUpdate = true;
    function handleObserve(entries) {
      const ratio = entries[0].intersectionRatio;
      if (ratio !== threshold) {
        if (!isFirstUpdate) {
          return refresh();
        }
        if (!ratio) {
          timeoutId = setTimeout(() => {
            refresh(false, 1e-7);
          }, 100);
        } else {
          refresh(false, ratio);
        }
      }
      isFirstUpdate = false;
    }

    // Older browsers don't support a `document` as the root and will throw an
    // error.
    try {
      io = new IntersectionObserver(handleObserve, {
        ...options,
        // Handle <iframe>s
        root: root.ownerDocument
      });
    } catch (e) {
      io = new IntersectionObserver(handleObserve, options);
    }
    io.observe(element);
  }
  refresh(true);
  return cleanup;
}

/**
 * Automatically updates the position of the floating element when necessary.
 * Should only be called when the floating element is mounted on the DOM or
 * visible on the screen.
 * @returns cleanup function that should be invoked when the floating element is
 * removed from the DOM or hidden from the screen.
 * @see https://floating-ui.com/docs/autoUpdate
 */
function autoUpdate(reference, floating, update, options) {
  if (options === void 0) {
    options = {};
  }
  const {
    ancestorScroll = true,
    ancestorResize = true,
    elementResize = typeof ResizeObserver === 'function',
    layoutShift = typeof IntersectionObserver === 'function',
    animationFrame = false
  } = options;
  const referenceEl = unwrapElement(reference);
  const ancestors = ancestorScroll || ancestorResize ? [...(referenceEl ? getOverflowAncestors(referenceEl) : []), ...getOverflowAncestors(floating)] : [];
  ancestors.forEach(ancestor => {
    ancestorScroll && ancestor.addEventListener('scroll', update, {
      passive: true
    });
    ancestorResize && ancestor.addEventListener('resize', update);
  });
  const cleanupIo = referenceEl && layoutShift ? observeMove(referenceEl, update) : null;
  let reobserveFrame = -1;
  let resizeObserver = null;
  if (elementResize) {
    resizeObserver = new ResizeObserver(_ref => {
      let [firstEntry] = _ref;
      if (firstEntry && firstEntry.target === referenceEl && resizeObserver) {
        // Prevent update loops when using the `size` middleware.
        // https://github.com/floating-ui/floating-ui/issues/1740
        resizeObserver.unobserve(floating);
        cancelAnimationFrame(reobserveFrame);
        reobserveFrame = requestAnimationFrame(() => {
          resizeObserver && resizeObserver.observe(floating);
        });
      }
      update();
    });
    if (referenceEl && !animationFrame) {
      resizeObserver.observe(referenceEl);
    }
    resizeObserver.observe(floating);
  }
  let frameId;
  let prevRefRect = animationFrame ? getBoundingClientRect(reference) : null;
  if (animationFrame) {
    frameLoop();
  }
  function frameLoop() {
    const nextRefRect = getBoundingClientRect(reference);
    if (prevRefRect && (nextRefRect.x !== prevRefRect.x || nextRefRect.y !== prevRefRect.y || nextRefRect.width !== prevRefRect.width || nextRefRect.height !== prevRefRect.height)) {
      update();
    }
    prevRefRect = nextRefRect;
    frameId = requestAnimationFrame(frameLoop);
  }
  update();
  return () => {
    ancestors.forEach(ancestor => {
      ancestorScroll && ancestor.removeEventListener('scroll', update);
      ancestorResize && ancestor.removeEventListener('resize', update);
    });
    cleanupIo && cleanupIo();
    resizeObserver && resizeObserver.disconnect();
    resizeObserver = null;
    if (animationFrame) {
      cancelAnimationFrame(frameId);
    }
  };
}

/**
 * Computes the `x` and `y` coordinates that will place the floating element
 * next to a reference element when it is given a certain CSS positioning
 * strategy.
 */
const computePosition = (reference, floating, options) => {
  // This caches the expensive `getClippingElementAncestors` function so that
  // multiple lifecycle resets re-use the same result. It only lives for a
  // single call. If other functions become expensive, we can add them as well.
  const cache = new Map();
  const mergedOptions = {
    platform: platform$1,
    ...options
  };
  const platformWithCache = {
    ...mergedOptions.platform,
    _c: cache
  };
  return computePosition$1(reference, floating, {
    ...mergedOptions,
    platform: platformWithCache
  });
};

function t$1(t){return r$1(t)}function e$1(t){return f$1(t,"offsetTop")}function n$1(t){return f$1(t,"offsetLeft")}function o$3(t){return t.assignedSlot?t.assignedSlot:t.parentNode instanceof ShadowRoot?t.parentNode.host:t.parentNode}function r$1(t){for(let e=t;e;e=o$3(e))if(e instanceof Element&&"none"===getComputedStyle(e).display)return null;for(let e=o$3(t);e;e=o$3(e)){if(!(e instanceof Element))continue;const t=getComputedStyle(e);if("contents"!==t.display){if("static"!==t.position||"none"!==t.filter)return e;if("BODY"===e.tagName)return e}}return null}function f$1(t,e){let n=t[e],o=r$1(t);const f=function(t){const e=new Set;let n=t.getRootNode();for(;n;)e.add(n),n=n.parentNode?n.parentNode.getRootNode():null;return e}(t);for(;o&&!f.has(o.getRootNode());)n-=o[e],o=r$1(o);return n}

function isVirtualElement(e) {
  return e !== null && typeof e === "object" && "getBoundingClientRect" in e;
}
var SlPopup = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.active = false;
    this.placement = "top";
    this.strategy = "absolute";
    this.distance = 0;
    this.skidding = 0;
    this.arrow = false;
    this.arrowPlacement = "anchor";
    this.arrowPadding = 10;
    this.flip = false;
    this.flipFallbackPlacements = "";
    this.flipFallbackStrategy = "best-fit";
    this.flipPadding = 0;
    this.shift = false;
    this.shiftPadding = 0;
    this.autoSizePadding = 0;
  }
  async connectedCallback() {
    super.connectedCallback();
    await this.updateComplete;
    this.start();
  }
  disconnectedCallback() {
    this.stop();
  }
  async updated(changedProps) {
    super.updated(changedProps);
    if (changedProps.has("active")) {
      if (this.active) {
        this.start();
      } else {
        this.stop();
      }
    }
    if (changedProps.has("anchor")) {
      this.handleAnchorChange();
    }
    if (this.active) {
      await this.updateComplete;
      this.reposition();
    }
  }
  async handleAnchorChange() {
    await this.stop();
    if (this.anchor && typeof this.anchor === "string") {
      const root = this.getRootNode();
      this.anchorEl = root.getElementById(this.anchor);
    } else if (this.anchor instanceof Element || isVirtualElement(this.anchor)) {
      this.anchorEl = this.anchor;
    } else {
      this.anchorEl = this.querySelector('[slot="anchor"]');
    }
    if (this.anchorEl instanceof HTMLSlotElement) {
      this.anchorEl = this.anchorEl.assignedElements({ flatten: true })[0];
    }
    if (!this.anchorEl) {
      throw new Error(
        "Invalid anchor element: no anchor could be found using the anchor slot or the anchor attribute."
      );
    }
    this.start();
  }
  start() {
    if (!this.anchorEl) {
      return;
    }
    this.cleanup = autoUpdate(this.anchorEl, this.popup, () => {
      this.reposition();
    });
  }
  async stop() {
    return new Promise((resolve) => {
      if (this.cleanup) {
        this.cleanup();
        this.cleanup = void 0;
        this.removeAttribute("data-current-placement");
        this.style.removeProperty("--auto-size-available-width");
        this.style.removeProperty("--auto-size-available-height");
        requestAnimationFrame(() => resolve());
      } else {
        resolve();
      }
    });
  }
  /** Forces the popup to recalculate and reposition itself. */
  reposition() {
    if (!this.active || !this.anchorEl) {
      return;
    }
    const middleware = [
      // The offset middleware goes first
      offset$1({ mainAxis: this.distance, crossAxis: this.skidding })
    ];
    if (this.sync) {
      middleware.push(
        size({
          apply: ({ rects }) => {
            const syncWidth = this.sync === "width" || this.sync === "both";
            const syncHeight = this.sync === "height" || this.sync === "both";
            this.popup.style.width = syncWidth ? `${rects.reference.width}px` : "";
            this.popup.style.height = syncHeight ? `${rects.reference.height}px` : "";
          }
        })
      );
    } else {
      this.popup.style.width = "";
      this.popup.style.height = "";
    }
    if (this.flip) {
      middleware.push(
        flip$1({
          boundary: this.flipBoundary,
          // @ts-expect-error - We're converting a string attribute to an array here
          fallbackPlacements: this.flipFallbackPlacements,
          fallbackStrategy: this.flipFallbackStrategy === "best-fit" ? "bestFit" : "initialPlacement",
          padding: this.flipPadding
        })
      );
    }
    if (this.shift) {
      middleware.push(
        shift$1({
          boundary: this.shiftBoundary,
          padding: this.shiftPadding
        })
      );
    }
    if (this.autoSize) {
      middleware.push(
        size({
          boundary: this.autoSizeBoundary,
          padding: this.autoSizePadding,
          apply: ({ availableWidth, availableHeight }) => {
            if (this.autoSize === "vertical" || this.autoSize === "both") {
              this.style.setProperty("--auto-size-available-height", `${availableHeight}px`);
            } else {
              this.style.removeProperty("--auto-size-available-height");
            }
            if (this.autoSize === "horizontal" || this.autoSize === "both") {
              this.style.setProperty("--auto-size-available-width", `${availableWidth}px`);
            } else {
              this.style.removeProperty("--auto-size-available-width");
            }
          }
        })
      );
    } else {
      this.style.removeProperty("--auto-size-available-width");
      this.style.removeProperty("--auto-size-available-height");
    }
    if (this.arrow) {
      middleware.push(
        arrow({
          element: this.arrowEl,
          padding: this.arrowPadding
        })
      );
    }
    const getOffsetParent = this.strategy === "absolute" ? (element) => platform$1.getOffsetParent(element, t$1) : platform$1.getOffsetParent;
    computePosition(this.anchorEl, this.popup, {
      placement: this.placement,
      middleware,
      strategy: this.strategy,
      platform: __spreadProps(__spreadValues({}, platform$1), {
        getOffsetParent
      })
    }).then(({ x, y, middlewareData, placement }) => {
      const isRtl = getComputedStyle(this).direction === "rtl";
      const staticSide = { top: "bottom", right: "left", bottom: "top", left: "right" }[placement.split("-")[0]];
      this.setAttribute("data-current-placement", placement);
      Object.assign(this.popup.style, {
        left: `${x}px`,
        top: `${y}px`
      });
      if (this.arrow) {
        const arrowX = middlewareData.arrow.x;
        const arrowY = middlewareData.arrow.y;
        let top = "";
        let right = "";
        let bottom = "";
        let left = "";
        if (this.arrowPlacement === "start") {
          const value = typeof arrowX === "number" ? `calc(${this.arrowPadding}px - var(--arrow-padding-offset))` : "";
          top = typeof arrowY === "number" ? `calc(${this.arrowPadding}px - var(--arrow-padding-offset))` : "";
          right = isRtl ? value : "";
          left = isRtl ? "" : value;
        } else if (this.arrowPlacement === "end") {
          const value = typeof arrowX === "number" ? `calc(${this.arrowPadding}px - var(--arrow-padding-offset))` : "";
          right = isRtl ? "" : value;
          left = isRtl ? value : "";
          bottom = typeof arrowY === "number" ? `calc(${this.arrowPadding}px - var(--arrow-padding-offset))` : "";
        } else if (this.arrowPlacement === "center") {
          left = typeof arrowX === "number" ? `calc(50% - var(--arrow-size-diagonal))` : "";
          top = typeof arrowY === "number" ? `calc(50% - var(--arrow-size-diagonal))` : "";
        } else {
          left = typeof arrowX === "number" ? `${arrowX}px` : "";
          top = typeof arrowY === "number" ? `${arrowY}px` : "";
        }
        Object.assign(this.arrowEl.style, {
          top,
          right,
          bottom,
          left,
          [staticSide]: "calc(var(--arrow-size-diagonal) * -1)"
        });
      }
    });
    this.emit("sl-reposition");
  }
  render() {
    return x$1`
      <slot name="anchor" @slotchange=${this.handleAnchorChange}></slot>

      <div
        part="popup"
        class=${o$9({
      popup: true,
      "popup--active": this.active,
      "popup--fixed": this.strategy === "fixed",
      "popup--has-arrow": this.arrow
    })}
      >
        <slot></slot>
        ${this.arrow ? x$1`<div part="arrow" class="popup__arrow" role="presentation"></div>` : ""}
      </div>
    `;
  }
};
SlPopup.styles = popup_styles_default;
__decorateClass([
  i$7(".popup")
], SlPopup.prototype, "popup", 2);
__decorateClass([
  i$7(".popup__arrow")
], SlPopup.prototype, "arrowEl", 2);
__decorateClass([
  e$c()
], SlPopup.prototype, "anchor", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlPopup.prototype, "active", 2);
__decorateClass([
  e$c({ reflect: true })
], SlPopup.prototype, "placement", 2);
__decorateClass([
  e$c({ reflect: true })
], SlPopup.prototype, "strategy", 2);
__decorateClass([
  e$c({ type: Number })
], SlPopup.prototype, "distance", 2);
__decorateClass([
  e$c({ type: Number })
], SlPopup.prototype, "skidding", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlPopup.prototype, "arrow", 2);
__decorateClass([
  e$c({ attribute: "arrow-placement" })
], SlPopup.prototype, "arrowPlacement", 2);
__decorateClass([
  e$c({ attribute: "arrow-padding", type: Number })
], SlPopup.prototype, "arrowPadding", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlPopup.prototype, "flip", 2);
__decorateClass([
  e$c({
    attribute: "flip-fallback-placements",
    converter: {
      fromAttribute: (value) => {
        return value.split(" ").map((p) => p.trim()).filter((p) => p !== "");
      },
      toAttribute: (value) => {
        return value.join(" ");
      }
    }
  })
], SlPopup.prototype, "flipFallbackPlacements", 2);
__decorateClass([
  e$c({ attribute: "flip-fallback-strategy" })
], SlPopup.prototype, "flipFallbackStrategy", 2);
__decorateClass([
  e$c({ type: Object })
], SlPopup.prototype, "flipBoundary", 2);
__decorateClass([
  e$c({ attribute: "flip-padding", type: Number })
], SlPopup.prototype, "flipPadding", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlPopup.prototype, "shift", 2);
__decorateClass([
  e$c({ type: Object })
], SlPopup.prototype, "shiftBoundary", 2);
__decorateClass([
  e$c({ attribute: "shift-padding", type: Number })
], SlPopup.prototype, "shiftPadding", 2);
__decorateClass([
  e$c({ attribute: "auto-size" })
], SlPopup.prototype, "autoSize", 2);
__decorateClass([
  e$c()
], SlPopup.prototype, "sync", 2);
__decorateClass([
  e$c({ type: Object })
], SlPopup.prototype, "autoSizeBoundary", 2);
__decorateClass([
  e$c({ attribute: "auto-size-padding", type: Number })
], SlPopup.prototype, "autoSizePadding", 2);

// src/internal/event.ts
function waitForEvent$1(el, eventName) {
  return new Promise((resolve) => {
    function done(event) {
      if (event.target === el) {
        el.removeEventListener(eventName, done);
        resolve();
      }
    }
    el.addEventListener(eventName, done);
  });
}

var SlTooltip = class extends ShoelaceElement {
  constructor() {
    super();
    this.localize = new LocalizeController(this);
    this.content = "";
    this.placement = "top";
    this.disabled = false;
    this.distance = 8;
    this.open = false;
    this.skidding = 0;
    this.trigger = "hover focus";
    this.hoist = false;
    this.handleBlur = () => {
      if (this.hasTrigger("focus")) {
        this.hide();
      }
    };
    this.handleClick = () => {
      if (this.hasTrigger("click")) {
        if (this.open) {
          this.hide();
        } else {
          this.show();
        }
      }
    };
    this.handleFocus = () => {
      if (this.hasTrigger("focus")) {
        this.show();
      }
    };
    this.handleKeyDown = (event) => {
      if (this.open && event.key === "Escape") {
        event.stopPropagation();
        this.hide();
      }
    };
    this.handleMouseOver = () => {
      if (this.hasTrigger("hover")) {
        const delay = parseDuration(getComputedStyle(this).getPropertyValue("--show-delay"));
        clearTimeout(this.hoverTimeout);
        this.hoverTimeout = window.setTimeout(() => this.show(), delay);
      }
    };
    this.handleMouseOut = () => {
      if (this.hasTrigger("hover")) {
        const delay = parseDuration(getComputedStyle(this).getPropertyValue("--hide-delay"));
        clearTimeout(this.hoverTimeout);
        this.hoverTimeout = window.setTimeout(() => this.hide(), delay);
      }
    };
    this.addEventListener("blur", this.handleBlur, true);
    this.addEventListener("focus", this.handleFocus, true);
    this.addEventListener("click", this.handleClick);
    this.addEventListener("keydown", this.handleKeyDown);
    this.addEventListener("mouseover", this.handleMouseOver);
    this.addEventListener("mouseout", this.handleMouseOut);
  }
  connectedCallback() {
    super.connectedCallback();
  }
  firstUpdated() {
    this.body.hidden = !this.open;
    if (this.open) {
      this.popup.active = true;
      this.popup.reposition();
    }
  }
  hasTrigger(triggerType) {
    const triggers = this.trigger.split(" ");
    return triggers.includes(triggerType);
  }
  async handleOpenChange() {
    if (this.open) {
      if (this.disabled) {
        return;
      }
      this.emit("sl-show");
      await stopAnimations(this.body);
      this.body.hidden = false;
      this.popup.active = true;
      const { keyframes, options } = getAnimation(this, "tooltip.show", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      this.emit("sl-after-show");
    } else {
      this.emit("sl-hide");
      await stopAnimations(this.body);
      const { keyframes, options } = getAnimation(this, "tooltip.hide", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      this.popup.active = false;
      this.body.hidden = true;
      this.emit("sl-after-hide");
    }
  }
  async handleOptionsChange() {
    if (this.hasUpdated) {
      await this.updateComplete;
      this.popup.reposition();
    }
  }
  handleDisabledChange() {
    if (this.disabled && this.open) {
      this.hide();
    }
  }
  /** Shows the tooltip. */
  async show() {
    if (this.open) {
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the tooltip */
  async hide() {
    if (!this.open) {
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  //
  // NOTE: Tooltip is a bit unique in that we're using aria-live instead of aria-labelledby to trick screen readers into
  // announcing the content. It works really well, but it violates an accessibility rule. We're also adding the
  // aria-describedby attribute to a slot, which is required by <sl-popup> to correctly locate the first assigned
  // element, otherwise positioning is incorrect.
  //
  render() {
    return x$1`
      <sl-popup
        part="base"
        exportparts="
          popup:base__popup,
          arrow:base__arrow
        "
        class=${o$9({
      tooltip: true,
      "tooltip--open": this.open
    })}
        placement=${this.placement}
        distance=${this.distance}
        skidding=${this.skidding}
        strategy=${this.hoist ? "fixed" : "absolute"}
        flip
        shift
        arrow
      >
        ${""}
        <slot slot="anchor" aria-describedby="tooltip"></slot>

        ${""}
        <div part="body" id="tooltip" class="tooltip__body" role="tooltip" aria-live=${this.open ? "polite" : "off"}>
          <slot name="content">${this.content}</slot>
        </div>
      </sl-popup>
    `;
  }
};
SlTooltip.styles = tooltip_styles_default;
SlTooltip.dependencies = { "sl-popup": SlPopup };
__decorateClass([
  i$7("slot:not([name])")
], SlTooltip.prototype, "defaultSlot", 2);
__decorateClass([
  i$7(".tooltip__body")
], SlTooltip.prototype, "body", 2);
__decorateClass([
  i$7("sl-popup")
], SlTooltip.prototype, "popup", 2);
__decorateClass([
  e$c()
], SlTooltip.prototype, "content", 2);
__decorateClass([
  e$c()
], SlTooltip.prototype, "placement", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTooltip.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Number })
], SlTooltip.prototype, "distance", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTooltip.prototype, "open", 2);
__decorateClass([
  e$c({ type: Number })
], SlTooltip.prototype, "skidding", 2);
__decorateClass([
  e$c()
], SlTooltip.prototype, "trigger", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlTooltip.prototype, "hoist", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlTooltip.prototype, "handleOpenChange", 1);
__decorateClass([
  watch(["content", "distance", "hoist", "placement", "skidding"])
], SlTooltip.prototype, "handleOptionsChange", 1);
__decorateClass([
  watch("disabled")
], SlTooltip.prototype, "handleDisabledChange", 1);
setDefaultAnimation("tooltip.show", {
  keyframes: [
    { opacity: 0, scale: 0.8 },
    { opacity: 1, scale: 1 }
  ],
  options: { duration: 150, easing: "ease" }
});
setDefaultAnimation("tooltip.hide", {
  keyframes: [
    { opacity: 1, scale: 1 },
    { opacity: 0, scale: 0.8 }
  ],
  options: { duration: 150, easing: "ease" }
});

// src/components/tooltip/tooltip.ts
var tooltip_default = SlTooltip;
SlTooltip.define("sl-tooltip");

// src/components/tree-item/tree-item.ts
var tree_item_default = SlTreeItem;
SlTreeItem.define("sl-tree-item");

var tab_panel_styles_default = i$b`
  ${component_styles_default}

  :host {
    --padding: 0;

    display: none;
  }

  :host([active]) {
    display: block;
  }

  .tab-panel {
    display: block;
    padding: var(--padding);
  }
`;

var id$2 = 0;
var SlTabPanel = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.attrId = ++id$2;
    this.componentId = `sl-tab-panel-${this.attrId}`;
    this.name = "";
    this.active = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.id = this.id.length > 0 ? this.id : this.componentId;
    this.setAttribute("role", "tabpanel");
  }
  handleActiveChange() {
    this.setAttribute("aria-hidden", this.active ? "false" : "true");
  }
  render() {
    return x$1`
      <slot
        part="base"
        class=${o$9({
      "tab-panel": true,
      "tab-panel--active": this.active
    })}
      ></slot>
    `;
  }
};
SlTabPanel.styles = tab_panel_styles_default;
__decorateClass([
  e$c({ reflect: true })
], SlTabPanel.prototype, "name", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTabPanel.prototype, "active", 2);
__decorateClass([
  watch("active")
], SlTabPanel.prototype, "handleActiveChange", 1);

// src/components/tab-panel/tab-panel.ts
var tab_panel_default = SlTabPanel;
SlTabPanel.define("sl-tab-panel");

var tag_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }

  .tag {
    display: flex;
    align-items: center;
    border: solid 1px;
    line-height: 1;
    white-space: nowrap;
    user-select: none;
  }

  .tag__remove::part(base) {
    color: inherit;
    padding: 0;
  }

  /*
   * Variant modifiers
   */

  .tag--primary {
    background-color: var(--sl-color-primary-50);
    border-color: var(--sl-color-primary-200);
    color: var(--sl-color-primary-800);
  }

  .tag--primary:active > sl-icon-button {
    color: var(--sl-color-primary-600);
  }

  .tag--success {
    background-color: var(--sl-color-success-50);
    border-color: var(--sl-color-success-200);
    color: var(--sl-color-success-800);
  }

  .tag--success:active > sl-icon-button {
    color: var(--sl-color-success-600);
  }

  .tag--neutral {
    background-color: var(--sl-color-neutral-50);
    border-color: var(--sl-color-neutral-200);
    color: var(--sl-color-neutral-800);
  }

  .tag--neutral:active > sl-icon-button {
    color: var(--sl-color-neutral-600);
  }

  .tag--warning {
    background-color: var(--sl-color-warning-50);
    border-color: var(--sl-color-warning-200);
    color: var(--sl-color-warning-800);
  }

  .tag--warning:active > sl-icon-button {
    color: var(--sl-color-warning-600);
  }

  .tag--danger {
    background-color: var(--sl-color-danger-50);
    border-color: var(--sl-color-danger-200);
    color: var(--sl-color-danger-800);
  }

  .tag--danger:active > sl-icon-button {
    color: var(--sl-color-danger-600);
  }

  /*
   * Size modifiers
   */

  .tag--small {
    font-size: var(--sl-button-font-size-small);
    height: calc(var(--sl-input-height-small) * 0.8);
    line-height: calc(var(--sl-input-height-small) - var(--sl-input-border-width) * 2);
    border-radius: var(--sl-input-border-radius-small);
    padding: 0 var(--sl-spacing-x-small);
  }

  .tag--medium {
    font-size: var(--sl-button-font-size-medium);
    height: calc(var(--sl-input-height-medium) * 0.8);
    line-height: calc(var(--sl-input-height-medium) - var(--sl-input-border-width) * 2);
    border-radius: var(--sl-input-border-radius-medium);
    padding: 0 var(--sl-spacing-small);
  }

  .tag--large {
    font-size: var(--sl-button-font-size-large);
    height: calc(var(--sl-input-height-large) * 0.8);
    line-height: calc(var(--sl-input-height-large) - var(--sl-input-border-width) * 2);
    border-radius: var(--sl-input-border-radius-large);
    padding: 0 var(--sl-spacing-medium);
  }

  .tag__remove {
    margin-inline-start: var(--sl-spacing-x-small);
  }

  /*
   * Pill modifier
   */

  .tag--pill {
    border-radius: var(--sl-border-radius-pill);
  }
`;

var icon_button_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
    color: var(--sl-color-neutral-600);
  }

  .icon-button {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    background: none;
    border: none;
    border-radius: var(--sl-border-radius-medium);
    font-size: inherit;
    color: inherit;
    padding: var(--sl-spacing-x-small);
    cursor: pointer;
    transition: var(--sl-transition-x-fast) color;
    -webkit-appearance: none;
  }

  .icon-button:hover:not(.icon-button--disabled),
  .icon-button:focus-visible:not(.icon-button--disabled) {
    color: var(--sl-color-primary-600);
  }

  .icon-button:active:not(.icon-button--disabled) {
    color: var(--sl-color-primary-700);
  }

  .icon-button:focus {
    outline: none;
  }

  .icon-button--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .icon-button:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .icon-button__icon {
    pointer-events: none;
  }
`;

var SlIconButton = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasFocus = false;
    this.label = "";
    this.disabled = false;
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleClick(event) {
    if (this.disabled) {
      event.preventDefault();
      event.stopPropagation();
    }
  }
  /** Simulates a click on the icon button. */
  click() {
    this.button.click();
  }
  /** Sets focus on the icon button. */
  focus(options) {
    this.button.focus(options);
  }
  /** Removes focus from the icon button. */
  blur() {
    this.button.blur();
  }
  render() {
    const isLink = this.href ? true : false;
    const tag = isLink ? i$9`a` : i$9`button`;
    return n$9`
      <${tag}
        part="base"
        class=${o$9({
      "icon-button": true,
      "icon-button--disabled": !isLink && this.disabled,
      "icon-button--focused": this.hasFocus
    })}
        ?disabled=${l$2(isLink ? void 0 : this.disabled)}
        type=${l$2(isLink ? void 0 : "button")}
        href=${l$2(isLink ? this.href : void 0)}
        target=${l$2(isLink ? this.target : void 0)}
        download=${l$2(isLink ? this.download : void 0)}
        rel=${l$2(isLink && this.target ? "noreferrer noopener" : void 0)}
        role=${l$2(isLink ? void 0 : "button")}
        aria-disabled=${this.disabled ? "true" : "false"}
        aria-label="${this.label}"
        tabindex=${this.disabled ? "-1" : "0"}
        @blur=${this.handleBlur}
        @focus=${this.handleFocus}
        @click=${this.handleClick}
      >
        <sl-icon
          class="icon-button__icon"
          name=${l$2(this.name)}
          library=${l$2(this.library)}
          src=${l$2(this.src)}
          aria-hidden="true"
        ></sl-icon>
      </${tag}>
    `;
  }
};
SlIconButton.styles = icon_button_styles_default;
SlIconButton.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7(".icon-button")
], SlIconButton.prototype, "button", 2);
__decorateClass([
  t$7()
], SlIconButton.prototype, "hasFocus", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "name", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "library", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "src", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "href", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "target", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "download", 2);
__decorateClass([
  e$c()
], SlIconButton.prototype, "label", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlIconButton.prototype, "disabled", 2);

var SlTag = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.variant = "neutral";
    this.size = "medium";
    this.pill = false;
    this.removable = false;
  }
  handleRemoveClick() {
    this.emit("sl-remove");
  }
  render() {
    return x$1`
      <span
        part="base"
        class=${o$9({
      tag: true,
      // Types
      "tag--primary": this.variant === "primary",
      "tag--success": this.variant === "success",
      "tag--neutral": this.variant === "neutral",
      "tag--warning": this.variant === "warning",
      "tag--danger": this.variant === "danger",
      "tag--text": this.variant === "text",
      // Sizes
      "tag--small": this.size === "small",
      "tag--medium": this.size === "medium",
      "tag--large": this.size === "large",
      // Modifiers
      "tag--pill": this.pill,
      "tag--removable": this.removable
    })}
      >
        <slot part="content" class="tag__content"></slot>

        ${this.removable ? x$1`
              <sl-icon-button
                part="remove-button"
                exportparts="base:remove-button__base"
                name="x-lg"
                library="system"
                label=${this.localize.term("remove")}
                class="tag__remove"
                @click=${this.handleRemoveClick}
                tabindex="-1"
              ></sl-icon-button>
            ` : ""}
      </span>
    `;
  }
};
SlTag.styles = tag_styles_default;
SlTag.dependencies = { "sl-icon-button": SlIconButton };
__decorateClass([
  e$c({ reflect: true })
], SlTag.prototype, "variant", 2);
__decorateClass([
  e$c({ reflect: true })
], SlTag.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTag.prototype, "pill", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlTag.prototype, "removable", 2);

// src/components/tag/tag.ts
var tag_default = SlTag;
SlTag.define("sl-tag");

// src/styles/form-control.styles.ts
var form_control_styles_default = i$b`
  .form-control .form-control__label {
    display: none;
  }

  .form-control .form-control__help-text {
    display: none;
  }

  /* Label */
  .form-control--has-label .form-control__label {
    display: inline-block;
    color: var(--sl-input-label-color);
    margin-bottom: var(--sl-spacing-3x-small);
  }

  .form-control--has-label.form-control--small .form-control__label {
    font-size: var(--sl-input-label-font-size-small);
  }

  .form-control--has-label.form-control--medium .form-control__label {
    font-size: var(--sl-input-label-font-size-medium);
  }

  .form-control--has-label.form-control--large .form-control__label {
    font-size: var(--sl-input-label-font-size-large);
  }

  :host([required]) .form-control--has-label .form-control__label::after {
    content: var(--sl-input-required-content);
    margin-inline-start: var(--sl-input-required-content-offset);
    color: var(--sl-input-required-content-color);
  }

  /* Help text */
  .form-control--has-help-text .form-control__help-text {
    display: block;
    color: var(--sl-input-help-text-color);
    margin-top: var(--sl-spacing-3x-small);
  }

  .form-control--has-help-text.form-control--small .form-control__help-text {
    font-size: var(--sl-input-help-text-font-size-small);
  }

  .form-control--has-help-text.form-control--medium .form-control__help-text {
    font-size: var(--sl-input-help-text-font-size-medium);
  }

  .form-control--has-help-text.form-control--large .form-control__help-text {
    font-size: var(--sl-input-help-text-font-size-large);
  }

  .form-control--has-help-text.form-control--radio-group .form-control__help-text {
    margin-top: var(--sl-spacing-2x-small);
  }
`;

var textarea_styles_default = i$b`
  ${component_styles_default}
  ${form_control_styles_default}

  :host {
    display: block;
  }

  .textarea {
    display: flex;
    align-items: center;
    position: relative;
    width: 100%;
    font-family: var(--sl-input-font-family);
    font-weight: var(--sl-input-font-weight);
    line-height: var(--sl-line-height-normal);
    letter-spacing: var(--sl-input-letter-spacing);
    vertical-align: middle;
    transition: var(--sl-transition-fast) color, var(--sl-transition-fast) border, var(--sl-transition-fast) box-shadow,
      var(--sl-transition-fast) background-color;
    cursor: text;
  }

  /* Standard textareas */
  .textarea--standard {
    background-color: var(--sl-input-background-color);
    border: solid var(--sl-input-border-width) var(--sl-input-border-color);
  }

  .textarea--standard:hover:not(.textarea--disabled) {
    background-color: var(--sl-input-background-color-hover);
    border-color: var(--sl-input-border-color-hover);
  }
  .textarea--standard:hover:not(.textarea--disabled) .textarea__control {
    color: var(--sl-input-color-hover);
  }

  .textarea--standard.textarea--focused:not(.textarea--disabled) {
    background-color: var(--sl-input-background-color-focus);
    border-color: var(--sl-input-border-color-focus);
    color: var(--sl-input-color-focus);
    box-shadow: 0 0 0 var(--sl-focus-ring-width) var(--sl-input-focus-ring-color);
  }

  .textarea--standard.textarea--focused:not(.textarea--disabled) .textarea__control {
    color: var(--sl-input-color-focus);
  }

  .textarea--standard.textarea--disabled {
    background-color: var(--sl-input-background-color-disabled);
    border-color: var(--sl-input-border-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
  }

  .textarea--standard.textarea--disabled .textarea__control {
    color: var(--sl-input-color-disabled);
  }

  .textarea--standard.textarea--disabled .textarea__control::placeholder {
    color: var(--sl-input-placeholder-color-disabled);
  }

  /* Filled textareas */
  .textarea--filled {
    border: none;
    background-color: var(--sl-input-filled-background-color);
    color: var(--sl-input-color);
  }

  .textarea--filled:hover:not(.textarea--disabled) {
    background-color: var(--sl-input-filled-background-color-hover);
  }

  .textarea--filled.textarea--focused:not(.textarea--disabled) {
    background-color: var(--sl-input-filled-background-color-focus);
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .textarea--filled.textarea--disabled {
    background-color: var(--sl-input-filled-background-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
  }

  .textarea__control {
    flex: 1 1 auto;
    font-family: inherit;
    font-size: inherit;
    font-weight: inherit;
    line-height: 1.4;
    color: var(--sl-input-color);
    border: none;
    background: none;
    box-shadow: none;
    cursor: inherit;
    -webkit-appearance: none;
  }

  .textarea__control::-webkit-search-decoration,
  .textarea__control::-webkit-search-cancel-button,
  .textarea__control::-webkit-search-results-button,
  .textarea__control::-webkit-search-results-decoration {
    -webkit-appearance: none;
  }

  .textarea__control::placeholder {
    color: var(--sl-input-placeholder-color);
    user-select: none;
  }

  .textarea__control:focus {
    outline: none;
  }

  /*
   * Size modifiers
   */

  .textarea--small {
    border-radius: var(--sl-input-border-radius-small);
    font-size: var(--sl-input-font-size-small);
  }

  .textarea--small .textarea__control {
    padding: 0.5em var(--sl-input-spacing-small);
  }

  .textarea--medium {
    border-radius: var(--sl-input-border-radius-medium);
    font-size: var(--sl-input-font-size-medium);
  }

  .textarea--medium .textarea__control {
    padding: 0.5em var(--sl-input-spacing-medium);
  }

  .textarea--large {
    border-radius: var(--sl-input-border-radius-large);
    font-size: var(--sl-input-font-size-large);
  }

  .textarea--large .textarea__control {
    padding: 0.5em var(--sl-input-spacing-large);
  }

  /*
   * Resize types
   */

  .textarea--resize-none .textarea__control {
    resize: none;
  }

  .textarea--resize-vertical .textarea__control {
    resize: vertical;
  }

  .textarea--resize-auto .textarea__control {
    height: auto;
    resize: none;
    overflow-y: hidden;
  }
`;

// src/internal/slot.ts
var HasSlotController$1 = class {
  constructor(host, ...slotNames) {
    this.slotNames = [];
    this.handleSlotChange = (event) => {
      const slot = event.target;
      if (this.slotNames.includes("[default]") && !slot.name || slot.name && this.slotNames.includes(slot.name)) {
        this.host.requestUpdate();
      }
    };
    (this.host = host).addController(this);
    this.slotNames = slotNames;
  }
  hasDefaultSlot() {
    return [...this.host.childNodes].some((node) => {
      if (node.nodeType === node.TEXT_NODE && node.textContent.trim() !== "") {
        return true;
      }
      if (node.nodeType === node.ELEMENT_NODE) {
        const el = node;
        const tagName = el.tagName.toLowerCase();
        if (tagName === "sl-visually-hidden") {
          return false;
        }
        if (!el.hasAttribute("slot")) {
          return true;
        }
      }
      return false;
    });
  }
  hasNamedSlot(name) {
    return this.host.querySelector(`:scope > [slot="${name}"]`) !== null;
  }
  test(slotName) {
    return slotName === "[default]" ? this.hasDefaultSlot() : this.hasNamedSlot(slotName);
  }
  hostConnected() {
    this.host.shadowRoot.addEventListener("slotchange", this.handleSlotChange);
  }
  hostDisconnected() {
    this.host.shadowRoot.removeEventListener("slotchange", this.handleSlotChange);
  }
};
function getTextContent$1(slot) {
  if (!slot) {
    return "";
  }
  const nodes = slot.assignedNodes({ flatten: true });
  let text = "";
  [...nodes].forEach((node) => {
    if (node.nodeType === Node.TEXT_NODE) {
      text += node.textContent;
    }
  });
  return text;
}

var SlTextarea = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      assumeInteractionOn: ["sl-blur", "sl-input"]
    });
    this.hasSlotController = new HasSlotController$1(this, "help-text", "label");
    this.hasFocus = false;
    this.title = "";
    this.name = "";
    this.value = "";
    this.size = "medium";
    this.filled = false;
    this.label = "";
    this.helpText = "";
    this.placeholder = "";
    this.rows = 4;
    this.resize = "vertical";
    this.disabled = false;
    this.readonly = false;
    this.form = "";
    this.required = false;
    this.spellcheck = true;
    this.defaultValue = "";
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  connectedCallback() {
    super.connectedCallback();
    this.resizeObserver = new ResizeObserver(() => this.setTextareaHeight());
    this.updateComplete.then(() => {
      this.setTextareaHeight();
      this.resizeObserver.observe(this.input);
    });
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.resizeObserver.unobserve(this.input);
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleChange() {
    this.value = this.input.value;
    this.setTextareaHeight();
    this.emit("sl-change");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleInput() {
    this.value = this.input.value;
    this.emit("sl-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  setTextareaHeight() {
    if (this.resize === "auto") {
      this.input.style.height = "auto";
      this.input.style.height = `${this.input.scrollHeight}px`;
    } else {
      this.input.style.height = void 0;
    }
  }
  handleDisabledChange() {
    this.formControlController.setValidity(this.disabled);
  }
  handleRowsChange() {
    this.setTextareaHeight();
  }
  async handleValueChange() {
    await this.updateComplete;
    this.formControlController.updateValidity();
    this.setTextareaHeight();
  }
  /** Sets focus on the textarea. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the textarea. */
  blur() {
    this.input.blur();
  }
  /** Selects all the text in the textarea. */
  select() {
    this.input.select();
  }
  /** Gets or sets the textarea's scroll position. */
  scrollPosition(position) {
    if (position) {
      if (typeof position.top === "number")
        this.input.scrollTop = position.top;
      if (typeof position.left === "number")
        this.input.scrollLeft = position.left;
      return void 0;
    }
    return {
      top: this.input.scrollTop,
      left: this.input.scrollTop
    };
  }
  /** Sets the start and end positions of the text selection (0-based). */
  setSelectionRange(selectionStart, selectionEnd, selectionDirection = "none") {
    this.input.setSelectionRange(selectionStart, selectionEnd, selectionDirection);
  }
  /** Replaces a range of text with a new string. */
  setRangeText(replacement, start, end, selectMode) {
    this.input.setRangeText(replacement, start, end, selectMode);
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
    if (this.value !== this.input.value) {
      this.value = this.input.value;
      this.setTextareaHeight();
    }
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    return x$1`
      <div
        part="form-control"
        class=${o$9({
      "form-control": true,
      "form-control--small": this.size === "small",
      "form-control--medium": this.size === "medium",
      "form-control--large": this.size === "large",
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText
    })}
      >
        <label
          part="form-control-label"
          class="form-control__label"
          for="input"
          aria-hidden=${hasLabel ? "false" : "true"}
        >
          <slot name="label">${this.label}</slot>
        </label>

        <div part="form-control-input" class="form-control-input">
          <div
            part="base"
            class=${o$9({
      textarea: true,
      "textarea--small": this.size === "small",
      "textarea--medium": this.size === "medium",
      "textarea--large": this.size === "large",
      "textarea--standard": !this.filled,
      "textarea--filled": this.filled,
      "textarea--disabled": this.disabled,
      "textarea--focused": this.hasFocus,
      "textarea--empty": !this.value,
      "textarea--resize-none": this.resize === "none",
      "textarea--resize-vertical": this.resize === "vertical",
      "textarea--resize-auto": this.resize === "auto"
    })}
          >
            <textarea
              part="textarea"
              id="input"
              class="textarea__control"
              title=${this.title}
              name=${l$2(this.name)}
              .value=${l$1(this.value)}
              ?disabled=${this.disabled}
              ?readonly=${this.readonly}
              ?required=${this.required}
              placeholder=${l$2(this.placeholder)}
              rows=${l$2(this.rows)}
              minlength=${l$2(this.minlength)}
              maxlength=${l$2(this.maxlength)}
              autocapitalize=${l$2(this.autocapitalize)}
              autocorrect=${l$2(this.autocorrect)}
              ?autofocus=${this.autofocus}
              spellcheck=${l$2(this.spellcheck)}
              enterkeyhint=${l$2(this.enterkeyhint)}
              inputmode=${l$2(this.inputmode)}
              aria-describedby="help-text"
              @change=${this.handleChange}
              @input=${this.handleInput}
              @invalid=${this.handleInvalid}
              @focus=${this.handleFocus}
              @blur=${this.handleBlur}
            ></textarea>
          </div>
        </div>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </div>
    `;
  }
};
SlTextarea.styles = textarea_styles_default;
__decorateClass([
  i$7(".textarea__control")
], SlTextarea.prototype, "input", 2);
__decorateClass([
  t$7()
], SlTextarea.prototype, "hasFocus", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "title", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "name", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "value", 2);
__decorateClass([
  e$c({ reflect: true })
], SlTextarea.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTextarea.prototype, "filled", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "label", 2);
__decorateClass([
  e$c({ attribute: "help-text" })
], SlTextarea.prototype, "helpText", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "placeholder", 2);
__decorateClass([
  e$c({ type: Number })
], SlTextarea.prototype, "rows", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "resize", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTextarea.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTextarea.prototype, "readonly", 2);
__decorateClass([
  e$c({ reflect: true })
], SlTextarea.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTextarea.prototype, "required", 2);
__decorateClass([
  e$c({ type: Number })
], SlTextarea.prototype, "minlength", 2);
__decorateClass([
  e$c({ type: Number })
], SlTextarea.prototype, "maxlength", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "autocapitalize", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "autocorrect", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "autocomplete", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlTextarea.prototype, "autofocus", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "enterkeyhint", 2);
__decorateClass([
  e$c({
    type: Boolean,
    converter: {
      // Allow "true|false" attribute values but keep the property boolean
      fromAttribute: (value) => !value || value === "false" ? false : true,
      toAttribute: (value) => value ? "true" : "false"
    }
  })
], SlTextarea.prototype, "spellcheck", 2);
__decorateClass([
  e$c()
], SlTextarea.prototype, "inputmode", 2);
__decorateClass([
  defaultValue()
], SlTextarea.prototype, "defaultValue", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlTextarea.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("rows", { waitUntilFirstUpdate: true })
], SlTextarea.prototype, "handleRowsChange", 1);
__decorateClass([
  watch("value", { waitUntilFirstUpdate: true })
], SlTextarea.prototype, "handleValueChange", 1);

// src/components/textarea/textarea.ts
var textarea_default = SlTextarea;
SlTextarea.define("sl-textarea");

var tab_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }

  .tab {
    display: inline-flex;
    align-items: center;
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-small);
    font-weight: var(--sl-font-weight-semibold);
    border-radius: var(--sl-border-radius-medium);
    color: var(--sl-color-neutral-600);
    padding: var(--sl-spacing-medium) var(--sl-spacing-large);
    white-space: nowrap;
    user-select: none;
    cursor: pointer;
    transition: var(--transition-speed) box-shadow, var(--transition-speed) color;
  }

  .tab:hover:not(.tab--disabled) {
    color: var(--sl-color-primary-600);
  }

  .tab:focus {
    outline: none;
  }

  .tab:focus-visible:not(.tab--disabled) {
    color: var(--sl-color-primary-600);
  }

  .tab:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: calc(-1 * var(--sl-focus-ring-width) - var(--sl-focus-ring-offset));
  }

  .tab.tab--active:not(.tab--disabled) {
    color: var(--sl-color-primary-600);
  }

  .tab.tab--closable {
    padding-inline-end: var(--sl-spacing-small);
  }

  .tab.tab--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .tab__close-button {
    font-size: var(--sl-font-size-small);
    margin-inline-start: var(--sl-spacing-small);
  }

  .tab__close-button::part(base) {
    padding: var(--sl-spacing-3x-small);
  }

  @media (forced-colors: active) {
    .tab.tab--active:not(.tab--disabled) {
      outline: solid 1px transparent;
      outline-offset: -3px;
    }
  }
`;

var id$1 = 0;
var SlTab = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.attrId = ++id$1;
    this.componentId = `sl-tab-${this.attrId}`;
    this.panel = "";
    this.active = false;
    this.closable = false;
    this.disabled = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "tab");
  }
  handleCloseClick(event) {
    event.stopPropagation();
    this.emit("sl-close");
  }
  handleActiveChange() {
    this.setAttribute("aria-selected", this.active ? "true" : "false");
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  /** Sets focus to the tab. */
  focus(options) {
    this.tab.focus(options);
  }
  /** Removes focus from the tab. */
  blur() {
    this.tab.blur();
  }
  render() {
    this.id = this.id.length > 0 ? this.id : this.componentId;
    return x$1`
      <div
        part="base"
        class=${o$9({
      tab: true,
      "tab--active": this.active,
      "tab--closable": this.closable,
      "tab--disabled": this.disabled
    })}
        tabindex=${this.disabled ? "-1" : "0"}
      >
        <slot></slot>
        ${this.closable ? x$1`
              <sl-icon-button
                part="close-button"
                exportparts="base:close-button__base"
                name="x-lg"
                library="system"
                label=${this.localize.term("close")}
                class="tab__close-button"
                @click=${this.handleCloseClick}
                tabindex="-1"
              ></sl-icon-button>
            ` : ""}
      </div>
    `;
  }
};
SlTab.styles = tab_styles_default;
SlTab.dependencies = { "sl-icon-button": SlIconButton };
__decorateClass([
  i$7(".tab")
], SlTab.prototype, "tab", 2);
__decorateClass([
  e$c({ reflect: true })
], SlTab.prototype, "panel", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTab.prototype, "active", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlTab.prototype, "closable", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlTab.prototype, "disabled", 2);
__decorateClass([
  watch("active")
], SlTab.prototype, "handleActiveChange", 1);
__decorateClass([
  watch("disabled")
], SlTab.prototype, "handleDisabledChange", 1);

// src/components/tab/tab.ts
var tab_default = SlTab;
SlTab.define("sl-tab");

var tab_group_styles_default = i$b`
  ${component_styles_default}

  :host {
    --indicator-color: var(--sl-color-primary-600);
    --track-color: var(--sl-color-neutral-200);
    --track-width: 2px;

    display: block;
  }

  .tab-group {
    display: flex;
    border-radius: 0;
  }

  .tab-group__tabs {
    display: flex;
    position: relative;
  }

  .tab-group__indicator {
    position: absolute;
    transition: var(--sl-transition-fast) translate ease, var(--sl-transition-fast) width ease;
  }

  .tab-group--has-scroll-controls .tab-group__nav-container {
    position: relative;
    padding: 0 var(--sl-spacing-x-large);
  }

  .tab-group__body {
    display: block;
    overflow: auto;
  }

  .tab-group__scroll-button {
    display: flex;
    align-items: center;
    justify-content: center;
    position: absolute;
    top: 0;
    bottom: 0;
    width: var(--sl-spacing-x-large);
  }

  .tab-group__scroll-button--start {
    left: 0;
  }

  .tab-group__scroll-button--end {
    right: 0;
  }

  .tab-group--rtl .tab-group__scroll-button--start {
    left: auto;
    right: 0;
  }

  .tab-group--rtl .tab-group__scroll-button--end {
    left: 0;
    right: auto;
  }

  /*
   * Top
   */

  .tab-group--top {
    flex-direction: column;
  }

  .tab-group--top .tab-group__nav-container {
    order: 1;
  }

  .tab-group--top .tab-group__nav {
    display: flex;
    overflow-x: auto;

    /* Hide scrollbar in Firefox */
    scrollbar-width: none;
  }

  /* Hide scrollbar in Chrome/Safari */
  .tab-group--top .tab-group__nav::-webkit-scrollbar {
    width: 0;
    height: 0;
  }

  .tab-group--top .tab-group__tabs {
    flex: 1 1 auto;
    position: relative;
    flex-direction: row;
    border-bottom: solid var(--track-width) var(--track-color);
  }

  .tab-group--top .tab-group__indicator {
    bottom: calc(-1 * var(--track-width));
    border-bottom: solid var(--track-width) var(--indicator-color);
  }

  .tab-group--top .tab-group__body {
    order: 2;
  }

  .tab-group--top ::slotted(sl-tab-panel) {
    --padding: var(--sl-spacing-medium) 0;
  }

  /*
   * Bottom
   */

  .tab-group--bottom {
    flex-direction: column;
  }

  .tab-group--bottom .tab-group__nav-container {
    order: 2;
  }

  .tab-group--bottom .tab-group__nav {
    display: flex;
    overflow-x: auto;

    /* Hide scrollbar in Firefox */
    scrollbar-width: none;
  }

  /* Hide scrollbar in Chrome/Safari */
  .tab-group--bottom .tab-group__nav::-webkit-scrollbar {
    width: 0;
    height: 0;
  }

  .tab-group--bottom .tab-group__tabs {
    flex: 1 1 auto;
    position: relative;
    flex-direction: row;
    border-top: solid var(--track-width) var(--track-color);
  }

  .tab-group--bottom .tab-group__indicator {
    top: calc(-1 * var(--track-width));
    border-top: solid var(--track-width) var(--indicator-color);
  }

  .tab-group--bottom .tab-group__body {
    order: 1;
  }

  .tab-group--bottom ::slotted(sl-tab-panel) {
    --padding: var(--sl-spacing-medium) 0;
  }

  /*
   * Start
   */

  .tab-group--start {
    flex-direction: row;
  }

  .tab-group--start .tab-group__nav-container {
    order: 1;
  }

  .tab-group--start .tab-group__tabs {
    flex: 0 0 auto;
    flex-direction: column;
    border-inline-end: solid var(--track-width) var(--track-color);
  }

  .tab-group--start .tab-group__indicator {
    right: calc(-1 * var(--track-width));
    border-right: solid var(--track-width) var(--indicator-color);
  }

  .tab-group--start.tab-group--rtl .tab-group__indicator {
    right: auto;
    left: calc(-1 * var(--track-width));
  }

  .tab-group--start .tab-group__body {
    flex: 1 1 auto;
    order: 2;
  }

  .tab-group--start ::slotted(sl-tab-panel) {
    --padding: 0 var(--sl-spacing-medium);
  }

  /*
   * End
   */

  .tab-group--end {
    flex-direction: row;
  }

  .tab-group--end .tab-group__nav-container {
    order: 2;
  }

  .tab-group--end .tab-group__tabs {
    flex: 0 0 auto;
    flex-direction: column;
    border-left: solid var(--track-width) var(--track-color);
  }

  .tab-group--end .tab-group__indicator {
    left: calc(-1 * var(--track-width));
    border-inline-start: solid var(--track-width) var(--indicator-color);
  }

  .tab-group--end.tab-group--rtl .tab-group__indicator {
    right: calc(-1 * var(--track-width));
    left: auto;
  }

  .tab-group--end .tab-group__body {
    flex: 1 1 auto;
    order: 1;
  }

  .tab-group--end ::slotted(sl-tab-panel) {
    --padding: 0 var(--sl-spacing-medium);
  }
`;

// src/internal/offset.ts
function getOffset(element, parent) {
  return {
    top: Math.round(element.getBoundingClientRect().top - parent.getBoundingClientRect().top),
    left: Math.round(element.getBoundingClientRect().left - parent.getBoundingClientRect().left)
  };
}

// src/internal/scroll.ts
var locks = /* @__PURE__ */ new Set();
function getScrollbarWidth() {
  const documentWidth = document.documentElement.clientWidth;
  return Math.abs(window.innerWidth - documentWidth);
}
function lockBodyScrolling(lockingEl) {
  locks.add(lockingEl);
  if (!document.body.classList.contains("sl-scroll-lock")) {
    const scrollbarWidth = getScrollbarWidth();
    document.body.classList.add("sl-scroll-lock");
    document.body.style.setProperty("--sl-scroll-lock-size", `${scrollbarWidth}px`);
  }
}
function unlockBodyScrolling(lockingEl) {
  locks.delete(lockingEl);
  if (locks.size === 0) {
    document.body.classList.remove("sl-scroll-lock");
    document.body.style.removeProperty("--sl-scroll-lock-size");
  }
}
function scrollIntoView$1(element, container, direction = "vertical", behavior = "smooth") {
  const offset = getOffset(element, container);
  const offsetTop = offset.top + container.scrollTop;
  const offsetLeft = offset.left + container.scrollLeft;
  const minX = container.scrollLeft;
  const maxX = container.scrollLeft + container.offsetWidth;
  const minY = container.scrollTop;
  const maxY = container.scrollTop + container.offsetHeight;
  if (direction === "horizontal" || direction === "both") {
    if (offsetLeft < minX) {
      container.scrollTo({ left: offsetLeft, behavior });
    } else if (offsetLeft + element.clientWidth > maxX) {
      container.scrollTo({ left: offsetLeft - container.offsetWidth + element.clientWidth, behavior });
    }
  }
  if (direction === "vertical" || direction === "both") {
    if (offsetTop < minY) {
      container.scrollTo({ top: offsetTop, behavior });
    } else if (offsetTop + element.clientHeight > maxY) {
      container.scrollTo({ top: offsetTop - container.offsetHeight + element.clientHeight, behavior });
    }
  }
}

var SlTabGroup = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.tabs = [];
    this.panels = [];
    this.hasScrollControls = false;
    this.placement = "top";
    this.activation = "auto";
    this.noScrollControls = false;
  }
  connectedCallback() {
    const whenAllDefined = Promise.all([
      customElements.whenDefined("sl-tab"),
      customElements.whenDefined("sl-tab-panel")
    ]);
    super.connectedCallback();
    this.resizeObserver = new ResizeObserver(() => {
      this.repositionIndicator();
      this.updateScrollControls();
    });
    this.mutationObserver = new MutationObserver((mutations) => {
      if (mutations.some((m) => !["aria-labelledby", "aria-controls"].includes(m.attributeName))) {
        setTimeout(() => this.setAriaLabels());
      }
      if (mutations.some((m) => m.attributeName === "disabled")) {
        this.syncTabsAndPanels();
      }
    });
    this.updateComplete.then(() => {
      this.syncTabsAndPanels();
      this.mutationObserver.observe(this, { attributes: true, childList: true, subtree: true });
      this.resizeObserver.observe(this.nav);
      whenAllDefined.then(() => {
        const intersectionObserver = new IntersectionObserver((entries, observer) => {
          var _a;
          if (entries[0].intersectionRatio > 0) {
            this.setAriaLabels();
            this.setActiveTab((_a = this.getActiveTab()) != null ? _a : this.tabs[0], { emitEvents: false });
            observer.unobserve(entries[0].target);
          }
        });
        intersectionObserver.observe(this.tabGroup);
      });
    });
  }
  disconnectedCallback() {
    this.mutationObserver.disconnect();
    this.resizeObserver.unobserve(this.nav);
  }
  getAllTabs(options = { includeDisabled: true }) {
    const slot = this.shadowRoot.querySelector('slot[name="nav"]');
    return [...slot.assignedElements()].filter((el) => {
      return options.includeDisabled ? el.tagName.toLowerCase() === "sl-tab" : el.tagName.toLowerCase() === "sl-tab" && !el.disabled;
    });
  }
  getAllPanels() {
    return [...this.body.assignedElements()].filter((el) => el.tagName.toLowerCase() === "sl-tab-panel");
  }
  getActiveTab() {
    return this.tabs.find((el) => el.active);
  }
  handleClick(event) {
    const target = event.target;
    const tab = target.closest("sl-tab");
    const tabGroup = tab == null ? void 0 : tab.closest("sl-tab-group");
    if (tabGroup !== this) {
      return;
    }
    if (tab !== null) {
      this.setActiveTab(tab, { scrollBehavior: "smooth" });
    }
  }
  handleKeyDown(event) {
    const target = event.target;
    const tab = target.closest("sl-tab");
    const tabGroup = tab == null ? void 0 : tab.closest("sl-tab-group");
    if (tabGroup !== this) {
      return;
    }
    if (["Enter", " "].includes(event.key)) {
      if (tab !== null) {
        this.setActiveTab(tab, { scrollBehavior: "smooth" });
        event.preventDefault();
      }
    }
    if (["ArrowLeft", "ArrowRight", "ArrowUp", "ArrowDown", "Home", "End"].includes(event.key)) {
      const activeEl = this.tabs.find((t) => t.matches(":focus"));
      const isRtl = this.localize.dir() === "rtl";
      if ((activeEl == null ? void 0 : activeEl.tagName.toLowerCase()) === "sl-tab") {
        let index = this.tabs.indexOf(activeEl);
        if (event.key === "Home") {
          index = 0;
        } else if (event.key === "End") {
          index = this.tabs.length - 1;
        } else if (["top", "bottom"].includes(this.placement) && event.key === (isRtl ? "ArrowRight" : "ArrowLeft") || ["start", "end"].includes(this.placement) && event.key === "ArrowUp") {
          index--;
        } else if (["top", "bottom"].includes(this.placement) && event.key === (isRtl ? "ArrowLeft" : "ArrowRight") || ["start", "end"].includes(this.placement) && event.key === "ArrowDown") {
          index++;
        }
        if (index < 0) {
          index = this.tabs.length - 1;
        }
        if (index > this.tabs.length - 1) {
          index = 0;
        }
        this.tabs[index].focus({ preventScroll: true });
        if (this.activation === "auto") {
          this.setActiveTab(this.tabs[index], { scrollBehavior: "smooth" });
        }
        if (["top", "bottom"].includes(this.placement)) {
          scrollIntoView$1(this.tabs[index], this.nav, "horizontal");
        }
        event.preventDefault();
      }
    }
  }
  handleScrollToStart() {
    this.nav.scroll({
      left: this.localize.dir() === "rtl" ? this.nav.scrollLeft + this.nav.clientWidth : this.nav.scrollLeft - this.nav.clientWidth,
      behavior: "smooth"
    });
  }
  handleScrollToEnd() {
    this.nav.scroll({
      left: this.localize.dir() === "rtl" ? this.nav.scrollLeft - this.nav.clientWidth : this.nav.scrollLeft + this.nav.clientWidth,
      behavior: "smooth"
    });
  }
  setActiveTab(tab, options) {
    options = __spreadValues({
      emitEvents: true,
      scrollBehavior: "auto"
    }, options);
    if (tab !== this.activeTab && !tab.disabled) {
      const previousTab = this.activeTab;
      this.activeTab = tab;
      this.tabs.forEach((el) => el.active = el === this.activeTab);
      this.panels.forEach((el) => {
        var _a;
        return el.active = el.name === ((_a = this.activeTab) == null ? void 0 : _a.panel);
      });
      this.syncIndicator();
      if (["top", "bottom"].includes(this.placement)) {
        scrollIntoView$1(this.activeTab, this.nav, "horizontal", options.scrollBehavior);
      }
      if (options.emitEvents) {
        if (previousTab) {
          this.emit("sl-tab-hide", { detail: { name: previousTab.panel } });
        }
        this.emit("sl-tab-show", { detail: { name: this.activeTab.panel } });
      }
    }
  }
  setAriaLabels() {
    this.tabs.forEach((tab) => {
      const panel = this.panels.find((el) => el.name === tab.panel);
      if (panel) {
        tab.setAttribute("aria-controls", panel.getAttribute("id"));
        panel.setAttribute("aria-labelledby", tab.getAttribute("id"));
      }
    });
  }
  repositionIndicator() {
    const currentTab = this.getActiveTab();
    if (!currentTab) {
      return;
    }
    const width = currentTab.clientWidth;
    const height = currentTab.clientHeight;
    const isRtl = this.localize.dir() === "rtl";
    const allTabs = this.getAllTabs();
    const precedingTabs = allTabs.slice(0, allTabs.indexOf(currentTab));
    const offset = precedingTabs.reduce(
      (previous, current) => ({
        left: previous.left + current.clientWidth,
        top: previous.top + current.clientHeight
      }),
      { left: 0, top: 0 }
    );
    switch (this.placement) {
      case "top":
      case "bottom":
        this.indicator.style.width = `${width}px`;
        this.indicator.style.height = "auto";
        this.indicator.style.translate = isRtl ? `${-1 * offset.left}px` : `${offset.left}px`;
        break;
      case "start":
      case "end":
        this.indicator.style.width = "auto";
        this.indicator.style.height = `${height}px`;
        this.indicator.style.translate = `0 ${offset.top}px`;
        break;
    }
  }
  // This stores tabs and panels so we can refer to a cache instead of calling querySelectorAll() multiple times.
  syncTabsAndPanels() {
    this.tabs = this.getAllTabs({ includeDisabled: false });
    this.panels = this.getAllPanels();
    this.syncIndicator();
    this.updateComplete.then(() => this.updateScrollControls());
  }
  updateScrollControls() {
    if (this.noScrollControls) {
      this.hasScrollControls = false;
    } else {
      this.hasScrollControls = ["top", "bottom"].includes(this.placement) && this.nav.scrollWidth > this.nav.clientWidth;
    }
  }
  syncIndicator() {
    const tab = this.getActiveTab();
    if (tab) {
      this.indicator.style.display = "block";
      this.repositionIndicator();
    } else {
      this.indicator.style.display = "none";
    }
  }
  /** Shows the specified tab panel. */
  show(panel) {
    const tab = this.tabs.find((el) => el.panel === panel);
    if (tab) {
      this.setActiveTab(tab, { scrollBehavior: "smooth" });
    }
  }
  render() {
    const isRtl = this.localize.dir() === "rtl";
    return x$1`
      <div
        part="base"
        class=${o$9({
      "tab-group": true,
      "tab-group--top": this.placement === "top",
      "tab-group--bottom": this.placement === "bottom",
      "tab-group--start": this.placement === "start",
      "tab-group--end": this.placement === "end",
      "tab-group--rtl": this.localize.dir() === "rtl",
      "tab-group--has-scroll-controls": this.hasScrollControls
    })}
        @click=${this.handleClick}
        @keydown=${this.handleKeyDown}
      >
        <div class="tab-group__nav-container" part="nav">
          ${this.hasScrollControls ? x$1`
                <sl-icon-button
                  part="scroll-button scroll-button--start"
                  exportparts="base:scroll-button__base"
                  class="tab-group__scroll-button tab-group__scroll-button--start"
                  name=${isRtl ? "chevron-right" : "chevron-left"}
                  library="system"
                  label=${this.localize.term("scrollToStart")}
                  @click=${this.handleScrollToStart}
                ></sl-icon-button>
              ` : ""}

          <div class="tab-group__nav">
            <div part="tabs" class="tab-group__tabs" role="tablist">
              <div part="active-tab-indicator" class="tab-group__indicator"></div>
              <slot name="nav" @slotchange=${this.syncTabsAndPanels}></slot>
            </div>
          </div>

          ${this.hasScrollControls ? x$1`
                <sl-icon-button
                  part="scroll-button scroll-button--end"
                  exportparts="base:scroll-button__base"
                  class="tab-group__scroll-button tab-group__scroll-button--end"
                  name=${isRtl ? "chevron-left" : "chevron-right"}
                  library="system"
                  label=${this.localize.term("scrollToEnd")}
                  @click=${this.handleScrollToEnd}
                ></sl-icon-button>
              ` : ""}
        </div>

        <slot part="body" class="tab-group__body" @slotchange=${this.syncTabsAndPanels}></slot>
      </div>
    `;
  }
};
SlTabGroup.styles = tab_group_styles_default;
SlTabGroup.dependencies = { "sl-icon-button": SlIconButton };
__decorateClass([
  i$7(".tab-group")
], SlTabGroup.prototype, "tabGroup", 2);
__decorateClass([
  i$7(".tab-group__body")
], SlTabGroup.prototype, "body", 2);
__decorateClass([
  i$7(".tab-group__nav")
], SlTabGroup.prototype, "nav", 2);
__decorateClass([
  i$7(".tab-group__indicator")
], SlTabGroup.prototype, "indicator", 2);
__decorateClass([
  t$7()
], SlTabGroup.prototype, "hasScrollControls", 2);
__decorateClass([
  e$c()
], SlTabGroup.prototype, "placement", 2);
__decorateClass([
  e$c()
], SlTabGroup.prototype, "activation", 2);
__decorateClass([
  e$c({ attribute: "no-scroll-controls", type: Boolean })
], SlTabGroup.prototype, "noScrollControls", 2);
__decorateClass([
  watch("noScrollControls", { waitUntilFirstUpdate: true })
], SlTabGroup.prototype, "updateScrollControls", 1);
__decorateClass([
  watch("placement", { waitUntilFirstUpdate: true })
], SlTabGroup.prototype, "syncIndicator", 1);

// src/components/tab-group/tab-group.ts
var tab_group_default = SlTabGroup;
SlTabGroup.define("sl-tab-group");

var resize_observer_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: contents;
  }
`;

var SlResizeObserver = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.observedElements = [];
    this.disabled = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.resizeObserver = new ResizeObserver((entries) => {
      this.emit("sl-resize", { detail: { entries } });
    });
    if (!this.disabled) {
      this.startObserver();
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.stopObserver();
  }
  handleSlotChange() {
    if (!this.disabled) {
      this.startObserver();
    }
  }
  startObserver() {
    const slot = this.shadowRoot.querySelector("slot");
    if (slot !== null) {
      const elements = slot.assignedElements({ flatten: true });
      this.observedElements.forEach((el) => this.resizeObserver.unobserve(el));
      this.observedElements = [];
      elements.forEach((el) => {
        this.resizeObserver.observe(el);
        this.observedElements.push(el);
      });
    }
  }
  stopObserver() {
    this.resizeObserver.disconnect();
  }
  handleDisabledChange() {
    if (this.disabled) {
      this.stopObserver();
    } else {
      this.startObserver();
    }
  }
  render() {
    return x$1` <slot @slotchange=${this.handleSlotChange}></slot> `;
  }
};
SlResizeObserver.styles = resize_observer_styles_default;
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlResizeObserver.prototype, "disabled", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlResizeObserver.prototype, "handleDisabledChange", 1);

// src/components/resize-observer/resize-observer.ts
var resize_observer_default = SlResizeObserver;
SlResizeObserver.define("sl-resize-observer");

var split_panel_styles_default = i$b`
  ${component_styles_default}

  :host {
    --divider-width: 4px;
    --divider-hit-area: 12px;
    --min: 0%;
    --max: 100%;

    display: grid;
  }

  .start,
  .end {
    overflow: hidden;
  }

  .divider {
    flex: 0 0 var(--divider-width);
    display: flex;
    position: relative;
    align-items: center;
    justify-content: center;
    background-color: var(--sl-color-neutral-200);
    color: var(--sl-color-neutral-900);
    z-index: 1;
  }

  .divider:focus {
    outline: none;
  }

  :host(:not([disabled])) .divider:focus-visible {
    background-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
  }

  :host([disabled]) .divider {
    cursor: not-allowed;
  }

  /* Horizontal */
  :host(:not([vertical], [disabled])) .divider {
    cursor: col-resize;
  }

  :host(:not([vertical])) .divider::after {
    display: flex;
    content: '';
    position: absolute;
    height: 100%;
    left: calc(var(--divider-hit-area) / -2 + var(--divider-width) / 2);
    width: var(--divider-hit-area);
  }

  /* Vertical */
  :host([vertical]) {
    flex-direction: column;
  }

  :host([vertical]:not([disabled])) .divider {
    cursor: row-resize;
  }

  :host([vertical]) .divider::after {
    content: '';
    position: absolute;
    width: 100%;
    top: calc(var(--divider-hit-area) / -2 + var(--divider-width) / 2);
    height: var(--divider-hit-area);
  }

  @media (forced-colors: active) {
    .divider {
      outline: solid 1px transparent;
    }
  }
`;

// src/internal/drag.ts
function drag$1(container, options) {
  function move(pointerEvent) {
    const dims = container.getBoundingClientRect();
    const defaultView = container.ownerDocument.defaultView;
    const offsetX = dims.left + defaultView.pageXOffset;
    const offsetY = dims.top + defaultView.pageYOffset;
    const x = pointerEvent.pageX - offsetX;
    const y = pointerEvent.pageY - offsetY;
    if (options == null ? void 0 : options.onMove) {
      options.onMove(x, y);
    }
  }
  function stop() {
    document.removeEventListener("pointermove", move);
    document.removeEventListener("pointerup", stop);
    if (options == null ? void 0 : options.onStop) {
      options.onStop();
    }
  }
  document.addEventListener("pointermove", move, { passive: true });
  document.addEventListener("pointerup", stop);
  if ((options == null ? void 0 : options.initialEvent) instanceof PointerEvent) {
    move(options.initialEvent);
  }
}

var SlSplitPanel = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.position = 50;
    this.vertical = false;
    this.disabled = false;
    this.snapThreshold = 12;
  }
  connectedCallback() {
    super.connectedCallback();
    this.resizeObserver = new ResizeObserver((entries) => this.handleResize(entries));
    this.updateComplete.then(() => this.resizeObserver.observe(this));
    this.detectSize();
    this.cachedPositionInPixels = this.percentageToPixels(this.position);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.resizeObserver.unobserve(this);
  }
  detectSize() {
    const { width, height } = this.getBoundingClientRect();
    this.size = this.vertical ? height : width;
  }
  percentageToPixels(value) {
    return this.size * (value / 100);
  }
  pixelsToPercentage(value) {
    return value / this.size * 100;
  }
  handleDrag(event) {
    const isRtl = this.localize.dir() === "rtl";
    if (this.disabled) {
      return;
    }
    if (event.cancelable) {
      event.preventDefault();
    }
    drag$1(this, {
      onMove: (x, y) => {
        let newPositionInPixels = this.vertical ? y : x;
        if (this.primary === "end") {
          newPositionInPixels = this.size - newPositionInPixels;
        }
        if (this.snap) {
          const snaps = this.snap.split(" ");
          snaps.forEach((value) => {
            let snapPoint;
            if (value.endsWith("%")) {
              snapPoint = this.size * (parseFloat(value) / 100);
            } else {
              snapPoint = parseFloat(value);
            }
            if (isRtl && !this.vertical) {
              snapPoint = this.size - snapPoint;
            }
            if (newPositionInPixels >= snapPoint - this.snapThreshold && newPositionInPixels <= snapPoint + this.snapThreshold) {
              newPositionInPixels = snapPoint;
            }
          });
        }
        this.position = clamp$1(this.pixelsToPercentage(newPositionInPixels), 0, 100);
      },
      initialEvent: event
    });
  }
  handleKeyDown(event) {
    if (this.disabled) {
      return;
    }
    if (["ArrowLeft", "ArrowRight", "ArrowUp", "ArrowDown", "Home", "End"].includes(event.key)) {
      let newPosition = this.position;
      const incr = (event.shiftKey ? 10 : 1) * (this.primary === "end" ? -1 : 1);
      event.preventDefault();
      if (event.key === "ArrowLeft" && !this.vertical || event.key === "ArrowUp" && this.vertical) {
        newPosition -= incr;
      }
      if (event.key === "ArrowRight" && !this.vertical || event.key === "ArrowDown" && this.vertical) {
        newPosition += incr;
      }
      if (event.key === "Home") {
        newPosition = this.primary === "end" ? 100 : 0;
      }
      if (event.key === "End") {
        newPosition = this.primary === "end" ? 0 : 100;
      }
      this.position = clamp$1(newPosition, 0, 100);
    }
  }
  handleResize(entries) {
    const { width, height } = entries[0].contentRect;
    this.size = this.vertical ? height : width;
    if (this.primary) {
      this.position = this.pixelsToPercentage(this.cachedPositionInPixels);
    }
  }
  handlePositionChange() {
    this.cachedPositionInPixels = this.percentageToPixels(this.position);
    this.positionInPixels = this.percentageToPixels(this.position);
    this.emit("sl-reposition");
  }
  handlePositionInPixelsChange() {
    this.position = this.pixelsToPercentage(this.positionInPixels);
  }
  handleVerticalChange() {
    this.detectSize();
  }
  render() {
    const gridTemplate = this.vertical ? "gridTemplateRows" : "gridTemplateColumns";
    const gridTemplateAlt = this.vertical ? "gridTemplateColumns" : "gridTemplateRows";
    const isRtl = this.localize.dir() === "rtl";
    const primary = `
      clamp(
        0%,
        clamp(
          var(--min),
          ${this.position}% - var(--divider-width) / 2,
          var(--max)
        ),
        calc(100% - var(--divider-width))
      )
    `;
    const secondary = "auto";
    if (this.primary === "end") {
      if (isRtl && !this.vertical) {
        this.style[gridTemplate] = `${primary} var(--divider-width) ${secondary}`;
      } else {
        this.style[gridTemplate] = `${secondary} var(--divider-width) ${primary}`;
      }
    } else {
      if (isRtl && !this.vertical) {
        this.style[gridTemplate] = `${secondary} var(--divider-width) ${primary}`;
      } else {
        this.style[gridTemplate] = `${primary} var(--divider-width) ${secondary}`;
      }
    }
    this.style[gridTemplateAlt] = "";
    return x$1`
      <slot name="start" part="panel start" class="start"></slot>

      <div
        part="divider"
        class="divider"
        tabindex=${l$2(this.disabled ? void 0 : "0")}
        role="separator"
        aria-valuenow=${this.position}
        aria-valuemin="0"
        aria-valuemax="100"
        aria-label=${this.localize.term("resize")}
        @keydown=${this.handleKeyDown}
        @mousedown=${this.handleDrag}
        @touchstart=${this.handleDrag}
      >
        <slot name="divider"></slot>
      </div>

      <slot name="end" part="panel end" class="end"></slot>
    `;
  }
};
SlSplitPanel.styles = split_panel_styles_default;
__decorateClass([
  i$7(".divider")
], SlSplitPanel.prototype, "divider", 2);
__decorateClass([
  e$c({ type: Number, reflect: true })
], SlSplitPanel.prototype, "position", 2);
__decorateClass([
  e$c({ attribute: "position-in-pixels", type: Number })
], SlSplitPanel.prototype, "positionInPixels", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSplitPanel.prototype, "vertical", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSplitPanel.prototype, "disabled", 2);
__decorateClass([
  e$c()
], SlSplitPanel.prototype, "primary", 2);
__decorateClass([
  e$c()
], SlSplitPanel.prototype, "snap", 2);
__decorateClass([
  e$c({ type: Number, attribute: "snap-threshold" })
], SlSplitPanel.prototype, "snapThreshold", 2);
__decorateClass([
  watch("position")
], SlSplitPanel.prototype, "handlePositionChange", 1);
__decorateClass([
  watch("positionInPixels")
], SlSplitPanel.prototype, "handlePositionInPixelsChange", 1);
__decorateClass([
  watch("vertical")
], SlSplitPanel.prototype, "handleVerticalChange", 1);

// src/components/split-panel/split-panel.ts
var split_panel_default = SlSplitPanel;
SlSplitPanel.define("sl-split-panel");

var switch_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }

  :host([size='small']) {
    --height: var(--sl-toggle-size-small);
    --thumb-size: calc(var(--sl-toggle-size-small) + 4px);
    --width: calc(var(--height) * 2);

    font-size: var(--sl-input-font-size-small);
  }

  :host([size='medium']) {
    --height: var(--sl-toggle-size-medium);
    --thumb-size: calc(var(--sl-toggle-size-medium) + 4px);
    --width: calc(var(--height) * 2);

    font-size: var(--sl-input-font-size-medium);
  }

  :host([size='large']) {
    --height: var(--sl-toggle-size-large);
    --thumb-size: calc(var(--sl-toggle-size-large) + 4px);
    --width: calc(var(--height) * 2);

    font-size: var(--sl-input-font-size-large);
  }

  .switch {
    position: relative;
    display: inline-flex;
    align-items: center;
    font-family: var(--sl-input-font-family);
    font-size: inherit;
    font-weight: var(--sl-input-font-weight);
    color: var(--sl-input-label-color);
    vertical-align: middle;
    cursor: pointer;
  }

  .switch__control {
    flex: 0 0 auto;
    position: relative;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: var(--width);
    height: var(--height);
    background-color: var(--sl-color-neutral-400);
    border: solid var(--sl-input-border-width) var(--sl-color-neutral-400);
    border-radius: var(--height);
    transition: var(--sl-transition-fast) border-color, var(--sl-transition-fast) background-color;
  }

  .switch__control .switch__thumb {
    width: var(--thumb-size);
    height: var(--thumb-size);
    background-color: var(--sl-color-neutral-0);
    border-radius: 50%;
    border: solid var(--sl-input-border-width) var(--sl-color-neutral-400);
    translate: calc((var(--width) - var(--height)) / -2);
    transition: var(--sl-transition-fast) translate ease, var(--sl-transition-fast) background-color,
      var(--sl-transition-fast) border-color, var(--sl-transition-fast) box-shadow;
  }

  .switch__input {
    position: absolute;
    opacity: 0;
    padding: 0;
    margin: 0;
    pointer-events: none;
  }

  /* Hover */
  .switch:not(.switch--checked):not(.switch--disabled) .switch__control:hover {
    background-color: var(--sl-color-neutral-400);
    border-color: var(--sl-color-neutral-400);
  }

  .switch:not(.switch--checked):not(.switch--disabled) .switch__control:hover .switch__thumb {
    background-color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-neutral-400);
  }

  /* Focus */
  .switch:not(.switch--checked):not(.switch--disabled) .switch__input:focus-visible ~ .switch__control {
    background-color: var(--sl-color-neutral-400);
    border-color: var(--sl-color-neutral-400);
  }

  .switch:not(.switch--checked):not(.switch--disabled) .switch__input:focus-visible ~ .switch__control .switch__thumb {
    background-color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-primary-600);
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  /* Checked */
  .switch--checked .switch__control {
    background-color: var(--sl-color-primary-600);
    border-color: var(--sl-color-primary-600);
  }

  .switch--checked .switch__control .switch__thumb {
    background-color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-primary-600);
    translate: calc((var(--width) - var(--height)) / 2);
  }

  /* Checked + hover */
  .switch.switch--checked:not(.switch--disabled) .switch__control:hover {
    background-color: var(--sl-color-primary-600);
    border-color: var(--sl-color-primary-600);
  }

  .switch.switch--checked:not(.switch--disabled) .switch__control:hover .switch__thumb {
    background-color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-primary-600);
  }

  /* Checked + focus */
  .switch.switch--checked:not(.switch--disabled) .switch__input:focus-visible ~ .switch__control {
    background-color: var(--sl-color-primary-600);
    border-color: var(--sl-color-primary-600);
  }

  .switch.switch--checked:not(.switch--disabled) .switch__input:focus-visible ~ .switch__control .switch__thumb {
    background-color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-primary-600);
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  /* Disabled */
  .switch--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .switch__label {
    display: inline-block;
    line-height: var(--height);
    margin-inline-start: 0.5em;
    user-select: none;
  }

  :host([required]) .switch__label::after {
    content: var(--sl-input-required-content);
    margin-inline-start: var(--sl-input-required-content-offset);
  }

  @media (forced-colors: active) {
    .switch.switch--checked:not(.switch--disabled) .switch__control:hover .switch__thumb,
    .switch--checked .switch__control .switch__thumb {
      background-color: ButtonText;
    }
  }
`;

var SlSwitch = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      value: (control) => control.checked ? control.value || "on" : void 0,
      defaultValue: (control) => control.defaultChecked,
      setValue: (control, checked) => control.checked = checked
    });
    this.hasFocus = false;
    this.title = "";
    this.name = "";
    this.size = "medium";
    this.disabled = false;
    this.checked = false;
    this.defaultChecked = false;
    this.form = "";
    this.required = false;
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleInput() {
    this.emit("sl-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleClick() {
    this.checked = !this.checked;
    this.emit("sl-change");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleKeyDown(event) {
    if (event.key === "ArrowLeft") {
      event.preventDefault();
      this.checked = false;
      this.emit("sl-change");
      this.emit("sl-input");
    }
    if (event.key === "ArrowRight") {
      event.preventDefault();
      this.checked = true;
      this.emit("sl-change");
      this.emit("sl-input");
    }
  }
  handleCheckedChange() {
    this.input.checked = this.checked;
    this.formControlController.updateValidity();
  }
  handleDisabledChange() {
    this.formControlController.setValidity(true);
  }
  /** Simulates a click on the switch. */
  click() {
    this.input.click();
  }
  /** Sets focus on the switch. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the switch. */
  blur() {
    this.input.blur();
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    return x$1`
      <label
        part="base"
        class=${o$9({
      switch: true,
      "switch--checked": this.checked,
      "switch--disabled": this.disabled,
      "switch--focused": this.hasFocus,
      "switch--small": this.size === "small",
      "switch--medium": this.size === "medium",
      "switch--large": this.size === "large"
    })}
      >
        <input
          class="switch__input"
          type="checkbox"
          title=${this.title}
          name=${this.name}
          value=${l$2(this.value)}
          .checked=${l$1(this.checked)}
          .disabled=${this.disabled}
          .required=${this.required}
          role="switch"
          aria-checked=${this.checked ? "true" : "false"}
          @click=${this.handleClick}
          @input=${this.handleInput}
          @invalid=${this.handleInvalid}
          @blur=${this.handleBlur}
          @focus=${this.handleFocus}
          @keydown=${this.handleKeyDown}
        />

        <span part="control" class="switch__control">
          <span part="thumb" class="switch__thumb"></span>
        </span>

        <slot part="label" class="switch__label"></slot>
      </label>
    `;
  }
};
SlSwitch.styles = switch_styles_default;
__decorateClass([
  i$7('input[type="checkbox"]')
], SlSwitch.prototype, "input", 2);
__decorateClass([
  t$7()
], SlSwitch.prototype, "hasFocus", 2);
__decorateClass([
  e$c()
], SlSwitch.prototype, "title", 2);
__decorateClass([
  e$c()
], SlSwitch.prototype, "name", 2);
__decorateClass([
  e$c()
], SlSwitch.prototype, "value", 2);
__decorateClass([
  e$c({ reflect: true })
], SlSwitch.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSwitch.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSwitch.prototype, "checked", 2);
__decorateClass([
  defaultValue("checked")
], SlSwitch.prototype, "defaultChecked", 2);
__decorateClass([
  e$c({ reflect: true })
], SlSwitch.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSwitch.prototype, "required", 2);
__decorateClass([
  watch("checked", { waitUntilFirstUpdate: true })
], SlSwitch.prototype, "handleCheckedChange", 1);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlSwitch.prototype, "handleDisabledChange", 1);

// src/components/switch/switch.ts
var switch_default = SlSwitch;
SlSwitch.define("sl-switch");

var radio_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
  }

  :host(:focus-visible) {
    outline: 0px;
  }

  .radio {
    display: inline-flex;
    align-items: top;
    font-family: var(--sl-input-font-family);
    font-size: var(--sl-input-font-size-medium);
    font-weight: var(--sl-input-font-weight);
    color: var(--sl-input-label-color);
    vertical-align: middle;
    cursor: pointer;
  }

  .radio--small {
    --toggle-size: var(--sl-toggle-size-small);
    font-size: var(--sl-input-font-size-small);
  }

  .radio--medium {
    --toggle-size: var(--sl-toggle-size-medium);
    font-size: var(--sl-input-font-size-medium);
  }

  .radio--large {
    --toggle-size: var(--sl-toggle-size-large);
    font-size: var(--sl-input-font-size-large);
  }

  .radio__checked-icon {
    display: inline-flex;
    width: var(--toggle-size);
    height: var(--toggle-size);
  }

  .radio__control {
    flex: 0 0 auto;
    position: relative;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: var(--toggle-size);
    height: var(--toggle-size);
    border: solid var(--sl-input-border-width) var(--sl-input-border-color);
    border-radius: 50%;
    background-color: var(--sl-input-background-color);
    color: transparent;
    transition: var(--sl-transition-fast) border-color, var(--sl-transition-fast) background-color,
      var(--sl-transition-fast) color, var(--sl-transition-fast) box-shadow;
  }

  .radio__input {
    position: absolute;
    opacity: 0;
    padding: 0;
    margin: 0;
    pointer-events: none;
  }

  /* Hover */
  .radio:not(.radio--checked):not(.radio--disabled) .radio__control:hover {
    border-color: var(--sl-input-border-color-hover);
    background-color: var(--sl-input-background-color-hover);
  }

  /* Checked */
  .radio--checked .radio__control {
    color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-primary-600);
    background-color: var(--sl-color-primary-600);
  }

  /* Checked + hover */
  .radio.radio--checked:not(.radio--disabled) .radio__control:hover {
    border-color: var(--sl-color-primary-500);
    background-color: var(--sl-color-primary-500);
  }

  /* Checked + focus */
  :host(:focus-visible) .radio__control {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  /* Disabled */
  .radio--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  /* When the control isn't checked, hide the circle for Windows High Contrast mode a11y */
  .radio:not(.radio--checked) svg circle {
    opacity: 0;
  }

  .radio__label {
    display: inline-block;
    color: var(--sl-input-label-color);
    line-height: var(--toggle-size);
    margin-inline-start: 0.5em;
    user-select: none;
  }
`;

var SlRadio = class extends ShoelaceElement {
  constructor() {
    super();
    this.checked = false;
    this.hasFocus = false;
    this.size = "medium";
    this.disabled = false;
    this.handleBlur = () => {
      this.hasFocus = false;
      this.emit("sl-blur");
    };
    this.handleClick = () => {
      if (!this.disabled) {
        this.checked = true;
      }
    };
    this.handleFocus = () => {
      this.hasFocus = true;
      this.emit("sl-focus");
    };
    this.addEventListener("blur", this.handleBlur);
    this.addEventListener("click", this.handleClick);
    this.addEventListener("focus", this.handleFocus);
  }
  connectedCallback() {
    super.connectedCallback();
    this.setInitialAttributes();
  }
  setInitialAttributes() {
    this.setAttribute("role", "radio");
    this.setAttribute("tabindex", "-1");
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  handleCheckedChange() {
    this.setAttribute("aria-checked", this.checked ? "true" : "false");
    this.setAttribute("tabindex", this.checked ? "0" : "-1");
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  render() {
    return x$1`
      <span
        part="base"
        class=${o$9({
      radio: true,
      "radio--checked": this.checked,
      "radio--disabled": this.disabled,
      "radio--focused": this.hasFocus,
      "radio--small": this.size === "small",
      "radio--medium": this.size === "medium",
      "radio--large": this.size === "large"
    })}
      >
        <span part="${`control${this.checked ? " control--checked" : ""}`}" class="radio__control">
          ${this.checked ? x$1` <sl-icon part="checked-icon" class="radio__checked-icon" library="system" name="radio"></sl-icon> ` : ""}
        </span>

        <slot part="label" class="radio__label"></slot>
      </span>
    `;
  }
};
SlRadio.styles = radio_styles_default;
SlRadio.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  t$7()
], SlRadio.prototype, "checked", 2);
__decorateClass([
  t$7()
], SlRadio.prototype, "hasFocus", 2);
__decorateClass([
  e$c()
], SlRadio.prototype, "value", 2);
__decorateClass([
  e$c({ reflect: true })
], SlRadio.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRadio.prototype, "disabled", 2);
__decorateClass([
  watch("checked")
], SlRadio.prototype, "handleCheckedChange", 1);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlRadio.prototype, "handleDisabledChange", 1);

// src/components/radio/radio.ts
var radio_default = SlRadio;
SlRadio.define("sl-radio");

var skeleton_styles_default = i$b`
  ${component_styles_default}

  :host {
    --border-radius: var(--sl-border-radius-pill);
    --color: var(--sl-color-neutral-200);
    --sheen-color: var(--sl-color-neutral-300);

    display: block;
    position: relative;
  }

  .skeleton {
    display: flex;
    width: 100%;
    height: 100%;
    min-height: 1rem;
  }

  .skeleton__indicator {
    flex: 1 1 auto;
    background: var(--color);
    border-radius: var(--border-radius);
  }

  .skeleton--sheen .skeleton__indicator {
    background: linear-gradient(270deg, var(--sheen-color), var(--color), var(--color), var(--sheen-color));
    background-size: 400% 100%;
    background-size: 400% 100%;
    animation: sheen 8s ease-in-out infinite;
  }

  .skeleton--pulse .skeleton__indicator {
    animation: pulse 2s ease-in-out 0.5s infinite;
  }

  /* Forced colors mode */
  @media (forced-colors: active) {
    :host {
      --color: GrayText;
    }
  }

  @keyframes sheen {
    0% {
      background-position: 200% 0;
    }
    to {
      background-position: -200% 0;
    }
  }

  @keyframes pulse {
    0% {
      opacity: 1;
    }
    50% {
      opacity: 0.4;
    }
    100% {
      opacity: 1;
    }
  }
`;

var SlSkeleton = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.effect = "none";
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      skeleton: true,
      "skeleton--pulse": this.effect === "pulse",
      "skeleton--sheen": this.effect === "sheen"
    })}
      >
        <div part="indicator" class="skeleton__indicator"></div>
      </div>
    `;
  }
};
SlSkeleton.styles = skeleton_styles_default;
__decorateClass([
  e$c()
], SlSkeleton.prototype, "effect", 2);

// src/components/skeleton/skeleton.ts
var skeleton_default = SlSkeleton;
SlSkeleton.define("sl-skeleton");

// src/components/spinner/spinner.ts
var spinner_default = SlSpinner;
SlSpinner.define("sl-spinner");

var rating_styles_default = i$b`
  ${component_styles_default}

  :host {
    --symbol-color: var(--sl-color-neutral-300);
    --symbol-color-active: var(--sl-color-amber-500);
    --symbol-size: 1.2rem;
    --symbol-spacing: var(--sl-spacing-3x-small);

    display: inline-flex;
  }

  .rating {
    position: relative;
    display: inline-flex;
    border-radius: var(--sl-border-radius-medium);
    vertical-align: middle;
  }

  .rating:focus {
    outline: none;
  }

  .rating:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .rating__symbols {
    display: inline-flex;
    position: relative;
    font-size: var(--symbol-size);
    line-height: 0;
    color: var(--symbol-color);
    white-space: nowrap;
    cursor: pointer;
  }

  .rating__symbols > * {
    padding: var(--symbol-spacing);
  }

  .rating__symbol--active,
  .rating__partial--filled {
    color: var(--symbol-color-active);
  }

  .rating__partial-symbol-container {
    position: relative;
  }

  .rating__partial--filled {
    position: absolute;
    top: var(--symbol-spacing);
    left: var(--symbol-spacing);
  }

  .rating__symbol {
    transition: var(--sl-transition-fast) scale;
  }

  .rating__symbol--hover {
    scale: 1.2;
  }

  .rating--disabled .rating__symbols,
  .rating--readonly .rating__symbols {
    cursor: default;
  }

  .rating--disabled .rating__symbol--hover,
  .rating--readonly .rating__symbol--hover {
    scale: none;
  }

  .rating--disabled {
    opacity: 0.5;
  }

  .rating--disabled .rating__symbols {
    cursor: not-allowed;
  }

  /* Forced colors mode */
  @media (forced-colors: active) {
    .rating__symbol--active {
      color: SelectedItem;
    }
  }
`;

var SlRating = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.hoverValue = 0;
    this.isHovering = false;
    this.label = "";
    this.value = 0;
    this.max = 5;
    this.precision = 1;
    this.readonly = false;
    this.disabled = false;
    this.getSymbol = () => '<sl-icon name="star-fill" library="system"></sl-icon>';
  }
  getValueFromMousePosition(event) {
    return this.getValueFromXCoordinate(event.clientX);
  }
  getValueFromTouchPosition(event) {
    return this.getValueFromXCoordinate(event.touches[0].clientX);
  }
  getValueFromXCoordinate(coordinate) {
    const isRtl = this.localize.dir() === "rtl";
    const { left, right, width } = this.rating.getBoundingClientRect();
    const value = isRtl ? this.roundToPrecision((right - coordinate) / width * this.max, this.precision) : this.roundToPrecision((coordinate - left) / width * this.max, this.precision);
    return clamp$1(value, 0, this.max);
  }
  handleClick(event) {
    if (this.disabled) {
      return;
    }
    this.setValue(this.getValueFromMousePosition(event));
    this.emit("sl-change");
  }
  setValue(newValue) {
    if (this.disabled || this.readonly) {
      return;
    }
    this.value = newValue === this.value ? 0 : newValue;
    this.isHovering = false;
  }
  handleKeyDown(event) {
    const isLtr = this.localize.dir() === "ltr";
    const isRtl = this.localize.dir() === "rtl";
    const oldValue = this.value;
    if (this.disabled || this.readonly) {
      return;
    }
    if (event.key === "ArrowDown" || isLtr && event.key === "ArrowLeft" || isRtl && event.key === "ArrowRight") {
      const decrement = event.shiftKey ? 1 : this.precision;
      this.value = Math.max(0, this.value - decrement);
      event.preventDefault();
    }
    if (event.key === "ArrowUp" || isLtr && event.key === "ArrowRight" || isRtl && event.key === "ArrowLeft") {
      const increment = event.shiftKey ? 1 : this.precision;
      this.value = Math.min(this.max, this.value + increment);
      event.preventDefault();
    }
    if (event.key === "Home") {
      this.value = 0;
      event.preventDefault();
    }
    if (event.key === "End") {
      this.value = this.max;
      event.preventDefault();
    }
    if (this.value !== oldValue) {
      this.emit("sl-change");
    }
  }
  handleMouseEnter(event) {
    this.isHovering = true;
    this.hoverValue = this.getValueFromMousePosition(event);
  }
  handleMouseMove(event) {
    this.hoverValue = this.getValueFromMousePosition(event);
  }
  handleMouseLeave() {
    this.isHovering = false;
  }
  handleTouchStart(event) {
    this.isHovering = true;
    this.hoverValue = this.getValueFromTouchPosition(event);
    event.preventDefault();
  }
  handleTouchMove(event) {
    this.hoverValue = this.getValueFromTouchPosition(event);
  }
  handleTouchEnd(event) {
    this.isHovering = false;
    this.setValue(this.hoverValue);
    this.emit("sl-change");
    event.preventDefault();
  }
  roundToPrecision(numberToRound, precision = 0.5) {
    const multiplier = 1 / precision;
    return Math.ceil(numberToRound * multiplier) / multiplier;
  }
  handleHoverValueChange() {
    this.emit("sl-hover", {
      detail: {
        phase: "move",
        value: this.hoverValue
      }
    });
  }
  handleIsHoveringChange() {
    this.emit("sl-hover", {
      detail: {
        phase: this.isHovering ? "start" : "end",
        value: this.hoverValue
      }
    });
  }
  /** Sets focus on the rating. */
  focus(options) {
    this.rating.focus(options);
  }
  /** Removes focus from the rating. */
  blur() {
    this.rating.blur();
  }
  render() {
    const isRtl = this.localize.dir() === "rtl";
    const counter = Array.from(Array(this.max).keys());
    let displayValue = 0;
    if (this.disabled || this.readonly) {
      displayValue = this.value;
    } else {
      displayValue = this.isHovering ? this.hoverValue : this.value;
    }
    return x$1`
      <div
        part="base"
        class=${o$9({
      rating: true,
      "rating--readonly": this.readonly,
      "rating--disabled": this.disabled,
      "rating--rtl": isRtl
    })}
        role="slider"
        aria-label=${this.label}
        aria-disabled=${this.disabled ? "true" : "false"}
        aria-readonly=${this.readonly ? "true" : "false"}
        aria-valuenow=${this.value}
        aria-valuemin=${0}
        aria-valuemax=${this.max}
        tabindex=${this.disabled ? "-1" : "0"}
        @click=${this.handleClick}
        @keydown=${this.handleKeyDown}
        @mouseenter=${this.handleMouseEnter}
        @touchstart=${this.handleTouchStart}
        @mouseleave=${this.handleMouseLeave}
        @touchend=${this.handleTouchEnd}
        @mousemove=${this.handleMouseMove}
        @touchmove=${this.handleTouchMove}
      >
        <span class="rating__symbols">
          ${counter.map((index) => {
      if (displayValue > index && displayValue < index + 1) {
        return x$1`
                <span
                  class=${o$9({
          rating__symbol: true,
          "rating__partial-symbol-container": true,
          "rating__symbol--hover": this.isHovering && Math.ceil(displayValue) === index + 1
        })}
                  role="presentation"
                  @mouseenter=${this.handleMouseEnter}
                >
                  <div
                    style=${o$7({
          clipPath: isRtl ? `inset(0 ${(displayValue - index) * 100}% 0 0)` : `inset(0 0 0 ${(displayValue - index) * 100}%)`
        })}
                  >
                    ${o$5(this.getSymbol(index + 1))}
                  </div>
                  <div
                    class="rating__partial--filled"
                    style=${o$7({
          clipPath: isRtl ? `inset(0 0 0 ${100 - (displayValue - index) * 100}%)` : `inset(0 ${100 - (displayValue - index) * 100}% 0 0)`
        })}
                  >
                    ${o$5(this.getSymbol(index + 1))}
                  </div>
                </span>
              `;
      }
      return x$1`
              <span
                class=${o$9({
        rating__symbol: true,
        "rating__symbol--hover": this.isHovering && Math.ceil(displayValue) === index + 1,
        "rating__symbol--active": displayValue >= index + 1
      })}
                role="presentation"
                @mouseenter=${this.handleMouseEnter}
              >
                ${o$5(this.getSymbol(index + 1))}
              </span>
            `;
    })}
        </span>
      </div>
    `;
  }
};
SlRating.styles = rating_styles_default;
SlRating.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7(".rating")
], SlRating.prototype, "rating", 2);
__decorateClass([
  t$7()
], SlRating.prototype, "hoverValue", 2);
__decorateClass([
  t$7()
], SlRating.prototype, "isHovering", 2);
__decorateClass([
  e$c()
], SlRating.prototype, "label", 2);
__decorateClass([
  e$c({ type: Number })
], SlRating.prototype, "value", 2);
__decorateClass([
  e$c({ type: Number })
], SlRating.prototype, "max", 2);
__decorateClass([
  e$c({ type: Number })
], SlRating.prototype, "precision", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRating.prototype, "readonly", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRating.prototype, "disabled", 2);
__decorateClass([
  e$c()
], SlRating.prototype, "getSymbol", 2);
__decorateClass([
  e$a({ passive: true })
], SlRating.prototype, "handleTouchMove", 1);
__decorateClass([
  watch("hoverValue")
], SlRating.prototype, "handleHoverValueChange", 1);
__decorateClass([
  watch("isHovering")
], SlRating.prototype, "handleIsHoveringChange", 1);

// src/components/rating/rating.ts
var rating_default = SlRating;
SlRating.define("sl-rating");

var availableUnits = [
  { max: 276e4, value: 6e4, unit: "minute" },
  // max 46 minutes
  { max: 72e6, value: 36e5, unit: "hour" },
  // max 20 hours
  { max: 5184e5, value: 864e5, unit: "day" },
  // max 6 days
  { max: 24192e5, value: 6048e5, unit: "week" },
  // max 28 days
  { max: 28512e6, value: 2592e6, unit: "month" },
  // max 11 months
  { max: Infinity, value: 31536e6, unit: "year" }
];
var SlRelativeTime = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.isoTime = "";
    this.relativeTime = "";
    this.titleTime = "";
    this.date = /* @__PURE__ */ new Date();
    this.format = "long";
    this.numeric = "auto";
    this.sync = false;
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    clearTimeout(this.updateTimeout);
  }
  render() {
    const now = /* @__PURE__ */ new Date();
    const then = new Date(this.date);
    if (isNaN(then.getMilliseconds())) {
      this.relativeTime = "";
      this.isoTime = "";
      return "";
    }
    const diff = then.getTime() - now.getTime();
    const { unit, value } = availableUnits.find((singleUnit) => Math.abs(diff) < singleUnit.max);
    this.isoTime = then.toISOString();
    this.titleTime = this.localize.date(then, {
      month: "long",
      year: "numeric",
      day: "numeric",
      hour: "numeric",
      minute: "numeric",
      timeZoneName: "short"
    });
    this.relativeTime = this.localize.relativeTime(Math.round(diff / value), unit, {
      numeric: this.numeric,
      style: this.format
    });
    clearTimeout(this.updateTimeout);
    if (this.sync) {
      let nextInterval;
      if (unit === "minute") {
        nextInterval = getTimeUntilNextUnit("second");
      } else if (unit === "hour") {
        nextInterval = getTimeUntilNextUnit("minute");
      } else if (unit === "day") {
        nextInterval = getTimeUntilNextUnit("hour");
      } else {
        nextInterval = getTimeUntilNextUnit("day");
      }
      this.updateTimeout = window.setTimeout(() => this.requestUpdate(), nextInterval);
    }
    return x$1` <time datetime=${this.isoTime} title=${this.titleTime}>${this.relativeTime}</time> `;
  }
};
__decorateClass([
  t$7()
], SlRelativeTime.prototype, "isoTime", 2);
__decorateClass([
  t$7()
], SlRelativeTime.prototype, "relativeTime", 2);
__decorateClass([
  t$7()
], SlRelativeTime.prototype, "titleTime", 2);
__decorateClass([
  e$c()
], SlRelativeTime.prototype, "date", 2);
__decorateClass([
  e$c()
], SlRelativeTime.prototype, "format", 2);
__decorateClass([
  e$c()
], SlRelativeTime.prototype, "numeric", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlRelativeTime.prototype, "sync", 2);
function getTimeUntilNextUnit(unit) {
  const units = { second: 1e3, minute: 6e4, hour: 36e5, day: 864e5 };
  const value = units[unit];
  return value - Date.now() % value;
}

// src/components/relative-time/relative-time.ts
var relative_time_default = SlRelativeTime;
SlRelativeTime.define("sl-relative-time");

var select_styles_default = i$b`
  ${component_styles_default}
  ${form_control_styles_default}

  :host {
    display: block;
  }

  /** The popup */
  .select {
    flex: 1 1 auto;
    display: inline-flex;
    width: 100%;
    position: relative;
    vertical-align: middle;
  }

  .select::part(popup) {
    z-index: var(--sl-z-index-dropdown);
  }

  .select[data-current-placement^='top']::part(popup) {
    transform-origin: bottom;
  }

  .select[data-current-placement^='bottom']::part(popup) {
    transform-origin: top;
  }

  /* Combobox */
  .select__combobox {
    flex: 1;
    display: flex;
    width: 100%;
    min-width: 0;
    position: relative;
    align-items: center;
    justify-content: start;
    font-family: var(--sl-input-font-family);
    font-weight: var(--sl-input-font-weight);
    letter-spacing: var(--sl-input-letter-spacing);
    vertical-align: middle;
    overflow: hidden;
    cursor: pointer;
    transition: var(--sl-transition-fast) color, var(--sl-transition-fast) border, var(--sl-transition-fast) box-shadow,
      var(--sl-transition-fast) background-color;
  }

  .select__display-input {
    position: relative;
    width: 100%;
    font: inherit;
    border: none;
    background: none;
    color: var(--sl-input-color);
    cursor: inherit;
    overflow: hidden;
    padding: 0;
    margin: 0;
    -webkit-appearance: none;
  }

  .select:not(.select--disabled):hover .select__display-input {
    color: var(--sl-input-color-hover);
  }

  .select__display-input:focus {
    outline: none;
  }

  /* Visually hide the display input when multiple is enabled */
  .select--multiple:not(.select--placeholder-visible) .select__display-input {
    position: absolute;
    z-index: -1;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    opacity: 0;
  }

  .select__value-input {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    padding: 0;
    margin: 0;
    opacity: 0;
    z-index: -1;
  }

  .select__tags {
    display: flex;
    flex: 1;
    align-items: center;
    flex-wrap: wrap;
    margin-inline-start: var(--sl-spacing-2x-small);
  }

  .select__tags::slotted(sl-tag) {
    cursor: pointer !important;
  }

  .select--disabled .select__tags,
  .select--disabled .select__tags::slotted(sl-tag) {
    cursor: not-allowed !important;
  }

  /* Standard selects */
  .select--standard .select__combobox {
    background-color: var(--sl-input-background-color);
    border: solid var(--sl-input-border-width) var(--sl-input-border-color);
  }

  .select--standard.select--disabled .select__combobox {
    background-color: var(--sl-input-background-color-disabled);
    border-color: var(--sl-input-border-color-disabled);
    color: var(--sl-input-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
    outline: none;
  }

  .select--standard:not(.select--disabled).select--open .select__combobox,
  .select--standard:not(.select--disabled).select--focused .select__combobox {
    background-color: var(--sl-input-background-color-focus);
    border-color: var(--sl-input-border-color-focus);
    box-shadow: 0 0 0 var(--sl-focus-ring-width) var(--sl-input-focus-ring-color);
  }

  /* Filled selects */
  .select--filled .select__combobox {
    border: none;
    background-color: var(--sl-input-filled-background-color);
    color: var(--sl-input-color);
  }

  .select--filled:hover:not(.select--disabled) .select__combobox {
    background-color: var(--sl-input-filled-background-color-hover);
  }

  .select--filled.select--disabled .select__combobox {
    background-color: var(--sl-input-filled-background-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
  }

  .select--filled:not(.select--disabled).select--open .select__combobox,
  .select--filled:not(.select--disabled).select--focused .select__combobox {
    background-color: var(--sl-input-filled-background-color-focus);
    outline: var(--sl-focus-ring);
  }

  /* Sizes */
  .select--small .select__combobox {
    border-radius: var(--sl-input-border-radius-small);
    font-size: var(--sl-input-font-size-small);
    min-height: var(--sl-input-height-small);
    padding-block: 0;
    padding-inline: var(--sl-input-spacing-small);
  }

  .select--small .select__clear {
    margin-inline-start: var(--sl-input-spacing-small);
  }

  .select--small .select__prefix::slotted(*) {
    margin-inline-end: var(--sl-input-spacing-small);
  }

  .select--small.select--multiple:not(.select--placeholder-visible) .select__combobox {
    padding-block: 2px;
    padding-inline-start: 0;
  }

  .select--small .select__tags {
    gap: 2px;
  }

  .select--medium .select__combobox {
    border-radius: var(--sl-input-border-radius-medium);
    font-size: var(--sl-input-font-size-medium);
    min-height: var(--sl-input-height-medium);
    padding-block: 0;
    padding-inline: var(--sl-input-spacing-medium);
  }

  .select--medium .select__clear {
    margin-inline-start: var(--sl-input-spacing-medium);
  }

  .select--medium .select__prefix::slotted(*) {
    margin-inline-end: var(--sl-input-spacing-medium);
  }

  .select--medium.select--multiple:not(.select--placeholder-visible) .select__combobox {
    padding-inline-start: 0;
    padding-block: 3px;
  }

  .select--medium .select__tags {
    gap: 3px;
  }

  .select--large .select__combobox {
    border-radius: var(--sl-input-border-radius-large);
    font-size: var(--sl-input-font-size-large);
    min-height: var(--sl-input-height-large);
    padding-block: 0;
    padding-inline: var(--sl-input-spacing-large);
  }

  .select--large .select__clear {
    margin-inline-start: var(--sl-input-spacing-large);
  }

  .select--large .select__prefix::slotted(*) {
    margin-inline-end: var(--sl-input-spacing-large);
  }

  .select--large.select--multiple:not(.select--placeholder-visible) .select__combobox {
    padding-inline-start: 0;
    padding-block: 4px;
  }

  .select--large .select__tags {
    gap: 4px;
  }

  /* Pills */
  .select--pill.select--small .select__combobox {
    border-radius: var(--sl-input-height-small);
  }

  .select--pill.select--medium .select__combobox {
    border-radius: var(--sl-input-height-medium);
  }

  .select--pill.select--large .select__combobox {
    border-radius: var(--sl-input-height-large);
  }

  /* Prefix */
  .select__prefix {
    flex: 0;
    display: inline-flex;
    align-items: center;
    color: var(--sl-input-placeholder-color);
  }

  /* Clear button */
  .select__clear {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    font-size: inherit;
    color: var(--sl-input-icon-color);
    border: none;
    background: none;
    padding: 0;
    transition: var(--sl-transition-fast) color;
    cursor: pointer;
  }

  .select__clear:hover {
    color: var(--sl-input-icon-color-hover);
  }

  .select__clear:focus {
    outline: none;
  }

  /* Expand icon */
  .select__expand-icon {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    transition: var(--sl-transition-medium) rotate ease;
    rotate: 0;
    margin-inline-start: var(--sl-spacing-small);
  }

  .select--open .select__expand-icon {
    rotate: -180deg;
  }

  /* Listbox */
  .select__listbox {
    display: block;
    position: relative;
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-medium);
    font-weight: var(--sl-font-weight-normal);
    box-shadow: var(--sl-shadow-large);
    background: var(--sl-panel-background-color);
    border: solid var(--sl-panel-border-width) var(--sl-panel-border-color);
    border-radius: var(--sl-border-radius-medium);
    padding-block: var(--sl-spacing-x-small);
    padding-inline: 0;
    overflow: auto;
    overscroll-behavior: none;

    /* Make sure it adheres to the popup's auto size */
    max-width: var(--auto-size-available-width);
    max-height: var(--auto-size-available-height);
  }

  .select__listbox ::slotted(sl-divider) {
    --spacing: var(--sl-spacing-x-small);
  }

  .select__listbox ::slotted(small) {
    font-size: var(--sl-font-size-small);
    font-weight: var(--sl-font-weight-semibold);
    color: var(--sl-color-neutral-500);
    padding-block: var(--sl-spacing-x-small);
    padding-inline: var(--sl-spacing-x-large);
  }
`;

var SlSelect = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      assumeInteractionOn: ["sl-blur", "sl-input"]
    });
    this.hasSlotController = new HasSlotController$1(this, "help-text", "label");
    this.localize = new LocalizeController(this);
    this.typeToSelectString = "";
    this.hasFocus = false;
    this.displayLabel = "";
    this.selectedOptions = [];
    this.name = "";
    this.value = "";
    this.defaultValue = "";
    this.size = "medium";
    this.placeholder = "";
    this.multiple = false;
    this.maxOptionsVisible = 3;
    this.disabled = false;
    this.clearable = false;
    this.open = false;
    this.hoist = false;
    this.filled = false;
    this.pill = false;
    this.label = "";
    this.placement = "bottom";
    this.helpText = "";
    this.form = "";
    this.required = false;
    this.getTag = (option) => {
      return x$1`
      <sl-tag
        part="tag"
        exportparts="
              base:tag__base,
              content:tag__content,
              remove-button:tag__remove-button,
              remove-button__base:tag__remove-button__base
            "
        ?pill=${this.pill}
        size=${this.size}
        removable
        @sl-remove=${(event) => this.handleTagRemove(event, option)}
      >
        ${option.getTextLabel()}
      </sl-tag>
    `;
    };
    this.handleDocumentFocusIn = (event) => {
      const path = event.composedPath();
      if (this && !path.includes(this)) {
        this.hide();
      }
    };
    this.handleDocumentKeyDown = (event) => {
      const target = event.target;
      const isClearButton = target.closest(".select__clear") !== null;
      const isIconButton = target.closest("sl-icon-button") !== null;
      if (isClearButton || isIconButton) {
        return;
      }
      if (event.key === "Escape" && this.open) {
        event.preventDefault();
        event.stopPropagation();
        this.hide();
        this.displayInput.focus({ preventScroll: true });
      }
      if (event.key === "Enter" || event.key === " " && this.typeToSelectString === "") {
        event.preventDefault();
        event.stopImmediatePropagation();
        if (!this.open) {
          this.show();
          return;
        }
        if (this.currentOption && !this.currentOption.disabled) {
          if (this.multiple) {
            this.toggleOptionSelection(this.currentOption);
          } else {
            this.setSelectedOptions(this.currentOption);
          }
          this.updateComplete.then(() => {
            this.emit("sl-input");
            this.emit("sl-change");
          });
          if (!this.multiple) {
            this.hide();
            this.displayInput.focus({ preventScroll: true });
          }
        }
        return;
      }
      if (["ArrowUp", "ArrowDown", "Home", "End"].includes(event.key)) {
        const allOptions = this.getAllOptions();
        const currentIndex = allOptions.indexOf(this.currentOption);
        let newIndex = Math.max(0, currentIndex);
        event.preventDefault();
        if (!this.open) {
          this.show();
          if (this.currentOption) {
            return;
          }
        }
        if (event.key === "ArrowDown") {
          newIndex = currentIndex + 1;
          if (newIndex > allOptions.length - 1)
            newIndex = 0;
        } else if (event.key === "ArrowUp") {
          newIndex = currentIndex - 1;
          if (newIndex < 0)
            newIndex = allOptions.length - 1;
        } else if (event.key === "Home") {
          newIndex = 0;
        } else if (event.key === "End") {
          newIndex = allOptions.length - 1;
        }
        this.setCurrentOption(allOptions[newIndex]);
      }
      if (event.key.length === 1 || event.key === "Backspace") {
        const allOptions = this.getAllOptions();
        if (event.metaKey || event.ctrlKey || event.altKey) {
          return;
        }
        if (!this.open) {
          if (event.key === "Backspace") {
            return;
          }
          this.show();
        }
        event.stopPropagation();
        event.preventDefault();
        clearTimeout(this.typeToSelectTimeout);
        this.typeToSelectTimeout = window.setTimeout(() => this.typeToSelectString = "", 1e3);
        if (event.key === "Backspace") {
          this.typeToSelectString = this.typeToSelectString.slice(0, -1);
        } else {
          this.typeToSelectString += event.key.toLowerCase();
        }
        for (const option of allOptions) {
          const label = option.getTextLabel().toLowerCase();
          if (label.startsWith(this.typeToSelectString)) {
            this.setCurrentOption(option);
            break;
          }
        }
      }
    };
    this.handleDocumentMouseDown = (event) => {
      const path = event.composedPath();
      if (this && !path.includes(this)) {
        this.hide();
      }
    };
  }
  /** Gets the validity state object */
  get validity() {
    return this.valueInput.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.valueInput.validationMessage;
  }
  connectedCallback() {
    super.connectedCallback();
    this.open = false;
  }
  addOpenListeners() {
    document.addEventListener("focusin", this.handleDocumentFocusIn);
    document.addEventListener("keydown", this.handleDocumentKeyDown);
    document.addEventListener("mousedown", this.handleDocumentMouseDown);
  }
  removeOpenListeners() {
    document.removeEventListener("focusin", this.handleDocumentFocusIn);
    document.removeEventListener("keydown", this.handleDocumentKeyDown);
    document.removeEventListener("mousedown", this.handleDocumentMouseDown);
  }
  handleFocus() {
    this.hasFocus = true;
    this.displayInput.setSelectionRange(0, 0);
    this.emit("sl-focus");
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleLabelClick() {
    this.displayInput.focus();
  }
  handleComboboxMouseDown(event) {
    const path = event.composedPath();
    const isIconButton = path.some((el) => el instanceof Element && el.tagName.toLowerCase() === "sl-icon-button");
    if (this.disabled || isIconButton) {
      return;
    }
    event.preventDefault();
    this.displayInput.focus({ preventScroll: true });
    this.open = !this.open;
  }
  handleComboboxKeyDown(event) {
    event.stopPropagation();
    this.handleDocumentKeyDown(event);
  }
  handleClearClick(event) {
    event.stopPropagation();
    if (this.value !== "") {
      this.setSelectedOptions([]);
      this.displayInput.focus({ preventScroll: true });
      this.updateComplete.then(() => {
        this.emit("sl-clear");
        this.emit("sl-input");
        this.emit("sl-change");
      });
    }
  }
  handleClearMouseDown(event) {
    event.stopPropagation();
    event.preventDefault();
  }
  handleOptionClick(event) {
    const target = event.target;
    const option = target.closest("sl-option");
    const oldValue = this.value;
    if (option && !option.disabled) {
      if (this.multiple) {
        this.toggleOptionSelection(option);
      } else {
        this.setSelectedOptions(option);
      }
      this.updateComplete.then(() => this.displayInput.focus({ preventScroll: true }));
      if (this.value !== oldValue) {
        this.updateComplete.then(() => {
          this.emit("sl-input");
          this.emit("sl-change");
        });
      }
      if (!this.multiple) {
        this.hide();
        this.displayInput.focus({ preventScroll: true });
      }
    }
  }
  handleDefaultSlotChange() {
    const allOptions = this.getAllOptions();
    const value = Array.isArray(this.value) ? this.value : [this.value];
    const values = [];
    if (customElements.get("sl-option")) {
      allOptions.forEach((option) => values.push(option.value));
      this.setSelectedOptions(allOptions.filter((el) => value.includes(el.value)));
    } else {
      customElements.whenDefined("sl-option").then(() => this.handleDefaultSlotChange());
    }
  }
  handleTagRemove(event, option) {
    event.stopPropagation();
    if (!this.disabled) {
      this.toggleOptionSelection(option, false);
      this.updateComplete.then(() => {
        this.emit("sl-input");
        this.emit("sl-change");
      });
    }
  }
  // Gets an array of all <sl-option> elements
  getAllOptions() {
    return [...this.querySelectorAll("sl-option")];
  }
  // Gets the first <sl-option> element
  getFirstOption() {
    return this.querySelector("sl-option");
  }
  // Sets the current option, which is the option the user is currently interacting with (e.g. via keyboard). Only one
  // option may be "current" at a time.
  setCurrentOption(option) {
    const allOptions = this.getAllOptions();
    allOptions.forEach((el) => {
      el.current = false;
      el.tabIndex = -1;
    });
    if (option) {
      this.currentOption = option;
      option.current = true;
      option.tabIndex = 0;
      option.focus();
    }
  }
  // Sets the selected option(s)
  setSelectedOptions(option) {
    const allOptions = this.getAllOptions();
    const newSelectedOptions = Array.isArray(option) ? option : [option];
    allOptions.forEach((el) => el.selected = false);
    if (newSelectedOptions.length) {
      newSelectedOptions.forEach((el) => el.selected = true);
    }
    this.selectionChanged();
  }
  // Toggles an option's selected state
  toggleOptionSelection(option, force) {
    if (force === true || force === false) {
      option.selected = force;
    } else {
      option.selected = !option.selected;
    }
    this.selectionChanged();
  }
  // This method must be called whenever the selection changes. It will update the selected options cache, the current
  // value, and the display value
  selectionChanged() {
    var _a, _b, _c, _d;
    this.selectedOptions = this.getAllOptions().filter((el) => el.selected);
    if (this.multiple) {
      this.value = this.selectedOptions.map((el) => el.value);
      if (this.placeholder && this.value.length === 0) {
        this.displayLabel = "";
      } else {
        this.displayLabel = this.localize.term("numOptionsSelected", this.selectedOptions.length);
      }
    } else {
      this.value = (_b = (_a = this.selectedOptions[0]) == null ? void 0 : _a.value) != null ? _b : "";
      this.displayLabel = (_d = (_c = this.selectedOptions[0]) == null ? void 0 : _c.getTextLabel()) != null ? _d : "";
    }
    this.updateComplete.then(() => {
      this.formControlController.updateValidity();
    });
  }
  get tags() {
    return this.selectedOptions.map((option, index) => {
      if (index < this.maxOptionsVisible || this.maxOptionsVisible <= 0) {
        const tag = this.getTag(option, index);
        return x$1`<div @sl-remove=${(e) => this.handleTagRemove(e, option)}>
          ${typeof tag === "string" ? o$5(tag) : tag}
        </div>`;
      } else if (index === this.maxOptionsVisible) {
        return x$1`<sl-tag>+${this.selectedOptions.length - index}</sl-tag>`;
      }
      return x$1``;
    });
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleDisabledChange() {
    if (this.disabled) {
      this.open = false;
      this.handleOpenChange();
    }
  }
  handleValueChange() {
    const allOptions = this.getAllOptions();
    const value = Array.isArray(this.value) ? this.value : [this.value];
    this.setSelectedOptions(allOptions.filter((el) => value.includes(el.value)));
  }
  async handleOpenChange() {
    if (this.open && !this.disabled) {
      this.setCurrentOption(this.selectedOptions[0] || this.getFirstOption());
      this.emit("sl-show");
      this.addOpenListeners();
      await stopAnimations(this);
      this.listbox.hidden = false;
      this.popup.active = true;
      requestAnimationFrame(() => {
        this.setCurrentOption(this.currentOption);
      });
      const { keyframes, options } = getAnimation(this, "select.show", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      if (this.currentOption) {
        scrollIntoView$1(this.currentOption, this.listbox, "vertical", "auto");
      }
      this.emit("sl-after-show");
    } else {
      this.emit("sl-hide");
      this.removeOpenListeners();
      await stopAnimations(this);
      const { keyframes, options } = getAnimation(this, "select.hide", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      this.listbox.hidden = true;
      this.popup.active = false;
      this.emit("sl-after-hide");
    }
  }
  /** Shows the listbox. */
  async show() {
    if (this.open || this.disabled) {
      this.open = false;
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the listbox. */
  async hide() {
    if (!this.open || this.disabled) {
      this.open = false;
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.valueInput.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.valueInput.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.valueInput.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  /** Sets focus on the control. */
  focus(options) {
    this.displayInput.focus(options);
  }
  /** Removes focus from the control. */
  blur() {
    this.displayInput.blur();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    const hasClearIcon = this.clearable && !this.disabled && this.value.length > 0;
    const isPlaceholderVisible = this.placeholder && this.value.length === 0;
    return x$1`
      <div
        part="form-control"
        class=${o$9({
      "form-control": true,
      "form-control--small": this.size === "small",
      "form-control--medium": this.size === "medium",
      "form-control--large": this.size === "large",
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText
    })}
      >
        <label
          id="label"
          part="form-control-label"
          class="form-control__label"
          aria-hidden=${hasLabel ? "false" : "true"}
          @click=${this.handleLabelClick}
        >
          <slot name="label">${this.label}</slot>
        </label>

        <div part="form-control-input" class="form-control-input">
          <sl-popup
            class=${o$9({
      select: true,
      "select--standard": true,
      "select--filled": this.filled,
      "select--pill": this.pill,
      "select--open": this.open,
      "select--disabled": this.disabled,
      "select--multiple": this.multiple,
      "select--focused": this.hasFocus,
      "select--placeholder-visible": isPlaceholderVisible,
      "select--top": this.placement === "top",
      "select--bottom": this.placement === "bottom",
      "select--small": this.size === "small",
      "select--medium": this.size === "medium",
      "select--large": this.size === "large"
    })}
            placement=${this.placement}
            strategy=${this.hoist ? "fixed" : "absolute"}
            flip
            shift
            sync="width"
            auto-size="vertical"
            auto-size-padding="10"
          >
            <div
              part="combobox"
              class="select__combobox"
              slot="anchor"
              @keydown=${this.handleComboboxKeyDown}
              @mousedown=${this.handleComboboxMouseDown}
            >
              <slot part="prefix" name="prefix" class="select__prefix"></slot>

              <input
                part="display-input"
                class="select__display-input"
                type="text"
                placeholder=${this.placeholder}
                .disabled=${this.disabled}
                .value=${this.displayLabel}
                autocomplete="off"
                spellcheck="false"
                autocapitalize="off"
                readonly
                aria-controls="listbox"
                aria-expanded=${this.open ? "true" : "false"}
                aria-haspopup="listbox"
                aria-labelledby="label"
                aria-disabled=${this.disabled ? "true" : "false"}
                aria-describedby="help-text"
                role="combobox"
                tabindex="0"
                @focus=${this.handleFocus}
                @blur=${this.handleBlur}
              />

              ${this.multiple ? x$1`<div part="tags" class="select__tags">${this.tags}</div>` : ""}

              <input
                class="select__value-input"
                type="text"
                ?disabled=${this.disabled}
                ?required=${this.required}
                .value=${Array.isArray(this.value) ? this.value.join(", ") : this.value}
                tabindex="-1"
                aria-hidden="true"
                @focus=${() => this.focus()}
                @invalid=${this.handleInvalid}
              />

              ${hasClearIcon ? x$1`
                    <button
                      part="clear-button"
                      class="select__clear"
                      type="button"
                      aria-label=${this.localize.term("clearEntry")}
                      @mousedown=${this.handleClearMouseDown}
                      @click=${this.handleClearClick}
                      tabindex="-1"
                    >
                      <slot name="clear-icon">
                        <sl-icon name="x-circle-fill" library="system"></sl-icon>
                      </slot>
                    </button>
                  ` : ""}

              <slot name="expand-icon" part="expand-icon" class="select__expand-icon">
                <sl-icon library="system" name="chevron-down"></sl-icon>
              </slot>
            </div>

            <div
              id="listbox"
              role="listbox"
              aria-expanded=${this.open ? "true" : "false"}
              aria-multiselectable=${this.multiple ? "true" : "false"}
              aria-labelledby="label"
              part="listbox"
              class="select__listbox"
              tabindex="-1"
              @mouseup=${this.handleOptionClick}
              @slotchange=${this.handleDefaultSlotChange}
            >
              <slot></slot>
            </div>
          </sl-popup>
        </div>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </div>
    `;
  }
};
SlSelect.styles = select_styles_default;
SlSelect.dependencies = {
  "sl-icon": SlIcon,
  "sl-popup": SlPopup,
  "sl-tag": SlTag
};
__decorateClass([
  i$7(".select")
], SlSelect.prototype, "popup", 2);
__decorateClass([
  i$7(".select__combobox")
], SlSelect.prototype, "combobox", 2);
__decorateClass([
  i$7(".select__display-input")
], SlSelect.prototype, "displayInput", 2);
__decorateClass([
  i$7(".select__value-input")
], SlSelect.prototype, "valueInput", 2);
__decorateClass([
  i$7(".select__listbox")
], SlSelect.prototype, "listbox", 2);
__decorateClass([
  t$7()
], SlSelect.prototype, "hasFocus", 2);
__decorateClass([
  t$7()
], SlSelect.prototype, "displayLabel", 2);
__decorateClass([
  t$7()
], SlSelect.prototype, "currentOption", 2);
__decorateClass([
  t$7()
], SlSelect.prototype, "selectedOptions", 2);
__decorateClass([
  e$c()
], SlSelect.prototype, "name", 2);
__decorateClass([
  e$c({
    converter: {
      fromAttribute: (value) => value.split(" "),
      toAttribute: (value) => value.join(" ")
    }
  })
], SlSelect.prototype, "value", 2);
__decorateClass([
  defaultValue()
], SlSelect.prototype, "defaultValue", 2);
__decorateClass([
  e$c({ reflect: true })
], SlSelect.prototype, "size", 2);
__decorateClass([
  e$c()
], SlSelect.prototype, "placeholder", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSelect.prototype, "multiple", 2);
__decorateClass([
  e$c({ attribute: "max-options-visible", type: Number })
], SlSelect.prototype, "maxOptionsVisible", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSelect.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlSelect.prototype, "clearable", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSelect.prototype, "open", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlSelect.prototype, "hoist", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSelect.prototype, "filled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSelect.prototype, "pill", 2);
__decorateClass([
  e$c()
], SlSelect.prototype, "label", 2);
__decorateClass([
  e$c({ reflect: true })
], SlSelect.prototype, "placement", 2);
__decorateClass([
  e$c({ attribute: "help-text" })
], SlSelect.prototype, "helpText", 2);
__decorateClass([
  e$c({ reflect: true })
], SlSelect.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlSelect.prototype, "required", 2);
__decorateClass([
  e$c()
], SlSelect.prototype, "getTag", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlSelect.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("value", { waitUntilFirstUpdate: true })
], SlSelect.prototype, "handleValueChange", 1);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlSelect.prototype, "handleOpenChange", 1);
setDefaultAnimation("select.show", {
  keyframes: [
    { opacity: 0, scale: 0.9 },
    { opacity: 1, scale: 1 }
  ],
  options: { duration: 100, easing: "ease" }
});
setDefaultAnimation("select.hide", {
  keyframes: [
    { opacity: 1, scale: 1 },
    { opacity: 0, scale: 0.9 }
  ],
  options: { duration: 100, easing: "ease" }
});

// src/components/select/select.ts
var select_default = SlSelect;
SlSelect.define("sl-select");

var button_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
    position: relative;
    width: auto;
    cursor: pointer;
  }

  .button {
    display: inline-flex;
    align-items: stretch;
    justify-content: center;
    width: 100%;
    border-style: solid;
    border-width: var(--sl-input-border-width);
    font-family: var(--sl-input-font-family);
    font-weight: var(--sl-font-weight-semibold);
    text-decoration: none;
    user-select: none;
    white-space: nowrap;
    vertical-align: middle;
    padding: 0;
    transition: var(--sl-transition-x-fast) background-color, var(--sl-transition-x-fast) color,
      var(--sl-transition-x-fast) border, var(--sl-transition-x-fast) box-shadow;
    cursor: inherit;
  }

  .button::-moz-focus-inner {
    border: 0;
  }

  .button:focus {
    outline: none;
  }

  .button:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .button--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  /* When disabled, prevent mouse events from bubbling up from children */
  .button--disabled * {
    pointer-events: none;
  }

  .button__prefix,
  .button__suffix {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    pointer-events: none;
  }

  .button__label {
    display: inline-block;
  }

  .button__label::slotted(sl-icon) {
    vertical-align: -2px;
  }

  /*
   * Standard buttons
   */

  /* Default */
  .button--standard.button--default {
    background-color: var(--sl-color-neutral-0);
    border-color: var(--sl-color-neutral-300);
    color: var(--sl-color-neutral-700);
  }

  .button--standard.button--default:hover:not(.button--disabled) {
    background-color: var(--sl-color-primary-50);
    border-color: var(--sl-color-primary-300);
    color: var(--sl-color-primary-700);
  }

  .button--standard.button--default:active:not(.button--disabled) {
    background-color: var(--sl-color-primary-100);
    border-color: var(--sl-color-primary-400);
    color: var(--sl-color-primary-700);
  }

  /* Primary */
  .button--standard.button--primary {
    background-color: var(--sl-color-primary-600);
    border-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--primary:hover:not(.button--disabled) {
    background-color: var(--sl-color-primary-500);
    border-color: var(--sl-color-primary-500);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--primary:active:not(.button--disabled) {
    background-color: var(--sl-color-primary-600);
    border-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
  }

  /* Success */
  .button--standard.button--success {
    background-color: var(--sl-color-success-600);
    border-color: var(--sl-color-success-600);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--success:hover:not(.button--disabled) {
    background-color: var(--sl-color-success-500);
    border-color: var(--sl-color-success-500);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--success:active:not(.button--disabled) {
    background-color: var(--sl-color-success-600);
    border-color: var(--sl-color-success-600);
    color: var(--sl-color-neutral-0);
  }

  /* Neutral */
  .button--standard.button--neutral {
    background-color: var(--sl-color-neutral-600);
    border-color: var(--sl-color-neutral-600);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--neutral:hover:not(.button--disabled) {
    background-color: var(--sl-color-neutral-500);
    border-color: var(--sl-color-neutral-500);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--neutral:active:not(.button--disabled) {
    background-color: var(--sl-color-neutral-600);
    border-color: var(--sl-color-neutral-600);
    color: var(--sl-color-neutral-0);
  }

  /* Warning */
  .button--standard.button--warning {
    background-color: var(--sl-color-warning-600);
    border-color: var(--sl-color-warning-600);
    color: var(--sl-color-neutral-0);
  }
  .button--standard.button--warning:hover:not(.button--disabled) {
    background-color: var(--sl-color-warning-500);
    border-color: var(--sl-color-warning-500);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--warning:active:not(.button--disabled) {
    background-color: var(--sl-color-warning-600);
    border-color: var(--sl-color-warning-600);
    color: var(--sl-color-neutral-0);
  }

  /* Danger */
  .button--standard.button--danger {
    background-color: var(--sl-color-danger-600);
    border-color: var(--sl-color-danger-600);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--danger:hover:not(.button--disabled) {
    background-color: var(--sl-color-danger-500);
    border-color: var(--sl-color-danger-500);
    color: var(--sl-color-neutral-0);
  }

  .button--standard.button--danger:active:not(.button--disabled) {
    background-color: var(--sl-color-danger-600);
    border-color: var(--sl-color-danger-600);
    color: var(--sl-color-neutral-0);
  }

  /*
   * Outline buttons
   */

  .button--outline {
    background: none;
    border: solid 1px;
  }

  /* Default */
  .button--outline.button--default {
    border-color: var(--sl-color-neutral-300);
    color: var(--sl-color-neutral-700);
  }

  .button--outline.button--default:hover:not(.button--disabled),
  .button--outline.button--default.button--checked:not(.button--disabled) {
    border-color: var(--sl-color-primary-600);
    background-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
  }

  .button--outline.button--default:active:not(.button--disabled) {
    border-color: var(--sl-color-primary-700);
    background-color: var(--sl-color-primary-700);
    color: var(--sl-color-neutral-0);
  }

  /* Primary */
  .button--outline.button--primary {
    border-color: var(--sl-color-primary-600);
    color: var(--sl-color-primary-600);
  }

  .button--outline.button--primary:hover:not(.button--disabled),
  .button--outline.button--primary.button--checked:not(.button--disabled) {
    background-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
  }

  .button--outline.button--primary:active:not(.button--disabled) {
    border-color: var(--sl-color-primary-700);
    background-color: var(--sl-color-primary-700);
    color: var(--sl-color-neutral-0);
  }

  /* Success */
  .button--outline.button--success {
    border-color: var(--sl-color-success-600);
    color: var(--sl-color-success-600);
  }

  .button--outline.button--success:hover:not(.button--disabled),
  .button--outline.button--success.button--checked:not(.button--disabled) {
    background-color: var(--sl-color-success-600);
    color: var(--sl-color-neutral-0);
  }

  .button--outline.button--success:active:not(.button--disabled) {
    border-color: var(--sl-color-success-700);
    background-color: var(--sl-color-success-700);
    color: var(--sl-color-neutral-0);
  }

  /* Neutral */
  .button--outline.button--neutral {
    border-color: var(--sl-color-neutral-600);
    color: var(--sl-color-neutral-600);
  }

  .button--outline.button--neutral:hover:not(.button--disabled),
  .button--outline.button--neutral.button--checked:not(.button--disabled) {
    background-color: var(--sl-color-neutral-600);
    color: var(--sl-color-neutral-0);
  }

  .button--outline.button--neutral:active:not(.button--disabled) {
    border-color: var(--sl-color-neutral-700);
    background-color: var(--sl-color-neutral-700);
    color: var(--sl-color-neutral-0);
  }

  /* Warning */
  .button--outline.button--warning {
    border-color: var(--sl-color-warning-600);
    color: var(--sl-color-warning-600);
  }

  .button--outline.button--warning:hover:not(.button--disabled),
  .button--outline.button--warning.button--checked:not(.button--disabled) {
    background-color: var(--sl-color-warning-600);
    color: var(--sl-color-neutral-0);
  }

  .button--outline.button--warning:active:not(.button--disabled) {
    border-color: var(--sl-color-warning-700);
    background-color: var(--sl-color-warning-700);
    color: var(--sl-color-neutral-0);
  }

  /* Danger */
  .button--outline.button--danger {
    border-color: var(--sl-color-danger-600);
    color: var(--sl-color-danger-600);
  }

  .button--outline.button--danger:hover:not(.button--disabled),
  .button--outline.button--danger.button--checked:not(.button--disabled) {
    background-color: var(--sl-color-danger-600);
    color: var(--sl-color-neutral-0);
  }

  .button--outline.button--danger:active:not(.button--disabled) {
    border-color: var(--sl-color-danger-700);
    background-color: var(--sl-color-danger-700);
    color: var(--sl-color-neutral-0);
  }

  @media (forced-colors: active) {
    .button.button--outline.button--checked:not(.button--disabled) {
      outline: solid 2px transparent;
    }
  }

  /*
   * Text buttons
   */

  .button--text {
    background-color: transparent;
    border-color: transparent;
    color: var(--sl-color-primary-600);
  }

  .button--text:hover:not(.button--disabled) {
    background-color: transparent;
    border-color: transparent;
    color: var(--sl-color-primary-500);
  }

  .button--text:focus-visible:not(.button--disabled) {
    background-color: transparent;
    border-color: transparent;
    color: var(--sl-color-primary-500);
  }

  .button--text:active:not(.button--disabled) {
    background-color: transparent;
    border-color: transparent;
    color: var(--sl-color-primary-700);
  }

  /*
   * Size modifiers
   */

  .button--small {
    height: auto;
    min-height: var(--sl-input-height-small);
    font-size: var(--sl-button-font-size-small);
    line-height: calc(var(--sl-input-height-small) - var(--sl-input-border-width) * 2);
    border-radius: var(--sl-input-border-radius-small);
  }

  .button--medium {
    height: auto;
    min-height: var(--sl-input-height-medium);
    font-size: var(--sl-button-font-size-medium);
    line-height: calc(var(--sl-input-height-medium) - var(--sl-input-border-width) * 2);
    border-radius: var(--sl-input-border-radius-medium);
  }

  .button--large {
    height: auto;
    min-height: var(--sl-input-height-large);
    font-size: var(--sl-button-font-size-large);
    line-height: calc(var(--sl-input-height-large) - var(--sl-input-border-width) * 2);
    border-radius: var(--sl-input-border-radius-large);
  }

  /*
   * Pill modifier
   */

  .button--pill.button--small {
    border-radius: var(--sl-input-height-small);
  }

  .button--pill.button--medium {
    border-radius: var(--sl-input-height-medium);
  }

  .button--pill.button--large {
    border-radius: var(--sl-input-height-large);
  }

  /*
   * Circle modifier
   */

  .button--circle {
    padding-left: 0;
    padding-right: 0;
  }

  .button--circle.button--small {
    width: var(--sl-input-height-small);
    border-radius: 50%;
  }

  .button--circle.button--medium {
    width: var(--sl-input-height-medium);
    border-radius: 50%;
  }

  .button--circle.button--large {
    width: var(--sl-input-height-large);
    border-radius: 50%;
  }

  .button--circle .button__prefix,
  .button--circle .button__suffix,
  .button--circle .button__caret {
    display: none;
  }

  /*
   * Caret modifier
   */

  .button--caret .button__suffix {
    display: none;
  }

  .button--caret .button__caret {
    height: auto;
  }

  /*
   * Loading modifier
   */

  .button--loading {
    position: relative;
    cursor: wait;
  }

  .button--loading .button__prefix,
  .button--loading .button__label,
  .button--loading .button__suffix,
  .button--loading .button__caret {
    visibility: hidden;
  }

  .button--loading sl-spinner {
    --indicator-color: currentColor;
    position: absolute;
    font-size: 1em;
    height: 1em;
    width: 1em;
    top: calc(50% - 0.5em);
    left: calc(50% - 0.5em);
  }

  /*
   * Badges
   */

  .button ::slotted(sl-badge) {
    position: absolute;
    top: 0;
    right: 0;
    translate: 50% -50%;
    pointer-events: none;
  }

  .button--rtl ::slotted(sl-badge) {
    right: auto;
    left: 0;
    translate: -50% -50%;
  }

  /*
   * Button spacing
   */

  .button--has-label.button--small .button__label {
    padding: 0 var(--sl-spacing-small);
  }

  .button--has-label.button--medium .button__label {
    padding: 0 var(--sl-spacing-medium);
  }

  .button--has-label.button--large .button__label {
    padding: 0 var(--sl-spacing-large);
  }

  .button--has-prefix.button--small {
    padding-inline-start: var(--sl-spacing-x-small);
  }

  .button--has-prefix.button--small .button__label {
    padding-inline-start: var(--sl-spacing-x-small);
  }

  .button--has-prefix.button--medium {
    padding-inline-start: var(--sl-spacing-small);
  }

  .button--has-prefix.button--medium .button__label {
    padding-inline-start: var(--sl-spacing-small);
  }

  .button--has-prefix.button--large {
    padding-inline-start: var(--sl-spacing-small);
  }

  .button--has-prefix.button--large .button__label {
    padding-inline-start: var(--sl-spacing-small);
  }

  .button--has-suffix.button--small,
  .button--caret.button--small {
    padding-inline-end: var(--sl-spacing-x-small);
  }

  .button--has-suffix.button--small .button__label,
  .button--caret.button--small .button__label {
    padding-inline-end: var(--sl-spacing-x-small);
  }

  .button--has-suffix.button--medium,
  .button--caret.button--medium {
    padding-inline-end: var(--sl-spacing-small);
  }

  .button--has-suffix.button--medium .button__label,
  .button--caret.button--medium .button__label {
    padding-inline-end: var(--sl-spacing-small);
  }

  .button--has-suffix.button--large,
  .button--caret.button--large {
    padding-inline-end: var(--sl-spacing-small);
  }

  .button--has-suffix.button--large .button__label,
  .button--caret.button--large .button__label {
    padding-inline-end: var(--sl-spacing-small);
  }

  /*
   * Button groups support a variety of button types (e.g. buttons with tooltips, buttons as dropdown triggers, etc.).
   * This means buttons aren't always direct descendants of the button group, thus we can't target them with the
   * ::slotted selector. To work around this, the button group component does some magic to add these special classes to
   * buttons and we style them here instead.
   */

  :host(.sl-button-group__button--first:not(.sl-button-group__button--last)) .button {
    border-start-end-radius: 0;
    border-end-end-radius: 0;
  }

  :host(.sl-button-group__button--inner) .button {
    border-radius: 0;
  }

  :host(.sl-button-group__button--last:not(.sl-button-group__button--first)) .button {
    border-start-start-radius: 0;
    border-end-start-radius: 0;
  }

  /* All except the first */
  :host(.sl-button-group__button:not(.sl-button-group__button--first)) {
    margin-inline-start: calc(-1 * var(--sl-input-border-width));
  }

  /* Add a visual separator between solid buttons */
  :host(
      .sl-button-group__button:not(
          .sl-button-group__button--first,
          .sl-button-group__button--radio,
          [variant='default']
        ):not(:hover)
    )
    .button:after {
    content: '';
    position: absolute;
    top: 0;
    inset-inline-start: 0;
    bottom: 0;
    border-left: solid 1px rgb(128 128 128 / 33%);
    mix-blend-mode: multiply;
  }

  /* Bump hovered, focused, and checked buttons up so their focus ring isn't clipped */
  :host(.sl-button-group__button--hover) {
    z-index: 1;
  }

  /* Focus and checked are always on top */
  :host(.sl-button-group__button--focus),
  :host(.sl-button-group__button[checked]) {
    z-index: 2;
  }
`;

var radio_button_styles_default = i$b`
  ${button_styles_default}

  .button__prefix,
  .button__suffix,
  .button__label {
    display: inline-flex;
    position: relative;
    align-items: center;
  }

  /* We use a hidden input so constraint validation errors work, since they don't appear to show when used with buttons.
    We can't actually hide it, though, otherwise the messages will be suppressed by the browser. */
  .hidden-input {
    all: unset;
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    outline: dotted 1px red;
    opacity: 0;
    z-index: -1;
  }
`;

var SlRadioButton = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController$1(this, "[default]", "prefix", "suffix");
    this.hasFocus = false;
    this.checked = false;
    this.disabled = false;
    this.size = "medium";
    this.pill = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "presentation");
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleClick(e) {
    if (this.disabled) {
      e.preventDefault();
      e.stopPropagation();
      return;
    }
    this.checked = true;
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  /** Sets focus on the radio button. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the radio button. */
  blur() {
    this.input.blur();
  }
  render() {
    return n$9`
      <div part="base" role="presentation">
        <button
          part="${`button${this.checked ? " button--checked" : ""}`}"
          role="radio"
          aria-checked="${this.checked}"
          class=${o$9({
      button: true,
      "button--default": true,
      "button--small": this.size === "small",
      "button--medium": this.size === "medium",
      "button--large": this.size === "large",
      "button--checked": this.checked,
      "button--disabled": this.disabled,
      "button--focused": this.hasFocus,
      "button--outline": true,
      "button--pill": this.pill,
      "button--has-label": this.hasSlotController.test("[default]"),
      "button--has-prefix": this.hasSlotController.test("prefix"),
      "button--has-suffix": this.hasSlotController.test("suffix")
    })}
          aria-disabled=${this.disabled}
          type="button"
          value=${l$2(this.value)}
          tabindex="${this.checked ? "0" : "-1"}"
          @blur=${this.handleBlur}
          @focus=${this.handleFocus}
          @click=${this.handleClick}
        >
          <slot name="prefix" part="prefix" class="button__prefix"></slot>
          <slot part="label" class="button__label"></slot>
          <slot name="suffix" part="suffix" class="button__suffix"></slot>
        </button>
      </div>
    `;
  }
};
SlRadioButton.styles = radio_button_styles_default;
__decorateClass([
  i$7(".button")
], SlRadioButton.prototype, "input", 2);
__decorateClass([
  i$7(".hidden-input")
], SlRadioButton.prototype, "hiddenInput", 2);
__decorateClass([
  t$7()
], SlRadioButton.prototype, "hasFocus", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRadioButton.prototype, "checked", 2);
__decorateClass([
  e$c()
], SlRadioButton.prototype, "value", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRadioButton.prototype, "disabled", 2);
__decorateClass([
  e$c({ reflect: true })
], SlRadioButton.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRadioButton.prototype, "pill", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlRadioButton.prototype, "handleDisabledChange", 1);

// src/components/radio-button/radio-button.ts
var radio_button_default = SlRadioButton;
SlRadioButton.define("sl-radio-button");

var radio_group_styles_default = i$b`
  ${component_styles_default}
  ${form_control_styles_default}

  :host {
    display: block;
  }

  .form-control {
    position: relative;
    border: none;
    padding: 0;
    margin: 0;
  }

  .form-control__label {
    padding: 0;
  }

  .radio-group--required .radio-group__label::after {
    content: var(--sl-input-required-content);
    margin-inline-start: var(--sl-input-required-content-offset);
  }

  .visually-hidden {
    position: absolute;
    width: 1px;
    height: 1px;
    padding: 0;
    margin: -1px;
    overflow: hidden;
    clip: rect(0, 0, 0, 0);
    white-space: nowrap;
    border: 0;
  }
`;

var button_group_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }

  .button-group {
    display: flex;
    flex-wrap: nowrap;
  }
`;

var SlButtonGroup = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.disableRole = false;
    this.label = "";
  }
  handleFocus(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.classList.add("sl-button-group__button--focus");
  }
  handleBlur(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.classList.remove("sl-button-group__button--focus");
  }
  handleMouseOver(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.classList.add("sl-button-group__button--hover");
  }
  handleMouseOut(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.classList.remove("sl-button-group__button--hover");
  }
  handleSlotChange() {
    const slottedElements = [...this.defaultSlot.assignedElements({ flatten: true })];
    slottedElements.forEach((el) => {
      const index = slottedElements.indexOf(el);
      const button = findButton(el);
      if (button) {
        button.classList.add("sl-button-group__button");
        button.classList.toggle("sl-button-group__button--first", index === 0);
        button.classList.toggle("sl-button-group__button--inner", index > 0 && index < slottedElements.length - 1);
        button.classList.toggle("sl-button-group__button--last", index === slottedElements.length - 1);
        button.classList.toggle("sl-button-group__button--radio", button.tagName.toLowerCase() === "sl-radio-button");
      }
    });
  }
  render() {
    return x$1`
      <div
        part="base"
        class="button-group"
        role="${this.disableRole ? "presentation" : "group"}"
        aria-label=${this.label}
        @focusout=${this.handleBlur}
        @focusin=${this.handleFocus}
        @mouseover=${this.handleMouseOver}
        @mouseout=${this.handleMouseOut}
      >
        <slot @slotchange=${this.handleSlotChange}></slot>
      </div>
    `;
  }
};
SlButtonGroup.styles = button_group_styles_default;
__decorateClass([
  i$7("slot")
], SlButtonGroup.prototype, "defaultSlot", 2);
__decorateClass([
  t$7()
], SlButtonGroup.prototype, "disableRole", 2);
__decorateClass([
  e$c()
], SlButtonGroup.prototype, "label", 2);
function findButton(el) {
  var _a;
  const selector = "sl-button, sl-radio-button";
  return (_a = el.closest(selector)) != null ? _a : el.querySelector(selector);
}

var SlRadioGroup = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this);
    this.hasSlotController = new HasSlotController$1(this, "help-text", "label");
    this.customValidityMessage = "";
    this.hasButtonGroup = false;
    this.errorMessage = "";
    this.defaultValue = "";
    this.label = "";
    this.helpText = "";
    this.name = "option";
    this.value = "";
    this.size = "medium";
    this.form = "";
    this.required = false;
  }
  /** Gets the validity state object */
  get validity() {
    const isRequiredAndEmpty = this.required && !this.value;
    const hasCustomValidityMessage = this.customValidityMessage !== "";
    if (hasCustomValidityMessage) {
      return customErrorValidityState;
    } else if (isRequiredAndEmpty) {
      return valueMissingValidityState;
    }
    return validValidityState;
  }
  /** Gets the validation message */
  get validationMessage() {
    const isRequiredAndEmpty = this.required && !this.value;
    const hasCustomValidityMessage = this.customValidityMessage !== "";
    if (hasCustomValidityMessage) {
      return this.customValidityMessage;
    } else if (isRequiredAndEmpty) {
      return this.validationInput.validationMessage;
    }
    return "";
  }
  connectedCallback() {
    super.connectedCallback();
    this.defaultValue = this.value;
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  getAllRadios() {
    return [...this.querySelectorAll("sl-radio, sl-radio-button")];
  }
  handleRadioClick(event) {
    const target = event.target.closest("sl-radio, sl-radio-button");
    const radios = this.getAllRadios();
    const oldValue = this.value;
    if (target.disabled) {
      return;
    }
    this.value = target.value;
    radios.forEach((radio) => radio.checked = radio === target);
    if (this.value !== oldValue) {
      this.emit("sl-change");
      this.emit("sl-input");
    }
  }
  handleKeyDown(event) {
    var _a;
    if (!["ArrowUp", "ArrowDown", "ArrowLeft", "ArrowRight", " "].includes(event.key)) {
      return;
    }
    const radios = this.getAllRadios().filter((radio) => !radio.disabled);
    const checkedRadio = (_a = radios.find((radio) => radio.checked)) != null ? _a : radios[0];
    const incr = event.key === " " ? 0 : ["ArrowUp", "ArrowLeft"].includes(event.key) ? -1 : 1;
    const oldValue = this.value;
    let index = radios.indexOf(checkedRadio) + incr;
    if (index < 0) {
      index = radios.length - 1;
    }
    if (index > radios.length - 1) {
      index = 0;
    }
    this.getAllRadios().forEach((radio) => {
      radio.checked = false;
      if (!this.hasButtonGroup) {
        radio.tabIndex = -1;
      }
    });
    this.value = radios[index].value;
    radios[index].checked = true;
    if (!this.hasButtonGroup) {
      radios[index].tabIndex = 0;
      radios[index].focus();
    } else {
      radios[index].shadowRoot.querySelector("button").focus();
    }
    if (this.value !== oldValue) {
      this.emit("sl-change");
      this.emit("sl-input");
    }
    event.preventDefault();
  }
  handleLabelClick() {
    const radios = this.getAllRadios();
    const checked = radios.find((radio) => radio.checked);
    const radioToFocus = checked || radios[0];
    if (radioToFocus) {
      radioToFocus.focus();
    }
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  async syncRadioElements() {
    var _a, _b;
    const radios = this.getAllRadios();
    await Promise.all(
      // Sync the checked state and size
      radios.map(async (radio) => {
        await radio.updateComplete;
        radio.checked = radio.value === this.value;
        radio.size = this.size;
      })
    );
    this.hasButtonGroup = radios.some((radio) => radio.tagName.toLowerCase() === "sl-radio-button");
    if (!radios.some((radio) => radio.checked)) {
      if (this.hasButtonGroup) {
        const buttonRadio = (_a = radios[0].shadowRoot) == null ? void 0 : _a.querySelector("button");
        if (buttonRadio) {
          buttonRadio.tabIndex = 0;
        }
      } else {
        radios[0].tabIndex = 0;
      }
    }
    if (this.hasButtonGroup) {
      const buttonGroup = (_b = this.shadowRoot) == null ? void 0 : _b.querySelector("sl-button-group");
      if (buttonGroup) {
        buttonGroup.disableRole = true;
      }
    }
  }
  syncRadios() {
    if (customElements.get("sl-radio") && customElements.get("sl-radio-button")) {
      this.syncRadioElements();
      return;
    }
    if (customElements.get("sl-radio")) {
      this.syncRadioElements();
    } else {
      customElements.whenDefined("sl-radio").then(() => this.syncRadios());
    }
    if (customElements.get("sl-radio-button")) {
      this.syncRadioElements();
    } else {
      customElements.whenDefined("sl-radio-button").then(() => this.syncRadios());
    }
  }
  updateCheckedRadio() {
    const radios = this.getAllRadios();
    radios.forEach((radio) => radio.checked = radio.value === this.value);
    this.formControlController.setValidity(this.validity.valid);
  }
  handleSizeChange() {
    this.syncRadios();
  }
  handleValueChange() {
    if (this.hasUpdated) {
      this.updateCheckedRadio();
    }
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    const isRequiredAndEmpty = this.required && !this.value;
    const hasCustomValidityMessage = this.customValidityMessage !== "";
    if (isRequiredAndEmpty || hasCustomValidityMessage) {
      this.formControlController.emitInvalidEvent();
      return false;
    }
    return true;
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    const isValid = this.validity.valid;
    this.errorMessage = this.customValidityMessage || isValid ? "" : this.validationInput.validationMessage;
    this.formControlController.setValidity(isValid);
    this.validationInput.hidden = true;
    clearTimeout(this.validationTimeout);
    if (!isValid) {
      this.validationInput.hidden = false;
      this.validationInput.reportValidity();
      this.validationTimeout = setTimeout(() => this.validationInput.hidden = true, 1e4);
    }
    return isValid;
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message = "") {
    this.customValidityMessage = message;
    this.errorMessage = message;
    this.validationInput.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    const defaultSlot = x$1`
      <slot @slotchange=${this.syncRadios} @click=${this.handleRadioClick} @keydown=${this.handleKeyDown}></slot>
    `;
    return x$1`
      <fieldset
        part="form-control"
        class=${o$9({
      "form-control": true,
      "form-control--small": this.size === "small",
      "form-control--medium": this.size === "medium",
      "form-control--large": this.size === "large",
      "form-control--radio-group": true,
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText
    })}
        role="radiogroup"
        aria-labelledby="label"
        aria-describedby="help-text"
        aria-errormessage="error-message"
      >
        <label
          part="form-control-label"
          id="label"
          class="form-control__label"
          aria-hidden=${hasLabel ? "false" : "true"}
          @click=${this.handleLabelClick}
        >
          <slot name="label">${this.label}</slot>
        </label>

        <div part="form-control-input" class="form-control-input">
          <div class="visually-hidden">
            <div id="error-message" aria-live="assertive">${this.errorMessage}</div>
            <label class="radio-group__validation">
              <input
                type="text"
                class="radio-group__validation-input"
                ?required=${this.required}
                tabindex="-1"
                hidden
                @invalid=${this.handleInvalid}
              />
            </label>
          </div>

          ${this.hasButtonGroup ? x$1`
                <sl-button-group part="button-group" exportparts="base:button-group__base" role="presentation">
                  ${defaultSlot}
                </sl-button-group>
              ` : defaultSlot}
        </div>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </fieldset>
    `;
  }
};
SlRadioGroup.styles = radio_group_styles_default;
SlRadioGroup.dependencies = { "sl-button-group": SlButtonGroup };
__decorateClass([
  i$7("slot:not([name])")
], SlRadioGroup.prototype, "defaultSlot", 2);
__decorateClass([
  i$7(".radio-group__validation-input")
], SlRadioGroup.prototype, "validationInput", 2);
__decorateClass([
  t$7()
], SlRadioGroup.prototype, "hasButtonGroup", 2);
__decorateClass([
  t$7()
], SlRadioGroup.prototype, "errorMessage", 2);
__decorateClass([
  t$7()
], SlRadioGroup.prototype, "defaultValue", 2);
__decorateClass([
  e$c()
], SlRadioGroup.prototype, "label", 2);
__decorateClass([
  e$c({ attribute: "help-text" })
], SlRadioGroup.prototype, "helpText", 2);
__decorateClass([
  e$c()
], SlRadioGroup.prototype, "name", 2);
__decorateClass([
  e$c({ reflect: true })
], SlRadioGroup.prototype, "value", 2);
__decorateClass([
  e$c({ reflect: true })
], SlRadioGroup.prototype, "size", 2);
__decorateClass([
  e$c({ reflect: true })
], SlRadioGroup.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRadioGroup.prototype, "required", 2);
__decorateClass([
  watch("size", { waitUntilFirstUpdate: true })
], SlRadioGroup.prototype, "handleSizeChange", 1);
__decorateClass([
  watch("value")
], SlRadioGroup.prototype, "handleValueChange", 1);

// src/components/radio-group/radio-group.ts
var radio_group_default = SlRadioGroup;
SlRadioGroup.define("sl-radio-group");

var range_styles_default = i$b`
  ${component_styles_default}
  ${form_control_styles_default}

  :host {
    --thumb-size: 20px;
    --tooltip-offset: 10px;
    --track-color-active: var(--sl-color-neutral-200);
    --track-color-inactive: var(--sl-color-neutral-200);
    --track-active-offset: 0%;
    --track-height: 6px;

    display: block;
  }

  .range {
    position: relative;
  }

  .range__control {
    --percent: 0%;
    -webkit-appearance: none;
    border-radius: 3px;
    width: 100%;
    height: var(--track-height);
    background: transparent;
    line-height: var(--sl-input-height-medium);
    vertical-align: middle;
    margin: 0;

    background-image: linear-gradient(
      to right,
      var(--track-color-inactive) 0%,
      var(--track-color-inactive) min(var(--percent), var(--track-active-offset)),
      var(--track-color-active) min(var(--percent), var(--track-active-offset)),
      var(--track-color-active) max(var(--percent), var(--track-active-offset)),
      var(--track-color-inactive) max(var(--percent), var(--track-active-offset)),
      var(--track-color-inactive) 100%
    );
  }

  .range--rtl .range__control {
    background-image: linear-gradient(
      to left,
      var(--track-color-inactive) 0%,
      var(--track-color-inactive) min(var(--percent), var(--track-active-offset)),
      var(--track-color-active) min(var(--percent), var(--track-active-offset)),
      var(--track-color-active) max(var(--percent), var(--track-active-offset)),
      var(--track-color-inactive) max(var(--percent), var(--track-active-offset)),
      var(--track-color-inactive) 100%
    );
  }

  /* Webkit */
  .range__control::-webkit-slider-runnable-track {
    width: 100%;
    height: var(--track-height);
    border-radius: 3px;
    border: none;
  }

  .range__control::-webkit-slider-thumb {
    border: none;
    width: var(--thumb-size);
    height: var(--thumb-size);
    border-radius: 50%;
    background-color: var(--sl-color-primary-600);
    border: solid var(--sl-input-border-width) var(--sl-color-primary-600);
    -webkit-appearance: none;
    margin-top: calc(var(--thumb-size) / -2 + var(--track-height) / 2);
    cursor: pointer;
  }

  .range__control:enabled::-webkit-slider-thumb:hover {
    background-color: var(--sl-color-primary-500);
    border-color: var(--sl-color-primary-500);
  }

  .range__control:enabled:focus-visible::-webkit-slider-thumb {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .range__control:enabled::-webkit-slider-thumb:active {
    background-color: var(--sl-color-primary-500);
    border-color: var(--sl-color-primary-500);
    cursor: grabbing;
  }

  /* Firefox */
  .range__control::-moz-focus-outer {
    border: 0;
  }

  .range__control::-moz-range-progress {
    background-color: var(--track-color-active);
    border-radius: 3px;
    height: var(--track-height);
  }

  .range__control::-moz-range-track {
    width: 100%;
    height: var(--track-height);
    background-color: var(--track-color-inactive);
    border-radius: 3px;
    border: none;
  }

  .range__control::-moz-range-thumb {
    border: none;
    height: var(--thumb-size);
    width: var(--thumb-size);
    border-radius: 50%;
    background-color: var(--sl-color-primary-600);
    border-color: var(--sl-color-primary-600);
    transition: var(--sl-transition-fast) border-color, var(--sl-transition-fast) background-color,
      var(--sl-transition-fast) color, var(--sl-transition-fast) box-shadow;
    cursor: pointer;
  }

  .range__control:enabled::-moz-range-thumb:hover {
    background-color: var(--sl-color-primary-500);
    border-color: var(--sl-color-primary-500);
  }

  .range__control:enabled:focus-visible::-moz-range-thumb {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .range__control:enabled::-moz-range-thumb:active {
    background-color: var(--sl-color-primary-500);
    border-color: var(--sl-color-primary-500);
    cursor: grabbing;
  }

  /* States */
  .range__control:focus-visible {
    outline: none;
  }

  .range__control:disabled {
    opacity: 0.5;
  }

  .range__control:disabled::-webkit-slider-thumb {
    cursor: not-allowed;
  }

  .range__control:disabled::-moz-range-thumb {
    cursor: not-allowed;
  }

  /* Tooltip output */
  .range__tooltip {
    position: absolute;
    z-index: var(--sl-z-index-tooltip);
    left: 0;
    border-radius: var(--sl-tooltip-border-radius);
    background-color: var(--sl-tooltip-background-color);
    font-family: var(--sl-tooltip-font-family);
    font-size: var(--sl-tooltip-font-size);
    font-weight: var(--sl-tooltip-font-weight);
    line-height: var(--sl-tooltip-line-height);
    color: var(--sl-tooltip-color);
    opacity: 0;
    padding: var(--sl-tooltip-padding);
    transition: var(--sl-transition-fast) opacity;
    pointer-events: none;
  }

  .range__tooltip:after {
    content: '';
    position: absolute;
    width: 0;
    height: 0;
    left: 50%;
    translate: calc(-1 * var(--sl-tooltip-arrow-size));
  }

  .range--tooltip-visible .range__tooltip {
    opacity: 1;
  }

  /* Tooltip on top */
  .range--tooltip-top .range__tooltip {
    top: calc(-1 * var(--thumb-size) - var(--tooltip-offset));
  }

  .range--tooltip-top .range__tooltip:after {
    border-top: var(--sl-tooltip-arrow-size) solid var(--sl-tooltip-background-color);
    border-left: var(--sl-tooltip-arrow-size) solid transparent;
    border-right: var(--sl-tooltip-arrow-size) solid transparent;
    top: 100%;
  }

  /* Tooltip on bottom */
  .range--tooltip-bottom .range__tooltip {
    bottom: calc(-1 * var(--thumb-size) - var(--tooltip-offset));
  }

  .range--tooltip-bottom .range__tooltip:after {
    border-bottom: var(--sl-tooltip-arrow-size) solid var(--sl-tooltip-background-color);
    border-left: var(--sl-tooltip-arrow-size) solid transparent;
    border-right: var(--sl-tooltip-arrow-size) solid transparent;
    bottom: 100%;
  }

  @media (forced-colors: active) {
    .range__control,
    .range__tooltip {
      border: solid 1px transparent;
    }

    .range__control::-webkit-slider-thumb {
      border: solid 1px transparent;
    }

    .range__control::-moz-range-thumb {
      border: solid 1px transparent;
    }

    .range__tooltip:after {
      display: none;
    }
  }
`;

var SlRange = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this);
    this.hasSlotController = new HasSlotController$1(this, "help-text", "label");
    this.localize = new LocalizeController(this);
    this.hasFocus = false;
    this.hasTooltip = false;
    this.title = "";
    this.name = "";
    this.value = 0;
    this.label = "";
    this.helpText = "";
    this.disabled = false;
    this.min = 0;
    this.max = 100;
    this.step = 1;
    this.tooltip = "top";
    this.tooltipFormatter = (value) => value.toString();
    this.form = "";
    this.defaultValue = 0;
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  connectedCallback() {
    super.connectedCallback();
    this.resizeObserver = new ResizeObserver(() => this.syncRange());
    if (this.value < this.min) {
      this.value = this.min;
    }
    if (this.value > this.max) {
      this.value = this.max;
    }
    this.updateComplete.then(() => {
      this.syncRange();
      this.resizeObserver.observe(this.input);
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.resizeObserver.unobserve(this.input);
  }
  handleChange() {
    this.emit("sl-change");
  }
  handleInput() {
    this.value = parseFloat(this.input.value);
    this.emit("sl-input");
    this.syncRange();
  }
  handleBlur() {
    this.hasFocus = false;
    this.hasTooltip = false;
    this.emit("sl-blur");
  }
  handleFocus() {
    this.hasFocus = true;
    this.hasTooltip = true;
    this.emit("sl-focus");
  }
  handleThumbDragStart() {
    this.hasTooltip = true;
  }
  handleThumbDragEnd() {
    this.hasTooltip = false;
  }
  syncProgress(percent) {
    this.input.style.setProperty("--percent", `${percent * 100}%`);
  }
  syncTooltip(percent) {
    if (this.output !== null) {
      const inputWidth = this.input.offsetWidth;
      const tooltipWidth = this.output.offsetWidth;
      const thumbSize = getComputedStyle(this.input).getPropertyValue("--thumb-size");
      const isRtl = this.localize.dir() === "rtl";
      const percentAsWidth = inputWidth * percent;
      if (isRtl) {
        const x = `${inputWidth - percentAsWidth}px + ${percent} * ${thumbSize}`;
        this.output.style.translate = `calc((${x} - ${tooltipWidth / 2}px - ${thumbSize} / 2))`;
      } else {
        const x = `${percentAsWidth}px - ${percent} * ${thumbSize}`;
        this.output.style.translate = `calc(${x} - ${tooltipWidth / 2}px + ${thumbSize} / 2)`;
      }
    }
  }
  handleValueChange() {
    this.formControlController.updateValidity();
    this.input.value = this.value.toString();
    this.value = parseFloat(this.input.value);
    this.syncRange();
  }
  handleDisabledChange() {
    this.formControlController.setValidity(this.disabled);
  }
  syncRange() {
    const percent = Math.max(0, (this.value - this.min) / (this.max - this.min));
    this.syncProgress(percent);
    if (this.tooltip !== "none") {
      this.syncTooltip(percent);
    }
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  /** Sets focus on the range. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the range. */
  blur() {
    this.input.blur();
  }
  /** Increments the value of the range by the value of the step attribute. */
  stepUp() {
    this.input.stepUp();
    if (this.value !== Number(this.input.value)) {
      this.value = Number(this.input.value);
    }
  }
  /** Decrements the value of the range by the value of the step attribute. */
  stepDown() {
    this.input.stepDown();
    if (this.value !== Number(this.input.value)) {
      this.value = Number(this.input.value);
    }
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    return x$1`
      <div
        part="form-control"
        class=${o$9({
      "form-control": true,
      "form-control--medium": true,
      // range only has one size
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText
    })}
      >
        <label
          part="form-control-label"
          class="form-control__label"
          for="input"
          aria-hidden=${hasLabel ? "false" : "true"}
        >
          <slot name="label">${this.label}</slot>
        </label>

        <div part="form-control-input" class="form-control-input">
          <div
            part="base"
            class=${o$9({
      range: true,
      "range--disabled": this.disabled,
      "range--focused": this.hasFocus,
      "range--rtl": this.localize.dir() === "rtl",
      "range--tooltip-visible": this.hasTooltip,
      "range--tooltip-top": this.tooltip === "top",
      "range--tooltip-bottom": this.tooltip === "bottom"
    })}
            @mousedown=${this.handleThumbDragStart}
            @mouseup=${this.handleThumbDragEnd}
            @touchstart=${this.handleThumbDragStart}
            @touchend=${this.handleThumbDragEnd}
          >
            <input
              part="input"
              id="input"
              class="range__control"
              title=${this.title}
              type="range"
              name=${l$2(this.name)}
              ?disabled=${this.disabled}
              min=${l$2(this.min)}
              max=${l$2(this.max)}
              step=${l$2(this.step)}
              .value=${l$1(this.value.toString())}
              aria-describedby="help-text"
              @change=${this.handleChange}
              @focus=${this.handleFocus}
              @input=${this.handleInput}
              @invalid=${this.handleInvalid}
              @blur=${this.handleBlur}
            />
            ${this.tooltip !== "none" && !this.disabled ? x$1`
                  <output part="tooltip" class="range__tooltip">
                    ${typeof this.tooltipFormatter === "function" ? this.tooltipFormatter(this.value) : this.value}
                  </output>
                ` : ""}
          </div>
        </div>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </div>
    `;
  }
};
SlRange.styles = range_styles_default;
__decorateClass([
  i$7(".range__control")
], SlRange.prototype, "input", 2);
__decorateClass([
  i$7(".range__tooltip")
], SlRange.prototype, "output", 2);
__decorateClass([
  t$7()
], SlRange.prototype, "hasFocus", 2);
__decorateClass([
  t$7()
], SlRange.prototype, "hasTooltip", 2);
__decorateClass([
  e$c()
], SlRange.prototype, "title", 2);
__decorateClass([
  e$c()
], SlRange.prototype, "name", 2);
__decorateClass([
  e$c({ type: Number })
], SlRange.prototype, "value", 2);
__decorateClass([
  e$c()
], SlRange.prototype, "label", 2);
__decorateClass([
  e$c({ attribute: "help-text" })
], SlRange.prototype, "helpText", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlRange.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Number })
], SlRange.prototype, "min", 2);
__decorateClass([
  e$c({ type: Number })
], SlRange.prototype, "max", 2);
__decorateClass([
  e$c({ type: Number })
], SlRange.prototype, "step", 2);
__decorateClass([
  e$c()
], SlRange.prototype, "tooltip", 2);
__decorateClass([
  e$c({ attribute: false })
], SlRange.prototype, "tooltipFormatter", 2);
__decorateClass([
  e$c({ reflect: true })
], SlRange.prototype, "form", 2);
__decorateClass([
  defaultValue()
], SlRange.prototype, "defaultValue", 2);
__decorateClass([
  e$a({ passive: true })
], SlRange.prototype, "handleThumbDragStart", 1);
__decorateClass([
  watch("value", { waitUntilFirstUpdate: true })
], SlRange.prototype, "handleValueChange", 1);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlRange.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("hasTooltip", { waitUntilFirstUpdate: true })
], SlRange.prototype, "syncRange", 1);

// src/components/range/range.ts
var range_default = SlRange;
SlRange.define("sl-range");

var progress_ring_styles_default = i$b`
  ${component_styles_default}

  :host {
    --size: 128px;
    --track-width: 4px;
    --track-color: var(--sl-color-neutral-200);
    --indicator-width: var(--track-width);
    --indicator-color: var(--sl-color-primary-600);
    --indicator-transition-duration: 0.35s;

    display: inline-flex;
  }

  .progress-ring {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    position: relative;
  }

  .progress-ring__image {
    width: var(--size);
    height: var(--size);
    rotate: -90deg;
    transform-origin: 50% 50%;
  }

  .progress-ring__track,
  .progress-ring__indicator {
    --radius: calc(var(--size) / 2 - max(var(--track-width), var(--indicator-width)) * 0.5);
    --circumference: calc(var(--radius) * 2 * 3.141592654);

    fill: none;
    r: var(--radius);
    cx: calc(var(--size) / 2);
    cy: calc(var(--size) / 2);
  }

  .progress-ring__track {
    stroke: var(--track-color);
    stroke-width: var(--track-width);
  }

  .progress-ring__indicator {
    stroke: var(--indicator-color);
    stroke-width: var(--indicator-width);
    stroke-linecap: round;
    transition-property: stroke-dashoffset;
    transition-duration: var(--indicator-transition-duration);
    stroke-dasharray: var(--circumference) var(--circumference);
    stroke-dashoffset: calc(var(--circumference) - var(--percentage) * var(--circumference));
  }

  .progress-ring__label {
    display: flex;
    align-items: center;
    justify-content: center;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    text-align: center;
    user-select: none;
  }
`;

var SlProgressRing = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.value = 0;
    this.label = "";
  }
  updated(changedProps) {
    super.updated(changedProps);
    if (changedProps.has("value")) {
      const radius = parseFloat(getComputedStyle(this.indicator).getPropertyValue("r"));
      const circumference = 2 * Math.PI * radius;
      const offset = circumference - this.value / 100 * circumference;
      this.indicatorOffset = `${offset}px`;
    }
  }
  render() {
    return x$1`
      <div
        part="base"
        class="progress-ring"
        role="progressbar"
        aria-label=${this.label.length > 0 ? this.label : this.localize.term("progress")}
        aria-describedby="label"
        aria-valuemin="0"
        aria-valuemax="100"
        aria-valuenow="${this.value}"
        style="--percentage: ${this.value / 100}"
      >
        <svg class="progress-ring__image">
          <circle class="progress-ring__track"></circle>
          <circle class="progress-ring__indicator" style="stroke-dashoffset: ${this.indicatorOffset}"></circle>
        </svg>

        <slot id="label" part="label" class="progress-ring__label"></slot>
      </div>
    `;
  }
};
SlProgressRing.styles = progress_ring_styles_default;
__decorateClass([
  i$7(".progress-ring__indicator")
], SlProgressRing.prototype, "indicator", 2);
__decorateClass([
  t$7()
], SlProgressRing.prototype, "indicatorOffset", 2);
__decorateClass([
  e$c({ type: Number, reflect: true })
], SlProgressRing.prototype, "value", 2);
__decorateClass([
  e$c()
], SlProgressRing.prototype, "label", 2);

// src/components/progress-ring/progress-ring.ts
var progress_ring_default = SlProgressRing;
SlProgressRing.define("sl-progress-ring");

var qr_code_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }
`;

/*
 jquery-qrcode v0.14.0 - https://larsjung.de/jquery-qrcode/ */
'use strict';let G$1=null;class H$1{}H$1.render=function(w,B){G$1(w,B);};self.QrCreator=H$1;
(function(w){function B(t,c,a,e){var b={},h=w(a,c);h.u(t);h.J();e=e||0;var r=h.h(),d=h.h()+2*e;b.text=t;b.level=c;b.version=a;b.O=d;b.a=function(b,a){b-=e;a-=e;return 0>b||b>=r||0>a||a>=r?!1:h.a(b,a)};return b}function C(t,c,a,e,b,h,r,d,g,x){function u(b,a,f,c,d,r,g){b?(t.lineTo(a+r,f+g),t.arcTo(a,f,c,d,h)):t.lineTo(a,f);}r?t.moveTo(c+h,a):t.moveTo(c,a);u(d,e,a,e,b,-h,0);u(g,e,b,c,b,0,-h);u(x,c,b,c,a,h,0);u(r,c,a,e,a,0,h);}function z(t,c,a,e,b,h,r,d,g,x){function u(b,a,c,d){t.moveTo(b+c,a);t.lineTo(b,
a);t.lineTo(b,a+d);t.arcTo(b,a,b+c,a,h);}r&&u(c,a,h,h);d&&u(e,a,-h,h);g&&u(e,b,-h,-h);x&&u(c,b,h,-h);}function A(t,c){var a=c.fill;if("string"===typeof a)t.fillStyle=a;else {var e=a.type,b=a.colorStops;a=a.position.map((b)=>Math.round(b*c.size));if("linear-gradient"===e)var h=t.createLinearGradient.apply(t,a);else if("radial-gradient"===e)h=t.createRadialGradient.apply(t,a);else throw Error("Unsupported fill");b.forEach(([b,a])=>{h.addColorStop(b,a);});t.fillStyle=h;}}function y(t,c){a:{var a=c.text,e=
c.v,b=c.N,h=c.K,r=c.P;b=Math.max(1,b||1);for(h=Math.min(40,h||40);b<=h;b+=1)try{var d=B(a,e,b,r);break a}catch(J){}d=void 0;}if(!d)return null;a=t.getContext("2d");c.background&&(a.fillStyle=c.background,a.fillRect(c.left,c.top,c.size,c.size));e=d.O;h=c.size/e;a.beginPath();for(r=0;r<e;r+=1)for(b=0;b<e;b+=1){var g=a,x=c.left+b*h,u=c.top+r*h,p=r,q=b,f=d.a,k=x+h,m=u+h,D=p-1,E=p+1,n=q-1,l=q+1,y=Math.floor(Math.min(.5,Math.max(0,c.R))*h),v=f(p,q),I=f(D,n),w=f(D,q);D=f(D,l);var F=f(p,l);l=f(E,l);q=f(E,
q);E=f(E,n);p=f(p,n);x=Math.round(x);u=Math.round(u);k=Math.round(k);m=Math.round(m);v?C(g,x,u,k,m,y,!w&&!p,!w&&!F,!q&&!F,!q&&!p):z(g,x,u,k,m,y,w&&p&&I,w&&F&&D,q&&F&&l,q&&p&&E);}A(a,c);a.fill();return t}var v={minVersion:1,maxVersion:40,ecLevel:"L",left:0,top:0,size:200,fill:"#000",background:null,text:"no text",radius:.5,quiet:0};G$1=function(t,c){var a={};Object.assign(a,v,t);a.N=a.minVersion;a.K=a.maxVersion;a.v=a.ecLevel;a.left=a.left;a.top=a.top;a.size=a.size;a.fill=a.fill;a.background=a.background;
a.text=a.text;a.R=a.radius;a.P=a.quiet;if(c instanceof HTMLCanvasElement){if(c.width!==a.size||c.height!==a.size)c.width=a.size,c.height=a.size;c.getContext("2d").clearRect(0,0,c.width,c.height);y(c,a);}else t=document.createElement("canvas"),t.width=a.size,t.height=a.size,a=y(t,a),c.appendChild(a);};})(function(){function w(c){var a=C.s(c);return {S:function(){return 4},b:function(){return a.length},write:function(c){for(var b=0;b<a.length;b+=1)c.put(a[b],8);}}}function B(){var c=[],a=0,e={B:function(){return c},
c:function(b){return 1==(c[Math.floor(b/8)]>>>7-b%8&1)},put:function(b,h){for(var a=0;a<h;a+=1)e.m(1==(b>>>h-a-1&1));},f:function(){return a},m:function(b){var h=Math.floor(a/8);c.length<=h&&c.push(0);b&&(c[h]|=128>>>a%8);a+=1;}};return e}function C(c,a){function e(b,h){for(var a=-1;7>=a;a+=1)if(!(-1>=b+a||d<=b+a))for(var c=-1;7>=c;c+=1)-1>=h+c||d<=h+c||(r[b+a][h+c]=0<=a&&6>=a&&(0==c||6==c)||0<=c&&6>=c&&(0==a||6==a)||2<=a&&4>=a&&2<=c&&4>=c?!0:!1);}function b(b,a){for(var f=d=4*c+17,k=Array(f),m=0;m<
f;m+=1){k[m]=Array(f);for(var p=0;p<f;p+=1)k[m][p]=null;}r=k;e(0,0);e(d-7,0);e(0,d-7);f=y.G(c);for(k=0;k<f.length;k+=1)for(m=0;m<f.length;m+=1){p=f[k];var q=f[m];if(null==r[p][q])for(var n=-2;2>=n;n+=1)for(var l=-2;2>=l;l+=1)r[p+n][q+l]=-2==n||2==n||-2==l||2==l||0==n&&0==l;}for(f=8;f<d-8;f+=1)null==r[f][6]&&(r[f][6]=0==f%2);for(f=8;f<d-8;f+=1)null==r[6][f]&&(r[6][f]=0==f%2);f=y.w(h<<3|a);for(k=0;15>k;k+=1)m=!b&&1==(f>>k&1),r[6>k?k:8>k?k+1:d-15+k][8]=m,r[8][8>k?d-k-1:9>k?15-k:14-k]=m;r[d-8][8]=!b;if(7<=
c){f=y.A(c);for(k=0;18>k;k+=1)m=!b&&1==(f>>k&1),r[Math.floor(k/3)][k%3+d-8-3]=m;for(k=0;18>k;k+=1)m=!b&&1==(f>>k&1),r[k%3+d-8-3][Math.floor(k/3)]=m;}if(null==g){b=t.I(c,h);f=B();for(k=0;k<x.length;k+=1)m=x[k],f.put(4,4),f.put(m.b(),y.f(4,c)),m.write(f);for(k=m=0;k<b.length;k+=1)m+=b[k].j;if(f.f()>8*m)throw Error("code length overflow. ("+f.f()+">"+8*m+")");for(f.f()+4<=8*m&&f.put(0,4);0!=f.f()%8;)f.m(!1);for(;!(f.f()>=8*m);){f.put(236,8);if(f.f()>=8*m)break;f.put(17,8);}var u=0;m=k=0;p=Array(b.length);
q=Array(b.length);for(n=0;n<b.length;n+=1){var v=b[n].j,w=b[n].o-v;k=Math.max(k,v);m=Math.max(m,w);p[n]=Array(v);for(l=0;l<p[n].length;l+=1)p[n][l]=255&f.B()[l+u];u+=v;l=y.C(w);v=z(p[n],l.b()-1).l(l);q[n]=Array(l.b()-1);for(l=0;l<q[n].length;l+=1)w=l+v.b()-q[n].length,q[n][l]=0<=w?v.c(w):0;}for(l=f=0;l<b.length;l+=1)f+=b[l].o;f=Array(f);for(l=u=0;l<k;l+=1)for(n=0;n<b.length;n+=1)l<p[n].length&&(f[u]=p[n][l],u+=1);for(l=0;l<m;l+=1)for(n=0;n<b.length;n+=1)l<q[n].length&&(f[u]=q[n][l],u+=1);g=f;}b=g;f=
-1;k=d-1;m=7;p=0;a=y.F(a);for(q=d-1;0<q;q-=2)for(6==q&&--q;;){for(n=0;2>n;n+=1)null==r[k][q-n]&&(l=!1,p<b.length&&(l=1==(b[p]>>>m&1)),a(k,q-n)&&(l=!l),r[k][q-n]=l,--m,-1==m&&(p+=1,m=7));k+=f;if(0>k||d<=k){k-=f;f=-f;break}}}var h=A[a],r=null,d=0,g=null,x=[],u={u:function(b){b=w(b);x.push(b);g=null;},a:function(b,a){if(0>b||d<=b||0>a||d<=a)throw Error(b+","+a);return r[b][a]},h:function(){return d},J:function(){for(var a=0,h=0,c=0;8>c;c+=1){b(!0,c);var d=y.D(u);if(0==c||a>d)a=d,h=c;}b(!1,h);}};return u}
function z(c,a){if("undefined"==typeof c.length)throw Error(c.length+"/"+a);var e=function(){for(var b=0;b<c.length&&0==c[b];)b+=1;for(var r=Array(c.length-b+a),d=0;d<c.length-b;d+=1)r[d]=c[d+b];return r}(),b={c:function(b){return e[b]},b:function(){return e.length},multiply:function(a){for(var h=Array(b.b()+a.b()-1),c=0;c<b.b();c+=1)for(var g=0;g<a.b();g+=1)h[c+g]^=v.i(v.g(b.c(c))+v.g(a.c(g)));return z(h,0)},l:function(a){if(0>b.b()-a.b())return b;for(var c=v.g(b.c(0))-v.g(a.c(0)),h=Array(b.b()),
g=0;g<b.b();g+=1)h[g]=b.c(g);for(g=0;g<a.b();g+=1)h[g]^=v.i(v.g(a.c(g))+c);return z(h,0).l(a)}};return b}C.s=function(c){for(var a=[],e=0;e<c.length;e++){var b=c.charCodeAt(e);128>b?a.push(b):2048>b?a.push(192|b>>6,128|b&63):55296>b||57344<=b?a.push(224|b>>12,128|b>>6&63,128|b&63):(e++,b=65536+((b&1023)<<10|c.charCodeAt(e)&1023),a.push(240|b>>18,128|b>>12&63,128|b>>6&63,128|b&63));}return a};var A={L:1,M:0,Q:3,H:2},y=function(){function c(b){for(var a=0;0!=b;)a+=1,b>>>=1;return a}var a=[[],[6,18],
[6,22],[6,26],[6,30],[6,34],[6,22,38],[6,24,42],[6,26,46],[6,28,50],[6,30,54],[6,32,58],[6,34,62],[6,26,46,66],[6,26,48,70],[6,26,50,74],[6,30,54,78],[6,30,56,82],[6,30,58,86],[6,34,62,90],[6,28,50,72,94],[6,26,50,74,98],[6,30,54,78,102],[6,28,54,80,106],[6,32,58,84,110],[6,30,58,86,114],[6,34,62,90,118],[6,26,50,74,98,122],[6,30,54,78,102,126],[6,26,52,78,104,130],[6,30,56,82,108,134],[6,34,60,86,112,138],[6,30,58,86,114,142],[6,34,62,90,118,146],[6,30,54,78,102,126,150],[6,24,50,76,102,128,154],
[6,28,54,80,106,132,158],[6,32,58,84,110,136,162],[6,26,54,82,110,138,166],[6,30,58,86,114,142,170]],e={w:function(b){for(var a=b<<10;0<=c(a)-c(1335);)a^=1335<<c(a)-c(1335);return (b<<10|a)^21522},A:function(b){for(var a=b<<12;0<=c(a)-c(7973);)a^=7973<<c(a)-c(7973);return b<<12|a},G:function(b){return a[b-1]},F:function(b){switch(b){case 0:return function(b,a){return 0==(b+a)%2};case 1:return function(b){return 0==b%2};case 2:return function(b,a){return 0==a%3};case 3:return function(b,a){return 0==
(b+a)%3};case 4:return function(b,a){return 0==(Math.floor(b/2)+Math.floor(a/3))%2};case 5:return function(b,a){return 0==b*a%2+b*a%3};case 6:return function(b,a){return 0==(b*a%2+b*a%3)%2};case 7:return function(b,a){return 0==(b*a%3+(b+a)%2)%2};default:throw Error("bad maskPattern:"+b);}},C:function(b){for(var a=z([1],0),c=0;c<b;c+=1)a=a.multiply(z([1,v.i(c)],0));return a},f:function(b,a){if(4!=b||1>a||40<a)throw Error("mode: "+b+"; type: "+a);return 10>a?8:16},D:function(b){for(var a=b.h(),c=0,
d=0;d<a;d+=1)for(var g=0;g<a;g+=1){for(var e=0,t=b.a(d,g),p=-1;1>=p;p+=1)if(!(0>d+p||a<=d+p))for(var q=-1;1>=q;q+=1)0>g+q||a<=g+q||(0!=p||0!=q)&&t==b.a(d+p,g+q)&&(e+=1);5<e&&(c+=3+e-5);}for(d=0;d<a-1;d+=1)for(g=0;g<a-1;g+=1)if(e=0,b.a(d,g)&&(e+=1),b.a(d+1,g)&&(e+=1),b.a(d,g+1)&&(e+=1),b.a(d+1,g+1)&&(e+=1),0==e||4==e)c+=3;for(d=0;d<a;d+=1)for(g=0;g<a-6;g+=1)b.a(d,g)&&!b.a(d,g+1)&&b.a(d,g+2)&&b.a(d,g+3)&&b.a(d,g+4)&&!b.a(d,g+5)&&b.a(d,g+6)&&(c+=40);for(g=0;g<a;g+=1)for(d=0;d<a-6;d+=1)b.a(d,g)&&!b.a(d+
1,g)&&b.a(d+2,g)&&b.a(d+3,g)&&b.a(d+4,g)&&!b.a(d+5,g)&&b.a(d+6,g)&&(c+=40);for(g=e=0;g<a;g+=1)for(d=0;d<a;d+=1)b.a(d,g)&&(e+=1);return c+=Math.abs(100*e/a/a-50)/5*10}};return e}(),v=function(){for(var c=Array(256),a=Array(256),e=0;8>e;e+=1)c[e]=1<<e;for(e=8;256>e;e+=1)c[e]=c[e-4]^c[e-5]^c[e-6]^c[e-8];for(e=0;255>e;e+=1)a[c[e]]=e;return {g:function(b){if(1>b)throw Error("glog("+b+")");return a[b]},i:function(b){for(;0>b;)b+=255;for(;256<=b;)b-=255;return c[b]}}}(),t=function(){function c(b,c){switch(c){case A.L:return a[4*
(b-1)];case A.M:return a[4*(b-1)+1];case A.Q:return a[4*(b-1)+2];case A.H:return a[4*(b-1)+3]}}var a=[[1,26,19],[1,26,16],[1,26,13],[1,26,9],[1,44,34],[1,44,28],[1,44,22],[1,44,16],[1,70,55],[1,70,44],[2,35,17],[2,35,13],[1,100,80],[2,50,32],[2,50,24],[4,25,9],[1,134,108],[2,67,43],[2,33,15,2,34,16],[2,33,11,2,34,12],[2,86,68],[4,43,27],[4,43,19],[4,43,15],[2,98,78],[4,49,31],[2,32,14,4,33,15],[4,39,13,1,40,14],[2,121,97],[2,60,38,2,61,39],[4,40,18,2,41,19],[4,40,14,2,41,15],[2,146,116],[3,58,36,
2,59,37],[4,36,16,4,37,17],[4,36,12,4,37,13],[2,86,68,2,87,69],[4,69,43,1,70,44],[6,43,19,2,44,20],[6,43,15,2,44,16],[4,101,81],[1,80,50,4,81,51],[4,50,22,4,51,23],[3,36,12,8,37,13],[2,116,92,2,117,93],[6,58,36,2,59,37],[4,46,20,6,47,21],[7,42,14,4,43,15],[4,133,107],[8,59,37,1,60,38],[8,44,20,4,45,21],[12,33,11,4,34,12],[3,145,115,1,146,116],[4,64,40,5,65,41],[11,36,16,5,37,17],[11,36,12,5,37,13],[5,109,87,1,110,88],[5,65,41,5,66,42],[5,54,24,7,55,25],[11,36,12,7,37,13],[5,122,98,1,123,99],[7,73,
45,3,74,46],[15,43,19,2,44,20],[3,45,15,13,46,16],[1,135,107,5,136,108],[10,74,46,1,75,47],[1,50,22,15,51,23],[2,42,14,17,43,15],[5,150,120,1,151,121],[9,69,43,4,70,44],[17,50,22,1,51,23],[2,42,14,19,43,15],[3,141,113,4,142,114],[3,70,44,11,71,45],[17,47,21,4,48,22],[9,39,13,16,40,14],[3,135,107,5,136,108],[3,67,41,13,68,42],[15,54,24,5,55,25],[15,43,15,10,44,16],[4,144,116,4,145,117],[17,68,42],[17,50,22,6,51,23],[19,46,16,6,47,17],[2,139,111,7,140,112],[17,74,46],[7,54,24,16,55,25],[34,37,13],[4,
151,121,5,152,122],[4,75,47,14,76,48],[11,54,24,14,55,25],[16,45,15,14,46,16],[6,147,117,4,148,118],[6,73,45,14,74,46],[11,54,24,16,55,25],[30,46,16,2,47,17],[8,132,106,4,133,107],[8,75,47,13,76,48],[7,54,24,22,55,25],[22,45,15,13,46,16],[10,142,114,2,143,115],[19,74,46,4,75,47],[28,50,22,6,51,23],[33,46,16,4,47,17],[8,152,122,4,153,123],[22,73,45,3,74,46],[8,53,23,26,54,24],[12,45,15,28,46,16],[3,147,117,10,148,118],[3,73,45,23,74,46],[4,54,24,31,55,25],[11,45,15,31,46,16],[7,146,116,7,147,117],
[21,73,45,7,74,46],[1,53,23,37,54,24],[19,45,15,26,46,16],[5,145,115,10,146,116],[19,75,47,10,76,48],[15,54,24,25,55,25],[23,45,15,25,46,16],[13,145,115,3,146,116],[2,74,46,29,75,47],[42,54,24,1,55,25],[23,45,15,28,46,16],[17,145,115],[10,74,46,23,75,47],[10,54,24,35,55,25],[19,45,15,35,46,16],[17,145,115,1,146,116],[14,74,46,21,75,47],[29,54,24,19,55,25],[11,45,15,46,46,16],[13,145,115,6,146,116],[14,74,46,23,75,47],[44,54,24,7,55,25],[59,46,16,1,47,17],[12,151,121,7,152,122],[12,75,47,26,76,48],
[39,54,24,14,55,25],[22,45,15,41,46,16],[6,151,121,14,152,122],[6,75,47,34,76,48],[46,54,24,10,55,25],[2,45,15,64,46,16],[17,152,122,4,153,123],[29,74,46,14,75,47],[49,54,24,10,55,25],[24,45,15,46,46,16],[4,152,122,18,153,123],[13,74,46,32,75,47],[48,54,24,14,55,25],[42,45,15,32,46,16],[20,147,117,4,148,118],[40,75,47,7,76,48],[43,54,24,22,55,25],[10,45,15,67,46,16],[19,148,118,6,149,119],[18,75,47,31,76,48],[34,54,24,34,55,25],[20,45,15,61,46,16]],e={I:function(b,a){var e=c(b,a);if("undefined"==
typeof e)throw Error("bad rs block @ typeNumber:"+b+"/errorCorrectLevel:"+a);b=e.length/3;a=[];for(var d=0;d<b;d+=1)for(var g=e[3*d],h=e[3*d+1],t=e[3*d+2],p=0;p<g;p+=1){var q=t,f={};f.o=h;f.j=q;a.push(f);}return a}};return e}();return C}());
var QrCreator$1 = QrCreator;

var SlQrCode = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.value = "";
    this.label = "";
    this.size = 128;
    this.fill = "black";
    this.background = "white";
    this.radius = 0;
    this.errorCorrection = "H";
  }
  firstUpdated() {
    this.generate();
  }
  generate() {
    if (!this.hasUpdated) {
      return;
    }
    QrCreator$1.render(
      {
        text: this.value,
        radius: this.radius,
        ecLevel: this.errorCorrection,
        fill: this.fill,
        background: this.background,
        // We draw the canvas larger and scale its container down to avoid blurring on high-density displays
        size: this.size * 2
      },
      this.canvas
    );
  }
  render() {
    var _a;
    return x$1`
      <canvas
        part="base"
        class="qr-code"
        role="img"
        aria-label=${((_a = this.label) == null ? void 0 : _a.length) > 0 ? this.label : this.value}
        style=${o$7({
      width: `${this.size}px`,
      height: `${this.size}px`
    })}
      ></canvas>
    `;
  }
};
SlQrCode.styles = qr_code_styles_default;
__decorateClass([
  i$7("canvas")
], SlQrCode.prototype, "canvas", 2);
__decorateClass([
  e$c()
], SlQrCode.prototype, "value", 2);
__decorateClass([
  e$c()
], SlQrCode.prototype, "label", 2);
__decorateClass([
  e$c({ type: Number })
], SlQrCode.prototype, "size", 2);
__decorateClass([
  e$c()
], SlQrCode.prototype, "fill", 2);
__decorateClass([
  e$c()
], SlQrCode.prototype, "background", 2);
__decorateClass([
  e$c({ type: Number })
], SlQrCode.prototype, "radius", 2);
__decorateClass([
  e$c({ attribute: "error-correction" })
], SlQrCode.prototype, "errorCorrection", 2);
__decorateClass([
  watch(["background", "errorCorrection", "fill", "radius", "size", "value"])
], SlQrCode.prototype, "generate", 1);

// src/components/qr-code/qr-code.ts
var qr_code_default = SlQrCode;
SlQrCode.define("sl-qr-code");

var option_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
    user-select: none;
  }

  :host(:focus) {
    outline: none;
  }

  .option {
    position: relative;
    display: flex;
    align-items: center;
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-medium);
    font-weight: var(--sl-font-weight-normal);
    line-height: var(--sl-line-height-normal);
    letter-spacing: var(--sl-letter-spacing-normal);
    color: var(--sl-color-neutral-700);
    padding: var(--sl-spacing-x-small) var(--sl-spacing-medium) var(--sl-spacing-x-small) var(--sl-spacing-x-small);
    transition: var(--sl-transition-fast) fill;
    cursor: pointer;
  }

  .option--hover:not(.option--current):not(.option--disabled) {
    background-color: var(--sl-color-neutral-100);
    color: var(--sl-color-neutral-1000);
  }

  .option--current,
  .option--current.option--disabled {
    background-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
    opacity: 1;
  }

  .option--disabled {
    outline: none;
    opacity: 0.5;
    cursor: not-allowed;
  }

  .option__label {
    flex: 1 1 auto;
    display: inline-block;
    line-height: var(--sl-line-height-dense);
  }

  .option .option__check {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    justify-content: center;
    visibility: hidden;
    padding-inline-end: var(--sl-spacing-2x-small);
  }

  .option--selected .option__check {
    visibility: visible;
  }

  .option__prefix,
  .option__suffix {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
  }

  .option__prefix::slotted(*) {
    margin-inline-end: var(--sl-spacing-x-small);
  }

  .option__suffix::slotted(*) {
    margin-inline-start: var(--sl-spacing-x-small);
  }

  @media (forced-colors: active) {
    :host(:hover:not([aria-disabled='true'])) .option {
      outline: dashed 1px SelectedItem;
      outline-offset: -1px;
    }
  }
`;

var SlOption = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    // @ts-expect-error - Controller is currently unused
    this.localize = new LocalizeController(this);
    this.current = false;
    this.selected = false;
    this.hasHover = false;
    this.value = "";
    this.disabled = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "option");
    this.setAttribute("aria-selected", "false");
  }
  handleDefaultSlotChange() {
    const textLabel = this.getTextLabel();
    if (typeof this.cachedTextLabel === "undefined") {
      this.cachedTextLabel = textLabel;
      return;
    }
    if (textLabel !== this.cachedTextLabel) {
      this.cachedTextLabel = textLabel;
      this.emit("slotchange", { bubbles: true, composed: false, cancelable: false });
    }
  }
  handleMouseEnter() {
    this.hasHover = true;
  }
  handleMouseLeave() {
    this.hasHover = false;
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  handleSelectedChange() {
    this.setAttribute("aria-selected", this.selected ? "true" : "false");
  }
  handleValueChange() {
    if (typeof this.value !== "string") {
      this.value = String(this.value);
    }
    if (this.value.includes(" ")) {
      console.error(`Option values cannot include a space. All spaces have been replaced with underscores.`, this);
      this.value = this.value.replace(/ /g, "_");
    }
  }
  /** Returns a plain text label based on the option's content. */
  getTextLabel() {
    var _a;
    return ((_a = this.textContent) != null ? _a : "").trim();
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      option: true,
      "option--current": this.current,
      "option--disabled": this.disabled,
      "option--selected": this.selected,
      "option--hover": this.hasHover
    })}
        @mouseenter=${this.handleMouseEnter}
        @mouseleave=${this.handleMouseLeave}
      >
        <sl-icon part="checked-icon" class="option__check" name="check" library="system" aria-hidden="true"></sl-icon>
        <slot part="prefix" name="prefix" class="option__prefix"></slot>
        <slot part="label" class="option__label" @slotchange=${this.handleDefaultSlotChange}></slot>
        <slot part="suffix" name="suffix" class="option__suffix"></slot>
      </div>
    `;
  }
};
SlOption.styles = option_styles_default;
SlOption.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7(".option__label")
], SlOption.prototype, "defaultSlot", 2);
__decorateClass([
  t$7()
], SlOption.prototype, "current", 2);
__decorateClass([
  t$7()
], SlOption.prototype, "selected", 2);
__decorateClass([
  t$7()
], SlOption.prototype, "hasHover", 2);
__decorateClass([
  e$c({ reflect: true })
], SlOption.prototype, "value", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlOption.prototype, "disabled", 2);
__decorateClass([
  watch("disabled")
], SlOption.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("selected")
], SlOption.prototype, "handleSelectedChange", 1);
__decorateClass([
  watch("value")
], SlOption.prototype, "handleValueChange", 1);

// src/components/option/option.ts
var option_default = SlOption;
SlOption.define("sl-option");

// src/components/popup/popup.ts
var popup_default = SlPopup;
SlPopup.define("sl-popup");

var progress_bar_styles_default = i$b`
  ${component_styles_default}

  :host {
    --height: 1rem;
    --track-color: var(--sl-color-neutral-200);
    --indicator-color: var(--sl-color-primary-600);
    --label-color: var(--sl-color-neutral-0);

    display: block;
  }

  .progress-bar {
    position: relative;
    background-color: var(--track-color);
    height: var(--height);
    border-radius: var(--sl-border-radius-pill);
    box-shadow: inset var(--sl-shadow-small);
    overflow: hidden;
  }

  .progress-bar__indicator {
    height: 100%;
    font-family: var(--sl-font-sans);
    font-size: 12px;
    font-weight: var(--sl-font-weight-normal);
    background-color: var(--indicator-color);
    color: var(--label-color);
    text-align: center;
    line-height: var(--height);
    white-space: nowrap;
    overflow: hidden;
    transition: 400ms width, 400ms background-color;
    user-select: none;
  }

  /* Indeterminate */
  .progress-bar--indeterminate .progress-bar__indicator {
    position: absolute;
    animation: indeterminate 2.5s infinite cubic-bezier(0.37, 0, 0.63, 1);
  }

  .progress-bar--indeterminate.progress-bar--rtl .progress-bar__indicator {
    animation-name: indeterminate-rtl;
  }

  @media (forced-colors: active) {
    .progress-bar {
      outline: solid 1px SelectedItem;
      background-color: var(--sl-color-neutral-0);
    }

    .progress-bar__indicator {
      outline: solid 1px SelectedItem;
      background-color: SelectedItem;
    }
  }

  @keyframes indeterminate {
    0% {
      left: -50%;
      width: 50%;
    }
    75%,
    100% {
      left: 100%;
      width: 50%;
    }
  }

  @keyframes indeterminate-rtl {
    0% {
      right: -50%;
      width: 50%;
    }
    75%,
    100% {
      right: 100%;
      width: 50%;
    }
  }
`;

var SlProgressBar = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.value = 0;
    this.indeterminate = false;
    this.label = "";
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      "progress-bar": true,
      "progress-bar--indeterminate": this.indeterminate,
      "progress-bar--rtl": this.localize.dir() === "rtl"
    })}
        role="progressbar"
        title=${l$2(this.title)}
        aria-label=${this.label.length > 0 ? this.label : this.localize.term("progress")}
        aria-valuemin="0"
        aria-valuemax="100"
        aria-valuenow=${this.indeterminate ? 0 : this.value}
      >
        <div part="indicator" class="progress-bar__indicator" style=${o$7({ width: `${this.value}%` })}>
          ${!this.indeterminate ? x$1` <slot part="label" class="progress-bar__label"></slot> ` : ""}
        </div>
      </div>
    `;
  }
};
SlProgressBar.styles = progress_bar_styles_default;
__decorateClass([
  e$c({ type: Number, reflect: true })
], SlProgressBar.prototype, "value", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlProgressBar.prototype, "indeterminate", 2);
__decorateClass([
  e$c()
], SlProgressBar.prototype, "label", 2);

// src/components/progress-bar/progress-bar.ts
var progress_bar_default = SlProgressBar;
SlProgressBar.define("sl-progress-bar");

var menu_label_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
  }

  .menu-label {
    display: inline-block;
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-small);
    font-weight: var(--sl-font-weight-semibold);
    line-height: var(--sl-line-height-normal);
    letter-spacing: var(--sl-letter-spacing-normal);
    color: var(--sl-color-neutral-500);
    padding: var(--sl-spacing-2x-small) var(--sl-spacing-x-large);
    user-select: none;
  }
`;

var SlMenuLabel = class extends ShoelaceElement {
  render() {
    return x$1` <slot part="base" class="menu-label"></slot> `;
  }
};
SlMenuLabel.styles = menu_label_styles_default;

// src/components/menu-label/menu-label.ts
var menu_label_default = SlMenuLabel;
SlMenuLabel.define("sl-menu-label");

var mutation_observer_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: contents;
  }
`;

var SlMutationObserver = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.attrOldValue = false;
    this.charData = false;
    this.charDataOldValue = false;
    this.childList = false;
    this.disabled = false;
    this.handleMutation = (mutationList) => {
      this.emit("sl-mutation", {
        detail: { mutationList }
      });
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.mutationObserver = new MutationObserver(this.handleMutation);
    if (!this.disabled) {
      this.startObserver();
    }
  }
  disconnectedCallback() {
    this.stopObserver();
  }
  startObserver() {
    const observeAttributes = typeof this.attr === "string" && this.attr.length > 0;
    const attributeFilter = observeAttributes && this.attr !== "*" ? this.attr.split(" ") : void 0;
    try {
      this.mutationObserver.observe(this, {
        subtree: true,
        childList: this.childList,
        attributes: observeAttributes,
        attributeFilter,
        attributeOldValue: this.attrOldValue,
        characterData: this.charData,
        characterDataOldValue: this.charDataOldValue
      });
    } catch (e) {
    }
  }
  stopObserver() {
    this.mutationObserver.disconnect();
  }
  handleDisabledChange() {
    if (this.disabled) {
      this.stopObserver();
    } else {
      this.startObserver();
    }
  }
  handleChange() {
    this.stopObserver();
    this.startObserver();
  }
  render() {
    return x$1` <slot></slot> `;
  }
};
SlMutationObserver.styles = mutation_observer_styles_default;
__decorateClass([
  e$c({ reflect: true })
], SlMutationObserver.prototype, "attr", 2);
__decorateClass([
  e$c({ attribute: "attr-old-value", type: Boolean, reflect: true })
], SlMutationObserver.prototype, "attrOldValue", 2);
__decorateClass([
  e$c({ attribute: "char-data", type: Boolean, reflect: true })
], SlMutationObserver.prototype, "charData", 2);
__decorateClass([
  e$c({ attribute: "char-data-old-value", type: Boolean, reflect: true })
], SlMutationObserver.prototype, "charDataOldValue", 2);
__decorateClass([
  e$c({ attribute: "child-list", type: Boolean, reflect: true })
], SlMutationObserver.prototype, "childList", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlMutationObserver.prototype, "disabled", 2);
__decorateClass([
  watch("disabled")
], SlMutationObserver.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("attr", { waitUntilFirstUpdate: true }),
  watch("attr-old-value", { waitUntilFirstUpdate: true }),
  watch("char-data", { waitUntilFirstUpdate: true }),
  watch("char-data-old-value", { waitUntilFirstUpdate: true }),
  watch("childList", { waitUntilFirstUpdate: true })
], SlMutationObserver.prototype, "handleChange", 1);

// src/components/mutation-observer/mutation-observer.ts
var mutation_observer_default = SlMutationObserver;
SlMutationObserver.define("sl-mutation-observer");

var input_styles_default = i$b`
  ${component_styles_default}
  ${form_control_styles_default}

  :host {
    display: block;
  }

  .input {
    flex: 1 1 auto;
    display: inline-flex;
    align-items: stretch;
    justify-content: start;
    position: relative;
    width: 100%;
    font-family: var(--sl-input-font-family);
    font-weight: var(--sl-input-font-weight);
    letter-spacing: var(--sl-input-letter-spacing);
    vertical-align: middle;
    overflow: hidden;
    cursor: text;
    transition: var(--sl-transition-fast) color, var(--sl-transition-fast) border, var(--sl-transition-fast) box-shadow,
      var(--sl-transition-fast) background-color;
  }

  /* Standard inputs */
  .input--standard {
    background-color: var(--sl-input-background-color);
    border: solid var(--sl-input-border-width) var(--sl-input-border-color);
  }

  .input--standard:hover:not(.input--disabled) {
    background-color: var(--sl-input-background-color-hover);
    border-color: var(--sl-input-border-color-hover);
  }

  .input--standard.input--focused:not(.input--disabled) {
    background-color: var(--sl-input-background-color-focus);
    border-color: var(--sl-input-border-color-focus);
    box-shadow: 0 0 0 var(--sl-focus-ring-width) var(--sl-input-focus-ring-color);
  }

  .input--standard.input--focused:not(.input--disabled) .input__control {
    color: var(--sl-input-color-focus);
  }

  .input--standard.input--disabled {
    background-color: var(--sl-input-background-color-disabled);
    border-color: var(--sl-input-border-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
  }

  .input--standard.input--disabled .input__control {
    color: var(--sl-input-color-disabled);
  }

  .input--standard.input--disabled .input__control::placeholder {
    color: var(--sl-input-placeholder-color-disabled);
  }

  /* Filled inputs */
  .input--filled {
    border: none;
    background-color: var(--sl-input-filled-background-color);
    color: var(--sl-input-color);
  }

  .input--filled:hover:not(.input--disabled) {
    background-color: var(--sl-input-filled-background-color-hover);
  }

  .input--filled.input--focused:not(.input--disabled) {
    background-color: var(--sl-input-filled-background-color-focus);
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .input--filled.input--disabled {
    background-color: var(--sl-input-filled-background-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
  }

  .input__control {
    flex: 1 1 auto;
    font-family: inherit;
    font-size: inherit;
    font-weight: inherit;
    min-width: 0;
    height: 100%;
    color: var(--sl-input-color);
    border: none;
    background: inherit;
    box-shadow: none;
    padding: 0;
    margin: 0;
    cursor: inherit;
    -webkit-appearance: none;
  }

  .input__control::-webkit-search-decoration,
  .input__control::-webkit-search-cancel-button,
  .input__control::-webkit-search-results-button,
  .input__control::-webkit-search-results-decoration {
    -webkit-appearance: none;
  }

  .input__control:-webkit-autofill,
  .input__control:-webkit-autofill:hover,
  .input__control:-webkit-autofill:focus,
  .input__control:-webkit-autofill:active {
    box-shadow: 0 0 0 var(--sl-input-height-large) var(--sl-input-background-color-hover) inset !important;
    -webkit-text-fill-color: var(--sl-color-primary-500);
    caret-color: var(--sl-input-color);
  }

  .input--filled .input__control:-webkit-autofill,
  .input--filled .input__control:-webkit-autofill:hover,
  .input--filled .input__control:-webkit-autofill:focus,
  .input--filled .input__control:-webkit-autofill:active {
    box-shadow: 0 0 0 var(--sl-input-height-large) var(--sl-input-filled-background-color) inset !important;
  }

  .input__control::placeholder {
    color: var(--sl-input-placeholder-color);
    user-select: none;
  }

  .input:hover:not(.input--disabled) .input__control {
    color: var(--sl-input-color-hover);
  }

  .input__control:focus {
    outline: none;
  }

  .input__prefix,
  .input__suffix {
    display: inline-flex;
    flex: 0 0 auto;
    align-items: center;
    cursor: default;
  }

  .input__prefix ::slotted(sl-icon),
  .input__suffix ::slotted(sl-icon) {
    color: var(--sl-input-icon-color);
  }

  /*
   * Size modifiers
   */

  .input--small {
    border-radius: var(--sl-input-border-radius-small);
    font-size: var(--sl-input-font-size-small);
    height: var(--sl-input-height-small);
  }

  .input--small .input__control {
    height: calc(var(--sl-input-height-small) - var(--sl-input-border-width) * 2);
    padding: 0 var(--sl-input-spacing-small);
  }

  .input--small .input__clear,
  .input--small .input__password-toggle {
    width: calc(1em + var(--sl-input-spacing-small) * 2);
  }

  .input--small .input__prefix ::slotted(*) {
    margin-inline-start: var(--sl-input-spacing-small);
  }

  .input--small .input__suffix ::slotted(*) {
    margin-inline-end: var(--sl-input-spacing-small);
  }

  .input--medium {
    border-radius: var(--sl-input-border-radius-medium);
    font-size: var(--sl-input-font-size-medium);
    height: var(--sl-input-height-medium);
  }

  .input--medium .input__control {
    height: calc(var(--sl-input-height-medium) - var(--sl-input-border-width) * 2);
    padding: 0 var(--sl-input-spacing-medium);
  }

  .input--medium .input__clear,
  .input--medium .input__password-toggle {
    width: calc(1em + var(--sl-input-spacing-medium) * 2);
  }

  .input--medium .input__prefix ::slotted(*) {
    margin-inline-start: var(--sl-input-spacing-medium);
  }

  .input--medium .input__suffix ::slotted(*) {
    margin-inline-end: var(--sl-input-spacing-medium);
  }

  .input--large {
    border-radius: var(--sl-input-border-radius-large);
    font-size: var(--sl-input-font-size-large);
    height: var(--sl-input-height-large);
  }

  .input--large .input__control {
    height: calc(var(--sl-input-height-large) - var(--sl-input-border-width) * 2);
    padding: 0 var(--sl-input-spacing-large);
  }

  .input--large .input__clear,
  .input--large .input__password-toggle {
    width: calc(1em + var(--sl-input-spacing-large) * 2);
  }

  .input--large .input__prefix ::slotted(*) {
    margin-inline-start: var(--sl-input-spacing-large);
  }

  .input--large .input__suffix ::slotted(*) {
    margin-inline-end: var(--sl-input-spacing-large);
  }

  /*
   * Pill modifier
   */

  .input--pill.input--small {
    border-radius: var(--sl-input-height-small);
  }

  .input--pill.input--medium {
    border-radius: var(--sl-input-height-medium);
  }

  .input--pill.input--large {
    border-radius: var(--sl-input-height-large);
  }

  /*
   * Clearable + Password Toggle
   */

  .input__clear:not(.input__clear--visible) {
    visibility: hidden;
  }

  .input__clear,
  .input__password-toggle {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    font-size: inherit;
    color: var(--sl-input-icon-color);
    border: none;
    background: none;
    padding: 0;
    transition: var(--sl-transition-fast) color;
    cursor: pointer;
  }

  .input__clear:hover,
  .input__password-toggle:hover {
    color: var(--sl-input-icon-color-hover);
  }

  .input__clear:focus,
  .input__password-toggle:focus {
    outline: none;
  }

  .input--empty .input__clear {
    visibility: hidden;
  }

  /* Don't show the browser's password toggle in Edge */
  ::-ms-reveal {
    display: none;
  }

  /* Hide the built-in number spinner */
  .input--no-spin-buttons input[type='number']::-webkit-outer-spin-button,
  .input--no-spin-buttons input[type='number']::-webkit-inner-spin-button {
    -webkit-appearance: none;
    display: none;
  }

  .input--no-spin-buttons input[type='number'] {
    -moz-appearance: textfield;
  }
`;

var SlInput = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      assumeInteractionOn: ["sl-blur", "sl-input"]
    });
    this.hasSlotController = new HasSlotController$1(this, "help-text", "label");
    this.localize = new LocalizeController(this);
    this.hasFocus = false;
    this.title = "";
    // make reactive to pass through
    this.__numberInput = Object.assign(document.createElement("input"), { type: "number" });
    this.__dateInput = Object.assign(document.createElement("input"), { type: "date" });
    this.type = "text";
    this.name = "";
    this.value = "";
    this.defaultValue = "";
    this.size = "medium";
    this.filled = false;
    this.pill = false;
    this.label = "";
    this.helpText = "";
    this.clearable = false;
    this.disabled = false;
    this.placeholder = "";
    this.readonly = false;
    this.passwordToggle = false;
    this.passwordVisible = false;
    this.noSpinButtons = false;
    this.form = "";
    this.required = false;
    this.spellcheck = true;
  }
  //
  // NOTE: We use an in-memory input for these getters/setters instead of the one in the template because the properties
  // can be set before the component is rendered.
  //
  /**
   * Gets or sets the current value as a `Date` object. Returns `null` if the value can't be converted. This will use the native `<input type="{{type}}">` implementation and may result in an error.
   */
  get valueAsDate() {
    var _a;
    this.__dateInput.type = this.type;
    this.__dateInput.value = this.value;
    return ((_a = this.input) == null ? void 0 : _a.valueAsDate) || this.__dateInput.valueAsDate;
  }
  set valueAsDate(newValue) {
    this.__dateInput.type = this.type;
    this.__dateInput.valueAsDate = newValue;
    this.value = this.__dateInput.value;
  }
  /** Gets or sets the current value as a number. Returns `NaN` if the value can't be converted. */
  get valueAsNumber() {
    var _a;
    this.__numberInput.value = this.value;
    return ((_a = this.input) == null ? void 0 : _a.valueAsNumber) || this.__numberInput.valueAsNumber;
  }
  set valueAsNumber(newValue) {
    this.__numberInput.valueAsNumber = newValue;
    this.value = this.__numberInput.value;
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleChange() {
    this.value = this.input.value;
    this.emit("sl-change");
  }
  handleClearClick(event) {
    this.value = "";
    this.emit("sl-clear");
    this.emit("sl-input");
    this.emit("sl-change");
    this.input.focus();
    event.stopPropagation();
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleInput() {
    this.value = this.input.value;
    this.formControlController.updateValidity();
    this.emit("sl-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleKeyDown(event) {
    const hasModifier = event.metaKey || event.ctrlKey || event.shiftKey || event.altKey;
    if (event.key === "Enter" && !hasModifier) {
      setTimeout(() => {
        if (!event.defaultPrevented && !event.isComposing) {
          this.formControlController.submit();
        }
      });
    }
  }
  handlePasswordToggle() {
    this.passwordVisible = !this.passwordVisible;
  }
  handleDisabledChange() {
    this.formControlController.setValidity(this.disabled);
  }
  handleStepChange() {
    this.input.step = String(this.step);
    this.formControlController.updateValidity();
  }
  async handleValueChange() {
    await this.updateComplete;
    this.formControlController.updateValidity();
  }
  /** Sets focus on the input. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the input. */
  blur() {
    this.input.blur();
  }
  /** Selects all the text in the input. */
  select() {
    this.input.select();
  }
  /** Sets the start and end positions of the text selection (0-based). */
  setSelectionRange(selectionStart, selectionEnd, selectionDirection = "none") {
    this.input.setSelectionRange(selectionStart, selectionEnd, selectionDirection);
  }
  /** Replaces a range of text with a new string. */
  setRangeText(replacement, start, end, selectMode) {
    this.input.setRangeText(replacement, start, end, selectMode);
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
  }
  /** Displays the browser picker for an input element (only works if the browser supports it for the input type). */
  showPicker() {
    if ("showPicker" in HTMLInputElement.prototype) {
      this.input.showPicker();
    }
  }
  /** Increments the value of a numeric input type by the value of the step attribute. */
  stepUp() {
    this.input.stepUp();
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
  }
  /** Decrements the value of a numeric input type by the value of the step attribute. */
  stepDown() {
    this.input.stepDown();
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    const hasClearIcon = this.clearable && !this.disabled && !this.readonly;
    const isClearIconVisible = hasClearIcon && (typeof this.value === "number" || this.value.length > 0);
    return x$1`
      <div
        part="form-control"
        class=${o$9({
      "form-control": true,
      "form-control--small": this.size === "small",
      "form-control--medium": this.size === "medium",
      "form-control--large": this.size === "large",
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText
    })}
      >
        <label
          part="form-control-label"
          class="form-control__label"
          for="input"
          aria-hidden=${hasLabel ? "false" : "true"}
        >
          <slot name="label">${this.label}</slot>
        </label>

        <div part="form-control-input" class="form-control-input">
          <div
            part="base"
            class=${o$9({
      input: true,
      // Sizes
      "input--small": this.size === "small",
      "input--medium": this.size === "medium",
      "input--large": this.size === "large",
      // States
      "input--pill": this.pill,
      "input--standard": !this.filled,
      "input--filled": this.filled,
      "input--disabled": this.disabled,
      "input--focused": this.hasFocus,
      "input--empty": !this.value,
      "input--no-spin-buttons": this.noSpinButtons
    })}
          >
            <span part="prefix" class="input__prefix">
              <slot name="prefix"></slot>
            </span>

            <input
              part="input"
              id="input"
              class="input__control"
              type=${this.type === "password" && this.passwordVisible ? "text" : this.type}
              title=${this.title}
              name=${l$2(this.name)}
              ?disabled=${this.disabled}
              ?readonly=${this.readonly}
              ?required=${this.required}
              placeholder=${l$2(this.placeholder)}
              minlength=${l$2(this.minlength)}
              maxlength=${l$2(this.maxlength)}
              min=${l$2(this.min)}
              max=${l$2(this.max)}
              step=${l$2(this.step)}
              .value=${l$1(this.value)}
              autocapitalize=${l$2(this.autocapitalize)}
              autocomplete=${l$2(this.autocomplete)}
              autocorrect=${l$2(this.autocorrect)}
              ?autofocus=${this.autofocus}
              spellcheck=${this.spellcheck}
              pattern=${l$2(this.pattern)}
              enterkeyhint=${l$2(this.enterkeyhint)}
              inputmode=${l$2(this.inputmode)}
              aria-describedby="help-text"
              @change=${this.handleChange}
              @input=${this.handleInput}
              @invalid=${this.handleInvalid}
              @keydown=${this.handleKeyDown}
              @focus=${this.handleFocus}
              @blur=${this.handleBlur}
            />

            ${hasClearIcon ? x$1`
                  <button
                    part="clear-button"
                    class=${o$9({
      input__clear: true,
      "input__clear--visible": isClearIconVisible
    })}
                    type="button"
                    aria-label=${this.localize.term("clearEntry")}
                    @click=${this.handleClearClick}
                    tabindex="-1"
                  >
                    <slot name="clear-icon">
                      <sl-icon name="x-circle-fill" library="system"></sl-icon>
                    </slot>
                  </button>
                ` : ""}
            ${this.passwordToggle && !this.disabled ? x$1`
                  <button
                    part="password-toggle-button"
                    class="input__password-toggle"
                    type="button"
                    aria-label=${this.localize.term(this.passwordVisible ? "hidePassword" : "showPassword")}
                    @click=${this.handlePasswordToggle}
                    tabindex="-1"
                  >
                    ${this.passwordVisible ? x$1`
                          <slot name="show-password-icon">
                            <sl-icon name="eye-slash" library="system"></sl-icon>
                          </slot>
                        ` : x$1`
                          <slot name="hide-password-icon">
                            <sl-icon name="eye" library="system"></sl-icon>
                          </slot>
                        `}
                  </button>
                ` : ""}

            <span part="suffix" class="input__suffix">
              <slot name="suffix"></slot>
            </span>
          </div>
        </div>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </div>
    `;
  }
};
SlInput.styles = input_styles_default;
SlInput.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7(".input__control")
], SlInput.prototype, "input", 2);
__decorateClass([
  t$7()
], SlInput.prototype, "hasFocus", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "title", 2);
__decorateClass([
  e$c({ reflect: true })
], SlInput.prototype, "type", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "name", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "value", 2);
__decorateClass([
  defaultValue()
], SlInput.prototype, "defaultValue", 2);
__decorateClass([
  e$c({ reflect: true })
], SlInput.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlInput.prototype, "filled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlInput.prototype, "pill", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "label", 2);
__decorateClass([
  e$c({ attribute: "help-text" })
], SlInput.prototype, "helpText", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlInput.prototype, "clearable", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlInput.prototype, "disabled", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "placeholder", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlInput.prototype, "readonly", 2);
__decorateClass([
  e$c({ attribute: "password-toggle", type: Boolean })
], SlInput.prototype, "passwordToggle", 2);
__decorateClass([
  e$c({ attribute: "password-visible", type: Boolean })
], SlInput.prototype, "passwordVisible", 2);
__decorateClass([
  e$c({ attribute: "no-spin-buttons", type: Boolean })
], SlInput.prototype, "noSpinButtons", 2);
__decorateClass([
  e$c({ reflect: true })
], SlInput.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlInput.prototype, "required", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "pattern", 2);
__decorateClass([
  e$c({ type: Number })
], SlInput.prototype, "minlength", 2);
__decorateClass([
  e$c({ type: Number })
], SlInput.prototype, "maxlength", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "min", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "max", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "step", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "autocapitalize", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "autocorrect", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "autocomplete", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlInput.prototype, "autofocus", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "enterkeyhint", 2);
__decorateClass([
  e$c({
    type: Boolean,
    converter: {
      // Allow "true|false" attribute values but keep the property boolean
      fromAttribute: (value) => !value || value === "false" ? false : true,
      toAttribute: (value) => value ? "true" : "false"
    }
  })
], SlInput.prototype, "spellcheck", 2);
__decorateClass([
  e$c()
], SlInput.prototype, "inputmode", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlInput.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("step", { waitUntilFirstUpdate: true })
], SlInput.prototype, "handleStepChange", 1);
__decorateClass([
  watch("value", { waitUntilFirstUpdate: true })
], SlInput.prototype, "handleValueChange", 1);

// src/components/input/input.ts
var input_default = SlInput;
SlInput.define("sl-input");

var menu_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
    position: relative;
    background: var(--sl-panel-background-color);
    border: solid var(--sl-panel-border-width) var(--sl-panel-border-color);
    border-radius: var(--sl-border-radius-medium);
    padding: var(--sl-spacing-x-small) 0;
    overflow: auto;
    overscroll-behavior: none;
  }

  ::slotted(sl-divider) {
    --spacing: var(--sl-spacing-x-small);
  }
`;

// src/components/menu-item/submenu-controller.ts
var SubmenuController = class {
  constructor(host, hasSlotController, localize) {
    this.popupRef = e$3();
    this.enableSubmenuTimer = -1;
    this.isConnected = false;
    this.isPopupConnected = false;
    this.skidding = 0;
    this.submenuOpenDelay = 100;
    this.handleMouseOver = () => {
      if (this.hasSlotController.test("submenu")) {
        this.enableSubmenu();
      }
    };
    // Focus on the first menu-item of a submenu.
    this.handleKeyDown = (event) => {
      switch (event.key) {
        case "Escape":
        case "Tab":
          this.disableSubmenu();
          break;
        case "ArrowLeft":
          if (event.target !== this.host) {
            event.preventDefault();
            event.stopPropagation();
            this.host.focus();
            this.disableSubmenu();
          }
          break;
        case "ArrowRight":
        case "Enter":
        case " ":
          this.handleSubmenuEntry(event);
          break;
        default:
          break;
      }
    };
    this.handleClick = (event) => {
      var _a;
      if (event.target === this.host) {
        event.preventDefault();
        event.stopPropagation();
      } else if (event.target instanceof Element && (event.target.tagName === "sl-menu-item" || ((_a = event.target.role) == null ? void 0 : _a.startsWith("menuitem")))) {
        this.disableSubmenu();
      }
    };
    // Close this submenu on focus outside of the parent or any descendants.
    this.handleFocusOut = (event) => {
      if (event.relatedTarget && event.relatedTarget instanceof Element && this.host.contains(event.relatedTarget)) {
        return;
      }
      this.disableSubmenu();
    };
    // Prevent the parent menu-item from getting focus on mouse movement on the submenu
    this.handlePopupMouseover = (event) => {
      event.stopPropagation();
    };
    (this.host = host).addController(this);
    this.hasSlotController = hasSlotController;
    this.localize = localize;
  }
  hostConnected() {
    if (this.hasSlotController.test("submenu") && !this.host.disabled) {
      this.addListeners();
    }
  }
  hostDisconnected() {
    this.removeListeners();
  }
  hostUpdated() {
    if (this.hasSlotController.test("submenu") && !this.host.disabled) {
      this.addListeners();
      this.updateSkidding();
    } else {
      this.removeListeners();
    }
  }
  addListeners() {
    if (!this.isConnected) {
      this.host.addEventListener("mouseover", this.handleMouseOver);
      this.host.addEventListener("keydown", this.handleKeyDown);
      this.host.addEventListener("click", this.handleClick);
      this.host.addEventListener("focusout", this.handleFocusOut);
      this.isConnected = true;
    }
    if (!this.isPopupConnected) {
      if (this.popupRef.value) {
        this.popupRef.value.addEventListener("mouseover", this.handlePopupMouseover);
        this.isPopupConnected = true;
      }
    }
  }
  removeListeners() {
    if (this.isConnected) {
      this.host.removeEventListener("mouseover", this.handleMouseOver);
      this.host.removeEventListener("keydown", this.handleKeyDown);
      this.host.removeEventListener("click", this.handleClick);
      this.host.removeEventListener("focusout", this.handleFocusOut);
      this.isConnected = false;
    }
    if (this.isPopupConnected) {
      if (this.popupRef.value) {
        this.popupRef.value.removeEventListener("mouseover", this.handlePopupMouseover);
        this.isPopupConnected = false;
      }
    }
  }
  handleSubmenuEntry(event) {
    const submenuSlot = this.host.renderRoot.querySelector("slot[name='submenu']");
    if (!submenuSlot) {
      console.error("Cannot activate a submenu if no corresponding menuitem can be found.", this);
      return;
    }
    let menuItems = null;
    for (const elt of submenuSlot.assignedElements()) {
      menuItems = elt.querySelectorAll("sl-menu-item, [role^='menuitem']");
      if (menuItems.length !== 0) {
        break;
      }
    }
    if (!menuItems || menuItems.length === 0) {
      return;
    }
    menuItems[0].setAttribute("tabindex", "0");
    for (let i = 1; i !== menuItems.length; ++i) {
      menuItems[i].setAttribute("tabindex", "-1");
    }
    if (this.popupRef.value) {
      event.preventDefault();
      event.stopPropagation();
      if (this.popupRef.value.active) {
        if (menuItems[0] instanceof HTMLElement) {
          menuItems[0].focus();
        }
      } else {
        this.enableSubmenu(false);
        this.host.updateComplete.then(() => {
          if (menuItems[0] instanceof HTMLElement) {
            menuItems[0].focus();
          }
        });
        this.host.requestUpdate();
      }
    }
  }
  setSubmenuState(state) {
    if (this.popupRef.value) {
      if (this.popupRef.value.active !== state) {
        this.popupRef.value.active = state;
        this.host.requestUpdate();
      }
    }
  }
  // Shows the submenu. Supports disabling the opening delay, e.g. for keyboard events that want to set the focus to the
  // newly opened menu.
  enableSubmenu(delay = true) {
    if (delay) {
      this.enableSubmenuTimer = window.setTimeout(() => {
        this.setSubmenuState(true);
      }, this.submenuOpenDelay);
    } else {
      this.setSubmenuState(true);
    }
  }
  disableSubmenu() {
    clearTimeout(this.enableSubmenuTimer);
    this.setSubmenuState(false);
  }
  // Calculate the space the top of a menu takes-up, for aligning the popup menu-item with the activating element.
  updateSkidding() {
    var _a;
    if (!((_a = this.host.parentElement) == null ? void 0 : _a.computedStyleMap)) {
      return;
    }
    const styleMap = this.host.parentElement.computedStyleMap();
    const attrs = ["padding-top", "border-top-width", "margin-top"];
    const skidding = attrs.reduce((accumulator, attr) => {
      var _a2;
      const styleValue = (_a2 = styleMap.get(attr)) != null ? _a2 : new CSSUnitValue(0, "px");
      const unitValue = styleValue instanceof CSSUnitValue ? styleValue : new CSSUnitValue(0, "px");
      const pxValue = unitValue.to("px");
      return accumulator - pxValue.value;
    }, 0);
    this.skidding = skidding;
  }
  isExpanded() {
    return this.popupRef.value ? this.popupRef.value.active : false;
  }
  renderSubmenu() {
    const isLtr = this.localize.dir() === "ltr";
    if (!this.isConnected) {
      return x$1` <slot name="submenu" hidden></slot> `;
    }
    return x$1`
      <sl-popup
        ${n$5(this.popupRef)}
        placement=${isLtr ? "right-start" : "left-start"}
        anchor="anchor"
        flip
        flip-fallback-strategy="best-fit"
        skidding="${this.skidding}"
        strategy="fixed"
      >
        <slot name="submenu"></slot>
      </sl-popup>
    `;
  }
};

var menu_item_styles_default = i$b`
  ${component_styles_default}

  :host {
    --submenu-offset: -2px;

    display: block;
  }

  :host([inert]) {
    display: none;
  }

  .menu-item {
    position: relative;
    display: flex;
    align-items: stretch;
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-medium);
    font-weight: var(--sl-font-weight-normal);
    line-height: var(--sl-line-height-normal);
    letter-spacing: var(--sl-letter-spacing-normal);
    color: var(--sl-color-neutral-700);
    padding: var(--sl-spacing-2x-small) var(--sl-spacing-2x-small);
    transition: var(--sl-transition-fast) fill;
    user-select: none;
    white-space: nowrap;
    cursor: pointer;
  }

  .menu-item.menu-item--disabled {
    outline: none;
    opacity: 0.5;
    cursor: not-allowed;
  }

  .menu-item .menu-item__label {
    flex: 1 1 auto;
    display: inline-block;
    text-overflow: ellipsis;
    overflow: hidden;
  }

  .menu-item .menu-item__prefix {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
  }

  .menu-item .menu-item__prefix::slotted(*) {
    margin-inline-end: var(--sl-spacing-x-small);
  }

  .menu-item .menu-item__suffix {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
  }

  .menu-item .menu-item__suffix::slotted(*) {
    margin-inline-start: var(--sl-spacing-x-small);
  }

  :host(:focus-visible) {
    outline: none;
  }

  :host(:hover:not([aria-disabled='true'], :focus-visible)) .menu-item,
  .menu-item--submenu-expanded {
    background-color: var(--sl-color-neutral-100);
    color: var(--sl-color-neutral-1000);
  }

  :host(:focus-visible) .menu-item {
    outline: none;
    background-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
    opacity: 1;
  }

  .menu-item .menu-item__check,
  .menu-item .menu-item__chevron {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    justify-content: center;
    width: 1.5em;
    visibility: hidden;
  }

  .menu-item--checked .menu-item__check,
  .menu-item--has-submenu .menu-item__chevron {
    visibility: visible;
  }

  /* Add elevation and z-index to submenus */
  sl-popup::part(popup) {
    box-shadow: var(--sl-shadow-large);
    z-index: var(--sl-z-index-dropdown);
    margin-left: var(--submenu-offset);
  }

  .menu-item--rtl sl-popup::part(popup) {
    margin-left: calc(-1 * var(--submenu-offset));
  }

  @media (forced-colors: active) {
    :host(:hover:not([aria-disabled='true'])) .menu-item,
    :host(:focus-visible) .menu-item {
      outline: dashed 1px SelectedItem;
      outline-offset: -1px;
    }
  }
`;

var SlMenuItem = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.type = "normal";
    this.checked = false;
    this.value = "";
    this.disabled = false;
    this.localize = new LocalizeController(this);
    this.hasSlotController = new HasSlotController$1(this, "submenu");
    this.submenuController = new SubmenuController(this, this.hasSlotController, this.localize);
    this.handleHostClick = (event) => {
      if (this.disabled) {
        event.preventDefault();
        event.stopImmediatePropagation();
      }
    };
    this.handleMouseOver = (event) => {
      this.focus();
      event.stopPropagation();
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.addEventListener("click", this.handleHostClick);
    this.addEventListener("mouseover", this.handleMouseOver);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("click", this.handleHostClick);
    this.removeEventListener("mouseover", this.handleMouseOver);
  }
  handleDefaultSlotChange() {
    const textLabel = this.getTextLabel();
    if (typeof this.cachedTextLabel === "undefined") {
      this.cachedTextLabel = textLabel;
      return;
    }
    if (textLabel !== this.cachedTextLabel) {
      this.cachedTextLabel = textLabel;
      this.emit("slotchange", { bubbles: true, composed: false, cancelable: false });
    }
  }
  handleCheckedChange() {
    if (this.checked && this.type !== "checkbox") {
      this.checked = false;
      console.error('The checked attribute can only be used on menu items with type="checkbox"', this);
      return;
    }
    if (this.type === "checkbox") {
      this.setAttribute("aria-checked", this.checked ? "true" : "false");
    } else {
      this.removeAttribute("aria-checked");
    }
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  handleTypeChange() {
    if (this.type === "checkbox") {
      this.setAttribute("role", "menuitemcheckbox");
      this.setAttribute("aria-checked", this.checked ? "true" : "false");
    } else {
      this.setAttribute("role", "menuitem");
      this.removeAttribute("aria-checked");
    }
  }
  /** Returns a text label based on the contents of the menu item's default slot. */
  getTextLabel() {
    return getTextContent$1(this.defaultSlot);
  }
  isSubmenu() {
    return this.hasSlotController.test("submenu");
  }
  render() {
    const isRtl = this.localize.dir() === "rtl";
    const isSubmenuExpanded = this.submenuController.isExpanded();
    return x$1`
      <div
        id="anchor"
        part="base"
        class=${o$9({
      "menu-item": true,
      "menu-item--rtl": isRtl,
      "menu-item--checked": this.checked,
      "menu-item--disabled": this.disabled,
      "menu-item--has-submenu": this.isSubmenu(),
      "menu-item--submenu-expanded": isSubmenuExpanded
    })}
        ?aria-haspopup="${this.isSubmenu()}"
        ?aria-expanded="${isSubmenuExpanded ? true : false}"
      >
        <span part="checked-icon" class="menu-item__check">
          <sl-icon name="check" library="system" aria-hidden="true"></sl-icon>
        </span>

        <slot name="prefix" part="prefix" class="menu-item__prefix"></slot>

        <slot part="label" class="menu-item__label" @slotchange=${this.handleDefaultSlotChange}></slot>

        <slot name="suffix" part="suffix" class="menu-item__suffix"></slot>

        <span part="submenu-icon" class="menu-item__chevron">
          <sl-icon name=${isRtl ? "chevron-left" : "chevron-right"} library="system" aria-hidden="true"></sl-icon>
        </span>

        ${this.submenuController.renderSubmenu()}
      </div>
    `;
  }
};
SlMenuItem.styles = menu_item_styles_default;
SlMenuItem.dependencies = {
  "sl-icon": SlIcon,
  "sl-popup": SlPopup
};
__decorateClass([
  i$7("slot:not([name])")
], SlMenuItem.prototype, "defaultSlot", 2);
__decorateClass([
  i$7(".menu-item")
], SlMenuItem.prototype, "menuItem", 2);
__decorateClass([
  e$c()
], SlMenuItem.prototype, "type", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlMenuItem.prototype, "checked", 2);
__decorateClass([
  e$c()
], SlMenuItem.prototype, "value", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlMenuItem.prototype, "disabled", 2);
__decorateClass([
  watch("checked")
], SlMenuItem.prototype, "handleCheckedChange", 1);
__decorateClass([
  watch("disabled")
], SlMenuItem.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("type")
], SlMenuItem.prototype, "handleTypeChange", 1);

var SlMenu = class extends ShoelaceElement {
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "menu");
  }
  handleClick(event) {
    if (!(event.target instanceof SlMenuItem)) {
      return;
    }
    const item = event.target;
    if (item.type === "checkbox") {
      item.checked = !item.checked;
    }
    this.emit("sl-select", { detail: { item } });
  }
  handleKeyDown(event) {
    if (event.key === "Enter" || event.key === " ") {
      const item = this.getCurrentItem();
      event.preventDefault();
      event.stopPropagation();
      item == null ? void 0 : item.click();
    } else if (["ArrowDown", "ArrowUp", "Home", "End"].includes(event.key)) {
      const items = this.getAllItems();
      const activeItem = this.getCurrentItem();
      let index = activeItem ? items.indexOf(activeItem) : 0;
      if (items.length > 0) {
        event.preventDefault();
        event.stopPropagation();
        if (event.key === "ArrowDown") {
          index++;
        } else if (event.key === "ArrowUp") {
          index--;
        } else if (event.key === "Home") {
          index = 0;
        } else if (event.key === "End") {
          index = items.length - 1;
        }
        if (index < 0) {
          index = items.length - 1;
        }
        if (index > items.length - 1) {
          index = 0;
        }
        this.setCurrentItem(items[index]);
        items[index].focus();
      }
    }
  }
  handleMouseDown(event) {
    const target = event.target;
    if (this.isMenuItem(target)) {
      this.setCurrentItem(target);
    }
  }
  handleSlotChange() {
    const items = this.getAllItems();
    if (items.length > 0) {
      this.setCurrentItem(items[0]);
    }
  }
  isMenuItem(item) {
    var _a;
    return item.tagName.toLowerCase() === "sl-menu-item" || ["menuitem", "menuitemcheckbox", "menuitemradio"].includes((_a = item.getAttribute("role")) != null ? _a : "");
  }
  /** @internal Gets all slotted menu items, ignoring dividers, headers, and other elements. */
  getAllItems() {
    return [...this.defaultSlot.assignedElements({ flatten: true })].filter((el) => {
      if (el.inert || !this.isMenuItem(el)) {
        return false;
      }
      return true;
    });
  }
  /**
   * @internal Gets the current menu item, which is the menu item that has `tabindex="0"` within the roving tab index.
   * The menu item may or may not have focus, but for keyboard interaction purposes it's considered the "active" item.
   */
  getCurrentItem() {
    return this.getAllItems().find((i) => i.getAttribute("tabindex") === "0");
  }
  /**
   * @internal Sets the current menu item to the specified element. This sets `tabindex="0"` on the target element and
   * `tabindex="-1"` to all other items. This method must be called prior to setting focus on a menu item.
   */
  setCurrentItem(item) {
    const items = this.getAllItems();
    items.forEach((i) => {
      i.setAttribute("tabindex", i === item ? "0" : "-1");
    });
  }
  render() {
    return x$1`
      <slot
        @slotchange=${this.handleSlotChange}
        @click=${this.handleClick}
        @keydown=${this.handleKeyDown}
        @mousedown=${this.handleMouseDown}
      ></slot>
    `;
  }
};
SlMenu.styles = menu_styles_default;
__decorateClass([
  i$7("slot")
], SlMenu.prototype, "defaultSlot", 2);

// src/components/menu/menu.ts
var menu_default = SlMenu;
SlMenu.define("sl-menu");

// src/components/menu-item/menu-item.ts
var menu_item_default = SlMenuItem;
SlMenuItem.define("sl-menu-item");

var image_comparer_styles_default = i$b`
  ${component_styles_default}

  :host {
    --divider-width: 2px;
    --handle-size: 2.5rem;

    display: inline-block;
    position: relative;
  }

  .image-comparer {
    max-width: 100%;
    max-height: 100%;
    overflow: hidden;
  }

  .image-comparer__before,
  .image-comparer__after {
    display: block;
    pointer-events: none;
  }

  .image-comparer__before::slotted(img),
  .image-comparer__after::slotted(img),
  .image-comparer__before::slotted(svg),
  .image-comparer__after::slotted(svg) {
    display: block;
    max-width: 100% !important;
    height: auto;
  }

  .image-comparer__after {
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
  }

  .image-comparer__divider {
    display: flex;
    align-items: center;
    justify-content: center;
    position: absolute;
    top: 0;
    width: var(--divider-width);
    height: 100%;
    background-color: var(--sl-color-neutral-0);
    translate: calc(var(--divider-width) / -2);
    cursor: ew-resize;
  }

  .image-comparer__handle {
    display: flex;
    align-items: center;
    justify-content: center;
    position: absolute;
    top: calc(50% - (var(--handle-size) / 2));
    width: var(--handle-size);
    height: var(--handle-size);
    background-color: var(--sl-color-neutral-0);
    border-radius: var(--sl-border-radius-circle);
    font-size: calc(var(--handle-size) * 0.5);
    color: var(--sl-color-neutral-700);
    cursor: inherit;
    z-index: 10;
  }

  .image-comparer__handle:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }
`;

var SlImageComparer = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.position = 50;
  }
  handleDrag(event) {
    const { width } = this.base.getBoundingClientRect();
    const isRtl = this.localize.dir() === "rtl";
    event.preventDefault();
    drag$1(this.base, {
      onMove: (x) => {
        this.position = parseFloat(clamp$1(x / width * 100, 0, 100).toFixed(2));
        if (isRtl)
          this.position = 100 - this.position;
      },
      initialEvent: event
    });
  }
  handleKeyDown(event) {
    const isLtr = this.localize.dir() === "ltr";
    const isRtl = this.localize.dir() === "rtl";
    if (["ArrowLeft", "ArrowRight", "Home", "End"].includes(event.key)) {
      const incr = event.shiftKey ? 10 : 1;
      let newPosition = this.position;
      event.preventDefault();
      if (isLtr && event.key === "ArrowLeft" || isRtl && event.key === "ArrowRight") {
        newPosition -= incr;
      }
      if (isLtr && event.key === "ArrowRight" || isRtl && event.key === "ArrowLeft") {
        newPosition += incr;
      }
      if (event.key === "Home") {
        newPosition = 0;
      }
      if (event.key === "End") {
        newPosition = 100;
      }
      newPosition = clamp$1(newPosition, 0, 100);
      this.position = newPosition;
    }
  }
  handlePositionChange() {
    this.emit("sl-change");
  }
  render() {
    const isRtl = this.localize.dir() === "rtl";
    return x$1`
      <div
        part="base"
        id="image-comparer"
        class=${o$9({
      "image-comparer": true,
      "image-comparer--rtl": isRtl
    })}
        @keydown=${this.handleKeyDown}
      >
        <div class="image-comparer__image">
          <div part="before" class="image-comparer__before">
            <slot name="before"></slot>
          </div>

          <div
            part="after"
            class="image-comparer__after"
            style=${o$7({
      clipPath: isRtl ? `inset(0 0 0 ${100 - this.position}%)` : `inset(0 ${100 - this.position}% 0 0)`
    })}
          >
            <slot name="after"></slot>
          </div>
        </div>

        <div
          part="divider"
          class="image-comparer__divider"
          style=${o$7({
      left: isRtl ? `${100 - this.position}%` : `${this.position}%`
    })}
          @mousedown=${this.handleDrag}
          @touchstart=${this.handleDrag}
        >
          <div
            part="handle"
            class="image-comparer__handle"
            role="scrollbar"
            aria-valuenow=${this.position}
            aria-valuemin="0"
            aria-valuemax="100"
            aria-controls="image-comparer"
            tabindex="0"
          >
            <slot name="handle">
              <sl-icon library="system" name="grip-vertical"></sl-icon>
            </slot>
          </div>
        </div>
      </div>
    `;
  }
};
SlImageComparer.styles = image_comparer_styles_default;
SlImageComparer.scopedElement = { "sl-icon": SlIcon };
__decorateClass([
  i$7(".image-comparer")
], SlImageComparer.prototype, "base", 2);
__decorateClass([
  i$7(".image-comparer__handle")
], SlImageComparer.prototype, "handle", 2);
__decorateClass([
  e$c({ type: Number, reflect: true })
], SlImageComparer.prototype, "position", 2);
__decorateClass([
  watch("position", { waitUntilFirstUpdate: true })
], SlImageComparer.prototype, "handlePositionChange", 1);

// src/components/image-comparer/image-comparer.ts
var image_comparer_default = SlImageComparer;
SlImageComparer.define("sl-image-comparer");

var include_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
  }
`;

// src/components/include/request.ts
var includeFiles = /* @__PURE__ */ new Map();
function requestInclude(src, mode = "cors") {
  const prev = includeFiles.get(src);
  if (prev !== void 0) {
    return Promise.resolve(prev);
  }
  const fileDataPromise = fetch(src, { mode }).then(async (response) => {
    const res = {
      ok: response.ok,
      status: response.status,
      html: await response.text()
    };
    includeFiles.set(src, res);
    return res;
  });
  includeFiles.set(src, fileDataPromise);
  return fileDataPromise;
}

var SlInclude = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.mode = "cors";
    this.allowScripts = false;
  }
  executeScript(script) {
    const newScript = document.createElement("script");
    [...script.attributes].forEach((attr) => newScript.setAttribute(attr.name, attr.value));
    newScript.textContent = script.textContent;
    script.parentNode.replaceChild(newScript, script);
  }
  async handleSrcChange() {
    try {
      const src = this.src;
      const file = await requestInclude(src, this.mode);
      if (src !== this.src) {
        return;
      }
      if (!file.ok) {
        this.emit("sl-error", { detail: { status: file.status } });
        return;
      }
      this.innerHTML = file.html;
      if (this.allowScripts) {
        [...this.querySelectorAll("script")].forEach((script) => this.executeScript(script));
      }
      this.emit("sl-load");
    } catch (e) {
      this.emit("sl-error", { detail: { status: -1 } });
    }
  }
  render() {
    return x$1`<slot></slot>`;
  }
};
SlInclude.styles = include_styles_default;
__decorateClass([
  e$c()
], SlInclude.prototype, "src", 2);
__decorateClass([
  e$c()
], SlInclude.prototype, "mode", 2);
__decorateClass([
  e$c({ attribute: "allow-scripts", type: Boolean })
], SlInclude.prototype, "allowScripts", 2);
__decorateClass([
  watch("src")
], SlInclude.prototype, "handleSrcChange", 1);

// src/components/include/include.ts
var include_default = SlInclude;
SlInclude.define("sl-include");

var SlFormatNumber = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.value = 0;
    this.type = "decimal";
    this.noGrouping = false;
    this.currency = "USD";
    this.currencyDisplay = "symbol";
  }
  render() {
    if (isNaN(this.value)) {
      return "";
    }
    return this.localize.number(this.value, {
      style: this.type,
      currency: this.currency,
      currencyDisplay: this.currencyDisplay,
      useGrouping: !this.noGrouping,
      minimumIntegerDigits: this.minimumIntegerDigits,
      minimumFractionDigits: this.minimumFractionDigits,
      maximumFractionDigits: this.maximumFractionDigits,
      minimumSignificantDigits: this.minimumSignificantDigits,
      maximumSignificantDigits: this.maximumSignificantDigits
    });
  }
};
__decorateClass([
  e$c({ type: Number })
], SlFormatNumber.prototype, "value", 2);
__decorateClass([
  e$c()
], SlFormatNumber.prototype, "type", 2);
__decorateClass([
  e$c({ attribute: "no-grouping", type: Boolean })
], SlFormatNumber.prototype, "noGrouping", 2);
__decorateClass([
  e$c()
], SlFormatNumber.prototype, "currency", 2);
__decorateClass([
  e$c({ attribute: "currency-display" })
], SlFormatNumber.prototype, "currencyDisplay", 2);
__decorateClass([
  e$c({ attribute: "minimum-integer-digits", type: Number })
], SlFormatNumber.prototype, "minimumIntegerDigits", 2);
__decorateClass([
  e$c({ attribute: "minimum-fraction-digits", type: Number })
], SlFormatNumber.prototype, "minimumFractionDigits", 2);
__decorateClass([
  e$c({ attribute: "maximum-fraction-digits", type: Number })
], SlFormatNumber.prototype, "maximumFractionDigits", 2);
__decorateClass([
  e$c({ attribute: "minimum-significant-digits", type: Number })
], SlFormatNumber.prototype, "minimumSignificantDigits", 2);
__decorateClass([
  e$c({ attribute: "maximum-significant-digits", type: Number })
], SlFormatNumber.prototype, "maximumSignificantDigits", 2);

// src/components/format-number/format-number.ts
var format_number_default = SlFormatNumber;
SlFormatNumber.define("sl-format-number");

// src/components/icon/icon.ts
var icon_default = SlIcon;
SlIcon.define("sl-icon");

var dropdown_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;
  }

  .dropdown::part(popup) {
    z-index: var(--sl-z-index-dropdown);
  }

  .dropdown[data-current-placement^='top']::part(popup) {
    transform-origin: bottom;
  }

  .dropdown[data-current-placement^='bottom']::part(popup) {
    transform-origin: top;
  }

  .dropdown[data-current-placement^='left']::part(popup) {
    transform-origin: right;
  }

  .dropdown[data-current-placement^='right']::part(popup) {
    transform-origin: left;
  }

  .dropdown__trigger {
    display: block;
  }

  .dropdown__panel {
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-medium);
    font-weight: var(--sl-font-weight-normal);
    box-shadow: var(--sl-shadow-large);
    border-radius: var(--sl-border-radius-medium);
    pointer-events: none;
  }

  .dropdown--open .dropdown__panel {
    display: block;
    pointer-events: all;
  }

  /* When users slot a menu, make sure it conforms to the popup's auto-size */
  ::slotted(sl-menu) {
    max-width: var(--auto-size-available-width) !important;
    max-height: var(--auto-size-available-height) !important;
  }
`;

// src/internal/tabbable.ts
function isTabbable(el) {
  const tag = el.tagName.toLowerCase();
  if (el.getAttribute("tabindex") === "-1") {
    return false;
  }
  if (el.hasAttribute("disabled")) {
    return false;
  }
  if (el.hasAttribute("aria-disabled") && el.getAttribute("aria-disabled") !== "false") {
    return false;
  }
  if (tag === "input" && el.getAttribute("type") === "radio" && !el.hasAttribute("checked")) {
    return false;
  }
  if (el.offsetParent === null && t$1(el) === null) {
    return false;
  }
  if (window.getComputedStyle(el).visibility === "hidden") {
    return false;
  }
  if ((tag === "audio" || tag === "video") && el.hasAttribute("controls")) {
    return true;
  }
  if (el.hasAttribute("tabindex")) {
    return true;
  }
  if (el.hasAttribute("contenteditable") && el.getAttribute("contenteditable") !== "false") {
    return true;
  }
  return ["button", "input", "select", "textarea", "a", "audio", "video", "summary"].includes(tag);
}
function getTabbableBoundary(root) {
  var _a, _b;
  const tabbableElements = getTabbableElements(root);
  const start = (_a = tabbableElements[0]) != null ? _a : null;
  const end = (_b = tabbableElements[tabbableElements.length - 1]) != null ? _b : null;
  return { start, end };
}
function getTabbableElements(root) {
  const tabbableElements = [];
  function walk(el) {
    if (el instanceof Element) {
      if (el.hasAttribute("inert")) {
        return;
      }
      if (!tabbableElements.includes(el) && isTabbable(el)) {
        tabbableElements.push(el);
      }
      const slotChildrenOutsideRootElement = (slotElement) => {
        var _a;
        return ((_a = slotElement.getRootNode({ composed: true })) == null ? void 0 : _a.host) !== root;
      };
      if (el instanceof HTMLSlotElement && slotChildrenOutsideRootElement(el)) {
        el.assignedElements({ flatten: true }).forEach((assignedEl) => {
          walk(assignedEl);
        });
      }
      if (el.shadowRoot !== null && el.shadowRoot.mode === "open") {
        walk(el.shadowRoot);
      }
    }
    [...el.children].forEach((e) => walk(e));
  }
  walk(root);
  return tabbableElements;
}

var SlDropdown = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.open = false;
    this.placement = "bottom-start";
    this.disabled = false;
    this.stayOpenOnSelect = false;
    this.distance = 0;
    this.skidding = 0;
    this.hoist = false;
    this.handleKeyDown = (event) => {
      if (this.open && event.key === "Escape") {
        event.stopPropagation();
        this.hide();
        this.focusOnTrigger();
      }
    };
    this.handleDocumentKeyDown = (event) => {
      var _a;
      if (event.key === "Escape" && this.open) {
        event.stopPropagation();
        this.focusOnTrigger();
        this.hide();
        return;
      }
      if (event.key === "Tab") {
        if (this.open && ((_a = document.activeElement) == null ? void 0 : _a.tagName.toLowerCase()) === "sl-menu-item") {
          event.preventDefault();
          this.hide();
          this.focusOnTrigger();
          return;
        }
        setTimeout(() => {
          var _a2, _b, _c;
          const activeElement = ((_a2 = this.containingElement) == null ? void 0 : _a2.getRootNode()) instanceof ShadowRoot ? (_c = (_b = document.activeElement) == null ? void 0 : _b.shadowRoot) == null ? void 0 : _c.activeElement : document.activeElement;
          if (!this.containingElement || (activeElement == null ? void 0 : activeElement.closest(this.containingElement.tagName.toLowerCase())) !== this.containingElement) {
            this.hide();
          }
        });
      }
    };
    this.handleDocumentMouseDown = (event) => {
      const path = event.composedPath();
      if (this.containingElement && !path.includes(this.containingElement)) {
        this.hide();
      }
    };
    this.handlePanelSelect = (event) => {
      const target = event.target;
      if (!this.stayOpenOnSelect && target.tagName.toLowerCase() === "sl-menu") {
        this.hide();
        this.focusOnTrigger();
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.containingElement) {
      this.containingElement = this;
    }
  }
  firstUpdated() {
    this.panel.hidden = !this.open;
    if (this.open) {
      this.addOpenListeners();
      this.popup.active = true;
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeOpenListeners();
    this.hide();
  }
  focusOnTrigger() {
    const trigger = this.trigger.assignedElements({ flatten: true })[0];
    if (typeof (trigger == null ? void 0 : trigger.focus) === "function") {
      trigger.focus();
    }
  }
  getMenu() {
    return this.panel.assignedElements({ flatten: true }).find((el) => el.tagName.toLowerCase() === "sl-menu");
  }
  handleTriggerClick() {
    if (this.open) {
      this.hide();
    } else {
      this.show();
      this.focusOnTrigger();
    }
  }
  async handleTriggerKeyDown(event) {
    if ([" ", "Enter"].includes(event.key)) {
      event.preventDefault();
      this.handleTriggerClick();
      return;
    }
    const menu = this.getMenu();
    if (menu) {
      const menuItems = menu.getAllItems();
      const firstMenuItem = menuItems[0];
      const lastMenuItem = menuItems[menuItems.length - 1];
      if (["ArrowDown", "ArrowUp", "Home", "End"].includes(event.key)) {
        event.preventDefault();
        if (!this.open) {
          this.show();
          await this.updateComplete;
        }
        if (menuItems.length > 0) {
          this.updateComplete.then(() => {
            if (event.key === "ArrowDown" || event.key === "Home") {
              menu.setCurrentItem(firstMenuItem);
              firstMenuItem.focus();
            }
            if (event.key === "ArrowUp" || event.key === "End") {
              menu.setCurrentItem(lastMenuItem);
              lastMenuItem.focus();
            }
          });
        }
      }
    }
  }
  handleTriggerKeyUp(event) {
    if (event.key === " ") {
      event.preventDefault();
    }
  }
  handleTriggerSlotChange() {
    this.updateAccessibleTrigger();
  }
  //
  // Slotted triggers can be arbitrary content, but we need to link them to the dropdown panel with `aria-haspopup` and
  // `aria-expanded`. These must be applied to the "accessible trigger" (the tabbable portion of the trigger element
  // that gets slotted in) so screen readers will understand them. The accessible trigger could be the slotted element,
  // a child of the slotted element, or an element in the slotted element's shadow root.
  //
  // For example, the accessible trigger of an <sl-button> is a <button> located inside its shadow root.
  //
  // To determine this, we assume the first tabbable element in the trigger slot is the "accessible trigger."
  //
  updateAccessibleTrigger() {
    const assignedElements = this.trigger.assignedElements({ flatten: true });
    const accessibleTrigger = assignedElements.find((el) => getTabbableBoundary(el).start);
    let target;
    if (accessibleTrigger) {
      switch (accessibleTrigger.tagName.toLowerCase()) {
        case "sl-button":
        case "sl-icon-button":
          target = accessibleTrigger.button;
          break;
        default:
          target = accessibleTrigger;
      }
      target.setAttribute("aria-haspopup", "true");
      target.setAttribute("aria-expanded", this.open ? "true" : "false");
    }
  }
  /** Shows the dropdown panel. */
  async show() {
    if (this.open) {
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the dropdown panel */
  async hide() {
    if (!this.open) {
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  /**
   * Instructs the dropdown menu to reposition. Useful when the position or size of the trigger changes when the menu
   * is activated.
   */
  reposition() {
    this.popup.reposition();
  }
  addOpenListeners() {
    this.panel.addEventListener("sl-select", this.handlePanelSelect);
    this.panel.addEventListener("keydown", this.handleKeyDown);
    document.addEventListener("keydown", this.handleDocumentKeyDown);
    document.addEventListener("mousedown", this.handleDocumentMouseDown);
  }
  removeOpenListeners() {
    if (this.panel) {
      this.panel.removeEventListener("sl-select", this.handlePanelSelect);
      this.panel.removeEventListener("keydown", this.handleKeyDown);
    }
    document.removeEventListener("keydown", this.handleDocumentKeyDown);
    document.removeEventListener("mousedown", this.handleDocumentMouseDown);
  }
  async handleOpenChange() {
    if (this.disabled) {
      this.open = false;
      return;
    }
    this.updateAccessibleTrigger();
    if (this.open) {
      this.emit("sl-show");
      this.addOpenListeners();
      await stopAnimations(this);
      this.panel.hidden = false;
      this.popup.active = true;
      const { keyframes, options } = getAnimation(this, "dropdown.show", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      this.emit("sl-after-show");
    } else {
      this.emit("sl-hide");
      this.removeOpenListeners();
      await stopAnimations(this);
      const { keyframes, options } = getAnimation(this, "dropdown.hide", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      this.panel.hidden = true;
      this.popup.active = false;
      this.emit("sl-after-hide");
    }
  }
  render() {
    return x$1`
      <sl-popup
        part="base"
        id="dropdown"
        placement=${this.placement}
        distance=${this.distance}
        skidding=${this.skidding}
        strategy=${this.hoist ? "fixed" : "absolute"}
        flip
        shift
        auto-size="vertical"
        auto-size-padding="10"
        class=${o$9({
      dropdown: true,
      "dropdown--open": this.open
    })}
      >
        <slot
          name="trigger"
          slot="anchor"
          part="trigger"
          class="dropdown__trigger"
          @click=${this.handleTriggerClick}
          @keydown=${this.handleTriggerKeyDown}
          @keyup=${this.handleTriggerKeyUp}
          @slotchange=${this.handleTriggerSlotChange}
        ></slot>

        <div aria-hidden=${this.open ? "false" : "true"} aria-labelledby="dropdown">
          <slot part="panel" class="dropdown__panel"></slot>
        </div>
      </sl-popup>
    `;
  }
};
SlDropdown.styles = dropdown_styles_default;
SlDropdown.dependencies = { "sl-popup": SlPopup };
__decorateClass([
  i$7(".dropdown")
], SlDropdown.prototype, "popup", 2);
__decorateClass([
  i$7(".dropdown__trigger")
], SlDropdown.prototype, "trigger", 2);
__decorateClass([
  i$7(".dropdown__panel")
], SlDropdown.prototype, "panel", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDropdown.prototype, "open", 2);
__decorateClass([
  e$c({ reflect: true })
], SlDropdown.prototype, "placement", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDropdown.prototype, "disabled", 2);
__decorateClass([
  e$c({ attribute: "stay-open-on-select", type: Boolean, reflect: true })
], SlDropdown.prototype, "stayOpenOnSelect", 2);
__decorateClass([
  e$c({ attribute: false })
], SlDropdown.prototype, "containingElement", 2);
__decorateClass([
  e$c({ type: Number })
], SlDropdown.prototype, "distance", 2);
__decorateClass([
  e$c({ type: Number })
], SlDropdown.prototype, "skidding", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlDropdown.prototype, "hoist", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlDropdown.prototype, "handleOpenChange", 1);
setDefaultAnimation("dropdown.show", {
  keyframes: [
    { opacity: 0, scale: 0.9 },
    { opacity: 1, scale: 1 }
  ],
  options: { duration: 100, easing: "ease" }
});
setDefaultAnimation("dropdown.hide", {
  keyframes: [
    { opacity: 1, scale: 1 },
    { opacity: 0, scale: 0.9 }
  ],
  options: { duration: 100, easing: "ease" }
});

// src/components/dropdown/dropdown.ts
var dropdown_default = SlDropdown;
SlDropdown.define("sl-dropdown");

var SlFormatBytes = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.value = 0;
    this.unit = "byte";
    this.display = "short";
  }
  render() {
    if (isNaN(this.value)) {
      return "";
    }
    const bitPrefixes = ["", "kilo", "mega", "giga", "tera"];
    const bytePrefixes = ["", "kilo", "mega", "giga", "tera", "peta"];
    const prefix = this.unit === "bit" ? bitPrefixes : bytePrefixes;
    const index = Math.max(0, Math.min(Math.floor(Math.log10(this.value) / 3), prefix.length - 1));
    const unit = prefix[index] + this.unit;
    const valueToFormat = parseFloat((this.value / Math.pow(1e3, index)).toPrecision(3));
    return this.localize.number(valueToFormat, {
      style: "unit",
      unit,
      unitDisplay: this.display
    });
  }
};
__decorateClass([
  e$c({ type: Number })
], SlFormatBytes.prototype, "value", 2);
__decorateClass([
  e$c()
], SlFormatBytes.prototype, "unit", 2);
__decorateClass([
  e$c()
], SlFormatBytes.prototype, "display", 2);

// src/components/format-bytes/format-bytes.ts
var format_bytes_default = SlFormatBytes;
SlFormatBytes.define("sl-format-bytes");

var SlFormatDate = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.date = /* @__PURE__ */ new Date();
    this.hourFormat = "auto";
  }
  render() {
    const date = new Date(this.date);
    const hour12 = this.hourFormat === "auto" ? void 0 : this.hourFormat === "12";
    if (isNaN(date.getMilliseconds())) {
      return void 0;
    }
    return x$1`
      <time datetime=${date.toISOString()}>
        ${this.localize.date(date, {
      weekday: this.weekday,
      era: this.era,
      year: this.year,
      month: this.month,
      day: this.day,
      hour: this.hour,
      minute: this.minute,
      second: this.second,
      timeZoneName: this.timeZoneName,
      timeZone: this.timeZone,
      hour12
    })}
      </time>
    `;
  }
};
__decorateClass([
  e$c()
], SlFormatDate.prototype, "date", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "weekday", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "era", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "year", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "month", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "day", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "hour", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "minute", 2);
__decorateClass([
  e$c()
], SlFormatDate.prototype, "second", 2);
__decorateClass([
  e$c({ attribute: "time-zone-name" })
], SlFormatDate.prototype, "timeZoneName", 2);
__decorateClass([
  e$c({ attribute: "time-zone" })
], SlFormatDate.prototype, "timeZone", 2);
__decorateClass([
  e$c({ attribute: "hour-format" })
], SlFormatDate.prototype, "hourFormat", 2);

// src/components/format-date/format-date.ts
var format_date_default = SlFormatDate;
SlFormatDate.define("sl-format-date");

// src/components/icon-button/icon-button.ts
var icon_button_default = SlIconButton;
SlIconButton.define("sl-icon-button");

var divider_styles_default = i$b`
  ${component_styles_default}

  :host {
    --color: var(--sl-panel-border-color);
    --width: var(--sl-panel-border-width);
    --spacing: var(--sl-spacing-medium);
  }

  :host(:not([vertical])) {
    display: block;
    border-top: solid var(--width) var(--color);
    margin: var(--spacing) 0;
  }

  :host([vertical]) {
    display: inline-block;
    height: 100%;
    border-left: solid var(--width) var(--color);
    margin: 0 var(--spacing);
  }
`;

var SlDivider = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.vertical = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "separator");
  }
  handleVerticalChange() {
    this.setAttribute("aria-orientation", this.vertical ? "vertical" : "horizontal");
  }
};
SlDivider.styles = divider_styles_default;
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDivider.prototype, "vertical", 2);
__decorateClass([
  watch("vertical")
], SlDivider.prototype, "handleVerticalChange", 1);

// src/components/divider/divider.ts
var divider_default = SlDivider;
SlDivider.define("sl-divider");

var drawer_styles_default = i$b`
  ${component_styles_default}

  :host {
    --size: 25rem;
    --header-spacing: var(--sl-spacing-large);
    --body-spacing: var(--sl-spacing-large);
    --footer-spacing: var(--sl-spacing-large);

    display: contents;
  }

  .drawer {
    top: 0;
    inset-inline-start: 0;
    width: 100%;
    height: 100%;
    pointer-events: none;
    overflow: hidden;
  }

  .drawer--contained {
    position: absolute;
    z-index: initial;
  }

  .drawer--fixed {
    position: fixed;
    z-index: var(--sl-z-index-drawer);
  }

  .drawer__panel {
    position: absolute;
    display: flex;
    flex-direction: column;
    z-index: 2;
    max-width: 100%;
    max-height: 100%;
    background-color: var(--sl-panel-background-color);
    box-shadow: var(--sl-shadow-x-large);
    overflow: auto;
    pointer-events: all;
  }

  .drawer__panel:focus {
    outline: none;
  }

  .drawer--top .drawer__panel {
    top: 0;
    inset-inline-end: auto;
    bottom: auto;
    inset-inline-start: 0;
    width: 100%;
    height: var(--size);
  }

  .drawer--end .drawer__panel {
    top: 0;
    inset-inline-end: 0;
    bottom: auto;
    inset-inline-start: auto;
    width: var(--size);
    height: 100%;
  }

  .drawer--bottom .drawer__panel {
    top: auto;
    inset-inline-end: auto;
    bottom: 0;
    inset-inline-start: 0;
    width: 100%;
    height: var(--size);
  }

  .drawer--start .drawer__panel {
    top: 0;
    inset-inline-end: auto;
    bottom: auto;
    inset-inline-start: 0;
    width: var(--size);
    height: 100%;
  }

  .drawer__header {
    display: flex;
  }

  .drawer__title {
    flex: 1 1 auto;
    font: inherit;
    font-size: var(--sl-font-size-large);
    line-height: var(--sl-line-height-dense);
    padding: var(--header-spacing);
    margin: 0;
  }

  .drawer__header-actions {
    flex-shrink: 0;
    display: flex;
    flex-wrap: wrap;
    justify-content: end;
    gap: var(--sl-spacing-2x-small);
    padding: 0 var(--header-spacing);
  }

  .drawer__header-actions sl-icon-button,
  .drawer__header-actions ::slotted(sl-icon-button) {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    font-size: var(--sl-font-size-medium);
  }

  .drawer__body {
    flex: 1 1 auto;
    display: block;
    padding: var(--body-spacing);
    overflow: auto;
    -webkit-overflow-scrolling: touch;
  }

  .drawer__footer {
    text-align: right;
    padding: var(--footer-spacing);
  }

  .drawer__footer ::slotted(sl-button:not(:last-of-type)) {
    margin-inline-end: var(--sl-spacing-x-small);
  }

  .drawer:not(.drawer--has-footer) .drawer__footer {
    display: none;
  }

  .drawer__overlay {
    display: block;
    position: fixed;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    background-color: var(--sl-overlay-background-color);
    pointer-events: all;
  }

  .drawer--contained .drawer__overlay {
    display: none;
  }

  @media (forced-colors: active) {
    .drawer__panel {
      border: solid 1px var(--sl-color-neutral-0);
    }
  }
`;

// src/internal/active-elements.ts
function* activeElements(activeElement = document.activeElement) {
  if (activeElement === null || activeElement === void 0)
    return;
  yield activeElement;
  if ("shadowRoot" in activeElement && activeElement.shadowRoot && activeElement.shadowRoot.mode !== "closed") {
    yield* activeElements(activeElement.shadowRoot.activeElement);
  }
}

// src/internal/modal.ts
var activeModals = [];
var Modal = class {
  constructor(element) {
    this.tabDirection = "forward";
    this.handleFocusIn = () => {
      this.checkFocus();
    };
    this.handleKeyDown = (event) => {
      var _a;
      if (event.key !== "Tab")
        return;
      if (event.shiftKey) {
        this.tabDirection = "backward";
      } else {
        this.tabDirection = "forward";
      }
      event.preventDefault();
      const tabbableElements = getTabbableElements(this.element);
      const start = tabbableElements[0];
      let focusIndex = this.startElementAlreadyFocused(start) ? 0 : this.currentFocusIndex;
      if (focusIndex === -1) {
        this.currentFocus = start;
        this.currentFocus.focus({ preventScroll: true });
        return;
      }
      const addition = this.tabDirection === "forward" ? 1 : -1;
      if (focusIndex + addition >= tabbableElements.length) {
        focusIndex = 0;
      } else if (this.currentFocusIndex + addition < 0) {
        focusIndex = tabbableElements.length - 1;
      } else {
        focusIndex += addition;
      }
      this.currentFocus = tabbableElements[focusIndex];
      (_a = this.currentFocus) == null ? void 0 : _a.focus({ preventScroll: true });
      setTimeout(() => this.checkFocus());
    };
    this.handleKeyUp = () => {
      this.tabDirection = "forward";
    };
    this.element = element;
  }
  activate() {
    activeModals.push(this.element);
    document.addEventListener("focusin", this.handleFocusIn);
    document.addEventListener("keydown", this.handleKeyDown);
    document.addEventListener("keyup", this.handleKeyUp);
  }
  deactivate() {
    activeModals = activeModals.filter((modal) => modal !== this.element);
    this.currentFocus = null;
    document.removeEventListener("focusin", this.handleFocusIn);
    document.removeEventListener("keydown", this.handleKeyDown);
    document.removeEventListener("keyup", this.handleKeyUp);
  }
  isActive() {
    return activeModals[activeModals.length - 1] === this.element;
  }
  checkFocus() {
    if (this.isActive()) {
      const tabbableElements = getTabbableElements(this.element);
      if (!this.element.matches(":focus-within")) {
        const start = tabbableElements[0];
        const end = tabbableElements[tabbableElements.length - 1];
        const target = this.tabDirection === "forward" ? start : end;
        if (typeof (target == null ? void 0 : target.focus) === "function") {
          this.currentFocus = target;
          target.focus({ preventScroll: true });
        }
      }
    }
  }
  get currentFocusIndex() {
    return getTabbableElements(this.element).findIndex((el) => el === this.currentFocus);
  }
  /**
   * Checks if the `startElement` is already focused. This is important if the modal already
   * has an existing focus prior to the first tab key.
   */
  startElementAlreadyFocused(startElement) {
    for (const activeElement of activeElements()) {
      if (startElement === activeElement) {
        return true;
      }
    }
    return false;
  }
};

// src/internal/string.ts
function uppercaseFirstLetter(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}

// src/components/drawer/drawer.component.ts
var SlDrawer = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController$1(this, "footer");
    this.localize = new LocalizeController(this);
    this.modal = new Modal(this);
    this.open = false;
    this.label = "";
    this.placement = "end";
    this.contained = false;
    this.noHeader = false;
    this.handleDocumentKeyDown = (event) => {
      if (this.contained) {
        return;
      }
      if (event.key === "Escape" && this.modal.isActive() && this.open) {
        event.stopImmediatePropagation();
        this.requestClose("keyboard");
      }
    };
  }
  firstUpdated() {
    this.drawer.hidden = !this.open;
    if (this.open) {
      this.addOpenListeners();
      if (!this.contained) {
        this.modal.activate();
        lockBodyScrolling(this);
      }
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    unlockBodyScrolling(this);
  }
  requestClose(source) {
    const slRequestClose = this.emit("sl-request-close", {
      cancelable: true,
      detail: { source }
    });
    if (slRequestClose.defaultPrevented) {
      const animation = getAnimation(this, "drawer.denyClose", { dir: this.localize.dir() });
      animateTo(this.panel, animation.keyframes, animation.options);
      return;
    }
    this.hide();
  }
  addOpenListeners() {
    document.addEventListener("keydown", this.handleDocumentKeyDown);
  }
  removeOpenListeners() {
    document.removeEventListener("keydown", this.handleDocumentKeyDown);
  }
  async handleOpenChange() {
    if (this.open) {
      this.emit("sl-show");
      this.addOpenListeners();
      this.originalTrigger = document.activeElement;
      if (!this.contained) {
        this.modal.activate();
        lockBodyScrolling(this);
      }
      const autoFocusTarget = this.querySelector("[autofocus]");
      if (autoFocusTarget) {
        autoFocusTarget.removeAttribute("autofocus");
      }
      await Promise.all([stopAnimations(this.drawer), stopAnimations(this.overlay)]);
      this.drawer.hidden = false;
      requestAnimationFrame(() => {
        const slInitialFocus = this.emit("sl-initial-focus", { cancelable: true });
        if (!slInitialFocus.defaultPrevented) {
          if (autoFocusTarget) {
            autoFocusTarget.focus({ preventScroll: true });
          } else {
            this.panel.focus({ preventScroll: true });
          }
        }
        if (autoFocusTarget) {
          autoFocusTarget.setAttribute("autofocus", "");
        }
      });
      const panelAnimation = getAnimation(this, `drawer.show${uppercaseFirstLetter(this.placement)}`, {
        dir: this.localize.dir()
      });
      const overlayAnimation = getAnimation(this, "drawer.overlay.show", { dir: this.localize.dir() });
      await Promise.all([
        animateTo(this.panel, panelAnimation.keyframes, panelAnimation.options),
        animateTo(this.overlay, overlayAnimation.keyframes, overlayAnimation.options)
      ]);
      this.emit("sl-after-show");
    } else {
      this.emit("sl-hide");
      this.removeOpenListeners();
      if (!this.contained) {
        this.modal.deactivate();
        unlockBodyScrolling(this);
      }
      await Promise.all([stopAnimations(this.drawer), stopAnimations(this.overlay)]);
      const panelAnimation = getAnimation(this, `drawer.hide${uppercaseFirstLetter(this.placement)}`, {
        dir: this.localize.dir()
      });
      const overlayAnimation = getAnimation(this, "drawer.overlay.hide", { dir: this.localize.dir() });
      await Promise.all([
        animateTo(this.overlay, overlayAnimation.keyframes, overlayAnimation.options).then(() => {
          this.overlay.hidden = true;
        }),
        animateTo(this.panel, panelAnimation.keyframes, panelAnimation.options).then(() => {
          this.panel.hidden = true;
        })
      ]);
      this.drawer.hidden = true;
      this.overlay.hidden = false;
      this.panel.hidden = false;
      const trigger = this.originalTrigger;
      if (typeof (trigger == null ? void 0 : trigger.focus) === "function") {
        setTimeout(() => trigger.focus());
      }
      this.emit("sl-after-hide");
    }
  }
  handleNoModalChange() {
    if (this.open && !this.contained) {
      this.modal.activate();
      lockBodyScrolling(this);
    }
    if (this.open && this.contained) {
      this.modal.deactivate();
      unlockBodyScrolling(this);
    }
  }
  /** Shows the drawer. */
  async show() {
    if (this.open) {
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the drawer */
  async hide() {
    if (!this.open) {
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      drawer: true,
      "drawer--open": this.open,
      "drawer--top": this.placement === "top",
      "drawer--end": this.placement === "end",
      "drawer--bottom": this.placement === "bottom",
      "drawer--start": this.placement === "start",
      "drawer--contained": this.contained,
      "drawer--fixed": !this.contained,
      "drawer--rtl": this.localize.dir() === "rtl",
      "drawer--has-footer": this.hasSlotController.test("footer")
    })}
      >
        <div part="overlay" class="drawer__overlay" @click=${() => this.requestClose("overlay")} tabindex="-1"></div>

        <div
          part="panel"
          class="drawer__panel"
          role="dialog"
          aria-modal="true"
          aria-hidden=${this.open ? "false" : "true"}
          aria-label=${l$2(this.noHeader ? this.label : void 0)}
          aria-labelledby=${l$2(!this.noHeader ? "title" : void 0)}
          tabindex="0"
        >
          ${!this.noHeader ? x$1`
                <header part="header" class="drawer__header">
                  <h2 part="title" class="drawer__title" id="title">
                    <!-- If there's no label, use an invisible character to prevent the header from collapsing -->
                    <slot name="label"> ${this.label.length > 0 ? this.label : String.fromCharCode(65279)} </slot>
                  </h2>
                  <div part="header-actions" class="drawer__header-actions">
                    <slot name="header-actions"></slot>
                    <sl-icon-button
                      part="close-button"
                      exportparts="base:close-button__base"
                      class="drawer__close"
                      name="x-lg"
                      label=${this.localize.term("close")}
                      library="system"
                      @click=${() => this.requestClose("close-button")}
                    ></sl-icon-button>
                  </div>
                </header>
              ` : ""}

          <slot part="body" class="drawer__body"></slot>

          <footer part="footer" class="drawer__footer">
            <slot name="footer"></slot>
          </footer>
        </div>
      </div>
    `;
  }
};
SlDrawer.styles = drawer_styles_default;
SlDrawer.dependencies = { "sl-icon-button": SlIconButton };
__decorateClass([
  i$7(".drawer")
], SlDrawer.prototype, "drawer", 2);
__decorateClass([
  i$7(".drawer__panel")
], SlDrawer.prototype, "panel", 2);
__decorateClass([
  i$7(".drawer__overlay")
], SlDrawer.prototype, "overlay", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDrawer.prototype, "open", 2);
__decorateClass([
  e$c({ reflect: true })
], SlDrawer.prototype, "label", 2);
__decorateClass([
  e$c({ reflect: true })
], SlDrawer.prototype, "placement", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDrawer.prototype, "contained", 2);
__decorateClass([
  e$c({ attribute: "no-header", type: Boolean, reflect: true })
], SlDrawer.prototype, "noHeader", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlDrawer.prototype, "handleOpenChange", 1);
__decorateClass([
  watch("contained", { waitUntilFirstUpdate: true })
], SlDrawer.prototype, "handleNoModalChange", 1);
setDefaultAnimation("drawer.showTop", {
  keyframes: [
    { opacity: 0, translate: "0 -100%" },
    { opacity: 1, translate: "0 0" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.hideTop", {
  keyframes: [
    { opacity: 1, translate: "0 0" },
    { opacity: 0, translate: "0 -100%" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.showEnd", {
  keyframes: [
    { opacity: 0, translate: "100%" },
    { opacity: 1, translate: "0" }
  ],
  rtlKeyframes: [
    { opacity: 0, translate: "-100%" },
    { opacity: 1, translate: "0" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.hideEnd", {
  keyframes: [
    { opacity: 1, translate: "0" },
    { opacity: 0, translate: "100%" }
  ],
  rtlKeyframes: [
    { opacity: 1, translate: "0" },
    { opacity: 0, translate: "-100%" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.showBottom", {
  keyframes: [
    { opacity: 0, translate: "0 100%" },
    { opacity: 1, translate: "0 0" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.hideBottom", {
  keyframes: [
    { opacity: 1, translate: "0 0" },
    { opacity: 0, translate: "0 100%" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.showStart", {
  keyframes: [
    { opacity: 0, translate: "-100%" },
    { opacity: 1, translate: "0" }
  ],
  rtlKeyframes: [
    { opacity: 0, translate: "100%" },
    { opacity: 1, translate: "0" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.hideStart", {
  keyframes: [
    { opacity: 1, translate: "0" },
    { opacity: 0, translate: "-100%" }
  ],
  rtlKeyframes: [
    { opacity: 1, translate: "0" },
    { opacity: 0, translate: "100%" }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("drawer.denyClose", {
  keyframes: [{ scale: 1 }, { scale: 1.01 }, { scale: 1 }],
  options: { duration: 250 }
});
setDefaultAnimation("drawer.overlay.show", {
  keyframes: [{ opacity: 0 }, { opacity: 1 }],
  options: { duration: 250 }
});
setDefaultAnimation("drawer.overlay.hide", {
  keyframes: [{ opacity: 1 }, { opacity: 0 }],
  options: { duration: 250 }
});

// src/components/drawer/drawer.ts
var drawer_default = SlDrawer;
SlDrawer.define("sl-drawer");

var copy_button_styles_default = i$b`
  ${component_styles_default}

  :host {
    --error-color: var(--sl-color-danger-600);
    --success-color: var(--sl-color-success-600);

    display: inline-block;
  }

  .copy-button__button {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    background: none;
    border: none;
    border-radius: var(--sl-border-radius-medium);
    font-size: inherit;
    color: inherit;
    padding: var(--sl-spacing-x-small);
    cursor: pointer;
    transition: var(--sl-transition-x-fast) color;
  }

  .copy-button--success .copy-button__button {
    color: var(--success-color);
  }

  .copy-button--error .copy-button__button {
    color: var(--error-color);
  }

  .copy-button__button:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .copy-button__button[disabled] {
    opacity: 0.5;
    cursor: not-allowed !important;
  }

  slot {
    display: inline-flex;
  }
`;

var SlCopyButton = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.isCopying = false;
    this.status = "rest";
    this.value = "";
    this.from = "";
    this.disabled = false;
    this.copyLabel = "";
    this.successLabel = "";
    this.errorLabel = "";
    this.feedbackDuration = 1e3;
    this.tooltipPlacement = "top";
    this.hoist = false;
  }
  async handleCopy() {
    if (this.disabled || this.isCopying) {
      return;
    }
    this.isCopying = true;
    let valueToCopy = this.value;
    if (this.from) {
      const root = this.getRootNode();
      const isProperty = this.from.includes(".");
      const isAttribute = this.from.includes("[") && this.from.includes("]");
      let id = this.from;
      let field = "";
      if (isProperty) {
        [id, field] = this.from.trim().split(".");
      } else if (isAttribute) {
        [id, field] = this.from.trim().replace(/\]$/, "").split("[");
      }
      const target = "getElementById" in root ? root.getElementById(id) : null;
      if (target) {
        if (isAttribute) {
          valueToCopy = target.getAttribute(field) || "";
        } else if (isProperty) {
          valueToCopy = target[field] || "";
        } else {
          valueToCopy = target.textContent || "";
        }
      } else {
        this.showStatus("error");
        this.emit("sl-error");
      }
    }
    if (!valueToCopy) {
      this.showStatus("error");
      this.emit("sl-error");
    } else {
      try {
        await navigator.clipboard.writeText(valueToCopy);
        this.showStatus("success");
        this.emit("sl-copy", {
          detail: {
            value: valueToCopy
          }
        });
      } catch (error) {
        this.showStatus("error");
        this.emit("sl-error");
      }
    }
  }
  async showStatus(status) {
    const copyLabel = this.copyLabel || this.localize.term("copy");
    const successLabel = this.successLabel || this.localize.term("copied");
    const errorLabel = this.errorLabel || this.localize.term("error");
    const iconToShow = status === "success" ? this.successIcon : this.errorIcon;
    const showAnimation = getAnimation(this, "copy.in", { dir: "ltr" });
    const hideAnimation = getAnimation(this, "copy.out", { dir: "ltr" });
    this.tooltip.content = status === "success" ? successLabel : errorLabel;
    await this.copyIcon.animate(hideAnimation.keyframes, hideAnimation.options).finished;
    this.copyIcon.hidden = true;
    this.status = status;
    iconToShow.hidden = false;
    await iconToShow.animate(showAnimation.keyframes, showAnimation.options).finished;
    setTimeout(async () => {
      await iconToShow.animate(hideAnimation.keyframes, hideAnimation.options).finished;
      iconToShow.hidden = true;
      this.status = "rest";
      this.copyIcon.hidden = false;
      await this.copyIcon.animate(showAnimation.keyframes, showAnimation.options).finished;
      this.tooltip.content = copyLabel;
      this.isCopying = false;
    }, this.feedbackDuration);
  }
  render() {
    const copyLabel = this.copyLabel || this.localize.term("copy");
    return x$1`
      <sl-tooltip
        class=${o$9({
      "copy-button": true,
      "copy-button--success": this.status === "success",
      "copy-button--error": this.status === "error"
    })}
        content=${copyLabel}
        placement=${this.tooltipPlacement}
        ?disabled=${this.disabled}
        ?hoist=${this.hoist}
        exportparts="
          base:tooltip__base
          base__popup:tooltip__base__popup
          base__arrow:tooltip__base__arrow
          body:tooltip__body
        "
      >
        <button
          class="copy-button__button"
          part="button"
          type="button"
          ?disabled=${this.disabled}
          @click=${this.handleCopy}
        >
          <slot part="copy-icon" name="copy-icon">
            <sl-icon library="system" name="copy"></sl-icon>
          </slot>
          <slot part="success-icon" name="success-icon" hidden>
            <sl-icon library="system" name="check"></sl-icon>
          </slot>
          <slot part="error-icon" name="error-icon" hidden>
            <sl-icon library="system" name="x-lg"></sl-icon>
          </slot>
        </button>
      </sl-tooltip>
    `;
  }
};
SlCopyButton.styles = copy_button_styles_default;
SlCopyButton.dependencies = {
  "sl-icon": SlIcon,
  "sl-tooltip": SlTooltip
};
__decorateClass([
  i$7('slot[name="copy-icon"]')
], SlCopyButton.prototype, "copyIcon", 2);
__decorateClass([
  i$7('slot[name="success-icon"]')
], SlCopyButton.prototype, "successIcon", 2);
__decorateClass([
  i$7('slot[name="error-icon"]')
], SlCopyButton.prototype, "errorIcon", 2);
__decorateClass([
  i$7("sl-tooltip")
], SlCopyButton.prototype, "tooltip", 2);
__decorateClass([
  t$7()
], SlCopyButton.prototype, "isCopying", 2);
__decorateClass([
  t$7()
], SlCopyButton.prototype, "status", 2);
__decorateClass([
  e$c()
], SlCopyButton.prototype, "value", 2);
__decorateClass([
  e$c()
], SlCopyButton.prototype, "from", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCopyButton.prototype, "disabled", 2);
__decorateClass([
  e$c({ attribute: "copy-label" })
], SlCopyButton.prototype, "copyLabel", 2);
__decorateClass([
  e$c({ attribute: "success-label" })
], SlCopyButton.prototype, "successLabel", 2);
__decorateClass([
  e$c({ attribute: "error-label" })
], SlCopyButton.prototype, "errorLabel", 2);
__decorateClass([
  e$c({ attribute: "feedback-duration", type: Number })
], SlCopyButton.prototype, "feedbackDuration", 2);
__decorateClass([
  e$c({ attribute: "tooltip-placement" })
], SlCopyButton.prototype, "tooltipPlacement", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlCopyButton.prototype, "hoist", 2);
setDefaultAnimation("copy.in", {
  keyframes: [
    { scale: ".25", opacity: ".25" },
    { scale: "1", opacity: "1" }
  ],
  options: { duration: 100 }
});
setDefaultAnimation("copy.out", {
  keyframes: [
    { scale: "1", opacity: "1" },
    { scale: ".25", opacity: "0" }
  ],
  options: { duration: 100 }
});

// src/components/copy-button/copy-button.ts
var copy_button_default = SlCopyButton;
SlCopyButton.define("sl-copy-button");

var details_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: block;
  }

  .details {
    border: solid 1px var(--sl-color-neutral-200);
    border-radius: var(--sl-border-radius-medium);
    background-color: var(--sl-color-neutral-0);
    overflow-anchor: none;
  }

  .details--disabled {
    opacity: 0.5;
  }

  .details__header {
    display: flex;
    align-items: center;
    border-radius: inherit;
    padding: var(--sl-spacing-medium);
    user-select: none;
    cursor: pointer;
  }

  .details__header::-webkit-details-marker {
    display: none;
  }

  .details__header:focus {
    outline: none;
  }

  .details__header:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: calc(1px + var(--sl-focus-ring-offset));
  }

  .details--disabled .details__header {
    cursor: not-allowed;
  }

  .details--disabled .details__header:focus-visible {
    outline: none;
    box-shadow: none;
  }

  .details__summary {
    flex: 1 1 auto;
    display: flex;
    align-items: center;
  }

  .details__summary-icon {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    transition: var(--sl-transition-medium) rotate ease;
  }

  .details--open .details__summary-icon {
    rotate: 90deg;
  }

  .details--open.details--rtl .details__summary-icon {
    rotate: -90deg;
  }

  .details--open slot[name='expand-icon'],
  .details:not(.details--open) slot[name='collapse-icon'] {
    display: none;
  }

  .details__body {
    overflow: hidden;
  }

  .details__content {
    display: block;
    padding: var(--sl-spacing-medium);
  }
`;

var SlDetails = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.open = false;
    this.disabled = false;
  }
  firstUpdated() {
    this.body.style.height = this.open ? "auto" : "0";
    if (this.open) {
      this.details.open = true;
    }
    this.detailsObserver = new MutationObserver((changes) => {
      for (const change of changes) {
        if (change.type === "attributes" && change.attributeName === "open") {
          if (this.details.open) {
            this.show();
          } else {
            this.hide();
          }
        }
      }
    });
    this.detailsObserver.observe(this.details, { attributes: true });
  }
  disconnectedCallback() {
    this.detailsObserver.disconnect();
  }
  handleSummaryClick(event) {
    event.preventDefault();
    if (!this.disabled) {
      if (this.open) {
        this.hide();
      } else {
        this.show();
      }
      this.header.focus();
    }
  }
  handleSummaryKeyDown(event) {
    if (event.key === "Enter" || event.key === " ") {
      event.preventDefault();
      if (this.open) {
        this.hide();
      } else {
        this.show();
      }
    }
    if (event.key === "ArrowUp" || event.key === "ArrowLeft") {
      event.preventDefault();
      this.hide();
    }
    if (event.key === "ArrowDown" || event.key === "ArrowRight") {
      event.preventDefault();
      this.show();
    }
  }
  async handleOpenChange() {
    if (this.open) {
      this.details.open = true;
      const slShow = this.emit("sl-show", { cancelable: true });
      if (slShow.defaultPrevented) {
        this.open = false;
        this.details.open = false;
        return;
      }
      await stopAnimations(this.body);
      const { keyframes, options } = getAnimation(this, "details.show", { dir: this.localize.dir() });
      await animateTo(this.body, shimKeyframesHeightAuto(keyframes, this.body.scrollHeight), options);
      this.body.style.height = "auto";
      this.emit("sl-after-show");
    } else {
      const slHide = this.emit("sl-hide", { cancelable: true });
      if (slHide.defaultPrevented) {
        this.details.open = true;
        this.open = true;
        return;
      }
      await stopAnimations(this.body);
      const { keyframes, options } = getAnimation(this, "details.hide", { dir: this.localize.dir() });
      await animateTo(this.body, shimKeyframesHeightAuto(keyframes, this.body.scrollHeight), options);
      this.body.style.height = "auto";
      this.details.open = false;
      this.emit("sl-after-hide");
    }
  }
  /** Shows the details. */
  async show() {
    if (this.open || this.disabled) {
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the details */
  async hide() {
    if (!this.open || this.disabled) {
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  render() {
    const isRtl = this.localize.dir() === "rtl";
    return x$1`
      <details
        part="base"
        class=${o$9({
      details: true,
      "details--open": this.open,
      "details--disabled": this.disabled,
      "details--rtl": isRtl
    })}
      >
        <summary
          part="header"
          id="header"
          class="details__header"
          role="button"
          aria-expanded=${this.open ? "true" : "false"}
          aria-controls="content"
          aria-disabled=${this.disabled ? "true" : "false"}
          tabindex=${this.disabled ? "-1" : "0"}
          @click=${this.handleSummaryClick}
          @keydown=${this.handleSummaryKeyDown}
        >
          <slot name="summary" part="summary" class="details__summary">${this.summary}</slot>

          <span part="summary-icon" class="details__summary-icon">
            <slot name="expand-icon">
              <sl-icon library="system" name=${isRtl ? "chevron-left" : "chevron-right"}></sl-icon>
            </slot>
            <slot name="collapse-icon">
              <sl-icon library="system" name=${isRtl ? "chevron-left" : "chevron-right"}></sl-icon>
            </slot>
          </span>
        </summary>

        <div class="details__body" role="region" aria-labelledby="header">
          <slot part="content" id="content" class="details__content"></slot>
        </div>
      </details>
    `;
  }
};
SlDetails.styles = details_styles_default;
SlDetails.dependencies = {
  "sl-icon": SlIcon
};
__decorateClass([
  i$7(".details")
], SlDetails.prototype, "details", 2);
__decorateClass([
  i$7(".details__header")
], SlDetails.prototype, "header", 2);
__decorateClass([
  i$7(".details__body")
], SlDetails.prototype, "body", 2);
__decorateClass([
  i$7(".details__expand-icon-slot")
], SlDetails.prototype, "expandIconSlot", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDetails.prototype, "open", 2);
__decorateClass([
  e$c()
], SlDetails.prototype, "summary", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDetails.prototype, "disabled", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlDetails.prototype, "handleOpenChange", 1);
setDefaultAnimation("details.show", {
  keyframes: [
    { height: "0", opacity: "0" },
    { height: "auto", opacity: "1" }
  ],
  options: { duration: 250, easing: "linear" }
});
setDefaultAnimation("details.hide", {
  keyframes: [
    { height: "auto", opacity: "1" },
    { height: "0", opacity: "0" }
  ],
  options: { duration: 250, easing: "linear" }
});

// src/components/details/details.ts
var details_default = SlDetails;
SlDetails.define("sl-details");

var dialog_styles_default = i$b`
  ${component_styles_default}

  :host {
    --width: 31rem;
    --header-spacing: var(--sl-spacing-large);
    --body-spacing: var(--sl-spacing-large);
    --footer-spacing: var(--sl-spacing-large);

    display: contents;
  }

  .dialog {
    display: flex;
    align-items: center;
    justify-content: center;
    position: fixed;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    z-index: var(--sl-z-index-dialog);
  }

  .dialog__panel {
    display: flex;
    flex-direction: column;
    z-index: 2;
    width: var(--width);
    max-width: calc(100% - var(--sl-spacing-2x-large));
    max-height: calc(100% - var(--sl-spacing-2x-large));
    background-color: var(--sl-panel-background-color);
    border-radius: var(--sl-border-radius-medium);
    box-shadow: var(--sl-shadow-x-large);
  }

  .dialog__panel:focus {
    outline: none;
  }

  /* Ensure there's enough vertical padding for phones that don't update vh when chrome appears (e.g. iPhone) */
  @media screen and (max-width: 420px) {
    .dialog__panel {
      max-height: 80vh;
    }
  }

  .dialog--open .dialog__panel {
    display: flex;
    opacity: 1;
  }

  .dialog__header {
    flex: 0 0 auto;
    display: flex;
  }

  .dialog__title {
    flex: 1 1 auto;
    font: inherit;
    font-size: var(--sl-font-size-large);
    line-height: var(--sl-line-height-dense);
    padding: var(--header-spacing);
    margin: 0;
  }

  .dialog__header-actions {
    flex-shrink: 0;
    display: flex;
    flex-wrap: wrap;
    justify-content: end;
    gap: var(--sl-spacing-2x-small);
    padding: 0 var(--header-spacing);
  }

  .dialog__header-actions sl-icon-button,
  .dialog__header-actions ::slotted(sl-icon-button) {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    font-size: var(--sl-font-size-medium);
  }

  .dialog__body {
    flex: 1 1 auto;
    display: block;
    padding: var(--body-spacing);
    overflow: auto;
    -webkit-overflow-scrolling: touch;
  }

  .dialog__footer {
    flex: 0 0 auto;
    text-align: right;
    padding: var(--footer-spacing);
  }

  .dialog__footer ::slotted(sl-button:not(:first-of-type)) {
    margin-inline-start: var(--sl-spacing-x-small);
  }

  .dialog:not(.dialog--has-footer) .dialog__footer {
    display: none;
  }

  .dialog__overlay {
    position: fixed;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    background-color: var(--sl-overlay-background-color);
  }

  @media (forced-colors: active) {
    .dialog__panel {
      border: solid 1px var(--sl-color-neutral-0);
    }
  }
`;

var SlDialog = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController$1(this, "footer");
    this.localize = new LocalizeController(this);
    this.modal = new Modal(this);
    this.open = false;
    this.label = "";
    this.noHeader = false;
    this.handleDocumentKeyDown = (event) => {
      if (event.key === "Escape" && this.modal.isActive() && this.open) {
        event.stopPropagation();
        this.requestClose("keyboard");
      }
    };
  }
  firstUpdated() {
    this.dialog.hidden = !this.open;
    if (this.open) {
      this.addOpenListeners();
      this.modal.activate();
      lockBodyScrolling(this);
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.modal.deactivate();
    unlockBodyScrolling(this);
  }
  requestClose(source) {
    const slRequestClose = this.emit("sl-request-close", {
      cancelable: true,
      detail: { source }
    });
    if (slRequestClose.defaultPrevented) {
      const animation = getAnimation(this, "dialog.denyClose", { dir: this.localize.dir() });
      animateTo(this.panel, animation.keyframes, animation.options);
      return;
    }
    this.hide();
  }
  addOpenListeners() {
    document.addEventListener("keydown", this.handleDocumentKeyDown);
  }
  removeOpenListeners() {
    document.removeEventListener("keydown", this.handleDocumentKeyDown);
  }
  async handleOpenChange() {
    if (this.open) {
      this.emit("sl-show");
      this.addOpenListeners();
      this.originalTrigger = document.activeElement;
      this.modal.activate();
      lockBodyScrolling(this);
      const autoFocusTarget = this.querySelector("[autofocus]");
      if (autoFocusTarget) {
        autoFocusTarget.removeAttribute("autofocus");
      }
      await Promise.all([stopAnimations(this.dialog), stopAnimations(this.overlay)]);
      this.dialog.hidden = false;
      requestAnimationFrame(() => {
        const slInitialFocus = this.emit("sl-initial-focus", { cancelable: true });
        if (!slInitialFocus.defaultPrevented) {
          if (autoFocusTarget) {
            autoFocusTarget.focus({ preventScroll: true });
          } else {
            this.panel.focus({ preventScroll: true });
          }
        }
        if (autoFocusTarget) {
          autoFocusTarget.setAttribute("autofocus", "");
        }
      });
      const panelAnimation = getAnimation(this, "dialog.show", { dir: this.localize.dir() });
      const overlayAnimation = getAnimation(this, "dialog.overlay.show", { dir: this.localize.dir() });
      await Promise.all([
        animateTo(this.panel, panelAnimation.keyframes, panelAnimation.options),
        animateTo(this.overlay, overlayAnimation.keyframes, overlayAnimation.options)
      ]);
      this.emit("sl-after-show");
    } else {
      this.emit("sl-hide");
      this.removeOpenListeners();
      this.modal.deactivate();
      await Promise.all([stopAnimations(this.dialog), stopAnimations(this.overlay)]);
      const panelAnimation = getAnimation(this, "dialog.hide", { dir: this.localize.dir() });
      const overlayAnimation = getAnimation(this, "dialog.overlay.hide", { dir: this.localize.dir() });
      await Promise.all([
        animateTo(this.overlay, overlayAnimation.keyframes, overlayAnimation.options).then(() => {
          this.overlay.hidden = true;
        }),
        animateTo(this.panel, panelAnimation.keyframes, panelAnimation.options).then(() => {
          this.panel.hidden = true;
        })
      ]);
      this.dialog.hidden = true;
      this.overlay.hidden = false;
      this.panel.hidden = false;
      unlockBodyScrolling(this);
      const trigger = this.originalTrigger;
      if (typeof (trigger == null ? void 0 : trigger.focus) === "function") {
        setTimeout(() => trigger.focus());
      }
      this.emit("sl-after-hide");
    }
  }
  /** Shows the dialog. */
  async show() {
    if (this.open) {
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the dialog */
  async hide() {
    if (!this.open) {
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      dialog: true,
      "dialog--open": this.open,
      "dialog--has-footer": this.hasSlotController.test("footer")
    })}
      >
        <div part="overlay" class="dialog__overlay" @click=${() => this.requestClose("overlay")} tabindex="-1"></div>

        <div
          part="panel"
          class="dialog__panel"
          role="dialog"
          aria-modal="true"
          aria-hidden=${this.open ? "false" : "true"}
          aria-label=${l$2(this.noHeader ? this.label : void 0)}
          aria-labelledby=${l$2(!this.noHeader ? "title" : void 0)}
          tabindex="-1"
        >
          ${!this.noHeader ? x$1`
                <header part="header" class="dialog__header">
                  <h2 part="title" class="dialog__title" id="title">
                    <slot name="label"> ${this.label.length > 0 ? this.label : String.fromCharCode(65279)} </slot>
                  </h2>
                  <div part="header-actions" class="dialog__header-actions">
                    <slot name="header-actions"></slot>
                    <sl-icon-button
                      part="close-button"
                      exportparts="base:close-button__base"
                      class="dialog__close"
                      name="x-lg"
                      label=${this.localize.term("close")}
                      library="system"
                      @click="${() => this.requestClose("close-button")}"
                    ></sl-icon-button>
                  </div>
                </header>
              ` : ""}
          ${""}
          <slot part="body" class="dialog__body" tabindex="-1"></slot>

          <footer part="footer" class="dialog__footer">
            <slot name="footer"></slot>
          </footer>
        </div>
      </div>
    `;
  }
};
SlDialog.styles = dialog_styles_default;
SlDialog.dependencies = {
  "sl-icon-button": SlIconButton
};
__decorateClass([
  i$7(".dialog")
], SlDialog.prototype, "dialog", 2);
__decorateClass([
  i$7(".dialog__panel")
], SlDialog.prototype, "panel", 2);
__decorateClass([
  i$7(".dialog__overlay")
], SlDialog.prototype, "overlay", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlDialog.prototype, "open", 2);
__decorateClass([
  e$c({ reflect: true })
], SlDialog.prototype, "label", 2);
__decorateClass([
  e$c({ attribute: "no-header", type: Boolean, reflect: true })
], SlDialog.prototype, "noHeader", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlDialog.prototype, "handleOpenChange", 1);
setDefaultAnimation("dialog.show", {
  keyframes: [
    { opacity: 0, scale: 0.8 },
    { opacity: 1, scale: 1 }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("dialog.hide", {
  keyframes: [
    { opacity: 1, scale: 1 },
    { opacity: 0, scale: 0.8 }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("dialog.denyClose", {
  keyframes: [{ scale: 1 }, { scale: 1.02 }, { scale: 1 }],
  options: { duration: 250 }
});
setDefaultAnimation("dialog.overlay.show", {
  keyframes: [{ opacity: 0 }, { opacity: 1 }],
  options: { duration: 250 }
});
setDefaultAnimation("dialog.overlay.hide", {
  keyframes: [{ opacity: 1 }, { opacity: 0 }],
  options: { duration: 250 }
});

// src/components/dialog/dialog.ts
var dialog_default = SlDialog;
SlDialog.define("sl-dialog");

var carousel_item_styles_default = i$b`
  ${component_styles_default}

  :host {
    --aspect-ratio: inherit;

    display: flex;
    align-items: center;
    justify-content: center;
    flex-direction: column;
    width: 100%;
    max-height: 100%;
    aspect-ratio: var(--aspect-ratio);
    scroll-snap-align: start;
    scroll-snap-stop: always;
  }

  ::slotted(img) {
    width: 100%;
    height: 100%;
    object-fit: cover;
  }
`;

var SlCarouselItem = class extends ShoelaceElement {
  static isCarouselItem(node) {
    return node instanceof Element && node.getAttribute("aria-roledescription") === "slide";
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "group");
  }
  render() {
    return x$1` <slot></slot> `;
  }
};
SlCarouselItem.styles = carousel_item_styles_default;

// src/components/carousel-item/carousel-item.ts
var carousel_item_default = SlCarouselItem;
SlCarouselItem.define("sl-carousel-item");

// src/components/checkbox/checkbox.ts
var checkbox_default = SlCheckbox;
SlCheckbox.define("sl-checkbox");

var color_picker_styles_default = i$b`
  ${component_styles_default}

  :host {
    --grid-width: 280px;
    --grid-height: 200px;
    --grid-handle-size: 16px;
    --slider-height: 15px;
    --slider-handle-size: 17px;
    --swatch-size: 25px;

    display: inline-block;
  }

  .color-picker {
    width: var(--grid-width);
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-medium);
    font-weight: var(--sl-font-weight-normal);
    color: var(--color);
    background-color: var(--sl-panel-background-color);
    border-radius: var(--sl-border-radius-medium);
    user-select: none;
  }

  .color-picker--inline {
    border: solid var(--sl-panel-border-width) var(--sl-panel-border-color);
  }

  .color-picker--inline:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .color-picker__grid {
    position: relative;
    height: var(--grid-height);
    background-image: linear-gradient(to bottom, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 1) 100%),
      linear-gradient(to right, #fff 0%, rgba(255, 255, 255, 0) 100%);
    border-top-left-radius: var(--sl-border-radius-medium);
    border-top-right-radius: var(--sl-border-radius-medium);
    cursor: crosshair;
    forced-color-adjust: none;
  }

  .color-picker__grid-handle {
    position: absolute;
    width: var(--grid-handle-size);
    height: var(--grid-handle-size);
    border-radius: 50%;
    box-shadow: 0 0 0 1px rgba(0, 0, 0, 0.25);
    border: solid 2px white;
    margin-top: calc(var(--grid-handle-size) / -2);
    margin-left: calc(var(--grid-handle-size) / -2);
    transition: var(--sl-transition-fast) scale;
  }

  .color-picker__grid-handle--dragging {
    cursor: none;
    scale: 1.5;
  }

  .color-picker__grid-handle:focus-visible {
    outline: var(--sl-focus-ring);
  }

  .color-picker__controls {
    padding: var(--sl-spacing-small);
    display: flex;
    align-items: center;
  }

  .color-picker__sliders {
    flex: 1 1 auto;
  }

  .color-picker__slider {
    position: relative;
    height: var(--slider-height);
    border-radius: var(--sl-border-radius-pill);
    box-shadow: inset 0 0 0 1px rgba(0, 0, 0, 0.2);
    forced-color-adjust: none;
  }

  .color-picker__slider:not(:last-of-type) {
    margin-bottom: var(--sl-spacing-small);
  }

  .color-picker__slider-handle {
    position: absolute;
    top: calc(50% - var(--slider-handle-size) / 2);
    width: var(--slider-handle-size);
    height: var(--slider-handle-size);
    background-color: white;
    border-radius: 50%;
    box-shadow: 0 0 0 1px rgba(0, 0, 0, 0.25);
    margin-left: calc(var(--slider-handle-size) / -2);
  }

  .color-picker__slider-handle:focus-visible {
    outline: var(--sl-focus-ring);
  }

  .color-picker__hue {
    background-image: linear-gradient(
      to right,
      rgb(255, 0, 0) 0%,
      rgb(255, 255, 0) 17%,
      rgb(0, 255, 0) 33%,
      rgb(0, 255, 255) 50%,
      rgb(0, 0, 255) 67%,
      rgb(255, 0, 255) 83%,
      rgb(255, 0, 0) 100%
    );
  }

  .color-picker__alpha .color-picker__alpha-gradient {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border-radius: inherit;
  }

  .color-picker__preview {
    flex: 0 0 auto;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    position: relative;
    width: 2.25rem;
    height: 2.25rem;
    border: none;
    border-radius: var(--sl-border-radius-circle);
    background: none;
    margin-left: var(--sl-spacing-small);
    cursor: copy;
    forced-color-adjust: none;
  }

  .color-picker__preview:before {
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border-radius: inherit;
    box-shadow: inset 0 0 0 1px rgba(0, 0, 0, 0.2);

    /* We use a custom property in lieu of currentColor because of https://bugs.webkit.org/show_bug.cgi?id=216780 */
    background-color: var(--preview-color);
  }

  .color-picker__preview:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .color-picker__preview-color {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border: solid 1px rgba(0, 0, 0, 0.125);
  }

  .color-picker__preview-color--copied {
    animation: pulse 0.75s;
  }

  @keyframes pulse {
    0% {
      box-shadow: 0 0 0 0 var(--sl-color-primary-500);
    }
    70% {
      box-shadow: 0 0 0 0.5rem transparent;
    }
    100% {
      box-shadow: 0 0 0 0 transparent;
    }
  }

  .color-picker__user-input {
    display: flex;
    padding: 0 var(--sl-spacing-small) var(--sl-spacing-small) var(--sl-spacing-small);
  }

  .color-picker__user-input sl-input {
    min-width: 0; /* fix input width in Safari */
    flex: 1 1 auto;
  }

  .color-picker__user-input sl-button-group {
    margin-left: var(--sl-spacing-small);
  }

  .color-picker__user-input sl-button {
    min-width: 3.25rem;
    max-width: 3.25rem;
    font-size: 1rem;
  }

  .color-picker__swatches {
    display: grid;
    grid-template-columns: repeat(8, 1fr);
    grid-gap: 0.5rem;
    justify-items: center;
    border-top: solid 1px var(--sl-color-neutral-200);
    padding: var(--sl-spacing-small);
    forced-color-adjust: none;
  }

  .color-picker__swatch {
    position: relative;
    width: var(--swatch-size);
    height: var(--swatch-size);
    border-radius: var(--sl-border-radius-small);
  }

  .color-picker__swatch .color-picker__swatch-color {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border: solid 1px rgba(0, 0, 0, 0.125);
    border-radius: inherit;
    cursor: pointer;
  }

  .color-picker__swatch:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .color-picker__transparent-bg {
    background-image: linear-gradient(45deg, var(--sl-color-neutral-300) 25%, transparent 25%),
      linear-gradient(45deg, transparent 75%, var(--sl-color-neutral-300) 75%),
      linear-gradient(45deg, transparent 75%, var(--sl-color-neutral-300) 75%),
      linear-gradient(45deg, var(--sl-color-neutral-300) 25%, transparent 25%);
    background-size: 10px 10px;
    background-position: 0 0, 0 0, -5px -5px, 5px 5px;
  }

  .color-picker--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .color-picker--disabled .color-picker__grid,
  .color-picker--disabled .color-picker__grid-handle,
  .color-picker--disabled .color-picker__slider,
  .color-picker--disabled .color-picker__slider-handle,
  .color-picker--disabled .color-picker__preview,
  .color-picker--disabled .color-picker__swatch,
  .color-picker--disabled .color-picker__swatch-color {
    pointer-events: none;
  }

  /*
   * Color dropdown
   */

  .color-dropdown::part(panel) {
    max-height: none;
    background-color: var(--sl-panel-background-color);
    border: solid var(--sl-panel-border-width) var(--sl-panel-border-color);
    border-radius: var(--sl-border-radius-medium);
    overflow: visible;
  }

  .color-dropdown__trigger {
    display: inline-block;
    position: relative;
    background-color: transparent;
    border: none;
    cursor: pointer;
    forced-color-adjust: none;
  }

  .color-dropdown__trigger.color-dropdown__trigger--small {
    width: var(--sl-input-height-small);
    height: var(--sl-input-height-small);
    border-radius: var(--sl-border-radius-circle);
  }

  .color-dropdown__trigger.color-dropdown__trigger--medium {
    width: var(--sl-input-height-medium);
    height: var(--sl-input-height-medium);
    border-radius: var(--sl-border-radius-circle);
  }

  .color-dropdown__trigger.color-dropdown__trigger--large {
    width: var(--sl-input-height-large);
    height: var(--sl-input-height-large);
    border-radius: var(--sl-border-radius-circle);
  }

  .color-dropdown__trigger:before {
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border-radius: inherit;
    background-color: currentColor;
    box-shadow: inset 0 0 0 2px var(--sl-input-border-color), inset 0 0 0 4px var(--sl-color-neutral-0);
  }

  .color-dropdown__trigger--empty:before {
    background-color: transparent;
  }

  .color-dropdown__trigger:focus-visible {
    outline: none;
  }

  .color-dropdown__trigger:focus-visible:not(.color-dropdown__trigger--disabled) {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .color-dropdown__trigger.color-dropdown__trigger--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }
`;

var SlButton = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      form: (input) => {
        if (input.hasAttribute("form")) {
          const doc = input.getRootNode();
          const formId = input.getAttribute("form");
          return doc.getElementById(formId);
        }
        return input.closest("form");
      },
      assumeInteractionOn: ["click"]
    });
    this.hasSlotController = new HasSlotController$1(this, "[default]", "prefix", "suffix");
    this.localize = new LocalizeController(this);
    this.hasFocus = false;
    this.invalid = false;
    this.title = "";
    this.variant = "default";
    this.size = "medium";
    this.caret = false;
    this.disabled = false;
    this.loading = false;
    this.outline = false;
    this.pill = false;
    this.circle = false;
    this.type = "button";
    this.name = "";
    this.value = "";
    this.href = "";
    this.rel = "noreferrer noopener";
  }
  /** Gets the validity state object */
  get validity() {
    if (this.isButton()) {
      return this.button.validity;
    }
    return validValidityState;
  }
  /** Gets the validation message */
  get validationMessage() {
    if (this.isButton()) {
      return this.button.validationMessage;
    }
    return "";
  }
  firstUpdated() {
    if (this.isButton()) {
      this.formControlController.updateValidity();
    }
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("sl-blur");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("sl-focus");
  }
  handleClick() {
    if (this.type === "submit") {
      this.formControlController.submit(this);
    }
    if (this.type === "reset") {
      this.formControlController.reset(this);
    }
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  isButton() {
    return this.href ? false : true;
  }
  isLink() {
    return this.href ? true : false;
  }
  handleDisabledChange() {
    if (this.isButton()) {
      this.formControlController.setValidity(this.disabled);
    }
  }
  /** Simulates a click on the button. */
  click() {
    this.button.click();
  }
  /** Sets focus on the button. */
  focus(options) {
    this.button.focus(options);
  }
  /** Removes focus from the button. */
  blur() {
    this.button.blur();
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    if (this.isButton()) {
      return this.button.checkValidity();
    }
    return true;
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    if (this.isButton()) {
      return this.button.reportValidity();
    }
    return true;
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    if (this.isButton()) {
      this.button.setCustomValidity(message);
      this.formControlController.updateValidity();
    }
  }
  render() {
    const isLink = this.isLink();
    const tag = isLink ? i$9`a` : i$9`button`;
    return n$9`
      <${tag}
        part="base"
        class=${o$9({
      button: true,
      "button--default": this.variant === "default",
      "button--primary": this.variant === "primary",
      "button--success": this.variant === "success",
      "button--neutral": this.variant === "neutral",
      "button--warning": this.variant === "warning",
      "button--danger": this.variant === "danger",
      "button--text": this.variant === "text",
      "button--small": this.size === "small",
      "button--medium": this.size === "medium",
      "button--large": this.size === "large",
      "button--caret": this.caret,
      "button--circle": this.circle,
      "button--disabled": this.disabled,
      "button--focused": this.hasFocus,
      "button--loading": this.loading,
      "button--standard": !this.outline,
      "button--outline": this.outline,
      "button--pill": this.pill,
      "button--rtl": this.localize.dir() === "rtl",
      "button--has-label": this.hasSlotController.test("[default]"),
      "button--has-prefix": this.hasSlotController.test("prefix"),
      "button--has-suffix": this.hasSlotController.test("suffix")
    })}
        ?disabled=${l$2(isLink ? void 0 : this.disabled)}
        type=${l$2(isLink ? void 0 : this.type)}
        title=${this.title}
        name=${l$2(isLink ? void 0 : this.name)}
        value=${l$2(isLink ? void 0 : this.value)}
        href=${l$2(isLink ? this.href : void 0)}
        target=${l$2(isLink ? this.target : void 0)}
        download=${l$2(isLink ? this.download : void 0)}
        rel=${l$2(isLink ? this.rel : void 0)}
        role=${l$2(isLink ? void 0 : "button")}
        aria-disabled=${this.disabled ? "true" : "false"}
        tabindex=${this.disabled ? "-1" : "0"}
        @blur=${this.handleBlur}
        @focus=${this.handleFocus}
        @invalid=${this.isButton() ? this.handleInvalid : null}
        @click=${this.handleClick}
      >
        <slot name="prefix" part="prefix" class="button__prefix"></slot>
        <slot part="label" class="button__label"></slot>
        <slot name="suffix" part="suffix" class="button__suffix"></slot>
        ${this.caret ? n$9` <sl-icon part="caret" class="button__caret" library="system" name="caret"></sl-icon> ` : ""}
        ${this.loading ? n$9`<sl-spinner part="spinner"></sl-spinner>` : ""}
      </${tag}>
    `;
  }
};
SlButton.styles = button_styles_default;
SlButton.dependencies = {
  "sl-icon": SlIcon,
  "sl-spinner": SlSpinner
};
__decorateClass([
  i$7(".button")
], SlButton.prototype, "button", 2);
__decorateClass([
  t$7()
], SlButton.prototype, "hasFocus", 2);
__decorateClass([
  t$7()
], SlButton.prototype, "invalid", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "title", 2);
__decorateClass([
  e$c({ reflect: true })
], SlButton.prototype, "variant", 2);
__decorateClass([
  e$c({ reflect: true })
], SlButton.prototype, "size", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlButton.prototype, "caret", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlButton.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlButton.prototype, "loading", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlButton.prototype, "outline", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlButton.prototype, "pill", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlButton.prototype, "circle", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "type", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "name", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "value", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "href", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "target", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "rel", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "download", 2);
__decorateClass([
  e$c()
], SlButton.prototype, "form", 2);
__decorateClass([
  e$c({ attribute: "formaction" })
], SlButton.prototype, "formAction", 2);
__decorateClass([
  e$c({ attribute: "formenctype" })
], SlButton.prototype, "formEnctype", 2);
__decorateClass([
  e$c({ attribute: "formmethod" })
], SlButton.prototype, "formMethod", 2);
__decorateClass([
  e$c({ attribute: "formnovalidate", type: Boolean })
], SlButton.prototype, "formNoValidate", 2);
__decorateClass([
  e$c({ attribute: "formtarget" })
], SlButton.prototype, "formTarget", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], SlButton.prototype, "handleDisabledChange", 1);

/**
 * Take input from [0, n] and return it as [0, 1]
 * @hidden
 */
function bound01(n, max) {
    if (isOnePointZero(n)) {
        n = '100%';
    }
    var isPercent = isPercentage(n);
    n = max === 360 ? n : Math.min(max, Math.max(0, parseFloat(n)));
    // Automatically convert percentage into number
    if (isPercent) {
        n = parseInt(String(n * max), 10) / 100;
    }
    // Handle floating point rounding errors
    if (Math.abs(n - max) < 0.000001) {
        return 1;
    }
    // Convert into [0, 1] range if it isn't already
    if (max === 360) {
        // If n is a hue given in degrees,
        // wrap around out-of-range values into [0, 360] range
        // then convert into [0, 1].
        n = (n < 0 ? (n % max) + max : n % max) / parseFloat(String(max));
    }
    else {
        // If n not a hue given in degrees
        // Convert into [0, 1] range if it isn't already.
        n = (n % max) / parseFloat(String(max));
    }
    return n;
}
/**
 * Force a number between 0 and 1
 * @hidden
 */
function clamp01(val) {
    return Math.min(1, Math.max(0, val));
}
/**
 * Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
 * <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
 * @hidden
 */
function isOnePointZero(n) {
    return typeof n === 'string' && n.indexOf('.') !== -1 && parseFloat(n) === 1;
}
/**
 * Check to see if string passed in is a percentage
 * @hidden
 */
function isPercentage(n) {
    return typeof n === 'string' && n.indexOf('%') !== -1;
}
/**
 * Return a valid alpha value [0,1] with all invalid values being set to 1
 * @hidden
 */
function boundAlpha(a) {
    a = parseFloat(a);
    if (isNaN(a) || a < 0 || a > 1) {
        a = 1;
    }
    return a;
}
/**
 * Replace a decimal with it's percentage value
 * @hidden
 */
function convertToPercentage(n) {
    if (n <= 1) {
        return "".concat(Number(n) * 100, "%");
    }
    return n;
}
/**
 * Force a hex value to have 2 characters
 * @hidden
 */
function pad2(c) {
    return c.length === 1 ? '0' + c : String(c);
}

// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
/**
 * Handle bounds / percentage checking to conform to CSS color spec
 * <http://www.w3.org/TR/css3-color/>
 * *Assumes:* r, g, b in [0, 255] or [0, 1]
 * *Returns:* { r, g, b } in [0, 255]
 */
function rgbToRgb(r, g, b) {
    return {
        r: bound01(r, 255) * 255,
        g: bound01(g, 255) * 255,
        b: bound01(b, 255) * 255,
    };
}
/**
 * Converts an RGB color value to HSL.
 * *Assumes:* r, g, and b are contained in [0, 255] or [0, 1]
 * *Returns:* { h, s, l } in [0,1]
 */
function rgbToHsl(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b);
    var min = Math.min(r, g, b);
    var h = 0;
    var s = 0;
    var l = (max + min) / 2;
    if (max === min) {
        s = 0;
        h = 0; // achromatic
    }
    else {
        var d = max - min;
        s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
            default:
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, l: l };
}
function hue2rgb(p, q, t) {
    if (t < 0) {
        t += 1;
    }
    if (t > 1) {
        t -= 1;
    }
    if (t < 1 / 6) {
        return p + (q - p) * (6 * t);
    }
    if (t < 1 / 2) {
        return q;
    }
    if (t < 2 / 3) {
        return p + (q - p) * (2 / 3 - t) * 6;
    }
    return p;
}
/**
 * Converts an HSL color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hslToRgb(h, s, l) {
    var r;
    var g;
    var b;
    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);
    if (s === 0) {
        // achromatic
        g = l;
        b = l;
        r = l;
    }
    else {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1 / 3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1 / 3);
    }
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color value to HSV
 *
 * *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
 * *Returns:* { h, s, v } in [0,1]
 */
function rgbToHsv(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b);
    var min = Math.min(r, g, b);
    var h = 0;
    var v = max;
    var d = max - min;
    var s = max === 0 ? 0 : d / max;
    if (max === min) {
        h = 0; // achromatic
    }
    else {
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
            default:
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, v: v };
}
/**
 * Converts an HSV color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hsvToRgb(h, s, v) {
    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);
    var i = Math.floor(h);
    var f = h - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);
    var mod = i % 6;
    var r = [v, q, p, p, t, v][mod];
    var g = [t, v, v, q, p, p][mod];
    var b = [p, p, t, v, v, q][mod];
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color to hex
 *
 * Assumes r, g, and b are contained in the set [0, 255]
 * Returns a 3 or 6 character hex
 */
function rgbToHex(r, g, b, allow3Char) {
    var hex = [
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
    ];
    // Return a 3 character hex if possible
    if (allow3Char &&
        hex[0].startsWith(hex[0].charAt(1)) &&
        hex[1].startsWith(hex[1].charAt(1)) &&
        hex[2].startsWith(hex[2].charAt(1))) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }
    return hex.join('');
}
/**
 * Converts an RGBA color plus alpha transparency to hex
 *
 * Assumes r, g, b are contained in the set [0, 255] and
 * a in [0, 1]. Returns a 4 or 8 character rgba hex
 */
// eslint-disable-next-line max-params
function rgbaToHex(r, g, b, a, allow4Char) {
    var hex = [
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
        pad2(convertDecimalToHex(a)),
    ];
    // Return a 4 character hex if possible
    if (allow4Char &&
        hex[0].startsWith(hex[0].charAt(1)) &&
        hex[1].startsWith(hex[1].charAt(1)) &&
        hex[2].startsWith(hex[2].charAt(1)) &&
        hex[3].startsWith(hex[3].charAt(1))) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0) + hex[3].charAt(0);
    }
    return hex.join('');
}
/**
 * Converts an RGBA color to an ARGB Hex8 string
 * Rarely used, but required for "toFilter()"
 */
function rgbaToArgbHex(r, g, b, a) {
    var hex = [
        pad2(convertDecimalToHex(a)),
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
    ];
    return hex.join('');
}
/** Converts a decimal to a hex value */
function convertDecimalToHex(d) {
    return Math.round(parseFloat(d) * 255).toString(16);
}
/** Converts a hex value to a decimal */
function convertHexToDecimal(h) {
    return parseIntFromHex(h) / 255;
}
/** Parse a base-16 hex value into a base-10 integer */
function parseIntFromHex(val) {
    return parseInt(val, 16);
}
function numberInputToObject(color) {
    return {
        r: color >> 16,
        g: (color & 0xff00) >> 8,
        b: color & 0xff,
    };
}

// https://github.com/bahamas10/css-color-names/blob/master/css-color-names.json
/**
 * @hidden
 */
var names = {
    aliceblue: '#f0f8ff',
    antiquewhite: '#faebd7',
    aqua: '#00ffff',
    aquamarine: '#7fffd4',
    azure: '#f0ffff',
    beige: '#f5f5dc',
    bisque: '#ffe4c4',
    black: '#000000',
    blanchedalmond: '#ffebcd',
    blue: '#0000ff',
    blueviolet: '#8a2be2',
    brown: '#a52a2a',
    burlywood: '#deb887',
    cadetblue: '#5f9ea0',
    chartreuse: '#7fff00',
    chocolate: '#d2691e',
    coral: '#ff7f50',
    cornflowerblue: '#6495ed',
    cornsilk: '#fff8dc',
    crimson: '#dc143c',
    cyan: '#00ffff',
    darkblue: '#00008b',
    darkcyan: '#008b8b',
    darkgoldenrod: '#b8860b',
    darkgray: '#a9a9a9',
    darkgreen: '#006400',
    darkgrey: '#a9a9a9',
    darkkhaki: '#bdb76b',
    darkmagenta: '#8b008b',
    darkolivegreen: '#556b2f',
    darkorange: '#ff8c00',
    darkorchid: '#9932cc',
    darkred: '#8b0000',
    darksalmon: '#e9967a',
    darkseagreen: '#8fbc8f',
    darkslateblue: '#483d8b',
    darkslategray: '#2f4f4f',
    darkslategrey: '#2f4f4f',
    darkturquoise: '#00ced1',
    darkviolet: '#9400d3',
    deeppink: '#ff1493',
    deepskyblue: '#00bfff',
    dimgray: '#696969',
    dimgrey: '#696969',
    dodgerblue: '#1e90ff',
    firebrick: '#b22222',
    floralwhite: '#fffaf0',
    forestgreen: '#228b22',
    fuchsia: '#ff00ff',
    gainsboro: '#dcdcdc',
    ghostwhite: '#f8f8ff',
    goldenrod: '#daa520',
    gold: '#ffd700',
    gray: '#808080',
    green: '#008000',
    greenyellow: '#adff2f',
    grey: '#808080',
    honeydew: '#f0fff0',
    hotpink: '#ff69b4',
    indianred: '#cd5c5c',
    indigo: '#4b0082',
    ivory: '#fffff0',
    khaki: '#f0e68c',
    lavenderblush: '#fff0f5',
    lavender: '#e6e6fa',
    lawngreen: '#7cfc00',
    lemonchiffon: '#fffacd',
    lightblue: '#add8e6',
    lightcoral: '#f08080',
    lightcyan: '#e0ffff',
    lightgoldenrodyellow: '#fafad2',
    lightgray: '#d3d3d3',
    lightgreen: '#90ee90',
    lightgrey: '#d3d3d3',
    lightpink: '#ffb6c1',
    lightsalmon: '#ffa07a',
    lightseagreen: '#20b2aa',
    lightskyblue: '#87cefa',
    lightslategray: '#778899',
    lightslategrey: '#778899',
    lightsteelblue: '#b0c4de',
    lightyellow: '#ffffe0',
    lime: '#00ff00',
    limegreen: '#32cd32',
    linen: '#faf0e6',
    magenta: '#ff00ff',
    maroon: '#800000',
    mediumaquamarine: '#66cdaa',
    mediumblue: '#0000cd',
    mediumorchid: '#ba55d3',
    mediumpurple: '#9370db',
    mediumseagreen: '#3cb371',
    mediumslateblue: '#7b68ee',
    mediumspringgreen: '#00fa9a',
    mediumturquoise: '#48d1cc',
    mediumvioletred: '#c71585',
    midnightblue: '#191970',
    mintcream: '#f5fffa',
    mistyrose: '#ffe4e1',
    moccasin: '#ffe4b5',
    navajowhite: '#ffdead',
    navy: '#000080',
    oldlace: '#fdf5e6',
    olive: '#808000',
    olivedrab: '#6b8e23',
    orange: '#ffa500',
    orangered: '#ff4500',
    orchid: '#da70d6',
    palegoldenrod: '#eee8aa',
    palegreen: '#98fb98',
    paleturquoise: '#afeeee',
    palevioletred: '#db7093',
    papayawhip: '#ffefd5',
    peachpuff: '#ffdab9',
    peru: '#cd853f',
    pink: '#ffc0cb',
    plum: '#dda0dd',
    powderblue: '#b0e0e6',
    purple: '#800080',
    rebeccapurple: '#663399',
    red: '#ff0000',
    rosybrown: '#bc8f8f',
    royalblue: '#4169e1',
    saddlebrown: '#8b4513',
    salmon: '#fa8072',
    sandybrown: '#f4a460',
    seagreen: '#2e8b57',
    seashell: '#fff5ee',
    sienna: '#a0522d',
    silver: '#c0c0c0',
    skyblue: '#87ceeb',
    slateblue: '#6a5acd',
    slategray: '#708090',
    slategrey: '#708090',
    snow: '#fffafa',
    springgreen: '#00ff7f',
    steelblue: '#4682b4',
    tan: '#d2b48c',
    teal: '#008080',
    thistle: '#d8bfd8',
    tomato: '#ff6347',
    turquoise: '#40e0d0',
    violet: '#ee82ee',
    wheat: '#f5deb3',
    white: '#ffffff',
    whitesmoke: '#f5f5f5',
    yellow: '#ffff00',
    yellowgreen: '#9acd32',
};

/* eslint-disable @typescript-eslint/no-redundant-type-constituents */
/**
 * Given a string or object, convert that input to RGB
 *
 * Possible string inputs:
 * ```
 * "red"
 * "#f00" or "f00"
 * "#ff0000" or "ff0000"
 * "#ff000000" or "ff000000"
 * "rgb 255 0 0" or "rgb (255, 0, 0)"
 * "rgb 1.0 0 0" or "rgb (1, 0, 0)"
 * "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
 * "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
 * "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
 * "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
 * "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
 * ```
 */
function inputToRGB(color) {
    var rgb = { r: 0, g: 0, b: 0 };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;
    if (typeof color === 'string') {
        color = stringInputToObject(color);
    }
    if (typeof color === 'object') {
        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === '%' ? 'prgb' : 'rgb';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = 'hsv';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = 'hsl';
        }
        if (Object.prototype.hasOwnProperty.call(color, 'a')) {
            a = color.a;
        }
    }
    a = boundAlpha(a);
    return {
        ok: ok,
        format: color.format || format,
        r: Math.min(255, Math.max(rgb.r, 0)),
        g: Math.min(255, Math.max(rgb.g, 0)),
        b: Math.min(255, Math.max(rgb.b, 0)),
        a: a,
    };
}
// <http://www.w3.org/TR/css3-values/#integers>
var CSS_INTEGER = '[-\\+]?\\d+%?';
// <http://www.w3.org/TR/css3-values/#number-value>
var CSS_NUMBER = '[-\\+]?\\d*\\.\\d+%?';
// Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
var CSS_UNIT = "(?:".concat(CSS_NUMBER, ")|(?:").concat(CSS_INTEGER, ")");
// Actual matching.
// Parentheses and commas are optional, but not required.
// Whitespace can take the place of commas or opening paren
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(".concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")\\s*\\)?");
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(".concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")\\s*\\)?");
var matchers = {
    CSS_UNIT: new RegExp(CSS_UNIT),
    rgb: new RegExp('rgb' + PERMISSIVE_MATCH3),
    rgba: new RegExp('rgba' + PERMISSIVE_MATCH4),
    hsl: new RegExp('hsl' + PERMISSIVE_MATCH3),
    hsla: new RegExp('hsla' + PERMISSIVE_MATCH4),
    hsv: new RegExp('hsv' + PERMISSIVE_MATCH3),
    hsva: new RegExp('hsva' + PERMISSIVE_MATCH4),
    hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
    hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
};
/**
 * Permissive string parsing.  Take in a number of formats, and output an object
 * based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
 */
function stringInputToObject(color) {
    color = color.trim().toLowerCase();
    if (color.length === 0) {
        return false;
    }
    var named = false;
    if (names[color]) {
        color = names[color];
        named = true;
    }
    else if (color === 'transparent') {
        return { r: 0, g: 0, b: 0, a: 0, format: 'name' };
    }
    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match = matchers.rgb.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3] };
    }
    match = matchers.rgba.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3], a: match[4] };
    }
    match = matchers.hsl.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3] };
    }
    match = matchers.hsla.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3], a: match[4] };
    }
    match = matchers.hsv.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3] };
    }
    match = matchers.hsva.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3], a: match[4] };
    }
    match = matchers.hex8.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex6.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    match = matchers.hex4.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            a: convertHexToDecimal(match[4] + match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex3.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    return false;
}
/**
 * Check to see if it looks like a CSS unit
 * (see `matchers` above for definition).
 */
function isValidCSSUnit(color) {
    return Boolean(matchers.CSS_UNIT.exec(String(color)));
}

var TinyColor = /** @class */ (function () {
    function TinyColor(color, opts) {
        if (color === void 0) { color = ''; }
        if (opts === void 0) { opts = {}; }
        var _a;
        // If input is already a tinycolor, return itself
        if (color instanceof TinyColor) {
            // eslint-disable-next-line no-constructor-return
            return color;
        }
        if (typeof color === 'number') {
            color = numberInputToObject(color);
        }
        this.originalInput = color;
        var rgb = inputToRGB(color);
        this.originalInput = color;
        this.r = rgb.r;
        this.g = rgb.g;
        this.b = rgb.b;
        this.a = rgb.a;
        this.roundA = Math.round(100 * this.a) / 100;
        this.format = (_a = opts.format) !== null && _a !== void 0 ? _a : rgb.format;
        this.gradientType = opts.gradientType;
        // Don't let the range of [0,255] come back in [0,1].
        // Potentially lose a little bit of precision here, but will fix issues where
        // .5 gets interpreted as half of the total, instead of half of 1
        // If it was supposed to be 128, this was already taken care of by `inputToRgb`
        if (this.r < 1) {
            this.r = Math.round(this.r);
        }
        if (this.g < 1) {
            this.g = Math.round(this.g);
        }
        if (this.b < 1) {
            this.b = Math.round(this.b);
        }
        this.isValid = rgb.ok;
    }
    TinyColor.prototype.isDark = function () {
        return this.getBrightness() < 128;
    };
    TinyColor.prototype.isLight = function () {
        return !this.isDark();
    };
    /**
     * Returns the perceived brightness of the color, from 0-255.
     */
    TinyColor.prototype.getBrightness = function () {
        // http://www.w3.org/TR/AERT#color-contrast
        var rgb = this.toRgb();
        return (rgb.r * 299 + rgb.g * 587 + rgb.b * 114) / 1000;
    };
    /**
     * Returns the perceived luminance of a color, from 0-1.
     */
    TinyColor.prototype.getLuminance = function () {
        // http://www.w3.org/TR/2008/REC-WCAG20-20081211/#relativeluminancedef
        var rgb = this.toRgb();
        var R;
        var G;
        var B;
        var RsRGB = rgb.r / 255;
        var GsRGB = rgb.g / 255;
        var BsRGB = rgb.b / 255;
        if (RsRGB <= 0.03928) {
            R = RsRGB / 12.92;
        }
        else {
            // eslint-disable-next-line prefer-exponentiation-operator
            R = Math.pow((RsRGB + 0.055) / 1.055, 2.4);
        }
        if (GsRGB <= 0.03928) {
            G = GsRGB / 12.92;
        }
        else {
            // eslint-disable-next-line prefer-exponentiation-operator
            G = Math.pow((GsRGB + 0.055) / 1.055, 2.4);
        }
        if (BsRGB <= 0.03928) {
            B = BsRGB / 12.92;
        }
        else {
            // eslint-disable-next-line prefer-exponentiation-operator
            B = Math.pow((BsRGB + 0.055) / 1.055, 2.4);
        }
        return 0.2126 * R + 0.7152 * G + 0.0722 * B;
    };
    /**
     * Returns the alpha value of a color, from 0-1.
     */
    TinyColor.prototype.getAlpha = function () {
        return this.a;
    };
    /**
     * Sets the alpha value on the current color.
     *
     * @param alpha - The new alpha value. The accepted range is 0-1.
     */
    TinyColor.prototype.setAlpha = function (alpha) {
        this.a = boundAlpha(alpha);
        this.roundA = Math.round(100 * this.a) / 100;
        return this;
    };
    /**
     * Returns whether the color is monochrome.
     */
    TinyColor.prototype.isMonochrome = function () {
        var s = this.toHsl().s;
        return s === 0;
    };
    /**
     * Returns the object as a HSVA object.
     */
    TinyColor.prototype.toHsv = function () {
        var hsv = rgbToHsv(this.r, this.g, this.b);
        return { h: hsv.h * 360, s: hsv.s, v: hsv.v, a: this.a };
    };
    /**
     * Returns the hsva values interpolated into a string with the following format:
     * "hsva(xxx, xxx, xxx, xx)".
     */
    TinyColor.prototype.toHsvString = function () {
        var hsv = rgbToHsv(this.r, this.g, this.b);
        var h = Math.round(hsv.h * 360);
        var s = Math.round(hsv.s * 100);
        var v = Math.round(hsv.v * 100);
        return this.a === 1 ? "hsv(".concat(h, ", ").concat(s, "%, ").concat(v, "%)") : "hsva(".concat(h, ", ").concat(s, "%, ").concat(v, "%, ").concat(this.roundA, ")");
    };
    /**
     * Returns the object as a HSLA object.
     */
    TinyColor.prototype.toHsl = function () {
        var hsl = rgbToHsl(this.r, this.g, this.b);
        return { h: hsl.h * 360, s: hsl.s, l: hsl.l, a: this.a };
    };
    /**
     * Returns the hsla values interpolated into a string with the following format:
     * "hsla(xxx, xxx, xxx, xx)".
     */
    TinyColor.prototype.toHslString = function () {
        var hsl = rgbToHsl(this.r, this.g, this.b);
        var h = Math.round(hsl.h * 360);
        var s = Math.round(hsl.s * 100);
        var l = Math.round(hsl.l * 100);
        return this.a === 1 ? "hsl(".concat(h, ", ").concat(s, "%, ").concat(l, "%)") : "hsla(".concat(h, ", ").concat(s, "%, ").concat(l, "%, ").concat(this.roundA, ")");
    };
    /**
     * Returns the hex value of the color.
     * @param allow3Char will shorten hex value to 3 char if possible
     */
    TinyColor.prototype.toHex = function (allow3Char) {
        if (allow3Char === void 0) { allow3Char = false; }
        return rgbToHex(this.r, this.g, this.b, allow3Char);
    };
    /**
     * Returns the hex value of the color -with a # prefixed.
     * @param allow3Char will shorten hex value to 3 char if possible
     */
    TinyColor.prototype.toHexString = function (allow3Char) {
        if (allow3Char === void 0) { allow3Char = false; }
        return '#' + this.toHex(allow3Char);
    };
    /**
     * Returns the hex 8 value of the color.
     * @param allow4Char will shorten hex value to 4 char if possible
     */
    TinyColor.prototype.toHex8 = function (allow4Char) {
        if (allow4Char === void 0) { allow4Char = false; }
        return rgbaToHex(this.r, this.g, this.b, this.a, allow4Char);
    };
    /**
     * Returns the hex 8 value of the color -with a # prefixed.
     * @param allow4Char will shorten hex value to 4 char if possible
     */
    TinyColor.prototype.toHex8String = function (allow4Char) {
        if (allow4Char === void 0) { allow4Char = false; }
        return '#' + this.toHex8(allow4Char);
    };
    /**
     * Returns the shorter hex value of the color depends on its alpha -with a # prefixed.
     * @param allowShortChar will shorten hex value to 3 or 4 char if possible
     */
    TinyColor.prototype.toHexShortString = function (allowShortChar) {
        if (allowShortChar === void 0) { allowShortChar = false; }
        return this.a === 1 ? this.toHexString(allowShortChar) : this.toHex8String(allowShortChar);
    };
    /**
     * Returns the object as a RGBA object.
     */
    TinyColor.prototype.toRgb = function () {
        return {
            r: Math.round(this.r),
            g: Math.round(this.g),
            b: Math.round(this.b),
            a: this.a,
        };
    };
    /**
     * Returns the RGBA values interpolated into a string with the following format:
     * "RGBA(xxx, xxx, xxx, xx)".
     */
    TinyColor.prototype.toRgbString = function () {
        var r = Math.round(this.r);
        var g = Math.round(this.g);
        var b = Math.round(this.b);
        return this.a === 1 ? "rgb(".concat(r, ", ").concat(g, ", ").concat(b, ")") : "rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(this.roundA, ")");
    };
    /**
     * Returns the object as a RGBA object.
     */
    TinyColor.prototype.toPercentageRgb = function () {
        var fmt = function (x) { return "".concat(Math.round(bound01(x, 255) * 100), "%"); };
        return {
            r: fmt(this.r),
            g: fmt(this.g),
            b: fmt(this.b),
            a: this.a,
        };
    };
    /**
     * Returns the RGBA relative values interpolated into a string
     */
    TinyColor.prototype.toPercentageRgbString = function () {
        var rnd = function (x) { return Math.round(bound01(x, 255) * 100); };
        return this.a === 1
            ? "rgb(".concat(rnd(this.r), "%, ").concat(rnd(this.g), "%, ").concat(rnd(this.b), "%)")
            : "rgba(".concat(rnd(this.r), "%, ").concat(rnd(this.g), "%, ").concat(rnd(this.b), "%, ").concat(this.roundA, ")");
    };
    /**
     * The 'real' name of the color -if there is one.
     */
    TinyColor.prototype.toName = function () {
        if (this.a === 0) {
            return 'transparent';
        }
        if (this.a < 1) {
            return false;
        }
        var hex = '#' + rgbToHex(this.r, this.g, this.b, false);
        for (var _i = 0, _a = Object.entries(names); _i < _a.length; _i++) {
            var _b = _a[_i], key = _b[0], value = _b[1];
            if (hex === value) {
                return key;
            }
        }
        return false;
    };
    TinyColor.prototype.toString = function (format) {
        var formatSet = Boolean(format);
        format = format !== null && format !== void 0 ? format : this.format;
        var formattedString = false;
        var hasAlpha = this.a < 1 && this.a >= 0;
        var needsAlphaFormat = !formatSet && hasAlpha && (format.startsWith('hex') || format === 'name');
        if (needsAlphaFormat) {
            // Special case for "transparent", all other non-alpha formats
            // will return rgba when there is transparency.
            if (format === 'name' && this.a === 0) {
                return this.toName();
            }
            return this.toRgbString();
        }
        if (format === 'rgb') {
            formattedString = this.toRgbString();
        }
        if (format === 'prgb') {
            formattedString = this.toPercentageRgbString();
        }
        if (format === 'hex' || format === 'hex6') {
            formattedString = this.toHexString();
        }
        if (format === 'hex3') {
            formattedString = this.toHexString(true);
        }
        if (format === 'hex4') {
            formattedString = this.toHex8String(true);
        }
        if (format === 'hex8') {
            formattedString = this.toHex8String();
        }
        if (format === 'name') {
            formattedString = this.toName();
        }
        if (format === 'hsl') {
            formattedString = this.toHslString();
        }
        if (format === 'hsv') {
            formattedString = this.toHsvString();
        }
        return formattedString || this.toHexString();
    };
    TinyColor.prototype.toNumber = function () {
        return (Math.round(this.r) << 16) + (Math.round(this.g) << 8) + Math.round(this.b);
    };
    TinyColor.prototype.clone = function () {
        return new TinyColor(this.toString());
    };
    /**
     * Lighten the color a given amount. Providing 100 will always return white.
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.lighten = function (amount) {
        if (amount === void 0) { amount = 10; }
        var hsl = this.toHsl();
        hsl.l += amount / 100;
        hsl.l = clamp01(hsl.l);
        return new TinyColor(hsl);
    };
    /**
     * Brighten the color a given amount, from 0 to 100.
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.brighten = function (amount) {
        if (amount === void 0) { amount = 10; }
        var rgb = this.toRgb();
        rgb.r = Math.max(0, Math.min(255, rgb.r - Math.round(255 * -(amount / 100))));
        rgb.g = Math.max(0, Math.min(255, rgb.g - Math.round(255 * -(amount / 100))));
        rgb.b = Math.max(0, Math.min(255, rgb.b - Math.round(255 * -(amount / 100))));
        return new TinyColor(rgb);
    };
    /**
     * Darken the color a given amount, from 0 to 100.
     * Providing 100 will always return black.
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.darken = function (amount) {
        if (amount === void 0) { amount = 10; }
        var hsl = this.toHsl();
        hsl.l -= amount / 100;
        hsl.l = clamp01(hsl.l);
        return new TinyColor(hsl);
    };
    /**
     * Mix the color with pure white, from 0 to 100.
     * Providing 0 will do nothing, providing 100 will always return white.
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.tint = function (amount) {
        if (amount === void 0) { amount = 10; }
        return this.mix('white', amount);
    };
    /**
     * Mix the color with pure black, from 0 to 100.
     * Providing 0 will do nothing, providing 100 will always return black.
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.shade = function (amount) {
        if (amount === void 0) { amount = 10; }
        return this.mix('black', amount);
    };
    /**
     * Desaturate the color a given amount, from 0 to 100.
     * Providing 100 will is the same as calling greyscale
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.desaturate = function (amount) {
        if (amount === void 0) { amount = 10; }
        var hsl = this.toHsl();
        hsl.s -= amount / 100;
        hsl.s = clamp01(hsl.s);
        return new TinyColor(hsl);
    };
    /**
     * Saturate the color a given amount, from 0 to 100.
     * @param amount - valid between 1-100
     */
    TinyColor.prototype.saturate = function (amount) {
        if (amount === void 0) { amount = 10; }
        var hsl = this.toHsl();
        hsl.s += amount / 100;
        hsl.s = clamp01(hsl.s);
        return new TinyColor(hsl);
    };
    /**
     * Completely desaturates a color into greyscale.
     * Same as calling `desaturate(100)`
     */
    TinyColor.prototype.greyscale = function () {
        return this.desaturate(100);
    };
    /**
     * Spin takes a positive or negative amount within [-360, 360] indicating the change of hue.
     * Values outside of this range will be wrapped into this range.
     */
    TinyColor.prototype.spin = function (amount) {
        var hsl = this.toHsl();
        var hue = (hsl.h + amount) % 360;
        hsl.h = hue < 0 ? 360 + hue : hue;
        return new TinyColor(hsl);
    };
    /**
     * Mix the current color a given amount with another color, from 0 to 100.
     * 0 means no mixing (return current color).
     */
    TinyColor.prototype.mix = function (color, amount) {
        if (amount === void 0) { amount = 50; }
        var rgb1 = this.toRgb();
        var rgb2 = new TinyColor(color).toRgb();
        var p = amount / 100;
        var rgba = {
            r: (rgb2.r - rgb1.r) * p + rgb1.r,
            g: (rgb2.g - rgb1.g) * p + rgb1.g,
            b: (rgb2.b - rgb1.b) * p + rgb1.b,
            a: (rgb2.a - rgb1.a) * p + rgb1.a,
        };
        return new TinyColor(rgba);
    };
    TinyColor.prototype.analogous = function (results, slices) {
        if (results === void 0) { results = 6; }
        if (slices === void 0) { slices = 30; }
        var hsl = this.toHsl();
        var part = 360 / slices;
        var ret = [this];
        for (hsl.h = (hsl.h - ((part * results) >> 1) + 720) % 360; --results;) {
            hsl.h = (hsl.h + part) % 360;
            ret.push(new TinyColor(hsl));
        }
        return ret;
    };
    /**
     * taken from https://github.com/infusion/jQuery-xcolor/blob/master/jquery.xcolor.js
     */
    TinyColor.prototype.complement = function () {
        var hsl = this.toHsl();
        hsl.h = (hsl.h + 180) % 360;
        return new TinyColor(hsl);
    };
    TinyColor.prototype.monochromatic = function (results) {
        if (results === void 0) { results = 6; }
        var hsv = this.toHsv();
        var h = hsv.h;
        var s = hsv.s;
        var v = hsv.v;
        var res = [];
        var modification = 1 / results;
        while (results--) {
            res.push(new TinyColor({ h: h, s: s, v: v }));
            v = (v + modification) % 1;
        }
        return res;
    };
    TinyColor.prototype.splitcomplement = function () {
        var hsl = this.toHsl();
        var h = hsl.h;
        return [
            this,
            new TinyColor({ h: (h + 72) % 360, s: hsl.s, l: hsl.l }),
            new TinyColor({ h: (h + 216) % 360, s: hsl.s, l: hsl.l }),
        ];
    };
    /**
     * Compute how the color would appear on a background
     */
    TinyColor.prototype.onBackground = function (background) {
        var fg = this.toRgb();
        var bg = new TinyColor(background).toRgb();
        var alpha = fg.a + bg.a * (1 - fg.a);
        return new TinyColor({
            r: (fg.r * fg.a + bg.r * bg.a * (1 - fg.a)) / alpha,
            g: (fg.g * fg.a + bg.g * bg.a * (1 - fg.a)) / alpha,
            b: (fg.b * fg.a + bg.b * bg.a * (1 - fg.a)) / alpha,
            a: alpha,
        });
    };
    /**
     * Alias for `polyad(3)`
     */
    TinyColor.prototype.triad = function () {
        return this.polyad(3);
    };
    /**
     * Alias for `polyad(4)`
     */
    TinyColor.prototype.tetrad = function () {
        return this.polyad(4);
    };
    /**
     * Get polyad colors, like (for 1, 2, 3, 4, 5, 6, 7, 8, etc...)
     * monad, dyad, triad, tetrad, pentad, hexad, heptad, octad, etc...
     */
    TinyColor.prototype.polyad = function (n) {
        var hsl = this.toHsl();
        var h = hsl.h;
        var result = [this];
        var increment = 360 / n;
        for (var i = 1; i < n; i++) {
            result.push(new TinyColor({ h: (h + i * increment) % 360, s: hsl.s, l: hsl.l }));
        }
        return result;
    };
    /**
     * compare color vs current color
     */
    TinyColor.prototype.equals = function (color) {
        return this.toRgbString() === new TinyColor(color).toRgbString();
    };
    return TinyColor;
}());
// kept for backwards compatability with v1
function tinycolor(color, opts) {
    if (color === void 0) { color = ''; }
    if (opts === void 0) { opts = {}; }
    return new TinyColor(color, opts);
}

// Readability Functions
// ---------------------
// <http://www.w3.org/TR/2008/REC-WCAG20-20081211/#contrast-ratiodef (WCAG Version 2)
/**
 * AKA `contrast`
 *
 * Analyze the 2 colors and returns the color contrast defined by (WCAG Version 2)
 */
function readability(color1, color2) {
    var c1 = new TinyColor(color1);
    var c2 = new TinyColor(color2);
    return ((Math.max(c1.getLuminance(), c2.getLuminance()) + 0.05) /
        (Math.min(c1.getLuminance(), c2.getLuminance()) + 0.05));
}
/**
 * Ensure that foreground and background color combinations meet WCAG2 guidelines.
 * The third argument is an object.
 *      the 'level' property states 'AA' or 'AAA' - if missing or invalid, it defaults to 'AA';
 *      the 'size' property states 'large' or 'small' - if missing or invalid, it defaults to 'small'.
 * If the entire object is absent, isReadable defaults to {level:"AA",size:"small"}.
 *
 * Example
 * ```ts
 * new TinyColor().isReadable('#000', '#111') => false
 * new TinyColor().isReadable('#000', '#111', { level: 'AA', size: 'large' }) => false
 * ```
 */
function isReadable(color1, color2, wcag2) {
    var _a, _b;
    if (wcag2 === void 0) { wcag2 = { level: 'AA', size: 'small' }; }
    var readabilityLevel = readability(color1, color2);
    switch (((_a = wcag2.level) !== null && _a !== void 0 ? _a : 'AA') + ((_b = wcag2.size) !== null && _b !== void 0 ? _b : 'small')) {
        case 'AAsmall':
        case 'AAAlarge':
            return readabilityLevel >= 4.5;
        case 'AAlarge':
            return readabilityLevel >= 3;
        case 'AAAsmall':
            return readabilityLevel >= 7;
        default:
            return false;
    }
}
/**
 * Given a base color and a list of possible foreground or background
 * colors for that base, returns the most readable color.
 * Optionally returns Black or White if the most readable color is unreadable.
 *
 * @param baseColor - the base color.
 * @param colorList - array of colors to pick the most readable one from.
 * @param args - and object with extra arguments
 *
 * Example
 * ```ts
 * new TinyColor().mostReadable('#123', ['#124", "#125'], { includeFallbackColors: false }).toHexString(); // "#112255"
 * new TinyColor().mostReadable('#123', ['#124", "#125'],{ includeFallbackColors: true }).toHexString();  // "#ffffff"
 * new TinyColor().mostReadable('#a8015a', ["#faf3f3"], { includeFallbackColors:true, level: 'AAA', size: 'large' }).toHexString(); // "#faf3f3"
 * new TinyColor().mostReadable('#a8015a', ["#faf3f3"], { includeFallbackColors:true, level: 'AAA', size: 'small' }).toHexString(); // "#ffffff"
 * ```
 */
function mostReadable(baseColor, colorList, args) {
    if (args === void 0) { args = { includeFallbackColors: false, level: 'AA', size: 'small' }; }
    var bestColor = null;
    var bestScore = 0;
    var includeFallbackColors = args.includeFallbackColors, level = args.level, size = args.size;
    for (var _i = 0, colorList_1 = colorList; _i < colorList_1.length; _i++) {
        var color = colorList_1[_i];
        var score = readability(baseColor, color);
        if (score > bestScore) {
            bestScore = score;
            bestColor = new TinyColor(color);
        }
    }
    if (isReadable(baseColor, bestColor, { level: level, size: size }) || !includeFallbackColors) {
        return bestColor;
    }
    args.includeFallbackColors = false;
    return mostReadable(baseColor, ['#fff', '#000'], args);
}

/**
 * Returns the color represented as a Microsoft filter for use in old versions of IE.
 */
function toMsFilter(firstColor, secondColor) {
    var color = new TinyColor(firstColor);
    var hex8String = '#' + rgbaToArgbHex(color.r, color.g, color.b, color.a);
    var secondHex8String = hex8String;
    var gradientType = color.gradientType ? 'GradientType = 1, ' : '';
    if (secondColor) {
        var s = new TinyColor(secondColor);
        secondHex8String = '#' + rgbaToArgbHex(s.r, s.g, s.b, s.a);
    }
    return "progid:DXImageTransform.Microsoft.gradient(".concat(gradientType, "startColorstr=").concat(hex8String, ",endColorstr=").concat(secondHex8String, ")");
}

/**
 * If input is an object, force 1 into "1.0" to handle ratios properly
 * String input requires "1.0" as input, so 1 will be treated as 1
 */
function fromRatio(ratio, opts) {
    var newColor = {
        r: convertToPercentage(ratio.r),
        g: convertToPercentage(ratio.g),
        b: convertToPercentage(ratio.b),
    };
    if (ratio.a !== undefined) {
        newColor.a = Number(ratio.a);
    }
    return new TinyColor(newColor, opts);
}
/** old random function */
function legacyRandom() {
    return new TinyColor({
        r: Math.random(),
        g: Math.random(),
        b: Math.random(),
    });
}

/* eslint-disable @typescript-eslint/no-redundant-type-constituents */
function random(options) {
    if (options === void 0) { options = {}; }
    // Check if we need to generate multiple colors
    if (options.count !== undefined &&
        options.count !== null) {
        var totalColors = options.count;
        var colors = [];
        options.count = undefined;
        while (totalColors > colors.length) {
            // Since we're generating multiple colors,
            // incremement the seed. Otherwise we'd just
            // generate the same color each time...
            options.count = null;
            if (options.seed) {
                options.seed += 1;
            }
            colors.push(random(options));
        }
        options.count = totalColors;
        return colors;
    }
    // First we pick a hue (H)
    var h = pickHue(options.hue, options.seed);
    // Then use H to determine saturation (S)
    var s = pickSaturation(h, options);
    // Then use S and H to determine brightness (B).
    var v = pickBrightness(h, s, options);
    var res = { h: h, s: s, v: v };
    if (options.alpha !== undefined) {
        res.a = options.alpha;
    }
    // Then we return the HSB color in the desired format
    return new TinyColor(res);
}
function pickHue(hue, seed) {
    var hueRange = getHueRange(hue);
    var res = randomWithin(hueRange, seed);
    // Instead of storing red as two seperate ranges,
    // we group them, using negative numbers
    if (res < 0) {
        res = 360 + res;
    }
    return res;
}
function pickSaturation(hue, options) {
    if (options.hue === 'monochrome') {
        return 0;
    }
    if (options.luminosity === 'random') {
        return randomWithin([0, 100], options.seed);
    }
    var saturationRange = getColorInfo(hue).saturationRange;
    var sMin = saturationRange[0];
    var sMax = saturationRange[1];
    switch (options.luminosity) {
        case 'bright':
            sMin = 55;
            break;
        case 'dark':
            sMin = sMax - 10;
            break;
        case 'light':
            sMax = 55;
            break;
        default:
            break;
    }
    return randomWithin([sMin, sMax], options.seed);
}
function pickBrightness(H, S, options) {
    var bMin = getMinimumBrightness(H, S);
    var bMax = 100;
    switch (options.luminosity) {
        case 'dark':
            bMax = bMin + 20;
            break;
        case 'light':
            bMin = (bMax + bMin) / 2;
            break;
        case 'random':
            bMin = 0;
            bMax = 100;
            break;
        default:
            break;
    }
    return randomWithin([bMin, bMax], options.seed);
}
function getMinimumBrightness(H, S) {
    var lowerBounds = getColorInfo(H).lowerBounds;
    for (var i = 0; i < lowerBounds.length - 1; i++) {
        var s1 = lowerBounds[i][0];
        var v1 = lowerBounds[i][1];
        var s2 = lowerBounds[i + 1][0];
        var v2 = lowerBounds[i + 1][1];
        if (S >= s1 && S <= s2) {
            var m = (v2 - v1) / (s2 - s1);
            var b = v1 - m * s1;
            return m * S + b;
        }
    }
    return 0;
}
function getHueRange(colorInput) {
    var num = parseInt(colorInput, 10);
    if (!Number.isNaN(num) && num < 360 && num > 0) {
        return [num, num];
    }
    if (typeof colorInput === 'string') {
        var namedColor = bounds.find(function (n) { return n.name === colorInput; });
        if (namedColor) {
            var color = defineColor(namedColor);
            if (color.hueRange) {
                return color.hueRange;
            }
        }
        var parsed = new TinyColor(colorInput);
        if (parsed.isValid) {
            var hue = parsed.toHsv().h;
            return [hue, hue];
        }
    }
    return [0, 360];
}
function getColorInfo(hue) {
    // Maps red colors to make picking hue easier
    if (hue >= 334 && hue <= 360) {
        hue -= 360;
    }
    for (var _i = 0, bounds_1 = bounds; _i < bounds_1.length; _i++) {
        var bound = bounds_1[_i];
        var color = defineColor(bound);
        if (color.hueRange && hue >= color.hueRange[0] && hue <= color.hueRange[1]) {
            return color;
        }
    }
    throw Error('Color not found');
}
function randomWithin(range, seed) {
    if (seed === undefined) {
        return Math.floor(range[0] + Math.random() * (range[1] + 1 - range[0]));
    }
    // Seeded random algorithm from http://indiegamr.com/generate-repeatable-random-numbers-in-js/
    var max = range[1] || 1;
    var min = range[0] || 0;
    seed = (seed * 9301 + 49297) % 233280;
    var rnd = seed / 233280.0;
    return Math.floor(min + rnd * (max - min));
}
function defineColor(bound) {
    var sMin = bound.lowerBounds[0][0];
    var sMax = bound.lowerBounds[bound.lowerBounds.length - 1][0];
    var bMin = bound.lowerBounds[bound.lowerBounds.length - 1][1];
    var bMax = bound.lowerBounds[0][1];
    return {
        name: bound.name,
        hueRange: bound.hueRange,
        lowerBounds: bound.lowerBounds,
        saturationRange: [sMin, sMax],
        brightnessRange: [bMin, bMax],
    };
}
/**
 * @hidden
 */
var bounds = [
    {
        name: 'monochrome',
        hueRange: null,
        lowerBounds: [
            [0, 0],
            [100, 0],
        ],
    },
    {
        name: 'red',
        hueRange: [-26, 18],
        lowerBounds: [
            [20, 100],
            [30, 92],
            [40, 89],
            [50, 85],
            [60, 78],
            [70, 70],
            [80, 60],
            [90, 55],
            [100, 50],
        ],
    },
    {
        name: 'orange',
        hueRange: [19, 46],
        lowerBounds: [
            [20, 100],
            [30, 93],
            [40, 88],
            [50, 86],
            [60, 85],
            [70, 70],
            [100, 70],
        ],
    },
    {
        name: 'yellow',
        hueRange: [47, 62],
        lowerBounds: [
            [25, 100],
            [40, 94],
            [50, 89],
            [60, 86],
            [70, 84],
            [80, 82],
            [90, 80],
            [100, 75],
        ],
    },
    {
        name: 'green',
        hueRange: [63, 178],
        lowerBounds: [
            [30, 100],
            [40, 90],
            [50, 85],
            [60, 81],
            [70, 74],
            [80, 64],
            [90, 50],
            [100, 40],
        ],
    },
    {
        name: 'blue',
        hueRange: [179, 257],
        lowerBounds: [
            [20, 100],
            [30, 86],
            [40, 80],
            [50, 74],
            [60, 60],
            [70, 52],
            [80, 44],
            [90, 39],
            [100, 35],
        ],
    },
    {
        name: 'purple',
        hueRange: [258, 282],
        lowerBounds: [
            [20, 100],
            [30, 87],
            [40, 79],
            [50, 70],
            [60, 65],
            [70, 59],
            [80, 52],
            [90, 45],
            [100, 42],
        ],
    },
    {
        name: 'pink',
        hueRange: [283, 334],
        lowerBounds: [
            [20, 100],
            [30, 90],
            [40, 86],
            [60, 84],
            [80, 80],
            [90, 75],
            [100, 73],
        ],
    },
];

var hasEyeDropper = "EyeDropper" in window;
var SlColorPicker = class extends ShoelaceElement {
  constructor() {
    super();
    this.formControlController = new FormControlController(this);
    this.isSafeValue = false;
    this.localize = new LocalizeController(this);
    this.hasFocus = false;
    this.isDraggingGridHandle = false;
    this.isEmpty = false;
    this.inputValue = "";
    this.hue = 0;
    this.saturation = 100;
    this.brightness = 100;
    this.alpha = 100;
    this.value = "";
    this.defaultValue = "";
    this.label = "";
    this.format = "hex";
    this.inline = false;
    this.size = "medium";
    this.noFormatToggle = false;
    this.name = "";
    this.disabled = false;
    this.hoist = false;
    this.opacity = false;
    this.uppercase = false;
    this.swatches = "";
    this.form = "";
    this.required = false;
    this.handleFocusIn = () => {
      this.hasFocus = true;
      this.emit("sl-focus");
    };
    this.handleFocusOut = () => {
      this.hasFocus = false;
      this.emit("sl-blur");
    };
    this.addEventListener("focusin", this.handleFocusIn);
    this.addEventListener("focusout", this.handleFocusOut);
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  firstUpdated() {
    this.input.updateComplete.then(() => {
      this.formControlController.updateValidity();
    });
  }
  handleCopy() {
    this.input.select();
    document.execCommand("copy");
    this.previewButton.focus();
    this.previewButton.classList.add("color-picker__preview-color--copied");
    this.previewButton.addEventListener("animationend", () => {
      this.previewButton.classList.remove("color-picker__preview-color--copied");
    });
  }
  handleFormatToggle() {
    const formats = ["hex", "rgb", "hsl", "hsv"];
    const nextIndex = (formats.indexOf(this.format) + 1) % formats.length;
    this.format = formats[nextIndex];
    this.setColor(this.value);
    this.emit("sl-change");
    this.emit("sl-input");
  }
  handleAlphaDrag(event) {
    const container = this.shadowRoot.querySelector(".color-picker__slider.color-picker__alpha");
    const handle = container.querySelector(".color-picker__slider-handle");
    const { width } = container.getBoundingClientRect();
    let oldValue = this.value;
    handle.focus();
    event.preventDefault();
    drag$1(container, {
      onMove: (x) => {
        this.alpha = clamp$1(x / width * 100, 0, 100);
        this.syncValues();
        if (this.value !== oldValue) {
          oldValue = this.value;
          this.emit("sl-change");
          this.emit("sl-input");
        }
      },
      initialEvent: event
    });
  }
  handleHueDrag(event) {
    const container = this.shadowRoot.querySelector(".color-picker__slider.color-picker__hue");
    const handle = container.querySelector(".color-picker__slider-handle");
    const { width } = container.getBoundingClientRect();
    let oldValue = this.value;
    handle.focus();
    event.preventDefault();
    drag$1(container, {
      onMove: (x) => {
        this.hue = clamp$1(x / width * 360, 0, 360);
        this.syncValues();
        if (this.value !== oldValue) {
          oldValue = this.value;
          this.emit("sl-change");
          this.emit("sl-input");
        }
      },
      initialEvent: event
    });
  }
  handleGridDrag(event) {
    const grid = this.shadowRoot.querySelector(".color-picker__grid");
    const handle = grid.querySelector(".color-picker__grid-handle");
    const { width, height } = grid.getBoundingClientRect();
    let oldValue = this.value;
    handle.focus();
    event.preventDefault();
    this.isDraggingGridHandle = true;
    drag$1(grid, {
      onMove: (x, y) => {
        this.saturation = clamp$1(x / width * 100, 0, 100);
        this.brightness = clamp$1(100 - y / height * 100, 0, 100);
        this.syncValues();
        if (this.value !== oldValue) {
          oldValue = this.value;
          this.emit("sl-change");
          this.emit("sl-input");
        }
      },
      onStop: () => this.isDraggingGridHandle = false,
      initialEvent: event
    });
  }
  handleAlphaKeyDown(event) {
    const increment = event.shiftKey ? 10 : 1;
    const oldValue = this.value;
    if (event.key === "ArrowLeft") {
      event.preventDefault();
      this.alpha = clamp$1(this.alpha - increment, 0, 100);
      this.syncValues();
    }
    if (event.key === "ArrowRight") {
      event.preventDefault();
      this.alpha = clamp$1(this.alpha + increment, 0, 100);
      this.syncValues();
    }
    if (event.key === "Home") {
      event.preventDefault();
      this.alpha = 0;
      this.syncValues();
    }
    if (event.key === "End") {
      event.preventDefault();
      this.alpha = 100;
      this.syncValues();
    }
    if (this.value !== oldValue) {
      this.emit("sl-change");
      this.emit("sl-input");
    }
  }
  handleHueKeyDown(event) {
    const increment = event.shiftKey ? 10 : 1;
    const oldValue = this.value;
    if (event.key === "ArrowLeft") {
      event.preventDefault();
      this.hue = clamp$1(this.hue - increment, 0, 360);
      this.syncValues();
    }
    if (event.key === "ArrowRight") {
      event.preventDefault();
      this.hue = clamp$1(this.hue + increment, 0, 360);
      this.syncValues();
    }
    if (event.key === "Home") {
      event.preventDefault();
      this.hue = 0;
      this.syncValues();
    }
    if (event.key === "End") {
      event.preventDefault();
      this.hue = 360;
      this.syncValues();
    }
    if (this.value !== oldValue) {
      this.emit("sl-change");
      this.emit("sl-input");
    }
  }
  handleGridKeyDown(event) {
    const increment = event.shiftKey ? 10 : 1;
    const oldValue = this.value;
    if (event.key === "ArrowLeft") {
      event.preventDefault();
      this.saturation = clamp$1(this.saturation - increment, 0, 100);
      this.syncValues();
    }
    if (event.key === "ArrowRight") {
      event.preventDefault();
      this.saturation = clamp$1(this.saturation + increment, 0, 100);
      this.syncValues();
    }
    if (event.key === "ArrowUp") {
      event.preventDefault();
      this.brightness = clamp$1(this.brightness + increment, 0, 100);
      this.syncValues();
    }
    if (event.key === "ArrowDown") {
      event.preventDefault();
      this.brightness = clamp$1(this.brightness - increment, 0, 100);
      this.syncValues();
    }
    if (this.value !== oldValue) {
      this.emit("sl-change");
      this.emit("sl-input");
    }
  }
  handleInputChange(event) {
    const target = event.target;
    const oldValue = this.value;
    event.stopPropagation();
    if (this.input.value) {
      this.setColor(target.value);
      target.value = this.value;
    } else {
      this.value = "";
    }
    if (this.value !== oldValue) {
      this.emit("sl-change");
      this.emit("sl-input");
    }
  }
  handleInputInput(event) {
    this.formControlController.updateValidity();
    event.stopPropagation();
  }
  handleInputKeyDown(event) {
    if (event.key === "Enter") {
      const oldValue = this.value;
      if (this.input.value) {
        this.setColor(this.input.value);
        this.input.value = this.value;
        if (this.value !== oldValue) {
          this.emit("sl-change");
          this.emit("sl-input");
        }
        setTimeout(() => this.input.select());
      } else {
        this.hue = 0;
      }
    }
  }
  handleInputInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleTouchMove(event) {
    event.preventDefault();
  }
  parseColor(colorString) {
    const color = new TinyColor(colorString);
    if (!color.isValid) {
      return null;
    }
    const hslColor = color.toHsl();
    const hsl = {
      h: hslColor.h,
      s: hslColor.s * 100,
      l: hslColor.l * 100,
      a: hslColor.a
    };
    const rgb = color.toRgb();
    const hex = color.toHexString();
    const hexa = color.toHex8String();
    const hsvColor = color.toHsv();
    const hsv = {
      h: hsvColor.h,
      s: hsvColor.s * 100,
      v: hsvColor.v * 100,
      a: hsvColor.a
    };
    return {
      hsl: {
        h: hsl.h,
        s: hsl.s,
        l: hsl.l,
        string: this.setLetterCase(`hsl(${Math.round(hsl.h)}, ${Math.round(hsl.s)}%, ${Math.round(hsl.l)}%)`)
      },
      hsla: {
        h: hsl.h,
        s: hsl.s,
        l: hsl.l,
        a: hsl.a,
        string: this.setLetterCase(
          `hsla(${Math.round(hsl.h)}, ${Math.round(hsl.s)}%, ${Math.round(hsl.l)}%, ${hsl.a.toFixed(2).toString()})`
        )
      },
      hsv: {
        h: hsv.h,
        s: hsv.s,
        v: hsv.v,
        string: this.setLetterCase(`hsv(${Math.round(hsv.h)}, ${Math.round(hsv.s)}%, ${Math.round(hsv.v)}%)`)
      },
      hsva: {
        h: hsv.h,
        s: hsv.s,
        v: hsv.v,
        a: hsv.a,
        string: this.setLetterCase(
          `hsva(${Math.round(hsv.h)}, ${Math.round(hsv.s)}%, ${Math.round(hsv.v)}%, ${hsv.a.toFixed(2).toString()})`
        )
      },
      rgb: {
        r: rgb.r,
        g: rgb.g,
        b: rgb.b,
        string: this.setLetterCase(`rgb(${Math.round(rgb.r)}, ${Math.round(rgb.g)}, ${Math.round(rgb.b)})`)
      },
      rgba: {
        r: rgb.r,
        g: rgb.g,
        b: rgb.b,
        a: rgb.a,
        string: this.setLetterCase(
          `rgba(${Math.round(rgb.r)}, ${Math.round(rgb.g)}, ${Math.round(rgb.b)}, ${rgb.a.toFixed(2).toString()})`
        )
      },
      hex: this.setLetterCase(hex),
      hexa: this.setLetterCase(hexa)
    };
  }
  setColor(colorString) {
    const newColor = this.parseColor(colorString);
    if (newColor === null) {
      return false;
    }
    this.hue = newColor.hsva.h;
    this.saturation = newColor.hsva.s;
    this.brightness = newColor.hsva.v;
    this.alpha = this.opacity ? newColor.hsva.a * 100 : 100;
    this.syncValues();
    return true;
  }
  setLetterCase(string) {
    if (typeof string !== "string") {
      return "";
    }
    return this.uppercase ? string.toUpperCase() : string.toLowerCase();
  }
  async syncValues() {
    const currentColor = this.parseColor(
      `hsva(${this.hue}, ${this.saturation}%, ${this.brightness}%, ${this.alpha / 100})`
    );
    if (currentColor === null) {
      return;
    }
    if (this.format === "hsl") {
      this.inputValue = this.opacity ? currentColor.hsla.string : currentColor.hsl.string;
    } else if (this.format === "rgb") {
      this.inputValue = this.opacity ? currentColor.rgba.string : currentColor.rgb.string;
    } else if (this.format === "hsv") {
      this.inputValue = this.opacity ? currentColor.hsva.string : currentColor.hsv.string;
    } else {
      this.inputValue = this.opacity ? currentColor.hexa : currentColor.hex;
    }
    this.isSafeValue = true;
    this.value = this.inputValue;
    await this.updateComplete;
    this.isSafeValue = false;
  }
  handleAfterHide() {
    this.previewButton.classList.remove("color-picker__preview-color--copied");
  }
  handleEyeDropper() {
    if (!hasEyeDropper) {
      return;
    }
    const eyeDropper = new EyeDropper();
    eyeDropper.open().then((colorSelectionResult) => {
      const oldValue = this.value;
      this.setColor(colorSelectionResult.sRGBHex);
      if (this.value !== oldValue) {
        this.emit("sl-change");
        this.emit("sl-input");
      }
    }).catch(() => {
    });
  }
  selectSwatch(color) {
    const oldValue = this.value;
    if (!this.disabled) {
      this.setColor(color);
      if (this.value !== oldValue) {
        this.emit("sl-change");
        this.emit("sl-input");
      }
    }
  }
  /** Generates a hex string from HSV values. Hue must be 0-360. All other arguments must be 0-100. */
  getHexString(hue, saturation, brightness, alpha = 100) {
    const color = new TinyColor(`hsva(${hue}, ${saturation}, ${brightness}, ${alpha / 100})`);
    if (!color.isValid) {
      return "";
    }
    return color.toHex8String();
  }
  // Prevents nested components from leaking events
  stopNestedEventPropagation(event) {
    event.stopImmediatePropagation();
  }
  handleFormatChange() {
    this.syncValues();
  }
  handleOpacityChange() {
    this.alpha = 100;
  }
  handleValueChange(oldValue, newValue) {
    this.isEmpty = !newValue;
    if (!newValue) {
      this.hue = 0;
      this.saturation = 0;
      this.brightness = 100;
      this.alpha = 100;
    }
    if (!this.isSafeValue) {
      const newColor = this.parseColor(newValue);
      if (newColor !== null) {
        this.inputValue = this.value;
        this.hue = newColor.hsva.h;
        this.saturation = newColor.hsva.s;
        this.brightness = newColor.hsva.v;
        this.alpha = newColor.hsva.a * 100;
        this.syncValues();
      } else {
        this.inputValue = oldValue != null ? oldValue : "";
      }
    }
  }
  /** Sets focus on the color picker. */
  focus(options) {
    if (this.inline) {
      this.base.focus(options);
    } else {
      this.trigger.focus(options);
    }
  }
  /** Removes focus from the color picker. */
  blur() {
    var _a;
    const elementToBlur = this.inline ? this.base : this.trigger;
    if (this.hasFocus) {
      elementToBlur.focus({ preventScroll: true });
      elementToBlur.blur();
    }
    if ((_a = this.dropdown) == null ? void 0 : _a.open) {
      this.dropdown.hide();
    }
  }
  /** Returns the current value as a string in the specified format. */
  getFormattedValue(format = "hex") {
    const currentColor = this.parseColor(
      `hsva(${this.hue}, ${this.saturation}%, ${this.brightness}%, ${this.alpha / 100})`
    );
    if (currentColor === null) {
      return "";
    }
    switch (format) {
      case "hex":
        return currentColor.hex;
      case "hexa":
        return currentColor.hexa;
      case "rgb":
        return currentColor.rgb.string;
      case "rgba":
        return currentColor.rgba.string;
      case "hsl":
        return currentColor.hsl.string;
      case "hsla":
        return currentColor.hsla.string;
      case "hsv":
        return currentColor.hsv.string;
      case "hsva":
        return currentColor.hsva.string;
      default:
        return "";
    }
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    if (!this.inline && !this.validity.valid) {
      this.dropdown.show();
      this.addEventListener("sl-after-show", () => this.input.reportValidity(), { once: true });
      if (!this.disabled) {
        this.formControlController.emitInvalidEvent();
      }
      return false;
    }
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const gridHandleX = this.saturation;
    const gridHandleY = 100 - this.brightness;
    const swatches = Array.isArray(this.swatches) ? this.swatches : this.swatches.split(";").filter((color) => color.trim() !== "");
    const colorPicker = x$1`
      <div
        part="base"
        class=${o$9({
      "color-picker": true,
      "color-picker--inline": this.inline,
      "color-picker--disabled": this.disabled,
      "color-picker--focused": this.hasFocus
    })}
        aria-disabled=${this.disabled ? "true" : "false"}
        aria-labelledby="label"
        tabindex=${this.inline ? "0" : "-1"}
      >
        ${this.inline ? x$1`
              <sl-visually-hidden id="label">
                <slot name="label">${this.label}</slot>
              </sl-visually-hidden>
            ` : null}

        <div
          part="grid"
          class="color-picker__grid"
          style=${o$7({ backgroundColor: this.getHexString(this.hue, 100, 100) })}
          @pointerdown=${this.handleGridDrag}
          @touchmove=${this.handleTouchMove}
        >
          <span
            part="grid-handle"
            class=${o$9({
      "color-picker__grid-handle": true,
      "color-picker__grid-handle--dragging": this.isDraggingGridHandle
    })}
            style=${o$7({
      top: `${gridHandleY}%`,
      left: `${gridHandleX}%`,
      backgroundColor: this.getHexString(this.hue, this.saturation, this.brightness, this.alpha)
    })}
            role="application"
            aria-label="HSV"
            tabindex=${l$2(this.disabled ? void 0 : "0")}
            @keydown=${this.handleGridKeyDown}
          ></span>
        </div>

        <div class="color-picker__controls">
          <div class="color-picker__sliders">
            <div
              part="slider hue-slider"
              class="color-picker__hue color-picker__slider"
              @pointerdown=${this.handleHueDrag}
              @touchmove=${this.handleTouchMove}
            >
              <span
                part="slider-handle hue-slider-handle"
                class="color-picker__slider-handle"
                style=${o$7({
      left: `${this.hue === 0 ? 0 : 100 / (360 / this.hue)}%`
    })}
                role="slider"
                aria-label="hue"
                aria-orientation="horizontal"
                aria-valuemin="0"
                aria-valuemax="360"
                aria-valuenow=${`${Math.round(this.hue)}`}
                tabindex=${l$2(this.disabled ? void 0 : "0")}
                @keydown=${this.handleHueKeyDown}
              ></span>
            </div>

            ${this.opacity ? x$1`
                  <div
                    part="slider opacity-slider"
                    class="color-picker__alpha color-picker__slider color-picker__transparent-bg"
                    @pointerdown="${this.handleAlphaDrag}"
                    @touchmove=${this.handleTouchMove}
                  >
                    <div
                      class="color-picker__alpha-gradient"
                      style=${o$7({
      backgroundImage: `linear-gradient(
                          to right,
                          ${this.getHexString(this.hue, this.saturation, this.brightness, 0)} 0%,
                          ${this.getHexString(this.hue, this.saturation, this.brightness, 100)} 100%
                        )`
    })}
                    ></div>
                    <span
                      part="slider-handle opacity-slider-handle"
                      class="color-picker__slider-handle"
                      style=${o$7({
      left: `${this.alpha}%`
    })}
                      role="slider"
                      aria-label="alpha"
                      aria-orientation="horizontal"
                      aria-valuemin="0"
                      aria-valuemax="100"
                      aria-valuenow=${Math.round(this.alpha)}
                      tabindex=${l$2(this.disabled ? void 0 : "0")}
                      @keydown=${this.handleAlphaKeyDown}
                    ></span>
                  </div>
                ` : ""}
          </div>

          <button
            type="button"
            part="preview"
            class="color-picker__preview color-picker__transparent-bg"
            aria-label=${this.localize.term("copy")}
            style=${o$7({
      "--preview-color": this.getHexString(this.hue, this.saturation, this.brightness, this.alpha)
    })}
            @click=${this.handleCopy}
          ></button>
        </div>

        <div class="color-picker__user-input" aria-live="polite">
          <sl-input
            part="input"
            type="text"
            name=${this.name}
            autocomplete="off"
            autocorrect="off"
            autocapitalize="off"
            spellcheck="false"
            value=${this.isEmpty ? "" : this.inputValue}
            ?required=${this.required}
            ?disabled=${this.disabled}
            aria-label=${this.localize.term("currentValue")}
            @keydown=${this.handleInputKeyDown}
            @sl-change=${this.handleInputChange}
            @sl-input=${this.handleInputInput}
            @sl-invalid=${this.handleInputInvalid}
            @sl-blur=${this.stopNestedEventPropagation}
            @sl-focus=${this.stopNestedEventPropagation}
          ></sl-input>

          <sl-button-group>
            ${!this.noFormatToggle ? x$1`
                  <sl-button
                    part="format-button"
                    aria-label=${this.localize.term("toggleColorFormat")}
                    exportparts="
                      base:format-button__base,
                      prefix:format-button__prefix,
                      label:format-button__label,
                      suffix:format-button__suffix,
                      caret:format-button__caret
                    "
                    @click=${this.handleFormatToggle}
                    @sl-blur=${this.stopNestedEventPropagation}
                    @sl-focus=${this.stopNestedEventPropagation}
                  >
                    ${this.setLetterCase(this.format)}
                  </sl-button>
                ` : ""}
            ${hasEyeDropper ? x$1`
                  <sl-button
                    part="eye-dropper-button"
                    exportparts="
                      base:eye-dropper-button__base,
                      prefix:eye-dropper-button__prefix,
                      label:eye-dropper-button__label,
                      suffix:eye-dropper-button__suffix,
                      caret:eye-dropper-button__caret
                    "
                    @click=${this.handleEyeDropper}
                    @sl-blur=${this.stopNestedEventPropagation}
                    @sl-focus=${this.stopNestedEventPropagation}
                  >
                    <sl-icon
                      library="system"
                      name="eyedropper"
                      label=${this.localize.term("selectAColorFromTheScreen")}
                    ></sl-icon>
                  </sl-button>
                ` : ""}
          </sl-button-group>
        </div>

        ${swatches.length > 0 ? x$1`
              <div part="swatches" class="color-picker__swatches">
                ${swatches.map((swatch) => {
      const parsedColor = this.parseColor(swatch);
      if (!parsedColor) {
        console.error(`Unable to parse swatch color: "${swatch}"`, this);
        return "";
      }
      return x$1`
                    <div
                      part="swatch"
                      class="color-picker__swatch color-picker__transparent-bg"
                      tabindex=${l$2(this.disabled ? void 0 : "0")}
                      role="button"
                      aria-label=${swatch}
                      @click=${() => this.selectSwatch(swatch)}
                      @keydown=${(event) => !this.disabled && event.key === "Enter" && this.setColor(parsedColor.hexa)}
                    >
                      <div
                        class="color-picker__swatch-color"
                        style=${o$7({ backgroundColor: parsedColor.hexa })}
                      ></div>
                    </div>
                  `;
    })}
              </div>
            ` : ""}
      </div>
    `;
    if (this.inline) {
      return colorPicker;
    }
    return x$1`
      <sl-dropdown
        class="color-dropdown"
        aria-disabled=${this.disabled ? "true" : "false"}
        .containing-element=${this}
        ?disabled=${this.disabled}
        ?hoist=${this.hoist}
        @sl-after-hide=${this.handleAfterHide}
      >
        <button
          part="trigger"
          slot="trigger"
          class=${o$9({
      "color-dropdown__trigger": true,
      "color-dropdown__trigger--disabled": this.disabled,
      "color-dropdown__trigger--small": this.size === "small",
      "color-dropdown__trigger--medium": this.size === "medium",
      "color-dropdown__trigger--large": this.size === "large",
      "color-dropdown__trigger--empty": this.isEmpty,
      "color-dropdown__trigger--focused": this.hasFocus,
      "color-picker__transparent-bg": true
    })}
          style=${o$7({
      color: this.getHexString(this.hue, this.saturation, this.brightness, this.alpha)
    })}
          type="button"
        >
          <sl-visually-hidden>
            <slot name="label">${this.label}</slot>
          </sl-visually-hidden>
        </button>
        ${colorPicker}
      </sl-dropdown>
    `;
  }
};
SlColorPicker.styles = color_picker_styles_default;
SlColorPicker.dependencies = {
  "sl-button-group": SlButtonGroup,
  "sl-button": SlButton,
  "sl-dropdown": SlDropdown,
  "sl-icon": SlIcon,
  "sl-input": SlInput,
  "sl-visually-hidden": SlVisuallyHidden
};
__decorateClass([
  i$7('[part~="base"]')
], SlColorPicker.prototype, "base", 2);
__decorateClass([
  i$7('[part~="input"]')
], SlColorPicker.prototype, "input", 2);
__decorateClass([
  i$7(".color-dropdown")
], SlColorPicker.prototype, "dropdown", 2);
__decorateClass([
  i$7('[part~="preview"]')
], SlColorPicker.prototype, "previewButton", 2);
__decorateClass([
  i$7('[part~="trigger"]')
], SlColorPicker.prototype, "trigger", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "hasFocus", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "isDraggingGridHandle", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "isEmpty", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "inputValue", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "hue", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "saturation", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "brightness", 2);
__decorateClass([
  t$7()
], SlColorPicker.prototype, "alpha", 2);
__decorateClass([
  e$c()
], SlColorPicker.prototype, "value", 2);
__decorateClass([
  defaultValue()
], SlColorPicker.prototype, "defaultValue", 2);
__decorateClass([
  e$c()
], SlColorPicker.prototype, "label", 2);
__decorateClass([
  e$c()
], SlColorPicker.prototype, "format", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlColorPicker.prototype, "inline", 2);
__decorateClass([
  e$c({ reflect: true })
], SlColorPicker.prototype, "size", 2);
__decorateClass([
  e$c({ attribute: "no-format-toggle", type: Boolean })
], SlColorPicker.prototype, "noFormatToggle", 2);
__decorateClass([
  e$c()
], SlColorPicker.prototype, "name", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlColorPicker.prototype, "disabled", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlColorPicker.prototype, "hoist", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlColorPicker.prototype, "opacity", 2);
__decorateClass([
  e$c({ type: Boolean })
], SlColorPicker.prototype, "uppercase", 2);
__decorateClass([
  e$c()
], SlColorPicker.prototype, "swatches", 2);
__decorateClass([
  e$c({ reflect: true })
], SlColorPicker.prototype, "form", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlColorPicker.prototype, "required", 2);
__decorateClass([
  watch("format", { waitUntilFirstUpdate: true })
], SlColorPicker.prototype, "handleFormatChange", 1);
__decorateClass([
  watch("opacity", { waitUntilFirstUpdate: true })
], SlColorPicker.prototype, "handleOpacityChange", 1);
__decorateClass([
  watch("value")
], SlColorPicker.prototype, "handleValueChange", 1);

// src/components/color-picker/color-picker.ts
var color_picker_default = SlColorPicker;
SlColorPicker.define("sl-color-picker");

var card_styles_default = i$b`
  ${component_styles_default}

  :host {
    --border-color: var(--sl-color-neutral-200);
    --border-radius: var(--sl-border-radius-medium);
    --border-width: 1px;
    --padding: var(--sl-spacing-large);

    display: inline-block;
  }

  .card {
    display: flex;
    flex-direction: column;
    background-color: var(--sl-panel-background-color);
    box-shadow: var(--sl-shadow-x-small);
    border: solid var(--border-width) var(--border-color);
    border-radius: var(--border-radius);
  }

  .card__image {
    display: flex;
    border-top-left-radius: var(--border-radius);
    border-top-right-radius: var(--border-radius);
    margin: calc(-1 * var(--border-width));
    overflow: hidden;
  }

  .card__image::slotted(img) {
    display: block;
    width: 100%;
  }

  .card:not(.card--has-image) .card__image {
    display: none;
  }

  .card__header {
    display: block;
    border-bottom: solid var(--border-width) var(--border-color);
    padding: calc(var(--padding) / 2) var(--padding);
  }

  .card:not(.card--has-header) .card__header {
    display: none;
  }

  .card:not(.card--has-image) .card__header {
    border-top-left-radius: var(--border-radius);
    border-top-right-radius: var(--border-radius);
  }

  .card__body {
    display: block;
    padding: var(--padding);
  }

  .card--has-footer .card__footer {
    display: block;
    border-top: solid var(--border-width) var(--border-color);
    padding: var(--padding);
  }

  .card:not(.card--has-footer) .card__footer {
    display: none;
  }
`;

var SlCard = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController$1(this, "footer", "header", "image");
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      card: true,
      "card--has-footer": this.hasSlotController.test("footer"),
      "card--has-image": this.hasSlotController.test("image"),
      "card--has-header": this.hasSlotController.test("header")
    })}
      >
        <slot name="image" part="image" class="card__image"></slot>
        <slot name="header" part="header" class="card__header"></slot>
        <slot part="body" class="card__body"></slot>
        <slot name="footer" part="footer" class="card__footer"></slot>
      </div>
    `;
  }
};
SlCard.styles = card_styles_default;

// src/components/card/card.ts
var card_default = SlCard;
SlCard.define("sl-card");

// src/components/carousel/autoplay-controller.ts
var AutoplayController = class {
  constructor(host, tickCallback) {
    this.timerId = 0;
    this.activeInteractions = 0;
    this.paused = false;
    this.stopped = true;
    this.pause = () => {
      if (!this.activeInteractions++) {
        this.paused = true;
        this.host.requestUpdate();
      }
    };
    this.resume = () => {
      if (!--this.activeInteractions) {
        this.paused = false;
        this.host.requestUpdate();
      }
    };
    host.addController(this);
    this.host = host;
    this.tickCallback = tickCallback;
  }
  hostConnected() {
    this.host.addEventListener("mouseenter", this.pause);
    this.host.addEventListener("mouseleave", this.resume);
    this.host.addEventListener("focusin", this.pause);
    this.host.addEventListener("focusout", this.resume);
    this.host.addEventListener("touchstart", this.pause, { passive: true });
    this.host.addEventListener("touchend", this.resume);
  }
  hostDisconnected() {
    this.stop();
    this.host.removeEventListener("mouseenter", this.pause);
    this.host.removeEventListener("mouseleave", this.resume);
    this.host.removeEventListener("focusin", this.pause);
    this.host.removeEventListener("focusout", this.resume);
    this.host.removeEventListener("touchstart", this.pause);
    this.host.removeEventListener("touchend", this.resume);
  }
  start(interval) {
    this.stop();
    this.stopped = false;
    this.timerId = window.setInterval(() => {
      if (!this.paused) {
        this.tickCallback();
      }
    }, interval);
  }
  stop() {
    clearInterval(this.timerId);
    this.stopped = true;
    this.host.requestUpdate();
  }
};

var carousel_styles_default = i$b`
  ${component_styles_default}

  :host {
    --slide-gap: var(--sl-spacing-medium, 1rem);
    --aspect-ratio: 16 / 9;
    --scroll-hint: 0px;

    display: flex;
  }

  .carousel {
    display: grid;
    grid-template-columns: min-content 1fr min-content;
    grid-template-rows: 1fr min-content;
    grid-template-areas:
      '. slides .'
      '. pagination .';
    gap: var(--sl-spacing-medium);
    align-items: center;
    min-height: 100%;
    min-width: 100%;
    position: relative;
  }

  .carousel__pagination {
    grid-area: pagination;
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
    gap: var(--sl-spacing-small);
  }

  .carousel__slides {
    grid-area: slides;

    display: grid;
    height: 100%;
    width: 100%;
    align-items: center;
    justify-items: center;
    overflow: auto;
    overscroll-behavior-x: contain;
    scrollbar-width: none;
    aspect-ratio: calc(var(--aspect-ratio) * var(--slides-per-page));
    border-radius: var(--sl-border-radius-small);

    --slide-size: calc((100% - (var(--slides-per-page) - 1) * var(--slide-gap)) / var(--slides-per-page));
  }

  @media (prefers-reduced-motion) {
    :where(.carousel__slides) {
      scroll-behavior: auto;
    }
  }

  .carousel__slides--horizontal {
    grid-auto-flow: column;
    grid-auto-columns: var(--slide-size);
    grid-auto-rows: 100%;
    column-gap: var(--slide-gap);
    scroll-snap-type: x mandatory;
    scroll-padding-inline: var(--scroll-hint);
    padding-inline: var(--scroll-hint);
    overflow-y: hidden;
  }

  .carousel__slides--vertical {
    grid-auto-flow: row;
    grid-auto-columns: 100%;
    grid-auto-rows: var(--slide-size);
    row-gap: var(--slide-gap);
    scroll-snap-type: y mandatory;
    scroll-padding-block: var(--scroll-hint);
    padding-block: var(--scroll-hint);
    overflow-x: hidden;
  }

  .carousel__slides--dragging,
  .carousel__slides--dropping {
    scroll-snap-type: unset;
  }

  :host([vertical]) ::slotted(sl-carousel-item) {
    height: 100%;
  }

  .carousel__slides::-webkit-scrollbar {
    display: none;
  }

  .carousel__navigation {
    grid-area: navigation;
    display: contents;
    font-size: var(--sl-font-size-x-large);
  }

  .carousel__navigation-button {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    background: none;
    border: none;
    border-radius: var(--sl-border-radius-small);
    font-size: inherit;
    color: var(--sl-color-neutral-600);
    padding: var(--sl-spacing-x-small);
    cursor: pointer;
    transition: var(--sl-transition-medium) color;
    appearance: none;
  }

  .carousel__navigation-button--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .carousel__navigation-button--disabled::part(base) {
    pointer-events: none;
  }

  .carousel__navigation-button--previous {
    grid-column: 1;
    grid-row: 1;
  }

  .carousel__navigation-button--next {
    grid-column: 3;
    grid-row: 1;
  }

  .carousel__pagination-item {
    display: block;
    cursor: pointer;
    background: none;
    border: 0;
    border-radius: var(--sl-border-radius-circle);
    width: var(--sl-spacing-small);
    height: var(--sl-spacing-small);
    background-color: var(--sl-color-neutral-300);
    padding: 0;
    margin: 0;
  }

  .carousel__pagination-item--active {
    background-color: var(--sl-color-neutral-700);
    transform: scale(1.2);
  }

  /* Focus styles */
  .carousel__slides:focus-visible,
  .carousel__navigation-button:focus-visible,
  .carousel__pagination-item:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }
`;

// src/internal/debounce.ts
var TIMER_ID_KEY = Symbol();
var debounce$1 = (delay) => {
  return (_target, _propertyKey, descriptor) => {
    const fn = descriptor.value;
    descriptor.value = function(...args) {
      clearTimeout(this[TIMER_ID_KEY]);
      this[TIMER_ID_KEY] = window.setTimeout(() => {
        fn.apply(this, args);
      }, delay);
    };
  };
};

// src/components/carousel/scroll-controller.ts
var ScrollController = class {
  constructor(host) {
    this.pointers = /* @__PURE__ */ new Set();
    this.dragging = false;
    this.scrolling = false;
    this.mouseDragging = false;
    this.handleScroll = () => {
      if (!this.scrolling) {
        this.scrolling = true;
        this.host.requestUpdate();
      }
      this.handleScrollEnd();
    };
    this.handlePointerDown = (event) => {
      if (event.pointerType === "touch") {
        return;
      }
      this.pointers.add(event.pointerId);
      const canDrag = this.mouseDragging && !this.dragging && event.button === 0;
      if (canDrag) {
        event.preventDefault();
        this.host.scrollContainer.addEventListener("pointermove", this.handlePointerMove);
      }
    };
    this.handlePointerMove = (event) => {
      const scrollContainer = this.host.scrollContainer;
      const hasMoved = !!event.movementX || !!event.movementY;
      if (!this.dragging && hasMoved) {
        scrollContainer.setPointerCapture(event.pointerId);
        this.handleDragStart();
      } else if (scrollContainer.hasPointerCapture(event.pointerId)) {
        this.handleDrag(event);
      }
    };
    this.handlePointerUp = (event) => {
      this.pointers.delete(event.pointerId);
      this.host.scrollContainer.releasePointerCapture(event.pointerId);
      if (this.pointers.size === 0) {
        this.handleDragEnd();
      }
    };
    this.handleTouchEnd = (event) => {
      for (const touch of event.changedTouches) {
        this.pointers.delete(touch.identifier);
      }
    };
    this.handleTouchStart = (event) => {
      for (const touch of event.touches) {
        this.pointers.add(touch.identifier);
      }
    };
    this.host = host;
    host.addController(this);
  }
  async hostConnected() {
    const host = this.host;
    await host.updateComplete;
    const scrollContainer = host.scrollContainer;
    scrollContainer.addEventListener("scroll", this.handleScroll, { passive: true });
    scrollContainer.addEventListener("pointerdown", this.handlePointerDown);
    scrollContainer.addEventListener("pointerup", this.handlePointerUp);
    scrollContainer.addEventListener("pointercancel", this.handlePointerUp);
    scrollContainer.addEventListener("touchstart", this.handleTouchStart, { passive: true });
    scrollContainer.addEventListener("touchend", this.handleTouchEnd);
  }
  hostDisconnected() {
    const host = this.host;
    const scrollContainer = host.scrollContainer;
    scrollContainer.removeEventListener("scroll", this.handleScroll);
    scrollContainer.removeEventListener("pointerdown", this.handlePointerDown);
    scrollContainer.removeEventListener("pointerup", this.handlePointerUp);
    scrollContainer.removeEventListener("pointercancel", this.handlePointerUp);
    scrollContainer.removeEventListener("touchstart", this.handleTouchStart);
    scrollContainer.removeEventListener("touchend", this.handleTouchEnd);
  }
  handleScrollEnd() {
    if (!this.pointers.size) {
      this.scrolling = false;
      this.host.scrollContainer.dispatchEvent(
        new CustomEvent("scrollend", {
          bubbles: false,
          cancelable: false
        })
      );
      this.host.requestUpdate();
    } else {
      this.handleScrollEnd();
    }
  }
  handleDragStart() {
    const host = this.host;
    this.dragging = true;
    host.scrollContainer.style.setProperty("scroll-snap-type", "unset");
    host.requestUpdate();
  }
  handleDrag(event) {
    this.host.scrollContainer.scrollBy({
      left: -event.movementX,
      top: -event.movementY
    });
  }
  async handleDragEnd() {
    const host = this.host;
    const scrollContainer = host.scrollContainer;
    scrollContainer.removeEventListener("pointermove", this.handlePointerMove);
    this.dragging = false;
    const startLeft = scrollContainer.scrollLeft;
    const startTop = scrollContainer.scrollTop;
    scrollContainer.style.removeProperty("scroll-snap-type");
    const finalLeft = scrollContainer.scrollLeft;
    const finalTop = scrollContainer.scrollTop;
    scrollContainer.style.setProperty("scroll-snap-type", "unset");
    scrollContainer.scrollTo({ left: startLeft, top: startTop, behavior: "auto" });
    scrollContainer.scrollTo({ left: finalLeft, top: finalTop, behavior: prefersReducedMotion() ? "auto" : "smooth" });
    if (this.scrolling) {
      await waitForEvent$1(scrollContainer, "scrollend");
    }
    scrollContainer.style.removeProperty("scroll-snap-type");
    host.requestUpdate();
  }
};
__decorateClass([
  debounce$1(100)
], ScrollController.prototype, "handleScrollEnd", 1);

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function*o$2(o,f){if(void 0!==o){let i=0;for(const t of o)yield f(t,i++);}}

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function*o$1(o,l,n=1){const t=void 0===l?0:o;null!=l||(l=o);for(let o=t;n>0?o<l:l<o;o+=n)yield o;}

var SlCarousel = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.loop = false;
    this.navigation = false;
    this.pagination = false;
    this.autoplay = false;
    this.autoplayInterval = 3e3;
    this.slidesPerPage = 1;
    this.slidesPerMove = 1;
    this.orientation = "horizontal";
    this.mouseDragging = false;
    this.activeSlide = 0;
    this.autoplayController = new AutoplayController(this, () => this.next());
    this.scrollController = new ScrollController(this);
    this.slides = this.getElementsByTagName("sl-carousel-item");
    // determines which slide is displayed
    // A map containing the state of all the slides
    this.intersectionObserverEntries = /* @__PURE__ */ new Map();
    this.localize = new LocalizeController(this);
    this.handleSlotChange = (mutations) => {
      const needsInitialization = mutations.some(
        (mutation) => [...mutation.addedNodes, ...mutation.removedNodes].some(
          (node) => SlCarouselItem.isCarouselItem(node) && !node.hasAttribute("data-clone")
        )
      );
      if (needsInitialization) {
        this.initializeSlides();
      }
      this.requestUpdate();
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "region");
    this.setAttribute("aria-label", this.localize.term("carousel"));
    const intersectionObserver = new IntersectionObserver(
      (entries) => {
        entries.forEach((entry) => {
          this.intersectionObserverEntries.set(entry.target, entry);
          const slide = entry.target;
          slide.toggleAttribute("inert", !entry.isIntersecting);
          slide.classList.toggle("--in-view", entry.isIntersecting);
          slide.setAttribute("aria-hidden", entry.isIntersecting ? "false" : "true");
        });
      },
      {
        root: this,
        threshold: 0.6
      }
    );
    this.intersectionObserver = intersectionObserver;
    intersectionObserver.takeRecords().forEach((entry) => {
      this.intersectionObserverEntries.set(entry.target, entry);
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.intersectionObserver.disconnect();
    this.mutationObserver.disconnect();
  }
  firstUpdated() {
    this.initializeSlides();
    this.mutationObserver = new MutationObserver(this.handleSlotChange);
    this.mutationObserver.observe(this, { childList: true, subtree: false });
  }
  getPageCount() {
    return Math.ceil(this.getSlides().length / this.slidesPerPage);
  }
  getCurrentPage() {
    return Math.ceil(this.activeSlide / this.slidesPerPage);
  }
  getSlides({ excludeClones = true } = {}) {
    return [...this.slides].filter((slide) => !excludeClones || !slide.hasAttribute("data-clone"));
  }
  handleKeyDown(event) {
    if (["ArrowLeft", "ArrowRight", "ArrowUp", "ArrowDown", "Home", "End"].includes(event.key)) {
      const target = event.target;
      const isRtl = this.localize.dir() === "rtl";
      const isFocusInPagination = target.closest('[part~="pagination-item"]') !== null;
      const isNext = event.key === "ArrowDown" || !isRtl && event.key === "ArrowRight" || isRtl && event.key === "ArrowLeft";
      const isPrevious = event.key === "ArrowUp" || !isRtl && event.key === "ArrowLeft" || isRtl && event.key === "ArrowRight";
      event.preventDefault();
      if (isPrevious) {
        this.previous();
      }
      if (isNext) {
        this.next();
      }
      if (event.key === "Home") {
        this.goToSlide(0);
      }
      if (event.key === "End") {
        this.goToSlide(this.getSlides().length - 1);
      }
      if (isFocusInPagination) {
        this.updateComplete.then(() => {
          var _a;
          const activePaginationItem = (_a = this.shadowRoot) == null ? void 0 : _a.querySelector(
            '[part~="pagination-item--active"]'
          );
          if (activePaginationItem) {
            activePaginationItem.focus();
          }
        });
      }
    }
  }
  handleScrollEnd() {
    const slides = this.getSlides();
    const entries = [...this.intersectionObserverEntries.values()];
    const firstIntersecting = entries.find((entry) => entry.isIntersecting);
    if (this.loop && (firstIntersecting == null ? void 0 : firstIntersecting.target.hasAttribute("data-clone"))) {
      const clonePosition = Number(firstIntersecting.target.getAttribute("data-clone"));
      this.goToSlide(clonePosition, "auto");
      return;
    }
    if (firstIntersecting) {
      this.activeSlide = slides.indexOf(firstIntersecting.target);
    }
  }
  initializeSlides() {
    const slides = this.getSlides();
    const intersectionObserver = this.intersectionObserver;
    this.intersectionObserverEntries.clear();
    this.getSlides({ excludeClones: false }).forEach((slide, index) => {
      intersectionObserver.unobserve(slide);
      slide.classList.remove("--in-view");
      slide.classList.remove("--is-active");
      slide.setAttribute("aria-label", this.localize.term("slideNum", index + 1));
      if (slide.hasAttribute("data-clone")) {
        slide.remove();
      }
    });
    if (this.loop) {
      const slidesPerPage = this.slidesPerPage;
      const lastSlides = slides.slice(-slidesPerPage);
      const firstSlides = slides.slice(0, slidesPerPage);
      lastSlides.reverse().forEach((slide, i) => {
        const clone = slide.cloneNode(true);
        clone.setAttribute("data-clone", String(slides.length - i - 1));
        this.prepend(clone);
      });
      firstSlides.forEach((slide, i) => {
        const clone = slide.cloneNode(true);
        clone.setAttribute("data-clone", String(i));
        this.append(clone);
      });
    }
    this.getSlides({ excludeClones: false }).forEach((slide) => {
      intersectionObserver.observe(slide);
    });
    this.goToSlide(this.activeSlide, "auto");
  }
  handelSlideChange() {
    const slides = this.getSlides();
    slides.forEach((slide, i) => {
      slide.classList.toggle("--is-active", i === this.activeSlide);
    });
    if (this.hasUpdated) {
      this.emit("sl-slide-change", {
        detail: {
          index: this.activeSlide,
          slide: slides[this.activeSlide]
        }
      });
    }
  }
  handleSlidesPerMoveChange() {
    const slides = this.getSlides({ excludeClones: false });
    const slidesPerMove = this.slidesPerMove;
    slides.forEach((slide, i) => {
      const shouldSnap = Math.abs(i - slidesPerMove) % slidesPerMove === 0;
      if (shouldSnap) {
        slide.style.removeProperty("scroll-snap-align");
      } else {
        slide.style.setProperty("scroll-snap-align", "none");
      }
    });
  }
  handleAutoplayChange() {
    this.autoplayController.stop();
    if (this.autoplay) {
      this.autoplayController.start(this.autoplayInterval);
    }
  }
  handleMouseDraggingChange() {
    this.scrollController.mouseDragging = this.mouseDragging;
  }
  /**
   * Move the carousel backward by `slides-per-move` slides.
   *
   * @param behavior - The behavior used for scrolling.
   */
  previous(behavior = "smooth") {
    let previousIndex = this.activeSlide || this.activeSlide - this.slidesPerMove;
    let canSnap = false;
    while (!canSnap && previousIndex > 0) {
      previousIndex -= 1;
      canSnap = Math.abs(previousIndex - this.slidesPerMove) % this.slidesPerMove === 0;
    }
    this.goToSlide(previousIndex, behavior);
  }
  /**
   * Move the carousel forward by `slides-per-move` slides.
   *
   * @param behavior - The behavior used for scrolling.
   */
  next(behavior = "smooth") {
    this.goToSlide(this.activeSlide + this.slidesPerMove, behavior);
  }
  /**
   * Scrolls the carousel to the slide specified by `index`.
   *
   * @param index - The slide index.
   * @param behavior - The behavior used for scrolling.
   */
  goToSlide(index, behavior = "smooth") {
    const { slidesPerPage, loop, scrollContainer } = this;
    const slides = this.getSlides();
    const slidesWithClones = this.getSlides({ excludeClones: false });
    const newActiveSlide = (index + slides.length) % slides.length;
    this.activeSlide = newActiveSlide;
    const nextSlideIndex = clamp$1(index + (loop ? slidesPerPage : 0), 0, slidesWithClones.length - 1);
    const nextSlide = slidesWithClones[nextSlideIndex];
    const scrollContainerRect = scrollContainer.getBoundingClientRect();
    const nextSlideRect = nextSlide.getBoundingClientRect();
    scrollContainer.scrollTo({
      left: nextSlideRect.left - scrollContainerRect.left + scrollContainer.scrollLeft,
      top: nextSlideRect.top - scrollContainerRect.top + scrollContainer.scrollTop,
      behavior: prefersReducedMotion() ? "auto" : behavior
    });
  }
  render() {
    const { scrollController, slidesPerPage } = this;
    const pagesCount = this.getPageCount();
    const currentPage = this.getCurrentPage();
    const prevEnabled = this.loop || currentPage > 0;
    const nextEnabled = this.loop || currentPage < pagesCount - 1;
    const isLtr = this.localize.dir() === "ltr";
    return x$1`
      <div part="base" class="carousel">
        <div
          id="scroll-container"
          part="scroll-container"
          class="${o$9({
      carousel__slides: true,
      "carousel__slides--horizontal": this.orientation === "horizontal",
      "carousel__slides--vertical": this.orientation === "vertical"
    })}"
          style="--slides-per-page: ${this.slidesPerPage};"
          aria-busy="${scrollController.scrolling ? "true" : "false"}"
          aria-atomic="true"
          tabindex="0"
          @keydown=${this.handleKeyDown}
          @scrollend=${this.handleScrollEnd}
        >
          <slot></slot>
        </div>

        ${this.navigation ? x$1`
              <div part="navigation" class="carousel__navigation">
                <button
                  part="navigation-button navigation-button--previous"
                  class="${o$9({
      "carousel__navigation-button": true,
      "carousel__navigation-button--previous": true,
      "carousel__navigation-button--disabled": !prevEnabled
    })}"
                  aria-label="${this.localize.term("previousSlide")}"
                  aria-controls="scroll-container"
                  aria-disabled="${prevEnabled ? "false" : "true"}"
                  @click=${prevEnabled ? () => this.previous() : null}
                >
                  <slot name="previous-icon">
                    <sl-icon library="system" name="${isLtr ? "chevron-left" : "chevron-right"}"></sl-icon>
                  </slot>
                </button>

                <button
                  part="navigation-button navigation-button--next"
                  class=${o$9({
      "carousel__navigation-button": true,
      "carousel__navigation-button--next": true,
      "carousel__navigation-button--disabled": !nextEnabled
    })}
                  aria-label="${this.localize.term("nextSlide")}"
                  aria-controls="scroll-container"
                  aria-disabled="${nextEnabled ? "false" : "true"}"
                  @click=${nextEnabled ? () => this.next() : null}
                >
                  <slot name="next-icon">
                    <sl-icon library="system" name="${isLtr ? "chevron-right" : "chevron-left"}"></sl-icon>
                  </slot>
                </button>
              </div>
            ` : ""}
        ${this.pagination ? x$1`
              <div part="pagination" role="tablist" class="carousel__pagination" aria-controls="scroll-container">
                ${o$2(o$1(pagesCount), (index) => {
      const isActive = index === currentPage;
      return x$1`
                    <button
                      part="pagination-item ${isActive ? "pagination-item--active" : ""}"
                      class="${o$9({
        "carousel__pagination-item": true,
        "carousel__pagination-item--active": isActive
      })}"
                      role="tab"
                      aria-selected="${isActive ? "true" : "false"}"
                      aria-label="${this.localize.term("goToSlide", index + 1, pagesCount)}"
                      tabindex=${isActive ? "0" : "-1"}
                      @click=${() => this.goToSlide(index * slidesPerPage)}
                      @keydown=${this.handleKeyDown}
                    ></button>
                  `;
    })}
              </div>
            ` : ""}
      </div>
    `;
  }
};
SlCarousel.styles = carousel_styles_default;
SlCarousel.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCarousel.prototype, "loop", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCarousel.prototype, "navigation", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCarousel.prototype, "pagination", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlCarousel.prototype, "autoplay", 2);
__decorateClass([
  e$c({ type: Number, attribute: "autoplay-interval" })
], SlCarousel.prototype, "autoplayInterval", 2);
__decorateClass([
  e$c({ type: Number, attribute: "slides-per-page" })
], SlCarousel.prototype, "slidesPerPage", 2);
__decorateClass([
  e$c({ type: Number, attribute: "slides-per-move" })
], SlCarousel.prototype, "slidesPerMove", 2);
__decorateClass([
  e$c()
], SlCarousel.prototype, "orientation", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true, attribute: "mouse-dragging" })
], SlCarousel.prototype, "mouseDragging", 2);
__decorateClass([
  i$7("slot:not([name])")
], SlCarousel.prototype, "defaultSlot", 2);
__decorateClass([
  i$7(".carousel__slides")
], SlCarousel.prototype, "scrollContainer", 2);
__decorateClass([
  i$7(".carousel__pagination")
], SlCarousel.prototype, "paginationContainer", 2);
__decorateClass([
  t$7()
], SlCarousel.prototype, "activeSlide", 2);
__decorateClass([
  watch("loop", { waitUntilFirstUpdate: true }),
  watch("slidesPerPage", { waitUntilFirstUpdate: true })
], SlCarousel.prototype, "initializeSlides", 1);
__decorateClass([
  watch("activeSlide")
], SlCarousel.prototype, "handelSlideChange", 1);
__decorateClass([
  watch("slidesPerMove")
], SlCarousel.prototype, "handleSlidesPerMoveChange", 1);
__decorateClass([
  watch("autoplay")
], SlCarousel.prototype, "handleAutoplayChange", 1);
__decorateClass([
  watch("mouseDragging")
], SlCarousel.prototype, "handleMouseDraggingChange", 1);

// src/components/carousel/carousel.ts
var carousel_default = SlCarousel;
SlCarousel.define("sl-carousel");

// src/components/button/button.ts
var button_default = SlButton;
SlButton.define("sl-button");

// src/components/button-group/button-group.ts
var button_group_default = SlButtonGroup;
SlButtonGroup.define("sl-button-group");

var avatar_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-block;

    --size: 3rem;
  }

  .avatar {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    position: relative;
    width: var(--size);
    height: var(--size);
    background-color: var(--sl-color-neutral-400);
    font-family: var(--sl-font-sans);
    font-size: calc(var(--size) * 0.5);
    font-weight: var(--sl-font-weight-normal);
    color: var(--sl-color-neutral-0);
    user-select: none;
    vertical-align: middle;
  }

  .avatar--circle,
  .avatar--circle .avatar__image {
    border-radius: var(--sl-border-radius-circle);
  }

  .avatar--rounded,
  .avatar--rounded .avatar__image {
    border-radius: var(--sl-border-radius-medium);
  }

  .avatar--square {
    border-radius: 0;
  }

  .avatar__icon {
    display: flex;
    align-items: center;
    justify-content: center;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }

  .avatar__initials {
    line-height: 1;
    text-transform: uppercase;
  }

  .avatar__image {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    object-fit: cover;
    overflow: hidden;
  }
`;

var SlAvatar = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasError = false;
    this.image = "";
    this.label = "";
    this.initials = "";
    this.loading = "eager";
    this.shape = "circle";
  }
  handleImageChange() {
    this.hasError = false;
  }
  render() {
    const avatarWithImage = x$1`
      <img
        part="image"
        class="avatar__image"
        src="${this.image}"
        loading="${this.loading}"
        alt=""
        @error="${() => this.hasError = true}"
      />
    `;
    let avatarWithoutImage = x$1``;
    if (this.initials) {
      avatarWithoutImage = x$1`<div part="initials" class="avatar__initials">${this.initials}</div>`;
    } else {
      avatarWithoutImage = x$1`
        <div part="icon" class="avatar__icon" aria-hidden="true">
          <slot name="icon">
            <sl-icon name="person-fill" library="system"></sl-icon>
          </slot>
        </div>
      `;
    }
    return x$1`
      <div
        part="base"
        class=${o$9({
      avatar: true,
      "avatar--circle": this.shape === "circle",
      "avatar--rounded": this.shape === "rounded",
      "avatar--square": this.shape === "square"
    })}
        role="img"
        aria-label=${this.label}
      >
        ${this.image && !this.hasError ? avatarWithImage : avatarWithoutImage}
      </div>
    `;
  }
};
SlAvatar.styles = avatar_styles_default;
SlAvatar.dependencies = {
  "sl-icon": SlIcon
};
__decorateClass([
  t$7()
], SlAvatar.prototype, "hasError", 2);
__decorateClass([
  e$c()
], SlAvatar.prototype, "image", 2);
__decorateClass([
  e$c()
], SlAvatar.prototype, "label", 2);
__decorateClass([
  e$c()
], SlAvatar.prototype, "initials", 2);
__decorateClass([
  e$c()
], SlAvatar.prototype, "loading", 2);
__decorateClass([
  e$c({ reflect: true })
], SlAvatar.prototype, "shape", 2);
__decorateClass([
  watch("image")
], SlAvatar.prototype, "handleImageChange", 1);

// src/components/avatar/avatar.ts
var avatar_default = SlAvatar;
SlAvatar.define("sl-avatar");

var breadcrumb_styles_default = i$b`
  ${component_styles_default}

  .breadcrumb {
    display: flex;
    align-items: center;
    flex-wrap: wrap;
  }
`;

var SlBreadcrumb = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.separatorDir = this.localize.dir();
    this.label = "";
  }
  // Generates a clone of the separator element to use for each breadcrumb item
  getSeparator() {
    const separator = this.separatorSlot.assignedElements({ flatten: true })[0];
    const clone = separator.cloneNode(true);
    [clone, ...clone.querySelectorAll("[id]")].forEach((el) => el.removeAttribute("id"));
    clone.setAttribute("data-default", "");
    clone.slot = "separator";
    return clone;
  }
  handleSlotChange() {
    const items = [...this.defaultSlot.assignedElements({ flatten: true })].filter(
      (item) => item.tagName.toLowerCase() === "sl-breadcrumb-item"
    );
    items.forEach((item, index) => {
      const separator = item.querySelector('[slot="separator"]');
      if (separator === null) {
        item.append(this.getSeparator());
      } else if (separator.hasAttribute("data-default")) {
        separator.replaceWith(this.getSeparator());
      } else {
      }
      if (index === items.length - 1) {
        item.setAttribute("aria-current", "page");
      } else {
        item.removeAttribute("aria-current");
      }
    });
  }
  render() {
    if (this.separatorDir !== this.localize.dir()) {
      this.separatorDir = this.localize.dir();
      this.updateComplete.then(() => this.handleSlotChange());
    }
    return x$1`
      <nav part="base" class="breadcrumb" aria-label=${this.label}>
        <slot @slotchange=${this.handleSlotChange}></slot>
      </nav>

      <span hidden aria-hidden="true">
        <slot name="separator">
          <sl-icon name=${this.localize.dir() === "rtl" ? "chevron-left" : "chevron-right"} library="system"></sl-icon>
        </slot>
      </span>
    `;
  }
};
SlBreadcrumb.styles = breadcrumb_styles_default;
SlBreadcrumb.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7("slot")
], SlBreadcrumb.prototype, "defaultSlot", 2);
__decorateClass([
  i$7('slot[name="separator"]')
], SlBreadcrumb.prototype, "separatorSlot", 2);
__decorateClass([
  e$c()
], SlBreadcrumb.prototype, "label", 2);

// src/components/breadcrumb/breadcrumb.ts
var breadcrumb_default = SlBreadcrumb;
SlBreadcrumb.define("sl-breadcrumb");

var breadcrumb_item_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-flex;
  }

  .breadcrumb-item {
    display: inline-flex;
    align-items: center;
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-small);
    font-weight: var(--sl-font-weight-semibold);
    color: var(--sl-color-neutral-600);
    line-height: var(--sl-line-height-normal);
    white-space: nowrap;
  }

  .breadcrumb-item__label {
    display: inline-block;
    font-family: inherit;
    font-size: inherit;
    font-weight: inherit;
    line-height: inherit;
    text-decoration: none;
    color: inherit;
    background: none;
    border: none;
    border-radius: var(--sl-border-radius-medium);
    padding: 0;
    margin: 0;
    cursor: pointer;
    transition: var(--sl-transition-fast) --color;
  }

  :host(:not(:last-of-type)) .breadcrumb-item__label {
    color: var(--sl-color-primary-600);
  }

  :host(:not(:last-of-type)) .breadcrumb-item__label:hover {
    color: var(--sl-color-primary-500);
  }

  :host(:not(:last-of-type)) .breadcrumb-item__label:active {
    color: var(--sl-color-primary-600);
  }

  .breadcrumb-item__label:focus {
    outline: none;
  }

  .breadcrumb-item__label:focus-visible {
    outline: var(--sl-focus-ring);
    outline-offset: var(--sl-focus-ring-offset);
  }

  .breadcrumb-item__prefix,
  .breadcrumb-item__suffix {
    display: none;
    flex: 0 0 auto;
    display: flex;
    align-items: center;
  }

  .breadcrumb-item--has-prefix .breadcrumb-item__prefix {
    display: inline-flex;
    margin-inline-end: var(--sl-spacing-x-small);
  }

  .breadcrumb-item--has-suffix .breadcrumb-item__suffix {
    display: inline-flex;
    margin-inline-start: var(--sl-spacing-x-small);
  }

  :host(:last-of-type) .breadcrumb-item__separator {
    display: none;
  }

  .breadcrumb-item__separator {
    display: inline-flex;
    align-items: center;
    margin: 0 var(--sl-spacing-x-small);
    user-select: none;
  }
`;

var SlBreadcrumbItem = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController$1(this, "prefix", "suffix");
    this.rel = "noreferrer noopener";
  }
  render() {
    const isLink = this.href ? true : false;
    return x$1`
      <div
        part="base"
        class=${o$9({
      "breadcrumb-item": true,
      "breadcrumb-item--has-prefix": this.hasSlotController.test("prefix"),
      "breadcrumb-item--has-suffix": this.hasSlotController.test("suffix")
    })}
      >
        <span part="prefix" class="breadcrumb-item__prefix">
          <slot name="prefix"></slot>
        </span>

        ${isLink ? x$1`
              <a
                part="label"
                class="breadcrumb-item__label breadcrumb-item__label--link"
                href="${this.href}"
                target="${l$2(this.target ? this.target : void 0)}"
                rel=${l$2(this.target ? this.rel : void 0)}
              >
                <slot></slot>
              </a>
            ` : x$1`
              <button part="label" type="button" class="breadcrumb-item__label breadcrumb-item__label--button">
                <slot></slot>
              </button>
            `}

        <span part="suffix" class="breadcrumb-item__suffix">
          <slot name="suffix"></slot>
        </span>

        <span part="separator" class="breadcrumb-item__separator" aria-hidden="true">
          <slot name="separator"></slot>
        </span>
      </div>
    `;
  }
};
SlBreadcrumbItem.styles = breadcrumb_item_styles_default;
__decorateClass([
  e$c()
], SlBreadcrumbItem.prototype, "href", 2);
__decorateClass([
  e$c()
], SlBreadcrumbItem.prototype, "target", 2);
__decorateClass([
  e$c()
], SlBreadcrumbItem.prototype, "rel", 2);

// src/components/breadcrumb-item/breadcrumb-item.ts
var breadcrumb_item_default = SlBreadcrumbItem;
SlBreadcrumbItem.define("sl-breadcrumb-item");

var animated_image_styles_default = i$b`
  ${component_styles_default}

  :host {
    --control-box-size: 3rem;
    --icon-size: calc(var(--control-box-size) * 0.625);

    display: inline-flex;
    position: relative;
    cursor: pointer;
  }

  img {
    display: block;
    width: 100%;
    height: 100%;
  }

  img[aria-hidden='true'] {
    display: none;
  }

  .animated-image__control-box {
    display: flex;
    position: absolute;
    align-items: center;
    justify-content: center;
    top: calc(50% - var(--control-box-size) / 2);
    right: calc(50% - var(--control-box-size) / 2);
    width: var(--control-box-size);
    height: var(--control-box-size);
    font-size: var(--icon-size);
    background: none;
    border: solid 2px currentColor;
    background-color: rgb(0 0 0 /50%);
    border-radius: var(--sl-border-radius-circle);
    color: white;
    pointer-events: none;
    transition: var(--sl-transition-fast) opacity;
  }

  :host([play]:hover) .animated-image__control-box {
    opacity: 1;
  }

  :host([play]:not(:hover)) .animated-image__control-box {
    opacity: 0;
  }

  :host([play]) slot[name='play-icon'],
  :host(:not([play])) slot[name='pause-icon'] {
    display: none;
  }
`;

var SlAnimatedImage = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.isLoaded = false;
  }
  handleClick() {
    this.play = !this.play;
  }
  handleLoad() {
    const canvas = document.createElement("canvas");
    const { width, height } = this.animatedImage;
    canvas.width = width;
    canvas.height = height;
    canvas.getContext("2d").drawImage(this.animatedImage, 0, 0, width, height);
    this.frozenFrame = canvas.toDataURL("image/gif");
    if (!this.isLoaded) {
      this.emit("sl-load");
      this.isLoaded = true;
    }
  }
  handleError() {
    this.emit("sl-error");
  }
  handlePlayChange() {
    if (this.play) {
      this.animatedImage.src = "";
      this.animatedImage.src = this.src;
    }
  }
  handleSrcChange() {
    this.isLoaded = false;
  }
  render() {
    return x$1`
      <div class="animated-image">
        <img
          class="animated-image__animated"
          src=${this.src}
          alt=${this.alt}
          crossorigin="anonymous"
          aria-hidden=${this.play ? "false" : "true"}
          @click=${this.handleClick}
          @load=${this.handleLoad}
          @error=${this.handleError}
        />

        ${this.isLoaded ? x$1`
              <img
                class="animated-image__frozen"
                src=${this.frozenFrame}
                alt=${this.alt}
                aria-hidden=${this.play ? "true" : "false"}
                @click=${this.handleClick}
              />

              <div part="control-box" class="animated-image__control-box">
                <slot name="play-icon"><sl-icon name="play-fill" library="system"></sl-icon></slot>
                <slot name="pause-icon"><sl-icon name="pause-fill" library="system"></sl-icon></slot>
              </div>
            ` : ""}
      </div>
    `;
  }
};
SlAnimatedImage.styles = animated_image_styles_default;
SlAnimatedImage.dependencies = { "sl-icon": SlIcon };
__decorateClass([
  i$7(".animated-image__animated")
], SlAnimatedImage.prototype, "animatedImage", 2);
__decorateClass([
  t$7()
], SlAnimatedImage.prototype, "frozenFrame", 2);
__decorateClass([
  t$7()
], SlAnimatedImage.prototype, "isLoaded", 2);
__decorateClass([
  e$c()
], SlAnimatedImage.prototype, "src", 2);
__decorateClass([
  e$c()
], SlAnimatedImage.prototype, "alt", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlAnimatedImage.prototype, "play", 2);
__decorateClass([
  watch("play", { waitUntilFirstUpdate: true })
], SlAnimatedImage.prototype, "handlePlayChange", 1);
__decorateClass([
  watch("src")
], SlAnimatedImage.prototype, "handleSrcChange", 1);

// src/components/animated-image/animated-image.ts
var animated_image_default = SlAnimatedImage;
SlAnimatedImage.define("sl-animated-image");

var animation_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: contents;
  }
`;

const bounce = [
  { offset: 0, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)', transform: 'translate3d(0, 0, 0)' },
  { offset: 0.2, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)', transform: 'translate3d(0, 0, 0)' },
  { offset: 0.4, easing: 'cubic-bezier(0.755, 0.05, 0.855, 0.06)', transform: 'translate3d(0, -30px, 0) scaleY(1.1)' },
  { offset: 0.43, easing: 'cubic-bezier(0.755, 0.05, 0.855, 0.06)', transform: 'translate3d(0, -30px, 0) scaleY(1.1)' },
  { offset: 0.53, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)', transform: 'translate3d(0, 0, 0)' },
  { offset: 0.7, easing: 'cubic-bezier(0.755, 0.05, 0.855, 0.06)', transform: 'translate3d(0, -15px, 0) scaleY(1.05)' },
  {
    offset: 0.8,
    'transition-timing-function': 'cubic-bezier(0.215, 0.61, 0.355, 1)',
    transform: 'translate3d(0, 0, 0) scaleY(0.95)'
  },
  { offset: 0.9, transform: 'translate3d(0, -4px, 0) scaleY(1.02)' },
  { offset: 1, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)', transform: 'translate3d(0, 0, 0)' }
];

const flash = [
  { offset: 0, opacity: '1' },
  { offset: 0.25, opacity: '0' },
  { offset: 0.5, opacity: '1' },
  { offset: 0.75, opacity: '0' },
  { offset: 1, opacity: '1' }
];

const headShake = [
  { offset: 0, transform: 'translateX(0)' },
  { offset: 0.065, transform: 'translateX(-6px) rotateY(-9deg)' },
  { offset: 0.185, transform: 'translateX(5px) rotateY(7deg)' },
  { offset: 0.315, transform: 'translateX(-3px) rotateY(-5deg)' },
  { offset: 0.435, transform: 'translateX(2px) rotateY(3deg)' },
  { offset: 0.5, transform: 'translateX(0)' }
];

const heartBeat = [
  { offset: 0, transform: 'scale(1)' },
  { offset: 0.14, transform: 'scale(1.3)' },
  { offset: 0.28, transform: 'scale(1)' },
  { offset: 0.42, transform: 'scale(1.3)' },
  { offset: 0.7, transform: 'scale(1)' }
];

const jello = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 0.111, transform: 'translate3d(0, 0, 0)' },
  { offset: 0.222, transform: 'skewX(-12.5deg) skewY(-12.5deg)' },
  { offset: 0.33299999999999996, transform: 'skewX(6.25deg) skewY(6.25deg)' },
  { offset: 0.444, transform: 'skewX(-3.125deg) skewY(-3.125deg)' },
  { offset: 0.555, transform: 'skewX(1.5625deg) skewY(1.5625deg)' },
  { offset: 0.6659999999999999, transform: 'skewX(-0.78125deg) skewY(-0.78125deg)' },
  { offset: 0.777, transform: 'skewX(0.390625deg) skewY(0.390625deg)' },
  { offset: 0.888, transform: 'skewX(-0.1953125deg) skewY(-0.1953125deg)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const pulse = [
  { offset: 0, transform: 'scale3d(1, 1, 1)' },
  { offset: 0.5, transform: 'scale3d(1.05, 1.05, 1.05)' },
  { offset: 1, transform: 'scale3d(1, 1, 1)' }
];

const rubberBand = [
  { offset: 0, transform: 'scale3d(1, 1, 1)' },
  { offset: 0.3, transform: 'scale3d(1.25, 0.75, 1)' },
  { offset: 0.4, transform: 'scale3d(0.75, 1.25, 1)' },
  { offset: 0.5, transform: 'scale3d(1.15, 0.85, 1)' },
  { offset: 0.65, transform: 'scale3d(0.95, 1.05, 1)' },
  { offset: 0.75, transform: 'scale3d(1.05, 0.95, 1)' },
  { offset: 1, transform: 'scale3d(1, 1, 1)' }
];

const shake = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 0.1, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.2, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.3, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.4, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.5, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.6, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.7, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.8, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.9, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const shakeX = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 0.1, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.2, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.3, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.4, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.5, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.6, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.7, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 0.8, transform: 'translate3d(10px, 0, 0)' },
  { offset: 0.9, transform: 'translate3d(-10px, 0, 0)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const shakeY = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 0.1, transform: 'translate3d(0, -10px, 0)' },
  { offset: 0.2, transform: 'translate3d(0, 10px, 0)' },
  { offset: 0.3, transform: 'translate3d(0, -10px, 0)' },
  { offset: 0.4, transform: 'translate3d(0, 10px, 0)' },
  { offset: 0.5, transform: 'translate3d(0, -10px, 0)' },
  { offset: 0.6, transform: 'translate3d(0, 10px, 0)' },
  { offset: 0.7, transform: 'translate3d(0, -10px, 0)' },
  { offset: 0.8, transform: 'translate3d(0, 10px, 0)' },
  { offset: 0.9, transform: 'translate3d(0, -10px, 0)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const swing = [
  { offset: 0.2, transform: 'rotate3d(0, 0, 1, 15deg)' },
  { offset: 0.4, transform: 'rotate3d(0, 0, 1, -10deg)' },
  { offset: 0.6, transform: 'rotate3d(0, 0, 1, 5deg)' },
  { offset: 0.8, transform: 'rotate3d(0, 0, 1, -5deg)' },
  { offset: 1, transform: 'rotate3d(0, 0, 1, 0deg)' }
];

const tada = [
  { offset: 0, transform: 'scale3d(1, 1, 1)' },
  { offset: 0.1, transform: 'scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg)' },
  { offset: 0.2, transform: 'scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg)' },
  { offset: 0.3, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
  { offset: 0.4, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg)' },
  { offset: 0.5, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
  { offset: 0.6, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg)' },
  { offset: 0.7, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
  { offset: 0.8, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg)' },
  { offset: 0.9, transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
  { offset: 1, transform: 'scale3d(1, 1, 1)' }
];

const wobble = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 0.15, transform: 'translate3d(-25%, 0, 0) rotate3d(0, 0, 1, -5deg)' },
  { offset: 0.3, transform: 'translate3d(20%, 0, 0) rotate3d(0, 0, 1, 3deg)' },
  { offset: 0.45, transform: 'translate3d(-15%, 0, 0) rotate3d(0, 0, 1, -3deg)' },
  { offset: 0.6, transform: 'translate3d(10%, 0, 0) rotate3d(0, 0, 1, 2deg)' },
  { offset: 0.75, transform: 'translate3d(-5%, 0, 0) rotate3d(0, 0, 1, -1deg)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const backInDown = [
  { offset: 0, transform: 'translateY(-1200px) scale(0.7)', opacity: '0.7' },
  { offset: 0.8, transform: 'translateY(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'scale(1)', opacity: '1' }
];

const backInLeft = [
  { offset: 0, transform: 'translateX(-2000px) scale(0.7)', opacity: '0.7' },
  { offset: 0.8, transform: 'translateX(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'scale(1)', opacity: '1' }
];

const backInRight = [
  { offset: 0, transform: 'translateX(2000px) scale(0.7)', opacity: '0.7' },
  { offset: 0.8, transform: 'translateX(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'scale(1)', opacity: '1' }
];

const backInUp = [
  { offset: 0, transform: 'translateY(1200px) scale(0.7)', opacity: '0.7' },
  { offset: 0.8, transform: 'translateY(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'scale(1)', opacity: '1' }
];

const backOutDown = [
  { offset: 0, transform: 'scale(1)', opacity: '1' },
  { offset: 0.2, transform: 'translateY(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'translateY(700px) scale(0.7)', opacity: '0.7' }
];

const backOutLeft = [
  { offset: 0, transform: 'scale(1)', opacity: '1' },
  { offset: 0.2, transform: 'translateX(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'translateX(-2000px) scale(0.7)', opacity: '0.7' }
];

const backOutRight = [
  { offset: 0, transform: 'scale(1)', opacity: '1' },
  { offset: 0.2, transform: 'translateX(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'translateX(2000px) scale(0.7)', opacity: '0.7' }
];

const backOutUp = [
  { offset: 0, transform: 'scale(1)', opacity: '1' },
  { offset: 0.2, transform: 'translateY(0px) scale(0.7)', opacity: '0.7' },
  { offset: 1, transform: 'translateY(-700px) scale(0.7)', opacity: '0.7' }
];

const bounceIn = [
  { offset: 0, opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)' },
  { offset: 0, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.2, transform: 'scale3d(1.1, 1.1, 1.1)' },
  { offset: 0.2, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.4, transform: 'scale3d(0.9, 0.9, 0.9)' },
  { offset: 0.4, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.6, opacity: '1', transform: 'scale3d(1.03, 1.03, 1.03)' },
  { offset: 0.6, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.8, transform: 'scale3d(0.97, 0.97, 0.97)' },
  { offset: 0.8, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 1, opacity: '1', transform: 'scale3d(1, 1, 1)' },
  { offset: 1, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' }
];

const bounceInDown = [
  { offset: 0, opacity: '0', transform: 'translate3d(0, -3000px, 0) scaleY(3)' },
  { offset: 0, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.6, opacity: '1', transform: 'translate3d(0, 25px, 0) scaleY(0.9)' },
  { offset: 0.6, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.75, transform: 'translate3d(0, -10px, 0) scaleY(0.95)' },
  { offset: 0.75, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.9, transform: 'translate3d(0, 5px, 0) scaleY(0.985)' },
  { offset: 0.9, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' }
];

const bounceInLeft = [
  { offset: 0, opacity: '0', transform: 'translate3d(-3000px, 0, 0) scaleX(3)' },
  { offset: 0, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.6, opacity: '1', transform: 'translate3d(25px, 0, 0) scaleX(1)' },
  { offset: 0.6, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.75, transform: 'translate3d(-10px, 0, 0) scaleX(0.98)' },
  { offset: 0.75, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.9, transform: 'translate3d(5px, 0, 0) scaleX(0.995)' },
  { offset: 0.9, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' }
];

const bounceInRight = [
  { offset: 0, opacity: '0', transform: 'translate3d(3000px, 0, 0) scaleX(3)' },
  { offset: 0, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.6, opacity: '1', transform: 'translate3d(-25px, 0, 0) scaleX(1)' },
  { offset: 0.6, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.75, transform: 'translate3d(10px, 0, 0) scaleX(0.98)' },
  { offset: 0.75, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.9, transform: 'translate3d(-5px, 0, 0) scaleX(0.995)' },
  { offset: 0.9, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' }
];

const bounceInUp = [
  { offset: 0, opacity: '0', transform: 'translate3d(0, 3000px, 0) scaleY(5)' },
  { offset: 0, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.6, opacity: '1', transform: 'translate3d(0, -20px, 0) scaleY(0.9)' },
  { offset: 0.6, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.75, transform: 'translate3d(0, 10px, 0) scaleY(0.95)' },
  { offset: 0.75, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 0.9, transform: 'translate3d(0, -5px, 0) scaleY(0.985)' },
  { offset: 0.9, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, easing: 'cubic-bezier(0.215, 0.61, 0.355, 1)' }
];

const bounceOut = [
  { offset: 0.2, transform: 'scale3d(0.9, 0.9, 0.9)' },
  { offset: 0.5, opacity: '1', transform: 'scale3d(1.1, 1.1, 1.1)' },
  { offset: 0.55, opacity: '1', transform: 'scale3d(1.1, 1.1, 1.1)' },
  { offset: 1, opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)' }
];

const bounceOutDown = [
  { offset: 0.2, transform: 'translate3d(0, 10px, 0) scaleY(0.985)' },
  { offset: 0.4, opacity: '1', transform: 'translate3d(0, -20px, 0) scaleY(0.9)' },
  { offset: 0.45, opacity: '1', transform: 'translate3d(0, -20px, 0) scaleY(0.9)' },
  { offset: 1, opacity: '0', transform: 'translate3d(0, 2000px, 0) scaleY(3)' }
];

const bounceOutLeft = [
  { offset: 0.2, opacity: '1', transform: 'translate3d(20px, 0, 0) scaleX(0.9)' },
  { offset: 1, opacity: '0', transform: 'translate3d(-2000px, 0, 0) scaleX(2)' }
];

const bounceOutRight = [
  { offset: 0.2, opacity: '1', transform: 'translate3d(-20px, 0, 0) scaleX(0.9)' },
  { offset: 1, opacity: '0', transform: 'translate3d(2000px, 0, 0) scaleX(2)' }
];

const bounceOutUp = [
  { offset: 0.2, transform: 'translate3d(0, -10px, 0) scaleY(0.985)' },
  { offset: 0.4, opacity: '1', transform: 'translate3d(0, 20px, 0) scaleY(0.9)' },
  { offset: 0.45, opacity: '1', transform: 'translate3d(0, 20px, 0) scaleY(0.9)' },
  { offset: 1, opacity: '0', transform: 'translate3d(0, -2000px, 0) scaleY(3)' }
];

const fadeIn = [
  { offset: 0, opacity: '0' },
  { offset: 1, opacity: '1' }
];

const fadeInBottomLeft = [
  { offset: 0, opacity: '0', transform: 'translate3d(-100%, 100%, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInBottomRight = [
  { offset: 0, opacity: '0', transform: 'translate3d(100%, 100%, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInDown = [
  { offset: 0, opacity: '0', transform: 'translate3d(0, -100%, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInDownBig = [
  { offset: 0, opacity: '0', transform: 'translate3d(0, -2000px, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInLeft = [
  { offset: 0, opacity: '0', transform: 'translate3d(-100%, 0, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInLeftBig = [
  { offset: 0, opacity: '0', transform: 'translate3d(-2000px, 0, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInRight = [
  { offset: 0, opacity: '0', transform: 'translate3d(100%, 0, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInRightBig = [
  { offset: 0, opacity: '0', transform: 'translate3d(2000px, 0, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInTopLeft = [
  { offset: 0, opacity: '0', transform: 'translate3d(-100%, -100%, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInTopRight = [
  { offset: 0, opacity: '0', transform: 'translate3d(100%, -100%, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInUp = [
  { offset: 0, opacity: '0', transform: 'translate3d(0, 100%, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeInUpBig = [
  { offset: 0, opacity: '0', transform: 'translate3d(0, 2000px, 0)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const fadeOut = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0' }
];

const fadeOutBottomLeft = [
  { offset: 0, opacity: '1', transform: 'translate3d(0, 0, 0)' },
  { offset: 1, opacity: '0', transform: 'translate3d(-100%, 100%, 0)' }
];

const fadeOutBottomRight = [
  { offset: 0, opacity: '1', transform: 'translate3d(0, 0, 0)' },
  { offset: 1, opacity: '0', transform: 'translate3d(100%, 100%, 0)' }
];

const fadeOutDown = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(0, 100%, 0)' }
];

const fadeOutDownBig = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(0, 2000px, 0)' }
];

const fadeOutLeft = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(-100%, 0, 0)' }
];

const fadeOutLeftBig = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(-2000px, 0, 0)' }
];

const fadeOutRight = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(100%, 0, 0)' }
];

const fadeOutRightBig = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(2000px, 0, 0)' }
];

const fadeOutTopLeft = [
  { offset: 0, opacity: '1', transform: 'translate3d(0, 0, 0)' },
  { offset: 1, opacity: '0', transform: 'translate3d(-100%, -100%, 0)' }
];

const fadeOutTopRight = [
  { offset: 0, opacity: '1', transform: 'translate3d(0, 0, 0)' },
  { offset: 1, opacity: '0', transform: 'translate3d(100%, -100%, 0)' }
];

const fadeOutUp = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(0, -100%, 0)' }
];

const fadeOutUpBig = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(0, -2000px, 0)' }
];

const flip = [
  {
    offset: 0,
    transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 0) rotate3d(0, 1, 0, -360deg)',
    easing: 'ease-out'
  },
  {
    offset: 0.4,
    transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 150px)\n      rotate3d(0, 1, 0, -190deg)',
    easing: 'ease-out'
  },
  {
    offset: 0.5,
    transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 150px)\n      rotate3d(0, 1, 0, -170deg)',
    easing: 'ease-in'
  },
  {
    offset: 0.8,
    transform: 'perspective(400px) scale3d(0.95, 0.95, 0.95) translate3d(0, 0, 0)\n      rotate3d(0, 1, 0, 0deg)',
    easing: 'ease-in'
  },
  {
    offset: 1,
    transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 0) rotate3d(0, 1, 0, 0deg)',
    easing: 'ease-in'
  }
];

const flipInX = [
  { offset: 0, transform: 'perspective(400px) rotate3d(1, 0, 0, 90deg)', easing: 'ease-in', opacity: '0' },
  { offset: 0.4, transform: 'perspective(400px) rotate3d(1, 0, 0, -20deg)', easing: 'ease-in' },
  { offset: 0.6, transform: 'perspective(400px) rotate3d(1, 0, 0, 10deg)', opacity: '1' },
  { offset: 0.8, transform: 'perspective(400px) rotate3d(1, 0, 0, -5deg)' },
  { offset: 1, transform: 'perspective(400px)' }
];

const flipInY = [
  { offset: 0, transform: 'perspective(400px) rotate3d(0, 1, 0, 90deg)', easing: 'ease-in', opacity: '0' },
  { offset: 0.4, transform: 'perspective(400px) rotate3d(0, 1, 0, -20deg)', easing: 'ease-in' },
  { offset: 0.6, transform: 'perspective(400px) rotate3d(0, 1, 0, 10deg)', opacity: '1' },
  { offset: 0.8, transform: 'perspective(400px) rotate3d(0, 1, 0, -5deg)' },
  { offset: 1, transform: 'perspective(400px)' }
];

const flipOutX = [
  { offset: 0, transform: 'perspective(400px)' },
  { offset: 0.3, transform: 'perspective(400px) rotate3d(1, 0, 0, -20deg)', opacity: '1' },
  { offset: 1, transform: 'perspective(400px) rotate3d(1, 0, 0, 90deg)', opacity: '0' }
];

const flipOutY = [
  { offset: 0, transform: 'perspective(400px)' },
  { offset: 0.3, transform: 'perspective(400px) rotate3d(0, 1, 0, -15deg)', opacity: '1' },
  { offset: 1, transform: 'perspective(400px) rotate3d(0, 1, 0, 90deg)', opacity: '0' }
];

const lightSpeedInLeft = [
  { offset: 0, transform: 'translate3d(-100%, 0, 0) skewX(30deg)', opacity: '0' },
  { offset: 0.6, transform: 'skewX(-20deg)', opacity: '1' },
  { offset: 0.8, transform: 'skewX(5deg)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const lightSpeedInRight = [
  { offset: 0, transform: 'translate3d(100%, 0, 0) skewX(-30deg)', opacity: '0' },
  { offset: 0.6, transform: 'skewX(20deg)', opacity: '1' },
  { offset: 0.8, transform: 'skewX(-5deg)' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const lightSpeedOutLeft = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'translate3d(-100%, 0, 0) skewX(-30deg)', opacity: '0' }
];

const lightSpeedOutRight = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'translate3d(100%, 0, 0) skewX(30deg)', opacity: '0' }
];

const rotateIn = [
  { offset: 0, transform: 'rotate3d(0, 0, 1, -200deg)', opacity: '0' },
  { offset: 1, transform: 'translate3d(0, 0, 0)', opacity: '1' }
];

const rotateInDownLeft = [
  { offset: 0, transform: 'rotate3d(0, 0, 1, -45deg)', opacity: '0' },
  { offset: 1, transform: 'translate3d(0, 0, 0)', opacity: '1' }
];

const rotateInDownRight = [
  { offset: 0, transform: 'rotate3d(0, 0, 1, 45deg)', opacity: '0' },
  { offset: 1, transform: 'translate3d(0, 0, 0)', opacity: '1' }
];

const rotateInUpLeft = [
  { offset: 0, transform: 'rotate3d(0, 0, 1, 45deg)', opacity: '0' },
  { offset: 1, transform: 'translate3d(0, 0, 0)', opacity: '1' }
];

const rotateInUpRight = [
  { offset: 0, transform: 'rotate3d(0, 0, 1, -90deg)', opacity: '0' },
  { offset: 1, transform: 'translate3d(0, 0, 0)', opacity: '1' }
];

const rotateOut = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'rotate3d(0, 0, 1, 200deg)', opacity: '0' }
];

const rotateOutDownLeft = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'rotate3d(0, 0, 1, 45deg)', opacity: '0' }
];

const rotateOutDownRight = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'rotate3d(0, 0, 1, -45deg)', opacity: '0' }
];

const rotateOutUpLeft = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'rotate3d(0, 0, 1, -45deg)', opacity: '0' }
];

const rotateOutUpRight = [
  { offset: 0, opacity: '1' },
  { offset: 1, transform: 'rotate3d(0, 0, 1, 90deg)', opacity: '0' }
];

const slideInDown = [
  { offset: 0, transform: 'translate3d(0, -100%, 0)', visibility: 'visible' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const slideInLeft = [
  { offset: 0, transform: 'translate3d(-100%, 0, 0)', visibility: 'visible' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const slideInRight = [
  { offset: 0, transform: 'translate3d(100%, 0, 0)', visibility: 'visible' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const slideInUp = [
  { offset: 0, transform: 'translate3d(0, 100%, 0)', visibility: 'visible' },
  { offset: 1, transform: 'translate3d(0, 0, 0)' }
];

const slideOutDown = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, visibility: 'hidden', transform: 'translate3d(0, 100%, 0)' }
];

const slideOutLeft = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, visibility: 'hidden', transform: 'translate3d(-100%, 0, 0)' }
];

const slideOutRight = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, visibility: 'hidden', transform: 'translate3d(100%, 0, 0)' }
];

const slideOutUp = [
  { offset: 0, transform: 'translate3d(0, 0, 0)' },
  { offset: 1, visibility: 'hidden', transform: 'translate3d(0, -100%, 0)' }
];

const hinge = [
  { offset: 0, easing: 'ease-in-out' },
  { offset: 0.2, transform: 'rotate3d(0, 0, 1, 80deg)', easing: 'ease-in-out' },
  { offset: 0.4, transform: 'rotate3d(0, 0, 1, 60deg)', easing: 'ease-in-out', opacity: '1' },
  { offset: 0.6, transform: 'rotate3d(0, 0, 1, 80deg)', easing: 'ease-in-out' },
  { offset: 0.8, transform: 'rotate3d(0, 0, 1, 60deg)', easing: 'ease-in-out', opacity: '1' },
  { offset: 1, transform: 'translate3d(0, 700px, 0)', opacity: '0' }
];

const jackInTheBox = [
  { offset: 0, opacity: '0', transform: 'scale(0.1) rotate(30deg)', 'transform-origin': 'center bottom' },
  { offset: 0.5, transform: 'rotate(-10deg)' },
  { offset: 0.7, transform: 'rotate(3deg)' },
  { offset: 1, opacity: '1', transform: 'scale(1)' }
];

const rollIn = [
  { offset: 0, opacity: '0', transform: 'translate3d(-100%, 0, 0) rotate3d(0, 0, 1, -120deg)' },
  { offset: 1, opacity: '1', transform: 'translate3d(0, 0, 0)' }
];

const rollOut = [
  { offset: 0, opacity: '1' },
  { offset: 1, opacity: '0', transform: 'translate3d(100%, 0, 0) rotate3d(0, 0, 1, 120deg)' }
];

const zoomIn = [
  { offset: 0, opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)' },
  { offset: 0.5, opacity: '1' }
];

const zoomInDown = [
  {
    offset: 0,
    opacity: '0',
    transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, -1000px, 0)',
    easing: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
  },
  {
    offset: 0.6,
    opacity: '1',
    transform: 'scale3d(0.475, 0.475, 0.475) translate3d(0, 60px, 0)',
    easing: 'cubic-bezier(0.175, 0.885, 0.32, 1)'
  }
];

const zoomInLeft = [
  {
    offset: 0,
    opacity: '0',
    transform: 'scale3d(0.1, 0.1, 0.1) translate3d(-1000px, 0, 0)',
    easing: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
  },
  {
    offset: 0.6,
    opacity: '1',
    transform: 'scale3d(0.475, 0.475, 0.475) translate3d(10px, 0, 0)',
    easing: 'cubic-bezier(0.175, 0.885, 0.32, 1)'
  }
];

const zoomInRight = [
  {
    offset: 0,
    opacity: '0',
    transform: 'scale3d(0.1, 0.1, 0.1) translate3d(1000px, 0, 0)',
    easing: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
  },
  {
    offset: 0.6,
    opacity: '1',
    transform: 'scale3d(0.475, 0.475, 0.475) translate3d(-10px, 0, 0)',
    easing: 'cubic-bezier(0.175, 0.885, 0.32, 1)'
  }
];

const zoomInUp = [
  {
    offset: 0,
    opacity: '0',
    transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, 1000px, 0)',
    easing: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
  },
  {
    offset: 0.6,
    opacity: '1',
    transform: 'scale3d(0.475, 0.475, 0.475) translate3d(0, -60px, 0)',
    easing: 'cubic-bezier(0.175, 0.885, 0.32, 1)'
  }
];

const zoomOut = [
  { offset: 0, opacity: '1' },
  { offset: 0.5, opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)' },
  { offset: 1, opacity: '0' }
];

const zoomOutDown = [
  {
    offset: 0.4,
    opacity: '1',
    transform: 'scale3d(0.475, 0.475, 0.475) translate3d(0, -60px, 0)',
    easing: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
  },
  {
    offset: 1,
    opacity: '0',
    transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, 2000px, 0)',
    easing: 'cubic-bezier(0.175, 0.885, 0.32, 1)'
  }
];

const zoomOutLeft = [
  { offset: 0.4, opacity: '1', transform: 'scale3d(0.475, 0.475, 0.475) translate3d(42px, 0, 0)' },
  { offset: 1, opacity: '0', transform: 'scale(0.1) translate3d(-2000px, 0, 0)' }
];

const zoomOutRight = [
  { offset: 0.4, opacity: '1', transform: 'scale3d(0.475, 0.475, 0.475) translate3d(-42px, 0, 0)' },
  { offset: 1, opacity: '0', transform: 'scale(0.1) translate3d(2000px, 0, 0)' }
];

const zoomOutUp = [
  {
    offset: 0.4,
    opacity: '1',
    transform: 'scale3d(0.475, 0.475, 0.475) translate3d(0, 60px, 0)',
    easing: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
  },
  {
    offset: 1,
    opacity: '0',
    transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, -2000px, 0)',
    easing: 'cubic-bezier(0.175, 0.885, 0.32, 1)'
  }
];

const easings = {
  linear: 'linear',
  ease: 'ease',
  easeIn: 'ease-in',
  easeOut: 'ease-out',
  easeInOut: 'ease-in-out',
  easeInSine: 'cubic-bezier(0.47, 0, 0.745, 0.715)',
  easeOutSine: 'cubic-bezier(0.39, 0.575, 0.565, 1)',
  easeInOutSine: 'cubic-bezier(0.445, 0.05, 0.55, 0.95)',
  easeInQuad: 'cubic-bezier(0.55, 0.085, 0.68, 0.53)',
  easeOutQuad: 'cubic-bezier(0.25, 0.46, 0.45, 0.94)',
  easeInOutQuad: 'cubic-bezier(0.455, 0.03, 0.515, 0.955)',
  easeInCubic: 'cubic-bezier(0.55, 0.055, 0.675, 0.19)',
  easeOutCubic: 'cubic-bezier(0.215, 0.61, 0.355, 1)',
  easeInOutCubic: 'cubic-bezier(0.645, 0.045, 0.355, 1)',
  easeInQuart: 'cubic-bezier(0.895, 0.03, 0.685, 0.22)',
  easeOutQuart: 'cubic-bezier(0.165, 0.84, 0.44, 1)',
  easeInOutQuart: 'cubic-bezier(0.77, 0, 0.175, 1)',
  easeInQuint: 'cubic-bezier(0.755, 0.05, 0.855, 0.06)',
  easeOutQuint: 'cubic-bezier(0.23, 1, 0.32, 1)',
  easeInOutQuint: 'cubic-bezier(0.86, 0, 0.07, 1)',
  easeInExpo: 'cubic-bezier(0.95, 0.05, 0.795, 0.035)',
  easeOutExpo: 'cubic-bezier(0.19, 1, 0.22, 1)',
  easeInOutExpo: 'cubic-bezier(1, 0, 0, 1)',
  easeInCirc: 'cubic-bezier(0.6, 0.04, 0.98, 0.335)',
  easeOutCirc: 'cubic-bezier(0.075, 0.82, 0.165, 1)',
  easeInOutCirc: 'cubic-bezier(0.785, 0.135, 0.15, 0.86)',
  easeInBack: 'cubic-bezier(0.6, -0.28, 0.735, 0.045)',
  easeOutBack: 'cubic-bezier(0.175, 0.885, 0.32, 1.275)',
  easeInOutBack: 'cubic-bezier(0.68, -0.55, 0.265, 1.55)'
};

var animations = /*#__PURE__*/Object.freeze({
	__proto__: null,
	easings: easings,
	bounce: bounce,
	flash: flash,
	headShake: headShake,
	heartBeat: heartBeat,
	jello: jello,
	pulse: pulse,
	rubberBand: rubberBand,
	shake: shake,
	shakeX: shakeX,
	shakeY: shakeY,
	swing: swing,
	tada: tada,
	wobble: wobble,
	backInDown: backInDown,
	backInLeft: backInLeft,
	backInRight: backInRight,
	backInUp: backInUp,
	backOutDown: backOutDown,
	backOutLeft: backOutLeft,
	backOutRight: backOutRight,
	backOutUp: backOutUp,
	bounceIn: bounceIn,
	bounceInDown: bounceInDown,
	bounceInLeft: bounceInLeft,
	bounceInRight: bounceInRight,
	bounceInUp: bounceInUp,
	bounceOut: bounceOut,
	bounceOutDown: bounceOutDown,
	bounceOutLeft: bounceOutLeft,
	bounceOutRight: bounceOutRight,
	bounceOutUp: bounceOutUp,
	fadeIn: fadeIn,
	fadeInBottomLeft: fadeInBottomLeft,
	fadeInBottomRight: fadeInBottomRight,
	fadeInDown: fadeInDown,
	fadeInDownBig: fadeInDownBig,
	fadeInLeft: fadeInLeft,
	fadeInLeftBig: fadeInLeftBig,
	fadeInRight: fadeInRight,
	fadeInRightBig: fadeInRightBig,
	fadeInTopLeft: fadeInTopLeft,
	fadeInTopRight: fadeInTopRight,
	fadeInUp: fadeInUp,
	fadeInUpBig: fadeInUpBig,
	fadeOut: fadeOut,
	fadeOutBottomLeft: fadeOutBottomLeft,
	fadeOutBottomRight: fadeOutBottomRight,
	fadeOutDown: fadeOutDown,
	fadeOutDownBig: fadeOutDownBig,
	fadeOutLeft: fadeOutLeft,
	fadeOutLeftBig: fadeOutLeftBig,
	fadeOutRight: fadeOutRight,
	fadeOutRightBig: fadeOutRightBig,
	fadeOutTopLeft: fadeOutTopLeft,
	fadeOutTopRight: fadeOutTopRight,
	fadeOutUp: fadeOutUp,
	fadeOutUpBig: fadeOutUpBig,
	flip: flip,
	flipInX: flipInX,
	flipInY: flipInY,
	flipOutX: flipOutX,
	flipOutY: flipOutY,
	lightSpeedInLeft: lightSpeedInLeft,
	lightSpeedInRight: lightSpeedInRight,
	lightSpeedOutLeft: lightSpeedOutLeft,
	lightSpeedOutRight: lightSpeedOutRight,
	rotateIn: rotateIn,
	rotateInDownLeft: rotateInDownLeft,
	rotateInDownRight: rotateInDownRight,
	rotateInUpLeft: rotateInUpLeft,
	rotateInUpRight: rotateInUpRight,
	rotateOut: rotateOut,
	rotateOutDownLeft: rotateOutDownLeft,
	rotateOutDownRight: rotateOutDownRight,
	rotateOutUpLeft: rotateOutUpLeft,
	rotateOutUpRight: rotateOutUpRight,
	slideInDown: slideInDown,
	slideInLeft: slideInLeft,
	slideInRight: slideInRight,
	slideInUp: slideInUp,
	slideOutDown: slideOutDown,
	slideOutLeft: slideOutLeft,
	slideOutRight: slideOutRight,
	slideOutUp: slideOutUp,
	hinge: hinge,
	jackInTheBox: jackInTheBox,
	rollIn: rollIn,
	rollOut: rollOut,
	zoomIn: zoomIn,
	zoomInDown: zoomInDown,
	zoomInLeft: zoomInLeft,
	zoomInRight: zoomInRight,
	zoomInUp: zoomInUp,
	zoomOut: zoomOut,
	zoomOutDown: zoomOutDown,
	zoomOutLeft: zoomOutLeft,
	zoomOutRight: zoomOutRight,
	zoomOutUp: zoomOutUp
});

// src/components/animation/animations.ts
function getAnimationNames() {
  return Object.entries(animations).filter(([name]) => name !== "easings").map(([name]) => name);
}
function getEasingNames() {
  return Object.entries(easings).map(([name]) => name);
}

var SlAnimation = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasStarted = false;
    this.name = "none";
    this.play = false;
    this.delay = 0;
    this.direction = "normal";
    this.duration = 1e3;
    this.easing = "linear";
    this.endDelay = 0;
    this.fill = "auto";
    this.iterations = Infinity;
    this.iterationStart = 0;
    this.playbackRate = 1;
    this.handleAnimationFinish = () => {
      this.play = false;
      this.hasStarted = false;
      this.emit("sl-finish");
    };
    this.handleAnimationCancel = () => {
      this.play = false;
      this.hasStarted = false;
      this.emit("sl-cancel");
    };
  }
  /** Gets and sets the current animation time. */
  get currentTime() {
    var _a, _b;
    return (_b = (_a = this.animation) == null ? void 0 : _a.currentTime) != null ? _b : 0;
  }
  set currentTime(time) {
    if (this.animation) {
      this.animation.currentTime = time;
    }
  }
  connectedCallback() {
    super.connectedCallback();
    this.createAnimation();
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.destroyAnimation();
  }
  handleSlotChange() {
    this.destroyAnimation();
    this.createAnimation();
  }
  async createAnimation() {
    var _a, _b;
    const easing = (_a = easings[this.easing]) != null ? _a : this.easing;
    const keyframes = (_b = this.keyframes) != null ? _b : animations[this.name];
    const slot = await this.defaultSlot;
    const element = slot.assignedElements()[0];
    if (!element || !keyframes) {
      return false;
    }
    this.destroyAnimation();
    this.animation = element.animate(keyframes, {
      delay: this.delay,
      direction: this.direction,
      duration: this.duration,
      easing,
      endDelay: this.endDelay,
      fill: this.fill,
      iterationStart: this.iterationStart,
      iterations: this.iterations
    });
    this.animation.playbackRate = this.playbackRate;
    this.animation.addEventListener("cancel", this.handleAnimationCancel);
    this.animation.addEventListener("finish", this.handleAnimationFinish);
    if (this.play) {
      this.hasStarted = true;
      this.emit("sl-start");
    } else {
      this.animation.pause();
    }
    return true;
  }
  destroyAnimation() {
    if (this.animation) {
      this.animation.cancel();
      this.animation.removeEventListener("cancel", this.handleAnimationCancel);
      this.animation.removeEventListener("finish", this.handleAnimationFinish);
      this.hasStarted = false;
    }
  }
  handleAnimationChange() {
    if (!this.hasUpdated) {
      return;
    }
    this.createAnimation();
  }
  handlePlayChange() {
    if (this.animation) {
      if (this.play && !this.hasStarted) {
        this.hasStarted = true;
        this.emit("sl-start");
      }
      if (this.play) {
        this.animation.play();
      } else {
        this.animation.pause();
      }
      return true;
    }
    return false;
  }
  handlePlaybackRateChange() {
    if (this.animation) {
      this.animation.playbackRate = this.playbackRate;
    }
  }
  /** Clears all keyframe effects caused by this animation and aborts its playback. */
  cancel() {
    var _a;
    (_a = this.animation) == null ? void 0 : _a.cancel();
  }
  /** Sets the playback time to the end of the animation corresponding to the current playback direction. */
  finish() {
    var _a;
    (_a = this.animation) == null ? void 0 : _a.finish();
  }
  render() {
    return x$1` <slot @slotchange=${this.handleSlotChange}></slot> `;
  }
};
SlAnimation.styles = animation_styles_default;
__decorateClass([
  e$8("slot")
], SlAnimation.prototype, "defaultSlot", 2);
__decorateClass([
  e$c()
], SlAnimation.prototype, "name", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlAnimation.prototype, "play", 2);
__decorateClass([
  e$c({ type: Number })
], SlAnimation.prototype, "delay", 2);
__decorateClass([
  e$c()
], SlAnimation.prototype, "direction", 2);
__decorateClass([
  e$c({ type: Number })
], SlAnimation.prototype, "duration", 2);
__decorateClass([
  e$c()
], SlAnimation.prototype, "easing", 2);
__decorateClass([
  e$c({ attribute: "end-delay", type: Number })
], SlAnimation.prototype, "endDelay", 2);
__decorateClass([
  e$c()
], SlAnimation.prototype, "fill", 2);
__decorateClass([
  e$c({ type: Number })
], SlAnimation.prototype, "iterations", 2);
__decorateClass([
  e$c({ attribute: "iteration-start", type: Number })
], SlAnimation.prototype, "iterationStart", 2);
__decorateClass([
  e$c({ attribute: false })
], SlAnimation.prototype, "keyframes", 2);
__decorateClass([
  e$c({ attribute: "playback-rate", type: Number })
], SlAnimation.prototype, "playbackRate", 2);
__decorateClass([
  watch([
    "name",
    "delay",
    "direction",
    "duration",
    "easing",
    "endDelay",
    "fill",
    "iterations",
    "iterationsStart",
    "keyframes"
  ])
], SlAnimation.prototype, "handleAnimationChange", 1);
__decorateClass([
  watch("play")
], SlAnimation.prototype, "handlePlayChange", 1);
__decorateClass([
  watch("playbackRate")
], SlAnimation.prototype, "handlePlaybackRateChange", 1);

// src/components/animation/animation.ts
var animation_default = SlAnimation;
SlAnimation.define("sl-animation");

var alert_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: contents;

    /* For better DX, we'll reset the margin here so the base part can inherit it */
    margin: 0;
  }

  .alert {
    position: relative;
    display: flex;
    align-items: stretch;
    background-color: var(--sl-panel-background-color);
    border: solid var(--sl-panel-border-width) var(--sl-panel-border-color);
    border-top-width: calc(var(--sl-panel-border-width) * 3);
    border-radius: var(--sl-border-radius-medium);
    font-family: var(--sl-font-sans);
    font-size: var(--sl-font-size-small);
    font-weight: var(--sl-font-weight-normal);
    line-height: 1.6;
    color: var(--sl-color-neutral-700);
    margin: inherit;
  }

  .alert:not(.alert--has-icon) .alert__icon,
  .alert:not(.alert--closable) .alert__close-button {
    display: none;
  }

  .alert__icon {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    font-size: var(--sl-font-size-large);
    padding-inline-start: var(--sl-spacing-large);
  }

  .alert--primary {
    border-top-color: var(--sl-color-primary-600);
  }

  .alert--primary .alert__icon {
    color: var(--sl-color-primary-600);
  }

  .alert--success {
    border-top-color: var(--sl-color-success-600);
  }

  .alert--success .alert__icon {
    color: var(--sl-color-success-600);
  }

  .alert--neutral {
    border-top-color: var(--sl-color-neutral-600);
  }

  .alert--neutral .alert__icon {
    color: var(--sl-color-neutral-600);
  }

  .alert--warning {
    border-top-color: var(--sl-color-warning-600);
  }

  .alert--warning .alert__icon {
    color: var(--sl-color-warning-600);
  }

  .alert--danger {
    border-top-color: var(--sl-color-danger-600);
  }

  .alert--danger .alert__icon {
    color: var(--sl-color-danger-600);
  }

  .alert__message {
    flex: 1 1 auto;
    display: block;
    padding: var(--sl-spacing-large);
    overflow: hidden;
  }

  .alert__close-button {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    font-size: var(--sl-font-size-medium);
    padding-inline-end: var(--sl-spacing-medium);
  }
`;

var toastStack = Object.assign(document.createElement("div"), { className: "sl-toast-stack" });
var SlAlert = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController$1(this, "icon", "suffix");
    this.localize = new LocalizeController(this);
    this.open = false;
    this.closable = false;
    this.variant = "primary";
    this.duration = Infinity;
  }
  firstUpdated() {
    this.base.hidden = !this.open;
  }
  restartAutoHide() {
    clearTimeout(this.autoHideTimeout);
    if (this.open && this.duration < Infinity) {
      this.autoHideTimeout = window.setTimeout(() => this.hide(), this.duration);
    }
  }
  handleCloseClick() {
    this.hide();
  }
  handleMouseMove() {
    this.restartAutoHide();
  }
  async handleOpenChange() {
    if (this.open) {
      this.emit("sl-show");
      if (this.duration < Infinity) {
        this.restartAutoHide();
      }
      await stopAnimations(this.base);
      this.base.hidden = false;
      const { keyframes, options } = getAnimation(this, "alert.show", { dir: this.localize.dir() });
      await animateTo(this.base, keyframes, options);
      this.emit("sl-after-show");
    } else {
      this.emit("sl-hide");
      clearTimeout(this.autoHideTimeout);
      await stopAnimations(this.base);
      const { keyframes, options } = getAnimation(this, "alert.hide", { dir: this.localize.dir() });
      await animateTo(this.base, keyframes, options);
      this.base.hidden = true;
      this.emit("sl-after-hide");
    }
  }
  handleDurationChange() {
    this.restartAutoHide();
  }
  /** Shows the alert. */
  async show() {
    if (this.open) {
      return void 0;
    }
    this.open = true;
    return waitForEvent$1(this, "sl-after-show");
  }
  /** Hides the alert */
  async hide() {
    if (!this.open) {
      return void 0;
    }
    this.open = false;
    return waitForEvent$1(this, "sl-after-hide");
  }
  /**
   * Displays the alert as a toast notification. This will move the alert out of its position in the DOM and, when
   * dismissed, it will be removed from the DOM completely. By storing a reference to the alert, you can reuse it by
   * calling this method again. The returned promise will resolve after the alert is hidden.
   */
  async toast() {
    return new Promise((resolve) => {
      if (toastStack.parentElement === null) {
        document.body.append(toastStack);
      }
      toastStack.appendChild(this);
      requestAnimationFrame(() => {
        this.clientWidth;
        this.show();
      });
      this.addEventListener(
        "sl-after-hide",
        () => {
          toastStack.removeChild(this);
          resolve();
          if (toastStack.querySelector("sl-alert") === null) {
            toastStack.remove();
          }
        },
        { once: true }
      );
    });
  }
  render() {
    return x$1`
      <div
        part="base"
        class=${o$9({
      alert: true,
      "alert--open": this.open,
      "alert--closable": this.closable,
      "alert--has-icon": this.hasSlotController.test("icon"),
      "alert--primary": this.variant === "primary",
      "alert--success": this.variant === "success",
      "alert--neutral": this.variant === "neutral",
      "alert--warning": this.variant === "warning",
      "alert--danger": this.variant === "danger"
    })}
        role="alert"
        aria-hidden=${this.open ? "false" : "true"}
        @mousemove=${this.handleMouseMove}
      >
        <div part="icon" class="alert__icon">
          <slot name="icon"></slot>
        </div>

        <div part="message" class="alert__message" aria-live="polite">
          <slot></slot>
        </div>

        ${this.closable ? x$1`
              <sl-icon-button
                part="close-button"
                exportparts="base:close-button__base"
                class="alert__close-button"
                name="x-lg"
                library="system"
                label=${this.localize.term("close")}
                @click=${this.handleCloseClick}
              ></sl-icon-button>
            ` : ""}
      </div>
    `;
  }
};
SlAlert.styles = alert_styles_default;
SlAlert.dependencies = { "sl-icon-button": SlIconButton };
__decorateClass([
  i$7('[part~="base"]')
], SlAlert.prototype, "base", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlAlert.prototype, "open", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlAlert.prototype, "closable", 2);
__decorateClass([
  e$c({ reflect: true })
], SlAlert.prototype, "variant", 2);
__decorateClass([
  e$c({ type: Number })
], SlAlert.prototype, "duration", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], SlAlert.prototype, "handleOpenChange", 1);
__decorateClass([
  watch("duration")
], SlAlert.prototype, "handleDurationChange", 1);
setDefaultAnimation("alert.show", {
  keyframes: [
    { opacity: 0, scale: 0.8 },
    { opacity: 1, scale: 1 }
  ],
  options: { duration: 250, easing: "ease" }
});
setDefaultAnimation("alert.hide", {
  keyframes: [
    { opacity: 1, scale: 1 },
    { opacity: 0, scale: 0.8 }
  ],
  options: { duration: 250, easing: "ease" }
});

// src/components/alert/alert.ts
var alert_default = SlAlert;
SlAlert.define("sl-alert");

// src/translations/en.ts
var translation = {
  $code: "en",
  $name: "English",
  $dir: "ltr",
  carousel: "Carousel",
  clearEntry: "Clear entry",
  close: "Close",
  copied: "Copied",
  copy: "Copy",
  currentValue: "Current value",
  error: "Error",
  goToSlide: (slide, count) => `Go to slide ${slide} of ${count}`,
  hidePassword: "Hide password",
  loading: "Loading",
  nextSlide: "Next slide",
  numOptionsSelected: (num) => {
    if (num === 0)
      return "No options selected";
    if (num === 1)
      return "1 option selected";
    return `${num} options selected`;
  },
  previousSlide: "Previous slide",
  progress: "Progress",
  remove: "Remove",
  resize: "Resize",
  scrollToEnd: "Scroll to end",
  scrollToStart: "Scroll to start",
  selectAColorFromTheScreen: "Select a color from the screen",
  showPassword: "Show password",
  slideNum: (slide) => `Slide ${slide}`,
  toggleColorFormat: "Toggle color format"
};
registerTranslation(translation);
var en_default = translation;

var badge_styles_default = i$b`
  ${component_styles_default}

  :host {
    display: inline-flex;
  }

  .badge {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    font-size: max(12px, 0.75em);
    font-weight: var(--sl-font-weight-semibold);
    letter-spacing: var(--sl-letter-spacing-normal);
    line-height: 1;
    border-radius: var(--sl-border-radius-small);
    border: solid 1px var(--sl-color-neutral-0);
    white-space: nowrap;
    padding: 0.35em 0.6em;
    user-select: none;
    cursor: inherit;
  }

  /* Variant modifiers */
  .badge--primary {
    background-color: var(--sl-color-primary-600);
    color: var(--sl-color-neutral-0);
  }

  .badge--success {
    background-color: var(--sl-color-success-600);
    color: var(--sl-color-neutral-0);
  }

  .badge--neutral {
    background-color: var(--sl-color-neutral-600);
    color: var(--sl-color-neutral-0);
  }

  .badge--warning {
    background-color: var(--sl-color-warning-600);
    color: var(--sl-color-neutral-0);
  }

  .badge--danger {
    background-color: var(--sl-color-danger-600);
    color: var(--sl-color-neutral-0);
  }

  /* Pill modifier */
  .badge--pill {
    border-radius: var(--sl-border-radius-pill);
  }

  /* Pulse modifier */
  .badge--pulse {
    animation: pulse 1.5s infinite;
  }

  .badge--pulse.badge--primary {
    --pulse-color: var(--sl-color-primary-600);
  }

  .badge--pulse.badge--success {
    --pulse-color: var(--sl-color-success-600);
  }

  .badge--pulse.badge--neutral {
    --pulse-color: var(--sl-color-neutral-600);
  }

  .badge--pulse.badge--warning {
    --pulse-color: var(--sl-color-warning-600);
  }

  .badge--pulse.badge--danger {
    --pulse-color: var(--sl-color-danger-600);
  }

  @keyframes pulse {
    0% {
      box-shadow: 0 0 0 0 var(--pulse-color);
    }
    70% {
      box-shadow: 0 0 0 0.5rem transparent;
    }
    100% {
      box-shadow: 0 0 0 0 transparent;
    }
  }
`;

var SlBadge = class extends ShoelaceElement {
  constructor() {
    super(...arguments);
    this.variant = "primary";
    this.pill = false;
    this.pulse = false;
  }
  render() {
    return x$1`
      <span
        part="base"
        class=${o$9({
      badge: true,
      "badge--primary": this.variant === "primary",
      "badge--success": this.variant === "success",
      "badge--neutral": this.variant === "neutral",
      "badge--warning": this.variant === "warning",
      "badge--danger": this.variant === "danger",
      "badge--pill": this.pill,
      "badge--pulse": this.pulse
    })}
        role="status"
      >
        <slot></slot>
      </span>
    `;
  }
};
SlBadge.styles = badge_styles_default;
__decorateClass([
  e$c({ reflect: true })
], SlBadge.prototype, "variant", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlBadge.prototype, "pill", 2);
__decorateClass([
  e$c({ type: Boolean, reflect: true })
], SlBadge.prototype, "pulse", 2);

// src/components/badge/badge.ts
var badge_default = SlBadge;
SlBadge.define("sl-badge");

var _dec$5, _dec2$4, _dec3$2, _dec4$2, _class$a, _descriptor$5, _descriptor2$3, _descriptor3$2, _descriptor4$2, _templateObject$17, _templateObject2$H, _templateObject3$q, _templateObject4$j, _templateObject5$g, _templateObject6$9, _templateObject7$6, _templateObject8$5, _templateObject9$3;
function asyncGeneratorStep$i(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$i(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$i(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$i(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _initializerDefineProperty$6(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _taggedTemplateLiteral$17(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1U(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$6(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$6(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }
/**
 * Tag is usually used in a Select with multiple=true, but there's no reason it can't go anywhere
 */
var Et2Tag = (_dec$5 = e$c({
  type: Boolean
}), _dec2$4 = e$c({
  type: String,
  reflect: true
}), _dec3$2 = t$7(), _dec4$2 = t$7(), (_class$a = class Et2Tag extends Et2Widget(tag_default) {
  static get styles() {
    return [super.styles, shoelace, i$b(_templateObject$17 || (_templateObject$17 = _taggedTemplateLiteral$17(["\n\t\t\t:host {\n\t\t\t  flex: 1 1 auto;\n\t\t\t}\n\n\t\t\t.tag--pill {\n\t\t\t  overflow: hidden;\n\t\t\t}\n\n\t\t\t::slotted(et2-image) {\n\t\t\t  height: 20px;\n\t\t\t  width: 20px;\n\t\t\t}\n\n\t\t\t.tag__prefix {\n\t\t\t  line-height: normal;\n\t\t\t}\n\t\t\t.tag__content {\n\t\t\t  padding: 0px 0.2rem;\n\t\t\t  flex: 1 2 auto;\n\t\t\t  overflow: hidden;\n\t\t\t  text-overflow: ellipsis;\n\t\t\t}\n\n\t\t\t.tag__edit {\n\t\t\t  flex: 10 1 auto;\n\t\t\t  min-width: 20ex;\n\t\t\t  width: 60ex;\n\t\t\t}\n\n\t\t\t/* Avoid button getting truncated by right side of button */\n\n\t\t\t.tag__remove {\n\t\t\t  margin-right: 0;\n\t\t\t  margin-left: 0;\n\t\t\t}\n\n\t\t\tet2-button-icon {\n\t\t\t  visibility: hidden;\n\t\t\t}\n\n\t\t\t:host(:hover) et2-button-icon {\n\t\t\t  visibility: visible;\n\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);
    _initializerDefineProperty$6(this, "editable", _descriptor$5, this);
    _initializerDefineProperty$6(this, "value", _descriptor2$3, this);
    _initializerDefineProperty$6(this, "current", _descriptor3$2, this);
    // the user has keyed into the tag (focused), but hasn't done anything yet (shows a highlight)
    _initializerDefineProperty$6(this, "isEditing", _descriptor4$2, this);
    this.pill = false;
    this.removable = true;
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }
  _styleTemplate() {
    return null;
  }
  render() {
    var content;
    if (this.isEditing) {
      content = x$1(_templateObject2$H || (_templateObject2$H = _taggedTemplateLiteral$17(["", ""])), this._editTemplate());
    } else {
      content = x$1(_templateObject3$q || (_templateObject3$q = _taggedTemplateLiteral$17(["", "\n            ", "\n            ", "\n\t\t\t"])), this._contentTemplate(), this.editable ? x$1(_templateObject4$j || (_templateObject4$j = _taggedTemplateLiteral$17(["\n                <et2-button-icon\n                        label=", "\n                        image=\"pencil\"\n                        noSubmit=\"true\"\n                        @click=", "\n                ></et2-button-icon>"])), this.egw().lang("edit"), this.startEdit) : '', this.removable ? x$1(_templateObject5$g || (_templateObject5$g = _taggedTemplateLiteral$17(["\n                        <sl-icon-button\n                                part=\"remove-button\"\n                                exportparts=\"base:remove-button__base\"\n                                name=\"x-lg\"\n                                library=\"system\"\n                                label=", "\n                                class=\"tag__remove\"\n                                @click=", "\n                                tabindex=\"-1\"\n                        ></sl-icon-button>\n                    "])), this.egw().lang('remove'), this.handleRemoveClick) : '');
    }
    return x$1(_templateObject6$9 || (_templateObject6$9 = _taggedTemplateLiteral$17(["\n            ", "\n            <span\n                    part=\"base\"\n                    class=", "\n            >\n\t\t\t\t", "\n\t\t\t", "\n      </span>\n\t\t"])), this._styleTemplate(), o$9({
      tag: true,
      'tag--editable': this.editable,
      'tag--editing': this.isEditing,
      // Types
      'tag--primary': this.variant === 'primary' || this.current,
      'tag--success': this.variant === 'success',
      'tag--neutral': this.variant === 'neutral' && !this.current,
      'tag--warning': this.variant === 'warning',
      'tag--danger': this.variant === 'danger',
      'tag--text': this.variant === 'text',
      // Sizes
      'tag--small': this.size === 'small',
      'tag--medium': this.size === 'medium',
      'tag--large': this.size === 'large',
      // Modifiers
      'tag--pill': this.pill,
      'tag--removable': this.removable
    }), this._prefixTemplate(), content);
  }
  _contentTemplate() {
    return x$1(_templateObject7$6 || (_templateObject7$6 = _taggedTemplateLiteral$17(["\n            <span part=\"content\" class=\"tag__content\">\n          <slot></slot>\n        </span>"])));
  }
  _editTemplate() {
    return x$1(_templateObject8$5 || (_templateObject8$5 = _taggedTemplateLiteral$17(["\n            <span part=\"content\" class=\"tag__content tag__edit\">\n\t\t\t\t<et2-textbox value=\"", "\"\n                             @sl-change=", "\n                             @blur=", "\n                             @mousedown=", "\n                             @click=", "\n                             @keydown=", "\n                ></et2-textbox>\n\t\t\t</span>\n\t\t"])), this.value, this.handleChange, this.stopEdit, e => e.stopPropagation(), e => e.stopPropagation(), this.handleKeyDown);
  }
  _prefixTemplate() {
    return x$1(_templateObject9$3 || (_templateObject9$3 = _taggedTemplateLiteral$17(["\n            <span part=\"prefix\" class=\"tag__prefix\">\n\t\t\t\t<slot name=\"prefix\"></slot>\n\t\t</span>"])));
  }
  startEdit(event) {
    var _this = this;
    if (event) {
      event.stopPropagation();
    }
    this.getRootNode().host.hide();
    this.isEditing = true;
    this.setAttribute("contenteditable", "true");
    this.requestUpdate();
    this.updateComplete.then( /*#__PURE__*/_asyncToGenerator$i(function* () {
      yield _this._editNode.updateComplete;
      // This stops drag and drop from interfereing with mouse edits
      _this._editNode.input.setAttribute("contenteditable", "true");
      _this._editNode.focus();
    }));
  }
  stopEdit() {
    this.isEditing = false;
    this.removeAttribute("contenteditable");
    var event = new Event("change", {
      bubbles: true
    });
    event.originalValue = this.value;
    this.dataset.original_value = this.value;
    if (!this.editable) {
      return;
    }
    this.value = this.textContent = this._editNode.value.trim();
    this.requestUpdate();
    this.updateComplete.then(() => {
      this.dispatchEvent(event);
    });
  }
  get _editNode() {
    return this.shadowRoot.querySelector('et2-textbox');
  }
  handleKeyDown(event) {
    // Consume event so it doesn't bubble up to select
    event.stopPropagation();
    if (["Tab", "Enter"].indexOf(event.key) !== -1) {
      this._editNode.blur();
    } else if (["Escape"].includes(event.key)) {
      this._editNode.value = this.value;
      this.stopEdit();
    }
  }
  handleChange(event) {}
}, (_descriptor$5 = _applyDecoratedDescriptor$6(_class$a.prototype, "editable", [_dec$5], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor2$3 = _applyDecoratedDescriptor$6(_class$a.prototype, "value", [_dec2$4], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return "";
  }
}), _descriptor3$2 = _applyDecoratedDescriptor$6(_class$a.prototype, "current", [_dec3$2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor4$2 = _applyDecoratedDescriptor$6(_class$a.prototype, "isEditing", [_dec4$2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
})), _class$a));
customElements.define("et2-tag", Et2Tag);

function asyncGeneratorStep$h(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$h(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$h(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$h(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _initializerDefineProperty$5(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _defineProperty$1T(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$5(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$5(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

// Export the Interface for TypeScript

/**
 * Base class for things that have static options
 *
 * We keep static options separate and concatenate them in to allow for extra options without
 * overwriting them when we get static options from the server
 */

var Et2StaticSelectMixin = superclass => {
  var _dec, _dec2, _class, _descriptor, _descriptor2;
  var Et2StaticSelectOptions = (_dec = t$7(), _dec2 = t$7(), (_class = class Et2StaticSelectOptions extends superclass {
    constructor() {
      super(...arguments);
      // Hold the static widget options separately so other options (like sent from server in sel_options) won't
      // conflict or be wiped out
      _initializerDefineProperty$5(this, "_static_options", _descriptor, this);
      // If widget needs to fetch options from server, we might want to wait for them
      _initializerDefineProperty$5(this, "fetchComplete", _descriptor2, this);
    }
    getUpdateComplete() {
      var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
        _this = this;
      return _asyncToGenerator$h(function* () {
        var result = yield _superprop_getGetUpdateComplete().call(_this);
        yield _this.fetchComplete;
        return result;
      })();
    }
    get select_options() {
      // @ts-ignore
      var options = super.select_options || [];
      var statics = this._static_options || [];
      if (options.length == 0) {
        return statics;
      }
      if (statics.length == 0) {
        return options;
      }
      // Merge & make sure result is unique
      return [...new Map([...options, ...(this._static_options || [])].map(item => [item.value, item])).values()];
    }
    set select_options(new_options) {
      // @ts-ignore IDE doesn't recognise property
      super.select_options = new_options;
    }
    set_static_options(new_static_options) {
      this._static_options = new_static_options;
      this.requestUpdate("select_options");

      // Shoelace select may have rejected our value due to missing option by now, so re-set it
      if (this.value && this.select && this.value !== this.select.value) {
        this.value = this.value;
      }
    }

    /**
     * Override the parent _missingOption to wait for server-side options
     * to come back before we check to see if the value is not there.
     *
     * @param {string} newValueElement
     * @protected
     */
    _missingOption(newValueElement) {
      this.fetchComplete.then(() => {
        if (this.optionSearch(newValueElement) == null) {
          super._missingOption(newValueElement);
        }
      });
    }

    /**
     * Override the parent fix_bad_value() to wait for server-side options
     * to come back before we check to see if the value is not there.
     */
    fix_bad_value() {
      this.fetchComplete.then(() => {
        // @ts-ignore Doesn't know it's an Et2Select
        if (typeof super.fix_bad_value == "function") {
          // @ts-ignore Doesn't know it's an Et2Select
          super.fix_bad_value();
        }
      });
    }
  }, (_descriptor = _applyDecoratedDescriptor$5(_class.prototype, "_static_options", [_dec], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function initializer() {
      return [];
    }
  }), _descriptor2 = _applyDecoratedDescriptor$5(_class.prototype, "fetchComplete", [_dec2], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: function initializer() {
      return Promise.resolve();
    }
  })), _class));
  return Et2StaticSelectOptions;
};

/**
 * Some options change, or are too complicated to have twice, so we get the
 * options from the server once, then keep them to use if they're needed again.
 * We use the options string to keep the different possibilities (eg. categories
 * for different apps) separate.
 *
 * @param {et2_selectbox} widget Selectbox we're looking at
 * @param {string} options_string
 * @param {Object} attrs Widget attributes (not yet fully set)
 * @param {boolean} return_promise true: always return a promise
 * @returns {Object[]|Promise<Object[]>} Array of options, or empty and they'll get filled in later, or Promise
 */
var StaticOptions = new class StaticOptionsType {
  cached_server_side(widget, type, options_string, return_promise) {
    // normalize options by removing trailing commas
    options_string = options_string.replace(/,+$/, '');
    var cache_id = widget.nodeName + '_' + options_string;
    var cache_owner = widget.egw().getCache('Et2Select');
    var cache = cache_owner[cache_id];
    if (typeof cache === 'undefined') {
      // Fetch with json instead of jsonq because there may be more than
      // one widget listening for the response by the time it gets back,
      // and we can't do that when it's queued.
      var req = widget.egw().json('EGroupware\\Api\\Etemplate\\Widget\\Select::ajax_get_options', [type, options_string, widget.value]).sendRequest();
      if (typeof cache === 'undefined') {
        cache_owner[cache_id] = req;
      }
      cache = req;
    }
    if (typeof cache.then === 'function') {
      // pending, wait for it
      var promise = cache.then(response => {
        cache = cache_owner[cache_id] = response.response[0].data || undefined;
        if (return_promise) return cache;

        // Set select_options in attributes in case we get a response before
        // the widget is finished loading (otherwise it will re-set to {})
        //widget.select_options = cache;

        // Avoid errors if widget is destroyed before the timeout
        if (widget && typeof widget.id !== 'undefined') {
          if (typeof widget.set_static_options == "function") {
            widget.set_static_options(cache);
          } else if (typeof widget.set_select_options == "function") {
            widget.set_select_options(find_select_options(widget, {}, cache));
          }
        }
      });
      return return_promise ? promise : [];
    } else {
      // Check that the value is in there
      // Make sure we are not requesting server for an empty value option or
      // other widgets but select-timezone as server won't find anything and
      // it will fall into an infinitive loop, e.g. select-cat widget.
      if (widget.value && widget.value != "" && widget.value != "0" && type == "select-timezone") {
        var missing_option = true;
        for (var i = 0; i < cache.length && missing_option; i++) {
          if (cache[i].value == widget.value) {
            missing_option = false;
          }
        }
        // Try again - ask the server with the current value this time
        if (missing_option) {
          delete cache_owner[cache_id];
          return this.cached_server_side(widget, type, options_string);
        } else {
          if (widget.value && widget && widget.get_value() !== widget.value) {
            egw.window.setTimeout(function () {
              // Avoid errors if widget is destroyed before the timeout
              if (this.widget && typeof this.widget.id !== 'undefined') {
                this.widget.set_value(this.widget.options.value);
              }
            }.bind({
              widget: widget
            }), 1);
          }
        }
      }
      return return_promise ? Promise.resolve(cache) : cache;
    }
  }
  cached_from_file(widget, file) {
    var cache_owner = widget.egw().getCache('Et2Select');
    var cache = cache_owner[file];
    if (typeof cache === 'undefined') {
      cache_owner[file] = cache = widget.egw().window.fetch(file).then(response => {
        // Get the options
        if (!response.ok) {
          throw response;
        }
        return response.json();
      }).then(options => {
        var _cleanSelectOptions;
        // Need to clean the options because file may be key=>value, may have option list, may be mixed
        cache_owner[file] = (_cleanSelectOptions = cleanSelectOptions(options)) !== null && _cleanSelectOptions !== void 0 ? _cleanSelectOptions : [];
        return cache_owner[file];
      });
    } else if (cache && typeof cache.then === "undefined") {
      return Promise.resolve(cache);
    }
    return cache;
  }
  priority(widget) {
    return [{
      value: "1",
      label: 'low'
    }, {
      value: "2",
      label: 'normal'
    }, {
      value: "3",
      label: 'high'
    }, {
      value: "0",
      label: 'undefined'
    }];
  }
  bool(widget) {
    return [{
      value: "0",
      label: 'no'
    }, {
      value: "1",
      label: 'yes'
    }];
  }
  month(widget) {
    return [{
      value: "1",
      label: 'January'
    }, {
      value: "2",
      label: 'February'
    }, {
      value: "3",
      label: 'March'
    }, {
      value: "4",
      label: 'April'
    }, {
      value: "5",
      label: 'May'
    }, {
      value: "6",
      label: 'June'
    }, {
      value: "7",
      label: 'July'
    }, {
      value: "8",
      label: 'August'
    }, {
      value: "9",
      label: 'September'
    }, {
      value: "10",
      label: 'October'
    }, {
      value: "11",
      label: 'November'
    }, {
      value: "12",
      label: 'December'
    }];
  }
  number(widget) {
    var _ref, _attrs$min, _ref2, _attrs$max, _ref3, _attrs$interval, _attrs$format;
    var attrs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var options = [];
    var min = parseFloat((_ref = (_attrs$min = attrs.min) !== null && _attrs$min !== void 0 ? _attrs$min : widget.min) !== null && _ref !== void 0 ? _ref : 1);
    var max = parseFloat((_ref2 = (_attrs$max = attrs.max) !== null && _attrs$max !== void 0 ? _attrs$max : widget.max) !== null && _ref2 !== void 0 ? _ref2 : 10);
    var interval = parseFloat((_ref3 = (_attrs$interval = attrs.interval) !== null && _attrs$interval !== void 0 ? _attrs$interval : widget.interval) !== null && _ref3 !== void 0 ? _ref3 : 1);
    var format = (_attrs$format = attrs.format) !== null && _attrs$format !== void 0 ? _attrs$format : '%d';

    // leading zero specified in interval
    if (widget.leading_zero && widget.leading_zero[0] == '0') {
      format = '%0' + ('' + interval).length + 'd';
    }
    // Suffix
    if (widget.suffix) {
      format += widget.egw().lang(widget.suffix);
    }

    // Avoid infinite loop if interval is the wrong direction
    if (min <= max != interval > 0) {
      interval = -interval;
    }
    for (var i = 0, n = min; n <= max && i <= 100; n += interval, ++i) {
      options.push({
        value: "" + n,
        label: sprintf(format, n)
      });
    }
    return options;
  }
  percent(widget) {
    return this.number(widget, {
      min: 0,
      max: 100,
      interval: 10,
      format: "%d%%"
    });
  }
  year(widget, attrs) {
    var _ref4, _attrs$min2, _ref5, _attrs$max2;
    if (typeof attrs != 'object') {
      attrs = {};
    }
    var t = new Date();
    attrs.min = t.getFullYear() + parseInt((_ref4 = (_attrs$min2 = attrs.min) !== null && _attrs$min2 !== void 0 ? _attrs$min2 : widget.min) !== null && _ref4 !== void 0 ? _ref4 : -3);
    attrs.max = t.getFullYear() + parseInt((_ref5 = (_attrs$max2 = attrs.max) !== null && _attrs$max2 !== void 0 ? _attrs$max2 : widget.max) !== null && _ref5 !== void 0 ? _ref5 : 2);
    return this.number(widget, attrs);
  }
  day(widget, attrs) {
    return this.number(widget, {
      min: 1,
      max: 31,
      interval: 1
    });
  }
  hour(widget, attrs) {
    var options = [];
    var timeformat = widget.egw().preference('common', 'timeformat');
    for (var h = 0; h <= 23; ++h) {
      options.push({
        value: "" + h,
        label: timeformat == 12 ? (12 ? h % 12 : 12) + ' ' + (h < 12 ? egw.lang('am') : egw.lang('pm')) : sprintf('%02d', h)
      });
    }
    return options;
  }
  app(widget, attrs) {
    var options = ',' + (attrs.other || []).join(',');
    return this.cached_server_side(widget, 'select-app', options, true);
  }
  cat(widget) {
    var options = [widget.globalCategories, /*?*/, widget.application, widget.parentCat];
    if (typeof options[3] == 'undefined') {
      options[3] = widget.application ||
      // When the widget is first created, it doesn't have a parent and can't find it's instanceManager
      widget.getInstanceManager() && widget.getInstanceManager().app || widget.egw().app_name();
    }
    return this.cached_server_side(widget, 'select-cat', options.join(','), true);
  }
  country(widget, attrs, return_promise) {
    var options = ',';
    return this.cached_server_side(widget, 'select-country', options, return_promise);
  }
  state(widget, attrs) {
    var options = attrs.country_code ? attrs.country_code : 'de';
    return this.cached_server_side(widget, 'select-state', options, true);
  }
  dow(widget, attrs) {
    var options = (widget.rows || "") + ',' + (attrs.other || []).join(',');
    return this.cached_server_side(widget, 'select-dow', options, true);
  }
  lang(widget, attrs) {
    var options = ',' + (attrs.other || []).join(',');
    return this.cached_server_side(widget, 'select-lang', options);
  }
  timezone(widget, attrs) {
    var options = ',' + (attrs.other || []).join(',');
    return this.cached_server_side(widget, 'select-timezone', options, true);
  }
}();

/**
 * Waits for a specific event to be emitted from an element. Ignores events that bubble up from child elements.
 *
 * Copied from Shoelace
 * /src/internal/event.ts
 */
function waitForEvent(el, eventName) {
  return new Promise(resolve => {
    function done(event) {
      if (event.target === el) {
        el.removeEventListener(eventName, done);
        resolve();
      }
    }
    el.addEventListener(eventName, done);
  });
}

var _templateObject$16, _templateObject2$G, _templateObject3$p, _templateObject4$i, _templateObject5$f, _templateObject6$8, _templateObject7$5, _templateObject8$4;
function asyncGeneratorStep$g(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$g(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$g(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$g(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _taggedTemplateLiteral$16(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$Y(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$X(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$Y(Object(source), true).forEach(function (key) { _defineProperty$1S(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$Y(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1S(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Otherwise import gets stripped
var keep_import$1;

// Export the Interface for TypeScript

/**
 * Base class for things that do search type behaviour
 * Separated to keep things a little simpler.
 *
 * Currently I assume we're extending an Et2Select, so changes may need to be made for better abstraction
 */
var Et2WithSearchMixin = dedupeMixin(superclass => {
  class Et2WidgetWithSearch extends superclass {
    static get properties() {
      return _objectSpread$X(_objectSpread$X({}, super.properties), {}, {
        search: {
          type: Boolean,
          reflect: true
        },
        searchUrl: {
          type: String
        },
        /**
         * Allow custom entries that are not in the options
         */
        allowFreeEntries: {
          type: Boolean,
          reflect: true
        },
        /**
         * Additional search parameters that are passed to the server
         * when we query searchUrl
         */
        searchOptions: {
          type: Object
        },
        /**
         * Allow editing tags by clicking on them.
         * allowFreeEntries must be true
         */
        editModeEnabled: {
          type: Boolean
        }
      });
    }
    static get styles() {
      return [
      // @ts-ignore
      ...(super.styles ? Symbol.iterator in Object(super.styles) ? super.styles : [super.styles] : []), i$b(_templateObject$16 || (_templateObject$16 = _taggedTemplateLiteral$16(["\n\n\t\t\t\t/* Full width search textbox covers loading spinner, lift it up */\n\t\t\t\t::slotted(sl-spinner) {\n\t\t\t\t\tz-index: 2;\n\t\t\t\t}\n\n\t\t\t\t/* Show edit textbox only when editing */\n\t\t\t\t.search_input #edit {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t}\n\t\t\t\t.search_input.editing #search {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t}\n\t\t\t\t.search_input.editing #edit {\n\t\t\t\t\tdisplay: initial;\n\t\t\t\t}\n\n\n\t\t\t\t  :host([search]) sl-select[open]::part(prefix), :host([allowfreeentries]) sl-select[open]::part(prefix) {\n\t\t\t\t\torder: 9;\n\t\t\t\t\tflex: 2 1 auto;\n\t\t\t\t\tflex-wrap: wrap;\n\t\t\t\t\twidth: 100%;\n\t\t\t\t}\n\n\t\t\t\t  :host([search]) sl-select[open]::part(display-input), :host([allowfreeentries]) sl-select[open]::part(display-input) {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t}\n\n\t\t\t\t  :host([search]) sl-select[open]::part(expand-icon) {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t  }\n\n\t\t\t\t  sl-select[open][multiple]::part(tags) {\n\t\t\t\t\tflex-basis: 100%;\n\t\t\t\t  }\n\n\t\t\t\t  sl-select[open][multiple]::part(combobox) {\n\t\t\t\t\tflex-flow: wrap;\n\t\t\t\t  }\n\n\n\t\t\t\t  /* Search textbox general styling, starts hidden */\n\n\t\t\t\t  .search_input {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t\t/* See also etemplate2.css, searchbox border turned off in there */\n\t\t\t\t\tborder: none;\n\t\t\t\t\tflex: 1 1 auto;\n\t\t\t\t\torder: 2;\n\t\t\t\t\tmargin-left: 0px;\n\t\t\t\t\theight: var(--sl-input-height-medium);\n\t\t\t\t\twidth: 100%;\n\t\t\t\t\tbackground-color: white;\n\t\t\t\t\tz-index: var(--sl-z-index-dropdown);\n\t\t\t\t  }\n\n\t\t\t\t  :host([search]) et2-textbox::part(base) {\n\t\t\t\t\tborder: none;\n\t\t\t\t\tbox-shadow: none;\n\t\t\t\t  }\n\n\t\t\t\t  /* Search UI active - show textbox & stuff */\n\n\t\t\t\t  .search_input.active,\n\t\t\t\t  .search_input.editing {\n\t\t\t\t\tdisplay: flex;\n\t\t\t\t  }\n\n\t\t\t\t  /* If multiple and no value, overlap search onto widget instead of below */\n\n\t\t\t\t  :host([multiple]) .search_input.active.novalue {\n\t\t\t\t\ttop: 0px;\n\t\t\t\t  }\n\t\t\t\t\n\t\t\t\t/* Hide options that do not match current search text */\n\n\t\t\t\t  :host([search]) sl-option.no-match {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t}\n\t\t\t\t/* Different cursor for editable tags */\n\t\t\t\t:host([allowfreeentries]):not([readonly]) .search_tag::part(base)  {\n\t\t\t\t\tcursor: text;\n\t\t\t\t}\n\t\t\t\t\n\t\t\t\t/** Readonly **/\n\t\t\t\t/* No border */\n\t\t\t\t:host([readonly]) .form-control-input {\n\t\t\t\t\tborder: none;\n\t\t\t\t}\n\t\t\t\t/* disable focus border */\n\t\t\t\t:host([readonly]) .form-control-input:focus-within {\n\t\t\t\t\tbox-shadow: none;\n\t\t\t\t}\n\t\t\t\t/* normal cursor */\n\t\t\t\t:host([readonly]) .select__control {\n\t\t\t\t\tcursor: initial;\n\t\t\t\t}\n\t\t\t\t"])))];
    }

    // Borrowed from Lion ValidatorMixin, but we don't want the whole thing

    constructor() {
      super(...arguments);
      _defineProperty$1S(this, "defaultValidators", void 0);
      _defineProperty$1S(this, "validators", void 0);
      _defineProperty$1S(this, "_searchTimeout", void 0);
      // Hold the original option data from earlier search results, since we discard on subsequent search
      _defineProperty$1S(this, "_selected_remote", []);
      // Hold current search results, selected or otherwise
      _defineProperty$1S(this, "_remote_options", []);
      _defineProperty$1S(this, "_total_result_count", 0);
      _defineProperty$1S(this, "_searchPromise", null);
      this.search = false;
      this.searchUrl = "";
      this.searchOptions = {
        app: "addressbook"
      };
      this.allowFreeEntries = false;
      this.editModeEnabled = false;

      // Hiding the selected options from the dropdown means we can't un-select the tags
      // hidden by the max limit.  Prefer no limit.
      this.maxOptionsVisible = -1;
      this.validators = [];
      /**
       * Used by Subclassers to add default Validators.
       * A email input for instance, always needs the isEmail validator.
       * @example
       * ```js
       * this.defaultValidators.push(new IsDate());
       * ```
       * @type {Validator[]}
       */
      this.defaultValidators = [];
      this.handleOptionClick = this.handleOptionClick.bind(this);
      this._handleChange = this._handleChange.bind(this);
      this.handleTagEdit = this.handleTagEdit.bind(this);
      this._handleAfterShow = this._handleAfterShow.bind(this);
      this._handleMenuHide = this._handleMenuHide.bind(this);
      this._handleSearchBlur = this._handleSearchBlur.bind(this);
      this._handleClear = this._handleClear.bind(this);
      this._handleDoubleClick = this._handleDoubleClick.bind(this);
      this._handleSearchAbort = this._handleSearchAbort.bind(this);
      this._handleSearchClear = this._handleSearchClear.bind(this);
      this._handleSearchChange = this._handleSearchChange.bind(this);
      this._handleSearchKeyDown = this._handleSearchKeyDown.bind(this);
      this._handleSearchMouseDown = this._handleSearchMouseDown.bind(this);
      this._handleEditKeyDown = this._handleEditKeyDown.bind(this);
      this._handlePaste = this._handlePaste.bind(this);
    }
    connectedCallback() {
      super.connectedCallback();
      this.classList.toggle("search", this.searchEnabled);

      // Missing any of the required attributes?  Don't change anything.
      // If readonly, skip it
      if (!this.searchEnabled && !this.editModeEnabled && !this.allowFreeEntries || this.readonly) {
        return;
      }
      this._bindListeners();
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this._unbindListeners();
    }
    getUpdateComplete() {
      var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
        _this = this;
      return _asyncToGenerator$g(function* () {
        var result = _superprop_getGetUpdateComplete().call(_this);
        if (_this._searchInputNode) {
          yield _this._searchInputNode.updateComplete;
        }
        return result;
      })();
    }
    willUpdate(changedProperties) {
      super.willUpdate(changedProperties);

      // Turn on search if there's more than 20 options
      if (changedProperties.has("select_options") && this.select_options.length > 20) {
        this.search = true;
      }

      // If searchURL is set, turn on search
      if (changedProperties.has("searchUrl") && this.searchUrl) {
        this.search = true;
        // Decode URL, possibly again.  If set in template, it can wind up double-encoded.
        this.searchUrl = this.egw().decodePath(this.searchUrl);
      }

      // Add missing options if search or free entries enabled
      if (changedProperties.has("value") && this.value) {
        // Overridden to add options if allowFreeEntries=true
        if (this.allowFreeEntries && typeof this.value == "string" && !this.select_options.find(o => o.value == this.value && (!o.class || o.class && !o.class.includes('remote')))) {
          this.createFreeEntry(this.value);
        } else if (this.allowFreeEntries && this.multiple) {
          this.getValueAsArray().forEach(e => {
            if (!this.select_options.find(o => o.value == e)) {
              this.createFreeEntry(e);
            }
          });
        }
        if (this.searchEnabled) {
          // Check to see if value is for an option we do not have
          for (var newValueElement of this.getValueAsArray()) {
            if (this.optionSearch(newValueElement)) {
              continue;
            }
            this._missingOption(newValueElement);
          }
        }
      }
    }
    update(changedProperties) {
      super.update(changedProperties);

      // One of the key properties has changed, need to add the needed nodes
      if (changedProperties.has("search") || changedProperties.has("editModeEnabled") || changedProperties.has("allowFreeEntries")) {
        this._unbindListeners();
        // Missing any of the required attributes?  Now we need to take it out.
        if (!this.searchEnabled && !this.editModeEnabled && !this.allowFreeEntries || this.readonly) {
          var _this$querySelector;
          (_this$querySelector = this.querySelector(".search_input")) === null || _this$querySelector === void 0 || _this$querySelector.remove();
          return;
        }

        // Listeners may have been skipped from connectedCallback()
        this._bindListeners();
      }
      // Update any tags if edit mode changes
      if (changedProperties.has("editModeEnabled") || changedProperties.has("readonly")) {
        // Required because we explicitly create tags instead of doing it in render()
        this.shadowRoot.querySelectorAll(".select__tags > *").forEach(tag => {
          tag.editable = this.editModeEnabled && !this.readonly;
          tag.removable = !this.readonly;
        });
        if (this.readonly) {
          this._unbindListeners();
        }
      }
    }
    _extraTemplate() {
      if (!this.searchEnabled && !this.editModeEnabled && !this.allowFreeEntries || this.readonly) {
        return A$1;
      }
      return x$1(_templateObject2$G || (_templateObject2$G = _taggedTemplateLiteral$16(["\n                ", "\n                ", "\n                ", "\n\t\t\t"])), this._searchInputTemplate(), m$1(this._moreResultsTemplate(), A$1), this._noResultsTemplate());
    }
    _moreResultsTemplate() {
      var _this2 = this;
      return _asyncToGenerator$g(function* () {
        if (_this2._total_result_count <= 0 || !_this2.select || !_this2._searchPromise) {
          return A$1;
        }
        return _this2._searchPromise.then(() => {
          var _this2$select;
          var moreCount = _this2._total_result_count - ((_this2$select = _this2.select) === null || _this2$select === void 0 ? void 0 : _this2$select.querySelectorAll("sl-option.match").length);
          var more = _this2.egw().lang("%1 more...", moreCount);
          return x$1(_templateObject3$p || (_templateObject3$p = _taggedTemplateLiteral$16(["<span class=\"more\">", "</span>"])), more);
        });
      })();
    }
    _searchInputTemplate() {
      var edit = A$1;
      if (this.editModeEnabled) {
        edit = x$1(_templateObject4$i || (_templateObject4$i = _taggedTemplateLiteral$16(["<input id=\"edit\" type=\"text\" part=\"input\" autocomplete=\"off\" style=\"width:100%\"\n                                   @keydown=", "\n                                   @click=", "\n                                   @blur=", "\n                />"])), this._handleEditKeyDown, e => e.stopPropagation(), this.stopEdit.bind(this));
      }
      return x$1(_templateObject5$f || (_templateObject5$f = _taggedTemplateLiteral$16(["\n                <div class=\"search_input\" slot=\"prefix\">\n                <et2-textbox id=\"search\" type=\"text\" part=\"input\"\n                             exportparts=\"base:search__base\"\n                             clearable\n                             autocomplete=\"off\"\n                             tabindex=\"-1\"\n                             placeholder=\"", "\"\n                             style=\"flex: 1 1 auto;\"\n                             @mousedown=", "\n                             @keydown=", "\n                             @blur=", "\n                             @sl-clear=", "\n                             @sl-change=", "\n                ></et2-textbox>\n                ", "\n                </div>\n\t\t\t"])), this.egw().lang("search"), this._handleSearchMouseDown, this._handleSearchKeyDown, this._handleSearchBlur, this._handleSearchClear, this._handleSearchChange, edit);
    }
    _noResultsTemplate() {
      var _this$_searchInputNod;
      if (this._total_result_count !== 0 || !((_this$_searchInputNod = this._searchInputNode) !== null && _this$_searchInputNod !== void 0 && _this$_searchInputNod.value)) {
        return A$1;
      }
      var noSuggestions = x$1(_templateObject6$8 || (_templateObject6$8 = _taggedTemplateLiteral$16(["\n                <div class=\"no-results\">", "</div>"])), this.egw().lang("no suggestions"));
      if (!this._searchPromise) {
        return noSuggestions;
      }
      var noResults = this._searchPromise.then(() => {
        return this._total_result_count == 0 ? noSuggestions : A$1;
      });
      return x$1(_templateObject7$5 || (_templateObject7$5 = _taggedTemplateLiteral$16(["", ""])), m$1(noResults, x$1(_templateObject8$4 || (_templateObject8$4 = _taggedTemplateLiteral$16(["\n                    <sl-spinner></sl-spinner>"])))));
    }

    /**
     * Do we have the needed properties set, so we can actually do searching
     *
     * @returns {boolean}
     */
    get searchEnabled() {
      return !this.readonly && (this.search || this.searchUrl.length > 0);
    }
    get _searchInputNode() {
      var _this$_activeControls;
      return (_this$_activeControls = this._activeControls) === null || _this$_activeControls === void 0 ? void 0 : _this$_activeControls.querySelector("#search");
    }
    get _editInputNode() {
      var _this$_activeControls2;
      return (_this$_activeControls2 = this._activeControls) === null || _this$_activeControls2 === void 0 ? void 0 : _this$_activeControls2.querySelector("input#edit");
    }
    get _activeControls() {
      var _this$shadowRoot;
      return ((_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector(".search_input")) || this.querySelector(".search_input");
    }
    get optionTag() {
      return 'sl-option';
    }

    /**
     * Only local options, excludes server options
     *
     * @protected
     */
    get localItems() {
      return this.select.querySelectorAll(this.optionTag + ":not(.remote)");
    }

    /**
     * Only remote options from search results
     * @returns {NodeList}
     * @protected
     */
    get remoteItems() {
      var _this$select$querySel, _this$select;
      return (_this$select$querySel = (_this$select = this.select) === null || _this$select === void 0 ? void 0 : _this$select.querySelectorAll(this.optionTag + ".remote")) !== null && _this$select$querySel !== void 0 ? _this$select$querySel : [];
    }

    /**
     * Only free entries
     * @returns {NodeList}
     * @protected
     */
    get freeEntries() {
      var _this$select$querySel2, _this$select2;
      return (_this$select$querySel2 = (_this$select2 = this.select) === null || _this$select2 === void 0 ? void 0 : _this$select2.querySelectorAll(this.optionTag + ".freeEntry")) !== null && _this$select$querySel2 !== void 0 ? _this$select$querySel2 : [];
    }
    get select_options() {
      var _this$__select_option, _this$_selected_remot, _this$_remote_options;
      var options = [];

      // Any provided options
      options = options.concat((_this$__select_option = this.__select_options) !== null && _this$__select_option !== void 0 ? _this$__select_option : []);

      // Any kept remote options
      options = options.concat((_this$_selected_remot = this._selected_remote) !== null && _this$_selected_remot !== void 0 ? _this$_selected_remot : []);

      // Current search results
      options = options.concat((_this$_remote_options = this._remote_options) !== null && _this$_remote_options !== void 0 ? _this$_remote_options : []);
      if (this.allowFreeEntries) {
        this.freeEntries.forEach(item => {
          if (!options.some(i => i.value == item.value.replaceAll("___", " "))) {
            options.push({
              value: item.value,
              label: item.textContent,
              class: item.classList.toString()
            });
          }
        });
      }
      return options;
    }
    set select_options(options) {
      var _this3 = this;
      super.select_options = options;

      // Remove any selected remote, they're real options now
      var _loop = function _loop() {
        var remote = _this3._selected_remote[remote_index];
        if (options.findIndex(o => o.value == remote.value) != -1) {
          var _this3$querySelector;
          _this3._selected_remote.splice(remote_index, 1);
          (_this3$querySelector = _this3.querySelector('[value="' + remote.value + '"]')) === null || _this3$querySelector === void 0 || _this3$querySelector.classList.remove("remote");
        }
      };
      for (var remote_index = this._selected_remote.length - 1; remote_index >= 0; remote_index--) {
        _loop();
      }
    }
    get value() {
      return super.value;
    }
    set value(new_value) {
      super.value = new_value;
      if (!new_value || !this.allowFreeEntries && !this.searchUrl) {
        return;
      }

      // If widget is currently open, we may need to re-calculate search / dropdown positioning
      if (this.isOpen) {
        this._handleMenuShow();
      }
    }

    /**
     * Some [part of a] value is missing from the available options, but should be there, so find and add it.
     *
     * This is used when not all options are sent to the client (search, link list).  Ideally we want to send
     * the options for the current value, but sometimes this is not the best option so here we search or create
     * the option as needed.  These are not free entries, but need to match some list somewhere.
     *
     * @param {string} newValueElement
     * @protected
     */
    _missingOption(newValueElement) {
      // Given a value we need to search for - this will add in all matches, including the one needed
      this.remoteSearch(newValueElement, this.searchOptions).then(result => {
        // Re-set / update value since SlSelect probably removed it by now due to missing option
        if (typeof this.select != "undefined") {
          var _this$shoelaceValue;
          this.select.value = (_this$shoelaceValue = this.shoelaceValue) !== null && _this$shoelaceValue !== void 0 ? _this$shoelaceValue : this.value;
          this.select.requestUpdate("value");
        }
        this.requestUpdate("value");
      });
    }
    fix_bad_value() {
      if (!this.allowFreeEntries && !this.searchEnabled) {
        // Let regular select deal with it
        return false;
      }
      var valueArray = Array.isArray(this.value) ? this.value : !this.value ? [] : this.value.toString().split(',');

      // Check any already found options
      if (Object.values(this.getAllOptions()).filter(option => valueArray.find(val => val == option.value)).length === 0) {
        return false;
      }
      return true;
      // TODO? Should we check the server, or just be OK with it?  Passing the "current" value in sel_options makes sure the value is there
    }

    _bindListeners() {
      this.addEventListener("sl-clear", this._handleClear);
      this.addEventListener("sl-show", this._handleMenuShow);
      this.addEventListener("sl-after-show", this._handleAfterShow);
      this.addEventListener("sl-hide", this._handleMenuHide);

      // Need our own change to catch the change event from search input
      this.addEventListener("change", this._handleChange);
      if (this.allowFreeEntries) {
        this.addEventListener("paste", this._handlePaste);
      }
      this.updateComplete.then(() => {
        var _this$_searchInputNod2, _this$_searchInputNod3;
        // Search messes up event order.  Since it throws its own bubbling change event,
        // selecting an option fires 2 change events - 1 before the widget is finished adjusting, losing the value
        // We catch all change events, then call this._oldChange only when value changes
        this.removeEventListener("change", this._oldChange);
        (_this$_searchInputNod2 = this._searchInputNode) === null || _this$_searchInputNod2 === void 0 || _this$_searchInputNod2.removeEventListener("change", this._searchInputNode.handleChange);
        (_this$_searchInputNod3 = this._searchInputNode) === null || _this$_searchInputNod3 === void 0 || _this$_searchInputNod3.addEventListener("change", this._handleSearchChange);

        //		this.dropdown.querySelector('.select__label').addEventListener("change", this.handleTagEdit);
      });
    }

    _unbindListeners() {
      var _this$_searchInputNod4;
      this.removeEventListener("sl-select", this._handleSelect);
      this.removeEventListener("sl-show", this._handleMenuShow);
      this.removeEventListener("sl-after-show", this._handleAfterShow);
      this.removeEventListener("sl-hide", this._handleMenuHide);
      this.removeEventListener("sl-clear", this._handleClear);
      this.removeEventListener("change", this._handleChange);
      this.removeEventListener("paste", this._handlePaste);
      (_this$_searchInputNod4 = this._searchInputNode) === null || _this$_searchInputNod4 === void 0 || _this$_searchInputNod4.removeEventListener("change", this._handleSearchChange);
    }
    _handleMenuShow() {
      var _this$_activeControls3;
      if (this.readonly) {
        return;
      }
      this.setAttribute("open", "");

      // Move search (& menu) if there's no value
      (_this$_activeControls3 = this._activeControls) === null || _this$_activeControls3 === void 0 || _this$_activeControls3.classList.toggle("novalue", this.multiple && this.value == '' || !this.multiple);

      // Reset for parent calculations, will be adjusted after if needed
      //this.dropdown.setAttribute("distance", 0);

      if (this.searchEnabled || this.allowFreeEntries) {
        var _this$_activeControls4;
        (_this$_activeControls4 = this._activeControls) === null || _this$_activeControls4 === void 0 || _this$_activeControls4.classList.add("active");
        // Hide edit explicitly since it's so hard via CSS
        if (this._editInputNode) {
          this._editInputNode.style.display = "none";
        }
      }
      if (this.editModeEnabled && this.allowFreeEntries && !this.multiple && this.value) {
        this.startEdit();
        this._editInputNode.select();
        // Hide search explicitly since it's so hard via CSS
        this._searchInputNode.style.display = "none";
      }
    }

    /**
     * Focus the search input after showing the dropdown so user can just type.
     *
     * Timeout is needed for some systems to properly focus
     */
    _handleAfterShow() {
      if (this.searchEnabled || this.allowFreeEntries) {
        window.setTimeout(() => {
          this._searchInputNode.focus();
          this._searchInputNode.select();
        }, 100);
      }
    }
    focus() {
      this.show().then(() => {
        var _this$_searchInputNod5;
        (_this$_searchInputNod5 = this._searchInputNode) === null || _this$_searchInputNod5 === void 0 || _this$_searchInputNod5.focus();
      });
    }
    _handleMenuHide() {
      var _this$_activeControls5;
      if (this.readonly) {
        return;
      }
      this.removeAttribute("open");
      waitForEvent(this, "sl-after-hide").then(() => this.clearSearch());

      // Reset display
      if (this._searchInputNode) {
        this._searchInputNode.style.display = "";
      }
      if (this._editInputNode) {
        this._editInputNode.style.display = "";
      }
      (_this$_activeControls5 = this._activeControls) === null || _this$_activeControls5 === void 0 || _this$_activeControls5.classList.remove("active");
    }
    _triggerChange(event) {
      // Don't want searchbox events to trigger change event
      if (event.target == this._searchInputNode) {
        event.stopImmediatePropagation();
        event.preventDefault();
        return false;
      }

      // Find and keep any selected remote entries
      // Doing it here catches keypress changes too
      this._keepSelectedRemote();
      return true;
    }
    _handleChange(event) {
      if (event.target == this._searchInputNode) {
        event.stopImmediatePropagation();
        event.preventDefault();
        return false;
      }
      return this._oldChange(event);
    }
    _handleDoubleClick(event) {
      // No edit (shouldn't happen...)
      if (!this.editModeEnabled) {
        return;
      }

      // Find the tag
      var path = event.composedPath();
      var tag = path.find(el => el instanceof Et2Tag);
      this.hide();
      this.updateComplete.then(() => {
        tag.startEdit(event);
      });
    }
    _keepSelectedRemote() {
      this.select.querySelectorAll("[aria-selected=true].remote").forEach(node => {
        var value = node.value.replaceAll("___", " ");
        if (!node.selected || this._selected_remote.some(o => o.value == value)) {
          return;
        }
        var filter = options => {
          for (var i = options.length - 1; i >= 0; i--) {
            if (Array.isArray(options[i].value)) {
              filter(options[i].value);
            } else if (options[i].value == value) {
              this._selected_remote.push(options[i]);
              options.splice(i, 1);
            }
          }
        };
        filter(this._remote_options);
      });
    }
    /**
     * An option was selected
     */
    handleOptionClick(event) {
      // Only interested in option clicks, but handler is bound higher
      if (event.target.tagName !== "SL-OPTION") {
        return;
      }
      if (typeof super.handleOptionClick == "function") super.handleOptionClick(event);
      this.updateComplete.then(() => {
        // If they just chose one from the list, re-focus the search
        if (this.multiple && this.searchEnabled) {
          this._searchInputNode.focus();
          this._searchInputNode.select();
        } else if (!this.multiple && this.searchEnabled) {
          // Stop all the search stuff when they select an option
          // this shows all non-matching options again
          this._handleSearchAbort(event);
        }
      });
    }

    /**
     * Value was cleared
     */
    _handleClear(e) {
      // Only keep remote options that are still used
      this._selected_remote = this._selected_remote.filter(option => this.value.indexOf(option.value) !== -1);
      if (!this.multiple && this.searchEnabled) {
        this._handleSearchAbort(e);
      }
    }

    /**
     * Handle blur from search field
     *
     * Either the user changed fields, or selected an option.  For selecting don't interfere, but for
     * changing fields we need to make sure the menu is hidden.
     *
     * @param event
     */
    _handleSearchBlur(event) {
      var _this4 = this;
      return _asyncToGenerator$g(function* () {
        event.stopPropagation();
        clearTimeout(_this4._searchTimeout);
      })();
    }

    /**
     * Handle keypresses inside the search input
     * @param {KeyboardEvent} event
     * @protected
     */
    _handleSearchKeyDown(event) {
      var _this$_activeControls6,
        _this5 = this;
      clearTimeout(this._searchTimeout);
      (_this$_activeControls6 = this._activeControls) === null || _this$_activeControls6 === void 0 || _this$_activeControls6.classList.add("active");

      // Pass off some keys to select
      if (['ArrowDown', 'ArrowUp', 'Home', 'End'].includes(event.key)) {
        // Strip out hidden non-matching selected & disabled items so key navigation works
        // TODO
        return;
      } else if (event.key == "Tab" && !this._searchInputNode.value) {
        // Mess with tabindexes to allow focus to easily go to next control
        var input = this.select.shadowRoot.querySelector('[tabindex="0"]');
        input.setAttribute("tabindex", "-1");
        this.updateComplete.then(() => {
          // Set it back so we can get focus again later
          input.setAttribute("tabindex", "0");
        });
        // Allow to propagate
        return;
      }
      event.stopPropagation();

      // Don't allow event to bubble or it will interact with select
      event.stopImmediatePropagation();
      if (Et2WidgetWithSearch.TAG_BREAK.indexOf(event.key) !== -1 && this.allowFreeEntries && this.createFreeEntry(this._searchInputNode.value)) {
        event.preventDefault();
        this._searchInputNode.value = "";
        this.updateComplete.then( /*#__PURE__*/_asyncToGenerator$g(function* () {
          // update sizing / position before getting ready for another one
          if (_this5.multiple) {
            //	await this.show();
            _this5._searchInputNode.focus();
          }
        }));
      } else if (event.key == "Enter") {
        event.preventDefault();
        this.startSearch();
        return;
      } else if (event.key == "Escape") {
        this._handleSearchAbort(event);
        this.hide();
        return;
      }

      // Start the search automatically if they have enough letters
      // -1 because we're in keyDown handler, and value is from _before_ this key was pressed
      if (this._searchInputNode.value.length >= Et2WidgetWithSearch.MIN_CHARS - 1) {
        this._searchTimeout = window.setTimeout(() => {
          this.startSearch();
        }, Et2WidgetWithSearch.SEARCH_TIMEOUT);
      }
    }

    /**
     * Combobox listens for mousedown, which interferes with search clear button.
     * Here we block it from bubbling
     * @param {MouseEvent} event
     * @protected
     */
    _handleSearchMouseDown(event) {
      event.stopPropagation();
    }
    _handleEditKeyDown(event) {
      // Stop propagation, or parent key handler will add again
      event.stopImmediatePropagation();
      if (Et2WidgetWithSearch.TAG_BREAK.indexOf(event.key) !== -1 && this.allowFreeEntries) {
        // Prevent default, since that would try to submit
        event.preventDefault();
        this.stopEdit();
      }
      // Abort edit, put original value back
      else if (event.key == "Escape") {
        this.stopEdit(true);
      }
    }

    /**
     * Sometimes users paste multiple comma separated values at once.  Split them then handle normally.
     *
     * @param {ClipboardEvent} event
     * @protected
     */
    _handlePaste(event) {
      event.preventDefault();
      var paste = event.clipboardData.getData('text');
      if (!paste) {
        return;
      }
      var selection = window.getSelection();
      if (selection.rangeCount) {
        selection.deleteFromDocument();
      }
      var values = paste.split(/,\t/);
      values.forEach(v => {
        this.createFreeEntry(v.trim());
      });
      this.dropdown.hide();
    }

    /**
     * Start searching
     *
     * If we have local options, we'll search & display any matches.
     * If serverUrl is set, we'll ask the server for results as well.
     */
    startSearch() {
      var _this6 = this;
      return _asyncToGenerator$g(function* () {
        var _this6$_searchInputNo;
        // Stop timeout timer
        clearTimeout(_this6._searchTimeout);
        _this6.setAttribute("searching", "");

        // Hide clear button
        var clear_button = (_this6$_searchInputNo = _this6._searchInputNode) === null || _this6$_searchInputNo === void 0 || (_this6$_searchInputNo = _this6$_searchInputNo.shadowRoot) === null || _this6$_searchInputNo === void 0 ? void 0 : _this6$_searchInputNo.querySelector(".input__clear");
        if (clear_button) {
          clear_button.style.display = "none";
        }

        // Clear previous results
        _this6._total_result_count = 0;
        _this6._clearResults();

        // Start the searches
        _this6._searchPromise = Promise.all([_this6.localSearch(_this6._searchInputNode.value, _this6.searchOptions), _this6.remoteSearch(_this6._searchInputNode.value, _this6.searchOptions)]).then( /*#__PURE__*/_asyncToGenerator$g(function* () {
          _this6.removeAttribute("searching");

          // Restore clear button
          if (clear_button) {
            clear_button.style.display = "";
          }
          yield _this6.updateComplete;
          _this6._searchPromise = null;
        }));
        _this6.requestUpdate();
        return _this6._searchPromise;
      })();
    }

    /**
     * Clear search term and any search results
     *
     * Local options are not removed, but remote options are
     */
    clearSearch() {
      // Stop timeout timer
      clearTimeout(this._searchTimeout);
      this._clearResults();

      // Clear search term
      if (this._searchInputNode) {
        this._searchInputNode.value = "";
      }
    }
    _clearResults() {
      var target = this._optionTargetNode || this;
      this._keepSelectedRemote();
      this._remote_options = [];
      this._total_result_count = 0;

      // Not searching anymore, clear flag
      var clear_flag = option => {
        if (Array.isArray(option.value)) {
          option.value.map(clear_flag);
        } else {
          option.isMatch = null;
        }
      };
      this.select_options.map(clear_flag);
      this.requestUpdate("select_options");

      // Rendering options using repeat() means we need to explicitly update the nodes since they
      // don't always get re-rendered
      for (var option of this.select.querySelectorAll(".no-match")) {
        option.classList.remove("no-match", "match");
      }
    }

    /**
     * Filter the local options
     *
     * @param {string} search
     * @protected
     */
    localSearch(search, options) {
      return new Promise(resolve => {
        this.select_options.forEach(option => {
          option.isMatch = this.searchMatch(search, option);
        });
        this.requestUpdate("select_options");
        resolve();
      });
    }

    /**
     * Ask for remote options and add them in unconditionally
     * @param {string} search
     * @protected
     */
    remoteSearch(search, options) {
      if (!this.searchUrl) {
        return Promise.resolve([]);
      }

      // Check our URL: JSON file or URL?
      if (this.searchUrl.includes(".json")) {
        // Get the file, search it
        return this.jsonQuery(search, options);
      } else {
        // Fire off the query to the server
        return this.remoteQuery(search, options);
      }
    }

    /**
     * Search through a JSON file in the browser
     *
     * @param {string} search
     * @param {object} options
     * @protected
     */
    jsonQuery(search, options) {
      // Get the file
      var controller = new AbortController();
      var signal = controller.signal;
      var response_ok = false;
      var resultLimit = Math.max(parseInt(this.egw().preference('maxmatchs', 'common')), 100);
      return StaticOptions.cached_from_file(this, this.searchUrl).then(options => {
        // Filter the options
        var lower_search = search.toLowerCase();
        var filtered = options.filter(option => {
          return option.label.toLowerCase().includes(lower_search) || option.value.includes(search);
        });
        // Limit results
        this._total_result_count += filtered.length;
        if (filtered.length > resultLimit) {
          filtered.splice(resultLimit);
        }
        // Add the matches
        this._total_result_count -= this.processRemoteResults(filtered);
        return filtered;
      }).catch(_err => {
        this.egw().message(_err.statusText || this.searchUrl, "error");
        return [];
      });
    }

    /**
     * Actually query the server.
     *
     * This can be overridden to change request parameters or eg. send them as POST parameters.
     *
     * Default implementation here sends search string and options:
     * - as two parameters to the AJAX function
     * - and (additional) as GET parameters plus search string as "query"
     *
     * This is done to support as well the old taglist callbacks, as the regular select ones!
     *
     * @param {string} search
     * @param {object} options
     * @returns {any}
     * @protected
     */
    remoteQuery(search, options) {
      var _parseInt;
      // Include a limit, even if options don't, to avoid massive lists breaking the UI
      var sendOptions = _objectSpread$X({
        num_rows: (_parseInt = parseInt(this.egw().preference('maxmatchs', 'common'))) !== null && _parseInt !== void 0 ? _parseInt : 100
      }, options);
      return this.egw().request(this.egw().link(this.egw().ajaxUrl(this.egw().decodePath(this.searchUrl)), _objectSpread$X({
        query: search
      }, sendOptions)), [search, sendOptions]).then(results => {
        return this._processResultCount(results);
      });
    }

    /**
     * Update total result count, checking results for a total attribute, then further processing the results
     * into select options
     *
     * @param results
     * @returns {SelectOption[]}
     * @protected
     */
    _processResultCount(results) {
      // If results have a total included, pull it out.
      // It will cause errors if left in the results
      if (typeof results.total !== "undefined") {
        this._total_result_count += results.total;
        delete results.total;
        // Make it an array, since it was probably an object, and cleanSelectOptions() treats objects differently
        results = Object.values(results);
      } else {
        this._total_result_count += results.length;
      }
      var entries = cleanSelectOptions(results);
      var entryCount = entries.length;
      this._total_result_count -= this.processRemoteResults(entries);
      return entries;
    }

    /**
     * Add in remote results
     *
     * Any results that already exist will be removed to avoid duplicates
     *
     * @param results
     * @return Duplicate count
     * @protected
     */
    processRemoteResults(entries) {
      var _this7 = this;
      if (!(entries !== null && entries !== void 0 && entries.length)) {
        return 0;
      }
      var duplicateCount = 0;
      var process = entries => {
        var _loop2 = function _loop2() {
          var entry = entries[i];
          entry.class = (entry.class || "") + " remote";

          // Handle option groups
          if (Array.isArray(entry.value)) {
            process(entry.value);
            return 1; // continue
          }

          // Server says it's a match
          entry.isMatch = true;

          // Avoid duplicates with existing options
          if (_this7.select_options.some(o => o.value == entry.value)) {
            duplicateCount++;
            entries.splice(i, 1);
          }
        };
        // Add a "remote" class so we can tell these apart from any local results
        for (var i = entries.length - 1; i >= 0; i--) {
          if (_loop2()) continue;
        }
      };
      process(entries);
      this._remote_options = entries;
      this.requestUpdate("select_options");
      return duplicateCount;
    }

    /**
     * Check if one of our [local] items matches the search
     *
     * @param search
     * @param item
     * @returns {boolean}
     * @protected
     */
    searchMatch(search, option) {
      var _option$label;
      if (!option || !option.value) {
        return false;
      }
      if ((_option$label = option.label) !== null && _option$label !== void 0 && _option$label.toLowerCase().includes(search.toLowerCase())) {
        return true;
      }
      if (typeof option.value == "string") {
        return option.value.includes(search.toLowerCase());
      }
      return option.value == search;
    }

    /**
     * Create an entry that is not in the options and add it to the value
     *
     * @param {string} text Used as both value and label
     */
    createFreeEntry(text) {
      var _this$_activeControls7;
      if (!text || !this.validateFreeEntry(text)) {
        return false;
      }
      // Make sure not to double-add
      if (!this.querySelector("[value='" + text.replace(/'/g, "\\\'") + "']") && !this.select_options.find(o => o.value == text)) {
        this.__select_options.push({
          value: text.trim(),
          label: text.trim(),
          class: "freeEntry",
          isMatch: false
        });
        this.requestUpdate('select_options');
      }

      // Make sure not to double-add, but wait until the option is there
      if (this.multiple && this.getValueAsArray().indexOf(text) == -1) {
        var value = this.getValueAsArray();
        value.push(text);
        this.value = value;
      } else if (!this.multiple && this.value !== text) {
        this.value = text;
      }
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));

      // If we were overlapping edit inputbox with the value display, reset
      if (!this.readonly && (_this$_activeControls7 = this._activeControls) !== null && _this$_activeControls7 !== void 0 && _this$_activeControls7.classList.contains("novalue")) {
        this._searchInputNode.style.display = "";
      }
      return true;
    }

    /**
     * Check if a free entry value is acceptable.
     * We use validators directly using the proposed value
     *
     * @param text
     * @returns {boolean}
     */
    validateFreeEntry(text) {
      var validators = [...this.validators, ...this.defaultValidators];
      var result = validators.filter(v => v.execute(text, v.param, {
        node: this
      }));
      return validators.length > 0 && result.length == 0 || validators.length == 0;
    }
    handleTagEdit(event) {
      var value = event.target.value;
      var original = event.target.dataset.original_value;
      if (!value || !this.allowFreeEntries || !this.validateFreeEntry(value)) {
        // Not a good value, reset it.
        event.target.variant = "danger";
        return false;
      }
      event.target.variant = "success";

      // Add to internal list
      this.createFreeEntry(value);

      // Remove original from value & DOM
      if (value != original) {
        if (this.multiple) {
          this.value = this.value.filter(v => v !== original);
        } else {
          this.value = value;
        }
        this.__select_options = this.__select_options.filter(v => v.value !== original);
      }
    }

    /**
     * Start editing the current value if multiple=false
     *
     * @param {Et2Tag} tag
     */
    startEdit(tag) {
      var tag_value = tag ? tag.value : this.value;

      // hide the menu
      this.dropdown.hide();
      waitForEvent(this, "sl-after-hide").then(() => {
        // Turn on edit UI
        this._activeControls.classList.add("editing", "active");

        // Pre-set value to tag value
        this._editInputNode.style.display = "";
        this._editInputNode.value = tag_value;
        this._editInputNode.focus();

        // If they abort the edit, they'll want the original back.
        this._editInputNode.dataset.initial = tag_value;
      });
    }
    stopEdit() {
      var _this8 = this;
      var abort = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      // type to select will focus matching entries, but we don't want to stop the edit yet
      if (typeof abort == "object" && abort.type == "blur") {
        var _abort$relatedTarget;
        if (((_abort$relatedTarget = abort.relatedTarget) === null || _abort$relatedTarget === void 0 ? void 0 : _abort$relatedTarget.localName) == this.optionTag) {
          return;
        }
        // Edit lost focus, accept changes
        abort = false;
      }
      var original = this._editInputNode.dataset.initial;
      delete this._editInputNode.dataset.initial;
      var value = abort ? original : this._editInputNode.value;
      this._editInputNode.value = "";
      if (value && value != original) {
        this.createFreeEntry(value);
        this.updateComplete.then(() => {
          var item = this.querySelector("[value='" + value.replace(/'/g, "\\\'") + "']");
          item.dispatchEvent(new CustomEvent("sl-select", {
            detail: {
              item
            }
          }));
        });
      }

      // Remove original from value & DOM
      if (value != original) {
        if (this.multiple) {
          var _this$querySelector2;
          this.value = this.value.filter(v => v !== original);
          (_this$querySelector2 = this.querySelector("[value='" + original.replace(/'/g, "\\\'") + "']")) === null || _this$querySelector2 === void 0 || _this$querySelector2.remove();
        } else {
          this.value = value;
        }
        this.select_options = this.select_options.filter(v => v.value !== original);
      }
      this._activeControls.classList.remove("editing", "active");
      if (!this.multiple) {
        this.updateComplete.then( /*#__PURE__*/_asyncToGenerator$g(function* () {
          // Don't know why, but this doesn't always work leaving the value hidden by prefix
          yield _this8.dropdown.hide();
          _this8.dropdown.classList.remove("select--open");
          _this8.dropdown.panel.setAttribute("hidden", "");
        }));
      }
    }
    _handleSearchAbort(e) {
      this._activeControls.classList.remove("active");
      this.clearSearch();
    }

    /**
     * et2-searchbox (SlInput) sends out an event on change.
     * We don't care, and if we let it bubble it'll get in the way.
     * @param e
     * @protected
     */
    _handleSearchChange(e) {
      e.stopImmediatePropagation();
      e.preventDefault();
      return false;
    }
    _handleSearchClear(e) {
      e.stopImmediatePropagation();
      e.preventDefault();
      this.clearSearch();
    }
  }
  /**
   * When user is typing, we wait this long for them to be finished before we start the search
   * @type {number}
   * @protected
   */
  _defineProperty$1S(Et2WidgetWithSearch, "SEARCH_TIMEOUT", 500);
  /**
   * We need at least this many characters before we start the search
   *
   * @type {number}
   * @protected
   */
  _defineProperty$1S(Et2WidgetWithSearch, "MIN_CHARS", 2);
  /**
   * These characters will end a free tag
   * @type {string[]}
   */
  _defineProperty$1S(Et2WidgetWithSearch, "TAG_BREAK", ["Tab", "Enter", ","]);
  return Et2WidgetWithSearch;
});

var _dec$4, _dec2$3, _dec3$1, _dec4$1, _dec5$1, _dec6$1, _dec7$1, _dec8$1, _dec9$1, _class$9, _descriptor$4, _descriptor2$2, _descriptor3$1, _descriptor4$1, _descriptor5$1, _descriptor6$1, _descriptor7$1, _descriptor8$1, _templateObject$15, _templateObject2$F, _templateObject3$o, _templateObject4$h, _templateObject5$e, _templateObject6$7, _templateObject7$4, _templateObject8$3, _templateObject9$2, _templateObject10, _templateObject11, _templateObject12;
function asyncGeneratorStep$f(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$f(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$f(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$f(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _initializerDefineProperty$4(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function ownKeys$X(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$W(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$X(Object(source), true).forEach(function (key) { _defineProperty$1R(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$X(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$15(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1R(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$4(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$4(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

// export Et2WidgetWithSelect which is used as type in other modules
class Et2WidgetWithSelect extends RowLimitedMixin(Et2WidgetWithSelectMixin(s$5)) {
  // Gets an array of all <sl-option> elements
  getAllOptions() {
    // @ts-ignore
    return [...this.querySelectorAll('sl-option')];
  }
}
;
/**
 * @summary Select one or more options from a given list
 * @since 23.1
 *
 * @dependency sl-select
 * @dependency sl-option
 *
 * At its most basic, you can select one option from a list provided.  The list can be passed from the server in
 * the sel_options array or options can be added as children in the template.  Some extending classes provide specific
 * options, such as Et2SelectPercent or Et2SelectCountry.  All provided options will be mixed together and used.
 *
 * To allow selecting more than one option, use the attribute multiple="true".   This will take & return an array
 * as value instead of just a string.
 *
 * SearchMixin adds additional abilities to ALL select boxes
 * @see Et2WithSearchMixin
 *
 * Override for extending widgets:
 * # Custom display of selected value
 * 	When selecting a single value (!multiple) you can override doLabelChange() to customise the displayed label
 * 	@see Et2SelectCategory, which adds in the category icon
 *
 * # Custom option rows
 *  Options can have 'class' and 'icon' properties that will be used for the option
 * 	The easiest way for further customisation to use CSS in an external file (like etemplate2.css) and ::part().
 * 	@see Et2SelectCountry which displays flags via CSS instead of using SelectOption.icon
 *
 * # Custom tags
 * 	When multiple is set, instead of a single value each selected value is shown in a tag.  While it's possible to
 * 	use CSS to some degree, we can also use a custom tag class that extends Et2Tag.
 * 	1.  Create the extending class
 * 	2.  Make sure it's loaded (add to etemplate2.ts)
 * 	3.  In your extending Et2Select, override get tagTag() to return the custom tag name
 *
 * @slot - Reflected into listbox options. Must be <sl-option> elements. You can use <sl-divider> to group items visually.  Normally you set the options by parameter.
 * @slot prefix - Used to prepend a presentational icon or similar element to the combobox.
 * @slot help-text - Text that describes how to use the input. Alternatively, you can use the `help-text` attribute.
 *
 * @event change - Emitted when the control's value changes.
 * @event sl-clear - Emitted when the control’s value is cleared.
 * @event sl-input - Emitted when the control receives input.
 * @event sl-focus - Emitted when the control gains focus.
 * @event sl-blur - Emitted when the control loses focus.
 * @event sl-show - Emitted when the suggestion menu opens.
 * @event sl-after-show - Emitted after the suggestion menu opens and all animations are complete.
 * @event sl-hide - Emitted when the suggestion menu closes.
 * @event sl-after-hide - Emitted after the suggestion menu closes and all animations are complete.
 *
 * @csspart prefix - The container that wraps the prefix slot.
 * @csspart tags - The container that houses option tags when multiselect is used.
 * @csspart display-input - The element that displays the selected option’s label, an <input> element.
 * @csspart expand-icon - The container that wraps the expand icon.
 * @csspart combobox - The container the wraps the prefix, combobox, clear icon, and expand button.
 * @csspart listbox - The listbox container where options are slotted.
 * @csspart option - The options in the listbox container
 * @csspart icon - Icon in the option
 * @csspart emptyLabel - Wrapper around the label shown when there is no option selected
 * @csspart tag__prefix - The container that wraps the option prefix
 * @csspart tag__suffix - The container that wraps the option suffix
 * @csspart tag__limit - Element that is shown when the number of selected options exceeds maxOptionsVisible
 */
// @ts-ignore SlSelect styles is a single CSSResult, not an array, so TS complains
var Et2Select = (_dec$4 = e$c(), _dec2$3 = e$c({
  type: Boolean,
  reflect: true
}), _dec3$1 = e$c({
  type: Boolean,
  reflect: true
}), _dec4$1 = e$c({
  type: Boolean
}), _dec5$1 = e$c(), _dec6$1 = e$c({
  reflect: true
}), _dec7$1 = e$c({
  attribute: 'help-text'
}), _dec8$1 = t$7(), _dec9$1 = e$c(), (_class$9 = class Et2Select extends Et2WithSearchMixin(Et2WidgetWithSelect) {
  static get styles() {
    return [
    // Parent (SlSelect) returns a single cssResult, not an array
    shoelace, super.styles, i$b(_templateObject$15 || (_templateObject$15 = _taggedTemplateLiteral$15(["\n\t\t\t  :host {\n\t\t\t\tdisplay: block;\n\t\t\t\tflex: 1 0 auto;\n\t\t\t\t--icon-width: 20px;\n\t\t\t  }\n\n\n\t\t\t  ::slotted(img), img {\n\t\t\t\tvertical-align: middle;\n\t\t\t}\n\t\t\t\n\t\t\t/* Get rid of padding before/after options */\n\t\t\tsl-menu::part(base) {\n\t\t\t\tpadding: 0px;\n\t\t\t}\n\t\t\t/* No horizontal scrollbar, even if options are long */\n\t\t\t.dropdown__panel {\n\t\t\t\toverflow-x: clip;\n\t\t\t  }\n\n\t\t\t  /* Ellipsis when too small */\n\n\t\t\t  ::part(tags) {\n\t\t\t\tmax-width: 100%;\n\t\t\t  }\n\t\t\t  .select__label {\n\t\t\t\tdisplay: block;\n\t\t\t\ttext-overflow: ellipsis;\n\t\t\t\t/* This is usually not used due to flex, but is the basis for ellipsis calculation */\n\t\t\t\twidth: 10ex;\n\t\t\t  }\n\n\t\t\t  /** multiple=true uses tags for each value **/\n\t\t\t  /* styling for icon inside tag (not option) */\n\n\t\t\t  .tag_image {\n\t\t\t\tmargin-right: var(--sl-spacing-x-small);\n\t\t\t  }\n\n\t\t\t  /* Maximum height + scrollbar on tags (+ other styling) */\n\n\t\t\t  ::part(tags) {\n\t\t\t\toverflow-y: auto;\n\t\t\t\tmargin-left: 0px;\n\t\t\t\tmax-height: initial;\n\t\t\t\tmin-height: auto;\n\t\t\t\tgap: 0.1rem 0.5rem;\n\t\t\t  }\n\n\t\t\t  :host([rows]) ::part(tags) {\n\t\t\t\tmax-height: calc(var(--rows, 5) * (var(--sl-input-height-medium) * 0.8))\n\t\t\t  }\n\n\t\t\t\t:host([readonly][rows='1']) ::part(tags) {\n\t\t\t\toverflow: hidden;\n\t\t\t  }\n\n\t\t\t  /* No rows set, default height limit about 5 rows */\n\n\t\t\t  :host(:not([rows])) ::part(tags) {\n\t\t\t\tmax-height: 11em;\n\t\t\t  }\n\n\t\t\t  select:hover {\n\t\t\t\tbox-shadow: 1px 1px 1px rgb(0 0 0 / 60%);\n\t\t\t  }\n\n\t\t\t  /* Hide dropdown trigger when multiple & readonly */\n\n\t\t\t  :host([readonly][multiple]:not([rows='1']))::part(expand-icon) {\n\t\t\t\tdisplay: none;\n\t\t\t  }\n\n\t\t\t  /* Style for tag count if rows=1 */\n\n\t\t\t  .tag_limit {\n\t\t\t\tposition: absolute;\n\t\t\t\tright: 0px;\n\t\t\t\ttop: 0px;\n\t\t\t\tbottom: 0px;\n\t\t\t\tbox-shadow: rgb(0 0 0/50%) -1.5ex 0px 1ex -1ex, rgb(0 0 0 / 0%) 0px 0px 0px 0px;\n\t\t\t  }\n\n\t\t\t  .tag_limit::part(base) {\n\t\t\t\theight: 100%;\n\t\t\t\tbackground-color: var(--sl-input-background-color);\n\t\t\t\tborder-top-left-radius: 0;\n\t\t\t\tborder-bottom-left-radius: 0;\n\t\t\t\tfont-weight: bold;\n\t\t\t\tmin-width: 3em;\n\t\t\t\tjustify-content: center;\n\t\t\t  }\n\n\t\t\t  /* Show all rows on hover if rows=1 */\n\n\t\t\t  :host([ readonly ][ multiple ][ rows ]) .hover__popup {\n\t\t\t\twidth: -webkit-fill-available;\n\t\t\t\twidth: -moz-fill-available;\n\t\t\t\twidth: fill-available;\n\t\t\t  }\n\n\t\t\t  :host([readonly][multiple][rows]) .hover__popup::part(popup) {\n\t\t\t\tz-index: var(--sl-z-index-dropdown);\n\t\t\t\tbackground-color: white;\n\t\t\t  }\n\n\t\t\t  :host([ readonly ][ multiple ][ rows ]) .hover__popup .select__tags {\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-wrap: wrap;\n\t\t\t  }\n\t\t\t  ::part(listbox) {\n\t\t\t\tz-index: 1;\n\t\t\t\tbackground: var(--sl-input-background-color);\n\t\t\t\tpadding: var(--sl-input-spacing-small);\n\t\t\t\tpadding-left: 2px;\n\n\t\t\t\tbox-shadow: var(--sl-shadow-large);\n\t\t\t\tmin-width: fit-content;\n\t\t\t\tborder-radius: var(--sl-border-radius-small);\n\t\t\t\tborder: 1px solid var(--sl-color-neutral-200);\n\t\t\t\toverflow-y: auto;\n\t\t\t  }\n\n\t\t\t  ::part(display-label) {\n\t\t\t\tmargin: 0;\n\t\t\t  }\n\n\t\t\t  :host::part(display-label) {\n\t\t\t\tmax-height: 8em;\n\t\t\t\toverflow-y: auto;\n\t\t\t  }\n\t\t\t  :host([readonly])::part(combobox) {\n\t\t\t\tbackground: none;\n\t\t\t\topacity: 1;\n\t\t\t\tborder: none;\n\t\t\t  }\n\n\t\t\t  /* Position & style of group titles */\n\n\t\t\t  small {\n\t\t\t\tpadding: var(--sl-spacing-medium);\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$W(_objectSpread$W({}, super.properties), {}, {
      /**
       * Toggle between single and multiple selection
       */
      multiple: {
        type: Boolean,
        reflect: true
      },
      /**
       * Click handler for individual tags instead of the select as a whole.
       * Only used if multiple=true so we have tags
       */
      onTagClick: {
        type: Function
      }
    });
  }

  /** Placeholder text to show as a hint when the select is empty. */

  constructor() {
    super();
    _initializerDefineProperty$4(this, "placeholder", _descriptor$4, this);
    /** Allows more than one option to be selected. */
    _initializerDefineProperty$4(this, "multiple", _descriptor2$2, this);
    /** Disables the select control. */
    _initializerDefineProperty$4(this, "disabled", _descriptor3$1, this);
    /** Adds a clear button when the select is not empty. */
    _initializerDefineProperty$4(this, "clearable", _descriptor4$1, this);
    /** The select's label. If you need to display HTML, use the `label` slot instead. */
    _initializerDefineProperty$4(this, "label", _descriptor5$1, this);
    /**
     * The preferred placement of the select's menu. Note that the actual placement may vary as needed to keep the listbox
     * inside of the viewport.
     */
    _initializerDefineProperty$4(this, "placement", _descriptor6$1, this);
    /** The select's help text. If you need to display HTML, use the `help-text` slot instead. */
    _initializerDefineProperty$4(this, "helpText", _descriptor7$1, this);
    /** If the select is limited to 1 row, we show the number of tags not visible */
    _initializerDefineProperty$4(this, "_tagsHidden", _descriptor8$1, this);
    _defineProperty$1R(this, "__value", "");
    _defineProperty$1R(this, "tagOverflowObserver", null);
    this.hoist = true;
    this._tagTemplate = this._tagTemplate.bind(this);
    this._handleMouseEnter = this._handleMouseEnter.bind(this);
    this._handleMouseLeave = this._handleMouseLeave.bind(this);
    this._handleTagOverflow = this._handleTagOverflow.bind(this);
  }
  /**
   * List of properties that get translated
   *
   * @returns object
   */
  static get translate() {
    return _objectSpread$W(_objectSpread$W({}, super.translate), {}, {
      emptyLabel: true
    });
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateComplete.then(() => {
      var _this$select, _this$select2;
      this.addEventListener("sl-change", this._triggerChange);
      // Fixes missing empty label
      (_this$select = this.select) === null || _this$select === void 0 || _this$select.requestUpdate("value");
      // Fixes incorrect opening position
      (_this$select2 = this.select) === null || _this$select2 === void 0 || (_this$select2 = _this$select2.popup) === null || _this$select2 === void 0 || _this$select2.handleAnchorChange();

      // requestUpdate("value") above means we need to check tags again
      this.select.updateComplete.then(() => {
        this.checkTagOverflow();
      });
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("sl-change", this._triggerChange);
  }
  _triggerChange(e) {
    if (super._triggerChange(e)) {
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));
    }
  }

  /**
   * Handle the case where there is no value set, or the value provided is not an option.
   * If this happens, we choose the first option or empty label.
   *
   * Careful when this is called.  We change the value here, so an infinite loop is possible if the widget has
   * onchange.
   *
   */
  fix_bad_value() {
    // Stop if there are no options
    if (!Array.isArray(this.select_options) || this.select_options.length == 0) {
      // Nothing to do here
      return;
    }

    // emptyLabel is fine
    if ((this.value == '' || this.value == []) && (this.emptyLabel || this.placeholder)) {
      return;
    }
    var valueArray = this.getValueAsArray();

    // Check for value using missing options (deleted or otherwise not allowed)
    var filtered = this.filterOutMissingOptions(valueArray);
    if (filtered.length != valueArray.length) {
      this.value = filtered;
      return;
    }

    // Multiple is allowed to be empty, and if we don't have an emptyLabel or options nothing to do
    if (this.multiple || !this.emptyLabel && this.select_options.length === 0) {
      return;
    }

    // See if parent (search / free entry) is OK with it
    if (super.fix_bad_value()) {
      return;
    }
    // If somebody gave '' as a select_option, let it be
    if (this.value === '' && this.select_options.filter(option => this.value === option.value).length == 1) {
      return;
    }
    // If no value is set, choose the first option
    // Only do this on once during initial setup, or it can be impossible to clear the value

    // value not in options --> use emptyLabel, if exists, or first option otherwise
    if (this.select_options.filter(option => valueArray.find(val => val == option.value) || Array.isArray(option.value) && option.value.filter(o => valueArray.find(val => val == o.value))).length === 0) {
      var _this$select_options$;
      var oldValue = this.value;
      this.value = this.emptyLabel ? "" : "" + ((_this$select_options$ = this.select_options[0]) === null || _this$select_options$ === void 0 ? void 0 : _this$select_options$.value);
      // ""+ to cast value of 0 to "0", to not replace with ""
      this.requestUpdate("value", oldValue);
    }
  }
  get value() {
    var _this$__value, _this$__value2;
    // Handle a bunch of non-values, if it's multiple we want an array
    if (this.multiple && (this.__value == "null" || this.__value == null || typeof this.__value == "undefined" || !this.emptyLabel && this.__value == "" && !this.select_options.find(o => o.value == ""))) {
      return [];
    }
    if (!this.multiple && !this.emptyLabel && this.__value == "" && !this.select_options.find(o => o.value == "")) {
      return null;
    }
    return this.multiple ? (_this$__value = this.__value) !== null && _this$__value !== void 0 ? _this$__value : [] : (_this$__value2 = this.__value) !== null && _this$__value2 !== void 0 ? _this$__value2 : "";
  }

  // @ts-ignore
  set value(val) {
    if (typeof val === "undefined" || val == null) {
      val = "";
    }
    if (typeof val === 'string' && val.indexOf(',') !== -1 && this.multiple) {
      val = val.split(',');
    }
    if (typeof val === 'number') {
      val = val.toString();
    }
    var oldValue = this.value;
    if (Array.isArray(val)) {
      // Make sure value has no duplicates, and values are strings
      this.__value = [...new Set(val.map(v => typeof v === 'number' ? v.toString() : v || ''))];
    } else {
      this.__value = val;
    }
    if (this.multiple && typeof this.__value == "string") {
      this.__value = this.__value != "" ? [this.__value] : [];
    } else if (!this.multiple && Array.isArray(this.__value)) {
      this.__value = this.__value.toString();
    }
    if (this.select) {
      this.select.value = this.shoelaceValue;
    }
    this.requestUpdate("value", oldValue);
  }

  /**
   * Check a value for missing options and remove them.
   *
   * We'll warn about it in the helpText, and if they save the change will be made.
   * This is to avoid the server-side validation error, which the user can't do much about.
   *
   * @param {string[]} value
   * @returns {string[]}
   */
  filterOutMissingOptions(value) {
    if (!this.readonly && value && value.length > 0 && !this.allowFreeEntries && this.select_options.length > 0) {
      function filterBySelectOptions(arrayToFilter, options) {
        var filteredArray = arrayToFilter.filter(item => {
          // Check if item is found in options
          return !options.some(option => {
            if (typeof option.value === 'string') {
              // Regular option
              return option.value === item;
            } else if (Array.isArray(option.value)) {
              // Recursively check if item is found in nested array (option groups)
              return filterBySelectOptions([item], option.value).length > 0;
            }
            return false;
          });
        });
        return filteredArray;
      }

      // Empty is allowed, if there's an emptyLabel
      if (value.toString() == "" && this.emptyLabel) {
        return value;
      }
      var missing = filterBySelectOptions(value, this.select_options);
      if (missing.length > 0) {
        debugger;
        console.warn("Invalid option '" + missing.join(", ") + "' removed from " + this.id, this);
        value = value.filter(item => missing.indexOf(item) == -1);
      }
    }
    return value;
  }

  /**
   * Additional customisations from the XET node
   *
   * @param {Element} _node
   */
  loadFromXML(_node) {
    super.loadFromXML(_node);

    // Wait for update to be complete before we check for bad value so extending selects can have a chance
    this.updateComplete.then(() => this.fix_bad_value());
  }

  /** @param {import('@lion/core').PropertyValues } changedProperties */
  willUpdate(changedProperties) {
    super.willUpdate(changedProperties);
    if (changedProperties.has("multiple")) {
      this.value = this.__value;
    }
    if (changedProperties.has("select_options") || changedProperties.has("value") || changedProperties.has("emptyLabel")) {
      this.updateComplete.then(() => {
        this.fix_bad_value();
      });
    }
  }

  /**
   * After render, DOM nodes are there
   *
   * Check to see if tags overflow, set the counter flag
   *
   * @param {PropertyValues} changedProperties
   */
  updated(changedProperties) {
    super.updated(changedProperties);
    this.checkTagOverflow();
  }
  checkTagOverflow() {
    // Create / destroy intersection observer
    if (this.readonly && this.rows == "1" && this.multiple && this.tagOverflowObserver == null) {
      this.tagOverflowObserver = new IntersectionObserver(this._handleTagOverflow, {
        root: this.select.shadowRoot.querySelector(".select__tags"),
        threshold: 0.1
      });
    } else if ((!this.readonly || this.rows !== "1" || !this.multiple) && this.tagOverflowObserver !== null) {
      this.tagOverflowObserver.disconnect();
      this.tagOverflowObserver = null;
    }
    if (this.tagOverflowObserver) {
      this.select.updateComplete.then(() => {
        // @ts-ignore
        for (var tag of this.select.shadowRoot.querySelectorAll(".select__tags *:not(div):not(sl-tag)")) {
          this.tagOverflowObserver.observe(tag);
        }
      });
    }
  }

  /**
   * Tag used for rendering tags when multiple=true
   * Used for creating, finding & filtering options.
   * @see createTagNode()
   * @returns {string}
   */
  get tagTag() {
    return i$9(_templateObject2$F || (_templateObject2$F = _taggedTemplateLiteral$15(["et2-tag"])));
  }
  blur() {
    if (typeof super.blur == "function") {
      super.blur();
    }
    this.hide();
  }

  /**
   * Apply the user preference to close the dropdown if an option is clicked, even if multiple=true.
   * The default (from SlSelect) leaves the dropdown open for multiple=true
   *
   * @param {MouseEvent} event
   * @private
   */
  handleOptionClick(event) {
    super.handleOptionClick(event);

    // Only interested in option clicks, but handler is bound higher
    if (event.target.tagName !== "SL-OPTION") {
      return;
    }
    if (this._close_on_select) {
      this.hide();
    }
  }
  et2HandleBlur(event) {
    if (typeof super.et2HandleBlur === "function") {
      super.et2HandleBlur(event);
    }
  }
  handleValueChange(e) {
    // Only interested when selected value changes, not any nested inputs
    if (e.target !== this.select) {
      return;
    }
    var old_value = this.__value;
    this.__value = Array.isArray(this.select.value) ? this.select.value.map(e => e.replaceAll("___", " ")) : this.select.value.replaceAll("___", " ");
    this.requestUpdate("value", old_value);
  }

  /**
   * Always close the dropdown if an option is clicked, even if multiple=true.  This differs from SlSelect,
   * which leaves the dropdown open for multiple=true
   *
   * @param {KeyboardEvent} event
   * @private
   */
  handleKeyDown(event) {
    if (event.key === 'Enter' || event.key === ' ' && this.typeToSelectString === '') {
      this.dropdown.hide().then(() => {
        if (typeof this.handleMenuHide == "function") {
          // Make sure search gets hidden
          this.handleMenuHide();
        }
      });
      event.stopPropagation();
    }
  }
  handleTagClick(event) {
    if (typeof this.onTagClick == "function") {
      event.stopPropagation();
      return this.onTagClick(event, event.target);
    }
  }

  /**
   * Callback for the intersection observer so we know when tags don't fit
   *
   * Here we set the flag to show how many more tags are hidden, but this only happens
   * when there are more tags than space.
   *
   * @param entries
   * @protected
   */
  _handleTagOverflow(entries) {
    var oldCount = this._tagsHidden;
    var visibleTagCount = this.value.length - this._tagsHidden;
    var update = false;
    // If we have all tags, start from 0, otherwise it's just a change
    if (entries.length == this.value.length) {
      visibleTagCount = 0;
    } else {
      update = true;
    }
    for (var tag of entries) {
      if (tag.isIntersecting) {
        visibleTagCount++;
      } else if (update && !tag.isIntersecting) {
        visibleTagCount--;
      } else {
        break;
      }
    }
    if (visibleTagCount && visibleTagCount < this.value.length) {
      this._tagsHidden = this.value.length - visibleTagCount;
    } else {
      this._tagsHidden = 0;
    }
    this.requestUpdate("_tagsHidden", oldCount);
  }

  /**
   * If rows=1 and multiple=true, when they put the mouse over the widget show all tags
   * @param {MouseEvent} e
   * @private
   */
  _handleMouseEnter(e) {
    if (this.readonly && this.rows == "1" && this.multiple == true && this.value.length > 1) {
      e.stopPropagation();
      var distance = -1 * parseInt(getComputedStyle(this).height) + 2;

      // Bind to turn this all off
      this.addEventListener("mouseleave", this._handleMouseLeave);

      // Popup - this might get wiped out next render(), might not
      this.updateComplete.then(() => {
        var tags = this.select.shadowRoot.querySelector(".select__tags");
        var popup = document.createElement("sl-popup");
        popup.anchor = this;
        popup.distance = distance;
        popup.placement = "bottom";
        popup.strategy = "fixed";
        popup.active = true;
        popup.sync = "width";
        popup.setAttribute("exportparts", "tags, popup");
        popup.classList.add("hover__popup", "details", "hoist", "details__body");
        this.shadowRoot.append(popup);
        popup.appendChild(tags.cloneNode(true));
        tags.style.width = getComputedStyle(this).width;
        tags.style.margin = 0;
      });
    }
  }

  /**
   * If we're showing all rows because of _handleMouseEnter, reset when mouse leaves
   * @param {MouseEvent} e
   * @private
   */
  _handleMouseLeave(e) {
    var popup = this.shadowRoot.querySelector("sl-popup");
    if (popup) {
      // Popup still here.  Remove it
      popup.remove();
    }
    this.select.requestUpdate();
  }

  /** Shows the listbox. */
  show() {
    var _this = this;
    return _asyncToGenerator$f(function* () {
      return _this.select.show();
    })();
  }

  /** Hides the listbox. */
  hide() {
    var _this2 = this;
    return _asyncToGenerator$f(function* () {
      _this2.select.hide();
    })();
  }
  get open() {
    var _this$select$open, _this$select3;
    return (_this$select$open = (_this$select3 = this.select) === null || _this$select3 === void 0 ? void 0 : _this$select3.open) !== null && _this$select$open !== void 0 ? _this$select$open : false;
  }
  get select() {
    var _this$shadowRoot;
    return (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector("sl-select");
  }

  /**
   * Custom, dynamic styling
   *
   * Put as much as you can in static styles for performance reasons
   * Override this for custom dynamic styles
   *
   * @returns {TemplateResult}
   * @protected
   */
  _styleTemplate() {
    return null;
  }

  /**
   * Used for the "no value" option for single select
   * Placeholder is used for multi-select with no value
   *
   * @returns {TemplateResult}
   */
  _emptyLabelTemplate() {
    if (!this.emptyLabel || this.multiple) {
      return n$9(_templateObject3$o || (_templateObject3$o = _taggedTemplateLiteral$15([""])));
    }
    return n$9(_templateObject4$h || (_templateObject4$h = _taggedTemplateLiteral$15(["\n            <sl-option\n                    part=\"emptyLabel option\"\n                    value=\"\"\n                    .selected=", "\n            >\n                ", "\n            </sl-option>"])), this.getValueAsArray().some(v => v == ""), this.emptyLabel);
  }

  /**
   * Iterate over all the options
   * @returns {TemplateResult}
   * @protected
   */
  _optionsTemplate() {
    return n$9(_templateObject5$e || (_templateObject5$e = _taggedTemplateLiteral$15(["", ""])), c$2(this.select_options
    // Filter out empty values if we have empty label to avoid duplicates
    .filter(o => this.emptyLabel ? o.value !== '' : o), o => o.value, this._groupTemplate.bind(this)));
  }

  /**
   * Used to render each option into the select
   * Override for custom select options.  Note that spaces are not allowed in option values,
   * and sl-select _requires_ options to be <sl-option>
   *
   * @param {SelectOption} option
   * @returns {TemplateResult}
   */
  _optionTemplate(option) {
    // Exclude non-matches when searching
    // unless they're already selected, in which case removing them removes them from value
    if (typeof option.isMatch == "boolean" && !option.isMatch && !this.getValueAsArray().includes(option.value)) {
      return n$9(_templateObject6$7 || (_templateObject6$7 = _taggedTemplateLiteral$15([""])));
    }

    // Tag used must match this.optionTag, but you can't use the variable directly.
    // Pass option along so SearchMixin can grab it if needed
    var value = option.value.replaceAll(" ", "___");
    var classes = option.class ? Object.fromEntries(option.class.split(" ").map(k => [k, true])) : {};
    return n$9(_templateObject7$4 || (_templateObject7$4 = _taggedTemplateLiteral$15(["\n            <sl-option\n                    part=\"option\"\n                    exportparts=\"prefix:tag__prefix, suffix:tag__suffix\"\n                    value=\"", "\"\n                    title=\"", "\"\n                    class=", "\n                    .option=", "\n                    .selected=", "\n                    ?disabled=", "\n            >\n                ", "\n                ", "\n            </sl-option>"])), value, !option.title || this.noLang ? option.title : this.egw().lang(option.title), o$9(_objectSpread$W({
      "match": this.searchEnabled && (option.isMatch || false),
      "no-match": this.searchEnabled && option.isMatch == false
    }, classes)), option, this.getValueAsArray().some(v => v == value), option.disabled, this._iconTemplate(option), this.noLang ? option.label : this.egw().lang(option.label));
  }

  /**
   * Get the icon for the select option
   *
   * @param option
   * @protected
   */
  _iconTemplate(option) {
    if (!option.icon) {
      return n$9(_templateObject8$3 || (_templateObject8$3 = _taggedTemplateLiteral$15([""])));
    }
    return n$9(_templateObject9$2 || (_templateObject9$2 = _taggedTemplateLiteral$15(["\n            <et2-image slot=\"prefix\" part=\"icon\" style=\"width: var(--icon-width)\"\n                       src=\"", "\"></et2-image>"])), option.icon);
  }

  /**
   * Custom tag
   *
   * Override this to customise display when multiple=true.
   * There is no restriction on the tag used, unlike _optionTemplate()
   *
   * @param {Et2Option} option
   * @param {number} index
   * @returns {TemplateResult}
   * @protected
   */
  _tagTemplate(option, index) {
    var _option$option;
    var readonly = this.readonly || option && typeof option.disabled != "undefined" && option.disabled;
    var isEditable = this.editModeEnabled && !readonly;
    var image = this._iconTemplate((_option$option = option.option) !== null && _option$option !== void 0 ? _option$option : option);
    var tagName = this.tagTag;
    return n$9(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral$15(["\n            <", "\n                    part=\"tag\"\n                    exportparts=\"\n                      base:tag__base,\n                      content:tag__content,\n                      remove-button:tag__remove-button,\n                      remove-button__base:tag__remove-button__base,\n                      icon:icon\n                    \"\n                    class=", "\n                    tabindex=\"-1\"\n                    ?pill=", "\n                    size=", "\n                    ?removable=", "\n                    ?readonly=", "\n                    .editable=", "\n                    .value=", "\n                    @change=", "\n                    @dblclick=", "\n                    @mousedown=", "\n            >\n                ", "\n                ", "\n            </", ">\n\t\t"])), tagName, "search_tag " + option.classList.value, this.pill, this.size || "medium", !readonly, readonly, isEditable, option.value.replaceAll("___", " "), this.handleTagEdit, this._handleDoubleClick, typeof this.onTagClick == "function" ? e => this.handleTagClick(e) : A$1, image !== null && image !== void 0 ? image : A$1, option.getTextLabel().trim(), tagName);
  }
  _tagLimitTemplate() {
    if (this._tagsHidden == 0) {
      return A$1;
    }
    return n$9(_templateObject11 || (_templateObject11 = _taggedTemplateLiteral$15(["\n            <sl-tag\n                    part=\"tag__limit\"\n                    class=\"tag_limit\"\n                    slot=\"expand-icon\"\n            >+", "\n            </sl-tag>"])), this._tagsHidden);
  }

  /**
   * Additional customisation template
   * Override if needed.  Added after select options.
   *
   * @protected
   */
  _extraTemplate() {
    return typeof super._extraTemplate == "function" ? super._extraTemplate() : A$1;
  }

  /**
   * Shoelace select uses space as multiple separator, so our values cannot have a space in them.
   * We replace spaces with "___" before passing the value to SlSelect
   *
   * @protected
   */
  get shoelaceValue() {
    return Array.isArray(this.value) ? this.value.map(v => {
      return v.replaceAll(" ", "___");
    }) : typeof this.value == "string" ? this.value.replaceAll(" ", "___") : "";
  }
  render() {
    var value = this.shoelaceValue;
    var icon = A$1;
    if (!this.multiple) {
      var icon_option = this.select_options.find(o => (o.value == value || Array.isArray(value) && value.includes(o.value)) && o.icon);
      if (icon_option) {
        icon = this._iconTemplate(icon_option);
      }
    }
    return n$9(_templateObject12 || (_templateObject12 = _taggedTemplateLiteral$15(["\n            ", "\n            <sl-select\n                    exportparts=\"prefix, tags, display-input, expand-icon, combobox, combobox:base, listbox, option\"\n                    label=", "\n                    placeholder=", "\n                    ?multiple=", "\n                    ?disabled=", "\n                    ?clearable=", "\n                    ?required=", "\n                    helpText=", "\n                    hoist\n                    placement=", "\n                    tabindex=\"0\"\n                    .getTag=", "\n                    .maxOptionsVisible=", "\n                    .value=", "\n                    @sl-change=", "\n                    @mouseenter=", "\n                    @mouseup=", "\n                    @mousewheel=", "\n                    size=", "\n            >\n                ", "\n                ", "\n                ", "\n                ", "\n                ", "\n                <slot name=\"prefix\" slot=\"prefix\"></slot>\n                <slot></slot>\n                <div slot=\"help-text\">\n                    <slot name=\"feedback\"></slot>\n                </div>\n            </sl-select>\n\t\t"])), this._styleTemplate(), this.label, this.placeholder || (this.multiple && this.emptyLabel ? this.emptyLabel : ""), this.multiple, this.disabled || this.readonly, this.clearable, this.required, this.helpText, this.placement, this._tagTemplate, 0, value, this.handleValueChange, this._handleMouseEnter, this.handleOptionClick,
    // Grab & stop mousewheel to prevent scrolling sidemenu when scrolling through options
    e => e.stopImmediatePropagation(), this.size || "medium", icon, this._emptyLabelTemplate(), this._optionsTemplate(), this._tagLimitTemplate(), this._extraTemplate());
  }
}, (_descriptor$4 = _applyDecoratedDescriptor$4(_class$9.prototype, "placeholder", [_dec$4], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor2$2 = _applyDecoratedDescriptor$4(_class$9.prototype, "multiple", [_dec2$3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor3$1 = _applyDecoratedDescriptor$4(_class$9.prototype, "disabled", [_dec3$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor4$1 = _applyDecoratedDescriptor$4(_class$9.prototype, "clearable", [_dec4$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor5$1 = _applyDecoratedDescriptor$4(_class$9.prototype, "label", [_dec5$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor6$1 = _applyDecoratedDescriptor$4(_class$9.prototype, "placement", [_dec6$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 'bottom';
  }
}), _descriptor7$1 = _applyDecoratedDescriptor$4(_class$9.prototype, "helpText", [_dec7$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor8$1 = _applyDecoratedDescriptor$4(_class$9.prototype, "_tagsHidden", [_dec8$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 0;
  }
}), _applyDecoratedDescriptor$4(_class$9.prototype, "value", [_dec9$1], Object.getOwnPropertyDescriptor(_class$9.prototype, "value"), _class$9.prototype)), _class$9));
if (typeof customElements.get("et2-select") === "undefined") {
  customElements.define("et2-select", Et2Select);
}

/**
 * EGroupware eTemplate2 - JS Selectbox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 * @author Andreas Stöckel
 * @copyright Nathan Gray 2011
 */
/**
 * @deprecated use Et2Select
 */
class et2_selectbox extends Et2Select {}

/**
 * @deprecated use Et2SelectReadonly
 */

/**
 * EGroupware eTemplate2 - Contains interfaces used inside the dataview
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright EGroupware GmbH 2011-2021
 */
var et2_dataviewIInvalidatable = "et2_dataview_IInvalidatable";
et2_implements_registry.et2_dataview_IInvalidatable = function (obj) {
  return implements_methods(obj, ["invalidate"]);
};
var et2_dataview_IViewRange = "et2_dataview_IViewRange";
et2_implements_registry.et2_dataview_IViewRange = function (obj) {
  return implements_methods(obj, ["setViewRange"]);
};

/**
 * Interface a data provider has to implement. The data provider functions are
 * called by the et2_dataview_controller class. The data provider basically acts
 * like the egw api egw_data extension, but some etemplate specific stuff has
 * been stripped away -- the implementation (for the nextmatch widget that is
 * et2_extension_nextmatch_dataprovider) has to take care of that.
 */

var et2_IDataProvider = "et2_IDataProvider";
et2_implements_registry.et2_IDataProvider = function (obj) {
  return implements_methods(obj, ["dataFetch", "dataRegisterUID", "dataUnregisterUID"]);
};

function _defineProperty$1Q(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The et2_dataview_container class is the main object each dataview consits of.
 * Each row, spacer as well as the grid itself are containers. A container is
 * described by its parent element and a certain height. On the DOM-Level a
 * container may consist of multiple "tr" nodes, which are treated as a unit.
 * Some containers (like grid containers) are capable of managing a set of child
 * containers. Each container can indicate, that it thinks that it's height
 * might have changed. In that case it informs its parent element about that.
 * The only requirement for the parent element is, that it implements the
 * et2_dataview_IInvalidatable interface.
 * A container does not know where it resides inside the grid, or whether it is
 * currently visible or not -- this information is efficiently managed by the
 * et2_dataview_grid container.
 *
 * @augments Class
 */
class et2_dataview_container extends ClassWithInterfaces {
  /**
   * Initializes the container object.
   *
   * @param _parent is an object which implements the IInvalidatable
   * 	interface. _parent may not be null.
   * @memberOf et2_dataview_container
   */
  constructor(_parent) {
    super();

    // Copy the given invalidation element
    _defineProperty$1Q(this, "_parent", void 0);
    // contains all DOM-Nodes this container exists of
    _defineProperty$1Q(this, "_nodes", void 0);
    _defineProperty$1Q(this, "_inTree", void 0);
    _defineProperty$1Q(this, "_attachData", void 0);
    _defineProperty$1Q(this, "_destroyCallback", void 0);
    _defineProperty$1Q(this, "_destroyContext", void 0);
    _defineProperty$1Q(this, "_height", void 0);
    _defineProperty$1Q(this, "_index", void 0);
    _defineProperty$1Q(this, "_top", void 0);
    _defineProperty$1Q(this, "tr", void 0);
    this._parent = _parent;
    this._nodes = [];
    this._inTree = false;
    this._attachData = {
      "node": null,
      "prepend": false
    };
    this._destroyCallback = null;
    this._destroyContext = null;
    this._height = -1;
    this._index = 0;
    this._top = 0;
  }

  /**
   * Destroys this container. Classes deriving from et2_dataview_container
   * should override this method and take care of unregistering all event
   * handlers etc.
   */
  destroy() {
    // Remove the nodes from the tree
    this.removeFromTree();

    // Call the callback function (if one is registered)
    if (this._destroyCallback) {
      this._destroyCallback.call(this._destroyContext, this);
    }
  }

  /**
   * Sets the "destroyCallback" -- the given function gets called whenever
   * the container is destroyed. This instance is passed as an parameter to
   * the callback.
   *
   * @param {function} _callback
   * @param {object} _context
   */
  setDestroyCallback(_callback, _context) {
    this._destroyCallback = _callback;
    this._destroyContext = _context;
  }

  /**
   * Inserts all container nodes into the DOM tree after or before the given
   * element.
   *
   * @param _node is the node after/before which the container "tr"s should
   * get inserted. _node should be a simple DOM node, not a jQuery object.
   * @param _prepend specifies whether the container should be inserted before
   * or after the given node. Inserting before is needed for inserting the
   * first element in front of an spacer.
   */
  insertIntoTree(_node, _prepend) {
    if (!this._inTree && _node != null && this._nodes.length > 0) {
      // Store the parent node and indicate that this element is now in
      // the tree.
      this._attachData = {
        node: _node,
        prepend: _prepend
      };
      this._inTree = true;
      for (var i = 0; i < this._nodes.length; i++) {
        if (i == 0) {
          if (_prepend) {
            _node.before(this._nodes[0]);
          } else {
            _node.after(this._nodes[0]);
          }
        } else {
          // Insert all following nodes after the previous node
          this._nodes[i - 1].after(this._nodes[i]);
        }
      }

      // Invalidate this element in order to update the height of the
      // parent
      this.invalidate();
    }
  }

  /**
   * Removes all container nodes from the tree.
   */
  removeFromTree() {
    if (this._inTree) {
      // Call the jQuery remove function to remove all nodes from the tree
      // again.
      for (var i = 0; i < this._nodes.length; i++) {
        this._nodes[i].remove();
      }

      // Reset the "attachData"
      this._inTree = false;
      this._attachData = {
        "node": null,
        "prepend": false
      };
    }
  }

  /**
   * Appends a node to the container.
   *
   * @param _node is the DOM-Node which should be appended.
   */
  appendNode(_node) {
    // Add the given node to the "nodes" array
    this._nodes.push(_node);

    // If the container is already in the tree, attach the given node to the
    // tree.
    if (this._inTree) {
      if (this._nodes.length === 1) {
        if (this._attachData.prepend) {
          this._attachData.node.before(_node);
        } else {
          this._attachData.node.after(_node);
        }
      } else {
        this._nodes[this._nodes.length - 2].after(_node);
      }
      this.invalidate();
    }
  }

  /**
   * Removes a certain node from the container
   *
   * @param {HTMLElement} _node
   */
  removeNode(_node) {
    // Get the index of the node in the nodes array
    var idx = this._nodes.indexOf(_node);
    if (idx >= 0) {
      // Remove the node if the container is currently attached
      if (this._inTree) {
        _node.parentNode.removeChild(_node);
      }

      // Remove the node from the nodes array
      this._nodes.splice(idx, 1);
    }
  }

  /**
   * Returns the last node of the container - new nodes have to be appended
   * after it.
   */
  getLastNode() {
    if (this._nodes.length > 0) {
      return this._nodes[this._nodes.length - 1];
    }
    return null;
  }

  /**
   * Returns the first node of the container.
   */
  getFirstNode() {
    return this._nodes.length > 0 ? this._nodes[0] : null;
  }

  /**
   * Returns the accumulated height of all container nodes. Only visible nodes
   * (without "display: none" etc.) are taken into account.
   */
  getHeight() {
    if (this._height === -1 && this._inTree) {
      this._height = 0;

      // Setting this before measuring height helps with issues getting the
      // wrong height due to margins & collapsed borders
      this.tr.css('display', 'block');

      // Increment the height value for each visible container node
      for (var i = 0; i < this._nodes.length; i++) {
        if (et2_dataview_container._isVisible(this._nodes[i][0])) {
          this._height += et2_dataview_container._nodeHeight(this._nodes[i][0]);
        }
      }
      this.tr.css('display', '');
    }
    return this._height === -1 ? 0 : this._height;
  }

  /**
   * Returns a datastructure containing information used for calculating the
   * average row height of a grid.
   * The datastructure has the
   * {
   *     avgHeight: <the calculated average height of this element>,
   *     avgCount: <the element count this calculation was based on>
   * }
   */
  getAvgHeightData() {
    return {
      "avgHeight": this.getHeight(),
      "avgCount": 1
    };
  }

  /**
   * Returns the previously set "pixel top" of the container.
   */
  getTop() {
    return this._top;
  }

  /**
   * Returns the "pixel bottom" of the container.
   */
  getBottom() {
    return this._top + this.getHeight();
  }

  /**
   * Returns the range of the element.
   */
  getRange() {
    return et2_bounds(this.getTop(), this.getBottom());
  }

  /**
   * Returns the index of the element.
   */
  getIndex() {
    return this._index;
  }

  /**
   * Returns how many elements this container represents.
   */
  getCount() {
    return 1;
  }

  /**
   * Sets the top of the element.
   *
   * @param {number} _value
   */
  setTop(_value) {
    this._top = _value;
  }

  /**
   * Sets the index of the element.
   *
   * @param {number} _value
   */
  setIndex(_value) {
    this._index = _value;
  }

  /* -- et2_dataview_IInvalidatable -- */

  /**
   * Broadcasts an invalidation through the container tree. Marks the own
   * height as invalid.
   */
  invalidate() {
    // Abort if this element is already marked as invalid.
    if (this._height !== -1) {
      // Delete the own, probably computed height
      this._height = -1;

      // Broadcast the invalidation to the parent element
      this._parent.invalidate();
    }
  }

  /* -- PRIVATE FUNCTIONS -- */

  /**
   * Used to check whether an element is visible or not (non recursive).
   *
   * @param _obj is the element which should be checked for visibility, it is
   * only checked whether some stylesheet makes the element invisible, not if
   * the given object is actually inside the DOM.
   */
  static _isVisible(_obj) {
    // Check whether the element is localy invisible
    if (_obj.style && (_obj.style.display === "none" || _obj.style.visibility === "none")) {
      return false;
    }

    // Get the computed style of the element
    var style = window.getComputedStyle ? window.getComputedStyle(_obj, null)
    // @ts-ignore
    : _obj.currentStyle;
    if (style.display === "none" || style.visibility === "none") {
      return false;
    }
    return true;
  }

  /**
   * Returns the height of a node in pixels and zero if the element is not
   * visible. The height is clamped to positive values.
   *
   * @param {HTMLElement} _node
   */
  static _nodeHeight(_node) {
    return _node.offsetHeight;
  }
}

/**
 * EGroupware eTemplate2 - Class which contains the spacer container
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright EGroupware GmbH 2011-2021
 */

/**
 * @augments et2_dataview_container
 */
class et2_dataview_spacer extends et2_dataview_container {
  /**
   * Constructor
   *
   * @param _parent
   * @param _rowProvider
   * @memberOf et2_dataview_spacer
   */
  constructor(_parent, _rowProvider) {
    // Call the inherited container constructor
    super(_parent);

    // Initialize the row count and the row height
    this._count = 0;
    this._rowHeight = 19;
    this._avgSum = 0;
    this._avgCount = 0;

    // Get the spacer row and append it to the container
    this.spacerNode = _rowProvider.getPrototype("spacer", this._createSpacerPrototype, this);
    this._phDiv = jQuery("td", this.spacerNode);
    this.appendNode(this.spacerNode);
  }
  setCount(_count, _rowHeight) {
    // Set the new count and _rowHeight if given
    this._count = _count;
    if (typeof _rowHeight !== "undefined") {
      this._rowHeight = _rowHeight;
    }

    // Update the element height
    this._phDiv.height(this._count * this._rowHeight);

    // Call the invalidate function
    this.invalidate();
  }
  getCount() {
    return this._count;
  }
  getHeight() {
    // Set the calculated height, so that "invalidate" will work correctly
    this._height = this._count * this._rowHeight;
    return this._height;
  }
  getAvgHeightData() {
    if (this._avgCount > 0) {
      return {
        "avgHeight": this._avgSum / this._avgCount,
        "avgCount": this._avgCount
      };
    }
    return null;
  }
  addAvgHeight(_height) {
    this._avgSum += _height;
    this._avgCount++;
  }

  /* ---- PRIVATE FUNCTIONS ---- */

  _createSpacerPrototype(_outerId, _columnIds) {
    var tr = jQuery(document.createElement("tr"));
    var td = jQuery(document.createElement("td")).addClass("egwGridView_spacer").addClass(_outerId + "_spacer_fullRow").attr("colspan", _columnIds.length).appendTo(tr);
    return tr;
  }
}

function _defineProperty$1P(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class et2_dataview_grid extends et2_dataview_container {
  /**
   * Creates the grid.
   *
   * @param _parent is the parent grid class - if null, this means that this
   * is the outer grid which manages the scrollarea. If not null, all other
   * parameters are ignored and copied from the given grid instance.
   * @param _parentGrid
   * @param _egw
   * @param _rowProvider
   * @param _avgHeight is the starting average height of the column rows.
   * @memberOf et2_dataview_grid
   */
  constructor(_parent, _parentGrid, _egw, _rowProvider, _avgHeight) {
    // Call the inherited constructor
    super(_parent);

    // If the parent is given, copy all other parameters from it
    _defineProperty$1P(this, "egw", void 0);
    _defineProperty$1P(this, "_orgAvgHeight", void 0);
    _defineProperty$1P(this, "_rowProvider", void 0);
    _defineProperty$1P(this, "_scrollHeight", void 0);
    _defineProperty$1P(this, "_scrollTimeout", void 0);
    _defineProperty$1P(this, "_parentGrid", void 0);
    _defineProperty$1P(this, "_callback", void 0);
    _defineProperty$1P(this, "_context", void 0);
    _defineProperty$1P(this, "_invalidateTimeout", void 0);
    _defineProperty$1P(this, "_invalidateCallback", void 0);
    _defineProperty$1P(this, "_invalidateContext", void 0);
    _defineProperty$1P(this, "doInvalidate", void 0);
    _defineProperty$1P(this, "_map", void 0);
    _defineProperty$1P(this, "_viewRange", void 0);
    _defineProperty$1P(this, "_total", void 0);
    _defineProperty$1P(this, "_avgHeight", void 0);
    _defineProperty$1P(this, "_avgCount", void 0);
    _defineProperty$1P(this, "scrollarea", void 0);
    _defineProperty$1P(this, "innerTbody", void 0);
    _defineProperty$1P(this, "outerCell", void 0);
    if (_parentGrid != null) {
      this.egw = _parent.egw;
      this._orgAvgHeight = false;
      this._rowProvider = _parentGrid._rowProvider;
    } else {
      // Otherwise copy the given parameters
      this.egw = _egw;
      this._orgAvgHeight = _avgHeight;
      this._rowProvider = _rowProvider;

      // As this grid instance has no parent, we need a scroll container
      this._scrollHeight = 0;
      this._scrollTimeout = null;
    }
    this._parentGrid = _parentGrid;
    this._scrollTimeout = null;
    this._invalidateTimeout = null;
    this._invalidateCallback = null;
    this._invalidateContext = null;

    // Flag for stopping invalidate while working
    this.doInvalidate = true;

    // _map contains a mapping between the grid indices and the elements
    // associated to it. The first element in the array always refers to the
    // element starting at index zero (being a spacer if the grid currently
    // displays another range).
    this._map = [];

    // _viewRange contains the current pixel-range of the grid which is
    // visible.
    this._viewRange = et2_range(0, 0);

    // Holds the maximum count of elements
    this._total = 0;

    // Holds data used for storing the current average height data
    this._avgHeight = false;
    this._avgCount = -1;

    // Build the outer grid nodes
    this._createNodes();
  }
  destroy() {
    // Destroy all containers
    this.setTotalCount(0);

    // Stop the scroll timeout
    if (this._scrollTimeout) {
      window.clearTimeout(this._scrollTimeout);
    }

    // Stop the invalidate timeout
    if (this._invalidateTimeout) {
      window.clearTimeout(this._invalidateTimeout);
    }
    super.destroy();
  }
  clear() {
    // Store the old total count and rescue the current average height in
    // form of the "original average height"
    var oldTotalCount = this._total;
    this._orgAvgHeight = this.getAverageHeight();

    // Set the total count to zero
    this.setTotalCount(0);

    // Reset the total count value
    this.setTotalCount(oldTotalCount);
  }

  /**
   * Throws all elements away which are outside the current view range
   */
  cleanup() {
    // Update the pixel positions
    this._recalculateElementPosition();

    // Get the visible mapping indices and recalculate index and pixel
    // position of the containers.
    var mapVis = this._calculateVisibleMappingIndices();

    // Delete all invisible elements -- if anything changed, we have to
    // recalculate the pixel positions again
    this._cleanupOutOfRangeElements(mapVis, 0);
  }

  /**
   * The insertRow function can be called to insert the given container(s) at
   * the given row index. If there currently is another container at that
   * given position, the new container(s) will be inserted above the old
   * container. Yet the "total count" of the grid will be preserved by
   * removing the correct count of elements from the next possible spacer. If
   * no spacer is found, the last containers will be removed. This causes
   * inserting new containers at the end of a grid to be immediately removed
   * again.
   *
   * @param _index is the row index at which the given container(s) should be
   * inserted.
   * @param _container is eiter a single et2_dataview_container instance
   * which should be inserted at the given position. Or an array of
   * et2_dataview_container instances. If you want to remove the container
   * don't do that manually by calling its "destroy" function but use the
   * deleteRow function.
   */
  insertRow(_index, _container) {
    // Calculate the map element the given index refers to
    var idx = this._calculateMapIndex(_index);
    if (idx !== false) {
      // Wrap the container inside an array
      if (_container instanceof et2_dataview_container) {
        _container = [_container];
      }

      // Fetch the average height
      var avg = this.getAverageHeight();

      // Call the internal _doInsertContainer function
      for (var i = 0; i < _container.length; i++) {
        this._doInsertContainer(_index, idx, _container[i], avg);
      }

      // Schedule an "invalidate" event
      this.invalidate();
    }
  }

  /**
   * The deleteRow function can be used to remove the element at the given
   * index.
   *
   * @param _index is the index from which should be deleted. If the given
   * index is outside the so called "managedRange" nothing will happen, as the
   * container has already been destroyed by the grid instance.
   */
  deleteRow(_index) {
    // Calculate the map element the given index refers to
    var idx = this._calculateMapIndex(_index);
    if (idx !== false) {
      this._doDeleteContainer(idx, false);

      // Schedule an "invalidate" event
      this.invalidate();
    }
  }

  /**
   * The given callback gets called whenever the scroll position changed or
   * the visible element range changed. The element indices are passed to the
   * function as et2_range.
   */
  setInvalidateCallback(_callback, _context) {
    this._invalidateCallback = _callback;
    this._invalidateContext = _context;
  }

  /**
   * The setDataCallback function is used to set the callback that will be
   * called when the grid requires new data.
   *
   * @param _callback is the callback function which gets called when the grid
   * needs some new rows.
   * @param _context is the context in which the callback function gets
   * called.
   */
  setDataCallback(_callback, _context) {
    this._callback = _callback;
    this._context = _context;
  }

  /**
   * The updateTotalCount function can be used to update the total count of
   * rows that are displayed inside the grid. Changing the count always causes
   * the spacer at the bottom (if it exists) to be
   *
   * @param _count specifies how many entries the grid can show.
   */
  setTotalCount(_count) {
    // Abort if the total count has not changed
    if (_count === this._total) return;

    // Calculate how many elements have to be removed/added
    var delta = Math.max(0, _count) - this._total;
    if (delta > 0) {
      this._appendEmptyRows(delta);
    } else {
      this._decreaseTotal(-delta);
    }
    this._total = Math.max(0, _count);

    // Schedule an invalidate
    this.invalidate();
  }

  /**
   * Returns the current "total" count.
   */
  getTotalCount() {
    return this._total;
  }

  /**
   * The setViewRange function updates the range in which rows are shown.
   */
  setViewRange(_range) {
    // Set the new view range
    this._viewRange = _range;

    // Immediately call the "invalidate" function
    this._doInvalidate();
  }

  /**
   * Return the indices of the currently visible rows.
   */
  getVisibleIndexRange(_viewRange) {
    function getElemIdx(_elem, _px) {
      if (_elem instanceof et2_dataview_spacer) {
        return _elem.getIndex() + Math.floor((_px - _elem.getTop()) / this.getAverageHeight());
      }
      return _elem.getIndex();
    }
    var idxTop = 0;
    var idxBottom = 0;
    var vr;
    if (_viewRange) {
      vr = _viewRange;
    } else {
      // Calculate the "correct" view range by removing ET2_GRID_VIEW_EXT
      vr = et2_bounds(this._viewRange.top + et2_dataview_grid.ET2_GRID_VIEW_EXT, this._viewRange.bottom - et2_dataview_grid.ET2_GRID_VIEW_EXT);
    }

    // Get the elements at the top and the bottom of the view
    var topElem = null;
    var botElem = null;
    for (var i = 0; i < this._map.length; i++) {
      if (!topElem && this._map[i].getBottom() > vr.top) {
        topElem = this._map[i];
      }
      if (this._map[i].getTop() > vr.bottom) {
        botElem = this._map[i];
        break;
      }
    }
    if (!botElem) {
      botElem = this._map[this._map.length - 1];
    }
    if (topElem) {
      idxTop = getElemIdx.call(this, topElem, vr.top);
      idxBottom = getElemIdx.call(this, botElem, vr.bottom);
    }

    // Return the calculated index top and bottom
    return et2_bounds(idxTop, idxBottom);
  }

  /**
   * Returns index range of all currently managed rows.
   */
  getIndexRange() {
    var idxTop = false;
    var idxBottom = false;
    for (var i = 0; i < this._map.length; i++) {
      if (!(this._map[i] instanceof et2_dataview_spacer)) {
        var idx = this._map[i].getIndex();
        if (idxTop === false) {
          idxTop = idx;
        }
        idxBottom = idx;
      }
    }
    return et2_bounds(idxTop, idxBottom);
  }

  /**
   * Updates the scrollheight
   */
  setScrollHeight(_height) {
    this._scrollHeight = _height;

    // Update the height of the outer container
    if (this.scrollarea) {
      this.scrollarea.height(_height);
    }

    // Update the viewing range
    this.setViewRange(et2_range(this._viewRange.top, this._scrollHeight));
  }

  /**
   * Returns the average row height data, overrides the corresponding function
   * of the et2_dataview_container.
   */
  getAvgHeightData() {
    if (this._avgHeight === false) {
      var avgCount = 0;
      var avgSum = 0;
      for (var i = 0; i < this._map.length; i++) {
        var data = this._map[i].getAvgHeightData();
        if (data !== null) {
          avgSum += data.avgHeight * data.avgCount;
          avgCount += data.avgCount;
        }
      }

      // Calculate the average height, but only if we have a height
      if (avgCount > 0 && avgSum > 0) {
        this._avgHeight = avgSum / avgCount;
        this._avgCount = avgCount;
      }
    }

    // Return the calculated average height if it is available
    if (this._avgHeight !== false) {
      return {
        "avgCount": this._avgCount,
        "avgHeight": this._avgHeight
      };
    }

    // Otherwise return the parent average height
    if (this._parent) {
      return this._parent.getAvgHeightData();
    }

    // Otherwise return the original average height given in the constructor
    if (this._orgAvgHeight !== false) {
      return {
        "avgCount": 1,
        "avgHeight": this._orgAvgHeight
      };
    }
    return null;
  }

  /**
   * Returns the average row height in pixels.
   */
  getAverageHeight() {
    var data = this.getAvgHeightData();
    return data ? data.avgHeight : 19;
  }

  /**
   * Returns the row provider.
   */
  getRowProvider() {
    return this._rowProvider;
  }

  /**
   * Called whenever the size of this or another element in the container tree
   * changes.
   */
  invalidate() {
    // Clear any existing "invalidate" timeout
    if (this._invalidateTimeout) {
      window.clearTimeout(this._invalidateTimeout);
    }
    if (!this.doInvalidate) {
      return;
    }
    var self = this;
    var _super = super.invalidate();
    this._invalidateTimeout = window.setTimeout(function () {
      this.egw.debug("log", "Dataview grid timed invalidate");
      // Clear the "_avgHeight"
      self._avgHeight = false;
      self._avgCount = -1;
      self._invalidateTimeout = null;
      self._doInvalidate(_super);
    }, et2_dataview_grid.ET2_GRID_INVALIDATE_TIMEOUT);
  }

  /**
   * Makes the given index visible: TODO: Propagate this to the parent grid.
   */
  makeIndexVisible(_idx) {
    // Get the element range
    var elemRange = this._getElementRange(_idx);

    // Abort if the index was out of range
    if (!elemRange) {
      return false;
    }

    // Calculate the current visible range
    var visibleRange = et2_bounds(this._viewRange.top + et2_dataview_grid.ET2_GRID_VIEW_EXT, this._viewRange.bottom - et2_dataview_grid.ET2_GRID_VIEW_EXT);

    // Check whether the element is currently completely visible -- if yes,
    // do nothing
    if (visibleRange.top < elemRange.top && visibleRange.bottom > elemRange.bottom) {
      return true;
    }
    if (elemRange.top < visibleRange.top) {
      this.scrollarea.scrollTop(elemRange.top);
    } else {
      var h = elemRange.bottom - elemRange.top;
      this.scrollarea.scrollTop(elemRange.top - this._scrollHeight + h);
    }
  }

  /* ---- PRIVATE FUNCTIONS ---- */

  /*	_inspectStructuralIntegrity: function() {
  		var idx = 0;
  		for (var i = 0; i < this._map.length; i++)
  		{
  			if (this._map[i].getIndex() != idx)
  			{
  				throw "Index missmatch!";
  			}
  			idx += this._map[i].getCount();
  		}
  
  		if (idx !== this._total)
  		{
  			throw "Total count missmatch!";
  		}
  	},*/

  /**
   * Translates the given index to a range, returns false if the index is
   * out of range.
   */
  _getElementRange(_idx) {
    // Recalculate the element positions
    this._recalculateElementPosition();

    // Translate the given index to the map index
    var mapIdx = this._calculateMapIndex(_idx);

    // Do nothing if the given index is out of range
    if (mapIdx === false) {
      return false;
    }

    // Get the map element
    var elem = this._map[mapIdx];

    // Get the element range
    if (elem instanceof et2_dataview_spacer) {
      var avg = this.getAverageHeight();
      return et2_range(elem.getTop() + avg * (elem.getIndex() - _idx), avg);
    }
    return elem.getRange();
  }

  /**
   * Recalculates the position of the currently managed containers. This
   * routine only updates the pixel position of the elements -- the index of
   * the elements is guaranteed to be maintained correctly by all high level
   * functions of the grid, as the index position is needed to be correct for
   * the "deleteRow" and "insertRow" functions, and we cannot effort to call
   * this calculation method after every change in the grid mapping.
   */
  _recalculateElementPosition() {
    for (var i = 0; i < this._map.length; i++) {
      if (i == 0) {
        this._map[i].setTop(0);
      } else {
        this._map[i].setTop(this._map[i - 1].getBottom());
      }
    }
  }

  /**
   * The "_calculateVisibleMappingIndices" function calculates the indices of
   * the _map array, which refer to containers that are currently (partially)
   * visible. This function is used internally by "_doInvalidate".
   */
  _calculateVisibleMappingIndices() {
    // First update the "top" and "bottom", and "index" values of all
    // managed elements, and at the same time calculate the mapping indices
    // of the elements which are inside the current view range.
    var mapVis = {
      "top": -1,
      "bottom": -1
    };
    for (var i = 0; i < this._map.length; i++) {
      // Update the top of the "map visible index" -- set it to the first
      // element index, where the bottom line is beneath the top line
      // of the view range.
      if (mapVis.top === -1 && this._map[i].getBottom() > this._viewRange.top) {
        mapVis.top = i;
      }

      // Update the bottom of the "map visible index" -- set it to the
      // first element index, where the top line is beneath the bottom
      // line of the view range.
      if (mapVis.bottom === -1 && this._map[i].getTop() > this._viewRange.bottom) {
        mapVis.bottom = i;
        break;
      }
    }
    return mapVis;
  }

  /**
   * Deletes all elements which are "out of the view range". This function is
   * internally used by "_doInvalidate". How many elements that are out of the
   * view range get preserved fully depends on the _holdCount parameter
   * variable.
   *
   * @param _mapVis contains the _map indices of the just visible containers.
   * @param _holdCount contains the number of elements that should be kept,
   * if not given, this parameter defaults to ET2_GRID_HOLD_COUNT
   */
  _cleanupOutOfRangeElements(_mapVis, _holdCount) {
    // Iterates over the map from and to the given indices and pushes all
    // elements onto the given array, which are more than _holdCount
    // elements remote from the start.
    function searchElements(_arr, _start, _stop, _dir) {
      var dist = 0;
      for (var _i = _start; _dir > 0 ? _i <= _stop : _i >= _stop; _i += _dir) {
        if (dist > _holdCount) {
          _arr.push(_i);
        } else {
          dist += this._map[_i].getCount();
        }
      }
    }

    // Set _holdCount to ET2_GRID_HOLD_COUNT if the parameters is not given
    _holdCount = typeof _holdCount === "undefined" ? et2_dataview_grid.ET2_GRID_HOLD_COUNT : _holdCount;

    // Collect all elements that will be deleted at the top and at the
    // bottom of the grid
    var deleteTop = [];
    var deleteBottom = [];
    if (_mapVis.top !== -1) {
      searchElements.call(this, deleteTop, _mapVis.top, 0, -1);
    }
    if (_mapVis.bottom !== -1) {
      searchElements.call(this, deleteBottom, _mapVis.bottom, this._map.length - 1, 1);
    }

    // The offset variable specifies how many elements have been deleted
    // from the map -- this variable is needed as deleting elements from the
    // map shifts the map indices. We iterate in oposite direction over the
    // elements, as this allows the _doDeleteContainer/ container function
    // to extend the (possibly) existing spacer at the top of the grid
    var offs = 0;
    for (var i = deleteTop.length - 1; i >= 0; i--) {
      // Delete the container and calculate the new offset
      var mapLength = this._map.length;
      this._doDeleteContainer(deleteTop[i] - offs, true);
      offs += mapLength - this._map.length;
    }
    for (var i = deleteBottom.length - 1; i >= 0; i--) {
      this._doDeleteContainer(deleteBottom[i] - offs, true);
    }
    return deleteBottom.length + deleteTop.length > 0;
  }

  /**
   * The _updateContainers function is used internally by "_doInvalidate" in
   * order to call the "setViewRange" function of all containers the implement
   * that interfaces (needed for nested grids), and to request new elements
   * for all currently visible spacers.
   */
  _updateContainers() {
    var _this = this;
    var _loop = function _loop() {
      var container = _this._map[i];

      // Check which type the container object has
      var isSpacer = container instanceof et2_dataview_spacer;
      var hasIViewRange = !isSpacer && et2_implements_registry.et2_dataview_IViewRange(container, et2_dataview_IViewRange);

      // If the container has one of those special types, calculate the
      // view range and use that to update the view range of the element
      // or to request new elements for the spacer
      if (isSpacer || hasIViewRange) {
        // Calculate the relative view range and check whether
        // the element is really visible
        var elemRange = container.getRange();

        // Abort if the element is not inside the visible range
        if (!et2_rangeIntersect(_this._viewRange, elemRange)) {
          return 1; // continue
        }
        if (hasIViewRange) {
          // Update the view range of the container
          container.setViewRange(et2_bounds(_this._viewRange.top - elemRange.top, _this._viewRange.bottom - elemRange.top));
        } else
          // This container is a spacer
          {
            // Obtain the average element height
            var avg = container._rowHeight;

            // Get the visible container range (vcr)
            var vcr_top = Math.max(_this._viewRange.top, elemRange.top);
            var vcr_bot = Math.min(_this._viewRange.bottom, elemRange.bottom);

            // Calculate the indices of the elements which will be
            // requested
            var cidx = container.getIndex();
            var ccnt = container.getCount();

            // Calculate the start index -- prevent vtop from getting
            // negative (and so idxStart being smaller than cidx) and
            // ensure that idxStart is not larger than the maximum
            // container index.
            var vtop = Math.max(0, vcr_top);
            var idxStart = Math.floor(Math.min(cidx + ccnt - 1, cidx + (vtop - elemRange.top) / avg, _this._total));

            // Calculate the end index -- prevent vtop from getting
            // negative (and so idxEnd being smaller than cidx) and
            // ensure that idxEnd is not larger than the maximum
            // container index.
            var vbot = Math.max(0, vcr_bot);
            var idxEnd = Math.ceil(Math.min(cidx + ccnt - 1, cidx + (vbot - elemRange.top) / avg, _this._total));

            // Initial resize while the grid is hidden will give NaN
            // This is an important optimisation, as it is involved in not
            // loading all rows, so we override in that case so
            // there are more than the 2-3 that fit in the min height.
            if (isNaN(idxStart) && isSpacer) idxStart = cidx - 1;
            if (isNaN(idxEnd) && isSpacer && _this._scrollHeight > 0 && elemRange.bottom == 0) {
              idxEnd = Math.min(ccnt, cidx + Math.ceil((_this._viewRange.bottom - container._top) / (_this._orgAvgHeight || 0)));
            }

            // Call the data callback
            if (_this._callback) {
              var self = _this;
              egw$1.debug("log", "Dataview grid flag for update: ", {
                start: idxStart,
                end: idxEnd
              });
              window.setTimeout(function () {
                // If row template changes, self._callback might disappear
                if (typeof self._callback != "undefined") {
                  self._callback.call(self._context, idxStart, idxEnd);
                }
              }, 0);
            }
          }
      }
    };
    for (var i = 0; i < this._map.length; i++) {
      if (_loop()) continue;
    }
  }

  /**
   * Invalidate iterates over the "mapping" array. It calculates which
   * containers have to be removed and where new containers should be added.
   */
  _doInvalidate(_super) {
    if (!this.doInvalidate) return;

    // Not visible?
    if (jQuery(":visible", this.outerCell).length == 0) {
      return;
    }
    // Update the pixel positions
    this._recalculateElementPosition();

    // Call the callback
    if (this._invalidateCallback) {
      var range = this.getVisibleIndexRange(et2_range(this.scrollarea.scrollTop(), this._scrollHeight));
      this._invalidateCallback.call(this._invalidateContext, range);
    }

    // Get the visible mapping indices and recalculate index and pixel
    // position of the containers.
    var mapVis = this._calculateVisibleMappingIndices();

    // Delete all invisible elements -- if anything changed, we have to
    // recalculate the pixel positions again
    if (this._cleanupOutOfRangeElements(mapVis)) {
      this._recalculateElementPosition();
    }

    // Update the view range of all visible elements that implement the
    // corresponding interface and request elements for all visible spacers
    this._updateContainers();

    // Call the inherited invalidate function, broadcast the invalidation
    // through the container tree.
    if (this._parent && _super) {
      _super._doInvalidate();
    }
  }

  /**
   * Translates the given grid index into the element index of the map. If the
   * given index is completely out of the range, "false" is returned.
   */
  _calculateMapIndex(_index) {
    var top = 0;
    var bot = this._map.length - 1;
    while (top <= bot) {
      var idx = Math.floor((top + bot) / 2);
      var elem = this._map[idx];
      var realIdx = elem.getIndex();
      var realCnt = elem.getCount();
      if (_index >= realIdx && _index < realIdx + realCnt) {
        return idx;
      } else if (_index < realIdx) {
        bot = idx - 1;
      } else {
        top = idx + 1;
      }
    }
    return false;
  }
  _insertContainerAtSpacer(_index, _mapIndex, _mapElem, _container, _avg) {
    // Set the index of the new container
    _container.setIndex(_index);

    // Calculate at which position the spacer has to be splitted
    var splitIdx = _index - _mapElem.getIndex();

    // Get the count of elements that remain at the top of the splitter
    var cntTop = splitIdx;

    // Get the count of elements that remain at the bottom of the splitter
    // -- it has to be one element less than before
    var cntBottom = _mapElem.getCount() - splitIdx - 1;

    // Split the containers if cntTop and cntBottom are larger than zero
    if (cntTop > 0 && cntBottom > 0) {
      // Set the new count of the currently existing container, preserving
      // its height as it was
      _mapElem.setCount(cntTop);

      // Add the new element after the old container
      _container.insertIntoTree(_mapElem.getLastNode());

      // Create a new spacer and add it after the newly inserted container
      var newSpacer = new et2_dataview_spacer(this, this._rowProvider);
      newSpacer.setCount(cntBottom, _avg);
      newSpacer.setIndex(_index + 1);
      newSpacer.insertIntoTree(_container.getLastNode());

      // Insert the container and the new spacer into the map
      this._map.splice(_mapIndex + 1, 0, _container, newSpacer);
    } else if (cntTop === 0 && cntBottom > 0) {
      // Simply adjust the size of the old spacer and insert the new
      // container in front of it
      _container.insertIntoTree(_mapElem.getFirstNode(), true);
      _mapElem.setIndex(_index + 1);
      _mapElem.setCount(cntBottom, _avg);
      this._map.splice(_mapIndex, 0, _container);
    } else if (cntTop > 0 && cntBottom === 0) {
      // Simply add the new container to the end of the old container and
      // adjust the count of the old spacer to the remaining count.
      _container.insertIntoTree(_mapElem.getLastNode());
      _mapElem.setCount(cntTop);
      this._map.splice(_mapIndex + 1, 0, _container);
    } else
      // if (cntTop === 0 && cntBottom === 0)
      {
        // Append the new container to the current container and then
        // destroy the old container
        _container.insertIntoTree(_mapElem.getLastNode());
        _mapElem.destroy();
        this._map.splice(_mapIndex, 1, _container);
      }
  }
  _insertContainerAtElement(_index, _mapIndex, _mapElem, _container, _avg) {
    // In a first step, simply insert the element at the specified position,
    // in front of the element _mapElem.
    _container.setIndex(_index);
    _container.insertIntoTree(_mapElem.getFirstNode(), true);
    this._map.splice(_mapIndex, 0, _container);

    // Search for the next spacer and increment the indices of all other
    // elements until there
    var _newIndex = _index + 1;
    for (var i = _mapIndex + 1; i < this._map.length; i++) {
      // Update the index of the element
      this._map[i].setIndex(_newIndex++);

      // We've found a spacer -- decrement its element count and abort
      if (this._map[i] instanceof et2_dataview_spacer) {
        this._decrementSpacerCount(i, _avg);
        return;
      }
    }

    // We've found no spacer so far, remove the last element from the map in
    // order to obtain the "totalCount" (especially the last element is no
    // spacer, so the following code cannot remove a spacer)
    this._map.pop().destroy();
  }

  /**
   * Inserts the given container at the given index.
   */
  _doInsertContainer(_index, _mapIndex, _container, _avg) {
    // Check whether the given element at the map index is a spacer. If
    // yes, we have to split the spacer at that position.
    var mapElem = this._map[_mapIndex];
    if (mapElem instanceof et2_dataview_spacer) {
      this._insertContainerAtSpacer(_index, _mapIndex, mapElem, _container, _avg);
    } else {
      this._insertContainerAtElement(_index, _mapIndex, mapElem, _container, _avg);
    }
  }

  /**
   * Replaces the container at the given index with a spacer. The function
   * tries to extend any spacer lying above or below the given _mapIndex.
   * This code does not destroy the given container, but maintains its map
   * index.
   *
   * @param _mapIndex is the index of _mapElem in the _map array.
   * @param _mapElem is the container which should be replaced.
   */
  _replaceContainerWithSpacer(_mapIndex, _mapElem) {
    var newAvg;
    var spacer;
    var totalHeight;
    var totalCount;
    // Check whether a spacer can be extended above or below the given
    // _mapIndex
    var spacerAbove = null;
    var spacerBelow = null;
    if (_mapIndex > 0 && this._map[_mapIndex - 1] instanceof et2_dataview_spacer) {
      spacerAbove = this._map[_mapIndex - 1];
    }
    if (_mapIndex < this._map.length - 1 && this._map[_mapIndex + 1] instanceof et2_dataview_spacer) {
      spacerBelow = this._map[_mapIndex + 1];
    }
    if (!spacerAbove && !spacerBelow) {
      // No spacer can be extended -- simply create a new one
      spacer = new et2_dataview_spacer(this, this._rowProvider);
      spacer.setIndex(_mapElem.getIndex());
      spacer.addAvgHeight(_mapElem.getHeight());
      spacer.setCount(1, _mapElem.getHeight());

      // Insert the new spacer at the correct place into the DOM tree and
      // the mapping
      spacer.insertIntoTree(_mapElem.getLastNode());
      this._map.splice(_mapIndex + 1, 0, spacer);
    } else if (spacerAbove && spacerBelow) {
      // We're going to consolidate the upper and the lower spacer. To do
      // that we'll calculate a new count of elements and a new average
      // height, so that the upper container can get the height of all
      // three elements together
      totalHeight = spacerAbove.getHeight() + spacerBelow.getHeight() + _mapElem.getHeight();
      totalCount = spacerAbove.getCount() + spacerBelow.getCount() + 1;
      newAvg = totalHeight / totalCount;

      // Update the upper spacer
      spacerAbove.addAvgHeight(_mapElem.getHeight());
      spacerAbove.setCount(totalCount, newAvg);

      // Delete the lower spacer and remove it from the mapping
      spacerBelow.destroy();
      this._map.splice(_mapIndex + 1, 1);
    } else {
      // One of the two spacers is available
      spacer = spacerAbove || spacerBelow;

      // Calculate the new count and the new average height of that spacer
      totalCount = spacer.getCount() + 1;
      totalHeight = spacer.getHeight() + _mapElem.getHeight();
      newAvg = totalHeight / totalCount;

      // Set the new container height
      spacer.setIndex(Math.min(spacer.getIndex(), _mapElem.getIndex()));
      spacer.addAvgHeight(_mapElem.getHeight());
      spacer.setCount(totalCount, newAvg);
    }
  }

  /**
   * Checks whether there is another spacer below the given map index and if
   * yes, consolidates the two.
   */
  _consolidateSpacers(_mapIndex) {
    if (_mapIndex < this._map.length - 1 && this._map[_mapIndex] instanceof et2_dataview_spacer && this._map[_mapIndex + 1] instanceof et2_dataview_spacer) {
      var spacerAbove = this._map[_mapIndex];
      var spacerBelow = this._map[_mapIndex + 1];

      // Calculate the new height/count of both containers
      var totalHeight = spacerAbove.getHeight() + spacerBelow.getHeight();
      var totalCount = spacerAbove.getCount() + spacerBelow.getCount();
      var newAvg = totalCount / totalHeight;

      // Extend the new spacer
      spacerAbove.setCount(totalCount, newAvg);

      // Delete the old spacer
      spacerBelow.destroy();
      this._map.splice(_mapIndex + 1, 1);
    }
  }

  /**
   * Decrements the count of the spacer at the given _mapIndex by one. If the
   * given spacer has no more elements, it will be removed from the mapping.
   * Note that this function does not update the indices of the following
   * elements, this function is only used internally by the
   * _insertContainerAtElement function and the _doDeleteContainer function
   * where appropriate adjustments to the map data structure are done.
   *
   * @param _mapIndex is the index of the spacer in the "map" data structure.
   * @param _avg is the new average height of the container, may be
   * "undefined" in which case the height of the spacer rows is kept as it
   * was.
   */
  _decrementSpacerCount(_mapIndex, _avg) {
    var cnt = this._map[_mapIndex].getCount() - 1;
    if (cnt > 0) {
      this._map[_mapIndex].setCount(cnt, _avg);
    } else {
      this._map[_mapIndex].destroy();
      this._map.splice(_mapIndex, 1);
    }
  }

  /**
   * Deletes the container at the given index.
   */
  _doDeleteContainer(_mapIndex, _replaceWithSpacer) {
    // _replaceWithSpacer defaults to false
    _replaceWithSpacer = _replaceWithSpacer ? _replaceWithSpacer : false;

    // Fetch the element at the given map index
    var mapElem = this._map[_mapIndex];

    // Indicates whether an element has really been removed -- if yes, the
    // bottom spacer will be extended
    var removedElement = false;

    // Check whether the map element is a spacer -- if yes, we have to do
    // some special treatment
    if (mapElem instanceof et2_dataview_spacer) {
      // Do nothing if the "_replaceWithSpacer" flag is true as the
      // element already is a spacer
      if (!_replaceWithSpacer) {
        this._decrementSpacerCount(_mapIndex);
        removedElement = true;
      }
    } else {
      if (_replaceWithSpacer) {
        this._replaceContainerWithSpacer(_mapIndex, mapElem);
      } else {
        removedElement = true;
      }

      // Remove the complete (current) container, decrement the _mapIndex
      this._map[_mapIndex].destroy();
      this._map.splice(_mapIndex, 1);
      _mapIndex--;

      // The delete operation may have created two joining spacers -- this
      // is highly suboptimal, so we'll consolidate those two spacers
      this._consolidateSpacers(_mapIndex);
    }

    // Update the indices of all elements after the current one, if we've
    // really removed an element
    if (removedElement) {
      for (var i = _mapIndex + 1; i < this._map.length; i++) {
        this._map[i].setIndex(this._map[i].getIndex() - 1);
      }

      // Extend the last spacer as we have to maintain the spacer count
      this._appendEmptyRows(1);
    }
  }

  /**
   * The appendEmptyRows function is used internally to append empty rows to
   * the end of the table. This functionality is needed in order to maintain
   * the "total count" in the _doDeleteContainer function and to increase the
   * "total count" in the "setCount" function.
   *
   * @param _count specifies the count of empty rows that will be added to the
   * end of the table.
   */
  _appendEmptyRows(_count) {
    // Special case -- the last element in the "_map" is no spacer -- this
    // means, that the "managedRange" is currently at the bottom of the list
    // -- so we have to insert a new spacer
    var spacer = null;
    var lastIndex = this._map.length - 1;
    if (this._map.length === 0 || !(this._map[lastIndex] instanceof et2_dataview_spacer)) {
      // Create a new spacer
      spacer = new et2_dataview_spacer(this, this._rowProvider);

      // Insert the spacer -- we have a special case if there currently is
      // no element inside the mapping
      if (this._map.length === 0) {
        // Add a dummy element to the grid
        var dummy = jQuery(document.createElement("tr"));
        this.innerTbody.append(dummy);

        // Append the spacer to the grid
        spacer.setIndex(0);
        spacer.insertIntoTree(dummy, false);

        // Remove the dummy element
        dummy.remove();
      } else {
        // Insert the new spacer after the last element
        spacer.setIndex(this._map[lastIndex].getIndex() + 1);
        spacer.insertIntoTree(this._map[lastIndex].getLastNode());
      }

      // Add the new spacer to the mapping
      this._map.push(spacer);
    } else {
      // Get the spacer at the bottom of the mapping
      spacer = this._map[lastIndex];
    }

    // Update the spacer count
    spacer.setCount(_count + spacer.getCount(), this.getAverageHeight());
  }

  /**
   * The _decreaseTotal function is used to decrease the total row count in
   * the grid. It tries to remove the given count of rows from the spacer
   * located at the bottom of the grid, if this is not possible, it starts
   * removing complete rows.
   *
   * @param _delta specifies how many rows should be removed.
   */
  _decreaseTotal(_delta) {
    // Iterate over the current mapping, starting at the bottom and delete
    // rows. _delta is decreased for each removed row. Abort when delta is
    // zero or the map is empty
    while (_delta > 0 && this._map.length > 0) {
      var cont = this._map[this._map.length - 1];

      // Remove as many containers as possible from spacers
      if (cont instanceof et2_dataview_spacer) {
        var diff = cont.getCount() - _delta;
        if (diff > 0) {
          // We're done as the spacer still has entries left
          _delta = 0;
          cont.setCount(diff, this.getAverageHeight());
          break;
        } else {
          // Decrease _delta by the count of rows the spacer had
          _delta -= diff + _delta;
        }
      } else {
        // We're going to remove a single row: remove it
        _delta -= 1;
      }

      // Destroy the container if there are no rows left
      cont.destroy();
      this._map.pop();
    }

    // Check whether _delta is really zero
    if (_delta > 0) {
      this.egw.debug('error', "Error while decreasing the total count - requested to remove more rows than available.");
    }
  }

  /**
   * Creates the grid DOM-Nodes
   */
  _createNodes() {
    this.tr = jQuery(document.createElement("tr"));
    this.outerCell = jQuery(document.createElement("td")).addClass("frame").attr("colspan", this._rowProvider.getColumnCount() + (this._parentGrid ? 0 : 1)).appendTo(this.tr);

    // Create the scrollarea div if this is the outer grid
    this.scrollarea = null;
    if (this._parentGrid == null) {
      this.scrollarea = jQuery(document.createElement("div")).addClass("egwGridView_scrollarea").scroll(this, function (e) {
        // Clear any older scroll timeout
        if (e.data._scrollTimeout) {
          window.clearTimeout(e.data._scrollTimeout);
        }

        // Clear any existing "invalidate" timeout (as the
        // "setViewRange" function triggered by the scroll event
        // forces an "invalidate").
        if (e.data._invalidateTimeout) {
          window.clearTimeout(e.data._invalidateTimeout);
          e.data._invalidateTimeout = null;
        }

        // Set a new timeout which calls the setViewArea
        // function
        e.data._scrollTimeout = window.setTimeout(jQuery.proxy(function () {
          var newRange = et2_range(this.scrollarea.scrollTop() - et2_dataview_grid.ET2_GRID_VIEW_EXT, this._scrollHeight + et2_dataview_grid.ET2_GRID_VIEW_EXT * 2);
          if (!et2_rangeEqual(newRange, this._viewRange)) {
            this.setViewRange(newRange);
          }
        }, e.data), et2_dataview_grid.ET2_GRID_SCROLL_TIMEOUT);
      }).height(this._scrollHeight).appendTo(this.outerCell);
    }

    // Create the inner table
    var table = jQuery(document.createElement("table")).addClass("egwGridView_grid").appendTo(this.scrollarea ? this.scrollarea : this.outerCell);
    this.innerTbody = jQuery(document.createElement("tbody")).appendTo(table);

    // Set the tr as container element
    this.appendNode(jQuery(this.tr[0]));
  }
}
/**
 * Determines how many pixels the view range of the gridview is extended inside
 * the scroll callback.
 */
_defineProperty$1P(et2_dataview_grid, "ET2_GRID_VIEW_EXT", 50);
/**
 * Determines the timeout after which the scroll-event is processed.
 */
_defineProperty$1P(et2_dataview_grid, "ET2_GRID_SCROLL_TIMEOUT", 50);
/**
 * Determines the timeout after which the invalidate-request gets processed.
 */
_defineProperty$1P(et2_dataview_grid, "ET2_GRID_INVALIDATE_TIMEOUT", 25);
/**
 * Determines how many elements are kept displayed outside of the current view
 * range until they get removed.
 */
_defineProperty$1P(et2_dataview_grid, "ET2_GRID_HOLD_COUNT", 50);

function _defineProperty$1O(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The row provider contains prototypes (full clonable dom-trees)
 * for all registered row types.
 *
 */
class et2_nextmatch_rowProvider {
  /**
   * Creates the nextmatch row provider.
   *
   * @param {et2_nextmatch_rowProvider} _rowProvider
   * @param {function} _subgridCallback
   * @param {object} _context
   * @memberOf et2_nextmatch_rowProvider
   */
  constructor(_rowProvider, _subgridCallback, _context) {
    _defineProperty$1O(this, "_rowProvider", void 0);
    _defineProperty$1O(this, "_subgridCallback", void 0);
    _defineProperty$1O(this, "_context", void 0);
    _defineProperty$1O(this, "_rootWidget", void 0);
    _defineProperty$1O(this, "_template", void 0);
    _defineProperty$1O(this, "_dataRow", void 0);
    /**
     * Match category-ids from class attribute eg. "cat_15" or "123,456,789 "
     *
     * Make sure to not match numbers inside other class-names.
     *
     * We can NOT use something like /(^| |,|cat_)([0-9]+)( |,|$)/g as it wont find all cats in "123,456,789 "!
     */
    _defineProperty$1O(this, "cat_regexp", /(^| |,|cat_)([0-9]+)/g);
    /**
     * Regular expression used to filter out non-nummerical chars from above matches
     */
    _defineProperty$1O(this, "cat_cleanup", /[^0-9]/g);
    // Copy the arguments
    this._rowProvider = _rowProvider;
    this._subgridCallback = _subgridCallback;
    this._context = _context;
    this._createEmptyPrototype();
  }
  destroy() {
    this._rowProvider.destroy();
    this._subgridCallback = null;
    this._context = null;
    this._dataRow = null;
  }

  /**
   * Creates the data row prototype.
   *
   * @param _widgets is an array containing the root widget for each column.
   * @param _rowData contains the properties of the root "tr" (like its class)
   * @param _rootWidget is the parent widget of the data rows (i.e.
   * the nextmatch)
   */
  setDataRowTemplate(_widgets, _rowData, _rootWidget) {
    // Copy the root widget
    this._rootWidget = _rootWidget;

    // Create the base row
    var row = this._rowProvider.getPrototype("default");

    // Copy the row template
    var rowTemplate = {
      "row": row[0],
      "rowData": _rowData,
      "widgets": _widgets,
      "root": _rootWidget,
      "seperated": null,
      "mgrs": _rootWidget.getArrayMgrs()
    };

    // Create the row widget and insert the given widgets into the row
    var rowWidget = new et2_nextmatch_rowWidget(rowTemplate.mgrs, row[0]);
    rowWidget._parent = _rootWidget;
    rowWidget.createWidgets(_widgets);

    // Get the set containing all variable attributes
    var variableAttributes = this._getVariableAttributeSet(rowWidget);

    // Filter out all widgets which do not implement the et2_IDetachedDOM
    // interface or do not support all attributes listed in the et2_IDetachedDOM
    // interface. A warning is issued for all those widgets as they heavily
    // degrade the performance of the dataview
    var seperated = rowTemplate.seperated = this._seperateWidgets(variableAttributes);

    // Remove all DOM-Nodes of all widgets inside the "remaining" slot from
    // the row-template, then build the access functions for the detachable
    // widgets
    this._stripTemplateRow(rowTemplate);
    this._buildNodeAccessFuncs(rowTemplate);

    // Create the DOM row template
    var tmpl = document.createDocumentFragment();
    row.children().each(function () {
      tmpl.appendChild(this);
    });
    this._dataRow = tmpl;
    this._template = rowTemplate;
  }
  getDataRow(_data, _row, _idx, _controller) {
    var _this = this;
    // Clone the row template
    var row = this._dataRow.cloneNode(true);

    // Create array managers with the given data merged in
    var mgrs = et2_arrayMgrs_expand(rowWidget, this._template.mgrs, _data, _idx);

    // Insert the widgets into the row which do not provide the functions
    // to set the _data directly
    var rowWidget = null;
    if (this._template.seperated.remaining.length > 0) {
      // Transform the variable attributes
      for (var i = 0; i < this._template.seperated.remaining.length; i++) {
        var entry = this._template.seperated.remaining[i];
        for (var j = 0; j < entry.data.length; j++) {
          var set = entry.data[j];
          if (typeof entry.widget.options != "undefined") {
            entry.widget.options[set.attribute] = mgrs["content"].expandName(set.expression);
          } else if (entry.widget.getAttributeNames().indexOf(set.attribute) >= 0) {
            entry.widget.setAttribute(set.attribute, mgrs["content"].expandName(set.expression));
          }
        }
      }

      // Create the row widget
      var rowWidget = new et2_nextmatch_rowTemplateWidget(this._rootWidget, row);

      // Let the row widget create the widgets
      rowWidget.createWidgets(mgrs, this._template.placeholders);
    }

    // Update the content of all other widgets
    var _loop = function _loop() {
        var _widget$transformAttr;
        entry = _this._template.seperated.detachable[i];
        var widget = entry.widget;
        var widget_class = window.customElements.get(widget.localName);

        // Parse the attribute expressions
        var data = {};
        var attributes = entry.data.map(attr => attr.attribute);
        for (j = 0; j < entry.data.length; j++) {
          set = entry.data[j];
          data[set.attribute] = mgrs["content"].expandName(set.expression);
        }
        // WebComponent IS the node, and we've already cloned it
        if (typeof widget_class != "undefined") {
          widget = _this._cloneWebComponent(entry, row, data);
          if (!widget) {
            console.warn("Error cloning ", entry);
            return 1; // continue
          }
        } else {
          // Retrieve all DOM-Nodes (legacy widgets)
          nodes = new Array(entry.nodeFuncs.length);
          for (j = 0; j < nodes.length; j++) {
            // Use the previously compiled node function to get the node
            // from the entry
            try {
              nodes[j] = entry.nodeFuncs[j](row);
            } catch (e) {
              debugger;
              continue;
            }
          }
        }

        // Set the array managers first
        widget.setArrayMgrs(mgrs);
        if (typeof data.id != "undefined") {
          widget.id = data.id;
        }

        // Adjust data for that row
        (_widget$transformAttr = widget.transformAttributes) === null || _widget$transformAttr === void 0 || _widget$transformAttr.call(widget, data);

        // Translate
        if (widget_class) {
          Object.keys(data).forEach(key => {
            if (widget_class.translate[key]) {
              data[key] = widget.egw().lang(data[key]);
            }
          });
        }

        // Make sure to only send detached attributes, filter out any deferredProperties
        var filtered = widget.deferredProperties ? Object.keys(data).filter(key => attributes.includes(key)).reduce((obj, key) => {
          obj[key] = data[key];
          return obj;
        }, {}) : data;

        // Call the setDetachedAttributes function
        widget.setDetachedAttributes(nodes, filtered, _data);
      },
      entry,
      j,
      set,
      nodes,
      j;
    for (var i = 0; i < this._template.seperated.detachable.length; i++) {
      if (_loop()) continue;
    }

    // Insert the row into the tr
    var tr = _row.getDOMNode();
    tr.appendChild(row);

    // Make the row expandable
    if (typeof _data.content["is_parent"] !== "undefined" && _data.content["is_parent"]) {
      _row.makeExpandable(true, function () {
        return this._subgridCallback.call(this._context, _row, _data, _controller);
      }, this);

      // Check for kept expansion, and set the row up to be re-expanded
      // Only the top controller tracks expanded, including sub-grids
      var top_controller = _controller;
      while (top_controller._parentController != null) {
        top_controller = top_controller._parentController;
      }
      var expansion_index = top_controller.kept_expansion.indexOf(top_controller.dataStorePrefix + '::' + _data.content[this._context.settings.row_id]);
      if (top_controller.kept_expansion && expansion_index >= 0) {
        top_controller.kept_expansion.splice(expansion_index, 1);
        // Use a timeout since the DOM nodes might not be finished yet
        window.setTimeout(function () {
          _row.expansionButton.trigger('click');
        }, et2_dataview_grid.ET2_GRID_INVALIDATE_TIMEOUT);
      }
    }

    // Set the row data
    this._setRowData(this._template.rowData, tr, mgrs);
    return rowWidget;
  }

  /**
   * Get the cloned web component
   */
  _cloneWebComponent(entry, row, data) {
    // Widget was already cloned from original row, just get it
    var widget = entry.nodeFuncs[0](row);
    // Original widget
    var original = entry.nodeFuncs[0](this._dataRow);

    // N.B. cloneNode widget is missing its unreflected properties and we need to get them from original
    var widget_class = window.customElements.get(widget.localName);
    var properties = widget_class ? widget_class.elementProperties : [];
    properties.forEach((v, key) => {
      widget[key] = original[key];
    });
    if (!widget || widget.localName !== entry.widget.localName) {
      return null;
    }

    // Need to set the parent to the nm or egw() (and probably others) will not be as expected, using window instead
    // of app.  arrayMgrs are fine without this though
    widget._parent = this._context;

    // Deal with the deferred properties like booleans with string values - we can't reflect them, and we don't want to lose them
    // No need to transform here, that happens later
    Object.assign(data, entry.widget.deferredProperties);
    return widget;
  }

  /**
   * Placeholder for empty row
   *
   * The empty row placeholder is used when there are no results to display.
   * This allows the user to still have a drop target, or use actions that
   * do not require a row ID, such as 'Add new'.
   */
  _createEmptyPrototype() {
    var label = this._context && this._context.options && this._context.options.settings.placeholder;
    var placeholder = jQuery(document.createElement("td")).attr("colspan", this._rowProvider.getColumnCount()).css("height", "19px").text(typeof label != "undefined" && label ? label : egw$1().lang("No matches found"));
    this._rowProvider._prototypes["empty"] = jQuery(document.createElement("tr")).addClass("egwGridView_empty").append(placeholder);
  }

  /** -- PRIVATE FUNCTIONS -- **/

  /**
   * Returns an array containing objects which have variable attributes
   *
   * @param {et2_widget} _widget
   */
  _getVariableAttributeSet(_widget) {
    var variableAttributes = [];
    var process = function process(_widget) {
      // Create the attribtues
      var hasAttr = false;
      var widgetData = {
        "widget": _widget,
        "data": []
      };

      // Get all attribute values
      var attrs = [];
      if (_widget.getDetachedAttributes) {
        _widget.getDetachedAttributes(attrs);
        // Manually add in ID for consideration, value won't get pulled without it
        attrs.push("id");
      }
      for (var key of attrs) {
        var attr_name = key;
        var val = _widget[key];
        if (typeof val == "string" && val.indexOf("$") >= 0) {
          hasAttr = true;
          widgetData.data.push({
            "attribute": attr_name,
            "expression": val
          });
        }
      }

      // Legacy
      if (_widget.instanceOf(et2_widget)) {
        for (var _key in _widget.attributes) {
          if (typeof _widget.attributes[_key] !== "object") {
            continue;
          }
          var _attr_name = _key;
          var _val = void 0;
          if (!_widget.attributes[_key].ignore && typeof _widget.options != "undefined" && typeof _widget.options[_key] != "undefined") {
            _val = _widget.options[_key];
          }
          // TODO: Improve detection
          if (typeof _val == "string" && _val.indexOf("$") >= 0) {
            hasAttr = true;
            widgetData.data.push({
              "attribute": _attr_name,
              "expression": _val
            });
          }
        }
      } else {
        // Need to include all webComponents or they lose their event handlers in the clone
        hasAttr = true;
      }

      // Add the entry if there is any data in it
      if (hasAttr) {
        variableAttributes.push(widgetData);
      }
    };

    // Check each column
    var columns = _widget._widgets;
    for (var i = 0; i < columns.length; i++) {
      // If column is hidden, don't process it
      if (typeof columns[i] === 'undefined' || this._context && this._context.columns && this._context.columns[i] && !this._context.columns[i].visible) {
        continue;
      }
      columns[i].iterateOver(process, this);
    }
    return variableAttributes;
  }
  _seperateWidgets(_varAttrs) {
    // The detachable array contains all widgets which implement the
    // et2_IDetachedDOM interface for all needed attributes
    var detachable = [];

    // The remaining array creates all widgets which have to be completely
    // cloned when the widget tree is created
    var remaining = [];

    // Iterate over the widgets
    for (var i = 0; i < _varAttrs.length; i++) {
      var widget = _varAttrs[i].widget;

      // Check whether the widget parents are not allready in the "remaining"
      // slot -  if this is the case do not include the widget at all.
      var insertWidget = true;
      var _checkWidget = function checkWidget(_widget) {
        if (_widget.parent != null) {
          for (var i = 0; i < remaining.length; i++) {
            if (remaining[i].widget == _widget.parent) {
              insertWidget = false;
              return;
            }
          }
          _checkWidget(_widget.parent);
        }
      };
      _checkWidget(widget);

      // Handle the next widget if this one should not be included.
      if (!insertWidget) {
        continue;
      }

      // Check whether the widget implements the et2_IDetachedDOM interface
      var isDetachable = false;
      if (widget.implements && widget.implements(et2_IDetachedDOM)) {
        // Get all attributes the widgets supports to be set in the
        // "detached" mode
        var supportedAttrs = [];
        if (widget.getDetachedAttributes) {
          widget.getDetachedAttributes(supportedAttrs);
        }
        supportedAttrs.push("id");
        isDetachable = true;
        for (var j = 0; j < _varAttrs[i].data.length /* && isDetachable*/; j++) {
          var data = _varAttrs[i].data[j];
          var supportsAttr = supportedAttrs.indexOf(data.attribute) != -1;
          if (!supportsAttr) {
            egw$1.debug("warn", "et2_IDetachedDOM widget " + widget._type + " does not support " + data.attribute);
          }
          isDetachable = isDetachable && supportsAttr;
        }
      }

      // Insert the widget into the correct slot
      if (isDetachable) {
        detachable.push(_varAttrs[i]);
      } else {
        remaining.push(_varAttrs[i]);
      }
    }
    return {
      "detachable": detachable,
      "remaining": remaining
    };
  }

  /**
   * Removes to DOM code for all widgets in the "remaining" slot
   *
   * @param {object} _rowTemplate
   */
  _stripTemplateRow(_rowTemplate) {
    _rowTemplate.placeholders = [];
    for (var i = 0; i < _rowTemplate.seperated.remaining.length; i++) {
      var entry = _rowTemplate.seperated.remaining[i];

      // Issue a warning - widgets which do not implement et2_IDOMNode
      // are very slow
      egw$1.debug("warn", "Non-clonable widget '" + entry.widget._type + "' in dataview row - this " + "might be slow", entry);

      // Set the placeholder for the entry to null
      entry.placeholder = null;

      // Get the outer DOM-Node of the widget
      if (entry.widget.implements(et2_IDOMNode)) {
        var node = entry.widget.getDOMNode(entry.widget);
        if (node && node.parentNode) {
          // Get the parent node and replace the node with a placeholder
          entry.placeholder = document.createElement("span");
          node.parentNode.replaceChild(entry.placeholder, node);
          _rowTemplate.placeholders.push({
            "widget": entry.widget,
            "func": this._compileDOMAccessFunc(_rowTemplate.row, entry.placeholder)
          });
        }
      }
    }
  }
  _nodeIndex(_node) {
    if (_node.parentNode == null) {
      return 0;
    }
    for (var i = 0; i < _node.parentNode.childNodes.length; i++) {
      if (_node.parentNode.childNodes[i] == _node) {
        return i;
      }
    }
    return -1;
  }

  /**
   * Returns a function which does a relative access on the given DOM-Node
   *
   * @param {DOMElement} _root
   * @param {DOMElement} _target
   */
  _compileDOMAccessFunc(_root, _target) {
    function recordPath(_root, _target, _path) {
      if (typeof _path == "undefined") {
        _path = [];
      }
      if (_root != _target && _target) {
        // Get the index of _target in its parent node
        var idx = this._nodeIndex(_target);
        if (idx >= 0) {
          // Add the access selector
          _path.unshift("childNodes[" + idx + "]");

          // Record the remaining path
          return recordPath.call(this, _root, _target.parentNode, _path);
        }
        throw "Internal error while compiling DOM access function.";
      } else {
        _path.unshift("_node");
        return "return " + _path.join(".") + ";";
      }
    }
    return new Function("_node", recordPath.call(this, _root, _target));
  }

  /**
   * Builds relative paths to the DOM-Nodes and compiles fast-access functions
   *
   * @param {object} _rowTemplate
   */
  _buildNodeAccessFuncs(_rowTemplate) {
    for (var i = 0; i < _rowTemplate.seperated.detachable.length; i++) {
      var entry = _rowTemplate.seperated.detachable[i];

      // Get all needed nodes from the widget
      var nodes = window.customElements.get(entry.widget.localName) ? [entry.widget] : entry.widget.getDetachedNodes();
      var nodeFuncs = entry.nodeFuncs = new Array(nodes.length);

      // Record the path to each DOM-Node
      for (var j = 0; j < nodes.length; j++) {
        nodeFuncs[j] = this._compileDOMAccessFunc(_rowTemplate.row, nodes[j]);
      }
    }
  }
  /**
   * Applies additional row data (like the class) to the tr
   *
   * @param {object} _data
   * @param {DOMElement} _tr
   * @param {object} _mgrs
   */
  _setRowData(_data, _tr, _mgrs) {
    // TODO: Implement other fields than "class"
    if (_data["class"]) {
      var classes = _mgrs["content"].expandName(_data["class"]);

      // Get fancy with categories
      var cats = [];
      // Assume any numeric class is a category
      if (_data["class"].indexOf("cat") !== -1 || classes.match(/[0-9]+/)) {
        // Accept either cat, cat_id or category as ID, and look there for category settings
        var category_location = _data["class"].match(/(cat(_id|egory)?)/);
        if (category_location) {
          category_location = category_location[0];
        }
        cats = classes.match(this.cat_regexp) || [];
        classes = classes.replace(this.cat_regexp, '');

        // Set category class
        for (var i = 0; i < cats.length; i++) {
          // Need cat_, classes can't start with a number
          var cat_id = cats[i].replace(this.cat_cleanup, '');
          var cat_class = 'cat_' + cat_id;
          classes += ' ' + cat_class;
        }
        classes += " row_category";
      }
      classes += " row";
      _tr.setAttribute("class", classes);
    }
    if (_data['valign']) {
      var align = _mgrs["content"].expandName(_data["valign"]);
      _tr.setAttribute("valign", align);
    }
  }
}

/**
 * @augments et2_widget
 */
class et2_nextmatch_rowWidget extends et2_widget {
  /**
   * Constructor
   *
   * @param _mgrs
   * @param _row
   * @memberOf et2_nextmatch_rowWidget
   */
  constructor(_mgrs, _row) {
    // Call the parent constructor with some dummy attributes
    super(null, {
      "id": "",
      "type": "rowWidget"
    });

    // Initialize some variables
    _defineProperty$1O(this, "_widgets", void 0);
    _defineProperty$1O(this, "_row", void 0);
    this._widgets = [];

    // Copy the given DOM node and the content arrays
    this._mgrs = _mgrs;
    this._row = _row;
  }

  /**
   * Copies the given array manager and clones the given widgets and inserts
   * them into the row which has been passed in the constructor.
   *
   * @param {array} _widgets
   */
  createWidgets(_widgets) {
    // Clone the given the widgets with this element as parent
    this._widgets = [];
    var row_id = 0;
    for (var i = 0; i < _widgets.length; i++) {
      // Disabled columns might be missing widget - skip it
      if (!_widgets[i]) {
        continue;
      }
      this._widgets[i] = _widgets[i].clone(this);
      this._widgets[i].loadingFinished();
      // Set column alignment from widget
      if (this._widgets[i].align && this._row.childNodes[row_id]) {
        this._row.childNodes[row_id].align = this._widgets[i].align;
      }
      row_id++;
    }
  }

  /**
   * Returns the column node for the given sender
   *
   * @param {et2_widget} _sender
   * @return {DOMElement}
   */
  getDOMNode(_sender) {
    var row_id = 0;
    for (var i = 0; i < this._widgets.length; i++) {
      // Disabled columns might be missing widget - skip it
      if (!this._widgets[i]) {
        continue;
      }
      if (this._widgets[i] == _sender && this._row.childNodes[row_id]) {
        return this._row.childNodes[row_id].childNodes[0]; // Return the i-th td tag
      }

      row_id++;
    }
    return null;
  }
}

/**
 * @augments et2_widget
 */
class et2_nextmatch_rowTemplateWidget extends et2_widget {
  /**
   * Constructor
   *
   * @param _root
   * @param _row
   * @memberOf et2_nextmatch_rowTemplateWidget
   */
  constructor(_root, _row) {
    // Call the parent constructor with some dummy attributes
    super(null, {
      "id": "",
      "type": "rowTemplateWidget"
    });
    _defineProperty$1O(this, "_root", void 0);
    _defineProperty$1O(this, "_row", void 0);
    _defineProperty$1O(this, "_widgets", void 0);
    this._root = _root;
    this._mgrs = {};
    this._row = _row;

    // Set parent to root widget, so sub-widget calls still work
    this._parent = _root;

    // Clone the widgets inside the placeholders array
    this._widgets = [];
  }
  createWidgets(_mgrs, _widgets) {
    // Set the array managers - don't use setArrayMgrs here as this creates
    // an unnecessary copy of the object
    this._mgrs = _mgrs;
    this._widgets = new Array(_widgets.length);
    for (var i = 0; i < _widgets.length; i++) {
      this._row.childNodes[0].childNodes[0];
      this._widgets[i] = {
        "widget": _widgets[i].widget.clone(this),
        "node": _widgets[i].func(this._row)
      };
      this._widgets[i].widget.loadingFinished();
    }
  }

  /**
   * Returns the column node for the given sender
   *
   * @param {et2_widget} _sender
   * @return {DOMElement}
   */
  getDOMNode(_sender) {
    for (var i = 0; i < this._widgets.length; i++) {
      if (this._widgets[i].widget == _sender) {
        return this._widgets[i].node;
      }
    }
    return null;
  }
}

/**
 * EGroupware eTemplate2 - dataview
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright EGroupware GmbH 2011-2021
 */
class et2_dataview_row extends et2_dataview_container {
  /**
   * Creates the row container. Use the "setRow" function to load the actual
   * row content.
   *
   * @param _parent is the row parent container.
   */
  constructor(_parent) {
    // Call the inherited constructor
    super(_parent);

    // Create the outer "tr" tag and append it to the container
    this.tr = jQuery(document.createElement("tr"));
    this.appendNode(this.tr);

    // Grid row which gets expanded when clicking on the corresponding
    // button
    this.expansionContainer = null;
    this.expansionVisible = false;

    // Toggle button which is used to show and hide the expansionContainer
    this.expansionButton = null;
  }
  destroy() {
    if (this.expansionContainer != null) {
      this.expansionContainer.destroy();
    }
    super.destroy();
  }
  clear() {
    this.tr.empty();
  }
  makeExpandable(_expandable, _callback, _context) {
    if (_expandable) {
      // Create the tr and the button if this has not been done yet
      if (!this.expansionButton) {
        this.expansionButton = jQuery(document.createElement("span"));
        this.expansionButton.addClass("arrow closed");
      }

      // Update context
      var self = this;
      this.expansionButton.off("click").on("click", function (e) {
        self._handleExpansionButtonClick(_callback, _context);
        e.stopImmediatePropagation();
      });
      jQuery("td:first", this.tr).prepend(this.expansionButton);
    } else {
      // If the row is made non-expandable, remove the created DOM-Nodes
      if (this.expansionButton) {
        this.expansionButton.remove();
      }
      if (this.expansionContainer) {
        this.expansionContainer.destroy();
      }
      this.expansionButton = null;
      this.expansionContainer = null;
    }
  }
  removeFromTree() {
    if (this.expansionContainer) {
      this.expansionContainer.removeFromTree();
    }
    this.expansionContainer = null;
    this.expansionButton = null;
    super.removeFromTree();
  }
  getDOMNode() {
    return this.tr[0];
  }
  getJNode() {
    return this.tr;
  }
  getHeight() {
    var h = super.getHeight();
    if (this.expansionContainer && this.expansionVisible) {
      h += this.expansionContainer.getHeight();
    }
    return h;
  }
  getAvgHeightData() {
    // Only take the height of the own tr into account
    //var oldVisible = this.expansionVisible;
    this.expansionVisible = false;
    var res = {
      "avgHeight": this.getHeight(),
      "avgCount": 1
    };
    this.expansionVisible = true;
    return res;
  }

  /** -- PRIVATE FUNCTIONS -- **/

  _handleExpansionButtonClick(_callback, _context) {
    // Create the "expansionContainer" if it does not exist yet
    if (!this.expansionContainer) {
      this.expansionContainer = _callback.call(_context);
      this.expansionContainer.insertIntoTree(this.tr);
      this.expansionVisible = false;
    }

    // Toggle the visibility of the expansion tr
    this.expansionVisible = !this.expansionVisible;
    jQuery(this.expansionContainer._nodes[0]).toggle(this.expansionVisible);

    // Set the class of the arrow
    if (this.expansionVisible) {
      this.expansionButton.addClass("opened");
      this.expansionButton.removeClass("closed");
    } else {
      this.expansionButton.addClass("closed");
      this.expansionButton.removeClass("opened");
    }
    this.invalidate();
  }

  /** -- Implementation of et2_dataview_IViewRange -- **/

  setViewRange(_range) {
    if (this.expansionContainer && this.expansionVisible && this.expansionContainer.implements(et2_dataview_IViewRange)) {
      // Substract the height of the own row from the container
      var oh = jQuery(this._nodes[0]).height();
      _range.top -= oh;

      // Proxy the setViewRange call to the expansion container
      this.expansionContainer.setViewRange(_range);
    }
  }
}

function _defineProperty$1N(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Displays tiles or thumbnails (squares) instead of full rows.
 *
 * It's important that the template specifies a fixed width and height (via CSS)
 * so that the rows and columns work out properly.
 *
 */
class et2_dataview_tile extends et2_dataview_row {
  /**
   * Creates the row container. Use the "setRow" function to load the actual
   * row content.
   *
   * @param _parent is the row parent container.
   * @memberOf et2_dataview_row
   */
  constructor(_parent) {
    // Call the inherited constructor
    super(_parent);

    // Make sure the needed class is there to get the CSS
    _defineProperty$1N(this, "columns", 4);
    this.tr.addClass('tile');
  }
  makeExpandable(_expandable, _callback, _context) {
    // Nope.  It mostly works, it's just weird.
  }
  getAvgHeightData() {
    var res = {
      "avgHeight": this.getHeight() / this.columns,
      "avgCount": this.columns
    };
    return res;
  }

  /**
   * Returns the height for the tile.
   *
   * This is where we do the magic.  If a new row should start, we return the proper
   * height.  If this should be another tile in the same row, we say it has 0 height.
   * @returns {Number}
   */
  getHeight() {
    if (this._index % this.columns == 0) {
      return super.getHeight();
    } else {
      return 0;
    }
  }

  /**
   * Broadcasts an invalidation through the container tree. Marks the own
   * height as invalid.
   */
  invalidate() {
    if (this._inTree && this.tr) {
      var template_width = jQuery('.innerContainer', this.tr).children().outerWidth(true);
      if (template_width) {
        this.tr.css('width', template_width + (this.tr.outerWidth(true) - this.tr.width()));
      }
    }
    this._recalculate_columns();
    super.invalidate();
  }

  /**
   * Recalculate how many columns we can fit in a row.
   * While browser takes care of the actual layout, we need this for proper
   * pagination.
   */
  _recalculate_columns() {
    if (this._inTree && this.tr && this.tr.parent()) {
      this.columns = Math.max(1, parseInt(this.tr.parent().innerWidth() / this.tr.outerWidth(true)));
    }
  }
}

/**
 * EGroupware eTemplate2 - Contains interfaces used inside the dataview
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright EGroupware GmbH 2011-2021
 */

/**
 * Contains the action object interface implementation for the nextmatch widget
 * row.
 */

var EGW_SELECTMODE_DEFAULT = 0;
var EGW_SELECTMODE_TOGGLE = 1;

/**
 * An action object interface for each nextmatch widget row - "inherits" from
 * egwActionObjectInterface
 *
 * @param {DOMNode} _node
 */
function et2_dataview_rowAOI(_node) {
  "use strict";

  var aoi = new egwActionObjectInterface();
  aoi.node = _node;
  aoi.selectMode = EGW_SELECTMODE_DEFAULT;
  aoi.checkBox = null; //(jQuery(":checkbox", aoi.node))[0];

  // Rows without a checkbox OR an id set are unselectable
  aoi.doGetDOMNode = function () {
    return aoi.node;
  };

  // Prevent the browser from selecting the content of the element, when
  // a special key is pressed.
  //Seems not to be necessary in nextmatch anymore
  //_node.addEventListener("mousedown",egwPreventSelect);

  /**
   * Now append some action code to the node
   *
   * @memberOf et2_dataview_rowAOI
   * @param {DOMEvent} e
   * @param {object} _params
   */
  var selectHandler = function selectHandler(e, _params) {
    // Reset the focus so that keyboard navigation will work properly
    // after the element has been clicked
    egwUnfocus();

    // Reset the prevent selection code (in order to allow wanted
    // selection of text)
    _node.onselectstart = null;
    if (e.target != aoi.checkBox) {
      var selected = egwBitIsSet(aoi.getState(), EGW_AO_STATE_SELECTED);
      var state = egwGetShiftState(e);
      if (_params) {
        if (egwIsMobile$1()) {
          switch (_params.swip) {
            case "left":
            case "right":
              state = 1;
              // Hide context menu on swip actions
              if (_egw_active_menu) _egw_active_menu.hide();
              break;
            case "up":
            case "down":
              return;
          }
        }
      }
      switch (aoi.selectMode) {
        case EGW_SELECTMODE_DEFAULT:
          aoi.updateState(EGW_AO_STATE_SELECTED, !egwBitIsSet(state, EGW_AO_SHIFT_STATE_MULTI) || !selected, state);
          break;
        case EGW_SELECTMODE_TOGGLE:
          aoi.updateState(EGW_AO_STATE_SELECTED, !selected, egwSetBit(state, EGW_AO_SHIFT_STATE_MULTI, true));
          break;
      }
    }
  };
  if (egwIsMobile$1()) {
    var swipe = new tapAndSwipe(_node, {
      // set the same threshold as action_popup event to get the tapAndHold working
      tapHoldThreshold: 1000,
      swipe: function swipe(event, direction, distance) {
        selectHandler(event, {
          swip: direction
        });
      },
      tap: function tap(event) {
        selectHandler(event);
      },
      tapAndHold: function tapAndHold(event) {
        return;
      }
    });
  } else {
    jQuery(_node).click(selectHandler);
  }
  jQuery(aoi.checkBox).change(function () {
    aoi.updateState(EGW_AO_STATE_SELECTED, this.checked, EGW_AO_SHIFT_STATE_MULTI);
  });
  aoi.doSetState = function (_state) {
    var selected = egwBitIsSet(_state, EGW_AO_STATE_SELECTED);
    if (this.checkBox) {
      this.checkBox.checked = selected;
    }
    jQuery(this.node).toggleClass('focused', egwBitIsSet(_state, EGW_AO_STATE_FOCUSED));
    jQuery(this.node).toggleClass('selected', selected);
  };
  return aoi;
}

function _defineProperty$1M(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Class which implements the "button" XET-Tag
 */
class et2_button extends et2_baseWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_button._attributes, _child || {}));
    _defineProperty$1M(this, "label", "");
    _defineProperty$1M(this, "clicked", false);
    _defineProperty$1M(this, "btn", null);
    _defineProperty$1M(this, "image", null);
    if (!this.options.background_image && (this.options.image || this.options.ro_image)) {
      this.image = jQuery(document.createElement("img")).addClass("et2_button et2_button_icon");
      if (!this.options.readonly) this.image.addClass("et2_clickable");
      this.setDOMNode(this.image[0]);
      return;
    }
    if (!this.options.readonly || this.options.ro_image) {
      this.btn = jQuery(document.createElement("button")).addClass("et2_button").attr({
        type: "button"
      });
      this.setDOMNode(this.btn[0]);
    }
    if (this.options.image) this.set_image(this.options.image);
  }

  /**
   * Apply the "modifications" to the element and translate attributes marked
   * with "translate: true"
   *
   * Reimplemented here to assign default background-images to buttons
   *
   * @param {object} _attrs
   */
  transformAttributes(_attrs) {
    if (this.id && typeof _attrs.background_image == 'undefined' && !_attrs.image) {
      for (var image in et2_button.default_background_images) {
        if (this.id.match(et2_button.default_background_images[image])) {
          _attrs.image = image;
          _attrs.background_image = true;
          break;
        }
      }
    }
    for (var name in et2_button.default_classes) {
      if (this.id.match(et2_button.default_classes[name])) {
        _attrs.class = (typeof _attrs.class == 'undefined' ? '' : _attrs.class + ' ') + name;
        break;
      }
    }
    super.transformAttributes(_attrs);
  }
  set_accesskey(key) {
    jQuery(this.node).attr("accesskey", key);
  }
  /**
   * Set image and update current image
   *
   * @param _image
   */
  set_image(_image) {
    this.options.image = _image;
    this.update_image();
  }
  /**
   * Set readonly image and update current image
   *
   * @param _image
   */
  set_ro_image(_image) {
    this.options.ro_image = _image;
    this.update_image();
  }
  /**
   * Set current image (dont update options.image)
   *
   * @param _image
   */
  update_image(_image) {
    if (!this.isInTree() || !this.options.background_image && this.image == null) return;
    if (typeof _image == 'undefined') _image = this.options.readonly ? this.options.ro_image || this.options.image : this.options.image;

    // Silently blank for percentages instead of warning about missing image - use a progress widget
    if (_image.match(/^[0-9]+\%$/)) {
      _image = "";
      //this.egw().debug("warn", "Use a progress widget instead of percentage images", this);
    }

    var found_image = false;
    if (_image != "") {
      var src = this.egw().image(_image);
      if (src) {
        found_image = true;
      } else if (_image[0] == '/' || _image.substr(0, 4) == 'http') {
        src = _image;
        found_image = true;
      }
      if (found_image) {
        if (this.image != null) {
          this.image.attr("src", src);
        } else if (this.options.background_image && this.btn) {
          this.btn.css("background-image", "url(" + src + ")");
          this.btn.addClass('et2_button_with_image');
        }
      }
    }
    if (!found_image) {
      this.set_label(this.label);
      if (this.btn) {
        this.btn.css("background-image", "");
        this.btn.removeClass('et2_button_with_image');
      }
    }
  }

  /**
   * Set options.readonly and update image
   *
   * @param {boolean} _ro
   */
  set_readonly(_ro) {
    if (_ro != this.options.readonly) {
      this.options.readonly = _ro;
      if (this.options.image || this.options.ro_image) {
        this.update_image();
      }
      // dont show readonly buttons as clickable
      if (this.btn || this.image) {
        (this.btn || this.image).toggleClass('et2_clickable', !_ro).toggleClass('et2_button_ro', _ro).css('cursor', _ro ? 'default' : 'pointer'); // temp. 'til it is removed from et2_button
      }
    }
  }

  attachToDOM() {
    var ret = super.attachToDOM();
    if (this.options.readonly && (this.btn || this.image)) {
      (this.btn || this.image).removeClass('et2_clickable').addClass('et2_button_ro').css('cursor', 'default'); // temp. 'til it is removed from et2_button
    }

    return ret;
  }
  getDOMNode() {
    return this.btn ? this.btn[0] : this.image ? this.image[0] : null;
  }

  /**
   * Overwritten to maintain an internal clicked attribute
   *
   * @param _ev
   * @returns {Boolean}
   */
  click(_ev) {
    var _this$btn, _this$getInstanceMana;
    // ignore click on readonly button
    if (this.options.readonly) return false;
    this.clicked = true;

    // Cancel buttons don't trigger the close confirmation prompt
    if ((_this$btn = this.btn) !== null && _this$btn !== void 0 && _this$btn.hasClass("et2_button_cancel")) {
      this.getInstanceManager().skip_close_prompt();
    }
    if (!super.click.apply(this, arguments)) {
      this.clicked = false;
      return false;
    }

    // Submit the form
    if (this.getType() != "buttononly") {
      this.getInstanceManager().submit(this, false, this.options.novalidate); //TODO: this only needs to be passed if it's in a datagrid
    }

    this.clicked = false;
    (_this$getInstanceMana = this.getInstanceManager()) === null || _this$getInstanceMana === void 0 || _this$getInstanceMana.skip_close_prompt(false);
    return true;
  }
  set_label(_value) {
    if (this.btn) {
      this.label = _value;
      this.btn.text(_value);
      if (_value && !this.image) this.btn.addClass('et2_button_text');else this.btn.removeClass('et2_button_text');
    }
    if (this.image) {
      this.image.attr("alt", _value);
      // Don't set title if there's a tooltip, browser may show both
      if (!this.options.statustext) {
        this.image.attr("title", _value);
      }
    }
  }

  /**
   * Set tab index
   *
   * @param {number} index
   */
  set_tabindex(index) {
    jQuery(this.btn).attr("tabindex", index);
  }

  /**
   * Implementation of the et2_IInput interface
   */

  /**
   * Always return false as a button is never dirty
   */
  isDirty() {
    return false;
  }
  resetDirty() {}
  getValue() {
    if (this.clicked) {
      return true;
    }

    // If "null" is returned, the result is not added to the submitted
    // array.
    return null;
  }
  isValid() {
    return true;
  }

  /**
   * et2_IDetachedDOM
   *
   * @param {array} _attrs
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("label", "value", "class", "image", "ro_image", "onclick", "background_image");
  }
  getDetachedNodes() {
    return [this.btn != null ? this.btn[0] : null, this.image != null ? this.image[0] : null];
  }
  setDetachedAttributes(_nodes, _values) {
    // Datagrid puts in the row for null
    this.btn = _nodes[0].nodeName[0] != '#' ? jQuery(_nodes[0]) : null;
    this.image = jQuery(_nodes[1]);
    if (typeof _values["id"] != "undefined") {
      this.set_id(_values["id"]);
    }
    if (typeof _values["label"] != "undefined") {
      this.set_label(_values["label"]);
    }
    if (typeof _values["value"] != "undefined") {}
    if (typeof _values["image"] != "undefined") {
      this.set_image(_values["image"]);
    }
    if (typeof _values["ro_image"] != "undefined") {
      this.set_ro_image(_values["ro_image"]);
    }
    if (typeof _values["class"] != "undefined") {
      this.set_class(_values["class"]);
    }
    if (typeof _values["onclick"] != "undefined") {
      this.options.onclick = _values["onclick"];
    }
    var type = this.getType();
    var attrs = jQuery.extend(_values, this.options);
    var parent = this.getParent();
    jQuery(this.getDOMNode()).bind("click.et2_baseWidget", this, function (e) {
      var widget = et2_createWidget(type, attrs, parent);
      e.data = widget;
      e.data.set_id(_values["id"]);
      return e.data.click.call(e.data, e);
    });
  }
}
_defineProperty$1M(et2_button, "_attributes", {
  "label": {
    "name": "caption",
    "type": "string",
    "description": "Label of the button",
    "translate": true
  },
  "image": {
    "name": "Icon",
    "type": "string",
    "description": "Use an icon instead of label (when available)"
  },
  "ro_image": {
    "name": "Read-only Icon",
    "type": "string",
    "description": "Use this icon instead of hiding for read-only"
  },
  "onclick": {
    "description": "JS code which gets executed when the button is clicked",
    "type": "js"
  },
  "accesskey": {
    "name": "Access Key",
    "type": "string",
    "default": et2_no_init,
    "description": "Alt + <key> activates widget"
  },
  "tabindex": {
    "name": "Tab index",
    "type": "integer",
    "default": et2_no_init,
    "description": "Specifies the tab order of a widget when the 'tab' button is used for navigating."
  },
  background_image: {
    name: "Add image in front of text",
    type: "boolean",
    description: "Adds image in front of text instead of just using an image with text as tooltip",
    default: et2_no_init // to leave it undefined, if not defined, so background-image is assigned by default
  },

  novalidate: {
    name: "Do NOT validate form",
    type: "boolean",
    description: "Do NOT validate form before submitting it",
    default: false
  },
  // No such thing as a required button
  "needed": {
    "ignore": true
  }
});
_defineProperty$1M(et2_button, "legacyOptions", ["image", "ro_image"]);
/**
 * images to be used as background-image, if none is explicitly applied and id matches given regular expression
 */
_defineProperty$1M(et2_button, "default_background_images", {
  save: /save(&|\]|$)/,
  apply: /apply(&|\]|$)/,
  cancel: /cancel(&|\]|$)/,
  delete: /delete(&|\]|$)/,
  discard: /discard(&|\]|$)/,
  edit: /edit(&|\[\]|$)/,
  next: /(next|continue)(&|\]|$)/,
  finish: /finish(&|\]|$)/,
  back: /(back|previous)(&|\]|$)/,
  copy: /copy(&|\]|$)/,
  more: /more(&|\]|$)/,
  check: /(yes|check)(&|\]|$)/,
  cancelled: /no(&|\]|$)/,
  ok: /ok(&|\]|$)/,
  close: /close(&|\]|$)/,
  add: /(add(&|\]|$)|create)/ // customfields use create*
});
/**
 * Classnames added automatic to buttons to set certain hover background colors
 */
_defineProperty$1M(et2_button, "default_classes", {
  et2_button_cancel: /cancel(&|\]|$)/,
  // yellow
  et2_button_question: /(yes|no)(&|\]|$)/,
  // yellow
  et2_button_delete: /delete(&|\]|$)/ // red
});

et2_register_widget(et2_button, ["button", "buttononly", "old-button", "old-buttononly"]);

var isWindow = (thing => !!(thing && thing.Window) && thing instanceof thing.Window);

let realWindow = undefined;
let win = undefined;
function init$4(window) {
  // get wrapped window if using Shadow DOM polyfill
  realWindow = window; // create a TextNode

  const el = window.document.createTextNode(''); // check if it's wrapped by a polyfill

  if (el.ownerDocument !== window.document && typeof window.wrap === 'function' && window.wrap(el) === el) {
    // use wrapped window
    window = window.wrap(window);
  }

  win = window;
}

if (typeof window !== 'undefined' && !!window) {
  init$4(window);
}

function getWindow(node) {
  if (isWindow(node)) {
    return node;
  }

  const rootNode = node.ownerDocument || node;
  return rootNode.defaultView || win.window;
}

const window$1 = thing => thing === win || isWindow(thing);

const docFrag = thing => object(thing) && thing.nodeType === 11;

const object = thing => !!thing && typeof thing === 'object';

const func = thing => typeof thing === 'function';

const number = thing => typeof thing === 'number';

const bool = thing => typeof thing === 'boolean';

const string = thing => typeof thing === 'string';

const element = thing => {
  if (!thing || typeof thing !== 'object') {
    return false;
  } // eslint-disable-next-line import/no-named-as-default-member


  const _window = getWindow(thing) || win;

  return /object|function/.test(typeof _window.Element) ? thing instanceof _window.Element // DOM2
  : thing.nodeType === 1 && typeof thing.nodeName === 'string';
};

const plainObject = thing => object(thing) && !!thing.constructor && /function Object\b/.test(thing.constructor.toString());

const array = thing => object(thing) && typeof thing.length !== 'undefined' && func(thing.splice);

var is = {
  window: window$1,
  docFrag,
  object,
  func,
  number,
  bool,
  string,
  element,
  plainObject,
  array
};

function install$g(scope) {
  const {
    actions,
    Interactable,
    defaults
  } = scope;
  Interactable.prototype.draggable = drag.draggable;
  actions.map.drag = drag;
  actions.methodDict.drag = 'draggable';
  defaults.actions.drag = drag.defaults;
}

function beforeMove({
  interaction
}) {
  if (interaction.prepared.name !== 'drag') return;
  const axis = interaction.prepared.axis;

  if (axis === 'x') {
    interaction.coords.cur.page.y = interaction.coords.start.page.y;
    interaction.coords.cur.client.y = interaction.coords.start.client.y;
    interaction.coords.velocity.client.y = 0;
    interaction.coords.velocity.page.y = 0;
  } else if (axis === 'y') {
    interaction.coords.cur.page.x = interaction.coords.start.page.x;
    interaction.coords.cur.client.x = interaction.coords.start.client.x;
    interaction.coords.velocity.client.x = 0;
    interaction.coords.velocity.page.x = 0;
  }
}

function move$1({
  iEvent,
  interaction
}) {
  if (interaction.prepared.name !== 'drag') return;
  const axis = interaction.prepared.axis;

  if (axis === 'x' || axis === 'y') {
    const opposite = axis === 'x' ? 'y' : 'x';
    iEvent.page[opposite] = interaction.coords.start.page[opposite];
    iEvent.client[opposite] = interaction.coords.start.client[opposite];
    iEvent.delta[opposite] = 0;
  }
}
/**
 * ```js
 * interact(element).draggable({
 *     onstart: function (event) {},
 *     onmove : function (event) {},
 *     onend  : function (event) {},
 *
 *     // the axis in which the first movement must be
 *     // for the drag sequence to start
 *     // 'xy' by default - any direction
 *     startAxis: 'x' || 'y' || 'xy',
 *
 *     // 'xy' by default - don't restrict to one axis (move in any direction)
 *     // 'x' or 'y' to restrict movement to either axis
 *     // 'start' to restrict movement to the axis the drag started in
 *     lockAxis: 'x' || 'y' || 'xy' || 'start',
 *
 *     // max number of drags that can happen concurrently
 *     // with elements of this Interactable. Infinity by default
 *     max: Infinity,
 *
 *     // max number of drags that can target the same element+Interactable
 *     // 1 by default
 *     maxPerElement: 2
 * })
 *
 * var isDraggable = interact('element').draggable(); // true
 * ```
 *
 * Get or set whether drag actions can be performed on the target
 *
 * @alias Interactable.prototype.draggable
 *
 * @param {boolean | object} [options] true/false or An object with event
 * listeners to be fired on drag events (object makes the Interactable
 * draggable)
 * @return {boolean | Interactable} boolean indicating if this can be the
 * target of drag events, or this Interctable
 */


const draggable = function draggable(options) {
  if (is.object(options)) {
    this.options.drag.enabled = options.enabled !== false;
    this.setPerAction('drag', options);
    this.setOnEvents('drag', options);

    if (/^(xy|x|y|start)$/.test(options.lockAxis)) {
      this.options.drag.lockAxis = options.lockAxis;
    }

    if (/^(xy|x|y)$/.test(options.startAxis)) {
      this.options.drag.startAxis = options.startAxis;
    }

    return this;
  }

  if (is.bool(options)) {
    this.options.drag.enabled = options;
    return this;
  }

  return this.options.drag;
};

const drag = {
  id: 'actions/drag',
  install: install$g,
  listeners: {
    'interactions:before-action-move': beforeMove,
    'interactions:action-resume': beforeMove,
    // dragmove
    'interactions:action-move': move$1,
    'auto-start:check': arg => {
      const {
        interaction,
        interactable,
        buttons
      } = arg;
      const dragOptions = interactable.options.drag;

      if (!(dragOptions && dragOptions.enabled) || // check mouseButton setting if the pointer is down
      interaction.pointerIsDown && /mouse|pointer/.test(interaction.pointerType) && (buttons & interactable.options.drag.mouseButtons) === 0) {
        return undefined;
      }

      arg.action = {
        name: 'drag',
        axis: dragOptions.lockAxis === 'start' ? dragOptions.startAxis : dragOptions.lockAxis
      };
      return false;
    }
  },
  draggable,
  beforeMove,
  move: move$1,
  defaults: {
    startAxis: 'xy',
    lockAxis: 'xy'
  },

  getCursor() {
    return 'move';
  }

};

const domObjects = {
  init: init$3,
  document: null,
  DocumentFragment: null,
  SVGElement: null,
  SVGSVGElement: null,
  SVGElementInstance: null,
  Element: null,
  HTMLElement: null,
  Event: null,
  Touch: null,
  PointerEvent: null
};

function blank() {}

function init$3(window) {
  const win = window;
  domObjects.document = win.document;
  domObjects.DocumentFragment = win.DocumentFragment || blank;
  domObjects.SVGElement = win.SVGElement || blank;
  domObjects.SVGSVGElement = win.SVGSVGElement || blank;
  domObjects.SVGElementInstance = win.SVGElementInstance || blank;
  domObjects.Element = win.Element || blank;
  domObjects.HTMLElement = win.HTMLElement || domObjects.Element;
  domObjects.Event = win.Event;
  domObjects.Touch = win.Touch || blank;
  domObjects.PointerEvent = win.PointerEvent || win.MSPointerEvent;
}

const browser$1 = {
  init: init$2,
  supportsTouch: null,
  supportsPointerEvent: null,
  isIOS7: null,
  isIOS: null,
  isIe9: null,
  isOperaMobile: null,
  prefixedMatchesSelector: null,
  pEventTypes: null,
  wheelEvent: null
};

function init$2(window) {
  const Element = domObjects.Element;
  const navigator = window.navigator || {}; // Does the browser support touch input?

  browser$1.supportsTouch = 'ontouchstart' in window || is.func(window.DocumentTouch) && domObjects.document instanceof window.DocumentTouch; // Does the browser support PointerEvents

  browser$1.supportsPointerEvent = navigator.pointerEnabled !== false && !!domObjects.PointerEvent;
  browser$1.isIOS = /iP(hone|od|ad)/.test(navigator.platform); // scrolling doesn't change the result of getClientRects on iOS 7

  browser$1.isIOS7 = /iP(hone|od|ad)/.test(navigator.platform) && /OS 7[^\d]/.test(navigator.appVersion);
  browser$1.isIe9 = /MSIE 9/.test(navigator.userAgent); // Opera Mobile must be handled differently

  browser$1.isOperaMobile = navigator.appName === 'Opera' && browser$1.supportsTouch && /Presto/.test(navigator.userAgent); // prefix matchesSelector

  browser$1.prefixedMatchesSelector = 'matches' in Element.prototype ? 'matches' : 'webkitMatchesSelector' in Element.prototype ? 'webkitMatchesSelector' : 'mozMatchesSelector' in Element.prototype ? 'mozMatchesSelector' : 'oMatchesSelector' in Element.prototype ? 'oMatchesSelector' : 'msMatchesSelector';
  browser$1.pEventTypes = browser$1.supportsPointerEvent ? domObjects.PointerEvent === window.MSPointerEvent ? {
    up: 'MSPointerUp',
    down: 'MSPointerDown',
    over: 'mouseover',
    out: 'mouseout',
    move: 'MSPointerMove',
    cancel: 'MSPointerCancel'
  } : {
    up: 'pointerup',
    down: 'pointerdown',
    over: 'pointerover',
    out: 'pointerout',
    move: 'pointermove',
    cancel: 'pointercancel'
  } : null; // because Webkit and Opera still use 'mousewheel' event type

  browser$1.wheelEvent = domObjects.document && 'onmousewheel' in domObjects.document ? 'mousewheel' : 'wheel';
}

function nodeContains(parent, child) {
  if (parent.contains) {
    return parent.contains(child);
  }

  while (child) {
    if (child === parent) {
      return true;
    }

    child = child.parentNode;
  }

  return false;
}
function closest$1(element, selector) {
  while (is.element(element)) {
    if (matchesSelector(element, selector)) {
      return element;
    }

    element = parentNode(element);
  }

  return null;
}
function parentNode(node) {
  let parent = node.parentNode;

  if (is.docFrag(parent)) {
    // skip past #shado-root fragments
    // tslint:disable-next-line
    while ((parent = parent.host) && is.docFrag(parent)) {
      continue;
    }

    return parent;
  }

  return parent;
}
function matchesSelector(element, selector) {
  // remove /deep/ from selectors if shadowDOM polyfill is used
  if (win !== realWindow) {
    selector = selector.replace(/\/deep\//g, ' ');
  }

  return element[browser$1.prefixedMatchesSelector](selector);
}

const getParent = el => el.parentNode || el.host; // Test for the element that's "above" all other qualifiers


function indexOfDeepestElement(elements) {
  let deepestNodeParents = [];
  let deepestNodeIndex;

  for (let i = 0; i < elements.length; i++) {
    const currentNode = elements[i];
    const deepestNode = elements[deepestNodeIndex]; // node may appear in elements array multiple times

    if (!currentNode || i === deepestNodeIndex) {
      continue;
    }

    if (!deepestNode) {
      deepestNodeIndex = i;
      continue;
    }

    const currentNodeParent = getParent(currentNode);
    const deepestNodeParent = getParent(deepestNode); // check if the deepest or current are document.documentElement/rootElement
    // - if the current node is, do nothing and continue

    if (currentNodeParent === currentNode.ownerDocument) {
      continue;
    } // - if deepest is, update with the current node and continue to next
    else if (deepestNodeParent === currentNode.ownerDocument) {
        deepestNodeIndex = i;
        continue;
      } // compare zIndex of siblings


    if (currentNodeParent === deepestNodeParent) {
      if (zIndexIsHigherThan(currentNode, deepestNode)) {
        deepestNodeIndex = i;
      }

      continue;
    } // populate the ancestry array for the latest deepest node


    deepestNodeParents = deepestNodeParents.length ? deepestNodeParents : getNodeParents(deepestNode);
    let ancestryStart; // if the deepest node is an HTMLElement and the current node is a non root svg element

    if (deepestNode instanceof domObjects.HTMLElement && currentNode instanceof domObjects.SVGElement && !(currentNode instanceof domObjects.SVGSVGElement)) {
      // TODO: is this check necessary? Was this for HTML elements embedded in SVG?
      if (currentNode === deepestNodeParent) {
        continue;
      }

      ancestryStart = currentNode.ownerSVGElement;
    } else {
      ancestryStart = currentNode;
    }

    const currentNodeParents = getNodeParents(ancestryStart, deepestNode.ownerDocument);
    let commonIndex = 0; // get (position of closest common ancestor) + 1

    while (currentNodeParents[commonIndex] && currentNodeParents[commonIndex] === deepestNodeParents[commonIndex]) {
      commonIndex++;
    }

    const parents = [currentNodeParents[commonIndex - 1], currentNodeParents[commonIndex], deepestNodeParents[commonIndex]];

    if (parents[0]) {
      let child = parents[0].lastChild;

      while (child) {
        if (child === parents[1]) {
          deepestNodeIndex = i;
          deepestNodeParents = currentNodeParents;
          break;
        } else if (child === parents[2]) {
          break;
        }

        child = child.previousSibling;
      }
    }
  }

  return deepestNodeIndex;
}

function getNodeParents(node, limit) {
  const parents = [];
  let parent = node;
  let parentParent;

  while ((parentParent = getParent(parent)) && parent !== limit && parentParent !== parent.ownerDocument) {
    parents.unshift(parent);
    parent = parentParent;
  }

  return parents;
}

function zIndexIsHigherThan(higherNode, lowerNode) {
  const higherIndex = parseInt(getWindow(higherNode).getComputedStyle(higherNode).zIndex, 10) || 0;
  const lowerIndex = parseInt(getWindow(lowerNode).getComputedStyle(lowerNode).zIndex, 10) || 0;
  return higherIndex >= lowerIndex;
}

function matchesUpTo(element, selector, limit) {
  while (is.element(element)) {
    if (matchesSelector(element, selector)) {
      return true;
    }

    element = parentNode(element);

    if (element === limit) {
      return matchesSelector(element, selector);
    }
  }

  return false;
}
function getActualElement(element) {
  return element.correspondingUseElement || element;
}
function getScrollXY(relevantWindow) {
  relevantWindow = relevantWindow || win;
  return {
    x: relevantWindow.scrollX || relevantWindow.document.documentElement.scrollLeft,
    y: relevantWindow.scrollY || relevantWindow.document.documentElement.scrollTop
  };
}
function getElementClientRect(element) {
  const clientRect = element instanceof domObjects.SVGElement ? element.getBoundingClientRect() : element.getClientRects()[0];
  return clientRect && {
    left: clientRect.left,
    right: clientRect.right,
    top: clientRect.top,
    bottom: clientRect.bottom,
    width: clientRect.width || clientRect.right - clientRect.left,
    height: clientRect.height || clientRect.bottom - clientRect.top
  };
}
function getElementRect(element) {
  const clientRect = getElementClientRect(element);

  if (!browser$1.isIOS7 && clientRect) {
    const scroll = getScrollXY(getWindow(element));
    clientRect.left += scroll.x;
    clientRect.right += scroll.x;
    clientRect.top += scroll.y;
    clientRect.bottom += scroll.y;
  }

  return clientRect;
}
function getPath(node) {
  const path = [];

  while (node) {
    path.push(node);
    node = parentNode(node);
  }

  return path;
}
function trySelector(value) {
  if (!is.string(value)) {
    return false;
  } // an exception will be raised if it is invalid


  domObjects.document.querySelector(value);
  return true;
}

function extend$1(dest, source) {
  for (const prop in source) {
    ;
    dest[prop] = source[prop];
  }

  const ret = dest;
  return ret;
}

function getStringOptionResult(value, target, element) {
  if (value === 'parent') {
    return parentNode(element);
  }

  if (value === 'self') {
    return target.getRect(element);
  }

  return closest$1(element, value);
}
function resolveRectLike(value, target, element, functionArgs) {
  let returnValue = value;

  if (is.string(returnValue)) {
    returnValue = getStringOptionResult(returnValue, target, element);
  } else if (is.func(returnValue)) {
    returnValue = returnValue(...functionArgs);
  }

  if (is.element(returnValue)) {
    returnValue = getElementRect(returnValue);
  }

  return returnValue;
}
function rectToXY(rect) {
  return rect && {
    x: 'x' in rect ? rect.x : rect.left,
    y: 'y' in rect ? rect.y : rect.top
  };
}
function xywhToTlbr(rect) {
  if (rect && !('left' in rect && 'top' in rect)) {
    rect = extend$1({}, rect);
    rect.left = rect.x || 0;
    rect.top = rect.y || 0;
    rect.right = rect.right || rect.left + rect.width;
    rect.bottom = rect.bottom || rect.top + rect.height;
  }

  return rect;
}
function tlbrToXywh(rect) {
  if (rect && !('x' in rect && 'y' in rect)) {
    rect = extend$1({}, rect);
    rect.x = rect.left || 0;
    rect.y = rect.top || 0;
    rect.width = rect.width || (rect.right || 0) - rect.x;
    rect.height = rect.height || (rect.bottom || 0) - rect.y;
  }

  return rect;
}
function addEdges(edges, rect, delta) {
  if (edges.left) {
    rect.left += delta.x;
  }

  if (edges.right) {
    rect.right += delta.x;
  }

  if (edges.top) {
    rect.top += delta.y;
  }

  if (edges.bottom) {
    rect.bottom += delta.y;
  }

  rect.width = rect.right - rect.left;
  rect.height = rect.bottom - rect.top;
}

function getOriginXY (target, element, actionName) {
  const actionOptions = target.options[actionName];
  const actionOrigin = actionOptions && actionOptions.origin;
  const origin = actionOrigin || target.options.origin;
  const originRect = resolveRectLike(origin, target, element, [target && element]);
  return rectToXY(originRect) || {
    x: 0,
    y: 0
  };
}

function normalize(type, listeners, result) {
  result = result || {};

  if (is.string(type) && type.search(' ') !== -1) {
    type = split$1(type);
  }

  if (is.array(type)) {
    return type.reduce((acc, t) => extend$1(acc, normalize(t, listeners, result)), result);
  } // ({ type: fn }) -> ('', { type: fn })


  if (is.object(type)) {
    listeners = type;
    type = '';
  }

  if (is.func(listeners)) {
    result[type] = result[type] || [];
    result[type].push(listeners);
  } else if (is.array(listeners)) {
    for (const l of listeners) {
      normalize(type, l, result);
    }
  } else if (is.object(listeners)) {
    for (const prefix in listeners) {
      const combinedTypes = split$1(prefix).map(p => `${type}${p}`);
      normalize(combinedTypes, listeners[prefix], result);
    }
  }

  return result;
}

function split$1(type) {
  return type.trim().split(/ +/);
}

var hypot = ((x, y) => Math.sqrt(x * x + y * y));

function pointerExtend(dest, source) {
  for (const prop in source) {
    const prefixedPropREs = pointerExtend.prefixedPropREs;
    let deprecated = false; // skip deprecated prefixed properties

    for (const vendor in prefixedPropREs) {
      if (prop.indexOf(vendor) === 0 && prefixedPropREs[vendor].test(prop)) {
        deprecated = true;
        break;
      }
    }

    if (!deprecated && typeof source[prop] !== 'function') {
      dest[prop] = source[prop];
    }
  }

  return dest;
}

pointerExtend.prefixedPropREs = {
  webkit: /(Movement[XY]|Radius[XY]|RotationAngle|Force)$/,
  moz: /(Pressure)$/
};

function copyCoords(dest, src) {
  dest.page = dest.page || {};
  dest.page.x = src.page.x;
  dest.page.y = src.page.y;
  dest.client = dest.client || {};
  dest.client.x = src.client.x;
  dest.client.y = src.client.y;
  dest.timeStamp = src.timeStamp;
}
function setCoordDeltas(targetObj, prev, cur) {
  targetObj.page.x = cur.page.x - prev.page.x;
  targetObj.page.y = cur.page.y - prev.page.y;
  targetObj.client.x = cur.client.x - prev.client.x;
  targetObj.client.y = cur.client.y - prev.client.y;
  targetObj.timeStamp = cur.timeStamp - prev.timeStamp;
}
function setCoordVelocity(targetObj, delta) {
  const dt = Math.max(delta.timeStamp / 1000, 0.001);
  targetObj.page.x = delta.page.x / dt;
  targetObj.page.y = delta.page.y / dt;
  targetObj.client.x = delta.client.x / dt;
  targetObj.client.y = delta.client.y / dt;
  targetObj.timeStamp = dt;
}
function setZeroCoords(targetObj) {
  targetObj.page.x = 0;
  targetObj.page.y = 0;
  targetObj.client.x = 0;
  targetObj.client.y = 0;
}
function isNativePointer(pointer) {
  return pointer instanceof domObjects.Event || pointer instanceof domObjects.Touch;
} // Get specified X/Y coords for mouse or event.touches[0]

function getXY(type, pointer, xy) {
  xy = xy || {};
  type = type || 'page';
  xy.x = pointer[type + 'X'];
  xy.y = pointer[type + 'Y'];
  return xy;
}
function getPageXY(pointer, page) {
  page = page || {
    x: 0,
    y: 0
  }; // Opera Mobile handles the viewport and scrolling oddly

  if (browser$1.isOperaMobile && isNativePointer(pointer)) {
    getXY('screen', pointer, page);
    page.x += window.scrollX;
    page.y += window.scrollY;
  } else {
    getXY('page', pointer, page);
  }

  return page;
}
function getClientXY(pointer, client) {
  client = client || {};

  if (browser$1.isOperaMobile && isNativePointer(pointer)) {
    // Opera Mobile handles the viewport and scrolling oddly
    getXY('screen', pointer, client);
  } else {
    getXY('client', pointer, client);
  }

  return client;
}
function getPointerId(pointer) {
  return is.number(pointer.pointerId) ? pointer.pointerId : pointer.identifier;
}
function setCoords(dest, pointers, timeStamp) {
  const pointer = pointers.length > 1 ? pointerAverage(pointers) : pointers[0];
  getPageXY(pointer, dest.page);
  getClientXY(pointer, dest.client);
  dest.timeStamp = timeStamp;
}
function getTouchPair(event) {
  const touches = []; // array of touches is supplied

  if (is.array(event)) {
    touches[0] = event[0];
    touches[1] = event[1];
  } // an event
  else {
      if (event.type === 'touchend') {
        if (event.touches.length === 1) {
          touches[0] = event.touches[0];
          touches[1] = event.changedTouches[0];
        } else if (event.touches.length === 0) {
          touches[0] = event.changedTouches[0];
          touches[1] = event.changedTouches[1];
        }
      } else {
        touches[0] = event.touches[0];
        touches[1] = event.touches[1];
      }
    }

  return touches;
}
function pointerAverage(pointers) {
  const average = {
    pageX: 0,
    pageY: 0,
    clientX: 0,
    clientY: 0,
    screenX: 0,
    screenY: 0
  };

  for (const pointer of pointers) {
    for (const prop in average) {
      average[prop] += pointer[prop];
    }
  }

  for (const prop in average) {
    average[prop] /= pointers.length;
  }

  return average;
}
function touchBBox(event) {
  if (!event.length) {
    return null;
  }

  const touches = getTouchPair(event);
  const minX = Math.min(touches[0].pageX, touches[1].pageX);
  const minY = Math.min(touches[0].pageY, touches[1].pageY);
  const maxX = Math.max(touches[0].pageX, touches[1].pageX);
  const maxY = Math.max(touches[0].pageY, touches[1].pageY);
  return {
    x: minX,
    y: minY,
    left: minX,
    top: minY,
    right: maxX,
    bottom: maxY,
    width: maxX - minX,
    height: maxY - minY
  };
}
function touchDistance(event, deltaSource) {
  const sourceX = deltaSource + 'X';
  const sourceY = deltaSource + 'Y';
  const touches = getTouchPair(event);
  const dx = touches[0][sourceX] - touches[1][sourceX];
  const dy = touches[0][sourceY] - touches[1][sourceY];
  return hypot(dx, dy);
}
function touchAngle(event, deltaSource) {
  const sourceX = deltaSource + 'X';
  const sourceY = deltaSource + 'Y';
  const touches = getTouchPair(event);
  const dx = touches[1][sourceX] - touches[0][sourceX];
  const dy = touches[1][sourceY] - touches[0][sourceY];
  const angle = 180 * Math.atan2(dy, dx) / Math.PI;
  return angle;
}
function getPointerType(pointer) {
  return is.string(pointer.pointerType) ? pointer.pointerType : is.number(pointer.pointerType) ? [undefined, undefined, 'touch', 'pen', 'mouse'][pointer.pointerType] : // if the PointerEvent API isn't available, then the "pointer" must
  // be either a MouseEvent, TouchEvent, or Touch object
  /touch/.test(pointer.type || '') || pointer instanceof domObjects.Touch ? 'touch' : 'mouse';
} // [ event.target, event.currentTarget ]

function getEventTargets(event) {
  const path = is.func(event.composedPath) ? event.composedPath() : event.path;
  return [getActualElement(path ? path[0] : event.target), getActualElement(event.currentTarget)];
}
function newCoords() {
  return {
    page: {
      x: 0,
      y: 0
    },
    client: {
      x: 0,
      y: 0
    },
    timeStamp: 0
  };
}
function coordsToEvent(coords) {
  const event = {
    coords,

    get page() {
      return this.coords.page;
    },

    get client() {
      return this.coords.client;
    },

    get timeStamp() {
      return this.coords.timeStamp;
    },

    get pageX() {
      return this.coords.page.x;
    },

    get pageY() {
      return this.coords.page.y;
    },

    get clientX() {
      return this.coords.client.x;
    },

    get clientY() {
      return this.coords.client.y;
    },

    get pointerId() {
      return this.coords.pointerId;
    },

    get target() {
      return this.coords.target;
    },

    get type() {
      return this.coords.type;
    },

    get pointerType() {
      return this.coords.pointerType;
    },

    get buttons() {
      return this.coords.buttons;
    },

    preventDefault() {}

  };
  return event;
}

class BaseEvent {
  constructor(interaction) {
    this.type = void 0;
    this.target = void 0;
    this.currentTarget = void 0;
    this.interactable = void 0;
    this._interaction = void 0;
    this.timeStamp = void 0;
    this.immediatePropagationStopped = false;
    this.propagationStopped = false;
    this._interaction = interaction;
  }

  preventDefault() {}
  /**
   * Don't call any other listeners (even on the current target)
   */


  stopPropagation() {
    this.propagationStopped = true;
  }
  /**
   * Don't call listeners on the remaining targets
   */


  stopImmediatePropagation() {
    this.immediatePropagationStopped = this.propagationStopped = true;
  }

} // defined outside of class definition to avoid assignment of undefined during
// construction

// getters and setters defined here to support typescript 3.6 and below which
// don't support getter and setters in .d.ts files
Object.defineProperty(BaseEvent.prototype, 'interaction', {
  get() {
    return this._interaction._proxy;
  },

  set() {}

});

const contains = (array, target) => array.indexOf(target) !== -1;
const remove = (array, target) => array.splice(array.indexOf(target), 1);
const merge = (target, source) => {
  for (const item of source) {
    target.push(item);
  }

  return target;
};
const from$1 = source => merge([], source);
const findIndex = (array, func) => {
  for (let i = 0; i < array.length; i++) {
    if (func(array[i], i, array)) {
      return i;
    }
  }

  return -1;
};
const find$2 = (array, func) => array[findIndex(array, func)];

class DropEvent extends BaseEvent {
  /**
   * Class of events fired on dropzones during drags with acceptable targets.
   */
  constructor(dropState, dragEvent, type) {
    super(dragEvent._interaction);
    this.target = void 0;
    this.dropzone = void 0;
    this.dragEvent = void 0;
    this.relatedTarget = void 0;
    this.draggable = void 0;
    this.timeStamp = void 0;
    this.propagationStopped = false;
    this.immediatePropagationStopped = false;
    const {
      element,
      dropzone
    } = type === 'dragleave' ? dropState.prev : dropState.cur;
    this.type = type;
    this.target = element;
    this.currentTarget = element;
    this.dropzone = dropzone;
    this.dragEvent = dragEvent;
    this.relatedTarget = dragEvent.target;
    this.draggable = dragEvent.interactable;
    this.timeStamp = dragEvent.timeStamp;
  }
  /**
   * If this is a `dropactivate` event, the dropzone element will be
   * deactivated.
   *
   * If this is a `dragmove` or `dragenter`, a `dragleave` will be fired on the
   * dropzone element and more.
   */


  reject() {
    const {
      dropState
    } = this._interaction;

    if (this.type !== 'dropactivate' && (!this.dropzone || dropState.cur.dropzone !== this.dropzone || dropState.cur.element !== this.target)) {
      return;
    }

    dropState.prev.dropzone = this.dropzone;
    dropState.prev.element = this.target;
    dropState.rejected = true;
    dropState.events.enter = null;
    this.stopImmediatePropagation();

    if (this.type === 'dropactivate') {
      const activeDrops = dropState.activeDrops;
      const index = findIndex(activeDrops, ({
        dropzone,
        element
      }) => dropzone === this.dropzone && element === this.target);
      dropState.activeDrops.splice(index, 1);
      const deactivateEvent = new DropEvent(dropState, this.dragEvent, 'dropdeactivate');
      deactivateEvent.dropzone = this.dropzone;
      deactivateEvent.target = this.target;
      this.dropzone.fire(deactivateEvent);
    } else {
      this.dropzone.fire(new DropEvent(dropState, this.dragEvent, 'dragleave'));
    }
  }

  preventDefault() {}

  stopPropagation() {
    this.propagationStopped = true;
  }

  stopImmediatePropagation() {
    this.immediatePropagationStopped = this.propagationStopped = true;
  }

}

function install$f(scope) {
  const {
    actions,

    /** @lends module:interact */
    interactStatic: interact,

    /** @lends Interactable */
    Interactable,
    defaults
  } = scope;
  scope.usePlugin(drag);
  /**
   *
   * ```js
   * interact('.drop').dropzone({
   *   accept: '.can-drop' || document.getElementById('single-drop'),
   *   overlap: 'pointer' || 'center' || zeroToOne
   * }
   * ```
   *
   * Returns or sets whether draggables can be dropped onto this target to
   * trigger drop events
   *
   * Dropzones can receive the following events:
   *  - `dropactivate` and `dropdeactivate` when an acceptable drag starts and ends
   *  - `dragenter` and `dragleave` when a draggable enters and leaves the dropzone
   *  - `dragmove` when a draggable that has entered the dropzone is moved
   *  - `drop` when a draggable is dropped into this dropzone
   *
   * Use the `accept` option to allow only elements that match the given CSS
   * selector or element. The value can be:
   *
   *  - **an Element** - only that element can be dropped into this dropzone.
   *  - **a string**, - the element being dragged must match it as a CSS selector.
   *  - **`null`** - accept options is cleared - it accepts any element.
   *
   * Use the `overlap` option to set how drops are checked for. The allowed
   * values are:
   *
   *   - `'pointer'`, the pointer must be over the dropzone (default)
   *   - `'center'`, the draggable element's center must be over the dropzone
   *   - a number from 0-1 which is the `(intersection area) / (draggable area)`.
   *   e.g. `0.5` for drop to happen when half of the area of the draggable is
   *   over the dropzone
   *
   * Use the `checker` option to specify a function to check if a dragged element
   * is over this Interactable.
   *
   * @param {boolean | object | null} [options] The new options to be set.
   * @return {object | Interactable} The current setting or this Interactable
   */

  Interactable.prototype.dropzone = function (options) {
    return dropzoneMethod(this, options);
  };
  /**
   * ```js
   * interact(target)
   * .dropChecker(function(dragEvent,         // related dragmove or dragend event
   *                       event,             // TouchEvent/PointerEvent/MouseEvent
   *                       dropped,           // bool result of the default checker
   *                       dropzone,          // dropzone Interactable
   *                       dropElement,       // dropzone elemnt
   *                       draggable,         // draggable Interactable
   *                       draggableElement) {// draggable element
   *
   *   return dropped && event.target.hasAttribute('allow-drop')
   * }
   * ```
   */


  Interactable.prototype.dropCheck = function (dragEvent, event, draggable, draggableElement, dropElement, rect) {
    return dropCheckMethod(this, dragEvent, event, draggable, draggableElement, dropElement, rect);
  };
  /**
   * Returns or sets whether the dimensions of dropzone elements are calculated
   * on every dragmove or only on dragstart for the default dropChecker
   *
   * @param {boolean} [newValue] True to check on each move. False to check only
   * before start
   * @return {boolean | interact} The current setting or interact
   */


  interact.dynamicDrop = function (newValue) {
    if (is.bool(newValue)) {
      // if (dragging && scope.dynamicDrop !== newValue && !newValue) {
      //  calcRects(dropzones)
      // }
      scope.dynamicDrop = newValue;
      return interact;
    }

    return scope.dynamicDrop;
  };

  extend$1(actions.phaselessTypes, {
    dragenter: true,
    dragleave: true,
    dropactivate: true,
    dropdeactivate: true,
    dropmove: true,
    drop: true
  });
  actions.methodDict.drop = 'dropzone';
  scope.dynamicDrop = false;
  defaults.actions.drop = drop$1.defaults;
}

function collectDrops({
  interactables
}, draggableElement) {
  const drops = []; // collect all dropzones and their elements which qualify for a drop

  for (const dropzone of interactables.list) {
    if (!dropzone.options.drop.enabled) {
      continue;
    }

    const accept = dropzone.options.drop.accept; // test the draggable draggableElement against the dropzone's accept setting

    if (is.element(accept) && accept !== draggableElement || is.string(accept) && !matchesSelector(draggableElement, accept) || is.func(accept) && !accept({
      dropzone,
      draggableElement
    })) {
      continue;
    } // query for new elements if necessary


    const dropElements = is.string(dropzone.target) ? dropzone._context.querySelectorAll(dropzone.target) : is.array(dropzone.target) ? dropzone.target : [dropzone.target];

    for (const dropzoneElement of dropElements) {
      if (dropzoneElement !== draggableElement) {
        drops.push({
          dropzone,
          element: dropzoneElement,
          rect: dropzone.getRect(dropzoneElement)
        });
      }
    }
  }

  return drops;
}

function fireActivationEvents(activeDrops, event) {
  // loop through all active dropzones and trigger event
  for (const {
    dropzone,
    element
  } of activeDrops.slice()) {
    event.dropzone = dropzone; // set current element as event target

    event.target = element;
    dropzone.fire(event);
    event.propagationStopped = event.immediatePropagationStopped = false;
  }
} // return a new array of possible drops. getActiveDrops should always be
// called when a drag has just started or a drag event happens while
// dynamicDrop is true


function getActiveDrops(scope, dragElement) {
  // get dropzones and their elements that could receive the draggable
  const activeDrops = collectDrops(scope, dragElement);

  for (const activeDrop of activeDrops) {
    activeDrop.rect = activeDrop.dropzone.getRect(activeDrop.element);
  }

  return activeDrops;
}

function getDrop({
  dropState,
  interactable: draggable,
  element: dragElement
}, dragEvent, pointerEvent) {
  const validDrops = []; // collect all dropzones and their elements which qualify for a drop

  for (const {
    dropzone,
    element: dropzoneElement,
    rect
  } of dropState.activeDrops) {
    validDrops.push(dropzone.dropCheck(dragEvent, pointerEvent, draggable, dragElement, dropzoneElement, rect) ? dropzoneElement : null);
  } // get the most appropriate dropzone based on DOM depth and order


  const dropIndex = indexOfDeepestElement(validDrops);
  return dropState.activeDrops[dropIndex] || null;
}

function getDropEvents(interaction, _pointerEvent, dragEvent) {
  const {
    dropState
  } = interaction;
  const dropEvents = {
    enter: null,
    leave: null,
    activate: null,
    deactivate: null,
    move: null,
    drop: null
  };

  if (dragEvent.type === 'dragstart') {
    dropEvents.activate = new DropEvent(dropState, dragEvent, 'dropactivate');
    dropEvents.activate.target = null;
    dropEvents.activate.dropzone = null;
  }

  if (dragEvent.type === 'dragend') {
    dropEvents.deactivate = new DropEvent(dropState, dragEvent, 'dropdeactivate');
    dropEvents.deactivate.target = null;
    dropEvents.deactivate.dropzone = null;
  }

  if (dropState.rejected) {
    return dropEvents;
  }

  if (dropState.cur.element !== dropState.prev.element) {
    // if there was a previous dropzone, create a dragleave event
    if (dropState.prev.dropzone) {
      dropEvents.leave = new DropEvent(dropState, dragEvent, 'dragleave');
      dragEvent.dragLeave = dropEvents.leave.target = dropState.prev.element;
      dragEvent.prevDropzone = dropEvents.leave.dropzone = dropState.prev.dropzone;
    } // if dropzone is not null, create a dragenter event


    if (dropState.cur.dropzone) {
      dropEvents.enter = new DropEvent(dropState, dragEvent, 'dragenter');
      dragEvent.dragEnter = dropState.cur.element;
      dragEvent.dropzone = dropState.cur.dropzone;
    }
  }

  if (dragEvent.type === 'dragend' && dropState.cur.dropzone) {
    dropEvents.drop = new DropEvent(dropState, dragEvent, 'drop');
    dragEvent.dropzone = dropState.cur.dropzone;
    dragEvent.relatedTarget = dropState.cur.element;
  }

  if (dragEvent.type === 'dragmove' && dropState.cur.dropzone) {
    dropEvents.move = new DropEvent(dropState, dragEvent, 'dropmove');
    dropEvents.move.dragmove = dragEvent;
    dragEvent.dropzone = dropState.cur.dropzone;
  }

  return dropEvents;
}

function fireDropEvents(interaction, events) {
  const {
    dropState
  } = interaction;
  const {
    activeDrops,
    cur,
    prev
  } = dropState;

  if (events.leave) {
    prev.dropzone.fire(events.leave);
  }

  if (events.enter) {
    cur.dropzone.fire(events.enter);
  }

  if (events.move) {
    cur.dropzone.fire(events.move);
  }

  if (events.drop) {
    cur.dropzone.fire(events.drop);
  }

  if (events.deactivate) {
    fireActivationEvents(activeDrops, events.deactivate);
  }

  dropState.prev.dropzone = cur.dropzone;
  dropState.prev.element = cur.element;
}

function onEventCreated({
  interaction,
  iEvent,
  event
}, scope) {
  if (iEvent.type !== 'dragmove' && iEvent.type !== 'dragend') {
    return;
  }

  const {
    dropState
  } = interaction;

  if (scope.dynamicDrop) {
    dropState.activeDrops = getActiveDrops(scope, interaction.element);
  }

  const dragEvent = iEvent;
  const dropResult = getDrop(interaction, dragEvent, event); // update rejected status

  dropState.rejected = dropState.rejected && !!dropResult && dropResult.dropzone === dropState.cur.dropzone && dropResult.element === dropState.cur.element;
  dropState.cur.dropzone = dropResult && dropResult.dropzone;
  dropState.cur.element = dropResult && dropResult.element;
  dropState.events = getDropEvents(interaction, event, dragEvent);
}

function dropzoneMethod(interactable, options) {
  if (is.object(options)) {
    interactable.options.drop.enabled = options.enabled !== false;

    if (options.listeners) {
      const normalized = normalize(options.listeners); // rename 'drop' to '' as it will be prefixed with 'drop'

      const corrected = Object.keys(normalized).reduce((acc, type) => {
        const correctedType = /^(enter|leave)/.test(type) ? `drag${type}` : /^(activate|deactivate|move)/.test(type) ? `drop${type}` : type;
        acc[correctedType] = normalized[type];
        return acc;
      }, {});
      interactable.off(interactable.options.drop.listeners);
      interactable.on(corrected);
      interactable.options.drop.listeners = corrected;
    }

    if (is.func(options.ondrop)) {
      interactable.on('drop', options.ondrop);
    }

    if (is.func(options.ondropactivate)) {
      interactable.on('dropactivate', options.ondropactivate);
    }

    if (is.func(options.ondropdeactivate)) {
      interactable.on('dropdeactivate', options.ondropdeactivate);
    }

    if (is.func(options.ondragenter)) {
      interactable.on('dragenter', options.ondragenter);
    }

    if (is.func(options.ondragleave)) {
      interactable.on('dragleave', options.ondragleave);
    }

    if (is.func(options.ondropmove)) {
      interactable.on('dropmove', options.ondropmove);
    }

    if (/^(pointer|center)$/.test(options.overlap)) {
      interactable.options.drop.overlap = options.overlap;
    } else if (is.number(options.overlap)) {
      interactable.options.drop.overlap = Math.max(Math.min(1, options.overlap), 0);
    }

    if ('accept' in options) {
      interactable.options.drop.accept = options.accept;
    }

    if ('checker' in options) {
      interactable.options.drop.checker = options.checker;
    }

    return interactable;
  }

  if (is.bool(options)) {
    interactable.options.drop.enabled = options;
    return interactable;
  }

  return interactable.options.drop;
}

function dropCheckMethod(interactable, dragEvent, event, draggable, draggableElement, dropElement, rect) {
  let dropped = false; // if the dropzone has no rect (eg. display: none)
  // call the custom dropChecker or just return false

  if (!(rect = rect || interactable.getRect(dropElement))) {
    return interactable.options.drop.checker ? interactable.options.drop.checker(dragEvent, event, dropped, interactable, dropElement, draggable, draggableElement) : false;
  }

  const dropOverlap = interactable.options.drop.overlap;

  if (dropOverlap === 'pointer') {
    const origin = getOriginXY(draggable, draggableElement, 'drag');
    const page = getPageXY(dragEvent);
    page.x += origin.x;
    page.y += origin.y;
    const horizontal = page.x > rect.left && page.x < rect.right;
    const vertical = page.y > rect.top && page.y < rect.bottom;
    dropped = horizontal && vertical;
  }

  const dragRect = draggable.getRect(draggableElement);

  if (dragRect && dropOverlap === 'center') {
    const cx = dragRect.left + dragRect.width / 2;
    const cy = dragRect.top + dragRect.height / 2;
    dropped = cx >= rect.left && cx <= rect.right && cy >= rect.top && cy <= rect.bottom;
  }

  if (dragRect && is.number(dropOverlap)) {
    const overlapArea = Math.max(0, Math.min(rect.right, dragRect.right) - Math.max(rect.left, dragRect.left)) * Math.max(0, Math.min(rect.bottom, dragRect.bottom) - Math.max(rect.top, dragRect.top));
    const overlapRatio = overlapArea / (dragRect.width * dragRect.height);
    dropped = overlapRatio >= dropOverlap;
  }

  if (interactable.options.drop.checker) {
    dropped = interactable.options.drop.checker(dragEvent, event, dropped, interactable, dropElement, draggable, draggableElement);
  }

  return dropped;
}

const drop$1 = {
  id: 'actions/drop',
  install: install$f,
  listeners: {
    'interactions:before-action-start': ({
      interaction
    }) => {
      if (interaction.prepared.name !== 'drag') {
        return;
      }

      interaction.dropState = {
        cur: {
          dropzone: null,
          element: null
        },
        prev: {
          dropzone: null,
          element: null
        },
        rejected: null,
        events: null,
        activeDrops: []
      };
    },
    'interactions:after-action-start': ({
      interaction,
      event,
      iEvent: dragEvent
    }, scope) => {
      if (interaction.prepared.name !== 'drag') {
        return;
      }

      const {
        dropState
      } = interaction; // reset active dropzones

      dropState.activeDrops = null;
      dropState.events = null;
      dropState.activeDrops = getActiveDrops(scope, interaction.element);
      dropState.events = getDropEvents(interaction, event, dragEvent);

      if (dropState.events.activate) {
        fireActivationEvents(dropState.activeDrops, dropState.events.activate);
        scope.fire('actions/drop:start', {
          interaction,
          dragEvent
        });
      }
    },
    'interactions:action-move': onEventCreated,
    'interactions:after-action-move': ({
      interaction,
      iEvent: dragEvent
    }, scope) => {
      if (interaction.prepared.name !== 'drag') {
        return;
      }

      fireDropEvents(interaction, interaction.dropState.events);
      scope.fire('actions/drop:move', {
        interaction,
        dragEvent
      });
      interaction.dropState.events = {};
    },
    'interactions:action-end': (arg, scope) => {
      if (arg.interaction.prepared.name !== 'drag') {
        return;
      }

      const {
        interaction,
        iEvent: dragEvent
      } = arg;
      onEventCreated(arg, scope);
      fireDropEvents(interaction, interaction.dropState.events);
      scope.fire('actions/drop:end', {
        interaction,
        dragEvent
      });
    },
    'interactions:stop': ({
      interaction
    }) => {
      if (interaction.prepared.name !== 'drag') {
        return;
      }

      const {
        dropState
      } = interaction;

      if (dropState) {
        dropState.activeDrops = null;
        dropState.events = null;
        dropState.cur.dropzone = null;
        dropState.cur.element = null;
        dropState.prev.dropzone = null;
        dropState.prev.element = null;
        dropState.rejected = false;
      }
    }
  },
  getActiveDrops,
  getDrop,
  getDropEvents,
  fireDropEvents,
  defaults: {
    enabled: false,
    accept: null,
    overlap: 'pointer'
  }
};

function install$e(scope) {
  const {
    actions,
    Interactable,
    defaults
  } = scope;
  /**
   * ```js
   * interact(element).gesturable({
   *     onstart: function (event) {},
   *     onmove : function (event) {},
   *     onend  : function (event) {},
   *
   *     // limit multiple gestures.
   *     // See the explanation in {@link Interactable.draggable} example
   *     max: Infinity,
   *     maxPerElement: 1,
   * })
   *
   * var isGestureable = interact(element).gesturable()
   * ```
   *
   * Gets or sets whether multitouch gestures can be performed on the target
   *
   * @param {boolean | object} [options] true/false or An object with event
   * listeners to be fired on gesture events (makes the Interactable gesturable)
   * @return {boolean | Interactable} A boolean indicating if this can be the
   * target of gesture events, or this Interactable
   */

  Interactable.prototype.gesturable = function (options) {
    if (is.object(options)) {
      this.options.gesture.enabled = options.enabled !== false;
      this.setPerAction('gesture', options);
      this.setOnEvents('gesture', options);
      return this;
    }

    if (is.bool(options)) {
      this.options.gesture.enabled = options;
      return this;
    }

    return this.options.gesture;
  };

  actions.map.gesture = gesture;
  actions.methodDict.gesture = 'gesturable';
  defaults.actions.gesture = gesture.defaults;
}

function updateGestureProps({
  interaction,
  iEvent,
  phase
}) {
  if (interaction.prepared.name !== 'gesture') return;
  const pointers = interaction.pointers.map(p => p.pointer);
  const starting = phase === 'start';
  const ending = phase === 'end';
  const deltaSource = interaction.interactable.options.deltaSource;
  iEvent.touches = [pointers[0], pointers[1]];

  if (starting) {
    iEvent.distance = touchDistance(pointers, deltaSource);
    iEvent.box = touchBBox(pointers);
    iEvent.scale = 1;
    iEvent.ds = 0;
    iEvent.angle = touchAngle(pointers, deltaSource);
    iEvent.da = 0;
    interaction.gesture.startDistance = iEvent.distance;
    interaction.gesture.startAngle = iEvent.angle;
  } else if (ending) {
    const prevEvent = interaction.prevEvent;
    iEvent.distance = prevEvent.distance;
    iEvent.box = prevEvent.box;
    iEvent.scale = prevEvent.scale;
    iEvent.ds = 0;
    iEvent.angle = prevEvent.angle;
    iEvent.da = 0;
  } else {
    iEvent.distance = touchDistance(pointers, deltaSource);
    iEvent.box = touchBBox(pointers);
    iEvent.scale = iEvent.distance / interaction.gesture.startDistance;
    iEvent.angle = touchAngle(pointers, deltaSource);
    iEvent.ds = iEvent.scale - interaction.gesture.scale;
    iEvent.da = iEvent.angle - interaction.gesture.angle;
  }

  interaction.gesture.distance = iEvent.distance;
  interaction.gesture.angle = iEvent.angle;

  if (is.number(iEvent.scale) && iEvent.scale !== Infinity && !isNaN(iEvent.scale)) {
    interaction.gesture.scale = iEvent.scale;
  }
}

const gesture = {
  id: 'actions/gesture',
  before: ['actions/drag', 'actions/resize'],
  install: install$e,
  listeners: {
    'interactions:action-start': updateGestureProps,
    'interactions:action-move': updateGestureProps,
    'interactions:action-end': updateGestureProps,
    'interactions:new': ({
      interaction
    }) => {
      interaction.gesture = {
        angle: 0,
        distance: 0,
        scale: 1,
        startAngle: 0,
        startDistance: 0
      };
    },
    'auto-start:check': arg => {
      if (arg.interaction.pointers.length < 2) {
        return undefined;
      }

      const gestureOptions = arg.interactable.options.gesture;

      if (!(gestureOptions && gestureOptions.enabled)) {
        return undefined;
      }

      arg.action = {
        name: 'gesture'
      };
      return false;
    }
  },
  defaults: {},

  getCursor() {
    return '';
  }

};

function install$d(scope) {
  const {
    actions,
    browser,

    /** @lends Interactable */
    Interactable,
    // tslint:disable-line no-shadowed-variable
    defaults
  } = scope; // Less Precision with touch input

  resize.cursors = initCursors(browser);
  resize.defaultMargin = browser.supportsTouch || browser.supportsPointerEvent ? 20 : 10;
  /**
   * ```js
   * interact(element).resizable({
   *   onstart: function (event) {},
   *   onmove : function (event) {},
   *   onend  : function (event) {},
   *
   *   edges: {
   *     top   : true,       // Use pointer coords to check for resize.
   *     left  : false,      // Disable resizing from left edge.
   *     bottom: '.resize-s',// Resize if pointer target matches selector
   *     right : handleEl    // Resize if pointer target is the given Element
   *   },
   *
   *     // Width and height can be adjusted independently. When `true`, width and
   *     // height are adjusted at a 1:1 ratio.
   *     square: false,
   *
   *     // Width and height can be adjusted independently. When `true`, width and
   *     // height maintain the aspect ratio they had when resizing started.
   *     preserveAspectRatio: false,
   *
   *   // a value of 'none' will limit the resize rect to a minimum of 0x0
   *   // 'negate' will allow the rect to have negative width/height
   *   // 'reposition' will keep the width/height positive by swapping
   *   // the top and bottom edges and/or swapping the left and right edges
   *   invert: 'none' || 'negate' || 'reposition'
   *
   *   // limit multiple resizes.
   *   // See the explanation in the {@link Interactable.draggable} example
   *   max: Infinity,
   *   maxPerElement: 1,
   * })
   *
   * var isResizeable = interact(element).resizable()
   * ```
   *
   * Gets or sets whether resize actions can be performed on the target
   *
   * @param {boolean | object} [options] true/false or An object with event
   * listeners to be fired on resize events (object makes the Interactable
   * resizable)
   * @return {boolean | Interactable} A boolean indicating if this can be the
   * target of resize elements, or this Interactable
   */

  Interactable.prototype.resizable = function (options) {
    return resizable(this, options, scope);
  };

  actions.map.resize = resize;
  actions.methodDict.resize = 'resizable';
  defaults.actions.resize = resize.defaults;
}

function resizeChecker(arg) {
  const {
    interaction,
    interactable,
    element,
    rect,
    buttons
  } = arg;

  if (!rect) {
    return undefined;
  }

  const page = extend$1({}, interaction.coords.cur.page);
  const resizeOptions = interactable.options.resize;

  if (!(resizeOptions && resizeOptions.enabled) || // check mouseButton setting if the pointer is down
  interaction.pointerIsDown && /mouse|pointer/.test(interaction.pointerType) && (buttons & resizeOptions.mouseButtons) === 0) {
    return undefined;
  } // if using resize.edges


  if (is.object(resizeOptions.edges)) {
    const resizeEdges = {
      left: false,
      right: false,
      top: false,
      bottom: false
    };

    for (const edge in resizeEdges) {
      resizeEdges[edge] = checkResizeEdge(edge, resizeOptions.edges[edge], page, interaction._latestPointer.eventTarget, element, rect, resizeOptions.margin || resize.defaultMargin);
    }

    resizeEdges.left = resizeEdges.left && !resizeEdges.right;
    resizeEdges.top = resizeEdges.top && !resizeEdges.bottom;

    if (resizeEdges.left || resizeEdges.right || resizeEdges.top || resizeEdges.bottom) {
      arg.action = {
        name: 'resize',
        edges: resizeEdges
      };
    }
  } else {
    const right = resizeOptions.axis !== 'y' && page.x > rect.right - resize.defaultMargin;
    const bottom = resizeOptions.axis !== 'x' && page.y > rect.bottom - resize.defaultMargin;

    if (right || bottom) {
      arg.action = {
        name: 'resize',
        axes: (right ? 'x' : '') + (bottom ? 'y' : '')
      };
    }
  }

  return arg.action ? false : undefined;
}

function resizable(interactable, options, scope) {
  if (is.object(options)) {
    interactable.options.resize.enabled = options.enabled !== false;
    interactable.setPerAction('resize', options);
    interactable.setOnEvents('resize', options);

    if (is.string(options.axis) && /^x$|^y$|^xy$/.test(options.axis)) {
      interactable.options.resize.axis = options.axis;
    } else if (options.axis === null) {
      interactable.options.resize.axis = scope.defaults.actions.resize.axis;
    }

    if (is.bool(options.preserveAspectRatio)) {
      interactable.options.resize.preserveAspectRatio = options.preserveAspectRatio;
    } else if (is.bool(options.square)) {
      interactable.options.resize.square = options.square;
    }

    return interactable;
  }

  if (is.bool(options)) {
    interactable.options.resize.enabled = options;
    return interactable;
  }

  return interactable.options.resize;
}

function checkResizeEdge(name, value, page, element, interactableElement, rect, margin) {
  // false, '', undefined, null
  if (!value) {
    return false;
  } // true value, use pointer coords and element rect


  if (value === true) {
    // if dimensions are negative, "switch" edges
    const width = is.number(rect.width) ? rect.width : rect.right - rect.left;
    const height = is.number(rect.height) ? rect.height : rect.bottom - rect.top; // don't use margin greater than half the relevent dimension

    margin = Math.min(margin, Math.abs((name === 'left' || name === 'right' ? width : height) / 2));

    if (width < 0) {
      if (name === 'left') {
        name = 'right';
      } else if (name === 'right') {
        name = 'left';
      }
    }

    if (height < 0) {
      if (name === 'top') {
        name = 'bottom';
      } else if (name === 'bottom') {
        name = 'top';
      }
    }

    if (name === 'left') {
      return page.x < (width >= 0 ? rect.left : rect.right) + margin;
    }

    if (name === 'top') {
      return page.y < (height >= 0 ? rect.top : rect.bottom) + margin;
    }

    if (name === 'right') {
      return page.x > (width >= 0 ? rect.right : rect.left) - margin;
    }

    if (name === 'bottom') {
      return page.y > (height >= 0 ? rect.bottom : rect.top) - margin;
    }
  } // the remaining checks require an element


  if (!is.element(element)) {
    return false;
  }

  return is.element(value) ? // the value is an element to use as a resize handle
  value === element : // otherwise check if element matches value as selector
  matchesUpTo(element, value, interactableElement);
}
/* eslint-disable multiline-ternary */
// eslint-disable-next-line @typescript-eslint/consistent-type-imports


function initCursors(browser) {
  return browser.isIe9 ? {
    x: 'e-resize',
    y: 's-resize',
    xy: 'se-resize',
    top: 'n-resize',
    left: 'w-resize',
    bottom: 's-resize',
    right: 'e-resize',
    topleft: 'se-resize',
    bottomright: 'se-resize',
    topright: 'ne-resize',
    bottomleft: 'ne-resize'
  } : {
    x: 'ew-resize',
    y: 'ns-resize',
    xy: 'nwse-resize',
    top: 'ns-resize',
    left: 'ew-resize',
    bottom: 'ns-resize',
    right: 'ew-resize',
    topleft: 'nwse-resize',
    bottomright: 'nwse-resize',
    topright: 'nesw-resize',
    bottomleft: 'nesw-resize'
  };
}
/* eslint-enable multiline-ternary */


function start$7({
  iEvent,
  interaction
}) {
  if (interaction.prepared.name !== 'resize' || !interaction.prepared.edges) {
    return;
  }

  const resizeEvent = iEvent;
  const rect = interaction.rect;
  interaction._rects = {
    start: extend$1({}, rect),
    corrected: extend$1({}, rect),
    previous: extend$1({}, rect),
    delta: {
      left: 0,
      right: 0,
      width: 0,
      top: 0,
      bottom: 0,
      height: 0
    }
  };
  resizeEvent.edges = interaction.prepared.edges;
  resizeEvent.rect = interaction._rects.corrected;
  resizeEvent.deltaRect = interaction._rects.delta;
}

function move({
  iEvent,
  interaction
}) {
  if (interaction.prepared.name !== 'resize' || !interaction.prepared.edges) return;
  const resizeEvent = iEvent;
  const resizeOptions = interaction.interactable.options.resize;
  const invert = resizeOptions.invert;
  const invertible = invert === 'reposition' || invert === 'negate';
  const current = interaction.rect;
  const {
    start: startRect,
    corrected,
    delta: deltaRect,
    previous
  } = interaction._rects;
  extend$1(previous, corrected);

  if (invertible) {
    // if invertible, copy the current rect
    extend$1(corrected, current);

    if (invert === 'reposition') {
      // swap edge values if necessary to keep width/height positive
      if (corrected.top > corrected.bottom) {
        const swap = corrected.top;
        corrected.top = corrected.bottom;
        corrected.bottom = swap;
      }

      if (corrected.left > corrected.right) {
        const swap = corrected.left;
        corrected.left = corrected.right;
        corrected.right = swap;
      }
    }
  } else {
    // if not invertible, restrict to minimum of 0x0 rect
    corrected.top = Math.min(current.top, startRect.bottom);
    corrected.bottom = Math.max(current.bottom, startRect.top);
    corrected.left = Math.min(current.left, startRect.right);
    corrected.right = Math.max(current.right, startRect.left);
  }

  corrected.width = corrected.right - corrected.left;
  corrected.height = corrected.bottom - corrected.top;

  for (const edge in corrected) {
    deltaRect[edge] = corrected[edge] - previous[edge];
  }

  resizeEvent.edges = interaction.prepared.edges;
  resizeEvent.rect = corrected;
  resizeEvent.deltaRect = deltaRect;
}

function end$1({
  iEvent,
  interaction
}) {
  if (interaction.prepared.name !== 'resize' || !interaction.prepared.edges) return;
  const resizeEvent = iEvent;
  resizeEvent.edges = interaction.prepared.edges;
  resizeEvent.rect = interaction._rects.corrected;
  resizeEvent.deltaRect = interaction._rects.delta;
}

function updateEventAxes({
  iEvent,
  interaction
}) {
  if (interaction.prepared.name !== 'resize' || !interaction.resizeAxes) return;
  const options = interaction.interactable.options;
  const resizeEvent = iEvent;

  if (options.resize.square) {
    if (interaction.resizeAxes === 'y') {
      resizeEvent.delta.x = resizeEvent.delta.y;
    } else {
      resizeEvent.delta.y = resizeEvent.delta.x;
    }

    resizeEvent.axes = 'xy';
  } else {
    resizeEvent.axes = interaction.resizeAxes;

    if (interaction.resizeAxes === 'x') {
      resizeEvent.delta.y = 0;
    } else if (interaction.resizeAxes === 'y') {
      resizeEvent.delta.x = 0;
    }
  }
}

const resize = {
  id: 'actions/resize',
  before: ['actions/drag'],
  install: install$d,
  listeners: {
    'interactions:new': ({
      interaction
    }) => {
      interaction.resizeAxes = 'xy';
    },
    'interactions:action-start': arg => {
      start$7(arg);
      updateEventAxes(arg);
    },
    'interactions:action-move': arg => {
      move(arg);
      updateEventAxes(arg);
    },
    'interactions:action-end': end$1,
    'auto-start:check': resizeChecker
  },
  defaults: {
    square: false,
    preserveAspectRatio: false,
    axis: 'xy',
    // use default margin
    margin: NaN,
    // object with props left, right, top, bottom which are
    // true/false values to resize when the pointer is over that edge,
    // CSS selectors to match the handles for each direction
    // or the Elements for each handle
    edges: null,
    // a value of 'none' will limit the resize rect to a minimum of 0x0
    // 'negate' will alow the rect to have negative width/height
    // 'reposition' will keep the width/height positive by swapping
    // the top and bottom edges and/or swapping the left and right edges
    invert: 'none'
  },
  cursors: null,

  getCursor({
    edges,
    axis,
    name
  }) {
    const cursors = resize.cursors;
    let result = null;

    if (axis) {
      result = cursors[name + axis];
    } else if (edges) {
      let cursorKey = '';

      for (const edge of ['top', 'bottom', 'left', 'right']) {
        if (edges[edge]) {
          cursorKey += edge;
        }
      }

      result = cursors[cursorKey];
    }

    return result;
  },

  defaultMargin: null
};

var actions = {
  id: 'actions',

  install(scope) {
    scope.usePlugin(gesture);
    scope.usePlugin(resize);
    scope.usePlugin(drag);
    scope.usePlugin(drop$1);
  }

};

let lastTime = 0;
let request;
let cancel;

function init$1(global) {
  request = global.requestAnimationFrame;
  cancel = global.cancelAnimationFrame;

  if (!request) {
    const vendors = ['ms', 'moz', 'webkit', 'o'];

    for (const vendor of vendors) {
      request = global[`${vendor}RequestAnimationFrame`];
      cancel = global[`${vendor}CancelAnimationFrame`] || global[`${vendor}CancelRequestAnimationFrame`];
    }
  }

  request = request && request.bind(global);
  cancel = cancel && cancel.bind(global);

  if (!request) {
    request = callback => {
      const currTime = Date.now();
      const timeToCall = Math.max(0, 16 - (currTime - lastTime));
      const token = global.setTimeout(() => {
        // eslint-disable-next-line node/no-callback-literal
        callback(currTime + timeToCall);
      }, timeToCall);
      lastTime = currTime + timeToCall;
      return token;
    };

    cancel = token => clearTimeout(token);
  }
}

var raf = {
  request: callback => request(callback),
  cancel: token => cancel(token),
  init: init$1
};

function install$c(scope) {
  const {
    defaults,
    actions
  } = scope;
  scope.autoScroll = autoScroll$1;

  autoScroll$1.now = () => scope.now();

  actions.phaselessTypes.autoscroll = true;
  defaults.perAction.autoScroll = autoScroll$1.defaults;
}

const autoScroll$1 = {
  defaults: {
    enabled: false,
    margin: 60,
    // the item that is scrolled (Window or HTMLElement)
    container: null,
    // the scroll speed in pixels per second
    speed: 300
  },
  now: Date.now,
  interaction: null,
  i: 0,
  // the handle returned by window.setInterval
  // Direction each pulse is to scroll in
  x: 0,
  y: 0,
  isScrolling: false,
  prevTime: 0,
  margin: 0,
  speed: 0,

  start(interaction) {
    autoScroll$1.isScrolling = true;
    raf.cancel(autoScroll$1.i);
    interaction.autoScroll = autoScroll$1;
    autoScroll$1.interaction = interaction;
    autoScroll$1.prevTime = autoScroll$1.now();
    autoScroll$1.i = raf.request(autoScroll$1.scroll);
  },

  stop() {
    autoScroll$1.isScrolling = false;

    if (autoScroll$1.interaction) {
      autoScroll$1.interaction.autoScroll = null;
    }

    raf.cancel(autoScroll$1.i);
  },

  // scroll the window by the values in scroll.x/y
  scroll() {
    const {
      interaction
    } = autoScroll$1;
    const {
      interactable,
      element
    } = interaction;
    const actionName = interaction.prepared.name;
    const options = interactable.options[actionName].autoScroll;
    const container = getContainer(options.container, interactable, element);
    const now = autoScroll$1.now(); // change in time in seconds

    const dt = (now - autoScroll$1.prevTime) / 1000; // displacement

    const s = options.speed * dt;

    if (s >= 1) {
      const scrollBy = {
        x: autoScroll$1.x * s,
        y: autoScroll$1.y * s
      };

      if (scrollBy.x || scrollBy.y) {
        const prevScroll = getScroll(container);

        if (is.window(container)) {
          container.scrollBy(scrollBy.x, scrollBy.y);
        } else if (container) {
          container.scrollLeft += scrollBy.x;
          container.scrollTop += scrollBy.y;
        }

        const curScroll = getScroll(container);
        const delta = {
          x: curScroll.x - prevScroll.x,
          y: curScroll.y - prevScroll.y
        };

        if (delta.x || delta.y) {
          interactable.fire({
            type: 'autoscroll',
            target: element,
            interactable,
            delta,
            interaction,
            container
          });
        }
      }

      autoScroll$1.prevTime = now;
    }

    if (autoScroll$1.isScrolling) {
      raf.cancel(autoScroll$1.i);
      autoScroll$1.i = raf.request(autoScroll$1.scroll);
    }
  },

  check(interactable, actionName) {
    var _options$actionName$a;

    const options = interactable.options;
    return (_options$actionName$a = options[actionName].autoScroll) == null ? void 0 : _options$actionName$a.enabled;
  },

  onInteractionMove({
    interaction,
    pointer
  }) {
    if (!(interaction.interacting() && autoScroll$1.check(interaction.interactable, interaction.prepared.name))) {
      return;
    }

    if (interaction.simulation) {
      autoScroll$1.x = autoScroll$1.y = 0;
      return;
    }

    let top;
    let right;
    let bottom;
    let left;
    const {
      interactable,
      element
    } = interaction;
    const actionName = interaction.prepared.name;
    const options = interactable.options[actionName].autoScroll;
    const container = getContainer(options.container, interactable, element);

    if (is.window(container)) {
      left = pointer.clientX < autoScroll$1.margin;
      top = pointer.clientY < autoScroll$1.margin;
      right = pointer.clientX > container.innerWidth - autoScroll$1.margin;
      bottom = pointer.clientY > container.innerHeight - autoScroll$1.margin;
    } else {
      const rect = getElementClientRect(container);
      left = pointer.clientX < rect.left + autoScroll$1.margin;
      top = pointer.clientY < rect.top + autoScroll$1.margin;
      right = pointer.clientX > rect.right - autoScroll$1.margin;
      bottom = pointer.clientY > rect.bottom - autoScroll$1.margin;
    }

    autoScroll$1.x = right ? 1 : left ? -1 : 0;
    autoScroll$1.y = bottom ? 1 : top ? -1 : 0;

    if (!autoScroll$1.isScrolling) {
      // set the autoScroll properties to those of the target
      autoScroll$1.margin = options.margin;
      autoScroll$1.speed = options.speed;
      autoScroll$1.start(interaction);
    }
  }

};
function getContainer(value, interactable, element) {
  return (is.string(value) ? getStringOptionResult(value, interactable, element) : value) || getWindow(element);
}
function getScroll(container) {
  if (is.window(container)) {
    container = window.document.body;
  }

  return {
    x: container.scrollLeft,
    y: container.scrollTop
  };
}
function getScrollSize(container) {
  if (is.window(container)) {
    container = window.document.body;
  }

  return {
    x: container.scrollWidth,
    y: container.scrollHeight
  };
}
function getScrollSizeDelta({
  interaction,
  element
}, func) {
  const scrollOptions = interaction && interaction.interactable.options[interaction.prepared.name].autoScroll;

  if (!scrollOptions || !scrollOptions.enabled) {
    func();
    return {
      x: 0,
      y: 0
    };
  }

  const scrollContainer = getContainer(scrollOptions.container, interaction.interactable, element);
  const prevSize = getScroll(scrollContainer);
  func();
  const curSize = getScroll(scrollContainer);
  return {
    x: curSize.x - prevSize.x,
    y: curSize.y - prevSize.y
  };
}
const autoScrollPlugin = {
  id: 'auto-scroll',
  install: install$c,
  listeners: {
    'interactions:new': ({
      interaction
    }) => {
      interaction.autoScroll = null;
    },
    'interactions:destroy': ({
      interaction
    }) => {
      interaction.autoScroll = null;
      autoScroll$1.stop();

      if (autoScroll$1.interaction) {
        autoScroll$1.interaction = null;
      }
    },
    'interactions:stop': autoScroll$1.stop,
    'interactions:action-move': arg => autoScroll$1.onInteractionMove(arg)
  }
};

function warnOnce(method, message) {
  let warned = false;
  return function () {
    if (!warned) {
      ;
      win.console.warn(message);
      warned = true;
    }

    return method.apply(this, arguments);
  };
}
function copyAction(dest, src) {
  dest.name = src.name;
  dest.axis = src.axis;
  dest.edges = src.edges;
  return dest;
}
const sign = n => n >= 0 ? 1 : -1;

function install$b(scope) {
  const {
    /** @lends Interactable */
    Interactable // tslint:disable-line no-shadowed-variable

  } = scope;

  Interactable.prototype.getAction = function getAction(pointer, event, interaction, element) {
    const action = defaultActionChecker(this, event, interaction, element, scope);

    if (this.options.actionChecker) {
      return this.options.actionChecker(pointer, event, action, this, element, interaction);
    }

    return action;
  };
  /**
   * If the target of the `mousedown`, `pointerdown` or `touchstart` event or any
   * of it's parents match the given CSS selector or Element, no
   * drag/resize/gesture is started.
   *
   * @deprecated
   * Don't use this method. Instead set the `ignoreFrom` option for each action
   * or for `pointerEvents`
   *
   * ```js
   * interact(targett)
   *   .draggable({
   *     ignoreFrom: 'input, textarea, a[href]'',
   *   })
   *   .pointerEvents({
   *     ignoreFrom: '[no-pointer]',
   *   })
   * ```
   *
   * @param {string | Element | null} [newValue] a CSS selector string, an
   * Element or `null` to not ignore any elements
   * @return {string | Element | object} The current ignoreFrom value or this
   * Interactable
   */


  Interactable.prototype.ignoreFrom = warnOnce(function (newValue) {
    return this._backCompatOption('ignoreFrom', newValue);
  }, 'Interactable.ignoreFrom() has been deprecated. Use Interactble.draggable({ignoreFrom: newValue}).');
  /**
   *
   * A drag/resize/gesture is started only If the target of the `mousedown`,
   * `pointerdown` or `touchstart` event or any of it's parents match the given
   * CSS selector or Element.
   *
   * @deprecated
   * Don't use this method. Instead set the `allowFrom` option for each action
   * or for `pointerEvents`
   *
   * ```js
   * interact(targett)
   *   .resizable({
   *     allowFrom: '.resize-handle',
   *   .pointerEvents({
   *     allowFrom: '.handle',,
   *   })
   * ```
   *
   * @param {string | Element | null} [newValue] a CSS selector string, an
   * Element or `null` to allow from any element
   * @return {string | Element | object} The current allowFrom value or this
   * Interactable
   */

  Interactable.prototype.allowFrom = warnOnce(function (newValue) {
    return this._backCompatOption('allowFrom', newValue);
  }, 'Interactable.allowFrom() has been deprecated. Use Interactble.draggable({allowFrom: newValue}).');
  /**
   * ```js
   * interact('.resize-drag')
   *   .resizable(true)
   *   .draggable(true)
   *   .actionChecker(function (pointer, event, action, interactable, element, interaction) {
   *
   *     if (interact.matchesSelector(event.target, '.drag-handle')) {
   *       // force drag with handle target
   *       action.name = drag
   *     }
   *     else {
   *       // resize from the top and right edges
   *       action.name  = 'resize'
   *       action.edges = { top: true, right: true }
   *     }
   *
   *     return action
   * })
   * ```
   *
   * Returns or sets the function used to check action to be performed on
   * pointerDown
   *
   * @param {function | null} [checker] A function which takes a pointer event,
   * defaultAction string, interactable, element and interaction as parameters
   * and returns an object with name property 'drag' 'resize' or 'gesture' and
   * optionally an `edges` object with boolean 'top', 'left', 'bottom' and right
   * props.
   * @return {Function | Interactable} The checker function or this Interactable
   */

  Interactable.prototype.actionChecker = actionChecker;
  /**
   * Returns or sets whether the the cursor should be changed depending on the
   * action that would be performed if the mouse were pressed and dragged.
   *
   * @param {boolean} [newValue]
   * @return {boolean | Interactable} The current setting or this Interactable
   */

  Interactable.prototype.styleCursor = styleCursor;
}

function defaultActionChecker(interactable, event, interaction, element, scope) {
  const rect = interactable.getRect(element);
  const buttons = event.buttons || {
    0: 1,
    1: 4,
    3: 8,
    4: 16
  }[event.button];
  const arg = {
    action: null,
    interactable,
    interaction,
    element,
    rect,
    buttons
  };
  scope.fire('auto-start:check', arg);
  return arg.action;
}

function styleCursor(newValue) {
  if (is.bool(newValue)) {
    this.options.styleCursor = newValue;
    return this;
  }

  if (newValue === null) {
    delete this.options.styleCursor;
    return this;
  }

  return this.options.styleCursor;
}

function actionChecker(checker) {
  if (is.func(checker)) {
    this.options.actionChecker = checker;
    return this;
  }

  if (checker === null) {
    delete this.options.actionChecker;
    return this;
  }

  return this.options.actionChecker;
}

var InteractableMethods = {
  id: 'auto-start/interactableMethods',
  install: install$b
};

function install$a(scope) {
  const {
    interactStatic: interact,
    defaults
  } = scope;
  scope.usePlugin(InteractableMethods);
  defaults.base.actionChecker = null;
  defaults.base.styleCursor = true;
  extend$1(defaults.perAction, {
    manualStart: false,
    max: Infinity,
    maxPerElement: 1,
    allowFrom: null,
    ignoreFrom: null,
    // only allow left button by default
    // see https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent/buttons#Return_value
    mouseButtons: 1
  });
  /**
   * Returns or sets the maximum number of concurrent interactions allowed.  By
   * default only 1 interaction is allowed at a time (for backwards
   * compatibility). To allow multiple interactions on the same Interactables and
   * elements, you need to enable it in the draggable, resizable and gesturable
   * `'max'` and `'maxPerElement'` options.
   *
   * @alias module:interact.maxInteractions
   *
   * @param {number} [newValue] Any number. newValue <= 0 means no interactions.
   */

  interact.maxInteractions = newValue => maxInteractions(newValue, scope);

  scope.autoStart = {
    // Allow this many interactions to happen simultaneously
    maxInteractions: Infinity,
    withinInteractionLimit,
    cursorElement: null
  };
}

function prepareOnDown({
  interaction,
  pointer,
  event,
  eventTarget
}, scope) {
  if (interaction.interacting()) return;
  const actionInfo = getActionInfo(interaction, pointer, event, eventTarget, scope);
  prepare(interaction, actionInfo, scope);
}

function prepareOnMove({
  interaction,
  pointer,
  event,
  eventTarget
}, scope) {
  if (interaction.pointerType !== 'mouse' || interaction.pointerIsDown || interaction.interacting()) return;
  const actionInfo = getActionInfo(interaction, pointer, event, eventTarget, scope);
  prepare(interaction, actionInfo, scope);
}

function startOnMove(arg, scope) {
  const {
    interaction
  } = arg;

  if (!interaction.pointerIsDown || interaction.interacting() || !interaction.pointerWasMoved || !interaction.prepared.name) {
    return;
  }

  scope.fire('autoStart:before-start', arg);
  const {
    interactable
  } = interaction;
  const actionName = interaction.prepared.name;

  if (actionName && interactable) {
    // check manualStart and interaction limit
    if (interactable.options[actionName].manualStart || !withinInteractionLimit(interactable, interaction.element, interaction.prepared, scope)) {
      interaction.stop();
    } else {
      interaction.start(interaction.prepared, interactable, interaction.element);
      setInteractionCursor(interaction, scope);
    }
  }
}

function clearCursorOnStop({
  interaction
}, scope) {
  const {
    interactable
  } = interaction;

  if (interactable && interactable.options.styleCursor) {
    setCursor(interaction.element, '', scope);
  }
} // Check if the current interactable supports the action.
// If so, return the validated action. Otherwise, return null


function validateAction(action, interactable, element, eventTarget, scope) {
  if (interactable.testIgnoreAllow(interactable.options[action.name], element, eventTarget) && interactable.options[action.name].enabled && withinInteractionLimit(interactable, element, action, scope)) {
    return action;
  }

  return null;
}

function validateMatches(interaction, pointer, event, matches, matchElements, eventTarget, scope) {
  for (let i = 0, len = matches.length; i < len; i++) {
    const match = matches[i];
    const matchElement = matchElements[i];
    const matchAction = match.getAction(pointer, event, interaction, matchElement);

    if (!matchAction) {
      continue;
    }

    const action = validateAction(matchAction, match, matchElement, eventTarget, scope);

    if (action) {
      return {
        action,
        interactable: match,
        element: matchElement
      };
    }
  }

  return {
    action: null,
    interactable: null,
    element: null
  };
}

function getActionInfo(interaction, pointer, event, eventTarget, scope) {
  let matches = [];
  let matchElements = [];
  let element = eventTarget;

  function pushMatches(interactable) {
    matches.push(interactable);
    matchElements.push(element);
  }

  while (is.element(element)) {
    matches = [];
    matchElements = [];
    scope.interactables.forEachMatch(element, pushMatches);
    const actionInfo = validateMatches(interaction, pointer, event, matches, matchElements, eventTarget, scope);

    if (actionInfo.action && !actionInfo.interactable.options[actionInfo.action.name].manualStart) {
      return actionInfo;
    }

    element = parentNode(element);
  }

  return {
    action: null,
    interactable: null,
    element: null
  };
}

function prepare(interaction, {
  action,
  interactable,
  element
}, scope) {
  action = action || {
    name: null
  };
  interaction.interactable = interactable;
  interaction.element = element;
  copyAction(interaction.prepared, action);
  interaction.rect = interactable && action.name ? interactable.getRect(element) : null;
  setInteractionCursor(interaction, scope);
  scope.fire('autoStart:prepared', {
    interaction
  });
}

function withinInteractionLimit(interactable, element, action, scope) {
  const options = interactable.options;
  const maxActions = options[action.name].max;
  const maxPerElement = options[action.name].maxPerElement;
  const autoStartMax = scope.autoStart.maxInteractions;
  let activeInteractions = 0;
  let interactableCount = 0;
  let elementCount = 0; // no actions if any of these values == 0

  if (!(maxActions && maxPerElement && autoStartMax)) {
    return false;
  }

  for (const interaction of scope.interactions.list) {
    const otherAction = interaction.prepared.name;

    if (!interaction.interacting()) {
      continue;
    }

    activeInteractions++;

    if (activeInteractions >= autoStartMax) {
      return false;
    }

    if (interaction.interactable !== interactable) {
      continue;
    }

    interactableCount += otherAction === action.name ? 1 : 0;

    if (interactableCount >= maxActions) {
      return false;
    }

    if (interaction.element === element) {
      elementCount++;

      if (otherAction === action.name && elementCount >= maxPerElement) {
        return false;
      }
    }
  }

  return autoStartMax > 0;
}

function maxInteractions(newValue, scope) {
  if (is.number(newValue)) {
    scope.autoStart.maxInteractions = newValue;
    return this;
  }

  return scope.autoStart.maxInteractions;
}

function setCursor(element, cursor, scope) {
  const {
    cursorElement: prevCursorElement
  } = scope.autoStart;

  if (prevCursorElement && prevCursorElement !== element) {
    prevCursorElement.style.cursor = '';
  }

  element.ownerDocument.documentElement.style.cursor = cursor;
  element.style.cursor = cursor;
  scope.autoStart.cursorElement = cursor ? element : null;
}

function setInteractionCursor(interaction, scope) {
  const {
    interactable,
    element,
    prepared
  } = interaction;

  if (!(interaction.pointerType === 'mouse' && interactable && interactable.options.styleCursor)) {
    // clear previous target element cursor
    if (scope.autoStart.cursorElement) {
      setCursor(scope.autoStart.cursorElement, '', scope);
    }

    return;
  }

  let cursor = '';

  if (prepared.name) {
    const cursorChecker = interactable.options[prepared.name].cursorChecker;

    if (is.func(cursorChecker)) {
      cursor = cursorChecker(prepared, interactable, element, interaction._interacting);
    } else {
      cursor = scope.actions.map[prepared.name].getCursor(prepared);
    }
  }

  setCursor(interaction.element, cursor || '', scope);
}

const autoStart$1 = {
  id: 'auto-start/base',
  before: ['actions'],
  install: install$a,
  listeners: {
    'interactions:down': prepareOnDown,
    'interactions:move': (arg, scope) => {
      prepareOnMove(arg, scope);
      startOnMove(arg, scope);
    },
    'interactions:stop': clearCursorOnStop
  },
  maxInteractions,
  withinInteractionLimit,
  validateAction
};

function beforeStart({
  interaction,
  eventTarget,
  dx,
  dy
}, scope) {
  if (interaction.prepared.name !== 'drag') return; // check if a drag is in the correct axis

  const absX = Math.abs(dx);
  const absY = Math.abs(dy);
  const targetOptions = interaction.interactable.options.drag;
  const startAxis = targetOptions.startAxis;
  const currentAxis = absX > absY ? 'x' : absX < absY ? 'y' : 'xy';
  interaction.prepared.axis = targetOptions.lockAxis === 'start' ? currentAxis[0] : // always lock to one axis even if currentAxis === 'xy'
  targetOptions.lockAxis; // if the movement isn't in the startAxis of the interactable

  if (currentAxis !== 'xy' && startAxis !== 'xy' && startAxis !== currentAxis) {
    // cancel the prepared action
    ;
    interaction.prepared.name = null; // then try to get a drag from another ineractable

    let element = eventTarget;

    const getDraggable = function (interactable) {
      if (interactable === interaction.interactable) return;
      const options = interaction.interactable.options.drag;

      if (!options.manualStart && interactable.testIgnoreAllow(options, element, eventTarget)) {
        const action = interactable.getAction(interaction.downPointer, interaction.downEvent, interaction, element);

        if (action && action.name === 'drag' && checkStartAxis(currentAxis, interactable) && autoStart$1.validateAction(action, interactable, element, eventTarget, scope)) {
          return interactable;
        }
      }
    }; // check all interactables


    while (is.element(element)) {
      const interactable = scope.interactables.forEachMatch(element, getDraggable);

      if (interactable) {
        ;
        interaction.prepared.name = 'drag';
        interaction.interactable = interactable;
        interaction.element = element;
        break;
      }

      element = parentNode(element);
    }
  }
}

function checkStartAxis(startAxis, interactable) {
  if (!interactable) {
    return false;
  }

  const thisAxis = interactable.options.drag.startAxis;
  return startAxis === 'xy' || thisAxis === 'xy' || thisAxis === startAxis;
}

var dragAxis = {
  id: 'auto-start/dragAxis',
  listeners: {
    'autoStart:before-start': beforeStart
  }
};

function install$9(scope) {
  const {
    defaults
  } = scope;
  scope.usePlugin(autoStart$1);
  defaults.perAction.hold = 0;
  defaults.perAction.delay = 0;
}

function getHoldDuration(interaction) {
  const actionName = interaction.prepared && interaction.prepared.name;

  if (!actionName) {
    return null;
  }

  const options = interaction.interactable.options;
  return options[actionName].hold || options[actionName].delay;
}

const hold = {
  id: 'auto-start/hold',
  install: install$9,
  listeners: {
    'interactions:new': ({
      interaction
    }) => {
      interaction.autoStartHoldTimer = null;
    },
    'autoStart:prepared': ({
      interaction
    }) => {
      const hold = getHoldDuration(interaction);

      if (hold > 0) {
        interaction.autoStartHoldTimer = setTimeout(() => {
          interaction.start(interaction.prepared, interaction.interactable, interaction.element);
        }, hold);
      }
    },
    'interactions:move': ({
      interaction,
      duplicate
    }) => {
      if (interaction.autoStartHoldTimer && interaction.pointerWasMoved && !duplicate) {
        clearTimeout(interaction.autoStartHoldTimer);
        interaction.autoStartHoldTimer = null;
      }
    },
    // prevent regular down->move autoStart
    'autoStart:before-start': ({
      interaction
    }) => {
      const holdDuration = getHoldDuration(interaction);

      if (holdDuration > 0) {
        interaction.prepared.name = null;
      }
    }
  },
  getHoldDuration
};

var autoStart = {
  id: 'auto-start',

  install(scope) {
    scope.usePlugin(autoStart$1);
    scope.usePlugin(hold);
    scope.usePlugin(dragAxis);
  }

};

function preventDefault(newValue) {
  if (/^(always|never|auto)$/.test(newValue)) {
    this.options.preventDefault = newValue;
    return this;
  }

  if (is.bool(newValue)) {
    this.options.preventDefault = newValue ? 'always' : 'never';
    return this;
  }

  return this.options.preventDefault;
}

function checkAndPreventDefault(interactable, scope, event) {
  const setting = interactable.options.preventDefault;
  if (setting === 'never') return;

  if (setting === 'always') {
    event.preventDefault();
    return;
  } // setting === 'auto'
  // if the browser supports passive event listeners and isn't running on iOS,
  // don't preventDefault of touch{start,move} events. CSS touch-action and
  // user-select should be used instead of calling event.preventDefault().


  if (scope.events.supportsPassive && /^touch(start|move)$/.test(event.type)) {
    const doc = getWindow(event.target).document;
    const docOptions = scope.getDocOptions(doc);

    if (!(docOptions && docOptions.events) || docOptions.events.passive !== false) {
      return;
    }
  } // don't preventDefault of pointerdown events


  if (/^(mouse|pointer|touch)*(down|start)/i.test(event.type)) {
    return;
  } // don't preventDefault on editable elements


  if (is.element(event.target) && matchesSelector(event.target, 'input,select,textarea,[contenteditable=true],[contenteditable=true] *')) {
    return;
  }

  event.preventDefault();
}

function onInteractionEvent({
  interaction,
  event
}) {
  if (interaction.interactable) {
    interaction.interactable.checkAndPreventDefault(event);
  }
}

function install$8(scope) {
  /** @lends Interactable */
  const {
    Interactable
  } = scope;
  /**
   * Returns or sets whether to prevent the browser's default behaviour in
   * response to pointer events. Can be set to:
   *  - `'always'` to always prevent
   *  - `'never'` to never prevent
   *  - `'auto'` to let interact.js try to determine what would be best
   *
   * @param {string} [newValue] `'always'`, `'never'` or `'auto'`
   * @return {string | Interactable} The current setting or this Interactable
   */

  Interactable.prototype.preventDefault = preventDefault;

  Interactable.prototype.checkAndPreventDefault = function (event) {
    return checkAndPreventDefault(this, scope, event);
  }; // prevent native HTML5 drag on interact.js target elements


  scope.interactions.docEvents.push({
    type: 'dragstart',

    listener(event) {
      for (const interaction of scope.interactions.list) {
        if (interaction.element && (interaction.element === event.target || nodeContains(interaction.element, event.target))) {
          interaction.interactable.checkAndPreventDefault(event);
          return;
        }
      }
    }

  });
}
var interactablePreventDefault = {
  id: 'core/interactablePreventDefault',
  install: install$8,
  listeners: ['down', 'move', 'up', 'cancel'].reduce((acc, eventType) => {
    acc[`interactions:${eventType}`] = onInteractionEvent;
    return acc;
  }, {})
};

var visualizer = {};

var CheckName;

(function (CheckName) {
  CheckName["touchAction"] = "touchAction";
  CheckName["boxSizing"] = "boxSizing";
  CheckName["noListeners"] = "noListeners";
})(CheckName || (CheckName = {}));

const prefix = '[interact.js] ';
const links = {
  touchAction: 'https://developer.mozilla.org/en-US/docs/Web/CSS/touch-action',
  boxSizing: 'https://developer.mozilla.org/en-US/docs/Web/CSS/box-sizing'
}; // eslint-disable-next-line no-undef

const isProduction = "development" === 'production';

function install$7(scope, {
  logger
} = {}) {
  const {
    Interactable,
    defaults
  } = scope;
  scope.logger = logger || console;
  defaults.base.devTools = {
    ignore: {}
  };

  Interactable.prototype.devTools = function (options) {
    if (options) {
      extend$1(this.options.devTools, options);
      return this;
    }

    return this.options.devTools;
  };

  scope.usePlugin(visualizer);
}

const checks = [{
  name: CheckName.touchAction,

  perform({
    element
  }) {
    return !parentHasStyle(element, 'touchAction', /pan-|pinch|none/);
  },

  getInfo({
    element
  }) {
    return [element, links.touchAction];
  },

  text: 'Consider adding CSS "touch-action: none" to this element\n'
}, {
  name: CheckName.boxSizing,

  perform(interaction) {
    const {
      element
    } = interaction;
    return interaction.prepared.name === 'resize' && element instanceof domObjects.HTMLElement && !hasStyle(element, 'boxSizing', /border-box/);
  },

  text: 'Consider adding CSS "box-sizing: border-box" to this resizable element',

  getInfo({
    element
  }) {
    return [element, links.boxSizing];
  }

}, {
  name: CheckName.noListeners,

  perform(interaction) {
    const actionName = interaction.prepared.name;
    const moveListeners = interaction.interactable.events.types[`${actionName}move`] || [];
    return !moveListeners.length;
  },

  getInfo(interaction) {
    return [interaction.prepared.name, interaction.interactable];
  },

  text: 'There are no listeners set for this action'
}];

function hasStyle(element, prop, styleRe) {
  const value = element.style[prop] || win.getComputedStyle(element)[prop];
  return styleRe.test((value || '').toString());
}

function parentHasStyle(element, prop, styleRe) {
  let parent = element;

  while (is.element(parent)) {
    if (hasStyle(parent, prop, styleRe)) {
      return true;
    }

    parent = parentNode(parent);
  }

  return false;
}

const id = 'dev-tools';
const defaultExport = isProduction ? {
  id,
  install: () => {}
} : {
  id,
  install: install$7,
  listeners: {
    'interactions:action-start': ({
      interaction
    }, scope) => {
      for (const check of checks) {
        const options = interaction.interactable && interaction.interactable.options;

        if (!(options && options.devTools && options.devTools.ignore[check.name]) && check.perform(interaction)) {
          scope.logger.warn(prefix + check.text, ...check.getInfo(interaction));
        }
      }
    }
  },
  checks,
  CheckName,
  links,
  prefix
};

function clone$1(source) {
  const dest = {};

  for (const prop in source) {
    const value = source[prop];

    if (is.plainObject(value)) {
      dest[prop] = clone$1(value);
    } else if (is.array(value)) {
      dest[prop] = from$1(value);
    } else {
      dest[prop] = value;
    }
  }

  return dest;
}

class Modification {
  constructor(interaction) {
    this.states = [];
    this.startOffset = {
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    };
    this.startDelta = void 0;
    this.result = void 0;
    this.endResult = void 0;
    this.edges = void 0;
    this.interaction = void 0;
    this.interaction = interaction;
    this.result = createResult();
  }

  start({
    phase
  }, pageCoords) {
    const {
      interaction
    } = this;
    const modifierList = getModifierList(interaction);
    this.prepareStates(modifierList);
    this.edges = extend$1({}, interaction.edges);
    this.startOffset = getRectOffset(interaction.rect, pageCoords);
    this.startDelta = {
      x: 0,
      y: 0
    };
    const arg = this.fillArg({
      phase,
      pageCoords,
      preEnd: false
    });
    this.result = createResult();
    this.startAll(arg);
    const result = this.result = this.setAll(arg);
    return result;
  }

  fillArg(arg) {
    const {
      interaction
    } = this;
    arg.interaction = interaction;
    arg.interactable = interaction.interactable;
    arg.element = interaction.element;
    arg.rect = arg.rect || interaction.rect;
    arg.edges = this.edges;
    arg.startOffset = this.startOffset;
    return arg;
  }

  startAll(arg) {
    for (const state of this.states) {
      if (state.methods.start) {
        arg.state = state;
        state.methods.start(arg);
      }
    }
  }

  setAll(arg) {
    const {
      phase,
      preEnd,
      skipModifiers,
      rect: unmodifiedRect
    } = arg;
    arg.coords = extend$1({}, arg.pageCoords);
    arg.rect = extend$1({}, unmodifiedRect);
    const states = skipModifiers ? this.states.slice(skipModifiers) : this.states;
    const newResult = createResult(arg.coords, arg.rect);

    for (const state of states) {
      var _state$methods;

      const {
        options
      } = state;
      const lastModifierCoords = extend$1({}, arg.coords);
      let returnValue = null;

      if ((_state$methods = state.methods) != null && _state$methods.set && this.shouldDo(options, preEnd, phase)) {
        arg.state = state;
        returnValue = state.methods.set(arg);
        addEdges(this.interaction.edges, arg.rect, {
          x: arg.coords.x - lastModifierCoords.x,
          y: arg.coords.y - lastModifierCoords.y
        });
      }

      newResult.eventProps.push(returnValue);
    }

    newResult.delta.x = arg.coords.x - arg.pageCoords.x;
    newResult.delta.y = arg.coords.y - arg.pageCoords.y;
    newResult.rectDelta.left = arg.rect.left - unmodifiedRect.left;
    newResult.rectDelta.right = arg.rect.right - unmodifiedRect.right;
    newResult.rectDelta.top = arg.rect.top - unmodifiedRect.top;
    newResult.rectDelta.bottom = arg.rect.bottom - unmodifiedRect.bottom;
    const prevCoords = this.result.coords;
    const prevRect = this.result.rect;

    if (prevCoords && prevRect) {
      const rectChanged = newResult.rect.left !== prevRect.left || newResult.rect.right !== prevRect.right || newResult.rect.top !== prevRect.top || newResult.rect.bottom !== prevRect.bottom;
      newResult.changed = rectChanged || prevCoords.x !== newResult.coords.x || prevCoords.y !== newResult.coords.y;
    }

    return newResult;
  }

  applyToInteraction(arg) {
    const {
      interaction
    } = this;
    const {
      phase
    } = arg;
    const curCoords = interaction.coords.cur;
    const startCoords = interaction.coords.start;
    const {
      result,
      startDelta
    } = this;
    const curDelta = result.delta;

    if (phase === 'start') {
      extend$1(this.startDelta, result.delta);
    }

    for (const [coordsSet, delta] of [[startCoords, startDelta], [curCoords, curDelta]]) {
      coordsSet.page.x += delta.x;
      coordsSet.page.y += delta.y;
      coordsSet.client.x += delta.x;
      coordsSet.client.y += delta.y;
    }

    const {
      rectDelta
    } = this.result;
    const rect = arg.rect || interaction.rect;
    rect.left += rectDelta.left;
    rect.right += rectDelta.right;
    rect.top += rectDelta.top;
    rect.bottom += rectDelta.bottom;
    rect.width = rect.right - rect.left;
    rect.height = rect.bottom - rect.top;
  }

  setAndApply(arg) {
    const {
      interaction
    } = this;
    const {
      phase,
      preEnd,
      skipModifiers
    } = arg;
    const result = this.setAll(this.fillArg({
      preEnd,
      phase,
      pageCoords: arg.modifiedCoords || interaction.coords.cur.page
    }));
    this.result = result; // don't fire an action move if a modifier would keep the event in the same
    // cordinates as before

    if (!result.changed && (!skipModifiers || skipModifiers < this.states.length) && interaction.interacting()) {
      return false;
    }

    if (arg.modifiedCoords) {
      const {
        page
      } = interaction.coords.cur;
      const adjustment = {
        x: arg.modifiedCoords.x - page.x,
        y: arg.modifiedCoords.y - page.y
      };
      result.coords.x += adjustment.x;
      result.coords.y += adjustment.y;
      result.delta.x += adjustment.x;
      result.delta.y += adjustment.y;
    }

    this.applyToInteraction(arg);
  }

  beforeEnd(arg) {
    const {
      interaction,
      event
    } = arg;
    const states = this.states;

    if (!states || !states.length) {
      return;
    }

    let doPreend = false;

    for (const state of states) {
      arg.state = state;
      const {
        options,
        methods
      } = state;
      const endPosition = methods.beforeEnd && methods.beforeEnd(arg);

      if (endPosition) {
        this.endResult = endPosition;
        return false;
      }

      doPreend = doPreend || !doPreend && this.shouldDo(options, true, arg.phase, true);
    }

    if (doPreend) {
      // trigger a final modified move before ending
      interaction.move({
        event,
        preEnd: true
      });
    }
  }

  stop(arg) {
    const {
      interaction
    } = arg;

    if (!this.states || !this.states.length) {
      return;
    }

    const modifierArg = extend$1({
      states: this.states,
      interactable: interaction.interactable,
      element: interaction.element,
      rect: null
    }, arg);
    this.fillArg(modifierArg);

    for (const state of this.states) {
      modifierArg.state = state;

      if (state.methods.stop) {
        state.methods.stop(modifierArg);
      }
    }

    this.states = null;
    this.endResult = null;
  }

  prepareStates(modifierList) {
    this.states = [];

    for (let index = 0; index < modifierList.length; index++) {
      const {
        options,
        methods,
        name
      } = modifierList[index];
      this.states.push({
        options,
        methods,
        index,
        name
      });
    }

    return this.states;
  }

  restoreInteractionCoords({
    interaction: {
      coords,
      rect,
      modification
    }
  }) {
    if (!modification.result) return;
    const {
      startDelta
    } = modification;
    const {
      delta: curDelta,
      rectDelta
    } = modification.result;
    const coordsAndDeltas = [[coords.start, startDelta], [coords.cur, curDelta]];

    for (const [coordsSet, delta] of coordsAndDeltas) {
      coordsSet.page.x -= delta.x;
      coordsSet.page.y -= delta.y;
      coordsSet.client.x -= delta.x;
      coordsSet.client.y -= delta.y;
    }

    rect.left -= rectDelta.left;
    rect.right -= rectDelta.right;
    rect.top -= rectDelta.top;
    rect.bottom -= rectDelta.bottom;
  }

  shouldDo(options, preEnd, phase, requireEndOnly) {
    if ( // ignore disabled modifiers
    !options || options.enabled === false || // check if we require endOnly option to fire move before end
    requireEndOnly && !options.endOnly || // don't apply endOnly modifiers when not ending
    options.endOnly && !preEnd || // check if modifier should run be applied on start
    phase === 'start' && !options.setStart) {
      return false;
    }

    return true;
  }

  copyFrom(other) {
    this.startOffset = other.startOffset;
    this.startDelta = other.startDelta;
    this.edges = other.edges;
    this.states = other.states.map(s => clone$1(s));
    this.result = createResult(extend$1({}, other.result.coords), extend$1({}, other.result.rect));
  }

  destroy() {
    for (const prop in this) {
      this[prop] = null;
    }
  }

}

function createResult(coords, rect) {
  return {
    rect,
    coords,
    delta: {
      x: 0,
      y: 0
    },
    rectDelta: {
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    },
    eventProps: [],
    changed: true
  };
}

function getModifierList(interaction) {
  const actionOptions = interaction.interactable.options[interaction.prepared.name];
  const actionModifiers = actionOptions.modifiers;

  if (actionModifiers && actionModifiers.length) {
    return actionModifiers;
  }

  return ['snap', 'snapSize', 'snapEdges', 'restrict', 'restrictEdges', 'restrictSize'].map(type => {
    const options = actionOptions[type];
    return options && options.enabled && {
      options,
      methods: options._methods
    };
  }).filter(m => !!m);
}

function getRectOffset(rect, coords) {
  return rect ? {
    left: coords.x - rect.left,
    top: coords.y - rect.top,
    right: rect.right - coords.x,
    bottom: rect.bottom - coords.y
  } : {
    left: 0,
    top: 0,
    right: 0,
    bottom: 0
  };
}

function makeModifier(module, name) {
  const {
    defaults
  } = module;
  const methods = {
    start: module.start,
    set: module.set,
    beforeEnd: module.beforeEnd,
    stop: module.stop
  };

  const modifier = _options => {
    const options = _options || {};
    options.enabled = options.enabled !== false; // add missing defaults to options

    for (const prop in defaults) {
      if (!(prop in options)) {
        ;
        options[prop] = defaults[prop];
      }
    }

    const m = {
      options,
      methods,
      name,
      enable: () => {
        options.enabled = true;
        return m;
      },
      disable: () => {
        options.enabled = false;
        return m;
      }
    };
    return m;
  };

  if (name && typeof name === 'string') {
    // for backwrads compatibility
    modifier._defaults = defaults;
    modifier._methods = methods;
  }

  return modifier;
}
function addEventModifiers({
  iEvent,
  interaction
}) {
  const result = interaction.modification.result;

  if (result) {
    iEvent.modifiers = result.eventProps;
  }
}
const modifiersBase = {
  id: 'modifiers/base',
  before: ['actions'],
  install: scope => {
    scope.defaults.perAction.modifiers = [];
  },
  listeners: {
    'interactions:new': ({
      interaction
    }) => {
      interaction.modification = new Modification(interaction);
    },
    'interactions:before-action-start': arg => {
      const modification = arg.interaction.modification;
      modification.start(arg, arg.interaction.coords.start.page);
      arg.interaction.edges = modification.edges;
      modification.applyToInteraction(arg);
    },
    'interactions:before-action-move': arg => arg.interaction.modification.setAndApply(arg),
    'interactions:before-action-end': arg => arg.interaction.modification.beforeEnd(arg),
    'interactions:action-start': addEventModifiers,
    'interactions:action-move': addEventModifiers,
    'interactions:action-end': addEventModifiers,
    'interactions:after-action-start': arg => arg.interaction.modification.restoreInteractionCoords(arg),
    'interactions:after-action-move': arg => arg.interaction.modification.restoreInteractionCoords(arg),
    'interactions:stop': arg => arg.interaction.modification.stop(arg)
  }
};

// eslint-disable-next-line @typescript-eslint/no-empty-interface
// export interface Options extends BaseDefaults, PerActionDefaults {}
const defaults$9 = {
  base: {
    preventDefault: 'auto',
    deltaSource: 'page'
  },
  perAction: {
    enabled: false,
    origin: {
      x: 0,
      y: 0
    }
  },
  actions: {}
};

class InteractEvent extends BaseEvent {
  // resize

  /** */
  constructor(interaction, event, actionName, phase, element, preEnd, type) {
    super(interaction);
    this.target = void 0;
    this.currentTarget = void 0;
    this.relatedTarget = null;
    this.screenX = void 0;
    this.screenY = void 0;
    this.button = void 0;
    this.buttons = void 0;
    this.ctrlKey = void 0;
    this.shiftKey = void 0;
    this.altKey = void 0;
    this.metaKey = void 0;
    this.page = void 0;
    this.client = void 0;
    this.delta = void 0;
    this.rect = void 0;
    this.x0 = void 0;
    this.y0 = void 0;
    this.t0 = void 0;
    this.dt = void 0;
    this.duration = void 0;
    this.clientX0 = void 0;
    this.clientY0 = void 0;
    this.velocity = void 0;
    this.speed = void 0;
    this.swipe = void 0;
    this.timeStamp = void 0;
    this.axes = void 0;
    this.preEnd = void 0;
    element = element || interaction.element;
    const target = interaction.interactable;
    const deltaSource = (target && target.options || defaults$9).deltaSource;
    const origin = getOriginXY(target, element, actionName);
    const starting = phase === 'start';
    const ending = phase === 'end';
    const prevEvent = starting ? this : interaction.prevEvent;
    const coords = starting ? interaction.coords.start : ending ? {
      page: prevEvent.page,
      client: prevEvent.client,
      timeStamp: interaction.coords.cur.timeStamp
    } : interaction.coords.cur;
    this.page = extend$1({}, coords.page);
    this.client = extend$1({}, coords.client);
    this.rect = extend$1({}, interaction.rect);
    this.timeStamp = coords.timeStamp;

    if (!ending) {
      this.page.x -= origin.x;
      this.page.y -= origin.y;
      this.client.x -= origin.x;
      this.client.y -= origin.y;
    }

    this.ctrlKey = event.ctrlKey;
    this.altKey = event.altKey;
    this.shiftKey = event.shiftKey;
    this.metaKey = event.metaKey;
    this.button = event.button;
    this.buttons = event.buttons;
    this.target = element;
    this.currentTarget = element;
    this.preEnd = preEnd;
    this.type = type || actionName + (phase || '');
    this.interactable = target;
    this.t0 = starting ? interaction.pointers[interaction.pointers.length - 1].downTime : prevEvent.t0;
    this.x0 = interaction.coords.start.page.x - origin.x;
    this.y0 = interaction.coords.start.page.y - origin.y;
    this.clientX0 = interaction.coords.start.client.x - origin.x;
    this.clientY0 = interaction.coords.start.client.y - origin.y;

    if (starting || ending) {
      this.delta = {
        x: 0,
        y: 0
      };
    } else {
      this.delta = {
        x: this[deltaSource].x - prevEvent[deltaSource].x,
        y: this[deltaSource].y - prevEvent[deltaSource].y
      };
    }

    this.dt = interaction.coords.delta.timeStamp;
    this.duration = this.timeStamp - this.t0; // velocity and speed in pixels per second

    this.velocity = extend$1({}, interaction.coords.velocity[deltaSource]);
    this.speed = hypot(this.velocity.x, this.velocity.y);
    this.swipe = ending || phase === 'inertiastart' ? this.getSwipe() : null;
  }

  getSwipe() {
    const interaction = this._interaction;

    if (interaction.prevEvent.speed < 600 || this.timeStamp - interaction.prevEvent.timeStamp > 150) {
      return null;
    }

    let angle = 180 * Math.atan2(interaction.prevEvent.velocityY, interaction.prevEvent.velocityX) / Math.PI;
    const overlap = 22.5;

    if (angle < 0) {
      angle += 360;
    }

    const left = 135 - overlap <= angle && angle < 225 + overlap;
    const up = 225 - overlap <= angle && angle < 315 + overlap;
    const right = !left && (315 - overlap <= angle || angle < 45 + overlap);
    const down = !up && 45 - overlap <= angle && angle < 135 + overlap;
    return {
      up,
      down,
      left,
      right,
      angle,
      speed: interaction.prevEvent.speed,
      velocity: {
        x: interaction.prevEvent.velocityX,
        y: interaction.prevEvent.velocityY
      }
    };
  }

  preventDefault() {}
  /**
   * Don't call listeners on the remaining targets
   */


  stopImmediatePropagation() {
    this.immediatePropagationStopped = this.propagationStopped = true;
  }
  /**
   * Don't call any other listeners (even on the current target)
   */


  stopPropagation() {
    this.propagationStopped = true;
  }

} // getters and setters defined here to support typescript 3.6 and below which
// don't support getter and setters in .d.ts files

Object.defineProperties(InteractEvent.prototype, {
  pageX: {
    get() {
      return this.page.x;
    },

    set(value) {
      this.page.x = value;
    }

  },
  pageY: {
    get() {
      return this.page.y;
    },

    set(value) {
      this.page.y = value;
    }

  },
  clientX: {
    get() {
      return this.client.x;
    },

    set(value) {
      this.client.x = value;
    }

  },
  clientY: {
    get() {
      return this.client.y;
    },

    set(value) {
      this.client.y = value;
    }

  },
  dx: {
    get() {
      return this.delta.x;
    },

    set(value) {
      this.delta.x = value;
    }

  },
  dy: {
    get() {
      return this.delta.y;
    },

    set(value) {
      this.delta.y = value;
    }

  },
  velocityX: {
    get() {
      return this.velocity.x;
    },

    set(value) {
      this.velocity.x = value;
    }

  },
  velocityY: {
    get() {
      return this.velocity.y;
    },

    set(value) {
      this.velocity.y = value;
    }

  }
});

class PointerInfo {
  constructor(id, pointer, event, downTime, downTarget) {
    this.id = void 0;
    this.pointer = void 0;
    this.event = void 0;
    this.downTime = void 0;
    this.downTarget = void 0;
    this.id = id;
    this.pointer = pointer;
    this.event = event;
    this.downTime = downTime;
    this.downTarget = downTarget;
  }

}

let _ProxyValues;

(function (_ProxyValues) {
  _ProxyValues["interactable"] = "";
  _ProxyValues["element"] = "";
  _ProxyValues["prepared"] = "";
  _ProxyValues["pointerIsDown"] = "";
  _ProxyValues["pointerWasMoved"] = "";
  _ProxyValues["_proxy"] = "";
})(_ProxyValues || (_ProxyValues = {}));

let _ProxyMethods;

(function (_ProxyMethods) {
  _ProxyMethods["start"] = "";
  _ProxyMethods["move"] = "";
  _ProxyMethods["end"] = "";
  _ProxyMethods["stop"] = "";
  _ProxyMethods["interacting"] = "";
})(_ProxyMethods || (_ProxyMethods = {}));

let idCounter = 0;
class Interaction {
  // current interactable being interacted with
  // the target element of the interactable
  // action that's ready to be fired on next move event
  // keep track of added pointers
  // pointerdown/mousedown/touchstart event
  // previous action event

  /** @internal */
  get pointerMoveTolerance() {
    return 1;
  }
  /**
   * @alias Interaction.prototype.move
   */


  /** */
  constructor({
    pointerType,
    scopeFire
  }) {
    this.interactable = null;
    this.element = null;
    this.rect = void 0;
    this._rects = void 0;
    this.edges = void 0;
    this._scopeFire = void 0;
    this.prepared = {
      name: null,
      axis: null,
      edges: null
    };
    this.pointerType = void 0;
    this.pointers = [];
    this.downEvent = null;
    this.downPointer = {};
    this._latestPointer = {
      pointer: null,
      event: null,
      eventTarget: null
    };
    this.prevEvent = null;
    this.pointerIsDown = false;
    this.pointerWasMoved = false;
    this._interacting = false;
    this._ending = false;
    this._stopped = true;
    this._proxy = null;
    this.simulation = null;
    this.doMove = warnOnce(function (signalArg) {
      this.move(signalArg);
    }, 'The interaction.doMove() method has been renamed to interaction.move()');
    this.coords = {
      // Starting InteractEvent pointer coordinates
      start: newCoords(),
      // Previous native pointer move event coordinates
      prev: newCoords(),
      // current native pointer move event coordinates
      cur: newCoords(),
      // Change in coordinates and time of the pointer
      delta: newCoords(),
      // pointer velocity
      velocity: newCoords()
    };
    this._id = idCounter++;
    this._scopeFire = scopeFire;
    this.pointerType = pointerType;
    const that = this;
    this._proxy = {};

    for (const key in _ProxyValues) {
      Object.defineProperty(this._proxy, key, {
        get() {
          return that[key];
        }

      });
    }

    for (const key in _ProxyMethods) {
      Object.defineProperty(this._proxy, key, {
        value: (...args) => that[key](...args)
      });
    }

    this._scopeFire('interactions:new', {
      interaction: this
    });
  }

  pointerDown(pointer, event, eventTarget) {
    const pointerIndex = this.updatePointer(pointer, event, eventTarget, true);
    const pointerInfo = this.pointers[pointerIndex];

    this._scopeFire('interactions:down', {
      pointer,
      event,
      eventTarget,
      pointerIndex,
      pointerInfo,
      type: 'down',
      interaction: this
    });
  }
  /**
   * ```js
   * interact(target)
   *   .draggable({
   *     // disable the default drag start by down->move
   *     manualStart: true
   *   })
   *   // start dragging after the user holds the pointer down
   *   .on('hold', function (event) {
   *     var interaction = event.interaction
   *
   *     if (!interaction.interacting()) {
   *       interaction.start({ name: 'drag' },
   *                         event.interactable,
   *                         event.currentTarget)
   *     }
   * })
   * ```
   *
   * Start an action with the given Interactable and Element as tartgets. The
   * action must be enabled for the target Interactable and an appropriate
   * number of pointers must be held down - 1 for drag/resize, 2 for gesture.
   *
   * Use it with `interactable.<action>able({ manualStart: false })` to always
   * [start actions manually](https://github.com/taye/interact.js/issues/114)
   *
   * @param {object} action   The action to be performed - drag, resize, etc.
   * @param {Interactable} target  The Interactable to target
   * @param {Element} element The DOM Element to target
   * @return {Boolean} Whether the interaction was successfully started
   */


  start(action, interactable, element) {
    if (this.interacting() || !this.pointerIsDown || this.pointers.length < (action.name === 'gesture' ? 2 : 1) || !interactable.options[action.name].enabled) {
      return false;
    }

    copyAction(this.prepared, action);
    this.interactable = interactable;
    this.element = element;
    this.rect = interactable.getRect(element);
    this.edges = this.prepared.edges ? extend$1({}, this.prepared.edges) : {
      left: true,
      right: true,
      top: true,
      bottom: true
    };
    this._stopped = false;
    this._interacting = this._doPhase({
      interaction: this,
      event: this.downEvent,
      phase: 'start'
    }) && !this._stopped;
    return this._interacting;
  }

  pointerMove(pointer, event, eventTarget) {
    if (!this.simulation && !(this.modification && this.modification.endResult)) {
      this.updatePointer(pointer, event, eventTarget, false);
    }

    const duplicateMove = this.coords.cur.page.x === this.coords.prev.page.x && this.coords.cur.page.y === this.coords.prev.page.y && this.coords.cur.client.x === this.coords.prev.client.x && this.coords.cur.client.y === this.coords.prev.client.y;
    let dx;
    let dy; // register movement greater than pointerMoveTolerance

    if (this.pointerIsDown && !this.pointerWasMoved) {
      dx = this.coords.cur.client.x - this.coords.start.client.x;
      dy = this.coords.cur.client.y - this.coords.start.client.y;
      this.pointerWasMoved = hypot(dx, dy) > this.pointerMoveTolerance;
    }

    const pointerIndex = this.getPointerIndex(pointer);
    const signalArg = {
      pointer,
      pointerIndex,
      pointerInfo: this.pointers[pointerIndex],
      event,
      type: 'move',
      eventTarget,
      dx,
      dy,
      duplicate: duplicateMove,
      interaction: this
    };

    if (!duplicateMove) {
      // set pointer coordinate, time changes and velocity
      setCoordVelocity(this.coords.velocity, this.coords.delta);
    }

    this._scopeFire('interactions:move', signalArg);

    if (!duplicateMove && !this.simulation) {
      // if interacting, fire an 'action-move' signal etc
      if (this.interacting()) {
        signalArg.type = null;
        this.move(signalArg);
      }

      if (this.pointerWasMoved) {
        copyCoords(this.coords.prev, this.coords.cur);
      }
    }
  }
  /**
   * ```js
   * interact(target)
   *   .draggable(true)
   *   .on('dragmove', function (event) {
   *     if (someCondition) {
   *       // change the snap settings
   *       event.interactable.draggable({ snap: { targets: [] }})
   *       // fire another move event with re-calculated snap
   *       event.interaction.move()
   *     }
   *   })
   * ```
   *
   * Force a move of the current action at the same coordinates. Useful if
   * snap/restrict has been changed and you want a movement with the new
   * settings.
   */


  move(signalArg) {
    if (!signalArg || !signalArg.event) {
      setZeroCoords(this.coords.delta);
    }

    signalArg = extend$1({
      pointer: this._latestPointer.pointer,
      event: this._latestPointer.event,
      eventTarget: this._latestPointer.eventTarget,
      interaction: this
    }, signalArg || {});
    signalArg.phase = 'move';

    this._doPhase(signalArg);
  } // End interact move events and stop auto-scroll unless simulation is running


  pointerUp(pointer, event, eventTarget, curEventTarget) {
    let pointerIndex = this.getPointerIndex(pointer);

    if (pointerIndex === -1) {
      pointerIndex = this.updatePointer(pointer, event, eventTarget, false);
    }

    const type = /cancel$/i.test(event.type) ? 'cancel' : 'up';

    this._scopeFire(`interactions:${type}`, {
      pointer,
      pointerIndex,
      pointerInfo: this.pointers[pointerIndex],
      event,
      eventTarget,
      type: type,
      curEventTarget,
      interaction: this
    });

    if (!this.simulation) {
      this.end(event);
    }

    this.removePointer(pointer, event);
  }

  documentBlur(event) {
    this.end(event);

    this._scopeFire('interactions:blur', {
      event,
      type: 'blur',
      interaction: this
    });
  }
  /**
   * ```js
   * interact(target)
   *   .draggable(true)
   *   .on('move', function (event) {
   *     if (event.pageX > 1000) {
   *       // end the current action
   *       event.interaction.end()
   *       // stop all further listeners from being called
   *       event.stopImmediatePropagation()
   *     }
   *   })
   * ```
   *
   * @param {PointerEvent} [event]
   */


  end(event) {
    this._ending = true;
    event = event || this._latestPointer.event;
    let endPhaseResult;

    if (this.interacting()) {
      endPhaseResult = this._doPhase({
        event,
        interaction: this,
        phase: 'end'
      });
    }

    this._ending = false;

    if (endPhaseResult === true) {
      this.stop();
    }
  }

  currentAction() {
    return this._interacting ? this.prepared.name : null;
  }

  interacting() {
    return this._interacting;
  }
  /** */


  stop() {
    this._scopeFire('interactions:stop', {
      interaction: this
    });

    this.interactable = this.element = null;
    this._interacting = false;
    this._stopped = true;
    this.prepared.name = this.prevEvent = null;
  }

  getPointerIndex(pointer) {
    const pointerId = getPointerId(pointer); // mouse and pen interactions may have only one pointer

    return this.pointerType === 'mouse' || this.pointerType === 'pen' ? this.pointers.length - 1 : findIndex(this.pointers, curPointer => curPointer.id === pointerId);
  }

  getPointerInfo(pointer) {
    return this.pointers[this.getPointerIndex(pointer)];
  }

  updatePointer(pointer, event, eventTarget, down) {
    const id = getPointerId(pointer);
    let pointerIndex = this.getPointerIndex(pointer);
    let pointerInfo = this.pointers[pointerIndex];
    down = down === false ? false : down || /(down|start)$/i.test(event.type);

    if (!pointerInfo) {
      pointerInfo = new PointerInfo(id, pointer, event, null, null);
      pointerIndex = this.pointers.length;
      this.pointers.push(pointerInfo);
    } else {
      pointerInfo.pointer = pointer;
    }

    setCoords(this.coords.cur, this.pointers.map(p => p.pointer), this._now());
    setCoordDeltas(this.coords.delta, this.coords.prev, this.coords.cur);

    if (down) {
      this.pointerIsDown = true;
      pointerInfo.downTime = this.coords.cur.timeStamp;
      pointerInfo.downTarget = eventTarget;
      pointerExtend(this.downPointer, pointer);

      if (!this.interacting()) {
        copyCoords(this.coords.start, this.coords.cur);
        copyCoords(this.coords.prev, this.coords.cur);
        this.downEvent = event;
        this.pointerWasMoved = false;
      }
    }

    this._updateLatestPointer(pointer, event, eventTarget);

    this._scopeFire('interactions:update-pointer', {
      pointer,
      event,
      eventTarget,
      down,
      pointerInfo,
      pointerIndex,
      interaction: this
    });

    return pointerIndex;
  }

  removePointer(pointer, event) {
    const pointerIndex = this.getPointerIndex(pointer);
    if (pointerIndex === -1) return;
    const pointerInfo = this.pointers[pointerIndex];

    this._scopeFire('interactions:remove-pointer', {
      pointer,
      event,
      eventTarget: null,
      pointerIndex,
      pointerInfo,
      interaction: this
    });

    this.pointers.splice(pointerIndex, 1);
    this.pointerIsDown = false;
  }

  _updateLatestPointer(pointer, event, eventTarget) {
    this._latestPointer.pointer = pointer;
    this._latestPointer.event = event;
    this._latestPointer.eventTarget = eventTarget;
  }

  destroy() {
    this._latestPointer.pointer = null;
    this._latestPointer.event = null;
    this._latestPointer.eventTarget = null;
  }

  _createPreparedEvent(event, phase, preEnd, type) {
    return new InteractEvent(this, event, this.prepared.name, phase, this.element, preEnd, type);
  }

  _fireEvent(iEvent) {
    this.interactable.fire(iEvent);

    if (!this.prevEvent || iEvent.timeStamp >= this.prevEvent.timeStamp) {
      this.prevEvent = iEvent;
    }
  }

  _doPhase(signalArg) {
    const {
      event,
      phase,
      preEnd,
      type
    } = signalArg;
    const {
      rect
    } = this;

    if (rect && phase === 'move') {
      // update the rect changes due to pointer move
      addEdges(this.edges, rect, this.coords.delta[this.interactable.options.deltaSource]);
      rect.width = rect.right - rect.left;
      rect.height = rect.bottom - rect.top;
    }

    const beforeResult = this._scopeFire(`interactions:before-action-${phase}`, signalArg);

    if (beforeResult === false) {
      return false;
    }

    const iEvent = signalArg.iEvent = this._createPreparedEvent(event, phase, preEnd, type);

    this._scopeFire(`interactions:action-${phase}`, signalArg);

    if (phase === 'start') {
      this.prevEvent = iEvent;
    }

    this._fireEvent(iEvent);

    this._scopeFire(`interactions:after-action-${phase}`, signalArg);

    return true;
  }

  _now() {
    return Date.now();
  }

}

;
_ProxyMethods.offsetBy = '';
function addTotal(interaction) {
  if (!interaction.pointerIsDown) {
    return;
  }

  addToCoords(interaction.coords.cur, interaction.offset.total);
  interaction.offset.pending.x = 0;
  interaction.offset.pending.y = 0;
}

function beforeAction({
  interaction
}) {
  applyPending(interaction);
}

function beforeEnd({
  interaction
}) {
  const hadPending = applyPending(interaction);
  if (!hadPending) return;
  interaction.move({
    offset: true
  });
  interaction.end();
  return false;
}

function end({
  interaction
}) {
  interaction.offset.total.x = 0;
  interaction.offset.total.y = 0;
  interaction.offset.pending.x = 0;
  interaction.offset.pending.y = 0;
}

function applyPending(interaction) {
  if (!hasPending(interaction)) {
    return false;
  }

  const {
    pending
  } = interaction.offset;
  addToCoords(interaction.coords.cur, pending);
  addToCoords(interaction.coords.delta, pending);
  addEdges(interaction.edges, interaction.rect, pending);
  pending.x = 0;
  pending.y = 0;
  return true;
}

function offsetBy({
  x,
  y
}) {
  this.offset.pending.x += x;
  this.offset.pending.y += y;
  this.offset.total.x += x;
  this.offset.total.y += y;
}

function addToCoords({
  page,
  client
}, {
  x,
  y
}) {
  page.x += x;
  page.y += y;
  client.x += x;
  client.y += y;
}

function hasPending(interaction) {
  return !!(interaction.offset.pending.x || interaction.offset.pending.y);
}

const offset = {
  id: 'offset',
  before: ['modifiers', 'pointer-events', 'actions', 'inertia'],

  install(scope) {
    scope.Interaction.prototype.offsetBy = offsetBy;
  },

  listeners: {
    'interactions:new': ({
      interaction
    }) => {
      interaction.offset = {
        total: {
          x: 0,
          y: 0
        },
        pending: {
          x: 0,
          y: 0
        }
      };
    },
    'interactions:update-pointer': ({
      interaction
    }) => addTotal(interaction),
    'interactions:before-action-start': beforeAction,
    'interactions:before-action-move': beforeAction,
    'interactions:before-action-end': beforeEnd,
    'interactions:stop': end
  }
};

function install$6(scope) {
  const {
    defaults
  } = scope;
  scope.usePlugin(offset);
  scope.usePlugin(modifiersBase);
  scope.actions.phases.inertiastart = true;
  scope.actions.phases.resume = true;
  defaults.perAction.inertia = {
    enabled: false,
    resistance: 10,
    // the lambda in exponential decay
    minSpeed: 100,
    // target speed must be above this for inertia to start
    endSpeed: 10,
    // the speed at which inertia is slow enough to stop
    allowResume: true,
    // allow resuming an action in inertia phase
    smoothEndDuration: 300 // animate to snap/restrict endOnly if there's no inertia

  };
}

class InertiaState {
  // eslint-disable-line camelcase
  // eslint-disable-line camelcase
  constructor(interaction) {
    this.active = false;
    this.isModified = false;
    this.smoothEnd = false;
    this.allowResume = false;
    this.modification = void 0;
    this.modifierCount = 0;
    this.modifierArg = void 0;
    this.startCoords = void 0;
    this.t0 = 0;
    this.v0 = 0;
    this.te = 0;
    this.targetOffset = void 0;
    this.modifiedOffset = void 0;
    this.currentOffset = void 0;
    this.lambda_v0 = 0;
    this.one_ve_v0 = 0;
    this.timeout = void 0;
    this.interaction = void 0;
    this.interaction = interaction;
  }

  start(event) {
    const {
      interaction
    } = this;
    const options = getOptions$1(interaction);

    if (!options || !options.enabled) {
      return false;
    }

    const {
      client: velocityClient
    } = interaction.coords.velocity;
    const pointerSpeed = hypot(velocityClient.x, velocityClient.y);
    const modification = this.modification || (this.modification = new Modification(interaction));
    modification.copyFrom(interaction.modification);
    this.t0 = interaction._now();
    this.allowResume = options.allowResume;
    this.v0 = pointerSpeed;
    this.currentOffset = {
      x: 0,
      y: 0
    };
    this.startCoords = interaction.coords.cur.page;
    this.modifierArg = modification.fillArg({
      pageCoords: this.startCoords,
      preEnd: true,
      phase: 'inertiastart'
    });
    const thrown = this.t0 - interaction.coords.cur.timeStamp < 50 && pointerSpeed > options.minSpeed && pointerSpeed > options.endSpeed;

    if (thrown) {
      this.startInertia();
    } else {
      modification.result = modification.setAll(this.modifierArg);

      if (!modification.result.changed) {
        return false;
      }

      this.startSmoothEnd();
    } // force modification change


    interaction.modification.result.rect = null; // bring inertiastart event to the target coords

    interaction.offsetBy(this.targetOffset);

    interaction._doPhase({
      interaction,
      event,
      phase: 'inertiastart'
    });

    interaction.offsetBy({
      x: -this.targetOffset.x,
      y: -this.targetOffset.y
    }); // force modification change

    interaction.modification.result.rect = null;
    this.active = true;
    interaction.simulation = this;
    return true;
  }

  startInertia() {
    const startVelocity = this.interaction.coords.velocity.client;
    const options = getOptions$1(this.interaction);
    const lambda = options.resistance;
    const inertiaDur = -Math.log(options.endSpeed / this.v0) / lambda;
    this.targetOffset = {
      x: (startVelocity.x - inertiaDur) / lambda,
      y: (startVelocity.y - inertiaDur) / lambda
    };
    this.te = inertiaDur;
    this.lambda_v0 = lambda / this.v0;
    this.one_ve_v0 = 1 - options.endSpeed / this.v0;
    const {
      modification,
      modifierArg
    } = this;
    modifierArg.pageCoords = {
      x: this.startCoords.x + this.targetOffset.x,
      y: this.startCoords.y + this.targetOffset.y
    };
    modification.result = modification.setAll(modifierArg);

    if (modification.result.changed) {
      this.isModified = true;
      this.modifiedOffset = {
        x: this.targetOffset.x + modification.result.delta.x,
        y: this.targetOffset.y + modification.result.delta.y
      };
    }

    this.onNextFrame(() => this.inertiaTick());
  }

  startSmoothEnd() {
    this.smoothEnd = true;
    this.isModified = true;
    this.targetOffset = {
      x: this.modification.result.delta.x,
      y: this.modification.result.delta.y
    };
    this.onNextFrame(() => this.smoothEndTick());
  }

  onNextFrame(tickFn) {
    this.timeout = raf.request(() => {
      if (this.active) {
        tickFn();
      }
    });
  }

  inertiaTick() {
    const {
      interaction
    } = this;
    const options = getOptions$1(interaction);
    const lambda = options.resistance;
    const t = (interaction._now() - this.t0) / 1000;

    if (t < this.te) {
      const progress = 1 - (Math.exp(-lambda * t) - this.lambda_v0) / this.one_ve_v0;
      let newOffset;

      if (this.isModified) {
        newOffset = getQuadraticCurvePoint(0, 0, this.targetOffset.x, this.targetOffset.y, this.modifiedOffset.x, this.modifiedOffset.y, progress);
      } else {
        newOffset = {
          x: this.targetOffset.x * progress,
          y: this.targetOffset.y * progress
        };
      }

      const delta = {
        x: newOffset.x - this.currentOffset.x,
        y: newOffset.y - this.currentOffset.y
      };
      this.currentOffset.x += delta.x;
      this.currentOffset.y += delta.y;
      interaction.offsetBy(delta);
      interaction.move();
      this.onNextFrame(() => this.inertiaTick());
    } else {
      interaction.offsetBy({
        x: this.modifiedOffset.x - this.currentOffset.x,
        y: this.modifiedOffset.y - this.currentOffset.y
      });
      this.end();
    }
  }

  smoothEndTick() {
    const {
      interaction
    } = this;
    const t = interaction._now() - this.t0;
    const {
      smoothEndDuration: duration
    } = getOptions$1(interaction);

    if (t < duration) {
      const newOffset = {
        x: easeOutQuad(t, 0, this.targetOffset.x, duration),
        y: easeOutQuad(t, 0, this.targetOffset.y, duration)
      };
      const delta = {
        x: newOffset.x - this.currentOffset.x,
        y: newOffset.y - this.currentOffset.y
      };
      this.currentOffset.x += delta.x;
      this.currentOffset.y += delta.y;
      interaction.offsetBy(delta);
      interaction.move({
        skipModifiers: this.modifierCount
      });
      this.onNextFrame(() => this.smoothEndTick());
    } else {
      interaction.offsetBy({
        x: this.targetOffset.x - this.currentOffset.x,
        y: this.targetOffset.y - this.currentOffset.y
      });
      this.end();
    }
  }

  resume({
    pointer,
    event,
    eventTarget
  }) {
    const {
      interaction
    } = this; // undo inertia changes to interaction coords

    interaction.offsetBy({
      x: -this.currentOffset.x,
      y: -this.currentOffset.y
    }); // update pointer at pointer down position

    interaction.updatePointer(pointer, event, eventTarget, true); // fire resume signals and event

    interaction._doPhase({
      interaction,
      event,
      phase: 'resume'
    });

    copyCoords(interaction.coords.prev, interaction.coords.cur);
    this.stop();
  }

  end() {
    this.interaction.move();
    this.interaction.end();
    this.stop();
  }

  stop() {
    this.active = this.smoothEnd = false;
    this.interaction.simulation = null;
    raf.cancel(this.timeout);
  }

}

function start$6({
  interaction,
  event
}) {
  if (!interaction._interacting || interaction.simulation) {
    return null;
  }

  const started = interaction.inertia.start(event); // prevent action end if inertia or smoothEnd

  return started ? false : null;
} // Check if the down event hits the current inertia target
// control should be return to the user


function resume(arg) {
  const {
    interaction,
    eventTarget
  } = arg;
  const state = interaction.inertia;
  if (!state.active) return;
  let element = eventTarget; // climb up the DOM tree from the event target

  while (is.element(element)) {
    // if interaction element is the current inertia target element
    if (element === interaction.element) {
      state.resume(arg);
      break;
    }

    element = parentNode(element);
  }
}

function stop({
  interaction
}) {
  const state = interaction.inertia;

  if (state.active) {
    state.stop();
  }
}

function getOptions$1({
  interactable,
  prepared
}) {
  return interactable && interactable.options && prepared.name && interactable.options[prepared.name].inertia;
}

const inertia = {
  id: 'inertia',
  before: ['modifiers', 'actions'],
  install: install$6,
  listeners: {
    'interactions:new': ({
      interaction
    }) => {
      interaction.inertia = new InertiaState(interaction);
    },
    'interactions:before-action-end': start$6,
    'interactions:down': resume,
    'interactions:stop': stop,
    'interactions:before-action-resume': arg => {
      const {
        modification
      } = arg.interaction;
      modification.stop(arg);
      modification.start(arg, arg.interaction.coords.cur.page);
      modification.applyToInteraction(arg);
    },
    'interactions:before-action-inertiastart': arg => arg.interaction.modification.setAndApply(arg),
    'interactions:action-resume': addEventModifiers,
    'interactions:action-inertiastart': addEventModifiers,
    'interactions:after-action-inertiastart': arg => arg.interaction.modification.restoreInteractionCoords(arg),
    'interactions:after-action-resume': arg => arg.interaction.modification.restoreInteractionCoords(arg)
  }
}; // http://stackoverflow.com/a/5634528/2280888

function _getQBezierValue(t, p1, p2, p3) {
  const iT = 1 - t;
  return iT * iT * p1 + 2 * iT * t * p2 + t * t * p3;
}

function getQuadraticCurvePoint(startX, startY, cpX, cpY, endX, endY, position) {
  return {
    x: _getQBezierValue(position, startX, cpX, endX),
    y: _getQBezierValue(position, startY, cpY, endY)
  };
} // http://gizma.com/easing/


function easeOutQuad(t, b, c, d) {
  t /= d;
  return -c * t * (t - 2) + b;
}

function fireUntilImmediateStopped(event, listeners) {
  for (const listener of listeners) {
    if (event.immediatePropagationStopped) {
      break;
    }

    listener(event);
  }
}

class Eventable {
  constructor(options) {
    this.options = void 0;
    this.types = {};
    this.propagationStopped = false;
    this.immediatePropagationStopped = false;
    this.global = void 0;
    this.options = extend$1({}, options || {});
  }

  fire(event) {
    let listeners;
    const global = this.global; // Interactable#on() listeners
    // tslint:disable no-conditional-assignment

    if (listeners = this.types[event.type]) {
      fireUntilImmediateStopped(event, listeners);
    } // interact.on() listeners


    if (!event.propagationStopped && global && (listeners = global[event.type])) {
      fireUntilImmediateStopped(event, listeners);
    }
  }

  on(type, listener) {
    const listeners = normalize(type, listener);

    for (type in listeners) {
      this.types[type] = merge(this.types[type] || [], listeners[type]);
    }
  }

  off(type, listener) {
    const listeners = normalize(type, listener);

    for (type in listeners) {
      const eventList = this.types[type];

      if (!eventList || !eventList.length) {
        continue;
      }

      for (const subListener of listeners[type]) {
        const index = eventList.indexOf(subListener);

        if (index !== -1) {
          eventList.splice(index, 1);
        }
      }
    }
  }

  getRect(_element) {
    return null;
  }

}

function isNonNativeEvent(type, actions) {
  if (actions.phaselessTypes[type]) {
    return true;
  }

  for (const name in actions.map) {
    if (type.indexOf(name) === 0 && type.substr(name.length) in actions.phases) {
      return true;
    }
  }

  return false;
}

/** @module interact */
function createInteractStatic(scope) {
  /**
   * ```js
   * interact('#draggable').draggable(true)
   *
   * var rectables = interact('rect')
   * rectables
   *   .gesturable(true)
   *   .on('gesturemove', function (event) {
   *       // ...
   *   })
   * ```
   *
   * The methods of this variable can be used to set elements as interactables
   * and also to change various default settings.
   *
   * Calling it as a function and passing an element or a valid CSS selector
   * string returns an Interactable object which has various methods to configure
   * it.
   *
   * @global
   *
   * @param {Element | string} target The HTML or SVG Element to interact with
   * or CSS selector
   * @return {Interactable}
   */
  const interact = (target, options) => {
    let interactable = scope.interactables.get(target, options);

    if (!interactable) {
      interactable = scope.interactables.new(target, options);
      interactable.events.global = interact.globalEvents;
    }

    return interactable;
  }; // expose the functions used to calculate multi-touch properties


  interact.getPointerAverage = pointerAverage;
  interact.getTouchBBox = touchBBox;
  interact.getTouchDistance = touchDistance;
  interact.getTouchAngle = touchAngle;
  interact.getElementRect = getElementRect;
  interact.getElementClientRect = getElementClientRect;
  interact.matchesSelector = matchesSelector;
  interact.closest = closest$1;
  interact.globalEvents = {}; // eslint-disable-next-line no-undef

  interact.version = "1.10.11";
  interact.scope = scope;
  /**
   * Use a plugin
   *
   * @alias module:interact.use
   *
   */

  interact.use = function (plugin, options) {
    this.scope.usePlugin(plugin, options);
    return this;
  };
  /**
   * Check if an element or selector has been set with the {@link interact}
   * function
   *
   * @alias module:interact.isSet
   *
   * @param {Target} target The Element or string being searched for
   * @param {object} options
   * @return {boolean} Indicates if the element or CSS selector was previously
   * passed to interact
   */


  interact.isSet = function (target, options) {
    return !!this.scope.interactables.get(target, options && options.context);
  };
  /**
   * @deprecated
   * Add a global listener for an InteractEvent or adds a DOM event to `document`
   *
   * @alias module:interact.on
   *
   * @param {string | array | object} type The types of events to listen for
   * @param {function} listener The function event (s)
   * @param {object | boolean} [options] object or useCapture flag for
   * addEventListener
   * @return {object} interact
   */


  interact.on = warnOnce(function on(type, listener, options) {
    if (is.string(type) && type.search(' ') !== -1) {
      type = type.trim().split(/ +/);
    }

    if (is.array(type)) {
      for (const eventType of type) {
        this.on(eventType, listener, options);
      }

      return this;
    }

    if (is.object(type)) {
      for (const prop in type) {
        this.on(prop, type[prop], listener);
      }

      return this;
    } // if it is an InteractEvent type, add listener to globalEvents


    if (isNonNativeEvent(type, this.scope.actions)) {
      // if this type of event was never bound
      if (!this.globalEvents[type]) {
        this.globalEvents[type] = [listener];
      } else {
        this.globalEvents[type].push(listener);
      }
    } // If non InteractEvent type, addEventListener to document
    else {
        this.scope.events.add(this.scope.document, type, listener, {
          options
        });
      }

    return this;
  }, 'The interact.on() method is being deprecated');
  /**
   * @deprecated
   * Removes a global InteractEvent listener or DOM event from `document`
   *
   * @alias module:interact.off
   *
   * @param {string | array | object} type The types of events that were listened
   * for
   * @param {function} listener The listener function to be removed
   * @param {object | boolean} options [options] object or useCapture flag for
   * removeEventListener
   * @return {object} interact
   */

  interact.off = warnOnce(function off(type, listener, options) {
    if (is.string(type) && type.search(' ') !== -1) {
      type = type.trim().split(/ +/);
    }

    if (is.array(type)) {
      for (const eventType of type) {
        this.off(eventType, listener, options);
      }

      return this;
    }

    if (is.object(type)) {
      for (const prop in type) {
        this.off(prop, type[prop], listener);
      }

      return this;
    }

    if (isNonNativeEvent(type, this.scope.actions)) {
      let index;

      if (type in this.globalEvents && (index = this.globalEvents[type].indexOf(listener)) !== -1) {
        this.globalEvents[type].splice(index, 1);
      }
    } else {
      this.scope.events.remove(this.scope.document, type, listener, options);
    }

    return this;
  }, 'The interact.off() method is being deprecated');

  interact.debug = function () {
    return this.scope;
  };
  /**
   * @alias module:interact.supportsTouch
   *
   * @return {boolean} Whether or not the browser supports touch input
   */


  interact.supportsTouch = function () {
    return browser$1.supportsTouch;
  };
  /**
   * @alias module:interact.supportsPointerEvent
   *
   * @return {boolean} Whether or not the browser supports PointerEvents
   */


  interact.supportsPointerEvent = function () {
    return browser$1.supportsPointerEvent;
  };
  /**
   * Cancels all interactions (end events are not fired)
   *
   * @alias module:interact.stop
   *
   * @return {object} interact
   */


  interact.stop = function () {
    for (const interaction of this.scope.interactions.list) {
      interaction.stop();
    }

    return this;
  };
  /**
   * Returns or sets the distance the pointer must be moved before an action
   * sequence occurs. This also affects tolerance for tap events.
   *
   * @alias module:interact.pointerMoveTolerance
   *
   * @param {number} [newValue] The movement from the start position must be greater than this value
   * @return {interact | number}
   */


  interact.pointerMoveTolerance = function (newValue) {
    if (is.number(newValue)) {
      this.scope.interactions.pointerMoveTolerance = newValue;
      return this;
    }

    return this.scope.interactions.pointerMoveTolerance;
  };

  interact.addDocument = function (doc, options) {
    this.scope.addDocument(doc, options);
  };

  interact.removeDocument = function (doc) {
    this.scope.removeDocument(doc);
  };

  return interact;
}

/* eslint-disable no-dupe-class-members */

/** */
class Interactable {
  /** @internal */
  get _defaults() {
    return {
      base: {},
      perAction: {},
      actions: {}
    };
  }

  /** */
  constructor(target, options, defaultContext, scopeEvents) {
    this.options = void 0;
    this._actions = void 0;
    this.target = void 0;
    this.events = new Eventable();
    this._context = void 0;
    this._win = void 0;
    this._doc = void 0;
    this._scopeEvents = void 0;
    this._rectChecker = void 0;
    this._actions = options.actions;
    this.target = target;
    this._context = options.context || defaultContext;
    this._win = getWindow(trySelector(target) ? this._context : target);
    this._doc = this._win.document;
    this._scopeEvents = scopeEvents;
    this.set(options);
  }

  setOnEvents(actionName, phases) {
    if (is.func(phases.onstart)) {
      this.on(`${actionName}start`, phases.onstart);
    }

    if (is.func(phases.onmove)) {
      this.on(`${actionName}move`, phases.onmove);
    }

    if (is.func(phases.onend)) {
      this.on(`${actionName}end`, phases.onend);
    }

    if (is.func(phases.oninertiastart)) {
      this.on(`${actionName}inertiastart`, phases.oninertiastart);
    }

    return this;
  }

  updatePerActionListeners(actionName, prev, cur) {
    if (is.array(prev) || is.object(prev)) {
      this.off(actionName, prev);
    }

    if (is.array(cur) || is.object(cur)) {
      this.on(actionName, cur);
    }
  }

  setPerAction(actionName, options) {
    const defaults = this._defaults; // for all the default per-action options

    for (const optionName_ in options) {
      const optionName = optionName_;
      const actionOptions = this.options[actionName];
      const optionValue = options[optionName]; // remove old event listeners and add new ones

      if (optionName === 'listeners') {
        this.updatePerActionListeners(actionName, actionOptions.listeners, optionValue);
      } // if the option value is an array


      if (is.array(optionValue)) {
        ;
        actionOptions[optionName] = from$1(optionValue);
      } // if the option value is an object
      else if (is.plainObject(optionValue)) {
          // copy the object
          ;
          actionOptions[optionName] = extend$1(actionOptions[optionName] || {}, clone$1(optionValue)); // set anabled field to true if it exists in the defaults

          if (is.object(defaults.perAction[optionName]) && 'enabled' in defaults.perAction[optionName]) {
            ;
            actionOptions[optionName].enabled = optionValue.enabled !== false;
          }
        } // if the option value is a boolean and the default is an object
        else if (is.bool(optionValue) && is.object(defaults.perAction[optionName])) {
            ;
            actionOptions[optionName].enabled = optionValue;
          } // if it's anything else, do a plain assignment
          else {
              ;
              actionOptions[optionName] = optionValue;
            }
    }
  }
  /**
   * The default function to get an Interactables bounding rect. Can be
   * overridden using {@link Interactable.rectChecker}.
   *
   * @param {Element} [element] The element to measure.
   * @return {Rect} The object's bounding rectangle.
   */


  getRect(element) {
    element = element || (is.element(this.target) ? this.target : null);

    if (is.string(this.target)) {
      element = element || this._context.querySelector(this.target);
    }

    return getElementRect(element);
  }
  /**
   * Returns or sets the function used to calculate the interactable's
   * element's rectangle
   *
   * @param {function} [checker] A function which returns this Interactable's
   * bounding rectangle. See {@link Interactable.getRect}
   * @return {function | object} The checker function or this Interactable
   */


  rectChecker(checker) {
    if (is.func(checker)) {
      this._rectChecker = checker;

      this.getRect = element => {
        const rect = extend$1({}, this._rectChecker(element));

        if (!('width' in rect)) {
          rect.width = rect.right - rect.left;
          rect.height = rect.bottom - rect.top;
        }

        return rect;
      };

      return this;
    }

    if (checker === null) {
      delete this.getRect;
      delete this._rectChecker;
      return this;
    }

    return this.getRect;
  }

  _backCompatOption(optionName, newValue) {
    if (trySelector(newValue) || is.object(newValue)) {
      ;
      this.options[optionName] = newValue;

      for (const action in this._actions.map) {
        ;
        this.options[action][optionName] = newValue;
      }

      return this;
    }

    return this.options[optionName];
  }
  /**
   * Gets or sets the origin of the Interactable's element.  The x and y
   * of the origin will be subtracted from action event coordinates.
   *
   * @param {Element | object | string} [origin] An HTML or SVG Element whose
   * rect will be used, an object eg. { x: 0, y: 0 } or string 'parent', 'self'
   * or any CSS selector
   *
   * @return {object} The current origin or this Interactable
   */


  origin(newValue) {
    return this._backCompatOption('origin', newValue);
  }
  /**
   * Returns or sets the mouse coordinate types used to calculate the
   * movement of the pointer.
   *
   * @param {string} [newValue] Use 'client' if you will be scrolling while
   * interacting; Use 'page' if you want autoScroll to work
   * @return {string | object} The current deltaSource or this Interactable
   */


  deltaSource(newValue) {
    if (newValue === 'page' || newValue === 'client') {
      this.options.deltaSource = newValue;
      return this;
    }

    return this.options.deltaSource;
  }
  /**
   * Gets the selector context Node of the Interactable. The default is
   * `window.document`.
   *
   * @return {Node} The context Node of this Interactable
   */


  context() {
    return this._context;
  }

  inContext(element) {
    return this._context === element.ownerDocument || nodeContains(this._context, element);
  }

  testIgnoreAllow(options, targetNode, eventTarget) {
    return !this.testIgnore(options.ignoreFrom, targetNode, eventTarget) && this.testAllow(options.allowFrom, targetNode, eventTarget);
  }

  testAllow(allowFrom, targetNode, element) {
    if (!allowFrom) {
      return true;
    }

    if (!is.element(element)) {
      return false;
    }

    if (is.string(allowFrom)) {
      return matchesUpTo(element, allowFrom, targetNode);
    } else if (is.element(allowFrom)) {
      return nodeContains(allowFrom, element);
    }

    return false;
  }

  testIgnore(ignoreFrom, targetNode, element) {
    if (!ignoreFrom || !is.element(element)) {
      return false;
    }

    if (is.string(ignoreFrom)) {
      return matchesUpTo(element, ignoreFrom, targetNode);
    } else if (is.element(ignoreFrom)) {
      return nodeContains(ignoreFrom, element);
    }

    return false;
  }
  /**
   * Calls listeners for the given InteractEvent type bound globally
   * and directly to this Interactable
   *
   * @param {InteractEvent} iEvent The InteractEvent object to be fired on this
   * Interactable
   * @return {Interactable} this Interactable
   */


  fire(iEvent) {
    this.events.fire(iEvent);
    return this;
  }

  _onOff(method, typeArg, listenerArg, options) {
    if (is.object(typeArg) && !is.array(typeArg)) {
      options = listenerArg;
      listenerArg = null;
    }

    const addRemove = method === 'on' ? 'add' : 'remove';
    const listeners = normalize(typeArg, listenerArg);

    for (let type in listeners) {
      if (type === 'wheel') {
        type = browser$1.wheelEvent;
      }

      for (const listener of listeners[type]) {
        // if it is an action event type
        if (isNonNativeEvent(type, this._actions)) {
          this.events[method](type, listener);
        } // delegated event
        else if (is.string(this.target)) {
            this._scopeEvents[`${addRemove}Delegate`](this.target, this._context, type, listener, options);
          } // remove listener from this Interactable's element
          else {
              this._scopeEvents[addRemove](this.target, type, listener, options);
            }
      }
    }

    return this;
  }
  /**
   * Binds a listener for an InteractEvent, pointerEvent or DOM event.
   *
   * @param {string | array | object} types The types of events to listen
   * for
   * @param {function | array | object} [listener] The event listener function(s)
   * @param {object | boolean} [options] options object or useCapture flag for
   * addEventListener
   * @return {Interactable} This Interactable
   */


  on(types, listener, options) {
    return this._onOff('on', types, listener, options);
  }
  /**
   * Removes an InteractEvent, pointerEvent or DOM event listener.
   *
   * @param {string | array | object} types The types of events that were
   * listened for
   * @param {function | array | object} [listener] The event listener function(s)
   * @param {object | boolean} [options] options object or useCapture flag for
   * removeEventListener
   * @return {Interactable} This Interactable
   */


  off(types, listener, options) {
    return this._onOff('off', types, listener, options);
  }
  /**
   * Reset the options of this Interactable
   *
   * @param {object} options The new settings to apply
   * @return {object} This Interactable
   */


  set(options) {
    const defaults = this._defaults;

    if (!is.object(options)) {
      options = {};
    }

    ;
    this.options = clone$1(defaults.base);

    for (const actionName_ in this._actions.methodDict) {
      const actionName = actionName_;
      const methodName = this._actions.methodDict[actionName];
      this.options[actionName] = {};
      this.setPerAction(actionName, extend$1(extend$1({}, defaults.perAction), defaults.actions[actionName]));
      this[methodName](options[actionName]);
    }

    for (const setting in options) {
      if (is.func(this[setting])) {
        ;
        this[setting](options[setting]);
      }
    }

    return this;
  }
  /**
   * Remove this interactable from the list of interactables and remove it's
   * action capabilities and event listeners
   */


  unset() {
    if (is.string(this.target)) {
      // remove delegated events
      for (const type in this._scopeEvents.delegatedEvents) {
        const delegated = this._scopeEvents.delegatedEvents[type];

        for (let i = delegated.length - 1; i >= 0; i--) {
          const {
            selector,
            context,
            listeners
          } = delegated[i];

          if (selector === this.target && context === this._context) {
            delegated.splice(i, 1);
          }

          for (let l = listeners.length - 1; l >= 0; l--) {
            this._scopeEvents.removeDelegate(this.target, this._context, type, listeners[l][0], listeners[l][1]);
          }
        }
      }
    } else {
      this._scopeEvents.remove(this.target, 'all');
    }
  }

}

class InteractableSet {
  // all set interactables
  constructor(scope) {
    this.list = [];
    this.selectorMap = {};
    this.scope = void 0;
    this.scope = scope;
    scope.addListeners({
      'interactable:unset': ({
        interactable
      }) => {
        const {
          target,
          _context: context
        } = interactable;
        const targetMappings = is.string(target) ? this.selectorMap[target] : target[this.scope.id];
        const targetIndex = findIndex(targetMappings, m => m.context === context);

        if (targetMappings[targetIndex]) {
          // Destroying mappingInfo's context and interactable
          targetMappings[targetIndex].context = null;
          targetMappings[targetIndex].interactable = null;
        }

        targetMappings.splice(targetIndex, 1);
      }
    });
  }

  new(target, options) {
    options = extend$1(options || {}, {
      actions: this.scope.actions
    });
    const interactable = new this.scope.Interactable(target, options, this.scope.document, this.scope.events);
    const mappingInfo = {
      context: interactable._context,
      interactable
    };
    this.scope.addDocument(interactable._doc);
    this.list.push(interactable);

    if (is.string(target)) {
      if (!this.selectorMap[target]) {
        this.selectorMap[target] = [];
      }

      this.selectorMap[target].push(mappingInfo);
    } else {
      if (!interactable.target[this.scope.id]) {
        Object.defineProperty(target, this.scope.id, {
          value: [],
          configurable: true
        });
      }

      ;
      target[this.scope.id].push(mappingInfo);
    }

    this.scope.fire('interactable:new', {
      target,
      options,
      interactable,
      win: this.scope._win
    });
    return interactable;
  }

  get(target, options) {
    const context = options && options.context || this.scope.document;
    const isSelector = is.string(target);
    const targetMappings = isSelector ? this.selectorMap[target] : target[this.scope.id];

    if (!targetMappings) {
      return null;
    }

    const found = find$2(targetMappings, m => m.context === context && (isSelector || m.interactable.inContext(target)));
    return found && found.interactable;
  }

  forEachMatch(node, callback) {
    for (const interactable of this.list) {
      let ret;

      if ((is.string(interactable.target) ? // target is a selector and the element matches
      is.element(node) && matchesSelector(node, interactable.target) : // target is the element
      node === interactable.target) && // the element is in context
      interactable.inContext(node)) {
        ret = callback(interactable);
      }

      if (ret !== undefined) {
        return ret;
      }
    }
  }

}

function install$5(scope) {
  var _scope$document;

  const targets = [];
  const delegatedEvents = {};
  const documents = [];
  const eventsMethods = {
    add,
    remove,
    addDelegate,
    removeDelegate,
    delegateListener,
    delegateUseCapture,
    delegatedEvents,
    documents,
    targets,
    supportsOptions: false,
    supportsPassive: false
  }; // check if browser supports passive events and options arg

  (_scope$document = scope.document) == null ? void 0 : _scope$document.createElement('div').addEventListener('test', null, {
    get capture() {
      return eventsMethods.supportsOptions = true;
    },

    get passive() {
      return eventsMethods.supportsPassive = true;
    }

  });
  scope.events = eventsMethods;

  function add(eventTarget, type, listener, optionalArg) {
    const options = getOptions(optionalArg);
    let target = find$2(targets, t => t.eventTarget === eventTarget);

    if (!target) {
      target = {
        eventTarget,
        events: {}
      };
      targets.push(target);
    }

    if (!target.events[type]) {
      target.events[type] = [];
    }

    if (eventTarget.addEventListener && !contains(target.events[type], listener)) {
      eventTarget.addEventListener(type, listener, eventsMethods.supportsOptions ? options : options.capture);
      target.events[type].push(listener);
    }
  }

  function remove(eventTarget, type, listener, optionalArg) {
    const options = getOptions(optionalArg);
    const targetIndex = findIndex(targets, t => t.eventTarget === eventTarget);
    const target = targets[targetIndex];

    if (!target || !target.events) {
      return;
    }

    if (type === 'all') {
      for (type in target.events) {
        if (target.events.hasOwnProperty(type)) {
          remove(eventTarget, type, 'all');
        }
      }

      return;
    }

    let typeIsEmpty = false;
    const typeListeners = target.events[type];

    if (typeListeners) {
      if (listener === 'all') {
        for (let i = typeListeners.length - 1; i >= 0; i--) {
          remove(eventTarget, type, typeListeners[i], options);
        }

        return;
      } else {
        for (let i = 0; i < typeListeners.length; i++) {
          if (typeListeners[i] === listener) {
            eventTarget.removeEventListener(type, listener, eventsMethods.supportsOptions ? options : options.capture);
            typeListeners.splice(i, 1);

            if (typeListeners.length === 0) {
              delete target.events[type];
              typeIsEmpty = true;
            }

            break;
          }
        }
      }
    }

    if (typeIsEmpty && !Object.keys(target.events).length) {
      targets.splice(targetIndex, 1);
    }
  }

  function addDelegate(selector, context, type, listener, optionalArg) {
    const options = getOptions(optionalArg);

    if (!delegatedEvents[type]) {
      delegatedEvents[type] = []; // add delegate listener functions

      for (const doc of documents) {
        add(doc, type, delegateListener);
        add(doc, type, delegateUseCapture, true);
      }
    }

    const delegates = delegatedEvents[type];
    let delegate = find$2(delegates, d => d.selector === selector && d.context === context);

    if (!delegate) {
      delegate = {
        selector,
        context,
        listeners: []
      };
      delegates.push(delegate);
    }

    delegate.listeners.push([listener, options]);
  }

  function removeDelegate(selector, context, type, listener, optionalArg) {
    const options = getOptions(optionalArg);
    const delegates = delegatedEvents[type];
    let matchFound = false;
    let index;
    if (!delegates) return; // count from last index of delegated to 0

    for (index = delegates.length - 1; index >= 0; index--) {
      const cur = delegates[index]; // look for matching selector and context Node

      if (cur.selector === selector && cur.context === context) {
        const {
          listeners
        } = cur; // each item of the listeners array is an array: [function, capture, passive]

        for (let i = listeners.length - 1; i >= 0; i--) {
          const [fn, {
            capture,
            passive
          }] = listeners[i]; // check if the listener functions and capture and passive flags match

          if (fn === listener && capture === options.capture && passive === options.passive) {
            // remove the listener from the array of listeners
            listeners.splice(i, 1); // if all listeners for this target have been removed
            // remove the target from the delegates array

            if (!listeners.length) {
              delegates.splice(index, 1); // remove delegate function from context

              remove(context, type, delegateListener);
              remove(context, type, delegateUseCapture, true);
            } // only remove one listener


            matchFound = true;
            break;
          }
        }

        if (matchFound) {
          break;
        }
      }
    }
  } // bound to the interactable context when a DOM event
  // listener is added to a selector interactable


  function delegateListener(event, optionalArg) {
    const options = getOptions(optionalArg);
    const fakeEvent = new FakeEvent(event);
    const delegates = delegatedEvents[event.type];
    const [eventTarget] = getEventTargets(event);
    let element = eventTarget; // climb up document tree looking for selector matches

    while (is.element(element)) {
      for (let i = 0; i < delegates.length; i++) {
        const cur = delegates[i];
        const {
          selector,
          context
        } = cur;

        if (matchesSelector(element, selector) && nodeContains(context, eventTarget) && nodeContains(context, element)) {
          const {
            listeners
          } = cur;
          fakeEvent.currentTarget = element;

          for (const [fn, {
            capture,
            passive
          }] of listeners) {
            if (capture === options.capture && passive === options.passive) {
              fn(fakeEvent);
            }
          }
        }
      }

      element = parentNode(element);
    }
  }

  function delegateUseCapture(event) {
    return delegateListener.call(this, event, true);
  } // for type inferrence


  return eventsMethods;
}

class FakeEvent {
  constructor(originalEvent) {
    this.currentTarget = void 0;
    this.originalEvent = void 0;
    this.type = void 0;
    this.originalEvent = originalEvent; // duplicate the event so that currentTarget can be changed

    pointerExtend(this, originalEvent);
  }

  preventOriginalDefault() {
    this.originalEvent.preventDefault();
  }

  stopPropagation() {
    this.originalEvent.stopPropagation();
  }

  stopImmediatePropagation() {
    this.originalEvent.stopImmediatePropagation();
  }

}

function getOptions(param) {
  if (!is.object(param)) {
    return {
      capture: !!param,
      passive: false
    };
  }

  const options = extend$1({}, param);
  options.capture = !!param.capture;
  options.passive = !!param.passive;
  return options;
}

var events = {
  id: 'events',
  install: install$5
};

const finder = {
  methodOrder: ['simulationResume', 'mouseOrPen', 'hasPointer', 'idle'],

  search(details) {
    for (const method of finder.methodOrder) {
      const interaction = finder[method](details);

      if (interaction) {
        return interaction;
      }
    }

    return null;
  },

  // try to resume simulation with a new pointer
  simulationResume({
    pointerType,
    eventType,
    eventTarget,
    scope
  }) {
    if (!/down|start/i.test(eventType)) {
      return null;
    }

    for (const interaction of scope.interactions.list) {
      let element = eventTarget;

      if (interaction.simulation && interaction.simulation.allowResume && interaction.pointerType === pointerType) {
        while (element) {
          // if the element is the interaction element
          if (element === interaction.element) {
            return interaction;
          }

          element = parentNode(element);
        }
      }
    }

    return null;
  },

  // if it's a mouse or pen interaction
  mouseOrPen({
    pointerId,
    pointerType,
    eventType,
    scope
  }) {
    if (pointerType !== 'mouse' && pointerType !== 'pen') {
      return null;
    }

    let firstNonActive;

    for (const interaction of scope.interactions.list) {
      if (interaction.pointerType === pointerType) {
        // if it's a down event, skip interactions with running simulations
        if (interaction.simulation && !hasPointerId(interaction, pointerId)) {
          continue;
        } // if the interaction is active, return it immediately


        if (interaction.interacting()) {
          return interaction;
        } // otherwise save it and look for another active interaction
        else if (!firstNonActive) {
            firstNonActive = interaction;
          }
      }
    } // if no active mouse interaction was found use the first inactive mouse
    // interaction


    if (firstNonActive) {
      return firstNonActive;
    } // find any mouse or pen interaction.
    // ignore the interaction if the eventType is a *down, and a simulation
    // is active


    for (const interaction of scope.interactions.list) {
      if (interaction.pointerType === pointerType && !(/down/i.test(eventType) && interaction.simulation)) {
        return interaction;
      }
    }

    return null;
  },

  // get interaction that has this pointer
  hasPointer({
    pointerId,
    scope
  }) {
    for (const interaction of scope.interactions.list) {
      if (hasPointerId(interaction, pointerId)) {
        return interaction;
      }
    }

    return null;
  },

  // get first idle interaction with a matching pointerType
  idle({
    pointerType,
    scope
  }) {
    for (const interaction of scope.interactions.list) {
      // if there's already a pointer held down
      if (interaction.pointers.length === 1) {
        const target = interaction.interactable; // don't add this pointer if there is a target interactable and it
        // isn't gesturable

        if (target && !(target.options.gesture && target.options.gesture.enabled)) {
          continue;
        }
      } // maximum of 2 pointers per interaction
      else if (interaction.pointers.length >= 2) {
          continue;
        }

      if (!interaction.interacting() && pointerType === interaction.pointerType) {
        return interaction;
      }
    }

    return null;
  }

};

function hasPointerId(interaction, pointerId) {
  return interaction.pointers.some(({
    id
  }) => id === pointerId);
}

const methodNames = ['pointerDown', 'pointerMove', 'pointerUp', 'updatePointer', 'removePointer', 'windowBlur'];

function install$4(scope) {
  const listeners = {};

  for (const method of methodNames) {
    listeners[method] = doOnInteractions(method, scope);
  }

  const pEventTypes = browser$1.pEventTypes;
  let docEvents;

  if (domObjects.PointerEvent) {
    docEvents = [{
      type: pEventTypes.down,
      listener: releasePointersOnRemovedEls
    }, {
      type: pEventTypes.down,
      listener: listeners.pointerDown
    }, {
      type: pEventTypes.move,
      listener: listeners.pointerMove
    }, {
      type: pEventTypes.up,
      listener: listeners.pointerUp
    }, {
      type: pEventTypes.cancel,
      listener: listeners.pointerUp
    }];
  } else {
    docEvents = [{
      type: 'mousedown',
      listener: listeners.pointerDown
    }, {
      type: 'mousemove',
      listener: listeners.pointerMove
    }, {
      type: 'mouseup',
      listener: listeners.pointerUp
    }, {
      type: 'touchstart',
      listener: releasePointersOnRemovedEls
    }, {
      type: 'touchstart',
      listener: listeners.pointerDown
    }, {
      type: 'touchmove',
      listener: listeners.pointerMove
    }, {
      type: 'touchend',
      listener: listeners.pointerUp
    }, {
      type: 'touchcancel',
      listener: listeners.pointerUp
    }];
  }

  docEvents.push({
    type: 'blur',

    listener(event) {
      for (const interaction of scope.interactions.list) {
        interaction.documentBlur(event);
      }
    }

  }); // for ignoring browser's simulated mouse events

  scope.prevTouchTime = 0;
  scope.Interaction = class extends Interaction {
    get pointerMoveTolerance() {
      return scope.interactions.pointerMoveTolerance;
    }

    set pointerMoveTolerance(value) {
      scope.interactions.pointerMoveTolerance = value;
    }

    _now() {
      return scope.now();
    }

  };
  scope.interactions = {
    // all active and idle interactions
    list: [],

    new(options) {
      options.scopeFire = (name, arg) => scope.fire(name, arg);

      const interaction = new scope.Interaction(options);
      scope.interactions.list.push(interaction);
      return interaction;
    },

    listeners,
    docEvents,
    pointerMoveTolerance: 1
  };

  function releasePointersOnRemovedEls() {
    // for all inactive touch interactions with pointers down
    for (const interaction of scope.interactions.list) {
      if (!interaction.pointerIsDown || interaction.pointerType !== 'touch' || interaction._interacting) {
        continue;
      } // if a pointer is down on an element that is no longer in the DOM tree


      for (const pointer of interaction.pointers) {
        if (!scope.documents.some(({
          doc
        }) => nodeContains(doc, pointer.downTarget))) {
          // remove the pointer from the interaction
          interaction.removePointer(pointer.pointer, pointer.event);
        }
      }
    }
  }

  scope.usePlugin(interactablePreventDefault);
}

function doOnInteractions(method, scope) {
  return function (event) {
    const interactions = scope.interactions.list;
    const pointerType = getPointerType(event);
    const [eventTarget, curEventTarget] = getEventTargets(event);
    const matches = []; // [ [pointer, interaction], ...]

    if (/^touch/.test(event.type)) {
      scope.prevTouchTime = scope.now(); // @ts-expect-error

      for (const changedTouch of event.changedTouches) {
        const pointer = changedTouch;
        const pointerId = getPointerId(pointer);
        const searchDetails = {
          pointer,
          pointerId,
          pointerType,
          eventType: event.type,
          eventTarget,
          curEventTarget,
          scope
        };
        const interaction = getInteraction(searchDetails);
        matches.push([searchDetails.pointer, searchDetails.eventTarget, searchDetails.curEventTarget, interaction]);
      }
    } else {
      let invalidPointer = false;

      if (!browser$1.supportsPointerEvent && /mouse/.test(event.type)) {
        // ignore mouse events while touch interactions are active
        for (let i = 0; i < interactions.length && !invalidPointer; i++) {
          invalidPointer = interactions[i].pointerType !== 'mouse' && interactions[i].pointerIsDown;
        } // try to ignore mouse events that are simulated by the browser
        // after a touch event


        invalidPointer = invalidPointer || scope.now() - scope.prevTouchTime < 500 || // on iOS and Firefox Mobile, MouseEvent.timeStamp is zero if simulated
        event.timeStamp === 0;
      }

      if (!invalidPointer) {
        const searchDetails = {
          pointer: event,
          pointerId: getPointerId(event),
          pointerType,
          eventType: event.type,
          curEventTarget,
          eventTarget,
          scope
        };
        const interaction = getInteraction(searchDetails);
        matches.push([searchDetails.pointer, searchDetails.eventTarget, searchDetails.curEventTarget, interaction]);
      }
    } // eslint-disable-next-line no-shadow


    for (const [pointer, eventTarget, curEventTarget, interaction] of matches) {
      interaction[method](pointer, event, eventTarget, curEventTarget);
    }
  };
}

function getInteraction(searchDetails) {
  const {
    pointerType,
    scope
  } = searchDetails;
  const foundInteraction = finder.search(searchDetails);
  const signalArg = {
    interaction: foundInteraction,
    searchDetails
  };
  scope.fire('interactions:find', signalArg);
  return signalArg.interaction || scope.interactions.new({
    pointerType
  });
}

function onDocSignal({
  doc,
  scope,
  options
}, eventMethodName) {
  const {
    interactions: {
      docEvents
    },
    events
  } = scope;
  const eventMethod = events[eventMethodName];

  if (scope.browser.isIOS && !options.events) {
    options.events = {
      passive: false
    };
  } // delegate event listener


  for (const eventType in events.delegatedEvents) {
    eventMethod(doc, eventType, events.delegateListener);
    eventMethod(doc, eventType, events.delegateUseCapture, true);
  }

  const eventOptions = options && options.events;

  for (const {
    type,
    listener
  } of docEvents) {
    eventMethod(doc, type, listener, eventOptions);
  }
}

const interactions = {
  id: 'core/interactions',
  install: install$4,
  listeners: {
    'scope:add-document': arg => onDocSignal(arg, 'add'),
    'scope:remove-document': arg => onDocSignal(arg, 'remove'),
    'interactable:unset': ({
      interactable
    }, scope) => {
      // Stop and destroy related interactions when an Interactable is unset
      for (let i = scope.interactions.list.length - 1; i >= 0; i--) {
        const interaction = scope.interactions.list[i];

        if (interaction.interactable !== interactable) {
          continue;
        }

        interaction.stop();
        scope.fire('interactions:destroy', {
          interaction
        });
        interaction.destroy();

        if (scope.interactions.list.length > 2) {
          scope.interactions.list.splice(i, 1);
        }
      }
    }
  },
  onDocSignal,
  doOnInteractions,
  methodNames
};

class Scope {
  // main window
  // main document
  // main window
  // all documents being listened to
  constructor() {
    this.id = `__interact_scope_${Math.floor(Math.random() * 100)}`;
    this.isInitialized = false;
    this.listenerMaps = [];
    this.browser = browser$1;
    this.defaults = clone$1(defaults$9);
    this.Eventable = Eventable;
    this.actions = {
      map: {},
      phases: {
        start: true,
        move: true,
        end: true
      },
      methodDict: {},
      phaselessTypes: {}
    };
    this.interactStatic = createInteractStatic(this);
    this.InteractEvent = InteractEvent;
    this.Interactable = void 0;
    this.interactables = new InteractableSet(this);
    this._win = void 0;
    this.document = void 0;
    this.window = void 0;
    this.documents = [];
    this._plugins = {
      list: [],
      map: {}
    };

    this.onWindowUnload = event => this.removeDocument(event.target);

    const scope = this;
    this.Interactable = class extends Interactable {
      get _defaults() {
        return scope.defaults;
      }

      set(options) {
        super.set(options);
        scope.fire('interactable:set', {
          options,
          interactable: this
        });
        return this;
      }

      unset() {
        super.unset();
        scope.interactables.list.splice(scope.interactables.list.indexOf(this), 1);
        scope.fire('interactable:unset', {
          interactable: this
        });
      }

    };
  }

  addListeners(map, id) {
    this.listenerMaps.push({
      id,
      map
    });
  }

  fire(name, arg) {
    for (const {
      map: {
        [name]: listener
      }
    } of this.listenerMaps) {
      if (!!listener && listener(arg, this, name) === false) {
        return false;
      }
    }
  }

  init(window) {
    return this.isInitialized ? this : initScope(this, window);
  }

  pluginIsInstalled(plugin) {
    return this._plugins.map[plugin.id] || this._plugins.list.indexOf(plugin) !== -1;
  }

  usePlugin(plugin, options) {
    if (!this.isInitialized) {
      return this;
    }

    if (this.pluginIsInstalled(plugin)) {
      return this;
    }

    if (plugin.id) {
      this._plugins.map[plugin.id] = plugin;
    }

    this._plugins.list.push(plugin);

    if (plugin.install) {
      plugin.install(this, options);
    }

    if (plugin.listeners && plugin.before) {
      let index = 0;
      const len = this.listenerMaps.length;
      const before = plugin.before.reduce((acc, id) => {
        acc[id] = true;
        acc[pluginIdRoot(id)] = true;
        return acc;
      }, {});

      for (; index < len; index++) {
        const otherId = this.listenerMaps[index].id;

        if (before[otherId] || before[pluginIdRoot(otherId)]) {
          break;
        }
      }

      this.listenerMaps.splice(index, 0, {
        id: plugin.id,
        map: plugin.listeners
      });
    } else if (plugin.listeners) {
      this.listenerMaps.push({
        id: plugin.id,
        map: plugin.listeners
      });
    }

    return this;
  }

  addDocument(doc, options) {
    // do nothing if document is already known
    if (this.getDocIndex(doc) !== -1) {
      return false;
    }

    const window = getWindow(doc);
    options = options ? extend$1({}, options) : {};
    this.documents.push({
      doc,
      options
    });
    this.events.documents.push(doc); // don't add an unload event for the main document
    // so that the page may be cached in browser history

    if (doc !== this.document) {
      this.events.add(window, 'unload', this.onWindowUnload);
    }

    this.fire('scope:add-document', {
      doc,
      window,
      scope: this,
      options
    });
  }

  removeDocument(doc) {
    const index = this.getDocIndex(doc);
    const window = getWindow(doc);
    const options = this.documents[index].options;
    this.events.remove(window, 'unload', this.onWindowUnload);
    this.documents.splice(index, 1);
    this.events.documents.splice(index, 1);
    this.fire('scope:remove-document', {
      doc,
      window,
      scope: this,
      options
    });
  }

  getDocIndex(doc) {
    for (let i = 0; i < this.documents.length; i++) {
      if (this.documents[i].doc === doc) {
        return i;
      }
    }

    return -1;
  }

  getDocOptions(doc) {
    const docIndex = this.getDocIndex(doc);
    return docIndex === -1 ? null : this.documents[docIndex].options;
  }

  now() {
    return (this.window.Date || Date).now();
  }

}
function initScope(scope, window) {
  scope.isInitialized = true;

  if (is.window(window)) {
    init$4(window);
  }

  domObjects.init(window);
  browser$1.init(window);
  raf.init(window); // @ts-expect-error

  scope.window = window;
  scope.document = window.document;
  scope.usePlugin(interactions);
  scope.usePlugin(events);
  return scope;
}

function pluginIdRoot(id) {
  return id && id.replace(/\/.*$/, '');
}

const scope = new Scope();
const interact = scope.interactStatic;

const _global = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : undefined;

scope.init(_global);

var edgeTarget = (() => {});

var elements = (() => {});

var grid = (grid => {
  const coordFields = [['x', 'y'], ['left', 'top'], ['right', 'bottom'], ['width', 'height']].filter(([xField, yField]) => xField in grid || yField in grid);

  const gridFunc = (x, y) => {
    const {
      range,
      limits = {
        left: -Infinity,
        right: Infinity,
        top: -Infinity,
        bottom: Infinity
      },
      offset = {
        x: 0,
        y: 0
      }
    } = grid;
    const result = {
      range,
      grid,
      x: null,
      y: null
    };

    for (const [xField, yField] of coordFields) {
      const gridx = Math.round((x - offset.x) / grid[xField]);
      const gridy = Math.round((y - offset.y) / grid[yField]);
      result[xField] = Math.max(limits.left, Math.min(limits.right, gridx * grid[xField] + offset.x));
      result[yField] = Math.max(limits.top, Math.min(limits.bottom, gridy * grid[yField] + offset.y));
    }

    return result;
  };

  gridFunc.grid = grid;
  gridFunc.coordFields = coordFields;
  return gridFunc;
});

/* eslint-disable import/no-named-as-default, import/no-unresolved */

var allSnappers = /*#__PURE__*/Object.freeze({
	__proto__: null,
	edgeTarget: edgeTarget,
	elements: elements,
	grid: grid
});

const snappersPlugin = {
  id: 'snappers',

  install(scope) {
    const {
      interactStatic: interact
    } = scope;
    interact.snappers = extend$1(interact.snappers || {}, allSnappers);
    interact.createSnapGrid = interact.snappers.grid;
  }

};

/**
 * @module modifiers/aspectRatio
 *
 * @description
 * This module forces elements to be resized with a specified dx/dy ratio.
 *
 * ```js
 * interact(target).resizable({
 *   modifiers: [
 *     interact.modifiers.snapSize({
 *       targets: [ interact.snappers.grid({ x: 20, y: 20 }) ],
 *     }),
 *     interact.aspectRatio({ ratio: 'preserve' }),
 *   ],
 * });
 * ```
 */
const aspectRatio = {
  start(arg) {
    const {
      state,
      rect,
      edges: originalEdges,
      pageCoords: coords
    } = arg;
    let {
      ratio
    } = state.options;
    const {
      equalDelta,
      modifiers
    } = state.options;

    if (ratio === 'preserve') {
      ratio = rect.width / rect.height;
    }

    state.startCoords = extend$1({}, coords);
    state.startRect = extend$1({}, rect);
    state.ratio = ratio;
    state.equalDelta = equalDelta;
    const linkedEdges = state.linkedEdges = {
      top: originalEdges.top || originalEdges.left && !originalEdges.bottom,
      left: originalEdges.left || originalEdges.top && !originalEdges.right,
      bottom: originalEdges.bottom || originalEdges.right && !originalEdges.top,
      right: originalEdges.right || originalEdges.bottom && !originalEdges.left
    };
    state.xIsPrimaryAxis = !!(originalEdges.left || originalEdges.right);

    if (state.equalDelta) {
      state.edgeSign = (linkedEdges.left ? 1 : -1) * (linkedEdges.top ? 1 : -1);
    } else {
      const negativeSecondaryEdge = state.xIsPrimaryAxis ? linkedEdges.top : linkedEdges.left;
      state.edgeSign = negativeSecondaryEdge ? -1 : 1;
    }

    extend$1(arg.edges, linkedEdges);
    if (!modifiers || !modifiers.length) return;
    const subModification = new Modification(arg.interaction);
    subModification.copyFrom(arg.interaction.modification);
    subModification.prepareStates(modifiers);
    state.subModification = subModification;
    subModification.startAll({ ...arg
    });
  },

  set(arg) {
    const {
      state,
      rect,
      coords
    } = arg;
    const initialCoords = extend$1({}, coords);
    const aspectMethod = state.equalDelta ? setEqualDelta : setRatio;
    aspectMethod(state, state.xIsPrimaryAxis, coords, rect);

    if (!state.subModification) {
      return null;
    }

    const correctedRect = extend$1({}, rect);
    addEdges(state.linkedEdges, correctedRect, {
      x: coords.x - initialCoords.x,
      y: coords.y - initialCoords.y
    });
    const result = state.subModification.setAll({ ...arg,
      rect: correctedRect,
      edges: state.linkedEdges,
      pageCoords: coords,
      prevCoords: coords,
      prevRect: correctedRect
    });
    const {
      delta
    } = result;

    if (result.changed) {
      const xIsCriticalAxis = Math.abs(delta.x) > Math.abs(delta.y); // do aspect modification again with critical edge axis as primary

      aspectMethod(state, xIsCriticalAxis, result.coords, result.rect);
      extend$1(coords, result.coords);
    }

    return result.eventProps;
  },

  defaults: {
    ratio: 'preserve',
    equalDelta: false,
    modifiers: [],
    enabled: false
  }
};

function setEqualDelta({
  startCoords,
  edgeSign
}, xIsPrimaryAxis, coords) {
  if (xIsPrimaryAxis) {
    coords.y = startCoords.y + (coords.x - startCoords.x) * edgeSign;
  } else {
    coords.x = startCoords.x + (coords.y - startCoords.y) * edgeSign;
  }
}

function setRatio({
  startRect,
  startCoords,
  ratio,
  edgeSign
}, xIsPrimaryAxis, coords, rect) {
  if (xIsPrimaryAxis) {
    const newHeight = rect.width / ratio;
    coords.y = startCoords.y + (newHeight - startRect.height) * edgeSign;
  } else {
    const newWidth = rect.height * ratio;
    coords.x = startCoords.x + (newWidth - startRect.width) * edgeSign;
  }
}

var aspectRatio$1 = makeModifier(aspectRatio, 'aspectRatio');

const noop$1 = () => {};

noop$1._defaults = {};

function start$5({
  rect,
  startOffset,
  state,
  interaction,
  pageCoords
}) {
  const {
    options
  } = state;
  const {
    elementRect
  } = options;
  const offset = extend$1({
    left: 0,
    top: 0,
    right: 0,
    bottom: 0
  }, options.offset || {});

  if (rect && elementRect) {
    const restriction = getRestrictionRect(options.restriction, interaction, pageCoords);

    if (restriction) {
      const widthDiff = restriction.right - restriction.left - rect.width;
      const heightDiff = restriction.bottom - restriction.top - rect.height;

      if (widthDiff < 0) {
        offset.left += widthDiff;
        offset.right += widthDiff;
      }

      if (heightDiff < 0) {
        offset.top += heightDiff;
        offset.bottom += heightDiff;
      }
    }

    offset.left += startOffset.left - rect.width * elementRect.left;
    offset.top += startOffset.top - rect.height * elementRect.top;
    offset.right += startOffset.right - rect.width * (1 - elementRect.right);
    offset.bottom += startOffset.bottom - rect.height * (1 - elementRect.bottom);
  }

  state.offset = offset;
}

function set$4({
  coords,
  interaction,
  state
}) {
  const {
    options,
    offset
  } = state;
  const restriction = getRestrictionRect(options.restriction, interaction, coords);
  if (!restriction) return;
  const rect = xywhToTlbr(restriction);
  coords.x = Math.max(Math.min(rect.right - offset.right, coords.x), rect.left + offset.left);
  coords.y = Math.max(Math.min(rect.bottom - offset.bottom, coords.y), rect.top + offset.top);
}

function getRestrictionRect(value, interaction, coords) {
  if (is.func(value)) {
    return resolveRectLike(value, interaction.interactable, interaction.element, [coords.x, coords.y, interaction]);
  } else {
    return resolveRectLike(value, interaction.interactable, interaction.element);
  }
}
const defaults$8 = {
  restriction: null,
  elementRect: null,
  offset: null,
  endOnly: false,
  enabled: false
};
const restrict = {
  start: start$5,
  set: set$4,
  defaults: defaults$8
};
var restrict$1 = makeModifier(restrict, 'restrict');

// This module adds the options.resize.restrictEdges setting which sets min and
const noInner = {
  top: +Infinity,
  left: +Infinity,
  bottom: -Infinity,
  right: -Infinity
};
const noOuter = {
  top: -Infinity,
  left: -Infinity,
  bottom: +Infinity,
  right: +Infinity
};

function start$4({
  interaction,
  startOffset,
  state
}) {
  const {
    options
  } = state;
  let offset;

  if (options) {
    const offsetRect = getRestrictionRect(options.offset, interaction, interaction.coords.start.page);
    offset = rectToXY(offsetRect);
  }

  offset = offset || {
    x: 0,
    y: 0
  };
  state.offset = {
    top: offset.y + startOffset.top,
    left: offset.x + startOffset.left,
    bottom: offset.y - startOffset.bottom,
    right: offset.x - startOffset.right
  };
}

function set$3({
  coords,
  edges,
  interaction,
  state
}) {
  const {
    offset,
    options
  } = state;

  if (!edges) {
    return;
  }

  const page = extend$1({}, coords);
  const inner = getRestrictionRect(options.inner, interaction, page) || {};
  const outer = getRestrictionRect(options.outer, interaction, page) || {};
  fixRect(inner, noInner);
  fixRect(outer, noOuter);

  if (edges.top) {
    coords.y = Math.min(Math.max(outer.top + offset.top, page.y), inner.top + offset.top);
  } else if (edges.bottom) {
    coords.y = Math.max(Math.min(outer.bottom + offset.bottom, page.y), inner.bottom + offset.bottom);
  }

  if (edges.left) {
    coords.x = Math.min(Math.max(outer.left + offset.left, page.x), inner.left + offset.left);
  } else if (edges.right) {
    coords.x = Math.max(Math.min(outer.right + offset.right, page.x), inner.right + offset.right);
  }
}

function fixRect(rect, defaults) {
  for (const edge of ['top', 'left', 'bottom', 'right']) {
    if (!(edge in rect)) {
      rect[edge] = defaults[edge];
    }
  }

  return rect;
}

const defaults$7 = {
  inner: null,
  outer: null,
  offset: null,
  endOnly: false,
  enabled: false
};
const restrictEdges = {
  noInner,
  noOuter,
  start: start$4,
  set: set$3,
  defaults: defaults$7
};
var restrictEdges$1 = makeModifier(restrictEdges, 'restrictEdges');

const defaults$6 = extend$1({
  get elementRect() {
    return {
      top: 0,
      left: 0,
      bottom: 1,
      right: 1
    };
  },

  set elementRect(_) {}

}, restrict.defaults);
const restrictRect = {
  start: restrict.start,
  set: restrict.set,
  defaults: defaults$6
};
var restrictRect$1 = makeModifier(restrictRect, 'restrictRect');

const noMin = {
  width: -Infinity,
  height: -Infinity
};
const noMax = {
  width: +Infinity,
  height: +Infinity
};

function start$3(arg) {
  return restrictEdges.start(arg);
}

function set$2(arg) {
  const {
    interaction,
    state,
    rect,
    edges
  } = arg;
  const {
    options
  } = state;

  if (!edges) {
    return;
  }

  const minSize = tlbrToXywh(getRestrictionRect(options.min, interaction, arg.coords)) || noMin;
  const maxSize = tlbrToXywh(getRestrictionRect(options.max, interaction, arg.coords)) || noMax;
  state.options = {
    endOnly: options.endOnly,
    inner: extend$1({}, restrictEdges.noInner),
    outer: extend$1({}, restrictEdges.noOuter)
  };

  if (edges.top) {
    state.options.inner.top = rect.bottom - minSize.height;
    state.options.outer.top = rect.bottom - maxSize.height;
  } else if (edges.bottom) {
    state.options.inner.bottom = rect.top + minSize.height;
    state.options.outer.bottom = rect.top + maxSize.height;
  }

  if (edges.left) {
    state.options.inner.left = rect.right - minSize.width;
    state.options.outer.left = rect.right - maxSize.width;
  } else if (edges.right) {
    state.options.inner.right = rect.left + minSize.width;
    state.options.outer.right = rect.left + maxSize.width;
  }

  restrictEdges.set(arg);
  state.options = options;
}

const defaults$5 = {
  min: null,
  max: null,
  endOnly: false,
  enabled: false
};
const restrictSize = {
  start: start$3,
  set: set$2,
  defaults: defaults$5
};
var restrictSize$1 = makeModifier(restrictSize, 'restrictSize');

function start$2(arg) {
  const {
    interaction,
    interactable,
    element,
    rect,
    state,
    startOffset
  } = arg;
  const {
    options
  } = state;
  const origin = options.offsetWithOrigin ? getOrigin(arg) : {
    x: 0,
    y: 0
  };
  let snapOffset;

  if (options.offset === 'startCoords') {
    snapOffset = {
      x: interaction.coords.start.page.x,
      y: interaction.coords.start.page.y
    };
  } else {
    const offsetRect = resolveRectLike(options.offset, interactable, element, [interaction]);
    snapOffset = rectToXY(offsetRect) || {
      x: 0,
      y: 0
    };
    snapOffset.x += origin.x;
    snapOffset.y += origin.y;
  }

  const {
    relativePoints
  } = options;
  state.offsets = rect && relativePoints && relativePoints.length ? relativePoints.map((relativePoint, index) => ({
    index,
    relativePoint,
    x: startOffset.left - rect.width * relativePoint.x + snapOffset.x,
    y: startOffset.top - rect.height * relativePoint.y + snapOffset.y
  })) : [{
    index: 0,
    relativePoint: null,
    x: snapOffset.x,
    y: snapOffset.y
  }];
}

function set$1(arg) {
  const {
    interaction,
    coords,
    state
  } = arg;
  const {
    options,
    offsets
  } = state;
  const origin = getOriginXY(interaction.interactable, interaction.element, interaction.prepared.name);
  const page = extend$1({}, coords);
  const targets = [];

  if (!options.offsetWithOrigin) {
    page.x -= origin.x;
    page.y -= origin.y;
  }

  for (const offset of offsets) {
    const relativeX = page.x - offset.x;
    const relativeY = page.y - offset.y;

    for (let index = 0, len = options.targets.length; index < len; index++) {
      const snapTarget = options.targets[index];
      let target;

      if (is.func(snapTarget)) {
        target = snapTarget(relativeX, relativeY, interaction._proxy, offset, index);
      } else {
        target = snapTarget;
      }

      if (!target) {
        continue;
      }

      targets.push({
        x: (is.number(target.x) ? target.x : relativeX) + offset.x,
        y: (is.number(target.y) ? target.y : relativeY) + offset.y,
        range: is.number(target.range) ? target.range : options.range,
        source: snapTarget,
        index,
        offset
      });
    }
  }

  const closest = {
    target: null,
    inRange: false,
    distance: 0,
    range: 0,
    delta: {
      x: 0,
      y: 0
    }
  };

  for (const target of targets) {
    const range = target.range;
    const dx = target.x - page.x;
    const dy = target.y - page.y;
    const distance = hypot(dx, dy);
    let inRange = distance <= range; // Infinite targets count as being out of range
    // compared to non infinite ones that are in range

    if (range === Infinity && closest.inRange && closest.range !== Infinity) {
      inRange = false;
    }

    if (!closest.target || (inRange ? // is the closest target in range?
    closest.inRange && range !== Infinity ? // the pointer is relatively deeper in this target
    distance / range < closest.distance / closest.range : // this target has Infinite range and the closest doesn't
    range === Infinity && closest.range !== Infinity || // OR this target is closer that the previous closest
    distance < closest.distance : // The other is not in range and the pointer is closer to this target
    !closest.inRange && distance < closest.distance)) {
      closest.target = target;
      closest.distance = distance;
      closest.range = range;
      closest.inRange = inRange;
      closest.delta.x = dx;
      closest.delta.y = dy;
    }
  }

  if (closest.inRange) {
    coords.x = closest.target.x;
    coords.y = closest.target.y;
  }

  state.closest = closest;
  return closest;
}

function getOrigin(arg) {
  const {
    element
  } = arg.interaction;
  const optionsOrigin = rectToXY(resolveRectLike(arg.state.options.origin, null, null, [element]));
  const origin = optionsOrigin || getOriginXY(arg.interactable, element, arg.interaction.prepared.name);
  return origin;
}

const defaults$4 = {
  range: Infinity,
  targets: null,
  offset: null,
  offsetWithOrigin: true,
  origin: null,
  relativePoints: null,
  endOnly: false,
  enabled: false
};
const snap = {
  start: start$2,
  set: set$1,
  defaults: defaults$4
};
var snap$1 = makeModifier(snap, 'snap');

// This module allows snapping of the size of targets during resize

function start$1(arg) {
  const {
    state,
    edges
  } = arg;
  const {
    options
  } = state;

  if (!edges) {
    return null;
  }

  arg.state = {
    options: {
      targets: null,
      relativePoints: [{
        x: edges.left ? 0 : 1,
        y: edges.top ? 0 : 1
      }],
      offset: options.offset || 'self',
      origin: {
        x: 0,
        y: 0
      },
      range: options.range
    }
  };
  state.targetFields = state.targetFields || [['width', 'height'], ['x', 'y']];
  snap.start(arg);
  state.offsets = arg.state.offsets;
  arg.state = state;
}

function set(arg) {
  const {
    interaction,
    state,
    coords
  } = arg;
  const {
    options,
    offsets
  } = state;
  const relative = {
    x: coords.x - offsets[0].x,
    y: coords.y - offsets[0].y
  };
  state.options = extend$1({}, options);
  state.options.targets = [];

  for (const snapTarget of options.targets || []) {
    let target;

    if (is.func(snapTarget)) {
      target = snapTarget(relative.x, relative.y, interaction);
    } else {
      target = snapTarget;
    }

    if (!target) {
      continue;
    }

    for (const [xField, yField] of state.targetFields) {
      if (xField in target || yField in target) {
        target.x = target[xField];
        target.y = target[yField];
        break;
      }
    }

    state.options.targets.push(target);
  }

  const returnValue = snap.set(arg);
  state.options = options;
  return returnValue;
}

const defaults$3 = {
  range: Infinity,
  targets: null,
  offset: null,
  endOnly: false,
  enabled: false
};
const snapSize = {
  start: start$1,
  set,
  defaults: defaults$3
};
var snapSize$1 = makeModifier(snapSize, 'snapSize');

/**
 * @module modifiers/snapEdges
 *
 * @description
 * WOW> This module allows snapping of the edges of targets during resize
 * interactions.
 *
 * ```js
 * interact(target).resizable({
 *   snapEdges: {
 *     targets: [interact.snappers.grid({ x: 100, y: 50 })],
 *   },
 * })
 *
 * interact(target).resizable({
 *   snapEdges: {
 *     targets: [
 *       interact.snappers.grid({
 *        top: 50,
 *        left: 50,
 *        bottom: 100,
 *        right: 100,
 *       }),
 *     ],
 *   },
 * })
 * ```
 */

function start(arg) {
  const {
    edges
  } = arg;

  if (!edges) {
    return null;
  }

  arg.state.targetFields = arg.state.targetFields || [[edges.left ? 'left' : 'right', edges.top ? 'top' : 'bottom']];
  return snapSize.start(arg);
}

const snapEdges = {
  start,
  set: snapSize.set,
  defaults: extend$1(clone$1(snapSize.defaults), {
    targets: null,
    range: null,
    offset: {
      x: 0,
      y: 0
    }
  })
};
var snapEdges$1 = makeModifier(snapEdges, 'snapEdges');

/* eslint-disable node/no-extraneous-import, import/no-unresolved */
var all = {
  aspectRatio: aspectRatio$1,
  restrictEdges: restrictEdges$1,
  restrict: restrict$1,
  restrictRect: restrictRect$1,
  restrictSize: restrictSize$1,
  snapEdges: snapEdges$1,
  snap: snap$1,
  snapSize: snapSize$1,
  spring: noop$1,
  avoid: noop$1,
  transform: noop$1,
  rubberband: noop$1
};

const modifiers = {
  id: 'modifiers',

  install(scope) {
    const {
      interactStatic: interact
    } = scope;
    scope.usePlugin(modifiersBase);
    scope.usePlugin(snappersPlugin);
    interact.modifiers = all; // for backwrads compatibility

    for (const type in all) {
      const {
        _defaults,
        _methods
      } = all[type];
      _defaults._methods = _methods;
      scope.defaults.perAction[type] = _defaults;
    }
  }

};

class PointerEvent$1 extends BaseEvent {
  /** */
  constructor(type, pointer, event, eventTarget, interaction, timeStamp) {
    super(interaction);
    this.type = void 0;
    this.originalEvent = void 0;
    this.pointerId = void 0;
    this.pointerType = void 0;
    this.double = void 0;
    this.pageX = void 0;
    this.pageY = void 0;
    this.clientX = void 0;
    this.clientY = void 0;
    this.dt = void 0;
    this.eventable = void 0;
    pointerExtend(this, event);

    if (event !== pointer) {
      pointerExtend(this, pointer);
    }

    this.timeStamp = timeStamp;
    this.originalEvent = event;
    this.type = type;
    this.pointerId = getPointerId(pointer);
    this.pointerType = getPointerType(pointer);
    this.target = eventTarget;
    this.currentTarget = null;

    if (type === 'tap') {
      const pointerIndex = interaction.getPointerIndex(pointer);
      this.dt = this.timeStamp - interaction.pointers[pointerIndex].downTime;
      const interval = this.timeStamp - interaction.tapTime;
      this.double = !!(interaction.prevTap && interaction.prevTap.type !== 'doubletap' && interaction.prevTap.target === this.target && interval < 500);
    } else if (type === 'doubletap') {
      this.dt = pointer.timeStamp - interaction.tapTime;
    }
  }

  _subtractOrigin({
    x: originX,
    y: originY
  }) {
    this.pageX -= originX;
    this.pageY -= originY;
    this.clientX -= originX;
    this.clientY -= originY;
    return this;
  }

  _addOrigin({
    x: originX,
    y: originY
  }) {
    this.pageX += originX;
    this.pageY += originY;
    this.clientX += originX;
    this.clientY += originY;
    return this;
  }
  /**
   * Prevent the default behaviour of the original Event
   */


  preventDefault() {
    this.originalEvent.preventDefault();
  }

}

const defaults$2 = {
  holdDuration: 600,
  ignoreFrom: null,
  allowFrom: null,
  origin: {
    x: 0,
    y: 0
  }
};
const pointerEvents = {
  id: 'pointer-events/base',
  before: ['inertia', 'modifiers', 'auto-start', 'actions'],
  install: install$3,
  listeners: {
    'interactions:new': addInteractionProps,
    'interactions:update-pointer': addHoldInfo,
    'interactions:move': moveAndClearHold,
    'interactions:down': (arg, scope) => {
      downAndStartHold(arg, scope);
      fire(arg, scope);
    },
    'interactions:up': (arg, scope) => {
      clearHold(arg);
      fire(arg, scope);
      tapAfterUp(arg, scope);
    },
    'interactions:cancel': (arg, scope) => {
      clearHold(arg);
      fire(arg, scope);
    }
  },
  PointerEvent: PointerEvent$1,
  fire,
  collectEventTargets,
  defaults: defaults$2,
  types: {
    down: true,
    move: true,
    up: true,
    cancel: true,
    tap: true,
    doubletap: true,
    hold: true
  }
};

function fire(arg, scope) {
  const {
    interaction,
    pointer,
    event,
    eventTarget,
    type,
    targets = collectEventTargets(arg, scope)
  } = arg;
  const pointerEvent = new PointerEvent$1(type, pointer, event, eventTarget, interaction, scope.now());
  scope.fire('pointerEvents:new', {
    pointerEvent
  });
  const signalArg = {
    interaction,
    pointer,
    event,
    eventTarget,
    targets,
    type,
    pointerEvent
  };

  for (let i = 0; i < targets.length; i++) {
    const target = targets[i];

    for (const prop in target.props || {}) {
      ;
      pointerEvent[prop] = target.props[prop];
    }

    const origin = getOriginXY(target.eventable, target.node);

    pointerEvent._subtractOrigin(origin);

    pointerEvent.eventable = target.eventable;
    pointerEvent.currentTarget = target.node;
    target.eventable.fire(pointerEvent);

    pointerEvent._addOrigin(origin);

    if (pointerEvent.immediatePropagationStopped || pointerEvent.propagationStopped && i + 1 < targets.length && targets[i + 1].node !== pointerEvent.currentTarget) {
      break;
    }
  }

  scope.fire('pointerEvents:fired', signalArg);

  if (type === 'tap') {
    // if pointerEvent should make a double tap, create and fire a doubletap
    // PointerEvent and use that as the prevTap
    const prevTap = pointerEvent.double ? fire({
      interaction,
      pointer,
      event,
      eventTarget,
      type: 'doubletap'
    }, scope) : pointerEvent;
    interaction.prevTap = prevTap;
    interaction.tapTime = prevTap.timeStamp;
  }

  return pointerEvent;
}

function collectEventTargets({
  interaction,
  pointer,
  event,
  eventTarget,
  type
}, scope) {
  const pointerIndex = interaction.getPointerIndex(pointer);
  const pointerInfo = interaction.pointers[pointerIndex]; // do not fire a tap event if the pointer was moved before being lifted

  if (type === 'tap' && (interaction.pointerWasMoved || // or if the pointerup target is different to the pointerdown target
  !(pointerInfo && pointerInfo.downTarget === eventTarget))) {
    return [];
  }

  const path = getPath(eventTarget);
  const signalArg = {
    interaction,
    pointer,
    event,
    eventTarget,
    type,
    path,
    targets: [],
    node: null
  };

  for (const node of path) {
    signalArg.node = node;
    scope.fire('pointerEvents:collect-targets', signalArg);
  }

  if (type === 'hold') {
    signalArg.targets = signalArg.targets.filter(target => {
      var _interaction$pointers;

      return target.eventable.options.holdDuration === ((_interaction$pointers = interaction.pointers[pointerIndex]) == null ? void 0 : _interaction$pointers.hold.duration);
    });
  }

  return signalArg.targets;
}

function addInteractionProps({
  interaction
}) {
  interaction.prevTap = null; // the most recent tap event on this interaction

  interaction.tapTime = 0; // time of the most recent tap event
}

function addHoldInfo({
  down,
  pointerInfo
}) {
  if (!down && pointerInfo.hold) {
    return;
  }

  pointerInfo.hold = {
    duration: Infinity,
    timeout: null
  };
}

function clearHold({
  interaction,
  pointerIndex
}) {
  const hold = interaction.pointers[pointerIndex].hold;

  if (hold && hold.timeout) {
    clearTimeout(hold.timeout);
    hold.timeout = null;
  }
}

function moveAndClearHold(arg, scope) {
  const {
    interaction,
    pointer,
    event,
    eventTarget,
    duplicate
  } = arg;

  if (!duplicate && (!interaction.pointerIsDown || interaction.pointerWasMoved)) {
    if (interaction.pointerIsDown) {
      clearHold(arg);
    }

    fire({
      interaction,
      pointer,
      event,
      eventTarget: eventTarget,
      type: 'move'
    }, scope);
  }
}

function downAndStartHold({
  interaction,
  pointer,
  event,
  eventTarget,
  pointerIndex
}, scope) {
  const timer = interaction.pointers[pointerIndex].hold;
  const path = getPath(eventTarget);
  const signalArg = {
    interaction,
    pointer,
    event,
    eventTarget,
    type: 'hold',
    targets: [],
    path,
    node: null
  };

  for (const node of path) {
    signalArg.node = node;
    scope.fire('pointerEvents:collect-targets', signalArg);
  }

  if (!signalArg.targets.length) return;
  let minDuration = Infinity;

  for (const target of signalArg.targets) {
    const holdDuration = target.eventable.options.holdDuration;

    if (holdDuration < minDuration) {
      minDuration = holdDuration;
    }
  }

  timer.duration = minDuration;
  timer.timeout = setTimeout(() => {
    fire({
      interaction,
      eventTarget,
      pointer,
      event,
      type: 'hold'
    }, scope);
  }, minDuration);
}

function tapAfterUp({
  interaction,
  pointer,
  event,
  eventTarget
}, scope) {
  if (!interaction.pointerWasMoved) {
    fire({
      interaction,
      eventTarget,
      pointer,
      event,
      type: 'tap'
    }, scope);
  }
}

function install$3(scope) {
  scope.pointerEvents = pointerEvents;
  scope.defaults.actions.pointerEvents = pointerEvents.defaults;
  extend$1(scope.actions.phaselessTypes, pointerEvents.types);
}

var pointerEvents$1 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	'default': pointerEvents
});

function install$2(scope) {
  scope.usePlugin(pointerEvents);
  const {
    pointerEvents: pointerEvents$1
  } = scope; // don't repeat by default

  pointerEvents$1.defaults.holdRepeatInterval = 0;
  pointerEvents$1.types.holdrepeat = scope.actions.phaselessTypes.holdrepeat = true;
}

function onNew({
  pointerEvent
}) {
  if (pointerEvent.type !== 'hold') return;
  pointerEvent.count = (pointerEvent.count || 0) + 1;
}

function onFired({
  interaction,
  pointerEvent,
  eventTarget,
  targets
}, scope) {
  if (pointerEvent.type !== 'hold' || !targets.length) return; // get the repeat interval from the first eventable

  const interval = targets[0].eventable.options.holdRepeatInterval; // don't repeat if the interval is 0 or less

  if (interval <= 0) return; // set a timeout to fire the holdrepeat event

  interaction.holdIntervalHandle = setTimeout(() => {
    scope.pointerEvents.fire({
      interaction,
      eventTarget,
      type: 'hold',
      pointer: pointerEvent,
      event: pointerEvent
    }, scope);
  }, interval);
}

function endHoldRepeat({
  interaction
}) {
  // set the interaction's holdStopTime property
  // to stop further holdRepeat events
  if (interaction.holdIntervalHandle) {
    clearInterval(interaction.holdIntervalHandle);
    interaction.holdIntervalHandle = null;
  }
}

const holdRepeat = {
  id: 'pointer-events/holdRepeat',
  install: install$2,
  listeners: ['move', 'up', 'cancel', 'endall'].reduce((acc, enderTypes) => {
    ;
    acc[`pointerEvents:${enderTypes}`] = endHoldRepeat;
    return acc;
  }, {
    'pointerEvents:new': onNew,
    'pointerEvents:fired': onFired
  })
};

function install$1(scope) {
  const {
    Interactable
  } = scope;
  Interactable.prototype.pointerEvents = pointerEventsMethod;
  const __backCompatOption = Interactable.prototype._backCompatOption;

  Interactable.prototype._backCompatOption = function (optionName, newValue) {
    const ret = __backCompatOption.call(this, optionName, newValue);

    if (ret === this) {
      this.events.options[optionName] = newValue;
    }

    return ret;
  };
}

function pointerEventsMethod(options) {
  extend$1(this.events.options, options);
  return this;
}

const plugin$1 = {
  id: 'pointer-events/interactableTargets',
  install: install$1,
  listeners: {
    'pointerEvents:collect-targets': ({
      targets,
      node,
      type,
      eventTarget
    }, scope) => {
      scope.interactables.forEachMatch(node, interactable => {
        const eventable = interactable.events;
        const options = eventable.options;

        if (eventable.types[type] && eventable.types[type].length && interactable.testIgnoreAllow(options, node, eventTarget)) {
          targets.push({
            node,
            eventable,
            props: {
              interactable
            }
          });
        }
      });
    },
    'interactable:new': ({
      interactable
    }) => {
      interactable.events.getRect = function (element) {
        return interactable.getRect(element);
      };
    },
    'interactable:set': ({
      interactable,
      options
    }, scope) => {
      extend$1(interactable.events.options, scope.pointerEvents.defaults);
      extend$1(interactable.events.options, options.pointerEvents || {});
    }
  }
};

const plugin = {
  id: 'pointer-events',

  install(scope) {
    scope.usePlugin(pointerEvents$1);
    scope.usePlugin(holdRepeat);
    scope.usePlugin(plugin$1);
  }

};

function install(scope) {
  const {
    /** @lends Interactable */
    Interactable
  } = scope;
  scope.actions.phases.reflow = true;
  /**
   * ```js
   * const interactable = interact(target)
   * const drag = { name: drag, axis: 'x' }
   * const resize = { name: resize, edges: { left: true, bottom: true }
   *
   * interactable.reflow(drag)
   * interactable.reflow(resize)
   * ```
   *
   * Start an action sequence to re-apply modifiers, check drops, etc.
   *
   * @param { Object } action The action to begin
   * @param { string } action.name The name of the action
   * @returns { Promise } A promise that resolves to the `Interactable` when actions on all targets have ended
   */

  Interactable.prototype.reflow = function (action) {
    return doReflow(this, action, scope);
  };
}

function doReflow(interactable, action, scope) {
  const elements = is.string(interactable.target) ? from$1(interactable._context.querySelectorAll(interactable.target)) : [interactable.target]; // tslint:disable-next-line variable-name

  const Promise = scope.window.Promise;
  const promises = Promise ? [] : null;

  for (const element of elements) {
    const rect = interactable.getRect(element);

    if (!rect) {
      break;
    }

    const runningInteraction = find$2(scope.interactions.list, interaction => {
      return interaction.interacting() && interaction.interactable === interactable && interaction.element === element && interaction.prepared.name === action.name;
    });
    let reflowPromise;

    if (runningInteraction) {
      runningInteraction.move();

      if (promises) {
        reflowPromise = runningInteraction._reflowPromise || new Promise(resolve => {
          runningInteraction._reflowResolve = resolve;
        });
      }
    } else {
      const xywh = tlbrToXywh(rect);
      const coords = {
        page: {
          x: xywh.x,
          y: xywh.y
        },
        client: {
          x: xywh.x,
          y: xywh.y
        },
        timeStamp: scope.now()
      };
      const event = coordsToEvent(coords);
      reflowPromise = startReflow(scope, interactable, element, action, event);
    }

    if (promises) {
      promises.push(reflowPromise);
    }
  }

  return promises && Promise.all(promises).then(() => interactable);
}

function startReflow(scope, interactable, element, action, event) {
  const interaction = scope.interactions.new({
    pointerType: 'reflow'
  });
  const signalArg = {
    interaction,
    event,
    pointer: event,
    eventTarget: element,
    phase: 'reflow'
  };
  interaction.interactable = interactable;
  interaction.element = element;
  interaction.prevEvent = event;
  interaction.updatePointer(event, event, element, true);
  setZeroCoords(interaction.coords.delta);
  copyAction(interaction.prepared, action);

  interaction._doPhase(signalArg);

  const {
    Promise
  } = scope.window;
  const reflowPromise = Promise ? new Promise(resolve => {
    interaction._reflowResolve = resolve;
  }) : undefined;
  interaction._reflowPromise = reflowPromise;
  interaction.start(action, interactable, element);

  if (interaction._interacting) {
    interaction.move(signalArg);
    interaction.end(event);
  } else {
    interaction.stop();

    interaction._reflowResolve();
  }

  interaction.removePointer(event, event);
  return reflowPromise;
}

const reflow = {
  id: 'reflow',
  install,
  listeners: {
    // remove completed reflow interactions
    'interactions:stop': ({
      interaction
    }, scope) => {
      if (interaction.pointerType === 'reflow') {
        if (interaction._reflowResolve) {
          interaction._reflowResolve();
        }

        remove(scope.interactions.list, interaction);
      }
    }
  }
};

interact.use(interactablePreventDefault);
interact.use(offset); // pointerEvents

interact.use(plugin); // inertia

interact.use(inertia); // snap, resize, etc.

interact.use(modifiers); // autoStart, hold

interact.use(autoStart); // drag and drop, resize, gesture

interact.use(actions); // autoScroll

interact.use(autoScrollPlugin); // reflow

interact.use(reflow); // eslint-disable-next-line no-undef

if ("development" !== 'production') {
  interact.use(defaultExport);
}

if (typeof module === 'object' && !!module) {
  try {
    module.exports = interact;
  } catch (_unused) {}
}

;
interact.default = interact;

var _templateObject$14, _templateObject2$E, _templateObject3$n, _templateObject4$g;
function ownKeys$W(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$V(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$W(Object(source), true).forEach(function (key) { _defineProperty$1L(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$W(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1L(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$14(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Image extends Et2Widget(SlotMixin(s$5)) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$14 || (_templateObject$14 = _taggedTemplateLiteral$14(["\n            :host {\n\t\t\t\tdisplay: inline-block;\n            }\n            ::slotted(img) {\n            \tmax-height: 100%;\n            \tmax-width: 100%;\n            }\n            :host([icon]) {\n            \theight: 1.3rem;\n            }\n            "])))];
  }
  static get properties() {
    return _objectSpread$V(_objectSpread$V({}, super.properties), {}, {
      /**
       * The label of the image
       * Actually not used as label, but we put it as title
       * Added here as there's no Lion parent
       */
      label: {
        type: String
      },
      /**
       * Image
       * Displayed image
       */
      src: {
        type: String
      },
      /**
       * Default image
       * Image to use if src is not found
       */
      defaultSrc: {
        type: String
      },
      /**
       * Link Target
       * Link URL, empty if you don't wan't to display a link.
       */
      href: {
        type: String
      },
      /**
       * Link target
       * Link target descriptor
       */
      extraLinkTarget: {
        type: String
      },
      /**
       * Popup
       * widthxheight, if popup should be used, eg. 640x480
       */
      extraLinkPopup: {
        type: String
      }
    });
  }
  get slots() {
    return {
      '': () => {
        return this._imageTemplate();
      }
    };
  }
  constructor() {
    super();
    this.src = "";
    this.defaultSrc = "";
    this.href = "";
    this.label = "";
    this.extraLinkTarget = "_self";
    this.extraLinkPopup = "";
    this._handleClick = this._handleClick.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
  }
  _imageTemplate() {
    var src = this.parse_href(this.src) || this.parse_href(this.defaultSrc);
    if (!src) {
      // Hide if no valid image
      return '';
    }
    return x$1(_templateObject2$E || (_templateObject2$E = _taggedTemplateLiteral$14(["\n            <img ", "\n                 src=\"", "\"\n                 alt=\"", "\"\n                 part=\"image\"\n                 loading=\"lazy\"\n                 title=\"", "\"\n            >"])), this.id ? x$1(_templateObject3$n || (_templateObject3$n = _taggedTemplateLiteral$14(["id=\"", "\""])), this.id) : '', src, this.label, this.statustext || this.label);
  }
  render() {
    return x$1(_templateObject4$g || (_templateObject4$g = _taggedTemplateLiteral$14(["\n            <slot></slot>"])));
  }
  parse_href(img_href) {
    var _this$egw;
    img_href = img_href || '';
    // allow url's too
    if (img_href[0] == '/' || img_href.substr(0, 4) == 'http' || img_href.substr(0, 5) == 'data:') {
      return img_href;
    }
    var src = (_this$egw = this.egw()) === null || _this$egw === void 0 ? void 0 : _this$egw.image(img_href);
    if (src) {
      return src;
    }
    return "";
  }
  _handleClick(_ev) {
    if (this.href) {
      this.egw().open_link(this.href, this.extraLinkTarget, this.extraLinkPopup);
    } else {
      return super._handleClick(_ev);
    }
  }
  get _img() {
    return this.querySelector('img');
  }

  /**
   * Handle changes that have to happen based on changes to properties
   *
   */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("src") && !this._img) {
      D$1(this._imageTemplate(), this);
    }
    if (changedProperties.has("src") && this._img) {
      this._img.setAttribute("src", this.parse_href(this.src) || this.parse_href(this.defaultSrc));
    }
    // if there's an href or onclick, make it look clickable
    if (changedProperties.has("href") || typeof this.onclick !== "undefined") {
      this.classList.toggle("et2_clickable", this.href || typeof this.onclick !== "undefined");
    }
    for (var changedPropertiesKey in changedProperties) {
      if (Et2Image.getPropertyOptions()[changedPropertiesKey]) {
        this._img[changedPropertiesKey] = this[changedPropertiesKey];
      }
    }
  }
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);

    // Expand src with additional stuff
    // This should go away, since we're not checking for $ or @
    if (typeof _attrs["src"] != "undefined") {
      var manager = this.getArrayMgr("content");
      if (manager && _attrs["src"]) {
        var src = manager.getEntry(_attrs["src"], false, true);
        if (typeof src != "undefined" && src !== null) {
          if (typeof src == "object") {
            this.src = this.egw().link('/index.php', src);
          } else {
            this.src = src;
          }
        }
      }
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM
   *
   * Individual widgets are detected and handled by the grid, but the interface is needed for this to happen
   *
   * @param {array} _attrs array to add further attributes to
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("src", "label", "href", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
}
customElements.define("et2-image", Et2Image, {
  extends: 'img'
});

var _templateObject$13;
function ownKeys$V(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$U(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$V(Object(source), true).forEach(function (key) { _defineProperty$1K(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$V(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$13(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1K(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var ButtonMixin = superclass => {
  var _class;
  return _class = class extends superclass {
    static get styles() {
      return [...shoelace, ...(super.styles || []), i$b(_templateObject$13 || (_templateObject$13 = _taggedTemplateLiteral$13(["\n            :host {\n                padding: 0;\n                /* These should probably come from somewhere else */\n               \tmax-width: 125px;\n               \tmin-width: fit-content;\n               \tdisplay: block;\n            }\n            /* Override general disabled=hide from Et2Widget */\n            :host([disabled]) {\n            \tdisplay: block;\n            }\n            :host([hideonreadonly][disabled]) {\n            \tdisplay:none !important;\n            }\n\n\t\t\t/* Leave label there for accessability, but position it so it can't be seen */\n\t\t\t:host(.imageOnly) .button__label {\n\t\t\t\tposition: absolute;\n\t\t\t\tleft: -999px\n\t\t\t}\n            \n            /* Set size for icon */\n            ::slotted(img.imageOnly) {\n    \t\t\tpadding-right: 0px !important;\n    \t\t\twidth: 16px !important;\n\t\t\t}\n            ::slotted(et2-image) {\n            \twidth: 20px;\n                max-width: 20px;\n                display: flex;\n            }\n            ::slotted([slot=\"icon\"][src='']) {\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\t.imageOnly {\n\t\t\t\twidth:18px;\n\t\t\t\theight: 18px;\n\t\t\t}\n\t\t\t/* Make hover border match other widgets (select) */\n\t\t\t.button--standard.button--default:hover:not(.button--disabled) {\n\t\t\t\tbackground-color: var(--sl-color-gray-150);\n\t\t\t\tborder-color: var(--sl-input-border-color-hover);\n\t\t\t\tcolor: var(--sl-input-color-hover);\n\t\t\t}\n\t\t\t.button {\n\t\t\t\tjustify-content: left;\n\t\t\t}\n\t\t\t.button--has-label.button--medium .button__label {\n\t\t\t\tpadding: 0 var(--sl-spacing-medium);\n\t\t\t}\n\t\t\t.button__label {\n\t\t\t\ttext-overflow: ellipsis;\n    \t\t\toverflow-x: hidden;\n\t\t\t}\n\t\t\t.button__prefix {\n\t\t\t\tpadding-left: 1px;\n\t\t\t}\n\t\t\t\n\t\t\t/* Only image, no label */\n\t\t\t.button--has-prefix:not(.button--has-label) {\n\t\t\t\tjustify-content: center;\n\t\t\t\twidth: var(--sl-input-height-medium);\n\t\t\t\tpadding-inline-start: 0;\t\t\t\n\t\t\t}\n\t\t\t\n\t\t\t/* Override primary styling - we use variant=primary on first dialog button */\n\t\t\t.button--standard.button--primary {\n\t\t\t\tbackground-color: hsl(240deg 5% 96%);\n\t\t\t\tborder-color: var(--sl-color-gray-400);\n\t\t\t\tcolor: var(--sl-input-color-hover);\n\t\t\t}\n\t\t\t.button--standard.button--primary:hover:not(.button--disabled),\n\t\t\t.button--standard.button--primary.button--checked:not(.button--disabled) {\n\t\t\t\tbackground-color: var(--sl-color-gray-150);\n\t\t\t\tborder-color: var(--sl-color-gray-600);\n\t\t\t\tcolor: initial;\n\t\t\t}\n\t\t\t.button--standard.button--primary:active:not(.button--disabled) {\n\t\t\t\tborder-color: var(--sl-color-gray-700);\n\t\t\t\tbackground-color: var(--sl-color-gray-300);\n\t\t\t\tcolor: initial;\n\t\t\t}\n            "])))];
    }
    static get properties() {
      return _objectSpread$U(_objectSpread$U({}, super.properties), {}, {
        image: {
          type: String,
          noAccessor: true
        },
        /**
         * If button is set to readonly, do we want to hide it completely (old behaviour) or show it as disabled
         * (default)
         * Something's not quite right here, as the attribute shows up as "hideonreadonly" instead of "hide" but
         * it does not show up without the "attribute", and attribute:"hideonreadonly" does not show as an attribute
         */
        hideOnReadonly: {
          type: Boolean,
          reflect: true,
          attribute: "hide"
        },
        /**
         * Button should submit the etemplate
         * Return false from the click handler to cancel the submit, or set noSubmit to true to skip submitting.
         */
        noSubmit: {
          type: Boolean,
          reflect: false
        },
        /**
         * When submitting, skip the validation step.  Allows to submit etemplates directly to the server.
         */
        noValidation: {
          type: Boolean
        }
      });
    }
    constructor() {
      super(...arguments);

      // Property default values
      _defineProperty$1K(this, "clicked", false);
      this.__image = '';
      this.noSubmit = false;
      this.hideOnReadonly = false;
      this.noValidation = false;

      // Do not add icon here, no children can be added in constructor
    }

    set image(new_image) {
      var oldValue = this.__image;
      if (new_image.indexOf("http") >= 0 || new_image.indexOf(this.egw().webserverUrl) >= 0) {
        this.__image = new_image;
      } else {
        this.__image = this.egw().image(new_image);
      }
      this.requestUpdate("image", oldValue);
    }
    get image() {
      return this.__image;
    }
    _handleClick(event) {
      var _this$getInstanceMana2;
      // ignore click on readonly button
      if (this.disabled || this.readonly || event.defaultPrevented) {
        event.preventDefault();
        event.stopImmediatePropagation();
        return false;
      }
      this.clicked = true;

      // Cancel buttons don't trigger the close confirmation prompt
      if (this.classList.contains("et2_button_cancel")) {
        var _this$getInstanceMana;
        (_this$getInstanceMana = this.getInstanceManager()) === null || _this$getInstanceMana === void 0 || _this$getInstanceMana.skip_close_prompt();
      }
      if (!super._handleClick(event)) {
        this.clicked = false;
        return false;
      }

      // Submit the form
      if (!this.noSubmit) {
        return this.getInstanceManager().submit(this, undefined, this.noValidation);
      }
      this.clicked = false;
      (_this$getInstanceMana2 = this.getInstanceManager()) === null || _this$getInstanceMana2 === void 0 || _this$getInstanceMana2.skip_close_prompt(false);
      return true;
    }

    /**
     * Handle changes that have to happen based on changes to properties
     *
     */
    requestUpdate(name, oldValue) {
      super.requestUpdate(name, oldValue);

      // "disabled" is the attribute from the spec
      if (name == 'readonly') {
        if (this.readonly) {
          this.setAttribute('disabled', "");
        } else {
          this.removeAttribute("disabled");
        }
      }

      // Default image & class are determined based on ID
      if (name == "id" && this._widget_id) {
        // Check against current value to avoid triggering another update
        if (!this.image) {
          var image = this._get_default_image(this._widget_id);
          if (image && image != this.__image) {
            this.image = image;
          }
        }
        var default_class = this._get_default_class(this._widget_id);
        if (default_class && !this.classList.contains(default_class)) {
          this.classList.add(default_class);
        }
      }
    }
    updated(changedProperties) {
      super.updated(changedProperties);
      if (changedProperties.has("image")) {
        if (this.image && !this._iconNode) {
          var image = document.createElement("et2-image");
          image.slot = "prefix";
          this.prepend(image);
          image.src = this.__image;
        } else if (this._iconNode) {
          this._iconNode.src = this.__image;
        }
      }
    }

    /**
     * Get a default image for the button based on ID
     *
     * @param {string} check_id
     */
    _get_default_image(check_id) {
      if (!check_id) {
        return "";
      }
      if (!this.image) {
        // @ts-ignore
        for (var image in this.constructor.default_background_images) {
          // @ts-ignore
          if (check_id.match(this.constructor.default_background_images[image])) {
            return image;
          }
        }
      }
      return "";
    }

    /**
     * If button ID has a default keyboard shortcut (eg: Save: Ctrl+S), register with egw_keymanager
     *
     * @param {string} check_id
     */
    _register_default_keyhandler(check_id) {
      if (!check_id) {
        return;
      }
      // @ts-ignore
      for (var keyindex in this.constructor.default_keys) {
        // @ts-ignore
        if (check_id.match(this.constructor.default_keys[keyindex])) {
          var [keycode, modifiers] = keyindex.substring(1).split("_");
          egw_registerGlobalShortcut(parseInt(keycode), modifiers.includes("S"), modifiers.includes("C"), modifiers.includes("A"), () => {
            this.dispatchEvent(new MouseEvent("click"));
            return true;
          }, this);
        }
      }
    }

    /**
     * Get a default class for the button based on ID
     *
     * @param check_id
     * @returns {string}
     */
    _get_default_class(check_id) {
      if (!check_id) {
        return "";
      }
      for (var name in ButtonMixin.default_classes) {
        if (check_id.match(ButtonMixin.default_classes[name])) {
          return name;
        }
      }
      return "";
    }
    get _iconNode() {
      return Array.from(this.children).find(el => el.slot === "prefix");
    }
    get _labelNode() {
      return Array.from(this.childNodes).find(el => el.nodeType === 3);
    }

    /**
     * Implementation of the et2_IInput interface
     */

    /**
     * Always return false as a button is never dirty
     */
    isDirty() {
      return false;
    }
    resetDirty() {}
    getValue() {
      if (this.clicked) {
        return true;
      }

      // If "null" is returned, the result is not added to the submitted
      // array.
      return null;
    }
  }, _defineProperty$1K(_class, "default_background_images", {
    save: /save(&|\]|$)/,
    apply: /apply(&|\]|$)/,
    cancel: /cancel(&|\]|$)/,
    delete: /delete(&|\]|$)/,
    discard: /discard(&|\]|$)/,
    edit: /edit(&|\[\]|$)/,
    next: /(next|continue)(&|\]|$)/,
    finish: /finish(&|\]|$)/,
    back: /(back|previous)(&|\]|$)/,
    copy: /copy(&|\]|$)/,
    more: /more(&|\]|$)/,
    check: /(yes|check)(&|\]|$)/,
    cancelled: /no(&|\]|$)/,
    ok: /ok(&|\]|$)/,
    close: /close(&|\]|$)/,
    link: /link(&|\]|_|$)/,
    add: /(add(&|\]|$)|create)/ // customfields use create*
  }), _defineProperty$1K(_class, "default_classes", {
    et2_button_cancel: /cancel(&|\]|$)/,
    // yellow
    et2_button_question: /(yes|no)(&|\]|$)/,
    // yellow
    et2_button_delete: /delete(&|\]|$)/ // red
  }), _defineProperty$1K(_class, "default_keys", {
    //egw_shortcutIdx : id regex
    _83_C: /save(&|\]|$)/,
    // CTRL+S
    _27_: /cancel(&|\]|$)/ // Esc
  }), _class;
};

function ownKeys$U(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$T(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$U(Object(source), true).forEach(function (key) { _defineProperty$1J(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$U(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1J(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Button extends ButtonMixin(Et2InputWidget(button_default)) {
  static get properties() {
    return _objectSpread$T(_objectSpread$T({}, super.properties), {}, {
      label: {
        type: String,
        noAccessor: true
      }
    });
  }
  firstUpdated(_changedProperties) {
    super.firstUpdated(_changedProperties);

    // Register default keyboard shortcut, if applicable
    this._register_default_keyhandler(this.id);
    if (!this.label && this.__image) {
      /*
       Label / no label should get special classes set, but they're missing without this extra requestUpdate()
       This is a work-around for button--has-prefix & button--has-label not being set, something to do
       with how we're setting them.
       */
      this.updateComplete.then(() => {
        this.requestUpdate();
      });
    }
  }
  set label(new_label) {
    this.updateComplete.then(() => {
      if (!this._labelNode) {
        var textNode = document.createTextNode(new_label);
        this.appendChild(textNode);
        // for some reason button doesn't get resized properly without a forced rendereing therefore the
        // requestUpdate is used to trigger a refresh.
        this.requestUpdate();
      } else {
        this._labelNode.textContent = new_label;
        // for some reason button doesn't get resized properly without a forced rendereingtherefore the
        // requestUpdate is used to trigger a refresh.
        this.requestUpdate();
      }
    });
  }
  get label() {
    var _this$_labelNode;
    return (_this$_labelNode = this._labelNode) === null || _this$_labelNode === void 0 || (_this$_labelNode = _this$_labelNode.textContent) === null || _this$_labelNode === void 0 ? void 0 : _this$_labelNode.trim();
  }
}
customElements.define("et2-button", Et2Button);

var _templateObject$12, _templateObject2$D, _templateObject3$m, _templateObject4$f, _templateObject5$d;
function asyncGeneratorStep$e(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$e(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$e(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$e(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$T(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$S(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$T(Object(source), true).forEach(function (key) { _defineProperty$1I(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$T(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$12(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1I(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * A common dialog widget that makes it easy to inform users or prompt for information.
 *
 * It is possible to have a custom dialog by using a template, but you can also use
 * the static method Et2Dialog.show_dialog().  At its simplest, you can just use:
 * ```ts
 *	Et2Dialog.show_dialog(false, "Operation completed");
 * ```
 *
 * Or a more complete example:
 * ```js
 * let callback = function (button_id)
 *	{
 *		if(button_id == Et2Dialog.YES_BUTTON)
 *		{
 *			// Do stuff
 *		}
 *		else if (button_id == Et2Dialog.NO_BUTTON)
 *		{
 *			// Other stuff
 *		}
 *		else if (button_id == Et2Dialog.CANCEL_BUTTON)
 *		{
 *			// Abort
 *		}
 *	}.
 *	let dialog = Et2Dialog.show_dialog(
 *		callback, "Erase the entire database?","Break things", {} // value
 *		et2_dialog.BUTTONS_YES_NO_CANCEL, et2_dialog.WARNING_MESSAGE
 *	);
 * ```
 *
 * Or, using Promises instead of a callback:
 * ```ts
 * let result = await Et2Dialog.show_prompt(null, "Name").getComplete();
 * if(result.button_id == Et2Dialog.OK_BUTTON)
 * {
 *     // Do stuff with result.value
 * }
 * ```
 *
 * The parameters for the above are all optional, except callback (which can be null) and message:
 * -	callback - function called when the dialog closes, or false/null.
 *		The ID of the button will be passed.  Button ID will be one of the Et2Dialog.*_BUTTON constants.
 *		The callback is _not_ called if the user closes the dialog with the X in the corner, or presses ESC.
 * -	message - (plain) text to display
 * -	title - Dialog title
 * -	value (for prompt)
 * -	buttons - Et2Dialog BUTTONS_* constant, or an array of button settings.  Use DialogButton interface.
 * -	dialog_type - Et2Dialog *_MESSAGE constant
 * -	icon - URL of icon
 *
 * Note that these methods will _not_ block program flow while waiting for user input unless you use "await" on getComplete().
 * The user's input will be provided to the callback.
 *
 * You can also create a custom dialog using an etemplate, even setting all the buttons yourself.
 * ```ts
 * // Pass egw in the constructor
 * 	let dialog = new Et2Dialog(my_egw_reference);
 *
 * 	// Set attributes.  They can be set in any way, but this is convenient.
 * 	dialog.transformAttributes({
 * 		// If you use a template, the second parameter will be the value of the template, as if it were submitted.
 * 		callback: function(button_id, value) {...},	// return false to prevent dialog closing
 * 		buttons: [
 * 			// These ones will use the callback, just like normal.  Use DialogButton interface.
 * 			{label: egw.lang("OK"),id:"OK", default: true},
 * 			{label: egw.lang("Yes"),id:"Yes"},
 * 			{label: egw.lang("Sure"),id:"Sure"},
 * 			{label: egw.lang("Maybe"),click: function() {
 * 				// If you override, 'this' will be the dialog DOMNode.
 * 				// Things get more complicated.
 * 				// Do what you like here
 * 			}},
 *
 * 		],
 * 		title: 'Why would you want to do this?',
 * 		template:"/egroupware/addressbook/templates/default/edit.xet",
 * 		value: { content: {...default values}, sel_options: {...}...}
 * 	});
 *	// Add to DOM, dialog will auto-open
 *	document.body.appendChild(dialog);
 *	// If you want, wait for close
 *	let result = await dialog.getComplete();
 *```
 *
 * Customize initial focus by setting the "autofocus" attribute on a control, otherwise first input will have focus
 */
class Et2Dialog$1 extends Et2Widget(SlotMixin(dialog_default)) {
  static get styles() {
    return [...shoelace, ...(super.styles || []), i$b(_templateObject$12 || (_templateObject$12 = _taggedTemplateLiteral$12(["\n\t\t\t\t:host {\n\t\t\t\t\t--header-spacing: var(--sl-spacing-medium);\n\t\t\t\t\t--body-spacing: var(--sl-spacing-medium);\n\t\t\t\t    --width: auto;\n\t\t\t\t}\n\t\t\t\t.dialog__panel {\n\t\t\t\t\tborder: 1px solid silver;\n\t\t\t\t\tbox-shadow: -2px 1px 9px 3px #b4b4b4;\n\t\t\t\t\tmin-width: 250px;\n\t\t\t\t\ttouch-action: none;\n\t\t\t\t}\n\t\t\t\t.dialog__header {\n\t\t\t\t\tdisplay: flex;\n          \t\t\tborder-bottom: 1px inset;\n\t\t\t\t}\n\t\t\t\t.dialog__title {\n\t\t\t\t\tfont-size: var(--sl-font-size-medium);\n\t\t\t\t\tuser-select: none;\n\t\t\t\t}\n\t\t\t\t.dialog__close {\n\t\t\t\t\tbackground-color: #f3f3f3;\n\t\t\t\t\tpadding: 0;\n\t\t\t\t\torder: 99;\n\t\t\t\t}\n\t\t\t\t.dialog__footer\t{\n\t\t\t\t\t--footer-spacing: 5px;\n\t\t\t\t\tdisplay: flex;\n\t\t\t\t\tflex-wrap: nowrap;\n\t\t\t\t\tjustify-content: flex-start;\n\t\t\t\t\talign-items: stretch;\n\t\t\t\t\tgap: 5px;\n\t\t\t\t\tborder-top: 1px solid silver;\n\t\t\t\t\tmargin-top: 0.5em;\n\t\t\t\t}\n\n\t\t\t  .dialog_content {\n\t\t\t\theight: var(--height, auto);\n\t\t\t  }\n\n\t\t\t  /* Non-modal dialogs don't have an overlay */\n\n\t\t\t  :host(:not([ismodal])) .dialog, :host(:not([isModal])) .dialog__overlay {\n\t\t\t\tpointer-events: none;\n\t\t\t\tbackground: transparent;\n\t\t\t  }\n\n\t\t\t  :host(:not([ismodal])) .dialog__panel {\n\t\t\t\tpointer-events: auto;\n\t\t\t  }\n\n\t\t\t  /* Hide close button when set */\n\n\t\t\t  :host([noclosebutton]) .dialog__close {\n\t\t\t\tdisplay: none;\n\t\t\t  }\n\n\t\t\t  /* Button alignments */\n\n\t\t\t  ::slotted([align=\"left\"]) {\n\t\t\t\tmargin-right: auto;\n\t\t\t\torder: -1;\n\t\t\t  }\n\n\t\t\t  ::slotted([align=\"right\"]) {\n\t\t\t\tmargin-left: auto;\n\t\t\t\torder: 1;\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$S(_objectSpread$S({}, super.properties), {}, {
      callback: Function,
      /**
       * Allow other controls to be accessed while the dialog is visible
       * while not conflicting with internal attribute
       */
      isModal: {
        type: Boolean,
        reflect: true
      },
      /**
       * Title for the dialog, goes in the header
       */
      title: String,
      /**
       * Pre-defined group of buttons, one of the BUTTONS_*
       */
      buttons: Number,
      /**
       * Instead of a message, show this template file instead
       */
      template: String,
      // Force size on the dialog.  Normally it sizes to content.
      width: Number,
      height: Number,
      // We just pass these on to Et2DialogContent
      message: String,
      dialog_type: Number,
      icon: String,
      value: Object,
      /**
       * Automatically destroy the dialog when it closes.  Set to false to keep the dialog around.
       */
      destroyOnClose: Boolean,
      /**
       * Legacy-option for appending dialog into a specific dom node
       */
      appendTo: String,
      /**
       * When it's set to false dialog won't get closed by hitting Esc
       */
      hideOnEscape: Boolean,
      /**
       * When set to true it removes the close button from dialog's header
       */
      noCloseButton: {
        type: Boolean,
        reflect: true
      }
    });
  }
  get slots() {
    return _objectSpread$S(_objectSpread$S({}, super.slots), {}, {
      '': () => {
        // to fix problem with Safari 16.2 of NOT displaying the content, we have to use the following,
        // instead of just return this._contentTemplate()
        var div = document.createElement("div");
        D$1(this._contentTemplate(), div);
        return div.children[0];
      }
    });
  }

  /*
  * List of properties that get translated
  * Done separately to not interfere with properties - if we re-define label property,
  * labels go missing.
  */
  static get translate() {
    return _objectSpread$S(_objectSpread$S({}, super.translate), {}, {
      title: true,
      message: true
    });
  }
  constructor(parent_egw) {
    super();
    /**
     * Dialogs don't always get added to an etemplate, so we keep our own egw
     *
     * @type {IegwAppLocal}
     * @protected
     * @internal
     */
    _defineProperty$1I(this, "__egw", void 0);
    /**
     * As long as the template is a legacy widget, we want to hold on to the widget
     * When it becomes a WebComponent, we can just include it in render()
     *
     * @type {et2_template | null}
     * @protected
     * @internal
     */
    _defineProperty$1I(this, "_template_widget", void 0);
    _defineProperty$1I(this, "_template_promise", void 0);
    /**
     * Treat the dialog as an atomic operation, and use this promise to notify when
     * "done" instead of (or in addition to) using the callback function.
     * It gives the button ID and the dialog value.
     * @internal
     */
    _defineProperty$1I(this, "_complete_promise", void 0);
    /**
     * Resolve the template promise
     */
    _defineProperty$1I(this, "_templateResolver", void 0);
    /**
     * Resolve the dialog complete promise
     */
    _defineProperty$1I(this, "_completeResolver", void 0);
    /**
     * The ID of the button that was clicked.  Always one of the button constants,
     * unless custom buttons were used
     *
     * @type {number|null}
     * @protected
     * @internal
     */
    _defineProperty$1I(this, "_button_id", void 0);
    _defineProperty$1I(this, "_buttons", [
    /*
    Pre-defined Button combos
    */
    //BUTTONS_OK: 0,
    [{
      "button_id": Et2Dialog$1.OK_BUTTON,
      label: 'ok',
      id: 'dialog[ok]',
      image: 'check',
      "default": true
    }],
    //BUTTONS_OK_CANCEL: 1,
    [{
      "button_id": Et2Dialog$1.OK_BUTTON,
      label: 'ok',
      id: 'dialog[ok]',
      image: 'check',
      "default": true
    }, {
      "button_id": Et2Dialog$1.CANCEL_BUTTON,
      label: 'cancel',
      id: 'dialog[cancel]',
      image: 'cancel',
      align: "right"
    }],
    //BUTTONS_YES_NO: 2,
    [{
      "button_id": Et2Dialog$1.YES_BUTTON,
      label: 'yes',
      id: 'dialog[yes]',
      image: 'check',
      "default": true
    }, {
      "button_id": Et2Dialog$1.NO_BUTTON,
      label: 'no',
      id: 'dialog[no]',
      image: 'cancel'
    }],
    //BUTTONS_YES_NO_CANCEL: 3,
    [{
      "button_id": Et2Dialog$1.YES_BUTTON,
      label: 'yes',
      id: 'dialog[yes]',
      image: 'check',
      "default": true
    }, {
      "button_id": Et2Dialog$1.NO_BUTTON,
      label: 'no',
      id: 'dialog[no]',
      image: 'cancelled'
    }, {
      "button_id": Et2Dialog$1.CANCEL_BUTTON,
      label: 'cancel',
      id: 'dialog[cancel]',
      image: 'cancel',
      align: "right"
    }]]);
    if (parent_egw) {
      this._setApiInstance(parent_egw);
    }
    this.isModal = false;
    this.dialog_type = Et2Dialog$1.PLAIN_MESSAGE;
    this.destroyOnClose = true;
    this.hideOnEscape = this.hideOnEscape === false ? false : true;
    this.__value = {};
    this.open = true;
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this._onClick = this._onClick.bind(this);
    this._onButtonClick = this._onButtonClick.bind(this);
    this._onMoveResize = this._onMoveResize.bind(this);
    this.handleKeyUp = this.handleKeyUp.bind(this);
    this._adoptTemplateButtons = this._adoptTemplateButtons.bind(this);

    // Don't leave it undefined, it's easier to deal with if it's just already resolved.
    // It will be re-set if a template is loaded
    this._template_promise = Promise.resolve(false);

    // Create this here so we have something, otherwise the creator might continue with undefined while we
    // wait for the dialog to complete & open
    this._complete_promise = new Promise(resolve => {
      this._completeResolver = value => resolve(value);
    });
  }
  connectedCallback() {
    super.connectedCallback();
    this.addEventListener("keyup", this.handleKeyUp);

    // Prevent close if they click the overlay when the dialog is modal
    this.addEventListener('sl-request-close', event => {
      // Prevent close on clicking somewhere else
      if (this.isModal && event.detail.source === 'overlay') {
        event.preventDefault();
        return;
      }
      // Prevent close on escape
      if (!this.hideOnEscape && event.detail.source === 'keyboard') {
        event.preventDefault();
        return;
      }
    });
    this.addEventListener("sl-after-show", this.handleOpen);
    this.addEventListener('sl-hide', this.handleClose);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("keyup", this.handleKeyUp);
    this.removeEventListener("sl-hide", this.handleClose);
    this.removeEventListener("sl-after-show", this.handleOpen);
  }
  destroy() {
    if (this.template) {
      this.template.clear(true);
    }
    this.remove();
  }

  /**
   * Hide the dialog.
   * Depending on destroyOnClose, it may be removed as well
   *
   * N.B. We can't have open() because it conflicts with SlDialog.  Use show() instead.
   */
  close() {
    return this.hide();
  }
  addOpenListeners() {
    //super.addOpenListeners();

    // Bind on the ancestor, not the buttons, so their click handler gets a chance to run
    this.addEventListener("click", this._onButtonClick);
    this.addEventListener("keydown", this.handleKeyDown);
  }
  removeOpenListeners() {
    //super.removeOpenListeners();
    this.removeEventListener("click", this._onButtonClick);
    this.removeEventListener("keydown", this.handleKeyDown);
  }
  handleKeyUp(event) {
    // Trigger the "primary" or first button
    if (this.open && event.key === 'Enter') {
      var button = this.querySelectorAll("[varient='primary']");
      if (button.length == 0) {
        // Nothing explicitly marked, check for buttons in the footer
        button = this.querySelectorAll("et2-button[slot='footer']");
      }
      if (button && button[0]) {
        event.stopPropagation();
        button[0].dispatchEvent(new CustomEvent('click', {
          bubbles: true
        }));
      }
    }
  }
  firstUpdated() {
    super.firstUpdated();

    // If we start open, fire handler to get setup done
    if (this.open) {
      this.handleOpenChange();
    }
    this.updateComplete.then(() => this._setDefaultAutofocus());
  }

  // Need to wait for Overlay
  getUpdateComplete() {
    var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
      _this = this;
    return _asyncToGenerator$e(function* () {
      yield _superprop_getGetUpdateComplete().call(_this);

      // Wait for template to finish loading
      yield _this._template_promise;
    })();
  }
  getComplete() {
    return this._complete_promise;
  }
  handleOpen(event) {
    if (event.target !== this) {
      return;
    }
    this.addOpenListeners();
    this._button_id = null;
    this._complete_promise = this._complete_promise || new Promise(resolve => this._completeResolver);

    // Now consumers can listen for "open" event, though getUpdateComplete().then(...) also works
    this.dispatchEvent(new Event('open'));
    Promise.all([this._template_promise, this.updateComplete]).then(() => this._setupMoveResize());
  }
  handleClose(ev) {
    // Avoid closing if a selectbox is closed
    if (ev.target !== this) {
      return;
    }
    this.removeOpenListeners();
    this._completeResolver([this._button_id, this.value]);
    this._button_id = null;
    this._complete_promise = undefined;
    this.dispatchEvent(new Event('close'));
    if (this.destroyOnClose) {
      if (this._template_widget) {
        this._template_widget.clear();
      }
      this.remove();
    }
  }

  /**
   * Only internally do our onClick on buttons in the footer
   * This calls _onClose() when the dialog is closed
   *
   * @param {MouseEvent} ev
   * @returns {boolean}
   */
  _onButtonClick(ev) {
    if (ev.target instanceof Et2Button && ev.target.slot == 'footer') {
      return this._onClick(ev);
    }
  }
  _onClick(ev) {
    var _ev$target, _ev$target2, _ev$target3, _ev$target4;
    // @ts-ignore
    this._button_id = (_ev$target = ev.target) !== null && _ev$target !== void 0 && _ev$target.getAttribute("button_id") ? parseInt((_ev$target2 = ev.target) === null || _ev$target2 === void 0 ? void 0 : _ev$target2.getAttribute("button_id")) : ((_ev$target3 = ev.target) === null || _ev$target3 === void 0 ? void 0 : _ev$target3.getAttribute("id")) || null;

    // we need to consider still buttons used in dialogs that may actually submit and have server-side interactions(eg.vfsSelect)
    if (!((_ev$target4 = ev.target) !== null && _ev$target4 !== void 0 && (_ev$target4 = _ev$target4.getInstanceManager()) !== null && _ev$target4 !== void 0 && _ev$target4._etemplate_exec_id)) {
      // we always need to stop the event as otherwise the result would be submitted to server-side eT2 handler
      // which does not know what to do with it, as the dialog was initiated from client-side (no eT2 request)
      ev.preventDefault();
      ev.stopPropagation();
    }

    // Handle anything bound via et2 onclick property
    try {
      var et2_widget_result = super._handleClick(ev);
      if (et2_widget_result === false) {
        return false;
      }
    } catch (e) {
      console.log(e);
    }

    // Callback expects (button_id, value)
    try {
      var callback_result = this.callback ? this.callback(this._button_id, this.value, ev) : true;
      if (callback_result === false) {
        return false;
      }
    } catch (e) {
      console.log(e);
    }
    this.hide();
  }

  /**
   * Handle moving and resizing
   *
   * @param event
   */
  _onMoveResize(event) {
    var target = event.target;
    var x = parseFloat(target.getAttribute('data-x')) || 0;
    var y = parseFloat(target.getAttribute('data-y')) || 0;

    // update the element's style
    target.style.width = event.rect.width + 'px';
    target.style.height = event.rect.height + 'px';

    // translate when resizing from top or left edges
    if (event.type == "resizemove") {
      x += event.deltaRect.left;
      y += event.deltaRect.top;
    } else {
      x += event.delta.x;
      y += event.delta.y;
    }
    target.style.transform = 'translate(' + x + 'px,' + y + 'px)';
    target.setAttribute('data-x', x);
    target.setAttribute('data-y', y);
  }

  /**
   * Returns the values of any widgets in the dialog.  This does not include
   * the buttons, which are only supplied for the callback.
   */
  get value() {
    var value = this.__value;
    if (this._template_widget && this._template_widget.widgetContainer) {
      value = this._template_widget.getValues(this._template_widget.widgetContainer);
    }
    return value;
  }

  /**
   * @deprecated
   * @returns {Object}
   */
  get_value() {
    console.warn("Deprecated get_value() called");
    return this.value;
  }
  set value(new_value) {
    this.__value = new_value;
  }
  set template(new_template_name) {
    var old_template = this.__template;
    this.__template = new_template_name;

    // Create the new promise here so we can wait for it immediately, not in update
    this._template_promise = new Promise(resolve => {
      this._templateResolver = value => resolve(value);
    });
    if (!this.__template) {
      this._templateResolver(true);
    }
    this.requestUpdate("template", old_template);
  }
  get template() {
    // Can't return undefined or requestUpdate() will not notice a change
    return this._template_widget || null;
  }
  get title() {
    return this.label;
  }
  set title(new_title) {
    this.label = new_title;
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("template")) {
      // Wait until update is finished to avoid an error in Safari
      super.getUpdateComplete().then(() => this._loadTemplate());
    }
    if (changedProperties.has("buttons")) {
      D$1(this._buttonsTemplate(), this);
      this.requestUpdate();
    }
    if (changedProperties.has("width")) {
      this.style.setProperty("--width", this.width ? this.width + "px" : "initial");
    }
  }
  _loadTemplate() {
    if (this._template_widget) {
      this._template_widget.clear();
    }
    this._contentNode.replaceChildren();

    // Etemplate wants a content
    if (typeof this.__value.content === "undefined") {
      this.__value.content = {};
    }
    this._template_widget = new etemplate2$1(this._contentNode);

    // Fire an event so consumers can do their thing - etemplate will fire its own load event when its done
    if (!this.dispatchEvent(new CustomEvent("before-load", {
      bubbles: true,
      cancelable: true,
      detail: this._template_widget
    }))) {
      return;
    }
    if (this.__template.indexOf('.xet') > 0) {
      var template = this.__template;
      // inject preprocessor, if not already in template-url
      var webserverUrl = this.egw().webserverUrl;
      if (!template.match(new RegExp(webserverUrl + '/api/etemplate.php'))) {
        template = template.replace(new RegExp(webserverUrl), webserverUrl + '/api/etemplate.php');
      }
      // if we have no cache-buster, reload daily
      if (template.indexOf('?') === -1) {
        template += '?' + (new Date().valueOf() / 86400 | 0).toString();
      }
      // File name provided, fetch from server
      this._template_widget.load("", template, this.__value || {
        content: {}
      }).then(() => {
        this._templateResolver(true);
      });
    } else {
      // Just template name, it better be loaded already
      this._template_widget.load(this.__template, '', this.__value || {},
      // true: do NOT call et2_ready, as it would overwrite this.et2 in app.js
      undefined, undefined, true).then(() => {
        this._templateResolver(true);
      });
    }

    // Don't let dialog closing destroy the parent session
    if (this._template_widget.etemplate_exec_id && this._template_widget.app) {
      for (var et of etemplate2$1.getByApplication(this._template_widget.app)) {
        if (et !== this._template_widget && et.etemplate_exec_id === this._template_widget.etemplate_exec_id) {
          // Found another template using that exec_id, don't destroy when dialog closes.
          this._template_widget.unbind_unload();
          break;
        }
      }
    }
    // set template-name as id, to allow to style dialogs
    this._template_widget.DOMContainer.setAttribute('id', this.__template.replace(/^(.*\/)?([^/]+?)(\.xet)?(\?.*)?$/, '$2').replace(/\./g, '-'));

    // Look for buttons after load
    this._contentNode.addEventListener("load", this._adoptTemplateButtons);

    // Default autofocus to first input if autofocus is not set
    this._contentNode.addEventListener("load", this._setDefaultAutofocus);

    // Need to update to pick up changes
    this.requestUpdate();
  }
  _contentTemplate() {
    /**
     * Classes for dialog type options
     */
    var _dialogTypes = [
    //PLAIN_MESSAGE: 0
    "",
    //INFORMATION_MESSAGE: 1,
    "dialog_info",
    //QUESTION_MESSAGE: 2,
    "dialog_help",
    //WARNING_MESSAGE: 3,
    "dialog_warning",
    //ERROR_MESSAGE: 4,
    "dialog_error"];
    var icon = this.icon || this.egw().image(_dialogTypes[this.dialogType] || "") || "";
    var type = _dialogTypes[this.dialogType];
    var classes = {
      dialog_content: true,
      "dialog--has_message": this.message,
      "dialog--has_template": this.__template
    };
    if (type) {
      classes[type] = true;
    }

    // Add in styles set via property
    var styles = {};
    if (this.width) {
      styles["--width"] = this.width;
    }
    if (this.height) {
      styles["--height"] = this.height;
    }
    return x$1(_templateObject2$D || (_templateObject2$D = _taggedTemplateLiteral$12(["\n            <div class=", " style=\"", "\">\n                ", "\n\n            </div>"])), o$9(classes), o$7(styles), this.__template ? "" : x$1(_templateObject3$m || (_templateObject3$m = _taggedTemplateLiteral$12([" <img class=\"dialog_icon\" src=", "/>\n                  <slot>", "</slot>"])), icon, this.message));
  }
  _buttonsTemplate() {
    // No buttons set, but careful with BUTTONS_OK
    if (!this.buttons && this.buttons !== Et2Dialog$1.BUTTONS_OK) {
      return;
    }
    var buttons = this._getButtons();
    var hasDefault = false;
    buttons.forEach(button => {
      if (button.default) {
        hasDefault = true;
      }
    });

    // Set button._parent here, otherwise button will have trouble finding our egw()
    return x$1(_templateObject4$f || (_templateObject4$f = _taggedTemplateLiteral$12(["", ""])), c$2(buttons, button => button.id, (button, index) => {
      var isDefault = hasDefault && button.default || !hasDefault && index == 0;
      return x$1(_templateObject5$d || (_templateObject5$d = _taggedTemplateLiteral$12(["\n                <et2-button ._parent=", " id=", " button_id=", "\n                            label=", "\n                            slot=\"footer\"\n                            .image=", "\n                            .noSubmit=", "\n                            ?disabled=", "\n                            variant=", "\n                            align=", ">\n                </et2-button>\n\t\t\t"])), this, button.id, button.button_id, button.label, l$2(button.image), true, button.disabled, isDefault ? "primary" : "default", l$2(button.align));
    }));
  }
  _getButtons() {
    if (Number.isInteger(this.buttons)) {
      // Translate as needed, since we're not calling transformAttributes() on the buttons
      // when we create them in a render()
      return this._buttons[this.buttons].map(but => {
        but.label = this.egw().lang(but.label);
        return but;
      });
    } else if (Array.isArray(this.buttons)) {
      return this.buttons;
    }
  }

  /**
   * Search for buttons in the template, and try to slot them
   *
   * We don't want to just grab them all, as there may be other buttons.
   */
  _adoptTemplateButtons() {
    var _this$_template_widge, _this$_template_widge2;
    // Check for something with buttons slot set
    var search_in = (_this$_template_widge = (_this$_template_widge2 = this._template_widget) === null || _this$_template_widge2 === void 0 ? void 0 : _this$_template_widge2.DOMContainer) !== null && _this$_template_widge !== void 0 ? _this$_template_widge : this._contentNode;
    if (!search_in) {
      return;
    }
    var template_buttons = [...search_in.querySelectorAll('[slot="footer"],[slot="buttons"]'),
    // Look for a dialog footer, which will contain several buttons and possible other widgets
    ...search_in.querySelectorAll(".dialogFooterToolbar et2-button"),
    // Look for buttons at high level (not everywhere, otherwise we can't have other buttons in the template)
    ...search_in.querySelectorAll(":scope > et2-button, :scope > * > et2-button")];
    if (template_buttons) {
      var _template_buttons$;
      if ((_template_buttons$ = template_buttons[0]) !== null && _template_buttons$ !== void 0 && _template_buttons$.instanceOf(Et2Button)) {
        template_buttons[0].variant = "primary";
      }
      template_buttons.forEach(button => {
        button.setAttribute("slot", "footer");
        this.appendChild(button);
      });
      this.requestUpdate();
    }
    // do NOT submit dialog, if it has no etemplate_exec_id, it only gives and error on server-side
    if (this._template_widget && !this._template_widget.widgetContainer.getInstanceManager().etemplate_exec_id) {
      var _this$_template_widge3;
      (_this$_template_widge3 = this._template_widget) === null || _this$_template_widge3 === void 0 || _this$_template_widge3.DOMContainer.querySelectorAll('et2-button').forEach(button => {
        button.noSubmit = true;
      });
    }
    return template_buttons;
  }

  /**
   * Set autofocus on first input element if nothing has autofocus
   */
  _setDefaultAutofocus() {
    var autofocused = this.querySelector("[autofocus]");
    if (autofocused) {
      return;
    }
    if (this.template) {
      this.template.focusOnFirstInput();
    } else {
      // Not a template, but maybe something?
      var $input = jQuery('input:visible,et2-textbox:visible,et2-select-email:visible', this)
      // Date fields open the calendar popup on focus
      .not('.et2_date').filter(function () {
        // Skip inputs that are out of tab ordering
        var $this = jQuery(this);
        return !$this.attr('tabindex') || parseInt($this.attr('tabIndex')) >= 0;
      }).first();

      // mobile device, focus only if the field is empty (usually means new entry)
      // should focus always for non-mobile one
      if (egwIsMobile$1() && $input.val() == "" || !egwIsMobile$1()) {
        $input.focus();
      }
    }
  }
  get _contentNode() {
    return this.querySelector('.dialog_content');
  }
  _setupMoveResize() {
    // Quick calculation of min size - dialog is made up of header, content & buttons
    var minHeight = 0;
    for (var e of this.panel.children) {
      minHeight += e.getBoundingClientRect().height + parseFloat(getComputedStyle(e).marginTop) + parseFloat(getComputedStyle(e).marginBottom);
    }
    interact(this.panel).resizable({
      edges: {
        bottom: true,
        right: true
      },
      listeners: {
        move: this._onMoveResize
      },
      modifiers: [
      // keep the edges inside the parent
      interact.modifiers.restrictEdges({
        outer: 'parent'
      }),
      // minimum size
      interact.modifiers.restrictSize({
        min: {
          width: 100,
          height: minHeight
        }
      })]
    }).draggable({
      allowFrom: ".dialog__header",
      ignoreFrom: ".dialog__close",
      listeners: {
        move: this._onMoveResize
      },
      modifiers: this.isModal ? [] : [interact.modifiers.restrict({
        restriction: 'parent',
        endOnly: true
      })]
    });
  }

  /**
   * Inject application specific egw object with loaded translations into the dialog
   *
   * @param {string|egw} _egw_or_appname egw object with already loaded translations or application name to load translations for
   */
  _setApiInstance(_egw_or_appname) {
    if (typeof _egw_or_appname == 'undefined') {
      // @ts-ignore
      _egw_or_appname = egw_appName;
    }
    // if egw object is passed in because called from et2, just use it
    if (typeof _egw_or_appname != 'string') {
      this.__egw = _egw_or_appname;
    }
    // otherwise use given appname to create app-specific egw instance and load default translations
    else {
      this.__egw = egw$1(_egw_or_appname);
      this.egw().langRequireApp(this.egw().window, _egw_or_appname);
    }
  }
  egw() {
    if (this.__egw) {
      return this.__egw;
    } else {
      return super.egw();
    }
  }

  /**
   * Show a confirmation dialog
   *
   * @param {function} _callback Function called when the user clicks a button.  The context will be the et2_dialog widget, and the button constant is passed in.
   * @param {string} _message Message to be place in the dialog.
   * @param {string} _title Text in the top bar of the dialog.
   * @param _value passed unchanged to callback as 2. parameter
   * @param {integer|array} _buttons One of the BUTTONS_ constants defining the set of buttons at the bottom of the box
   * @param {integer} _type One of the message constants.  This defines the style of the message.
   * @param {string} _icon URL of an icon to display.  If not provided, a type-specific icon will be used.
   * @param {string|egw} _egw_or_appname egw object with already laoded translations or application name to load translations for
   *
   * @return {Et2Dialog} You can use dialog.getComplete().then(...) to wait for the dialog to close.
   */
  static show_dialog(_callback, _message, _title, _value, _buttons, _type, _icon, _egw_or_appname) {
    // Just pass them along, widget handles defaults & missing
    var dialog = document.createElement('et2-dialog');
    dialog._setApiInstance(_egw_or_appname);
    dialog.transformAttributes({
      callback: _callback || function () {},
      message: _message,
      title: _title || dialog.egw().lang('Confirmation required'),
      buttons: typeof _buttons != 'undefined' ? _buttons : Et2Dialog$1.BUTTONS_YES_NO,
      isModal: true,
      dialog_type: typeof _type != 'undefined' ? _type : Et2Dialog$1.QUESTION_MESSAGE,
      icon: _icon,
      value: _value
    });
    document.body.appendChild(dialog);
    return dialog;
  }
  /**
   * Show an alert message with OK button
   *
   * @param {string} _message Message to be place in the dialog.
   * @param {string} _title Text in the top bar of the dialog.
   * @param {integer} _type One of the message constants.  This defines the style of the message.
   *
   * @return Promise<[ button_id : number, value : Object ]> will resolve when the dialog closes
   */
  static alert(_message, _title, _type) {
    var dialog = document.createElement('et2-dialog');
    dialog._setApiInstance();
    dialog.transformAttributes({
      callback: function callback() {},
      message: _message,
      title: _title,
      buttons: Et2Dialog$1.BUTTONS_OK,
      isModal: true,
      dialog_type: _type || Et2Dialog$1.INFORMATION_MESSAGE
    });
    document.body.appendChild(dialog);
    return dialog.getComplete();
  }

  /**
   * Show a prompt dialog
   *
   * @param {function} _callback Function called when the user clicks a button.  The button constant is passed in along with the value.
   * @param {string} _message Message to be place in the dialog.
   * @param {string} _title Text in the top bar of the dialog.
   * @param {string} _value for prompt, passed to callback as 2. parameter
   * @param {integer|array} _buttons One of the BUTTONS_ constants defining the set of buttons at the bottom of the box
   * @param {string|egw} _egw_or_appname egw object with already laoded translations or application name to load translations for
   *
   * @return {Et2Dialog} You can use dialog.getComplete().then(...) to wait for the dialog to close.
   */
  static show_prompt(_callback, _message, _title, _value, _buttons, _egw_or_appname) {
    var dialog = document.createElement('et2-dialog');
    dialog._setApiInstance();
    dialog.transformAttributes({
      // Wrap callback to _only_ return _value.value, not the whole object like we normally would
      callback: function callback(_button_id, _value) {
        if (typeof _callback == "function") {
          _callback.call(this, _button_id, _value.value);
        }
      },
      title: _title || 'Input required',
      buttons: _buttons || Et2Dialog$1.BUTTONS_OK_CANCEL,
      isModal: true,
      value: {
        content: {
          value: _value,
          message: _message
        }
      },
      template: egw$1.webserverUrl + '/api/etemplate.php/api/templates/default/prompt.xet',
      class: "et2_prompt"
    });
    document.body.appendChild(dialog);
    return dialog;
  }

  /**
   * Method to build a confirmation dialog only with
   * YES OR NO buttons and submit content back to server
   *
   * @param {widget} _senders widget that has been clicked
   * @param {string} _dialogMsg message shows in dialog box
   * @param {string} _titleMsg message shows as a title of the dialog box
   * @param {boolean} _postSubmit true: use postSubmit instead of submit
   *
   * @description submit the form contents including the button that has been pressed
   */
  static confirm(_senders, _dialogMsg, _titleMsg, _postSubmit) {
    var senders = _senders;
    var button = _senders;
    var dialogMsg = typeof _dialogMsg != "undefined" ? _dialogMsg : '';
    var titleMsg = typeof _titleMsg != "undefined" ? _titleMsg : '';
    var egw = _senders instanceof et2_widget ? _senders.egw() : undefined;
    var callbackDialog = function callbackDialog(button_id) {
      if (button_id == Et2Dialog$1.YES_BUTTON) {
        if (_postSubmit) {
          senders.getRoot().getInstanceManager().postSubmit(button);
        } else if (senders.instanceOf(et2_button) && senders.getType() !== "buttononly") {
          senders.clicked = true;
          senders.getInstanceManager().submit(senders, false, senders.options.novalidate);
          senders.clicked = false;
        } else {
          senders.clicked = true;
          senders.getRoot().getInstanceManager().submit(button);
          senders.clicked = false;
        }
      }
    };
    Et2Dialog$1.show_dialog(callbackDialog, dialogMsg, titleMsg, {}, Et2Dialog$1.BUTTONS_YES_NO, Et2Dialog$1.WARNING_MESSAGE, undefined, egw);
  }
  /**
   * Show a dialog for a long-running, multi-part task
   *
   * Given a server url and a list of parameters, this will open a dialog with
   * a progress bar, asynchronously call the url with each parameter, and update
   * the progress bar.
   * Any output from the server will be displayed in a box.
   *
   * When all tasks are done, the callback will be called with boolean true.  It will
   * also be called if the user clicks a button (OK or CANCEL), so be sure to
   * check to avoid executing more than intended.
   *
   * @param {function} _callback Function called when the user clicks a button,
   *	or when the list is done processing.  The context will be the et2_dialog
   *	widget, and the button constant is passed in.
   * @param {string} _message Message to be place in the dialog.  Usually just
   *	text, but DOM nodes will work too.
   * @param {string} _title Text in the top bar of the dialog.
   * @param {string} _menuaction the menuaction function which should be called and
   * 	which handles the actual request. If the menuaction is a full featured
   * 	url, this one will be used instead.
   * @param {Array[]} _list - List of parameters, one for each call to the
   *	address.  Multiple parameters are allowed, in an array.
   * @param {string|egw} _egw_or_appname egw object with already laoded translations or application name to load translations for
   *
   * @return {et2_dialog}
   */
  static long_task(_callback, _message, _title, _menuaction, _list, _egw_or_appname) {
    // Special action for cancel
    var buttons = [
    // OK starts disabled
    {
      "button_id": Et2Dialog$1.OK_BUTTON,
      label: 'ok',
      "default": true,
      "disabled": true,
      image: "check"
    }, {
      "button_id": Et2Dialog$1.CANCEL_BUTTON,
      label: 'cancel',
      image: "cancel",
      click: function click() {
        // Cancel run
        cancel = true;
        jQuery("button[button_id=" + Et2Dialog$1.CANCEL_BUTTON + "]", dialog.div.parent()).button("disable");
        updateUi.call(_list.length, '');
      }
    }];
    var dialog = new Et2Dialog$1(_egw_or_appname);
    dialog.transformAttributes({
      template: dialog.egw().webserverUrl + '/api/etemplate.php/api/templates/default/long_task.xet',
      value: {
        content: {
          message: _message
        }
      },
      callback: function callback(_button_id, _value) {
        if (_button_id == Et2Dialog$1.CANCEL_BUTTON) {
          cancel = true;
        }
        if (typeof _callback == "function") {
          _callback.call(this, _button_id, _value.value);
        }
      },
      title: _title || 'please wait...',
      isModal: true,
      buttons: buttons
    });
    dialog.egw().window.document.body.appendChild(dialog);
    var log = null;
    var progressbar = null;
    var cancel = false;
    var totals = {
      success: 0,
      skipped: 0,
      failed: 0,
      widget: null
    };
    var success = [];
    var retryDialog = null;

    // Updates progressbar & log, returns next index
    var updateUi = function updateUi(response) {
      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      progressbar.set_value(100 * (index / _list.length));
      progressbar.set_label(index + ' / ' + _list.length);

      // Display response information
      switch (response.type) {
        case 'error':
          var div = document.createElement("DIV");
          div.className = "message error";
          div.textContent = response.data;
          log.appendChild(div);
          totals.failed++;

          // Ask to retry / ignore / abort
          var retry = new Et2Dialog$1(dialog.egw());
          var retry_index = null;
          retry.transformAttributes({
            callback: function callback(button) {
              switch (button) {
                case 'dialog[cancel]':
                  cancel = true;
                  break;
                case 'dialog[skip]':
                  totals.skipped++;
                  break;
                default:
                  // Try again with previous index
                  retry_index = index - 1;
              }
            },
            message: response.data,
            title: '',
            buttons: [
            // These ones will use the callback, just like normal
            {
              label: dialog.egw().lang("Abort"),
              id: 'dialog[cancel]'
            }, {
              label: dialog.egw().lang("Retry"),
              id: 'dialog[retry]'
            }, {
              label: dialog.egw().lang("Skip"),
              id: 'dialog[skip]',
              default: true
            }],
            dialog_type: Et2Dialog$1.ERROR_MESSAGE
          });
          dialog.egw().window.document.body.appendChild(retry);
          // Early exit
          retryDialog = retry.getComplete().then(() => {
            retryDialog = null;
            if (retry_index !== null) {
              sendRequest(retry_index);
            }
          });
        default:
          if (response && typeof response === "string") {
            success.push(_list[index - 1]);
            totals.success++;
            var _div = document.createElement("DIV");
            _div.className = "message";
            _div.textContent = response;
            log.appendChild(_div);
          } else if (response) {
            var _div2 = document.createElement("DIV");
            _div2.className = "message error";
            _div2.textContent = JSON.stringify(response);
            log.appendChild(_div2);
          }
      }
      // Scroll to bottom
      var height = log.scrollHeight;
      log.scrollTop = height;

      // Update totals
      totals.widget.set_value(dialog.egw().lang("Total: %1 Successful: %2 Failed: %3 Skipped: %4", _list.length, totals.success, totals.failed, totals.skipped));

      // Fire next step
      if (!cancel && index < _list.length) {
        return Promise.resolve(index);
      }
    };

    /** Send off the request for one item */
    var sendRequest = function sendRequest(index) {
      var request = null;
      var parameters = _list[index];
      if (typeof parameters != 'object') {
        parameters = [parameters];
      }

      // Set up timeout for 30 seconds
      var timeout_id = window.setTimeout(() => {
        // Abort request, we'll either skip it or try again
        if (request && request.abort) {
          request.abort();
        }
        updateUi({
          type: 'error',
          data: dialog.egw().lang("failed") + " " + parameters.join(" ")
        }, index + 1);
      }, 30000);

      // Async request, we'll take the next step in the callback
      // We can't pass index = 0, it looks like false and causes issues
      try {
        request = dialog.egw().json(_menuaction, parameters).sendRequest().then( /*#__PURE__*/function () {
          var _ref = _asyncToGenerator$e(function* (response) {
            if (response && response.response) {
              clearTimeout(timeout_id);
              for (var _value2 of response.response) {
                yield updateUi(_value2.type == "data" ? _value2.data : _value2, index + 1);
              }
            }
          });
          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }()).catch( /*#__PURE__*/function () {
          var _ref2 = _asyncToGenerator$e(function* (response) {
            var _response$message;
            clearTimeout(timeout_id);
            updateUi({
              type: 'error',
              data: (_response$message = response.message) !== null && _response$message !== void 0 ? _response$message : response
            }, index + 1);
          });
          return function (_x2) {
            return _ref2.apply(this, arguments);
          };
        }());
      } catch (e) {
        clearTimeout(timeout_id);
        request.abort();
        updateUi({
          type: 'error',
          data: dialog.egw().lang("No response from server: your data is probably NOT saved")
        }, index + 1);
      }
      return request;
    };
    // Wait for dialog, then start the process
    dialog.getUpdateComplete().then( /*#__PURE__*/_asyncToGenerator$e(function* () {
      // Get access to template widgets
      log = dialog.template.widgetContainer.getDOMWidgetById('log').getDOMNode();
      progressbar = dialog.template.widgetContainer.getWidgetById('progressbar');
      progressbar.set_label('0 / ' + _list.length);
      totals.widget = dialog.template.widgetContainer.getWidgetById('totals');
      for (var index = 0; index < _list.length && !cancel; index++) {
        yield sendRequest(index);
        if (retryDialog) {
          yield retryDialog;
        }
      }

      // All done
      if (!cancel) {
        progressbar.set_value(100);
      }

      // Disable cancel (it's too late), enable OK
      dialog.querySelector('et2-button[button_id="' + Et2Dialog$1.CANCEL_BUTTON + '"]').setAttribute("disabled", "");
      dialog.querySelector('et2-button[button_id="' + Et2Dialog$1.OK_BUTTON + '"]').removeAttribute("disabled");
      if (!cancel && typeof _callback == "function") {
        _callback.call(dialog, true, success);
      }
    }));
    return dialog;
  }
}

//@ts-ignore TS doesn't recognize Et2Dialog as HTMLEntry
/**
 * Types
 * @constant
 */
_defineProperty$1I(Et2Dialog$1, "PLAIN_MESSAGE", 0);
_defineProperty$1I(Et2Dialog$1, "INFORMATION_MESSAGE", 1);
_defineProperty$1I(Et2Dialog$1, "QUESTION_MESSAGE", 2);
_defineProperty$1I(Et2Dialog$1, "WARNING_MESSAGE", 3);
_defineProperty$1I(Et2Dialog$1, "ERROR_MESSAGE", 4);
/* Pre-defined Button combos */
_defineProperty$1I(Et2Dialog$1, "BUTTONS_OK", 0);
_defineProperty$1I(Et2Dialog$1, "BUTTONS_OK_CANCEL", 1);
_defineProperty$1I(Et2Dialog$1, "BUTTONS_YES_NO", 2);
_defineProperty$1I(Et2Dialog$1, "BUTTONS_YES_NO_CANCEL", 3);
/* Button constants */
_defineProperty$1I(Et2Dialog$1, "CANCEL_BUTTON", 0);
_defineProperty$1I(Et2Dialog$1, "OK_BUTTON", 1);
_defineProperty$1I(Et2Dialog$1, "YES_BUTTON", 2);
_defineProperty$1I(Et2Dialog$1, "NO_BUTTON", 3);
customElements.define("et2-dialog", Et2Dialog$1);
// make et2_dialog publicly available as we need to call it from templates
{
  window['et2_dialog'] = Et2Dialog$1;
  window['Et2Dialog'] = Et2Dialog$1;
}

function _defineProperty$1H(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The selectioManager is internally used by the et2_dataview_controller class
 * to manage the row selection.
 * As the action system does not allow selection of entries which are currently
 * not in the dom tree, we have to manage this in this class. The idea is to
 * manage an external action object interface for each visible row and proxy all
 * state changes between an dummy action object, that does no selection handling,
 * and the external action object interface.
 *
 * @augments Class
 */
class et2_dataview_selectionManager {
  /**
   * Constructor
   *
   * @param _parent
   * @param _indexMap
   * @param _actionObjectManager
   * @param _queryRangeCallback
   * @param _makeVisibleCallback
   * @param _context
   * @memberOf et2_dataview_selectionManager
   */
  constructor(_parent, _indexMap, _actionObjectManager, _queryRangeCallback, _makeVisibleCallback, _context) {
    _defineProperty$1H(this, "_parent", void 0);
    _defineProperty$1H(this, "_indexMap", void 0);
    _defineProperty$1H(this, "_actionObjectManager", void 0);
    _defineProperty$1H(this, "_makeVisibleCallback", void 0);
    _defineProperty$1H(this, "_queryRangeCallback", void 0);
    _defineProperty$1H(this, "select_callback", void 0);
    _defineProperty$1H(this, "_context", void 0);
    _defineProperty$1H(this, "_registeredRows", void 0);
    _defineProperty$1H(this, "_focusedEntry", void 0);
    _defineProperty$1H(this, "_invertSelection", void 0);
    _defineProperty$1H(this, "_selectAll", void 0);
    _defineProperty$1H(this, "_inUpdate", void 0);
    _defineProperty$1H(this, "_total", void 0);
    _defineProperty$1H(this, "_children", void 0);
    // Copy the arguments
    this._parent = _parent;
    this._indexMap = _indexMap;
    this._actionObjectManager = _actionObjectManager;
    this._queryRangeCallback = _queryRangeCallback;
    this._makeVisibleCallback = _makeVisibleCallback;
    this._context = _context;

    // Attach this manager to the parent manager if one is given
    if (this._parent) {
      this._parent._children.push(this);
    }

    // Use our selection instead of object manager's to handle not-loaded rows
    if (_actionObjectManager) {
      this._actionObjectManager.getAllSelected = jQuery.proxy(this.getAllSelected, this);
    }

    // Internal map which contains all curently selected uids and their
    // state
    this._registeredRows = {};
    this._focusedEntry = null;
    this._invertSelection = false;
    this._selectAll = false;
    this._inUpdate = false;
    this._total = 0;
    this._children = [];

    // Callback for when the selection changes
    this.select_callback = null;
  }
  destroy() {
    // If we have a parent, unregister from that
    if (this._parent) {
      var idx = this._parent._children.indexOf(this);
      this._parent._children.splice(idx, 1);
    }

    // Destroy all children
    for (var i = this._children.length - 1; i >= 0; i--) {
      this._children[i].destroy();
    }

    // Delete all still registered rows
    for (var key in this._registeredRows) {
      this.unregisterRow(key, this._registeredRows[key].tr);
    }
    this.select_callback = null;
  }
  clear() {
    for (var key in this._registeredRows) {
      this.unregisterRow(key, this._registeredRows[key].tr);
      delete this._registeredRows[key];
    }
    if (this._actionObjectManager) {
      this._actionObjectManager.clear();
    }
    for (key in this._indexMap) {
      delete this._indexMap[key];
    }
    this._total = 0;
    this._focusedEntry = null;
    this._invertSelection = false;
    this._selectAll = false;
    this._inUpdate = false;
  }
  setIndexMap(_indexMap) {
    this._indexMap = _indexMap;
  }
  setTotalCount(_total) {
    this._total = _total;
  }
  registerRow(_uid, _idx, _tr, _links) {
    // Get the corresponding entry from the registered rows array
    var entry = this._getRegisteredRowsEntry(_uid);

    // If the row has changed unregister the old one and do not delete
    // entry from the entry map
    if (entry.tr && entry.tr !== _tr) {
      this.unregisterRow(_uid, entry.tr, true);
    }

    // Create the AOI for the tr
    if (!entry.tr && _links) {
      this._attachActionObjectInterface(entry, _tr, _uid);
      this._attachActionObject(entry, _tr, _uid, _links, _idx);
    }

    // Update the entry
    if (entry.ao) entry.ao._index;
    entry.idx = _idx;
    entry.tr = _tr;

    // Update the visible state of the _tr
    this._updateEntryState(entry, entry.state);
  }
  unregisterRow(_uid, _tr, _noDelete) {
    // _noDelete defaults to false
    _noDelete = _noDelete ? true : false;
    if (typeof this._registeredRows[_uid] !== "undefined" && this._registeredRows[_uid].tr === _tr) {
      this._inUpdate = true;

      // Don't leave focusedEntry
      // @ts-ignore
      if (this._focusedEntry !== null && this._focusedEntry.uid == _uid) {
        this.setFocused(_uid, false);
      }
      this._registeredRows[_uid].tr = null;
      this._registeredRows[_uid].aoi = null;

      // Remove the action object from its container
      if (this._registeredRows[_uid].ao) {
        this._registeredRows[_uid].ao.remove();
        this._registeredRows[_uid].ao = null;
      }
      if (!_noDelete && this._registeredRows[_uid].state === EGW_AO_STATE_NORMAL) {
        delete this._registeredRows[_uid];
      }
      this._inUpdate = false;
    }
  }
  resetSelection() {
    this._invertSelection = false;
    this._selectAll = false;
    this._actionObjectManager.setAllSelected(false);
    for (var key in this._registeredRows) {
      this.setSelected(key, false);
    }
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].resetSelection();
    }
  }
  setSelected(_uid, _selected) {
    this._selectAll = false;
    var entry = this._getRegisteredRowsEntry(_uid);
    this._updateEntryState(entry, egwSetBit(entry.state, EGW_AO_STATE_SELECTED, _selected));
  }
  getAllSelected() {
    var selected = this.getSelected();
    return selected.all || selected.ids.length === this._total;
  }
  setFocused(_uid, _focused) {
    // Reset the state of the currently focused entry
    if (this._focusedEntry) {
      this._updateEntryState(this._focusedEntry, egwSetBit(this._focusedEntry.state, EGW_AO_STATE_FOCUSED, false));
      this._focusedEntry = null;
    }
    // Mark the new given uid as focused
    if (_focused) {
      //console.log('et2_dataview_controller_selection::setFocused -> UID:'+_uid+' is focused by:'+this._actionObjectManager.name);
      var entry = this._focusedEntry = this._getRegisteredRowsEntry(_uid);
      this._updateEntryState(entry, egwSetBit(entry.state, EGW_AO_STATE_FOCUSED, true));
    }
  }
  selectAll() {
    // Reset the selection
    this.resetSelection();
    this._selectAll = true;

    // Run as a range if there's less then the max
    if (egw$1.dataKnownUIDs(this._context._dataProvider.dataStorePrefix).length !== this._total && this._total <= et2_dataview_selectionManager.MAX_SELECTION) {
      this._selectRange(0, this._total);
    }
    // Tell action manager to do all
    this._actionObjectManager.setAllSelected(true);

    // Update the selection
    for (var key in this._registeredRows) {
      var entry = this._registeredRows[key];
      this._updateEntryState(entry, entry.state);
    }
    this._selectAll = true;
  }
  getSelected() {
    // Collect all currently selected ids
    var ids = [];
    for (var key in this._registeredRows) {
      if (egwBitIsSet(this._registeredRows[key].state, EGW_AO_STATE_SELECTED)) {
        ids.push(key);
      }
    }

    // Push all events of the child managers onto the list
    for (var i = 0; i < this._children.length; i++) {
      ids = ids.concat(this._children[i].getSelected().ids);
    }

    // Return an array containing those ids
    // RB: we are currently NOT using "inverted"
    return {
      //"inverted": this._invertSelection,
      "all": this._selectAll,
      "ids": ids
    };
  }

  /** -- PRIVATE FUNCTIONS -- **/

  _attachActionObjectInterface(_entry, _tr, _uid) {
    // Create the AOI which is used internally in the selection manager
    // this AOI is not connected to the AO, as the selection manager
    // cares about selection etc.
    _entry.aoi = new et2_dataview_rowAOI(_tr);
    _entry.aoi.setStateChangeCallback(function (_newState, _changedBit, _shiftState) {
      if (_changedBit === EGW_AO_STATE_SELECTED) {
        // Call the select handler
        this._handleSelect(_uid, _entry, egwBitIsSet(_shiftState, EGW_AO_SHIFT_STATE_BLOCK), egwBitIsSet(_shiftState, EGW_AO_SHIFT_STATE_MULTI));
      }
    }, this);
  }
  _getDummyAOI(_entry, _tr, _uid, _idx) {
    // Create AOI
    var dummyAOI = new egwActionObjectInterface();
    var self = this;

    // Handling for Action Implementations updating the state
    dummyAOI.doSetState = function (_state) {
      if (!self._inUpdate) {
        // Update the "focused" flag
        self.setFocused(_uid, egwBitIsSet(_state, EGW_AO_STATE_FOCUSED));

        // Generally update the state
        self._updateState(_uid, _state);
      }
    };

    // Handle the "make visible" event, pass the request to the parent
    // controller
    dummyAOI.doMakeVisible = function () {
      self._makeVisibleCallback.call(self._context, _idx);
    };

    // Connect the the two AOIs
    dummyAOI.doTriggerEvent = _entry.aoi.doTriggerEvent;

    // Implementation of the getDOMNode function, so that the event
    // handlers can be properly bound
    dummyAOI.getDOMNode = function () {
      return _tr;
    };
    return dummyAOI;
  }
  _attachActionObject(_entry, _tr, _uid, _links, _idx) {
    // Get the dummyAOI which connects the action object to the tr but
    // does no selection handling
    var dummyAOI = this._getDummyAOI(_entry, _tr, _uid, _idx);

    // Create an action object for the tr and connect it to a dummy AOI
    if (this._actionObjectManager) {
      if (this._actionObjectManager.getObjectById(_uid)) {
        var state = _entry.state;
        this._actionObjectManager.getObjectById(_uid).remove();
        _entry.state = state;
      }
      _entry.ao = this._actionObjectManager.addObject(_uid, dummyAOI);
    }

    // Force context (actual widget) in here, it's the last place it's available
    _entry.ao._context = this._context;
    _entry.ao.updateActionLinks(_links);
    _entry.ao._index = _idx;

    // Overwrite some functions like "traversePath", "getNext" and
    // "getPrevious"
    var self = this;
    function getIndexAO(_idx) {
      // Check whether the index is in the index map
      if (typeof self._indexMap[_idx] !== "undefined" && self._indexMap[_idx].uid) {
        return self._getRegisteredRowsEntry(self._indexMap[_idx].uid).ao;
      }
      return null;
    }
    function getElementRelatively(_step) {
      var total = self._total || Object.keys(self._indexMap).length;
      var max_index = Math.max.apply(Math, Object.keys(self._indexMap));
      // Get a reasonable number of iterations - not all
      var count = Math.max(1, Math.min(self._total, 50));
      var element = null;
      var idx = _entry.idx;
      while (element == null && count > 0 && max_index > 0) {
        count--;
        element = getIndexAO(Math.max(0, Math.min(max_index, idx += _step)));
      }
      return element;
    }
    _entry.ao.getPrevious = function (_step) {
      return getElementRelatively(-_step);
    };
    _entry.ao.getNext = function (_step) {
      return getElementRelatively(_step);
    };
    _entry.ao.traversePath = function (_obj) {
      // Get the start and the stop index
      var s = Math.min(this._index, _obj._index);
      var e = Math.max(this._index, _obj._index);
      var result = [];
      for (var i = s; i < e; i++) {
        var ao = getIndexAO(i);
        if (ao) {
          result.push(ao);
        }
      }
      return result;
    };
  }
  _updateState(_uid, _state) {
    var entry = this._getRegisteredRowsEntry(_uid);
    this._updateEntryState(entry, _state);
    return entry;
  }
  _updateEntryState(_entry, _state) {
    if (this._selectAll) {
      _state |= EGW_AO_STATE_SELECTED;
    } else if (this._invertSelection) {
      _state ^= EGW_AO_STATE_SELECTED;
    }

    // Attach ao if not there, happens for rows loaded for selection, but
    // not displayed yet
    if (!_entry.ao && _entry.uid && this._actionObjectManager) {
      var _links = [];
      for (var key in this._registeredRows) {
        if (this._registeredRows[key].ao && this._registeredRows[key].ao.actionLinks) {
          _links = this._registeredRows[key].ao.actionLinks;
          break;
        }
      }
      if (_links.length) {
        this._attachActionObjectInterface(_entry, null, _entry.uid);
        this._attachActionObject(_entry, null, _entry.uid, _links, _entry.idx);
      }
    }

    // Update the state if it has changed
    if (_entry.aoi && _entry.aoi.getState() !== _state || _entry.state != _state) {
      this._inUpdate = true; // Recursion prevention

      // Update the state of the action object
      if (_entry.ao) {
        _entry.ao.setSelected(egwBitIsSet(_state, EGW_AO_STATE_SELECTED));
        _entry.ao.setFocused(egwBitIsSet(_state, EGW_AO_STATE_FOCUSED));
      }
      this._inUpdate = false;

      // Delete the element if state was set to "NORMAL" and there is
      // no tr
      if (_state === EGW_AO_STATE_NORMAL && !_entry.tr) {
        delete this._registeredRows[_entry.uid];
      }
    }

    // Update the visual state
    if (_entry.aoi && _entry.aoi.doSetState) {
      _entry.aoi.doSetState(_state);
    }

    // Update the state of the entry
    _entry.state = _state;
  }
  _getRegisteredRowsEntry(_uid) {
    if (typeof this._registeredRows[_uid] === "undefined") {
      this._registeredRows[_uid] = {
        "uid": _uid,
        "idx": null,
        "state": EGW_AO_STATE_NORMAL,
        "tr": null,
        "aoi": null,
        "ao": null
      };
    }
    return this._registeredRows[_uid];
  }
  _handleSelect(_uid, _entry, _shift, _ctrl) {
    // If not "_ctrl" is set, reset the selection
    if (!_ctrl) {
      var top = this;
      while (top._parent !== null) {
        top = top._parent;
      }
      top.resetSelection();
      this._actionObjectManager.setAllSelected(false); // needed for hirachical stuff
    }

    // Mark the element that was clicked as selected
    var entry = this._getRegisteredRowsEntry(_uid);
    this.setSelected(_uid, !_ctrl || !egwBitIsSet(entry.state, EGW_AO_STATE_SELECTED));

    // Focus the element if shift is not pressed
    if (!_shift) {
      this.setFocused(_uid, true);
    } else if (this._focusedEntry) {
      this._selectRange(this._focusedEntry.idx, _entry.idx);
    }
    if (this.select_callback && typeof this.select_callback == "function") {
      this.select_callback.apply(this._context, arguments);
    }
  }
  _selectRange(_start, _stop) {
    // Contains ranges that are not currently in the index map and that have
    // to be queried
    var queryRanges = [];

    // Iterate over the given range and select the elements in the range
    // from _start to _stop
    var naStart = false;
    var s = Math.min(_start, _stop);
    var e = Math.max(_stop, _start);
    var RANGE_MAX = 50;
    var range_break = s + RANGE_MAX;
    for (var i = s; i <= e; i++) {
      if (typeof this._indexMap[i] !== "undefined" && this._indexMap[i].uid && egw$1.dataGetUIDdata(this._indexMap[i].uid)) {
        // Add the range to the "queryRanges"
        if (naStart !== false) {
          queryRanges.push(et2_bounds(naStart, i - 1));
          naStart = false;
          range_break += RANGE_MAX;
        }

        // Select the element, unless flagged for exclusion
        // Check for no_actions flag via data
        var data = egw$1.dataGetUIDdata(this._indexMap[i].uid);
        if (data && data.data && !data.data.no_actions) {
          this.setSelected(this._indexMap[i].uid, true);
        }
      } else if (naStart === false) {
        naStart = i;
        range_break = naStart + RANGE_MAX;
      } else if (i >= range_break) {
        queryRanges.push(et2_bounds(naStart ? naStart : s, i - 1));
        naStart = i;
        range_break += RANGE_MAX;
      }
    }

    // Add the last range to the "queryRanges"
    if (naStart !== false) {
      queryRanges.push(et2_bounds(naStart, i - 1));
      naStart = false;
    }

    // Query all unknown ranges from the server
    if (queryRanges.length > 0) {
      this._query_ranges(queryRanges);
    }
  }
  _query_ranges(queryRanges) {
    var that = this;
    var record_count = 0;
    var range_index = 0;
    var range_count = queryRanges.length;
    var cont = true;
    var fetchResolver;
    var fetchPromise = new Promise(function (resolve) {
      fetchResolver = resolve;
    });
    var fetchList = [fetchPromise];
    // Found after dialog loads
    var progressbar;
    var dialog = new Et2Dialog$1(this._context._widget.egw());
    dialog.transformAttributes({
      callback:
      // Abort the long task if they canceled the data load
      function callback() {
        cont = false;
      },
      template: egw$1.webserverUrl + '/api/templates/default/long_task.xet',
      message: egw$1.lang('Loading'),
      title: egw$1.lang('please wait...'),
      buttons: [{
        button_id: Et2Dialog$1.CANCEL_BUTTON,
        label: egw$1.lang('cancel'),
        id: 'dialog[cancel]',
        image: 'cancel'
      }],
      width: 300
    });
    (this._context._widget.getDOMNode() || document.body).append(dialog);
    dialog.updateComplete.then(() => {
      dialog.template.DOMContainer.addEventListener('load', () => {
        // Get access to template widgets
        progressbar = dialog.template.widgetContainer.getWidgetById('progressbar');
        var rangePromise = fetchPromise;
        for (var i = 0; i < queryRanges.length; i++) {
          if (record_count + (queryRanges[i].bottom - queryRanges[i].top + 1) > et2_dataview_selectionManager.MAX_SELECTION) {
            egw$1.message(egw$1.lang('Too many rows selected.<br />Select all, or less than %1 rows', et2_dataview_selectionManager.MAX_SELECTION));
            break;
          } else {
            record_count += queryRanges[i].bottom - queryRanges[i].top + 1;
            // We want to chain these one after the other, not fire them all right away
            rangePromise = rangePromise.then(function () {
              // Check for abort
              if (!cont) {
                return;
              }
              return new Promise(function (resolve) {
                that._queryRangeCallback.call(that._context, this, function (_order) {
                  for (var j = 0; j < _order.length; j++) {
                    // Check for no_actions flag via data since entry isn't there/available
                    var data = egw$1.dataGetUIDdata(_order[j]);
                    if (!data || data && data.data && !data.data.no_actions) {
                      var entry = this._getRegisteredRowsEntry(_order[j]);
                      this._updateEntryState(entry, egwSetBit(entry.state, EGW_AO_STATE_SELECTED, true));
                    }
                  }
                  progressbar.set_value(100 * (++range_index / range_count));
                  resolve();
                }, that);
              }.bind(this));
            }.bind(queryRanges[i]));
            fetchList.push(rangePromise);
          }
        }

        // Start the first fetch
        fetchResolver();
        Promise.all(fetchList).finally(function () {
          dialog.close();
        });
      });
    });
  }
}
// Maximum number of rows we can safely fetch for selection
// Actual selection may have more rows if we already have some
_defineProperty$1H(et2_dataview_selectionManager, "MAX_SELECTION", 1000);

function _defineProperty$1G(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The fetch timeout specifies the time during which the controller tries to
 * consolidate requests for rows.
 */
var ET2_DATAVIEW_FETCH_TIMEOUT = 50;
var ET2_DATAVIEW_STEPSIZE = 50;

/**
 * The et2_dataview_controller class is the intermediate layer between a grid
 * instance and the corresponding data source. It manages updating the grid,
 * as well as inserting and deleting rows.
 */
class et2_dataview_controller {
  /**
   * Constructor of the et2_dataview_controller, connects to the grid
   * callback.
   *
   * @param _grid is the grid the controller should controll.
   * @param _rowCallback is the callback function that gets called when a row
   * is requested.
   * @param _linkCallback is the callback function that gets called for
   * requesting action links for a row. The row data, the index of the row and
   * the uid are passed as parameters to the function.
   * uid is passed to the function.
   * @param _actionObjectManager is the object that manages the action
   * objects.
   */
  constructor(_parentController, _grid) {
    _defineProperty$1G(this, "_parentController", void 0);
    _defineProperty$1G(this, "_grid", void 0);
    _defineProperty$1G(this, "dataStorePrefix", void 0);
    _defineProperty$1G(this, "_dataProvider", void 0);
    _defineProperty$1G(this, "_rowCallback", void 0);
    _defineProperty$1G(this, "_linkCallback", void 0);
    _defineProperty$1G(this, "_context", void 0);
    _defineProperty$1G(this, "_children", void 0);
    _defineProperty$1G(this, "_indexMap", {});
    _defineProperty$1G(this, "_queueTimer", void 0);
    _defineProperty$1G(this, "_lastModification", void 0);
    _defineProperty$1G(this, "_queue", void 0);
    _defineProperty$1G(this, "_request_queue", void 0);
    _defineProperty$1G(this, "_selectionMgr", void 0);
    _defineProperty$1G(this, "_objectManager", void 0);
    _defineProperty$1G(this, "hasData", void 0);
    // Copy the given arguments
    this._parentController = _parentController;
    this._grid = _grid;

    // Initialize list of child controllers
    this._children = [];

    // Initialize the "index map" which contains all currently displayed
    // containers hashed by the "index"
    this._indexMap = {};

    // Timer used for queing fetch requests
    this._queueTimer = null;

    // Array which contains all currently queued row indices in the form of
    // an associative array
    this._queue = {};

    // Current concurrent requests we have
    this._request_queue = [];

    // Register the dataFetch callback
    this._grid.setDataCallback(this._gridCallback, this);

    // Record the child
    if (this._parentController != null) {
      this._parentController._children.push(this);
    }
  }
  destroy() {
    // Destroy the selection manager
    this._selectionMgr.destroy();

    // Clear the selection timeout
    this._clearTimer();

    // Remove the child from the child list
    if (this._parentController != null) {
      var idx = this._parentController._children.indexOf(this);
      if (idx >= 0) {
        // This element is no longer parent of the child
        this._parentController._children.splice(idx, 1);
        this._parentController = null;
      }
    }
    this._grid = null;
  }

  /**
   * @param value is an object implementing the et2_IDataProvider
   * interface
   */
  setDataProvider(value) {
    this._dataProvider = value;
  }
  setRowCallback(value) {
    this._rowCallback = value;
  }
  setLinkCallback(value) {
    this._linkCallback = value;
  }

  /**
   * @param value is the context in which the _rowCallback and the
   * _linkCallback are called.
   */
  setContext(value) {
    this._context = value;
  }
  setActionObjectManager(_actionObjectManager) {
    if (this._selectionMgr) {
      this._selectionMgr.destroy();
    }

    // Create the selection manager
    this._selectionMgr = new et2_dataview_selectionManager(this._parentController ? this._parentController._selectionMgr : null, this._indexMap, _actionObjectManager, this._selectionFetchRange, this._makeIndexVisible, this);
  }

  /**
   * The update function queries the server for changes in the currently
   * managed index range -- those changes are then merged into the current
   * view without a complete rebuild of every row.
   *
   * @param {boolean} clear Skip the fancy stuff, dump everything and start again.
   *		Completely clears the grid and selection.
   */
  update(clear) {
    // Avoid update after destroy
    // Happens sometimes if AJAX response comes after etemplate unload
    if (!this._grid) return;

    // ---------

    // TODO: Actually stuff here should be done if the server responds that
    // there at all were some changes (needs implementation of "refresh")

    // Tell the grid not to try and update itself while we do this
    this._grid.doInvalidate = false;
    if (clear) {
      // Scroll to top
      this._grid.makeIndexVisible(0);
      this._grid.clear();

      // Free selection manager
      this._selectionMgr.clear();

      // Clear object manager
      this._objectManager.clear();

      // Clear the map
      this._indexMap = {};
      // Update selection manager, it uses this by reference
      this._selectionMgr.setIndexMap(this._indexMap);

      // Clear the queue
      this._queue = {};

      // Invalidate the change detection, re-fetches any known rows
      this._lastModification = 0;
    }
    // Remove all rows which are outside the view range
    this._grid.cleanup();

    // Get the currently visible range from the grid
    var range = this._grid.getIndexRange();

    // Force range.top and range.bottom to contain an integer
    if (range.top === false) {
      range.top = range.bottom = 0;
    }
    this._request_queue = [];

    // Require that range from the server
    this._queueFetch(et2_bounds(range.top, clear ? 0 : range.bottom + 1), 0, true);
  }

  /**
   * Rebuilds the complete grid.
   */
  reset() {
    // Throw away all internal mappings and reset the timestamp
    this._indexMap = {};
    // Update selection manager, it uses this by reference
    this._selectionMgr.setIndexMap(this._indexMap);

    // Clear the grid
    this._grid.clear();

    // Clear the row queue
    this._queue = {};

    // Reset the request queue
    this._request_queue = [];

    // Update the data
    this.update();
  }

  /**
   * Loads the initial order. Do not call multiple times.
   */
  loadInitialOrder(order) {
    for (var i = 0; i < order.length; i++) {
      this._getIndexEntry(i).uid = order[i];
    }
  }

  /**
   * Load initial data
   *
   * @param {string} uid_key Name of the unique row identifier field
   * @param {Object} data Key / Value mapping of initial data.
   */
  loadInitialData(uid_prefix, uid_key, data) {
    var idx = 0;
    for (var key in data) {
      // Skip any extra keys
      if (typeof data[key] != "object" || data[key] == null || typeof data[key][uid_key] == "undefined") continue;

      // Add to row / uid map
      var entry = this._getIndexEntry(idx++);
      entry.uid = data[key][uid_key] + "";
      if (entry.uid.indexOf(uid_prefix) < 0) {
        entry.uid = uid_prefix + "::" + entry.uid;
      }

      // Add to data cache so grid will find it
      egw$1.dataStoreUID(entry.uid, data[key]);

      // Don't try to insert the rows, grid will do that automatically
    }

    if (idx == 0) {
      // No rows, start with an empty
      this._selectionMgr.clear();
      this._emptyRow(this._grid._total == 0);
    }
  }

  /**
   * Returns the depth of the controller instance.
   */
  getDepth() {
    if (this._parentController) {
      return this._parentController.getDepth() + 1;
    }
    return 0;
  }

  /**
   * Set the data cache prefix
   * The default is to use appname, but if you need to set it explicitly to
   * something else to avoid conflicts.  Use the same prefix everywhere for
   * each type of data.  eg. infolog for infolog entries, even if accessed via addressbook
   */
  setPrefix(prefix) {
    this.dataStorePrefix = prefix;
  }

  /**
   * Returns the row information of the passed node, or null if not available
   *
   * @param {DOMNode} node
   * @return {string|false} UID, or false if not found
   */
  getRowByNode(node) {
    // Whatever the node, find a TR
    var row_node = jQuery(node).closest('tr');
    var row = null;

    // Check index map - simple case
    var indexed = this._getIndexEntry(row_node.index());
    if (indexed && indexed.row && indexed.row.getDOMNode() == row_node[0]) {
      row = indexed;
    } else {
      // Check whole index map
      for (var index in this._indexMap) {
        indexed = this._indexMap[index];
        if (indexed && indexed.row && indexed.row.getDOMNode() == row_node[0]) {
          row = indexed;
          break;
        }
      }
    }

    // Check children
    for (var i = 0; !row && i < this._children.length; i++) {
      var child_row = this._children[i].getRowByNode(node);
      if (child_row !== false) row = child_row;
    }
    if (row && !row.controller) {
      row.controller = this;
    }
    return row;
  }

  /**
   * Returns the current "total" count.
   */
  getTotalCount() {
    return this._grid.getTotalCount();
  }

  /* -- PRIVATE FUNCTIONS -- */

  _getIndexEntry(_idx) {
    // Create an entry in the index map if it does not exist yet
    if (typeof this._indexMap[_idx] === "undefined") {
      this._indexMap[_idx] = {
        "row": null,
        "uid": null
      };
    }

    // Always update the index of the entries before returning them. This is
    // neccessary, as when we remove the uid from an entry without row, its
    // index does not get updated any further
    this._indexMap[_idx]["idx"] = _idx;
    return this._indexMap[_idx];
  }

  /**
   * Inserts a new data row into the grid. index and uid are derived from the
   * given management entry. If the data for the given uid does not exist yet,
   * a "loading" placeholder will be shown instead. The function will do
   * nothing if there already is a row associated to the entry. This function
   * will not re-insert a row if the entry already had a row.
   *
   * @param _entry is the management entry for the index the row will be
   * displayed at.
   * @param _update specifies whether the row should be updated if _entry.row
   * already exists.
   * @return true, if all data for the row has been available, false
   * otherwise.
   */
  _insertDataRow(_entry, _update) {
    // Abort if the entry already has a row but the _insert flag is not set
    if (_entry.row && !_update) {
      return true;
    }

    // Context used for the callback functions
    var ctx = {
      "self": this,
      "entry": _entry
    };

    // Create a new row instance, if it does not exist yet
    var createdRow = false;
    if (!_entry.row) {
      createdRow = true;
      _entry.row = this._createRow(ctx);
      _entry.row.setDestroyCallback(this._destroyCallback, ctx);
    }

    // Load the row data if we have a uid for the entry
    this.hasData = false; // Gets updated by the _dataCallback
    if (_entry.uid) {
      // Register the callback / immediately load the data
      this._dataProvider.dataRegisterUID(_entry.uid, this._dataCallback, ctx);
    }

    // Display the loading "row prototype" if we don't have data for the row
    if (!this.hasData) {
      // Get the average height, the "-5" derives from the td padding
      var avg = Math.round(this._grid.getAverageHeight() - 5) + "px";
      var prototype = this._grid.getRowProvider().getPrototype("loading");
      jQuery("div", prototype).css("height", avg);
      var node = _entry.row.getJNode();
      node.empty();
      node.append(prototype.children());
    }

    // Insert the row into the table -- the same row must never be inserted
    // twice into the grid, so this function only executes the following
    // code only if it is a newly created row.
    if (createdRow && _entry.row) {
      this._grid.insertRow(_entry.idx, _entry.row);
    }

    // Remove 'No matches found' row
    var row = jQuery(".egwGridView_empty", this._grid.innerTbody).remove();
    if (row.length) {
      this._selectionMgr.unregisterRow("", 0);
    }

    // Update index map only for push (autorefresh disabled)
    if (this._indexMap[_entry.idx] && this._indexMap[_entry.idx].uid !== _entry.uid) {
      var max = parseInt(Object.keys(this._indexMap).reduce((a, b) => this._indexMap[a] > this._indexMap[b] ? a : b));
      for (var idx = max; idx >= _entry.idx; idx--) {
        var entry = this._indexMap[idx];
        this._indexMap[idx].idx = idx + 1;
        this._indexMap[this._indexMap[idx].idx] = this._indexMap[idx];
        if (this._selectionMgr && this._selectionMgr._registeredRows[entry.uid]) {
          this._selectionMgr._registeredRows[entry.uid].idx = entry.idx;
        }
      }
    }
    this._indexMap[_entry.idx] = _entry;
    return this.hasData;
  }

  /**
   * Create a new row.
   *
   * @param {type} ctx
   * @returns {et2_dataview_container}
   */
  _createRow(ctx) {
    return new et2_dataview_row(this._grid);
  }

  /**
   * Function which gets called by the grid when data is requested.
   *
   * @param _idxStart is the index of the first row for which data is
   * requested.
   * @param _idxEnd is the index of the last requested row.
   */
  _gridCallback(_idxStart, _idxEnd) {
    var needsData = false;

    // Iterate over all elements the dataview requested and create a row
    // which indicates that we are currently loading data
    for (var i = _idxStart; i <= _idxEnd; i++) {
      var entry = this._getIndexEntry(i);

      // Insert the row for the entry -- do not update rows which are
      // already existing, as we do not have new data for those.
      if (!this._insertDataRow(entry, false) && needsData === false) {
        needsData = i;
      }
    }

    // Queue fetching that data range
    if (needsData !== false) {
      this._queueFetch(et2_bounds(needsData, _idxEnd + 1), needsData == _idxStart ? 0 : needsData > _idxStart ? 1 : -1, false);
    }
  }

  /**
   * The _queueFetch function is used to queue a fetch request.
   * TODO: Refresh is currently not used
   */
  _queueFetch(_range, _direction, _isUpdate) {
    // Force immediate to be false
    _isUpdate = _isUpdate ? _isUpdate : false;

    // Push the requests onto the request queue
    var start = Math.max(0, _range.top);
    var end = Math.min(this._grid.getTotalCount(), _range.bottom);
    for (var i = start; i < end; i++) {
      if (typeof this._queue[i] === "undefined") {
        this._queue[i] = _direction; // Stage 1 - queue for after current, -1 -- queue for before current
      }
    }

    // Start the queue timer, if this has not already been done
    if (this._queueTimer === null && !_isUpdate) {
      var self = this;
      egw$1.debug('log', 'Dataview queue: ', _range);
      this._queueTimer = window.setTimeout(function () {
        self._flushQueue(false);
      }, ET2_DATAVIEW_FETCH_TIMEOUT);
    }
    if (_isUpdate) {
      this._flushQueue(true);
    }
  }

  /**
   * Flushes the queue.
   */
  _flushQueue(_isUpdate) {
    // Clear any still existing timer
    this._clearTimer();

    // Mark all elements in a radius of ET2_DATAVIEW_STEPSIZE
    var marked = {};
    var r = _isUpdate ? 0 : Math.floor(ET2_DATAVIEW_STEPSIZE / 2);
    var total = this._grid.getTotalCount();
    for (var key in this._queue) {
      if (this._queue[key] > 1) continue;
      key = parseInt(key);
      var b = Math.max(0, key - r + r * this._queue[key]);
      var t = Math.min(key + r + r * this._queue[key], total - 1);
      var c = 0;
      for (var i = b; i <= t && c < ET2_DATAVIEW_STEPSIZE; i++) {
        if (typeof this._queue[i] == "undefined" || this._queue[i] <= 1) {
          this._queue[i] = 2; // Stage 2 -- pending or available
          marked[i] = true;
          c++;
        }
      }
    }

    // Create a list with start indices and counts
    var fetchList = [];
    var entry = null;
    var last = 0;

    // Get the int keys and sort the array numeric
    var arr = et2_arrayIntKeys(marked).sort(function (a, b) {
      return a > b ? 1 : a == b ? 0 : -1;
    });
    for (var i = 0; i < arr.length; i++) {
      if (i == 0 || arr[i] - last > 1) {
        if (entry) {
          fetchList.push(entry);
        }
        entry = {
          "start": arr[i],
          "count": 1
        };
      } else {
        entry.count++;
      }
      last = arr[i];
    }
    if (entry) {
      fetchList.push(entry);
    }

    // Special case: If there are no entries in the fetch list and this is
    // an update, create an dummy entry, so that we'll get the current count
    if (fetchList.length === 0 && _isUpdate) {
      fetchList.push({
        "start": 0,
        "count": 0
      });

      // Disable grid invalidate, or it might request again before we're done
      this._grid.doInvalidate = false;
    }
    egw$1.debug("log", "Dataview flush", fetchList);
    // Execute all queries
    for (var i = 0; i < fetchList.length; i++) {
      // Build the query
      var query = {
        "start": fetchList[i].start,
        "num_rows": fetchList[i].count,
        "refresh": false
      };

      // Context used in the callback function
      var ctx = {
        "self": this,
        "start": query.start,
        "count": query.num_rows,
        "lastModification": this._lastModification,
        prefix: undefined
      };
      if (this.dataStorePrefix) {
        ctx.prefix = this.dataStorePrefix;
      }
      this._queueRequest(query, ctx);
    }
  }

  /**
   * Queue a request for data
   * @param {Object} query
   * @param {Object} ctx
   */
  _queueRequest(query, ctx) {
    this._request_queue.push({
      query: query,
      context: ctx,
      // Start pending, set to 1 when request sent
      status: 0
    });
    this._fetchQueuedRequest();
  }

  /**
   * Fetch data for a queued request, subject to rate limit
   */
  _fetchQueuedRequest() {
    // Check to see if there's room
    var count = 0;
    for (var i = 0; i < this._request_queue.length; i++) {
      if (this._request_queue[i].status > 0) count++;
    }
    // Too many requests, will try again after response is received
    if (count >= et2_dataview_controller.CONCURRENT_REQUESTS || this._request_queue.length === 0) {
      return;
    }

    // Keep at least 1 previous pending
    var keep = 1;

    // The most recent is the one the user's most interested in
    var request = null;
    for (var i = this._request_queue.length - 1; i >= 0; i--) {
      // Only interested in pending requests (status 0)
      if (this._request_queue[i].status != 0) {
        continue;
      }
      if (request == null) {
        request = this._request_queue[i];
      } else if (keep > 0) {
        keep--;
      } else if (keep <= 0) {
        // Cancel pending, they've probably scrolled past.
        this._request_queue.splice(i, 1);
      }
    }
    if (request == null) return;

    // Request being sent
    request.status = 1;

    // Call the callback
    this._dataProvider.dataFetch(request.query, this._fetchCallback, request.context);
  }
  _clearTimer() {
    // Reset the queue timer upon destruction
    if (this._queueTimer) {
      window.clearTimeout(this._queueTimer);
      this._queueTimer = null;
    }
  }

  /**
   * Called by the data source when the data changes
   *
   * @param _data Object|null New data, or null.  Null will remove the row.
   */
  _dataCallback(_data) {
    // Set the "hasData" flag
    this.self.hasData = true;

    // Call the row callback with the new data -- the row callback then
    // generates the row DOM nodes that will be inserted into the grid
    if (this.self._rowCallback) {
      // Remove everything from the current row
      this.entry.row.clear();

      // If there's no data, stop
      if (typeof _data == "undefined" || _data == null) {
        this.self._destroyCallback.call(this, this.entry.row);
        return;
      }

      // Fill the row DOM Node with data
      this.self._rowCallback.call(this.self._context, _data, this.entry.row, this.entry.idx, this.entry);

      // Attach the "subgrid" tag to the row, if the depth of this
      // controller is larger than zero
      var tr = this.entry.row.getDOMNode();
      var d = this.self.getDepth();
      if (d > 0) {
        jQuery(tr).addClass("subentry");
        jQuery("td:first", tr).children("div").last().addClass("level_" + d + " indentation");
        if (this.entry.idx == 0) {
          // Set the CSS for the level - required so columns line up
          var indent = jQuery("<span class='indentation'/>").appendTo('body');
          egw$1.css(".subentry td div.innerContainer.level_" + d, "margin-right:" + parseInt(indent.css("margin-right")) * d + "px");
          indent.remove();
        }
      }
      var links = null;

      // Look for a flag in the row to avoid actions.  Use for sums or extra header rows.
      if (!_data.no_actions) {
        // Get the action links if the links callback is set
        if (this.self._linkCallback) {
          links = this.self._linkCallback.call(this.self._context, _data, this.entry.idx, this.entry.uid);
        }

        // Register the row in the selection manager
        this.self._selectionMgr.registerRow(this.entry.uid, this.entry.idx, tr, links);
      } else {
        // Remember that
        this.entry.no_actions = true;
      }

      // Invalidate the current row entry
      this.entry.row.invalidate();
    }
  }

  /**
   *
   */
  _destroyCallback(_row) {
    // Unregister the row from the selection manager, if not selected
    // If it is selected, leave it there - allows selecting rows and scrolling
    var selection = this.self._selectionMgr._getRegisteredRowsEntry(this.entry.uid);
    if (this.entry.row && selection && !egwBitIsSet(selection.state, EGW_AO_STATE_SELECTED)) {
      var tr = this.entry.row.getDOMNode();
      this.self._selectionMgr._updateState(this.entry.uid, EGW_AO_STATE_NORMAL);
      this.self._selectionMgr.unregisterRow(this.entry.uid, tr);
    }

    // There is no further row connected to the entry
    this.entry.row = null;

    // Unregister the data callback
    this.self._dataProvider.dataUnregisterUID(this.entry.uid, this.self._dataCallback, this);
  }

  /**
   * Returns an array containing "_count" index mapping entries starting from
   * the index given in "_start".
   */
  _getIndexMapping(_start, _count) {
    var result = [];
    for (var i = _start; i < _start + _count; i++) {
      result.push(this._getIndexEntry(i));
    }
    return result;
  }

  /**
   * Updates the grid according to the new order. The function simply does the
   * following: It iterates along the new order (given in _order) and the old
   * order given in _idxMap. Iteration variables used are
   *     a) i -- points to the current entry in _order
   *     b) idx -- points to the current grid row that will be effected by
   *        this operation.
   *     c) mapIdx -- points to the current entry in _indexMap
   * The following cases may occur:
   *     a) The current entry in the old order has no uid or no row -- in that
   *        case the row at the current position is simply updated,
   *        the old pointer will be incremented.
   *     b) The two uids differ -- insert a new row with the new uid, do not
   *        increment the old pointer.
   *     c) The two uids are the same -- increment the old pointer.
   * In a last step all rows that are left in the old order are deleted. All
   * newly created index entries are returned. This function does not update
   * the internal mapping in _idxMap.
   */
  _updateOrder(_start, _count, _idxMap, _order) {
    // The result contains the newly created index map entries which have to
    // be merged with the result
    var result = [];

    // Iterate over the new order
    var mapIdx = 0;
    var idx = _start;
    for (var i = 0; i < _order.length; i++, idx++) {
      var current = _idxMap[mapIdx];
      if (!current.row || !current.uid) {
        // If there is no row yet at the current position or the uid
        // of that entry is unknown, simply update the entry.
        current.uid = _order[i];
        current.idx = idx;

        // Only update the row, if it is displayed (e.g. has a "loading"
        // row displayed) -- this is needed for prefetching
        if (current.row) {
          this._insertDataRow(current, true);
        }
        mapIdx++;
      } else if (current.uid !== _order[i]) {
        // Insert a new row at the new position
        var entry = {
          "idx": idx,
          "uid": _order[i],
          "row": null
        };
        this._insertDataRow(entry, true);

        // Remember the new entry
        result.push(entry);
      } else {
        // Do nothing, the uids do not differ, just update the index of
        // the element
        current.idx = idx;
        mapIdx++;
      }
    }

    // Delete as many rows as we have left, invalidate the corresponding
    // index entry
    for (var i = mapIdx; i < _idxMap.length; i++) {
      if (typeof _idxMap[i] != 'undefined') {
        _idxMap[i].uid = null;
      }
    }
    return result;
  }
  _mergeResult(_newEntries, _invalidStartIdx, _diff, _total) {
    if (_newEntries.length > 0 || _diff > 0) {
      // Create a new index map
      var newMap = {};

      // Insert all new entries into the new index map
      for (var i = 0; i < _newEntries.length; i++) {
        newMap[_newEntries[i].idx] = _newEntries[i];
      }

      // Merge the old map with all old entries
      for (var key in this._indexMap) {
        // Get the corresponding index entry
        var entry = this._indexMap[key];

        // Calculate the new index -- if rows were deleted, we'll
        // have to adjust the index
        var newIdx = entry.idx >= _invalidStartIdx ? entry.idx - _diff : entry.idx;
        if (newIdx >= 0 && newIdx < _total && typeof newMap[newIdx] === "undefined") {
          entry.idx = newIdx;
          newMap[newIdx] = entry;
        } else if (newMap[newIdx] !== this._indexMap[key]) {
          // Make sure the old entry gets invalidated
          entry.idx = null;
          entry.row = null;
        }
      }

      // Make the new index map the current index map
      this._indexMap = newMap;
      this._selectionMgr.setIndexMap(newMap);
    }
  }
  _fetchCallback(_response) {
    // Remove answered request from queue
    var request = null;
    for (var i = 0; i < this.self._request_queue.length; i++) {
      if (this.self._request_queue[i].context == this) {
        request = this.self._request_queue[i];
        this.self._request_queue.splice(i, 1);
        break;
      }
    }
    this.self._lastModification = _response.lastModification;

    // Do nothing if _response.order evaluates to false
    if (!_response.order) {
      return;
    }

    // Make sure _response.order.length is not longer than the requested
    // count, if a specific count was requested
    var order = this.count != 0 ? _response.order.splice(0, this.count) : _response.order;

    // Remove from queue, or it will not be fetched again
    if (_response.total < this.count) {
      // Less rows than we expected
      // Clear the queue, or the remnants will never be loaded again
      this.self._queue = {};
    } else {
      for (var i = this.start; i < this.start + order.length; i++) delete this.self._queue[i];
    }

    // Get the current index map for the updated region
    var idxMap = this.self._getIndexMapping(this.start, order.length);

    // Update the grid using the new order. The _updateOrder function does
    // not update the internal mapping while inserting and deleting rows, as
    // this would move us to another asymptotic runtime level.
    var res = this.self._updateOrder(this.start, this.count, idxMap, order);

    // Merge the new indices, update all indices with rows that were not
    // affected and invalidate all indices if there were changes
    this.self._mergeResult(res, this.start + order.length, idxMap.length - order.length, _response.total);
    if (_response.total == 0) {
      this.self._emptyRow(true);
    } else {
      var row = jQuery(".egwGridView_empty", this.self._grid.innerTbody).remove();
      this.self._selectionMgr.unregisterRow("", 0, row.get(0));
    }

    // Now it's OK to invalidate, if it wasn't before
    this.self._grid.doInvalidate = true;

    // Update the total element count in the grid
    this.self._grid.setTotalCount(_response.total);
    this.self._selectionMgr.setTotalCount(_response.total);

    // Schedule an invalidate, in case total is the same
    this.self._grid.invalidate();

    // Check if requests are waiting
    this.self._fetchQueuedRequest();
  }

  /**
   * Insert an empty / placeholder row when there is no data to display
   */
  _emptyRow(_noRows) {
    var noRows = !_noRows ? false : true;
    jQuery(".egwGridView_empty", this._grid.innerTbody).remove();
    if (typeof this._grid._rowProvider != "undefined" && this._grid._rowProvider.getPrototype("empty")) {
      var placeholder = this._grid._rowProvider.getPrototype("empty");
      if (jQuery("td", placeholder).length == 1) {
        jQuery("td", placeholder).css("width", this._grid.outerCell.width() + "px");
      }
      placeholder.appendTo(this._grid.innerTbody);

      // Register placeholder action only if no rows
      if (noRows) {
        // Get the action links if the links callback is set
        var links = null;
        if (this._linkCallback) {
          links = this._linkCallback.call(this._context, {}, 0, "");
        }
        this._selectionMgr.registerRow("", 0, placeholder.get(0), links);
      }
    }
  }

  /**
   * Callback function used by the selection manager to translate the selected
   * range to uids.
   */
  _selectionFetchRange(_range, _callback, _context) {
    this._dataProvider.dataFetch({
      "start": _range.top,
      "num_rows": _range.bottom - _range.top + 1,
      "no_data": true
    }, function (_response) {
      _callback.call(_context, _response.order);
    }, _context);
  }

  /**
   * Tells the grid to make the given index visible.
   */
  _makeIndexVisible(_idx) {
    this._grid.makeIndexVisible(_idx);
  }
}
// Maximum concurrent data requests.  Additional ones are held in the queue.
_defineProperty$1G(et2_dataview_controller, "CONCURRENT_REQUESTS", 5);

var _class$8;
function _defineProperty$1F(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which stores the data of a single column.
 *
 * @augments Class
 */
class et2_dataview_column {
  /**
   * Constructor
   */
  constructor(_attrs) {
    _defineProperty$1F(this, "fixedWidth", void 0);
    _defineProperty$1F(this, "relativeWidth", void 0);
    /**
     * Unique identifier for this column. It is used to store changed column widths or visibilities.
     */
    _defineProperty$1F(this, "id", void 0);
    /**
     * Defines the visibility state of this column.
     */
    _defineProperty$1F(this, "visibility", et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE);
    _defineProperty$1F(this, "caption", '');
    /**
     * Column type - Type of the column
     *
     * One of ET2_COL_TYPE_DEFAULT or ET2_COL_TYPE_NAME_ICON_FIXED
     */
    _defineProperty$1F(this, "type", et2_dataview_column.ET2_COL_TYPE_DEFAULT);
    /**
     * Width of the column
     */
    _defineProperty$1F(this, "width", 80);
    /**
     * Maximum width of the column
     */
    _defineProperty$1F(this, "maxWidth", 0);
    /**
     * Minimum width of the column, in pixels.  Values below this are rejected.
     */
    _defineProperty$1F(this, "minWidth", 20);
    this.id = _attrs.id;
    if (typeof _attrs.visibility !== "undefined") {
      this.visibility = _attrs.visibility;
    }
    this.caption = _attrs.caption;
    if (typeof _attrs.type !== "undefined") {
      this.type = _attrs.type;
    }
    if (typeof _attrs.width !== "undefined") {
      this.set_width(_attrs.width);
    }
    if (typeof _attrs.maxWidth !== "undefined") {
      this.maxWidth = _attrs.maxWidth;
    }
    if (typeof _attrs.minWidth !== "undefined") {
      this.minWidth = _attrs.minWidth;
    }
  }

  /**
   * Set the column width
   *
   * Posible value types are:
   * 	1. "100" => fixedWidth 100px
   * 	2. "100px" => fixedWidth 100px
   *	3. "50%" => relativeWidth 50%
   *	4. 0.5 => relativeWidth 50%
   *
   * @param {float|string} _value
   */
  set_width(_value) {
    // Parse the width parameter.
    this.relativeWidth = false;
    this.fixedWidth = false;
    var w = _value;
    if (typeof w == 'number') {
      this.relativeWidth = parseFloat(w.toFixed(3));
    } else if (w.charAt(w.length - 1) == "%" && !isNaN(w.substr(0, w.length - 1))) {
      this.relativeWidth = parseInt(w.substr(0, w.length - 1)) / 100;

      // Relative widths with more than 100% are not allowed!
      if (this.relativeWidth > 1) {
        this.relativeWidth = false;
      }
    } else if (w.substr(w.length - 2, 2) == "px" && !isNaN(w.substr(0, w.length - 2))) {
      this.fixedWidth = parseInt(w.substr(0, w.length - 2));
    } else if (typeof w == 'string' && !isNaN(parseFloat(w))) {
      this.fixedWidth = parseInt(w);
    }
  }
  set_visibility(_value) {
    // If visibility is always, don't turn it off
    if (this.visibility == et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS || this.visibility == et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT) return;
    if (_value === true) {
      this.visibility = et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE;
    } else if (_value === false) {
      this.visibility = et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE;
    } else if (typeof _value == "number") {
      this.visibility = _value;
    } else {
      egw$1().debug("warn", "Invalid visibility option for column: ", _value);
    }
  }
}

/**
 * Contains logic for the columns class. The columns class represents the unique set
 * of columns a grid view owns. The parameters of the columns (except for visibility)
 * do normaly not change.
 */
_class$8 = et2_dataview_column;
_defineProperty$1F(et2_dataview_column, "ET2_COL_TYPE_DEFAULT", 0);
_defineProperty$1F(et2_dataview_column, "ET2_COL_TYPE_NAME_ICON_FIXED", 1);
_defineProperty$1F(et2_dataview_column, "ET2_COL_VISIBILITY_ALWAYS", 0);
_defineProperty$1F(et2_dataview_column, "ET2_COL_VISIBILITY_VISIBLE", 1);
_defineProperty$1F(et2_dataview_column, "ET2_COL_VISIBILITY_INVISIBLE", 2);
_defineProperty$1F(et2_dataview_column, "ET2_COL_VISIBILITY_ALWAYS_NOSELECT", 3);
_defineProperty$1F(et2_dataview_column, "ET2_COL_VISIBILITY_DISABLED", 4);
_defineProperty$1F(et2_dataview_column, "_attributes", {
  "id": {
    "name": "ID",
    "type": "string",
    "description": "Unique identifier for this column. It is used to " + "store changed column widths or visibilities."
  },
  "visibility": {
    "name": "Visibility",
    "type": "integer",
    "default": _class$8.ET2_COL_VISIBILITY_VISIBLE,
    "description": "Defines the visibility state of this column."
  },
  "caption": {
    "name": "Caption",
    "type": "string",
    "description": "Caption of the column as it is displayed in the " + "select columns popup."
  },
  "type": {
    "name": "Column type",
    "type": "integer",
    "default": _class$8.ET2_COL_TYPE_DEFAULT,
    "description": "Type of the column"
  },
  "width": {
    "name": "Width",
    "type": "dimension",
    "default": "80px",
    "description": "Width of the column."
  },
  "minWidth": {
    "name": "Minimum width",
    "type": "integer",
    "default": 20,
    "description": "Minimum width of the column, in pixels.  Values below this are rejected."
  },
  "maxWidth": {
    "name": "Maximum width",
    "type": "integer",
    "default": 0,
    "description": "Maximum width of the column"
  }
});
class et2_dataview_columns {
  constructor(_columnData) {
    _defineProperty$1F(this, "_totalWidth", void 0);
    _defineProperty$1F(this, "_totalFixed", void 0);
    _defineProperty$1F(this, "columnWidths", void 0);
    _defineProperty$1F(this, "columns", void 0);
    _defineProperty$1F(this, "_updated", void 0);
    // Initialize some variables
    this._totalWidth = 0;
    this._totalFixed = 0;
    this.columnWidths = [];

    // Create the columns object
    this.columns = new Array(_columnData.length);
    for (var i = 0; i < _columnData.length; i++) {
      this.columns[i] = new et2_dataview_column(_columnData[i]);
    }
    this._updated = true;
  }
  destroy() {
    // Free all column objects
    for (var i = 0; i < this.columns.length; i++) {
      this.columns[i] = null;
    }
  }
  updated() {
    this._updated = true;
  }
  columnCount() {
    return this.columns.length;
  }
  get totalWidth() {
    return this._totalWidth;
  }
  get totalFixed() {
    return this._totalFixed ? this._totalFixed : 0;
  }

  /**
   * Set the total width of the header row
   *
   * @param {(string|number)} _width
   */
  setTotalWidth(_width) {
    if (_width != this._totalWidth && _width > 0) {
      this._totalWidth = _width;
      this._updated = true;
    }
  }

  /**
   * Returns the index of the colum with the given id
   *
   * @param {string} _id
   */
  getColumnIndexById(_id) {
    for (var i = 0; i < this.columns.length; i++) {
      if (this.columns[i].id == _id) {
        return i;
      }
    }
    return -1;
  }

  /**
   * Returns the column with the given id
   *
   * @param {string} _id
   */
  getColumnById(_id) {
    var idx = this.getColumnIndexById(_id);
    return idx == -1 ? null : this.columns[idx];
  }

  /**
   * Returns the width of the column with the given index
   *
   * @param {number} _idx
   */
  getColumnWidth(_idx) {
    if (this._totalWidth > 0 && _idx >= 0 && _idx < this.columns.length) {
      // Recalculate the column widths if something has changed.
      if (this._updated) {
        this._calculateWidths();
        this._updated = false;
      }

      // Return the calculated width for the column with the given index.
      return this.columnWidths[_idx];
    }
    return 0;
  }

  /**
   * Returns an array containing the width of the column and its visibility
   * state.
   */
  getColumnData() {
    var result = [];
    for (var i = 0; i < this.columns.length; i++) {
      result.push({
        "id": this.columns[i].id,
        "width": this.getColumnWidth(i),
        "visible": this.columns[i].visibility !== et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE && this.columns[i].visibility !== et2_dataview_column.ET2_COL_VISIBILITY_DISABLED
      });
    }
    return result;
  }

  /**
   * Returns an associative array which contains data about the visibility
   * state of the columns.
   */
  getColumnVisibilitySet() {
    var result = {};
    for (var i = 0; i < this.columns.length; i++) {
      if (this.columns[i].visibility != et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT) {
        result[this.columns[i].id] = {
          "caption": this.columns[i].caption,
          "enabled": this.columns[i].visibility != et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS && this.columns[i].visibility != et2_dataview_column.ET2_COL_VISIBILITY_DISABLED && this.columns[i].type != et2_dataview_column.ET2_COL_TYPE_NAME_ICON_FIXED,
          "visible": this.columns[i].visibility != et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE
        };
      }
    }
    return result;
  }

  /**
   * Sets a column visiblity set
   *
   * @param {object} _set
   */
  setColumnVisibilitySet(_set) {
    for (var k in _set) {
      var col = this.getColumnById(k);
      if (col) {
        col.set_visibility(_set[k].visible ? et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE : et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE);
      }
    }
    this._updated = true;
  }

  /* ---- PRIVATE FUNCTIONS ---- */

  /**
   * Calculates the absolute column width depending on the previously set
   * "totalWidth" value. The calculated values are stored in the columnWidths
   * array.
   */
  _calculateWidths() {
    // Reset some values which are used during the calculation
    var _larger = Array(this.columns.length);
    for (var i = 0; i < this.columns.length; i++) {
      _larger[i] = false;
    }

    // Remove the spacing between the columns from the total width
    var tw = this._totalWidth;

    // Calculate how many space is - relatively - not occupied with columns with
    // relative or fixed width
    var totalRelative = 0;
    var fixedCount = 0;
    this._totalFixed = 0;
    for (var i = 0; i < this.columns.length; i++) {
      var col = this.columns[i];
      if (col.visibility !== et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE && col.visibility !== et2_dataview_column.ET2_COL_VISIBILITY_DISABLED) {
        // Some bounds sanity checking
        if (col.fixedWidth > tw || col.fixedWidth < 0) {
          col.fixedWidth = false;
        } else if (col.relativeWidth > 1 || col.relativeWidth < 0) {
          col.relativeWidth = false;
        }
        if (col.relativeWidth) {
          totalRelative += col.relativeWidth;
        } else if (col.fixedWidth) {
          this._totalFixed += col.fixedWidth;
          fixedCount++;
        }
      }
    }

    // Now calculate the absolute width of the columns in pixels
    var usedTotal = 0;
    this.columnWidths = [];
    for (var i = 0; i < this.columns.length; i++) {
      var w = 0;
      var col = this.columns[i];
      if (col.visibility != et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE && col.visibility !== et2_dataview_column.ET2_COL_VISIBILITY_DISABLED) {
        if (_larger[i]) {
          w = col.maxWidth;
        } else if (col.fixedWidth) {
          w = col.fixedWidth;
        } else if (col.relativeWidth) {
          // Reset relative to an actual percentage (of 1.00) or
          // resizing eventually sends them to 0
          col.relativeWidth = col.relativeWidth / totalRelative;
          w = Math.round((tw - this._totalFixed) * col.relativeWidth);
        }
        if (w > tw || col.maxWidth && w > col.maxWidth) {
          w = Math.min(tw - usedTotal, col.maxWidth);
        }
        if (w < 0 || w < col.minWidth) {
          w = Math.max(0, col.minWidth);
        }
      }
      this.columnWidths.push(w);
      usedTotal += w;
    }

    // Deal with any accumulated rounding errors
    if (usedTotal != tw) {
      var column, columnIndex;
      var remaining_width = usedTotal - tw;

      // Pick the first relative column and use it
      for (columnIndex = 0; columnIndex < this.columns.length; columnIndex++) {
        if (this.columns[columnIndex].visibility === et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE || this.columns[columnIndex].visibility === et2_dataview_column.ET2_COL_VISIBILITY_DISABLED || this.columnWidths[columnIndex] <= 0 || remaining_width > 0 && this.columnWidths[columnIndex] <= this.columns[columnIndex].minWidth) {
          continue;
        }
        var col = this.columns[columnIndex];
        if (col.relativeWidth || !col.fixedWidth) {
          column = col;
          break;
        } else if (!col.fixedWidth) {
          column = col;
        }
      }
      if (!column) {
        // Distribute shortage over all fixed width columns
        var diff = Math.round(remaining_width / fixedCount);
        for (var i = 0; i < this.columns.length; i++) {
          var col = this.columns[i];
          var col_diff = diff < 0 ? Math.max(remaining_width, diff) : Math.min(remaining_width, diff);
          if (!col.fixedWidth) continue;
          var new_width = this.columnWidths[i] - col_diff;
          remaining_width -= col_diff;
          this.columnWidths[i] = Math.max(0, Math.min(new_width, tw));
        }
      } else {
        this.columnWidths[columnIndex] = Math.max(column.minWidth, this.columnWidths[columnIndex] - remaining_width);
      }
    }
  }
}

/**
 * EGroupware eTemplate2 - JS Nextmatch object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 * @author Ralf Becker <RalfBecker@outdoor-training.de>
 * @copyright EGroupware GmbH 2012-2021
 */

/**
 * Default action for nextmatch rows, runs action specified _action.data.nm_action: see nextmatch_widget::egw_actions()
 *
 * @param {egwAction} _action action object with attributes caption, id, nm_action, ...
 * @param {array} _senders array of rows selected
 * @param {object} _target
 * @param {object} _ids attributs all and ids (array of string)
 */
function nm_action(_action, _senders, _target, _ids)
{
	// ignore checkboxes, unless they have an explicit defined nm_action
	if (_action.checkbox && (!_action.data || typeof _action.data.nm_action == 'undefined')) return;

	if (typeof _action.data == 'undefined' || !_action.data) _action.data = {};
	if (typeof _action.data.nm_action == 'undefined' && _action.type == 'popup') _action.data.nm_action = 'submit';

	if(typeof _ids == 'undefined')
	{
		// Get IDs from nextmatch - nextmatch is in the top of the action tree
		// @see et2_extension_nextmatch_controller._initActions()
		var nm = null;
		var action = _action;
		while(nm == null && action != null)
		{
			if(action.data != null && action.data.nextmatch)
			{
				nm = action.data.nextmatch;
			}
			action = action.parent;
		}
		if(nm)
		{
			_ids = nm.getSelection();
			_action.data.nextmatch = nm;
		}
		else
		{
			// This will probably fail without nm, but it depends on the action
			_ids = {ids: _senders.map(function(s) {return s.id;})};
		}
	}
	// row ids
	var row_ids = "";
	for (var i = 0; i < _ids.ids.length; i++)
	{
		var row_id = _ids.ids[i];
		row_ids += (row_id.indexOf(',') >= 0 ? '"'+row_id.replace(/"/g,'""')+'"' : row_id) +
			((i < _ids.ids.length - 1) ? "," : "");
	}

	// Translate the internal uids back to server uids
	var idsArr = _ids.ids;
	for (var i = 0; i < idsArr.length; i++)
	{
		// empty placeholder gets reported --> ignore it
		if (!idsArr[i])
		{
			idsArr.splice(i,1);
			continue;
		}
		idsArr[i] = idsArr[i].split("::").pop();
	}

	// Calculate the ids parameters
	var ids = "";
	for (var i = 0; i < idsArr.length; i++)
	{
		var id = idsArr[i];
		ids += (id.indexOf(',') >= 0 ? '"'+id.replace(/"/g,'""')+'"' : id) +
			((i < idsArr.length - 1) ? "," : "");
	}
	//console.log(_action); console.log(_senders);

	let mgr = _action instanceof EgwActionManager ? _action : _action.getManager();

	var url = '#';
	if (typeof _action.data.url != 'undefined')
	{
		// Add selected IDs to url
		url = _action.data.url.replace(/(\$|%24)id/,encodeURIComponent(ids))
			// Include select all flag too
			.replace(/(\$|%24)select_all/,_ids.all)
			// Add row_ids to url
			.replace(/(\$|%24)row_id/,encodeURIComponent(row_ids));
	}

	var target = null;
	if (typeof _action.data.target != 'undefined')
	{
		target = _action.data.target;
	}

	switch(_action.data.nm_action)
	{
		case 'alert':
			alert(_action.caption + " (\'" + _action.id + "\') executed on rows: " + ids);
			break;

		case 'location':
			if (typeof _action.data.targetapp != 'undefined')
			{
				egw.top.egw_appWindowOpen(_action.data.targetapp, url);
			}
			else if(target)
			{
				egw.open_link(url, target, _action.data.width ? _action.data.width+'x'+_action.data.height : false);
			}
			else
			{
				window.location.href = url;
			}
			break;

		case 'popup':
			// According to microsoft, IE 10/11 can only accept a url with 2083 characters
			// therefore we need to send request to compose window with POST method
			// instead of GET. We create a temporary <Form> and will post emails.
			// ** WebServers and other browsers also have url length limit:
			// Firefox:~ 65k, Safari:80k, Chrome: 2MB, Apache: 4k, Nginx: 4k
			if (url.length > 2083)
			{
				var $tmpForm = jQuery(document.createElement('form'));
				var $tmpSubmitInput = jQuery(document.createElement('input')).attr({type:"submit"});
				var params = url.split('&');
				url = params[0];
				for (var i=1;i<params.length;i++)
				{
					var values = params[i].split('=');
					switch (values[0])
					{
						case 'cd':
						case 'tz':
						case 'menuaction':
						case 'hasupdate':
							url = url + '&' + values.join('=');
							break;
					}
					$tmpForm.append(jQuery(document.createElement('input')).attr({name:values[0], type:"text", value: values[1]}));
				}
				var postRequest = true;
			}

			var popup_window = egw.open_link(url,target,_action.data.width+'x'+_action.data.height);

			if (postRequest)
			{
				popup_window.name = popup_window.name ? popup_window.name : 'postRequest';
				// Set the temporary form's attributes
				$tmpForm.attr({target:popup_window.name, action:url, method:"post"})
						.append($tmpSubmitInput).appendTo('body');
				$tmpForm.submit();
				// Remove the form after submit
				$tmpForm.remove();
			}
			break;

		case 'long_task':
			// Run a long task once for each ID with a nice dialog instead of
			// freezing for a while.  If egw_open is set, and only 1 row selected,
			// egw_open will be used instead.
			if(doLongTask(idsArr, _ids.all,_action, mgr.data.nextmatch)) break;

			// Fall through
		case 'egw_open':
			var params = _action.data.egw_open.split('-');	// type-appname-idNum (idNum is part of id split by :), eg. "edit-infolog"

			var egw_open_id = idsArr[0];
			var type = params.shift();
			var app = params.shift();
			if (typeof params[2] != 'undefined')
			{
					if(egw_open_id.indexOf(':') >= 0)
					{
						egw_open_id = egw_open_id.split(':')[params.shift(params[2])];
					}
					else
					{
						// Discard , special handling when from=merge is involved
						if(params.length>1 && params[0]=='' && params[1].indexOf('from=merge')!=-1)
						{
							params.shift();
						}
						else
						{
							params.shift(params[2]);
						}
					}
			}
			//special handling when from=merge is involved
			if(params.length>1 && params[0]=='' && params[1].indexOf('from=merge')!=-1)
			{
				params.shift();
			}
			// Re-join, in case extra has a -
			var extra = params.join('-');
			egw(app,window).open(egw_open_id,app,type,extra,target);
			break;

		case 'open_popup':
			// open div styled as popup contained in current form and named action.id+'_popup'
			if (nm_popup_action == null)
			{
				nm_open_popup(_action, _ids.ids);
				break;
			}
			// fall through, if popup is open --> submit form
		case 'submit':
			var checkboxes = mgr.getActionsByAttr("checkbox", true);
			var checkbox_values = {};
			if (checkboxes)
				for (var i in checkboxes)
					checkbox_values[checkboxes[i].id] = checkboxes[i].checked;

			var nextmatch = _action.data.nextmatch;
			if(!nextmatch && _senders.length)
			{
				// Pull it from deep within, where it was stuffed in et2_dataview_controller_selection._attachActionObject()
				nextmatch = _senders[0]._context._widget;
			}
			if(nextmatch)
			{
				// Fake a getValue() function
				var old_value = nextmatch.getValue;
				var value = nextmatch.getValue();
				jQuery.extend(value, _action.data, nextmatch.activeFilters, {
					"selected": idsArr,
					"select_all": _ids.all,
					"checkboxes": checkbox_values
				});
				// Skip this one, it would cause the nm to change ID on reload
				delete value.id;
				value[nextmatch.options.settings.action_var]= _action.id;

				// Don't try to send the nextmatch
				delete value['nextmatch'];

				nextmatch.getValue = function() {
					return value;
				};


				// downloads need a regular submit via POST (no Ajax)
				if (_action.data.postSubmit)
				{
					nextmatch.getInstanceManager().postSubmit();
				}
				else
				{
					nextmatch.getInstanceManager().submit();
				}
			}
			else
			{
				egw().debug("error", "Missing nextmatch widget, could not submit", _action);
			}
			break;
	}
}

/**
 * Fetch all IDs to the client side, user wants to do something with them...
 *
 * @param {string[]} ids Array of selected IDs
 * @param {et2_nextmatch} nextmatch
 * @param {function} callback Callback function
 * @returns {Boolean}
 */
function fetchAll(ids, nextmatch, callback)
{
	if(!nextmatch || !nextmatch.controller) return false;
	var selection = nextmatch.getSelection();
	if(!selection.all) return false;

	if(nextmatch.controller._grid && nextmatch.controller._grid.getTotalCount() > ids.length)
	{
		// Need to actually fetch all (TODO: just ids) to do this client side
		var idsArr = [];
		var count = idsArr.length;
		var total = nextmatch.controller._grid.getTotalCount();
		var cancel = false;
		var dialog = et2_dialog.show_dialog(
			// Abort the long task if they canceled the data load
			function() {count = total; cancel=true;},
			egw.lang('Loading'), egw.lang('please wait...'),{},[
				{"button_id": et2_dialog.CANCEL_BUTTON,"text": egw.lang('cancel'),id: 'dialog[cancel]',image: 'cancel'}
			]
		);

		// dataFetch() is asyncronous, so all these requests just get fired off...
		// 200 rows chosen arbitrarily to reduce requests.
		do {
			nextmatch.controller.dataFetch({start:count, num_rows: 200}, function(data) {
				if(data && data.order)
				{
					for(var i = 0; i < data.order.length; i++)
					{
						idsArr.push(data.order[i].split("::").pop());
					}
				}
				// Update total, just in case it changed
				if(data && data.total) total = data.total;

				if(idsArr.length >= total)
				{
					dialog.destroy();
					if(!cancel)
					{
						callback.call(this, idsArr);
					}
				}
			}, {});
			count += 200;
		} while (count < total)
		return true;
	}
	return false;
}

/**
 * Fetch all IDs and run a long task.
 *
 * @param {String[]} idsArr Array of IDs
 * @param {boolean} all True if all IDs are selected.  They'll have to be fetched if missing.
 * @param {type} _action
 * @param {et2_nextmatch} nextmatch
 * @returns {Boolean}
 */
function doLongTask(idsArr, all, _action, nextmatch)
{
	if(all || idsArr.length > 1 || typeof _action.data.egw_open == 'undefined')
	{
		if(all)
		{
			var fetching = fetchAll(idsArr, nextmatch,function(idsArr){
				et2_dialog.long_task(null,_action.data.message||_action.caption,_action.data.title,_action.data.menuaction,idsArr);
			});
			if(fetching) return true;
		}
		et2_dialog.long_task(null,_action.data.message||_action.caption,_action.data.title,_action.data.menuaction,idsArr);
		return true;
	}
	return false;
}

/**
 * Callback to check if a certain field (_action.data.fieldId) is (not) equal to given value (_action.data.fieldValue)
 *
 * If field is not found, we return false too!
 *
 * @param _action egwAction object, we use _action.data.fieldId to check agains _action.data.fieldValue
 * @param _senders array of egwActionObject objects
 * @param _target egwActionObject object, get's called for every object in _senders
 * @returns boolean true if field found and has specified value, false otherwise
 */
function nm_compare_field(_action, _senders, _target)
{
	var value = false;

	// This probably won't work...
	var field = document.getElementById(_action.data.fieldId);

	// Use widget
	if (!field)
	{
		var nextmatch = _action.data.nextmatch;
		if(!nextmatch && _senders.length)
		{
			// Pull it from deep within, where it was stuffed in et2_dataview_controller_selection._attachActionObject()
			nextmatch = _senders[0]._context._widget;
		}
		if(!nextmatch) return false;

		field = nextmatch.getWidgetById(_action.data.fieldId);
		value = field.getValue();
	}
	else
	{
		value = jQuery(field).val();
	}
	if (!field) return false;


	if (_action.data.fieldValue.substr(0,1) == '!')
		return value != _action.data.fieldValue.substr(1);

	return value == _action.data.fieldValue;
}

// TODO: This code is rather suboptimal! No global variables as this code will
// run in a global context
window.nm_action = nm_action;
window.fetchAll = fetchAll;
window.doLongTask = doLongTask;
window.nm_popup_action = null;
window.nm_popup_ids = null;

/**
 * Open popup for a certain action requiring further input
 *
 * Popup needs to have eTemplate name of action id plus "_popup"
 *
 * @param {egwAction} _action
 * @param {egwActionObject[]} _selected
 */
function nm_open_popup(_action, _selected)
{
	//Check if there is nextmatch on _action otherwise gets the uniqueid from _ids
	var uid;
	if (typeof _action.data.nextmatch !== 'undefined')
	{
		uid = _action.data.nextmatch.getInstanceManager().uniqueId;
	}
	else if (typeof _selected[0] !== 'undefined')
	{
		uid = _selected[0].manager.data.nextmatch.getInstanceManager().uniqueId;
	}
	let action = _action;
	let selected = _selected;
	nm_popup_action = _action;

	if (_selected.length && typeof _selected[0] == 'object')
	{
		_action.data.nextmatch = _selected[0]._context._widget;
		nm_popup_ids = _selected;
	}
	else
	{
		egw().debug("warn", 'Not proper format for IDs, should be array of egwActionObject', _selected);
		nm_popup_ids = _selected;
	}

	// Find the popup div
	let nm = _action.data.nextmatch;
	var popup = (nm?.getInstanceManager().DOMContainer || document.body).querySelector("et2-dialog[id*='" + _action.id + "_popup']") || document.body.querySelector("#" + (uid || "") + "_" + _action.id + "_popup") || document.body.querySelector("[id*='" + _action.id + "_popup']");
	if (popup && popup instanceof Et2Dialog)
	{
		popup.show();
	}
	else if (popup)
	{
		let dialog = new Et2Dialog(nm?.egw());
		dialog.destroyOnClose = false;
		dialog.id = popup.id;
		popup.removeAttribute("id");
		// Remove class that hides
		popup.classList.remove("prompt");
		popup.classList.remove("action_popup");

		// Set title
		let title = popup.querySelector(".promptheader");
		if (title)
		{
			title.slot = "label";
			dialog.appendChild(title);
		}
		popup.slot = "";

		dialog.addEventListener("close", () =>
		{
			window.nm_popup_action = null;
		});
		// Move buttons
		popup.querySelectorAll('et2-button').forEach((button, index) =>
		{
			button.slot = "footer";
			if (index == 0)
			{
				button.variant = "primary";
			}
			let button_click = button.onclick;
			button.onclick = (e) =>
			{
				window.nm_popup_action = button_click ? action : null;
				window.nm_popup_ids = selected;
				dialog.hide();

				return button_click?.apply(button, e.currentTarget);
			};
			dialog.appendChild(button);
		});
		dialog.appendChild(popup);
		dialog.requestUpdate();

		if (nm)
		{
			nm.getInstanceManager().DOMContainer.appendChild(dialog);
		}
		else
		{
			document.body.appendChild(dialog);
		}

		// Reset global variables
		nm_popup_action = null;
		nm_popup_ids = null;
	}
}

/**
 * Submit a popup action
 *
 * Must to be global, as it's used as onclick action!
 *
 * @param {DOMNode} button DOM node of button
 */
window.nm_submit_popup = function(button)
{
	if (nm_popup_action.data.nextmatch)
	{
		button.clicked = true;
	}

	// Mangle senders to get IDs where nm_action() wants them
	if(nm_popup_ids.length && typeof nm_popup_ids[0] != 'object')
	{
		// Legacy ID just as string
		var ids = {ids:[]};
		for(var i in nm_popup_ids)
		{
			if(nm_popup_ids[i])
			ids.ids.push(nm_popup_ids[i]);
		}
	}

	// call regular nm_action to transmit action and senders correct
	nm_action(nm_popup_action,nm_popup_ids, button, ids );

	nm_hide_popup(button, null);
	nm_popup_ids = null;
};

/**
 * Hide popup
 *
 * Must to be global, as it's used as onclick action!
 *
 * @param {DOMNode} element
 * @param {string} div_id
 * @returns {Boolean}
 */
window.nm_hide_popup = function(element, div_id)
{
	var prefix = element.id.substring(0, element.id.indexOf('['));
	var popup = div_id ? document.getElementById(div_id) : document.querySelector("#" + prefix + "_popup") || document.querySelector("[id*='" + prefix + "_popup']");

	// Hide popup
	if (popup)
	{
		popup.close();
	}
	nm_popup_action = null;
	nm_popup_ids = null;

	return false;
};

/**
 * Activate/click first link in row
 *
 * @param {egwAction} _action
 * @param {array} _senders of egwActionObject
 */
window.nm_activate_link = function(_action, _senders)
{
	jQuery(_senders[0].iface.getDOMNode()).find('.et2_clickable:first').trigger('click');
};

function _defineProperty$1E(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @augments et2_dataview_controller
 */
class et2_nextmatch_controller extends et2_dataview_controller {
  /**
   * Initializes the nextmatch controller.
   *
   * @param _parentController is the parent nextmatch controller instance
   * @param _egw is the api instance
   * @param _execId is the execId of the etemplate
   * @param _widget is the nextmatch-widget we are fetching data for.
   * @param _grid is the grid the grid controller will be controlling
   * @param _rowProvider is the nextmatch row provider instance.
   * @param _objectManager is the parent object manager (if null, the object
   * manager) will be created using
   * @param _actionLinks contains the action links
   * @param _actions contains the actions, may be null if an object manager
   * is given.
   * @memberOf et2_nextmatch_controller
   */
  constructor(_parentController, _egw, _execId, _widget, _parentId, _grid, _rowProvider, _actionLinks, _objectManager, _actions) {
    // Call the parent et2_dataview_controller constructor
    super(_parentController, _grid);
    _defineProperty$1E(this, "_widget", void 0);
    _defineProperty$1E(this, "egw", void 0);
    _defineProperty$1E(this, "_actionLinks", void 0);
    _defineProperty$1E(this, "_execId", void 0);
    _defineProperty$1E(this, "_widgetId", void 0);
    _defineProperty$1E(this, "_parentId", void 0);
    _defineProperty$1E(this, "_rowProvider", void 0);
    _defineProperty$1E(this, "_actionManager", void 0);
    _defineProperty$1E(this, "_filters", void 0);
    _defineProperty$1E(this, "kept_selection", void 0);
    _defineProperty$1E(this, "kept_focus", void 0);
    _defineProperty$1E(this, "kept_expansion", void 0);
    _defineProperty$1E(this, "_view", void 0);
    this.setDataProvider(this);
    this.setRowCallback(this._nmRowCallback);
    this.setLinkCallback(this._nmLinkCallback);
    this.setContext(this);

    // Copy the egw reference
    this.egw = _egw;

    // Keep a reference to the widget
    this._widget = _widget;

    // Copy the given parameters
    this._actionLinks = _actionLinks;
    this._execId = _execId;

    // Get full widget ID, including path
    var id = _widget.getArrayMgr('content').getPath();
    if (typeof id == 'string') {
      this._widgetId = id;
    } else if (id.length === 1) {
      this._widgetId = id[0];
    } else {
      this._widgetId = id.shift() + '[' + id.join('][') + ']';
    }
    this._parentId = _parentId;
    this._rowProvider = _rowProvider;

    // Initialize the action and the object manager
    // _initActions calls _init_link_dnd, which uses this._actionLinks,
    // so this must happen after the above parameter copying
    if (!_objectManager) {
      this._initActions(_actions);
    } else {
      this._actionManager = null;
      this._objectManager = _objectManager;
    }
    this.setActionObjectManager(this._objectManager);

    // Add our selection callback to selection manager
    var self = this;
    this._objectManager.setSelectedCallback = function () {
      self._selectCallback.apply(self, [this, arguments]);
    };

    // We start with no filters
    this._filters = {};

    // Keep selection across filter changes
    this.kept_selection = null;
    this.kept_focus = null;
    this.kept_expansion = [];

    // Directly use the API-Implementation of dataRegisterUID and
    // dataUnregisterUID
    this.dataUnregisterUID = _egw.dataUnregisterUID;

    // Default to rows
    this._view = et2_nextmatch_controller.VIEW_ROW;
  }
  destroy() {
    // If the actionManager variable is set, the object- and actionManager
    // were created by this instance -- clear them
    if (this._actionManager) {
      this._objectManager.remove();
      this._actionManager.remove();
    }
    this._widget = null;
    super.destroy();
  }

  /**
   * Updates the filter instance.
   */
  setFilters(_filters) {
    // Update the filters
    this._filters = _filters;
  }

  /**
   * Keep the selection, if possible, across a data fetch and restore it
   * after
   */
  keepSelection() {
    this.kept_selection = this._selectionMgr ? this._selectionMgr.getSelected() : null;
    this.kept_focus = this._selectionMgr && this._selectionMgr._focusedEntry ? this._selectionMgr._focusedEntry.uid || null : null;

    // Find expanded rows
    var nm = this._widget;
    var controller = this;
    jQuery('.arrow.opened', this._widget.getDOMNode(this._widget)).each(function () {
      var entry = controller.getRowByNode(this);
      if (entry && entry.uid) {
        controller.kept_expansion.push(entry.uid);
      }
    });
  }
  getObjectManager() {
    return this._objectManager;
  }

  /**
   * Deletes a row from the grid
   *
   * @param {string} uid
   */
  deleteRow(uid) {
    var entry = Object.values(this._indexMap).find(entry => entry.uid == uid);

    // Unselect
    this._selectionMgr.setSelected(uid, false);
    if (entry && entry.idx !== null) {
      this._selectionMgr.unregisterRow(uid, entry.tr);
      // This will remove the row, but add an empty to the end.
      // That's OK, because it will be removed when we update the row count
      this._grid.deleteRow(entry.idx);

      // Remove from internal map
      delete this._indexMap[entry.idx];

      // Update the indices of all elements after the current one
      for (var mapIndex = entry.idx + 1; typeof this._indexMap[mapIndex] !== 'undefined'; mapIndex++) {
        var entry = this._indexMap[mapIndex];
        entry.idx = mapIndex - 1;
        this._indexMap[mapIndex - 1] = entry;

        // Update selection mgr too
        if (entry.uid && typeof this._selectionMgr._registeredRows[entry.uid] !== 'undefined') {
          var reg = this._selectionMgr._getRegisteredRowsEntry(entry.uid);
          reg.idx = entry.idx;
          if (reg.ao && reg.ao._index) reg.ao._index = entry.idx;
          this._selectionMgr._registeredRows[entry.uid].idx = reg.idx;
        }
      }
      // Remove last one, it was moved to mapIndex-1 before increment
      delete this._indexMap[mapIndex - 1];

      // Not needed, they share by reference
      // this._selectionMgr.setIndexMap(this._indexMap);
    }

    for (var child of this._children) {
      child.deleteRow(uid);
    }
  }

  /** -- PRIVATE FUNCTIONS -- **/

  /**
   * Create a new row, either normal or tiled
   *
   * @param {type} ctx
   * @returns {et2_dataview_container}
   */
  _createRow(ctx) {
    switch (this._view) {
      case et2_nextmatch_controller.VIEW_TILE:
        var row = new et2_dataview_tile(this._grid);
        // Try to overcome chrome rendering issue where float is not
        // applied properly, leading to incomplete rows
        window.setTimeout(function () {
          if (!row.tr) return;
          row.tr.css('float', 'none');
          window.setTimeout(function () {
            if (!row.tr) return;
            row.tr.css('float', 'left');
          }, 50);
        }, 100);
        return row;
      case et2_nextmatch_controller.VIEW_ROW:
      default:
        return new et2_dataview_row(this._grid);
    }
  }

  /**
   * Initializes the action and the object manager.
   */
  _initActions(_actions) {
    // Generate a uid for the action and object manager
    var uid = this._widget.id || this.egw.uid();
    if (_actions == null) _actions = [];

    // Initialize the action manager and add some actions to it
    // Only look 1 level deep
    var gam = egw_getActionManager(this.egw.appName, true, 1);
    if (this._actionManager == null) {
      this._actionManager = gam.addAction("actionManager", uid);
    }
    var data = this._actionManager.data;
    if (data == 'undefined' || !data) {
      data = {};
    }
    data.nextmatch = this._widget;
    data.context = this._widget.getInstanceManager().app_obj;
    this._actionManager.set_data(data);
    this._actionManager.updateActions(_actions, this.egw.appName);

    // Set the default execute handler
    var self = this;
    this._actionManager.setDefaultExecute(function (_action, _senders, _target) {
      // Get the selected ids descriptor object
      var ids = self._selectionMgr.getSelected();

      // Pass a reference to the actual widget
      if (typeof _action.data == 'undefined' || !_action.data) _action.data = {};
      _action.data.nextmatch = self._widget;

      // Call the nm_action function with the ids
      nm_action(_action, _senders, _target, ids);
    });

    // Set the 'Select All' handler
    var select_all = this._actionManager.getActionById('select_all');
    if (select_all) {
      select_all.set_onExecute(jQuery.proxy(function (action, selected) {
        this._selectionMgr.selectAll();
      }, this));
    }

    // Initialize the object manager - look for application
    // object manager 1 level deep
    var gom = egw_getObjectManager(this.egw.appName, true, 1);
    if (this._objectManager == null) {
      this._objectManager = gom.addObject(new egwActionObjectManager(uid, this._actionManager));
      this._objectManager.handleKeyPress = function (_keyCode, _shift, _ctrl, _alt) {
        for (var i = 0; i < self._actionManager.children.length; i++) {
          if (typeof self._actionManager.children[i].shortcut === 'object' && self._actionManager.children[i].shortcut && _keyCode == self._actionManager.children[i].shortcut.keyCode) {
            return this.executeActionImplementation({
              "keyEvent": {
                "keyCode": _keyCode,
                "shift": _shift,
                "ctrl": _ctrl,
                "alt": _alt
              }
            }, "popup", EGW_AO_EXEC_SELECTED);
          }
        }
        return egwActionObject.prototype.handleKeyPress.call(this, _keyCode, _shift, _ctrl, _alt);
      };
    }
    this._objectManager.flags = this._objectManager.flags | EGW_AO_FLAG_DEFAULT_FOCUS | EGW_AO_FLAG_IS_CONTAINER;
    this._init_links_dnd();
    if (this._selectionMgr) {
      // Need to update the action links for every registered row too
      for (var uid in this._selectionMgr._registeredRows) {
        // Get the corresponding entry from the registered rows array
        var entry = this._selectionMgr._getRegisteredRowsEntry(uid);
        if (entry.ao) {
          entry.ao.updateActionLinks(this._actionLinks);
        }
      }
    }
  }

  /**
   * Automatically add dnd support for linking
   */
  _init_links_dnd() {
    var mgr = this._actionManager;
    var self = this;
    var drop_action = mgr.getActionById('egw_link_drop');
    var drag_action = mgr.getActionById('egw_link_drag');
    var drop_cancel = mgr.getActionById('egw_cancel_drop');
    if (!this._actionLinks) {
      this._actionLinks = [];
    }
    if (!drop_cancel) {
      // Create a generic cancel action in order to cancel drop action
      // applied for all apps plus file and link action.
      drop_cancel = mgr.addAction('drop', 'egw_cancel_drop', this.egw.lang('Cancel'), egw$1.image('cancel'), function () {}, true);
      drop_cancel.set_group('99');
      drop_cancel.acceptedTypes = drop_cancel.acceptedTypes.concat(Object.keys(egw$1.user('apps')).concat(['link', 'file']));
      this._actionLinks.push(drop_cancel.id);
    }

    // Check if this app supports linking
    if (!egw$1.link_get_registry(this.dataStorePrefix || this.egw.appName, 'query') || egw$1.link_get_registry(this.dataStorePrefix || this.egw.appName, 'title')) {
      if (drop_action) {
        drop_action.remove();
        if (this._actionLinks.indexOf(drop_action.id) >= 0) {
          this._actionLinks.splice(this._actionLinks.indexOf(drop_action.id), 1);
        }
      }
      if (drag_action) {
        drag_action.remove();
        if (this._actionLinks.indexOf(drag_action.id) >= 0) {
          this._actionLinks.splice(this._actionLinks.indexOf(drag_action.id), 1);
        }
      }
      return;
    }

    // Don't re-add
    if (drop_action == null) {
      // Create the drop action that links entries
      drop_action = mgr.addAction('drop', 'egw_link_drop', this.egw.lang('Create link'), egw$1.image('link'), function (action, source, dropped) {
        // Extract link IDs
        var links = [];
        var id = '';
        for (var i = 0; i < source.length; i++) {
          if (!source[i].id) continue;
          id = source[i].id.split('::');
          links.push({
            app: id[0] == 'filemanager' ? 'link' : id[0],
            id: id[1]
          });
        }
        if (!links.length) {
          return;
        }

        // Link the entries
        self.egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link", dropped.id.split('::').concat([links]), function (result) {
          if (result) {
            for (var i = 0; i < this._objectManager.selectedChildren.length; i++) {
              this._widget.refresh(this._objectManager.selectedChildren[i].id, 'update');
            }
            this._widget.egw().message('Linked');
            // Update the target to show the liks
            this._widget.refresh(dropped.id, 'update');
          }
        }, self, true, self).sendRequest();
      }, true);
    }
    if (this._actionLinks.indexOf(drop_action.id) < 0) {
      this._actionLinks.push(drop_action.id);
    }
    // Accept other links, and files dragged from the filemanager
    // This does not handle files dragged from the desktop.  They are
    // handled by et2_nextmatch, since it needs DOM stuff
    if (drop_action.acceptedTypes.indexOf('link') == -1) {
      drop_action.acceptedTypes.push('link');
    }

    // Don't re-add
    if (drag_action == null) {
      // Create drag action that allows linking
      drag_action = mgr.addAction('drag', 'egw_link_drag', this.egw.lang('link'), 'link', function (action, selected) {
        // Drag helper - list titles.  Arbitrarily limited to 10.
        var helper = jQuery(document.createElement("div"));
        for (var i = 0; i < selected.length && i < 10; i++) {
          var id = selected[i].id.split('::');
          var span = jQuery(document.createElement('span')).appendTo(helper);
          self.egw.link_title(id[0], id[1], function (title) {
            this.append(title);
            this.append('<br />');
          }, span);
        }
        // As we wanted to have a general defaul helper interface, we return null here and not using customize helper for links
        // TODO: Need to decide if we need to create a customized helper interface for links anyway
        //return helper;
        return null;
      }, true);
    }
    if (this._actionLinks.indexOf(drag_action.id) < 0) {
      this._actionLinks.push(drag_action.id);
    }
    drag_action.set_dragType('link');
  }

  /**
   * Set the data cache prefix
   * Overridden from the parent to re-check automatically the added link dnd
   * since the prefix is used in support detection.
   */
  setPrefix(prefix) {
    super.setPrefix(prefix);
    this._init_links_dnd();
  }

  /**
   * Overwrites the inherited _destroyCallback function in order to be able
   * to free the "rowWidget".
   */
  _destroyCallback(_row) {
    // Destroy any widget associated to the row
    if (this.entry.widget) {
      this.entry.widget.destroy();
      this.entry.widget = null;
    }

    // Call the inherited function
    super._destroyCallback(_row);
  }

  /**
   * Creates the actual data row.
   *
   * @param _data is an array containing the row data
   * @param _tr is the tr into which the data will be inserted
   * @param _idx is the index of the row
   * @param _entry is the internal row datastructure of the controller, in
   * this special case used to store the rowWidget reference, so that it can
   * be properly freed.
   */
  _nmRowCallback(_data, _tr, _idx, _entry) {
    // Let the row provider fill in the data row -- store the returned
    // rowWidget inside the _entry
    _entry.widget = this._rowProvider.getDataRow({
      "content": _data
    }, _tr, _idx, this);
  }

  /**
   * Returns the names of action links for a given data row -- currently these are
   * always the same links, as we controll enabled/disabled over the row
   * classes, unless the row UID is "", then it's an 'empty' row.
   *
   * The empty row placeholder can still have actions, but nothing that requires
   * an actual UID.
   *
   * @TODO: Currently empty row is just add, need to actually filter somehow.  Here
   * 	might not be the right place.
   *
   * @param _data Object The data for the row
   * @param _idx int The row index
   * @param _uid String The row's ID
   *
   * @return Array List of action names that valid for the row
   */
  _nmLinkCallback(_data, _idx, _uid) {
    if (_uid.trim() != "") {
      return this._actionLinks;
    }

    // No UID, so return a filtered list of actions that doesn't need a UID
    var links = [];
    try {
      links = typeof this._widget.options.settings.placeholder_actions != 'undefined' ? this._widget.options.settings.placeholder_actions : this._widget.options.add ? ["add"] : [];
      // Make sure that placeholder actions are defined and existed in client-side,
      // otherwise do not set them as placeholder. for instance actions with
      // attribute hideOnMobile do not get sent to client-side.
      var action_search = function action_search(current) {
        if (typeof this._widget.options.actions[current] !== 'undefined') return true;
        // Check children
        for (var action in this._widget.options.actions) {
          action = this._widget.options.actions[action];
          if (action.children && action.children[current]) return true;
        }
        return false;
      };
      links = links.filter(action_search, this);
    } catch (e) {}
    return links;
  }

  /**
   * Overridden from the parent to also process any additional data that
   * the data source adds, such as readonlys and additonal content.
   * For example, non-numeric IDs in rows are added to the content manager
   */
  _fetchCallback(_response) {
    var nm = this.self._widget;
    if (!nm) {
      // Nextmatch either not connected, or it tried to destroy this
      // but the server returned something
      return;
    }
    // Readonlys
    // Other stuff
    for (var i in _response.rows) {
      if (jQuery.isNumeric(i)) continue;
      if (i == 'sel_options') {
        var mgr = nm.getArrayMgr(i);
        for (var id in _response.rows.sel_options) {
          mgr.data[id] = _response.rows.sel_options[id];
          var select = nm.getWidgetById(id);
          if (select && select.set_select_options) {
            select.set_select_options(_response.rows.sel_options[id]);
          }
          // Clear rowProvider internal cache so it uses new values
          if (id == 'cat_id') {
            this.self._rowProvider.categories = null;
          }
          // update array mgr so select widgets in row also get refreshed options
          nm.getParent().getArrayMgr('sel_options').data[id] = _response.rows.sel_options[id];
        }
      } else if (i === "order" && _response.rows[i] !== nm.activeFilters.order) {
        nm.sortBy(_response.rows[i], undefined, false);
      } else {
        var mgr = nm.getArrayMgr('content');
        mgr.data[i] = _response.rows[i];

        // It's not enough to just update the data, the widgets need to
        // be updated too, if there are matching widgets.
        var widget = nm.getWidgetById(i);
        if (widget && widget.set_value) {
          widget.set_value(mgr.getEntry(i));
        }
      }
    }
    // Might be trying to disable a column
    var col_refresh = false;
    for (var column_index = 0; column_index < nm.columns.length; column_index++) {
      if (typeof nm.columns[column_index].disabled === 'string' && nm.columns[column_index].disabled[0] === '@') {
        col_refresh = true;
        nm.dataview.columnMgr.getColumnById('col_' + column_index).set_visibility(nm.getArrayMgr('content').parseBoolExpression(nm.columns[column_index].disabled) ? et2_dataview_column.ET2_COL_VISIBILITY_DISABLED : nm.columns[column_index].visible);
      }
    }
    if (col_refresh) {
      nm.dataview.columnMgr.updated();
      nm.dataview._updateColumns();
    }

    // If we're doing an autorefresh and the count decreases, preserve the
    // selection or it will be lost when the grid rows are shuffled.  Increases
    // are fine though.
    if (this.self && this.self.kept_selection == null && !this.refresh && this.self._grid.getTotalCount() > _response.total) {
      this.self.keepSelection();
    }

    // Call the inherited function
    super._fetchCallback.apply(this, arguments);

    // Restore selection, if passed
    if (this.self && this.self.kept_selection && this.self._selectionMgr) {
      if (this.self.kept_selection.all) {
        this.self._selectionMgr.selectAll();
      }
      for (var i = (this.self.kept_selection.ids.length || 1) - 1; i >= 0; i--) {
        // Only keep the selected if they came back in the fetch
        if (_response.order.indexOf(this.self.kept_selection.ids[i]) >= 0) {
          this.self._selectionMgr.setSelected(this.self.kept_selection.ids[i], true);
          this.self.kept_selection.ids.splice(i, 1);
        } else {
          this.self.kept_selection.ids.splice(i, 1);
        }
      }
      if (this.self.kept_focus && _response.order.indexOf(this.self.kept_focus) >= 0) {
        this.self._selectionMgr.setFocused(this.self.kept_focus, true);
      }
      // Re-expanding rows handled in et2_extension_nextmatch_rowProvider
      // Expansions might still be valid, so we don't clear them
      if (this.self.kept_selection != null && typeof this.self.kept_selection.ids != 'undefined' && this.self.kept_selection.ids.length == 0) {
        this.self.kept_selection = null;
      }
      this.self.kept_focus = null;
    }
  }

  /**
   * Execute the select callback when the row selection changes
   */
  _selectCallback(action, senders) {
    if (typeof senders == "undefined") {
      senders = [];
    }
    if (!this._widget) return;

    // inform mobile framework about nm selections, need to update status of header objects on selection
    if (egwIsMobile$1()) window.framework.nm_onselect_ctrl(this._widget, action, senders);
    this._widget.onselect.call(this._widget, action, senders);
  }

  /** -- Implementation of et2_IDataProvider -- **/

  dataFetch(_queriedRange, _callback, _context) {
    // Merge the parent id into the _queriedRange if it is set
    if (this._parentId !== null) {
      _queriedRange["parent_id"] = this._parentId;
    }

    // sub-levels dont have there own _filters object, need to use the one from parent (or it's parents parent)
    var obj = this;
    while ((typeof obj._filters == 'undefined' || jQuery.isEmptyObject(obj._filters)) && obj._parentController) {
      obj = obj._parentController;
    }

    // Pass the fetch call to the API, multiplex the data about the
    // nextmatch instance into the call.
    this.egw.dataFetch(this._widget.getInstanceManager().etemplate_exec_id || this._execId, _queriedRange, obj._filters, this._widgetId, _callback, _context);
  }
  dataRegisterUID(_uid, _callback, _context) {
    // Make sure we use correct prefix when data comes back
    if (this._widget && this._widget._get_appname() != this.egw.getAppName()) {
      _context.prefix = _uid.split('::')[0];
    }
    this.egw.dataRegisterUID(_uid, _callback, _context, this._widget.getInstanceManager().etemplate_exec_id || this._execId, this._widgetId);
  }
  dataUnregisterUID() {
    // Overwritten in the constructor
  }
}
// Display constants
_defineProperty$1E(et2_nextmatch_controller, "VIEW_ROW", 'row');
_defineProperty$1E(et2_nextmatch_controller, "VIEW_TILE", 'tile');

var _class$7;
function _defineProperty$1D(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * This set of functions is currently only supporting resizing in ew-direction
 */

class et2_dataview_view_resizable {
  // In resize region returns whether the mouse is currently in the
  // "resizeRegion"
  static inResizeRegion(_x, _elem) {
    var ol = _x - _elem.offset().left;
    return ol > _elem.outerWidth(true) - et2_dataview_view_resizable.RESIZE_BORDER;
  }
  static startResize(_outerElem, _elem, _callback, _column) {
    if (this.overlay == null || this.helper == null) {
      // Prevent text selection
      // FireFox handles highlight prevention (text selection) different than other browsers
      if (typeof _elem[0].style.MozUserSelect != "undefined") {
        _elem[0].style.MozUserSelect = "none";
      } else {
        _elem[0].onselectstart = function () {
          return false;
        };
      }

      // Indicate resizing is in progress
      jQuery(_outerElem).addClass('egwResizing');

      // Reset the "didResize" flag
      this.didResize = false;

      // Create the resize helper
      var left = _elem.offset().left;
      this.helper = jQuery(document.createElement("div")).addClass("egwResizeHelper").appendTo("body").css("top", _elem.offset().top + "px").css("left", left + "px").css("height", _outerElem.outerHeight(true) + "px");

      // Create the overlay which will be catching the mouse movements
      this.overlay = jQuery(document.createElement("div")).addClass("egwResizeOverlay").bind("mousemove", function (e) {
        this.didResize = true;
        this.resizeWidth = Math.max(e.pageX - left + et2_dataview_view_resizable.RESIZE_ADD, _column && _column.minWidth ? _column.minWidth : et2_dataview_view_resizable.RESIZE_MIN_WIDTH);
        this.helper.css("width", this.resizeWidth + "px");
      }.bind(this)).bind("mouseup", function () {
        this.stopResize(_outerElem);

        // Reset text selection
        _elem[0].onselectstart = null;

        // Call the callback if the user actually performed a resize
        if (this.didResize) {
          _callback(this.resizeWidth);
        }
      }.bind(this)).appendTo("body");
    }
  }
  static stopResize(_outerElem) {
    jQuery(_outerElem).removeClass('egwResizing');
    if (this.helper != null) {
      this.helper.remove();
      this.helper = null;
    }
    if (this.overlay != null) {
      this.overlay.remove();
      this.overlay = null;
    }
  }
}
_class$7 = et2_dataview_view_resizable;
// Define some constants
_defineProperty$1D(et2_dataview_view_resizable, "RESIZE_BORDER", 12);
_defineProperty$1D(et2_dataview_view_resizable, "RESIZE_MIN_WIDTH", 25);
_defineProperty$1D(et2_dataview_view_resizable, "RESIZE_ADD", 2);
// Used to ensure mouse is under the resize element after resizing has finished
_defineProperty$1D(et2_dataview_view_resizable, "helper", null);
_defineProperty$1D(et2_dataview_view_resizable, "overlay", null);
_defineProperty$1D(et2_dataview_view_resizable, "didResize", false);
_defineProperty$1D(et2_dataview_view_resizable, "resizeWidth", 0);
_defineProperty$1D(et2_dataview_view_resizable, "makeResizeable", function (_elem, _callback, _context) {
  // Get the table surrounding the given element - this element is used to
  // align the helper properly
  var outerTable = _elem.closest("table");

  // Bind the "mousemove" event in the "resize" namespace
  _elem.bind("mousemove.resize", function (e) {
    var stopResize = false;
    // Stop switch to resize cursor if the mouse position
    // is more intended for scrollbar not the resize edge
    // 8pixel is an arbitary number for scrolbar area
    if (e.target.clientHeight < e.target.scrollHeight && e.target.offsetWidth - e.offsetX <= 8) {
      stopResize = true;
    }
    _elem.css("cursor", _class$7.inResizeRegion(e.pageX, _elem) && !stopResize ? "ew-resize" : "auto");
  });

  // Bind the "mousedown" event in the "resize" namespace
  _elem.bind("mousedown.resize", function (e) {
    // Only do resize on the column edge, ignore mousedown on widgets
    var stopResize = e.target.tagName.toLowerCase() !== "th";
    // Stop resize if the mouse position is more intended
    // for scrollbar not the resize edge
    // 8pixel is an arbitary number for scrolbar area
    if (e.target.clientHeight < e.target.scrollHeight && e.target.offsetWidth - e.offsetX <= 8) {
      stopResize = true;
    }
    // Do not triger startResize if clicked element is select-tag, as it may causes conflict in some browsers
    if (_class$7.inResizeRegion(e.pageX, _elem) && e.target.tagName != 'SELECT' && !stopResize) {
      // Start the resizing
      _class$7.startResize(outerTable, _elem, function (_w) {
        _callback.call(_context, _w);
      }, _context);
    }
  });

  // Bind double click for auto-size
  _elem.dblclick(function (e) {
    // Just show message for relative width columns
    if (_context && _context.relativeWidth) {
      return egw$1.message(egw$1.lang('You tried to automatically size a flex column, which always takes the rest of the space', 'info'));
    }
    // Find column class - it's usually the first one
    var col_class = '';
    for (var i = 0; i < this.classList.length; i++) {
      if (this.classList[i].indexOf('gridCont') === 0) {
        col_class = this.classList[i];
        break;
      }
    }

    // Find widest part, including header
    var column = jQuery(this);
    column.children().css('width', 'auto');
    var max_width = column.children().children().innerWidth();
    var padding = column.outerWidth(true) - max_width;
    var resize = jQuery(this).closest('.egwGridView_outer').find('tbody td.' + col_class + '> div:first-child').add(column.children())
    // Set column width to auto to allow space for everything to flow
    .css('width', 'auto');
    resize.children().css({
      'white-space': 'nowrap'
    }).each(function () {
      var col = jQuery(this);
      // Find visible (text) children and force them to not wrap
      var children = col.find('span:visible, time:visible, label:visible').css({
        'white-space': 'nowrap'
      });
      this.offsetWidth;
      children.each(function () {
        var child = jQuery(this);
        this.offsetWidth;
        if (child.outerWidth() > max_width) {
          max_width = child.outerWidth();
        }
        window.getComputedStyle(this).width;
      });
      this.offsetWidth;
      if (col.innerWidth() > max_width) {
        max_width = col.innerWidth();
      }

      // Reset children
      children.css('white-space', '');
      children.css('display', '');
    }).css({
      'white-space': ''
    });

    // Reset column
    column.children().css('width', '');
    resize.css('width', '');
    _callback.call(_context, max_width + padding);
  });
});
_defineProperty$1D(et2_dataview_view_resizable, "et2_dataview_resetResizeable", function (_elem) {
  // Remove all events in the ".resize" namespace from the element
  _elem.unbind(".resize");
});

function _defineProperty$1C(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * EGroupware eTemplate2 - Class which contains a factory method for rows
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright EGroupware GmbH 2011-2021
 */

/*egw:uses
	/vendor/bower-asset/jquery/dist/jquery.js;
	et2_core_inheritance;
	et2_core_interfaces;
	et2_core_arrayMgr;
	et2_core_widget;
*/

/**
 * The row provider contains prototypes (full clonable dom-trees)
 * for all registered row types.
 */
class et2_dataview_rowProvider {
  /**
   *
   * @param _outerId
   * @param _columnIds
   */
  constructor(_outerId, _columnIds) {
    _defineProperty$1C(this, "_outerId", void 0);
    _defineProperty$1C(this, "_columnIds", void 0);
    _defineProperty$1C(this, "_prototypes", void 0);
    _defineProperty$1C(this, "_template", void 0);
    _defineProperty$1C(this, "_mgrs", void 0);
    _defineProperty$1C(this, "_rootWidget", void 0);
    // Copy the given parameters
    this._outerId = _outerId;
    this._columnIds = _columnIds;
    this._prototypes = {};
    this._template = null;
    this._mgrs = null;
    this._rootWidget = null;

    // Create the default row "prototypes"
    this._createFullRowPrototype();
    this._createDefaultPrototype();
    this._createEmptyPrototype();
    this._createLoadingPrototype();
  }
  destroy() {
    this._template = null;
    this._mgrs = null;
    this._rootWidget = null;
    this._prototypes = {};
    this._columnIds = [];
  }
  getColumnCount() {
    return this._columnIds.length;
  }

  /**
   * Returns a clone of the prototype with the given name. If the generator
   * callback function is given, this function is called if the prototype
   * does not yet registered.
   *
   * @param {string} _name
   * @param {function} _generator
   * @param {object} _context
   */
  getPrototype(_name, _generator, _context) {
    if (typeof this._prototypes[_name] == "undefined") {
      if (typeof _generator != "undefined") {
        this._prototypes[_name] = _generator.call(_context, this._outerId, this._columnIds);
      } else {
        return null;
      }
    }
    return this._prototypes[_name].clone();
  }

  /* ---- PRIVATE FUNCTIONS ---- */

  _createFullRowPrototype() {
    var tr = jQuery(document.createElement("tr"));
    var td = jQuery(document.createElement("td")).addClass(this._outerId + "_td_fullRow").attr("colspan", this._columnIds.length).appendTo(tr);
    var div = jQuery(document.createElement("div")).addClass(this._outerId + "_div_fullRow").appendTo(td);
    this._prototypes["fullRow"] = tr;
  }
  _createDefaultPrototype() {
    var tr = jQuery(document.createElement("tr"));

    // Append a td for each column
    for (var column of this._columnIds) {
      if (!column) continue;
      var td = jQuery(document.createElement("td")).addClass(this._outerId + "_td_" + column).appendTo(tr);
      var div = jQuery(document.createElement("div")).addClass(this._outerId + "_div_" + column).addClass("innerContainer").appendTo(td);
    }
    this._prototypes["default"] = tr;
  }
  _createEmptyPrototype() {
    this._prototypes["empty"] = jQuery(document.createElement("tr"));
  }
  _createLoadingPrototype() {
    var fullRow = this.getPrototype("fullRow");
    jQuery("div", fullRow).addClass("loading");
    this._prototypes["loading"] = fullRow;
  }
}

function _defineProperty$1B(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The et2_dataview class is the main class for displaying a dataview. The
 * dataview class manages the creation of the outer html nodes (like the table,
 * header, etc.) and contains the root container: an instance of
 * et2_dataview_view_grid, which can be accessed using the "grid" property of
 * this object.
 *
 * @augments Class
 */
class et2_dataview {
  /**
   * Constructor for the grid container
   *
   * @param {DOMElement} _parentNode is the DOM-Node into which the grid view will be inserted
   * @param {egw} _egw
   * @memberOf et2_dataview
   */
  constructor(_parentNode, _egw) {
    /**
     * Constant which regulates the column padding.
     */
    _defineProperty$1B(this, "columnPadding", void 0);
    /**
     * Some browser dependant variables which will be calculated on creation of
     * the first gridContainer object.
     */
    _defineProperty$1B(this, "scrollbarWidth", void 0);
    _defineProperty$1B(this, "headerBorderWidth", void 0);
    _defineProperty$1B(this, "columnBorderWidth", void 0);
    _defineProperty$1B(this, "width", void 0);
    _defineProperty$1B(this, "height", void 0);
    _defineProperty$1B(this, "uniqueId", void 0);
    /**
     * Hooks to allow parent to keep up to date if things change
     */
    _defineProperty$1B(this, "onUpdateColumns", void 0);
    _defineProperty$1B(this, "selectColumnsClick", void 0);
    _defineProperty$1B(this, "parentNode", void 0);
    _defineProperty$1B(this, "egw", void 0);
    _defineProperty$1B(this, "columnNodes", void 0);
    _defineProperty$1B(this, "columns", void 0);
    _defineProperty$1B(this, "columnMgr", void 0);
    _defineProperty$1B(this, "rowProvider", void 0);
    _defineProperty$1B(this, "grid", void 0);
    // DOM stuff
    _defineProperty$1B(this, "selectColIcon", void 0);
    _defineProperty$1B(this, "headTr", void 0);
    _defineProperty$1B(this, "containerTr", void 0);
    _defineProperty$1B(this, "selectCol", void 0);
    _defineProperty$1B(this, "thead", void 0);
    _defineProperty$1B(this, "tbody", void 0);
    _defineProperty$1B(this, "table", void 0);
    _defineProperty$1B(this, "visibleColumnCount", void 0);
    // Copy the arguments
    this.parentNode = jQuery(_parentNode);
    this.egw = _egw;

    // Initialize some variables
    this.columnNodes = []; // Array with the header containers
    this.columns = [];
    this.columnMgr = null;
    this.rowProvider = null;
    this.width = 0;
    this.height = 0;
    this.uniqueId = "gridCont_" + this.egw.uid();

    // Build the base nodes
    this._createElements();

    // Read the browser dependant variables
    this._getDepVars();
  }

  /**
   * Destroys the object, removes all dom nodes and clears all references.
   */
  destroy() {
    // Clear the columns
    this._clearHeader();

    // Free the grid
    if (this.grid) {
      this.grid.destroy();
    }

    // Free the row provider
    if (this.rowProvider) {
      this.rowProvider.destroy();
    }

    // Detatch the outer element
    this.table.remove();
  }

  /**
   * Clears all data rows and reloads them
   */
  clear() {
    if (this.grid) {
      this.grid.clear();
    }
  }

  /**
   * Returns the column container node for the given column index
   *
   * @param _columnIdx the integer column index
   */
  getHeaderContainerNode(_columnIdx) {
    if (typeof this.columnNodes[_columnIdx] != "undefined") {
      return this.columnNodes[_columnIdx].container[0];
    }
    return null;
  }

  /**
   * Sets the column descriptors and creates the column header according to it.
   * The inner grid will be emptied if it has already been built.
   */
  setColumns(_columnData) {
    // Free all column objects which have been created till this moment
    this._clearHeader();

    // Copy the given column data
    this.columnMgr = new et2_dataview_columns(_columnData);

    // Create the stylesheets
    this.updateColumns();

    // Build the header row
    this._buildHeader();

    // Build the grid
    this._buildGrid();
  }

  /**
   * Resizes the grid
   */
  resize(_w, _h) {
    // Not fully initialized yet...
    if (!this.columnMgr) return;
    if (this.width != _w) {
      this.width = _w;

      // Take grid border width into account
      _w -= this.table.outerWidth(true) - this.table.innerWidth();

      // Take grid header border's width into account. eg. category colors may add extra pixel into width
      _w = _w - (this.thead.find('tr').outerWidth() - this.thead.find('tr').innerWidth());

      // Rebuild the column stylesheets
      this.columnMgr.setTotalWidth(_w - this.scrollbarWidth);
      this._updateColumns();
    }
    if (this.height != _h) {
      this.height = _h;

      // Set the height of the grid.
      if (this.grid) {
        this.grid.setScrollHeight(this.height - this.headTr.outerHeight(true));
      }
    }
  }

  /**
   * Returns the column manager object. You can use it to set the visibility
   * of columns etc. Call "updateHeader" if you did any changes.
   */
  getColumnMgr() {
    return this.columnMgr;
  }

  /**
   * Recalculates the stylesheets which determine the column visibility and
   * width.
   *
   * @param setDefault boolean Allow admins to save current settings as default for all users
   */
  updateColumns() {
    var setDefault = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    if (this.columnMgr) {
      this._updateColumns();
    }

    // Ability to notify parent / someone else
    if (this.onUpdateColumns) {
      this.onUpdateColumns(setDefault);
    }
  }

  /* --- PRIVATE FUNCTIONS --- */

  /* --- Code for building the grid container DOM-Tree elements ---- */

  /**
   * Builds the base DOM-Tree elements
   */
  _createElements() {
    /*
    	Structure:
    	<table class="egwGridView_outer">
    		<thead>
    			<tr> [HEAD] </tr>
    		</thead>
    		<tbody>
    			<tr> [GRID CONTAINER] </tr>
    		</tbody>
    	</table>
    */

    this.containerTr = jQuery(document.createElement("tr"));
    this.headTr = jQuery(document.createElement("tr"));
    this.thead = jQuery(document.createElement("thead")).append(this.headTr);
    this.tbody = jQuery(document.createElement("tbody")).append(this.containerTr);
    this.table = jQuery(document.createElement("table")).addClass("egwGridView_outer").append(this.thead, this.tbody).appendTo(this.parentNode);
  }

  /* --- Code for building the header row --- */

  /**
   * Clears the header row
   */
  _clearHeader() {
    if (this.columnMgr) {
      this.columnMgr.destroy();
      this.columnMgr = null;
    }

    // Remove dynamic CSS,
    for (var i = 0; i < this.columns.length; i++) {
      if (this.columns[i].tdClass) {
        this.egw.css('.' + this.columns[i].tdClass);
      }
      if (this.columns[i].divClass) {
        this.egw.css('.' + this.columns[i].divClass);
        this.egw.css(".egwGridView_outer ." + this.columns[i].divClass);
        this.egw.css(".egwGridView_grid ." + this.columns[i].divClass);
      }
    }
    this.egw.css(".egwGridView_grid ." + this.uniqueId + "_div_fullRow");
    this.egw.css(".egwGridView_outer ." + this.uniqueId + "_td_fullRow");
    this.egw.css(".egwGridView_outer ." + this.uniqueId + "_spacer_fullRow");

    // Reset the headerColumns array and empty the table row
    this.columnNodes = [];
    this.columns = [];
    this.headTr.empty();
  }

  /**
   * Sets the column data which is retrieved by calling egwGridColumns.getColumnData.
   * The columns will be updated.
   */
  _updateColumns() {
    // Copy the columns data
    this.columns = this.columnMgr.getColumnData();

    // Count the visible rows
    var total_cnt = 0;
    for (var i = 0; i < this.columns.length; i++) {
      if (this.columns[i].visible) {
        total_cnt++;
      }
    }

    // Set the grid column styles
    var first = true;
    var vis_col = this.visibleColumnCount = 0;
    var totalWidth = 0;
    for (var i = 0; i < this.columns.length; i++) {
      var col = this.columns[i];
      col.tdClass = this.uniqueId + "_td_" + col.id;
      col.divClass = this.uniqueId + "_div_" + col.id;
      if (col.visible) {
        vis_col++;
        this.visibleColumnCount++;

        // Update the visibility of the column
        this.egw.css("." + col.tdClass, "display: table-cell; " + "!important;");

        // Ugly browser dependant code - each browser seems to treat the
        // right (collapsed) border of the row differently
        var subBorder = 0;
        var subHBorder = 0;
        /*
        if (jQuery.browser.mozilla)
        {
        	var maj = jQuery.browser.version.split(".")[0];
        	if (maj < 2) {
        		subBorder = 1; // Versions <= FF 3.6
        	}
        }
        if (jQuery.browser.webkit)
        {
        	if (!first)
        	{
        		subBorder = 1;
        	}
        	subHBorder = 1;
        }
        if ((jQuery.browser.msie || jQuery.browser.opera) && first)
        {
        	subBorder = -1;
        }
        */

        // Make the last columns one pixel smaller, to prevent a horizontal
        // scrollbar from showing up
        if (vis_col == total_cnt) {
          subBorder += 1;
        }

        // Write the width of the header columns
        var headerWidth = Math.max(0, col.width - this.headerBorderWidth - subHBorder);
        this.egw.css(".egwGridView_outer ." + col.divClass, "width: " + headerWidth + "px;");

        // Write the width of the body-columns
        var columnWidth = Math.max(0, col.width - this.columnBorderWidth - subBorder);
        this.egw.css(".egwGridView_grid ." + col.divClass, "width: " + columnWidth + "px;");
        totalWidth += col.width;
        first = false;
      } else {
        this.egw.css("." + col.tdClass, "display: none;");
      }
    }

    // Add the full row and spacer class
    this.egw.css(".egwGridView_grid ." + this.uniqueId + "_div_fullRow", "width: " + (totalWidth - this.columnBorderWidth - 2) + "px; border-right-width: 0 !important;");
    this.egw.css(".egwGridView_outer ." + this.uniqueId + "_td_fullRow", "border-right-width: 0 !important;");
    this.egw.css(".egwGridView_outer ." + this.uniqueId + "_spacer_fullRow", "width: " + (totalWidth - 1) + "px; border-right-width: 0 !important;");
  }

  /**
   * Builds the containers for the header row
   */
  _buildHeader() {
    var self = this;
    var handler = function handler(event) {};
    for (var i = 0; i < this.columns.length; i++) {
      var col = this.columns[i];

      // Create the column header and the container element
      var cont = jQuery(document.createElement("div")).addClass("innerContainer").addClass(col.divClass);
      var column = jQuery(document.createElement("th")).addClass(col.tdClass).attr("align", "left").append(cont).appendTo(this.headTr);
      if (this.columnMgr && this.columnMgr.getColumnById(i)) {
        column.addClass(this.columnMgr.getColumnById(i).fixedWidth ? 'fixedWidth' : 'relativeWidth');
        if (this.columnMgr.getColumnById(i).visibility === et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT) {
          column.addClass('noResize');
        }
      }

      // make column resizable
      var enc_column = self.columnMgr.getColumnById(col.id);
      if (enc_column.visibility !== et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT) {
        et2_dataview_view_resizable.makeResizeable(column, function (_w) {
          // User wants the column to stay where they put it, even for relative
          // width columns, so set it explicitly first and adjust other relative
          // columns to match.
          if (this.relativeWidth) {
            // Set to selected width
            this.set_width(_w + "px");
            self.columnMgr.updated();
            // Just triggers recalculation
            self.columnMgr.getColumnWidth(0);

            // Set relative widths to match
            var relative = self.columnMgr.totalWidth - self.columnMgr.totalFixed + _w;
            this.set_width(_w / relative);
            for (var i = 0; i < self.columnMgr.columnCount(); i++) {
              var col = self.columnMgr.getColumnById('col_' + i);
              if (!col || col == this || col.fixedWidth) continue;
              col.set_width(self.columnMgr.getColumnWidth(i) / relative);
            }
            // Triggers column change callback, which saves
            self.updateColumns();
          } else {
            this.set_width(this.relativeWidth ? _w / self.columnMgr.totalWidth : _w + "px");
            self.columnMgr.updated();
            self.updateColumns();
          }
        }, enc_column);
      }

      // Store both nodes in the columnNodes array
      this.columnNodes.push({
        "column": column,
        "container": cont
      });
    }
    this._buildSelectCol();
  }

  /**
   * Builds the select cols column
   */
  _buildSelectCol() {
    // Build the "select columns" icon
    this.selectColIcon = jQuery(document.createElement("span")).addClass("selectcols").css('display', 'inline-block'); // otherwise jQuery('span.selectcols',this.dataview.headTr).show() set it to "inline" causing it to not show up because 0 height

    // Build the option column
    this.selectCol = jQuery(document.createElement("th")).addClass("optcol").append(this.selectColIcon)
    // Toggle display of option popup
    .click(this, function (e) {
      if (e.data.selectColumnsClick) e.data.selectColumnsClick(e);
    }).appendTo(this.headTr);
    this.selectCol.css("width", this.scrollbarWidth - this.selectCol.outerWidth() + this.selectCol.width() + 1);
  }

  /**
   * Builds the inner grid class
   */
  _buildGrid() {
    // Create the collection of column ids
    var colIds = [];
    for (var i = 0; i < this.columns.length; i++) {
      if (this.columns[i].visible) {
        colIds[i] = this.columns[i].id;
      }
    }

    // Create the row provider
    if (this.rowProvider) {
      this.rowProvider.destroy();
    }
    this.rowProvider = new et2_dataview_rowProvider(this.uniqueId, colIds);

    // Create the grid class and pass "19" as the starting average row height
    this.grid = new et2_dataview_grid(null, null, this.egw, this.rowProvider, 19);

    // Insert the grid into the DOM-Tree
    var tr = jQuery(this.grid.getFirstNode());
    this.containerTr.replaceWith(tr);
    this.containerTr = tr;
  }

  /* --- Code for calculating the browser/css depending widths --- */

  /**
   * Reads the browser dependant variables
   */
  _getDepVars() {
    if (typeof this.scrollbarWidth === 'undefined') {
      // Clone the table and attach it to the outer body tag
      var clone = this.table.clone();
      jQuery(egw$1.top.document.getElementsByTagName("body")[0]).append(clone);

      // Read the scrollbar width
      this.scrollbarWidth = this.constructor.prototype.scrollbarWidth = this._getScrollbarWidth(clone);

      // Read the header border width
      this.headerBorderWidth = this.constructor.prototype.headerBorderWidth = this._getHeaderBorderWidth(clone);

      // Read the column border width
      this.columnBorderWidth = this.constructor.prototype.columnBorderWidth = this._getColumnBorderWidth(clone);

      // Remove the cloned DOM-Node again from the outer body
      clone.remove();
    }
  }

  /**
   * Reads the scrollbar width
   */
  _getScrollbarWidth(_table) {
    // Create a temporary td and two divs, which are inserted into the
    // DOM-Tree. The outer div has a fixed size and "overflow" set to auto.
    // When the second div is inserted, it will be forced to display a scrollbar.
    var div_inner = jQuery(document.createElement("div")).css("height", "1000px");
    var div_outer = jQuery(document.createElement("div")).css("height", "100px").css("width", "100px").css("overflow", "auto").append(div_inner);
    var td = jQuery(document.createElement("td")).append(div_outer);

    // Store the scrollbar width statically.
    jQuery("tbody tr", _table).append(td);
    var width = Math.max(10, div_outer.outerWidth() - div_inner.outerWidth());

    // Remove the elements again
    div_outer.remove();
    return width;
  }

  /**
   * Calculates the total width of the header column border
   */
  _getHeaderBorderWidth(_table) {
    // Create a temporary th which is appended to the outer thead row
    var cont = jQuery(document.createElement("div")).addClass("innerContainer");
    var th = jQuery(document.createElement("th")).append(cont);

    // Insert the th into the document tree
    jQuery("thead tr", _table).append(th);

    // Calculate the total border width
    var width = th.outerWidth(true) - cont.width();

    // Remove the appended element again
    th.remove();
    return width;
  }

  /**
   * Calculates the total width of the column border
   */
  _getColumnBorderWidth(_table) {
    // Create a temporary th which is appended to the outer thead row
    var cont = jQuery(document.createElement("div")).addClass("innerContainer");
    var td = jQuery(document.createElement("td")).append(cont);

    // Insert the th into the document tree
    jQuery("tbody tr", _table).append(td);

    // Calculate the total border width
    _table.addClass("egwGridView_grid");
    var width = td.outerWidth(true) - cont.width();

    // Remove the appended element again
    td.remove();
    return width;
  }
}

function ownKeys$S(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$R(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$S(Object(source), true).forEach(function (key) { _defineProperty$1A(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$S(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1A(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class et2_customfields_list extends et2_valueWidget {
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_customfields_list._attributes, _child || {}));

    // Some apps (infolog edit) don't give ID, so assign one to get settings
    _defineProperty$1A(this, "tbody", void 0);
    _defineProperty$1A(this, "table", void 0);
    _defineProperty$1A(this, "rows", {});
    _defineProperty$1A(this, "widgets", {});
    _defineProperty$1A(this, "detachedNodes", []);
    if (!this.id) {
      this.id = _attrs.id = et2_customfields_list.DEFAULT_ID;

      // Add all attributes hidden in the content arrays to the attributes
      // parameter
      this.transformAttributes(_attrs);

      // Create a local copy of the options object
      this.options = et2_cloneObject(_attrs);
    }

    // Create the table body and the table
    this.tbody = jQuery(document.createElement("tbody"));
    this.table = jQuery(document.createElement("table")).addClass("et2_grid et2_customfield_list");
    this.table.append(this.tbody);
    if (!this.options.fields) this.options.fields = {};
    if (typeof this.options.fields === 'string') {
      var fields = this.options.fields.split(',');
      this.options.fields = {};
      for (var i = 0; i < fields.length; i++) {
        this.options.fields[fields[i]] = true;
      }
    }
    if (this.options.type_filter && typeof this.options.type_filter == "string") {
      this.options.type_filter = this.options.type_filter.split(",");
    }
    if (this.options.type_filter) {
      var already_filtered = !jQuery.isEmptyObject(this.options.fields);
      for (var field_name in this.options.customfields) {
        // Already excluded?
        if (already_filtered && !this.options.fields[field_name]) continue;
        if (!this.options.customfields[field_name].type2 || this.options.customfields[field_name].type2.length == 0 || this.options.customfields[field_name].type2 == '0') {
          // No restrictions
          this.options.fields[field_name] = true;
          continue;
        }
        var types = typeof this.options.customfields[field_name].type2 == 'string' ? this.options.customfields[field_name].type2.split(",") : this.options.customfields[field_name].type2;
        this.options.fields[field_name] = false;
        for (var i = 0; i < types.length; i++) {
          if (jQuery.inArray(types[i], this.options.type_filter) > -1) {
            this.options.fields[field_name] = true;
          }
        }
      }
    }
    this.setDOMNode(this.table[0]);
  }
  destroy() {
    super.destroy();
    this.rows = {};
    this.widgets = {};
    this.detachedNodes = [];
    this.tbody = null;
  }

  /**
   * What does this do?  I don't know, but when everything is done the second
   * time, this makes it work.  Otherwise, all custom fields are lost.
   */
  assign(_obj) {
    this.loadFields();
  }
  getDOMNode(_sender) {
    // Check whether the _sender object exists inside the management array
    if (this.rows && _sender.id && this.rows[_sender.id]) {
      return this.rows[_sender.id];
    }
    if (this.rows && _sender.id && _sender.id.indexOf("_label") && this.rows[_sender.id.replace("_label", "")]) {
      return jQuery(this.rows[_sender.id.replace("_label", "")]).prev("td")[0] || null;
    }
    return super.getDOMNode(_sender);
  }

  /**
   * Initialize widgets for custom fields
   */
  loadFields() {
    var _this = this;
    if (!this.options || !this.options.customfields) return;

    // Already set up - avoid duplicates in nextmatch
    if (this.getType() == 'customfields-list' && !this.isInTree() && Object.keys(this.widgets).length > 0) return;
    if (!jQuery.isEmptyObject(this.widgets)) return;

    // Check for global setting changes (visibility)
    var global_data = this.getArrayMgr("modifications").getRoot().getEntry('~custom_fields~');
    if (global_data && global_data.fields && !this.options.fields) this.options.fields = global_data.fields;

    // For checking app entries
    var apps = this.egw().link_app_list();

    // Create the table rows
    var _loop = function _loop(field_name) {
        // Skip fields if we're filtering
        if (_this.getType() != 'customfields-list' && !jQuery.isEmptyObject(_this.options.fields) && !_this.options.fields[field_name]) return 0; // continue
        var field = _this.options.customfields[field_name];
        var id = _this.options.prefix + field_name;

        // Need curlies around ID for nm row expansion
        if (_this.id == '$row') {
          id = "{" + _this.id + "}" + "[" + _this.options.prefix + field_name + "]";
        } else if (_this.id != et2_customfields_list.DEFAULT_ID) {
          // Prefix this ID to avoid potential ID collisions
          id = _this.id + "[" + id + "]";
        }

        // Avoid creating field twice
        if (!_this.rows[id]) {
          var row = jQuery(document.createElement("tr")).appendTo(_this.tbody).addClass(_this.id + '_' + id);
          var cf = jQuery(document.createElement("td")).appendTo(row);
          if (!field.type) field.type = 'text";';
          var setup_function = '_setup_' + (apps[field.type] ? 'link_entry' : field.type.replace("-", "_"));
          var attrs = jQuery.extend({}, _this.options[field_name] ? _this.options[field_name] : {}, {
            'id': id,
            'statustext': field.help || '',
            'needed': field.needed,
            'readonly': _this.getArrayMgr("readonlys").isReadOnly(id, "" + _this.options.readonly),
            'value': _this.options.value[_this.options.prefix + field_name]
          });
          // Can't have a required readonly, it will warn & be removed later, so avoid the warning
          if (attrs.readonly === true) delete attrs.needed;
          if (_this.options.onchange) {
            attrs.onchange = _this.options.onchange;
          }
          if (_this[setup_function]) {
            var no_skip = _this[setup_function].call(_this, field_name, field, attrs);
            if (!no_skip) return 0; // continue
          }
          _this.rows[id] = cf[0];
          if (_this.getType() == 'customfields-list') {
            // No label, custom widget
            attrs.readonly = true;
            // Widget tooltips don't work in nextmatch because of the creation / binding separation
            // Set title to field label so browser will show something
            // Add field label & help as data attribute to row, so it can be stylied with CSS (title should be disabled)
            row.attr('title', field.label);
            row.attr('data-label', field.label);
            row.attr('data-field', field_name);
            row.attr('data-help', field.help);
            _this.detachedNodes.push(row[0]);
          } else {
            // Label in first column, widget in 2nd
            var label = _this.options.label || field.label || '';
            jQuery(document.createElement("td")).prependTo(row);
            et2_createWidget("label", {
              id: id + "_label",
              value: label.trim(),
              for: id
            }, _this);
          }
          var type = attrs.type ? attrs.type : field.type;
          // Set any additional attributes set in options, but not for widgets that pass actual options
          if (['select', 'radio', 'radiogroup', 'checkbox', 'button'].indexOf(field.type) == -1 && setup_function !== '_setup_link_entry' && !jQuery.isEmptyObject(field.values)) {
            var w = et2_registry[type];
            var wc = window.customElements.get('et2-' + type);
            if (wc) {
              for (var attr_name in field.values) {
                if (wc.getPropertyOptions(attr_name)) {
                  attrs[attr_name] = field.values[attr_name];
                }
              }
            } else if (typeof w !== 'undefined') {
              for (var _attr_name in field.values) {
                if (typeof w._attributes[_attr_name] != "undefined") {
                  attrs[_attr_name] = field.values[_attr_name];
                }
              }
            }
          }
          // Create widget
          if (window.customElements.get('et2-' + type)) {
            if (typeof attrs.needed !== 'undefined') {
              attrs.required = attrs.needed;
              delete attrs.needed;
            }
            if (typeof attrs.size !== 'undefined' && ['small', 'medium', 'large'].indexOf(attrs.size) === -1) {
              if (attrs.size > 0) attrs.width = attrs.size + 'em';
              delete attrs.size;
            }
            //this.widgets[field_name] = loadWebComponent('et2-' + type, attrs, null);
            // et2_extension_customfields.getDOMNode() needs webcomponent to have ID before it can put it in
            var _wc = loadWebComponent('et2-' + type, attrs, _this);
            _wc.setParent(_this);
            _wc.updateComplete.then(() => {
              _this.widgets[field_name] = _wc;
            });
          } else if (typeof et2_registry[type] !== 'undefined') {
            _this.widgets[field_name] = et2_createWidget(type, attrs, _this);
          }
        }

        // Field is not to be shown
        if (!_this.options.fields || jQuery.isEmptyObject(_this.options.fields) || _this.options.fields[field_name] == true) {
          jQuery(_this.rows[field_name]).show();
        } else {
          jQuery(_this.rows[field_name]).hide();
        }
      },
      _ret;
    for (var field_name in this.options.customfields) {
      _ret = _loop(field_name);
      if (_ret === 0) continue;
    }
  }

  /**
   * Read needed info on available custom fields from various places it's stored.
   */
  transformAttributes(_attrs) {
    var _this$getArrayMgr$get;
    super.transformAttributes(_attrs);

    // Add in settings that are objects

    // Customized settings for this widget (unlikely)
    var data = this.id ? (_this$getArrayMgr$get = this.getArrayMgr("modifications").getEntry(this.id)) !== null && _this$getArrayMgr$get !== void 0 ? _this$getArrayMgr$get : {} : {};
    // Check for global settings
    var global_data = this.getArrayMgr("modifications").getRoot().getEntry('~custom_fields~', true);
    if (global_data) {
      for (var _key in data) {
        // Don't overwrite fields / customfields with global values
        if (global_data[_key] && _key !== 'fields' && (_key !== "customfields" || !data.customfields || !Object.keys(data.customfields).length)) {
          data[_key] = _objectSpread$R(_objectSpread$R({}, data[_key]), global_data[_key]);
        }
      }
    }
    for (var key in data) {
      _attrs[key] = data[key];
    }
    for (var _key2 in global_data) {
      if (typeof global_data[_key2] != 'undefined' && !_attrs[_key2]) _attrs[_key2] = global_data[_key2];
    }
    if (this.id) {
      // Set the value for this element
      var contentMgr = this.getArrayMgr("content");
      if (contentMgr != null) {
        var val = contentMgr.getEntry(this.id);
        _attrs["value"] = {};
        var prefix = _attrs["prefix"] || et2_customfields_list.PREFIX;
        if (val !== null) {
          if (this.id.indexOf(prefix) === 0 && typeof data.fields != 'undefined' && data.fields[this.id.replace(prefix, '')] === true) {
            _attrs['value'][this.id] = val;
          } else {
            // Only set the values that match desired custom fields
            for (var _key3 in val) {
              if (_key3.indexOf(prefix) === 0) {
                _attrs["value"][_key3] = val[_key3];
              }
            }
          }
          //_attrs["value"] = val;
        } else {
          // Check for custom fields directly in record
          for (var key in _attrs.customfields) {
            _attrs["value"][prefix + key] = contentMgr.getEntry(prefix + key);
          }
        }
      }
    }
  }
  loadFromXML(_node) {
    this.loadFields();

    // Load the nodes as usual
    super.loadFromXML(_node);
  }
  set_label(_value) {
    // If we've got a field list, or all fields use normal label
    if (this.getType() == 'customfields-list' || jQuery.isEmptyObject(this.options.fields) || Object.keys(this.options.fields).filter(f => this.options.fields[f]).length != 1) {
      return super.set_label(_value);
    }
    // For single field, we apply the widget label to the single field
  }

  set_value(_value) {
    if (!this.options.customfields) return;
    for (var field_name in this.options.customfields) {
      // Skip fields if we're filtering
      if (!jQuery.isEmptyObject(this.options.fields) && !this.options.fields[field_name]) continue;

      // Make sure widget is created, and has the needed function
      if (!this.widgets[field_name] || !this.widgets[field_name].set_value) continue;
      var value = _value[this.options.prefix + field_name] ? _value[this.options.prefix + field_name] : null;

      // Check if ID was missing
      if (value == null && this.id == et2_customfields_list.DEFAULT_ID && this.getArrayMgr("content").getEntry(this.options.prefix + field_name)) {
        value = this.getArrayMgr("content").getEntry(this.options.prefix + field_name);
      }
      switch (this.options.customfields[field_name].type) {
        case 'date':
          // Date custom fields are always in Y-m-d, which seldom matches user's preference
          // which fails when sent to date widget.  This is only used for nm rows, when possible
          // this is fixed server side
          if (value && isNaN(value)) {
            // ToDo: value = jQuery.datepicker.parseDate("yy-mm-dd",value);
          }
          break;
      }
      this.widgets[field_name].set_value(value);
    }
  }

  /**
   * et2_IInput so the custom field can be it's own widget.
   */
  getValue() {
    // Not using an ID means we have to grab all the widget values, and put them where server knows to look
    if (this.id != et2_customfields_list.DEFAULT_ID) {
      return null;
    }
    var value = {};
    for (var field_name in this.widgets) {
      if (this.widgets[field_name].getValue && !this.widgets[field_name].options.readonly) {
        value[this.options.prefix + field_name] = this.widgets[field_name].getValue();
      }
    }
    return value;
  }
  isDirty() {
    var dirty = false;
    for (var field_name in this.widgets) {
      if (this.widgets[field_name].isDirty) {
        dirty = dirty || this.widgets[field_name].isDirty();
      }
    }
    return dirty;
  }
  resetDirty() {
    for (var field_name in this.widgets) {
      if (this.widgets[field_name].resetDirty) {
        this.widgets[field_name].resetDirty();
      }
    }
  }
  isValid() {
    // Individual customfields will handle themselves
    return true;
  }

  /**
   * Adapt provided attributes to match options for widget
   *
   * rows > 1 --> textarea, with rows=rows and cols=len
   * !rows    --> input, with size=len
   * rows = 1 --> input, with size=len, maxlength=len
   */
  _setup_text(field_name, field, attrs) {
    // No label on the widget itself
    delete attrs.label;
    field.type = 'textbox';
    attrs.rows = field.rows > 1 ? field.rows : null;
    if (attrs.rows && attrs.rows > 0) {
      field.type = 'textarea';
    }
    if (field.len) {
      attrs.size = field.len;
      if (field.rows == 1) {
        attrs.maxlength = field.len;
      }
    }
    if (attrs.readonly) {
      field.type = 'description';
    }
    return true;
  }
  _setup_passwd(field_name, field, attrs) {
    // No label on the widget itself
    delete attrs.label;
    attrs.type = "password";
    var defaults = {
      viewable: true,
      plaintext: false,
      suggest: 16
    };
    for (var key of Object.keys(defaults)) {
      attrs[key] = field.values && typeof field.values[key] !== "undefined" ? field.values[key] : defaults[key];
    }
    return true;
  }
  _setup_ajax_select(field_name, field, attrs) {
    var attributes = ['get_rows', 'get_title', 'id_field', 'template'];
    if (field.values) {
      for (var i = 0; i < attributes.length; i++) {
        if (typeof field.values[attributes[i]] !== 'undefined') {
          attrs[attributes[i]] = field.values[attributes[i]];
        }
      }
    }
    return true;
  }
  _setup_float(field_name, field, attrs) {
    // No label on the widget itself
    delete attrs.label;
    field.type = 'float';
    if (field.len) {
      attrs.size = field.len;
    }
    return true;
  }
  _setup_select(field_name, field, attrs) {
    // No label on the widget itself
    delete attrs.label;
    attrs.rows = field.rows;
    if (attrs.rows > 1) {
      attrs.multiple = true;
    }
    if (field.values && field.values["@"]) {
      // Options are in a list stored in a file
      attrs.searchUrl = field.values["@"];
    }
    return true;
  }
  _setup_select_account(field_name, field, attrs) {
    attrs.empty_label = egw.lang('Select');
    if (field.account_type) {
      attrs.account_type = field.account_type;
    }
    return this._setup_select(field_name, field, attrs);
  }
  _setup_date(field_name, field, attrs) {
    var _field$values;
    attrs.data_format = field.values && field.values.format ? field.values.format : 'Y-m-d';
    if ((_field$values = field.values) !== null && _field$values !== void 0 && _field$values.format) {
      delete field.values.format;
    }
    return true;
  }
  _setup_date_time(field_name, field, attrs) {
    var _field$values2;
    attrs.data_format = field.values && field.values.format ? field.values.format : 'Y-m-d H:i:s';
    if ((_field$values2 = field.values) !== null && _field$values2 !== void 0 && _field$values2.format) {
      delete field.values.format;
    }
    return true;
  }
  _setup_htmlarea(field_name, field, attrs) {
    attrs.config = field.config ? field.config : {};
    attrs.config.toolbarStartupExpanded = false;
    if (field.len) {
      attrs.config.width = field.len + 'px';
    }
    attrs.config.height = (field.rows > 0 && field.rows != 'undefined' ? field.rows : 5) * 16 + 'px';

    // We have to push the config modifications into the modifications array, or they'll
    // be overwritten by the site config from the server
    var data = this.getArrayMgr("modifications").getEntry(this.options.prefix + field_name);
    if (data) jQuery.extend(data.config, attrs.config);
    return true;
  }
  _setup_radio(field_name, field, attrs) {
    // 'Empty' label will be first
    delete attrs.label;
    if (field.values && field.values['']) {
      attrs.label = field.values[''];
      delete field.values[''];
    }
    field.type = 'radiogroup';
    attrs.options = field.values;
    return true;
  }
  _setup_checkbox(field_name, field, attrs) {
    // Read-only checkbox is just text
    if (attrs.readonly && this.getType() !== "customfields") {
      attrs.ro_true = field.label;
    } else if (field.hasOwnProperty('ro_true')) {
      attrs.ro_true = field.ro_true;
    }
    if (field.hasOwnProperty('ro_false')) {
      attrs.ro_false = field.ro_false;
    }
    return true;
  }

  /**
   * People set button attributes as
   * label: javascript
   */
  _setup_button(field_name, field, attrs) {
    // No label on the widget itself
    delete attrs.label;
    attrs.label = field.label;
    if (this.getType() == 'customfields-list') {
      // No buttons in a list, it causes problems with detached nodes
      return false;
    }
    // Simple case, one widget for a custom field
    if (!field.values || typeof field.values != 'object' || Object.keys(field.values).length == 1) {
      for (var _key4 in field.values) {
        attrs.label = _key4;
        attrs.onclick = field.values[_key4];
      }
      if (!attrs.label) {
        attrs.label = 'No "label=onclick" in values!';
        attrs.onclick = function () {
          return false;
        };
      }
      return !attrs.readonly;
    } else {
      // Complicated case, a single custom field you get multiple widgets
      // Handle it all here, since this is the exception
      var row = jQuery('tr', this.tbody).last();
      var cf = jQuery('td', row);
      // Label in first column, widget in 2nd
      cf.text(field.label + "");
      cf = jQuery(document.createElement("td")).appendTo(row);
      for (var key in field.values) {
        var button_attrs = jQuery.extend({}, attrs);
        button_attrs.label = key;
        button_attrs.onclick = field.values[key];
        button_attrs.id = attrs.id + '_' + key;

        // This controls where the button is placed in the DOM
        this.rows[button_attrs.id] = cf[0];

        // Do not store in the widgets list, one name for multiple widgets would cause problems
        /*this.widgets[field_name] = */
        et2_createWidget(attrs.type ? attrs.type : field.type, button_attrs, this);
      }
      return false;
    }
  }
  _setup_link_entry(field_name, field, attrs) {
    if (field.type === 'filemanager') {
      return this._setup_filemanager(field_name, field, attrs);
    }
    // No label on the widget itself
    delete attrs.label;
    attrs.type = "link-entry";
    attrs[attrs.readonly ? "app" : "only_app"] = typeof field.only_app == "undefined" ? field.type : field.only_app;
    attrs.searchOptions = {
      filter: field.values || {}
    };
    return true;
  }
  _setup_filemanager(field_name, field, attrs) {
    attrs.type = 'vfs-upload';
    delete attrs.label;
    if (this.getType() == 'customfields-list') {
      // No special UI needed?
      return true;
    } else {
      // Complicated case, a single custom field you get multiple widgets
      // Handle it all here, since this is the exception
      var row = jQuery('tr', this.tbody).last();
      var cf = jQuery('td', row);

      // Label in first column, widget in 2nd
      cf.text(field.label + "");
      cf = jQuery(document.createElement("td")).appendTo(row);

      // Create upload widget
      var widget = this.widgets[field_name] = et2_createWidget(attrs.type ? attrs.type : field.type, attrs, this);

      // This controls where the widget is placed in the DOM
      this.rows[attrs.id] = cf[0];
      jQuery(widget.getDOMNode(widget)).css('vertical-align', 'top');

      // Add a link to existing VFS file
      var select_attrs = jQuery.extend({}, attrs,
      // Filemanager select
      {
        label: '',
        mode: widget.options.multiple ? 'open-multiple' : 'open',
        method: 'EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_existing',
        method_id: attrs.path,
        button_label: egw.lang('Link')
      }, {
        type: 'vfs-select'
      });
      select_attrs.id = attrs.id + '_vfs_select';

      // This controls where the button is placed in the DOM
      this.rows[select_attrs.id] = cf[0];

      // Do not store in the widgets list, one name for multiple widgets would cause problems
      widget = et2_createWidget(select_attrs.type, select_attrs, this);
      jQuery(widget.getDOMNode(widget)).css('vertical-align', 'top').prependTo(cf);
    }
    return false;
  }

  /**
   * Display links in list as CF name
   * @param field_name
   * @param field
   * @param attrs
   */
  _setup_url(field_name, field, attrs) {
    if (this.getType() == 'customfields-list') {
      attrs.label = field.label;
    }
    return true;
  }

  /**
   * Set which fields are visible, by name
   *
   * Note: no # prefix on the name
   *
   */
  set_visible(_fields) {
    for (var name in _fields) {
      if (this.rows[this.options.prefix + name]) {
        if (_fields[name]) {
          jQuery(this.rows[this.options.prefix + name]).show();
        } else {
          jQuery(this.rows[this.options.prefix + name]).hide();
        }
      }
      this.options.fields[name] = _fields[name];
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "class");
  }
  getDetachedNodes() {
    return this.detachedNodes ? this.detachedNodes : [];
  }
  setDetachedAttributes(_nodes, _values) {
    // Individual widgets are detected and handled by the grid, but the interface is needed for this to happen

    // Show the row if there's a value, hide it if there is no value
    for (var i = 0; i < _nodes.length; i++) {
      // toggle() needs a boolean to do what we want
      var key = _nodes[i].getAttribute('data-field');
      jQuery(_nodes[i]).toggle(_values.fields[key] && _values.value[this.options.prefix + key] ? true : false);
    }
  }
}
_defineProperty$1A(et2_customfields_list, "_attributes", {
  'customfields': {
    'name': 'Custom fields',
    'description': 'Auto filled',
    'type': 'any'
  },
  'fields': {
    'name': 'Custom fields',
    'description': 'Auto filled',
    'type': 'any'
  },
  'value': {
    'name': 'Custom fields',
    'description': 'Auto filled',
    'type': "any"
  },
  'type_filter': {
    'name': 'Field filter',
    "default": "",
    "type": "any",
    // String or array
    "description": "Filter displayed custom fields by their 'type2' attribute"
  },
  'private': {
    ignore: true,
    type: 'boolean'
  },
  'sub_app': {
    'name': 'sub app name',
    'type': "string",
    'description': "Name of sub application"
  },
  // Allow onchange so you can put handlers on the sub-widgets
  'onchange': {
    "name": "onchange",
    "type": "string",
    "default": et2_no_init,
    "description": "JS code which is executed when the value changes."
  },
  // Allow changing the field prefix.  Normally it's the constant but importexport filter changes it.
  "prefix": {
    name: "prefix",
    type: "string",
    default: "#",
    description: "Custom prefix for custom fields.  Default #"
  }
});
_defineProperty$1A(et2_customfields_list, "legacyOptions", ["type_filter", "private", "fields"]);
// Field restriction & private done server-side
_defineProperty$1A(et2_customfields_list, "PREFIX", '#');
_defineProperty$1A(et2_customfields_list, "DEFAULT_ID", "custom_fields");
et2_register_widget(et2_customfields_list, ["customfields", "customfields-list"]);

/**!
 * Sortable 1.14.0
 * @author	RubaXa   <trash@rubaxa.org>
 * @author	owenm    <owen23355@gmail.com>
 * @license MIT
 */
function ownKeys$R(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys$R(Object(source), true).forEach(function (key) {
        _defineProperty$1z(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys$R(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty$1z(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var version$1 = "1.14.0";

function userAgent(pattern) {
  if (typeof window !== 'undefined' && window.navigator) {
    return !! /*@__PURE__*/navigator.userAgent.match(pattern);
  }
}

var IE11OrLess = userAgent(/(?:Trident.*rv[ :]?11\.|msie|iemobile|Windows Phone)/i);
var Edge = userAgent(/Edge/i);
var FireFox = userAgent(/firefox/i);
var Safari = userAgent(/safari/i) && !userAgent(/chrome/i) && !userAgent(/android/i);
var IOS = userAgent(/iP(ad|od|hone)/i);
var ChromeForAndroid = userAgent(/chrome/i) && userAgent(/android/i);

var captureMode = {
  capture: false,
  passive: false
};

function on$1(el, event, fn) {
  el.addEventListener(event, fn, !IE11OrLess && captureMode);
}

function off$1(el, event, fn) {
  el.removeEventListener(event, fn, !IE11OrLess && captureMode);
}

function matches(
/**HTMLElement*/
el,
/**String*/
selector) {
  if (!selector) return;
  selector[0] === '>' && (selector = selector.substring(1));

  if (el) {
    try {
      if (el.matches) {
        return el.matches(selector);
      } else if (el.msMatchesSelector) {
        return el.msMatchesSelector(selector);
      } else if (el.webkitMatchesSelector) {
        return el.webkitMatchesSelector(selector);
      }
    } catch (_) {
      return false;
    }
  }

  return false;
}

function getParentOrHost(el) {
  return el.host && el !== document && el.host.nodeType ? el.host : el.parentNode;
}

function closest(
/**HTMLElement*/
el,
/**String*/
selector,
/**HTMLElement*/
ctx, includeCTX) {
  if (el) {
    ctx = ctx || document;

    do {
      if (selector != null && (selector[0] === '>' ? el.parentNode === ctx && matches(el, selector) : matches(el, selector)) || includeCTX && el === ctx) {
        return el;
      }

      if (el === ctx) break;
      /* jshint boss:true */
    } while (el = getParentOrHost(el));
  }

  return null;
}

var R_SPACE = /\s+/g;

function toggleClass$1(el, name, state) {
  if (el && name) {
    if (el.classList) {
      el.classList[state ? 'add' : 'remove'](name);
    } else {
      var className = (' ' + el.className + ' ').replace(R_SPACE, ' ').replace(' ' + name + ' ', ' ');
      el.className = (className + (state ? ' ' + name : '')).replace(R_SPACE, ' ');
    }
  }
}

function css(el, prop, val) {
  var style = el && el.style;

  if (style) {
    if (val === void 0) {
      if (document.defaultView && document.defaultView.getComputedStyle) {
        val = document.defaultView.getComputedStyle(el, '');
      } else if (el.currentStyle) {
        val = el.currentStyle;
      }

      return prop === void 0 ? val : val[prop];
    } else {
      if (!(prop in style) && prop.indexOf('webkit') === -1) {
        prop = '-webkit-' + prop;
      }

      style[prop] = val + (typeof val === 'string' ? '' : 'px');
    }
  }
}

function matrix(el, selfOnly) {
  var appliedTransforms = '';

  if (typeof el === 'string') {
    appliedTransforms = el;
  } else {
    do {
      var transform = css(el, 'transform');

      if (transform && transform !== 'none') {
        appliedTransforms = transform + ' ' + appliedTransforms;
      }
      /* jshint boss:true */

    } while (!selfOnly && (el = el.parentNode));
  }

  var matrixFn = window.DOMMatrix || window.WebKitCSSMatrix || window.CSSMatrix || window.MSCSSMatrix;
  /*jshint -W056 */

  return matrixFn && new matrixFn(appliedTransforms);
}

function find$1(ctx, tagName, iterator) {
  if (ctx) {
    var list = ctx.getElementsByTagName(tagName),
        i = 0,
        n = list.length;

    if (iterator) {
      for (; i < n; i++) {
        iterator(list[i], i);
      }
    }

    return list;
  }

  return [];
}

function getWindowScrollingElement() {
  var scrollingElement = document.scrollingElement;

  if (scrollingElement) {
    return scrollingElement;
  } else {
    return document.documentElement;
  }
}
/**
 * Returns the "bounding client rect" of given element
 * @param  {HTMLElement} el                       The element whose boundingClientRect is wanted
 * @param  {[Boolean]} relativeToContainingBlock  Whether the rect should be relative to the containing block of (including) the container
 * @param  {[Boolean]} relativeToNonStaticParent  Whether the rect should be relative to the relative parent of (including) the contaienr
 * @param  {[Boolean]} undoScale                  Whether the container's scale() should be undone
 * @param  {[HTMLElement]} container              The parent the element will be placed in
 * @return {Object}                               The boundingClientRect of el, with specified adjustments
 */


function getRect(el, relativeToContainingBlock, relativeToNonStaticParent, undoScale, container) {
  if (!el.getBoundingClientRect && el !== window) return;
  var elRect, top, left, bottom, right, height, width;

  if (el !== window && el.parentNode && el !== getWindowScrollingElement()) {
    elRect = el.getBoundingClientRect();
    top = elRect.top;
    left = elRect.left;
    bottom = elRect.bottom;
    right = elRect.right;
    height = elRect.height;
    width = elRect.width;
  } else {
    top = 0;
    left = 0;
    bottom = window.innerHeight;
    right = window.innerWidth;
    height = window.innerHeight;
    width = window.innerWidth;
  }

  if ((relativeToContainingBlock || relativeToNonStaticParent) && el !== window) {
    // Adjust for translate()
    container = container || el.parentNode; // solves #1123 (see: https://stackoverflow.com/a/37953806/6088312)
    // Not needed on <= IE11

    if (!IE11OrLess) {
      do {
        if (container && container.getBoundingClientRect && (css(container, 'transform') !== 'none' || relativeToNonStaticParent && css(container, 'position') !== 'static')) {
          var containerRect = container.getBoundingClientRect(); // Set relative to edges of padding box of container

          top -= containerRect.top + parseInt(css(container, 'border-top-width'));
          left -= containerRect.left + parseInt(css(container, 'border-left-width'));
          bottom = top + elRect.height;
          right = left + elRect.width;
          break;
        }
        /* jshint boss:true */

      } while (container = container.parentNode);
    }
  }

  if (undoScale && el !== window) {
    // Adjust for scale()
    var elMatrix = matrix(container || el),
        scaleX = elMatrix && elMatrix.a,
        scaleY = elMatrix && elMatrix.d;

    if (elMatrix) {
      top /= scaleY;
      left /= scaleX;
      width /= scaleX;
      height /= scaleY;
      bottom = top + height;
      right = left + width;
    }
  }

  return {
    top: top,
    left: left,
    bottom: bottom,
    right: right,
    width: width,
    height: height
  };
}
/**
 * Checks if a side of an element is scrolled past a side of its parents
 * @param  {HTMLElement}  el           The element who's side being scrolled out of view is in question
 * @param  {String}       elSide       Side of the element in question ('top', 'left', 'right', 'bottom')
 * @param  {String}       parentSide   Side of the parent in question ('top', 'left', 'right', 'bottom')
 * @return {HTMLElement}               The parent scroll element that the el's side is scrolled past, or null if there is no such element
 */


function isScrolledPast(el, elSide, parentSide) {
  var parent = getParentAutoScrollElement(el, true),
      elSideVal = getRect(el)[elSide];
  /* jshint boss:true */

  while (parent) {
    var parentSideVal = getRect(parent)[parentSide],
        visible = void 0;

    if (parentSide === 'top' || parentSide === 'left') {
      visible = elSideVal >= parentSideVal;
    } else {
      visible = elSideVal <= parentSideVal;
    }

    if (!visible) return parent;
    if (parent === getWindowScrollingElement()) break;
    parent = getParentAutoScrollElement(parent, false);
  }

  return false;
}
/**
 * Gets nth child of el, ignoring hidden children, sortable's elements (does not ignore clone if it's visible)
 * and non-draggable elements
 * @param  {HTMLElement} el       The parent element
 * @param  {Number} childNum      The index of the child
 * @param  {Object} options       Parent Sortable's options
 * @return {HTMLElement}          The child at index childNum, or null if not found
 */


function getChild(el, childNum, options, includeDragEl) {
  var currentChild = 0,
      i = 0,
      children = el.children;

  while (i < children.length) {
    if (children[i].style.display !== 'none' && children[i] !== Sortable.ghost && (includeDragEl || children[i] !== Sortable.dragged) && closest(children[i], options.draggable, el, false)) {
      if (currentChild === childNum) {
        return children[i];
      }

      currentChild++;
    }

    i++;
  }

  return null;
}
/**
 * Gets the last child in the el, ignoring ghostEl or invisible elements (clones)
 * @param  {HTMLElement} el       Parent element
 * @param  {selector} selector    Any other elements that should be ignored
 * @return {HTMLElement}          The last child, ignoring ghostEl
 */


function lastChild(el, selector) {
  var last = el.lastElementChild;

  while (last && (last === Sortable.ghost || css(last, 'display') === 'none' || selector && !matches(last, selector))) {
    last = last.previousElementSibling;
  }

  return last || null;
}
/**
 * Returns the index of an element within its parent for a selected set of
 * elements
 * @param  {HTMLElement} el
 * @param  {selector} selector
 * @return {number}
 */


function index(el, selector) {
  var index = 0;

  if (!el || !el.parentNode) {
    return -1;
  }
  /* jshint boss:true */


  while (el = el.previousElementSibling) {
    if (el.nodeName.toUpperCase() !== 'TEMPLATE' && el !== Sortable.clone && (!selector || matches(el, selector))) {
      index++;
    }
  }

  return index;
}
/**
 * Returns the scroll offset of the given element, added with all the scroll offsets of parent elements.
 * The value is returned in real pixels.
 * @param  {HTMLElement} el
 * @return {Array}             Offsets in the format of [left, top]
 */


function getRelativeScrollOffset(el) {
  var offsetLeft = 0,
      offsetTop = 0,
      winScroller = getWindowScrollingElement();

  if (el) {
    do {
      var elMatrix = matrix(el),
          scaleX = elMatrix.a,
          scaleY = elMatrix.d;
      offsetLeft += el.scrollLeft * scaleX;
      offsetTop += el.scrollTop * scaleY;
    } while (el !== winScroller && (el = el.parentNode));
  }

  return [offsetLeft, offsetTop];
}
/**
 * Returns the index of the object within the given array
 * @param  {Array} arr   Array that may or may not hold the object
 * @param  {Object} obj  An object that has a key-value pair unique to and identical to a key-value pair in the object you want to find
 * @return {Number}      The index of the object in the array, or -1
 */


function indexOfObject(arr, obj) {
  for (var i in arr) {
    if (!arr.hasOwnProperty(i)) continue;

    for (var key in obj) {
      if (obj.hasOwnProperty(key) && obj[key] === arr[i][key]) return Number(i);
    }
  }

  return -1;
}

function getParentAutoScrollElement(el, includeSelf) {
  // skip to window
  if (!el || !el.getBoundingClientRect) return getWindowScrollingElement();
  var elem = el;
  var gotSelf = false;

  do {
    // we don't need to get elem css if it isn't even overflowing in the first place (performance)
    if (elem.clientWidth < elem.scrollWidth || elem.clientHeight < elem.scrollHeight) {
      var elemCSS = css(elem);

      if (elem.clientWidth < elem.scrollWidth && (elemCSS.overflowX == 'auto' || elemCSS.overflowX == 'scroll') || elem.clientHeight < elem.scrollHeight && (elemCSS.overflowY == 'auto' || elemCSS.overflowY == 'scroll')) {
        if (!elem.getBoundingClientRect || elem === document.body) return getWindowScrollingElement();
        if (gotSelf || includeSelf) return elem;
        gotSelf = true;
      }
    }
    /* jshint boss:true */

  } while (elem = elem.parentNode);

  return getWindowScrollingElement();
}

function extend(dst, src) {
  if (dst && src) {
    for (var key in src) {
      if (src.hasOwnProperty(key)) {
        dst[key] = src[key];
      }
    }
  }

  return dst;
}

function isRectEqual(rect1, rect2) {
  return Math.round(rect1.top) === Math.round(rect2.top) && Math.round(rect1.left) === Math.round(rect2.left) && Math.round(rect1.height) === Math.round(rect2.height) && Math.round(rect1.width) === Math.round(rect2.width);
}

var _throttleTimeout;

function throttle(callback, ms) {
  return function () {
    if (!_throttleTimeout) {
      var args = arguments,
          _this = this;

      if (args.length === 1) {
        callback.call(_this, args[0]);
      } else {
        callback.apply(_this, args);
      }

      _throttleTimeout = setTimeout(function () {
        _throttleTimeout = void 0;
      }, ms);
    }
  };
}

function cancelThrottle() {
  clearTimeout(_throttleTimeout);
  _throttleTimeout = void 0;
}

function scrollBy(el, x, y) {
  el.scrollLeft += x;
  el.scrollTop += y;
}

function clone(el) {
  var Polymer = window.Polymer;
  var $ = window.jQuery || window.Zepto;

  if (Polymer && Polymer.dom) {
    return Polymer.dom(el).cloneNode(true);
  } else if ($) {
    return $(el).clone(true)[0];
  } else {
    return el.cloneNode(true);
  }
}

function setRect(el, rect) {
  css(el, 'position', 'absolute');
  css(el, 'top', rect.top);
  css(el, 'left', rect.left);
  css(el, 'width', rect.width);
  css(el, 'height', rect.height);
}

function unsetRect(el) {
  css(el, 'position', '');
  css(el, 'top', '');
  css(el, 'left', '');
  css(el, 'width', '');
  css(el, 'height', '');
}

var expando = 'Sortable' + new Date().getTime();

function AnimationStateManager() {
  var animationStates = [],
      animationCallbackId;
  return {
    captureAnimationState: function captureAnimationState() {
      animationStates = [];
      if (!this.options.animation) return;
      var children = [].slice.call(this.el.children);
      children.forEach(function (child) {
        if (css(child, 'display') === 'none' || child === Sortable.ghost) return;
        animationStates.push({
          target: child,
          rect: getRect(child)
        });

        var fromRect = _objectSpread2({}, animationStates[animationStates.length - 1].rect); // If animating: compensate for current animation


        if (child.thisAnimationDuration) {
          var childMatrix = matrix(child, true);

          if (childMatrix) {
            fromRect.top -= childMatrix.f;
            fromRect.left -= childMatrix.e;
          }
        }

        child.fromRect = fromRect;
      });
    },
    addAnimationState: function addAnimationState(state) {
      animationStates.push(state);
    },
    removeAnimationState: function removeAnimationState(target) {
      animationStates.splice(indexOfObject(animationStates, {
        target: target
      }), 1);
    },
    animateAll: function animateAll(callback) {
      var _this = this;

      if (!this.options.animation) {
        clearTimeout(animationCallbackId);
        if (typeof callback === 'function') callback();
        return;
      }

      var animating = false,
          animationTime = 0;
      animationStates.forEach(function (state) {
        var time = 0,
            target = state.target,
            fromRect = target.fromRect,
            toRect = getRect(target),
            prevFromRect = target.prevFromRect,
            prevToRect = target.prevToRect,
            animatingRect = state.rect,
            targetMatrix = matrix(target, true);

        if (targetMatrix) {
          // Compensate for current animation
          toRect.top -= targetMatrix.f;
          toRect.left -= targetMatrix.e;
        }

        target.toRect = toRect;

        if (target.thisAnimationDuration) {
          // Could also check if animatingRect is between fromRect and toRect
          if (isRectEqual(prevFromRect, toRect) && !isRectEqual(fromRect, toRect) && // Make sure animatingRect is on line between toRect & fromRect
          (animatingRect.top - toRect.top) / (animatingRect.left - toRect.left) === (fromRect.top - toRect.top) / (fromRect.left - toRect.left)) {
            // If returning to same place as started from animation and on same axis
            time = calculateRealTime(animatingRect, prevFromRect, prevToRect, _this.options);
          }
        } // if fromRect != toRect: animate


        if (!isRectEqual(toRect, fromRect)) {
          target.prevFromRect = fromRect;
          target.prevToRect = toRect;

          if (!time) {
            time = _this.options.animation;
          }

          _this.animate(target, animatingRect, toRect, time);
        }

        if (time) {
          animating = true;
          animationTime = Math.max(animationTime, time);
          clearTimeout(target.animationResetTimer);
          target.animationResetTimer = setTimeout(function () {
            target.animationTime = 0;
            target.prevFromRect = null;
            target.fromRect = null;
            target.prevToRect = null;
            target.thisAnimationDuration = null;
          }, time);
          target.thisAnimationDuration = time;
        }
      });
      clearTimeout(animationCallbackId);

      if (!animating) {
        if (typeof callback === 'function') callback();
      } else {
        animationCallbackId = setTimeout(function () {
          if (typeof callback === 'function') callback();
        }, animationTime);
      }

      animationStates = [];
    },
    animate: function animate(target, currentRect, toRect, duration) {
      if (duration) {
        css(target, 'transition', '');
        css(target, 'transform', '');
        var elMatrix = matrix(this.el),
            scaleX = elMatrix && elMatrix.a,
            scaleY = elMatrix && elMatrix.d,
            translateX = (currentRect.left - toRect.left) / (scaleX || 1),
            translateY = (currentRect.top - toRect.top) / (scaleY || 1);
        target.animatingX = !!translateX;
        target.animatingY = !!translateY;
        css(target, 'transform', 'translate3d(' + translateX + 'px,' + translateY + 'px,0)');
        this.forRepaintDummy = repaint(target); // repaint

        css(target, 'transition', 'transform ' + duration + 'ms' + (this.options.easing ? ' ' + this.options.easing : ''));
        css(target, 'transform', 'translate3d(0,0,0)');
        typeof target.animated === 'number' && clearTimeout(target.animated);
        target.animated = setTimeout(function () {
          css(target, 'transition', '');
          css(target, 'transform', '');
          target.animated = false;
          target.animatingX = false;
          target.animatingY = false;
        }, duration);
      }
    }
  };
}

function repaint(target) {
  return target.offsetWidth;
}

function calculateRealTime(animatingRect, fromRect, toRect, options) {
  return Math.sqrt(Math.pow(fromRect.top - animatingRect.top, 2) + Math.pow(fromRect.left - animatingRect.left, 2)) / Math.sqrt(Math.pow(fromRect.top - toRect.top, 2) + Math.pow(fromRect.left - toRect.left, 2)) * options.animation;
}

var plugins = [];
var defaults$1 = {
  initializeByDefault: true
};
var PluginManager = {
  mount: function mount(plugin) {
    // Set default static properties
    for (var option in defaults$1) {
      if (defaults$1.hasOwnProperty(option) && !(option in plugin)) {
        plugin[option] = defaults$1[option];
      }
    }

    plugins.forEach(function (p) {
      if (p.pluginName === plugin.pluginName) {
        throw "Sortable: Cannot mount plugin ".concat(plugin.pluginName, " more than once");
      }
    });
    plugins.push(plugin);
  },
  pluginEvent: function pluginEvent(eventName, sortable, evt) {
    var _this = this;

    this.eventCanceled = false;

    evt.cancel = function () {
      _this.eventCanceled = true;
    };

    var eventNameGlobal = eventName + 'Global';
    plugins.forEach(function (plugin) {
      if (!sortable[plugin.pluginName]) return; // Fire global events if it exists in this sortable

      if (sortable[plugin.pluginName][eventNameGlobal]) {
        sortable[plugin.pluginName][eventNameGlobal](_objectSpread2({
          sortable: sortable
        }, evt));
      } // Only fire plugin event if plugin is enabled in this sortable,
      // and plugin has event defined


      if (sortable.options[plugin.pluginName] && sortable[plugin.pluginName][eventName]) {
        sortable[plugin.pluginName][eventName](_objectSpread2({
          sortable: sortable
        }, evt));
      }
    });
  },
  initializePlugins: function initializePlugins(sortable, el, defaults, options) {
    plugins.forEach(function (plugin) {
      var pluginName = plugin.pluginName;
      if (!sortable.options[pluginName] && !plugin.initializeByDefault) return;
      var initialized = new plugin(sortable, el, sortable.options);
      initialized.sortable = sortable;
      initialized.options = sortable.options;
      sortable[pluginName] = initialized; // Add default options from plugin

      _extends(defaults, initialized.defaults);
    });

    for (var option in sortable.options) {
      if (!sortable.options.hasOwnProperty(option)) continue;
      var modified = this.modifyOption(sortable, option, sortable.options[option]);

      if (typeof modified !== 'undefined') {
        sortable.options[option] = modified;
      }
    }
  },
  getEventProperties: function getEventProperties(name, sortable) {
    var eventProperties = {};
    plugins.forEach(function (plugin) {
      if (typeof plugin.eventProperties !== 'function') return;

      _extends(eventProperties, plugin.eventProperties.call(sortable[plugin.pluginName], name));
    });
    return eventProperties;
  },
  modifyOption: function modifyOption(sortable, name, value) {
    var modifiedValue;
    plugins.forEach(function (plugin) {
      // Plugin must exist on the Sortable
      if (!sortable[plugin.pluginName]) return; // If static option listener exists for this option, call in the context of the Sortable's instance of this plugin

      if (plugin.optionListeners && typeof plugin.optionListeners[name] === 'function') {
        modifiedValue = plugin.optionListeners[name].call(sortable[plugin.pluginName], value);
      }
    });
    return modifiedValue;
  }
};

function dispatchEvent(_ref) {
  var sortable = _ref.sortable,
      rootEl = _ref.rootEl,
      name = _ref.name,
      targetEl = _ref.targetEl,
      cloneEl = _ref.cloneEl,
      toEl = _ref.toEl,
      fromEl = _ref.fromEl,
      oldIndex = _ref.oldIndex,
      newIndex = _ref.newIndex,
      oldDraggableIndex = _ref.oldDraggableIndex,
      newDraggableIndex = _ref.newDraggableIndex,
      originalEvent = _ref.originalEvent,
      putSortable = _ref.putSortable,
      extraEventProperties = _ref.extraEventProperties;
  sortable = sortable || rootEl && rootEl[expando];
  if (!sortable) return;
  var evt,
      options = sortable.options,
      onName = 'on' + name.charAt(0).toUpperCase() + name.substr(1); // Support for new CustomEvent feature

  if (window.CustomEvent && !IE11OrLess && !Edge) {
    evt = new CustomEvent(name, {
      bubbles: true,
      cancelable: true
    });
  } else {
    evt = document.createEvent('Event');
    evt.initEvent(name, true, true);
  }

  evt.to = toEl || rootEl;
  evt.from = fromEl || rootEl;
  evt.item = targetEl || rootEl;
  evt.clone = cloneEl;
  evt.oldIndex = oldIndex;
  evt.newIndex = newIndex;
  evt.oldDraggableIndex = oldDraggableIndex;
  evt.newDraggableIndex = newDraggableIndex;
  evt.originalEvent = originalEvent;
  evt.pullMode = putSortable ? putSortable.lastPutMode : undefined;

  var allEventProperties = _objectSpread2(_objectSpread2({}, extraEventProperties), PluginManager.getEventProperties(name, sortable));

  for (var option in allEventProperties) {
    evt[option] = allEventProperties[option];
  }

  if (rootEl) {
    rootEl.dispatchEvent(evt);
  }

  if (options[onName]) {
    options[onName].call(sortable, evt);
  }
}

var _excluded = ["evt"];

var pluginEvent = function pluginEvent(eventName, sortable) {
  var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      originalEvent = _ref.evt,
      data = _objectWithoutProperties(_ref, _excluded);

  PluginManager.pluginEvent.bind(Sortable)(eventName, sortable, _objectSpread2({
    dragEl: dragEl,
    parentEl: parentEl,
    ghostEl: ghostEl,
    rootEl: rootEl,
    nextEl: nextEl,
    lastDownEl: lastDownEl,
    cloneEl: cloneEl,
    cloneHidden: cloneHidden,
    dragStarted: moved,
    putSortable: putSortable,
    activeSortable: Sortable.active,
    originalEvent: originalEvent,
    oldIndex: oldIndex,
    oldDraggableIndex: oldDraggableIndex,
    newIndex: newIndex,
    newDraggableIndex: newDraggableIndex,
    hideGhostForTarget: _hideGhostForTarget,
    unhideGhostForTarget: _unhideGhostForTarget,
    cloneNowHidden: function cloneNowHidden() {
      cloneHidden = true;
    },
    cloneNowShown: function cloneNowShown() {
      cloneHidden = false;
    },
    dispatchSortableEvent: function dispatchSortableEvent(name) {
      _dispatchEvent({
        sortable: sortable,
        name: name,
        originalEvent: originalEvent
      });
    }
  }, data));
};

function _dispatchEvent(info) {
  dispatchEvent(_objectSpread2({
    putSortable: putSortable,
    cloneEl: cloneEl,
    targetEl: dragEl,
    rootEl: rootEl,
    oldIndex: oldIndex,
    oldDraggableIndex: oldDraggableIndex,
    newIndex: newIndex,
    newDraggableIndex: newDraggableIndex
  }, info));
}

var dragEl,
    parentEl,
    ghostEl,
    rootEl,
    nextEl,
    lastDownEl,
    cloneEl,
    cloneHidden,
    oldIndex,
    newIndex,
    oldDraggableIndex,
    newDraggableIndex,
    activeGroup,
    putSortable,
    awaitingDragStarted = false,
    ignoreNextClick = false,
    sortables = [],
    tapEvt,
    touchEvt,
    lastDx,
    lastDy,
    tapDistanceLeft,
    tapDistanceTop,
    moved,
    lastTarget,
    lastDirection,
    pastFirstInvertThresh = false,
    isCircumstantialInvert = false,
    targetMoveDistance,
    // For positioning ghost absolutely
ghostRelativeParent,
    ghostRelativeParentInitialScroll = [],
    // (left, top)
_silent = false,
    savedInputChecked = [];
/** @const */

var documentExists = typeof document !== 'undefined',
    PositionGhostAbsolutely = IOS,
    CSSFloatProperty = Edge || IE11OrLess ? 'cssFloat' : 'float',
    // This will not pass for IE9, because IE9 DnD only works on anchors
supportDraggable = documentExists && !ChromeForAndroid && !IOS && 'draggable' in document.createElement('div'),
    supportCssPointerEvents = function () {
  if (!documentExists) return; // false when <= IE11

  if (IE11OrLess) {
    return false;
  }

  var el = document.createElement('x');
  el.style.cssText = 'pointer-events:auto';
  return el.style.pointerEvents === 'auto';
}(),
    _detectDirection = function _detectDirection(el, options) {
  var elCSS = css(el),
      elWidth = parseInt(elCSS.width) - parseInt(elCSS.paddingLeft) - parseInt(elCSS.paddingRight) - parseInt(elCSS.borderLeftWidth) - parseInt(elCSS.borderRightWidth),
      child1 = getChild(el, 0, options),
      child2 = getChild(el, 1, options),
      firstChildCSS = child1 && css(child1),
      secondChildCSS = child2 && css(child2),
      firstChildWidth = firstChildCSS && parseInt(firstChildCSS.marginLeft) + parseInt(firstChildCSS.marginRight) + getRect(child1).width,
      secondChildWidth = secondChildCSS && parseInt(secondChildCSS.marginLeft) + parseInt(secondChildCSS.marginRight) + getRect(child2).width;

  if (elCSS.display === 'flex') {
    return elCSS.flexDirection === 'column' || elCSS.flexDirection === 'column-reverse' ? 'vertical' : 'horizontal';
  }

  if (elCSS.display === 'grid') {
    return elCSS.gridTemplateColumns.split(' ').length <= 1 ? 'vertical' : 'horizontal';
  }

  if (child1 && firstChildCSS["float"] && firstChildCSS["float"] !== 'none') {
    var touchingSideChild2 = firstChildCSS["float"] === 'left' ? 'left' : 'right';
    return child2 && (secondChildCSS.clear === 'both' || secondChildCSS.clear === touchingSideChild2) ? 'vertical' : 'horizontal';
  }

  return child1 && (firstChildCSS.display === 'block' || firstChildCSS.display === 'flex' || firstChildCSS.display === 'table' || firstChildCSS.display === 'grid' || firstChildWidth >= elWidth && elCSS[CSSFloatProperty] === 'none' || child2 && elCSS[CSSFloatProperty] === 'none' && firstChildWidth + secondChildWidth > elWidth) ? 'vertical' : 'horizontal';
},
    _dragElInRowColumn = function _dragElInRowColumn(dragRect, targetRect, vertical) {
  var dragElS1Opp = vertical ? dragRect.left : dragRect.top,
      dragElS2Opp = vertical ? dragRect.right : dragRect.bottom,
      dragElOppLength = vertical ? dragRect.width : dragRect.height,
      targetS1Opp = vertical ? targetRect.left : targetRect.top,
      targetS2Opp = vertical ? targetRect.right : targetRect.bottom,
      targetOppLength = vertical ? targetRect.width : targetRect.height;
  return dragElS1Opp === targetS1Opp || dragElS2Opp === targetS2Opp || dragElS1Opp + dragElOppLength / 2 === targetS1Opp + targetOppLength / 2;
},

/**
 * Detects first nearest empty sortable to X and Y position using emptyInsertThreshold.
 * @param  {Number} x      X position
 * @param  {Number} y      Y position
 * @return {HTMLElement}   Element of the first found nearest Sortable
 */
_detectNearestEmptySortable = function _detectNearestEmptySortable(x, y) {
  var ret;
  sortables.some(function (sortable) {
    var threshold = sortable[expando].options.emptyInsertThreshold;
    if (!threshold || lastChild(sortable)) return;
    var rect = getRect(sortable),
        insideHorizontally = x >= rect.left - threshold && x <= rect.right + threshold,
        insideVertically = y >= rect.top - threshold && y <= rect.bottom + threshold;

    if (insideHorizontally && insideVertically) {
      return ret = sortable;
    }
  });
  return ret;
},
    _prepareGroup = function _prepareGroup(options) {
  function toFn(value, pull) {
    return function (to, from, dragEl, evt) {
      var sameGroup = to.options.group.name && from.options.group.name && to.options.group.name === from.options.group.name;

      if (value == null && (pull || sameGroup)) {
        // Default pull value
        // Default pull and put value if same group
        return true;
      } else if (value == null || value === false) {
        return false;
      } else if (pull && value === 'clone') {
        return value;
      } else if (typeof value === 'function') {
        return toFn(value(to, from, dragEl, evt), pull)(to, from, dragEl, evt);
      } else {
        var otherGroup = (pull ? to : from).options.group.name;
        return value === true || typeof value === 'string' && value === otherGroup || value.join && value.indexOf(otherGroup) > -1;
      }
    };
  }

  var group = {};
  var originalGroup = options.group;

  if (!originalGroup || _typeof(originalGroup) != 'object') {
    originalGroup = {
      name: originalGroup
    };
  }

  group.name = originalGroup.name;
  group.checkPull = toFn(originalGroup.pull, true);
  group.checkPut = toFn(originalGroup.put);
  group.revertClone = originalGroup.revertClone;
  options.group = group;
},
    _hideGhostForTarget = function _hideGhostForTarget() {
  if (!supportCssPointerEvents && ghostEl) {
    css(ghostEl, 'display', 'none');
  }
},
    _unhideGhostForTarget = function _unhideGhostForTarget() {
  if (!supportCssPointerEvents && ghostEl) {
    css(ghostEl, 'display', '');
  }
}; // #1184 fix - Prevent click event on fallback if dragged but item not changed position


if (documentExists) {
  document.addEventListener('click', function (evt) {
    if (ignoreNextClick) {
      evt.preventDefault();
      evt.stopPropagation && evt.stopPropagation();
      evt.stopImmediatePropagation && evt.stopImmediatePropagation();
      ignoreNextClick = false;
      return false;
    }
  }, true);
}

var nearestEmptyInsertDetectEvent = function nearestEmptyInsertDetectEvent(evt) {
  if (dragEl) {
    evt = evt.touches ? evt.touches[0] : evt;

    var nearest = _detectNearestEmptySortable(evt.clientX, evt.clientY);

    if (nearest) {
      // Create imitation event
      var event = {};

      for (var i in evt) {
        if (evt.hasOwnProperty(i)) {
          event[i] = evt[i];
        }
      }

      event.target = event.rootEl = nearest;
      event.preventDefault = void 0;
      event.stopPropagation = void 0;

      nearest[expando]._onDragOver(event);
    }
  }
};

var _checkOutsideTargetEl = function _checkOutsideTargetEl(evt) {
  if (dragEl) {
    dragEl.parentNode[expando]._isOutsideThisEl(evt.target);
  }
};
/**
 * @class  Sortable
 * @param  {HTMLElement}  el
 * @param  {Object}       [options]
 */


function Sortable(el, options) {
  if (!(el && el.nodeType && el.nodeType === 1)) {
    throw "Sortable: `el` must be an HTMLElement, not ".concat({}.toString.call(el));
  }

  this.el = el; // root element

  this.options = options = _extends({}, options); // Export instance

  el[expando] = this;
  var defaults = {
    group: null,
    sort: true,
    disabled: false,
    store: null,
    handle: null,
    draggable: /^[uo]l$/i.test(el.nodeName) ? '>li' : '>*',
    swapThreshold: 1,
    // percentage; 0 <= x <= 1
    invertSwap: false,
    // invert always
    invertedSwapThreshold: null,
    // will be set to same as swapThreshold if default
    removeCloneOnHide: true,
    direction: function direction() {
      return _detectDirection(el, this.options);
    },
    ghostClass: 'sortable-ghost',
    chosenClass: 'sortable-chosen',
    dragClass: 'sortable-drag',
    ignore: 'a, img',
    filter: null,
    preventOnFilter: true,
    animation: 0,
    easing: null,
    setData: function setData(dataTransfer, dragEl) {
      dataTransfer.setData('Text', dragEl.textContent);
    },
    dropBubble: false,
    dragoverBubble: false,
    dataIdAttr: 'data-id',
    delay: 0,
    delayOnTouchOnly: false,
    touchStartThreshold: (Number.parseInt ? Number : window).parseInt(window.devicePixelRatio, 10) || 1,
    forceFallback: false,
    fallbackClass: 'sortable-fallback',
    fallbackOnBody: false,
    fallbackTolerance: 0,
    fallbackOffset: {
      x: 0,
      y: 0
    },
    supportPointer: Sortable.supportPointer !== false && 'PointerEvent' in window && !Safari,
    emptyInsertThreshold: 5
  };
  PluginManager.initializePlugins(this, el, defaults); // Set default options

  for (var name in defaults) {
    !(name in options) && (options[name] = defaults[name]);
  }

  _prepareGroup(options); // Bind all private methods


  for (var fn in this) {
    if (fn.charAt(0) === '_' && typeof this[fn] === 'function') {
      this[fn] = this[fn].bind(this);
    }
  } // Setup drag mode


  this.nativeDraggable = options.forceFallback ? false : supportDraggable;

  if (this.nativeDraggable) {
    // Touch start threshold cannot be greater than the native dragstart threshold
    this.options.touchStartThreshold = 1;
  } // Bind events


  if (options.supportPointer) {
    on$1(el, 'pointerdown', this._onTapStart);
  } else {
    on$1(el, 'mousedown', this._onTapStart);
    on$1(el, 'touchstart', this._onTapStart);
  }

  if (this.nativeDraggable) {
    on$1(el, 'dragover', this);
    on$1(el, 'dragenter', this);
  }

  sortables.push(this.el); // Restore sorting

  options.store && options.store.get && this.sort(options.store.get(this) || []); // Add animation state manager

  _extends(this, AnimationStateManager());
}

Sortable.prototype =
/** @lends Sortable.prototype */
{
  constructor: Sortable,
  _isOutsideThisEl: function _isOutsideThisEl(target) {
    if (!this.el.contains(target) && target !== this.el) {
      lastTarget = null;
    }
  },
  _getDirection: function _getDirection(evt, target) {
    return typeof this.options.direction === 'function' ? this.options.direction.call(this, evt, target, dragEl) : this.options.direction;
  },
  _onTapStart: function _onTapStart(
  /** Event|TouchEvent */
  evt) {
    if (!evt.cancelable) return;

    var _this = this,
        el = this.el,
        options = this.options,
        preventOnFilter = options.preventOnFilter,
        type = evt.type,
        touch = evt.touches && evt.touches[0] || evt.pointerType && evt.pointerType === 'touch' && evt,
        target = (touch || evt).target,
        originalTarget = evt.target.shadowRoot && (evt.path && evt.path[0] || evt.composedPath && evt.composedPath()[0]) || target,
        filter = options.filter;

    _saveInputCheckedState(el); // Don't trigger start event when an element is been dragged, otherwise the evt.oldindex always wrong when set option.group.


    if (dragEl) {
      return;
    }

    if (/mousedown|pointerdown/.test(type) && evt.button !== 0 || options.disabled) {
      return; // only left button and enabled
    } // cancel dnd if original target is content editable


    if (originalTarget.isContentEditable) {
      return;
    } // Safari ignores further event handling after mousedown


    if (!this.nativeDraggable && Safari && target && target.tagName.toUpperCase() === 'SELECT') {
      return;
    }

    target = closest(target, options.draggable, el, false);

    if (target && target.animated) {
      return;
    }

    if (lastDownEl === target) {
      // Ignoring duplicate `down`
      return;
    } // Get the index of the dragged element within its parent


    oldIndex = index(target);
    oldDraggableIndex = index(target, options.draggable); // Check filter

    if (typeof filter === 'function') {
      if (filter.call(this, evt, target, this)) {
        _dispatchEvent({
          sortable: _this,
          rootEl: originalTarget,
          name: 'filter',
          targetEl: target,
          toEl: el,
          fromEl: el
        });

        pluginEvent('filter', _this, {
          evt: evt
        });
        preventOnFilter && evt.cancelable && evt.preventDefault();
        return; // cancel dnd
      }
    } else if (filter) {
      filter = filter.split(',').some(function (criteria) {
        criteria = closest(originalTarget, criteria.trim(), el, false);

        if (criteria) {
          _dispatchEvent({
            sortable: _this,
            rootEl: criteria,
            name: 'filter',
            targetEl: target,
            fromEl: el,
            toEl: el
          });

          pluginEvent('filter', _this, {
            evt: evt
          });
          return true;
        }
      });

      if (filter) {
        preventOnFilter && evt.cancelable && evt.preventDefault();
        return; // cancel dnd
      }
    }

    if (options.handle && !closest(originalTarget, options.handle, el, false)) {
      return;
    } // Prepare `dragstart`


    this._prepareDragStart(evt, touch, target);
  },
  _prepareDragStart: function _prepareDragStart(
  /** Event */
  evt,
  /** Touch */
  touch,
  /** HTMLElement */
  target) {
    var _this = this,
        el = _this.el,
        options = _this.options,
        ownerDocument = el.ownerDocument,
        dragStartFn;

    if (target && !dragEl && target.parentNode === el) {
      var dragRect = getRect(target);
      rootEl = el;
      dragEl = target;
      parentEl = dragEl.parentNode;
      nextEl = dragEl.nextSibling;
      lastDownEl = target;
      activeGroup = options.group;
      Sortable.dragged = dragEl;
      tapEvt = {
        target: dragEl,
        clientX: (touch || evt).clientX,
        clientY: (touch || evt).clientY
      };
      tapDistanceLeft = tapEvt.clientX - dragRect.left;
      tapDistanceTop = tapEvt.clientY - dragRect.top;
      this._lastX = (touch || evt).clientX;
      this._lastY = (touch || evt).clientY;
      dragEl.style['will-change'] = 'all';

      dragStartFn = function dragStartFn() {
        pluginEvent('delayEnded', _this, {
          evt: evt
        });

        if (Sortable.eventCanceled) {
          _this._onDrop();

          return;
        } // Delayed drag has been triggered
        // we can re-enable the events: touchmove/mousemove


        _this._disableDelayedDragEvents();

        if (!FireFox && _this.nativeDraggable) {
          dragEl.draggable = true;
        } // Bind the events: dragstart/dragend


        _this._triggerDragStart(evt, touch); // Drag start event


        _dispatchEvent({
          sortable: _this,
          name: 'choose',
          originalEvent: evt
        }); // Chosen item


        toggleClass$1(dragEl, options.chosenClass, true);
      }; // Disable "draggable"


      options.ignore.split(',').forEach(function (criteria) {
        find$1(dragEl, criteria.trim(), _disableDraggable);
      });
      on$1(ownerDocument, 'dragover', nearestEmptyInsertDetectEvent);
      on$1(ownerDocument, 'mousemove', nearestEmptyInsertDetectEvent);
      on$1(ownerDocument, 'touchmove', nearestEmptyInsertDetectEvent);
      on$1(ownerDocument, 'mouseup', _this._onDrop);
      on$1(ownerDocument, 'touchend', _this._onDrop);
      on$1(ownerDocument, 'touchcancel', _this._onDrop); // Make dragEl draggable (must be before delay for FireFox)

      if (FireFox && this.nativeDraggable) {
        this.options.touchStartThreshold = 4;
        dragEl.draggable = true;
      }

      pluginEvent('delayStart', this, {
        evt: evt
      }); // Delay is impossible for native DnD in Edge or IE

      if (options.delay && (!options.delayOnTouchOnly || touch) && (!this.nativeDraggable || !(Edge || IE11OrLess))) {
        if (Sortable.eventCanceled) {
          this._onDrop();

          return;
        } // If the user moves the pointer or let go the click or touch
        // before the delay has been reached:
        // disable the delayed drag


        on$1(ownerDocument, 'mouseup', _this._disableDelayedDrag);
        on$1(ownerDocument, 'touchend', _this._disableDelayedDrag);
        on$1(ownerDocument, 'touchcancel', _this._disableDelayedDrag);
        on$1(ownerDocument, 'mousemove', _this._delayedDragTouchMoveHandler);
        on$1(ownerDocument, 'touchmove', _this._delayedDragTouchMoveHandler);
        options.supportPointer && on$1(ownerDocument, 'pointermove', _this._delayedDragTouchMoveHandler);
        _this._dragStartTimer = setTimeout(dragStartFn, options.delay);
      } else {
        dragStartFn();
      }
    }
  },
  _delayedDragTouchMoveHandler: function _delayedDragTouchMoveHandler(
  /** TouchEvent|PointerEvent **/
  e) {
    var touch = e.touches ? e.touches[0] : e;

    if (Math.max(Math.abs(touch.clientX - this._lastX), Math.abs(touch.clientY - this._lastY)) >= Math.floor(this.options.touchStartThreshold / (this.nativeDraggable && window.devicePixelRatio || 1))) {
      this._disableDelayedDrag();
    }
  },
  _disableDelayedDrag: function _disableDelayedDrag() {
    dragEl && _disableDraggable(dragEl);
    clearTimeout(this._dragStartTimer);

    this._disableDelayedDragEvents();
  },
  _disableDelayedDragEvents: function _disableDelayedDragEvents() {
    var ownerDocument = this.el.ownerDocument;
    off$1(ownerDocument, 'mouseup', this._disableDelayedDrag);
    off$1(ownerDocument, 'touchend', this._disableDelayedDrag);
    off$1(ownerDocument, 'touchcancel', this._disableDelayedDrag);
    off$1(ownerDocument, 'mousemove', this._delayedDragTouchMoveHandler);
    off$1(ownerDocument, 'touchmove', this._delayedDragTouchMoveHandler);
    off$1(ownerDocument, 'pointermove', this._delayedDragTouchMoveHandler);
  },
  _triggerDragStart: function _triggerDragStart(
  /** Event */
  evt,
  /** Touch */
  touch) {
    touch = touch || evt.pointerType == 'touch' && evt;

    if (!this.nativeDraggable || touch) {
      if (this.options.supportPointer) {
        on$1(document, 'pointermove', this._onTouchMove);
      } else if (touch) {
        on$1(document, 'touchmove', this._onTouchMove);
      } else {
        on$1(document, 'mousemove', this._onTouchMove);
      }
    } else {
      on$1(dragEl, 'dragend', this);
      on$1(rootEl, 'dragstart', this._onDragStart);
    }

    try {
      if (document.selection) {
        // Timeout neccessary for IE9
        _nextTick(function () {
          document.selection.empty();
        });
      } else {
        window.getSelection().removeAllRanges();
      }
    } catch (err) {}
  },
  _dragStarted: function _dragStarted(fallback, evt) {

    awaitingDragStarted = false;

    if (rootEl && dragEl) {
      pluginEvent('dragStarted', this, {
        evt: evt
      });

      if (this.nativeDraggable) {
        on$1(document, 'dragover', _checkOutsideTargetEl);
      }

      var options = this.options; // Apply effect

      !fallback && toggleClass$1(dragEl, options.dragClass, false);
      toggleClass$1(dragEl, options.ghostClass, true);
      Sortable.active = this;
      fallback && this._appendGhost(); // Drag start event

      _dispatchEvent({
        sortable: this,
        name: 'start',
        originalEvent: evt
      });
    } else {
      this._nulling();
    }
  },
  _emulateDragOver: function _emulateDragOver() {
    if (touchEvt) {
      this._lastX = touchEvt.clientX;
      this._lastY = touchEvt.clientY;

      _hideGhostForTarget();

      var target = document.elementFromPoint(touchEvt.clientX, touchEvt.clientY);
      var parent = target;

      while (target && target.shadowRoot) {
        target = target.shadowRoot.elementFromPoint(touchEvt.clientX, touchEvt.clientY);
        if (target === parent) break;
        parent = target;
      }

      dragEl.parentNode[expando]._isOutsideThisEl(target);

      if (parent) {
        do {
          if (parent[expando]) {
            var inserted = void 0;
            inserted = parent[expando]._onDragOver({
              clientX: touchEvt.clientX,
              clientY: touchEvt.clientY,
              target: target,
              rootEl: parent
            });

            if (inserted && !this.options.dragoverBubble) {
              break;
            }
          }

          target = parent; // store last element
        }
        /* jshint boss:true */
        while (parent = parent.parentNode);
      }

      _unhideGhostForTarget();
    }
  },
  _onTouchMove: function _onTouchMove(
  /**TouchEvent*/
  evt) {
    if (tapEvt) {
      var options = this.options,
          fallbackTolerance = options.fallbackTolerance,
          fallbackOffset = options.fallbackOffset,
          touch = evt.touches ? evt.touches[0] : evt,
          ghostMatrix = ghostEl && matrix(ghostEl, true),
          scaleX = ghostEl && ghostMatrix && ghostMatrix.a,
          scaleY = ghostEl && ghostMatrix && ghostMatrix.d,
          relativeScrollOffset = PositionGhostAbsolutely && ghostRelativeParent && getRelativeScrollOffset(ghostRelativeParent),
          dx = (touch.clientX - tapEvt.clientX + fallbackOffset.x) / (scaleX || 1) + (relativeScrollOffset ? relativeScrollOffset[0] - ghostRelativeParentInitialScroll[0] : 0) / (scaleX || 1),
          dy = (touch.clientY - tapEvt.clientY + fallbackOffset.y) / (scaleY || 1) + (relativeScrollOffset ? relativeScrollOffset[1] - ghostRelativeParentInitialScroll[1] : 0) / (scaleY || 1); // only set the status to dragging, when we are actually dragging

      if (!Sortable.active && !awaitingDragStarted) {
        if (fallbackTolerance && Math.max(Math.abs(touch.clientX - this._lastX), Math.abs(touch.clientY - this._lastY)) < fallbackTolerance) {
          return;
        }

        this._onDragStart(evt, true);
      }

      if (ghostEl) {
        if (ghostMatrix) {
          ghostMatrix.e += dx - (lastDx || 0);
          ghostMatrix.f += dy - (lastDy || 0);
        } else {
          ghostMatrix = {
            a: 1,
            b: 0,
            c: 0,
            d: 1,
            e: dx,
            f: dy
          };
        }

        var cssMatrix = "matrix(".concat(ghostMatrix.a, ",").concat(ghostMatrix.b, ",").concat(ghostMatrix.c, ",").concat(ghostMatrix.d, ",").concat(ghostMatrix.e, ",").concat(ghostMatrix.f, ")");
        css(ghostEl, 'webkitTransform', cssMatrix);
        css(ghostEl, 'mozTransform', cssMatrix);
        css(ghostEl, 'msTransform', cssMatrix);
        css(ghostEl, 'transform', cssMatrix);
        lastDx = dx;
        lastDy = dy;
        touchEvt = touch;
      }

      evt.cancelable && evt.preventDefault();
    }
  },
  _appendGhost: function _appendGhost() {
    // Bug if using scale(): https://stackoverflow.com/questions/2637058
    // Not being adjusted for
    if (!ghostEl) {
      var container = this.options.fallbackOnBody ? document.body : rootEl,
          rect = getRect(dragEl, true, PositionGhostAbsolutely, true, container),
          options = this.options; // Position absolutely

      if (PositionGhostAbsolutely) {
        // Get relatively positioned parent
        ghostRelativeParent = container;

        while (css(ghostRelativeParent, 'position') === 'static' && css(ghostRelativeParent, 'transform') === 'none' && ghostRelativeParent !== document) {
          ghostRelativeParent = ghostRelativeParent.parentNode;
        }

        if (ghostRelativeParent !== document.body && ghostRelativeParent !== document.documentElement) {
          if (ghostRelativeParent === document) ghostRelativeParent = getWindowScrollingElement();
          rect.top += ghostRelativeParent.scrollTop;
          rect.left += ghostRelativeParent.scrollLeft;
        } else {
          ghostRelativeParent = getWindowScrollingElement();
        }

        ghostRelativeParentInitialScroll = getRelativeScrollOffset(ghostRelativeParent);
      }

      ghostEl = dragEl.cloneNode(true);
      toggleClass$1(ghostEl, options.ghostClass, false);
      toggleClass$1(ghostEl, options.fallbackClass, true);
      toggleClass$1(ghostEl, options.dragClass, true);
      css(ghostEl, 'transition', '');
      css(ghostEl, 'transform', '');
      css(ghostEl, 'box-sizing', 'border-box');
      css(ghostEl, 'margin', 0);
      css(ghostEl, 'top', rect.top);
      css(ghostEl, 'left', rect.left);
      css(ghostEl, 'width', rect.width);
      css(ghostEl, 'height', rect.height);
      css(ghostEl, 'opacity', '0.8');
      css(ghostEl, 'position', PositionGhostAbsolutely ? 'absolute' : 'fixed');
      css(ghostEl, 'zIndex', '100000');
      css(ghostEl, 'pointerEvents', 'none');
      Sortable.ghost = ghostEl;
      container.appendChild(ghostEl); // Set transform-origin

      css(ghostEl, 'transform-origin', tapDistanceLeft / parseInt(ghostEl.style.width) * 100 + '% ' + tapDistanceTop / parseInt(ghostEl.style.height) * 100 + '%');
    }
  },
  _onDragStart: function _onDragStart(
  /**Event*/
  evt,
  /**boolean*/
  fallback) {
    var _this = this;

    var dataTransfer = evt.dataTransfer;
    var options = _this.options;
    pluginEvent('dragStart', this, {
      evt: evt
    });

    if (Sortable.eventCanceled) {
      this._onDrop();

      return;
    }

    pluginEvent('setupClone', this);

    if (!Sortable.eventCanceled) {
      cloneEl = clone(dragEl);
      cloneEl.draggable = false;
      cloneEl.style['will-change'] = '';

      this._hideClone();

      toggleClass$1(cloneEl, this.options.chosenClass, false);
      Sortable.clone = cloneEl;
    } // #1143: IFrame support workaround


    _this.cloneId = _nextTick(function () {
      pluginEvent('clone', _this);
      if (Sortable.eventCanceled) return;

      if (!_this.options.removeCloneOnHide) {
        rootEl.insertBefore(cloneEl, dragEl);
      }

      _this._hideClone();

      _dispatchEvent({
        sortable: _this,
        name: 'clone'
      });
    });
    !fallback && toggleClass$1(dragEl, options.dragClass, true); // Set proper drop events

    if (fallback) {
      ignoreNextClick = true;
      _this._loopId = setInterval(_this._emulateDragOver, 50);
    } else {
      // Undo what was set in _prepareDragStart before drag started
      off$1(document, 'mouseup', _this._onDrop);
      off$1(document, 'touchend', _this._onDrop);
      off$1(document, 'touchcancel', _this._onDrop);

      if (dataTransfer) {
        dataTransfer.effectAllowed = 'move';
        options.setData && options.setData.call(_this, dataTransfer, dragEl);
      }

      on$1(document, 'drop', _this); // #1276 fix:

      css(dragEl, 'transform', 'translateZ(0)');
    }

    awaitingDragStarted = true;
    _this._dragStartId = _nextTick(_this._dragStarted.bind(_this, fallback, evt));
    on$1(document, 'selectstart', _this);
    moved = true;

    if (Safari) {
      css(document.body, 'user-select', 'none');
    }
  },
  // Returns true - if no further action is needed (either inserted or another condition)
  _onDragOver: function _onDragOver(
  /**Event*/
  evt) {
    var el = this.el,
        target = evt.target,
        dragRect,
        targetRect,
        revert,
        options = this.options,
        group = options.group,
        activeSortable = Sortable.active,
        isOwner = activeGroup === group,
        canSort = options.sort,
        fromSortable = putSortable || activeSortable,
        vertical,
        _this = this,
        completedFired = false;

    if (_silent) return;

    function dragOverEvent(name, extra) {
      pluginEvent(name, _this, _objectSpread2({
        evt: evt,
        isOwner: isOwner,
        axis: vertical ? 'vertical' : 'horizontal',
        revert: revert,
        dragRect: dragRect,
        targetRect: targetRect,
        canSort: canSort,
        fromSortable: fromSortable,
        target: target,
        completed: completed,
        onMove: function onMove(target, after) {
          return _onMove(rootEl, el, dragEl, dragRect, target, getRect(target), evt, after);
        },
        changed: changed
      }, extra));
    } // Capture animation state


    function capture() {
      dragOverEvent('dragOverAnimationCapture');

      _this.captureAnimationState();

      if (_this !== fromSortable) {
        fromSortable.captureAnimationState();
      }
    } // Return invocation when dragEl is inserted (or completed)


    function completed(insertion) {
      dragOverEvent('dragOverCompleted', {
        insertion: insertion
      });

      if (insertion) {
        // Clones must be hidden before folding animation to capture dragRectAbsolute properly
        if (isOwner) {
          activeSortable._hideClone();
        } else {
          activeSortable._showClone(_this);
        }

        if (_this !== fromSortable) {
          // Set ghost class to new sortable's ghost class
          toggleClass$1(dragEl, putSortable ? putSortable.options.ghostClass : activeSortable.options.ghostClass, false);
          toggleClass$1(dragEl, options.ghostClass, true);
        }

        if (putSortable !== _this && _this !== Sortable.active) {
          putSortable = _this;
        } else if (_this === Sortable.active && putSortable) {
          putSortable = null;
        } // Animation


        if (fromSortable === _this) {
          _this._ignoreWhileAnimating = target;
        }

        _this.animateAll(function () {
          dragOverEvent('dragOverAnimationComplete');
          _this._ignoreWhileAnimating = null;
        });

        if (_this !== fromSortable) {
          fromSortable.animateAll();
          fromSortable._ignoreWhileAnimating = null;
        }
      } // Null lastTarget if it is not inside a previously swapped element


      if (target === dragEl && !dragEl.animated || target === el && !target.animated) {
        lastTarget = null;
      } // no bubbling and not fallback


      if (!options.dragoverBubble && !evt.rootEl && target !== document) {
        dragEl.parentNode[expando]._isOutsideThisEl(evt.target); // Do not detect for empty insert if already inserted


        !insertion && nearestEmptyInsertDetectEvent(evt);
      }

      !options.dragoverBubble && evt.stopPropagation && evt.stopPropagation();
      return completedFired = true;
    } // Call when dragEl has been inserted


    function changed() {
      newIndex = index(dragEl);
      newDraggableIndex = index(dragEl, options.draggable);

      _dispatchEvent({
        sortable: _this,
        name: 'change',
        toEl: el,
        newIndex: newIndex,
        newDraggableIndex: newDraggableIndex,
        originalEvent: evt
      });
    }

    if (evt.preventDefault !== void 0) {
      evt.cancelable && evt.preventDefault();
    }

    target = closest(target, options.draggable, el, true);
    dragOverEvent('dragOver');
    if (Sortable.eventCanceled) return completedFired;

    if (dragEl.contains(evt.target) || target.animated && target.animatingX && target.animatingY || _this._ignoreWhileAnimating === target) {
      return completed(false);
    }

    ignoreNextClick = false;

    if (activeSortable && !options.disabled && (isOwner ? canSort || (revert = parentEl !== rootEl) // Reverting item into the original list
    : putSortable === this || (this.lastPutMode = activeGroup.checkPull(this, activeSortable, dragEl, evt)) && group.checkPut(this, activeSortable, dragEl, evt))) {
      vertical = this._getDirection(evt, target) === 'vertical';
      dragRect = getRect(dragEl);
      dragOverEvent('dragOverValid');
      if (Sortable.eventCanceled) return completedFired;

      if (revert) {
        parentEl = rootEl; // actualization

        capture();

        this._hideClone();

        dragOverEvent('revert');

        if (!Sortable.eventCanceled) {
          if (nextEl) {
            rootEl.insertBefore(dragEl, nextEl);
          } else {
            rootEl.appendChild(dragEl);
          }
        }

        return completed(true);
      }

      var elLastChild = lastChild(el, options.draggable);

      if (!elLastChild || _ghostIsLast(evt, vertical, this) && !elLastChild.animated) {
        // Insert to end of list
        // If already at end of list: Do not insert
        if (elLastChild === dragEl) {
          return completed(false);
        } // if there is a last element, it is the target


        if (elLastChild && el === evt.target) {
          target = elLastChild;
        }

        if (target) {
          targetRect = getRect(target);
        }

        if (_onMove(rootEl, el, dragEl, dragRect, target, targetRect, evt, !!target) !== false) {
          capture();
          el.appendChild(dragEl);
          parentEl = el; // actualization

          changed();
          return completed(true);
        }
      } else if (elLastChild && _ghostIsFirst(evt, vertical, this)) {
        // Insert to start of list
        var firstChild = getChild(el, 0, options, true);

        if (firstChild === dragEl) {
          return completed(false);
        }

        target = firstChild;
        targetRect = getRect(target);

        if (_onMove(rootEl, el, dragEl, dragRect, target, targetRect, evt, false) !== false) {
          capture();
          el.insertBefore(dragEl, firstChild);
          parentEl = el; // actualization

          changed();
          return completed(true);
        }
      } else if (target.parentNode === el) {
        targetRect = getRect(target);
        var direction = 0,
            targetBeforeFirstSwap,
            differentLevel = dragEl.parentNode !== el,
            differentRowCol = !_dragElInRowColumn(dragEl.animated && dragEl.toRect || dragRect, target.animated && target.toRect || targetRect, vertical),
            side1 = vertical ? 'top' : 'left',
            scrolledPastTop = isScrolledPast(target, 'top', 'top') || isScrolledPast(dragEl, 'top', 'top'),
            scrollBefore = scrolledPastTop ? scrolledPastTop.scrollTop : void 0;

        if (lastTarget !== target) {
          targetBeforeFirstSwap = targetRect[side1];
          pastFirstInvertThresh = false;
          isCircumstantialInvert = !differentRowCol && options.invertSwap || differentLevel;
        }

        direction = _getSwapDirection(evt, target, targetRect, vertical, differentRowCol ? 1 : options.swapThreshold, options.invertedSwapThreshold == null ? options.swapThreshold : options.invertedSwapThreshold, isCircumstantialInvert, lastTarget === target);
        var sibling;

        if (direction !== 0) {
          // Check if target is beside dragEl in respective direction (ignoring hidden elements)
          var dragIndex = index(dragEl);

          do {
            dragIndex -= direction;
            sibling = parentEl.children[dragIndex];
          } while (sibling && (css(sibling, 'display') === 'none' || sibling === ghostEl));
        } // If dragEl is already beside target: Do not insert


        if (direction === 0 || sibling === target) {
          return completed(false);
        }

        lastTarget = target;
        lastDirection = direction;
        var nextSibling = target.nextElementSibling,
            after = false;
        after = direction === 1;

        var moveVector = _onMove(rootEl, el, dragEl, dragRect, target, targetRect, evt, after);

        if (moveVector !== false) {
          if (moveVector === 1 || moveVector === -1) {
            after = moveVector === 1;
          }

          _silent = true;
          setTimeout(_unsilent, 30);
          capture();

          if (after && !nextSibling) {
            el.appendChild(dragEl);
          } else {
            target.parentNode.insertBefore(dragEl, after ? nextSibling : target);
          } // Undo chrome's scroll adjustment (has no effect on other browsers)


          if (scrolledPastTop) {
            scrollBy(scrolledPastTop, 0, scrollBefore - scrolledPastTop.scrollTop);
          }

          parentEl = dragEl.parentNode; // actualization
          // must be done before animation

          if (targetBeforeFirstSwap !== undefined && !isCircumstantialInvert) {
            targetMoveDistance = Math.abs(targetBeforeFirstSwap - getRect(target)[side1]);
          }

          changed();
          return completed(true);
        }
      }

      if (el.contains(dragEl)) {
        return completed(false);
      }
    }

    return false;
  },
  _ignoreWhileAnimating: null,
  _offMoveEvents: function _offMoveEvents() {
    off$1(document, 'mousemove', this._onTouchMove);
    off$1(document, 'touchmove', this._onTouchMove);
    off$1(document, 'pointermove', this._onTouchMove);
    off$1(document, 'dragover', nearestEmptyInsertDetectEvent);
    off$1(document, 'mousemove', nearestEmptyInsertDetectEvent);
    off$1(document, 'touchmove', nearestEmptyInsertDetectEvent);
  },
  _offUpEvents: function _offUpEvents() {
    var ownerDocument = this.el.ownerDocument;
    off$1(ownerDocument, 'mouseup', this._onDrop);
    off$1(ownerDocument, 'touchend', this._onDrop);
    off$1(ownerDocument, 'pointerup', this._onDrop);
    off$1(ownerDocument, 'touchcancel', this._onDrop);
    off$1(document, 'selectstart', this);
  },
  _onDrop: function _onDrop(
  /**Event*/
  evt) {
    var el = this.el,
        options = this.options; // Get the index of the dragged element within its parent

    newIndex = index(dragEl);
    newDraggableIndex = index(dragEl, options.draggable);
    pluginEvent('drop', this, {
      evt: evt
    });
    parentEl = dragEl && dragEl.parentNode; // Get again after plugin event

    newIndex = index(dragEl);
    newDraggableIndex = index(dragEl, options.draggable);

    if (Sortable.eventCanceled) {
      this._nulling();

      return;
    }

    awaitingDragStarted = false;
    isCircumstantialInvert = false;
    pastFirstInvertThresh = false;
    clearInterval(this._loopId);
    clearTimeout(this._dragStartTimer);

    _cancelNextTick(this.cloneId);

    _cancelNextTick(this._dragStartId); // Unbind events


    if (this.nativeDraggable) {
      off$1(document, 'drop', this);
      off$1(el, 'dragstart', this._onDragStart);
    }

    this._offMoveEvents();

    this._offUpEvents();

    if (Safari) {
      css(document.body, 'user-select', '');
    }

    css(dragEl, 'transform', '');

    if (evt) {
      if (moved) {
        evt.cancelable && evt.preventDefault();
        !options.dropBubble && evt.stopPropagation();
      }

      ghostEl && ghostEl.parentNode && ghostEl.parentNode.removeChild(ghostEl);

      if (rootEl === parentEl || putSortable && putSortable.lastPutMode !== 'clone') {
        // Remove clone(s)
        cloneEl && cloneEl.parentNode && cloneEl.parentNode.removeChild(cloneEl);
      }

      if (dragEl) {
        if (this.nativeDraggable) {
          off$1(dragEl, 'dragend', this);
        }

        _disableDraggable(dragEl);

        dragEl.style['will-change'] = ''; // Remove classes
        // ghostClass is added in dragStarted

        if (moved && !awaitingDragStarted) {
          toggleClass$1(dragEl, putSortable ? putSortable.options.ghostClass : this.options.ghostClass, false);
        }

        toggleClass$1(dragEl, this.options.chosenClass, false); // Drag stop event

        _dispatchEvent({
          sortable: this,
          name: 'unchoose',
          toEl: parentEl,
          newIndex: null,
          newDraggableIndex: null,
          originalEvent: evt
        });

        if (rootEl !== parentEl) {
          if (newIndex >= 0) {
            // Add event
            _dispatchEvent({
              rootEl: parentEl,
              name: 'add',
              toEl: parentEl,
              fromEl: rootEl,
              originalEvent: evt
            }); // Remove event


            _dispatchEvent({
              sortable: this,
              name: 'remove',
              toEl: parentEl,
              originalEvent: evt
            }); // drag from one list and drop into another


            _dispatchEvent({
              rootEl: parentEl,
              name: 'sort',
              toEl: parentEl,
              fromEl: rootEl,
              originalEvent: evt
            });

            _dispatchEvent({
              sortable: this,
              name: 'sort',
              toEl: parentEl,
              originalEvent: evt
            });
          }

          putSortable && putSortable.save();
        } else {
          if (newIndex !== oldIndex) {
            if (newIndex >= 0) {
              // drag & drop within the same list
              _dispatchEvent({
                sortable: this,
                name: 'update',
                toEl: parentEl,
                originalEvent: evt
              });

              _dispatchEvent({
                sortable: this,
                name: 'sort',
                toEl: parentEl,
                originalEvent: evt
              });
            }
          }
        }

        if (Sortable.active) {
          /* jshint eqnull:true */
          if (newIndex == null || newIndex === -1) {
            newIndex = oldIndex;
            newDraggableIndex = oldDraggableIndex;
          }

          _dispatchEvent({
            sortable: this,
            name: 'end',
            toEl: parentEl,
            originalEvent: evt
          }); // Save sorting


          this.save();
        }
      }
    }

    this._nulling();
  },
  _nulling: function _nulling() {
    pluginEvent('nulling', this);
    rootEl = dragEl = parentEl = ghostEl = nextEl = cloneEl = lastDownEl = cloneHidden = tapEvt = touchEvt = moved = newIndex = newDraggableIndex = oldIndex = oldDraggableIndex = lastTarget = lastDirection = putSortable = activeGroup = Sortable.dragged = Sortable.ghost = Sortable.clone = Sortable.active = null;
    savedInputChecked.forEach(function (el) {
      el.checked = true;
    });
    savedInputChecked.length = lastDx = lastDy = 0;
  },
  handleEvent: function handleEvent(
  /**Event*/
  evt) {
    switch (evt.type) {
      case 'drop':
      case 'dragend':
        this._onDrop(evt);

        break;

      case 'dragenter':
      case 'dragover':
        if (dragEl) {
          this._onDragOver(evt);

          _globalDragOver(evt);
        }

        break;

      case 'selectstart':
        evt.preventDefault();
        break;
    }
  },

  /**
   * Serializes the item into an array of string.
   * @returns {String[]}
   */
  toArray: function toArray() {
    var order = [],
        el,
        children = this.el.children,
        i = 0,
        n = children.length,
        options = this.options;

    for (; i < n; i++) {
      el = children[i];

      if (closest(el, options.draggable, this.el, false)) {
        order.push(el.getAttribute(options.dataIdAttr) || _generateId(el));
      }
    }

    return order;
  },

  /**
   * Sorts the elements according to the array.
   * @param  {String[]}  order  order of the items
   */
  sort: function sort(order, useAnimation) {
    var items = {},
        rootEl = this.el;
    this.toArray().forEach(function (id, i) {
      var el = rootEl.children[i];

      if (closest(el, this.options.draggable, rootEl, false)) {
        items[id] = el;
      }
    }, this);
    useAnimation && this.captureAnimationState();
    order.forEach(function (id) {
      if (items[id]) {
        rootEl.removeChild(items[id]);
        rootEl.appendChild(items[id]);
      }
    });
    useAnimation && this.animateAll();
  },

  /**
   * Save the current sorting
   */
  save: function save() {
    var store = this.options.store;
    store && store.set && store.set(this);
  },

  /**
   * For each element in the set, get the first element that matches the selector by testing the element itself and traversing up through its ancestors in the DOM tree.
   * @param   {HTMLElement}  el
   * @param   {String}       [selector]  default: `options.draggable`
   * @returns {HTMLElement|null}
   */
  closest: function closest$1(el, selector) {
    return closest(el, selector || this.options.draggable, this.el, false);
  },

  /**
   * Set/get option
   * @param   {string} name
   * @param   {*}      [value]
   * @returns {*}
   */
  option: function option(name, value) {
    var options = this.options;

    if (value === void 0) {
      return options[name];
    } else {
      var modifiedValue = PluginManager.modifyOption(this, name, value);

      if (typeof modifiedValue !== 'undefined') {
        options[name] = modifiedValue;
      } else {
        options[name] = value;
      }

      if (name === 'group') {
        _prepareGroup(options);
      }
    }
  },

  /**
   * Destroy
   */
  destroy: function destroy() {
    pluginEvent('destroy', this);
    var el = this.el;
    el[expando] = null;
    off$1(el, 'mousedown', this._onTapStart);
    off$1(el, 'touchstart', this._onTapStart);
    off$1(el, 'pointerdown', this._onTapStart);

    if (this.nativeDraggable) {
      off$1(el, 'dragover', this);
      off$1(el, 'dragenter', this);
    } // Remove draggable attributes


    Array.prototype.forEach.call(el.querySelectorAll('[draggable]'), function (el) {
      el.removeAttribute('draggable');
    });

    this._onDrop();

    this._disableDelayedDragEvents();

    sortables.splice(sortables.indexOf(this.el), 1);
    this.el = el = null;
  },
  _hideClone: function _hideClone() {
    if (!cloneHidden) {
      pluginEvent('hideClone', this);
      if (Sortable.eventCanceled) return;
      css(cloneEl, 'display', 'none');

      if (this.options.removeCloneOnHide && cloneEl.parentNode) {
        cloneEl.parentNode.removeChild(cloneEl);
      }

      cloneHidden = true;
    }
  },
  _showClone: function _showClone(putSortable) {
    if (putSortable.lastPutMode !== 'clone') {
      this._hideClone();

      return;
    }

    if (cloneHidden) {
      pluginEvent('showClone', this);
      if (Sortable.eventCanceled) return; // show clone at dragEl or original position

      if (dragEl.parentNode == rootEl && !this.options.group.revertClone) {
        rootEl.insertBefore(cloneEl, dragEl);
      } else if (nextEl) {
        rootEl.insertBefore(cloneEl, nextEl);
      } else {
        rootEl.appendChild(cloneEl);
      }

      if (this.options.group.revertClone) {
        this.animate(dragEl, cloneEl);
      }

      css(cloneEl, 'display', '');
      cloneHidden = false;
    }
  }
};

function _globalDragOver(
/**Event*/
evt) {
  if (evt.dataTransfer) {
    evt.dataTransfer.dropEffect = 'move';
  }

  evt.cancelable && evt.preventDefault();
}

function _onMove(fromEl, toEl, dragEl, dragRect, targetEl, targetRect, originalEvent, willInsertAfter) {
  var evt,
      sortable = fromEl[expando],
      onMoveFn = sortable.options.onMove,
      retVal; // Support for new CustomEvent feature

  if (window.CustomEvent && !IE11OrLess && !Edge) {
    evt = new CustomEvent('move', {
      bubbles: true,
      cancelable: true
    });
  } else {
    evt = document.createEvent('Event');
    evt.initEvent('move', true, true);
  }

  evt.to = toEl;
  evt.from = fromEl;
  evt.dragged = dragEl;
  evt.draggedRect = dragRect;
  evt.related = targetEl || toEl;
  evt.relatedRect = targetRect || getRect(toEl);
  evt.willInsertAfter = willInsertAfter;
  evt.originalEvent = originalEvent;
  fromEl.dispatchEvent(evt);

  if (onMoveFn) {
    retVal = onMoveFn.call(sortable, evt, originalEvent);
  }

  return retVal;
}

function _disableDraggable(el) {
  el.draggable = false;
}

function _unsilent() {
  _silent = false;
}

function _ghostIsFirst(evt, vertical, sortable) {
  var rect = getRect(getChild(sortable.el, 0, sortable.options, true));
  var spacer = 10;
  return vertical ? evt.clientX < rect.left - spacer || evt.clientY < rect.top && evt.clientX < rect.right : evt.clientY < rect.top - spacer || evt.clientY < rect.bottom && evt.clientX < rect.left;
}

function _ghostIsLast(evt, vertical, sortable) {
  var rect = getRect(lastChild(sortable.el, sortable.options.draggable));
  var spacer = 10;
  return vertical ? evt.clientX > rect.right + spacer || evt.clientX <= rect.right && evt.clientY > rect.bottom && evt.clientX >= rect.left : evt.clientX > rect.right && evt.clientY > rect.top || evt.clientX <= rect.right && evt.clientY > rect.bottom + spacer;
}

function _getSwapDirection(evt, target, targetRect, vertical, swapThreshold, invertedSwapThreshold, invertSwap, isLastTarget) {
  var mouseOnAxis = vertical ? evt.clientY : evt.clientX,
      targetLength = vertical ? targetRect.height : targetRect.width,
      targetS1 = vertical ? targetRect.top : targetRect.left,
      targetS2 = vertical ? targetRect.bottom : targetRect.right,
      invert = false;

  if (!invertSwap) {
    // Never invert or create dragEl shadow when target movemenet causes mouse to move past the end of regular swapThreshold
    if (isLastTarget && targetMoveDistance < targetLength * swapThreshold) {
      // multiplied only by swapThreshold because mouse will already be inside target by (1 - threshold) * targetLength / 2
      // check if past first invert threshold on side opposite of lastDirection
      if (!pastFirstInvertThresh && (lastDirection === 1 ? mouseOnAxis > targetS1 + targetLength * invertedSwapThreshold / 2 : mouseOnAxis < targetS2 - targetLength * invertedSwapThreshold / 2)) {
        // past first invert threshold, do not restrict inverted threshold to dragEl shadow
        pastFirstInvertThresh = true;
      }

      if (!pastFirstInvertThresh) {
        // dragEl shadow (target move distance shadow)
        if (lastDirection === 1 ? mouseOnAxis < targetS1 + targetMoveDistance // over dragEl shadow
        : mouseOnAxis > targetS2 - targetMoveDistance) {
          return -lastDirection;
        }
      } else {
        invert = true;
      }
    } else {
      // Regular
      if (mouseOnAxis > targetS1 + targetLength * (1 - swapThreshold) / 2 && mouseOnAxis < targetS2 - targetLength * (1 - swapThreshold) / 2) {
        return _getInsertDirection(target);
      }
    }
  }

  invert = invert || invertSwap;

  if (invert) {
    // Invert of regular
    if (mouseOnAxis < targetS1 + targetLength * invertedSwapThreshold / 2 || mouseOnAxis > targetS2 - targetLength * invertedSwapThreshold / 2) {
      return mouseOnAxis > targetS1 + targetLength / 2 ? 1 : -1;
    }
  }

  return 0;
}
/**
 * Gets the direction dragEl must be swapped relative to target in order to make it
 * seem that dragEl has been "inserted" into that element's position
 * @param  {HTMLElement} target       The target whose position dragEl is being inserted at
 * @return {Number}                   Direction dragEl must be swapped
 */


function _getInsertDirection(target) {
  if (index(dragEl) < index(target)) {
    return 1;
  } else {
    return -1;
  }
}
/**
 * Generate id
 * @param   {HTMLElement} el
 * @returns {String}
 * @private
 */


function _generateId(el) {
  var str = el.tagName + el.className + el.src + el.href + el.textContent,
      i = str.length,
      sum = 0;

  while (i--) {
    sum += str.charCodeAt(i);
  }

  return sum.toString(36);
}

function _saveInputCheckedState(root) {
  savedInputChecked.length = 0;
  var inputs = root.getElementsByTagName('input');
  var idx = inputs.length;

  while (idx--) {
    var el = inputs[idx];
    el.checked && savedInputChecked.push(el);
  }
}

function _nextTick(fn) {
  return setTimeout(fn, 0);
}

function _cancelNextTick(id) {
  return clearTimeout(id);
} // Fixed #973:


if (documentExists) {
  on$1(document, 'touchmove', function (evt) {
    if ((Sortable.active || awaitingDragStarted) && evt.cancelable) {
      evt.preventDefault();
    }
  });
} // Export utils


Sortable.utils = {
  on: on$1,
  off: off$1,
  css: css,
  find: find$1,
  is: function is(el, selector) {
    return !!closest(el, selector, el, false);
  },
  extend: extend,
  throttle: throttle,
  closest: closest,
  toggleClass: toggleClass$1,
  clone: clone,
  index: index,
  nextTick: _nextTick,
  cancelNextTick: _cancelNextTick,
  detectDirection: _detectDirection,
  getChild: getChild
};
/**
 * Get the Sortable instance of an element
 * @param  {HTMLElement} element The element
 * @return {Sortable|undefined}         The instance of Sortable
 */

Sortable.get = function (element) {
  return element[expando];
};
/**
 * Mount a plugin to Sortable
 * @param  {...SortablePlugin|SortablePlugin[]} plugins       Plugins being mounted
 */


Sortable.mount = function () {
  for (var _len = arguments.length, plugins = new Array(_len), _key = 0; _key < _len; _key++) {
    plugins[_key] = arguments[_key];
  }

  if (plugins[0].constructor === Array) plugins = plugins[0];
  plugins.forEach(function (plugin) {
    if (!plugin.prototype || !plugin.prototype.constructor) {
      throw "Sortable: Mounted plugin must be a constructor function, not ".concat({}.toString.call(plugin));
    }

    if (plugin.utils) Sortable.utils = _objectSpread2(_objectSpread2({}, Sortable.utils), plugin.utils);
    PluginManager.mount(plugin);
  });
};
/**
 * Create sortable instance
 * @param {HTMLElement}  el
 * @param {Object}      [options]
 */


Sortable.create = function (el, options) {
  return new Sortable(el, options);
}; // Export


Sortable.version = version$1;

var autoScrolls = [],
    scrollEl,
    scrollRootEl,
    scrolling = false,
    lastAutoScrollX,
    lastAutoScrollY,
    touchEvt$1,
    pointerElemChangedInterval;

function AutoScrollPlugin() {
  function AutoScroll() {
    this.defaults = {
      scroll: true,
      forceAutoScrollFallback: false,
      scrollSensitivity: 30,
      scrollSpeed: 10,
      bubbleScroll: true
    }; // Bind all private methods

    for (var fn in this) {
      if (fn.charAt(0) === '_' && typeof this[fn] === 'function') {
        this[fn] = this[fn].bind(this);
      }
    }
  }

  AutoScroll.prototype = {
    dragStarted: function dragStarted(_ref) {
      var originalEvent = _ref.originalEvent;

      if (this.sortable.nativeDraggable) {
        on$1(document, 'dragover', this._handleAutoScroll);
      } else {
        if (this.options.supportPointer) {
          on$1(document, 'pointermove', this._handleFallbackAutoScroll);
        } else if (originalEvent.touches) {
          on$1(document, 'touchmove', this._handleFallbackAutoScroll);
        } else {
          on$1(document, 'mousemove', this._handleFallbackAutoScroll);
        }
      }
    },
    dragOverCompleted: function dragOverCompleted(_ref2) {
      var originalEvent = _ref2.originalEvent;

      // For when bubbling is canceled and using fallback (fallback 'touchmove' always reached)
      if (!this.options.dragOverBubble && !originalEvent.rootEl) {
        this._handleAutoScroll(originalEvent);
      }
    },
    drop: function drop() {
      if (this.sortable.nativeDraggable) {
        off$1(document, 'dragover', this._handleAutoScroll);
      } else {
        off$1(document, 'pointermove', this._handleFallbackAutoScroll);
        off$1(document, 'touchmove', this._handleFallbackAutoScroll);
        off$1(document, 'mousemove', this._handleFallbackAutoScroll);
      }

      clearPointerElemChangedInterval();
      clearAutoScrolls();
      cancelThrottle();
    },
    nulling: function nulling() {
      touchEvt$1 = scrollRootEl = scrollEl = scrolling = pointerElemChangedInterval = lastAutoScrollX = lastAutoScrollY = null;
      autoScrolls.length = 0;
    },
    _handleFallbackAutoScroll: function _handleFallbackAutoScroll(evt) {
      this._handleAutoScroll(evt, true);
    },
    _handleAutoScroll: function _handleAutoScroll(evt, fallback) {
      var _this = this;

      var x = (evt.touches ? evt.touches[0] : evt).clientX,
          y = (evt.touches ? evt.touches[0] : evt).clientY,
          elem = document.elementFromPoint(x, y);
      touchEvt$1 = evt; // IE does not seem to have native autoscroll,
      // Edge's autoscroll seems too conditional,
      // MACOS Safari does not have autoscroll,
      // Firefox and Chrome are good

      if (fallback || this.options.forceAutoScrollFallback || Edge || IE11OrLess || Safari) {
        autoScroll(evt, this.options, elem, fallback); // Listener for pointer element change

        var ogElemScroller = getParentAutoScrollElement(elem, true);

        if (scrolling && (!pointerElemChangedInterval || x !== lastAutoScrollX || y !== lastAutoScrollY)) {
          pointerElemChangedInterval && clearPointerElemChangedInterval(); // Detect for pointer elem change, emulating native DnD behaviour

          pointerElemChangedInterval = setInterval(function () {
            var newElem = getParentAutoScrollElement(document.elementFromPoint(x, y), true);

            if (newElem !== ogElemScroller) {
              ogElemScroller = newElem;
              clearAutoScrolls();
            }

            autoScroll(evt, _this.options, newElem, fallback);
          }, 10);
          lastAutoScrollX = x;
          lastAutoScrollY = y;
        }
      } else {
        // if DnD is enabled (and browser has good autoscrolling), first autoscroll will already scroll, so get parent autoscroll of first autoscroll
        if (!this.options.bubbleScroll || getParentAutoScrollElement(elem, true) === getWindowScrollingElement()) {
          clearAutoScrolls();
          return;
        }

        autoScroll(evt, this.options, getParentAutoScrollElement(elem, false), false);
      }
    }
  };
  return _extends(AutoScroll, {
    pluginName: 'scroll',
    initializeByDefault: true
  });
}

function clearAutoScrolls() {
  autoScrolls.forEach(function (autoScroll) {
    clearInterval(autoScroll.pid);
  });
  autoScrolls = [];
}

function clearPointerElemChangedInterval() {
  clearInterval(pointerElemChangedInterval);
}

var autoScroll = throttle(function (evt, options, rootEl, isFallback) {
  // Bug: https://bugzilla.mozilla.org/show_bug.cgi?id=505521
  if (!options.scroll) return;
  var x = (evt.touches ? evt.touches[0] : evt).clientX,
      y = (evt.touches ? evt.touches[0] : evt).clientY,
      sens = options.scrollSensitivity,
      speed = options.scrollSpeed,
      winScroller = getWindowScrollingElement();
  var scrollThisInstance = false,
      scrollCustomFn; // New scroll root, set scrollEl

  if (scrollRootEl !== rootEl) {
    scrollRootEl = rootEl;
    clearAutoScrolls();
    scrollEl = options.scroll;
    scrollCustomFn = options.scrollFn;

    if (scrollEl === true) {
      scrollEl = getParentAutoScrollElement(rootEl, true);
    }
  }

  var layersOut = 0;
  var currentParent = scrollEl;

  do {
    var el = currentParent,
        rect = getRect(el),
        top = rect.top,
        bottom = rect.bottom,
        left = rect.left,
        right = rect.right,
        width = rect.width,
        height = rect.height,
        canScrollX = void 0,
        canScrollY = void 0,
        scrollWidth = el.scrollWidth,
        scrollHeight = el.scrollHeight,
        elCSS = css(el),
        scrollPosX = el.scrollLeft,
        scrollPosY = el.scrollTop;

    if (el === winScroller) {
      canScrollX = width < scrollWidth && (elCSS.overflowX === 'auto' || elCSS.overflowX === 'scroll' || elCSS.overflowX === 'visible');
      canScrollY = height < scrollHeight && (elCSS.overflowY === 'auto' || elCSS.overflowY === 'scroll' || elCSS.overflowY === 'visible');
    } else {
      canScrollX = width < scrollWidth && (elCSS.overflowX === 'auto' || elCSS.overflowX === 'scroll');
      canScrollY = height < scrollHeight && (elCSS.overflowY === 'auto' || elCSS.overflowY === 'scroll');
    }

    var vx = canScrollX && (Math.abs(right - x) <= sens && scrollPosX + width < scrollWidth) - (Math.abs(left - x) <= sens && !!scrollPosX);
    var vy = canScrollY && (Math.abs(bottom - y) <= sens && scrollPosY + height < scrollHeight) - (Math.abs(top - y) <= sens && !!scrollPosY);

    if (!autoScrolls[layersOut]) {
      for (var i = 0; i <= layersOut; i++) {
        if (!autoScrolls[i]) {
          autoScrolls[i] = {};
        }
      }
    }

    if (autoScrolls[layersOut].vx != vx || autoScrolls[layersOut].vy != vy || autoScrolls[layersOut].el !== el) {
      autoScrolls[layersOut].el = el;
      autoScrolls[layersOut].vx = vx;
      autoScrolls[layersOut].vy = vy;
      clearInterval(autoScrolls[layersOut].pid);

      if (vx != 0 || vy != 0) {
        scrollThisInstance = true;
        /* jshint loopfunc:true */

        autoScrolls[layersOut].pid = setInterval(function () {
          // emulate drag over during autoscroll (fallback), emulating native DnD behaviour
          if (isFallback && this.layer === 0) {
            Sortable.active._onTouchMove(touchEvt$1); // To move ghost if it is positioned absolutely

          }

          var scrollOffsetY = autoScrolls[this.layer].vy ? autoScrolls[this.layer].vy * speed : 0;
          var scrollOffsetX = autoScrolls[this.layer].vx ? autoScrolls[this.layer].vx * speed : 0;

          if (typeof scrollCustomFn === 'function') {
            if (scrollCustomFn.call(Sortable.dragged.parentNode[expando], scrollOffsetX, scrollOffsetY, evt, touchEvt$1, autoScrolls[this.layer].el) !== 'continue') {
              return;
            }
          }

          scrollBy(autoScrolls[this.layer].el, scrollOffsetX, scrollOffsetY);
        }.bind({
          layer: layersOut
        }), 24);
      }
    }

    layersOut++;
  } while (options.bubbleScroll && currentParent !== winScroller && (currentParent = getParentAutoScrollElement(currentParent, false)));

  scrolling = scrollThisInstance; // in case another function catches scrolling as false in between when it is not
}, 30);

var drop = function drop(_ref) {
  var originalEvent = _ref.originalEvent,
      putSortable = _ref.putSortable,
      dragEl = _ref.dragEl,
      activeSortable = _ref.activeSortable,
      dispatchSortableEvent = _ref.dispatchSortableEvent,
      hideGhostForTarget = _ref.hideGhostForTarget,
      unhideGhostForTarget = _ref.unhideGhostForTarget;
  if (!originalEvent) return;
  var toSortable = putSortable || activeSortable;
  hideGhostForTarget();
  var touch = originalEvent.changedTouches && originalEvent.changedTouches.length ? originalEvent.changedTouches[0] : originalEvent;
  var target = document.elementFromPoint(touch.clientX, touch.clientY);
  unhideGhostForTarget();

  if (toSortable && !toSortable.el.contains(target)) {
    dispatchSortableEvent('spill');
    this.onSpill({
      dragEl: dragEl,
      putSortable: putSortable
    });
  }
};

function Revert() {}

Revert.prototype = {
  startIndex: null,
  dragStart: function dragStart(_ref2) {
    var oldDraggableIndex = _ref2.oldDraggableIndex;
    this.startIndex = oldDraggableIndex;
  },
  onSpill: function onSpill(_ref3) {
    var dragEl = _ref3.dragEl,
        putSortable = _ref3.putSortable;
    this.sortable.captureAnimationState();

    if (putSortable) {
      putSortable.captureAnimationState();
    }

    var nextSibling = getChild(this.sortable.el, this.startIndex, this.options);

    if (nextSibling) {
      this.sortable.el.insertBefore(dragEl, nextSibling);
    } else {
      this.sortable.el.appendChild(dragEl);
    }

    this.sortable.animateAll();

    if (putSortable) {
      putSortable.animateAll();
    }
  },
  drop: drop
};

_extends(Revert, {
  pluginName: 'revertOnSpill'
});

function Remove() {}

Remove.prototype = {
  onSpill: function onSpill(_ref4) {
    var dragEl = _ref4.dragEl,
        putSortable = _ref4.putSortable;
    var parentSortable = putSortable || this.sortable;
    parentSortable.captureAnimationState();
    dragEl.parentNode && dragEl.parentNode.removeChild(dragEl);
    parentSortable.animateAll();
  },
  drop: drop
};

_extends(Remove, {
  pluginName: 'removeOnSpill'
});

var lastSwapEl;

function SwapPlugin() {
  function Swap() {
    this.defaults = {
      swapClass: 'sortable-swap-highlight'
    };
  }

  Swap.prototype = {
    dragStart: function dragStart(_ref) {
      var dragEl = _ref.dragEl;
      lastSwapEl = dragEl;
    },
    dragOverValid: function dragOverValid(_ref2) {
      var completed = _ref2.completed,
          target = _ref2.target,
          onMove = _ref2.onMove,
          activeSortable = _ref2.activeSortable,
          changed = _ref2.changed,
          cancel = _ref2.cancel;
      if (!activeSortable.options.swap) return;
      var el = this.sortable.el,
          options = this.options;

      if (target && target !== el) {
        var prevSwapEl = lastSwapEl;

        if (onMove(target) !== false) {
          toggleClass$1(target, options.swapClass, true);
          lastSwapEl = target;
        } else {
          lastSwapEl = null;
        }

        if (prevSwapEl && prevSwapEl !== lastSwapEl) {
          toggleClass$1(prevSwapEl, options.swapClass, false);
        }
      }

      changed();
      completed(true);
      cancel();
    },
    drop: function drop(_ref3) {
      var activeSortable = _ref3.activeSortable,
          putSortable = _ref3.putSortable,
          dragEl = _ref3.dragEl;
      var toSortable = putSortable || this.sortable;
      var options = this.options;
      lastSwapEl && toggleClass$1(lastSwapEl, options.swapClass, false);

      if (lastSwapEl && (options.swap || putSortable && putSortable.options.swap)) {
        if (dragEl !== lastSwapEl) {
          toSortable.captureAnimationState();
          if (toSortable !== activeSortable) activeSortable.captureAnimationState();
          swapNodes(dragEl, lastSwapEl);
          toSortable.animateAll();
          if (toSortable !== activeSortable) activeSortable.animateAll();
        }
      }
    },
    nulling: function nulling() {
      lastSwapEl = null;
    }
  };
  return _extends(Swap, {
    pluginName: 'swap',
    eventProperties: function eventProperties() {
      return {
        swapItem: lastSwapEl
      };
    }
  });
}

function swapNodes(n1, n2) {
  var p1 = n1.parentNode,
      p2 = n2.parentNode,
      i1,
      i2;
  if (!p1 || !p2 || p1.isEqualNode(n2) || p2.isEqualNode(n1)) return;
  i1 = index(n1);
  i2 = index(n2);

  if (p1.isEqualNode(p2) && i1 < i2) {
    i2++;
  }

  p1.insertBefore(n2, p1.children[i1]);
  p2.insertBefore(n1, p2.children[i2]);
}

var multiDragElements = [],
    multiDragClones = [],
    lastMultiDragSelect,
    // for selection with modifier key down (SHIFT)
multiDragSortable,
    initialFolding = false,
    // Initial multi-drag fold when drag started
folding = false,
    // Folding any other time
dragStarted = false,
    dragEl$1,
    clonesFromRect,
    clonesHidden;

function MultiDragPlugin() {
  function MultiDrag(sortable) {
    // Bind all private methods
    for (var fn in this) {
      if (fn.charAt(0) === '_' && typeof this[fn] === 'function') {
        this[fn] = this[fn].bind(this);
      }
    }

    if (sortable.options.supportPointer) {
      on$1(document, 'pointerup', this._deselectMultiDrag);
    } else {
      on$1(document, 'mouseup', this._deselectMultiDrag);
      on$1(document, 'touchend', this._deselectMultiDrag);
    }

    on$1(document, 'keydown', this._checkKeyDown);
    on$1(document, 'keyup', this._checkKeyUp);
    this.defaults = {
      selectedClass: 'sortable-selected',
      multiDragKey: null,
      setData: function setData(dataTransfer, dragEl) {
        var data = '';

        if (multiDragElements.length && multiDragSortable === sortable) {
          multiDragElements.forEach(function (multiDragElement, i) {
            data += (!i ? '' : ', ') + multiDragElement.textContent;
          });
        } else {
          data = dragEl.textContent;
        }

        dataTransfer.setData('Text', data);
      }
    };
  }

  MultiDrag.prototype = {
    multiDragKeyDown: false,
    isMultiDrag: false,
    delayStartGlobal: function delayStartGlobal(_ref) {
      var dragged = _ref.dragEl;
      dragEl$1 = dragged;
    },
    delayEnded: function delayEnded() {
      this.isMultiDrag = ~multiDragElements.indexOf(dragEl$1);
    },
    setupClone: function setupClone(_ref2) {
      var sortable = _ref2.sortable,
          cancel = _ref2.cancel;
      if (!this.isMultiDrag) return;

      for (var i = 0; i < multiDragElements.length; i++) {
        multiDragClones.push(clone(multiDragElements[i]));
        multiDragClones[i].sortableIndex = multiDragElements[i].sortableIndex;
        multiDragClones[i].draggable = false;
        multiDragClones[i].style['will-change'] = '';
        toggleClass$1(multiDragClones[i], this.options.selectedClass, false);
        multiDragElements[i] === dragEl$1 && toggleClass$1(multiDragClones[i], this.options.chosenClass, false);
      }

      sortable._hideClone();

      cancel();
    },
    clone: function clone(_ref3) {
      var sortable = _ref3.sortable,
          rootEl = _ref3.rootEl,
          dispatchSortableEvent = _ref3.dispatchSortableEvent,
          cancel = _ref3.cancel;
      if (!this.isMultiDrag) return;

      if (!this.options.removeCloneOnHide) {
        if (multiDragElements.length && multiDragSortable === sortable) {
          insertMultiDragClones(true, rootEl);
          dispatchSortableEvent('clone');
          cancel();
        }
      }
    },
    showClone: function showClone(_ref4) {
      var cloneNowShown = _ref4.cloneNowShown,
          rootEl = _ref4.rootEl,
          cancel = _ref4.cancel;
      if (!this.isMultiDrag) return;
      insertMultiDragClones(false, rootEl);
      multiDragClones.forEach(function (clone) {
        css(clone, 'display', '');
      });
      cloneNowShown();
      clonesHidden = false;
      cancel();
    },
    hideClone: function hideClone(_ref5) {
      var _this = this;

      var sortable = _ref5.sortable,
          cloneNowHidden = _ref5.cloneNowHidden,
          cancel = _ref5.cancel;
      if (!this.isMultiDrag) return;
      multiDragClones.forEach(function (clone) {
        css(clone, 'display', 'none');

        if (_this.options.removeCloneOnHide && clone.parentNode) {
          clone.parentNode.removeChild(clone);
        }
      });
      cloneNowHidden();
      clonesHidden = true;
      cancel();
    },
    dragStartGlobal: function dragStartGlobal(_ref6) {
      var sortable = _ref6.sortable;

      if (!this.isMultiDrag && multiDragSortable) {
        multiDragSortable.multiDrag._deselectMultiDrag();
      }

      multiDragElements.forEach(function (multiDragElement) {
        multiDragElement.sortableIndex = index(multiDragElement);
      }); // Sort multi-drag elements

      multiDragElements = multiDragElements.sort(function (a, b) {
        return a.sortableIndex - b.sortableIndex;
      });
      dragStarted = true;
    },
    dragStarted: function dragStarted(_ref7) {
      var _this2 = this;

      var sortable = _ref7.sortable;
      if (!this.isMultiDrag) return;

      if (this.options.sort) {
        // Capture rects,
        // hide multi drag elements (by positioning them absolute),
        // set multi drag elements rects to dragRect,
        // show multi drag elements,
        // animate to rects,
        // unset rects & remove from DOM
        sortable.captureAnimationState();

        if (this.options.animation) {
          multiDragElements.forEach(function (multiDragElement) {
            if (multiDragElement === dragEl$1) return;
            css(multiDragElement, 'position', 'absolute');
          });
          var dragRect = getRect(dragEl$1, false, true, true);
          multiDragElements.forEach(function (multiDragElement) {
            if (multiDragElement === dragEl$1) return;
            setRect(multiDragElement, dragRect);
          });
          folding = true;
          initialFolding = true;
        }
      }

      sortable.animateAll(function () {
        folding = false;
        initialFolding = false;

        if (_this2.options.animation) {
          multiDragElements.forEach(function (multiDragElement) {
            unsetRect(multiDragElement);
          });
        } // Remove all auxiliary multidrag items from el, if sorting enabled


        if (_this2.options.sort) {
          removeMultiDragElements();
        }
      });
    },
    dragOver: function dragOver(_ref8) {
      var target = _ref8.target,
          completed = _ref8.completed,
          cancel = _ref8.cancel;

      if (folding && ~multiDragElements.indexOf(target)) {
        completed(false);
        cancel();
      }
    },
    revert: function revert(_ref9) {
      var fromSortable = _ref9.fromSortable,
          rootEl = _ref9.rootEl,
          sortable = _ref9.sortable,
          dragRect = _ref9.dragRect;

      if (multiDragElements.length > 1) {
        // Setup unfold animation
        multiDragElements.forEach(function (multiDragElement) {
          sortable.addAnimationState({
            target: multiDragElement,
            rect: folding ? getRect(multiDragElement) : dragRect
          });
          unsetRect(multiDragElement);
          multiDragElement.fromRect = dragRect;
          fromSortable.removeAnimationState(multiDragElement);
        });
        folding = false;
        insertMultiDragElements(!this.options.removeCloneOnHide, rootEl);
      }
    },
    dragOverCompleted: function dragOverCompleted(_ref10) {
      var sortable = _ref10.sortable,
          isOwner = _ref10.isOwner,
          insertion = _ref10.insertion,
          activeSortable = _ref10.activeSortable,
          parentEl = _ref10.parentEl,
          putSortable = _ref10.putSortable;
      var options = this.options;

      if (insertion) {
        // Clones must be hidden before folding animation to capture dragRectAbsolute properly
        if (isOwner) {
          activeSortable._hideClone();
        }

        initialFolding = false; // If leaving sort:false root, or already folding - Fold to new location

        if (options.animation && multiDragElements.length > 1 && (folding || !isOwner && !activeSortable.options.sort && !putSortable)) {
          // Fold: Set all multi drag elements's rects to dragEl's rect when multi-drag elements are invisible
          var dragRectAbsolute = getRect(dragEl$1, false, true, true);
          multiDragElements.forEach(function (multiDragElement) {
            if (multiDragElement === dragEl$1) return;
            setRect(multiDragElement, dragRectAbsolute); // Move element(s) to end of parentEl so that it does not interfere with multi-drag clones insertion if they are inserted
            // while folding, and so that we can capture them again because old sortable will no longer be fromSortable

            parentEl.appendChild(multiDragElement);
          });
          folding = true;
        } // Clones must be shown (and check to remove multi drags) after folding when interfering multiDragElements are moved out


        if (!isOwner) {
          // Only remove if not folding (folding will remove them anyways)
          if (!folding) {
            removeMultiDragElements();
          }

          if (multiDragElements.length > 1) {
            var clonesHiddenBefore = clonesHidden;

            activeSortable._showClone(sortable); // Unfold animation for clones if showing from hidden


            if (activeSortable.options.animation && !clonesHidden && clonesHiddenBefore) {
              multiDragClones.forEach(function (clone) {
                activeSortable.addAnimationState({
                  target: clone,
                  rect: clonesFromRect
                });
                clone.fromRect = clonesFromRect;
                clone.thisAnimationDuration = null;
              });
            }
          } else {
            activeSortable._showClone(sortable);
          }
        }
      }
    },
    dragOverAnimationCapture: function dragOverAnimationCapture(_ref11) {
      var dragRect = _ref11.dragRect,
          isOwner = _ref11.isOwner,
          activeSortable = _ref11.activeSortable;
      multiDragElements.forEach(function (multiDragElement) {
        multiDragElement.thisAnimationDuration = null;
      });

      if (activeSortable.options.animation && !isOwner && activeSortable.multiDrag.isMultiDrag) {
        clonesFromRect = _extends({}, dragRect);
        var dragMatrix = matrix(dragEl$1, true);
        clonesFromRect.top -= dragMatrix.f;
        clonesFromRect.left -= dragMatrix.e;
      }
    },
    dragOverAnimationComplete: function dragOverAnimationComplete() {
      if (folding) {
        folding = false;
        removeMultiDragElements();
      }
    },
    drop: function drop(_ref12) {
      var evt = _ref12.originalEvent,
          rootEl = _ref12.rootEl,
          parentEl = _ref12.parentEl,
          sortable = _ref12.sortable,
          dispatchSortableEvent = _ref12.dispatchSortableEvent,
          oldIndex = _ref12.oldIndex,
          putSortable = _ref12.putSortable;
      var toSortable = putSortable || this.sortable;
      if (!evt) return;
      var options = this.options,
          children = parentEl.children; // Multi-drag selection

      if (!dragStarted) {
        if (options.multiDragKey && !this.multiDragKeyDown) {
          this._deselectMultiDrag();
        }

        toggleClass$1(dragEl$1, options.selectedClass, !~multiDragElements.indexOf(dragEl$1));

        if (!~multiDragElements.indexOf(dragEl$1)) {
          multiDragElements.push(dragEl$1);
          dispatchEvent({
            sortable: sortable,
            rootEl: rootEl,
            name: 'select',
            targetEl: dragEl$1,
            originalEvt: evt
          }); // Modifier activated, select from last to dragEl

          if (evt.shiftKey && lastMultiDragSelect && sortable.el.contains(lastMultiDragSelect)) {
            var lastIndex = index(lastMultiDragSelect),
                currentIndex = index(dragEl$1);

            if (~lastIndex && ~currentIndex && lastIndex !== currentIndex) {
              // Must include lastMultiDragSelect (select it), in case modified selection from no selection
              // (but previous selection existed)
              var n, i;

              if (currentIndex > lastIndex) {
                i = lastIndex;
                n = currentIndex;
              } else {
                i = currentIndex;
                n = lastIndex + 1;
              }

              for (; i < n; i++) {
                if (~multiDragElements.indexOf(children[i])) continue;
                toggleClass$1(children[i], options.selectedClass, true);
                multiDragElements.push(children[i]);
                dispatchEvent({
                  sortable: sortable,
                  rootEl: rootEl,
                  name: 'select',
                  targetEl: children[i],
                  originalEvt: evt
                });
              }
            }
          } else {
            lastMultiDragSelect = dragEl$1;
          }

          multiDragSortable = toSortable;
        } else {
          multiDragElements.splice(multiDragElements.indexOf(dragEl$1), 1);
          lastMultiDragSelect = null;
          dispatchEvent({
            sortable: sortable,
            rootEl: rootEl,
            name: 'deselect',
            targetEl: dragEl$1,
            originalEvt: evt
          });
        }
      } // Multi-drag drop


      if (dragStarted && this.isMultiDrag) {
        folding = false; // Do not "unfold" after around dragEl if reverted

        if ((parentEl[expando].options.sort || parentEl !== rootEl) && multiDragElements.length > 1) {
          var dragRect = getRect(dragEl$1),
              multiDragIndex = index(dragEl$1, ':not(.' + this.options.selectedClass + ')');
          if (!initialFolding && options.animation) dragEl$1.thisAnimationDuration = null;
          toSortable.captureAnimationState();

          if (!initialFolding) {
            if (options.animation) {
              dragEl$1.fromRect = dragRect;
              multiDragElements.forEach(function (multiDragElement) {
                multiDragElement.thisAnimationDuration = null;

                if (multiDragElement !== dragEl$1) {
                  var rect = folding ? getRect(multiDragElement) : dragRect;
                  multiDragElement.fromRect = rect; // Prepare unfold animation

                  toSortable.addAnimationState({
                    target: multiDragElement,
                    rect: rect
                  });
                }
              });
            } // Multi drag elements are not necessarily removed from the DOM on drop, so to reinsert
            // properly they must all be removed


            removeMultiDragElements();
            multiDragElements.forEach(function (multiDragElement) {
              if (children[multiDragIndex]) {
                parentEl.insertBefore(multiDragElement, children[multiDragIndex]);
              } else {
                parentEl.appendChild(multiDragElement);
              }

              multiDragIndex++;
            }); // If initial folding is done, the elements may have changed position because they are now
            // unfolding around dragEl, even though dragEl may not have his index changed, so update event
            // must be fired here as Sortable will not.

            if (oldIndex === index(dragEl$1)) {
              var update = false;
              multiDragElements.forEach(function (multiDragElement) {
                if (multiDragElement.sortableIndex !== index(multiDragElement)) {
                  update = true;
                  return;
                }
              });

              if (update) {
                dispatchSortableEvent('update');
              }
            }
          } // Must be done after capturing individual rects (scroll bar)


          multiDragElements.forEach(function (multiDragElement) {
            unsetRect(multiDragElement);
          });
          toSortable.animateAll();
        }

        multiDragSortable = toSortable;
      } // Remove clones if necessary


      if (rootEl === parentEl || putSortable && putSortable.lastPutMode !== 'clone') {
        multiDragClones.forEach(function (clone) {
          clone.parentNode && clone.parentNode.removeChild(clone);
        });
      }
    },
    nullingGlobal: function nullingGlobal() {
      this.isMultiDrag = dragStarted = false;
      multiDragClones.length = 0;
    },
    destroyGlobal: function destroyGlobal() {
      this._deselectMultiDrag();

      off$1(document, 'pointerup', this._deselectMultiDrag);
      off$1(document, 'mouseup', this._deselectMultiDrag);
      off$1(document, 'touchend', this._deselectMultiDrag);
      off$1(document, 'keydown', this._checkKeyDown);
      off$1(document, 'keyup', this._checkKeyUp);
    },
    _deselectMultiDrag: function _deselectMultiDrag(evt) {
      if (typeof dragStarted !== "undefined" && dragStarted) return; // Only deselect if selection is in this sortable

      if (multiDragSortable !== this.sortable) return; // Only deselect if target is not item in this sortable

      if (evt && closest(evt.target, this.options.draggable, this.sortable.el, false)) return; // Only deselect if left click

      if (evt && evt.button !== 0) return;

      while (multiDragElements.length) {
        var el = multiDragElements[0];
        toggleClass$1(el, this.options.selectedClass, false);
        multiDragElements.shift();
        dispatchEvent({
          sortable: this.sortable,
          rootEl: this.sortable.el,
          name: 'deselect',
          targetEl: el,
          originalEvt: evt
        });
      }
    },
    _checkKeyDown: function _checkKeyDown(evt) {
      if (evt.key === this.options.multiDragKey) {
        this.multiDragKeyDown = true;
      }
    },
    _checkKeyUp: function _checkKeyUp(evt) {
      if (evt.key === this.options.multiDragKey) {
        this.multiDragKeyDown = false;
      }
    }
  };
  return _extends(MultiDrag, {
    // Static methods & properties
    pluginName: 'multiDrag',
    utils: {
      /**
       * Selects the provided multi-drag item
       * @param  {HTMLElement} el    The element to be selected
       */
      select: function select(el) {
        var sortable = el.parentNode[expando];
        if (!sortable || !sortable.options.multiDrag || ~multiDragElements.indexOf(el)) return;

        if (multiDragSortable && multiDragSortable !== sortable) {
          multiDragSortable.multiDrag._deselectMultiDrag();

          multiDragSortable = sortable;
        }

        toggleClass$1(el, sortable.options.selectedClass, true);
        multiDragElements.push(el);
      },

      /**
       * Deselects the provided multi-drag item
       * @param  {HTMLElement} el    The element to be deselected
       */
      deselect: function deselect(el) {
        var sortable = el.parentNode[expando],
            index = multiDragElements.indexOf(el);
        if (!sortable || !sortable.options.multiDrag || !~index) return;
        toggleClass$1(el, sortable.options.selectedClass, false);
        multiDragElements.splice(index, 1);
      }
    },
    eventProperties: function eventProperties() {
      var _this3 = this;

      var oldIndicies = [],
          newIndicies = [];
      multiDragElements.forEach(function (multiDragElement) {
        oldIndicies.push({
          multiDragElement: multiDragElement,
          index: multiDragElement.sortableIndex
        }); // multiDragElements will already be sorted if folding

        var newIndex;

        if (folding && multiDragElement !== dragEl$1) {
          newIndex = -1;
        } else if (folding) {
          newIndex = index(multiDragElement, ':not(.' + _this3.options.selectedClass + ')');
        } else {
          newIndex = index(multiDragElement);
        }

        newIndicies.push({
          multiDragElement: multiDragElement,
          index: newIndex
        });
      });
      return {
        items: _toConsumableArray(multiDragElements),
        clones: [].concat(multiDragClones),
        oldIndicies: oldIndicies,
        newIndicies: newIndicies
      };
    },
    optionListeners: {
      multiDragKey: function multiDragKey(key) {
        key = key.toLowerCase();

        if (key === 'ctrl') {
          key = 'Control';
        } else if (key.length > 1) {
          key = key.charAt(0).toUpperCase() + key.substr(1);
        }

        return key;
      }
    }
  });
}

function insertMultiDragElements(clonesInserted, rootEl) {
  multiDragElements.forEach(function (multiDragElement, i) {
    var target = rootEl.children[multiDragElement.sortableIndex + (clonesInserted ? Number(i) : 0)];

    if (target) {
      rootEl.insertBefore(multiDragElement, target);
    } else {
      rootEl.appendChild(multiDragElement);
    }
  });
}
/**
 * Insert multi-drag clones
 * @param  {[Boolean]} elementsInserted  Whether the multi-drag elements are inserted
 * @param  {HTMLElement} rootEl
 */


function insertMultiDragClones(elementsInserted, rootEl) {
  multiDragClones.forEach(function (clone, i) {
    var target = rootEl.children[clone.sortableIndex + (elementsInserted ? Number(i) : 0)];

    if (target) {
      rootEl.insertBefore(clone, target);
    } else {
      rootEl.appendChild(clone);
    }
  });
}

function removeMultiDragElements() {
  multiDragElements.forEach(function (multiDragElement) {
    if (multiDragElement === dragEl$1) return;
    multiDragElement.parentNode && multiDragElement.parentNode.removeChild(multiDragElement);
  });
}

Sortable.mount(new AutoScrollPlugin());
Sortable.mount(Remove, Revert);

Sortable.mount(new SwapPlugin());
Sortable.mount(new MultiDragPlugin());

function _defineProperty$1y(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "grid" XET-Tag
 *
 * This also includes repeating the last row in the grid and filling
 * it with content data
 *
 * @augments et2_DOMWidget
 */
class et2_grid extends et2_DOMWidget {
  /**
   * Constructor
   *
   * @memberOf et2_grid
   */
  constructor(_parent, _attrs, _child) {
    // Call the parent constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_grid._attributes, _child || {}));
    // Create the table body and the table
    _defineProperty$1y(this, "table", void 0);
    _defineProperty$1y(this, "thead", void 0);
    _defineProperty$1y(this, "tfoot", void 0);
    _defineProperty$1y(this, "tbody", void 0);
    // Counters for rows and columns
    _defineProperty$1y(this, "rowCount", 0);
    _defineProperty$1y(this, "columnCount", 0);
    // 2D-Array which holds references to the DOM td tags
    _defineProperty$1y(this, "cells", []);
    _defineProperty$1y(this, "rowData", []);
    _defineProperty$1y(this, "colData", []);
    _defineProperty$1y(this, "managementArray", []);
    // Keep the template node for later regeneration
    _defineProperty$1y(this, "template_node", null);
    // Wrapper div for height & overflow, if needed
    _defineProperty$1y(this, "wrapper", null);
    _defineProperty$1y(this, "lastRowNode", void 0);
    _defineProperty$1y(this, "sortablejs", null);
    this.table = jQuery(document.createElement("table")).addClass("et2_grid");
    if (_attrs.class) this.table.addClass(_attrs.class);
    this.thead = jQuery(document.createElement("thead")).appendTo(this.table);
    this.tfoot = jQuery(document.createElement("tfoot")).appendTo(this.table);
    this.tbody = jQuery(document.createElement("tbody")).appendTo(this.table);
  }
  _initCells(_colData, _rowData) {
    // Copy the width and height
    var w = _colData.length;
    var h = _rowData.length;

    // Create the 2D-Cells array
    var cells = new Array(h);
    for (var y = 0; y < h; y++) {
      cells[y] = new Array(w);

      // Initialize the cell description objects
      for (var x = 0; x < w; x++) {
        // Some columns (nm) we do not parse into a boolean
        var col_disabled = _colData[x].disabled;
        cells[y][x] = {
          "td": null,
          "widget": null,
          "colData": _colData[x],
          "rowData": _rowData[y],
          "disabled": col_disabled || _rowData[y].disabled,
          "class": _colData[x]["class"],
          "colSpan": 1,
          "autoColSpan": false,
          "rowSpan": 1,
          "autoRowSpan": false,
          "width": _colData[x].width,
          "x": x,
          "y": y
        };
      }
    }
    return cells;
  }
  _getColDataEntry() {
    return {
      width: "auto",
      class: "",
      align: "",
      span: "1",
      disabled: false
    };
  }
  _getRowDataEntry() {
    return {
      height: "auto",
      class: "",
      valign: "top",
      span: "1",
      disabled: false
    };
  }
  _getCell(_cells, _x, _y) {
    if (0 <= _y && _y < _cells.length) {
      var row = _cells[_y];
      if (0 <= _x && _x < row.length) {
        return row[_x];
      }
    }
    throw "Error while accessing grid cells, invalid element count or span value!";
  }
  _forceNumber(_val) {
    if (isNaN(_val)) {
      throw _val + " is not a number!";
    }
    return parseInt(_val);
  }
  _fetchRowColData(columns, rows, colData, rowData) {
    var _this = this;
    // Some things cannot be done inside a nextmatch - nm will do the expansion later
    var nm = false;
    var widget = this;
    while (!nm && widget != this.getRoot()) {
      nm = widget.getType() == 'nextmatch';
      widget = widget.getParent();
    }

    // Parse the columns tag
    et2_filteredNodeIterator(columns, function (node, nodeName) {
      var colDataEntry = this._getColDataEntry();
      // This cannot be done inside a nm, it will expand it later
      colDataEntry["disabled"] = nm ? et2_readAttrWithDefault(node, "disabled", "") : this.getArrayMgr("content").parseBoolExpression(et2_readAttrWithDefault(node, "disabled", ""));
      if (nodeName == "column") {
        colDataEntry["width"] = et2_readAttrWithDefault(node, "width", "auto");
        colDataEntry["class"] = et2_readAttrWithDefault(node, "class", "");
        colDataEntry["align"] = et2_readAttrWithDefault(node, "align", "");
        colDataEntry["span"] = et2_readAttrWithDefault(node, "span", "1");

        // Keep any others attributes set, there's no 'column' widget
        for (var i in node.attributes) {
          var attr = node.attributes[i];
          if (attr.nodeType == 2 && typeof colDataEntry[attr.nodeName] == 'undefined') {
            colDataEntry[attr.nodeName] = attr.value;
          }
        }
      } else {
        colDataEntry["span"] = "all";
      }
      colData.push(colDataEntry);
    }, this);

    // Parse the rows tag
    et2_filteredNodeIterator(rows, function (node, nodeName) {
      var rowDataEntry = this._getRowDataEntry();
      rowDataEntry["disabled"] = this.getArrayMgr("content").parseBoolExpression(et2_readAttrWithDefault(node, "disabled", ""));
      if (nodeName == "row") {
        // Remember this row for auto-repeat - it'll eventually be the last one
        this.lastRowNode = node;
        rowDataEntry["height"] = et2_readAttrWithDefault(node, "height", "auto");
        rowDataEntry["class"] = et2_readAttrWithDefault(node, "class", "");
        rowDataEntry["valign"] = et2_readAttrWithDefault(node, "valign", "");
        rowDataEntry["span"] = et2_readAttrWithDefault(node, "span", "1");
        rowDataEntry["part"] = et2_readAttrWithDefault(node, "part", "body");
        var id = et2_readAttrWithDefault(node, "id", "");
        if (id) {
          rowDataEntry["id"] = id;
        }
      } else {
        rowDataEntry["span"] = "all";
      }
      rowData.push(rowDataEntry);
    }, this);

    // Add in repeated rows
    // TODO: It would be nice if we could skip header (thead) & footer (tfoot) or treat them separately
    var rowIndex = Infinity;
    if (this.getArrayMgr("content")) {
      var content = this.getArrayMgr("content");
      var rowDataEntry = rowData[rowData.length - 1];
      rowIndex = rowData.length - 1;
      // Find out if we have any content rows, and how many
      var cont = true;
      var _loop = function _loop() {
          if (content.data[rowIndex]) {
            rowData[rowIndex] = jQuery.extend({}, rowDataEntry);
            rowIndex++;
          } else if (_this.lastRowNode != null) {
            // Have to look through actual widgets to support const[$row]
            // style names - should be avoided so we can remove this extra check
            // Old etemplate checked first two widgets, or first two box children
            // This cannot be done inside a nextmatch - nm will do the expansion later
            nm = false;
            if (nm) {
              // No further checks for repeated rows
              return 0; // break
            }

            // Not in a nextmatch, so we can expand with abandon
            var currentPerspective = jQuery.extend({}, content.perspectiveData);
            var check = function check(node, nodeName) {
              if (nodeName == 'box' || nodeName == 'hbox' || nodeName == 'vbox') {
                return et2_filteredNodeIterator(node, check, this);
              }
              content.perspectiveData.row = rowIndex;
              for (var attr in node.attributes) {
                var value = et2_readAttrWithDefault(node, node.attributes[attr].name, "");
                // Don't include first char, those should be handled by normal means
                // and it would break nextmatch
                if (value.indexOf('@') > 0 || value.indexOf('$') > 0) {
                  // Ok, we found something.  How many? Check for values.
                  var ident = content.expandName(value);
                  // expandName() handles index into content (@), but we have to look up
                  // regular values
                  if (value[0] != '@') {
                    // Returns null if there isn't an actual value
                    ident = content.getEntry(ident, false, true);
                  }
                  while (ident != null && rowIndex < 1000) {
                    rowData[rowIndex] = jQuery.extend({}, rowDataEntry);
                    content.perspectiveData.row = ++rowIndex;
                    ident = content.expandName(value);
                    if (value[0] != '@') {
                      // Returns null if there isn't an actual value
                      ident = content.getEntry(ident, false, true);
                    }
                  }
                  if (rowIndex >= 1000) {
                    egw$1.debug("error", "Problem in autorepeat fallback: too many rows for '%s'.  Use a nextmatch, or start debugging.", value);
                  }
                  return;
                }
              }
            };
            et2_filteredNodeIterator(_this.lastRowNode, check, _this);
            cont = false;
            content.perspectiveData = currentPerspective;
          } else {
            // No more rows, stop
            return 0; // break
          }
        },
        nm,
        _ret;
      while (cont) {
        _ret = _loop();
        if (_ret === 0) break;
      }
    }
    if (rowIndex <= rowData.length - 1) {
      // No auto-repeat
      this.lastRowNode = null;
    }
  }
  _fillCells(cells, columns, rows) {
    var h = cells.length;
    var w = h > 0 ? cells[0].length : 0;
    var currentPerspective = jQuery.extend({}, this.getArrayMgr("content").perspectiveData);

    // Read the elements inside the columns
    var x = 0;
    et2_filteredNodeIterator(columns, function (node, nodeName) {
      function _readColNode(node, nodeName) {
        if (y >= h) {
          this.egw().debug("warn", "Skipped grid cell in column, '" + nodeName + "'");
          return;
        }
        var cell = this._getCell(cells, x, y);

        // Read the span value of the element
        if (node.getAttribute("span")) {
          cell.rowSpan = node.getAttribute("span");
        } else {
          cell.rowSpan = cell.colData["span"];
          cell.autoRowSpan = true;
        }
        if (cell.rowSpan == "all") {
          cell.rowSpan = cells.length;
        }
        var span = cell.rowSpan = this._forceNumber(cell.rowSpan);

        // Create the widget
        var widget = this.createElementFromNode(node, nodeName);

        // Fill all cells the widget is spanning
        for (var i = 0; i < span && y < cells.length; i++, y++) {
          this._getCell(cells, x, y).widget = widget;
        }
      }

      // If the node is a column, create the widgets which belong into
      // the column
      var y = 0;
      if (nodeName == "column") {
        et2_filteredNodeIterator(node, _readColNode, this);
      } else {
        _readColNode.call(this, node, nodeName);
      }
      x++;
    }, this);

    // Read the elements inside the rows
    var y = 0;
    x = 0;
    var readRowNode;
    var nm = false;
    var widget = this;
    while (!nm && widget != this.getRoot()) {
      nm = widget.getType() == 'nextmatch';
      widget = widget.getParent();
    }
    et2_filteredNodeIterator(rows, function (node, nodeName) {
      readRowNode = function _readRowNode(node, nodeName) {
        if (x >= w) {
          if (nodeName != "description") {
            // Only notify it skipping other than description,
            // description used to pad
            this.egw().debug("warn", "Skipped grid cell in row, '" + nodeName + "'");
          }
          return;
        }
        var cell = this._getCell(cells, x, y);

        // Read the span value of the element
        if (node.getAttribute("span")) {
          cell.colSpan = node.getAttribute("span");
        } else {
          cell.colSpan = cell.rowData["span"];
          cell.autoColSpan = true;
        }
        if (cell.colSpan == "all") {
          cell.colSpan = cells[y].length;
        }
        var span = cell.colSpan = this._forceNumber(cell.colSpan);

        // Read the align value of the element
        if (node.getAttribute("align")) {
          cell.align = node.getAttribute("align");
        }

        // store id of nextmatch-*headers, so it is available for disabled widgets, which get not instanciated
        if (nodeName.substr(0, 10) == 'nextmatch-') {
          cell.nm_id = node.getAttribute('id');
        }
        // Apply widget's class to td, for backward compatability
        if (node.getAttribute("class")) {
          var widget_class = (this.getArrayMgr("content").expandName(node.getAttribute("class")) || ""
          // Do not pass et2_required into parent cell, it looks bad
          ).replace("et2_required", "");
          cell.class += (cell.class ? " " : "") + widget_class;
        }

        // Create the element
        if (!cell.disabled || cell.disabled && typeof cell.disabled === 'string') {
          //Skip if it is a nextmatch while the nextmatch handles row adjustment by itself
          if (!nm) {
            // Adjust for the row
            var mgrs = this.getArrayMgrs();
            for (var _name in mgrs) {
              this.getArrayMgr(_name).perspectiveData.row = y;
            }
            if (this._getCell(cells, x, y).rowData.id) {
              this._getCell(cells, x, y).rowData.id = this.getArrayMgr("content").expandName(this._getCell(cells, x, y).rowData.id);
            }
            if (this._getCell(cells, x, y).rowData.class) {
              this._getCell(cells, x, y).rowData.class = this.getArrayMgr("content").expandName(this._getCell(cells, x, y).rowData.class);
            }
          }
          if (!nm && typeof cell.disabled === 'string') {
            cell.disabled = this.getArrayMgr("content").parseBoolExpression(cell.disabled);
          }
          if (nm || !cell.disabled) {
            var widget = this.createElementFromNode(node, nodeName);
          }
        }

        // Fill all cells the widget is spanning
        for (var i = 0; i < span && x < cells[y].length; i++, x++) {
          cell = this._getCell(cells, x, y);
          if (cell.widget == null) {
            cell.widget = widget;
          } else {
            throw "Grid cell collision, two elements " + "defined for cell (" + x + "," + y + ")!";
          }
        }
      };

      // If the node is a row, create the widgets which belong into
      // the row
      x = 0;
      if (this.lastRowNode && node == this.lastRowNode) {
        return;
      }
      if (nodeName == "row") {
        // Adjust for the row
        for (var name in this.getArrayMgrs()) {
          //this.getArrayMgr(name).perspectiveData.row = y;
        }
        var cell = this._getCell(cells, x, y);
        if (cell.rowData.id) {
          this.getArrayMgr("content").expandName(cell.rowData.id);
        }
        // If row disabled, just skip it
        var disabled = false;
        if (node.getAttribute("disabled") == "1") {
          disabled = true;
        }
        if (!disabled) {
          et2_filteredNodeIterator(node, readRowNode, this);
        }
      } else {
        readRowNode.call(this, node, nodeName);
      }
      y++;
    }, this);

    // Extra content rows
    for (y; y < h; y++) {
      x = 0;
      et2_filteredNodeIterator(this.lastRowNode, readRowNode, this);
    }
    // Reset
    for (var name in this.getArrayMgrs()) {
      this.getArrayMgr(name).perspectiveData = currentPerspective;
    }
  }
  _expandLastCells(_cells) {
    var h = _cells.length;
    var w = h > 0 ? _cells[0].length : 0;

    // Determine the last cell in each row and expand its span value if
    // the span has not been explicitly set.
    for (var y = 0; y < h; y++) {
      for (var x = w - 1; x >= 0; x--) {
        var cell = _cells[y][x];
        if (cell.widget != null) {
          if (cell.autoColSpan) {
            cell.colSpan = w - x;
          }
          break;
        }
      }
    }

    // Determine the last cell in each column and expand its span value if
    // the span has not been explicitly set.
    for (var x = 0; x < w; x++) {
      for (var y = h - 1; y >= 0; y--) {
        var cell = _cells[y][x];
        if (cell.widget != null) {
          if (cell.autoRowSpan) {
            cell.rowSpan = h - y;
          }
          break;
        }
      }
    }
  }
  _createNamespace() {
    return true;
  }

  /**
   * As the does not fit very well into the default widget structure, we're
   * overwriting the loadFromXML function and doing a two-pass reading -
   * in the first step the
   *
   * @param {object} _node xml node to process
   */
  loadFromXML(_node) {
    // Keep the node for later changing / reloading
    this.template_node = _node;

    // Get the columns and rows tag
    var rowsElems = et2_directChildrenByTagName(_node, "rows");
    var columnsElems = et2_directChildrenByTagName(_node, "columns");
    if (rowsElems.length == 1 && columnsElems.length == 1) {
      var columns = columnsElems[0];
      var rows = rowsElems[0];
      var colData = [];
      var rowData = [];

      // Fetch the column and row data
      this._fetchRowColData(columns, rows, colData, rowData);

      // Initialize the cells
      var cells = this._initCells(colData, rowData);

      // Create the widgets inside the cells and read the span values
      this._fillCells(cells, columns, rows);

      // Expand the span values of the last cells
      this._expandLastCells(cells);

      // Create the table rows
      this.createTableFromCells(cells, colData, rowData);
    } else {
      throw "Error while parsing grid, none or multiple rows or columns tags!";
    }
  }
  createTableFromCells(_cells, _colData, _rowData) {
    this.managementArray = [];
    this.cells = _cells;
    this.colData = _colData;
    this.rowData = _rowData;

    // Set the rowCount and columnCount variables
    var h = this.rowCount = _cells.length;
    var w = this.columnCount = h > 0 ? _cells[0].length : 0;

    // Create the table rows.
    for (var y = 0; y < h; y++) {
      var parent = this.tbody;
      switch (this.rowData[y]["part"]) {
        case 'header':
          if (!this.tbody.children().length && !this.tfoot.children().length) {
            parent = this.thead;
          }
          break;
        case 'footer':
          if (!this.tbody.children().length) {
            parent = this.tfoot;
          }
          break;
      }
      var tr = jQuery(document.createElement("tr")).appendTo(parent).addClass(this.rowData[y]["class"]);
      if (this.rowData[y].disabled) {
        tr.hide();
      }
      if (this.rowData[y].height != "auto") {
        tr.height(this.rowData[y].height);
      }
      if (this.rowData[y].valign) {
        tr.attr("valign", this.rowData[y].valign);
      }
      if (this.rowData[y].id) {
        tr.attr("id", this.rowData[y].id);
      }
      // Create the cells. x is incremented by the colSpan value of the
      // cell.
      for (var x = 0; x < w;) {
        // Fetch a cell from the cells
        var cell = this._getCell(_cells, x, y);
        if (cell.td == null && cell.widget != null) {
          // Create the cell
          var td = jQuery(document.createElement("td")).appendTo(tr).addClass(cell["class"]);
          if (cell.disabled) {
            td.hide();
            // Need to do different things with webComponents
            if (typeof cell.widget.options === "object") {
              cell.widget.options.disabled = cell.disabled;
            } else if (cell.widget.nodeName) {
              cell.widget.disabled = cell.disabled;
            }
          }

          // do NOT set cell width, if we have a colspan
          if (cell.width !== "auto" && cell.colSpan <= 1) {
            td.width(cell.width);
          }
          if (cell.align) {
            td.attr("align", cell.align);
          }

          // Add the entry for the widget to the management array
          this.managementArray.push({
            "cell": td[0],
            "widget": cell.widget,
            "disabled": cell.disabled
          });

          // Set the span values of the cell
          var cs = x == w - 1 ? w - x : Math.min(w - x, cell.colSpan);
          var rs = y == h - 1 ? h - y : Math.min(h - y, cell.rowSpan);

          // Set the col and row span values
          if (cs > 1) {
            td.attr("colspan", cs);
          }
          if (rs > 1) {
            td.attr("rowspan", rs);
          }

          // Assign the td to the cell
          for (var sx = x; sx < x + cs; sx++) {
            for (var sy = y; sy < y + rs; sy++) {
              this._getCell(_cells, sx, sy).td = td;
            }
          }
          x += cell.colSpan;
        } else {
          x++;
        }
      }
    }
  }
  getDOMNode(_sender) {
    // If the parent class functions are asking for the DOM-Node, return the
    // outer table.
    if (_sender == this || typeof _sender == 'undefined') {
      return this.wrapper != null ? this.wrapper[0] : this.table[0];
    }

    // Check whether the _sender object exists inside the management array
    for (var i = 0; i < this.managementArray.length; i++) {
      if (this.managementArray[i].widget == _sender) {
        return this.managementArray[i].cell;
      }
    }
    return null;
  }
  isInTree(_sender) {
    var vis = true;
    if (typeof _sender != "undefined" && _sender != this) {
      vis = false;

      // Check whether the _sender object exists inside the management array
      for (var i = 0; i < this.managementArray.length; i++) {
        if (this.managementArray[i].widget == _sender) {
          vis = !(typeof this.managementArray[i].disabled === 'boolean' ? this.managementArray[i].disabled : this.getArrayMgr("content").parseBoolExpression(this.managementArray[i].disabled));
          break;
        }
      }
    }
    return super.isInTree(this, vis);
  }

  /**
   * Set the overflow attribute
   *
   * Grid needs special handling because HTML tables don't do overflow.  We
   * create a wrapper DIV to handle it.
   * No value or default visible needs no wrapper, as table is always overflow visible.
   *
   * @param {string} _value Overflow value, must be a valid CSS overflow value, default 'visible'
   */
  set_overflow(_value) {
    var wrapper = this.wrapper || this.table.parent('[id$="_grid_wrapper"]');
    this.overflow = _value;
    if (wrapper.length == 0 && _value && _value !== 'visible') {
      this.wrapper = wrapper = this.table.wrap('<div id="' + this.id + '_grid_wrapper"></div>').parent();
      if (this.height) {
        wrapper.css('height', this.height);
      }
    }
    wrapper.css('overflow', _value);
    if (wrapper.length && (!_value || _value === 'visible')) {
      this.table.unwrap();
    }
  }

  /**
   * Change the content for the grid, and re-generate its contents.
   *
   * Changing the content does not allow changing the structure of the grid,
   * as that is loaded from the template file.  The rows and widgets inside
   * will be re-created (including auto-repeat).
   *
   * @param {Object} _value New data for the grid
   * @param {Object} [_value.content] New content
   * @param {Object} [_value.sel_options] New select options
   * @param {Object} [_value.readonlys] New read-only values
   */
  set_value(_value) {
    // Destroy children, empty grid
    for (var i = 0; i < this.managementArray.length; i++) {
      var cell = this.managementArray[i];
      if (cell.widget) {
        this.removeChild(cell.widget);
        cell.widget.destroy();
      }
    }
    this.managementArray = [];
    this.thead.empty();
    this.tfoot.empty();
    this.tbody.empty();

    // Update array managers
    for (var key in _value) {
      this.getArrayMgr(key).data = _value[key];
    }

    // Rebuild grid
    this.loadFromXML(this.template_node);

    // New widgets need to finish
    var promises = [];
    this.loadingFinished(promises);
  }

  /**
   * Sortable allows you to reorder grid rows using the mouse.
   * The new order is returned as part of the value of the
   * grid, in 'sort_order'.
   *
   * @param {boolean|function} sortable Callback or false to disable
   */
  set_sortable(sortable) {
    var self = this;
    var tbody = this.getDOMNode().getElementsByTagName('tbody')[0];
    if (!sortable && this.sortablejs) {
      this.sortablejs.destroy();
      return;
    }
    for (var i = 0; i < tbody.children.length; i++) {
      if (!tbody.children[i].classList.contains('th') && !tbody.children[i].id) {
        tbody.children[i].setAttribute('id', i.toString());
      }
    }
    this.sortablejs = new Sortable(tbody, {
      group: this.options.sortable_connectWith,
      draggable: "tr:not(.th)",
      filter: this.options.sortable_cancel,
      ghostClass: this.options.sortable_placeholder,
      dataIdAttr: 'id',
      onAdd: function onAdd(event) {
        if (typeof self.options.sortable_recieveCallback == 'function') {
          self.options.sortable_recieveCallback.call(self, event, this, self.id);
        }
      },
      onStart: function onStart(event, ui) {
        if (typeof self.options.sortable_startCallback == 'function') {
          self.options.sortable_startCallback.call(self, event, this, self.id);
        }
      },
      onSort: function onSort(event) {
        self.egw().json(sortable, [self.getInstanceManager().etemplate_exec_id, self.sortablejs.toArray(), self.id], null, self, true).sendRequest();
      }
    });
  }

  /**
   * Override parent to apply actions on each row
   *
   * @param {array} actions [ {ID: attributes..}+] as for set_actions
   */
  _link_actions(actions) {
    // Get the top level element for the tree
    // get appObjectManager for the actual app, it might not always be the current app(e.g. running app content under admin tab)
    // @ts-ignore
    var objectManager = egw_getAppObjectManager(true, this.getInstanceManager().app);
    objectManager = objectManager.getObjectById(this.getInstanceManager().uniqueId, 2) || objectManager;
    var widget_object = objectManager.getObjectById(this.id);
    if (widget_object == null) {
      // Add a new container to the object manager which will hold the widget
      // objects
      widget_object = objectManager.insertObject(false, new egwActionObject(this.id, objectManager, new et2_action_object_impl(this).getAOI(), this._actionManager || objectManager.manager.getActionById(this.id) || objectManager.manager));
    }

    // Delete all old objects
    widget_object.clear();

    // Go over the widget & add links - this is where we decide which actions are
    // 'allowed' for this widget at this time
    var action_links = this._get_action_links(actions);

    // Deal with each row in tbody, ignore action-wise rows in thead or tfooter for now
    var i = 0,
      r = 0;
    for (; i < this.rowData.length; i++) {
      if (this.rowData[i].part != 'body') continue;
      var content = this.getArrayMgr('content').getEntry(i);
      if (content) {
        // Add a new action object to the object manager
        var row = jQuery('tr', this.tbody)[r];
        var aoi = new et2_action_object_impl(this, row).getAOI();
        var obj = widget_object.addObject(content.id || "row_" + r, aoi);

        // Set the data to the content so it's available for the action
        obj.data = content;
        obj.updateActionLinks(action_links);
      }
      r++;
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM
   * This doesn't need to be implemented.
   * Individual widgets are detected and handled by the grid, but the interface is needed for this to happen
   *
   * @param {array} _attrs array to add further attributes to
   */
  getDetachedAttributes(_attrs) {}
  getDetachedNodes() {
    return [this.getDOMNode()];
  }
  setDetachedAttributes(_nodes, _values) {}

  /**
   * Generates nextmatch column name for headers in a grid
   *
   * Implemented here as default implementation in et2_externsion_nextmatch
   * only considers children, but grid does NOT instanciate disabled rows as children.
   *
   * @return {string}
   */
  _getColumnName() {
    var ids = [];
    for (var r = 0; r < this.cells.length; ++r) {
      var cols = this.cells[r];
      for (var c = 0; c < cols.length; ++c) {
        if (cols[c].nm_id) ids.push(cols[c].nm_id);
      }
    }
    return ids.join('_');
  }
  resize(_height) {
    if (typeof this.options != 'undefined' && _height && typeof this.options.resize_ratio != 'undefined' && this.options.resize_ratio) {
      // apply the ratio
      _height = this.options.resize_ratio != '' ? _height * this.options.resize_ratio : _height;
      if (_height != 0) {
        if (this.wrapper) {
          this.wrapper.height(this.wrapper.height() + _height);
        } else {
          this.table.height(this.table.height() + _height);
        }
      }
    }
  }

  /**
   * Get a dummy row object containing all widget of a row
   *
   * This is only a temp. solution until rows are implemented as eT2 containers and
   * _sender.getParent() will return a real row container.
   *
   * @deprecated Not used?  Remove this if you find something using it
   *
   * @param {et2_widget} _sender
   * @returns {Array|undefined}
   */
  getRow(_sender) {
    var _this2 = this;
    if (!_sender || !this.cells) return;
    for (var r = 0; r < this.cells.length; ++r) {
      var row = this.cells[r];
      var _loop2 = function _loop2() {
          if (!row[c].widget) return 0; // continue
          var found = row[c].widget === _sender;
          if (!found) row[c].widget.iterateOver(function (_widget) {
            if (_widget === _sender) found = true;
          });
          if (found) {
            // return a fake row object allowing to iterate over it's children
            var row_obj = new et2_widget(_this2, {});
            for (c = 0; c < row.length; ++c) {
              if (row[c].widget) row_obj.addChild(row[c].widget);
            }
            row_obj.isInTree = jQuery.proxy(_this2.isInTree, _this2);
            // we must not free the children!
            row_obj.destroy = function () {
              // @ts-ignore
              delete row_obj._children;
            };
            return {
              v: row_obj
            };
          }
        },
        c,
        _ret2;
      for (var c = 0; c < row.length; ++c) {
        _ret2 = _loop2();
        if (_ret2 === 0) continue;
        if (_ret2) return _ret2.v;
      }
    }
  }

  /**
   * Needed for the align interface, but we're not doing anything with it...
   */
  get_align() {
    return "";
  }
}
_defineProperty$1y(et2_grid, "_attributes", {
  // Better to use CSS, no need to warn about it
  "border": {
    "ignore": true
  },
  "align": {
    "name": "Align",
    "type": "string",
    "default": "left",
    "description": "Position of this element in the parent hbox"
  },
  "spacing": {
    "ignore": true
  },
  "padding": {
    "ignore": true
  },
  "sortable": {
    "name": "Sortable callback",
    "type": "string",
    "default": et2_no_init,
    "description": "PHP function called when user sorts the grid.  Setting this enables sorting the grid rows.  The callback will be passed the ID of the grid and the new order of the rows."
  },
  sortable_containment: {
    name: "Sortable bounding area",
    type: "string",
    default: "",
    description: "Defines bounding area for sortable items"
  },
  sortable_connectWith: {
    name: "Sortable connectWith element",
    type: "string",
    default: "",
    description: "Defines other sortable areas that should be connected to sort list"
  },
  sortable_placeholder: {
    name: "Sortable placeholder",
    type: "string",
    default: "",
    description: "Defines sortable placeholder"
  },
  sortable_cancel: {
    name: "Sortable cancel class",
    type: "string",
    default: "",
    description: "Defines sortable cancel which prevents sorting the matching element"
  },
  sortable_recieveCallback: {
    name: "Sortable receive callback",
    type: "js",
    default: et2_no_init,
    description: "Defines sortable receive callback function"
  },
  sortable_startCallback: {
    name: "Sortable start callback",
    type: "js",
    default: et2_no_init,
    description: "Defines sortable start callback function"
  }
});
et2_register_widget(et2_grid, ["grid"]);

function _defineProperty$1x(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Object which resizes an inner node to the maximum extend of an outer node
 * (without creating a scrollbar) - it achieves that by performing some very
 * nasty and time consuming calculations.
 */
class et2_dynheight {
  constructor(_outerNode, _innerNode, _minHeight) {
    _defineProperty$1x(this, "initialized", false);
    _defineProperty$1x(this, "outerNode", void 0);
    _defineProperty$1x(this, "innerNode", void 0);
    _defineProperty$1x(this, "minHeight", 0);
    _defineProperty$1x(this, "bottomNodes", []);
    _defineProperty$1x(this, "innerMargin", 0);
    _defineProperty$1x(this, "outerMargin", 0);
    this.outerNode = jQuery(_outerNode);
    this.innerNode = jQuery(_innerNode);
    this.minHeight = _minHeight;
  }
  destroy() {
    this.outerNode = null;
    this.innerNode = null;
    this.bottomNodes = [];
  }

  /**
   * Resizes the inner node. When this is done, the callback function is
   * called.
   *
   * @param {function} _callback
   * @param {object} _context
   */
  update(_callback, _context) {
    // Check whether the inner node is actually visible - if not, don't
    // trigger the callback function
    if (this.innerNode.is(":visible")) {
      // Initialize the height calculation
      this._initialize();

      // Get the outer container height and offset, if available
      var oh = this.outerNode.height();
      var ot = this.outerNode.offset() ? this.outerNode.offset().top : 0;

      // Get top and height of the inner node
      var it = this.innerNode.offset().top;

      // Calculate the height of the "bottomNodes"
      var bminTop = this.bottomNodes.length ? Infinity : 0;
      var bmaxBot = 0;
      for (var i = 0; i < this.bottomNodes.length; i++) {
        // Ignore hidden popups
        if (this.bottomNodes[i].find('.action_popup').length) {
          egw$1.debug('warn', "Had to skip a hidden popup - it should be removed", this.bottomNodes[i].find('.action_popup'));
          continue;
        }
        // Ignore other hidden nodes
        if (!this.bottomNodes[i].is(':visible')) continue;

        // Get height, top and bottom and calculate the maximum/minimum
        var _bh = this.bottomNodes[i].outerHeight(true);
        var bt = this.bottomNodes[i].offset().top;
        var bb = _bh + bt;
        if (i == 0 || bminTop > bt) {
          bminTop = bt;
        }
        if (i == 0 || bmaxBot < bb) {
          bmaxBot = bb;
        }
      }

      // Get the height of the bottom container
      var bh = Math.max(0, bmaxBot - bminTop);

      // Calculate the new height of the inner container
      var h = Math.max(this.minHeight, oh + ot - it - bh - this.innerMargin - this.outerMargin);
      this.innerNode.height(h);

      // Update the width
      // Some checking to make sure it doesn't overflow the width when user
      // resizes the window
      var w = this.outerNode.width();
      if (w > jQuery(window).width()) {
        // 50px border, totally arbitrary, but we just need to make sure it's inside
        w = jQuery(window).width() - 50;
      }
      if (w != this.innerNode.outerWidth()) {
        this.innerNode.width(w);
      }

      // Call the callback function
      if (typeof _callback != "undefined") {
        _callback.call(_context, w, h);
      }
    }
  }

  /**
   * Function used internally which collects all DOM-Nodes which are located
   * below this element.
   *
   * @param {HTMLElement} _node
   * @param {number} _bottom
   */
  _collectBottomNodes(_node, _bottom) {
    // Calculate the bottom position of the inner node
    if (typeof _bottom == "undefined") {
      _bottom = this.innerNode.offset().top + this.innerNode.height();
    }
    if (_node) {
      // Accumulate the outer margin of the parent elements
      var node = jQuery(_node);
      var ooh = node.outerHeight(true);
      var oh = node.height();
      this.outerMargin += (ooh - oh) / 2; // Divide by 2 as the value contains margin-top and -bottom

      // Iterate over the children of the given node and do the same
      // recursively to the parent nodes until the _outerNode or body is
      // reached.
      var self = this;
      jQuery(_node).children().each(function () {
        var $this = jQuery(this);
        var top = $this.offset().top;
        if (this != self.innerNode[0] && top >= _bottom && ["fixed", "absolute"].indexOf(getComputedStyle(this).position) == -1) {
          self.bottomNodes.push($this);
        }
      });
      if (_node != this.outerNode[0] && _node != jQuery("body")[0]) {
        this._collectBottomNodes(_node.parentNode, _bottom);
      }
    }
  }

  /**
   * Used internally to calculate some information which will not change over
   * the time.
   */
  _initialize() {
    if (!this.initialized) {
      // Collect all bottomNodes and calculates the outer margin
      this.bottomNodes = [];
      this.outerMargin = 0;
      this._collectBottomNodes(this.innerNode[0].parentNode);

      // Calculate the inner margin
      var ioh = this.innerNode.outerHeight(true);
      var ih = this.innerNode.height();
      this.innerMargin = ioh - ih;
      this.initialized = true;
    }
  }
}

function asyncGeneratorStep$d(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$d(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$d(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$d(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$Q(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$Q(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$Q(Object(source), true).forEach(function (key) { _defineProperty$1w(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$Q(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1w(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
//import {et2_selectAccount} from "./et2_widget_SelectAccount";
var keep_import;

/**
 * Interface all special nextmatch header elements have to implement.
 */

var et2_INextmatchHeader = "et2_INextmatchHeader";
et2_implements_registry.et2_INextmatchHeader = function (obj) {
  return implements_methods(obj, ["setNextmatch"]);
};
var et2_INextmatchSortable = "et2_INextmatchSortable";
et2_implements_registry.et2_INextmatchSortable = function (obj) {
  return implements_methods(obj, ["setSortmode"]);
};

// For holding settings while whe print

/**
 * Class which implements the "nextmatch" XET-Tag
 *
 * NM header is build like this in DOM
 *
 * +- nextmatch_header -----+------------+----------+--------+---------+--------------+-----------+-------+
 * + header_left | search.. | header_row | category | filter | filter2 | header_right | favorites | count |
 * +-------------+----------+------------+----------+--------+---------+--------------+-----------+-------+
 *
 * everything left incl. standard filters is floated left:
 * +- nextmatch_header -----+------------+----------+--------+---------+
 * + header_left | search.. | header_row | category | filter | filter2 |
 * +-------------+----------+------------+----------+--------+---------+
 * everything from header_right on is floated right:
 *                                          +--------------+-----------+-------+
 *                                          | header_right | favorites | count |
 *                                          +--------------+-----------+-------+
 * @augments et2_DOMWidget
 */
class et2_nextmatch extends et2_DOMWidget {
  /**
   * Constructor
   *
   * @memberOf et2_nextmatch
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_nextmatch._attributes, _child || {}));
    // Currently active filters
    _defineProperty$1w(this, "activeFilters", void 0);
    // DOM / jQuery stuff
    _defineProperty$1w(this, "div", void 0);
    _defineProperty$1w(this, "innerDiv", void 0);
    _defineProperty$1w(this, "dynheight", void 0);
    _defineProperty$1w(this, "blank", void 0);
    // Popup to select columns
    _defineProperty$1w(this, "selectPopup", void 0);
    _defineProperty$1w(this, "template", void 0);
    _defineProperty$1w(this, "columns", void 0);
    _defineProperty$1w(this, "sortedColumnsList", void 0);
    // If we need the nextmatch to have a value, keep it here.
    // Normally this is used in actions, and is the action and selected rows.
    _defineProperty$1w(this, "value", void 0);
    // Big old bag of settings
    _defineProperty$1w(this, "settings", void 0);
    // Current view, either row or tile.  We store it here as controllers are
    // recreated when the template changes.
    _defineProperty$1w(this, "view", void 0);
    // Sub-objects used for actual work
    _defineProperty$1w(this, "header", void 0);
    _defineProperty$1w(this, "dataview", void 0);
    _defineProperty$1w(this, "controller", void 0);
    _defineProperty$1w(this, "rowProvider", void 0);
    // Flag for an update is currently being done, to avoid a loop
    _defineProperty$1w(this, "update_in_progress", void 0);
    // Window timer for automatically refreshing
    _defineProperty$1w(this, "_autorefresh_timer", void 0);
    // Nextmatch can't render while hidden, we store refresh requests for later
    _defineProperty$1w(this, "_queued_refreshes", []);
    // When printing, we change the layout around.  Keep some values so it can be restored after
    _defineProperty$1w(this, "print", {
      old_height: 0,
      row_selector: '',
      orientation_style: null
    });
    /**
     * When loading the row template, we have to wait for the template before we try to process it.
     * During the legacy load process, we need to return this from doLoadingFinished() so it can be waited on so we
     * have to store it.
     */
    _defineProperty$1w(this, "template_promise", void 0);
    this.activeFilters = {
      col_filter: {}
    };
    this.columns = [];
    // keeps sorted columns
    this.sortedColumnsList = [];

    // Directly set current col_filters from settings
    jQuery.extend(this.activeFilters.col_filter, this.options.settings.col_filter);

    /*
    Process selected custom fields here, so that the settings are correctly
    set before the row template is parsed
    */
    var prefs = this._getPreferences();
    var cfs = {};
    for (var i = 0; i < prefs.visible.length; i++) {
      if (prefs.visible[i].indexOf(et2_nextmatch_customfields.PREFIX) == 0) {
        cfs[prefs.visible[i].substr(1)] = !prefs.negated;
      }
    }
    var global_data = this.getArrayMgr("modifications").getRoot().getEntry('~custom_fields~');
    if (typeof global_data == 'object' && global_data != null) {
      global_data.fields = cfs;
    }
    this.div = jQuery(document.createElement("div")).addClass("et2_nextmatch");
    this.header = et2_createWidget("nextmatch_header_bar", {}, this);
    this.innerDiv = jQuery(document.createElement("div")).appendTo(this.div);

    // Create the dynheight component which dynamically scales the inner
    // container.
    this.dynheight = this._getDynheight();

    // Create the outer grid container
    this.dataview = new et2_dataview(this.innerDiv, this.egw());

    // Blank placeholder
    this.blank = jQuery(document.createElement("div")).appendTo(this.dataview.table);

    // We cannot create the grid controller now, as this depends on the grid
    // instance, which can first be created once we have the columns
    this.controller = null;
    this.rowProvider = null;
    this._queue_refresh_callback = this._queue_refresh_callback.bind(this);
  }

  /**
   * Destroys all
   */
  destroy() {
    // Stop auto-refresh
    if (this._autorefresh_timer) {
      window.clearInterval(this._autorefresh_timer);
      this._autorefresh_timer = null;
    }
    // Unbind handler used for toggling autorefresh
    jQuery(this.getInstanceManager().DOMContainer.parentNode).off('show.et2_nextmatch');
    jQuery(this.getInstanceManager().DOMContainer.parentNode).off('hide.et2_nextmatch');

    // Free the grid components
    this.dataview.destroy();
    if (this.rowProvider) {
      this.rowProvider.destroy();
    }
    if (this.controller) {
      this.controller.destroy();
    }
    this.dynheight.destroy();
    super.destroy();
  }
  getController() {
    return this.controller;
  }

  /**
   * Loads the nextmatch settings
   *
   * @param {object} _attrs
   */
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
    if (this.id) {
      var entry = this.getArrayMgr("content").data;
      _attrs["settings"] = {};
      if (entry) {
        _attrs["settings"] = entry;

        // Make sure there's an action var parameter
        if (_attrs["settings"]["actions"] && !_attrs.settings["action_var"]) {
          _attrs.settings.action_var = "action";
        }

        // Merge settings mess into attributes
        for (var attr in this.attributes) {
          if (_attrs.settings[attr]) {
            _attrs[attr] = _attrs.settings[attr];
            delete _attrs.settings[attr];
          }
        }
      }
    }
  }
  doLoadingFinished() {
    super.doLoadingFinished();
    if (!this.dynheight) {
      this.dynheight = this._getDynheight();
    }

    // Register handler for dropped files, if possible
    if (this.options.settings.row_id) {
      // Appname should be first part of the template name
      var split = this.options.template.split('.');
      var appname = split[0];

      // Check link registry
      if (this.egw().link_get_registry(appname)) {
        var self = this;
        // Register a handler
        // @ts-ignore
        jQuery(this.div).on('dragenter', '.egwGridView_grid tr', function (e) {
          // Figure out _which_ row
          var row = self.controller.getRowByNode(this);
          if (!row || !row.uid) {
            return false;
          }
          e.stopPropagation();
          e.preventDefault();

          // Indicate acceptance
          if (row.controller && row.controller._selectionMgr) {
            row.controller._selectionMgr.setFocused(row.uid, true);
          }
          return false;
        }).on('dragexit', '.egwGridView_grid tr', function () {
          self.controller._selectionMgr.setFocused();
        }).on('dragover', '.egwGridView_grid tr', false).attr("dropzone", "copy").on('drop', '.egwGridView_grid tr', function (e) {
          self.handle_drop(e, this);
          return false;
        });
      }
    }
    // stop invalidation in no visible tabs
    jQuery(this.getInstanceManager().DOMContainer.parentNode).on('hide.et2_nextmatch', jQuery.proxy(function () {
      if (this.controller && this.controller._grid) {
        this.controller._grid.doInvalidate = false;
      }
    }, this));
    jQuery(this.getInstanceManager().DOMContainer.parentNode).on('show.et2_nextmatch', jQuery.proxy(function () {
      if (this.controller && this.controller._grid) {
        this.controller._grid.doInvalidate = true;
      }
    }, this));
    return this.template_promise ? this.template_promise : true;
  }

  /**
   * Implements the et2_IResizeable interface - lets the dynheight manager
   * update the width and height and then update the dataview container.
   */
  resize() {
    if (this.dynheight) {
      this.dynheight.update(function (_w, _h) {
        this.dataview.resize(_w, _h);
      }, this);
    }
  }

  /**
   * Sorts the nextmatch widget by the given ID.
   *
   * @param {string} _id is the id of the data entry which should be sorted.
   * @param {boolean} _asc if true, the elements are sorted ascending, otherwise
   * 	descending. If not set, the sort direction will be determined
   * 	automatically.
   * @param {boolean} _update true/undefined: call applyFilters, false: only set sort
   */
  sortBy(_id, _asc, _update) {
    if (typeof _update == "undefined") {
      _update = true;
    }

    // Create the "sort" entry in the active filters if it did not exist
    // yet.
    if (typeof this.activeFilters["sort"] == "undefined") {
      this.activeFilters["sort"] = {
        "id": null,
        "asc": true
      };
    }

    // Determine the sort direction automatically if it is not set
    if (typeof _asc == "undefined") {
      _asc = true;
      if (this.activeFilters["sort"].id == _id) {
        _asc = !this.activeFilters["sort"].asc;
      }
    }

    // Set the sortmode display
    this.iterateOver(function (_widget) {
      _widget.setSortmode(_widget.id == _id ? _asc ? "asc" : "desc" : "none");
    }, this, et2_INextmatchSortable);
    if (_update) {
      this.applyFilters({
        sort: {
          id: _id,
          asc: _asc
        }
      });
    } else {
      // Update the entry in the activeFilters object
      this.activeFilters["sort"] = {
        "id": _id,
        "asc": _asc
      };
    }
  }

  /**
   * Removes the sort entry from the active filters object and thus returns to
   * the natural sort order.
   */
  resetSort() {
    // Check whether the nextmatch widget is currently sorted
    if (typeof this.activeFilters["sort"] != "undefined") {
      // Reset the sort mode
      this.iterateOver(function (_widget) {
        _widget.setSortmode("none");
      }, this, et2_INextmatchSortable);

      // Delete the "sort" filter entry
      this.applyFilters({
        sort: undefined
      });
    }
  }

  /**
   * Apply current or modified filters on NM widget (updating rows accordingly)
   *
   * @param _set filter(s) to set eg. { filter: '' } to reset filter in NM header
   */
  applyFilters(_set) {
    var changed = false;
    var keep_selection = false;

    // Avoid loops cause by change events
    if (this.update_in_progress || !this.controller) return;
    this.update_in_progress = true;

    // Cleared explicitly
    if (typeof _set != 'undefined' && jQuery.isEmptyObject(_set)) {
      changed = true;
      this.activeFilters = {
        col_filter: {}
      };
    }
    if (typeof this.activeFilters == "undefined") {
      this.activeFilters = {
        col_filter: {}
      };
    }
    if (typeof this.activeFilters.col_filter == "undefined") {
      this.activeFilters.col_filter = {};
    }
    if (typeof _set == 'object') {
      for (var s in _set) {
        if (s == 'col_filter') {
          // allow apps setState() to reset all col_filter by using undefined or null for it
          // they can not pass {} for _set / state.state, if they need to set something
          if (_set.col_filter === undefined || _set.col_filter === null) {
            this.activeFilters.col_filter = {};
            changed = true;
          } else {
            for (var c in _set.col_filter) {
              if (this.activeFilters.col_filter[c] !== _set.col_filter[c]) {
                if (_set.col_filter[c]) {
                  this.activeFilters.col_filter[c] = _set.col_filter[c];
                } else {
                  delete this.activeFilters.col_filter[c];
                }
                changed = true;
              }
            }
          }
        } else if (s === 'selected') {
          changed = true;
          keep_selection = true;
          this.controller._selectionMgr.resetSelection();
          this.controller._objectManager.clear();
          for (var i in _set.selected) {
            this.controller._selectionMgr.setSelected(_set.selected[i].indexOf('::') > 0 ? _set.selected[i] : this.controller.dataStorePrefix + '::' + _set.selected[i], true);
          }
          delete _set.selected;
        } else if (this.activeFilters[s] !== _set[s]) {
          this.activeFilters[s] = _set[s];
          changed = true;
        }
      }
    }
    this.egw().debug("info", "Changing nextmatch filters to ", this.activeFilters);

    // Keep the selection after applying filters, but only if unchanged
    if (!changed || keep_selection) {
      this.controller.keepSelection();
    } else {
      // Do not keep selection
      this.controller._selectionMgr.resetSelection();
      this.controller._objectManager.clear();
      this.controller.keepSelection();
    }

    // Update the filters in the grid controller
    this.controller.setFilters(this.activeFilters);

    // Update the header
    this.header.setFilters(this.activeFilters);

    // Update any column filters
    this.iterateOver(function (column) {
      // Skip favorites - it implements et2_INextmatchHeader, but we don't want it in the filter
      if (typeof column.id != "undefined" && column.id.indexOf('favorite') == 0) return;
      if (typeof column.set_value != "undefined" && column.id) {
        column.set_value(typeof this[column.id] == "undefined" || this[column.id] == null ? "" : this[column.id]);
      }
      if (column.id && typeof column.get_value == "function") {
        this[column.id] = column.get_value();
      }
    }, this.activeFilters.col_filter, et2_INextmatchHeader);

    // Trigger an update
    this.controller.update(true);
    if (changed) {
      // Highlight matching favorite in sidebox
      if (this.getInstanceManager().app) {
        var appname = this.getInstanceManager().app;
        if (app[appname] && app[appname].highlight_favorite) {
          app[appname].highlight_favorite();
        }
      }
    }

    // Wait a bit.  header.setFilters() can cause webComponents to update, so we want to wait for that
    var wait = [];
    this.header.iterateOver(w => {
      if (typeof w.updateComplete != "undefined") {
        wait.push(w.updateComplete);
      }
    }, this);
    setTimeout(() => {
      // It needs a little longer than just the updateComplete, not sure why.
      // Turning it off too soon causes problems with app.infolog.filter2_change
      Promise.allSettled(wait).then(() => {
        this.update_in_progress = false;
      });
    }, 100);
  }

  /**
   * Refresh given rows for specified change
   *
   * Change type parameters allows for quicker refresh then complete server side reload:
   * - update: request modified data from given rows.  May be moved.
   * - update-in-place: update row, but do NOT move it, or refresh if uid does not exist
   * - edit: rows changed, but sorting may be affected.  Full reload.
   * - delete: just delete the given rows clientside (no server interaction neccessary)
   * - add: put the new row in at the top, unless app says otherwise
   *
   * What actually happens also depends on a general preference "lazy-update":
   *	default/lazy:
   *  - add always on top
   *	- updates on top, if sorted by last modified, otherwise update-in-place
   *	- update-in-place is always in place!
   *
   *	exact:
   *	- add and update on top if sorted by last modified, otherwise full refresh
   *	- update-in-place is always in place!
   *
   * Nextmatch checks the application callback nm_refresh_index, which has a default implementation
   * in egw_app.nm_refresh_index().
   *
   * @param {string[]|string} _row_ids rows to refresh
   * @param {?string} _type "update-in-place", "update", "edit", "delete" or "add"
   *
   * @see jsapi.egw_refresh()
   * @see egw_app.nm_refresh_index()
   * @fires refresh from the widget itself
   */
  refresh(_row_ids, _type) {
    var _this = this;
    // Framework trying to refresh, but nextmatch not fully initialized
    if (this.controller === null || !this.div) {
      return;
    }

    // Make sure we're dealing with arrays
    if (typeof _row_ids == 'string' || typeof _row_ids == 'number') _row_ids = [_row_ids];

    // Make some changes in what we're doing based on preference
    var update_pref = egw$1.preference("lazy-update") || 'lazy';
    if (_type == et2_nextmatch.UPDATE && !this.is_sorted_by_modified()) {
      _type = update_pref == "lazy" ? et2_nextmatch.UPDATE_IN_PLACE : et2_nextmatch.EDIT;
    } else if (update_pref == "exact" && _type == et2_nextmatch.ADD && !this.is_sorted_by_modified()) {
      _type = et2_nextmatch.EDIT;
    }
    if (_type == et2_nextmatch.ADD && !(update_pref == "lazy" || update_pref == "exact" && this.is_sorted_by_modified())) {
      _type = et2_nextmatch.EDIT;
    }
    if (typeof _type == 'undefined') _type = et2_nextmatch.EDIT;
    if (!this.div.is(':visible'))
      // run refresh, once we become visible again
      {
        return this._queue_refresh(_row_ids, _type);
      }
    if (typeof _row_ids == "undefined" || _row_ids === null) {
      this.applyFilters();

      // Trigger an event so app code can act on it
      jQuery(this).triggerHandler("refresh", [this]);
      return;
    }

    // Clean IDs in case they're UIDs with app prefixed
    _row_ids = _row_ids.map(function (id) {
      if (id.toString().indexOf(this.controller.dataStorePrefix) == -1) {
        return id;
      }
      var parts = id.split("::");
      parts.shift();
      return parts.join("::");
    }.bind(this));
    if (_type == et2_nextmatch.DELETE) {
      // Record current & next index
      var uid = _row_ids[0].toString().indexOf(this.controller.dataStorePrefix) == 0 ? _row_ids[0] : this.controller.dataStorePrefix + "::" + _row_ids[0];
      var entry = this.controller._selectionMgr._getRegisteredRowsEntry(uid);
      if (entry && entry.idx !== null) {
        var next = entry.ao ? entry.ao.getNext(_row_ids.length) : null;
        if (next == null || !next.id || next.id == uid) {
          // No next, select previous
          next = entry.ao ? entry.ao.getPrevious(1) : null;
        }

        // Stop automatic updating
        this.dataview.grid.doInvalidate = false;
        for (var i = 0; i < _row_ids.length; i++) {
          uid = _row_ids[i].toString().indexOf(this.controller.dataStorePrefix) == 0 ? _row_ids[i] : this.controller.dataStorePrefix + "::" + _row_ids[i];

          // Delete from internal references
          this.controller.deleteRow(uid);
        }

        // Select & focus next row
        if (next && next.id && !this.options.disable_selection_advance) {
          this.controller._selectionMgr.setSelected(next.id, true);
          this.controller._selectionMgr.setFocused(next.id, true);
        }

        // Update the count
        var total = this.dataview.grid._total - _row_ids.length;
        // This will remove the last row!
        // That's OK, because grid adds one in this.controller.deleteRow()
        this.dataview.grid.setTotalCount(total);
        this.controller._selectionMgr.setTotalCount(total);

        // Re-enable automatic updating
        this.dataview.grid.doInvalidate = true;
        this.dataview.grid.invalidate();
      }
    }
    var _loop = function _loop() {
        var uid = _row_ids[i].toString().indexOf(_this.controller.dataStorePrefix) == 0 ? _row_ids[i] : _this.controller.dataStorePrefix + "::" + _row_ids[i];

        // Check for update on a row we don't have
        var known = Object.values(_this.controller._indexMap).filter(function (row) {
          return row.uid == uid;
        });
        if ((_type == et2_nextmatch.UPDATE || _type == et2_nextmatch.UPDATE_IN_PLACE) && (!known || known.length == 0)) {
          _type = et2_nextmatch.ADD;
          if (update_pref == "exact" && !_this.is_sorted_by_modified()) {
            _type = et2_nextmatch.EDIT;
          }
        }
        if ([et2_nextmatch.ADD, et2_nextmatch.UPDATE].indexOf(_type) !== -1) {
          // Pre-ask for the row data, and only proceed if we actually get it
          // need to send nextmatch filters too, as server-side will merge old version from request otherwise
          _this._refresh_grid(_type, _this.controller, _row_ids, uid);
          return {
            v: void 0
          };
        }
        switch (_type) {
          // update-in-place = update, but always only in place
          case et2_nextmatch.UPDATE_IN_PLACE:
            _this.egw().dataRefreshUID(uid);
            break;

          // These ones handled above in dataFetch() callback
          case et2_nextmatch.UPDATE:
            // update [existing] row, maybe we'll put it on top
            break;
          case et2_nextmatch.DELETE:
            // Handled above, more code to execute after loop so don't exit early
            break;
          case et2_nextmatch.ADD:
            break;

          // No more smart things we can do, refresh the whole thing
          case et2_nextmatch.EDIT:
          default:
            // Trigger refresh
            _this.applyFilters();
            return 0; // break id_loop
        }
      },
      _ret;
    id_loop: for (var i = 0; i < _row_ids.length; i++) {
      _ret = _loop();
      if (_ret === 0) break id_loop;
      if (_ret) return _ret.v;
    }
    // Trigger an event so app code can act on it
    jQuery(this).triggerHandler("refresh", [this, _row_ids, _type]);
  }
  _refresh_grid(type, controller, row_ids, uid) {
    // Pre-ask for the row data, and only proceed if we actually get it
    // need to send nextmatch filters too, as server-side will merge old version from request otherwise
    return this.egw().dataFetch(this.getInstanceManager().etemplate_exec_id, {
      refresh: row_ids
    }, controller._filters, this.id, function (data) {
      // In the event that the etemplate got removed before the data came back (Usually an action caused
      // a full submit) just stop here.
      if (!this.nm.getParent()) {
        return;
      }
      if (data.total >= 1) {
        row_ids.forEach(id => {
          var uid = "".concat(this.prefix, "::").concat(id);
          this.type == et2_nextmatch.ADD ? this.nm.refresh_add(uid, this.type, controller) : this.nm.refresh_update(uid, controller);
        });
      } else if (this.type == et2_nextmatch.UPDATE) {
        // Remove rows from controller
        row_ids.forEach(id => {
          var uid = "".concat(this.prefix, "::").concat(id);
          this.controller.deleteRow(uid);
        });

        // Adjust total rows, clean grid
        this.controller._grid.setTotalCount(this.nm.controller._grid._total - row_ids.length);
        this.controller._selectionMgr.setTotalCount(this.nm.controller._grid._total);
      }
    }, {
      type: type,
      nm: this,
      controller: controller,
      uid: uid,
      prefix: this.controller.dataStorePrefix
    }, [row_ids]);
  }

  /**
   * An entry has been updated.  Request new data, and ask app about where the row
   * goes now.
   *
   * @param uid
   */
  refresh_update(uid, controller) {
    // Row data update has been sent, let's move it where app wants it
    var entry = controller._selectionMgr._getRegisteredRowsEntry(uid);

    // Need to delete first as there's a good chance indexes will change in an unknown way
    // and we can't always find it by UID after due to duplication
    controller.deleteRow(uid);

    // Pretend it's a new row, let app tell us where it goes and we'll mark it as new
    if (!this.refresh_add(uid, et2_nextmatch.UPDATE, controller)) {
      // App did not want the row, or doesn't know where it goes but we've already removed it...
      // Put it back before anyone notices.  New data coming from server anyway.
      var callback = function callback(data) {
        data.class += " new_entry";
        this.egw().dataUnregisterUID(uid, callback, this);
      };
      this.egw().dataRegisterUID(uid, callback, this, this.getInstanceManager().etemplate_exec_id, this.id);
      controller._insertDataRow(entry, true);
    }
    // Update does not need to increase row count, but refresh_add() adds it in
    controller._grid.setTotalCount(controller._grid.getTotalCount() - 1);
    controller._selectionMgr.setTotalCount(controller._grid.getTotalCount());
    return true;
  }

  /**
   * An entry has been added.  Put it in the list.
   *
   * @param uid
   * @return boolean false: not added, true: added
   */
  refresh_add(uid) {
    var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : et2_nextmatch.ADD;
    var controller = arguments.length > 2 ? arguments[2] : undefined;
    var index = egw$1.preference("lazy-update") !== "exact" ? 0 : this.is_sorted_by_modified() ? 0 : false;

    // No add, do a full refresh
    if (index === false) {
      return false;
    }
    var time = new Date().valueOf();
    this.egw().dataRegisterUID(uid, this._push_add_callback, {
      nm: this,
      controller: controller,
      uid: uid,
      index: index
    }, this.getInstanceManager().etemplate_exec_id, this.id);
    return true;
  }

  /**
   * Callback for adding a new row via push
   *
   * Expected context: {nm: this, uid: string, index: number}
   */
  _push_add_callback(data) {
    if (data && this.nm && this.nm.getParent()) {
      if (data.class) {
        data.class += " new_entry";
      }
      // Don't remove if new data has not arrived
      var stored = egw$1.dataGetUIDdata(this.uid);
      //if(stored?.timestamp >= time) return;

      // Increase displayed row count or we lose the last row when we add and the total is wrong
      this.controller._grid.setTotalCount(this.nm.controller._grid.getTotalCount() + 1);
      this.controller._selectionMgr.setTotalCount(this.nm.controller._grid.getTotalCount());

      // Insert at the top of the list, or where app said
      var entry = this.controller._selectionMgr._getRegisteredRowsEntry(this.uid);
      entry.idx = typeof this.index == "number" ? this.index : 0;
      this.controller._insertDataRow(entry, true);
    } else if (this.nm && this.nm.getParent()) {
      // Server didn't give us our row data
      // Delete from internal references
      this.controller.deleteRow(this.uid);
      this.controller._grid.setTotalCount(this.nm.controller._grid.getTotalCount() - 1);
      this.controller._selectionMgr.setTotalCount(this.nm.controller._grid.getTotalCount());
    }
    this.nm.egw().dataUnregisterUID(this.uid, this.nm._push_add_callback, this);
  }

  /**
   * Queue a refresh request until later, when nextmatch is visible
   *
   * Nextmatch can't re-draw anything while it's hidden (it messes up the sizing when it renders) so we can't actually
   * do a refresh right now.  Queue it up and when visible again we'll update then.  If we get too many changes
   * queued, we'll throw them all away and do a full refresh.
   *
   * @param _row_ids
   * @param _type
   * @private
   */
  _queue_refresh(_row_ids, _type) {
    // Maximum number of requests to queue.  50 chosen arbitrarily just to limit things
    var max_queued = 50;
    if (this._queued_refreshes === null) {
      // Already too many or an EDIT came, we'll refresh everything later
      return;
    }

    // Bind so we can get the queued data when tab is re-activated
    // only do it for this._queued_refreshes === [], to not install multiple event-handlers (jQuery.one() does NOT help here!)
    if (Array.isArray(this._queued_refreshes) && !this._queued_refreshes.length) {
      jQuery(this.getInstanceManager().DOMContainer.parentNode).one('show.et2_nextmatch', this._queue_refresh_callback.bind(this));
    }

    // Edit means refresh everything, so no need to keep queueing
    // Too many?  Forget it, we'll refresh everything.
    if (this._queued_refreshes.length >= max_queued || _type == et2_nextmatch.EDIT || !_type) {
      this._queued_refreshes = null;
      return;
    }

    // Skip if already in array
    if (this._queued_refreshes.some(queue => queue.ids.length === _row_ids.length && queue.ids.every((value, index) => value === _row_ids[index]))) {
      return;
    }
    this._queued_refreshes.push({
      ids: _row_ids,
      type: _type
    });
  }
  _queue_refresh_callback() {
    if (this._queued_refreshes === null) {
      // Still bound, but length is 0 - full refresh time
      this._queued_refreshes = [];
      return this.applyFilters();
    }
    var types = {};
    types[et2_nextmatch.ADD] = [];
    types[et2_nextmatch.UPDATE] = [];
    types[et2_nextmatch.UPDATE_IN_PLACE] = [];
    types[et2_nextmatch.DELETE] = [];
    for (var refresh of this._queued_refreshes) {
      types[refresh.type] = types[refresh.type].concat(refresh.ids);
    }
    this._queued_refreshes = [];
    for (var type in types) {
      if (types[type].length > 0) {
        // Fire each change type once with all changed IDs
        this.refresh(types[type].filter((v, i, a) => a.indexOf(v) === i), type);
      }
    }
  }

  /**
   * Is this nextmatch currently sorted by "modified" date
   *
   * This is decided by the row_modified options passed from the server and the current sort order
   */
  is_sorted_by_modified() {
    var _this$getValue;
    var sort = ((_this$getValue = this.getValue()) === null || _this$getValue === void 0 ? void 0 : _this$getValue.sort) || {};
    return sort && sort.id && sort.id == this.settings.add_on_top_sort_field && sort.asc == false;
  }
  _get_appname() {
    var app = '';
    var list = [];
    list = et2_csvSplit(this.options.settings.columnselection_pref, 2, ".");
    if (this.options.settings.columnselection_pref.indexOf('nextmatch') == 0) {
      app = list[0].substring('nextmatch'.length + 1);
    } else {
      app = list[0];
    }
    return app;
  }

  /**
   * Gets the selection
   *
   * @return Object { ids: [UIDs], inverted: boolean}
   */
  getSelection() {
    var selected = this.controller && this.controller._selectionMgr ? this.controller._selectionMgr.getSelected() : null;
    if (typeof selected == "object" && selected != null) {
      return selected;
    }
    return {
      ids: [],
      all: false
    };
  }

  /**
   * Log some debug information about internal values
   */
  spillYourGuts() {
    var guts = function guts(controller) {
      console.log("Controller:", controller);
      console.log("Controller indexMap:", controller._indexMap);
      console.log("Grid:", controller._grid);
      console.log("Selection Manager:", controller._selectionMgr);
      console.log("Selection registered rows:", controller._selectionMgr._registeredRows);
      if (controller && controller._children.length > 0) {
        console.groupCollapsed("Sub-grids");
        var child_index = 0;
        for (var child of controller._children) {
          console.groupCollapsed("Child " + ++child_index);
          guts(child);
          console.groupEnd();
        }
        console.groupEnd();
      }
    };
    console.group("Nextmatch internals");
    guts(this.controller);
    console.groupEnd();
  }

  /**
   * Event handler for when the selection changes
   *
   * If the onselect attribute was set to a string with javascript code, it will
   * be executed "legacy style".  You can get the selected values with getSelection().
   * If the onselect attribute is in app.appname.function style, it will be called
   * with the nextmatch and an array of selected row IDs.
   *
   * The array can be empty, if user cleared the selection.
   *
   * @param action ActionObject From action system.  Ignored.
   * @param senders ActionObjectImplemetation From action system.  Ignored.
   */
  onselect(action, senders) {
    // Execute the JS code connected to the event handler
    if (typeof this.options.onselect == 'function') {
      return this.options.onselect.call(this, this.getSelection().ids, this);
    }
  }

  /**
   * Nextmatch needs a namespace
   */
  _createNamespace() {
    return true;
  }

  /**
   * Create the dynamic height so nm fills all available space
   *
   * @returns {undefined}
   */
  _getDynheight() {
    // Find the parent container, either a tab or the main container
    var tab = this.get_tab_info();
    if (!tab) {
      return new et2_dynheight(this.getInstanceManager().DOMContainer, this.innerDiv, 100);
    } else if (tab && tab.contentDiv) {
      // Bind a resize while we're here
      if (tab.flagDiv) {
        tab.flagDiv.addEventListener("click", e => {
          window.setTimeout(() => this.resize(), 1);
        });
      }
      return new et2_dynheight(tab.contentDiv, this.innerDiv, 100);
    }
    return false;
  }

  /**
   * Generates the column caption for the given column widget
   *
   * @param {et2_widget} _widget
   */
  _genColumnCaption(_widget) {
    var result = null;
    if (typeof _widget._genColumnCaption == "function") return _widget._genColumnCaption();
    var self = this;
    _widget.iterateOver(function (_widget) {
      var label = self.egw().lang(_widget.label || _widget.emptyLabel || _widget.options.label || _widget.options.empty_label || '');
      if (!label) return; // skip empty, undefined or null labels
      if (!result) {
        result = label;
      } else {
        result += ", " + label;
      }
    }, this, et2_INextmatchHeader);
    return result;
  }

  /**
   * Generates the column name (internal) for the given column widget
   * Used in preferences to refer to the columns by name instead of position
   *
   * See _getColumnCaption() for human fiendly captions
   *
   * @param {et2_widget} _widget
   */
  _getColumnName(_widget) {
    if (typeof _widget._getColumnName == 'function') return _widget._getColumnName();
    var name = _widget.id;
    var child_names = [];
    var children = _widget.getChildren();
    for (var i = 0; i < children.length; i++) {
      if (children[i].id) child_names.push(children[i].id);
    }
    var colName = name + (name != "" && child_names.length > 0 ? "_" : "") + child_names.join("_");
    if (colName == "") {
      this.egw().debug("info", "Unable to generate nm column name for %o, no IDs", _widget);
    }
    return colName;
  }

  /**
   * Retrieve the user's preferences for this nextmatch merged with defaults
   * Column display, column size, etc.
   */
  _getPreferences() {
    // Read preference or default for column visibility
    var negated = false;
    var columnPreference = "";
    if (this.options.settings.default_cols) {
      negated = this.options.settings.default_cols[0] == "!";
      columnPreference = negated ? this.options.settings.default_cols.substring(1) : this.options.settings.default_cols;
    }
    if (this.options.settings.selectcols && this.options.settings.selectcols.length) {
      columnPreference = this.options.settings.selectcols;
      negated = false;
    }
    if (!this.options.settings.columnselection_pref) {
      // Set preference name so changes are saved
      this.options.settings.columnselection_pref = this.options.template;
    }
    var app = '';
    var list = [];
    if (this.options.settings.columnselection_pref) {
      var pref = {};
      list = et2_csvSplit(this.options.settings.columnselection_pref, 2, ".");
      if (this.options.settings.columnselection_pref.indexOf('nextmatch') == 0) {
        app = list[0].substring('nextmatch'.length + 1);
        pref = egw$1.preference(this.options.settings.columnselection_pref, app);
      } else {
        app = list[0];
        // 'nextmatch-' prefix is there in preference name, but not in setting, so add it in
        pref = egw$1.preference("nextmatch-" + this.options.settings.columnselection_pref, app);
      }
      if (pref) {
        negated = pref[0] == "!";
        columnPreference = negated ? pref.substring(1) : pref;
      }
    }
    var columnDisplay = [];
    // If no column preference or default set, use all columns
    if (typeof columnPreference == "string" && columnPreference.length == 0) {
      columnDisplay = [];
      negated = true;
    }
    columnDisplay = typeof columnPreference === "string" ? et2_csvSplit(columnPreference, null, ",") : columnPreference;

    // Adjusted column sizes
    var size = {};
    if (this.options.settings.columnselection_pref && app) {
      var size_pref = this.options.settings.columnselection_pref + "-size";

      // If columnselection pref is missing prefix, add it in
      if (size_pref.indexOf('nextmatch') == -1) {
        size_pref = 'nextmatch-' + size_pref;
      }
      size = this.egw().preference(size_pref, app);
    }
    if (!size) size = {};

    // Column order
    var order = {};
    for (var i = 0; i < columnDisplay.length; i++) {
      order[columnDisplay[i]] = i;
    }
    return {
      visible: columnDisplay,
      visible_negated: negated,
      negated: negated,
      size: size,
      order: order
    };
  }

  /**
   * Apply stored user preferences to discovered columns
   *
   * @param {array} _row
   * @param {array} _colData
   */
  _applyUserPreferences(_row, _colData) {
    var prefs = this._getPreferences();
    var columnDisplay = prefs.visible;
    var size = prefs.size;
    var negated = prefs.visible_negated;
    var order = prefs.order;
    var colName = '';

    // Add in display preferences
    if (columnDisplay && columnDisplay.length > 0) {
      RowLoop: for (var i = 0; i < _row.length; i++) {
        colName = '';
        if (_row[i].disabled === true) {
          _colData[i].visible = false;
          continue;
        }

        // Customfields needs special processing
        if (_row[i].widget.instanceOf(et2_nextmatch_customfields)) {
          // Find cf field
          for (var j = 0; j < columnDisplay.length; j++) {
            if (columnDisplay[j].indexOf(_row[i].widget.id) == 0) {
              _row[i].widget.options.fields = {};
              for (var k = j; k < columnDisplay.length; k++) {
                if (columnDisplay[k].indexOf(_row[i].widget.prefix) == 0) {
                  _row[i].widget.options.fields[columnDisplay[k].substr(1)] = true;
                }
              }
              // Resets field visibility too
              _row[i].widget._getColumnName();
              _colData[i].visible = !(negated || jQuery.isEmptyObject(_row[i].widget.options.fields));
              break;
            }
          }
          // Disable if there are no custom fields
          if (jQuery.isEmptyObject(_row[i].widget.customfields)) {
            _colData[i].visible = false;
            continue;
          }
          colName = _row[i].widget.id;
        } else {
          colName = this._getColumnName(_row[i].widget);
        }
        if (!negated) {
          _colData[i].order = typeof order[colName] === 'undefined' ? i : order[colName];
        }
        if (!colName) continue;
        _colData[i].visible = negated;
        var stop = false;
        for (var j = 0; j < columnDisplay.length && !stop; j++) {
          if (columnDisplay[j] == colName) {
            _colData[i].visible = !negated;
            stop = true;
          }
        }
        if (size[colName]) {
          // Make sure percentages stay percentages, and forget any preference otherwise
          if (_colData[i].width.charAt(_colData[i].width.length - 1) == "%") {
            _colData[i].width = typeof size[colName] == 'string' && size[colName].charAt(size[colName].length - 1) == "%" ? size[colName] : _colData[i].width;
          } else {
            _colData[i].width = parseInt(size[colName]) + 'px';
          }
        }
      }
    }
    _colData.sort(function (a, b) {
      return a.order - b.order;
    });
    _row.sort(function (a, b) {
      if (typeof a.colData !== 'undefined' && typeof b.colData !== 'undefined') {
        return a.colData.order - b.colData.order;
      } else if (typeof a.order !== 'undefined' && typeof b.order !== 'undefined') {
        return a.order - b.order;
      }
    });
  }

  /**
   * Take current column display settings and store them in this.egw().preferences
   * for next time
   */
  _updateUserPreferences() {
    var colMgr = this.dataview.getColumnMgr();
    var app = "";
    if (!this.options.settings.columnselection_pref) {
      this.options.settings.columnselection_pref = this.options.template;
    }
    var visibility = colMgr.getColumnVisibilitySet();
    var colDisplay = [];
    var colSize = {};
    var custom_fields = [];

    // visibility is indexed by internal ID, widget is referenced by position, preference needs name
    for (var i = 0; i < colMgr.columns.length; i++) {
      // @ts-ignore
      var widget = this.columns[i].widget;
      var colName = this._getColumnName(widget);
      if (colName) {
        // Server side wants each cf listed as a seperate column
        if (widget.instanceOf(et2_nextmatch_customfields)) {
          // Just the ID for server side, not the whole nm name - some apps use it to skip custom fields
          colName = widget.id;
          for (var name in widget.options.fields) {
            if (widget.options.fields[name]) custom_fields.push(et2_nextmatch_customfields.PREFIX + name);
          }
        }
        if (visibility[colMgr.columns[i].id].visible) colDisplay.push(colName);

        // When saving sizes, only save columns with explicit values, preserving relative vs fixed
        // Others will be left to flex if width changes or more columns are added
        if (colMgr.columns[i].relativeWidth) {
          colSize[colName] = colMgr.columns[i].relativeWidth * 100 + "%";
        } else if (colMgr.columns[i].fixedWidth) {
          colSize[colName] = colMgr.columns[i].fixedWidth;
        }
      } else if (colMgr.columns[i].fixedWidth || colMgr.columns[i].relativeWidth) {
        this.egw().debug("info", "Could not save column width - no name", colMgr.columns[i].id);
      }
    }
    var list = et2_csvSplit(this.options.settings.columnselection_pref, 2, ".");
    var pref = this.options.settings.columnselection_pref;
    if (pref.indexOf('nextmatch') == 0) {
      app = list[0].substring('nextmatch'.length + 1);
    } else {
      app = list[0];
      // 'nextmatch-' prefix is there in preference name, but not in setting, so add it in
      pref = "nextmatch-" + this.options.settings.columnselection_pref;
    }

    // Server side wants each cf listed as a seperate column
    jQuery.merge(colDisplay, custom_fields);

    // Update query value, so data source can use visible columns to exclude expensive sub-queries
    var oldCols = this.get_columns();
    this.activeFilters.selectcols = this.sortedColumnsList.length > 0 ? this.sortedColumnsList : colDisplay;

    // We don't need to re-query if they've removed a column
    var changed = [];
    ColLoop: for (var i = 0; i < colDisplay.length; i++) {
      for (var j = 0; j < oldCols.length; j++) {
        if (colDisplay[i] == oldCols[j]) continue ColLoop;
      }
      changed.push(colDisplay[i]);
    }

    // If a custom field column was added, throw away cache to deal with
    // efficient apps that didn't send all custom fields in the first request
    var cf_added = jQuery(changed).filter(jQuery(custom_fields)).length > 0;

    // Save visible columns and sizes if selectcols is not emtpy (an empty selectcols actually deletes the prefrence)
    if (!jQuery.isEmptyObject(this.activeFilters.selectcols)) {
      // 'nextmatch-' prefix is there in preference name, but not in setting, so add it in
      this.egw().set_preference(app, pref, this.activeFilters.selectcols.join(","),
      // Use callback after the preference gets set to trigger refresh, in case app
      // isn't looking at selectcols and just uses preference
      cf_added ? jQuery.proxy(function () {
        if (this.controller) this.controller.update(true);
      }, this) : null);
      // Save adjusted column sizes and inform user about it
      this.egw().set_preference(app, pref + "-size", colSize);
      this.egw().message(this.egw().lang("Saved column sizes to preferences."));
    }
    this.egw().set_preference(app, pref + "-size", colSize);

    // No significant change (just normal columns shown) and no need to wait,
    // but the grid still needs to be redrawn if a custom field was removed because
    // the cell content changed.  This is a cheaper refresh than the callback,
    // this.controller.update(true)
    if ((changed.length || custom_fields.length) && !cf_added) this.applyFilters();
  }
  _parseHeaderRow(_row, _colData) {
    // Make sure there's a widget - cols disabled in template can be missing them, and the header really likes to have a widget

    for (var x = 0; x < _row.length; x++) {
      if (!_row[x].widget) {
        _row[x].widget = et2_createWidget("label", {});
      }
    }

    // Get column display preference
    this._applyUserPreferences(_row, _colData);

    // Go over the header row and create the column entries
    this.columns = new Array(_row.length);
    var columnData = new Array(_row.length);

    // No action columns in et2
    var remove_action_index = null;
    for (var x = 0; x < _row.length; x++) {
      this.columns[x] = jQuery.extend({
        "order": _colData[x] && typeof _colData[x].order !== 'undefined' ? _colData[x].order : x,
        "widget": _row[x].widget
      }, _colData[x]);
      var visibility = !_colData[x] || _colData[x].visible ? et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE : et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE;
      if (_colData[x].disabled && _colData[x].disabled !== '' && this.getArrayMgr("content").parseBoolExpression(_colData[x].disabled)) {
        visibility = et2_dataview_column.ET2_COL_VISIBILITY_DISABLED;
        this.columns[x].visible = false;
      }
      columnData[x] = {
        "id": "col_" + x,
        // @ts-ignore
        "order": this.columns[x].order,
        "caption": this._genColumnCaption(_row[x].widget),
        "visibility": visibility,
        "width": _colData[x] ? _colData[x].width : 0
      };
      if (_colData[x].width === 'auto') {
        // Column manager does not understand 'auto', which grid widget
        // uses if width is not set
        columnData[x].width = '100%';
      }
      if (_colData[x].minWidth) {
        columnData[x].minWidth = _colData[x].minWidth;
      }
      if (_colData[x].maxWidth) {
        columnData[x].maxWidth = _colData[x].maxWidth;
      }

      // No action columns in et2
      var colName = this._getColumnName(_row[x].widget);
      if (colName == 'actions' || colName == 'legacy_actions' || colName == 'legacy_actions_check_all') {
        remove_action_index = x;
      } else if (!colName) {
        // Unnamed column cannot be toggled or saved
        columnData[x].visibility = et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT;
        this.columns[x].visible = true;
      }
    }

    // Remove action column
    if (remove_action_index != null) {
      this.columns.splice(remove_action_index, remove_action_index);
      columnData.splice(remove_action_index, remove_action_index);
      _colData.splice(remove_action_index, remove_action_index);
    }

    // Create the column manager and update the grid container
    this.dataview.setColumns(columnData);
    for (var x = 0; x < _row.length; x++) {
      // Append the widget to this container
      this.addChild(_row[x].widget);
    }

    // Create the nextmatch row provider
    this.rowProvider = new et2_nextmatch_rowProvider(this.dataview.rowProvider, this._getSubgrid, this);

    // Register handler to update preferences when column properties are changed
    var self = this;
    this.dataview.onUpdateColumns = function () {
      // Use apply to make sure context is there
      self._updateUserPreferences.apply(self);

      // Allow column widgets a chance to resize
      self.iterateOver(function (widget) {
        if (typeof widget.resize === 'function') {
          widget.resize();
        }
      }, self, et2_IResizeable);
    };

    // Register handler for column selection popup, or disable
    if (this.selectPopup) {
      this.selectPopup.remove();
      this.selectPopup = null;
    }
    if (this.options.settings.no_columnselection) {
      this.dataview.selectColumnsClick = function () {
        return false;
      };
      jQuery('span.selectcols', this.dataview.headTr).hide();
    } else {
      jQuery('span.selectcols', this.dataview.headTr).show();
      this.dataview.selectColumnsClick = function (event) {
        self._selectColumnsClick(event);
      };
    }
  }
  _parseDataRow(_row, _rowData, _colData) {
    var columnWidgets = [];
    _row.sort(function (a, b) {
      return a.colData.order - b.colData.order;
    });
    for (var x = 0; x < this.columns.length; x++) {
      if (!this.columns[x].visible) {
        continue;
      }
      columnWidgets[x] = _row[x].widget;

      // Pass along column alignment
      if (_row[x].align && columnWidgets[x]) {
        columnWidgets[x].align = _row[x].align;
      }
    }
    this.rowProvider.setDataRowTemplate(columnWidgets, _rowData, this);

    // Create the grid controller
    this.controller = new et2_nextmatch_controller(null, this.egw(), this.getInstanceManager().etemplate_exec_id, this, null, this.dataview.grid, this.rowProvider, this.options.settings.action_links, null, this.options.actions);
    this.controller.setFilters(this.activeFilters);

    // Need to trigger empty row the first time
    if (total == 0) this.controller._emptyRow();

    // Set data cache prefix to either provided custom or auto
    if (!this.options.settings.dataStorePrefix && this.options.settings.get_rows) {
      // Use jsapi data module to update
      var list = this.options.settings.get_rows.split('.', 2);
      if (list.length < 2) list = this.options.settings.get_rows.split('_'); // support "app_something::method"
      this.options.settings.dataStorePrefix = list[0];
    }
    this.controller.setPrefix(this.options.settings.dataStorePrefix);

    // Set the view
    this.controller._view = this.view;

    // Load the initial order
    /*this.controller.loadInitialOrder(this._getInitialOrder(
    	this.options.settings.rows, this.options.settings.row_id
    ));*/

    // Set the initial row count
    var total = typeof this.options.settings.total != "undefined" ? this.options.settings.total : 0;
    // This triggers an invalidate, which updates the grid
    this.dataview.grid.setTotalCount(total);

    // Insert any data sent from server, so invalidate finds data already
    if (this.options.settings.rows && this.options.settings.num_rows) {
      this.controller.loadInitialData(this.options.settings.dataStorePrefix, this.options.settings.row_id, this.options.settings.rows);
      // Remove, to prevent duplication
      delete this.options.settings.rows;
    }
  }
  _parseGrid(_grid) {
    // Search the rows for a header-row - if one is found, parse it
    for (var y = 0; y < _grid.rowData.length; y++) {
      // Parse the first row as a header, need header to parse the data rows
      if (_grid.rowData[y]["class"] == "th" || y == 0) {
        this._parseHeaderRow(_grid.cells[y], _grid.colData);
      } else if (this.controller == null) {
        this._parseDataRow(_grid.cells[y], _grid.rowData[y], _grid.colData);
      }
    }
    this.dataview.table.resize();
  }
  _getSubgrid(_row, _data, _controller) {
    // Fetch the id of the element described by _data, this will be the
    // parent_id of the elements in the subgrid
    var rowId = _data.content[this.options.settings.row_id];

    // Create a new grid with the row as parent and the dataview grid as
    // parent grid
    var grid = new et2_dataview_grid(_row, this.dataview.grid);

    // Create a new controller for the grid
    var controller = new et2_nextmatch_controller(_controller, this.egw(), this.getInstanceManager().etemplate_exec_id, this, rowId, grid, this.rowProvider, this.options.settings.action_links, _controller.getObjectManager());
    controller.update();

    // Register inside the destruction callback of the grid
    grid.setDestroyCallback(function () {
      controller.destroy();
    });
    return grid;
  }
  _getInitialOrder(_rows, _rowId) {
    var _order = [];

    // Get the length of the non-numerical rows arra
    var len = 0;
    for (var _key in _rows) {
      if (!isNaN(parseInt(_key)) && parseInt(_key) > len) len = parseInt(_key);
    }

    // Iterate over the rows
    for (var i = 0; i < len; i++) {
      // Get the uid from the data
      var uid = this.egw().app_name() + '::' + _rows[i][_rowId];

      // Store the data for that uid
      this.egw().dataStoreUID(uid, _rows[i]);

      // Push the uid onto the order array
      _order.push(uid);
    }
    return _order;
  }
  _selectColumnsClick(e) {
    var self = this;
    var columnMgr = this.dataview.getColumnMgr();

    // ID for faking letter selection in column selection
    var LETTERS = '~search_letter~';
    var columns = [];
    var columns_selected = [];
    for (var i = 0; i < columnMgr.columns.length; i++) {
      var col = columnMgr.columns[i];
      var widget = this.columns[i].widget;
      columns.push(_objectSpread$Q(_objectSpread$Q({}, col), {}, {
        widget: widget
      }));
    }

    // Letter search
    if (this.options.settings.lettersearch) {
      columns.push({
        id: LETTERS,
        caption: this.egw().lang('Search letter'),
        visibility: this.header.lettersearch.is(':visible') ? et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE : et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE
      });
    }
    var updateColumns = function updateColumns(button, values) {
      if (button != Et2Dialog$1.OK_BUTTON) {
        return;
      }

      // Update visibility
      var visibility = {};
      for (var i = 0; i < columnMgr.columns.length; i++) {
        var _col = columnMgr.columns[i];
        if (_col.caption && _col.visibility !== et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT && _col.visibility !== et2_dataview_column.ET2_COL_VISIBILITY_DISABLED) {
          visibility[_col.id] = {
            visible: false
          };
        }
      }
      var value = values.columns;

      // Update & remove letter filter
      if (self.header.lettersearch) {
        var show_letters = true;
        if (value.indexOf(LETTERS) >= 0) {
          value.splice(value.indexOf(LETTERS), 1);
        } else {
          show_letters = false;
        }
        self._set_lettersearch(show_letters);
      }
      self.sortedColumnsList = [];
      for (var i = 0; i < value.length; i++) {
        // Handle skipped columns
        var column = 0;
        while (value[i] != "col_" + column && column < columnMgr.columns.length) {
          column++;
        }
        if (!self.columns[column]) {
          continue;
        }
        if (visibility[value[i]]) {
          visibility[value[i]].visible = true;
        }
        var col_name = self._getColumnName(self.columns[column].widget);

        // Custom fields are listed seperately in column list, but are only 1 column
        if (self.columns[column] && self.columns[column].widget.instanceOf(et2_nextmatch_customfields)) {
          var cf = self.columns[column].widget.options.customfields;
          var visible = self.columns[column].widget.options.fields;
          self.sortedColumnsList.push(self.columns[column].widget.id);

          // Turn off all custom fields
          for (var field_name in cf) {
            visible[field_name] = false;
          }
          // Turn on selected custom fields
          for (var j = i; j < value.length; j++) {
            if (value[j].indexOf(et2_customfields_list.PREFIX) != 0) {
              continue;
            }
            self.sortedColumnsList.push(value[j]);
            visible[value[j].substring(1)] = true;
            i++;
          }
          self.columns[column].widget.set_visible(visible);
        } else {
          self.sortedColumnsList.push(col_name);
        }
      }
      columnMgr.setColumnVisibilitySet(visibility);
      self.dataview.updateColumns();

      // Auto refresh
      self._set_autorefresh(values.autoRefresh);
      if (show_letters) {
        self.activeFilters.selectcols.push('lettersearch');
      }
      self.getInstanceManager().submit();
      self.selectPopup = null;
    };

    // Build the popup
    var apps = this.egw().user('apps');
    var colDialog = new Et2Dialog$1(this.egw());
    colDialog.transformAttributes({
      title: this.egw().lang("Select columns"),
      buttons: Et2Dialog$1.BUTTONS_OK_CANCEL,
      template: this.egw().link(this.egw().webserverUrl + "/api/templates/default/nm_column_selection.xet"),
      callback: updateColumns,
      value: {
        content: {
          autoRefresh: parseInt(this._get_autorefresh())
        },
        readonlys: {
          default_preference: typeof apps.admin == "undefined"
        },
        modifications: {
          autoRefresh: {
            disabled: this.options.disable_autorefresh
          },
          columns: {
            columns: columns
          }
        }
      }
    });
    document.body.appendChild(colDialog);
  }

  /**
   * Get the currently displayed columns
   * Each customfield is listed separately
   */
  get_columns() {
    var colMgr = this.dataview.getColumnMgr();
    if (!colMgr) {
      return [];
    }
    var visibility = colMgr.getColumnVisibilitySet();
    var colDisplay = [];
    var custom_fields = [];

    // visibility is indexed by internal ID, widget is referenced by position, preference needs name
    for (var i = 0; i < colMgr.columns.length; i++) {
      // @ts-ignore
      var widget = this.columns[i].widget;
      var colName = this._getColumnName(widget);
      if (colName) {
        // Server side wants each cf listed as a seperate column
        if (widget.instanceOf(et2_nextmatch_customfields)) {
          // Just the ID for server side, not the whole nm name - some apps use it to skip custom fields
          colName = widget.id;
          for (var name in widget.options.fields) {
            if (widget.options.fields[name]) custom_fields.push(et2_nextmatch_customfields.PREFIX + name);
          }
        }
        if (visibility[colMgr.columns[i].id].visible) {
          colDisplay.push(colName);
        }
      }
    }

    // List each customfield as a seperate column
    jQuery.merge(colDisplay, custom_fields);
    return this.sortedColumnsList.length > 0 ? this.sortedColumnsList : colDisplay;
  }

  /**
   * Set the currently displayed columns, without updating user's preference
   *
   * @param {string[]} column_list List of column names
   * @param {boolean} trigger_update =false - explicitly trigger an update
   */
  set_columns(column_list) {
    var trigger_update = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var columnMgr = this.dataview.getColumnMgr();
    var visibility = {};
    var need_reload = false;

    // Initialize to false
    for (var i = 0; i < columnMgr.columns.length; i++) {
      var col = columnMgr.columns[i];
      if (col.caption && col.visibility != et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT) {
        visibility[col.id] = {
          visible: false
        };
      }
    }
    for (var i = 0; i < this.columns.length; i++) {
      var _visibility$columnMgr;
      var widget = this.columns[i].widget;
      var colName = this._getColumnName(widget);
      if (column_list.indexOf(colName) !== -1 && typeof visibility[columnMgr.columns[i].id] !== 'undefined') {
        visibility[columnMgr.columns[i].id].visible = true;
      }

      // Custom fields are listed seperately in column list, but are only 1 column
      if (widget && widget.instanceOf(et2_nextmatch_customfields)) {
        // Just the ID for server side, not the whole nm name - some apps use it to skip custom fields
        colName = widget.id;
        if (column_list.indexOf(colName) !== -1) {
          visibility[columnMgr.columns[i].id].visible = true;
        }
        var cf = this.columns[i].widget.options.customfields;
        var visible = this.columns[i].widget.options.fields;

        // Turn off all custom fields
        for (var field_name in cf) {
          visible[field_name] = false;
        }
        // Turn on selected custom fields - start from 0 in case they're not in order
        for (var j = 0; j < column_list.length; j++) {
          if (column_list[j].indexOf(et2_customfields_list.PREFIX) != 0) continue;
          visible[column_list[j].substring(1)] = true;
        }
        widget.set_visible(visible);
      }
      this.columns[i].visible = (_visibility$columnMgr = visibility[columnMgr.columns[i].id]) === null || _visibility$columnMgr === void 0 ? void 0 : _visibility$columnMgr.visible;
      if (this.dataview.rowProvider._columnIds.indexOf(columnMgr.columns[i].id) == -1) {
        need_reload = need_reload || this.columns[i].visible;
      }
    }
    columnMgr.setColumnVisibilitySet(visibility);

    // We don't want to update user's preference, so directly update
    this.dataview._updateColumns();
    if (need_reload) {
      // We need to change preferences and reload to get columns that were hidden during the first load
      this.dataview.updateColumns();
      this.getInstanceManager().submit();
      return;
    }

    // Allow column widgets a chance to resize
    this.iterateOver(function (widget) {
      if (typeof widget.resize === 'function') {
        widget.resize();
      }
    }, this, et2_IResizeable);
  }

  /**
   * Set the letter search preference, and update the UI
   *
   * @param {boolean} letters_on
   */
  _set_lettersearch(letters_on) {
    if (letters_on) {
      this.header.lettersearch.show();
    } else {
      this.header.lettersearch.hide();
    }
    var lettersearch_preference = "nextmatch-" + this.options.settings.columnselection_pref + "-lettersearch";
    this.egw().set_preference(this.egw().app_name(), lettersearch_preference, letters_on);
  }

  /**
   * Set the auto-refresh time period, and starts the timer if not started
   *
   * @param time int Refresh period, in seconds
   */
  _set_autorefresh(time) {
    // Start / update timer
    if (this._autorefresh_timer) {
      window.clearInterval(this._autorefresh_timer);
      delete this._autorefresh_timer;
    }

    // Store preference
    var refresh_preference = "nextmatch-" + this.options.settings.columnselection_pref + "-autorefresh";
    var app = this._get_appname();
    if (this._get_autorefresh() != time) {
      this.egw().set_preference(app, refresh_preference, time);
    }
    if (time > 0) {
      if (!this.controller) {
        // Controller is not ready yet, come back later
        setTimeout(() => {
          this._set_autorefresh(time);
        }, 1000);
        return;
      }
      this._autorefresh_timer = setInterval(jQuery.proxy(this.controller.update, this.controller), time * 1000);

      // Bind to tab show/hide events, so that we don't bother refreshing in the background
      jQuery(this.getInstanceManager().DOMContainer.parentNode).on('hide.et2_nextmatch', jQuery.proxy(function (e) {
        // Stop
        window.clearInterval(this._autorefresh_timer);
        jQuery(e.target).off(e);

        // If the autorefresh time is up, bind once to trigger a refresh
        // (if needed) when tab is activated again
        this._autorefresh_timer = setTimeout(jQuery.proxy(function () {
          // Check in case it was stopped / destroyed since
          if (!this._autorefresh_timer || !this.getInstanceManager()) return;
          jQuery(this.getInstanceManager().DOMContainer.parentNode).one('show.et2_nextmatch',
          // Important to use anonymous function instead of just 'this.refresh' because
          // of the parameters passed
          jQuery.proxy(function () {
            this.refresh(null, 'edit');
          }, this));
        }, this), time * 1000);
      }, this));
      jQuery(this.getInstanceManager().DOMContainer.parentNode).on('show.et2_nextmatch', jQuery.proxy(function (e) {
        // Start normal autorefresh timer again
        this._set_autorefresh(this._get_autorefresh());
        jQuery(e.target).off(e);
      }, this));
    }
  }

  /**
   * Get the auto-refresh timer
   *
   * @return int Refresh period, in secods
   */
  _get_autorefresh() {
    if (this.options.disable_autorefresh) {
      return 0;
    }
    var refresh_preference = "nextmatch-" + this.options.settings.columnselection_pref + "-autorefresh";
    return this.egw().preference(refresh_preference, this._get_appname());
  }

  /**
   * Enable or disable autorefresh
   *
   * If false, autorefresh will be shown in column selection.  If the user already has an autorefresh preference
   * for this nextmatch, the timer will be started.
   *
   * If true, the timer will be stopped and autorefresh will not be shown in column selection
   *
   * @param disabled
   */
  set_disable_autorefresh(disabled) {
    this.options.disable_autorefresh = disabled;
    this._set_autorefresh(this._get_autorefresh());
  }

  /**
   * When the template attribute is set, the nextmatch widget tries to load
   * that template and to fetch the grid which is inside of it. It then calls
   *
   * @param {string} template_name Full template name in the form app.template[.template]
   */
  set_template(template_name) {
    var template = et2_createWidget("template", {
      "id": template_name
    }, this);
    if (this.template) {
      // Stop early to prevent unneeded processing, and prevent infinite
      // loops if the server changes the template in get_rows
      if (this.template == template_name) {
        return;
      }

      // Free the grid components - they'll be re-created as the template is processed
      this.dataview.destroy();
      this.rowProvider.destroy();
      this.controller.destroy();
      this.controller = null;

      // Free any children from previous template
      // They may get left behind because of how detached nodes are processed
      // We don't use iterateOver because it checks sub-children
      for (var i = this._children.length - 1; i >= 0; i--) {
        var _node = this._children[i];
        if (_node != this.header && _node !== template) {
          this.removeChild(_node);
          _node.destroy();
        }
      }

      // Clear this setting if it's the same as the template, or
      // the columns will not be loaded
      if (this.template == this.options.settings.columnselection_pref) {
        this.options.settings.columnselection_pref = template_name;
      }
      this.dataview = new et2_dataview(this.innerDiv, this.egw());
    }
    if (!template) {
      this.egw().debug("error", "Error while loading definition template for " + "nextmatch widget.", template_name);
      return;
    }
    if (this.options.disabled) {
      return;
    }

    // Deferred parse function - template might not be fully loaded
    var parse = function parse(template) {
      // Keep the name of the template, as we'll free up the widget after parsing
      this.template = template_name;

      // Fetch the grid element and parse it
      var definitionGrid = template.getChildren()[0];
      if (definitionGrid && definitionGrid instanceof et2_grid) {
        this._parseGrid(definitionGrid);
      } else {
        this.egw().debug("error", "Nextmatch widget expects a grid to be the " + "first child of the defined template.");
        return;
      }

      // Free the template again, but don't remove it
      setTimeout(function () {
        template.destroy();
      }, 1);

      // Call the "setNextmatch" function of all registered
      // INextmatchHeader widgets.  This updates this.activeFilters.col_filters according
      // to what's in the template.
      this.iterateOver(function (_node) {
        _node.setNextmatch(this);
      }, this, et2_INextmatchHeader);

      // Set filters to current values
      // TODO this.controller.setFilters(this.activeFilters);

      // If no data was sent from the server, and num_rows is 0, the nm will be empty.
      // This triggers a cache check if visible
      if (!this.options.settings.num_rows && this.controller) {
        if (jQuery(this.getDOMNode()).filter(":visible").length > 0) {
          this.controller.update();
        } else {
          // Not visible, queue it up
          this._queue_refresh([], et2_nextmatch.EDIT);
        }
      }

      // Load the default sort order
      if (this.options.settings.order && this.options.settings.sort) {
        this.sortBy(this.options.settings.order, this.options.settings.sort == "ASC", false);
      }

      // Start auto-refresh
      this._set_autorefresh(this._get_autorefresh());
    };

    // Template might not be loaded yet, defer parsing
    var promise = [];
    template.loadingFinished(promise);

    // Wait until template (& children) are done
    // Keep promise so we can return it from doLoadingFinished
    this.template_promise = Promise.all(promise).then(() => {
      parse.call(this, template);
      if (!this.dynheight) {
        this.dynheight = this._getDynheight();
      }
      this.dynheight.initialized = false;

      // Give components a chance to finish.  Their size will affect available space, especially column headers.
      var waitForWebComponents = [];
      this.getChildren().forEach(w => {
        // @ts-ignore
        if (typeof w.updateComplete !== "undefined") {
          // @ts-ignore
          waitForWebComponents.push(w.updateComplete);
        }
      });
      Promise.all(waitForWebComponents).then(() => {
        this.resize();
      });
    }).finally(() => this.template_promise = null);
    return this.template_promise;
  }

  // Some accessors to match conventions
  set_hide_header(hide) {
    hide ? this.header.div.hide() : this.header.div.show();
  }
  set_header_left(template) {
    this.header._build_header("left", template);
  }
  set_header_right(template) {
    this.header._build_header("right", template);
  }
  set_header_row(template) {
    this.header._build_header("row", template);
  }
  set_no_filter(bool, filter_name) {
    if (typeof filter_name == 'undefined') {
      filter_name = 'filter';
    }
    this.options['no_' + filter_name] = bool;
    var filter = this.header[filter_name];
    if (filter) {
      filter.set_disabled(bool);
    } else if (bool) {
      filter = this.header._build_select(filter_name, 'et2-select', this.settings[filter_name], this.settings[filter_name + '_no_lang']);
    }
  }
  set_no_filter2(bool) {
    this.set_no_filter(bool, 'filter2');
  }

  /**
   * Directly change filter value, with no server query.
   *
   * This allows the server app code to change filter value, and have it
   * updated in the client UI.
   *
   * @param {String|number} value
   */
  set_filter(value) {
    var update = this.update_in_progress;
    this.update_in_progress = true;
    this.activeFilters.filter = value;

    // Update the header
    this.header.setFilters(this.activeFilters);
    this.update_in_progress = update;
  }

  /**
   * Directly change filter2 value, with no server query.
   *
   * This allows the server app code to change filter2 value, and have it
   * updated in the client UI.
   *
   * @param {String|number} value
   */
  set_filter2(value) {
    var update = this.update_in_progress;
    this.update_in_progress = true;
    this.activeFilters.filter2 = value;

    // Update the header
    this.header.setFilters(this.activeFilters);
    this.update_in_progress = update;
  }

  /**
   * If nextmatch starts disabled, it will need a resize after being shown
   * to get all the sizing correct.  Override the parent to add the resize
   * when enabling.
   *
   * @param {boolean} _value
   */
  set_disabled(_value) {
    var previous = this.disabled;
    super.set_disabled(_value);
    if (previous && !_value) {
      this.resize();
    }
  }

  /**
   * Actions are handled by the controller, so ignore these during init.
   *
   * @param {object} actions
   */
  set_actions(actions) {
    if (actions != this.options.actions && this.controller != null && this.controller._actionManager) {
      for (var i = this.controller._actionManager.children.length - 1; i >= 0; i--) {
        this.controller._actionManager.children[i].remove();
      }
      this.options.actions = actions;
      this.options.settings.action_links = this.controller._actionLinks = this._get_action_links(actions);
      this.controller._initActions(actions);
    }
  }

  /**
   * Switch view between row and tile.
   * This should be followed by a call to change the template to match, which
   * will cause a reload of the grid using the new settings.
   *
   * @param {string} view Either 'tile' or 'row'
   */
  set_view(view) {
    // Restrict to the only 2 accepted values
    if (view == 'tile') {
      this.view = 'tile';
    } else {
      this.view = 'row';
    }
  }

  /**
   * Set a different / additional handler for dropped files.
   *
   * File dropping doesn't work with the action system, so we handle it in the
   * nextmatch by linking automatically to the target row.  This allows an additional handler.
   * It should accept a row UID and a File[], and return a boolean Execute the default (link) action
   *
   * @param {String|Function} handler
   */
  set_onfiledrop(handler) {
    this.options.onfiledrop = handler;
  }

  /**
   * Handle drops of files by linking to the row, if possible.
   *
   * HTML5 / native file drops conflict with jQueryUI draggable, which handles
   * all our drop actions.  So we side-step the issue by registering an additional
   * drop handler on the rows parent.  If the row/actions itself doesn't handle
   * the drop, it should bubble and get handled here.
   *
   * @param {object} event
   * @param {object} target
   */
  handle_drop(event, target) {
    // Check to see if we can handle the link
    // First, find the UID
    var row = this.controller.getRowByNode(target);
    var uid = (row === null || row === void 0 ? void 0 : row.uid) || null;

    // Get the file information
    var files = [];
    if (event.originalEvent && event.originalEvent.dataTransfer && event.originalEvent.dataTransfer.files && event.originalEvent.dataTransfer.files.length > 0) {
      files = event.originalEvent.dataTransfer.files;
    } else {
      return false;
    }

    // Exectute the custom handler code
    if (this.options.onfiledrop && !this.options.onfiledrop.call(this, uid, files)) {
      return false;
    }
    event.stopPropagation();
    event.preventDefault();
    if (!row || !row.uid) return false;

    // Link the file to the row
    // just use a link widget, it's all already done
    var split = uid.split('::');
    var link_value = {
      to_app: split.shift(),
      to_id: split.join('::')
    };
    // Create widget and mangle to our needs
    var link = et2_createWidget("link-to", {
      value: link_value
    }, this);
    link.loadingFinished();
    link.file_upload.set_drop_target(false);
    if (row.row.tr) {
      // Ignore most of the UI, just use the status indicators
      var status = jQuery(document.createElement("div")).addClass('et2_link_to').width(row.row.tr.width()).position({
        my: "left top",
        at: "left top",
        of: row.row.tr
      }).append(link.status_span).append(link.file_upload.progress).appendTo(row.row.tr);

      // Bind to link event so we can remove when done
      link.div.on('link.et2_link_to', function (e, linked) {
        if (!linked) {
          jQuery("li.success", link.file_upload.progress).removeClass('success').addClass('validation_error');
        } else {
          // Update row
          link._parent.refresh(uid, 'edit');
        }
        // Fade out nicely
        status.delay(linked ? 1 : 2000).fadeOut(500, function () {
          link.destroy();
          status.remove();
        });
      });
    }

    // Upload and link - this triggers the upload, which triggers the link, which triggers the cleanup and refresh
    link.file_upload.set_value(files);
  }
  getDOMNode(_sender) {
    if (_sender == this || typeof _sender === 'undefined') {
      return this.div[0];
    }
    if (_sender == this.header) {
      return this.header.div[0];
    }
    for (var i = 0; i < this.columns.length; i++) {
      if (this.columns[i] && this.columns[i].widget && _sender == this.columns[i].widget) {
        return this.dataview.getHeaderContainerNode(i);
      }
    }

    // Let header have a chance
    if (_sender && _sender._parent && _sender._parent == this) {
      return this.header.getDOMNode(_sender);
    }
    return null;
  }

  /**
   * Called when loading the widget (sub-tree) is finished. First when this
   * function is called, the DOM-Tree is created. loadingFinished is
   * recursively called for all child elements. Do not directly override this
   * function but the doLoadingFinished function which is executed before
   * descending deeper into the DOM-Tree.
   *
   * Some widgets (template) do not load immediately because they request
   * additional resources via AJAX.  They will return a Deferred Promise object.
   * If you call loadingFinished(promises) after creating such a widget
   * programmatically, you might need to wait for it to fully complete its
   * loading before proceeding.
   *
   * Overridden to skip children in the sub-templates since we handle those directly.
   * Putting the children's promises into the list will stall the load, since those children
   * will never actually get completed - we clone them, and use the clones instead.
   *
   * @param {Promise[]} promises List of promises from widgets that are not done.  Pass an empty array, it will be filled if needed.
   */
  loadingFinished(promises) {
    // Call all availble setters
    this.initAttributes(this.options);
    var childPromises = [];
    var loadChildren = () => {
      // Descend recursively into the tree
      for (var i = 0; i < this._children.length; i++) {
        try {
          this._children[i].loadingFinished(childPromises);
        } catch (e) {
          egw$1.debug("error", "There was an error with a widget:\nError:%o\nProblem widget:%o", e.valueOf(), this._children[i], e.stack);
        }
      }
    };
    var result = this.doLoadingFinished();
    if (typeof result == "object" && result.then) {
      // Widget is waiting.  Add to the list
      promises.push(result);
      result.then(loadChildren);
    } else {
      loadChildren();
    }
  }

  // Input widget

  /**
   * Get the current 'value' for the nextmatch
   */
  getValue() {
    var _ids = this.getSelection();

    // Translate the internal uids back to server uids
    var idsArr = _ids.ids;
    for (var i = 0; i < idsArr.length; i++) {
      idsArr[i] = idsArr[i].split("::").pop();
    }
    var value = {
      selected: idsArr,
      col_filter: {}
    };
    jQuery.extend(value, this.activeFilters, this.value);
    if (typeof value.selectcols == "undefined" || value.selectcols.length === 0) {
      value.selectcols = this.get_columns();
    }
    return value;
  }
  resetDirty() {}
  isDirty() {
    return false;
  }
  isValid() {
    return true;
  }
  set_value(_value) {
    this.value = _value;
  }

  // Printing
  /**
   * Prepare for printing
   *
   * We check for un-loaded rows, and ask the user what they want to do about them.
   * If they want to print them all, we ask the server and print when they're loaded.
   */
  beforePrint() {
    var _this2 = this;
    // Add the class, if needed
    this.div.addClass('print');

    // Trigger resize, so we can fit on a page
    this.dynheight.outerNode.css('max-width', this.div.css('max-width'));
    this.resize();
    // Reset height to auto (after width resize) so there's no restrictions
    this.dynheight.innerNode.css('height', 'auto');

    // Check for rows that aren't loaded yet, or lots of rows
    var range = this.controller._grid.getIndexRange();
    this.print.old_height = this.controller._grid._scrollHeight;
    var loaded_count = range.bottom - range.top + 1;
    var total = this.controller._grid.getTotalCount();

    // Defer the printing to ask about columns & rows
    return new Promise( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator$d(function* (resolve, reject) {
        var pref = _this2.options.settings.columnselection_pref;
        if (pref.indexOf('nextmatch') == 0) {
          pref = 'nextmatch-' + pref;
        }
        var app = _this2.getInstanceManager().app;
        var columns = [];
        var columnMgr = _this2.dataview.getColumnMgr();
        pref += '_print';
        var columns_selected = [];
        for (var i = 0; i < columnMgr.columns.length; i++) {
          var col = columnMgr.columns[i];
          var widget = _this2.columns[i].widget;
          columns.push(_objectSpread$Q(_objectSpread$Q({}, col), {}, {
            widget: widget,
            name: _this2._getColumnName(widget)
          }));
        }

        // Preference exists?  Set it now
        if (_this2.egw().preference(pref, app)) {
          _this2.set_columns(jQuery.extend([], _this2.egw().preference(pref, app)));
        }
        var callback = function (button, value) {
          if (button === Et2Dialog$1.CANCEL_BUTTON) {
            // Give dialog a chance to close, or it will be in the print
            window.setTimeout(function () {
              reject();
            }, 0);
            return;
          }
          var orientation = value.orientation ? "landscape" : "portrait";
          // Set CSS for orientation
          this.div.addClass(orientation);
          this.egw().set_preference(app, pref + '_orientation', orientation);

          // Try to tell browser about orientation
          var css = '@page { size: ' + orientation + '; }',
            head = document.head || document.getElementsByTagName('head')[0],
            style = document.createElement('style');
          style.type = 'text/css';
          style.media = 'print';

          // @ts-ignore
          if (style.styleSheet) {
            // @ts-ignore
            style.styleSheet.cssText = css;
          } else {
            style.appendChild(document.createTextNode(css));
          }
          head.appendChild(style);
          this.print.orientation_style = style;

          // Trigger resize, so we can fit on a page
          this.dynheight.outerNode.css('max-width', this.div.css('max-width'));

          // Handle columns
          var column_names = [];
          value.columns.forEach(col_id => {
            var _columns$find;
            var name = ((_columns$find = columns.find(col => col.id == col_id)) === null || _columns$find === void 0 ? void 0 : _columns$find.name) || "";
            column_names.push(name || col_id);
          });
          this.set_columns(column_names);
          this.egw().set_preference(app, pref, column_names);
          var rows = parseInt(value.row_count);
          if (rows > total) {
            rows = total;
          }

          // If they want the whole thing, style it as all
          if (button === Et2Dialog$1.OK_BUTTON && rows == this.controller._grid.getTotalCount()) {
            // Add the class, gives more reliable sizing
            this.div.addClass('print');
            // Show it all
            jQuery('.egwGridView_scrollarea', this.div).css('height', 'auto');
          }
          // We need more rows
          if (button === 'dialog[all]' || rows > loaded_count) {
            var count = 0;
            var fetchedCount = 0;
            var cancel = false;
            var nm = this;
            var dialog = Et2Dialog$1.show_dialog(
            // Abort the long task if they canceled the data load
            function () {
              count = total;
              cancel = true;
              window.setTimeout(function () {
                reject();
              }, 0);
            }, egw$1.lang('Loading'), egw$1.lang('please wait...'), {}, [{
              "button_id": Et2Dialog$1.CANCEL_BUTTON,
              label: 'cancel',
              id: 'dialog[cancel]',
              image: 'cancel'
            }]);

            // dataFetch() is asynchronous, so all these requests just get fired off...
            // 200 rows chosen arbitrarily to reduce requests.
            do {
              var ctx = {
                "self": this.controller,
                "start": count,
                "count": Math.min(rows, 200),
                "lastModification": this.controller._lastModification
              };
              if (nm.controller.dataStorePrefix) {
                // @ts-ignore
                ctx.prefix = nm.controller.dataStorePrefix;
              }
              nm.controller.dataFetch({
                start: count,
                num_rows: Math.min(rows, 200)
              }, function (data) {
                // Keep track
                if (data && data.order) {
                  fetchedCount += data.order.length;
                }
                nm.controller._fetchCallback.apply(this, arguments);
                if (fetchedCount >= rows) {
                  if (cancel) {
                    dialog.destroy();
                    reject();
                    return;
                  }
                  // Use CSS to hide all but the requested rows
                  // Prevents us from showing more than requested, if actual height was less than average
                  nm.print.row_selector = ".egwGridView_grid > tbody > tr:not(:nth-child(-n+" + rows + "))";
                  egw$1.css(nm.print.row_selector, 'display: none');

                  // No scrollbar in print view
                  jQuery('.egwGridView_scrollarea', nm.div).css('overflow-y', 'hidden');
                  // Show it all
                  jQuery('.egwGridView_scrollarea', nm.div).css('height', 'auto');

                  // Grid (& widgets) need to redraw before it can be printed, so wait
                  window.setTimeout(function () {
                    // et2-link-string are the worst for taking a while
                    var nodeListArray = Array.from(nm.div[0].querySelectorAll("et2-link-string"));
                    var promises = nodeListArray.map(node => node.updateComplete);
                    Promise.all(promises).finally(() => {
                      dialog.close();

                      // Should be OK to print now
                      dialog.updateComplete.then(() => {
                        resolve();
                      });
                    });
                  }, 10 * fetchedCount);
                }
              }, ctx);
              count += 200;
            } while (count < rows);
            nm.controller._grid.setScrollHeight(nm.controller._grid.getAverageHeight() * (rows + 1));
          } else {
            // Don't need more rows, limit to requested and finish

            // Show it all
            jQuery('.egwGridView_scrollarea', this.div).css('height', 'auto');

            // Use CSS to hide all but the requested rows
            // Prevents us from showing more than requested, if actual height was less than average
            this.print.row_selector = ".egwGridView_grid > tbody > tr:not(:nth-child(-n+" + rows + "))";
            egw$1.css(this.print.row_selector, 'display: none');

            // No scrollbar in print view
            jQuery('.egwGridView_scrollarea', this.div).css('overflow-y', 'hidden');
            // Give dialog a chance to close, or it will be in the print
            window.setTimeout(function () {
              resolve();
            }, 0);
          }
        }.bind(_this2);
        var value = {
          content: {
            row_count: Math.min(100, total),
            columns: _this2.egw().preference(pref, app) || columns_selected,
            orientation: _this2.egw().preference(pref + '_orientation', app) == "landscape"
          },
          modifications: {
            autoRefresh: {
              disabled: true
            },
            columns: {
              columns: columns
            }
          }
        };
        yield _this2._create_print_dialog.call(_this2, value, callback).updateComplete;
      });
      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
  }

  /**
   * Create and show the print dialog, which calls the provided callback when
   * done.  Broken out for overriding if needed.
   *
   * @param {Object} value Current settings and preferences, passed to the dialog for
   *	the template
   * @param {Object} value.content
   * @param {Object} value.sel_options
   *
   * @param {function(int, Object)} callback - Process the dialog response,
   *  format things according to the specified orientation and fetch any needed
   *  rows.
   *
   */
  _create_print_dialog(value, callback) {
    var base_url = this.getInstanceManager().template_base_url;
    if (base_url.substr(base_url.length - 1) == '/') base_url = base_url.slice(0, -1); // otherwise we generate a url //api/templates, which is wrong
    var tab = this.get_tab_info();
    // Get title for print dialog from settings or tab, if available
    var title = this.options.settings.label ? this.options.settings.label : tab ? tab.label : '';
    var dialog = new Et2Dialog$1(this.egw());
    dialog.transformAttributes({
      // If you use a template, the second parameter will be the value of the template, as if it were submitted.
      callback: callback,
      // return false to prevent dialog closing
      buttons: Et2Dialog$1.BUTTONS_OK_CANCEL,
      title: this.egw().lang('Print') + ' ' + this.egw().lang(title),
      template: this.egw().link(base_url + '/api/templates/default/nm_print_dialog.xet'),
      value: value
    });
    document.body.appendChild(dialog);
    return dialog;
  }

  /**
   * Try to clean up the mess we made getting ready for printing
   * in beforePrint()
   */
  afterPrint() {
    if (!this.div.hasClass('print')) {
      return;
    }
    this.div.removeClass('print landscape portrait');
    jQuery(this.print.orientation_style).remove();
    delete this.print.orientation_style;

    // Put scrollbar back
    jQuery('.egwGridView_scrollarea', this.div).css('overflow-y', '');

    // Correct size of grid, and trigger resize to fix it
    this.controller._grid.setScrollHeight(this.print.old_height);
    delete this.print.old_height;

    // Remove CSS rule hiding extra rows
    if (this.print.row_selector) {
      egw$1.css(this.print.row_selector, '');
      delete this.print.row_selector;
    }

    // Restore columns
    var pref = [];
    var app = this.getInstanceManager().app;
    if (this.options.settings.columnselection_pref.indexOf('nextmatch') == 0) {
      pref = egw$1.preference(this.options.settings.columnselection_pref, app);
    } else {
      // 'nextmatch-' prefix is there in preference name, but not in setting, so add it in
      pref = egw$1.preference("nextmatch-" + this.options.settings.columnselection_pref, app);
    }
    if (pref) {
      if (typeof pref === 'string') pref = pref.split(',');
      // @ts-ignore
      this.set_columns(pref, app);
    }
    this.dynheight.outerNode.css('max-width', 'inherit');
    this.resize();
  }
}
_defineProperty$1w(et2_nextmatch, "_attributes", {
  // These normally set in settings, but broken out into attributes to allow run-time changes
  "template": {
    "name": "Template",
    "type": "string",
    "description": "The id of the template which contains the grid layout."
  },
  "hide_header": {
    "name": "Hide header",
    "type": "boolean",
    "description": "Hide the header",
    "default": false
  },
  "header_left": {
    "name": "Left custom template",
    "type": "string",
    "description": "Customise the nextmatch - left side.  Provided template becomes a child of nextmatch, and any input widgets are automatically bound to refresh the nextmatch on change.  Any inputs with an onChange attribute can trigger the nextmatch to refresh by returning true.",
    "default": ""
  },
  "header_right": {
    "name": "Right custom template",
    "type": "string",
    "description": "Customise the nextmatch - right side.  Provided template becomes a child of nextmatch, and any input widgets are automatically bound to refresh the nextmatch on change.  Any inputs with an onChange attribute can trigger the nextmatch to refresh by returning true.",
    "default": ""
  },
  "header_row": {
    "name": "Inline custom template",
    "type": "string",
    "description": "Customise the nextmatch - inline, after row count.  Provided template becomes a child of nextmatch, and any input widgets are automatically bound to refresh the nextmatch on change.  Any inputs with an onChange attribute can trigger the nextmatch to refresh by returning true.",
    "default": ""
  },
  "no_filter": {
    "name": "No filter",
    "type": "boolean",
    "description": "Hide the first filter",
    "default": et2_no_init
  },
  "no_filter2": {
    "name": "No filter2",
    "type": "boolean",
    "description": "Hide the second filter",
    "default": et2_no_init
  },
  "disable_autorefresh": {
    "name": "Disable autorefresh",
    "type": "boolean",
    "description": "Disable the ability to autorefresh the nextmatch on a regular interval.  ",
    "default": false
  },
  "disable_selection_advance": {
    "name": "Disable selection advance",
    "type": "boolean",
    "description": "If a refresh deletes the currently selected row, we normally advance the selection to the next row.  Set to true to stop this.",
    "default": false
  },
  "view": {
    "name": "View",
    "type": "string",
    "description": "Display entries as either 'row' or 'tile'.  A matching template must also be set after changing this.",
    "default": et2_no_init
  },
  "onselect": {
    "name": "onselect",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code which gets executed when rows are selected.  Can also be a app.appname.func(selected) style method"
  },
  "onfiledrop": {
    "name": "onFileDrop",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code that gets executed when a _file_ is dropped on a row.  Other drop interactions are handled by the action system.  Return false to prevent the default link action."
  },
  "onadd": {
    "name": "onAdd",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code that gets executed when a new entry is added via refresh().  Allows apps to override the default handling.  Return false to cancel the add."
  },
  "settings": {
    "name": "Settings",
    "type": "any",
    "description": "The nextmatch settings",
    "default": {}
  }
});
/**
 * Update types
 * @see et2_nextmatch.refresh() for more information
 */
_defineProperty$1w(et2_nextmatch, "ADD", 'add');
_defineProperty$1w(et2_nextmatch, "UPDATE_IN_PLACE", 'update-in-place');
_defineProperty$1w(et2_nextmatch, "UPDATE", 'update');
_defineProperty$1w(et2_nextmatch, "EDIT", 'edit');
_defineProperty$1w(et2_nextmatch, "DELETE", 'delete');
_defineProperty$1w(et2_nextmatch, "legacyOptions", ["template", "hide_header", "header_left", "header_right"]);
et2_register_widget(et2_nextmatch, ["nextmatch"]);

/**
 * Standard nextmatch header bar, containing filters, search, record count, letter filters, etc.
 *
 * Unable to use an existing template for this because parent (nm) doesn't, and template widget doesn't
 * actually load templates from the server.
 * @augments et2_DOMWidget
 */
class et2_nextmatch_header_bar extends et2_DOMWidget {
  /**
   * Constructor
   *
   * @param _parent
   * @param _attrs
   * @param _child
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, [_parent, _parent.options.settings], ClassWithAttributes.extendAttributes(et2_nextmatch_header_bar._attributes, _child || {}));
    _defineProperty$1w(this, "headers", void 0);
    _defineProperty$1w(this, "et2_searchbox", void 0);
    _defineProperty$1w(this, "favorites", void 0);
    // Actually favorite
    _defineProperty$1w(this, "nextmatch", void 0);
    _defineProperty$1w(this, "div", void 0);
    _defineProperty$1w(this, "update_in_progress", void 0);
    _defineProperty$1w(this, "header_div", void 0);
    _defineProperty$1w(this, "header_row", void 0);
    _defineProperty$1w(this, "filter_div", void 0);
    _defineProperty$1w(this, "row_div", void 0);
    _defineProperty$1w(this, "fav_span", void 0);
    _defineProperty$1w(this, "toggle_header", void 0);
    _defineProperty$1w(this, "lettersearch", void 0);
    _defineProperty$1w(this, "delete_action", void 0);
    _defineProperty$1w(this, "action_header", void 0);
    _defineProperty$1w(this, "search_box", void 0);
    _defineProperty$1w(this, "category", void 0);
    _defineProperty$1w(this, "filter", void 0);
    _defineProperty$1w(this, "filter2", void 0);
    _defineProperty$1w(this, "right_div", void 0);
    _defineProperty$1w(this, "count", void 0);
    _defineProperty$1w(this, "count_total", void 0);
    this.nextmatch = _parent;
    this.div = jQuery(document.createElement("div")).addClass("nextmatch_header");
    this._createHeader();

    // Flag to avoid loops while updating filters
    this.update_in_progress = false;
  }
  destroy() {
    this.nextmatch = null;
    super.destroy();
    this.div = null;
  }
  setNextmatch(nextmatch) {
    var create_once = this.nextmatch == null;
    this.nextmatch = nextmatch;
    if (create_once) {
      this._createHeader();
    }

    // Bind row count
    this.nextmatch.dataview.grid.setInvalidateCallback(function () {
      this.count_total.text(this.nextmatch.dataview.grid.getTotalCount() + "");
    }, this);
  }

  /**
   * Actions are handled by the controller, so ignore these
   *
   * @param {object} actions
   */
  set_actions(actions) {}
  _createHeader() {
    var button;
    var self = this;
    var nm_div = this.nextmatch.getDOMNode();
    var settings = this.nextmatch.options.settings;
    this.div.prependTo(nm_div);

    // Left & Right (& row) headers
    this.headers = [{
      id: this.nextmatch.options.header_left
    }, {
      id: this.nextmatch.options.header_right
    }, {
      id: this.nextmatch.options.header_row
    }];

    // The rest of the header
    this.header_div = this.row_div = jQuery(document.createElement("div")).addClass("nextmatch_header_row").appendTo(this.div);
    this.filter_div = jQuery(document.createElement("div")).addClass('filtersContainer').appendTo(this.row_div);

    // Search
    this.search_box = jQuery(document.createElement("div")).addClass('search').prependTo(egwIsMobile$1() ? this.nextmatch.getDOMNode() : this.row_div);

    // searchbox widget options
    var searchbox_options = {
      id: "search",
      overlay: typeof settings.searchbox != 'undefined' && typeof settings.searchbox.overlay != 'undefined' ? settings.searchbox.overlay : false,
      onchange: function onchange() {
        if (this.value !== self.nextmatch.activeFilters.search) {
          self.nextmatch.applyFilters({
            search: this.get_value()
          });
        }
      },
      value: settings.search || '',
      fix: !egwIsMobile$1(),
      placeholder: egw$1.lang("Search")
    };
    // searchbox widget
    this.et2_searchbox = loadWebComponent('et2-searchbox', searchbox_options, this);

    // Set activeFilters to current value
    this.nextmatch.activeFilters.search = settings.search || '';
    this.et2_searchbox.set_value(settings.search || '');
    jQuery(this.et2_searchbox.getInputNode()).attr("aria-label", egw$1.lang("search"));
    /**
     *  Mobile theme specific part for nm header
     *  nm header has very different behaivior for mobile theme and basically
     *  it has its own markup separately from nm header in normal templates.
     */
    if (egwIsMobile$1()) {
      this.search_box.addClass('nm-mob-header');
      jQuery(this.div).css({
        display: 'inline-block'
      }).addClass('nm_header_hide');

      //indicates appname in header
      jQuery(document.createElement('div')).addClass('nm_appname_header').text(egw$1.lang(egw$1.app_name())).appendTo(this.search_box);
      this.delete_action = jQuery(document.createElement('div')).addClass('nm_delete_action').prependTo(this.search_box);
      // toggle header
      // add new button
      this.fav_span = jQuery(document.createElement('div')).addClass('nm_favorites_div').prependTo(this.search_box);
      // toggle header menu
      this.toggle_header = jQuery(document.createElement('button')).addClass('nm_toggle_header').click(function () {
        jQuery(self.div).toggleClass('nm_header_hide');
        jQuery(this).toggleClass('nm_toggle_header_on');
        window.setTimeout(function () {
          self.nextmatch.resize();
        }, 800);
      }).prependTo(this.search_box);
      // Context menu
      this.action_header = jQuery(document.createElement('button')).addClass('nm_action_header').hide().click(function (e) {
        if (self.nextmatch.getDOMNode().getElementsByClassName('selected').length > 0) {
          self.nextmatch.getDOMNode().getElementsByClassName('selected')[0].dispatchEvent(new CustomEvent("tapandhold", {
            type: 'tapandhold'
          }));
        }
      }).prependTo(this.search_box);
    }

    // Add category
    if (!settings.no_cat) {
      if (typeof settings.cat_id_label == 'undefined') settings.cat_id_label = '';
      this.category = this._build_select('cat_id', settings.cat_is_select ? 'et2-select' : 'et2-select-cat', settings.cat_id, settings.cat_is_select !== true, {
        multiple: false,
        class: "select-cat",
        value_class: settings.cat_id_class
      });
    }

    // Filter 1
    if (!settings.no_filter) {
      this.filter = this._build_select('filter', 'et2-select', settings.filter, settings.filter_no_lang);
    }

    // Filter 2
    if (!settings.no_filter2) {
      this.filter2 = this._build_select('filter2', 'et2-select', settings.filter2, settings.filter2_no_lang, {
        multiple: false,
        class: "select-cat",
        value_class: settings.filter2_class
      });
    }

    // Other stuff
    this.right_div = jQuery(document.createElement("div")).addClass('header_row_right').appendTo(this.row_div);

    // Record count
    this.count = jQuery(document.createElement("span")).addClass("header_count ui-corner-all");

    // Need to figure out how to update this as grid scrolls
    // this.count.append("? - ? ").append(egw.lang("of")).append(" ");
    this.count_total = jQuery(document.createElement("span")).appendTo(this.count).text(settings.total + "");
    this.count.appendTo(this.row_div);

    // Favorites
    this._setup_favorites(settings['favorites']);

    // Export
    if (typeof settings.csv_fields != "undefined" && settings.csv_fields != false) {
      var definition = settings.csv_fields;
      if (settings.csv_fields === true) {
        definition = egw$1.preference('nextmatch-export-definition', this.nextmatch.egw().app_name());
      }
      var _button = et2_createWidget("buttononly", {
        id: "export",
        "statustext": "Export",
        image: "download",
        "background_image": true
      }, this);
      jQuery(_button.getDOMNode()).click(this.nextmatch, function (event) {
        // @ts-ignore
        egw_openWindowCentered2(egw$1.link('/index.php', {
          'menuaction': 'importexport.importexport_export_ui.export_dialog',
          'appname': event.data.egw().getAppName(),
          'definition': definition
        }), '_blank', 850, 440, 'yes');
      });
    }

    // Another place to customize nextmatch
    this.header_row = jQuery(document.createElement("div")).addClass('header_row').appendTo(this.right_div);

    // Letter search
    var current_letter = this.nextmatch.options.settings.searchletter ? this.nextmatch.options.settings.searchletter : this.nextmatch.activeFilters ? this.nextmatch.activeFilters.searchletter : false;
    if (this.nextmatch.options.settings.lettersearch || current_letter) {
      this.lettersearch = jQuery(document.createElement("table")).addClass('nextmatch_lettersearch').css("width", "100%").appendTo(this.div);
      var tbody = jQuery(document.createElement("tbody")).appendTo(this.lettersearch);
      var row = jQuery(document.createElement("tr")).appendTo(tbody);

      // Capitals, A-Z
      var letters = this.egw().lang('ABCDEFGHIJKLMNOPQRSTUVWXYZ').split('');
      for (var i in letters) {
        button = jQuery(document.createElement("td")).addClass("lettersearch").appendTo(row).attr("id", letters[i]).text(letters[i]);
        if (letters[i] == current_letter) button.addClass("lettersearch_active");
      }
      button = jQuery(document.createElement("td")).addClass("lettersearch").appendTo(row).attr("id", "").text(egw$1.lang("all"));
      if (!current_letter) button.addClass("lettersearch_active");
      this.lettersearch.click(this.nextmatch, function (event) {
        // this is the lettersearch table
        jQuery("td", this).removeClass("lettersearch_active");
        jQuery(event.target).addClass("lettersearch_active");
        event.data.applyFilters({
          searchletter: event.target.id || false
        });
      });
      // Set activeFilters to current value
      this.nextmatch.activeFilters.searchletter = current_letter;
    }
    // Apply letter search preference
    var lettersearch_preference = "nextmatch-" + this.nextmatch.options.settings.columnselection_pref + "-lettersearch";
    if (this.lettersearch && !egw$1.preference(lettersearch_preference, this.nextmatch.egw().app_name())) {
      this.lettersearch.hide();
    }
  }

  /**
   * Build & bind to a sub-template into the header
   *
   * @param {string} location One of left, right, or row
   * @param {string} template_name Name of the template to load into the location
   */
  _build_header(location, template_name) {
    var id = location == "left" ? 0 : location == "right" ? 1 : 2;
    var existing = this.headers[id];
    // @ts-ignore
    if (existing && existing._type) {
      if (existing.id == template_name) return;
      existing.destroy();
      this.headers[id] = null;
    }
    if (!template_name) return;

    // Load the template
    var self = this;
    var header = et2_createWidget("template", {
      "id": template_name
    }, this);
    this.headers[id] = header;
    var deferred = [];
    header.loadingFinished(deferred);

    // Wait until all child widgets are loaded, then bind
    Promise.all(deferred).then(() => {
      // fix order in DOM by reattaching templates in correct position
      switch (id) {
        case 0:
          // header_left: prepend
          jQuery(header.getDOMNode()).prependTo(self.header_div);
          break;
        case 1:
          // header_right: before favorites and count
          window.setTimeout(() => jQuery(header.getDOMNode()).prependTo(self.header_div.find('div.header_row_right')));
          break;
        case 2:
          // header_row: after search
          window.setTimeout(function () {
            // otherwise we might end up after filters
            jQuery(header.getDOMNode()).insertAfter(self.header_div.find('div.search'));
          }, 1);
          break;
      }
      self._bindHeaderInput(header);
    });
  }

  /**
   * Build the selectbox filters in the header bar
   * Sets value, options, labels, and change handlers
   *
   * @param {string} name
   * @param {string} type
   * @param {string} value
   * @param {string} lang
   * @param {object} extra
   */
  _build_select(name, type, value, lang, extra) {
    var widget_options = jQuery.extend({
      "id": name,
      "label": this.nextmatch.options.settings[name + "_label"],
      "no_lang": lang,
      "disabled": this.nextmatch.options['no_' + name]
    }, extra);

    // Set select options
    // Check in content for options-<name>
    var mgr = this.nextmatch.getArrayMgr("content");
    var options = false;
    // Sometimes legacy stuff puts it in here
    options = mgr.getEntry('rows[sel_options][' + name + ']');

    // Maybe in a row, and options got stuck in ${row} instead of top level
    var row_stuck = ['${row}', '{$row}'];
    for (var i = 0; !options && i < row_stuck.length; i++) {
      var row_id = '';
      if ((!options || options.length == 0) && (
      // perspectiveData.row in nm, data["${row}"] in an auto-repeat grid
      this.nextmatch.getArrayMgr("sel_options").perspectiveData.row || this.nextmatch.getArrayMgr("sel_options").data[row_stuck[i]])) {
        row_id = name.replace(/[0-9]+/, row_stuck[i]);
        options = this.nextmatch.getArrayMgr("sel_options").getEntry(row_id);
        if (!options) {
          row_id = row_stuck[i] + "[" + name + "]";
          options = this.nextmatch.getArrayMgr("sel_options").getEntry(row_id);
        }
      }
      if (options) {
        this.egw().debug('warn', 'Nextmatch filter options in a weird place - "%s".  Should be in sel_options[%s].', row_id, name);
      }
    }
    // Legacy: Add in 'All' option for cat_id, if not provided.
    if (name == 'cat_id' && (options == null || options != null && typeof options[''] == 'undefined' && typeof options[0] != 'undefined' && options[0].value != '')
    // Not mail, since it needs to be different
    && !['mail'].includes(this.getInstanceManager().app)) {
      widget_options.emptyLabel = this.egw().lang('All categories');
    }

    // Create widget
    var select = loadWebComponent(type, widget_options, this);
    if (options) {
      select.select_options = options;
    }
    if (select.disabled) {
      // Don't just disable, hide completely
      select.classList.add("hideme");
    }

    // Set value
    select.set_value(value);

    // Set activeFilters to current value
    this.nextmatch.activeFilters[select.id] = select.value;

    // Tell framework to ignore, or it will reset it to ''/empty when it does loadingFinished()
    //select.attributes.select_options.ignore = true;

    if (this.nextmatch.options.settings[name + "_onchange"]) {
      // Get the onchange function string
      var onchange = this.nextmatch.options.settings[name + "_onchange"];

      // Real submits cause all sorts of problems
      if (onchange.match(/this\.form\.submit/)) {
        this.egw().debug("warn", "%s tries to submit form, which is not allowed.  Filter changes automatically refresh data with no reload.", name);
        onchange = onchange.replace(/this\.form\.submit\([^)]*\);?/, 'return true;');
      }

      // Connect it to the onchange event of the input element - may submit
      select.onchange = et2_compileLegacyJS(onchange, this.nextmatch, select.getInputNode());
      this._bindHeaderInput(select);
    } else
      // default request changed rows with new filters, previous this.form.submit()
      {
        select.addEventListener("change", () => {
          var set = {};
          set[select.id] = select.getValue();
          this.nextmatch.applyFilters(set);
          select.resetDirty();
        });
      }
    // Sometimes the filter does not display the current value
    // Work-around: Request another update to get it to display
    select.updateComplete.then( /*#__PURE__*/_asyncToGenerator$d(function* () {
      yield select.updateComplete;
      select.requestUpdate("value");
    }));
    return select;
  }

  /**
   * Set up the favorites UI control
   *
   * @param filters Array|boolean The nextmatch setting for favorites.  Either true, or a list of
   *	additional fields/settings to add in to the favorite.
   */
  _setup_favorites(filters) {
    if (typeof filters == "undefined" || filters === false) {
      // No favorites configured
      return;
    }
    var widget_options = {
      default_pref: "nextmatch-" + this.nextmatch.options.settings.columnselection_pref + "-favorite",
      app: this.getInstanceManager().app,
      filters: filters,
      sidebox_target: 'favorite_sidebox_' + this.getInstanceManager().app
    };
    this.favorites = et2_createWidget('favorites', widget_options, this);

    // Add into header
    jQuery(this.favorites.getDOMNode(this.favorites)).prependTo(egwIsMobile$1() ? this.search_box.find('.nm_favorites_div').show() : this.right_div);
  }

  /**
   * Updates all the filter elements in the header
   *
   * Does not actually refresh the data, just sets values to match those given.
   * Called by et2_nextmatch.applyFilters().
   *
   * @param filters Array Key => Value pairs of current filters
   */
  setFilters(filters) {
    // Avoid loops cause by change events
    if (this.update_in_progress) return;
    this.update_in_progress = true;

    // Use an array mgr to hande non-simple IDs
    var mgr = new et2_arrayMgr(filters);
    this.iterateOver(function (child) {
      // Skip favorites, don't want them in the filter
      if (typeof child.id != "undefined" && child.id.indexOf("favorite") == 0) return;
      var value = '';
      if (typeof child.set_value != "undefined" && child.id) {
        value = mgr.getEntry(child.id);
        if (value == null) value = '';
        /**
         * Sometimes a filter value is not in current options.  This can
         * happen in a saved favorite, for example, or if server changes
         * some filter options, and the order doesn't work out.  The normal behaviour
         * is to warn & not set it, but for nextmatch we'll just add it
         * in, and let the server either set it properly, or ignore.
         */
        if (value && typeof value != 'object' && child.instanceOf(et2_selectbox)) {
          var found = typeof child.options.select_options[value] != 'undefined';
          // options is array of objects with attribute value&label
          if (jQuery.isArray(child.options.select_options)) {
            for (var o = 0; o < child.options.select_options.length; ++o) {
              if (child.options.select_options[o].value == value) {
                found = true;
                break;
              }
            }
          }
          if (!found) {
            var old_options = child.options.select_options;
            // Actual label is not available, obviously, or it would be there
            old_options[value] = child.egw().lang("Loading");
            child.set_select_options(old_options);
          }
        }
        child.set_value(value);
      }
      if (typeof child.get_value == "function" && child.id) {
        // Put data in the proper place
        var target = this;
        value = child.get_value();

        // Split up indexes
        var indexes = child.id.replace(/&#x5B;/g, '[').split('[');
        for (var i = 0; i < indexes.length; i++) {
          indexes[i] = indexes[i].replace(/&#x5D;/g, '').replace(']', '');
          if (i < indexes.length - 1) {
            if (typeof target[indexes[i]] == "undefined") target[indexes[i]] = {};
            target = target[indexes[i]];
          } else {
            target[indexes[i]] = value;
          }
        }
      }
    }, filters);

    // Letter search
    if (this.nextmatch.options.settings.lettersearch) {
      jQuery("td", this.lettersearch).removeClass("lettersearch_active");
      jQuery(filters.searchletter ? "td#" + filters.searchletter : "td.lettersearch[id='']", this.lettersearch).addClass("lettersearch_active");

      // Set activeFilters to current value
      filters.searchletter = jQuery("td.lettersearch_active", this.lettersearch).attr("id") || false;
    }

    // Reset flag
    this.update_in_progress = false;
  }

  /**
   * Help out nextmatch / widget stuff by checking to see if sender is part of header
   *
   * @param {et2_widget} _sender
   */
  getDOMNode(_sender) {
    var filters = [this.category, this.filter, this.filter2];
    for (var i = 0; i < filters.length; i++) {
      if (_sender == filters[i]) {
        // Give them the filter div
        return this.filter_div[0];
      }
    }
    if (_sender == this.et2_searchbox) {
      return this.search_box[0];
    }
    if (_sender == this.favorites) {
      return egwIsMobile$1() ? this.search_box.find('.nm_favorites_div').show()[0] : this.right_div[0];
    }
    if (_sender.id == 'export') {
      return this.right_div[0];
    }
    if (_sender && _sender._type == "template") {
      for (var _i = 0; _i < this.headers.length; _i++) {
        if (_sender.id == this.headers[_i].id && _sender._parent == this) {
          return _i == 2 ? this.header_row[0] : this.header_div[0];
        }
      }
    }
    return null;
  }

  /**
   * Bind all the inputs in the header sub-templates to update the filters
   * on change, and update current filter with the inputs' current values
   *
   * @param {et2_template} sub_header
   */
  _bindHeaderInput(sub_header) {
    var header = this;
    var bind_change = function bind_change(_widget) {
      // Previously set change function
      var widget_change = window.customElements.get(_widget.localName) ? _widget.onchange : _widget.change;
      var change = function change(_node) {
        // Call previously set change function
        var params = [_node, header.nextmatch, _widget];
        if (widget_change !== null && widget_change !== void 0 && widget_change.toString().startsWith("function (ev, widget) {\n    // Dump the executed code for debugging")) {
          // Legacy - do not pass the nextmatch, it will override widget
          params.splice(1, 1);
        }
        var result = widget_change === null || widget_change === void 0 ? void 0 : widget_change.apply(_widget, params);

        // Find current value in activeFilters
        var entry = header.nextmatch.activeFilters;
        var path = _widget.getArrayMgr('content').explodeKey(_widget.id);
        var i = 0;
        if (path.length > 0) {
          for (; i < path.length; i++) {
            entry = entry[path[i]];
          }
        }

        // Update filters, if we're not already doing so
        if ((result || typeof result === 'undefined') && !header.update_in_progress) {
          // Widget will not have an entry in getValues() because nulls
          // are not returned, we remove it from activeFilters
          if (_widget._oldValue == null) {
            var _path = _widget.getArrayMgr('content').explodeKey(_widget.id);
            if (_path.length > 0) {
              var _entry = header.nextmatch.activeFilters;
              var _i2 = 0;
              for (; _i2 < _path.length - 1; _i2++) {
                _entry = _entry[_path[_i2]];
              }
              delete _entry[_path[_i2]];
            }
            header.nextmatch.applyFilters(header.nextmatch.activeFilters);
          } else {
            // Not null is easy, just get values
            var _value2 = this.getInstanceManager().getValues(sub_header);
            header.nextmatch.applyFilters(_value2[header.nextmatch.id]);
          }
        }
        // In case this gets bound twice, it's important to return
        return true;
      };
      if (_widget.localName && window.customElements.get(_widget.localName) !== "undefined") {
        // We could use addEventListener(), but callbacks expect these arguments
        // @ts-ignore
        _widget.onchange = ev => {
          return change.call(this, _widget, _widget);
        };
      } else {
        _widget.change = change;
      }

      // Set activeFilters to current value
      // Use an array mgr to hande non-simple IDs
      var value = {};
      value[_widget.id] = _widget._oldValue = _widget.getValue();
      var mgr = new et2_arrayMgr(value);
      jQuery.extend(true, this.nextmatch.activeFilters, mgr.data);
    };
    if (sub_header.instanceOf(et2_inputWidget)) {
      bind_change.call(this, sub_header);
    } else {
      sub_header.iterateOver(bind_change, this, et2_IInput);
    }
  }
}
_defineProperty$1w(et2_nextmatch_header_bar, "_attributes", {
  "filter_label": {
    "name": "Filter label",
    "type": "string",
    "description": "Label for filter",
    "default": "",
    "translate": true
  },
  "filter_help": {
    "name": "Filter help",
    "type": "string",
    "description": "Help message for filter",
    "default": "",
    "translate": true
  },
  "filter": {
    "name": "Filter value",
    "type": "any",
    "description": "Current value for filter",
    "default": ""
  },
  "no_filter": {
    "name": "No filter",
    "type": "boolean",
    "description": "Remove filter",
    "default": false
  }
});
et2_register_widget(et2_nextmatch_header_bar, ["nextmatch_header_bar"]);

/**
 * Classes for the nextmatch sortheaders etc.
 *
 * @augments et2_baseWidget
 */
class et2_nextmatch_header extends et2_baseWidget {
  /**
   * Constructor
   *
   * @memberOf et2_nextmatch_header
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_nextmatch_header._attributes, _child || {}));
    _defineProperty$1w(this, "labelNode", void 0);
    _defineProperty$1w(this, "nextmatch", void 0);
    _defineProperty$1w(this, "label", void 0);
    this.labelNode = jQuery(document.createElement("span"));
    this.nextmatch = null;
    this.setDOMNode(this.labelNode[0]);
  }

  /**
   * Set nextmatch is the function which has to be implemented for the
   * et2_INextmatchHeader interface.
   *
   * @param {et2_nextmatch} _nextmatch
   */
  setNextmatch(_nextmatch) {
    this.nextmatch = _nextmatch;
  }
  set_label(_value) {
    this.label = _value;
    this.labelNode.text(_value);

    // add class if label is empty
    this.labelNode.toggleClass('et2_label_empty', !_value);
  }
}
_defineProperty$1w(et2_nextmatch_header, "_attributes", {
  "label": {
    "name": "Caption",
    "type": "string",
    "description": "Caption for the nextmatch header",
    "translate": true
  }
});
et2_register_widget(et2_nextmatch_header, ['nextmatch-header']);

/**
 * Extend header to process customfields
 *
 * @augments et2_customfields_list
 *
 * TODO This should extend customfield widget when it's ready, put the whole column in constructor() back too
 */
class et2_nextmatch_customfields extends et2_customfields_list {
  /**
   * Constructor
   *
   * @memberOf et2_nextmatch_customfields
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_nextmatch_customfields._attributes, _child || {}));

    // Specifically take the whole column
    _defineProperty$1w(this, "nextmatch", void 0);
    this.table.css("width", "100%");
  }
  destroy() {
    this.nextmatch = null;
    super.destroy();
  }
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);

    // Add in settings that are objects
    if (!_attrs.customfields) {
      // Check for custom stuff (unlikely)
      var data = this.getArrayMgr("modifications").getEntry(this.id);
      // Check for global settings
      if (!data) data = this.getArrayMgr("modifications").getRoot().getEntry('~custom_fields~', true);
      for (var _key2 in data) {
        if (typeof data[_key2] === 'object' && !_attrs[_key2]) _attrs[_key2] = data[_key2];
      }
    }
  }
  setNextmatch(_nextmatch) {
    this.nextmatch = _nextmatch;
    this.loadFields();
  }

  /**
   * Build widgets for header - sortable for numeric, text, etc., filterables for selectbox, radio
   */
  loadFields() {
    if (this.nextmatch == null) {
      // not ready yet
      return;
    }
    var columnMgr = this.nextmatch.dataview.getColumnMgr();
    var nm_column = null;
    var set_fields = {};
    for (var i = 0; i < this.nextmatch.columns.length; i++) {
      // @ts-ignore
      if (this.nextmatch.columns[i].widget == this) {
        nm_column = columnMgr.columns[i];
        break;
      }
    }
    if (!nm_column) return;

    // Check for global setting changes (visibility)
    var global_data = this.getArrayMgr("modifications").getRoot().getEntry('~custom_fields~');
    if (global_data != null && global_data.fields) this.options.fields = global_data.fields;
    var apps = egw$1.link_app_list();
    for (var field_name in this.options.customfields) {
      var field = this.options.customfields[field_name];
      var cf_id = et2_customfields_list.PREFIX + field_name;
      if (this.rows[field_name]) continue;

      // Table row
      var row = jQuery(document.createElement("tr")).appendTo(this.tbody);
      var cf = jQuery(document.createElement("td")).appendTo(row);
      this.rows[cf_id] = cf[0];

      // Create widget by type
      var widget = null;
      if (field.type == 'select' || field.type == 'select-account') {
        // Remove empty label
        if (field.values && field.values.findIndex && field.values.findIndex(i => i.value == '') !== -1) {
          field.values.splice(field.values.findIndex(i => i.value == ''), 1);
        }
        var attrs = {
          id: cf_id,
          emptyLabel: field.label
        };
        if (field.values && field.values["@"]) {
          attrs.searchUrl = field.values["@"];
        }
        widget = loadWebComponent(field.type == 'select-account' ? 'et2-nextmatch-header-account' : "et2-nextmatch-header-filter", attrs, this);
      } else if (apps[field.type]) {
        widget = loadWebComponent("et2-nextmatch-header-entry", {
          id: cf_id,
          onlyApp: field.type,
          placeholder: field.label
        }, this);
      } else {
        widget = et2_createWidget("nextmatch-sortheader", {
          id: cf_id,
          label: field.label
        }, this);
      }

      // If this is already attached, widget needs to be finished explicitly
      if (this.isAttached() && typeof widget.isAttached == "function" && !widget.isAttached()) {
        widget.loadingFinished();
      }
      // Check for column filter
      if (!jQuery.isEmptyObject(this.options.fields) && (this.options.fields[field_name] == false || typeof this.options.fields[field_name] == 'undefined')) {
        cf.hide();
      } else if (jQuery.isEmptyObject(this.options.fields)) {
        // If we're showing it make sure it's set, but only after
        set_fields[field_name] = true;
      }
    }
    jQuery.extend(this.options.fields, set_fields);
  }

  /**
   * Override parent so we can update the nextmatch row too
   *
   * @param {array} _fields
   */
  set_visible(_fields) {
    super.set_visible(_fields);

    // Find data row, and do it too
    var self = this;
    if (this.nextmatch) {
      this.nextmatch.iterateOver(function (widget) {
        if (widget == self) return;
        widget.set_visible(_fields);
      }, this, et2_customfields_list);
    }
  }

  /**
   * Provide own column caption (column selection)
   *
   * If only one custom field, just use that, otherwise use "custom fields"
   */
  _genColumnCaption() {
    return egw$1.lang("Custom fields");
  }

  /**
   * Provide own column naming, including only selected columns - only useful
   * to nextmatch itself, not for sending server-side
   */
  _getColumnName() {
    var name = this.id;
    var visible = [];
    for (var field_name in this.options.customfields) {
      if (jQuery.isEmptyObject(this.options.fields) || this.options.fields[field_name] == true) {
        visible.push(et2_customfields_list.PREFIX + field_name);
        jQuery(this.rows[field_name]).show();
      } else if (typeof this.rows[field_name] != "undefined") {
        jQuery(this.rows[field_name]).hide();
      }
    }
    if (visible.length) {
      name += "_" + visible.join("_");
    } else if (this.rows) {
      // None hidden means all visible
      jQuery(this.rows[field_name]).parent().parent().children().show();
    }

    // Update global custom fields column(s) - widgets will check on their own

    // Check for custom stuff (unlikely)
    var data = this.getArrayMgr("modifications").getEntry(this.id);
    // Check for global settings
    if (!data) data = this.getArrayMgr("modifications").getRoot().getEntry('~custom_fields~', true) || {};
    if (!data.fields) data.fields = {};
    for (var field in this.options.customfields) {
      data.fields[field] = this.options.fields == null || typeof this.options.fields[field] == 'undefined' ? false : this.options.fields[field];
    }
    return name;
  }
}
_defineProperty$1w(et2_nextmatch_customfields, "_attributes", {
  'customfields': {
    'name': 'Custom fields',
    'description': 'Auto filled'
  },
  'fields': {
    'name': "Visible fields",
    "description": "Auto filled"
  }
});
et2_register_widget(et2_nextmatch_customfields, ['nextmatch-customfields']);

/**
 * @augments et2_nextmatch_header
 */
// @ts-ignore
class et2_nextmatch_sortheader extends et2_nextmatch_header {
  /**
   * Constructor
   *
   * @memberOf et2_nextmatch_sortheader
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_nextmatch_sortheader._attributes, _child || {}));
    _defineProperty$1w(this, "sortmode", void 0);
    this.sortmode = "none";
    this.labelNode.addClass("nextmatch_sortheader none");
  }
  click(_event) {
    if (this.nextmatch && super.click(_event)) {
      // Send default sort mode if not sorted, otherwise send undefined to calculate
      this.nextmatch.sortBy(this.id, this.sortmode == "none" ? !(this.options.sortmode.toUpperCase() == "DESC") : undefined);

      // Update sort preference
      this.egw().set_preference(this.nextmatch._get_appname(), this.nextmatch.options.template + "_sort", this.nextmatch.activeFilters["sort"]);
      return true;
    }
    return false;
  }

  /**
   * Wrapper to join up interface * framework
   *
   * @param {string} _mode
   */
  set_sortmode(_mode) {
    // Set via nextmatch after setup
    if (this.nextmatch) return;
    this.setSortmode(_mode);
  }

  /**
   * Function which implements the et2_INextmatchSortable function.
   *
   * @param {string} _mode
   */
  setSortmode(_mode) {
    // Remove the last sortmode class and add the new one
    this.labelNode.removeClass(this.sortmode).addClass(_mode);
    this.sortmode = _mode;
  }
}
_defineProperty$1w(et2_nextmatch_sortheader, "_attributes", {
  "sortmode": {
    "name": "Sort order",
    "type": "string",
    "description": "Default sort order",
    "translate": false
  }
});
_defineProperty$1w(et2_nextmatch_sortheader, "legacyOptions", void 0);
et2_register_widget(et2_nextmatch_sortheader, ['nextmatch-sortheader']);

var _templateObject$11, _templateObject2$C, _templateObject3$l, _templateObject4$e, _templateObject5$c;
function ownKeys$P(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$P(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$P(Object(source), true).forEach(function (key) { _defineProperty$1v(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$P(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$11(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1v(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * A split button - a button with a dropdown list
 *
 * There are several parts to the button UI:
 * - Container: This is what is percieved as the dropdown button, the whole package together
 *   - Button: The part on the left that can be clicked
 *   - Arrow: The button to display the choices
 *   - Menu: The list of choices
 *
 * Menu options are passed via the select_options.  They are normally the same
 * as for a select box, but the title can also be full HTML if needed.
 *
 */
class Et2DropdownButton extends Et2WidgetWithSelectMixin(s$5) {
  static get styles() {
    return [...super.styles, shoelace, i$b(_templateObject$11 || (_templateObject$11 = _taggedTemplateLiteral$11(["\n            :host {\n            \t/* Avoid unwanted style overlap from button */\n            \tborder: none;\n            \tbackground-color: none;\n            }\n            :host, sl-menu {\n                /**\n                Adapt shoelace color variables to what we want \n                Maybe some logical variables from etemplate2.css here? \n                */\n\t\t\t\t--sl-color-primary-50: rgb(244, 246, 247);\n\t\t\t\t--sl-color-primary-100: var(--gray-10);\n\t\t\t\t--sl-color-primary-300: var(--input-border-color);\n\t\t\t\t--sl-color-primary-400: var(--input-border-color);\n\t\t\t\t--sl-color-primary-600: var(--primary-background-color);\n\t\t\t\t--sl-color-primary-700: #505050;\n            }\n            :host(:active), :host([active]) {\n            \tbackground-color: initial;\n            }\n            sl-button-group {\n            \tdisplay: initial;\n            }\n            #main {\n            \tflex: 1 1 auto;\n            }\n            "])))];
  }
  static get properties() {
    return _objectSpread$P({}, super.properties);
  }

  // Make sure imports stay

  constructor() {
    super();

    // Bind handlers - parent already got click
    _defineProperty$1v(this, "_group", void 0);
    _defineProperty$1v(this, "_dropdow", void 0);
    this._handleSelect = this._handleSelect.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();

    // Rebind click to just the main button, not the whole thing
    this.removeEventListener("click", this._handleClick);
  }
  _renderOptions() {
    // We have our own render, so we can handle it internally
  }
  render() {
    if (this.readonly) {
      return x$1(_templateObject2$C || (_templateObject2$C = _taggedTemplateLiteral$11([""])));
    }
    return x$1(_templateObject3$l || (_templateObject3$l = _taggedTemplateLiteral$11(["\n            <sl-button-group>\n                <sl-button size=\"", "\" id=\"main\"\n                           ?disabled=", "\n                           @click=", "\n                >\n                    ", "\n                </sl-button>\n                <sl-dropdown placement=\"bottom-end\" hoist>\n                    <sl-button size=\"", "\" slot=\"trigger\" caret\n                               ?disabled=", "></sl-button>\n                    <sl-menu @sl-select=", ">\n                        ", "\n                    </sl-menu>\n                </sl-dropdown>\n            </sl-button-group>\n\t\t"])), egwIsMobile() ? "large" : "medium", this.disabled, this._handleClick, this.label, egwIsMobile() ? "large" : "medium", this.disabled, this._handleSelect, (this.select_options || []).map(option => this._optionTemplate(option)));
  }
  _optionTemplate(option) {
    var icon = option.icon ? x$1(_templateObject4$e || (_templateObject4$e = _taggedTemplateLiteral$11(["\n            <et2-image slot=\"prefix\" src=", " icon></et2-image>"])), option.icon) : '';
    return x$1(_templateObject5$c || (_templateObject5$c = _taggedTemplateLiteral$11(["\n            <sl-menu-item value=\"", "\">\n                ", "\n                ", "\n            </sl-menu-item>"])), option.value, icon, this.noLang ? option.label : this.egw().lang(option.label));
  }
  _handleSelect(ev) {
    this._value = ev.detail.item.value;

    // Trigger a change event
    this.dispatchEvent(new Event("change"));

    // Let it bubble, if anyone else is interested
  }

  get value() {
    return this._value;
  }
  set value(new_value) {
    var oldValue = this.value;
    this._value = new_value;
    this.requestUpdate("value", oldValue);
  }
  get _optionTargetNode() {
    return this.shadowRoot.querySelector("sl-menu");
  }
  get buttonNode() {
    return this.shadowRoot.querySelector("#main");
  }
  get triggerButtonNode() {
    return this.shadowRoot.querySelector("[slot='trigger']");
  }
  get dropdownNode() {
    return this.shadowRoot.querySelector("sl-dropdown");
  }
  blur() {
    var _this$shadowRoot$quer;
    (_this$shadowRoot$quer = this.shadowRoot.querySelector("sl-button-group")) === null || _this$shadowRoot$quer === void 0 || _this$shadowRoot$quer.dispatchEvent(new Event('blur'));
  }
  focus() {
    var _this$shadowRoot$quer2;
    (_this$shadowRoot$quer2 = this.shadowRoot.querySelector("sl-button-group")) === null || _this$shadowRoot$quer2 === void 0 || _this$shadowRoot$quer2.dispatchEvent(new Event('focus'));
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Button is a LitElement
customElements.define("et2-dropdown-button", Et2DropdownButton);

var _templateObject$10, _templateObject2$B, _templateObject3$k, _templateObject4$d, _templateObject5$b, _templateObject6$6;
function ownKeys$O(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$O(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$O(Object(source), true).forEach(function (key) { _defineProperty$1u(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$O(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$10(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1u(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Favorites widget, designed for use in the nextmatch header
 *
 * The primary control is a split/dropdown button.  Clicking on the left side of the button filters the
 * nextmatch list by the user's default filter.  The right side of the button gives a list of
 * saved filters, pulled from preferences.  Clicking a filter from the dropdown list sets the
 * filters as saved.
 *
 * Favorites can also automatically be shown in the sidebox, using the special ID favorite_sidebox.
 * Use the following code to generate the sidebox section:
 *  display_sidebox($appname,lang('Favorites'),array(
 *	array(
 *		'no_lang' => true,
 *		'text'=>'<span id="favorite_sidebox"/>',
 *		'link'=>false,
 *		'icon' => false
 *	)
 * ));
 * This sidebox list will be automatically generated and kept up to date.
 *
 *
 * Favorites are implemented by saving the values for [column] filters.  Filters are stored
 * in preferences, with the name favorite_<name>.  The favorite favorite used for clicking on
 * the filter button is stored in nextmatch-<columnselection_pref>-favorite.
 *
 */
class Et2Favorites extends Et2DropdownButton {
  static get styles() {
    return [...super.styles, i$b(_templateObject$10 || (_templateObject$10 = _taggedTemplateLiteral$10(["\n\t\t\t  :host {\n\t\t\t\tmin-width: 8ex;\n\t\t\t  }\n\n\t\t\t  et2-image {\n\t\t\t\tdisplay: flex;\n\t\t\t\theight: 100%;\n\t\t\t\twidth: ", "\n\t\t\t  }\n\n\t\t\t  et2-image[src=\"trash\"] {\n\t\t\t\tdisplay: none;\n\t\t\t  }\n\n\t\t\t  sl-menu {\n\t\t\t\tmin-width: 15em;\n\t\t\t  }\n\n\t\t\t\tsl-menu-item:hover et2-image[src=\"trash\"] {\n\t\t\t\tdisplay: initial;\n\t\t\t  }\n\n\t\t\t  /* Add star icons - radio button is already in prefix */\n\n\t\t\t\tsl-menu-item::part(base) {\n\t\t\t\tbackground-image: ", ";\n\t\t\t\tbackground-repeat: no-repeat;\n\t\t\t\tbackground-size: 16px 16px;\n\t\t\t\tbackground-position: 5px center;\n\t\t\t  }\n\n\t\t\t\tsl-menu-item[checked]::part(base) {\n\t\t\t\tbackground-image: ", ";\n\t\t\t  }\n\n\t\t\t\tsl-menu-item:last-child::part(base) {\n\t\t\t\tbackground-image: none;\n\t\t\t  }\n\t\t\t"])), egwIsMobile() ? i$b(_templateObject2$B || (_templateObject2$B = _taggedTemplateLiteral$10(["4ex"]))) : i$b(_templateObject3$k || (_templateObject3$k = _taggedTemplateLiteral$10(["2ex"]))), cssImage("fav_filter"), cssImage("favorites"))];
  }
  static get properties() {
    return _objectSpread$O(_objectSpread$O({}, super.properties), {}, {
      // Where we keep the "default" preference
      defaultPref: {
        type: String
      },
      // Application to show favorites for
      app: {
        type: String
      },
      // Extra filters to include in the saved favorite
      filters: {
        type: Object
      }
    });
  }

  // Favorites are prefixed in preferences

  constructor() {
    super();
    _defineProperty$1u(this, "favSortedList", []);
    _defineProperty$1u(this, "_preferred", void 0);
    _defineProperty$1u(this, "_nextmatch", void 0);
    this.__statustext = "Favorite queries";
    this._handleRadio = this._handleRadio.bind(this);
    this._handleDelete = this._handleDelete.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.id) {
      this.id = "favorite";
    }
    this._preferred = this.egw().preference(this.defaultPref, this.app);

    // Need to wait until update is done and these exist
    this.updateComplete.then(() => {
      if (this.buttonNode) {
        var img = new Et2Image();
        img.src = "fav_filter";
        this.buttonNode.append(img);
      }
    });
  }
  set select_options(_new_options) {
    // We don't actually want your options, thanks.
  }
  get select_options() {
    if (this.__select_options.length) {
      return this.__select_options;
    }
  }
  get preferred() {
    return this._preferred;
  }
  _optionTemplate(option) {
    var radio = x$1(_templateObject4$d || (_templateObject4$d = _taggedTemplateLiteral$10(["<input type=\"radio\" slot=\"prefix\" name=\"favorite\" value=\"", "\"\n                                ?checked=\"", "\"\n                                @change=", "\n                                title=\"", "\"/>"])), option.value, option.value == this._preferred, this._handleRadio, this.egw().lang('Set as default'));

    //@ts-ignore TS doesn't know about window.app
    var is_admin = typeof this.egw().app('admin') != "undefined";
    //@ts-ignore option.group does not exist
    var icon = option.group !== false && !is_admin || ['blank', '~add~'].includes(option.value) ? "" : x$1(_templateObject5$b || (_templateObject5$b = _taggedTemplateLiteral$10(["\n            <et2-image slot=\"suffix\" src=", " icon @click=", "\n                       statustext=\"", "\"></et2-image>"])), "trash", this._handleDelete, this.egw().lang("Delete"));
    return x$1(_templateObject6$6 || (_templateObject6$6 = _taggedTemplateLiteral$10(["\n            <sl-menu-item value=\"", "\">\n                ", "\n                ", "\n                ", "\n            </sl-menu-item>"])), option.value, option.value !== Et2Favorites.ADD_VALUE ? radio : "", icon, option.label);
  }

  /** @param {import('@lion/core').PropertyValues } changedProperties */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("app")) {
      this._preferred = this.egw().preference(this.defaultPref, this.app);
      this.__select_options = this._load_favorites(this.app);
      this.requestUpdate("select_options");
    }
  }

  /**
   * Load favorites from preferences
   *
   * @param app String Load favorites from this application
   */
  _load_favorites(app) {
    // Default blank filter
    var favorites = {
      'blank': {
        name: this.egw().lang("No filters"),
        state: {}
      }
    };

    // Load saved favorites
    this.favSortedList = [];
    var preferences = this.egw().preference("*", app);
    for (var pref_name in preferences) {
      if (pref_name.indexOf(Et2Favorites.PREFIX) == 0 && typeof preferences[pref_name] == 'object') {
        var name = pref_name.substr(Et2Favorites.PREFIX.length);
        favorites[name] = preferences[pref_name];
        // Keep older favorites working - they used to store nm filters in 'filters',not state
        if (preferences[pref_name]["filters"]) {
          favorites[pref_name]["state"] = preferences[pref_name]["filters"];
        }
      }
      if (pref_name == 'fav_sort_pref') {
        this.favSortedList = preferences[pref_name];
        //Make sure sorted list is always an array, seems some old fav are not array
        if (!Array.isArray(this.favSortedList)) {
          this.favSortedList = this.favSortedList.split(',');
        }
      }
    }
    for (var _name in favorites) {
      if (this.favSortedList.indexOf(_name) < 0) {
        this.favSortedList.push(_name);
      }
    }
    this.egw().set_preference(this.app, 'fav_sort_pref', this.favSortedList);
    if (this.favSortedList.length > 0) {
      var sortedListObj = {};
      for (var i = 0; i < this.favSortedList.length; i++) {
        if (typeof favorites[this.favSortedList[i]] != 'undefined') {
          sortedListObj[this.favSortedList[i]] = favorites[this.favSortedList[i]];
        } else {
          this.favSortedList.splice(i, 1);
          this.egw().set_preference(this.app, 'fav_sort_pref', this.favSortedList);
        }
      }
      favorites = Object.assign(sortedListObj, favorites);
    }
    var options = [];
    Object.keys(favorites).forEach(name => {
      options.push(Object.assign({
        value: name,
        label: favorites[name].name || name
      }, favorites[name]));
    });
    // Only add 'Add current' if we have a nextmatch
    if (this._nextmatch) {
      options.push({
        value: Et2Favorites.ADD_VALUE,
        label: this.egw().lang('Add current')
      });
    }
    this.requestUpdate("select_options");
    return options;
  }
  load_favorites(app) {
    this.__select_options = this._load_favorites(app);
    this.requestUpdate("select_options");
  }

  /**
   * Add the current settings as a new favorite
   */
  _add_current() {
    // Get current filters
    var current_filters = Object.assign({}, this._nextmatch.activeFilters);

    // Add in extras
    for (var extra in this.filters) {
      // Don't overwrite what nm has, chances are nm has more up-to-date value
      if (typeof current_filters == 'undefined') {
        // @ts-ignore
        current_filters[extra] = this._nextmatch.options.settings[extra];
      }
    }
    // Skip columns
    delete current_filters.selectcols;

    // Add in application's settings
    if (this.filters != true) {
      for (var i = 0; i < this.filters.length; i++) {
        current_filters[this.filters[i]] = this._nextmatch.options.settings[this.filters[i]];
      }
    }

    // Call framework
    //@ts-ignore TS doesn't know about window.app
    window.app[this.app].add_favorite(current_filters);
  }

  /**
   * Get a favorite from the list by id
   */
  favoriteByID(id) {
    if (!id) {
      return null;
    }
    return this.__select_options.find(f => f.value == id);
  }

  /**
   * Clicked on an option
   *
   * @param ev
   * @protected
   */
  _handleSelect(ev) {
    if (ev.detail.item.value == Et2Favorites.ADD_VALUE) {
      return this._add_current();
    }
    this._value = ev.detail.item.value;
    this._apply_favorite(ev.detail.item.value);
  }

  /**
   * Handle the click from the main button
   *
   * @param {MouseEvent} event
   * @protected
   */
  _handleClick(event) {
    this._apply_favorite(this.preferred);
  }

  /**
   * Clicked a radio button
   *
   * @param _ev
   * @protected
   */
  _handleRadio(_ev) {
    // Don't do the menu
    _ev.stopImmediatePropagation();

    // Save as default favorite - used when you click the button
    var pref = _ev.target.value;
    this.egw().set_preference(this.app, this.defaultPref, pref);
    this._preferred = pref;
    this.dropdownNode.hide();
    this.requestUpdate("select_options");
    this.dispatchEvent(new Event("change", {
      bubbles: true
    }));
  }
  _handleDelete(_ev) {
    // Don't do the menu
    _ev.stopImmediatePropagation();
    var trash = _ev.target.parentNode;
    var line = trash.parentNode;
    var fav = this.favoriteByID(line.value);
    line.classList.add("loading");

    // Make sure first
    var do_delete = function (button_id) {
      if (button_id != Et2Dialog$1.YES_BUTTON) {
        line.classList.remove('loading');
        return;
      }

      // Hide the trash
      trash.remove();

      // Delete preference server side
      var request = this.egw().json("EGroupware\\Api\\Framework::ajax_set_favorite", [this.app, fav.name, "delete", "" + fav.group, '']).sendRequest();
      request.then(response => {
        line.classList.remove("loading");
        var result = response.response.find(r => r.type == "data");

        // Could not find the result we want
        if (!result || result.type !== "data") {
          return;
        }
        if (typeof result.data == 'boolean' && result.data) {
          // Remove line from list
          line.remove();

          // Remove favorite from options
          this.__select_options = this.__select_options.filter(f => f.value != fav.value);
        } else {
          // Something went wrong server side
          line.classList.add('error');
        }
      });
    }.bind(this);
    Et2Dialog$1.show_dialog(do_delete, this.egw().lang("Delete") + " " + fav.name + "?", "Delete", null, Et2Dialog$1.BUTTONS_YES_NO, Et2Dialog$1.QUESTION_MESSAGE);
    return false;
  }

  /**
   * Apply a favorite to the app or nextmatch
   *
   * @param {string} favorite_name
   * @protected
   */
  _apply_favorite(favorite_name) {
    var fav = favorite_name == "blank" ? {} : this.favoriteByID(favorite_name);
    // use app[appname].setState if available to allow app to overwrite it (eg. change to non-listview in calendar)
    //@ts-ignore TS doesn't know about window.app
    if (typeof window.app[this.app] != 'undefined') {
      //@ts-ignore TS doesn't know about window.app
      window.app[this.app].setState(fav);
    }
  }

  /**
   * Set the nextmatch to filter
   * From et2_INextmatchHeader interface
   *
   * @param {et2_nextmatch} nextmatch
   */
  setNextmatch(nextmatch) {
    this._nextmatch = nextmatch;
    if (this.nm_filter) {
      this.set_value(this.nm_filter);
      this.nm_filter = false;
    }

    // Re-generate filter list so we can add 'Add current'
    this.__select_options = this._load_favorites(this.app);
    this.requestUpdate("select_options");
  }
}
_defineProperty$1u(Et2Favorites, "PREFIX", "favorite_");
_defineProperty$1u(Et2Favorites, "ADD_VALUE", "~add~");
customElements.define("et2-favorites", Et2Favorites);

var _class$6;
var _Symbol$iterator;
function asyncGeneratorStep$c(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$c(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$c(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$c(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$N(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$N(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$N(Object(source), true).forEach(function (key) { _defineProperty$1t(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$N(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1t(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Type for push-message
 */
_Symbol$iterator = Symbol.iterator;
/**
 * Common base class for application javascript
 * Each app should extend as needed.
 *
 * All application javascript should be inside.  Intitialization goes in init(),
 * clean-up code goes in destroy().  Initialization is done once all js is loaded.
 *
 * var app.appname = AppJS.extend({
 *	// Actually set this one, the rest is example
 *	appname: appname,
 *
 *	internal_var: 1000,
 *
 *	init: function()
 *	{
 *		// Call the super
 *		this._super.apply(this, arguments);
 *
 *		// Init the stuff
 *		if ( egw.preference('dateformat', 'common') )
 *		{
 *			// etc
 *		}
 *	},
 *	_private: function()
 *	{
 *		// Underscore private by convention
 *	}
 * });
 */
class EgwApp {
  /**
   * Initialization and setup goes here, but the etemplate2 object
   * is not yet ready.
   */
  constructor(appname, _wnd) {
    /**
     * Internal application name - pass this in constructor
     */
    _defineProperty$1t(this, "appname", void 0);
    /**
     * Internal reference to the most recently loaded etemplate2 widget tree
     *
     * NOTE: This variable can change which etemplate it points to as the user
     * works.  For example, loading the home or admin apps can cause
     * et2_ready() to be called again with a different template.  this.et2 will
     * then point to a different template.  If the user then closes that tab,
     * this.et2 will point to a destroyed object, and trying to use it will fail.
     *
     * If you need a reference to a certain template you can either store a local
     * reference or access it through etemplate2.
     *
     * @example <caption>Store a local reference</caption>
     *	// in et2_ready()
     *	if(name == 'index') this.index_et2 = et2.widgetContainer;
     *
     *	// Remember to clean up in destroy()
     *	delete this.index_et2;
     *
     *	// Instead of this.et2, using a local reference
     *	this.index_et2 ...
     *
     *
     * @example <caption>Access via etemplate2 object</caption>
     * // Instead of this.et2, using its unique ID
     * var et2 = etemplate2.getById("myapp-index")
     * if(et2)
     * {
     *		et2.widgetContainer. ...
     * }
     *
     * @var {et2_container}
     */
    _defineProperty$1t(this, "et2", void 0);
    /**
     * Internal reference to egw client-side api object for current app and window
     *
     * @var {egw}
     */
    _defineProperty$1t(this, "egw", void 0);
    _defineProperty$1t(this, "sidebox", void 0);
    _defineProperty$1t(this, "viewContainer", void 0);
    _defineProperty$1t(this, "viewTemplate", void 0);
    _defineProperty$1t(this, "et2_view", void 0);
    _defineProperty$1t(this, "favorite_popup", void 0);
    _defineProperty$1t(this, "dom_id", void 0);
    _defineProperty$1t(this, "mailvelopeSyncHandlerObj", void 0);
    /**
     * If pushData.acl has fields that can help filter based on ACL grants, list them
     * here and we can check them and ignore push messages if there is no ACL for that entry
     *
     * @protected
     */
    _defineProperty$1t(this, "push_grant_fields", void 0);
    /**
     * If pushData.acl has fields that can help filter based on current nextmatch filters,
     * list them here and we can check and ignore push messages if the nextmatch filters do not exclude them
     *
     * @protected
     */
    _defineProperty$1t(this, "push_filter_fields", void 0);
    /**
     * PGP begin and end tags
     */
    _defineProperty$1t(this, "begin_pgp_message", '-----BEGIN PGP MESSAGE-----');
    _defineProperty$1t(this, "end_pgp_message", '-----END PGP MESSAGE-----');
    /**
     * Mailvelope "egroupware" Keyring
     */
    _defineProperty$1t(this, "mailvelope_keyring", undefined);
    /**
     * jQuery selector for Mailvelope iframes in all browsers
     */
    _defineProperty$1t(this, "mailvelope_iframe_selector", 'iframe[src^="chrome-extension"],iframe[src^="about:blank?mvelo"]');
    this.appname = appname;
    this.egw = egw(this.appname, _wnd || window);

    // Initialize sidebox for non-popups.
    // ID set server side
    if (!this.egw.is_popup()) {
      var sidebox = jQuery('#favorite_sidebox_' + this.appname);
      if (sidebox.length == 0 && egw_getFramework() != null) {
        var egw_fw = egw_getFramework();
        sidebox = jQuery('#favorite_sidebox_' + this.appname, egw_fw.sidemenuDiv);
      }
      // Make sure we're running in the top window when we init sidebox
      //@ts-ignore
      if (window.app[this.appname] === this && egw.top.app[this.appname] !== this && egw.top.app[this.appname]) {
        //@ts-ignore
        egw.top.app[this.appname]._init_sidebox(sidebox);
      } else {
        this._init_sidebox(sidebox);
      }
    }
    this.mailvelopeSyncHandlerObj = this.mailvelopeSyncHandler();

    // Keep track of this instance
    EgwApp._register_instance(this);
  }

  /**
   * Clean up any created objects & references
   * @param {object} _app local app object
   */
  destroy(_app) {
    delete this.et2;
    if (this.sidebox) this.sidebox.off();
    delete this.sidebox;
    if (!_app) delete app[this.appname];
    var index = -1;
    if ((index = EgwApp._instances.indexOf(this)) >= 0) {
      EgwApp._instances.splice(index, 1);
    }
  }

  /**
   * This function is called when the etemplate2 object is loaded
   * and ready.  If you must store a reference to the et2 object,
   * make sure to clean it up in destroy().  Note that this can be called
   * several times, with different et2 objects, as templates are loaded.
   *
   * @param {etemplate2} et2
   * @param {string} name template name
   */
  et2_ready(et2, name) {
    if (this.et2 !== null) {
      egw.debug('log', "Changed et2 object");
    }
    this.et2 = et2.widgetContainer;
    this._fix_iFrameScrolling();
    if (this.egw && this.egw.is_popup()) {
      this._set_Window_title();
    }

    // Highlights the favorite based on initial list state
    this.highlight_favorite();
  }

  /**
   * Observer method receives update notifications from all applications
   *
   * App is responsible for only reacting to "messages" it is interested in!
   *
   * @param {string} _msg message (already translated) to show, eg. 'Entry deleted'
   * @param {string} _app application name
   * @param {(string|number)} _id id of entry to refresh or null
   * @param {string} _type either 'update', 'edit', 'delete', 'add' or null
   * - update: request just modified data from given rows.  Sorting is not considered,
   *		so if the sort field is changed, the row will not be moved.
   * - edit: rows changed, but sorting may be affected.  Requires full reload.
   * - delete: just delete the given rows clientside (no server interaction neccessary)
   * - add: requires full reload for proper sorting
   * @param {string} _msg_type 'error', 'warning' or 'success' (default)
   * @param {object|null} _links app => array of ids of linked entries
   * or null, if not triggered on server-side, which adds that info
   * @return {false|*} false to stop regular refresh, thought all observers are run
   */
  observer(_msg, _app, _id, _type, _msg_type, _links) {}

  /**
   * Handle a push notification about entry changes from the websocket
   *
   * Gets called for data of all apps, but should only handle data of apps it displays,
   * which is by default only its own, but can be for multiple apps eg. for calendar.
   *
   * @param  pushData
   * @param {string} pushData.app application name
   * @param {(string|number)} pushData.id id of entry to refresh or null
   * @param {string} pushData.type either 'update', 'edit', 'delete', 'add' or null
   * - update: request just modified data from given rows.  Sorting is not considered,
   *		so if the sort field is changed, the row will not be moved.
   * - edit: rows changed, but sorting may be affected.  Requires full reload.
   * - delete: just delete the given rows clientside (no server interaction neccessary)
   * - add: requires full reload for proper sorting
   * @param {object|null} pushData.acl Extra data for determining relevance.  eg: owner or responsible to decide if update is necessary
   * @param {number} pushData.account_id User that caused the notification
   */
  push(pushData) {
    var _this$et;
    // don't care about other apps data, reimplement if your app does care eg. calendar
    if (pushData.app !== this.appname) {
      return;
    }

    // handle delete, for simple case of uid === "$app::$id"
    if (pushData.type === 'delete' && egw.dataHasUID(this.uid(pushData))) {
      egw.refresh('', pushData.app, pushData.id, 'delete');
      return;
    }

    // If we know about it and it's an update, just update.
    // This must be before all ACL checks, as responsible might have changed and entry need to be removed
    // (server responds then with null / no entry causing the entry to disappear)
    if (pushData.type !== "add" && this.egw.dataHasUID(this.uid(pushData)) && this.et2) {
      return this.et2.getInstanceManager().refresh("", pushData.app, pushData.id, pushData.type);
    }

    // Check grants to see if we know we aren't supposed to show it
    if (typeof this.push_grant_fields !== "undefined" && this.push_grant_fields.length > 0 && !this._push_grant_check(pushData, this.push_grant_fields)) {
      return;
    }

    // Nextmatch does the hard part of updating.  Try to find one.
    var nm = (_this$et = this.et2) === null || _this$et === void 0 ? void 0 : _this$et.getDOMWidgetById('nm');
    if (!nm) {
      return;
    }

    // Filter what's allowed down to those we can see / care about based on nm filters
    if (typeof this.push_filter_fields !== "undefined" && this.push_filter_fields.length > 0 && !this._push_field_filter(pushData, nm, this.push_filter_fields)) {
      return;
    }

    // Pass actual refresh on to just nextmatch
    nm.refresh(pushData.id, pushData.type);
  }

  /**
   * Check grants to see if we can quickly tell if this entry is not for us
   *
   * Override this method if the app has non-standard access control.
   *
   * @param pushData
   * @param grant_fields List of fields in pushData.acl with account IDs that might grant access eg: info_responsible
   * @param appname Optional, to check against the grants for a different application.  Defaults to this.appname.
   *
   * @return boolean Entry has ACL access
   */
  _push_grant_check(pushData, grant_fields, appname) {
    var grants = egw.grants(appname || this.appname);

    // No grants known
    if (!grants) {
      return true;
    }

    // check user has a grant from owner or something
    var _loop = function _loop() {
        var grant_field = pushData.acl[grant_fields[i]];
        if (["number", "string"].indexOf(typeof grant_field) >= 0 && grants[grant_field] !== 'undefined') {
          // ACL access
          return {
            v: true
          };
        } else if (!Object.keys(grants).filter(function (grant_account) {
          return grant_field.indexOf(grant_account) >= 0 || grant_field.indexOf(parseInt(grant_account)).length;
        })) {
          return {
            v: false
          };
        }
      },
      _ret;
    for (var i = 0; i < grant_fields.length; i++) {
      _ret = _loop();
      if (_ret) return _ret.v;
    }
    return false;
  }

  /**
   * Check pushData.acl values against a list of fields to see if we care about this entry based on current nextmatch
   * filter values.  This is not a definitive yes or no (the server will tell us when we ask), we just want to cheaply
   * avoid a server call if we know it won't be in the list.
   *
   * @param pushData
   * @param filter_fields List of filter field names eg: [owner, cat_id]
   * @return boolean True if the nextmatch filters might include the entry, false if not
   */
  _push_field_filter(pushData, nm, filter_fields) {
    var filters = {};
    for (var i = 0; i < filter_fields.length; i++) {
      filters[filter_fields[i]] = {
        col: filter_fields[i],
        filter_values: []
      };
    }

    // Get current filter values
    var value = nm.getValue();
    if (!value || !value.col_filter) return false;
    for (var field_filter of Object.values(filters)) {
      var val = value.col_filter[field_filter.col];
      if (val && typeof val == "string" && val.trim().length > 0) {
        field_filter.filter_values.push(val);
      } else if (val && typeof val == "object" && !jQuery.isEmptyObject(val)) {
        field_filter.filter_values = field_filter.filter_values.concat(Object.values(val));
      }
    }

    // check filters against pushData.acl data
    var _loop2 = function _loop2(_field_filter) {
        // no filter set
        if (_field_filter.filter_values.length == 0) return 0; // continue

        // acl value is a scalar (not array) --> check contained in filter
        if (pushData.acl && typeof pushData.acl[_field_filter.col] !== 'object') {
          if (_field_filter.filter_values.indexOf(pushData.acl[_field_filter.col]) < 0) {
            return {
              v: false
            };
          }
          return 0; // continue
        }
        // acl value is an array (eg. tr_assigned) --> check intersection with filter
        if (!_field_filter.filter_values.filter(account => pushData.acl[_field_filter.col].indexOf(account) >= 0).length) {
          return {
            v: false
          };
        }
      },
      _ret2;
    for (var _field_filter of Object.values(filters)) {
      _ret2 = _loop2(_field_filter);
      if (_ret2 === 0) continue;
      if (_ret2) return _ret2.v;
    }
    return true;
  }

  /**
   * Get (possible) app-specific uid
   *
   * @param {object} pushData see push method for individual attributes
   */
  uid(pushData) {
    return pushData.app + '::' + pushData.id;
  }

  /**
   * Open an entry.
   *
   * Designed to be used with the action system as a callback
   * eg: onExecute => app.<appname>.open
   *
   * @param _action
   * @param _senders
   */
  open(_action, _senders) {
    var id_app = _senders[0].id.split('::');
    egw.open(id_app[1], this.appname);
  }
  _do_action(action_id, selected) {}

  /**
   * A generic method to action to server asynchronously
   *
   * Designed to be used with the action system as a callback.
   * In the PHP side, set the action
   * 'onExecute' => 'javaScript:app.<appname>.action', and
   * implement _do_action(action_id, selected)
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _elems
   */
  action(_action, _elems) {
    // let user confirm select-all
    var select_all = _action.getManager().getActionById("select_all");
    var confirm_msg = (_elems.length > 1 || select_all && select_all.checked) && typeof _action.data.confirm_multiple != 'undefined' ? _action.data.confirm_multiple : _action.data.confirm;
    if (typeof confirm_msg != 'undefined') {
      var that = this;
      var action_id = _action.id;
      Et2Dialog$1.show_dialog(function (button_id, value) {
        if (button_id != Et2Dialog$1.NO_BUTTON) {
          that._do_action(action_id, _elems);
        }
      }, confirm_msg, 'Confirmation required', null, Et2Dialog$1.BUTTONS_YES_NO, Et2Dialog$1.QUESTION_MESSAGE);
    } else if (typeof this._do_action == 'function') {
      this._do_action(_action.id, _elems);
    } else {
      // If this is a nextmatch action, do an ajax submit setting the action
      var nm = null;
      var action = _action;
      while (nm == null && action.parent != null) {
        if (action.data.nextmatch) nm = action.data.nextmatch;
        action = action.parent;
      }
      if (nm != null) {
        var value = {};
        value[nm.options.settings.action_var] = _action.id;
        nm.set_value(value);
        nm.getInstanceManager().submit();
      }
    }
  }

  /**
   * Set the application's state to the given state.
   *
   * While not pretending to implement the history API, it is patterned similarly
   * @link http://www.whatwg.org/specs/web-apps/current-work/multipage/history.html
   *
   * The default implementation works with the favorites to apply filters to a nextmatch.
   *
   *
   * @param {{name: string, state: object}|string} state Object (or JSON string) for a state.
   *	Only state is required, and its contents are application specific.
   * @param {string} template template name to check, instead of trying all templates of current app
   * @return {boolean} false - Returns false to stop event propagation
   */
  setState(state, template) {
    var _egw$app;
    // State should be an object, not a string, but we'll parse
    if (typeof state == "string") {
      if (state.indexOf('{') != -1 || state == 'null') {
        state = JSON.parse(state);
      }
    }
    if (typeof state != "object") {
      egw.debug('error', 'Unable to set state to %o, needs to be an object', state);
      return;
    }
    if (state == null) {
      state = {};
    }

    // Check for egw.open() parameters
    if (state.state && state.state.id && state.state.app) {
      return egw.open(state.state, undefined, undefined, {}, '_self');
    }

    // Try and find a nextmatch widget, and set its filters
    var nextmatched = false;
    var et2 = template ? etemplate2$1.getByTemplate(template) : etemplate2$1.getByApplication(this.appname);
    for (var i = 0; i < et2.length; i++) {
      et2[i].widgetContainer.iterateOver(function (_widget) {
        // Firefox has trouble with spaces in search
        if (state.state && state.state.search) state.state.search = unescape(state.state.search);

        // Apply
        if (state.state && state.state.sort && state.state.sort.id) {
          _widget.sortBy(state.state.sort.id, state.state.sort.asc, false);
        } else {
          // Not using resetSort() to avoid the extra applyFilters() call
          _widget.sortBy(undefined, undefined, false);
        }
        _widget.applyFilters(state.state || state.filter || {});
        if (state.state && state.state.selectcols) {
          // Make sure it's a real array, not an object, then set cols
          _widget.set_columns(jQuery.extend([], state.state.selectcols));
        }
        nextmatched = true;
      }, this, et2_nextmatch);
      if (nextmatched) return false;
    }

    // 'blank' is the special name for no filters, send that instead of the nice translated name
    var safe_name = jQuery.isEmptyObject(state) || jQuery.isEmptyObject(state.state || state.filter) ? 'blank' : state.name.replace(/[^A-Za-z0-9-_]/g, '_');
    var url = '/' + this.appname + '/index.php';

    // Try a redirect to list, if app defines a "list" value in registry
    if (egw.link_get_registry(this.appname, 'list')) {
      url = egw.link('/index.php', jQuery.extend({
        'favorite': safe_name
      }, egw.link_get_registry(this.appname, 'list')));
    }
    // if no list try index value from application
    else if ((_egw$app = egw.app(this.appname)) !== null && _egw$app !== void 0 && _egw$app.index) {
      url = egw.link('/index.php', 'menuaction=' + egw.app(this.appname).index + '&favorite=' + safe_name);
    }
    egw.open_link(url, undefined, undefined, this.appname);
    return false;
  }

  /**
   * Retrieve the current state of the application for future restoration
   *
   * The state can be anything, as long as it's an object.  The contents are
   * application specific.  The default implementation finds a nextmatch and
   * returns its value.
   * The return value of this function cannot be passed directly to setState(),
   * since setState is expecting an additional wrapper, eg:
   * {name: 'something', state: getState()}
   *
   * @return {object} Application specific map representing the current state
   */
  getState() {
    var state = {};

    // Try and find a nextmatch widget, and set its filters
    var et2 = etemplate2$1.getByApplication(this.appname);
    for (var i = 0; i < et2.length; i++) {
      et2[i].widgetContainer.iterateOver(function (_widget) {
        state = _widget.getValue();
      }, this, et2_nextmatch);
    }
    return state;
  }

  /**
   * Function to load selected row from nm into a template view
   *
   * @param {object} _action
   * @param {object} _senders
   * @param {boolean} _noEdit defines whether to set edit button or not default is false
   * @param {function} et2_callback function to run after et2 is loaded
   */
  viewEntry(_action, _senders, _noEdit, et2_callback) {
    //full id in nm
    var id = _senders[0].id;
    // flag for edit button
    var noEdit = _noEdit || false;
    // nm row id
    var rowID = '';
    // content to feed to etemplate2
    var content = {};
    var self = this;
    if (id) {
      var parts = id.split('::');
      rowID = parts[1];
      content = egw.dataGetUIDdata(id);
      if (content.data) content = content.data;
    }

    // create a new app object with just constructors for our new etemplate2 object
    var app = {
      classes: window.app.classes
    };

    /* destroy generated etemplate for view mode in DOM*/
    var destroy = function destroy() {
      self.viewContainer.remove();
      delete self.viewTemplate;
      delete self.viewContainer;
      delete self.et2_view;
      // we need to reference back into parent context this
      for (var v in self) {
        this[v] = self[v];
      }
      app = null;
    };

    // view container
    this.viewContainer = jQuery(document.createElement('div')).addClass('et2_mobile_view').css({
      "z-index": 102,
      width: "100%",
      height: "100%",
      background: "white",
      display: 'block',
      position: 'absolute',
      left: 0,
      bottom: 0,
      right: 0,
      overflow: 'auto'
    }).attr('id', 'popupMainDiv').appendTo('body');

    // close button
    var close = jQuery(document.createElement('span')).addClass('egw_fw_mobile_popup_close loaded').click(function () {
      destroy.call(app[self.appname]);
      //disable selected actions after close
      egw_globalObjectManager.setAllSelected(false);
    }).appendTo(this.viewContainer);
    if (!noEdit) {
      // edit button
      var edit = jQuery(document.createElement('span')).addClass('mobile-view-editBtn').click(function () {
        egw.open(rowID, self.appname);
      }).appendTo(this.viewContainer);
    }
    // view template main container (content)
    this.viewTemplate = jQuery(document.createElement('div')).attr('id', this.appname + '-view').addClass('et2_mobile-view-container popupMainDiv').appendTo(this.viewContainer);
    var mobileViewTemplate = (_action.data.mobileViewTemplate || 'edit').split('?');
    var templateName = mobileViewTemplate[0];
    var templateTimestamp = mobileViewTemplate[1];
    var templateURL = egw.webserverUrl + '/' + this.appname + '/templates/mobile/' + templateName + '.xet' + '?' + templateTimestamp;
    var data = {
      'content': content,
      'readonlys': {
        '__ALL__': true,
        'link_to': false
      },
      'currentapp': this.appname,
      'langRequire': this.et2.getArrayMgr('langRequire').data,
      'sel_options': this.et2.getArrayMgr('sel_options').data,
      'modifications': this.et2.getArrayMgr('modifications').data,
      'validation_errors': this.et2.getArrayMgr('validation_errors').data
    };

    // etemplate2 object for view
    this.et2_view = new etemplate2$1(this.viewTemplate[0], '');
    framework.pushState('view');
    if (templateName) {
      this.et2_view.load(this.appname + '.' + templateName, templateURL, data, typeof et2_callback == 'function' ? et2_callback : function () {}, app);
    }

    // define a global close function for view template
    // in order to be able to destroy view on action
    this.et2_view.close = destroy;
  }

  /**
   * Opens _menuaction in an Et2Dialog
   *
   * Equivalent to egw.openDialog, though this one works in popups too.
   *
   * @param _menuaction
   * @return Promise<Et2Dialog>
   */
  openDialog(_menuaction) {
    var resolver;
    var rejector;
    var dialog_promise = new Promise((resolve, reject) => {
      resolver = value => resolve(value);
      rejector = reason => reject(reason);
    });
    var request = this.egw.json(_menuaction.match(/^([^.:]+)/)[0] + '.jdots_framework.ajax_exec.template.' + _menuaction, ['index.php?menuaction=' + _menuaction, true], _response => {
      if (Array.isArray(_response) && typeof _response[0] === 'string') {
        var dialog = jQuery(_response[0]).appendTo(document.body);
        if (dialog.length > 0 && dialog.get(0)) {
          resolver(dialog.get(0));
        } else {
          console.log("Unable to add dialog with dialogExec('" + _menuaction + "')", _response);
          rejector(new Error("Unable to add dialog"));
        }
      } else {
        console.log("Invalid response to dialogExec('" + _menuaction + "')", _response);
        rejector(new Error("Invalid response to dialogExec('" + _menuaction + "')"));
      }
    }).sendRequest();
    return dialog_promise;
  }

  /**
   * Merge selected entries into template document
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _selected
   */
  merge(_action, _selected) {
    var _nm;
    // Find what we need
    var nm = null;
    var action = _action;
    var as_pdf = null;

    // Find Select all
    while (nm == null && action.parent != null) {
      if (action.data != null && action.data.nextmatch) {
        nm = action.data.nextmatch;
      }
      if (as_pdf === null && action.getActionById('as_pdf') !== null) {
        as_pdf = action.getActionById('as_pdf').checked;
      }
      action = action.parent;
    }
    var all = ((_nm = nm) === null || _nm === void 0 ? void 0 : _nm.getSelection().all) || false;
    as_pdf = as_pdf || false;

    // Get list of entry IDs
    var ids = [];
    for (var i = 0; !all && i < _selected.length; i++) {
      var split = _selected[i].id.split("::");
      ids.push(split[1]);
    }
    var vars = _objectSpread$N(_objectSpread$N({}, _action.data.merge_data), {}, {
      pdf: as_pdf,
      select_all: all,
      id: JSON.stringify(ids)
    });
    egw.open_link(egw.link('/index.php', vars), '_blank');
  }

  /**
   * Initializes actions and handlers on sidebox (delete)
   *
   * @param {jQuery} sidebox jQuery of DOM node
   */
  _init_sidebox(sidebox) {
    if (sidebox.length) {
      var _document$getElementB;
      var self = this;
      if (this.sidebox) this.sidebox.off();
      this.sidebox = sidebox;
      sidebox.off()
      // removed .on("mouse(enter|leave)" (wrapping trash icon), as it stalls delete in IE11
      .on("click.sidebox", "div.ui-icon-trash", this, this.delete_favorite)
      // need to install a favorite handler, as we switch original one off with .off()
      .on('click.sidebox', 'li[data-id]', this, function (event) {
        var li = jQuery(this);
        li.siblings().removeClass('ui-state-highlight');
        var state = {};
        var pref = egw.preference('favorite_' + this.dataset.id, self.appname);
        if (pref) {
          // Extend, to prevent changing the preference by reference
          jQuery.extend(true, state, pref);
        }
        if (this.dataset.id != 'add') {
          event.stopImmediatePropagation();
          self.setState.call(self, state);
          return false;
        }
      }).addClass("ui-helper-clearfix");
      var el = (_document$getElementB = document.getElementById('favorite_sidebox_' + this.appname)) === null || _document$getElementB === void 0 ? void 0 : _document$getElementB.getElementsByTagName('ul')[0];
      if (el && el instanceof HTMLElement) {
        var sortablejs = Sortable.create(el, {
          ghostClass: 'ui-fav-sortable-placeholder',
          draggable: 'li:not([data-id$="add"])',
          delay: 25,
          dataIdAttr: 'data-id',
          onSort: function onSort(event) {
            var favSortedList = sortablejs.toArray();
            self.egw.set_preference(self.appname, 'fav_sort_pref', favSortedList);
            self._refresh_fav_nm();
          }
        });
      }

      // Bind favorite de-select
      var egw_fw = egw_getFramework();
      if (egw_fw && egw_fw.applications[this.appname] && egw_fw.applications[this.appname].browser && egw_fw.applications[this.appname].browser.baseDiv) {
        jQuery(egw_fw.applications[this.appname].browser.baseDiv).off('.sidebox').on('change.sidebox', function () {
          self.highlight_favorite();
        });
        egw_fw.applications[this.appname].browser.baseDiv.addEventListener("change", e => {
          if (e.target.localName == "et2-favorites") {
            sidebox[0].querySelectorAll("li:not([data-id='add']) > a > div:first-child").forEach(f => {
              f.classList.add("sideboxstar");
              f.classList.remove('ui-icon', 'ui-heart');
            });
            var new_pref = sidebox[0].querySelector("li[data-id='" + e.target.preferred + "'] > a > div:first-child");
            if (new_pref) {
              new_pref.classList.add('ui-icon', 'ui-icon-heart');
              new_pref.classList.remove("sideboxstar");
            }
          }
        });
      }
      return true;
    }
    return false;
  }

  /**
   * Add a new favorite
   *
   * Fetches the current state from the application, then opens a dialog to get the
   * name and other settings.  If user proceeds, the favorite is saved, and if possible
   * the sidebox is directly updated to include the new favorite
   *
   * @param {object} [state] State settings to be merged into the application state
   */
  add_favorite(state) {
    // Get current state
    // Make sure it's an object - deep copy to prevent references in sub-objects (col_filters)
    state = _objectSpread$N(_objectSpread$N({}, this.getState()), state || {});
    this._create_favorite_popup(state);

    // Stop the normal bubbling if this is called on click
    return false;
  }

  /**
   * Update favorite items in nm fav. menu
   *
   */
  _refresh_fav_nm() {
    var self = this;
    if (etemplate2$1 && etemplate2$1.getByApplication) {
      var et2 = etemplate2$1.getByApplication(self.appname);
      for (var i = 0; i < et2.length; i++) {
        et2[i].widgetContainer.iterateOver(function (_widget) {
          _widget.stored_filters = _widget.load_favorites(self.appname);
        }, self, Et2Favorites);
      }
    } else {
      throw new Error("_refresh_fav_nm():Either et2 is  not ready/ not there yet. Make sure that etemplate2 is ready before call this method.");
    }
  }

  /**
   * Create the "Add new" popup dialog
   */
  _create_favorite_popup(state) {
    var _this = this;
    var favorite_prefix = 'favorite_';

    // Clear old, if existing
    if (this.favorite_popup && this.favorite_popup.group) {
      this.favorite_popup.group.destroy();
      delete this.favorite_popup;
    }

    // Add some controls if user is an admin
    var apps = this.egw.user('apps');
    var is_admin = typeof apps['admin'] != "undefined";

    // Setup data
    var data = {
      content: {
        state: state || [],
        current_filters: []
      },
      readonlys: {
        group: !is_admin
      }
    };

    // Show current set filters (more for debug than user)
    var filter_list = [];
    var add_to_popup = function add_to_popup(arr) {
      var inset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
      Object.keys(arr).forEach(index => {
        var filter = arr[index];
        filter_list.push({
          label: inset + index.toString(),
          value: typeof filter != "object" ? "" + filter : ""
        });
        if (typeof filter == "object" && filter != null) {
          add_to_popup(filter, inset + "    ");
        }
      });
    };
    add_to_popup(data.content.state);
    data.content.current_filters = filter_list;
    var save_callback = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator$c(function* (button, value) {
        if (button !== Et2Dialog$1.OK_BUTTON) {
          return;
        }
        if (value.name) {
          // Add to the list
          value.name = value.name.replace(/(<([^>]+)>)/ig, "");
          var safe_name = value.name.replace(/[^A-Za-z0-9-_]/g, "_");
          if (safe_name != value.name) {
            // Check if the label matches an existing preference, consider it an update
            var existing = _this.egw.preference(favorite_prefix + safe_name, _this.appname);
            if (existing && existing.name !== value.name) {
              // Name mis-match, this is a new favorite with the same safe name
              safe_name += "_" + (yield _this.egw.hashString(value.name));
            }
          }
          var favorite = {
            name: value.name,
            group: value.group || false,
            state: data.content.state
          };
          var favorite_pref = favorite_prefix + safe_name;

          // Save to preferences
          if (typeof value.group != "undefined" && value.group != '') {
            // Admin stuff - save preference server side
            _this.egw.jsonq('EGroupware\\Api\\Framework::ajax_set_favorite', [_this.appname, value.name, "add", value.group, data.content.state]);
          } else {
            // Normal user - just save to preferences client side
            _this.egw.set_preference(_this.appname, favorite_pref, favorite);
          }

          // Add to list immediately
          if (_this.sidebox) {
            // Remove any existing with that name
            _this.sidebox.get(0).querySelectorAll('[data-id="' + safe_name + '"]').forEach(e => e.remove());

            // Create new item
            var html = "<li data-id='" + safe_name + "' data-group='" + favorite.group + "' class='ui-menu-item' role='menuitem'>\n";
            var href = 'javascript:app.' + _this.appname + '.setState(' + JSON.stringify(favorite) + ');';
            html += "<a href='" + href + "' class='ui-corner-all' tabindex='-1'>";
            html += "<div class='" + 'sideboxstar' + "'></div>" + favorite.name;
            html += "<div class='ui-icon ui-icon-trash' title='" + _this.egw.lang('Delete') + "'/>";
            html += "</a></li>\n";
            jQuery(html).insertBefore(jQuery('li', _this.sidebox).last());
            _this._init_sidebox(_this.sidebox);
          }

          // Try to update nextmatch favorites too
          _this._refresh_fav_nm();
        }
      });
      return function save_callback(_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }();

    // Create popup
    this.favorite_popup = new Et2Dialog$1(this.egw);
    this.favorite_popup.transformAttributes({
      callback: save_callback,
      title: this.egw.lang("New favorite"),
      buttons: Et2Dialog$1.BUTTONS_OK_CANCEL,
      width: 400,
      value: data,
      template: this.egw.webserverUrl + '/api/templates/default/add_favorite.xet'
    });
    document.body.appendChild(this.favorite_popup);
    return false;
  }

  /**
   * Delete a favorite from the list and update preferences
   * Registered as a handler on the delete icons
   *
   * @param {jQuery.event} event event object
   */
  delete_favorite(event) {
    // Don't do the menu
    event.stopImmediatePropagation();
    var app = event.data;
    var id = jQuery(this).parentsUntil('li').parent().attr("data-id");
    var group = jQuery(this).parentsUntil('li').parent().attr("data-group") || '';
    var line = jQuery('li[data-id="' + id + '"]', app.sidebox);
    var name = line.first().text();
    var trash = this;
    line.addClass('loading');

    // Make sure first
    var do_delete = function do_delete(button_id) {
      if (button_id != Et2Dialog$1.YES_BUTTON) {
        line.removeClass('loading');
        return;
      }

      // Hide the trash
      jQuery(trash).hide();

      // Delete preference server side
      var request = egw.json("EGroupware\\Api\\Framework::ajax_set_favorite", [app.appname, id, "delete", group, ''], function (result) {
        // Got the full response from callback, which we don't want
        if (result.type) return;
        if (result && typeof result == 'boolean') {
          // Remove line from list
          line.slideUp("slow", function () {});
          app._refresh_fav_nm();
        } else {
          // Something went wrong server side
          line.removeClass('loading').addClass('ui-state-error');
        }
      }, jQuery(trash).parentsUntil("li").parent(), true, jQuery(trash).parentsUntil("li").parent());
      request.sendRequest(true);
    };
    Et2Dialog$1.show_dialog(do_delete, egw.lang("Delete") + " " + name + "?", "Delete", null, Et2Dialog$1.BUTTONS_YES_NO, Et2Dialog$1.QUESTION_MESSAGE);
    return false;
  }

  /**
   * Mark the favorite closest matching the current state
   *
   * Closest matching takes into account not set values, so we pick the favorite
   * with the most matching values without a value that differs.
   */
  highlight_favorite() {
    if (!this.sidebox) return;
    var state = this.getState();
    var best_match = false;
    var best_count = 0;
    var self = this;
    jQuery('li[data-id]', this.sidebox).removeClass('ui-state-highlight');
    jQuery('li[data-id]', this.sidebox).each(function (i, href) {
      var favorite = {};
      if (this.dataset.id && egw.preference('favorite_' + this.dataset.id, self.appname)) {
        favorite = egw.preference('favorite_' + this.dataset.id, self.appname);
      }
      if (!favorite || jQuery.isEmptyObject(favorite)) return;

      // Handle old style by making it like new style
      if (favorite.filter && !favorite.state) {
        favorite.state = favorite.filter;
      }
      var match_count = 0;
      var extra_keys = Object.keys(favorite.state);
      for (var state_key in state) {
        extra_keys.splice(extra_keys.indexOf(state_key), 1);
        if (typeof favorite.state != 'undefined' && typeof state[state_key] != 'undefined' && typeof favorite.state[state_key] != 'undefined' && (state[state_key] == favorite.state[state_key] || !state[state_key] && !favorite.state[state_key])) {
          match_count++;
        } else if (state_key == 'selectcols' && typeof favorite.state.selectcols == "undefined") {
          // Skip, not set in favorite
        } else if (typeof state[state_key] != 'undefined' && state[state_key] && typeof state[state_key] === 'object' && typeof favorite.state != 'undefined' && typeof favorite.state[state_key] != 'undefined' && favorite.state[state_key] && typeof favorite.state[state_key] === 'object') {
          if ((typeof state[state_key].length !== 'undefined' || typeof state[state_key].length !== 'undefined') && (state[state_key].length || Object.keys(state[state_key]).length) != (favorite.state[state_key].length || Object.keys(favorite.state[state_key]).length)) {
            // State or favorite has a length, but the other does not
            if ((state[state_key].length === 0 || Object.keys(state[state_key]).length === 0) && (favorite.state[state_key].length == 0 || Object.keys(favorite.state[state_key]).length === 0)) {
              // Just missing, or one is an array and the other is an object
              continue;
            }
            // One has a value and the other doesn't, no match
            return;
          } else if (state[state_key].length !== 'undefined' && typeof favorite.state[state_key].length !== 'undefined' && state[state_key].length === 0 && favorite.state[state_key].length === 0) {
            // Both set, but both empty
            match_count++;
            continue;
          }
          // Consider sub-objects (column filters) individually
          for (var sub_key in state[state_key]) {
            if (state[state_key][sub_key] == favorite.state[state_key][sub_key] || !state[state_key][sub_key] && !favorite.state[state_key][sub_key]) {
              match_count++;
            } else if (state[state_key][sub_key] && favorite.state[state_key][sub_key] && typeof state[state_key][sub_key] === 'object' && typeof favorite.state[state_key][sub_key] === 'object') {
              // Too deep to keep going, just string compare for perfect match
              if (JSON.stringify(state[state_key][sub_key]) === JSON.stringify(favorite.state[state_key][sub_key])) {
                match_count++;
              }
            } else if (typeof state[state_key][sub_key] !== 'undefined' && state[state_key][sub_key] != favorite.state[state_key][sub_key]) {
              // Different values, do not match
              return;
            }
          }
        } else if (typeof state[state_key] !== 'undefined' && typeof favorite.state != 'undefined' && typeof favorite.state[state_key] !== 'undefined' && state[state_key] != favorite.state[state_key]) {
          // Different values, do not match
          return;
        }
      }
      // Check for anything set that the current one does not have
      for (var i = 0; i < extra_keys.length; i++) {
        if (favorite.state[extra_keys[i]]) return;
      }
      if (match_count > best_count) {
        best_match = this.dataset.id;
        best_count = match_count;
      }
    });
    if (best_match) {
      jQuery('li[data-id="' + best_match + '"]', this.sidebox).addClass('ui-state-highlight');
    }
  }

  /**
   * Fix scrolling iframe browsed by iPhone/iPod/iPad touch devices
   */
  _fix_iFrameScrolling() {
    if (/iPhone|iPod|iPad/.test(navigator.userAgent)) {
      jQuery("iframe").on({
        load: function load() {
          var body = this.contentWindow.document.body;
          var div = jQuery(document.createElement("div")).css({
            'height': jQuery(this.parentNode).height(),
            'width': jQuery(this.parentNode).width(),
            'overflow': 'scroll'
          });
          while (body.firstChild) {
            div.append(body.firstChild);
          }
          jQuery(body).append(div);
        }
      });
    }
  }

  /**
   * Set document title, uses getWindowTitle to get the correct title,
   * otherwise set it with uniqueID as default title
   */
  _set_Window_title() {
    var title = this.getWindowTitle();
    if (title) {
      document.title = this.et2._inst.uniqueId + ": " + title;
    }
  }

  /**
   * Window title getter function in order to set the window title
   * this can be overridden on each application app.js file to customize the title value
   *
   * @returns {string} window title
   */
  getWindowTitle() {
    var titleWidget = this.et2.getWidgetById('title');
    if (titleWidget) {
      return titleWidget.get_value ? titleWidget.get_value() : titleWidget.value || "";
    } else {
      return this.et2._inst.uniqueId;
    }
  }

  /**
   * Handler for drag and drop when dragging nextmatch rows from mail app
   * and dropped on a row in the current application.  We copy the mail into
   * the filemanager to link it since we can't link directly.
   *
   * This doesn't happen automatically.  Each application must indicate that
   * it will accept dropped mail by its nextmatch actions:
   *
   * $actions['info_drop_mail'] = array(
   *		'type' => 'drop',
   *		'acceptedTypes' => 'mail',
   *		'onExecute' => 'javaScript:app.infolog.handle_dropped_mail',
   *		'hideOnDisabled' => true
   *	);
   *
   * This action, when defined, will not affect the automatic linking between
   * normal applications.
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _selected Dragged mail rows
   * @param {egwActionObject} _target Current application's nextmatch row the mail was dropped on
   */
  handle_dropped_mail(_action, _selected, _target) {
    /**
     * Mail doesn't support link system, so we copy it to VFS
     */
    var ids = _target.id.split("::");
    if (ids.length != 2 || ids[0] == 'mail') return;
    var vfs_path = "/apps/" + ids[0] + "/" + ids[1];
    var mail_ids = [];
    for (var i = 0; i < _selected.length; i++) {
      mail_ids.push(_selected[i].id);
    }
    if (mail_ids.length) {
      egw.message(egw.lang("Please wait..."));
      this.egw.json('filemanager.filemanager_ui.ajax_action', ['mail', mail_ids, vfs_path], function (data) {
        // Trigger an update (minimal, no sorting changes) to display the new link
        egw.refresh(data.msg || '', ids[0], ids[1], 'update');
      }).sendRequest(true);
    }
  }

  /**
   * Check if Mailvelope is available, open (or create) "egroupware" keyring and call callback with it
   *
   * @param {function} _callback called if and only if mailvelope is available (context is this!)
   */
  mailvelopeAvailable(_callback) {
    var self = this;
    var callback = jQuery.proxy(_callback, this);
    if (typeof mailvelope !== 'undefined') {
      this.mailvelopeOpenKeyring().then(callback);
    } else {
      jQuery(window).on('mailvelope', function () {
        self.mailvelopeOpenKeyring().then(callback);
      });
    }
  }

  /**
   * mailvelope object contains SyncHandlers
   *
   * @property {function} descriptionuploadSync function called by Mailvelope to upload encrypted private key backup
   * @property {function} downloadSync function called by Mailvelope to download encrypted private key backup
   * @property {function} backup function called by Mailvelope to upload a public keyring backup
   * @property {function} restore function called by Mailvelope to restore a public keyring backup
   */
  mailvelopeSyncHandler() {
    return {
      /**
       * function called by Mailvelope to upload a public keyring
       * @param {UploadSyncHandler} _uploadObj
       *	@property {string} etag entity tag for the uploaded encrypted keyring, or null if initial upload
       *	@property {AsciiArmored} keyringMsg encrypted keyring as PGP armored message
       * @returns {Promise.<UploadSyncReply, Error>}
       */
      uploadSync: function uploadSync(_uploadObj) {
        return new Promise(function (_resolve, _reject) {});
      },
      /**
       * function called by Mailvelope to download a public keyring
       *
       * @param {object} _downloadObj
       *	@property {string} etag entity tag for the current local keyring, or null if no local eTag
       * @returns {Promise.<DownloadSyncReply, Error>}
       */
      downloadSync: function downloadSync(_downloadObj) {
        return new Promise(function (_resolve, _reject) {});
      },
      /**
       * function called by Mailvelope to upload an encrypted private key backup
       *
       * @param {BackupSyncPacket} _backup
       *	@property {AsciiArmored} backup an encrypted private key as PGP armored message
       * @returns {Promise.<undefined, Error>}
       */
      backup: function backup(_backup) {
        return new Promise(function (_resolve, _reject) {
          // Store backup sync packet into .PGP-Key-Backup file in user directory
          jQuery.ajax({
            method: 'PUT',
            url: egw.webserverUrl + '/webdav.php/home/' + egw.user('account_lid') + '/.PGP-Key-Backup',
            contentType: 'application/json',
            data: JSON.stringify(_backup),
            success: function success() {
              _resolve(_backup);
            },
            error: function error(_err) {
              _reject(_err);
            }
          });
        });
      },
      /**
       * function called by Mailvelope to restore an encrypted private key backup
       *
       * @returns {Promise.<BackupSyncPacket, Error>}
       * @todo
       */
      restore: function restore() {
        return new Promise(function (_resolve, _reject) {
          var resolve = _resolve;
          var reject = _reject;
          jQuery.ajax({
            url: egw.webserverUrl + '/webdav.php/home/' + egw.user('account_lid') + '/.PGP-Key-Backup',
            method: 'GET',
            success: function success(_backup) {
              resolve(JSON.parse(_backup));
              egw.message('Your key has been restored successfully.');
            },
            error: function error(_err) {
              //Try with old back file name
              if (_err.status == 404) {
                jQuery.ajax({
                  method: 'GET',
                  url: egw.webserverUrl + '/webdav.php/home/' + egw.user('account_lid') + '/.PK_PGP',
                  success: function success(_backup) {
                    resolve(JSON.parse(_backup));
                    egw.message('Your key has been restored successfully.');
                  },
                  error: function error(_err) {
                    _reject(_err);
                  }
                });
              } else {
                _reject(_err);
              }
            }
          });
        });
      }
    };
  }

  /**
   * Function for backup file operations
   *
   * @param {type} _url Url of the backup file
   * @param {type} _cmd command to operate
   *	- PUT: to store backup file
   *	- GET: to read backup file
   *	- DELETE: to delete backup file
   *
   * @param {type} _successCallback function called when the operation is successful
   * @param {type} _errorCallback function called when the operation fails
   * @param {type} _data data which needs to be stored in file via PUT command
   */
  _mailvelopeBackupFileOperator(_url, _cmd, _successCallback, _errorCallback, _data) {
    var ajaxObj = {
      url: _url || egw.webserverUrl + '/webdav.php/home/' + egw.user('account_lid') + '/.PGP-Key-Backup',
      method: _cmd,
      success: _successCallback,
      error: _errorCallback
    };
    switch (_cmd) {
      case 'PUT':
        jQuery.extend({}, ajaxObj, {
          data: JSON.stringify(_data),
          contentType: 'application/json'
        });
        break;
      case 'GET':
        jQuery.extend({}, ajaxObj, {
          dataType: 'json'
        });
        break;
      case 'DELETE':
        break;
    }
    jQuery.ajax(ajaxObj);
  }

  /**
   * Create backup dialog
   * @param {string} _selector DOM selector to attach backupDialog
   * @param {boolean} _initSetup determine whether it's an initialization backup or restore backup
   *
   * @returns {Promise.<backupPopupId, Error>}
   */
  mailvelopeCreateBackupDialog(_selector, _initSetup) {
    var self = this;
    var selector = _selector || 'body';
    var initSetup = _initSetup;
    jQuery('iframe[src^="chrome-extension"],iframe[src^="about:blank?mvelo"]').remove();
    return new Promise(function (_resolve, _reject) {
      var resolve = _resolve;
      var reject = _reject;
      mailvelope.getKeyring('egroupware').then(function (_keyring) {
        _keyring.addSyncHandler(self.mailvelopeSyncHandlerObj);
        var options = {
          initialSetup: initSetup
        };
        _keyring.createKeyBackupContainer(selector, options).then(function (_popupId) {
          var $backup_selector = jQuery('iframe[src^="chrome-extension"],iframe[src^="about:blank?mvelo"]');
          $backup_selector.css({
            position: 'absolute',
            "z-index": 1
          });
          _popupId.isReady().then(function (result) {
            egw.message('Your key has been backedup into  .PGP-Key-Backup successfully.');
            jQuery(selector).empty();
          });
          resolve(_popupId);
        }, function (_err) {
          reject(_err);
        });
      }, function (_err) {
        reject(_err);
      });
    });
  }

  /**
   * Delete backup key from filesystem
   */
  mailvelopeDeleteBackup() {
    var self = this;
    Et2Dialog$1.show_dialog(function (_button_id) {
      if (_button_id == Et2Dialog$1.YES_BUTTON) {
        self._mailvelopeBackupFileOperator(undefined, 'DELETE', function () {
          self.egw.message(self.egw.lang('The backup key has been deleted.'));
        }, function (_err) {
          self.egw.message(self.egw.lang('Was not able to delete the backup key because %1', _err));
        });
      }
    }, 'Are you sure, you would like to delete the backup key?', 'Delete backup key', {}, Et2Dialog$1.BUTTONS_YES_NO_CANCEL, Et2Dialog$1.QUESTION_MESSAGE, undefined, self.egw);
  }

  /**
   * Create mailvelope restore dialog
   * @param {string} _selector DOM selector to attach restorDialog
   * @param {boolean} _restorePassword if true, will restore key password too
   *
   * @returns {Promise}
   */
  mailvelopeCreateRestoreDialog(_selector, _restorePassword) {
    var self = this;
    var restorePassword = _restorePassword;
    var selector = _selector || 'body';
    //Clear the
    jQuery('iframe[src^="chrome-extension"],iframe[src^="about:blank?mvelo"]').remove();
    return new Promise(function (_resolve, _reject) {
      var resolve = _resolve;
      var reject = _reject;
      mailvelope.getKeyring('egroupware').then(function (_keyring) {
        _keyring.addSyncHandler(self.mailvelopeSyncHandlerObj);
        var options = {
          restorePassword: restorePassword
        };
        _keyring.restoreBackupContainer(selector, options).then(function (_restoreId) {
          var $restore_selector = jQuery('iframe[src^="chrome-extension"],iframe[src^="about:blank?mvelo"]');
          $restore_selector.css({
            position: 'absolute',
            "z-index": 1
          });
          resolve(_restoreId);
        }, function (_err) {
          reject(_err);
        });
      }, function (_err) {
        reject(_err);
      });
    });
  }

  /**
   * Create a dialog to show all backup/restore options
   *
   * @returns {undefined}
   */
  mailvelopeCreateBackupRestoreDialog() {
    var self = this;
    var appname = egw.app_name();
    var menu = [
    // Header row should be empty item 0
    {},
    // Restore Keyring item 1
    {
      label: "Restore key",
      image: "lock",
      onclick: "app." + appname + ".mailvelopeCreateRestoreDialog('#_mvelo')"
    },
    // Restore pass phrase item 2
    {
      label: "Restore password",
      image: "password",
      onclick: "app." + appname + ".mailvelopeCreateRestoreDialog('#_mvelo', true)"
    },
    // Delete backup Key item 3
    {
      label: "Delete backup",
      image: "delete",
      onclick: "app." + appname + ".mailvelopeDeleteBackup"
    },
    // Backup Key item 4
    {
      label: "Backup Key",
      image: "save",
      onclick: "app." + appname + ".mailvelopeCreateBackupDialog('#_mvelo', false)"
    }];
    var dialog = function dialog(_content, _callback) {
      var dialog = new Et2Dialog$1(this.egw);
      dialog.transformAttributes({
        callback: function callback(_button_id, _value) {
          if (typeof _callback == "function") {
            _callback.call(this, _button_id, _value.value);
          }
        },
        title: egw.lang('Backup/Restore'),
        buttons: [{
          "button_id": 'close',
          "label": egw.lang('Close'),
          id: 'dialog[close]',
          image: 'cancelled',
          "default": true
        }],
        value: {
          content: {
            menu: _content
          }
        },
        template: egw.webserverUrl + '/api/templates/default/pgp_backup_restore.xet',
        class: "pgp_backup_restore",
        isModal: true
      });
      return dialog;
    };
    if (typeof mailvelope != 'undefined') {
      mailvelope.getKeyring('egroupware').then(function (_keyring) {
        self._mailvelopeBackupFileOperator(undefined, 'GET', function (_data) {
          dialog(menu);
        }, function () {
          // Remove delete item
          menu.splice(3, 1);
          menu[3]['onclick'] = "app." + appname + ".mailvelopeCreateBackupDialog('#_mvelo', true)";
          dialog(menu);
        });
      }, function () {
        mailvelope.createKeyring('egroupware').then(function () {
          dialog(menu);
        });
      });
    } else {
      this.mailvelopeInstallationOffer();
    }
  }

  /**
   * Create a dialog and offers installation option for installing mailvelope plugin
   * plus it offers a video tutorials to get the user morte familiar with mailvelope
   */
  mailvelopeInstallationOffer() {
    var buttons = [{
      "text": egw.lang('Install'),
      id: 'install',
      image: 'check',
      "default": true
    }, {
      "text": egw.lang('Close'),
      id: 'close',
      image: 'cancelled'
    }];
    var dialog = function dialog(_content, _callback) {
      return et2_createWidget("dialog", {
        callback: function callback(_button_id, _value) {
          if (typeof _callback == "function") {
            _callback.call(this, _button_id, _value.value);
          }
        },
        title: egw.lang('PGP Encryption Installation'),
        buttons: buttons,
        dialog_type: 'info',
        value: {
          content: _content
        },
        template: egw.webserverUrl + '/api/templates/default/pgp_installation.xet',
        class: "pgp_installation",
        isModal: true
        //resizable:false,
      });
    };

    var content = [
    // Header row should be empty item 0
    {}, {
      domain: this.egw.lang('Add your domain as "%1" in options to list of email providers and enable API.', '*.' + this._mailvelopeDomain()),
      video: "test",
      control: "true"
    }];
    dialog(content, function (_button) {
      if (_button == 'install') {
        if (typeof chrome != 'undefined') {
          // ATM we are not able to trigger mailvelope installation directly
          // since the installation should be triggered from the extension
          // owner validate website (mailvelope.com), therefore, we just redirect
          // user to chrome webstore to install mailvelope from there.
          window.open('https://chrome.google.com/webstore/detail/mailvelope/kajibbejlbohfaggdiogboambcijhkke');
        } else if (typeof InstallTrigger != 'undefined' && InstallTrigger.enabled()) {
          InstallTrigger.install({
            mailvelope: "https://download.mailvelope.com/releases/latest/mailvelope.firefox.xpi"
          }, function (_url, _status) {
            if (_status == 0) {
              Et2Dialog$1.alert(egw.lang('Mailvelope addon installation succeded. Now you may configure the options.'));
              return;
            } else {
              Et2Dialog$1.alert(egw.lang('Mailvelope addon installation failed! Please try again.'));
            }
          });
        }
      }
    });
  }
  /**
   * Open (or create) "egroupware" keyring and call callback with it
   *
   * @returns {Promise.<Keyring, Error>} Keyring or Error with message
   */
  mailvelopeOpenKeyring() {
    var self = this;
    var mailvelope = this.egw.window.mailvelope; // use Mailvelope of correct window

    return new Promise(function (_resolve, _reject) {
      if (self.mailvelope_keyring) _resolve(self.mailvelope_keyring);
      var resolve = _resolve;
      var reject = _reject;
      mailvelope.getKeyring('egroupware').then(function (_keyring) {
        self.mailvelope_keyring = _keyring;
        resolve(_keyring);
      }, function (_err) {
        mailvelope.createKeyring('egroupware').then(function (_keyring) {
          self.mailvelope_keyring = _keyring;
          var mvelo_settings_selector = self.mailvelope_iframe_selector.split(',').map(function (_val) {
            return 'body>' + _val;
          }).join(',');
          mailvelope.createSettingsContainer('body', _keyring, {
            email: self.egw.user('account_email'),
            fullName: self.egw.user('account_fullname')
          }).then(function () {
            // make only Mailvelope settings dialog visible
            jQuery(mvelo_settings_selector).css({
              position: 'absolute',
              top: 0
            });
            // add a close button, so we know when to offer storing public key to AB
            jQuery('<button class="et2_button et2_button_text" id="mailvelope_close_settings">' + self.egw.lang('Close') + '</button>').css({
              position: 'absolute',
              top: 8,
              right: 8,
              "z-index": 2
            }).click(function () {
              // try fetching public key, to check user created onw
              self.mailvelope_keyring.exportOwnPublicKey(self.egw.user('account_email')).then(function (_pubKey) {
                // CreateBackupDialog
                self.mailvelopeCreateBackupDialog().then(function (_popupId) {
                  jQuery('iframe[src^="chrome-extension"],iframe[src^="about:blank?mvelo"]').css({
                    position: 'absolute',
                    "z-index": 1
                  });
                }, function (_err) {
                  egw.message(_err);
                });

                // if yes, hide settings dialog
                jQuery(mvelo_settings_selector).each(function (index, item) {
                  if (!item.src.match(/keyBackupDialog.html/, 'ig')) item.remove();
                });
                jQuery('button#mailvelope_close_settings').remove();

                // offer user to store his public key to AB for other users to find
                var buttons = [{
                  button_id: 2,
                  label: 'Yes',
                  id: 'dialog[yes]',
                  image: 'check',
                  default: true
                }, {
                  button_id: 3,
                  label: 'No',
                  id: 'dialog[no]',
                  image: 'cancelled'
                }];
                if (egw.user('apps').admin) {
                  buttons.unshift({
                    button_id: 5,
                    label: 'Yes and allow non-admin users to do that too (recommended)',
                    id: 'dialog[yes_allow]',
                    image: 'check',
                    default: true
                  });
                  delete buttons[1].default;
                }
                Et2Dialog$1.show_dialog(function (_button_id) {
                  if (_button_id != Et2Dialog$1.NO_BUTTON) {
                    var keys = {};
                    keys[self.egw.user('account_id')] = _pubKey;
                    self.egw.json('addressbook.addressbook_bo.ajax_set_pgp_keys', [keys, _button_id != Et2Dialog$1.YES_BUTTON ? true : undefined]).sendRequest().then(function (_data) {
                      self.egw.message(_data.response['0'].data);
                    });
                  }
                }, 'It is recommended to store your public key in addressbook, so other users can write you encrypted mails.', 'Store your public key in Addressbook?', {}, buttons, Et2Dialog$1.QUESTION_MESSAGE, undefined, self.egw);
              }, function (_err) {
                self.egw.message(_err.message + "\n\n" + self.egw.lang("You will NOT be able to send or receive encrypted mails before completing that step!"), 'error');
              });
            }).appendTo('body');
          });
          resolve(_keyring);
        }, function (_err) {
          reject(_err);
        });
      });
    });
  }

  /**
   * Mailvelope uses Domain without first part: eg. "stylite.de" for "egw.stylite.de"
   *
   * @returns {string}
   */
  _mailvelopeDomain() {
    var parts = document.location.hostname.split('.');
    if (parts.length > 1) parts.shift();
    return parts.join('.');
  }

  /**
   * Check if we have a key for all recipients
   *
   * @param {Array} _recipients
   * @returns {Promise.<Array, Error>} Array of recipients or Error with recipients without key
   */
  mailvelopeGetCheckRecipients(_recipients) {
    // replace rfc822 addresses with raw email, as Mailvelop does not like them and lowercase all email
    var rfc822_preg = /<([^'" <>]+)>$/;
    var recipients = _recipients.map(function (_recipient) {
      var matches = _recipient.match(rfc822_preg);
      return matches ? matches[1].toLowerCase() : _recipient.toLowerCase();
    });

    // check if we have keys for all recipients
    var self = this;
    return new Promise(function (_resolve, _reject) {
      var resolve = _resolve;
      var reject = _reject;
      self.mailvelopeOpenKeyring().then(function (_keyring) {
        var keyring = _keyring;
        _keyring.validKeyForAddress(recipients).then(function (_status) {
          var no_key = [];
          for (var email in _status) {
            if (!_status[email]) no_key.push(email);
          }
          if (no_key.length) {
            // server addressbook on server for missing public keys
            self.egw.json('addressbook.addressbook_bo.ajax_get_pgp_keys', [no_key]).sendRequest().then(function (_data) {
              var data = _data.response['0'].data;
              var promises = [];
              for (var email in data) {
                promises.push(keyring.importPublicKey(data[email]).then(function (_result) {
                  if (_result == 'IMPORTED' || _result == 'UPDATED') {
                    no_key.splice(no_key.indexOf(email), 1);
                  }
                }));
              }
              Promise.all(promises).then(function () {
                if (no_key.length) {
                  reject(new Error(self.egw.lang('No key for recipient:') + ' ' + no_key.join(', ')));
                } else {
                  resolve(recipients);
                }
              });
            });
          } else {
            resolve(recipients);
          }
        });
      }, function (_err) {
        reject(_err);
      });
    });
  }

  /**
   * Check if the share action is enabled for this entry
   *
   * @param {egwAction} _action
   * @param {egwActionObject[]} _entries
   * @param {egwActionObject} _target
   * @returns {boolean} if action is enabled
   */
  is_share_enabled(_action, _entries, _target) {
    return true;
  }

  /**
   * create a share-link for the given entry
   *
   * @param {egwAction} _action egw actions
   * @param {egwActionObject[]} _senders selected nm row
   * @param {egwActionObject} _target Drag source.  Not used here.
   * @param {Boolean} _writable Allow edit access from the share.
   * @param {Boolean} _files Allow access to files from the share.
   * @param {Function} _callback Callback with results
   * @param {Object} _extra Additional (app-specific or special) parameters
   * @returns {Boolean} returns false if not successful
   */
  share_link(_action, _senders, _target, _writable, _files, _callback, _extra) {
    var path = _senders[0].id;
    if (!path) {
      return this.egw.message(this.egw.lang('Missing share path.  Unable to create share.'), 'error');
    }
    switch (_action.id) {
      case 'shareFilemanager':
        // Sharing a link to just files in filemanager
        var id = path.split('::');
        path = '/apps/' + id[0] + '/' + id[1];
    }
    if (typeof _writable === 'undefined' && _action.parent && _action.parent.getActionById('shareWritable')) {
      _writable = _action.parent.getActionById('shareWritable').checked || false;
    }
    if (typeof _files === 'undefined' && _action.parent && _action.parent.getActionById('shareFiles')) {
      _files = _action.parent.getActionById('shareFiles').checked || false;
    }
    if (typeof _extra === 'undefined') {
      _extra = {};
    }
    return egw.json('EGroupware\\Api\\Sharing::ajax_create', [_action.id, path, _writable, _files, _extra], _callback ? _callback : this._share_link_callback, this, true, this).sendRequest();
  }
  share_merge(_action, _senders, _target) {
    var parent = _action.parent.parent;
    var _writable = false;
    var _files = false;
    if (parent && parent.getActionById('shareWritable')) {
      _writable = parent.getActionById('shareWritable').checked || false;
    }
    if (parent && parent.getActionById('shareFiles')) {
      _files = parent.getActionById('shareFiles').checked || false;
    }

    // Share only works on one at a time
    var promises = [];
    for (var i = 0; i < _senders.length; i++) {
      promises.push(new Promise(function (resolve, reject) {
        this.share_link(_action, [_senders[i]], _target, _writable, _files, resolve);
      }.bind(this)));
    }

    // But merge into email can handle several
    Promise.all(promises.map(function (p) {
      p.catch(function (e) {
        console.log(e);
      });
    })).then(function (values) {
      // Process document after all shares created
      return nm_action(_action, _senders, _target);
    });
  }

  /**
   * Share-link callback
   * @param {object} _data
   */
  _share_link_callback(_data) {
    if (_data.msg || _data.share_link) window.egw_refresh(_data.msg, this.appname);
    var copy_link_to_clipboard = function copy_link_to_clipboard(evt) {
      var $target = jQuery(evt.target);
      $target.select();
      try {
        var successful = document.execCommand('copy');
        if (successful) {
          egw.message('Share link copied into clipboard');
          return true;
        }
      } catch (e) {}
      egw.message('Failed to copy the link!');
    };
    jQuery("body").on("click", "[name=share_link]", copy_link_to_clipboard);
    et2_createWidget("dialog", {
      callback: function callback(button_id, value) {
        jQuery("body").off("click", "[name=share_link]", copy_link_to_clipboard);
        return true;
      },
      title: _data.title ? _data.title : egw.lang("%1 Share Link", _data.writable ? egw.lang("Writable") : egw.lang("Readonly")),
      template: _data.template,
      width: 450,
      value: {
        content: {
          "share_link": _data.share_link
        }
      }
    });
  }

  /**
   * Keep a list of all EgwApp instances
   *
   * This is not just the globals available in window.app, it also includes private instances as well
   *
   * @private
   * @param app_obj
   */
  static _register_instance(app_obj) {
    // Reject improper objects
    if (!app_obj.appname) return;
    EgwApp._instances.push(app_obj);
  }

  /**
   * Iterator over all app instances
   *
   * Use for(const app of EgwApp) {...} to iterate over all app objects.
   */
  static [_Symbol$iterator]() {
    return EgwApp._instances[Symbol.iterator]();
  }
}

// EgwApp need to be global on window, as it's used to iterate through all EgwApp instances
_class$6 = EgwApp;
/**
 * In some cases (CRM) a private, disconnected app instance is created instead of
 * using the global.  We want to be able to access them for observer() & push(), so
 * we track all instances.
 */
_defineProperty$1t(EgwApp, "_instances", []);
window.EgwApp = EgwApp;

var _templateObject$$, _templateObject2$A, _templateObject3$j, _templateObject4$c, _templateObject5$a;
function _taggedTemplateLiteral$$(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
/**
 * @summary A basic wrapper to group other widgets
 *
 * @slot - Any other widget
 */
class Et2Box extends Et2Widget(s$5) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$$ || (_templateObject$$ = _taggedTemplateLiteral$$(["\n            :host {\n\t\t\t\tdisplay: block;\n            }\n            :host > div {\n            \tdisplay: flex;\n            \tflex-wrap: nowrap;\n            \tjustify-content: flex-start;\n            \talign-items: stretch;\n            \tgap: 5px;\n            \theight: 100%;\n\t\t\t}\n\t\t\t:host([align=\"right\"]) > div {\n\t\t\t\tjustify-content: flex-end;\n\t\t\t}\n\t\t\t:host([align=\"left\"]) > div {\n\t\t\t\tjustify-content: flex-start;\n\t\t\t}\n\t\t\t:host([align=\"center\"]) > div {\n\t\t\t\tjustify-content: center;\n\t\t\t}\n\t\t\t/* CSS for child elements */\n            ::slotted(*) {\n            \tflex: 1 1 auto;\n            }\n            ::slotted(img),::slotted(et2-image) {\n            \t/* Stop images from growing.  In general we want them to stay */\n            \tflex-grow: 0;\n            }\n            ::slotted([align=\"left\"]) {\n            \tmargin-right: auto;\n            \torder: -1;\n            }\n            ::slotted([align=\"right\"]) {\n            \tmargin-left: auto;\n            \torder: 1;\n            }\n            \n            /* work around for chromium print bug, see render() */\n            :host > .no-print-gap {\n            \tgap: 0px;\n            }\n            "])))];
  }
  render() {
    /**
     * Work around Chromium bug
     * https://bugs.chromium.org/p/chromium/issues/detail?id=1161709
     *
     * Printing with gap on empty element gives huge print output
     */
    var noGap = false;
    if (this.querySelectorAll(":scope > :not([disabled])").length == 0) {
      noGap = true;
    }
    return x$1(_templateObject2$A || (_templateObject2$A = _taggedTemplateLiteral$$(["\n            <div part=\"base\" ", " class=", ">\n                <slot></slot>\n            </div> "])), this.id ? x$1(_templateObject3$j || (_templateObject3$j = _taggedTemplateLiteral$$(["id=\"", "\""])), this.id) : '', o$9({
      "no-print-gap": noGap
    }));
  }
  set_label(new_label) {
    // Boxes don't have labels
  }
  _createNamespace() {
    return true;
  }

  /**
   * Code for implementing et2_IDetachedDOM
   *
   * Individual widgets are detected and handled by the grid, but the interface is needed for this to happen
   *
   * @param {array} _attrs array to add further attributes to
   */
  getDetachedAttributes(_attrs) {
    _attrs.push('data', 'onclick');
  }
  getDetachedNodes() {
    return [this.getDOMNode()];
  }
  setDetachedAttributes(_nodes, _values) {
    if (_values.data) {
      this.data = _values.data;
    }
  }
}
customElements.define("et2-box", Et2Box);
class Et2HBox extends Et2Box {
  static get styles() {
    return [...super.styles, i$b(_templateObject4$c || (_templateObject4$c = _taggedTemplateLiteral$$(["\n            :host > div {\n            \tflex-direction: row;\n\t\t\t}"])))];
  }
}
customElements.define("et2-hbox", Et2HBox);

/**
 * @summary Vertically align child widgets
 *
 * This box includes styling to stop children from growing vertically.
 * Set css```flex-grow: 1``` on the child to allow it to grow.
 *
 * @slot - Any other widget
 */
class Et2VBox extends Et2Box {
  static get styles() {
    return [...super.styles, i$b(_templateObject5$a || (_templateObject5$a = _taggedTemplateLiteral$$(["\n\t\t\t  :host > div {\n\t\t\t\tflex-direction: column;\n\t\t\t  }\n\n\t\t\t  :host([align=\"center\"]) > div {\n\t\t\t\talign-items: center;\n\t\t\t  }\n\n\t\t\t  /* CSS for child elements */\n\n\t\t\t  ::slotted(*) {\n\t\t\t\t/* Stop children from growing vertically.  In general we want them to stay their \"normal\" height */\n\t\t\t\tflex-grow: 0;\n\t\t\t  }\n\n\t\t\t"])))];
  }
}
customElements.define("et2-vbox", Et2VBox);

var _templateObject$_;
function ownKeys$M(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$M(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$M(Object(source), true).forEach(function (key) { _defineProperty$1s(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$M(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1s(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$_(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Details extends Et2Widget(details_default) {
  static get styles() {
    return [...super.styles, shoelace, i$b(_templateObject$_ || (_templateObject$_ = _taggedTemplateLiteral$_(["\n            :host {\n\t\t\t\tdisplay: block;\n            }\n            \n\t\t\t:host([align=\"right\"]) > div {\n\t\t\t\tjustify-content: flex-end;\n\t\t\t}\n\t\t\t:host([align=\"left\"]) > div {\n\t\t\t\tjustify-content: flex-start;\n\t\t\t}\n\t\t\t/* CSS for child elements */\n            ::slotted(*) {\n            \tflex: 1 1 auto;\n            }\n            ::slotted(img),::slotted(et2-image) {\n            \t/* Stop images from growing.  In general we want them to stay */\n            \tflex-grow: 0;\n            }\n            ::slotted([align=\"left\"]) {\n            \tmargin-right: auto;\n            \torder: -1;\n            }\n            ::slotted([align=\"right\"]) {\n            \tmargin-left: auto;\n            \torder: 1;\n            }\n\n              .details.hoist {\n                position: relative;\n              }\n\n              .details.hoist .details__body {\n                position: absolute;\n                z-index: var(--sl-z-index-drawer);\n                background: var(--sl-color-neutral-0);\n                box-shadow: var(--sl-shadow-large);\n                width: 100%;\n                min-width: fit-content;\n                border-radius: var(--sl-border-radius-small);\n                border: 1px solid var(--sl-color-neutral-200);\n                max-height: 15em;\n                overflow-y: auto;\n              }\n              .details.hoist .details__body.overlaySummaryLeftAligned {\n\t\t\t\ttop: 0;\n\t\t\t\tleft: 2em;\n\t\t\t\twidth: calc(100% - 2em);\n\t\t\t  }\n              .details.hoist .details__body.overlaySummaryRightAligned {\n                top: 0;\n              }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$M(_objectSpread$M({}, super.properties), {}, {
      /**
       * Toggle when hover over
       */
      toggleOnHover: {
        type: Boolean
      },
      /**
       * Makes details content fixed position to break out of the container
       */
      hoist: {
        type: Boolean
      },
      /**
       * set toggle alignment either to left or right. Default is right alignment.
       */
      toggleAlign: {
        type: String
      },
      /**
       * Overlay summary container with the details container when in open state
       */
      overlaySummaryOnOpen: {
        type: Boolean
      }
    });
  }

  /**
   * List of properties that get translated
   * Done separately to not interfere with properties - if we re-define label property,
   * labels go missing.
   */
  static get translate() {
    return _objectSpread$M(_objectSpread$M({}, super.translate), {}, {
      summary: true
    });
  }
  constructor() {
    super();
    this.toggleOnHover = false;
    this.toggleAlign = 'right';
    this.hoist = false;
    this.overlaySummaryOnOpen = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateComplete.then(() => {
      if (this.toggleOnHover) {
        this.addEventListener("mouseover", this.show);
        window.document.addEventListener('mouseout', this._mouseOutEvent.bind(this));
      }
      if (this.hoist) {
        this.shadowRoot.querySelector('.details').classList.add('hoist');
      }
      if (this.toggleAlign === 'left') {
        this.shadowRoot.querySelector('.details__summary-icon').style.order = -1;
      }
      if (this.overlaySummaryOnOpen) {
        this.shadowRoot.querySelector('.details__body').classList.add(this.toggleAlign === 'left' ? 'overlaySummaryLeftAligend' : 'overlaySummaryRightAligned');
      }
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    window.document.removeEventListener('mouseout', this._mouseOutEvent);
  }

  /**
   * Handle mouse out event for hiding out details
   * @param event
   */
  _mouseOutEvent(event) {
    if (!this.getDOMNode().contains(event.relatedTarget)) this.hide();
  }
}
customElements.define("et2-details", Et2Details);

var _templateObject$Z;
function ownKeys$L(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$L(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$L(Object(source), true).forEach(function (key) { _defineProperty$1r(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$L(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1r(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$Z(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Tab extends Et2Widget(tab_default) {
  static get styles() {
    return [...super.styles, ...shoelace, i$b(_templateObject$Z || (_templateObject$Z = _taggedTemplateLiteral$Z(["\n\t\t\t\t.tab {\n\t\t\t\t\tfont-size: var(--sl-size-x-small);\n\t\t\t\t}\n\t\t\t\t.tab.tab--active:not(.tab--disabled) {color:var(--sl-color-gray-800)}\n\t\t\t\t.tab:hover:not(.tab--disabled) {color:var(--sl-color-gray-800)}\t\t\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$L(_objectSpread$L({}, super.properties), {}, {
      hidden: {
        type: Boolean,
        reflect: true
      }
    });
  }
  constructor() {
    super();
    this.hidden = false;
  }
}
customElements.define("et2-tab", Et2Tab);

var _templateObject$Y;
function _taggedTemplateLiteral$Y(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var colorsDefStyles = i$b(_templateObject$Y || (_templateObject$Y = _taggedTemplateLiteral$Y(["\n\t:host {\n\t\t\n\t\t/****** colors ************/\n\t\t--gray_100 : #000000;\n\t\t--gray_90 : #1E1E1E;\n\t\t--gray_80 : #373737;\n\t\t--gray_70 : #505050;\n\t\t--gray_60 : #696969;\n\t\t--gray_50 : #828282;\n\t\t--gray_40 : #9B9B9B;\n\t\t--gray_30 : #B4B4B4;\n\t\t--gray_20 : #CDCDCD;\n\t\t--gray_10 : #E6E6E6;\n\t\t--gray_5 : #F2F2F2;\n\t\t--gray_0 : #FFFFFF;\n\t\t\n\t\t--btn-label-color: #000000;\n\t\t\n\t\t\n\t\t/****** Backgrounds *******/\n\t\t--bg_color_0_gray : #FFFFFF;\n\t\t--bg_color_5_gray : #FAFAFA;\n\t\t--bg_color_10_gray : #F0F0F0;\n\t\t--bg_color_15_gray : #D9D9D9;\n\t\t--bg_color_20_gray : #CCCCCC;\n\t\t--bg_color_25_gray : #BFBFBF;\n\t\t--bg_color_30_gray : #B3B3B3;\n\t\t--bg_color_40_gray : #999999;\n\t\t--bg_color_50_gray : #808080;\n\t\t\n\t\t--row_hover : rgba(153,204,255,.4);\n\t}\n"])));

var _templateObject$X;
function ownKeys$K(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$K(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$K(Object(source), true).forEach(function (key) { _defineProperty$1q(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$K(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$X(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1q(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Tabs extends Et2InputWidget(tab_group_default) {
  static get styles() {
    return [...super.styles, colorsDefStyles, ...shoelace, i$b(_templateObject$X || (_templateObject$X = _taggedTemplateLiteral$X(["\n\t\t\t.tab-group--top {\n\t\t\t\theight: 100%;\n\t\t\t\tmin-height: fit-content;\n\t\t\t}\n\t\t\t.tab-group__body {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\toverflow: hidden auto;\n\t\t\t}\n\t\t\t.tab-group__body-fixed-height {\n\t\t\t\tflex: 0 0 auto;\n\t\t\t}\n\t\t\t::slotted([hidden]) {\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\t::slotted(et2-tab-panel) {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t}\n\t\t\t::slotted(et2-tab-panel:not([active])) {\n    \t\t\tdisplay: none;\n\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$K(_objectSpread$K({}, super.properties), {}, {
      /**
       * Array of [extra] tabs.
       * Each tab needs {label:..., template:...}.
       * Additional optional keys are prepend, hidden and id, for access into content array
       */
      extraTabs: {
        type: Object
      },
      /**
       * Add tabs to template
       * Set to true if tabs specified in tabs property should be added to tabs read from template,
       * default false if not which replaces what's in template
       */
      addTabs: {
        type: Boolean
      },
      /**
       * Set the height for tabs
       * Leave unset to size automatically
       */
      tabHeight: {
        type: String
      },
      /**
       * @deprecated use "placement" instead
       * @see https://shoelace.style/components/tab-group
       */
      alignTabs: {
        type: String
      },
      /**
       * active tab is the value
       */
      value: {
        type: String
      }
    });
  }

  /**
   * Index of currently selected tab
   * @type {number}
   * @private
   */

  constructor() {
    super();
    _defineProperty$1q(this, "_selectedIndex", -1);
    _defineProperty$1q(this, "tabData", []);
    _defineProperty$1q(this, "lazyLoaded", false);
    this.extraTabs = [];
    this.addTabs = false;
    if (egwIsMobile()) {
      this.placement = 'end';
    }
  }
  get value() {
    var _this$getActiveTab;
    return (_this$getActiveTab = this.getActiveTab()) === null || _this$getActiveTab === void 0 ? void 0 : _this$getActiveTab.panel;
  }
  set value(tab) {
    if (this.tabs && Array.isArray(this.tabs) && this.tabs.length) {
      this.show(this.__value = tab);
    } else {
      this.__value = tab;
    }
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateComplete.then(() => {
      if (this.__value) {
        this.show(this.__value);
      }
    });
  }
  isDirty() {
    return false;
  }
  loadFromXML(_node) {
    // Get the tabs and tabpanels tags
    var tabsElems = et2_directChildrenByTagName(_node, "tabs");
    var tabpanelsElems = et2_directChildrenByTagName(_node, "tabpanels");
    var tabData = [];

    // Check for a parent height, we'll apply it to tab panels
    var height = et2_readAttrWithDefault(_node.parentNode, "height", null);
    if (height && !this.tabHeight) {
      this.tabHeight = height;
    }

    // if no tabs set or they should be added to tabs from xml
    if (!this.extraTabs || this.extraTabs.length == 0 || this.addTabs) {
      if (tabsElems.length == 1 && tabpanelsElems.length == 1) {
        var tabs = tabsElems[0];
        var tabpanels = tabpanelsElems[0];

        // Parse the "tabs" tag
        this._readTabs(tabData, tabs);

        // Read and create the widgets defined in the "tabpanels"
        this._readTabPanels(tabData, tabpanels);
      } else {
        this.egw().debug("error", "Error while parsing tabbox, none or multiple tabs or tabpanels tags!", this);
      }
    }
    // Add in additional tabs
    if (this.extraTabs) {
      var readonly = this.getArrayMgr("readonlys").getEntry(this.id) || {};
      for (var i = 0; i < this.extraTabs.length; i++) {
        var tab = this.extraTabs[i];
        var tab_id = tab.id || tab.template;
        var tab_options = {
          id: tab_id,
          template: tab.template,
          url: tab.url,
          content: undefined
        };
        if (tab.id) {
          tab_options.content = tab.id;
        }
        tabData[tab.prepend ? 'unshift' : 'push'].call(tabData, {
          "id": tab_id,
          "label": this.egw().lang(tab.label),
          "widget": null,
          "widget_options": tab_options,
          "contentDiv": null,
          "flagDiv": null,
          "hidden": typeof tab.hidden != "undefined" ? tab.hidden : readonly[tab_id] || false,
          "XMLNode": null,
          "promise": null
        });
      }
    }

    // Create the tab DOM-Nodes
    this.createTabs(tabData);
  }
  _readTabs(tabData, tabs) {
    var selected = "";
    this._selectedIndex = -1;
    var hidden = {};
    if (this.id) {
      // Set the value for this element
      var contentMgr = this.getArrayMgr("content");
      if (contentMgr != null) {
        var val = contentMgr.getEntry(this.id);
        if (val !== null) {
          selected = val;
        }
      }
      contentMgr = this.getArrayMgr("readonlys");
      if (contentMgr != null) {
        var _val = contentMgr.getEntry(this.id);
        if (_val !== null && typeof _val !== 'undefined') {
          hidden = _val;
        }
      }
    }
    var i = 0;
    et2_filteredNodeIterator(tabs, function (node, nodeName) {
      if (nodeName == "tab") {
        var index_name = et2_readAttrWithDefault(node, "id", '');
        var hide = false;
        var widget_options = {};
        if (index_name) {
          if (selected == index_name) {
            this.selected_index = i;
          }
          if (hidden[index_name]) {
            hide = true;
          }
          // Get the class attribute and add it as widget_options
          var classAttr = et2_readAttrWithDefault(node, "class", '');
          if (classAttr) {
            widget_options = {
              'class': classAttr
            };
          }
        }
        tabData.push({
          "id": index_name,
          "label": this.egw().lang(et2_readAttrWithDefault(node, "label", "Tab")),
          "widget": null,
          "widget_options": widget_options,
          "contentDiv": null,
          "flagDiv": null,
          "hidden": hide,
          "XMLNode": null,
          "promise": null
        });
      } else {
        throw "Error while parsing: Invalid tag '" + nodeName + "' in tabs tag";
      }
      i++;
    }, this);

    // Make sure we don't try to display a hidden tab
    for (var _i = 0; _i < tabData.length && this._selectedIndex < 0; _i++) {
      if (!tabData[_i].hidden) {
        this._selectedIndex = _i;
      }
    }
  }
  _readTabPanels(tabData, tabpanels) {
    var i = 0;
    et2_filteredNodeIterator(tabpanels, function (node, nodeName) {
      if (i < tabData.length) {
        // Store node for later evaluation
        tabData[i].XMLNode = node;
      } else {
        throw "Error while reading tabpanels tag, too many widgets!";
      }
      i++;
    }, this);
  }
  update(changedProperties) {
    super.update(changedProperties);
    if (changedProperties.has("tabHeight")) {
      var body = this.shadowRoot.querySelector(".tab-group__body");
      if (body) {
        body.style.setProperty("height", this.tabHeight == parseInt(this.tabHeight) + "" ? this.tabHeight + "px" : this.tabHeight);
        body.classList.toggle("tab-group__body-fixed-height", this.tabHeight !== '');
      }
    }
  }

  /**
   * Create the nodes for tabs
   *
   * @param tabData
   * @protected
   */
  createTabs(tabData) {
    this.tabData = tabData;
    tabData.forEach((tab, index) => {
      // Tab - SlTabGroup looks for sl-tab, so we can't use our own without overriding a lot
      tab.flagDiv = loadWebComponent("et2-tab", {
        slot: "nav",
        panel: tab.id,
        active: index == this._selectedIndex,
        hidden: tab.hidden
      }, this);

      // Set tab label
      tab.flagDiv.appendChild(document.createTextNode(tab.label));
    });
    tabData.forEach((tab, index) => {
      this.createPanel(tab);
    });
  }
  createPanel(tab) {
    var active = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    // Tab panel
    tab.contentDiv = loadWebComponent('et2-tab-panel', {
      id: tab.id,
      name: tab.id,
      active: active,
      hidden: tab.hidden,
      // Set readonly so it gets passed on to children
      readonly: tab.hidden
    }, this);

    // Tab content
    if (tab.XMLNode) {
      // Just read the XMLNode
      var tabContent = tab.contentDiv.createElementFromNode(tab.XMLNode);
      tab.contentDiv.appendChild(typeof window.customElements.get(tab.XMLNode.nodeName) == "undefined" ? tabContent.getDOMNode() : tabContent);
    } else {
      et2_createWidget('template', tab.widget_options, tab.contentDiv);
    }
    return tab.contentDiv;
  }
  getAllTabs() {
    var includeDisabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var slot = this.shadowRoot.querySelector('slot[name="nav"]');
    var tabNames = ["sl-tab", "et2-tab"];
    return [...slot.assignedElements()].filter(el => {
      return includeDisabled ? tabNames.indexOf(el.tagName.toLowerCase()) != -1 : tabNames.indexOf(el.tagName.toLowerCase()) !== -1 && !el.disabled;
    });
  }

  /**
   * Overridden to allow et2-tab-panel as well as sl-tab-panel
   *
   * @returns {[SlTabPanel]}
   */
  getAllPanels() {
    var slot = this.body;
    return [...slot.assignedElements()].filter(el => ['et2-tab-panel', 'sl-tab-panel'].indexOf(el.tagName.toLowerCase()) != -1);
  }
  handleClick(event) {
    var target = event.target;
    var tab = target.closest('et2-tab');
    var tabGroup = (tab === null || tab === void 0 ? void 0 : tab.closest('sl-tab-group')) || (tab === null || tab === void 0 ? void 0 : tab.closest('et2-tabbox'));

    // Ensure the target tab is in this tab group
    if (tabGroup !== this) {
      return;
    }
    if (tab !== null) {
      this.setActiveTab(tab, {
        scrollBehavior: 'smooth'
      });
    }
  }

  /**
   * Keyboard navigation
   * Copy + Paste from parent due to tagname differences (sl-tab vs et2-tab)
   *
   * @param event
   */
  handleKeyDown(event) {
    var target = event.target;
    var tab = target.closest("et2-tab");
    var tabGroup = tab == null ? void 0 : tab.closest("et2-tabbox");
    if (tabGroup !== this) {
      return;
    }
    if (["Enter", " "].includes(event.key)) {
      if (tab !== null) {
        this.setActiveTab(tab, {
          scrollBehavior: "smooth"
        });
        event.preventDefault();
      }
    }
    if (["ArrowLeft", "ArrowRight", "ArrowUp", "ArrowDown", "Home", "End"].includes(event.key)) {
      var activeEl = document.activeElement;
      var isRtl = this.localize.dir() === "rtl";
      if ((activeEl == null ? void 0 : activeEl.tagName.toLowerCase()) === "et2-tab") {
        var index = this.tabs.indexOf(activeEl);
        if (event.key === "Home") {
          index = 0;
        } else if (event.key === "End") {
          index = this.tabs.length - 1;
        } else if (["top", "bottom"].includes(this.placement) && event.key === (isRtl ? "ArrowRight" : "ArrowLeft") || ["start", "end"].includes(this.placement) && event.key === "ArrowUp") {
          index--;
        } else if (["top", "bottom"].includes(this.placement) && event.key === (isRtl ? "ArrowLeft" : "ArrowRight") || ["start", "end"].includes(this.placement) && event.key === "ArrowDown") {
          index++;
        }
        if (index < 0) {
          index = this.tabs.length - 1;
        }
        if (index > this.tabs.length - 1) {
          index = 0;
        }
        this.tabs[index].focus({
          preventScroll: true
        });
        if (this.activation === "auto") {
          this.setActiveTab(this.tabs[index], {
            scrollBehavior: "smooth"
          });
        }
        if (["top", "bottom"].includes(this.placement)) {
          scrollIntoView(this.tabs[index], this.nav, "horizontal");
        }
        event.preventDefault();
      }
    }
  }
  /**
   * Set up for printing
   *
   * @return {undefined|Deferred} Return a jQuery Deferred object if not done setting up
   *  (waiting for data)
   */
  beforePrint() {
    // Remove the "active" flag from all tabs-flags
    this.querySelector("[active]").removeAttribute("active");

    // Remove height limit
    this.style.height = '';

    // Show all enabled tabs
    for (var i = 0; i < this.tabData.length; i++) {
      var entry = this.tabData[i];
      if (entry.hidden) {
        continue;
      }
      entry.flagDiv.insertBefore(entry.contentDiv);
      entry.contentDiv.show();
    }
  }

  /**
   * Reset after printing
   */
  afterPrint() {
    this.setActiveTab(this._selectedIndex);
  }

  /**
   * Activate the tab containing the given widget
   *
   * @param {et2_widget} widget
   * @return {bool} widget was found in a tab
   */
  activateTab(widget) {
    var tab = widget;
    while (tab._parent && tab._parent.nodeName !== 'ET2-TABBOX') {
      tab = tab._parent;
    }
    if (tab.nodeName === 'ET2-TAB-PANEL') {
      this.show(tab.name);
      return true;
    }
    return false;
  }

  /**
   * Reimplement to allow our existing function signatures too
   *
   * @deprecated use this.show(name : string)
   * @param tab number or name of tab (Sl uses that internally with a SlTab!)
   * @param options
   */
  setActiveTab(tab, options) {
    if (typeof tab === 'number') {
      tab = this.getAllTabs()[tab];
      return this.show(tab.panel);
    }
    if (typeof tab === 'string') {
      return this.show(tab);
    }
    return super.setActiveTab(tab, options);
  }
  resize(_height) {
    if (_height) {
      this.tabHeight = parseInt(this.tabHeight) + parseInt(_height);
    }
  }
}
customElements.define("et2-tabbox", Et2Tabs);

var _templateObject$W;
function ownKeys$J(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$J(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$J(Object(source), true).forEach(function (key) { _defineProperty$1p(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$J(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1p(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$W(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2TabPanel extends Et2Widget(tab_panel_default) {
  static get styles() {
    return [
    // @ts-ignore
    ...super.styles, ...shoelace, i$b(_templateObject$W || (_templateObject$W = _taggedTemplateLiteral$W(["\n\t\t\t:host {\n\t\t\t\n\t\t\t\theight: 100%;\n\t\t\t\t/*\n\t\t\t\twidth: 100%;\n\t\t\t\t\n\t\t\t\tmin-height: fit-content;\n\t\t\t\tmin-width: fit-content;\n\t\t\t\t*/\n\t\t\t}\n\t\t\t.tab-panel {\n\t\t\t\theight: 100%;\n\t\t\t}\n\t\t\t::slotted(*) {\n\t\t\t\theight: 100%;\n\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$J(_objectSpread$J({}, super.properties), {}, {
      hidden: {
        type: Boolean,
        reflect: true
      }
    });
  }
  constructor() {
    super();
    this.hidden = false;
  }
}
customElements.define("et2-tab-panel", Et2TabPanel);

var _templateObject$V, _templateObject2$z;
function _taggedTemplateLiteral$V(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
/**
 * Widget to render tabs in a mobile-friendly way
 *
 * We render tabs as a series of details instead of normal tabs.
 * loadWebComponent() will load this component instead of Et2Tabs on mobile browsers
 */
class Et2TabsMobile extends Et2Tabs {
  connectedCallback() {
    super.connectedCallback();
  }
  createTabs(tabData) {
    // "Tabs" are created in render()
    this.tabData = tabData;

    // Create tab panels here though
    tabData.forEach((tab, index) => {
      var panel = this.createPanel(tab, true);
      panel.slot = tab.id;
    });
  }
  getAllTabs() {
    var includeDisabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var slot = this.shadowRoot.querySelectorAll('et2-details');
    var tabNames = ["et2-details"];

    // It's really not a list of SlTab...
    return [...slot].filter(el => {
      return includeDisabled ? tabNames.indexOf(el.tagName.toLowerCase()) != -1 : tabNames.indexOf(el.tagName.toLowerCase()) !== -1 && !el.disabled;
    });
  }
  getAllPanels() {
    var slot = this.querySelector('slot');
    return [...this.querySelectorAll('et2-tab-panel')];
  }
  syncIndicator() {
    // Don't have an indicator to sync
  }
  repositionIndicator() {
    // Don't have an indicator to reposition
  }
  preventIndicatorTransition() {
    // Don't have an indicator
  }

  /**
   * Reimplement to allow our existing function signatures too
   *
   * @deprecated use this.show(name : string)
   * @param tab number or name of tab (Sl uses that internally with a SlTab!)
   * @param options
   */
  setActiveTab(tab, options) {
    if (typeof tab === 'number') {
      tab = this.getAllTabs()[tab];
      return this.show(tab.panel);
    }
    if (typeof tab === 'string') {
      return this.show(tab);
    }
    // Don't call super, it hides tab content
  }

  get nav() {
    return this.shadowRoot.querySelector("et2-vbox");
  }
  tabTemplate(tab, index) {
    return x$1(_templateObject$V || (_templateObject$V = _taggedTemplateLiteral$V(["\n            <et2-details\n                    id=\"", "\"\n                    summary=\"", "\"\n                    ?open=", "\n                    ?disabled=", "\n                    ?hidden=", "\n            >\n                <slot name=\"", "\"/>\n            </et2-details>"])), tab.id, tab.label, index == this._selectedIndex, tab.disabled, tab.hidden, tab.id);
  }
  render() {
    return x$1(_templateObject2$z || (_templateObject2$z = _taggedTemplateLiteral$V(["\n            <et2-vbox\n                    part=\"base\"\n                    class=", "\n                    @click=", "\n                    @keydown=", "\n            >\n                ", "\n                <slot>\n            </et2-vbox>\n\t\t"])), o$9({
      'tab-group': true,
      'tab-group-mobile': true,
      // Get styling as if it were top
      'tab-group--top': true
    }), this.handleClick, this.handleKeyDown, c$2(this.tabData, this.tabTemplate.bind(this)));
  }
}
if (typeof customElements.get("et2-tabbox_mobile") == "undefined") {
  customElements.define("et2-tabbox_mobile", Et2TabsMobile);
}

var _templateObject$U;
function _taggedTemplateLiteral$U(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/*!
 * Cropper.js v1.5.12
 * https://fengyuanchen.github.io/cropperjs
 *
 * Copyright 2015-present Chen Fengyuan
 * Released under the MIT license
 *
 * Date: 2021-06-12T08:00:11.623Z
 */
var cropperStyles = i$b(_templateObject$U || (_templateObject$U = _taggedTemplateLiteral$U(["\n.cropper-container {\n\tdirection: ltr;\n\tfont-size: 0;\n\tline-height: 0;\n\tposition: relative;\n\t-ms-touch-action: none;\n\ttouch-action: none;\n\t-webkit-user-select: none;\n\t-moz-user-select: none;\n\t-ms-user-select: none;\n\tuser-select: none;\n}\n\n.cropper-container img {\n\tdisplay: block;\n\theight: 100%;\n\timage-orientation: 0deg;\n\tmax-height: none !important;\n\tmax-width: none !important;\n\tmin-height: 0 !important;\n\tmin-width: 0 !important;\n\twidth: 100%;\n}\n\n.cropper-wrap-box,\n.cropper-canvas,\n.cropper-drag-box,\n.cropper-crop-box,\n.cropper-modal {\n\tbottom: 0;\n\tleft: 0;\n\tposition: absolute;\n\tright: 0;\n\ttop: 0;\n}\n\n.cropper-wrap-box,\n.cropper-canvas {\n\toverflow: hidden;\n}\n\n.cropper-drag-box {\n\tbackground-color: #fff;\n\topacity: 0;\n}\n\n.cropper-modal {\n\tbackground-color: #000;\n\topacity: 0.5;\n}\n\n.cropper-view-box {\n\tdisplay: block;\n\theight: 100%;\n\toutline: 1px solid #39f;\n\toutline-color: rgba(51, 153, 255, 0.75);\n\toverflow: hidden;\n\twidth: 100%;\n}\n\n.cropper-dashed {\n\tborder: 0 dashed #eee;\n\tdisplay: block;\n\topacity: 0.5;\n\tposition: absolute;\n}\n\n.cropper-dashed.dashed-h {\n\tborder-bottom-width: 1px;\n\tborder-top-width: 1px;\n\theight: calc(100% / 3);\n\tleft: 0;\n\ttop: calc(100% / 3);\n\twidth: 100%;\n}\n\n.cropper-dashed.dashed-v {\n\tborder-left-width: 1px;\n\tborder-right-width: 1px;\n\theight: 100%;\n\tleft: calc(100% / 3);\n\ttop: 0;\n\twidth: calc(100% / 3);\n}\n\n.cropper-center {\n\tdisplay: block;\n\theight: 0;\n\tleft: 50%;\n\topacity: 0.75;\n\tposition: absolute;\n\ttop: 50%;\n\twidth: 0;\n}\n\n.cropper-center::before,\n.cropper-center::after {\n\tbackground-color: #eee;\n\tcontent: ' ';\n\tdisplay: block;\n\tposition: absolute;\n}\n\n.cropper-center::before {\n\theight: 1px;\n\tleft: -3px;\n\ttop: 0;\n\twidth: 7px;\n}\n\n.cropper-center::after {\n\theight: 7px;\n\tleft: 0;\n\ttop: -3px;\n\twidth: 1px;\n}\n\n.cropper-face,\n.cropper-line,\n.cropper-point {\n\tdisplay: block;\n\theight: 100%;\n\topacity: 0.1;\n\tposition: absolute;\n\twidth: 100%;\n}\n\n.cropper-face {\n\tbackground-color: #fff;\n\tleft: 0;\n\ttop: 0;\n}\n\n.cropper-line {\n\tbackground-color: #39f;\n}\n\n.cropper-line.line-e {\n\tcursor: ew-resize;\n\tright: -3px;\n\ttop: 0;\n\twidth: 5px;\n}\n\n.cropper-line.line-n {\n\tcursor: ns-resize;\n\theight: 5px;\n\tleft: 0;\n\ttop: -3px;\n}\n\n.cropper-line.line-w {\n\tcursor: ew-resize;\n\tleft: -3px;\n\ttop: 0;\n\twidth: 5px;\n}\n\n.cropper-line.line-s {\n\tbottom: -3px;\n\tcursor: ns-resize;\n\theight: 5px;\n\tleft: 0;\n}\n\n.cropper-point {\n\tbackground-color: #39f;\n\theight: 5px;\n\topacity: 0.75;\n\twidth: 5px;\n}\n\n.cropper-point.point-e {\n\tcursor: ew-resize;\n\tmargin-top: -3px;\n\tright: -3px;\n\ttop: 50%;\n}\n\n.cropper-point.point-n {\n\tcursor: ns-resize;\n\tleft: 50%;\n\tmargin-left: -3px;\n\ttop: -3px;\n}\n\n.cropper-point.point-w {\n\tcursor: ew-resize;\n\tleft: -3px;\n\tmargin-top: -3px;\n\ttop: 50%;\n}\n\n.cropper-point.point-s {\n\tbottom: -3px;\n\tcursor: s-resize;\n\tleft: 50%;\n\tmargin-left: -3px;\n}\n\n.cropper-point.point-ne {\n\tcursor: nesw-resize;\n\tright: -3px;\n\ttop: -3px;\n}\n\n.cropper-point.point-nw {\n\tcursor: nwse-resize;\n\tleft: -3px;\n\ttop: -3px;\n}\n\n.cropper-point.point-sw {\n\tbottom: -3px;\n\tcursor: nesw-resize;\n\tleft: -3px;\n}\n\n.cropper-point.point-se {\n\tbottom: -3px;\n\tcursor: nwse-resize;\n\theight: 20px;\n\topacity: 1;\n\tright: -3px;\n\twidth: 20px;\n}\n\n@media (min-width: 768px) {\n.cropper-point.point-se {\n\t\theight: 15px;\n\t\twidth: 15px;\n\t}\n}\n\n@media (min-width: 992px) {\n.cropper-point.point-se {\n\t\theight: 10px;\n\t\twidth: 10px;\n\t}\n}\n\n@media (min-width: 1200px) {\n.cropper-point.point-se {\n\t\theight: 5px;\n\t\topacity: 0.75;\n\t\twidth: 5px;\n\t}\n}\n\n.cropper-point.point-se::before {\n\tbackground-color: #39f;\n\tbottom: -50%;\n\tcontent: ' ';\n\tdisplay: block;\n\theight: 200%;\n\topacity: 0;\n\tposition: absolute;\n\tright: -50%;\n\twidth: 200%;\n}\n\n.cropper-invisible {\n\topacity: 0;\n}\n\n.cropper-bg {\n\tbackground-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAAA3NCSVQICAjb4U/gAAAABlBMVEXMzMz////TjRV2AAAACXBIWXMAAArrAAAK6wGCiw1aAAAAHHRFWHRTb2Z0d2FyZQBBZG9iZSBGaXJld29ya3MgQ1M26LyyjAAAABFJREFUCJlj+M/AgBVhF/0PAH6/D/HkDxOGAAAAAElFTkSuQmCC');\n}\n\n.cropper-hide {\n\tdisplay: block;\n\theight: 0;\n\tposition: absolute;\n\twidth: 0;\n}\n\n.cropper-hidden {\n\tdisplay: none !important;\n}\n\n.cropper-move {\n\tcursor: move;\n}\n\n.cropper-crop {\n\tcursor: crosshair;\n}\n\n.cropper-disabled .cropper-drag-box,\n.cropper-disabled .cropper-face,\n.cropper-disabled .cropper-line,\n.cropper-disabled .cropper-point {\n\tcursor: not-allowed;\n}\n"])));

var _templateObject$T;
function ownKeys$I(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$I(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$I(Object(source), true).forEach(function (key) { _defineProperty$1o(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$I(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$T(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1o(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Avatar extends Et2Widget(avatar_default) {
  static get styles() {
    return [...super.styles, shoelace, cropperStyles, i$b(_templateObject$T || (_templateObject$T = _taggedTemplateLiteral$T(["\n\t\t\t\t:host::part(edit) {\n\t\t\t\t\tvisibility: hidden;\n\t\t\t\t\tborder-radius: 50%;\n\t\t\t\t\tmargin: -4px;\n\t\t\t\t\tz-index: 1;\n\t\t\t\t}\n\t\t\t\t\n\t\t\t\t:host(:hover)::part(edit) {\n\t\t\t\t\tvisibility: visible;\n\t\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$I(_objectSpread$I({}, super.properties), {}, {
      /**
       * The label of the image
       * Actually not used as label, but we put it as title
       * Added here as there's no Lion parent
       */
      label: {
        type: String
      },
      /**
       * Contact id should be either user account_id {account:number} or contact_id {contact:number or number}
       */
      contactId: {
        type: String,
        noAccessor: true
      },
      /**
       * Image
       * Displayed image
       * @deprecated
       */
      src: {
        type: String
      },
      /**
       * The shape of the avatar
       * circle | square | rounded
       */
      shape: {
        type: String,
        reflect: true
      },
      /**
       * Make avatar widget editable to be able to crop profile picture or upload a new photo
       */
      editable: {
        type: Boolean
      },
      image: {
        type: String,
        reflect: true
      },
      crop: {
        type: Boolean
      },
      /**
       * Explicitly specify the avatar size.
       * Better to set the --size CSS variable in app.css, since it allows inheritance and overriding
       */
      size: {
        type: String
      }
    });
  }
  constructor() {
    super();
    _defineProperty$1o(this, "_contactId", void 0);
    _defineProperty$1o(this, "_delBtn", void 0);
    _defineProperty$1o(this, "_editBtn", void 0);
    this.src = "";
    this.label = "";
    this.contactId = "";
    this.editable = false;
    this.crop = false;
    this.icon = "";
    this.shape = "rounded";
  }

  /**
   * Handle changes that have to happen based on changes to properties
   *
   */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("crop")) {
      if (this.crop && !this.readonly && this._imageNode) {
        jQuery(this._imageNode).cropper({
          aspectRatio: 1 / 1
        });
      }
    }
    if (changedProperties.has("size")) {
      if (this.size && this.size.match(/\d/)) {
        this.getDOMNode().setAttribute('style', "--size:".concat(this.size));
      } else {
        this.style.removeProperty("--size");
      }
    }
  }
  firstUpdated() {
    var self = this;
    if (this.contactId && this.editable) {
      egw$1(window).json('addressbook.addressbook_ui.ajax_noPhotoExists', [this.contactId], function (noPhotoExists) {
        if (noPhotoExists) self.image = "";
        self._buildEditableLayer(noPhotoExists);
      }).sendRequest(true);
    }
  }
  get contactId() {
    return this._contactId;
  }
  /**
   * Function to set contactId
   * contactId could be in one of these formats:
   *		'number', will be considered as contact_id
   *		'contact:number', similar to above
   *		'account:number', will be considered as account id
   *		'email:<email>', will be considered as email address
   * @example: contactId = "account:4"
   *
   * @param {string} _contactId contact id could be as above-mentioned formats
   */
  set contactId(_contactId) {
    var params = {};
    var id = 'contact_id';
    var parsedId = "";
    if (!_contactId) {
      parsedId = null;
    } else if (_contactId.substr(0, 8) === 'account:') {
      id = 'account_id';
      parsedId = _contactId.substr(8);
    } else if (_contactId.substr(0, 6) === 'email:') {
      id = 'email';
      var matches = Et2Avatar.RFC822EMAIL.exec(_contactId);
      parsedId = matches ? matches[1] : _contactId.substr(6);
    } else {
      id = 'contact_id';
      parsedId = _contactId.replace('contact:', '');
    }
    var oldContactId = this._contactId;
    this._contactId = _contactId;
    // if our image (incl. cache-buster) already includes the correct id, use that one
    if (!parsedId) {
      this.image = null;
    } else if (!this.image || !this.image.match("(&|\\?)" + id + "=" + encodeURIComponent(parsedId) + "(&|$)")) {
      params[id] = parsedId;
      this.image = egw$1.link('/api/avatar.php', params);
    }
    this.requestUpdate("contactId", oldContactId);
  }
  set value(_value) {
    this.contactId = _value;
  }

  /**
   * set the image source
   * @deprecated please use image instead
   * @param _value
   */
  set src(_value) {
    this.image = _value;
  }
  get _baseNode() {
    return this.shadowRoot.querySelector("[part='base']");
  }
  get _imageNode() {
    return this.shadowRoot.querySelector("[part='image']");
  }

  /**
   * Build Editable Mask Layer (EML) in order to show edit/delete actions
   * on top of profile picture.
   * @param {boolean} _noDelete disable delete button in initialization
   */
  _buildEditableLayer(_noDelete) {
    var self = this;
    this._editBtn = document.createElement('et2-button-icon');
    this._editBtn.setAttribute('image', 'pencil');
    this._editBtn.setAttribute('part', 'edit');
    this._delBtn = document.createElement('et2-button-icon');
    this._delBtn.setAttribute('image', 'delete');
    this._delBtn.setAttribute('part', 'edit');
    this._baseNode.append(this._editBtn);
    this._baseNode.append(this._delBtn);

    // disable the delete button if no delete is set
    this._delBtn.disabled = _noDelete;

    // bind click handler to edit button
    this._editBtn.addEventListener('click', this.editButtonClickHandler.bind(this));

    // bind click handler to del button
    this._delBtn.addEventListener('click', this.delButtonClickHandler.bind(this));
  }

  /**
   * click handler to handle click on edit button
   */
  editButtonClickHandler() {
    var buttons = [{
      "button_id": 1,
      label: this.egw().lang('save'),
      id: 'save',
      image: 'check',
      "default": true
    }, {
      "button_id": 0,
      label: this.egw().lang('cancel'),
      id: 'cancel',
      image: 'cancelled'
    }];
    var value = {
      contactId: this.contactId,
      src: this.image
    };
    this._editDialog(egw$1.lang('Edit avatar'), value, buttons, null);
  }

  /**
   * Build edit dialog
   * @param _title
   * @param _value
   * @param _buttons
   * @param _egw_or_appname
   */
  _editDialog(_title, _value, _buttons, _egw_or_appname) {
    var dialog = new Et2Dialog$1(this.egw());
    dialog.transformAttributes({
      callback: this.__editDialogCallback.bind(this),
      title: _title || egw$1.lang('Input required'),
      buttons: _buttons || Et2Dialog$1.BUTTONS_OK_CANCEL,
      value: {
        content: _value
      },
      width: "90%",
      height: "450",
      resizable: false,
      position: "top+10",
      template: egw$1.webserverUrl + '/api/templates/default/avatar_edit.xet'
    });
    document.body.appendChild(dialog);
    return dialog;
  }

  /**
   * Edit dialog callback function
   * @param _buttons
   * @param _value
   */
  __editDialogCallback(_buttons, _value) {
    var widget = document.getElementById('_cropper_image');
    switch (_buttons) {
      case 0:
        return true;
      case 1:
        var canvas = jQuery(widget._imageNode).cropper('getCroppedCanvas');
        this.image = canvas.toDataURL("image/jpeg", 1.0);
        this.egw().json('addressbook.addressbook_ui.ajax_update_photo', [this.getInstanceManager().etemplate_exec_id, canvas.toDataURL("image/jpeg", 1.0)], this.__editAjaxUpdatePhotoCallback.bind(this)).sendRequest();
        break;
      case '_rotate_reset':
        jQuery(widget._imageNode).cropper('reset');
        return false;
      case '_rotate_l':
        jQuery(widget._imageNode).cropper('rotate', -90);
        return false;
      case '_rotate_r':
        jQuery(widget._imageNode).cropper('rotate', 90);
        return false;
      default:
        return false;
    }
  }

  /**
   * Edit ajax update photo response callback
   * @param response
   */
  __editAjaxUpdatePhotoCallback(response) {
    if (response) {
      this._delBtn.style.visibility = 'visible';
    }
  }

  /**
   * click handler to handel click on delete button
   */
  delButtonClickHandler() {
    //build delete dialog
    Et2Dialog$1.show_dialog(this._delBtnDialogCallback.bind(this), egw$1.lang('Delete this photo?'), egw$1.lang('Delete'), null, Et2Dialog$1.BUTTONS_YES_NO);
  }

  /**
   * del dialog callback function
   * @param _btn
   */
  _delBtnDialogCallback(_btn) {
    if (_btn == Et2Dialog$1.YES_BUTTON) {
      this.egw().json('addressbook.addressbook_ui.ajax_update_photo', [this.getInstanceManager().etemplate_exec_id, null], this.__delAjaxUpdatePhotoCallback.bind(this)).sendRequest();
    }
  }

  /**
   * Del ajax update photo response callback
   * @param response
   */
  __delAjaxUpdatePhotoCallback(response) {
    if (response) {
      this.image = '';
      this._delBtn.style.visibility = 'none';
      egw$1.refresh('Avatar Deleted.', egw$1.app_name());
    }
  }

  /**
   * Function runs after uplaod in avatar dialog is finished and it tries to
   * update image and cropper container.
   * @param {type} e
   */
  static uploadAvatar_onFinish(e) {
    var file = e.data.resumable.files[0].file;
    var reader = new FileReader();
    reader.onload = function (e) {
      var widget = document.getElementById('_cropper_image');
      widget.image = e.target.result;
      // Wait for everything to complete
      widget.getUpdateComplete().then(() => {
        jQuery(widget._imageNode).cropper('replace', e.target.result);
      });
    };
    reader.readAsDataURL(file);
  }

  /**
   *
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("contactId", "label", "href", "src", "image", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
}
_defineProperty$1o(Et2Avatar, "RFC822EMAIL", /<([^<>]+)>$/);
customElements.define("et2-avatar", Et2Avatar);
// make et2_avatar publicly available as we need to call it from templates
{
  window['et2_avatar'] = Et2Avatar;
  window['Et2Avatar'] = Et2Avatar;
}

var _templateObject$S, _templateObject2$y, _templateObject3$i;
function ownKeys$H(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$H(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$H(Object(source), true).forEach(function (key) { _defineProperty$1n(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$H(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1n(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$S(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Show multiple avatars
 */
class Et2AvatarGroup extends Et2Widget(s$5) {
  static get styles() {
    return [...super.styles, shoelace, // TODO: More work on sizing needed to better adapt to available space
    i$b(_templateObject$S || (_templateObject$S = _taggedTemplateLiteral$S(["\n\t\t\t:host {\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-direction: row;\n\t\t\t\tjustify-content: flex-end;\n\t\t\t}\n\t\t\tet2-avatar {\n\t\t\t\t--size: 1.5rem;\n\t\t\t\tflex: 0 0 auto;\n\t\t\t\tmin-width: 20px;\n\t\t\t\ttransition-duration:0.1s;\n\t\t\t}\n\t\t\tet2-avatar:not(:first-of-type) {\n\t\t\t\tmargin-left: -0.5rem;\n\t\t\t}\n\t\t\tet2-avatar::part(base) {\n\t\t\t\tborder: solid 2px var(--sl-color-neutral-0);\n\t\t\t}\n\t\t\tet2-avatar:hover {\n\t\t\t\t--size: 2.5rem;\n\t\t\t\toverflow: visible;\n\t\t\t\tz-index: 11;\n\t\t\t\ttransition-delay: 1s;\n\t\t\t\ttransition-suration:0.5s\n\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$H(_objectSpread$H({}, super.properties), {}, {
      /**
       * List of contact IDs
       */
      value: {
        type: Array
      }
    });
  }
  constructor() {
    super();
    this.value = [];
  }
  set_value(new_value) {
    if (typeof new_value !== "object") {
      new_value = new_value.split(",");
    }
    this.value = new_value;
  }
  avatarTemplate(contact) {
    if (typeof contact == "string") {
      contact = {
        id: contact
      };
    }
    return x$1(_templateObject2$y || (_templateObject2$y = _taggedTemplateLiteral$S(["\n            <et2-avatar\n                    .contactId=\"", "\"\n                    .label=\"", "\"\n                    .title=\"", "\"\n                    shape=\"circle\"\n                    size=\"\"\n            ></et2-avatar>"])), contact.id, contact.label, contact.label);
  }
  render() {
    return x$1(_templateObject3$i || (_templateObject3$i = _taggedTemplateLiteral$S(["\n            ", ""])), c$2(this.value, contact => contact.id, contact => this.avatarTemplate(contact)));
  }
}
customElements.define("et2-avatar-group", Et2AvatarGroup);

var _templateObject$R;
function _taggedTemplateLiteral$R(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2ButtonIcon extends ButtonMixin(Et2InputWidget(icon_button_default)) {
  static get styles() {
    return [...shoelace, ...(super.styles || []), i$b(_templateObject$R || (_templateObject$R = _taggedTemplateLiteral$R(["\n            :host {\n                flex: 0 0 auto !important;\t\t\t\n\t\t\t}\n            "])))];
  }
  set image(new_image) {
    var oldValue = this.__src;
    if (new_image.indexOf("http") >= 0 || new_image.indexOf(this.egw().webserverUrl) >= 0) {
      this.src = new_image;
    } else {
      this.src = this.egw().image(new_image);
    }

    // For some reason setting it directly does not show the image
    this.updateComplete.then(() => {
      var icon = this.shadowRoot.querySelector('sl-icon');
      icon.id = "";
      if (new_image && !this.src) {
        icon.src = "";
        icon.name = new_image;
      } else {
        icon.name = "";
      }
    });
  }
  get image() {
    return this.src || this.name;
  }
}
customElements.define("et2-button-icon", Et2ButtonIcon);

var _templateObject$Q, _templateObject2$x;
function _taggedTemplateLiteral$Q(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Up / Down spinner buttons are used to adjust a value by a set amount
 *
 * @event et2-scroll Emitted when one of the buttons is clicked.  Check event.detail for direction.  1 for up, -1 for down.
 *
 * example:
 * Add the scroll into an input, then catch the et2-scroll event to adjust the value:
 * <et2-button-scroll slot="suffix" @et2-scroll=${this.handleScroll}></et2-button-scroll>
 *
 * handleScroll(e) {
 * 	this.value = "" + (this.valueAsNumber + e.detail * (parseFloat(this.step) || 1));
 * }
 */
class Et2ButtonScroll extends ButtonMixin(s$5) {
  static get styles() {
    return [...(super.styles ? Array.isArray(super.styles) ? super.styles : [super.styles] : []), i$b(_templateObject$Q || (_templateObject$Q = _taggedTemplateLiteral$Q(["\n\t\t\t  /* Scroll buttons */\n\n\t\t\t  .et2-button-scroll {\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-direction: column;\n\t\t\t\twidth: calc(var(--sl-input-height-medium) / 2);\n\t\t\t  }\n\n\t\t\t  et2-button-icon {\n\t\t\t\tfont-size: 85%;\n\t\t\t\theight: calc(var(--sl-input-height-medium) / 2);\n\t\t\t\t/* Override spacing in sl-icon-button */\n\t\t\t\t--sl-spacing-x-small: 3px;\n\t\t\t  }\n\t\t\t"])))];
  }
  constructor() {
    super();
    this.handleClick = this.handleClick.bind(this);
  }

  /**
   * Catch clicks on buttons and dispatch an et2-scroll event with the direction included
   *
   * @param e
   * @private
   */
  handleClick(e) {
    var direction = parseInt(e.target.dataset.direction || "1") || 0;
    e.stopPropagation();
    this.dispatchEvent(new CustomEvent("et2-scroll", {
      bubbles: true,
      detail: direction
    }));
  }
  render() {
    // No spinner buttons on mobile
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      return '';
    }
    return x$1(_templateObject2$x || (_templateObject2$x = _taggedTemplateLiteral$Q(["\n            <div class=\"et2-button-scroll\"\n                 part=\"form-control\"\n                 exportparts=\"button:button\"\n                 slot=\"suffix\"\n                 @click=", "\n            >\n                <et2-button-icon\n                        noSubmit\n                        data-direction=\"1\"\n                        image=\"chevron-up\"\n                        part=\"button\"\n                >\u2191\n                </et2-button-icon>\n                <et2-button-icon\n                        noSubmit\n                        data-direction=\"-1\"\n                        image=\"chevron-down\"\n                        part=\"button\"\n                >\u2193\n                </et2-button-icon>\n            </div>"])), this.handleClick);
  }
}
if (typeof customElements.get("et2-button-scroll") == "undefined") {
  customElements.define("et2-button-scroll", Et2ButtonScroll);
}

function date (format, timestamp) {
    // http://kevin.vanzonneveld.net
    // +   original by: Carlos R. L. Rodrigues (http://www.jsfromhell.com)
    // +      parts by: Peter-Paul Koch (http://www.quirksmode.org/js/beat.html)
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: MeEtc (http://yass.meetcweb.com)
    // +   improved by: Brad Touesnard
    // +   improved by: Tim Wiel
    // +   improved by: Bryan Elliott
    //
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   improved by: David Randall
    // +      input by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   improved by: Theriault
    // +  derived from: gettimeofday
    // +      input by: majak
    // +   bugfixed by: majak
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: Alex
    // +   bugfixed by: Brett Zamir (http://brett-zamir.me)
    // +   improved by: Theriault
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   improved by: Theriault
    // +   improved by: Thomas Beaucourt (http://www.webapp.fr)
    // +   improved by: JT
    // +   improved by: Theriault
    // +   improved by: Rafał Kukawski (http://blog.kukawski.pl)
    // +      input by: Martin
    // +      input by: Alex Wilson
    // %        note 1: Uses global: php_js to store the default timezone
    // %        note 2: Although the function potentially allows timezone info (see notes), it currently does not set
    // %        note 2: per a timezone specified by date_default_timezone_set(). Implementers might use
    // %        note 2: this.php_js.currentTimezoneOffset and this.php_js.currentTimezoneDST set by that function
    // %        note 2: in order to adjust the dates in this function (or our other date functions!) accordingly
    // *     example 1: date('H:m:s \\m \\i\\s \\m\\o\\n\\t\\h', 1062402400);
    // *     returns 1: '09:09:40 m is month'
    // *     example 2: date('F j, Y, g:i a', 1062462400);
    // *     returns 2: 'September 2, 2003, 2:26 am'
    // *     example 3: date('Y W o', 1062462400);
    // *     returns 3: '2003 36 2003'
    // *     example 4: x = date('Y m d', (new Date()).getTime()/1000);
    // *     example 4: (x+'').length == 10 // 2009 01 09
    // *     returns 4: true
    // *     example 5: date('W', 1104534000);
    // *     returns 5: '53'
    // *     example 6: date('B t', 1104534000);
    // *     returns 6: '999 31'
    // *     example 7: date('W U', 1293750000.82); // 2010-12-31
    // *     returns 7: '52 1293750000'
    // *     example 8: date('W', 1293836400); // 2011-01-01
    // *     returns 8: '52'
    // *     example 9: date('W Y-m-d', 1293974054); // 2011-01-02
    // *     returns 9: '52 2011-01-02'
    var that = this,
        jsdate, f, formatChr = /\\?([a-z])/gi,
        formatChrCb,
        // Keep this here (works, but for code commented-out
        // below for file size reasons)
        //, tal= [],
        _pad = function (n, c) {
            if ((n = n + '').length < c) {
                return new Array((++c) - n.length).join('0') + n;
            }
            return n;
        },
        txt_words = ["Sun", "Mon", "Tues", "Wednes", "Thurs", "Fri", "Satur", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
    formatChrCb = function (t, s) {
        return f[t] ? f[t]() : s;
    };
    f = {
        // Day
        d: function () { // Day of month w/leading 0; 01..31
            return _pad(f.j(), 2);
        },
        D: function () { // Shorthand day name; Mon...Sun
            return f.l().slice(0, 3);
        },
        j: function () { // Day of month; 1..31
            return jsdate.getDate();
        },
        l: function () { // Full day name; Monday...Sunday
            return egw && egw.lang ? egw.lang(txt_words[f.w()] + 'day') : txt_words[f.w()] + 'day';
        },
        N: function () { // ISO-8601 day of week; 1[Mon]..7[Sun]
            return f.w() || 7;
        },
        S: function () { // Ordinal suffix for day of month; st, nd, rd, th
            var j = f.j();
            return j > 4 || j < 21 ? 'th' : {1: 'st', 2: 'nd', 3: 'rd'}[j % 10] || 'th';
        },
        w: function () { // Day of week; 0[Sun]..6[Sat]
            return jsdate.getDay();
        },
        z: function () { // Day of year; 0..365
            var a = new Date(f.Y(), f.n() - 1, f.j()),
                b = new Date(f.Y(), 0, 1);
            return Math.round((a - b) / 864e5) + 1;
        },

        // Week
        W: function () { // ISO-8601 week number
            var a = new Date(f.Y(), f.n() - 1, f.j() - f.N() + 3),
                b = new Date(a.getFullYear(), 0, 4);
            return _pad(1 + Math.round((a - b) / 864e5 / 7), 2);
        },

        // Month
        F: function () { // Full month name; January...December
            return egw && egw.lang ? egw.lang(txt_words[6 + f.n()]) : txt_words[6 + f.n()];
        },
        m: function () { // Month w/leading 0; 01...12
            return _pad(f.n(), 2);
        },
        M: function () { // Shorthand month name; Jan...Dec
            return f.F().slice(0, 3);
        },
        n: function () { // Month; 1...12
            return jsdate.getMonth() + 1;
        },
        t: function () { // Days in month; 28...31
            return (new Date(f.Y(), f.n(), 0)).getDate();
        },

        // Year
        L: function () { // Is leap year?; 0 or 1
            return new Date(f.Y(), 1, 29).getMonth() === 1 | 0;
        },
        o: function () { // ISO-8601 year
            var n = f.n(),
                W = f.W(),
                Y = f.Y();
            return Y + (n === 12 && W < 9 ? -1 : n === 1 && W > 9);
        },
        Y: function () { // Full year; e.g. 1980...2010
            return jsdate.getFullYear();
        },
        y: function () { // Last two digits of year; 00...99
            return (f.Y() + "").slice(-2);
        },

        // Time
        a: function () { // am or pm
            return jsdate.getHours() > 11 ? "pm" : "am";
        },
        A: function () { // AM or PM
            return f.a().toUpperCase();
        },
        B: function () { // Swatch Internet time; 000..999
            var H = jsdate.getUTCHours() * 36e2,
                // Hours
                i = jsdate.getUTCMinutes() * 60,
                // Minutes
                s = jsdate.getUTCSeconds(); // Seconds
            return _pad(Math.floor((H + i + s + 36e2) / 86.4) % 1e3, 3);
        },
        g: function () { // 12-Hours; 1..12
            return f.G() % 12 || 12;
        },
        G: function () { // 24-Hours; 0..23
            return jsdate.getHours();
        },
        h: function () { // 12-Hours w/leading 0; 01..12
            return _pad(f.g(), 2);
        },
        H: function () { // 24-Hours w/leading 0; 00..23
            return _pad(f.G(), 2);
        },
        i: function () { // Minutes w/leading 0; 00..59
            return _pad(jsdate.getMinutes(), 2);
        },
        s: function () { // Seconds w/leading 0; 00..59
            return _pad(jsdate.getSeconds(), 2);
        },
        u: function () { // Microseconds; 000000-999000
            return _pad(jsdate.getMilliseconds() * 1000, 6);
        },

        // Timezone
        e: function () { // Timezone identifier; e.g. Atlantic/Azores, ...
            // The following works, but requires inclusion of the very large
            // timezone_abbreviations_list() function.
/*              return this.date_default_timezone_get();
*/
            throw 'Not supported (see source code of date() for timezone on how to add support)';
        },
        I: function () { // DST observed?; 0 or 1
            // Compares Jan 1 minus Jan 1 UTC to Jul 1 minus Jul 1 UTC.
            // If they are not equal, then DST is observed.
            var a = new Date(f.Y(), 0),
                // Jan 1
                c = Date.UTC(f.Y(), 0),
                // Jan 1 UTC
                b = new Date(f.Y(), 6),
                // Jul 1
                d = Date.UTC(f.Y(), 6); // Jul 1 UTC
            return 0 + ((a - c) !== (b - d));
        },
        O: function () { // Difference to GMT in hour format; e.g. +0200
            var a = jsdate.getTimezoneOffset();
            return (a > 0 ? "-" : "+") + _pad(Math.abs(a / 60 * 100), 4);
        },
        P: function () { // Difference to GMT w/colon; e.g. +02:00
            var O = f.O();
            return (O.substr(0, 3) + ":" + O.substr(3, 2));
        },
        T: function () { // Timezone abbreviation; e.g. EST, MDT, ...
            // The following works, but requires inclusion of the very
            // large timezone_abbreviations_list() function.
/*              var abbr = '', i = 0, os = 0, default = 0;
            if (!tal.length) {
                tal = that.timezone_abbreviations_list();
            }
            if (that.php_js && that.php_js.default_timezone) {
                default = that.php_js.default_timezone;
                for (abbr in tal) {
                    for (i=0; i < tal[abbr].length; i++) {
                        if (tal[abbr][i].timezone_id === default) {
                            return abbr.toUpperCase();
                        }
                    }
                }
            }
            for (abbr in tal) {
                for (i = 0; i < tal[abbr].length; i++) {
                    os = -jsdate.getTimezoneOffset() * 60;
                    if (tal[abbr][i].offset === os) {
                        return abbr.toUpperCase();
                    }
                }
            }
*/
            return 'UTC';
        },
        Z: function () { // Timezone offset in seconds (-43200...50400)
            return -jsdate.getTimezoneOffset() * 60;
        },

        // Full Date/Time
        c: function () { // ISO-8601 date.
            return 'Y-m-d\\Th:i:sP'.replace(formatChr, formatChrCb);
        },
        r: function () { // RFC 2822
            return 'D, d M Y H:i:s O'.replace(formatChr, formatChrCb);
        },
        U: function () { // Seconds since UNIX epoch
            return jsdate.getTime() / 1000 | 0;
        }
    };
    window.date = function (format, timestamp) {
        that = this;
        jsdate = ((typeof timestamp === 'undefined' ||isNaN(timestamp.valueOf())) ? new Date() : // Not provided
        (timestamp instanceof Date) ? new Date(timestamp) : // JS Date()
        new Date(timestamp * 1000) // UNIX timestamp (auto-convert to int)
        );
        return format.replace(formatChr, formatChrCb);
    };
    return window.date(format, timestamp);
}

function ownKeys$G(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$G(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$G(Object(source), true).forEach(function (key) { _defineProperty$1m(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$G(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1m(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Class which implements the "et2-button-timestamp" tag
 *
 * Clicking the button puts the current time and current user at the end of
 * the provided field.
 */
class Et2ButtonTimestamper extends Et2Button {
  static get properties() {
    return _objectSpread$G(_objectSpread$G({}, super.properties), {}, {
      /**
       * Which field to place the timestamp in
       */
      target: {
        type: String
      },
      /**
       * Format for the timestamp.  User is always after.
       */
      format: {
        type: String
      },
      /**
       * Timezone.  Default is user time.
       */
      timezone: {
        type: String
      },
      /**
       * Icon to use, default "timestamp"
       */
      image: {
        type: String
      }
    });
  }
  constructor() {
    super(...arguments);

    // Property default values
    this.image = 'timestamp';
    this.noSubmit = true;
    this.onclick = this.stamp.bind(this);
  }

  /**
   * Stamp the date / user into the target widget
   *
   * @param _ev
   */
  stamp(event) {
    var now = new Date(new Date().toLocaleString('en-US', {
      timeZone: this.timezone || this.egw().preference('tz')
    }));
    var format = this.format || this.egw().preference('dateformat') + ' ' + (this.egw().preference("timeformat") === "12" ? "h:ia" : "H:i") + ' ';
    var text = date(format, now);

    // Get properly formatted user name

    // Try from account first, it's faster
    var fromAccount = this.egw().user("account_fullname") || "";
    if (fromAccount != "") {
      this.setText(text + fromAccount + ': ');
    } else {
      var user = '' + parseInt(this.egw().user('account_id'));
      this.egw().accounts('accounts').then(accounts => {
        var account = accounts.filter(option => option.value == user)[0];
        this.setText(text + account.label + ': ');
      });
    }
  }
  setText(text) {
    var widget = this._get_input(this.target);
    var input = widget.input ? widget.input : widget.getDOMNode();
    if (input.context) {
      input = input.get(0);
    }
    var scrollPos = input.scrollTop;
    var browser = input.selectionStart || input.selectionStart == "0" ? "standards" : document["selection"] ? "ie" : false;
    var pos = 0;
    var tinymce = tinyMCE && tinyMCE.EditorManager.get(input.id) || false;

    // Find cursor or selection
    if (browser == "ie") {
      input.focus();
      var range = document["selection"].createRange();
      range.moveStart("character", -input.value.length);
      pos = range.text.length;
    } else if (browser == "standards") {
      pos = input.selectionStart;
    }

    // If on a tab, switch to that tab so user can see it
    var tabbox = widget;
    while (tabbox._parent && tabbox.nodeName !== 'ET2-TABBOX') {
      tabbox = tabbox._parent;
    }
    if (tabbox.nodeName === 'ET2-TABBOX') {
      tabbox.activateTab(widget);
    }

    // If tinymce, update it
    if (tinymce) {
      tinymce.insertContent(text);
    } else {
      // Insert the text
      var front = input.value.substring(0, pos);
      var back = input.value.substring(pos, input.value.length);
      // for webComponent, we need to set the component value too, otherwise the change is lost!
      if (typeof widget.tagName !== 'undefined') {
        widget.value = front + text + back;
      }
      input.value = front + text + back;

      // Clean up a little
      pos = pos + text.length;
      if (browser == "ie") {
        input.focus();
        var _range = document["selection"].createRange();
        _range.moveStart("character", -input.value.length);
        _range.moveStart("character", pos);
        _range.moveEnd("character", 0);
        _range.select();
      } else if (browser == "standards") {
        input.selectionStart = pos;
        input.selectionEnd = pos;
        input.focus();
      }
      input.scrollTop = scrollPos;
      input.focus();
    }
  }
  _get_input(target) {
    var _input;
    var input = null;
    var widget = null;
    if (typeof target == 'string') {
      widget = this.getRoot().getWidgetById(target);
    } else if (target.instanceOf && target.instanceOf(et2_IInput)) {
      widget = target;
    } else if (typeof target == 'string' && target.indexOf('#') < 0 && jQuery('#' + this.target).is('input')) {
      input = this.target;
    }
    if (widget) {
      return widget;
    }
    if ((_input = input) !== null && _input !== void 0 && _input.context) {
      input = input.get(0);
    }
    return input;
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Button is a LitElement
customElements.define("et2-button-timestamp", Et2ButtonTimestamper);

var _templateObject$P;
function ownKeys$F(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$F(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$F(Object(source), true).forEach(function (key) { _defineProperty$1l(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$F(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$P(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1l(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Checkbox extends Et2InputWidget(checkbox_default) {
  static get styles() {
    return [...shoelace, ...super.styles, i$b(_templateObject$P || (_templateObject$P = _taggedTemplateLiteral$P(["\n\t\t\t  :host {\n\t\t\t\t/* Make it line up with the middle of surroundings */\n\t\t\t\tmargin: auto 0px;\n\t\t\t\tvertical-align: baseline;\n\t\t\t  }\n\n\t\t\t  :host([disabled]) {\n\t\t\t\tdisplay: initial;\n\t\t\t  }\n\n\t\t\t  /* Fix positioning */\n\n\t\t\t  .checkbox {\n\t\t\t\tposition: relative;\n\t\t\t  }\n\n\t\t\t  /* Extend hover highlight to label */\n\n\t\t\t  .checkbox:not(.checkbox--disabled):hover {\n\t\t\t\tcolor: var(--sl-input-border-color-hover);\n\t\t\t  }\n\n\t\t\t  /* Use normal color even when required */\n\n\t\t\t  :host([required]) .checkbox__control {\n\t\t\t\tcolor: var(--input-text-color);\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$F(_objectSpread$F({}, super.properties), {}, {
      /* Different value when checked */
      selectedValue: {
        type: String
      },
      /* Different value when unchecked */
      unselectedValue: {
        type: String
      }
    });
  }
  constructor() {
    super();
    this.isSlComponent = true;
    this.selectedValue = 'true';
    this.unselectedValue = '';
  }
  connectedCallback() {
    super.connectedCallback();
  }
  get label() {
    var _this$_labelNode;
    return ((_this$_labelNode = this._labelNode) === null || _this$_labelNode === void 0 ? void 0 : _this$_labelNode.textContent) || "";
  }
  set label(label_text) {
    if (this._labelNode) {
      this._labelNode.textContent = label_text;
    } else {
      this.updateComplete.then(() => {
        this.label = label_text;
      });
    }
  }
  get value() {
    return this.indeterminate ? undefined : this.checked ? this.selectedValue : this.unselectedValue;
  }
  set value(new_value) {
    this.requestUpdate("checked");
    this.indeterminate = false;
    if (typeof new_value === "boolean") {
      this.checked = new_value;
    } else if (new_value == this.selectedValue) {
      this.checked = true;
    } else if (new_value == this.unselectedValue) {
      this.checked = false;
    }
    // concept of an indeterminate value did not exist in eT2 and set value gets called with all kind of truthy of falsy values
    // therefore we can NOT set everything not matching our (un)selectedValue to indeterminate!
    // For now, we only do that for an explicit Et2Checkbox.INDETERMINATE value
    else if (new_value === Et2Checkbox.INDETERMINATE) {
      this.indeterminate = true;
    } else {
      this.checked = !!new_value;
    }
  }
  get _labelNode() {
    var _this$shadowRoot;
    return (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector("slot:not([name])");
  }
}
/**
 * Value to set checkbox in (third) indeterminate state
 */
_defineProperty$1l(Et2Checkbox, "INDETERMINATE", '***undefined***');
customElements.define("et2-checkbox", Et2Checkbox);

var _templateObject$O, _templateObject2$w, _templateObject3$h;
function ownKeys$E(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$E(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$E(Object(source), true).forEach(function (key) { _defineProperty$1k(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$E(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1k(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$O(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * et2_checkbox_ro is the dummy readonly implementation of the checkbox
 * @augments et2_checkbox
 */
class Et2CheckboxReadonly extends Et2InputWidget(s$5) {
  static get styles() {
    return [...shoelace, ...super.styles, i$b(_templateObject$O || (_templateObject$O = _taggedTemplateLiteral$O(["\n\t\t\t:host {\n\t\t\t\tmargin: auto 0px;\n\t\t\t\tvertical-align: -webkit-baseline-middle;\n\t\t\t}\n            "])))];
  }
  static get properties() {
    return _objectSpread$E(_objectSpread$E({}, super.properties), {}, {
      /**
       *  Checkbox is checked
       */
      checked: {
        type: Boolean
      },
      /**
       * The checkbox's value attribute
       */
      value: {
        type: String
      },
      /* Value when checked */
      selectedValue: {
        type: String
      },
      /**
       * What should be displayed when readonly and selected
       */
      roTrue: {
        type: String
      },
      /**
       * What should be displayed when readonly and not selected
       */
      roFalse: {
        type: String
      }
    });
  }
  constructor() {
    super();
  }
  render() {
    var isChecked = this.checked ||
    // selectedValue is set, so only a value matching that counts as checked
    typeof this.selectedValue == "string" && this.value == this.selectedValue ||
    // selectedValue is not set, any truthy value counts as checked
    typeof this.selectedValue === "undefined" && this.value;
    var check = "";
    if (isChecked && this.roTrue) {
      check = this.roTrue;
    } else if (isChecked) {
      check = x$1(_templateObject2$w || (_templateObject2$w = _taggedTemplateLiteral$O(["\n                <sl-icon name=\"check\"></sl-icon>"])));
    } else if (!isChecked && this.roFalse) {
      check = this.roFalse;
    }
    return x$1(_templateObject3$h || (_templateObject3$h = _taggedTemplateLiteral$O(["\n            <label part=\"base\" class=", "\n            >\n                <span part=\"control\" class=\"checkbox__control\">", "</span>\n                <span part=\"label\" class=\"checkbox__label\">\n\t\t\t\t  <slot>", "</slot>\n\t\t\t\t</span>\n            </label>\n\t\t"])), o$9({
      checkbox: true,
      'checkbox--checked': this.checked,
      'checkbox--disabled': this.disabled,
      'checkbox--focused': this.hasFocus,
      'checkbox--indeterminate': this.indeterminate
    }), check, this.label);
  }
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "class", "statustext");
  }
  getDetachedNodes() {
    return [];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
}
customElements.define("et2-checkbox_ro", Et2CheckboxReadonly);

var es_string_endsWith = {};

'use strict';
var $$5 = _export;
var uncurryThis$1 = functionUncurryThisClause;
var getOwnPropertyDescriptor$1 = objectGetOwnPropertyDescriptor.f;
var toLength = toLength$4;
var toString$1 = toString$a;
var notARegExp = notARegexp;
var requireObjectCoercible = requireObjectCoercible$6;
var correctIsRegExpLogic = correctIsRegexpLogic;
var IS_PURE$1 = isPure;

// eslint-disable-next-line es/no-string-prototype-endswith -- safe
var nativeEndsWith = uncurryThis$1(''.endsWith);
var slice = uncurryThis$1(''.slice);
var min = Math.min;

var CORRECT_IS_REGEXP_LOGIC = correctIsRegExpLogic('endsWith');
// https://github.com/zloirock/core-js/pull/702
var MDN_POLYFILL_BUG = !IS_PURE$1 && !CORRECT_IS_REGEXP_LOGIC && !!function () {
  var descriptor = getOwnPropertyDescriptor$1(String.prototype, 'endsWith');
  return descriptor && !descriptor.writable;
}();

// `String.prototype.endsWith` method
// https://tc39.es/ecma262/#sec-string.prototype.endswith
$$5({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG && !CORRECT_IS_REGEXP_LOGIC }, {
  endsWith: function endsWith(searchString /* , endPosition = @length */) {
    var that = toString$1(requireObjectCoercible(this));
    notARegExp(searchString);
    var endPosition = arguments.length > 1 ? arguments[1] : undefined;
    var len = that.length;
    var end = endPosition === undefined ? len : min(toLength(endPosition), len);
    var search = toString$1(searchString);
    return nativeEndsWith
      ? nativeEndsWith(that, search, end)
      : slice(that, end - search.length, end) === search;
  }
});

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __createBinding(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}

function __exportStar(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};

function __importStar(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result.default = mod;
    return result;
}

function __importDefault(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}

function __classPrivateFieldGet(receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
}

function __classPrivateFieldSet(receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
}

const HOOKS = [
    "onChange",
    "onClose",
    "onDayCreate",
    "onDestroy",
    "onKeyDown",
    "onMonthChange",
    "onOpen",
    "onParseConfig",
    "onReady",
    "onValueUpdate",
    "onYearChange",
    "onPreCalendarPosition",
];
const defaults = {
    _disable: [],
    allowInput: false,
    allowInvalidPreload: false,
    altFormat: "F j, Y",
    altInput: false,
    altInputClass: "form-control input",
    animate: typeof window === "object" &&
        window.navigator.userAgent.indexOf("MSIE") === -1,
    ariaDateFormat: "F j, Y",
    autoFillDefaultTime: true,
    clickOpens: true,
    closeOnSelect: true,
    conjunction: ", ",
    dateFormat: "Y-m-d",
    defaultHour: 12,
    defaultMinute: 0,
    defaultSeconds: 0,
    disable: [],
    disableMobile: false,
    enableSeconds: false,
    enableTime: false,
    errorHandler: (err) => typeof console !== "undefined" && console.warn(err),
    getWeek: (givenDate) => {
        const date = new Date(givenDate.getTime());
        date.setHours(0, 0, 0, 0);
        date.setDate(date.getDate() + 3 - ((date.getDay() + 6) % 7));
        var week1 = new Date(date.getFullYear(), 0, 4);
        return (1 +
            Math.round(((date.getTime() - week1.getTime()) / 86400000 -
                3 +
                ((week1.getDay() + 6) % 7)) /
                7));
    },
    hourIncrement: 1,
    ignoredFocusElements: [],
    inline: false,
    locale: "default",
    minuteIncrement: 5,
    mode: "single",
    monthSelectorType: "dropdown",
    nextArrow: "<svg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' viewBox='0 0 17 17'><g></g><path d='M13.207 8.472l-7.854 7.854-0.707-0.707 7.146-7.146-7.146-7.148 0.707-0.707 7.854 7.854z' /></svg>",
    noCalendar: false,
    now: new Date(),
    onChange: [],
    onClose: [],
    onDayCreate: [],
    onDestroy: [],
    onKeyDown: [],
    onMonthChange: [],
    onOpen: [],
    onParseConfig: [],
    onReady: [],
    onValueUpdate: [],
    onYearChange: [],
    onPreCalendarPosition: [],
    plugins: [],
    position: "auto",
    positionElement: undefined,
    prevArrow: "<svg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' viewBox='0 0 17 17'><g></g><path d='M5.207 8.471l7.146 7.147-0.707 0.707-7.853-7.854 7.854-7.853 0.707 0.707-7.147 7.146z' /></svg>",
    shorthandCurrentMonth: false,
    showMonths: 1,
    static: false,
    time_24hr: false,
    weekNumbers: false,
    wrap: false,
};

const english = {
    weekdays: {
        shorthand: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
        longhand: [
            "Sunday",
            "Monday",
            "Tuesday",
            "Wednesday",
            "Thursday",
            "Friday",
            "Saturday",
        ],
    },
    months: {
        shorthand: [
            "Jan",
            "Feb",
            "Mar",
            "Apr",
            "May",
            "Jun",
            "Jul",
            "Aug",
            "Sep",
            "Oct",
            "Nov",
            "Dec",
        ],
        longhand: [
            "January",
            "February",
            "March",
            "April",
            "May",
            "June",
            "July",
            "August",
            "September",
            "October",
            "November",
            "December",
        ],
    },
    daysInMonth: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
    firstDayOfWeek: 0,
    ordinal: (nth) => {
        const s = nth % 100;
        if (s > 3 && s < 21)
            return "th";
        switch (s % 10) {
            case 1:
                return "st";
            case 2:
                return "nd";
            case 3:
                return "rd";
            default:
                return "th";
        }
    },
    rangeSeparator: " to ",
    weekAbbreviation: "Wk",
    scrollTitle: "Scroll to increment",
    toggleTitle: "Click to toggle",
    amPM: ["AM", "PM"],
    yearAriaLabel: "Year",
    monthAriaLabel: "Month",
    hourAriaLabel: "Hour",
    minuteAriaLabel: "Minute",
    time_24hr: false,
};

const pad = (number, length = 2) => `000${number}`.slice(length * -1);
const int = (bool) => (bool === true ? 1 : 0);
function debounce(fn, wait) {
    let t;
    return function () {
        clearTimeout(t);
        t = setTimeout(() => fn.apply(this, arguments), wait);
    };
}
const arrayify = (obj) => obj instanceof Array ? obj : [obj];

function toggleClass(elem, className, bool) {
    if (bool === true)
        return elem.classList.add(className);
    elem.classList.remove(className);
}
function createElement(tag, className, content) {
    const e = window.document.createElement(tag);
    className = className || "";
    content = content || "";
    e.className = className;
    if (content !== undefined)
        e.textContent = content;
    return e;
}
function clearNode(node) {
    while (node.firstChild)
        node.removeChild(node.firstChild);
}
function findParent(node, condition) {
    if (condition(node))
        return node;
    else if (node.parentNode)
        return findParent(node.parentNode, condition);
    return undefined;
}
function createNumberInput(inputClassName, opts) {
    const wrapper = createElement("div", "numInputWrapper"), numInput = createElement("input", "numInput " + inputClassName), arrowUp = createElement("span", "arrowUp"), arrowDown = createElement("span", "arrowDown");
    if (navigator.userAgent.indexOf("MSIE 9.0") === -1) {
        numInput.type = "number";
    }
    else {
        numInput.type = "text";
        numInput.pattern = "\\d*";
    }
    if (opts !== undefined)
        for (const key in opts)
            numInput.setAttribute(key, opts[key]);
    wrapper.appendChild(numInput);
    wrapper.appendChild(arrowUp);
    wrapper.appendChild(arrowDown);
    return wrapper;
}
function getEventTarget(event) {
    try {
        if (typeof event.composedPath === "function") {
            const path = event.composedPath();
            return path[0];
        }
        return event.target;
    }
    catch (error) {
        return event.target;
    }
}

const doNothing = () => undefined;
const monthToStr = (monthNumber, shorthand, locale) => locale.months[shorthand ? "shorthand" : "longhand"][monthNumber];
const revFormat = {
    D: doNothing,
    F: function (dateObj, monthName, locale) {
        dateObj.setMonth(locale.months.longhand.indexOf(monthName));
    },
    G: (dateObj, hour) => {
        dateObj.setHours(parseFloat(hour));
    },
    H: (dateObj, hour) => {
        dateObj.setHours(parseFloat(hour));
    },
    J: (dateObj, day) => {
        dateObj.setDate(parseFloat(day));
    },
    K: (dateObj, amPM, locale) => {
        dateObj.setHours((dateObj.getHours() % 12) +
            12 * int(new RegExp(locale.amPM[1], "i").test(amPM)));
    },
    M: function (dateObj, shortMonth, locale) {
        dateObj.setMonth(locale.months.shorthand.indexOf(shortMonth));
    },
    S: (dateObj, seconds) => {
        dateObj.setSeconds(parseFloat(seconds));
    },
    U: (_, unixSeconds) => new Date(parseFloat(unixSeconds) * 1000),
    W: function (dateObj, weekNum, locale) {
        const weekNumber = parseInt(weekNum);
        const date = new Date(dateObj.getFullYear(), 0, 2 + (weekNumber - 1) * 7, 0, 0, 0, 0);
        date.setDate(date.getDate() - date.getDay() + locale.firstDayOfWeek);
        return date;
    },
    Y: (dateObj, year) => {
        dateObj.setFullYear(parseFloat(year));
    },
    Z: (_, ISODate) => new Date(ISODate),
    d: (dateObj, day) => {
        dateObj.setDate(parseFloat(day));
    },
    h: (dateObj, hour) => {
        dateObj.setHours(parseFloat(hour));
    },
    i: (dateObj, minutes) => {
        dateObj.setMinutes(parseFloat(minutes));
    },
    j: (dateObj, day) => {
        dateObj.setDate(parseFloat(day));
    },
    l: doNothing,
    m: (dateObj, month) => {
        dateObj.setMonth(parseFloat(month) - 1);
    },
    n: (dateObj, month) => {
        dateObj.setMonth(parseFloat(month) - 1);
    },
    s: (dateObj, seconds) => {
        dateObj.setSeconds(parseFloat(seconds));
    },
    u: (_, unixMillSeconds) => new Date(parseFloat(unixMillSeconds)),
    w: doNothing,
    y: (dateObj, year) => {
        dateObj.setFullYear(2000 + parseFloat(year));
    },
};
const tokenRegex = {
    D: "(\\w+)",
    F: "(\\w+)",
    G: "(\\d\\d|\\d)",
    H: "(\\d\\d|\\d)",
    J: "(\\d\\d|\\d)\\w+",
    K: "",
    M: "(\\w+)",
    S: "(\\d\\d|\\d)",
    U: "(.+)",
    W: "(\\d\\d|\\d)",
    Y: "(\\d{4})",
    Z: "(.+)",
    d: "(\\d\\d|\\d)",
    h: "(\\d\\d|\\d)",
    i: "(\\d\\d|\\d)",
    j: "(\\d\\d|\\d)",
    l: "(\\w+)",
    m: "(\\d\\d|\\d)",
    n: "(\\d\\d|\\d)",
    s: "(\\d\\d|\\d)",
    u: "(.+)",
    w: "(\\d\\d|\\d)",
    y: "(\\d{2})",
};
const formats = {
    Z: (date) => date.toISOString(),
    D: function (date, locale, options) {
        return locale.weekdays.shorthand[formats.w(date, locale, options)];
    },
    F: function (date, locale, options) {
        return monthToStr(formats.n(date, locale, options) - 1, false, locale);
    },
    G: function (date, locale, options) {
        return pad(formats.h(date, locale, options));
    },
    H: (date) => pad(date.getHours()),
    J: function (date, locale) {
        return locale.ordinal !== undefined
            ? date.getDate() + locale.ordinal(date.getDate())
            : date.getDate();
    },
    K: (date, locale) => locale.amPM[int(date.getHours() > 11)],
    M: function (date, locale) {
        return monthToStr(date.getMonth(), true, locale);
    },
    S: (date) => pad(date.getSeconds()),
    U: (date) => date.getTime() / 1000,
    W: function (date, _, options) {
        return options.getWeek(date);
    },
    Y: (date) => pad(date.getFullYear(), 4),
    d: (date) => pad(date.getDate()),
    h: (date) => (date.getHours() % 12 ? date.getHours() % 12 : 12),
    i: (date) => pad(date.getMinutes()),
    j: (date) => date.getDate(),
    l: function (date, locale) {
        return locale.weekdays.longhand[date.getDay()];
    },
    m: (date) => pad(date.getMonth() + 1),
    n: (date) => date.getMonth() + 1,
    s: (date) => date.getSeconds(),
    u: (date) => date.getTime(),
    w: (date) => date.getDay(),
    y: (date) => String(date.getFullYear()).substring(2),
};

const createDateFormatter = ({ config = defaults, l10n = english, isMobile = false, }) => (dateObj, frmt, overrideLocale) => {
    const locale = overrideLocale || l10n;
    if (config.formatDate !== undefined && !isMobile) {
        return config.formatDate(dateObj, frmt, locale);
    }
    return frmt
        .split("")
        .map((c, i, arr) => formats[c] && arr[i - 1] !== "\\"
        ? formats[c](dateObj, locale, config)
        : c !== "\\"
            ? c
            : "")
        .join("");
};
const createDateParser = ({ config = defaults, l10n = english }) => (date, givenFormat, timeless, customLocale) => {
    if (date !== 0 && !date)
        return undefined;
    const locale = customLocale || l10n;
    let parsedDate;
    const dateOrig = date;
    if (date instanceof Date)
        parsedDate = new Date(date.getTime());
    else if (typeof date !== "string" &&
        date.toFixed !== undefined)
        parsedDate = new Date(date);
    else if (typeof date === "string") {
        const format = givenFormat || (config || defaults).dateFormat;
        const datestr = String(date).trim();
        if (datestr === "today") {
            parsedDate = new Date();
            timeless = true;
        }
        else if (/Z$/.test(datestr) ||
            /GMT$/.test(datestr))
            parsedDate = new Date(date);
        else if (config && config.parseDate)
            parsedDate = config.parseDate(date, format);
        else {
            parsedDate =
                !config || !config.noCalendar
                    ? new Date(new Date().getFullYear(), 0, 1, 0, 0, 0, 0)
                    : new Date(new Date().setHours(0, 0, 0, 0));
            let matched, ops = [];
            for (let i = 0, matchIndex = 0, regexStr = ""; i < format.length; i++) {
                const token = format[i];
                const isBackSlash = token === "\\";
                const escaped = format[i - 1] === "\\" || isBackSlash;
                if (tokenRegex[token] && !escaped) {
                    regexStr += tokenRegex[token];
                    const match = new RegExp(regexStr).exec(date);
                    if (match && (matched = true)) {
                        ops[token !== "Y" ? "push" : "unshift"]({
                            fn: revFormat[token],
                            val: match[++matchIndex],
                        });
                    }
                }
                else if (!isBackSlash)
                    regexStr += ".";
                ops.forEach(({ fn, val }) => (parsedDate = fn(parsedDate, val, locale) || parsedDate));
            }
            parsedDate = matched ? parsedDate : undefined;
        }
    }
    if (!(parsedDate instanceof Date && !isNaN(parsedDate.getTime()))) {
        config.errorHandler(new Error(`Invalid date provided: ${dateOrig}`));
        return undefined;
    }
    if (timeless === true)
        parsedDate.setHours(0, 0, 0, 0);
    return parsedDate;
};
function compareDates(date1, date2, timeless = true) {
    if (timeless !== false) {
        return (new Date(date1.getTime()).setHours(0, 0, 0, 0) -
            new Date(date2.getTime()).setHours(0, 0, 0, 0));
    }
    return date1.getTime() - date2.getTime();
}
function compareTimes(date1, date2) {
    return (3600 * (date1.getHours() - date2.getHours()) +
        60 * (date1.getMinutes() - date2.getMinutes()) +
        date1.getSeconds() -
        date2.getSeconds());
}
const isBetween = (ts, ts1, ts2) => {
    return ts > Math.min(ts1, ts2) && ts < Math.max(ts1, ts2);
};
const duration = {
    DAY: 86400000,
};
function getDefaultHours(config) {
    let hours = config.defaultHour;
    let minutes = config.defaultMinute;
    let seconds = config.defaultSeconds;
    if (config.minDate !== undefined) {
        const minHour = config.minDate.getHours();
        const minMinutes = config.minDate.getMinutes();
        const minSeconds = config.minDate.getSeconds();
        if (hours < minHour) {
            hours = minHour;
        }
        if (hours === minHour && minutes < minMinutes) {
            minutes = minMinutes;
        }
        if (hours === minHour && minutes === minMinutes && seconds < minSeconds)
            seconds = config.minDate.getSeconds();
    }
    if (config.maxDate !== undefined) {
        const maxHr = config.maxDate.getHours();
        const maxMinutes = config.maxDate.getMinutes();
        hours = Math.min(hours, maxHr);
        if (hours === maxHr)
            minutes = Math.min(maxMinutes, minutes);
        if (hours === maxHr && minutes === maxMinutes)
            seconds = config.maxDate.getSeconds();
    }
    return { hours, minutes, seconds };
}

"use strict";
if (typeof Object.assign !== "function") {
    Object.assign = function (target, ...args) {
        if (!target) {
            throw TypeError("Cannot convert undefined or null to object");
        }
        for (const source of args) {
            if (source) {
                Object.keys(source).forEach((key) => (target[key] = source[key]));
            }
        }
        return target;
    };
}

const DEBOUNCED_CHANGE_MS = 300;
function FlatpickrInstance(element, instanceConfig) {
    const self = {
        config: Object.assign(Object.assign({}, defaults), flatpickr$1.defaultConfig),
        l10n: english,
    };
    self.parseDate = createDateParser({ config: self.config, l10n: self.l10n });
    self._handlers = [];
    self.pluginElements = [];
    self.loadedPlugins = [];
    self._bind = bind;
    self._setHoursFromDate = setHoursFromDate;
    self._positionCalendar = positionCalendar;
    self.changeMonth = changeMonth;
    self.changeYear = changeYear;
    self.clear = clear;
    self.close = close;
    self._createElement = createElement;
    self.destroy = destroy;
    self.isEnabled = isEnabled;
    self.jumpToDate = jumpToDate;
    self.open = open;
    self.redraw = redraw;
    self.set = set;
    self.setDate = setDate;
    self.toggle = toggle;
    function setupHelperFunctions() {
        self.utils = {
            getDaysInMonth(month = self.currentMonth, yr = self.currentYear) {
                if (month === 1 && ((yr % 4 === 0 && yr % 100 !== 0) || yr % 400 === 0))
                    return 29;
                return self.l10n.daysInMonth[month];
            },
        };
    }
    function init() {
        self.element = self.input = element;
        self.isOpen = false;
        parseConfig();
        setupLocale();
        setupInputs();
        setupDates();
        setupHelperFunctions();
        if (!self.isMobile)
            build();
        bindEvents();
        if (self.selectedDates.length || self.config.noCalendar) {
            if (self.config.enableTime) {
                setHoursFromDate(self.config.noCalendar ? self.latestSelectedDateObj : undefined);
            }
            updateValue(false);
        }
        setCalendarWidth();
        const isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
        if (!self.isMobile && isSafari) {
            positionCalendar();
        }
        triggerEvent("onReady");
    }
    function bindToInstance(fn) {
        return fn.bind(self);
    }
    function setCalendarWidth() {
        const config = self.config;
        if (config.weekNumbers === false && config.showMonths === 1) {
            return;
        }
        else if (config.noCalendar !== true) {
            window.requestAnimationFrame(function () {
                if (self.calendarContainer !== undefined) {
                    self.calendarContainer.style.visibility = "hidden";
                    self.calendarContainer.style.display = "block";
                }
                if (self.daysContainer !== undefined) {
                    const daysWidth = (self.days.offsetWidth + 1) * config.showMonths;
                    self.daysContainer.style.width = daysWidth + "px";
                    self.calendarContainer.style.width =
                        daysWidth +
                            (self.weekWrapper !== undefined
                                ? self.weekWrapper.offsetWidth
                                : 0) +
                            "px";
                    self.calendarContainer.style.removeProperty("visibility");
                    self.calendarContainer.style.removeProperty("display");
                }
            });
        }
    }
    function updateTime(e) {
        if (self.selectedDates.length === 0) {
            const defaultDate = self.config.minDate === undefined ||
                compareDates(new Date(), self.config.minDate) >= 0
                ? new Date()
                : new Date(self.config.minDate.getTime());
            const defaults = getDefaultHours(self.config);
            defaultDate.setHours(defaults.hours, defaults.minutes, defaults.seconds, defaultDate.getMilliseconds());
            self.selectedDates = [defaultDate];
            self.latestSelectedDateObj = defaultDate;
        }
        if (e !== undefined && e.type !== "blur") {
            timeWrapper(e);
        }
        const prevValue = self._input.value;
        setHoursFromInputs();
        updateValue();
        if (self._input.value !== prevValue) {
            self._debouncedChange();
        }
    }
    function ampm2military(hour, amPM) {
        return (hour % 12) + 12 * int(amPM === self.l10n.amPM[1]);
    }
    function military2ampm(hour) {
        switch (hour % 24) {
            case 0:
            case 12:
                return 12;
            default:
                return hour % 12;
        }
    }
    function setHoursFromInputs() {
        if (self.hourElement === undefined || self.minuteElement === undefined)
            return;
        let hours = (parseInt(self.hourElement.value.slice(-2), 10) || 0) % 24, minutes = (parseInt(self.minuteElement.value, 10) || 0) % 60, seconds = self.secondElement !== undefined
            ? (parseInt(self.secondElement.value, 10) || 0) % 60
            : 0;
        if (self.amPM !== undefined) {
            hours = ampm2military(hours, self.amPM.textContent);
        }
        const limitMinHours = self.config.minTime !== undefined ||
            (self.config.minDate &&
                self.minDateHasTime &&
                self.latestSelectedDateObj &&
                compareDates(self.latestSelectedDateObj, self.config.minDate, true) ===
                    0);
        const limitMaxHours = self.config.maxTime !== undefined ||
            (self.config.maxDate &&
                self.maxDateHasTime &&
                self.latestSelectedDateObj &&
                compareDates(self.latestSelectedDateObj, self.config.maxDate, true) ===
                    0);
        if (limitMaxHours) {
            const maxTime = self.config.maxTime !== undefined
                ? self.config.maxTime
                : self.config.maxDate;
            hours = Math.min(hours, maxTime.getHours());
            if (hours === maxTime.getHours())
                minutes = Math.min(minutes, maxTime.getMinutes());
            if (minutes === maxTime.getMinutes())
                seconds = Math.min(seconds, maxTime.getSeconds());
        }
        if (limitMinHours) {
            const minTime = self.config.minTime !== undefined
                ? self.config.minTime
                : self.config.minDate;
            hours = Math.max(hours, minTime.getHours());
            if (hours === minTime.getHours() && minutes < minTime.getMinutes())
                minutes = minTime.getMinutes();
            if (minutes === minTime.getMinutes())
                seconds = Math.max(seconds, minTime.getSeconds());
        }
        setHours(hours, minutes, seconds);
    }
    function setHoursFromDate(dateObj) {
        const date = dateObj || self.latestSelectedDateObj;
        if (date) {
            setHours(date.getHours(), date.getMinutes(), date.getSeconds());
        }
    }
    function setHours(hours, minutes, seconds) {
        if (self.latestSelectedDateObj !== undefined) {
            self.latestSelectedDateObj.setHours(hours % 24, minutes, seconds || 0, 0);
        }
        if (!self.hourElement || !self.minuteElement || self.isMobile)
            return;
        self.hourElement.value = pad(!self.config.time_24hr
            ? ((12 + hours) % 12) + 12 * int(hours % 12 === 0)
            : hours);
        self.minuteElement.value = pad(minutes);
        if (self.amPM !== undefined)
            self.amPM.textContent = self.l10n.amPM[int(hours >= 12)];
        if (self.secondElement !== undefined)
            self.secondElement.value = pad(seconds);
    }
    function onYearInput(event) {
        const eventTarget = getEventTarget(event);
        const year = parseInt(eventTarget.value) + (event.delta || 0);
        if (year / 1000 > 1 ||
            (event.key === "Enter" && !/[^\d]/.test(year.toString()))) {
            changeYear(year);
        }
    }
    function bind(element, event, handler, options) {
        if (event instanceof Array)
            return event.forEach((ev) => bind(element, ev, handler, options));
        if (element instanceof Array)
            return element.forEach((el) => bind(el, event, handler, options));
        element.addEventListener(event, handler, options);
        self._handlers.push({
            remove: () => element.removeEventListener(event, handler),
        });
    }
    function triggerChange() {
        triggerEvent("onChange");
    }
    function bindEvents() {
        if (self.config.wrap) {
            ["open", "close", "toggle", "clear"].forEach((evt) => {
                Array.prototype.forEach.call(self.element.querySelectorAll(`[data-${evt}]`), (el) => bind(el, "click", self[evt]));
            });
        }
        if (self.isMobile) {
            setupMobile();
            return;
        }
        const debouncedResize = debounce(onResize, 50);
        self._debouncedChange = debounce(triggerChange, DEBOUNCED_CHANGE_MS);
        if (self.daysContainer && !/iPhone|iPad|iPod/i.test(navigator.userAgent))
            bind(self.daysContainer, "mouseover", (e) => {
                if (self.config.mode === "range")
                    onMouseOver(getEventTarget(e));
            });
        bind(window.document.body, "keydown", onKeyDown);
        if (!self.config.inline && !self.config.static)
            bind(window, "resize", debouncedResize);
        if (window.ontouchstart !== undefined)
            bind(window.document, "touchstart", documentClick);
        else
            bind(window.document, "mousedown", documentClick);
        bind(window.document, "focus", documentClick, { capture: true });
        if (self.config.clickOpens === true) {
            bind(self._input, "focus", self.open);
            bind(self._input, "click", self.open);
        }
        if (self.daysContainer !== undefined) {
            bind(self.monthNav, "click", onMonthNavClick);
            bind(self.monthNav, ["keyup", "increment"], onYearInput);
            bind(self.daysContainer, "click", selectDate);
        }
        if (self.timeContainer !== undefined &&
            self.minuteElement !== undefined &&
            self.hourElement !== undefined) {
            const selText = (e) => getEventTarget(e).select();
            bind(self.timeContainer, ["increment"], updateTime);
            bind(self.timeContainer, "blur", updateTime, { capture: true });
            bind(self.timeContainer, "click", timeIncrement);
            bind([self.hourElement, self.minuteElement], ["focus", "click"], selText);
            if (self.secondElement !== undefined)
                bind(self.secondElement, "focus", () => self.secondElement && self.secondElement.select());
            if (self.amPM !== undefined) {
                bind(self.amPM, "click", (e) => {
                    updateTime(e);
                    triggerChange();
                });
            }
        }
        if (self.config.allowInput) {
            bind(self._input, "blur", onBlur);
        }
    }
    function jumpToDate(jumpDate, triggerChange) {
        const jumpTo = jumpDate !== undefined
            ? self.parseDate(jumpDate)
            : self.latestSelectedDateObj ||
                (self.config.minDate && self.config.minDate > self.now
                    ? self.config.minDate
                    : self.config.maxDate && self.config.maxDate < self.now
                        ? self.config.maxDate
                        : self.now);
        const oldYear = self.currentYear;
        const oldMonth = self.currentMonth;
        try {
            if (jumpTo !== undefined) {
                self.currentYear = jumpTo.getFullYear();
                self.currentMonth = jumpTo.getMonth();
            }
        }
        catch (e) {
            e.message = "Invalid date supplied: " + jumpTo;
            self.config.errorHandler(e);
        }
        if (triggerChange && self.currentYear !== oldYear) {
            triggerEvent("onYearChange");
            buildMonthSwitch();
        }
        if (triggerChange &&
            (self.currentYear !== oldYear || self.currentMonth !== oldMonth)) {
            triggerEvent("onMonthChange");
        }
        self.redraw();
    }
    function timeIncrement(e) {
        const eventTarget = getEventTarget(e);
        if (~eventTarget.className.indexOf("arrow"))
            incrementNumInput(e, eventTarget.classList.contains("arrowUp") ? 1 : -1);
    }
    function incrementNumInput(e, delta, inputElem) {
        const target = e && getEventTarget(e);
        const input = inputElem ||
            (target && target.parentNode && target.parentNode.firstChild);
        const event = createEvent("increment");
        event.delta = delta;
        input && input.dispatchEvent(event);
    }
    function build() {
        const fragment = window.document.createDocumentFragment();
        self.calendarContainer = createElement("div", "flatpickr-calendar");
        self.calendarContainer.tabIndex = -1;
        if (!self.config.noCalendar) {
            fragment.appendChild(buildMonthNav());
            self.innerContainer = createElement("div", "flatpickr-innerContainer");
            if (self.config.weekNumbers) {
                const { weekWrapper, weekNumbers } = buildWeeks();
                self.innerContainer.appendChild(weekWrapper);
                self.weekNumbers = weekNumbers;
                self.weekWrapper = weekWrapper;
            }
            self.rContainer = createElement("div", "flatpickr-rContainer");
            self.rContainer.appendChild(buildWeekdays());
            if (!self.daysContainer) {
                self.daysContainer = createElement("div", "flatpickr-days");
                self.daysContainer.tabIndex = -1;
            }
            buildDays();
            self.rContainer.appendChild(self.daysContainer);
            self.innerContainer.appendChild(self.rContainer);
            fragment.appendChild(self.innerContainer);
        }
        if (self.config.enableTime) {
            fragment.appendChild(buildTime());
        }
        toggleClass(self.calendarContainer, "rangeMode", self.config.mode === "range");
        toggleClass(self.calendarContainer, "animate", self.config.animate === true);
        toggleClass(self.calendarContainer, "multiMonth", self.config.showMonths > 1);
        self.calendarContainer.appendChild(fragment);
        const customAppend = self.config.appendTo !== undefined &&
            self.config.appendTo.nodeType !== undefined;
        if (self.config.inline || self.config.static) {
            self.calendarContainer.classList.add(self.config.inline ? "inline" : "static");
            if (self.config.inline) {
                if (!customAppend && self.element.parentNode)
                    self.element.parentNode.insertBefore(self.calendarContainer, self._input.nextSibling);
                else if (self.config.appendTo !== undefined)
                    self.config.appendTo.appendChild(self.calendarContainer);
            }
            if (self.config.static) {
                const wrapper = createElement("div", "flatpickr-wrapper");
                if (self.element.parentNode)
                    self.element.parentNode.insertBefore(wrapper, self.element);
                wrapper.appendChild(self.element);
                if (self.altInput)
                    wrapper.appendChild(self.altInput);
                wrapper.appendChild(self.calendarContainer);
            }
        }
        if (!self.config.static && !self.config.inline)
            (self.config.appendTo !== undefined
                ? self.config.appendTo
                : window.document.body).appendChild(self.calendarContainer);
    }
    function createDay(className, date, dayNumber, i) {
        const dateIsEnabled = isEnabled(date, true), dayElement = createElement("span", "flatpickr-day " + className, date.getDate().toString());
        dayElement.dateObj = date;
        dayElement.$i = i;
        dayElement.setAttribute("aria-label", self.formatDate(date, self.config.ariaDateFormat));
        if (className.indexOf("hidden") === -1 &&
            compareDates(date, self.now) === 0) {
            self.todayDateElem = dayElement;
            dayElement.classList.add("today");
            dayElement.setAttribute("aria-current", "date");
        }
        if (dateIsEnabled) {
            dayElement.tabIndex = -1;
            if (isDateSelected(date)) {
                dayElement.classList.add("selected");
                self.selectedDateElem = dayElement;
                if (self.config.mode === "range") {
                    toggleClass(dayElement, "startRange", self.selectedDates[0] &&
                        compareDates(date, self.selectedDates[0], true) === 0);
                    toggleClass(dayElement, "endRange", self.selectedDates[1] &&
                        compareDates(date, self.selectedDates[1], true) === 0);
                    if (className === "nextMonthDay")
                        dayElement.classList.add("inRange");
                }
            }
        }
        else {
            dayElement.classList.add("flatpickr-disabled");
        }
        if (self.config.mode === "range") {
            if (isDateInRange(date) && !isDateSelected(date))
                dayElement.classList.add("inRange");
        }
        if (self.weekNumbers &&
            self.config.showMonths === 1 &&
            className !== "prevMonthDay" &&
            dayNumber % 7 === 1) {
            self.weekNumbers.insertAdjacentHTML("beforeend", "<span class='flatpickr-day'>" + self.config.getWeek(date) + "</span>");
        }
        triggerEvent("onDayCreate", dayElement);
        return dayElement;
    }
    function focusOnDayElem(targetNode) {
        targetNode.focus();
        if (self.config.mode === "range")
            onMouseOver(targetNode);
    }
    function getFirstAvailableDay(delta) {
        const startMonth = delta > 0 ? 0 : self.config.showMonths - 1;
        const endMonth = delta > 0 ? self.config.showMonths : -1;
        for (let m = startMonth; m != endMonth; m += delta) {
            const month = self.daysContainer.children[m];
            const startIndex = delta > 0 ? 0 : month.children.length - 1;
            const endIndex = delta > 0 ? month.children.length : -1;
            for (let i = startIndex; i != endIndex; i += delta) {
                const c = month.children[i];
                if (c.className.indexOf("hidden") === -1 && isEnabled(c.dateObj))
                    return c;
            }
        }
        return undefined;
    }
    function getNextAvailableDay(current, delta) {
        const givenMonth = current.className.indexOf("Month") === -1
            ? current.dateObj.getMonth()
            : self.currentMonth;
        const endMonth = delta > 0 ? self.config.showMonths : -1;
        const loopDelta = delta > 0 ? 1 : -1;
        for (let m = givenMonth - self.currentMonth; m != endMonth; m += loopDelta) {
            const month = self.daysContainer.children[m];
            const startIndex = givenMonth - self.currentMonth === m
                ? current.$i + delta
                : delta < 0
                    ? month.children.length - 1
                    : 0;
            const numMonthDays = month.children.length;
            for (let i = startIndex; i >= 0 && i < numMonthDays && i != (delta > 0 ? numMonthDays : -1); i += loopDelta) {
                const c = month.children[i];
                if (c.className.indexOf("hidden") === -1 &&
                    isEnabled(c.dateObj) &&
                    Math.abs(current.$i - i) >= Math.abs(delta))
                    return focusOnDayElem(c);
            }
        }
        self.changeMonth(loopDelta);
        focusOnDay(getFirstAvailableDay(loopDelta), 0);
        return undefined;
    }
    function focusOnDay(current, offset) {
        const dayFocused = isInView(document.activeElement || document.body);
        const startElem = current !== undefined
            ? current
            : dayFocused
                ? document.activeElement
                : self.selectedDateElem !== undefined && isInView(self.selectedDateElem)
                    ? self.selectedDateElem
                    : self.todayDateElem !== undefined && isInView(self.todayDateElem)
                        ? self.todayDateElem
                        : getFirstAvailableDay(offset > 0 ? 1 : -1);
        if (startElem === undefined) {
            self._input.focus();
        }
        else if (!dayFocused) {
            focusOnDayElem(startElem);
        }
        else {
            getNextAvailableDay(startElem, offset);
        }
    }
    function buildMonthDays(year, month) {
        const firstOfMonth = (new Date(year, month, 1).getDay() - self.l10n.firstDayOfWeek + 7) % 7;
        const prevMonthDays = self.utils.getDaysInMonth((month - 1 + 12) % 12, year);
        const daysInMonth = self.utils.getDaysInMonth(month, year), days = window.document.createDocumentFragment(), isMultiMonth = self.config.showMonths > 1, prevMonthDayClass = isMultiMonth ? "prevMonthDay hidden" : "prevMonthDay", nextMonthDayClass = isMultiMonth ? "nextMonthDay hidden" : "nextMonthDay";
        let dayNumber = prevMonthDays + 1 - firstOfMonth, dayIndex = 0;
        for (; dayNumber <= prevMonthDays; dayNumber++, dayIndex++) {
            days.appendChild(createDay(prevMonthDayClass, new Date(year, month - 1, dayNumber), dayNumber, dayIndex));
        }
        for (dayNumber = 1; dayNumber <= daysInMonth; dayNumber++, dayIndex++) {
            days.appendChild(createDay("", new Date(year, month, dayNumber), dayNumber, dayIndex));
        }
        for (let dayNum = daysInMonth + 1; dayNum <= 42 - firstOfMonth &&
            (self.config.showMonths === 1 || dayIndex % 7 !== 0); dayNum++, dayIndex++) {
            days.appendChild(createDay(nextMonthDayClass, new Date(year, month + 1, dayNum % daysInMonth), dayNum, dayIndex));
        }
        const dayContainer = createElement("div", "dayContainer");
        dayContainer.appendChild(days);
        return dayContainer;
    }
    function buildDays() {
        if (self.daysContainer === undefined) {
            return;
        }
        clearNode(self.daysContainer);
        if (self.weekNumbers)
            clearNode(self.weekNumbers);
        const frag = document.createDocumentFragment();
        for (let i = 0; i < self.config.showMonths; i++) {
            const d = new Date(self.currentYear, self.currentMonth, 1);
            d.setMonth(self.currentMonth + i);
            frag.appendChild(buildMonthDays(d.getFullYear(), d.getMonth()));
        }
        self.daysContainer.appendChild(frag);
        self.days = self.daysContainer.firstChild;
        if (self.config.mode === "range" && self.selectedDates.length === 1) {
            onMouseOver();
        }
    }
    function buildMonthSwitch() {
        if (self.config.showMonths > 1 ||
            self.config.monthSelectorType !== "dropdown")
            return;
        const shouldBuildMonth = function (month) {
            if (self.config.minDate !== undefined &&
                self.currentYear === self.config.minDate.getFullYear() &&
                month < self.config.minDate.getMonth()) {
                return false;
            }
            return !(self.config.maxDate !== undefined &&
                self.currentYear === self.config.maxDate.getFullYear() &&
                month > self.config.maxDate.getMonth());
        };
        self.monthsDropdownContainer.tabIndex = -1;
        self.monthsDropdownContainer.innerHTML = "";
        for (let i = 0; i < 12; i++) {
            if (!shouldBuildMonth(i))
                continue;
            const month = createElement("option", "flatpickr-monthDropdown-month");
            month.value = new Date(self.currentYear, i).getMonth().toString();
            month.textContent = monthToStr(i, self.config.shorthandCurrentMonth, self.l10n);
            month.tabIndex = -1;
            if (self.currentMonth === i) {
                month.selected = true;
            }
            self.monthsDropdownContainer.appendChild(month);
        }
    }
    function buildMonth() {
        const container = createElement("div", "flatpickr-month");
        const monthNavFragment = window.document.createDocumentFragment();
        let monthElement;
        if (self.config.showMonths > 1 ||
            self.config.monthSelectorType === "static") {
            monthElement = createElement("span", "cur-month");
        }
        else {
            self.monthsDropdownContainer = createElement("select", "flatpickr-monthDropdown-months");
            self.monthsDropdownContainer.setAttribute("aria-label", self.l10n.monthAriaLabel);
            bind(self.monthsDropdownContainer, "change", (e) => {
                const target = getEventTarget(e);
                const selectedMonth = parseInt(target.value, 10);
                self.changeMonth(selectedMonth - self.currentMonth);
                triggerEvent("onMonthChange");
            });
            buildMonthSwitch();
            monthElement = self.monthsDropdownContainer;
        }
        const yearInput = createNumberInput("cur-year", { tabindex: "-1" });
        const yearElement = yearInput.getElementsByTagName("input")[0];
        yearElement.setAttribute("aria-label", self.l10n.yearAriaLabel);
        if (self.config.minDate) {
            yearElement.setAttribute("min", self.config.minDate.getFullYear().toString());
        }
        if (self.config.maxDate) {
            yearElement.setAttribute("max", self.config.maxDate.getFullYear().toString());
            yearElement.disabled =
                !!self.config.minDate &&
                    self.config.minDate.getFullYear() === self.config.maxDate.getFullYear();
        }
        const currentMonth = createElement("div", "flatpickr-current-month");
        currentMonth.appendChild(monthElement);
        currentMonth.appendChild(yearInput);
        monthNavFragment.appendChild(currentMonth);
        container.appendChild(monthNavFragment);
        return {
            container,
            yearElement,
            monthElement,
        };
    }
    function buildMonths() {
        clearNode(self.monthNav);
        self.monthNav.appendChild(self.prevMonthNav);
        if (self.config.showMonths) {
            self.yearElements = [];
            self.monthElements = [];
        }
        for (let m = self.config.showMonths; m--;) {
            const month = buildMonth();
            self.yearElements.push(month.yearElement);
            self.monthElements.push(month.monthElement);
            self.monthNav.appendChild(month.container);
        }
        self.monthNav.appendChild(self.nextMonthNav);
    }
    function buildMonthNav() {
        self.monthNav = createElement("div", "flatpickr-months");
        self.yearElements = [];
        self.monthElements = [];
        self.prevMonthNav = createElement("span", "flatpickr-prev-month");
        self.prevMonthNav.innerHTML = self.config.prevArrow;
        self.nextMonthNav = createElement("span", "flatpickr-next-month");
        self.nextMonthNav.innerHTML = self.config.nextArrow;
        buildMonths();
        Object.defineProperty(self, "_hidePrevMonthArrow", {
            get: () => self.__hidePrevMonthArrow,
            set(bool) {
                if (self.__hidePrevMonthArrow !== bool) {
                    toggleClass(self.prevMonthNav, "flatpickr-disabled", bool);
                    self.__hidePrevMonthArrow = bool;
                }
            },
        });
        Object.defineProperty(self, "_hideNextMonthArrow", {
            get: () => self.__hideNextMonthArrow,
            set(bool) {
                if (self.__hideNextMonthArrow !== bool) {
                    toggleClass(self.nextMonthNav, "flatpickr-disabled", bool);
                    self.__hideNextMonthArrow = bool;
                }
            },
        });
        self.currentYearElement = self.yearElements[0];
        updateNavigationCurrentMonth();
        return self.monthNav;
    }
    function buildTime() {
        self.calendarContainer.classList.add("hasTime");
        if (self.config.noCalendar)
            self.calendarContainer.classList.add("noCalendar");
        const defaults = getDefaultHours(self.config);
        self.timeContainer = createElement("div", "flatpickr-time");
        self.timeContainer.tabIndex = -1;
        const separator = createElement("span", "flatpickr-time-separator", ":");
        const hourInput = createNumberInput("flatpickr-hour", {
            "aria-label": self.l10n.hourAriaLabel,
        });
        self.hourElement = hourInput.getElementsByTagName("input")[0];
        const minuteInput = createNumberInput("flatpickr-minute", {
            "aria-label": self.l10n.minuteAriaLabel,
        });
        self.minuteElement = minuteInput.getElementsByTagName("input")[0];
        self.hourElement.tabIndex = self.minuteElement.tabIndex = -1;
        self.hourElement.value = pad(self.latestSelectedDateObj
            ? self.latestSelectedDateObj.getHours()
            : self.config.time_24hr
                ? defaults.hours
                : military2ampm(defaults.hours));
        self.minuteElement.value = pad(self.latestSelectedDateObj
            ? self.latestSelectedDateObj.getMinutes()
            : defaults.minutes);
        self.hourElement.setAttribute("step", self.config.hourIncrement.toString());
        self.minuteElement.setAttribute("step", self.config.minuteIncrement.toString());
        self.hourElement.setAttribute("min", self.config.time_24hr ? "0" : "1");
        self.hourElement.setAttribute("max", self.config.time_24hr ? "23" : "12");
        self.hourElement.setAttribute("maxlength", "2");
        self.minuteElement.setAttribute("min", "0");
        self.minuteElement.setAttribute("max", "59");
        self.minuteElement.setAttribute("maxlength", "2");
        self.timeContainer.appendChild(hourInput);
        self.timeContainer.appendChild(separator);
        self.timeContainer.appendChild(minuteInput);
        if (self.config.time_24hr)
            self.timeContainer.classList.add("time24hr");
        if (self.config.enableSeconds) {
            self.timeContainer.classList.add("hasSeconds");
            const secondInput = createNumberInput("flatpickr-second");
            self.secondElement = secondInput.getElementsByTagName("input")[0];
            self.secondElement.value = pad(self.latestSelectedDateObj
                ? self.latestSelectedDateObj.getSeconds()
                : defaults.seconds);
            self.secondElement.setAttribute("step", self.minuteElement.getAttribute("step"));
            self.secondElement.setAttribute("min", "0");
            self.secondElement.setAttribute("max", "59");
            self.secondElement.setAttribute("maxlength", "2");
            self.timeContainer.appendChild(createElement("span", "flatpickr-time-separator", ":"));
            self.timeContainer.appendChild(secondInput);
        }
        if (!self.config.time_24hr) {
            self.amPM = createElement("span", "flatpickr-am-pm", self.l10n.amPM[int((self.latestSelectedDateObj
                ? self.hourElement.value
                : self.config.defaultHour) > 11)]);
            self.amPM.title = self.l10n.toggleTitle;
            self.amPM.tabIndex = -1;
            self.timeContainer.appendChild(self.amPM);
        }
        return self.timeContainer;
    }
    function buildWeekdays() {
        if (!self.weekdayContainer)
            self.weekdayContainer = createElement("div", "flatpickr-weekdays");
        else
            clearNode(self.weekdayContainer);
        for (let i = self.config.showMonths; i--;) {
            const container = createElement("div", "flatpickr-weekdaycontainer");
            self.weekdayContainer.appendChild(container);
        }
        updateWeekdays();
        return self.weekdayContainer;
    }
    function updateWeekdays() {
        if (!self.weekdayContainer) {
            return;
        }
        const firstDayOfWeek = self.l10n.firstDayOfWeek;
        let weekdays = [...self.l10n.weekdays.shorthand];
        if (firstDayOfWeek > 0 && firstDayOfWeek < weekdays.length) {
            weekdays = [
                ...weekdays.splice(firstDayOfWeek, weekdays.length),
                ...weekdays.splice(0, firstDayOfWeek),
            ];
        }
        for (let i = self.config.showMonths; i--;) {
            self.weekdayContainer.children[i].innerHTML = `
      <span class='flatpickr-weekday'>
        ${weekdays.join("</span><span class='flatpickr-weekday'>")}
      </span>
      `;
        }
    }
    function buildWeeks() {
        self.calendarContainer.classList.add("hasWeeks");
        const weekWrapper = createElement("div", "flatpickr-weekwrapper");
        weekWrapper.appendChild(createElement("span", "flatpickr-weekday", self.l10n.weekAbbreviation));
        const weekNumbers = createElement("div", "flatpickr-weeks");
        weekWrapper.appendChild(weekNumbers);
        return {
            weekWrapper,
            weekNumbers,
        };
    }
    function changeMonth(value, isOffset = true) {
        const delta = isOffset ? value : value - self.currentMonth;
        if ((delta < 0 && self._hidePrevMonthArrow === true) ||
            (delta > 0 && self._hideNextMonthArrow === true))
            return;
        self.currentMonth += delta;
        if (self.currentMonth < 0 || self.currentMonth > 11) {
            self.currentYear += self.currentMonth > 11 ? 1 : -1;
            self.currentMonth = (self.currentMonth + 12) % 12;
            triggerEvent("onYearChange");
            buildMonthSwitch();
        }
        buildDays();
        triggerEvent("onMonthChange");
        updateNavigationCurrentMonth();
    }
    function clear(triggerChangeEvent = true, toInitial = true) {
        self.input.value = "";
        if (self.altInput !== undefined)
            self.altInput.value = "";
        if (self.mobileInput !== undefined)
            self.mobileInput.value = "";
        self.selectedDates = [];
        self.latestSelectedDateObj = undefined;
        if (toInitial === true) {
            self.currentYear = self._initialDate.getFullYear();
            self.currentMonth = self._initialDate.getMonth();
        }
        if (self.config.enableTime === true) {
            const { hours, minutes, seconds } = getDefaultHours(self.config);
            setHours(hours, minutes, seconds);
        }
        self.redraw();
        if (triggerChangeEvent)
            triggerEvent("onChange");
    }
    function close() {
        self.isOpen = false;
        if (!self.isMobile) {
            if (self.calendarContainer !== undefined) {
                self.calendarContainer.classList.remove("open");
            }
            if (self._input !== undefined) {
                self._input.classList.remove("active");
            }
        }
        triggerEvent("onClose");
    }
    function destroy() {
        if (self.config !== undefined)
            triggerEvent("onDestroy");
        for (let i = self._handlers.length; i--;) {
            self._handlers[i].remove();
        }
        self._handlers = [];
        if (self.mobileInput) {
            if (self.mobileInput.parentNode)
                self.mobileInput.parentNode.removeChild(self.mobileInput);
            self.mobileInput = undefined;
        }
        else if (self.calendarContainer && self.calendarContainer.parentNode) {
            if (self.config.static && self.calendarContainer.parentNode) {
                const wrapper = self.calendarContainer.parentNode;
                wrapper.lastChild && wrapper.removeChild(wrapper.lastChild);
                if (wrapper.parentNode) {
                    while (wrapper.firstChild)
                        wrapper.parentNode.insertBefore(wrapper.firstChild, wrapper);
                    wrapper.parentNode.removeChild(wrapper);
                }
            }
            else
                self.calendarContainer.parentNode.removeChild(self.calendarContainer);
        }
        if (self.altInput) {
            self.input.type = "text";
            if (self.altInput.parentNode)
                self.altInput.parentNode.removeChild(self.altInput);
            delete self.altInput;
        }
        if (self.input) {
            self.input.type = self.input._type;
            self.input.classList.remove("flatpickr-input");
            self.input.removeAttribute("readonly");
        }
        [
            "_showTimeInput",
            "latestSelectedDateObj",
            "_hideNextMonthArrow",
            "_hidePrevMonthArrow",
            "__hideNextMonthArrow",
            "__hidePrevMonthArrow",
            "isMobile",
            "isOpen",
            "selectedDateElem",
            "minDateHasTime",
            "maxDateHasTime",
            "days",
            "daysContainer",
            "_input",
            "_positionElement",
            "innerContainer",
            "rContainer",
            "monthNav",
            "todayDateElem",
            "calendarContainer",
            "weekdayContainer",
            "prevMonthNav",
            "nextMonthNav",
            "monthsDropdownContainer",
            "currentMonthElement",
            "currentYearElement",
            "navigationCurrentMonth",
            "selectedDateElem",
            "config",
        ].forEach((k) => {
            try {
                delete self[k];
            }
            catch (_) { }
        });
    }
    function isCalendarElem(elem) {
        if (self.config.appendTo && self.config.appendTo.contains(elem))
            return true;
        return self.calendarContainer.contains(elem);
    }
    function documentClick(e) {
        if (self.isOpen && !self.config.inline) {
            const eventTarget = getEventTarget(e);
            const isCalendarElement = isCalendarElem(eventTarget);
            const isInput = eventTarget === self.input ||
                eventTarget === self.altInput ||
                self.element.contains(eventTarget) ||
                (e.path &&
                    e.path.indexOf &&
                    (~e.path.indexOf(self.input) ||
                        ~e.path.indexOf(self.altInput)));
            const lostFocus = e.type === "blur"
                ? isInput &&
                    e.relatedTarget &&
                    !isCalendarElem(e.relatedTarget)
                : !isInput &&
                    !isCalendarElement &&
                    !isCalendarElem(e.relatedTarget);
            const isIgnored = !self.config.ignoredFocusElements.some((elem) => elem.contains(eventTarget));
            if (lostFocus && isIgnored) {
                if (self.timeContainer !== undefined &&
                    self.minuteElement !== undefined &&
                    self.hourElement !== undefined &&
                    self.input.value !== "" &&
                    self.input.value !== undefined) {
                    updateTime();
                }
                self.close();
                if (self.config &&
                    self.config.mode === "range" &&
                    self.selectedDates.length === 1) {
                    self.clear(false);
                    self.redraw();
                }
            }
        }
    }
    function changeYear(newYear) {
        if (!newYear ||
            (self.config.minDate && newYear < self.config.minDate.getFullYear()) ||
            (self.config.maxDate && newYear > self.config.maxDate.getFullYear()))
            return;
        const newYearNum = newYear, isNewYear = self.currentYear !== newYearNum;
        self.currentYear = newYearNum || self.currentYear;
        if (self.config.maxDate &&
            self.currentYear === self.config.maxDate.getFullYear()) {
            self.currentMonth = Math.min(self.config.maxDate.getMonth(), self.currentMonth);
        }
        else if (self.config.minDate &&
            self.currentYear === self.config.minDate.getFullYear()) {
            self.currentMonth = Math.max(self.config.minDate.getMonth(), self.currentMonth);
        }
        if (isNewYear) {
            self.redraw();
            triggerEvent("onYearChange");
            buildMonthSwitch();
        }
    }
    function isEnabled(date, timeless = true) {
        var _a;
        const dateToCheck = self.parseDate(date, undefined, timeless);
        if ((self.config.minDate &&
            dateToCheck &&
            compareDates(dateToCheck, self.config.minDate, timeless !== undefined ? timeless : !self.minDateHasTime) < 0) ||
            (self.config.maxDate &&
                dateToCheck &&
                compareDates(dateToCheck, self.config.maxDate, timeless !== undefined ? timeless : !self.maxDateHasTime) > 0))
            return false;
        if (!self.config.enable && self.config.disable.length === 0)
            return true;
        if (dateToCheck === undefined)
            return false;
        const bool = !!self.config.enable, array = (_a = self.config.enable) !== null && _a !== void 0 ? _a : self.config.disable;
        for (let i = 0, d; i < array.length; i++) {
            d = array[i];
            if (typeof d === "function" &&
                d(dateToCheck))
                return bool;
            else if (d instanceof Date &&
                dateToCheck !== undefined &&
                d.getTime() === dateToCheck.getTime())
                return bool;
            else if (typeof d === "string") {
                const parsed = self.parseDate(d, undefined, true);
                return parsed && parsed.getTime() === dateToCheck.getTime()
                    ? bool
                    : !bool;
            }
            else if (typeof d === "object" &&
                dateToCheck !== undefined &&
                d.from &&
                d.to &&
                dateToCheck.getTime() >= d.from.getTime() &&
                dateToCheck.getTime() <= d.to.getTime())
                return bool;
        }
        return !bool;
    }
    function isInView(elem) {
        if (self.daysContainer !== undefined)
            return (elem.className.indexOf("hidden") === -1 &&
                elem.className.indexOf("flatpickr-disabled") === -1 &&
                self.daysContainer.contains(elem));
        return false;
    }
    function onBlur(e) {
        const isInput = e.target === self._input;
        if (isInput &&
            (self.selectedDates.length > 0 || self._input.value.length > 0) &&
            !(e.relatedTarget && isCalendarElem(e.relatedTarget))) {
            self.setDate(self._input.value, true, e.target === self.altInput
                ? self.config.altFormat
                : self.config.dateFormat);
        }
    }
    function onKeyDown(e) {
        const eventTarget = getEventTarget(e);
        const isInput = self.config.wrap
            ? element.contains(eventTarget)
            : eventTarget === self._input;
        const allowInput = self.config.allowInput;
        const allowKeydown = self.isOpen && (!allowInput || !isInput);
        const allowInlineKeydown = self.config.inline && isInput && !allowInput;
        if (e.keyCode === 13 && isInput) {
            if (allowInput) {
                self.setDate(self._input.value, true, eventTarget === self.altInput
                    ? self.config.altFormat
                    : self.config.dateFormat);
                return eventTarget.blur();
            }
            else {
                self.open();
            }
        }
        else if (isCalendarElem(eventTarget) ||
            allowKeydown ||
            allowInlineKeydown) {
            const isTimeObj = !!self.timeContainer &&
                self.timeContainer.contains(eventTarget);
            switch (e.keyCode) {
                case 13:
                    if (isTimeObj) {
                        e.preventDefault();
                        updateTime();
                        focusAndClose();
                    }
                    else
                        selectDate(e);
                    break;
                case 27:
                    e.preventDefault();
                    focusAndClose();
                    break;
                case 8:
                case 46:
                    if (isInput && !self.config.allowInput) {
                        e.preventDefault();
                        self.clear();
                    }
                    break;
                case 37:
                case 39:
                    if (!isTimeObj && !isInput) {
                        e.preventDefault();
                        if (self.daysContainer !== undefined &&
                            (allowInput === false ||
                                (document.activeElement && isInView(document.activeElement)))) {
                            const delta = e.keyCode === 39 ? 1 : -1;
                            if (!e.ctrlKey)
                                focusOnDay(undefined, delta);
                            else {
                                e.stopPropagation();
                                changeMonth(delta);
                                focusOnDay(getFirstAvailableDay(1), 0);
                            }
                        }
                    }
                    else if (self.hourElement)
                        self.hourElement.focus();
                    break;
                case 38:
                case 40:
                    e.preventDefault();
                    const delta = e.keyCode === 40 ? 1 : -1;
                    if ((self.daysContainer &&
                        eventTarget.$i !== undefined) ||
                        eventTarget === self.input ||
                        eventTarget === self.altInput) {
                        if (e.ctrlKey) {
                            e.stopPropagation();
                            changeYear(self.currentYear - delta);
                            focusOnDay(getFirstAvailableDay(1), 0);
                        }
                        else if (!isTimeObj)
                            focusOnDay(undefined, delta * 7);
                    }
                    else if (eventTarget === self.currentYearElement) {
                        changeYear(self.currentYear - delta);
                    }
                    else if (self.config.enableTime) {
                        if (!isTimeObj && self.hourElement)
                            self.hourElement.focus();
                        updateTime(e);
                        self._debouncedChange();
                    }
                    break;
                case 9:
                    if (isTimeObj) {
                        const elems = [
                            self.hourElement,
                            self.minuteElement,
                            self.secondElement,
                            self.amPM,
                        ]
                            .concat(self.pluginElements)
                            .filter((x) => x);
                        const i = elems.indexOf(eventTarget);
                        if (i !== -1) {
                            const target = elems[i + (e.shiftKey ? -1 : 1)];
                            e.preventDefault();
                            (target || self._input).focus();
                        }
                    }
                    else if (!self.config.noCalendar &&
                        self.daysContainer &&
                        self.daysContainer.contains(eventTarget) &&
                        e.shiftKey) {
                        e.preventDefault();
                        self._input.focus();
                    }
                    break;
                default:
                    break;
            }
        }
        if (self.amPM !== undefined && eventTarget === self.amPM) {
            switch (e.key) {
                case self.l10n.amPM[0].charAt(0):
                case self.l10n.amPM[0].charAt(0).toLowerCase():
                    self.amPM.textContent = self.l10n.amPM[0];
                    setHoursFromInputs();
                    updateValue();
                    break;
                case self.l10n.amPM[1].charAt(0):
                case self.l10n.amPM[1].charAt(0).toLowerCase():
                    self.amPM.textContent = self.l10n.amPM[1];
                    setHoursFromInputs();
                    updateValue();
                    break;
            }
        }
        if (isInput || isCalendarElem(eventTarget)) {
            triggerEvent("onKeyDown", e);
        }
    }
    function onMouseOver(elem) {
        if (self.selectedDates.length !== 1 ||
            (elem &&
                (!elem.classList.contains("flatpickr-day") ||
                    elem.classList.contains("flatpickr-disabled"))))
            return;
        const hoverDate = elem
            ? elem.dateObj.getTime()
            : self.days.firstElementChild.dateObj.getTime(), initialDate = self.parseDate(self.selectedDates[0], undefined, true).getTime(), rangeStartDate = Math.min(hoverDate, self.selectedDates[0].getTime()), rangeEndDate = Math.max(hoverDate, self.selectedDates[0].getTime());
        let containsDisabled = false;
        let minRange = 0, maxRange = 0;
        for (let t = rangeStartDate; t < rangeEndDate; t += duration.DAY) {
            if (!isEnabled(new Date(t), true)) {
                containsDisabled =
                    containsDisabled || (t > rangeStartDate && t < rangeEndDate);
                if (t < initialDate && (!minRange || t > minRange))
                    minRange = t;
                else if (t > initialDate && (!maxRange || t < maxRange))
                    maxRange = t;
            }
        }
        for (let m = 0; m < self.config.showMonths; m++) {
            const month = self.daysContainer.children[m];
            for (let i = 0, l = month.children.length; i < l; i++) {
                const dayElem = month.children[i], date = dayElem.dateObj;
                const timestamp = date.getTime();
                const outOfRange = (minRange > 0 && timestamp < minRange) ||
                    (maxRange > 0 && timestamp > maxRange);
                if (outOfRange) {
                    dayElem.classList.add("notAllowed");
                    ["inRange", "startRange", "endRange"].forEach((c) => {
                        dayElem.classList.remove(c);
                    });
                    continue;
                }
                else if (containsDisabled && !outOfRange)
                    continue;
                ["startRange", "inRange", "endRange", "notAllowed"].forEach((c) => {
                    dayElem.classList.remove(c);
                });
                if (elem !== undefined) {
                    elem.classList.add(hoverDate <= self.selectedDates[0].getTime()
                        ? "startRange"
                        : "endRange");
                    if (initialDate < hoverDate && timestamp === initialDate)
                        dayElem.classList.add("startRange");
                    else if (initialDate > hoverDate && timestamp === initialDate)
                        dayElem.classList.add("endRange");
                    if (timestamp >= minRange &&
                        (maxRange === 0 || timestamp <= maxRange) &&
                        isBetween(timestamp, initialDate, hoverDate))
                        dayElem.classList.add("inRange");
                }
            }
        }
    }
    function onResize() {
        if (self.isOpen && !self.config.static && !self.config.inline)
            positionCalendar();
    }
    function open(e, positionElement = self._positionElement) {
        if (self.isMobile === true) {
            if (e) {
                e.preventDefault();
                const eventTarget = getEventTarget(e);
                if (eventTarget) {
                    eventTarget.blur();
                }
            }
            if (self.mobileInput !== undefined) {
                self.mobileInput.focus();
                self.mobileInput.click();
            }
            triggerEvent("onOpen");
            return;
        }
        else if (self._input.disabled || self.config.inline) {
            return;
        }
        const wasOpen = self.isOpen;
        self.isOpen = true;
        if (!wasOpen) {
            self.calendarContainer.classList.add("open");
            self._input.classList.add("active");
            triggerEvent("onOpen");
            positionCalendar(positionElement);
        }
        if (self.config.enableTime === true && self.config.noCalendar === true) {
            if (self.config.allowInput === false &&
                (e === undefined ||
                    !self.timeContainer.contains(e.relatedTarget))) {
                setTimeout(() => self.hourElement.select(), 50);
            }
        }
    }
    function minMaxDateSetter(type) {
        return (date) => {
            const dateObj = (self.config[`_${type}Date`] = self.parseDate(date, self.config.dateFormat));
            const inverseDateObj = self.config[`_${type === "min" ? "max" : "min"}Date`];
            if (dateObj !== undefined) {
                self[type === "min" ? "minDateHasTime" : "maxDateHasTime"] =
                    dateObj.getHours() > 0 ||
                        dateObj.getMinutes() > 0 ||
                        dateObj.getSeconds() > 0;
            }
            if (self.selectedDates) {
                self.selectedDates = self.selectedDates.filter((d) => isEnabled(d));
                if (!self.selectedDates.length && type === "min")
                    setHoursFromDate(dateObj);
                updateValue();
            }
            if (self.daysContainer) {
                redraw();
                if (dateObj !== undefined)
                    self.currentYearElement[type] = dateObj.getFullYear().toString();
                else
                    self.currentYearElement.removeAttribute(type);
                self.currentYearElement.disabled =
                    !!inverseDateObj &&
                        dateObj !== undefined &&
                        inverseDateObj.getFullYear() === dateObj.getFullYear();
            }
        };
    }
    function parseConfig() {
        const boolOpts = [
            "wrap",
            "weekNumbers",
            "allowInput",
            "allowInvalidPreload",
            "clickOpens",
            "time_24hr",
            "enableTime",
            "noCalendar",
            "altInput",
            "shorthandCurrentMonth",
            "inline",
            "static",
            "enableSeconds",
            "disableMobile",
        ];
        const userConfig = Object.assign(Object.assign({}, JSON.parse(JSON.stringify(element.dataset || {}))), instanceConfig);
        const formats = {};
        self.config.parseDate = userConfig.parseDate;
        self.config.formatDate = userConfig.formatDate;
        Object.defineProperty(self.config, "enable", {
            get: () => self.config._enable,
            set: (dates) => {
                self.config._enable = parseDateRules(dates);
            },
        });
        Object.defineProperty(self.config, "disable", {
            get: () => self.config._disable,
            set: (dates) => {
                self.config._disable = parseDateRules(dates);
            },
        });
        const timeMode = userConfig.mode === "time";
        if (!userConfig.dateFormat && (userConfig.enableTime || timeMode)) {
            const defaultDateFormat = flatpickr$1.defaultConfig.dateFormat || defaults.dateFormat;
            formats.dateFormat =
                userConfig.noCalendar || timeMode
                    ? "H:i" + (userConfig.enableSeconds ? ":S" : "")
                    : defaultDateFormat + " H:i" + (userConfig.enableSeconds ? ":S" : "");
        }
        if (userConfig.altInput &&
            (userConfig.enableTime || timeMode) &&
            !userConfig.altFormat) {
            const defaultAltFormat = flatpickr$1.defaultConfig.altFormat || defaults.altFormat;
            formats.altFormat =
                userConfig.noCalendar || timeMode
                    ? "h:i" + (userConfig.enableSeconds ? ":S K" : " K")
                    : defaultAltFormat + ` h:i${userConfig.enableSeconds ? ":S" : ""} K`;
        }
        Object.defineProperty(self.config, "minDate", {
            get: () => self.config._minDate,
            set: minMaxDateSetter("min"),
        });
        Object.defineProperty(self.config, "maxDate", {
            get: () => self.config._maxDate,
            set: minMaxDateSetter("max"),
        });
        const minMaxTimeSetter = (type) => (val) => {
            self.config[type === "min" ? "_minTime" : "_maxTime"] = self.parseDate(val, "H:i:S");
        };
        Object.defineProperty(self.config, "minTime", {
            get: () => self.config._minTime,
            set: minMaxTimeSetter("min"),
        });
        Object.defineProperty(self.config, "maxTime", {
            get: () => self.config._maxTime,
            set: minMaxTimeSetter("max"),
        });
        if (userConfig.mode === "time") {
            self.config.noCalendar = true;
            self.config.enableTime = true;
        }
        Object.assign(self.config, formats, userConfig);
        for (let i = 0; i < boolOpts.length; i++)
            self.config[boolOpts[i]] =
                self.config[boolOpts[i]] === true ||
                    self.config[boolOpts[i]] === "true";
        HOOKS.filter((hook) => self.config[hook] !== undefined).forEach((hook) => {
            self.config[hook] = arrayify(self.config[hook] || []).map(bindToInstance);
        });
        self.isMobile =
            !self.config.disableMobile &&
                !self.config.inline &&
                self.config.mode === "single" &&
                !self.config.disable.length &&
                !self.config.enable &&
                !self.config.weekNumbers &&
                /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);
        for (let i = 0; i < self.config.plugins.length; i++) {
            const pluginConf = self.config.plugins[i](self) || {};
            for (const key in pluginConf) {
                if (HOOKS.indexOf(key) > -1) {
                    self.config[key] = arrayify(pluginConf[key])
                        .map(bindToInstance)
                        .concat(self.config[key]);
                }
                else if (typeof userConfig[key] === "undefined")
                    self.config[key] = pluginConf[key];
            }
        }
        if (!userConfig.altInputClass) {
            self.config.altInputClass =
                getInputElem().className + " " + self.config.altInputClass;
        }
        triggerEvent("onParseConfig");
    }
    function getInputElem() {
        return self.config.wrap
            ? element.querySelector("[data-input]")
            : element;
    }
    function setupLocale() {
        if (typeof self.config.locale !== "object" &&
            typeof flatpickr$1.l10ns[self.config.locale] === "undefined")
            self.config.errorHandler(new Error(`flatpickr: invalid locale ${self.config.locale}`));
        self.l10n = Object.assign(Object.assign({}, flatpickr$1.l10ns.default), (typeof self.config.locale === "object"
            ? self.config.locale
            : self.config.locale !== "default"
                ? flatpickr$1.l10ns[self.config.locale]
                : undefined));
        tokenRegex.K = `(${self.l10n.amPM[0]}|${self.l10n.amPM[1]}|${self.l10n.amPM[0].toLowerCase()}|${self.l10n.amPM[1].toLowerCase()})`;
        const userConfig = Object.assign(Object.assign({}, instanceConfig), JSON.parse(JSON.stringify(element.dataset || {})));
        if (userConfig.time_24hr === undefined &&
            flatpickr$1.defaultConfig.time_24hr === undefined) {
            self.config.time_24hr = self.l10n.time_24hr;
        }
        self.formatDate = createDateFormatter(self);
        self.parseDate = createDateParser({ config: self.config, l10n: self.l10n });
    }
    function positionCalendar(customPositionElement) {
        if (typeof self.config.position === "function") {
            return void self.config.position(self, customPositionElement);
        }
        if (self.calendarContainer === undefined)
            return;
        triggerEvent("onPreCalendarPosition");
        const positionElement = customPositionElement || self._positionElement;
        const calendarHeight = Array.prototype.reduce.call(self.calendarContainer.children, ((acc, child) => acc + child.offsetHeight), 0), calendarWidth = self.calendarContainer.offsetWidth, configPos = self.config.position.split(" "), configPosVertical = configPos[0], configPosHorizontal = configPos.length > 1 ? configPos[1] : null, inputBounds = positionElement.getBoundingClientRect(), distanceFromBottom = window.innerHeight - inputBounds.bottom, showOnTop = configPosVertical === "above" ||
            (configPosVertical !== "below" &&
                distanceFromBottom < calendarHeight &&
                inputBounds.top > calendarHeight);
        const top = window.pageYOffset +
            inputBounds.top +
            (!showOnTop ? positionElement.offsetHeight + 2 : -calendarHeight - 2);
        toggleClass(self.calendarContainer, "arrowTop", !showOnTop);
        toggleClass(self.calendarContainer, "arrowBottom", showOnTop);
        if (self.config.inline)
            return;
        let left = window.pageXOffset + inputBounds.left;
        let isCenter = false;
        let isRight = false;
        if (configPosHorizontal === "center") {
            left -= (calendarWidth - inputBounds.width) / 2;
            isCenter = true;
        }
        else if (configPosHorizontal === "right") {
            left -= calendarWidth - inputBounds.width;
            isRight = true;
        }
        toggleClass(self.calendarContainer, "arrowLeft", !isCenter && !isRight);
        toggleClass(self.calendarContainer, "arrowCenter", isCenter);
        toggleClass(self.calendarContainer, "arrowRight", isRight);
        const right = window.document.body.offsetWidth -
            (window.pageXOffset + inputBounds.right);
        const rightMost = left + calendarWidth > window.document.body.offsetWidth;
        const centerMost = right + calendarWidth > window.document.body.offsetWidth;
        toggleClass(self.calendarContainer, "rightMost", rightMost);
        if (self.config.static)
            return;
        self.calendarContainer.style.top = `${top}px`;
        if (!rightMost) {
            self.calendarContainer.style.left = `${left}px`;
            self.calendarContainer.style.right = "auto";
        }
        else if (!centerMost) {
            self.calendarContainer.style.left = "auto";
            self.calendarContainer.style.right = `${right}px`;
        }
        else {
            const doc = getDocumentStyleSheet();
            if (doc === undefined)
                return;
            const bodyWidth = window.document.body.offsetWidth;
            const centerLeft = Math.max(0, bodyWidth / 2 - calendarWidth / 2);
            const centerBefore = ".flatpickr-calendar.centerMost:before";
            const centerAfter = ".flatpickr-calendar.centerMost:after";
            const centerIndex = doc.cssRules.length;
            const centerStyle = `{left:${inputBounds.left}px;right:auto;}`;
            toggleClass(self.calendarContainer, "rightMost", false);
            toggleClass(self.calendarContainer, "centerMost", true);
            doc.insertRule(`${centerBefore},${centerAfter}${centerStyle}`, centerIndex);
            self.calendarContainer.style.left = `${centerLeft}px`;
            self.calendarContainer.style.right = "auto";
        }
    }
    function getDocumentStyleSheet() {
        let editableSheet = null;
        for (let i = 0; i < document.styleSheets.length; i++) {
            const sheet = document.styleSheets[i];
            try {
                sheet.cssRules;
            }
            catch (err) {
                continue;
            }
            editableSheet = sheet;
            break;
        }
        return editableSheet != null ? editableSheet : createStyleSheet();
    }
    function createStyleSheet() {
        const style = document.createElement("style");
        document.head.appendChild(style);
        return style.sheet;
    }
    function redraw() {
        if (self.config.noCalendar || self.isMobile)
            return;
        buildMonthSwitch();
        updateNavigationCurrentMonth();
        buildDays();
    }
    function focusAndClose() {
        self._input.focus();
        if (window.navigator.userAgent.indexOf("MSIE") !== -1 ||
            navigator.msMaxTouchPoints !== undefined) {
            setTimeout(self.close, 0);
        }
        else {
            self.close();
        }
    }
    function selectDate(e) {
        e.preventDefault();
        e.stopPropagation();
        const isSelectable = (day) => day.classList &&
            day.classList.contains("flatpickr-day") &&
            !day.classList.contains("flatpickr-disabled") &&
            !day.classList.contains("notAllowed");
        const t = findParent(getEventTarget(e), isSelectable);
        if (t === undefined)
            return;
        const target = t;
        const selectedDate = (self.latestSelectedDateObj = new Date(target.dateObj.getTime()));
        const shouldChangeMonth = (selectedDate.getMonth() < self.currentMonth ||
            selectedDate.getMonth() >
                self.currentMonth + self.config.showMonths - 1) &&
            self.config.mode !== "range";
        self.selectedDateElem = target;
        if (self.config.mode === "single")
            self.selectedDates = [selectedDate];
        else if (self.config.mode === "multiple") {
            const selectedIndex = isDateSelected(selectedDate);
            if (selectedIndex)
                self.selectedDates.splice(parseInt(selectedIndex), 1);
            else
                self.selectedDates.push(selectedDate);
        }
        else if (self.config.mode === "range") {
            if (self.selectedDates.length === 2) {
                self.clear(false, false);
            }
            self.latestSelectedDateObj = selectedDate;
            self.selectedDates.push(selectedDate);
            if (compareDates(selectedDate, self.selectedDates[0], true) !== 0)
                self.selectedDates.sort((a, b) => a.getTime() - b.getTime());
        }
        setHoursFromInputs();
        if (shouldChangeMonth) {
            const isNewYear = self.currentYear !== selectedDate.getFullYear();
            self.currentYear = selectedDate.getFullYear();
            self.currentMonth = selectedDate.getMonth();
            if (isNewYear) {
                triggerEvent("onYearChange");
                buildMonthSwitch();
            }
            triggerEvent("onMonthChange");
        }
        updateNavigationCurrentMonth();
        buildDays();
        updateValue();
        if (!shouldChangeMonth &&
            self.config.mode !== "range" &&
            self.config.showMonths === 1)
            focusOnDayElem(target);
        else if (self.selectedDateElem !== undefined &&
            self.hourElement === undefined) {
            self.selectedDateElem && self.selectedDateElem.focus();
        }
        if (self.hourElement !== undefined)
            self.hourElement !== undefined && self.hourElement.focus();
        if (self.config.closeOnSelect) {
            const single = self.config.mode === "single" && !self.config.enableTime;
            const range = self.config.mode === "range" &&
                self.selectedDates.length === 2 &&
                !self.config.enableTime;
            if (single || range) {
                focusAndClose();
            }
        }
        triggerChange();
    }
    const CALLBACKS = {
        locale: [setupLocale, updateWeekdays],
        showMonths: [buildMonths, setCalendarWidth, buildWeekdays],
        minDate: [jumpToDate],
        maxDate: [jumpToDate],
        clickOpens: [
            () => {
                if (self.config.clickOpens === true) {
                    bind(self._input, "focus", self.open);
                    bind(self._input, "click", self.open);
                }
                else {
                    self._input.removeEventListener("focus", self.open);
                    self._input.removeEventListener("click", self.open);
                }
            },
        ],
    };
    function set(option, value) {
        if (option !== null && typeof option === "object") {
            Object.assign(self.config, option);
            for (const key in option) {
                if (CALLBACKS[key] !== undefined)
                    CALLBACKS[key].forEach((x) => x());
            }
        }
        else {
            self.config[option] = value;
            if (CALLBACKS[option] !== undefined)
                CALLBACKS[option].forEach((x) => x());
            else if (HOOKS.indexOf(option) > -1)
                self.config[option] = arrayify(value);
        }
        self.redraw();
        updateValue(true);
    }
    function setSelectedDate(inputDate, format) {
        let dates = [];
        if (inputDate instanceof Array)
            dates = inputDate.map((d) => self.parseDate(d, format));
        else if (inputDate instanceof Date || typeof inputDate === "number")
            dates = [self.parseDate(inputDate, format)];
        else if (typeof inputDate === "string") {
            switch (self.config.mode) {
                case "single":
                case "time":
                    dates = [self.parseDate(inputDate, format)];
                    break;
                case "multiple":
                    dates = inputDate
                        .split(self.config.conjunction)
                        .map((date) => self.parseDate(date, format));
                    break;
                case "range":
                    dates = inputDate
                        .split(self.l10n.rangeSeparator)
                        .map((date) => self.parseDate(date, format));
                    break;
                default:
                    break;
            }
        }
        else
            self.config.errorHandler(new Error(`Invalid date supplied: ${JSON.stringify(inputDate)}`));
        self.selectedDates = (self.config.allowInvalidPreload
            ? dates
            : dates.filter((d) => d instanceof Date && isEnabled(d, false)));
        if (self.config.mode === "range")
            self.selectedDates.sort((a, b) => a.getTime() - b.getTime());
    }
    function setDate(date, triggerChange = false, format = self.config.dateFormat) {
        if ((date !== 0 && !date) || (date instanceof Array && date.length === 0))
            return self.clear(triggerChange);
        setSelectedDate(date, format);
        self.latestSelectedDateObj =
            self.selectedDates[self.selectedDates.length - 1];
        self.redraw();
        jumpToDate(undefined, triggerChange);
        setHoursFromDate();
        if (self.selectedDates.length === 0) {
            self.clear(false);
        }
        updateValue(triggerChange);
        if (triggerChange)
            triggerEvent("onChange");
    }
    function parseDateRules(arr) {
        return arr
            .slice()
            .map((rule) => {
            if (typeof rule === "string" ||
                typeof rule === "number" ||
                rule instanceof Date) {
                return self.parseDate(rule, undefined, true);
            }
            else if (rule &&
                typeof rule === "object" &&
                rule.from &&
                rule.to)
                return {
                    from: self.parseDate(rule.from, undefined),
                    to: self.parseDate(rule.to, undefined),
                };
            return rule;
        })
            .filter((x) => x);
    }
    function setupDates() {
        self.selectedDates = [];
        self.now = self.parseDate(self.config.now) || new Date();
        const preloadedDate = self.config.defaultDate ||
            ((self.input.nodeName === "INPUT" ||
                self.input.nodeName === "TEXTAREA") &&
                self.input.placeholder &&
                self.input.value === self.input.placeholder
                ? null
                : self.input.value);
        if (preloadedDate)
            setSelectedDate(preloadedDate, self.config.dateFormat);
        self._initialDate =
            self.selectedDates.length > 0
                ? self.selectedDates[0]
                : self.config.minDate &&
                    self.config.minDate.getTime() > self.now.getTime()
                    ? self.config.minDate
                    : self.config.maxDate &&
                        self.config.maxDate.getTime() < self.now.getTime()
                        ? self.config.maxDate
                        : self.now;
        self.currentYear = self._initialDate.getFullYear();
        self.currentMonth = self._initialDate.getMonth();
        if (self.selectedDates.length > 0)
            self.latestSelectedDateObj = self.selectedDates[0];
        if (self.config.minTime !== undefined)
            self.config.minTime = self.parseDate(self.config.minTime, "H:i");
        if (self.config.maxTime !== undefined)
            self.config.maxTime = self.parseDate(self.config.maxTime, "H:i");
        self.minDateHasTime =
            !!self.config.minDate &&
                (self.config.minDate.getHours() > 0 ||
                    self.config.minDate.getMinutes() > 0 ||
                    self.config.minDate.getSeconds() > 0);
        self.maxDateHasTime =
            !!self.config.maxDate &&
                (self.config.maxDate.getHours() > 0 ||
                    self.config.maxDate.getMinutes() > 0 ||
                    self.config.maxDate.getSeconds() > 0);
    }
    function setupInputs() {
        self.input = getInputElem();
        if (!self.input) {
            self.config.errorHandler(new Error("Invalid input element specified"));
            return;
        }
        self.input._type = self.input.type;
        self.input.type = "text";
        self.input.classList.add("flatpickr-input");
        self._input = self.input;
        if (self.config.altInput) {
            self.altInput = createElement(self.input.nodeName, self.config.altInputClass);
            self._input = self.altInput;
            self.altInput.placeholder = self.input.placeholder;
            self.altInput.disabled = self.input.disabled;
            self.altInput.required = self.input.required;
            self.altInput.tabIndex = self.input.tabIndex;
            self.altInput.type = "text";
            self.input.setAttribute("type", "hidden");
            if (!self.config.static && self.input.parentNode)
                self.input.parentNode.insertBefore(self.altInput, self.input.nextSibling);
        }
        if (!self.config.allowInput)
            self._input.setAttribute("readonly", "readonly");
        self._positionElement = self.config.positionElement || self._input;
    }
    function setupMobile() {
        const inputType = self.config.enableTime
            ? self.config.noCalendar
                ? "time"
                : "datetime-local"
            : "date";
        self.mobileInput = createElement("input", self.input.className + " flatpickr-mobile");
        self.mobileInput.tabIndex = 1;
        self.mobileInput.type = inputType;
        self.mobileInput.disabled = self.input.disabled;
        self.mobileInput.required = self.input.required;
        self.mobileInput.placeholder = self.input.placeholder;
        self.mobileFormatStr =
            inputType === "datetime-local"
                ? "Y-m-d\\TH:i:S"
                : inputType === "date"
                    ? "Y-m-d"
                    : "H:i:S";
        if (self.selectedDates.length > 0) {
            self.mobileInput.defaultValue = self.mobileInput.value = self.formatDate(self.selectedDates[0], self.mobileFormatStr);
        }
        if (self.config.minDate)
            self.mobileInput.min = self.formatDate(self.config.minDate, "Y-m-d");
        if (self.config.maxDate)
            self.mobileInput.max = self.formatDate(self.config.maxDate, "Y-m-d");
        if (self.input.getAttribute("step"))
            self.mobileInput.step = String(self.input.getAttribute("step"));
        self.input.type = "hidden";
        if (self.altInput !== undefined)
            self.altInput.type = "hidden";
        try {
            if (self.input.parentNode)
                self.input.parentNode.insertBefore(self.mobileInput, self.input.nextSibling);
        }
        catch (_a) { }
        bind(self.mobileInput, "change", (e) => {
            self.setDate(getEventTarget(e).value, false, self.mobileFormatStr);
            triggerEvent("onChange");
            triggerEvent("onClose");
        });
    }
    function toggle(e) {
        if (self.isOpen === true)
            return self.close();
        self.open(e);
    }
    function triggerEvent(event, data) {
        if (self.config === undefined)
            return;
        const hooks = self.config[event];
        if (hooks !== undefined && hooks.length > 0) {
            for (let i = 0; hooks[i] && i < hooks.length; i++)
                hooks[i](self.selectedDates, self.input.value, self, data);
        }
        if (event === "onChange") {
            self.input.dispatchEvent(createEvent("change"));
            self.input.dispatchEvent(createEvent("input"));
        }
    }
    function createEvent(name) {
        const e = document.createEvent("Event");
        e.initEvent(name, true, true);
        return e;
    }
    function isDateSelected(date) {
        for (let i = 0; i < self.selectedDates.length; i++) {
            if (compareDates(self.selectedDates[i], date) === 0)
                return "" + i;
        }
        return false;
    }
    function isDateInRange(date) {
        if (self.config.mode !== "range" || self.selectedDates.length < 2)
            return false;
        return (compareDates(date, self.selectedDates[0]) >= 0 &&
            compareDates(date, self.selectedDates[1]) <= 0);
    }
    function updateNavigationCurrentMonth() {
        if (self.config.noCalendar || self.isMobile || !self.monthNav)
            return;
        self.yearElements.forEach((yearElement, i) => {
            const d = new Date(self.currentYear, self.currentMonth, 1);
            d.setMonth(self.currentMonth + i);
            if (self.config.showMonths > 1 ||
                self.config.monthSelectorType === "static") {
                self.monthElements[i].textContent =
                    monthToStr(d.getMonth(), self.config.shorthandCurrentMonth, self.l10n) + " ";
            }
            else {
                self.monthsDropdownContainer.value = d.getMonth().toString();
            }
            yearElement.value = d.getFullYear().toString();
        });
        self._hidePrevMonthArrow =
            self.config.minDate !== undefined &&
                (self.currentYear === self.config.minDate.getFullYear()
                    ? self.currentMonth <= self.config.minDate.getMonth()
                    : self.currentYear < self.config.minDate.getFullYear());
        self._hideNextMonthArrow =
            self.config.maxDate !== undefined &&
                (self.currentYear === self.config.maxDate.getFullYear()
                    ? self.currentMonth + 1 > self.config.maxDate.getMonth()
                    : self.currentYear > self.config.maxDate.getFullYear());
    }
    function getDateStr(format) {
        return self.selectedDates
            .map((dObj) => self.formatDate(dObj, format))
            .filter((d, i, arr) => self.config.mode !== "range" ||
            self.config.enableTime ||
            arr.indexOf(d) === i)
            .join(self.config.mode !== "range"
            ? self.config.conjunction
            : self.l10n.rangeSeparator);
    }
    function updateValue(triggerChange = true) {
        if (self.mobileInput !== undefined && self.mobileFormatStr) {
            self.mobileInput.value =
                self.latestSelectedDateObj !== undefined
                    ? self.formatDate(self.latestSelectedDateObj, self.mobileFormatStr)
                    : "";
        }
        self.input.value = getDateStr(self.config.dateFormat);
        if (self.altInput !== undefined) {
            self.altInput.value = getDateStr(self.config.altFormat);
        }
        if (triggerChange !== false)
            triggerEvent("onValueUpdate");
    }
    function onMonthNavClick(e) {
        const eventTarget = getEventTarget(e);
        const isPrevMonth = self.prevMonthNav.contains(eventTarget);
        const isNextMonth = self.nextMonthNav.contains(eventTarget);
        if (isPrevMonth || isNextMonth) {
            changeMonth(isPrevMonth ? -1 : 1);
        }
        else if (self.yearElements.indexOf(eventTarget) >= 0) {
            eventTarget.select();
        }
        else if (eventTarget.classList.contains("arrowUp")) {
            self.changeYear(self.currentYear + 1);
        }
        else if (eventTarget.classList.contains("arrowDown")) {
            self.changeYear(self.currentYear - 1);
        }
    }
    function timeWrapper(e) {
        e.preventDefault();
        const isKeyDown = e.type === "keydown", eventTarget = getEventTarget(e), input = eventTarget;
        if (self.amPM !== undefined && eventTarget === self.amPM) {
            self.amPM.textContent =
                self.l10n.amPM[int(self.amPM.textContent === self.l10n.amPM[0])];
        }
        const min = parseFloat(input.getAttribute("min")), max = parseFloat(input.getAttribute("max")), step = parseFloat(input.getAttribute("step")), curValue = parseInt(input.value, 10), delta = e.delta ||
            (isKeyDown ? (e.which === 38 ? 1 : -1) : 0);
        let newValue = curValue + step * delta;
        if (typeof input.value !== "undefined" && input.value.length === 2) {
            const isHourElem = input === self.hourElement, isMinuteElem = input === self.minuteElement;
            if (newValue < min) {
                newValue =
                    max +
                        newValue +
                        int(!isHourElem) +
                        (int(isHourElem) && int(!self.amPM));
                if (isMinuteElem)
                    incrementNumInput(undefined, -1, self.hourElement);
            }
            else if (newValue > max) {
                newValue =
                    input === self.hourElement ? newValue - max - int(!self.amPM) : min;
                if (isMinuteElem)
                    incrementNumInput(undefined, 1, self.hourElement);
            }
            if (self.amPM &&
                isHourElem &&
                (step === 1
                    ? newValue + curValue === 23
                    : Math.abs(newValue - curValue) > step)) {
                self.amPM.textContent =
                    self.l10n.amPM[int(self.amPM.textContent === self.l10n.amPM[0])];
            }
            input.value = pad(newValue);
        }
    }
    init();
    return self;
}
function _flatpickr(nodeList, config) {
    const nodes = Array.prototype.slice
        .call(nodeList)
        .filter((x) => x instanceof HTMLElement);
    const instances = [];
    for (let i = 0; i < nodes.length; i++) {
        const node = nodes[i];
        try {
            if (node.getAttribute("data-fp-omit") !== null)
                continue;
            if (node._flatpickr !== undefined) {
                node._flatpickr.destroy();
                node._flatpickr = undefined;
            }
            node._flatpickr = FlatpickrInstance(node, config || {});
            instances.push(node._flatpickr);
        }
        catch (e) {
            console.error(e);
        }
    }
    return instances.length === 1 ? instances[0] : instances;
}
if (typeof HTMLElement !== "undefined" &&
    typeof HTMLCollection !== "undefined" &&
    typeof NodeList !== "undefined") {
    HTMLCollection.prototype.flatpickr = NodeList.prototype.flatpickr = function (config) {
        return _flatpickr(this, config);
    };
    HTMLElement.prototype.flatpickr = function (config) {
        return _flatpickr([this], config);
    };
}
var flatpickr$1 = function (selector, config) {
    if (typeof selector === "string") {
        return _flatpickr(window.document.querySelectorAll(selector), config);
    }
    else if (selector instanceof Node) {
        return _flatpickr([selector], config);
    }
    else {
        return _flatpickr(selector, config);
    }
};
flatpickr$1.defaultConfig = {};
flatpickr$1.l10ns = {
    en: Object.assign({}, english),
    default: Object.assign({}, english),
};
flatpickr$1.localize = (l10n) => {
    flatpickr$1.l10ns.default = Object.assign(Object.assign({}, flatpickr$1.l10ns.default), l10n);
};
flatpickr$1.setDefaults = (config) => {
    flatpickr$1.defaultConfig = Object.assign(Object.assign({}, flatpickr$1.defaultConfig), config);
};
flatpickr$1.parseDate = createDateParser({});
flatpickr$1.formatDate = createDateFormatter({});
flatpickr$1.compareDates = compareDates;
if (typeof jQuery !== "undefined" && typeof jQuery.fn !== "undefined") {
    jQuery.fn.flatpickr = function (config) {
        return _flatpickr(this, config);
    };
}
Date.prototype.fp_incr = function (days) {
    return new Date(this.getFullYear(), this.getMonth(), this.getDate() + (typeof days === "string" ? parseInt(days, 10) : days));
};
if (typeof window !== "undefined") {
    window.flatpickr = flatpickr$1;
}

const styleRepository = 'https://npmcdn.com/flatpickr@4.6.9/dist/themes/';
var FlatpickrTheme;
(function (FlatpickrTheme) {
    FlatpickrTheme["light"] = "light";
    FlatpickrTheme["dark"] = "dark";
    FlatpickrTheme["materialBlue"] = "material_blue";
    FlatpickrTheme["materialGreen"] = "material_green";
    FlatpickrTheme["materialOrange"] = "material_orange";
    FlatpickrTheme["materialRed"] = "material_red";
    FlatpickrTheme["airbnb"] = "airbnb";
    FlatpickrTheme["confetti"] = "confetti";
    FlatpickrTheme["none"] = "none";
})(FlatpickrTheme || (FlatpickrTheme = {}));
function getStyleRepository(theme) {
    return `${styleRepository}${theme}.css`;
}

const themeUrlPrefix$1 = 'https://npmcdn.com/flatpickr@4.6.9/dist/themes';
class StyleLoader {
    constructor(theme) {
        this.theme = theme;
        this.theme = theme;
    }
    async initStyles() {
        const themeUrl = getStyleRepository(this.theme);
        const themeIsLoaded = this.isThemeLoaded();
        if (!themeIsLoaded) {
            this.appendThemeStyles(themeUrl);
            await this.waitForStyleToLoad(() => this.isThemeLoaded());
        }
    }
    /**
     * We want to prevent the styles from flickering, so we halt the
     * initialization process until the styles have been loaded
     * */
    waitForStyleToLoad(checkFunction) {
        return new Promise((resolve, reject) => {
            const checkIfStylesHaveLoaded = (iteration = 0) => {
                if (checkFunction())
                    return resolve();
                if (iteration > 10) {
                    throw Error('Styles took too long to load, or were not able to be loaded');
                    reject();
                }
                setTimeout(() => checkIfStylesHaveLoaded(iteration++), 100);
            };
            checkIfStylesHaveLoaded();
        });
    }
    isThemeLoaded() {
        // special theme value to prevent any loading of styles
        if (this.theme === FlatpickrTheme.none)
            return true;
        const styleSheetSources = Array.from(document.styleSheets).map(ss => ss.href);
        return styleSheetSources.some(sss => sss != null && new RegExp(themeUrlPrefix$1).test(sss));
    }
    appendThemeStyles(themeUrl) {
        const styleElem = document.createElement('link');
        styleElem.rel = 'stylesheet';
        styleElem.type = 'text/css';
        styleElem.href = themeUrl;
        document.head.append(styleElem);
    }
}

const themeUrlPrefix = 'https://npmcdn.com/flatpickr@4.6.9/dist/l10n';
async function loadLocale(locale) {
    const themeUrl = themeUrlPrefix + '/' + locale + '.js';
    const themeData = await import(themeUrl);
}

let LitFlatpickr = class LitFlatpickr extends s$5 {
    constructor() {
        super(...arguments);
        /**
         * Placeholder text for input element provided by lit-flatpickr
         * */
        this.placeholder = '';
        /**
         * Exactly the same as date format, but for the altInput field
         * @prop
         * @type string
         **/
        this.altFormat = 'F j, Y';
        /**
         * Show the user a readable date (as per altFormat), but return something totally different to the server.
         * @prop
         * @type boolean
         * */
        this.altInput = false;
        /**
         * This class will be added to the input element created by the altInput option.
         * Note that altInput already inherits classes from the original input.
         * @prop
         * @type string
         * */
        this.altInputClass = '';
        /**
         * Allows the user to enter a date directly input the input field. By default, direct entry is disabled.
         * @prop
         * @type boolean
         **/
        this.allowInput = false;
        /**
         * Defines how the date will be formatted in the aria-label for calendar days, using the same tokens as dateFormat.
         * If you change this, you should choose a value that will make sense if a screen reader reads it out loud
         * @prop
         * @type string
         **/
        this.ariaDateFormat = 'F j, Y';
        /**
         * Whether clicking on the input should open the picker.
         * You could disable this if you wish to open the calendar manually with.open()
         * @prop
         * @type boolean
         * */
        this.clickOpens = true;
        /**
         * A string of characters which are used to define how the date will be displayed in the input box.
         * @prop
         * @type string
         * */
        this.dateFormat = 'Y-m-d';
        /**
         * Initial value of the hour element.
         * @prop
         * @type number
         * */
        this.defaultHour = 12;
        /**
         * Initial value of the minute element.
         * @prop
         * @type number
         * */
        this.defaultMinute = 0;
        /**
         * Dates selected to be unavailable for selection.
         * @prop
         * @type DateLimit<DateOption>[]
         * */
        this.disable = [];
        /**
         * Set disableMobile to true to always use the non-native picker.
         * By default, flatpickr utilizes native datetime widgets unless certain options (e.g. disable) are used.
         * @prop
         * @type boolean
         * */
        this.disableMobile = false;
        /**
         * Dates selected to be available for selection.
         * @prop
         * @type DateLimit<DateOption>[]
         * */
        this.enable = undefined;
        /**
         * Enables time picker
         * @prop
         * @type boolean
         * */
        this.enableTime = false;
        /**
         * Enables seconds in the time picker
         * @prop
         * @type boolean
         * */
        this.enableSeconds = false;
        /**
         * Adjusts the step for the hour input (incl. scrolling)
         * @prop
         * @type number
         * */
        this.hourIncrement = 1;
        /**
         * Adjusts the step for the minute input (incl. scrolling)
         * @prop
         * @type number
         * */
        this.minuteIncrement = 5;
        /**
         * Displays the calendar inline
         * @prop
         * @type boolean
         * */
        this.inline = false;
        /**
         * "single", "multiple", or "range"
         * @prop
         * @type {"single" | "multiple" | "range"}
         * */
        this.mode = 'single';
        /**
         * HTML for the arrow icon, used to switch months.
         * @prop
         * @type string
         * */
        this.nextArrow = '>';
        /**
         * HTML for the arrow icon, used to switch months.
         * @prop
         * @type string
         * */
        this.prevArrow = '<';
        /**
         * Hides the day selection in calendar.
         * Use it along with enableTime to create a time picker.
         * @prop
         * @type boolean
         * */
        this.noCalendar = false;
        /**
         * Where the calendar is rendered relative to the input
         * @prop
         * @type {"auto" | "above" | "below"}
         * */
        this.position = 'auto';
        /**
         * Show the month using the shorthand version (ie, Sep instead of September)
         * @prop
         * @type boolean
         * */
        this.shorthandCurrentMonth = false;
        /**
         * The number of months showed
         * @prop
         * @type number
         * */
        this.showMonths = 1;
        /**
         * Position the calendar inside the wrapper and next to the input element
         * @prop
         * @type boolean
         **/
        this.static = false;
        /**
         * Displays the time picker in 24 hour mode without AM/PM selection when enabled
         * @prop
         * @type boolean
         * */
        this.time_24hr = false;
        /**
         * Enabled display of week numbers in calendar
         * @prop
         * @type boolean
         * */
        this.weekNumbers = false;
        /**
         * flatpickr can parse an input group of textboxes and buttons, common in Bootstrap and other frameworks.
         * This permits additional markup, as well as custom elements to trigger the state of the calendar.
         * @prop
         * @type boolean
         * */
        this.wrap = false;
        /**
         * The set theme of flatpickr.
         * @prop
         * @type { "light" | "dark" | "material_blue" | "material_red" | "material_green" | "material_orange" | "airbnb" | "confetti" | "none" }
         * */
        this.theme = 'light';
        this.firstDayOfWeek = 1;
        this._hasSlottedElement = false;
    }
    static get styles() {
        return [i$b `
      :host {
        width: fit-content;
        display: block;
        cursor: pointer;
        background: #fff;
        color: #000;
        overflow: hidden;
      }

      ::slotted(*) {
        cursor: pointer;
      }

      input {
        width: 100%;
        height: 100%;
        font-size: inherit;
        cursor: pointer;
        background: inherit;
        box-sizing: border-box;
        outline: none;
        color: inherit;
        border: none;
      }
    `];
    }
    firstUpdated() {
        this._hasSlottedElement = this.checkForSlottedElement();
    }
    updated() {
        // TODO: Might not need to init every time updated, but only
        // when relevant stuff changes
        this.init();
    }
    checkForSlottedElement() {
        var _a;
        const slottedElem = (_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelector('slot');
        // We don't want to think that a whitespace / line break is a node
        const assignedNodes = slottedElem ? slottedElem.assignedNodes().filter(this.removeTextNodes) : [];
        return slottedElem != null && assignedNodes && assignedNodes.length > 0;
    }
    getSlottedElement() {
        var _a;
        if (!this._hasSlottedElement) {
            return undefined;
        }
        const slottedElem = (_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelector('slot');
        const slottedElemNodes = slottedElem === null || slottedElem === void 0 ? void 0 : slottedElem.assignedNodes().filter(this.removeTextNodes);
        if (!slottedElemNodes || slottedElemNodes.length < 1) {
            return undefined;
        }
        return slottedElemNodes[0];
    }
    removeTextNodes(node) {
        return node.nodeName !== '#text';
    }
    async init() {
        const styleLoader = new StyleLoader(this.theme);
        await styleLoader.initStyles();
        if (this.locale) {
            await loadLocale(this.locale);
        }
        this.initializeComponent();
    }
    getOptions() {
        /* eslint-disable  @typescript-eslint/no-explicit-any */
        const options = {
            altFormat: this.altFormat,
            altInput: this.altInput,
            altInputClass: this.altInputClass,
            allowInput: this.allowInput,
            ariaDateFormat: this.ariaDateFormat,
            clickOpens: this.clickOpens,
            dateFormat: this.dateFormat,
            defaultDate: this.defaultDate,
            defaultHour: this.defaultHour,
            defaultMinute: this.defaultMinute,
            disable: this.disable,
            disableMobile: this.disableMobile,
            enable: this.enable,
            enableTime: this.enableTime,
            enableSeconds: this.enableSeconds,
            formatDate: this.formatDateFn,
            hourIncrement: this.hourIncrement,
            inline: this.inline,
            maxDate: this.maxDate,
            minDate: this.minDate,
            minuteIncrement: this.minuteIncrement,
            mode: this.mode,
            nextArrow: this.nextArrow,
            prevArrow: this.prevArrow,
            noCalendar: this.noCalendar,
            onChange: this.onChange,
            onClose: this.onClose,
            onOpen: this.onOpen,
            onReady: this.onReady,
            onMonthChange: this.onMonthChange,
            onYearChange: this.onYearChange,
            onValueUpdate: this.onValueUpdate,
            parseDate: this.parseDateFn,
            position: this.position,
            shorthandCurrentMonth: this.shorthandCurrentMonth,
            showMonths: this.showMonths,
            static: this.static,
            // eslint-disable-next-line @typescript-eslint/camelcase
            time_24hr: this.time_24hr,
            weekNumbers: this.weekNumbers,
            wrap: this.wrap,
            locale: this.locale,
        };
        Object.keys(options).forEach(key => {
            if (options[key] === undefined)
                delete options[key];
        });
        return options;
    }
    initializeComponent() {
        var _a;
        if (this._instance) {
            if (Object.prototype.hasOwnProperty.call(this, 'destroy')) {
                this._instance.destroy();
            }
        }
        let inputElement;
        if (this._hasSlottedElement) {
            // If lit-flatpickr has a slotted element, it means that
            // the user wants to use their custom input.
            inputElement = this.findInputField();
        }
        else {
            inputElement = (_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelector('input');
        }
        if (inputElement) {
            this._inputElement = inputElement;
            flatpickr.l10ns.default.firstDayOfWeek = this.firstDayOfWeek;
            this._instance = flatpickr(inputElement, this.getOptions());
        }
    }
    findInputField() {
        let inputElement = null;
        // First we check if the slotted element is just light dom HTML
        inputElement = this.querySelector('input');
        if (inputElement) {
            return inputElement;
        }
        // If not, we traverse down the slotted element's dom/shadow dom until we
        // find a dead-end or an input
        const slottedElement = this.getSlottedElement();
        if (typeof slottedElement !== undefined) {
            inputElement = this.searchWebComponentForInputElement(slottedElement);
        }
        return inputElement ? inputElement : null;
    }
    /**
     * Traverse the shadow dom tree and search for input from it
     * and it's children
     * */
    searchWebComponentForInputElement(element) {
        let inputElement = this.getInputFieldInElement(element);
        if (inputElement)
            return inputElement;
        const webComponentsInChildren = this.getWebComponentsInsideElement(element);
        for (let i = 0; i < webComponentsInChildren.length; i++) {
            inputElement = this.searchWebComponentForInputElement(webComponentsInChildren[i]);
            if (inputElement) {
                break;
            }
        }
        return inputElement;
    }
    /**
     * Check if said element's dom tree contains a input element
     * */
    getInputFieldInElement(element) {
        let inputElement = null;
        if (element.shadowRoot) {
            inputElement = element.shadowRoot.querySelector('input');
        }
        else {
            inputElement = element.querySelector('input');
        }
        return inputElement;
    }
    getWebComponentsInsideElement(element) {
        if (element.shadowRoot) {
            return [
                ...Array.from(element.querySelectorAll('*')),
                ...Array.from(element.shadowRoot.querySelectorAll('*')),
            ].filter((elem) => elem.shadowRoot);
        }
        else {
            return Array.from(element.querySelectorAll('*')).filter((elem) => elem.shadowRoot);
        }
    }
    changeMonth(monthNum, isOffset = true) {
        if (!this._instance)
            return;
        this._instance.changeMonth(monthNum, isOffset);
    }
    clear() {
        if (!this._instance)
            return;
        this._instance.clear();
    }
    close() {
        if (!this._instance)
            return;
        this._instance.close();
    }
    destroy() {
        if (!this._instance)
            return;
        this._instance.destroy();
    }
    formatDate(dateObj, formatStr) {
        if (!this._instance)
            return '';
        return this._instance.formatDate(dateObj, formatStr);
    }
    jumpToDate(date, triggerChange) {
        if (!this._instance)
            return;
        this._instance.jumpToDate(date, triggerChange);
    }
    open() {
        if (!this._instance)
            return;
        this._instance.open();
    }
    parseDate(dateStr, dateFormat) {
        if (!this._instance)
            return undefined;
        return this._instance.parseDate(dateStr, dateFormat);
    }
    redraw() {
        if (!this._instance)
            return;
        this._instance.redraw();
    }
    /* eslint-disable  @typescript-eslint/no-explicit-any */
    set(option, value) {
        if (!this._instance)
            return;
        this._instance.set(option, value);
    }
    setDate(date, triggerChange, dateStrFormat) {
        if (!this._instance)
            return;
        this._instance.setDate(date, triggerChange, dateStrFormat);
    }
    toggle() {
        if (!this._instance)
            return;
    }
    getSelectedDates() {
        if (!this._instance)
            return [];
        return this._instance.selectedDates;
    }
    getCurrentYear() {
        if (!this._instance)
            return -1;
        return this._instance.currentYear;
    }
    getCurrentMonth() {
        if (!this._instance)
            return -1;
        return this._instance.currentMonth;
    }
    getConfig() {
        if (!this._instance)
            return {};
        return this._instance.config;
    }
    getValue() {
        if (!this._inputElement)
            return '';
        return this._inputElement.value;
    }
    render() {
        return x$1 `
      ${!this._hasSlottedElement
            ? x$1 `<input class="lit-flatpickr flatpickr flatpickr-input" placeholder=${this.placeholder} />`
            : x$1 ``}
      <slot></slot>
    `;
    }
};
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "placeholder", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "altFormat", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "altInput", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "altInputClass", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "allowInput", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "ariaDateFormat", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "clickOpens", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "dateFormat", void 0);
__decorate([
    e$c({ type: Object })
], LitFlatpickr.prototype, "defaultDate", void 0);
__decorate([
    e$c({ type: Number })
], LitFlatpickr.prototype, "defaultHour", void 0);
__decorate([
    e$c({ type: Number })
], LitFlatpickr.prototype, "defaultMinute", void 0);
__decorate([
    e$c({ type: Array })
], LitFlatpickr.prototype, "disable", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "disableMobile", void 0);
__decorate([
    e$c({ type: Array })
], LitFlatpickr.prototype, "enable", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "enableTime", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "enableSeconds", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "formatDateFn", void 0);
__decorate([
    e$c({ type: Number })
], LitFlatpickr.prototype, "hourIncrement", void 0);
__decorate([
    e$c({ type: Number })
], LitFlatpickr.prototype, "minuteIncrement", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "inline", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "maxDate", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "minDate", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "mode", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "nextArrow", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "prevArrow", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "noCalendar", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onChange", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onClose", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onOpen", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onReady", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onMonthChange", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onYearChange", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "onValueUpdate", void 0);
__decorate([
    e$c({ type: Function })
], LitFlatpickr.prototype, "parseDateFn", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "position", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "shorthandCurrentMonth", void 0);
__decorate([
    e$c({ type: Number })
], LitFlatpickr.prototype, "showMonths", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "static", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "time_24hr", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "weekNumbers", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "wrap", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "theme", void 0);
__decorate([
    e$c({ type: Number })
], LitFlatpickr.prototype, "firstDayOfWeek", void 0);
__decorate([
    e$c({ type: String })
], LitFlatpickr.prototype, "locale", void 0);
__decorate([
    e$c({ type: Boolean })
], LitFlatpickr.prototype, "_hasSlottedElement", void 0);
LitFlatpickr = __decorate([
    e$d('lit-flatpickr')
], LitFlatpickr);

var _templateObject$N;
function _taggedTemplateLiteral$N(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var dateStyles = [colorsDefStyles, i$b(_templateObject$N || (_templateObject$N = _taggedTemplateLiteral$N(["\n\t:host {\n\t\tdisplay: block;\n\t\twhite-space: nowrap;\n\t\tmin-width: fit-content;\n\t}\n\t.overdue {\n\t\tcolor: red; // var(--whatever the theme color)\n\t}\n\tinput.flatpickr {\n\t\tborder: 1px solid;\n\t\tborder-color: var(--input-border-color);\n\t\tcolor: var(--input-text-color);\n\t\tpadding-top: 4px;\n\t\tpadding-bottom: 4px;\n\t\tflex: 1 1 auto;\n\t}\n\tinput.flatpickr:hover {\n\t\tbackground-image: ", ";\n\t\tbackground-repeat: no-repeat;\n\t\tbackground-position-x: right;\n\t\tbackground-position-y: 1px;\n\t\tbackground-size: 18px;\n\t}\n"])), cssImage("datepopup"))];

var scrollPluginExports = {};
var scrollPlugin$1 = {
  get exports(){ return scrollPluginExports; },
  set exports(v){ scrollPluginExports = v; },
};

(function (module, exports) {
	(function (global, factory) {
	  'object' === 'object' && 'object' !== 'undefined' ? module.exports = factory() :
	  typeof undefined === 'function' && undefined.amd ? undefined(factory) :
	  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.scrollPlugin = factory());
	}(commonjsGlobal$1, (function () { 'use strict';

	  function getEventTarget(event) {
	      try {
	          if (typeof event.composedPath === "function") {
	              var path = event.composedPath();
	              return path[0];
	          }
	          return event.target;
	      }
	      catch (error) {
	          return event.target;
	      }
	  }

	  if (typeof window.CustomEvent !== "function") {
	      function CustomEvent(typeArg, eventInitDict) {
	          eventInitDict = eventInitDict || {
	              bubbles: false,
	              cancelable: false,
	              detail: undefined,
	          };
	          var evt = document.createEvent("CustomEvent");
	          evt.initCustomEvent(typeArg, eventInitDict.bubbles, eventInitDict.cancelable, eventInitDict.detail);
	          return evt;
	      }
	      CustomEvent.prototype = window.Event.prototype;
	      window.CustomEvent = CustomEvent;
	  }
	  function delta(e) {
	      return Math.max(-1, Math.min(1, e.wheelDelta || -e.deltaY));
	  }
	  var scroll = function (e) {
	      e.preventDefault();
	      var ev = new CustomEvent("increment", {
	          bubbles: true,
	      });
	      ev.delta = delta(e);
	      getEventTarget(e).dispatchEvent(ev);
	  };
	  function scrollMonth(fp) {
	      return function (e) {
	          e.preventDefault();
	          var mDelta = delta(e);
	          fp.changeMonth(mDelta);
	      };
	  }
	  function scrollPlugin() {
	      return function (fp) {
	          var monthScroller = scrollMonth(fp);
	          return {
	              onReady: function () {
	                  if (fp.timeContainer) {
	                      fp.timeContainer.addEventListener("wheel", scroll);
	                  }
	                  fp.yearElements.forEach(function (yearElem) {
	                      return yearElem.addEventListener("wheel", scroll);
	                  });
	                  fp.monthElements.forEach(function (monthElem) {
	                      return monthElem.addEventListener("wheel", monthScroller);
	                  });
	                  fp.loadedPlugins.push("scroll");
	              },
	              onDestroy: function () {
	                  if (fp.timeContainer) {
	                      fp.timeContainer.removeEventListener("wheel", scroll);
	                  }
	                  fp.yearElements.forEach(function (yearElem) {
	                      return yearElem.removeEventListener("wheel", scroll);
	                  });
	                  fp.monthElements.forEach(function (monthElem) {
	                      return monthElem.removeEventListener("wheel", monthScroller);
	                  });
	              },
	          };
	      };
	  }

	  return scrollPlugin;

	})));
} (scrollPlugin$1, scrollPluginExports));

var scrollPlugin = scrollPluginExports;

var shortcutButtonsFlatpickrExports = {};
var shortcutButtonsFlatpickr = {
  get exports(){ return shortcutButtonsFlatpickrExports; },
  set exports(v){ shortcutButtonsFlatpickrExports = v; },
};

(function (module, exports) {
	(function webpackUniversalModuleDefinition(root, factory) {
		if('object' === 'object' && 'object' === 'object')
			module.exports = factory();
		else if(typeof undefined === 'function' && undefined.amd)
			undefined([], factory);
		else if('object' === 'object')
			exports["ShortcutButtonsPlugin"] = factory();
		else
			root["ShortcutButtonsPlugin"] = factory();
	})(window, function() {
	return /******/ (function(modules) { // webpackBootstrap
	/******/ 	// The module cache
	/******/ 	var installedModules = {};
	/******/
	/******/ 	// The require function
	/******/ 	function __webpack_require__(moduleId) {
	/******/
	/******/ 		// Check if module is in cache
	/******/ 		if(installedModules[moduleId]) {
	/******/ 			return installedModules[moduleId].exports;
	/******/ 		}
	/******/ 		// Create a new module (and put it into the cache)
	/******/ 		var module = installedModules[moduleId] = {
	/******/ 			i: moduleId,
	/******/ 			l: false,
	/******/ 			exports: {}
	/******/ 		};
	/******/
	/******/ 		// Execute the module function
	/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
	/******/
	/******/ 		// Flag the module as loaded
	/******/ 		module.l = true;
	/******/
	/******/ 		// Return the exports of the module
	/******/ 		return module.exports;
	/******/ 	}
	/******/
	/******/
	/******/ 	// expose the modules object (__webpack_modules__)
	/******/ 	__webpack_require__.m = modules;
	/******/
	/******/ 	// expose the module cache
	/******/ 	__webpack_require__.c = installedModules;
	/******/
	/******/ 	// define getter function for harmony exports
	/******/ 	__webpack_require__.d = function(exports, name, getter) {
	/******/ 		if(!__webpack_require__.o(exports, name)) {
	/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
	/******/ 		}
	/******/ 	};
	/******/
	/******/ 	// define __esModule on exports
	/******/ 	__webpack_require__.r = function(exports) {
	/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
	/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
	/******/ 		}
	/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
	/******/ 	};
	/******/
	/******/ 	// create a fake namespace object
	/******/ 	// mode & 1: value is a module id, require it
	/******/ 	// mode & 2: merge all properties of value into the ns
	/******/ 	// mode & 4: return value when already ns object
	/******/ 	// mode & 8|1: behave like require
	/******/ 	__webpack_require__.t = function(value, mode) {
	/******/ 		if(mode & 1) value = __webpack_require__(value);
	/******/ 		if(mode & 8) return value;
	/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
	/******/ 		var ns = Object.create(null);
	/******/ 		__webpack_require__.r(ns);
	/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
	/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
	/******/ 		return ns;
	/******/ 	};
	/******/
	/******/ 	// getDefaultExport function for compatibility with non-harmony modules
	/******/ 	__webpack_require__.n = function(module) {
	/******/ 		var getter = module && module.__esModule ?
	/******/ 			function getDefault() { return module['default']; } :
	/******/ 			function getModuleExports() { return module; };
	/******/ 		__webpack_require__.d(getter, 'a', getter);
	/******/ 		return getter;
	/******/ 	};
	/******/
	/******/ 	// Object.prototype.hasOwnProperty.call
	/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
	/******/
	/******/ 	// __webpack_public_path__
	/******/ 	__webpack_require__.p = "";
	/******/
	/******/
	/******/ 	// Load entry module and return exports
	/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
	/******/ })
	/************************************************************************/
	/******/ ({

	/***/ "./src/index.ts":
	/*!**********************!*\
	  !*** ./src/index.ts ***!
	  \**********************/
	/*! no static exports found */
	/***/ (function(module, exports, __webpack_require__) {

	"use strict";

	/*
	 * Copyright (c) 2018 João Morais under the MIT license.
	 * https://github.com/jcsmorais/shortcut-buttons-flatpickr/
	 */
	var __assign = (this && this.__assign) || function () {
	    __assign = Object.assign || function(t) {
	        for (var s, i = 1, n = arguments.length; i < n; i++) {
	            s = arguments[i];
	            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
	                t[p] = s[p];
	        }
	        return t;
	    };
	    return __assign.apply(this, arguments);
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.ShortcutButtonsPlugin = void 0;
	var defaultConfig = {
	    theme: 'light',
	};
	/**
	 * List of attributes that can be set through button's options.
	 */
	var supportedAttributes = new Set([
	    'accesskey',
	    'aria-label',
	    'class',
	    'tabindex',
	]);
	/**
	 * Adds shortcut buttons to flatpickr providing users an alternative way to interact with the datetime picker.
	 *
	 * Example usage:
	 *
	 * ```ts
	 * flatpickr('.target-input-element', {
	 *     // ...
	 *     plugins: [ShortcutButtonsPlugin({
	 *         button: {
	 *             label: 'The Beginning Of Time',
	 *         },
	 *         onClick: (index: number, fp: Flatpickr) => {
	 *             // Do something when a button is clicked
	 *         },
	 *         theme: 'light',
	 *     })],
	 * })
	 * ```
	 *
	 * @param config Configuration options.
	 *
	 * Supported options are:
	 *    `button`: button(s).
	 *    `button.attributes`: button's attributes.
	 *    `button.label`: button's label.
	 *    `label`: label including a sentence stating that the user can use the calendar controls or one of the buttons.
	 *    `onClick`: callback(s) invoked when plugin's buttons are clicked.
	 *    `theme`: flatpickr's theme.
	 */
	function ShortcutButtonsPlugin(config) {
	    var cfg = __assign(__assign({}, defaultConfig), config);
	    return function (fp) {
	        /**
	         * Element that wraps this plugin's dependent elements.
	         */
	        var wrapper;
	        /**
	         * Handles click events on plugin's button.
	         */
	        function onClick(event) {
	            event.stopPropagation();
	            event.preventDefault();
	            var target = event.target;
	            if (target.tagName.toLowerCase() !== 'button' || typeof cfg.onClick === 'undefined') {
	                return;
	            }
	            var index = parseInt(target.dataset.index, 10);
	            var callbacks = Array.isArray(cfg.onClick) ?
	                cfg.onClick :
	                [cfg.onClick];
	            for (var _i = 0, callbacks_1 = callbacks; _i < callbacks_1.length; _i++) {
	                var callback = callbacks_1[_i];
	                if (typeof callback === 'function') {
	                    callback(index, fp);
	                }
	            }
	        }
	        /**
	         * Handles key down events on plugin's button.
	         */
	        function onKeyDown(event) {
	            var target = event.target;
	            if (event.key !== 'Tab' || target.tagName.toLowerCase() !== 'button') {
	                return;
	            }
	            if ((event.shiftKey && !target.previousSibling) || (!event.shiftKey && !target.nextSibling)) {
	                event.preventDefault();
	                fp.element.focus();
	            }
	        }
	        /**
	         * Set given button's attributes.
	         */
	        function setButtonsAttributes(button, attributes) {
	            Object.keys(attributes).filter(function (attribute) { return supportedAttributes.has(attribute); }).forEach(function (key) {
	                var _a;
	                if (key === 'class') {
	                    (_a = button.classList).add.apply(_a, attributes[key].split(' '));
	                    return;
	                }
	                button.setAttribute(key, attributes[key]);
	            });
	        }
	        return {
	            /**
	             * Initialize plugin.
	             */
	            onReady: function () {
	                wrapper = document.createElement('div');
	                wrapper.classList.add('shortcut-buttons-flatpickr-wrapper', cfg.theme);
	                if (typeof cfg.label !== 'undefined' && cfg.label.length) {
	                    var label = document.createElement('div');
	                    label.classList.add('shortcut-buttons-flatpickr-label');
	                    label.textContent = cfg.label;
	                    wrapper.appendChild(label);
	                }
	                var buttons = document.createElement('div');
	                buttons.classList.add('shortcut-buttons-flatpickr-buttons');
	                (Array.isArray(cfg.button) ? cfg.button : [cfg.button]).forEach(function (b, index) {
	                    var button = document.createElement('button');
	                    button.type = 'button';
	                    button.classList.add('shortcut-buttons-flatpickr-button');
	                    button.textContent = b.label;
	                    button.dataset.index = String(index);
	                    if (typeof b.attributes !== 'undefined') {
	                        setButtonsAttributes(button, b.attributes);
	                    }
	                    buttons.appendChild(button);
	                    fp.pluginElements.push(button);
	                });
	                wrapper.appendChild(buttons);
	                fp.calendarContainer.appendChild(wrapper);
	                wrapper.addEventListener('click', onClick);
	                wrapper.addEventListener('keydown', onKeyDown);
	            },
	            /**
	             * Clean up before flatpickr is destroyed.
	             */
	            onDestroy: function () {
	                wrapper.removeEventListener('keydown', onKeyDown);
	                wrapper.removeEventListener('click', onClick);
	                wrapper = undefined;
	            },
	        };
	    };
	}
	exports.ShortcutButtonsPlugin = ShortcutButtonsPlugin;


	/***/ })

	/******/ })["ShortcutButtonsPlugin"];
	});
} (shortcutButtonsFlatpickr, shortcutButtonsFlatpickrExports));

var ShortcutButtonsPlugin = /*@__PURE__*/getDefaultExportFromCjs(shortcutButtonsFlatpickrExports);

var _templateObject$M, _templateObject2$v, _templateObject3$g, _templateObject4$b, _templateObject5$9;
function asyncGeneratorStep$b(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$b(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$b(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$b(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$D(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$D(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$D(Object(source), true).forEach(function (key) { _defineProperty$1j(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$D(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1j(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$M(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// list of existing localizations from node_modules/flatpicker/dist/l10n directory:
var l10n = ['ar', 'at', 'az', 'be', 'bg', 'bn', 'bs', 'cat', 'cs', 'cy', 'da', 'de', 'eo', 'es', 'et', 'fa', 'fi', 'fo', 'fr', 'ga', 'gr', 'he', 'hi', 'hr', 'hu', 'id', 'index', 'is', 'it', 'ja', 'ka', 'km', 'ko', 'kz', 'lt', 'lv', 'mk', 'mn', 'ms', 'my', 'nl', 'no', 'pa', 'pl', 'pt', 'ro', 'ru', 'si', 'sk', 'sl', 'sq', 'sr-cyr', 'sr', 'sv', 'th', 'tr', 'uk', 'uz', 'uz_latn', 'vn', 'zh-tw', 'zh'];
var lang = egw$1 ? egw$1.preference('lang') || "" : "";
// only load localization, if we have one
if (l10n.indexOf(lang) >= 0) {
  import(egw$1.webserverUrl + "/node_modules/flatpickr/dist/l10n/" + lang + ".js").then(() => {
    // @ts-ignore
    flatpickr$1.localize(flatpickr$1.l10ns[lang]);
  });
}

/**
 * Parse a date string into a Date object
 * Time will be 00:00:00 UTC
 *
 * @param {string} dateString
 * @returns {Date | undefined}
 */
function parseDate(dateString, formatString) {
  // First try the server format
  if (dateString.substr(-1) === "Z") {
    try {
      var date = new Date(dateString);
      if (date instanceof Date) {
        return date;
      }
    } catch (e) {
      // Nope, that didn't parse directly
    }
  }
  formatString = formatString || window.egw.preference("dateformat") || 'Y-m-d';
  //@ts-ignore replaceAll() does not exist
  formatString = formatString.replaceAll(new RegExp('[-/\.]', 'ig'), '-');
  var parsedString = "";
  switch (formatString) {
    case 'd-m-Y':
      parsedString = "".concat(dateString.slice(6, 10), "/").concat(dateString.slice(3, 5), "/").concat(dateString.slice(0, 2));
      break;
    case 'm-d-Y':
      parsedString = "".concat(dateString.slice(6, 10), "/").concat(dateString.slice(0, 2), "/").concat(dateString.slice(3, 5));
      break;
    case 'Y-m-d':
      parsedString = "".concat(dateString.slice(0, 4), "/").concat(dateString.slice(5, 7), "/").concat(dateString.slice(8, 10));
      break;
    case 'Y-d-m':
      parsedString = "".concat(dateString.slice(0, 4), "/").concat(dateString.slice(8, 10), "/").concat(dateString.slice(5, 7));
      break;
    case 'd-M-Y':
      parsedString = "".concat(dateString.slice(6, 10), "/").concat(dateString.slice(3, 5), "/").concat(dateString.slice(0, 2));
      break;
    case 'Ymd':
      // Not a preference option, but used by some dates
      parsedString = "".concat(dateString.slice(0, 4), "/").concat(dateString.slice(4, 6), "/").concat(dateString.slice(6, 8));
      break;
    default:
      parsedString = '0000/00/00';
  }
  var [year, month, day] = parsedString.split('/').map(Number);
  var parsedDate = new Date("".concat(year, "-").concat(month < 10 ? "0" + month : month, "-").concat(day < 10 ? "0" + day : day, "T00:00:00Z"));

  // Check if parsedDate is not `Invalid Date` or that the date has changed (e.g. the not existing 31.02.2020)
  if (year > 0 && month > 0 && day > 0 && parsedDate.getUTCDate() === day && parsedDate.getUTCMonth() === month - 1) {
    return parsedDate;
  }
  return undefined;
}

/**
 * To parse a time into a Date object
 * Date will be 1970-01-01, time is in UTC to avoid browser issues
 *
 * @param {string} timeString
 * @returns {Date | undefined}
 */
function parseTime(timeString) {
  // First try the server format
  if (timeString.substr(-1) === "Z") {
    try {
      var date = new Date(timeString);
      if (date instanceof Date) {
        return date;
      }
    } catch (e) {
      // Nope, that didn't parse directly
    }
  }
  var am_pm = timeString.endsWith("pm") || timeString.endsWith("PM") ? 12 : 0;
  var strippedString = timeString.replaceAll(/[^0-9:]/gi, '');
  if (timeString.startsWith("12") && strippedString != timeString) {
    // 12:xx am -> 0:xx, 12:xx pm -> 12:xx
    am_pm -= 12;
  }
  var [hour, minute] = strippedString.split(':').map(Number);
  var parsedDate = new Date("1970-01-01T00:00:00Z");
  parsedDate.setUTCHours(hour + am_pm);
  parsedDate.setUTCMinutes(minute);

  // Check if parsedDate is not `Invalid Date` or that the time has changed
  if (parsedDate.getUTCHours() === hour + am_pm && parsedDate.getUTCMinutes() === minute) {
    return parsedDate;
  }
  return undefined;
}

/**
 * To parse a date+time into an object
 * Time is in UTC to avoid browser issues
 *
 * @param {string} dateTimeString
 * @returns {Date | undefined}
 */
function parseDateTime(dateTimeString) {
  // First try some common invalid values
  if (dateTimeString === "" || dateTimeString === "0" || dateTimeString === 0) {
    return undefined;
  }

  // Next try server format
  if (typeof dateTimeString === "string" && dateTimeString.substr(-1) === "Z" || !isNaN(dateTimeString)) {
    if (!isNaN(dateTimeString) && parseInt(dateTimeString) == dateTimeString) {
      console.warn("Invalid date/time string: " + dateTimeString);
      dateTimeString *= 1000;
    }
    try {
      var _date = new Date(dateTimeString);
      if (_date instanceof Date) {
        return _date;
      }
    } catch (e) {
      // Nope, that didn't parse directly
    }
  }
  var date = parseDate(dateTimeString);
  var explody = dateTimeString.split(" ");
  explody.shift();
  var time = parseTime(explody.join(" "));
  if (typeof date === "undefined" || typeof time === "undefined") {
    return undefined;
  }
  date.setUTCHours(time.getUTCHours());
  date.setUTCMinutes(time.getUTCMinutes());
  date.setUTCSeconds(time.getUTCSeconds());
  return date;
}

/**
 * Format dates according to user preference
 *
 * @param {Date} date
 * @param {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} [options] Intl options are available
 * 	set 'dateFormat': "Y-m-d" to specify a particular format
 * @returns {string}
 */
function formatDate$1(date) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    dateFormat: ""
  };
  if (!date || !(date instanceof Date)) {
    return "";
  }
  var _value = '';
  var dateformat = options.dateFormat || window.egw.preference("dateformat") || 'Y-m-d';
  var replace_map = {
    d: (date.getUTCDate() < 10 ? "0" : "") + date.getUTCDate(),
    m: (date.getUTCMonth() < 9 ? "0" : "") + (date.getUTCMonth() + 1),
    Y: "" + date.getUTCFullYear(),
    H: ("0" + date.getUTCHours()).slice(-2),
    i: ("0" + date.getUTCMinutes()).slice(-2)
  };
  if (dateformat.indexOf("M") != -1) {
    replace_map["M"] = flatpickr$1.formatDate(date, "M");
  }
  var re = new RegExp(Object.keys(replace_map).join("|"), "g");
  _value = dateformat.replace(re, function (matched) {
    return replace_map[matched];
  });
  return _value;
}

/**
 * Format dates according to user preference
 *
 * @param {Date} date
 * @param {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} [options] Intl options are available
 * 	set 'timeFormat': "12" to specify a particular format
 * @returns {string}
 */
function formatTime(date) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    timeFormat: ""
  };
  if (!date || !(date instanceof Date)) {
    return "";
  }
  var _value = '';
  var timeformat = options.timeFormat || window.egw.preference("timeformat") || "24";
  var hours = timeformat == "12" && date.getUTCHours() > 12 ? date.getUTCHours() - 12 : date.getUTCHours();
  if (timeformat == "12" && hours == 0) {
    // 00:00 is 12:00 am
    hours = 12;
  }
  _value = (timeformat == "24" && hours < 10 ? "0" : "") + hours + ":" + (date.getUTCMinutes() < 10 ? "0" : "") + date.getUTCMinutes() + (timeformat == "24" ? "" : date.getUTCHours() < 12 ? " am" : " pm");
  return _value;
}

/**
 * Format date+time according to user preference
 *
 * @param {Date} date
 * @param {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} [options] Intl options are available
 * 	set 'dateFormat': "Y-m-d", 'timeFormat': "12" to specify a particular format
 * @returns {string}
 */
function formatDateTime(date) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    dateFormat: "",
    timeFormat: ""
  };
  if (!date || !(date instanceof Date)) {
    return "";
  }
  return formatDate$1(date, options) + " " + formatTime(date, options);
}

// !!! ValidateMixin !!!
class Et2Date extends Et2InputWidget(FormControlMixin(LitFlatpickr)) {
  static get styles() {
    return [...(super.styles ? Array.isArray(super.styles) ? super.styles : [super.styles] : []), shoelace, dateStyles, i$b(_templateObject$M || (_templateObject$M = _taggedTemplateLiteral$M(["\n\t\t\t  :host {\n\t\t\t\twidth: auto;\n\t\t\t  }\n\n\t\t\t  ::slotted([slot='input']) {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\tmin-width: 12ex;\n\t\t\t  }\n\n\t\t\t  /* Scroll buttons */\n\n\t\t\t  .input-group__container {\n\t\t\t\tposition: relative;\n\t\t\t  }\n\n\t\t\t  .input-group__container:hover .et2-date-time__scrollbuttons {\n\t\t\t\tdisplay: flex;\n\t\t\t  }\n\n\t\t\t  .et2-date-time__scrollbuttons {\n\t\t\t\tdisplay: none;\n\t\t\t\tflex-direction: column;\n\t\t\t\twidth: calc(var(--sl-input-height-medium) / 2);\n\t\t\t\tposition: absolute;\n\t\t\t\tright: 0px;\n\t\t\t  }\n\n\t\t\t  .et2-date-time__scrollbuttons > * {\n\t\t\t\tfont-size: var(--sl-font-size-2x-small);\n\t\t\t\theight: calc(var(--sl-input-height-medium) / 2);\n\t\t\t  }\n\t\t\t.et2-date-time__scrollbuttons > *::part(base) {\n\t\t\t\tpadding: 3px;\n\t\t\t}\n            "])))];
  }
  static get properties() {
    return _objectSpread$D(_objectSpread$D({}, super.properties), {}, {
      /**
       * Display the calendar inline instead of revealed as needed
       */
      inline: {
        type: Boolean
      },
      /**
       * Placeholder text for input
       */
      placeholder: {
        type: String
      },
      /**
       * Allow value that is not a multiple of minuteIncrement
       *
       * eg: 11:23 with default 5 minuteIncrement = 11:25
       * 16:47 with 30 minuteIncrement = 17:00
       * If false (default), it is impossible to have a time that is not a multiple of minuteIncrement.
       * Does not affect scroll, which always goes to nearest multiple.
       */
      freeMinuteEntry: {
        type: Boolean
      },
      /**
       * The preferred placement of the calendar popup can be set with the placement attribute.  The default
       * is "auto".  Note that the actual position may vary to ensure the calendar remains in the viewport.
       * Valid placements are "top", "bottom" or "auto".
       */
      placement: {
        type: String,
        noAccessor: true
      }
    });
  }
  get slots() {
    return _objectSpread$D(_objectSpread$D({}, super.slots), {}, {
      input: () => {
        if (typeof egwIsMobile == "function" && egwIsMobile()) {
          // Plain input for mobile
          var _text = document.createElement('input');
          _text.type = this._mobileInputType();
          return _text;
        }
        // This element gets hidden and used for value, but copied by flatpicr and used for input
        var text = document.createElement('et2-textbox');
        text.type = "text";
        text.placeholder = this.placeholder;
        text.required = this.required;
        return text;
      }
    });
  }
  constructor() {
    super();

    // By default, 5 minute resolution (see minuteIncrement to change resolution)
    this.freeMinuteEntry = false;
    this._onDayCreate = this._onDayCreate.bind(this);
    this._handleInputChange = this._handleInputChange.bind(this);
    this._onReady = this._onReady.bind(this);
    this.handleScroll = this.handleScroll.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    this._updateValueOnChange = this._updateValueOnChange.bind(this);
    this._handleShortcutButtonClick = this._handleShortcutButtonClick.bind(this);
  }
  disconnectedCallback() {
    var _this$_inputNode, _this$findInputField;
    super.disconnectedCallback();
    (_this$_inputNode = this._inputNode) === null || _this$_inputNode === void 0 || _this$_inputNode.removeEventListener('change', this._onChange);
    (_this$findInputField = this.findInputField()) === null || _this$findInputField === void 0 || _this$findInputField.removeEventListener("input", this._handleInputChange);
  }

  /**
   * Override parent to skip call to CDN
   * @returns {Promise<void>}
   */
  init() {
    var _this = this;
    return _asyncToGenerator$b(function* () {
      // Plain input for mobile
      if (typeof egwIsMobile == "function" && egwIsMobile()) {
        return;
      }
      if (_this.locale) {
        //	await loadLocale(this.locale);
      }
      if (typeof _this._instance === "undefined") {
        if (_this.getOptions().allowInput) {
          // Change this so it uses findInputField() to get the input
          _this._hasSlottedElement = true;

          // Wait for everything to be there before we start flatpickr
          yield _this.updateComplete;
          yield _this._inputNode.updateComplete;
          _this._inputNode.requestUpdate();
          yield _this._inputNode.updateComplete;

          // Set flag attribute on _internal_ input - flatpickr needs an <input>
          if (_this._inputNode.shadowRoot.querySelectorAll("input[type='text']").length == 1) {
            _this.findInputField().setAttribute("data-input", "");
          }
          if (_this.defaultDate) {
            _this._inputNode.value = flatpickr$1.formatDate(_this.defaultDate, _this.getOptions().dateFormat);
          }
        }
        _this.initializeComponent();

        // This has to go in init() rather than connectedCallback() because flatpickr creates its nodes in
        // initializeComponent() so this._inputNode is not available before this
        _this.findInputField().addEventListener('change', _this._updateValueOnChange);
        _this.findInputField().addEventListener("input", _this._handleInputChange);
      }
    })();
  }

  /**
   * Override some flatpickr defaults to get things how we like it
   *
   * @see https://flatpickr.js.org/options/
   * @returns {any}
   */
  getOptions() {
    var _this$egw;
    var options = super.getOptions();
    options.altFormat = ((_this$egw = this.egw()) === null || _this$egw === void 0 ? void 0 : _this$egw.preference("dateformat")) || "Y-m-d";
    options.altInput = true;
    options.allowInput = true;
    options.dateFormat = "Y-m-dT00:00:00\\Z";
    options.weekNumbers = true;
    // Wrap needs to be false because flatpickr can't look inside et2-textbox and find the <input> it wants
    // We provide it directly through findInputField()
    options.wrap = false;
    options.onDayCreate = this._onDayCreate;
    this._localize(options);
    if (this.inline) {
      options.inline = this.inline;
    }
    if (this.placement) {
      options.position = this._convert_placement(this.placement);
    }
    options.plugins = [
    // Turn on scroll wheel support
    // @ts-ignore TypeScript can't find scrollPlugin, but rollup does
    new scrollPlugin()];
    // Add "Ok" and "today" buttons
    var buttons = this._buttonPlugin();
    if (buttons) {
      options.plugins.push(buttons);
    }

    // Listen for flatpickr change so we can update internal value, needed for validation
    options.onChange = this._updateValueOnChange;
    options.onReady = this._onReady;

    // Remove Lion's inert attribute so we can work in Et2Dialog
    options.onOpen = [() => {
      var _this$_instance$calen;
      (_this$_instance$calen = this._instance.calendarContainer) === null || _this$_instance$calen === void 0 || _this$_instance$calen.removeAttribute("inert");
    }];
    return options;
  }

  /**
   * Handle click on shortcut button(s) like "Today"
   *
   * @param button_index
   * @param fp Flatpickr instance
   */
  _handleShortcutButtonClick(button_index, fp) {
    switch (button_index) {
      case 0:
        // OK
        fp.close();
        break;
      default:
        fp.setDate(new Date());
    }
  }

  /**
   * Set localize options & translations
   * @param options
   * @protected
   */
  _localize(options) {
    var _this$egw2;
    var first_dow = ((_this$egw2 = this.egw()) === null || _this$egw2 === void 0 ? void 0 : _this$egw2.preference('weekdaystarts', 'calendar')) || 'Monday';
    var DOW_MAP = {
      Monday: 1,
      Sunday: 0,
      Saturday: 6
    };
    options.locale = {
      firstDayOfWeek: DOW_MAP[first_dow]
    };
  }

  /**
   * For mobile, we use a plain input of the proper type
   * @returns {string}
   */
  _mobileInputType() {
    return "date";
  }

  /**
   * Add "today" button below calendar
   * @protected
   */
  _buttonPlugin() {
    // @ts-ignore TypeScript can't find ShortcutButtonsPlugin, but rollup does
    return ShortcutButtonsPlugin({
      button: [{
        label: this.egw().lang("ok")
      }, {
        label: this.egw().lang("Today")
      }],
      onClick: this._handleShortcutButtonClick
    });
  }
  set value(value) {
    if (!value || value == 0 || value == "0") {
      value = "";
      this.clear();
      return;
    }
    var date;
    // handle relative time (eg. "+3600" or "-3600") used in calendar
    if (typeof value === 'string' && (value[0] === '+' || value[0] === '-')) {
      date = new Date(this.getValue());
      date.setSeconds(date.getSeconds() + parseInt(value));
    } else {
      date = new Date(value);
    }
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      if (this._inputNode) {
        this._inputNode.value = isNaN(date) ? "" : this.format(date);
      } else {
        this.updateComplete.then(() => {
          this._inputNode.value = isNaN(date) ? "" : this.format(date);
        });
      }
      return;
    }
    // Handle timezone offset, flatpickr uses local time
    var formatDate = new Date(date.valueOf() + date.getTimezoneOffset() * 60 * 1000);
    if (!this._instance) {
      this.defaultDate = formatDate;
    } else {
      this.setDate(formatDate);
    }
    this.requestUpdate("value", this._oldValue);
  }
  get value() {
    if (!this._inputElement) {
      var _this$_inputNode2, _this$_inputNode4;
      if (this.defaultDate) {
        return flatpickr$1.formatDate(this.defaultDate, this.getOptions().dateFormat);
      }
      if (typeof egwIsMobile == "function" && egwIsMobile() && (_this$_inputNode2 = this._inputNode) !== null && _this$_inputNode2 !== void 0 && _this$_inputNode2.value) {
        var _this$_inputNode3;
        return ((_this$_inputNode3 = this._inputNode) === null || _this$_inputNode3 === void 0 ? void 0 : _this$_inputNode3.value) + "Z";
      }
      return ((_this$_inputNode4 = this._inputNode) === null || _this$_inputNode4 === void 0 ? void 0 : _this$_inputNode4.value) || '';
    }
    var value = this._inputElement.value;

    // Empty field, return ''
    if (!value) {
      return '';
    }
    return value;
  }
  get parse() {
    return parseDate;
  }
  get format() {
    // Mobile is specific about the date format, no time allowed
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      return date => {
        return formatDate$1(date, {
          dateFormat: "Y-m-d"
        });
      };
    }
    return formatDate$1;
  }
  set format(_format) {
    // ignored, trying to fix TypeError opening a new contact
  }

  /**
   * Inline calendars need a slot
   *
   * @return {TemplateResult}
   * @protected
   */
  // eslint-disable-next-line class-methods-use-this
  _inputGroupAfterTemplate() {
    return x$1(_templateObject2$v || (_templateObject2$v = _taggedTemplateLiteral$M(["\n            <div class=\"input-group__after\">\n                <slot name=\"after\"></slot>\n                <slot/>\n            </div>\n\t\t"])));
  }

  /**
   * Update the calendar when the input value changes
   * Otherwise, user's change will be overwritten by calendar popup when the input loses focus
   *
   * @param e
   */
  _handleInputChange(e) {
    // Update
    var value = this.findInputField().value;
    if (value === "" && this._instance.selectedDates.length > 0) {
      // Update the et2-textbox so it will fail a required validation check
      this._inputNode.value = '';
      this._instance.clear();
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));
    }
    var parsedDate = null;
    try {
      parsedDate = this._instance.parseDate(value, this.getOptions().altFormat);
    } catch (e) {
      // Invalid date string
    }
    // If they typed a valid date/time, try to update flatpickr
    if (parsedDate) {
      var formattedDate = flatpickr$1.formatDate(parsedDate, this.getOptions().altFormat);
      if (value === formattedDate &&
      // Avoid infinite loop of setting the same value back triggering another change
      this._instance.input.value !== flatpickr$1.formatDate(parsedDate, this.getOptions().dateFormat)) {
        try {
          // Can error for time-only due to missing calendar
          this._instance.setDate(value, true, this._instance.config.altFormat);
        } catch (e) {
          // Just do it again, it works the second time
          this._instance.setDate(value, true, this._instance.config.altFormat);
        }
      }
      // Update the et2-textbox so it has current value for any (required) validation
      this._inputNode.value = formattedDate;
      this._inputNode.validate();
    }
    this.dispatchEvent(new Event("change", {
      bubbles: true
    }));
  }

  /**
   * Change handler setting modelValue for validation
   *
   * @param _ev
   * @returns
   */
  _updateValueOnChange(selectedDates, dateStr, instance) {
    this.modelValue = this.getValue();
  }
  _onReady(selectedDates, dateStr, instance) {
    this._updateValueOnChange(selectedDates, dateStr, instance);

    // Add any classes we have to the instance
    instance.calendarContainer.classList.add(...this.classList.values());
  }

  /**
   * Customise date rendering
   *
   * @see https://flatpickr.js.org/events/
   *
   * @param {Date} dates Currently selected date(s)
   * @param dStr a string representation of the latest selected Date object by the user. The string is formatted as per the dateFormat option.
   * @param inst flatpickr instance
   * @param dayElement
   * @protected
   */
  _onDayCreate(dates, dStr, inst, dayElement) {
    //@ts-ignore flatpickr adds dateObj to days
    var date = new Date(dayElement.dateObj);
    var f_date = new Date(date.valueOf() - date.getTimezoneOffset() * 60 * 1000);
    if (!f_date) {
      return;
    }
    var set_holiday = function (holidays, element) {
      var day_holidays = holidays[formatDate$1(f_date, {
        dateFormat: "Ymd"
      })];
      var tooltip = '';
      if (typeof day_holidays !== 'undefined' && day_holidays.length) {
        for (var i = 0; i < day_holidays.length; i++) {
          if (typeof day_holidays[i]['birthyear'] !== 'undefined') {
            element.classList.add('calBirthday');
          } else {
            element.classList.add('calHoliday');
          }
          tooltip += day_holidays[i]['name'] + "\n";
        }
      }
      if (tooltip) {
        this.egw().tooltipBind(element, tooltip);
      }
    }.bind(this);
    egw$1.holidays(f_date.getFullYear()).then(h => set_holiday(h, dayElement));
  }

  /**
   * Set the minimum allowed date
   * @param {string | Date} min
   */
  set_min(min) {
    this.minDate = min;
  }
  set minDate(min) {
    if (this._instance) {
      if (min) {
        // Handle timezone offset, flatpickr uses local time
        var date = new Date(min);
        var _formatDate = new Date(date.valueOf() + date.getTimezoneOffset() * 60 * 1000);
        this._instance.set("minDate", _formatDate);
      } else {
        this._instance.set("minDate", "");
      }
    }
  }

  /**
   * Set the minimum allowed date
   * @param {string | Date} max
   */
  set_max(max) {
    this.maxDate = max;
  }
  set maxDate(max) {
    if (this._instance) {
      if (max) {
        // Handle timezone offset, flatpickr uses local time
        var date = new Date(max);
        var _formatDate2 = new Date(date.valueOf() + date.getTimezoneOffset() * 60 * 1000);
        this._instance.set("maxDate", _formatDate2);
      } else {
        this._instance.set("maxDate", "");
      }
    }
  }
  _convert_placement(position) {
    var placement = "auto";
    switch (position) {
      case "top":
        placement = "above";
        break;
      case "bottom":
        placement = "below";
        break;
    }
    return placement;
  }
  get placement() {
    return this.__placement;
  }
  set placement(new_placement) {
    if (this._instance) {
      this._instance.set("position", this._convert_placement(new_placement));
    }
    this.__placement = new_placement;
  }

  /**
   * Override from flatpickr - This is the node we tell flatpickr to use
   * It must be an <input>, flatpickr doesn't understand anything else
   * @returns {any}
   */
  findInputField() {
    var _this$_inputNode5;
    return (_this$_inputNode5 = this._inputNode) === null || _this$_inputNode5 === void 0 || (_this$_inputNode5 = _this$_inputNode5.shadowRoot) === null || _this$_inputNode5 === void 0 ? void 0 : _this$_inputNode5.querySelector('input:not([type="hidden"])');
  }

  /**
   * The interactive (form) element.
   * This is an et2-textbox, which causes some problems with flatpickr
   * @protected
   */
  get _inputNode() {
    return this.querySelector('[slot="input"]');
  }

  /**
   * The holder of value for flatpickr
   */
  get _valueNode() {
    return this.querySelector('et2-textbox');
  }

  /**
   * Handle clicks on scroll buttons
   *
   * @param e
   */
  handleScroll(e) {
    if (e.target && !e.target.dataset.direction) {
      return;
    }
    e.stopPropagation();
    var direction = parseInt(e.target.dataset.direction, 10) || 1;
    this.increment(direction, "day", true);
  }

  /**
   * Increment the current value
   *
   * @param {number} delta Amount of change, positive or negative
   * @param {"day" | "hour" | "minute"} field
   * @param {boolean} roundToDelta Round the current value to a multiple of delta before incrementing
   * 	Useful for keeping things to a multiple of 5, for example.
   */
  increment(delta, field) {
    var roundToDelta = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    var date;
    if (this._inputElement.value) {
      date = new Date(this._inputElement.value);
      // Handle timezone offset, flatpickr uses local time
      date = new Date(date.valueOf() + date.getTimezoneOffset() * 60 * 1000);
    } else {
      // No current value - start with "now", but don't increment at all
      date = new Date();
      delta = 0;
    }
    var fieldMap = {
      day: "UTCDate",
      hour: "UTCHours",
      minute: "UTCMinutes"
    };
    var original = date["get" + fieldMap[field]]();
    // Avoid divide by 0 in case we have no current value, or delta of 0 passed in
    var roundResolution = delta || {
      day: 1,
      hour: this.getOptions().hourIncrement,
      minute: this.getOptions().minuteIncrement
    }[field];
    var bound = roundToDelta ? Math.round(original / roundResolution) * roundResolution : original;
    date["set" + fieldMap[field]](bound + delta);
    this.setDate(date, false, null);
  }
  render() {
    return x$1(_templateObject3$g || (_templateObject3$g = _taggedTemplateLiteral$M(["\n            <div part=\"form-control\" class=\"form-control\">\n                <div class=\"form-field__group-one\" part=\"form-control-label\">", "</div>\n                <div class=\"form-field__group-two\" part=\"form-control-input\">", "</div>\n            </div>\n\t\t"])), this._groupOneTemplate(), this._groupTwoTemplate());
  }
  _inputGroupInputTemplate() {
    return x$1(_templateObject4$b || (_templateObject4$b = _taggedTemplateLiteral$M(["\n            <slot name=\"input\"></slot>\n            ", "\n\t\t"])), this._incrementButtonTemplate());
  }
  _incrementButtonTemplate() {
    // No increment buttons on mobile
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      return '';
    }
    return x$1(_templateObject5$9 || (_templateObject5$9 = _taggedTemplateLiteral$M(["\n            <div class=\"et2-date-time__scrollbuttons\" part=\"scrollbuttons\" @click=", ">\n                <et2-button-icon\n                        noSubmit\n                        image=\"chevron-up\"\n                        data-direction=\"1\"\n                >\u2191\n                </et2-button-icon>\n                <et2-button-icon\n                        noSubmit\n                        image=\"chevron-down\"\n                        data-direction=\"-1\"\n                >\u2193\n                </et2-button-icon>\n            </div>"])), this.handleScroll);
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Date is a LitElement
customElements.define("et2-date", Et2Date);

var _templateObject$L, _templateObject2$u, _templateObject3$f, _templateObject4$a, _templateObject5$8, _templateObject6$5, _templateObject7$3, _templateObject8$2;
function asyncGeneratorStep$a(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$a(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$a(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$a(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$C(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$C(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$C(Object(source), true).forEach(function (key) { _defineProperty$1i(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$C(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$L(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1i(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
;

/**
 * Format a number as a time duration
 *
 * @param {number} value
 * @param {object} options
 * 	set 'timeFormat': "12" to specify a particular format
 * @returns {value: string, unit: string}
 */
function formatDuration(value, options) {
  // Handle empty / 0 / no value
  if (value === "" || value == "0" || !value) {
    return {
      value: options.emptyNot0 ? "0" : "",
      unit: ""
    };
  }
  // Make sure it's a number now
  value = typeof value == "string" ? parseInt(value) : value;
  if (!options.selectUnit) {
    var vals = [];
    for (var i = 0; i < options.displayFormat.length; ++i) {
      var unit = options.displayFormat[i];
      var val = this._unit_from_value(value, unit, i === 0, options);
      if (unit === 's' || unit === 'm' || unit === 'h' && options.displayFormat[0] === 'd') {
        vals.push(sprintf('%02d', val));
      } else {
        vals.push(val);
      }
    }
    return {
      value: vals.join(':'),
      unit: ''
    };
  }

  // Put value into minutes for further processing
  switch (options.dataFormat) {
    case 'd':
      value *= options.hoursPerDay;
    // fall-through
    case 'h':
      value *= 60;
      break;
    case 's':
      // round to full minutes, unless this would give 0, use 1 digit instead
      value = value < 30 ? Math.round(value / 6.0) / 10.0 : Math.round(value / 60.0);
      break;
  }

  // Figure out the best unit for display
  var _unit = options.displayFormat == "d" ? "d" : "h";
  if (options.displayFormat.indexOf('m') > -1 && value < 60) {
    _unit = 'm';
  } else if (options.displayFormat.indexOf('d') > -1 && value >= 60 * options.hoursPerDay) {
    _unit = 'd';
  }
  var out_value = "" + (_unit == 'm' ? value : Math.round(value / 60.0 / (_unit == 'd' ? options.hoursPerDay : 1) * 100) / 100);
  if (out_value === '') {
    _unit = '';
  }

  // use decimal separator from user prefs
  var format = options.number_format || this.egw().preference('number_format');
  var sep = format ? format[0] : '.';
  if (format && sep && sep != '.') {
    out_value = out_value.replace('.', sep);
  }
  return {
    value: out_value,
    unit: _unit
  };
}

/**
 * Display a time duration (eg: 3 days, 6 hours)
 *
 * If not specified, the time is in assumed to be minutes and will be displayed with a calculated unit
 * but this can be specified with the properties.
 */
class Et2DateDuration extends Et2InputWidget(FormControlMixin(s$5)) {
  static get styles() {
    return [...super.styles, shoelace, ...dateStyles, i$b(_templateObject$L || (_templateObject$L = _taggedTemplateLiteral$L(["\n\t\t\t  .form-field__group-two {\n\t\t\t\tmax-width: 100%;\n\t\t\t  }\n\n\t\t\t  .input-group {\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-direction: row;\n\t\t\t\tflex-wrap: nowrap;\n\t\t\t\talign-items: baseline;\n\t\t\t  }\n\n\t\t\t  .input-group__after {\n\t\t\t\tdisplay: contents;\n\t\t\t\tmargin-inline-start: var(--sl-input-spacing-medium);\n\t\t\t  }\n\n\t\t\t  et2-select {\n\t\t\t\tcolor: var(--input-text-color);\n\t\t\t\tborder-left: 1px solid var(--input-border-color);\n\t\t\t\tflex: 2 1 auto;\n\t\t\t  }\n\n\t\t\t  et2-select::part(control) {\n\t\t\t\tborder-top-left-radius: 0px;\n\t\t\t\tborder-bottom-left-radius: 0px;\n\t\t\t  }\n\n\t\t\t  .duration__input {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\tmax-width: 4.5em;\n\t\t\t\tmargin-right: -2px;\n\t\t\t  }\n\n\t\t\t  .duration__input::part(input) {\n\t\t\t\tpadding-right: 0px;\n\t\t\t  }\n\n\t\t\t  .duration__input:not(:last-child)::part(base) {\n\t\t\t\tborder-right: none;\n\t\t\t\tborder-top-right-radius: 0px;\n\t\t\t\tborder-bottom-right-radius: 0px;\n\t\t\t  }\n\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$C(_objectSpread$C({}, super.properties), {}, {
      /**
       * Data format
       *
       * Units to read/store the data.  'd' = days (float), 'h' = hours (float), 'm' = minutes (int), 's' = seconds (int).
       */
      dataFormat: {
        reflect: true,
        type: String
      },
      /**
       * Display format
       *
       * Permitted units for displaying the data.
       * 'd' = days, 'h' = hours, 'm' = minutes, 's' = seconds.  Use combinations to give a choice.
       * Default is 'dh' = days or hours with selectbox.
       */
      displayFormat: {
        reflect: true,
        type: String
      },
      /**
       * Select unit or input per unit
       *
       * Display a unit-selection for multiple units, or an input field per unit.
       * Default is true
       */
      selectUnit: {
        reflect: true,
        type: Boolean
      },
      /**
       * Percent allowed
       *
       * Allows to enter a percentage instead of numbers
       */
      percentAllowed: {
        type: Boolean
      },
      /**
       * Hours per day
       *
       * Number of hours in a day, used for converting between hours and (working) days.
       * Default 8
       */
      hoursPerDay: {
        reflect: true,
        type: Number
      },
      /**
       * 0 or empty
       *
       * Should the widget differ between 0 and empty, which get then returned as NULL
       * Default false, empty is considered as 0
       */
      emptyNot0: {
        reflect: true,
        type: Boolean
      },
      /**
       * Short labels
       *
       * use d/h/m instead of day/hour/minute
       */
      shortLabels: {
        reflect: true,
        type: Boolean
      },
      /**
       * Step limit
       *
       * Works with the min and max attributes to limit the increments at which a numeric or date-time value can be set.
       */
      step: {
        type: String
      }
    });
  }
  constructor() {
    super();

    // Property defaults
    _defineProperty$1i(this, "_display", {
      value: "",
      unit: ""
    });
    this.dataFormat = "m";
    this.displayFormat = "dhm";
    this.selectUnit = true;
    this.percentAllowed = false;
    this.hoursPerDay = 8;
    this.emptyNot0 = false;
    this.shortLabels = false;
    this.formatter = formatDuration;
  }
  getUpdateComplete() {
    var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
      _this = this;
    return _asyncToGenerator$a(function* () {
      var _this$_formatNode;
      var result = yield _superprop_getGetUpdateComplete().call(_this);

      // Format select does not start with value, needs an update
      (_this$_formatNode = _this._formatNode) === null || _this$_formatNode === void 0 || _this$_formatNode.requestUpdate("value");
      return result;
    })();
  }
  transformAttributes(attrs) {
    // Clean formats, but avoid things that need to be expanded like $cont[displayFormat]
    var check = new RegExp('[\$\@' + Object.keys(Et2DateDuration.time_formats).join('') + ']');
    for (var attr in ["displayFormat", "dataFormat"]) {
      if (typeof attrs[attrs] === 'string' && !check.test(attrs[attr])) {
        console.warn("Invalid format for " + attr + "'" + attrs[attr] + "'", this);
        attrs[attr] = attrs[attr].replace(/[^dhms]/g, '');
      }
    }
    super.transformAttributes(attrs);
  }
  get value() {
    var value = 0;
    if (!this.selectUnit) {
      for (var i = this._durationNode.length; --i >= 0;) {
        value += parseInt(this._durationNode[i].value) * this._unit2seconds(this._durationNode[i].name);
      }
      if (this.dataFormat !== 's') {
        value /= this._unit2seconds(this.dataFormat);
      }
      return "" + (this.dataFormat === 'm' ? Math.round(value) : value);
    }
    var val = this._durationNode.length ? this._durationNode[0].valueAsNumber : '';
    if (val === '' || isNaN(val)) {
      return this.emptyNot0 ? '' : "0";
    }
    value = parseFloat(val);

    // Put value into minutes for further processing
    switch (this._formatNode && this._formatNode.value ? this._formatNode.value : this.displayFormat) {
      case 'd':
        value *= this.hoursPerDay;
      // fall-through
      case 'h':
        value *= 60;
        break;
    }
    // Minutes should be an integer.  Floating point math.
    if (this.dataFormat !== 's') {
      value = Math.round(value);
    }
    switch (this.dataFormat) {
      case 'd':
        value /= this.hoursPerDay;
      // fall-through
      case 'h':
        value /= 60.0;
        break;
      case 's':
        value = Math.round(value * 60.0);
        break;
    }
    return "" + value;
  }
  set value(_value) {
    this._display = this._convert_to_display(this.emptyNot0 && "" + _value === "" ? '' : parseFloat(_value));
    this.requestUpdate();
  }

  /**
   * Set the format for displaying the duration
   *
   * @param {string} value
   */
  set displayFormat(value) {
    this.__displayFormat = "";
    if (!value) {
      // Don't allow an empty value, but don't throw a real error
      console.warn("Invalid displayFormat ", value, this);
      value = "dhm";
    }
    // Display format must be in decreasing size order (dhms) or the calculations
    // don't work out nicely
    for (var f of Object.keys(Et2DateDuration.time_formats)) {
      if (value.indexOf(f) !== -1) {
        this.__displayFormat += f;
      }
    }
  }
  get displayFormat() {
    return this.__displayFormat;
  }
  render() {
    return x$1(_templateObject2$u || (_templateObject2$u = _taggedTemplateLiteral$L(["\n            <div part=\"form-control\" class=", ">\n                <div class=\"form-field__group-one form-control__label\" part=\"form-control-label\">\n                    ", "\n                </div>\n                <div class=\"form-field__group-two\" part=\"form-control-input\">", "</div>\n            </div>\n\t\t"])), o$9({
      'form-control': true,
      'form-control--has-label': this.label.split("%")[0] || false
    }), this._groupOneTemplate(), this._groupTwoTemplate());
  }

  /**
   * @return {TemplateResult}
   * @protected
   */
  // eslint-disable-next-line class-methods-use-this
  _inputGroupInputTemplate() {
    return x$1(_templateObject3$f || (_templateObject3$f = _taggedTemplateLiteral$L(["\n            <div class=\"input-group__input\" @sl-change=", ">\n                <slot name=\"input\">\n                    ", "\n                    ", "\n                </slot>\n            </div>\n\t\t"])), () => {
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));
    }, this._inputTemplate(), this._formatTemplate());
  }

  /**
   * Converts the value in data format into value in display format.
   *
   * @param _value int/float Data in data format
   *
   * @return Object {value: Value in display format, unit: unit for display}
   */
  _convert_to_display(_value) {
    if (!this.selectUnit) {
      var vals = [];
      for (var i = 0; i < this.displayFormat.length; ++i) {
        var unit = this.displayFormat[i];
        var val = this._unit_from_value(_value, unit, i === 0, {
          hoursPerDay: this.hoursPerDay,
          dataFormat: this.dataFormat
        });
        if (unit === 's' || unit === 'm' || unit === 'h' && this.displayFormat[0] === 'd') {
          vals.push(sprintf('%02d', val));
        } else {
          vals.push(val);
        }
      }
      return {
        value: vals.join(':'),
        unit: ''
      };
    }
    if (_value) {
      // Put value into minutes for further processing
      switch (this.dataFormat) {
        case 'd':
          _value *= this.hoursPerDay;
        // fall-through
        case 'h':
          _value *= 60;
          break;
        case 's':
          _value /= 60.0;
          break;
      }
    }

    // Figure out best unit for display
    var _unit = this.displayFormat == "d" ? "d" : "h";
    if (this.displayFormat.indexOf('m') > -1 && _value && _value < 60) {
      _unit = 'm';
    } else if (this.displayFormat.indexOf('d') > -1 && _value >= 60 * this.hoursPerDay) {
      _unit = 'd';
    }
    _value = this.emptyNot0 && _value === '' || !this.emptyNot0 && !_value ? '' : _unit == 'm' ? parseInt(_value) : Math.round(_value / 60.0 / (_unit == 'd' ? this.hoursPerDay : 1) * 100) / 100;
    if (_value === '') {
      _unit = '';
    }

    // use decimal separator from user prefs
    var format = this.egw().preference('number_format');
    var sep = format ? format[0] : '.';
    if (typeof _value == 'string' && format && sep && sep != '.') {
      _value = _value.replace('.', sep);
    }
    return {
      value: _value,
      unit: _unit
    };
  }
  _unit2seconds(_unit) {
    switch (_unit) {
      case 's':
        return 1;
      case 'm':
        return 60;
      case 'h':
        return 3600;
      case 'd':
        return 3600 * this.hoursPerDay;
    }
  }
  _unit_from_value(_value, _unit, _highest, options) {
    _value *= this._unit2seconds(options.dataFormat);
    // get value for given _unit
    switch (_unit) {
      case 's':
        return _highest ? _value : _value % 60;
      case 'm':
        _value = Math.floor(_value / 60);
        return _highest ? _value : _value % 60;
      case 'h':
        _value = Math.floor(_value / 3600);
        return _highest ? _value : _value % options.hoursPerDay;
      case 'd':
        return Math.floor(_value / 3600 / options.hoursPerDay);
    }
  }

  /**
   * Render the needed number inputs according to selectUnit & displayFormat properties
   *
   * @returns {any}
   * @protected
   */
  _inputTemplate() {
    var inputs = [];
    var value = typeof this._display.value === "number" ? this._display.value : this._display.value.split(":") || [];
    var count = this.selectUnit ? 1 : this.displayFormat.length;
    for (var i = count; i > 0; --i) {
      var input = {
        name: "",
        title: "",
        value: typeof value == "number" ? value : (this.selectUnit ? value.pop() : value[i]) || "",
        min: undefined,
        max: undefined,
        precision: count == 1 ? 2 : 0
      };
      if (!this.selectUnit) {
        input.min = 0;
        input.name = this.displayFormat[this.displayFormat.length - i];
        // @ts-ignore - it doesn't like that it may have been an array
        input.value = value[this.displayFormat.length - i];
        switch (this.displayFormat[this.displayFormat.length - i]) {
          case 's':
            input.max = 60;
            input.title = this.egw().lang('Seconds');
            break;
          case 'm':
            input.max = 60;
            input.title = this.egw().lang('Minutes');
            break;
          case 'h':
            input.max = 24;
            input.title = this.egw().lang('Hours');
            break;
          case 'd':
            input.title = this.egw().lang('Days');
            break;
        }
      }
      inputs.push(input);
    }
    return x$1(_templateObject4$a || (_templateObject4$a = _taggedTemplateLiteral$L(["", "\n\t\t"])), inputs.map(input => x$1(_templateObject5$8 || (_templateObject5$8 = _taggedTemplateLiteral$L(["\n                    <et2-number part=\"", "\" class=\"duration__input\"\n                                exportparts=\"scroll:scroll,scrollbutton:scrollbutton\"\n                                name=", "\n                                min=", " max=", " precision=", " title=", "\n                                value=", "></et2-number>"])), "duration__" + input.name, input.name, input.min, input.max, input.precision, input.title, input.value)));
  }

  /**
   * Generate the format selector according to the selectUnit and displayFormat properties
   *
   * @returns {any}
   * @protected
   */
  _formatTemplate() {
    // If no formats or only 1 format, no need for a selector
    if (!this.displayFormat || this.displayFormat.length < 1 || !this.selectUnit && this.displayFormat.length > 1) {
      return x$1(_templateObject6$5 || (_templateObject6$5 = _taggedTemplateLiteral$L([""])));
    }
    // Get translations
    this.time_formats = this.time_formats || {
      d: this.shortLabels ? this.egw().lang("d") : this.egw().lang("Days"),
      h: this.shortLabels ? this.egw().lang("h") : this.egw().lang("Hours"),
      m: this.shortLabels ? this.egw().lang("m") : this.egw().lang("Minutes"),
      s: this.shortLabels ? this.egw().lang("s") : this.egw().lang("Seconds")
    };
    // It would be nice to use an et2-select here, but something goes weird with the styling
    var current = this._display.unit || this.displayFormat[0];
    return x$1(_templateObject7$3 || (_templateObject7$3 = _taggedTemplateLiteral$L(["\n            <sl-select value=\"", "\">\n                ", "\n            </sl-select>\n\t\t"])), current, [...this.displayFormat].map(format => x$1(_templateObject8$2 || (_templateObject8$2 = _taggedTemplateLiteral$L(["\n                            <sl-option\n                                    value=", "\n                                    .selected=", "\n                            >\n                                ", "\n                            </sl-option>"])), format, format == current, this.time_formats[format])));
  }

  /**
   * @returns {HTMLInputElement}
   */
  get _durationNode() {
    return this.shadowRoot ? this.shadowRoot.querySelectorAll(".duration__input") || [] : [];
  }

  /**
   * @returns {HTMLSelectElement}
   */
  get _formatNode() {
    return this.shadowRoot ? this.shadowRoot.querySelector("sl-select") : null;
  }
}

// @ts-ignore TypeScript is not recognizing that this is a LitElement
_defineProperty$1i(Et2DateDuration, "time_formats", {
  d: "d",
  h: "h",
  m: "m",
  s: "s"
});
customElements.define("et2-date-duration", Et2DateDuration);

var _templateObject$K, _templateObject2$t, _templateObject3$e;
function _taggedTemplateLiteral$K(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * This is a stripped-down read-only widget used in nextmatch
 */
class Et2DateDurationReadonly extends Et2DateDuration {
  static get styles() {
    return [...super.styles, ...dateStyles, i$b(_templateObject$K || (_templateObject$K = _taggedTemplateLiteral$K(["\n\t\t\t:host {\n\t\t\tborder: none;\n\t\t\tmin-width: 2em;\n\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super();

    // Property defaults
    this.selectUnit = false; // otherwise just best matching unit will be used for eg. display_format "h:m:s"
  }

  get value() {
    return this.__value;
  }
  set value(_value) {
    var old_value = this.__value;
    this.__value = _value;
    this.requestUpdate("value", old_value);
  }
  render() {
    var parsed = this.__value;
    var format_options = {
      selectUnit: this.selectUnit,
      displayFormat: this.displayFormat,
      dataFormat: this.dataFormat,
      numberFormat: this.egw().preference("number_format"),
      hoursPerDay: this.hoursPerDay,
      emptyNot0: this.emptyNot0
    };
    var display = this.formatter(parsed, format_options);
    return x$1(_templateObject2$t || (_templateObject2$t = _taggedTemplateLiteral$K(["\n            <span ", ">\n                  ", "", "\n            </span>\n\t\t"])), this.id ? x$1(_templateObject3$e || (_templateObject3$e = _taggedTemplateLiteral$K(["id=\"", "\""])), this._dom_id) : '', display.value, display.unit);
  }

  /**
   * These are the attributes we allow to change for each row
   *
   * @param attrs
   */
  getDetachedAttributes(attrs) {
    attrs.push("id", "value", "class", "disabled");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-date-duration_ro", Et2DateDurationReadonly);

var web_url_toJson = {};

'use strict';
var $$4 = _export;
var call$1 = functionCall;

// `URL.prototype.toJSON` method
// https://url.spec.whatwg.org/#dom-url-tojson
$$4({ target: 'URL', proto: true, enumerable: true }, {
  toJSON: function toJSON() {
    return call$1(URL.prototype.toString, this);
  }
});

var _templateObject$J, _templateObject2$s, _templateObject3$d, _templateObject4$9, _templateObject5$7;
function ownKeys$B(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$B(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$B(Object(source), true).forEach(function (key) { _defineProperty$1h(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$B(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$J(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1h(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Display a time duration (eg: 3 days, 6 hours)
 *
 * If not specified, the time is in assumed to be minutes and will be displayed with a calculated unit
 * but this can be specified with the properties.
 */
class Et2DateRange extends Et2InputWidget(FormControlMixin(s$5)) {
  static get styles() {
    return [...super.styles, shoelace, ...dateStyles, i$b(_templateObject$J || (_templateObject$J = _taggedTemplateLiteral$J(["\n\n              .input-group {\n                display: flex;\n                flex-direction: row;\n                flex-wrap: nowrap;\n                align-items: baseline;\n              }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$B(_objectSpread$B({}, super.properties), {}, {
      /**
       * Is the date range relative (this week) or absolute (2016-02-15 - 2016-02-21).  This will affect the value returned.
       */
      relative: {
        type: Boolean
      },
      /**
       * An object with keys 'from' and 'to' for absolute ranges, or a relative range string
       */
      value: {
        type: Object
      }
    });
  }
  constructor() {
    super();
  }
  render() {
    var hasLabel = this.label ? true : false;
    var hasHelpText = this.helpText ? true : false;
    return x$1(_templateObject2$s || (_templateObject2$s = _taggedTemplateLiteral$J(["\n            <div part=\"form-control\" class=", ">\n                <div class=\"form-control__label\" part=\"form-control-label\">\n                    <label\n                            part=\"form-control-label\"\n                            class=\"form-control__label\"\n                            for=\"input\"\n                            aria-hidden=", "\n                    >\n                        <slot name=\"label\">", "</slot>\n                    </label>\n                </div>\n                <div class=\"form-control-input\" part=\"form-control-input\">", "</div>\n\t\t\t\t<slot\n\t\t\t\t\t\tname=\"help-text\"\n\t\t\t\t\t\tpart=\"form-control-help-text\"\n\t\t\t\t\t\tid=\"help-text\"\n\t\t\t\t\t\tclass=\"form-control__help-text\"\n\t\t\t\t\t\taria-hidden=", "\n\t\t\t\t>\n\t\t\t\t\t", "\n\t\t\t\t</slot>\n            </div>\n\t\t"])), o$9({
      'form-control': true,
      'form-control--has-label': this.label.split("%")[0] || false
    }), hasLabel ? 'false' : 'true', this.label, this._inputGroupTemplate(), hasHelpText ? 'false' : 'true', this.helpText);
  }
  _inputGroupTemplate() {
    return x$1(_templateObject3$d || (_templateObject3$d = _taggedTemplateLiteral$J(["\n\t\t<slot name=\"prefix\" part=\"prefix\" class=\"input__prefix\"></slot>\n\t\t", "\n\t\t<slot name=\"suffix\" part=\"suffix\" class=\"input__suffix\"></slot>\n\t\t"])), this.relative ? this._inputRelativeTemplate() : this._inputAbsoluteTemplate());
  }

  /**
   * We're doing a relative date range, show the relative options
   * @returns {TemplateResult}
   * @protected
   */
  _inputRelativeTemplate() {
    return x$1(_templateObject4$9 || (_templateObject4$9 = _taggedTemplateLiteral$J(["\n            <et2-select\n                    name=\"relative\"\n                    ?disabled=", "\n                    ?readonly=", "\n                    ?required=", "\n                    placeholder=", "\n                    .emptyLabel=", "\n                    .select_options=", "></et2-select>"])), this.disabled, this.readonly, this.required, l$2(this.placeholder), l$2(this.emptyLabel), Et2DateRange.relative_dates);
  }

  /**
   * We're doing an absolute date range, we need start and end dates
   *
   * @returns {TemplateResult}
   * @protected
   */
  _inputAbsoluteTemplate() {
    var _this$value, _this$value2;
    return x$1(_templateObject5$7 || (_templateObject5$7 = _taggedTemplateLiteral$J(["\n\t\t\t<et2-date\n\t\t\t\tname=\"from\"\n\t\t\t\t?disabled=", "\n\t\t\t\t?readonly=", "\n\t\t\t\t?required=", "\n\t\t\t\tplaceholder=", "\n\t\t\t\tdefaultDate=", "\n            ></et2-date>\n            <et2-date\n                    name=\"to\"\n                    ?disabled=", "\n\t\t\t\t?readonly=", "\n\t\t\t\t?required=", "\n\t\t\t\tplaceholder=", "\n\t\t\t\tvalue=", "\n            ></et2-date>\n\t\t"])), this.disabled, this.readonly, this.required, l$2(this.placeholder), l$2((_this$value = this.value) === null || _this$value === void 0 ? void 0 : _this$value.from), this.disabled, this.readonly, this.required, l$2(this.placeholder), l$2((_this$value2 = this.value) === null || _this$value2 === void 0 ? void 0 : _this$value2.to));
  }
  get fromElement() {
    var _this$shadowRoot;
    return (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector("[name='from']");
  }
  get toElement() {
    var _this$shadowRoot2;
    return (_this$shadowRoot2 = this.shadowRoot) === null || _this$shadowRoot2 === void 0 ? void 0 : _this$shadowRoot2.querySelector("[name='to']");
  }
  get relativeElement() {
    var _this$shadowRoot3;
    return (_this$shadowRoot3 = this.shadowRoot) === null || _this$shadowRoot3 === void 0 ? void 0 : _this$shadowRoot3.querySelector("[name='relative']");
  }
  get value() {
    var _this$fromElement, _this$toElement;
    if (this.relative) {
      var _this$relativeElement;
      return ((_this$relativeElement = this.relativeElement) === null || _this$relativeElement === void 0 ? void 0 : _this$relativeElement.value) || "";
    }
    var val = {
      from: ((_this$fromElement = this.fromElement) === null || _this$fromElement === void 0 || (_this$fromElement = _this$fromElement.findInputField()) === null || _this$fromElement === void 0 ? void 0 : _this$fromElement.value) || null,
      to: ((_this$toElement = this.toElement) === null || _this$toElement === void 0 ? void 0 : _this$toElement.value) || null
    };
    if (val.from) val.from = formatDate$1(parseDate(val.from), {
      dateFormat: "Y-m-dT00:00:00Z"
    });
    if (val.to) val.to = formatDate$1(parseDate(val.to), {
      dateFormat: "Y-m-dT00:00:00Z"
    });
    return val.from || val.to ? val : null;
  }
  set value(new_value) {
    if (!this.isConnected) {
      this.updateComplete.then(() => {
        this.value = new_value;
      });
      return;
    }
    if (this.relative) {
      this.relativeElement.value = new_value;
    } else if (this.fromElement && this.toElement) {
      if (typeof new_value == "string") {
        // Relative -> absolute
        new_value = Et2DateRange.relativeToAbsolute(new_value);
      }
      if (this.fromElement._instance) {
        var _new_value, _new_value2;
        this.fromElement._instance.setDate([(_new_value = new_value) === null || _new_value === void 0 ? void 0 : _new_value.from, (_new_value2 = new_value) === null || _new_value2 === void 0 ? void 0 : _new_value2.to], true);
      } else {
        var _new_value3, _new_value4;
        this.fromElement.value = ((_new_value3 = new_value) === null || _new_value3 === void 0 ? void 0 : _new_value3.from.toJSON()) || "";
        this.toElement.value = ((_new_value4 = new_value) === null || _new_value4 === void 0 ? void 0 : _new_value4.to.toJSON()) || "";
      }
    }
  }
  static relativeToAbsolute(date) {
    var absolute = {
      from: '',
      to: ''
    };
    var relative = Et2DateRange.relative_dates.find(e => e.value.toLowerCase() == date.toLowerCase());
    var tempDate = new Date();
    var today = new Date(tempDate.getFullYear(), tempDate.getMonth(), tempDate.getDate(), 0, -tempDate.getTimezoneOffset(), 0);
    Object.keys(absolute).forEach(k => {
      var value = today.toJSON();
      if (relative && typeof relative[k] == "function") {
        absolute[k] = relative[k](new Date(value));
      }
    });
    return absolute;
  }

  // Class Constants
}
_defineProperty$1h(Et2DateRange, "relative_dates", [
// Start and end are relative offsets, see et2_date.set_min()
// or Date objects
{
  value: 'Today',
  label: egw$1.lang('Today'),
  from(date) {
    return date;
  },
  to(date) {
    return date;
  }
}, {
  label: egw$1.lang('Yesterday'),
  value: 'Yesterday',
  from(date) {
    date.setUTCDate(date.getUTCDate() - 1);
    return date;
  },
  to: ''
}, {
  label: egw$1.lang('This week'),
  value: 'This week',
  from(date) {
    return egw$1.week_start(date);
  },
  to(date) {
    date.setUTCDate(date.getUTCDate() + 6);
    return date;
  }
}, {
  label: egw$1.lang('Last week'),
  value: 'Last week',
  from(date) {
    var d = egw$1.week_start(date);
    d.setUTCDate(d.getUTCDate() - 7);
    return d;
  },
  to(date) {
    date.setUTCDate(date.getUTCDate() + 6);
    return date;
  }
}, {
  label: egw$1.lang('This month'),
  value: 'This month',
  from(date) {
    date.setUTCDate(1);
    return date;
  },
  to(date) {
    date.setUTCMonth(date.getUTCMonth() + 1);
    date.setUTCDate(0);
    return date;
  }
}, {
  label: egw$1.lang('Last month'),
  value: 'Last month',
  from(date) {
    date.setUTCMonth(date.getUTCMonth() - 1);
    date.setUTCDate(1);
    return date;
  },
  to(date) {
    date.setUTCMonth(date.getUTCMonth() + 1);
    date.setUTCDate(0);
    return date;
  }
}, {
  label: egw$1.lang('Last 3 months'),
  value: 'Last 3 months',
  from(date) {
    date.setUTCMonth(date.getUTCMonth() - 2);
    date.setUTCDate(1);
    return date;
  },
  to(date) {
    date.setUTCMonth(date.getUTCMonth() + 3);
    date.setUTCDate(0);
    return date;
  }
}, {
  label: egw$1.lang('This year'),
  value: 'This year',
  from(d) {
    d.setUTCMonth(0);
    d.setUTCDate(1);
    return d;
  },
  to(d) {
    d.setUTCMonth(11);
    d.setUTCDate(31);
    return d;
  }
}, {
  label: egw$1.lang('Last year'),
  value: 'Last year',
  from(d) {
    d.setUTCMonth(0);
    d.setUTCDate(1);
    d.setUTCYear(d.getUTCYear() - 1);
    return d;
  },
  to(d) {
    d.setUTCMonth(11);
    d.setUTCDate(31);
    d.setUTCYear(d.getUTCYear() - 1);
    return d;
  }
}]);
customElements.define("et2-date-range", Et2DateRange);

var _templateObject$I, _templateObject2$r;
function _taggedTemplateLiteral$I(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$A(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$A(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$A(Object(source), true).forEach(function (key) { _defineProperty$1g(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$A(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1g(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * This is a stripped-down read-only widget used in nextmatch
 */
class Et2DateReadonly extends Et2Widget(s$5) {
  static get styles() {
    return [...super.styles, dateStyles];
  }
  static get properties() {
    return _objectSpread$A(_objectSpread$A({}, super.properties), {}, {
      value: String
    });
  }
  constructor() {
    super();
    _defineProperty$1g(this, "parser", void 0);
    _defineProperty$1g(this, "formatter", void 0);
    this.parser = parseDate;
    this.formatter = formatDate$1;
  }
  set_value(value) {
    this.value = value;
  }
  render() {
    var parsed = this.value ? this.parser(this.value) : false;
    return x$1(_templateObject$I || (_templateObject$I = _taggedTemplateLiteral$I(["\n            <span slot=\"label\">", "</span>\n            <time ", "\n                  datetime=\"", "\">\n                ", "\n            </time>\n\t\t"])), this.label, this.id ? x$1(_templateObject2$r || (_templateObject2$r = _taggedTemplateLiteral$I(["id=\"", "\""])), this._dom_id) : '', parsed ? this.formatter(parsed, {
      dateFormat: "Y-m-d",
      timeFormat: "H:i:s"
    }) : "", this.value ? this.formatter(parsed) : '');
  }
  getDetachedAttributes(attrs) {
    attrs.push("id", "value", "class", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
  loadFromXML() {
    // nope
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-date_ro", Et2DateReadonly);

var _templateObject$H, _templateObject2$q;
function _taggedTemplateLiteral$H(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$z(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$z(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$z(Object(source), true).forEach(function (key) { _defineProperty$1f(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$z(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1f(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Formatter for time since widget.
 *
 * @param {Date} date
 * @returns {string}
 */
var formatDate = function formatDate(date) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    units: "YmdHis"
  };
  var unit2label = {
    'Y': 'years',
    'm': 'month',
    'd': 'days',
    'H': 'hours',
    'i': 'minutes',
    's': 'seconds'
  };
  var unit2s = {
    'Y': 31536000,
    'm': 2628000,
    'd': 86400,
    'H': 3600,
    'i': 60,
    's': 1
  };
  var d = new Date();
  var diff = Math.round(d.valueOf() / 1000) - Math.round(date.valueOf() / 1000 + egw.getTimezoneOffset() * 60);
  var display = '';

  // limit units used to display
  var smallest = 's';
  if (options.units) {
    var valid = Object.entries(unit2s).filter(e => options.units.includes(e[0]));
    unit2s = Object.fromEntries(valid);
    smallest = (valid.pop() || [])[0];
  }
  for (var unit in unit2s) {
    var unit_s = unit2s[unit];
    if (diff >= unit_s || unit === smallest) {
      display = Math.round(diff / unit_s) + ' ' + this.egw().lang(unit2label[unit]);
      break;
    }
  }
  return display;
};

/**
 * Displays the elapsed time since the given date
 *
 * The time units (years, months, days, etc) will be calculated automatically to best match the
 * time scale being dealt with, unless the units property is set.
 *
 * This is a stripped-down read-only widget used in nextmatch
 */
class Et2DateSinceReadonly extends Et2DateReadonly {
  static get properties() {
    return _objectSpread$z(_objectSpread$z({}, super.properties), {}, {
      /**
       * Allowed display units, default 'YmdHis', e.g. 'd' to display a value only in days"
       */
      units: {
        type: String,
        reflect: true
      }
    });
  }
  constructor() {
    super();
    this.parser = parseDateTime;
    this.formatter = formatDate;
  }
  set_value(value) {
    this.value = value;
  }
  render() {
    var parsed = this.value ? this.parser(this.value) : false;

    // Be more forgiving if time is missing
    if (!parsed && this.value) {
      parsed = parseDate(this.value) || false;
    }
    return x$1(_templateObject$H || (_templateObject$H = _taggedTemplateLiteral$H(["\n            <span ", "\n                  datetime=\"", "\">\n                ", "\n            </span>\n\t\t"])), this.id ? x$1(_templateObject2$q || (_templateObject2$q = _taggedTemplateLiteral$H(["id=\"", "\""])), this._dom_id) : '', parsed ? parsed.toJSON() : "", this.value ? this.formatter(parsed, {
      units: this.units
    }) : '');
  }
  getDetachedAttributes(attrs) {
    attrs.push("id", "value", "class");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    // Do nothing, since we can't actually stop being a DOM node...
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-date-since", Et2DateSinceReadonly);

var _templateObject$G;
function ownKeys$y(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$y(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$y(Object(source), true).forEach(function (key) { _defineProperty$1e(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$y(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1e(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$G(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2DateTime extends Et2Date {
  static get styles() {
    return [...super.styles, i$b(_templateObject$G || (_templateObject$G = _taggedTemplateLiteral$G(["\n\t\t\t  :host([focused]) ::slotted(button), :host(:hover) ::slotted(button) {\n\t\t\t\tdisplay: inline-block;\n\t\t\t  }\n\n\t\t\t  ::slotted([slot='input']) {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\tmin-width: 17ex;\n\t\t\t  }\n\n\t\t\t  ::slotted(.calendar_button) {\n\t\t\t\tborder: none;\n\t\t\t\tbackground: transparent;\n\t\t\t\tmargin-left: -20px;\n\t\t\t\tdisplay: none;\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$y({}, super.properties);
  }
  constructor() {
    super();
  }

  /**
   * Override some flatpickr defaults to get things how we like it
   *
   * @see https://flatpickr.js.org/options/
   * @returns {any}
   */
  getOptions() {
    var _this$egw, _this$egw2, _this$egw3;
    var options = super.getOptions();
    var dateFormat = ((_this$egw = this.egw()) === null || _this$egw === void 0 ? void 0 : _this$egw.preference("dateformat")) || "Y-m-d";
    var timeFormat = (((_this$egw2 = this.egw()) === null || _this$egw2 === void 0 ? void 0 : _this$egw2.preference("timeformat")) || "24") == "24" ? "H:i" : "h:i K";
    options.altFormat = dateFormat + " " + timeFormat;
    options.enableTime = true;
    options.time_24hr = ((_this$egw3 = this.egw()) === null || _this$egw3 === void 0 ? void 0 : _this$egw3.preference("timeformat", "common")) == "24";
    options.dateFormat = "Y-m-dTH:i:00\\Z";
    options.defaultHour = new Date().getHours();
    return options;
  }

  /**
   * Change handler setting modelValue for validation
   *
   * @returns
   * @param selectedDates
   * @param dateStr
   * @param instance
   */
  _updateValueOnChange(selectedDates, dateStr, instance) {
    super._updateValueOnChange(selectedDates, dateStr, instance);
    if (!this.freeMinuteEntry && dateStr && instance && instance.config.minuteIncrement > 1) {
      var i = instance.latestSelectedDateObj;
      var d = i ? i : new Date();
      var original = d.getMinutes();
      var bound = Math.round(original / instance.config.minuteIncrement) * instance.config.minuteIncrement;
      if (bound != original) {
        d.setMinutes(bound);
        instance.setDate(d, false);
      }
    }
  }

  /**
   * For mobile, we use a plain input of the proper type
   * @returns {string}
   */
  _mobileInputType() {
    return "datetime-local";
  }
  get format() {
    // Mobile is specific about the date format
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      // Use formatDate() for full control, formatDateTime() will add a space
      return date => {
        return formatDate$1(date, {
          dateFormat: "Y-m-dTH:i"
        });
      };
    }
    return formatDateTime;
  }

  /**
   * Add "today" button below calendar
   * @protected
   */
  _buttonPlugin() {
    return ShortcutButtonsPlugin({
      button: [{
        label: this.egw().lang("ok")
      }, {
        label: this.egw().lang("Now")
      }],
      onClick: this._handleShortcutButtonClick
    });
  }

  /**
   * Handle clicks on scroll buttons
   *
   * @param e
   */
  handleScroll(e) {
    if (e.target && !e.target.dataset.direction) {
      return;
    }
    e.stopPropagation();
    var direction = parseInt(e.target.dataset.direction, 10) || 1;
    this.increment(direction * this.getOptions().minuteIncrement, "minute", true);
  }
}

// @ts-ignore TypeScript is not recognizing that Et2DateTime is a LitElement
customElements.define("et2-date-time", Et2DateTime);

function ownKeys$x(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$x(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$x(Object(source), true).forEach(function (key) { _defineProperty$1d(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$x(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$1d(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2DateTimeOnly extends Et2DateTime {
  static get styles() {
    return [...super.styles];
  }
  static get properties() {
    return _objectSpread$x({}, super.properties);
  }
  constructor() {
    super();

    // Configure flatpickr
  }

  /**
   * Override some flatpickr defaults to get things how we like it
   *
   * @see https://flatpickr.js.org/options/
   * @returns {any}
   */
  getOptions() {
    var options = super.getOptions();
    var timeFormat = (window.egw.preference("timeformat") || "24") == "24" ? "H:i" : "h:i K";
    options.altFormat = timeFormat;
    options.noCalendar = true;
    options.dateFormat = "1970-01-01TH:i:00\\Z";

    // Time only does not have year & month, which scrollPlugin blindly tries to use
    // This causes an error and interrupts the initialization
    options.plugins.push(instance => {
      return {
        onReady: function onReady() {
          this.yearElements = [];
          this.monthElements = [];
        }
      };
    });
    return options;
  }

  /**
   * For mobile, we use a plain input of the proper type
   * @returns {string}
   */
  _mobileInputType() {
    return "time";
  }
  get format() {
    // Mobile is specific about the date format
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      return date => {
        return formatDate$1(date, {
          dateFormat: "H:i"
        });
      };
    }
    return super.format;
  }
  set_value(value) {
    var adjustedValue = '';
    if (!value || value == 0 || value == "0") {
      value = '';
    }
    var date = new Date(value);
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      date = new Date(value);
      if (this._inputNode) {
        this._inputNode.value = isNaN(date) ? "" : this.format(date);
      } else {
        this.updateComplete.then(() => {
          this._inputNode.value = isNaN(date) ? "" : this.format(date);
        });
      }
      return;
    }
    // Handle timezone offset, flatpickr uses local time
    if (value) {
      adjustedValue = new Date(date.valueOf() + date.getTimezoneOffset() * 60 * 1000);
      adjustedValue.setDate(1);
      adjustedValue.setMonth(0);
      adjustedValue.setFullYear(1970);
    }
    if (!this._instance) {
      this.defaultDate = adjustedValue;
    } else {
      this.setDate(adjustedValue);
    }
  }
}

// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-date-timeonly", Et2DateTimeOnly);

/**
 * EGroupware eTemplate2 - Readonly date+time WebComponent
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 */

/**
 * This is a stripped-down read-only widget used in nextmatch
 */
class Et2DateTimeOnlyReadonly extends Et2DateReadonly {
  constructor() {
    super();
    this.parser = parseDateTime;
    this.formatter = formatTime;
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Date is a LitElement
customElements.define("et2-date-timeonly_ro", Et2DateTimeOnlyReadonly);

/**
 * EGroupware eTemplate2 - Readonly date+time WebComponent
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 */

/**
 * This is a stripped-down read-only widget used in nextmatch
 */
class Et2DateTimeReadonly extends Et2DateReadonly {
  constructor() {
    super();
    this.parser = parseDateTime;
    this.formatter = formatDateTime;
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Date is a LitElement
customElements.define("et2-date-time_ro", Et2DateTimeReadonly);

/**
 * EGroupware eTemplate2 - Readonly date-time_today WebComponent
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 */

/**
 * Widget displays date/time with different formatting relative to today
 * If the date is today, we show just the time, otherwise just the date.
 */
class Et2DateTimeToday extends Et2DateReadonly {
  constructor() {
    super();
    this.parser = parseDateTime;
    this.formatter = this.formatDateTime;
  }

  /**
   * Format date+time relative to "now"
   * If the date is today, we show just the time.  Otherwise, the date.
   *
   * @param {Date} date
   * @param {import('@lion/localize/types/LocalizeMixinTypes').FormatDateOptions} [options] Intl options are available
   * @returns {string}
   */
  formatDateTime(date) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
      dateFormat: "",
      timeFormat: ""
    };
    var display = "";
    // Today - just the time
    if (formatDate$1(date, {
      dateFormat: 'Y-m-d'
    }) == formatDate$1(new Date(), {
      dateFormat: 'Y-m-d'
    })) {
      display = formatTime(date);
    }
    // Before today - just the date
    else {
      display = formatDate$1(date);
    }
    return display;
  }
}

// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-date-time-today", Et2DateTimeToday);

var _templateObject$F, _templateObject2$p;
function _taggedTemplateLiteral$F(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Activates links in text
 *
 * @example
 * this.value = "This text has links to https://www.egroupware.org";
 * ...
 * render()
 * {
 *     return html`activateLinks(this.value)`;
 * }
 * renders as:
 * <a href="https://www.egroupware.org" target="_blank">egroupware.org</a>
 */
class ActivateLinksDirective extends i$6 {
  render(text_with_urls, _target) {
    var list = et2_activateLinks(text_with_urls);
    return x$1(_templateObject$F || (_templateObject$F = _taggedTemplateLiteral$F(["", ""])), c$2(list, (item, index) => {
      // No urls in this section
      if (typeof item == "string" || typeof item == "number") {
        // Just text.  Easy (framework handles \n)
        return item;
      }
      // Url found, deal with it
      else if (item && item.text) {
        if (!item.href) {
          console.warn("et2_activateLinks gave bad data", item, _target);
          item.href = "";
        }
        var click = null;
        var target = null;

        // open mailto links depending on preferences in mail app
        if (item.href.substr(0, 7) == "mailto:" && egw.user('apps').mail && egw.preference('force_mailto', 'addressbook') != '1') {
          click = function (event) {
            egw.open_link(this);
            return false;
          }.bind(item.href);
          item.href = "#";
        }
        if (typeof _target != "undefined" && _target && _target != "_self" && item.href.substr(0, 7) != "mailto:") {
          target = _target;
        }
        return x$1(_templateObject2$p || (_templateObject2$p = _taggedTemplateLiteral$F(["<a href=\"", "\" @click=", " target=\"", "\">", "</a>"])), item.href, click, target, item.text);
      }
    }));
  }
}
var activateLinks = e$6(ActivateLinksDirective);

var _templateObject$E, _templateObject2$o, _templateObject3$c, _templateObject4$8, _templateObject5$6, _templateObject6$4;
function asyncGeneratorStep$9(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$9(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$9(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$9(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$w(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$w(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$w(Object(source), true).forEach(function (key) { _defineProperty$1c(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$w(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$E(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1c(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Description extends Et2Widget(s$5) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$E || (_templateObject$E = _taggedTemplateLiteral$E(["\n\t\t\t* {\n\t\t\t\twhite-space: pre-wrap;\n\t\t\t}\n\t\t\t:host {\n\t\t\t\tdisplay:flex;\n\t\t\t\tflex-direction: column;\n\t\t\t\tjustify-content: space-evenly;\n\t\t\t\tflex: 0 1 auto !important;\n\t\t\t}\n\t\t\tlabel {display: contents;}\n\t\t\t::slotted(a) {\n\t\t\t\tcursor: pointer;\n\t\t\t\tcolor: #26537c;\n\t\t\t\ttext-decoration: none;\n\t\t\t  \tdisplay: inherit;\n\t\t\t}"])))];
  }
  static get properties() {
    return _objectSpread$w(_objectSpread$w({}, super.properties), {}, {
      /**
       * Scan the value, and if there are any links (URL, mailto:) then wrap them in a clickable
       * <a/> tag
       */
      activateLinks: {
        type: Boolean,
        reflect: true
      },
      /**
       * Extra link target
       * Goes with href.  If provided, that's the target for opening the link.
       */
      extraLinkTarget: {
        type: String,
        reflect: true
      },
      /**
       * widthxheight, if popup should be used, eg. 640x480
       */
      extraLinkPopup: {
        type: String,
        reflect: true
      },
      /**
       * Link URL
       * If provided, will be clickable and open this URL
       */
      href: {
        type: String,
        reflect: true
      },
      value: {
        type: String,
        noAccessor: true
      }
    });
  }
  constructor() {
    super();

    // Initialize properties
    _defineProperty$1c(this, "_value", "");
    this.activateLinks = false;
    this.extraLinkPopup = "";
    this.extraLinkTarget = "_browser";
    // Don't initialize this to avoid href(unknown) when rendered
    //this.href = "";
    this.value = "";
    this._handleClick = this._handleClick.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();

    // Put content directly in DOM
    if (this.value) {
      D$1(this._renderContent(), this);
    }
  }
  set_value(value) {
    this.value = value;
  }
  get value() {
    return this._value;
  }
  set value(_value) {
    var oldValue = this.value;
    if (!_value) {
      _value = "";
    }

    // Do we do this here, or in transformAttributes()?
    if (_value && !this.noLang) {
      _value = this.egw().lang(_value);
    }
    if (_value && (_value + "").indexOf('%s') != -1) {
      _value = _value.replace(/%s/g, _value);
    }
    this._value = _value;
    this.requestUpdate('value', oldValue);
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    // Due to how we do the rendering into the light DOM (not sure it's right) we need this after
    // value change or it won't actually show up
    if ((changedProperties.has("value") || changedProperties.has("href") || changedProperties.has("activateLinks")) && this.parentNode) {
      D$1(this._renderContent(), this);
    }
  }
  _renderContent() {
    var render = null;

    // Add hover action button (Edit)
    if (this.hover_action) {
      // TODO
    }

    // If there's a link, wrap that
    if (this.href && this.value) {
      render = this.wrapLink(this.href, this.value);
    }
    // If we want to activate links inside, do that
    else if (this.activateLinks && this.value) {
      render = this.getActivatedValue(this.value, this.href ? this.extraLinkTarget : '_blank');
    }
    // Just do the value
    else {
      render = x$1(_templateObject2$o || (_templateObject2$o = _taggedTemplateLiteral$E(["", ""])), this.value);
    }
    return render;
  }
  render() {
    var label = this.label;
    var after;
    if (label) {
      // Split the label at the "%s"
      var parts = et2_csvSplit(label, 2, "%s");
      if (parts.length > 1) {
        after = x$1(_templateObject3$c || (_templateObject3$c = _taggedTemplateLiteral$E(["<label>", "</label>"])), parts[1]);
        label = parts[0];
      }
    }
    // Turn off IDE reformatting, or it will add an extra line break into the template
    // @formatter:off
    return x$1(_templateObject4$8 || (_templateObject4$8 = _taggedTemplateLiteral$E(["<slot part=\"form-control-label\" name=\"label\">", "</slot><slot part=\"form-control-value\"></slot>", ""])), label, after);
    // @formatter:on
  }

  firstUpdated() {
    var _this = this;
    return _asyncToGenerator$9(function* () {
      _this.removeEventListener('click.extra_link', _this._handleClick);
      if (_this.extraLinkPopup || _this.mime) {
        // Add click listener
        _this.addEventListener('click.extra_link', _this._handleClick);
      }
    })();
  }
  _handleClick(_ev) {
    // call super to get the onclick handling running
    super._handleClick(_ev);
    if (this.mimeData || this.href) {
      egw(window).open_link(this.mimeData || this.href, this.extraLinkTarget, this.extraLinkPopup, null, null, this.mime);
      _ev.preventDefault();
      return false;
    } else if (_ev.target.nodeName !== "A") {
      // If it's not an activated link, just stop
      _ev.preventDefault();
      return false;
    }
    // Let links (present if activateLinks = true) do their thing normally
  }

  wrapLink(href, value) {
    var _this$target;
    if (href.indexOf('/') == -1 && href.split('.').length >= 3 && !(href.indexOf('mailto:') != -1 || href.indexOf('://') != -1 || href.indexOf('javascript:') != -1)) {
      href = "/index.php?menuaction=" + href;
    }
    if (href.charAt(0) == '/')
      // link relative to eGW
      {
        href = egw.link(href);
      }
    return x$1(_templateObject5$6 || (_templateObject5$6 = _taggedTemplateLiteral$E(["<a href=\"", "\" target=\"", "\">", "</a>"])), href, (_this$target = this.target) !== null && _this$target !== void 0 ? _this$target : "_blank", value);
  }
  getActivatedValue(value, target) {
    return x$1(_templateObject6$4 || (_templateObject6$4 = _taggedTemplateLiteral$E(["", ""])), activateLinks(value, target));
  }
  getDetachedAttributes(attrs) {
    attrs.push("id", "label", "value", "class", "href", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
  loadFromXML() {
    // nope
  }
}
// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-description", Et2Description);
class Et2Label extends Et2Description {}
// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-label", Et2Label);

/**
 * @license
 * Copyright 2021 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */const i$1=e$6(class extends i$6{constructor(){super(...arguments),this.key=A$1;}render(r,t){return this.key=r,t}update(r,[t,e]){return t!==this.key&&(a$1(r),this.key=t),e}});

function _defineProperty$1b(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * A reactive controller that determines when slots exist.
 *
 * Copied from Shoelace
 * /src/internal/slot.ts
 */
class HasSlotController {
  constructor(host) {
    _defineProperty$1b(this, "host", void 0);
    _defineProperty$1b(this, "slotNames", []);
    _defineProperty$1b(this, "handleSlotChange", event => {
      var slot = event.target;
      if (this.slotNames.includes('[default]') && !slot.name || slot.name && this.slotNames.includes(slot.name)) {
        this.host.requestUpdate();
      }
    });
    (this.host = host).addController(this);
    for (var _len = arguments.length, slotNames = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      slotNames[_key - 1] = arguments[_key];
    }
    this.slotNames = slotNames;
  }
  hasDefaultSlot() {
    return [...this.host.childNodes].some(node => {
      if (node.nodeType === node.TEXT_NODE && node.textContent.trim() !== '') {
        return true;
      }
      if (node.nodeType === node.ELEMENT_NODE) {
        var el = node;
        var tagName = el.tagName.toLowerCase();

        // Ignore visually hidden elements since they aren't rendered
        if (tagName === 'sl-visually-hidden') {
          return false;
        }

        // If it doesn't have a slot attribute, it's part of the default slot
        if (!el.hasAttribute('slot')) {
          return true;
        }
      }
      return false;
    });
  }
  hasNamedSlot(name) {
    return this.host.querySelector(":scope > [slot=\"".concat(name, "\"]")) !== null;
  }
  test(slotName) {
    return slotName === '[default]' ? this.hasDefaultSlot() : this.hasNamedSlot(slotName);
  }
  hostConnected() {
    this.host.shadowRoot.addEventListener('slotchange', this.handleSlotChange);
  }
  hostDisconnected() {
    this.host.shadowRoot.removeEventListener('slotchange', this.handleSlotChange);
  }
}

/**
 * Given a slot, this function iterates over all of its assigned element and text nodes and returns the concatenated
 * HTML as a string. This is useful because we can't use slot.innerHTML as an alternative.
 */
function getInnerHTML(slot) {
  var nodes = slot.assignedNodes({
    flatten: true
  });
  var html = '';
  [...nodes].forEach(node => {
    if (node.nodeType === Node.ELEMENT_NODE) {
      html += node.outerHTML;
    }
    if (node.nodeType === Node.TEXT_NODE) {
      html += node.textContent;
    }
  });
  return html;
}

/**
 * Given a slot, this function iterates over all of its assigned text nodes and returns the concatenated text as a
 * string. This is useful because we can't use slot.textContent as an alternative.
 */
function getTextContent(slot) {
  if (!slot) {
    return '';
  }
  var nodes = slot.assignedNodes({
    flatten: true
  });
  var text = '';
  [...nodes].forEach(node => {
    if (node.nodeType === Node.TEXT_NODE) {
      text += node.textContent;
    }
  });
  return text;
}

function asyncGeneratorStep$8(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$8(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$8(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$8(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
/**
 * Email address UI utilities
 *
 * You probably want formatEmailAddress(address)
 */

function _getEmailDisplayPreference() {
  var _window$egw$preferenc;
  var pref = (_window$egw$preferenc = window.egw.preference("emailTag", "mail")) !== null && _window$egw$preferenc !== void 0 ? _window$egw$preferenc : "";
  switch (pref) {
    case "fullemail":
      return "full";
    default:
    case "onlyname":
      return "name";
    case "onlyemail":
      return "email";
    case "domain":
      return "domain";
  }
}
var email_cache = {};
var contact_request;
var contact_requests = {};

/**
 * Cache information about a contact
 */

/**
 * Get contact information using an email address
 *
 * @param {string} email
 * @returns {Promise<boolean | ContactInfo>}
 */
function checkContact(email) {
  if (typeof email_cache[email] !== "undefined") {
    return Promise.resolve(email_cache[email]);
  }
  if (!contact_request && window.egw) {
    contact_request = window.egw.jsonq('EGroupware\\Api\\Etemplate\\Widget\\Url::ajax_contact', [[]], null, null, parameters => {
      for (var _email in contact_requests) {
        parameters[0].push(_email);
      }
    }).then(result => {
      var _loop = function _loop(_email2) {
        email_cache[_email2] = result[_email2];
        contact_requests[_email2].forEach(resolve => {
          resolve(result[_email2]);
        });
      };
      for (var _email2 in contact_requests) {
        _loop(_email2);
      }
      contact_request = null;
      contact_requests = {};
    });
  }
  if (typeof contact_requests[email] === 'undefined') {
    contact_requests[email] = [];
  }
  return new Promise(resolve => {
    contact_requests[email].push(resolve);
  });
}

/**
 * if we have a "name <email>" value split it into name & email
 * @param email_string
 *
 * @return {name:string, email:string}
 */
function splitEmail(email_string) {
  var split = {
    name: "",
    email: email_string
  };
  if (email_string && email_string.indexOf('<') !== -1) {
    var parts = email_string.split('<');
    if (parts.length > 1) {
      split.email = parts.pop();
      split.email = split.email.substring(0, split.email.length - 1).trim();
      split.name = parts.join("<").trim();
      // remove quotes
      while (split.name.length > 1 && (split.name[0] === '"' || split.name[0] === "'") && split.name[0] === split.name.substring(split.name.length - 1)) {
        split.name = split.name.substring(1, split.name.length - 1);
      }
    } else
      // <email> --> email
      {
        split.email = parts[1].substring(0, email_string.length - 1);
      }
  }
  return split;
}

/**
 * Format an email address according to user preference
 *
 * @param address
 * @param {"full" | "email" | "name" | "domain"} emailDisplayFormat
 * @returns {any}
 */
function formatEmailAddress(_x, _x2) {
  return _formatEmailAddress.apply(this, arguments);
}
function _formatEmailAddress() {
  _formatEmailAddress = _asyncToGenerator$8(function* (address, emailDisplayFormat) {
    if (!address || !address.trim()) {
      return "";
    }
    if (!emailDisplayFormat) {
      emailDisplayFormat = _getEmailDisplayPreference();
    }
    var split = splitEmail(address);
    var content = address;
    var contact;
    if (emailDisplayFormat !== 'email' && !split.name && (contact = yield checkContact(address))) {
      split.name = contact.n_fn;
    }
    if (split.name) {
      switch (emailDisplayFormat) {
        case "full":
          content = split.name + " <" + split.email + ">";
          break;
        case "email":
          content = split.email;
          break;
        case "name":
        default:
          content = split.name;
          break;
        case "domain":
          content = split.name + " (" + split.email.split("@").pop() + ")";
          break;
      }
    }
    return content;
  });
  return _formatEmailAddress.apply(this, arguments);
}

var _dec$3, _dec2$2, _class$5, _descriptor$3, _descriptor2$1, _templateObject$D, _templateObject2$n, _templateObject3$b, _templateObject4$7, _templateObject5$5, _templateObject6$3, _templateObject7$2;
function _initializerDefineProperty$3(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _taggedTemplateLiteral$D(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$1a(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$3(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$3(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

/**
 * Display a single email address
 * On hover, queries the server to see if the email is associated with a contact already.  If it is, we
 * show the contact's avatar, clicking it opens CRM view for that contact.  If the email is unknown, we
 * show and Add icon.  Clicking it opens the add contact dialog with the email pre-filled.
 *
 * Tag is usually used in a Et2EmailSelect with multiple=true, but there's no reason it can't go anywhere
 */
var Et2EmailTag = (_dec$3 = e$c({
  type: Boolean,
  reflect: true
}), _dec2$2 = e$c({
  type: String
}), (_class$5 = class Et2EmailTag extends Et2Tag {
  static get styles() {
    return [super.styles, shoelace, i$b(_templateObject$D || (_templateObject$D = _taggedTemplateLiteral$D(["\n\t\t\t.tag {\n\t\t\t  position: relative;\n\t\t\t}\n\n\t\t\t.tag__prefix {\n\t\t\t  flex: 0 1 auto;\n\n\t\t\t  opacity: 30%;\n\t\t\t  cursor: pointer;\n\t\t\t}\n\n\t\t\t.tag__has_plus et2-button-icon {\n\t\t\t  visibility: visible;\n\t\t\t}\n\n\t\t\t:host(:hover) .tag__has_plus {\n\t\t\t  opacity: 100%;\n\t\t\t}\n\n\t\t\t/* Address is for a contact - always show */\n\n\t\t\t.tag__prefix.tag__has_contact {\n\t\t\t  opacity: 100%;\n\t\t\t}\n\n\t\t\t.tag__remove {\n\t\t\t  order: 3;\n\t\t\t}\n\n\t\t\t/* Shoelace disabled gives a not-allowed cursor, but we also set disabled for read-only.\n\t\t\t * We don't want the not-allowed cursor, since you can always click the email address\n\t\t\t */\n\n\t\t\t:host([readonly]) {\n\t\t\t  cursor: pointer !important;\n\t\t\t}\n\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);
    _initializerDefineProperty$3(this, "contactPlus", _descriptor$3, this);
    /**
     * What to display for the selected email addresses
     *
     *	- full: "Mr Test User <test@example.com>
     *	- name: "Mr Test User"
     *	- domain: "Mr Test User (example.com)"
     *	- email: "test@example.com"
     *
     * If name is unknown, we'll use the email instead.
     */
    _initializerDefineProperty$3(this, "emailDisplay", _descriptor2$1, this);
    this.handleMouseEnter = this.handleMouseEnter.bind(this);
    this.handleMouseLeave = this.handleMouseLeave.bind(this);
    this.handleMouseClick = this.handleMouseClick.bind(this);
    this.handleContactMouseDown = this.handleContactMouseDown.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    if (this.contactPlus && this.egw().app('addressbook')) {
      this.addEventListener("mouseenter", this.handleMouseEnter);
      this.addEventListener("mouseleave", this.handleMouseLeave);
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("mouseenter", this.handleMouseEnter);
    this.removeEventListener("mouseleave", this.handleMouseLeave);
  }
  handleMouseEnter(e) {
    this.shadowRoot.querySelector(".tag").classList.add("contact_plus");
  }
  handleMouseLeave(e) {
    this.shadowRoot.querySelector(".tag").classList.remove("contact_plus");
  }
  handleMouseClick(e) {
    var _this$value;
    e.stopPropagation();
    var extra = {
      'presets[email]': (_this$value = this.value) !== null && _this$value !== void 0 ? _this$value : ""
    };
    this.egw().open('', 'addressbook', 'add', extra);
  }
  handleContactMouseDown(e) {
    e.stopPropagation();
    checkContact(this.value).then(result => {
      this.egw().open(result.id, 'addressbook', 'view', {
        title: result.n_fn,
        icon: result.photo
      });
    });
  }

  /**
   * Get the node that is shown & clicked on to add email as contact
   *
   * @returns {Element}
   */
  get _contactPlusNode() {
    return this.shadowRoot.querySelector(".tag__prefix");
  }
  _contentTemplate() {
    var content = formatEmailAddress(this.value, this.emailDisplay);
    return x$1(_templateObject2$n || (_templateObject2$n = _taggedTemplateLiteral$D(["\n            <span part=\"content\" class=\"tag__content\" title=\"", "\">\n\t\t\t", "\n        </span>"])), this.value, m$1(content, this.value));
  }
  _prefixTemplate() {
    var classes = {
      "tag__prefix": true
    };
    var button_or_avatar = checkContact(this.value).then(option => {
      var button_or_avatar;
      if (typeof option == "object") {
        // Show the lavatar for the contact
        classes['tag__has_contact'] = true;

        // lavatar uses a size property, not a CSS variable
        var style = getComputedStyle(this);
        button_or_avatar = x$1(_templateObject3$b || (_templateObject3$b = _taggedTemplateLiteral$D(["\n                <et2-lavatar slot=\"prefix\" exportparts=\"image\" part=\"icon\" tabindex=\"-1\"\n                             @mousedown=", "\n                             .size=", "\n                             lname=", "\n                             fname=", "\n                             image=", "\n                             statustext=\"", "\"\n                >\n                </et2-lavatar>"])), this.handleContactMouseDown, style.getPropertyValue("--icon-width"), option.lname || A$1, option.fname || A$1, option.photo || A$1, this.egw().lang("Open existing contact") + ": " + option.n_fn);
      } else {
        // Show a button to add as new contact
        classes['tag__has_plus'] = true;
        button_or_avatar = x$1(_templateObject4$7 || (_templateObject4$7 = _taggedTemplateLiteral$D(["\n                    <et2-button-icon image=\"add\" tabindex=\"-1\" @click=", " .noSubmit=", "\n                                 label=\"", "\"\n                                 statustext=\"", "\">\n                </et2-button-icon>"])), this.handleMouseClick, true, this.egw().lang("Add a new contact"), this.egw().lang("Add a new contact"));
      }
      return x$1(_templateObject5$5 || (_templateObject5$5 = _taggedTemplateLiteral$D(["<span part=\"prefix\" class=", ">\n\t\t\t\t<slot name=\"prefix\">\n\t\t\t\t</slot>\n\t\t\t\t", "\n\t\t\t</span>"])), o$9(classes), button_or_avatar);
    });
    return x$1(_templateObject6$3 || (_templateObject6$3 = _taggedTemplateLiteral$D(["\n            ", ""])), m$1(button_or_avatar, x$1(_templateObject7$2 || (_templateObject7$2 = _taggedTemplateLiteral$D(["\n                <span part=\"prefix\" class=", "> \n\t\t\t\t\t<slot name=\"prefix\"></slot>\n\t\t\t\t\t<sl-spinner></sl-spinner>\n\t\t\t\t</span>"])), o$9(classes))));
  }
}, (_descriptor$3 = _applyDecoratedDescriptor$3(_class$5.prototype, "contactPlus", [_dec$3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return true;
  }
}), _descriptor2$1 = _applyDecoratedDescriptor$3(_class$5.prototype, "emailDisplay", [_dec2$2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return "domain";
  }
})), _class$5));
customElements.define("et2-email-tag", Et2EmailTag);

var _templateObject$C;
function _taggedTemplateLiteral$C(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
var styles = i$b(_templateObject$C || (_templateObject$C = _taggedTemplateLiteral$C(["\n\t:host([open]) {\n\t\t/* Handles z-index issues with toolbar of html editor on the page*/\n\t\tposition: relative;\n\t\tz-index: 2;\n\t}\n\n\t.form-control-input {\n\t\t/* This allows the dropdown to show over other inputs */\n\t\tposition: relative;\n\t\tz-index: 1;\n\t}\n\n\t.email .email__combobox {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: row;\n\t\tflex-wrap: wrap;\n\t\talign-items: center;\n\t\tgap: 0.1rem 0.5rem;\n\n\t\tbackground-color: var(--sl-input-background-color);\n\t\tborder: solid var(--sl-input-border-width) var(--sl-input-border-color);\n\n\t\tborder-radius: var(--sl-input-border-radius-medium);\n\t\tfont-size: var(--sl-input-font-size-medium);\n\t\tmin-height: var(--sl-input-height-medium);\n\t\tmax-height: calc(var(--height, 5) * var(--sl-input-height-medium));\n\t\toverflow-y: auto;\n\t\tpadding-block: 0;\n\t\tpadding-inline: var(--sl-input-spacing-medium);\n\t\tpadding-top: 0.1rem;\n\t\tpadding-bottom: 0.1rem;\n\n\t\ttransition: var(--sl-transition-fast) color, var(--sl-transition-fast) border, var(--sl-transition-fast) box-shadow,\n\t\tvar(--sl-transition-fast) background-color;\n\t}\n\n\t.email.email--disabled .email__combobox {\n\t\tbackground-color: var(--sl-input-background-color-disabled);\n\t\tborder-color: var(--sl-input-border-color-disabled);\n\t\tcolor: var(--sl-input-color-disabled);\n\t\topacity: 0.5;\n\t\tcursor: not-allowed;\n\t\toutline: none;\n\t}\n\n\t.email:not(.email--disabled).email--open .email__combobox,\n\t.email:not(.email--disabled).email--focused .email__combobox {\n\t\tbackground-color: var(--sl-input-background-color-focus);\n\t\tborder-color: var(--sl-input-border-color-focus);\n\t\tbox-shadow: 0 0 0 var(--sl-focus-ring-width) var(--sl-input-focus-ring-color);\n\t}\n\n\t.email .email__prefix {\n\t\torder: 1;\n\t}\n\t/* Tags */\n\n\tet2-email-tag {\n\t\torder: 2;\n\t\tflex-grow: 0;\n\t\tmargin: auto 0px;\n\t\t--icon-width: 1.8em;\n\n\t\toutline: none;\n\t}\n\n\t/* Search box */\n\t.email__search {\n\t\tflex: 1 1 auto;\n\t\torder: 10;\n\t\tmin-width: 7em;\n\t\tborder: none;\n\t\toutline: none;\n\n\t\tfont-size: var(--sl-input-font-size-medium);\n\t\tpadding-block: 0;\n\t\tpadding-inline: var(--sl-input-spacing-medium);\n\t}\n\n\t.form-control--medium .email__search {\n\t\t/* Input same size as tags */\n\t\theight: calc(var(--sl-input-height-medium) * 0.8);\n\t}\n\n\t.email .email__loading {\n\t\torder: 19;\n\t}\n\t.email .email__suffix {\n\t\torder: 20;\n\t}\n\n\t/* Listbox */\n\n\t.email__listbox {\n\t\tdisplay: block;\n\t\tposition: relative;\n\t\tfont-family: var(--sl-font-sans);\n\t\tfont-size: var(--sl-font-size-medium);\n\t\tfont-weight: var(--sl-font-weight-normal);\n\t\tbox-shadow: var(--sl-shadow-large);\n\t\tbackground: var(--sl-panel-background-color);\n\t\tborder: solid var(--sl-panel-border-width) var(--sl-panel-border-color);\n\t\tborder-radius: var(--sl-border-radius-medium);\n\t\tpadding-block: var(--sl-spacing-x-small);\n\t\tpadding-inline: 0;\n\t\toverflow: auto;\n\t\toverscroll-behavior: none;\n\n\t\t/* Make sure it adheres to the popup's auto size */\n\t\tmax-width: var(--auto-size-available-width);\n\t\tmax-height: var(--auto-size-available-height);\n\n\t\t/* This doesn't work for some reason, it's overwritten somewhere */\n\t\t--size: 1.8em;\n\t}\n\n\t.email__listbox ::slotted(sl-divider) {\n\t\t--spacing: var(--sl-spacing-x-small);\n\t}\n\n\t.email__listbox ::slotted(small) {\n\t\tfont-size: var(--sl-font-size-small);\n\t\tfont-weight: var(--sl-font-weight-semibold);\n\t\tcolor: var(--sl-color-neutral-500);\n\t\tpadding-block: var(--sl-spacing-x-small);\n\t\tpadding-inline: var(--sl-spacing-x-large);\n\t}\n\n\t/**\n\t * Readonly\n\t */\n\n\t:host([readonly]) .email .email__combobox {\n\t\tborder: none;\n\t\tbox-shadow: none;\n\t\tmax-height: calc(var(--height, 5) * (var(--sl-input-height-medium) * 0.8))\n\t}\n\n\t:host([readonly])::part(expand-icon) {\n\t\tdisplay: none;\n\t}\n\n\t:host([readonly]) .email__search {\n\t\tdisplay: none;\n\t}\n\n\t/** \n\t* Style for tag count if readonly and rows=1 \n\t*/\n\n\t:host([readonly][rows='1']) .email__combobox {\n\t\toverflow: hidden;\n\t\tmin-height: auto;\n\t\tmax-height: calc(var(--sl-input-height-medium) * 0.8);\n\t}\n\n\t.tag_limit {\n\t\tposition: absolute;\n\t\tright: 0px;\n\t\ttop: 0px;\n\t\tbottom: 0px;\n\t\tbox-shadow: rgb(0 0 0/50%) -1.5ex 0px 1ex -1ex, rgb(0 0 0 / 0%) 0px 0px 0px 0px;\n\t\tz-index: 1;\n\t}\n\n\t.tag_limit::part(base) {\n\t\theight: 100%;\n\t\tbackground-color: var(--sl-input-background-color);\n\t\tborder-top-left-radius: 0;\n\t\tborder-bottom-left-radius: 0;\n\t\tfont-weight: bold;\n\t\tmin-width: 3em;\n\t\tjustify-content: center;\n\t}\n\n\t/* Show all rows on hover if readonly rows=1 */\n\n\t:host([ readonly ][ rows ]) .hover__popup {\n\t\twidth: -webkit-fill-available;\n\t\twidth: -moz-fill-available;\n\t\twidth: fill-available;\n\t}\n\n\t:host([readonly][rows]) .hover__popup::part(popup) {\n\t\tz-index: var(--sl-z-index-dropdown);\n\t\tbackground-color: white;\n\t\tdisplay: flex;\n\t\tflex-wrap: wrap;\n\n\t\t/* Same as .email__combobox */\n\t\tpadding-inline: var(--sl-input-spacing-medium);\n\t\tgap: 0.1rem 0.5rem;\n\t}\n\n\t/* End styles for [readonly][rows=1] */\n"])));

var _class$4;
function asyncGeneratorStep$7(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$7(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$7(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$7(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _defineProperty$19(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class IsEmail extends Pattern {
  /**
   *
   * @param _allowPlaceholders true: allow valid email-addresses OR something with placeholder(s)
   */
  constructor(_allowPlaceholders) {
    super(_allowPlaceholders ? IsEmail.EMAIL_PLACEHOLDER_PREG : IsEmail.EMAIL_PREG);
  }

  /**
   * Give a message about this field being required.  Could be customised according to MessageData.
   * @param {MessageData | undefined} data
   * @returns {Promise<string>}
   */
  static getMessage(data) {
    return _asyncToGenerator$7(function* () {
      return data.formControl.egw().lang("Invalid email") + (data.modelValue ? ' "' + data.modelValue + '"' : "");
    })();
  }
}
_class$4 = IsEmail;
/**
 * Regexes for validating email addresses incl. email in angle-brackets eg.
 * + "Ralf Becker <rb@egroupware.org>"
 * + "Ralf Becker (EGroupware GmbH) <rb@egroupware.org>"
 * + "<rb@egroupware.org>" or "rb@egroupware.org"
 * + '"Becker, Ralf" <rb@egroupware.org>'
 * + "'Becker, Ralf' <rb@egroupware.org>"
 * but NOT:
 * - "Becker, Ralf <rb@egroupware.org>" (contains comma outside " or ' enclosed block)
 * - "Becker < Ralf <rb@egroupware.org>" (contains <    ----------- " ---------------)
 *
 * About umlaut or IDN domains: we currently only allow German umlauts in domain part!
 * We forbid all non-ascii chars in local part, as Horde does not yet support SMTPUTF8 extension (rfc6531)
 * and we get a "SMTP server does not support internationalized header data" error otherwise.
 *
 * Using \042 instead of " to NOT stall minifyer!
 *
 * Similar, but not identical, preg is in Etemplate\Widget\Url PHP class!
 * We can not use "(?<![.\s])", used to check that name-part does not end in
 * a dot or white-space. The expression is valid in recent Chrome, but fails
 * eg. in Safari 11.0 or node.js 4.8.3 and therefore grunt uglify!
 * Server-side will fail in that case because it uses the full regexp.
 */
_defineProperty$19(IsEmail, "EMAIL_PREG", /^(([^\042',<][^,<]+|\042[^\042]+\042|\'[^\']+\'|"(?:[^"\\]|\\.)*")\s?<)?[^\x00-\x20()\xe2\x80\x8b<>@,;:\042\[\]\x80-\xff]+@([a-z0-9ÄÖÜäöüß](|[a-z0-9ÄÖÜäöüß_-]*[a-z0-9ÄÖÜäöüß])\.)+[a-z]{2,}>?$/i);
/**
 * Allow everything containing at least one placeholder e.g.:
 * - "{{email}}"
 * - "{{n_fn}} <{{email}}"
 * - "{{#<custom-field-name>}}"
 * - "{{info_contact/email}}" or "{{user/#<custom-field-name}}"
 * - we do NOT check if the placeholder is implemented by addressbook or a valid custom-field name!
 * - "test" or "{test}}" are NOT valid
 */
_defineProperty$19(IsEmail, "EMAIL_PLACEHOLDER_PREG", new RegExp('^(.*{{[a-z0-9_/#]+}}.*|' + _class$4.EMAIL_PREG.source.substr(1, _class$4.EMAIL_PREG.source.length - 2) + ')$', 'i'));

var _dec$2, _dec2$1, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _class$3, _descriptor$2, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _class2, _templateObject$B, _templateObject2$m, _templateObject3$a, _templateObject4$6, _templateObject5$4, _templateObject6$2, _templateObject7$1, _templateObject8$1, _templateObject9$1;
function _taggedTemplateLiteral$B(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$v(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$v(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$v(Object(source), true).forEach(function (key) { _defineProperty$18(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$v(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function asyncGeneratorStep$6(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$6(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$6(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$6(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _initializerDefineProperty$2(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _defineProperty$18(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$2(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$2(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

/**
 * @summary Enter email addresses, offering suggestions from contacts
 * @since 23.1
 *
 * @dependency sl-icon
 * @dependency sl-popup
 * @dependency et2-email-tag
 * @dependency et2-textbox
 *
 * @slot label - The input's label. Alternatively, you can use the `label` attribute.
 * @slot prefix - Used to prepend a presentational icon or similar element to the combobox.
 * @slot suffix - Like prefix, but after
 * @slot help-text - Text that describes how to use the input. Alternatively, you can use the `help-text` attribute.
 *
 * @event change - Emitted when the control's value changes.
 * @event sl-input - Emitted when the control receives input.
 * @event sl-focus - Emitted when the control gains focus.
 * @event sl-blur - Emitted when the control loses focus.
 * @event sl-show - Emitted when the suggestion menu opens.
 * @event sl-after-show - Emitted after the suggestion menu opens and all animations are complete.
 * @event sl-hide - Emitted when the suggestion menu closes.
 * @event sl-after-hide - Emitted after the suggestion menu closes and all animations are complete.
 *
 * @csspart form-control - The form control that wraps the label, input, and help text.
 * @csspart form-control-label - The label's wrapper.
 * @csspart form-control-input - The textbox's wrapper.
 * @csspart form-control-help-text - The help text's wrapper.
 * @csspart combobox - The visible part of the control that is not the listbox - tags, input, prefix & suffix
 * @csspart prefix - The container that wraps the prefix slot.
 * @csspart suffix - The container that wraps the suffix slot.
 * @csspart listbox - The listbox container where suggestions are slotted.
 * @csspart input - The input element
 * @csspart option - Each matching email address suggestion
 * @csspart tag - The individual tags that represent each email address.
 *
 * @cssproperty [--height=5] - The maximum height of the widget, to limit size when you have a lot of addresses.  Set by rows property, when set.
 */
var Et2Email = (_dec$2 = e$c({
  converter: {
    fromAttribute: value => {
      // Parse string into array
      if (typeof value === 'string' && value.indexOf(',') !== -1) {
        return parseEmailsString(value, false);
      }
      return value;
    },
    toAttribute: value => value.join(',')
  }
}), _dec2$1 = e$c(), _dec3 = e$c({
  type: Boolean
}), _dec4 = e$c({
  type: Boolean
}), _dec5 = e$c({
  type: Boolean
}), _dec6 = e$c({
  type: String
}), _dec7 = e$c({
  attribute: 'help-text'
}), _dec8 = e$c({
  type: Boolean,
  reflect: true
}), _dec9 = e$c({
  type: Object
}), _dec10 = e$c({
  type: String
}), _dec11 = e$c({
  type: Number,
  reflect: true
}), _dec12 = t$7(), _dec13 = t$7(), _dec14 = t$7(), _dec15 = t$7(), _dec16 = t$7(), (_class$3 = (_class2 = class Et2Email extends Et2InputWidget(s$5) {
  static get styles() {
    return [shoelace, ...super.styles, styles];
  }

  /**
   * The current value of the component, an array of valid email addresses.
   * If allowPlaceholder=true, placeholders are also allowed
   */

  get _popup() {
    return this.shadowRoot.querySelector("sl-popup");
  }
  get _listbox() {
    return this.shadowRoot.querySelector("#listbox");
  }
  get _search() {
    return this.shadowRoot.querySelector("#search");
  }
  get _tags() {
    return Array.from(this.shadowRoot.querySelectorAll("et2-email-tag"));
  }
  get _suggestions() {
    return Array.from(this.shadowRoot.querySelectorAll("sl-option"));
  }

  /**
   * When user is typing, we wait this long for them to be finished before we start the search
   * @type {number}
   * @protected
   * @internal
   */

  constructor() {
    // @ts-ignore
    super(...arguments);
    _initializerDefineProperty$2(this, "value", _descriptor$2, this);
    /** Placeholder text to show as a hint when the select is empty. */
    _initializerDefineProperty$2(this, "placeholder", _descriptor2, this);
    /** Allow drag and drop tags between two or more Et2Email widgets */
    _initializerDefineProperty$2(this, "allowDragAndDrop", _descriptor3, this);
    /** Allow placeholders like {{email}}, as well as real email-addresses */
    _initializerDefineProperty$2(this, "allowPlaceholder", _descriptor4, this);
    /** Include mailing lists: returns them with their integer list_id */
    _initializerDefineProperty$2(this, "includeLists", _descriptor5, this);
    /**
     * What to display for the selected email addresses
     *
     * {@link Et2EmailTag#emailDisplay}
     */
    _initializerDefineProperty$2(this, "emailDisplay", _descriptor6, this);
    /** The component's help text. If you need to display HTML, use the `help-text` slot instead. */
    _initializerDefineProperty$2(this, "helpText", _descriptor7, this);
    /**
     * Indicates whether the suggestions are open. You can toggle this attribute to show and hide the menu, or you can
     * use the `show()` and `hide()` methods and this attribute will reflect the suggestion open state.
     */
    _initializerDefineProperty$2(this, "open", _descriptor8, this);
    /**
     * Custom search options, passed to the searchUrl along with the search text
     *
     * @type {{includeLists : boolean}}
     */
    _initializerDefineProperty$2(this, "searchOptions", _descriptor9, this);
    /**
     * Server-side search for suggested email addresses.
     * Set to "" to cancel searching.
     * @type {string}
     */
    _initializerDefineProperty$2(this, "searchUrl", _descriptor10, this);
    /**
     * Limit the maximum height of the widget, for when you have a lot of addresses.
     * Set it to 1 for special single-line styling, 0 to disable
     * @type {number}
     */
    _initializerDefineProperty$2(this, "rows", _descriptor11, this);
    _initializerDefineProperty$2(this, "searching", _descriptor12, this);
    _initializerDefineProperty$2(this, "hasFocus", _descriptor13, this);
    _initializerDefineProperty$2(this, "currentOption", _descriptor14, this);
    _initializerDefineProperty$2(this, "currentTag", _descriptor15, this);
    /** If the select is limited to 1 row, we show the number of tags not visible */
    _initializerDefineProperty$2(this, "_tagsHidden", _descriptor16, this);
    _defineProperty$18(this, "hasSlotController", new HasSlotController(this, 'help-text', 'label'));
    /** User preference to immediately close the search results after selecting a match
     * @internal
     */
    _defineProperty$18(this, "_close_on_select", true);
    _defineProperty$18(this, "_searchTimeout", void 0);
    _defineProperty$18(this, "_searchPromise", Promise.resolve([]));
    _defineProperty$18(this, "_selectOptions", []);
    // Overflow Observer for +# display
    _defineProperty$18(this, "tagOverflowObserver", null);
    // Drag / drop / sort
    _defineProperty$18(this, "_sortable", void 0);
    // UID to force Lit to re-draw tags after sort
    _defineProperty$18(this, "_valueUID", void 0);
    /**
     * Focus has gone somewhere else
     * @param {MouseEvent} event
     */
    _defineProperty$18(this, "handleLostFocus", event => {
      // Close when clicking outside of the component
      var path = event.composedPath();
      if (this && !path.includes(this)) {
        this.hide();
      }
    });
    this.defaultValidators.push(new IsEmail(this.allowPlaceholder));

    // Set email display to preference, will be overridden by template attribute
    this.emailDisplay = this._getEmailDisplayPreference();

    // Additional option for select email, per ticket #79694
    this._close_on_select = this.egw().preference("select_multiple_close") != "open";
    this.handleOpenChange = this.handleOpenChange.bind(this);
    this.handleLostFocus = this.handleLostFocus.bind(this);
    this.handleSortEnd = this.handleSortEnd.bind(this);
    this.handleTagOverflow = this.handleTagOverflow.bind(this);
    this.handleMouseEnter = this.handleMouseEnter.bind(this);
    this.handleMouseLeave = this.handleMouseLeave.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    this.open = false;
    this._valueUID = this.egw().uid();
    this.updateComplete.then(() => this.makeSortable());
    document.addEventListener('focusin', this.handleLostFocus);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    if (this._sortable) {
      this._sortable.destroy();
    }
    document.removeEventListener('focusin', this.handleLostFocus);
  }
  set_value(_value) {
    if (!Array.isArray(_value)) {
      this.value = parseEmailsString(_value, this.allowPlaceholder);
    } else {
      this.value = _value;
    }
    this._valueUID = this.egw().uid();
    this.requestUpdate("value");
  }
  willUpdate(changedProperties) {
    super.willUpdate(changedProperties);
    if (changedProperties.has('allowPlaceholder')) {
      this.defaultValidators = this.defaultValidators.filter(v => !(v instanceof IsEmail));
      this.defaultValidators.push(new IsEmail(this.allowPlaceholder));
    }
  }
  update(changedProperties) {
    super.update(changedProperties);
    if (changedProperties.has("open")) {
      this.handleOpenChange();
    }
  }
  firstUpdated(changedProperties) {
    super.firstUpdated(changedProperties);

    // Make sure validators reflect allowPlaceholder, in case it's not caught by willUpdate()
    this.defaultValidators = this.defaultValidators.filter(v => !(v instanceof IsEmail));
    this.defaultValidators.push(new IsEmail(this.allowPlaceholder));
  }
  updated(changedProperties) {
    super.updated(changedProperties);

    // Re-set sorting / drag & drop
    if (changedProperties.has("value")) {
      this.makeSortable();
    }
    this.checkTagOverflow();
  }
  _getEmailDisplayPreference() {
    var _this$egw$preference;
    var pref = (_this$egw$preference = this.egw().preference("emailTag", "mail")) !== null && _this$egw$preference !== void 0 ? _this$egw$preference : "";
    switch (pref) {
      case "fullemail":
        return "full";
      default:
      case "onlyname":
        return "name";
      case "onlyemail":
        return "email";
      case "domain":
        return "domain";
    }
  }
  addOpenListeners() {
    document.addEventListener('mousedown', this.handleLostFocus);
  }
  removeOpenListeners() {
    document.removeEventListener('mousedown', this.handleLostFocus);
  }
  makeSortable() {
    if (this._sortable) {
      this._sortable.destroy();
    }
    if (!this.allowDragAndDrop) {
      this.classList.remove("et2-sortable-email");
      return;
    }
    this.classList.add("et2-sortable-email");
    var pull = !this.disabled && !this.readonly;
    if (this.readonly && !this.disabled) {
      pull = 'clone';
    }
    this._sortable = Sortable.create(this.shadowRoot.querySelector('.email__combobox'), {
      draggable: "et2-email-tag",
      group: {
        name: "email",
        pull: pull,
        put: !(this.readonly || this.disabled)
      },
      onEnd: this.handleSortEnd
    });
  }

  /**
   * Sets the current suggestion, which is the option the user is currently interacting with (e.g. via keyboard).
   * Only one option may be "current" at a time.
   */
  setCurrentOption(option) {
    // Clear selection
    this._suggestions.forEach(el => {
      el.current = false;
      el.tabIndex = -1;
    });

    // Select the target option
    this.currentOption = option;
    if (option) {
      option.current = true;
      option.tabIndex = 0;
      option.focus();
    }
  }
  setCurrentTag(tag) {
    this._tags.forEach(t => {
      t.tabIndex = -1;
      if (t.current) {
        t.current = false;
        t.requestUpdate();
      }
    });
    this.currentTag = tag;
    if (tag) {
      this.currentTag.tabIndex = 0;
      this.currentTag.current = true;
      this.currentTag.requestUpdate();
      this.currentTag.focus();
    }
  }
  checkTagOverflow() {
    // Create / destroy intersection observer
    if (this.readonly && this.rows == "1" && this.tagOverflowObserver == null) {
      this.tagOverflowObserver = new IntersectionObserver(this.handleTagOverflow, {
        root: this.shadowRoot.querySelector(".email__combobox"),
        threshold: 0.1
      });
    } else if ((!this.readonly || this.rows !== 1) && this.tagOverflowObserver !== null) {
      this.tagOverflowObserver.disconnect();
      this.tagOverflowObserver = null;
    }
    if (this.tagOverflowObserver) {
      this.updateComplete.then(() => {
        for (var tag of Array.from(this.shadowRoot.querySelectorAll(".email__combobox et2-email-tag"))) {
          this.tagOverflowObserver.observe(tag);
        }
      });
    }
  }

  /**
   * Create an entry that is not in the suggestions and add it to the value
   *
   * @param {string} text Used as both value and label
   */
  addAddress(text) {
    if (!text || !this.validateAddress(text)) {
      return false;
    }
    // Make sure not to double-add
    if (!this.value.includes(text.replace(/'/g, "\\\'"))) {
      this.value.push(text.trim());
      this.requestUpdate('value');
    }
    this.dispatchEvent(new Event("change", {
      bubbles: true
    }));
    return true;
  }

  /**
   * Check if a free entry value is acceptable.
   * We use validators directly using the proposed value
   *
   * @param text
   * @returns {boolean}
   */
  validateAddress(text) {
    var validators = [...this.validators, ...this.defaultValidators];
    var result = validators.filter(v => v.execute(text, v.param, {
      node: this
    }));
    return validators.length > 0 && result.length == 0 || validators.length == 0;
  }

  /** Sets focus on the control. */
  focus(options) {
    this.hasFocus = true;
    // Should not be needed, but not firing the update
    this.requestUpdate("hasFocus");
    if (this._search) {
      this._search.focus(options);
    }
  }

  /** Removes focus from the control. */
  blur() {
    this.open = false;
    this.hasFocus = false;
    // Should not be needed, but not firing the update
    this.requestUpdate("open");
    this.requestUpdate("hasFocus");
    this._search.blur();
    clearTimeout(this._searchTimeout);
  }

  /** Shows the listbox. */
  show() {
    var _this = this;
    return _asyncToGenerator$6(function* () {
      if (_this.open || _this.disabled) {
        _this.open = false;
        _this.requestUpdate("open", true);
        return undefined;
      }
      _this.open = true;
      _this.requestUpdate("open", false);
      return waitForEvent(_this, 'sl-after-show');
    })();
  }

  /** Hides the listbox. */
  hide() {
    var _this2 = this;
    return _asyncToGenerator$6(function* () {
      if (!_this2.open || _this2.disabled) {
        return undefined;
      }
      _this2.open = false;
      _this2.requestUpdate("open");
      return waitForEvent(_this2, 'sl-after-hide');
    })();
  }

  /**
   * Start searching for contacts matching what has been typed
   */
  startSearch() {
    var _this3 = this;
    return _asyncToGenerator$6(function* () {
      // Stop timeout timer
      clearTimeout(_this3._searchTimeout);

      // Clear current option, it's probably going to go away
      _this3.setCurrentOption(null);

      // If no searchUrl, no search
      if (!_this3.searchUrl) {
        return;
      }
      _this3.searching = true;
      _this3.requestUpdate("searching");

      // Start the searches
      _this3._searchPromise = _this3.remoteSearch(_this3._search.value, _this3.searchOptions);
      return _this3._searchPromise.then( /*#__PURE__*/_asyncToGenerator$6(function* () {
        _this3.searching = false;
        _this3.requestUpdate("searching", true);
        if (!_this3.open && _this3.hasFocus) {
          _this3.show();
        }
        yield _this3.updateComplete;
      }));
    })();
  }

  /**
   * Actually query the server.
   *
   * This can be overridden to change request parameters or eg. send them as POST parameters.
   *
   * Default implementation here sends search string and options:
   * - as two parameters to the AJAX function
   * - and (additional) as GET parameters plus search string as "query"
   *
   *
   * @param {string} search
   * @param {object} options
   * @returns Promise<SelectOption[]>
   * @protected
   * @internal
   */
  remoteSearch(search, options) {
    // Include a limit, even if options don't, to avoid massive lists breaking the UI
    var sendOptions = _objectSpread$v({
      num_rows: 10
    }, options);
    return this.egw().request(this.egw().link(this.egw().ajaxUrl(this.egw().decodePath(this.searchUrl)), _objectSpread$v({
      query: search
    }, sendOptions)), [search, sendOptions]).then(results => {
      return this.processRemoteResults(results);
    });
  }

  /**
   * Add in remote results
   *
   * Any results that already exist will be removed to avoid duplicates
   *
   * @param results
   * @protected
   * @internal
   */
  processRemoteResults(entries) {
    this._selectOptions = entries;
    this.updateComplete.then(() => {
      this.currentOption = this._suggestions[0];
    });
    this.requestUpdate();
    return entries;
  }

  /**
   * The end of a sort, either internal or between widgets that deal with email
   *
   * @param event
   * @protected
   * @internal
   */
  handleSortEnd(event) {
    var _event$item;
    if (this.disabled || this.readonly || !((_event$item = event.item) !== null && _event$item !== void 0 && _event$item.value) || !this.validateAddress(event.item.value) ||
    // No real change
    event.from === event.to && event.oldDraggableIndex == event.newDraggableIndex) {
      return;
    }
    var tag = event.item;
    var from = Sortable.utils.closest(event.from, "et2-email, .et2-sortable-email");
    var to = Sortable.utils.closest(event.to, "et2-email, .et2-sortable-email");
    if (from == this) {
      var _this$egw$uid, _this$egw;
      var index = this.value.indexOf(tag.value);
      if (index > -1) {
        this.value.splice(index, 1);
      }

      // Reset focus
      /*
      if(typeof from.focus == "function")
      {
      	this.updateComplete.then(() =>
      	{
      		from.focus();
      	});
      }
       */
      // Update key to force Lit to redraw tags
      this._valueUID = (_this$egw$uid = (_this$egw = this.egw()) === null || _this$egw === void 0 ? void 0 : _this$egw.uid()) !== null && _this$egw$uid !== void 0 ? _this$egw$uid : new Date().toISOString();
    }
    if (to === this) {
      var _this$egw$uid2, _this$egw2;
      var targetIndex = typeof event.newDraggableIndex == "number" ? event.newDraggableIndex : this.value.length;
      this.value.splice(targetIndex, 0, tag.value);

      // Update key to force Lit to redraw tags
      this._valueUID = (_this$egw$uid2 = (_this$egw2 = this.egw()) === null || _this$egw2 === void 0 ? void 0 : _this$egw2.uid()) !== null && _this$egw$uid2 !== void 0 ? _this$egw$uid2 : new Date().toISOString();
    } else if (typeof to.handleSortEnd == "function") {
      to.handleSortEnd(event);
    }
    // Remove tag to avoid occasional duplication
    tag.remove();
    this.requestUpdate("value");
  }
  handleOpenChange() {
    var _this4 = this;
    return _asyncToGenerator$6(function* () {
      if (_this4.open && !_this4.disabled) {
        // Reset the current option
        _this4.setCurrentOption(_this4._suggestions[0]);

        // Show
        _this4.dispatchEvent(new CustomEvent('sl-show', {
          bubbles: true
        }));
        _this4.addOpenListeners();
        _this4._listbox.hidden = false;
        _this4._popup.active = true;

        // Make sure the current option is scrolled into view (required for Safari)
        if (_this4.currentOption) {
          _this4.currentOption.scrollIntoView();
        }
        _this4.dispatchEvent(new CustomEvent('sl-after-show', {
          bubbles: true
        }));
      } else {
        // Hide
        _this4.dispatchEvent(new CustomEvent('sl-hide', {
          bubbles: true
        }));
        _this4.removeOpenListeners();
        _this4._listbox.hidden = true;
        _this4._popup.active = false;
        _this4.dispatchEvent(new CustomEvent('sl-after-hide', {
          bubbles: true
        }));
      }
    })();
  }

  /**
   * Callback for the intersection observer so we know when tags don't fit
   *
   * Here we set the flag to show how many more tags are hidden, but this only happens
   * when there are more tags than space.
   *
   * @param entries
   * @protected
   */
  handleTagOverflow(entries) {
    var oldCount = this._tagsHidden;
    var visibleTagCount = this.value.length - this._tagsHidden;
    var update = false;
    // If we have all tags, start from 0, otherwise it's just a change
    if (entries.length == this.value.length) {
      visibleTagCount = 0;
    } else {
      update = true;
    }
    for (var tag of entries) {
      if (tag.isIntersecting) {
        visibleTagCount++;
      } else if (update && !tag.isIntersecting) {
        visibleTagCount--;
      } else {
        break;
      }
    }
    if (visibleTagCount && visibleTagCount < this.value.length) {
      this._tagsHidden = this.value.length - visibleTagCount;
    } else {
      this._tagsHidden = 0;
    }
    this.requestUpdate("_tagsHidden", oldCount);
  }

  /**
   * Sometimes users paste multiple comma separated values at once.  Split them then handle normally.
   * Overridden here to handle email addresses that may have commas using the regex from the validator.
   *
   * @param {ClipboardEvent} event
   * @protected
   */
  handlePaste(event) {
    event.preventDefault();
    var paste = event.clipboardData.getData('text');
    if (!paste) {
      return;
    }
    var selection = window.getSelection();
    if (selection.rangeCount) {
      selection.deleteFromDocument();
    }
    var values = parseEmailsString(paste, this.allowPlaceholder);
    if (values) {
      var _this$egw$uid3, _this$egw3;
      values.forEach(v => {
        this.addAddress(v.trim());
      });
      this.hide();

      // Update key to force Lit to redraw tags
      this._valueUID = (_this$egw$uid3 = (_this$egw3 = this.egw()) === null || _this$egw3 === void 0 ? void 0 : _this$egw3.uid()) !== null && _this$egw$uid3 !== void 0 ? _this$egw$uid3 : new Date().toISOString();
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));
    }
  }
  handleSearchFocus() {
    // Clear any manual message (errors on invalid search text)
    this.set_validation_error(false);
    this.hasFocus = true;
    // Should not be needed, but not firing the update
    this.requestUpdate("hasFocus");

    // Reset tags to not take focus
    this.setCurrentTag(null);
    this._search.setSelectionRange(this._search.value.length, this._search.value.length);
  }
  handleSearchBlur(event) {
    this.hasFocus = false;
    // Should not be needed, but not firing the update
    this.requestUpdate("hasFocus");

    // If they had something OK typed, use it, but only if focus went outside Et2Email
    // because maybe they clicked an option which took focus
    if (event.composedPath().includes(this)) {
      if (this.addAddress(this._search.value.trim())) {
        this._search.value = "";
        this.dispatchEvent(new Event("change", {
          bubbles: true
        }));
      } else if (this._search.value) {
        // Invalid input, show message.  Not part of the value, so normal validation doesn't apply
        // Can't just call this.validate(), it will get cleared immediately
        this.set_validation_error(this.egw().lang("Invalid email") + ' "' + this._search.value + '"');
      }
    }
  }
  handleSearchKeyDown(event) {
    clearTimeout(this._searchTimeout);

    // Left at beginning goes to tags
    if (this._search.selectionStart == 0 && event.key == "ArrowLeft") {
      this.hide();
      this._tags.forEach(t => t.tabIndex = 0);
      if (this._tags.length > 0) {
        this.setCurrentTag(this._tags[this._tags.length - 1]);
      }
      event.stopPropagation();
      return;
    }

    // Tab on empty leaves
    if (this._search.value == "" && event.key == "Tab") {
      // Propagate, browser will do its thing
      return;
    }
    // Up / Down navigates options
    if (['ArrowDown', 'ArrowUp'].includes(event.key) && this._suggestions.length) {
      if (!this.open) {
        return this.show();
      }
      return this.handleSuggestionsKeyDown(event);
    }
    // Tab or enter checks current value
    else if (Et2Email.TAG_BREAK.indexOf(event.key) !== -1) {
      // Check for valid email or current selection
      if (!this.validateAddress(this._search.value.trim()) && this.currentOption && this.currentOption.value.toLowerCase().includes(this._search.value.toLowerCase())) {
        this._search.value = this.currentOption.value.replaceAll("___", " ");
      }
      if (this.addAddress(this._search.value.trim())) {
        this.open = false;
        this._search.value = "";
        this.dispatchEvent(new Event("change", {
          bubbles: true
        }));
      }
      if (event.key == "Tab") {
        this.blur();
        // Allow tab to change the focus
      } else {
        // Don't want the key to do its normal thing
        event.stopPropagation();
        event.preventDefault();
      }
    }
    // Start search immediately
    else if (event.key == "Enter") {
      event.preventDefault();
      this.startSearch();
      return;
    } else if (event.key == "Escape") {
      this._selectOptions = [];
      this.hide();
      return;
    }

    // Start the search automatically if they have enough letters
    // -1 because we're in keyDown handler, and value is from _before_ this key was pressed
    if (this._search.value.length - 1 > 0) {
      this._searchTimeout = window.setTimeout(() => {
        this.startSearch();
      }, Et2Email.SEARCH_TIMEOUT);
    }
  }
  handleLabelClick() {
    this._search.focus();
  }

  /**
   * Keyboard events that the search input did not grab
   * (tags, otion navigation)
   *
   * @param {KeyboardEvent} event
   */
  handleComboboxKeyDown(event) {
    // Navigate between tags
    if (this.currentTag && ["ArrowLeft", "ArrowRight", "Home", "End"].includes(event.key)) {
      var nextTagIndex = this._tags.indexOf(this.currentTag);
      var tagCount = this._tags.length;
      switch (event.key) {
        case 'ArrowLeft':
          nextTagIndex--;
          break;
        case 'ArrowRight':
          nextTagIndex++;
          break;
        case 'Home':
          nextTagIndex = 0;
          break;
        case 'End':
          nextTagIndex = this._tags.length - 1;
          break;
      }
      nextTagIndex = Math.max(0, nextTagIndex);
      if (nextTagIndex < tagCount && this._tags[nextTagIndex]) {
        this.setCurrentTag(this._tags[nextTagIndex]);
      } else {
        // Arrow back to search, or got lost
        this._search.focus();
      }
      event.stopPropagation();
      return false;
    }
    // Remove tag
    if (event.target instanceof Et2EmailTag && ["Delete", "Backspace"].includes(event.key)) {
      var tags = this._tags;
      var index = tags.indexOf(event.target);
      event.target.dispatchEvent(new CustomEvent('sl-remove', {
        bubbles: true
      }));
      index += event.key == "Delete" ? 1 : -1;
      if (index >= 0 && index < tags.length) {
        this.setCurrentTag(this._tags[index]);
      } else {
        this._search.focus();
      }
    }
    // Edit tag
    else if (event.target instanceof Et2EmailTag && ["Enter"].includes(event.key)) {
      event.target.startEdit();
    }
  }

  /**
   * If rows=1 and multiple=true, when they put the mouse over the widget show all tags
   * @param {MouseEvent} e
   * @private
   */
  handleMouseEnter(e) {
    if (this.rows == "1" && this.value.length > 1) {
      e.stopPropagation();

      // Bind to turn this all off
      this.addEventListener("mouseleave", this.handleMouseLeave);
      this.classList.add("hover");
      this.requestUpdate();
    }
  }

  /**
   * If we're showing all rows because of _handleMouseEnter, reset when mouse leaves
   * @param {MouseEvent} e
   * @private
   */
  handleMouseLeave(e) {
    this.classList.remove("hover");
    this.requestUpdate();
  }

  /**
   * Keyboard events from the suggestion list
   *
   * @param {KeyboardEvent} event
   */
  handleSuggestionsKeyDown(event) {
    // Select the option
    if (this.currentOption && ["ArrowRight", " ", ...Et2Email.TAG_BREAK].includes(event.key) && this.addAddress(this.currentOption.value.replaceAll("___", " "))) {
      if (this._close_on_select) {
        this.open = false;
      }
      this._search.focus();
      this._search.value = "";
      if (event.key !== "Tab") {
        event.stopPropagation();
        event.preventDefault();
      }
      return;
    }
    // Navigate options
    if (["ArrowUp", "ArrowDown", "Home", "End"].includes(event.key)) {
      event.stopPropagation();
      var suggestions = this._suggestions;
      var currentIndex = suggestions.indexOf(this.currentOption);
      var newIndex = Math.max(0, currentIndex);

      // Prevent scrolling
      event.preventDefault();
      if (event.key === "ArrowDown") {
        newIndex = currentIndex + 1;
        if (newIndex > suggestions.length - 1) {
          newIndex = suggestions.length - 1;
        }
      } else if (event.key === "ArrowUp") {
        newIndex = currentIndex - 1;
        if (newIndex < 0) {
          this.setCurrentOption(null);
          this._search.focus();
        }
      } else if (event.key === "Home") {
        newIndex = 0;
      } else if (event.key === "End") {
        newIndex = suggestions.length - 1;
      }
      this.setCurrentOption(suggestions[newIndex]);
    } else if (["Escape"]) {
      this.open = false;
      this._search.focus();
    }
  }

  /**
   * Mouse up from the suggestion list
   * @param event
   */
  handleSuggestionsMouseUp(event) {
    if (typeof event.target.value == "undefined") {
      return;
    }
    var value = event.target.value.replaceAll("___", " ");
    this.addAddress(value);
    this._search.value = "";
    this._search.focus();
    this.requestUpdate("value");
    this.dispatchEvent(new Event("change", {
      bubbles: true
    }));
    if (this._close_on_select) {
      this.open = false;
    }
  }
  handleTagChange(event) {
    // Need to update our value, or it will just redo the tag with the old value
    if (event.originalValue && this.value.includes(event.originalValue)) {
      var index = this.value.indexOf(event.originalValue);
      this.value[index] = event.target.value;
      this.requestUpdate();
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));
    }
    if (event.target.current) {
      this.setCurrentTag(event.target);
    }
  }
  handleTagRemove(event, value) {
    event.stopPropagation();

    // Find the tag value and remove it from current value
    var index = this.value.indexOf(value);
    this.value.splice(index, 1);
    this._valueUID = this.egw().uid();
    this.requestUpdate("value");
    this.dispatchEvent(new Event("change", {
      bubbles: true
    }));
  }

  /* Sub-template when [readonly][rows=1] to show all tags in current value in popup */
  readonlyHoverTemplate() {
    if (!this.classList.contains("hover")) {
      return A$1;
    }

    // Offset distance to open _over_ the rest
    var distance = -1 * parseInt(getComputedStyle(this).height) + 1;
    return x$1(_templateObject$B || (_templateObject$B = _taggedTemplateLiteral$B(["\n            <sl-popup\n                    active\n                    anchor=", "\n                    auto-size=\"both\"\n                    class=\"hover__popup details hoist details__body\"\n                    distance=", "\n                    placement=\"bottom\"\n                    sync=\"width\"\n            >\n                ", "\n            </sl-popup>\n\t\t"])), this, distance, this.tagsTemplate());
  }
  tagsTemplate() {
    return x$1(_templateObject2$m || (_templateObject2$m = _taggedTemplateLiteral$B(["", ""])), i$1(this._valueUID, o$2(this.value, (value, index) => this.tagTemplate(value))));
  }
  tagTemplate(value) {
    var _this$emailDisplay;
    var readonly = this.readonly || this.disabled;
    var isEditable = !readonly;
    var isValid = this.validateAddress(value);
    return x$1(_templateObject3$a || (_templateObject3$a = _taggedTemplateLiteral$B(["\n            <et2-email-tag\n                    exportparts=\"image\"\n                    part=\"tag\"\n                    class=", "\n                    variant=", "\n                    .emailDisplay=", "\n                    .value=", "\n                    ?removable=", "\n                    ?readonly=", "\n                    ?editable=", "\n                    @sl-remove=", "\n                    @mousedown=", "\n                    @dblclick=", "\n                    @change=", "\n            >\n            </et2-email-tag>"])), o$9({
      "et2-select-draggable": !this.readonly && this.allowDragAndDrop
    }), this.isValid ? A$1 : "danger", (_this$emailDisplay = this.emailDisplay) !== null && _this$emailDisplay !== void 0 ? _this$emailDisplay : A$1, l$1(value), !readonly, readonly, isEditable, e => this.handleTagRemove(e, value), e => {
      this._cancelOpen = true;
    }, e => {
      e.target.startEdit();
    }, this.handleTagChange);
  }
  tagLimitTemplate() {
    if (this._tagsHidden == 0) {
      return A$1;
    }
    return x$1(_templateObject4$6 || (_templateObject4$6 = _taggedTemplateLiteral$B(["\n            <sl-tag\n                    part=\"tag__limit\"\n                    class=\"tag_limit\"\n                    slot=\"expand-icon\"\n            >+", "\n            </sl-tag>"])), this._tagsHidden);
  }
  inputTemplate() {
    return x$1(_templateObject5$4 || (_templateObject5$4 = _taggedTemplateLiteral$B(["\n            <input id=\"search\" type=\"text\" part=\"input\"\n                   class=\"email__search\"\n                   exportparts=\"base:search__base\"\n                   autocomplete=\"off\"\n                   ?disabled=", "\n                   ?readonly=", "\n                   placeholder=\"", "\"\n                   tabindex=\"0\"\n                   @keydown=", "\n                   @blur=", "\n                   @focus=", "\n                   @paste=", "\n            />\n\t\t"])), this.disabled, this.readonly, this.hasFocus || this.value.length > 0 || this.disabled || this.readonly ? "" : this.placeholder, this.handleSearchKeyDown, this.handleSearchBlur, this.handleSearchFocus, this.handlePaste);
  }
  suggestionsTemplate() {
    return x$1(_templateObject6$2 || (_templateObject6$2 = _taggedTemplateLiteral$B(["", ""])), c$2(this._selectOptions, o => o.value, this.optionTemplate.bind(this)));
  }

  /**
   * Used to render each option into the suggestions
   *
   * @param {SelectOption} option
   * @returns {TemplateResult}
   */
  optionTemplate(option) {
    var classes = option.class ? Object.fromEntries(option.class.split(" ").map(k => [k, true])) : {};
    var value = option.value.replaceAll(" ", "___");
    return x$1(_templateObject7$1 || (_templateObject7$1 = _taggedTemplateLiteral$B(["\n            <sl-option\n                    part=\"option\"\n                    exportparts=\"prefix:tag__prefix, suffix:tag__suffix, image\"\n                    title=\"", "\"\n                    class=", "\n                    .value=\"", "\"\n                    .option=", "\n                    ?disabled=", "\n            >\n                <et2-lavatar slot=\"prefix\" exportparts=\"image\" part=\"icon\" size=\"1.8em\"\n                             lname=", "\n                             fname=", "\n                             image=", "\n                >\n                </et2-lavatar>\n                ", "\n            </sl-option>"])), !option.title || this.noLang ? option.title : this.egw().lang(option.title), o$9(_objectSpread$v({}, classes)), value, option, option.disabled, option.lname || A$1, option.fname || A$1, option.icon || A$1, this.noLang ? option.label : this.egw().lang(option.label));
  }
  render() {
    var hasLabelSlot = this.hasSlotController.test('label');
    var hasHelpTextSlot = this.hasSlotController.test('help-text');
    var hasLabel = this.label ? true : !!hasLabelSlot;
    var hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    var isPlaceholderVisible = this.placeholder && this.value.length === 0 && !this.disabled && !this.readonly;
    var styles = {};
    if (this.rows !== 0) {
      styles["--height"] = this.rows;
    }

    // TODO Don't forget required & disabled

    return x$1(_templateObject8$1 || (_templateObject8$1 = _taggedTemplateLiteral$B(["\n            <div\n                    part=\"form-control\"\n                    class=", "\n                    style=", "\n                    @click=", "\n                    @mouseenter=", "\n                    @mousedown=", "\n            >\n                <label\n                        id=\"label\"\n                        part=\"form-control-label\"\n                        class=\"form-control__label\"\n                        aria-hidden=", "\n                        @click=", "\n                >\n                    <slot name=\"label\">", "</slot>\n                </label>\n                ", "\n                <div part=\"form-control-input\" class=\"form-control-input\">\n                    <sl-popup\n                            class=", "\n                            placement=\"bottom\"\n                            strategy=\"fixed\"\n                            flip\n                            shift\n                            sync=\"width\"\n                            auto-size=\"vertical\"\n                            auto-size-padding=\"10\"\n                            ?active=", "\n                    >\n                        <div\n                                part=\"combobox base\"\n                                class=\"email__combobox\"\n                                slot=\"anchor\"\n                                @keydown=", "\n                        >\n                            <slot part=\"prefix\" name=\"prefix\" class=\"email__prefix\"></slot>\n                            ", "\n                            ", "\n                            ", "\n                            ", "\n                            <slot part=\"suffix\" name=\"suffix\" class=\"email__suffix\"></slot>\n                        </div>\n                        <div\n                                id=\"listbox\"\n                                role=\"listbox\"\n                                aria-expanded=", "\n                                aria-labelledby=\"label\"\n                                part=\"listbox\"\n                                class=\"email__listbox\"\n                                tabindex=\"-1\"\n                                @keydown=", "\n                                @mouseup=", "\n                        >\n                            ", "\n                        </div>\n                    </sl-popup>\n                </div>\n                <div\n                        part=\"form-control-help-text\"\n                        id=\"help-text\"\n                        class=\"form-control__help-text\"\n                        aria-hidden=", "\n                >\n                    <slot name=\"help-text\">", "</slot>\n                </div>\n            </div>\n\t\t"])), o$9({
      'form-control': true,
      'form-control--medium': true,
      'form-control--has-label': hasLabel,
      'form-control--has-help-text': hasHelpText
    }), o$7(styles), this.handleLabelClick, this.handleMouseEnter, () => {
      if (!this.hasFocus) {
        // Helps Sortable work every time
        this.focus();
      }
    }, hasLabel ? 'false' : 'true', this.handleLabelClick, this.label, this.readonlyHoverTemplate(), o$9({
      email: true,
      input: true,
      'email--open': this.open,
      'email--disabled': this.disabled,
      'email--readonly': this.readonly,
      'email--focused': this.hasFocus,
      'email--placeholder-visible': isPlaceholderVisible,
      'email--top': this.placement === 'top',
      'email--bottom': this.placement === 'bottom'
    }), this.open, this.handleComboboxKeyDown, this.tagsTemplate(), this.inputTemplate(), this.tagLimitTemplate(), this.searching ? x$1(_templateObject9$1 || (_templateObject9$1 = _taggedTemplateLiteral$B(["\n                                <sl-spinner class=\"email__loading\"></sl-spinner>"]))) : A$1, this.open ? 'true' : 'false', this.handleSuggestionsKeyDown, this.handleSuggestionsMouseUp, this._selectOptions && this._selectOptions.length ? this.suggestionsTemplate() : this.egw().lang("no matches found"), hasHelpText ? 'false' : 'true', this.helpText);
  }
}, _defineProperty$18(_class2, "shadowRootOptions", _objectSpread$v(_objectSpread$v({}, s$5.shadowRootOptions), {}, {
  delegatesFocus: true
})), _defineProperty$18(_class2, "SEARCH_TIMEOUT", 500), _defineProperty$18(_class2, "TAG_BREAK", ["Tab", "Enter", ","]), _class2), (_descriptor$2 = _applyDecoratedDescriptor$2(_class$3.prototype, "value", [_dec$2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor2 = _applyDecoratedDescriptor$2(_class$3.prototype, "placeholder", [_dec2$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor3 = _applyDecoratedDescriptor$2(_class$3.prototype, "allowDragAndDrop", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return true;
  }
}), _descriptor4 = _applyDecoratedDescriptor$2(_class$3.prototype, "allowPlaceholder", [_dec4], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor5 = _applyDecoratedDescriptor$2(_class$3.prototype, "includeLists", [_dec5], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor6 = _applyDecoratedDescriptor$2(_class$3.prototype, "emailDisplay", [_dec6], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor7 = _applyDecoratedDescriptor$2(_class$3.prototype, "helpText", [_dec7], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor8 = _applyDecoratedDescriptor$2(_class$3.prototype, "open", [_dec8], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor9 = _applyDecoratedDescriptor$2(_class$3.prototype, "searchOptions", [_dec9], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {
      includeLists: true
    };
  }
}), _descriptor10 = _applyDecoratedDescriptor$2(_class$3.prototype, "searchUrl", [_dec10], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return "EGroupware\\Api\\Etemplate\\Widget\\Taglist::ajax_email";
  }
}), _descriptor11 = _applyDecoratedDescriptor$2(_class$3.prototype, "rows", [_dec11], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor12 = _applyDecoratedDescriptor$2(_class$3.prototype, "searching", [_dec12], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor13 = _applyDecoratedDescriptor$2(_class$3.prototype, "hasFocus", [_dec13], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor14 = _applyDecoratedDescriptor$2(_class$3.prototype, "currentOption", [_dec14], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor15 = _applyDecoratedDescriptor$2(_class$3.prototype, "currentTag", [_dec15], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor16 = _applyDecoratedDescriptor$2(_class$3.prototype, "_tagsHidden", [_dec16], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 0;
  }
})), _class$3));
customElements.define("et2-email", Et2Email);

/**
 * Parse string that may contain multiple comma separated email addresses into an array
 *
 * @param {string} value
 * @returns {string[]}
 * @protected
 */
function parseEmailsString(value) {
  var allowPlaceholder = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  if (!value) return [];
  var preg = allowPlaceholder ? IsEmail.EMAIL_PLACEHOLDER_PREG : IsEmail.EMAIL_PREG;
  // Trim line start / end anchors off validation regex, make global
  var regex = new RegExp(preg.toString().substring(2, preg.toString().length - 3), 'g');
  return value.match(regex);
}

!function(){"use strict";function t(t,e){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t}function i(t){if(!this||this.find!==i.prototype.find)return new i(t);if(this.length=0,t)if((t="string"==typeof t?this.find(t):t).nodeType||t===t.window)this.length=1,this[0]=t;else {var e=t.length;for(this.length=e;e;)this[--e]=t[e];}}i.extend=t,i.contains=function(t,e){do{if((e=e.parentNode)===t)return !0}while(e);return !1},i.parseJSON=function(t){return JSON.parse(t)},t(i.prototype,{find:function(t){var e=this[0]||document;return new i(t="string"==typeof t?e.querySelectorAll?e.querySelectorAll(t):"#"===t.charAt(0)?e.getElementById(t.slice(1)):e.getElementsByTagName(t):t)},hasClass:function(t){return !!this[0]&&new RegExp("(?:^|\\s+)"+t+"(?:\\s+|$)").test(this[0].className)},addClass:function(t){for(var e,i,s,n=this.length;n;)if((i=this[--n]).className)for(e=e||t.split(/\s+/),s=0;s<e.length;s+=1)this.hasClass(e[s])||(i.className+=" "+e[s]);else i.className=t;return this},removeClass:function(t){for(var e,i=new RegExp("^(?:"+t.split(/\s+/).join("|")+")$"),s=/(\S+)(?:\s+|$)/g,n=function(t,e){return i.test(e)?"":t},o=/\s+$/,a=this.length;a;)(e=this[--a]).className=e.className.replace(s,n).replace(o,"");return this},on:function(t,e){for(var i,s,n=t.split(/\s+/);n.length;)for(t=n.shift(),i=this.length;i;)(s=this[--i]).addEventListener?s.addEventListener(t,e,!1):s.attachEvent&&s.attachEvent("on"+t,e);return this},off:function(t,e){for(var i,s,n=t.split(/\s+/);n.length;)for(t=n.shift(),i=this.length;i;)(s=this[--i]).removeEventListener?s.removeEventListener(t,e,!1):s.detachEvent&&s.detachEvent("on"+t,e);return this},empty:function(){for(var t,e=this.length;e;)for(t=this[--e];t.hasChildNodes();)t.removeChild(t.lastChild);return this},first:function(){return new i(this[0])}}),"function"==typeof define&&define.amd?define(function(){return i}):(window.blueimp=window.blueimp||{},window.blueimp.helper=i);}(),function(t){"use strict";"function"==typeof define&&define.amd?define(["./blueimp-helper"],t):(window.blueimp=window.blueimp||{},window.blueimp.Gallery=t(window.blueimp.helper||window.jQuery));}(function(f){"use strict";function i(t,e){return document.body.style.maxHeight===undefined?null:this&&this.options===i.prototype.options?void(t&&t.length?(this.list=t,this.num=t.length,this.initOptions(e),this.initialize()):this.console.log("blueimp Gallery: No or empty list provided as first argument.",t)):new i(t,e)}return f.extend(i.prototype,{options:{container:"#blueimp-gallery",slidesContainer:"div",titleElement:"h3",displayClass:"blueimp-gallery-display",controlsClass:"blueimp-gallery-controls",singleClass:"blueimp-gallery-single",leftEdgeClass:"blueimp-gallery-left",rightEdgeClass:"blueimp-gallery-right",playingClass:"blueimp-gallery-playing",svgasimgClass:"blueimp-gallery-svgasimg",smilClass:"blueimp-gallery-smil",slideClass:"slide",slideActiveClass:"slide-active",slidePrevClass:"slide-prev",slideNextClass:"slide-next",slideLoadingClass:"slide-loading",slideErrorClass:"slide-error",slideContentClass:"slide-content",toggleClass:"toggle",prevClass:"prev",nextClass:"next",closeClass:"close",playPauseClass:"play-pause",typeProperty:"type",titleProperty:"title",altTextProperty:"alt",urlProperty:"href",srcsetProperty:"srcset",sizesProperty:"sizes",sourcesProperty:"sources",displayTransition:!0,clearSlides:!0,toggleControlsOnEnter:!0,toggleControlsOnSlideClick:!0,toggleSlideshowOnSpace:!0,enableKeyboardNavigation:!0,closeOnEscape:!0,closeOnSlideClick:!0,closeOnSwipeUpOrDown:!0,closeOnHashChange:!0,emulateTouchEvents:!0,stopTouchEventsPropagation:!1,hidePageScrollbars:!0,disableScroll:!0,carousel:!1,continuous:!0,unloadElements:!0,startSlideshow:!1,slideshowInterval:5e3,slideshowDirection:"ltr",index:0,preloadRange:2,transitionDuration:300,slideshowTransitionDuration:500,event:undefined,onopen:undefined,onopened:undefined,onslide:undefined,onslideend:undefined,onslidecomplete:undefined,onclose:undefined,onclosed:undefined},carouselOptions:{hidePageScrollbars:!1,toggleControlsOnEnter:!1,toggleSlideshowOnSpace:!1,enableKeyboardNavigation:!1,closeOnEscape:!1,closeOnSlideClick:!1,closeOnSwipeUpOrDown:!1,closeOnHashChange:!1,disableScroll:!1,startSlideshow:!0},console:window.console&&"function"==typeof window.console.log?window.console:{log:function(){}},support:function(s){var t,n={source:!!window.HTMLSourceElement,picture:!!window.HTMLPictureElement,svgasimg:document.implementation.hasFeature("http://www.w3.org/TR/SVG11/feature#Image","1.1"),smil:!!document.createElementNS&&/SVGAnimate/.test(document.createElementNS("http://www.w3.org/2000/svg","animate").toString()),touch:window.ontouchstart!==undefined||window.DocumentTouch&&document instanceof DocumentTouch},e={webkitTransition:{end:"webkitTransitionEnd",prefix:"-webkit-"},MozTransition:{end:"transitionend",prefix:"-moz-"},OTransition:{end:"otransitionend",prefix:"-o-"},transition:{end:"transitionend",prefix:""}};for(t in e)if(Object.prototype.hasOwnProperty.call(e,t)&&s.style[t]!==undefined){n.transition=e[t],n.transition.name=t;break}function i(){var t,e,i=n.transition;document.body.appendChild(s),i&&(t=i.name.slice(0,-9)+"ransform",s.style[t]!==undefined&&(s.style[t]="translateZ(0)",e=window.getComputedStyle(s).getPropertyValue(i.prefix+"transform"),n.transform={prefix:i.prefix,name:t,translate:!0,translateZ:!!e&&"none"!==e})),document.body.removeChild(s);}return document.body?i():f(document).on("DOMContentLoaded",i),n}(document.createElement("div")),requestAnimationFrame:window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame,cancelAnimationFrame:window.cancelAnimationFrame||window.webkitCancelRequestAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame,initialize:function(){if(this.initStartIndex(),!1===this.initWidget())return !1;this.initEventListeners(),this.onslide(this.index),this.ontransitionend(),this.options.startSlideshow&&this.play();},slide:function(t,e){window.clearTimeout(this.timeout);var i,s,n,o=this.index;if(o!==t&&1!==this.num){if(e=e||this.options.transitionDuration,this.support.transform){for(this.options.continuous||(t=this.circle(t)),i=Math.abs(o-t)/(o-t),this.options.continuous&&(s=i,(i=-this.positions[this.circle(t)]/this.slideWidth)!==s&&(t=-i*this.num+t)),n=Math.abs(o-t)-1;n;)this.move(this.circle((o<t?t:o)- --n-1),this.slideWidth*i,0);t=this.circle(t),this.move(o,this.slideWidth*i,e),this.move(t,0,e),this.options.continuous&&this.move(this.circle(t-i),-this.slideWidth*i,0);}else t=this.circle(t),this.animate(o*-this.slideWidth,t*-this.slideWidth,e);this.onslide(t);}},getIndex:function(){return this.index},getNumber:function(){return this.num},prev:function(){(this.options.continuous||this.index)&&this.slide(this.index-1);},next:function(){(this.options.continuous||this.index<this.num-1)&&this.slide(this.index+1);},play:function(t){var i=this,e=this.index+("rtl"===this.options.slideshowDirection?-1:1);window.clearTimeout(this.timeout),this.interval=t||this.options.slideshowInterval,1<this.elements[this.index]&&(this.timeout=this.setTimeout(!this.requestAnimationFrame&&this.slide||function(t,e){i.animationFrameId=i.requestAnimationFrame.call(window,function(){i.slide(t,e);});},[e,this.options.slideshowTransitionDuration],this.interval)),this.container.addClass(this.options.playingClass),this.slidesContainer[0].setAttribute("aria-live","off"),this.playPauseElement.length&&this.playPauseElement[0].setAttribute("aria-pressed","true");},pause:function(){window.clearTimeout(this.timeout),this.interval=null,this.cancelAnimationFrame&&(this.cancelAnimationFrame.call(window,this.animationFrameId),this.animationFrameId=null),this.container.removeClass(this.options.playingClass),this.slidesContainer[0].setAttribute("aria-live","polite"),this.playPauseElement.length&&this.playPauseElement[0].setAttribute("aria-pressed","false");},add:function(t){var e;for(t.concat||(t=Array.prototype.slice.call(t)),this.list.concat||(this.list=Array.prototype.slice.call(this.list)),this.list=this.list.concat(t),this.num=this.list.length,2<this.num&&null===this.options.continuous&&(this.options.continuous=!0,this.container.removeClass(this.options.leftEdgeClass)),this.container.removeClass(this.options.rightEdgeClass).removeClass(this.options.singleClass),e=this.num-t.length;e<this.num;e+=1)this.addSlide(e),this.positionSlide(e);this.positions.length=this.num,this.initSlides(!0);},resetSlides:function(){this.slidesContainer.empty(),this.unloadAllSlides(),this.slides=[];},handleClose:function(){var t=this.options;this.destroyEventListeners(),this.pause(),this.container[0].style.display="none",this.container.removeClass(t.displayClass).removeClass(t.singleClass).removeClass(t.leftEdgeClass).removeClass(t.rightEdgeClass),t.hidePageScrollbars&&(document.body.style.overflow=this.bodyOverflowStyle),this.options.clearSlides&&this.resetSlides(),this.options.onclosed&&this.options.onclosed.call(this);},close:function(){var e=this;this.options.onclose&&this.options.onclose.call(this),this.support.transition&&this.options.displayTransition?(this.container.on(this.support.transition.end,function i(t){t.target===e.container[0]&&(e.container.off(e.support.transition.end,i),e.handleClose());}),this.container.removeClass(this.options.displayClass)):this.handleClose();},circle:function(t){return (this.num+t%this.num)%this.num},move:function(t,e,i){this.translateX(t,e,i),this.positions[t]=e;},translate:function(t,e,i,s){var n,o;this.slides[t]&&(n=this.slides[t].style,o=this.support.transition,t=this.support.transform,n[o.name+"Duration"]=s+"ms",n[t.name]="translate("+e+"px, "+i+"px)"+(t.translateZ?" translateZ(0)":""));},translateX:function(t,e,i){this.translate(t,e,0,i);},translateY:function(t,e,i){this.translate(t,0,e,i);},animate:function(e,i,s){var n,o,a;s?(n=this,o=(new Date).getTime(),a=window.setInterval(function(){var t=(new Date).getTime()-o;if(s<t)return n.slidesContainer[0].style.left=i+"px",n.ontransitionend(),void window.clearInterval(a);n.slidesContainer[0].style.left=(i-e)*(Math.floor(t/s*100)/100)+e+"px";},4)):this.slidesContainer[0].style.left=i+"px";},preventDefault:function(t){t.preventDefault?t.preventDefault():t.returnValue=!1;},stopPropagation:function(t){t.stopPropagation?t.stopPropagation():t.cancelBubble=!0;},onresize:function(){this.initSlides(!0);},onhashchange:function(){this.options.closeOnHashChange&&this.close();},onmousedown:function(t){t.which&&1===t.which&&"VIDEO"!==t.target.nodeName&&"AUDIO"!==t.target.nodeName&&(t.preventDefault(),(t.originalEvent||t).touches=[{pageX:t.pageX,pageY:t.pageY}],this.ontouchstart(t));},onmousemove:function(t){this.touchStart&&((t.originalEvent||t).touches=[{pageX:t.pageX,pageY:t.pageY}],this.ontouchmove(t));},onmouseup:function(t){this.touchStart&&(this.ontouchend(t),delete this.touchStart);},onmouseout:function(t){var e,i;this.touchStart&&(e=t.target,(i=t.relatedTarget)&&(i===e||f.contains(e,i))||this.onmouseup(t));},ontouchstart:function(t){this.options.stopTouchEventsPropagation&&this.stopPropagation(t);t=(t.originalEvent||t).touches[0];this.touchStart={x:t.pageX,y:t.pageY,time:Date.now()},this.isScrolling=undefined,this.touchDelta={};},ontouchmove:function(t){this.options.stopTouchEventsPropagation&&this.stopPropagation(t);var e,i,s=(t.originalEvent||t).touches,n=s[0],o=(t.originalEvent||t).scale,a=this.index;if(!(1<s.length||o&&1!==o))if(this.options.disableScroll&&t.preventDefault(),this.touchDelta={x:n.pageX-this.touchStart.x,y:n.pageY-this.touchStart.y},e=this.touchDelta.x,this.isScrolling===undefined&&(this.isScrolling=this.isScrolling||Math.abs(e)<Math.abs(this.touchDelta.y)),this.isScrolling)this.options.carousel||this.translateY(a,this.touchDelta.y+this.positions[a],0);else for(t.preventDefault(),window.clearTimeout(this.timeout),this.options.continuous?i=[this.circle(a+1),a,this.circle(a-1)]:(this.touchDelta.x=e/=!a&&0<e||a===this.num-1&&e<0?Math.abs(e)/this.slideWidth+1:1,i=[a],a&&i.push(a-1),a<this.num-1&&i.unshift(a+1));i.length;)a=i.pop(),this.translateX(a,e+this.positions[a],0);},ontouchend:function(t){this.options.stopTouchEventsPropagation&&this.stopPropagation(t);var e=this.index,i=Math.abs(this.touchDelta.x),s=this.slideWidth,n=Math.ceil(this.options.transitionDuration*(1-i/s)/2),o=20<i,a=!e&&0<this.touchDelta.x||e===this.num-1&&this.touchDelta.x<0,l=!o&&this.options.closeOnSwipeUpOrDown&&20<Math.abs(this.touchDelta.y);this.options.continuous&&(a=!1),t=this.touchDelta.x<0?-1:1,this.isScrolling?l?this.close():this.translateY(e,0,n):o&&!a?(i=e+t,l=e-t,o=s*t,a=-s*t,this.options.continuous?(this.move(this.circle(i),o,0),this.move(this.circle(e-2*t),a,0)):0<=i&&i<this.num&&this.move(i,o,0),this.move(e,this.positions[e]+o,n),this.move(this.circle(l),this.positions[this.circle(l)]+o,n),e=this.circle(l),this.onslide(e)):this.options.continuous?(this.move(this.circle(e-1),-s,n),this.move(e,0,n),this.move(this.circle(e+1),s,n)):(e&&this.move(e-1,-s,n),this.move(e,0,n),e<this.num-1&&this.move(e+1,s,n));},ontouchcancel:function(t){this.touchStart&&(this.ontouchend(t),delete this.touchStart);},ontransitionend:function(t){var e=this.slides[this.index];t&&e!==t.target||(this.interval&&this.play(),this.setTimeout(this.options.onslideend,[this.index,e]));},oncomplete:function(t){var e,i=t.target||t.srcElement,s=i&&i.parentNode;i&&s&&(e=this.getNodeIndex(s),f(s).removeClass(this.options.slideLoadingClass),"error"===t.type?(f(s).addClass(this.options.slideErrorClass),this.elements[e]=3):this.elements[e]=2,i.clientHeight>this.container[0].clientHeight&&(i.style.maxHeight=this.container[0].clientHeight),this.interval&&this.slides[this.index]===s&&this.play(),this.setTimeout(this.options.onslidecomplete,[e,s]));},onload:function(t){this.oncomplete(t);},onerror:function(t){this.oncomplete(t);},onkeydown:function(t){switch(t.which||t.keyCode){case 13:this.options.toggleControlsOnEnter&&(this.preventDefault(t),this.toggleControls());break;case 27:this.options.closeOnEscape&&(this.close(),t.stopImmediatePropagation());break;case 32:this.options.toggleSlideshowOnSpace&&(this.preventDefault(t),this.toggleSlideshow());break;case 37:this.options.enableKeyboardNavigation&&(this.preventDefault(t),this.prev());break;case 39:this.options.enableKeyboardNavigation&&(this.preventDefault(t),this.next());}},handleClick:function(t){var e=this.options,i=t.target||t.srcElement,s=i.parentNode;function n(t){return f(i).hasClass(t)||f(s).hasClass(t)}n(e.toggleClass)?(this.preventDefault(t),this.toggleControls()):n(e.prevClass)?(this.preventDefault(t),this.prev()):n(e.nextClass)?(this.preventDefault(t),this.next()):n(e.closeClass)?(this.preventDefault(t),this.close()):n(e.playPauseClass)?(this.preventDefault(t),this.toggleSlideshow()):s===this.slidesContainer[0]?e.closeOnSlideClick?(this.preventDefault(t),this.close()):e.toggleControlsOnSlideClick&&(this.preventDefault(t),this.toggleControls()):s.parentNode&&s.parentNode===this.slidesContainer[0]&&e.toggleControlsOnSlideClick&&(this.preventDefault(t),this.toggleControls());},onclick:function(t){if(!(this.options.emulateTouchEvents&&this.touchDelta&&(20<Math.abs(this.touchDelta.x)||20<Math.abs(this.touchDelta.y))))return this.handleClick(t);delete this.touchDelta;},updateEdgeClasses:function(t){t?this.container.removeClass(this.options.leftEdgeClass):this.container.addClass(this.options.leftEdgeClass),t===this.num-1?this.container.addClass(this.options.rightEdgeClass):this.container.removeClass(this.options.rightEdgeClass);},updateActiveSlide:function(t,e){for(var i,s,n=this.slides,o=this.options,a=[{index:e,method:"addClass",hidden:!1},{index:t,method:"removeClass",hidden:!0}];a.length;)i=a.pop(),f(n[i.index])[i.method](o.slideActiveClass),s=this.circle(i.index-1),(o.continuous||s<i.index)&&f(n[s])[i.method](o.slidePrevClass),s=this.circle(i.index+1),(o.continuous||s>i.index)&&f(n[s])[i.method](o.slideNextClass);this.slides[t].setAttribute("aria-hidden","true"),this.slides[e].removeAttribute("aria-hidden");},handleSlide:function(t,e){this.options.continuous||this.updateEdgeClasses(e),this.updateActiveSlide(t,e),this.loadElements(e),this.options.unloadElements&&this.unloadElements(t,e),this.setTitle(e);},onslide:function(t){this.handleSlide(this.index,t),this.index=t,this.setTimeout(this.options.onslide,[t,this.slides[t]]);},setTitle:function(t){var e=this.slides[t].firstChild,t=e.title||e.alt,e=this.titleElement;e.length&&(this.titleElement.empty(),t&&e[0].appendChild(document.createTextNode(t)));},setTimeout:function(t,e,i){var s=this;return t&&window.setTimeout(function(){t.apply(s,e||[]);},i||0)},imageFactory:function(t,e){var i,s,n,o,a,l,r,h,d=this.options,c=this,u=t,p=this.imagePrototype.cloneNode(!1);if("string"!=typeof u&&(u=this.getItemProperty(t,d.urlProperty),n=this.support.picture&&this.support.source&&this.getItemProperty(t,d.sourcesProperty),o=this.getItemProperty(t,d.srcsetProperty),a=this.getItemProperty(t,d.sizesProperty),l=this.getItemProperty(t,d.titleProperty),r=this.getItemProperty(t,d.altTextProperty)||l),p.draggable=!1,l&&(p.title=l),r&&(p.alt=r),f(p).on("load error",function m(t){if(!s){if(!(t={type:t.type,target:i||p}).target.parentNode)return c.setTimeout(m,[t]);s=!0,f(p).off("load error",m),e(t);}}),n&&n.length){for(i=this.picturePrototype.cloneNode(!1),h=0;h<n.length;h+=1)i.appendChild(f.extend(this.sourcePrototype.cloneNode(!1),n[h]));i.appendChild(p),f(i).addClass(d.toggleClass);}return o&&(a&&(p.sizes=a),p.srcset=o),p.src=u,i||p},createElement:function(t,e){var i=t&&this.getItemProperty(t,this.options.typeProperty),i=i&&this[i.split("/")[0]+"Factory"]||this.imageFactory,i=t&&i.call(this,t,e);return i||(i=this.elementPrototype.cloneNode(!1),this.setTimeout(e,[{type:"error",target:i}])),f(i).addClass(this.options.slideContentClass),i},iteratePreloadRange:function(t,e){for(var i=this.num,s=this.options,n=Math.min(i,2*s.preloadRange+1),o=t,a=0;a<n;a+=1){if((o+=a*(a%2==0?-1:1))<0||i<=o){if(!s.continuous)continue;o=this.circle(o);}e.call(this,o);}},loadElement:function(t){this.elements[t]||(this.slides[t].firstChild?this.elements[t]=f(this.slides[t]).hasClass(this.options.slideErrorClass)?3:2:(this.elements[t]=1,f(this.slides[t]).addClass(this.options.slideLoadingClass),this.slides[t].appendChild(this.createElement(this.list[t],this.proxyListener))));},loadElements:function(t){this.iteratePreloadRange(t,this.loadElement);},unloadElements:function(t,i){var s=this.options.preloadRange;this.iteratePreloadRange(t,function(t){var e=Math.abs(t-i);s<e&&e+s<this.num&&(this.unloadSlide(t),delete this.elements[t]);});},addSlide:function(t){var e=this.slidePrototype.cloneNode(!1);e.setAttribute("data-index",t),e.setAttribute("aria-hidden","true"),this.slidesContainer[0].appendChild(e),this.slides.push(e);},positionSlide:function(t){var e=this.slides[t];e.style.width=this.slideWidth+"px",this.support.transform&&(e.style.left=t*-this.slideWidth+"px",this.move(t,this.index>t?-this.slideWidth:this.index<t?this.slideWidth:0,0));},initSlides:function(t){var e,i;for(t||(this.positions=[],this.positions.length=this.num,this.elements={},this.picturePrototype=this.support.picture&&document.createElement("picture"),this.sourcePrototype=this.support.source&&document.createElement("source"),this.imagePrototype=document.createElement("img"),this.elementPrototype=document.createElement("div"),this.slidePrototype=this.elementPrototype.cloneNode(!1),f(this.slidePrototype).addClass(this.options.slideClass),this.slides=this.slidesContainer[0].children,e=this.options.clearSlides||this.slides.length!==this.num),this.slideWidth=this.container[0].clientWidth,this.slideHeight=this.container[0].clientHeight,this.slidesContainer[0].style.width=this.num*this.slideWidth+"px",e&&this.resetSlides(),i=0;i<this.num;i+=1)e&&this.addSlide(i),this.positionSlide(i);this.options.continuous&&this.support.transform&&(this.move(this.circle(this.index-1),-this.slideWidth,0),this.move(this.circle(this.index+1),this.slideWidth,0)),this.support.transform||(this.slidesContainer[0].style.left=this.index*-this.slideWidth+"px");},unloadSlide:function(t){var e=this.slides[t],t=e.firstChild;null!==t&&e.removeChild(t);},unloadAllSlides:function(){for(var t=0,e=this.slides.length;t<e;t++)this.unloadSlide(t);},toggleControls:function(){var t=this.options.controlsClass;this.container.hasClass(t)?this.container.removeClass(t):this.container.addClass(t);},toggleSlideshow:function(){this.interval?this.pause():this.play();},getNodeIndex:function(t){return parseInt(t.getAttribute("data-index"),10)},getNestedProperty:function(o,t){return t.replace(/\[(?:'([^']+)'|"([^"]+)"|(\d+))\]|(?:(?:^|\.)([^\.\[]+))/g,function(t,e,i,s,n){s=n||e||i||s&&parseInt(s,10);t&&o&&(o=o[s]);}),o},getDataProperty:function(t,e){var i;if(t.dataset?(i=e.replace(/-([a-z])/g,function(t,e){return e.toUpperCase()}),i=t.dataset[i]):t.getAttribute&&(i=t.getAttribute("data-"+e.replace(/([A-Z])/g,"-$1").toLowerCase())),"string"==typeof i){if(/^(true|false|null|-?\d+(\.\d+)?|\{[\s\S]*\}|\[[\s\S]*\])$/.test(i))try{return f.parseJSON(i)}catch(s){}return i}},getItemProperty:function(t,e){var i=this.getDataProperty(t,e);return i=(i=i===undefined?t[e]:i)===undefined?this.getNestedProperty(t,e):i},initStartIndex:function(){var t,e=this.options.index,i=this.options.urlProperty;if(e&&"number"!=typeof e)for(t=0;t<this.num;t+=1)if(this.list[t]===e||this.getItemProperty(this.list[t],i)===this.getItemProperty(e,i)){e=t;break}this.index=this.circle(parseInt(e,10)||0);},initEventListeners:function(){var i=this,t=this.slidesContainer;function e(t){var e=i.support.transition&&i.support.transition.end===t.type?"transitionend":t.type;i["on"+e](t);}f(window).on("resize",e),f(window).on("hashchange",e),f(document.body).on("keydown",e),this.container.on("click",e),this.support.touch?t.on("touchstart touchmove touchend touchcancel",e):this.options.emulateTouchEvents&&this.support.transition&&t.on("mousedown mousemove mouseup mouseout",e),this.support.transition&&t.on(this.support.transition.end,e),this.proxyListener=e;},destroyEventListeners:function(){var t=this.slidesContainer,e=this.proxyListener;f(window).off("resize",e),f(document.body).off("keydown",e),this.container.off("click",e),this.support.touch?t.off("touchstart touchmove touchend touchcancel",e):this.options.emulateTouchEvents&&this.support.transition&&t.off("mousedown mousemove mouseup mouseout",e),this.support.transition&&t.off(this.support.transition.end,e);},handleOpen:function(){this.options.onopened&&this.options.onopened.call(this);},initWidget:function(){var e=this;return this.container=f(this.options.container),this.container.length?(this.slidesContainer=this.container.find(this.options.slidesContainer).first(),this.slidesContainer.length?(this.titleElement=this.container.find(this.options.titleElement).first(),this.playPauseElement=this.container.find("."+this.options.playPauseClass).first(),1===this.num&&this.container.addClass(this.options.singleClass),this.support.svgasimg&&this.container.addClass(this.options.svgasimgClass),this.support.smil&&this.container.addClass(this.options.smilClass),this.options.onopen&&this.options.onopen.call(this),this.support.transition&&this.options.displayTransition?this.container.on(this.support.transition.end,function i(t){t.target===e.container[0]&&(e.container.off(e.support.transition.end,i),e.handleOpen());}):this.handleOpen(),this.options.hidePageScrollbars&&(this.bodyOverflowStyle=document.body.style.overflow,document.body.style.overflow="hidden"),this.container[0].style.display="block",this.initSlides(),void this.container.addClass(this.options.displayClass)):(this.console.log("blueimp Gallery: Slides container not found.",this.options.slidesContainer),!1)):(this.console.log("blueimp Gallery: Widget container not found.",this.options.container),!1)},initOptions:function(t){this.options=f.extend({},this.options),(t&&t.carousel||this.options.carousel&&(!t||!1!==t.carousel))&&f.extend(this.options,this.carouselOptions),f.extend(this.options,t),this.num<3&&(this.options.continuous=!!this.options.continuous&&null),this.support.transition||(this.options.emulateTouchEvents=!1),this.options.event&&this.preventDefault(this.options.event);}}),i}),function(t){"use strict";"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery"],t):t(window.blueimp.helper||window.jQuery,window.blueimp.Gallery);}(function(t,e){"use strict";var i=e.prototype;t.extend(i.options,{fullscreen:!1});var s=i.initialize,n=i.close;return t.extend(i,{getFullScreenElement:function(){return document.fullscreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.msFullscreenElement},requestFullScreen:function(t){t.requestFullscreen?t.requestFullscreen():t.webkitRequestFullscreen?t.webkitRequestFullscreen():t.mozRequestFullScreen?t.mozRequestFullScreen():t.msRequestFullscreen&&t.msRequestFullscreen();},exitFullScreen:function(){document.exitFullscreen?document.exitFullscreen():document.webkitCancelFullScreen?document.webkitCancelFullScreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.msExitFullscreen&&document.msExitFullscreen();},initialize:function(){s.call(this),this.options.fullscreen&&!this.getFullScreenElement()&&this.requestFullScreen(this.container[0]);},close:function(){this.getFullScreenElement()===this.container[0]&&this.exitFullScreen(),n.call(this);}}),e}),function(t){"use strict";"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery"],t):t(window.blueimp.helper||window.jQuery,window.blueimp.Gallery);}(function(a,t){"use strict";var e=t.prototype;a.extend(e.options,{indicatorContainer:"ol",activeIndicatorClass:"active",thumbnailProperty:"thumbnail",thumbnailIndicators:!0});var i=e.initSlides,s=e.addSlide,n=e.resetSlides,o=e.handleClick,l=e.handleSlide,r=e.handleClose;return a.extend(e,{createIndicator:function(t){var e,i,s=this.indicatorPrototype.cloneNode(!1),n=this.getItemProperty(t,this.options.titleProperty),o=this.options.thumbnailProperty;return this.options.thumbnailIndicators&&(e=(e=o?this.getItemProperty(t,o):e)===undefined&&(i=t.getElementsByTagName&&a(t).find("img")[0])?i.src:e)&&(s.style.backgroundImage='url("'+e+'")'),n&&(s.title=n),s.setAttribute("role","link"),s},addIndicator:function(t){var e;this.indicatorContainer.length&&((e=this.createIndicator(this.list[t])).setAttribute("data-index",t),this.indicatorContainer[0].appendChild(e),this.indicators.push(e));},setActiveIndicator:function(t){this.indicators&&(this.activeIndicator&&this.activeIndicator.removeClass(this.options.activeIndicatorClass),this.activeIndicator=a(this.indicators[t]),this.activeIndicator.addClass(this.options.activeIndicatorClass));},initSlides:function(t){t||(this.indicatorContainer=this.container.find(this.options.indicatorContainer),this.indicatorContainer.length&&(this.indicatorPrototype=document.createElement("li"),this.indicators=this.indicatorContainer[0].children)),i.call(this,t);},addSlide:function(t){s.call(this,t),this.addIndicator(t);},resetSlides:function(){n.call(this),this.indicatorContainer.empty(),this.indicators=[];},handleClick:function(t){var e=t.target||t.srcElement,i=e.parentNode;if(i===this.indicatorContainer[0])this.preventDefault(t),this.slide(this.getNodeIndex(e));else {if(i.parentNode!==this.indicatorContainer[0])return o.call(this,t);this.preventDefault(t),this.slide(this.getNodeIndex(i));}},handleSlide:function(t,e){l.call(this,t,e),this.setActiveIndicator(e);},handleClose:function(){this.activeIndicator&&this.activeIndicator.removeClass(this.options.activeIndicatorClass),r.call(this);}}),t}),function(t){"use strict";"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery"],t):t(window.blueimp.helper||window.jQuery,window.blueimp.Gallery);}(function(C,t){"use strict";var e=t.prototype;C.extend(e.options,{videoContentClass:"video-content",videoLoadingClass:"video-loading",videoPlayingClass:"video-playing",videoIframeClass:"video-iframe",videoCoverClass:"video-cover",videoPlayClass:"video-play",videoPlaysInline:!0,videoPreloadProperty:"preload",videoPosterProperty:"poster"});var i=e.handleSlide;return C.extend(e,{handleSlide:function(t,e){i.call(this,t,e),this.setTimeout(function(){this.activeVideo&&this.activeVideo.pause();});},videoFactory:function(t,e,i){var s,n,o,a=this,l=this.options,r=this.elementPrototype.cloneNode(!1),h=C(r),d=[{type:"error",target:r}],c=i||document.createElement("video"),u=this.elementPrototype.cloneNode(!1),p=document.createElement("a"),m=this.getItemProperty(t,l.urlProperty),f=this.getItemProperty(t,l.sourcesProperty),y=this.getItemProperty(t,l.titleProperty),g=this.getItemProperty(t,l.videoPosterProperty),v=[p];if(h.addClass(l.videoContentClass),C(p).addClass(l.videoPlayClass),C(u).addClass(l.videoCoverClass).hasClass(l.toggleClass)||v.push(u),u.draggable=!1,y&&(r.title=y,p.setAttribute("aria-label",y)),g&&(u.style.backgroundImage='url("'+g+'")'),c.setAttribute?l.videoPlaysInline&&c.setAttribute("playsinline",""):h.addClass(l.videoIframeClass),c.preload=this.getItemProperty(t,l.videoPreloadProperty)||"none",this.support.source&&f)for(o=0;o<f.length;o+=1)c.appendChild(C.extend(this.sourcePrototype.cloneNode(!1),f[o]));return m&&(c.src=m),p.href=m||f&&f.length&&f[0].src,c.play&&c.pause&&((i||C(c)).on("error",function(){a.setTimeout(e,d);}).on("pause",function(){c.seeking||(n=!1,h.removeClass(a.options.videoLoadingClass).removeClass(a.options.videoPlayingClass),s&&a.container.addClass(a.options.controlsClass),c.controls=!1,c===a.activeVideo&&delete a.activeVideo,a.interval&&a.play());}).on("playing",function(){n=!1,u.removeAttribute("style"),h.removeClass(a.options.videoLoadingClass).addClass(a.options.videoPlayingClass);}).on("play",function(){window.clearTimeout(a.timeout),n=!0,h.addClass(a.options.videoLoadingClass),a.container.hasClass(a.options.controlsClass)?(s=!0,a.container.removeClass(a.options.controlsClass)):s=!1,c.controls=!0,a.activeVideo=c;}),C(v).on("click",function(t){a.preventDefault(t),a.activeVideo=c,n?c.pause():c.play();}),r.appendChild(i&&i.element||c)),r.appendChild(u),r.appendChild(p),this.setTimeout(e,[{type:"load",target:r}]),r}}),t}),function(t){"use strict";"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery-video"],t):t(window.blueimp.helper||window.jQuery,window.blueimp.Gallery);}(function(l,t){"use strict";if(!window.postMessage)return t;var e=t.prototype;l.extend(e.options,{vimeoVideoIdProperty:"vimeo",vimeoPlayerUrl:"https://player.vimeo.com/video/VIDEO_ID?api=1&player_id=PLAYER_ID",vimeoPlayerIdPrefix:"vimeo-player-",vimeoClickToPlay:!1});var n=e.textFactory||e.imageFactory,o=function(t,e,i,s){this.url=t,this.videoId=e,this.playerId=i,this.clickToPlay=s,this.element=document.createElement("div"),this.listeners={};},a=0;return l.extend(o.prototype,{on:function(t,e){return this.listeners[t]=e,this},loadAPI:function(){var t,e,i=this,s="https://f.vimeocdn.com/js/froogaloop2.min.js",n=document.getElementsByTagName("script"),o=n.length;function a(){!e&&i.playOnReady&&i.play(),e=!0;}for(;o;)if(n[--o].src===s){t=n[o];break}t||((t=document.createElement("script")).src=s),l(t).on("load",a),n[0].parentNode.insertBefore(t,n[0]),/loaded|complete/.test(t.readyState)&&a();},onReady:function(){var t=this;this.ready=!0,this.player.addEvent("play",function(){t.hasPlayed=!0,t.onPlaying();}),this.player.addEvent("pause",function(){t.onPause();}),this.player.addEvent("finish",function(){t.onPause();}),this.playOnReady&&this.play();},onPlaying:function(){this.playStatus<2&&(this.listeners.playing(),this.playStatus=2);},onPause:function(){this.listeners.pause(),delete this.playStatus;},insertIframe:function(){var t=document.createElement("iframe");t.src=this.url.replace("VIDEO_ID",this.videoId).replace("PLAYER_ID",this.playerId),t.id=this.playerId,t.allow="autoplay",this.element.parentNode.replaceChild(t,this.element),this.element=t;},play:function(){var t=this;this.playStatus||(this.listeners.play(),this.playStatus=1),this.ready?!this.hasPlayed&&(this.clickToPlay||window.navigator&&/iP(hone|od|ad)/.test(window.navigator.platform))?this.onPlaying():this.player.api("play"):(this.playOnReady=!0,window.$f?this.player||(this.insertIframe(),this.player=$f(this.element),this.player.addEvent("ready",function(){t.onReady();})):this.loadAPI());},pause:function(){this.ready?this.player.api("pause"):this.playStatus&&(delete this.playOnReady,this.listeners.pause(),delete this.playStatus);}}),l.extend(e,{VimeoPlayer:o,textFactory:function(t,e){var i=this.options,s=this.getItemProperty(t,i.vimeoVideoIdProperty);return s?(this.getItemProperty(t,i.urlProperty)===undefined&&(t[i.urlProperty]="https://vimeo.com/"+s),a+=1,this.videoFactory(t,e,new o(i.vimeoPlayerUrl,s,i.vimeoPlayerIdPrefix+a,i.vimeoClickToPlay))):n.call(this,t,e)}}),t}),function(t){"use strict";"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery-video"],t):t(window.blueimp.helper||window.jQuery,window.blueimp.Gallery);}(function(t,e){"use strict";if(!window.postMessage)return e;var i=e.prototype;t.extend(i.options,{youTubeVideoIdProperty:"youtube",youTubePlayerVars:{wmode:"transparent"},youTubeClickToPlay:!1});var n=i.textFactory||i.imageFactory,o=function(t,e,i){this.videoId=t,this.playerVars=e,this.clickToPlay=i,this.element=document.createElement("div"),this.listeners={};};return t.extend(o.prototype,{on:function(t,e){return this.listeners[t]=e,this},loadAPI:function(){var t,e=this,i=window.onYouTubeIframeAPIReady,s="https://www.youtube.com/iframe_api",n=document.getElementsByTagName("script"),o=n.length;for(window.onYouTubeIframeAPIReady=function(){i&&i.apply(this),e.playOnReady&&e.play();};o;)if(n[--o].src===s)return;(t=document.createElement("script")).src=s,n[0].parentNode.insertBefore(t,n[0]);},onReady:function(){this.ready=!0,this.playOnReady&&this.play();},onPlaying:function(){this.playStatus<2&&(this.listeners.playing(),this.playStatus=2);},onPause:function(){this.listeners.pause(),delete this.playStatus;},onStateChange:function(t){switch(window.clearTimeout(this.pauseTimeout),t.data){case YT.PlayerState.PLAYING:this.hasPlayed=!0,this.onPlaying();break;case YT.PlayerState.UNSTARTED:case YT.PlayerState.PAUSED:this.pauseTimeout=i.setTimeout.call(this,this.onPause,null,500);break;case YT.PlayerState.ENDED:this.onPause();}},onError:function(t){this.listeners.error(t);},play:function(){var e=this;this.playStatus||(this.listeners.play(),this.playStatus=1),this.ready?!this.hasPlayed&&(this.clickToPlay||window.navigator&&/iP(hone|od|ad)/.test(window.navigator.platform))?this.onPlaying():this.player.playVideo():(this.playOnReady=!0,window.YT&&YT.Player?this.player||(this.player=new YT.Player(this.element,{videoId:this.videoId,playerVars:this.playerVars,events:{onReady:function(){e.onReady();},onStateChange:function(t){e.onStateChange(t);},onError:function(t){e.onError(t);}}})):this.loadAPI());},pause:function(){this.ready?this.player.pauseVideo():this.playStatus&&(delete this.playOnReady,this.listeners.pause(),delete this.playStatus);}}),t.extend(i,{YouTubePlayer:o,textFactory:function(t,e){var i=this.options,s=this.getItemProperty(t,i.youTubeVideoIdProperty);return s?(this.getItemProperty(t,i.urlProperty)===undefined&&(t[i.urlProperty]="https://www.youtube.com/watch?v="+s),this.getItemProperty(t,i.videoPosterProperty)===undefined&&(t[i.videoPosterProperty]="https://img.youtube.com/vi/"+s+"/maxresdefault.jpg"),this.videoFactory(t,e,new o(s,i.youTubePlayerVars,i.youTubeClickToPlay))):n.call(this,t,e)}}),e});

var _templateObject$A, _templateObject2$l;
function ownKeys$u(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$u(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$u(Object(source), true).forEach(function (key) { _defineProperty$17(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$u(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$A(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$17(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Minimum data to qualify as an image and not cause errors
var IMAGE_DEFAULT = {
  title: egw$1.lang('loading'),
  href: '',
  type: 'image/png',
  thumbnail: '',
  loading: true
};

// For filtering to only show things we can handle
var MIME_REGEX = navigator.userAgent.match(/(MSIE|Trident)/) ?
// IE only supports video/mp4 mime type
new RegExp(/(video\/mp4)|(image\/:*(?!tif|x-xcf|pdf))|(audio\/:*)/, 'i') : new RegExp(/(video\/(mp4|ogg|webm))|(image\/:*(?!tif|x-xcf|pdf))|(audio\/:*)/, 'i');
var MIME_AUDIO_REGEX = new RegExp(/(audio\/:*)/, 'i');
// open office document mime type currently supported by webodf editor
var MIME_ODF_REGEX = new RegExp(/application\/vnd\.oasis\.opendocument\.text/);

/**
 * Interface used to determine if widget can expose
 */

/**
 * Data to show a single slide
 */

function ExposeMixin(superclass) {
  return class extends superclass {
    static get styles() {
      return [...super.styles, i$b(_templateObject$A || (_templateObject$A = _taggedTemplateLiteral$A(["\n\t\t\t\t"])))];
    }
    static get properties() {
      return _objectSpread$u(_objectSpread$u({}, super.properties), {}, {
        /**
         * Function to extract an image list
         *
         * "Normally" we'll try to pull a list of images from the nextmatch or show just the current widget,
         * but if you know better you can provide a method to get the list.
         */
        mediaContentFunction: {
          type: Function
        }
      });
    }

    // @ts-ignore

    constructor() {
      super(...arguments);

      // bind handler context to instance
      _defineProperty$17(this, "_gallery", void 0);
      _defineProperty$17(this, "__mediaContentFunction", void 0);
      _defineProperty$17(this, "URL_REGEXP", /url\("([^)]+)"\)/);
      var handlers = ["expose_onclick", "expose_onopen", "expose_onopened", "expose_onslide", "expose_onslideend", "expose_onslidecomplete", "expose_onclose", "expose_onclosed"];
      for (var key of handlers) {
        this[key] = this[key].bind(this);
      }
    }
    connectedCallback() {
      super.connectedCallback();
      if (document.body.querySelector('#blueimp-gallery') == null) {
        this.egw().includeCSS(egw$1.webserverUrl + "/node_modules/blueimp-gallery/css/blueimp-gallery.css");
        this.egw().includeCSS(egw$1.webserverUrl + "/node_modules/blueimp-gallery/css/blueimp-gallery-indicator.css");
        this.egw().includeCSS(egw$1.webserverUrl + "/node_modules/blueimp-gallery/css/blueimp-gallery-video.css");
        // Create Gallery DOM structure
        D$1(this._galleryTemplate(), document.body);
      }
    }
    disconnectedCallback() {
      super.disconnectedCallback();
    }

    /**
     * Get the info needed to determine if this widget's value allows it to participate in expose
     * It needs to have a path, and we use mime to determine if it can expose
     *
     * It's also passed to getMedia() when we're not reading from a nextmatch
     *
     * @returns {ExposeValue}
     */
    get exposeValue() {
      //@ts-ignore value might not exist
      return this.value || null;
    }

    /**
     * Get the info needed to show the given value as slide(s)
     *
     * _value is (usually?) pulled from egw.dataGetUIDdata()
     *
     * Override this
     */
    getMedia(_value) {
      var mediaContent = [];
      if (_value) {
        mediaContent = [{
          title: _value.label,
          href: _value.download_url ? this._processUrl(_value.download_url) : this._processUrl(_value.path),
          type: _value.mime || (_value.type ? _value.type + "/*" : "")
        }];
        if (this.isExposable()) {
          mediaContent[0].thumbnail = _value.thumbnail ? this._processUrl(_value.thumbnail) : mediaContent[0].href;
        } else {
          var fe = egw$1.file_editor_prefered_mimes(_value.mime);
          if (fe && fe.mime[_value.mime] && fe.mime[_value.mime].favIconUrl) {
            mediaContent[0].thumbnail = fe.mime[_value.mime].favIconUrl;
          }
        }
      }
      return mediaContent;
    }
    _processUrl(url) {
      var base_url = egw$1.webserverUrl.match(/^\/ig/) ? egw$1(window).window.location.origin + egw$1.webserverUrl + '/' : egw$1.webserverUrl + '/';
      if (base_url && base_url != '/' && url.indexOf(base_url) != 0) {
        url = base_url + url;
      }
      return url;
    }

    /**
     * Handle changes that have to happen based on changes to properties
     *
     */
    requestUpdate(name, oldValue, options) {
      super.requestUpdate(name, oldValue, options);

      // if there's a value change, (de)bind the gallery
      if (name === "value") {
        this._bindGallery();
      }
    }

    /**
     * Binds a click handler so if the user clicks, we'll initialize & show the gallery
     *
     * @protected
     */
    _bindGallery() {
      // If the media type is not supported do not bind the click handler
      if (!this.isExposable()) {
        this.classList.remove("et2_clickable");
        if (this._gallery) {
          this._gallery.close();
        }
        return;
      }
      if (!this._gallery) {
        this.classList.add("et2_clickable");

        // Normal click handler will handle it
      }
    }

    isExposable() {
      if (!this.exposeValue || typeof this.exposeValue.mime !== "string") {
        return false;
      }
      if (this.exposeValue.mime.match(MIME_REGEX) || this.exposeValue.mime.match(MIME_AUDIO_REGEX)) {
        return true;
      }
      return false;
    }

    /**
     * Just override the normal click handler
     *
     * @param {MouseEvent} _ev
     * @returns {boolean}
     */
    _handleClick(_ev) {
      if ((!this.isExposable() || this.expose_onclick(_ev)) && typeof super._handleClick === "function") {
        return super._handleClick(_ev);
      }
      return false;
    }
    get expose_options() {
      return {
        // The Id, element or querySelector of the gallery widget:
        container: '#blueimp-gallery',
        // The tag name, Id, element or querySelector of the slides container:
        slidesContainer: 'div',
        // The tag name, Id, element or querySelector of the title element:
        titleElement: 'h3',
        // The class to add when the gallery is visible:
        displayClass: 'blueimp-gallery-display',
        // The class to add when the gallery controls are visible:
        controlsClass: 'blueimp-gallery-controls',
        // The class to add when the gallery only displays one element:
        singleClass: 'blueimp-gallery-single',
        // The class to add when the left edge has been reached:
        leftEdgeClass: 'blueimp-gallery-left',
        // The class to add when the right edge has been reached:
        rightEdgeClass: 'blueimp-gallery-right',
        // The class to add when the automatic slideshow is active:
        playingClass: 'blueimp-gallery-playing',
        // The class for all slides:
        slideClass: 'slide',
        // The slide class for loading elements:
        slideLoadingClass: 'loading',
        // The slide class for elements that failed to load:
        slideErrorClass: 'slide-error',
        // The class for the content element loaded into each slide:
        slideContentClass: 'slide-content',
        // The class for the "toggle" control:
        toggleClass: 'toggle',
        // The class for the "prev" control:
        prevClass: 'prev',
        // The class for the "next" control:
        nextClass: 'next',
        // The class for the "close" control:
        closeClass: 'close',
        // The class for the "play-pause" toggle control:
        playPauseClass: 'play-pause',
        // The class to add for fullscreen button option
        fullscreenClass: 'fullscreen',
        // The list object property (or data attribute) with the object type:
        typeProperty: 'type',
        // The list object property (or data attribute) with the object title:
        titleProperty: 'title',
        // The list object property (or data attribute) with the object URL:
        urlProperty: 'href',
        // The gallery listens for transitionend events before triggering the
        // opened and closed events, unless the following option is set to false:
        displayTransition: true,
        // Defines if the gallery slides are cleared from the gallery modal,
        // or reused for the next gallery initialization:
        clearSlides: true,
        // Defines if images should be stretched to fill the available space,
        // while maintaining their aspect ratio (will only be enabled for browsers
        // supporting background-size="contain", which excludes IE < 9).
        // Set to "cover", to make images cover all available space (requires
        // support for background-size="cover", which excludes IE < 9):
        stretchImages: true,
        // Toggle the controls on pressing the Return key:
        toggleControlsOnReturn: true,
        // Toggle the automatic slideshow interval on pressing the Space key:
        toggleSlideshowOnSpace: true,
        // Navigate the gallery by pressing left and right on the keyboard:
        enableKeyboardNavigation: true,
        // Close the gallery on pressing the ESC key:
        closeOnEscape: true,
        // Close the gallery when clicking on an empty slide area:
        closeOnSlideClick: false,
        // Close the gallery by swiping up or down:
        closeOnSwipeUpOrDown: true,
        // Emulate touch events on mouse-pointer devices such as desktop browsers:
        emulateTouchEvents: true,
        // Stop touch events from bubbling up to ancestor elements of the Gallery:
        stopTouchEventsPropagation: false,
        // Hide the page scrollbars:
        hidePageScrollbars: true,
        // Stops any touches on the container from scrolling the page:
        disableScroll: true,
        // Carousel mode (shortcut for carousel specific options):
        carousel: true,
        // Allow continuous navigation, moving from last to first
        // and from first to last slide:
        continuous: false,
        // Remove elements outside of the preload range from the DOM:
        unloadElements: true,
        // Start with the automatic slideshow:
        startSlideshow: false,
        // Delay in milliseconds between slides for the automatic slideshow:
        slideshowInterval: 3000,
        // The starting index as integer.
        // Can also be an object of the given list,
        // or an equal object with the same url property:
        index: 0,
        // The number of elements to load around the current index:
        preloadRange: 2,
        // The transition speed between slide changes in milliseconds:
        transitionSpeed: 400,
        //Hide controls when the slideshow is playing
        hideControlsOnSlideshow: true,
        //Request fullscreen on slide show
        toggleFullscreenOnSlideShow: true,
        // The transition speed for automatic slide changes, set to an integer
        // greater 0 to override the default transition speed:
        slideshowTransitionSpeed: undefined,
        // The tag name, Id, element or querySelector of the indicator container:
        indicatorContainer: 'ol',
        // The class for the active indicator:
        activeIndicatorClass: 'active',
        // The list object property (or data attribute) with the thumbnail URL,
        // used as alternative to a thumbnail child element:
        thumbnailProperty: 'thumbnail',
        // Defines if the gallery indicators should display a thumbnail:
        thumbnailIndicators: true,
        //thumbnail with image tag
        thumbnailWithImgTag: true,
        // Callback function executed when the Gallery is initialized.
        // Is called with the gallery instance as "this" object:
        onopen: this.expose_onopen,
        // Callback function executed when the Gallery has been initialized
        // and the initialization transition has been completed.
        // Is called with the gallery instance as "this" object:
        onopened: this.expose_onopened,
        // Callback function executed on slide change.
        // Is called with the gallery instance as "this" object and the
        // current index and slide as arguments:
        onslide: this.expose_onslide,
        // Callback function executed after the slide change transition.
        // Is called with the gallery instance as "this" object and the
        // current index and slide as arguments:
        onslideend: this.expose_onslideend,
        //// Callback function executed on slide content load.
        // Is called with the gallery instance as "this" object and the
        // slide index and slide element as arguments:
        onslidecomplete: this.expose_onslidecomplete,
        //// Callback function executed when the Gallery is about to be closed.
        // Is called with the gallery instance as "this" object:
        onclose: this.expose_onclose,
        // Callback function executed when the Gallery has been closed
        // and the closing transition has been completed.
        // Is called with the gallery instance as "this" object:
        onclosed: this.expose_onclosed
      };
    }
    _galleryTemplate() {
      return x$1(_templateObject2$l || (_templateObject2$l = _taggedTemplateLiteral$A(["\n                <div id=\"blueimp-gallery\" class=\"blueimp-gallery\">\n                    <div class=\"slides\"></div>\n                    <h3 class=\"title\"></h3>\n                    <a class=\"prev\">\u2039</a>\n                    <a class=\"next\">\u203A</a>\n                    <a title=\"", "\" class=\"close\"></a>\n                    <a title=\"", "\" class=\"play-pause\"></a>\n                    <a title=\"", "\" class=\"fullscreen\"></a>\n                    <a title=\"", "\" class=\"download\"></a>\n                    <ol class=\"indicator\"></ol>\n                </div>\n\t\t\t"])), egw$1().lang('Close'), egw$1().lang('Play/Pause'), egw$1().lang('Fullscreen'), egw$1().lang('Save'));
    }

    /**
     * See if the current widget is in a nextmatch, as this allows us to display
     * thumbnails underneath
     *
     * @param {et2_IExposable} widget
     * @returns {et2_nextmatch | null}
     */
    find_nextmatch(widget) {
      var current = widget;
      var nextmatch = null;
      while (nextmatch == null && current) {
        current = current.getParent();
        if (current && typeof current != 'undefined' && current.instanceOf(et2_nextmatch)) {
          nextmatch = current;
        }
      }
      // No nextmatch, or nextmatch not quite ready
      // At the moment only filemanger nm would work
      // as gallery, thus we disable other nestmatches
      // to build up gallery but filemanager
      if (nextmatch == null || nextmatch.controller == null || !nextmatch.dom_id.match(/filemanager/, 'ig')) {
        return null;
      }
      return nextmatch;
    }
    _init_blueimp_gallery(event, _value) {
      // Image list
      var mediaContent = [];

      // We'll customise default options
      var options = this.expose_options;
      var nm = this.find_nextmatch(this);
      if (typeof this.__mediaContentFunction == "function") {
        this.__mediaContentFunction(this);
      } else if (nm && !this._is_target_indepth(nm, event.target)) {
        // Get the row that was clicked, find its index in the list
        var current_entry = nm.controller.getRowByNode(event.target);

        // But before it goes, we'll pull everything we can
        this.read_from_nextmatch(nm, mediaContent);
        // find current_entry in array and set it's array-index
        for (var i = 0; i < mediaContent.length; i++) {
          if ('filemanager::' + mediaContent[i].path == current_entry.uid) {
            options.index = i;
            break;
          }
        }

        // This will trigger nm to refresh and get just the ones we can handle
        // but it might take a while, so do it later - make sure our current
        // one is loaded first.
        window.setTimeout(function () {
          nm.applyFilters({
            col_filter: {
              mime: '/' + MIME_REGEX.source + '/'
            }
          });
        }, 1);
      } else {
        // Try for all exposable of the same type in the parent widget
        try {
          var others = (this.getParent().closest("[exposable]") || this.getParent().getDOMNode()).querySelectorAll(this.localName);
          others.forEach((exposable, index) => {
            if (exposable === this) {
              options.index = mediaContent.length;
            }
            if (exposable.isExposable()) {
              mediaContent.push(...exposable.getMedia(Object.assign({}, IMAGE_DEFAULT, exposable.exposeValue)));
            }
          });
          if (!others || others.length == 0) {
            mediaContent = this.getMedia(_value);
          }
        } catch (e) {
          // Well, that didn't work.  Just the one then.
          // @ts-ignore
          mediaContent = this.getMedia(_value);
        }
        // Do not show thumbnail indicator on single expose view
        options.thumbnailIndicators = mediaContent.length > 1;
        if (!options.thumbnailIndicators) {
          options.indicatorContainer = 'nope';
        }
      }

      // @ts-ignore
      this._gallery = new blueimp.Gallery(mediaContent, options);
    }

    /**
     * Read images out of the data for the nextmatch
     *
     * @param {et2_nextmatch} nm
     * @param {Object[]} images
     * @param {number} start_at
     * @returns {undefined}
     */
    read_from_nextmatch(nm, images, start_at) {
      if (!start_at) {
        start_at = 0;
      }
      var image_index = start_at;
      var stop = Math.max.apply(null, Object.keys(nm.controller._indexMap));
      for (var i = start_at; i <= stop; i++) {
        var _data$data;
        if (!nm.controller._indexMap[i] || !nm.controller._indexMap[i].uid) {
          // Returning instead of using IMAGE_DEFAULT means we stop as
          // soon as a hole is found, instead of getting everything that is
          // available.  The gallery can't fill in the holes.
          images[image_index++] = IMAGE_DEFAULT;
          continue;
        }
        var uid = nm.controller._indexMap[i].uid;
        if (!uid) {
          continue;
        }
        var data = egw$1.dataGetUIDdata(uid);
        if (typeof (data === null || data === void 0 || (_data$data = data.data) === null || _data$data === void 0 ? void 0 : _data$data.mime) === "string" && MIME_REGEX.test(data.data.mime)) {
          var media = this.getMedia(data.data);
          images[image_index++] = Object.assign({}, data.data, media[0]);
        }
      }
    }

    /**
     * Set a particular index/image in the gallery instead of just appending
     * it to the end
     *
     * @param {integer} index
     * @param {Object} image
     * @returns {undefined}
     */
    set_slide(index, image) {
      var active = index == this._gallery.index;

      // Pad with blanks until length is right
      while (index > this._gallery.getNumber()) {
        this._gallery.add([Object.assign({}, IMAGE_DEFAULT)]);
      }

      // Don't bother with adding a default, we just did that
      if (image.loading) {
        //Add load class if it's really a slide with error
        if (this._gallery.slidesContainer.find('[data-index="' + index + '"]').hasClass(this._gallery.options.slideErrorClass)) {
          this._gallery.slides[index].classList.add(this._gallery.options.slideLoadingClass);
          this._gallery.slides[index].classList.remove(this._gallery.options.slideErrorClass);
        }
        return;
      }
      // Remove the loading class if the slide is loaded
      else if (this._gallery.slides[index]) {
        this._gallery.slides[index].classList.remove(this._gallery.options.slideLoadingClass);
      }

      // Just use add to let gallery create everything it needs
      var new_index = this._gallery.num;
      this._gallery.add([image]);

      // Move it to where we want it.
      // Gallery uses arrays and indexes and has several internal variables
      // that need to be updated.
      //
      // list
      this._gallery.list[index] = this._gallery.list[new_index];
      this._gallery.list.splice(new_index, 1);

      // indicators & slides
      var dom_nodes = ['indicators', 'slides'];
      for (var i in dom_nodes) {
        var var_name = dom_nodes[i];
        // Remove old one from DOM
        this._gallery[var_name][index].remove();
        // Move new one into it's place in gallery
        this._gallery[var_name][index] = this._gallery[var_name][new_index];
        // Move into place in DOM
        var node = this._gallery[var_name][index];
        node.setAttribute('data-index', index);
        if (this._gallery.slides[index + 1]) {
          this._gallery.slidesContainer[0].insertBefore(this._gallery.slides[index + 1], undefined);
        }
        if (active) {
          node.classList.add(this._gallery.options.activeIndicatorClass);
        }
        this._gallery[var_name].splice(new_index, 1);
      }
      if (active) {
        this._gallery.activeIndicator = this._gallery.indicators[index];
      }

      // positions
      this._gallery.positions[index] = active ? 0 : index > this._gallery.index ? this._gallery.slideWidth : -this._gallery.slideWidth;
      this._gallery.positions.splice(new_index, 1);

      // elements - removing will allow to re-do the slide
      if (this._gallery.elements[index]) {
        delete this._gallery.elements[index];
        this._gallery.loadElement(index);
      }

      // Remove the one we just added
      this._gallery.num -= 1;
    }
    /**
     * audio player expose
     * @param _value
     * @private
     */
    _audio_player(_value) {
      var button = [{
        "button_id": 1,
        "label": egw$1.lang('close'),
        id: '1',
        image: 'cancel',
        default: true
      }];
      var mediaContent = this.getMedia(_value)[0];
      var dialog = new Et2Dialog$1();
      dialog.transformAttributes({
        callback: function callback(_btn, value) {
          if (_btn == Et2Dialog$1.OK_BUTTON) {}
        },
        beforeClose: function beforeClose() {},
        title: mediaContent.title,
        buttons: button,
        minWidth: 350,
        minHeight: 200,
        isModal: false,
        position: "right bottom,right-50 bottom-10",
        value: {
          content: {
            src: mediaContent.download_href || mediaContent.href
          }
        },
        resizable: false,
        template: egw$1.webserverUrl + '/api/templates/default/audio_player.xet',
        dialogClass: "audio_player"
      });
      // @ts-ignore
      document.body.appendChild(dialog);
    }

    /**
     * Check if clicked target from nm is in depth
     *
     *  @param nm nextmatch widget
     *  @param target selected target dom node
     *
     *  @return {boolean} returns false if target is not in depth otherwise True
     */
    _is_target_indepth(nm, target) {
      var res = false;
      if (nm) {
        if (!target) {
          // @ts-ignore
          var _target = this.getDOMNode();
        }
        var entry = nm.controller.getRowByNode(target);
        if (entry && entry.controller.getDepth() > 0) {
          res = true;
        }
      }
      return res;
    }
    expose_onclick(event) {
      // Do not trigger expose view if one of the operator keys are held
      if (event.altKey || event.ctrlKey || event.shiftKey || event.metaKey) {
        return;
      }
      event.stopImmediatePropagation();
      if (this.exposeValue.mime.match(MIME_REGEX) && !this.exposeValue.mime.match(MIME_AUDIO_REGEX)) {
        this._init_blueimp_gallery(event, this.exposeValue);
        return false;
      } else if (this.exposeValue.mime.match(MIME_AUDIO_REGEX)) {
        this._audio_player(this.exposeValue);
        return false;
      }
      return true;
    }
    expose_onopen() {}
    expose_onopened() {
      // Check to see if we're in a nextmatch, do magic
      var nm = this.find_nextmatch(this);
      var self = this;
      if (nm) {
        // Add scrolling to the indicator list
        var total_count = nm.controller._grid.getTotalCount();
        if (total_count >= this._gallery.num) {
          var $indicator = this._gallery.container.find('.indicator');
          $indicator.addClass('paginating');
          /*
          	.swipe(function(event, direction, distance)
          	{
          		// @ts-ignore
          		if(direction == jQuery.fn.swipe.directions.LEFT)
          		{
          			distance *= -1;
          		}
          		// @ts-ignore
          		else if(direction == jQuery.fn.swipe.directions.RIGHT)
          		{
          			// OK.
          		}
          		else
          		{
          			return;
          		}
          		jQuery(this).css('left', Math.min(0, parseInt(jQuery(this).css('left')) - (distance * 30)) + 'px');
          	});
          	 */

          // Bind the mousewheel handler
          $indicator[0].addEventListener('wheel', function (event, _delta) {
            var delta = _delta || event.deltaY / 120;
            var g_width = parseInt(getComputedStyle(this._gallery.container[0]).width);
            var width = parseInt(getComputedStyle(this._gallery.indicatorContainer[0]).width);
            var left = parseInt(getComputedStyle(this._gallery.indicatorContainer[0]).left);
            if (delta > 0 && left > g_width / 2) {
              return;
            }

            //Reload next pictures into the gallery by scrolling on thumbnails
            if (delta < 0 && width + left < g_width) {
              var nextIndex = this._gallery.indicatorContainer.find('[title="loading"]')[0];
              if (nextIndex) {
                self.expose_onslideend(this._gallery, nextIndex.dataset.index - 1);
              }
              return;
            }
            // Move it about 5 indicators
            var i_width = parseInt(getComputedStyle(this._gallery.activeIndicator[0]).width);
            jQuery($indicator[0]).css('left', left - -delta * i_width * 5 + 'px');
            event.preventDefault();
          }.bind(this));
        }
      }
    }
    expose_onslide(index, slide) {
      //todo
      //if (typeof this._super == 'undefined') return;
      // First let parent try
      var nm = this.find_nextmatch(this);
      if (nm) {
        // See if we need to move the indicator
        var indicator = this._gallery.container.find('.indicator');
        var current = jQuery('.active', indicator).position();
        if (current) {
          var width = parseInt(window.getComputedStyle(this._gallery.container[0]).width);
          //	indicator.animate({left: (width / 2) - current.left}, 10);
        }
      }
    }

    expose_onslideend(index, slide) {
      // Check to see if we're in a nextmatch, do magic
      var nm = this.find_nextmatch(this);
      if (nm && !nm.update_in_progress) {
        // Check to see if we're near the end, or maybe some pagination
        // would be good.
        var total_count = nm.controller._grid.getTotalCount();

        // Already at the end, don't bother
        if (index == total_count - 1 || index == 0) {
          return;
        }

        // Try to determine direction from state of next & previous slides
        var direction = 1;
        for (var i in this._gallery.elements) {
          // Loading or error
          if (this._gallery.elements[i] == 1 || this._gallery.elements[i] == 3 || this._gallery.list[i].loading) {
            direction = i >= index ? 1 : -1;
            break;
          }
        }
        if (!this._gallery.list[index + direction] || this._gallery.list[index + direction].loading || total_count > this._gallery.getNumber() && index + ET2_DATAVIEW_STEPSIZE > this._gallery.getNumber()) {
          // This will get the next batch of rows
          var start = Math.max(0, direction > 0 ? index : index - ET2_DATAVIEW_STEPSIZE);
          var end = Math.min(total_count - 1, start + ET2_DATAVIEW_STEPSIZE);
          nm.controller._gridCallback(start, end);
          var images = [];
          this.read_from_nextmatch(nm, images, start);

          // Gallery always adds to the end, causing problems with pagination
          for (var _i in images) {
            this.set_slide(parseInt(_i), images[_i]);
          }
        }
      }
    }
    expose_onslidecomplete() {
      var indicators = this._gallery.container.find('ol.indicator')[0].querySelectorAll('li');
      indicators.forEach(indicator => {
        if (indicator.style.backgroundImage && indicator.style.backgroundImage !== 'none') {
          var img = indicator.ownerDocument.createElement('img');
          img.src = indicator.style.backgroundImage.replace(this.URL_REGEXP, '$1');
          indicator.appendChild(img);
          indicator.style.backgroundImage = 'none';
        }
      });
    }
    expose_onclose() {
      // Check to see if we're in a nextmatch, remove magic
      var nm = this.find_nextmatch(this);

      // redefine essential removeClass method in case the active element has no longer contains it.
      if (!this._gallery.activeIndicator.removeClass) {
        this._gallery.activeIndicator.removeClass = blueimp.helper.prototype.removeClass;
      }
      if (nm && !this._is_target_indepth(nm)) {
        // Remove scrolling from thumbnails
        this._gallery.container.find('.indicator').removeClass('paginating').off('mousewheel').off('swipe');

        // Remove applied mime filter
        nm.applyFilters({
          col_filter: {
            mime: ''
          }
        });
      }
    }
    expose_onclosed() {}
  };
}

/**
 * Shows an image and if you click on it it gets bigger
 *
 * Set src property for the thumbnail / small image
 * Set href property to the URL of the full / large image
 */ //@ts-ignore Something not right with types & inheritance according to TypeScript
class Et2ImageExpose extends ExposeMixin(Et2Image) {
  constructor() {
    super();
  }
  connectedCallback() {
    super.connectedCallback();
  }

  /**
   * Used to determine if this widget is exposable.  Images always are, even if we don't actually
   * know the mime type.
   *
   * @returns {ExposeValue}
   */
  get exposeValue() {
    return {
      mime: "image/*",
      path: this.href,
      download_url: this.href
    };
  }

  /**
   * Get the info needed to show this image as slide(s)
   */
  getMedia(_value) {
    var media = super.getMedia(_value);
    media[0].title = this.label;
    media[0].thumbnail = this.src;
    return media;
  }
}
customElements.define("et2-image-expose", Et2ImageExpose, {
  extends: 'img'
});

var _templateObject$z;
function _taggedTemplateLiteral$z(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$t(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$t(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$t(Object(source), true).forEach(function (key) { _defineProperty$16(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$t(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$16(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Shows a description and if you click on it, it shows the file specified by href in gallery.
 *
 * If the gallery cannot handle the file type (specified by mime) then href is handled as
 * a normal description, and clicking follows the link.
 */
//@ts-ignore Something not right with types & inheritance according to TypeScript
class Et2DescriptionExpose extends ExposeMixin(Et2Description) {
  static get properties() {
    return _objectSpread$t(_objectSpread$t({}, super.properties), {}, {
      /**
       * Mime type
       * Used to determine this widget can be exposed.  If not one of the OK mime types, will be treated
       * as a normal description
       */
      mime: {
        type: String,
        reflect: true
      },
      /**
       * hash for data stored on service-side with egw_link::(get|set)_data()
       */
      mimeData: {
        type: String
      }
    });
  }
  constructor() {
    super();
  }
  connectedCallback() {
    super.connectedCallback();
  }
  disconnectedCallback() {
    super.disconnectedCallback();
  }

  /** These guys needed to get value where it needs to be */
  set value(new_value) {
    return super.value = new_value;
  }
  get value() {
    return super.value;
  }

  /**
   * Needed to for transformAttributes() to set the value.
   * Not sure why Et2Description.set_value() isn't enough.
   */
  set_value(value) {
    super.set_value(value);
  }

  /**
   * Override the wrap link, since clicking on a link would work and do both
   * @param href
   * @param value
   * @returns {TemplateResult<1>}
   * @protected
   */
  wrapLink(href, value) {
    if (this.isExposable()) {
      return x$1(_templateObject$z || (_templateObject$z = _taggedTemplateLiteral$z(["", ""])), value);
    } else {
      // Expose cannot handle this particular file / link, wrap it as normal
      return super.wrapLink(href, value);
    }
  }

  /**
   * Used to determine if this widget is exposable.  Images always are, even if we don't actually
   * know the mime type.
   *
   * @returns {ExposeValue}
   */
  get exposeValue() {
    return {
      mime: this.mime,
      path: this.href,
      download_url: this.href
    };
  }

  /**
   * Get the info needed to show this image as slide(s)
   */
  getMedia(_value) {
    var media = super.getMedia(_value);
    if (media) {
      media[0].title = this.value;
    }
    return media;
  }
}
customElements.define("et2-description-expose", Et2DescriptionExpose);

/**
 * EGroupware eTemplate2 - et2-appicon widget
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Ralf Becker
 */
class Et2AppIcon extends Et2Image {
  constructor() {
    super();
    this.defaultSrc = 'nonav';
  }
  parse_href(_app) {
    if (!_app) _app = this.egw().app_name();
    var src = (this.egw().app(_app, 'icon_app') || _app) + '/' + (this.egw().app(_app, 'icon') || 'navbar');
    return super.parse_href(src);
  }
}
customElements.define("et2-appicon", Et2AppIcon, {
  extends: 'img'
});

var _templateObject$y;
function ownKeys$s(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$s(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$s(Object(source), true).forEach(function (key) { _defineProperty$15(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$s(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$y(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$15(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2LAvatar extends Et2Avatar {
  static get styles() {
    return [...super.styles, shoelace, i$b(_templateObject$y || (_templateObject$y = _taggedTemplateLiteral$y(["\n\t\t\t\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$s(_objectSpread$s({}, super.properties), {}, {
      lname: {
        type: String
      },
      fname: {
        type: String
      }
    });
  }
  constructor() {
    super();
    this.lname = "";
    this.fname = "";
  }

  /**
   * Handle changes that have to happen based on changes to properties
   *
   */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("lname") || changedProperties.has("fname") || changedProperties.has("contactId") || changedProperties.has("src")) {
      if (!this.src || decodeURIComponent(this.src).match("lavatar=1") && (this.fname || this.lname) && this.contactId) {
        var lavatar = Et2LAvatar.lavatar(this.fname, this.lname, this.contactId);
        this.initials = lavatar.initials;
        this._baseNode.style.backgroundColor = lavatar.background;
      } else if (this.src) {
        this.image = this.src;
      }
      if (this.lname || this.fname) {
        // Update tooltip - we don't have enough info for more than name but we can put it in the right order
        var label = (this.egw().preference("account_display", "common") || "firstname").includes("first") || !this.lname || !this.fname ? this.fname + " " + this.lname : this.lname + ", " + this.fname;
        if (label != this.statustext) {
          this.statustext = label.trim();
        }
      }
    }
  }

  /**
   *
   */
  getDetachedAttributes(_attrs) {
    super.getDetachedAttributes(_attrs);
    _attrs.push("lname", "fname");
  }

  /**
   * Generate letter avatar with given data
   * @param {type} _fname
   * @param {type} _lname
   * @param {type} _id
   * @returns {string} return data url
   */
  static lavatar(_fname, _lname, _id) {
    var str = _fname + _lname + _id;
    var getBgColor = function getBgColor(_str) {
      var hash = 0;
      for (var i = 0; i < _str.length; i++) {
        hash = _str[i].charCodeAt(0) + hash;
      }
      return Et2LAvatar.LAVATAR_BG_COLORS[hash % Et2LAvatar.LAVATAR_BG_COLORS.length];
    };
    var bg = getBgColor(str);
    var text = (_fname ? _fname[0].toUpperCase() : "") + (_lname ? _lname[0].toUpperCase() : "");
    return {
      background: bg,
      initials: text
    };
  }
}
/**
 * background color codes
 */
_defineProperty$15(Et2LAvatar, "LAVATAR_BG_COLORS", ['#5a8770', '#b2b7bb', '#6fa9ab', '#f5af29', '#0088b9', '#f18636', '#d93a37', '#a6b12e', '#0088b9', '#f18636', '#d93a37', '#a6b12e', '#5c9bbc', '#f5888d', '#9a89b5', '#407887', '#9a89b5', '#5a8770', '#d33f33', '#a2b01f', '#f0b126', '#0087bf', '#f18636', '#0087bf', '#b2b7bb', '#72acae', '#9c8ab4', '#5a8770', '#eeb424', '#407887']);
customElements.define("et2-lavatar", Et2LAvatar);

var es_string_trimEnd = {};

var es_string_trimRight = {};

'use strict';
var $trimEnd = stringTrim.end;
var forcedStringTrimMethod = stringTrimForced;

// `String.prototype.{ trimEnd, trimRight }` method
// https://tc39.es/ecma262/#sec-string.prototype.trimend
// https://tc39.es/ecma262/#String.prototype.trimright
var stringTrimEnd = forcedStringTrimMethod('trimEnd') ? function trimEnd() {
  return $trimEnd(this);
// eslint-disable-next-line es/no-string-prototype-trimstart-trimend -- safe
} : ''.trimEnd;

var $$3 = _export;
var trimEnd$1 = stringTrimEnd;

// `String.prototype.trimRight` method
// https://tc39.es/ecma262/#sec-string.prototype.trimend
// eslint-disable-next-line es/no-string-prototype-trimleft-trimright -- safe
$$3({ target: 'String', proto: true, name: 'trimEnd', forced: ''.trimRight !== trimEnd$1 }, {
  trimRight: trimEnd$1
});

// TODO: Remove this line from `core-js@4`

var $$2 = _export;
var trimEnd = stringTrimEnd;

// `String.prototype.trimEnd` method
// https://tc39.es/ecma262/#sec-string.prototype.trimend
// eslint-disable-next-line es/no-string-prototype-trimstart-trimend -- safe
$$2({ target: 'String', proto: true, name: 'trimEnd', forced: ''.trimEnd !== trimEnd }, {
  trimEnd: trimEnd
});

var _templateObject$x, _templateObject2$k, _templateObject3$9, _templateObject4$5;
function asyncGeneratorStep$5(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$5(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$5(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$5(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$r(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$r(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$r(Object(source), true).forEach(function (key) { _defineProperty$14(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$r(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$x(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$14(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Display a specific, single entry from an application
 *
 * The entry is specified with the application name, and the app's ID for that entry.
 * You can set it directly in the properties (application, entryId) or use set_value() to
 * pass an object {app: string, id: string, [title: string]} or string in the form <application>::<ID>.
 * If title is not specified, it will be fetched using framework's egw.link_title()
 *
 */ // @ts-ignore TypeScript says there's something wrong with types
class Et2Link extends ExposeMixin(Et2Widget(s$5)) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$x || (_templateObject$x = _taggedTemplateLiteral$x(["\n\t\t\t  :host {\n\t\t\t\tdisplay: block;\n\t\t\t\tcursor: pointer;\n\t\t\t  }\n\n\t\t\t  .link {\n\t\t\t\tdisplay: flex;\n\t\t\t\tgap: 0.5rem;\n\t\t\t  }\n\n\t\t\t  .link__title {\n\t\t\t\tflex: 2 1 50%;\n                overflow: hidden;\n                text-overflow: ellipsis;\n                max-width: max-content;\n                width: 0;\n\t\t\t  }\n\n\t\t\t  .link__remark {\n\t\t\t\tflex: 1 1 50%;\n                overflow: hidden;\n                text-overflow: ellipsis;\n                max-width: max-content;\n                width: 0;\n\t\t\t  }\n\n\t\t\t  :host:hover {\n\t\t\t\ttext-decoration: underline\n\t\t\t  }\n\n\t\t\t  /** Style based on parent **/\n\n\t\t\t  :host(et2-link-string) div {\n\t\t\t\tdisplay: inline;\n\t\t\t  }\n\n\t\t\t  :host-context(et2-link-list):hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$r(_objectSpread$r({}, super.properties), {}, {
      /**
       * Specify the application for the entry
       */
      app: {
        type: String,
        reflect: true
      },
      /**
       * Application entry ID
       */
      entryId: {
        type: String,
        reflect: true
      },
      /**
       * Pass value as an object, will be parsed to set application & entryId
       */
      value: {
        type: Object,
        reflect: false
      },
      /**
       * View link type
       * Used for displaying the linked entry
       * [view|edit|add]
       * default "view"
       */
      linkHook: {
        type: String
      },
      /**
       * Target application
       *
       * Passed to egw.open() to open entry in specified application
       */
      targetApp: {
        type: String
      },
      /**
       * Optional parameter to be passed to egw().open in order to open links in specified target eg. _blank
       */
      extraLinkTarget: {
        type: String
      },
      /**
       * Breaks title into multiple lines based on this delimiter by replacing it with '\r\n'"
       */
      breakTitle: {
        type: String
      }
    });
  }
  constructor() {
    super();
    // Title is read-only inside
    _defineProperty$14(this, "_title", void 0);
    _defineProperty$14(this, "_titlePromise", void 0);
    this._title = Et2Link.MISSING_TITLE;
    this.__linkHook = "view";
  }
  connectedCallback() {
    super.connectedCallback();
  }
  getUpdateComplete() {
    var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
      _this = this;
    return _asyncToGenerator$5(function* () {
      var result = yield _superprop_getGetUpdateComplete().call(_this);
      if (_this._titlePromise) {
        // Wait for the title to arrive before we say we're done
        yield _this._titlePromise;
      }
      return result;
    })();
  }

  /**
   * Build a thumbnail for the link
   * @param link
   * @returns {TemplateResult}
   * @protected
   */
  _thumbnailTemplate(link) {
    // If we have a mimetype, use a Et2VfsMime
    // Files have path set in 'icon' property, and mime in 'type'
    if (link.type && link.icon) {
      return x$1(_templateObject2$k || (_templateObject2$k = _taggedTemplateLiteral$x(["\n                <et2-vfs-mime part=\"icon\" class=\"link__icon\" ._parent=", " .value=", "\n                ></et2-vfs-mime>"])), this, Object.assign({
        name: link.title,
        mime: link.type,
        path: link.icon
      }, link));
    }
    return x$1(_templateObject3$9 || (_templateObject3$9 = _taggedTemplateLiteral$x(["\n            <et2-image-expose\n                    part=\"icon\"\n                    class=\"link__icon\"\n                    ._parent=", "\n                    href=\"", "\"\n                    src=", "\n                    ?disabled=", "\n            ></et2-image-expose>"])), this, link.href, this.egw().image("" + link.icon), !(link.href || link.icon));
  }
  render() {
    var title = this.title;
    if (this.breakTitle) {
      // Set up title to optionally break on the provided character - replace all space with nbsp, add a
      // zero-width space after the break string
      title = title.replace(this.breakTitle, this.breakTitle.trimEnd() + "\u200B").replace(/ /g, '\u00a0')
      // Change hyphen to non-breaking hyphen
      .replace(/-/g, '‑');
    }
    return x$1(_templateObject4$5 || (_templateObject4$5 = _taggedTemplateLiteral$x(["\n            <div part=\"base\" class=\"link et2_link\" draggable=\"", "\" @dragstart=", ">\n                ", "\n                <span part=\"title\" class=\"link__title\">", "</span>\n                <span part=\"remark\" class=\"link__remark\">", "</span>\n            </div>"])), this.app == 'file', this._handleDragStart.bind(this, this.dataset), this._thumbnailTemplate(_objectSpread$r({
      id: this.entryId,
      app: this.app
    }, this.dataset)), title, this.dataset.remark);
  }
  set title(_title) {
    this._title = _title;
  }
  get title() {
    return this._title;
  }

  /**
   * Get a value representation of the link.
   *
   * @returns {LinkInfo | string}
   */
  get value() {
    return this.app && this.entryId ? this.app + ":" + this.entryId : "";
  }
  set value(_value) {
    if (!_value) {
      this.entryId = "";
      this.title = "";
      return;
    }
    if (typeof _value != 'object' && _value) {
      if (_value.indexOf(':') >= 0) {
        // application_name:ID
        var app = _value.split(':', 1);
        var id = _value.substr(app[0].length + 1);
        _value = {
          app: app[0],
          id: id
        };
      } else if (this.app) {
        // Application set, just passed ID
        _value = {
          app: this.app,
          id: _value
        };
      } else {
        console.warn("Bad value for link widget.  Need an object with keys 'app', 'id', and optionally 'title'", _value);
        return;
      }
    }
    if (typeof _value !== "string") {
      this.app = _value.app;
      this.entryId = _value.id;
      if (_value.title) {
        this._title = _value.title;
      }
      Object.keys(_value).forEach(key => {
        // Skip these, they're either handled explicitly, or ID which we don't want to mess with
        if (["app", "entryId", "title", "id"].indexOf(key) != -1) {
          return;
        }
        // we should not let null value being stored into dataset as 'null'
        if (_value[key] === null) {
          this.dataset[key] = "";
        } else {
          this.dataset[key] = _value[key];
        }
      });
    }
    this.requestUpdate("value");
  }
  set_value(_value) {
    this.value = _value;
  }
  get exposeValue() {
    var info = {
      app: this.app,
      id: this.entryId,
      path: this.dataset['icon']
    };
    info['label'] = this.title;
    info = Object.assign(info, this.dataset);
    if (info['remark']) {
      info['label'] += " - " + info['remark'];
    }
    if (!info.path && this.app == "file") {
      // Fallback to check the "normal" place if path wasn't available
      info.path = "/webdav.php/apps/" + this.dataset.app2 + "/" + this.dataset.id2 + "/" + this.entryId;
    }
    if (typeof info["type"] !== "undefined") {
      // Links use "type" for mimetype.
      info.mime = info["type"];
    }
    return info;
  }

  /**
   * If app or entryId has changed, we'll update the title
   *
   * @param changedProperties
   */
  willUpdate(changedProperties) {
    super.willUpdate(changedProperties);
    super.requestUpdate();
    if (changedProperties.has("app") || changedProperties.has("entryId")) {
      if (this.app && this.entryId && !this._title) {
        this._title = Et2Link.MISSING_TITLE;
      }
      if (this.app && this.entryId && this._title == Et2Link.MISSING_TITLE) {
        var _this$egw;
        // Title will be fetched from server and then set
        this._titlePromise = (_this$egw = this.egw()) === null || _this$egw === void 0 ? void 0 : _this$egw.link_title(this.app, this.entryId, true).then(title => {
          this._title = title;
          // It's probably already been rendered
          this.requestUpdate();
        });
      }
    }
  }

  /**
   * Handle dragstart event for dragging out a file
   *
   * @param _data
   * @param _ev
   * @protected
   */
  _handleDragStart(_data, _ev) {
    // // Unfortunately, dragging files is currently only supported by Chrome
    if (navigator && navigator.userAgent.indexOf('Chrome') >= 0) {
      if (_ev.dataTransfer == null) {
        return;
      }
      if (_data && _data.type && _data.download_url) {
        _ev.dataTransfer.dropEffect = "copy";
        _ev.dataTransfer.effectAllowed = "copy";
        var url = _data.download_url;

        // NEED an absolute URL
        if (url[0] == '/') {
          url = this.egw().link(url);
        }
        // egw.link adds the webserver, but that might not be an absolute URL - try again
        if (url[0] == '/') url = window.location.origin + url;

        // Unfortunately, dragging files is currently only supported by Chrome
        if (navigator && navigator.userAgent.indexOf('Chrome')) {
          _ev.dataTransfer.setData("DownloadURL", _data.type + ':' + this.title + ':' + url);
        }

        // Include URL as a fallback
        _ev.dataTransfer.setData("text/uri-list", url);
      }
      if (_ev.dataTransfer.types.length == 0) {
        // No file data? Abort: drag does nothing
        _ev.preventDefault();
        return;
      }
    }
  }
  _handleClick(_ev) {
    // If we don't have app & entryId, nothing we can do
    if (!this.app || !this.entryId || typeof this.entryId !== "string") {
      return false;
    }
    // If super didn't handle it (returns false), just use egw.open()
    if (super._handleClick(_ev)) {
      this.egw().open(Object.assign({
        app: this.app,
        id: this.entryId
      }, this.dataset), "", this.linkHook, this.dataset.extra_args, this.extraLinkTarget || this.app, this.targetApp || this.app);
    }
    _ev.stopImmediatePropagation();
    return false;
  }
  getDetachedAttributes(_attrs) {
    _attrs.push("app", "entryId", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var k in _values) {
      this[k] = _values[k];
    }
  }
}

// @ts-ignore TypeScript says there's something wrong with types
_defineProperty$14(Et2Link, "MISSING_TITLE", "??");
customElements.define("et2-link", Et2Link);

/**
 * Interface to describe needed information about a link
 */

var _templateObject$w, _templateObject2$j;
function ownKeys$q(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$q(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$q(Object(source), true).forEach(function (key) { _defineProperty$13(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$q(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$w(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$13(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Find and select a single entry using the link system.
 *
 *
 */
class Et2LinkAdd extends Et2InputWidget(FormControlMixin(ValidateMixin(SlotMixin(s$5)))) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$w || (_templateObject$w = _taggedTemplateLiteral$w(["\n\t\t\t:host {\n\t\t\t\tdisplay: block;\n\t\t\t\tborder: solid var(--sl-input-border-width) var(--sl-input-border-color);\n    \t\t\tborder-radius: var(--sl-input-border-radius-medium);\n\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$q(_objectSpread$q({}, super.properties), {}, {
      /**
       * Either an array of LinkInfo (defined in Et2Link.ts) or array with keys to_app and to_id
       */
      value: {
        type: Object
      },
      /**
       * Limit to just this application - hides app selection
       */
      application: {
        type: String
      },
      /**
       * Limit to the listed applications (comma seperated)
       */
      applicationList: {
        type: String
      }
    });
  }
  get slots() {
    return _objectSpread$q(_objectSpread$q({}, super.slots), {}, {
      app: () => {
        var app = document.createElement("et2-link-apps");
        app.appIcons = false;
        if (this.application) {
          app.onlyApp = this.application;
        } else if (typeof this._value !== "undefined" && this._value.app) {
          app.value = this._value.app;
        }
        if (this.applicationList) {
          app.applicationList = this.applicationList;
        }
        return app;
      },
      button: () => {
        var button = document.createElement("et2-button");
        button.id = this.id + "_add";
        button.label = this.egw().lang("Add");
        button.noSubmit = true;
        return button;
      }
    });
  }

  /**
   * We only care about this value until render.  After the sub-nodes are created,
   * we take their "live" values for our value.
   *
   * N.B.: Single underscore!  Otherwise we conflict with parent __value
   *
   * @type {LinkInfo}
   * @private
   */

  constructor() {
    super();
    _defineProperty$13(this, "_value", void 0);
    this.handleButtonClick = this.handleButtonClick.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();

    // Clear initial value, no longer needed
    this._value = undefined;
    this._bindListeners();
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("readonly")) {
      this._appNode.readonly = this.readonly;
    }
    // Pass some properties on to app selection
    if (changedProperties.has("only_app")) {
      this._appNode.only_app = this.only_app;
    }
    if (changedProperties.has("applicationList")) {
      this._appNode.applicationList = this.applicationList;
    }
    if (changedProperties.has("app_icons")) {
      this._appNode.app_icons = this.app_icons;
    }
  }
  set application(app) {
    app = app || "";

    // If initial value got set before only_app, it still needs app in pre-render value
    if (this._value && app) {
      this._value.app = app;
    }
    if (this._appNode) {
      this._appNode.value = app;
    }
  }
  get application() {
    if (this._value) {
      return this._value.app;
    }
    if (this._appNode) {
      return this._appNode.value;
    }
  }
  get _appNode() {
    return this.querySelector("[slot='app']");
  }
  get _buttonNode() {
    return this.querySelector("[slot='button']");
  }

  /**
   * @return {TemplateResult}
   * @protected
   */
  _inputGroupInputTemplate() {
    return x$1(_templateObject2$j || (_templateObject2$j = _taggedTemplateLiteral$w(["\n            <div class=\"input-group__input\">\n                <slot name=\"app\"></slot>\n                <slot name=\"button\"></slot>\n            </div>\n\t\t"])));
  }
  _bindListeners() {
    //this._appNode.addEventListener("change", this._handleAppChange);
    this._buttonNode.addEventListener("click", this.handleButtonClick);
  }
  _unbindListeners() {
    this._buttonNode.removeEventListener("click", this.handleButtonClick);
  }

  /**
   * Add button was clicked
   * @param {MouseEvent} e
   */
  handleButtonClick(e) {
    this.egw().open(this.value.to_app + ":" + this.value.to_id, this._appNode.value, 'add');
  }
}
customElements.define("et2-link-add", Et2LinkAdd);

var _templateObject$v, _templateObject2$i;
function ownKeys$p(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$p(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$p(Object(source), true).forEach(function (key) { _defineProperty$12(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$p(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$v(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$12(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2LinkAppSelect extends Et2Select {
  static get styles() {
    return [...super.styles, i$b(_templateObject$v || (_templateObject$v = _taggedTemplateLiteral$v(["\n\t\t\t:host {\n\t\t\t\t--icon-width: 20px;\n\t\t\t\tdisplay: inline-block;\n\t\t\t\tmin-width: 64px;\n\t\t\t}\n\t\t\t:host([appIcons]) {\n\t\t\t\tmax-width: 75px;\n\t\t\t}\n\t\t\t.select__menu {\n\t\t\t\toverflow-x: hidden;\n\t\t\t}\n\t\t\t::part(control) {\n\t\t\t\tborder: none;\n\t\t\t\tbox-shadow: initial;\n\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$p(_objectSpread$p({}, super.properties), {}, {
      /**
       * Limit to just this one application, and hide the selection
       */
      onlyApp: {
        type: String
      },
      /**
       * Limit to these applications (comma seperated).
       */
      applicationList: {
        type: String
      },
      /**
       * Show application icons instead of application names
       */
      appIcons: {
        type: Boolean,
        reflect: true
      }
    });
  }
  /**
   * Constructor
   *
   */
  constructor() {
    super();
    /*
    				icon.style.width = "var(--icon-width)";
    				icon.style.height = "var(--icon-width)";
    	 */
    _defineProperty$12(this, "__applicationList", void 0);
    _defineProperty$12(this, "__onlyApp", void 0);
    this.onlyApp = "";
    this.appIcons = true;
    this.applicationList = [];
    this.hoist = true;

    // Select options are based off abilities registered with link system
    this._reset_select_options();
  }
  set onlyApp(app) {
    this.__onlyApp = app || "";
    this.updateComplete.then(() => {
      this.style.display = this.onlyApp ? 'none' : '';
    });
  }
  get onlyApp() {
    // __onlyApp may be undefined during creation
    return this.__onlyApp || "";
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.value) {
      // use preference
      var appname = "";
      if (typeof this.value != 'undefined' && this.parentNode && this.parentNode.toApp) {
        appname = this.parentNode.toApp;
      }
      this.value = this.egw().preference('link_app', appname || this.egw().app_name());
    }
    // Register to
    this.addEventListener("sl-change", this._handleChange);
    if (this.__onlyApp) {
      this.style.display = 'none';
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("sl-change", this._handleChange);
  }

  /**
   * Called before update() to compute values needed during the update
   *
   * @param changedProperties
   */
  willUpdate(changedProperties) {
    super.willUpdate(changedProperties);
    if (changedProperties.has("onlyApp") || changedProperties.has("applicationList")) {
      this._reset_select_options();
    }
  }
  set applicationList(app_list) {
    var oldValue = this.__applicationList;
    if (typeof app_list == "string") {
      app_list = app_list.split(",");
    }
    this.__applicationList = app_list;
    this.requestUpdate("applicationList", oldValue);
  }
  get applicationList() {
    return this.__applicationList;
  }
  get value() {
    return this.onlyApp ? this.onlyApp : super.value;
  }
  set value(new_value) {
    super.value = new_value;
  }
  handleValueChange(e) {
    super.handleValueChange(e);

    // update preference
    var appname = "";
    if (typeof this.value != 'undefined' && this.parentNode && this.parentNode.toApp) {
      appname = this.parentNode.toApp;
    }
    this.egw().set_preference(appname || this.egw().app_name(), 'link_app', this.value);
  }

  /**
   * Limited select options here
   * This method will check properties and set select options appropriately
   */
  _reset_select_options() {
    var select_options = [];

    // Limit to one app
    if (this.onlyApp) {
      var _this$egw$link_get_re;
      select_options.push({
        value: this.onlyApp,
        label: this.egw().lang(this.onlyApp),
        icon: (_this$egw$link_get_re = this.egw().link_get_registry(this.onlyApp, 'icon')) !== null && _this$egw$link_get_re !== void 0 ? _this$egw$link_get_re : this.onlyApp + "/navbar"
      });
    } else if (this.applicationList.length > 0) {
      select_options = this.applicationList.map(app => {
        var _this$egw$link_get_re2;
        return {
          value: app,
          label: this.egw().lang(app),
          icon: (_this$egw$link_get_re2 = this.egw().link_get_registry(app, 'icon')) !== null && _this$egw$link_get_re2 !== void 0 ? _this$egw$link_get_re2 : app + "/navbar"
        };
      });
    } else {
      //@ts-ignore link_app_list gives {app:name} instead of an array, but parent will fix it
      select_options = this.egw().link_app_list('query');
      if (typeof select_options['addressbook-email'] !== 'undefined') {
        delete select_options['addressbook-email'];
      }
      select_options = cleanSelectOptions(select_options);
      select_options.map(option => {
        var _this$egw$link_get_re3;
        option.icon = (_this$egw$link_get_re3 = this.egw().link_get_registry(option.value, 'icon')) !== null && _this$egw$link_get_re3 !== void 0 ? _this$egw$link_get_re3 : option.value + "/navbar";
      });
    }
    if (!this.value) {
      this.value = this.egw().preference('link_app', this.egw().app_name());
    }
    this.select_options = select_options;
  }
  _optionTemplate(option) {
    return x$1(_templateObject2$i || (_templateObject2$i = _taggedTemplateLiteral$v(["\n            <sl-option value=\"", "\" title=\"", "\">\n                ", "\n                ", "\n            </sl-option>"])), option.value, option.title, this.appIcons ? "" : option.label, this._iconTemplate(option));
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-link-apps", Et2LinkAppSelect);

var _templateObject$u, _templateObject2$h;
function ownKeys$o(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$o(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$o(Object(source), true).forEach(function (key) { _defineProperty$11(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$o(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$u(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$11(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Find and select a single entry using the link system.
 *
 *
 */
class Et2LinkEntry extends Et2InputWidget(FormControlMixin(SlotMixin(s$5))) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$u || (_templateObject$u = _taggedTemplateLiteral$u(["\n\t\t\t  :host {\n\t\t\t\tdisplay: block;\n\t\t\t  }\n\n\t\t\t  :host(.hideApp) ::slotted([slot=\"app\"]) {\n\t\t\t\tdisplay: none;\n\t\t\t  }\n\n\t\t\t  .input-group__input {\n\t\t\t\tgap: 0.5rem;\n\t\t\t  }\n\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$o(_objectSpread$o({}, super.properties), {}, {
      value: {
        type: Object
      },
      /**
       * Limit to just this application - hides app selection
       */
      onlyApp: {
        type: String
      },
      /**
       * Limit to the listed applications (comma seperated)
       */
      applicationList: {
        type: String
      },
      /**
       * Show just application icons instead of names
       */
      appIcons: {
        type: Boolean
      },
      /**
       * Callback before query to server.
       * It will be passed the request & et2_link_entry objects.  Must return true, or false to abort query.
       */
      query: {
        type: Function
      },
      /**
       * Callback when user selects an option.  Must return true, or false to abort normal action.
       */
      select: {
        type: Function
      },
      /**
       * Displayed in the search / select when no value is selected
       */
      placeholder: {
        type: String
      },
      /**
       * Additional search parameters that are passed to the server
       * when we query searchUrl
       */
      searchOptions: {
        type: Object
      }
    });
  }
  get slots() {
    return _objectSpread$o(_objectSpread$o({}, super.slots), {}, {
      app: () => {
        var app = document.createElement("et2-link-apps");
        if (this.__onlyApp) {
          app.onlyApp = this.__onlyApp;
        } else if (typeof this._value !== "undefined" && this._value.app) {
          app.value = this._value.app;
        }
        return app;
      },
      select: () => {
        var select = document.createElement("et2-link-search");
        if (typeof this._value !== "undefined" && this._value.id) {
          if (this._value.title) {
            select.select_options = [{
              value: this._value.id,
              label: this._value.title
            }];
          }
          select.app = this._value.app;
          select.value = this._value.id;
        }
        return select;
      }
    });
  }

  /**
   * We only care about this value until render.  After the sub-nodes are created,
   * we take their "live" values for our value.
   *
   * N.B.: Single underscore!  Otherwise we conflict with parent __value
   *
   * @type {LinkInfo}
   * @private
   */

  constructor() {
    super();
    _defineProperty$11(this, "_value", void 0);
    _defineProperty$11(this, "__onlyApp", void 0);
  }
  connectedCallback() {
    super.connectedCallback();
    this._handleAppChange = this._handleAppChange.bind(this);
    this._handleEntrySelect = this._handleEntrySelect.bind(this);
    this._handleEntryClear = this._handleEntryClear.bind(this);
    this._handleShow = this._handleShow.bind(this);
    this._handleHide = this._handleHide.bind(this);

    // Clear initial value
    this._value = undefined;
    if (!this.readonly) {
      this._bindListeners();
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this._unbindListeners();
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("required")) {
      this._searchNode.required = this.required;
    }
    if (changedProperties.has("readonly")) {
      this._appNode.readonly = this._appNode.disabled = this.readonly;
      this._searchNode.readonly = this.readonly;
    }
    // Pass some properties on to app selection
    if (changedProperties.has("onlyApp")) {
      this._appNode.onlyApp = this.onlyApp;
    }
    if (changedProperties.has("applicationList")) {
      this._appNode.applicationList = this.applicationList;
    }
    if (changedProperties.has("appIcons")) {
      this._appNode.appIcons = this.appIcons;
    }
  }
  set onlyApp(app) {
    this.__onlyApp = app || "";

    // If initial value got set before onlyApp, it still needs app in pre-render value
    if (this._value && app) {
      this._value.app = this.__onlyApp;
    }
    if (app) {
      this.app = app;
    }
    if (this._appNode) {
      this._appNode.onlyApp = app;
    }
  }
  get onlyApp() {
    return this.__onlyApp;
  }
  set app(app) {
    this.updateComplete.then(() => {
      this._appNode.value = app;
      this._searchNode.app = app;
    });
  }
  get app() {
    var _this$_appNode;
    return ((_this$_appNode = this._appNode) === null || _this$_appNode === void 0 ? void 0 : _this$_appNode.value) || "";
  }
  set searchOptions(options) {
    this.updateComplete.then(() => {
      this._searchNode.searchOptions = options;
    });
  }
  get searchOptions() {
    var _this$_searchNode;
    return (_this$_searchNode = this._searchNode) === null || _this$_searchNode === void 0 ? void 0 : _this$_searchNode.searchOptions;
  }
  get _appNode() {
    return this.querySelector("[slot='app']");
  }
  get _searchNode() {
    return this.querySelector("[slot='select']");
  }
  get placeholder() {
    var _this$_searchNode2;
    return (_this$_searchNode2 = this._searchNode) === null || _this$_searchNode2 === void 0 ? void 0 : _this$_searchNode2.placeholder;
  }
  set placeholder(new_value) {
    if (this._searchNode) {
      this._searchNode.placeholder = new_value;
    }
  }
  _bindListeners() {
    this._appNode.addEventListener("change", this._handleAppChange);
    this._searchNode.addEventListener("change", this._handleEntrySelect);
    this._searchNode.addEventListener("sl-clear", this._handleEntryClear);
    this.addEventListener("sl-show", this._handleShow);
    this.addEventListener("sl-hide", this._handleHide);
  }
  _unbindListeners() {
    this._appNode.removeEventListener("change", this._handleAppChange);
    this.removeEventListener("sl-select", this._handleEntrySelect);
    this.removeEventListener("sl-clear", this._handleEntryClear);
    this.removeEventListener("sl-show", this._handleShow);
    this.removeEventListener("sl-hide", this._handleHide);
  }

  /**
   * Update the search node's app & clear selected value when
   * selected app changes.
   * @param event
   * @protected
   */
  _handleAppChange(event) {
    this._searchNode.app = this._appNode.value;
    this._searchNode.value = "";
    this._searchNode.clearSearch();
    this._searchNode.focus();
    this.requestUpdate('value');
  }

  /**
   * Hide app selection when there's an entry
   * @param event
   * @protected
   */
  _handleEntrySelect(event) {
    var _this$value;
    event.stopPropagation();
    this.classList.toggle("hideApp", Boolean(typeof this.value == "object" ? (_this$value = this.value) === null || _this$value === void 0 ? void 0 : _this$value.id : this.value));
    this.dispatchEvent(new Event("change"));
    this.requestUpdate('value');
    this.validate();
  }

  /**
   * Show app selection when there's no entry
   * @param event
   * @protected
   */
  _handleEntryClear(event) {
    this.classList.remove("hideApp");
    this._searchNode.value = "";
    this._searchNode.focus();
    this.dispatchEvent(new Event("change"));
    this.requestUpdate('value');
    this.validate();
  }

  /**
   * Option select dropdown opened
   * Show app selection (Et2LinkAppSelect controls own visibility according to onlyApp)
   * @param event
   * @protected
   */
  _handleShow(event) {
    this.classList.remove("hideApp");
  }

  /**
   * Option select dropdown closed
   * Hide app selection (Et2LinkAppSelect controls own visibility according to onlyApp)
   * only if there's a value selected
   *
   * @param event
   * @protected
   */
  _handleHide(event) {
    if (this._searchNode.value) {
      this.classList.add("hideApp");
    }
  }
  get value() {
    if (this.onlyApp) {
      var _ref, _this$_searchNode3;
      return (_ref = (_this$_searchNode3 = this._searchNode) === null || _this$_searchNode3 === void 0 ? void 0 : _this$_searchNode3.value) !== null && _ref !== void 0 ? _ref : "";
    }
    return this._searchNode ? {
      id: this._searchNode.value,
      app: this.app
      //search: this._searchNode...	// content of search field
    } : this._value;
  }
  set value(val) {
    var value = {
      app: this.onlyApp || this.app,
      id: ""
    };
    if (typeof val === 'string' && val.length > 0) {
      if (val.indexOf(',') > 0) {
        val = val.replace(",", ":");
      }
      if (val.indexOf(':') > 0) {
        var vals = val.split(':');
        value.app = vals[0];
        value.id = vals[1];
      } else {
        value.id = val;
      }
    } else if (typeof val === "number" && val) {
      value.id = String(val);
    } else if (typeof val === "object" && val !== null)
      // object with attributes: app, id, title
      {
        value = val;
      }

    // If the searchNode is not there yet, hold value.  We'll use these values when we create the
    // slotted searchNode.
    if (this._searchNode == null) {
      this._value = value;
    } else {
      this.app = this._searchNode.app = value.app;
      this._searchNode.value = value.id;
    }
    this.classList.toggle("hideApp", Boolean(value.id));
  }

  /**
   * @return {TemplateResult}
   * @protected
   */
  _inputGroupInputTemplate() {
    return x$1(_templateObject2$h || (_templateObject2$h = _taggedTemplateLiteral$u(["\n            <div class=\"input-group__input\" part=\"control\">\n                <slot name=\"app\"></slot>\n                <slot name=\"select\"></slot>\n            </div>\n\t\t"])));
  }
}
customElements.define("et2-link-entry", Et2LinkEntry);
class Et2LinkEntryReadonly extends Et2Link {}
customElements.define("et2-link-entry_ro", Et2LinkEntryReadonly);

var _templateObject$t, _templateObject2$g, _templateObject3$8, _templateObject4$4, _templateObject5$3;
function asyncGeneratorStep$4(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$4(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$4(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$4(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$n(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$n(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$n(Object(source), true).forEach(function (key) { _defineProperty$10(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$n(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$t(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$10(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Display a list of entries in a comma separated list
 *
 * Given an application & entry ID, will query the list of links and display
 *
 * @see Et2Link
 */ // @ts-ignore TypeScript says there's something wrong with types
class Et2LinkString extends Et2Widget(s$5) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$t || (_templateObject$t = _taggedTemplateLiteral$t(["\n\t\t\t  :host {\n\t\t\t\tlist-style-type: none;\n\t\t\t\tdisplay: inline;\n\t\t\t\tpadding: 0px;\n\t\t\t  }\n\n\t\t\t  ::slotted(*) {\n\t\t\t\tdisplay: inline;\n\t\t\t  }\n\n\t\t\t  ::slotted(*):hover {\n\t\t\t\ttext-decoration: underline;\n\t\t\t  }\n\n\n\t\t\t  /* CSS for child elements */\n\n\t\t\t  ::slotted(*):after {\n\t\t\t\tcontent: \", \"\n\t\t\t  }\n\n\t\t\t  ::slotted(*:last-child):after {\n\t\t\t\tcontent: initial;\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$n(_objectSpread$n({}, super.properties), {}, {
      /**
       * Specify the application for all the entries, so you only need to specify the entry ID
       */
      application: {
        type: String,
        reflect: true
      },
      /**
       * Application entry ID
       */
      entryId: {
        type: String,
        reflect: true
      },
      /**
       * Application filter
       * Set to an appname or comma separated list of applications to show only linked entries from those
       * applications
       */
      onlyApp: {
        type: String
      },
      /**
       * Type filter
       * Sub-type key to list only entries of that type
       */
      linkType: {
        type: String
      },
      // Show links that are marked as deleted, being held for purge
      showDeleted: {
        type: Boolean
      },
      /**
       * Pass value as an object, will be parsed to set application & entryId
       */
      value: {
        type: Object,
        reflect: false
      }
    });
  }
  constructor() {
    super();
    _defineProperty$10(this, "_link_list", void 0);
    _defineProperty$10(this, "_loadingPromise", void 0);
    this._link_list = [];
    this.__showDeleted = false;
  }
  getUpdateComplete() {
    var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
      _this = this;
    return _asyncToGenerator$4(function* () {
      var result = yield _superprop_getGetUpdateComplete().call(_this);
      if (_this._loadingPromise) {
        // Wait for the values to arrive before we say we're done
        yield _this._loadingPromise;
      }
      return result;
    })();
  }

  /**
   * Set the value of the list
   *
   * Value can be:
   * - String: CSV list of entries in either app:ID or just ID if application is set.
   * - Object: {to_app: <appname>, to_id: <Entry ID>} List of linked entries will be fetched from the server
   * - Array: {app: <appname>, id: <ID>}[]
   * @param _value
   */
  set_value(_value) {
    this._link_list = [];
    if (typeof _value == "object" && !Array.isArray(_value) && !_value.to_app && this.application) {
      _value.to_app = this.application;
    }

    // We have app & ID - fetch list
    if (typeof _value == 'object' && !Array.isArray(_value) && _value.to_app && _value.to_id && (typeof _value.to_id === "string" || typeof _value.to_id == "number")) {
      this.application = _value.to_app;
      this.entryId = _value.to_id;
      this.get_links();
      return;
    }

    // CSV list of IDs for one app
    if (typeof _value === "string") {
      var ids = _value.split(",");
      ids.forEach(id => this._link_list.push({
        app: this.application,
        id: id
      }));
    }
    // List of LinkInfo
    else if (Array.isArray(_value)) {
      this._link_list = _value;
    }
    // List of LinkInfo stuffed into to_id - entry is not yet saved
    else if (_value.to_id && typeof _value.to_id !== "string") {
      this.entryId = _value.to_id;
      Object.keys(_value.to_id).forEach(key => {
        this._link_list.push(_value.to_id[key]);
      });
    }
    this._addLinks(this._link_list);
    super.requestUpdate();
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if ((changedProperties.has("application") || changedProperties.has("entryId") || changedProperties.has("onlyApp") || changedProperties.has("linkType")) && this.application && this.entryId) {
      // Something changed, and we have the information needed to get the matching links
      this.get_links();
    }
  }
  render() {
    var _this$_loadingPromise;
    // This shows loading template until loadingPromise resolves, then shows _listTemplate
    return x$1(_templateObject2$g || (_templateObject2$g = _taggedTemplateLiteral$t(["\n            ", "\n\t\t"])), this._loadingPromise ? m$1((_this$_loadingPromise = this._loadingPromise) === null || _this$_loadingPromise === void 0 ? void 0 : _this$_loadingPromise.then(res => {
      this._listTemplate();
    }), this._loadingTemplate()) : this._listTemplate());
  }
  _listTemplate() {
    return x$1(_templateObject3$8 || (_templateObject3$8 = _taggedTemplateLiteral$t(["\n            <slot></slot>"])));
  }

  /**
   * Render one link
   *
   * @param link
   * @returns {TemplateResult}
   * @protected
   */
  _linkTemplate(link) {
    var id = typeof link.id === "string" ? link.id : link.link_id;
    return x$1(_templateObject4$4 || (_templateObject4$4 = _taggedTemplateLiteral$t(["\n            <et2-link app=\"", "\" entryId=\"", "\" .value=", " ._parent=", "></et2-link>"])), link.app, id, link, this);
  }

  /**
   * Render that we're waiting for data
   * @returns {TemplateResult}
   * @protected
   */
  _loadingTemplate() {
    return x$1(_templateObject5$3 || (_templateObject5$3 = _taggedTemplateLiteral$t(["loading..."])));
  }

  /**
   * Render a list of links inside the list
   * These get slotted, rather than put inside the shadow dom
   *
   * @param links
   * @protected
   */
  _addLinks(links) {
    // Remove anything there right now
    while (this.lastChild) {
      this.removeChild(this.lastChild);
    }
    links.forEach(link => {
      var temp = document.createElement("div");
      D$1(this._linkTemplate(link), temp);
      temp.childNodes.forEach(node => this.appendChild(node));
    });

    /*
    This should work, and it does, but only once.
    It fails if you try and update then run it again - none of the children get added
    Something about how lit renders
    render(html`${repeat(links,
    		(link) => link.app + ":" + link.id,
    		(link) => this._linkTemplate(link))}`,
    	<HTMLElement><unknown>this
    );
    	 */
    this.dispatchEvent(new Event("change", {
      bubbles: true
    }));
  }

  /**
   * Starts the request for link list to the server
   *
   * Called internally to fetch the list.  May be called externally to trigger a refresh if a link is added.
   *
   */
  get_links(not_saved_links) {
    if (typeof not_saved_links === "undefined") {
      not_saved_links = [];
    }
    var _value = {
      to_app: this.application,
      to_id: this.entryId,
      only_app: this.onlyApp,
      show_deleted: this.showDeleted
    };
    if (this._loadingPromise) {
      // Already waiting
      return;
    }
    this._loadingPromise = this.egw().jsonq('EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_list', [_value]).then(_value => {
      if (_value && Array.isArray(_value)) {
        var _loop = function _loop(link) {
          if (!not_saved_links.some(l => l.app == link.app && l.id == link.id)) {
            not_saved_links.push(link);
          }
        };
        for (var link of _value) {
          _loop(link);
        }
      }
      this._addLinks(not_saved_links);
      this._loadingPromise = null;
    });
  }
  getDetachedAttributes(_attrs) {
    _attrs.push("application", "entryId", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var k in _values) {
      this[k] = _values[k];
    }
  }
}
;

// @ts-ignore TypeScript says there's something wrong with types
customElements.define("et2-link-string", Et2LinkString, {
  extends: 'ul'
});

var _templateObject$s, _templateObject2$f, _templateObject3$7, _templateObject4$3, _templateObject5$2, _templateObject6$1;
function ownKeys$m(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$m(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$m(Object(source), true).forEach(function (key) { _defineProperty$$(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$m(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$$(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$s(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Display a list of entries in a comma separated list
 *
 * Given an application & entry ID, will query the list of links and display
 *
 * @see Et2Link
 *
 * To make things easy and consistent for ExposeMixin, we don't want children in the shadow dom, so they are slotted
 * in.  When rendering we generate a slot for each link, then let browser slot them in using the slot name.
 *
 * Templates:
 * _listTemplate - generates the list
 * 	_rowTemplate - creates the slots
 * 	_linkTemplate - generates the content _inside_ each slot
 * 		_thumbnailTemplate - generates the thumbnail image
 */

// @ts-ignore TypeScript says there's something wrong with types
class Et2LinkList extends Et2LinkString {
  static get styles() {
    return [...super.styles, i$b(_templateObject$s || (_templateObject$s = _taggedTemplateLiteral$s(["\n\t\t\t  :host {\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-direction: column;\n\t\t\t\tcolumn-gap: 10px;\n\t\t\t\toverflow: hidden;\n\t\t\t  }\n\n\t\t\t  div {\n\t\t\t\tdisplay: flex;\n\t\t\t\tgap: 10px;\n\t\t\t  }\n\n\t\t\t  div:hover {\n\t\t\t\tbackground-color: var(--highlight-background-color);\n\t\t\t  }\n\n\t\t\t  div.zip_highlight {\n\t\t\t\tanimation-name: new_entry_pulse, new_entry_clear;\n\t\t\t\tanimation-duration: 5s;\n\t\t\t\tanimation-delay: 0s, 30s;\n\t\t\t\tanimation-fill-mode: forwards;\n\t\t\t  }\n\n\t\t\t  /* CSS for child elements */\n\n\t\t\t  ::slotted(*):after {\n\t\t\t\t/* Reset from Et2LinkString */\n\t\t\t\tcontent: initial;\n\t\t\t  }\n\n\t\t\t  ::slotted(*)::part(icon) {\n\t\t\t\twidth: 1rem;\n\t\t\t  }\n\n\t\t\t  ::slotted(et2-link) {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t  }\n\n\t\t\t  ::slotted(.remark) {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\twidth: 20%;\n\t\t\t  }\n\n\t\t\t  ::slotted(.delete_button) {\n\t\t\t\tvisibility: hidden;\n\t\t\t\twidth: 16px;\n\t\t\t\torder: 5;\n\t\t\t  }\n\n\t\t\t  div:hover ::slotted(.delete_button) {\n\t\t\t\tvisibility: initial;\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$m(_objectSpread$m({}, super.properties), {}, {
      // JS code which is executed when the links change
      onchange: {
        type: Function
      },
      // Does NOT allow user to enter data, just displays existing data
      // Disables delete, etc.
      readonly: {
        type: Boolean
      }
    });
  }
  constructor() {
    super();
    this.readonly = false;
    this._handleRowContext = this._handleRowContext.bind(this);
    this._handleChange = this._handleChange.bind(this);
    this._handleLinkToChange = this._handleLinkToChange.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    this._createContextMenu();

    // Look for LinkTo and listen for change so we can update
    if (this.getInstanceManager()) {
      this.getInstanceManager().DOMContainer.querySelectorAll("et2-link-to").forEach(link => {
        link.addEventListener("et2-change", this._handleLinkToChange);
      });
    }
    this.addEventListener("change", this._handleChange);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    if (this.getInstanceManager()) {
      this.getInstanceManager().DOMContainer.querySelectorAll("et2-link-to").forEach(link => {
        link.removeEventListener("et2-change", this._handleLinkToChange);
      });
    }
    this.removeEventListener("change", this._handleChange);
  }
  _listTemplate() {
    return x$1(_templateObject2$f || (_templateObject2$f = _taggedTemplateLiteral$s(["\n            ", ""])), c$2(this._link_list, link => link.app + ":" + link.id, link => this._rowTemplate(link)));
  }

  /**
   * Render a list of links inside the list
   * These get put inside the shadow dom rather than slotted
   *
   * @param links
   * @protected
   */
  _addLinks(links) {
    this._link_list = links;
    this.requestUpdate();
    this.updateComplete.then(() => super._addLinks(links));
  }

  /**
   * Render one link
   * These elements are slotted and are found in the light DOM (use this.querySelector(...) to find them)
   *
   * @param link
   * @returns {TemplateResult}
   * @protected
   */
  _linkTemplate(link) {
    var id = typeof link.id === "string" ? link.id : link.link_id;
    return x$1(_templateObject3$7 || (_templateObject3$7 = _taggedTemplateLiteral$s(["\n            <et2-link slot=\"", "\" app=\"", "\" entryId=\"", "\" statustext=\"", "\"\n                      ._parent=", "\n                      .value=", "></et2-link>\n            ", "\n\t\t"])), this._get_row_id(link), link.app, id, link.title, this, link, this._deleteButtonTemplate(link));
  }

  /**
   * Render the row for one link.
   * This is just the structure and slot, actual row contents are done in _linkTemplate.
   * These rows are found in the shadowRoot.  Use this.shadowRoot.querySelector(...) to find them.
   *
   * @param link
   * @returns {TemplateResult}
   * @protected
   */
  _rowTemplate(link) {
    return x$1(_templateObject4$3 || (_templateObject4$3 = _taggedTemplateLiteral$s(["\n            <div id=\"", "\"\n                 @contextmenu=", ">\n                <slot name=\"", "\"></slot>\n            </div>"])), this._get_row_id(link), this._handleRowContext, this._get_row_id(link));
  }

  /**
   * Handle & pass on an internal change
   * @param {ChangeEvent} _event
   * @protected
   */
  _handleChange(_event) {
    if (!this.onchange) {
      return;
    }
    this.onchange(this, _event.data, _event);
  }

  /**
   * We listen to LinkTo widgets so we can update
   *
   * @param _ev
   * @protected
   */
  _handleLinkToChange(_ev) {
    if (_ev && typeof _ev.currentTarget) {
      this.get_links(_ev.detail || []);
    }
  }

  /**
   * Build the delete button
   *
   * @param {LinkInfo} link
   * @returns {TemplateResult}
   * @protected
   */
  _deleteButtonTemplate(link) {
    if (this.readonly) {
      return x$1(_templateObject5$2 || (_templateObject5$2 = _taggedTemplateLiteral$s([""])));
    }
    return x$1(_templateObject6$1 || (_templateObject6$1 = _taggedTemplateLiteral$s(["\n            <et2-image class=\"delete_button\" slot=\"", "\" src=\"delete\"\n                       part=\"delete-button\"\n                       ._parent=", "\n                       .onclick=", "\n                       aria-label=\"", "\"\n            >\n            </et2-image>"])), this._get_row_id(link), this, () => {
      this._delete_link(link);
    }, this.egw().lang(link.app === "file" ? "Delete" : "Unlink"));
  }

  /**
   * Get an ID for a link
   * @param {LinkInfo} link
   * @protected
   */
  _get_row_id(link) {
    return "link_" + (link.dom_id ? link.dom_id : typeof link.link_id == "string" ? link.link_id.replace(/[:.]/g, '_') : link.link_id || link.id);
  }

  /**
   * Delete a link
   * @protected
   */
  _delete_link(link) {
    var link_element = this.querySelector("et2-link[slot='" + this._get_row_id(link) + "']");
    link_element.classList.add("loading");
    this.dispatchEvent(new CustomEvent("et2-before-delete", {
      detail: link
    }));
    var removeLink = () => {
      this.querySelectorAll("[slot='" + this._get_row_id(link) + "']").forEach(e => e.remove());
      if (this._link_list.indexOf(link) != -1) {
        this._link_list.splice(this._link_list.indexOf(link), 1);
      }
      this.dispatchEvent(new CustomEvent("et2-delete", {
        bubbles: true,
        detail: link
      }));
      var change = new Event("change", {
        bubbles: true
      });
      change['data'] = link;
      this.dispatchEvent(change);
    };

    // Unsaved entry, had no ID yet
    if (!this.entryId || typeof this.entryId !== "string" && this.entryId[link.link_id]) {
      if (this.entryId) {
        delete this.entryId[link.link_id];
      }
      removeLink();
    } else if (typeof this.entryId == "string" && link.link_id) {
      egw$1.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_delete", [link.link_id]).sendRequest().then(data => {
        if (data) {
          removeLink();
        }
      });
    }
  }

  /**
   * Handle values passed as an array
   *
   * @param _value
   */
  set value(_value) {
    this._link_list = [];

    // Handle case where server passed a list of links that aren't ready yet
    if (_value && typeof _value == "object") {
      var list = [];
      if (!Array.isArray(_value) && _value.to_id && typeof _value.to_id == "object") {
        list = _value.to_id;
      } else if (Array.isArray(_value) && _value.length) {
        list = _value;
      }
      if (list.length > 0) {
        for (var id in list) {
          var link = list[id];
          if (!link.app && typeof list.splice !== "undefined") {
            list.splice(parseInt(id), 1);
            continue;
          } else if (link.app) {
            // Temp IDs can cause problems since the ID includes the file name or :
            if (link.link_id && typeof link.link_id != 'number') {
              link.dom_id = 'temp_' + egw$1.uid();
            }
            // Icon should be in registry
            if (!link.icon) {
              link.icon = egw$1.link_get_registry(link.app, 'icon');
              // No icon, try by mime type - different place for un-saved entries
              if (link.icon == false && link.id.type) {
                // Triggers icon by mime type, not thumbnail or app
                link.type = link.id.type;
                link.icon = true;
              }
            }
            // Special handling for file - if not existing, we can't ask for title
            if (typeof link.id == 'object' && !link.title) {
              link.title = link.id.name || '';
            }
          }
        }
        this._addLinks(list);
      } else {
        super.set_value(_value);
      }
    }
  }
  _createContextMenu() {
    // Set up context menu
    this.context = new egwMenu();
    this.context.addItem("comment", this.egw().lang("Comment"), "", () => {
      Et2Dialog$1.show_prompt((button, comment) => {
        if (button != Et2Dialog$1.OK_BUTTON) {
          return;
        }
        this._set_comment(this.context.data, comment);
      }, '', this.egw().lang("Comment"), this.context.data.remark || '');
    });
    this.context.addItem("file_info", this.egw().lang("File information"), this.egw().image("edit"), () => {
      var link_data = this.context.data;
      if (link_data.app == 'file') {
        // File info is always the same
        var url = '/apps/' + link_data.app2 + '/' + link_data.id2 + '/' + decodeURIComponent(link_data.id);
        if (typeof url == 'string' && url.indexOf('webdav.php')) {
          // URL is url to file in webdav, so get rid of that part
          url = url.replace('/webdav.php', '');
        }
        this.egw().open(url, "filemanager", "edit");
      }
    });
    this.context.addItem("-", "-");
    this.context.addItem("save", this.egw().lang("Save as"), this.egw().image('save'), () => {
      var link_data = this.context.data;
      // Download file
      if (link_data.download_url) {
        var url = link_data.download_url;
        if (url[0] == '/') {
          url = egw$1.link(url);
        }
        var a = document.createElement('a');
        if (typeof a.download == "undefined") {
          window.location.href = url + "?download";
          return false;
        }

        // Multiple file download for those that support it
        a.setAttribute("href", url);
        a.setAttribute("download", link_data.title || "");
        this.getInstanceManager().DOMContainer.appendChild(a);
        var evt = document.createEvent('MouseEvent');
        evt.initMouseEvent('click', true, true, window, 1, 0, 0, 0, 0, false, false, false, false, 0, null);
        a.dispatchEvent(evt);
        a.remove();
        return false;
      }
      this.egw().open(link_data, "", "view", 'download', link_data.target ? link_data.target : link_data.app, link_data.app);
    });
    this.context.addItem("zip", this.egw().lang("Save as Zip"), this.egw().image('save_zip'), () => {
      // Highlight files for nice UI indicating what will be in the zip.
      // Files have negative IDs.
      this.shadowRoot.querySelectorAll('div[id^="link_-"]').forEach(row => row.classList.add("zip_highlight"));

      // Download ZIP
      window.location.href = this.egw().link('/index.php', {
        menuaction: 'api.EGroupware\\Api\\Etemplate\\Widget\\Link.download_zip',
        app: this.application,
        id: this.entryId
      });
    });

    // Only allow this option if the entry has been saved, and has a real ID
    if (this.to_id && typeof this.to_id != 'object') {
      this.context.addItem("copy_to", this.egw().lang("Copy to"), this.egw().image('copy'), () => {
        // Highlight files for nice UI indicating what will be copied
        this.shadowRoot.querySelectorAll('div[id^="link_-"]').forEach(row => row.classList.add("zip_highlight"));

        // Get target
        var select_attrs = {
          mode: "select-dir",
          button_caption: '',
          button_icon: 'copy',
          button_label: egw$1.lang("copy"),
          //extra_buttons: [{text: egw.lang("link"),	id:"link", image: "link"}],
          dialog_title: egw$1.lang('Copy to'),
          method: "EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_copy_to",
          method_id: this.context.data
        };
        var vfs_select = et2_createWidget("vfs-select", select_attrs, self);

        // No button, just open it
        vfs_select.button.hide();
        vfs_select.click(null);
      });
    }
    this.context.addItem("-", "-");
    this.context.addItem("delete", this.egw().lang("Delete link"), this.egw().image("delete"), () => {
      Et2Dialog$1.show_dialog(button => {
        if (button == Et2Dialog$1.YES_BUTTON) {
          this._delete_link(this.context.data);
        }
      }, egw$1.lang('Delete link?'));
    });
  }
  _handleRowContext(_ev) {
    // Do not trigger expose view if one of the operator keys are held
    if (this.readonly || _ev.altKey || _ev.ctrlKey || _ev.shiftKey || _ev.metaKey) {
      return;
    }
    // Find the link
    var link = this.querySelector("et2-link[slot='" + _ev.currentTarget.id + "']");
    var _link_data = Object.assign({
      app: link.app,
      id: link.entryId
    }, link.dataset);
    // Comment only available if link_id is there and not readonly
    this.context.getItem("comment").set_enabled(typeof _link_data.link_id != 'undefined' && !this.readonly);
    // File info only available for existing files
    this.context.getItem("file_info").set_enabled(typeof _link_data.id != 'object' && _link_data.app == 'file');
    this.context.getItem("save").set_enabled(typeof _link_data.id != 'object' && _link_data.app == 'file');
    // Zip download only offered if there are at least 2 files
    this.context.getItem("zip").set_enabled(this._link_list.length >= 2);
    // Show delete item only if the widget is not readonly
    this.context.getItem("delete").set_enabled(!this.readonly);
    this.context.getItem("delete").caption = _link_data.app === "file" ? this.egw().lang("Delete file") : this.egw().lang("Delete link");
    this.context.data = _link_data;
    this.context.showAt(_ev.pageX, _ev.pageY, true);
    _ev.preventDefault();
  }
  _set_comment(link, comment) {
    var remark = this.querySelector("et2-link[slot='" + this._get_row_id(link) + "']");
    if (!remark) {
      console.warn("Could not find link to comment on", link);
      return;
    }
    /* // TODO
    if(isNaN(link.link_id))	// new entry, not yet stored
    {
    	remark.text(comment);
    	// Look for a link-to with the same ID, refresh it
    		if(link.link_id)
    	{
    		var _widget = link_id.widget || null;
    		self.getRoot().iterateOver(
    			function(widget)
    			{
    				if(widget.id == self.id)
    				{
    					_widget = widget;
    				}
    			},
    			self, et2_link_to
    		);
    		var value = _widget != null ? _widget.getValue() : false;
    		if(_widget && value && value.to_id)
    		{
    			value.to_id[self.context.data.link_id].remark = comment;
    		}
    	}
    	return;
    }
    	 */
    remark.classList.add("loading");
    egw$1.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_comment", [link.link_id, comment]).sendRequest().then(() => {
      if (remark) {
        // Append "" to make sure it's a string, not undefined
        remark.classList.remove("loading");
        // Update internal data
        link.remark = comment + "";
        // Update link widget
        remark.value = link;
      }
    });
  }
}

// @ts-ignore TypeScript says there's something wrong with types
customElements.define("et2-link-list", Et2LinkList);

var _templateObject$r;
function ownKeys$l(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$l(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$l(Object(source), true).forEach(function (key) { _defineProperty$_(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$l(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$_(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$r(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2LinkSearch extends Et2Select {
  static get styles() {
    return [...super.styles, i$b(_templateObject$r || (_templateObject$r = _taggedTemplateLiteral$r(["\n\t\t\t:host {\n\t\t\t\tdisplay: block;\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\tmin-width: 200px;\n\t\t\t}\n\t\t\t::part(icon), .select__icon {\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$l(_objectSpread$l({}, super.properties), {}, {
      app: {
        type: String,
        reflect: true
      }
    });
  }
  constructor() {
    super();
    this.search = true;
    this.searchUrl = "EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_search";
    this.clearable = true;
    this.hoist = true;
    this.placeholder = this.getAttribute("placeholder") || this.egw().lang("search");
  }
  get _appNode() {
    var _this$parentNode;
    return (_this$parentNode = this.parentNode) === null || _this$parentNode === void 0 ? void 0 : _this$parentNode.querySelector("et2-link-apps");
  }

  /**
   * Override parent to do nothing - option is often not in select options
   *
   */
  fix_bad_value() {}
  remoteQuery(search, options) {
    var _this$_appNode$value, _this$_appNode;
    var request = this.egw().request(this.searchUrl, [(_this$_appNode$value = (_this$_appNode = this._appNode) === null || _this$_appNode === void 0 ? void 0 : _this$_appNode.value) !== null && _this$_appNode$value !== void 0 ? _this$_appNode$value : options.app, '', search, options]);
    if (this.query && typeof this.query == "function") {
      if (!this.query(request, this)) {
        return Promise.resolve([]);
      }
    }
    return request.then(result => {
      return this._processResultCount(result);
    });
  }
  updated(changedProperties) {
    super.updated(changedProperties);

    // Set a value we don't have as an option?  That's OK, we'll just add it
    if (changedProperties.has("value") && this.value && this.value.length > 0 && (this.select_options.length == 0 || this.select_options.filter && this.select_options.filter(item => this.getValueAsArray().includes(item.value)).length == 0)) {
      this._missingOption(this.value);
    }
    if (changedProperties.has("readonly")) {
      this.clearable = !this.readonly;
    }
  }

  /**
   * The set value requires an option we don't have.
   * Add it in, asking server for title if needed
   *
   * @param value
   * @protected
   */
  _missingOption(value) {
    var _this$egw;
    var option = {
      value: value,
      label: Et2Link.MISSING_TITLE,
      class: "loading"
    };

    // Weird call instead of just unshift() to make sure to trigger setter
    this.select_options = Object.assign([option], this.__select_options);
    (_this$egw = this.egw()) === null || _this$egw === void 0 || _this$egw.link_title(this.app, option.value, true).then(title => {
      var _this$select;
      option.label = title || Et2Link.MISSING_TITLE;
      option.class = "";
      // It's probably already been rendered, find the item
      var item = (_this$select = this.select) === null || _this$select === void 0 ? void 0 : _this$select.querySelector('[value="' + option.value + '"]');
      if (item) {
        this.requestUpdate();
        this.select.requestUpdate("value");
        item.classList.remove("loading");
      } else {
        // Not already rendered, update the select option
        this.requestUpdate("select_options");
      }
    });
  }
  validate() {
    // Do not validate
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-link-search", Et2LinkSearch);

var _templateObject$q, _templateObject2$e;
function _taggedTemplateLiteral$q(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$k(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$k(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$k(Object(source), true).forEach(function (key) { _defineProperty$Z(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$k(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$Z(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Choose an existing entry, VFS file or local file, and link it to the current entry.
 *
 * If there is no "current entry", link information will be stored for submission instead
 * of being directly linked.
 */
class Et2LinkTo extends Et2InputWidget(ScopedElementsMixin(FormControlMixin(ValidateMixin(s$5)))) {
  static get properties() {
    return _objectSpread$k(_objectSpread$k({}, super.properties), {}, {
      /**
       * Hide buttons to attach files
       */
      noFiles: {
        type: Boolean
      },
      /**
       * Limit to just this application - hides app selection
       */
      onlyApp: {
        type: String
      },
      /**
       * Limit to the listed applications (comma seperated)
       */
      applicationList: {
        type: String
      },
      value: {
        type: Object
      }
    });
  }
  static get styles() {
    return [...super.styles, i$b(_templateObject$q || (_templateObject$q = _taggedTemplateLiteral$q(["\n\t\t\t:host(.can_link) #link_button {\n\t\t\t\tdisplay: initial;\n\t\t\t}\n\t\t\t#link_button {\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\tet2-link-entry {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t}\n\t\t\t.input-group__container {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t}\n\t\t\t.input-group {\n\t\t\t\tdisplay: flex;\n\t\t\t\twidth: 100%;\n\t\t\t\tgap: 0.5rem;\n\t\t\t}\n\t\t\t.input-group__before {\n\t\t\t\tdisplay: flex;\n\t\t\t\tgap: 0.5rem;\n\t\t\t}\n\t\t\t::slotted(.et2_file) {\n\t\t\t\twidth: 30px;\n\t\t\t}\n\t\t\t"])))];
  }

  // Still not sure what this does, but it's important.
  // Seems to be related to rendering and what's available "inside"
  static get scopedElements() {
    return _objectSpread$k(_objectSpread$k({}, super.scopedElements), {}, {
      'et2-button': Et2Button,
      'et2-link-entry': Et2LinkEntry
    });
  }
  constructor() {
    super();
    this.noFiles = false;
    this.handleFilesUploaded = this.handleFilesUploaded.bind(this);
    this.handleEntrySelected = this.handleEntrySelected.bind(this);
    this.handleEntryCleared = this.handleEntryCleared.bind(this);
    this.handleLinkButtonClick = this.handleLinkButtonClick.bind(this);
    this.handleLinkDeleted = this.handleLinkDeleted.bind(this);
  }
  firstUpdated() {
    // Add file buttons in
    // TODO: Replace when they're webcomponents
    this._fileButtons();
  }
  connectedCallback() {
    super.connectedCallback();
    this.getInstanceManager().DOMContainer.addEventListener("et2-delete", this.handleLinkDeleted);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.getInstanceManager().DOMContainer.removeEventListener("et2-delete", this.handleLinkDeleted);
  }

  /**
   * @return {TemplateResult}
   * @protected
   */
  _inputGroupInputTemplate() {
    return x$1(_templateObject2$e || (_templateObject2$e = _taggedTemplateLiteral$q(["\n            <et2-link-entry .onlyApp=\"", "\"\n                            .applicationList=\"", "\"\n                            .readonly=", "\n                            @sl-change=", "\n                            @sl-clear=\"", "\">\n            </et2-link-entry>\n            <et2-button id=\"link_button\" label=\"Link\" class=\"link\" .noSubmit=", "\n                        @click=", ">\n            </et2-button>\n\t\t"])), this.onlyApp, this.applicationList, this.readonly, this.handleEntrySelected, this.handleEntryCleared, true, this.handleLinkButtonClick);
  }

  // TODO: Replace when they're webcomponents
  _fileButtons() {
    if (this.noFiles) {
      return "";
    }

    // File upload
    //@ts-ignore IDE doesn't know about Et2WidgetClass
    var self = this;
    var file_attrs = {
      multiple: true,
      id: this.id + '_file',
      label: '',
      // Make the whole template a drop target
      drop_target: this.getInstanceManager().DOMContainer.getAttribute("id"),
      readonly: this.readonly,
      // Change to this tab when they drop
      onStart: function onStart(event, file_count) {
        // Find the tab widget, if there is one
        var tabs = self;
        do {
          tabs = tabs.getParent();
        } while (tabs != self.getRoot() && tabs.getType() != 'ET2-TABBOX');
        if (tabs != self.getRoot()) {
          tabs.activateTab(self);
        }
        return true;
      },
      onFinish: function onFinish(event, file_count) {
        // Auto-link uploaded files
        self.handleFilesUploaded(event);
      }
    };
    this.file_upload = et2_createWidget("file", file_attrs, this);
    this.file_upload.set_readonly(this.readonly);
    this.file_upload.getDOMNode().slot = "before";
    this.append(this.file_upload.getDOMNode());

    // Filemanager select
    var select_attrs = {
      button_label: egw$1.lang('Link'),
      button_caption: '',
      button_icon: 'link',
      readonly: this.readonly,
      dialog_title: egw$1.lang('Link'),
      extra_buttons: [{
        text: egw$1.lang("copy"),
        id: "copy",
        image: "copy"
      }, {
        text: egw$1.lang("move"),
        id: "move",
        image: "move"
      }],
      onchange: function onchange() {
        var values = true;
        // If entry not yet saved, store for linking on server
        if (!self.value.to_id || typeof self.value.to_id == 'object') {
          values = self.value.to_id || {};
          var files = this.getValue();
          if (typeof files !== 'undefined') {
            for (var i = 0; i < files.length; i++) {
              values['link:' + files[i]] = {
                app: 'link',
                id: files[i],
                type: 'unknown',
                icon: 'link',
                remark: '',
                title: files[i]
              };
            }
          }
        }
        self._link_result(values);
      }
    };
    // only set server-side callback, if we have a real application-id (not null or array)
    // otherwise it only gives an error on server-side
    if (self.value && self.value.to_id && typeof self.value.to_id != 'object') {
      select_attrs.method = 'EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_existing';
      select_attrs.method_id = self.value.to_app + ':' + self.value.to_id;
    }
    this.vfs_select = et2_createWidget("vfs-select", select_attrs, this);
    this.vfs_select.set_readonly(this.readonly);
    this.vfs_select.onchange = select_attrs.onchange;
    this.vfs_select.getDOMNode().slot = "before";
    this.append(this.vfs_select.getDOMNode());
  }

  /**
   * Create links
   *
   * Using current value for one end of the link, create links to the provided files or entries
   *
   * @param _links
   */
  createLink(_links) {
    var links;
    if (typeof _links == 'undefined') {
      links = [];
    } else {
      links = _links;
    }

    // If no link array was passed in, don't make the ajax call
    if (links.length > 0) {
      egw$1.request("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link", [this.value.to_app, this.value.to_id, links]).then(result => this._link_result(result));
    }
  }

  /**
   * Sent some links, server has a result
   *
   * @param {Object} success
   */
  _link_result(success) {
    if (success) {
      // Show some kind of success...

      // Reset
      this.resetAfterLink();

      // Server says it's OK, but didn't store - we'll send this again on submit
      // This happens if you link to something before it's saved to the DB
      if (typeof success == "object") {
        // Save as appropriate in value
        if (typeof this.value != "object") {
          this.value = {};
        }
        this.value.to_id = success;
        for (var link in success) {
          // Icon should be in registry
          if (typeof success[link].icon == 'undefined') {
            success[link].icon = egw$1.link_get_registry(success[link].app, 'icon');
            // No icon, try by mime type - different place for un-saved entries
            if (success[link].icon == false && success[link].id.type) {
              // Triggers icon by mime type, not thumbnail or app
              success[link].type = success[link].id.type;
              success[link].icon = true;
            }
          }
          // Special handling for file - if not existing, we can't ask for title
          if (success[link].app == 'file' && typeof success[link].title == 'undefined') {
            success[link].title = success[link].id.name || '';
          }
        }
      }

      // Send an event so listeners can update
      this.dispatchEvent(new CustomEvent("et2-change", {
        bubbles: true,
        detail: typeof success == "object" ? Object.values(success) : []
      }));
    } else {
      this.validators.push(new ManualMessage(this.egw().lang("failed")));
    }
    this.dispatchEvent(new CustomEvent('link.et2_link_to', {
      bubbles: true,
      detail: success
    }));
  }

  /**
   * A link was attempted.  Reset internal values to get ready for the next one.
   */
  resetAfterLink() {
    // Hide link button again
    this.classList.remove("can_link");
    this.link_button.image = "";

    // Clear internal
    delete this.value.app;
    delete this.value.id;

    // Clear file upload
    for (var file in this.file_upload.options.value) {
      delete this.file_upload.options.value[file];
    }
    this.file_upload.progress.empty();

    // Clear link entry
    this.select.value = {
      app: this.select.app,
      id: ""
    };
    this.select._searchNode.clearSearch();
    this.select._searchNode.select_options = [];
  }

  /**
   * Files have been uploaded (successfully), ready to link
   *
   * @param event
   * @protected
   */
  handleFilesUploaded(event) {
    this.classList.add("can_link");
    var links = [];

    // Get files from file upload widget
    var files = this.file_upload.get_value();
    for (var file in files) {
      links.push({
        app: 'file',
        id: file,
        name: files[file].name,
        type: files[file].type

        // Not sure what this is...
        /*
        	remark: jQuery("li[file='" + files[file].name.replace(/'/g, '&quot') + "'] > input", self.file_upload.progress)
        		.filter(function ()
        		{
        			return jQuery(this).attr("placeholder") != jQuery(this).val();
        		}).val()
         */
      });
    }

    this.createLink(links);
  }

  /**
   * An entry has been selected, ready to link
   *
   */
  handleEntrySelected(event) {
    // Could be the app, could be they selected an entry
    if (event.target == this.select._searchNode) {
      this.classList.add("can_link");
      this.link_button.focus();
    }
  }

  /**
   * An entry was selected, but instead of clicking "Link", the user cleared the selection
   */
  handleEntryCleared(event) {
    this.classList.remove("can_link");
  }
  handleLinkButtonClick(event) {
    this.link_button.image = "loading";
    var link_info = [];
    if (this.select.value) {
      var selected = this.select.value;
      // Extra complicated because LinkEntry doesn't always return a LinkInfo
      if (this.onlyApp) {
        selected = {
          app: this.onlyApp,
          id: selected
        };
      }
      link_info.push(selected);
    }
    this.createLink(link_info);
  }

  /**
   * Handle a link being removed
   *
   * Event is thrown every time a link is removed (from a LinkList) but we only care if the
   * entry hasn't been saved yet and has no ID.  In this case we've been keeping the list
   * to submit and link server-side so we have to remove the deleted link from our list.
   *
   * @param {CustomEvent} e
   */
  handleLinkDeleted(e) {
    if (e && e.detail && this.value && typeof this.value.to_id == "object") {
      delete this.value.to_id[e.detail.link_id || ""];
    }
  }
  get link_button() {
    return this.shadowRoot.querySelector("#link_button");
  }
  get select() {
    return this.shadowRoot.querySelector("et2-link-entry");
  }

  /**
   * Types of validation supported by this FormControl (for instance 'error'|'warning'|'info')
   *
   * @type {ValidationType[]}
   */
  static get validationTypes() {
    return ['error', 'success'];
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-link-to", Et2LinkTo);

var _templateObject$p, _templateObject2$d, _templateObject3$6, _templateObject4$2, _templateObject5$1, _templateObject6, _templateObject7, _templateObject8, _templateObject9;
function _taggedTemplateLiteral$p(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$Y(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2ColumnSelection extends Et2InputWidget(s$5) {
  static get styles() {
    return [super.styles, shoelace, i$b(_templateObject$p || (_templateObject$p = _taggedTemplateLiteral$p(["\n\t\t\t:host {\n\t\t\t\tmax-height: inherit;\n\t\t\t\tmin-width: 35em;\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-direction: column;\n\t\t\t\tflex: 1 1 auto;\n\t\t\t\t--icon-width: 20px;\n\t\t\t}\n\t\t\tsl-menu {\n\t\t\t\tflex: 1 10 auto;\n\t\t\t\toverflow-y: auto;\n\t\t\t\tmax-height: 50em;\n\t\t\t}\n\t\t\t/* Drag handle on columns (not individual custom fields or search letter) */\n\t\t\tsl-menu > .select_row::part(base) {\n\t\t\t\tpadding-left: 10px;\n\t\t\t}\n\t\t\tsl-menu > .column::part(base) {\n\t\t\t\tbackground-image: ", ";\n\t\t\t\tbackground-position: 3px 1.5ex;\n\t\t\t\tbackground-repeat: no-repeat;\n\t\t\t\tcursor: grab;\n\t\t\t}\n\n\t\t\t  sl-menu-item::part(label), sl-menu-item::part(submenu-icon) {\n\t\t\t\tcursor: initial;\n\t\t\t  }\n\t\t\t/* Change vertical alignment of CF checkbox line to up with title, not middle */\n\t\t\t.custom_fields::part(base) {\n\t\t\t\talign-items: baseline;\n\t\t\t}\n\t\t\t"])), cssImage("splitter_vert"))];
  }
  static get properties() {
    return {
      /**
       * List of currently selected columns
       */
      value: {
        type: Object
      },
      columns: {
        type: Object
      },
      autoRefresh: {
        type: Number
      }
    };
  }
  constructor() {
    super(...arguments);
    _defineProperty$Y(this, "__columns", []);
    _defineProperty$Y(this, "__autoRefresh", false);
    _defineProperty$Y(this, "sort", void 0);
    this.handleSelectAll = this.handleSelectAll.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateComplete.then(() => {
      this.sort = Sortable.create(this.shadowRoot.querySelector('sl-menu'), {
        ghostClass: 'ui-fav-sortable-placeholder',
        draggable: 'sl-menu-item.column',
        dataIdAttr: 'value',
        direction: 'vertical',
        delay: 25
      });
    });
  }
  render() {
    return x$1(_templateObject2$d || (_templateObject2$d = _taggedTemplateLiteral$p(["\n            <sl-icon slot=\"header\" name=\"check-all\" @click=", "\n                     title=\"", "\"\n                     style=\"font-size:24px\"></sl-icon>\n            <sl-menu part=\"columns\" slot=\"content\">\n                ", "\n            </sl-menu>"])), this.handleSelectAll, this.egw().lang("Select all"), c$2(this.__columns, column => column.id, column => this.rowTemplate(column)));
  }
  footerTemplate() {
    var autoRefresh = x$1(_templateObject3$6 || (_templateObject3$6 = _taggedTemplateLiteral$p(["\n            <et2-select id=\"nm_autorefresh\" emptyLabel=\"Refresh\" statustext=\"Automatically refresh list\"\n                        value=\"", "\">\n            </et2-select>\n\t\t"])), this.__autoRefresh);
    // Add default checkbox for admins
    var apps = this.egw().user('apps');
    return x$1(_templateObject4$2 || (_templateObject4$2 = _taggedTemplateLiteral$p(["\n            ", "\n            ", "\n\t\t"])), this.__autoRefresh !== "false" ? autoRefresh : '', !apps['admin'] ? '' : x$1(_templateObject5$1 || (_templateObject5$1 = _taggedTemplateLiteral$p(["\n                <et2-select id=\"default_preference\" emptylabel=\"", "\">\n                </et2-select>"])), this.egw().lang("Preference")));
  }

  /**
   * Template for each individual column
   *
   * @param column
   * @returns {TemplateResult}
   * @protected
   */
  rowTemplate(column) {
    var _column$widget;
    var isCustom = ((_column$widget = column.widget) === null || _column$widget === void 0 ? void 0 : _column$widget.instanceOf(et2_nextmatch_customfields)) || false;
    var alwaysOn = [et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS, et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT].indexOf(column.visibility) !== -1;

    // Don't show disabled columns
    if (column.visibility == et2_dataview_column.ET2_COL_VISIBILITY_DISABLED) {
      return x$1(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral$p([""])));
    }
    return x$1(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral$p(["\n            <sl-menu-item\n                    value=\"", "\"\n                    type=\"checkbox\"\n                    ?checked=", "\n                    ?disabled=", "\n                    title=\"", "\"\n                    class=\"", "\">\n                ", "\n                <!-- Custom fields get listed separately -->\n                ", "\n            </sl-menu-item>"])), column.id.replaceAll(" ", "___"), alwaysOn || column.visibility == et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE, alwaysOn, column.title, o$9({
      select_row: true,
      custom_fields: isCustom,
      column: column.widget
    }), column.caption, isCustom ? this.customFieldsTemplate(column) : '');
  }

  /**
   * Template for all custom fields
   * Does not include "Custom fields", it's done as a regular column
   *
   * @param column
   * @returns {TemplateResult}
   * @protected
   */
  customFieldsTemplate(column) {
    // Custom fields get listed separately
    var widget = column.widget;
    if (jQuery.isEmptyObject(widget.customfields)) {
      // No customfields defined, don't show column
      return x$1(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral$p([""])));
    }
    return x$1(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral$p(["\n            <sl-divider></sl-divider>\n            ", "\n            <sl-divider></sl-divider>"])), c$2(Object.values(widget.customfields), field => field.name, field => {
      return this.rowTemplate({
        id: et2_customfields_list.PREFIX + field.name,
        caption: field.label,
        visibility: widget.fields[field.name] ? et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE : false
      });
    }));
  }
  handleSelectAll(event) {
    var checked = this.shadowRoot.querySelector("sl-menu-item").checked || false;
    this.shadowRoot.querySelectorAll('sl-menu-item').forEach(item => {
      item.checked = !checked;
    });
  }
  set columns(new_columns) {
    this.__columns = new_columns;
    this.requestUpdate();
  }
  get value() {
    var _this$sort, _this$shadowRoot;
    var value = [];
    (_this$sort = this.sort) === null || _this$sort === void 0 || _this$sort.toArray().forEach(val => {
      var column = this.__columns.find(col => col.id == val);
      var menuItem = this.shadowRoot.querySelector("[value='" + val + "']");
      if (column && menuItem) {
        var _column$widget2;
        if (menuItem.checked) {
          value.push(val);
        }
        if ((_column$widget2 = column.widget) !== null && _column$widget2 !== void 0 && _column$widget2.customfields) {
          menuItem.querySelectorAll("[value][checked]").forEach(cf => {
            value.push(cf.value.replaceAll("___", " "));
          });
        }
      }
    });

    // Add in letters
    (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 || _this$shadowRoot.querySelectorAll("[part='columns'] > :not(.column)").forEach(i => {
      if (i.checked) {
        value.push(i.value);
      }
    });
    return value;
  }
  set value(new_value) {
    // TODO?  Only here to avoid error right now
  }
  get _autoRefreshNode() {
    var _this$shadowRoot2;
    return (_this$shadowRoot2 = this.shadowRoot) === null || _this$shadowRoot2 === void 0 ? void 0 : _this$shadowRoot2.querySelector("#nm_autorefresh");
  }
  get _preferenceNode() {
    return this.shadowRoot.querySelector("#default_preference");
  }
  get autoRefresh() {
    var _this$_autoRefreshNod;
    return parseInt((_this$_autoRefreshNod = this._autoRefreshNode) === null || _this$_autoRefreshNod === void 0 ? void 0 : _this$_autoRefreshNod.value.toString()) || 0;
  }
  set autoRefresh(new_value) {
    this.__autoRefresh = new_value;
    this.requestUpdate("autoRefresh");
  }
}
customElements.define("et2-nextmatch-columnselection", Et2ColumnSelection);

function _defineProperty$X(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * EGroupware eTemplate2 - SelectAccountMixin
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 */
/**
 * Common code for editable & read-only select account
 * Moved out so we don't have copy+paste code in both
 */
var SelectAccountMixin = superclass => {
  class SelectAccount extends superclass {
    constructor() {
      super();
      /**
       * Hold on to accounts we had to fetch from the server
       * @type {any[]}
       * @protected
       */
      _defineProperty$X(this, "account_options", []);
      this.account_options = [];
    }

    /**
     * If the value has an account that's not already in the list, check with the server.
     * We probably don't have all the accounts client side.  This is similar to freeEntries,
     * but a little safer because we don't allow just anything.
     *
     * @param {any} new_value
     */
    set value(new_value) {
      super.value = new_value;
      if (!new_value) {
        return;
      }
      var val = Array.isArray(this.value) ? this.value : [this.value];
      if (this.isConnected) {
        this._find_options(val);
      } else {
        // If not already connected, wait until any provided select_options have been found
        this.updateComplete.then(() => {
          this._find_options(val);
          this.requestUpdate('select_options');
        });
      }
    }

    /**
     * OVerridden to do nothing, we handle it differently in _find_options()
     * @param {string} newValueElement
     * @protected
     */
    _missingOption(newValueElement) {}
    _find_options(val) {
      var _this = this;
      var _loop = function _loop(id) {
        // Don't add if it's already there
        if (_this.select_options.findIndex(o => o.value == id) != -1) {
          return 1; // continue
        }
        var account_name = null;
        var tempLabel = id + " ...";
        var option = {
          value: "" + id,
          label: tempLabel
        };
        _this.account_options.push(option);
        if (_this.value && (account_name = _this.egw().link_title('api-accounts', id, false))) {
          option.label = account_name;
        } else if (!account_name) {
          // Not already cached, need to fetch it
          _this.egw().link_title('api-accounts', id, true).then(title => {
            var _this$select;
            option.label = title || '';
            _this.requestUpdate();
            _this.account_options.sort(_this.optionSort);
            // Directly update if it's already there
            var slOption = (_this$select = _this.select) === null || _this$select === void 0 ? void 0 : _this$select.querySelector('[value="' + id + '"]');
            if (slOption) {
              // Replace instead of changing the whole thing to preserve LitElement marker comments
              slOption.textContent.replace(tempLabel, title);
              _this.select.requestUpdate("value");
            }
          });
        }
      };
      for (var id of val) {
        if (_loop(id)) continue;
      }
      this.account_options.sort(this.optionSort);
    }
    get value() {
      return super.value;
    }
    get select_options() {
      return [...new Map([...this.account_options, ...(super.select_options || [])].map(item => [item.value, item])).values()].sort(this.optionSort);
    }
    set select_options(value) {
      super.select_options = value;
    }

    /**
     * Sort options
     * @param a
     * @param b
     * @returns {number}
     * @protected
     */
    optionSort(a, b) {
      // Sort accounts before groups, then by label
      var int_a = 0;
      var int_b = 0;
      if (typeof a.value === "string") {
        var _parseInt;
        int_a = (_parseInt = parseInt(a.value)) !== null && _parseInt !== void 0 ? _parseInt : 0;
      }
      if (typeof b.value === "string") {
        var _parseInt2;
        int_b = (_parseInt2 = parseInt(b.value)) !== null && _parseInt2 !== void 0 ? _parseInt2 : 0;
      }
      if (int_a < 0 && int_b < 0 || int_a > 0 && int_b > 0) {
        return ('' + a.label).localeCompare(b.label);
      }
      // Accounts before groups
      return int_b - int_a;
    }
  }
  return SelectAccount;
};

var _templateObject$o;
function _taggedTemplateLiteral$o(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$j(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$j(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$j(Object(source), true).forEach(function (key) { _defineProperty$W(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$j(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$W(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * @customElement et2-select-account
 */
class Et2SelectAccount extends SelectAccountMixin(Et2StaticSelectMixin(Et2Select)) {
  static get properties() {
    return _objectSpread$j(_objectSpread$j({}, super.properties), {}, {
      /**
       * One of: 'accounts','groups','both','owngroups'
       */
      accountType: String
    });
  }
  constructor() {
    super();

    // all types can search the server.  If there are a lot of accounts, local list will
    // not be complete
    if (this.egw().preference('account_selection', 'common') !== 'none') {
      this.searchUrl = "EGroupware\\Api\\Etemplate\\Widget\\Taglist::ajax_search";
    }
    this.searchOptions = {
      type: 'account',
      account_type: 'accounts'
    };
    this.__accountType = 'accounts';
  }
  connectedCallback() {
    super.connectedCallback();

    // Start fetch of select_options
    this.fetchComplete = this._getAccounts();
  }

  /**
   * Pre-fill the account list according to type & preferences
   *
   * @protected
   * @internal
   */
  _getAccounts() {
    var type = this.egw().preference('account_selection', 'common');
    var fetch = [];
    var process = options => {
      // Shallow copy to avoid re-using the same object.
      // Uses more memory, but otherwise multiple selectboxes get "tied" together
      var cleaned = cleanSelectOptions(options)
      // slice to avoid problems with lots of accounts
      .slice(0, /* Et2WidgetWithSearch.RESULT_LIMIT */100);
      this.account_options = this.account_options.concat(cleaned);
    };
    // for primary_group we only display owngroups == own memberships, not other groups
    if (type === 'primary_group' && this.accountType !== 'accounts') {
      if (this.accountType === 'both') {
        fetch.push(this.egw().accounts('accounts').then(process));
      }
      fetch.push(this.egw().accounts('owngroups').then(process));
    } else if (type !== "none") {
      fetch.push(this.egw().accounts(this.accountType).then(process));
    }
    return Promise.all(fetch).then(() => {
      this.requestUpdate("select_options");
      this.value = this.value;
    });
  }
  set accountType(type) {
    this.__accountType = type;
    this.searchOptions.account_type = type;
    super.select_options = this.select_options;
  }
  get accountType() {
    return this.__accountType;
  }

  /**
   * Get account info for select options from common client-side account cache
   */
  get select_options() {
    var type = this.egw().preference('account_selection', 'common');
    if (type === 'none' && typeof this.egw().user('apps').admin === 'undefined') {
      return [];
    }
    return super.select_options;
  }
  set select_options(new_options) {
    super.select_options = new_options;
  }

  /**
   * Override filter to not, since we don't have all accounts available
   */
  filterOutMissingOptions(value) {
    return value;
  }

  /**
   * Override icon for the select option
   *
   * @param option
   * @protected
   */
  _iconTemplate(option) {
    // lavatar uses a size property, not a CSS variable
    var style = getComputedStyle(this);
    return x$1(_templateObject$o || (_templateObject$o = _taggedTemplateLiteral$o(["\n            <et2-lavatar slot=\"prefix\" part=\"icon\" exportparts=\"image\" .size=", "\n                         lname=", "\n                         fname=", "\n                         image=", "\n            >\n            </et2-lavatar>"])), style.getPropertyValue("--icon-width"), option.lname || A$1, option.fname || A$1, option.icon || A$1);
  }
}
customElements.define("et2-select-account", Et2SelectAccount);

function _defineProperty$V(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Export the Interface for TypeScript

/**
 * Base class for things that do filter type behaviour in nextmatch header
 * Separated to keep things a little simpler.
 *
 * Currently I assume we're extending an Et2Select, so changes may need to be made for better abstraction
 */
var FilterMixin = superclass => class extends superclass {
  constructor() {
    super(...arguments);
    _defineProperty$V(this, "nextmatch", void 0);
  }
  /**
   * Override to add change handler
   *
   */
  connectedCallback() {
    super.connectedCallback();

    // Make sure there's an option for all
    if (!this.emptyLabel && Array.isArray(this.select_options) && !this.select_options.find(o => o.value == "")) {
      this.emptyLabel = this.label ? this.label : egw$1.lang("All");
    }
    this.handleChange = this.handleChange.bind(this);

    // Bind late, maybe that helps early change triggers?
    this.updateComplete.then(() => {
      this.addEventListener("change", this.handleChange);
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("change", this.handleChange);
  }
  handleChange(event) {
    if (typeof this.nextmatch == 'undefined') {
      // Not fully set up yet
      return;
    }
    var col_filter = {};
    col_filter[this.id] = this.value;
    this.nextmatch.applyFilters({
      col_filter: col_filter
    });
  }

  /**
   * Set nextmatch is the function which has to be implemented for the
   * et2_INextmatchHeader interface.
   *
   * @param {et2_nextmatch} _nextmatch
   */
  setNextmatch(_nextmatch) {
    this.nextmatch = _nextmatch;

    // Set current filter value from nextmatch settings
    if (this.nextmatch.activeFilters.col_filter && this.nextmatch.activeFilters.col_filter[this.id]) {
      this.set_value(this.nextmatch.activeFilters.col_filter[this.id]);
    }
  }
};

/**
 * Filter by account
 */
class Et2AccountFilterHeader extends FilterMixin(Et2SelectAccount) {
  constructor() {
    super();
    this.hoist = true;
    this.clearable = true;
  }
}
customElements.define("et2-nextmatch-header-account", Et2AccountFilterHeader);

var _templateObject$n;
function _taggedTemplateLiteral$n(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$i(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$i(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$i(Object(source), true).forEach(function (key) { _defineProperty$U(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$i(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$U(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Filter by some other type of widget
 * Acts as a wrapper around the other widget, but handles all the nm stuff here
 * Any attributes set are passed to the filter widget
 */
class Et2CustomFilterHeader extends FilterMixin(Et2InputWidget(s$5)) {
  static get properties() {
    return _objectSpread$i(_objectSpread$i({}, super.properties), {}, {
      /**
       * tag of widget we want to use to filter
       */
      widgetType: {
        type: String
      },
      /**
       * Attributes / properties used for the filter widget
       */
      widgetOptions: {
        type: Object
      }
    });
  }
  constructor() {
    super();
    _defineProperty$U(this, "widgetType", void 0);
    _defineProperty$U(this, "widgetOptions", void 0);
    _defineProperty$U(this, "filter_node", void 0);
    this.widgetType = "et2-description";
    this.widgetOptions = {};
  }
  transformAttributes(attrs) {
    var _this$getArrayMgr$get;
    super.transformAttributes(attrs);
    var widgetType = ((_this$getArrayMgr$get = this.getArrayMgr("modifications").getEntry(this.id)) === null || _this$getArrayMgr$get === void 0 ? void 0 : _this$getArrayMgr$get.widgetType) || attrs.widgetType || "";
    switch (widgetType) {
      case "link-entry":
        this.widgetType = 'et2-nextmatch-header-entry';
        break;
      default:
        this.widgetType = widgetType;
        // Prefer webcomponent, if legacy type was sent
        if (window.customElements.get("et2-" + this.widgetType)) {
          this.widgetType = "et2-" + this.widgetType;
        }
    }
    if (!window.customElements.get(this.widgetType)) {
      console.error("Unknown widget type '%s'", this.widgetType);
      this.widgetType = 'et2-select';
    }
    // @ts-ignore TS doesn't know about this.getParent()
    this.filter_node = loadWebComponent(this.widgetType, _objectSpread$i(_objectSpread$i({}, attrs), this.widgetOptions), this);
    if (this.filter_node instanceof Et2Select) {
      this.filter_node.hoist = true;
      this.filter_node.clearable = true;
    }
  }
  connectedCallback() {
    super.connectedCallback();
    if (this.filter_node) {
      this.filter_node.updateComplete.then(() => {
        this.filter_node.addEventListener("change", this.handleChange);
      });
    }
  }

  /**
   * New filter options from server
   * @param new_options
   */
  set_select_options(new_options) {
    var _this$filter_node;
    var widget_class = window.customElements.get((_this$filter_node = this.filter_node) === null || _this$filter_node === void 0 ? void 0 : _this$filter_node.localName);
    var property = widget_class.getPropertyOptions('select_options');
    if (this.filter_node && property) {
      this.filter_node.select_options = cleanSelectOptions(new_options);
    }
  }
  render() {
    return x$1(_templateObject$n || (_templateObject$n = _taggedTemplateLiteral$n(["\n            <slot></slot>"])));
  }
  get value() {
    var _this$filter_node2;
    return ((_this$filter_node2 = this.filter_node) === null || _this$filter_node2 === void 0 ? void 0 : _this$filter_node2.value) || undefined;
  }
  set value(new_value) {
    if (this.filter_node) {
      this.filter_node.value = new_value;
    }
  }
}
customElements.define("et2-nextmatch-header-custom", Et2CustomFilterHeader);

/**
 * Filter using a selected entry
 */
class Et2EntryFilterHeader extends FilterMixin(Et2LinkEntry) {
  /**
   * Override to always return a string appname:id (or just id) for simple (one real selection)
   * cases, parent returns an object.  If multiple are selected, or anything other than app and
   * id, the original parent value is returned.
   */
  get value() {
    var value = super.value;
    if (typeof value == "object" && value != null) {
      if (!value.app || !value.id) {
        return null;
      }

      // If simple value, format it legacy string style, otherwise
      // we return full value
      if (typeof value.id == 'string') {
        value = value.app + ":" + value.id;
      }
    }
    return value;
  }
  set value(new_value) {
    super.value = new_value;
  }
}
customElements.define("et2-nextmatch-header-entry", Et2EntryFilterHeader);

/**
 * Filter from a provided list of options
 */
class Et2FilterHeader extends FilterMixin(Et2Select) {
  constructor() {
    super(...arguments);
    this.hoist = true;
    this.clearable = true;
  }
}
customElements.define("et2-nextmatch-header-filter", Et2FilterHeader);

var _dec$1, _dec2, _class$2, _descriptor$1, _templateObject$m, _templateObject2$c, _templateObject3$5, _templateObject4$1;
function _initializerDefineProperty$1(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _taggedTemplateLiteral$m(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$T(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor$1(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper$1(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }
/**
 * A selectbox that shows more than one row at a time
 *
 * Set rows attribute to adjust how many rows are visible at once
 *
 * Use Et2Selectbox in most cases, it's better.
 */
var Et2Listbox = (_dec$1 = e$c({
  type: Boolean,
  reflect: true
}), _dec2 = e$c(), (_class$2 = class Et2Listbox extends RowLimitedMixin(Et2WidgetWithSelectMixin(s$5)) {
  static get styles() {
    return [
    // Parent (SlMenu) returns a single cssResult, not an array
    shoelace, super.styles, i$b(_templateObject$m || (_templateObject$m = _taggedTemplateLiteral$m(["\n\t\t\t:host {\n\t\t\t\tdisplay: block;\n\t\t\t\tflex: 1 0 auto;\n\t\t\t\t--icon-width: 20px;\n\t\t\t}\n\t\t\t\n\t\t\t::slotted(img), img {\n\t\t\t\tvertical-align: middle;\n\t\t\t}\n\t\t\t\n\t\t\t.menu {\n\t\t\t\t/* Get rid of padding before/after options */\n\t\t\t\tpadding: 0px;\n\t\t\t\n\t\t\t\t/* No horizontal scrollbar, even if options are long */\n\t\t\t\toverflow-x: clip;\n\t\t\t}\n\t\t\t/* Ellipsis when too small */\n\n\t\t\t  sl-option.option__label {\n\t\t\t\tdisplay: block;\n    \t\t\ttext-overflow: ellipsis;\n    \t\t\t/* This is usually not used due to flex, but is the basis for ellipsis calculation */\n    \t\t\twidth: 10ex;\n\t\t\t}\n\n\t\t\t  :host([rows]) .menu {\n\t\t\t\theight: calc(var(--rows, 5) * 1.9rem);\n\t\t\t\toverflow-y: auto;\n\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super();
    _initializerDefineProperty$1(this, "multiple", _descriptor$1, this);
    _defineProperty$T(this, "__value", void 0);
    this.handleSelect = this.handleSelect.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    this.addEventListener("sl-select", this.handleSelect);
    this.updateComplete.then(() => {
      this.addEventListener("sl-change", this._triggerChange);
    });
  }
  getAllItems() {
    var _ref, _this$shadowRoot;
    return (_ref = Array.from((_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelectorAll('sl-menu-item'))) !== null && _ref !== void 0 ? _ref : [];
  }

  /**
   * Handle an item was selected
   *
   * Toggle the checkmark and fire the changed event
   *
   * @param {MouseEvent} event
   */
  handleSelect(event) {
    var _event$detail;
    var item = (_event$detail = event.detail) === null || _event$detail === void 0 ? void 0 : _event$detail.item;
    if (!item) {
      return;
    }
    if (!this.multiple) {
      this.getAllItems().forEach(i => i.checked = false);
      item.checked = true;
    } else {
      item.checked = !item.checked;
    }
    this.dispatchEvent(new Event("change"));
  }
  get value() {
    var _this$__value;
    var value = this.hasUpdated ? this.getAllItems().filter(item => item.checked).map(item => item.value) : (_this$__value = this.__value) !== null && _this$__value !== void 0 ? _this$__value : [];
    return this.multiple ? value : value.pop();
  }
  set value(new_value) {
    var oldValue = this.value;
    if (typeof new_value == "string") {
      new_value = [new_value];
    }
    this.__value = new_value;
    this.requestUpdate("value", oldValue);
  }
  _optionTemplate(option) {
    var icon = option.icon ? x$1(_templateObject2$c || (_templateObject2$c = _taggedTemplateLiteral$m(["\n            <et2-image slot=\"prefix\" part=\"icon\" style=\"width: var(--icon-width)\"\n                       src=\"", "\"></et2-image>"])), option.icon) : "";
    var checked = this.__value == null ? option.value === this.value || this.multiple && this.value.indexOf(option.value) >= 0 : this.__value.indexOf(option.value) >= 0;

    // Tag used must match this.optionTag, but you can't use the variable directly.
    // Pass option along so SearchMixin can grab it if needed
    return x$1(_templateObject3$5 || (_templateObject3$5 = _taggedTemplateLiteral$m(["\n            <sl-menu-item\n                    value=\"", "\"\n                    title=\"", "\"\n                    class=\"", "\" .option=", "\n                    type=\"checkbox\"\n                    ?checked=", "\n            >\n                ", "\n                ", "\n            </sl-menu-item>"])), option.value, !option.title || this.noLang ? option.title : this.egw().lang(option.title), option.class, option, checked, icon, this.noLang ? option.label : this.egw().lang(option.label));
  }
  render() {
    return x$1(_templateObject4$1 || (_templateObject4$1 = _taggedTemplateLiteral$m(["\n            <sl-menu class=\"menu\">\n                ", "\n            </sl-menu>\n\t\t"])), c$2(this.select_options, o => o.value, option => this._optionTemplate(option)));
  }
}, (_descriptor$1 = _applyDecoratedDescriptor$1(_class$2.prototype, "multiple", [_dec$1], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor$1(_class$2.prototype, "value", [_dec2], Object.getOwnPropertyDescriptor(_class$2.prototype, "value"), _class$2.prototype)), _class$2));
customElements.define("et2-listbox", Et2Listbox);

class Et2SelectApp extends Et2StaticSelectMixin(Et2Select) {
  connectedCallback() {
    super.connectedCallback();
    this.fetchComplete = StaticOptions.app(this, {}).then(options => {
      this.set_static_options(cleanSelectOptions(options));
    });
  }
}
customElements.define("et2-select-app", Et2SelectApp);

class Et2SelectBitwise extends Et2StaticSelectMixin(Et2Select) {
  /* currently handled server-side */
  /*
  set value(new_value)
  {
  	let oldValue = this._value;
  	let expanded_value = [];
  	let options = this.select_options;
  	for(let index in options)
  	{
  		let right = parseInt(options[index].value);
  		if(!!(new_value & right))
  		{
  			expanded_value.push(right);
  		}
  	}
  	super.value = expanded_value;
  }
  */
}
customElements.define("et2-select-bitwise", Et2SelectBitwise);

class Et2SelectBool extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    super();
    this._static_options = StaticOptions.bool(this);
  }
  get value() {
    return super.value;
  }

  /**
   * Boolean option values are "0" and "1", so change boolean to those
   * @param {string | string[]} new_value
   */
  set value(new_value) {
    super.value = new_value ? "1" : "0";
  }
}
customElements.define("et2-select-bool", Et2SelectBool);

var _templateObject$l, _templateObject2$b, _templateObject3$4;
function asyncGeneratorStep$3(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$3(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$3(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$3(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$h(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$h(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$h(Object(source), true).forEach(function (key) { _defineProperty$S(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$h(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$S(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$l(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Customised Select widget for categories
 * This widget gives us category colors and icons in the options and selected value.
 */
class Et2SelectCategory extends Et2StaticSelectMixin(Et2Select) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$l || (_templateObject$l = _taggedTemplateLiteral$l(["\n\t\t\t/* Category color on options */\n\n\t\t\t  sl-option {\n\t\t\t\tborder-left: 6px solid var(--category-color, transparent);\n\t\t\t}\n\t\t\t/* Border on the (single) selected value */\n\n\t\t\t  :host(:not([multiple]))::part(combobox) {\n\t\t\t\tborder-left: 6px solid var(--category-color, var(--sl-input-border-color));\n\t\t\t}\t\t\t\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$h(_objectSpread$h({}, super.properties), {}, {
      /**
       * Include global categories
       */
      globalCategories: {
        type: Boolean
      },
      /**
       * Show categories from this application.  If not set, will be the current application
       */
      application: {
        type: String
      },
      /**
       * Show categories below this parent category
       */
      parentCat: {
        type: Number
      }
    });
  }
  constructor() {
    super();
    // we should not translate categories name
    this.noLang = true;
  }
  connectedCallback() {
    var _superprop_getConnectedCallback = () => super.connectedCallback,
      _this = this;
    return _asyncToGenerator$3(function* () {
      _superprop_getConnectedCallback().call(_this);
      if (typeof _this.application == 'undefined') {
        _this.application =
        // When the widget is first created, it doesn't have a parent and can't find it's instanceManager
        _this.getInstanceManager() && _this.getInstanceManager().app || _this.egw().app_name();
      }
    })();
  }
  willUpdate(changedProperties) {
    super.willUpdate(changedProperties);
    if (changedProperties.has("global_categories") || changedProperties.has("application") || changedProperties.has("parentCat")) {
      this.fetchComplete = StaticOptions.cat(this).then(options => {
        this._static_options = cleanSelectOptions(options);
        this.requestUpdate("select_options");

        // Shoelace select has rejected our value due to missing option by now, so re-set it
        this.updateComplete.then(() => {
          this.value = this.value;
        });
      });
    }
  }
  handleValueChange(e) {
    super.handleValueChange(e);

    // Just re-draw to get the colors & icon
    this.requestUpdate();
  }

  /**
   * Custom, dynamic styling
   *
   * CSS variables are not making it through to options, re-declaring them here works
   *
   * @returns {TemplateResult}
   * @protected
   */
  _styleTemplate() {
    return x$1(_templateObject2$b || (_templateObject2$b = _taggedTemplateLiteral$l(["\n            <style>\n                ", "\n            </style>\n\t\t"])), c$2(this.select_options, option => {
      if (typeof option.color == "undefined" || !option.color) {
        return A$1;
      }
      return r$7((this.getValueAsArray().includes(option.value) ? "::part(combobox) { --category-color: " + option.color + ";}" : "") + ".cat_" + option.value + " {--category-color: " + option.color + ";}");
    }));
  }

  /**
   * Use a custom tag for when multiple=true
   *
   * @returns {string}
   */
  get tagTag() {
    return i$9(_templateObject3$4 || (_templateObject3$4 = _taggedTemplateLiteral$l(["et2-category-tag"])));
  }
}
customElements.define("et2-select-cat", Et2SelectCategory);

var _templateObject$k;
function _taggedTemplateLiteral$k(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$g(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$g(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$g(Object(source), true).forEach(function (key) { _defineProperty$R(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$g(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$R(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Customised Select widget for countries
 * This widget uses CSS from api/templates/default/css/flags.css to set flags
 */
egw$1(window).includeCSS("api/templates/default/css/flags.css");
class Et2SelectCountry extends Et2StaticSelectMixin(Et2Select) {
  static get properties() {
    return _objectSpread$g(_objectSpread$g({}, super.properties), {}, {
      /* Reflect the value so we can use CSS selectors */
      value: {
        type: String,
        reflect: true
      }
    });
  }
  constructor() {
    super();
    this.search = true;
    this.fetchComplete = StaticOptions.country(this, {}, true).then(options => {
      this._static_options = options;
      this.requestUpdate("select_options");
    });
  }
  connectedCallback() {
    super.connectedCallback();
  }

  /**
   * Get the element for the flag
   *
   * @param option
   * @protected
   */
  _iconTemplate(option) {
    return x$1(_templateObject$k || (_templateObject$k = _taggedTemplateLiteral$k(["\n            <span slot=\"prefix\" part=\"flag country_", "_flag\"\n                  style=\"width: var(--icon-width)\">\n\t\t\t</span>"])), option.value);
  }

  /**
   * Used to render each option into the select
   * Override to get flags in
   *
   * @param {SelectOption} option
   * @returns {TemplateResult}
   *
  protected _optionTemplate(option : SelectOption) : TemplateResult
  {
  	// Exclude non-matches when searching
  	if(typeof option.isMatch == "boolean" && !option.isMatch)
  	{
  		return html``;
  	}
  		return html`
             <sl-option
                     part="option"
                     value="${value}"
                     title="${!option.title || this.noLang ? option.title : this.egw().lang(option.title)}"
                     class="${option.class}" .option=${option}
                     .selected=${this.getValueAsArray().some(v => v == value)}
                     ?disabled=${option.disabled}
             >
                 ${this._iconTemplate(option)}
                 ${this.noLang ? option.label : this.egw().lang(option.label)}
             </sl-option>`;
  }
   */
}

customElements.define("et2-select-country", Et2SelectCountry);

class Et2SelectDay extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    super();
    this._static_options = StaticOptions.day(this, {});
  }
}
customElements.define("et2-select-day", Et2SelectDay);

class Et2SelectDayOfWeek extends Et2StaticSelectMixin(Et2Select) {
  connectedCallback() {
    super.connectedCallback();

    // Wait for connected instead of constructor because attributes make a difference in
    // which options are offered
    this.fetchComplete = StaticOptions.dow(this, {
      other: this.other || []
    }).then(options => {
      this.set_static_options(cleanSelectOptions(options));
    });
  }
  set value(new_value) {
    var expanded_value = typeof new_value == "object" ? new_value : [];
    if (new_value && (typeof new_value == "string" || typeof new_value == "number")) {
      var int_value = parseInt(new_value);
      this.updateComplete.then(() => {
        this.fetchComplete.then(() => {
          var options = this.select_options;
          for (var index in options) {
            var right = parseInt(options[index].value);
            if ((int_value & right) == right) {
              expanded_value.push("" + right);
            }
          }
          super.value = expanded_value;
        });
      });
      return;
    }
    super.value = expanded_value;
  }
  get value() {
    return super.value;
  }
}
customElements.define("et2-select-dow", Et2SelectDayOfWeek);

class Et2SelectHour extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    super();
    this._static_options = StaticOptions.hour(this, {
      other: this.other || []
    });
  }
}
customElements.define("et2-select-hour", Et2SelectHour);

class Et2SelectLang extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    super();
    this._static_options = StaticOptions.lang(this, {
      other: this.other || []
    });
  }
}
customElements.define("et2-select-lang", Et2SelectLang);

class Et2SelectMonth extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    super();
    this._static_options = StaticOptions.month(this);
  }
}
customElements.define("et2-select-month", Et2SelectMonth);

function ownKeys$f(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$f(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$f(Object(source), true).forEach(function (key) { _defineProperty$Q(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$f(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$Q(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2SelectNumber extends Et2StaticSelectMixin(Et2Select) {
  static get properties() {
    return _objectSpread$f(_objectSpread$f({}, super.properties), {}, {
      /**
       * Step between numbers
       */
      interval: {
        type: Number
      },
      min: {
        type: Number
      },
      max: {
        type: Number
      },
      /**
       * Add one or more leading zeros
       * Set to how many zeros you want (000)
       */
      leading_zero: {
        type: String
      },
      /**
       * Appended after every number
       */
      suffix: {
        type: String
      }
    });
  }
  constructor() {
    super();
    this.min = 1;
    this.max = 10;
    this.interval = 1;
    this.leading_zero = "";
    this.suffix = "";
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has('min') || changedProperties.has('max') || changedProperties.has('interval') || changedProperties.has('suffix')) {
      this._static_options = StaticOptions.number(this);
      this.requestUpdate("select_options");
    }
  }
}
customElements.define("et2-select-number", Et2SelectNumber);

class Et2SelectPercent extends Et2SelectNumber {
  constructor() {
    super();
    this.min = 0;
    this.max = 100;
    this.interval = 10;
    this.suffix = "%%";
  }
}
customElements.define("et2-select-percent", Et2SelectPercent);

class Et2SelectPriority extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    super();
    this._static_options = StaticOptions.priority(this);
  }
}
customElements.define("et2-select-priority", Et2SelectPriority);

var _templateObject$j, _templateObject2$a, _templateObject3$3;
function asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$2(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys$e(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$e(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$e(Object(source), true).forEach(function (key) { _defineProperty$P(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$e(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$j(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$P(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * This is a stripped-down read-only widget used in nextmatch
 * (and other read-only usages)
 */
class Et2SelectReadonly extends Et2Widget(s$5) {
  static get styles() {
    return [...super.styles, i$b(_templateObject$j || (_templateObject$j = _taggedTemplateLiteral$j(["\nul {\n    margin: 0px;\n    padding: 0px;\n    display: inline-block;\n}\n\nli {\n    text-decoration: none;\n    list-style-image: none;\n    list-style-type: none;\n}\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$e(_objectSpread$e({}, super.properties), {}, {
      value: String,
      select_options: {
        type: Array
      },
      searchUrl: String // Used for options from file
    });
  }

  constructor() {
    super();
    _defineProperty$P(this, "__select_options", void 0);
    _defineProperty$P(this, "__value", void 0);
    _defineProperty$P(this, "__fetchComplete", null);
    this.type = "";
    this.__select_options = [];
    this.__value = [];
  }
  getUpdateComplete() {
    var _superprop_getGetUpdateComplete = () => super.getUpdateComplete,
      _this = this;
    return _asyncToGenerator$2(function* () {
      if (_this.__fetchComplete) {
        var response = yield _superprop_getGetUpdateComplete().call(_this);
        yield _this.__fetchComplete;
        return response;
      } else {
        return _superprop_getGetUpdateComplete().call(_this);
      }
    })();
  }
  find_select_options(_attrs) {
    var sel_options = find_select_options(this, _attrs['select_options']);
    if (sel_options.length > 0) {
      this.select_options = sel_options;
    }

    // Cache options from file
    if (this.searchUrl && this.searchUrl.includes(".json") && this.__fetchComplete == null) {
      this.__fetchComplete = StaticOptions.cached_from_file(this, this.searchUrl).then(options => {
        this.select_options = options;
        this.requestUpdate();
      });
    }
  }
  transformAttributes(_attrs) {
    /*
    TODO: Check with more / different nextmatch data to see if this becomes faster.
    Currently it's faster for the nextmatch to re-do transformAttributes() and find_select_options()
     on every row than it is to use widget.clone()
    	// If there's no parent, there's a good chance we're in a nextmatch row so skip the transform
    if(!this.getParent())
    {
    	return;
    }
     */

    super.transformAttributes(_attrs);
    this.find_select_options(_attrs);
  }

  /**
   * @deprecated assign to value
   * @param value
   */
  set_value(value) {
    this.value = value;
  }

  /**
   * @deprecated use value
   * @param value
   */
  get_value(value) {
    return this.value;
  }

  /**
   * @deprecated use value
   * @param value
   */
  getValue(value) {
    return this.value;
  }
  getValueAsArray() {
    return Array.isArray(this.value) ? this.value : [this.value];
  }
  set value(new_value) {
    // Split anything that is still a CSV
    if (typeof new_value == "string" && new_value.indexOf(",") != -1) {
      new_value = new_value.split(",");
    }
    // Wrap any single value into an array for consistent rendering
    if (typeof new_value == "string" || typeof new_value == "number") {
      new_value = ["" + new_value];
    }
    var oldValue = this.__value;
    this.__value = new_value;
    this.requestUpdate("value", oldValue);
  }
  get value() {
    return this.__value;
  }

  /**
   * Set the select options
   *
   * @param {SelectOption[]} new_options
   */
  set select_options(new_options) {
    if (!Array.isArray(new_options)) {
      var fixed_options = [];
      for (var _key in new_options) {
        fixed_options.push({
          value: _key,
          label: new_options[_key]
        });
      }
      console.warn(this.id + " passed a key => value map instead of array");
      this.select_options = fixed_options;
      return;
    }
    this.__select_options = new_options;
  }

  /**
   * Set the select options
   *
   * @deprecated assign to select_options
   * @param new_options
   */
  set_select_options(new_options) {
    this.select_options = new_options;
  }
  get select_options() {
    return this.__select_options;
  }
  render() {
    var value = this.getValueAsArray();
    return x$1(_templateObject2$a || (_templateObject2$a = _taggedTemplateLiteral$j(["\n            <ul>\n                ", "\n            </ul>\n\t\t"])), c$2(this.getValueAsArray(), val => val, val => {
      var option = this.select_options.find(option => option.value == val);
      if (!option) {
        return "";
      }
      return this._readonlyRender(option);
    }));
  }
  _readonlyRender(option) {
    return x$1(_templateObject3$3 || (_templateObject3$3 = _taggedTemplateLiteral$j(["\n            <li>", "</li>\n\t\t"])), this.noLang ? option.label : this.egw().lang(option.label + ""));
  }
  getDetachedAttributes(attrs) {
    attrs.push("id", "value", "class", "statustext");
  }
  getDetachedNodes() {
    return [this];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    for (var attr in _values) {
      this[attr] = _values[attr];
    }
  }
  loadFromXML() {
    // nope
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select_ro", Et2SelectReadonly);
class Et2SelectAccountReadonly extends SelectAccountMixin(Et2SelectReadonly) {}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-account_ro", Et2SelectAccountReadonly);
class Et2SelectAppReadonly extends Et2StaticSelectMixin(Et2SelectReadonly) {
  find_select_options(_attrs) {
    this.fetchComplete = StaticOptions.app(this, _attrs).then(options => {
      this.set_static_options(cleanSelectOptions(options));
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-app_ro", Et2SelectAppReadonly);
class Et2SelectBitwiseReadonly extends Et2SelectReadonly {
  /* Currently handled server side, we get an array
  render()
  {
  	let new_value = [];
  	let int_value = parseInt(this.value);
  	for(let index in this.select_options)
  	{
  		let option = this.select_options[index];
  		let right = parseInt(option && option.value ? option.value : index);
  		if(!!(int_value & right))
  		{
  			new_value.push(right);
  		}
  	}
  	return html`
             <ul>
                 ${repeat(new_value, (val : string) => val, (val) =>
                 {
                     let option = (<SelectOption[]>this.select_options).find(option => option.value == val);
                     if(!option)
                     {
                         return "";
                     }
                     return this._readonlyRender(option);
                 })}
             </ul>`;
  }
  	 */
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-bitwise_ro", Et2SelectBitwiseReadonly);
class Et2SelectBoolReadonly extends Et2StaticSelectMixin(Et2SelectReadonly) {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.bool(this);
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-bool_ro", Et2SelectBoolReadonly);
class Et2SelectCategoryReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    // Need to do this in find_select_options so attrs can be used to get proper options
    StaticOptions.cat(this).then(_options => {
      this.select_options = _options;

      // on first load we have the value before the options arrive --> need to request an update
      if (this.value && (!Array.isArray(this.value) || this.value.length)) {
        this.requestUpdate('value');
      }
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-cat_ro", Et2SelectCategoryReadonly);
class Et2SelectPercentReadonly extends Et2SelectReadonly {
  constructor() {
    super(...arguments);
    this.select_options = StaticOptions.percent(this);
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-percent_ro", Et2SelectPercentReadonly);
class Et2SelectCountryReadonly extends Et2StaticSelectMixin(Et2SelectReadonly) {
  find_select_options(_attrs) {
    this.fetchComplete = StaticOptions.country(this, _attrs, true).then(options => {
      this.set_static_options(cleanSelectOptions(options));
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-country_ro", Et2SelectCountryReadonly);
class Et2SelectDayReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.day(this, {
      other: this.other || []
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-day_ro", Et2SelectDayReadonly);
class Et2SelectDayOfWeekReadonly extends Et2StaticSelectMixin(Et2SelectReadonly) {
  find_select_options(_attrs) {
    // Wait for connected instead of constructor because attributes make a difference in
    // which options are offered
    this.fetchComplete = StaticOptions.dow(this, {
      other: this.other || []
    }).then(options => {
      this.set_static_options(cleanSelectOptions(options));
    });
  }
  getValueAsArray() {
    var expanded_value = [];
    var int_value = parseInt(this.value);
    var options = this.select_options;
    for (var index in options) {
      var right = parseInt(options[index].value);
      if ((int_value & right) == right) {
        expanded_value.push("" + right);
      }
    }
    return expanded_value;
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-dow_ro", Et2SelectDayOfWeekReadonly);
class Et2SelectHourReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.hour(this, {
      other: this.other || []
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-hour_ro", Et2SelectHourReadonly);
class Et2SelectMonthReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.month(this);
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-month_ro", Et2SelectMonthReadonly);
class Et2SelectNumberReadonly extends Et2StaticSelectMixin(Et2SelectReadonly) {
  find_select_options(_attrs) {
    this._static_options = StaticOptions.number(this, _attrs);
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-number_ro", Et2SelectNumberReadonly);
class Et2SelectPriorityReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.priority(this);
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-priority_ro", Et2SelectPriorityReadonly);
class Et2SelectStateReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.state(this, {
      other: this.other || []
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-state_ro", Et2SelectStateReadonly);
class Et2SelectTimezoneReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.timezone(this, {
      other: this.other || []
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-timezone_ro", Et2SelectTimezoneReadonly);
class Et2SelectYearReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.year(this, {
      other: this.other || []
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-year_ro", Et2SelectYearReadonly);
class Et2SelectLangReadonly extends Et2SelectReadonly {
  find_select_options(_attrs) {
    this.select_options = StaticOptions.lang(this, {
      other: this.other || []
    });
  }
}

// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-select-lang_ro", Et2SelectLangReadonly);

function ownKeys$d(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$d(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$d(Object(source), true).forEach(function (key) { _defineProperty$O(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$d(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$O(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2SelectState extends Et2StaticSelectMixin(Et2Select) {
  static get properties() {
    return _objectSpread$d(_objectSpread$d({}, super.properties), {}, {
      countryCode: String
    });
  }
  constructor() {
    super();
    /**
     * Two-letter ISO country code
     */
    _defineProperty$O(this, "__countryCode", void 0);
    this.countryCode = 'DE';
  }
  get countryCode() {
    return this.__countryCode;
  }
  set countryCode(code) {
    this.__countryCode = code;
    this.fetchComplete = StaticOptions.state(this, {
      country_code: code
    }).then(options => {
      this._static_options = cleanSelectOptions(options);
      this.requestUpdate();
    });
  }
  set_country_code(code) {
    this.countryCode = code;
  }
}
customElements.define("et2-select-state", Et2SelectState);

class Et2SelectTab extends Et2SelectApp {
  constructor() {
    super();
    this.allowFreeEntries = true;
  }
  set value(new_value) {
    if (!new_value) {
      super.value = new_value;
      return;
    }
    var values = Array.isArray(new_value) ? new_value : [new_value];
    var options = this.select_options;
    values.forEach(value => {
      if (!options.filter(option => option.value == value).length) {
        var matches = value.match(/^([a-z0-9]+)\-/i);
        var option = {
          value: value,
          label: value
        };
        if (matches) {
          option = options.filter(option => option.value == matches[1])[0] || {
            value: value,
            label: this.egw().lang(matches[1])
          };
          option.value = value;
          option.label += ' ' + this.egw().lang('Tab');
        }
        try {
          var _opener;
          var app = (_opener = opener) === null || _opener === void 0 ? void 0 : _opener.framework.getApplicationByName(value);
          if (app && app.displayName) {
            option.label = app.displayName;
          }
        } catch (e) {
          // ignore security exception, if opener is not accessible
        }
        this.select_options.concat(option);
      }
    });
    super.value = new_value;
  }
  get value() {
    return super.value;
  }
}
customElements.define("et2-select-tab", Et2SelectTab);

var _templateObject$i, _templateObject2$9;
function _taggedTemplateLiteral$i(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2SelectThumbnail extends Et2Select {
  static get styles() {
    return [...super.styles, i$b(_templateObject$i || (_templateObject$i = _taggedTemplateLiteral$i(["\n\t\n\t\t\t/* Hide selected options from the dropdown */\n\t\t\t::slotted([checked])\n\t\t\t{\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\t/* Hide dropdown icon */\n\t\t\t::part(icon), .select__icon {\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);
    this.search = false;
    this.allowFreeEntries = true;
    this.editModeEnabled = true;
    this.multiple = true;
    this.pill = false;
  }

  /**
   * Create an entry that is not in the options and add it to the value
   * Overridden here to set the icon as the text, since this is a thumbnail
   *
   * @param {string} text Used as both value and label
   */
  createFreeEntry(text) {
    if (!this.validateFreeEntry(text)) {
      return false;
    }
    // Make sure not to double-add
    if (!this.select_options.find(o => o.value == text)) {
      this.__select_options.push({
        value: text,
        label: "",
        icon: text
      });
      this.requestUpdate('select_options');
    }
    this.requestUpdate();

    // Make sure not to double-add
    if (this.multiple && this.value.indexOf(text) == -1) {
      this.value.push(text);
    } else if (!this.multiple) {
      this.value = text;
      return;
    }
    return true;
  }
  get tagTag() {
    return "et2-thumbnail-tag";
  }

  /**
   * Custom tag
   *
   * Override this to customise display when multiple=true.
   * There is no restriction on the tag used, unlike _optionTemplate()
   *
   * @param {Et2Option} option
   * @param {number} index
   * @returns {TemplateResult}
   * @protected
   */
  _tagTemplate(option, index) {
    // Different image - slot in just an image so we can have complete control over styling
    return x$1(_templateObject2$9 || (_templateObject2$9 = _taggedTemplateLiteral$i(["\n            <et2-thumbnail-tag>\n                <img\n                        part=\"image\"\n                        slot=\"prefix\"\n                        src=\"", "\"\n                />\n            </et2-thumbnail-tag>\n\t\t"])), option.value);
  }
}
customElements.define("et2-select-thumbnail", Et2SelectThumbnail);

class Et2SelectTimezone extends Et2StaticSelectMixin(Et2Select) {
  constructor() {
    var _this$other;
    super();
    this.fetchComplete = StaticOptions.timezone(this, {
      other: (_this$other = this.other) !== null && _this$other !== void 0 ? _this$other : []
    }).then(options => {
      this.set_static_options(cleanSelectOptions(options));
    });
  }
}
customElements.define("et2-select-timezone", Et2SelectTimezone);

class Et2SelectYear extends Et2SelectNumber {
  constructor() {
    super();
    this.min = -3;
    this.max = 2;
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has('min') || changedProperties.has('max') || changedProperties.has('interval') || changedProperties.has('suffix')) {
      this._static_options = StaticOptions.year(this);
    }
  }
}
customElements.define("et2-select-year", Et2SelectYear);

/**
 * Import all our sub-types
 */

var _templateObject$h, _templateObject2$8;
function _taggedTemplateLiteral$h(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$N(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Tag is usually used in a Et2CategorySelect with multiple=true, but there's no reason it can't go anywhere
 */
class Et2CategoryTag extends Et2Tag {
  static get styles() {
    return [super.styles, shoelace, i$b(_templateObject$h || (_templateObject$h = _taggedTemplateLiteral$h(["\n\t\t\t.tag {\n\t\t\t\tgap: var(--sl-spacing-2x-small);\n\t\t\t\t/* --category-color is passed through in _styleTemplate() */\n\t\t\t\tborder-left: 6px solid var(--category-color, transparent);\n\t\t\t}\n\t\t"])))];
  }
  constructor() {
    super(...arguments);
    _defineProperty$N(this, "value", void 0);
  }

  /**
   * Due to how the scoping / encapulation works, we need to re-assign the category color
   * variable here so it can be passed through.  .cat_# {--category-color} is not visible.
   *
   * @returns {TemplateResult}
   * @protected
   */
  _styleTemplate() {
    var cat_var = "var(--cat-" + this.value + "-color)";
    // @formatter:off
    return x$1(_templateObject2$8 || (_templateObject2$8 = _taggedTemplateLiteral$h(["<style>.tag { --category-color: ", "}</style>"])), cat_var);
    //@formatter:on
  }
}

customElements.define("et2-category-tag", Et2CategoryTag);

var _templateObject$g;
function _taggedTemplateLiteral$g(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Used in a Et2ThumbnailSelect with multiple=true
 *
 * It's just easier to deal with the styling here due to scoping
 */
class Et2ThumbnailTag extends Et2Tag {
  static get styles() {
    return [super.styles, shoelace, i$b(_templateObject$g || (_templateObject$g = _taggedTemplateLiteral$g(["\n\t\t\t.tag {\n\t\t\t\t--icon-width: 100%;\n\t\t\t\tmax-width: 15em;\n\t\t\t\theight: unset;\n\t\t\t}\n\t\t\t\n\t\t\t::slotted(img) {\n\t\t\t\twidth: 100%;\n\t\t\t\theight: 50px;\n\t\t\t} \n\n\t\t"])))];
  }
  constructor() {
    super(...arguments);
    this.pill = false;
  }
}
customElements.define("et2-thumbnail-tag", Et2ThumbnailTag);

var _templateObject$f;
function ownKeys$c(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$c(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$c(Object(source), true).forEach(function (key) { _defineProperty$M(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$c(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$M(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$f(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Spinner extends Et2Widget(spinner_default) {
  static get styles() {
    return [...super.styles, shoelace, i$b(_templateObject$f || (_templateObject$f = _taggedTemplateLiteral$f(["\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$c(_objectSpread$c({}, super.properties), {}, {
      /**
       * font-size		size is based on font size
       * --track-width	The width of the track.
       * --track-color	The color of the track.
       * --indicator-color	The color of the indicator.
       * --speed	The time it takes for the spinner to complete one animation cycle.
       */
      style: {
        type: String
      }
    });
  }
  constructor() {
    super();
    this.style = '';
  }

  /**
   * Handle changes that have to happen based on changes to properties
   *
   */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("style")) {
      if (this.style) {
        this.getDOMNode().setAttribute('style', this.style);
      }
    }
  }
}
customElements.define("et2-spinner", Et2Spinner);

var _templateObject$e, _templateObject2$7;
function ownKeys$b(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$b(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$b(Object(source), true).forEach(function (key) { _defineProperty$L(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$b(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$L(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$e(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Switch to turn on or off.  Like a checkbox, but different UI.
 *
 * Add "et2SlideSwitch" class to use an alternate UI with images.  Use CSS to set the images:
 *
 */
class Et2Switch extends Et2InputWidget(SlotMixin(switch_default)) {
  static get styles() {
    return [...shoelace, ...super.styles, i$b(_templateObject$e || (_templateObject$e = _taggedTemplateLiteral$e(["\n\t\t\t  :host {\n\t\t\t\t/* Make it line up with the middle of surroundings */\n\t\t\t\tmargin: auto 0px;\n\t\t\t\tvertical-align: -webkit-baseline-middle;\n\t\t\t  }\n\n\t\t\t  .switch {\n\t\t\t\tposition: relative;\n\t\t\t  }\n\n\t\t\t  .toggle__label {\n\t\t\t\tposition: absolute;\n\t\t\t\tleft: 0px;\n\t\t\t\tborder-radius: 50%;\n\t\t\t\tflex: 0 0 auto;\n\t\t\t\tdisplay: inline-flex;\n\t\t\t\talign-items: center;\n\t\t\t\tjustify-content: center;\n\t\t\t\twidth: var(--width);\n\t\t\t\theight: var(--height);\n\t\t\t\tmargin: 0px;\n\t\t\t  }\n\n\t\t\t  .switch__thumb {\n\t\t\t\tz-index: var(--sl-z-index-tooltip);\n\t\t\t  }\n\n\t\t\t  ::slotted(span.label) {\n\t\t\t\twidth: var(--width);\n\t\t\t\tdisplay: inline-flex;\n\t\t\t\talign-items: center;\n\t\t\t\theight: var(--height);\n\t\t\t  }\n\n\t\t\t  /* \n\t\t\t  Use two images instead of normal switch by adding et2_image_switch class\n\t\t\t  see etemplate.css for the rest (slotted label)\n\t\t\t   */\n\n\t\t\t  :host(.et2SlideSwitch) .switch {\n\t\t\t\tmin-width: 60px;\n\t\t\t\t--height: var(--sl-input-height-medium);\n\t\t\t\tborder-color: var(--sl-input-border-color);\n\t\t\t\tborder-width: var(--sl-input-border-width);\n\t\t\t\tborder-radius: var(--sl-border-radius-medium);\n\t\t\t\tborder-style: solid;\n\t\t\t  }\n\n\t\t\t  :host(.et2SlideSwitch) .switch__control {\n\t\t\t\tvisibility: hidden;\n\t\t\t  }\n\n\t\t\t  :host(.et2SlideSwitch) .switch__label {\n\t\t\t\twidth: 100%;\n\t\t\t\theight: 100%;\n\t\t\t  }\n\n\t\t\t  :host(.et2SlideSwitch) ::slotted(.label) {\n\t\t\t\tflex: 1 1 auto;\n\t\t\t  }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$b(_objectSpread$b({}, super.properties), {}, {
      /* label to show when the toggle switch is on */
      toggleOn: {
        type: String
      },
      /* label to show when the toggle switch is off */
      toggleOff: {
        type: String
      }
    });
  }
  get slots() {
    return _objectSpread$b(_objectSpread$b({}, super.slots), {}, {
      '': () => {
        return this.labelTemplate();
      }
    });
  }
  constructor() {
    super();
    this.isSlComponent = true;
    this.toggleOn = '';
    this.toggleOff = '';
  }
  updated(changedProperties) {
    if (changedProperties.has("toggleOn") || changedProperties.has("toggleOff") || changedProperties.has("label")) {
      if (!this.toggleOn && !this.toggleOff && this._labelNode) {
        this._labelNode.childNodes.forEach(c => c.remove());
      } else {
        if (this._labelNode) {
          this._labelNode.querySelector('.on').textContent = this.toggleOn;
          this._labelNode.querySelector('.off').textContent = this.toggleOff;
        }
        this.shadowRoot.querySelector('.switch__label').classList.add('toggle__label');
      }
    }
  }
  set value(new_value) {
    this.requestUpdate("checked");
    if (this.toggleOn || this.toggleOf) {
      if (new_value) {
        var _this$_labelNode;
        (_this$_labelNode = this._labelNode) === null || _this$_labelNode === void 0 || _this$_labelNode.classList.add('on');
      } else {
        var _this$_labelNode2;
        (_this$_labelNode2 = this._labelNode) === null || _this$_labelNode2 === void 0 || _this$_labelNode2.classList.remove('on');
      }
    }
    this.checked = !!new_value;
    return;
  }
  get value() {
    return this.checked;
  }
  get _labelNode() {
    return this.querySelector(".label");
  }
  labelTemplate() {
    var labelClass = this.checked ? "label on" : "label";
    return x$1(_templateObject2$7 || (_templateObject2$7 = _taggedTemplateLiteral$e(["\n            <span class=", " aria-label=\"", "\">\n\t\t\t\t<span class=\"on\">", "</span>\n\t\t\t\t<span class=\"off\">", "</span>\n\t\t\t</span>\n\t\t"])), labelClass, this.label, this.toggleOn, this.toggleOff);
  }
}
customElements.define("et2-switch", Et2Switch);

var _templateObject$d;
function ownKeys$a(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$a(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$a(Object(source), true).forEach(function (key) { _defineProperty$K(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$a(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$K(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$d(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Textarea extends Et2InputWidget(textarea_default) {
  static get styles() {
    return [...shoelace, ...super.styles, i$b(_templateObject$d || (_templateObject$d = _taggedTemplateLiteral$d(["\n\t\t\t:host {\n\t\t\t\tdisplay: flex;\n\t\t\t\tflex-direction: column;\n\t\t\t\twidth: 100%;\n\t\t\t\theight: 100%;\n            }\n\n\t\t\t  .textarea--resize-vertical {\n            \theight: 100%;\n            }\n            :host::part(form-control) {\n    \t\t\theight: 100%;\n    \t\t\talign-items: stretch !important;\n\t\t\t}\n\n\t\t\t  :host::part(form-control-input), :host::part(textarea) {\n            \theight: 100%;\n            }\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$a(_objectSpread$a({}, super.properties), {}, {
      /**
       * Specify the width of the text area.
       * If not set, it will expand to fill the space available.
       */
      width: {
        type: String
      },
      /**
       * Specify the height of the text area.
       * If not set, it will expand to fill the space available.
       */
      height: {
        type: String
      },
      onkeypress: Function
    });
  }
  constructor() {
    super();
    this.rows = "";
  }
  connectedCallback() {
    super.connectedCallback();
    if (this.__width) {
      this.style.width = this.__width;
    }
    if (this.__height) {
      this.style.height = this.__height;
    }
  }

  /**
   * Use width and height attributes to affect style
   * It would be better to deprecate these and just use CSS
   *
   * @param value
   */
  set width(value) {
    var oldValue = this.__width;
    this.__width = value;
    this.requestUpdate("width", oldValue);
  }
  set height(value) {
    var oldValue = this.__height;
    this.__height = value;
    this.requestUpdate("height", oldValue);
  }

  /** Override some parent stuff to get sizing how we like it **/
  setTextareaMaxHeight() {
    this._inputNode.style.maxHeight = 'inherit';
  }
  get _inputNode() {
    var _this$shadowRoot;
    return (_this$shadowRoot = this.shadowRoot) === null || _this$shadowRoot === void 0 ? void 0 : _this$shadowRoot.querySelector("textarea");
  }
}
customElements.define("et2-textarea", Et2Textarea);

/**
 * A readonly textbox is just a description.  You should use that instead, but here it is.
 */
class Et2TextareaReadonly extends Et2Description {}

// We can't bind the same class to a different tag
// @ts-ignore TypeScript is not recognizing that Et2Textbox is a LitElement
customElements.define("et2-textarea_ro", Et2TextareaReadonly);

function asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator$1(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
class Regex extends Pattern {
  /**
   * Give a message about this field being required.  Could be customised according to MessageData.
   * @param {MessageData | undefined} data
   * @returns {Promise<string>}
   */
  static getMessage(data) {
    return _asyncToGenerator$1(function* () {
      // TODO: This is a poor error message, it shows the REGEX
      return data.formControl.egw().lang("'%1' has an invalid format !!!", data.params);
    })();
  }
}

var _templateObject$c;
function ownKeys$9(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$9(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$9(Object(source), true).forEach(function (key) { _defineProperty$J(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$9(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$J(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$c(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Textbox extends Et2InputWidget(input_default) {
  static get styles() {
    return [...shoelace, ...super.styles, i$b(_templateObject$c || (_templateObject$c = _taggedTemplateLiteral$c(["\n\t\t\t\t:host([type=\"hidden\"]) {\n\t\t\t\t\tdisplay: none;\n\t\t\t\t}\n\t\t\t\t.input__control {\n\t\t\t\t\tborder: none;\n\t\t\t\t\twidth: 100%;\n\t\t\t\t}\n\t\t\t\t.input:hover:not(.input--disabled) .input__control {\n\t\t\t\t\tcolor: var(--input-text-color, inherit);\n\t\t\t\t}\n\t\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$9(_objectSpread$9({}, super.properties), {}, {
      /**
       * Perl regular expression eg. '/^[0-9][a-f]{4}$/i'
       *
       * Not to be confused with this.validators, which is a list of validators for this widget
       */
      validator: String,
      onkeypress: Function
    });
  }
  static get translate() {
    return Object.assign({
      helpText: true
    }, super.translate);
  }
  constructor() {
    super(...arguments);
  }
  connectedCallback() {
    super.connectedCallback();
  }

  /** @param {import('@lion/core').PropertyValues } changedProperties */
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has('validator')) {
      // Remove all existing Pattern validators (avoids duplicates)
      this.validators = (this.validators || []).filter(validator => !(validator instanceof Regex));
      this.validators.push(new Regex(this.validator));
    }
  }
  get validator() {
    return this.__validator;
  }
  set validator(value) {
    if (typeof value == 'string') {
      var parts = value.split('/');
      var flags = parts.pop();
      if (parts.length < 2 || parts[0] !== '') {
        this.egw().debug(this.egw().lang("'%1' has an invalid format !!!", value));
        return;
      }
      parts.shift();
      this.__validator = new RegExp(parts.join('/'), flags);
      this.requestUpdate("validator");
    }
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Textbox is a LitElement
customElements.define("et2-textbox", Et2Textbox);

/**
 * EGroupware eTemplate2 - Readonly Textbox widget (WebComponent)
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Nathan Gray
 */

/**
 * A readonly textbox is just a description.  You should use that instead, but here it is.
 */
class Et2TextboxReadonly extends Et2Description {}

// We can't bind the same class to a different tag
// @ts-ignore TypeScript is not recognizing that Et2Textbox is a LitElement
customElements.define("et2-textbox_ro", Et2TextboxReadonly);

var _templateObject$b, _templateObject2$6;
function ownKeys$8(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$8(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$8(Object(source), true).forEach(function (key) { _defineProperty$I(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$8(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$I(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$b(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Number extends Et2Textbox {
  static get styles() {
    return [...(super.styles ? Array.isArray(super.styles) ? super.styles : [super.styles] : []), i$b(_templateObject$b || (_templateObject$b = _taggedTemplateLiteral$b(["\n\t\t\t  /* Scroll buttons */\n\n\t\t\t  :host(:hover) ::slotted(et2-button-scroll) {\n\t\t\t\tdisplay: flex;\n\t\t\t  }\n\n\t\t\t  ::slotted(et2-button-scroll) {\n\t\t\t\tdisplay: none;\n\t\t\t  }\n\n\t\t\t  .input--medium .input__suffix ::slotted(et2-button-scroll) {\n\t\t\t\tpadding: 0px;\n\t\t\t  }\n\n\t\t\t"])))];
  }
  static get properties() {
    return _objectSpread$8(_objectSpread$8({}, super.properties), {}, {
      /**
       * Minimum value
       */
      min: Number,
      /**
       * Maximum value
       */
      max: Number,
      /**
       * Step value
       */
      step: Number,
      /**
       * Precision of float number or 0 for integer
       */
      precision: Number
    });
  }
  constructor() {
    super();
    this.handleScroll = this.handleScroll.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();

    // Add spinners
    D$1(this._incrementButtonTemplate(), this);
  }
  transformAttributes(attrs) {
    if (attrs.precision === 0 && typeof attrs.step === 'undefined') {
      attrs.step = 1;
    }
    if (typeof attrs.validator === 'undefined') {
      attrs.validator = attrs.precision === 0 ? '/^-?[0-9]*$/' : '/^-?[0-9]*[,.]?[0-9]*$/';
    }
    attrs.inputmode = "numeric";
    super.transformAttributes(attrs);
  }

  /**
   * Somehow the setter is not inherited from the parent, not defining it here leaves the validator a string!
   *
   * @param regexp
   */
  set validator(regexp) {
    super.validator = regexp;
  }
  get validator() {
    return super.validator;
  }
  handleInput() {
    // Do nothing
  }
  handleBlur() {
    this.value = this.input.value;
    super.handleBlur();
  }
  set value(val) {
    if ("" + val !== "") {
      // use decimal separator from user prefs
      var format = this.egw().preference('number_format');
      var sep = format ? format[0] : '.';

      // Remove separator so parseFloat works
      if (typeof val === 'string') {
        val = val.replace(",", '.');
      }
      if (typeof this.precision !== 'undefined') {
        val = parseFloat(val).toFixed(this.precision);
      } else {
        val = parseFloat(val);
      }
      // Put separator back in, if different
      if (typeof val === 'string' && format && sep && sep !== '.') {
        val = val.replace('.', sep);
      }
    }
    super.value = val;
  }
  get value() {
    return super.value;
  }
  getValue() {
    // Needs to be string to pass validator
    return "" + this.valueAsNumber;
  }
  get valueAsNumber() {
    var val = super.value;
    if ("" + val !== "") {
      // remove decimal separator from user prefs
      var format = this.egw().preference('number_format');
      var sep = format ? format[0] : '.';
      if (typeof val === 'string' && format && sep && sep !== '.') {
        val = val.replace(sep, '.');
      }
      if (typeof this.precision !== 'undefined') {
        val = parseFloat(parseFloat(val).toFixed(this.precision));
      } else {
        val = parseFloat(val);
      }
    }
    return val;
  }
  handleScroll(e) {
    var _this$min, _this$max;
    if (this.disabled) return;
    var old_value = this.value;
    var min = parseFloat((_this$min = this.min) !== null && _this$min !== void 0 ? _this$min : Number.MIN_SAFE_INTEGER);
    if (Number.isNaN(min)) {
      min = Number.MIN_SAFE_INTEGER;
    }
    var max = parseFloat((_this$max = this.max) !== null && _this$max !== void 0 ? _this$max : Number.MAX_SAFE_INTEGER);
    if (Number.isNaN(max)) {
      max = Number.MAX_SAFE_INTEGER;
    }
    this.value = "" + Math.min(Math.max(this.valueAsNumber + e.detail * (parseFloat(this.step) || 1), min), max);
    this.dispatchEvent(new CustomEvent("sl-change", {
      bubbles: true
    }));
    this.requestUpdate("value", old_value);
  }
  _incrementButtonTemplate() {
    // No increment buttons on mobile
    if (typeof egwIsMobile == "function" && egwIsMobile()) {
      return '';
    }
    return this.disabled ? '' : x$1(_templateObject2$6 || (_templateObject2$6 = _taggedTemplateLiteral$b(["\n            <et2-button-scroll class=\"et2-number__scrollbuttons\" slot=\"suffix\"\n                               part=\"scroll\"\n                               @et2-scroll=", "></et2-button-scroll>"])), this.handleScroll);
  }
}
// @ts-ignore TypeScript is not recognizing that Et2Textbox is a LitElement
customElements.define("et2-number", Et2Number);

function ownKeys$7(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$7(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$7(Object(source), true).forEach(function (key) { _defineProperty$H(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$7(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$H(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2NumberReadonly extends Et2TextboxReadonly {
  static get properties() {
    return _objectSpread$7(_objectSpread$7({}, super.properties), {}, {
      /**
       * Precision of float number or 0 for integer
       */
      precision: Number
    });
  }
  set_value(val) {
    if (val === null) {
      val = "";
    } else if ("" + val !== "") {
      if (typeof this.precision !== 'undefined') {
        val = parseFloat(val).toFixed(this.precision);
      } else {
        val = parseFloat(val);
      }
    }
    // use decimal separator from user prefs
    var format = this.egw().preference('number_format');
    var sep = format ? format[0] : '.';
    if (typeof val === 'string' && format && sep && sep !== '.') {
      val = val.replace('.', sep);
    }
    // can not call super.set_value(), as it does not call the setter for value
    super.value = val;
  }
}

// @ts-ignore TypeScript is not recognizing that Et2Textbox is a LitElement
customElements.define("et2-number_ro", Et2NumberReadonly);

var _templateObject$a, _templateObject2$5;
function _taggedTemplateLiteral$a(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
class Et2Colorpicker extends Et2InputWidget(color_picker_default) {
  static get styles() {
    return [shoelace, ...super.styles, i$b(_templateObject$a || (_templateObject$a = _taggedTemplateLiteral$a(["\n\t\t\t:host {\n\t\t\t\tdisplay: flex;\n\t\t\t}\n\t\t\t.input-group__suffix{\n\t\t\t\twidth: 12px;\n\t\t\t\theight: 12px;\n\t\t\t}\n\t\t\t.input-group__container {\n\t\t\t\talign-items: center\n\t\t\t}\n\n\t\t\t.color-dropdown__trigger--empty .input__clear {\n\t\t\t\tdisplay: none;\n\t\t\t}\n\t\t\t.input__clear {\n\t\t\t\tdisplay: inline-flex;\n\t\t\t\talign-items: center;\n\t\t\t\tjustify-content: center;\n\t\t\t\tfont-size: inherit;\n\t\t\t\tcolor: var(--sl-input-icon-color);\n\t\t\t\tborder: none;\n\t\t\t\tbackground: none;\n\t\t\t\tpadding: 0px;\n\t\t\t\ttransition: var(--sl-transition-fast) color;\n\t\t\t\tcursor: pointer;\n\t\t\t\t\n\t\t\t\t/* Positioning of clear button */\n\t\t\t\tposition: absolute;\n\t\t\t\tleft: var(--sl-input-height-medium);\n\t\t\t\ttop: 0px;\n\t\t\t\tmargin: auto 0px;\n\t\t\t\tbottom: 0px;\n\n\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super();
    this.hoist = true;
    this.noFormatToggle = true;
    this.uppercase = true;

    // Bind the handlers
    this._handleClickClear = this._handleClickClear.bind(this);
  }
  firstUpdated(_changedProperties) {
    super.firstUpdated(_changedProperties);

    // Add in clear button - parent has no accessible slots
    D$1(this._clearButtonTemplate(), this._buttonNode);
  }
  get _buttonNode() {
    return this.shadowRoot.querySelector("button[slot='trigger']");
  }
  _clearButtonTemplate() {
    return x$1(_templateObject2$5 || (_templateObject2$5 = _taggedTemplateLiteral$a(["\n            <button part=\"clear-button\" class=\"input__clear\" type=\"button\" tabindex=\"-1\"\n                    aria-label=\"", "\"\n                    @click=", ">\n                <slot name=\"clear-icon\">\n                    <sl-icon name=\"x-circle-fill\" library=\"system\"></sl-icon>\n                </slot>\n            </button>\n\t\t"])), this.egw().lang("Clear entry"), this._handleClickClear);
  }
  _handleClickClear(e) {
    e.stopImmediatePropagation();
    this.value = "";
  }
}
customElements.define('et2-colorpicker', Et2Colorpicker);

var _templateObject$9, _templateObject2$4;
function ownKeys$6(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$6(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$6(Object(source), true).forEach(function (key) { _defineProperty$G(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$6(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$G(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _taggedTemplateLiteral$9(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Invoker mixing adds an invoker button to a widget to trigger some action, e.g.:
 * - searchbox to delete input
 * - url to open url
 * - url-email to open mail compose
 *
 * Inspired by Lion date-picker.
 */

var Et2InvokerMixin = dedupeMixin(superclass => {
  class Et2Invoker extends SlotMixin(Et2InputWidget(superclass)) {
    /** @type {any} */
    static get properties() {
      return {
        /**
         * Textual label or image specifier for egw.image()
         */
        _invokerLabel: {
          type: String
        },
        _invokerTitle: {
          type: String
        },
        _invokerAction: {
          type: Function
        }
      };
    }
    static get styles() {
      return [...super.styles, colorsDefStyles, i$b(_templateObject$9 || (_templateObject$9 = _taggedTemplateLiteral$9(["\n\t\t\t\t::slotted(input), input, ::slotted(select) {\n\t\t\t\t\tbackground-color: transparent;\n\t\t\t\t\tborder: none !important;\n\t\t\t\t}\n\t\t\t\t.input-group {\n\t\t\t\t\tborder: 1px solid var(--input-border-color);\n\t\t\t\t}\n\t\t\t\t.input-group__suffix{\n\t\t\t\t\ttext-align: center;\n\t\t\t\t}\n\t\t\t\t.input-group__container {\n\t\t\t\t\talign-items: center\n\t\t\t\t}\n\t\t\t\t::slotted([slot=\"suffix\"]) {\n\t\t\t\t\twidth: 14px;\n\t\t\t\t\tborder: none !important;\n\t\t\t\t\tbackground-color: transparent !important;\n\t\t\t\t\twidth: 1em;\n\t\t\t\t\theight: 1em;\n\t\t\t\t\tbackground-position: center right;\n\t\t\t\t\tbackground-size: contain;\n\t\t\t\t\tbackground-repeat: no-repeat;\n\t\t\t\t}\n\t\t\t\t::slotted(:disabled) {cursor: default !important;}\n\t\t\t\t:host(:hover) ::slotted([slot=\"suffix\"]) {\n\t\t\t\t\tcursor: pointer;\n\t\t\t\t}\n\t\t\t"])))];
    }
    get slots() {
      return _objectSpread$6(_objectSpread$6({}, super.slots), {}, {
        suffix: () => {
          return this._invokerTemplate();
        }
      });
    }

    /**
     * @protected
     */
    get _invokerNode() {
      return (/** @type {HTMLElement} */this.querySelector("#".concat(this.__invokerId))
      );
    }
    constructor() {
      super(...arguments);
      /** @private */
      this.__invokerId = this.__createUniqueIdForA11y();
      // default for properties
      this._invokerTitle = 'Click to open';
    }

    /** @private */
    __createUniqueIdForA11y() {
      return "".concat(this.localName, "-").concat(Math.random().toString(36).substr(2, 10));
    }

    /**
     * @param {PropertyKey} name
     * @param {?} oldValue
     */
    requestUpdate(name, oldValue) {
      super.requestUpdate(name, oldValue);
      if (name === 'disabled' || name === 'showsFeedbackFor' || name === 'modelValue') {
        this._toggleInvokerDisabled();
      }
      if (name === '_invokerLabel' || name === '_invokerTitle') {
        this._toggleInvoker();
      }
      if (name === '_invokerAction') {
        var _this$_invokerNode, _this$_invokerNode2;
        if (oldValue) (_this$_invokerNode = this._invokerNode) === null || _this$_invokerNode === void 0 || _this$_invokerNode.removeEventListener('click', oldValue);
        (_this$_invokerNode2 = this._invokerNode) === null || _this$_invokerNode2 === void 0 || _this$_invokerNode2.addEventListener('click', this._invokerAction.bind(this), true);
      }
    }

    /**
     * (Un)Hide invoker, if no label or action defined
     *
     * @protected
     * */
    _toggleInvoker() {
      if (this._invokerNode) {
        this._invokerNode.style.display = !this._invokerLabel ? 'none' : 'inline-block';
        var img = this._invokerLabel ? this.egw().image(this._invokerLabel) : null;
        if (img) {
          this._invokerNode.style.backgroundImage = 'url(' + img + ')';
          this._invokerNode.innerHTML = '';
        } else {
          this._invokerNode.style.backgroundImage = 'none';
          this._invokerNode.innerHTML = this._invokerLabel || '';
        }
        this._invokerNode.title = this._invokerTitle || '';
      }
    }

    /**
     * Method to check if invoker can be activated: not disabled, empty or invalid
     *
     * @protected
     * */
    _toggleInvokerDisabled() {
      if (this._invokerNode) {
        var invokerNode = /** @type {HTMLElement & {disabled: boolean}} */this._invokerNode;
        invokerNode.disabled = this.disabled || !this.value || this.input && !this.input.reportValidity();
      }
    }

    /**
     * Reimplemented to enable/disable invoker on content change
     *
     * @param _ev
     * @returns
     */
    _oldChange(_ev) {
      this._toggleInvokerDisabled();
      return super._oldChange(_ev);
    }

    /** @param {import('@lion/core').PropertyValues } changedProperties */
    firstUpdated(changedProperties) {
      super.firstUpdated(changedProperties);
      this._toggleInvokerDisabled();
      this._toggleInvoker();
    }

    /**
     * Subclassers can replace this with their custom extension invoker,
     * like `<my-button><calendar-icon></calendar-icon></my-button>`
     */
    // eslint-disable-next-line class-methods-use-this
    _invokerTemplate() {
      return x$1(_templateObject2$4 || (_templateObject2$4 = _taggedTemplateLiteral$9(["\n                <button\n                        type=\"button\"\n                        @click=\"", "\"\n                        id=\"", "\"\n                        aria-label=\"", "\"\n                        title=\"", "\"\n                >\n                    ", "\n                </button>\n\t\t\t"])), this._invokerAction, this.__invokerId, this._invokerTitle, this._invokerTitle, this._invokerLabel);
    }
  }
  return Et2Invoker;
});

var _templateObject$8;
function _taggedTemplateLiteral$8(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$5(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$5(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$5(Object(source), true).forEach(function (key) { _defineProperty$F(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$5(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$F(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @customElement et2-url
 *
 * @ToDo: implement allowPath attributes
 */
class Et2Url extends Et2InvokerMixin(Et2Textbox) {
  /** @type {any} */
  static get properties() {
    return _objectSpread$5(_objectSpread$5({}, super.properties), {}, {
      /**
       * Allow a path instead of a URL, path must start with /, default false = not allowed
       */
      allowPath: {
        type: Boolean
      },
      /**
       * Require (or forbid) that the path ends with a /, default not checked
       */
      trailingSlash: {
        type: Boolean
      }
    });
  }
  static get styles() {
    return [...super.styles, colorsDefStyles, i$b(_templateObject$8 || (_templateObject$8 = _taggedTemplateLiteral$8(["\n\t\t\t\t::slotted([slot=\"suffix\"]) {\n\t\t\t\t\tfont-size: 133% !important;\n\t\t\t\t\tposition: relative;\n\t\t\t\t\theight: auto;\n\t\t\t\t\twidth: auto;\n\t\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);
    this._invokerLabel = '⎆';
    this._invokerTitle = 'Open';
    this._invokerAction = () => {
      Et2Url.action(this.value);
    };
    this.allowPath = false;
    this.trailingSlash = undefined;
  }

  /**
   * Change handler calling custom handler set via onchange attribute
   *
   * Reimplemented to add/remove trailing slash depending on trailingSlash attribute
   *
   * @param _ev
   * @returns
   */
  _oldChange(_ev) {
    var value = this.modelValue;
    if (typeof this.trailingSlash !== 'undefined' && value && this.trailingSlash !== (value.substr(-1) === '/')) {
      if (!this.trailingSlash) {
        this.modelValue = value.replace(/\/+$/, '');
      } else {
        this.modelValue += '/';
      }
    }
    return super._oldChange(_ev);
  }
  static action(value) {
    if (!value) return;
    // implicit add http:// if no protocol given
    if (value.indexOf("://") === -1) value = "http://" + value;
    // as this is static, we can NOT use this.egw(), but global egw
    egw$1.open_link(value, '_blank');
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url", Et2Url);

var _templateObject$7;
function _taggedTemplateLiteral$7(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$E(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @customElement et2-url_ro
 */
class Et2UrlReadonly extends Et2Description {
  constructor() {
    super(...arguments);
    // Don't try to translate URLs (or sub-classes)
    _defineProperty$E(this, "noLang", true);
  }
  static get styles() {
    return [...super.styles, i$b(_templateObject$7 || (_templateObject$7 = _taggedTemplateLiteral$7(["\n\t\t\t  \n\t\t\ta {\n\t\t\t\tcursor: pointer;\n\t\t\t\tcolor: #26537c !important;\n\t\t\t    text-decoration: none !important;\n\t\t\t}"])))];
  }
  transformAttributes(attrs) {
    if (typeof attrs.onclick === 'undefined') {
      attrs.onclick = () => {
        if (this.value) {
          Et2Url.action(this.value);
        }
      };
    }
    super.transformAttributes(attrs);
  }

  /**
   * Override parent render so we can have the special case where label is used as link text
   *
   * @returns {TemplateResult<1>}
   * @protected
   */
  render() {
    if (this.label && !this.href && this.value) {
      // We have label & value, use label as link text
      return this.wrapLink(this.value, this.label);
    }
    return super.render();
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url_ro", Et2UrlReadonly);

var _templateObject$6;
function _taggedTemplateLiteral$6(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * @customElement et2-url-email
 */
class Et2UrlEmail extends Et2InvokerMixin(Et2Textbox) {
  static get styles() {
    return [...super.styles, colorsDefStyles, i$b(_templateObject$6 || (_templateObject$6 = _taggedTemplateLiteral$6(["\n\t\t\t\t::slotted([slot=\"suffix\"]) {\n\t\t\t\t\tfont-size: 90% !important;\n\t\t\t\t\theight: auto;\n\t\t\t\t\twidth: auto;\n\t\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);
    this.defaultValidators.push(new IsEmail());
    this._invokerLabel = '@';
    this._invokerTitle = 'Compose mail to';
    this._invokerAction = () => {
      if (this.value.length > 0 && !this.hasFeedbackFor.length) {
        Et2UrlEmail.action(this.value);
      }
    };
  }
  static action(value) {
    if (value && egw$1.user('apps').mail && egw$1.preference('force_mailto', 'addressbook') != '1') {
      egw$1.open_link('mailto:' + value);
    } else {
      window.open("mailto:" + value);
    }
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url-email", Et2UrlEmail);

var _dec, _class$1, _descriptor;
function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _defineProperty$D(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

/**
 * @customElement et2-url-email_ro
 */
var Et2UrlEmailReadonly = (_dec = e$c({
  type: String
}), (_class$1 = class Et2UrlEmailReadonly extends Et2UrlReadonly {
  constructor() {
    super(...arguments);
    /**
     * What to display for the selected email addresses
     *
     *  - email: "test@example.com" (default)
     *	- full: "Mr Test User <test@example.com>
     *	- name: "Mr Test User"
     *	- domain: "Mr Test User (example.com)"
     *  - preference: use the users preference, like et2-email does
     *
     * If name is unknown, we'll use the email instead.
     */
    _initializerDefineProperty(this, "emailDisplay", _descriptor, this);
  }
  set value(val) {
    this._value = val;
    var split = splitEmail(this._value);
    super.statustext = split.name ? split.email : "";
    formatEmailAddress(val, !this.emailDisplay ? "email" : this.emailDisplay === 'preference' ? null : this.emailDisplay).then(value => super.value = value);
  }
  get value() {
    return super.value;
  }
  transformAttributes(attrs) {
    if (typeof attrs.onclick === 'undefined') {
      attrs.onclick = () => {
        var email = this._value;
        if (!IsEmail.EMAIL_PREG.exec(email)) {
          var name = this._value;
          // do we need to remove the domain in brackets again?
          if ((this.emailDisplay === 'preference' ? window.egw.preference("emailTag", "mail") : this.emailDisplay) === 'domain') {
            name = this._value.replace(/ \([^@. ]+\.[^@ )]+\)$/, '');
          }
          email = '"' + name + '" <' + this.statustext + '>';
        }
        if (IsEmail.EMAIL_PREG.exec(email)) {
          Et2UrlEmail.action(email);
        }
      };
    }
    super.transformAttributes(attrs);
  }
}, (_descriptor = _applyDecoratedDescriptor(_class$1.prototype, "emailDisplay", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class$1));
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url-email_ro", Et2UrlEmailReadonly);

var _templateObject$5;
function _taggedTemplateLiteral$5(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * @customElement et2-url-phone
 */
class Et2UrlPhone extends Et2InvokerMixin(Et2Textbox) {
  static get styles() {
    return [...super.styles, colorsDefStyles, i$b(_templateObject$5 || (_templateObject$5 = _taggedTemplateLiteral$5(["\n\t\t\t\t::slotted([slot=\"suffix\"]) {\n\t\t\t\t\tfont-size: 133% !important;\n\t\t\t\t\theight: auto;\n\t\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);

    //this.defaultValidators.push(...);
    this._invokerLabel = '✆';
    this._invokerTitle = 'Call';
    this._invokerAction = () => {
      Et2UrlPhone.action(this.value);
    };
  }
  static action(value) {
    // Clean number
    value = value.replace('&#9829;', '').replace('(0)', '');
    value = value.replace(/[abc]/gi, 2).replace(/[def]/gi, 3).replace(/[ghi]/gi, 4).replace(/[jkl]/gi, 5).replace(/[mno]/gi, 6);
    value = value.replace(/[pqrs]/gi, 7).replace(/[tuv]/gi, 8).replace(/[wxyz]/gi, 9);
    // remove everything but numbers and plus, as telephon software might not like it
    value = value.replace(/[^0-9+]/g, '');
    if (!value) return; // don't try to dial an empty number

    // mobile Webkit (iPhone, Android) have precedence over server configuration!
    if (navigator.userAgent.indexOf('AppleWebKit') !== -1 && (navigator.userAgent.indexOf("iPhone") !== -1 || navigator.userAgent.indexOf("Android") !== -1)) {
      window.open("tel:" + value);
    } else if (egw.config("call_link")) {
      var link = egw.config("call_link")
      // tel: links use no URL encoding according to rfc3966 section-5.1.4
      .replace("%1", egw.config("call_link").substr(0, 4) == 'tel:' ? value : encodeURIComponent(value)).replace("%u", egw.user('account_lid')).replace("%t", egw.user('account_phone'));
      var popup = egw.config("call_popup");
      if (popup && popup !== '_self' || !link.match(/^https?:/))
        // execute non-http(s) links eg. tel: like before
        {
          egw.open_link(link, '_phonecall', popup);
        } else {
        // No popup, use AJAX.  We don't care about the response.
        window.fetch(link, {
          headers: {
            'Content-Type': 'application/json'
          },
          method: "GET"
        });
      }
    }
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url-phone", Et2UrlPhone);

/**
 * EGroupware eTemplate2 - Phone url/call widget
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Ralf Becker
 */

/**
 * @customElement et2-url-phone_ro
 */
class Et2UrlPhoneReadonly extends Et2UrlReadonly {
  transformAttributes(attrs) {
    if (typeof attrs.onclick === 'undefined') {
      attrs.onclick = () => {
        Et2UrlPhone.action(this.value);
      };
    }
    super.transformAttributes(attrs);
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url-phone_ro", Et2UrlPhoneReadonly);

var _templateObject$4;
function _taggedTemplateLiteral$4(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * @customElement et2-url-phone
 */
class Et2UrlFax extends Et2UrlPhone {
  static get styles() {
    return [...super.styles, colorsDefStyles, i$b(_templateObject$4 || (_templateObject$4 = _taggedTemplateLiteral$4(["\n\t\t\t\t::slotted([slot=\"suffix\"]) {\n\t\t\t\t\tfont-size: 90% !important;\n\t\t\t\t\tposition: relative;\n\t\t\t\t\theight: auto;\n\t\t\t\t\twidth: auto;\n\t\t\t\t}\n\t\t\t"])))];
  }
  constructor() {
    super(...arguments);

    //this.defaultValidators.push(...);
    this._invokerLabel = '📠';
    this._invokerTitle = 'Send';
    this._invokerAction = () => {
      Et2UrlFax.action(this.value);
    };
  }
  static action(value) {
    // convert fax numbers to email, if configured
    if (egw.config('fax_email') && (value = value.replace('&#9829;', '').replace('(0)', '').replace(/[^0-9+]/g, ''))) {
      value = value.replace(new RegExp(egw.config('fax_email_regexp') || '(.*)'), egw.config('fax_email'));
      Et2UrlEmail.action(value);
    } else {
      Et2UrlPhone.action(value);
    }
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url-fax", Et2UrlFax);

/**
 * EGroupware eTemplate2 - Fax url/send widget
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Ralf Becker
 */

/**
 * @customElement et2-url-fax_ro
 */
class Et2UrlFaxReadonly extends Et2UrlReadonly {
  transformAttributes(attrs) {
    if (typeof attrs.onclick === 'undefined') {
      attrs.onclick = () => {
        Et2UrlFax.action(this.value);
      };
    }
    super.transformAttributes(attrs);
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-url-fax_ro", Et2UrlFaxReadonly);

var _templateObject$3, _templateObject2$3;
function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { _defineProperty$C(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$3(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$C(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Split extends Et2Widget(SlotMixin(split_panel_default)) {
  static get styles() {
    return [...super.styles, colorsDefStyles, i$b(_templateObject$3 || (_templateObject$3 = _taggedTemplateLiteral$3(["\n\t\t\t:host {\n\t\t\t\theight: 100%;\n\t\t\t}\n\t\t\tslot:not([name='handle'])::slotted(*) {\n\t\t\t\theight: 100%;\n\t\t\t\twidth: 100%;\n\t\t\t}\n\t\t\t::slotted(.split-handle) {\n\t\t\t\tposition: absolute;\n\t\t\t\twidth: 20px;\n\t\t\t\theight: 20px;\n\t\t\t\tbackground-image: ", ";\n\t\t\t\tbackground-position: center;\n\t\t\t\tbackground-repeat: no-repeat;\n\t\t\t}\n\t\t\t:host([vertical]) ::slotted(.split-handle) {\n\t\t\t\tbackground-image: ", ";\n\t\t\t}\n\t\t\t.divider {\n\t\t\t\tbackground-color: var(--gray_10)\n\t\t\t}\n\t\t\t.divider:hover {\n\t\t\t\tfilter: brightness(85%);\n\t\t\t}\n\t\t\t"])), cssImage("splitter_vert"), cssImage("splitter_horz"))];
  }
  static get properties() {
    return _objectSpread$4(_objectSpread$4({}, super.properties), {}, {
      /**
       * The current position of the divider from the primary panel's edge as a percentage 0-100.
       * Defaults to 50% of the container's initial size
       */
      position: Number,
      /**
       * If no primary panel is designated, both panels will resize proportionally and docking is disabled
       * "start" | "end" | undefined
       */
      primary: String,
      /**
       * Legacy orientation
       * "v" | "h"
       * @deprecated use vertical=true|false instead
       */
      orientation: String
    });
  }
  get slots() {
    return {
      handle: () => {
        return this._handleTemplate();
      }
    };
  }
  constructor() {
    super();

    // Bind handlers to instance
    _defineProperty$C(this, "_resize_timeout", null);
    _defineProperty$C(this, "_undock_position", undefined);
    // To hold troublesome elements we need to hide while resizing
    _defineProperty$C(this, "_hidden", []);
    this._handleResize = this._handleResize.bind(this);
    this._handleMouseDown = this._handleMouseDown.bind(this);
    this._handleMouseUp = this._handleMouseUp.bind(this);
    this._handleDoubleClick = this._handleDoubleClick.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();

    // Add listeners
    this.addEventListener("sl-reposition", this._handleResize);

    // Wait for everything to complete,
    this.getUpdateComplete().then(() => {
      // Divider node not available earlier
      this._dividerNode.addEventListener("mousedown", this._handleMouseDown);
      this._dividerNode.addEventListener("mouseup", this._handleMouseUp);
      this._dividerNode.addEventListener("dblclick", this._handleDoubleClick);

      // now tell legacy children to resize
      this.iterateOver(widget => {
        // Nextmatches (and possibly other "full height" widgets) need to be adjusted
        // Trigger the dynamic height thing to re-initialize
        // TODO: When dynheight goes away, this can too
        if (typeof widget.dynheight !== "undefined") {
          var outerNodetopOffset = widget.dynheight.outerNode.offset().top;
          widget.dynheight.outerNode = {
            // Random 3px deducted to make things fit better.  Otherwise nm edges are hidden
            width: () => parseInt(getComputedStyle(this.querySelector("[slot='start']")).width) - 3,
            height: () => parseInt(getComputedStyle(this.querySelector("[slot='start']")).height) - 3,
            offset: () => {
              return {
                top: outerNodetopOffset
              };
            }
          };
          widget.dynheight._collectBottomNodes = function () {
            this.bottomNodes = []; //widget.dynheight.bottomNodes.filter((node) => (node[0].parentNode != this));
          };
        }

        if (widget.resize) {
          widget.resize();
        }
      }, this, et2_DOMWidget);
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("sl-reposition", this._handleResize);
    this._dividerNode.removeEventListener("mousedown", this._handleMouseDown);
    this._dividerNode.removeEventListener("mouseup", this._handleMouseUp);
    this._dividerNode.removeEventListener("dblclick", this._handleDoubleClick);
  }

  /**
   * Determine if the splitter is docked
   * @return boolean
   */
  isDocked() {
    // Docked if we have a primary set, and we're all the way to one side
    return this.primary == "start" && this.position == 100 || this.primary == "end" && this.position == 0;
  }

  /**
   * Toggle docked or not
   *
   * @param {boolean} dock
   */
  toggleDock(dock) {
    // Need a primary panel designated so we know which one disappears
    if (typeof this.primary == "undefined") {
      return;
    }
    if (typeof dock == "undefined") {
      dock = !this.isDocked();
    }
    var undocked = typeof this._undock_position == "undefined" || [0, 100].indexOf(this._undock_position) != -1 ? 50 : this._undock_position;
    this.position = dock ? this.primary == 'start' ? 100 : 0 : undocked;
  }
  dock() {
    return this.toggleDock(true);
  }
  undock() {
    return this.toggleDock(false);
  }

  /**
   * Set the orientation of the splitter
   *
   * "h" for the splitter bar to be horizontal (children are stacked vertically)
   * "v" for the splitter bar to be vertical (children are side by side horizontally)
   *
   * @param {string} orientation
   */
  set orientation(orientation) {
    this.vertical = orientation == "h";
    this.requestUpdate("vertical");
  }
  get orientation() {
    return this.vertical ? "h" : "v";
  }

  /**
   * Load user's size preference
   *
   * @protected
   */
  _loadPreference() {
    if (!this.id) {
      return;
    }
    var pref = this.egw().preference(Et2Split.PREF_PREFIX + this.id, this.egw().getAppName());
    if (pref) {
      // Doesn't matter if it's left or top or what, we just want the number
      this.position = parseInt(Object.values(pref)[0]);
      if (typeof this.position != "number" || isNaN(this.position)) {
        this.position = 50;
      }
    }
    this._undock_position = this.position;
  }

  /**
   * Save the current position to user preference
   *
   * @protected
   */
  _savePreference() {
    if (!this.id || !this.egw() || !this.position) {
      return;
    }

    // Store current position in preferences
    var size = this.vertical ? {
      sizeTop: Math.round(this.position)
    } : {
      sizeLeft: Math.round(this.position)
    };
    this.egw().set_preference(this.egw().getAppName(), Et2Split.PREF_PREFIX + this.id, size);

    // make sure mouse up is handled when the mouse position has crossed the min/max points. The mouseup event does not
    // get called naturally in those situations.
    if (this.position <= parseInt(this.style.getPropertyValue('--min')) || this.position >= parseInt(this.style.getPropertyValue('--max'))) {
      this._handleMouseUp();
    }
  }

  /**
   * Handle changes that have to happen based on changes to properties
   *
   */
  updated(changedProperties) {
    super.updated(changedProperties);

    // if ID changes, check preference
    if (changedProperties.has("id") && this.id) {
      this._loadPreference();
    }
  }

  /**
   * Override parent to avoid resizing when not visible, as that breaks size calculations
   *
   * @returns {any}
   */
  handlePositionChange() {
    if (this.offsetParent !== null) {
      return super.handlePositionChange();
    }
  }

  /**
   * Override parent to avoid resizing when not visible, as that breaks size calculations
   */
  handleResize(entries) {
    if (this.offsetParent !== null) {
      return super.handleResize(entries);
    }
  }

  /**
   * Handle a resize
   * This includes notifying any manually resizing widgets, and updating preference if needed
   *
   *
   * @param e
   */
  _handleResize(e) {
    var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
    // Update where we would undock to
    if (this.position != 0 && this.position != 100) {
      this._undock_position = this.position;
    }
    if (this._resize_timeout) {
      clearTimeout(this._resize_timeout);
    }
    this._resize_timeout = setTimeout(function () {
      this._resize_timeout = undefined;
      this._savePreference();

      // Tell widgets that manually resize about it
      this.iterateOver(function (_widget) {
        if (typeof _widget.resize === 'function') {
          _widget.resize();
        }
      }, self, et2_IResizeable);
    }.bind(this), timeout);
  }

  /**
   * Handle doubleclick (on splitter bar) to dock
   */
  _handleDoubleClick(e) {
    this.toggleDock();
  }

  /**
   * Hide child iframes, they screw up sizing
   * @param e
   */
  _handleMouseDown(e) {
    var hidden = ['iframe'];
    for (var tag of hidden) {
      var hide = this.querySelectorAll(tag);
      this._hidden.push(...hide);
      for (var h of hide) {
        h.style.visibility = "hidden";
        this.egw().loading_prompt(this.id, true, this.egw().lang('Recalculating frame size...'), h.parentElement);
      }
    }

    // If they move quickly, the mouse can leave the divider and we won't get the mouseup
    // On firefox, this causes incorrect sizes
    var listener = e => {
      this._handleMouseUp(e);
      this.getRootNode().removeEventListener("mouseup", listener);
    };
    this.getRootNode().addEventListener("mouseup", listener);
  }

  /**
   * Show any hidden children
   */
  _handleMouseUp(e) {
    for (var h of this._hidden) {
      h.style.visibility = "initial";
      this.egw().loading_prompt(this.id, false);
    }
    // Do resize a little later for fast draggers using firefox
    this._handleResize(e, 500);
  }

  /**
   * HTML template for split handle
   */
  _handleTemplate() {
    return x$1(_templateObject2$3 || (_templateObject2$3 = _taggedTemplateLiteral$3(["\n            <div class=\"split-handle\"></div>"])));
  }
  get _dividerNode() {
    return this.shadowRoot.querySelector("[part='divider']");
  }

  /**
   * Loads the widget tree from an XML node
   * Overridden here to auto-assign slots if not set
   *
   * @param _node xml node
   */
  loadFromXML(_node) {
    super.loadFromXML(_node);
    for (var i = 0; i < this.getChildren().length && i < Et2Split.PANEL_NAMES.length; i++) {
      var child = this.getChildren()[i].getDOMNode();
      if (child && !child.getAttribute("slot")) {
        child.setAttribute("slot", Et2Split.PANEL_NAMES[i]);
      }
    }
  }
}
_defineProperty$C(Et2Split, "PREF_PREFIX", "splitter-size-");
_defineProperty$C(Et2Split, "PANEL_NAMES", ["start", "end"]);
customElements.define("et2-split", Et2Split);

function _defineProperty$B(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "textbox" XET-Tag
 *
 * @augments et2_inputWidget
 */
class et2_textbox extends et2_inputWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_textbox._attributes, _child || {}));
    _defineProperty$B(this, "input", null);
    _defineProperty$B(this, "size", void 0);
    _defineProperty$B(this, "maxLength", void 0);
    this.input = null;
    this.createInputWidget();
  }
  createInputWidget() {
    if (this.options.multiline || this.options.rows > 1 || this.options.cols > 1) {
      this.input = jQuery(document.createElement("textarea"));
      if (this.options.rows > 0) {
        this.input.attr("rows", this.options.rows);
      }
      if (this.options.cols > 0) {
        this.input.attr("cols", this.options.cols);
      }
    } else {
      this.input = jQuery(document.createElement("input"));
      switch (this.options.type) {
        case "hidden":
          this.input.attr("type", "hidden");
          break;
      }
      if (this.options.autocomplete) this.input.attr("autocomplete", this.options.autocomplete);
    }
    if (this.options.size) {
      this.set_size(this.options.size);
    }
    if (this.options.blur) {
      this.set_blur(this.options.blur);
    }
    if (this.options.readonly) {
      this.set_readonly(true);
    }
    this.input.addClass("et2_textbox");
    this.setDOMNode(this.input[0]);
    if (this.options.value) {
      this.set_value(this.options.value);
    }
    if (this.options.onkeypress && typeof this.options.onkeypress == 'function') {
      var self = this;
      this.input.keypress(function (_ev) {
        return self.options.onkeypress.call(this, _ev, self);
      });
    }
  }
  destroy() {
    var node = this.getInputNode();
    if (node) jQuery(node).unbind("keypress");
    super.destroy();
  }
  getValue() {
    // only return "" for blur-value, if browser does not support html5 placeholder
    if (this.options && this.options.blur && this.input && !this.input[0].placeholder && this.input.val() == this.options.blur) {
      return "";
    }
    return super.getValue();
  }

  /**
   * Clientside validation using regular expression in "validator" attribute
   *
   * @param {array} _messages
   */
  isValid(_messages) {
    var ok = true;
    // Check input is valid
    if (this.options && this.options.validator && !this.options.readonly && !this.disabled) {
      if (typeof this.options.validator == 'string') {
        var parts = this.options.validator.split('/');
        var flags = parts.pop();
        if (parts.length < 2 || parts[0] !== '') {
          _messages.push(this.egw().lang("'%1' has an invalid format !!!", this.options.validator));
          return false; // show invalid expression
        }

        parts.shift();
        this.options.validator = new RegExp(parts.join('/'), flags);
      }
      var value = this.getValue();
      if (!(ok = this.options.validator.test(value))) {
        _messages.push(this.egw().lang("'%1' has an invalid format !!!", value));
      }
    }
    return super.isValid(_messages) && ok;
  }

  /**
   * Set input widget size
   * @param _size Rather arbitrary size units, approximately characters
   */
  set_size(_size) {
    if (this.options.multiline || this.options.rows > 1 || this.options.cols > 1) {
      this.input.css('width', _size + "em");
    } else if (typeof _size != 'undefined' && _size != parseInt(this.input.attr("size"))) {
      this.size = _size;
      this.input.attr("size", this.size);
    }
  }

  /**
   * Set maximum characters allowed
   * @param _size Max characters allowed
   */
  set_maxlength(_size) {
    if (typeof _size != 'undefined' && _size != parseInt(this.input.attr("maxlength"))) {
      this.maxLength = _size;
      this.input.attr("maxLength", this.maxLength);
    }
  }

  /**
   * Set HTML readonly attribute.
   * Do not confuse this with etemplate readonly, which would use et_textbox_ro instead
   * @param _readonly Boolean
   */
  set_readonly(_readonly) {
    this.input.attr("readonly", _readonly);
    this.input.toggleClass('et2_textbox_ro', _readonly);
  }
  set_blur(_value) {
    if (_value) {
      this.input.attr("placeholder", this.egw().lang(_value) + ""); // HTML5
      if (!this.input[0].placeholder) {
        // Not HTML5
        if (this.input.val() == "") this.input.val(this.egw().lang(this.options.blur));
        this.input.focus(this, function (e) {
          if (e.data.input.val() == e.data.egw().lang(e.data.options.blur)) e.data.input.val("");
        }).blur(this, function (e) {
          if (e.data.input.val() == "") e.data.input.val(e.data.egw().lang(e.data.options.blur));
        });
      }
    } else {
      if (!this.getValue()) this.input.val('');
      this.input.removeAttr("placeholder");
    }
    this.options.blur = _value;
  }
  set_autocomplete(_value) {
    this.options.autocomplete = _value;
    this.input.attr('autocomplete', _value);
  }
  resize(_height) {
    if (_height && this.options.multiline) {
      // apply the ratio
      _height = this.options.resize_ratio != '' ? _height * this.options.resize_ratio : _height;
      if (_height != 0) {
        this.input.height(this.input.height() + _height);
        // resize parent too, so mailvelope injected into parent inherits its height
        this.input.parent().height(this.input.parent().height() + _height);
      }
    }
  }
}
_defineProperty$B(et2_textbox, "_attributes", {
  "multiline": {
    "name": "multiline",
    "type": "boolean",
    "default": false,
    "description": "If true, the textbox is a multiline edit field."
  },
  "size": {
    "name": "Size",
    "type": "integer",
    "default": et2_no_init,
    "description": "Field width"
  },
  "maxlength": {
    "name": "Maximum length",
    "type": "integer",
    "default": et2_no_init,
    "description": "Maximum number of characters allowed"
  },
  "blur": {
    "name": "Placeholder",
    "type": "string",
    "default": "",
    "description": "This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."
  },
  // These for multi-line
  "rows": {
    "name": "Rows",
    "type": "integer",
    "default": -1,
    "description": "Multiline field height - better to use CSS"
  },
  "cols": {
    "name": "Size",
    "type": "integer",
    "default": -1,
    "description": "Multiline field width - better to use CSS"
  },
  "validator": {
    "name": "Validator",
    "type": "string",
    "default": et2_no_init,
    "description": "Perl regular expression eg. '/^[0-9][a-f]{4}$/i'"
  },
  onkeypress: {
    name: "onKeypress",
    type: "js",
    default: et2_no_init,
    description: "JS code or app.$app.$method called when key is pressed, return false cancels it."
  }
});
_defineProperty$B(et2_textbox, "legacyOptions", ["size", "maxlength", "validator"]);
et2_register_widget(et2_textbox, ["textbox", "hidden"]);

/**
 * et2_textbox_ro is the dummy readonly implementation of the textbox.
 *
 * @augments et2_valueWidget
 */
class et2_textbox_ro extends et2_valueWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_textbox_ro._attributes, _child || {}));
    _defineProperty$B(this, "value", "");
    _defineProperty$B(this, "span", void 0);
    _defineProperty$B(this, "value_span", void 0);
    this.span = jQuery(document.createElement("label")).addClass("et2_label");
    this.value_span = jQuery(document.createElement("span")).addClass("et2_textbox_ro").appendTo(this.span);
    this.setDOMNode(this.span[0]);
  }
  set_label(label) {
    // Remove current label
    this.span.contents().filter(function () {
      return this.nodeType == 3;
    }).remove();
    var parts = et2_csvSplit(label, 2, "%s");
    this.span.prepend(parts[0]);
    this.span.append(parts[1]);
    this.label = label;

    // add class if label is empty
    this.span.toggleClass('et2_label_empty', !label || !parts[0]);
  }
  set_value(_value) {
    this.value = _value;
    if (!_value) {
      _value = "";
    }
    if (this.label != "") {
      this.span.removeClass('et2_label_empty');
    } else {
      this.span.addClass('et2_label_empty');
    }
    this.value_span.text(_value);
  }

  /**
   * Code for implementing et2_IDetachedDOM
   *
   * @param {array} _attrs array to add further attributes to
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "label");
  }
  getDetachedNodes() {
    return [this.span[0], this.value_span[0]];
  }
  setDetachedAttributes(_nodes, _values) {
    this.span = jQuery(_nodes[0]);
    this.value_span = jQuery(_nodes[1]);
    if (typeof _values["label"] != 'undefined') {
      this.set_label(_values["label"]);
    }
    if (typeof _values["value"] != 'undefined') {
      this.set_value(_values["value"]);
    }
  }
}
/**
 * Ignore all more advanced attributes.
 */
_defineProperty$B(et2_textbox_ro, "_attributes", {
  "multiline": {
    "ignore": true
  },
  "maxlength": {
    "ignore": true
  },
  "onchange": {
    "ignore": true
  },
  "rows": {
    "ignore": true
  },
  "cols": {
    "ignore": true
  },
  "size": {
    "ignore": true
  },
  "needed": {
    "ignore": true
  }
});
et2_register_widget(et2_textbox_ro, ["textbox_ro"]);

/**
 * et2_searchbox is a widget which provides a collapsable input search
 * with on searching indicator and clear handler regardless of any browser limitation.
 */
class et2_searchbox extends et2_textbox {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_searchbox._attributes, _child || {}));
    _defineProperty$B(this, "value", "");
    _defineProperty$B(this, "div", void 0);
    _defineProperty$B(this, "flex", void 0);
    _defineProperty$B(this, "button", void 0);
    _defineProperty$B(this, "search", void 0);
    _defineProperty$B(this, "oldValue", void 0);
    _defineProperty$B(this, "clear", void 0);
  }
  createInputWidget() {
    var self = this;
    this.div = jQuery(document.createElement('div')).addClass('et2_searchbox');
    this.flex = jQuery(document.createElement('div')).addClass('flex').appendTo(this.div);
    this.setDOMNode(this.div[0]);
    if (this.options.overlay) this.flex.addClass('overlay');

    // search button indicator
    // no need to create search button if it's a fix search field
    if (!this.options.fix) {
      this.button = jQuery(document.createElement('button')).css({
        "background-image": egw$1.image('search')
      }).click(function () {
        self._show_hide(jQuery(self.flex).hasClass('hide'));
        self.search.input.focus();
      }).addClass('et2_button');
      this.div.prepend(this.button);
    }
    // input field
    this.search = et2_createWidget('textbox', {
      "blur": egw$1.lang("search"),
      onkeypress: function onkeypress(event) {
        if (event.which == 13) {
          event.preventDefault();
          self.getInstanceManager().autocomplete_fixer();
          // Use a timeout to make sure we get the autocomplete value,
          // if one was chosen, instead of what was actually typed.
          // Chrome doesn't need this, but FF does.
          window.setTimeout(function () {
            self.set_value(self.search.input.val());
            self.change();
          }, 0);
        }
      }
    }, this);
    // Autocomplete needs name
    this.search.input.attr('name', this.id || 'searchbox');
    this.search.input.on({
      keyup: function keyup(event) {
        self.clear.toggle(self.get_value() != '' || !self.options.fix);
        if (event.which == 27)
          // Escape
          {
            // Excape clears search
            self.set_value('');
          }
      },
      blur(event) {
        if (egwIsMobile()) return;
        if (!event.relatedTarget || !jQuery(event.relatedTarget.parentNode).hasClass('et2_searchbox')) {
          self._show_hide(!self.options.overlay && self.get_value());
        }
        if (typeof self.oldValue != 'undefined' && self._oldValue != self.get_value()) {
          self.change();
        }
      },
      mousedown: function mousedown(event) {
        if (event.target.tagName == 'span') event.stopImmediatePropagation();
      }
    });

    // clear button implementation
    this.clear = jQuery(document.createElement('span')).addClass('ui-icon clear').toggle(!this.options.fix || this._oldValue != '' && !jQuery.isEmptyObject(this._oldValue)).on('mousedown', function (event) {
      event.preventDefault();
    }).on('click', function (event) {
      if (self.get_value()) {
        self.search.input.val('');
        self.search.input.focus();
        self._show_hide(true);
        if (self._oldValue) self.change();
      } else {
        self._show_hide(false);
      }
      if (self.options.fix) self.clear.hide();
    }).appendTo(this.flex);
  }

  /**
   * Show/hide search field
   * @param {boolean} _stat true means show and false means hide
   */
  _show_hide(_stat) {
    // Not applied for fix option
    if (this.options.fix) return;
    jQuery(this.flex).toggleClass('hide', !_stat);
    jQuery(this.getDOMNode(this)).toggleClass('expanded', _stat);
  }

  /**
   * toggle search button status based on value
   */
  _searchToggleState() {
    if (this.options.fix || egwIsMobile()) return;
    if (!this.get_value()) {
      jQuery(this.button.getDOMNode()).removeClass('toolbar_toggled');
      this.button.set_statustext('');
    } else {
      jQuery(this.button.getDOMNode()).addClass('toolbar_toggled');
      this.button.set_statustext(egw$1.lang("search for '%1'", this.get_value()));
    }
  }

  /**
   * override change function in order to preset the toggle state
   */
  change() {
    this._searchToggleState();
    super.change.apply(this, arguments);
  }
  getInputNode() {
    var _this$search;
    return (_this$search = this.search) === null || _this$search === void 0 ? void 0 : _this$search.input.get(0);
  }
  get_value() {
    return this.search.input.val();
  }
  set_value(_value) {
    super.set_value(_value);
    if (this.search) {
      this.search.input.val(_value);
      this.clear.toggle(_value != '');
    }
  }
  set_readonly(_readonly) {
    this.search.set_readonly(_readonly);
  }
  set_blur(_value) {
    this.search.set_blur(_value);
  }
  /**
   * override doLoadingFinished in order to set initial state
   */
  doLoadingFinished() {
    super.doLoadingFinished();
    if (!this.get_value()) {
      this._show_hide(false);
    } else {
      this._show_hide(!this.options.overlay);
      this._searchToggleState();
    }
    return true;
  }
  getDOMNode(asker) {
    if (asker && asker.getParent() == this) {
      return this.flex[0];
    }
    return super.getDOMNode(asker);
  }
  /**
   * Overrride attachToDOM in order to unbind change handler
   */
  attachToDOM() {
    var ret = super.attachToDOM();
    var node = this.getInputNode();
    if (node) {
      jQuery(node).off('.et2_inputWidget');
    }
    return ret;
  }
}
/**
 * Advanced attributes
 */
_defineProperty$B(et2_searchbox, "_attributes", {
  overlay: {
    name: "Overlay searchbox",
    type: "boolean",
    default: false,
    description: "Define wheter the searchbox overlays while it's open (true) or stay as solid box infront of the search button (false). Default is false."
  },
  fix: {
    name: "Fix searchbox",
    type: "boolean",
    default: true,
    description: "Define whether the searchbox should be a fix input field or flexible search button. Default is true (fix)."
  }
});
et2_register_widget(et2_searchbox, ["searchbox"]);

function _defineProperty$A(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "description" XET-Tag
 *
 * @deprecated use Et2Description
 * @todo remove after extending widgets are ported to web-components
 */
class et2_description extends et2_baseWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_description._attributes, _child || {}));

    // Create the span/label tag which contains the label text
    _defineProperty$A(this, "span", void 0);
    _defineProperty$A(this, "label", void 0);
    _defineProperty$A(this, "_labelContainer", null);
    _defineProperty$A(this, "font_style", void 0);
    _defineProperty$A(this, "mime_regexp", void 0);
    this.span = jQuery(document.createElement(this.options["for"] ? "label" : "span")).addClass("et2_label");
    et2_insertLinkText(this._parseText(this.options.value), this.span[0], this.options.href ? this.options.extra_link_target : '_blank');
    this.setDOMNode(this.span[0]);
  }
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
    if (this.id) {
      var val = this.getArrayMgr("content").getEntry(this.id);
      if (val) {
        _attrs["value"] = val;
      }
    }
  }
  doLoadingFinished() {
    super.doLoadingFinished();

    // Get the real id of the 'for' widget
    var for_widget = null;
    var for_id = "";
    if (this.options["for"] && ((for_widget = this.getParent().getWidgetById(this.options.for)) || (for_widget = this.getRoot().getWidgetById(this.options.for))) && for_widget && for_widget.id) {
      if (for_widget.dom_id || for_widget.getDOMNode().id) {
        for_id = for_widget.dom_id || for_widget.getDOMNode().id;
        if (for_widget.instanceOf(et2_IInputNode) && for_widget.getInputNode() && for_id !== for_widget.getInputNode().id) {
          for_id = for_widget.getInputNode().id;
        }
        this.span.attr("for", for_id);
      } else {
        // Target widget is not done yet, need to wait
        return new Promise(resolve => {
          window.setTimeout(() => {
            var _for_widget$getInputN;
            for_id = for_widget.dom_id;
            if (for_widget.instanceOf(et2_inputWidget) && for_widget.getInputNode() && for_widget.dom_id !== ((_for_widget$getInputN = for_widget.getInputNode()) === null || _for_widget$getInputN === void 0 ? void 0 : _for_widget$getInputN.id)) {
              for_id = for_widget.getInputNode().id;
            }
            this.span.attr("for", for_id);
            resolve();
          }, 0);
        });
      }
    }
    return true;
  }
  set_label(_value) {
    // Abort if there was no change in the label
    if (_value == this.label) {
      return;
    }
    if (_value) {
      // Create the label container if it didn't exist yet
      if (this._labelContainer == null) {
        this._labelContainer = jQuery(document.createElement("label")).addClass("et2_label");
        this.getSurroundings().insertDOMNode(this._labelContainer[0]);
      }

      // Clear the label container.
      this._labelContainer.empty();

      // Create the placeholder element and set it
      var ph = document.createElement("span");
      this.getSurroundings().setWidgetPlaceholder(ph);

      // Split the label at the "%s"
      var parts = et2_csvSplit(_value, 2, "%s");

      // Update the content of the label container
      for (var i = 0; i < parts.length; i++) {
        if (parts[i]) {
          this._labelContainer.append(document.createTextNode(parts[i]));
        }
        if (i == 0) {
          this._labelContainer.append(ph);
        }
      }

      // add class if label is empty
      this._labelContainer.toggleClass('et2_label_empty', !_value || !parts[0]);
    } else {
      // Delete the labelContainer from the surroundings object
      if (this._labelContainer) {
        this.getSurroundings().removeDOMNode(this._labelContainer[0]);
      }
      this._labelContainer = null;
    }

    // Update the surroundings in order to reflect the change in the label
    this.getSurroundings().update();

    // Copy the given value
    this.label = _value;
  }

  /**
   * Function to get media content to feed the expose
   * @param {type} _value
   * @returns {Array|Array.getMedia.mediaContent}
   */
  getMedia(_value) {
    var base_url = egw$1.webserverUrl.match(new RegExp(/^\//, 'ig')) ? egw$1(window).window.location.origin : '';
    var mediaContent = [];
    if (_value) {
      mediaContent = [{
        title: this.options.label,
        href: base_url + _value,
        type: this.options.type + "/*",
        thumbnail: base_url + _value
      }];
      if (_value.match(/\/webdav.php/, 'ig')) mediaContent[0]["download_href"] = base_url + _value + '?download';
    }
    return mediaContent;
  }
  set_value(_value) {
    if (!_value) _value = "";
    if (!this.options.no_lang) _value = this.egw().lang(_value);
    if (this.options.value && (this.options.value + "").indexOf('%s') != -1) {
      _value = this.options.value.replace(/%s/g, _value);
    }
    et2_insertLinkText(this._parseText(_value), this.span[0], this.options.href ? this.options.extra_link_target : '_blank');
    // Add hover action button (Edit)
    if (this.options.hover_action) {
      this._build_hover_action();
    }
    if (this.options.extra_link_popup || this.options.mime) {
      var href = this.options.href;
      var mime_data = this.options.mime_data;
      var self = this;
      var $span = this.options.mime_data ? jQuery(this.span) : jQuery('a', this.span);
      $span.click(function (e) {
        if (self.options.expose_view && typeof self.options.mime != 'undefined' && self.options.mime.match(self.mime_regexp, 'ig')) {
          self._init_blueimp_gallery(e, href);
        } else {
          egw$1(window).open_link(mime_data || href, self.options.extra_link_target, self.options.extra_link_popup, null, null, self.options.mime);
        }
        e.preventDefault();
        return false;
      });
    }
  }
  _parseText(_value) {
    if (this.options.href) {
      var href = this.options.href;
      if (href.indexOf('/') == -1 && href.split('.').length >= 3 && !(href.indexOf('mailto:') != -1 || href.indexOf('://') != -1 || href.indexOf('javascript:') != -1)) {
        href = "/index.php?menuaction=" + href;
      }
      if (href.charAt(0) == '/')
        // link relative to eGW
        {
          href = egw$1.link(href);
        }
      return [{
        "href": href,
        "text": _value
      }];
    } else if (this.options.activate_links) {
      return et2_activateLinks(_value);
    } else {
      return [_value];
    }
  }
  set_font_style(_value) {
    this.font_style = _value;
    this.span.toggleClass("et2_bold", _value.indexOf("b") >= 0);
    this.span.toggleClass("et2_italic", _value.indexOf("i") >= 0);
  }

  /**
   * Code for implementing et2_IDetachedDOM
   *
   * @param {array} _attrs
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "class", "href");
  }
  getDetachedNodes() {
    return [this.span[0]];
  }
  setDetachedAttributes(_nodes, _values, _data) {
    // Update the properties
    var updateLink = false;
    if (typeof _values["href"] != "undefined") {
      updateLink = true;
      this.options.href = _values["href"];
    }
    if (typeof _values["value"] != "undefined" || updateLink && (_values["value"] || this.options.value)) {
      this.span = jQuery(_nodes[0]);
      this.set_value(_values["value"]);
    }
    if (typeof _values["class"] != "undefined") {
      _nodes[0].setAttribute("class", _values["class"]);
    }

    // Add hover action button (Edit), _data is nm's row data
    if (this.options.hover_action) {
      this._build_hover_action(_data);
    }
  }

  /**
   * Builds button for hover action
   * @param {object} _data
   */
  _build_hover_action(_data) {
    var content = _data && _data.content ? _data.content : undefined;
    var widget = this;
    this.span.off().on('mouseenter', jQuery.proxy(function (event) {
      event.stopImmediatePropagation();
      var self = this;
      this.span.tooltip({
        items: 'span.et2_label',
        position: {
          my: "right top",
          at: "left top",
          collision: "flipfit"
        },
        tooltipClass: "et2_email_popup",
        content() {
          return jQuery('<a href="#" class= "et2_url_email_contactPlus" title="' + widget.egw().lang(widget.options.hover_action_title) + '"><img src="' + egw$1.image("edit") + '"/></a>').on('click', function () {
            widget.options.hover_action.call(self, self.widget, content);
          });
        },
        close(event, ui) {
          ui.tooltip.hover(function () {
            jQuery(this).stop(true).fadeTo(400, 1);
          }, function () {
            jQuery(this).fadeOut("400", function () {
              jQuery(this).remove();
            });
          });
        }
      }).tooltip("open");
    }, {
      widget: this,
      span: this.span
    }));
    this.span.on('mouseout', function () {
      if (jQuery(this).tooltip('instance')) {
        jQuery(this).tooltip('close');
      }
    });
  }
}
_defineProperty$A(et2_description, "_attributes", {
  "label": {
    "name": "Label",
    "default": "",
    "type": "string",
    "description": "The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",
    "translate": true
  },
  "value": {
    "name": "Value",
    "type": "string",
    "description": "Displayed text",
    "translate": "!no_lang",
    "default": ""
  },
  /**
   * Options converted from the "options"-attribute.
   */
  "font_style": {
    "name": "Font Style",
    "type": "string",
    "description": "Style may be a compositum of \"b\" and \"i\" which " + " renders the text bold and/or italic."
  },
  "href": {
    "name": "Link URL",
    "type": "string",
    "description": "Link URL, empty if you don't wan't to display a link."
  },
  "activate_links": {
    "name": "Replace URLs",
    "type": "boolean",
    "default": false,
    "description": "If set, URLs in the text are automatically replaced " + "by links"
  },
  "for": {
    "name": "Label for widget",
    "type": "string",
    "description": "Marks the text as label for the given widget."
  },
  "extra_link_target": {
    "name": "Link target",
    "type": "string",
    "default": "_browser",
    "description": "Link target for href attribute"
  },
  "extra_link_popup": {
    "name": "Popup",
    "type": "string",
    "description": "widthxheight, if popup should be used, eg. 640x480"
  },
  "expose_view": {
    name: "Expose view",
    type: "boolean",
    default: false,
    description: "Clicking on description with href value would popup an expose view, and will show content referenced by href."
  },
  mime: {
    name: "Mime type",
    type: "string",
    default: '',
    description: "Mime type of the registered link"
  },
  mime_data: {
    name: "Mime data",
    type: "string",
    default: '',
    description: "hash for data stored on service-side with egw_link::(get|set)_data()"
  },
  hover_action: {
    "name": "hover action",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code which is executed when clicking on action button. This action is explicitly for attached nodes, like in nm."
  },
  hover_action_title: {
    "name": "hover action title",
    "type": "string",
    "default": "Edit",
    "description": "Text to show as tooltip of defined action"
  }
});
_defineProperty$A(et2_description, "legacyOptions", ["font_style", "href", "activate_links", "for", "extra_link_target", "extra_link_popup", "statustext"]);

var resumableExports = {};
var resumable$1 = {
  get exports(){ return resumableExports; },
  set exports(v){ resumableExports = v; },
};

/*
* MIT Licensed
* http://www.23developer.com/opensource
* http://github.com/23/resumable.js
* Steffen Tiedemann Christensen, steffen@23company.com
*/

(function (module) {
	(function(){
	"use strict";

	  var Resumable = function(opts){
	    if ( !(this instanceof Resumable) ) {
	      return new Resumable(opts);
	    }
	    this.version = 1.0;
	    // SUPPORTED BY BROWSER?
	    // Check if these features are support by the browser:
	    // - File object type
	    // - Blob object type
	    // - FileList object type
	    // - slicing files
	    this.support = (
	                   (typeof(File)!=='undefined')
	                   &&
	                   (typeof(Blob)!=='undefined')
	                   &&
	                   (typeof(FileList)!=='undefined')
	                   &&
	                   (!!Blob.prototype.webkitSlice||!!Blob.prototype.mozSlice||!!Blob.prototype.slice||false)
	                   );
	    if(!this.support) return(false);


	    // PROPERTIES
	    var $ = this;
	    $.files = [];
	    $.defaults = {
	      chunkSize:1*1024*1024,
	      forceChunkSize:false,
	      simultaneousUploads:3,
	      fileParameterName:'file',
	      chunkNumberParameterName: 'resumableChunkNumber',
	      chunkSizeParameterName: 'resumableChunkSize',
	      currentChunkSizeParameterName: 'resumableCurrentChunkSize',
	      totalSizeParameterName: 'resumableTotalSize',
	      typeParameterName: 'resumableType',
	      identifierParameterName: 'resumableIdentifier',
	      fileNameParameterName: 'resumableFilename',
	      relativePathParameterName: 'resumableRelativePath',
	      totalChunksParameterName: 'resumableTotalChunks',
	      dragOverClass: 'dragover',
	      throttleProgressCallbacks: 0.5,
	      query:{},
	      headers:{},
	      preprocess:null,
	      preprocessFile:null,
	      method:'multipart',
	      uploadMethod: 'POST',
	      testMethod: 'GET',
	      prioritizeFirstAndLastChunk:false,
	      target:'/',
	      testTarget: null,
	      parameterNamespace:'',
	      testChunks:true,
	      generateUniqueIdentifier:null,
	      getTarget:null,
	      maxChunkRetries:100,
	      chunkRetryInterval:undefined,
	      permanentErrors:[400, 401, 403, 404, 409, 415, 500, 501],
	      maxFiles:undefined,
	      withCredentials:false,
	      xhrTimeout:0,
	      clearInput:true,
	      chunkFormat:'blob',
	      setChunkTypeFromFile:false,
	      maxFilesErrorCallback:function (files, errorCount) {
	        var maxFiles = $.getOpt('maxFiles');
	        alert('Please upload no more than ' + maxFiles + ' file' + (maxFiles === 1 ? '' : 's') + ' at a time.');
	      },
	      minFileSize:1,
	      minFileSizeErrorCallback:function(file, errorCount) {
	        alert(file.fileName||file.name +' is too small, please upload files larger than ' + $h.formatSize($.getOpt('minFileSize')) + '.');
	      },
	      maxFileSize:undefined,
	      maxFileSizeErrorCallback:function(file, errorCount) {
	        alert(file.fileName||file.name +' is too large, please upload files less than ' + $h.formatSize($.getOpt('maxFileSize')) + '.');
	      },
	      fileType: [],
	      fileTypeErrorCallback: function(file, errorCount) {
	        alert(file.fileName||file.name +' has type not allowed, please upload files of type ' + $.getOpt('fileType') + '.');
	      }
	    };
	    $.opts = opts||{};
	    $.getOpt = function(o) {
	      var $opt = this;
	      // Get multiple option if passed an array
	      if(o instanceof Array) {
	        var options = {};
	        $h.each(o, function(option){
	          options[option] = $opt.getOpt(option);
	        });
	        return options;
	      }
	      // Otherwise, just return a simple option
	      if ($opt instanceof ResumableChunk) {
	        if (typeof $opt.opts[o] !== 'undefined') { return $opt.opts[o]; }
	        else { $opt = $opt.fileObj; }
	      }
	      if ($opt instanceof ResumableFile) {
	        if (typeof $opt.opts[o] !== 'undefined') { return $opt.opts[o]; }
	        else { $opt = $opt.resumableObj; }
	      }
	      if ($opt instanceof Resumable) {
	        if (typeof $opt.opts[o] !== 'undefined') { return $opt.opts[o]; }
	        else { return $opt.defaults[o]; }
	      }
	    };
	    $.indexOf = function(array, obj) {
	    	if (array.indexOf) { return array.indexOf(obj); }
	    	for (var i = 0; i < array.length; i++) {
	            if (array[i] === obj) { return i; }
	        }
	        return -1;
	    };

	    // EVENTS
	    // catchAll(event, ...)
	    // fileSuccess(file), fileProgress(file), fileAdded(file, event), filesAdded(files, filesSkipped), fileRetry(file),
	    // fileError(file, message), complete(), progress(), error(message, file), pause()
	    $.events = [];
	    $.on = function(event,callback){
	      $.events.push(event.toLowerCase(), callback);
	    };
	    $.fire = function(){
	      // `arguments` is an object, not array, in FF, so:
	      var args = [];
	      for (var i=0; i<arguments.length; i++) args.push(arguments[i]);
	      // Find event listeners, and support pseudo-event `catchAll`
	      var event = args[0].toLowerCase();
	      for (var i=0; i<=$.events.length; i+=2) {
	        if($.events[i]==event) $.events[i+1].apply($,args.slice(1));
	        if($.events[i]=='catchall') $.events[i+1].apply(null,args);
	      }
	      if(event=='fileerror') $.fire('error', args[2], args[1]);
	      if(event=='fileprogress') $.fire('progress');
	    };


	    // INTERNAL HELPER METHODS (handy, but ultimately not part of uploading)
	    var $h = {
	      stopEvent: function(e){
	        e.stopPropagation();
	        e.preventDefault();
	      },
	      each: function(o,callback){
	        if(typeof(o.length)!=='undefined') {
	          for (var i=0; i<o.length; i++) {
	            // Array or FileList
	            if(callback(o[i])===false) return;
	          }
	        } else {
	          for (i in o) {
	            // Object
	            if(callback(i,o[i])===false) return;
	          }
	        }
	      },
	      generateUniqueIdentifier:function(file, event){
	        var custom = $.getOpt('generateUniqueIdentifier');
	        if(typeof custom === 'function') {
	          return custom(file, event);
	        }
	        var relativePath = file.webkitRelativePath||file.relativePath||file.fileName||file.name; // Some confusion in different versions of Firefox
	        var size = file.size;
	        return(size + '-' + relativePath.replace(/[^0-9a-zA-Z_-]/img, ''));
	      },
	      contains:function(array,test) {
	        var result = false;

	        $h.each(array, function(value) {
	          if (value == test) {
	            result = true;
	            return false;
	          }
	          return true;
	        });

	        return result;
	      },
	      formatSize:function(size){
	        if(size<1024) {
	          return size + ' bytes';
	        } else if(size<1024*1024) {
	          return (size/1024.0).toFixed(0) + ' KB';
	        } else if(size<1024*1024*1024) {
	          return (size/1024.0/1024.0).toFixed(1) + ' MB';
	        } else {
	          return (size/1024.0/1024.0/1024.0).toFixed(1) + ' GB';
	        }
	      },
	      getTarget:function(request, params){
	        var target = $.getOpt('target');

	        if (request === 'test' && $.getOpt('testTarget')) {
	          target = $.getOpt('testTarget') === '/' ? $.getOpt('target') : $.getOpt('testTarget');
	        }

	        if (typeof target === 'function') {
	          return target(params);
	        }

	        var separator = target.indexOf('?') < 0 ? '?' : '&';
	        var joinedParams = params.join('&');

	        if (joinedParams) target = target + separator + joinedParams;

	        return target;
	      }
	    };

	    var onDrop = function(e){
	      e.currentTarget.classList.remove($.getOpt('dragOverClass'));
	      $h.stopEvent(e);

	      //handle dropped things as items if we can (this lets us deal with folders nicer in some cases)
	      if (e.dataTransfer && e.dataTransfer.items) {
	        loadFiles(e.dataTransfer.items, e);
	      }
	      //else handle them as files
	      else if (e.dataTransfer && e.dataTransfer.files) {
	        loadFiles(e.dataTransfer.files, e);
	      }
	    };
	    var onDragLeave = function(e){
	      e.currentTarget.classList.remove($.getOpt('dragOverClass'));
	    };
	    var onDragOverEnter = function(e) {
	      e.preventDefault();
	      var dt = e.dataTransfer;
	      if ($.indexOf(dt.types, "Files") >= 0) { // only for file drop
	        e.stopPropagation();
	        dt.dropEffect = "copy";
	        dt.effectAllowed = "copy";
	        e.currentTarget.classList.add($.getOpt('dragOverClass'));
	      } else { // not work on IE/Edge....
	        dt.dropEffect = "none";
	        dt.effectAllowed = "none";
	      }
	    };

	    /**
	     * processes a single upload item (file or directory)
	     * @param {Object} item item to upload, may be file or directory entry
	     * @param {string} path current file path
	     * @param {File[]} items list of files to append new items to
	     * @param {Function} cb callback invoked when item is processed
	     */
	    function processItem(item, path, items, cb) {
	      var entry;
	      if(item.isFile){
	        // file provided
	        return item.file(function(file){
	          file.relativePath = path + file.name;
	          items.push(file);
	          cb();
	        });
	      }else if(item.isDirectory){
	        // item is already a directory entry, just assign
	        entry = item;
	      }else if(item instanceof File) {
	        items.push(item);
	      }
	      if('function' === typeof item.webkitGetAsEntry){
	        // get entry from file object
	        entry = item.webkitGetAsEntry();
	      }
	      if(entry && entry.isDirectory){
	        // directory provided, process it
	        return processDirectory(entry, path + entry.name + '/', items, cb);
	      }
	      if('function' === typeof item.getAsFile){
	        // item represents a File object, convert it
	        item = item.getAsFile();
	        if(item instanceof File) {
	          item.relativePath = path + item.name;
	          items.push(item);
	        }
	      }
	      cb(); // indicate processing is done
	    }


	    /**
	     * cps-style list iteration.
	     * invokes all functions in list and waits for their callback to be
	     * triggered.
	     * @param  {Function[]}   items list of functions expecting callback parameter
	     * @param  {Function} cb    callback to trigger after the last callback has been invoked
	     */
	    function processCallbacks(items, cb){
	      if(!items || items.length === 0){
	        // empty or no list, invoke callback
	        return cb();
	      }
	      // invoke current function, pass the next part as continuation
	      items[0](function(){
	        processCallbacks(items.slice(1), cb);
	      });
	    }

	    /**
	     * recursively traverse directory and collect files to upload
	     * @param  {Object}   directory directory to process
	     * @param  {string}   path      current path
	     * @param  {File[]}   items     target list of items
	     * @param  {Function} cb        callback invoked after traversing directory
	     */
	    function processDirectory (directory, path, items, cb) {
	      var dirReader = directory.createReader();
	      var allEntries = [];

	      function readEntries () {
	        dirReader.readEntries(function(entries){
	          if (entries.length) {
	            allEntries = allEntries.concat(entries);
	            return readEntries();
	          }

	          // process all conversion callbacks, finally invoke own one
	          processCallbacks(
	            allEntries.map(function(entry){
	              // bind all properties except for callback
	              return processItem.bind(null, entry, path, items);
	            }),
	            cb
	          );
	        });
	      }

	      readEntries();
	    }

	    /**
	     * process items to extract files to be uploaded
	     * @param  {File[]} items items to process
	     * @param  {Event} event event that led to upload
	     */
	    function loadFiles(items, event) {
	      if(!items.length){
	        return; // nothing to do
	      }
	      $.fire('beforeAdd');
	      var files = [];
	      processCallbacks(
	          Array.prototype.map.call(items, function(item){
	            // bind all properties except for callback
	            var entry = item;
	            if('function' === typeof item.webkitGetAsEntry){
	              entry = item.webkitGetAsEntry() || item;
	            }
	            return processItem.bind(null, entry, "", files);
	          }),
	          function(){
	            if(files.length){
	              // at least one file found
	              appendFilesFromFileList(files, event);
	            }
	          }
	      );
	    };

	    var appendFilesFromFileList = function(fileList, event){
	      // check for uploading too many files
	      var errorCount = 0;
	      var o = $.getOpt(['maxFiles', 'minFileSize', 'maxFileSize', 'maxFilesErrorCallback', 'minFileSizeErrorCallback', 'maxFileSizeErrorCallback', 'fileType', 'fileTypeErrorCallback']);
	      if (typeof(o.maxFiles)!=='undefined' && o.maxFiles<(fileList.length+$.files.length)) {
	        // if single-file upload, file is already added, and trying to add 1 new file, simply replace the already-added file
	        if (o.maxFiles===1 && $.files.length===1 && fileList.length===1) {
	          $.removeFile($.files[0]);
	        } else {
	          o.maxFilesErrorCallback(fileList, errorCount++);
	          return false;
	        }
	      }
	      var files = [], filesSkipped = [], remaining = fileList.length;
	      var decreaseReamining = function(){
	        if(!--remaining){
	          // all files processed, trigger event
	          if(!files.length && !filesSkipped.length){
	            // no succeeded files, just skip
	            return;
	          }
	          window.setTimeout(function(){
	            $.fire('filesAdded', files, filesSkipped);
	          },0);
	        }
	      };
	      $h.each(fileList, function(file){
	        var fileName = file.name;
	        var fileType = file.type; // e.g video/mp4
	        if(o.fileType.length > 0){
	          var fileTypeFound = false;
	          for(var index in o.fileType){
	            // For good behaviour we do some inital sanitizing. Remove spaces and lowercase all
	            o.fileType[index] = o.fileType[index].replace(/\s/g, '').toLowerCase();

	            // Allowing for both [extension, .extension, mime/type, mime/*]
	            var extension = ((o.fileType[index].match(/^[^.][^/]+$/)) ? '.' : '') + o.fileType[index];

	            if ((fileName.substr(-1 * extension.length).toLowerCase() === extension) ||
	              //If MIME type, check for wildcard or if extension matches the files tiletype
	              (extension.indexOf('/') !== -1 && (
	                (extension.indexOf('*') !== -1 && fileType.substr(0, extension.indexOf('*')) === extension.substr(0, extension.indexOf('*'))) ||
	                fileType === extension
	              ))
	            ){
	              fileTypeFound = true;
	              break;
	            }
	          }
	          if (!fileTypeFound) {
	            o.fileTypeErrorCallback(file, errorCount++);
	            return true;
	          }
	        }

	        if (typeof(o.minFileSize)!=='undefined' && file.size<o.minFileSize) {
	          o.minFileSizeErrorCallback(file, errorCount++);
	          return true;
	        }
	        if (typeof(o.maxFileSize)!=='undefined' && file.size>o.maxFileSize) {
	          o.maxFileSizeErrorCallback(file, errorCount++);
	          return true;
	        }

	        function addFile(uniqueIdentifier){
	          if (!$.getFromUniqueIdentifier(uniqueIdentifier)) {(function(){
	            file.uniqueIdentifier = uniqueIdentifier;
	            var f = new ResumableFile($, file, uniqueIdentifier);
	            $.files.push(f);
	            files.push(f);
	            f.container = (typeof event != 'undefined' ? event.srcElement : null);
	            window.setTimeout(function(){
	              $.fire('fileAdded', f, event);
	            },0);
	          })();} else {
	            filesSkipped.push(file);
	          };
	          decreaseReamining();
	        }
	        // directories have size == 0
	        var uniqueIdentifier = $h.generateUniqueIdentifier(file, event);
	        if(uniqueIdentifier && typeof uniqueIdentifier.then === 'function'){
	          // Promise or Promise-like object provided as unique identifier
	          uniqueIdentifier
	          .then(
	            function(uniqueIdentifier){
	              // unique identifier generation succeeded
	              addFile(uniqueIdentifier);
	            },
	           function(){
	              // unique identifier generation failed
	              // skip further processing, only decrease file count
	              decreaseReamining();
	            }
	          );
	        }else {
	          // non-Promise provided as unique identifier, process synchronously
	          addFile(uniqueIdentifier);
	        }
	      });
	    };

	    // INTERNAL OBJECT TYPES
	    function ResumableFile(resumableObj, file, uniqueIdentifier){
	      var $ = this;
	      $.opts = {};
	      $.getOpt = resumableObj.getOpt;
	      $._prevProgress = 0;
	      $.resumableObj = resumableObj;
	      $.file = file;
	      $.fileName = file.fileName||file.name; // Some confusion in different versions of Firefox
	      $.size = file.size;
	      $.relativePath = file.relativePath || file.webkitRelativePath || $.fileName;
	      $.uniqueIdentifier = uniqueIdentifier;
	      $._pause = false;
	      $.container = '';
	      $.preprocessState = 0; // 0 = unprocessed, 1 = processing, 2 = finished
	      var _error = uniqueIdentifier !== undefined;

	      // Callback when something happens within the chunk
	      var chunkEvent = function(event, message){
	        // event can be 'progress', 'success', 'error' or 'retry'
	        switch(event){
	        case 'progress':
	          $.resumableObj.fire('fileProgress', $, message);
	          break;
	        case 'error':
	          $.abort();
	          _error = true;
	          $.chunks = [];
	          $.resumableObj.fire('fileError', $, message);
	          break;
	        case 'success':
	          if(_error) return;
	          $.resumableObj.fire('fileProgress', $, message); // it's at least progress
	          if($.isComplete()) {
	            $.resumableObj.fire('fileSuccess', $, message);
	          }
	          break;
	        case 'retry':
	          $.resumableObj.fire('fileRetry', $);
	          break;
	        }
	      };

	      // Main code to set up a file object with chunks,
	      // packaged to be able to handle retries if needed.
	      $.chunks = [];
	      $.abort = function(){
	        // Stop current uploads
	        var abortCount = 0;
	        $h.each($.chunks, function(c){
	          if(c.status()=='uploading') {
	            c.abort();
	            abortCount++;
	          }
	        });
	        if(abortCount>0) $.resumableObj.fire('fileProgress', $);
	      };
	      $.cancel = function(){
	        // Reset this file to be void
	        var _chunks = $.chunks;
	        $.chunks = [];
	        // Stop current uploads
	        $h.each(_chunks, function(c){
	          if(c.status()=='uploading')  {
	            c.abort();
	            $.resumableObj.uploadNextChunk();
	          }
	        });
	        $.resumableObj.removeFile($);
	        $.resumableObj.fire('fileProgress', $);
	      };
	      $.retry = function(){
	        $.bootstrap();
	        var firedRetry = false;
	        $.resumableObj.on('chunkingComplete', function(){
	          if(!firedRetry) $.resumableObj.upload();
	          firedRetry = true;
	        });
	      };
	      $.bootstrap = function(){
	        $.abort();
	        _error = false;
	        // Rebuild stack of chunks from file
	        $.chunks = [];
	        $._prevProgress = 0;
	        var round = $.getOpt('forceChunkSize') ? Math.ceil : Math.floor;
	        var maxOffset = Math.max(round($.file.size/$.getOpt('chunkSize')),1);
	        for (var offset=0; offset<maxOffset; offset++) {(function(offset){
	            window.setTimeout(function(){
	                $.chunks.push(new ResumableChunk($.resumableObj, $, offset, chunkEvent));
	                $.resumableObj.fire('chunkingProgress',$,offset/maxOffset);
	            },0);
	        })(offset);}
	        window.setTimeout(function(){
	            $.resumableObj.fire('chunkingComplete',$);
	        },0);
	      };
	      $.progress = function(){
	        if(_error) return(1);
	        // Sum up progress across everything
	        var ret = 0;
	        var error = false;
	        $h.each($.chunks, function(c){
	          if(c.status()=='error') error = true;
	          ret += c.progress(true); // get chunk progress relative to entire file
	        });
	        ret = (error ? 1 : (ret>0.99999 ? 1 : ret));
	        ret = Math.max($._prevProgress, ret); // We don't want to lose percentages when an upload is paused
	        $._prevProgress = ret;
	        return(ret);
	      };
	      $.isUploading = function(){
	        var uploading = false;
	        $h.each($.chunks, function(chunk){
	          if(chunk.status()=='uploading') {
	            uploading = true;
	            return(false);
	          }
	        });
	        return(uploading);
	      };
	      $.isComplete = function(){
	        var outstanding = false;
	        if ($.preprocessState === 1) {
	          return(false);
	        }
	        $h.each($.chunks, function(chunk){
	          var status = chunk.status();
	          if(status=='pending' || status=='uploading' || chunk.preprocessState === 1) {
	            outstanding = true;
	            return(false);
	          }
	        });
	        return(!outstanding);
	      };
	      $.pause = function(pause){
	          if(typeof(pause)==='undefined'){
	              $._pause = ($._pause ? false : true);
	          }else {
	              $._pause = pause;
	          }
	      };
	      $.isPaused = function() {
	        return $._pause;
	      };
	      $.preprocessFinished = function(){
	        $.preprocessState = 2;
	        $.upload();
	      };
	      $.upload = function () {
	        var found = false;
	        if ($.isPaused() === false) {
	          var preprocess = $.getOpt('preprocessFile');
	          if(typeof preprocess === 'function') {
	            switch($.preprocessState) {
	            case 0: $.preprocessState = 1; preprocess($); return(true);
	            case 1: return(true);
	            case 2: break;
	            }
	          }
	          $h.each($.chunks, function (chunk) {
	            if (chunk.status() == 'pending' && chunk.preprocessState !== 1) {
	              chunk.send();
	              found = true;
	              return(false);
	            }
	          });
	        }
	        return(found);
	      };
	      $.markChunksCompleted = function (chunkNumber) {
	        if (!$.chunks || $.chunks.length <= chunkNumber) {
	            return;
	        }
	        for (var num = 0; num < chunkNumber; num++) {
	            $.chunks[num].markComplete = true;
	        }
	      };

	      // Bootstrap and return
	      $.resumableObj.fire('chunkingStart', $);
	      $.bootstrap();
	      return(this);
	    }


	    function ResumableChunk(resumableObj, fileObj, offset, callback){
	      var $ = this;
	      $.opts = {};
	      $.getOpt = resumableObj.getOpt;
	      $.resumableObj = resumableObj;
	      $.fileObj = fileObj;
	      $.fileObjSize = fileObj.size;
	      $.fileObjType = fileObj.file.type;
	      $.offset = offset;
	      $.callback = callback;
	      $.lastProgressCallback = (new Date);
	      $.tested = false;
	      $.retries = 0;
	      $.pendingRetry = false;
	      $.preprocessState = 0; // 0 = unprocessed, 1 = processing, 2 = finished
	      $.markComplete = false;

	      // Computed properties
	      var chunkSize = $.getOpt('chunkSize');
	      $.loaded = 0;
	      $.startByte = $.offset*chunkSize;
	      $.endByte = Math.min($.fileObjSize, ($.offset+1)*chunkSize);
	      if ($.fileObjSize-$.endByte < chunkSize && !$.getOpt('forceChunkSize')) {
	        // The last chunk will be bigger than the chunk size, but less than 2*chunkSize
	        $.endByte = $.fileObjSize;
	      }
	      $.xhr = null;

	      // test() makes a GET request without any data to see if the chunk has already been uploaded in a previous session
	      $.test = function(){
	        // Set up request and listen for event
	        $.xhr = new XMLHttpRequest();

	        var testHandler = function(e){
	          $.tested = true;
	          var status = $.status();
	          if(status=='success') {
	            $.callback(status, $.message());
	            $.resumableObj.uploadNextChunk();
	          } else {
	            $.send();
	          }
	        };
	        $.xhr.addEventListener('load', testHandler, false);
	        $.xhr.addEventListener('error', testHandler, false);
	        $.xhr.addEventListener('timeout', testHandler, false);

	        // Add data from the query options
	        var params = [];
	        var parameterNamespace = $.getOpt('parameterNamespace');
	        var customQuery = $.getOpt('query');
	        if(typeof customQuery == 'function') customQuery = customQuery($.fileObj, $);
	        $h.each(customQuery, function(k,v){
	          params.push([encodeURIComponent(parameterNamespace+k), encodeURIComponent(v)].join('='));
	        });
	        // Add extra data to identify chunk
	        params = params.concat(
	          [
	            // define key/value pairs for additional parameters
	            ['chunkNumberParameterName', $.offset + 1],
	            ['chunkSizeParameterName', $.getOpt('chunkSize')],
	            ['currentChunkSizeParameterName', $.endByte - $.startByte],
	            ['totalSizeParameterName', $.fileObjSize],
	            ['typeParameterName', $.fileObjType],
	            ['identifierParameterName', $.fileObj.uniqueIdentifier],
	            ['fileNameParameterName', $.fileObj.fileName],
	            ['relativePathParameterName', $.fileObj.relativePath],
	            ['totalChunksParameterName', $.fileObj.chunks.length]
	          ].filter(function(pair){
	            // include items that resolve to truthy values
	            // i.e. exclude false, null, undefined and empty strings
	            return $.getOpt(pair[0]);
	          })
	          .map(function(pair){
	            // map each key/value pair to its final form
	            return [
	              parameterNamespace + $.getOpt(pair[0]),
	              encodeURIComponent(pair[1])
	            ].join('=');
	          })
	        );
	        // Append the relevant chunk and send it
	        $.xhr.open($.getOpt('testMethod'), $h.getTarget('test', params));
	        $.xhr.timeout = $.getOpt('xhrTimeout');
	        $.xhr.withCredentials = $.getOpt('withCredentials');
	        // Add data from header options
	        var customHeaders = $.getOpt('headers');
	        if(typeof customHeaders === 'function') {
	          customHeaders = customHeaders($.fileObj, $);
	        }
	        $h.each(customHeaders, function(k,v) {
	          $.xhr.setRequestHeader(k, v);
	        });
	        $.xhr.send(null);
	      };

	      $.preprocessFinished = function(){
	        $.preprocessState = 2;
	        $.send();
	      };

	      // send() uploads the actual data in a POST call
	      $.send = function(){
	        var preprocess = $.getOpt('preprocess');
	        if(typeof preprocess === 'function') {
	          switch($.preprocessState) {
	          case 0: $.preprocessState = 1; preprocess($); return;
	          case 1: return;
	          case 2: break;
	          }
	        }
	        if($.getOpt('testChunks') && !$.tested) {
	          $.test();
	          return;
	        }

	        // Set up request and listen for event
	        $.xhr = new XMLHttpRequest();

	        // Progress
	        $.xhr.upload.addEventListener('progress', function(e){
	          if( (new Date) - $.lastProgressCallback > $.getOpt('throttleProgressCallbacks') * 1000 ) {
	            $.callback('progress');
	            $.lastProgressCallback = (new Date);
	          }
	          $.loaded=e.loaded||0;
	        }, false);
	        $.loaded = 0;
	        $.pendingRetry = false;
	        $.callback('progress');

	        // Done (either done, failed or retry)
	        var doneHandler = function(e){
	          var status = $.status();
	          if(status=='success'||status=='error') {
	            $.callback(status, $.message());
	            $.resumableObj.uploadNextChunk();
	          } else {
	            $.callback('retry', $.message());
	            $.abort();
	            $.retries++;
	            var retryInterval = $.getOpt('chunkRetryInterval');
	            if(retryInterval !== undefined) {
	              $.pendingRetry = true;
	              setTimeout($.send, retryInterval);
	            } else {
	              $.send();
	            }
	          }
	        };
	        $.xhr.addEventListener('load', doneHandler, false);
	        $.xhr.addEventListener('error', doneHandler, false);
	        $.xhr.addEventListener('timeout', doneHandler, false);

	        // Set up the basic query data from Resumable
	        var query = [
	          ['chunkNumberParameterName', $.offset + 1],
	          ['chunkSizeParameterName', $.getOpt('chunkSize')],
	          ['currentChunkSizeParameterName', $.endByte - $.startByte],
	          ['totalSizeParameterName', $.fileObjSize],
	          ['typeParameterName', $.fileObjType],
	          ['identifierParameterName', $.fileObj.uniqueIdentifier],
	          ['fileNameParameterName', $.fileObj.fileName],
	          ['relativePathParameterName', $.fileObj.relativePath],
	          ['totalChunksParameterName', $.fileObj.chunks.length],
	        ].filter(function(pair){
	          // include items that resolve to truthy values
	          // i.e. exclude false, null, undefined and empty strings
	          return $.getOpt(pair[0]);
	        })
	        .reduce(function(query, pair){
	          // assign query key/value
	          query[$.getOpt(pair[0])] = pair[1];
	          return query;
	        }, {});
	        // Mix in custom data
	        var customQuery = $.getOpt('query');
	        if(typeof customQuery == 'function') customQuery = customQuery($.fileObj, $);
	        $h.each(customQuery, function(k,v){
	          query[k] = v;
	        });

	        var func = ($.fileObj.file.slice ? 'slice' : ($.fileObj.file.mozSlice ? 'mozSlice' : ($.fileObj.file.webkitSlice ? 'webkitSlice' : 'slice')));
	        var bytes = $.fileObj.file[func]($.startByte, $.endByte, $.getOpt('setChunkTypeFromFile') ? $.fileObj.file.type : "");
	        var data = null;
	        var params = [];

	        var parameterNamespace = $.getOpt('parameterNamespace');
	                if ($.getOpt('method') === 'octet') {
	                    // Add data from the query options
	                    data = bytes;
	                    $h.each(query, function (k, v) {
	                        params.push([encodeURIComponent(parameterNamespace + k), encodeURIComponent(v)].join('='));
	                    });
	                } else {
	                    // Add data from the query options
	                    data = new FormData();
	                    $h.each(query, function (k, v) {
	                        data.append(parameterNamespace + k, v);
	                        params.push([encodeURIComponent(parameterNamespace + k), encodeURIComponent(v)].join('='));
	                    });
	                    if ($.getOpt('chunkFormat') == 'blob') {
	                        data.append(parameterNamespace + $.getOpt('fileParameterName'), bytes, $.fileObj.fileName);
	                    }
	                    else if ($.getOpt('chunkFormat') == 'base64') {
	                        var fr = new FileReader();
	                        fr.onload = function (e) {
	                            data.append(parameterNamespace + $.getOpt('fileParameterName'), fr.result);
	                            $.xhr.send(data);
	                        };
	                        fr.readAsDataURL(bytes);
	                    }
	                }

	        var target = $h.getTarget('upload', params);
	        var method = $.getOpt('uploadMethod');

	        $.xhr.open(method, target);
	        if ($.getOpt('method') === 'octet') {
	          $.xhr.setRequestHeader('Content-Type', 'application/octet-stream');
	        }
	        $.xhr.timeout = $.getOpt('xhrTimeout');
	        $.xhr.withCredentials = $.getOpt('withCredentials');
	        // Add data from header options
	        var customHeaders = $.getOpt('headers');
	        if(typeof customHeaders === 'function') {
	          customHeaders = customHeaders($.fileObj, $);
	        }

	        $h.each(customHeaders, function(k,v) {
	          $.xhr.setRequestHeader(k, v);
	        });

	        if ($.getOpt('chunkFormat') == 'blob') {
	            $.xhr.send(data);
	        }
	      };
	      $.abort = function(){
	        // Abort and reset
	        if($.xhr) $.xhr.abort();
	        $.xhr = null;
	      };
	      $.status = function(){
	        // Returns: 'pending', 'uploading', 'success', 'error'
	        if($.pendingRetry) {
	          // if pending retry then that's effectively the same as actively uploading,
	          // there might just be a slight delay before the retry starts
	          return('uploading');
	        } else if($.markComplete) {
	          return 'success';
	        } else if(!$.xhr) {
	          return('pending');
	        } else if($.xhr.readyState<4) {
	          // Status is really 'OPENED', 'HEADERS_RECEIVED' or 'LOADING' - meaning that stuff is happening
	          return('uploading');
	        } else {
	          if($.xhr.status == 200 || $.xhr.status == 201) {
	            // HTTP 200, 201 (created)
	            return('success');
	          } else if($h.contains($.getOpt('permanentErrors'), $.xhr.status) || $.retries >= $.getOpt('maxChunkRetries')) {
	            // HTTP 400, 404, 409, 415, 500, 501 (permanent error)
	            return('error');
	          } else {
	            // this should never happen, but we'll reset and queue a retry
	            // a likely case for this would be 503 service unavailable
	            $.abort();
	            return('pending');
	          }
	        }
	      };
	      $.message = function(){
	        return($.xhr ? $.xhr.responseText : '');
	      };
	      $.progress = function(relative){
	        if(typeof(relative)==='undefined') relative = false;
	        var factor = (relative ? ($.endByte-$.startByte)/$.fileObjSize : 1);
	        if($.pendingRetry) return(0);
	        if((!$.xhr || !$.xhr.status) && !$.markComplete) factor*=.95;
	        var s = $.status();
	        switch(s){
	        case 'success':
	        case 'error':
	          return(1*factor);
	        case 'pending':
	          return(0*factor);
	        default:
	          return($.loaded/($.endByte-$.startByte)*factor);
	        }
	      };
	      return(this);
	    }

	    // QUEUE
	    $.uploadNextChunk = function(){
	      var found = false;

	      // In some cases (such as videos) it's really handy to upload the first
	      // and last chunk of a file quickly; this let's the server check the file's
	      // metadata and determine if there's even a point in continuing.
	      if ($.getOpt('prioritizeFirstAndLastChunk')) {
	        $h.each($.files, function(file){
	          if(file.chunks.length && file.chunks[0].status()=='pending' && file.chunks[0].preprocessState === 0) {
	            file.chunks[0].send();
	            found = true;
	            return(false);
	          }
	          if(file.chunks.length>1 && file.chunks[file.chunks.length-1].status()=='pending' && file.chunks[file.chunks.length-1].preprocessState === 0) {
	            file.chunks[file.chunks.length-1].send();
	            found = true;
	            return(false);
	          }
	        });
	        if(found) return(true);
	      }

	      // Now, simply look for the next, best thing to upload
	      $h.each($.files, function(file){
	        found = file.upload();
	        if(found) return(false);
	      });
	      if(found) return(true);

	      // The are no more outstanding chunks to upload, check is everything is done
	      var outstanding = false;
	      $h.each($.files, function(file){
	        if(!file.isComplete()) {
	          outstanding = true;
	          return(false);
	        }
	      });
	      if(!outstanding) {
	        // All chunks have been uploaded, complete
	        $.fire('complete');
	      }
	      return(false);
	    };


	    // PUBLIC METHODS FOR RESUMABLE.JS
	    $.assignBrowse = function(domNodes, isDirectory){
	      if(typeof(domNodes.length)=='undefined') domNodes = [domNodes];
	      $h.each(domNodes, function(domNode) {
	        var input;
	        if(domNode.tagName==='INPUT' && domNode.type==='file'){
	          input = domNode;
	        } else {
	          input = document.createElement('input');
	          input.setAttribute('type', 'file');
	          input.style.display = 'none';
	          domNode.addEventListener('click', function(){
	            input.style.opacity = 0;
	            input.style.display='block';
	            input.focus();
	            input.click();
	            input.style.display='none';
	          }, false);
	          domNode.appendChild(input);
	        }
	        var maxFiles = $.getOpt('maxFiles');
	        if (typeof(maxFiles)==='undefined'||maxFiles!=1){
	          input.setAttribute('multiple', 'multiple');
	        } else {
	          input.removeAttribute('multiple');
	        }
	        if(isDirectory){
	          input.setAttribute('webkitdirectory', 'webkitdirectory');
	        } else {
	          input.removeAttribute('webkitdirectory');
	        }
	        var fileTypes = $.getOpt('fileType');
	        if (typeof (fileTypes) !== 'undefined' && fileTypes.length >= 1) {
	          input.setAttribute('accept', fileTypes.map(function (e) {
	            e = e.replace(/\s/g, '').toLowerCase();
	            if(e.match(/^[^.][^/]+$/)){
	              e = '.' + e;
	            }
	            return e;
	          }).join(','));
	        }
	        else {
	          input.removeAttribute('accept');
	        }
	        // When new files are added, simply append them to the overall list
	        input.addEventListener('change', function(e){
	          appendFilesFromFileList(e.target.files,e);
	          var clearInput = $.getOpt('clearInput');
	          if (clearInput) {
	            e.target.value = '';
	          }
	        }, false);
	      });
	    };
	    $.assignDrop = function(domNodes){
	      if(typeof(domNodes.length)=='undefined') domNodes = [domNodes];

	      $h.each(domNodes, function(domNode) {
	        domNode.addEventListener('dragover', onDragOverEnter, false);
	        domNode.addEventListener('dragenter', onDragOverEnter, false);
	        domNode.addEventListener('dragleave', onDragLeave, false);
	        domNode.addEventListener('drop', onDrop, false);
	      });
	    };
	    $.unAssignDrop = function(domNodes) {
	      if (typeof(domNodes.length) == 'undefined') domNodes = [domNodes];

	      $h.each(domNodes, function(domNode) {
	        domNode.removeEventListener('dragover', onDragOverEnter);
	        domNode.removeEventListener('dragenter', onDragOverEnter);
	        domNode.removeEventListener('dragleave', onDragLeave);
	        domNode.removeEventListener('drop', onDrop);
	      });
	    };
	    $.isUploading = function(){
	      var uploading = false;
	      $h.each($.files, function(file){
	        if (file.isUploading()) {
	          uploading = true;
	          return(false);
	        }
	      });
	      return(uploading);
	    };
	    $.upload = function(){
	      // Make sure we don't start too many uploads at once
	      if($.isUploading()) return;
	      // Kick off the queue
	      $.fire('uploadStart');
	      for (var num=1; num<=$.getOpt('simultaneousUploads'); num++) {
	        $.uploadNextChunk();
	      }
	    };
	    $.pause = function(){
	      // Resume all chunks currently being uploaded
	      $h.each($.files, function(file){
	        file.abort();
	      });
	      $.fire('pause');
	    };
	    $.cancel = function(){
	      $.fire('beforeCancel');
	      for(var i = $.files.length - 1; i >= 0; i--) {
	        $.files[i].cancel();
	      }
	      $.fire('cancel');
	    };
	    $.progress = function(){
	      var totalDone = 0;
	      var totalSize = 0;
	      // Resume all chunks currently being uploaded
	      $h.each($.files, function(file){
	        totalDone += file.progress()*file.size;
	        totalSize += file.size;
	      });
	      return(totalSize>0 ? totalDone/totalSize : 0);
	    };
	    $.addFile = function(file, event){
	      appendFilesFromFileList([file], event);
	    };
	    $.addFiles = function(files, event){
	      appendFilesFromFileList(files, event);
	    };
	    $.removeFile = function(file){
	      for(var i = $.files.length - 1; i >= 0; i--) {
	        if($.files[i] === file) {
	          $.files.splice(i, 1);
	        }
	      }
	    };
	    $.getFromUniqueIdentifier = function(uniqueIdentifier){
	      var ret = false;
	      $h.each($.files, function(f){
	        if(f.uniqueIdentifier==uniqueIdentifier) ret = f;
	      });
	      return(ret);
	    };
	    $.getSize = function(){
	      var totalSize = 0;
	      $h.each($.files, function(file){
	        totalSize += file.size;
	      });
	      return(totalSize);
	    };
	    $.handleDropEvent = function (e) {
	      onDrop(e);
	    };
	    $.handleChangeEvent = function (e) {
	      appendFilesFromFileList(e.target.files, e);
	      e.target.value = '';
	    };
	    $.updateQuery = function(query){
	        $.opts.query = query;
	    };

	    return(this);
	  };


	  // Node.js-style export for Node and Component
	  if ('object' != 'undefined') {
	    // left here for backwards compatibility
	    module.exports = Resumable;
	    module.exports.Resumable = Resumable;
	  } else if (typeof undefined === "function" && undefined.amd) {
	    // AMD/requirejs: Define the module
	    undefined(function(){
	      return Resumable;
	    });
	  } else {
	    // Browser: Expose to window
	    window.Resumable = Resumable;
	  }

	})();
} (resumable$1));

var resumable = resumableExports;

function _defineProperty$z(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements file upload
 *
 * @augments et2_inputWidget
 */
class et2_file extends et2_inputWidget {
  /**
   * Constructor
   *
   * @memberOf et2_file
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_file._attributes, _child || {}));
    _defineProperty$z(this, "asyncOptions", {});
    _defineProperty$z(this, "input", null);
    _defineProperty$z(this, "progress", null);
    _defineProperty$z(this, "span", null);
    _defineProperty$z(this, "disabled_buttons", void 0);
    _defineProperty$z(this, "resumable", void 0);
    this.node = null;
    this.input = null;
    this.progress = null;
    this.span = null;
    // Contains all submit buttons need to be disabled during upload process
    this.disabled_buttons = jQuery("input[type='submit'], button");

    // Make sure it's an object, not an array, or values get lost when sent to server
    this.options.value = jQuery.extend({}, this.options.value);
    if (!this.options.id) {
      console.warn("File widget needs an ID.  Used 'file_widget'.");
      this.options.id = "file_widget";
    }

    // Legacy - id ending in [] means multiple
    if (this.options.id.substr(-2) == "[]") {
      this.options.multiple = true;
    }
    // If ID ends in /, it's a directory - allow multiple
    else if (this.options.id.substr(-1) === "/") {
      this.options.multiple = true;
      _attrs.multiple = true;
    }

    // Set up the URL to have the request ID & the widget ID
    var instance = this.getInstanceManager();
    var self = this;
    this.asyncOptions = jQuery.extend({}, this.getAsyncOptions(this));
    this.asyncOptions.fieldName = this.options.id;
    this.createInputWidget();
    this.set_readonly(this.options.readonly);
  }
  destroy() {
    super.destroy();
    this.set_drop_target(null);
    this.node = null;
    this.input = null;
    this.span = null;
    this.progress = null;
  }
  createInputWidget() {
    this.node = jQuery(document.createElement("div")).addClass("et2_file");
    this.span = jQuery(document.createElement("et2-button")).addClass('et2_file_span').attr("image", "attach").attr('label', this.options.label || '').attr("noSubmit", true).appendTo(this.node);
    var span = this.span;
    this.input = jQuery(document.createElement("input")).attr("type", "file").attr("placeholder", this.options.blur).addClass("et2_file_upload").appendTo(this.node).hover(function () {
      jQuery(span).toggleClass('et2_file_spanHover');
    }).on({
      mousedown: function mousedown() {
        jQuery(span).addClass('et2_file_spanActive');
      },
      mouseup: function mouseup() {
        jQuery(span).removeClass('et2_file_spanActive');
      }
    });
    var self = this;
    // trigger native input upload file
    if (!this.options.readonly) this.span.click(function () {
      self.input.click();
    });
    // Check for File interface, should fall back to normal form submit if missing
    if (typeof File != "undefined" && typeof new XMLHttpRequest().upload != "undefined") {
      this.resumable = new resumableExports.Resumable(this.asyncOptions);
      this.resumable.assignBrowse(this.input);
      this.resumable.on('fileAdded', jQuery.proxy(this._fileAdded, this));
      this.resumable.on('fileProgress', jQuery.proxy(this._fileProgress, this));
      this.resumable.on('fileSuccess', jQuery.proxy(this.finishUpload, this));
      this.resumable.on('complete', jQuery.proxy(this.onFinish, this));
    } else {
      // This may be a problem submitting via ajax
    }
    if (this.options.accept) this.input.attr('accept', this.options.accept);
    if (this.options.progress) {
      var widget = this.getRoot().getWidgetById(this.options.progress);
      if (widget) {
        //may be not available at createInputWidget time
        this.progress = jQuery(widget.getDOMNode());
      }
    }
    if (!this.progress) {
      this.progress = jQuery(document.createElement("div")).appendTo(this.node);
    }
    this.progress.addClass("progress");
    if (this.options.multiple) {
      this.input.attr("multiple", "multiple");
    }
    this.setDOMNode(this.node[0]);
    // set drop target to widget dom node if no target option is specified
    if (!this.options.drop_target) {
      this.resumable.assignDrop([this.getDOMNode()]);
    } else {
      this.set_drop_target(this.options.drop_target);
    }
  }

  /**
   * Get any specific async upload options
   */
  getAsyncOptions(self) {
    return {
      // Callbacks
      onStart: function onStart(event, file_count) {
        return self.onStart(event, file_count);
      },
      onFinish: function onFinish(event, file_count) {
        self.onFinish.apply(self, [event, file_count]);
      },
      onStartOne: function onStartOne(event, file_name, index, file_count) {},
      onFinishOne: function onFinishOne(event, response, name, number, total) {
        return self.finishUpload(event, response, name, number, total);
      },
      onProgress: function onProgress(event, progress, name, number, total) {
        return self.onProgress(event, progress, name, number, total);
      },
      onError: function onError(event, name, error) {
        return self.onError(event, name, error);
      },
      beforeSend: function beforeSend(form) {
        return self.beforeSend(form);
      },
      chunkSize: this.options.chunk_size || 1024 * 1024,
      target: egw.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\File::ajax_upload"),
      query: function query(file) {
        return self.beforeSend(file);
      },
      // Disable checking for already uploaded chunks
      testChunks: false
    };
  }
  /**
   * Set a widget or DOM node as a HTML5 file drop target
   *
   * @param {string} new_target widget ID or DOM node ID to be used as a new target
   */
  set_drop_target(new_target) {
    // Cancel old drop target
    if (this.options.drop_target) {
      var _widget = this.getRoot().getWidgetById(this.options.drop_target);
      var _drop_target = _widget && _widget.getDOMNode() || document.getElementById(this.options.drop_target);
      if (_drop_target) {
        this.resumable.unAssignDrop([_drop_target]);
      }
    }
    this.options.drop_target = new_target;
    if (!this.options.drop_target) return;

    // Set up new drop target
    var widget = this.getRoot().getWidgetById(this.options.drop_target);
    var drop_target = widget && widget.getDOMNode() || document.getElementById(this.options.drop_target);
    if (drop_target) {
      this.resumable.assignDrop([drop_target]);
    } else {
      this.egw().debug("warn", "Did not find file drop target %s", this.options.drop_target);
    }
  }
  attachToDOM() {
    var res = super.attachToDOM();
    // Override parent's change, file widget will fire change when finished uploading
    this.input.unbind("change.et2_inputWidget");
    return res;
  }
  getValue() {
    return this.options.value ? this.options.value : this.input.val();
  }

  /**
   * Set the value of the file widget.
   *
   * If you pass a FileList or list of files, it will trigger the async upload
   *
   * @param {FileList|File[]|false} value List of files to be uploaded, or false to reset.
   * @param {Event} event Most browsers require the user to initiate file transfers in some way.
   *	Pass the event in, if you have it.
   */
  set_value(value, event) {
    if (!value || typeof value == "undefined") {
      value = {};
    }
    if (jQuery.isEmptyObject(value)) {
      this.options.value = {};
      if (this.resumable.progress() == 1) this.progress.empty();

      // Reset the HTML element
      this.input.wrap('<form>').closest('form').get(0).reset();
      this.input.unwrap();
      return;
    }
    var addFile = jQuery.proxy(function (i, file) {
      this.resumable.addFile(file, event);
    }, this);
    if (typeof value == 'object' && value.length && typeof value[0] == 'object' && value[0].name) {
      try {
        this.input[0].files = value;
        jQuery.each(value, addFile);
      } catch (e) {
        var self = this;
        var args = arguments;
        jQuery.each(value, addFile);
      }
    }
  }

  /**
   * Set the value for label
   * The label is used as caption for span tag which customize the HTML file upload styling
   *
   * @param {string} value text value of label
   */
  set_label(value) {
    if (this.span != null && value != null) {
      this.span.label = value;
    }
  }
  getInputNode() {
    if (typeof this.input == 'undefined') return false;
    return this.input[0];
  }
  set_mime(mime) {
    if (!mime) {
      this.options.mime = null;
    }
    if (mime.indexOf("/") != 0) {
      // Lower case it now, if it's not a regex
      this.options.mime = mime.toLowerCase();
    } else {
      this.options.mime = mime;
    }
  }
  set_multiple(_multiple) {
    this.options.multiple = _multiple;
    if (_multiple) {
      return this.input.attr("multiple", "multiple");
    }
    return this.input.removeAttr("multiple");
  }

  /**
   * Check to see if the provided file's mimetype matches
   *
   * @param f File object
   * @return boolean
   */
  checkMime(f) {
    if (!this.options.mime) return true;
    var mime = '';
    if (this.options.mime.indexOf("/") != 0) {
      // Lower case it now, if it's not a regex
      mime = this.options.mime.toLowerCase();
    } else {
      // Convert into a js regex
      var parts = this.options.mime.substr(1).match(/(.*)\/([igm]?)$/);
      mime = new RegExp(parts[1], parts.length > 2 ? parts[2] : "");
    }

    // If missing, let the server handle it
    if (!mime || !f.type) return true;
    var is_preg = typeof mime == "object";
    if (!is_preg && f.type.toLowerCase() == mime || is_preg && mime.test(f.type)) {
      return true;
    }

    // Not right mime
    return false;
  }
  _fileAdded(file, event) {
    // Manual additions have no event
    if (typeof event == 'undefined') {
      event = {};
    }
    // Trigger start of uploading, calls callback
    if (!this.resumable.isUploading()) {
      if (!this.onStart(event, this.resumable.files.length)) return;
    }

    // Here 'this' is the input
    if (this.checkMime(file.file)) {
      if (this.createStatus(event, file)) {
        // Disable buttons
        this.disabled_buttons.not("[disabled]").attr("disabled", true).addClass('et2_button_ro').removeClass('et2_clickable').css('cursor', 'default');

        // Actually start uploading
        this.resumable.upload();
      }
    } else {
      // Wrong mime type - show in the list of files
      return this.createStatus(this.egw().lang("File is of wrong type (%1 != %2)!", file.file.type, this.options.mime), file);
    }
  }

  /**
   * Add in the request id
   */
  beforeSend(form) {
    var instance = this.getInstanceManager();
    return {
      request_id: instance.etemplate_exec_id,
      widget_id: this.id
    };
  }

  /**
   * Disables submit buttons while uploading
   */
  onStart(event, file_count) {
    // Hide any previous errors
    this.hideMessage();
    event.data = this;

    //Add dropdown_progress
    if (this.options.progress_dropdownlist) {
      this._build_progressDropDownList();
    }

    // Callback
    if (this.options.onStart) return et2_call(this.options.onStart, event, file_count);
    return true;
  }

  /**
   * Re-enables submit buttons when done
   */
  onFinish() {
    this.disabled_buttons.removeAttr("disabled").css('cursor', 'pointer').removeClass('et2_button_ro');
    var file_count = this.resumable.files.length;

    // Remove files from list
    while (this.resumable.files.length > 0) {
      this.resumable.removeFile(this.resumable.files[this.resumable.files.length - 1]);
    }
    var event = jQuery.Event('upload');
    event.data = this;
    var result = false;

    //Remove progress_dropDown_fileList class and unbind the click handler from body
    if (this.options.progress_dropdownlist) {
      this.progress.removeClass("progress_dropDown_fileList");
      jQuery(this.node).find('span').removeClass('totalProgress_loader');
      jQuery('body').off('click');
    }
    if (this.options.onFinish && !jQuery.isEmptyObject(this.getValue())) {
      result = et2_call(this.options.onFinish, event, file_count);
    } else {
      result = file_count == 0 || !jQuery.isEmptyObject(this.getValue());
    }
    if (result) {
      // Fire legacy change action when done
      this.change(this.input);
    }
  }

  /**
   * Build up dropdown progress with total count indicator
   *
   * @todo Implement totalProgress bar instead of ajax-loader, in order to show how much percent of uploading is completed
   */
  _build_progressDropDownList() {
    this.progress.addClass("progress_dropDown_fileList");

    //Add uploading indicator and bind hover handler on it
    jQuery(this.node).find('span').addClass('totalProgress_loader');
    jQuery(this.node).find('span.et2_file_span').hover(function () {
      jQuery('.progress_dropDown_fileList').show();
    });
    //Bind click handler to dismiss the dropdown while uploading
    jQuery('body').on('click', function (event) {
      if (event.target.className != 'remove') {
        jQuery('.progress_dropDown_fileList').hide();
      }
    });
  }

  /**
   * Creates the elements used for displaying the file, and it's upload status, and
   * attaches them to the DOM
   *
   * @param _event Either the event, or an error message
   */
  createStatus(_event, file) {
    var error = typeof _event == "object" ? "" : _event;
    if (this.options.max_file_size && file.size > this.options.max_file_size) {
      error = this.egw().lang("File too large.  Maximum %1", et2_vfsSize.prototype.human_size(this.options.max_file_size));
    }
    if (this.options.progress) {
      var widget = this.getRoot().getWidgetById(this.options.progress);
      if (widget) {
        this.progress = jQuery(widget.getDOMNode());
        this.progress.addClass("progress");
      }
    }
    if (this.progress) {
      var fileName = file.fileName || 'file';
      var status = jQuery("<li data-file='" + fileName.replace(/'/g, '&quot') + "'>" + fileName + "<div class='remove'/><span class='progressBar'><p/></span></li>").appendTo(this.progress);
      jQuery("div.remove", status).on('click', file, jQuery.proxy(this.cancel, this));
      if (error != "") {
        status.addClass("message ui-state-error");
        status.append("<div>" + error + "</diff>");
        jQuery(".progressBar", status).css("display", "none");
      }
    }
    return error == "";
  }
  _fileProgress(file) {
    if (this.progress) {
      jQuery("li[data-file='" + file.fileName.replace(/'/g, '&quot') + "'] > span.progressBar > p").css("width", Math.ceil(file.progress() * 100) + "%");
    }
    return true;
  }
  onError(event, name, error) {
    console.warn(event, name, error);
  }

  /**
   * A file upload is finished, update the UI
   */
  finishUpload(file, response) {
    var name = file.fileName || 'file';
    if (typeof response == 'string') response = jQuery.parseJSON(response);
    if (response.response[0] && typeof response.response[0].data.length == 'undefined') {
      if (typeof this.options.value !== 'object' || !this.options.multiple) {
        this.set_value({});
      }
      for (var key in response.response[0].data) {
        if (typeof response.response[0].data[key] == "string") {
          // Message from server - probably error
          jQuery("[data-file='" + name.replace(/'/g, '&quot') + "']", this.progress).addClass("error").css("display", "block").text(response.response[0].data[key]);
        } else {
          this.options.value[key] = response.response[0].data[key];
          // If not multiple, we already destroyed the status, so re-create it
          if (!this.options.multiple) {
            this.createStatus({}, file);
          }
          if (this.progress) {
            jQuery("[data-file='" + name.replace(/'/g, '&quot') + "']", this.progress).addClass("message success");
          }
        }
      }
    } else if (this.progress) {
      jQuery("[data-file='" + name.replace(/'/g, '&quot') + "']", this.progress).addClass("ui-state-error").css("display", "block").text(this.egw().lang("Server error"));
    }
    var event = jQuery.Event('upload');
    event.data = this;

    // Callback
    if (typeof this.onFinishOne == 'function') {
      this.onFinishOne(event, response, name);
    }
    return true;
  }

  /**
   * Remove a file from the list of values
   *
   * @param {File|string} File object, or file name, to remove
   */
  remove_file(file) {
    //console.info(filename);
    if (typeof file == 'string') {
      file = {
        fileName: file
      };
    }
    for (var key in this.options.value) {
      if (this.options.value[key].name == file.fileName) {
        delete this.options.value[key];
        jQuery('[data-file="' + file.fileName.replace(/'/g, '&quot') + '"]', this.node).remove();
        return;
      }
    }
    if (file.isComplete && !file.isComplete() && file.cancel) file.cancel();
  }

  /**
   * Cancel a file - event callback
   */
  cancel(e) {
    e.preventDefault();
    // Look for file name in list
    var target = jQuery(e.target).parents("li");
    this.remove_file(e.data);

    // In case it didn't make it to the list (error)
    target.remove();
    jQuery(e.target).remove();
  }

  /**
   * Set readonly
   *
   * @param {boolean} _ro boolean readonly state, true means readonly
   */
  set_readonly(_ro) {
    if (typeof _ro != "undefined") {
      this.options.readonly = _ro;
      this.span.toggleClass('et2_file_ro', _ro);
      this.span[0].readonly = _ro;
      if (this.options.readonly) {
        this.span.unbind('click');
      } else {
        var self = this;
        this.span.off().bind('click', function () {
          self.input.click();
        });
      }
    }
  }
}
_defineProperty$z(et2_file, "_attributes", {
  "multiple": {
    "name": "Multiple files",
    "type": "boolean",
    "default": false,
    "description": "Allow the user to select more than one file to upload at a time.  Subject to browser support."
  },
  "max_file_size": {
    "name": "Maximum file size",
    "type": "integer",
    "default": 0,
    "description": "Largest file accepted, in bytes.  Subject to server limitations.  8MB = 8388608"
  },
  "mime": {
    "name": "Allowed file types",
    "type": "string",
    "default": et2_no_init,
    "description": "Mime type (eg: image/png) or regex (eg: /^text\//i) for allowed file types"
  },
  "blur": {
    "name": "Placeholder",
    "type": "string",
    "default": "",
    "description": "This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."
  },
  "progress": {
    "name": "Progress node",
    "type": "string",
    "default": et2_no_init,
    "description": "The ID of an alternate node (div) to display progress and results.  The Node is fetched with et2 getWidgetById so you MUST use the id assigned in XET-File (it may not be available at creation time, so we (re)check on createStatus time)"
  },
  "onStart": {
    "name": "Start event handler",
    "type": "any",
    "default": et2_no_init,
    "description": "A (js) function called when an upload starts.  Return true to continue with upload, false to cancel."
  },
  "onFinish": {
    "name": "Finish event handler",
    "type": "any",
    "default": et2_no_init,
    "description": "A (js) function called when all files to be uploaded are finished."
  },
  drop_target: {
    "name": "Optional, additional drop target for HTML5 uploads",
    "type": "string",
    "default": et2_no_init,
    "description": "The ID of an additional drop target for HTML5 drag-n-drop file uploads"
  },
  label: {
    "name": "Label of file upload",
    "type": "string",
    "default": "Choose file...",
    "description": "String caption to be displayed on file upload span"
  },
  progress_dropdownlist: {
    "name": "List on files in progress like dropdown",
    "type": "boolean",
    "default": false,
    "description": "Style list of files in uploading progress like dropdown list with a total upload progress indicator"
  },
  onFinishOne: {
    "name": "Finish event handler for each one",
    "type": "js",
    "default": et2_no_init,
    "description": "A (js) function called when a file to be uploaded is finished."
  },
  accept: {
    "name": "Acceptable extensions",
    "type": "string",
    "default": '',
    "description": "Define types of files that the server accepts. Multiple types can be seperated by comma and the default is to accept everything."
  },
  chunk_size: {
    "name": "Chunk size",
    "type": "integer",
    "default": 1024 * 1024,
    "description": "Max chunk size, gets set from server-side PHP (max_upload_size-1M)/2" // last chunk can be up to 2*chunk_size!
  }
});

et2_register_widget(et2_file, ["file"]);

function _defineProperty$y(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Class which implements the "vfs" XET-Tag
 *
 * @augments et2_valueWidget
 */
class et2_vfs extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_vfs
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfs._attributes, _child || {}));
    _defineProperty$y(this, "value", void 0);
    _defineProperty$y(this, "span", null);
    this.value = "";
    this.span = jQuery(document.createElement("ul")).addClass('et2_vfs');
    this.setDOMNode(this.span[0]);
  }
  getValue() {
    return this.value;
  }
  set_value(_value) {
    var _this = this;
    if (typeof _value !== 'object') {
      // Only warn if it's an actual value, just blank for falsy values
      if (_value) {
        this.egw().debug("warn", "%s only has path, needs full array", this.id, _value);
      }
      this.span.empty().text(_value);
      return;
    }
    this.span.empty();
    this.value = _value;
    var path = _value.path ? _value.path : '/';
    // calculate path as parent of name, which can contain slashes
    // eg. _value.path=/home/ralf/sub/file, _value.name=sub/file --> path=/home/ralf
    // --> generate clickable fields for sub/ + file
    var sub_path = path.substring(0, _value.path.length - _value.name.length - 1);
    var path_offset, path_parts;
    if (_value.path.indexOf(_value.name) >= 0 && sub_path[sub_path.length - 1] === '/') {
      path = sub_path;
      path_offset = path.split('/').length;
      path_parts = _value.path.split('/');
    } else {
      if (_value.path.indexOf(_value.name) >= 0) {
        // Remove name from end, so we can add it again later
        path = sub_path;
      }
      path_offset = 0;
      path_parts = _value.name.split('/');
    }
    var text;
    var _loop = function _loop() {
        path += (path == '/' ? '' : '/') + path_parts[i];
        text = egw$1.decodePath(path_parts[i]);

        // Nice human-readable stuff for apps
        if (path_parts[1] == 'apps') {
          switch (path_parts.length) {
            case 2:
              if (i == 1) {
                text = _this.egw().lang('applications');
              }
              break;
            case 3:
              if (i == 2) {
                text = _this.egw().lang(path_parts[2]);
              }
              break;
            case 4:
              if (!isNaN(text)) {
                var link_title = _this.egw().link_title(path_parts[2], path_parts[3], function (title) {
                  if (!title || this.value.name == title) return;
                  jQuery('li', this.span).last().text(title);
                }, _this);
                if (link_title && typeof link_title !== 'undefined') text = link_title;
              }
              break;
          }
        }
        var self = _this;
        data = {
          path: path,
          type: i < path_parts.length - 1 ? et2_vfs.DIR_MIME_TYPE : _value.mime
        };
        node = jQuery(document.createElement("li")).addClass("vfsFilename").text(text + (i < path_parts.length - 1 ? '/' : ''))
        //.attr('title', egw.decodePath(path))
        .addClass("et2_clickable et2_link").click({
          data: data,
          egw: _this.egw()
        }, function (e) {
          if (!self.onclick) {
            e.data.egw.open(e.data.data, "file");
          } else if (self.click(e)) {
            e.data.egw.open(e.data.data, "file");
          }
        }).appendTo(_this.span);
      },
      data,
      node;
    for (var i = path_offset; i < path_parts.length; i++) {
      _loop();
    }
    // Last part of path do default action
    this._bind_default_action(node, data);
  }
  _bind_default_action(node, data) {
    var links = [];
    var widget = this;
    var defaultAction = null;
    var object = null;
    var app = this.getInstanceManager().app;
    while (links.length === 0 && widget.getParent()) {
      object = egw_getAppObjectManager(app).getObjectById(widget.id);
      if (object && object.manager && object.manager.children) {
        links = object.manager.children;
      }
      widget = widget.getParent();
    }
    for (var k in links) {
      if (links[k].default && links[k].enabled.exec(links[k])) {
        defaultAction = links[k];
        break;
      }
    }
    if (defaultAction && !this.onclick) {
      node.off('click').click({
        data: data,
        egw: this.egw()
      }, function (e) {
        // Wait until object selection happens
        window.setTimeout(function () {
          // execute default action
          egw_keyHandler(EGW_KEY_ENTER, false, false, false);
        });
        // Select row
        return true;
      }.bind({
        data: data,
        object: object
      }));
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM (data grid)
   *
   * @param {array} _attrs array of attribute-names to push further names onto
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value");
  }
  getDetachedNodes() {
    return [this.span[0]];
  }
  setDetachedAttributes(_nodes, _values) {
    this.span = jQuery(_nodes[0]);
    if (typeof _values["value"] != 'undefined') {
      this.set_value(_values["value"]);
    }
  }
}
_defineProperty$y(et2_vfs, "_attributes", {
  "value": {
    "type": "any",
    // Object
    "description": "Array of (stat) information about the file"
  }
});
/**
 * Mime type of directories
 */
_defineProperty$y(et2_vfs, "DIR_MIME_TYPE", 'httpd/unix-directory');
et2_register_widget(et2_vfs, ["vfs"]);

/**
* vfs-name
* filename automatically urlencoded on return (urldecoded on display to user)
*
* @augments et2_textbox
*/
class et2_vfsName extends et2_textbox {
  /**
   * Constructor
   *
   * @memberOf et2_vfsName
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsName._attributes, _child || {}));
    this.input.addClass("et2_vfs");
  }
  set_value(_value) {
    if (_value.path) {
      _value = _value.path;
    }
    try {
      _value = egw$1.decodePath(_value);
    } catch (e) {
      _value = 'Error! ' + _value;
    }
    super.set_value(_value);
  }
  getValue() {
    return egw$1.encodePath(super.getValue() || '');
  }
}
et2_register_widget(et2_vfsName, ["vfs-name"]);

/**
* vfs-name
* filename automatically urlencoded on return (urldecoded on display to user)
*
* @augments et2_textbox
*/
class et2_vfsPath extends et2_vfsName {
  /**
   * Constructor
   *
   * @memberOf et2_vfsName
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsPath._attributes, _child || {}));
    _defineProperty$y(this, "div", void 0);
    _defineProperty$y(this, "span", void 0);
    this.div = jQuery(document.createElement("div")).addClass('et2_vfsPath');
    this.span = jQuery(document.createElement("ul")).appendTo(this.div);
    this.div.prepend(this.input);
    this.setDOMNode(this.div[0]);
    this.span.on('wheel', function (e) {
      var delta = e.originalEvent["deltaY"] > 0 ? 30 : -30;
      this.scrollLeft = this.scrollLeft - delta;
    });
    this.span.on('mouseover', function (e) {
      if (this.scrollWidth > this.clientWidth) {
        jQuery(this).addClass('scrollable');
      } else {
        jQuery(this).removeClass('scrollable');
      }
    });
  }
  createInputWidget() {
    super.createInputWidget();
    this.input.on('focus', function () {
      this.input.val(this.options.value);
      this.span.hide();
    }.bind(this)).on('focusout', function () {
      // Can't use show() because it uses the wrong display
      this.span.css('display', 'flex');
      this.input.val('');
    }.bind(this));
  }
  change(_node) {
    if (this.input.val()) {
      this.set_value(this.input.val());
    }
    return super.change(_node);
  }
  set_value(_value) {
    var _this2 = this;
    if (_value.path) {
      _value = _value.path;
    }
    if (_value === this.options.value && this._oldValue !== et2_no_init) return;
    var path_parts = _value.split('/');
    if (_value === '/') path_parts = [''];
    var path = "/";
    var text = '';
    if (this.span) this.span.empty().css('display', 'flex');
    this.input.val('');
    var _loop2 = function _loop2() {
      path += (path == '/' ? '' : '/') + path_parts[i];
      text = egw$1.decodePath(path_parts[i]);
      var image = path == '/' ? _this2.egw().image('navbar', 'api') : _this2.egw().image(text);

      // Nice human-readable stuff for apps
      if (path_parts[1] == 'apps') {
        if (i === 1) {
          text = _this2.egw().lang('applications');
        } else if (i === 2) {
          text = _this2.egw().lang(path_parts[2]);
          image = _this2.egw().image('navbar', path_parts[2].toLowerCase());
        } else if (i === 3 && !isNaN(text)) {
          // we first need to call link_title without callback, as callback would be called for cache-hits too!
          var link_title = _this2.egw().link_title(path_parts[2], path_parts[3], false);
          if (link_title && typeof link_title !== 'undefined') {
            text = link_title;
          } else {
            _this2.egw().link_title(path_parts[2], path_parts[3], true).then(title => {
              if (!title) return;
              jQuery('li', _this2.span).first().text(title);
            });
          }
        }
      }
      var self = _this2;
      var node = jQuery(document.createElement("li")).addClass("vfsPath et2_clickable").text(text)
      //.attr('title', egw.decodePath(path))
      .click({
        data: path,
        egw: _this2.egw()
      }, function (e) {
        return self.set_value(e.data.data);
      }).prependTo(_this2.span);
      if (image && !_this2.options.noicon) {
        node.prepend(_this2.egw().image_element(image));
      }
      jQuery(_this2.getDOMNode()).append(_this2.span);
    };
    for (var i = 0; i < path_parts.length; i++) {
      _loop2();
    }
    if (this.isAttached() && this.options.value !== _value) {
      this._oldValue = this.options.value;
      this.options.value = _value;
      this.change();
    }
  }
  getValue() {
    return this.options ? this.options.value : null;
  }
}
_defineProperty$y(et2_vfsPath, "_attributes", {
  noicon: {
    type: "boolean",
    description: "suppress folder icons",
    default: true
  }
});
et2_register_widget(et2_vfsPath, ["vfs-path"]);

/**
* vfs-name
* filename automatically urlencoded on return (urldecoded on display to user)
*
* @augments et2_textbox_ro
*/
class et2_vfsName_ro extends et2_textbox_ro {
  /**
   * Constructor
   *
   * @memberOf et2_vfsName_ro
   */
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsName_ro._attributes, _child || {}));
  }
  set_value(_value) {
    if (_value.path) {
      _value = _value.path;
    }
    try {
      _value = egw$1.decodePath(_value);
    } catch (e) {
      _value = 'Error! ' + _value;
    }
    super.set_value(_value);
  }
  getValue() {
    return egw$1.encodePath(super.getValue() || '');
  }
}
et2_register_widget(et2_vfsName_ro, ["vfs-name_ro"]);

/**
 * vfs-mime: icon for mimetype of file, or thumbnail
 * incl. optional link overlay icon, if file is a symlink
 *
 * Creates following structure
 * <span class="iconOverlayContainer">
 *   <img class="et2_vfs vfsMimeIcon" src="..."/>
 *   <span class="overlayContainer">
 *      <img class="overlay" src="etemplate/templates/default/images/link.png"/>
 *   </span>
 * </span>
 *
 * span.overlayContainer is optional and only generated for symlinks
 * @augments et2_valueWidget
 * @deprecated use Et2VfsMime
*/

/**
* vfs-size
* Human readable file sizes
*
* @augments et2_description
*/
class et2_vfsSize extends et2_description {
  /**
   * Constructor
   *
   * @memberOf et2_vfsSize
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsSize._attributes, _child || {}));
    this.span.addClass("et2_vfs");
  }
  human_size(size) {
    if (typeof size !== "number") {
      size = parseInt(size);
    }
    if (Number.isNaN(size)) {
      return '';
    }
    var sign = '';
    if (size < 0) {
      sign = '-';
      size = -size;
    }
    var units = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    var i = 0;
    while (size >= 1024) {
      size /= 1024;
      ++i;
    }
    return sign + size.toFixed(i == 0 ? 0 : 1) + ' ' + units[i];
  }
  set_value(_value) {
    if (_value.size) {
      _value = _value.size;
    }
    jQuery(this.node).text(this.human_size(_value));
  }
  setDetachedAttributes(_nodes, _values) {
    if (typeof _values["value"] !== "undefined") {
      this.node = _nodes[0];
      this.set_value(_values["value"]);
      delete _values["value"];
    }
    super.setDetachedAttributes(_nodes, _values);
  }
}
_defineProperty$y(et2_vfsSize, "_attributes", {
  "value": {
    "type": "any" // not using "integer", as we use parseInt on everything not a number, but want to show empty of "" or undefined, not 0B
  }
});

et2_register_widget(et2_vfsSize, ["vfs-size"]);

/**
* vfs-mode: textual representation of permissions + extra bits
*
* @augments et2_description
*/
class et2_vfsMode extends et2_description {
  /**
   * Constructor
   *
   * @memberOf et2_vfsMode
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsMode._attributes, _child || {}));
    this.span.addClass("et2_vfs");
  }

  /**
   * Get text for file stuff
   * Result will be like -rwxr--r--.  First char is type, then read, write, execute (or other bits) for
   * user, group, world
   *
   * @param {number} _value vfs mode
   */
  text_mode(_value) {
    var text = [];
    if (typeof _value != "number") {
      _value = parseInt(_value);
    }
    if (!_value) return "----------";

    // Figure out type
    var type = 'u'; // unknown
    for (var flag in et2_vfsMode.types) {
      if ((_value & et2_vfsMode.types[flag]) == et2_vfsMode.types[flag]) {
        type = flag;
        break;
      }
    }

    // World, group, user - build string backwards
    for (var i = 0; i < 3; i++) {
      for (var perm in et2_vfsMode.perms) {
        if (_value & et2_vfsMode.perms[perm]) {
          text.unshift(perm);
        } else {
          text.unshift("-");
        }
      }
      _value = _value >> 3;
    }
    // Sticky / UID / GID
    for (var _i = 0; _i < et2_vfsMode.sticky.length; _i++) {
      if (et2_vfsMode.sticky[_i].mask & _value) {
        var current = text[et2_vfsMode.sticky[_i].position];
        text[et2_vfsMode.sticky[_i].position] = et2_vfsMode.sticky[_i]["char"];
        if (current == 'x') text[et2_vfsMode.sticky[_i].position].toLowerCase();
      }
    }
    return type + text.join('');
  }
  set_value(_value) {
    if (_value.size) {
      _value = _value.size;
    }
    var text = this.text_mode(_value);
    jQuery(this.node).text(text);
  }
  setDetachedAttributes(_nodes, _values) {
    if (typeof _values["value"] !== "undefined") {
      this.node = _nodes[0];
      this.set_value(_values["value"]);
      delete _values["value"];
    }
    super.setDetachedAttributes(_nodes, _values);
  }
}
// Masks for file types
_defineProperty$y(et2_vfsMode, "types", {
  'l': 0xA000,
  // link
  's': 0xC000,
  // Socket
  'p': 0x1000,
  // FIFO pipe
  'c': 0x2000,
  // Character special
  'd': 0x4000,
  // Directory
  'b': 0x6000,
  // Block special
  '-': 0x8000 // Regular
});
// Sticky / UID / GID
_defineProperty$y(et2_vfsMode, "sticky", [{
  mask: 0x200,
  "char": "T",
  position: 9
},
// Sticky
{
  mask: 0x400,
  "char": "S",
  position: 6
},
// sGID
{
  mask: 0x800,
  "char": "S",
  position: 3
} // SUID
]);
_defineProperty$y(et2_vfsMode, "perms", {
  'x': 0x1,
  // Execute
  'w': 0x2,
  // Write
  'r': 0x4 // Read
});

et2_register_widget(et2_vfsMode, ["vfs-mode"]);

/**
* vfs-uid / vfs-gid: Displays the name for an ID.
* Same as read-only selectAccount, except if there's no user it shows "root"
*
* @deprecated use Et2VfsUid
*/

/**
 * @deprecated use Et2VfsGid
 */

/* vfs-upload aka VFS file:       displays either download and delete (x) links or a file upload
*   + ID is either a vfs path or colon separated $app:$id:$relative_path, eg: infolog:123:special/offer
*   + if empty($id) / new entry, file is created in a hidden temporary directory in users home directory
*     and calling app is responsible to move content of that dir to entry directory, after entry is saved
*   + option: required mimetype or regular expression for mimetype to match, eg. '/^text\//i' for all text files
*   + if path ends in a slash, multiple files can be uploaded, their original filename is kept then
*
* @augments et2_file
*/
class et2_vfsUpload extends et2_file {
  /**
   * Constructor
   *
   * @param _parent
   * @param attrs
   * @memberof et2_vfsUpload
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsUpload._attributes, _child || {}));
    _defineProperty$y(this, "list", null);
    jQuery(this.node).addClass("et2_vfs");
    if (!this.options.path) {
      this.options.path = this.options.id;
    }
    // If the path is a directory, allow multiple uploads
    if (this.options.path.substr(-1) == '/') {
      this.set_multiple(true);
    }
    this.list = jQuery(document.createElement('table')).appendTo(this.node);
    if (this.options.listonly) {
      this.input.remove();
      this.span.remove();
      this.progress.remove();
    }
  }

  /**
   * Get any specific async upload options
   */
  getAsyncOptions(self) {
    return jQuery.extend({}, super.getAsyncOptions(self), {
      target: egw$1.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_upload")
    });
  }

  /**
   * If there is a file / files in the specified location, display them
   * Value is the information for the file[s] in the specified location.
   *
   * @param {Object{}} _value
   */
  set_value(_value) {
    // Remove previous
    while (this._children.length > 0) {
      var node = this._children[this._children.length - 1];
      this.removeChild(node);
      node.destroy();
    }
    this.progress.empty();
    this.list.empty();

    // Set new
    if (typeof _value == 'object' && _value && Object.keys(_value).length) {
      for (var i in _value) {
        this._addFile(_value[i]);
      }
    }
    return true;
  }
  getDOMNode(sender) {
    if (sender && sender !== this && (sender.tagName && sender.tagName.indexOf("VFS") >= 0 || sender._type && sender._type.indexOf('vfs') >= 0)) {
      var _sender$options;
      var value = sender.getValue && sender.getValue() || ((_sender$options = sender.options) === null || _sender$options === void 0 ? void 0 : _sender$options.value) || false;
      var row;
      if (value) {
        // Have a value, we can find the right place
        row = jQuery("[data-path='" + value.path.replace(/'/g, '&quot') + "']", this.list);
      } else {
        // No value, just use the last one
        row = jQuery("[data-path]", this.list).last();
      }
      if (sender.tagName === "ET2-VFS-MIME" || sender._type === 'vfs-mime') {
        return jQuery('.icon', row).get(0) || null;
      } else {
        return jQuery('.title', row).get(0) || null;
      }
    } else {
      return super.getDOMNode(sender);
    }
  }

  /**
   * Add in the request id
   *
   * @param {type} form
   */
  beforeSend(form) {
    var extra = super.beforeSend(form);
    extra["path"] = this.options.path;
    return extra;
  }

  /**
   * A file upload is finished, update the UI
   *
   * @param {object} file
   * @param {string|object} response
   */
  finishUpload(file, response) {
    var result = super.finishUpload(file, response);
    if (typeof response == 'string') response = jQuery.parseJSON(response);
    if (response.response[0] && typeof response.response[0].data.length == 'undefined') {
      for (var key in response.response[0].data) {
        var value = response.response[0].data[key];
        if (value && value.path) {
          this._addFile(value);
          jQuery("[data-file='" + file.fileName.replace(/'/g, '&quot') + "']", this.progress).hide();
        }
      }
    }
    return result;
  }
  _addFile(file_data) {
    if (jQuery("[data-path='" + file_data.path.replace(/'/g, '&quot') + "']").remove().length) {
      for (var child_index = this._children.length - 1; child_index >= 0; child_index--) {
        var child = this._children[child_index];
        if (child.options.value.path === file_data.path) {
          this.removeChild(child);
          child.destroy();
        }
      }
    }
    // Set up for expose
    if (file_data && typeof file_data.download_url === "undefined") {
      file_data.download_url = "/webdav.php" + file_data.path;
    }
    var row = jQuery(document.createElement("tr")).attr("data-path", file_data.path.replace(/'/g, '&quot')).attr("draggable", "true").appendTo(this.list);
    jQuery(document.createElement("td")).addClass('icon').appendTo(row);
    jQuery(document.createElement("td")).addClass('title').appendTo(row);
    var mime = et2_createWidget('vfs-mime', {
      value: file_data
    }, this);

    // Trigger expose on click, if supported
    var vfs_attrs = {
      value: file_data,
      onclick: undefined
    };
    if (file_data && typeof file_data.download_url != 'undefined') {
      var fe_mime = egw$1.file_editor_prefered_mimes(file_data.mime);
      // Pass off opening responsibility to the Et2VfsMime widget
      if (typeof file_data.mime === 'string' && mime.isExposable()) {
        vfs_attrs.onclick = function (ev) {
          ev.stopPropagation();
          // Pass it off to the associated vfsMime widget
          jQuery('img', this.parentNode.parentNode).trigger("click");
          return false;
        };
      }
    }
    var vfs = et2_createWidget('vfs', vfs_attrs, this);

    // If already attached, need to do this explicitly
    if (this.isAttached()) {
      mime.set_value(file_data);
      vfs.set_value(file_data);
      vfs.doLoadingFinished();
    }

    // Add in delete button
    if (!this.options.readonly) {
      var self = this;
      var delete_button = jQuery(document.createElement("td")).appendTo(row);
      jQuery("<div />").appendTo(delete_button)
      // We don't use ui-icon because it assigns a bg image
      .addClass("delete icon").bind('click', function () {
        var d = new Et2Dialog$1('api');
        d.transformAttributes({
          callback: function callback(button) {
            if (button == Et2Dialog$1.YES_BUTTON) {
              egw$1.json("filemanager_ui::ajax_action", ['delete', [row.attr('data-path').replace(/&quot/g, "'")], ''], function (data) {
                if (data && data.errs == 0) {
                  row.slideUp(null, row.remove);
                }
                if (data && data.msg) {
                  self.egw().message(data.msg, data.errs == 0 ? 'success' : 'error');
                }
              }).sendRequest();
            }
          },
          message: self.egw().lang('Delete file') + '?',
          title: self.egw().lang('Confirmation required'),
          buttons: Et2Dialog$1.BUTTONS_YES_NO,
          dialog_type: Et2Dialog$1.QUESTION_MESSAGE,
          width: 250
        });
        document.body.appendChild(d);
      });
    }
  }
}
_defineProperty$y(et2_vfsUpload, "_attributes", {
  "value": {
    "type": "any" // Either nothing, or an object with file info
  },

  "path": {
    "name": "Path",
    "description": "Upload files to the specified VFS path",
    "type": "string",
    "default": ''
  },
  "listonly": {
    "name": "List Only",
    "description": "Display given file objects only as list (removes span,input and progress from the dom)",
    "type": "boolean",
    "default": false
  }
});
_defineProperty$y(et2_vfsUpload, "legacyOptions", ["mime"]);
et2_register_widget(et2_vfsUpload, ["vfs-upload"]);
class et2_vfsSelect extends et2_inputWidget {
  /**
   * Constructor
   *
   * @param _parent
   * @param _attrs
   * @memberOf et2_vfsSelect
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_vfsSelect._attributes, _child || {}));

    // Allow no child widgets
    // Allowed mode options
    _defineProperty$y(this, "modes", ['open', 'open-multiple', 'saveas', 'select-dir']);
    _defineProperty$y(this, "button", void 0);
    _defineProperty$y(this, "submit_callback", void 0);
    _defineProperty$y(this, "dialog", void 0);
    _defineProperty$y(this, "value", void 0);
    this.supportedWidgetClasses = [];
    this.button = jQuery(document.createElement("et2-button")).attr("title", this.egw().lang("Select file(s) from VFS")).attr("noSubmit", true).addClass("et2_vfs_btn").attr("image", "filemanager/navbar");
    if (this.options.readonly) {
      this.button.hide();
    }
    if (this.options.button_caption != "") {
      this.button.text(this.options.button_caption);
    }
    this.setDOMNode(this.button[0]);
  }
  _content(_content, _callback) {
    egw$1(window).loading_prompt('vfs-select', true, '', 'body');
    var self = this;
    if (typeof app.vfsSelectUI != "undefined") {
      if (this.dialog) {
        this.dialog.close();
      }
      app.vfsSelectUI.destroy();
      delete app.vfsSelectUI;
    }
    var attrs = {
      mode: this.options.mode,
      label: this.options.button_label,
      path: this.options.path || null,
      mime: this.options.mime || null,
      name: this.options.name,
      method: this.options.method,
      recentPaths: et2_vfsSelect._getRecentPaths()
    };
    var callback = _callback || this._buildDialog;
    egw$1(window).json('EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_vfsSelect_content', [_content, attrs], function (_content) {
      egw$1(window).loading_prompt('vfs-select', false);
      callback.apply(self, arguments);
    }).sendRequest(true);
  }

  /**
   * Builds file navigator dialog
   *
   * @param {object} _data content
   */
  _buildDialog(_data) {
    if (!_data.content.mode.match(/open|open-multiple|saveas|select-dir/)) {
      egw$1.debug('warn', 'Mode is not matched!');
      return;
    }
    var self = this;
    var buttons = [{
      label: egw$1.lang(_data.content.label),
      id: "submit",
      image: _data.content.mode.match(/saveas|select-dir/) ? "save" : this.options.button_icon,
      default: false
    }];
    var extra_buttons_action = {};
    if (this.options.extra_buttons && this.options.method) {
      for (var i = 0; i < this.options.extra_buttons.length; i++) {
        delete this.options.extra_buttons[i]['click'];
        buttons.push(this.options.extra_buttons[i]);
        extra_buttons_action[this.options.extra_buttons[i]['id']] = this.options.extra_buttons[i]['id'];
      }
    }
    buttons.push({
      label: egw$1.lang("Close"),
      id: "close",
      image: "cancel"
    });

    // Don't rely only on app_name to fetch et2 object as app_name may not
    // always represent current app of the window, e.g.: mail admin account.
    // Try to fetch et2 from its template name.
    var etemplate = jQuery('form').data('etemplate');
    var et2;
    var currentApp = egw$1(window).app_name();
    if (etemplate && etemplate.name && !app[currentApp]) {
      et2 = etemplate2.getByTemplate(etemplate.name)[0];
      currentApp = et2.name.split('.')[0];
    } else {
      et2 = etemplate2.getByApplication(currentApp)[0];
    }
    var data = jQuery.extend(_data, {
      'currentapp': currentApp,
      etemplate_exec_id: et2.etemplate_exec_id
    });

    // define a mini app object for vfs select UI
    app.vfsSelectUI = et2.app_obj['vfsSelectUI'] = new app.classes.vfsSelectUI();

    // callback for dialog
    this.submit_callback = function (submit_button_id, submit_value, savemode) {
      if ((submit_button_id == 'submit' || extra_buttons_action && extra_buttons_action[submit_button_id]) && submit_value) {
        var files = [];
        switch (_data.content.mode) {
          case 'open-multiple':
            if (submit_value.dir && submit_value.dir.selected) {
              for (var key in Object.keys(submit_value.dir.selected)) {
                if (submit_value.dir.selected[key] != "") {
                  files.push(submit_value.path + '/' + submit_value.dir.selected[key]);
                }
              }
            }
            break;
          case 'select-dir':
            files = submit_value.path;
            break;
          default:
            if (self.options.method === 'download') submit_value.path = _data.content.download_baseUrl;
            files = submit_value.path + '/' + submit_value.name;
            if (self.options.mode === 'saveas' && !savemode) {
              for (var p in _data.content.dir) {
                if (_data.content.dir[p]['name'] == submit_value.name) {
                  var saveModeDialogButtons = [{
                    text: self.egw().lang("Yes"),
                    id: "overwrite",
                    class: "ui-priority-primary",
                    "default": true,
                    image: 'check'
                  }, {
                    text: self.egw().lang("Rename"),
                    id: "rename",
                    image: 'edit'
                  }, {
                    text: self.egw().lang("Cancel"),
                    id: "cancel"
                  }];
                  return Et2Dialog$1.show_prompt(function (_button_id, _value) {
                    switch (_button_id) {
                      case "overwrite":
                        return self.submit_callback(submit_button_id, submit_value, 'overwrite');
                      case "rename":
                        submit_value.name = _value;
                        return self.submit_callback(submit_button_id, submit_value, 'rename');
                    }
                  }, self.egw().lang('Do you want to overwrite existing file %1 in directory %2?', submit_value.name, submit_value.path), self.egw().lang('File %1 already exists', submit_value.name), submit_value.name, saveModeDialogButtons, null);
                }
              }
            }
            break;
        }
        et2_vfsSelect._setRecentPaths(submit_value.path);
        self.value = files;
        if (self.options.method && self.options.method !== 'download') {
          egw$1(window).request(self.options.method, [self.options.method_id, files, submit_button_id, savemode]).then(function (data) {
            jQuery(self.node).change();
          });
        } else {
          jQuery(self.node).change();
        }
        delete app.vfsSelectUI;
        self.dialog.close();
        return true;
      }
    };
    this.dialog = new Et2Dialog$1('api');
    this.dialog.transformAttributes({
      callback: this.submit_callback,
      title: this.options.dialog_title,
      buttons: buttons,
      minWidth: 500,
      minHeight: 400,
      value: data,
      template: egw$1.webserverUrl + '/api/templates/default/vfsSelectUI.xet',
      resizable: false,
      // Don't destroy on close, it would take out the opening etemplate
      destroy_on_close: false
    });
    this.dialog.addEventListener("before-load", ev => {
      this.dialog.template.uniqueId = 'api.vfsSelectUI';
    });
    document.body.appendChild(this.dialog);

    // Wait for dialog to finish loading
    this.dialog.updateComplete.then(() => {
      app.vfsSelectUI.et2 = self.dialog.template.widgetContainer;
      app.vfsSelectUI.vfsSelectWidget = self;
      app.vfsSelectUI.et2_ready(app.vfsSelectUI.et2, 'api.vfsSelectUI');
      app.vfsSelectUI.et2.getInstanceManager().app_obj['vfsSelectUI'] = app.vfsSelectUI;
    });
    this.dialog.addEventListener("close", () => {
      self.dialog = undefined;
    });
  }

  /**
   * Set recent path into sessionStorage
   * @param {string} _path
   */
  static _setRecentPaths(_path) {
    var recentPaths = egw$1.getSessionItem('api', 'vfsRecentPaths') ? egw$1.getSessionItem('api', 'vfsRecentPaths').split(',') : [];
    if (recentPaths.indexOf(_path) == -1) recentPaths.push(_path);
    egw$1.setSessionItem('api', 'vfsRecentPaths', recentPaths);
  }

  /**
   * Get recent paths from sessionStorage
   * @returns {Array} returns an array of recent paths
   */
  static _getRecentPaths() {
    return egw$1.getSessionItem('api', 'vfsRecentPaths') ? egw$1.getSessionItem('api', 'vfsRecentPaths').split(',') : [];
  }

  /**
   * click handler
   * @param {event object} e
   */
  click(e) {
    this._content.call(this, null);
  }

  /**
   * Set the dialog's mode.
   * Valid options are in et2_vfsSelect.modes
   *
   * @param {string} mode 'open', 'open-multiple', 'saveas' or 'select-dir'
   */
  set_mode(mode) {
    // Check mode
    if (jQuery.inArray(mode, this.modes) < 0) {
      this.egw().debug("warn", "Invalid mode for '%s': %s Valid options:", this.id, mode, this.modes);
      return;
    }
    this.options.mode = mode;
  }

  /**
   * Set the label on the dialog's OK button.
   *
   * @param {string} label
   */
  set_button_label(label) {
    this.options.button_label = label;
  }

  /**
   * Set the caption for vfs-select button
   *
   * @param {string} caption string value as a caption
   */
  set_button_caption(caption) {
    this.options.button_caption = caption;
  }

  /**
   * Set the ID passed to the server side callback
   *
   * @param {string} id
   */
  set_method_id(id) {
    this.options.method_id = id;
  }
  set_readonly(readonly) {
    this.options.readonly = Boolean(readonly);
    if (this.options.readonly) {
      this.button.hide();
    } else {
      this.button.show();
    }
  }
  set_value(value) {
    this.value = value;
  }
  getValue() {
    return this.value;
  }
}
_defineProperty$y(et2_vfsSelect, "_attributes", {
  "mode": {
    name: "Dialog mode",
    type: "string",
    description: "One of {open|open-multiple|saveas|select-dir}",
    default: "open-multiple"
  },
  "method": {
    name: "Server side callback",
    type: "string",
    description: "Server side callback to process selected value(s) in \n\
		app.class.method or class::method format.  The first parameter will \n\
		be Method ID, the second the file list. 'download' is reserved and it \n\
		means it should use download_baseUrl instead of path in value (no method\n\
		 will be actually executed)."
  },
  "method_id": {
    name: "Method ID",
    type: "any",
    description: "optional parameter passed to server side callback.\n\
		Can be a string or a function.",
    default: ""
  },
  "path": {
    name: "Path",
    type: "string",
    description: "Start path in VFS.  Leave unset to use the last used path."
  },
  "mime": {
    name: "Mime type",
    type: "any",
    description: "Limit display to the given mime-type"
  },
  "button_label": {
    name: "Button label",
    description: "Set the label on the dialog's OK button.",
    default: "open"
  },
  "value": {
    type: "any",
    // Object
    description: "Array of paths (strings)"
  },
  "button_caption": {
    name: "button caption",
    type: "string",
    default: "Select files from Filemanager ...",
    description: "Caption for vfs-select button.",
    translate: true
  },
  "button_icon": {
    name: "button icon",
    type: "string",
    default: "check",
    description: "Custom icon to show on submit button."
  },
  "name": {
    name: "File name",
    type: "any",
    // Object
    description: "file name",
    default: ""
  },
  "dialog_title": {
    name: "dialog title",
    type: "string",
    default: "Save as",
    description: "Title of dialog",
    translate: true
  },
  "extra_buttons": {
    name: "extra action buttons",
    type: "any",
    description: "Extra buttons passed to dialog. It's co-related to method."
  }
});
;
et2_register_widget(et2_vfsSelect, ["vfs-select"]);

var _templateObject$2, _templateObject2$2, _templateObject3$2;
function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { _defineProperty$x(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral$2(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$x(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2VfsMime extends Et2ImageExpose {
  static get styles() {
    return [...super.styles, i$b(_templateObject$2 || (_templateObject$2 = _taggedTemplateLiteral$2(["\n            :host {\n            \tposition: relative\n            }\n            img.overlay {\n            \tposition: absolute;\n            \tbottom: 0px;\n            \tright: 0px;\n            \tz-index: 1;\n            \twidth: 12px;\n            \theight: 12px;\n            }\n            "])))];
  }
  static get properties() {
    return _objectSpread$3(_objectSpread$3({}, super.properties), {}, {
      /**
       * Mime type we're displaying
       */
      mime: {
        type: String,
        reflect: true
      },
      /**
       * Mark the file as a link
       */
      symlink: {
        type: Boolean,
        reflect: true
      },
      /** Allow to pass all data */
      value: {
        type: Object
      }
    });
  }

  /**
   * Mime type of directories
   */

  constructor() {
    super();
    _defineProperty$x(this, "__mime", void 0);
    _defineProperty$x(this, "__symlink", void 0);
    _defineProperty$x(this, "__download_url", void 0);
    this.__mime = "";
    this.__symlink = false;
    this.__download_url = "";
  }

  /**
   * Used to determine if this widget is exposable.  Images always are, even if we don't actually
   * know the mime type.
   *
   * @returns {ExposeValue}
   */
  get exposeValue() {
    return Object.assign(super.exposeValue, {
      mime: this.mime,
      download_url: this.__download_url
    });
  }

  /**
   * Overridden here because while some files cannot actually be put in the gallery, we still want to handle them
   * in some way.  Some files we'll open directly on click
   *
   * @returns {boolean}
   */
  isExposable() {
    // do not try to expose directories, they are handled by the action system
    if (this.exposeValue.mime === Et2VfsMime.DIR_MIME_TYPE) {
      return false;
    }
    var gallery = super.isExposable();

    // @ts-ignore Wants an argument, but does not require it
    var fe = egw.file_editor_prefered_mimes();
    if (fe && fe.mime && fe.edit && fe.mime[this.exposeValue.mime]) {
      return true;
    }
    return gallery;
  }

  /**
   * Override et2-image click-handler, to not call egw.open_link with href=<vfs-path>
   *
   * @param {MouseEvent} _ev
   * @returns {boolean}
   */
  _handleClick(_ev) {
    if (this.isExposable()) {
      this.expose_onclick(_ev);
    }
    return false;
  }

  /**
   * Some files cannot be opened in gallery, but we still want to do something with them
   * Editable files we open on click.
   *
   * @param {MouseEvent} event
   * @returns {boolean}
   * @protected
   */
  expose_onclick(event) {
    // super.expose_onclick returns false when it has handled the event, true if it didn't
    var super_handled = super.expose_onclick(event);
    if (true == super_handled) {
      // @ts-ignore Wants an argument, but does not require it
      var fe = egw.file_editor_prefered_mimes();
      if (fe && fe.mime && fe.edit && fe.mime[this.exposeValue.mime]) {
        egw.open_link(egw.link('/index.php', {
          menuaction: fe.edit.menuaction,
          path: this.exposeValue.path,
          cd: 'no' // needed to not reload framework in sharing
        }), '', fe.edit_popup);
        return false;
      }
    }
    return super_handled;
  }

  /**
   * Function to get media content to feed the expose
   *
   * @param {type} _value
   * @returns {Array} return an array of object consists of media content
   */
  getMedia(_value) {
    var mediaContent = Object.assign(super.getMedia(_value)[0], {
      title: _value.name,
      type: _value.mime,
      href: _value.download_url
    });

    // check if download_url is not already an url (some stream-wrappers allow to specify that!)
    if (_value.download_url && (_value.download_url[0] == '/' || _value.download_url.substr(0, 4) != 'http')) {
      mediaContent.href = this._processUrl(_value.download_url);
      if (mediaContent.href && mediaContent.href.match(/\/webdav.php/, 'ig')) {
        mediaContent["download_href"] = mediaContent.href + '?download';
      }
    }
    mediaContent["thumbnail"] = this.egw().mime_icon(_value.mime, _value.path, undefined, _value.mtime);
    return [mediaContent];
  }
  set_value(_value) {
    this.value = _value;
  }
  set value(_value) {
    if (!_value) {
      return;
    }
    if (typeof _value !== 'object') {
      this.egw().debug("warn", "%s only has path, needs array with path & mime", this.id, _value);
      // Keep going, will be 'unknown type'
    }

    if (_value.mime) {
      this.mime = _value.mime;
    }
    if (_value.path) {
      this.href = _value.path;
    }
    if (_value.download_url) {
      this.__download_url = _value.download_url;
    }
    var src = this.egw().mime_icon(_value.mime, _value.path, undefined, _value.mtime);
    if (src) {
      this.src = src;
    }
    // add/remove link icon, if file is (not) a symlink
    this.symlink = typeof _value.mode !== "undefined" && (_value.mode & et2_vfsMode.types.l) == et2_vfsMode.types.l;
  }
  get value() {
    var _this$__download_url;
    return {
      mime: this.mime,
      symlink: this.__symlink,
      href: this.href,
      path: this.href,
      download_url: (_this$__download_url = this.__download_url) !== null && _this$__download_url !== void 0 ? _this$__download_url : '',
      src: this.src
    };
  }
  get src() {
    return super.src;
  }
  set src(_value) {
    super.src = _value;
    this._set_tooltip();
  }
  render() {
    return x$1(_templateObject2$2 || (_templateObject2$2 = _taggedTemplateLiteral$2(["\n            <slot></slot>\n            ", "\n\t\t"])), this.__symlink ? x$1(_templateObject3$2 || (_templateObject3$2 = _taggedTemplateLiteral$2(["<img src=\"", "\"\n                                         class=\"overlay\"/>"])), this.egw().image("symlink", "api")) : "");
  }
  _set_tooltip() {
    // tooltip for mimetypes with available detailed thumbnail
    if (this.mime && this.mime.match(/application\/vnd\.oasis\.opendocument\.(text|presentation|spreadsheet|chart)/)) {
      this.egw().tooltipBind(this, '<img src="' + this.src + '&thsize=512"/>', true);
    } else {
      this.egw().tooltipUnbind(this);
    }
  }
}
_defineProperty$x(Et2VfsMime, "DIR_MIME_TYPE", 'httpd/unix-directory');
customElements.define("et2-vfs-mime", Et2VfsMime, {
  extends: 'img'
});

/**
 * EGroupware eTemplate2 - Readonly select WebComponent
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package api
 * @link https://www.egroupware.org
 * @author Ralf Becker <rb@egroupware.org>
 */
class Et2VfsUid extends Et2SelectAccountReadonly {
  set value(_val) {
    if (!_val || _val === '0') {
      this.select_options = [{
        value: '0',
        label: 'root'
      }];
    }
    super.value = _val;
  }
  get value() {
    return super.value;
  }
}
// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-vfs-uid", Et2VfsUid);
class Et2VfsGid extends Et2VfsUid {}
// @ts-ignore TypeScript is not recognizing that this widget is a LitElement
customElements.define("et2-vfs-gid", Et2VfsGid);

var _navigator$userAgentD, _templateObject$1, _templateObject2$1, _templateObject3$1, _templateObject4, _templateObject5;
function _taggedTemplateLiteral$1(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { _defineProperty$w(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$w(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var isChromium = (_navigator$userAgentD = navigator.userAgentData) === null || _navigator$userAgentD === void 0 ? void 0 : _navigator$userAgentD.brands.some(b => b.brand.includes('Chromium'));
var isFirefox = isChromium ? false : navigator.userAgent.includes('Firefox');

/**
 * @customElement et2-password
 */
class Et2Password extends Et2InvokerMixin(Et2Textbox) {
  /** @type {any} */
  static get properties() {
    return _objectSpread$2(_objectSpread$2({}, super.properties), {}, {
      /**
       * Password is plaintext
       */
      plaintext: Boolean,
      /**
       * Suggest password length (0 for off)
       */
      suggest: Number
    });
  }
  constructor() {
    super(...arguments);
    // The password is stored encrypted server side, and passed encrypted.
    // This flag is for if we've decrypted the password to show it already
    _defineProperty$w(this, "encrypted", true);
    _defineProperty$w(this, "visible", false);
    this.plaintext = true;
    this.suggest = 0;
    this._invokerLabel = '';
    this._invokerTitle = this.egw().lang("Suggest password");
    this._invokerAction = () => {
      this.suggestPassword();
    };
  }
  transformAttributes(attrs) {
    if (typeof attrs.suggest !== "undefined") {
      attrs.suggest = parseInt(attrs.suggest);
    }
    attrs.type = 'password';
    if (typeof attrs.viewable !== "undefined") {
      attrs['togglePassword'] = attrs.viewable;
      delete attrs.viewable;
    }
    if (typeof attrs.togglePassword !== "undefined" && !attrs.togglePassword || typeof attrs.togglePassword == "string" && !this.getArrayMgr("content").parseBoolExpression(attrs.togglePassword)) {
      // Unset togglePassword if its false.  It's from parent, and it doesn't handle string "false" = false
      delete attrs.togglePassword;
    }
    super.transformAttributes(attrs);
  }

  /**
   * Method to check if invoker can be activated: not disabled, empty or invalid
   *
   * @protected
   * */
  _toggleInvokerDisabled() {
    if (this._invokerNode) {
      var invokerNode = /** @type {HTMLElement & {disabled: boolean}} */this._invokerNode;
      invokerNode.disabled = this.disabled || this.readonly;
    }
  }

  /**
   * @param {PropertyKey} name
   * @param {?} oldValue
   */
  requestUpdate(name, oldValue) {
    super.requestUpdate(name, oldValue);
    if (name === 'suggest' && this.suggest != oldValue) {
      this._invokerLabel = this.suggest ? 'generate_password' : '';
      this._toggleInvokerDisabled();
    }
  }

  /**
   * @param _len
   * @deprecated use this.suggest instead
   */
  set_suggest(_len) {
    this.suggest = _len;
  }

  /**
   * Ask the server for a password suggestion
   */
  suggestPassword() {
    // They need to see the suggestion
    this.encrypted = false;
    this.type = 'text';
    //this.toggle_visibility(true);

    var suggestion = "Suggestion";
    var request = egw$1.request("EGroupware\\Api\\Etemplate\\Widget\\Password::ajax_suggest", [this.suggest]).then(suggestion => {
      this.encrypted = false;
      this.value = suggestion;

      // Check for second password, update it too
      var two = this.getParent().getWidgetById(this.id + '_2');
      if (two && two.getType() == this.getType()) {
        two.type = 'text';
        two.value = suggestion;
      }
    });
  }

  /**
   * If the password is viewable, toggle the visibility.
   * If the password is still encrypted, we'll ask for the user's password then have the server decrypt it.
   */
  handlePasswordToggle() {
    super.handlePasswordToggle();
    this.visible = !this.visible; // can't access private isPasswordVisible

    if (!this.visible || !this.encrypted || !this.value) {
      this.type = this.visible ? 'text' : 'password';
      return;
    }
    if (this.plaintext) return; // no need to query user-password, if the password is plaintext

    // Need username & password to decrypt
    Et2Dialog$1.show_prompt((button, user_password) => {
      if (button == Et2Dialog$1.CANCEL_BUTTON) {
        return this.handlePasswordToggle();
      }
      this.egw().request("EGroupware\\Api\\Etemplate\\Widget\\Password::ajax_decrypt", [user_password, this.value]).then(decrypted => {
        if (decrypted) {
          this.encrypted = false;
          this.value = decrypted;
          this.type = 'text';
        } else {
          this.set_validation_error(this.egw().lang("invalid password"));
          window.setTimeout(() => {
            this.set_validation_error(false);
          }, 2000);
        }
      });
    }, this.egw().lang("Enter your password"), this.egw().lang("Authenticate"));
  }
  render() {
    var hasLabelSlot = this.hasSlotController.test('label');
    var hasHelpTextSlot = this.hasSlotController.test('help-text');
    var hasLabel = this.label ? true : !!hasLabelSlot;
    var hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    var hasClearIcon = this.clearable && !this.disabled && !this.readonly && (typeof this.value === 'number' || this.value.length > 0);
    return x$1(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteral$1(["\n            <div\n                    part=\"form-control\"\n                    class=", "\n            >\n                <label\n                        part=\"form-control-label\"\n                        class=\"form-control__label\"\n                        for=\"input\"\n                        aria-hidden=", "\n                >\n                    <slot name=\"label\">", "</slot>\n                </label>\n                <div part=\"form-control-input\" class=\"form-control-input\">\n                    <div\n                            part=\"base\"\n                            class=", "\n                    >\n                        <slot name=\"prefix\" part=\"prefix\" class=\"input__prefix\"></slot>\n                        <input\n                                part=\"input\"\n                                id=\"input\"\n                                class=\"input__control\"\n                                type=", "\n                                title=", "\n                                name=", "\n                                ?disabled=", "\n                                ?readonly=", "\n                                ?required=", "\n                                placeholder=", "\n                                minlength=", "\n                                maxlength=", "\n                                min=", "\n                                max=", "\n                                step=", "\n                                .value=", "\n                                autocapitalize=", "\n                                autocomplete=", "\n                                autocorrect=\"off\"\n                                ?autofocus=", "\n                                spellcheck=", "\n                                pattern=", "\n                                enterkeyhint=", "\n                                inputmode=", "\n                                aria-describedby=\"help-text\"\n                                @change=", "\n                                @input=", "\n                                @invalid=", "\n                                @keydown=", "\n                                @focus=", "\n                                @blur=", "\n                        />\n                        ", "\n                        ", "\n                        <slot name=\"suffix\" part=\"suffix\" class=\"input__suffix\"></slot>\n                    </div>\n                </div>\n                <slot\n                        name=\"help-text\"\n                        part=\"form-control-help-text\"\n                        id=\"help-text\"\n                        class=\"form-control__help-text\"\n                        aria-hidden=", "\n                >\n                    ", "\n                </slot>\n            </div>\n            </div>\n\t\t"])), o$9({
      'form-control': true,
      'form-control--small': this.size === 'small',
      'form-control--medium': this.size === 'medium',
      'form-control--large': this.size === 'large',
      'form-control--has-label': hasLabel,
      'form-control--has-help-text': hasHelpText
    }), hasLabel ? 'false' : 'true', this.label, o$9({
      input: true,
      // Sizes
      'input--small': this.size === 'small',
      'input--medium': this.size === 'medium',
      'input--large': this.size === 'large',
      // States
      'input--pill': this.pill,
      'input--standard': !this.filled,
      'input--filled': this.filled,
      'input--disabled': this.disabled,
      'input--focused': this.hasFocus,
      'input--empty': !this.value,
      'input--no-spin-buttons': this.noSpinButtons,
      'input--is-firefox': isFirefox
    }), this.type === 'password' && this.passwordVisible ? 'text' : this.type, this.title /* An empty title prevents browser validation tooltips from appearing on hover */, l$2(this.name), this.disabled, this.readonly || this.autocomplete == "new-password", this.required, l$2(this.placeholder), l$2(this.minlength), l$2(this.maxlength), l$2(this.min), l$2(this.max), l$2(this.step), this.value, l$2(this.type === 'password' ? 'off' : this.autocapitalize), l$2(this.autocomplete), this.autofocus, this.spellcheck, l$2(this.pattern), l$2(this.enterkeyhint), l$2(this.inputmode), this.handleChange, this.handleInput, this.handleInvalid, this.handleKeyDown, this.handleFocus, this.handleBlur, hasClearIcon ? x$1(_templateObject2$1 || (_templateObject2$1 = _taggedTemplateLiteral$1(["\n                                    <button\n                                            part=\"clear-button\"\n                                            class=\"input__clear\"\n                                            type=\"button\"\n                                            aria-label=", "\n                                            @click=", "\n                                            tabindex=\"-1\"\n                                    >\n                                        <slot name=\"clear-icon\">\n                                            <sl-icon name=\"x-circle-fill\" library=\"system\"></sl-icon>\n                                        </slot>\n                                    </button>\n                                "])), this.localize.term('clearEntry'), this.handleClearClick) : '', this.togglePassword && !this.disabled ? x$1(_templateObject3$1 || (_templateObject3$1 = _taggedTemplateLiteral$1(["\n                                    <button\n                                            part=\"password-toggle-button\"\n                                            class=\"input__password-toggle\"\n                                            type=\"button\"\n                                            aria-label=", "\n                                            @click=", "\n                                            tabindex=\"-1\"\n                                    >\n                                        ", "\n                                    </button>\n                                "])), this.localize.term(this.isPasswordVisible ? 'hidePassword' : 'showPassword'), this.handlePasswordToggle, this.isPasswordVisible ? x$1(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral$1(["\n                                                    <slot name=\"show-password-icon\">\n                                                        <sl-icon name=\"eye-slash\" library=\"system\"></sl-icon>\n                                                    </slot>\n                                                "]))) : x$1(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral$1(["\n                                                    <slot name=\"hide-password-icon\">\n                                                        <sl-icon name=\"eye\" library=\"system\"></sl-icon>\n                                                    </slot>\n                                                "])))) : '', hasHelpText ? 'false' : 'true', this.helpText);
  }
  handleFocus(e) {
    if (!this.readonly) {
      this.shadowRoot.querySelector("input").removeAttribute("readonly");
    }
    super.handleFocus(e);
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-password", Et2Password);

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$v(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _defineProperty$v(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @customElement et2-searchbox
 */
class Et2Searchbox extends Et2Textbox {
  /** @type {any} */
  static get properties() {
    return _objectSpread$1(_objectSpread$1({}, super.properties), {}, {
      /**
       * Define whether the searchbox overlays while it's open (true) or stay as solid box in front of the search button (false). Default is false.
       * @todo implement again
       */
      overlay: Boolean,
      /**
       * Define whether the searchbox should be a fix input field or flexible search button. Default is true (fix).
       * @todo implement again
       */
      fix: Boolean
    });
  }
  constructor() {
    super(...arguments);
    this.overlay = false;
    this.fix = true;
    this.clearable = true;
    this.type = 'search';
    this.placeholder = 'search';
    this.enterkeyhint = 'search';
  }

  /**
   * Overwritten to trigger a change/search
   *
   * @param event
   */
  handleKeyDown(event) {
    var hasModifier = event.metaKey || event.ctrlKey || event.shiftKey || event.altKey;

    // Pressing enter when focused on an input should submit the form like a native input, but we wait a tick before
    // submitting to allow users to cancel the keydown event if they need to
    if (event.key === 'Enter' && !hasModifier) {
      event.preventDefault();

      // Stop from bubbling; enter in search is just for here.
      event.stopPropagation();

      // Lose focus, which triggers change, instead of calling change handler which would trigger again when losing focus
      this.blur();
    }
  }

  /**
   * Overwritten to trigger a change/search
   *
   * @param event
   */
  handleClearClick(event) {
    event.preventDefault();
    this.value = '';
    this._oldChange(event);

    // Call super so it works as expected
    super.handleClearClick(event);
  }
}
// @ts-ignore TypeScript is not recognizing that this is a LitElement
customElements.define("et2-searchbox", Et2Searchbox);

var _templateObject, _templateObject2, _templateObject3;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty$u(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
function _defineProperty$u(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
class Et2Tree extends Et2WidgetWithSelectMixin(s$5) {
  static get styles() {
    return [shoelace,
    // @ts-ignore
    ...super.styles, i$b(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n\n\t\t\t"])))];
  }
  constructor() {
    super();
    _defineProperty$u(this, "currentItem", void 0);
    _defineProperty$u(this, "input", null);
    _defineProperty$u(this, "autoloading_url", void 0);
    _defineProperty$u(this, "selectOptions", []);
    _defineProperty$u(this, "needsLazyLoading", true);
  }
  loadFromXML() {
    //if(this.id)
    this.selectOptions = find_select_options(this)[1];
  }
  static get properties() {
    return _objectSpread(_objectSpread({}, super.properties), {}, {
      multiple: {
        name: "",
        type: Boolean,
        default: false,
        description: "Allow selecting multiple options"
      },
      selectOptions: {
        type: "any",
        name: "Select options",
        default: {},
        description: "Used to set the tree options."
      },
      onClick: {
        name: "onClick",
        type: "js",
        description: "JS code which gets executed when clicks on text of a node"
      },
      onSelect: {
        name: "onSelect",
        type: "js",
        default: et2_no_init,
        description: "Javascript executed when user selects a node"
      },
      onCheck: {
        name: "onCheck",
        type: "js",
        default: et2_no_init,
        description: "Javascript executed when user checks a node"
      },
      // TODO do this : --> onChange event is mapped depending on multiple to onCheck or onSelect
      onOpenStart: {
        name: "onOpenStart",
        type: "js",
        default: et2_no_init,
        description: "Javascript function executed when user opens a node: function(_id, _widget, _hasChildren) returning true to allow opening!"
      },
      onOpenEnd: {
        name: "onOpenEnd",
        type: "js",
        default: et2_no_init,
        description: "Javascript function executed when opening a node is finished: function(_id, _widget, _hasChildren)"
      },
      imagePath: {
        name: "Image directory",
        type: String,
        default: egw$1().webserverUrl + "/api/templates/default/images/dhtmlxtree/",
        //TODO we will need a different path here! maybe just rename the path?
        description: "Directory for tree structure images, set on server-side to 'dhtmlx' subdir of templates image-directory"
      },
      value: {
        type: "any",
        default: {}
      },
      actions: {
        name: "Actions array",
        type: "any",
        default: et2_no_init,
        description: "List of egw actions that can be done on the tree.  This includes context menu, drag and drop.  TODO: Link to action documentation"
      },
      autoLoading: {
        name: "Auto loading",
        type: String,
        default: "",
        description: "JSON URL or menuaction to be called for nodes marked with child=1, but not having children, GET parameter selected contains node-id"
      },
      stdImages: {
        name: "Standard images",
        type: String,
        default: "",
        description: "comma-separated names of icons for a leaf, closed and opened folder (default: leaf.png,folderClosed.png,folderOpen.png), images with extension get loaded from imagePath, just 'image' or 'appname/image' are allowed too"
      },
      multiMarking: {
        name: "multi marking",
        type: "any",
        default: false,
        description: "Allow marking multiple nodes, default is false which means disabled multiselection, true or 'strict' activates it and 'strict' makes it strict to only same level marking"
      },
      highlighting: {
        name: "highlighting",
        type: Boolean,
        default: false,
        description: "Add highlighting class on hovered over item, highlighting is disabled by default"
      }
    });
  }
  set onOpenStart(_handler) {
    this.installHandler("onOpenStart", _handler);
  }
  set onChange(_handler) {
    this.installHandler("onChange", _handler);
  }
  set onClick(_handler) {
    this.installHandler("onClick", _handler);
  }
  set onSelect(_handler) {
    this.installHandler("onSelect", _handler);
  }
  set onOpenEnd(_handler) {
    this.installHandler("onOpenEnd", _handler);
  }

  /**
   * @deprecated assign to onOpenStart
   * @param _handler
   */
  set_onopenstart(_handler) {
    this.installHandler("onOpenStart", _handler);
  }

  /**
   * @deprecated assign to onChange
   * @param _handler
   */
  set_onchange(_handler) {
    this.installHandler('onchange', _handler);
  }

  /**
   * @deprecated assign to onClick
   * @param _handler
   */
  set_onclick(_handler) {
    this.installHandler('onclick', _handler);
  }

  /**
   * @deprecated assign to onSelect
   * @param _handler
   */
  set_onselect(_handler) {
    this.installHandler('onselect', _handler);
  }

  /**
   * @deprecated assign to onOpenEnd
   * @param _handler
   */
  set_onopenend(_handler) {
    this.installHandler('onOpenEnd', _handler);
  }
  installHandler(_name, _handler) {
    if (this.input == null) this.createTree();
    // automatic convert onChange event to oncheck or onSelect depending on multiple is used or not
    // if (_name == "onchange") {
    //     _name = this.options.multiple ? "oncheck" : "onselect"
    // }
    // let handler = _handler;
    // let widget = this;
    // this.input.attachEvent(_name, function(_id){
    //     let args = jQuery.makeArray(arguments);
    //     // splice in widget as 2. parameter, 1. is new node-id, now 3. is old node id
    //     args.splice(1, 0, widget);
    //     // try to close mobile sidemenu after clicking on node
    //     if (egwIsMobile() && typeof args[2] == 'string') framework.toggleMenu('on');
    //     return handler.apply(this, args);
    // });
  }

  createTree() {
    // widget.input = document.querySelector("et2-tree");
    // // Allow controlling icon size by CSS
    // widget.input.def_img_x = "";
    // widget.input.def_img_y = "";
    //
    // // to allow "," in value, eg. folder-names, IF value is specified as array
    // widget.input.dlmtr = ':}-*(';
    // @ts-ignore from static get properties
    if (this.autoLoading) {
      // @ts-ignore from static get properties
      var url = this.autoLoading;
      if (url.charAt(0) != '/' && url.substr(0, 4) != 'http') {
        url = '/json.php?menuaction=' + url;
      }
      this.autoloading_url = url;
    }
  }
  handleLazyLoading(_item) {
    var sendOptions = {
      num_rows: Et2Tree.RESULT_LIMIT
    };
    return egw$1().request(egw$1().link(egw$1().ajaxUrl(egw$1().decodePath(this.autoloading_url)), {
      id: _item.id
    }), [sendOptions]).then(results => {
      // If results have a total included, pull it out.
      // It will cause errors if left in the results
      // this._total_result_count = results.length;
      // if(typeof results.total !== "undefined")
      // {
      // 	this._total_result_count = results.total;
      // 	delete results.total;
      // }
      // let entries = cleanSelectOptions(results);
      // this.processRemoteResults(entries);
      // return entries;
      return results;
    });
  }

  //this.selectOptions = find_select_options(this)[1];
  _optionTemplate(selectOption) {
    // @ts-ignore

    //slot = expanded/collapsed instead of expand/collapse like it is in documentation
    //selectOption.child === 1
    return x$1(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n            <sl-tree-item\n                    .currentItem=", "\n                    ?lazy=", "\n                    @sl-lazy-load=", "\n            >\n                ", "\n                ", "\n            </sl-tree-item>"])), selectOption, this.needsLazyLoading, () => this.handleLazyLoading(selectOption), selectOption.text, c$2(selectOption.item, this._optionTemplate.bind(this)));
  }
  render() {
    return x$1(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n            <sl-tree\n\n            >\n                ", "\n            </sl-tree>\n\t\t"])), c$2(this.selectOptions, this._optionTemplate.bind(this)));
  }
  remoteQuery(search, options) {
    // Include a limit, even if options don't, to avoid massive lists breaking the UI
    var sendOptions = _objectSpread({
      num_rows: Et2Tree.RESULT_LIMIT
    }, options);
    return this.egw().request(this.egw().link(this.egw().ajaxUrl(this.egw().decodePath(this.searchUrl)), _objectSpread({
      query: search
    }, sendOptions)), [search, sendOptions]).then(results => {
      // If results have a total included, pull it out.
      // It will cause errors if left in the results
      this._total_result_count = results.length;
      if (typeof results.total !== "undefined") {
        this._total_result_count = results.total;
        delete results.total;
      }
      var entries = cleanSelectOptions(results);
      this.processRemoteResults(entries);
      return entries;
    });
  }
}
/**
 * Limit server searches to 100 results, matches Link::DEFAULT_NUM_ROWS
 * @type {number}
 */
_defineProperty$u(Et2Tree, "RESULT_LIMIT", 100);
customElements.define("et2-tree", Et2Tree);

function _defineProperty$t(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "template" XET-Tag. When the id parameter is set,
 * the template class checks whether another template with this id already
 * exists. If yes, this template is removed from the DOM tree, copied and
 * inserted in place of this template.
 */
class et2_template extends et2_DOMWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_template._attributes, _child || {}));

    // Set this early, so it's available for creating namespace
    _defineProperty$t(this, "content", void 0);
    _defineProperty$t(this, "div", void 0);
    _defineProperty$t(this, "loading", void 0);
    if (_attrs.content) {
      this.content = _attrs.content;
    }
    // constructor was called here before!

    this.div = document.createElement("div");

    // Deferred object so we can load via AJAX
    this.loading = new Promise((resolve, reject) => {
      // run transformAttributes now, to get server-side modifications (url!)
      if (_attrs.template) {
        this.id = _attrs.template;
        this.transformAttributes(_attrs);
        this.options = et2_cloneObject(_attrs);
        _attrs = {};
      }
      if ((this.id != "" || this.options.template) && !this.options.disabled) {
        var parts = (this.options.template || this.id).split('?');
        var cache_buster = parts.length > 1 ? parts.pop() : null;
        var template_name = parts.pop();

        // Check to see if XML is known
        var xml = null;
        var templates = etemplate2$1.templates; // use global eTemplate cache
        if (!(xml = templates[template_name])) {
          // Check to see if ID is short form --> prepend parent/top-level name
          if (template_name.indexOf('.') < 0) {
            var root = _parent ? _parent.getRoot() : null;
            var top_name = root && root._inst ? root._inst.name : null;
            if (top_name && template_name.indexOf('.') < 0) {
              template_name = top_name + '.' + template_name;
            }
          }
          xml = templates[template_name];
          if (!xml) {
            // Ask server
            var url = this.options.url;
            if (!this.options.url) {
              var splitted = template_name.split('.');
              var app = splitted.shift();
              url = egw$1.link('/' + app + "/templates/default/" + splitted.join('.') + ".xet", {
                download: cache_buster ? cache_buster : new Date().valueOf()
              });
            }
            // if server did not give a cache-buster, fall back to current time
            if (url.indexOf('?') == -1) url += '?download=' + new Date().valueOf();
            if (this.options.url || splitted.length) {
              var fetch_url_callback = function (_xmldoc) {
                // Scan for templates and store them
                for (var i = 0; i < _xmldoc.childNodes.length; i++) {
                  var template = _xmldoc.childNodes[i];
                  if (template.nodeName.toLowerCase() != "template") {
                    continue;
                  }
                  templates[template.getAttribute("id")] = template;
                }

                // Read the XML structure of the requested template
                if (typeof templates[template_name] != 'undefined') {
                  this.loadFromXML(templates[template_name]);
                }

                // Update flag
                resolve();
              }.bind(this);
              et2_loadXMLFromURL(url, fetch_url_callback, this, function (error) {
                url = egw$1.link('/' + app + "/templates/default/" + splitted.join('.') + ".xet", {
                  download: cache_buster ? cache_buster : new Date().valueOf()
                });
                et2_loadXMLFromURL(url, fetch_url_callback, this);
              });
            }
            return;
          }
        }
        if (xml !== null && typeof xml !== "undefined") {
          this.egw().debug("log", "Loading template from XML: ", template_name);
          this.loadFromXML(xml);
          // Don't call this here - done by caller, or on whole widget tree
          //this.loadingFinished();

          // But resolve the promise
          resolve();
        } else {
          this.egw().debug("warn", "Unable to find XML for ", template_name);
          reject("Unable to find XML for " + template_name);
        }
      } else {
        // No actual template - not an error, just nothing to do
        resolve();
      }
    });
  }

  /**
   * Override parent to support content attribute
   * Templates always have ID set, but seldom do we want them to
   * create a namespace based on their ID.
   */
  checkCreateNamespace(_attrs) {
    if (_attrs.content) {
      var old_id = _attrs.id;
      this.id = _attrs.content;
      super.checkCreateNamespace.apply(this, arguments);
      this.id = old_id;
    }
  }
  _createNamespace() {
    return true;
  }
  getDOMNode() {
    return this.div;
  }
  attachToDOM() {
    if (this.div) {
      jQuery(this.div).off('.et2_template').bind("load.et2_template", this, function (e) {
        e.data.load.call(e.data, this);
      });
    }
    return super.attachToDOM();
  }

  /**
   * Called after the template is fully loaded to handle any onload handlers
   */
  load() {
    if (typeof this.options.onload == 'function') {
      // Make sure function gets a reference to the widget
      var args = Array.prototype.slice.call(arguments);
      if (args.indexOf(this) == -1) args.push(this);
      return this.options.onload.apply(this, args);
    }
  }

  /**
   * Override to return the promise for deferred loading
   */
  doLoadingFinished() {
    // Apply parent now, which actually puts into the DOM
    super.doLoadingFinished();

    // Fire load event when done loading
    this.loading.then(function () {
      jQuery(this).trigger("load");
    }.bind(this.div));

    // Not done yet, but widget will let you know
    return this.loading;
  }
}
_defineProperty$t(et2_template, "_attributes", {
  "template": {
    "name": "Template",
    "type": "string",
    "description": "Name / ID of template with optional cache-buster ('?'+filemtime of template on server)",
    "default": et2_no_init
  },
  "group": {
    // TODO: Not implemented
    "name": "Group",
    "description": "Not implemented",
    //"default": 0
    "default": et2_no_init
  },
  "version": {
    "name": "Version",
    "type": "string",
    "description": "Version of the template"
  },
  "lang": {
    "name": "Language",
    "type": "string",
    "description": "Language the template is written in"
  },
  "content": {
    "name": "Content index",
    "default": et2_no_init,
    "description": "Used for passing in specific content to the template other than what it would get by ID."
  },
  url: {
    name: "URL of template",
    type: "string",
    description: "full URL to load template incl. cache-buster"
  },
  "onload": {
    "name": "onload",
    "type": "js",
    "default": et2_no_init,
    "description": "JS code which is executed after the template is loaded."
  }
});
et2_register_widget(et2_template, ["template"]);

function _defineProperty$s(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements box and vbox tag
 *
 * Auto-repeat: In order to get box auto repeat to work we need to have another
 * box as a wrapper with an id set.
 *
 * @augments et2_baseWidget
 */
class et2_box extends et2_baseWidget {
  /**
   * Constructor
   *
   * @memberOf et2_box
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, _child);
    _defineProperty$s(this, "div", void 0);
    this.div = jQuery(document.createElement("div")).addClass("et2_" + this.getType()).addClass("et2_box_widget");
    this.setDOMNode(this.div[0]);
  }
  _createNamespace() {
    return true;
  }

  /**
   * Overriden so we can check for autorepeating children.  We only check for
   * $ in the immediate children & grandchildren of this node.
   *
   * @param {object} _node
   */
  loadFromXML(_node) {
    if (this.getType() != "old-box") {
      return super.loadFromXML(_node);
    }
    // Load the child nodes.
    var childIndex = 0;
    var repeatNode = null;
    for (var i = 0; i < _node.childNodes.length; i++) {
      var node = _node.childNodes[i];
      var widgetType = node.nodeName.toLowerCase();
      if (widgetType == "#comment") {
        continue;
      }
      if (widgetType == "#text") {
        if (node.data.replace(/^\s+|\s+$/g, '')) {
          this.loadContent(node.data);
        }
        continue;
      }

      // Create the new element, if no expansion needed
      var id = et2_readAttrWithDefault(node, "id", "");
      if (id.indexOf('$') < 0 || ['box', 'grid', 'et2-box'].indexOf(widgetType) == -1 && typeof customElements.get(widgetType) == "undefined") {
        this.createElementFromNode(node);
        childIndex++;
      } else {
        repeatNode = node;
      }
    }

    // Only the last child repeats(?)
    if (repeatNode != null) {
      var currentPerspective = this.getArrayMgr("content").perspectiveData;
      // Extra content
      for (childIndex; typeof this.getArrayMgr("content").data[childIndex] != "undefined" && this.getArrayMgr("content").data[childIndex]; childIndex++) {
        // Adjust for the row
        var mgrs = this.getArrayMgrs();
        for (var name in mgrs) {
          if (this.getArrayMgr(name).getEntry(childIndex)) {
            this.getArrayMgr(name).setRow(childIndex);
          }
        }
        this.createElementFromNode(repeatNode);
      }

      // Reset
      for (var name in this.getArrayMgrs()) {
        this.getArrayMgr(name).setPerspectiveData(currentPerspective);
      }
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM
   * This doesn't need to be implemented.
   * Individual widgets are detected and handled by the grid, but the interface is needed for this to happen
   *
   * @param {array} _attrs array to add further attributes to
   */
  getDetachedAttributes(_attrs) {
    _attrs.push('data');
  }
  getDetachedNodes() {
    return [this.getDOMNode()];
  }
  setDetachedAttributes(_nodes, _values) {
    if (_values.data) {
      var pairs = _values.data.split(/,/g);
      for (var i = 0; i < pairs.length; ++i) {
        var name_value = pairs[i].split(':');
        jQuery(_nodes[0]).attr('data-' + name_value[0], name_value[1]);
      }
    }
  }
}
_defineProperty$s(et2_box, "_attributes", {
  // Not needed
  "rows": {
    "ignore": true
  },
  "cols": {
    "ignore": true
  }
});
et2_register_widget(et2_box, ["vbox", "box", "old-vbox", "old-box", "old-hbox"]);

/**
 * Details widget implementation
 * widget name is "details" and can be use as a wrapping container
 * in order to make its children collapsible.
 *
 * Note: details widget does not represent html5 "details" tag in DOM
 *
 * <details>
 *		<widgets>
 *		....
 * <details/>
 *
 */
class et2_details extends et2_box {
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, _child);
    _defineProperty$s(this, "title", void 0);
    _defineProperty$s(this, "span", void 0);
    _defineProperty$s(this, "wrapper", void 0);
    this.div = jQuery(document.createElement('div')).addClass('et2_details');
    this.title = jQuery(document.createElement('span')).addClass('et2_label et2_details_title').appendTo(this.div);
    this.span = jQuery(document.createElement('span')).addClass('et2_details_toggle').appendTo(this.div);
    this.wrapper = jQuery(document.createElement('div')).addClass('et2_details_wrapper').appendTo(this.div);
    this._createWidget();
  }

  /**
   * Function happens on toggle action
   */
  _toggle() {
    this.div.toggleClass('et2_details_expanded');
  }

  /**
   * Create widget, set contents, and binds handlers
   */
  _createWidget() {
    var self = this;
    this.span.on('click', function (e) {
      self._toggle();
    });

    //Set header title
    if (this.options.title) {
      this.title.click(function () {
        self._toggle();
      }).text(this.egw().lang(this.options.title));
    }

    // Align toggle button left/right
    if (this.options.toggle_align === "left") this.span.css({
      float: 'left'
    });
  }
  getDOMNode(_sender) {
    if (!_sender || _sender === this) {
      return this.div[0];
    } else {
      return this.wrapper[0];
    }
  }
}
_defineProperty$s(et2_details, "_attributes", {
  "toggle_align": {
    name: "Toggle button alignment",
    description: " Defines where to align the toggle button, default is right alignment",
    type: "string",
    default: "right"
  },
  title: {
    name: "title",
    description: "Set a header title for box and shows it next to toggle button, default is no title",
    type: "string",
    default: "",
    translate: true
  }
});
et2_register_widget(et2_details, ["details"]);

function _defineProperty$r(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements hbox tag
 *
 * @augments et2_baseWidget
 */
class et2_hbox extends et2_baseWidget {
  /**
   * Constructor
   *
   * @memberOf et2_hbox
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_hbox._attributes, _child || {}));
    _defineProperty$r(this, "alignData", {
      "hasAlign": false,
      "hasLeft": false,
      "hasCenter": false,
      "hasRight": false,
      "lastAlign": "left"
    });
    _defineProperty$r(this, "leftDiv", null);
    _defineProperty$r(this, "rightDiv", null);
    _defineProperty$r(this, "div", null);
    this.leftDiv = null;
    this.rightDiv = null;
    this.div = jQuery(document.createElement("div")).addClass("et2_" + super.getType()).addClass("et2_box_widget");
    super.setDOMNode(this.div[0]);
  }
  _createNamespace() {
    return true;
  }
  _buildAlignCells() {
    if (this.alignData.hasAlign) {
      // Check whether we have more than one type of align
      var mto = this.alignData.hasLeft && this.alignData.hasRight || this.alignData.hasLeft && this.alignData.hasCenter || this.alignData.hasCenter && this.alignData.hasRight;
      if (!mto) {
        // If there is only one type of align, we simply have to set
        // the align of the top container
        if (this.alignData.lastAlign != "left") {
          this.div.addClass("et2_hbox_al_" + this.alignData.lastAlign);
        }
      } else {
        // Create an additional container for elements with align type
        // "right"
        if (this.alignData.hasRight) {
          this.rightDiv = jQuery(document.createElement("div")).addClass("et2_hbox_right").appendTo(this.div);
        }

        // Create an additional container for elements with align type
        // left, as the top container is used for the centered elements
        if (this.alignData.hasCenter) {
          // Create the left div if an element is centered
          this.leftDiv = jQuery(document.createElement("div")).addClass("et2_hbox_left").appendTo(this.div);
          this.div.addClass("et2_hbox_al_center");
        }
      }
    }
  }

  /**
   * The overwritten loadFromXML function checks whether any child element has
   * a special align value.
   *
   * @param {object} _node
   */
  loadFromXML(_node) {
    // Check whether any child node has an alignment tag
    et2_filteredNodeIterator(_node, function (_node) {
      var align = _node.getAttribute("align");
      if (!align) {
        align = "left";
      }
      if (align != "left") {
        this.alignData.hasAlign = true;
      }
      this.alignData.lastAlign = align;
      switch (align) {
        case "left":
          this.alignData.hasLeft = true;
          break;
        case "right":
          this.alignData.hasRight = true;
          break;
        case "center":
          this.alignData.hasCenter = true;
          break;
      }
    }, this);

    // Build the align cells
    this._buildAlignCells();

    // Load the nodes as usual
    super.loadFromXML(_node);
  }
  assign(_obj) {
    // Copy the align data and the cells from the object which should be
    // assigned
    this.alignData = et2_cloneObject(_obj.alignData);
    this._buildAlignCells();

    // Call the inherited assign function
    super.assign(_obj);
  }
  getDOMNode(_sender) {
    // Return a special align container if this hbox needs it
    if (_sender != this && this.alignData.hasAlign) {
      // Check whether we've create a special container for the widget
      var align = _sender !== null && _sender !== void 0 && _sender.implements(et2_IAligned) ? _sender === null || _sender === void 0 ? void 0 : _sender.get_align() : "left";
      if (align == "left" && this.leftDiv != null) {
        return this.leftDiv[0];
      }
      if (align == "right" && this.rightDiv != null) {
        return this.rightDiv[0];
      }
    }

    // Normally simply return the hbox-div
    return super.getDOMNode(_sender);
  }

  /**
   * Tables added to the root node need to be inline instead of blocks
   *
   * @param {et2_widget} child child-widget to add
   */
  addChild(child) {
    super.addChild(child);
    if (child.instanceOf && child.instanceOf(et2_grid) && this.isAttached() || child._type == 'et2_grid' && this.isAttached()) {
      jQuery(child.getDOMNode(child)).css("display", "inline-table");
    }
  }
}
et2_register_widget(et2_hbox, ["hbox", "old-hbox"]);

function _defineProperty$q(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the groupbox tag
 *
 * @augments et2_baseWidget
 */
class et2_groupbox extends et2_baseWidget {
  /**
   * Constructor
   *
   * @memberOf et2_groupbox
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_groupbox._attributes, _child || {}));
    this.setDOMNode(document.createElement("fieldset"));
  }
}
et2_register_widget(et2_groupbox, ["groupbox"]);

/**
 * @augments et2_baseWidget
 */
class et2_groupbox_legend extends et2_baseWidget {
  /**
   * Constructor
   *
   * @memberOf et2_groupbox_legend
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_groupbox_legend._attributes, _child || {}));
    var legend = jQuery(document.createElement("legend")).text(this.options.label);
    this.setDOMNode(legend[0]);
  }
}
_defineProperty$q(et2_groupbox_legend, "_attributes", {
  "label": {
    "name": "Label",
    "type": "string",
    "default": "",
    "description": "Label for group box",
    "translate": true
  }
});
et2_register_widget(et2_groupbox_legend, ["caption"]);

function _defineProperty$p(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * A widget to display a value from an entry
 *
 * Since we have Etemplate\Widget\Transformer, this client side widget exists
 * mostly to resolve the problem where the ID for the entry widget is the same
 * as the widget where you actually set the value, which prevents transformer
 * from working.
 *
 * Server side will find the associated entry, and load it into ~<entry_id> to
 * avoid overwriting the widget with id="entry_id".  This widget will reverse
 * that, and the modifications from transformer will be applied.
 *
 * @augments et2_valueWidget
 */
class et2_entry extends et2_valueWidget {
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_entry._attributes, _child || {}));

    // Often the ID conflicts, so check prefix
    _defineProperty$p(this, "widget", null);
    if (_attrs.id && _attrs.id.indexOf(et2_entry.prefix) < 0) {
      this.id = _attrs.id = et2_entry.prefix + _attrs.id;
    }
    var value = _attrs.value;

    // Add all attributes hidden in the content arrays to the attributes
    // parameter
    this.transformAttributes(_attrs);

    // Create a local copy of the options object
    this.options = et2_cloneObject(_attrs);

    // Save value from parsing, but only if set
    if (value) {
      this.options.value = value;
    }
    this.widget = null;
    this.setDOMNode(document.createElement('span'));
  }
  loadFromXML(_node) {
    // Load the nodes as usual
    super.loadFromXML(_node);
    // Do the magic
    this.loadField();
  }

  /**
   * Initialize widget for entry field
   */
  loadField() {
    // Create widget of correct type
    var attrs = {
      id: this.id + (this.options.field ? '[' + this.options.field + ']' : ''),
      type: 'label',
      readonly: this.options.readonly
    };
    var modifications = this.getArrayMgr("modifications");
    if (modifications && this.options.field) {
      jQuery.extend(attrs, modifications.getEntry(attrs.id));
    }

    // Supress labels on templates
    if (attrs.type == 'template' && this.options.label) {
      this.egw().debug('log', "Surpressed label on <" + this.getType() + ' label="' + this.options.label + '" id="' + this.id + '"...>');
      this.options.label = '';
    }
    var widget = et2_createWidget(attrs.type, attrs, this);

    // If value is not set, etemplate takes care of everything
    // If value was set, find the record explicitly.
    if (typeof this.options.value == 'string') {
      widget.value = this.getArrayMgr('content').getEntry(this.id + '[' + this.options.field + ']') || this.getRoot().getArrayMgr('content').getEntry(et2_entry.prefix + this.options.value + '[' + this.options.field + ']');
    } else if (this.options.field && this.options.value && this.options.value[this.options.field]) {
      widget.value = this.options.value[this.options.field];
    }
    if (this.options.compare) {
      widget.value = widget.options.value == this.options.compare ? 'X' : '';
    }
    if (this.options.alternate_fields) {
      var sum = 0;
      var fields = this.options.alternate_fields.split(':');
      for (var i = 0; i < fields.length; i++) {
        var negate = fields[i][0] == "-";
        var value = this.getArrayMgr('content').getEntry(fields[i].replace('-', ''));
        sum += typeof value === 'undefined' ? 0 : parseFloat(value) * (negate ? -1 : 1);
        if (value && this.options.field !== 'sum') {
          widget.value = value;
          break;
        }
      }
      if (this.options.field == 'sum') {
        if (this.options.precision && !isNaN(sum)) {
          sum = parseFloat(sum).toFixed(this.options.precision);
        }
        // use decimal separator from user prefs
        var format = this.egw().preference('number_format');
        var sep = format ? format[0] : '.';
        if (typeof sum === 'string' && format && sep && sep !== '.') {
          sum = sum.replace('.', sep);
        }
        widget.value = sum;
      }
    }
  }
}
_defineProperty$p(et2_entry, "_attributes", {
  field: {
    'name': 'Fields',
    'description': 'Which entry field to display, or "sum" to add up the alternate_fields',
    'type': 'string'
  },
  compare: {
    name: 'Compare',
    description: 'if given, the selected field is compared with its value and an X is printed on equality, nothing otherwise',
    default: et2_no_init,
    type: 'string'
  },
  alternate_fields: {
    name: 'Alternate fields',
    description: 'colon (:) separated list of alternative fields.  The first non-empty one is used if the selected field is empty, (-) used for subtraction',
    type: 'string',
    default: et2_no_init
  },
  precision: {
    name: 'Decimals to be shown',
    description: 'Specifies the number of decimals for sum of alternates, the default is 2',
    type: 'string',
    default: '2'
  },
  regex: {
    name: 'Regular expression pattern',
    description: 'Only used server-side in a preg_replace with regex_replace to modify the value',
    default: et2_no_init,
    type: 'string'
  },
  regex_replace: {
    name: 'Regular expression replacement pattern',
    description: 'Only used server-side in a preg_replace with regex to modify the value',
    default: et2_no_init,
    type: 'string'
  },
  value: {
    type: 'any'
  },
  readonly: {
    default: true
  }
});
_defineProperty$p(et2_entry, "legacyOptions", ["field", "compare", "alternate_fields"]);
_defineProperty$p(et2_entry, "prefix", '~');
et2_register_widget(et2_entry, ["entry", 'contact-value', 'contact-account', 'contact-template', 'infolog-value', 'tracker-value', 'records-value']);

function _defineProperty$o(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "int" and textbox type=float XET-Tags
 *
 * @augments et2_textbox
 */
class et2_number extends et2_textbox {
  /**
   * Constructor
   *
   * @memberOf et2_number
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_number._attributes, _child || {}));
    _defineProperty$o(this, "min", null);
    _defineProperty$o(this, "max", null);
    _defineProperty$o(this, "step", null);
  }
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
    if (typeof _attrs.validator == 'undefined') {
      _attrs.validator = _attrs.type == 'float' ? '/^-?[0-9]*[,.]?[0-9]*$/' : '/^-?[0-9]*$/';
    }
  }

  /**
   * Clientside validation using regular expression in "validator" attribute
   *
   * @param {array} _messages
   */
  isValid(_messages) {
    var ok = true;
    // if we have a html5 validation error, show it, as this.input.val() will be empty!
    if (this.input && this.input[0] && this.input[0].validationMessage && !this.input[0].validity.stepMismatch) {
      _messages.push(this.input[0].validationMessage);
      ok = false;
    }
    return super.isValid(_messages) && ok;
  }
  createInputWidget() {
    this.input = jQuery(document.createElement("input"));
    this.input.attr("type", "number");
    this.input.addClass("et2_textbox");
    // bind invalid event to change, to trigger our validation
    this.input.on('invalid', jQuery.proxy(this.change, this));
    if (this.options.onkeypress && typeof this.options.onkeypress == 'function') {
      var self = this;
      this.input.keypress(function (_ev) {
        return self.options.onkeypress.call(this, _ev, self);
      });
    }
    this.setDOMNode(this.input[0]);
  }

  /**
   * Set input widget size
   *
   * Overwritten from et2_textbox as input type=number seems to ignore size,
   * therefore we set width in em instead, if not et2_fullWidth given.
   *
   * @param _size Rather arbitrary size units, approximately characters
   */
  set_size(_size) {
    if (typeof _size != 'undefined' && _size != this.input.attr("size")) {
      this.size = _size;
      this.input.attr("size", this.size);
      if (typeof this.options.class == 'undefined' || this.options.class.search('et2_fullWidth') == -1) {
        this.input.css('width', _size + 'em');
      }
    }
  }
  set_min(_value) {
    this.min = _value;
    if (this.min == null) {
      this.input.removeAttr("min");
    } else {
      this.input.attr("min", this.min);
    }
  }
  set_max(_value) {
    this.max = _value;
    if (this.max == null) {
      this.input.removeAttr("max");
    } else {
      this.input.attr("max", this.max);
    }
  }
  set_step(_value) {
    this.step = _value;
    if (this.step == null) {
      this.input.removeAttr("step");
    } else {
      this.input.attr("step", this.step);
    }
  }
}
_defineProperty$o(et2_number, "_attributes", {
  "value": {
    "type": "float"
  },
  // Override default width, numbers are usually shorter
  "size": {
    "default": 5
  },
  "min": {
    "name": "Minimum",
    "type": "any",
    "default": et2_no_init,
    "description": "Minimum allowed value"
  },
  "max": {
    "name": "Maximum",
    "type": "any",
    "default": et2_no_init,
    "description": "Maximum allowed value"
  },
  "step": {
    "name": "step value",
    "type": "integer",
    "default": et2_no_init,
    "description": "Step attribute specifies the interval between legal numbers"
  },
  "precision": {
    // TODO: Implement this in some nice way other than HTML5's step attribute
    "name": "Precision",
    "type": "integer",
    "default": et2_no_init,
    "description": "Allowed precision - # of decimal places",
    "ignore": true
  }
});
et2_register_widget(et2_number, ["int", "integer", "float", "old-int"]);

/**
 * Extend read-only to tell it to ignore special attributes, which
 * would cause warnings otherwise
 * @augments et2_textbox_ro
 * @class
 */
class et2_number_ro extends et2_textbox_ro {
  set_value(_value) {
    if (typeof this.options.precision != 'undefined' && "" + _value != "") {
      _value = parseFloat(_value).toFixed(this.options.precision);
    }
    super.set_value(_value);
  }
}
_defineProperty$o(et2_number_ro, "_attributes", {
  min: {
    ignore: true
  },
  max: {
    ignore: true
  },
  precision: {
    name: "Precision",
    type: "integer",
    default: et2_no_init,
    description: "Allowed precision - # of decimal places",
    ignore: true
  },
  value: {
    type: "float"
  }
});
et2_register_widget(et2_number_ro, ["int_ro", "integer_ro", "float_ro"]);

function _defineProperty$n(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Class which implements the "radiobox" XET-Tag
 *
 * A radio button belongs to same group by giving all buttons of a group same id!
 *
 * set_value iterates over all of them and (un)checks them depending on given value.
 *
 * @augments et2_inputWidget
 */
class et2_radiobox extends et2_inputWidget {
  /**
   * Constructor
   *
   * @memberOf et2_radiobox
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_radiobox._attributes, _child || {}));
    _defineProperty$n(this, "input", null);
    _defineProperty$n(this, "id", "");
    this.createInputWidget();
  }
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
    var readonly = this.getArrayMgr('readonlys').getEntry(this.id);
    if (readonly && readonly.hasOwnProperty(_attrs.set_value)) {
      _attrs.readonly = readonly[_attrs.set_value];
    }
  }
  createInputWidget() {
    this.input = jQuery(document.createElement("input")).val(this.options.set_value).attr("type", "radio").attr("disabled", this.options.readonly);
    this.input.addClass("et2_radiobox");
    this.setDOMNode(this.input[0]);
  }

  /**
   * Overwritten to set different DOM level ids by appending set_value
   *
   * @param _id
   */
  set_id(_id) {
    super.set_id(_id);
    this.dom_id = this.dom_id.replace('[]', '') + '-' + this.options.set_value;
    if (this.input) this.input.attr('id', this.dom_id);
  }

  /**
   * Default for radio buttons is label after button
   *
   * @param _label String New label for radio button.  Use %s to locate the radio button somewhere else in the label
   */
  set_label(_label) {
    if (_label.length > 0 && _label.indexOf('%s') == -1) {
      _label = '%s' + _label;
    }
    super.set_label(_label);
  }

  /**
   * Override default to match against set/unset value AND iterate over all siblings with same id
   *
   * @param {string} _value
   */
  set_value(_value) {
    this.getRoot().iterateOver(function (radio) {
      if (radio.id == this.id) {
        radio.input.prop('checked', _value == radio.options.set_value);
      }
    }, this, et2_radiobox);
  }

  /**
   * Override default to iterate over all siblings with same id
   *
   * @return {string}
   */
  getValue() {
    var val = this.options.value; // initial value, when form is loaded
    var values = [];
    this.getRoot().iterateOver(function (radio) {
      values.push(radio.options.set_value);
      if (radio.id == this.id && radio.input && radio.input.prop('checked')) {
        val = radio.options.set_value;
      }
    }, this, et2_radiobox);
    return val && val.indexOf(values) ? val : null;
  }

  /**
   * Overridden from parent so if it's required, only 1 in a group needs a value
   *
   * @param {array} messages
   * @returns {Boolean}
   */
  isValid(messages) {
    var ok = true;

    // Check for required
    if (this.options && this.options.needed && !this.options.readonly && !this.disabled && (this.getValue() == null || this.getValue().valueOf() == '')) {
      if (jQuery.isEmptyObject(this.getInstanceManager().getValues(this.getInstanceManager().widgetContainer)[this.id.replace('[]', '')])) {
        messages.push(this.egw().lang('Field must not be empty !!!'));
        ok = false;
      }
    }
    return ok;
  }

  /**
   * Set radio readonly attribute.
   *
   * @param _readonly Boolean
   */
  set_readonly(_readonly) {
    this.options.readonly = _readonly;
    this.getRoot().iterateOver(function (radio) {
      if (radio.id == this.id) {
        radio.input.prop('disabled', _readonly);
      }
    }, this, et2_radiobox);
  }
}
_defineProperty$n(et2_radiobox, "_attributes", {
  "set_value": {
    "name": "Set value",
    "type": "string",
    "default": "true",
    "description": "Value when selected"
  },
  "ro_true": {
    "name": "Read only selected",
    "type": "string",
    "default": "x",
    "description": "What should be displayed when readonly and selected"
  },
  "ro_false": {
    "name": "Read only unselected",
    "type": "string",
    "default": "",
    "description": "What should be displayed when readonly and not selected"
  }
});
_defineProperty$n(et2_radiobox, "legacyOptions", ["set_value", "ro_true", "ro_false"]);
et2_register_widget(et2_radiobox, ["radio"]);

/**
 * @augments et2_valueWidget
 */
class et2_radiobox_ro extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_radiobox_ro
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_radiobox_ro._attributes, _child || {}));
    _defineProperty$n(this, "value", "");
    _defineProperty$n(this, "span", null);
    this.span = jQuery(document.createElement("span")).addClass("et2_radiobox");
    this.setDOMNode(this.span[0]);
  }

  /**
   * Override default to match against set/unset value
   *
   * @param {string} _value
   */
  set_value(_value) {
    this.value = _value;
    if (_value == this.options.set_value) {
      this.span.text(this.options.ro_true);
    } else {
      this.span.text(this.options.ro_false);
    }
  }
  set_label(_label) {
    // no label for ro radio, we show label of checked option as content, unless it's x
    // then we need the label for things to make sense
    if (this.options.ro_true == "x") {
      return super.set_label(_label);
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM
   *
   * @param {array} _attrs
   */
  getDetachedAttributes(_attrs) {
    // Show label in nextmatch instead of just x
    this.options.ro_true = this.options.label;
    _attrs.push("value");
  }
  getDetachedNodes() {
    return [this.span[0]];
  }
  setDetachedAttributes(_nodes, _values) {
    this.span = jQuery(_nodes[0]);
    this.set_value(_values["value"]);
  }
}
_defineProperty$n(et2_radiobox_ro, "_attributes", {
  "set_value": {
    "name": "Set value",
    "type": "string",
    "default": "true",
    "description": "Value when selected"
  },
  "ro_true": {
    "name": "Read only selected",
    "type": "string",
    "default": "x",
    "description": "What should be displayed when readonly and selected"
  },
  "ro_false": {
    "name": "Read only unselected",
    "type": "string",
    "default": "",
    "description": "What should be displayed when readonly and not selected"
  },
  "label": {
    "name": "Label",
    "default": "",
    "type": "string"
  }
});
_defineProperty$n(et2_radiobox_ro, "legacyOptions", ["set_value", "ro_true", "ro_false"]);
et2_register_widget(et2_radiobox_ro, ["radio_ro"]);

/**
 * A group of radio buttons
 *
 * @augments et2_valueWidget
 */
class et2_radioGroup extends et2_valueWidget {
  /**
   * Constructor
   *
   * @param parent
   * @param attrs
   * @memberOf et2_radioGroup
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_radioGroup._attributes, _child || {}));
    _defineProperty$n(this, "node", null);
    _defineProperty$n(this, "value", null);
    this.node = jQuery(document.createElement("div")).addClass("et2_vbox").addClass("et2_box_widget");
    if (this.options.needed) {
      // This isn't strictly allowed, but it works
      this.node.attr("required", "required");
    }
    this.setDOMNode(this.node[0]);

    // The supported widget classes array defines a whitelist for all widget
    // classes or interfaces child widgets have to support.
    this.supportedWidgetClasses = [et2_radiobox, et2_radiobox_ro];
  }
  set_value(_value) {
    this.value = _value;
    for (var i = 0; i < this._children.length; i++) {
      var radio = this._children[i];
      radio.set_value(_value);
    }
  }
  getValue() {
    return jQuery("input:checked", this.getDOMNode()).val();
  }

  /**
   * Set a bunch of radio buttons
   *
   * @param {object} _options object with value: label pairs
   */
  set_options(_options) {
    // Call the destructor of all children
    for (var i = this._children.length - 1; i >= 0; i--) {
      this._children[i].destroy();
    }
    this._children = [];
    // create radio buttons for each option
    for (var key in _options) {
      var attrs = {
        // Add index so radios work properly
        "id": this.options.readonly ? this.id : this.id + "[" + "]",
        set_value: key,
        label: _options[key],
        ro_true: this.options.ro_true,
        ro_false: this.options.ro_false,
        readonly: this.options.readonly
      };
      if (typeof _options[key] === 'object' && _options[key].label) {
        attrs.set_value = _options[key].value;
        attrs.label = _options[key].label;
      }
      // Can't have a required readonly, it will warn & be removed later, so avoid the warning
      if (attrs.readonly === false) {
        attrs['needed'] = this.options.needed;
      }
      et2_createWidget("radio", attrs, this);
    }
    this.set_value(this.value);
  }

  /**
   * Set a label on the group of radio buttons
   *
   * @param {string} _value
   */
  set_label(_value) {
    // Abort if ther was no change in the label
    if (_value == this.label) {
      return;
    }
    if (_value) {
      // Create the label container if it didn't exist yet
      if (this._labelContainer == null) {
        this._labelContainer = jQuery(document.createElement("label"));
        this.getSurroundings().insertDOMNode(this._labelContainer[0]);
      }

      // Clear the label container.
      this._labelContainer.empty();

      // Create the placeholder element and set it
      var ph = document.createElement("span");
      this.getSurroundings().setWidgetPlaceholder(ph);
      this._labelContainer.append(document.createTextNode(_value)).append(ph);
    } else {
      // Delete the labelContainer from the surroundings object
      if (this._labelContainer) {
        this.getSurroundings().removeDOMNode(this._labelContainer[0]);
      }
      this._labelContainer = null;
    }
  }

  /**
   * Code for implementing et2_IDetachedDOM
   * This doesn't need to be implemented.
   * Individual widgets are detected and handled by the grid, but the interface is needed for this to happen
   *
   * @param {object} _attrs
   */
  getDetachedAttributes(_attrs) {}
  getDetachedNodes() {
    return [this.getDOMNode()];
  }
  setDetachedAttributes(_nodes, _values) {}
}
// No such tag as 'radiogroup', but it needs something
_defineProperty$n(et2_radioGroup, "_attributes", {
  "label": {
    "name": "Label",
    "default": "",
    "type": "string",
    "description": "The label is displayed above the list of radio buttons. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",
    "translate": true
  },
  "value": {
    "name": "Value",
    "type": "string",
    "default": "true",
    "description": "Value for each radio button"
  },
  "ro_true": {
    "name": "Read only selected",
    "type": "string",
    "default": "x",
    "description": "What should be displayed when readonly and selected"
  },
  "ro_false": {
    "name": "Read only unselected",
    "type": "string",
    "default": "",
    "description": "What should be displayed when readonly and not selected"
  },
  "options": {
    "name": "Radio options",
    "type": "any",
    "default": {},
    "description": "Options for radio buttons.  Should be {value: label, ...}"
  },
  "needed": {
    "name": "Required",
    "default": false,
    "type": "boolean",
    "description": "If required, the user must select one of the options before the form can be submitted"
  }
});
et2_register_widget(et2_radioGroup, ["radiogroup"]);

function _defineProperty$m(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * @deprecated use Et2Date
 */
class et2_date extends Et2Date {}

/**
 * @deprecated use Et2Date
 */
class et2_date_duration extends Et2DateDuration {}

/**
 * @deprecated use Et2Date
 */
class et2_date_duration_ro extends Et2DateDurationReadonly {}

/**
 * @deprecated use Et2Date
 */
class et2_date_ro extends Et2DateReadonly {}

/**
 * Widget for selecting a date range
 *
 * @todo port to web-component
 */
class et2_date_range extends et2_inputWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_date_range._attributes, _child || {}));
    _defineProperty$m(this, "div", void 0);
    _defineProperty$m(this, "from", void 0);
    _defineProperty$m(this, "to", void 0);
    _defineProperty$m(this, "select", void 0);
    this.div = jQuery(document.createElement('div')).attr({
      class: 'et2_date_range'
    });
    this.from = null;
    this.to = null;
    this.select = null;

    // Set domid
    this.set_id(this.id);
    this.setDOMNode(this.div[0]);
    this._createWidget();
    this.set_relative(this.options.relative || false);
  }
  _createWidget() {
    var widget = this;
    this.from = loadWebComponent('et2-date', {
      id: this.id + '[from]',
      blur: egw.lang('From'),
      onchange(_node, _widget) {
        widget.to.set_min(widget.from.getValue());
        if (_node instanceof Event) widget.onchange.call(widget, _widget, widget);
      }
    }, this);
    this.to = loadWebComponent('et2-date', {
      id: this.id + '[to]',
      blur: egw.lang('To'),
      onchange(_node, _widget) {
        widget.from.set_max(widget.to.getValue());
        if (_node instanceof Event) widget.onchange.call(widget, _widget, widget);
      }
    }, this);
    this.select = loadWebComponent('et2-select', {
      id: this.id + '[relative]',
      select_options: et2_date_range.relative_dates,
      empty_label: this.options.blur || 'All'
    }, this);
    //this.select.loadingFinished();
  }

  /**
   * Function which allows iterating over the complete widget tree.
   * Overridden here to avoid problems with children when getting value
   *
   * @param _callback is the function which should be called for each widget
   * @param _context is the context in which the function should be executed
   * @param _type is an optional parameter which specifies a class/interface
   * 	the elements have to be instanceOf.
   */
  iterateOver(_callback, _context, _type) {
    if (typeof _type == "undefined") {
      _type = et2_widget;
    }
    if (this.isInTree() && this.instanceOf(_type)) {
      _callback.call(_context, this);
    }
  }

  /**
   * Toggles relative or absolute dates
   *
   * @param {boolean} _value
   */
  set_relative(_value) {
    this.options.relative = _value;
    if (this.options.relative) {
      jQuery(this.from.getDOMNode()).hide();
      jQuery(this.to.getDOMNode()).hide();
    } else {
      jQuery(this.select.getDOMNode()).hide();
    }
  }
  set_value(value) {
    // @ts-ignore
    if (!value || typeof value == 'null') {
      this.select.set_value('');
      this.from.set_value(null);
      this.to.set_value(null);
    }

    // Relative
    if (value && typeof value === 'string') {
      this._set_relative_value(value);
    } else if (value && typeof value.from === 'undefined' && value[0]) {
      value = {
        from: value[0],
        to: value[1] || new Date().valueOf() / 1000
      };
    } else if (value && value.from && value.to) {
      this.from.set_value(value.from);
      this.to.set_value(value.to);
    }
  }
  getValue() {
    return this.options.relative ? this.select.getValue() : {
      from: this.from.getValue(),
      to: this.to.getValue()
    };
  }
  _set_relative_value(_value) {
    if (this.options.relative) {
      jQuery(this.select.getDOMNode()).show();
    }
    // Show description
    this.select.set_value(_value);
    var tempDate = new Date();
    var today = new Date(tempDate.getFullYear(), tempDate.getMonth(), tempDate.getDate(), 0, -tempDate.getTimezoneOffset(), 0);

    // Use strings to avoid references
    this.from.set_value(today.toJSON());
    this.to.set_value(today.toJSON());
    var relative = null;
    for (var index in et2_date_range.relative_dates) {
      if (et2_date_range.relative_dates[index].value === _value) {
        relative = et2_date_range.relative_dates[index];
        break;
      }
    }
    if (relative) {
      var dates = ["from", "to"];
      var value = today.toJSON();
      for (var i = 0; i < dates.length; i++) {
        var date = dates[i];
        if (typeof relative[date] == "function") {
          value = relative[date](new Date(value));
        } else {
          value = this[date]._relativeDate(relative[date]);
        }
        this[date].set_value(value);
      }
    }
  }

  // Class Constants
}
_defineProperty$m(et2_date_range, "_attributes", {
  value: {
    "type": "any",
    "description": "An object with keys 'from' and 'to' for absolute ranges, or a relative range string"
  },
  relative: {
    name: 'Relative',
    type: 'boolean',
    description: 'Is the date range relative (this week) or absolute (2016-02-15 - 2016-02-21).  This will affect the value returned.'
  }
});
_defineProperty$m(et2_date_range, "relative_dates", [
// Start and end are relative offsets, see et2_date.set_min()
// or Date objects
{
  value: 'Today',
  label: egw.lang('Today'),
  from(date) {
    return date;
  },
  to(date) {
    return date;
  }
}, {
  label: egw.lang('Yesterday'),
  value: 'Yesterday',
  from(date) {
    date.setUTCDate(date.getUTCDate() - 1);
    return date;
  },
  to: ''
}, {
  label: egw.lang('This week'),
  value: 'This week',
  from(date) {
    return egw.week_start(date);
  },
  to(date) {
    date.setUTCDate(date.getUTCDate() + 6);
    return date;
  }
}, {
  label: egw.lang('Last week'),
  value: 'Last week',
  from(date) {
    var d = egw.week_start(date);
    d.setUTCDate(d.getUTCDate() - 7);
    return d;
  },
  to(date) {
    date.setUTCDate(date.getUTCDate() + 6);
    return date;
  }
}, {
  label: egw.lang('This month'),
  value: 'This month',
  from(date) {
    date.setUTCDate(1);
    return date;
  },
  to(date) {
    date.setUTCMonth(date.getUTCMonth() + 1);
    date.setUTCDate(0);
    return date;
  }
}, {
  label: egw.lang('Last month'),
  value: 'Last month',
  from(date) {
    date.setUTCMonth(date.getUTCMonth() - 1);
    date.setUTCDate(1);
    return date;
  },
  to(date) {
    date.setUTCMonth(date.getUTCMonth() + 1);
    date.setUTCDate(0);
    return date;
  }
}, {
  label: egw.lang('Last 3 months'),
  value: 'Last 3 months',
  from(date) {
    date.setUTCMonth(date.getUTCMonth() - 2);
    date.setUTCDate(1);
    return date;
  },
  to(date) {
    date.setUTCMonth(date.getUTCMonth() + 3);
    date.setUTCDate(0);
    return date;
  }
},
/*
'This quarter'=> array(0,0,0,0,  0,0,0,0),      // Just a marker, needs special handling
'Last quarter'=> array(0,-4,0,0, 0,-4,0,0),     // Just a marker
*/
{
  label: egw.lang('This year'),
  value: 'This year',
  from(d) {
    d.setUTCMonth(0);
    d.setUTCDate(1);
    return d;
  },
  to(d) {
    d.setUTCMonth(11);
    d.setUTCDate(31);
    return d;
  }
}, {
  label: egw.lang('Last year'),
  value: 'Last year',
  from(d) {
    d.setUTCMonth(0);
    d.setUTCDate(1);
    d.setUTCYear(d.getUTCYear() - 1);
    return d;
  },
  to(d) {
    d.setUTCMonth(11);
    d.setUTCDate(31);
    d.setUTCYear(d.getUTCYear() - 1);
    return d;
  }
}
/* Still needed?
'2 years ago' => array(-2,0,0,0, -1,0,0,0),
'3 years ago' => array(-3,0,0,0, -2,0,0,0),
*/]);

et2_register_widget(et2_date_range, ["date-range"]);

/**
 * Just a stub that wraps Et2Dialog
 *
 * Replace calls like:
 * ```ts
 * this.dialog = <et2_dialog>et2_createWidget("dialog",
	{
		callback: this.submit_callback,
		title: this.egw().lang(this.dialog_title),
		buttons: buttons,
		minWidth: 500,
		minHeight: 400,
		width: 400,
		value: data,
		template: this.egw().webserverUrl + this.TEMPLATE,
		resizable: true
	}, et2_dialog._create_parent('api'));
 * ```
 *
 * with this:
 * ```ts
 * this.dialog = new Et2Dialog(this.egw());
 * this.dialog.transformAttributes({
		callback: this.submit_callback,
		title: this.dialog_title,
		buttons: buttons,
		width: 400,
		value: data,
		template: this.egw().webserverUrl + this.TEMPLATE
	});
 document.body.appendChild(this.dialog);
 * ```
 * Dialog size now comes from contents, so it's better to leave width & height unset.
 * Set minimum dimensions in CSS.
 * Title & message are translated by Et2Dialog
 * @deprecated
 */
class et2_dialog$1 extends Et2Dialog$1 {
  constructor(parent, attrs) {
    super((parent === null || parent === void 0 ? void 0 : parent.egw()) || egw);
    if (attrs.hasOwnProperty("modal")) {
      // modal is an internal property of SlDialog
      console.warn("modal is an internal property, use isModal instead");
      attrs.isModal = attrs.modal;
      delete attrs.modal;
    }
    if (attrs) {
      this.transformAttributes(attrs);
    }
    document.body.appendChild(this);
  }
  get template() {
    return super.template || {};
  }
  set template(value) {
    super.template = value;
  }
  _getButtons() {
    if (Array.isArray(this.buttons) && this.buttons[0].text) {
      console.warn("Button definitions should follow DialogButton interface", this, this.buttons);
      return this.buttons.map(button => {
        if (button.text) {
          button.label = button.text;
        }
        return button;
      });
    }
    return super._getButtons();
  }
  handleOpen(event) {
    super.handleOpen(event);

    // move the overlay dialog into appendTo dom since we want it to be shown in that container
    if (this.appendTo) {
      document.getElementsByClassName(this.appendTo.replace('.', ''))[0].appendChild(this);
    }
  }

  /**
   * @deprecated
   * @returns {any}
   */
  get div() {
    return this;
  }

  /**
   * Create a parent to inject application specific egw object with loaded translations into et2_dialog
   *
   * @param {string|egw} _egw_or_appname egw object with already loaded translations or application name to load translations for
   */
  static _create_parent(_egw_or_appname) {
    if (typeof _egw_or_appname == 'undefined') {
      // @ts-ignore
      _egw_or_appname = egw_appName;
    }
    // create a dummy parent with a correct reference to an application specific egw object
    var parent = new et2_widget();
    // if egw object is passed in because called from et2, just use it
    if (typeof _egw_or_appname != 'string') {
      parent.setApiInstance(_egw_or_appname);
    }
    // otherwise use given appname to create app-specific egw instance and load default translations
    else {
      parent.setApiInstance(egw(_egw_or_appname));
      parent.egw().langRequireApp(parent.egw().window, _egw_or_appname);
    }
    return parent;
  }
}

// Get it working transparently as a legacy dialog
et2_register_widget(et2_dialog$1, ["dialog", "legacy_dialog"]);
var type_map = {
  String: "string",
  Function: "js"
};
var attrs = {};
for (var [key, value] of Object.entries(et2_dialog$1.properties)) {
  var _attr$type;
  var attr = et2_dialog$1.properties[key];
  attrs[key] = {
    type: type_map[((_attr$type = attr.type) === null || _attr$type === void 0 ? void 0 : _attr$type.name) || attr.name] || "any"
  };
}
attrs["value"] = {
  type: "any"
};
et2_attribute_registry[et2_dialog$1.name] = attrs;
customElements.define("legacy-dialog", et2_dialog$1);

function _defineProperty$l(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class that displays the diff between two [text] values
 *
 * @augments et2_valueWidget
 */
class et2_diff extends et2_valueWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_diff._attributes, _child || {}));

    // included via etemplate2.css
    //this.egw().includeCSS('../../../vendor/bower-asset/dist/dist2html.css');
    _defineProperty$l(this, "diff_options", void 0);
    _defineProperty$l(this, "div", void 0);
    _defineProperty$l(this, "mini", true);
    this.div = document.createElement("div");
    jQuery(this.div).addClass('et2_diff');
  }
  set_value(value) {
    jQuery(this.div).empty();
    if (typeof value == 'string') {
      // Diff2Html likes to have files, we don't have them
      if (value.indexOf('---') !== 0) {
        value = "--- diff\n+++ diff\n" + value;
      }
      // @ts-ignore
      var diff = Diff2Html.getPrettyHtml(value, this.diff_options);
      //	var ui = new Diff2HtmlUI({diff: diff});
      //	ui.draw(jQuery(this.div), this.diff_options);
      jQuery(this.div).append(diff);
    } else if (typeof value != 'object') {
      jQuery(this.div).append(value);
    }
    this.check_mini();
  }
  check_mini() {
    if (!this.mini) {
      return false;
    }
    var view = jQuery(this.div).children();
    this.minify(view);
    var self = this;
    jQuery('<span class="ui-icon ui-icon-circle-plus">&nbsp;</span>').appendTo(self.div).css("cursor", "pointer").click({
      diff: view,
      div: self.div,
      label: self.options.label
    }, function (e) {
      var diff = e.data.diff;
      var div = e.data.div;
      self.un_minify(diff);
      var dialog = new Et2Dialog$1(self.egw());
      dialog.transformAttributes({
        title: e.data.label,
        //modal: true,
        buttons: [{
          label: 'ok'
        }],
        class: "et2_diff"
      });
      diff.attr("slot", "content");
      dialog.addEventListener("open", () => {
        diff.appendTo(dialog);
        if (jQuery(this).parent().height() > jQuery(window).height()) {
          jQuery(this).height(jQuery(window).height() * 0.7);
        }
      });
      dialog.addEventListener("close", () => {
        // Need to destroy the dialog, etemplate widget needs divs back where they were
        self.minify(this);

        // Put it back where it came from, or et2 will error when clear() is called
        diff.prependTo(div);
      });
      document.body.appendChild(dialog);
    });
  }
  set_label(_label) {
    this.options.label = _label;
  }

  /**
   * Make the diff into a mini-diff
   *
   * @param {DOMNode|String} view
   */
  minify(view) {
    view = jQuery(view).addClass('mini')
    // Dialog changes these, if resized
    .css('height', 'inherit').show();
    jQuery('th', view).hide();
    jQuery('td.equal', view).hide().prevAll().hide();
  }

  /**
   * Expand mini-diff
   *
   * @param {DOMNode|String} view
   */
  un_minify(view) {
    jQuery(view).removeClass('mini').show();
    jQuery('th', view).show();
    jQuery('td.equal', view).show();
  }

  /**
   * Code for implementing et2_IDetachedDOM
   * Fast-clonable read-only widget that only deals with DOM nodes, not the widget tree
   */

  /**
   * Build a list of attributes which can be set when working in the
   * "detached" mode in the _attrs array which is provided
   * by the calling code.
   *
   * @param {object} _attrs
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "label");
  }

  /**
   * Returns an array of DOM nodes. The (relativly) same DOM-Nodes have to be
   * passed to the "setDetachedAttributes" function in the same order.
   */
  getDetachedNodes() {
    return [this.div];
  }

  /**
   * Sets the given associative attribute->value array and applies the
   * attributes to the given DOM-Node.
   *
   * @param _nodes is an array of nodes which has to be in the same order as
   *      the nodes returned by "getDetachedNodes"
   * @param _values is an associative array which contains a subset of attributes
   *      returned by the "getDetachedAttributes" function and sets them to the
   *      given values.
   */
  setDetachedAttributes(_nodes, _values) {
    this.div = _nodes[0];
    if (typeof _values['label'] != 'undefined') {
      this.set_label(_values['label']);
    }
    if (typeof _values['value'] != 'undefined') {
      this.set_value(_values['value']);
    }
  }
}
_defineProperty$l(et2_diff, "_attributes", {
  "value": {
    "type": "any"
  }
});
et2_register_widget(et2_diff, ["diff"]);

function _defineProperty$k(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Function which appends the encapsulated style data to the head tag of the
 * page.
 *
 * TODO: The style data could be parsed for rules and appended using the JS
 * stylesheet interface, allowing the style only to modifiy nodes of the current
 * template.
 *
 * @augments et2_widget
 */
class et2_styles extends et2_widget {
  /**
   * Constructor
   *
   * @memberOf et2_styles
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_styles._attributes, _child || {}));

    // Allow no child widgets
    _defineProperty$k(this, "styleNode", void 0);
    _defineProperty$k(this, "head", void 0);
    _defineProperty$k(this, "dom_id", void 0);
    this.supportedWidgetClasses = [];

    // Create the style node and append it to the head node
    this.styleNode = document.createElement("style");
    this.styleNode.setAttribute("type", "text/css");
    this.head = this.egw().window.document.getElementsByTagName("head")[0];
    this.head.appendChild(this.styleNode);
  }
  destroy() {
    // Remove the style node again and delete any reference to it
    this.head.removeChild(this.styleNode);
    super.destroy();
  }
  loadContent(_content) {
    // @ts-ignore
    if (this.styleNode.styleSheet) {
      // IE
      // @ts-ignore
      this.styleNode.styleSheet.cssText += _content;
    } else {
      this.styleNode.appendChild(document.createTextNode(_content));
    }
  }

  /**
   * Sets the id of the DOM-Node.
   *
   * DOM id's have dots "." replaced with dashes "-"
   *
   * @param {string} _value id to set
   */
  set_id(_value) {
    this.id = _value;
    this.dom_id = _value ? this.getInstanceManager().uniqueId + '_' + _value.replace(/\./g, '-') : _value;
    if (this.styleNode) {
      if (_value != "") {
        this.styleNode.setAttribute("id", this.dom_id);
      } else {
        this.styleNode.removeAttribute("id");
      }
    }
  }
}
et2_register_widget(et2_styles, ["styles"]);

function _defineProperty$j(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @augments et2_valueWidget
 */
class et2_html extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_html
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_html._attributes, _child || {}));

    // Allow no child widgets
    _defineProperty$j(this, "htmlNode", null);
    this.supportedWidgetClasses = [];
    this.htmlNode = jQuery(document.createElement("span"));
    if (this.getType() == 'htmlarea') {
      this.htmlNode.addClass('et2_textbox_ro');
    }
    if (this.options.label) {
      this.htmlNode.append('<span class="et2_label">' + this.options.label + '</span>');
    }
    this.setDOMNode(this.htmlNode[0]);
  }
  loadContent(_data) {
    // Create an object containg the given value and an empty js string
    var html = {
      html: _data ? _data : '',
      js: ''
    };

    // Separate the javascript from the given html. The js code will be
    // written to the previously created empty js string
    egw_seperateJavaScript(html);

    // Append the html to the parent element
    if (this.options.label) {
      this.htmlNode.append('<span class="et2_label">' + this.options.label + '</span>');
    }
    this.htmlNode.append(html.html);
    this.htmlNode.append(html.js);
  }
  set_value(_value) {
    this.htmlNode.empty();
    this.loadContent(_value);
  }

  /**
   * Code for implementing et2_IDetachedDOM
   *
   * @param {array} _attrs
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "class");
  }
  getDetachedNodes() {
    return [this.htmlNode[0]];
  }
  setDetachedAttributes(_nodes, _values) {
    this.htmlNode = jQuery(_nodes[0]);
    if (typeof _values['value'] !== 'undefined') {
      this.set_value(_values['value']);
    }
  }
}
_defineProperty$j(et2_html, "_attributes", {
  'label': {
    'default': "",
    description: "The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",
    ignore: false,
    name: "Label",
    translate: true,
    type: "string"
  },
  "needed": {
    "ignore": true
  },
  value: {
    name: "Value",
    description: "The value of the widget",
    type: "html",
    // "string" would remove html tags by running html_entity_decode
    default: et2_no_init
  }
});
et2_register_widget(et2_html, ["html", "htmlarea_ro"]);

function _defineProperty$i(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * et2_editableWidget derives from et2_inputWidget and adds the ability to start
 * readonly, then turn editable on double-click.  If we decide to do this with
 * more widgets, it should just be merged with et2_inputWidget.
 *
 * @augments et2_inputWidget
 */
class et2_editableWidget extends et2_inputWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // 'Editable' really should be boolean for everything else to work
    if (_attrs.readonly && typeof _attrs.readonly === 'string') {
      _attrs.readonly = true;
      var toggle_readonly = _attrs.toggle_readonly;
    }
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_editableWidget._attributes, _child || {}));
    _defineProperty$i(this, "_toggle_readonly", void 0);
    if (typeof toggle_readonly != 'undefined') this._toggle_readonly = toggle_readonly;
  }
  destroy() {
    var node = this.getInputNode();
    if (node) {
      jQuery(node).off('.et2_editableWidget');
    }
    super.destroy();
  }

  /**
   * Load the validation errors from the server
   *
   * @param {object} _attrs
   */
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
  }
  attachToDOM() {
    var res = super.attachToDOM();
    var node = this.getDOMNode();
    if (node && this._toggle_readonly) {
      jQuery(node).off('.et2_editableWidget').on("dblclick.et2_editableWidget", this, function (e) {
        e.data.dblclick.call(e.data, this);
      }).addClass('et2_clickable et2_editable');
    } else {
      jQuery(node).addClass('et2_editable_readonly');
    }
    return res;
  }
  detatchFromDOM() {
    super.detatchFromDOM();
  }

  /**
   * Handle double click
   *
   * Turn widget editable
   *
   * @param {DOMNode} _node
   */
  dblclick(_node) {
    // Turn off readonly
    this.set_readonly(false);
    jQuery('body').on("click.et2_editableWidget", this, function (e) {
      // Make sure click comes from body, not a popup
      if (jQuery.contains(this, e.target) && e.target.type != 'textarea') {
        jQuery(this).off("click.et2_editableWidget");
        e.data.focusout.call(e.data, this);
      }
    });
  }

  /**
   * User clicked somewhere else, save and turn back to readonly
   *
   * @param {DOMNode} _node Body node
   * @returns {et2_core_editableWidgetet2_editableWidget.et2_core_editableWidgetAnonym$0@call;getInstanceManager@call;submit}
   */
  focusout(_node) {
    var value = this.get_value();
    var oldValue = this._oldValue;

    // Change back to readonly
    this.set_readonly(true);

    // No change, do nothing
    if (value == oldValue) return;

    // Submit
    if (this.options.save_callback) {
      var params = [value];
      if (this.options.save_callback_params) {
        params = params.concat(this.options.save_callback_params.split(','));
      }
      egw$1.json(this.options.save_callback, params, function () {}, this, true, this).sendRequest();
    } else {
      this.set_value(value);
      return this.getInstanceManager().submit();
    }
  }

  /**
   * Called whenever the template gets submitted.
   * If we have a save_callback, we call that before the submit (no check on
   * the result)
   *
   * @param _values contains the values which will be sent to the server.
   * 	Listeners may change these values before they get submitted.
   */
  submit(_values) {
    if (this.options.readonly) {
      // Not currently editing, just continue on
      return true;
    }
    // Change back to readonly
    this.set_readonly(true);
    var params = [this.get_value()];
    if (this.options.save_callback_params) {
      params = params.concat(this.options.save_callback_params.split(','));
    }
    if (this.options.save_callback) {
      egw$1.json(this.options.save_callback, params, function () {}, this, true, this).sendRequest();
    }
    return true;
  }
}
_defineProperty$i(et2_editableWidget, "_attributes", {
  readonly: {
    name: "readonly",
    type: "string",
    // | boolean
    default: false,
    description: "If set to 'editable' will start readonly, double clicking will make it editable and clicking out will save",
    ignore: true // todo: not sure why this used to be ignored before migration by default but not anymore
  },

  toggle_readonly: {
    name: "toggle_readonly",
    type: "boolean",
    default: true,
    description: "Double clicking makes widget editable.  If off, must be made editable in some other way."
  },
  save_callback: {
    name: "save_callback",
    type: "string",
    default: et2_no_init,
    description: "Ajax callback to save changed value when readonly is 'editable'.  If not provided, a regular submit is done."
  },
  save_callback_params: {
    name: "readonly",
    type: "string",
    default: et2_no_init,
    description: "Additional parameters passed to save_callback"
  },
  editable_height: {
    name: "Editable height",
    description: "Set height for widget while in edit mode",
    type: "string"
  }
});

function _defineProperty$h(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @augments et2_inputWidget
 */
class et2_htmlarea extends et2_editableWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_htmlarea._attributes, _child || {}));
    _defineProperty$h(this, "editor", null);
    _defineProperty$h(this, "supportedWidgetClasses", void 0);
    _defineProperty$h(this, "htmlNode", null);
    _defineProperty$h(this, "mode", void 0);
    _defineProperty$h(this, "toolbar", void 0);
    _defineProperty$h(this, "tinymce", void 0);
    _defineProperty$h(this, "tinymce_container", void 0);
    _defineProperty$h(this, "file_picker_callback", void 0);
    _defineProperty$h(this, "menubar", void 0);
    _defineProperty$h(this, "value", void 0);
    this.editor = null; // TinyMce editor instance
    this.supportedWidgetClasses = []; // Allow no child widgets
    this.htmlNode = jQuery(document.createElement(this.options.readonly ? "div" : "textarea")).addClass('et2_textbox_ro');
    if (this.options.height) {
      this.htmlNode.css('height', this.options.height);
    }
    this.setDOMNode(this.htmlNode[0]);
  }

  /**
   *
   * @returns {undefined}
   */
  doLoadingFinished() {
    super.doLoadingFinished();
    return this.init_editor();
  }
  init_editor() {
    if (this.mode == 'ascii' || this.editor != null || this.options.readonly) return;
    var imageUpload;
    var self = this;
    if (this.options.imageUpload && this.options.imageUpload[0] !== '/' && this.options.imageUpload.substr(0, 4) != 'http') {
      imageUpload = egw$1.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_htmlarea_upload") + '&request_id=' + this.getInstanceManager().etemplate_exec_id + '&widget_id=' + this.options.imageUpload + '&type=htmlarea';
      imageUpload = imageUpload.substr(egw$1.webserverUrl.length + 1);
    } else if (imageUpload) {
      imageUpload = this.options.imageUpload.substr(egw$1.webserverUrl.length + 1);
    } else {
      imageUpload = egw$1.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_htmlarea_upload") + '&request_id=' + this.getInstanceManager().etemplate_exec_id + '&type=htmlarea';
    }
    // default settings for initialization
    var settings = {
      base_url: egw$1.webserverUrl + '/vendor/tinymce/tinymce',
      target: this.htmlNode[0],
      body_id: this.dom_id + '_htmlarea',
      menubar: false,
      statusbar: this.options.statusbar,
      toolbar_mode: this.options.toolbar_mode,
      branding: false,
      resize: false,
      height: this.options.height,
      width: this.options.width,
      end_container_on_empty_block: true,
      mobile: {
        theme: 'silver'
      },
      formats: {
        // setting p (and below also the preferred formatblock) to the users font and -size preference
        p: {
          block: 'p',
          styles: {
            "font-family": egw$1.preference('rte_font', 'common') || 'arial, helvetica, sans-serif',
            "font-size": (egw$1.preference('rte_font_size', 'common') || '10') + (egw$1.preference('rte_font_unit', 'common') || 'pt')
          }
        },
        customparagraph: {
          block: 'p',
          styles: {
            "margin-block-start": "0px",
            "margin-block-end": "0px"
          }
        }
      },
      min_height: 100,
      convert_urls: false,
      language: et2_htmlarea.LANGUAGE_CODE[egw$1.preference('lang', 'common')],
      language_url: egw$1.webserverUrl + '/api/js/tinymce/langs/' + et2_htmlarea.LANGUAGE_CODE[egw$1.preference('lang', 'common')] + '.js',
      paste_data_images: true,
      paste_filter_drop: true,
      browser_spellcheck: true,
      contextmenu: false,
      images_upload_url: imageUpload,
      file_picker_callback: jQuery.proxy(this._file_picker_callback, this),
      images_upload_handler: this.options.images_upload_handler,
      init_instance_callback: jQuery.proxy(this._instanceIsReady, this),
      auto_focus: false,
      valid_children: this.options.valid_children,
      plugins: ["print searchreplace autolink directionality ", "visualblocks visualchars image link media template fullscreen", "codesample table charmap hr pagebreak nonbreaking anchor toc ", "insertdatetime advlist lists textcolor wordcount imagetools ", "colorpicker textpattern help paste code searchreplace tabfocus"],
      toolbar: et2_htmlarea.TOOLBAR_SIMPLE,
      block_formats: "Paragraph=p;Heading 1=h1;Heading 2=h2;Heading 3=h3;" + "Heading 4=h4;Heading 5=h5;Heading 6=h6;Preformatted=pre",
      font_formats: "Andale Mono=andale mono,times;Arial=arial,helvetica," + "sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book " + "antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;" + "Courier New=courier new,courier;Georgia=georgia,palatino;" + "Helvetica=helvetica;Impact=impact,chicago;Segoe=segoe,segoe ui;Symbol=symbol;" + "Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal," + "monaco;Times New Roman=times new roman,times;Trebuchet " + "MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;" + "Wingdings=wingdings,zapf dingbats",
      fontsize_formats: '8pt 10pt 12pt 14pt 18pt 24pt 36pt',
      content_css: egw$1.webserverUrl + '/api/tinymce.php?' +
      // use the 3 prefs as cache-buster
      btoa(egw$1.preference('rte_font', 'common') + '::' + egw$1.preference('rte_font_size', 'common') + '::' + egw$1.preference('rte_font_unit', 'common'))
    };
    var rte_formatblock = egw$1.preference('rte_formatblock', 'common') || 'p';
    if (rte_formatblock === 'customparagraph') {
      settings.forced_root_block = false;
      settings.force_br_newlines = true;
      settings.force_p_newlines = false;
      rte_formatblock = 'p';
    } else if (rte_formatblock !== 'p') {
      settings.formats[rte_formatblock] = jQuery.extend(true, {}, settings.formats.p);
      settings.formats[rte_formatblock].block = rte_formatblock;
    }
    // extend default settings with configured options and preferences
    jQuery.extend(settings, this._extendedSettings());
    this.tinymce = tinymce.init(settings);
    // make sure value gets set in case of widget gets loaded by delay like
    // inside an inactive tabs
    this.tinymce.then(function () {
      self.set_value(self.htmlNode.val());
      self.resetDirty();
      if (self.editor && self.editor.editorContainer) {
        var activeElement = document.activeElement;
        self.editor.formatter.toggle(rte_formatblock);
        jQuery(self.editor.editorContainer).height(self.options.height);
        jQuery(self.editor.iframeElement.contentWindow.document).on('dragenter', function () {
          if (jQuery('#dragover-tinymce').length < 1) jQuery("<style id='dragover-tinymce'>.dragover:after {height:calc(100% - " + jQuery(this).height() + "px) !important;}</style>").appendTo('head');
        });
        // give focus back
        activeElement && activeElement.focus && activeElement.focus();
      }
    });
    return this.tinymce;
  }

  /**
   * set disabled
   *
   * @param {type} _value
   * @returns {undefined}
   */
  set_disabled(_value) {
    super.set_disabled(_value);
    if (_value) {
      jQuery(this.tinymce_container).css('display', 'none');
    } else {
      jQuery(this.tinymce_container).css('display', 'flex');
    }
  }
  set_readonly(_value) {
    if (this.options.readonly === _value) return;
    var value = this.get_value();
    this.options.readonly = _value;
    if (this.options.readonly) {
      if (this.editor) this.editor.remove();
      this.htmlNode = jQuery(document.createElement(this.options.readonly ? "div" : "textarea")).addClass('et2_textbox_ro');
      if (this.options.height) {
        this.htmlNode.css('height', this.options.height);
      }
      this.editor = null;
      this.setDOMNode(this.htmlNode[0]);
      this.set_value(value);
    } else {
      if (!this.editor) {
        this.htmlNode = jQuery(document.createElement("textarea")).val(value);
        if (this.options.height || this.options.editable_height) {
          this.htmlNode.css('height', this.options.editable_height ? this.options.editable_height : this.options.height);
        }
        this.setDOMNode(this.htmlNode[0]);
        this.init_editor();
      }
    }
  }

  /**
   * Callback function runs when the filepicker in image dialog is clicked
   *
   * @param {type} _callback
   * @param {type} _value
   * @param {type} _meta
   */
  _file_picker_callback(_callback, _value, _meta) {
    if (typeof this.file_picker_callback == 'function') return this.file_picker_callback.call(arguments, this);
    var callback = _callback;

    // Don't rely only on app_name to fetch et2 object as app_name may not
    // always represent current app of the window, e.g.: mail admin account.
    // Try to fetch et2 from its template name.
    var etemplate = jQuery('form').data('etemplate');
    var et2;
    if (etemplate && etemplate.name && !app[egw$1(window).app_name()]) {
      et2 = etemplate2$1.getByTemplate(etemplate.name)[0]['widgetContainer'];
    } else {
      et2 = app[egw$1(window).app_name()].et2;
    }
    var vfsSelect = et2_createWidget('vfs-select', {
      id: 'upload',
      mode: 'open',
      name: '',
      button_caption: "Link",
      button_label: "Link",
      dialog_title: "Link file",
      method: "download"
    }, et2);
    jQuery(vfsSelect.getDOMNode()).on('change', function () {
      callback(vfsSelect.get_value(), {
        alt: vfsSelect.get_value()
      });
    });

    // start the file selector dialog
    vfsSelect.click();
  }

  /**
   * Callback when instance is ready
   *
   * @param {type} _editor
   */
  _instanceIsReady(_editor) {
    console.log("Editor: " + _editor.id + " is now initialized.");
    // try to reserve focus state as running command on editor may steal the
    // current focus.
    var focusedEl = jQuery(':focus');
    this.editor = _editor;
    this.editor.on('drop', function (e) {
      e.preventDefault();
    });
    if (!this.disabled) jQuery(this.editor.editorContainer).css('display', 'flex');
    this.tinymce_container = this.editor.editorContainer;
    // go back to reserved focused element
    focusedEl.focus();
  }

  /**
   * Takes all relevant preferences into account and set settings accordingly
   *
   * @returns {object} returns a object including all settings
   */
  _extendedSettings() {
    var rte_menubar = egw$1.preference('rte_menubar', 'common');
    var rte_toolbar = egw$1.preference('rte_toolbar', 'common');
    // we need to have rte_toolbar values as an array
    if (rte_toolbar && typeof rte_toolbar == "object" && this.toolbar == '') {
      rte_toolbar = Object.keys(rte_toolbar).map(function (key) {
        return rte_toolbar[key];
      });
    } else if (this.toolbar != '') {
      rte_toolbar = this.toolbar.split(',');
    }
    var settings = {
      fontsize_formats: et2_htmlarea.FONT_SIZE_FORMATS[egw$1.preference('rte_font_unit', 'common')],
      menubar: parseInt(rte_menubar) && this.menubar ? true : typeof rte_menubar != 'undefined' ? false : this.menubar
    };
    switch (this.mode) {
      case 'simple':
        settings['toolbar'] = et2_htmlarea.TOOLBAR_SIMPLE;
        break;
      case 'extended':
        settings['toolbar'] = et2_htmlarea.TOOLBAR_EXTENDED;
        break;
      case 'advanced':
        settings['toolbar'] = et2_htmlarea.TOOLBAR_ADVANCED;
        break;
      default:
        this.mode = '';
    }

    // take rte_toolbar into account if no mode restrictly set from template
    if (rte_toolbar && !this.mode) {
      var toolbar_diff = et2_htmlarea.TOOLBAR_LIST.filter(function (i) {
        return !(rte_toolbar.indexOf(i) > -1);
      });
      settings['toolbar'] = et2_htmlarea.TOOLBAR_ADVANCED;
      toolbar_diff.forEach(function (a) {
        var r = new RegExp(a);
        settings['toolbar'] = settings['toolbar'].replace(r, '');
      });
    }
    return settings;
  }
  destroy() {
    if (this.editor) {
      try {
        this.editor.destroy();
      } catch (e) {
        egw$1().debug("Error destroying editor", e);
      }
    }
    this.editor = null;
    this.tinymce = null;
    this.tinymce_container = null;
    this.htmlNode.remove();
    this.htmlNode = null;
    super.destroy();
  }
  set_value(_value) {
    this._oldValue = _value;
    if (this.editor) {
      this.editor.setContent(_value);

      // need to defer a little, so TinyMCE does its modifications we want to counter
      if (this.options.applyDefaultFont) {
        window.setTimeout(() => this.wrapTextNodes(), 10);
      }
    } else {
      if (this.options.readonly) {
        this.htmlNode.empty().append(_value);
      } else {
        this.htmlNode.val(_value);
      }
    }
    this.value = _value;
  }

  /**
   * @param boolean submit_value true: call by etemplate2.(getValues|submit|postSubmit)()
   */
  getValue(submit_value) {
    if (this.editor) {
      // not always applying defaut font, as getValue() is called a lot, e.g. to test input is dirty
      if (this.options.applyDefaultFont && submit_value) {
        this.applyDefaultFont();
      }
      return this.editor.getContent();
    }
    return this.options.readonly ? this.value : this.htmlNode.val();
  }

  /**
   * Wrap text-nodes and other non-block elements with <p></p> as TinyMCE produces them, if we use small paragraphs
   *
   * This is done to create valid HTML and allow to set our default font, see applyDefaultFont(),
   * which can NOT set a font on text-nodes or br!
   */
  wrapTextNodes() {
    var _this$editor;
    var body = (_this$editor = this.editor) === null || _this$editor === void 0 ? void 0 : _this$editor.editorContainer.querySelector('iframe').contentDocument.querySelector('body');
    if (!body) return false;
    var toWrap = [];
    body.childNodes.forEach(node => {
      var _node$computedStyleMa;
      var text_non_block_node = node.nodeType === node.TEXT_NODE || node.nodeType === node.ELEMENT_NODE && typeof node.computedStyleMap !== 'undefined' && ((_node$computedStyleMa = node.computedStyleMap().get('display')) === null || _node$computedStyleMa === void 0 ? void 0 : _node$computedStyleMa.value) !== 'block';
      if (text_non_block_node) {
        toWrap.push(node);
      }
      if ((!text_non_block_node || node === body.lastChild) && toWrap.length) {
        var wrap = body.ownerDocument.createElement('p');
        toWrap.forEach(node => {
          wrap.appendChild(node === toWrap[0] ? body.replaceChild(wrap, node) : body.removeChild(node));
        });
        toWrap = [];
      }
    });
    // TinyMCE inserts a BR in the first P --> remove it, if it's not the only child, as it is not wanted (moves the text down on each submit)
    var firstChild = body.firstChild;
    if (firstChild.nodeName === 'P' && firstChild.firstChild !== firstChild.lastChild && firstChild.firstChild.nodeName === 'BR') {
      firstChild.removeChild(firstChild.firstChild);
    }
    return true;
  }

  /**
   * Apply default font and -size
   */
  applyDefaultFont() {
    var _this$editor2;
    var edit_area = (_this$editor2 = this.editor) === null || _this$editor2 === void 0 ? void 0 : _this$editor2.editorContainer.querySelector('iframe').contentDocument;
    if (!edit_area) return false;

    // we first need to wrap all text and non-block elements in p, to be able to set a font
    this.wrapTextNodes();
    var font_family = egw$1.preference('rte_font', 'common') || 'arial, helvetica, sans-serif';
    edit_area.querySelectorAll('h1:not([style*="font-family"]),h2:not([style*="font-family"]),h3:not([style*="font-family"]),h4:not([style*="font-family"]),h5:not([style*="font-family"]),h6:not([style*="font-family"]),' + 'div:not([style*="font-family"]),li:not([style*="font-family"]),p:not([style*="font-family"]),blockquote:not([style*="font-family"]),' + 'td:not([style*="font-family"]),th:not([style*="font-family"]').forEach(elem => {
      elem.style.fontFamily = font_family;
    });
    var font_size = (egw$1.preference('rte_font_size', 'common') || '10') + (egw$1.preference('rte_font_unit', 'common') || 'pt');
    edit_area.querySelectorAll('div:not([style*="font-size"]),li:not([style*="font-size"]),p:not([style*="font-size"]),blockquote:not([style*="font-size"]),' + 'td:not([style*="font-size"]),th:not([style*="font-size"])').forEach(elem => {
      elem.style.fontSize = font_size;
    });
    return true;
  }

  /**
   * Resize htmlNode tag according to window size
   * @param {type} _height excess height which comes from window resize
   */
  resize(_height) {
    if (_height && this.options.resize_ratio !== '0') {
      // apply the ratio
      _height = this.options.resize_ratio != '' ? _height * this.options.resize_ratio : _height;
      if (_height != 0) {
        if (this.editor)
          // TinyMCE HTML
          {
            var _this$editor$editorCo, _this$editor$editorCo2;
            var h;
            if (typeof this.editor.iframeElement != 'undefined' && this.editor.editorContainer.clientHeight > 0) {
              h = this.editor.editorContainer.clientHeight + _height > 0 ? this.editor.editorContainer.clientHeight + _height : this.editor.settings.min_height;
            } else
              // fallback height size
              {
                h = this.editor.settings.min_height + _height;
              }
            jQuery(this.editor.editorContainer).height(h);
            jQuery(this.editor.iframeElement).height(h - (((_this$editor$editorCo = this.editor.editorContainer.getElementsByClassName('tox-editor-header')[0]) === null || _this$editor$editorCo === void 0 ? void 0 : _this$editor$editorCo.clientHeight) + ((_this$editor$editorCo2 = this.editor.editorContainer.getElementsByClassName('tox-statusbar')[0]) === null || _this$editor$editorCo2 === void 0 ? void 0 : _this$editor$editorCo2.clientHeight)));
          } else
          // No TinyMCE
          {
            this.htmlNode.height(this.htmlNode.height() + _height);
          }
      }
    }
  }
}
_defineProperty$h(et2_htmlarea, "_attributes", {
  mode: {
    'name': 'Mode',
    'description': 'One of {ascii|simple|extended|advanced}',
    'default': '',
    'type': 'string'
  },
  height: {
    'name': 'Height',
    'default': et2_no_init,
    'type': 'string'
  },
  width: {
    'name': 'Width',
    'default': et2_no_init,
    'type': 'string'
  },
  value: {
    name: "Value",
    description: "The value of the widget",
    type: "html",
    // "string" would remove html tags by running html_entity_decode
    default: et2_no_init
  },
  imageUpload: {
    name: "imageUpload",
    description: "Url to upload images dragged in or id of link_to widget to it's vfs upload. Can also be just a name for which content array contains a path to upload the picture.",
    type: "string",
    default: null
  },
  file_picker_callback: {
    name: "File picker callback",
    description: "Callback function to get called when file picker is clicked",
    type: 'js',
    default: et2_no_init
  },
  images_upload_handler: {
    name: "Images upload handler",
    description: "Callback function for handling image upload",
    type: 'js',
    default: et2_no_init
  },
  menubar: {
    name: "Menubar",
    description: "Display menubar at the top of the editor",
    type: "boolean",
    default: true
  },
  statusbar: {
    name: "Status bar",
    description: "Enable/disable status bar on the bottom of editor",
    type: "boolean",
    default: true
  },
  valid_children: {
    name: "Valid children",
    description: "Enables to control what child tag is allowed or not allowed of the present tag. For instance: +body[style], makes style tag allowed inside body",
    type: "string",
    default: "+body[style]"
  },
  toolbar: {
    'name': 'Toolbar',
    'description': 'Comma separated string of toolbar actions. It will only be considered if no Mode is restricted.',
    'default': '',
    'type': 'string'
  },
  toolbar_mode: {
    'name': 'toolbar mode',
    'type': 'string',
    'default': 'floating',
    'description': 'It allows to extend the toolbar to accommodate the overflowing toolbar buttons. {floating, sliding, scrolling, wrap}'
  },
  applyDefaultFont: {
    name: 'apply default font and size',
    type: 'boolean',
    default: false,
    description: 'Add default font and size as style attribute to the markup. Also ensures all non-block elements are wrapped in p.'
  }
});
/**
 * Array of toolbars
 * @constant
 */
_defineProperty$h(et2_htmlarea, "TOOLBAR_LIST", ['undo', 'redo', 'formatselect', 'fontselect', 'fontsizeselect', 'bold', 'italic', 'strikethrough', 'forecolor', 'backcolor', 'link', 'alignleft', 'aligncenter', 'alignright', 'alignjustify', 'numlist', 'bullist', 'outdent', 'indent', 'ltr', 'rtl', 'removeformat', 'code', 'image', 'searchreplace', 'fullscreen', 'table']);
/**
 * arranged toolbars as simple mode
 * @constant
 */
_defineProperty$h(et2_htmlarea, "TOOLBAR_SIMPLE", "undo redo|formatselect fontselect fontsizeselect | bold italic underline removeformat forecolor backcolor | " + "alignleft aligncenter alignright alignjustify | bullist " + "numlist outdent indent| link image pastetext | table");
/**
 * arranged toolbars as extended mode
 * @constant
 */
_defineProperty$h(et2_htmlarea, "TOOLBAR_EXTENDED", "fontselect fontsizeselect | bold italic underline strikethrough forecolor backcolor | " + "link | alignleft aligncenter alignright alignjustify  | numlist " + "bullist outdent indent | removeformat | image | fullscreen | table");
/**
 * arranged toolbars as advanced mode
 * @constant
 */
_defineProperty$h(et2_htmlarea, "TOOLBAR_ADVANCED", "undo redo| formatselect | fontselect fontsizeselect | bold italic underline strikethrough forecolor backcolor | " + "alignleft aligncenter alignright alignjustify | bullist " + "numlist outdent indent ltr rtl | removeformat code| link image pastetext | searchreplace | fullscreen | table");
/**
 * font size formats
 * @constant
 */
_defineProperty$h(et2_htmlarea, "FONT_SIZE_FORMATS", {
  pt: "8pt 9pt 10pt 11pt 12pt 14pt 16pt 18pt 20pt 22pt 24pt 26pt 28pt 36pt 48pt 72pt",
  px: "8px 9px 10px 11px 12px 14px 16px 18px 20px 22px 24px 26px 28px 36px 48px 72px"
});
/**
 * language code represention for TinyMCE lang code
 */
_defineProperty$h(et2_htmlarea, "LANGUAGE_CODE", {
  bg: "bg_BG",
  ca: "ca",
  cs: "cs",
  da: "da",
  de: "de",
  en: "en_CA",
  el: "el",
  "es-es": "es",
  et: "et",
  eu: "eu",
  fa: "fa_IR",
  fi: "fi",
  fr: "fr_FR",
  hi: "",
  hr: "hr",
  hu: "hu_HU",
  id: "id",
  it: "it",
  iw: "",
  ja: "ja",
  ko: "ko_KR",
  lo: "",
  lt: "lt",
  lv: "lv",
  nl: "nl",
  no: "nb_NO",
  pl: "pl",
  pt: "pt_PT",
  "pt-br": "pt_BR",
  ru: "ru",
  sk: "sk",
  sl: "sl_SI",
  sv: "sv_SE",
  th: "th_TH",
  tr: "tr_TR",
  uk: "en_GB",
  vi: "vi_VN",
  zh: "zh_CN",
  "zh-tw": "zh_TW"
});
et2_register_widget(et2_htmlarea, ["htmlarea"]);

function _defineProperty$g(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * This toolbar gets its contents from its actions
 *
 * @augments et2_valueWidget
 */
class et2_toolbar extends et2_DOMWidget {
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_toolbar._attributes, _child || {}));
    /**
     * id of last action executed / value of toolbar if submitted
     */
    _defineProperty$g(this, "value", null);
    /**
     * actionbox is a div for stored actions
     */
    _defineProperty$g(this, "actionbox", null);
    /**
     * actionlist is a div for active actions
    	 */
    _defineProperty$g(this, "actionlist", null);
    _defineProperty$g(this, "div", null);
    _defineProperty$g(this, "countActions", 0);
    _defineProperty$g(this, "dropdowns", {});
    _defineProperty$g(this, "preference", {});
    _defineProperty$g(this, "menu", null);
    _defineProperty$g(this, "_objectManager", null);
    this.div = jQuery(document.createElement('div')).addClass('et2_toolbar ui-widget-header ui-corner-all');

    // Set proper id and dom_id for the widget
    this.set_id(this.id);
    if (!this.options.preference_id) {
      this.options.preference_id = this.dom_id;
    }
    if (!this.options.preference_app) {
      this.options.preference_app = this.egw().app_name();
    }
    this.actionbox = jQuery(document.createElement('details')).addClass("et2_toolbar_more").attr('id', this.id + '-' + 'actionbox');
    this.actionlist = jQuery(document.createElement('div')).addClass("et2_toolbar_actionlist").attr('id', this.id + '-' + 'actionlist');
    this.countActions = 0;
    this.dropdowns = {};
    this.preference = {};
    this._build_menu(et2_toolbar.default_toolbar, true);
  }
  destroy() {
    // Destroy widget
    if (this.div && this.div.data('ui-menu')) this.menu.menu("destroy");

    // Null children

    // Remove
    this.div.empty().remove();
    this.actionbox.empty().remove();
    this.actionlist.empty().remove();
  }

  /**
   * Fix function in order to fix toolbar preferences with the new preference structure
   * @param {action object} _action
   * @todo ** SEE IMPORTANT TODO **
   */
  _fix_preference(_action) {
    // ** IMPORTANT TODO: This switch case should be removed for new release **
    // This is an ugly hack but we need to add this switch becuase to update and fix
    // current users toolbar preferences with the new structure which is:
    // - All actions should be stored in preference
    // - Actions inside menu set as true
    // - Actions outside menu set as false
    // - if an action gets added to toolbar it would be undefined in
    //  the preference which we need to consider to add it to the preference
    //  according to its toolbarDefault option.
    if (this.dom_id === 'mail-display_displayToolbar' || this.dom_id === 'mail-index_toolbar') {
      switch (_action.id) {
        // Actions newly added to mail index and display toolbar
        case 'read':
        case 'label1':
        case 'label2':
        case 'label3':
        case 'label4':
        case 'label5':
          this.set_prefered(_action.id, !_action.toolbarDefault);
          break;
        default:
          // Fix structure and add the actions not the preference
          // into the preference with value false, as they're already
          // outside of the menu.
          this.set_prefered(_action.id, false);
      }
    } else {
      // ** IMPORTANT TODO: This line needs to stay and be fixed with !toolbarDefault after the if condition
      // has been removed.
      this.set_prefered(_action.id, false /*!toolbarDefault*/);
    }
  }

  /**
   * Count number of actions including their children
   * @param {object} actions
   * @return {number} return total number of actions
   */
  _countActions(actions) {
    var totalCount = 0;
    var childCounter = function childCounter(action, count) {
      var children = action.children || 0,
        returnCounter = count || 0;
      if (children) {
        returnCounter -= 1;
        for (var nChild in children) {
          returnCounter += 1;
          returnCounter = childCounter(children[nChild], returnCounter);
        }
      } else {
        returnCounter = count;
      }
      return returnCounter;
    };
    for (var nAction in actions) {
      if (this.options.flat_list) {
        totalCount += childCounter(actions[nAction], 1);
      } else {
        totalCount++;
      }
    }
    return totalCount;
  }

  /**
   * Go through actions and build buttons for the toolbar
   *
   * @param {Object} actions egw-actions to build menu from
   * @param {boolean} isDefault setting isDefault with true will
   *  avoid actions get into the preferences, for instandce, first
   *  time toolbar_default actions initialization.
   */
  _build_menu(actions, isDefault) {
    var _this = this;
    // Clear existing
    this.div.empty();
    this.actionbox.removeClass('et2_dropZone').empty();
    this.actionlist.removeClass('et2_dropZone').empty();
    var admin_setting = this.options.is_admin ? '<span class="toolbar-admin-pref" title="' + egw$1.lang('Admin settings') + ' ..."></span>' : '';
    var list_header = this.options.list_header == 'more' ? true : false;
    this.actionbox.append('<summary class="ui-toolbar-menulistHeader' + (!list_header ? ' list_header-short' : ' ') + '">' + (list_header ? egw$1.lang('more') + ' ...' : '') + admin_setting + '</summary>');
    this.actionbox.append('<div id="' + this.id + '-menulist' + '" class="ui-toolbar-menulist" ></div>');
    var that = this;
    if (this.options.is_admin) {
      this.actionbox.find('.toolbar-admin-pref').click(function (e) {
        egw$1.json('EGroupware\\Api\\Etemplate\\Widget\\Toolbar::ajax_get_default_prefs', [that.options.preference_app, that.options.preference_id], function (_prefs) {
          var prefs = [];
          for (var p in _prefs) {
            if (_prefs[p] === false) prefs.push(p);
          }
          that._admin_settings_dialog.call(that, actions, prefs);
        }).sendRequest(true);
        return false;
      });
      this.actionbox.addClass('admin');
    }
    var pref = !egwIsMobile$1() ? egw$1.preference(this.options.preference_id, this.options.preference_app) : undefined;
    // check pref has a reasonable value: is a real object (not an array), strings e.g. stall the whole widget
    if (pref && typeof pref === 'object' && !Array.isArray(pref)) {
      this.preference = pref;
    }

    //Set the default actions for the first time
    if (typeof pref === 'undefined' && !isDefault) {
      for (var name in actions) {
        if ((typeof actions[name].children === 'undefined' || !this.options.flat_list) && actions[name].id) {
          this.set_prefered(actions[name].id, !actions[name].toolbarDefault);
        }
      }
    } else if (!isDefault) {
      for (var name in actions) {
        // Check if the action is not in the preference, means it's an new added action
        // therefore it needs to be added to the preference with taking its toolbarDefault
        // option into account.
        if ((typeof actions[name].children === 'undefined' || !this.options.flat_list) && typeof pref[name] === 'undefined') {
          this._fix_preference(actions[name]);
        }
      }
    }
    var menuLen = 0;
    for (var key in this.preference) {
      if (this.preference[key]) menuLen++;
    }
    this.countActions = this._countActions(actions) - menuLen;
    var last_group = null;
    var last_group_id = null;
    var _loop = function _loop() {
        var action = actions[_name];
        if (typeof action == 'string') action = {
          id: _name,
          caption: action
        };
        if (typeof action.group == 'undefined') {
          action.group = 'default';
        }

        // Add in divider
        if (last_group_id != action.group) {
          last_group = jQuery('[data-group="' + action.group + '"]', _this.actionlist);
          if (last_group.length == 0) {
            jQuery('<span data-group="' + action.group + '">').appendTo(_this.actionlist);
          }
          last_group_id = action.group;
        }

        // Make sure there's something to display
        if (!action.caption && !action.icon && !action.iconUrl) return 0; // continue
        if (action.children) {
          var children = {};
          var add_children = function add_children(root, children) {
            for (var id in root.children) {
              var info = {
                id: id || root.children[id].id,
                value: id || root.children[id].id,
                label: root.children[id].caption
              };
              var childaction = {};
              if (root.children[id].iconUrl) {
                info['icon'] = root.children[id].iconUrl;
              }
              if (root.children[id].children) {
                add_children(root.children[id], info);
              }
              children[id] = info;
              if (that.options.flat_list) {
                childaction = root.children[id];
                if (typeof pref === 'undefined' && !isDefault) {
                  if (!childaction['toolbarDefault']) {
                    that.set_prefered(childaction['id'], true);
                  } else {
                    that.set_prefered(childaction['id'], false);
                  }
                } else if (!isDefault) {
                  if (typeof pref[childaction['id']] === 'undefined') {
                    that._fix_preference(childaction);
                  }
                }
                if (typeof root.children[id].group !== 'undefined' && typeof root.group !== 'undefined') {
                  childaction['group'] = root.group;
                }
                that._make_button(childaction);
              }
            }
          };
          add_children(action, children);
          if (_this.options.flat_list && children) {
            return 0; // continue
          }
          var dropdown = loadWebComponent("et2-dropdown-button", {
            id: _this.id + "-" + action.id,
            label: action.caption,
            class: _this.preference[action.id] ? "et2_toolbar-dropdown et2_toolbar_draggable".concat(_this.id, " et2_toolbar-dropdown-menulist") : "et2_toolbar-dropdown et2_toolbar_draggable".concat(_this.id),
            onchange: function (ev) {
              var action = that._actionManager.getActionById(dropdown.value);
              dropdown.set_label(action.caption);
              if (action) {
                this.value = action.id;
                action.execute([]);
              }
              //console.debug(selected, this, action);
            }.bind(action),
            image: action.iconUrl || ''
          }, _this);
          dropdown.select_options = Object.values(children);

          //Set default selected action
          if (typeof action.children != 'undefined') {
            for (var child in action.children) {
              if (action.children[child].default) {
                dropdown.label = action.children[child].caption;
              }
            }
          }
          dropdown.onclick = function (selected, dropdown) {
            var action = that._actionManager.getActionById(this.getValue());
            if (action) {
              this.value = action.id;
              action.execute([]);
            }
            //console.debug(selected, this, action);
          }.bind(dropdown);
          jQuery(dropdown.getDOMNode()).appendTo(_this.preference[action.id] ? _this.actionbox.children()[1] : jQuery('[data-group=' + action.group + ']', _this.actionlist));
        } else {
          _this._make_button(action);
        }
      },
      _ret;
    for (var _name in actions) {
      _ret = _loop();
      if (_ret === 0) continue;
    }

    // ************** Drag and Drop feature for toolbar *****
    this.actionlist.find('span[data-group]').sort(function (lg, g) {
      return +lg.getAttribute('data-group') - +g.getAttribute('data-group');
    }).appendTo(this.actionlist);
    this.actionlist.appendTo(this.div);
    this.actionbox.appendTo(this.div);
    var toolbar = this.actionlist.find('span[data-group]'),
      toolbox = this.actionbox;
    this.actionlist[0].classList.add("et2_toolbar_dropzone_list".concat(this.id));
    this.actionbox[0].classList.add("et2_toolbar_dropzone_more".concat(this.id));
    this.actions = actions;
    var dragPosition = {
      x: 0,
      y: 0
    };
    var dragTranslate = {
      x: 0,
      y: 0
    };
    var draggables = this.getDOMNode().querySelectorAll(".et2_toolbar_draggable".concat(this.id));
    draggables.forEach(_item => {
      interact(_item).draggable({
        startAxis: 'xy',
        listeners: {
          start: function start(e) {
            dragPosition = {
              x: e.page.x,
              y: e.page.y
            };
            e.target.setAttribute('style', "width:".concat(e.target.clientWidth, "px !important"));
            e.target.style.position = 'fixed';
            e.target.style.transform = "translate(".concat(dragPosition.x, "px, ").concat(dragPosition.y, "px)");
          },
          move: function move(e) {
            dragTranslate.x += e.delta.x;
            dragTranslate.y += e.delta.y;
            e.target.style.transform = "translate(".concat(dragTranslate.x, "px, ").concat(dragTranslate.y, "px)");
          },
          end: function end(e) {
            that._build_menu(that.actions);
          }
        }
      });
    });
    interact(".et2_toolbar_dropzone_list".concat(this.id)).unset();
    interact(".et2_toolbar_dropzone_list".concat(this.id)).dropzone({
      checker: function checker(dragEvent,
      // related dragmove or dragend
      event,
      // Touch, Pointer or Mouse Event
      dropped,
      // bool default checker result
      dropzone,
      // dropzone Interactable
      dropzoneElement,
      // dropzone element
      draggable,
      // draggable Interactable
      draggableElement // draggable element
      ) {
        return dropped && !dropzoneElement.contains(draggableElement);
      },
      accept: ".et2_toolbar_draggable".concat(this.id),
      ondrop: function ondrop(e) {
        that.set_prefered(e.draggable.target.id.replace(that.id + '-', ''), false);
        that._build_menu(that.actions);
      },
      ondragenter: function ondragenter(e) {
        e.target.classList.add('et2_dropZone');
      },
      ondragleave: function ondragleave(e) {
        e.target.classList.remove('et2_dropZone');
      }
    });
    var menulist = [".et2_toolbar_dropzone_more".concat(this.id), "#".concat(this.id, "-menulist")];
    menulist.forEach(_item => {
      interact(_item).unset();
      interact(_item).dropzone({
        checker: function checker(dragEvent,
        // related dragmove or dragend
        event,
        // Touch, Pointer or Mouse Event
        dropped,
        // bool default checker result
        dropzone,
        // dropzone Interactable
        dropzoneElement,
        // dropzone element
        draggable,
        // draggable Interactable
        draggableElement // draggable element
        ) {
          console.log(dragEvent);
          return dropped && !dropzoneElement.contains(draggableElement);
        },
        accept: ".et2_toolbar_draggable".concat(this.id),
        ondrop: function ondrop(e) {
          that.set_prefered(e.draggable.target.id.replace(that.id + '-', ''), true);
          if (that.actionlist.find(".et2_toolbar_draggable".concat(that.id)).length == 0) {
            that.preference = {};
            egw$1.set_preference(that.options.preference_app, that.options.preference_id, that.preference);
          }
          that._build_menu(that.actions);
        },
        ondragenter: function ondragenter(e) {
          e.target.classList.add('et2_dropZone');
        },
        ondragleave: function ondragleave(e) {
          e.target.classList.remove('et2_dropZone');
        }
      });
    });
    toolbox.on('toggle', e => {
      var details = e.target;
      if (details.open) {
        jQuery('html').on('click.outsideOfMenu', function (e) {
          // Clicking on dropdown button should not close the details, we'd like to see the dropdown
          if (e.target instanceof Et2DropdownButton) {
            return;
          }
          if (e.target != details && e.target != details.firstChild) {
            details.open = false;
          }
          jQuery('html').unbind('click.outsideOfMenu');
        });
      }
    });
  }

  /**
   * Add/Or remove an action from prefence
   *
   * @param {string} _action name of the action which needs to be stored in pereference
   * @param {boolean} _state if set to true action will be set to actionbox, false will set it to actionlist
   *
   */
  set_prefered(_action, _state) {
    this.preference[_action] = _state;
    if (egwIsMobile$1()) return;
    egw$1.set_preference(this.options.preference_app, this.options.preference_id, this.preference);
  }

  /**
   * Make a button based on the given action
   *
   * @param {Object} action action object with attributes icon, caption, ...
   */
  _make_button(action) {
    var _action$data, _action$data2;
    var self = this;
    var isCheckbox = action && action.checkbox;
    var isToggleSwitch = ((_action$data = action.data) === null || _action$data === void 0 ? void 0 : _action$data.toggle_on) || ((_action$data2 = action.data) === null || _action$data2 === void 0 ? void 0 : _action$data2.toggle_off);
    var actionHandler = function (action, e) {
      var actionObj = this._actionManager.getActionById(action.id);
      if (actionObj) {
        if (actionObj.checkbox) {
          self.checkbox(actionObj.id, !actionObj.checked);
        }
        this.value = actionObj.id;
        actionObj.data.event = e;
        actionObj.execute([]);
      }
    }.bind(this, action);
    var widget = null;
    if (isToggleSwitch) {
      widget = loadWebComponent('et2-switch', {
        id: "".concat(this.id, "-").concat(action.id),
        label: action.caption,
        toggleOn: action.data.toggle_on,
        toggleOff: action.data.toggle_off,
        class: "et2_toolbar_draggable".concat(this.id)
      }, this);
      widget.style.backgroundImage = "url(".concat(action.iconUrl, ")");
      widget.value = action.checked;
      action.data.widget = widget;
      widget.onchange = actionHandler;
    } else {
      widget = loadWebComponent(egwIsMobile$1() && !this.preference[action.id] ? "et2-button-icon" : "et2-button", {
        id: "".concat(this.id, "-").concat(action.id),
        image: action.iconUrl || '',
        label: action.caption,
        slot: "buttons",
        class: "et2_toolbar_draggable".concat(this.id),
        readonly: false
      }, this);
      if (egwIsMobile$1() && !this.preference[action.id]) widget.name = '';
      if (isCheckbox) {
        widget.classList.add('toolbar_toggle');
        if (this.checkbox(action.id)) widget.classList.add('toolbar_toggled' + (typeof action.toggledClass != 'undefined' ? " " + action.toggledClass : ''));
      }
      widget.onclick = actionHandler;
    }
    jQuery(widget.getDOMNode()).appendTo(this.preference[action.id] ? this.actionbox.children()[1] : jQuery('[data-group=' + action.group + ']', this.actionlist));
    if (action.caption) {
      widget.statustext = action.caption;
      if ((this.countActions <= parseInt(this.view_range) || this.preference[action.id] || !action.iconUrl) && !(isCheckbox && isToggleSwitch))
        // no caption for slideswitch checkboxes
        {
          widget.classList.add(action.iconUrl ? 'et2_toolbar_hasCaption' : 'et2_toolbar_onlyCaption');
        }
    }
  }

  /**
   * Link the actions to the DOM nodes / widget bits.
   *
   * @param {Object} actions egw-actions to build menu from
   */
  _link_actions(actions) {
    this._build_menu(actions);
    var self = this;
    var gom = egw_getObjectManager(this.egw().app_name(), true, 1);
    if (this._objectManager == null) {
      this._objectManager = gom.addObject(new egwActionObjectManager(this.id, this._actionManager));
      this._objectManager.handleKeyPress = function (_keyCode, _shift, _ctrl, _alt) {
        for (var i = 0; i < self._actionManager.children.length; i++) {
          var action = self._actionManager.children[i];
          if (typeof action.shortcut === 'object' && action.shortcut && _keyCode == action.shortcut.keyCode && _ctrl == action.shortcut.ctrl && _alt == action.shortcut.alt && _shift == action.shortcut.shift) {
            self.value = action.id;
            action.execute([]);
            return true;
          }
        }
        return egwActionObject.prototype.handleKeyPress.call(this, _keyCode, _shift, _ctrl, _alt);
      };
      this._objectManager.parent.updateFocusedChild(this._objectManager, true);
    }
  }

  /**
   * Set/Get the checkbox toolbar action
   *
   * @param {string} _action action name of the selected toolbar
   * @param {boolean} _value value that needs to be set for the action true|false
   *	- if no value means checkbox value returns the current value
   *
   * @returns {boolean} returns boolean result of get checkbox value
   * or returns undefined as Set result or failure
   */
  checkbox(_action, _value) {
    if (!_action || typeof this._actionManager == 'undefined') return undefined;
    var action_event = this._actionManager.getActionById(_action);
    if (action_event && typeof _value != 'undefined') {
      action_event.set_checked(_value);
      var btn = jQuery('#' + this.dom_id + '-' + _action);
      if (action_event.data && action_event.data.widget) {
        action_event.data.widget.set_value(_value);
      } else if (btn.length > 0) {
        btn.toggleClass('toolbar_toggled' + (typeof action_event.data.toggledClass != 'undefined' ? " " + action_event.data.toggledClass : ''), _value);
      }
    } else if (action_event) {
      return action_event.checked;
    } else {
      return undefined;
    }
  }
  getDOMNode() {
    return this.div[0];
  }

  /**
   * getValue has to return the value of the input widget
   */
  getValue() {
    return this.value;
  }

  /**
   * Is dirty returns true if the value of the widget has changed since it
   * was loaded.  We don't consider toolbars as dirtyable
   */
  isDirty() {
    return false;
  }

  /**
   * Causes the dirty flag to be reseted.
   */
  resetDirty() {
    this.value = null;
  }

  /**
   * Checks the data to see if it is valid, as far as the client side can tell.
   * Return true if it's not possible to tell on the client side, because the server
   * will have the chance to validate also.
   *
   * The messages array is to be populated with everything wrong with the data,
   * so don't stop checking after the first problem unless it really makes sense
   * to ignore other problems.
   *
   * @param {String[]} messages List of messages explaining the failure(s).
   *	messages should be fairly short, and already translated.
   *
   * @return {boolean} True if the value is valid (enough), false to fail
   */
  isValid(messages) {
    return true;
  }

  /**
   * Attach the container node of the widget to DOM-Tree
   * @returns {Boolean}
   */
  doLoadingFinished() {
    super.doLoadingFinished();
    return false;
  }

  /**
   * Builds dialog for possible admin settings (e.g. default actions pref)
   *
   * @param {type} _actions
   * @param {object} _default_prefs
   */
  _admin_settings_dialog(_actions, _default_prefs) {
    var buttons = [{
      label: egw$1.lang("Save"),
      id: "save"
    }, {
      label: egw$1.lang("Close"),
      id: "close"
    }];
    var self = this;
    var sel_options = {
      actions: []
    };
    var content = {
      actions: [],
      reset: false
    };
    for (var key in _actions) {
      if (_actions[key]['children'] && this.options.flat_list) {
        for (var child in _actions[key]['children']) {
          sel_options.actions.push({
            id: child,
            value: child,
            label: _actions[key]['children'][child]['caption'],
            app: self.options.preference_app,
            icon: _actions[key]['children'][child]['iconUrl']
          });
        }
      } else {
        sel_options.actions.push({
          id: key,
          value: key,
          label: _actions[key]['caption'],
          app: self.options.preference_app,
          icon: _actions[key]['iconUrl']
        });
      }
      if ((!_default_prefs || _default_prefs.length == 0) && _actions[key]['toolbarDefault']) {
        content.actions.push(key);
      }
    }
    if (_default_prefs && _default_prefs.length > 0) {
      content.actions = _default_prefs;
    }
    var dialog = new Et2Dialog$1(this.egw());
    dialog.transformAttributes({
      callback: function callback(_button_id, _value) {
        if (_button_id == 'save' && _value) {
          if (_value.actions) {
            var pref = jQuery.extend({}, self.preference);
            for (var i in pref) {
              pref[i] = true;
              if (_value.actions.includes(i)) {
                pref[i] = false;
              }
            }
            _value.actions = pref;
          }
          egw$1.json('EGroupware\\Api\\Etemplate\\Widget\\Toolbar::ajax_setAdminSettings', [_value, self.options.preference_id, self.options.preference_app], function (_result) {
            egw$1.message(_result);
          }).sendRequest(true);
        }
      },
      title: egw$1.lang('admin settings for %1', this.options.preference_id),
      buttons: buttons,
      minWidth: 600,
      minHeight: 300,
      value: {
        content: content,
        sel_options: sel_options
      },
      template: egw$1.webserverUrl + '/api/templates/default/toolbarAdminSettings.xet?1',
      resizable: false
    });
    document.body.appendChild(dialog);
  }
}
_defineProperty$g(et2_toolbar, "_attributes", {
  "view_range": {
    "name": "View range",
    "type": "string",
    "default": "5",
    "description": "Define minimum action view range to show actions by both icons and caption"
  },
  "flat_list": {
    "name": "Flat list",
    "type": "boolean",
    "default": true,
    "description": "Define whether the actions with children should be shown as dropdown or flat list"
  },
  "list_header": {
    "name": "list header style",
    "type": "string",
    "default": "short",
    "description": "Define a style for list header (more ...), which can get short 3dots with no caption or bigger button with caption more ..."
  },
  "preference_id": {
    "name": "Preference id",
    "type": "string",
    "default": false,
    "description": "Define a custom preference id for saving the toolbar preferences." + "This is useful when you have the same toolbar and you use it in a pop up but also in a tab, which have different dom ids" + "When not set it defaults to the dom id of the form."
  },
  "preference_app": {
    "name": "Preference application",
    "type": "string",
    "default": false,
    "description": "Define a custom preference application for saving the toolbar preferences." + "This is useful when you have the same toolbar and you use it in a pop up but also in a tab, wich have different application names" + "When not set it defaults to the result of this.egw().app_name();"
  }
});
/**
 * Default buttons, so there is something for the widget browser / editor to show
 */
_defineProperty$g(et2_toolbar, "default_toolbar", {
  view: {
    caption: 'View',
    icons: {
      primary: 'ui-icon-check'
    },
    group: 1,
    toolbarDefault: true
  },
  edit: {
    caption: 'Edit',
    group: 1,
    toolbarDefault: true
  },
  save: {
    caption: 'Save',
    group: 2,
    toolbarDefault: true
  }
});
et2_register_widget(et2_toolbar, ["toolbar"]);

/**
 * EGroupware egw_dragdrop_dhtmlxmenu - egw action framework
 *
 * @link https://www.egroupware.org
 * @author Andreas Stöckel <as@stylite.de>
 * @copyright 2011 by Andreas Stöckel
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package egw_action
 */

/**
 * This file contains an egw_actionObjectInterface which allows a dhtmlx tree
 * row to be a drag target and contains a function which transforms a complete
 * dhtmlx tree into egw_actionObjects
 */

function dhtmlxTree_getNode(_tree, _itemId) {
  var node = _tree._globalIdStorageFind(_itemId);
  if (node != null) {
    // Get the outer html table node of the tree node - return the first
    // "tr" child of the element
    return node.htmlNode.querySelector("tr:first-child");
  }
}

// An action object interface for an dhtmlxTree entry - it only contains the
// code needed for drag/drop handling
class dhtmlxtreeItemAOI {
  constructor(_tree, _itemId) {
    var aoi = new egwActionObjectInterface();

    // Retrieve the actual node from the tree
    aoi.node = dhtmlxTree_getNode(_tree, _itemId);
    aoi.id = _itemId;
    aoi.doGetDOMNode = function () {
      return aoi.node;
    };
    aoi.doTriggerEvent = function (_event) {
      if (_event == EGW_AI_DRAG_OVER) {
        jQuery(this.node).addClass("draggedOver");
      }
      if (_event == EGW_AI_DRAG_OUT) {
        jQuery(this.node).removeClass("draggedOver");
      }
    };
    aoi.doSetState = function (_state) {
      if (!_tree || !_tree.focusItem) return;

      // Update the "focused" flag
      if (egwBitIsSet(_state, EGW_AO_STATE_FOCUSED)) {
        _tree.focusItem(this.id);
      }
      if (egwBitIsSet(_state, EGW_AO_STATE_SELECTED)) {
        _tree.selectItem(this.id, false); // false = do not trigger onSelect
      }
    };

    return aoi;
  }
}

function _defineProperty$f(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* no module, but egw:uses is ignored, so adding it here commented out
import '../../../api/js/dhtmlxtree/sources/dhtmlxtree.js';
import '../../../api/js/dhtmlxtree/sources/ext/dhtmlxtree_json.js';
import '../../../api/js/dhtmlxtree/sources/ext/dhtmlxtree_start.js';
 */

/**
 * Tree widget
 *
 * For syntax of nodes supplied via sel_options or autoloading refer to Etemplate\Widget\Tree class.
 *
 * @augments et2_inputWidget
 */
class et2_tree extends et2_inputWidget {
  /**
   * Constructor
   *
   * @memberOf et2_tree
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_tree._attributes, _child || {}));
    _defineProperty$f(this, "input", null);
    _defineProperty$f(this, "div", void 0);
    _defineProperty$f(this, "autoloading_url", void 0);
    /**
     * Regexp used by _htmlencode
     */
    _defineProperty$f(this, "_lt_regexp", /</g);
    this.input = null;
    this.div = jQuery(document.createElement("div")).addClass("dhtmlxTree");
    this.setDOMNode(this.div[0]);
  }
  destroy() {
    if (this.input) {
      this.input.destructor();
    }
    this.input = null;
    super.destroy();
  }

  /**
   * Get tree items from the sel_options data array
   *
   * @param {object} _attrs
   */
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);

    // If select_options are already known, skip the rest
    if (this.options && this.options.select_options && !jQuery.isEmptyObject(this.options.select_options)) {
      return;
    }
    var name_parts = this.id.replace(/]/g, '').split('[');

    // Try to find the options inside the "sel-options" array
    if (this.getArrayMgr("sel_options")) {
      // Select options tend to be defined once, at the top level, so try that first
      var content_options = this.getArrayMgr("sel_options").getRoot().getEntry(name_parts[name_parts.length - 1]);

      // Try again according to ID
      if (!content_options) content_options = this.getArrayMgr("sel_options").getEntry(this.id);
      if (_attrs["select_options"] && !jQuery.isEmptyObject(_attrs["select_options"]) && content_options) {
        _attrs["select_options"] = jQuery.extend({}, _attrs["select_options"], content_options);
      } else if (content_options) {
        _attrs["select_options"] = content_options;
      }
    }

    // Check whether the options entry was found, if not read it from the
    // content array.
    if (_attrs["select_options"] == null) {
      // Again, try last name part at top level
      var _content_options = this.getArrayMgr('content').getRoot().getEntry(name_parts[name_parts.length - 1]);
      // If that didn't work, check according to ID
      _attrs["select_options"] = _content_options ? _content_options : this.getArrayMgr('content').getEntry("options-" + this.id);
    }

    // Default to an empty object
    if (_attrs["select_options"] == null) {
      _attrs["select_options"] = {};
    }
  }

  // overwrite default onclick to do nothing, as we install onclick via dhtmlxtree
  click(_node) {}
  createTree(widget) {
    widget.input = new dhtmlXTreeObject({
      parent: widget.div[0],
      width: '100%',
      height: '100%',
      image_path: widget.options.image_path,
      checkbox: widget.options.multiple
    });
    // Allow controlling icon size by CSS
    widget.input.def_img_x = "";
    widget.input.def_img_y = "";

    // to allow "," in value, eg. folder-names, IF value is specified as array
    widget.input.dlmtr = ':}-*(';
    if (widget.options.std_images) {
      widget.setImages.apply(widget, widget.options.std_images.split(','));
    } else {
      // calling setImages to get our png or svg default images
      widget.setImages();
    }
    // Add in the callback so we can keep the two in sync
    widget.input.AJAX_callback = function (dxmlObject) {
      widget._dhtmlxtree_json_callback(JSON.parse(dxmlObject.xmlDoc.responseText), widget.input.lastLoadedXMLId);
      // Call this in case we added some options that were already selected, but missing
      if (widget.options.multiple) {
        widget.set_value(widget.value);
      }
    };
    if (widget.options.autoloading) {
      var url = widget.options.autoloading;

      //Set escaping mode to utf8, as url in
      //autoloading needs to be utf8 encoded.
      //For instance item id with umlaut.
      widget.input.setEscapingMode('utf8');
      if (url.charAt(0) != '/' && url.substr(0, 4) != 'http') {
        url = '/json.php?menuaction=' + url;
      }
      this.autoloading_url = url;
      widget.input.setXMLAutoLoading(egw$1.link(url));
      widget.input.setDataMode('JSON');
    }
    if (widget.options.multimarking) {
      widget.input.enableMultiselection(!!widget.options.multimarking, widget.options.multimarking === 'strict');
    }
    // Enable/Disable highlighting
    widget.input.enableHighlighting(!!widget.options.highlighting);

    // if templates supplies open/close right/down arrows, show no more lines and use them instead of plus/minus
    var open = egw$1.image('dhtmlxtree/open');
    var close = egw$1.image('dhtmlxtree/close');
    if (open && close) {
      widget.input.enableTreeLines(false);
      open = this._rel_url(open);
      widget.input.setImageArrays('plus', open, open, open, open, open);
      close = this._rel_url(close);
      widget.input.setImageArrays('minus', close, close, close, close, close);
    }
    this._install_handler('onBeforeCheck', function () {
      return !this.options.readonly;
    }.bind(this));
  }

  /**
   * Install event handlers on tree
   *
   * @param _name
   * @param _handler
   */
  _install_handler(_name, _handler) {
    if (typeof _handler == 'function') {
      if (this.input == null) this.createTree(this);
      // automatic convert onChange event to oncheck or onSelect depending on multiple is used or not
      if (_name == 'onchange') _name = this.options.multiple ? 'oncheck' : 'onselect';
      var handler = _handler;
      var widget = this;
      this.input.attachEvent(_name, function (_id) {
        var args = jQuery.makeArray(arguments);
        // splice in widget as 2. parameter, 1. is new node-id, now 3. is old node id
        args.splice(1, 0, widget);
        // try to close mobile sidemenu after clicking on node
        if (egwIsMobile$1() && typeof args[2] == 'string') framework.toggleMenu('on');
        return handler.apply(this, args);
      });
    }
  }
  set_onchange(_handler) {
    this._install_handler('onchange', _handler);
  }
  set_onclick(_handler) {
    this._install_handler('onclick', _handler);
  }
  set_onselect(_handler) {
    this._install_handler('onselect', _handler);
  }
  set_onopenstart(_handler) {
    this._install_handler('onOpenStart', _handler);
  }
  set_onopenend(_handler) {
    this._install_handler('onOpenEnd', _handler);
  }
  set_select_options(options) {
    var custom_images = false;
    this.options.select_options = options;
    if (this.input == null) {
      this.createTree(this);
    }

    // Structure data for category tree
    if (this.getType() == 'tree-cat') {
      var data = {
        id: 0,
        item: []
      };
      var stack = {};
      for (var key = 0; key < options.length; key++) {
        // See if item has an icon
        if (options[key].data && typeof options[key].data.icon !== 'undefined' && options[key].data.icon) {
          var img = this.egw().image(options[key].data.icon, options[key].appname);
          if (img) {
            custom_images = true;
            options[key].im0 = options[key].im1 = options[key].im2 = img;
          }
        }
        // Item color - not working
        if (options[key].data && typeof options[key].data.color !== 'undefined' && options[key].data.color) {
          options[key].style = options[key].style || "" + "background-color:'" + options[key].data.color + "';";
        }

        // Tooltip
        if (options[key].description && !options[key].tooltip) {
          options[key].tooltip = options[key].description;
        }
        var parent_id = parseInt(options[key]['parent']);
        if (isNaN(parent_id)) parent_id = 0;
        if (!stack[parent_id]) stack[parent_id] = [];
        stack[parent_id].push(options[key]);
      }
      if (custom_images) {
        var path = this.input.iconURL;
        this.input.setIconPath("");
        for (var k = 0; k < this.input.imageArray.length; k++) this.input.imageArray[k] = path + this.input.imageArray[k];
      }
      var f = function f(data, _f) {
        if (stack[data.id]) {
          data.item = stack[data.id];
          for (var j = 0; j < data.item.length; j++) {
            f(data.item[j], _f);
          }
        }
      };
      f(data, f);
      options = data;
    }
    this.input.deleteChildItems("0");
    // if no options given, but autoloading url, use that to load initial nodes
    if (typeof options.id == 'undefined' && this.input.XMLsource) this.input.loadJSON(this.input.XMLsource);else this.input.loadJSONObject(this._htmlencode_node(options));
  }

  /**
   * html encoding of text of node
   *
   * We only do a minimal html encoding by replacing opening bracket < with &lt;
   * as tree seems not to need more and we dont want to waste time.
   *
   * @param {string} _text text to encode
   * @return {string}
   */
  _htmlencode(_text) {
    if (_text && _text.indexOf('<') >= 0) {
      _text = _text.replace(this._lt_regexp, '&lt;');
    }
    return _text;
  }

  /**
   * html encoding of text of node incl. all children
   *
   * @param {object} _item with required attributes text, id and optional tooltip and item
   * @return {object} encoded node
   */
  _htmlencode_node(_item) {
    _item.text = this._htmlencode(_item.text);
    if (_item.item && jQuery.isArray(_item.item)) {
      for (var i = 0; i < _item.item.length; ++i) {
        this._htmlencode_node(_item.item[i]);
      }
    }
    return _item;
  }
  set_value(new_value) {
    this.value = this._oldValue = typeof new_value === 'string' && this.options.multiple ? new_value.split(',') : new_value;
    if (this.input == null) return;
    if (this.options.multiple) {
      // Clear all checked
      var checked = this.input.getAllChecked().split(this.input.dlmtr);
      for (var i = 0; i < checked.length; i++) {
        this.input.setCheck(checked[i], false);
      }

      // Check selected
      for (var _i = 0; _i < this.value.length; _i++) {
        this.input.setCheck(this.value[_i], true);
        // autoloading openning needs to be absolutely based on user interaction
        // or open flag in folder structure, therefore, We should
        // not force it to open the node
        if (!this.options.autoloading) this.input.openItem(this.value[_i]);
      }
    } else {
      this.input.selectItem(this.value, false); // false = do not trigger onSelect
      this.input.focusItem(this.value);
      this.input.openItem(this.value);
    }
  }

  /**
   * Links actions to tree nodes
   *
   * @param {object} actions [ {ID: attributes..}+] as for set_actions
   */
  _link_actions(actions) {
    // Get the top level element for the tree
    // Only look 1 level deep for application object manager
    var objectManager = egw_getObjectManager(this.egw().app_name(), true, 1);
    var treeObj = objectManager.getObjectById(this.id);
    if (treeObj == null) {
      // Add a new container to the object manager which will hold the tree
      // objects
      treeObj = objectManager.addObject(new egwActionObject(this.id, objectManager, null, this._actionManager, EGW_AO_FLAG_IS_CONTAINER), null, EGW_AO_FLAG_IS_CONTAINER);
    }

    // Delete all old objects
    treeObj.clear();

    // Go over the tree parts & add links
    var action_links = this._get_action_links(actions);
    if (typeof this.options.select_options != 'undefined') {
      // Iterate over the options (leaves) and add action to each one
      var apply_actions = function apply_actions(treeObj, option) {
        // Add a new action object to the object manager
        // @ts-ignore
        var obj = treeObj.addObject(typeof option.id == 'number' ? String(option.id) : option.id, new dhtmlxtreeItemAOI(this.input, option.id));
        obj.updateActionLinks(action_links);
        if (option.item && option.item.length > 0) {
          for (var i = 0; i < option.item.length; i++) {
            apply_actions.call(this, treeObj, option.item[i]);
          }
        }
      };
      apply_actions.call(this, treeObj, this.options.select_options);
    }
  }

  /**
   * getValue, retrieves the Id of the selected Item
   * @return string or object or null
   */
  getValue() {
    if (this.input == null) return null;
    if (this.options.multiple) {
      var allChecked = this.input.getAllChecked().split(this.input.dlmtr);
      var allUnchecked = this.input.getAllUnchecked().split(this.input.dlmtr);
      if (this.options.autoloading) {
        var res = {};
        for (var i = 0; i < allChecked.length; i++) {
          res[allChecked[i]] = {
            value: true
          };
        }
        for (var _i2 = 0; _i2 < allUnchecked.length; _i2++) {
          res[allUnchecked[_i2]] = {
            value: false
          };
        }
        return res;
      } else {
        return allChecked;
      }
    }
    return this.input.getSelectedItemId();
  }

  /**
   * getSelectedLabel, retrieves the Label of the selected Item
   * @return string or null
   */
  getSelectedLabel() {
    if (this.input == null) return null;
    if (this.options.multiple) {
      /*
      var out = [];
      var checked = this.input.getAllChecked().split(this.input.dlmtr);
      for(var i = 0; i < checked.length; i++)
      {
      	out.push(this.input.getItemText(checked[i]));
      }
      return out;
      */
      return null; // not supported yet
    } else {
      return this.input.getSelectedItemText();
    }
  }

  /**
   * renameItem, renames an item by id
   *
   * @param {string} _id ID of the node
   * @param {string} _newItemId ID of the node
   * @param {string} _label label to set
   */
  renameItem(_id, _newItemId, _label) {
    if (this.input == null) return null;
    this.input.changeItemId(_id, _newItemId);

    // Update action
    // since the action ID has to = this.id, getObjectById() won't work
    var treeObj = egw_getAppObjectManager().getObjectById(this.id);
    for (var i = 0; i < treeObj.children.length; i++) {
      if (treeObj.children[i].id == _id) {
        treeObj.children[i].id = _newItemId;
        if (treeObj.children[i].iface) treeObj.children[i].iface.id = _newItemId;
        break;
      }
    }
    if (typeof _label != 'undefined') this.setLabel(_newItemId, _label);
  }

  /**
   * deleteItem, deletes an item by id
   * @param _id ID of the node
   * @param _selectParent select the parent node true/false
   * @return void
   */
  deleteItem(_id, _selectParent) {
    if (this.input == null) return null;
    this.input.deleteItem(_id, _selectParent);
    // Update action
    // since the action ID has to = this.id, getObjectById() won't work
    var treeObj = egw_getAppObjectManager().getObjectById(this.id);
    for (var i = 0; i < treeObj.children.length; i++) {
      if (treeObj.children[i].id == _id) {
        treeObj.children.splice(i, 1);
      }
    }
  }

  /**
   * Updates a leaf of the tree by requesting new information from the server using the
   * autoloading attribute.
   *
   * @param {string} _id ID of the node
   * @param {Object} [data] If provided, the item is refreshed directly  with
   *	the provided data instead of asking the server
   * @return void
   */
  refreshItem(_id, data) {
    if (this.input == null) return null;
    this.input.deleteChildItems(_id);
    this.input.setDataMode('JSON');

    /* Can't use this, it doesn't allow a callback
    this.input.refreshItem(_id);
    */

    var self = this;
    if (typeof data != 'undefined' && data != null) {
      this.input.loadJSONObject(data, function () {
        self._dhtmlxtree_json_callback(data, _id);
      });
    } else {
      this.input.loadJSON(this.egw().link(this.autoloading_url, {
        id: _id
      }), function (dxmlObject) {
        self._dhtmlxtree_json_callback(JSON.parse(dxmlObject.xmlDoc.responseText), _id);

        // refreshing root node causes binding actions fails in dhtmlx tree, we try to refresh the opened node
        // in order to rebind the actions again.
        if (_id == 0) {
          var openedId = self._oldValue.split("::")[0];
          var interval = setInterval(() => {
            if (self.input.getOpenState(openedId)) {
              clearInterval(interval);
              self.refreshItem(openedId);
            }
          }, 100);
        }
      });
    }
  }

  /**
   * focus the item, and scrolls it into view
   *
   * @param _id ID of the node
   * @return void
   */
  focusItem(_id) {
    if (this.input == null) return null;
    this.input.focusItem(_id);
  }

  /**
   * hasChildren
   *
   * @param _id ID of the node
   * @return the number of childelements
   */
  hasChildren(_id) {
    if (this.input == null) return null;
    return this.input.hasChildren(_id);
  }

  /**
   * Callback for after using dhtmlxtree's AJAX loading
   * The tree has visually already been updated at this point, we just need
   * to update the internal data.
   *
   * @param {object} new_data Fresh data for the tree
   * @param {string} update_option_id optional If provided, only update that node (and children) with the
   *	provided data instead of the whole thing.  Allows for partial updates.
   * @return void
   */
  _dhtmlxtree_json_callback(new_data, update_option_id) {
    // not sure if it makes sense to try update_option_id, so far I only seen it to be -1
    var parent_id = typeof update_option_id != 'undefined' && update_option_id != -1 ? update_option_id : new_data.id;
    // find root of loaded data to merge it there
    var option = this._find_in_item(parent_id, this.options.select_options);
    // if we found it, merge it
    if (option) {
      jQuery.extend(option, new_data || {});
    } else
      // else store it in root
      {
        this.options.select_options = new_data;
      }
    // Update actions by just re-setting them
    this.set_actions(this.options.actions || {});
  }

  /**
   * Recursive search item object for given id
   *
   * @param {string} _id
   * @param {object} _item
   * @returns
   */
  _find_in_item(_id, _item) {
    if (_item && _item.id == _id) {
      return _item;
    }
    if (_item && typeof _item.item != 'undefined') {
      for (var i = 0; i < _item.item.length; ++i) {
        var found = this._find_in_item(_id, _item.item[i]);
        if (found) return found;
      }
    }
    return null;
  }

  /**
   * Get node data by id
   *
   * @param {string} _id id of node
   * @return {object} object with attributes id, im0-2, text, tooltip, ... as set via select_options or autoload url
   */
  getNode(_id) {
    return this._find_in_item(_id, this.options.select_options);
  }

  /**
   * Sets label of an item by id
   *
   * @param _id ID of the node
   * @param _label label to set
   * @param _tooltip new tooltip, default is previous set tooltip
   * @return void
   */
  setLabel(_id, _label, _tooltip) {
    if (this.input == null) return null;
    var tooltip = _tooltip || (this.getNode(_id) && this.getNode(_id).tooltip ? this.getNode(_id).tooltip : "");
    this.input.setItemText(_id, this._htmlencode(_label), tooltip);
  }

  /**
   * Sets a style for an item by id
   *
   * @param {string} _id ID of node
   * @param {string} _style style to set
   * @return void
   */
  setStyle(_id, _style) {
    if (this.input == null) return null;
    this.input.setItemStyle(_id, _style);
  }

  /**
   * getLabel, gets the Label of of an item by id
   * @param _id ID of the node
   * @return _label
   */
  getLabel(_id) {
    if (this.input == null) return null;
    return this.input.getItemText(_id);
  }

  /**
   * getSelectedNode, retrieves the full node of the selected Item
   * @return string or null
   */
  getSelectedNode() {
    if (this.input == null) return null;
    // no support for multiple selections
    // as there is no get Method to return the full selected node, we use this
    return this.options.multiple ? null : this.input._selected[0];
  }

  /**
   * getTreeNodeOpenItems
   *
   * @param {string} _nodeID the nodeID where to start from (initial node)
   * @param {string} mode the mode to run in: "forced" fakes the initial node openState to be open
   * @return {object} structured array of node ids: array(message-ids)
   */
  getTreeNodeOpenItems(_nodeID, mode) {
    if (this.input == null) return null;
    var z = this.input.getSubItems(_nodeID).split(this.input.dlmtr);
    var oS;
    var PoS;
    var rv;
    var returnValue = [_nodeID];
    var modetorun = "none";
    if (mode) {
      modetorun = mode;
    }
    PoS = this.input.getOpenState(_nodeID);
    if (modetorun == "forced") PoS = 1;
    if (PoS == 1) {
      for (var i = 0; i < z.length; i++) {
        oS = this.input.getOpenState(z[i]);
        //alert(z[i]+' OpenState:'+oS);
        if (oS == -1) {
          returnValue.push(z[i]);
        }
        if (oS == 0) {
          returnValue.push(z[i]);
        }
        if (oS == 1) {
          //alert("got here")
          rv = this.getTreeNodeOpenItems(z[i]);
          //returnValue.concat(rv); // not working as expected; the following does
          for (var j = 0; j < rv.length; j++) {
            returnValue.push(rv[j]);
          }
        }
      }
    }
    //alert(returnValue.join('#,#'));
    return returnValue;
  }

  /**
   * Fetch user-data stored in specified node under given name
   *
   * User-data need to be stored in json as follows:
   *
   * {"id": "node-id", "im0": ..., "userdata": [{"name": "user-name", "content": "user-value"},...]}
   *
   * In above example getUserData("node-id", "user-name") will return "user-value"
   *
   * @param _nodeId
   * @param _name
   * @returns
   */
  getUserData(_nodeId, _name) {
    if (this.input == null) return null;
    return this.input.getUserData(_nodeId, _name);
  }

  /**
   * Stores / updates user-data in specified node and name
   *
   * @param _nodeId
   * @param _name
   * @param _value
   * @returns
   */
  setUserData(_nodeId, _name, _value) {
    if (this.input == null) return null;
    return this.input.setUserData(_nodeId, _name, _value);
  }

  /**
   * Query nodes open state and optinal change it
   *
   * @param _id node-id
   * @param _open specify to change true: open, false: close, everything else toggle
   * @returns true if open, false if closed
   */
  openItem(_id, _open) {
    if (this.input == null) return null;
    var is_open = this.input.getOpenState(_id) == 1;
    if (typeof _open != 'undefined' && is_open !== _open) {
      if (is_open) {
        this.input.closeItem(_id);
      } else {
        this.input.openItem(_id);
      }
    }
    return is_open;
  }

  /**
   * reSelectItem, reselects an item by id
   * @param _id ID of the node
   */
  reSelectItem(_id) {
    if (this.input == null) return null;
    this.input.selectItem(_id, false, false);
  }

  /**
   * Set images for a specific node or all new nodes (default)
   *
   * If images contain an extension eg. "leaf" they are asumed to be in image path (/phpgwapi/templates/default/images/dhtmlxtree/).
   * Otherwise they get searched via egw.image() in current app, phpgwapi or can be specified as "app/image".
   *
   * @param {string} _leaf leaf image, default "leaf"
   * @param {string} _closed closed folder image, default "folderClosed"
   * @param {string} _open opened folder image, default "folderOpen"
   * @param {string} _id if not given, standard images for new nodes are set
   */
  setImages(_leaf, _closed, _open, _id) {
    // NOTE: The image order for open/closed as documented in dhtmltree is backwards
    var images = [_leaf || 'dhtmlxtree/leaf', _open || 'dhtmlxtree/folderOpen', _closed || 'dhtmlxtree/folderClosed'];
    var image_extensions = /\.(gif|png|jpe?g|svg)/i;
    for (var i = 0; i < 3; ++i) {
      var image = images[i];
      if (!image.match(image_extensions)) {
        images[i] = this._rel_url(this.egw().image(image) || image);
      }
    }
    if (typeof _id == 'undefined') {
      this.input.setStdImages.apply(this.input, images);
    } else {
      images.unshift(_id);
      this.input.setItemImage2.apply(this.input, images);
    }
  }

  /**
   * Set state of node incl. it's children
   *
   * @param {string} _id id of node
   * @param {boolean|string} _state or "toggle" to toggle state
   */
  setSubChecked(_id, _state) {
    if (_state === "toggle") _state = !this.input.isItemChecked(_id);
    this.input.setSubChecked(_id, _state);
  }

  /**
   * Get URL relative to image_path option
   *
   * Both URL start with EGroupware webserverUrl and image_path gets allways appended to images by tree.
   *
   * @param {string} _url
   * @return {string} relativ url
   */
  _rel_url(_url) {
    var path_parts = this.options.image_path.split(this.egw().webserverUrl);
    path_parts = path_parts[1].split('/');
    var url_parts = _url.split(this.egw().webserverUrl);
    url_parts = url_parts[1].split('/');
    for (var i = 0; i < path_parts.length; ++i) {
      if (path_parts[i] != url_parts[i]) {
        while (++i < path_parts.length) url_parts.unshift('..');
        break;
      }
      url_parts.shift();
    }
    return url_parts.join('/');
  }
}
_defineProperty$f(et2_tree, "_attributes", {
  "multiple": {
    "name": "multiple",
    "type": "boolean",
    "default": false,
    "description": "Allow selecting multiple options"
  },
  "select_options": {
    "type": "any",
    "name": "Select options",
    "default": {},
    "description": "Used to set the tree options."
  },
  "onclick": {
    "description": "JS code which gets executed when clicks on text of a node"
  },
  "onselect": {
    "name": "onSelect",
    "type": "js",
    "default": et2_no_init,
    "description": "Javascript executed when user selects a node"
  },
  "oncheck": {
    "name": "onCheck",
    "type": "js",
    "default": et2_no_init,
    "description": "Javascript executed when user checks a node"
  },
  // onChange event is mapped depending on multiple to onCheck or onSelect
  onopenstart: {
    "name": "onOpenStart",
    "type": "js",
    "default": et2_no_init,
    "description": "Javascript function executed when user opens a node: function(_id, _widget, _hasChildren) returning true to allow opening!"
  },
  onopenend: {
    "name": "onOpenEnd",
    "type": "js",
    "default": et2_no_init,
    "description": "Javascript function executed when opening a node is finished: function(_id, _widget, _hasChildren)"
  },
  "image_path": {
    "name": "Image directory",
    "type": "string",
    "default": egw$1().webserverUrl + "/api/templates/default/images/dhtmlxtree/",
    "description": "Directory for tree structure images, set on server-side to 'dhtmlx' subdir of templates image-directory"
  },
  "value": {
    "type": "any",
    "default": {}
  },
  "actions": {
    "name": "Actions array",
    "type": "any",
    "default": et2_no_init,
    "description": "List of egw actions that can be done on the tree.  This includes context menu, drag and drop.  TODO: Link to action documentation"
  },
  "autoloading": {
    "name": "Autoloading",
    "type": "string",
    "default": "",
    "description": "JSON URL or menuaction to be called for nodes marked with child=1, but not having children, GET parameter selected contains node-id"
  },
  "std_images": {
    "name": "Standard images",
    "type": "string",
    "default": "",
    "description": "comma-separated names of icons for a leaf, closed and opend folder (default: leaf.png,folderClosed.png,folderOpen.png), images with extension get loaded from image_path, just 'image' or 'appname/image' are allowed too"
  },
  "multimarking": {
    "name": "multimarking",
    "type": "any",
    "default": false,
    "description": "Allow marking multiple nodes, default is false which means disabled multiselection, true or 'strict' activates it and 'strict' makes it strick to only same level marking"
  },
  highlighting: {
    "name": "highlighting",
    "type": "boolean",
    "default": false,
    "description": "Add highlighting class on hovered over item, highlighting is disabled by default"
  }
});
et2_register_widget(et2_tree, ["tree", "tree-cat"]);

function _defineProperty$e(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * eTemplate history log widget displays a list of changes to the current record.
 * The widget is encapsulated, and only needs the record's ID, and a map of
 * fields:widgets for display.
 *
 * It defers its initialization until the tab that it's on is selected, to avoid
 * wasting time if the user never looks at it.
 *
 * @augments et2_valueWidget
 */
class et2_historylog extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_historylog
   */
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_historylog._attributes, _child || {}));
    _defineProperty$e(this, "div", void 0);
    _defineProperty$e(this, "innerDiv", void 0);
    _defineProperty$e(this, "_filters", void 0);
    _defineProperty$e(this, "dataview", void 0);
    _defineProperty$e(this, "controller", void 0);
    _defineProperty$e(this, "fields", void 0);
    _defineProperty$e(this, "diff", void 0);
    this.div = jQuery(document.createElement("div")).addClass("et2_historylog");
    this.innerDiv = jQuery(document.createElement("div")).appendTo(this.div);
    this._resize = this._resize.bind(this);
  }
  set_status_id(_new_id) {
    this.options.status_id = _new_id;
  }
  doLoadingFinished() {
    super.doLoadingFinished();

    // Find the tab
    var tab = this.get_tab_info();
    if (tab) {
      // Bind the action to when the tab is selected
      var handler = e => {
        if (typeof this.dataview == "undefined") {
          this.finishInit();
        }
        // TODO: Find a better way to get this to wait
        window.setTimeout(this._resize, 10);
      };
      tab.flagDiv.addEventListener("click", handler);
    } else {
      this.finishInit();
    }
    return true;
  }
  _createNamespace() {
    return true;
  }
  /**
   * Finish initialization which was skipped until tab was selected
   */
  finishInit() {
    // No point with no ID
    if (!this.options.value || !this.options.value.id) {
      return;
    }
    this._filters = {
      record_id: this.options.value.id,
      appname: this.options.value.app,
      get_rows: this.options.get_rows
    };

    // Warn if status_id is the same as history id, that causes overlap and missing labels
    if (this.options.status_id === this.id) {
      this.egw().debug("warn", "status_id attribute should not be the same as historylog ID");
    }
    var parent = this.get_tab_info();

    // Create the outer grid container
    this.dataview = new et2_dataview(this.innerDiv, this.egw());
    var dataview_columns = [];
    var _columns = typeof this.options.columns === "string" ? this.options.columns.split(',') : this.options.columns;
    for (var i = 0; i < et2_historylog.columns.length; i++) {
      dataview_columns[i] = {
        "id": et2_historylog.columns[i].id,
        "caption": et2_historylog.columns[i].caption,
        "width": et2_historylog.columns[i].width,
        "visibility": _columns.indexOf(et2_historylog.columns[i].id) < 0 ? et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE : et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE
      };
    }
    this.dataview.setColumns(dataview_columns);

    // Create widgets for columns that stay the same, and set up varying widgets
    this.createWidgets();

    // Create the gridview controller
    var linkCallback = function linkCallback() {};
    this.controller = new et2_dataview_controller(null, this.dataview.grid);
    this.controller.setContext(this);
    this.controller.setDataProvider(this);
    this.controller.setLinkCallback(linkCallback);
    this.controller.setRowCallback(this.rowCallback);
    this.controller.setActionObjectManager(null);
    var total = typeof this.options.value.total !== "undefined" ? this.options.value.total : 0;

    // This triggers an invalidate, which updates the grid
    this.dataview.grid.setTotalCount(total);

    // Insert any data sent from server, so invalidate finds data already
    if (this.options.value.rows && this.options.value.num_rows) {
      this.controller.loadInitialData(this.options.value.dataStorePrefix, this.options.value.row_id, this.options.value.rows);
      // Remove, to prevent duplication
      delete this.options.value.rows;
      // This triggers an invalidate, which updates the grid
      this.dataview.grid.setTotalCount(total);
    } else {
      // Trigger the initial update
      this.controller.update();
    }

    // Write something inside the column headers
    for (var i = 0; i < et2_historylog.columns.length; i++) {
      jQuery(this.dataview.getHeaderContainerNode(i)).text(et2_historylog.columns[i].caption);
    }

    // Register a resize callback
    jQuery(window).on('resize.' + this.options.value.app + this.options.value.id, function () {
      this.dataview.resize();
    }.bind(this));
  }

  /**
   * Destroys all
   */
  destroy() {
    // Unbind, if bound
    if (this.options.value && !this.options.value.id) {
      jQuery(window).off('.' + this.options.value.app + this.options.value.id);
    }

    // Free the widgets
    for (var i = 0; i < et2_historylog.columns.length; i++) {
      if (et2_historylog.columns[i].widget) et2_historylog.columns[i].widget.destroy();
    }
    for (var key in this.fields) {
      this.fields[key].widget.destroy();
    }

    // Free the grid components
    if (this.dataview) this.dataview.destroy();
    if (this.controller) this.controller.destroy();
    super.destroy();
  }

  /**
   * Create all needed widgets for new / old values
   */
  createWidgets() {
    var _this = this;
    // Constant widgets - first 3 columns
    for (var _i = 0; _i < et2_historylog.columns.length; _i++) {
      var column = et2_historylog.columns[_i];
      if (column.widget_type) {
        // Status ID is allowed to be remapped to something else.  Only affects the widget ID though
        var attrs = {
          'readonly': true,
          'id': _i == et2_historylog.FIELD ? this.options.status_id : column.id
        };
        column.widget = loadWebComponent(column.widget_type, attrs, this);
        column.nodes = jQuery(column.widget.getDetachedNodes());
      }
    }

    // Add in handling for links
    if (typeof this.options.value['status-widgets']['~link~'] == 'undefined') {
      et2_historylog.columns[et2_historylog.FIELD].widget.select_options.push({
        value: '~link~',
        label: this.egw().lang('link')
      });
      this.options.value['status-widgets']['~link~'] = 'link';
    }

    // Add in handling for files
    if (typeof this.options.value['status-widgets']['~file~'] == 'undefined') {
      et2_historylog.columns[et2_historylog.FIELD].widget.select_options.push({
        value: '~file~',
        label: this.egw().lang('File')
      });
      this.options.value['status-widgets']['~file~'] = 'vfs';
    }

    // Add in handling for user-agent & action
    if (typeof this.options.value['status-widgets']['user_agent_action'] == 'undefined') {
      et2_historylog.columns[et2_historylog.FIELD].widget.select_options.push({
        value: 'user_agent_action',
        label: this.egw().lang('User-agent & action')
      });
    }

    // Per-field widgets - new value & old value
    this.fields = {};
    var labels = et2_historylog.columns[et2_historylog.FIELD].widget.select_options;

    // Custom fields - Need to create one that's all read-only for proper display
    var cf_widget = et2_createWidget('customfields', {
      'readonly': true
    }, this);
    cf_widget.loadFields();
    // Override this or it may damage the real values
    cf_widget.getValue = function () {
      return null;
    };
    var _loop = function _loop(_key) {
        // Add label
        var option = labels.find(option => option.value == et2_customfields_list.PREFIX + _key);
        if (option && !option.label) {
          option.label = cf_widget.options.customfields[_key].label;
        } else {
          labels.push({
            value: et2_customfields_list.PREFIX + _key,
            label: cf_widget.options.customfields[_key].label
          });
        }

        // If it doesn't support detached nodes, just treat it as text
        if (cf_widget.widgets[_key].getDetachedNodes) {
          nodes = cf_widget.widgets[_key].getDetachedNodes();
          for (i = 0; i < nodes.length; i++) {
            if (nodes[i] == null) {
              nodes.splice(i, 1);
            }
          }

          // Save to use for each row
          _this.fields[et2_customfields_list.PREFIX + _key] = {
            attrs: cf_widget.widgets[_key].options,
            widget: cf_widget.widgets[_key],
            nodes: jQuery(nodes)
          };
        }
      },
      nodes,
      i;
    for (var _key in cf_widget.widgets) {
      _loop(_key);
    }

    // Add all cf labels
    et2_historylog.columns[et2_historylog.FIELD].widget.set_select_options(labels);

    // From app
    for (var key in this.options.value['status-widgets']) {
      var _attrs2 = jQuery.extend({
        'readonly': true,
        'id': key
      }, this.getArrayMgr('modifications').getEntry(key));
      var field = _attrs2.type || this.options.value['status-widgets'][key];
      var options = null;
      var widget = this._create_widget(key, field, _attrs2, options);
      if (widget === null) {
        continue;
      }
      if (widget.instanceOf(et2_selectbox)) widget.options.multiple = true;
      widget.transformAttributes(_attrs2);

      // Save to use for each row
      var _nodes = widget._children.length ? [] : jQuery(widget.getDetachedNodes());
      for (var _i2 = 0; _i2 < widget._children.length; _i2++) {
        // @ts-ignore
        _nodes.push(jQuery(widget._children[_i2].getDetachedNodes()));
      }
      this.fields[key] = {
        attrs: _attrs2,
        widget: widget,
        nodes: _nodes
      };
    }
    // Widget for text diffs
    var diff = et2_createWidget('diff', {}, this);
    this.diff = {
      // @ts-ignore
      widget: diff,
      nodes: jQuery(diff.getDetachedNodes())
    };
  }
  _create_widget(key, field, attrs, options) {
    var widget = null;

    // If field has multiple parts (is object) and isn't an obvious select box
    if (typeof field === 'object') {
      // Check for multi-part statuses needing multiple widgets
      var need_box = false; //!this.getArrayMgr('sel_options').getEntry(key);
      for (var j in field) {
        // Require widget to be a widget, to avoid invalid widgets
        // (and template, which is a widget and an infolog todo status)
        if (et2_registry[field[j]] && ['template'].indexOf(field[j]) < 0 || customElements.get(field[j]) || typeof field[j] == "object" && typeof field[j].value == "undefined") {
          need_box = true;
          break;
        }
      }
      if (need_box) {
        // Multi-part value needs multiple widgets
        widget = loadWebComponent('et2-vbox', attrs, this);
        for (var i in field) {
          var type = field[i];
          var child_attrs = jQuery.extend({
            readonly: true
          }, attrs);
          if (typeof type === 'object') {
            child_attrs['select_options'] = cleanSelectOptions(field[i]);
            type = 'et2-select';
          } else {
            delete child_attrs['select_options'];
          }
          child_attrs.id = i;
          var child = this._create_widget(i, type, child_attrs, options);
          widget.addChild(child);
          child.transformAttributes(child_attrs);
        }
      } else {
        attrs['select_options'] = cleanSelectOptions(field);
      }
    }
    // Check for options after the type, ex: link-entry:infolog
    else if (field.indexOf(':') > 0) {
      var options = field.split(':');
      field = options.shift();
    }
    if (widget === null) {
      // Try to find a webcomponent first
      var tries = [field, "et2-" + field + "_ro", "et2-" + field];
      for (var _i3 = 0; _i3 < tries.length && !widget; _i3++) {
        if (typeof window.customElements.get(tries[_i3]) !== "undefined") {
          widget = loadWebComponent(tries[_i3], attrs, this);
        }
      }
      if (!widget) {
        widget = et2_createWidget(typeof field === 'string' ? field : 'select', attrs, this);
        if (typeof field === "string") {
          console.log("History specified legacy widget '" + field + "' for " + key + ".  Please change in PHP source.");
        }
      }
    }
    if (!widget.instanceOf(et2_IDetachedDOM)) {
      this.egw().debug("warn", this, "Invalid widget " + field + " for " + key + ".  Status widgets must implement et2_IDetachedDOM.");
      return null;
    }

    // Parse / set legacy options
    if (options) {
      var mgr = this.getArrayMgr("content");
      var legacy = widget.constructor.legacyOptions || [];
      for (var _i4 = 0; _i4 < options.length && _i4 < legacy.length; _i4++) {
        // Not set
        if (options[_i4] === "") continue;
        var attr = widget.attributes[legacy[_i4]] || {};
        var attrValue = options[_i4];

        // If the attribute is marked as boolean, parse the
        // expression as bool expression.
        if (attr.type === "boolean") {
          attrValue = mgr.parseBoolExpression(attrValue);
        } else {
          attrValue = mgr.expandName(attrValue);
        }
        attrs[legacy[_i4]] = attrValue;
        if (typeof widget['set_' + legacy[_i4]] === 'function') {
          widget['set_' + legacy[_i4]].call(widget, attrValue);
        } else {
          widget.options[legacy[_i4]] = attrValue;
        }
      }
    }
    return widget;
  }
  getDOMNode(_sender) {
    if (_sender == this) {
      return this.div[0];
    }
    for (var i = 0; i < et2_historylog.columns.length; i++) {
      if (_sender == et2_historylog.columns[i].widget) {
        return this.dataview.getHeaderContainerNode(i);
      }
    }
    return null;
  }
  dataFetch(_queriedRange, _callback, _context) {
    // Skip getting data if there's no ID
    if (!this.value.id) return;

    // Set num_rows to fetch via nextmatch
    if (this.options.value['num_rows']) _queriedRange['num_rows'] = this.options.value['num_rows'];
    var historylog = this;
    // Pass the fetch call to the API
    this.egw().dataFetch(this.getInstanceManager().etemplate_exec_id, _queriedRange, this._filters, this.id, function (_response) {
      _callback.call(this, _response);
    }, _context, []);
  }

  // Needed by interface
  dataRegisterUID(_uid, _callback, _context) {
    this.egw().dataRegisterUID(_uid, _callback, _context, this.getInstanceManager().etemplate_exec_id, this.id);
  }
  dataUnregisterUID(_uid, _callback, _context) {
    // Needed by interface
  }

  /**
   * The row callback gets called by the gridview controller whenever
   * the actual DOM-Nodes for a node with the given data have to be
   * created.
   *
   * @param {type} _data
   * @param {type} _row
   * @param {type} _idx
   * @param {type} _entry
   */
  rowCallback(_data, _row, _idx, _entry) {
    var tr = _row.getDOMNode();
    jQuery(tr).attr("valign", "top");
    var row = this.dataview.rowProvider.getPrototype("default");
    var self = this;
    jQuery("div", row).each(function (i) {
      var nodes = [];
      var widget = et2_historylog.columns[i].widget;
      var value = _data[et2_historylog.columns[i].id];
      if (et2_historylog.OWNER === i && _data['share_email']) {
        // Show share email instead of owner
        widget = undefined;
        value = _data['share_email'];
      }
      // Get widget from list, unless it needs a diff widget
      if ((typeof widget == 'undefined' || widget == null) && typeof self.fields[_data.status] != 'undefined' && (i < et2_historylog.NEW_VALUE || i >= et2_historylog.NEW_VALUE && (self.fields[_data.status].nodes || !self._needsDiffWidget(_data['status'], _data[et2_historylog.columns[et2_historylog.OLD_VALUE].id])))) {
        widget = self.fields[_data.status].widget;
        if (widget && typeof window.customElements.get(widget.localName) != "undefined") {
          nodes = widget.clone(); // Note: Slower than cloneNode(), but simpler to deal with all the different widgets;
          widget = nodes;
        } else if (!widget._children.length) {
          nodes = self.fields[_data.status].nodes.clone();
        }
      }
      // WebComponent IS the node
      else if (widget && typeof window.customElements.get(widget.localName) != "undefined") {
        nodes = widget.clone(); // Note: Slower than cloneNode(), but simpler to deal with all the different widgets;
        widget = nodes;
      } else if (widget) {
        nodes = et2_historylog.columns[i].nodes.clone();
      } else if (
      // Already parsed & cached
      typeof _data[et2_historylog.columns[et2_historylog.NEW_VALUE].id] == "object" && typeof _data[et2_historylog.columns[et2_historylog.NEW_VALUE].id] != "undefined" && _data[et2_historylog.columns[et2_historylog.NEW_VALUE].id] !== null ||
      // typeof null === 'object'
      // Large old value
      self._needsDiffWidget(_data['status'], _data[et2_historylog.columns[et2_historylog.OLD_VALUE].id]) ||
      // Large new value
      self._needsDiffWidget(_data['status'], _data[et2_historylog.columns[et2_historylog.NEW_VALUE].id])) {
        // Large text value - span both columns, and show a nice diff
        var jthis = jQuery(this);
        if (i === et2_historylog.NEW_VALUE) {
          // Diff widget
          widget = self.diff.widget;
          nodes = self.diff.nodes.clone();
          if (widget) widget.setDetachedAttributes(nodes, {
            value: value,
            label: jthis.parents("td").prev().text()
          });
          self._spanValueColumns(jthis);
        }
      } else {
        // No widget fallback - display actual value
        nodes = jQuery('<span>').text(value === null ? '' : value);
      }
      if (widget) {
        if (widget._children.length) {
          // Multi-part values
          for (var j = 0; j < widget._children.length; j++) {
            var id = widget._children[j].id;
            var widget_value = value ? value[id] || "" : "";
            widget._children[j].setDetachedAttributes(nodes[j], {
              value: widget_value
            });
          }
        } else {
          widget.setDetachedAttributes(nodes, {
            value: value
          });
        }
      }
      jQuery(this).append(nodes);
    });
    jQuery(tr).append(row.children());
    return tr;
  }

  /**
   * How to tell if the row needs a diff widget or not
   *
   * @param {string} columnName
   * @param {string} value
   * @returns {Boolean}
   */
  _needsDiffWidget(columnName, value) {
    if (typeof value !== "string" && value) {
      this.egw().debug("warn", "Crazy diff value", value);
      return false;
    }
    return value === '***diff***';
  }

  /**
   * Make a single row's new value cell span across both new value and old value
   * columns.  Used for diff widget.
   *
   * @param {jQuery} row jQuery wrapped row node
   */
  _spanValueColumns(row) {
    // Stretch column 4
    row.parents("td").attr("colspan", 2).css("border-right", "none");
    row.css("width", this.dataview.getColumnMgr().getColumnWidth(et2_historylog.NEW_VALUE) + this.dataview.getColumnMgr().getColumnWidth(et2_historylog.OLD_VALUE) - 10 + 'px');

    // Skip column 5
    row.parents("td").next().remove();
  }
  _resize() {
    var tab = this.get_tab_info();
    if (this.dataview) {
      var style = getComputedStyle(tab.contentDiv);
      // -# to avoid scrollbars
      this.dataview.resize(Math.min(window.innerWidth - 15, parseInt(style.width)) - 5, parseInt(style.height) - parseInt(style.paddingTop) - parseInt(style.paddingBottom) - 5);
    }
  }
  resize(_height) {
    this._resize();
    // Resize diff widgets to match new space
    if (this.dataview) {
      var columns = this.dataview.getColumnMgr();
      jQuery('.et2_diff', this.div).closest('.innerContainer').width(columns.getColumnWidth(et2_historylog.NEW_VALUE) + columns.getColumnWidth(et2_historylog.OLD_VALUE));
    }
  }
}
_defineProperty$e(et2_historylog, "_attributes", {
  "value": {
    "name": "Value",
    "type": "any",
    "description": "Object {app: ..., id: ..., status-widgets: {}} where status-widgets is a map of fields to widgets used to display those fields"
  },
  "status_id": {
    "name": "status_id",
    "type": "string",
    "default": "status",
    "description": "The history widget is traditionally named 'status'.  If you name another widget in the same template 'status', you can use this attribute to re-name the history widget.  "
  },
  "columns": {
    "name": "columns",
    "type": "string",
    "default": "user_ts,owner,status,new_value,old_value",
    "description": "Columns to display.  Default is user_ts,owner,status,new_value,old_value"
  },
  "get_rows": {
    "name": "get_rows",
    "type": "string",
    "default": "EGroupware\\Api\\Storage\\History::get_rows",
    "description": "Method to get rows"
  }
});
_defineProperty$e(et2_historylog, "legacyOptions", ["status_id"]);
_defineProperty$e(et2_historylog, "columns", [{
  'id': 'user_ts',
  caption: 'Date',
  'width': '120px',
  widget_type: 'et2-date-time',
  widget: null,
  nodes: null
}, {
  'id': 'owner',
  caption: 'User',
  'width': '150px',
  widget_type: 'et2-select-account_ro',
  widget: null,
  nodes: null
}, {
  'id': 'status',
  caption: 'Changed',
  'width': '120px',
  widget_type: 'et2-select',
  widget: null,
  nodes: null
}, {
  'id': 'new_value',
  caption: 'New Value',
  'width': '50%',
  widget: null,
  nodes: null
}, {
  'id': 'old_value',
  caption: 'Old Value',
  'width': '50%',
  widget: null,
  nodes: null
}]);
_defineProperty$e(et2_historylog, "TIMESTAMP", 0);
_defineProperty$e(et2_historylog, "OWNER", 1);
_defineProperty$e(et2_historylog, "FIELD", 2);
_defineProperty$e(et2_historylog, "NEW_VALUE", 3);
_defineProperty$e(et2_historylog, "OLD_VALUE", 4);
et2_register_widget(et2_historylog, ['historylog']);

/**
 * EGroupware eTemplate2 - JS HRule object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 */

/**
 * Class which implements the hrule tag
 *
 * @augments et2_baseWidget
 */
class et2_hrule extends et2_baseWidget {
  /**
   * Constructor
   *
   * @memberOf et2_hrule
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_hrule._attributes, _child || {}));
    this.setDOMNode(document.createElement("hr"));
  }
}
et2_register_widget(et2_hrule, ["hrule"]);

function _defineProperty$d(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @augments et2_valueWidget
 */
class et2_iframe extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_iframe
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_iframe._attributes, _child || {}));

    // Allow no child widgets
    _defineProperty$d(this, "htmlNode", null);
    this.supportedWidgetClasses = [];
    this.htmlNode = jQuery(document.createElement("iframe"));
    if (this.options.label) {
      this.htmlNode.append('<span class="et2_label">' + this.options.label + '</span>');
    }
    if (this.options.fullscreen) {
      this.htmlNode.attr('allowfullscreen', 1);
    }
    this.setDOMNode(this.htmlNode[0]);
  }

  /**
   * Set name of iframe (to be used as target for links)
   *
   * @param _name
   */
  set_name(_name) {
    this.options.name = _name;
    this.htmlNode.attr('name', _name);
  }
  set_allow(_allow) {
    this.options.allow = _allow;
    this.htmlNode.attr('allow', _allow);
  }
  /**
   * Make it look like part of the containing document
   *
   * @param _seamless boolean
   */
  set_seamless(_seamless) {
    this.options.seamless = _seamless;
    this.htmlNode.attr("seamless", _seamless);
  }
  set_value(_value) {
    if (typeof _value == "undefined") _value = "";
    if (_value.trim().indexOf("http") == 0 || _value.indexOf('about:') == 0 || _value[0] == '/') {
      // Value is a URL
      this.set_src(_value);
    } else {
      // Value is content
      this.set_srcdoc(_value);
    }
  }

  /**
   * Set the URL for the iframe
   *
   * Sets the src attribute to the given value
   *
   * @param _value String URL
   */
  set_src(_value) {
    if (_value.trim() != "") {
      if (_value.trim() == 'about:blank') {
        this.htmlNode.attr("src", _value);
      } else {
        // Load the new page, but display a loader
        var loader = jQuery('<div class="et2_iframe loading"/>');
        this.htmlNode.before(loader);
        window.setTimeout(jQuery.proxy(function () {
          this.htmlNode.attr("src", _value).one('load', function () {
            loader.remove();
          });
        }, this), 0);
      }
    }
  }

  /**
   * Sets the content of the iframe
   *
   * Sets the srcdoc attribute to the given value
   *
   * @param _value String Content of a document
   */
  set_srcdoc(_value) {
    this.htmlNode.attr("srcdoc", _value);
  }
}
_defineProperty$d(et2_iframe, "_attributes", {
  'label': {
    'default': "",
    description: "The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",
    ignore: false,
    name: "Label",
    translate: true,
    type: "string"
  },
  "needed": {
    "ignore": true
  },
  "seamless": {
    name: "Seamless",
    'default': true,
    description: "Specifies that the iframe should be rendered in a manner that makes it appear to be part of the containing document",
    translate: false,
    type: "boolean"
  },
  "name": {
    name: "Name",
    "default": "",
    description: "Specifies name of frame, to be used as target for links",
    type: "string"
  },
  fullscreen: {
    name: "Fullscreen",
    "default": false,
    description: "Make the iframe compatible to be a fullscreen video player mode",
    type: "boolean"
  },
  src: {
    name: "Source",
    "default": "",
    description: "Specifies URL for the iframe",
    type: "string"
  },
  allow: {
    name: "Allow",
    "default": "",
    description: "Specifies list of allow features, e.g. camera",
    type: "string"
  }
});
et2_register_widget(et2_iframe, ["iframe"]);

function _defineProperty$c(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Display a dialog to choose a placeholder
 */
class et2_placeholder_select extends et2_inputWidget {
  /**
   * Constructor
   *
   * @param _parent
   * @param _attrs
   * @memberOf et2_vfsSelect
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_placeholder_select._attributes, _child || {}));

    // Allow no child widgets
    _defineProperty$c(this, "button", void 0);
    _defineProperty$c(this, "submit_callback", void 0);
    _defineProperty$c(this, "dialog", void 0);
    _defineProperty$c(this, "value", void 0);
    _defineProperty$c(this, "LIST_URL", 'EGroupware\\Api\\Etemplate\\Widget\\Placeholder::ajax_get_placeholders');
    _defineProperty$c(this, "TEMPLATE", '/api/templates/default/insert_merge_placeholder.xet?1');
    this.supportedWidgetClasses = [];
  }
  _content(_content, _callback) {
    var self = this;
    if (this.dialog) {
      this.dialog.close();
    }
    var callback = _callback || this._buildDialog;
    if (et2_placeholder_select.placeholders === null) {
      this.egw().loading_prompt('placeholder_select', true, '', 'body');
      this.egw().json(this.LIST_URL, [], function (_content) {
        if (typeof _content === 'object' && _content.message) {
          // Something went wrong
          this.egw().message(_content.message, 'error');
          return;
        }
        this.egw().loading_prompt('placeholder_select', false);
        et2_placeholder_select.placeholders = _content;
        callback.apply(self, arguments);
      }.bind(this)).sendRequest(true);
    } else {
      this._buildDialog(et2_placeholder_select.placeholders);
    }
  }

  /**
   * Builds placeholder selection dialog
   *
   * @param {object} _data content
   */
  _buildDialog(_data) {
    var _data$sel_options$gro;
    var buttons = [{
      label: this.egw().lang("Insert"),
      id: "submit",
      image: "export"
    }];
    var extra_buttons_action = {};
    if (this.options.extra_buttons && this.options.method) {
      for (var i = 0; i < this.options.extra_buttons.length; i++) {
        delete this.options.extra_buttons[i]['click'];
        buttons.push(this.options.extra_buttons[i]);
        extra_buttons_action[this.options.extra_buttons[i]['id']] = this.options.extra_buttons[i]['id'];
      }
    }
    buttons.push({
      label: this.egw().lang("Cancel"),
      id: "cancel",
      image: "cancel"
    });
    var data = {
      content: {
        app: '',
        group: '',
        entry: {}
      },
      sel_options: {
        app: [],
        group: []
      },
      modifications: {
        entry: {
          application_list: []
        }
      }
    };
    Object.keys(_data).map(key => {
      data.sel_options.app.push({
        value: key,
        label: this.egw().lang(key)
      });
    });
    data.sel_options.group = this._get_group_options(Object.keys(_data)[0]);
    data.content.app = data.sel_options.app[0].value;
    data.content.group = (_data$sel_options$gro = data.sel_options.group[0]) === null || _data$sel_options$gro === void 0 ? void 0 : _data$sel_options$gro.value;
    data.content.entry = {
      app: data.content.app
    };
    data.modifications.entry.application_list = Object.keys(_data);
    // Remove non-app placeholders (user & general)
    var non_apps = ['user', 'general'];
    for (var _i = 0; _i < non_apps.length; _i++) {
      var index = data.modifications.entry.application_list.indexOf(non_apps[_i]);
      data.modifications.entry.application_list.splice(index, 1);
    }

    // callback for dialog
    this.submit_callback = function (submit_button_id, submit_value) {
      if ((submit_button_id == 'submit' || extra_buttons_action && extra_buttons_action[submit_button_id]) && submit_value) {
        this._do_insert_callback(submit_value);
        return true;
      } else if (submit_button_id == 'cancel') {
        return true;
      } else {
        // Keep dialog open
        return false;
      }
    }.bind(this);
    this.dialog = new Et2Dialog$1(this.egw());
    this.dialog.transformAttributes({
      callback: this.submit_callback,
      title: this.options.dialog_title || "Insert Placeholder",
      buttons: buttons,
      value: data,
      template: this.egw().webserverUrl + this.TEMPLATE,
      resizable: true,
      width: ''
    });
    document.body.appendChild(this.dialog);
    this.dialog.addEventListener('open', this._on_template_load.bind(this));
  }
  doLoadingFinished() {
    this._content.call(this, null);
    return true;
  }

  /**
   * Post-load of the dialog
   * Bind internal events, set some things that are difficult to do in the template
   */
  _on_template_load() {
    var app = this.dialog.template.widgetContainer.getDOMWidgetById("app");
    var group = this.dialog.template.widgetContainer.getDOMWidgetById("group");
    var placeholder_list = this.dialog.template.widgetContainer.getDOMWidgetById("placeholder_list");
    var preview = this.dialog.template.widgetContainer.getDOMWidgetById("preview_placeholder");
    var entry = this.dialog.template.widgetContainer.getDOMWidgetById("entry");
    placeholder_list.set_select_options(this._get_placeholders(app.get_value(), group.get_value()));

    // Bind some handlers
    app.onchange = (node, widget) => {
      preview.set_value("");
      if (['user', 'filemanager'].indexOf(widget.get_value()) >= 0) {
        // These ones don't let you select an entry for preview (they don't work)
        entry.set_disabled(true);
        entry.set_value({
          app: 'user',
          id: '',
          query: ''
        });
      } else if (widget.get_value() == 'general') {
        // Don't change entry app, leave it
        entry.set_disabled(false);
      } else {
        // Load app translations
        this.egw().langRequireApp(this.egw().window, widget.get_value());
        entry.set_disabled(false);
        entry.set_value({
          app: widget.get_value(),
          id: '',
          query: ''
        });
      }
      var groups = this._get_group_options(widget.get_value());
      group.set_select_options(groups);
      group.set_value(groups[0].value);
      group.onchange();
    };
    group.onchange = (select_node, select_widget) => {
      var options = this._get_placeholders(app.get_value(), group.get_value());
      placeholder_list.set_select_options(options);
      preview.set_value("");
      placeholder_list.updateComplete.then(() => placeholder_list.set_value(options[0].value));
    };
    placeholder_list.onchange = this._on_placeholder_select.bind(this);
    entry.onchange = this._on_placeholder_select.bind(this);
    this.dialog.template.widgetContainer.getDOMWidgetById("insert_placeholder").onclick = () => {
      this.options.insert_callback(this.dialog.template.widgetContainer.getDOMWidgetById("preview_placeholder").getDOMNode().textContent);
    };
    this.dialog.template.widgetContainer.getDOMWidgetById("insert_content").onclick = () => {
      this.options.insert_callback(this.dialog.template.widgetContainer.getDOMWidgetById("preview_content").getDOMNode().textContent);
    };
    app.set_value(app.get_value());
  }

  /**
   * User has selected a placeholder
   * Update the UI, and if they have an entry selected do the replacement and show that.
   */
  _on_placeholder_select() {
    var _placeholder_list$get;
    var app = this.dialog.template.widgetContainer.getDOMWidgetById("app");
    var entry = this.dialog.template.widgetContainer.getDOMWidgetById("entry");
    var placeholder_list = this.dialog.template.widgetContainer.getDOMWidgetById("placeholder_list");
    var preview = this.dialog.template.widgetContainer.getDOMWidgetById("preview_placeholder");
    var preview_content = this.dialog.template.widgetContainer.getDOMWidgetById("preview_content");

    // Show the selected placeholder
    this.set_value(placeholder_list.get_value());
    preview.set_value(placeholder_list.get_value());
    preview.getDOMNode().parentNode.style.visibility = (_placeholder_list$get = placeholder_list.get_value()) !== null && _placeholder_list$get !== void 0 && _placeholder_list$get.trim() ? null : 'hidden';
    if (placeholder_list.get_value() && entry.get_value()) {
      // Show the selected placeholder replaced with value from the selected entry
      this.egw().json('EGroupware\\Api\\Etemplate\\Widget\\Placeholder::ajax_fill_placeholders', [placeholder_list.get_value(), entry.get_value()], function (_content) {
        if (!_content) {
          _content = '';
        }
        preview_content.set_value(_content);
        preview_content.getDOMNode().parentNode.style.visibility = _content.trim() ? null : 'hidden';
      }.bind(this)).sendRequest(true);
    } else {
      // No value, hide the row
      preview_content.getDOMNode().parentNode.style.visibility = 'hidden';
    }
  }

  /**
   * Get the list of placeholder groups under the selected application
   * @param appname
   * @returns {value:string, label:string}[]
   */
  _get_group_options(appname) {
    var options = [];
    Object.keys(et2_placeholder_select.placeholders[appname]).map(key => {
      // @ts-ignore
      if (Object.keys(et2_placeholder_select.placeholders[appname][key]).filter(key => isNaN(key)).length > 0) {
        // Handle groups of groups
        if (typeof et2_placeholder_select.placeholders[appname][key].label !== "undefined") {
          options.push({
            label: key,
            value: et2_placeholder_select.placeholders[appname][key]
          });
        } else {
          var a = {
            label: key,
            value: []
          };
          for (var sub of Object.keys(et2_placeholder_select.placeholders[appname][key])) {
            if (!et2_placeholder_select.placeholders[appname][key][sub]) {
              continue;
            }
            a.value.push({
              value: key + '-' + sub,
              label: this.egw().lang(sub)
            });
          }
          options.push(a);
        }
      } else {
        options.push({
          value: key,
          label: this.egw().lang(key)
        });
      }
    });
    return options;
  }

  /**
   * Get a list of placeholders under the given application + group
   *
   * @param appname
   * @param group
   * @returns {value:string, label:string}[]
   */
  _get_placeholders(appname, group) {
    var _group = group.split('-', 2);
    var ph = et2_placeholder_select.placeholders[appname];
    for (var i = 0; typeof ph !== "undefined" && i < _group.length; i++) {
      ph = ph[_group[i]];
    }
    return ph || [];
  }

  /**
   * Get the correct insert text call the insert callback with it
   *
   * @param dialog_values
   */
  _do_insert_callback(dialog_values) {
    this.options.insert_callback(this.get_value());
  }
  set_value(value) {
    this.value = value;
  }
  getValue() {
    return this.value;
  }
}
_defineProperty$c(et2_placeholder_select, "_attributes", {
  insert_callback: {
    "name": "Insert callback",
    "description": "Method called with the selected placeholder text",
    "type": "js"
  },
  dialog_title: {
    "name": "Dialog title",
    "type": "string",
    "default": "Insert Placeholder"
  }
});
_defineProperty$c(et2_placeholder_select, "placeholders", null);
;
et2_register_widget(et2_placeholder_select, ["placeholder-select"]);

/**
 * Display a dialog to choose from a set list of placeholder snippets
 */
class et2_placeholder_snippet_select extends et2_placeholder_select {
  /**
   * Constructor
   *
   * @param _parent
   * @param _attrs
   * @memberOf et2_vfsSelect
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_placeholder_select._attributes, _child || {}));

    // Load app translations
    _defineProperty$c(this, "button", void 0);
    _defineProperty$c(this, "submit_callback", void 0);
    _defineProperty$c(this, "dialog", void 0);
    _defineProperty$c(this, "value", void 0);
    _defineProperty$c(this, "LIST_URL", 'EGroupware\\Api\\Etemplate\\Widget\\Placeholder::ajax_get_placeholders');
    _defineProperty$c(this, "TEMPLATE", '/api/templates/default/placeholder_snippet.xet?1');
    this.egw().langRequireApp(this.egw().window, "addressbook");
  }

  /**
   * Post-load of the dialog
   * Bind internal events, set some things that are difficult to do in the template
   */
  _on_template_load() {
    var app = this.dialog.template.widgetContainer.getDOMWidgetById("app");
    var placeholder_list = this.dialog.template.widgetContainer.getDOMWidgetById("placeholder_list");
    var preview = this.dialog.template.widgetContainer.getDOMWidgetById("preview_content");
    var entry = this.dialog.template.widgetContainer.getDOMWidgetById("entry");
    placeholder_list.set_select_options(this._get_placeholders("addressbook", "addresses"));

    // Further setup / styling that can't be done in etemplate
    app.setAttribute("readonly", true);

    // Bind some handlers
    app.onchange = (node, widget) => {
      entry.set_value({
        app: widget.get_value()
      });
      placeholder_list.set_select_options(this._get_placeholders(app.value, "addresses"));
    };
    placeholder_list.onchange = this._on_placeholder_select.bind(this);
    entry.onchange = this._on_placeholder_select.bind(this);
    app.set_value(app.value);
    this._on_placeholder_select();
  }

  /**
   * User has selected a placeholder
   * Update the UI, and if they have an entry selected do the replacement and show that.
   */
  _on_placeholder_select() {
    var app = this.dialog.template.widgetContainer.getDOMWidgetById("app");
    var entry = this.dialog.template.widgetContainer.getDOMWidgetById("entry");
    var placeholder_list = this.dialog.template.widgetContainer.getDOMWidgetById("placeholder_list");
    var preview_content = this.dialog.template.widgetContainer.getDOMWidgetById("preview_content");
    var placeholder = "";
    if (app && app.value) {
      placeholder = Object.keys(et2_placeholder_snippet_select.placeholders[app.value]["addresses"])[placeholder_list.value];
    }
    if (placeholder && entry.get_value()) {
      // Show the selected placeholder replaced with value from the selected entry
      this.egw().json('EGroupware\\Api\\Etemplate\\Widget\\Placeholder::ajax_fill_placeholders', [placeholder, {
        app: "addressbook",
        id: entry.get_value()
      }], function (_content) {
        if (!_content) {
          _content = '';
        }
        this.set_value(_content);
        preview_content.set_value(_content);
        preview_content.getDOMNode().parentNode.style.visibility = _content.trim() ? null : 'hidden';
      }.bind(this)).sendRequest(true);
    } else {
      // No value, hide the row
      preview_content.getDOMNode().parentNode.style.visibility = 'hidden';
    }
    if (!entry.get_value()) {
      entry._searchNode.focus();
    }
  }

  /**
   * Get the list of placeholder groups under the selected application
   * @param appname
   * @returns {value:string, label:string}[]
   */
  _get_group_options(appname) {
    var options = [];
    Object.keys(et2_placeholder_select.placeholders[appname]).map(key => {
      options.push({
        value: key,
        label: this.egw().lang(key)
      });
    });
    return options;
  }

  /**
   * Get a list of placeholders under the given application + group
   *
   * @param appname
   * @param group
   * @returns {value:string, label:string}[]
   */
  _get_placeholders(appname, group) {
    var options = [];
    Object.keys(et2_placeholder_snippet_select.placeholders[appname][group]).map((key, index) => {
      options.push({
        value: index,
        label: this.egw().lang(et2_placeholder_snippet_select.placeholders[appname][group][key])
      });
    });
    return options;
  }

  /**
   * Get the correct insert text call the insert callback with it
   *
   * @param dialog_values
   */
  _do_insert_callback(dialog_values) {
    this.options.insert_callback(this.get_value());
  }
  set_value(value) {
    this.value = value;
  }
  getValue() {
    return this.value;
  }
}
_defineProperty$c(et2_placeholder_snippet_select, "_attributes", {
  dialog_title: {
    "default": "Insert address"
  }
});
_defineProperty$c(et2_placeholder_snippet_select, "placeholders", {
  "addressbook": {
    "addresses": {
      "{{org_name}}\n{{n_fn}}\n{{adr_one_street}}{{NELF adr_one_street2}}\n{{adr_one_formatted}}": "Business address",
      "{{n_fn}}\n{{adr_two_street}}{{NELF adr_two_street2}}\n{{adr_two_formatted}}": "Home address",
      "{{n_fn}}\n{{email}}\n{{tel_work}}": "Name, email, phone"
    }
  }
});
;
et2_register_widget(et2_placeholder_snippet_select, ["placeholder-snippet"]);

function _defineProperty$b(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "progress" XET-Tag
 *
 * @augments et2_valueWidget
 */
class et2_progress extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_progress
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_progress._attributes, _child || {}));
    _defineProperty$b(this, "progress", null);
    var outer = document.createElement("div");
    outer.className = "et2_progress";
    this.progress = document.createElement("div");
    this.progress.style.width = "0";
    outer.appendChild(this.progress);
    if (this.options.href) {
      outer.className += ' et2_clickable';
    }
    if (this.options["class"]) {
      outer.className += ' ' + this.options["class"];
    }
    this.setDOMNode(outer); // set's this.node = outer
  }

  click(e) {
    super.click(e);
    if (this.options.href) {
      this.egw().open_link(this.options.href, this.options.extra_link_target, this.options.extra_link_popup);
    }
  }

  // setting the value as width of the progress-bar
  set_value(_value) {
    super.set_value(_value);
    _value = parseInt(_value) + "%"; // make sure we have percent attached
    this.progress.style.width = _value;
    if (!this.options.label) this.set_label(_value);
  }

  // set's label as title of this.node
  set_label(_value) {
    this.node.title = _value;
  }

  // set's class of this.node; preserve baseclasses et2_progress and if this.options.href is set et2_clickable
  set_class(_value) {
    var baseClass = "et2_progress";
    if (this.options.href) {
      baseClass += ' et2_clickable';
    }
    this.node.setAttribute('class', baseClass + ' ' + _value);
  }
  set_href(_value) {
    if (!this.isInTree()) {
      return false;
    }
    this.options.href = _value;
    if (_value) {
      jQuery(this.node).addClass('et2_clickable').wrapAll('<a href="' + _value + '"></a>"');
      var href = this.options.href;
      var popup = this.options.extra_link_popup;
      var target = this.options.extra_link_target;
      jQuery(this.node).parent().click(function (e) {
        egw$1.open_link(href, target, popup);
        e.preventDefault();
        return false;
      });
    } else if (jQuery(this.node).parent('a').length) {
      jQuery(this.node).removeClass('et2_clickable').unwrap();
    }
    return true;
  }

  /**
   * Implementation of "et2_IDetachedDOM" for fast viewing in gridview
   *
   * * @param {array} _attrs array to add further attributes to
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value", "label", "href");
  }
  getDetachedNodes() {
    return [this.node, this.progress];
  }
  setDetachedAttributes(_nodes, _values) {
    // Set the given DOM-Nodes
    this.node = _nodes[0];
    this.progress = _nodes[1];

    // Set the attributes
    if (_values["label"]) {
      this.set_label(_values["label"]);
    }
    if (_values["value"]) {
      this.set_value(_values["value"]);
    } else if (_values["label"]) {
      this.set_value(_values["label"]);
    }
    if (_values["href"]) {
      jQuery(this.node).addClass('et2_clickable');
      this.set_href(_values["href"]);
    }
  }
}
_defineProperty$b(et2_progress, "_attributes", {
  "href": {
    "name": "Link Target",
    "type": "string",
    "description": "Link URL, empty if you don't wan't to display a link."
  },
  "extra_link_target": {
    "name": "Link target",
    "type": "string",
    "default": "_self",
    "description": "Link target descriptor"
  },
  "extra_link_popup": {
    "name": "Popup",
    "type": "string",
    "description": "widthxheight, if popup should be used, eg. 640x480"
  },
  "label": {
    "name": "Label",
    "default": "",
    "type": "string",
    "description": "The label is displayed as the title.  The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",
    "translate": true
  }
});
_defineProperty$b(et2_progress, "legacyOptions", ["href", "extra_link_target", "imagemap", "extra_link_popup", "id"]);
et2_register_widget(et2_progress, ["progress"]);

var t,e,r,n,i=function(){return i=Object.assign||function(t){for(var e,r=1,n=arguments.length;r<n;r++)for(var i in e=arguments[r])Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t},i.apply(this,arguments)};function o(t,e,r){if(r||2===arguments.length)for(var n,i=0,o=e.length;i<o;i++)!n&&i in e||(n||(n=Array.prototype.slice.call(e,0,i)),n[i]=e[i]);return t.concat(n||Array.prototype.slice.call(e))}!function(t){t.HEX="HEX",t.RGB="RGB",t.RGBA="RGBA",t.HSL="HSL",t.HSLA="HSLA",t.CMYK="CMYK";}(t||(t={})),function(t){t.ANALOGOUS="ANALOGOUS",t.COMPLEMENTARY="COMPLEMENTARY",t.SPLIT_COMPLEMENTARY="SPLIT_COMPLEMENTARY",t.TRIADIC="TRIADIC",t.TETRADIC="TETRADIC",t.SQUARE="SQUARE";}(e||(e={})),function(t){t.ADDITIVE="ADDITIVE",t.SUBTRACTIVE="SUBTRACTIVE";}(r||(r={})),function(t){t.black="#000000",t.silver="#C0C0C0",t.gray="#808080",t.white="#FFFFFF",t.maroon="#800000",t.red="#FF0000",t.purple="#800080",t.fuchsia="#FF00FF",t.green="#008000",t.lime="#00FF00",t.olive="#808000",t.yellow="#FFFF00",t.navy="#000080",t.blue="#0000FF",t.teal="#008080",t.aqua="#00FFFF",t.orange="#FFA500",t.aliceblue="#F0F8FF",t.antiquewhite="#FAEBD7",t.aquamarine="#7FFFD4",t.azure="#F0FFFF",t.beige="#F5F5DC",t.bisque="#FFE4C4",t.blanchedalmond="#FFEBCD",t.blueviolet="#8A2BE2",t.brown="#A52A2A",t.burlywood="#DEB887",t.cadetblue="#5F9EA0",t.chartreuse="#7FFF00",t.chocolate="#D2691E",t.coral="#FF7F50",t.cornflowerblue="#6495ED",t.cornsilk="#FFF8DC",t.crimson="#DC143C",t.cyan="#00FFFF",t.darkblue="#00008B",t.darkcyan="#008B8B",t.darkgoldenrod="#B8860B",t.darkgray="#A9A9A9",t.darkgreen="#006400",t.darkgrey="#A9A9A9",t.darkkhaki="#BDB76B",t.darkmagenta="#8B008B",t.darkolivegreen="#556B2F",t.darkorange="#FF8C00",t.darkorchid="#9932CC",t.darkred="#8B0000",t.darksalmon="#E9967A",t.darkseagreen="#8FBC8F",t.darkslateblue="#483D8B",t.darkslategray="#2F4F4F",t.darkslategrey="#2F4F4F",t.darkturquoise="#00CED1",t.darkviolet="#9400D3",t.deeppink="#FF1493",t.deepskyblue="#00BFFF",t.dimgray="#696969",t.dimgrey="#696969",t.dodgerblue="#1E90FF",t.firebrick="#B22222",t.floralwhite="#FFFAF0",t.forestgreen="#228B22",t.gainsboro="#DCDCDC",t.ghostwhite="#F8F8FF",t.gold="#FFD700",t.goldenrod="#DAA520",t.greenyellow="#ADFF2F",t.grey="#808080",t.honeydew="#F0FFF0",t.hotpink="#FF69B4",t.indianred="#CD5C5C",t.indigo="#4B0082",t.ivory="#FFFFF0",t.khaki="#F0E68C",t.lavender="#E6E6FA",t.lavenderblush="#FFF0F5",t.lawngreen="#7CFC00",t.lemonchiffon="#FFFACD",t.lightblue="#ADD8E6",t.lightcoral="#F08080",t.lightcyan="#E0FFFF",t.lightgoldenrodyellow="#FAFAD2",t.lightgray="#D3D3D3",t.lightgreen="#90EE90",t.lightgrey="#D3D3D3",t.lightpink="#FFB6C1",t.lightsalmon="#FFA07A",t.lightseagreen="#20B2AA",t.lightskyblue="#87CEFA",t.lightslategray="#778899",t.lightslategrey="#778899",t.lightsteelblue="#B0C4DE",t.lightyellow="#FFFFE0",t.limegreen="#32CD32",t.linen="#FAF0E6",t.magenta="#FF00FF",t.mediumaquamarine="#66CDAA",t.mediumblue="#0000CD",t.mediumorchid="#BA55D3",t.mediumpurple="#9370DB",t.mediumseagreen="#3CB371",t.mediumslateblue="#7B68EE",t.mediumspringgreen="#00FA9A",t.mediumturquoise="#48D1CC",t.mediumvioletred="#C71585",t.midnightblue="#191970",t.mintcream="#F5FFFA",t.mistyrose="#FFE4E1",t.moccasin="#FFE4B5",t.navajowhite="#FFDEAD",t.oldlace="#FDF5E6",t.olivedrab="#6B8E23",t.orangered="#FF4500",t.orchid="#DA70D6",t.palegoldenrod="#EEE8AA",t.palegreen="#98FB98",t.paleturquoise="#AFEEEE",t.palevioletred="#DB7093",t.papayawhip="#FFEFD5",t.peachpuff="#FFDAB9",t.peru="#CD853F",t.pink="#FFC0CB",t.plum="#DDA0DD",t.powderblue="#B0E0E6",t.rosybrown="#BC8F8F",t.royalblue="#4169E1",t.saddlebrown="#8B4513",t.salmon="#FA8072",t.sandybrown="#F4A460",t.seagreen="#2E8B57",t.seashell="#FFF5EE",t.sienna="#A0522D",t.skyblue="#87CEEB",t.slateblue="#6A5ACD",t.slategray="#708090",t.slategrey="#708090",t.snow="#FFFAFA",t.springgreen="#00FF7F",t.steelblue="#4682B4",t.tan="#D2B48C",t.thistle="#D8BFD8",t.tomato="#FF6347",t.turquoise="#40E0D0",t.violet="#EE82EE",t.wheat="#F5DEB3",t.whitesmoke="#F5F5F5",t.yellowgreen="#9ACD32",t.rebeccapurple="#663399";}(n||(n={}));var u,a,s,c,d,f,h,l=Object.keys(n),p=((u={})[t.HEX]=/^#(?:([a-f\d])([a-f\d])([a-f\d])([a-f\d])?|([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?)$/i,u[t.RGB]=/^rgb\s*\(\s*(?:(\d+%)\s*,\s*(\d+%)\s*,\s*(\d+%)|(\d+)\s*,\s*(\d+)\s*,\s*(\d+))\s*\)$/,u[t.RGBA]=/^rgba\s*\(\s*(?:(\d+%)\s*,\s*(\d+%)\s*,\s*(\d+%)|(\d+)\s*,\s*(\d+)\s*,\s*(\d+))\s*,\s*(\d\.?\d*)\s*\)$/,u[t.HSL]=/^hsl\s*\(\s*(-?\d+\.?\d*)\s*,\s*(\d+\.?\d*)%\s*,\s*(\d+\.?\d*)%s*\)$/,u[t.HSLA]=/^hsla\s*\(\s*(-?\d+\.?\d*)\s*,\s*(\d+\.?\d*)%\s*,\s*(\d+\.?\d*)%\s*,\s*(\d\.?\d*)\s*\)$/,u[t.CMYK]=/^(?:device-cmyk|cmyk)\s*\(\s*(?:(\d+\.?\d*%)\s*,\s*(\d+\.?\d*%)\s*,\s*(\d+\.?\d*%)\s*,\s*(\d+\.?\d*%)|(\d\.?\d*)\s*,\s*(\d\.?\d*)\s*,\s*(\d\.?\d*)\s*,\s*(\d\.?\d*))\s*\)$/,u),g=/^(\d+(?:\.\d+)?|\.\d+)%$/,b=/^0x([a-f\d]{1,2})$/i,F="The provided string color doesn't have a correct format",A="The provided color object doesn't have the proper keys or format",m=function(t,e,r){return r<0&&(r+=6),r>=6&&(r-=6),r<1?Math.round(255*((e-t)*r+t)):r<3?Math.round(255*e):r<4?Math.round(255*((e-t)*(4-r)+t)):Math.round(255*t)},y=function(t,e,r){e/=100;var n=(r/=100)<=.5?r*(e+1):r+e-r*e,i=2*r-n;return {r:m(i,n,(t/=60)+2),g:m(i,n,t),b:m(i,n,t-2)}},E=function(t,e,r,n){return n=1-n,{r:Math.round(255*(1-t)*n),g:Math.round(255*(1-e)*n),b:Math.round(255*(1-r)*n)}},H=function(t,e,r){t/=255,e/=255,r/=255;var n=1-Math.max(t,e,r),i=1-n,o=(i-t)/i,u=(i-e)/i,a=(i-r)/i;return {c:Math.round(100*o),m:Math.round(100*u),y:Math.round(100*a),k:Math.round(100*n)}},B=function(t,e,r,n){void 0===n&&(n=1),t/=255,e/=255,r/=255,n=Math.min(n,1);var i=Math.max(t,e,r),o=Math.min(t,e,r),u=i-o,a=0,s=0,c=(i+o)/2;if(0===u)a=0,s=0;else {switch(i){case t:a=(e-r)/u%6;break;case e:a=(r-t)/u+2;break;case r:a=(t-e)/u+4;}(a=Math.round(60*a))<0&&(a+=360),s=u/(1-Math.abs(2*c-1));}return {h:a,s:Math.round(100*s),l:Math.round(100*c),a:n}},v=function(t,e){if(t<0&&(t+=360),t>360&&(t-=360),360===t||0===t)return t;var r=[[0,120],[120,180],[180,240],[240,360]],n=[[0,60],[60,120],[120,240],[240,360]],i=e?n:r,o=0,u=0,a=0,s=0;return (e?r:n).find((function(e,r){return t>=e[0]&&t<e[1]&&(o=e[0],u=e[1],a=i[r][0],s=i[r][1],!0)})),a+(s-a)/(u-o)*(t-o)},M=function(t,e){return Object.prototype.hasOwnProperty.call(t,e)},R=function(t){return g.test(""+t)?+(""+t).replace(g,"$1"):Math.min(+t,100)},S=function(t){return 1===t.length&&(t+=t),parseInt(t,16)},C=function(t){var e=parseInt(""+t).toString(16).toUpperCase();return 1===e.length?"0x0"+e:"0x"+e},L=function(t){var e=parseInt(""+t).toString(16).toUpperCase();return 1===e.length&&(e="0"+e),e},D=function(t,e){return void 0===e&&(e=!1),!e&&g.test(t)?Math.min(255*+t.replace(g,"$1")/100,255):b.test(t)?3===t.length?e?parseInt(t+t.slice(-1))/255:parseInt(t+t.slice(-1)):e?parseInt(t)/255:parseInt(t):Math.min(+t,e?1:255)},G=function(t){return Math.min(g.test(t)?+t.replace(g,"$1")/100:+t,1)},k=function(t){return t.sort().join().toUpperCase()},O=function(t,e){void 0===e&&(e=0);var r=Math.pow(10,e);return Math.round(+t*r)/r},X=function(t,e,r){return Math.max(e,Math.min(t,r))},I=((a={})[t.HEX]=function(t){return "#"+L(t.r)+L(t.g)+L(t.b)+(M(t,"a")&&L(t.a)||"")},a[t.RGB]=function(t){return "rgb"+(M(t,"a")?"a":"")+"("+O(t.r)+","+O(t.g)+","+O(t.b)+(M(t,"a")&&","+O(t.a,2)||"")+")"},a[t.HSL]=function(t){return "hsl"+(M(t,"a")?"a":"")+"("+O(t.h)+","+O(t.s)+"%,"+O(t.l)+"%"+(M(t,"a")&&","+O(t.a,2)||"")+")"},a[t.CMYK]=function(t){return "cmyk("+O(t.c)+"%,"+O(t.m)+"%,"+O(t.y)+"%,"+O(t.k)+"%)"},a),j=function(t){return (t>360||t<0)&&(t-=360*Math.floor(t/360)),t},T=function(t){return isNaN(+t)||t>1?1:O(t,2)},Y=function(t,e,n){return e.reduce((function(e,u){return o(o([],e,!0),[i(i({},t),{h:n===r.ADDITIVE?j(t.h+u):j(v(v(t.h,!1)+u,!0))})],!1)}),[i({},t)])},P=function(t,e){return Y(t,[30,-30],e)},w=function(t,e){return Y(t,[180],e)},K=function(t,e){return Y(t,[150,-150],e)},x=function(t,e){return Y(t,[120,-120],e)},N=function(t,e){return Y(t,[60,-120,180],e)},V=function(t,e){return Y(t,[90,-90,180],e)},U=function(e){return "string"==typeof e?function(e){var r;if(Object.keys(t).some((function(t){if(p[t].test(e))return r=t,!0})),!r&&~l.indexOf(e)&&(r=t.HEX),!r)throw new Error(F);return r}(e):function(e){var r,n=!1,i=k(Object.keys(e));if(Object.keys(t).filter((function(e){return e!==t.HEX})).some((function(t){if(k(t.split(""))===i)return r=t,!0})),r&&r===t.RGB||r===t.RGBA){var o=Object.entries(e).map((function(t){return b.test(""+t[1])})),u=Object.entries(e).map((function(t){return g.test(""+t[1])||!b.test(""+t[1])&&!isNaN(+t[1])&&+t[1]<=255})),a=o.some((function(t,e){return e>0&&t!==o[e-1]})),s=u.some((function(t,e){return e>0&&t!==u[e-1]}));!(n=a||s||!o[0]&&!u[0])&&o[0]&&(r=t.HEX);}if(!r||n)throw new Error(A);return r}(e)},$$1=((s={})[t.HEX]=function(t){var e=(~l.indexOf(t)?n[t]:t).match(p.HEX),r={r:S(e[1]||e[5]),g:S(e[2]||e[6]),b:S(e[3]||e[7])},i=e[4]||e[8];return void 0!==i&&(r.a=S(i)/255),r},s[t.RGB]=function(t){var e=t.match(p.RGB),r=D(e[1]||e[4]),n=D(e[2]||e[5]),i=D(e[3]||e[6]);return {r:Math.min(r,255),g:Math.min(n,255),b:Math.min(i,255)}},s[t.RGBA]=function(t){var e=t.match(p.RGBA),r=D(e[1]||e[4]),n=D(e[2]||e[5]),i=D(e[3]||e[6]),o=+e[7];return {r:Math.min(r,255),g:Math.min(n,255),b:Math.min(i,255),a:T(o)}},s[t.HSL]=function(t){var e=t.match(p.HSL),r=j(+e[1]),n=R(e[2]),i=R(e[3]);return y(r,n,i)},s[t.HSLA]=function(t){var e=t.match(p.HSLA),r=j(+e[1]),n=R(e[2]),i=R(e[3]),o=+e[4],u=y(r,n,i);return u.a=T(o),u},s[t.CMYK]=function(t){var e=t.match(p.CMYK),r=G(e[1]||e[5]),n=G(e[2]||e[6]),i=G(e[3]||e[7]),o=G(e[4]||e[8]);return E(r,n,i,o)},s),q=((c={})[t.HEX]=function(t){var e={r:D(""+t.r),g:D(""+t.g),b:D(""+t.b)};return e.a=M(t,"a")?Math.min(D(""+t.a,!0),1):1,e},c[t.RGB]=function(t){var e=this.HEX(t);return delete e.a,e},c[t.RGBA]=function(t){return this.HEX(t)},c[t.HSL]=function(t){var e=R(""+t.s),r=R(""+t.l);return y(j(t.h),e,r)},c[t.HSLA]=function(t){var e=this.HSL(t);return e.a=T(t.a),e},c[t.CMYK]=function(t){var e=G(""+t.c),r=G(""+t.m),n=G(""+t.y),i=G(""+t.k);return E(e,r,n,i)},c),Q=function(t,e){return void 0===e&&(e=U(t)),"string"==typeof t?$$1[e](t):q[e](t)},_=((d={})[t.HEX]=function(t){return {r:C(t.r),g:C(t.g),b:C(t.b)}},d.HEXA=function(t){var e=_.HEX(t);return e.a=M(t,"a")?C(255*t.a):"0xFF",e},d[t.RGB]=function(t){return M(t,"a")&&delete t.a,t},d[t.RGBA]=function(t){return t.a=M(t,"a")?O(t.a,2):1,t},d[t.HSL]=function(t){var e=B(t.r,t.g,t.b);return delete e.a,e},d[t.HSLA]=function(t){var e=_.HSL(t);return e.a=M(t,"a")?O(t.a,2):1,e},d[t.CMYK]=function(t){return H(t.r,t.g,t.b)},d),z=function(e,r,n){var o=U(e),u="string"==typeof e,a=Q(e,o),s="string"==typeof e&&M(a,"a")||"string"!=typeof e&&M(e,"a"),c=B(a.r,a.g,a.b,a.a);s||delete c.a;var d=n?c.l/(r+1):(100-c.l)/(r+1),f=Array(r).fill(null).map((function(t,e){return i(i({},c),{l:c.l+d*(e+1)*(1-2*+n)})}));switch(o){case t.HEX:default:return f.map((function(t){var e=y(t.h,t.s,t.l);return s&&(e.a=t.a),u?s?I.HEX(i(i({},e),{a:O(255*e.a,2)})):I.HEX(e):s?_.HEXA(e):_.HEX(e)}));case t.RGB:case t.RGBA:return f.map((function(t){var e=y(t.h,t.s,t.l);return s&&(e.a=t.a),u?I.RGB(e):s?_.RGBA(e):_.RGB(e)}));case t.HSL:case t.HSLA:return f.map((function(t){return u?I.HSL(t):s?_.HSLA(i(i({},y(t.h,t.s,t.l)),{a:t.a})):_.HSL(y(t.h,t.s,t.l))}))}},J=((f={buildHarmony:function(e,r,n){var i=U(e),o=Q(e,i),u=B(o.r,o.g,o.b,o.a),a="string"==typeof e&&M(o,"a")||"string"!=typeof e&&M(e,"a"),s="string"==typeof e;switch(i){case t.HEX:default:return a?this.HEXA(u,r,n,s):this.HEX(u,r,n,s);case t.HSL:return this.HSL(u,r,n,s);case t.HSLA:return this.HSLA(u,r,n,s);case t.RGB:return this.RGB(u,r,n,s);case t.RGBA:return this.RGBA(u,r,n,s)}}})[t.HEX]=function(t,e,r,n){return e(t,r).map((function(t){return n?I.HEX(y(t.h,t.s,t.l)):_.HEX(y(t.h,t.s,t.l))}))},f.HEXA=function(t,e,r,n){return e(t,r).map((function(t){return n?I.HEX(i(i({},y(t.h,t.s,t.l)),{a:255*T(t.a)})):_.HEXA(i(i({},y(t.h,t.s,t.l)),{a:T(t.a)}))}))},f[t.RGB]=function(t,e,r,n){return e(t,r).map((function(t){return n?I.RGB(y(t.h,t.s,t.l)):_.RGB(y(t.h,t.s,t.l))}))},f[t.RGBA]=function(t,e,r,n){return e(t,r).map((function(t){return n?I.RGB(i(i({},y(t.h,t.s,t.l)),{a:T(t.a)})):_.RGBA(i(i({},y(t.h,t.s,t.l)),{a:T(t.a)}))}))},f[t.HSL]=function(t,e,r,n){return e(t,r).map((function(t){return n?I.HSL({h:t.h,s:t.s,l:t.l}):_.HSL(y(t.h,t.s,t.l))}))},f[t.HSLA]=function(t,e,r,n){return e(t,r).map((function(t){return n?I.HSL(i(i({},t),{a:T(t.a)})):_.HSLA(i(i({},y(t.h,t.s,t.l)),{a:T(t.a)}))}))},f),W=((h={mix:function(t,e){var n,o,u,a,s,c,d,f,h,l,p,g,b,F,A,m=t.map((function(t){var e=U(t);return Q(t,e)})),y=e===r.SUBTRACTIVE?m.map((function(t){var e,r,n,i,o,u,a,s,c,d,f,h,l,p,g=(e=t.r,r=t.g,n=t.b,i=Math.min(e,r,n),o=Math.min(255-e,255-r,255-n),u=e-i,a=r-i,s=n-i,c=Math.min(u,a),d=u-c,f=(a+c)/2,h=(s+a-c)/2,l=Math.max(d,f,h)/Math.max(u,a,s),p=isNaN(l)||l===1/0||l<=0?1:l,{r:d/p+o,y:f/p+o,b:h/p+o});return M(t,"a")&&(g.a=t.a),g})):null;function E(t){var n=e===r.ADDITIVE?{r:0,g:0,b:0,a:0}:{r:0,y:0,b:0,a:0};return t.reduce((function(t,n){var o=M(n,"a")?n.a:1,u={r:Math.min(t.r+n.r*o,255),b:Math.min(t.b+n.b*o,255),a:1-(1-o)*(1-t.a)},a="g"in t?t.g:t.y,s="g"in n?n.g:n.y;return i(i({},u),e===r.ADDITIVE?{g:Math.min(a+s*o,255)}:{y:Math.min(a+s*o,255)})}),n)}if(e===r.ADDITIVE)n=E(m);else {var H=E(y);o=H.r,u=H.y,a=H.b,s=Math.min(o,u,a),c=Math.min(255-o,255-u,255-a),d=o-s,f=u-s,h=a-s,l=Math.min(f,h),p=d+f-l,g=f+2*l,b=2*(h-l),F=Math.max(p,g,b)/Math.max(d,f,h),A=isNaN(F)||F===1/0||F<=0?1:F,(n={r:p/A+c,g:g/A+c,b:b/A+c}).a=H.a;}return {r:O(n.r,2),g:O(n.g,2),b:O(n.b,2),a:X(n.a,0,1)}}})[t.HEX]=function(t,e,r){var n=this.mix(t,e);return delete n.a,r?I.HEX(n):_.HEX(n)},h.HEXA=function(t,e,r){var n=this.mix(t,e);return n.a=r?255*T(n.a):T(n.a),r?I.HEX(n):_.HEXA(n)},h[t.RGB]=function(t,e,r){var n=this.mix(t,e);return delete n.a,r?I.RGB(n):_.RGB(n)},h[t.RGBA]=function(t,e,r){var n=this.mix(t,e);return r?I.RGB(n):_.RGBA(n)},h[t.HSL]=function(t,e,r){var n=this.mix(t,e),i=B(n.r,n.g,n.b);return delete n.a,delete i.a,r?I.HSL(i):_.HSL(n)},h[t.HSLA]=function(t,e,r){var n=this.mix(t,e),i=B(n.r,n.g,n.b,n.a);return r?I.HSL(i):_.HSLA(n)},h),Z=function(t,e){return "string"==typeof t&&e||"object"==typeof t&&!e},tt=function(t,e,r,n,i){var o=n(Q(t,e));return r?i(o):o},et=function(t,e,r,n,i,o){r<1&&(r=5);var u=function(t,e,r){var n=r-1,i=(e.r-t.r)/n,o=(e.g-t.g)/n,u=(e.b-t.b)/n,a=T(t.a),s=(T(e.a)-a)/n;return Array(r).fill(null).map((function(r,c){return 0===c?t:c===n?e:{r:O(t.r+i*c),g:O(t.g+o*c),b:O(t.b+u*c),a:O(a+s*c,2)}}))}(Q(t),Q(e),r);return u.map((function(t){var e=i(t);return n?o(e):e}))},rt=function(){function n(t){this.rgb=Q(t),this.updateHSL(),this.updateCMYK();}return n.prototype.updateRGB=function(){this.rgb=i(i({},y(this.hsl.h,this.hsl.s,this.hsl.l)),{a:this.hsl.a});},n.prototype.updateRGBFromCMYK=function(){this.rgb=i(i({},E(this.cmyk.c,this.cmyk.m,this.cmyk.y,this.cmyk.k)),{a:this.rgb.a});},n.prototype.updateHSL=function(){this.hsl=B(this.rgb.r,this.rgb.g,this.rgb.b,this.rgb.a);},n.prototype.updateCMYK=function(){this.cmyk=H(this.rgb.r,this.rgb.g,this.rgb.b);},n.prototype.updateRGBAndCMYK=function(){return this.updateRGB(),this.updateCMYK(),this},n.prototype.updateHSLAndCMYK=function(){return this.updateHSL(),this.updateCMYK(),this},n.prototype.updateRGBAndHSL=function(){return this.updateRGBFromCMYK(),this.updateHSL(),this},n.prototype.setH=function(t){return this.hsl.h=j(t),this.updateRGBAndCMYK()},n.prototype.setS=function(t){return this.hsl.s=X(t,0,100),this.updateRGBAndCMYK()},n.prototype.setL=function(t){return this.hsl.l=X(t,0,100),this.updateRGBAndCMYK()},n.prototype.setR=function(t){return this.rgb.r=X(t,0,255),this.updateHSLAndCMYK()},n.prototype.setG=function(t){return this.rgb.g=X(t,0,255),this.updateHSLAndCMYK()},n.prototype.setB=function(t){return this.rgb.b=X(t,0,255),this.updateHSLAndCMYK()},n.prototype.setA=function(t){return this.hsl.a=this.rgb.a=X(t,0,1),this},n.prototype.setC=function(t){return this.cmyk.c=X(t,0,100),this.updateRGBAndHSL()},n.prototype.setM=function(t){return this.cmyk.m=X(t,0,100),this.updateRGBAndHSL()},n.prototype.setY=function(t){return this.cmyk.y=X(t,0,100),this.updateRGBAndHSL()},n.prototype.setK=function(t){return this.cmyk.k=X(t,0,100),this.updateRGBAndHSL()},Object.defineProperty(n.prototype,"H",{get:function(){return O(this.hsl.h)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"S",{get:function(){return O(this.hsl.s)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"L",{get:function(){return O(this.hsl.l)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"R",{get:function(){return O(this.rgb.r)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"G",{get:function(){return O(this.rgb.g)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"B",{get:function(){return O(this.rgb.b)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"A",{get:function(){return O(this.hsl.a,2)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"C",{get:function(){return O(this.cmyk.c)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"M",{get:function(){return O(this.cmyk.m)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"Y",{get:function(){return O(this.cmyk.y)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"K",{get:function(){return O(this.cmyk.k)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HEXObject",{get:function(){return _.HEX(this.rgb)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HEXAObject",{get:function(){return _.HEXA(this.rgb)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"RGBObject",{get:function(){return {r:this.R,g:this.G,b:this.B}},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"RGBAObject",{get:function(){return i(i({},this.RGBObject),{a:this.A})},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HSLObject",{get:function(){return {h:this.H,s:this.S,l:this.L}},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HSLAObject",{get:function(){return i(i({},this.HSLObject),{a:this.A})},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"CMYKObject",{get:function(){return {c:this.C,m:this.M,y:this.Y,k:this.K}},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HEX",{get:function(){var t=this.rgb,e={r:t.r,g:t.g,b:t.b};return I.HEX(e)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HEXA",{get:function(){var t=this.rgb,e={r:t.r,g:t.g,b:t.b,a:255*this.A};return I.HEX(e)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"RGB",{get:function(){var t=this.rgb,e={r:t.r,g:t.g,b:t.b};return I.RGB(e)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"RGBA",{get:function(){var t=this.rgb,e={r:t.r,g:t.g,b:t.b,a:this.A};return I.RGB(e)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HSL",{get:function(){var t=this.hsl,e={h:t.h,s:t.s,l:t.l};return I.HSL(e)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"HSLA",{get:function(){return I.HSL(this.hsl)},enumerable:!1,configurable:!0}),Object.defineProperty(n.prototype,"CMYK",{get:function(){return I.CMYK(this.cmyk)},enumerable:!1,configurable:!0}),n.toHEX=function(t,e){void 0===e&&(e=!0);var r=U(t);return tt(t,r,e,_.HEX,I.HEX)},n.toHEXA=function(t,e){void 0===e&&(e=!0);var r=U(t);return tt(t,r,e,_.HEXA,I.HEX)},n.toRGB=function(t,e){void 0===e&&(e=!0);var r=U(t);return tt(t,r,e,_.RGB,I.RGB)},n.toRGBA=function(t,e){void 0===e&&(e=!0);var r=U(t);return tt(t,r,e,_.RGBA,I.RGB)},n.toHSL=function(e,r){void 0===r&&(r=!0);var n=U(e);return n===t.HSL&&Z(e,r)?e:tt(e,n,r,_.HSL,I.HSL)},n.toHSLA=function(e,r){void 0===r&&(r=!0);var n=U(e);return n===t.HSLA&&Z(e,r)?e:tt(e,n,r,_.HSLA,I.HSL)},n.toCMYK=function(e,r){void 0===r&&(r=!0);var n=U(e);return n===t.CMYK&&Z(e,r)?e:tt(e,n,r,_.CMYK,I.CMYK)},n.getBlendHEX=function(t,e,r,n){return void 0===r&&(r=5),void 0===n&&(n=!0),et(t,e,r,n,_.HEX,I.HEX)},n.getBlendHEXA=function(t,e,r,n){return void 0===r&&(r=5),void 0===n&&(n=!0),et(t,e,r,n,_.HEXA,I.HEX)},n.getBlendRGB=function(t,e,r,n){return void 0===r&&(r=5),void 0===n&&(n=!0),et(t,e,r,n,_.RGB,I.RGB)},n.getBlendRGBA=function(t,e,r,n){return void 0===r&&(r=5),void 0===n&&(n=!0),et(t,e,r,n,_.RGBA,I.RGB)},n.getBlendHSL=function(t,e,r,n){return void 0===r&&(r=5),void 0===n&&(n=!0),et(t,e,r,n,_.HSL,I.HSL)},n.getBlendHSLA=function(t,e,r,n){return void 0===r&&(r=5),void 0===n&&(n=!0),et(t,e,r,n,_.HSLA,I.HSL)},n.getMixHEX=function(t,e,n){return void 0===e&&(e=r.ADDITIVE),void 0===n&&(n=!0),W.HEX(t,e,n)},n.getMixHEXA=function(t,e,n){return void 0===e&&(e=r.ADDITIVE),void 0===n&&(n=!0),W.HEXA(t,e,n)},n.getMixRGB=function(t,e,n){return void 0===e&&(e=r.ADDITIVE),void 0===n&&(n=!0),W.RGB(t,e,n)},n.getMixRGBA=function(t,e,n){return void 0===e&&(e=r.ADDITIVE),void 0===n&&(n=!0),W.RGBA(t,e,n)},n.getMixHSL=function(t,e,n){return void 0===e&&(e=r.ADDITIVE),void 0===n&&(n=!0),W.HSL(t,e,n)},n.getMixHSLA=function(t,e,n){return void 0===e&&(e=r.ADDITIVE),void 0===n&&(n=!0),W.HSLA(t,e,n)},n.getShades=function(t,e){return z(t,e,!0)},n.getTints=function(t,e){return z(t,e,!1)},n.getHarmony=function(t,n,i){switch(void 0===n&&(n=e.COMPLEMENTARY),void 0===i&&(i=r.ADDITIVE),n){case e.ANALOGOUS:return J.buildHarmony(t,P,i);case e.SPLIT_COMPLEMENTARY:return J.buildHarmony(t,K,i);case e.TRIADIC:return J.buildHarmony(t,x,i);case e.TETRADIC:return J.buildHarmony(t,N,i);case e.SQUARE:return J.buildHarmony(t,V,i);default:return J.buildHarmony(t,w,i)}},n}();

function _defineProperty$a(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * Class which implements the UI of a Portlet
 *
 * This manages the frame and decoration, but also provides the UI for properties.
 *
 * Portlets are only internal to EGroupware.
 *
 * Home does not fully implement WSRP, but tries not to conflict, ether.
 * @link http://docs.oasis-open.org/wsrp/v2/wsrp-2.0-spec-os-01.html
 * @augments et2_baseWidget
 */
class et2_portlet extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_portlet
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_portlet._attributes, _child || {}));
    _defineProperty$a(this, "GRID", 55);
    _defineProperty$a(this, "settings", void 0);
    /**
     * These are the "normal" actions that every portlet is expected to have.
     * The widget provides default actions for all of these, but they can
     * be added to or overridden if needed by setting the action attribute.
     */
    _defineProperty$a(this, "default_actions", {
      edit_settings: {
        icon: "edit",
        caption: "Configure",
        "default": true,
        hideOnDisabled: true,
        group: "portlet"
      },
      remove_portlet: {
        icon: "delete",
        caption: "Remove",
        group: "portlet"
      }
    });
    _defineProperty$a(this, "div", void 0);
    _defineProperty$a(this, "header", void 0);
    _defineProperty$a(this, "content", void 0);
    var self = this;

    // Create DOM nodes
    this.div = jQuery(document.createElement("div")).addClass(this.options.class).addClass("ui-widget ui-widget-content ui-corner-all").addClass("et2_portlet")
    /* Gridster */.attr("data-sizex", this.options.width).attr("data-sizey", this.options.height).attr("data-row", this.options.row).attr("data-col", this.options.col).resizable({
      autoHide: true,
      grid: this.GRID,
      //containment: this.getParent().getDOMNode(),
      stop: function stop(event, ui) {
        self.set_width(Math.round(ui.size.width / self.GRID));
        self.set_height(Math.round(ui.size.height / self.GRID));
        self.egw().jsonq("home.home_ui.ajax_set_properties", [self.id, {}, {
          width: self.options.width,
          height: self.options.height
        }], null, self);
        // Tell children
        self.iterateOver(function (widget) {
          if (typeof widget.resize === 'function') {
            widget.resize();
          }
        }, null, et2_IResizeable);
      }
    });
    this.header = jQuery(document.createElement("div")).attr('id', this.getInstanceManager().uniqueId + '_' + this.id.replace(/\./g, '-') + '_header').addClass("ui-widget-header ui-corner-all").appendTo(this.div).html(this.options.title);
    this.content = jQuery(document.createElement("div")).attr('id', this.getInstanceManager().uniqueId + '_' + this.id.replace(/\./g, '-') + '_content').appendTo(this.div);
    this.setDOMNode(this.div[0]);
  }
  destroy() {
    for (var i = 0; i < this._children.length; i++) {
      // Check for child is a different template and clear it,
      // since it won't be cleared by destroy()
      if (this._children[i].getInstanceManager() != this.getInstanceManager()) {
        this._children[i].getInstanceManager().clear();
      }
    }
    super.destroy();
  }
  doLoadingFinished() {
    this.set_color(this.options.color);
    return true;
  }

  /**
   * If anyone asks, return the content node, so content goes inside
   */
  getDOMNode(_sender) {
    if (typeof _sender != 'undefined' && _sender != this) {
      return this.content[0];
    }
    return super.getDOMNode(_sender);
  }

  /**
   * Overriden from parent to add in default actions
   */
  set_actions(actions) {
    // Set targets for actions
    var defaults = {};
    for (var action_name in this.default_actions) {
      defaults[action_name] = this.default_actions[action_name];
      // Translate caption here, as translations aren't available earlier
      defaults[action_name].caption = this.egw().lang(this.default_actions[action_name].caption);
      if (typeof this[action_name] == "function") {
        defaults[action_name].onExecute = jQuery.proxy(this[action_name], this);
      }
    }

    // Add in defaults, but let provided actions override them
    this.options.actions = jQuery.extend(true, {}, defaults, actions);
    super.set_actions(this.options.actions);
  }

  /**
   * Override _link_actions to remove edit action, if there is no settings
   *
   * @param actions
   */
  _link_actions(actions) {
    // Get the top level element
    var objectManager = egw_getAppObjectManager(true);
    var widget_object = objectManager.getObjectById(this.id);
    if (widget_object == null) {
      // Add a new container to the object manager which will hold the widget
      // objects
      widget_object = objectManager.insertObject(false, new egwActionObject(this.id, objectManager, new et2_action_object_impl(this).getAOI(), this._actionManager || objectManager.manager.getActionById(this.id) || objectManager.manager));
    }

    // Delete all old objects
    widget_object.clear();

    // Go over the widget & add links - this is where we decide which actions are
    // 'allowed' for this widget at this time
    var action_links = [];
    for (var i in actions) {
      var id = typeof actions[i].id != 'undefined' ? actions[i].id : i;
      var action = {
        actionId: id,
        enabled: true
      };

      // If there are no settings, there can be no customization, so remove the edit action
      if (id == 'edit_settings' && (!this.options.settings || jQuery.isEmptyObject(this.options.settings))) {
        this.egw().debug("log", "No settings for portlet %o, edit_settings action removed", this);
        action.enabled = false;
      }
      action_links.push(action);
    }
    widget_object.updateActionLinks(action_links);
  }

  /**
   * Create & show a dialog for customizing this portlet
   *
   * Properties for customization are sent in the 'settings' attribute
   */
  edit_settings() {
    var dialog = new Et2Dialog$1(this.egw());
    dialog.transformAttributes({
      callback: this._process_edit.bind(this),
      template: this.options.edit_template,
      value: {
        content: this.options.settings
      },
      buttons: Et2Dialog$1.BUTTONS_OK_CANCEL
    });
    // Set separately to avoid translation
    dialog.title = this.egw().lang("Edit") + " " + (this.options.title || '');
  }
  _process_edit(button_id, value) {
    if (button_id != Et2Dialog$1.OK_BUTTON) {
      return;
    }

    // Save settings - server might reply with new content if the portlet needs an update,
    // but ideally it doesn't
    this.div.addClass("loading");

    // Pass updated settings, unless we're removing
    var settings = typeof value == 'string' ? {} : this.options.settings || {};
    this.egw().jsonq("home.home_ui.ajax_set_properties", [this.id, settings, value, this.settings ? this.settings.group : false], function (data) {
      // This section not for us
      if (!data || typeof data.attributes == 'undefined') return false;
      this.div.removeClass("loading");
      this.set_value(data.content);
      for (var key in data.attributes) {
        if (typeof this["set_" + key] == "function") {
          this["set_" + key].call(this, data.attributes[key]);
        } else if (this.attributes[key]) {
          this.options[key] = data.attributes[key];
        }
      }

      // Flagged as needing to edit settings?  Open dialog
      if (typeof data.edit_settings != 'undefined' && data.edit_settings) {
        this.edit_settings();
      }

      // Only resize once, and only if needed
      if (data.attributes.width || data.attributes.height) {
        // Tell children
        try {
          this.iterateOver(function (widget) {
            if (typeof widget.resize === 'function') {
              widget.resize();
            }
          }, null, et2_IResizeable);
        } catch (e) {
          // Something went wrong, but do not stop
          egw$1.debug('warn', e, this);
        }
      }
    }, this);

    // Extend, not replace, because settings has types while value has just value
    if (typeof value == 'object') {
      jQuery.extend(this.options.settings, value);
    }
  }

  /**
   * Remove this portlet from the home page
   */
  remove_portlet() {
    var self = this;
    Et2Dialog$1.show_dialog(function (button_id) {
      if (button_id != Et2Dialog$1.OK_BUTTON) {
        return;
      }
      self._process_edit(button_id, '~remove~');
      self.getParent().removeChild(self);
      self.destroy();
    }, this.egw().lang("Remove"), this.options.title, {}, Et2Dialog$1.BUTTONS_OK_CANCEL, Et2Dialog$1.QUESTION_MESSAGE);
  }

  /**
   * Set the HTML content of the portlet
   *
   * @param value String HTML fragment
   */
  set_value(value) {
    this.content.html(value);
  }

  /**
   * Set the content of the header
   *
   * @param value String HTML fragment
   */
  set_title(value) {
    this.header.contents().filter(function () {
      return this.nodeType === 3;
    }).remove();
    this.options.title = value;
    this.header.append(value);
  }

  /**
   * Let this portlet stand out a little by allowing a custom color
   */
  set_color(color) {
    this.options.color = color;
    this.header.css("backgroundColor", color);
    this.header.css('color', new rt(this.header.css("backgroundColor")).L > 50 ? 'black' : 'white');
    this.content.css("backgroundColor", color);
  }

  /**
   * Set the number of grid cells this widget spans
   *
   * @param value int Number of horizontal grid cells
   */
  set_width(value) {
    this.options.width = value;
    this.div.attr("data-sizex", value);
    // Clear what's there from jQuery, we get width from CSS according to sizex
    this.div.css('width', '');
  }

  /**
   * Set the number of vertical grid cells this widget spans
   *
   * @param value int Number of vertical grid cells
   */
  set_height(value) {
    this.options.height = value;
    this.div.attr("data-sizey", value);
    // Clear what's there from jQuery, we get width from CSS according to sizey
    this.div.css('height', '');
  }
}
_defineProperty$a(et2_portlet, "_attributes", {
  "title": {
    "name": "Title",
    "description": "Goes in the little bit at the top with the icons",
    "type": "string",
    "default": ""
  },
  "edit_template": {
    "name": "Edit template",
    "description": "Custom eTemplate used to customize / set up the portlet",
    "type": "string",
    "default": egw$1.webserverUrl + "/home/templates/default/edit.xet"
  },
  "color": {
    "name": "Color",
    "description": "Set the portlet color",
    "type": "string",
    "default": ''
  },
  "settings": {
    "name": "Customization settings",
    "description": "Array of customization settings, similar in structure to preference settings",
    "type": "any",
    "default": et2_no_init
  },
  "actions": {
    default: {}
  },
  "width": {
    "default": 2,
    "ignore": true
  },
  "height": {
    "default": 1,
    "type": "integer"
  },
  "rows": {
    "ignore": true,
    default: et2_no_init
  },
  "cols": {
    "ignore": true,
    default: et2_no_init
  },
  "resize_ratio": {
    "ignore": true,
    default: et2_no_init
  },
  // Portlets are explicitly sized
  "row": {
    "name": "Row",
    "description": "Home page location (row) - handled by home app",
    "default": 1
  },
  "col": {
    "name": "Column",
    "description": "Home page location(column) - handled by home app",
    "default": 1
  }
});
et2_register_widget(et2_portlet, ["portlet"]);

function _defineProperty$9(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Using AJAX, this widget allows a type-ahead find similar to a ComboBox, where as the user enters information,
 * a drop-down box is populated with the n closest matches.  If the user clicks on an item in the drop-down, that
 * value is selected.
 * n is the maximum number of results set in the user's preferences.
 * The user is restricted to selecting values in the list.
 * This widget can get data from any function that can provide data to a nextmatch widget.
 * @augments et2_inputWidget
 */
class et2_ajaxSelect extends et2_inputWidget {
  /**
   * Constructor
   *
   * @memberOf et2_ajaxSelect
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_ajaxSelect._attributes, _child || {}));
    _defineProperty$9(this, "input", null);
    if (typeof _attrs.get_rows == 'string') {
      _attrs.get_rows = this.egw().link('/index.php', {
        menuaction: this.options.get_rows
      });
    }
    this.createInputWidget();
    this.input = null;
    this.createInputWidget();
  }
  createInputWidget() {
    this.input = jQuery(document.createElement("input"));
    this.input.addClass("et2_textbox");
    this.setDOMNode(this.input[0]);
    var widget = this;
    this.input.autocomplete({
      delay: 100,
      source: this.options.get_rows ? this.options.get_rows : find_select_options(this, this.options.values),
      select: function select(event, ui) {
        widget.value = ui.item[widget.options.id_field];
        if (widget.options.get_title) {
          if (typeof widget.options.get_title == 'function') {
            widget.input.val(widget.options.get_title.call(widget.value));
          } else if (typeof widget.options.get_title == 'string') {
            // TODO: Server side callback
          }
        } else {
          widget.input.val(ui.item.label);
        }
        // Prevent default action of setting field to the value
        return false;
      }
    });
  }
  getValue() {
    if (this.options.blur && this.input.val() == this.options.blur) return "";
    return this.value;
  }
  set_value(_value) {
    this.value = _value;
    if (this.input.autocomplete('instance')) {
      var source = this.input.autocomplete('option', 'source');
      if (typeof source == 'object') {
        for (var i in source) {
          if (typeof source[i].value != 'undefined' && typeof source[i].label != 'undefined' && source[i].value === _value) {
            this.input.val(source[i].label);
          } else if (typeof source[i] == 'string') {
            this.input.val(source[_value]);
            break;
          }
        }
      } else if (typeof source == 'function') {
        // TODO
      }
    }
  }
  set_blur(_value) {
    if (_value) {
      this.input.attr("placeholder", _value + ""); // HTML5
      if (!this.input[0]["placeholder"]) {
        // Not HTML5
        if (this.input.val() == "") this.input.val(this.options.blur);
        this.input.focus(this, function (e) {
          if (e.data.input.val() == e.data.options.blur) e.data.input.val("");
        }).blur(this, function (e) {
          if (e.data.input.val() == "") e.data.input.val(e.data.options.blur);
        });
      }
    } else {
      this.input.removeAttr("placeholder");
    }
  }
}
_defineProperty$9(et2_ajaxSelect, "_attributes", {
  'get_rows': {
    "name": "Data source",
    "type": "any",
    "default": "",
    "description": "Function to get search results, either a javascript function or server-side."
  },
  'get_title': {
    "name": "Title function",
    "type": "any",
    "default": "",
    "description": "Function to get title for selected entry.  Used when closed, and if no template is given."
  },
  'id_field': {
    "name": "Result ID field",
    "type": "string",
    "default": "value",
    "description": "Which key in result sub-array to look for row ID.  If omitted, the key for the row will be used."
  },
  'template': {
    "name": "Row template",
    "type": "string",
    "default": "",
    "description": "ID of the template to use to display rows.  If omitted, title will be shown for each result."
  },
  'filter': {
    "name": "Filter",
    "type": "string",
    "default": "",
    "description": "Apply filter to search results.  Same as nextmatch."
  },
  'filter2': {
    "name": "Filter 2",
    "type": "string",
    "default": "",
    "description": "Apply filter to search results.  Same as nextmatch."
  },
  'link': {
    "name": "Read only link",
    "type": "boolean",
    "default": "true",
    "description": "If readonly, widget will be text.  If link is set, widget will be a link."
  },
  // Pass by code only
  'values': {
    "name": "Values",
    "type": "any",
    "default": {},
    "description": "Specify the available options.  Use this, or Data source."
  }
});
et2_register_widget(et2_ajaxSelect, ["ajax_select"]);

/**
* et2_textbox_ro is the dummy readonly implementation of the textbox.
* @augments et2_valueWidget
*/
class et2_ajaxSelect_ro extends et2_valueWidget {
  /**
   * Constructor
   *
   * @memberOf et2_ajaxSelect_ro
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_ajaxSelect_ro._attributes, _child || {}));
    _defineProperty$9(this, "span", void 0);
    this.value = "";
    this.span = jQuery(document.createElement("span"));
    this.setDOMNode(this.span[0]);
  }
  set_value(_value) {
    this.value = _value;
    if (!_value) _value = "";
    this.span.text(_value);
  }
  /**
   * Code for implementing et2_IDetachedDOM
   */
  getDetachedAttributes(_attrs) {
    _attrs.push("value");
  }
  getDetachedNodes() {
    return [this.span[0]];
  }
  setDetachedAttributes(_nodes, _values) {
    this.span = jQuery(_nodes[0]);
    if (typeof _values["value"] != 'undefined') {
      this.set_value(_values["value"]);
    }
  }
}
/**
 * Ignore all more advanced attributes.
 */
_defineProperty$9(et2_ajaxSelect_ro, "_attributes", {
  "multiline": {
    "ignore": true
  }
});
et2_register_widget(et2_ajaxSelect_ro, ["ajax_select_ro"]);

var web_urlSearchParams = {};

var fails = fails$e;
var wellKnownSymbol$1 = wellKnownSymbol$f;
var DESCRIPTORS$1 = descriptors;
var IS_PURE = isPure;

var ITERATOR$1 = wellKnownSymbol$1('iterator');

var urlConstructorDetection = !fails(function () {
  // eslint-disable-next-line unicorn/relative-url-style -- required for testing
  var url = new URL('b?a=1&b=2&c=3', 'http://a');
  var searchParams = url.searchParams;
  var result = '';
  url.pathname = 'c%20d';
  searchParams.forEach(function (value, key) {
    searchParams['delete']('b');
    result += key + value;
  });
  return (IS_PURE && !url.toJSON)
    || (!searchParams.size && (IS_PURE || !DESCRIPTORS$1))
    || !searchParams.sort
    || url.href !== 'http://a/c%20d?a=1&c=3'
    || searchParams.get('c') !== '3'
    || String(new URLSearchParams('?a=1')) !== 'a=1'
    || !searchParams[ITERATOR$1]
    // throws in Edge
    || new URL('https://a@b').username !== 'a'
    || new URLSearchParams(new URLSearchParams('a=b')).get('a') !== 'b'
    // not punycoded in Edge
    || new URL('http://тест').host !== 'xn--e1aybc'
    // not escaped in Chrome 62-
    || new URL('http://a#б').hash !== '#%D0%B1'
    // fails in Chrome 66-
    || result !== 'a1c3'
    // throws in Safari
    || new URL('http://x', undefined).host !== 'x';
});

var defineBuiltIn$1 = defineBuiltIn$8;

var defineBuiltIns$1 = function (target, src, options) {
  for (var key in src) defineBuiltIn$1(target, key, src[key], options);
  return target;
};

'use strict';
// TODO: in core-js@4, move /modules/ dependencies to public entries for better optimization by tools like `preset-env`

var $ = _export;
var global$2 = global$c;
var call = functionCall;
var uncurryThis = functionUncurryThis;
var DESCRIPTORS = descriptors;
var USE_NATIVE_URL = urlConstructorDetection;
var defineBuiltIn = defineBuiltIn$8;
var defineBuiltInAccessor = defineBuiltInAccessor$4;
var defineBuiltIns = defineBuiltIns$1;
var setToStringTag = setToStringTag$4;
var createIteratorConstructor = iteratorCreateConstructor;
var InternalStateModule = internalState;
var anInstance = anInstance$2;
var isCallable = isCallable$f;
var hasOwn = hasOwnProperty_1;
var bind = functionBindContext;
var classof = classof$5;
var anObject = anObject$a;
var isObject = isObject$5;
var $toString = toString$a;
var create = objectCreate;
var createPropertyDescriptor = createPropertyDescriptor$3;
var getIterator = getIterator$2;
var getIteratorMethod = getIteratorMethod$3;
var validateArgumentsLength = validateArgumentsLength$2;
var wellKnownSymbol = wellKnownSymbol$f;
var arraySort = arraySort$1;

var ITERATOR = wellKnownSymbol('iterator');
var URL_SEARCH_PARAMS = 'URLSearchParams';
var URL_SEARCH_PARAMS_ITERATOR = URL_SEARCH_PARAMS + 'Iterator';
var setInternalState = InternalStateModule.set;
var getInternalParamsState = InternalStateModule.getterFor(URL_SEARCH_PARAMS);
var getInternalIteratorState = InternalStateModule.getterFor(URL_SEARCH_PARAMS_ITERATOR);
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Avoid NodeJS experimental warning
var safeGetBuiltIn = function (name) {
  if (!DESCRIPTORS) return global$2[name];
  var descriptor = getOwnPropertyDescriptor(global$2, name);
  return descriptor && descriptor.value;
};

var nativeFetch = safeGetBuiltIn('fetch');
var NativeRequest = safeGetBuiltIn('Request');
var Headers$1 = safeGetBuiltIn('Headers');
var RequestPrototype = NativeRequest && NativeRequest.prototype;
var HeadersPrototype = Headers$1 && Headers$1.prototype;
var RegExp$1 = global$2.RegExp;
var TypeError$1 = global$2.TypeError;
var decodeURIComponent$1 = global$2.decodeURIComponent;
var encodeURIComponent$1 = global$2.encodeURIComponent;
var charAt = uncurryThis(''.charAt);
var join = uncurryThis([].join);
var push = uncurryThis([].push);
var replace = uncurryThis(''.replace);
var shift = uncurryThis([].shift);
var splice = uncurryThis([].splice);
var split = uncurryThis(''.split);
var stringSlice = uncurryThis(''.slice);

var plus = /\+/g;
var sequences = Array(4);

var percentSequence = function (bytes) {
  return sequences[bytes - 1] || (sequences[bytes - 1] = RegExp$1('((?:%[\\da-f]{2}){' + bytes + '})', 'gi'));
};

var percentDecode = function (sequence) {
  try {
    return decodeURIComponent$1(sequence);
  } catch (error) {
    return sequence;
  }
};

var deserialize = function (it) {
  var result = replace(it, plus, ' ');
  var bytes = 4;
  try {
    return decodeURIComponent$1(result);
  } catch (error) {
    while (bytes) {
      result = replace(result, percentSequence(bytes--), percentDecode);
    }
    return result;
  }
};

var find = /[!'()~]|%20/g;

var replacements = {
  '!': '%21',
  "'": '%27',
  '(': '%28',
  ')': '%29',
  '~': '%7E',
  '%20': '+'
};

var replacer = function (match) {
  return replacements[match];
};

var serialize = function (it) {
  return replace(encodeURIComponent$1(it), find, replacer);
};

var URLSearchParamsIterator = createIteratorConstructor(function Iterator(params, kind) {
  setInternalState(this, {
    type: URL_SEARCH_PARAMS_ITERATOR,
    iterator: getIterator(getInternalParamsState(params).entries),
    kind: kind
  });
}, 'Iterator', function next() {
  var state = getInternalIteratorState(this);
  var kind = state.kind;
  var step = state.iterator.next();
  var entry = step.value;
  if (!step.done) {
    step.value = kind === 'keys' ? entry.key : kind === 'values' ? entry.value : [entry.key, entry.value];
  } return step;
}, true);

var URLSearchParamsState = function (init) {
  this.entries = [];
  this.url = null;

  if (init !== undefined) {
    if (isObject(init)) this.parseObject(init);
    else this.parseQuery(typeof init == 'string' ? charAt(init, 0) === '?' ? stringSlice(init, 1) : init : $toString(init));
  }
};

URLSearchParamsState.prototype = {
  type: URL_SEARCH_PARAMS,
  bindURL: function (url) {
    this.url = url;
    this.update();
  },
  parseObject: function (object) {
    var iteratorMethod = getIteratorMethod(object);
    var iterator, next, step, entryIterator, entryNext, first, second;

    if (iteratorMethod) {
      iterator = getIterator(object, iteratorMethod);
      next = iterator.next;
      while (!(step = call(next, iterator)).done) {
        entryIterator = getIterator(anObject(step.value));
        entryNext = entryIterator.next;
        if (
          (first = call(entryNext, entryIterator)).done ||
          (second = call(entryNext, entryIterator)).done ||
          !call(entryNext, entryIterator).done
        ) throw TypeError$1('Expected sequence with length 2');
        push(this.entries, { key: $toString(first.value), value: $toString(second.value) });
      }
    } else for (var key in object) if (hasOwn(object, key)) {
      push(this.entries, { key: key, value: $toString(object[key]) });
    }
  },
  parseQuery: function (query) {
    if (query) {
      var attributes = split(query, '&');
      var index = 0;
      var attribute, entry;
      while (index < attributes.length) {
        attribute = attributes[index++];
        if (attribute.length) {
          entry = split(attribute, '=');
          push(this.entries, {
            key: deserialize(shift(entry)),
            value: deserialize(join(entry, '='))
          });
        }
      }
    }
  },
  serialize: function () {
    var entries = this.entries;
    var result = [];
    var index = 0;
    var entry;
    while (index < entries.length) {
      entry = entries[index++];
      push(result, serialize(entry.key) + '=' + serialize(entry.value));
    } return join(result, '&');
  },
  update: function () {
    this.entries.length = 0;
    this.parseQuery(this.url.query);
  },
  updateURL: function () {
    if (this.url) this.url.update();
  }
};

// `URLSearchParams` constructor
// https://url.spec.whatwg.org/#interface-urlsearchparams
var URLSearchParamsConstructor = function URLSearchParams(/* init */) {
  anInstance(this, URLSearchParamsPrototype);
  var init = arguments.length > 0 ? arguments[0] : undefined;
  var state = setInternalState(this, new URLSearchParamsState(init));
  if (!DESCRIPTORS) this.length = state.entries.length;
};

var URLSearchParamsPrototype = URLSearchParamsConstructor.prototype;

defineBuiltIns(URLSearchParamsPrototype, {
  // `URLSearchParams.prototype.append` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-append
  append: function append(name, value) {
    validateArgumentsLength(arguments.length, 2);
    var state = getInternalParamsState(this);
    push(state.entries, { key: $toString(name), value: $toString(value) });
    if (!DESCRIPTORS) this.length++;
    state.updateURL();
  },
  // `URLSearchParams.prototype.delete` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-delete
  'delete': function (name) {
    validateArgumentsLength(arguments.length, 1);
    var state = getInternalParamsState(this);
    var entries = state.entries;
    var key = $toString(name);
    var index = 0;
    while (index < entries.length) {
      if (entries[index].key === key) splice(entries, index, 1);
      else index++;
    }
    if (!DESCRIPTORS) this.length = entries.length;
    state.updateURL();
  },
  // `URLSearchParams.prototype.get` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-get
  get: function get(name) {
    validateArgumentsLength(arguments.length, 1);
    var entries = getInternalParamsState(this).entries;
    var key = $toString(name);
    var index = 0;
    for (; index < entries.length; index++) {
      if (entries[index].key === key) return entries[index].value;
    }
    return null;
  },
  // `URLSearchParams.prototype.getAll` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-getall
  getAll: function getAll(name) {
    validateArgumentsLength(arguments.length, 1);
    var entries = getInternalParamsState(this).entries;
    var key = $toString(name);
    var result = [];
    var index = 0;
    for (; index < entries.length; index++) {
      if (entries[index].key === key) push(result, entries[index].value);
    }
    return result;
  },
  // `URLSearchParams.prototype.has` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-has
  has: function has(name) {
    validateArgumentsLength(arguments.length, 1);
    var entries = getInternalParamsState(this).entries;
    var key = $toString(name);
    var index = 0;
    while (index < entries.length) {
      if (entries[index++].key === key) return true;
    }
    return false;
  },
  // `URLSearchParams.prototype.set` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-set
  set: function set(name, value) {
    validateArgumentsLength(arguments.length, 1);
    var state = getInternalParamsState(this);
    var entries = state.entries;
    var found = false;
    var key = $toString(name);
    var val = $toString(value);
    var index = 0;
    var entry;
    for (; index < entries.length; index++) {
      entry = entries[index];
      if (entry.key === key) {
        if (found) splice(entries, index--, 1);
        else {
          found = true;
          entry.value = val;
        }
      }
    }
    if (!found) push(entries, { key: key, value: val });
    if (!DESCRIPTORS) this.length = entries.length;
    state.updateURL();
  },
  // `URLSearchParams.prototype.sort` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-sort
  sort: function sort() {
    var state = getInternalParamsState(this);
    arraySort(state.entries, function (a, b) {
      return a.key > b.key ? 1 : -1;
    });
    state.updateURL();
  },
  // `URLSearchParams.prototype.forEach` method
  forEach: function forEach(callback /* , thisArg */) {
    var entries = getInternalParamsState(this).entries;
    var boundFunction = bind(callback, arguments.length > 1 ? arguments[1] : undefined);
    var index = 0;
    var entry;
    while (index < entries.length) {
      entry = entries[index++];
      boundFunction(entry.value, entry.key, this);
    }
  },
  // `URLSearchParams.prototype.keys` method
  keys: function keys() {
    return new URLSearchParamsIterator(this, 'keys');
  },
  // `URLSearchParams.prototype.values` method
  values: function values() {
    return new URLSearchParamsIterator(this, 'values');
  },
  // `URLSearchParams.prototype.entries` method
  entries: function entries() {
    return new URLSearchParamsIterator(this, 'entries');
  }
}, { enumerable: true });

// `URLSearchParams.prototype[@@iterator]` method
defineBuiltIn(URLSearchParamsPrototype, ITERATOR, URLSearchParamsPrototype.entries, { name: 'entries' });

// `URLSearchParams.prototype.toString` method
// https://url.spec.whatwg.org/#urlsearchparams-stringification-behavior
defineBuiltIn(URLSearchParamsPrototype, 'toString', function toString() {
  return getInternalParamsState(this).serialize();
}, { enumerable: true });

// `URLSearchParams.prototype.size` getter
// https://github.com/whatwg/url/pull/734
if (DESCRIPTORS) defineBuiltInAccessor(URLSearchParamsPrototype, 'size', {
  get: function size() {
    return getInternalParamsState(this).entries.length;
  },
  configurable: true,
  enumerable: true
});

setToStringTag(URLSearchParamsConstructor, URL_SEARCH_PARAMS);

$({ global: true, constructor: true, forced: !USE_NATIVE_URL }, {
  URLSearchParams: URLSearchParamsConstructor
});

// Wrap `fetch` and `Request` for correct work with polyfilled `URLSearchParams`
if (!USE_NATIVE_URL && isCallable(Headers$1)) {
  var headersHas = uncurryThis(HeadersPrototype.has);
  var headersSet = uncurryThis(HeadersPrototype.set);

  var wrapRequestOptions = function (init) {
    if (isObject(init)) {
      var body = init.body;
      var headers;
      if (classof(body) === URL_SEARCH_PARAMS) {
        headers = init.headers ? new Headers$1(init.headers) : new Headers$1();
        if (!headersHas(headers, 'content-type')) {
          headersSet(headers, 'content-type', 'application/x-www-form-urlencoded;charset=UTF-8');
        }
        return create(init, {
          body: createPropertyDescriptor(0, $toString(body)),
          headers: createPropertyDescriptor(0, headers)
        });
      }
    } return init;
  };

  if (isCallable(nativeFetch)) {
    $({ global: true, enumerable: true, dontCallGetSet: true, forced: true }, {
      fetch: function fetch(input /* , init */) {
        return nativeFetch(input, arguments.length > 1 ? wrapRequestOptions(arguments[1]) : {});
      }
    });
  }

  if (isCallable(NativeRequest)) {
    var RequestConstructor = function Request(input /* , init */) {
      anInstance(this, RequestPrototype);
      return new NativeRequest(input, arguments.length > 1 ? wrapRequestOptions(arguments[1]) : {});
    };

    RequestPrototype.constructor = RequestConstructor;
    RequestConstructor.prototype = RequestPrototype;

    $({ global: true, constructor: true, dontCallGetSet: true, forced: true }, {
      Request: RequestConstructor
    });
  }
}

var web_urlSearchParams_constructor = {
  URLSearchParams: URLSearchParamsConstructor,
  getState: getInternalParamsState
};

function _defineProperty$8(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * EGroupware Custom Html Elements - Multi Video Web Components
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Hadi Nategh <hn[at]egroupware.org>
 * @copyright EGroupware GmbH
 */

/*
	This web component allows to merge multiple videos and display them as one single widget/element
	most of the html video attributes and methodes are supported. No controls attribute supported yet.
 */

// Create a class for the element
class multi_video extends HTMLElement {
  constructor() {
    super();

    // Create a shadow root
    _defineProperty$8(this, "_src", '');
    /**
     * shadow dom container
     * @private
     */
    _defineProperty$8(this, "_shadow", null);
    /**
     * wrapper container holds video tags
     * @private
     */
    _defineProperty$8(this, "_wrapper", void 0);
    /**
     * Styling contianer
     * @private
     */
    _defineProperty$8(this, "_style", void 0);
    /**
     * contains video objects of type VideoTagsArray
     * @private
     */
    _defineProperty$8(this, "_videos", []);
    /**
     * keeps duration time internally
     * @private
     */
    _defineProperty$8(this, "_duration", 0);
    /**
     * keeps currentTime internally
     * @private
     */
    _defineProperty$8(this, "_currentTime", 0);
    /**
     * Keeps video playing state internally
     * @private
     */
    _defineProperty$8(this, "__playing", false);
    this._shadow = this.attachShadow({
      mode: 'open'
    });

    // Create videos wrapper
    this._wrapper = document.createElement('div');
    this._wrapper.setAttribute('class', 'wrapper');

    // Create some CSS to apply to the shadow dom
    this._style = document.createElement('style');
    this._style.textContent = '.wrapper {' + 'width: 100%;' + 'height: auto;' + 'display: block;' + '}' + '.wrapper video {' + 'width: 100%;' + 'height: auto;' + '}';

    // attach to the shadow dom
    this._shadow.appendChild(this._style);
    this._shadow.appendChild(this._wrapper);
  }

  /**
   * set observable attributes
   * @return {string[]}
   */
  static get observedAttributes() {
    return ['src', 'type'];
  }

  /**
   * Gets called on observable attributes changes
   * @param name attribute name
   * @param _
   * @param newVal new value
   */
  attributeChangedCallback(name, _, newVal) {
    switch (name) {
      case 'src':
        this.src = newVal;
        break;
      case 'type':
        this._videos.forEach(_item => {
          _item.node.setAttribute('type', newVal);
        });
        break;
    }
  }

  /**
   * Calls load method for all its sub videos
   * https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/load
   */
  load() {
    this._videos.forEach(_item => {
      _item.node.load();
    });
  }

  /**
   * init/update video tags
   * @param array|string _value
   * @private
   */
  __buildVideoTags(_value) {
    var _this = this;
    var value = Array.isArray(_value) ? _value : _value.split(',');
    var video = null;
    var duration = 0;
    var _loop = function _loop(i) {
      video = document.createElement('video');
      // get duration from url duration param which is necessary for setting duration time of webm file
      var params = new URLSearchParams(value[i].split('?')[1] || '');
      duration = parseInt(params.get('duration') || '0');
      video.src = value[i];
      _this._videos[i] = {
        node: _this._wrapper.appendChild(video),
        loadedmetadata: false,
        timeupdate: false,
        duration: duration ? duration : 0,
        previousDurations: 0,
        currentTime: 0,
        active: false,
        index: i
      };

      // loadmetadata event
      _this._videos[i]['node'].addEventListener("loadedmetadata", function (_i, _event) {
        this._videos[_i]['loadedmetadata'] = true;
        this.__check_loadedmetadata();
      }.bind(_this, i));

      //timeupdate event
      _this._videos[i]['node'].addEventListener("timeupdate", function (_i, _event) {
        this._currentTime = this._videos[i]['previousDurations'] + _event.target.currentTime;

        // push the next video to start otherwise the time update gets paused as it ends automatically
        // with the current video being ended
        if (this._videos[i].node.ended && !this.ended) this.currentTime = this._currentTime + 0.1;
        this.__pushEvent('timeupdate');
      }.bind(_this, i));
    };
    for (var i = 0; i < value.length; i++) {
      _loop(i);
    }
  }

  /**
   * calculates duration of videos
   * @return {number} returns accumulated durations
   * @private
   */
  __duration() {
    var duration = 0;
    this._videos.forEach(_item => {
      duration += _item.duration;
    });
    return duration;
  }

  /**
   * Get current active video
   * @return {*[]} returns an array of object consist of current video displayed node
   * @private
   */
  __getActiveVideo() {
    return this._videos.filter(_item => {
      return _item.active;
    });
  }

  /**
   * check if all meta data from videos are ready then pushes the event
   * @private
   */
  __check_loadedmetadata() {
    var allReady = true;
    this._videos.forEach(_item => {
      allReady = allReady && _item.loadedmetadata;
    });
    if (allReady) {
      this._videos.forEach(_item => {
        _item.duration = _item.duration ? _item.duration : _item.node.duration;
        _item.previousDurations = _item.index > 0 ? this._videos[_item.index - 1]['duration'] + this._videos[_item.index - 1]['previousDurations'] : 0;
      });
      this.duration = this.__duration();
      this.currentTime = 0;
      this.__pushEvent('loadedmetadata');
    }
  }

  /**
   * Creates event and dispatches it
   * @param _name
   */
  __pushEvent(_name) {
    var event = document.createEvent("Event");
    event.initEvent(_name, true, true);
    this.dispatchEvent(event);
  }

  /**************************** PUBLIC ATTRIBUTES & METHODES *************************************************/

  /****************************** ATTRIBUTES **************************************/

  /**
   * set src
   * @param _value
   */
  set src(_value) {
    var _Array$from, _this$_wrapper;
    this._src = _value;
    var value = _value.split(',');
    (_Array$from = Array.from((_this$_wrapper = this._wrapper) === null || _this$_wrapper === void 0 ? void 0 : _this$_wrapper.children)) === null || _Array$from === void 0 || _Array$from.forEach(_ch => {
      _ch.remove();
    });
    this.__buildVideoTags(value);
  }

  /**
   * get src
   * @return string returns comma separated sources
   */
  get src() {
    return this._src;
  }

  /**
   * currentTime
   * @param _time
   */
  set currentTime(_time) {
    var ctime = _time;
    this._currentTime = _time;
    this._videos.forEach(_item => {
      if (ctime < _item.duration + _item.previousDurations && (ctime == 0 && _item.previousDurations == 0 || ctime > _item.previousDurations)) {
        if (this.__playing && _item.node.paused) _item.node.play();
        _item.currentTime = Math.abs(_item.previousDurations - ctime);
        _item.node.currentTime = _item.currentTime;
        _item.active = true;
      } else {
        _item.active = false;
        _item.node.pause();
      }
      _item.node.hidden = !_item.active;
    });
  }

  /**
   * get currentTime
   * @return {number}
   */
  get currentTime() {
    return this._currentTime;
  }

  /**
   * set video duration time attribute
   * @param _value
   */
  set duration(_value) {
    this._duration = _value;
  }

  /**
   * get video duration time
   */
  get duration() {
    return this._duration;
  }

  /**
   * get paused attribute
   */
  get paused() {
    var _this$__getActiveVide;
    return (_this$__getActiveVide = this.__getActiveVideo()[0]) === null || _this$__getActiveVide === void 0 || (_this$__getActiveVide = _this$__getActiveVide.node) === null || _this$__getActiveVide === void 0 ? void 0 : _this$__getActiveVide.paused;
  }

  /**
   * set muted attribute
   * @param _value
   */
  set muted(_value) {
    this._videos.forEach(_item => {
      _item.node.muted = _value;
    });
  }

  /**
   * get muted attribute
   */
  get muted() {
    var _this$__getActiveVide2;
    return (_this$__getActiveVide2 = this.__getActiveVideo()[0]) === null || _this$__getActiveVide2 === void 0 || (_this$__getActiveVide2 = _this$__getActiveVide2.node) === null || _this$__getActiveVide2 === void 0 ? void 0 : _this$__getActiveVide2.muted;
  }

  /**
   * get video ended attribute
   */
  get ended() {
    var _this$_videos;
    return (_this$_videos = this._videos[this._videos.length - 1]) === null || _this$_videos === void 0 || (_this$_videos = _this$_videos.node) === null || _this$_videos === void 0 ? void 0 : _this$_videos.ended;
  }

  /**
   * set playbackRate
   * @param _value
   */
  set playbackRate(_value) {
    this._videos.forEach(_item => {
      _item.node.playbackRate = _value;
    });
  }

  /**
   * get playbackRate
   */
  get playbackRate() {
    var _this$__getActiveVide3;
    return (_this$__getActiveVide3 = this.__getActiveVideo()[0]) === null || _this$__getActiveVide3 === void 0 || (_this$__getActiveVide3 = _this$__getActiveVide3.node) === null || _this$__getActiveVide3 === void 0 ? void 0 : _this$__getActiveVide3.playbackRate;
  }

  /**
   * set volume
   */
  set volume(_value) {
    this._videos.forEach(_item => {
      _item.node.volume = _value;
    });
  }

  /**
   * get volume
   */
  get volume() {
    var _this$__getActiveVide4;
    return (_this$__getActiveVide4 = this.__getActiveVideo()[0]) === null || _this$__getActiveVide4 === void 0 || (_this$__getActiveVide4 = _this$__getActiveVide4.node) === null || _this$__getActiveVide4 === void 0 ? void 0 : _this$__getActiveVide4.volume;
  }

  /************************************************* METHODES ******************************************/

  /**
   * Play video
   */
  play() {
    var _this$__getActiveVide5;
    this.__playing = true;
    return (_this$__getActiveVide5 = this.__getActiveVideo()[0]) === null || _this$__getActiveVide5 === void 0 || (_this$__getActiveVide5 = _this$__getActiveVide5.node) === null || _this$__getActiveVide5 === void 0 ? void 0 : _this$__getActiveVide5.play();
  }

  /**
   * pause video
   */
  pause() {
    var _this$__getActiveVide6;
    this.__playing = false;
    (_this$__getActiveVide6 = this.__getActiveVideo()[0]) === null || _this$__getActiveVide6 === void 0 || (_this$__getActiveVide6 = _this$__getActiveVide6.node) === null || _this$__getActiveVide6 === void 0 || _this$__getActiveVide6.pause();
  }
}

// Define the new multi-video element
customElements.define('multi-video', multi_video);

var global$1 = (typeof global !== "undefined" ? global :
            typeof self !== "undefined" ? self :
            typeof window !== "undefined" ? window : {});

// shim for using process in browser
// based off https://github.com/defunctzombie/node-process/blob/master/browser.js

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
var cachedSetTimeout = defaultSetTimout;
var cachedClearTimeout = defaultClearTimeout;
if (typeof global$1.setTimeout === 'function') {
    cachedSetTimeout = setTimeout;
}
if (typeof global$1.clearTimeout === 'function') {
    cachedClearTimeout = clearTimeout;
}

function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}
function nextTick(fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
}
// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
var title = 'browser';
var platform = 'browser';
var browser = true;
var env = {};
var argv = [];
var version = ''; // empty string to avoid regexp issues
var versions = {};
var release = {};
var config = {};

function noop() {}

var on = noop;
var addListener = noop;
var once = noop;
var off = noop;
var removeListener = noop;
var removeAllListeners = noop;
var emit = noop;

function binding(name) {
    throw new Error('process.binding is not supported');
}

function cwd () { return '/' }
function chdir (dir) {
    throw new Error('process.chdir is not supported');
}function umask() { return 0; }

// from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
var performance = global$1.performance || {};
var performanceNow =
  performance.now        ||
  performance.mozNow     ||
  performance.msNow      ||
  performance.oNow       ||
  performance.webkitNow  ||
  function(){ return (new Date()).getTime() };

// generate timestamp or delta
// see http://nodejs.org/api/process.html#process_process_hrtime
function hrtime(previousTimestamp){
  var clocktime = performanceNow.call(performance)*1e-3;
  var seconds = Math.floor(clocktime);
  var nanoseconds = Math.floor((clocktime%1)*1e9);
  if (previousTimestamp) {
    seconds = seconds - previousTimestamp[0];
    nanoseconds = nanoseconds - previousTimestamp[1];
    if (nanoseconds<0) {
      seconds--;
      nanoseconds += 1e9;
    }
  }
  return [seconds,nanoseconds]
}

var startTime = new Date();
function uptime() {
  var currentTime = new Date();
  var dif = currentTime - startTime;
  return dif / 1000;
}

var process$1 = {
  nextTick: nextTick,
  title: title,
  browser: browser,
  env: env,
  argv: argv,
  version: version,
  versions: versions,
  on: on,
  addListener: addListener,
  once: once,
  off: off,
  removeListener: removeListener,
  removeAllListeners: removeAllListeners,
  emit: emit,
  binding: binding,
  cwd: cwd,
  chdir: chdir,
  umask: umask,
  hrtime: hrtime,
  platform: platform,
  release: release,
  config: config,
  uptime: uptime
};

var lookup = [];
var revLookup = [];
var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
var inited = false;
function init () {
  inited = true;
  var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
  for (var i = 0, len = code.length; i < len; ++i) {
    lookup[i] = code[i];
    revLookup[code.charCodeAt(i)] = i;
  }

  revLookup['-'.charCodeAt(0)] = 62;
  revLookup['_'.charCodeAt(0)] = 63;
}

function toByteArray (b64) {
  if (!inited) {
    init();
  }
  var i, j, l, tmp, placeHolders, arr;
  var len = b64.length;

  if (len % 4 > 0) {
    throw new Error('Invalid string. Length must be a multiple of 4')
  }

  // the number of equal signs (place holders)
  // if there are two placeholders, than the two characters before it
  // represent one byte
  // if there is only one, then the three characters before it represent 2 bytes
  // this is just a cheap hack to not do indexOf twice
  placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0;

  // base64 is 4/3 + up to two characters of the original data
  arr = new Arr(len * 3 / 4 - placeHolders);

  // if there are placeholders, only get up to the last complete 4 chars
  l = placeHolders > 0 ? len - 4 : len;

  var L = 0;

  for (i = 0, j = 0; i < l; i += 4, j += 3) {
    tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)];
    arr[L++] = (tmp >> 16) & 0xFF;
    arr[L++] = (tmp >> 8) & 0xFF;
    arr[L++] = tmp & 0xFF;
  }

  if (placeHolders === 2) {
    tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4);
    arr[L++] = tmp & 0xFF;
  } else if (placeHolders === 1) {
    tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2);
    arr[L++] = (tmp >> 8) & 0xFF;
    arr[L++] = tmp & 0xFF;
  }

  return arr
}

function tripletToBase64 (num) {
  return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
}

function encodeChunk (uint8, start, end) {
  var tmp;
  var output = [];
  for (var i = start; i < end; i += 3) {
    tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
    output.push(tripletToBase64(tmp));
  }
  return output.join('')
}

function fromByteArray (uint8) {
  if (!inited) {
    init();
  }
  var tmp;
  var len = uint8.length;
  var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
  var output = '';
  var parts = [];
  var maxChunkLength = 16383; // must be multiple of 3

  // go through the array every three bytes, we'll deal with trailing stuff later
  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
    parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
  }

  // pad the end with zeros, but make sure to not forget the extra bytes
  if (extraBytes === 1) {
    tmp = uint8[len - 1];
    output += lookup[tmp >> 2];
    output += lookup[(tmp << 4) & 0x3F];
    output += '==';
  } else if (extraBytes === 2) {
    tmp = (uint8[len - 2] << 8) + (uint8[len - 1]);
    output += lookup[tmp >> 10];
    output += lookup[(tmp >> 4) & 0x3F];
    output += lookup[(tmp << 2) & 0x3F];
    output += '=';
  }

  parts.push(output);

  return parts.join('')
}

function read (buffer, offset, isLE, mLen, nBytes) {
  var e, m;
  var eLen = nBytes * 8 - mLen - 1;
  var eMax = (1 << eLen) - 1;
  var eBias = eMax >> 1;
  var nBits = -7;
  var i = isLE ? (nBytes - 1) : 0;
  var d = isLE ? -1 : 1;
  var s = buffer[offset + i];

  i += d;

  e = s & ((1 << (-nBits)) - 1);
  s >>= (-nBits);
  nBits += eLen;
  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

  m = e & ((1 << (-nBits)) - 1);
  e >>= (-nBits);
  nBits += mLen;
  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

  if (e === 0) {
    e = 1 - eBias;
  } else if (e === eMax) {
    return m ? NaN : ((s ? -1 : 1) * Infinity)
  } else {
    m = m + Math.pow(2, mLen);
    e = e - eBias;
  }
  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
}

function write (buffer, value, offset, isLE, mLen, nBytes) {
  var e, m, c;
  var eLen = nBytes * 8 - mLen - 1;
  var eMax = (1 << eLen) - 1;
  var eBias = eMax >> 1;
  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
  var i = isLE ? 0 : (nBytes - 1);
  var d = isLE ? 1 : -1;
  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

  value = Math.abs(value);

  if (isNaN(value) || value === Infinity) {
    m = isNaN(value) ? 1 : 0;
    e = eMax;
  } else {
    e = Math.floor(Math.log(value) / Math.LN2);
    if (value * (c = Math.pow(2, -e)) < 1) {
      e--;
      c *= 2;
    }
    if (e + eBias >= 1) {
      value += rt / c;
    } else {
      value += rt * Math.pow(2, 1 - eBias);
    }
    if (value * c >= 2) {
      e++;
      c /= 2;
    }

    if (e + eBias >= eMax) {
      m = 0;
      e = eMax;
    } else if (e + eBias >= 1) {
      m = (value * c - 1) * Math.pow(2, mLen);
      e = e + eBias;
    } else {
      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
      e = 0;
    }
  }

  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

  e = (e << mLen) | m;
  eLen += mLen;
  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

  buffer[offset + i - d] |= s * 128;
}

var toString = {}.toString;

var isArray = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};

var INSPECT_MAX_BYTES = 50;

/**
 * If `Buffer.TYPED_ARRAY_SUPPORT`:
 *   === true    Use Uint8Array implementation (fastest)
 *   === false   Use Object implementation (most compatible, even IE6)
 *
 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
 * Opera 11.6+, iOS 4.2+.
 *
 * Due to various browser bugs, sometimes the Object implementation will be used even
 * when the browser supports typed arrays.
 *
 * Note:
 *
 *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
 *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
 *
 *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
 *
 *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
 *     incorrect length in some situations.

 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
 * get the Object implementation, which is slower but behaves correctly.
 */
Buffer.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined
  ? global$1.TYPED_ARRAY_SUPPORT
  : true;

function kMaxLength () {
  return Buffer.TYPED_ARRAY_SUPPORT
    ? 0x7fffffff
    : 0x3fffffff
}

function createBuffer (that, length) {
  if (kMaxLength() < length) {
    throw new RangeError('Invalid typed array length')
  }
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    // Return an augmented `Uint8Array` instance, for best performance
    that = new Uint8Array(length);
    that.__proto__ = Buffer.prototype;
  } else {
    // Fallback: Return an object instance of the Buffer class
    if (that === null) {
      that = new Buffer(length);
    }
    that.length = length;
  }

  return that
}

/**
 * The Buffer constructor returns instances of `Uint8Array` that have their
 * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
 * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
 * and the `Uint8Array` methods. Square bracket notation works as expected -- it
 * returns a single octet.
 *
 * The `Uint8Array` prototype remains unmodified.
 */

function Buffer (arg, encodingOrOffset, length) {
  if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
    return new Buffer(arg, encodingOrOffset, length)
  }

  // Common case.
  if (typeof arg === 'number') {
    if (typeof encodingOrOffset === 'string') {
      throw new Error(
        'If encoding is specified then the first argument must be a string'
      )
    }
    return allocUnsafe(this, arg)
  }
  return from(this, arg, encodingOrOffset, length)
}

Buffer.poolSize = 8192; // not used by this implementation

// TODO: Legacy, not needed anymore. Remove in next major version.
Buffer._augment = function (arr) {
  arr.__proto__ = Buffer.prototype;
  return arr
};

function from (that, value, encodingOrOffset, length) {
  if (typeof value === 'number') {
    throw new TypeError('"value" argument must not be a number')
  }

  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
    return fromArrayBuffer(that, value, encodingOrOffset, length)
  }

  if (typeof value === 'string') {
    return fromString(that, value, encodingOrOffset)
  }

  return fromObject(that, value)
}

/**
 * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
 * if value is a number.
 * Buffer.from(str[, encoding])
 * Buffer.from(array)
 * Buffer.from(buffer)
 * Buffer.from(arrayBuffer[, byteOffset[, length]])
 **/
Buffer.from = function (value, encodingOrOffset, length) {
  return from(null, value, encodingOrOffset, length)
};

if (Buffer.TYPED_ARRAY_SUPPORT) {
  Buffer.prototype.__proto__ = Uint8Array.prototype;
  Buffer.__proto__ = Uint8Array;
}

function assertSize (size) {
  if (typeof size !== 'number') {
    throw new TypeError('"size" argument must be a number')
  } else if (size < 0) {
    throw new RangeError('"size" argument must not be negative')
  }
}

function alloc (that, size, fill, encoding) {
  assertSize(size);
  if (size <= 0) {
    return createBuffer(that, size)
  }
  if (fill !== undefined) {
    // Only pay attention to encoding if it's a string. This
    // prevents accidentally sending in a number that would
    // be interpretted as a start offset.
    return typeof encoding === 'string'
      ? createBuffer(that, size).fill(fill, encoding)
      : createBuffer(that, size).fill(fill)
  }
  return createBuffer(that, size)
}

/**
 * Creates a new filled Buffer instance.
 * alloc(size[, fill[, encoding]])
 **/
Buffer.alloc = function (size, fill, encoding) {
  return alloc(null, size, fill, encoding)
};

function allocUnsafe (that, size) {
  assertSize(size);
  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
  if (!Buffer.TYPED_ARRAY_SUPPORT) {
    for (var i = 0; i < size; ++i) {
      that[i] = 0;
    }
  }
  return that
}

/**
 * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
 * */
Buffer.allocUnsafe = function (size) {
  return allocUnsafe(null, size)
};
/**
 * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
 */
Buffer.allocUnsafeSlow = function (size) {
  return allocUnsafe(null, size)
};

function fromString (that, string, encoding) {
  if (typeof encoding !== 'string' || encoding === '') {
    encoding = 'utf8';
  }

  if (!Buffer.isEncoding(encoding)) {
    throw new TypeError('"encoding" must be a valid string encoding')
  }

  var length = byteLength(string, encoding) | 0;
  that = createBuffer(that, length);

  var actual = that.write(string, encoding);

  if (actual !== length) {
    // Writing a hex string, for example, that contains invalid characters will
    // cause everything after the first invalid character to be ignored. (e.g.
    // 'abxxcd' will be treated as 'ab')
    that = that.slice(0, actual);
  }

  return that
}

function fromArrayLike (that, array) {
  var length = array.length < 0 ? 0 : checked(array.length) | 0;
  that = createBuffer(that, length);
  for (var i = 0; i < length; i += 1) {
    that[i] = array[i] & 255;
  }
  return that
}

function fromArrayBuffer (that, array, byteOffset, length) {
  array.byteLength; // this throws if `array` is not a valid ArrayBuffer

  if (byteOffset < 0 || array.byteLength < byteOffset) {
    throw new RangeError('\'offset\' is out of bounds')
  }

  if (array.byteLength < byteOffset + (length || 0)) {
    throw new RangeError('\'length\' is out of bounds')
  }

  if (byteOffset === undefined && length === undefined) {
    array = new Uint8Array(array);
  } else if (length === undefined) {
    array = new Uint8Array(array, byteOffset);
  } else {
    array = new Uint8Array(array, byteOffset, length);
  }

  if (Buffer.TYPED_ARRAY_SUPPORT) {
    // Return an augmented `Uint8Array` instance, for best performance
    that = array;
    that.__proto__ = Buffer.prototype;
  } else {
    // Fallback: Return an object instance of the Buffer class
    that = fromArrayLike(that, array);
  }
  return that
}

function fromObject (that, obj) {
  if (internalIsBuffer(obj)) {
    var len = checked(obj.length) | 0;
    that = createBuffer(that, len);

    if (that.length === 0) {
      return that
    }

    obj.copy(that, 0, 0, len);
    return that
  }

  if (obj) {
    if ((typeof ArrayBuffer !== 'undefined' &&
        obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
      if (typeof obj.length !== 'number' || isnan(obj.length)) {
        return createBuffer(that, 0)
      }
      return fromArrayLike(that, obj)
    }

    if (obj.type === 'Buffer' && isArray(obj.data)) {
      return fromArrayLike(that, obj.data)
    }
  }

  throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
}

function checked (length) {
  // Note: cannot use `length < kMaxLength()` here because that fails when
  // length is NaN (which is otherwise coerced to zero.)
  if (length >= kMaxLength()) {
    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                         'size: 0x' + kMaxLength().toString(16) + ' bytes')
  }
  return length | 0
}
Buffer.isBuffer = isBuffer;
function internalIsBuffer (b) {
  return !!(b != null && b._isBuffer)
}

Buffer.compare = function compare (a, b) {
  if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
    throw new TypeError('Arguments must be Buffers')
  }

  if (a === b) return 0

  var x = a.length;
  var y = b.length;

  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
    if (a[i] !== b[i]) {
      x = a[i];
      y = b[i];
      break
    }
  }

  if (x < y) return -1
  if (y < x) return 1
  return 0
};

Buffer.isEncoding = function isEncoding (encoding) {
  switch (String(encoding).toLowerCase()) {
    case 'hex':
    case 'utf8':
    case 'utf-8':
    case 'ascii':
    case 'latin1':
    case 'binary':
    case 'base64':
    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
      return true
    default:
      return false
  }
};

Buffer.concat = function concat (list, length) {
  if (!isArray(list)) {
    throw new TypeError('"list" argument must be an Array of Buffers')
  }

  if (list.length === 0) {
    return Buffer.alloc(0)
  }

  var i;
  if (length === undefined) {
    length = 0;
    for (i = 0; i < list.length; ++i) {
      length += list[i].length;
    }
  }

  var buffer = Buffer.allocUnsafe(length);
  var pos = 0;
  for (i = 0; i < list.length; ++i) {
    var buf = list[i];
    if (!internalIsBuffer(buf)) {
      throw new TypeError('"list" argument must be an Array of Buffers')
    }
    buf.copy(buffer, pos);
    pos += buf.length;
  }
  return buffer
};

function byteLength (string, encoding) {
  if (internalIsBuffer(string)) {
    return string.length
  }
  if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
      (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
    return string.byteLength
  }
  if (typeof string !== 'string') {
    string = '' + string;
  }

  var len = string.length;
  if (len === 0) return 0

  // Use a for loop to avoid recursion
  var loweredCase = false;
  for (;;) {
    switch (encoding) {
      case 'ascii':
      case 'latin1':
      case 'binary':
        return len
      case 'utf8':
      case 'utf-8':
      case undefined:
        return utf8ToBytes(string).length
      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return len * 2
      case 'hex':
        return len >>> 1
      case 'base64':
        return base64ToBytes(string).length
      default:
        if (loweredCase) return utf8ToBytes(string).length // assume utf8
        encoding = ('' + encoding).toLowerCase();
        loweredCase = true;
    }
  }
}
Buffer.byteLength = byteLength;

function slowToString (encoding, start, end) {
  var loweredCase = false;

  // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
  // property of a typed array.

  // This behaves neither like String nor Uint8Array in that we set start/end
  // to their upper/lower bounds if the value passed is out of range.
  // undefined is handled specially as per ECMA-262 6th Edition,
  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
  if (start === undefined || start < 0) {
    start = 0;
  }
  // Return early if start > this.length. Done here to prevent potential uint32
  // coercion fail below.
  if (start > this.length) {
    return ''
  }

  if (end === undefined || end > this.length) {
    end = this.length;
  }

  if (end <= 0) {
    return ''
  }

  // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
  end >>>= 0;
  start >>>= 0;

  if (end <= start) {
    return ''
  }

  if (!encoding) encoding = 'utf8';

  while (true) {
    switch (encoding) {
      case 'hex':
        return hexSlice(this, start, end)

      case 'utf8':
      case 'utf-8':
        return utf8Slice(this, start, end)

      case 'ascii':
        return asciiSlice(this, start, end)

      case 'latin1':
      case 'binary':
        return latin1Slice(this, start, end)

      case 'base64':
        return base64Slice(this, start, end)

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return utf16leSlice(this, start, end)

      default:
        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
        encoding = (encoding + '').toLowerCase();
        loweredCase = true;
    }
  }
}

// The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
// Buffer instances.
Buffer.prototype._isBuffer = true;

function swap (b, n, m) {
  var i = b[n];
  b[n] = b[m];
  b[m] = i;
}

Buffer.prototype.swap16 = function swap16 () {
  var len = this.length;
  if (len % 2 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 16-bits')
  }
  for (var i = 0; i < len; i += 2) {
    swap(this, i, i + 1);
  }
  return this
};

Buffer.prototype.swap32 = function swap32 () {
  var len = this.length;
  if (len % 4 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 32-bits')
  }
  for (var i = 0; i < len; i += 4) {
    swap(this, i, i + 3);
    swap(this, i + 1, i + 2);
  }
  return this
};

Buffer.prototype.swap64 = function swap64 () {
  var len = this.length;
  if (len % 8 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 64-bits')
  }
  for (var i = 0; i < len; i += 8) {
    swap(this, i, i + 7);
    swap(this, i + 1, i + 6);
    swap(this, i + 2, i + 5);
    swap(this, i + 3, i + 4);
  }
  return this
};

Buffer.prototype.toString = function toString () {
  var length = this.length | 0;
  if (length === 0) return ''
  if (arguments.length === 0) return utf8Slice(this, 0, length)
  return slowToString.apply(this, arguments)
};

Buffer.prototype.equals = function equals (b) {
  if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer')
  if (this === b) return true
  return Buffer.compare(this, b) === 0
};

Buffer.prototype.inspect = function inspect () {
  var str = '';
  var max = INSPECT_MAX_BYTES;
  if (this.length > 0) {
    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
    if (this.length > max) str += ' ... ';
  }
  return '<Buffer ' + str + '>'
};

Buffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
  if (!internalIsBuffer(target)) {
    throw new TypeError('Argument must be a Buffer')
  }

  if (start === undefined) {
    start = 0;
  }
  if (end === undefined) {
    end = target ? target.length : 0;
  }
  if (thisStart === undefined) {
    thisStart = 0;
  }
  if (thisEnd === undefined) {
    thisEnd = this.length;
  }

  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
    throw new RangeError('out of range index')
  }

  if (thisStart >= thisEnd && start >= end) {
    return 0
  }
  if (thisStart >= thisEnd) {
    return -1
  }
  if (start >= end) {
    return 1
  }

  start >>>= 0;
  end >>>= 0;
  thisStart >>>= 0;
  thisEnd >>>= 0;

  if (this === target) return 0

  var x = thisEnd - thisStart;
  var y = end - start;
  var len = Math.min(x, y);

  var thisCopy = this.slice(thisStart, thisEnd);
  var targetCopy = target.slice(start, end);

  for (var i = 0; i < len; ++i) {
    if (thisCopy[i] !== targetCopy[i]) {
      x = thisCopy[i];
      y = targetCopy[i];
      break
    }
  }

  if (x < y) return -1
  if (y < x) return 1
  return 0
};

// Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
// OR the last index of `val` in `buffer` at offset <= `byteOffset`.
//
// Arguments:
// - buffer - a Buffer to search
// - val - a string, Buffer, or number
// - byteOffset - an index into `buffer`; will be clamped to an int32
// - encoding - an optional encoding, relevant is val is a string
// - dir - true for indexOf, false for lastIndexOf
function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
  // Empty buffer means no match
  if (buffer.length === 0) return -1

  // Normalize byteOffset
  if (typeof byteOffset === 'string') {
    encoding = byteOffset;
    byteOffset = 0;
  } else if (byteOffset > 0x7fffffff) {
    byteOffset = 0x7fffffff;
  } else if (byteOffset < -0x80000000) {
    byteOffset = -0x80000000;
  }
  byteOffset = +byteOffset;  // Coerce to Number.
  if (isNaN(byteOffset)) {
    // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
    byteOffset = dir ? 0 : (buffer.length - 1);
  }

  // Normalize byteOffset: negative offsets start from the end of the buffer
  if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
  if (byteOffset >= buffer.length) {
    if (dir) return -1
    else byteOffset = buffer.length - 1;
  } else if (byteOffset < 0) {
    if (dir) byteOffset = 0;
    else return -1
  }

  // Normalize val
  if (typeof val === 'string') {
    val = Buffer.from(val, encoding);
  }

  // Finally, search either indexOf (if dir is true) or lastIndexOf
  if (internalIsBuffer(val)) {
    // Special case: looking for empty string/buffer always fails
    if (val.length === 0) {
      return -1
    }
    return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
  } else if (typeof val === 'number') {
    val = val & 0xFF; // Search for a byte value [0-255]
    if (Buffer.TYPED_ARRAY_SUPPORT &&
        typeof Uint8Array.prototype.indexOf === 'function') {
      if (dir) {
        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
      } else {
        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
      }
    }
    return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
  }

  throw new TypeError('val must be string, number or Buffer')
}

function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
  var indexSize = 1;
  var arrLength = arr.length;
  var valLength = val.length;

  if (encoding !== undefined) {
    encoding = String(encoding).toLowerCase();
    if (encoding === 'ucs2' || encoding === 'ucs-2' ||
        encoding === 'utf16le' || encoding === 'utf-16le') {
      if (arr.length < 2 || val.length < 2) {
        return -1
      }
      indexSize = 2;
      arrLength /= 2;
      valLength /= 2;
      byteOffset /= 2;
    }
  }

  function read (buf, i) {
    if (indexSize === 1) {
      return buf[i]
    } else {
      return buf.readUInt16BE(i * indexSize)
    }
  }

  var i;
  if (dir) {
    var foundIndex = -1;
    for (i = byteOffset; i < arrLength; i++) {
      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
        if (foundIndex === -1) foundIndex = i;
        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
      } else {
        if (foundIndex !== -1) i -= i - foundIndex;
        foundIndex = -1;
      }
    }
  } else {
    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;
    for (i = byteOffset; i >= 0; i--) {
      var found = true;
      for (var j = 0; j < valLength; j++) {
        if (read(arr, i + j) !== read(val, j)) {
          found = false;
          break
        }
      }
      if (found) return i
    }
  }

  return -1
}

Buffer.prototype.includes = function includes (val, byteOffset, encoding) {
  return this.indexOf(val, byteOffset, encoding) !== -1
};

Buffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
};

Buffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
};

function hexWrite (buf, string, offset, length) {
  offset = Number(offset) || 0;
  var remaining = buf.length - offset;
  if (!length) {
    length = remaining;
  } else {
    length = Number(length);
    if (length > remaining) {
      length = remaining;
    }
  }

  // must be an even number of digits
  var strLen = string.length;
  if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

  if (length > strLen / 2) {
    length = strLen / 2;
  }
  for (var i = 0; i < length; ++i) {
    var parsed = parseInt(string.substr(i * 2, 2), 16);
    if (isNaN(parsed)) return i
    buf[offset + i] = parsed;
  }
  return i
}

function utf8Write (buf, string, offset, length) {
  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
}

function asciiWrite (buf, string, offset, length) {
  return blitBuffer(asciiToBytes(string), buf, offset, length)
}

function latin1Write (buf, string, offset, length) {
  return asciiWrite(buf, string, offset, length)
}

function base64Write (buf, string, offset, length) {
  return blitBuffer(base64ToBytes(string), buf, offset, length)
}

function ucs2Write (buf, string, offset, length) {
  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
}

Buffer.prototype.write = function write (string, offset, length, encoding) {
  // Buffer#write(string)
  if (offset === undefined) {
    encoding = 'utf8';
    length = this.length;
    offset = 0;
  // Buffer#write(string, encoding)
  } else if (length === undefined && typeof offset === 'string') {
    encoding = offset;
    length = this.length;
    offset = 0;
  // Buffer#write(string, offset[, length][, encoding])
  } else if (isFinite(offset)) {
    offset = offset | 0;
    if (isFinite(length)) {
      length = length | 0;
      if (encoding === undefined) encoding = 'utf8';
    } else {
      encoding = length;
      length = undefined;
    }
  // legacy write(string, encoding, offset, length) - remove in v0.13
  } else {
    throw new Error(
      'Buffer.write(string, encoding, offset[, length]) is no longer supported'
    )
  }

  var remaining = this.length - offset;
  if (length === undefined || length > remaining) length = remaining;

  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
    throw new RangeError('Attempt to write outside buffer bounds')
  }

  if (!encoding) encoding = 'utf8';

  var loweredCase = false;
  for (;;) {
    switch (encoding) {
      case 'hex':
        return hexWrite(this, string, offset, length)

      case 'utf8':
      case 'utf-8':
        return utf8Write(this, string, offset, length)

      case 'ascii':
        return asciiWrite(this, string, offset, length)

      case 'latin1':
      case 'binary':
        return latin1Write(this, string, offset, length)

      case 'base64':
        // Warning: maxLength not taken into account in base64Write
        return base64Write(this, string, offset, length)

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return ucs2Write(this, string, offset, length)

      default:
        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
        encoding = ('' + encoding).toLowerCase();
        loweredCase = true;
    }
  }
};

Buffer.prototype.toJSON = function toJSON () {
  return {
    type: 'Buffer',
    data: Array.prototype.slice.call(this._arr || this, 0)
  }
};

function base64Slice (buf, start, end) {
  if (start === 0 && end === buf.length) {
    return fromByteArray(buf)
  } else {
    return fromByteArray(buf.slice(start, end))
  }
}

function utf8Slice (buf, start, end) {
  end = Math.min(buf.length, end);
  var res = [];

  var i = start;
  while (i < end) {
    var firstByte = buf[i];
    var codePoint = null;
    var bytesPerSequence = (firstByte > 0xEF) ? 4
      : (firstByte > 0xDF) ? 3
      : (firstByte > 0xBF) ? 2
      : 1;

    if (i + bytesPerSequence <= end) {
      var secondByte, thirdByte, fourthByte, tempCodePoint;

      switch (bytesPerSequence) {
        case 1:
          if (firstByte < 0x80) {
            codePoint = firstByte;
          }
          break
        case 2:
          secondByte = buf[i + 1];
          if ((secondByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F);
            if (tempCodePoint > 0x7F) {
              codePoint = tempCodePoint;
            }
          }
          break
        case 3:
          secondByte = buf[i + 1];
          thirdByte = buf[i + 2];
          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F);
            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
              codePoint = tempCodePoint;
            }
          }
          break
        case 4:
          secondByte = buf[i + 1];
          thirdByte = buf[i + 2];
          fourthByte = buf[i + 3];
          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F);
            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
              codePoint = tempCodePoint;
            }
          }
      }
    }

    if (codePoint === null) {
      // we did not generate a valid codePoint so insert a
      // replacement char (U+FFFD) and advance only 1 byte
      codePoint = 0xFFFD;
      bytesPerSequence = 1;
    } else if (codePoint > 0xFFFF) {
      // encode to utf16 (surrogate pair dance)
      codePoint -= 0x10000;
      res.push(codePoint >>> 10 & 0x3FF | 0xD800);
      codePoint = 0xDC00 | codePoint & 0x3FF;
    }

    res.push(codePoint);
    i += bytesPerSequence;
  }

  return decodeCodePointsArray(res)
}

// Based on http://stackoverflow.com/a/22747272/680742, the browser with
// the lowest limit is Chrome, with 0x10000 args.
// We go 1 magnitude less, for safety
var MAX_ARGUMENTS_LENGTH = 0x1000;

function decodeCodePointsArray (codePoints) {
  var len = codePoints.length;
  if (len <= MAX_ARGUMENTS_LENGTH) {
    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
  }

  // Decode in chunks to avoid "call stack size exceeded".
  var res = '';
  var i = 0;
  while (i < len) {
    res += String.fromCharCode.apply(
      String,
      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
    );
  }
  return res
}

function asciiSlice (buf, start, end) {
  var ret = '';
  end = Math.min(buf.length, end);

  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i] & 0x7F);
  }
  return ret
}

function latin1Slice (buf, start, end) {
  var ret = '';
  end = Math.min(buf.length, end);

  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i]);
  }
  return ret
}

function hexSlice (buf, start, end) {
  var len = buf.length;

  if (!start || start < 0) start = 0;
  if (!end || end < 0 || end > len) end = len;

  var out = '';
  for (var i = start; i < end; ++i) {
    out += toHex(buf[i]);
  }
  return out
}

function utf16leSlice (buf, start, end) {
  var bytes = buf.slice(start, end);
  var res = '';
  for (var i = 0; i < bytes.length; i += 2) {
    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
  }
  return res
}

Buffer.prototype.slice = function slice (start, end) {
  var len = this.length;
  start = ~~start;
  end = end === undefined ? len : ~~end;

  if (start < 0) {
    start += len;
    if (start < 0) start = 0;
  } else if (start > len) {
    start = len;
  }

  if (end < 0) {
    end += len;
    if (end < 0) end = 0;
  } else if (end > len) {
    end = len;
  }

  if (end < start) end = start;

  var newBuf;
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    newBuf = this.subarray(start, end);
    newBuf.__proto__ = Buffer.prototype;
  } else {
    var sliceLen = end - start;
    newBuf = new Buffer(sliceLen, undefined);
    for (var i = 0; i < sliceLen; ++i) {
      newBuf[i] = this[i + start];
    }
  }

  return newBuf
};

/*
 * Need to make sure that buffer isn't trying to write out of bounds.
 */
function checkOffset (offset, ext, length) {
  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
}

Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
  offset = offset | 0;
  byteLength = byteLength | 0;
  if (!noAssert) checkOffset(offset, byteLength, this.length);

  var val = this[offset];
  var mul = 1;
  var i = 0;
  while (++i < byteLength && (mul *= 0x100)) {
    val += this[offset + i] * mul;
  }

  return val
};

Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
  offset = offset | 0;
  byteLength = byteLength | 0;
  if (!noAssert) {
    checkOffset(offset, byteLength, this.length);
  }

  var val = this[offset + --byteLength];
  var mul = 1;
  while (byteLength > 0 && (mul *= 0x100)) {
    val += this[offset + --byteLength] * mul;
  }

  return val
};

Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 1, this.length);
  return this[offset]
};

Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length);
  return this[offset] | (this[offset + 1] << 8)
};

Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length);
  return (this[offset] << 8) | this[offset + 1]
};

Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length);

  return ((this[offset]) |
      (this[offset + 1] << 8) |
      (this[offset + 2] << 16)) +
      (this[offset + 3] * 0x1000000)
};

Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length);

  return (this[offset] * 0x1000000) +
    ((this[offset + 1] << 16) |
    (this[offset + 2] << 8) |
    this[offset + 3])
};

Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
  offset = offset | 0;
  byteLength = byteLength | 0;
  if (!noAssert) checkOffset(offset, byteLength, this.length);

  var val = this[offset];
  var mul = 1;
  var i = 0;
  while (++i < byteLength && (mul *= 0x100)) {
    val += this[offset + i] * mul;
  }
  mul *= 0x80;

  if (val >= mul) val -= Math.pow(2, 8 * byteLength);

  return val
};

Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
  offset = offset | 0;
  byteLength = byteLength | 0;
  if (!noAssert) checkOffset(offset, byteLength, this.length);

  var i = byteLength;
  var mul = 1;
  var val = this[offset + --i];
  while (i > 0 && (mul *= 0x100)) {
    val += this[offset + --i] * mul;
  }
  mul *= 0x80;

  if (val >= mul) val -= Math.pow(2, 8 * byteLength);

  return val
};

Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 1, this.length);
  if (!(this[offset] & 0x80)) return (this[offset])
  return ((0xff - this[offset] + 1) * -1)
};

Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length);
  var val = this[offset] | (this[offset + 1] << 8);
  return (val & 0x8000) ? val | 0xFFFF0000 : val
};

Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length);
  var val = this[offset + 1] | (this[offset] << 8);
  return (val & 0x8000) ? val | 0xFFFF0000 : val
};

Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length);

  return (this[offset]) |
    (this[offset + 1] << 8) |
    (this[offset + 2] << 16) |
    (this[offset + 3] << 24)
};

Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length);

  return (this[offset] << 24) |
    (this[offset + 1] << 16) |
    (this[offset + 2] << 8) |
    (this[offset + 3])
};

Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length);
  return read(this, offset, true, 23, 4)
};

Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length);
  return read(this, offset, false, 23, 4)
};

Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 8, this.length);
  return read(this, offset, true, 52, 8)
};

Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 8, this.length);
  return read(this, offset, false, 52, 8)
};

function checkInt (buf, value, offset, ext, max, min) {
  if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
  if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
  if (offset + ext > buf.length) throw new RangeError('Index out of range')
}

Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
  value = +value;
  offset = offset | 0;
  byteLength = byteLength | 0;
  if (!noAssert) {
    var maxBytes = Math.pow(2, 8 * byteLength) - 1;
    checkInt(this, value, offset, byteLength, maxBytes, 0);
  }

  var mul = 1;
  var i = 0;
  this[offset] = value & 0xFF;
  while (++i < byteLength && (mul *= 0x100)) {
    this[offset + i] = (value / mul) & 0xFF;
  }

  return offset + byteLength
};

Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
  value = +value;
  offset = offset | 0;
  byteLength = byteLength | 0;
  if (!noAssert) {
    var maxBytes = Math.pow(2, 8 * byteLength) - 1;
    checkInt(this, value, offset, byteLength, maxBytes, 0);
  }

  var i = byteLength - 1;
  var mul = 1;
  this[offset + i] = value & 0xFF;
  while (--i >= 0 && (mul *= 0x100)) {
    this[offset + i] = (value / mul) & 0xFF;
  }

  return offset + byteLength
};

Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
  this[offset] = (value & 0xff);
  return offset + 1
};

function objectWriteUInt16 (buf, value, offset, littleEndian) {
  if (value < 0) value = 0xffff + value + 1;
  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
      (littleEndian ? i : 1 - i) * 8;
  }
}

Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value & 0xff);
    this[offset + 1] = (value >>> 8);
  } else {
    objectWriteUInt16(this, value, offset, true);
  }
  return offset + 2
};

Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 8);
    this[offset + 1] = (value & 0xff);
  } else {
    objectWriteUInt16(this, value, offset, false);
  }
  return offset + 2
};

function objectWriteUInt32 (buf, value, offset, littleEndian) {
  if (value < 0) value = 0xffffffff + value + 1;
  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff;
  }
}

Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset + 3] = (value >>> 24);
    this[offset + 2] = (value >>> 16);
    this[offset + 1] = (value >>> 8);
    this[offset] = (value & 0xff);
  } else {
    objectWriteUInt32(this, value, offset, true);
  }
  return offset + 4
};

Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 24);
    this[offset + 1] = (value >>> 16);
    this[offset + 2] = (value >>> 8);
    this[offset + 3] = (value & 0xff);
  } else {
    objectWriteUInt32(this, value, offset, false);
  }
  return offset + 4
};

Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) {
    var limit = Math.pow(2, 8 * byteLength - 1);

    checkInt(this, value, offset, byteLength, limit - 1, -limit);
  }

  var i = 0;
  var mul = 1;
  var sub = 0;
  this[offset] = value & 0xFF;
  while (++i < byteLength && (mul *= 0x100)) {
    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
      sub = 1;
    }
    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
  }

  return offset + byteLength
};

Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) {
    var limit = Math.pow(2, 8 * byteLength - 1);

    checkInt(this, value, offset, byteLength, limit - 1, -limit);
  }

  var i = byteLength - 1;
  var mul = 1;
  var sub = 0;
  this[offset + i] = value & 0xFF;
  while (--i >= 0 && (mul *= 0x100)) {
    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
      sub = 1;
    }
    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
  }

  return offset + byteLength
};

Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
  if (value < 0) value = 0xff + value + 1;
  this[offset] = (value & 0xff);
  return offset + 1
};

Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value & 0xff);
    this[offset + 1] = (value >>> 8);
  } else {
    objectWriteUInt16(this, value, offset, true);
  }
  return offset + 2
};

Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 8);
    this[offset + 1] = (value & 0xff);
  } else {
    objectWriteUInt16(this, value, offset, false);
  }
  return offset + 2
};

Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value & 0xff);
    this[offset + 1] = (value >>> 8);
    this[offset + 2] = (value >>> 16);
    this[offset + 3] = (value >>> 24);
  } else {
    objectWriteUInt32(this, value, offset, true);
  }
  return offset + 4
};

Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
  value = +value;
  offset = offset | 0;
  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
  if (value < 0) value = 0xffffffff + value + 1;
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 24);
    this[offset + 1] = (value >>> 16);
    this[offset + 2] = (value >>> 8);
    this[offset + 3] = (value & 0xff);
  } else {
    objectWriteUInt32(this, value, offset, false);
  }
  return offset + 4
};

function checkIEEE754 (buf, value, offset, ext, max, min) {
  if (offset + ext > buf.length) throw new RangeError('Index out of range')
  if (offset < 0) throw new RangeError('Index out of range')
}

function writeFloat (buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(buf, value, offset, 4);
  }
  write(buf, value, offset, littleEndian, 23, 4);
  return offset + 4
}

Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
  return writeFloat(this, value, offset, true, noAssert)
};

Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
  return writeFloat(this, value, offset, false, noAssert)
};

function writeDouble (buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(buf, value, offset, 8);
  }
  write(buf, value, offset, littleEndian, 52, 8);
  return offset + 8
}

Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
  return writeDouble(this, value, offset, true, noAssert)
};

Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
  return writeDouble(this, value, offset, false, noAssert)
};

// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
Buffer.prototype.copy = function copy (target, targetStart, start, end) {
  if (!start) start = 0;
  if (!end && end !== 0) end = this.length;
  if (targetStart >= target.length) targetStart = target.length;
  if (!targetStart) targetStart = 0;
  if (end > 0 && end < start) end = start;

  // Copy 0 bytes; we're done
  if (end === start) return 0
  if (target.length === 0 || this.length === 0) return 0

  // Fatal error conditions
  if (targetStart < 0) {
    throw new RangeError('targetStart out of bounds')
  }
  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
  if (end < 0) throw new RangeError('sourceEnd out of bounds')

  // Are we oob?
  if (end > this.length) end = this.length;
  if (target.length - targetStart < end - start) {
    end = target.length - targetStart + start;
  }

  var len = end - start;
  var i;

  if (this === target && start < targetStart && targetStart < end) {
    // descending copy from end
    for (i = len - 1; i >= 0; --i) {
      target[i + targetStart] = this[i + start];
    }
  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
    // ascending copy from start
    for (i = 0; i < len; ++i) {
      target[i + targetStart] = this[i + start];
    }
  } else {
    Uint8Array.prototype.set.call(
      target,
      this.subarray(start, start + len),
      targetStart
    );
  }

  return len
};

// Usage:
//    buffer.fill(number[, offset[, end]])
//    buffer.fill(buffer[, offset[, end]])
//    buffer.fill(string[, offset[, end]][, encoding])
Buffer.prototype.fill = function fill (val, start, end, encoding) {
  // Handle string cases:
  if (typeof val === 'string') {
    if (typeof start === 'string') {
      encoding = start;
      start = 0;
      end = this.length;
    } else if (typeof end === 'string') {
      encoding = end;
      end = this.length;
    }
    if (val.length === 1) {
      var code = val.charCodeAt(0);
      if (code < 256) {
        val = code;
      }
    }
    if (encoding !== undefined && typeof encoding !== 'string') {
      throw new TypeError('encoding must be a string')
    }
    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
      throw new TypeError('Unknown encoding: ' + encoding)
    }
  } else if (typeof val === 'number') {
    val = val & 255;
  }

  // Invalid ranges are not set to a default, so can range check early.
  if (start < 0 || this.length < start || this.length < end) {
    throw new RangeError('Out of range index')
  }

  if (end <= start) {
    return this
  }

  start = start >>> 0;
  end = end === undefined ? this.length : end >>> 0;

  if (!val) val = 0;

  var i;
  if (typeof val === 'number') {
    for (i = start; i < end; ++i) {
      this[i] = val;
    }
  } else {
    var bytes = internalIsBuffer(val)
      ? val
      : utf8ToBytes(new Buffer(val, encoding).toString());
    var len = bytes.length;
    for (i = 0; i < end - start; ++i) {
      this[i + start] = bytes[i % len];
    }
  }

  return this
};

// HELPER FUNCTIONS
// ================

var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

function base64clean (str) {
  // Node strips out invalid characters like \n and \t from the string, base64-js does not
  str = stringtrim(str).replace(INVALID_BASE64_RE, '');
  // Node converts strings with length < 2 to ''
  if (str.length < 2) return ''
  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
  while (str.length % 4 !== 0) {
    str = str + '=';
  }
  return str
}

function stringtrim (str) {
  if (str.trim) return str.trim()
  return str.replace(/^\s+|\s+$/g, '')
}

function toHex (n) {
  if (n < 16) return '0' + n.toString(16)
  return n.toString(16)
}

function utf8ToBytes (string, units) {
  units = units || Infinity;
  var codePoint;
  var length = string.length;
  var leadSurrogate = null;
  var bytes = [];

  for (var i = 0; i < length; ++i) {
    codePoint = string.charCodeAt(i);

    // is surrogate component
    if (codePoint > 0xD7FF && codePoint < 0xE000) {
      // last char was a lead
      if (!leadSurrogate) {
        // no lead yet
        if (codePoint > 0xDBFF) {
          // unexpected trail
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
          continue
        } else if (i + 1 === length) {
          // unpaired lead
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
          continue
        }

        // valid lead
        leadSurrogate = codePoint;

        continue
      }

      // 2 leads in a row
      if (codePoint < 0xDC00) {
        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
        leadSurrogate = codePoint;
        continue
      }

      // valid surrogate pair
      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
    } else if (leadSurrogate) {
      // valid bmp char, but last char was a lead
      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
    }

    leadSurrogate = null;

    // encode utf8
    if (codePoint < 0x80) {
      if ((units -= 1) < 0) break
      bytes.push(codePoint);
    } else if (codePoint < 0x800) {
      if ((units -= 2) < 0) break
      bytes.push(
        codePoint >> 0x6 | 0xC0,
        codePoint & 0x3F | 0x80
      );
    } else if (codePoint < 0x10000) {
      if ((units -= 3) < 0) break
      bytes.push(
        codePoint >> 0xC | 0xE0,
        codePoint >> 0x6 & 0x3F | 0x80,
        codePoint & 0x3F | 0x80
      );
    } else if (codePoint < 0x110000) {
      if ((units -= 4) < 0) break
      bytes.push(
        codePoint >> 0x12 | 0xF0,
        codePoint >> 0xC & 0x3F | 0x80,
        codePoint >> 0x6 & 0x3F | 0x80,
        codePoint & 0x3F | 0x80
      );
    } else {
      throw new Error('Invalid code point')
    }
  }

  return bytes
}

function asciiToBytes (str) {
  var byteArray = [];
  for (var i = 0; i < str.length; ++i) {
    // Node's code seems to be doing this and not & 0x7F..
    byteArray.push(str.charCodeAt(i) & 0xFF);
  }
  return byteArray
}

function utf16leToBytes (str, units) {
  var c, hi, lo;
  var byteArray = [];
  for (var i = 0; i < str.length; ++i) {
    if ((units -= 2) < 0) break

    c = str.charCodeAt(i);
    hi = c >> 8;
    lo = c % 256;
    byteArray.push(lo);
    byteArray.push(hi);
  }

  return byteArray
}


function base64ToBytes (str) {
  return toByteArray(base64clean(str))
}

function blitBuffer (src, dst, offset, length) {
  for (var i = 0; i < length; ++i) {
    if ((i + offset >= dst.length) || (i >= src.length)) break
    dst[i + offset] = src[i];
  }
  return i
}

function isnan (val) {
  return val !== val // eslint-disable-line no-self-compare
}


// the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
// The _isBuffer check is for Safari 5-7 support, because it's missing
// Object.prototype.constructor. Remove this eventually
function isBuffer(obj) {
  return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj))
}

function isFastBuffer (obj) {
  return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
}

// For Node v0.10 support. Remove this eventually.
function isSlowBuffer (obj) {
  return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0))
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var require$$4 = {};

var pdf = createCommonjsModule(function (module, exports) {
/**
 * @licstart The following is the entire license notice for the
 * Javascript code in this page
 *
 * Copyright 2020 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * Javascript code in this page
 */

(function webpackUniversalModuleDefinition(root, factory) {
	module.exports = factory();
})(commonjsGlobal, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __w_pdfjs_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__w_pdfjs_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__w_pdfjs_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__w_pdfjs_require__.d = function(exports, name, getter) {
/******/ 		if(!__w_pdfjs_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__w_pdfjs_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__w_pdfjs_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __w_pdfjs_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__w_pdfjs_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __w_pdfjs_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__w_pdfjs_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__w_pdfjs_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__w_pdfjs_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__w_pdfjs_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __w_pdfjs_require__(__w_pdfjs_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "addLinkAttributes", {
  enumerable: true,
  get: function () {
    return _display_utils.addLinkAttributes;
  }
});
Object.defineProperty(exports, "getFilenameFromUrl", {
  enumerable: true,
  get: function () {
    return _display_utils.getFilenameFromUrl;
  }
});
Object.defineProperty(exports, "LinkTarget", {
  enumerable: true,
  get: function () {
    return _display_utils.LinkTarget;
  }
});
Object.defineProperty(exports, "loadScript", {
  enumerable: true,
  get: function () {
    return _display_utils.loadScript;
  }
});
Object.defineProperty(exports, "PDFDateString", {
  enumerable: true,
  get: function () {
    return _display_utils.PDFDateString;
  }
});
Object.defineProperty(exports, "RenderingCancelledException", {
  enumerable: true,
  get: function () {
    return _display_utils.RenderingCancelledException;
  }
});
Object.defineProperty(exports, "build", {
  enumerable: true,
  get: function () {
    return _api.build;
  }
});
Object.defineProperty(exports, "getDocument", {
  enumerable: true,
  get: function () {
    return _api.getDocument;
  }
});
Object.defineProperty(exports, "LoopbackPort", {
  enumerable: true,
  get: function () {
    return _api.LoopbackPort;
  }
});
Object.defineProperty(exports, "PDFDataRangeTransport", {
  enumerable: true,
  get: function () {
    return _api.PDFDataRangeTransport;
  }
});
Object.defineProperty(exports, "PDFWorker", {
  enumerable: true,
  get: function () {
    return _api.PDFWorker;
  }
});
Object.defineProperty(exports, "version", {
  enumerable: true,
  get: function () {
    return _api.version;
  }
});
Object.defineProperty(exports, "CMapCompressionType", {
  enumerable: true,
  get: function () {
    return _util.CMapCompressionType;
  }
});
Object.defineProperty(exports, "createObjectURL", {
  enumerable: true,
  get: function () {
    return _util.createObjectURL;
  }
});
Object.defineProperty(exports, "createPromiseCapability", {
  enumerable: true,
  get: function () {
    return _util.createPromiseCapability;
  }
});
Object.defineProperty(exports, "createValidAbsoluteUrl", {
  enumerable: true,
  get: function () {
    return _util.createValidAbsoluteUrl;
  }
});
Object.defineProperty(exports, "InvalidPDFException", {
  enumerable: true,
  get: function () {
    return _util.InvalidPDFException;
  }
});
Object.defineProperty(exports, "MissingPDFException", {
  enumerable: true,
  get: function () {
    return _util.MissingPDFException;
  }
});
Object.defineProperty(exports, "OPS", {
  enumerable: true,
  get: function () {
    return _util.OPS;
  }
});
Object.defineProperty(exports, "PasswordResponses", {
  enumerable: true,
  get: function () {
    return _util.PasswordResponses;
  }
});
Object.defineProperty(exports, "PermissionFlag", {
  enumerable: true,
  get: function () {
    return _util.PermissionFlag;
  }
});
Object.defineProperty(exports, "removeNullCharacters", {
  enumerable: true,
  get: function () {
    return _util.removeNullCharacters;
  }
});
Object.defineProperty(exports, "shadow", {
  enumerable: true,
  get: function () {
    return _util.shadow;
  }
});
Object.defineProperty(exports, "UnexpectedResponseException", {
  enumerable: true,
  get: function () {
    return _util.UnexpectedResponseException;
  }
});
Object.defineProperty(exports, "UNSUPPORTED_FEATURES", {
  enumerable: true,
  get: function () {
    return _util.UNSUPPORTED_FEATURES;
  }
});
Object.defineProperty(exports, "Util", {
  enumerable: true,
  get: function () {
    return _util.Util;
  }
});
Object.defineProperty(exports, "VerbosityLevel", {
  enumerable: true,
  get: function () {
    return _util.VerbosityLevel;
  }
});
Object.defineProperty(exports, "AnnotationLayer", {
  enumerable: true,
  get: function () {
    return _annotation_layer.AnnotationLayer;
  }
});
Object.defineProperty(exports, "apiCompatibilityParams", {
  enumerable: true,
  get: function () {
    return _api_compatibility.apiCompatibilityParams;
  }
});
Object.defineProperty(exports, "GlobalWorkerOptions", {
  enumerable: true,
  get: function () {
    return _worker_options.GlobalWorkerOptions;
  }
});
Object.defineProperty(exports, "renderTextLayer", {
  enumerable: true,
  get: function () {
    return _text_layer.renderTextLayer;
  }
});
Object.defineProperty(exports, "SVGGraphics", {
  enumerable: true,
  get: function () {
    return _svg.SVGGraphics;
  }
});

var _display_utils = __w_pdfjs_require__(1);

var _api = __w_pdfjs_require__(5);

var _util = __w_pdfjs_require__(2);

var _annotation_layer = __w_pdfjs_require__(16);

var _api_compatibility = __w_pdfjs_require__(7);

var _worker_options = __w_pdfjs_require__(10);

var _text_layer = __w_pdfjs_require__(17);

var _svg = __w_pdfjs_require__(18);
{
  const {
    isNodeJS
  } = __w_pdfjs_require__(4);

  if (isNodeJS) {
    const PDFNodeStream = __w_pdfjs_require__(19).PDFNodeStream;

    (0, _api.setPDFNetworkStreamFactory)(params => {
      return new PDFNodeStream(params);
    });
  } else {
    const PDFNetworkStream = __w_pdfjs_require__(22).PDFNetworkStream;

    let PDFFetchStream;

    if ((0, _display_utils.isFetchSupported)()) {
      PDFFetchStream = __w_pdfjs_require__(23).PDFFetchStream;
    }

    (0, _api.setPDFNetworkStreamFactory)(params => {
      if (PDFFetchStream && (0, _display_utils.isValidFetchUrl)(params.url)) {
        return new PDFFetchStream(params);
      }

      return new PDFNetworkStream(params);
    });
  }
}

/***/ }),
/* 1 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addLinkAttributes = addLinkAttributes;
exports.getFilenameFromUrl = getFilenameFromUrl;
exports.isFetchSupported = isFetchSupported;
exports.isValidFetchUrl = isValidFetchUrl;
exports.loadScript = loadScript;
exports.deprecated = deprecated;
exports.PDFDateString = exports.StatTimer = exports.DOMSVGFactory = exports.DOMCMapReaderFactory = exports.DOMCanvasFactory = exports.DEFAULT_LINK_REL = exports.LinkTarget = exports.RenderingCancelledException = exports.PageViewport = void 0;

var _util = __w_pdfjs_require__(2);

const DEFAULT_LINK_REL = "noopener noreferrer nofollow";
exports.DEFAULT_LINK_REL = DEFAULT_LINK_REL;
const SVG_NS = "http://www.w3.org/2000/svg";

class DOMCanvasFactory {
  create(width, height) {
    if (width <= 0 || height <= 0) {
      throw new Error("Invalid canvas size");
    }

    const canvas = document.createElement("canvas");
    const context = canvas.getContext("2d");
    canvas.width = width;
    canvas.height = height;
    return {
      canvas,
      context
    };
  }

  reset(canvasAndContext, width, height) {
    if (!canvasAndContext.canvas) {
      throw new Error("Canvas is not specified");
    }

    if (width <= 0 || height <= 0) {
      throw new Error("Invalid canvas size");
    }

    canvasAndContext.canvas.width = width;
    canvasAndContext.canvas.height = height;
  }

  destroy(canvasAndContext) {
    if (!canvasAndContext.canvas) {
      throw new Error("Canvas is not specified");
    }

    canvasAndContext.canvas.width = 0;
    canvasAndContext.canvas.height = 0;
    canvasAndContext.canvas = null;
    canvasAndContext.context = null;
  }

}

exports.DOMCanvasFactory = DOMCanvasFactory;

class DOMCMapReaderFactory {
  constructor({
    baseUrl = null,
    isCompressed = false
  }) {
    this.baseUrl = baseUrl;
    this.isCompressed = isCompressed;
  }

  async fetch({
    name
  }) {
    if (!this.baseUrl) {
      throw new Error('The CMap "baseUrl" parameter must be specified, ensure that ' + 'the "cMapUrl" and "cMapPacked" API parameters are provided.');
    }

    if (!name) {
      throw new Error("CMap name must be specified.");
    }

    const url = this.baseUrl + name + (this.isCompressed ? ".bcmap" : "");
    const compressionType = this.isCompressed ? _util.CMapCompressionType.BINARY : _util.CMapCompressionType.NONE;

    if (isFetchSupported() && isValidFetchUrl(url, document.baseURI)) {
      return fetch(url).then(async response => {
        if (!response.ok) {
          throw new Error(response.statusText);
        }

        let cMapData;

        if (this.isCompressed) {
          cMapData = new Uint8Array(await response.arrayBuffer());
        } else {
          cMapData = (0, _util.stringToBytes)(await response.text());
        }

        return {
          cMapData,
          compressionType
        };
      }).catch(reason => {
        throw new Error(`Unable to load ${this.isCompressed ? "binary " : ""}` + `CMap at: ${url}`);
      });
    }

    return new Promise((resolve, reject) => {
      const request = new XMLHttpRequest();
      request.open("GET", url, true);

      if (this.isCompressed) {
        request.responseType = "arraybuffer";
      }

      request.onreadystatechange = () => {
        if (request.readyState !== XMLHttpRequest.DONE) {
          return;
        }

        if (request.status === 200 || request.status === 0) {
          let cMapData;

          if (this.isCompressed && request.response) {
            cMapData = new Uint8Array(request.response);
          } else if (!this.isCompressed && request.responseText) {
            cMapData = (0, _util.stringToBytes)(request.responseText);
          }

          if (cMapData) {
            resolve({
              cMapData,
              compressionType
            });
            return;
          }
        }

        reject(new Error(request.statusText));
      };

      request.send(null);
    }).catch(reason => {
      throw new Error(`Unable to load ${this.isCompressed ? "binary " : ""}` + `CMap at: ${url}`);
    });
  }

}

exports.DOMCMapReaderFactory = DOMCMapReaderFactory;

class DOMSVGFactory {
  create(width, height) {
    (0, _util.assert)(width > 0 && height > 0, "Invalid SVG dimensions");
    const svg = document.createElementNS(SVG_NS, "svg:svg");
    svg.setAttribute("version", "1.1");
    svg.setAttribute("width", width + "px");
    svg.setAttribute("height", height + "px");
    svg.setAttribute("preserveAspectRatio", "none");
    svg.setAttribute("viewBox", "0 0 " + width + " " + height);
    return svg;
  }

  createElement(type) {
    (0, _util.assert)(typeof type === "string", "Invalid SVG element type");
    return document.createElementNS(SVG_NS, type);
  }

}

exports.DOMSVGFactory = DOMSVGFactory;

class PageViewport {
  constructor({
    viewBox,
    scale,
    rotation,
    offsetX = 0,
    offsetY = 0,
    dontFlip = false
  }) {
    this.viewBox = viewBox;
    this.scale = scale;
    this.rotation = rotation;
    this.offsetX = offsetX;
    this.offsetY = offsetY;
    const centerX = (viewBox[2] + viewBox[0]) / 2;
    const centerY = (viewBox[3] + viewBox[1]) / 2;
    let rotateA, rotateB, rotateC, rotateD;
    rotation = rotation % 360;
    rotation = rotation < 0 ? rotation + 360 : rotation;

    switch (rotation) {
      case 180:
        rotateA = -1;
        rotateB = 0;
        rotateC = 0;
        rotateD = 1;
        break;

      case 90:
        rotateA = 0;
        rotateB = 1;
        rotateC = 1;
        rotateD = 0;
        break;

      case 270:
        rotateA = 0;
        rotateB = -1;
        rotateC = -1;
        rotateD = 0;
        break;

      case 0:
        rotateA = 1;
        rotateB = 0;
        rotateC = 0;
        rotateD = -1;
        break;

      default:
        throw new Error("PageViewport: Invalid rotation, must be a multiple of 90 degrees.");
    }

    if (dontFlip) {
      rotateC = -rotateC;
      rotateD = -rotateD;
    }

    let offsetCanvasX, offsetCanvasY;
    let width, height;

    if (rotateA === 0) {
      offsetCanvasX = Math.abs(centerY - viewBox[1]) * scale + offsetX;
      offsetCanvasY = Math.abs(centerX - viewBox[0]) * scale + offsetY;
      width = Math.abs(viewBox[3] - viewBox[1]) * scale;
      height = Math.abs(viewBox[2] - viewBox[0]) * scale;
    } else {
      offsetCanvasX = Math.abs(centerX - viewBox[0]) * scale + offsetX;
      offsetCanvasY = Math.abs(centerY - viewBox[1]) * scale + offsetY;
      width = Math.abs(viewBox[2] - viewBox[0]) * scale;
      height = Math.abs(viewBox[3] - viewBox[1]) * scale;
    }

    this.transform = [rotateA * scale, rotateB * scale, rotateC * scale, rotateD * scale, offsetCanvasX - rotateA * scale * centerX - rotateC * scale * centerY, offsetCanvasY - rotateB * scale * centerX - rotateD * scale * centerY];
    this.width = width;
    this.height = height;
  }

  clone({
    scale = this.scale,
    rotation = this.rotation,
    offsetX = this.offsetX,
    offsetY = this.offsetY,
    dontFlip = false
  } = {}) {
    return new PageViewport({
      viewBox: this.viewBox.slice(),
      scale,
      rotation,
      offsetX,
      offsetY,
      dontFlip
    });
  }

  convertToViewportPoint(x, y) {
    return _util.Util.applyTransform([x, y], this.transform);
  }

  convertToViewportRectangle(rect) {
    const topLeft = _util.Util.applyTransform([rect[0], rect[1]], this.transform);

    const bottomRight = _util.Util.applyTransform([rect[2], rect[3]], this.transform);

    return [topLeft[0], topLeft[1], bottomRight[0], bottomRight[1]];
  }

  convertToPdfPoint(x, y) {
    return _util.Util.applyInverseTransform([x, y], this.transform);
  }

}

exports.PageViewport = PageViewport;

class RenderingCancelledException extends _util.BaseException {
  constructor(msg, type) {
    super(msg);
    this.type = type;
  }

}

exports.RenderingCancelledException = RenderingCancelledException;
const LinkTarget = {
  NONE: 0,
  SELF: 1,
  BLANK: 2,
  PARENT: 3,
  TOP: 4
};
exports.LinkTarget = LinkTarget;

function addLinkAttributes(link, {
  url,
  target,
  rel,
  enabled = true
} = {}) {
  (0, _util.assert)(url && typeof url === "string", 'addLinkAttributes: A valid "url" parameter must provided.');
  const urlNullRemoved = (0, _util.removeNullCharacters)(url);

  if (enabled) {
    link.href = link.title = urlNullRemoved;
  } else {
    link.href = "";
    link.title = `Disabled: ${urlNullRemoved}`;

    link.onclick = () => {
      return false;
    };
  }

  let targetStr = "";

  switch (target) {
    case LinkTarget.NONE:
      break;

    case LinkTarget.SELF:
      targetStr = "_self";
      break;

    case LinkTarget.BLANK:
      targetStr = "_blank";
      break;

    case LinkTarget.PARENT:
      targetStr = "_parent";
      break;

    case LinkTarget.TOP:
      targetStr = "_top";
      break;
  }

  link.target = targetStr;
  link.rel = typeof rel === "string" ? rel : DEFAULT_LINK_REL;
}

function getFilenameFromUrl(url) {
  const anchor = url.indexOf("#");
  const query = url.indexOf("?");
  const end = Math.min(anchor > 0 ? anchor : url.length, query > 0 ? query : url.length);
  return url.substring(url.lastIndexOf("/", end) + 1, end);
}

class StatTimer {
  constructor() {
    this.started = Object.create(null);
    this.times = [];
  }

  time(name) {
    if (name in this.started) {
      (0, _util.warn)(`Timer is already running for ${name}`);
    }

    this.started[name] = Date.now();
  }

  timeEnd(name) {
    if (!(name in this.started)) {
      (0, _util.warn)(`Timer has not been started for ${name}`);
    }

    this.times.push({
      name,
      start: this.started[name],
      end: Date.now()
    });
    delete this.started[name];
  }

  toString() {
    const outBuf = [];
    let longest = 0;

    for (const time of this.times) {
      const name = time.name;

      if (name.length > longest) {
        longest = name.length;
      }
    }

    for (const time of this.times) {
      const duration = time.end - time.start;
      outBuf.push(`${time.name.padEnd(longest)} ${duration}ms\n`);
    }

    return outBuf.join("");
  }

}

exports.StatTimer = StatTimer;

function isFetchSupported() {
  return typeof fetch !== "undefined" && typeof Response !== "undefined" && "body" in Response.prototype && typeof ReadableStream !== "undefined";
}

function isValidFetchUrl(url, baseUrl) {
  try {
    const {
      protocol
    } = baseUrl ? new URL(url, baseUrl) : new URL(url);
    return protocol === "http:" || protocol === "https:";
  } catch (ex) {
    return false;
  }
}

function loadScript(src) {
  return new Promise((resolve, reject) => {
    const script = document.createElement("script");
    script.src = src;
    script.onload = resolve;

    script.onerror = function () {
      reject(new Error(`Cannot load script at: ${script.src}`));
    };

    (document.head || document.documentElement).appendChild(script);
  });
}

function deprecated(details) {
  console.log("Deprecated API usage: " + details);
}

let pdfDateStringRegex;

class PDFDateString {
  static toDateObject(input) {
    if (!input || !(0, _util.isString)(input)) {
      return null;
    }

    if (!pdfDateStringRegex) {
      pdfDateStringRegex = new RegExp("^D:" + "(\\d{4})" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "([Z|+|-])?" + "(\\d{2})?" + "'?" + "(\\d{2})?" + "'?");
    }

    const matches = pdfDateStringRegex.exec(input);

    if (!matches) {
      return null;
    }

    const year = parseInt(matches[1], 10);
    let month = parseInt(matches[2], 10);
    month = month >= 1 && month <= 12 ? month - 1 : 0;
    let day = parseInt(matches[3], 10);
    day = day >= 1 && day <= 31 ? day : 1;
    let hour = parseInt(matches[4], 10);
    hour = hour >= 0 && hour <= 23 ? hour : 0;
    let minute = parseInt(matches[5], 10);
    minute = minute >= 0 && minute <= 59 ? minute : 0;
    let second = parseInt(matches[6], 10);
    second = second >= 0 && second <= 59 ? second : 0;
    const universalTimeRelation = matches[7] || "Z";
    let offsetHour = parseInt(matches[8], 10);
    offsetHour = offsetHour >= 0 && offsetHour <= 23 ? offsetHour : 0;
    let offsetMinute = parseInt(matches[9], 10) || 0;
    offsetMinute = offsetMinute >= 0 && offsetMinute <= 59 ? offsetMinute : 0;

    if (universalTimeRelation === "-") {
      hour += offsetHour;
      minute += offsetMinute;
    } else if (universalTimeRelation === "+") {
      hour -= offsetHour;
      minute -= offsetMinute;
    }

    return new Date(Date.UTC(year, month, day, hour, minute, second));
  }

}

exports.PDFDateString = PDFDateString;

/***/ }),
/* 2 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.arrayByteLength = arrayByteLength;
exports.arraysToBytes = arraysToBytes;
exports.assert = assert;
exports.bytesToString = bytesToString;
exports.createPromiseCapability = createPromiseCapability;
exports.getVerbosityLevel = getVerbosityLevel;
exports.info = info;
exports.isArrayBuffer = isArrayBuffer;
exports.isArrayEqual = isArrayEqual;
exports.isBool = isBool;
exports.isEmptyObj = isEmptyObj;
exports.isNum = isNum;
exports.isString = isString;
exports.isSameOrigin = isSameOrigin;
exports.createValidAbsoluteUrl = createValidAbsoluteUrl;
exports.removeNullCharacters = removeNullCharacters;
exports.setVerbosityLevel = setVerbosityLevel;
exports.shadow = shadow;
exports.string32 = string32;
exports.stringToBytes = stringToBytes;
exports.stringToPDFString = stringToPDFString;
exports.stringToUTF8String = stringToUTF8String;
exports.utf8StringToString = utf8StringToString;
exports.warn = warn;
exports.unreachable = unreachable;
exports.IsEvalSupportedCached = exports.IsLittleEndianCached = exports.createObjectURL = exports.FormatError = exports.Util = exports.UnknownErrorException = exports.UnexpectedResponseException = exports.TextRenderingMode = exports.StreamType = exports.PermissionFlag = exports.PasswordResponses = exports.PasswordException = exports.MissingPDFException = exports.InvalidPDFException = exports.AbortException = exports.CMapCompressionType = exports.ImageKind = exports.FontType = exports.AnnotationType = exports.AnnotationStateModelType = exports.AnnotationReviewState = exports.AnnotationReplyType = exports.AnnotationMarkedState = exports.AnnotationFlag = exports.AnnotationFieldFlag = exports.AnnotationBorderStyleType = exports.UNSUPPORTED_FEATURES = exports.VerbosityLevel = exports.OPS = exports.IDENTITY_MATRIX = exports.FONT_IDENTITY_MATRIX = exports.BaseException = void 0;

__w_pdfjs_require__(3);

const IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0];
exports.IDENTITY_MATRIX = IDENTITY_MATRIX;
const FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0];
exports.FONT_IDENTITY_MATRIX = FONT_IDENTITY_MATRIX;
const PermissionFlag = {
  PRINT: 0x04,
  MODIFY_CONTENTS: 0x08,
  COPY: 0x10,
  MODIFY_ANNOTATIONS: 0x20,
  FILL_INTERACTIVE_FORMS: 0x100,
  COPY_FOR_ACCESSIBILITY: 0x200,
  ASSEMBLE: 0x400,
  PRINT_HIGH_QUALITY: 0x800
};
exports.PermissionFlag = PermissionFlag;
const TextRenderingMode = {
  FILL: 0,
  STROKE: 1,
  FILL_STROKE: 2,
  INVISIBLE: 3,
  FILL_ADD_TO_PATH: 4,
  STROKE_ADD_TO_PATH: 5,
  FILL_STROKE_ADD_TO_PATH: 6,
  ADD_TO_PATH: 7,
  FILL_STROKE_MASK: 3,
  ADD_TO_PATH_FLAG: 4
};
exports.TextRenderingMode = TextRenderingMode;
const ImageKind = {
  GRAYSCALE_1BPP: 1,
  RGB_24BPP: 2,
  RGBA_32BPP: 3
};
exports.ImageKind = ImageKind;
const AnnotationType = {
  TEXT: 1,
  LINK: 2,
  FREETEXT: 3,
  LINE: 4,
  SQUARE: 5,
  CIRCLE: 6,
  POLYGON: 7,
  POLYLINE: 8,
  HIGHLIGHT: 9,
  UNDERLINE: 10,
  SQUIGGLY: 11,
  STRIKEOUT: 12,
  STAMP: 13,
  CARET: 14,
  INK: 15,
  POPUP: 16,
  FILEATTACHMENT: 17,
  SOUND: 18,
  MOVIE: 19,
  WIDGET: 20,
  SCREEN: 21,
  PRINTERMARK: 22,
  TRAPNET: 23,
  WATERMARK: 24,
  THREED: 25,
  REDACT: 26
};
exports.AnnotationType = AnnotationType;
const AnnotationStateModelType = {
  MARKED: "Marked",
  REVIEW: "Review"
};
exports.AnnotationStateModelType = AnnotationStateModelType;
const AnnotationMarkedState = {
  MARKED: "Marked",
  UNMARKED: "Unmarked"
};
exports.AnnotationMarkedState = AnnotationMarkedState;
const AnnotationReviewState = {
  ACCEPTED: "Accepted",
  REJECTED: "Rejected",
  CANCELLED: "Cancelled",
  COMPLETED: "Completed",
  NONE: "None"
};
exports.AnnotationReviewState = AnnotationReviewState;
const AnnotationReplyType = {
  GROUP: "Group",
  REPLY: "R"
};
exports.AnnotationReplyType = AnnotationReplyType;
const AnnotationFlag = {
  INVISIBLE: 0x01,
  HIDDEN: 0x02,
  PRINT: 0x04,
  NOZOOM: 0x08,
  NOROTATE: 0x10,
  NOVIEW: 0x20,
  READONLY: 0x40,
  LOCKED: 0x80,
  TOGGLENOVIEW: 0x100,
  LOCKEDCONTENTS: 0x200
};
exports.AnnotationFlag = AnnotationFlag;
const AnnotationFieldFlag = {
  READONLY: 0x0000001,
  REQUIRED: 0x0000002,
  NOEXPORT: 0x0000004,
  MULTILINE: 0x0001000,
  PASSWORD: 0x0002000,
  NOTOGGLETOOFF: 0x0004000,
  RADIO: 0x0008000,
  PUSHBUTTON: 0x0010000,
  COMBO: 0x0020000,
  EDIT: 0x0040000,
  SORT: 0x0080000,
  FILESELECT: 0x0100000,
  MULTISELECT: 0x0200000,
  DONOTSPELLCHECK: 0x0400000,
  DONOTSCROLL: 0x0800000,
  COMB: 0x1000000,
  RICHTEXT: 0x2000000,
  RADIOSINUNISON: 0x2000000,
  COMMITONSELCHANGE: 0x4000000
};
exports.AnnotationFieldFlag = AnnotationFieldFlag;
const AnnotationBorderStyleType = {
  SOLID: 1,
  DASHED: 2,
  BEVELED: 3,
  INSET: 4,
  UNDERLINE: 5
};
exports.AnnotationBorderStyleType = AnnotationBorderStyleType;
const StreamType = {
  UNKNOWN: "UNKNOWN",
  FLATE: "FLATE",
  LZW: "LZW",
  DCT: "DCT",
  JPX: "JPX",
  JBIG: "JBIG",
  A85: "A85",
  AHX: "AHX",
  CCF: "CCF",
  RLX: "RLX"
};
exports.StreamType = StreamType;
const FontType = {
  UNKNOWN: "UNKNOWN",
  TYPE1: "TYPE1",
  TYPE1C: "TYPE1C",
  CIDFONTTYPE0: "CIDFONTTYPE0",
  CIDFONTTYPE0C: "CIDFONTTYPE0C",
  TRUETYPE: "TRUETYPE",
  CIDFONTTYPE2: "CIDFONTTYPE2",
  TYPE3: "TYPE3",
  OPENTYPE: "OPENTYPE",
  TYPE0: "TYPE0",
  MMTYPE1: "MMTYPE1"
};
exports.FontType = FontType;
const VerbosityLevel = {
  ERRORS: 0,
  WARNINGS: 1,
  INFOS: 5
};
exports.VerbosityLevel = VerbosityLevel;
const CMapCompressionType = {
  NONE: 0,
  BINARY: 1,
  STREAM: 2
};
exports.CMapCompressionType = CMapCompressionType;
const OPS = {
  dependency: 1,
  setLineWidth: 2,
  setLineCap: 3,
  setLineJoin: 4,
  setMiterLimit: 5,
  setDash: 6,
  setRenderingIntent: 7,
  setFlatness: 8,
  setGState: 9,
  save: 10,
  restore: 11,
  transform: 12,
  moveTo: 13,
  lineTo: 14,
  curveTo: 15,
  curveTo2: 16,
  curveTo3: 17,
  closePath: 18,
  rectangle: 19,
  stroke: 20,
  closeStroke: 21,
  fill: 22,
  eoFill: 23,
  fillStroke: 24,
  eoFillStroke: 25,
  closeFillStroke: 26,
  closeEOFillStroke: 27,
  endPath: 28,
  clip: 29,
  eoClip: 30,
  beginText: 31,
  endText: 32,
  setCharSpacing: 33,
  setWordSpacing: 34,
  setHScale: 35,
  setLeading: 36,
  setFont: 37,
  setTextRenderingMode: 38,
  setTextRise: 39,
  moveText: 40,
  setLeadingMoveText: 41,
  setTextMatrix: 42,
  nextLine: 43,
  showText: 44,
  showSpacedText: 45,
  nextLineShowText: 46,
  nextLineSetSpacingShowText: 47,
  setCharWidth: 48,
  setCharWidthAndBounds: 49,
  setStrokeColorSpace: 50,
  setFillColorSpace: 51,
  setStrokeColor: 52,
  setStrokeColorN: 53,
  setFillColor: 54,
  setFillColorN: 55,
  setStrokeGray: 56,
  setFillGray: 57,
  setStrokeRGBColor: 58,
  setFillRGBColor: 59,
  setStrokeCMYKColor: 60,
  setFillCMYKColor: 61,
  shadingFill: 62,
  beginInlineImage: 63,
  beginImageData: 64,
  endInlineImage: 65,
  paintXObject: 66,
  markPoint: 67,
  markPointProps: 68,
  beginMarkedContent: 69,
  beginMarkedContentProps: 70,
  endMarkedContent: 71,
  beginCompat: 72,
  endCompat: 73,
  paintFormXObjectBegin: 74,
  paintFormXObjectEnd: 75,
  beginGroup: 76,
  endGroup: 77,
  beginAnnotations: 78,
  endAnnotations: 79,
  beginAnnotation: 80,
  endAnnotation: 81,
  paintJpegXObject: 82,
  paintImageMaskXObject: 83,
  paintImageMaskXObjectGroup: 84,
  paintImageXObject: 85,
  paintInlineImageXObject: 86,
  paintInlineImageXObjectGroup: 87,
  paintImageXObjectRepeat: 88,
  paintImageMaskXObjectRepeat: 89,
  paintSolidColorImageMask: 90,
  constructPath: 91
};
exports.OPS = OPS;
const UNSUPPORTED_FEATURES = {
  unknown: "unknown",
  forms: "forms",
  javaScript: "javaScript",
  smask: "smask",
  shadingPattern: "shadingPattern",
  font: "font",
  errorTilingPattern: "errorTilingPattern",
  errorExtGState: "errorExtGState",
  errorXObject: "errorXObject",
  errorFontLoadType3: "errorFontLoadType3",
  errorFontState: "errorFontState",
  errorFontMissing: "errorFontMissing",
  errorFontTranslate: "errorFontTranslate",
  errorColorSpace: "errorColorSpace",
  errorOperatorList: "errorOperatorList",
  errorFontToUnicode: "errorFontToUnicode",
  errorFontLoadNative: "errorFontLoadNative",
  errorFontGetPath: "errorFontGetPath"
};
exports.UNSUPPORTED_FEATURES = UNSUPPORTED_FEATURES;
const PasswordResponses = {
  NEED_PASSWORD: 1,
  INCORRECT_PASSWORD: 2
};
exports.PasswordResponses = PasswordResponses;
let verbosity = VerbosityLevel.WARNINGS;

function setVerbosityLevel(level) {
  if (Number.isInteger(level)) {
    verbosity = level;
  }
}

function getVerbosityLevel() {
  return verbosity;
}

function info(msg) {
  if (verbosity >= VerbosityLevel.INFOS) {
    console.log(`Info: ${msg}`);
  }
}

function warn(msg) {
  if (verbosity >= VerbosityLevel.WARNINGS) {
    console.log(`Warning: ${msg}`);
  }
}

function unreachable(msg) {
  throw new Error(msg);
}

function assert(cond, msg) {
  if (!cond) {
    unreachable(msg);
  }
}

function isSameOrigin(baseUrl, otherUrl) {
  let base;

  try {
    base = new URL(baseUrl);

    if (!base.origin || base.origin === "null") {
      return false;
    }
  } catch (e) {
    return false;
  }

  const other = new URL(otherUrl, base);
  return base.origin === other.origin;
}

function _isValidProtocol(url) {
  if (!url) {
    return false;
  }

  switch (url.protocol) {
    case "http:":
    case "https:":
    case "ftp:":
    case "mailto:":
    case "tel:":
      return true;

    default:
      return false;
  }
}

function createValidAbsoluteUrl(url, baseUrl) {
  if (!url) {
    return null;
  }

  try {
    const absoluteUrl = baseUrl ? new URL(url, baseUrl) : new URL(url);

    if (_isValidProtocol(absoluteUrl)) {
      return absoluteUrl;
    }
  } catch (ex) {}

  return null;
}

function shadow(obj, prop, value) {
  Object.defineProperty(obj, prop, {
    value,
    enumerable: true,
    configurable: true,
    writable: false
  });
  return value;
}

const BaseException = function BaseExceptionClosure() {
  function BaseException(message) {
    if (this.constructor === BaseException) {
      unreachable("Cannot initialize BaseException.");
    }

    this.message = message;
    this.name = this.constructor.name;
  }

  BaseException.prototype = new Error();
  BaseException.constructor = BaseException;
  return BaseException;
}();

exports.BaseException = BaseException;

class PasswordException extends BaseException {
  constructor(msg, code) {
    super(msg);
    this.code = code;
  }

}

exports.PasswordException = PasswordException;

class UnknownErrorException extends BaseException {
  constructor(msg, details) {
    super(msg);
    this.details = details;
  }

}

exports.UnknownErrorException = UnknownErrorException;

class InvalidPDFException extends BaseException {}

exports.InvalidPDFException = InvalidPDFException;

class MissingPDFException extends BaseException {}

exports.MissingPDFException = MissingPDFException;

class UnexpectedResponseException extends BaseException {
  constructor(msg, status) {
    super(msg);
    this.status = status;
  }

}

exports.UnexpectedResponseException = UnexpectedResponseException;

class FormatError extends BaseException {}

exports.FormatError = FormatError;

class AbortException extends BaseException {}

exports.AbortException = AbortException;
const NullCharactersRegExp = /\x00/g;

function removeNullCharacters(str) {
  if (typeof str !== "string") {
    warn("The argument for removeNullCharacters must be a string.");
    return str;
  }

  return str.replace(NullCharactersRegExp, "");
}

function bytesToString(bytes) {
  assert(bytes !== null && typeof bytes === "object" && bytes.length !== undefined, "Invalid argument for bytesToString");
  const length = bytes.length;
  const MAX_ARGUMENT_COUNT = 8192;

  if (length < MAX_ARGUMENT_COUNT) {
    return String.fromCharCode.apply(null, bytes);
  }

  const strBuf = [];

  for (let i = 0; i < length; i += MAX_ARGUMENT_COUNT) {
    const chunkEnd = Math.min(i + MAX_ARGUMENT_COUNT, length);
    const chunk = bytes.subarray(i, chunkEnd);
    strBuf.push(String.fromCharCode.apply(null, chunk));
  }

  return strBuf.join("");
}

function stringToBytes(str) {
  assert(typeof str === "string", "Invalid argument for stringToBytes");
  const length = str.length;
  const bytes = new Uint8Array(length);

  for (let i = 0; i < length; ++i) {
    bytes[i] = str.charCodeAt(i) & 0xff;
  }

  return bytes;
}

function arrayByteLength(arr) {
  if (arr.length !== undefined) {
    return arr.length;
  }

  assert(arr.byteLength !== undefined, "arrayByteLength - invalid argument.");
  return arr.byteLength;
}

function arraysToBytes(arr) {
  const length = arr.length;

  if (length === 1 && arr[0] instanceof Uint8Array) {
    return arr[0];
  }

  let resultLength = 0;

  for (let i = 0; i < length; i++) {
    resultLength += arrayByteLength(arr[i]);
  }

  let pos = 0;
  const data = new Uint8Array(resultLength);

  for (let i = 0; i < length; i++) {
    let item = arr[i];

    if (!(item instanceof Uint8Array)) {
      if (typeof item === "string") {
        item = stringToBytes(item);
      } else {
        item = new Uint8Array(item);
      }
    }

    const itemLength = item.byteLength;
    data.set(item, pos);
    pos += itemLength;
  }

  return data;
}

function string32(value) {
  return String.fromCharCode(value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
}

function isLittleEndian() {
  const buffer8 = new Uint8Array(4);
  buffer8[0] = 1;
  const view32 = new Uint32Array(buffer8.buffer, 0, 1);
  return view32[0] === 1;
}

const IsLittleEndianCached = {
  get value() {
    return shadow(this, "value", isLittleEndian());
  }

};
exports.IsLittleEndianCached = IsLittleEndianCached;

function isEvalSupported() {
  try {
    new Function("");
    return true;
  } catch (e) {
    return false;
  }
}

const IsEvalSupportedCached = {
  get value() {
    return shadow(this, "value", isEvalSupported());
  }

};
exports.IsEvalSupportedCached = IsEvalSupportedCached;
const rgbBuf = ["rgb(", 0, ",", 0, ",", 0, ")"];

class Util {
  static makeCssRgb(r, g, b) {
    rgbBuf[1] = r;
    rgbBuf[3] = g;
    rgbBuf[5] = b;
    return rgbBuf.join("");
  }

  static transform(m1, m2) {
    return [m1[0] * m2[0] + m1[2] * m2[1], m1[1] * m2[0] + m1[3] * m2[1], m1[0] * m2[2] + m1[2] * m2[3], m1[1] * m2[2] + m1[3] * m2[3], m1[0] * m2[4] + m1[2] * m2[5] + m1[4], m1[1] * m2[4] + m1[3] * m2[5] + m1[5]];
  }

  static applyTransform(p, m) {
    const xt = p[0] * m[0] + p[1] * m[2] + m[4];
    const yt = p[0] * m[1] + p[1] * m[3] + m[5];
    return [xt, yt];
  }

  static applyInverseTransform(p, m) {
    const d = m[0] * m[3] - m[1] * m[2];
    const xt = (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d;
    const yt = (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d;
    return [xt, yt];
  }

  static getAxialAlignedBoundingBox(r, m) {
    const p1 = Util.applyTransform(r, m);
    const p2 = Util.applyTransform(r.slice(2, 4), m);
    const p3 = Util.applyTransform([r[0], r[3]], m);
    const p4 = Util.applyTransform([r[2], r[1]], m);
    return [Math.min(p1[0], p2[0], p3[0], p4[0]), Math.min(p1[1], p2[1], p3[1], p4[1]), Math.max(p1[0], p2[0], p3[0], p4[0]), Math.max(p1[1], p2[1], p3[1], p4[1])];
  }

  static inverseTransform(m) {
    const d = m[0] * m[3] - m[1] * m[2];
    return [m[3] / d, -m[1] / d, -m[2] / d, m[0] / d, (m[2] * m[5] - m[4] * m[3]) / d, (m[4] * m[1] - m[5] * m[0]) / d];
  }

  static apply3dTransform(m, v) {
    return [m[0] * v[0] + m[1] * v[1] + m[2] * v[2], m[3] * v[0] + m[4] * v[1] + m[5] * v[2], m[6] * v[0] + m[7] * v[1] + m[8] * v[2]];
  }

  static singularValueDecompose2dScale(m) {
    const transpose = [m[0], m[2], m[1], m[3]];
    const a = m[0] * transpose[0] + m[1] * transpose[2];
    const b = m[0] * transpose[1] + m[1] * transpose[3];
    const c = m[2] * transpose[0] + m[3] * transpose[2];
    const d = m[2] * transpose[1] + m[3] * transpose[3];
    const first = (a + d) / 2;
    const second = Math.sqrt((a + d) * (a + d) - 4 * (a * d - c * b)) / 2;
    const sx = first + second || 1;
    const sy = first - second || 1;
    return [Math.sqrt(sx), Math.sqrt(sy)];
  }

  static normalizeRect(rect) {
    const r = rect.slice(0);

    if (rect[0] > rect[2]) {
      r[0] = rect[2];
      r[2] = rect[0];
    }

    if (rect[1] > rect[3]) {
      r[1] = rect[3];
      r[3] = rect[1];
    }

    return r;
  }

  static intersect(rect1, rect2) {
    function compare(a, b) {
      return a - b;
    }

    const orderedX = [rect1[0], rect1[2], rect2[0], rect2[2]].sort(compare);
    const orderedY = [rect1[1], rect1[3], rect2[1], rect2[3]].sort(compare);
    const result = [];
    rect1 = Util.normalizeRect(rect1);
    rect2 = Util.normalizeRect(rect2);

    if (orderedX[0] === rect1[0] && orderedX[1] === rect2[0] || orderedX[0] === rect2[0] && orderedX[1] === rect1[0]) {
      result[0] = orderedX[1];
      result[2] = orderedX[2];
    } else {
      return null;
    }

    if (orderedY[0] === rect1[1] && orderedY[1] === rect2[1] || orderedY[0] === rect2[1] && orderedY[1] === rect1[1]) {
      result[1] = orderedY[1];
      result[3] = orderedY[2];
    } else {
      return null;
    }

    return result;
  }

}

exports.Util = Util;
const PDFStringTranslateTable = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2D8, 0x2C7, 0x2C6, 0x2D9, 0x2DD, 0x2DB, 0x2DA, 0x2DC, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2022, 0x2020, 0x2021, 0x2026, 0x2014, 0x2013, 0x192, 0x2044, 0x2039, 0x203A, 0x2212, 0x2030, 0x201E, 0x201C, 0x201D, 0x2018, 0x2019, 0x201A, 0x2122, 0xFB01, 0xFB02, 0x141, 0x152, 0x160, 0x178, 0x17D, 0x131, 0x142, 0x153, 0x161, 0x17E, 0, 0x20AC];

function stringToPDFString(str) {
  const length = str.length,
        strBuf = [];

  if (str[0] === "\xFE" && str[1] === "\xFF") {
    for (let i = 2; i < length; i += 2) {
      strBuf.push(String.fromCharCode(str.charCodeAt(i) << 8 | str.charCodeAt(i + 1)));
    }
  } else if (str[0] === "\xFF" && str[1] === "\xFE") {
    for (let i = 2; i < length; i += 2) {
      strBuf.push(String.fromCharCode(str.charCodeAt(i + 1) << 8 | str.charCodeAt(i)));
    }
  } else {
    for (let i = 0; i < length; ++i) {
      const code = PDFStringTranslateTable[str.charCodeAt(i)];
      strBuf.push(code ? String.fromCharCode(code) : str.charAt(i));
    }
  }

  return strBuf.join("");
}

function stringToUTF8String(str) {
  return decodeURIComponent(escape(str));
}

function utf8StringToString(str) {
  return unescape(encodeURIComponent(str));
}

function isEmptyObj(obj) {
  for (const key in obj) {
    return false;
  }

  return true;
}

function isBool(v) {
  return typeof v === "boolean";
}

function isNum(v) {
  return typeof v === "number";
}

function isString(v) {
  return typeof v === "string";
}

function isArrayBuffer(v) {
  return typeof v === "object" && v !== null && v.byteLength !== undefined;
}

function isArrayEqual(arr1, arr2) {
  if (arr1.length !== arr2.length) {
    return false;
  }

  return arr1.every(function (element, index) {
    return element === arr2[index];
  });
}

function createPromiseCapability() {
  const capability = Object.create(null);
  let isSettled = false;
  Object.defineProperty(capability, "settled", {
    get() {
      return isSettled;
    }

  });
  capability.promise = new Promise(function (resolve, reject) {
    capability.resolve = function (data) {
      isSettled = true;
      resolve(data);
    };

    capability.reject = function (reason) {
      isSettled = true;
      reject(reason);
    };
  });
  return capability;
}

const createObjectURL = function createObjectURLClosure() {
  const digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
  return function createObjectURL(data, contentType, forceDataSchema = false) {
    if (!forceDataSchema && URL.createObjectURL) {
      const blob = new Blob([data], {
        type: contentType
      });
      return URL.createObjectURL(blob);
    }

    let buffer = `data:${contentType};base64,`;

    for (let i = 0, ii = data.length; i < ii; i += 3) {
      const b1 = data[i] & 0xff;
      const b2 = data[i + 1] & 0xff;
      const b3 = data[i + 2] & 0xff;
      const d1 = b1 >> 2,
            d2 = (b1 & 3) << 4 | b2 >> 4;
      const d3 = i + 1 < ii ? (b2 & 0xf) << 2 | b3 >> 6 : 64;
      const d4 = i + 2 < ii ? b3 & 0x3f : 64;
      buffer += digits[d1] + digits[d2] + digits[d3] + digits[d4];
    }

    return buffer;
  };
}();

exports.createObjectURL = createObjectURL;

/***/ }),
/* 3 */
/***/ (function(module, exports, __w_pdfjs_require__) {


var _is_node = __w_pdfjs_require__(4);

/***/ }),
/* 4 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNodeJS = void 0;
const isNodeJS = typeof process$1 === "object" && process$1 + "" === "[object process]" && !process$1.versions.nw && !process$1.versions.electron;
exports.isNodeJS = isNodeJS;

/***/ }),
/* 5 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDocument = getDocument;
exports.setPDFNetworkStreamFactory = setPDFNetworkStreamFactory;
exports.build = exports.version = exports.PDFPageProxy = exports.PDFDocumentProxy = exports.PDFWorker = exports.PDFDataRangeTransport = exports.LoopbackPort = void 0;

var _util = __w_pdfjs_require__(2);

var _display_utils = __w_pdfjs_require__(1);

var _font_loader = __w_pdfjs_require__(6);

var _api_compatibility = __w_pdfjs_require__(7);

var _canvas = __w_pdfjs_require__(8);

var _worker_options = __w_pdfjs_require__(10);

var _is_node = __w_pdfjs_require__(4);

var _message_handler = __w_pdfjs_require__(11);

var _metadata = __w_pdfjs_require__(12);

var _transport_stream = __w_pdfjs_require__(14);

var _webgl = __w_pdfjs_require__(15);

const DEFAULT_RANGE_CHUNK_SIZE = 65536;
const RENDERING_CANCELLED_TIMEOUT = 100;
let createPDFNetworkStream;

function setPDFNetworkStreamFactory(pdfNetworkStreamFactory) {
  createPDFNetworkStream = pdfNetworkStreamFactory;
}

function getDocument(src) {
  const task = new PDFDocumentLoadingTask();
  let source;

  if (typeof src === "string") {
    source = {
      url: src
    };
  } else if ((0, _util.isArrayBuffer)(src)) {
    source = {
      data: src
    };
  } else if (src instanceof PDFDataRangeTransport) {
    source = {
      range: src
    };
  } else {
    if (typeof src !== "object") {
      throw new Error("Invalid parameter in getDocument, " + "need either Uint8Array, string or a parameter object");
    }

    if (!src.url && !src.data && !src.range) {
      throw new Error("Invalid parameter object: need either .data, .range or .url");
    }

    source = src;
  }

  const params = Object.create(null);
  let rangeTransport = null,
      worker = null;

  for (const key in source) {
    if (key === "url" && typeof window !== "undefined") {
      params[key] = new URL(source[key], window.location).href;
      continue;
    } else if (key === "range") {
      rangeTransport = source[key];
      continue;
    } else if (key === "worker") {
      worker = source[key];
      continue;
    } else if (key === "data" && !(source[key] instanceof Uint8Array)) {
      const pdfBytes = source[key];

      if (typeof pdfBytes === "string") {
        params[key] = (0, _util.stringToBytes)(pdfBytes);
      } else if (typeof pdfBytes === "object" && pdfBytes !== null && !isNaN(pdfBytes.length)) {
        params[key] = new Uint8Array(pdfBytes);
      } else if ((0, _util.isArrayBuffer)(pdfBytes)) {
        params[key] = new Uint8Array(pdfBytes);
      } else {
        throw new Error("Invalid PDF binary data: either typed array, " + "string or array-like object is expected in the " + "data property.");
      }

      continue;
    }

    params[key] = source[key];
  }

  params.rangeChunkSize = params.rangeChunkSize || DEFAULT_RANGE_CHUNK_SIZE;
  params.CMapReaderFactory = params.CMapReaderFactory || _display_utils.DOMCMapReaderFactory;
  params.ignoreErrors = params.stopAtErrors !== true;
  params.fontExtraProperties = params.fontExtraProperties === true;
  params.pdfBug = params.pdfBug === true;

  if (!Number.isInteger(params.maxImageSize)) {
    params.maxImageSize = -1;
  }

  if (typeof params.isEvalSupported !== "boolean") {
    params.isEvalSupported = true;
  }

  if (typeof params.disableFontFace !== "boolean") {
    params.disableFontFace = _api_compatibility.apiCompatibilityParams.disableFontFace || false;
  }

  if (typeof params.disableRange !== "boolean") {
    params.disableRange = false;
  }

  if (typeof params.disableStream !== "boolean") {
    params.disableStream = false;
  }

  if (typeof params.disableAutoFetch !== "boolean") {
    params.disableAutoFetch = false;
  }

  (0, _util.setVerbosityLevel)(params.verbosity);

  if (!worker) {
    const workerParams = {
      verbosity: params.verbosity,
      port: _worker_options.GlobalWorkerOptions.workerPort
    };
    worker = workerParams.port ? PDFWorker.fromPort(workerParams) : new PDFWorker(workerParams);
    task._worker = worker;
  }

  const docId = task.docId;
  worker.promise.then(function () {
    if (task.destroyed) {
      throw new Error("Loading aborted");
    }

    const workerIdPromise = _fetchDocument(worker, params, rangeTransport, docId);

    const networkStreamPromise = new Promise(function (resolve) {
      let networkStream;

      if (rangeTransport) {
        networkStream = new _transport_stream.PDFDataTransportStream({
          length: params.length,
          initialData: params.initialData,
          progressiveDone: params.progressiveDone,
          disableRange: params.disableRange,
          disableStream: params.disableStream
        }, rangeTransport);
      } else if (!params.data) {
        networkStream = createPDFNetworkStream({
          url: params.url,
          length: params.length,
          httpHeaders: params.httpHeaders,
          withCredentials: params.withCredentials,
          rangeChunkSize: params.rangeChunkSize,
          disableRange: params.disableRange,
          disableStream: params.disableStream
        });
      }

      resolve(networkStream);
    });
    return Promise.all([workerIdPromise, networkStreamPromise]).then(function ([workerId, networkStream]) {
      if (task.destroyed) {
        throw new Error("Loading aborted");
      }

      const messageHandler = new _message_handler.MessageHandler(docId, workerId, worker.port);
      messageHandler.postMessageTransfers = worker.postMessageTransfers;
      const transport = new WorkerTransport(messageHandler, task, networkStream, params);
      task._transport = transport;
      messageHandler.send("Ready", null);
    });
  }).catch(task._capability.reject);
  return task;
}

function _fetchDocument(worker, source, pdfDataRangeTransport, docId) {
  if (worker.destroyed) {
    return Promise.reject(new Error("Worker was destroyed"));
  }

  if (pdfDataRangeTransport) {
    source.length = pdfDataRangeTransport.length;
    source.initialData = pdfDataRangeTransport.initialData;
    source.progressiveDone = pdfDataRangeTransport.progressiveDone;
  }

  return worker.messageHandler.sendWithPromise("GetDocRequest", {
    docId,
    apiVersion: '2.5.207',
    source: {
      data: source.data,
      url: source.url,
      password: source.password,
      disableAutoFetch: source.disableAutoFetch,
      rangeChunkSize: source.rangeChunkSize,
      length: source.length
    },
    maxImageSize: source.maxImageSize,
    disableFontFace: source.disableFontFace,
    postMessageTransfers: worker.postMessageTransfers,
    docBaseUrl: source.docBaseUrl,
    ignoreErrors: source.ignoreErrors,
    isEvalSupported: source.isEvalSupported,
    fontExtraProperties: source.fontExtraProperties
  }).then(function (workerId) {
    if (worker.destroyed) {
      throw new Error("Worker was destroyed");
    }

    return workerId;
  });
}

const PDFDocumentLoadingTask = function PDFDocumentLoadingTaskClosure() {
  let nextDocumentId = 0;

  class PDFDocumentLoadingTask {
    constructor() {
      this._capability = (0, _util.createPromiseCapability)();
      this._transport = null;
      this._worker = null;
      this.docId = "d" + nextDocumentId++;
      this.destroyed = false;
      this.onPassword = null;
      this.onProgress = null;
      this.onUnsupportedFeature = null;
    }

    get promise() {
      return this._capability.promise;
    }

    destroy() {
      this.destroyed = true;
      const transportDestroyed = !this._transport ? Promise.resolve() : this._transport.destroy();
      return transportDestroyed.then(() => {
        this._transport = null;

        if (this._worker) {
          this._worker.destroy();

          this._worker = null;
        }
      });
    }

  }

  return PDFDocumentLoadingTask;
}();

class PDFDataRangeTransport {
  constructor(length, initialData, progressiveDone = false) {
    this.length = length;
    this.initialData = initialData;
    this.progressiveDone = progressiveDone;
    this._rangeListeners = [];
    this._progressListeners = [];
    this._progressiveReadListeners = [];
    this._progressiveDoneListeners = [];
    this._readyCapability = (0, _util.createPromiseCapability)();
  }

  addRangeListener(listener) {
    this._rangeListeners.push(listener);
  }

  addProgressListener(listener) {
    this._progressListeners.push(listener);
  }

  addProgressiveReadListener(listener) {
    this._progressiveReadListeners.push(listener);
  }

  addProgressiveDoneListener(listener) {
    this._progressiveDoneListeners.push(listener);
  }

  onDataRange(begin, chunk) {
    for (const listener of this._rangeListeners) {
      listener(begin, chunk);
    }
  }

  onDataProgress(loaded, total) {
    this._readyCapability.promise.then(() => {
      for (const listener of this._progressListeners) {
        listener(loaded, total);
      }
    });
  }

  onDataProgressiveRead(chunk) {
    this._readyCapability.promise.then(() => {
      for (const listener of this._progressiveReadListeners) {
        listener(chunk);
      }
    });
  }

  onDataProgressiveDone() {
    this._readyCapability.promise.then(() => {
      for (const listener of this._progressiveDoneListeners) {
        listener();
      }
    });
  }

  transportReady() {
    this._readyCapability.resolve();
  }

  requestDataRange(begin, end) {
    (0, _util.unreachable)("Abstract method PDFDataRangeTransport.requestDataRange");
  }

  abort() {}

}

exports.PDFDataRangeTransport = PDFDataRangeTransport;

class PDFDocumentProxy {
  constructor(pdfInfo, transport) {
    this._pdfInfo = pdfInfo;
    this._transport = transport;
  }

  get numPages() {
    return this._pdfInfo.numPages;
  }

  get fingerprint() {
    return this._pdfInfo.fingerprint;
  }

  getPage(pageNumber) {
    return this._transport.getPage(pageNumber);
  }

  getPageIndex(ref) {
    return this._transport.getPageIndex(ref);
  }

  getDestinations() {
    return this._transport.getDestinations();
  }

  getDestination(id) {
    return this._transport.getDestination(id);
  }

  getPageLabels() {
    return this._transport.getPageLabels();
  }

  getPageLayout() {
    return this._transport.getPageLayout();
  }

  getPageMode() {
    return this._transport.getPageMode();
  }

  getViewerPreferences() {
    return this._transport.getViewerPreferences();
  }

  getOpenAction() {
    return this._transport.getOpenAction();
  }

  getOpenActionDestination() {
    (0, _display_utils.deprecated)("getOpenActionDestination, use getOpenAction instead.");
    return this.getOpenAction().then(function (openAction) {
      return openAction && openAction.dest ? openAction.dest : null;
    });
  }

  getAttachments() {
    return this._transport.getAttachments();
  }

  getJavaScript() {
    return this._transport.getJavaScript();
  }

  getOutline() {
    return this._transport.getOutline();
  }

  getPermissions() {
    return this._transport.getPermissions();
  }

  getMetadata() {
    return this._transport.getMetadata();
  }

  getData() {
    return this._transport.getData();
  }

  getDownloadInfo() {
    return this._transport.downloadInfoCapability.promise;
  }

  getStats() {
    return this._transport.getStats();
  }

  cleanup() {
    return this._transport.startCleanup();
  }

  destroy() {
    return this.loadingTask.destroy();
  }

  get loadingParams() {
    return this._transport.loadingParams;
  }

  get loadingTask() {
    return this._transport.loadingTask;
  }

}

exports.PDFDocumentProxy = PDFDocumentProxy;

class PDFPageProxy {
  constructor(pageIndex, pageInfo, transport, pdfBug = false) {
    this._pageIndex = pageIndex;
    this._pageInfo = pageInfo;
    this._transport = transport;
    this._stats = pdfBug ? new _display_utils.StatTimer() : null;
    this._pdfBug = pdfBug;
    this.commonObjs = transport.commonObjs;
    this.objs = new PDFObjects();
    this.cleanupAfterRender = false;
    this.pendingCleanup = false;
    this.intentStates = Object.create(null);
    this.destroyed = false;
  }

  get pageNumber() {
    return this._pageIndex + 1;
  }

  get rotate() {
    return this._pageInfo.rotate;
  }

  get ref() {
    return this._pageInfo.ref;
  }

  get userUnit() {
    return this._pageInfo.userUnit;
  }

  get view() {
    return this._pageInfo.view;
  }

  getViewport({
    scale,
    rotation = this.rotate,
    offsetX = 0,
    offsetY = 0,
    dontFlip = false
  } = {}) {
    return new _display_utils.PageViewport({
      viewBox: this.view,
      scale,
      rotation,
      offsetX,
      offsetY,
      dontFlip
    });
  }

  getAnnotations({
    intent = null
  } = {}) {
    if (!this.annotationsPromise || this.annotationsIntent !== intent) {
      this.annotationsPromise = this._transport.getAnnotations(this._pageIndex, intent);
      this.annotationsIntent = intent;
    }

    return this.annotationsPromise;
  }

  render({
    canvasContext,
    viewport,
    intent = "display",
    enableWebGL = false,
    renderInteractiveForms = false,
    transform = null,
    imageLayer = null,
    canvasFactory = null,
    background = null
  }) {
    if (this._stats) {
      this._stats.time("Overall");
    }

    const renderingIntent = intent === "print" ? "print" : "display";
    this.pendingCleanup = false;

    if (!this.intentStates[renderingIntent]) {
      this.intentStates[renderingIntent] = Object.create(null);
    }

    const intentState = this.intentStates[renderingIntent];

    if (intentState.streamReaderCancelTimeout) {
      clearTimeout(intentState.streamReaderCancelTimeout);
      intentState.streamReaderCancelTimeout = null;
    }

    const canvasFactoryInstance = canvasFactory || new _display_utils.DOMCanvasFactory();
    const webGLContext = new _webgl.WebGLContext({
      enable: enableWebGL
    });

    if (!intentState.displayReadyCapability) {
      intentState.displayReadyCapability = (0, _util.createPromiseCapability)();
      intentState.operatorList = {
        fnArray: [],
        argsArray: [],
        lastChunk: false
      };

      if (this._stats) {
        this._stats.time("Page Request");
      }

      this._pumpOperatorList({
        pageIndex: this._pageIndex,
        intent: renderingIntent,
        renderInteractiveForms: renderInteractiveForms === true
      });
    }

    const complete = error => {
      const i = intentState.renderTasks.indexOf(internalRenderTask);

      if (i >= 0) {
        intentState.renderTasks.splice(i, 1);
      }

      if (this.cleanupAfterRender || renderingIntent === "print") {
        this.pendingCleanup = true;
      }

      this._tryCleanup();

      if (error) {
        internalRenderTask.capability.reject(error);

        this._abortOperatorList({
          intentState,
          reason: error
        });
      } else {
        internalRenderTask.capability.resolve();
      }

      if (this._stats) {
        this._stats.timeEnd("Rendering");

        this._stats.timeEnd("Overall");
      }
    };

    const internalRenderTask = new InternalRenderTask({
      callback: complete,
      params: {
        canvasContext,
        viewport,
        transform,
        imageLayer,
        background
      },
      objs: this.objs,
      commonObjs: this.commonObjs,
      operatorList: intentState.operatorList,
      pageIndex: this._pageIndex,
      canvasFactory: canvasFactoryInstance,
      webGLContext,
      useRequestAnimationFrame: renderingIntent !== "print",
      pdfBug: this._pdfBug
    });

    if (!intentState.renderTasks) {
      intentState.renderTasks = [];
    }

    intentState.renderTasks.push(internalRenderTask);
    const renderTask = internalRenderTask.task;
    intentState.displayReadyCapability.promise.then(transparency => {
      if (this.pendingCleanup) {
        complete();
        return;
      }

      if (this._stats) {
        this._stats.time("Rendering");
      }

      internalRenderTask.initializeGraphics(transparency);
      internalRenderTask.operatorListChanged();
    }).catch(complete);
    return renderTask;
  }

  getOperatorList() {
    function operatorListChanged() {
      if (intentState.operatorList.lastChunk) {
        intentState.opListReadCapability.resolve(intentState.operatorList);
        const i = intentState.renderTasks.indexOf(opListTask);

        if (i >= 0) {
          intentState.renderTasks.splice(i, 1);
        }
      }
    }

    const renderingIntent = "oplist";

    if (!this.intentStates[renderingIntent]) {
      this.intentStates[renderingIntent] = Object.create(null);
    }

    const intentState = this.intentStates[renderingIntent];
    let opListTask;

    if (!intentState.opListReadCapability) {
      opListTask = {};
      opListTask.operatorListChanged = operatorListChanged;
      intentState.opListReadCapability = (0, _util.createPromiseCapability)();
      intentState.renderTasks = [];
      intentState.renderTasks.push(opListTask);
      intentState.operatorList = {
        fnArray: [],
        argsArray: [],
        lastChunk: false
      };

      if (this._stats) {
        this._stats.time("Page Request");
      }

      this._pumpOperatorList({
        pageIndex: this._pageIndex,
        intent: renderingIntent
      });
    }

    return intentState.opListReadCapability.promise;
  }

  streamTextContent({
    normalizeWhitespace = false,
    disableCombineTextItems = false
  } = {}) {
    const TEXT_CONTENT_CHUNK_SIZE = 100;
    return this._transport.messageHandler.sendWithStream("GetTextContent", {
      pageIndex: this._pageIndex,
      normalizeWhitespace: normalizeWhitespace === true,
      combineTextItems: disableCombineTextItems !== true
    }, {
      highWaterMark: TEXT_CONTENT_CHUNK_SIZE,

      size(textContent) {
        return textContent.items.length;
      }

    });
  }

  getTextContent(params = {}) {
    const readableStream = this.streamTextContent(params);
    return new Promise(function (resolve, reject) {
      function pump() {
        reader.read().then(function ({
          value,
          done
        }) {
          if (done) {
            resolve(textContent);
            return;
          }

          Object.assign(textContent.styles, value.styles);
          textContent.items.push(...value.items);
          pump();
        }, reject);
      }

      const reader = readableStream.getReader();
      const textContent = {
        items: [],
        styles: Object.create(null)
      };
      pump();
    });
  }

  _destroy() {
    this.destroyed = true;
    this._transport.pageCache[this._pageIndex] = null;
    const waitOn = [];
    Object.keys(this.intentStates).forEach(intent => {
      const intentState = this.intentStates[intent];

      this._abortOperatorList({
        intentState,
        reason: new Error("Page was destroyed."),
        force: true
      });

      if (intent === "oplist") {
        return;
      }

      intentState.renderTasks.forEach(function (renderTask) {
        const renderCompleted = renderTask.capability.promise.catch(function () {});
        waitOn.push(renderCompleted);
        renderTask.cancel();
      });
    });
    this.objs.clear();
    this.annotationsPromise = null;
    this.pendingCleanup = false;
    return Promise.all(waitOn);
  }

  cleanup(resetStats = false) {
    this.pendingCleanup = true;
    return this._tryCleanup(resetStats);
  }

  _tryCleanup(resetStats = false) {
    if (!this.pendingCleanup || Object.keys(this.intentStates).some(intent => {
      const intentState = this.intentStates[intent];
      return intentState.renderTasks.length !== 0 || !intentState.operatorList.lastChunk;
    })) {
      return false;
    }

    Object.keys(this.intentStates).forEach(intent => {
      delete this.intentStates[intent];
    });
    this.objs.clear();
    this.annotationsPromise = null;

    if (resetStats && this._stats) {
      this._stats = new _display_utils.StatTimer();
    }

    this.pendingCleanup = false;
    return true;
  }

  _startRenderPage(transparency, intent) {
    const intentState = this.intentStates[intent];

    if (!intentState) {
      return;
    }

    if (this._stats) {
      this._stats.timeEnd("Page Request");
    }

    if (intentState.displayReadyCapability) {
      intentState.displayReadyCapability.resolve(transparency);
    }
  }

  _renderPageChunk(operatorListChunk, intentState) {
    for (let i = 0, ii = operatorListChunk.length; i < ii; i++) {
      intentState.operatorList.fnArray.push(operatorListChunk.fnArray[i]);
      intentState.operatorList.argsArray.push(operatorListChunk.argsArray[i]);
    }

    intentState.operatorList.lastChunk = operatorListChunk.lastChunk;

    for (let i = 0; i < intentState.renderTasks.length; i++) {
      intentState.renderTasks[i].operatorListChanged();
    }

    if (operatorListChunk.lastChunk) {
      this._tryCleanup();
    }
  }

  _pumpOperatorList(args) {
    (0, _util.assert)(args.intent, 'PDFPageProxy._pumpOperatorList: Expected "intent" argument.');

    const readableStream = this._transport.messageHandler.sendWithStream("GetOperatorList", args);

    const reader = readableStream.getReader();
    const intentState = this.intentStates[args.intent];
    intentState.streamReader = reader;

    const pump = () => {
      reader.read().then(({
        value,
        done
      }) => {
        if (done) {
          intentState.streamReader = null;
          return;
        }

        if (this._transport.destroyed) {
          return;
        }

        this._renderPageChunk(value, intentState);

        pump();
      }, reason => {
        intentState.streamReader = null;

        if (this._transport.destroyed) {
          return;
        }

        if (intentState.operatorList) {
          intentState.operatorList.lastChunk = true;

          for (let i = 0; i < intentState.renderTasks.length; i++) {
            intentState.renderTasks[i].operatorListChanged();
          }

          this._tryCleanup();
        }

        if (intentState.displayReadyCapability) {
          intentState.displayReadyCapability.reject(reason);
        } else if (intentState.opListReadCapability) {
          intentState.opListReadCapability.reject(reason);
        } else {
          throw reason;
        }
      });
    };

    pump();
  }

  _abortOperatorList({
    intentState,
    reason,
    force = false
  }) {
    (0, _util.assert)(reason instanceof Error || typeof reason === "object" && reason !== null, 'PDFPageProxy._abortOperatorList: Expected "reason" argument.');

    if (!intentState.streamReader) {
      return;
    }

    if (!force) {
      if (intentState.renderTasks.length !== 0) {
        return;
      }

      if (reason instanceof _display_utils.RenderingCancelledException) {
        intentState.streamReaderCancelTimeout = setTimeout(() => {
          this._abortOperatorList({
            intentState,
            reason,
            force: true
          });

          intentState.streamReaderCancelTimeout = null;
        }, RENDERING_CANCELLED_TIMEOUT);
        return;
      }
    }

    intentState.streamReader.cancel(new _util.AbortException(reason && reason.message));
    intentState.streamReader = null;

    if (this._transport.destroyed) {
      return;
    }

    Object.keys(this.intentStates).some(intent => {
      if (this.intentStates[intent] === intentState) {
        delete this.intentStates[intent];
        return true;
      }

      return false;
    });
    this.cleanup();
  }

  get stats() {
    return this._stats;
  }

}

exports.PDFPageProxy = PDFPageProxy;

class LoopbackPort {
  constructor(defer = true) {
    this._listeners = [];
    this._defer = defer;
    this._deferred = Promise.resolve(undefined);
  }

  postMessage(obj, transfers) {
    function cloneValue(value) {
      if (typeof value !== "object" || value === null) {
        return value;
      }

      if (cloned.has(value)) {
        return cloned.get(value);
      }

      let buffer, result;

      if ((buffer = value.buffer) && (0, _util.isArrayBuffer)(buffer)) {
        const transferable = transfers && transfers.includes(buffer);

        if (transferable) {
          result = new value.constructor(buffer, value.byteOffset, value.byteLength);
        } else {
          result = new value.constructor(value);
        }

        cloned.set(value, result);
        return result;
      }

      result = Array.isArray(value) ? [] : {};
      cloned.set(value, result);

      for (const i in value) {
        let desc,
            p = value;

        while (!(desc = Object.getOwnPropertyDescriptor(p, i))) {
          p = Object.getPrototypeOf(p);
        }

        if (typeof desc.value === "undefined") {
          continue;
        }

        if (typeof desc.value === "function") {
          if (value.hasOwnProperty && value.hasOwnProperty(i)) {
            throw new Error(`LoopbackPort.postMessage - cannot clone: ${value[i]}`);
          }

          continue;
        }

        result[i] = cloneValue(desc.value);
      }

      return result;
    }

    if (!this._defer) {
      this._listeners.forEach(listener => {
        listener.call(this, {
          data: obj
        });
      });

      return;
    }

    const cloned = new WeakMap();
    const e = {
      data: cloneValue(obj)
    };

    this._deferred.then(() => {
      this._listeners.forEach(listener => {
        listener.call(this, e);
      });
    });
  }

  addEventListener(name, listener) {
    this._listeners.push(listener);
  }

  removeEventListener(name, listener) {
    const i = this._listeners.indexOf(listener);

    this._listeners.splice(i, 1);
  }

  terminate() {
    this._listeners.length = 0;
  }

}

exports.LoopbackPort = LoopbackPort;

const PDFWorker = function PDFWorkerClosure() {
  const pdfWorkerPorts = new WeakMap();
  let isWorkerDisabled = false;
  let fallbackWorkerSrc;
  let nextFakeWorkerId = 0;
  let fakeWorkerCapability;

  if (_is_node.isNodeJS && typeof commonjsRequire === "function") {
    isWorkerDisabled = true;
    fallbackWorkerSrc = "./pdf.worker.js";
  } else if (typeof document === "object" && "currentScript" in document) {
    const pdfjsFilePath = document.currentScript && document.currentScript.src;

    if (pdfjsFilePath) {
      fallbackWorkerSrc = pdfjsFilePath.replace(/(\.(?:min\.)?js)(\?.*)?$/i, ".worker$1$2");
    }
  }

  function getWorkerSrc() {
    if (_worker_options.GlobalWorkerOptions.workerSrc) {
      return _worker_options.GlobalWorkerOptions.workerSrc;
    }

    if (typeof fallbackWorkerSrc !== "undefined") {
      if (!_is_node.isNodeJS) {
        (0, _display_utils.deprecated)('No "GlobalWorkerOptions.workerSrc" specified.');
      }

      return fallbackWorkerSrc;
    }

    throw new Error('No "GlobalWorkerOptions.workerSrc" specified.');
  }

  function getMainThreadWorkerMessageHandler() {
    let mainWorkerMessageHandler;

    try {
      mainWorkerMessageHandler = globalThis.pdfjsWorker && globalThis.pdfjsWorker.WorkerMessageHandler;
    } catch (ex) {}

    return mainWorkerMessageHandler || null;
  }

  function setupFakeWorkerGlobal() {
    if (fakeWorkerCapability) {
      return fakeWorkerCapability.promise;
    }

    fakeWorkerCapability = (0, _util.createPromiseCapability)();

    const loader = async function () {
      const mainWorkerMessageHandler = getMainThreadWorkerMessageHandler();

      if (mainWorkerMessageHandler) {
        return mainWorkerMessageHandler;
      }

      if (_is_node.isNodeJS && typeof commonjsRequire === "function") {
        const worker = eval("require")(getWorkerSrc());
        return worker.WorkerMessageHandler;
      }

      await (0, _display_utils.loadScript)(getWorkerSrc());
      return window.pdfjsWorker.WorkerMessageHandler;
    };

    loader().then(fakeWorkerCapability.resolve, fakeWorkerCapability.reject);
    return fakeWorkerCapability.promise;
  }

  function createCDNWrapper(url) {
    const wrapper = "importScripts('" + url + "');";
    return URL.createObjectURL(new Blob([wrapper]));
  }

  class PDFWorker {
    constructor({
      name = null,
      port = null,
      verbosity = (0, _util.getVerbosityLevel)()
    } = {}) {
      if (port && pdfWorkerPorts.has(port)) {
        throw new Error("Cannot use more than one PDFWorker per port");
      }

      this.name = name;
      this.destroyed = false;
      this.postMessageTransfers = true;
      this.verbosity = verbosity;
      this._readyCapability = (0, _util.createPromiseCapability)();
      this._port = null;
      this._webWorker = null;
      this._messageHandler = null;

      if (port) {
        pdfWorkerPorts.set(port, this);

        this._initializeFromPort(port);

        return;
      }

      this._initialize();
    }

    get promise() {
      return this._readyCapability.promise;
    }

    get port() {
      return this._port;
    }

    get messageHandler() {
      return this._messageHandler;
    }

    _initializeFromPort(port) {
      this._port = port;
      this._messageHandler = new _message_handler.MessageHandler("main", "worker", port);

      this._messageHandler.on("ready", function () {});

      this._readyCapability.resolve();
    }

    _initialize() {
      if (typeof Worker !== "undefined" && !isWorkerDisabled && !getMainThreadWorkerMessageHandler()) {
        let workerSrc = getWorkerSrc();

        try {
          if (!(0, _util.isSameOrigin)(window.location.href, workerSrc)) {
            workerSrc = createCDNWrapper(new URL(workerSrc, window.location).href);
          }

          const worker = new Worker(workerSrc);
          const messageHandler = new _message_handler.MessageHandler("main", "worker", worker);

          const terminateEarly = () => {
            worker.removeEventListener("error", onWorkerError);
            messageHandler.destroy();
            worker.terminate();

            if (this.destroyed) {
              this._readyCapability.reject(new Error("Worker was destroyed"));
            } else {
              this._setupFakeWorker();
            }
          };

          const onWorkerError = () => {
            if (!this._webWorker) {
              terminateEarly();
            }
          };

          worker.addEventListener("error", onWorkerError);
          messageHandler.on("test", data => {
            worker.removeEventListener("error", onWorkerError);

            if (this.destroyed) {
              terminateEarly();
              return;
            }

            if (data) {
              this._messageHandler = messageHandler;
              this._port = worker;
              this._webWorker = worker;

              if (!data.supportTransfers) {
                this.postMessageTransfers = false;
              }

              this._readyCapability.resolve();

              messageHandler.send("configure", {
                verbosity: this.verbosity
              });
            } else {
              this._setupFakeWorker();

              messageHandler.destroy();
              worker.terminate();
            }
          });
          messageHandler.on("ready", data => {
            worker.removeEventListener("error", onWorkerError);

            if (this.destroyed) {
              terminateEarly();
              return;
            }

            try {
              sendTest();
            } catch (e) {
              this._setupFakeWorker();
            }
          });

          const sendTest = () => {
            const testObj = new Uint8Array([this.postMessageTransfers ? 255 : 0]);

            try {
              messageHandler.send("test", testObj, [testObj.buffer]);
            } catch (ex) {
              (0, _util.warn)("Cannot use postMessage transfers.");
              testObj[0] = 0;
              messageHandler.send("test", testObj);
            }
          };

          sendTest();
          return;
        } catch (e) {
          (0, _util.info)("The worker has been disabled.");
        }
      }

      this._setupFakeWorker();
    }

    _setupFakeWorker() {
      if (!isWorkerDisabled) {
        (0, _util.warn)("Setting up fake worker.");
        isWorkerDisabled = true;
      }

      setupFakeWorkerGlobal().then(WorkerMessageHandler => {
        if (this.destroyed) {
          this._readyCapability.reject(new Error("Worker was destroyed"));

          return;
        }

        const port = new LoopbackPort();
        this._port = port;
        const id = "fake" + nextFakeWorkerId++;
        const workerHandler = new _message_handler.MessageHandler(id + "_worker", id, port);
        WorkerMessageHandler.setup(workerHandler, port);
        const messageHandler = new _message_handler.MessageHandler(id, id + "_worker", port);
        this._messageHandler = messageHandler;

        this._readyCapability.resolve();

        messageHandler.send("configure", {
          verbosity: this.verbosity
        });
      }).catch(reason => {
        this._readyCapability.reject(new Error(`Setting up fake worker failed: "${reason.message}".`));
      });
    }

    destroy() {
      this.destroyed = true;

      if (this._webWorker) {
        this._webWorker.terminate();

        this._webWorker = null;
      }

      pdfWorkerPorts.delete(this._port);
      this._port = null;

      if (this._messageHandler) {
        this._messageHandler.destroy();

        this._messageHandler = null;
      }
    }

    static fromPort(params) {
      if (!params || !params.port) {
        throw new Error("PDFWorker.fromPort - invalid method signature.");
      }

      if (pdfWorkerPorts.has(params.port)) {
        return pdfWorkerPorts.get(params.port);
      }

      return new PDFWorker(params);
    }

    static getWorkerSrc() {
      return getWorkerSrc();
    }

  }

  return PDFWorker;
}();

exports.PDFWorker = PDFWorker;

class WorkerTransport {
  constructor(messageHandler, loadingTask, networkStream, params) {
    this.messageHandler = messageHandler;
    this.loadingTask = loadingTask;
    this.commonObjs = new PDFObjects();
    this.fontLoader = new _font_loader.FontLoader({
      docId: loadingTask.docId,
      onUnsupportedFeature: this._onUnsupportedFeature.bind(this)
    });
    this._params = params;
    this.CMapReaderFactory = new params.CMapReaderFactory({
      baseUrl: params.cMapUrl,
      isCompressed: params.cMapPacked
    });
    this.destroyed = false;
    this.destroyCapability = null;
    this._passwordCapability = null;
    this._networkStream = networkStream;
    this._fullReader = null;
    this._lastProgress = null;
    this.pageCache = [];
    this.pagePromises = [];
    this.downloadInfoCapability = (0, _util.createPromiseCapability)();
    this.setupMessageHandler();
  }

  destroy() {
    if (this.destroyCapability) {
      return this.destroyCapability.promise;
    }

    this.destroyed = true;
    this.destroyCapability = (0, _util.createPromiseCapability)();

    if (this._passwordCapability) {
      this._passwordCapability.reject(new Error("Worker was destroyed during onPassword callback"));
    }

    const waitOn = [];
    this.pageCache.forEach(function (page) {
      if (page) {
        waitOn.push(page._destroy());
      }
    });
    this.pageCache.length = 0;
    this.pagePromises.length = 0;
    const terminated = this.messageHandler.sendWithPromise("Terminate", null);
    waitOn.push(terminated);
    Promise.all(waitOn).then(() => {
      this.fontLoader.clear();

      if (this._networkStream) {
        this._networkStream.cancelAllRequests(new _util.AbortException("Worker was terminated."));
      }

      if (this.messageHandler) {
        this.messageHandler.destroy();
        this.messageHandler = null;
      }

      this.destroyCapability.resolve();
    }, this.destroyCapability.reject);
    return this.destroyCapability.promise;
  }

  setupMessageHandler() {
    const {
      messageHandler,
      loadingTask
    } = this;
    messageHandler.on("GetReader", (data, sink) => {
      (0, _util.assert)(this._networkStream, "GetReader - no `IPDFStream` instance available.");
      this._fullReader = this._networkStream.getFullReader();

      this._fullReader.onProgress = evt => {
        this._lastProgress = {
          loaded: evt.loaded,
          total: evt.total
        };
      };

      sink.onPull = () => {
        this._fullReader.read().then(function ({
          value,
          done
        }) {
          if (done) {
            sink.close();
            return;
          }

          (0, _util.assert)((0, _util.isArrayBuffer)(value), "GetReader - expected an ArrayBuffer.");
          sink.enqueue(new Uint8Array(value), 1, [value]);
        }).catch(reason => {
          sink.error(reason);
        });
      };

      sink.onCancel = reason => {
        this._fullReader.cancel(reason);
      };
    });
    messageHandler.on("ReaderHeadersReady", data => {
      const headersCapability = (0, _util.createPromiseCapability)();
      const fullReader = this._fullReader;
      fullReader.headersReady.then(() => {
        if (!fullReader.isStreamingSupported || !fullReader.isRangeSupported) {
          if (this._lastProgress && loadingTask.onProgress) {
            loadingTask.onProgress(this._lastProgress);
          }

          fullReader.onProgress = evt => {
            if (loadingTask.onProgress) {
              loadingTask.onProgress({
                loaded: evt.loaded,
                total: evt.total
              });
            }
          };
        }

        headersCapability.resolve({
          isStreamingSupported: fullReader.isStreamingSupported,
          isRangeSupported: fullReader.isRangeSupported,
          contentLength: fullReader.contentLength
        });
      }, headersCapability.reject);
      return headersCapability.promise;
    });
    messageHandler.on("GetRangeReader", (data, sink) => {
      (0, _util.assert)(this._networkStream, "GetRangeReader - no `IPDFStream` instance available.");

      const rangeReader = this._networkStream.getRangeReader(data.begin, data.end);

      if (!rangeReader) {
        sink.close();
        return;
      }

      sink.onPull = () => {
        rangeReader.read().then(function ({
          value,
          done
        }) {
          if (done) {
            sink.close();
            return;
          }

          (0, _util.assert)((0, _util.isArrayBuffer)(value), "GetRangeReader - expected an ArrayBuffer.");
          sink.enqueue(new Uint8Array(value), 1, [value]);
        }).catch(reason => {
          sink.error(reason);
        });
      };

      sink.onCancel = reason => {
        rangeReader.cancel(reason);
      };
    });
    messageHandler.on("GetDoc", ({
      pdfInfo
    }) => {
      this._numPages = pdfInfo.numPages;

      loadingTask._capability.resolve(new PDFDocumentProxy(pdfInfo, this));
    });
    messageHandler.on("DocException", function (ex) {
      let reason;

      switch (ex.name) {
        case "PasswordException":
          reason = new _util.PasswordException(ex.message, ex.code);
          break;

        case "InvalidPDFException":
          reason = new _util.InvalidPDFException(ex.message);
          break;

        case "MissingPDFException":
          reason = new _util.MissingPDFException(ex.message);
          break;

        case "UnexpectedResponseException":
          reason = new _util.UnexpectedResponseException(ex.message, ex.status);
          break;

        case "UnknownErrorException":
          reason = new _util.UnknownErrorException(ex.message, ex.details);
          break;
      }

      loadingTask._capability.reject(reason);
    });
    messageHandler.on("PasswordRequest", exception => {
      this._passwordCapability = (0, _util.createPromiseCapability)();

      if (loadingTask.onPassword) {
        const updatePassword = password => {
          this._passwordCapability.resolve({
            password
          });
        };

        try {
          loadingTask.onPassword(updatePassword, exception.code);
        } catch (ex) {
          this._passwordCapability.reject(ex);
        }
      } else {
        this._passwordCapability.reject(new _util.PasswordException(exception.message, exception.code));
      }

      return this._passwordCapability.promise;
    });
    messageHandler.on("DataLoaded", data => {
      if (loadingTask.onProgress) {
        loadingTask.onProgress({
          loaded: data.length,
          total: data.length
        });
      }

      this.downloadInfoCapability.resolve(data);
    });
    messageHandler.on("StartRenderPage", data => {
      if (this.destroyed) {
        return;
      }

      const page = this.pageCache[data.pageIndex];

      page._startRenderPage(data.transparency, data.intent);
    });
    messageHandler.on("commonobj", data => {
      if (this.destroyed) {
        return;
      }

      const [id, type, exportedData] = data;

      if (this.commonObjs.has(id)) {
        return;
      }

      switch (type) {
        case "Font":
          const params = this._params;

          if ("error" in exportedData) {
            const exportedError = exportedData.error;
            (0, _util.warn)(`Error during font loading: ${exportedError}`);
            this.commonObjs.resolve(id, exportedError);
            break;
          }

          let fontRegistry = null;

          if (params.pdfBug && globalThis.FontInspector && globalThis.FontInspector.enabled) {
            fontRegistry = {
              registerFont(font, url) {
                globalThis.FontInspector.fontAdded(font, url);
              }

            };
          }

          const font = new _font_loader.FontFaceObject(exportedData, {
            isEvalSupported: params.isEvalSupported,
            disableFontFace: params.disableFontFace,
            ignoreErrors: params.ignoreErrors,
            onUnsupportedFeature: this._onUnsupportedFeature.bind(this),
            fontRegistry
          });
          this.fontLoader.bind(font).catch(reason => {
            return messageHandler.sendWithPromise("FontFallback", {
              id
            });
          }).finally(() => {
            if (!params.fontExtraProperties && font.data) {
              font.data = null;
            }

            this.commonObjs.resolve(id, font);
          });
          break;

        case "FontPath":
        case "FontType3Res":
        case "Image":
          this.commonObjs.resolve(id, exportedData);
          break;

        default:
          throw new Error(`Got unknown common object type ${type}`);
      }
    });
    messageHandler.on("obj", data => {
      if (this.destroyed) {
        return undefined;
      }

      const [id, pageIndex, type, imageData] = data;
      const pageProxy = this.pageCache[pageIndex];

      if (pageProxy.objs.has(id)) {
        return undefined;
      }

      switch (type) {
        case "Image":
          pageProxy.objs.resolve(id, imageData);
          const MAX_IMAGE_SIZE_TO_STORE = 8000000;

          if (imageData && "data" in imageData && imageData.data.length > MAX_IMAGE_SIZE_TO_STORE) {
            pageProxy.cleanupAfterRender = true;
          }

          break;

        default:
          throw new Error(`Got unknown object type ${type}`);
      }

      return undefined;
    });
    messageHandler.on("DocProgress", data => {
      if (this.destroyed) {
        return;
      }

      if (loadingTask.onProgress) {
        loadingTask.onProgress({
          loaded: data.loaded,
          total: data.total
        });
      }
    });
    messageHandler.on("UnsupportedFeature", this._onUnsupportedFeature.bind(this));
    messageHandler.on("FetchBuiltInCMap", (data, sink) => {
      if (this.destroyed) {
        sink.error(new Error("Worker was destroyed"));
        return;
      }

      let fetched = false;

      sink.onPull = () => {
        if (fetched) {
          sink.close();
          return;
        }

        fetched = true;
        this.CMapReaderFactory.fetch(data).then(function (builtInCMap) {
          sink.enqueue(builtInCMap, 1, [builtInCMap.cMapData.buffer]);
        }).catch(function (reason) {
          sink.error(reason);
        });
      };
    });
  }

  _onUnsupportedFeature({
    featureId
  }) {
    if (this.destroyed) {
      return;
    }

    if (this.loadingTask.onUnsupportedFeature) {
      this.loadingTask.onUnsupportedFeature(featureId);
    }
  }

  getData() {
    return this.messageHandler.sendWithPromise("GetData", null);
  }

  getPage(pageNumber) {
    if (!Number.isInteger(pageNumber) || pageNumber <= 0 || pageNumber > this._numPages) {
      return Promise.reject(new Error("Invalid page request"));
    }

    const pageIndex = pageNumber - 1;

    if (pageIndex in this.pagePromises) {
      return this.pagePromises[pageIndex];
    }

    const promise = this.messageHandler.sendWithPromise("GetPage", {
      pageIndex
    }).then(pageInfo => {
      if (this.destroyed) {
        throw new Error("Transport destroyed");
      }

      const page = new PDFPageProxy(pageIndex, pageInfo, this, this._params.pdfBug);
      this.pageCache[pageIndex] = page;
      return page;
    });
    this.pagePromises[pageIndex] = promise;
    return promise;
  }

  getPageIndex(ref) {
    return this.messageHandler.sendWithPromise("GetPageIndex", {
      ref
    }).catch(function (reason) {
      return Promise.reject(new Error(reason));
    });
  }

  getAnnotations(pageIndex, intent) {
    return this.messageHandler.sendWithPromise("GetAnnotations", {
      pageIndex,
      intent
    });
  }

  getDestinations() {
    return this.messageHandler.sendWithPromise("GetDestinations", null);
  }

  getDestination(id) {
    if (typeof id !== "string") {
      return Promise.reject(new Error("Invalid destination request."));
    }

    return this.messageHandler.sendWithPromise("GetDestination", {
      id
    });
  }

  getPageLabels() {
    return this.messageHandler.sendWithPromise("GetPageLabels", null);
  }

  getPageLayout() {
    return this.messageHandler.sendWithPromise("GetPageLayout", null);
  }

  getPageMode() {
    return this.messageHandler.sendWithPromise("GetPageMode", null);
  }

  getViewerPreferences() {
    return this.messageHandler.sendWithPromise("GetViewerPreferences", null);
  }

  getOpenAction() {
    return this.messageHandler.sendWithPromise("GetOpenAction", null);
  }

  getAttachments() {
    return this.messageHandler.sendWithPromise("GetAttachments", null);
  }

  getJavaScript() {
    return this.messageHandler.sendWithPromise("GetJavaScript", null);
  }

  getOutline() {
    return this.messageHandler.sendWithPromise("GetOutline", null);
  }

  getPermissions() {
    return this.messageHandler.sendWithPromise("GetPermissions", null);
  }

  getMetadata() {
    return this.messageHandler.sendWithPromise("GetMetadata", null).then(results => {
      return {
        info: results[0],
        metadata: results[1] ? new _metadata.Metadata(results[1]) : null,
        contentDispositionFilename: this._fullReader ? this._fullReader.filename : null
      };
    });
  }

  getStats() {
    return this.messageHandler.sendWithPromise("GetStats", null);
  }

  startCleanup() {
    return this.messageHandler.sendWithPromise("Cleanup", null).then(() => {
      for (let i = 0, ii = this.pageCache.length; i < ii; i++) {
        const page = this.pageCache[i];

        if (page) {
          const cleanupSuccessful = page.cleanup();

          if (!cleanupSuccessful) {
            throw new Error(`startCleanup: Page ${i + 1} is currently rendering.`);
          }
        }
      }

      this.commonObjs.clear();
      this.fontLoader.clear();
    });
  }

  get loadingParams() {
    const params = this._params;
    return (0, _util.shadow)(this, "loadingParams", {
      disableAutoFetch: params.disableAutoFetch,
      disableFontFace: params.disableFontFace
    });
  }

}

class PDFObjects {
  constructor() {
    this._objs = Object.create(null);
  }

  _ensureObj(objId) {
    if (this._objs[objId]) {
      return this._objs[objId];
    }

    return this._objs[objId] = {
      capability: (0, _util.createPromiseCapability)(),
      data: null,
      resolved: false
    };
  }

  get(objId, callback = null) {
    if (callback) {
      this._ensureObj(objId).capability.promise.then(callback);

      return null;
    }

    const obj = this._objs[objId];

    if (!obj || !obj.resolved) {
      throw new Error(`Requesting object that isn't resolved yet ${objId}.`);
    }

    return obj.data;
  }

  has(objId) {
    const obj = this._objs[objId];
    return obj ? obj.resolved : false;
  }

  resolve(objId, data) {
    const obj = this._ensureObj(objId);

    obj.resolved = true;
    obj.data = data;
    obj.capability.resolve(data);
  }

  clear() {
    this._objs = Object.create(null);
  }

}

class RenderTask {
  constructor(internalRenderTask) {
    this._internalRenderTask = internalRenderTask;
    this.onContinue = null;
  }

  get promise() {
    return this._internalRenderTask.capability.promise;
  }

  cancel() {
    this._internalRenderTask.cancel();
  }

}

const InternalRenderTask = function InternalRenderTaskClosure() {
  const canvasInRendering = new WeakSet();

  class InternalRenderTask {
    constructor({
      callback,
      params,
      objs,
      commonObjs,
      operatorList,
      pageIndex,
      canvasFactory,
      webGLContext,
      useRequestAnimationFrame = false,
      pdfBug = false
    }) {
      this.callback = callback;
      this.params = params;
      this.objs = objs;
      this.commonObjs = commonObjs;
      this.operatorListIdx = null;
      this.operatorList = operatorList;
      this._pageIndex = pageIndex;
      this.canvasFactory = canvasFactory;
      this.webGLContext = webGLContext;
      this._pdfBug = pdfBug;
      this.running = false;
      this.graphicsReadyCallback = null;
      this.graphicsReady = false;
      this._useRequestAnimationFrame = useRequestAnimationFrame === true && typeof window !== "undefined";
      this.cancelled = false;
      this.capability = (0, _util.createPromiseCapability)();
      this.task = new RenderTask(this);
      this._continueBound = this._continue.bind(this);
      this._scheduleNextBound = this._scheduleNext.bind(this);
      this._nextBound = this._next.bind(this);
      this._canvas = params.canvasContext.canvas;
    }

    initializeGraphics(transparency = false) {
      if (this.cancelled) {
        return;
      }

      if (this._canvas) {
        if (canvasInRendering.has(this._canvas)) {
          throw new Error("Cannot use the same canvas during multiple render() operations. " + "Use different canvas or ensure previous operations were " + "cancelled or completed.");
        }

        canvasInRendering.add(this._canvas);
      }

      if (this._pdfBug && globalThis.StepperManager && globalThis.StepperManager.enabled) {
        this.stepper = globalThis.StepperManager.create(this._pageIndex);
        this.stepper.init(this.operatorList);
        this.stepper.nextBreakPoint = this.stepper.getNextBreakPoint();
      }

      const {
        canvasContext,
        viewport,
        transform,
        imageLayer,
        background
      } = this.params;
      this.gfx = new _canvas.CanvasGraphics(canvasContext, this.commonObjs, this.objs, this.canvasFactory, this.webGLContext, imageLayer);
      this.gfx.beginDrawing({
        transform,
        viewport,
        transparency,
        background
      });
      this.operatorListIdx = 0;
      this.graphicsReady = true;

      if (this.graphicsReadyCallback) {
        this.graphicsReadyCallback();
      }
    }

    cancel(error = null) {
      this.running = false;
      this.cancelled = true;

      if (this.gfx) {
        this.gfx.endDrawing();
      }

      if (this._canvas) {
        canvasInRendering.delete(this._canvas);
      }

      this.callback(error || new _display_utils.RenderingCancelledException(`Rendering cancelled, page ${this._pageIndex + 1}`, "canvas"));
    }

    operatorListChanged() {
      if (!this.graphicsReady) {
        if (!this.graphicsReadyCallback) {
          this.graphicsReadyCallback = this._continueBound;
        }

        return;
      }

      if (this.stepper) {
        this.stepper.updateOperatorList(this.operatorList);
      }

      if (this.running) {
        return;
      }

      this._continue();
    }

    _continue() {
      this.running = true;

      if (this.cancelled) {
        return;
      }

      if (this.task.onContinue) {
        this.task.onContinue(this._scheduleNextBound);
      } else {
        this._scheduleNext();
      }
    }

    _scheduleNext() {
      if (this._useRequestAnimationFrame) {
        window.requestAnimationFrame(() => {
          this._nextBound().catch(this.cancel.bind(this));
        });
      } else {
        Promise.resolve().then(this._nextBound).catch(this.cancel.bind(this));
      }
    }

    async _next() {
      if (this.cancelled) {
        return;
      }

      this.operatorListIdx = this.gfx.executeOperatorList(this.operatorList, this.operatorListIdx, this._continueBound, this.stepper);

      if (this.operatorListIdx === this.operatorList.argsArray.length) {
        this.running = false;

        if (this.operatorList.lastChunk) {
          this.gfx.endDrawing();

          if (this._canvas) {
            canvasInRendering.delete(this._canvas);
          }

          this.callback();
        }
      }
    }

  }

  return InternalRenderTask;
}();

const version = '2.5.207';
exports.version = version;
const build = '0974d605';
exports.build = build;

/***/ }),
/* 6 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FontLoader = exports.FontFaceObject = void 0;

var _util = __w_pdfjs_require__(2);

class BaseFontLoader {
  constructor({
    docId,
    onUnsupportedFeature
  }) {
    if (this.constructor === BaseFontLoader) {
      (0, _util.unreachable)("Cannot initialize BaseFontLoader.");
    }

    this.docId = docId;
    this._onUnsupportedFeature = onUnsupportedFeature;
    this.nativeFontFaces = [];
    this.styleElement = null;
  }

  addNativeFontFace(nativeFontFace) {
    this.nativeFontFaces.push(nativeFontFace);
    document.fonts.add(nativeFontFace);
  }

  insertRule(rule) {
    let styleElement = this.styleElement;

    if (!styleElement) {
      styleElement = this.styleElement = document.createElement("style");
      styleElement.id = `PDFJS_FONT_STYLE_TAG_${this.docId}`;
      document.documentElement.getElementsByTagName("head")[0].appendChild(styleElement);
    }

    const styleSheet = styleElement.sheet;
    styleSheet.insertRule(rule, styleSheet.cssRules.length);
  }

  clear() {
    this.nativeFontFaces.forEach(function (nativeFontFace) {
      document.fonts.delete(nativeFontFace);
    });
    this.nativeFontFaces.length = 0;

    if (this.styleElement) {
      this.styleElement.remove();
      this.styleElement = null;
    }
  }

  async bind(font) {
    if (font.attached || font.missingFile) {
      return;
    }

    font.attached = true;

    if (this.isFontLoadingAPISupported) {
      const nativeFontFace = font.createNativeFontFace();

      if (nativeFontFace) {
        this.addNativeFontFace(nativeFontFace);

        try {
          await nativeFontFace.loaded;
        } catch (ex) {
          this._onUnsupportedFeature({
            featureId: _util.UNSUPPORTED_FEATURES.errorFontLoadNative
          });

          (0, _util.warn)(`Failed to load font '${nativeFontFace.family}': '${ex}'.`);
          font.disableFontFace = true;
          throw ex;
        }
      }

      return;
    }

    const rule = font.createFontFaceRule();

    if (rule) {
      this.insertRule(rule);

      if (this.isSyncFontLoadingSupported) {
        return;
      }

      await new Promise(resolve => {
        const request = this._queueLoadingCallback(resolve);

        this._prepareFontLoadEvent([rule], [font], request);
      });
    }
  }

  _queueLoadingCallback(callback) {
    (0, _util.unreachable)("Abstract method `_queueLoadingCallback`.");
  }

  get isFontLoadingAPISupported() {
    const supported = typeof document !== "undefined" && !!document.fonts;
    return (0, _util.shadow)(this, "isFontLoadingAPISupported", supported);
  }

  get isSyncFontLoadingSupported() {
    (0, _util.unreachable)("Abstract method `isSyncFontLoadingSupported`.");
  }

  get _loadTestFont() {
    (0, _util.unreachable)("Abstract method `_loadTestFont`.");
  }

  _prepareFontLoadEvent(rules, fontsToLoad, request) {
    (0, _util.unreachable)("Abstract method `_prepareFontLoadEvent`.");
  }

}

let FontLoader;
exports.FontLoader = FontLoader;
{
  exports.FontLoader = FontLoader = class GenericFontLoader extends BaseFontLoader {
    constructor(docId) {
      super(docId);
      this.loadingContext = {
        requests: [],
        nextRequestId: 0
      };
      this.loadTestFontId = 0;
    }

    get isSyncFontLoadingSupported() {
      let supported = false;

      if (typeof navigator === "undefined") {
        supported = true;
      } else {
        const m = /Mozilla\/5.0.*?rv:(\d+).*? Gecko/.exec(navigator.userAgent);

        if (m && m[1] >= 14) {
          supported = true;
        }
      }

      return (0, _util.shadow)(this, "isSyncFontLoadingSupported", supported);
    }

    _queueLoadingCallback(callback) {
      function completeRequest() {
        (0, _util.assert)(!request.done, "completeRequest() cannot be called twice.");
        request.done = true;

        while (context.requests.length > 0 && context.requests[0].done) {
          const otherRequest = context.requests.shift();
          setTimeout(otherRequest.callback, 0);
        }
      }

      const context = this.loadingContext;
      const request = {
        id: `pdfjs-font-loading-${context.nextRequestId++}`,
        done: false,
        complete: completeRequest,
        callback
      };
      context.requests.push(request);
      return request;
    }

    get _loadTestFont() {
      const getLoadTestFont = function () {
        return atob("T1RUTwALAIAAAwAwQ0ZGIDHtZg4AAAOYAAAAgUZGVE1lkzZwAAAEHAAAABxHREVGABQA" + "FQAABDgAAAAeT1MvMlYNYwkAAAEgAAAAYGNtYXABDQLUAAACNAAAAUJoZWFk/xVFDQAA" + "ALwAAAA2aGhlYQdkA+oAAAD0AAAAJGhtdHgD6AAAAAAEWAAAAAZtYXhwAAJQAAAAARgA" + "AAAGbmFtZVjmdH4AAAGAAAAAsXBvc3T/hgAzAAADeAAAACAAAQAAAAEAALZRFsRfDzz1" + "AAsD6AAAAADOBOTLAAAAAM4KHDwAAAAAA+gDIQAAAAgAAgAAAAAAAAABAAADIQAAAFoD" + "6AAAAAAD6AABAAAAAAAAAAAAAAAAAAAAAQAAUAAAAgAAAAQD6AH0AAUAAAKKArwAAACM" + "AooCvAAAAeAAMQECAAACAAYJAAAAAAAAAAAAAQAAAAAAAAAAAAAAAFBmRWQAwAAuAC4D" + "IP84AFoDIQAAAAAAAQAAAAAAAAAAACAAIAABAAAADgCuAAEAAAAAAAAAAQAAAAEAAAAA" + "AAEAAQAAAAEAAAAAAAIAAQAAAAEAAAAAAAMAAQAAAAEAAAAAAAQAAQAAAAEAAAAAAAUA" + "AQAAAAEAAAAAAAYAAQAAAAMAAQQJAAAAAgABAAMAAQQJAAEAAgABAAMAAQQJAAIAAgAB" + "AAMAAQQJAAMAAgABAAMAAQQJAAQAAgABAAMAAQQJAAUAAgABAAMAAQQJAAYAAgABWABY" + "AAAAAAAAAwAAAAMAAAAcAAEAAAAAADwAAwABAAAAHAAEACAAAAAEAAQAAQAAAC7//wAA" + "AC7////TAAEAAAAAAAABBgAAAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAAAAD/gwAyAAAAAQAAAAAAAAAAAAAAAAAA" + "AAABAAQEAAEBAQJYAAEBASH4DwD4GwHEAvgcA/gXBIwMAYuL+nz5tQXkD5j3CBLnEQAC" + "AQEBIVhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYAAABAQAADwACAQEEE/t3" + "Dov6fAH6fAT+fPp8+nwHDosMCvm1Cvm1DAz6fBQAAAAAAAABAAAAAMmJbzEAAAAAzgTj" + "FQAAAADOBOQpAAEAAAAAAAAADAAUAAQAAAABAAAAAgABAAAAAAAAAAAD6AAAAAAAAA==");
      };

      return (0, _util.shadow)(this, "_loadTestFont", getLoadTestFont());
    }

    _prepareFontLoadEvent(rules, fonts, request) {
      function int32(data, offset) {
        return data.charCodeAt(offset) << 24 | data.charCodeAt(offset + 1) << 16 | data.charCodeAt(offset + 2) << 8 | data.charCodeAt(offset + 3) & 0xff;
      }

      function spliceString(s, offset, remove, insert) {
        const chunk1 = s.substring(0, offset);
        const chunk2 = s.substring(offset + remove);
        return chunk1 + insert + chunk2;
      }

      let i, ii;
      const canvas = document.createElement("canvas");
      canvas.width = 1;
      canvas.height = 1;
      const ctx = canvas.getContext("2d");
      let called = 0;

      function isFontReady(name, callback) {
        called++;

        if (called > 30) {
          (0, _util.warn)("Load test font never loaded.");
          callback();
          return;
        }

        ctx.font = "30px " + name;
        ctx.fillText(".", 0, 20);
        const imageData = ctx.getImageData(0, 0, 1, 1);

        if (imageData.data[3] > 0) {
          callback();
          return;
        }

        setTimeout(isFontReady.bind(null, name, callback));
      }

      const loadTestFontId = `lt${Date.now()}${this.loadTestFontId++}`;
      let data = this._loadTestFont;
      const COMMENT_OFFSET = 976;
      data = spliceString(data, COMMENT_OFFSET, loadTestFontId.length, loadTestFontId);
      const CFF_CHECKSUM_OFFSET = 16;
      const XXXX_VALUE = 0x58585858;
      let checksum = int32(data, CFF_CHECKSUM_OFFSET);

      for (i = 0, ii = loadTestFontId.length - 3; i < ii; i += 4) {
        checksum = checksum - XXXX_VALUE + int32(loadTestFontId, i) | 0;
      }

      if (i < loadTestFontId.length) {
        checksum = checksum - XXXX_VALUE + int32(loadTestFontId + "XXX", i) | 0;
      }

      data = spliceString(data, CFF_CHECKSUM_OFFSET, 4, (0, _util.string32)(checksum));
      const url = `url(data:font/opentype;base64,${btoa(data)});`;
      const rule = `@font-face {font-family:"${loadTestFontId}";src:${url}}`;
      this.insertRule(rule);
      const names = [];

      for (i = 0, ii = fonts.length; i < ii; i++) {
        names.push(fonts[i].loadedName);
      }

      names.push(loadTestFontId);
      const div = document.createElement("div");
      div.style.visibility = "hidden";
      div.style.width = div.style.height = "10px";
      div.style.position = "absolute";
      div.style.top = div.style.left = "0px";

      for (i = 0, ii = names.length; i < ii; ++i) {
        const span = document.createElement("span");
        span.textContent = "Hi";
        span.style.fontFamily = names[i];
        div.appendChild(span);
      }

      document.body.appendChild(div);
      isFontReady(loadTestFontId, function () {
        document.body.removeChild(div);
        request.complete();
      });
    }

  };
}

class FontFaceObject {
  constructor(translatedData, {
    isEvalSupported = true,
    disableFontFace = false,
    ignoreErrors = false,
    onUnsupportedFeature = null,
    fontRegistry = null
  }) {
    this.compiledGlyphs = Object.create(null);

    for (const i in translatedData) {
      this[i] = translatedData[i];
    }

    this.isEvalSupported = isEvalSupported !== false;
    this.disableFontFace = disableFontFace === true;
    this.ignoreErrors = ignoreErrors === true;
    this._onUnsupportedFeature = onUnsupportedFeature;
    this.fontRegistry = fontRegistry;
  }

  createNativeFontFace() {
    if (!this.data || this.disableFontFace) {
      return null;
    }

    const nativeFontFace = new FontFace(this.loadedName, this.data, {});

    if (this.fontRegistry) {
      this.fontRegistry.registerFont(this);
    }

    return nativeFontFace;
  }

  createFontFaceRule() {
    if (!this.data || this.disableFontFace) {
      return null;
    }

    const data = (0, _util.bytesToString)(new Uint8Array(this.data));
    const url = `url(data:${this.mimetype};base64,${btoa(data)});`;
    const rule = `@font-face {font-family:"${this.loadedName}";src:${url}}`;

    if (this.fontRegistry) {
      this.fontRegistry.registerFont(this, url);
    }

    return rule;
  }

  getPathGenerator(objs, character) {
    if (this.compiledGlyphs[character] !== undefined) {
      return this.compiledGlyphs[character];
    }

    let cmds, current;

    try {
      cmds = objs.get(this.loadedName + "_path_" + character);
    } catch (ex) {
      if (!this.ignoreErrors) {
        throw ex;
      }

      if (this._onUnsupportedFeature) {
        this._onUnsupportedFeature({
          featureId: _util.UNSUPPORTED_FEATURES.errorFontGetPath
        });
      }

      (0, _util.warn)(`getPathGenerator - ignoring character: "${ex}".`);
      return this.compiledGlyphs[character] = function (c, size) {};
    }

    if (this.isEvalSupported && _util.IsEvalSupportedCached.value) {
      let args,
          js = "";

      for (let i = 0, ii = cmds.length; i < ii; i++) {
        current = cmds[i];

        if (current.args !== undefined) {
          args = current.args.join(",");
        } else {
          args = "";
        }

        js += "c." + current.cmd + "(" + args + ");\n";
      }

      return this.compiledGlyphs[character] = new Function("c", "size", js);
    }

    return this.compiledGlyphs[character] = function (c, size) {
      for (let i = 0, ii = cmds.length; i < ii; i++) {
        current = cmds[i];

        if (current.cmd === "scale") {
          current.args = [size, -size];
        }

        c[current.cmd].apply(c, current.args);
      }
    };
  }

}

exports.FontFaceObject = FontFaceObject;

/***/ }),
/* 7 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.apiCompatibilityParams = void 0;

var _is_node = __w_pdfjs_require__(4);

const compatibilityParams = Object.create(null);
{
  (function checkFontFace() {
    if (_is_node.isNodeJS) {
      compatibilityParams.disableFontFace = true;
    }
  })();
}
const apiCompatibilityParams = Object.freeze(compatibilityParams);
exports.apiCompatibilityParams = apiCompatibilityParams;

/***/ }),
/* 8 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CanvasGraphics = void 0;

var _util = __w_pdfjs_require__(2);

var _pattern_helper = __w_pdfjs_require__(9);

var MIN_FONT_SIZE = 16;
var MAX_FONT_SIZE = 100;
var MAX_GROUP_SIZE = 4096;
var MIN_WIDTH_FACTOR = 0.65;
var MAX_SIZE_TO_COMPILE = 1000;
var FULL_CHUNK_HEIGHT = 16;

function addContextCurrentTransform(ctx) {
  if (!ctx.mozCurrentTransform) {
    ctx._originalSave = ctx.save;
    ctx._originalRestore = ctx.restore;
    ctx._originalRotate = ctx.rotate;
    ctx._originalScale = ctx.scale;
    ctx._originalTranslate = ctx.translate;
    ctx._originalTransform = ctx.transform;
    ctx._originalSetTransform = ctx.setTransform;
    ctx._transformMatrix = ctx._transformMatrix || [1, 0, 0, 1, 0, 0];
    ctx._transformStack = [];
    Object.defineProperty(ctx, "mozCurrentTransform", {
      get: function getCurrentTransform() {
        return this._transformMatrix;
      }
    });
    Object.defineProperty(ctx, "mozCurrentTransformInverse", {
      get: function getCurrentTransformInverse() {
        var m = this._transformMatrix;
        var a = m[0],
            b = m[1],
            c = m[2],
            d = m[3],
            e = m[4],
            f = m[5];
        var ad_bc = a * d - b * c;
        var bc_ad = b * c - a * d;
        return [d / ad_bc, b / bc_ad, c / bc_ad, a / ad_bc, (d * e - c * f) / bc_ad, (b * e - a * f) / ad_bc];
      }
    });

    ctx.save = function ctxSave() {
      var old = this._transformMatrix;

      this._transformStack.push(old);

      this._transformMatrix = old.slice(0, 6);

      this._originalSave();
    };

    ctx.restore = function ctxRestore() {
      var prev = this._transformStack.pop();

      if (prev) {
        this._transformMatrix = prev;

        this._originalRestore();
      }
    };

    ctx.translate = function ctxTranslate(x, y) {
      var m = this._transformMatrix;
      m[4] = m[0] * x + m[2] * y + m[4];
      m[5] = m[1] * x + m[3] * y + m[5];

      this._originalTranslate(x, y);
    };

    ctx.scale = function ctxScale(x, y) {
      var m = this._transformMatrix;
      m[0] = m[0] * x;
      m[1] = m[1] * x;
      m[2] = m[2] * y;
      m[3] = m[3] * y;

      this._originalScale(x, y);
    };

    ctx.transform = function ctxTransform(a, b, c, d, e, f) {
      var m = this._transformMatrix;
      this._transformMatrix = [m[0] * a + m[2] * b, m[1] * a + m[3] * b, m[0] * c + m[2] * d, m[1] * c + m[3] * d, m[0] * e + m[2] * f + m[4], m[1] * e + m[3] * f + m[5]];

      ctx._originalTransform(a, b, c, d, e, f);
    };

    ctx.setTransform = function ctxSetTransform(a, b, c, d, e, f) {
      this._transformMatrix = [a, b, c, d, e, f];

      ctx._originalSetTransform(a, b, c, d, e, f);
    };

    ctx.rotate = function ctxRotate(angle) {
      var cosValue = Math.cos(angle);
      var sinValue = Math.sin(angle);
      var m = this._transformMatrix;
      this._transformMatrix = [m[0] * cosValue + m[2] * sinValue, m[1] * cosValue + m[3] * sinValue, m[0] * -sinValue + m[2] * cosValue, m[1] * -sinValue + m[3] * cosValue, m[4], m[5]];

      this._originalRotate(angle);
    };
  }
}

var CachedCanvases = function CachedCanvasesClosure() {
  function CachedCanvases(canvasFactory) {
    this.canvasFactory = canvasFactory;
    this.cache = Object.create(null);
  }

  CachedCanvases.prototype = {
    getCanvas: function CachedCanvases_getCanvas(id, width, height, trackTransform) {
      var canvasEntry;

      if (this.cache[id] !== undefined) {
        canvasEntry = this.cache[id];
        this.canvasFactory.reset(canvasEntry, width, height);
        canvasEntry.context.setTransform(1, 0, 0, 1, 0, 0);
      } else {
        canvasEntry = this.canvasFactory.create(width, height);
        this.cache[id] = canvasEntry;
      }

      if (trackTransform) {
        addContextCurrentTransform(canvasEntry.context);
      }

      return canvasEntry;
    },

    clear() {
      for (var id in this.cache) {
        var canvasEntry = this.cache[id];
        this.canvasFactory.destroy(canvasEntry);
        delete this.cache[id];
      }
    }

  };
  return CachedCanvases;
}();

function compileType3Glyph(imgData) {
  var POINT_TO_PROCESS_LIMIT = 1000;
  var width = imgData.width,
      height = imgData.height;
  var i,
      j,
      j0,
      width1 = width + 1;
  var points = new Uint8Array(width1 * (height + 1));
  var POINT_TYPES = new Uint8Array([0, 2, 4, 0, 1, 0, 5, 4, 8, 10, 0, 8, 0, 2, 1, 0]);
  var lineSize = width + 7 & ~7,
      data0 = imgData.data;
  var data = new Uint8Array(lineSize * height),
      pos = 0,
      ii;

  for (i = 0, ii = data0.length; i < ii; i++) {
    var mask = 128,
        elem = data0[i];

    while (mask > 0) {
      data[pos++] = elem & mask ? 0 : 255;
      mask >>= 1;
    }
  }

  var count = 0;
  pos = 0;

  if (data[pos] !== 0) {
    points[0] = 1;
    ++count;
  }

  for (j = 1; j < width; j++) {
    if (data[pos] !== data[pos + 1]) {
      points[j] = data[pos] ? 2 : 1;
      ++count;
    }

    pos++;
  }

  if (data[pos] !== 0) {
    points[j] = 2;
    ++count;
  }

  for (i = 1; i < height; i++) {
    pos = i * lineSize;
    j0 = i * width1;

    if (data[pos - lineSize] !== data[pos]) {
      points[j0] = data[pos] ? 1 : 8;
      ++count;
    }

    var sum = (data[pos] ? 4 : 0) + (data[pos - lineSize] ? 8 : 0);

    for (j = 1; j < width; j++) {
      sum = (sum >> 2) + (data[pos + 1] ? 4 : 0) + (data[pos - lineSize + 1] ? 8 : 0);

      if (POINT_TYPES[sum]) {
        points[j0 + j] = POINT_TYPES[sum];
        ++count;
      }

      pos++;
    }

    if (data[pos - lineSize] !== data[pos]) {
      points[j0 + j] = data[pos] ? 2 : 4;
      ++count;
    }

    if (count > POINT_TO_PROCESS_LIMIT) {
      return null;
    }
  }

  pos = lineSize * (height - 1);
  j0 = i * width1;

  if (data[pos] !== 0) {
    points[j0] = 8;
    ++count;
  }

  for (j = 1; j < width; j++) {
    if (data[pos] !== data[pos + 1]) {
      points[j0 + j] = data[pos] ? 4 : 8;
      ++count;
    }

    pos++;
  }

  if (data[pos] !== 0) {
    points[j0 + j] = 4;
    ++count;
  }

  if (count > POINT_TO_PROCESS_LIMIT) {
    return null;
  }

  var steps = new Int32Array([0, width1, -1, 0, -width1, 0, 0, 0, 1]);
  var outlines = [];

  for (i = 0; count && i <= height; i++) {
    var p = i * width1;
    var end = p + width;

    while (p < end && !points[p]) {
      p++;
    }

    if (p === end) {
      continue;
    }

    var coords = [p % width1, i];
    var type = points[p],
        p0 = p,
        pp;

    do {
      var step = steps[type];

      do {
        p += step;
      } while (!points[p]);

      pp = points[p];

      if (pp !== 5 && pp !== 10) {
        type = pp;
        points[p] = 0;
      } else {
        type = pp & 0x33 * type >> 4;
        points[p] &= type >> 2 | type << 2;
      }

      coords.push(p % width1);
      coords.push(p / width1 | 0);

      if (!points[p]) {
        --count;
      }
    } while (p0 !== p);

    outlines.push(coords);
    --i;
  }

  var drawOutline = function (c) {
    c.save();
    c.scale(1 / width, -1 / height);
    c.translate(0, -height);
    c.beginPath();

    for (let k = 0, kk = outlines.length; k < kk; k++) {
      var o = outlines[k];
      c.moveTo(o[0], o[1]);

      for (let l = 2, ll = o.length; l < ll; l += 2) {
        c.lineTo(o[l], o[l + 1]);
      }
    }

    c.fill();
    c.beginPath();
    c.restore();
  };

  return drawOutline;
}

var CanvasExtraState = function CanvasExtraStateClosure() {
  function CanvasExtraState() {
    this.alphaIsShape = false;
    this.fontSize = 0;
    this.fontSizeScale = 1;
    this.textMatrix = _util.IDENTITY_MATRIX;
    this.textMatrixScale = 1;
    this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
    this.leading = 0;
    this.x = 0;
    this.y = 0;
    this.lineX = 0;
    this.lineY = 0;
    this.charSpacing = 0;
    this.wordSpacing = 0;
    this.textHScale = 1;
    this.textRenderingMode = _util.TextRenderingMode.FILL;
    this.textRise = 0;
    this.fillColor = "#000000";
    this.strokeColor = "#000000";
    this.patternFill = false;
    this.fillAlpha = 1;
    this.strokeAlpha = 1;
    this.lineWidth = 1;
    this.activeSMask = null;
    this.resumeSMaskCtx = null;
  }

  CanvasExtraState.prototype = {
    clone: function CanvasExtraState_clone() {
      return Object.create(this);
    },
    setCurrentPoint: function CanvasExtraState_setCurrentPoint(x, y) {
      this.x = x;
      this.y = y;
    }
  };
  return CanvasExtraState;
}();

var CanvasGraphics = function CanvasGraphicsClosure() {
  var EXECUTION_TIME = 15;
  var EXECUTION_STEPS = 10;

  function CanvasGraphics(canvasCtx, commonObjs, objs, canvasFactory, webGLContext, imageLayer) {
    this.ctx = canvasCtx;
    this.current = new CanvasExtraState();
    this.stateStack = [];
    this.pendingClip = null;
    this.pendingEOFill = false;
    this.res = null;
    this.xobjs = null;
    this.commonObjs = commonObjs;
    this.objs = objs;
    this.canvasFactory = canvasFactory;
    this.webGLContext = webGLContext;
    this.imageLayer = imageLayer;
    this.groupStack = [];
    this.processingType3 = null;
    this.baseTransform = null;
    this.baseTransformStack = [];
    this.groupLevel = 0;
    this.smaskStack = [];
    this.smaskCounter = 0;
    this.tempSMask = null;
    this.cachedCanvases = new CachedCanvases(this.canvasFactory);

    if (canvasCtx) {
      addContextCurrentTransform(canvasCtx);
    }

    this._cachedGetSinglePixelWidth = null;
  }

  function putBinaryImageData(ctx, imgData) {
    if (typeof ImageData !== "undefined" && imgData instanceof ImageData) {
      ctx.putImageData(imgData, 0, 0);
      return;
    }

    var height = imgData.height,
        width = imgData.width;
    var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
    var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
    var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
    var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
    var srcPos = 0,
        destPos;
    var src = imgData.data;
    var dest = chunkImgData.data;
    var i, j, thisChunkHeight, elemsInThisChunk;

    if (imgData.kind === _util.ImageKind.GRAYSCALE_1BPP) {
      var srcLength = src.byteLength;
      var dest32 = new Uint32Array(dest.buffer, 0, dest.byteLength >> 2);
      var dest32DataLength = dest32.length;
      var fullSrcDiff = width + 7 >> 3;
      var white = 0xffffffff;
      var black = _util.IsLittleEndianCached.value ? 0xff000000 : 0x000000ff;

      for (i = 0; i < totalChunks; i++) {
        thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
        destPos = 0;

        for (j = 0; j < thisChunkHeight; j++) {
          var srcDiff = srcLength - srcPos;
          var k = 0;
          var kEnd = srcDiff > fullSrcDiff ? width : srcDiff * 8 - 7;
          var kEndUnrolled = kEnd & ~7;
          var mask = 0;
          var srcByte = 0;

          for (; k < kEndUnrolled; k += 8) {
            srcByte = src[srcPos++];
            dest32[destPos++] = srcByte & 128 ? white : black;
            dest32[destPos++] = srcByte & 64 ? white : black;
            dest32[destPos++] = srcByte & 32 ? white : black;
            dest32[destPos++] = srcByte & 16 ? white : black;
            dest32[destPos++] = srcByte & 8 ? white : black;
            dest32[destPos++] = srcByte & 4 ? white : black;
            dest32[destPos++] = srcByte & 2 ? white : black;
            dest32[destPos++] = srcByte & 1 ? white : black;
          }

          for (; k < kEnd; k++) {
            if (mask === 0) {
              srcByte = src[srcPos++];
              mask = 128;
            }

            dest32[destPos++] = srcByte & mask ? white : black;
            mask >>= 1;
          }
        }

        while (destPos < dest32DataLength) {
          dest32[destPos++] = 0;
        }

        ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
      }
    } else if (imgData.kind === _util.ImageKind.RGBA_32BPP) {
      j = 0;
      elemsInThisChunk = width * FULL_CHUNK_HEIGHT * 4;

      for (i = 0; i < fullChunks; i++) {
        dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
        srcPos += elemsInThisChunk;
        ctx.putImageData(chunkImgData, 0, j);
        j += FULL_CHUNK_HEIGHT;
      }

      if (i < totalChunks) {
        elemsInThisChunk = width * partialChunkHeight * 4;
        dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
        ctx.putImageData(chunkImgData, 0, j);
      }
    } else if (imgData.kind === _util.ImageKind.RGB_24BPP) {
      thisChunkHeight = FULL_CHUNK_HEIGHT;
      elemsInThisChunk = width * thisChunkHeight;

      for (i = 0; i < totalChunks; i++) {
        if (i >= fullChunks) {
          thisChunkHeight = partialChunkHeight;
          elemsInThisChunk = width * thisChunkHeight;
        }

        destPos = 0;

        for (j = elemsInThisChunk; j--;) {
          dest[destPos++] = src[srcPos++];
          dest[destPos++] = src[srcPos++];
          dest[destPos++] = src[srcPos++];
          dest[destPos++] = 255;
        }

        ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
      }
    } else {
      throw new Error(`bad image kind: ${imgData.kind}`);
    }
  }

  function putBinaryImageMask(ctx, imgData) {
    var height = imgData.height,
        width = imgData.width;
    var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
    var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
    var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
    var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
    var srcPos = 0;
    var src = imgData.data;
    var dest = chunkImgData.data;

    for (var i = 0; i < totalChunks; i++) {
      var thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
      var destPos = 3;

      for (var j = 0; j < thisChunkHeight; j++) {
        var mask = 0;

        for (var k = 0; k < width; k++) {
          if (!mask) {
            var elem = src[srcPos++];
            mask = 128;
          }

          dest[destPos] = elem & mask ? 0 : 255;
          destPos += 4;
          mask >>= 1;
        }
      }

      ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
    }
  }

  function copyCtxState(sourceCtx, destCtx) {
    var properties = ["strokeStyle", "fillStyle", "fillRule", "globalAlpha", "lineWidth", "lineCap", "lineJoin", "miterLimit", "globalCompositeOperation", "font"];

    for (var i = 0, ii = properties.length; i < ii; i++) {
      var property = properties[i];

      if (sourceCtx[property] !== undefined) {
        destCtx[property] = sourceCtx[property];
      }
    }

    if (sourceCtx.setLineDash !== undefined) {
      destCtx.setLineDash(sourceCtx.getLineDash());
      destCtx.lineDashOffset = sourceCtx.lineDashOffset;
    }
  }

  function resetCtxToDefault(ctx) {
    ctx.strokeStyle = "#000000";
    ctx.fillStyle = "#000000";
    ctx.fillRule = "nonzero";
    ctx.globalAlpha = 1;
    ctx.lineWidth = 1;
    ctx.lineCap = "butt";
    ctx.lineJoin = "miter";
    ctx.miterLimit = 10;
    ctx.globalCompositeOperation = "source-over";
    ctx.font = "10px sans-serif";

    if (ctx.setLineDash !== undefined) {
      ctx.setLineDash([]);
      ctx.lineDashOffset = 0;
    }
  }

  function composeSMaskBackdrop(bytes, r0, g0, b0) {
    var length = bytes.length;

    for (var i = 3; i < length; i += 4) {
      var alpha = bytes[i];

      if (alpha === 0) {
        bytes[i - 3] = r0;
        bytes[i - 2] = g0;
        bytes[i - 1] = b0;
      } else if (alpha < 255) {
        var alpha_ = 255 - alpha;
        bytes[i - 3] = bytes[i - 3] * alpha + r0 * alpha_ >> 8;
        bytes[i - 2] = bytes[i - 2] * alpha + g0 * alpha_ >> 8;
        bytes[i - 1] = bytes[i - 1] * alpha + b0 * alpha_ >> 8;
      }
    }
  }

  function composeSMaskAlpha(maskData, layerData, transferMap) {
    var length = maskData.length;
    var scale = 1 / 255;

    for (var i = 3; i < length; i += 4) {
      var alpha = transferMap ? transferMap[maskData[i]] : maskData[i];
      layerData[i] = layerData[i] * alpha * scale | 0;
    }
  }

  function composeSMaskLuminosity(maskData, layerData, transferMap) {
    var length = maskData.length;

    for (var i = 3; i < length; i += 4) {
      var y = maskData[i - 3] * 77 + maskData[i - 2] * 152 + maskData[i - 1] * 28;
      layerData[i] = transferMap ? layerData[i] * transferMap[y >> 8] >> 8 : layerData[i] * y >> 16;
    }
  }

  function genericComposeSMask(maskCtx, layerCtx, width, height, subtype, backdrop, transferMap) {
    var hasBackdrop = !!backdrop;
    var r0 = hasBackdrop ? backdrop[0] : 0;
    var g0 = hasBackdrop ? backdrop[1] : 0;
    var b0 = hasBackdrop ? backdrop[2] : 0;
    var composeFn;

    if (subtype === "Luminosity") {
      composeFn = composeSMaskLuminosity;
    } else {
      composeFn = composeSMaskAlpha;
    }

    var PIXELS_TO_PROCESS = 1048576;
    var chunkSize = Math.min(height, Math.ceil(PIXELS_TO_PROCESS / width));

    for (var row = 0; row < height; row += chunkSize) {
      var chunkHeight = Math.min(chunkSize, height - row);
      var maskData = maskCtx.getImageData(0, row, width, chunkHeight);
      var layerData = layerCtx.getImageData(0, row, width, chunkHeight);

      if (hasBackdrop) {
        composeSMaskBackdrop(maskData.data, r0, g0, b0);
      }

      composeFn(maskData.data, layerData.data, transferMap);
      maskCtx.putImageData(layerData, 0, row);
    }
  }

  function composeSMask(ctx, smask, layerCtx, webGLContext) {
    var mask = smask.canvas;
    var maskCtx = smask.context;
    ctx.setTransform(smask.scaleX, 0, 0, smask.scaleY, smask.offsetX, smask.offsetY);
    var backdrop = smask.backdrop || null;

    if (!smask.transferMap && webGLContext.isEnabled) {
      const composed = webGLContext.composeSMask({
        layer: layerCtx.canvas,
        mask,
        properties: {
          subtype: smask.subtype,
          backdrop
        }
      });
      ctx.setTransform(1, 0, 0, 1, 0, 0);
      ctx.drawImage(composed, smask.offsetX, smask.offsetY);
      return;
    }

    genericComposeSMask(maskCtx, layerCtx, mask.width, mask.height, smask.subtype, backdrop, smask.transferMap);
    ctx.drawImage(mask, 0, 0);
  }

  var LINE_CAP_STYLES = ["butt", "round", "square"];
  var LINE_JOIN_STYLES = ["miter", "round", "bevel"];
  var NORMAL_CLIP = {};
  var EO_CLIP = {};
  CanvasGraphics.prototype = {
    beginDrawing({
      transform,
      viewport,
      transparency = false,
      background = null
    }) {
      var width = this.ctx.canvas.width;
      var height = this.ctx.canvas.height;
      this.ctx.save();
      this.ctx.fillStyle = background || "rgb(255, 255, 255)";
      this.ctx.fillRect(0, 0, width, height);
      this.ctx.restore();

      if (transparency) {
        var transparentCanvas = this.cachedCanvases.getCanvas("transparent", width, height, true);
        this.compositeCtx = this.ctx;
        this.transparentCanvas = transparentCanvas.canvas;
        this.ctx = transparentCanvas.context;
        this.ctx.save();
        this.ctx.transform.apply(this.ctx, this.compositeCtx.mozCurrentTransform);
      }

      this.ctx.save();
      resetCtxToDefault(this.ctx);

      if (transform) {
        this.ctx.transform.apply(this.ctx, transform);
      }

      this.ctx.transform.apply(this.ctx, viewport.transform);
      this.baseTransform = this.ctx.mozCurrentTransform.slice();

      if (this.imageLayer) {
        this.imageLayer.beginLayout();
      }
    },

    executeOperatorList: function CanvasGraphics_executeOperatorList(operatorList, executionStartIdx, continueCallback, stepper) {
      var argsArray = operatorList.argsArray;
      var fnArray = operatorList.fnArray;
      var i = executionStartIdx || 0;
      var argsArrayLen = argsArray.length;

      if (argsArrayLen === i) {
        return i;
      }

      var chunkOperations = argsArrayLen - i > EXECUTION_STEPS && typeof continueCallback === "function";
      var endTime = chunkOperations ? Date.now() + EXECUTION_TIME : 0;
      var steps = 0;
      var commonObjs = this.commonObjs;
      var objs = this.objs;
      var fnId;

      while (true) {
        if (stepper !== undefined && i === stepper.nextBreakPoint) {
          stepper.breakIt(i, continueCallback);
          return i;
        }

        fnId = fnArray[i];

        if (fnId !== _util.OPS.dependency) {
          this[fnId].apply(this, argsArray[i]);
        } else {
          for (const depObjId of argsArray[i]) {
            const objsPool = depObjId.startsWith("g_") ? commonObjs : objs;

            if (!objsPool.has(depObjId)) {
              objsPool.get(depObjId, continueCallback);
              return i;
            }
          }
        }

        i++;

        if (i === argsArrayLen) {
          return i;
        }

        if (chunkOperations && ++steps > EXECUTION_STEPS) {
          if (Date.now() > endTime) {
            continueCallback();
            return i;
          }

          steps = 0;
        }
      }
    },
    endDrawing: function CanvasGraphics_endDrawing() {
      if (this.current.activeSMask !== null) {
        this.endSMaskGroup();
      }

      this.ctx.restore();

      if (this.transparentCanvas) {
        this.ctx = this.compositeCtx;
        this.ctx.save();
        this.ctx.setTransform(1, 0, 0, 1, 0, 0);
        this.ctx.drawImage(this.transparentCanvas, 0, 0);
        this.ctx.restore();
        this.transparentCanvas = null;
      }

      this.cachedCanvases.clear();
      this.webGLContext.clear();

      if (this.imageLayer) {
        this.imageLayer.endLayout();
      }
    },
    setLineWidth: function CanvasGraphics_setLineWidth(width) {
      this.current.lineWidth = width;
      this.ctx.lineWidth = width;
    },
    setLineCap: function CanvasGraphics_setLineCap(style) {
      this.ctx.lineCap = LINE_CAP_STYLES[style];
    },
    setLineJoin: function CanvasGraphics_setLineJoin(style) {
      this.ctx.lineJoin = LINE_JOIN_STYLES[style];
    },
    setMiterLimit: function CanvasGraphics_setMiterLimit(limit) {
      this.ctx.miterLimit = limit;
    },
    setDash: function CanvasGraphics_setDash(dashArray, dashPhase) {
      var ctx = this.ctx;

      if (ctx.setLineDash !== undefined) {
        ctx.setLineDash(dashArray);
        ctx.lineDashOffset = dashPhase;
      }
    },

    setRenderingIntent(intent) {},

    setFlatness(flatness) {},

    setGState: function CanvasGraphics_setGState(states) {
      for (var i = 0, ii = states.length; i < ii; i++) {
        var state = states[i];
        var key = state[0];
        var value = state[1];

        switch (key) {
          case "LW":
            this.setLineWidth(value);
            break;

          case "LC":
            this.setLineCap(value);
            break;

          case "LJ":
            this.setLineJoin(value);
            break;

          case "ML":
            this.setMiterLimit(value);
            break;

          case "D":
            this.setDash(value[0], value[1]);
            break;

          case "RI":
            this.setRenderingIntent(value);
            break;

          case "FL":
            this.setFlatness(value);
            break;

          case "Font":
            this.setFont(value[0], value[1]);
            break;

          case "CA":
            this.current.strokeAlpha = state[1];
            break;

          case "ca":
            this.current.fillAlpha = state[1];
            this.ctx.globalAlpha = state[1];
            break;

          case "BM":
            this.ctx.globalCompositeOperation = value;
            break;

          case "SMask":
            if (this.current.activeSMask) {
              if (this.stateStack.length > 0 && this.stateStack[this.stateStack.length - 1].activeSMask === this.current.activeSMask) {
                this.suspendSMaskGroup();
              } else {
                this.endSMaskGroup();
              }
            }

            this.current.activeSMask = value ? this.tempSMask : null;

            if (this.current.activeSMask) {
              this.beginSMaskGroup();
            }

            this.tempSMask = null;
            break;
        }
      }
    },
    beginSMaskGroup: function CanvasGraphics_beginSMaskGroup() {
      var activeSMask = this.current.activeSMask;
      var drawnWidth = activeSMask.canvas.width;
      var drawnHeight = activeSMask.canvas.height;
      var cacheId = "smaskGroupAt" + this.groupLevel;
      var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight, true);
      var currentCtx = this.ctx;
      var currentTransform = currentCtx.mozCurrentTransform;
      this.ctx.save();
      var groupCtx = scratchCanvas.context;
      groupCtx.scale(1 / activeSMask.scaleX, 1 / activeSMask.scaleY);
      groupCtx.translate(-activeSMask.offsetX, -activeSMask.offsetY);
      groupCtx.transform.apply(groupCtx, currentTransform);
      activeSMask.startTransformInverse = groupCtx.mozCurrentTransformInverse;
      copyCtxState(currentCtx, groupCtx);
      this.ctx = groupCtx;
      this.setGState([["BM", "source-over"], ["ca", 1], ["CA", 1]]);
      this.groupStack.push(currentCtx);
      this.groupLevel++;
    },
    suspendSMaskGroup: function CanvasGraphics_endSMaskGroup() {
      var groupCtx = this.ctx;
      this.groupLevel--;
      this.ctx = this.groupStack.pop();
      composeSMask(this.ctx, this.current.activeSMask, groupCtx, this.webGLContext);
      this.ctx.restore();
      this.ctx.save();
      copyCtxState(groupCtx, this.ctx);
      this.current.resumeSMaskCtx = groupCtx;

      var deltaTransform = _util.Util.transform(this.current.activeSMask.startTransformInverse, groupCtx.mozCurrentTransform);

      this.ctx.transform.apply(this.ctx, deltaTransform);
      groupCtx.save();
      groupCtx.setTransform(1, 0, 0, 1, 0, 0);
      groupCtx.clearRect(0, 0, groupCtx.canvas.width, groupCtx.canvas.height);
      groupCtx.restore();
    },
    resumeSMaskGroup: function CanvasGraphics_endSMaskGroup() {
      var groupCtx = this.current.resumeSMaskCtx;
      var currentCtx = this.ctx;
      this.ctx = groupCtx;
      this.groupStack.push(currentCtx);
      this.groupLevel++;
    },
    endSMaskGroup: function CanvasGraphics_endSMaskGroup() {
      var groupCtx = this.ctx;
      this.groupLevel--;
      this.ctx = this.groupStack.pop();
      composeSMask(this.ctx, this.current.activeSMask, groupCtx, this.webGLContext);
      this.ctx.restore();
      copyCtxState(groupCtx, this.ctx);

      var deltaTransform = _util.Util.transform(this.current.activeSMask.startTransformInverse, groupCtx.mozCurrentTransform);

      this.ctx.transform.apply(this.ctx, deltaTransform);
    },
    save: function CanvasGraphics_save() {
      this.ctx.save();
      var old = this.current;
      this.stateStack.push(old);
      this.current = old.clone();
      this.current.resumeSMaskCtx = null;
    },
    restore: function CanvasGraphics_restore() {
      if (this.current.resumeSMaskCtx) {
        this.resumeSMaskGroup();
      }

      if (this.current.activeSMask !== null && (this.stateStack.length === 0 || this.stateStack[this.stateStack.length - 1].activeSMask !== this.current.activeSMask)) {
        this.endSMaskGroup();
      }

      if (this.stateStack.length !== 0) {
        this.current = this.stateStack.pop();
        this.ctx.restore();
        this.pendingClip = null;
        this._cachedGetSinglePixelWidth = null;
      }
    },
    transform: function CanvasGraphics_transform(a, b, c, d, e, f) {
      this.ctx.transform(a, b, c, d, e, f);
      this._cachedGetSinglePixelWidth = null;
    },
    constructPath: function CanvasGraphics_constructPath(ops, args) {
      var ctx = this.ctx;
      var current = this.current;
      var x = current.x,
          y = current.y;

      for (var i = 0, j = 0, ii = ops.length; i < ii; i++) {
        switch (ops[i] | 0) {
          case _util.OPS.rectangle:
            x = args[j++];
            y = args[j++];
            var width = args[j++];
            var height = args[j++];

            if (width === 0) {
              width = this.getSinglePixelWidth();
            }

            if (height === 0) {
              height = this.getSinglePixelWidth();
            }

            var xw = x + width;
            var yh = y + height;
            this.ctx.moveTo(x, y);
            this.ctx.lineTo(xw, y);
            this.ctx.lineTo(xw, yh);
            this.ctx.lineTo(x, yh);
            this.ctx.lineTo(x, y);
            this.ctx.closePath();
            break;

          case _util.OPS.moveTo:
            x = args[j++];
            y = args[j++];
            ctx.moveTo(x, y);
            break;

          case _util.OPS.lineTo:
            x = args[j++];
            y = args[j++];
            ctx.lineTo(x, y);
            break;

          case _util.OPS.curveTo:
            x = args[j + 4];
            y = args[j + 5];
            ctx.bezierCurveTo(args[j], args[j + 1], args[j + 2], args[j + 3], x, y);
            j += 6;
            break;

          case _util.OPS.curveTo2:
            ctx.bezierCurveTo(x, y, args[j], args[j + 1], args[j + 2], args[j + 3]);
            x = args[j + 2];
            y = args[j + 3];
            j += 4;
            break;

          case _util.OPS.curveTo3:
            x = args[j + 2];
            y = args[j + 3];
            ctx.bezierCurveTo(args[j], args[j + 1], x, y, x, y);
            j += 4;
            break;

          case _util.OPS.closePath:
            ctx.closePath();
            break;
        }
      }

      current.setCurrentPoint(x, y);
    },
    closePath: function CanvasGraphics_closePath() {
      this.ctx.closePath();
    },
    stroke: function CanvasGraphics_stroke(consumePath) {
      consumePath = typeof consumePath !== "undefined" ? consumePath : true;
      var ctx = this.ctx;
      var strokeColor = this.current.strokeColor;
      ctx.globalAlpha = this.current.strokeAlpha;

      if (strokeColor && strokeColor.hasOwnProperty("type") && strokeColor.type === "Pattern") {
        ctx.save();
        const transform = ctx.mozCurrentTransform;

        const scale = _util.Util.singularValueDecompose2dScale(transform)[0];

        ctx.strokeStyle = strokeColor.getPattern(ctx, this);
        ctx.lineWidth = Math.max(this.getSinglePixelWidth() * MIN_WIDTH_FACTOR, this.current.lineWidth * scale);
        ctx.stroke();
        ctx.restore();
      } else {
        ctx.lineWidth = Math.max(this.getSinglePixelWidth() * MIN_WIDTH_FACTOR, this.current.lineWidth);
        ctx.stroke();
      }

      if (consumePath) {
        this.consumePath();
      }

      ctx.globalAlpha = this.current.fillAlpha;
    },
    closeStroke: function CanvasGraphics_closeStroke() {
      this.closePath();
      this.stroke();
    },
    fill: function CanvasGraphics_fill(consumePath) {
      consumePath = typeof consumePath !== "undefined" ? consumePath : true;
      var ctx = this.ctx;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var needRestore = false;

      if (isPatternFill) {
        ctx.save();

        if (this.baseTransform) {
          ctx.setTransform.apply(ctx, this.baseTransform);
        }

        ctx.fillStyle = fillColor.getPattern(ctx, this);
        needRestore = true;
      }

      if (this.pendingEOFill) {
        ctx.fill("evenodd");
        this.pendingEOFill = false;
      } else {
        ctx.fill();
      }

      if (needRestore) {
        ctx.restore();
      }

      if (consumePath) {
        this.consumePath();
      }
    },
    eoFill: function CanvasGraphics_eoFill() {
      this.pendingEOFill = true;
      this.fill();
    },
    fillStroke: function CanvasGraphics_fillStroke() {
      this.fill(false);
      this.stroke(false);
      this.consumePath();
    },
    eoFillStroke: function CanvasGraphics_eoFillStroke() {
      this.pendingEOFill = true;
      this.fillStroke();
    },
    closeFillStroke: function CanvasGraphics_closeFillStroke() {
      this.closePath();
      this.fillStroke();
    },
    closeEOFillStroke: function CanvasGraphics_closeEOFillStroke() {
      this.pendingEOFill = true;
      this.closePath();
      this.fillStroke();
    },
    endPath: function CanvasGraphics_endPath() {
      this.consumePath();
    },
    clip: function CanvasGraphics_clip() {
      this.pendingClip = NORMAL_CLIP;
    },
    eoClip: function CanvasGraphics_eoClip() {
      this.pendingClip = EO_CLIP;
    },
    beginText: function CanvasGraphics_beginText() {
      this.current.textMatrix = _util.IDENTITY_MATRIX;
      this.current.textMatrixScale = 1;
      this.current.x = this.current.lineX = 0;
      this.current.y = this.current.lineY = 0;
    },
    endText: function CanvasGraphics_endText() {
      var paths = this.pendingTextPaths;
      var ctx = this.ctx;

      if (paths === undefined) {
        ctx.beginPath();
        return;
      }

      ctx.save();
      ctx.beginPath();

      for (var i = 0; i < paths.length; i++) {
        var path = paths[i];
        ctx.setTransform.apply(ctx, path.transform);
        ctx.translate(path.x, path.y);
        path.addToPath(ctx, path.fontSize);
      }

      ctx.restore();
      ctx.clip();
      ctx.beginPath();
      delete this.pendingTextPaths;
    },
    setCharSpacing: function CanvasGraphics_setCharSpacing(spacing) {
      this.current.charSpacing = spacing;
    },
    setWordSpacing: function CanvasGraphics_setWordSpacing(spacing) {
      this.current.wordSpacing = spacing;
    },
    setHScale: function CanvasGraphics_setHScale(scale) {
      this.current.textHScale = scale / 100;
    },
    setLeading: function CanvasGraphics_setLeading(leading) {
      this.current.leading = -leading;
    },
    setFont: function CanvasGraphics_setFont(fontRefName, size) {
      var fontObj = this.commonObjs.get(fontRefName);
      var current = this.current;

      if (!fontObj) {
        throw new Error(`Can't find font for ${fontRefName}`);
      }

      current.fontMatrix = fontObj.fontMatrix ? fontObj.fontMatrix : _util.FONT_IDENTITY_MATRIX;

      if (current.fontMatrix[0] === 0 || current.fontMatrix[3] === 0) {
        (0, _util.warn)("Invalid font matrix for font " + fontRefName);
      }

      if (size < 0) {
        size = -size;
        current.fontDirection = -1;
      } else {
        current.fontDirection = 1;
      }

      this.current.font = fontObj;
      this.current.fontSize = size;

      if (fontObj.isType3Font) {
        return;
      }

      var name = fontObj.loadedName || "sans-serif";
      let bold = "normal";

      if (fontObj.black) {
        bold = "900";
      } else if (fontObj.bold) {
        bold = "bold";
      }

      var italic = fontObj.italic ? "italic" : "normal";
      var typeface = `"${name}", ${fontObj.fallbackName}`;
      let browserFontSize = size;

      if (size < MIN_FONT_SIZE) {
        browserFontSize = MIN_FONT_SIZE;
      } else if (size > MAX_FONT_SIZE) {
        browserFontSize = MAX_FONT_SIZE;
      }

      this.current.fontSizeScale = size / browserFontSize;
      this.ctx.font = `${italic} ${bold} ${browserFontSize}px ${typeface}`;
    },
    setTextRenderingMode: function CanvasGraphics_setTextRenderingMode(mode) {
      this.current.textRenderingMode = mode;
    },
    setTextRise: function CanvasGraphics_setTextRise(rise) {
      this.current.textRise = rise;
    },
    moveText: function CanvasGraphics_moveText(x, y) {
      this.current.x = this.current.lineX += x;
      this.current.y = this.current.lineY += y;
    },
    setLeadingMoveText: function CanvasGraphics_setLeadingMoveText(x, y) {
      this.setLeading(-y);
      this.moveText(x, y);
    },
    setTextMatrix: function CanvasGraphics_setTextMatrix(a, b, c, d, e, f) {
      this.current.textMatrix = [a, b, c, d, e, f];
      this.current.textMatrixScale = Math.sqrt(a * a + b * b);
      this.current.x = this.current.lineX = 0;
      this.current.y = this.current.lineY = 0;
    },
    nextLine: function CanvasGraphics_nextLine() {
      this.moveText(0, this.current.leading);
    },

    paintChar(character, x, y, patternTransform) {
      var ctx = this.ctx;
      var current = this.current;
      var font = current.font;
      var textRenderingMode = current.textRenderingMode;
      var fontSize = current.fontSize / current.fontSizeScale;
      var fillStrokeMode = textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;
      var isAddToPathSet = !!(textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG);
      const patternFill = current.patternFill && !font.missingFile;
      var addToPath;

      if (font.disableFontFace || isAddToPathSet || patternFill) {
        addToPath = font.getPathGenerator(this.commonObjs, character);
      }

      if (font.disableFontFace || patternFill) {
        ctx.save();
        ctx.translate(x, y);
        ctx.beginPath();
        addToPath(ctx, fontSize);

        if (patternTransform) {
          ctx.setTransform.apply(ctx, patternTransform);
        }

        if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.fill();
        }

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.stroke();
        }

        ctx.restore();
      } else {
        if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.fillText(character, x, y);
        }

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.strokeText(character, x, y);
        }
      }

      if (isAddToPathSet) {
        var paths = this.pendingTextPaths || (this.pendingTextPaths = []);
        paths.push({
          transform: ctx.mozCurrentTransform,
          x,
          y,
          fontSize,
          addToPath
        });
      }
    },

    get isFontSubpixelAAEnabled() {
      const {
        context: ctx
      } = this.cachedCanvases.getCanvas("isFontSubpixelAAEnabled", 10, 10);
      ctx.scale(1.5, 1);
      ctx.fillText("I", 0, 10);
      var data = ctx.getImageData(0, 0, 10, 10).data;
      var enabled = false;

      for (var i = 3; i < data.length; i += 4) {
        if (data[i] > 0 && data[i] < 255) {
          enabled = true;
          break;
        }
      }

      return (0, _util.shadow)(this, "isFontSubpixelAAEnabled", enabled);
    },

    showText: function CanvasGraphics_showText(glyphs) {
      var current = this.current;
      var font = current.font;

      if (font.isType3Font) {
        return this.showType3Text(glyphs);
      }

      var fontSize = current.fontSize;

      if (fontSize === 0) {
        return undefined;
      }

      var ctx = this.ctx;
      var fontSizeScale = current.fontSizeScale;
      var charSpacing = current.charSpacing;
      var wordSpacing = current.wordSpacing;
      var fontDirection = current.fontDirection;
      var textHScale = current.textHScale * fontDirection;
      var glyphsLength = glyphs.length;
      var vertical = font.vertical;
      var spacingDir = vertical ? 1 : -1;
      var defaultVMetrics = font.defaultVMetrics;
      var widthAdvanceScale = fontSize * current.fontMatrix[0];
      var simpleFillText = current.textRenderingMode === _util.TextRenderingMode.FILL && !font.disableFontFace && !current.patternFill;
      ctx.save();
      let patternTransform;

      if (current.patternFill) {
        ctx.save();
        const pattern = current.fillColor.getPattern(ctx, this);
        patternTransform = ctx.mozCurrentTransform;
        ctx.restore();
        ctx.fillStyle = pattern;
      }

      ctx.transform.apply(ctx, current.textMatrix);
      ctx.translate(current.x, current.y + current.textRise);

      if (fontDirection > 0) {
        ctx.scale(textHScale, -1);
      } else {
        ctx.scale(textHScale, 1);
      }

      var lineWidth = current.lineWidth;
      var scale = current.textMatrixScale;

      if (scale === 0 || lineWidth === 0) {
        var fillStrokeMode = current.textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          this._cachedGetSinglePixelWidth = null;
          lineWidth = this.getSinglePixelWidth() * MIN_WIDTH_FACTOR;
        }
      } else {
        lineWidth /= scale;
      }

      if (fontSizeScale !== 1.0) {
        ctx.scale(fontSizeScale, fontSizeScale);
        lineWidth /= fontSizeScale;
      }

      ctx.lineWidth = lineWidth;
      var x = 0,
          i;

      for (i = 0; i < glyphsLength; ++i) {
        var glyph = glyphs[i];

        if ((0, _util.isNum)(glyph)) {
          x += spacingDir * glyph * fontSize / 1000;
          continue;
        }

        var restoreNeeded = false;
        var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
        var character = glyph.fontChar;
        var accent = glyph.accent;
        var scaledX, scaledY, scaledAccentX, scaledAccentY;
        var width = glyph.width;

        if (vertical) {
          var vmetric, vx, vy;
          vmetric = glyph.vmetric || defaultVMetrics;
          vx = glyph.vmetric ? vmetric[1] : width * 0.5;
          vx = -vx * widthAdvanceScale;
          vy = vmetric[2] * widthAdvanceScale;
          width = vmetric ? -vmetric[0] : width;
          scaledX = vx / fontSizeScale;
          scaledY = (x + vy) / fontSizeScale;
        } else {
          scaledX = x / fontSizeScale;
          scaledY = 0;
        }

        if (font.remeasure && width > 0) {
          var measuredWidth = ctx.measureText(character).width * 1000 / fontSize * fontSizeScale;

          if (width < measuredWidth && this.isFontSubpixelAAEnabled) {
            var characterScaleX = width / measuredWidth;
            restoreNeeded = true;
            ctx.save();
            ctx.scale(characterScaleX, 1);
            scaledX /= characterScaleX;
          } else if (width !== measuredWidth) {
            scaledX += (width - measuredWidth) / 2000 * fontSize / fontSizeScale;
          }
        }

        if (glyph.isInFont || font.missingFile) {
          if (simpleFillText && !accent) {
            ctx.fillText(character, scaledX, scaledY);
          } else {
            this.paintChar(character, scaledX, scaledY, patternTransform);

            if (accent) {
              scaledAccentX = scaledX + accent.offset.x / fontSizeScale;
              scaledAccentY = scaledY - accent.offset.y / fontSizeScale;
              this.paintChar(accent.fontChar, scaledAccentX, scaledAccentY, patternTransform);
            }
          }
        }

        var charWidth;

        if (vertical) {
          charWidth = width * widthAdvanceScale - spacing * fontDirection;
        } else {
          charWidth = width * widthAdvanceScale + spacing * fontDirection;
        }

        x += charWidth;

        if (restoreNeeded) {
          ctx.restore();
        }
      }

      if (vertical) {
        current.y -= x;
      } else {
        current.x += x * textHScale;
      }

      ctx.restore();
    },
    showType3Text: function CanvasGraphics_showType3Text(glyphs) {
      var ctx = this.ctx;
      var current = this.current;
      var font = current.font;
      var fontSize = current.fontSize;
      var fontDirection = current.fontDirection;
      var spacingDir = font.vertical ? 1 : -1;
      var charSpacing = current.charSpacing;
      var wordSpacing = current.wordSpacing;
      var textHScale = current.textHScale * fontDirection;
      var fontMatrix = current.fontMatrix || _util.FONT_IDENTITY_MATRIX;
      var glyphsLength = glyphs.length;
      var isTextInvisible = current.textRenderingMode === _util.TextRenderingMode.INVISIBLE;
      var i, glyph, width, spacingLength;

      if (isTextInvisible || fontSize === 0) {
        return;
      }

      this._cachedGetSinglePixelWidth = null;
      ctx.save();
      ctx.transform.apply(ctx, current.textMatrix);
      ctx.translate(current.x, current.y);
      ctx.scale(textHScale, fontDirection);

      for (i = 0; i < glyphsLength; ++i) {
        glyph = glyphs[i];

        if ((0, _util.isNum)(glyph)) {
          spacingLength = spacingDir * glyph * fontSize / 1000;
          this.ctx.translate(spacingLength, 0);
          current.x += spacingLength * textHScale;
          continue;
        }

        var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
        var operatorList = font.charProcOperatorList[glyph.operatorListId];

        if (!operatorList) {
          (0, _util.warn)(`Type3 character "${glyph.operatorListId}" is not available.`);
          continue;
        }

        this.processingType3 = glyph;
        this.save();
        ctx.scale(fontSize, fontSize);
        ctx.transform.apply(ctx, fontMatrix);
        this.executeOperatorList(operatorList);
        this.restore();

        var transformed = _util.Util.applyTransform([glyph.width, 0], fontMatrix);

        width = transformed[0] * fontSize + spacing;
        ctx.translate(width, 0);
        current.x += width * textHScale;
      }

      ctx.restore();
      this.processingType3 = null;
    },
    setCharWidth: function CanvasGraphics_setCharWidth(xWidth, yWidth) {},
    setCharWidthAndBounds: function CanvasGraphics_setCharWidthAndBounds(xWidth, yWidth, llx, lly, urx, ury) {
      this.ctx.rect(llx, lly, urx - llx, ury - lly);
      this.clip();
      this.endPath();
    },
    getColorN_Pattern: function CanvasGraphics_getColorN_Pattern(IR) {
      var pattern;

      if (IR[0] === "TilingPattern") {
        var color = IR[1];
        var baseTransform = this.baseTransform || this.ctx.mozCurrentTransform.slice();
        var canvasGraphicsFactory = {
          createCanvasGraphics: ctx => {
            return new CanvasGraphics(ctx, this.commonObjs, this.objs, this.canvasFactory, this.webGLContext);
          }
        };
        pattern = new _pattern_helper.TilingPattern(IR, color, this.ctx, canvasGraphicsFactory, baseTransform);
      } else {
        pattern = (0, _pattern_helper.getShadingPatternFromIR)(IR);
      }

      return pattern;
    },
    setStrokeColorN: function CanvasGraphics_setStrokeColorN() {
      this.current.strokeColor = this.getColorN_Pattern(arguments);
    },
    setFillColorN: function CanvasGraphics_setFillColorN() {
      this.current.fillColor = this.getColorN_Pattern(arguments);
      this.current.patternFill = true;
    },
    setStrokeRGBColor: function CanvasGraphics_setStrokeRGBColor(r, g, b) {
      var color = _util.Util.makeCssRgb(r, g, b);

      this.ctx.strokeStyle = color;
      this.current.strokeColor = color;
    },
    setFillRGBColor: function CanvasGraphics_setFillRGBColor(r, g, b) {
      var color = _util.Util.makeCssRgb(r, g, b);

      this.ctx.fillStyle = color;
      this.current.fillColor = color;
      this.current.patternFill = false;
    },
    shadingFill: function CanvasGraphics_shadingFill(patternIR) {
      var ctx = this.ctx;
      this.save();
      var pattern = (0, _pattern_helper.getShadingPatternFromIR)(patternIR);
      ctx.fillStyle = pattern.getPattern(ctx, this, true);
      var inv = ctx.mozCurrentTransformInverse;

      if (inv) {
        var canvas = ctx.canvas;
        var width = canvas.width;
        var height = canvas.height;

        var bl = _util.Util.applyTransform([0, 0], inv);

        var br = _util.Util.applyTransform([0, height], inv);

        var ul = _util.Util.applyTransform([width, 0], inv);

        var ur = _util.Util.applyTransform([width, height], inv);

        var x0 = Math.min(bl[0], br[0], ul[0], ur[0]);
        var y0 = Math.min(bl[1], br[1], ul[1], ur[1]);
        var x1 = Math.max(bl[0], br[0], ul[0], ur[0]);
        var y1 = Math.max(bl[1], br[1], ul[1], ur[1]);
        this.ctx.fillRect(x0, y0, x1 - x0, y1 - y0);
      } else {
        this.ctx.fillRect(-1e10, -1e10, 2e10, 2e10);
      }

      this.restore();
    },
    beginInlineImage: function CanvasGraphics_beginInlineImage() {
      (0, _util.unreachable)("Should not call beginInlineImage");
    },
    beginImageData: function CanvasGraphics_beginImageData() {
      (0, _util.unreachable)("Should not call beginImageData");
    },
    paintFormXObjectBegin: function CanvasGraphics_paintFormXObjectBegin(matrix, bbox) {
      this.save();
      this.baseTransformStack.push(this.baseTransform);

      if (Array.isArray(matrix) && matrix.length === 6) {
        this.transform.apply(this, matrix);
      }

      this.baseTransform = this.ctx.mozCurrentTransform;

      if (bbox) {
        var width = bbox[2] - bbox[0];
        var height = bbox[3] - bbox[1];
        this.ctx.rect(bbox[0], bbox[1], width, height);
        this.clip();
        this.endPath();
      }
    },
    paintFormXObjectEnd: function CanvasGraphics_paintFormXObjectEnd() {
      this.restore();
      this.baseTransform = this.baseTransformStack.pop();
    },
    beginGroup: function CanvasGraphics_beginGroup(group) {
      this.save();
      var currentCtx = this.ctx;

      if (!group.isolated) {
        (0, _util.info)("TODO: Support non-isolated groups.");
      }

      if (group.knockout) {
        (0, _util.warn)("Knockout groups not supported.");
      }

      var currentTransform = currentCtx.mozCurrentTransform;

      if (group.matrix) {
        currentCtx.transform.apply(currentCtx, group.matrix);
      }

      if (!group.bbox) {
        throw new Error("Bounding box is required.");
      }

      var bounds = _util.Util.getAxialAlignedBoundingBox(group.bbox, currentCtx.mozCurrentTransform);

      var canvasBounds = [0, 0, currentCtx.canvas.width, currentCtx.canvas.height];
      bounds = _util.Util.intersect(bounds, canvasBounds) || [0, 0, 0, 0];
      var offsetX = Math.floor(bounds[0]);
      var offsetY = Math.floor(bounds[1]);
      var drawnWidth = Math.max(Math.ceil(bounds[2]) - offsetX, 1);
      var drawnHeight = Math.max(Math.ceil(bounds[3]) - offsetY, 1);
      var scaleX = 1,
          scaleY = 1;

      if (drawnWidth > MAX_GROUP_SIZE) {
        scaleX = drawnWidth / MAX_GROUP_SIZE;
        drawnWidth = MAX_GROUP_SIZE;
      }

      if (drawnHeight > MAX_GROUP_SIZE) {
        scaleY = drawnHeight / MAX_GROUP_SIZE;
        drawnHeight = MAX_GROUP_SIZE;
      }

      var cacheId = "groupAt" + this.groupLevel;

      if (group.smask) {
        cacheId += "_smask_" + this.smaskCounter++ % 2;
      }

      var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight, true);
      var groupCtx = scratchCanvas.context;
      groupCtx.scale(1 / scaleX, 1 / scaleY);
      groupCtx.translate(-offsetX, -offsetY);
      groupCtx.transform.apply(groupCtx, currentTransform);

      if (group.smask) {
        this.smaskStack.push({
          canvas: scratchCanvas.canvas,
          context: groupCtx,
          offsetX,
          offsetY,
          scaleX,
          scaleY,
          subtype: group.smask.subtype,
          backdrop: group.smask.backdrop,
          transferMap: group.smask.transferMap || null,
          startTransformInverse: null
        });
      } else {
        currentCtx.setTransform(1, 0, 0, 1, 0, 0);
        currentCtx.translate(offsetX, offsetY);
        currentCtx.scale(scaleX, scaleY);
      }

      copyCtxState(currentCtx, groupCtx);
      this.ctx = groupCtx;
      this.setGState([["BM", "source-over"], ["ca", 1], ["CA", 1]]);
      this.groupStack.push(currentCtx);
      this.groupLevel++;
      this.current.activeSMask = null;
    },
    endGroup: function CanvasGraphics_endGroup(group) {
      this.groupLevel--;
      var groupCtx = this.ctx;
      this.ctx = this.groupStack.pop();

      if (this.ctx.imageSmoothingEnabled !== undefined) {
        this.ctx.imageSmoothingEnabled = false;
      } else {
        this.ctx.mozImageSmoothingEnabled = false;
      }

      if (group.smask) {
        this.tempSMask = this.smaskStack.pop();
      } else {
        this.ctx.drawImage(groupCtx.canvas, 0, 0);
      }

      this.restore();
    },
    beginAnnotations: function CanvasGraphics_beginAnnotations() {
      this.save();

      if (this.baseTransform) {
        this.ctx.setTransform.apply(this.ctx, this.baseTransform);
      }
    },
    endAnnotations: function CanvasGraphics_endAnnotations() {
      this.restore();
    },
    beginAnnotation: function CanvasGraphics_beginAnnotation(rect, transform, matrix) {
      this.save();
      resetCtxToDefault(this.ctx);
      this.current = new CanvasExtraState();

      if (Array.isArray(rect) && rect.length === 4) {
        var width = rect[2] - rect[0];
        var height = rect[3] - rect[1];
        this.ctx.rect(rect[0], rect[1], width, height);
        this.clip();
        this.endPath();
      }

      this.transform.apply(this, transform);
      this.transform.apply(this, matrix);
    },
    endAnnotation: function CanvasGraphics_endAnnotation() {
      this.restore();
    },
    paintImageMaskXObject: function CanvasGraphics_paintImageMaskXObject(img) {
      var ctx = this.ctx;
      var width = img.width,
          height = img.height;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var glyph = this.processingType3;

      if ( glyph && glyph.compiled === undefined) {
        if (width <= MAX_SIZE_TO_COMPILE && height <= MAX_SIZE_TO_COMPILE) {
          glyph.compiled = compileType3Glyph({
            data: img.data,
            width,
            height
          });
        } else {
          glyph.compiled = null;
        }
      }

      if (glyph && glyph.compiled) {
        glyph.compiled(ctx);
        return;
      }

      var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
      var maskCtx = maskCanvas.context;
      maskCtx.save();
      putBinaryImageMask(maskCtx, img);
      maskCtx.globalCompositeOperation = "source-in";
      maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
      maskCtx.fillRect(0, 0, width, height);
      maskCtx.restore();
      this.paintInlineImageXObject(maskCanvas.canvas);
    },
    paintImageMaskXObjectRepeat: function CanvasGraphics_paintImageMaskXObjectRepeat(imgData, scaleX, scaleY, positions) {
      var width = imgData.width;
      var height = imgData.height;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
      var maskCtx = maskCanvas.context;
      maskCtx.save();
      putBinaryImageMask(maskCtx, imgData);
      maskCtx.globalCompositeOperation = "source-in";
      maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
      maskCtx.fillRect(0, 0, width, height);
      maskCtx.restore();
      var ctx = this.ctx;

      for (var i = 0, ii = positions.length; i < ii; i += 2) {
        ctx.save();
        ctx.transform(scaleX, 0, 0, scaleY, positions[i], positions[i + 1]);
        ctx.scale(1, -1);
        ctx.drawImage(maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
        ctx.restore();
      }
    },
    paintImageMaskXObjectGroup: function CanvasGraphics_paintImageMaskXObjectGroup(images) {
      var ctx = this.ctx;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;

      for (var i = 0, ii = images.length; i < ii; i++) {
        var image = images[i];
        var width = image.width,
            height = image.height;
        var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
        var maskCtx = maskCanvas.context;
        maskCtx.save();
        putBinaryImageMask(maskCtx, image);
        maskCtx.globalCompositeOperation = "source-in";
        maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
        maskCtx.fillRect(0, 0, width, height);
        maskCtx.restore();
        ctx.save();
        ctx.transform.apply(ctx, image.transform);
        ctx.scale(1, -1);
        ctx.drawImage(maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
        ctx.restore();
      }
    },
    paintImageXObject: function CanvasGraphics_paintImageXObject(objId) {
      const imgData = objId.startsWith("g_") ? this.commonObjs.get(objId) : this.objs.get(objId);

      if (!imgData) {
        (0, _util.warn)("Dependent image isn't ready yet");
        return;
      }

      this.paintInlineImageXObject(imgData);
    },
    paintImageXObjectRepeat: function CanvasGraphics_paintImageXObjectRepeat(objId, scaleX, scaleY, positions) {
      const imgData = objId.startsWith("g_") ? this.commonObjs.get(objId) : this.objs.get(objId);

      if (!imgData) {
        (0, _util.warn)("Dependent image isn't ready yet");
        return;
      }

      var width = imgData.width;
      var height = imgData.height;
      var map = [];

      for (var i = 0, ii = positions.length; i < ii; i += 2) {
        map.push({
          transform: [scaleX, 0, 0, scaleY, positions[i], positions[i + 1]],
          x: 0,
          y: 0,
          w: width,
          h: height
        });
      }

      this.paintInlineImageXObjectGroup(imgData, map);
    },
    paintInlineImageXObject: function CanvasGraphics_paintInlineImageXObject(imgData) {
      var width = imgData.width;
      var height = imgData.height;
      var ctx = this.ctx;
      this.save();
      ctx.scale(1 / width, -1 / height);
      var currentTransform = ctx.mozCurrentTransformInverse;
      var a = currentTransform[0],
          b = currentTransform[1];
      var widthScale = Math.max(Math.sqrt(a * a + b * b), 1);
      var c = currentTransform[2],
          d = currentTransform[3];
      var heightScale = Math.max(Math.sqrt(c * c + d * d), 1);
      var imgToPaint, tmpCanvas;

      if (typeof HTMLElement === "function" && imgData instanceof HTMLElement || !imgData.data) {
        imgToPaint = imgData;
      } else {
        tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", width, height);
        var tmpCtx = tmpCanvas.context;
        putBinaryImageData(tmpCtx, imgData);
        imgToPaint = tmpCanvas.canvas;
      }

      var paintWidth = width,
          paintHeight = height;
      var tmpCanvasId = "prescale1";

      while (widthScale > 2 && paintWidth > 1 || heightScale > 2 && paintHeight > 1) {
        var newWidth = paintWidth,
            newHeight = paintHeight;

        if (widthScale > 2 && paintWidth > 1) {
          newWidth = Math.ceil(paintWidth / 2);
          widthScale /= paintWidth / newWidth;
        }

        if (heightScale > 2 && paintHeight > 1) {
          newHeight = Math.ceil(paintHeight / 2);
          heightScale /= paintHeight / newHeight;
        }

        tmpCanvas = this.cachedCanvases.getCanvas(tmpCanvasId, newWidth, newHeight);
        tmpCtx = tmpCanvas.context;
        tmpCtx.clearRect(0, 0, newWidth, newHeight);
        tmpCtx.drawImage(imgToPaint, 0, 0, paintWidth, paintHeight, 0, 0, newWidth, newHeight);
        imgToPaint = tmpCanvas.canvas;
        paintWidth = newWidth;
        paintHeight = newHeight;
        tmpCanvasId = tmpCanvasId === "prescale1" ? "prescale2" : "prescale1";
      }

      ctx.drawImage(imgToPaint, 0, 0, paintWidth, paintHeight, 0, -height, width, height);

      if (this.imageLayer) {
        var position = this.getCanvasPosition(0, -height);
        this.imageLayer.appendImage({
          imgData,
          left: position[0],
          top: position[1],
          width: width / currentTransform[0],
          height: height / currentTransform[3]
        });
      }

      this.restore();
    },
    paintInlineImageXObjectGroup: function CanvasGraphics_paintInlineImageXObjectGroup(imgData, map) {
      var ctx = this.ctx;
      var w = imgData.width;
      var h = imgData.height;
      var tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", w, h);
      var tmpCtx = tmpCanvas.context;
      putBinaryImageData(tmpCtx, imgData);

      for (var i = 0, ii = map.length; i < ii; i++) {
        var entry = map[i];
        ctx.save();
        ctx.transform.apply(ctx, entry.transform);
        ctx.scale(1, -1);
        ctx.drawImage(tmpCanvas.canvas, entry.x, entry.y, entry.w, entry.h, 0, -1, 1, 1);

        if (this.imageLayer) {
          var position = this.getCanvasPosition(entry.x, entry.y);
          this.imageLayer.appendImage({
            imgData,
            left: position[0],
            top: position[1],
            width: w,
            height: h
          });
        }

        ctx.restore();
      }
    },
    paintSolidColorImageMask: function CanvasGraphics_paintSolidColorImageMask() {
      this.ctx.fillRect(0, 0, 1, 1);
    },
    paintXObject: function CanvasGraphics_paintXObject() {
      (0, _util.warn)("Unsupported 'paintXObject' command.");
    },
    markPoint: function CanvasGraphics_markPoint(tag) {},
    markPointProps: function CanvasGraphics_markPointProps(tag, properties) {},
    beginMarkedContent: function CanvasGraphics_beginMarkedContent(tag) {},
    beginMarkedContentProps: function CanvasGraphics_beginMarkedContentProps(tag, properties) {},
    endMarkedContent: function CanvasGraphics_endMarkedContent() {},
    beginCompat: function CanvasGraphics_beginCompat() {},
    endCompat: function CanvasGraphics_endCompat() {},
    consumePath: function CanvasGraphics_consumePath() {
      var ctx = this.ctx;

      if (this.pendingClip) {
        if (this.pendingClip === EO_CLIP) {
          ctx.clip("evenodd");
        } else {
          ctx.clip();
        }

        this.pendingClip = null;
      }

      ctx.beginPath();
    },

    getSinglePixelWidth(scale) {
      if (this._cachedGetSinglePixelWidth === null) {
        const inverse = this.ctx.mozCurrentTransformInverse;
        this._cachedGetSinglePixelWidth = Math.sqrt(Math.max(inverse[0] * inverse[0] + inverse[1] * inverse[1], inverse[2] * inverse[2] + inverse[3] * inverse[3]));
      }

      return this._cachedGetSinglePixelWidth;
    },

    getCanvasPosition: function CanvasGraphics_getCanvasPosition(x, y) {
      var transform = this.ctx.mozCurrentTransform;
      return [transform[0] * x + transform[2] * y + transform[4], transform[1] * x + transform[3] * y + transform[5]];
    }
  };

  for (var op in _util.OPS) {
    CanvasGraphics.prototype[_util.OPS[op]] = CanvasGraphics.prototype[op];
  }

  return CanvasGraphics;
}();

exports.CanvasGraphics = CanvasGraphics;

/***/ }),
/* 9 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getShadingPatternFromIR = getShadingPatternFromIR;
exports.TilingPattern = void 0;

var _util = __w_pdfjs_require__(2);

var ShadingIRs = {};

function applyBoundingBox(ctx, bbox) {
  if (!bbox || typeof Path2D === "undefined") {
    return;
  }

  const width = bbox[2] - bbox[0];
  const height = bbox[3] - bbox[1];
  const region = new Path2D();
  region.rect(bbox[0], bbox[1], width, height);
  ctx.clip(region);
}

ShadingIRs.RadialAxial = {
  fromIR: function RadialAxial_fromIR(raw) {
    var type = raw[1];
    var bbox = raw[2];
    var colorStops = raw[3];
    var p0 = raw[4];
    var p1 = raw[5];
    var r0 = raw[6];
    var r1 = raw[7];
    return {
      type: "Pattern",
      getPattern: function RadialAxial_getPattern(ctx) {
        applyBoundingBox(ctx, bbox);
        var grad;

        if (type === "axial") {
          grad = ctx.createLinearGradient(p0[0], p0[1], p1[0], p1[1]);
        } else if (type === "radial") {
          grad = ctx.createRadialGradient(p0[0], p0[1], r0, p1[0], p1[1], r1);
        }

        for (var i = 0, ii = colorStops.length; i < ii; ++i) {
          var c = colorStops[i];
          grad.addColorStop(c[0], c[1]);
        }

        return grad;
      }
    };
  }
};

var createMeshCanvas = function createMeshCanvasClosure() {
  function drawTriangle(data, context, p1, p2, p3, c1, c2, c3) {
    var coords = context.coords,
        colors = context.colors;
    var bytes = data.data,
        rowSize = data.width * 4;
    var tmp;

    if (coords[p1 + 1] > coords[p2 + 1]) {
      tmp = p1;
      p1 = p2;
      p2 = tmp;
      tmp = c1;
      c1 = c2;
      c2 = tmp;
    }

    if (coords[p2 + 1] > coords[p3 + 1]) {
      tmp = p2;
      p2 = p3;
      p3 = tmp;
      tmp = c2;
      c2 = c3;
      c3 = tmp;
    }

    if (coords[p1 + 1] > coords[p2 + 1]) {
      tmp = p1;
      p1 = p2;
      p2 = tmp;
      tmp = c1;
      c1 = c2;
      c2 = tmp;
    }

    var x1 = (coords[p1] + context.offsetX) * context.scaleX;
    var y1 = (coords[p1 + 1] + context.offsetY) * context.scaleY;
    var x2 = (coords[p2] + context.offsetX) * context.scaleX;
    var y2 = (coords[p2 + 1] + context.offsetY) * context.scaleY;
    var x3 = (coords[p3] + context.offsetX) * context.scaleX;
    var y3 = (coords[p3 + 1] + context.offsetY) * context.scaleY;

    if (y1 >= y3) {
      return;
    }

    var c1r = colors[c1],
        c1g = colors[c1 + 1],
        c1b = colors[c1 + 2];
    var c2r = colors[c2],
        c2g = colors[c2 + 1],
        c2b = colors[c2 + 2];
    var c3r = colors[c3],
        c3g = colors[c3 + 1],
        c3b = colors[c3 + 2];
    var minY = Math.round(y1),
        maxY = Math.round(y3);
    var xa, car, cag, cab;
    var xb, cbr, cbg, cbb;

    for (var y = minY; y <= maxY; y++) {
      if (y < y2) {
        let k;

        if (y < y1) {
          k = 0;
        } else if (y1 === y2) {
          k = 1;
        } else {
          k = (y1 - y) / (y1 - y2);
        }

        xa = x1 - (x1 - x2) * k;
        car = c1r - (c1r - c2r) * k;
        cag = c1g - (c1g - c2g) * k;
        cab = c1b - (c1b - c2b) * k;
      } else {
        let k;

        if (y > y3) {
          k = 1;
        } else if (y2 === y3) {
          k = 0;
        } else {
          k = (y2 - y) / (y2 - y3);
        }

        xa = x2 - (x2 - x3) * k;
        car = c2r - (c2r - c3r) * k;
        cag = c2g - (c2g - c3g) * k;
        cab = c2b - (c2b - c3b) * k;
      }

      let k;

      if (y < y1) {
        k = 0;
      } else if (y > y3) {
        k = 1;
      } else {
        k = (y1 - y) / (y1 - y3);
      }

      xb = x1 - (x1 - x3) * k;
      cbr = c1r - (c1r - c3r) * k;
      cbg = c1g - (c1g - c3g) * k;
      cbb = c1b - (c1b - c3b) * k;
      var x1_ = Math.round(Math.min(xa, xb));
      var x2_ = Math.round(Math.max(xa, xb));
      var j = rowSize * y + x1_ * 4;

      for (var x = x1_; x <= x2_; x++) {
        k = (xa - x) / (xa - xb);

        if (k < 0) {
          k = 0;
        } else if (k > 1) {
          k = 1;
        }

        bytes[j++] = car - (car - cbr) * k | 0;
        bytes[j++] = cag - (cag - cbg) * k | 0;
        bytes[j++] = cab - (cab - cbb) * k | 0;
        bytes[j++] = 255;
      }
    }
  }

  function drawFigure(data, figure, context) {
    var ps = figure.coords;
    var cs = figure.colors;
    var i, ii;

    switch (figure.type) {
      case "lattice":
        var verticesPerRow = figure.verticesPerRow;
        var rows = Math.floor(ps.length / verticesPerRow) - 1;
        var cols = verticesPerRow - 1;

        for (i = 0; i < rows; i++) {
          var q = i * verticesPerRow;

          for (var j = 0; j < cols; j++, q++) {
            drawTriangle(data, context, ps[q], ps[q + 1], ps[q + verticesPerRow], cs[q], cs[q + 1], cs[q + verticesPerRow]);
            drawTriangle(data, context, ps[q + verticesPerRow + 1], ps[q + 1], ps[q + verticesPerRow], cs[q + verticesPerRow + 1], cs[q + 1], cs[q + verticesPerRow]);
          }
        }

        break;

      case "triangles":
        for (i = 0, ii = ps.length; i < ii; i += 3) {
          drawTriangle(data, context, ps[i], ps[i + 1], ps[i + 2], cs[i], cs[i + 1], cs[i + 2]);
        }

        break;

      default:
        throw new Error("illegal figure");
    }
  }

  function createMeshCanvas(bounds, combinesScale, coords, colors, figures, backgroundColor, cachedCanvases, webGLContext) {
    var EXPECTED_SCALE = 1.1;
    var MAX_PATTERN_SIZE = 3000;
    var BORDER_SIZE = 2;
    var offsetX = Math.floor(bounds[0]);
    var offsetY = Math.floor(bounds[1]);
    var boundsWidth = Math.ceil(bounds[2]) - offsetX;
    var boundsHeight = Math.ceil(bounds[3]) - offsetY;
    var width = Math.min(Math.ceil(Math.abs(boundsWidth * combinesScale[0] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
    var height = Math.min(Math.ceil(Math.abs(boundsHeight * combinesScale[1] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
    var scaleX = boundsWidth / width;
    var scaleY = boundsHeight / height;
    var context = {
      coords,
      colors,
      offsetX: -offsetX,
      offsetY: -offsetY,
      scaleX: 1 / scaleX,
      scaleY: 1 / scaleY
    };
    var paddedWidth = width + BORDER_SIZE * 2;
    var paddedHeight = height + BORDER_SIZE * 2;
    var canvas, tmpCanvas, i, ii;

    if (webGLContext.isEnabled) {
      canvas = webGLContext.drawFigures({
        width,
        height,
        backgroundColor,
        figures,
        context
      });
      tmpCanvas = cachedCanvases.getCanvas("mesh", paddedWidth, paddedHeight, false);
      tmpCanvas.context.drawImage(canvas, BORDER_SIZE, BORDER_SIZE);
      canvas = tmpCanvas.canvas;
    } else {
      tmpCanvas = cachedCanvases.getCanvas("mesh", paddedWidth, paddedHeight, false);
      var tmpCtx = tmpCanvas.context;
      var data = tmpCtx.createImageData(width, height);

      if (backgroundColor) {
        var bytes = data.data;

        for (i = 0, ii = bytes.length; i < ii; i += 4) {
          bytes[i] = backgroundColor[0];
          bytes[i + 1] = backgroundColor[1];
          bytes[i + 2] = backgroundColor[2];
          bytes[i + 3] = 255;
        }
      }

      for (i = 0; i < figures.length; i++) {
        drawFigure(data, figures[i], context);
      }

      tmpCtx.putImageData(data, BORDER_SIZE, BORDER_SIZE);
      canvas = tmpCanvas.canvas;
    }

    return {
      canvas,
      offsetX: offsetX - BORDER_SIZE * scaleX,
      offsetY: offsetY - BORDER_SIZE * scaleY,
      scaleX,
      scaleY
    };
  }

  return createMeshCanvas;
}();

ShadingIRs.Mesh = {
  fromIR: function Mesh_fromIR(raw) {
    var coords = raw[2];
    var colors = raw[3];
    var figures = raw[4];
    var bounds = raw[5];
    var matrix = raw[6];
    var bbox = raw[7];
    var background = raw[8];
    return {
      type: "Pattern",
      getPattern: function Mesh_getPattern(ctx, owner, shadingFill) {
        applyBoundingBox(ctx, bbox);
        var scale;

        if (shadingFill) {
          scale = _util.Util.singularValueDecompose2dScale(ctx.mozCurrentTransform);
        } else {
          scale = _util.Util.singularValueDecompose2dScale(owner.baseTransform);

          if (matrix) {
            var matrixScale = _util.Util.singularValueDecompose2dScale(matrix);

            scale = [scale[0] * matrixScale[0], scale[1] * matrixScale[1]];
          }
        }

        var temporaryPatternCanvas = createMeshCanvas(bounds, scale, coords, colors, figures, shadingFill ? null : background, owner.cachedCanvases, owner.webGLContext);

        if (!shadingFill) {
          ctx.setTransform.apply(ctx, owner.baseTransform);

          if (matrix) {
            ctx.transform.apply(ctx, matrix);
          }
        }

        ctx.translate(temporaryPatternCanvas.offsetX, temporaryPatternCanvas.offsetY);
        ctx.scale(temporaryPatternCanvas.scaleX, temporaryPatternCanvas.scaleY);
        return ctx.createPattern(temporaryPatternCanvas.canvas, "no-repeat");
      }
    };
  }
};
ShadingIRs.Dummy = {
  fromIR: function Dummy_fromIR() {
    return {
      type: "Pattern",
      getPattern: function Dummy_fromIR_getPattern() {
        return "hotpink";
      }
    };
  }
};

function getShadingPatternFromIR(raw) {
  var shadingIR = ShadingIRs[raw[0]];

  if (!shadingIR) {
    throw new Error(`Unknown IR type: ${raw[0]}`);
  }

  return shadingIR.fromIR(raw);
}

var TilingPattern = function TilingPatternClosure() {
  var PaintType = {
    COLORED: 1,
    UNCOLORED: 2
  };
  var MAX_PATTERN_SIZE = 3000;

  function TilingPattern(IR, color, ctx, canvasGraphicsFactory, baseTransform) {
    this.operatorList = IR[2];
    this.matrix = IR[3] || [1, 0, 0, 1, 0, 0];
    this.bbox = IR[4];
    this.xstep = IR[5];
    this.ystep = IR[6];
    this.paintType = IR[7];
    this.tilingType = IR[8];
    this.color = color;
    this.canvasGraphicsFactory = canvasGraphicsFactory;
    this.baseTransform = baseTransform;
    this.type = "Pattern";
    this.ctx = ctx;
  }

  TilingPattern.prototype = {
    createPatternCanvas: function TilinPattern_createPatternCanvas(owner) {
      var operatorList = this.operatorList;
      var bbox = this.bbox;
      var xstep = this.xstep;
      var ystep = this.ystep;
      var paintType = this.paintType;
      var tilingType = this.tilingType;
      var color = this.color;
      var canvasGraphicsFactory = this.canvasGraphicsFactory;
      (0, _util.info)("TilingType: " + tilingType);
      var x0 = bbox[0],
          y0 = bbox[1],
          x1 = bbox[2],
          y1 = bbox[3];

      var matrixScale = _util.Util.singularValueDecompose2dScale(this.matrix);

      var curMatrixScale = _util.Util.singularValueDecompose2dScale(this.baseTransform);

      var combinedScale = [matrixScale[0] * curMatrixScale[0], matrixScale[1] * curMatrixScale[1]];
      var dimx = this.getSizeAndScale(xstep, this.ctx.canvas.width, combinedScale[0]);
      var dimy = this.getSizeAndScale(ystep, this.ctx.canvas.height, combinedScale[1]);
      var tmpCanvas = owner.cachedCanvases.getCanvas("pattern", dimx.size, dimy.size, true);
      var tmpCtx = tmpCanvas.context;
      var graphics = canvasGraphicsFactory.createCanvasGraphics(tmpCtx);
      graphics.groupLevel = owner.groupLevel;
      this.setFillAndStrokeStyleToContext(graphics, paintType, color);
      graphics.transform(dimx.scale, 0, 0, dimy.scale, 0, 0);
      graphics.transform(1, 0, 0, 1, -x0, -y0);
      this.clipBbox(graphics, bbox, x0, y0, x1, y1);
      graphics.executeOperatorList(operatorList);
      this.ctx.transform(1, 0, 0, 1, x0, y0);
      this.ctx.scale(1 / dimx.scale, 1 / dimy.scale);
      return tmpCanvas.canvas;
    },
    getSizeAndScale: function TilingPattern_getSizeAndScale(step, realOutputSize, scale) {
      step = Math.abs(step);
      var maxSize = Math.max(MAX_PATTERN_SIZE, realOutputSize);
      var size = Math.ceil(step * scale);

      if (size >= maxSize) {
        size = maxSize;
      } else {
        scale = size / step;
      }

      return {
        scale,
        size
      };
    },
    clipBbox: function clipBbox(graphics, bbox, x0, y0, x1, y1) {
      if (Array.isArray(bbox) && bbox.length === 4) {
        var bboxWidth = x1 - x0;
        var bboxHeight = y1 - y0;
        graphics.ctx.rect(x0, y0, bboxWidth, bboxHeight);
        graphics.clip();
        graphics.endPath();
      }
    },
    setFillAndStrokeStyleToContext: function setFillAndStrokeStyleToContext(graphics, paintType, color) {
      const context = graphics.ctx,
            current = graphics.current;

      switch (paintType) {
        case PaintType.COLORED:
          var ctx = this.ctx;
          context.fillStyle = ctx.fillStyle;
          context.strokeStyle = ctx.strokeStyle;
          current.fillColor = ctx.fillStyle;
          current.strokeColor = ctx.strokeStyle;
          break;

        case PaintType.UNCOLORED:
          var cssColor = _util.Util.makeCssRgb(color[0], color[1], color[2]);

          context.fillStyle = cssColor;
          context.strokeStyle = cssColor;
          current.fillColor = cssColor;
          current.strokeColor = cssColor;
          break;

        default:
          throw new _util.FormatError(`Unsupported paint type: ${paintType}`);
      }
    },
    getPattern: function TilingPattern_getPattern(ctx, owner) {
      ctx = this.ctx;
      ctx.setTransform.apply(ctx, this.baseTransform);
      ctx.transform.apply(ctx, this.matrix);
      var temporaryPatternCanvas = this.createPatternCanvas(owner);
      return ctx.createPattern(temporaryPatternCanvas, "repeat");
    }
  };
  return TilingPattern;
}();

exports.TilingPattern = TilingPattern;

/***/ }),
/* 10 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GlobalWorkerOptions = void 0;
const GlobalWorkerOptions = Object.create(null);
exports.GlobalWorkerOptions = GlobalWorkerOptions;
GlobalWorkerOptions.workerPort = GlobalWorkerOptions.workerPort === undefined ? null : GlobalWorkerOptions.workerPort;
GlobalWorkerOptions.workerSrc = GlobalWorkerOptions.workerSrc === undefined ? "" : GlobalWorkerOptions.workerSrc;

/***/ }),
/* 11 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageHandler = void 0;

var _util = __w_pdfjs_require__(2);

const CallbackKind = {
  UNKNOWN: 0,
  DATA: 1,
  ERROR: 2
};
const StreamKind = {
  UNKNOWN: 0,
  CANCEL: 1,
  CANCEL_COMPLETE: 2,
  CLOSE: 3,
  ENQUEUE: 4,
  ERROR: 5,
  PULL: 6,
  PULL_COMPLETE: 7,
  START_COMPLETE: 8
};

function wrapReason(reason) {
  if (typeof reason !== "object" || reason === null) {
    return reason;
  }

  switch (reason.name) {
    case "AbortException":
      return new _util.AbortException(reason.message);

    case "MissingPDFException":
      return new _util.MissingPDFException(reason.message);

    case "UnexpectedResponseException":
      return new _util.UnexpectedResponseException(reason.message, reason.status);

    case "UnknownErrorException":
      return new _util.UnknownErrorException(reason.message, reason.details);

    default:
      return new _util.UnknownErrorException(reason.message, reason.toString());
  }
}

class MessageHandler {
  constructor(sourceName, targetName, comObj) {
    this.sourceName = sourceName;
    this.targetName = targetName;
    this.comObj = comObj;
    this.callbackId = 1;
    this.streamId = 1;
    this.postMessageTransfers = true;
    this.streamSinks = Object.create(null);
    this.streamControllers = Object.create(null);
    this.callbackCapabilities = Object.create(null);
    this.actionHandler = Object.create(null);

    this._onComObjOnMessage = event => {
      const data = event.data;

      if (data.targetName !== this.sourceName) {
        return;
      }

      if (data.stream) {
        this._processStreamMessage(data);

        return;
      }

      if (data.callback) {
        const callbackId = data.callbackId;
        const capability = this.callbackCapabilities[callbackId];

        if (!capability) {
          throw new Error(`Cannot resolve callback ${callbackId}`);
        }

        delete this.callbackCapabilities[callbackId];

        if (data.callback === CallbackKind.DATA) {
          capability.resolve(data.data);
        } else if (data.callback === CallbackKind.ERROR) {
          capability.reject(wrapReason(data.reason));
        } else {
          throw new Error("Unexpected callback case");
        }

        return;
      }

      const action = this.actionHandler[data.action];

      if (!action) {
        throw new Error(`Unknown action from worker: ${data.action}`);
      }

      if (data.callbackId) {
        const cbSourceName = this.sourceName;
        const cbTargetName = data.sourceName;
        new Promise(function (resolve) {
          resolve(action(data.data));
        }).then(function (result) {
          comObj.postMessage({
            sourceName: cbSourceName,
            targetName: cbTargetName,
            callback: CallbackKind.DATA,
            callbackId: data.callbackId,
            data: result
          });
        }, function (reason) {
          comObj.postMessage({
            sourceName: cbSourceName,
            targetName: cbTargetName,
            callback: CallbackKind.ERROR,
            callbackId: data.callbackId,
            reason: wrapReason(reason)
          });
        });
        return;
      }

      if (data.streamId) {
        this._createStreamSink(data);

        return;
      }

      action(data.data);
    };

    comObj.addEventListener("message", this._onComObjOnMessage);
  }

  on(actionName, handler) {
    const ah = this.actionHandler;

    if (ah[actionName]) {
      throw new Error(`There is already an actionName called "${actionName}"`);
    }

    ah[actionName] = handler;
  }

  send(actionName, data, transfers) {
    this._postMessage({
      sourceName: this.sourceName,
      targetName: this.targetName,
      action: actionName,
      data
    }, transfers);
  }

  sendWithPromise(actionName, data, transfers) {
    const callbackId = this.callbackId++;
    const capability = (0, _util.createPromiseCapability)();
    this.callbackCapabilities[callbackId] = capability;

    try {
      this._postMessage({
        sourceName: this.sourceName,
        targetName: this.targetName,
        action: actionName,
        callbackId,
        data
      }, transfers);
    } catch (ex) {
      capability.reject(ex);
    }

    return capability.promise;
  }

  sendWithStream(actionName, data, queueingStrategy, transfers) {
    const streamId = this.streamId++;
    const sourceName = this.sourceName;
    const targetName = this.targetName;
    const comObj = this.comObj;
    return new ReadableStream({
      start: controller => {
        const startCapability = (0, _util.createPromiseCapability)();
        this.streamControllers[streamId] = {
          controller,
          startCall: startCapability,
          pullCall: null,
          cancelCall: null,
          isClosed: false
        };

        this._postMessage({
          sourceName,
          targetName,
          action: actionName,
          streamId,
          data,
          desiredSize: controller.desiredSize
        }, transfers);

        return startCapability.promise;
      },
      pull: controller => {
        const pullCapability = (0, _util.createPromiseCapability)();
        this.streamControllers[streamId].pullCall = pullCapability;
        comObj.postMessage({
          sourceName,
          targetName,
          stream: StreamKind.PULL,
          streamId,
          desiredSize: controller.desiredSize
        });
        return pullCapability.promise;
      },
      cancel: reason => {
        (0, _util.assert)(reason instanceof Error, "cancel must have a valid reason");
        const cancelCapability = (0, _util.createPromiseCapability)();
        this.streamControllers[streamId].cancelCall = cancelCapability;
        this.streamControllers[streamId].isClosed = true;
        comObj.postMessage({
          sourceName,
          targetName,
          stream: StreamKind.CANCEL,
          streamId,
          reason: wrapReason(reason)
        });
        return cancelCapability.promise;
      }
    }, queueingStrategy);
  }

  _createStreamSink(data) {
    const self = this;
    const action = this.actionHandler[data.action];
    const streamId = data.streamId;
    const sourceName = this.sourceName;
    const targetName = data.sourceName;
    const comObj = this.comObj;
    const streamSink = {
      enqueue(chunk, size = 1, transfers) {
        if (this.isCancelled) {
          return;
        }

        const lastDesiredSize = this.desiredSize;
        this.desiredSize -= size;

        if (lastDesiredSize > 0 && this.desiredSize <= 0) {
          this.sinkCapability = (0, _util.createPromiseCapability)();
          this.ready = this.sinkCapability.promise;
        }

        self._postMessage({
          sourceName,
          targetName,
          stream: StreamKind.ENQUEUE,
          streamId,
          chunk
        }, transfers);
      },

      close() {
        if (this.isCancelled) {
          return;
        }

        this.isCancelled = true;
        comObj.postMessage({
          sourceName,
          targetName,
          stream: StreamKind.CLOSE,
          streamId
        });
        delete self.streamSinks[streamId];
      },

      error(reason) {
        (0, _util.assert)(reason instanceof Error, "error must have a valid reason");

        if (this.isCancelled) {
          return;
        }

        this.isCancelled = true;
        comObj.postMessage({
          sourceName,
          targetName,
          stream: StreamKind.ERROR,
          streamId,
          reason: wrapReason(reason)
        });
      },

      sinkCapability: (0, _util.createPromiseCapability)(),
      onPull: null,
      onCancel: null,
      isCancelled: false,
      desiredSize: data.desiredSize,
      ready: null
    };
    streamSink.sinkCapability.resolve();
    streamSink.ready = streamSink.sinkCapability.promise;
    this.streamSinks[streamId] = streamSink;
    new Promise(function (resolve) {
      resolve(action(data.data, streamSink));
    }).then(function () {
      comObj.postMessage({
        sourceName,
        targetName,
        stream: StreamKind.START_COMPLETE,
        streamId,
        success: true
      });
    }, function (reason) {
      comObj.postMessage({
        sourceName,
        targetName,
        stream: StreamKind.START_COMPLETE,
        streamId,
        reason: wrapReason(reason)
      });
    });
  }

  _processStreamMessage(data) {
    const streamId = data.streamId;
    const sourceName = this.sourceName;
    const targetName = data.sourceName;
    const comObj = this.comObj;

    switch (data.stream) {
      case StreamKind.START_COMPLETE:
        if (data.success) {
          this.streamControllers[streamId].startCall.resolve();
        } else {
          this.streamControllers[streamId].startCall.reject(wrapReason(data.reason));
        }

        break;

      case StreamKind.PULL_COMPLETE:
        if (data.success) {
          this.streamControllers[streamId].pullCall.resolve();
        } else {
          this.streamControllers[streamId].pullCall.reject(wrapReason(data.reason));
        }

        break;

      case StreamKind.PULL:
        if (!this.streamSinks[streamId]) {
          comObj.postMessage({
            sourceName,
            targetName,
            stream: StreamKind.PULL_COMPLETE,
            streamId,
            success: true
          });
          break;
        }

        if (this.streamSinks[streamId].desiredSize <= 0 && data.desiredSize > 0) {
          this.streamSinks[streamId].sinkCapability.resolve();
        }

        this.streamSinks[streamId].desiredSize = data.desiredSize;
        const {
          onPull
        } = this.streamSinks[data.streamId];
        new Promise(function (resolve) {
          resolve(onPull && onPull());
        }).then(function () {
          comObj.postMessage({
            sourceName,
            targetName,
            stream: StreamKind.PULL_COMPLETE,
            streamId,
            success: true
          });
        }, function (reason) {
          comObj.postMessage({
            sourceName,
            targetName,
            stream: StreamKind.PULL_COMPLETE,
            streamId,
            reason: wrapReason(reason)
          });
        });
        break;

      case StreamKind.ENQUEUE:
        (0, _util.assert)(this.streamControllers[streamId], "enqueue should have stream controller");

        if (this.streamControllers[streamId].isClosed) {
          break;
        }

        this.streamControllers[streamId].controller.enqueue(data.chunk);
        break;

      case StreamKind.CLOSE:
        (0, _util.assert)(this.streamControllers[streamId], "close should have stream controller");

        if (this.streamControllers[streamId].isClosed) {
          break;
        }

        this.streamControllers[streamId].isClosed = true;
        this.streamControllers[streamId].controller.close();

        this._deleteStreamController(streamId);

        break;

      case StreamKind.ERROR:
        (0, _util.assert)(this.streamControllers[streamId], "error should have stream controller");
        this.streamControllers[streamId].controller.error(wrapReason(data.reason));

        this._deleteStreamController(streamId);

        break;

      case StreamKind.CANCEL_COMPLETE:
        if (data.success) {
          this.streamControllers[streamId].cancelCall.resolve();
        } else {
          this.streamControllers[streamId].cancelCall.reject(wrapReason(data.reason));
        }

        this._deleteStreamController(streamId);

        break;

      case StreamKind.CANCEL:
        if (!this.streamSinks[streamId]) {
          break;
        }

        const {
          onCancel
        } = this.streamSinks[data.streamId];
        new Promise(function (resolve) {
          resolve(onCancel && onCancel(wrapReason(data.reason)));
        }).then(function () {
          comObj.postMessage({
            sourceName,
            targetName,
            stream: StreamKind.CANCEL_COMPLETE,
            streamId,
            success: true
          });
        }, function (reason) {
          comObj.postMessage({
            sourceName,
            targetName,
            stream: StreamKind.CANCEL_COMPLETE,
            streamId,
            reason: wrapReason(reason)
          });
        });
        this.streamSinks[streamId].sinkCapability.reject(wrapReason(data.reason));
        this.streamSinks[streamId].isCancelled = true;
        delete this.streamSinks[streamId];
        break;

      default:
        throw new Error("Unexpected stream case");
    }
  }

  async _deleteStreamController(streamId) {
    await Promise.allSettled([this.streamControllers[streamId].startCall, this.streamControllers[streamId].pullCall, this.streamControllers[streamId].cancelCall].map(function (capability) {
      return capability && capability.promise;
    }));
    delete this.streamControllers[streamId];
  }

  _postMessage(message, transfers) {
    if (transfers && this.postMessageTransfers) {
      this.comObj.postMessage(message, transfers);
    } else {
      this.comObj.postMessage(message);
    }
  }

  destroy() {
    this.comObj.removeEventListener("message", this._onComObjOnMessage);
  }

}

exports.MessageHandler = MessageHandler;

/***/ }),
/* 12 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Metadata = void 0;

var _util = __w_pdfjs_require__(2);

var _xml_parser = __w_pdfjs_require__(13);

class Metadata {
  constructor(data) {
    (0, _util.assert)(typeof data === "string", "Metadata: input is not a string");
    data = this._repair(data);
    const parser = new _xml_parser.SimpleXMLParser();
    const xmlDocument = parser.parseFromString(data);
    this._metadataMap = new Map();

    if (xmlDocument) {
      this._parse(xmlDocument);
    }
  }

  _repair(data) {
    return data.replace(/^[^<]+/, "").replace(/>\\376\\377([^<]+)/g, function (all, codes) {
      const bytes = codes.replace(/\\([0-3])([0-7])([0-7])/g, function (code, d1, d2, d3) {
        return String.fromCharCode(d1 * 64 + d2 * 8 + d3 * 1);
      }).replace(/&(amp|apos|gt|lt|quot);/g, function (str, name) {
        switch (name) {
          case "amp":
            return "&";

          case "apos":
            return "'";

          case "gt":
            return ">";

          case "lt":
            return "<";

          case "quot":
            return '"';
        }

        throw new Error(`_repair: ${name} isn't defined.`);
      });
      let chars = "";

      for (let i = 0, ii = bytes.length; i < ii; i += 2) {
        const code = bytes.charCodeAt(i) * 256 + bytes.charCodeAt(i + 1);

        if (code >= 32 && code < 127 && code !== 60 && code !== 62 && code !== 38) {
          chars += String.fromCharCode(code);
        } else {
          chars += "&#x" + (0x10000 + code).toString(16).substring(1) + ";";
        }
      }

      return ">" + chars;
    });
  }

  _parse(xmlDocument) {
    let rdf = xmlDocument.documentElement;

    if (rdf.nodeName.toLowerCase() !== "rdf:rdf") {
      rdf = rdf.firstChild;

      while (rdf && rdf.nodeName.toLowerCase() !== "rdf:rdf") {
        rdf = rdf.nextSibling;
      }
    }

    const nodeName = rdf ? rdf.nodeName.toLowerCase() : null;

    if (!rdf || nodeName !== "rdf:rdf" || !rdf.hasChildNodes()) {
      return;
    }

    const children = rdf.childNodes;

    for (let i = 0, ii = children.length; i < ii; i++) {
      const desc = children[i];

      if (desc.nodeName.toLowerCase() !== "rdf:description") {
        continue;
      }

      for (let j = 0, jj = desc.childNodes.length; j < jj; j++) {
        if (desc.childNodes[j].nodeName.toLowerCase() !== "#text") {
          const entry = desc.childNodes[j];
          const name = entry.nodeName.toLowerCase();

          this._metadataMap.set(name, entry.textContent.trim());
        }
      }
    }
  }

  get(name) {
    return this._metadataMap.has(name) ? this._metadataMap.get(name) : null;
  }

  getAll() {
    const obj = Object.create(null);

    for (const [key, value] of this._metadataMap) {
      obj[key] = value;
    }

    return obj;
  }

  has(name) {
    return this._metadataMap.has(name);
  }

}

exports.Metadata = Metadata;

/***/ }),
/* 13 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleXMLParser = void 0;
const XMLParserErrorCode = {
  NoError: 0,
  EndOfDocument: -1,
  UnterminatedCdat: -2,
  UnterminatedXmlDeclaration: -3,
  UnterminatedDoctypeDeclaration: -4,
  UnterminatedComment: -5,
  MalformedElement: -6,
  OutOfMemory: -7,
  UnterminatedAttributeValue: -8,
  UnterminatedElement: -9,
  ElementNeverBegun: -10
};

function isWhitespace(s, index) {
  const ch = s[index];
  return ch === " " || ch === "\n" || ch === "\r" || ch === "\t";
}

function isWhitespaceString(s) {
  for (let i = 0, ii = s.length; i < ii; i++) {
    if (!isWhitespace(s, i)) {
      return false;
    }
  }

  return true;
}

class XMLParserBase {
  _resolveEntities(s) {
    return s.replace(/&([^;]+);/g, (all, entity) => {
      if (entity.substring(0, 2) === "#x") {
        return String.fromCharCode(parseInt(entity.substring(2), 16));
      } else if (entity.substring(0, 1) === "#") {
        return String.fromCharCode(parseInt(entity.substring(1), 10));
      }

      switch (entity) {
        case "lt":
          return "<";

        case "gt":
          return ">";

        case "amp":
          return "&";

        case "quot":
          return '"';
      }

      return this.onResolveEntity(entity);
    });
  }

  _parseContent(s, start) {
    const attributes = [];
    let pos = start;

    function skipWs() {
      while (pos < s.length && isWhitespace(s, pos)) {
        ++pos;
      }
    }

    while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
      ++pos;
    }

    const name = s.substring(start, pos);
    skipWs();

    while (pos < s.length && s[pos] !== ">" && s[pos] !== "/" && s[pos] !== "?") {
      skipWs();
      let attrName = "",
          attrValue = "";

      while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== "=") {
        attrName += s[pos];
        ++pos;
      }

      skipWs();

      if (s[pos] !== "=") {
        return null;
      }

      ++pos;
      skipWs();
      const attrEndChar = s[pos];

      if (attrEndChar !== '"' && attrEndChar !== "'") {
        return null;
      }

      const attrEndIndex = s.indexOf(attrEndChar, ++pos);

      if (attrEndIndex < 0) {
        return null;
      }

      attrValue = s.substring(pos, attrEndIndex);
      attributes.push({
        name: attrName,
        value: this._resolveEntities(attrValue)
      });
      pos = attrEndIndex + 1;
      skipWs();
    }

    return {
      name,
      attributes,
      parsed: pos - start
    };
  }

  _parseProcessingInstruction(s, start) {
    let pos = start;

    function skipWs() {
      while (pos < s.length && isWhitespace(s, pos)) {
        ++pos;
      }
    }

    while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
      ++pos;
    }

    const name = s.substring(start, pos);
    skipWs();
    const attrStart = pos;

    while (pos < s.length && (s[pos] !== "?" || s[pos + 1] !== ">")) {
      ++pos;
    }

    const value = s.substring(attrStart, pos);
    return {
      name,
      value,
      parsed: pos - start
    };
  }

  parseXml(s) {
    let i = 0;

    while (i < s.length) {
      const ch = s[i];
      let j = i;

      if (ch === "<") {
        ++j;
        const ch2 = s[j];
        let q;

        switch (ch2) {
          case "/":
            ++j;
            q = s.indexOf(">", j);

            if (q < 0) {
              this.onError(XMLParserErrorCode.UnterminatedElement);
              return;
            }

            this.onEndElement(s.substring(j, q));
            j = q + 1;
            break;

          case "?":
            ++j;

            const pi = this._parseProcessingInstruction(s, j);

            if (s.substring(j + pi.parsed, j + pi.parsed + 2) !== "?>") {
              this.onError(XMLParserErrorCode.UnterminatedXmlDeclaration);
              return;
            }

            this.onPi(pi.name, pi.value);
            j += pi.parsed + 2;
            break;

          case "!":
            if (s.substring(j + 1, j + 3) === "--") {
              q = s.indexOf("-->", j + 3);

              if (q < 0) {
                this.onError(XMLParserErrorCode.UnterminatedComment);
                return;
              }

              this.onComment(s.substring(j + 3, q));
              j = q + 3;
            } else if (s.substring(j + 1, j + 8) === "[CDATA[") {
              q = s.indexOf("]]>", j + 8);

              if (q < 0) {
                this.onError(XMLParserErrorCode.UnterminatedCdat);
                return;
              }

              this.onCdata(s.substring(j + 8, q));
              j = q + 3;
            } else if (s.substring(j + 1, j + 8) === "DOCTYPE") {
              const q2 = s.indexOf("[", j + 8);
              let complexDoctype = false;
              q = s.indexOf(">", j + 8);

              if (q < 0) {
                this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
                return;
              }

              if (q2 > 0 && q > q2) {
                q = s.indexOf("]>", j + 8);

                if (q < 0) {
                  this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
                  return;
                }

                complexDoctype = true;
              }

              const doctypeContent = s.substring(j + 8, q + (complexDoctype ? 1 : 0));
              this.onDoctype(doctypeContent);
              j = q + (complexDoctype ? 2 : 1);
            } else {
              this.onError(XMLParserErrorCode.MalformedElement);
              return;
            }

            break;

          default:
            const content = this._parseContent(s, j);

            if (content === null) {
              this.onError(XMLParserErrorCode.MalformedElement);
              return;
            }

            let isClosed = false;

            if (s.substring(j + content.parsed, j + content.parsed + 2) === "/>") {
              isClosed = true;
            } else if (s.substring(j + content.parsed, j + content.parsed + 1) !== ">") {
              this.onError(XMLParserErrorCode.UnterminatedElement);
              return;
            }

            this.onBeginElement(content.name, content.attributes, isClosed);
            j += content.parsed + (isClosed ? 2 : 1);
            break;
        }
      } else {
        while (j < s.length && s[j] !== "<") {
          j++;
        }

        const text = s.substring(i, j);
        this.onText(this._resolveEntities(text));
      }

      i = j;
    }
  }

  onResolveEntity(name) {
    return `&${name};`;
  }

  onPi(name, value) {}

  onComment(text) {}

  onCdata(text) {}

  onDoctype(doctypeContent) {}

  onText(text) {}

  onBeginElement(name, attributes, isEmpty) {}

  onEndElement(name) {}

  onError(code) {}

}

class SimpleDOMNode {
  constructor(nodeName, nodeValue) {
    this.nodeName = nodeName;
    this.nodeValue = nodeValue;
    Object.defineProperty(this, "parentNode", {
      value: null,
      writable: true
    });
  }

  get firstChild() {
    return this.childNodes && this.childNodes[0];
  }

  get nextSibling() {
    const childNodes = this.parentNode.childNodes;

    if (!childNodes) {
      return undefined;
    }

    const index = childNodes.indexOf(this);

    if (index === -1) {
      return undefined;
    }

    return childNodes[index + 1];
  }

  get textContent() {
    if (!this.childNodes) {
      return this.nodeValue || "";
    }

    return this.childNodes.map(function (child) {
      return child.textContent;
    }).join("");
  }

  hasChildNodes() {
    return this.childNodes && this.childNodes.length > 0;
  }

}

class SimpleXMLParser extends XMLParserBase {
  constructor() {
    super();
    this._currentFragment = null;
    this._stack = null;
    this._errorCode = XMLParserErrorCode.NoError;
  }

  parseFromString(data) {
    this._currentFragment = [];
    this._stack = [];
    this._errorCode = XMLParserErrorCode.NoError;
    this.parseXml(data);

    if (this._errorCode !== XMLParserErrorCode.NoError) {
      return undefined;
    }

    const [documentElement] = this._currentFragment;

    if (!documentElement) {
      return undefined;
    }

    return {
      documentElement
    };
  }

  onResolveEntity(name) {
    switch (name) {
      case "apos":
        return "'";
    }

    return super.onResolveEntity(name);
  }

  onText(text) {
    if (isWhitespaceString(text)) {
      return;
    }

    const node = new SimpleDOMNode("#text", text);

    this._currentFragment.push(node);
  }

  onCdata(text) {
    const node = new SimpleDOMNode("#text", text);

    this._currentFragment.push(node);
  }

  onBeginElement(name, attributes, isEmpty) {
    const node = new SimpleDOMNode(name);
    node.childNodes = [];

    this._currentFragment.push(node);

    if (isEmpty) {
      return;
    }

    this._stack.push(this._currentFragment);

    this._currentFragment = node.childNodes;
  }

  onEndElement(name) {
    this._currentFragment = this._stack.pop() || [];
    const lastElement = this._currentFragment[this._currentFragment.length - 1];

    if (!lastElement) {
      return;
    }

    for (let i = 0, ii = lastElement.childNodes.length; i < ii; i++) {
      lastElement.childNodes[i].parentNode = lastElement;
    }
  }

  onError(code) {
    this._errorCode = code;
  }

}

exports.SimpleXMLParser = SimpleXMLParser;

/***/ }),
/* 14 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFDataTransportStream = void 0;

var _util = __w_pdfjs_require__(2);

class PDFDataTransportStream {
  constructor(params, pdfDataRangeTransport) {
    (0, _util.assert)(pdfDataRangeTransport, 'PDFDataTransportStream - missing required "pdfDataRangeTransport" argument.');
    this._queuedChunks = [];
    this._progressiveDone = params.progressiveDone || false;
    const initialData = params.initialData;

    if (initialData && initialData.length > 0) {
      const buffer = new Uint8Array(initialData).buffer;

      this._queuedChunks.push(buffer);
    }

    this._pdfDataRangeTransport = pdfDataRangeTransport;
    this._isStreamingSupported = !params.disableStream;
    this._isRangeSupported = !params.disableRange;
    this._contentLength = params.length;
    this._fullRequestReader = null;
    this._rangeReaders = [];

    this._pdfDataRangeTransport.addRangeListener((begin, chunk) => {
      this._onReceiveData({
        begin,
        chunk
      });
    });

    this._pdfDataRangeTransport.addProgressListener((loaded, total) => {
      this._onProgress({
        loaded,
        total
      });
    });

    this._pdfDataRangeTransport.addProgressiveReadListener(chunk => {
      this._onReceiveData({
        chunk
      });
    });

    this._pdfDataRangeTransport.addProgressiveDoneListener(() => {
      this._onProgressiveDone();
    });

    this._pdfDataRangeTransport.transportReady();
  }

  _onReceiveData(args) {
    const buffer = new Uint8Array(args.chunk).buffer;

    if (args.begin === undefined) {
      if (this._fullRequestReader) {
        this._fullRequestReader._enqueue(buffer);
      } else {
        this._queuedChunks.push(buffer);
      }
    } else {
      const found = this._rangeReaders.some(function (rangeReader) {
        if (rangeReader._begin !== args.begin) {
          return false;
        }

        rangeReader._enqueue(buffer);

        return true;
      });

      (0, _util.assert)(found, "_onReceiveData - no `PDFDataTransportStreamRangeReader` instance found.");
    }
  }

  get _progressiveDataLength() {
    return this._fullRequestReader ? this._fullRequestReader._loaded : 0;
  }

  _onProgress(evt) {
    if (evt.total === undefined) {
      const firstReader = this._rangeReaders[0];

      if (firstReader && firstReader.onProgress) {
        firstReader.onProgress({
          loaded: evt.loaded
        });
      }
    } else {
      const fullReader = this._fullRequestReader;

      if (fullReader && fullReader.onProgress) {
        fullReader.onProgress({
          loaded: evt.loaded,
          total: evt.total
        });
      }
    }
  }

  _onProgressiveDone() {
    if (this._fullRequestReader) {
      this._fullRequestReader.progressiveDone();
    }

    this._progressiveDone = true;
  }

  _removeRangeReader(reader) {
    const i = this._rangeReaders.indexOf(reader);

    if (i >= 0) {
      this._rangeReaders.splice(i, 1);
    }
  }

  getFullReader() {
    (0, _util.assert)(!this._fullRequestReader, "PDFDataTransportStream.getFullReader can only be called once.");
    const queuedChunks = this._queuedChunks;
    this._queuedChunks = null;
    return new PDFDataTransportStreamReader(this, queuedChunks, this._progressiveDone);
  }

  getRangeReader(begin, end) {
    if (end <= this._progressiveDataLength) {
      return null;
    }

    const reader = new PDFDataTransportStreamRangeReader(this, begin, end);

    this._pdfDataRangeTransport.requestDataRange(begin, end);

    this._rangeReaders.push(reader);

    return reader;
  }

  cancelAllRequests(reason) {
    if (this._fullRequestReader) {
      this._fullRequestReader.cancel(reason);
    }

    const readers = this._rangeReaders.slice(0);

    readers.forEach(function (rangeReader) {
      rangeReader.cancel(reason);
    });

    this._pdfDataRangeTransport.abort();
  }

}

exports.PDFDataTransportStream = PDFDataTransportStream;

class PDFDataTransportStreamReader {
  constructor(stream, queuedChunks, progressiveDone = false) {
    this._stream = stream;
    this._done = progressiveDone || false;
    this._filename = null;
    this._queuedChunks = queuedChunks || [];
    this._loaded = 0;

    for (const chunk of this._queuedChunks) {
      this._loaded += chunk.byteLength;
    }

    this._requests = [];
    this._headersReady = Promise.resolve();
    stream._fullRequestReader = this;
    this.onProgress = null;
  }

  _enqueue(chunk) {
    if (this._done) {
      return;
    }

    if (this._requests.length > 0) {
      const requestCapability = this._requests.shift();

      requestCapability.resolve({
        value: chunk,
        done: false
      });
    } else {
      this._queuedChunks.push(chunk);
    }

    this._loaded += chunk.byteLength;
  }

  get headersReady() {
    return this._headersReady;
  }

  get filename() {
    return this._filename;
  }

  get isRangeSupported() {
    return this._stream._isRangeSupported;
  }

  get isStreamingSupported() {
    return this._stream._isStreamingSupported;
  }

  get contentLength() {
    return this._stream._contentLength;
  }

  async read() {
    if (this._queuedChunks.length > 0) {
      const chunk = this._queuedChunks.shift();

      return {
        value: chunk,
        done: false
      };
    }

    if (this._done) {
      return {
        value: undefined,
        done: true
      };
    }

    const requestCapability = (0, _util.createPromiseCapability)();

    this._requests.push(requestCapability);

    return requestCapability.promise;
  }

  cancel(reason) {
    this._done = true;

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];
  }

  progressiveDone() {
    if (this._done) {
      return;
    }

    this._done = true;
  }

}

class PDFDataTransportStreamRangeReader {
  constructor(stream, begin, end) {
    this._stream = stream;
    this._begin = begin;
    this._end = end;
    this._queuedChunk = null;
    this._requests = [];
    this._done = false;
    this.onProgress = null;
  }

  _enqueue(chunk) {
    if (this._done) {
      return;
    }

    if (this._requests.length === 0) {
      this._queuedChunk = chunk;
    } else {
      const requestsCapability = this._requests.shift();

      requestsCapability.resolve({
        value: chunk,
        done: false
      });

      this._requests.forEach(function (requestCapability) {
        requestCapability.resolve({
          value: undefined,
          done: true
        });
      });

      this._requests = [];
    }

    this._done = true;

    this._stream._removeRangeReader(this);
  }

  get isStreamingSupported() {
    return false;
  }

  async read() {
    if (this._queuedChunk) {
      const chunk = this._queuedChunk;
      this._queuedChunk = null;
      return {
        value: chunk,
        done: false
      };
    }

    if (this._done) {
      return {
        value: undefined,
        done: true
      };
    }

    const requestCapability = (0, _util.createPromiseCapability)();

    this._requests.push(requestCapability);

    return requestCapability.promise;
  }

  cancel(reason) {
    this._done = true;

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    this._stream._removeRangeReader(this);
  }

}

/***/ }),
/* 15 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebGLContext = void 0;

var _util = __w_pdfjs_require__(2);

class WebGLContext {
  constructor({
    enable = false
  }) {
    this._enabled = enable === true;
  }

  get isEnabled() {
    let enabled = this._enabled;

    if (enabled) {
      enabled = WebGLUtils.tryInitGL();
    }

    return (0, _util.shadow)(this, "isEnabled", enabled);
  }

  composeSMask({
    layer,
    mask,
    properties
  }) {
    return WebGLUtils.composeSMask(layer, mask, properties);
  }

  drawFigures({
    width,
    height,
    backgroundColor,
    figures,
    context
  }) {
    return WebGLUtils.drawFigures(width, height, backgroundColor, figures, context);
  }

  clear() {
    WebGLUtils.cleanup();
  }

}

exports.WebGLContext = WebGLContext;

var WebGLUtils = function WebGLUtilsClosure() {
  function loadShader(gl, code, shaderType) {
    var shader = gl.createShader(shaderType);
    gl.shaderSource(shader, code);
    gl.compileShader(shader);
    var compiled = gl.getShaderParameter(shader, gl.COMPILE_STATUS);

    if (!compiled) {
      var errorMsg = gl.getShaderInfoLog(shader);
      throw new Error("Error during shader compilation: " + errorMsg);
    }

    return shader;
  }

  function createVertexShader(gl, code) {
    return loadShader(gl, code, gl.VERTEX_SHADER);
  }

  function createFragmentShader(gl, code) {
    return loadShader(gl, code, gl.FRAGMENT_SHADER);
  }

  function createProgram(gl, shaders) {
    var program = gl.createProgram();

    for (var i = 0, ii = shaders.length; i < ii; ++i) {
      gl.attachShader(program, shaders[i]);
    }

    gl.linkProgram(program);
    var linked = gl.getProgramParameter(program, gl.LINK_STATUS);

    if (!linked) {
      var errorMsg = gl.getProgramInfoLog(program);
      throw new Error("Error during program linking: " + errorMsg);
    }

    return program;
  }

  function createTexture(gl, image, textureId) {
    gl.activeTexture(textureId);
    var texture = gl.createTexture();
    gl.bindTexture(gl.TEXTURE_2D, texture);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
    gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, image);
    return texture;
  }

  var currentGL, currentCanvas;

  function generateGL() {
    if (currentGL) {
      return;
    }

    currentCanvas = document.createElement("canvas");
    currentGL = currentCanvas.getContext("webgl", {
      premultipliedalpha: false
    });
  }

  var smaskVertexShaderCode = "\
  attribute vec2 a_position;                                    \
  attribute vec2 a_texCoord;                                    \
                                                                \
  uniform vec2 u_resolution;                                    \
                                                                \
  varying vec2 v_texCoord;                                      \
                                                                \
  void main() {                                                 \
    vec2 clipSpace = (a_position / u_resolution) * 2.0 - 1.0;   \
    gl_Position = vec4(clipSpace * vec2(1, -1), 0, 1);          \
                                                                \
    v_texCoord = a_texCoord;                                    \
  }                                                             ";
  var smaskFragmentShaderCode = "\
  precision mediump float;                                      \
                                                                \
  uniform vec4 u_backdrop;                                      \
  uniform int u_subtype;                                        \
  uniform sampler2D u_image;                                    \
  uniform sampler2D u_mask;                                     \
                                                                \
  varying vec2 v_texCoord;                                      \
                                                                \
  void main() {                                                 \
    vec4 imageColor = texture2D(u_image, v_texCoord);           \
    vec4 maskColor = texture2D(u_mask, v_texCoord);             \
    if (u_backdrop.a > 0.0) {                                   \
      maskColor.rgb = maskColor.rgb * maskColor.a +             \
                      u_backdrop.rgb * (1.0 - maskColor.a);     \
    }                                                           \
    float lum;                                                  \
    if (u_subtype == 0) {                                       \
      lum = maskColor.a;                                        \
    } else {                                                    \
      lum = maskColor.r * 0.3 + maskColor.g * 0.59 +            \
            maskColor.b * 0.11;                                 \
    }                                                           \
    imageColor.a *= lum;                                        \
    imageColor.rgb *= imageColor.a;                             \
    gl_FragColor = imageColor;                                  \
  }                                                             ";
  var smaskCache = null;

  function initSmaskGL() {
    var canvas, gl;
    generateGL();
    canvas = currentCanvas;
    currentCanvas = null;
    gl = currentGL;
    currentGL = null;
    var vertexShader = createVertexShader(gl, smaskVertexShaderCode);
    var fragmentShader = createFragmentShader(gl, smaskFragmentShaderCode);
    var program = createProgram(gl, [vertexShader, fragmentShader]);
    gl.useProgram(program);
    var cache = {};
    cache.gl = gl;
    cache.canvas = canvas;
    cache.resolutionLocation = gl.getUniformLocation(program, "u_resolution");
    cache.positionLocation = gl.getAttribLocation(program, "a_position");
    cache.backdropLocation = gl.getUniformLocation(program, "u_backdrop");
    cache.subtypeLocation = gl.getUniformLocation(program, "u_subtype");
    var texCoordLocation = gl.getAttribLocation(program, "a_texCoord");
    var texLayerLocation = gl.getUniformLocation(program, "u_image");
    var texMaskLocation = gl.getUniformLocation(program, "u_mask");
    var texCoordBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, texCoordBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 1.0]), gl.STATIC_DRAW);
    gl.enableVertexAttribArray(texCoordLocation);
    gl.vertexAttribPointer(texCoordLocation, 2, gl.FLOAT, false, 0, 0);
    gl.uniform1i(texLayerLocation, 0);
    gl.uniform1i(texMaskLocation, 1);
    smaskCache = cache;
  }

  function composeSMask(layer, mask, properties) {
    var width = layer.width,
        height = layer.height;

    if (!smaskCache) {
      initSmaskGL();
    }

    var cache = smaskCache,
        canvas = cache.canvas,
        gl = cache.gl;
    canvas.width = width;
    canvas.height = height;
    gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
    gl.uniform2f(cache.resolutionLocation, width, height);

    if (properties.backdrop) {
      gl.uniform4f(cache.resolutionLocation, properties.backdrop[0], properties.backdrop[1], properties.backdrop[2], 1);
    } else {
      gl.uniform4f(cache.resolutionLocation, 0, 0, 0, 0);
    }

    gl.uniform1i(cache.subtypeLocation, properties.subtype === "Luminosity" ? 1 : 0);
    var texture = createTexture(gl, layer, gl.TEXTURE0);
    var maskTexture = createTexture(gl, mask, gl.TEXTURE1);
    var buffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0, 0, width, 0, 0, height, 0, height, width, 0, width, height]), gl.STATIC_DRAW);
    gl.enableVertexAttribArray(cache.positionLocation);
    gl.vertexAttribPointer(cache.positionLocation, 2, gl.FLOAT, false, 0, 0);
    gl.clearColor(0, 0, 0, 0);
    gl.enable(gl.BLEND);
    gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
    gl.clear(gl.COLOR_BUFFER_BIT);
    gl.drawArrays(gl.TRIANGLES, 0, 6);
    gl.flush();
    gl.deleteTexture(texture);
    gl.deleteTexture(maskTexture);
    gl.deleteBuffer(buffer);
    return canvas;
  }

  var figuresVertexShaderCode = "\
  attribute vec2 a_position;                                    \
  attribute vec3 a_color;                                       \
                                                                \
  uniform vec2 u_resolution;                                    \
  uniform vec2 u_scale;                                         \
  uniform vec2 u_offset;                                        \
                                                                \
  varying vec4 v_color;                                         \
                                                                \
  void main() {                                                 \
    vec2 position = (a_position + u_offset) * u_scale;          \
    vec2 clipSpace = (position / u_resolution) * 2.0 - 1.0;     \
    gl_Position = vec4(clipSpace * vec2(1, -1), 0, 1);          \
                                                                \
    v_color = vec4(a_color / 255.0, 1.0);                       \
  }                                                             ";
  var figuresFragmentShaderCode = "\
  precision mediump float;                                      \
                                                                \
  varying vec4 v_color;                                         \
                                                                \
  void main() {                                                 \
    gl_FragColor = v_color;                                     \
  }                                                             ";
  var figuresCache = null;

  function initFiguresGL() {
    var canvas, gl;
    generateGL();
    canvas = currentCanvas;
    currentCanvas = null;
    gl = currentGL;
    currentGL = null;
    var vertexShader = createVertexShader(gl, figuresVertexShaderCode);
    var fragmentShader = createFragmentShader(gl, figuresFragmentShaderCode);
    var program = createProgram(gl, [vertexShader, fragmentShader]);
    gl.useProgram(program);
    var cache = {};
    cache.gl = gl;
    cache.canvas = canvas;
    cache.resolutionLocation = gl.getUniformLocation(program, "u_resolution");
    cache.scaleLocation = gl.getUniformLocation(program, "u_scale");
    cache.offsetLocation = gl.getUniformLocation(program, "u_offset");
    cache.positionLocation = gl.getAttribLocation(program, "a_position");
    cache.colorLocation = gl.getAttribLocation(program, "a_color");
    figuresCache = cache;
  }

  function drawFigures(width, height, backgroundColor, figures, context) {
    if (!figuresCache) {
      initFiguresGL();
    }

    var cache = figuresCache,
        canvas = cache.canvas,
        gl = cache.gl;
    canvas.width = width;
    canvas.height = height;
    gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
    gl.uniform2f(cache.resolutionLocation, width, height);
    var count = 0;
    var i, ii, rows;

    for (i = 0, ii = figures.length; i < ii; i++) {
      switch (figures[i].type) {
        case "lattice":
          rows = figures[i].coords.length / figures[i].verticesPerRow | 0;
          count += (rows - 1) * (figures[i].verticesPerRow - 1) * 6;
          break;

        case "triangles":
          count += figures[i].coords.length;
          break;
      }
    }

    var coords = new Float32Array(count * 2);
    var colors = new Uint8Array(count * 3);
    var coordsMap = context.coords,
        colorsMap = context.colors;
    var pIndex = 0,
        cIndex = 0;

    for (i = 0, ii = figures.length; i < ii; i++) {
      var figure = figures[i],
          ps = figure.coords,
          cs = figure.colors;

      switch (figure.type) {
        case "lattice":
          var cols = figure.verticesPerRow;
          rows = ps.length / cols | 0;

          for (var row = 1; row < rows; row++) {
            var offset = row * cols + 1;

            for (var col = 1; col < cols; col++, offset++) {
              coords[pIndex] = coordsMap[ps[offset - cols - 1]];
              coords[pIndex + 1] = coordsMap[ps[offset - cols - 1] + 1];
              coords[pIndex + 2] = coordsMap[ps[offset - cols]];
              coords[pIndex + 3] = coordsMap[ps[offset - cols] + 1];
              coords[pIndex + 4] = coordsMap[ps[offset - 1]];
              coords[pIndex + 5] = coordsMap[ps[offset - 1] + 1];
              colors[cIndex] = colorsMap[cs[offset - cols - 1]];
              colors[cIndex + 1] = colorsMap[cs[offset - cols - 1] + 1];
              colors[cIndex + 2] = colorsMap[cs[offset - cols - 1] + 2];
              colors[cIndex + 3] = colorsMap[cs[offset - cols]];
              colors[cIndex + 4] = colorsMap[cs[offset - cols] + 1];
              colors[cIndex + 5] = colorsMap[cs[offset - cols] + 2];
              colors[cIndex + 6] = colorsMap[cs[offset - 1]];
              colors[cIndex + 7] = colorsMap[cs[offset - 1] + 1];
              colors[cIndex + 8] = colorsMap[cs[offset - 1] + 2];
              coords[pIndex + 6] = coords[pIndex + 2];
              coords[pIndex + 7] = coords[pIndex + 3];
              coords[pIndex + 8] = coords[pIndex + 4];
              coords[pIndex + 9] = coords[pIndex + 5];
              coords[pIndex + 10] = coordsMap[ps[offset]];
              coords[pIndex + 11] = coordsMap[ps[offset] + 1];
              colors[cIndex + 9] = colors[cIndex + 3];
              colors[cIndex + 10] = colors[cIndex + 4];
              colors[cIndex + 11] = colors[cIndex + 5];
              colors[cIndex + 12] = colors[cIndex + 6];
              colors[cIndex + 13] = colors[cIndex + 7];
              colors[cIndex + 14] = colors[cIndex + 8];
              colors[cIndex + 15] = colorsMap[cs[offset]];
              colors[cIndex + 16] = colorsMap[cs[offset] + 1];
              colors[cIndex + 17] = colorsMap[cs[offset] + 2];
              pIndex += 12;
              cIndex += 18;
            }
          }

          break;

        case "triangles":
          for (var j = 0, jj = ps.length; j < jj; j++) {
            coords[pIndex] = coordsMap[ps[j]];
            coords[pIndex + 1] = coordsMap[ps[j] + 1];
            colors[cIndex] = colorsMap[cs[j]];
            colors[cIndex + 1] = colorsMap[cs[j] + 1];
            colors[cIndex + 2] = colorsMap[cs[j] + 2];
            pIndex += 2;
            cIndex += 3;
          }

          break;
      }
    }

    if (backgroundColor) {
      gl.clearColor(backgroundColor[0] / 255, backgroundColor[1] / 255, backgroundColor[2] / 255, 1.0);
    } else {
      gl.clearColor(0, 0, 0, 0);
    }

    gl.clear(gl.COLOR_BUFFER_BIT);
    var coordsBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, coordsBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, coords, gl.STATIC_DRAW);
    gl.enableVertexAttribArray(cache.positionLocation);
    gl.vertexAttribPointer(cache.positionLocation, 2, gl.FLOAT, false, 0, 0);
    var colorsBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, colorsBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, colors, gl.STATIC_DRAW);
    gl.enableVertexAttribArray(cache.colorLocation);
    gl.vertexAttribPointer(cache.colorLocation, 3, gl.UNSIGNED_BYTE, false, 0, 0);
    gl.uniform2f(cache.scaleLocation, context.scaleX, context.scaleY);
    gl.uniform2f(cache.offsetLocation, context.offsetX, context.offsetY);
    gl.drawArrays(gl.TRIANGLES, 0, count);
    gl.flush();
    gl.deleteBuffer(coordsBuffer);
    gl.deleteBuffer(colorsBuffer);
    return canvas;
  }

  return {
    tryInitGL() {
      try {
        generateGL();
        return !!currentGL;
      } catch (ex) {}

      return false;
    },

    composeSMask,
    drawFigures,

    cleanup() {
      if (smaskCache && smaskCache.canvas) {
        smaskCache.canvas.width = 0;
        smaskCache.canvas.height = 0;
      }

      if (figuresCache && figuresCache.canvas) {
        figuresCache.canvas.width = 0;
        figuresCache.canvas.height = 0;
      }

      smaskCache = null;
      figuresCache = null;
    }

  };
}();

/***/ }),
/* 16 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnnotationLayer = void 0;

var _display_utils = __w_pdfjs_require__(1);

var _util = __w_pdfjs_require__(2);

class AnnotationElementFactory {
  static create(parameters) {
    const subtype = parameters.data.annotationType;

    switch (subtype) {
      case _util.AnnotationType.LINK:
        return new LinkAnnotationElement(parameters);

      case _util.AnnotationType.TEXT:
        return new TextAnnotationElement(parameters);

      case _util.AnnotationType.WIDGET:
        const fieldType = parameters.data.fieldType;

        switch (fieldType) {
          case "Tx":
            return new TextWidgetAnnotationElement(parameters);

          case "Btn":
            if (parameters.data.radioButton) {
              return new RadioButtonWidgetAnnotationElement(parameters);
            } else if (parameters.data.checkBox) {
              return new CheckboxWidgetAnnotationElement(parameters);
            }

            return new PushButtonWidgetAnnotationElement(parameters);

          case "Ch":
            return new ChoiceWidgetAnnotationElement(parameters);
        }

        return new WidgetAnnotationElement(parameters);

      case _util.AnnotationType.POPUP:
        return new PopupAnnotationElement(parameters);

      case _util.AnnotationType.FREETEXT:
        return new FreeTextAnnotationElement(parameters);

      case _util.AnnotationType.LINE:
        return new LineAnnotationElement(parameters);

      case _util.AnnotationType.SQUARE:
        return new SquareAnnotationElement(parameters);

      case _util.AnnotationType.CIRCLE:
        return new CircleAnnotationElement(parameters);

      case _util.AnnotationType.POLYLINE:
        return new PolylineAnnotationElement(parameters);

      case _util.AnnotationType.CARET:
        return new CaretAnnotationElement(parameters);

      case _util.AnnotationType.INK:
        return new InkAnnotationElement(parameters);

      case _util.AnnotationType.POLYGON:
        return new PolygonAnnotationElement(parameters);

      case _util.AnnotationType.HIGHLIGHT:
        return new HighlightAnnotationElement(parameters);

      case _util.AnnotationType.UNDERLINE:
        return new UnderlineAnnotationElement(parameters);

      case _util.AnnotationType.SQUIGGLY:
        return new SquigglyAnnotationElement(parameters);

      case _util.AnnotationType.STRIKEOUT:
        return new StrikeOutAnnotationElement(parameters);

      case _util.AnnotationType.STAMP:
        return new StampAnnotationElement(parameters);

      case _util.AnnotationType.FILEATTACHMENT:
        return new FileAttachmentAnnotationElement(parameters);

      default:
        return new AnnotationElement(parameters);
    }
  }

}

class AnnotationElement {
  constructor(parameters, isRenderable = false, ignoreBorder = false) {
    this.isRenderable = isRenderable;
    this.data = parameters.data;
    this.layer = parameters.layer;
    this.page = parameters.page;
    this.viewport = parameters.viewport;
    this.linkService = parameters.linkService;
    this.downloadManager = parameters.downloadManager;
    this.imageResourcesPath = parameters.imageResourcesPath;
    this.renderInteractiveForms = parameters.renderInteractiveForms;
    this.svgFactory = parameters.svgFactory;

    if (isRenderable) {
      this.container = this._createContainer(ignoreBorder);
    }
  }

  _createContainer(ignoreBorder = false) {
    const data = this.data,
          page = this.page,
          viewport = this.viewport;
    const container = document.createElement("section");
    let width = data.rect[2] - data.rect[0];
    let height = data.rect[3] - data.rect[1];
    container.setAttribute("data-annotation-id", data.id);

    const rect = _util.Util.normalizeRect([data.rect[0], page.view[3] - data.rect[1] + page.view[1], data.rect[2], page.view[3] - data.rect[3] + page.view[1]]);

    container.style.transform = `matrix(${viewport.transform.join(",")})`;
    container.style.transformOrigin = `-${rect[0]}px -${rect[1]}px`;

    if (!ignoreBorder && data.borderStyle.width > 0) {
      container.style.borderWidth = `${data.borderStyle.width}px`;

      if (data.borderStyle.style !== _util.AnnotationBorderStyleType.UNDERLINE) {
        width = width - 2 * data.borderStyle.width;
        height = height - 2 * data.borderStyle.width;
      }

      const horizontalRadius = data.borderStyle.horizontalCornerRadius;
      const verticalRadius = data.borderStyle.verticalCornerRadius;

      if (horizontalRadius > 0 || verticalRadius > 0) {
        const radius = `${horizontalRadius}px / ${verticalRadius}px`;
        container.style.borderRadius = radius;
      }

      switch (data.borderStyle.style) {
        case _util.AnnotationBorderStyleType.SOLID:
          container.style.borderStyle = "solid";
          break;

        case _util.AnnotationBorderStyleType.DASHED:
          container.style.borderStyle = "dashed";
          break;

        case _util.AnnotationBorderStyleType.BEVELED:
          (0, _util.warn)("Unimplemented border style: beveled");
          break;

        case _util.AnnotationBorderStyleType.INSET:
          (0, _util.warn)("Unimplemented border style: inset");
          break;

        case _util.AnnotationBorderStyleType.UNDERLINE:
          container.style.borderBottomStyle = "solid";
          break;
      }

      if (data.color) {
        container.style.borderColor = _util.Util.makeCssRgb(data.color[0] | 0, data.color[1] | 0, data.color[2] | 0);
      } else {
        container.style.borderWidth = 0;
      }
    }

    container.style.left = `${rect[0]}px`;
    container.style.top = `${rect[1]}px`;
    container.style.width = `${width}px`;
    container.style.height = `${height}px`;
    return container;
  }

  _createPopup(container, trigger, data) {
    if (!trigger) {
      trigger = document.createElement("div");
      trigger.style.height = container.style.height;
      trigger.style.width = container.style.width;
      container.appendChild(trigger);
    }

    const popupElement = new PopupElement({
      container,
      trigger,
      color: data.color,
      title: data.title,
      modificationDate: data.modificationDate,
      contents: data.contents,
      hideWrapper: true
    });
    const popup = popupElement.render();
    popup.style.left = container.style.width;
    container.appendChild(popup);
  }

  render() {
    (0, _util.unreachable)("Abstract method `AnnotationElement.render` called");
  }

}

class LinkAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.url || parameters.data.dest || parameters.data.action);
    super(parameters, isRenderable);
  }

  render() {
    this.container.className = "linkAnnotation";
    const {
      data,
      linkService
    } = this;
    const link = document.createElement("a");

    if (data.url) {
      (0, _display_utils.addLinkAttributes)(link, {
        url: data.url,
        target: data.newWindow ? _display_utils.LinkTarget.BLANK : linkService.externalLinkTarget,
        rel: linkService.externalLinkRel,
        enabled: linkService.externalLinkEnabled
      });
    } else if (data.action) {
      this._bindNamedAction(link, data.action);
    } else {
      this._bindLink(link, data.dest);
    }

    this.container.appendChild(link);
    return this.container;
  }

  _bindLink(link, destination) {
    link.href = this.linkService.getDestinationHash(destination);

    link.onclick = () => {
      if (destination) {
        this.linkService.navigateTo(destination);
      }

      return false;
    };

    if (destination) {
      link.className = "internalLink";
    }
  }

  _bindNamedAction(link, action) {
    link.href = this.linkService.getAnchorUrl("");

    link.onclick = () => {
      this.linkService.executeNamedAction(action);
      return false;
    };

    link.className = "internalLink";
  }

}

class TextAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable);
  }

  render() {
    this.container.className = "textAnnotation";
    const image = document.createElement("img");
    image.style.height = this.container.style.height;
    image.style.width = this.container.style.width;
    image.src = this.imageResourcesPath + "annotation-" + this.data.name.toLowerCase() + ".svg";
    image.alt = "[{{type}} Annotation]";
    image.dataset.l10nId = "text_annotation_type";
    image.dataset.l10nArgs = JSON.stringify({
      type: this.data.name
    });

    if (!this.data.hasPopup) {
      this._createPopup(this.container, image, this.data);
    }

    this.container.appendChild(image);
    return this.container;
  }

}

class WidgetAnnotationElement extends AnnotationElement {
  render() {
    return this.container;
  }

}

class TextWidgetAnnotationElement extends WidgetAnnotationElement {
  constructor(parameters) {
    const isRenderable = parameters.renderInteractiveForms || !parameters.data.hasAppearance && !!parameters.data.fieldValue;
    super(parameters, isRenderable);
  }

  render() {
    const TEXT_ALIGNMENT = ["left", "center", "right"];
    this.container.className = "textWidgetAnnotation";
    let element = null;

    if (this.renderInteractiveForms) {
      if (this.data.multiLine) {
        element = document.createElement("textarea");
        element.textContent = this.data.fieldValue;
      } else {
        element = document.createElement("input");
        element.type = "text";
        element.setAttribute("value", this.data.fieldValue);
      }

      element.disabled = this.data.readOnly;
      element.name = this.data.fieldName;

      if (this.data.maxLen !== null) {
        element.maxLength = this.data.maxLen;
      }

      if (this.data.comb) {
        const fieldWidth = this.data.rect[2] - this.data.rect[0];
        const combWidth = fieldWidth / this.data.maxLen;
        element.classList.add("comb");
        element.style.letterSpacing = `calc(${combWidth}px - 1ch)`;
      }
    } else {
      element = document.createElement("div");
      element.textContent = this.data.fieldValue;
      element.style.verticalAlign = "middle";
      element.style.display = "table-cell";
      let font = null;

      if (this.data.fontRefName && this.page.commonObjs.has(this.data.fontRefName)) {
        font = this.page.commonObjs.get(this.data.fontRefName);
      }

      this._setTextStyle(element, font);
    }

    if (this.data.textAlignment !== null) {
      element.style.textAlign = TEXT_ALIGNMENT[this.data.textAlignment];
    }

    this.container.appendChild(element);
    return this.container;
  }

  _setTextStyle(element, font) {
    const style = element.style;
    style.fontSize = `${this.data.fontSize}px`;
    style.direction = this.data.fontDirection < 0 ? "rtl" : "ltr";

    if (!font) {
      return;
    }

    let bold = "normal";

    if (font.black) {
      bold = "900";
    } else if (font.bold) {
      bold = "bold";
    }

    style.fontWeight = bold;
    style.fontStyle = font.italic ? "italic" : "normal";
    const fontFamily = font.loadedName ? `"${font.loadedName}", ` : "";
    const fallbackName = font.fallbackName || "Helvetica, sans-serif";
    style.fontFamily = fontFamily + fallbackName;
  }

}

class CheckboxWidgetAnnotationElement extends WidgetAnnotationElement {
  constructor(parameters) {
    super(parameters, parameters.renderInteractiveForms);
  }

  render() {
    this.container.className = "buttonWidgetAnnotation checkBox";
    const element = document.createElement("input");
    element.disabled = this.data.readOnly;
    element.type = "checkbox";
    element.name = this.data.fieldName;

    if (this.data.fieldValue && this.data.fieldValue !== "Off") {
      element.setAttribute("checked", true);
    }

    this.container.appendChild(element);
    return this.container;
  }

}

class RadioButtonWidgetAnnotationElement extends WidgetAnnotationElement {
  constructor(parameters) {
    super(parameters, parameters.renderInteractiveForms);
  }

  render() {
    this.container.className = "buttonWidgetAnnotation radioButton";
    const element = document.createElement("input");
    element.disabled = this.data.readOnly;
    element.type = "radio";
    element.name = this.data.fieldName;

    if (this.data.fieldValue === this.data.buttonValue) {
      element.setAttribute("checked", true);
    }

    this.container.appendChild(element);
    return this.container;
  }

}

class PushButtonWidgetAnnotationElement extends LinkAnnotationElement {
  render() {
    const container = super.render();
    container.className = "buttonWidgetAnnotation pushButton";
    return container;
  }

}

class ChoiceWidgetAnnotationElement extends WidgetAnnotationElement {
  constructor(parameters) {
    super(parameters, parameters.renderInteractiveForms);
  }

  render() {
    this.container.className = "choiceWidgetAnnotation";
    const selectElement = document.createElement("select");
    selectElement.disabled = this.data.readOnly;
    selectElement.name = this.data.fieldName;

    if (!this.data.combo) {
      selectElement.size = this.data.options.length;

      if (this.data.multiSelect) {
        selectElement.multiple = true;
      }
    }

    for (const option of this.data.options) {
      const optionElement = document.createElement("option");
      optionElement.textContent = option.displayValue;
      optionElement.value = option.exportValue;

      if (this.data.fieldValue.includes(option.displayValue)) {
        optionElement.setAttribute("selected", true);
      }

      selectElement.appendChild(optionElement);
    }

    this.container.appendChild(selectElement);
    return this.container;
  }

}

class PopupAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable);
  }

  render() {
    const IGNORE_TYPES = ["Line", "Square", "Circle", "PolyLine", "Polygon", "Ink"];
    this.container.className = "popupAnnotation";

    if (IGNORE_TYPES.includes(this.data.parentType)) {
      return this.container;
    }

    const selector = `[data-annotation-id="${this.data.parentId}"]`;
    const parentElement = this.layer.querySelector(selector);

    if (!parentElement) {
      return this.container;
    }

    const popup = new PopupElement({
      container: this.container,
      trigger: parentElement,
      color: this.data.color,
      title: this.data.title,
      modificationDate: this.data.modificationDate,
      contents: this.data.contents
    });
    const parentLeft = parseFloat(parentElement.style.left);
    const parentWidth = parseFloat(parentElement.style.width);
    this.container.style.transformOrigin = `-${parentLeft + parentWidth}px -${parentElement.style.top}`;
    this.container.style.left = `${parentLeft + parentWidth}px`;
    this.container.appendChild(popup.render());
    return this.container;
  }

}

class PopupElement {
  constructor(parameters) {
    this.container = parameters.container;
    this.trigger = parameters.trigger;
    this.color = parameters.color;
    this.title = parameters.title;
    this.modificationDate = parameters.modificationDate;
    this.contents = parameters.contents;
    this.hideWrapper = parameters.hideWrapper || false;
    this.pinned = false;
  }

  render() {
    const BACKGROUND_ENLIGHT = 0.7;
    const wrapper = document.createElement("div");
    wrapper.className = "popupWrapper";
    this.hideElement = this.hideWrapper ? wrapper : this.container;
    this.hideElement.setAttribute("hidden", true);
    const popup = document.createElement("div");
    popup.className = "popup";
    const color = this.color;

    if (color) {
      const r = BACKGROUND_ENLIGHT * (255 - color[0]) + color[0];
      const g = BACKGROUND_ENLIGHT * (255 - color[1]) + color[1];
      const b = BACKGROUND_ENLIGHT * (255 - color[2]) + color[2];
      popup.style.backgroundColor = _util.Util.makeCssRgb(r | 0, g | 0, b | 0);
    }

    const title = document.createElement("h1");
    title.textContent = this.title;
    popup.appendChild(title);

    const dateObject = _display_utils.PDFDateString.toDateObject(this.modificationDate);

    if (dateObject) {
      const modificationDate = document.createElement("span");
      modificationDate.textContent = "{{date}}, {{time}}";
      modificationDate.dataset.l10nId = "annotation_date_string";
      modificationDate.dataset.l10nArgs = JSON.stringify({
        date: dateObject.toLocaleDateString(),
        time: dateObject.toLocaleTimeString()
      });
      popup.appendChild(modificationDate);
    }

    const contents = this._formatContents(this.contents);

    popup.appendChild(contents);
    this.trigger.addEventListener("click", this._toggle.bind(this));
    this.trigger.addEventListener("mouseover", this._show.bind(this, false));
    this.trigger.addEventListener("mouseout", this._hide.bind(this, false));
    popup.addEventListener("click", this._hide.bind(this, true));
    wrapper.appendChild(popup);
    return wrapper;
  }

  _formatContents(contents) {
    const p = document.createElement("p");
    const lines = contents.split(/(?:\r\n?|\n)/);

    for (let i = 0, ii = lines.length; i < ii; ++i) {
      const line = lines[i];
      p.appendChild(document.createTextNode(line));

      if (i < ii - 1) {
        p.appendChild(document.createElement("br"));
      }
    }

    return p;
  }

  _toggle() {
    if (this.pinned) {
      this._hide(true);
    } else {
      this._show(true);
    }
  }

  _show(pin = false) {
    if (pin) {
      this.pinned = true;
    }

    if (this.hideElement.hasAttribute("hidden")) {
      this.hideElement.removeAttribute("hidden");
      this.container.style.zIndex += 1;
    }
  }

  _hide(unpin = true) {
    if (unpin) {
      this.pinned = false;
    }

    if (!this.hideElement.hasAttribute("hidden") && !this.pinned) {
      this.hideElement.setAttribute("hidden", true);
      this.container.style.zIndex -= 1;
    }
  }

}

class FreeTextAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "freeTextAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class LineAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "lineAnnotation";
    const data = this.data;
    const width = data.rect[2] - data.rect[0];
    const height = data.rect[3] - data.rect[1];
    const svg = this.svgFactory.create(width, height);
    const line = this.svgFactory.createElement("svg:line");
    line.setAttribute("x1", data.rect[2] - data.lineCoordinates[0]);
    line.setAttribute("y1", data.rect[3] - data.lineCoordinates[1]);
    line.setAttribute("x2", data.rect[2] - data.lineCoordinates[2]);
    line.setAttribute("y2", data.rect[3] - data.lineCoordinates[3]);
    line.setAttribute("stroke-width", data.borderStyle.width || 1);
    line.setAttribute("stroke", "transparent");
    svg.appendChild(line);
    this.container.append(svg);

    this._createPopup(this.container, line, data);

    return this.container;
  }

}

class SquareAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "squareAnnotation";
    const data = this.data;
    const width = data.rect[2] - data.rect[0];
    const height = data.rect[3] - data.rect[1];
    const svg = this.svgFactory.create(width, height);
    const borderWidth = data.borderStyle.width;
    const square = this.svgFactory.createElement("svg:rect");
    square.setAttribute("x", borderWidth / 2);
    square.setAttribute("y", borderWidth / 2);
    square.setAttribute("width", width - borderWidth);
    square.setAttribute("height", height - borderWidth);
    square.setAttribute("stroke-width", borderWidth || 1);
    square.setAttribute("stroke", "transparent");
    square.setAttribute("fill", "none");
    svg.appendChild(square);
    this.container.append(svg);

    this._createPopup(this.container, square, data);

    return this.container;
  }

}

class CircleAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "circleAnnotation";
    const data = this.data;
    const width = data.rect[2] - data.rect[0];
    const height = data.rect[3] - data.rect[1];
    const svg = this.svgFactory.create(width, height);
    const borderWidth = data.borderStyle.width;
    const circle = this.svgFactory.createElement("svg:ellipse");
    circle.setAttribute("cx", width / 2);
    circle.setAttribute("cy", height / 2);
    circle.setAttribute("rx", width / 2 - borderWidth / 2);
    circle.setAttribute("ry", height / 2 - borderWidth / 2);
    circle.setAttribute("stroke-width", borderWidth || 1);
    circle.setAttribute("stroke", "transparent");
    circle.setAttribute("fill", "none");
    svg.appendChild(circle);
    this.container.append(svg);

    this._createPopup(this.container, circle, data);

    return this.container;
  }

}

class PolylineAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
    this.containerClassName = "polylineAnnotation";
    this.svgElementName = "svg:polyline";
  }

  render() {
    this.container.className = this.containerClassName;
    const data = this.data;
    const width = data.rect[2] - data.rect[0];
    const height = data.rect[3] - data.rect[1];
    const svg = this.svgFactory.create(width, height);
    let points = [];

    for (const coordinate of data.vertices) {
      const x = coordinate.x - data.rect[0];
      const y = data.rect[3] - coordinate.y;
      points.push(x + "," + y);
    }

    points = points.join(" ");
    const polyline = this.svgFactory.createElement(this.svgElementName);
    polyline.setAttribute("points", points);
    polyline.setAttribute("stroke-width", data.borderStyle.width || 1);
    polyline.setAttribute("stroke", "transparent");
    polyline.setAttribute("fill", "none");
    svg.appendChild(polyline);
    this.container.append(svg);

    this._createPopup(this.container, polyline, data);

    return this.container;
  }

}

class PolygonAnnotationElement extends PolylineAnnotationElement {
  constructor(parameters) {
    super(parameters);
    this.containerClassName = "polygonAnnotation";
    this.svgElementName = "svg:polygon";
  }

}

class CaretAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "caretAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class InkAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
    this.containerClassName = "inkAnnotation";
    this.svgElementName = "svg:polyline";
  }

  render() {
    this.container.className = this.containerClassName;
    const data = this.data;
    const width = data.rect[2] - data.rect[0];
    const height = data.rect[3] - data.rect[1];
    const svg = this.svgFactory.create(width, height);

    for (const inkList of data.inkLists) {
      let points = [];

      for (const coordinate of inkList) {
        const x = coordinate.x - data.rect[0];
        const y = data.rect[3] - coordinate.y;
        points.push(`${x},${y}`);
      }

      points = points.join(" ");
      const polyline = this.svgFactory.createElement(this.svgElementName);
      polyline.setAttribute("points", points);
      polyline.setAttribute("stroke-width", data.borderStyle.width || 1);
      polyline.setAttribute("stroke", "transparent");
      polyline.setAttribute("fill", "none");

      this._createPopup(this.container, polyline, data);

      svg.appendChild(polyline);
    }

    this.container.append(svg);
    return this.container;
  }

}

class HighlightAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "highlightAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class UnderlineAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "underlineAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class SquigglyAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "squigglyAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class StrikeOutAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "strikeoutAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class StampAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    const isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    super(parameters, isRenderable, true);
  }

  render() {
    this.container.className = "stampAnnotation";

    if (!this.data.hasPopup) {
      this._createPopup(this.container, null, this.data);
    }

    return this.container;
  }

}

class FileAttachmentAnnotationElement extends AnnotationElement {
  constructor(parameters) {
    super(parameters, true);
    const {
      filename,
      content
    } = this.data.file;
    this.filename = (0, _display_utils.getFilenameFromUrl)(filename);
    this.content = content;

    if (this.linkService.eventBus) {
      this.linkService.eventBus.dispatch("fileattachmentannotation", {
        source: this,
        id: (0, _util.stringToPDFString)(filename),
        filename,
        content
      });
    }
  }

  render() {
    this.container.className = "fileAttachmentAnnotation";
    const trigger = document.createElement("div");
    trigger.style.height = this.container.style.height;
    trigger.style.width = this.container.style.width;
    trigger.addEventListener("dblclick", this._download.bind(this));

    if (!this.data.hasPopup && (this.data.title || this.data.contents)) {
      this._createPopup(this.container, trigger, this.data);
    }

    this.container.appendChild(trigger);
    return this.container;
  }

  _download() {
    if (!this.downloadManager) {
      (0, _util.warn)("Download cannot be started due to unavailable download manager");
      return;
    }

    this.downloadManager.downloadData(this.content, this.filename, "");
  }

}

class AnnotationLayer {
  static render(parameters) {
    const sortedAnnotations = [],
          popupAnnotations = [];

    for (const data of parameters.annotations) {
      if (!data) {
        continue;
      }

      if (data.annotationType === _util.AnnotationType.POPUP) {
        popupAnnotations.push(data);
        continue;
      }

      sortedAnnotations.push(data);
    }

    if (popupAnnotations.length) {
      sortedAnnotations.push(...popupAnnotations);
    }

    for (const data of sortedAnnotations) {
      const element = AnnotationElementFactory.create({
        data,
        layer: parameters.div,
        page: parameters.page,
        viewport: parameters.viewport,
        linkService: parameters.linkService,
        downloadManager: parameters.downloadManager,
        imageResourcesPath: parameters.imageResourcesPath || "",
        renderInteractiveForms: parameters.renderInteractiveForms || false,
        svgFactory: new _display_utils.DOMSVGFactory()
      });

      if (element.isRenderable) {
        parameters.div.appendChild(element.render());
      }
    }
  }

  static update(parameters) {
    for (const data of parameters.annotations) {
      const element = parameters.div.querySelector(`[data-annotation-id="${data.id}"]`);

      if (element) {
        element.style.transform = `matrix(${parameters.viewport.transform.join(",")})`;
      }
    }

    parameters.div.removeAttribute("hidden");
  }

}

exports.AnnotationLayer = AnnotationLayer;

/***/ }),
/* 17 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderTextLayer = void 0;

var _util = __w_pdfjs_require__(2);

var renderTextLayer = function renderTextLayerClosure() {
  var MAX_TEXT_DIVS_TO_RENDER = 100000;
  var NonWhitespaceRegexp = /\S/;

  function isAllWhitespace(str) {
    return !NonWhitespaceRegexp.test(str);
  }

  function appendText(task, geom, styles) {
    var textDiv = document.createElement("span");
    var textDivProperties = {
      angle: 0,
      canvasWidth: 0,
      isWhitespace: false,
      originalTransform: null,
      paddingBottom: 0,
      paddingLeft: 0,
      paddingRight: 0,
      paddingTop: 0,
      scale: 1
    };

    task._textDivs.push(textDiv);

    if (isAllWhitespace(geom.str)) {
      textDivProperties.isWhitespace = true;

      task._textDivProperties.set(textDiv, textDivProperties);

      return;
    }

    var tx = _util.Util.transform(task._viewport.transform, geom.transform);

    var angle = Math.atan2(tx[1], tx[0]);
    var style = styles[geom.fontName];

    if (style.vertical) {
      angle += Math.PI / 2;
    }

    var fontHeight = Math.sqrt(tx[2] * tx[2] + tx[3] * tx[3]);
    var fontAscent = fontHeight;

    if (style.ascent) {
      fontAscent = style.ascent * fontAscent;
    } else if (style.descent) {
      fontAscent = (1 + style.descent) * fontAscent;
    }

    let left, top;

    if (angle === 0) {
      left = tx[4];
      top = tx[5] - fontAscent;
    } else {
      left = tx[4] + fontAscent * Math.sin(angle);
      top = tx[5] - fontAscent * Math.cos(angle);
    }

    textDiv.style.left = `${left}px`;
    textDiv.style.top = `${top}px`;
    textDiv.style.fontSize = `${fontHeight}px`;
    textDiv.style.fontFamily = style.fontFamily;
    textDiv.textContent = geom.str;

    if (task._fontInspectorEnabled) {
      textDiv.dataset.fontName = geom.fontName;
    }

    if (angle !== 0) {
      textDivProperties.angle = angle * (180 / Math.PI);
    }

    let shouldScaleText = false;

    if (geom.str.length > 1) {
      shouldScaleText = true;
    } else if (geom.transform[0] !== geom.transform[3]) {
      const absScaleX = Math.abs(geom.transform[0]),
            absScaleY = Math.abs(geom.transform[3]);

      if (absScaleX !== absScaleY && Math.max(absScaleX, absScaleY) / Math.min(absScaleX, absScaleY) > 1.5) {
        shouldScaleText = true;
      }
    }

    if (shouldScaleText) {
      if (style.vertical) {
        textDivProperties.canvasWidth = geom.height * task._viewport.scale;
      } else {
        textDivProperties.canvasWidth = geom.width * task._viewport.scale;
      }
    }

    task._textDivProperties.set(textDiv, textDivProperties);

    if (task._textContentStream) {
      task._layoutText(textDiv);
    }

    if (task._enhanceTextSelection) {
      var angleCos = 1,
          angleSin = 0;

      if (angle !== 0) {
        angleCos = Math.cos(angle);
        angleSin = Math.sin(angle);
      }

      var divWidth = (style.vertical ? geom.height : geom.width) * task._viewport.scale;
      var divHeight = fontHeight;
      var m, b;

      if (angle !== 0) {
        m = [angleCos, angleSin, -angleSin, angleCos, left, top];
        b = _util.Util.getAxialAlignedBoundingBox([0, 0, divWidth, divHeight], m);
      } else {
        b = [left, top, left + divWidth, top + divHeight];
      }

      task._bounds.push({
        left: b[0],
        top: b[1],
        right: b[2],
        bottom: b[3],
        div: textDiv,
        size: [divWidth, divHeight],
        m
      });
    }
  }

  function render(task) {
    if (task._canceled) {
      return;
    }

    var textDivs = task._textDivs;
    var capability = task._capability;
    var textDivsLength = textDivs.length;

    if (textDivsLength > MAX_TEXT_DIVS_TO_RENDER) {
      task._renderingDone = true;
      capability.resolve();
      return;
    }

    if (!task._textContentStream) {
      for (var i = 0; i < textDivsLength; i++) {
        task._layoutText(textDivs[i]);
      }
    }

    task._renderingDone = true;
    capability.resolve();
  }

  function findPositiveMin(ts, offset, count) {
    let result = 0;

    for (let i = 0; i < count; i++) {
      const t = ts[offset++];

      if (t > 0) {
        result = result ? Math.min(t, result) : t;
      }
    }

    return result;
  }

  function expand(task) {
    var bounds = task._bounds;
    var viewport = task._viewport;
    var expanded = expandBounds(viewport.width, viewport.height, bounds);

    for (var i = 0; i < expanded.length; i++) {
      var div = bounds[i].div;

      var divProperties = task._textDivProperties.get(div);

      if (divProperties.angle === 0) {
        divProperties.paddingLeft = bounds[i].left - expanded[i].left;
        divProperties.paddingTop = bounds[i].top - expanded[i].top;
        divProperties.paddingRight = expanded[i].right - bounds[i].right;
        divProperties.paddingBottom = expanded[i].bottom - bounds[i].bottom;

        task._textDivProperties.set(div, divProperties);

        continue;
      }

      var e = expanded[i],
          b = bounds[i];
      var m = b.m,
          c = m[0],
          s = m[1];
      var points = [[0, 0], [0, b.size[1]], [b.size[0], 0], b.size];
      var ts = new Float64Array(64);
      points.forEach(function (p, j) {
        var t = _util.Util.applyTransform(p, m);

        ts[j + 0] = c && (e.left - t[0]) / c;
        ts[j + 4] = s && (e.top - t[1]) / s;
        ts[j + 8] = c && (e.right - t[0]) / c;
        ts[j + 12] = s && (e.bottom - t[1]) / s;
        ts[j + 16] = s && (e.left - t[0]) / -s;
        ts[j + 20] = c && (e.top - t[1]) / c;
        ts[j + 24] = s && (e.right - t[0]) / -s;
        ts[j + 28] = c && (e.bottom - t[1]) / c;
        ts[j + 32] = c && (e.left - t[0]) / -c;
        ts[j + 36] = s && (e.top - t[1]) / -s;
        ts[j + 40] = c && (e.right - t[0]) / -c;
        ts[j + 44] = s && (e.bottom - t[1]) / -s;
        ts[j + 48] = s && (e.left - t[0]) / s;
        ts[j + 52] = c && (e.top - t[1]) / -c;
        ts[j + 56] = s && (e.right - t[0]) / s;
        ts[j + 60] = c && (e.bottom - t[1]) / -c;
      });
      var boxScale = 1 + Math.min(Math.abs(c), Math.abs(s));
      divProperties.paddingLeft = findPositiveMin(ts, 32, 16) / boxScale;
      divProperties.paddingTop = findPositiveMin(ts, 48, 16) / boxScale;
      divProperties.paddingRight = findPositiveMin(ts, 0, 16) / boxScale;
      divProperties.paddingBottom = findPositiveMin(ts, 16, 16) / boxScale;

      task._textDivProperties.set(div, divProperties);
    }
  }

  function expandBounds(width, height, boxes) {
    var bounds = boxes.map(function (box, i) {
      return {
        x1: box.left,
        y1: box.top,
        x2: box.right,
        y2: box.bottom,
        index: i,
        x1New: undefined,
        x2New: undefined
      };
    });
    expandBoundsLTR(width, bounds);
    var expanded = new Array(boxes.length);
    bounds.forEach(function (b) {
      var i = b.index;
      expanded[i] = {
        left: b.x1New,
        top: 0,
        right: b.x2New,
        bottom: 0
      };
    });
    boxes.map(function (box, i) {
      var e = expanded[i],
          b = bounds[i];
      b.x1 = box.top;
      b.y1 = width - e.right;
      b.x2 = box.bottom;
      b.y2 = width - e.left;
      b.index = i;
      b.x1New = undefined;
      b.x2New = undefined;
    });
    expandBoundsLTR(height, bounds);
    bounds.forEach(function (b) {
      var i = b.index;
      expanded[i].top = b.x1New;
      expanded[i].bottom = b.x2New;
    });
    return expanded;
  }

  function expandBoundsLTR(width, bounds) {
    bounds.sort(function (a, b) {
      return a.x1 - b.x1 || a.index - b.index;
    });
    var fakeBoundary = {
      x1: -Infinity,
      y1: -Infinity,
      x2: 0,
      y2: Infinity,
      index: -1,
      x1New: 0,
      x2New: 0
    };
    var horizon = [{
      start: -Infinity,
      end: Infinity,
      boundary: fakeBoundary
    }];
    bounds.forEach(function (boundary) {
      var i = 0;

      while (i < horizon.length && horizon[i].end <= boundary.y1) {
        i++;
      }

      var j = horizon.length - 1;

      while (j >= 0 && horizon[j].start >= boundary.y2) {
        j--;
      }

      var horizonPart, affectedBoundary;
      var q,
          k,
          maxXNew = -Infinity;

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;
        var xNew;

        if (affectedBoundary.x2 > boundary.x1) {
          xNew = affectedBoundary.index > boundary.index ? affectedBoundary.x1New : boundary.x1;
        } else if (affectedBoundary.x2New === undefined) {
          xNew = (affectedBoundary.x2 + boundary.x1) / 2;
        } else {
          xNew = affectedBoundary.x2New;
        }

        if (xNew > maxXNew) {
          maxXNew = xNew;
        }
      }

      boundary.x1New = maxXNew;

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;

        if (affectedBoundary.x2New === undefined) {
          if (affectedBoundary.x2 > boundary.x1) {
            if (affectedBoundary.index > boundary.index) {
              affectedBoundary.x2New = affectedBoundary.x2;
            }
          } else {
            affectedBoundary.x2New = maxXNew;
          }
        } else if (affectedBoundary.x2New > maxXNew) {
          affectedBoundary.x2New = Math.max(maxXNew, affectedBoundary.x2);
        }
      }

      var changedHorizon = [],
          lastBoundary = null;

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;
        var useBoundary = affectedBoundary.x2 > boundary.x2 ? affectedBoundary : boundary;

        if (lastBoundary === useBoundary) {
          changedHorizon[changedHorizon.length - 1].end = horizonPart.end;
        } else {
          changedHorizon.push({
            start: horizonPart.start,
            end: horizonPart.end,
            boundary: useBoundary
          });
          lastBoundary = useBoundary;
        }
      }

      if (horizon[i].start < boundary.y1) {
        changedHorizon[0].start = boundary.y1;
        changedHorizon.unshift({
          start: horizon[i].start,
          end: boundary.y1,
          boundary: horizon[i].boundary
        });
      }

      if (boundary.y2 < horizon[j].end) {
        changedHorizon[changedHorizon.length - 1].end = boundary.y2;
        changedHorizon.push({
          start: boundary.y2,
          end: horizon[j].end,
          boundary: horizon[j].boundary
        });
      }

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;

        if (affectedBoundary.x2New !== undefined) {
          continue;
        }

        var used = false;

        for (k = i - 1; !used && k >= 0 && horizon[k].start >= affectedBoundary.y1; k--) {
          used = horizon[k].boundary === affectedBoundary;
        }

        for (k = j + 1; !used && k < horizon.length && horizon[k].end <= affectedBoundary.y2; k++) {
          used = horizon[k].boundary === affectedBoundary;
        }

        for (k = 0; !used && k < changedHorizon.length; k++) {
          used = changedHorizon[k].boundary === affectedBoundary;
        }

        if (!used) {
          affectedBoundary.x2New = maxXNew;
        }
      }

      Array.prototype.splice.apply(horizon, [i, j - i + 1].concat(changedHorizon));
    });
    horizon.forEach(function (horizonPart) {
      var affectedBoundary = horizonPart.boundary;

      if (affectedBoundary.x2New === undefined) {
        affectedBoundary.x2New = Math.max(width, affectedBoundary.x2);
      }
    });
  }

  function TextLayerRenderTask({
    textContent,
    textContentStream,
    container,
    viewport,
    textDivs,
    textContentItemsStr,
    enhanceTextSelection
  }) {
    this._textContent = textContent;
    this._textContentStream = textContentStream;
    this._container = container;
    this._viewport = viewport;
    this._textDivs = textDivs || [];
    this._textContentItemsStr = textContentItemsStr || [];
    this._enhanceTextSelection = !!enhanceTextSelection;
    this._fontInspectorEnabled = !!(globalThis.FontInspector && globalThis.FontInspector.enabled);
    this._reader = null;
    this._layoutTextLastFontSize = null;
    this._layoutTextLastFontFamily = null;
    this._layoutTextCtx = null;
    this._textDivProperties = new WeakMap();
    this._renderingDone = false;
    this._canceled = false;
    this._capability = (0, _util.createPromiseCapability)();
    this._renderTimer = null;
    this._bounds = [];

    this._capability.promise.finally(() => {
      if (this._layoutTextCtx) {
        this._layoutTextCtx.canvas.width = 0;
        this._layoutTextCtx.canvas.height = 0;
        this._layoutTextCtx = null;
      }
    }).catch(() => {});
  }

  TextLayerRenderTask.prototype = {
    get promise() {
      return this._capability.promise;
    },

    cancel: function TextLayer_cancel() {
      this._canceled = true;

      if (this._reader) {
        this._reader.cancel(new _util.AbortException("TextLayer task cancelled."));

        this._reader = null;
      }

      if (this._renderTimer !== null) {
        clearTimeout(this._renderTimer);
        this._renderTimer = null;
      }

      this._capability.reject(new Error("TextLayer task cancelled."));
    },

    _processItems(items, styleCache) {
      for (let i = 0, len = items.length; i < len; i++) {
        this._textContentItemsStr.push(items[i].str);

        appendText(this, items[i], styleCache);
      }
    },

    _layoutText(textDiv) {
      const textDivProperties = this._textDivProperties.get(textDiv);

      if (textDivProperties.isWhitespace) {
        return;
      }

      let transform = "";

      if (textDivProperties.canvasWidth !== 0) {
        const {
          fontSize,
          fontFamily
        } = textDiv.style;

        if (fontSize !== this._layoutTextLastFontSize || fontFamily !== this._layoutTextLastFontFamily) {
          this._layoutTextCtx.font = `${fontSize} ${fontFamily}`;
          this._layoutTextLastFontSize = fontSize;
          this._layoutTextLastFontFamily = fontFamily;
        }

        const {
          width
        } = this._layoutTextCtx.measureText(textDiv.textContent);

        if (width > 0) {
          textDivProperties.scale = textDivProperties.canvasWidth / width;
          transform = `scaleX(${textDivProperties.scale})`;
        }
      }

      if (textDivProperties.angle !== 0) {
        transform = `rotate(${textDivProperties.angle}deg) ${transform}`;
      }

      if (transform.length > 0) {
        if (this._enhanceTextSelection) {
          textDivProperties.originalTransform = transform;
        }

        textDiv.style.transform = transform;
      }

      this._textDivProperties.set(textDiv, textDivProperties);

      this._container.appendChild(textDiv);
    },

    _render: function TextLayer_render(timeout) {
      const capability = (0, _util.createPromiseCapability)();
      let styleCache = Object.create(null);
      const canvas = document.createElement("canvas");
      canvas.mozOpaque = true;
      this._layoutTextCtx = canvas.getContext("2d", {
        alpha: false
      });

      if (this._textContent) {
        const textItems = this._textContent.items;
        const textStyles = this._textContent.styles;

        this._processItems(textItems, textStyles);

        capability.resolve();
      } else if (this._textContentStream) {
        const pump = () => {
          this._reader.read().then(({
            value,
            done
          }) => {
            if (done) {
              capability.resolve();
              return;
            }

            Object.assign(styleCache, value.styles);

            this._processItems(value.items, styleCache);

            pump();
          }, capability.reject);
        };

        this._reader = this._textContentStream.getReader();
        pump();
      } else {
        throw new Error('Neither "textContent" nor "textContentStream"' + " parameters specified.");
      }

      capability.promise.then(() => {
        styleCache = null;

        if (!timeout) {
          render(this);
        } else {
          this._renderTimer = setTimeout(() => {
            render(this);
            this._renderTimer = null;
          }, timeout);
        }
      }, this._capability.reject);
    },
    expandTextDivs: function TextLayer_expandTextDivs(expandDivs) {
      if (!this._enhanceTextSelection || !this._renderingDone) {
        return;
      }

      if (this._bounds !== null) {
        expand(this);
        this._bounds = null;
      }

      const transformBuf = [],
            paddingBuf = [];

      for (var i = 0, ii = this._textDivs.length; i < ii; i++) {
        const div = this._textDivs[i];

        const divProps = this._textDivProperties.get(div);

        if (divProps.isWhitespace) {
          continue;
        }

        if (expandDivs) {
          transformBuf.length = 0;
          paddingBuf.length = 0;

          if (divProps.originalTransform) {
            transformBuf.push(divProps.originalTransform);
          }

          if (divProps.paddingTop > 0) {
            paddingBuf.push(`${divProps.paddingTop}px`);
            transformBuf.push(`translateY(${-divProps.paddingTop}px)`);
          } else {
            paddingBuf.push(0);
          }

          if (divProps.paddingRight > 0) {
            paddingBuf.push(`${divProps.paddingRight / divProps.scale}px`);
          } else {
            paddingBuf.push(0);
          }

          if (divProps.paddingBottom > 0) {
            paddingBuf.push(`${divProps.paddingBottom}px`);
          } else {
            paddingBuf.push(0);
          }

          if (divProps.paddingLeft > 0) {
            paddingBuf.push(`${divProps.paddingLeft / divProps.scale}px`);
            transformBuf.push(`translateX(${-divProps.paddingLeft / divProps.scale}px)`);
          } else {
            paddingBuf.push(0);
          }

          div.style.padding = paddingBuf.join(" ");

          if (transformBuf.length) {
            div.style.transform = transformBuf.join(" ");
          }
        } else {
          div.style.padding = null;
          div.style.transform = divProps.originalTransform;
        }
      }
    }
  };

  function renderTextLayer(renderParameters) {
    var task = new TextLayerRenderTask({
      textContent: renderParameters.textContent,
      textContentStream: renderParameters.textContentStream,
      container: renderParameters.container,
      viewport: renderParameters.viewport,
      textDivs: renderParameters.textDivs,
      textContentItemsStr: renderParameters.textContentItemsStr,
      enhanceTextSelection: renderParameters.enhanceTextSelection
    });

    task._render(renderParameters.timeout);

    return task;
  }

  return renderTextLayer;
}();

exports.renderTextLayer = renderTextLayer;

/***/ }),
/* 18 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SVGGraphics = void 0;

var _util = __w_pdfjs_require__(2);

var _display_utils = __w_pdfjs_require__(1);

var _is_node = __w_pdfjs_require__(4);

let SVGGraphics = function () {
  throw new Error("Not implemented: SVGGraphics");
};

exports.SVGGraphics = SVGGraphics;
{
  const SVG_DEFAULTS = {
    fontStyle: "normal",
    fontWeight: "normal",
    fillColor: "#000000"
  };
  const XML_NS = "http://www.w3.org/XML/1998/namespace";
  const XLINK_NS = "http://www.w3.org/1999/xlink";
  const LINE_CAP_STYLES = ["butt", "round", "square"];
  const LINE_JOIN_STYLES = ["miter", "round", "bevel"];

  const convertImgDataToPng = function () {
    const PNG_HEADER = new Uint8Array([0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a]);
    const CHUNK_WRAPPER_SIZE = 12;
    const crcTable = new Int32Array(256);

    for (let i = 0; i < 256; i++) {
      let c = i;

      for (let h = 0; h < 8; h++) {
        if (c & 1) {
          c = 0xedb88320 ^ c >> 1 & 0x7fffffff;
        } else {
          c = c >> 1 & 0x7fffffff;
        }
      }

      crcTable[i] = c;
    }

    function crc32(data, start, end) {
      let crc = -1;

      for (let i = start; i < end; i++) {
        const a = (crc ^ data[i]) & 0xff;
        const b = crcTable[a];
        crc = crc >>> 8 ^ b;
      }

      return crc ^ -1;
    }

    function writePngChunk(type, body, data, offset) {
      let p = offset;
      const len = body.length;
      data[p] = len >> 24 & 0xff;
      data[p + 1] = len >> 16 & 0xff;
      data[p + 2] = len >> 8 & 0xff;
      data[p + 3] = len & 0xff;
      p += 4;
      data[p] = type.charCodeAt(0) & 0xff;
      data[p + 1] = type.charCodeAt(1) & 0xff;
      data[p + 2] = type.charCodeAt(2) & 0xff;
      data[p + 3] = type.charCodeAt(3) & 0xff;
      p += 4;
      data.set(body, p);
      p += body.length;
      const crc = crc32(data, offset + 4, p);
      data[p] = crc >> 24 & 0xff;
      data[p + 1] = crc >> 16 & 0xff;
      data[p + 2] = crc >> 8 & 0xff;
      data[p + 3] = crc & 0xff;
    }

    function adler32(data, start, end) {
      let a = 1;
      let b = 0;

      for (let i = start; i < end; ++i) {
        a = (a + (data[i] & 0xff)) % 65521;
        b = (b + a) % 65521;
      }

      return b << 16 | a;
    }

    function deflateSync(literals) {
      if (!_is_node.isNodeJS) {
        return deflateSyncUncompressed(literals);
      }

      try {
        let input;

        if (parseInt(process$1.versions.node) >= 8) {
          input = literals;
        } else {
          input = Buffer.from(literals);
        }

        const output = require$$4.deflateSync(input, {
          level: 9
        });

        return output instanceof Uint8Array ? output : new Uint8Array(output);
      } catch (e) {
        (0, _util.warn)("Not compressing PNG because zlib.deflateSync is unavailable: " + e);
      }

      return deflateSyncUncompressed(literals);
    }

    function deflateSyncUncompressed(literals) {
      let len = literals.length;
      const maxBlockLength = 0xffff;
      const deflateBlocks = Math.ceil(len / maxBlockLength);
      const idat = new Uint8Array(2 + len + deflateBlocks * 5 + 4);
      let pi = 0;
      idat[pi++] = 0x78;
      idat[pi++] = 0x9c;
      let pos = 0;

      while (len > maxBlockLength) {
        idat[pi++] = 0x00;
        idat[pi++] = 0xff;
        idat[pi++] = 0xff;
        idat[pi++] = 0x00;
        idat[pi++] = 0x00;
        idat.set(literals.subarray(pos, pos + maxBlockLength), pi);
        pi += maxBlockLength;
        pos += maxBlockLength;
        len -= maxBlockLength;
      }

      idat[pi++] = 0x01;
      idat[pi++] = len & 0xff;
      idat[pi++] = len >> 8 & 0xff;
      idat[pi++] = ~len & 0xffff & 0xff;
      idat[pi++] = (~len & 0xffff) >> 8 & 0xff;
      idat.set(literals.subarray(pos), pi);
      pi += literals.length - pos;
      const adler = adler32(literals, 0, literals.length);
      idat[pi++] = adler >> 24 & 0xff;
      idat[pi++] = adler >> 16 & 0xff;
      idat[pi++] = adler >> 8 & 0xff;
      idat[pi++] = adler & 0xff;
      return idat;
    }

    function encode(imgData, kind, forceDataSchema, isMask) {
      const width = imgData.width;
      const height = imgData.height;
      let bitDepth, colorType, lineSize;
      const bytes = imgData.data;

      switch (kind) {
        case _util.ImageKind.GRAYSCALE_1BPP:
          colorType = 0;
          bitDepth = 1;
          lineSize = width + 7 >> 3;
          break;

        case _util.ImageKind.RGB_24BPP:
          colorType = 2;
          bitDepth = 8;
          lineSize = width * 3;
          break;

        case _util.ImageKind.RGBA_32BPP:
          colorType = 6;
          bitDepth = 8;
          lineSize = width * 4;
          break;

        default:
          throw new Error("invalid format");
      }

      const literals = new Uint8Array((1 + lineSize) * height);
      let offsetLiterals = 0,
          offsetBytes = 0;

      for (let y = 0; y < height; ++y) {
        literals[offsetLiterals++] = 0;
        literals.set(bytes.subarray(offsetBytes, offsetBytes + lineSize), offsetLiterals);
        offsetBytes += lineSize;
        offsetLiterals += lineSize;
      }

      if (kind === _util.ImageKind.GRAYSCALE_1BPP && isMask) {
        offsetLiterals = 0;

        for (let y = 0; y < height; y++) {
          offsetLiterals++;

          for (let i = 0; i < lineSize; i++) {
            literals[offsetLiterals++] ^= 0xff;
          }
        }
      }

      const ihdr = new Uint8Array([width >> 24 & 0xff, width >> 16 & 0xff, width >> 8 & 0xff, width & 0xff, height >> 24 & 0xff, height >> 16 & 0xff, height >> 8 & 0xff, height & 0xff, bitDepth, colorType, 0x00, 0x00, 0x00]);
      const idat = deflateSync(literals);
      const pngLength = PNG_HEADER.length + CHUNK_WRAPPER_SIZE * 3 + ihdr.length + idat.length;
      const data = new Uint8Array(pngLength);
      let offset = 0;
      data.set(PNG_HEADER, offset);
      offset += PNG_HEADER.length;
      writePngChunk("IHDR", ihdr, data, offset);
      offset += CHUNK_WRAPPER_SIZE + ihdr.length;
      writePngChunk("IDATA", idat, data, offset);
      offset += CHUNK_WRAPPER_SIZE + idat.length;
      writePngChunk("IEND", new Uint8Array(0), data, offset);
      return (0, _util.createObjectURL)(data, "image/png", forceDataSchema);
    }

    return function convertImgDataToPng(imgData, forceDataSchema, isMask) {
      const kind = imgData.kind === undefined ? _util.ImageKind.GRAYSCALE_1BPP : imgData.kind;
      return encode(imgData, kind, forceDataSchema, isMask);
    };
  }();

  class SVGExtraState {
    constructor() {
      this.fontSizeScale = 1;
      this.fontWeight = SVG_DEFAULTS.fontWeight;
      this.fontSize = 0;
      this.textMatrix = _util.IDENTITY_MATRIX;
      this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
      this.leading = 0;
      this.textRenderingMode = _util.TextRenderingMode.FILL;
      this.textMatrixScale = 1;
      this.x = 0;
      this.y = 0;
      this.lineX = 0;
      this.lineY = 0;
      this.charSpacing = 0;
      this.wordSpacing = 0;
      this.textHScale = 1;
      this.textRise = 0;
      this.fillColor = SVG_DEFAULTS.fillColor;
      this.strokeColor = "#000000";
      this.fillAlpha = 1;
      this.strokeAlpha = 1;
      this.lineWidth = 1;
      this.lineJoin = "";
      this.lineCap = "";
      this.miterLimit = 0;
      this.dashArray = [];
      this.dashPhase = 0;
      this.dependencies = [];
      this.activeClipUrl = null;
      this.clipGroup = null;
      this.maskId = "";
    }

    clone() {
      return Object.create(this);
    }

    setCurrentPoint(x, y) {
      this.x = x;
      this.y = y;
    }

  }

  function opListToTree(opList) {
    let opTree = [];
    const tmp = [];

    for (const opListElement of opList) {
      if (opListElement.fn === "save") {
        opTree.push({
          fnId: 92,
          fn: "group",
          items: []
        });
        tmp.push(opTree);
        opTree = opTree[opTree.length - 1].items;
        continue;
      }

      if (opListElement.fn === "restore") {
        opTree = tmp.pop();
      } else {
        opTree.push(opListElement);
      }
    }

    return opTree;
  }

  function pf(value) {
    if (Number.isInteger(value)) {
      return value.toString();
    }

    const s = value.toFixed(10);
    let i = s.length - 1;

    if (s[i] !== "0") {
      return s;
    }

    do {
      i--;
    } while (s[i] === "0");

    return s.substring(0, s[i] === "." ? i : i + 1);
  }

  function pm(m) {
    if (m[4] === 0 && m[5] === 0) {
      if (m[1] === 0 && m[2] === 0) {
        if (m[0] === 1 && m[3] === 1) {
          return "";
        }

        return `scale(${pf(m[0])} ${pf(m[3])})`;
      }

      if (m[0] === m[3] && m[1] === -m[2]) {
        const a = Math.acos(m[0]) * 180 / Math.PI;
        return `rotate(${pf(a)})`;
      }
    } else {
      if (m[0] === 1 && m[1] === 0 && m[2] === 0 && m[3] === 1) {
        return `translate(${pf(m[4])} ${pf(m[5])})`;
      }
    }

    return `matrix(${pf(m[0])} ${pf(m[1])} ${pf(m[2])} ${pf(m[3])} ${pf(m[4])} ` + `${pf(m[5])})`;
  }

  let clipCount = 0;
  let maskCount = 0;
  let shadingCount = 0;
  exports.SVGGraphics = SVGGraphics = class SVGGraphics {
    constructor(commonObjs, objs, forceDataSchema = false) {
      this.svgFactory = new _display_utils.DOMSVGFactory();
      this.current = new SVGExtraState();
      this.transformMatrix = _util.IDENTITY_MATRIX;
      this.transformStack = [];
      this.extraStack = [];
      this.commonObjs = commonObjs;
      this.objs = objs;
      this.pendingClip = null;
      this.pendingEOFill = false;
      this.embedFonts = false;
      this.embeddedFonts = Object.create(null);
      this.cssStyle = null;
      this.forceDataSchema = !!forceDataSchema;
      this._operatorIdMapping = [];

      for (const op in _util.OPS) {
        this._operatorIdMapping[_util.OPS[op]] = op;
      }
    }

    save() {
      this.transformStack.push(this.transformMatrix);
      const old = this.current;
      this.extraStack.push(old);
      this.current = old.clone();
    }

    restore() {
      this.transformMatrix = this.transformStack.pop();
      this.current = this.extraStack.pop();
      this.pendingClip = null;
      this.tgrp = null;
    }

    group(items) {
      this.save();
      this.executeOpTree(items);
      this.restore();
    }

    loadDependencies(operatorList) {
      const fnArray = operatorList.fnArray;
      const argsArray = operatorList.argsArray;

      for (let i = 0, ii = fnArray.length; i < ii; i++) {
        if (fnArray[i] !== _util.OPS.dependency) {
          continue;
        }

        for (const obj of argsArray[i]) {
          const objsPool = obj.startsWith("g_") ? this.commonObjs : this.objs;
          const promise = new Promise(resolve => {
            objsPool.get(obj, resolve);
          });
          this.current.dependencies.push(promise);
        }
      }

      return Promise.all(this.current.dependencies);
    }

    transform(a, b, c, d, e, f) {
      const transformMatrix = [a, b, c, d, e, f];
      this.transformMatrix = _util.Util.transform(this.transformMatrix, transformMatrix);
      this.tgrp = null;
    }

    getSVG(operatorList, viewport) {
      this.viewport = viewport;

      const svgElement = this._initialize(viewport);

      return this.loadDependencies(operatorList).then(() => {
        this.transformMatrix = _util.IDENTITY_MATRIX;
        this.executeOpTree(this.convertOpList(operatorList));
        return svgElement;
      });
    }

    convertOpList(operatorList) {
      const operatorIdMapping = this._operatorIdMapping;
      const argsArray = operatorList.argsArray;
      const fnArray = operatorList.fnArray;
      const opList = [];

      for (let i = 0, ii = fnArray.length; i < ii; i++) {
        const fnId = fnArray[i];
        opList.push({
          fnId,
          fn: operatorIdMapping[fnId],
          args: argsArray[i]
        });
      }

      return opListToTree(opList);
    }

    executeOpTree(opTree) {
      for (const opTreeElement of opTree) {
        const fn = opTreeElement.fn;
        const fnId = opTreeElement.fnId;
        const args = opTreeElement.args;

        switch (fnId | 0) {
          case _util.OPS.beginText:
            this.beginText();
            break;

          case _util.OPS.dependency:
            break;

          case _util.OPS.setLeading:
            this.setLeading(args);
            break;

          case _util.OPS.setLeadingMoveText:
            this.setLeadingMoveText(args[0], args[1]);
            break;

          case _util.OPS.setFont:
            this.setFont(args);
            break;

          case _util.OPS.showText:
            this.showText(args[0]);
            break;

          case _util.OPS.showSpacedText:
            this.showText(args[0]);
            break;

          case _util.OPS.endText:
            this.endText();
            break;

          case _util.OPS.moveText:
            this.moveText(args[0], args[1]);
            break;

          case _util.OPS.setCharSpacing:
            this.setCharSpacing(args[0]);
            break;

          case _util.OPS.setWordSpacing:
            this.setWordSpacing(args[0]);
            break;

          case _util.OPS.setHScale:
            this.setHScale(args[0]);
            break;

          case _util.OPS.setTextMatrix:
            this.setTextMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
            break;

          case _util.OPS.setTextRise:
            this.setTextRise(args[0]);
            break;

          case _util.OPS.setTextRenderingMode:
            this.setTextRenderingMode(args[0]);
            break;

          case _util.OPS.setLineWidth:
            this.setLineWidth(args[0]);
            break;

          case _util.OPS.setLineJoin:
            this.setLineJoin(args[0]);
            break;

          case _util.OPS.setLineCap:
            this.setLineCap(args[0]);
            break;

          case _util.OPS.setMiterLimit:
            this.setMiterLimit(args[0]);
            break;

          case _util.OPS.setFillRGBColor:
            this.setFillRGBColor(args[0], args[1], args[2]);
            break;

          case _util.OPS.setStrokeRGBColor:
            this.setStrokeRGBColor(args[0], args[1], args[2]);
            break;

          case _util.OPS.setStrokeColorN:
            this.setStrokeColorN(args);
            break;

          case _util.OPS.setFillColorN:
            this.setFillColorN(args);
            break;

          case _util.OPS.shadingFill:
            this.shadingFill(args[0]);
            break;

          case _util.OPS.setDash:
            this.setDash(args[0], args[1]);
            break;

          case _util.OPS.setRenderingIntent:
            this.setRenderingIntent(args[0]);
            break;

          case _util.OPS.setFlatness:
            this.setFlatness(args[0]);
            break;

          case _util.OPS.setGState:
            this.setGState(args[0]);
            break;

          case _util.OPS.fill:
            this.fill();
            break;

          case _util.OPS.eoFill:
            this.eoFill();
            break;

          case _util.OPS.stroke:
            this.stroke();
            break;

          case _util.OPS.fillStroke:
            this.fillStroke();
            break;

          case _util.OPS.eoFillStroke:
            this.eoFillStroke();
            break;

          case _util.OPS.clip:
            this.clip("nonzero");
            break;

          case _util.OPS.eoClip:
            this.clip("evenodd");
            break;

          case _util.OPS.paintSolidColorImageMask:
            this.paintSolidColorImageMask();
            break;

          case _util.OPS.paintImageXObject:
            this.paintImageXObject(args[0]);
            break;

          case _util.OPS.paintInlineImageXObject:
            this.paintInlineImageXObject(args[0]);
            break;

          case _util.OPS.paintImageMaskXObject:
            this.paintImageMaskXObject(args[0]);
            break;

          case _util.OPS.paintFormXObjectBegin:
            this.paintFormXObjectBegin(args[0], args[1]);
            break;

          case _util.OPS.paintFormXObjectEnd:
            this.paintFormXObjectEnd();
            break;

          case _util.OPS.closePath:
            this.closePath();
            break;

          case _util.OPS.closeStroke:
            this.closeStroke();
            break;

          case _util.OPS.closeFillStroke:
            this.closeFillStroke();
            break;

          case _util.OPS.closeEOFillStroke:
            this.closeEOFillStroke();
            break;

          case _util.OPS.nextLine:
            this.nextLine();
            break;

          case _util.OPS.transform:
            this.transform(args[0], args[1], args[2], args[3], args[4], args[5]);
            break;

          case _util.OPS.constructPath:
            this.constructPath(args[0], args[1]);
            break;

          case _util.OPS.endPath:
            this.endPath();
            break;

          case 92:
            this.group(opTreeElement.items);
            break;

          default:
            (0, _util.warn)(`Unimplemented operator ${fn}`);
            break;
        }
      }
    }

    setWordSpacing(wordSpacing) {
      this.current.wordSpacing = wordSpacing;
    }

    setCharSpacing(charSpacing) {
      this.current.charSpacing = charSpacing;
    }

    nextLine() {
      this.moveText(0, this.current.leading);
    }

    setTextMatrix(a, b, c, d, e, f) {
      const current = this.current;
      current.textMatrix = current.lineMatrix = [a, b, c, d, e, f];
      current.textMatrixScale = Math.sqrt(a * a + b * b);
      current.x = current.lineX = 0;
      current.y = current.lineY = 0;
      current.xcoords = [];
      current.ycoords = [];
      current.tspan = this.svgFactory.createElement("svg:tspan");
      current.tspan.setAttributeNS(null, "font-family", current.fontFamily);
      current.tspan.setAttributeNS(null, "font-size", `${pf(current.fontSize)}px`);
      current.tspan.setAttributeNS(null, "y", pf(-current.y));
      current.txtElement = this.svgFactory.createElement("svg:text");
      current.txtElement.appendChild(current.tspan);
    }

    beginText() {
      const current = this.current;
      current.x = current.lineX = 0;
      current.y = current.lineY = 0;
      current.textMatrix = _util.IDENTITY_MATRIX;
      current.lineMatrix = _util.IDENTITY_MATRIX;
      current.textMatrixScale = 1;
      current.tspan = this.svgFactory.createElement("svg:tspan");
      current.txtElement = this.svgFactory.createElement("svg:text");
      current.txtgrp = this.svgFactory.createElement("svg:g");
      current.xcoords = [];
      current.ycoords = [];
    }

    moveText(x, y) {
      const current = this.current;
      current.x = current.lineX += x;
      current.y = current.lineY += y;
      current.xcoords = [];
      current.ycoords = [];
      current.tspan = this.svgFactory.createElement("svg:tspan");
      current.tspan.setAttributeNS(null, "font-family", current.fontFamily);
      current.tspan.setAttributeNS(null, "font-size", `${pf(current.fontSize)}px`);
      current.tspan.setAttributeNS(null, "y", pf(-current.y));
    }

    showText(glyphs) {
      const current = this.current;
      const font = current.font;
      const fontSize = current.fontSize;

      if (fontSize === 0) {
        return;
      }

      const fontSizeScale = current.fontSizeScale;
      const charSpacing = current.charSpacing;
      const wordSpacing = current.wordSpacing;
      const fontDirection = current.fontDirection;
      const textHScale = current.textHScale * fontDirection;
      const vertical = font.vertical;
      const spacingDir = vertical ? 1 : -1;
      const defaultVMetrics = font.defaultVMetrics;
      const widthAdvanceScale = fontSize * current.fontMatrix[0];
      let x = 0;

      for (const glyph of glyphs) {
        if (glyph === null) {
          x += fontDirection * wordSpacing;
          continue;
        } else if ((0, _util.isNum)(glyph)) {
          x += spacingDir * glyph * fontSize / 1000;
          continue;
        }

        const spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
        const character = glyph.fontChar;
        let scaledX, scaledY;
        let width = glyph.width;

        if (vertical) {
          let vx;
          const vmetric = glyph.vmetric || defaultVMetrics;
          vx = glyph.vmetric ? vmetric[1] : width * 0.5;
          vx = -vx * widthAdvanceScale;
          const vy = vmetric[2] * widthAdvanceScale;
          width = vmetric ? -vmetric[0] : width;
          scaledX = vx / fontSizeScale;
          scaledY = (x + vy) / fontSizeScale;
        } else {
          scaledX = x / fontSizeScale;
          scaledY = 0;
        }

        if (glyph.isInFont || font.missingFile) {
          current.xcoords.push(current.x + scaledX);

          if (vertical) {
            current.ycoords.push(-current.y + scaledY);
          }

          current.tspan.textContent += character;
        }

        let charWidth;

        if (vertical) {
          charWidth = width * widthAdvanceScale - spacing * fontDirection;
        } else {
          charWidth = width * widthAdvanceScale + spacing * fontDirection;
        }

        x += charWidth;
      }

      current.tspan.setAttributeNS(null, "x", current.xcoords.map(pf).join(" "));

      if (vertical) {
        current.tspan.setAttributeNS(null, "y", current.ycoords.map(pf).join(" "));
      } else {
        current.tspan.setAttributeNS(null, "y", pf(-current.y));
      }

      if (vertical) {
        current.y -= x;
      } else {
        current.x += x * textHScale;
      }

      current.tspan.setAttributeNS(null, "font-family", current.fontFamily);
      current.tspan.setAttributeNS(null, "font-size", `${pf(current.fontSize)}px`);

      if (current.fontStyle !== SVG_DEFAULTS.fontStyle) {
        current.tspan.setAttributeNS(null, "font-style", current.fontStyle);
      }

      if (current.fontWeight !== SVG_DEFAULTS.fontWeight) {
        current.tspan.setAttributeNS(null, "font-weight", current.fontWeight);
      }

      const fillStrokeMode = current.textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;

      if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
        if (current.fillColor !== SVG_DEFAULTS.fillColor) {
          current.tspan.setAttributeNS(null, "fill", current.fillColor);
        }

        if (current.fillAlpha < 1) {
          current.tspan.setAttributeNS(null, "fill-opacity", current.fillAlpha);
        }
      } else if (current.textRenderingMode === _util.TextRenderingMode.ADD_TO_PATH) {
        current.tspan.setAttributeNS(null, "fill", "transparent");
      } else {
        current.tspan.setAttributeNS(null, "fill", "none");
      }

      if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
        const lineWidthScale = 1 / (current.textMatrixScale || 1);

        this._setStrokeAttributes(current.tspan, lineWidthScale);
      }

      let textMatrix = current.textMatrix;

      if (current.textRise !== 0) {
        textMatrix = textMatrix.slice();
        textMatrix[5] += current.textRise;
      }

      current.txtElement.setAttributeNS(null, "transform", `${pm(textMatrix)} scale(${pf(textHScale)}, -1)`);
      current.txtElement.setAttributeNS(XML_NS, "xml:space", "preserve");
      current.txtElement.appendChild(current.tspan);
      current.txtgrp.appendChild(current.txtElement);

      this._ensureTransformGroup().appendChild(current.txtElement);
    }

    setLeadingMoveText(x, y) {
      this.setLeading(-y);
      this.moveText(x, y);
    }

    addFontStyle(fontObj) {
      if (!fontObj.data) {
        throw new Error("addFontStyle: No font data available, " + 'ensure that the "fontExtraProperties" API parameter is set.');
      }

      if (!this.cssStyle) {
        this.cssStyle = this.svgFactory.createElement("svg:style");
        this.cssStyle.setAttributeNS(null, "type", "text/css");
        this.defs.appendChild(this.cssStyle);
      }

      const url = (0, _util.createObjectURL)(fontObj.data, fontObj.mimetype, this.forceDataSchema);
      this.cssStyle.textContent += `@font-face { font-family: "${fontObj.loadedName}";` + ` src: url(${url}); }\n`;
    }

    setFont(details) {
      const current = this.current;
      const fontObj = this.commonObjs.get(details[0]);
      let size = details[1];
      current.font = fontObj;

      if (this.embedFonts && !fontObj.missingFile && !this.embeddedFonts[fontObj.loadedName]) {
        this.addFontStyle(fontObj);
        this.embeddedFonts[fontObj.loadedName] = fontObj;
      }

      current.fontMatrix = fontObj.fontMatrix ? fontObj.fontMatrix : _util.FONT_IDENTITY_MATRIX;
      let bold = "normal";

      if (fontObj.black) {
        bold = "900";
      } else if (fontObj.bold) {
        bold = "bold";
      }

      const italic = fontObj.italic ? "italic" : "normal";

      if (size < 0) {
        size = -size;
        current.fontDirection = -1;
      } else {
        current.fontDirection = 1;
      }

      current.fontSize = size;
      current.fontFamily = fontObj.loadedName;
      current.fontWeight = bold;
      current.fontStyle = italic;
      current.tspan = this.svgFactory.createElement("svg:tspan");
      current.tspan.setAttributeNS(null, "y", pf(-current.y));
      current.xcoords = [];
      current.ycoords = [];
    }

    endText() {
      const current = this.current;

      if (current.textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG && current.txtElement && current.txtElement.hasChildNodes()) {
        current.element = current.txtElement;
        this.clip("nonzero");
        this.endPath();
      }
    }

    setLineWidth(width) {
      if (width > 0) {
        this.current.lineWidth = width;
      }
    }

    setLineCap(style) {
      this.current.lineCap = LINE_CAP_STYLES[style];
    }

    setLineJoin(style) {
      this.current.lineJoin = LINE_JOIN_STYLES[style];
    }

    setMiterLimit(limit) {
      this.current.miterLimit = limit;
    }

    setStrokeAlpha(strokeAlpha) {
      this.current.strokeAlpha = strokeAlpha;
    }

    setStrokeRGBColor(r, g, b) {
      this.current.strokeColor = _util.Util.makeCssRgb(r, g, b);
    }

    setFillAlpha(fillAlpha) {
      this.current.fillAlpha = fillAlpha;
    }

    setFillRGBColor(r, g, b) {
      this.current.fillColor = _util.Util.makeCssRgb(r, g, b);
      this.current.tspan = this.svgFactory.createElement("svg:tspan");
      this.current.xcoords = [];
      this.current.ycoords = [];
    }

    setStrokeColorN(args) {
      this.current.strokeColor = this._makeColorN_Pattern(args);
    }

    setFillColorN(args) {
      this.current.fillColor = this._makeColorN_Pattern(args);
    }

    shadingFill(args) {
      const width = this.viewport.width;
      const height = this.viewport.height;

      const inv = _util.Util.inverseTransform(this.transformMatrix);

      const bl = _util.Util.applyTransform([0, 0], inv);

      const br = _util.Util.applyTransform([0, height], inv);

      const ul = _util.Util.applyTransform([width, 0], inv);

      const ur = _util.Util.applyTransform([width, height], inv);

      const x0 = Math.min(bl[0], br[0], ul[0], ur[0]);
      const y0 = Math.min(bl[1], br[1], ul[1], ur[1]);
      const x1 = Math.max(bl[0], br[0], ul[0], ur[0]);
      const y1 = Math.max(bl[1], br[1], ul[1], ur[1]);
      const rect = this.svgFactory.createElement("svg:rect");
      rect.setAttributeNS(null, "x", x0);
      rect.setAttributeNS(null, "y", y0);
      rect.setAttributeNS(null, "width", x1 - x0);
      rect.setAttributeNS(null, "height", y1 - y0);
      rect.setAttributeNS(null, "fill", this._makeShadingPattern(args));

      if (this.current.fillAlpha < 1) {
        rect.setAttributeNS(null, "fill-opacity", this.current.fillAlpha);
      }

      this._ensureTransformGroup().appendChild(rect);
    }

    _makeColorN_Pattern(args) {
      if (args[0] === "TilingPattern") {
        return this._makeTilingPattern(args);
      }

      return this._makeShadingPattern(args);
    }

    _makeTilingPattern(args) {
      const color = args[1];
      const operatorList = args[2];
      const matrix = args[3] || _util.IDENTITY_MATRIX;
      const [x0, y0, x1, y1] = args[4];
      const xstep = args[5];
      const ystep = args[6];
      const paintType = args[7];
      const tilingId = `shading${shadingCount++}`;

      const [tx0, ty0] = _util.Util.applyTransform([x0, y0], matrix);

      const [tx1, ty1] = _util.Util.applyTransform([x1, y1], matrix);

      const [xscale, yscale] = _util.Util.singularValueDecompose2dScale(matrix);

      const txstep = xstep * xscale;
      const tystep = ystep * yscale;
      const tiling = this.svgFactory.createElement("svg:pattern");
      tiling.setAttributeNS(null, "id", tilingId);
      tiling.setAttributeNS(null, "patternUnits", "userSpaceOnUse");
      tiling.setAttributeNS(null, "width", txstep);
      tiling.setAttributeNS(null, "height", tystep);
      tiling.setAttributeNS(null, "x", `${tx0}`);
      tiling.setAttributeNS(null, "y", `${ty0}`);
      const svg = this.svg;
      const transformMatrix = this.transformMatrix;
      const fillColor = this.current.fillColor;
      const strokeColor = this.current.strokeColor;
      const bbox = this.svgFactory.create(tx1 - tx0, ty1 - ty0);
      this.svg = bbox;
      this.transformMatrix = matrix;

      if (paintType === 2) {
        const cssColor = _util.Util.makeCssRgb(...color);

        this.current.fillColor = cssColor;
        this.current.strokeColor = cssColor;
      }

      this.executeOpTree(this.convertOpList(operatorList));
      this.svg = svg;
      this.transformMatrix = transformMatrix;
      this.current.fillColor = fillColor;
      this.current.strokeColor = strokeColor;
      tiling.appendChild(bbox.childNodes[0]);
      this.defs.appendChild(tiling);
      return `url(#${tilingId})`;
    }

    _makeShadingPattern(args) {
      switch (args[0]) {
        case "RadialAxial":
          const shadingId = `shading${shadingCount++}`;
          const colorStops = args[3];
          let gradient;

          switch (args[1]) {
            case "axial":
              const point0 = args[4];
              const point1 = args[5];
              gradient = this.svgFactory.createElement("svg:linearGradient");
              gradient.setAttributeNS(null, "id", shadingId);
              gradient.setAttributeNS(null, "gradientUnits", "userSpaceOnUse");
              gradient.setAttributeNS(null, "x1", point0[0]);
              gradient.setAttributeNS(null, "y1", point0[1]);
              gradient.setAttributeNS(null, "x2", point1[0]);
              gradient.setAttributeNS(null, "y2", point1[1]);
              break;

            case "radial":
              const focalPoint = args[4];
              const circlePoint = args[5];
              const focalRadius = args[6];
              const circleRadius = args[7];
              gradient = this.svgFactory.createElement("svg:radialGradient");
              gradient.setAttributeNS(null, "id", shadingId);
              gradient.setAttributeNS(null, "gradientUnits", "userSpaceOnUse");
              gradient.setAttributeNS(null, "cx", circlePoint[0]);
              gradient.setAttributeNS(null, "cy", circlePoint[1]);
              gradient.setAttributeNS(null, "r", circleRadius);
              gradient.setAttributeNS(null, "fx", focalPoint[0]);
              gradient.setAttributeNS(null, "fy", focalPoint[1]);
              gradient.setAttributeNS(null, "fr", focalRadius);
              break;

            default:
              throw new Error(`Unknown RadialAxial type: ${args[1]}`);
          }

          for (const colorStop of colorStops) {
            const stop = this.svgFactory.createElement("svg:stop");
            stop.setAttributeNS(null, "offset", colorStop[0]);
            stop.setAttributeNS(null, "stop-color", colorStop[1]);
            gradient.appendChild(stop);
          }

          this.defs.appendChild(gradient);
          return `url(#${shadingId})`;

        case "Mesh":
          (0, _util.warn)("Unimplemented pattern Mesh");
          return null;

        case "Dummy":
          return "hotpink";

        default:
          throw new Error(`Unknown IR type: ${args[0]}`);
      }
    }

    setDash(dashArray, dashPhase) {
      this.current.dashArray = dashArray;
      this.current.dashPhase = dashPhase;
    }

    constructPath(ops, args) {
      const current = this.current;
      let x = current.x,
          y = current.y;
      let d = [];
      let j = 0;

      for (const op of ops) {
        switch (op | 0) {
          case _util.OPS.rectangle:
            x = args[j++];
            y = args[j++];
            const width = args[j++];
            const height = args[j++];
            const xw = x + width;
            const yh = y + height;
            d.push("M", pf(x), pf(y), "L", pf(xw), pf(y), "L", pf(xw), pf(yh), "L", pf(x), pf(yh), "Z");
            break;

          case _util.OPS.moveTo:
            x = args[j++];
            y = args[j++];
            d.push("M", pf(x), pf(y));
            break;

          case _util.OPS.lineTo:
            x = args[j++];
            y = args[j++];
            d.push("L", pf(x), pf(y));
            break;

          case _util.OPS.curveTo:
            x = args[j + 4];
            y = args[j + 5];
            d.push("C", pf(args[j]), pf(args[j + 1]), pf(args[j + 2]), pf(args[j + 3]), pf(x), pf(y));
            j += 6;
            break;

          case _util.OPS.curveTo2:
            d.push("C", pf(x), pf(y), pf(args[j]), pf(args[j + 1]), pf(args[j + 2]), pf(args[j + 3]));
            x = args[j + 2];
            y = args[j + 3];
            j += 4;
            break;

          case _util.OPS.curveTo3:
            x = args[j + 2];
            y = args[j + 3];
            d.push("C", pf(args[j]), pf(args[j + 1]), pf(x), pf(y), pf(x), pf(y));
            j += 4;
            break;

          case _util.OPS.closePath:
            d.push("Z");
            break;
        }
      }

      d = d.join(" ");

      if (current.path && ops.length > 0 && ops[0] !== _util.OPS.rectangle && ops[0] !== _util.OPS.moveTo) {
        d = current.path.getAttributeNS(null, "d") + d;
      } else {
        current.path = this.svgFactory.createElement("svg:path");

        this._ensureTransformGroup().appendChild(current.path);
      }

      current.path.setAttributeNS(null, "d", d);
      current.path.setAttributeNS(null, "fill", "none");
      current.element = current.path;
      current.setCurrentPoint(x, y);
    }

    endPath() {
      const current = this.current;
      current.path = null;

      if (!this.pendingClip) {
        return;
      }

      if (!current.element) {
        this.pendingClip = null;
        return;
      }

      const clipId = `clippath${clipCount++}`;
      const clipPath = this.svgFactory.createElement("svg:clipPath");
      clipPath.setAttributeNS(null, "id", clipId);
      clipPath.setAttributeNS(null, "transform", pm(this.transformMatrix));
      const clipElement = current.element.cloneNode(true);

      if (this.pendingClip === "evenodd") {
        clipElement.setAttributeNS(null, "clip-rule", "evenodd");
      } else {
        clipElement.setAttributeNS(null, "clip-rule", "nonzero");
      }

      this.pendingClip = null;
      clipPath.appendChild(clipElement);
      this.defs.appendChild(clipPath);

      if (current.activeClipUrl) {
        current.clipGroup = null;
        this.extraStack.forEach(function (prev) {
          prev.clipGroup = null;
        });
        clipPath.setAttributeNS(null, "clip-path", current.activeClipUrl);
      }

      current.activeClipUrl = `url(#${clipId})`;
      this.tgrp = null;
    }

    clip(type) {
      this.pendingClip = type;
    }

    closePath() {
      const current = this.current;

      if (current.path) {
        const d = `${current.path.getAttributeNS(null, "d")}Z`;
        current.path.setAttributeNS(null, "d", d);
      }
    }

    setLeading(leading) {
      this.current.leading = -leading;
    }

    setTextRise(textRise) {
      this.current.textRise = textRise;
    }

    setTextRenderingMode(textRenderingMode) {
      this.current.textRenderingMode = textRenderingMode;
    }

    setHScale(scale) {
      this.current.textHScale = scale / 100;
    }

    setRenderingIntent(intent) {}

    setFlatness(flatness) {}

    setGState(states) {
      for (const [key, value] of states) {
        switch (key) {
          case "LW":
            this.setLineWidth(value);
            break;

          case "LC":
            this.setLineCap(value);
            break;

          case "LJ":
            this.setLineJoin(value);
            break;

          case "ML":
            this.setMiterLimit(value);
            break;

          case "D":
            this.setDash(value[0], value[1]);
            break;

          case "RI":
            this.setRenderingIntent(value);
            break;

          case "FL":
            this.setFlatness(value);
            break;

          case "Font":
            this.setFont(value);
            break;

          case "CA":
            this.setStrokeAlpha(value);
            break;

          case "ca":
            this.setFillAlpha(value);
            break;

          default:
            (0, _util.warn)(`Unimplemented graphic state operator ${key}`);
            break;
        }
      }
    }

    fill() {
      const current = this.current;

      if (current.element) {
        current.element.setAttributeNS(null, "fill", current.fillColor);
        current.element.setAttributeNS(null, "fill-opacity", current.fillAlpha);
        this.endPath();
      }
    }

    stroke() {
      const current = this.current;

      if (current.element) {
        this._setStrokeAttributes(current.element);

        current.element.setAttributeNS(null, "fill", "none");
        this.endPath();
      }
    }

    _setStrokeAttributes(element, lineWidthScale = 1) {
      const current = this.current;
      let dashArray = current.dashArray;

      if (lineWidthScale !== 1 && dashArray.length > 0) {
        dashArray = dashArray.map(function (value) {
          return lineWidthScale * value;
        });
      }

      element.setAttributeNS(null, "stroke", current.strokeColor);
      element.setAttributeNS(null, "stroke-opacity", current.strokeAlpha);
      element.setAttributeNS(null, "stroke-miterlimit", pf(current.miterLimit));
      element.setAttributeNS(null, "stroke-linecap", current.lineCap);
      element.setAttributeNS(null, "stroke-linejoin", current.lineJoin);
      element.setAttributeNS(null, "stroke-width", pf(lineWidthScale * current.lineWidth) + "px");
      element.setAttributeNS(null, "stroke-dasharray", dashArray.map(pf).join(" "));
      element.setAttributeNS(null, "stroke-dashoffset", pf(lineWidthScale * current.dashPhase) + "px");
    }

    eoFill() {
      if (this.current.element) {
        this.current.element.setAttributeNS(null, "fill-rule", "evenodd");
      }

      this.fill();
    }

    fillStroke() {
      this.stroke();
      this.fill();
    }

    eoFillStroke() {
      if (this.current.element) {
        this.current.element.setAttributeNS(null, "fill-rule", "evenodd");
      }

      this.fillStroke();
    }

    closeStroke() {
      this.closePath();
      this.stroke();
    }

    closeFillStroke() {
      this.closePath();
      this.fillStroke();
    }

    closeEOFillStroke() {
      this.closePath();
      this.eoFillStroke();
    }

    paintSolidColorImageMask() {
      const rect = this.svgFactory.createElement("svg:rect");
      rect.setAttributeNS(null, "x", "0");
      rect.setAttributeNS(null, "y", "0");
      rect.setAttributeNS(null, "width", "1px");
      rect.setAttributeNS(null, "height", "1px");
      rect.setAttributeNS(null, "fill", this.current.fillColor);

      this._ensureTransformGroup().appendChild(rect);
    }

    paintImageXObject(objId) {
      const imgData = this.objs.get(objId);

      if (!imgData) {
        (0, _util.warn)(`Dependent image with object ID ${objId} is not ready yet`);
        return;
      }

      this.paintInlineImageXObject(imgData);
    }

    paintInlineImageXObject(imgData, mask) {
      const width = imgData.width;
      const height = imgData.height;
      const imgSrc = convertImgDataToPng(imgData, this.forceDataSchema, !!mask);
      const cliprect = this.svgFactory.createElement("svg:rect");
      cliprect.setAttributeNS(null, "x", "0");
      cliprect.setAttributeNS(null, "y", "0");
      cliprect.setAttributeNS(null, "width", pf(width));
      cliprect.setAttributeNS(null, "height", pf(height));
      this.current.element = cliprect;
      this.clip("nonzero");
      const imgEl = this.svgFactory.createElement("svg:image");
      imgEl.setAttributeNS(XLINK_NS, "xlink:href", imgSrc);
      imgEl.setAttributeNS(null, "x", "0");
      imgEl.setAttributeNS(null, "y", pf(-height));
      imgEl.setAttributeNS(null, "width", pf(width) + "px");
      imgEl.setAttributeNS(null, "height", pf(height) + "px");
      imgEl.setAttributeNS(null, "transform", `scale(${pf(1 / width)} ${pf(-1 / height)})`);

      if (mask) {
        mask.appendChild(imgEl);
      } else {
        this._ensureTransformGroup().appendChild(imgEl);
      }
    }

    paintImageMaskXObject(imgData) {
      const current = this.current;
      const width = imgData.width;
      const height = imgData.height;
      const fillColor = current.fillColor;
      current.maskId = `mask${maskCount++}`;
      const mask = this.svgFactory.createElement("svg:mask");
      mask.setAttributeNS(null, "id", current.maskId);
      const rect = this.svgFactory.createElement("svg:rect");
      rect.setAttributeNS(null, "x", "0");
      rect.setAttributeNS(null, "y", "0");
      rect.setAttributeNS(null, "width", pf(width));
      rect.setAttributeNS(null, "height", pf(height));
      rect.setAttributeNS(null, "fill", fillColor);
      rect.setAttributeNS(null, "mask", `url(#${current.maskId})`);
      this.defs.appendChild(mask);

      this._ensureTransformGroup().appendChild(rect);

      this.paintInlineImageXObject(imgData, mask);
    }

    paintFormXObjectBegin(matrix, bbox) {
      if (Array.isArray(matrix) && matrix.length === 6) {
        this.transform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
      }

      if (bbox) {
        const width = bbox[2] - bbox[0];
        const height = bbox[3] - bbox[1];
        const cliprect = this.svgFactory.createElement("svg:rect");
        cliprect.setAttributeNS(null, "x", bbox[0]);
        cliprect.setAttributeNS(null, "y", bbox[1]);
        cliprect.setAttributeNS(null, "width", pf(width));
        cliprect.setAttributeNS(null, "height", pf(height));
        this.current.element = cliprect;
        this.clip("nonzero");
        this.endPath();
      }
    }

    paintFormXObjectEnd() {}

    _initialize(viewport) {
      const svg = this.svgFactory.create(viewport.width, viewport.height);
      const definitions = this.svgFactory.createElement("svg:defs");
      svg.appendChild(definitions);
      this.defs = definitions;
      const rootGroup = this.svgFactory.createElement("svg:g");
      rootGroup.setAttributeNS(null, "transform", pm(viewport.transform));
      svg.appendChild(rootGroup);
      this.svg = rootGroup;
      return svg;
    }

    _ensureClipGroup() {
      if (!this.current.clipGroup) {
        const clipGroup = this.svgFactory.createElement("svg:g");
        clipGroup.setAttributeNS(null, "clip-path", this.current.activeClipUrl);
        this.svg.appendChild(clipGroup);
        this.current.clipGroup = clipGroup;
      }

      return this.current.clipGroup;
    }

    _ensureTransformGroup() {
      if (!this.tgrp) {
        this.tgrp = this.svgFactory.createElement("svg:g");
        this.tgrp.setAttributeNS(null, "transform", pm(this.transformMatrix));

        if (this.current.activeClipUrl) {
          this._ensureClipGroup().appendChild(this.tgrp);
        } else {
          this.svg.appendChild(this.tgrp);
        }
      }

      return this.tgrp;
    }

  };
}

/***/ }),
/* 19 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFNodeStream = void 0;

var _util = __w_pdfjs_require__(2);

var _network_utils = __w_pdfjs_require__(20);

const fs = require$$4;

const http = require$$4;

const https = require$$4;

const url = require$$4;

const fileUriRegex = /^file:\/\/\/[a-zA-Z]:\//;

function parseUrl(sourceUrl) {
  const parsedUrl = url.parse(sourceUrl);

  if (parsedUrl.protocol === "file:" || parsedUrl.host) {
    return parsedUrl;
  }

  if (/^[a-z]:[/\\]/i.test(sourceUrl)) {
    return url.parse(`file:///${sourceUrl}`);
  }

  if (!parsedUrl.host) {
    parsedUrl.protocol = "file:";
  }

  return parsedUrl;
}

class PDFNodeStream {
  constructor(source) {
    this.source = source;
    this.url = parseUrl(source.url);
    this.isHttp = this.url.protocol === "http:" || this.url.protocol === "https:";
    this.isFsUrl = this.url.protocol === "file:";
    this.httpHeaders = this.isHttp && source.httpHeaders || {};
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }

  get _progressiveDataLength() {
    return this._fullRequestReader ? this._fullRequestReader._loaded : 0;
  }

  getFullReader() {
    (0, _util.assert)(!this._fullRequestReader, "PDFNodeStream.getFullReader can only be called once.");
    this._fullRequestReader = this.isFsUrl ? new PDFNodeStreamFsFullReader(this) : new PDFNodeStreamFullReader(this);
    return this._fullRequestReader;
  }

  getRangeReader(start, end) {
    if (end <= this._progressiveDataLength) {
      return null;
    }

    const rangeReader = this.isFsUrl ? new PDFNodeStreamFsRangeReader(this, start, end) : new PDFNodeStreamRangeReader(this, start, end);

    this._rangeRequestReaders.push(rangeReader);

    return rangeReader;
  }

  cancelAllRequests(reason) {
    if (this._fullRequestReader) {
      this._fullRequestReader.cancel(reason);
    }

    const readers = this._rangeRequestReaders.slice(0);

    readers.forEach(function (reader) {
      reader.cancel(reason);
    });
  }

}

exports.PDFNodeStream = PDFNodeStream;

class BaseFullReader {
  constructor(stream) {
    this._url = stream.url;
    this._done = false;
    this._storedError = null;
    this.onProgress = null;
    const source = stream.source;
    this._contentLength = source.length;
    this._loaded = 0;
    this._filename = null;
    this._disableRange = source.disableRange || false;
    this._rangeChunkSize = source.rangeChunkSize;

    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }

    this._isStreamingSupported = !source.disableStream;
    this._isRangeSupported = !source.disableRange;
    this._readableStream = null;
    this._readCapability = (0, _util.createPromiseCapability)();
    this._headersCapability = (0, _util.createPromiseCapability)();
  }

  get headersReady() {
    return this._headersCapability.promise;
  }

  get filename() {
    return this._filename;
  }

  get contentLength() {
    return this._contentLength;
  }

  get isRangeSupported() {
    return this._isRangeSupported;
  }

  get isStreamingSupported() {
    return this._isStreamingSupported;
  }

  async read() {
    await this._readCapability.promise;

    if (this._done) {
      return {
        value: undefined,
        done: true
      };
    }

    if (this._storedError) {
      throw this._storedError;
    }

    const chunk = this._readableStream.read();

    if (chunk === null) {
      this._readCapability = (0, _util.createPromiseCapability)();
      return this.read();
    }

    this._loaded += chunk.length;

    if (this.onProgress) {
      this.onProgress({
        loaded: this._loaded,
        total: this._contentLength
      });
    }

    const buffer = new Uint8Array(chunk).buffer;
    return {
      value: buffer,
      done: false
    };
  }

  cancel(reason) {
    if (!this._readableStream) {
      this._error(reason);

      return;
    }

    this._readableStream.destroy(reason);
  }

  _error(reason) {
    this._storedError = reason;

    this._readCapability.resolve();
  }

  _setReadableStream(readableStream) {
    this._readableStream = readableStream;
    readableStream.on("readable", () => {
      this._readCapability.resolve();
    });
    readableStream.on("end", () => {
      readableStream.destroy();
      this._done = true;

      this._readCapability.resolve();
    });
    readableStream.on("error", reason => {
      this._error(reason);
    });

    if (!this._isStreamingSupported && this._isRangeSupported) {
      this._error(new _util.AbortException("streaming is disabled"));
    }

    if (this._storedError) {
      this._readableStream.destroy(this._storedError);
    }
  }

}

class BaseRangeReader {
  constructor(stream) {
    this._url = stream.url;
    this._done = false;
    this._storedError = null;
    this.onProgress = null;
    this._loaded = 0;
    this._readableStream = null;
    this._readCapability = (0, _util.createPromiseCapability)();
    const source = stream.source;
    this._isStreamingSupported = !source.disableStream;
  }

  get isStreamingSupported() {
    return this._isStreamingSupported;
  }

  async read() {
    await this._readCapability.promise;

    if (this._done) {
      return {
        value: undefined,
        done: true
      };
    }

    if (this._storedError) {
      throw this._storedError;
    }

    const chunk = this._readableStream.read();

    if (chunk === null) {
      this._readCapability = (0, _util.createPromiseCapability)();
      return this.read();
    }

    this._loaded += chunk.length;

    if (this.onProgress) {
      this.onProgress({
        loaded: this._loaded
      });
    }

    const buffer = new Uint8Array(chunk).buffer;
    return {
      value: buffer,
      done: false
    };
  }

  cancel(reason) {
    if (!this._readableStream) {
      this._error(reason);

      return;
    }

    this._readableStream.destroy(reason);
  }

  _error(reason) {
    this._storedError = reason;

    this._readCapability.resolve();
  }

  _setReadableStream(readableStream) {
    this._readableStream = readableStream;
    readableStream.on("readable", () => {
      this._readCapability.resolve();
    });
    readableStream.on("end", () => {
      readableStream.destroy();
      this._done = true;

      this._readCapability.resolve();
    });
    readableStream.on("error", reason => {
      this._error(reason);
    });

    if (this._storedError) {
      this._readableStream.destroy(this._storedError);
    }
  }

}

function createRequestOptions(parsedUrl, headers) {
  return {
    protocol: parsedUrl.protocol,
    auth: parsedUrl.auth,
    host: parsedUrl.hostname,
    port: parsedUrl.port,
    path: parsedUrl.path,
    method: "GET",
    headers
  };
}

class PDFNodeStreamFullReader extends BaseFullReader {
  constructor(stream) {
    super(stream);

    const handleResponse = response => {
      if (response.statusCode === 404) {
        const error = new _util.MissingPDFException(`Missing PDF "${this._url}".`);
        this._storedError = error;

        this._headersCapability.reject(error);

        return;
      }

      this._headersCapability.resolve();

      this._setReadableStream(response);

      const getResponseHeader = name => {
        return this._readableStream.headers[name.toLowerCase()];
      };

      const {
        allowRangeRequests,
        suggestedLength
      } = (0, _network_utils.validateRangeRequestCapabilities)({
        getResponseHeader,
        isHttp: stream.isHttp,
        rangeChunkSize: this._rangeChunkSize,
        disableRange: this._disableRange
      });
      this._isRangeSupported = allowRangeRequests;
      this._contentLength = suggestedLength || this._contentLength;
      this._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);
    };

    this._request = null;

    if (this._url.protocol === "http:") {
      this._request = http.request(createRequestOptions(this._url, stream.httpHeaders), handleResponse);
    } else {
      this._request = https.request(createRequestOptions(this._url, stream.httpHeaders), handleResponse);
    }

    this._request.on("error", reason => {
      this._storedError = reason;

      this._headersCapability.reject(reason);
    });

    this._request.end();
  }

}

class PDFNodeStreamRangeReader extends BaseRangeReader {
  constructor(stream, start, end) {
    super(stream);
    this._httpHeaders = {};

    for (const property in stream.httpHeaders) {
      const value = stream.httpHeaders[property];

      if (typeof value === "undefined") {
        continue;
      }

      this._httpHeaders[property] = value;
    }

    this._httpHeaders.Range = `bytes=${start}-${end - 1}`;

    const handleResponse = response => {
      if (response.statusCode === 404) {
        const error = new _util.MissingPDFException(`Missing PDF "${this._url}".`);
        this._storedError = error;
        return;
      }

      this._setReadableStream(response);
    };

    this._request = null;

    if (this._url.protocol === "http:") {
      this._request = http.request(createRequestOptions(this._url, this._httpHeaders), handleResponse);
    } else {
      this._request = https.request(createRequestOptions(this._url, this._httpHeaders), handleResponse);
    }

    this._request.on("error", reason => {
      this._storedError = reason;
    });

    this._request.end();
  }

}

class PDFNodeStreamFsFullReader extends BaseFullReader {
  constructor(stream) {
    super(stream);
    let path = decodeURIComponent(this._url.path);

    if (fileUriRegex.test(this._url.href)) {
      path = path.replace(/^\//, "");
    }

    fs.lstat(path, (error, stat) => {
      if (error) {
        if (error.code === "ENOENT") {
          error = new _util.MissingPDFException(`Missing PDF "${path}".`);
        }

        this._storedError = error;

        this._headersCapability.reject(error);

        return;
      }

      this._contentLength = stat.size;

      this._setReadableStream(fs.createReadStream(path));

      this._headersCapability.resolve();
    });
  }

}

class PDFNodeStreamFsRangeReader extends BaseRangeReader {
  constructor(stream, start, end) {
    super(stream);
    let path = decodeURIComponent(this._url.path);

    if (fileUriRegex.test(this._url.href)) {
      path = path.replace(/^\//, "");
    }

    this._setReadableStream(fs.createReadStream(path, {
      start,
      end: end - 1
    }));
  }

}

/***/ }),
/* 20 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createResponseStatusError = createResponseStatusError;
exports.extractFilenameFromHeader = extractFilenameFromHeader;
exports.validateRangeRequestCapabilities = validateRangeRequestCapabilities;
exports.validateResponseStatus = validateResponseStatus;

var _util = __w_pdfjs_require__(2);

var _content_disposition = __w_pdfjs_require__(21);

function validateRangeRequestCapabilities({
  getResponseHeader,
  isHttp,
  rangeChunkSize,
  disableRange
}) {
  (0, _util.assert)(rangeChunkSize > 0, "Range chunk size must be larger than zero");
  const returnValues = {
    allowRangeRequests: false,
    suggestedLength: undefined
  };
  const length = parseInt(getResponseHeader("Content-Length"), 10);

  if (!Number.isInteger(length)) {
    return returnValues;
  }

  returnValues.suggestedLength = length;

  if (length <= 2 * rangeChunkSize) {
    return returnValues;
  }

  if (disableRange || !isHttp) {
    return returnValues;
  }

  if (getResponseHeader("Accept-Ranges") !== "bytes") {
    return returnValues;
  }

  const contentEncoding = getResponseHeader("Content-Encoding") || "identity";

  if (contentEncoding !== "identity") {
    return returnValues;
  }

  returnValues.allowRangeRequests = true;
  return returnValues;
}

function extractFilenameFromHeader(getResponseHeader) {
  const contentDisposition = getResponseHeader("Content-Disposition");

  if (contentDisposition) {
    let filename = (0, _content_disposition.getFilenameFromContentDispositionHeader)(contentDisposition);

    if (filename.includes("%")) {
      try {
        filename = decodeURIComponent(filename);
      } catch (ex) {}
    }

    if (/\.pdf$/i.test(filename)) {
      return filename;
    }
  }

  return null;
}

function createResponseStatusError(status, url) {
  if (status === 404 || status === 0 && url.startsWith("file:")) {
    return new _util.MissingPDFException('Missing PDF "' + url + '".');
  }

  return new _util.UnexpectedResponseException("Unexpected server response (" + status + ') while retrieving PDF "' + url + '".', status);
}

function validateResponseStatus(status) {
  return status === 200 || status === 206;
}

/***/ }),
/* 21 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFilenameFromContentDispositionHeader = getFilenameFromContentDispositionHeader;

function getFilenameFromContentDispositionHeader(contentDisposition) {
  let needsEncodingFixup = true;
  let tmp = toParamRegExp("filename\\*", "i").exec(contentDisposition);

  if (tmp) {
    tmp = tmp[1];
    let filename = rfc2616unquote(tmp);
    filename = unescape(filename);
    filename = rfc5987decode(filename);
    filename = rfc2047decode(filename);
    return fixupEncoding(filename);
  }

  tmp = rfc2231getparam(contentDisposition);

  if (tmp) {
    const filename = rfc2047decode(tmp);
    return fixupEncoding(filename);
  }

  tmp = toParamRegExp("filename", "i").exec(contentDisposition);

  if (tmp) {
    tmp = tmp[1];
    let filename = rfc2616unquote(tmp);
    filename = rfc2047decode(filename);
    return fixupEncoding(filename);
  }

  function toParamRegExp(attributePattern, flags) {
    return new RegExp("(?:^|;)\\s*" + attributePattern + "\\s*=\\s*" + "(" + '[^";\\s][^;\\s]*' + "|" + '"(?:[^"\\\\]|\\\\"?)+"?' + ")", flags);
  }

  function textdecode(encoding, value) {
    if (encoding) {
      if (!/^[\x00-\xFF]+$/.test(value)) {
        return value;
      }

      try {
        const decoder = new TextDecoder(encoding, {
          fatal: true
        });
        const bytes = Array.from(value, function (ch) {
          return ch.charCodeAt(0) & 0xff;
        });
        value = decoder.decode(new Uint8Array(bytes));
        needsEncodingFixup = false;
      } catch (e) {
        if (/^utf-?8$/i.test(encoding)) {
          try {
            value = decodeURIComponent(escape(value));
            needsEncodingFixup = false;
          } catch (err) {}
        }
      }
    }

    return value;
  }

  function fixupEncoding(value) {
    if (needsEncodingFixup && /[\x80-\xff]/.test(value)) {
      value = textdecode("utf-8", value);

      if (needsEncodingFixup) {
        value = textdecode("iso-8859-1", value);
      }
    }

    return value;
  }

  function rfc2231getparam(contentDispositionStr) {
    const matches = [];
    let match;
    const iter = toParamRegExp("filename\\*((?!0\\d)\\d+)(\\*?)", "ig");

    while ((match = iter.exec(contentDispositionStr)) !== null) {
      let [, n, quot, part] = match;
      n = parseInt(n, 10);

      if (n in matches) {
        if (n === 0) {
          break;
        }

        continue;
      }

      matches[n] = [quot, part];
    }

    const parts = [];

    for (let n = 0; n < matches.length; ++n) {
      if (!(n in matches)) {
        break;
      }

      let [quot, part] = matches[n];
      part = rfc2616unquote(part);

      if (quot) {
        part = unescape(part);

        if (n === 0) {
          part = rfc5987decode(part);
        }
      }

      parts.push(part);
    }

    return parts.join("");
  }

  function rfc2616unquote(value) {
    if (value.startsWith('"')) {
      const parts = value.slice(1).split('\\"');

      for (let i = 0; i < parts.length; ++i) {
        const quotindex = parts[i].indexOf('"');

        if (quotindex !== -1) {
          parts[i] = parts[i].slice(0, quotindex);
          parts.length = i + 1;
        }

        parts[i] = parts[i].replace(/\\(.)/g, "$1");
      }

      value = parts.join('"');
    }

    return value;
  }

  function rfc5987decode(extvalue) {
    const encodingend = extvalue.indexOf("'");

    if (encodingend === -1) {
      return extvalue;
    }

    const encoding = extvalue.slice(0, encodingend);
    const langvalue = extvalue.slice(encodingend + 1);
    const value = langvalue.replace(/^[^']*'/, "");
    return textdecode(encoding, value);
  }

  function rfc2047decode(value) {
    if (!value.startsWith("=?") || /[\x00-\x19\x80-\xff]/.test(value)) {
      return value;
    }

    return value.replace(/=\?([\w-]*)\?([QqBb])\?((?:[^?]|\?(?!=))*)\?=/g, function (matches, charset, encoding, text) {
      if (encoding === "q" || encoding === "Q") {
        text = text.replace(/_/g, " ");
        text = text.replace(/=([0-9a-fA-F]{2})/g, function (match, hex) {
          return String.fromCharCode(parseInt(hex, 16));
        });
        return textdecode(charset, text);
      }

      try {
        text = atob(text);
      } catch (e) {}

      return textdecode(charset, text);
    });
  }

  return "";
}

/***/ }),
/* 22 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFNetworkStream = void 0;

var _util = __w_pdfjs_require__(2);

var _network_utils = __w_pdfjs_require__(20);
const OK_RESPONSE = 200;
const PARTIAL_CONTENT_RESPONSE = 206;

function getArrayBuffer(xhr) {
  const data = xhr.response;

  if (typeof data !== "string") {
    return data;
  }

  const array = (0, _util.stringToBytes)(data);
  return array.buffer;
}

class NetworkManager {
  constructor(url, args) {
    this.url = url;
    args = args || {};
    this.isHttp = /^https?:/i.test(url);
    this.httpHeaders = this.isHttp && args.httpHeaders || {};
    this.withCredentials = args.withCredentials || false;

    this.getXhr = args.getXhr || function NetworkManager_getXhr() {
      return new XMLHttpRequest();
    };

    this.currXhrId = 0;
    this.pendingRequests = Object.create(null);
  }

  requestRange(begin, end, listeners) {
    const args = {
      begin,
      end
    };

    for (const prop in listeners) {
      args[prop] = listeners[prop];
    }

    return this.request(args);
  }

  requestFull(listeners) {
    return this.request(listeners);
  }

  request(args) {
    const xhr = this.getXhr();
    const xhrId = this.currXhrId++;
    const pendingRequest = this.pendingRequests[xhrId] = {
      xhr
    };
    xhr.open("GET", this.url);
    xhr.withCredentials = this.withCredentials;

    for (const property in this.httpHeaders) {
      const value = this.httpHeaders[property];

      if (typeof value === "undefined") {
        continue;
      }

      xhr.setRequestHeader(property, value);
    }

    if (this.isHttp && "begin" in args && "end" in args) {
      xhr.setRequestHeader("Range", `bytes=${args.begin}-${args.end - 1}`);
      pendingRequest.expectedStatus = PARTIAL_CONTENT_RESPONSE;
    } else {
      pendingRequest.expectedStatus = OK_RESPONSE;
    }

    xhr.responseType = "arraybuffer";

    if (args.onError) {
      xhr.onerror = function (evt) {
        args.onError(xhr.status);
      };
    }

    xhr.onreadystatechange = this.onStateChange.bind(this, xhrId);
    xhr.onprogress = this.onProgress.bind(this, xhrId);
    pendingRequest.onHeadersReceived = args.onHeadersReceived;
    pendingRequest.onDone = args.onDone;
    pendingRequest.onError = args.onError;
    pendingRequest.onProgress = args.onProgress;
    xhr.send(null);
    return xhrId;
  }

  onProgress(xhrId, evt) {
    const pendingRequest = this.pendingRequests[xhrId];

    if (!pendingRequest) {
      return;
    }

    if (pendingRequest.onProgress) {
      pendingRequest.onProgress(evt);
    }
  }

  onStateChange(xhrId, evt) {
    const pendingRequest = this.pendingRequests[xhrId];

    if (!pendingRequest) {
      return;
    }

    const xhr = pendingRequest.xhr;

    if (xhr.readyState >= 2 && pendingRequest.onHeadersReceived) {
      pendingRequest.onHeadersReceived();
      delete pendingRequest.onHeadersReceived;
    }

    if (xhr.readyState !== 4) {
      return;
    }

    if (!(xhrId in this.pendingRequests)) {
      return;
    }

    delete this.pendingRequests[xhrId];

    if (xhr.status === 0 && this.isHttp) {
      if (pendingRequest.onError) {
        pendingRequest.onError(xhr.status);
      }

      return;
    }

    const xhrStatus = xhr.status || OK_RESPONSE;
    const ok_response_on_range_request = xhrStatus === OK_RESPONSE && pendingRequest.expectedStatus === PARTIAL_CONTENT_RESPONSE;

    if (!ok_response_on_range_request && xhrStatus !== pendingRequest.expectedStatus) {
      if (pendingRequest.onError) {
        pendingRequest.onError(xhr.status);
      }

      return;
    }

    const chunk = getArrayBuffer(xhr);

    if (xhrStatus === PARTIAL_CONTENT_RESPONSE) {
      const rangeHeader = xhr.getResponseHeader("Content-Range");
      const matches = /bytes (\d+)-(\d+)\/(\d+)/.exec(rangeHeader);
      pendingRequest.onDone({
        begin: parseInt(matches[1], 10),
        chunk
      });
    } else if (chunk) {
      pendingRequest.onDone({
        begin: 0,
        chunk
      });
    } else if (pendingRequest.onError) {
      pendingRequest.onError(xhr.status);
    }
  }

  hasPendingRequests() {
    for (const xhrId in this.pendingRequests) {
      return true;
    }

    return false;
  }

  getRequestXhr(xhrId) {
    return this.pendingRequests[xhrId].xhr;
  }

  isPendingRequest(xhrId) {
    return xhrId in this.pendingRequests;
  }

  abortAllRequests() {
    for (const xhrId in this.pendingRequests) {
      this.abortRequest(xhrId | 0);
    }
  }

  abortRequest(xhrId) {
    const xhr = this.pendingRequests[xhrId].xhr;
    delete this.pendingRequests[xhrId];
    xhr.abort();
  }

}

class PDFNetworkStream {
  constructor(source) {
    this._source = source;
    this._manager = new NetworkManager(source.url, {
      httpHeaders: source.httpHeaders,
      withCredentials: source.withCredentials
    });
    this._rangeChunkSize = source.rangeChunkSize;
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }

  _onRangeRequestReaderClosed(reader) {
    const i = this._rangeRequestReaders.indexOf(reader);

    if (i >= 0) {
      this._rangeRequestReaders.splice(i, 1);
    }
  }

  getFullReader() {
    (0, _util.assert)(!this._fullRequestReader, "PDFNetworkStream.getFullReader can only be called once.");
    this._fullRequestReader = new PDFNetworkStreamFullRequestReader(this._manager, this._source);
    return this._fullRequestReader;
  }

  getRangeReader(begin, end) {
    const reader = new PDFNetworkStreamRangeRequestReader(this._manager, begin, end);
    reader.onClosed = this._onRangeRequestReaderClosed.bind(this);

    this._rangeRequestReaders.push(reader);

    return reader;
  }

  cancelAllRequests(reason) {
    if (this._fullRequestReader) {
      this._fullRequestReader.cancel(reason);
    }

    const readers = this._rangeRequestReaders.slice(0);

    readers.forEach(function (reader) {
      reader.cancel(reason);
    });
  }

}

exports.PDFNetworkStream = PDFNetworkStream;

class PDFNetworkStreamFullRequestReader {
  constructor(manager, source) {
    this._manager = manager;
    const args = {
      onHeadersReceived: this._onHeadersReceived.bind(this),
      onDone: this._onDone.bind(this),
      onError: this._onError.bind(this),
      onProgress: this._onProgress.bind(this)
    };
    this._url = source.url;
    this._fullRequestId = manager.requestFull(args);
    this._headersReceivedCapability = (0, _util.createPromiseCapability)();
    this._disableRange = source.disableRange || false;
    this._contentLength = source.length;
    this._rangeChunkSize = source.rangeChunkSize;

    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }

    this._isStreamingSupported = false;
    this._isRangeSupported = false;
    this._cachedChunks = [];
    this._requests = [];
    this._done = false;
    this._storedError = undefined;
    this._filename = null;
    this.onProgress = null;
  }

  _onHeadersReceived() {
    const fullRequestXhrId = this._fullRequestId;

    const fullRequestXhr = this._manager.getRequestXhr(fullRequestXhrId);

    const getResponseHeader = name => {
      return fullRequestXhr.getResponseHeader(name);
    };

    const {
      allowRangeRequests,
      suggestedLength
    } = (0, _network_utils.validateRangeRequestCapabilities)({
      getResponseHeader,
      isHttp: this._manager.isHttp,
      rangeChunkSize: this._rangeChunkSize,
      disableRange: this._disableRange
    });

    if (allowRangeRequests) {
      this._isRangeSupported = true;
    }

    this._contentLength = suggestedLength || this._contentLength;
    this._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);

    if (this._isRangeSupported) {
      this._manager.abortRequest(fullRequestXhrId);
    }

    this._headersReceivedCapability.resolve();
  }

  _onDone(args) {
    if (args) {
      if (this._requests.length > 0) {
        const requestCapability = this._requests.shift();

        requestCapability.resolve({
          value: args.chunk,
          done: false
        });
      } else {
        this._cachedChunks.push(args.chunk);
      }
    }

    this._done = true;

    if (this._cachedChunks.length > 0) {
      return;
    }

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];
  }

  _onError(status) {
    const url = this._url;
    const exception = (0, _network_utils.createResponseStatusError)(status, url);
    this._storedError = exception;

    this._headersReceivedCapability.reject(exception);

    this._requests.forEach(function (requestCapability) {
      requestCapability.reject(exception);
    });

    this._requests = [];
    this._cachedChunks = [];
  }

  _onProgress(data) {
    if (this.onProgress) {
      this.onProgress({
        loaded: data.loaded,
        total: data.lengthComputable ? data.total : this._contentLength
      });
    }
  }

  get filename() {
    return this._filename;
  }

  get isRangeSupported() {
    return this._isRangeSupported;
  }

  get isStreamingSupported() {
    return this._isStreamingSupported;
  }

  get contentLength() {
    return this._contentLength;
  }

  get headersReady() {
    return this._headersReceivedCapability.promise;
  }

  async read() {
    if (this._storedError) {
      throw this._storedError;
    }

    if (this._cachedChunks.length > 0) {
      const chunk = this._cachedChunks.shift();

      return {
        value: chunk,
        done: false
      };
    }

    if (this._done) {
      return {
        value: undefined,
        done: true
      };
    }

    const requestCapability = (0, _util.createPromiseCapability)();

    this._requests.push(requestCapability);

    return requestCapability.promise;
  }

  cancel(reason) {
    this._done = true;

    this._headersReceivedCapability.reject(reason);

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    if (this._manager.isPendingRequest(this._fullRequestId)) {
      this._manager.abortRequest(this._fullRequestId);
    }

    this._fullRequestReader = null;
  }

}

class PDFNetworkStreamRangeRequestReader {
  constructor(manager, begin, end) {
    this._manager = manager;
    const args = {
      onDone: this._onDone.bind(this),
      onProgress: this._onProgress.bind(this)
    };
    this._requestId = manager.requestRange(begin, end, args);
    this._requests = [];
    this._queuedChunk = null;
    this._done = false;
    this.onProgress = null;
    this.onClosed = null;
  }

  _close() {
    if (this.onClosed) {
      this.onClosed(this);
    }
  }

  _onDone(data) {
    const chunk = data.chunk;

    if (this._requests.length > 0) {
      const requestCapability = this._requests.shift();

      requestCapability.resolve({
        value: chunk,
        done: false
      });
    } else {
      this._queuedChunk = chunk;
    }

    this._done = true;

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    this._close();
  }

  _onProgress(evt) {
    if (!this.isStreamingSupported && this.onProgress) {
      this.onProgress({
        loaded: evt.loaded
      });
    }
  }

  get isStreamingSupported() {
    return false;
  }

  async read() {
    if (this._queuedChunk !== null) {
      const chunk = this._queuedChunk;
      this._queuedChunk = null;
      return {
        value: chunk,
        done: false
      };
    }

    if (this._done) {
      return {
        value: undefined,
        done: true
      };
    }

    const requestCapability = (0, _util.createPromiseCapability)();

    this._requests.push(requestCapability);

    return requestCapability.promise;
  }

  cancel(reason) {
    this._done = true;

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    if (this._manager.isPendingRequest(this._requestId)) {
      this._manager.abortRequest(this._requestId);
    }

    this._close();
  }

}

/***/ }),
/* 23 */
/***/ (function(module, exports, __w_pdfjs_require__) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFFetchStream = void 0;

var _util = __w_pdfjs_require__(2);

var _network_utils = __w_pdfjs_require__(20);

function createFetchOptions(headers, withCredentials, abortController) {
  return {
    method: "GET",
    headers,
    signal: abortController && abortController.signal,
    mode: "cors",
    credentials: withCredentials ? "include" : "same-origin",
    redirect: "follow"
  };
}

function createHeaders(httpHeaders) {
  const headers = new Headers();

  for (const property in httpHeaders) {
    const value = httpHeaders[property];

    if (typeof value === "undefined") {
      continue;
    }

    headers.append(property, value);
  }

  return headers;
}

class PDFFetchStream {
  constructor(source) {
    this.source = source;
    this.isHttp = /^https?:/i.test(source.url);
    this.httpHeaders = this.isHttp && source.httpHeaders || {};
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }

  get _progressiveDataLength() {
    return this._fullRequestReader ? this._fullRequestReader._loaded : 0;
  }

  getFullReader() {
    (0, _util.assert)(!this._fullRequestReader, "PDFFetchStream.getFullReader can only be called once.");
    this._fullRequestReader = new PDFFetchStreamReader(this);
    return this._fullRequestReader;
  }

  getRangeReader(begin, end) {
    if (end <= this._progressiveDataLength) {
      return null;
    }

    const reader = new PDFFetchStreamRangeReader(this, begin, end);

    this._rangeRequestReaders.push(reader);

    return reader;
  }

  cancelAllRequests(reason) {
    if (this._fullRequestReader) {
      this._fullRequestReader.cancel(reason);
    }

    const readers = this._rangeRequestReaders.slice(0);

    readers.forEach(function (reader) {
      reader.cancel(reason);
    });
  }

}

exports.PDFFetchStream = PDFFetchStream;

class PDFFetchStreamReader {
  constructor(stream) {
    this._stream = stream;
    this._reader = null;
    this._loaded = 0;
    this._filename = null;
    const source = stream.source;
    this._withCredentials = source.withCredentials || false;
    this._contentLength = source.length;
    this._headersCapability = (0, _util.createPromiseCapability)();
    this._disableRange = source.disableRange || false;
    this._rangeChunkSize = source.rangeChunkSize;

    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }

    if (typeof AbortController !== "undefined") {
      this._abortController = new AbortController();
    }

    this._isStreamingSupported = !source.disableStream;
    this._isRangeSupported = !source.disableRange;
    this._headers = createHeaders(this._stream.httpHeaders);
    const url = source.url;
    fetch(url, createFetchOptions(this._headers, this._withCredentials, this._abortController)).then(response => {
      if (!(0, _network_utils.validateResponseStatus)(response.status)) {
        throw (0, _network_utils.createResponseStatusError)(response.status, url);
      }

      this._reader = response.body.getReader();

      this._headersCapability.resolve();

      const getResponseHeader = name => {
        return response.headers.get(name);
      };

      const {
        allowRangeRequests,
        suggestedLength
      } = (0, _network_utils.validateRangeRequestCapabilities)({
        getResponseHeader,
        isHttp: this._stream.isHttp,
        rangeChunkSize: this._rangeChunkSize,
        disableRange: this._disableRange
      });
      this._isRangeSupported = allowRangeRequests;
      this._contentLength = suggestedLength || this._contentLength;
      this._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);

      if (!this._isStreamingSupported && this._isRangeSupported) {
        this.cancel(new _util.AbortException("Streaming is disabled."));
      }
    }).catch(this._headersCapability.reject);
    this.onProgress = null;
  }

  get headersReady() {
    return this._headersCapability.promise;
  }

  get filename() {
    return this._filename;
  }

  get contentLength() {
    return this._contentLength;
  }

  get isRangeSupported() {
    return this._isRangeSupported;
  }

  get isStreamingSupported() {
    return this._isStreamingSupported;
  }

  async read() {
    await this._headersCapability.promise;
    const {
      value,
      done
    } = await this._reader.read();

    if (done) {
      return {
        value,
        done
      };
    }

    this._loaded += value.byteLength;

    if (this.onProgress) {
      this.onProgress({
        loaded: this._loaded,
        total: this._contentLength
      });
    }

    const buffer = new Uint8Array(value).buffer;
    return {
      value: buffer,
      done: false
    };
  }

  cancel(reason) {
    if (this._reader) {
      this._reader.cancel(reason);
    }

    if (this._abortController) {
      this._abortController.abort();
    }
  }

}

class PDFFetchStreamRangeReader {
  constructor(stream, begin, end) {
    this._stream = stream;
    this._reader = null;
    this._loaded = 0;
    const source = stream.source;
    this._withCredentials = source.withCredentials || false;
    this._readCapability = (0, _util.createPromiseCapability)();
    this._isStreamingSupported = !source.disableStream;

    if (typeof AbortController !== "undefined") {
      this._abortController = new AbortController();
    }

    this._headers = createHeaders(this._stream.httpHeaders);

    this._headers.append("Range", `bytes=${begin}-${end - 1}`);

    const url = source.url;
    fetch(url, createFetchOptions(this._headers, this._withCredentials, this._abortController)).then(response => {
      if (!(0, _network_utils.validateResponseStatus)(response.status)) {
        throw (0, _network_utils.createResponseStatusError)(response.status, url);
      }

      this._readCapability.resolve();

      this._reader = response.body.getReader();
    });
    this.onProgress = null;
  }

  get isStreamingSupported() {
    return this._isStreamingSupported;
  }

  async read() {
    await this._readCapability.promise;
    const {
      value,
      done
    } = await this._reader.read();

    if (done) {
      return {
        value,
        done
      };
    }

    this._loaded += value.byteLength;

    if (this.onProgress) {
      this.onProgress({
        loaded: this._loaded
      });
    }

    const buffer = new Uint8Array(value).buffer;
    return {
      value: buffer,
      done: false
    };
  }

  cancel(reason) {
    if (this._reader) {
      this._reader.cancel(reason);
    }

    if (this._abortController) {
      this._abortController.abort();
    }
  }

}

/***/ })
/******/ ]);
});

});

unwrapExports(pdf);

var pdf_1 = pdf;

function _defineProperty$7(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
	This web component allows to display and play pdf file like a video player widget/element. Its attributes and
	methodes are mostley identical as video html. No controls attribute supported yet.
*/
pdf_1.GlobalWorkerOptions.workerSrc = 'node_modules/@bundled-es-modules/pdfjs-dist/build/pdf.worker.js';

/**
 *
 */

// Create a class for the element
class pdf_player extends HTMLElement {
  constructor() {
    super();

    // Create a shadow root
    /**
     * shadow dom container
     * @private
     */
    _defineProperty$7(this, "_shadow", null);
    /**
     * wrapper container holds canvas
     * @private
     */
    _defineProperty$7(this, "_wrapper", void 0);
    /**
     * Canvas element to render pdf
     * @private
     */
    _defineProperty$7(this, "_canvas", void 0);
    /**
     * Styling contianer
     * @private
     */
    _defineProperty$7(this, "_style", void 0);
    /**
     * keeps duration time internally
     * @private
     */
    _defineProperty$7(this, "_duration", 0);
    /**
     * keeps currentTime internally
     * @private
     */
    _defineProperty$7(this, "_currentTime", 0);
    /**
     * Keeps playing state internally
     * @private
     */
    _defineProperty$7(this, "__playing", false);
    /**
     * keeps playing interval id
     * @private
     */
    _defineProperty$7(this, "__playingInterval", 0);
    /**
     * keeps play back rate
     * @private
     */
    _defineProperty$7(this, "_playBackRate", 1000);
    /**
     * keeps ended state of playing pdf
     * @private
     */
    _defineProperty$7(this, "_ended", false);
    /**
     * keep paused state
     * @private
     */
    _defineProperty$7(this, "_paused", false);
    /**
     * keeps pdf doc states
     * @private
     */
    _defineProperty$7(this, "__pdfViewState", {
      pdf: null,
      currentPage: 1,
      zoom: 1
    });
    this._shadow = this.attachShadow({
      mode: 'open'
    });

    // Create wrapper
    this._wrapper = document.createElement('div');
    this._wrapper.setAttribute('class', 'wrapper');

    // Create some CSS to apply to the shadow dom
    this._style = document.createElement('style');
    this._style.textContent = '.wrapper {' + 'width: 100%;' + 'height: auto;' + 'display: block;' + '}' + '.wrapper canvas {' + 'width: 100%;' + 'height: auto;' + '}';

    // attach to the shadow dom
    this._shadow.appendChild(this._style);
    this._shadow.appendChild(this._wrapper);
  }

  /**
   * set observable attributes
   * @return {string[]}
   */
  static get observedAttributes() {
    return ['src', 'type'];
  }

  /**
   * Gets called on observable attributes changes
   * @param name attribute name
   * @param _
   * @param newVal new value
   */
  attributeChangedCallback(name, _, newVal) {
    switch (name) {
      case 'src':
        this.__buildPDFView(newVal);
        break;
      case 'type':
        // do nothing
        break;
    }
  }

  /**
   * init/update pdf tag
   * @param _value
   * @private
   */
  __buildPDFView(_value) {
    this._canvas = document.createElement('canvas');
    this._wrapper.appendChild(this._canvas);
    var longTask = pdf_1.getDocument(_value);
    longTask.promise.then(pdf => {
      this.__pdfViewState.pdf = pdf;
      this._duration = this.__pdfViewState.pdf._pdfInfo.numPages;

      // initiate the pdf file viewer for the first time after loading
      this.__render(1).then(_ => {
        this.__pushEvent('loadedmetadata');
      });
    });
  }

  /**
   * Render given page from pdf into the canvas container
   *
   * @param _page
   * @private
   */
  __render(_page) {
    if (!this.__pdfViewState.pdf) return;
    var p = _page || this.__pdfViewState.currentPage;
    var self = this;
    return this.__pdfViewState.pdf.getPage(p).then(page => {
      var canvasContext = self._canvas.getContext('2d');
      var viewport = page.getViewport({
        scale: self.__pdfViewState.zoom
      });
      self._canvas.width = viewport.width;
      self._canvas.height = viewport.height;
      page.render({
        canvasContext: canvasContext,
        viewport: viewport
      });
    });
  }

  /**
   * Creates event and dispatches it
   * @param _name
   */
  __pushEvent(_name) {
    var event = document.createEvent("Event");
    event.initEvent(_name, true, true);
    this.dispatchEvent(event);
  }

  /**************************** PUBLIC ATTRIBUTES & METHODES *************************************************/

  /****************************** ATTRIBUTES **************************************/

  /**
   * set src
   * @param _value
   */
  set src(_value) {
    this._wrapper.children.forEach(_ch => {
      _ch.remove();
    });
    this.__buildPDFView(_value);
  }

  /**
   * get src
   * @return string returns comma separated sources
   */
  get src() {
    return this.src;
  }

  /**
   * currentTime
   * @param _time
   */
  set currentTime(_time) {
    var time = Math.floor(_time < 1 ? 1 : _time);
    if (time > this._duration) {
      // set ended state to true as it's the last page of pdf
      this._ended = true;
      // don't go further because it's litterally the last page
      return;
    }

    // set ended state to false as it's not the end of the pdf
    this._ended = false;
    this._currentTime = time;
    this.__pdfViewState.currentPage = time;
    this.__render(time);
  }

  /**
   * get currentTime
   * @return {number}
   */
  get currentTime() {
    return this._currentTime;
  }

  /**
   * get duration time
   */
  get duration() {
    return this._duration;
  }

  /**
   * get paused attribute
   */
  get paused() {
    return this._paused;
  }

  /**
   * set muted attribute
   * @param _value
   */
  set muted(_value) {
    return;
  }

  /**
   * get muted attribute
   */
  get muted() {
    return true;
  }
  set ended(_value) {
    this._ended = _value;
  }

  /**
   * get ended attribute
   */
  get ended() {
    return this._ended;
  }

  /**
   * set playbackRate
   * @param _value
   */
  set playbackRate(_value) {
    this._playBackRate = _value * 1000;
  }

  /**
   * get playbackRate
   */
  get playbackRate() {
    return this._playBackRate;
  }

  /**
   * set volume
   */
  set volume(_value) {
    return;
  }

  /**
   * get volume
   */
  get volume() {
    return 0;
  }

  /************************************************* METHODES ******************************************/

  /**
   * Play
   */
  play() {
    this.__playing = true;
    var self = this;
    return new Promise(function (_resolve, _reject) {
      self.__playingInterval = window.setInterval(_ => {
        if (self.currentTime >= self._duration) {
          self.ended = true;
          self.pause();
        }
        self.currentTime += 1;
        self.__pushEvent('timeupdate');
      }, self._playBackRate);
      _resolve();
    });
  }

  /**
   * pause
   */
  pause() {
    this.__playing = false;
    this._paused = true;
    window.clearInterval(this.__playingInterval);
  }

  /**
   * seek previous page
   */
  prevPage() {
    this.currentTime -= 1;
  }

  /**
   * seek next page
   */
  nextPage() {
    this.currentTime += 1;
  }
}

// Define pdf-player element
customElements.define('pdf-player', pdf_player);

function _defineProperty$6(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * This widget represents the HTML5 video tag with all its optional attributes
 *
 * The widget can be created in the following ways:
 * <code>
 * var videoTag = et2_createWidget("video", {
 *			video_src: "../../test.mp4",
 *			src_type: "video/mp4",
 *			muted: true,
 *			autoplay: true,
 *			controls: true,
 *			poster: "../../poster.jpg",
 *			loop: true,
 *			height: 100,
 *			width: 200,
 * });
 * </code>
 * Or by adding XET-tag in your template (.xet) file:
 * <code>
 * <video [attributes...]/>
 * </code>
 */

/**
 * Class which implements the "video" XET-Tag
 *
 * @augments et2_baseWidget
 */
class et2_video extends et2_baseWidget {
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_video._attributes, _child || {}));
    _defineProperty$6(this, "video", null);
    _defineProperty$6(this, "youtube", void 0);
    /**
     * keeps internal state of previousTime video played
     * @private
     */
    _defineProperty$6(this, "_previousTime", 0);
    /**
     * keeps the currentTime
     * @private
     */
    _defineProperty$6(this, "_currentTime", void 0);
    /**
     * interval defined for youtube type to simulate ontimeupdate html5 event
     * @private
     */
    _defineProperty$6(this, "_youtubeOntimeUpdateIntrv", void 0);
    /**
     * youtube iframe api will replace it with iframe
     * @protected
     */
    _defineProperty$6(this, "youtubeFrame", void 0);
    this.set_src_type(this.options.src_type);
    this.options.starttime = isNaN(this.options.starttime) ? 0 : this.options.starttime;
  }
  set_src_type(_type) {
    this.options.src_type = _type;
    if (this.video && this._isYoutube() === (this.video[0].tagName === 'DIV')) {
      return;
    }
    //Create Video tag
    this.video = jQuery(document.createElement(this._isYoutube() ? "div" : _type.match('pdf') ? "pdf-player" : this.options.multi_src ? 'multi-video' : 'video')).addClass('et2_video').attr('id', this.dom_id);
    if (this._isYoutube()) {
      // this div will be replaced by youtube iframe api when youtube gets ready
      this.youtubeFrame = jQuery(document.createElement('div')).appendTo(this.video).attr('id', et2_video.youtubePrefixId + this.id);
      if (!document.getElementById('youtube-api-script')) {
        //Load youtube iframe api
        var tag = document.createElement('script');
        tag.id = 'youtube-api-script';
        tag.src = "https://www.youtube.com/iframe_api";
        var firstScriptTag = document.getElementsByTagName('script')[0];
        firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
      }
    }
    if (!this._isYoutube() && this.options.controls) {
      this.video.attr("controls", 1);
    }
    if (!this._isYoutube() && this.options.autoplay) {
      this.video.attr("autoplay", 1);
    }
    if (this.options.muted) {
      this.video.attr("muted", 1);
    }
    if (this.options.video_src) {
      this.set_src(this.options.video_src);
    }
    if (this.options.loop) {
      this.video.attr("loop", 1);
    }
    this.setDOMNode(this.video[0]);
    this.set_width(this.options.width || 'auto');
    this.set_height(this.options.height || 'auto');
  }

  /**
   * Set video src
   *
   * @param {string} _value url
   */
  set_src(_value) {
    var self = this;
    this.options.video_src = _value;
    if (_value && !this._isYoutube()) {
      this.video.attr('src', _value);
      if (this.options.src_type) {
        this.video.attr('type', this.options.src_type);
      }
    } else if (_value) {
      if (typeof YT == 'undefined') {
        //initiate youtube Api object, it gets called automatically by iframe_api script from the api
        window.onYouTubeIframeAPIReady = this._onYoutubeIframeAPIReady;
        window.addEventListener('et2_video.onYoutubeIframeAPIReady', function () {
          self._createYoutubePlayer(self.options.video_src);
        });
      } else {
        self._createYoutubePlayer(self.options.video_src);
      }
    }
  }

  /**
   * Set autoplay option for video
   * -If autoplay is set, video would be played automatically after the page is loaded
   *
   * @param {string} _value true set the autoplay and false not to set
   */
  set_autoplay(_value) {
    if (_value && !this._isYoutube()) {
      this.video.attr("autoplay", _value);
    }
  }

  /**
   * Set controls option for video
   *
   * @param {string} _value true set the autoplay and false not to set
   */
  set_controls(_value) {
    if (_value && !this._isYoutube()) {
      this.video.attr("controls", _value);
    }
  }

  /**
   * Method to set volume
   * @param _value
   */
  set_volume(_value) {
    var value = _value > 100 ? 100 : _value;
    if (value >= 0) {
      if (this._isYoutube() && this.youtube && typeof this.youtube.setVolume === 'function') {
        this.youtube.setVolume(value);
      } else if (!this._isYoutube()) {
        this.video[0].volume = value / 100;
      }
    }
  }

  /**
   * get volume
   */
  get_volume() {
    if (this._isYoutube() && this.youtube) {
      return this.youtube.getVolume();
    } else {
      return this.video[0].volume * 100;
    }
  }

  /**
   * method to set playBackRate
   * @param _value
   */
  set_playBackRate(_value) {
    var value = _value > 16 ? 16 : _value;
    if (value >= 0) {
      if (this._isYoutube() && this.youtube) {
        this.youtube.setPlaybackRate(value);
      } else {
        this.video[0].playbackRate = value;
      }
    }
  }

  /**
   * get playBackRate
   */
  get_playBackRate() {
    if (this._isYoutube() && this.youtube) {
      return this.youtube.getPlaybackRate();
    } else {
      return this.video[0].playbackRate;
    }
  }
  set_mute(_value) {
    if (this._isYoutube() && this.youtube) {
      if (_value) {
        this.youtube.mute();
      } else {
        this.youtube.unMute();
      }
    } else {
      this.video[0].muted = _value;
    }
  }
  get_mute() {
    if (this._isYoutube() && this.youtube) {
      return this.youtube.isMuted();
    } else {
      return this.video[0].muted;
    }
  }
  /**
   * Set poster attribute in order to specify
   * an image to be shown while video is loading or before user play it
   *
   * @param {string} _url url or image spec like "api/mime128_video"
   */
  set_poster(_url) {
    if (_url) {
      if (_url[0] !== '/' && !_url.match(/^https?:\/\//)) {
        _url = this.egw().image(_url);
      }
      this.video.attr("poster", _url);
    }
  }

  /**
   * Seek to a time / position
   *
   * @param _vtime in seconds
   */
  seek_video(_vtime) {
    if (this._isYoutube()) {
      if (this.youtube.seekTo) {
        this.youtube.seekTo(_vtime, true);
        this._currentTime = _vtime;
      }
    } else {
      this.video[0].currentTime = _vtime;
    }
  }

  /**
   * Play video
   */
  play_video() {
    if (this._isYoutube()) {
      var self = this;
      return new Promise(function (resolve) {
        if (self.youtube.playVideo) {
          self.youtube.playVideo();
          resolve();
        }
      });
    }
    return this.video[0].play();
  }

  /**
   * Pause video
   */
  pause_video() {
    if (this._isYoutube()) {
      if (this.youtube.pauseVideo) {
        this.youtube.pauseVideo();
        if (this.youtube.getCurrentTime() != this._currentTime) {
          // give it a chance to get actual current time ready otherwise we would still get the previous time
          // unfortunately we need to rely on a timeout as the youtube seekTo not returning any promise to wait for.
          setTimeout(_ => {
            this.currentTime(this.youtube.getCurrentTime());
          }, 500);
        } else {
          this.currentTime(this.youtube.getCurrentTime());
        }
      }
    } else {
      this.video[0].pause();
    }
  }

  /**
   * play video
   * ***Internal use and should not be overriden in its extended class***
   */
  play() {
    var _this$youtube;
    return this._isYoutube() && (_this$youtube = this.youtube) !== null && _this$youtube !== void 0 && _this$youtube.playVideo ? this.youtube.playVideo() : this.video[0].play();
  }

  /**
   * Get/set current video time / position in seconds
   * @return returns currentTime
   */
  currentTime(_time) {
    if (_time) {
      if (this._isYoutube()) {
        this.youtube.seekTo(_time);
      } else {
        this.video[0].currentTime = _time;
      }
      return this._currentTime = _time;
    }
    if (this._isYoutube()) {
      var _this$youtube2;
      if (typeof this._currentTime != 'undefined') {
        return this._currentTime;
      }
      return (_this$youtube2 = this.youtube) !== null && _this$youtube2 !== void 0 && _this$youtube2.getCurrentTime ? this.youtube.getCurrentTime() : 0;
    } else {
      return this.video[0].currentTime;
    }
  }

  /**
   * get duration time
   * @return returns duration time
   */
  duration() {
    if (this._isYoutube()) {
      var _this$youtube3;
      return (_this$youtube3 = this.youtube) !== null && _this$youtube3 !== void 0 && _this$youtube3.getDuration ? this.youtube.getDuration() : 0;
    } else {
      return this.video[0].duration;
    }
  }

  /**
   * get pasued
   * @return returns paused flag
   */
  paused() {
    if (this._isYoutube()) {
      return this.youtube.getPlayerState() == et2_video.youtube_player_states.paused;
    }
    return this.video[0].paused;
  }

  /**
   * get ended
   * @return returns ended flag
   */
  ended() {
    if (this._isYoutube()) {
      return this.youtube.getPlayerState() == et2_video.youtube_player_states.ended;
    }
    return this.video[0].ended;
  }

  /**
   * get/set priviousTime
   * @param _time
   * @return returns time
   */
  previousTime(_time) {
    if (_time) this._previousTime = _time;
    return this._previousTime;
  }
  doLoadingFinished() {
    super.doLoadingFinished();
    var self = this;
    if (!this._isYoutube()) {
      this.video[0].addEventListener("loadedmetadata", function () {
        self._onReady();
      });
      this.video[0].addEventListener("timeupdate", function () {
        self._onTimeUpdate();
      });
    } else {
      // need to create the player after the DOM is ready otherwise player won't show up
      if (window.YT) this._createYoutubePlayer(this.options.video_src);
    }
    return false;
  }
  videoLoadnigIsFinished() {
    if (this.options.starttime >= 0) {
      this.seek_video(this.options.starttime);

      // unfortunately, youtube api autoplays the video after seekTo on initiation
      // and there's no way to stop that therefore we need to trick it by manually
      // pausing the video (this would bring up the spinner with the black screen,
      // in order to avoid that we let the video plays for a second then we pause).
      // since the youtube timeline is one second advanced we need to seek back to
      // the original stattime although this time because it was manually paused
      // we won't have the spinner and black screen instead we get the preview.
      if (this._isYoutube()) window.setTimeout(function () {
        this.youtube.pauseVideo();
        this.youtube.seekTo(this.options.starttime);
        ;
      }.bind(this), 1000);
    }
  }
  _onReady() {
    // need to set the video dom to transformed iframe
    if (this._isYoutube() && this.youtube.getIframe) this.youtubeFrame = jQuery(this.youtube.getIframe());
    var event = document.createEvent("Event");
    event.initEvent('et2_video.onReady.' + this.id, true, true);
    this.video[0].dispatchEvent(event);
  }
  _onTimeUpdate() {
    // update currentTime manually since youtube currentTime might be updated due to the loading
    if (this._isYoutube() && this.youtube.getCurrentTime) this._currentTime = this.youtube.getCurrentTime();
    var event = document.createEvent("Event");
    event.initEvent('et2_video.onTimeUpdate.' + this.id, true, true);
    this.video[0].dispatchEvent(event);
  }

  /**
   * check if the video is a youtube type
   * @return return true if it's a youtube type video
   * @private
   */
  _isYoutube() {
    return !!this.options.src_type.match('youtube');
  }
  _onStateChangeYoutube(_data) {
    switch (_data.data) {
      case et2_video.youtube_player_states.unstarted:
        // do nothing
        break;
      case et2_video.youtube_player_states.playing:
        this._youtubeOntimeUpdateIntrv = window.setInterval(jQuery.proxy(this._onTimeUpdate, this), 100);
        break;
      default:
        window.clearInterval(this._youtubeOntimeUpdateIntrv);
    }
    console.log(_data);
  }

  /**
   * youtube on IframeAPI ready event
   */
  _onYoutubeIframeAPIReady() {
    var event = document.createEvent("Event");
    event.initEvent('et2_video.onYoutubeIframeAPIReady', true, true);
    window.dispatchEvent(event);
  }

  /**
   * create youtube player
   *
   * @param _value
   */
  _createYoutubePlayer(_value) {
    var matches = _value === null || _value === void 0 ? void 0 : _value.match(et2_video.youtubeRegexp);
    if (matches && typeof YT != 'undefined') {
      this.youtube = new YT.Player(et2_video.youtubePrefixId + this.id, {
        height: this.options.height || '400',
        width: '100%',
        playerVars: {
          'autoplay': 0,
          'controls': 0,
          'modestbranding': 1,
          'fs': 0,
          'disablekb': 1,
          'rel': 0,
          'iv_load_policy': 0,
          'cc_load_policy': 0
        },
        videoId: matches[4],
        events: {
          'onReady': jQuery.proxy(this._onReady, this),
          'onStateChange': jQuery.proxy(this._onStateChangeYoutube, this)
        }
      });
    }
  }
}
_defineProperty$6(et2_video, "_attributes", {
  "video_src": {
    "name": "Video",
    "type": "string",
    "description": "Source of video to display"
  },
  "src_type": {
    "name": "Source type",
    "type": "string",
    "description": "Defines the type the stream source provided"
  },
  "multi_src": {
    "name": "Multi Video source",
    "type": "boolean",
    "default": false,
    "description": "creates a multi-video tag in order to render all provided video sources"
  },
  "muted": {
    "name": "Audio control",
    "type": "boolean",
    "default": false,
    "description": "Defines that the audio output of the video should be muted"
  },
  "autoplay": {
    "name": "Autoplay",
    "type": "boolean",
    "default": false,
    "description": "Defines if Video will start playing as soon as it is ready"
  },
  starttime: {
    "name": "Inital position of video",
    "type": "float",
    "default": 0,
    "description": "Set initial position of video"
  },
  "controls": {
    "name": "Control buttons",
    "type": "boolean",
    "default": false,
    "description": "Defines if Video controls, play/pause buttons should be displayed"
  },
  "poster": {
    "name": "Video Poster",
    "type": "string",
    "default": "",
    "description": "Specifies an image to be shown while video is loading or before user play it"
  },
  "loop": {
    "name": "Video loop",
    "type": "boolean",
    "default": false,
    "description": "Defines if the video should be played repeatedly"
  },
  "volume": {
    "name": "Video volume",
    "type": "float",
    "default": 0,
    "description": "Set video's volume"
  },
  "playbackrate": {
    "name": "Video playBackRate",
    "type": "float",
    "default": 1,
    "description": "Set video's playBackRate"
  }
});
_defineProperty$6(et2_video, "youtube_player_states", {
  unstarted: -1,
  ended: 0,
  playing: 1,
  paused: 2,
  buffering: 3,
  video_cued: 5
});
/**
 * prefix id used for addressing youtube player dom
 * @private
 */
_defineProperty$6(et2_video, "youtubePrefixId", "frame-");
_defineProperty$6(et2_video, "youtubeRegexp", new RegExp(/^https:\/\/((www\.|m\.)?youtube(-nocookie)?\.com|youtu\.be)\/.*(?:\/|%3D|v=|vi=)([0-9A-z-_]{11})(?:[%#?&]|$)/m));
et2_register_widget(et2_video, ["video"]);

function _defineProperty$5(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * This widget represents the HTML5 Audio tag with all its optional attributes
 *
 * The widget can be created in the following ways:
 * <code>
 * var audioTag = et2_createWidget("audio", {
 *			audio_src: "../../test.mp3",
 *			src_type: "audio/mpeg",
 *			muted: true,
 *			autoplay: true,
 *			controls: true,
 *			loop: true,
 *			height: 100,
 *			width: 200,
 * });
 * </code>
 * Or by adding XET-tag in your template (.xet) file:
 * <code>
 * <audio [attributes...]/>
 * </code>
 */
/**
 * Class which implements the "audio" XET-Tag
 *
 * @augments et2_baseWidget
 */
class et2_audio extends et2_baseWidget {
  constructor(_parent, _attrs, _child) {
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_audio._attributes, _child || {}));

    //Create Audio tag
    _defineProperty$5(this, "audio", null);
    _defineProperty$5(this, "container", null);
    this.audio = new Audio();
    // Container
    this.container = document.createElement('div');
    this.container.append(this.audio);
    this.container.classList.add('et2_audio');
    if (this.options.autohide) this.container.classList.add('et2_audio_autohide');
    if (this.options.controls) this.audio.setAttribute("controls", '1');
    if (this.options.autoplay) this.audio.setAttribute("autoplay", '1');
    if (this.options.muted) this.audio.setAttribute("muted", '1');
    if (this.options.loop) this.audio.setAttribute("loop", '1');
    if (this.options.preload) this.audio.setAttribute('preload', this.options.preload);
    this.setDOMNode(this.container);
  }

  /**
   * Set audio source
   *
   * @param {string} _value url
   */
  set_src(_value) {
    if (_value) {
      this.audio.setAttribute('src', _value);
      if (this.options.src_type) {
        this.audio.setAttribute('type', this.options.src_type);
      }
      //preload the audio after changing the source/ only if preload is allowed
      if (this.options.preload != "none") this.audio.load();
    }
  }

  /**
   * @return Promise
   */
  play() {
    return this.audio.play();
  }
  pause() {
    this.audio.pause();
  }
  currentTime() {
    return this.audio.currentTime;
  }
  seek(_time) {
    this.audio.currentTime = _time;
  }
}
_defineProperty$5(et2_audio, "_attributes", {
  "src": {
    "name": "Audio",
    "type": "string",
    "description": "Source of audio to play"
  },
  "src_type": {
    "name": "Source type",
    "type": "string",
    "description": "Defines the type the stream source provided"
  },
  "muted": {
    "name": "Audio control",
    "type": "boolean",
    "default": false,
    "description": "Defines that the audio output should be muted"
  },
  "autoplay": {
    "name": "Autoplay",
    "type": "boolean",
    "default": false,
    "description": "Defines if audio will start playing as soon as it is ready"
  },
  "controls": {
    "name": "Control buttons",
    "type": "boolean",
    "default": true,
    "description": "Defines if audio controls, play/pause buttons should be displayed"
  },
  "loop": {
    "name": "Audio loop",
    "type": "boolean",
    "default": false,
    "description": "Defines if the audio should be played repeatedly"
  },
  "autohide": {
    "name": "Auto hide",
    "type": "boolean",
    "default": false,
    "description": "Auto hides audio control bars and only shows a play button, hovering for few seconds will show the whole controlbar."
  },
  "preload": {
    "name": "preload",
    "type": "string",
    "default": 'auto',
    "description": "preloads audio source based on given option. none(do not preload), auto(preload), metadata(preload metadata only)."
  }
});
et2_register_widget(et2_audio, ["audio"]);

var _class;
function _defineProperty$4(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "barcode" XET-Tag
 *
 */
class et2_barcode extends et2_valueWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_barcode._attributes, _child || {}));
    _defineProperty$4(this, "div", void 0);
    _defineProperty$4(this, "settings", void 0);
    this.div = jQuery(document.createElement('div')).attr({
      class: 'et2_barcode'
    });

    // Set domid
    this.set_id(this.id);
    this.setDOMNode(this.div[0]);
    this.createWidget();
  }
  createWidget() {
    this.settings = {
      output: this.options.format,
      bgColor: this.options.bgColor,
      color: this.options.barColor,
      barWidth: this.options.barWidth,
      barHeight: this.options.barHeight
    };
    if (this.get_value()) {
      // @ts-ignore
      this.div.barcode(this.get_value(), this.options.code_type, this.settings);
    }
  }
  set_value(_val) {
    if (typeof _val !== 'undefined') {
      this.value = _val;
      this.createWidget();
    }
  }
}
_class = et2_barcode;
// Class Constants
/*
 * type const
 */
_defineProperty$4(et2_barcode, "TYPE_CODEBAR", "codebar");
_defineProperty$4(et2_barcode, "TYPE_CODE11", "code11");
//(code 11)
_defineProperty$4(et2_barcode, "TYPE_CODE39", "code39");
//(code 39)
_defineProperty$4(et2_barcode, "TYPE_CODE128", "code128");
//(code 128)
_defineProperty$4(et2_barcode, "TYPE_EAN8", "ean8");
//(ean 8) - http://barcode-coder.com/en/ean-8-specification-101.html
_defineProperty$4(et2_barcode, "TYPE_EAN13", "ean13");
//(ean 13) - http://barcode-coder.com/en/ean-13-specification-102.html
_defineProperty$4(et2_barcode, "TYPE_STD25", "std25");
//(standard 2 of 5 - industrial 2 of 5) - http://barcode-coder.com/en/standard-2-of-5-specification-103.html
_defineProperty$4(et2_barcode, "TYPE_INT25", "int25");
//(interleaved 2 of 5)
_defineProperty$4(et2_barcode, "TYPE_MSI", "msi");
_defineProperty$4(et2_barcode, "TYPE_DATAMATRIX", "datamatrix");
//(ASCII + extended) - http://barcode-coder.com/en/datamatrix-specification-104.html
/**
 * Formats consts
 */
_defineProperty$4(et2_barcode, "FORMAT_CSS", "css");
_defineProperty$4(et2_barcode, "FORMAT_SVG", "svg");
_defineProperty$4(et2_barcode, "FORMAT_bmp", "bmp");
_defineProperty$4(et2_barcode, "FORMAT_CANVAS", "canvas");
_defineProperty$4(et2_barcode, "_attributes", {
  "code_type": {
    "name": "code type",
    "type": "string",
    "default": _class.TYPE_DATAMATRIX,
    "description": "Barcode type to be generated, default is QR barcode"
  },
  bgColor: {
    "name": "bgColor",
    "type": "string",
    "default": '#FFFFFF',
    "description": "Defines backgorund color of barcode container"
  },
  barColor: {
    "name": "barColor",
    "type": "string",
    "default": '#000000',
    "description": "Defines color of the bars in barcode."
  },
  format: {
    "name": "format",
    "type": "string",
    "default": 'css',
    //et2_barcode.FORMAT_CSS
    "description": "Defines in which format the barcode should be rendered. Default is SVG."
  },
  barWidth: {
    "name": "bar width",
    "type": "string",
    "default": '1',
    "description": "Defines width of each bar in the barcode."
  },
  barHeight: {
    "name": "bar height",
    "type": "string",
    "default": '50',
    "description": "Defines heigh of each bar in the barcode."
  }
});
et2_register_widget(et2_barcode, ["barcode"]);

function _defineProperty$3(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "itempicker" XET-Tag
 *
 * @augments et2_inputWidget
 */
class et2_itempicker extends et2_inputWidget {
  /**
   * Constructor
   *
   * @memberOf et2_itempicker
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_itempicker._attributes, _child || {}));
    _defineProperty$3(this, "last_search", "");
    // Remember last search value
    _defineProperty$3(this, "action", null);
    // Action function for button
    _defineProperty$3(this, "current_app", "");
    // Remember currently chosen application
    _defineProperty$3(this, "div", null);
    _defineProperty$3(this, "left", null);
    _defineProperty$3(this, "right", null);
    _defineProperty$3(this, "right_container", null);
    _defineProperty$3(this, "app_select", null);
    _defineProperty$3(this, "search", null);
    _defineProperty$3(this, "button_action", null);
    _defineProperty$3(this, "itemlist", null);
    _defineProperty$3(this, "clear", void 0);
    this.div = null;
    this.left = null;
    this.right = null;
    this.right_container = null;
    this.app_select = null;
    this.search = null;
    this.button_action = null;
    this.itemlist = null;
    if (this.options.action !== null && typeof this.options.action == "string") {
      this.action = new egwFnct(this, "javaScript:" + this.options.action);
    } else {
      console.log("itempicker widget: no action provided for button");
    }
    this.createInputWidget();
  }
  clearSearchResults() {
    this.search.val("");
    this.itemlist.html("");
    this.search.focus();
    this.clear.hide();
  }
  createInputWidget() {
    var _self = this;
    this.div = jQuery(document.createElement("div"));
    this.left = jQuery(document.createElement("div"));
    this.right = jQuery(document.createElement("div"));
    this.right_container = jQuery(document.createElement("div"));
    this.app_select = jQuery(document.createElement("ul"));
    this.search = jQuery(document.createElement("input"));
    this.clear = jQuery(document.createElement("span"));
    this.itemlist = jQuery(document.createElement("div"));

    // Container elements
    this.div.addClass("et2_itempicker");
    this.left.addClass("et2_itempicker_left");
    this.right.addClass("et2_itempicker_right");
    this.right_container.addClass("et2_itempicker_right_container");

    // Application select
    this.app_select.addClass("et2_itempicker_app_select");
    var item_count = 0;
    for (var key in this.options.select_options) {
      var img_icon = this.egw().image(key + "/navbar");
      if (img_icon === null) {
        continue;
      }
      var img = jQuery(document.createElement("img"));
      img.attr("src", img_icon);
      var item = jQuery(document.createElement("li"));
      item.attr("id", key).click(function () {
        _self.selectApplication(jQuery(this));
      }).append(img);
      if (item_count == 0) {
        this.selectApplication(item); // select first item by default
      }

      this.app_select.append(item);
      item_count++;
    }

    // Search input field
    this.search.addClass("et2_itempicker_search");
    this.search.keyup(function () {
      var request = {};
      request.term = jQuery(this).val();
      _self.query(request);
    });
    this.set_blur(this.options.blur, this.search);

    // Clear button for search
    this.clear.addClass("et2_itempicker_clear ui-icon ui-icon-close").click(function () {
      _self.clearSearchResults();
    }).hide();

    // Action button
    this.button_action = et2_createWidget("button", {});
    jQuery(this.button_action.getDOMNode()).addClass("et2_itempicker_button_action");
    this.button_action.set_label(this.egw().lang(this.options.action_label));
    this.button_action.click = function () {
      _self.doAction();
    };

    // Itemlist
    this.itemlist.attr("id", "itempicker_itemlist");
    this.itemlist.addClass("et2_itempicker_itemlist");

    // Put everything together
    this.left.append(this.app_select);
    this.right_container.append(this.search);
    this.right_container.append(this.clear);
    this.right_container.append(this.button_action.getDOMNode());
    this.right_container.append(this.itemlist);
    this.right.append(this.right_container);
    this.div.append(this.right); // right before left to have a natural
    this.div.append(this.left); // z-index for left div over right div

    this.setDOMNode(this.div[0]);
  }
  doAction() {
    if (this.action !== null) {
      var data = {};
      data.app = this.current_app;
      data.value = this.options.value;
      data.checked = this.getSelectedItems();
      return this.action.exec(this, data);
    }
    return false;
  }
  getSelectedItems() {
    var items = [];
    jQuery(this.itemlist).children("ul").children("li.selected").each(function (index) {
      items[index] = jQuery(this).attr("id");
    });
    return items;
  }

  /**
   * Ask server for entries matching selected app/type and filtered by search string
   */
  query(request) {
    if (request.term.length < 3) {
      return true;
    }
    // Remember last search
    this.last_search = request.term;

    // Allow hook / tie in
    if (this.options.query && typeof this.options.query == 'function') {
      if (!this.options.query(request, response)) return false;
    }

    //if(request.term in this.cache) {
    //	return response(this.cache[request.term]);
    //}

    this.itemlist.addClass("loading");
    this.clear.css("display", "inline-block");
    egw$1.json("EGroupware\\Api\\Etemplate\\Widget\\ItemPicker::ajax_item_search", [this.current_app, '', request.term, request.options], this.queryResults, this, true, this).sendRequest();
  }

  /**
   * Server found some results for query
   */
  queryResults(data) {
    this.itemlist.removeClass("loading");
    this.updateItemList(data);
  }
  selectApplication(app) {
    this.clearSearchResults();
    jQuery(".et2_itempicker_app_select li").removeClass("selected");
    app.addClass("selected");
    this.current_app = app.attr("id");
    return true;
  }
  set_blur(_value, input) {
    if (typeof input == 'undefined') input = this.search;
    if (_value) {
      input.attr("placeholder", _value); // HTML5
      if (!input[0].placeholder) {
        // Not HTML5
        if (input.val() == "") input.val(_value);
        input.focus(input, function (e) {
          var placeholder = _value;
          if (e.data.val() == placeholder) e.data.val("");
        }).blur(input, function (e) {
          var placeholder = _value;
          if (e.data.val() == "") e.data.val(placeholder);
        });
        if (input.val() == "") input.val(_value);
      }
    } else {
      this.search.removeAttr("placeholder");
    }
  }
  transformAttributes(_attrs) {
    super.transformAttributes(_attrs);
    _attrs["select_options"] = {};
    if (_attrs["application"]) {
      var apps = et2_csvSplit(_attrs["application"], null, ",");
      for (var i = 0; i < apps.length; i++) {
        _attrs["select_options"][apps[i]] = this.egw().lang(apps[i]);
      }
    } else {
      _attrs["select_options"] = this.egw().link_app_list('query');
    }

    // Check whether the options entry was found, if not read it from the
    // content array.
    if (_attrs["select_options"] == null) {
      _attrs["select_options"] = this.getArrayMgr('content').getEntry("options-" + this.id);
    }

    // Default to an empty object
    if (_attrs["select_options"] == null) {
      _attrs["select_options"] = {};
    }
  }
  updateItemList(data) {
    var list = jQuery(document.createElement("ul"));
    var item_count = 0;
    for (var id in data) {
      var item = jQuery(document.createElement("li"));
      if (item_count % 2 == 0) {
        item.addClass("row_on");
      } else {
        item.addClass("row_off");
      }
      item.attr("id", id).html(data[id]).click(function (e) {
        if (e.ctrlKey || e.metaKey) {
          // add to selection
          jQuery(this).addClass("selected");
        } else if (e.shiftKey) {
          var _start;
          // select range
          var start = jQuery(this).siblings(".selected").first();
          if (((_start = start) === null || _start === void 0 ? void 0 : _start.length) == 0) {
            // no start item - cannot select range - select single item
            jQuery(this).addClass("selected");
            return true;
          }
          var end = jQuery(this);
          // swap start and end if start appears after end in dom hierarchy
          if (start.index() > end.index()) {
            var startOld = start;
            start = end;
            end = startOld;
          }
          // select start to end
          start.addClass("selected");
          start.nextUntil(end).addClass("selected");
          end.addClass("selected");
        } else {
          // select single item
          jQuery(this).siblings(".selected").removeClass("selected");
          jQuery(this).addClass("selected");
        }
      });
      list.append(item);
      item_count++;
    }
    this.itemlist.html(list);
  }
}
_defineProperty$3(et2_itempicker, "_attributes", {
  "action": {
    "name": "Action callback",
    "type": "string",
    "default": false,
    "description": "Callback for action.  Must be a function(context, data)"
  },
  "action_label": {
    "name": "Action label",
    "type": "string",
    "default": "Action",
    "description": "Label for action button"
  },
  "application": {
    "name": "Application",
    "type": "string",
    "default": "",
    "description": "Limit to the listed application or applications (comma separated)"
  },
  "blur": {
    "name": "Placeholder",
    "type": "string",
    "default": et2_no_init,
    "description": "This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."
  },
  "value": {
    "name": "value",
    "type": "any",
    "default": "",
    "description": "Optional itempicker value(s) - can be used for e.g. environmental information"
  },
  "query": {
    "name": "Query callback",
    "type": "any",
    "default": false,
    "description": "Callback before query to server.  Must return true, or false to abort query."
  }
});
_defineProperty$3(et2_itempicker, "legacyOptions", ["application"]);
et2_register_widget(et2_itempicker, ["itempicker"]);

/**
 * EGroupware eTemplate2 - JS widget class containing javascript
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Ralf Becker
 */

/**
 * Function which executes the encapsulated script data.
 *
 * This should only be used for customization and NOT for regular EGroupware code!
 *
 * We can NOT create a script tag containing the content, as this violates our CSP policy!
 *
 * We use new Function(_content) instead. Therefore you have to use window to address global context:
 *
 * window.some_func = function() {...}
 *
 * instead of not working
 *
 * function some_funct() {...}
 *
 * @augments et2_widget
 */
class et2_script extends et2_widget {
  constructor(_parent, _attrs, _child) {
    super();
    // Allow no child widgets
    this.supportedWidgetClasses = [];
  }
  /**
   * We can NOT create a script tag containing the content, as this violoates our CSP policy!
   *
   * @param {string} _content
   */
  loadContent(_content) {
    try {
      var func = new Function(_content);
      func.call(window);
    } catch (e) {
      this.egw.debug('error', 'Error while executing script: ', _content, e);
    }
  }
}
et2_register_widget(et2_script, ["script"]);

function _defineProperty$2(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Class which implements the "countdown" XET-Tag
 *
 * Value for countdown is an integer duration in seconds or a server-side to a duration converted expiry datetime.
 *
 * The duration has the benefit, that it does not depend on the correct set time and timezone of the browser / computer of the user.
 */
class et2_countdown extends et2_valueWidget {
  /**
   * Constructor
   */
  constructor(_parent, _attrs, _child) {
    // Call the inherited constructor
    super(_parent, _attrs, ClassWithAttributes.extendAttributes(et2_countdown._attributes, _child || {}));

    // Build countdown dom container
    _defineProperty$2(this, "time", void 0);
    _defineProperty$2(this, "timer", null);
    _defineProperty$2(this, "container", null);
    _defineProperty$2(this, "days", null);
    _defineProperty$2(this, "hours", null);
    _defineProperty$2(this, "minutes", null);
    _defineProperty$2(this, "seconds", null);
    this.container = jQuery(document.createElement("div")).addClass("et2_countdown");
    this.days = jQuery(document.createElement("span")).addClass("et2_countdown_days").appendTo(this.container);
    this.hours = jQuery(document.createElement("span")).addClass("et2_countdown_hours").appendTo(this.container);
    this.minutes = jQuery(document.createElement("span")).addClass("et2_countdown_minutes").appendTo(this.container);
    this.seconds = jQuery(document.createElement("span")).addClass("et2_countdown_seconds").appendTo(this.container);
    this.setDOMNode(this.container[0]);
  }
  set_value(_time) {
    if (isNaN(_time)) return;
    super.set_value(_time);
    if (this.timer) {
      clearInterval(this.timer);
    }
    this.time = new Date();
    this.time.setSeconds(this.time.getSeconds() + parseInt(_time));
    var self = this;
    this.timer = setInterval(function () {
      if (self._updateTimer() <= 0) {
        clearInterval(self.timer);
        if (typeof self.onFinish == "function") self.onFinish();
      }
    }, 1000);
  }
  _updateTimer() {
    var now = new Date();
    var distance = this.time.getTime() - now.getTime();
    if (distance < 0) return 0;
    var alarms = [];
    if (Array.isArray(this.options.alarm)) {
      alarms = this.options.alarm;
    } else {
      alarms[this.options.alarm] = this.options.alarm;
    }

    // alarm values should be set as array index to reduce its time complexity from O(n) to O(1)
    // otherwise the execution time might be more than a second which would cause timer being delayed
    if (alarms[Math.floor(distance / 1000)] && typeof this.onAlarm == 'function') {
      console.log('alarm is called');
      this.onAlarm();
    }
    var values = {
      days: Math.floor(distance / (1000 * 60 * 60 * 24)),
      hours: Math.floor(distance % (1000 * 60 * 60 * 24) / (1000 * 60 * 60)),
      minutes: Math.floor(distance % (1000 * 60 * 60) / (1000 * 60)),
      secounds: Math.floor(distance % (1000 * 60) / 1000)
    };
    this.days.text(values.days + this._getIndicator("days"));
    this.hours.text(values.hours + this._getIndicator("hours"));
    this.minutes.text(values.minutes + this._getIndicator("minutes"));
    this.seconds.text(values.secounds + this._getIndicator("seconds"));
    if (this.options.hideEmpties) {
      if (values.days == 0) {
        this.days.hide();
        if (values.hours == 0) {
          this.hours.hide();
          if (values.minutes == 0) {
            this.minutes.hide();
            if (values.secounds == 0) this.seconds.hide();
          }
        }
      }
    }
    if (this.options.precision) {
      var units = ['days', 'hours', 'minutes', 'seconds'];
      for (var u = 0; u < 4; ++u) {
        if (values[units[u]]) {
          for (var n = u + this.options.precision; n < 4; n++) {
            this[units[n]].hide();
          }
          break;
        } else {
          this[units[u]].hide();
        }
      }
    }
    return distance;
  }
  _getIndicator(_v) {
    return this.options.format == 's' ? egw$1.lang(_v).substr(0, 1) : egw$1.lang(_v);
  }
}
_defineProperty$2(et2_countdown, "_attributes", {
  format: {
    name: "display format",
    type: "string",
    default: "s",
    // s or l
    description: "Defines display format; s (Initial letter) or l (Complete word) display, default is s."
  },
  onFinish: {
    name: "on finish countdown",
    type: "js",
    default: et2_no_init,
    description: "Callback function to call when the countdown is finished."
  },
  hideEmpties: {
    name: "hide empties",
    type: "string",
    default: true,
    description: "Only displays none empty values."
  },
  precision: {
    name: "how many counters to show",
    type: "integer",
    default: 0,
    // =all
    description: "Limit number of counters, eg. 2 does not show minutes and seconds, if days are displayed"
  },
  alarm: {
    name: "alarm",
    type: "any",
    default: "",
    description: "Defines an alarm set before the countdown is finished, it should be in seconds"
  },
  onAlarm: {
    name: "alarm callback",
    type: "js",
    default: "",
    description: "Defines a callback to gets called at alarm - timer. This only will work if there's an alarm set."
  }
});
et2_register_widget(et2_countdown, ["countdown"]);

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
/**
 * UI for VFS Select widget
 *
 */
class vfsSelectUI extends EgwApp {
  /**
   * Constructor
   *
   */
  constructor() {
    // call parent
    super('vfsSelectUI');
    _defineProperty$1(this, "appname", void 0);
    _defineProperty$1(this, "dirContent", void 0);
    _defineProperty$1(this, "vfsSelectWidget", void 0);
    _defineProperty$1(this, "path_widget", void 0);
    this.egw.langRequireApp(this.egw.window, 'filemanager');
  }

  /**
   * Destructor
   */
  destroy(_app) {
    delete this.path_widget;
    delete this.vfsSelectWidget;
    // call parent
    super.destroy(_app);
  }

  /**
   * This function is called when the etemplate2 object is loaded
   * and ready.  If you must store a reference to the et2 object,
   * make sure to clean it up in destroy().
   *
   * @param et2 etemplate2 Newly ready object
   * @param {string} name template name
   */
  et2_ready(et2, name) {
    this.path_widget = this.et2.getWidgetById('path');
    this.dirContent = this.et2.getArrayMgr('content').data.dir;
  }

  /**
   * Get directory of a path
   *
   * @param {string} _path
   * @returns string
   */
  dirname(_path) {
    var parts = _path.split('/');
    parts.pop();
    return parts.join('/') || '/';
  }

  /**
   * Get name of a path
   *
   * @param {string} _path
   * @returns string
   */
  basename(_path) {
    return _path.split('/').pop();
  }

  /**
   * Get current working directory
   *
   * @return string
   */
  get_path() {
    return this.path_widget.get_value();
  }

  /**
   * Send names of uploaded files (again) to server,
   * to process them: either copy to vfs or ask overwrite/rename
   *
   * @param {event} _event
   */
  storeFile(_event) {
    var path = this.get_path();
    if (!jQuery.isEmptyObject(_event.data.getValue())) {
      var widget = _event.data;
      egw$1(window).json('EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_vfsSelect_storeFile', [widget.getValue(), path], this._storeFile_callback, this, true, this).sendRequest(true);
      widget.set_value('');
    }
  }

  /**
   * Callback for server response to storeFile request:
   * - display message and refresh list
   * - ask use to confirm overwritting existing files or rename upload
   *
   * @param {object} _data values for attributes msg, files, ...
   */
  _storeFile_callback(_data) {
    if (_data.msg || _data.uploaded) egw$1(window).message(_data.msg);
    var that = this;
    for (var file in _data.uploaded) {
      if (_data.uploaded[file].confirm && !_data.uploaded[file].confirmed) {
        var buttons = [{
          label: this.egw.lang("Yes"),
          id: "overwrite",
          class: "ui-priority-primary",
          "default": true,
          image: 'check'
        }, {
          label: this.egw.lang("Rename"),
          id: "rename",
          image: 'edit'
        }, {
          label: this.egw.lang("Cancel"),
          id: "cancel"
        }];
        if (_data.uploaded[file].confirm === "is_dir") {
          buttons.shift();
        }
        var dialog = Et2Dialog$1.show_prompt(function (_button_id, _value) {
          var uploaded = {};
          uploaded[this.my_data.file] = this.my_data.data;
          switch (_button_id) {
            case "overwrite":
              uploaded[this.my_data.file].confirmed = true;
            // fall through
            case "rename":
              uploaded[this.my_data.file].name = _value;
              delete uploaded[this.my_data.file].confirm;
              // send overwrite-confirmation and/or rename request to server
              egw$1.json('EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_vfsSelect_storeFile', [uploaded, this.my_data.path], that._storeFile_callback, that, true, that).sendRequest();
              return;
            case "cancel":
              // Remove that file from every file widget...
              that.et2.iterateOver(function (_widget) {
                _widget.remove_file(this.my_data.data.name);
              }, this, et2_file);
          }
        }, _data.uploaded[file].confirm === "is_dir" ? this.egw.lang("There's already a directory with that name!") : this.egw.lang('Do you want to overwrite existing file %1 in directory %2?', _data.uploaded[file].name, _data.path), this.egw.lang('File %1 already exists', _data.uploaded[file].name), _data.uploaded[file].name, buttons, file);
        // setting required data for callback in as my_data
        dialog.my_data = {
          file: file,
          path: _data.path,
          data: _data.uploaded[file]
        };
      } else {
        this.submit();
      }
    }
  }

  /**
   * Prompt user for directory to create
   *
   * @param {egwAction|undefined|jQuery.Event} action Action, event or undefined if called directly
   * @param {egwActionObject[] | undefined} selected Selected row, or undefined if called directly
   */
  createdir(action, selected) {
    var self = this;
    Et2Dialog$1.show_prompt(function (button, dir) {
      if (button && dir) {
        var path = self.get_path();
        self.egw.json('EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_create_dir', [dir, path], function (msg) {
          self.egw.message(msg);
          self.change_dir((path == '/' ? '' : path) + '/' + dir);
        }).sendRequest(false);
      }
    }, this.egw.lang('New directory'), this.egw.lang('Create directory'));
  }

  /**
   * Change directory
   *
   * @param {string} _dir directory to change to incl. '..' for one up
   */
  change_dir(_dir) {
    if (_dir == '..') {
      _dir = this.dirname(this.get_path());
    }
    this.path_widget.set_value(_dir);
  }

  /**
   * Row or filename in select-file dialog clicked
   *
   * @param {jQuery.event} event
   * @param {et2_widget} widget
   */
  select_clicked(event, widget) {
    if (!widget || typeof widget.value != 'object') {} else if (widget.value.is_dir)
      // true for "httpd/unix-directory" and "egw/*"
      {
        var path = widget.getRoot().getWidgetById("path");
        if (path) {
          path.set_value(widget.value.path);
        }
      } else if (this.et2 && this.et2.getArrayMgr('content').getEntry('mode') != 'open-multiple') {
      this.et2.setValueById('name', widget.value.name);
    } else {
      var file = widget.value.name;
      widget.getParent().iterateOver(function (widget) {
        if (widget.options.selectedValue === file) {
          widget.set_value(widget.get_value() === file ? widget.options.unselectedValue : file);
        }
      }, null, Et2Checkbox);
    }
    // Stop event or it will toggle back off
    event.preventDefault();
    event.stopPropagation();
    return false;
  }

  /**
   * Handles action and offer it to the submit
   *
   * @param {string} action action name
   * @param {object} widget widget which action was called from
   */
  do_action(action, widget) {
    if (!this.et2) {
      // Etemplate has already gone
      return;
    }
    if (!action && widget && widget.id) {
      action = widget.id;
    }
    if (!action) {
      return;
    }
    var field = '',
      value = '';
    switch (action) {
      case 'path':
        field = 'path';
        value = widget.getValue();
        break;
      case 'home':
        field = 'action';
        value = 'home';
        break;
      case 'app':
        field = 'app';
        value = widget.getValue();
        break;
      case 'mime':
        field = 'mime';
        value = widget.getValue();
        break;
    }
    this.submit(field, value);
    return false;
  }

  /**
   * Sumbits content value after modification
   *
   * @param {string} _field content field to be modified
   * @param {any} _val value of field
   * @param {function} _callback
   */
  submit(_field, _val, _callback) {
    var arrMgrs = this.et2.getArrayMgrs();
    if (_field) {
      arrMgrs.content.data[_field] = _val;
      jQuery.extend(arrMgrs.content.data, arrMgrs.modifications.data);
      this.et2.setArrayMgrs(arrMgrs);
    }

    // preserve value of the name
    if (arrMgrs && this.et2.getWidgetById('name')) {
      arrMgrs.content.data['name'] = this.et2.getWidgetById('name').get_value();
    }
    this.vfsSelectWidget._content(arrMgrs.content.data, _callback);
  }

  /**
   * search through dir content and set its content base on searched query
   * @returns
   */
  search(_ev, _widget) {
    var dir = this.et2.getWidgetById('dir');
    var query = _widget.get_value();
    if (query == "") {
      dir.set_value({
        content: this.dirContent
      });
      return;
    }
    var self = this;
    var searchQuery = function searchQuery(_query) {
      var result = {};
      var reg = RegExp(_query, 'ig');
      var key = 0;
      for (var i in self.dirContent) {
        if (typeof self.dirContent[i]['name'] != 'undefined' && self.dirContent[i]['name'].match(reg)) {
          result[key] = self.dirContent[i];
          key++;
        } else if (typeof self.dirContent[i]['name'] == 'undefined' && isNaN(i)) {
          result[i] = self.dirContent[i];
        }
      }
      return result;
    };
    dir.set_value({
      content: searchQuery(query)
    });
  }
}
app.classes.vfsSelectUI = vfsSelectUI;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The etemplate2 class manages a certain etemplate2 instance.
 *
 * @param _container is the DOM-Node into which the DOM-Nodes of this instance
 * 	should be inserted
 * @param _menuaction is the URL to which the form data should be submitted.
 */
class etemplate2$1 {
  constructor(_container, _menuaction, _uniqueId) {
    _defineProperty(this, "_etemplate_exec_id", void 0);
    _defineProperty(this, "menuaction", void 0);
    _defineProperty(this, "name", void 0);
    _defineProperty(this, "uniqueId", void 0);
    _defineProperty(this, "template_base_url", void 0);
    _defineProperty(this, "_widgetContainer", void 0);
    _defineProperty(this, "_DOMContainer", void 0);
    _defineProperty(this, "resize_timeout", void 0);
    _defineProperty(this, "destroy_session", void 0);
    _defineProperty(this, "close_prompt", void 0);
    _defineProperty(this, "_skip_close_prompt", void 0);
    _defineProperty(this, "app_obj", void 0);
    _defineProperty(this, "app", void 0);
    /**
     * Flag indicating that all loading is done, and the etemplate is ready to be used by app.js
     *
     * onChange handler checks this to ignore change events before the etemplate is ready
     */
    _defineProperty(this, "ready", false);
    if (typeof _menuaction == "undefined") {
      _menuaction = "EGroupware\\Api\\Etemplate::ajax_process_content";
    }

    // Copy the given parameters
    this._DOMContainer = _container;
    this.menuaction = _menuaction;

    // Unique ID to prevent DOM collisions across multiple templates
    this.uniqueId = _uniqueId ? _uniqueId : _container.getAttribute("id") ? _container.getAttribute("id").replace('.', '-') : '';

    /**
     * Preset the object variable
     * @type {et2_container}
     */
    this._widgetContainer = null;

    // List of templates (XML) that are known, not always used.  Indexed by id.
    // We share list of templates with iframes and popups
    try {
      if (opener && opener.etemplate2) {
        etemplate2$1.templates = opener.etemplate2.templates;
      }
      // @ts-ignore
      else if (top.etemplate2) {
        // @ts-ignore
        etemplate2$1.templates = top.etemplate2.templates;
      }
    } catch (e) {
      // catch security exception if opener is from a different domain
      console.log('Security exception accessing etemplate2.prototype of opener or top!');
    }
    if (typeof etemplate2$1.templates == "undefined") {
      etemplate2$1.templates = {};
    }
  }

  /**
   * Calls the resize event of all widgets
   *
   * @param {jQuery.event} e
   */
  resize(e) {
    var event = e;
    var self = this;
    var excess_height = false;

    // Check if the framework has an specific excess height calculation
    if (typeof window.framework != 'undefined' && typeof window.framework.get_wExcessHeight != 'undefined') {
      excess_height = window.framework.get_wExcessHeight(window);
    }

    //@TODO implement getaccess height for other framework and remove
    if (typeof event != 'undefined' && event.type == 'resize') {
      if (this.resize_timeout) {
        clearTimeout(this.resize_timeout);
      }
      this.resize_timeout = setTimeout(function () {
        self.resize_timeout = false;
        if (self._widgetContainer) {
          var appHeader = jQuery('#divAppboxHeader');

          //Calculate the excess height
          excess_height = egw$1(window).is_popup() ? jQuery(window).height() - jQuery(self._DOMContainer).height() - appHeader.outerHeight() + 11 : 0;
          // Recalculate excess height if the appheader is shown
          if (appHeader.length > 0 && appHeader.is(':visible')) {
            excess_height -= appHeader.outerHeight() - 9;
          }

          // Do not resize if the template height is bigger than screen available height
          // For templates which have sub templates and they are bigger than screenHeight
          if (screen.availHeight < jQuery(self._DOMContainer).height()) {
            excess_height = 0;
          }

          // If we're visible, call the "resize" event of all functions which implement the
          // "IResizeable" interface
          if (jQuery(self.DOMContainer).is(":visible")) {
            self._widgetContainer.iterateOver(function (_widget) {
              if (typeof _widget.resize === 'function') {
                _widget.resize(excess_height);
              }
            }, self, et2_IResizeable);
          }
        }
      }, 100);
    }
    // Initial resize needs to be resized immediately (for instance for nextmatch resize)
    else if (this._widgetContainer) {
      // Call the "resize" event of all functions which implement the
      // "IResizeable" interface
      this._widgetContainer.iterateOver(function (_widget) {
        _widget.resize(excess_height);
      }, this, et2_IResizeable);
    }
  }
  /**
   * Clears the current instance.
   * @param _keep_app_object keep app object
   * @param _keep_session keep server-side et2 session eg. for vfs-select
   */
  clear(_keep_app_object, _keep_session) {
    this.DOMContainer.dispatchEvent(new Event("clear", {
      bubbles: true
    }));

    // Remove any handlers on window (resize)
    if (this.uniqueId) {
      jQuery(window).off("." + this.uniqueId);
    }

    // call our destroy_session handler, if it is not already unbind, and unbind it after
    if (this.destroy_session) {
      if (!_keep_session) {
        this.destroy_session();
      }
      this.unbind_unload();
    }
    if (this._widgetContainer != null) {
      // Un-register handler
      this._widgetContainer.egw().unregisterJSONPlugin(this.handle_assign, this, 'assign');
      this._widgetContainer.destroy();
      this._widgetContainer = null;
    }
    jQuery(this._DOMContainer).empty();

    // Remove self from the index
    for (var name in etemplate2$1.templates) {
      if (typeof etemplate2$1._byTemplate[name] == "undefined") {
        continue;
      }
      for (var i = 0; i < etemplate2$1._byTemplate[name].length; i++) {
        if (etemplate2$1._byTemplate[name][i] === this) {
          etemplate2$1._byTemplate[name].splice(i, 1);
        }
      }
    }

    // If using a private app object, remove all of them
    if (!_keep_app_object && this.app_obj !== window.app) {
      for (var app_name in this.app_obj) {
        if (this.app_obj[app_name] instanceof EgwApp) {
          this.app_obj[app_name].destroy(this.app_obj);
        }
      }
    }
  }
  get widgetContainer() {
    return this._widgetContainer;
  }
  get DOMContainer() {
    return this._DOMContainer;
  }
  get etemplate_exec_id() {
    return this._etemplate_exec_id;
  }
  get isReady() {
    return this.ready;
  }

  /**
   * Creates an associative array containing the data array managers for each part
   * of the associative data array. A part is something like "content", "readonlys"
   * or "sel_options".
   *
   * @param {object} _data object with values for attributes content, sel_options, readonlys, modifications
   */
  _createArrayManagers(_data) {
    if (typeof _data == "undefined") {
      _data = {};
    }

    // Create all neccessary _data entries
    var neededEntries = ["content", "sel_options", "readonlys", "modifications", "validation_errors"];
    for (var i = 0; i < neededEntries.length; i++) {
      if (typeof _data[neededEntries[i]] == "undefined" || !_data[neededEntries[i]]) {
        egw$1.debug("log", "Created not passed entry '" + neededEntries[i] + "' in data array.");
        _data[neededEntries[i]] = {};
      }
    }
    var result = {};

    // Create an array manager object for each part of the _data array.
    for (var key in _data) {
      switch (key) {
        case "etemplate_exec_id": // already processed
        case "app_header":
          break;
        case "readonlys":
          result[key] = new et2_readonlysArrayMgr(_data[key]);
          result[key].perspectiveData.owner = this._widgetContainer;
          break;
        default:
          result[key] = new et2_arrayMgr(_data[key]);
          result[key].perspectiveData.owner = this._widgetContainer;
      }
    }
    return result;
  }

  /**
   * Bind our unload handler to notify server that eT session/request no longer needed
   *
   * We only bind, if we have an etemplate_exec_id: not the case for pure client-side
   * calls, eg. via et2_dialog.
   */
  bind_unload() {
    // Prompt user to save for dirty popups
    if (window !== egw_topWindow() && !this.close_prompt) {
      this.close_prompt = this._close_changed_prompt.bind(this);
      window.addEventListener("beforeunload", this.close_prompt);
    } else if (window == egw_topWindow()) {
      window.addEventListener("beforeunload", this.destroy_session);
    }
    if (this._etemplate_exec_id) {
      this.destroy_session = jQuery.proxy(function (ev) {
        // need to use async === "keepalive" to run via beforeunload
        egw$1.json("EGroupware\\Api\\Etemplate::ajax_destroy_session", [this._etemplate_exec_id], null, null, "keepalive").sendRequest();
      }, this);
      window.addEventListener("unload", this.destroy_session);
    }
  }
  _close_changed_prompt(e) {
    if (this._skip_close_prompt || !this.isDirty()) {
      return;
    }

    // Cancel the event
    e.preventDefault(); // If you prevent default behavior in Mozilla Firefox prompt will always be shown

    // Chrome requires returnValue to be set
    e.returnValue = '';
    return "";
  }
  skip_close_prompt() {
    var skip = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
    this._skip_close_prompt = skip;
  }

  /**
   * Unbind our unload handler
   */
  unbind_unload() {
    window.removeEventListener("beforeunload", this.destroy_session);
    window.removeEventListener("beforeunload", this.close_prompt);
    if (window.onbeforeunload === this.destroy_session) {
      window.onbeforeunload = null;
    } else {
      var onbeforeunload = window.onbeforeunload;
      window.onbeforeunload = null;
      // bind unload handler again (can NOT do it direct, as this would be quick enough to be still triggered!)
      window.setTimeout(function () {
        window.onbeforeunload = onbeforeunload;
      }, 100);
    }
    delete this.destroy_session;
  }

  /**
   * Download a URL not triggering our unload handler and therefore destroying our et2 request
   *
   * We use a new anchor element to avoid not destroying other etemplates as well, which
   * is what happens if we use window.location
   *
   * @param {string} _url
   */
  download(_url) {
    var a = document.createElement('a');
    a.href = _url;
    a.download = 'download';

    // Programmatically trigger a click on the anchor element
    a.click();
  }

  /**
   * Loads the template from the given URL and sets the data object
   *
   * @param {string} _name name of template
   * @param {string} _url url to load template
   * @param {object} _data object with attributes content, langRequire, etemplate_exec_id, ...
   * @param {function} _callback called after template is loaded
   * @param {object} _app local app object
   * @param {boolean} _no_et2_ready true: do not send et2_ready, used by et2_dialog to not overwrite app.js et2 object
   * @param {string} _open_target flag of string to distinguish between tab target and normal app object
   * @return Promise
   */
  load(_name, _url, _data, _callback, _app, _no_et2_ready, _open_target) {
    var _this = this;
    return _asyncToGenerator(function* () {
      _this.ready = false;
      var app = _app || window.app;
      _this.name = _name; // store top-level template name to have it available in widgets
      // store template base url, in case initial template is loaded via webdav, to use that for further loads too
      // need to split off domain first, as it could contain app-name part of template eg. stylite.report.xet and https://my.stylite.de/egw/...
      if (_url && _url[0] != '/') {
        _this.template_base_url = _url.match(/https?:\/\/[^/]+/).shift();
        _url = _url.split(_this.template_base_url)[1];
      } else {
        _this.template_base_url = '';
      }
      _this.template_base_url += _url.split(_name.split('.').shift())[0];
      egw$1().debug("info", "Loaded data", _data);
      var currentapp = _this.app = _data.currentapp || egw$1().app_name();
      var appname = _name.split('.')[0];
      // if no app object provided and template app is not currentapp (eg. infolog CRM view)
      // create private app object / closure with just classes / prototypes
      if (!_app && appname && appname != currentapp || _open_target) {
        app = {
          classes: window.app.classes
        };
      }
      // remember used app object, to eg. use: onchange="widget.getInstanceMgr().app_object[app].callback()"
      _this.app_obj = app;

      // extract $content['msg'] and call egw.message() with it
      var msg = _data.content.msg;
      if (typeof msg != 'undefined') {
        egw$1(window).message(msg);
        delete _data.content.msg;
      }

      // Register a handler for AJAX responses
      egw$1(currentapp, window).registerJSONPlugin(_this.handle_assign, _this, 'assign');
      if (egw$1.debug_level() >= 3) {
        if (console.groupCollapsed) {
          egw$1.window.console.groupCollapsed("Loading %s into ", _name, '#' + _this._DOMContainer.id);
        }
      }
      // Timing & profiling on debug level 'log' (4)
      if (egw$1.debug_level() >= 4) {
        if (console.time) {
          console.time(_name);
        }
        if (console.profile) {
          console.profile(_name);
        }
        var start_time = new Date().getTime();
      }

      // require necessary translations from server AND the app.js file, if not already loaded
      var promisses = [window.egw_ready]; // to wait for legacy-loaded JS
      if (Array.isArray(_data.langRequire)) {
        promisses.push(egw$1(currentapp, window).langRequire(window, _data.langRequire));
      }
      if (appname && typeof app[appname] !== "object") {
        /*
        Don't have the app.ts code - load it here and delay load until its ready
        			promisses.push(import(egw.webserverUrl + "/" + appname + "/js/app.min.js?" + ((new Date).valueOf() / 86400 | 0).toString())
        				.then(() =>
        				{
        					if(typeof app.classes[appname] === "undefined")
        					{
        						throw new Error("app.classes." + appname + " not found!");
        					}
        				}));
        */
      }
      return Promise.all(promisses).catch(err => {
        console.log("et2.load(): error loading lang-files and app.js: " + err.message);
      }).then(() => {
        _this.clear();

        // Initialize application js
        var app_callback = null;
        // Only initialize once
        // new app class with constructor function in app.classes[appname]
        if (typeof app[appname] !== 'object' && typeof app.classes[appname] == 'function') {
          app[appname] = new app.classes[appname]();
        } else if (appname && typeof app[appname] !== "object") {
          egw$1.debug("warn", "Did not load '%s' JS object", appname);
        }
        // If etemplate current app does not match app owning the template,
        // initialize the current app too
        if (typeof app[_this.app] !== 'object' && typeof app.classes[_this.app] == 'function') {
          app[_this.app] = new app.classes[_this.app]();
        }
        if (typeof app[appname] == "object") {
          app_callback = function app_callback(_et2, _name) {
            app[appname].et2_ready(_et2, _name);
          };
        }

        // Create the basic widget container and attach it to the DOM
        _this._widgetContainer = new et2_container(null);
        _this._widgetContainer.setApiInstance(egw$1(currentapp, egw$1.elemWindow(_this._DOMContainer)));
        _this._widgetContainer.setInstanceManager(_this);
        _this._widgetContainer.setParentDOMNode(_this._DOMContainer);

        // store the id to submit it back to server
        if (_data) {
          _this._etemplate_exec_id = _data.etemplate_exec_id;
          // set app_header
          if (typeof _data.app_header == 'string') {
            // @ts-ignore
            window.egw_app_header(_data.app_header);
          }
          // bind our unload handler
          _this.bind_unload();
        }
        var _load = function _load() {
          egw$1.debug("log", "Loading template...");
          if (egw$1.debug_level() >= 4 && console.timeStamp) {
            console.timeStamp("Begin rendering template");
            console.time("Template load");
            console.time("loadFromXML");
          }

          // Add into indexed list - do this before, so anything looking can find it,
          // even if it's not loaded
          if (typeof etemplate2$1._byTemplate[_name] == "undefined") {
            etemplate2$1._byTemplate[_name] = [];
          }
          etemplate2$1._byTemplate[_name].push(this);

          // Read the XML structure of the requested template
          this._widgetContainer.loadFromXML(etemplate2$1.templates[this.name]);
          console.timeEnd("loadFromXML");
          console.time("deferred");

          // List of Promises from widgets that are not quite fully loaded
          var deferred = [];

          // Inform the widget tree that it has been successfully loaded.
          this._widgetContainer.loadingFinished(deferred);

          // Connect to the window resize event
          jQuery(window).on("resize." + this.uniqueId, this, function (e) {
            e.data.resize(e);
          });
          if (egw$1.debug_level() >= 3 && console.groupEnd) {
            if (console.timeStamp) {
              console.timeStamp("loading finished, waiting for deferred");
            }
            egw$1.window.console.groupEnd();
          }

          // Wait for everything to be loaded, then finish it up.  Use timeout to give anything else a chance
          // to run.
          setTimeout(() => {
            Promise.all(deferred).then(() => {
              console.timeEnd("deferred");
              console.timeStamp("Deferred done");
              // Clear dirty now that it's all loaded
              this.widgetContainer.iterateOver(_widget => {
                _widget.resetDirty();
              }, this, et2_IInput);
              egw$1.debug("log", "Finished loading %s, triggering load event", _name);
              if (typeof window.framework != 'undefined' && typeof window.framework.et2_loadingFinished != 'undefined') {
                //Call loading finished method of the framework with local window
                window.framework.et2_loadingFinished(egw$1(window).window);
              }
              // Trigger the "resize" event
              this.resize();

              // Automatically set focus to first visible input for popups
              if (this._widgetContainer._egw.is_popup() && jQuery('[autofocus]', this._DOMContainer).focus().length == 0) {
                this.focusOnFirstInput();
              }

              // Now etemplate is ready for others to interact with (eg: app.js)
              this.ready = true;

              // Tell others about it
              if (typeof _callback == "function") {
                _callback.call(window, this, _name);
              }
              if (app_callback && _callback != app_callback && !_no_et2_ready) {
                app_callback.call(window, this, _name);
              }
              if (appname && appname != this.app && typeof app[this.app] == "object" && !_no_et2_ready) {
                // Loaded a template from a different application?
                // Let the application that loaded it know too
                app[this.app].et2_ready(this, this.name);
              }

              // Dispatch an event that will bubble through shadow DOM boundary (pass through custom elements)
              this._DOMContainer.dispatchEvent(new CustomEvent('load', {
                bubbles: true,
                composed: true,
                detail: this
              }));
              if (etemplate2$1.templates[this.name].attributes.onload) {
                var onload = et2_checkType(etemplate2$1.templates[this.name].attributes.onload.value, 'js', 'onload', {});
                if (typeof onload === 'string') {
                  onload = et2_compileLegacyJS(onload, this, this._widgetContainer);
                }
                onload.call(this._widgetContainer);
              }

              // Profiling
              if (egw$1.debug_level() >= 4) {
                if (console.timeEnd) {
                  console.timeEnd(_name);
                }
                if (console.profileEnd) {
                  console.profileEnd(_name);
                }
                var end_time = new Date().getTime();
                var gen_time_div = jQuery('#divGenTime_' + appname);
                if (!gen_time_div.length) {
                  gen_time_div = jQuery('.pageGenTime');
                }
                gen_time_div.find('.et2RenderTime').remove();
                gen_time_div.append('<span class="et2RenderTime">' + egw$1.lang('eT2 rendering took %1s', '' + (end_time - start_time) / 1000) + '</span>');
              }
            });
          });
        };

        // Load & process
        try {
          if (etemplate2$1.templates[_name]) {
            // Set array managers first, or errors will happen
            _this._widgetContainer.setArrayMgrs(_this._createArrayManagers(_data));

            // Already have it
            _load.apply(_this, []);
            return;
          }
        } catch (e) {
          // weird security exception in IE denying access to template cache in opener
          if (e.message == 'Permission denied') {
            etemplate2$1.templates = {};
          }
          // other error eg. in app.js et2_ready or event handlers --> rethrow it
          else {
            throw e;
          }
        }
        // Split the given data into array manager objects and pass those to the
        // widget container - do this here because file is loaded async
        _this._widgetContainer.setArrayMgrs(_this._createArrayManagers(_data));

        // Asynchronously load the XET file
        return et2_loadXMLFromURL(_url, function (_xmldoc) {
          // Scan for templates and store them
          for (var i = 0; i < _xmldoc.childNodes.length; i++) {
            var template = _xmldoc.childNodes[i];
            if (template.nodeName.toLowerCase() != "template") {
              continue;
            }
            etemplate2$1.templates[template.getAttribute("id")] = template;
            if (!_name) {
              this.name = template.getAttribute("id");
            }
          }
          _load.apply(this, []);
        }, _this);
      });
    })();
  }
  focusOnFirstInput() {
    var $input = jQuery('input:visible,et2-textbox:visible,et2-select-email:visible', this.DOMContainer)
    // Date fields open the calendar popup on focus
    .not('.et2_date').filter(function () {
      // Skip inputs that are out of tab ordering
      var $this = jQuery(this);
      return !$this.attr('tabindex') || parseInt($this.attr('tabIndex')) >= 0;
    }).first();

    // mobile device, focus only if the field is empty (usually means new entry)
    // should focus always for non-mobile one
    if (egwIsMobile$1() && $input.val() == "" || !egwIsMobile$1()) {
      $input.focus();
    }
  }

  /**
   * Check if template contains any dirty (unsaved) content
   *
   * @returns {Boolean}
   */
  isDirty() {
    var _this$_widgetContaine;
    var dirty = false;
    (_this$_widgetContaine = this._widgetContainer) === null || _this$_widgetContaine === void 0 || _this$_widgetContaine.iterateOver(function (_widget) {
      if (_widget.isDirty && _widget.isDirty()) {
        console.info(_widget.id + " is dirty", _widget);
        dirty = true;
      }
    }, this);
    return dirty;
  }

  /**
   * Submit the et2_container form to a blank iframe in order to activate browser autocomplete
   */
  autocomplete_fixer() {
    var self = this;
    var form = self._DOMContainer;

    // Safari always do the autofill for password field regardless of autocomplete = off
    // and since there's no other way to switch the autocomplete of, we should switch the
    // form autocomplete off (e.g. compose dialog, attachment password field)
    if (navigator.userAgent.match(/safari/i) && !navigator.userAgent.match(/chrome/i) && jQuery('input[type="password"]').length > 0) {
      return;
    }
    if (form) {
      // Stop submit propagation in order to not fire other possible submit events
      form.onsubmit = function (e) {
        e.stopPropagation();
      };

      // Firefox give a security warning when transmitting to "about:blank" from a https site
      // we work around that by giving existing etemplate/empty.html url
      // Safari shows same warning, thought Chrome userAgent also includes Safari
      if (navigator.userAgent.match(/(firefox|safari|iceweasel)/i) && !navigator.userAgent.match(/chrome/i)) {
        jQuery(form).attr({
          action: egw$1.webserverUrl + '/api/templates/default/empty.html',
          method: 'post'
        });
      }
      // need to trigger submit because submit() would not trigger onsubmit event
      // since the submit does not get fired directly via user interaction.
      jQuery(form).trigger('submit');
    }
  }
  _set_button(button, values) {
    if (typeof button == 'string') {
      button = this._widgetContainer.getWidgetById(button);
    }
    // Button parameter used for submit buttons in datagrid
    // TODO: This should probably go in nextmatch's getValues(), along with selected rows somehow.
    // I'm just not sure how.
    if (button && !values.button) {
      var i;
      values.button = {};
      var path = button.getPath();
      var target = values;
      for (i = 0; i < path.length; i++) {
        if (!values[path[i]]) {
          values[path[i]] = {};
        }
        target = values[path[i]];
      }
      if (target != values || button.id.indexOf('[') != -1 && path.length == 0) {
        var indexes = button.id.split('[');
        if (indexes.length > 1) {
          indexes = [indexes.shift(), indexes.join('[')];
          indexes[1] = indexes[1].substring(0, indexes[1].length - 1);
          var children = indexes[1].split('][');
          if (children.length) {
            indexes = jQuery.merge([indexes[0]], children);
          }
        }
        var idx = '';
        for (i = 0; i < indexes.length; i++) {
          idx = indexes[i];
          if (!target[idx] || target[idx]['$row_cont']) {
            target[idx] = i < indexes.length - 1 ? {} : true;
          }
          target = target[idx];
        }
      } else if (typeof values.button == 'undefined' || jQuery.isEmptyObject(values.button)) {
        delete values.button;
        values[button.id] = true;
      }
    }
  }

  /**
   * Check if there is an invalid widget / all widgets are valid
   *
   * @param container
   * @param values
   * @return Promise<et2_widget>|Promise<Et2Widget>|null
   */
  isInvalid(container, values) {
    var _this2 = this;
    return _asyncToGenerator(function* () {
      if (typeof container === 'undefined') {
        container = _this2._widgetContainer;
      }
      if (typeof values === 'undefined') {
        values = _this2.getValues(container);
      }
      var invalid = [];
      container.iterateOver(function (_widget) {
        var submit = _widget.submit(values);
        if (submit === false) {
          invalid.push(_widget);
        } else if (submit instanceof Promise) {
          invalid.push(submit.then(function (ok) {
            return ok ? false : this;
          }.bind(_widget)));
        }
      }, _this2, et2_ISubmitListener);
      return Promise.all(invalid);
    })();
  }

  /**
   * Submit form via ajax
   *
   * @param {(et2_button|string)} button button widget or string with id
   * @param {boolean|string} async true: do an asynchronious submit, string: spinner message (please wait...)
   * default is asynchronoush with message
   * @param {boolean} no_validation - Do not do individual widget validation, just submit their current values
   * @param {et2_widget|undefined} _container container to submit, default whole template
   * @return {boolean} true if submit was send, false if eg. validation stoped submit
   */
  submit(button, async, no_validation, _container) {
    var api = this._widgetContainer.egw();
    if (typeof no_validation == 'undefined') {
      no_validation = false;
    }
    var container = _container || this._widgetContainer;

    // Get the form values
    var values = this.getValues(container);
    var doSubmit = () => {
      if (typeof async == 'undefined' || typeof async == 'string') {
        api.loading_prompt('et2_submit_spinner', true, api.lang(typeof async == 'string' ? async : 'Please wait...'));
        async = true;
      }
      if (button) {
        this._set_button(button, values);
      }

      // Create the request object
      if (this.menuaction) {
        //Autocomplete
        this.autocomplete_fixer();

        // unbind our session-destroy handler, as we are submitting
        this.unbind_unload();
        var request = api.json(this.menuaction, [this._etemplate_exec_id, values, no_validation], function () {
          api.loading_prompt('et2_submit_spinner', false);
        }, this, async);
        var request_promise = request.sendRequest();

        // Set up timeout for 30 seconds
        var warning_message = null;
        var timeout_id = window.setTimeout(() => {
          // Do not abort request, it might still come
          api.debug("warn", "Request '" + this.menuaction + "' timeout");
          warning_message = api.message(api.lang("No response from server: your data is probably NOT saved"), "warning");
          api.loading_prompt('et2_submit_spinner', false);
        }, 30000);

        // Cancel timeout
        request_promise.then(() => {
          // Responded  * and response processed *
          clearTimeout(timeout_id);
          if (warning_message) {
            warning_message.close();
          }
        });
      } else {
        this._widgetContainer.egw().debug("warn", "Missing menuaction for submit.  Values: ", values);
      }
    };

    // Trigger the submit event
    var canSubmit = true;
    var invalid = null;
    if (!no_validation) {
      var _invalid;
      canSubmit = !(invalid = this.isInvalid(container, values));
      (_invalid = invalid) === null || _invalid === void 0 || _invalid.then(widgets => {
        var invalid_widgets = widgets.filter(widget => widget);
        if (invalid_widgets.length && !(invalid_widgets[0] instanceof et2_widget)) {
          // Handle validation_error (messages coming back from server as a response) if widget is children of a tabbox
          var tmpWidget = invalid_widgets[0];
          while (tmpWidget.getParent() && tmpWidget.getType() !== 'ET2-TABBOX') {
            tmpWidget = tmpWidget.getParent();
          }
          //Activate the tab where the widget with validation error is located
          if (tmpWidget.getType() === 'ET2-TABBOX') {
            tmpWidget.activateTab(invalid_widgets[0]);
          }
          // scroll the widget into view
          if (typeof tmpWidget.scrollIntoView === 'function') {
            tmpWidget.scrollIntoView();
          }
        } else {
          doSubmit();
        }
      });
    } else {
      doSubmit();
    }
    return canSubmit;
  }

  /**
   * Does a full form post submit necessary for downloads
   *
   * Only use this one if you need it, use the ajax submit() instead.
   * It ensures eT2 session continues to exist on server by unbinding unload handler and rebinding it.
   *
   * @param {(et2_button|string)} button button widget or string with id
   */
  postSubmit(button) {
    // Get the form values
    var values = this.getValues(this._widgetContainer);

    // Trigger the submit event
    var canSubmit = true;
    this._widgetContainer.iterateOver(function (_widget) {
      if (_widget.submit(values) === false) {
        canSubmit = false;
      }
    }, this, et2_ISubmitListener);
    if (canSubmit) {
      if (button) {
        this._set_button(button, values);
      }

      // unbind our session-destroy handler, as we are submitting
      this.unbind_unload();
      var form = jQuery("<form id='form' action='" + egw$1().webserverUrl + "/index.php?menuaction=" + this._widgetContainer.egw().getAppName() + ".EGroupware\\Api\\Etemplate.process_exec&ajax=true' method='POST'>");
      var etemplate_id = jQuery(document.createElement("input")).attr("name", 'etemplate_exec_id').attr("type", 'hidden').val(this._etemplate_exec_id).appendTo(form);
      var input = document.createElement("input");
      input.type = "hidden";
      input.name = 'value';
      input.value = egw$1().jsonEncode(values);
      form.append(input);
      form.appendTo(jQuery('body')).submit();

      // bind unload handler again (can NOT do it direct, as this would be quick enough to be still triggered!)
      window.setTimeout(jQuery.proxy(this.bind_unload, this), 100);
    }
  }

  /**
   * Fetches all input element values and returns them in an associative
   * array. Widgets which introduce namespacing can use the internal _target
   * parameter to add another layer.
   *
   * @param {et2_widget} _root widget to start iterating
   * @param {boolean} skip_reset_dirty true: do NOT reset dirty status
   */
  getValues(_root, skip_reset_dirty) {
    var result = {};

    // Iterate over the widget tree
    _root.iterateOver(function (_widget) {
      var _id2, _indexes;
      // The widget must have an id to be included in the values array
      if (_widget.id === undefined || _widget.id === "") {
        return;
      }

      // Get the path to the node we have to store the value at
      var path = _widget.getPath();

      // check if id contains a hierachical name, eg. "button[save]"
      var id = _widget.id || "";
      var indexes = (_id2 = id) === null || _id2 === void 0 ? void 0 : _id2.split('[');
      if (((_indexes = indexes) === null || _indexes === void 0 ? void 0 : _indexes.length) > 1) {
        indexes = [indexes.shift(), indexes.join('[')];
        indexes[1] = indexes[1].substring(0, indexes[1].length - 1);
        var children = indexes[1].split('][');
        if (children.length) {
          indexes = jQuery.merge([indexes[0]], children);
        }
        path = path.concat(indexes);
        // Take the last one as the ID
        id = path.pop();
      }

      // Set the _target variable to that node
      var _target = result;
      for (var i = 0; i < path.length; i++) {
        // Create a new object for not-existing path nodes
        if (typeof _target[path[i]] === 'undefined') {
          _target[path[i]] = {};
        }

        // Check whether the path node is really an object
        if (typeof _target[path[i]] === 'object') {
          _target = _target[path[i]];
        } else {
          egw$1.debug("error", "ID collision while writing at path " + "node '" + path[i] + "'");
        }
      }

      // Handle arrays, eg radio[]
      if (id === "") {
        id = typeof _target == "undefined" ? 0 : Object.keys(_target).length;
      }
      var value = _widget.getValue(true); // true: let widget know getValue() / submit is calling it

      // Check whether the entry is really undefined
      if (typeof _target[id] != "undefined" && (typeof _target[id] != 'object' || typeof value != 'object')) {
        // Don't warn about children of nextmatch header - they're part of nm value
        if (!_widget.getParent().instanceOf(et2_nextmatch_header_bar)) {
          egw$1.debug("warn", _widget, "Overwriting value of '" + _widget.id + "', id exists twice!");
        }
      }

      // Store the value of the widget and reset its dirty flag
      if (value !== null) {
        // Merge, if possible (link widget)
        if (typeof _target[id] == 'object' && typeof value == 'object') {
          _target[id] = jQuery.extend({}, _target[id], value);
        } else {
          _target[id] = value;
        }
      } else if (jQuery.isEmptyObject(_target)) {
        // Avoid sending back empty sub-arrays
        _target = result;
        for (var i = 0; i < path.length - 1; i++) {
          _target = _target[path[i]];
        }
        delete _target[path[path.length - 1]];
      }
      if (!skip_reset_dirty) {
        _widget.resetDirty();
      }
    }, this, et2_IInput);
    egw$1().debug("info", "Value", result);
    return result;
  }

  /**
   * "Intelligently" refresh the template based on the given ID
   *
   * Rather than blindly re-load the entire template, we try to be a little smarter about it.
   * If there's a message provided, we try to find where it goes and set it directly.  Then
   * we look for a nextmatch widget, and tell it to refresh its data based on that ID.
   *
   * @see egw_message.refresh()
   *
   * @param {string} msg message to try to display.  eg: "Entry added" (not used anymore, handeled by egw_refresh and egw_message)
   * @param {string} app app-name
   * @param {(string|null)} id application specific entry ID to try to refresh
   * @param {(string|null)} type type of change.  One of 'update','edit', 'delete', 'add' or null
   * @return {boolean} true if nextmatch found and refreshed, false if not
   */
  refresh(msg, app, id, type) {
    // msg, app;	// unused but required by function signature
    var refresh_done = false;

    // Refresh nextmatches
    this._widgetContainer.iterateOver(function (_widget) {
      // Trigger refresh
      _widget.refresh(id, type);
      refresh_done = true;
    }, this, et2_nextmatch);
    return refresh_done;
  }

  /**
   * "Intelligently" refresh a given app
   *
   * @see egw_message.refresh()
   *
   * @param {string} _msg message to try to display.  eg: "Entry added" (not used anymore, handeled by egw_refresh and egw_message)
   * @param {string} _app app-name
   * @param {(string|null)} _id application specific entry ID to try to refresh
   * @param {(string|null)} _type type of change.  One of 'update','edit', 'delete', 'add' or null
   * @return {boolean} true if nextmatch found and refreshed, false if not
   */
  static app_refresh(_msg, _app, _id, _type) {
    var refresh_done = false;
    var app = _app.split('-');
    var et2 = etemplate2$1.getByApplication(app[0]);
    for (var i = 0; i < et2.length; i++) {
      if (app[1]) {
        if (et2[i]['uniqueId'].match(_app)) {
          refresh_done = et2[i].refresh(_msg, app[0], _id, _type) || refresh_done;
          break;
        }
      } else {
        refresh_done = et2[i].refresh(_msg, app[0], _id, _type) || refresh_done;
      }
    }
    return refresh_done;
  }

  /**
   * "Intelligently" print a given etemplate
   *
   * Mostly, we let the nextmatch change how many rows it's showing, so you don't
   * get just one printed page.
   *
   * @return {Deferred[]} A list of Deferred objects that must complete before
   *  actual printing can begin.
   */
  print() {
    // Sometimes changes take time
    var deferred = [];

    // Skip hidden etemplates
    if (jQuery(this._DOMContainer).filter(':visible').length === 0) {
      return [];
    }

    // Allow any widget to change for printing
    this._widgetContainer.iterateOver(function (_widget) {
      // Skip widgets from a different etemplate (home)
      if (_widget.getInstanceManager() != this) {
        return;
      }

      // Skip hidden widgets
      if (jQuery(_widget.getDOMNode()).filter(':visible').length === 0) {
        return;
      }
      var result = _widget.beforePrint();
      if (typeof result == "object") {
        deferred.push(result);
      }
    }, this, et2_IPrint);
    return deferred;
  }

  // Some static things to make getting into widget context a little easier //

  /**
   * Get a list of etemplate2 objects that loaded the given template name
   *
   * @param template String Name of the template that was loaded
   *
   * @return Array list of etemplate2 that have that template
   */

  static getByTemplate(template) {
    if (typeof etemplate2$1._byTemplate[template] != "undefined") {
      return etemplate2$1._byTemplate[template];
    } else {
      // Return empty array so you can always iterate over results
      return [];
    }
  }

  /**
   * Get a list of etemplate2 objects that are associated with the given application
   *
   * "Associated" is determined by the first part of the template
   *
   * @param {string} app app-name
   * @return {etemplate2[]} list of etemplate2 that have that app as the first part of their loaded template
   */
  static getByApplication(app) {
    var list = [];
    for (var name in etemplate2$1._byTemplate) {
      if (name.indexOf(app + ".") == 0) {
        list = list.concat(etemplate2$1._byTemplate[name]);
      }
    }
    return list;
  }

  /**
   * Get a etemplate2 object from the given DOM ID
   *
   * @param {string} id DOM ID of the container node
   * @returns {etemplate2|null}
   */
  static getById(id) {
    for (var name in etemplate2$1._byTemplate) {
      for (var i = 0; i < etemplate2$1._byTemplate[name].length; i++) {
        var et = etemplate2$1._byTemplate[name][i];
        if (et._DOMContainer.getAttribute("id") == id) {
          return et;
        }
      }
    }
    return null;
  }

  /**
   * Plugin for egw.json type "et2_load"
   *
   * @param _type
   * @param _response
   * @returns Promise
   */
  static handle_load(_type, _response) {
    var _this3 = this;
    return _asyncToGenerator(function* () {
      var _ref, _document$querySelect, _this3$DOMContainer;
      // Check the parameters
      var data = _response.data;
      // window-close does NOT send data.DOMNodeID!
      var dialog = (_ref = (_document$querySelect = document.querySelector('et2-dialog > form' + (data.DOMNodeID ? '#' + data.DOMNodeID : '.dialog_content'))) === null || _document$querySelect === void 0 ? void 0 : _document$querySelect.parentNode) !== null && _ref !== void 0 ? _ref :
      // Reloaded into same container
      (_this3 === null || _this3 === void 0 || (_this3$DOMContainer = _this3.DOMContainer) === null || _this3$DOMContainer === void 0 ? void 0 : _this3$DOMContainer.parentNode) instanceof Et2Dialog$1 ? _this3.DOMContainer.parentNode : undefined;
      if (dialog) {
        // stop dialogs from being closed on button click
        dialog.callback = () => false;
      }

      // handle Api\Framework::refresh_opener()
      if (Array.isArray(data['refresh-opener'])) {
        if (window.opener || dialog)
          // && typeof window.opener.egw_refresh == 'function')
          {
            var _egw = window.egw(dialog ? window : opener);
            _egw.refresh.apply(_egw, data['refresh-opener']);
          }
      }
      var egw = window.egw(window);

      // need to set app_header before message, as message temp. replaces app_header
      if (typeof data.data == 'object' && typeof data.data.app_header == 'string') {
        if (dialog) {
          dialog.title = data.data.app_header;
        } else {
          egw.app_header(data.data.app_header, data.data.currentapp || null);
        }
        delete data.data.app_header;
      }

      // handle Api\Framework::message()
      if (Array.isArray(data.message)) {
        egw.message.apply(egw, data.message);
      }

      // handle Api\Framework::window_close(), this will terminate execution
      if (data['window-close']) {
        if (typeof data['window-close'] == 'string' && data['window-close'] !== 'true') {
          alert(data['window-close']);
        }
        if (dialog) {
          return dialog.close();
        }
        egw.close();
        return true;
      }

      // handle Api\Framework::window_focus()
      if (data['window-focus']) {
        window.focus();
      }

      // handle framework.setSidebox calls
      if (!dialog && window.framework && Array.isArray(data.setSidebox)) {
        if (data['fw-target']) {
          data.setSidebox[0] = data['fw-target'];
        }
        window.framework.setSidebox.apply(window.framework, data.setSidebox);
      }

      // regular et2 re-load
      if (typeof data.url == "string" && typeof data.data === 'object') {
        var load;
        // @ts-ignore
        if (_this3 && typeof _this3.load == 'function') {
          // Called from etemplate
          // set id in case serverside returned a different template
          _this3._DOMContainer.id = _this3.uniqueId = data.DOMNodeID;

          // @ts-ignore
          load = _this3.load(data.name, data.url, data.data);
        } else {
          // Not etemplate
          var node = document.getElementById(data.DOMNodeID);
          var uniqueId = data.DOMNodeID;
          if (node) {
            if (node.children.length) {
              // Node has children already?  Check for loading over an
              // existing etemplate
              var old = etemplate2$1.getById(node.id);
              if (old) {
                old.clear();
              }
            }
            if (data['open_target'] && !uniqueId.match(data['open_target'])) {
              uniqueId = data.DOMNodeID.replace('.', '-') + '-' + data['open_target'];
            }
            var et2 = new etemplate2$1(node, data.data.menuaction, uniqueId);
            load = et2.load(data.name, data.url, data.data, null, null, null, data['fw-target']);
          } else {
            egw.debug("error", "Could not find target node %s", data.DOMNodeId);
          }
        }

        // Extra handling for being loaded into a Et2Dialog
        if (dialog) {
          load.then(() => {
            // Move footer type buttons into dialog footer
            var buttons = dialog._adoptTemplateButtons();

            // Make sure adopted buttons are removed on clear
            dialog.addEventListener("clear", () => {
              buttons.forEach(n => n.remove());
            });
          });
        }
        return load;
      }
      throw "Error while parsing et2_load response";
    })();
  }

  /**
   * Plugin for egw.json type "et2_validation_error"
   *
   * @param _type
   * @param _response
   */
  static handle_validation_error(_type, _response) {
    // Display validation errors
    for (var id in _response.data) {
      // @ts-ignore
      var widget = this._widgetContainer.getWidgetById(id);
      if (widget && widget.instanceOf(et2_baseWidget)) {
        widget.showMessage(_response.data[id], 'validation_error');
      } else if (typeof widget.set_validation_error == "function") {
        widget.set_validation_error(_response.data[id]);
      }
      // Handle validation_error (messages coming back from server as a response) if widget is children of a tabbox
      var tmpWidget = widget;
      while (tmpWidget.getParent() && tmpWidget.getType() !== 'ET2-TABBOX') {
        tmpWidget = tmpWidget.getParent();
      }
      //Activate the tab where the widget with validation error is located
      if (tmpWidget.getType() === 'ET2-TABBOX') {
        tmpWidget.activateTab(widget);
      }
      // scroll the widget into view
      if (typeof widget.getDOMNode().scrollIntoView === 'function') {
        widget.scrollIntoView();
      }
    }
    egw$1().debug("warn", "Validation errors", _response.data);
  }

  /**
   * Handle assign for attributes on etemplate2 widgets
   *
   * @param {string} type "assign"
   * @param {object} res Response
   * res.data.id {String} Widget ID
   * res.data.key {String} Attribute name
   * res.data.value New value for widget
   * res.data.etemplate_exec_id
   * @param {object} req
   * @returns {Boolean} Handled by this plugin
   * @throws Invalid parameters if the required res.data parameters are missing
   */
  handle_assign(type, res, req) {
    //type, req;	// unused, but required by plugin signature

    //Check whether all needed parameters have been passed and call the alertHandler function
    if (typeof res.data.id != 'undefined' && typeof res.data.key != 'undefined' && typeof res.data.value != 'undefined') {
      if (typeof res.data.etemplate_exec_id == 'undefined' || res.data.etemplate_exec_id != this._etemplate_exec_id) {
        // Not for this etemplate, but not an error
        return false;
      }
      if (res.data.key == 'etemplate_exec_id') {
        this._etemplate_exec_id = res.data.value;
        return true;
      }
      if (this._widgetContainer == null) {
        // Right etemplate, but it's already been cleared.
        egw$1.debug('warn', "Tried to call assign on an un-loaded etemplate", res.data);
        return false;
      }
      var widget = this._widgetContainer.getWidgetById(res.data.id);
      if (widget) {
        if (typeof widget['set_' + res.data.key] != 'function') {
          egw$1.debug('warn', "Cannot set %s attribute %s via JSON assign, no set_%s()", res.data.id, res.data.key, res.data.key);
          return false;
        }
        try {
          widget['set_' + res.data.key].call(widget, res.data.value);
          return true;
        } catch (e) {
          egw$1.debug("error", "When assigning %s on %s via AJAX, \n" + (e.message || e + ""), res.data.key, res.data.id, widget);
        }
      }
      return false;
    }
    throw 'Invalid parameters';
  }
}

// make etemplate2 global, as we need it to check an app uses it and then call methods on it
/**
 * List of loaded templates
 */
_defineProperty(etemplate2$1, "templates", {});
/**
 * List of etemplates by loaded template
 */
_defineProperty(etemplate2$1, "_byTemplate", {});
if (typeof window.etemplate2 === 'undefined') {
  window['etemplate2'] = etemplate2$1;
}

// Calls etemplate2_handle_response in the context of the object which
// requested the response from the server
egw$1(window).registerJSONPlugin(etemplate2$1.handle_load, null, 'et2_load');
egw$1(window).registerJSONPlugin(etemplate2$1.handle_validation_error, null, 'et2_validation_error');

export { et2_textbox as $, et2_no_init as A, flatpickr$1 as B, ClassWithAttributes as C, parseTime as D, EgwApp as E, et2_dataview_grid as F, et2_IResizeable as G, et2_compileLegacyJS as H, Et2Date as I, i$b as J, parseDate as K, Et2StaticSelectMixin as L, Et2Select as M, x$1 as N, o$9 as O, A$1 as P, IsEmail as Q, egw_unregisterGlobalShortcut as R, Sortable as S, egw_getFramework$1 as T, et2_widget as U, egw_registerGlobalShortcut as V, et2_IInput as W, et2_file as X, egwAction as Y, et2_nextmatch_controller as Z, MIME_REGEX as _, egw$1 as a, setSpecies$2 as a$, iteratorDefine as a0, createIterResultObject$1 as a1, iteratorClose$1 as a2, functionBindContext as a3, isArrayIteratorMethod$1 as a4, isConstructor$1 as a5, createProperty$2 as a6, getIterator$2 as a7, getIteratorMethod$3 as a8, urlConstructorDetection as a9, implements_methods as aA, Et2Checkbox as aB, et2_baseWidget as aC, et2_html as aD, et2_htmlarea as aE, et2_number as aF, et2_button as aG, et2_radiobox as aH, et2_vfsUpload as aI, s$5 as aJ, Et2InputWidget as aK, Et2Button as aL, Et2WidgetWithSelectMixin as aM, radio_group_default as aN, t$7 as aO, h$4 as aP, et2_selectbox as aQ, Et2LinkList as aR, e$c as aS, Et2SelectAccount as aT, objectGetPrototypeOf as aU, objectSetPrototypeOf as aV, checkCorrectnessOfIteration$1 as aW, aConstructor$1 as aX, defineBuiltIns$1 as aY, speciesConstructor$3 as aZ, isArray$2 as a_, defineBuiltInAccessor$4 as aa, anInstance$2 as ab, objectAssign as ac, arraySliceSimple as ad, setToStringTag$4 as ae, validateArgumentsLength$2 as af, web_urlSearchParams_constructor as ag, Et2Widget as ah, card_default as ai, shoelace as aj, HasSlotController as ak, Et2Favorites as al, o$5 as am, c$2 as an, loadWebComponent as ao, nm_open_popup as ap, et2_template as aq, Et2Label as ar, et2_grid as as, et2_dialog$1 as at, et2_inputWidget as au, et2_dynheight as av, egwActionObjectInterface as aw, Et2Description as ax, et2_video as ay, et2_implements_registry as az, etemplate2$1 as b, inheritIfRequired$1 as b0, arraySort$1 as b1, engineFfVersion as b2, engineIsIeOrEdge as b3, engineWebkitVersion as b4, functionApply as b5, arraySlice$2 as b6, Et2Dialog$1 as c, nm_compare_field as d, et2_IPrint as e, fetchAll as f, et2_nextmatch as g, date as h, interact as i, et2_valueWidget as j, formatDate$1 as k, et2_createWidget as l, egw_getObjectManager as m, nm_action as n, et2_action_object_impl as o, egwActionObject as p, et2_register_widget as q, StaticOptions as r, rt as s, tapAndSwipe as t, formatTime as u, formatDateTime as v, et2_insertLinkText as w, et2_activateLinks as x, et2_container as y, egw_getAppObjectManager as z };
//# sourceMappingURL=etemplate2-0976562a.js.map
